#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 6361
#define LARGE_STATE_COUNT 1247
#define SYMBOL_COUNT 421
#define ALIAS_COUNT 6
#define TOKEN_COUNT 173
#define EXTERNAL_TOKEN_COUNT 9
#define FIELD_COUNT 51
#define MAX_ALIAS_SEQUENCE_LENGTH 10
#define PRODUCTION_ID_COUNT 397

enum ts_symbol_identifiers {
  sym_identifier = 1,
  sym_hash_bang_line = 2,
  anon_sym_export = 3,
  anon_sym_STAR = 4,
  anon_sym_default = 5,
  anon_sym_type = 6,
  anon_sym_EQ = 7,
  anon_sym_as = 8,
  anon_sym_namespace = 9,
  anon_sym_LBRACE = 10,
  anon_sym_COMMA = 11,
  anon_sym_RBRACE = 12,
  anon_sym_typeof = 13,
  anon_sym_import = 14,
  anon_sym_from = 15,
  anon_sym_with = 16,
  anon_sym_var = 17,
  anon_sym_let = 18,
  anon_sym_const = 19,
  anon_sym_BANG = 20,
  anon_sym_else = 21,
  anon_sym_if = 22,
  anon_sym_switch = 23,
  anon_sym_for = 24,
  anon_sym_LPAREN = 25,
  anon_sym_RPAREN = 26,
  anon_sym_await = 27,
  anon_sym_in = 28,
  anon_sym_of = 29,
  anon_sym_while = 30,
  anon_sym_do = 31,
  anon_sym_try = 32,
  anon_sym_break = 33,
  anon_sym_continue = 34,
  anon_sym_debugger = 35,
  anon_sym_return = 36,
  anon_sym_throw = 37,
  anon_sym_SEMI = 38,
  anon_sym_COLON = 39,
  anon_sym_case = 40,
  anon_sym_catch = 41,
  anon_sym_finally = 42,
  anon_sym_yield = 43,
  anon_sym_LBRACK = 44,
  anon_sym_RBRACK = 45,
  sym__glimmer_template_content = 46,
  anon_sym_LTtemplate_GT = 47,
  anon_sym_LT_SLASHtemplate_GT = 48,
  anon_sym_GT = 49,
  anon_sym_DOT = 50,
  anon_sym_DQUOTE = 51,
  anon_sym_SQUOTE = 52,
  anon_sym_class = 53,
  anon_sym_async = 54,
  anon_sym_function = 55,
  anon_sym_EQ_GT = 56,
  anon_sym_QMARK_DOT = 57,
  anon_sym_new = 58,
  anon_sym_using = 59,
  anon_sym_PLUS_EQ = 60,
  anon_sym_DASH_EQ = 61,
  anon_sym_STAR_EQ = 62,
  anon_sym_SLASH_EQ = 63,
  anon_sym_PERCENT_EQ = 64,
  anon_sym_CARET_EQ = 65,
  anon_sym_AMP_EQ = 66,
  anon_sym_PIPE_EQ = 67,
  anon_sym_GT_GT_EQ = 68,
  anon_sym_GT_GT_GT_EQ = 69,
  anon_sym_LT_LT_EQ = 70,
  anon_sym_STAR_STAR_EQ = 71,
  anon_sym_AMP_AMP_EQ = 72,
  anon_sym_PIPE_PIPE_EQ = 73,
  anon_sym_QMARK_QMARK_EQ = 74,
  anon_sym_DOT_DOT_DOT = 75,
  anon_sym_AMP_AMP = 76,
  anon_sym_PIPE_PIPE = 77,
  anon_sym_GT_GT = 78,
  anon_sym_GT_GT_GT = 79,
  anon_sym_LT_LT = 80,
  anon_sym_AMP = 81,
  anon_sym_CARET = 82,
  anon_sym_PIPE = 83,
  anon_sym_PLUS = 84,
  anon_sym_DASH = 85,
  anon_sym_SLASH = 86,
  anon_sym_PERCENT = 87,
  anon_sym_STAR_STAR = 88,
  anon_sym_LT = 89,
  anon_sym_LT_EQ = 90,
  anon_sym_EQ_EQ = 91,
  anon_sym_EQ_EQ_EQ = 92,
  anon_sym_BANG_EQ = 93,
  anon_sym_BANG_EQ_EQ = 94,
  anon_sym_GT_EQ = 95,
  anon_sym_QMARK_QMARK = 96,
  anon_sym_instanceof = 97,
  anon_sym_TILDE = 98,
  anon_sym_void = 99,
  anon_sym_delete = 100,
  anon_sym_PLUS_PLUS = 101,
  anon_sym_DASH_DASH = 102,
  sym_unescaped_double_string_fragment = 103,
  sym_unescaped_single_string_fragment = 104,
  sym_escape_sequence = 105,
  aux_sym_comment_token1 = 106,
  anon_sym_BQUOTE = 107,
  anon_sym_DOLLAR_LBRACE = 108,
  anon_sym_SLASH2 = 109,
  sym_regex_pattern = 110,
  sym_regex_flags = 111,
  sym_number = 112,
  sym_private_property_identifier = 113,
  anon_sym_target = 114,
  sym_this = 115,
  sym_super = 116,
  sym_true = 117,
  sym_false = 118,
  sym_null = 119,
  sym_undefined = 120,
  anon_sym_AT = 121,
  anon_sym_static = 122,
  anon_sym_readonly = 123,
  anon_sym_get = 124,
  anon_sym_set = 125,
  anon_sym_QMARK = 126,
  anon_sym_declare = 127,
  anon_sym_public = 128,
  anon_sym_private = 129,
  anon_sym_protected = 130,
  anon_sym_override = 131,
  anon_sym_module = 132,
  anon_sym_any = 133,
  anon_sym_number = 134,
  anon_sym_boolean = 135,
  anon_sym_string = 136,
  anon_sym_symbol = 137,
  anon_sym_object = 138,
  anon_sym_property = 139,
  anon_sym_signal = 140,
  anon_sym_on = 141,
  anon_sym_required = 142,
  anon_sym_component = 143,
  anon_sym_abstract = 144,
  anon_sym_satisfies = 145,
  anon_sym_require = 146,
  anon_sym_extends = 147,
  anon_sym_implements = 148,
  anon_sym_global = 149,
  anon_sym_interface = 150,
  anon_sym_enum = 151,
  anon_sym_DASH_QMARK_COLON = 152,
  anon_sym_PLUS_QMARK_COLON = 153,
  anon_sym_QMARK_COLON = 154,
  anon_sym_asserts = 155,
  anon_sym_infer = 156,
  anon_sym_is = 157,
  anon_sym_keyof = 158,
  anon_sym_unique = 159,
  anon_sym_unknown = 160,
  anon_sym_never = 161,
  anon_sym_LBRACE_PIPE = 162,
  anon_sym_PIPE_RBRACE = 163,
  anon_sym_pragma = 164,
  aux_sym_ui_version_specifier_token1 = 165,
  anon_sym_list = 166,
  sym__automatic_semicolon = 167,
  sym__template_chars = 168,
  sym__ternary_qmark = 169,
  sym_html_comment = 170,
  sym__function_signature_automatic_semicolon = 171,
  sym___error_recovery = 172,
  sym_program = 173,
  sym_export_statement = 174,
  sym_namespace_export = 175,
  sym_export_clause = 176,
  sym_export_specifier = 177,
  sym__module_export_name = 178,
  sym_declaration = 179,
  sym_import = 180,
  sym_import_statement = 181,
  sym_import_clause = 182,
  sym__from_clause = 183,
  sym_namespace_import = 184,
  sym_named_imports = 185,
  sym_import_specifier = 186,
  sym_import_attribute = 187,
  sym_statement = 188,
  sym_expression_statement = 189,
  sym_variable_declaration = 190,
  sym_lexical_declaration = 191,
  sym_variable_declarator = 192,
  sym_statement_block = 193,
  sym_else_clause = 194,
  sym_if_statement = 195,
  sym_switch_statement = 196,
  sym_for_statement = 197,
  sym_for_in_statement = 198,
  sym__for_header = 199,
  sym_while_statement = 200,
  sym_do_statement = 201,
  sym_try_statement = 202,
  sym_with_statement = 203,
  sym_break_statement = 204,
  sym_continue_statement = 205,
  sym_debugger_statement = 206,
  sym_return_statement = 207,
  sym_throw_statement = 208,
  sym_empty_statement = 209,
  sym_labeled_statement = 210,
  sym_switch_body = 211,
  sym_switch_case = 212,
  sym_switch_default = 213,
  sym_catch_clause = 214,
  sym_finally_clause = 215,
  sym_parenthesized_expression = 216,
  sym_expression = 217,
  sym_primary_expression = 218,
  sym_yield_expression = 219,
  sym_object = 220,
  sym_object_pattern = 221,
  sym_assignment_pattern = 222,
  sym_object_assignment_pattern = 223,
  sym_array = 224,
  sym_array_pattern = 225,
  sym_glimmer_template = 226,
  sym_glimmer_opening_tag = 227,
  sym_glimmer_closing_tag = 228,
  sym_nested_identifier = 229,
  sym_class = 230,
  sym_class_declaration = 231,
  sym_class_heritage = 232,
  sym_function_expression = 233,
  sym_function_declaration = 234,
  sym_generator_function = 235,
  sym_generator_function_declaration = 236,
  sym_arrow_function = 237,
  sym__call_signature = 238,
  sym__formal_parameter = 239,
  sym_optional_chain = 240,
  sym_call_expression = 241,
  sym_new_expression = 242,
  sym_await_expression = 243,
  sym_member_expression = 244,
  sym_subscript_expression = 245,
  sym_assignment_expression = 246,
  sym__augmented_assignment_lhs = 247,
  sym_augmented_assignment_expression = 248,
  sym__initializer = 249,
  sym__destructuring_pattern = 250,
  sym_spread_element = 251,
  sym_ternary_expression = 252,
  sym_binary_expression = 253,
  sym_unary_expression = 254,
  sym_update_expression = 255,
  sym_sequence_expression = 256,
  sym_string = 257,
  sym_comment = 258,
  sym_template_string = 259,
  sym_template_substitution = 260,
  sym_regex = 261,
  sym_meta_property = 262,
  sym_arguments = 263,
  sym_decorator = 264,
  sym_decorator_member_expression = 265,
  sym_decorator_call_expression = 266,
  sym_class_body = 267,
  sym_formal_parameters = 268,
  sym_class_static_block = 269,
  sym_pattern = 270,
  sym_rest_pattern = 271,
  sym_method_definition = 272,
  sym_pair = 273,
  sym_pair_pattern = 274,
  sym__property_name = 275,
  sym_computed_property_name = 276,
  sym_public_field_definition = 277,
  sym__import_identifier = 278,
  sym_non_null_expression = 279,
  sym_method_signature = 280,
  sym_abstract_method_signature = 281,
  sym_function_signature = 282,
  sym_type_assertion = 283,
  sym_as_expression = 284,
  sym_satisfies_expression = 285,
  sym_instantiation_expression = 286,
  sym_import_require_clause = 287,
  sym_extends_clause = 288,
  sym__extends_clause_single = 289,
  sym_implements_clause = 290,
  sym_ambient_declaration = 291,
  sym_abstract_class_declaration = 292,
  sym_module = 293,
  sym_internal_module = 294,
  sym__module = 295,
  sym_import_alias = 296,
  sym_nested_type_identifier = 297,
  sym_interface_declaration = 298,
  sym_extends_type_clause = 299,
  sym_enum_declaration = 300,
  sym_enum_body = 301,
  sym_enum_assignment = 302,
  sym_type_alias_declaration = 303,
  sym_accessibility_modifier = 304,
  sym_override_modifier = 305,
  sym_required_parameter = 306,
  sym_optional_parameter = 307,
  sym__parameter_name = 308,
  sym_omitting_type_annotation = 309,
  sym_adding_type_annotation = 310,
  sym_opting_type_annotation = 311,
  sym_type_annotation = 312,
  sym__type_query_member_expression_in_type_annotation = 313,
  sym__type_query_call_expression_in_type_annotation = 314,
  sym_asserts = 315,
  sym_asserts_annotation = 316,
  sym__type = 317,
  sym_tuple_parameter = 318,
  sym_optional_tuple_parameter = 319,
  sym_optional_type = 320,
  sym_rest_type = 321,
  sym__tuple_type_member = 322,
  sym_constructor_type = 323,
  sym__primary_type = 324,
  sym_template_type = 325,
  sym_template_literal_type = 326,
  sym_infer_type = 327,
  sym_conditional_type = 328,
  sym_generic_type = 329,
  sym_type_predicate = 330,
  sym_type_predicate_annotation = 331,
  sym__type_query_member_expression = 332,
  sym__type_query_subscript_expression = 333,
  sym__type_query_call_expression = 334,
  sym__type_query_instantiation_expression = 335,
  sym_type_query = 336,
  sym_index_type_query = 337,
  sym_lookup_type = 338,
  sym_mapped_type_clause = 339,
  sym_literal_type = 340,
  sym__number = 341,
  sym_existential_type = 342,
  sym_flow_maybe_type = 343,
  sym_parenthesized_type = 344,
  sym_predefined_type = 345,
  sym_type_arguments = 346,
  sym_object_type = 347,
  sym_call_signature = 348,
  sym_property_signature = 349,
  sym_type_parameters = 350,
  sym_type_parameter = 351,
  sym_default_type = 352,
  sym_constraint = 353,
  sym_construct_signature = 354,
  sym_index_signature = 355,
  sym_array_type = 356,
  sym_tuple_type = 357,
  sym_readonly_type = 358,
  sym_union_type = 359,
  sym_intersection_type = 360,
  sym_function_type = 361,
  sym_ui_pragma = 362,
  sym_ui_import = 363,
  sym_ui_version_specifier = 364,
  sym_ui_object_definition = 365,
  sym_ui_annotated_object = 366,
  sym_ui_annotation = 367,
  sym_ui_object_initializer = 368,
  sym_ui_annotated_object_member = 369,
  sym_ui_object_definition_binding = 370,
  sym_ui_binding = 371,
  sym_ui_property = 372,
  sym_ui_list_property_type = 373,
  sym_ui_property_modifier = 374,
  sym_ui_object_array = 375,
  sym_ui_required = 376,
  sym_ui_signal = 377,
  sym_ui_signal_parameters = 378,
  sym_ui_signal_parameter = 379,
  sym_ui_inline_component = 380,
  sym__qml_enum_declaration = 381,
  sym__qml_enum_body = 382,
  sym__qml_enum_assignment = 383,
  sym__qml_enum_negative_number = 384,
  sym_ui_nested_identifier = 385,
  sym_ui_simple_nested_identifier = 386,
  aux_sym_program_repeat1 = 387,
  aux_sym_export_statement_repeat1 = 388,
  aux_sym_export_clause_repeat1 = 389,
  aux_sym_named_imports_repeat1 = 390,
  aux_sym_variable_declaration_repeat1 = 391,
  aux_sym_statement_block_repeat1 = 392,
  aux_sym_switch_body_repeat1 = 393,
  aux_sym_object_repeat1 = 394,
  aux_sym_object_pattern_repeat1 = 395,
  aux_sym_array_repeat1 = 396,
  aux_sym_array_pattern_repeat1 = 397,
  aux_sym_glimmer_template_repeat1 = 398,
  aux_sym_sequence_expression_repeat1 = 399,
  aux_sym_string_repeat1 = 400,
  aux_sym_string_repeat2 = 401,
  aux_sym_template_string_repeat1 = 402,
  aux_sym_class_body_repeat1 = 403,
  aux_sym_formal_parameters_repeat1 = 404,
  aux_sym_extends_clause_repeat1 = 405,
  aux_sym_implements_clause_repeat1 = 406,
  aux_sym_extends_type_clause_repeat1 = 407,
  aux_sym_enum_body_repeat1 = 408,
  aux_sym_template_literal_type_repeat1 = 409,
  aux_sym_type_arguments_repeat1 = 410,
  aux_sym_object_type_repeat1 = 411,
  aux_sym_type_parameters_repeat1 = 412,
  aux_sym_tuple_type_repeat1 = 413,
  aux_sym_ui_pragma_repeat1 = 414,
  aux_sym_ui_annotated_object_repeat1 = 415,
  aux_sym_ui_object_initializer_repeat1 = 416,
  aux_sym_ui_property_repeat1 = 417,
  aux_sym_ui_object_array_repeat1 = 418,
  aux_sym_ui_signal_parameters_repeat1 = 419,
  aux_sym__qml_enum_body_repeat1 = 420,
  alias_sym_interface_body = 421,
  alias_sym_property_identifier = 422,
  alias_sym_shorthand_property_identifier = 423,
  alias_sym_shorthand_property_identifier_pattern = 424,
  alias_sym_statement_identifier = 425,
  alias_sym_this_type = 426,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym_hash_bang_line] = "hash_bang_line",
  [anon_sym_export] = "export",
  [anon_sym_STAR] = "*",
  [anon_sym_default] = "default",
  [anon_sym_type] = "type",
  [anon_sym_EQ] = "=",
  [anon_sym_as] = "as",
  [anon_sym_namespace] = "namespace",
  [anon_sym_LBRACE] = "{",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACE] = "}",
  [anon_sym_typeof] = "typeof",
  [anon_sym_import] = "import",
  [anon_sym_from] = "from",
  [anon_sym_with] = "with",
  [anon_sym_var] = "var",
  [anon_sym_let] = "let",
  [anon_sym_const] = "const",
  [anon_sym_BANG] = "!",
  [anon_sym_else] = "else",
  [anon_sym_if] = "if",
  [anon_sym_switch] = "switch",
  [anon_sym_for] = "for",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_await] = "await",
  [anon_sym_in] = "in",
  [anon_sym_of] = "of",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_try] = "try",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_debugger] = "debugger",
  [anon_sym_return] = "return",
  [anon_sym_throw] = "throw",
  [anon_sym_SEMI] = ";",
  [anon_sym_COLON] = ":",
  [anon_sym_case] = "case",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_yield] = "yield",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [sym__glimmer_template_content] = "_glimmer_template_content",
  [anon_sym_LTtemplate_GT] = "<template>",
  [anon_sym_LT_SLASHtemplate_GT] = "</template>",
  [anon_sym_GT] = ">",
  [anon_sym_DOT] = ".",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_SQUOTE] = "'",
  [anon_sym_class] = "class",
  [anon_sym_async] = "async",
  [anon_sym_function] = "function",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_QMARK_DOT] = "\?.",
  [anon_sym_new] = "new",
  [anon_sym_using] = "using",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_AMP_AMP_EQ] = "&&=",
  [anon_sym_PIPE_PIPE_EQ] = "||=",
  [anon_sym_QMARK_QMARK_EQ] = "\?\?=",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_PIPE] = "|",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_LT] = "<",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_BANG_EQ_EQ] = "!==",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_QMARK_QMARK] = "\?\?",
  [anon_sym_instanceof] = "instanceof",
  [anon_sym_TILDE] = "~",
  [anon_sym_void] = "void",
  [anon_sym_delete] = "delete",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [sym_unescaped_double_string_fragment] = "string_fragment",
  [sym_unescaped_single_string_fragment] = "string_fragment",
  [sym_escape_sequence] = "escape_sequence",
  [aux_sym_comment_token1] = "comment_token1",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_SLASH2] = "/",
  [sym_regex_pattern] = "regex_pattern",
  [sym_regex_flags] = "regex_flags",
  [sym_number] = "number",
  [sym_private_property_identifier] = "private_property_identifier",
  [anon_sym_target] = "target",
  [sym_this] = "this",
  [sym_super] = "super",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_undefined] = "undefined",
  [anon_sym_AT] = "@",
  [anon_sym_static] = "static",
  [anon_sym_readonly] = "readonly",
  [anon_sym_get] = "get",
  [anon_sym_set] = "set",
  [anon_sym_QMARK] = "\?",
  [anon_sym_declare] = "declare",
  [anon_sym_public] = "public",
  [anon_sym_private] = "private",
  [anon_sym_protected] = "protected",
  [anon_sym_override] = "override",
  [anon_sym_module] = "module",
  [anon_sym_any] = "any",
  [anon_sym_number] = "number",
  [anon_sym_boolean] = "boolean",
  [anon_sym_string] = "string",
  [anon_sym_symbol] = "symbol",
  [anon_sym_object] = "object",
  [anon_sym_property] = "property",
  [anon_sym_signal] = "signal",
  [anon_sym_on] = "on",
  [anon_sym_required] = "required",
  [anon_sym_component] = "component",
  [anon_sym_abstract] = "abstract",
  [anon_sym_satisfies] = "satisfies",
  [anon_sym_require] = "require",
  [anon_sym_extends] = "extends",
  [anon_sym_implements] = "implements",
  [anon_sym_global] = "global",
  [anon_sym_interface] = "interface",
  [anon_sym_enum] = "enum",
  [anon_sym_DASH_QMARK_COLON] = "-\?:",
  [anon_sym_PLUS_QMARK_COLON] = "+\?:",
  [anon_sym_QMARK_COLON] = "\?:",
  [anon_sym_asserts] = "asserts",
  [anon_sym_infer] = "infer",
  [anon_sym_is] = "is",
  [anon_sym_keyof] = "keyof",
  [anon_sym_unique] = "unique symbol",
  [anon_sym_unknown] = "unknown",
  [anon_sym_never] = "never",
  [anon_sym_LBRACE_PIPE] = "{|",
  [anon_sym_PIPE_RBRACE] = "|}",
  [anon_sym_pragma] = "pragma",
  [aux_sym_ui_version_specifier_token1] = "number",
  [anon_sym_list] = "type_identifier",
  [sym__automatic_semicolon] = "_automatic_semicolon",
  [sym__template_chars] = "string_fragment",
  [sym__ternary_qmark] = "\?",
  [sym_html_comment] = "html_comment",
  [sym__function_signature_automatic_semicolon] = "_function_signature_automatic_semicolon",
  [sym___error_recovery] = "__error_recovery",
  [sym_program] = "program",
  [sym_export_statement] = "export_statement",
  [sym_namespace_export] = "namespace_export",
  [sym_export_clause] = "export_clause",
  [sym_export_specifier] = "export_specifier",
  [sym__module_export_name] = "_module_export_name",
  [sym_declaration] = "declaration",
  [sym_import] = "import",
  [sym_import_statement] = "import_statement",
  [sym_import_clause] = "import_clause",
  [sym__from_clause] = "_from_clause",
  [sym_namespace_import] = "namespace_import",
  [sym_named_imports] = "named_imports",
  [sym_import_specifier] = "import_specifier",
  [sym_import_attribute] = "import_attribute",
  [sym_statement] = "statement",
  [sym_expression_statement] = "expression_statement",
  [sym_variable_declaration] = "variable_declaration",
  [sym_lexical_declaration] = "lexical_declaration",
  [sym_variable_declarator] = "variable_declarator",
  [sym_statement_block] = "statement_block",
  [sym_else_clause] = "else_clause",
  [sym_if_statement] = "if_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_in_statement] = "for_in_statement",
  [sym__for_header] = "_for_header",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_try_statement] = "try_statement",
  [sym_with_statement] = "with_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_debugger_statement] = "debugger_statement",
  [sym_return_statement] = "return_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym_switch_body] = "switch_body",
  [sym_switch_case] = "switch_case",
  [sym_switch_default] = "switch_default",
  [sym_catch_clause] = "catch_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_expression] = "expression",
  [sym_primary_expression] = "primary_expression",
  [sym_yield_expression] = "yield_expression",
  [sym_object] = "object",
  [sym_object_pattern] = "object_pattern",
  [sym_assignment_pattern] = "assignment_pattern",
  [sym_object_assignment_pattern] = "object_assignment_pattern",
  [sym_array] = "array",
  [sym_array_pattern] = "array_pattern",
  [sym_glimmer_template] = "glimmer_template",
  [sym_glimmer_opening_tag] = "glimmer_opening_tag",
  [sym_glimmer_closing_tag] = "glimmer_closing_tag",
  [sym_nested_identifier] = "nested_identifier",
  [sym_class] = "class",
  [sym_class_declaration] = "class_declaration",
  [sym_class_heritage] = "class_heritage",
  [sym_function_expression] = "function_expression",
  [sym_function_declaration] = "function_declaration",
  [sym_generator_function] = "generator_function",
  [sym_generator_function_declaration] = "generator_function_declaration",
  [sym_arrow_function] = "arrow_function",
  [sym__call_signature] = "_call_signature",
  [sym__formal_parameter] = "_formal_parameter",
  [sym_optional_chain] = "optional_chain",
  [sym_call_expression] = "call_expression",
  [sym_new_expression] = "new_expression",
  [sym_await_expression] = "await_expression",
  [sym_member_expression] = "member_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym__augmented_assignment_lhs] = "_augmented_assignment_lhs",
  [sym_augmented_assignment_expression] = "augmented_assignment_expression",
  [sym__initializer] = "_initializer",
  [sym__destructuring_pattern] = "_destructuring_pattern",
  [sym_spread_element] = "spread_element",
  [sym_ternary_expression] = "ternary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_update_expression] = "update_expression",
  [sym_sequence_expression] = "sequence_expression",
  [sym_string] = "string",
  [sym_comment] = "comment",
  [sym_template_string] = "template_string",
  [sym_template_substitution] = "template_substitution",
  [sym_regex] = "regex",
  [sym_meta_property] = "meta_property",
  [sym_arguments] = "arguments",
  [sym_decorator] = "decorator",
  [sym_decorator_member_expression] = "member_expression",
  [sym_decorator_call_expression] = "call_expression",
  [sym_class_body] = "class_body",
  [sym_formal_parameters] = "formal_parameters",
  [sym_class_static_block] = "class_static_block",
  [sym_pattern] = "pattern",
  [sym_rest_pattern] = "rest_pattern",
  [sym_method_definition] = "method_definition",
  [sym_pair] = "pair",
  [sym_pair_pattern] = "pair_pattern",
  [sym__property_name] = "_property_name",
  [sym_computed_property_name] = "computed_property_name",
  [sym_public_field_definition] = "public_field_definition",
  [sym__import_identifier] = "_import_identifier",
  [sym_non_null_expression] = "non_null_expression",
  [sym_method_signature] = "method_signature",
  [sym_abstract_method_signature] = "abstract_method_signature",
  [sym_function_signature] = "function_signature",
  [sym_type_assertion] = "type_assertion",
  [sym_as_expression] = "as_expression",
  [sym_satisfies_expression] = "satisfies_expression",
  [sym_instantiation_expression] = "instantiation_expression",
  [sym_import_require_clause] = "import_require_clause",
  [sym_extends_clause] = "extends_clause",
  [sym__extends_clause_single] = "_extends_clause_single",
  [sym_implements_clause] = "implements_clause",
  [sym_ambient_declaration] = "ambient_declaration",
  [sym_abstract_class_declaration] = "abstract_class_declaration",
  [sym_module] = "module",
  [sym_internal_module] = "internal_module",
  [sym__module] = "_module",
  [sym_import_alias] = "import_alias",
  [sym_nested_type_identifier] = "nested_type_identifier",
  [sym_interface_declaration] = "interface_declaration",
  [sym_extends_type_clause] = "extends_type_clause",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_body] = "enum_body",
  [sym_enum_assignment] = "enum_assignment",
  [sym_type_alias_declaration] = "type_alias_declaration",
  [sym_accessibility_modifier] = "accessibility_modifier",
  [sym_override_modifier] = "override_modifier",
  [sym_required_parameter] = "required_parameter",
  [sym_optional_parameter] = "optional_parameter",
  [sym__parameter_name] = "_parameter_name",
  [sym_omitting_type_annotation] = "omitting_type_annotation",
  [sym_adding_type_annotation] = "adding_type_annotation",
  [sym_opting_type_annotation] = "opting_type_annotation",
  [sym_type_annotation] = "type_annotation",
  [sym__type_query_member_expression_in_type_annotation] = "member_expression",
  [sym__type_query_call_expression_in_type_annotation] = "call_expression",
  [sym_asserts] = "asserts",
  [sym_asserts_annotation] = "asserts_annotation",
  [sym__type] = "_type",
  [sym_tuple_parameter] = "required_parameter",
  [sym_optional_tuple_parameter] = "optional_parameter",
  [sym_optional_type] = "optional_type",
  [sym_rest_type] = "rest_type",
  [sym__tuple_type_member] = "_tuple_type_member",
  [sym_constructor_type] = "constructor_type",
  [sym__primary_type] = "_primary_type",
  [sym_template_type] = "template_type",
  [sym_template_literal_type] = "template_literal_type",
  [sym_infer_type] = "infer_type",
  [sym_conditional_type] = "conditional_type",
  [sym_generic_type] = "generic_type",
  [sym_type_predicate] = "type_predicate",
  [sym_type_predicate_annotation] = "type_predicate_annotation",
  [sym__type_query_member_expression] = "member_expression",
  [sym__type_query_subscript_expression] = "subscript_expression",
  [sym__type_query_call_expression] = "call_expression",
  [sym__type_query_instantiation_expression] = "instantiation_expression",
  [sym_type_query] = "type_query",
  [sym_index_type_query] = "index_type_query",
  [sym_lookup_type] = "lookup_type",
  [sym_mapped_type_clause] = "mapped_type_clause",
  [sym_literal_type] = "literal_type",
  [sym__number] = "unary_expression",
  [sym_existential_type] = "existential_type",
  [sym_flow_maybe_type] = "flow_maybe_type",
  [sym_parenthesized_type] = "parenthesized_type",
  [sym_predefined_type] = "predefined_type",
  [sym_type_arguments] = "type_arguments",
  [sym_object_type] = "object_type",
  [sym_call_signature] = "call_signature",
  [sym_property_signature] = "property_signature",
  [sym_type_parameters] = "type_parameters",
  [sym_type_parameter] = "type_parameter",
  [sym_default_type] = "default_type",
  [sym_constraint] = "constraint",
  [sym_construct_signature] = "construct_signature",
  [sym_index_signature] = "index_signature",
  [sym_array_type] = "array_type",
  [sym_tuple_type] = "tuple_type",
  [sym_readonly_type] = "readonly_type",
  [sym_union_type] = "union_type",
  [sym_intersection_type] = "intersection_type",
  [sym_function_type] = "function_type",
  [sym_ui_pragma] = "ui_pragma",
  [sym_ui_import] = "ui_import",
  [sym_ui_version_specifier] = "ui_version_specifier",
  [sym_ui_object_definition] = "ui_object_definition",
  [sym_ui_annotated_object] = "ui_annotated_object",
  [sym_ui_annotation] = "ui_annotation",
  [sym_ui_object_initializer] = "ui_object_initializer",
  [sym_ui_annotated_object_member] = "ui_annotated_object_member",
  [sym_ui_object_definition_binding] = "ui_object_definition_binding",
  [sym_ui_binding] = "ui_binding",
  [sym_ui_property] = "ui_property",
  [sym_ui_list_property_type] = "ui_list_property_type",
  [sym_ui_property_modifier] = "ui_property_modifier",
  [sym_ui_object_array] = "ui_object_array",
  [sym_ui_required] = "ui_required",
  [sym_ui_signal] = "ui_signal",
  [sym_ui_signal_parameters] = "ui_signal_parameters",
  [sym_ui_signal_parameter] = "ui_signal_parameter",
  [sym_ui_inline_component] = "ui_inline_component",
  [sym__qml_enum_declaration] = "enum_declaration",
  [sym__qml_enum_body] = "enum_body",
  [sym__qml_enum_assignment] = "enum_assignment",
  [sym__qml_enum_negative_number] = "unary_expression",
  [sym_ui_nested_identifier] = "nested_identifier",
  [sym_ui_simple_nested_identifier] = "nested_identifier",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_export_statement_repeat1] = "export_statement_repeat1",
  [aux_sym_export_clause_repeat1] = "export_clause_repeat1",
  [aux_sym_named_imports_repeat1] = "named_imports_repeat1",
  [aux_sym_variable_declaration_repeat1] = "variable_declaration_repeat1",
  [aux_sym_statement_block_repeat1] = "statement_block_repeat1",
  [aux_sym_switch_body_repeat1] = "switch_body_repeat1",
  [aux_sym_object_repeat1] = "object_repeat1",
  [aux_sym_object_pattern_repeat1] = "object_pattern_repeat1",
  [aux_sym_array_repeat1] = "array_repeat1",
  [aux_sym_array_pattern_repeat1] = "array_pattern_repeat1",
  [aux_sym_glimmer_template_repeat1] = "glimmer_template_repeat1",
  [aux_sym_sequence_expression_repeat1] = "sequence_expression_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
  [aux_sym_template_string_repeat1] = "template_string_repeat1",
  [aux_sym_class_body_repeat1] = "class_body_repeat1",
  [aux_sym_formal_parameters_repeat1] = "formal_parameters_repeat1",
  [aux_sym_extends_clause_repeat1] = "extends_clause_repeat1",
  [aux_sym_implements_clause_repeat1] = "implements_clause_repeat1",
  [aux_sym_extends_type_clause_repeat1] = "extends_type_clause_repeat1",
  [aux_sym_enum_body_repeat1] = "enum_body_repeat1",
  [aux_sym_template_literal_type_repeat1] = "template_literal_type_repeat1",
  [aux_sym_type_arguments_repeat1] = "type_arguments_repeat1",
  [aux_sym_object_type_repeat1] = "object_type_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [aux_sym_tuple_type_repeat1] = "tuple_type_repeat1",
  [aux_sym_ui_pragma_repeat1] = "ui_pragma_repeat1",
  [aux_sym_ui_annotated_object_repeat1] = "ui_annotated_object_repeat1",
  [aux_sym_ui_object_initializer_repeat1] = "ui_object_initializer_repeat1",
  [aux_sym_ui_property_repeat1] = "ui_property_repeat1",
  [aux_sym_ui_object_array_repeat1] = "ui_object_array_repeat1",
  [aux_sym_ui_signal_parameters_repeat1] = "ui_signal_parameters_repeat1",
  [aux_sym__qml_enum_body_repeat1] = "_qml_enum_body_repeat1",
  [alias_sym_interface_body] = "interface_body",
  [alias_sym_property_identifier] = "property_identifier",
  [alias_sym_shorthand_property_identifier] = "shorthand_property_identifier",
  [alias_sym_shorthand_property_identifier_pattern] = "shorthand_property_identifier_pattern",
  [alias_sym_statement_identifier] = "statement_identifier",
  [alias_sym_this_type] = "this_type",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [sym_hash_bang_line] = sym_hash_bang_line,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_namespace] = anon_sym_namespace,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_typeof] = anon_sym_typeof,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_from] = anon_sym_from,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_await] = anon_sym_await,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_of] = anon_sym_of,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_debugger] = anon_sym_debugger,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [sym__glimmer_template_content] = sym__glimmer_template_content,
  [anon_sym_LTtemplate_GT] = anon_sym_LTtemplate_GT,
  [anon_sym_LT_SLASHtemplate_GT] = anon_sym_LT_SLASHtemplate_GT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_QMARK_DOT] = anon_sym_QMARK_DOT,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_using] = anon_sym_using,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_GT_GT_GT_EQ] = anon_sym_GT_GT_GT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_STAR_STAR_EQ] = anon_sym_STAR_STAR_EQ,
  [anon_sym_AMP_AMP_EQ] = anon_sym_AMP_AMP_EQ,
  [anon_sym_PIPE_PIPE_EQ] = anon_sym_PIPE_PIPE_EQ,
  [anon_sym_QMARK_QMARK_EQ] = anon_sym_QMARK_QMARK_EQ,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_GT_GT_GT] = anon_sym_GT_GT_GT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_EQ_EQ_EQ] = anon_sym_EQ_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_BANG_EQ_EQ] = anon_sym_BANG_EQ_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_QMARK_QMARK] = anon_sym_QMARK_QMARK,
  [anon_sym_instanceof] = anon_sym_instanceof,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_void] = anon_sym_void,
  [anon_sym_delete] = anon_sym_delete,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [sym_unescaped_double_string_fragment] = sym__template_chars,
  [sym_unescaped_single_string_fragment] = sym__template_chars,
  [sym_escape_sequence] = sym_escape_sequence,
  [aux_sym_comment_token1] = aux_sym_comment_token1,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [anon_sym_DOLLAR_LBRACE] = anon_sym_DOLLAR_LBRACE,
  [anon_sym_SLASH2] = anon_sym_SLASH,
  [sym_regex_pattern] = sym_regex_pattern,
  [sym_regex_flags] = sym_regex_flags,
  [sym_number] = sym_number,
  [sym_private_property_identifier] = sym_private_property_identifier,
  [anon_sym_target] = anon_sym_target,
  [sym_this] = sym_this,
  [sym_super] = sym_super,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_null] = sym_null,
  [sym_undefined] = sym_undefined,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_readonly] = anon_sym_readonly,
  [anon_sym_get] = anon_sym_get,
  [anon_sym_set] = anon_sym_set,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_declare] = anon_sym_declare,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_protected] = anon_sym_protected,
  [anon_sym_override] = anon_sym_override,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_any] = anon_sym_any,
  [anon_sym_number] = anon_sym_number,
  [anon_sym_boolean] = anon_sym_boolean,
  [anon_sym_string] = anon_sym_string,
  [anon_sym_symbol] = anon_sym_symbol,
  [anon_sym_object] = anon_sym_object,
  [anon_sym_property] = anon_sym_property,
  [anon_sym_signal] = anon_sym_signal,
  [anon_sym_on] = anon_sym_on,
  [anon_sym_required] = anon_sym_required,
  [anon_sym_component] = anon_sym_component,
  [anon_sym_abstract] = anon_sym_abstract,
  [anon_sym_satisfies] = anon_sym_satisfies,
  [anon_sym_require] = anon_sym_require,
  [anon_sym_extends] = anon_sym_extends,
  [anon_sym_implements] = anon_sym_implements,
  [anon_sym_global] = anon_sym_global,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_DASH_QMARK_COLON] = anon_sym_DASH_QMARK_COLON,
  [anon_sym_PLUS_QMARK_COLON] = anon_sym_PLUS_QMARK_COLON,
  [anon_sym_QMARK_COLON] = anon_sym_QMARK_COLON,
  [anon_sym_asserts] = anon_sym_asserts,
  [anon_sym_infer] = anon_sym_infer,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_keyof] = anon_sym_keyof,
  [anon_sym_unique] = anon_sym_unique,
  [anon_sym_unknown] = anon_sym_unknown,
  [anon_sym_never] = anon_sym_never,
  [anon_sym_LBRACE_PIPE] = anon_sym_LBRACE_PIPE,
  [anon_sym_PIPE_RBRACE] = anon_sym_PIPE_RBRACE,
  [anon_sym_pragma] = anon_sym_pragma,
  [aux_sym_ui_version_specifier_token1] = sym_number,
  [anon_sym_list] = anon_sym_list,
  [sym__automatic_semicolon] = sym__automatic_semicolon,
  [sym__template_chars] = sym__template_chars,
  [sym__ternary_qmark] = anon_sym_QMARK,
  [sym_html_comment] = sym_html_comment,
  [sym__function_signature_automatic_semicolon] = sym__function_signature_automatic_semicolon,
  [sym___error_recovery] = sym___error_recovery,
  [sym_program] = sym_program,
  [sym_export_statement] = sym_export_statement,
  [sym_namespace_export] = sym_namespace_export,
  [sym_export_clause] = sym_export_clause,
  [sym_export_specifier] = sym_export_specifier,
  [sym__module_export_name] = sym__module_export_name,
  [sym_declaration] = sym_declaration,
  [sym_import] = sym_import,
  [sym_import_statement] = sym_import_statement,
  [sym_import_clause] = sym_import_clause,
  [sym__from_clause] = sym__from_clause,
  [sym_namespace_import] = sym_namespace_import,
  [sym_named_imports] = sym_named_imports,
  [sym_import_specifier] = sym_import_specifier,
  [sym_import_attribute] = sym_import_attribute,
  [sym_statement] = sym_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym_lexical_declaration] = sym_lexical_declaration,
  [sym_variable_declarator] = sym_variable_declarator,
  [sym_statement_block] = sym_statement_block,
  [sym_else_clause] = sym_else_clause,
  [sym_if_statement] = sym_if_statement,
  [sym_switch_statement] = sym_switch_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_for_in_statement] = sym_for_in_statement,
  [sym__for_header] = sym__for_header,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_with_statement] = sym_with_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_debugger_statement] = sym_debugger_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_throw_statement] = sym_throw_statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym_switch_body] = sym_switch_body,
  [sym_switch_case] = sym_switch_case,
  [sym_switch_default] = sym_switch_default,
  [sym_catch_clause] = sym_catch_clause,
  [sym_finally_clause] = sym_finally_clause,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_expression] = sym_expression,
  [sym_primary_expression] = sym_primary_expression,
  [sym_yield_expression] = sym_yield_expression,
  [sym_object] = sym_object,
  [sym_object_pattern] = sym_object_pattern,
  [sym_assignment_pattern] = sym_assignment_pattern,
  [sym_object_assignment_pattern] = sym_object_assignment_pattern,
  [sym_array] = sym_array,
  [sym_array_pattern] = sym_array_pattern,
  [sym_glimmer_template] = sym_glimmer_template,
  [sym_glimmer_opening_tag] = sym_glimmer_opening_tag,
  [sym_glimmer_closing_tag] = sym_glimmer_closing_tag,
  [sym_nested_identifier] = sym_nested_identifier,
  [sym_class] = sym_class,
  [sym_class_declaration] = sym_class_declaration,
  [sym_class_heritage] = sym_class_heritage,
  [sym_function_expression] = sym_function_expression,
  [sym_function_declaration] = sym_function_declaration,
  [sym_generator_function] = sym_generator_function,
  [sym_generator_function_declaration] = sym_generator_function_declaration,
  [sym_arrow_function] = sym_arrow_function,
  [sym__call_signature] = sym__call_signature,
  [sym__formal_parameter] = sym__formal_parameter,
  [sym_optional_chain] = sym_optional_chain,
  [sym_call_expression] = sym_call_expression,
  [sym_new_expression] = sym_new_expression,
  [sym_await_expression] = sym_await_expression,
  [sym_member_expression] = sym_member_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym__augmented_assignment_lhs] = sym__augmented_assignment_lhs,
  [sym_augmented_assignment_expression] = sym_augmented_assignment_expression,
  [sym__initializer] = sym__initializer,
  [sym__destructuring_pattern] = sym__destructuring_pattern,
  [sym_spread_element] = sym_spread_element,
  [sym_ternary_expression] = sym_ternary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_sequence_expression] = sym_sequence_expression,
  [sym_string] = sym_string,
  [sym_comment] = sym_comment,
  [sym_template_string] = sym_template_string,
  [sym_template_substitution] = sym_template_substitution,
  [sym_regex] = sym_regex,
  [sym_meta_property] = sym_meta_property,
  [sym_arguments] = sym_arguments,
  [sym_decorator] = sym_decorator,
  [sym_decorator_member_expression] = sym_member_expression,
  [sym_decorator_call_expression] = sym_call_expression,
  [sym_class_body] = sym_class_body,
  [sym_formal_parameters] = sym_formal_parameters,
  [sym_class_static_block] = sym_class_static_block,
  [sym_pattern] = sym_pattern,
  [sym_rest_pattern] = sym_rest_pattern,
  [sym_method_definition] = sym_method_definition,
  [sym_pair] = sym_pair,
  [sym_pair_pattern] = sym_pair_pattern,
  [sym__property_name] = sym__property_name,
  [sym_computed_property_name] = sym_computed_property_name,
  [sym_public_field_definition] = sym_public_field_definition,
  [sym__import_identifier] = sym__import_identifier,
  [sym_non_null_expression] = sym_non_null_expression,
  [sym_method_signature] = sym_method_signature,
  [sym_abstract_method_signature] = sym_abstract_method_signature,
  [sym_function_signature] = sym_function_signature,
  [sym_type_assertion] = sym_type_assertion,
  [sym_as_expression] = sym_as_expression,
  [sym_satisfies_expression] = sym_satisfies_expression,
  [sym_instantiation_expression] = sym_instantiation_expression,
  [sym_import_require_clause] = sym_import_require_clause,
  [sym_extends_clause] = sym_extends_clause,
  [sym__extends_clause_single] = sym__extends_clause_single,
  [sym_implements_clause] = sym_implements_clause,
  [sym_ambient_declaration] = sym_ambient_declaration,
  [sym_abstract_class_declaration] = sym_abstract_class_declaration,
  [sym_module] = sym_module,
  [sym_internal_module] = sym_internal_module,
  [sym__module] = sym__module,
  [sym_import_alias] = sym_import_alias,
  [sym_nested_type_identifier] = sym_nested_type_identifier,
  [sym_interface_declaration] = sym_interface_declaration,
  [sym_extends_type_clause] = sym_extends_type_clause,
  [sym_enum_declaration] = sym_enum_declaration,
  [sym_enum_body] = sym_enum_body,
  [sym_enum_assignment] = sym_enum_assignment,
  [sym_type_alias_declaration] = sym_type_alias_declaration,
  [sym_accessibility_modifier] = sym_accessibility_modifier,
  [sym_override_modifier] = sym_override_modifier,
  [sym_required_parameter] = sym_required_parameter,
  [sym_optional_parameter] = sym_optional_parameter,
  [sym__parameter_name] = sym__parameter_name,
  [sym_omitting_type_annotation] = sym_omitting_type_annotation,
  [sym_adding_type_annotation] = sym_adding_type_annotation,
  [sym_opting_type_annotation] = sym_opting_type_annotation,
  [sym_type_annotation] = sym_type_annotation,
  [sym__type_query_member_expression_in_type_annotation] = sym_member_expression,
  [sym__type_query_call_expression_in_type_annotation] = sym_call_expression,
  [sym_asserts] = sym_asserts,
  [sym_asserts_annotation] = sym_asserts_annotation,
  [sym__type] = sym__type,
  [sym_tuple_parameter] = sym_required_parameter,
  [sym_optional_tuple_parameter] = sym_optional_parameter,
  [sym_optional_type] = sym_optional_type,
  [sym_rest_type] = sym_rest_type,
  [sym__tuple_type_member] = sym__tuple_type_member,
  [sym_constructor_type] = sym_constructor_type,
  [sym__primary_type] = sym__primary_type,
  [sym_template_type] = sym_template_type,
  [sym_template_literal_type] = sym_template_literal_type,
  [sym_infer_type] = sym_infer_type,
  [sym_conditional_type] = sym_conditional_type,
  [sym_generic_type] = sym_generic_type,
  [sym_type_predicate] = sym_type_predicate,
  [sym_type_predicate_annotation] = sym_type_predicate_annotation,
  [sym__type_query_member_expression] = sym_member_expression,
  [sym__type_query_subscript_expression] = sym_subscript_expression,
  [sym__type_query_call_expression] = sym_call_expression,
  [sym__type_query_instantiation_expression] = sym_instantiation_expression,
  [sym_type_query] = sym_type_query,
  [sym_index_type_query] = sym_index_type_query,
  [sym_lookup_type] = sym_lookup_type,
  [sym_mapped_type_clause] = sym_mapped_type_clause,
  [sym_literal_type] = sym_literal_type,
  [sym__number] = sym_unary_expression,
  [sym_existential_type] = sym_existential_type,
  [sym_flow_maybe_type] = sym_flow_maybe_type,
  [sym_parenthesized_type] = sym_parenthesized_type,
  [sym_predefined_type] = sym_predefined_type,
  [sym_type_arguments] = sym_type_arguments,
  [sym_object_type] = sym_object_type,
  [sym_call_signature] = sym_call_signature,
  [sym_property_signature] = sym_property_signature,
  [sym_type_parameters] = sym_type_parameters,
  [sym_type_parameter] = sym_type_parameter,
  [sym_default_type] = sym_default_type,
  [sym_constraint] = sym_constraint,
  [sym_construct_signature] = sym_construct_signature,
  [sym_index_signature] = sym_index_signature,
  [sym_array_type] = sym_array_type,
  [sym_tuple_type] = sym_tuple_type,
  [sym_readonly_type] = sym_readonly_type,
  [sym_union_type] = sym_union_type,
  [sym_intersection_type] = sym_intersection_type,
  [sym_function_type] = sym_function_type,
  [sym_ui_pragma] = sym_ui_pragma,
  [sym_ui_import] = sym_ui_import,
  [sym_ui_version_specifier] = sym_ui_version_specifier,
  [sym_ui_object_definition] = sym_ui_object_definition,
  [sym_ui_annotated_object] = sym_ui_annotated_object,
  [sym_ui_annotation] = sym_ui_annotation,
  [sym_ui_object_initializer] = sym_ui_object_initializer,
  [sym_ui_annotated_object_member] = sym_ui_annotated_object_member,
  [sym_ui_object_definition_binding] = sym_ui_object_definition_binding,
  [sym_ui_binding] = sym_ui_binding,
  [sym_ui_property] = sym_ui_property,
  [sym_ui_list_property_type] = sym_ui_list_property_type,
  [sym_ui_property_modifier] = sym_ui_property_modifier,
  [sym_ui_object_array] = sym_ui_object_array,
  [sym_ui_required] = sym_ui_required,
  [sym_ui_signal] = sym_ui_signal,
  [sym_ui_signal_parameters] = sym_ui_signal_parameters,
  [sym_ui_signal_parameter] = sym_ui_signal_parameter,
  [sym_ui_inline_component] = sym_ui_inline_component,
  [sym__qml_enum_declaration] = sym_enum_declaration,
  [sym__qml_enum_body] = sym_enum_body,
  [sym__qml_enum_assignment] = sym_enum_assignment,
  [sym__qml_enum_negative_number] = sym_unary_expression,
  [sym_ui_nested_identifier] = sym_nested_identifier,
  [sym_ui_simple_nested_identifier] = sym_nested_identifier,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym_export_statement_repeat1] = aux_sym_export_statement_repeat1,
  [aux_sym_export_clause_repeat1] = aux_sym_export_clause_repeat1,
  [aux_sym_named_imports_repeat1] = aux_sym_named_imports_repeat1,
  [aux_sym_variable_declaration_repeat1] = aux_sym_variable_declaration_repeat1,
  [aux_sym_statement_block_repeat1] = aux_sym_statement_block_repeat1,
  [aux_sym_switch_body_repeat1] = aux_sym_switch_body_repeat1,
  [aux_sym_object_repeat1] = aux_sym_object_repeat1,
  [aux_sym_object_pattern_repeat1] = aux_sym_object_pattern_repeat1,
  [aux_sym_array_repeat1] = aux_sym_array_repeat1,
  [aux_sym_array_pattern_repeat1] = aux_sym_array_pattern_repeat1,
  [aux_sym_glimmer_template_repeat1] = aux_sym_glimmer_template_repeat1,
  [aux_sym_sequence_expression_repeat1] = aux_sym_sequence_expression_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_string_repeat2] = aux_sym_string_repeat2,
  [aux_sym_template_string_repeat1] = aux_sym_template_string_repeat1,
  [aux_sym_class_body_repeat1] = aux_sym_class_body_repeat1,
  [aux_sym_formal_parameters_repeat1] = aux_sym_formal_parameters_repeat1,
  [aux_sym_extends_clause_repeat1] = aux_sym_extends_clause_repeat1,
  [aux_sym_implements_clause_repeat1] = aux_sym_implements_clause_repeat1,
  [aux_sym_extends_type_clause_repeat1] = aux_sym_extends_type_clause_repeat1,
  [aux_sym_enum_body_repeat1] = aux_sym_enum_body_repeat1,
  [aux_sym_template_literal_type_repeat1] = aux_sym_template_literal_type_repeat1,
  [aux_sym_type_arguments_repeat1] = aux_sym_type_arguments_repeat1,
  [aux_sym_object_type_repeat1] = aux_sym_object_type_repeat1,
  [aux_sym_type_parameters_repeat1] = aux_sym_type_parameters_repeat1,
  [aux_sym_tuple_type_repeat1] = aux_sym_tuple_type_repeat1,
  [aux_sym_ui_pragma_repeat1] = aux_sym_ui_pragma_repeat1,
  [aux_sym_ui_annotated_object_repeat1] = aux_sym_ui_annotated_object_repeat1,
  [aux_sym_ui_object_initializer_repeat1] = aux_sym_ui_object_initializer_repeat1,
  [aux_sym_ui_property_repeat1] = aux_sym_ui_property_repeat1,
  [aux_sym_ui_object_array_repeat1] = aux_sym_ui_object_array_repeat1,
  [aux_sym_ui_signal_parameters_repeat1] = aux_sym_ui_signal_parameters_repeat1,
  [aux_sym__qml_enum_body_repeat1] = aux_sym__qml_enum_body_repeat1,
  [alias_sym_interface_body] = alias_sym_interface_body,
  [alias_sym_property_identifier] = alias_sym_property_identifier,
  [alias_sym_shorthand_property_identifier] = alias_sym_shorthand_property_identifier,
  [alias_sym_shorthand_property_identifier_pattern] = alias_sym_shorthand_property_identifier_pattern,
  [alias_sym_statement_identifier] = alias_sym_statement_identifier,
  [alias_sym_this_type] = alias_sym_this_type,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_bang_line] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_debugger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [sym__glimmer_template_content] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_LTtemplate_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_SLASHtemplate_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_using] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instanceof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [sym_unescaped_double_string_fragment] = {
    .visible = true,
    .named = true,
  },
  [sym_unescaped_single_string_fragment] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_comment_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH2] = {
    .visible = true,
    .named = false,
  },
  [sym_regex_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_regex_flags] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [sym_private_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_target] = {
    .visible = true,
    .named = false,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_undefined] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_override] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_any] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_number] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_boolean] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_symbol] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_object] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_property] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_signal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_on] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_required] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_component] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_satisfies] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_require] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implements] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_QMARK_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_QMARK_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_asserts] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_infer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_keyof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unique] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unknown] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_never] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pragma] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_ui_version_specifier_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym__automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__template_chars] = {
    .visible = true,
    .named = true,
  },
  [sym__ternary_qmark] = {
    .visible = true,
    .named = false,
  },
  [sym_html_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__function_signature_automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym___error_recovery] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_export_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_export] = {
    .visible = true,
    .named = true,
  },
  [sym_export_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_export_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym__module_export_name] = {
    .visible = false,
    .named = true,
  },
  [sym_declaration] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_import] = {
    .visible = true,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__from_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_namespace_import] = {
    .visible = true,
    .named = true,
  },
  [sym_named_imports] = {
    .visible = true,
    .named = true,
  },
  [sym_import_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_import_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_lexical_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_block] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_in_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_header] = {
    .visible = false,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_debugger_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_body] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_case] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_default] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_primary_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_yield_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_object] = {
    .visible = true,
    .named = true,
  },
  [sym_object_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_object_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_array_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_glimmer_template] = {
    .visible = true,
    .named = true,
  },
  [sym_glimmer_opening_tag] = {
    .visible = true,
    .named = true,
  },
  [sym_glimmer_closing_tag] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_class_heritage] = {
    .visible = true,
    .named = true,
  },
  [sym_function_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_arrow_function] = {
    .visible = true,
    .named = true,
  },
  [sym__call_signature] = {
    .visible = false,
    .named = true,
  },
  [sym__formal_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym_optional_chain] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__augmented_assignment_lhs] = {
    .visible = false,
    .named = true,
  },
  [sym_augmented_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__initializer] = {
    .visible = false,
    .named = true,
  },
  [sym__destructuring_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym_spread_element] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_template_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_meta_property] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_class_static_block] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_rest_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_pair_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__property_name] = {
    .visible = false,
    .named = true,
  },
  [sym_computed_property_name] = {
    .visible = true,
    .named = true,
  },
  [sym_public_field_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__import_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym_non_null_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_function_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_as_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_satisfies_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_instantiation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_import_require_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_extends_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__extends_clause_single] = {
    .visible = false,
    .named = true,
  },
  [sym_implements_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_ambient_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_internal_module] = {
    .visible = true,
    .named = true,
  },
  [sym__module] = {
    .visible = false,
    .named = true,
  },
  [sym_import_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_extends_type_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_type_alias_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_accessibility_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_override_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_required_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__parameter_name] = {
    .visible = false,
    .named = true,
  },
  [sym_omitting_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_adding_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_opting_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym__type_query_member_expression_in_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym__type_query_call_expression_in_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_asserts] = {
    .visible = true,
    .named = true,
  },
  [sym_asserts_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym_tuple_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_tuple_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_type] = {
    .visible = true,
    .named = true,
  },
  [sym_rest_type] = {
    .visible = true,
    .named = true,
  },
  [sym__tuple_type_member] = {
    .visible = false,
    .named = true,
  },
  [sym_constructor_type] = {
    .visible = true,
    .named = true,
  },
  [sym__primary_type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_template_type] = {
    .visible = true,
    .named = true,
  },
  [sym_template_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym_infer_type] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_type] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym__type_query_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__type_query_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__type_query_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__type_query_instantiation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_index_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_lookup_type] = {
    .visible = true,
    .named = true,
  },
  [sym_mapped_type_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym__number] = {
    .visible = true,
    .named = true,
  },
  [sym_existential_type] = {
    .visible = true,
    .named = true,
  },
  [sym_flow_maybe_type] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type] = {
    .visible = true,
    .named = true,
  },
  [sym_predefined_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_object_type] = {
    .visible = true,
    .named = true,
  },
  [sym_call_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_property_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_default_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_construct_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_index_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_readonly_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_intersection_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [sym_ui_pragma] = {
    .visible = true,
    .named = true,
  },
  [sym_ui_import] = {
    .visible = true,
    .named = true,
  },
  [sym_ui_version_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ui_object_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_ui_annotated_object] = {
    .visible = true,
    .named = true,
  },
  [sym_ui_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_ui_object_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_ui_annotated_object_member] = {
    .visible = true,
    .named = true,
  },
  [sym_ui_object_definition_binding] = {
    .visible = true,
    .named = true,
  },
  [sym_ui_binding] = {
    .visible = true,
    .named = true,
  },
  [sym_ui_property] = {
    .visible = true,
    .named = true,
  },
  [sym_ui_list_property_type] = {
    .visible = true,
    .named = true,
  },
  [sym_ui_property_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ui_object_array] = {
    .visible = true,
    .named = true,
  },
  [sym_ui_required] = {
    .visible = true,
    .named = true,
  },
  [sym_ui_signal] = {
    .visible = true,
    .named = true,
  },
  [sym_ui_signal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_ui_signal_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_ui_inline_component] = {
    .visible = true,
    .named = true,
  },
  [sym__qml_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__qml_enum_body] = {
    .visible = true,
    .named = true,
  },
  [sym__qml_enum_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym__qml_enum_negative_number] = {
    .visible = true,
    .named = true,
  },
  [sym_ui_nested_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ui_simple_nested_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_named_imports_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_statement_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_glimmer_template_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_sequence_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_extends_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_implements_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_extends_type_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_literal_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_ui_pragma_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_ui_annotated_object_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_ui_object_initializer_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_ui_property_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_ui_object_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_ui_signal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__qml_enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_interface_body] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_this_type] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alias = 1,
  field_alternative = 2,
  field_annotation = 3,
  field_argument = 4,
  field_arguments = 5,
  field_body = 6,
  field_close_tag = 7,
  field_component = 8,
  field_condition = 9,
  field_consequence = 10,
  field_constraint = 11,
  field_constructor = 12,
  field_content = 13,
  field_declaration = 14,
  field_decorator = 15,
  field_definition = 16,
  field_finalizer = 17,
  field_flags = 18,
  field_function = 19,
  field_handler = 20,
  field_increment = 21,
  field_index = 22,
  field_index_type = 23,
  field_initializer = 24,
  field_key = 25,
  field_kind = 26,
  field_label = 27,
  field_left = 28,
  field_major = 29,
  field_minor = 30,
  field_module = 31,
  field_name = 32,
  field_object = 33,
  field_open_tag = 34,
  field_operator = 35,
  field_optional_chain = 36,
  field_parameter = 37,
  field_parameters = 38,
  field_pattern = 39,
  field_property = 40,
  field_return_type = 41,
  field_right = 42,
  field_root = 43,
  field_sign = 44,
  field_source = 45,
  field_type = 46,
  field_type_arguments = 47,
  field_type_name = 48,
  field_type_parameters = 49,
  field_value = 50,
  field_version = 51,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_annotation] = "annotation",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_body] = "body",
  [field_close_tag] = "close_tag",
  [field_component] = "component",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constraint] = "constraint",
  [field_constructor] = "constructor",
  [field_content] = "content",
  [field_declaration] = "declaration",
  [field_decorator] = "decorator",
  [field_definition] = "definition",
  [field_finalizer] = "finalizer",
  [field_flags] = "flags",
  [field_function] = "function",
  [field_handler] = "handler",
  [field_increment] = "increment",
  [field_index] = "index",
  [field_index_type] = "index_type",
  [field_initializer] = "initializer",
  [field_key] = "key",
  [field_kind] = "kind",
  [field_label] = "label",
  [field_left] = "left",
  [field_major] = "major",
  [field_minor] = "minor",
  [field_module] = "module",
  [field_name] = "name",
  [field_object] = "object",
  [field_open_tag] = "open_tag",
  [field_operator] = "operator",
  [field_optional_chain] = "optional_chain",
  [field_parameter] = "parameter",
  [field_parameters] = "parameters",
  [field_pattern] = "pattern",
  [field_property] = "property",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_root] = "root",
  [field_sign] = "sign",
  [field_source] = "source",
  [field_type] = "type",
  [field_type_arguments] = "type_arguments",
  [field_type_name] = "type_name",
  [field_type_parameters] = "type_parameters",
  [field_value] = "value",
  [field_version] = "version",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 1},
  [3] = {.index = 2, .length = 1},
  [4] = {.index = 3, .length = 2},
  [5] = {.index = 3, .length = 2},
  [6] = {.index = 5, .length = 2},
  [7] = {.index = 7, .length = 2},
  [8] = {.index = 9, .length = 1},
  [9] = {.index = 10, .length = 2},
  [11] = {.index = 12, .length = 1},
  [12] = {.index = 13, .length = 1},
  [13] = {.index = 12, .length = 1},
  [14] = {.index = 14, .length = 2},
  [15] = {.index = 16, .length = 1},
  [16] = {.index = 17, .length = 1},
  [17] = {.index = 18, .length = 4},
  [18] = {.index = 22, .length = 2},
  [19] = {.index = 22, .length = 2},
  [20] = {.index = 24, .length = 2},
  [21] = {.index = 26, .length = 1},
  [22] = {.index = 27, .length = 1},
  [24] = {.index = 28, .length = 2},
  [25] = {.index = 30, .length = 2},
  [26] = {.index = 24, .length = 2},
  [27] = {.index = 16, .length = 1},
  [28] = {.index = 32, .length = 3},
  [29] = {.index = 35, .length = 2},
  [30] = {.index = 37, .length = 2},
  [31] = {.index = 35, .length = 2},
  [32] = {.index = 39, .length = 2},
  [33] = {.index = 41, .length = 2},
  [34] = {.index = 43, .length = 2},
  [35] = {.index = 45, .length = 1},
  [36] = {.index = 46, .length = 2},
  [37] = {.index = 48, .length = 1},
  [38] = {.index = 49, .length = 1},
  [40] = {.index = 17, .length = 1},
  [42] = {.index = 50, .length = 2},
  [43] = {.index = 52, .length = 2},
  [44] = {.index = 54, .length = 2},
  [45] = {.index = 56, .length = 1},
  [46] = {.index = 57, .length = 2},
  [47] = {.index = 59, .length = 2},
  [48] = {.index = 61, .length = 2},
  [49] = {.index = 63, .length = 2},
  [50] = {.index = 65, .length = 3},
  [51] = {.index = 65, .length = 3},
  [54] = {.index = 68, .length = 1},
  [55] = {.index = 69, .length = 2},
  [56] = {.index = 71, .length = 2},
  [57] = {.index = 73, .length = 2},
  [58] = {.index = 75, .length = 3},
  [59] = {.index = 78, .length = 5},
  [60] = {.index = 65, .length = 3},
  [61] = {.index = 65, .length = 3},
  [62] = {.index = 83, .length = 2},
  [63] = {.index = 85, .length = 2},
  [64] = {.index = 87, .length = 2},
  [65] = {.index = 83, .length = 2},
  [66] = {.index = 85, .length = 2},
  [67] = {.index = 83, .length = 2},
  [68] = {.index = 83, .length = 2},
  [69] = {.index = 89, .length = 2},
  [70] = {.index = 91, .length = 2},
  [71] = {.index = 93, .length = 3},
  [72] = {.index = 93, .length = 3},
  [73] = {.index = 96, .length = 3},
  [74] = {.index = 99, .length = 2},
  [75] = {.index = 101, .length = 2},
  [76] = {.index = 103, .length = 2},
  [77] = {.index = 105, .length = 2},
  [79] = {.index = 107, .length = 1},
  [80] = {.index = 108, .length = 2},
  [81] = {.index = 110, .length = 2},
  [82] = {.index = 112, .length = 2},
  [83] = {.index = 114, .length = 1},
  [84] = {.index = 115, .length = 3},
  [85] = {.index = 118, .length = 3},
  [86] = {.index = 121, .length = 2},
  [87] = {.index = 123, .length = 2},
  [88] = {.index = 125, .length = 2},
  [89] = {.index = 127, .length = 2},
  [90] = {.index = 129, .length = 1},
  [91] = {.index = 130, .length = 2},
  [92] = {.index = 132, .length = 1},
  [93] = {.index = 133, .length = 2},
  [94] = {.index = 135, .length = 4},
  [95] = {.index = 139, .length = 2},
  [96] = {.index = 141, .length = 2},
  [97] = {.index = 143, .length = 3},
  [98] = {.index = 146, .length = 2},
  [99] = {.index = 148, .length = 2},
  [100] = {.index = 16, .length = 1},
  [101] = {.index = 150, .length = 2},
  [102] = {.index = 152, .length = 2},
  [103] = {.index = 154, .length = 2},
  [106] = {.index = 150, .length = 2},
  [107] = {.index = 156, .length = 4},
  [108] = {.index = 101, .length = 2},
  [109] = {.index = 103, .length = 2},
  [110] = {.index = 160, .length = 3},
  [111] = {.index = 85, .length = 2},
  [112] = {.index = 163, .length = 3},
  [113] = {.index = 163, .length = 3},
  [114] = {.index = 166, .length = 3},
  [115] = {.index = 169, .length = 2},
  [116] = {.index = 171, .length = 3},
  [117] = {.index = 174, .length = 4},
  [118] = {.index = 178, .length = 3},
  [119] = {.index = 181, .length = 2},
  [120] = {.index = 101, .length = 2},
  [121] = {.index = 183, .length = 2},
  [122] = {.index = 185, .length = 5},
  [123] = {.index = 190, .length = 3},
  [124] = {.index = 190, .length = 3},
  [126] = {.index = 190, .length = 3},
  [127] = {.index = 190, .length = 3},
  [128] = {.index = 193, .length = 2},
  [129] = {.index = 193, .length = 2},
  [130] = {.index = 195, .length = 2},
  [131] = {.index = 197, .length = 2},
  [132] = {.index = 197, .length = 2},
  [133] = {.index = 197, .length = 2},
  [134] = {.index = 197, .length = 2},
  [135] = {.index = 199, .length = 1},
  [136] = {.index = 200, .length = 2},
  [137] = {.index = 202, .length = 1},
  [138] = {.index = 203, .length = 6},
  [139] = {.index = 209, .length = 2},
  [140] = {.index = 211, .length = 1},
  [141] = {.index = 127, .length = 2},
  [142] = {.index = 127, .length = 2},
  [143] = {.index = 212, .length = 5},
  [144] = {.index = 217, .length = 2},
  [145] = {.index = 219, .length = 3},
  [146] = {.index = 222, .length = 1},
  [147] = {.index = 223, .length = 1},
  [148] = {.index = 224, .length = 3},
  [149] = {.index = 227, .length = 3},
  [150] = {.index = 230, .length = 4},
  [151] = {.index = 234, .length = 2},
  [152] = {.index = 236, .length = 3},
  [153] = {.index = 239, .length = 4},
  [154] = {.index = 243, .length = 1},
  [155] = {.index = 244, .length = 2},
  [156] = {.index = 246, .length = 1},
  [157] = {.index = 247, .length = 2},
  [158] = {.index = 249, .length = 3},
  [159] = {.index = 252, .length = 2},
  [160] = {.index = 254, .length = 4},
  [161] = {.index = 258, .length = 2},
  [162] = {.index = 260, .length = 2},
  [163] = {.index = 262, .length = 4},
  [164] = {.index = 260, .length = 2},
  [165] = {.index = 266, .length = 4},
  [166] = {.index = 270, .length = 3},
  [167] = {.index = 273, .length = 2},
  [168] = {.index = 273, .length = 2},
  [169] = {.index = 275, .length = 2},
  [170] = {.index = 277, .length = 1},
  [171] = {.index = 278, .length = 2},
  [172] = {.index = 280, .length = 4},
  [173] = {.index = 284, .length = 4},
  [174] = {.index = 288, .length = 4},
  [175] = {.index = 292, .length = 2},
  [176] = {.index = 294, .length = 2},
  [177] = {.index = 296, .length = 3},
  [178] = {.index = 299, .length = 2},
  [179] = {.index = 301, .length = 4},
  [180] = {.index = 301, .length = 4},
  [181] = {.index = 305, .length = 4},
  [182] = {.index = 305, .length = 4},
  [183] = {.index = 309, .length = 2},
  [184] = {.index = 311, .length = 3},
  [185] = {.index = 314, .length = 3},
  [186] = {.index = 317, .length = 2},
  [187] = {.index = 319, .length = 3},
  [188] = {.index = 322, .length = 5},
  [189] = {.index = 327, .length = 4},
  [190] = {.index = 327, .length = 4},
  [191] = {.index = 327, .length = 4},
  [192] = {.index = 327, .length = 4},
  [193] = {.index = 69, .length = 2},
  [194] = {.index = 331, .length = 4},
  [195] = {.index = 335, .length = 2},
  [196] = {.index = 337, .length = 2},
  [197] = {.index = 339, .length = 3},
  [198] = {.index = 342, .length = 3},
  [199] = {.index = 342, .length = 3},
  [200] = {.index = 342, .length = 3},
  [201] = {.index = 342, .length = 3},
  [202] = {.index = 345, .length = 1},
  [203] = {.index = 346, .length = 1},
  [204] = {.index = 347, .length = 1},
  [205] = {.index = 348, .length = 2},
  [206] = {.index = 350, .length = 6},
  [207] = {.index = 356, .length = 2},
  [208] = {.index = 358, .length = 4},
  [209] = {.index = 348, .length = 2},
  [210] = {.index = 362, .length = 1},
  [211] = {.index = 362, .length = 1},
  [212] = {.index = 247, .length = 2},
  [213] = {.index = 249, .length = 3},
  [214] = {.index = 363, .length = 5},
  [215] = {.index = 368, .length = 2},
  [216] = {.index = 370, .length = 1},
  [217] = {.index = 371, .length = 4},
  [218] = {.index = 375, .length = 2},
  [219] = {.index = 377, .length = 1},
  [220] = {.index = 378, .length = 2},
  [221] = {.index = 380, .length = 2},
  [222] = {.index = 382, .length = 2},
  [223] = {.index = 384, .length = 4},
  [224] = {.index = 388, .length = 2},
  [225] = {.index = 390, .length = 3},
  [226] = {.index = 393, .length = 3},
  [227] = {.index = 396, .length = 3},
  [228] = {.index = 399, .length = 4},
  [229] = {.index = 403, .length = 4},
  [230] = {.index = 407, .length = 2},
  [231] = {.index = 409, .length = 2},
  [232] = {.index = 411, .length = 1},
  [233] = {.index = 412, .length = 4},
  [234] = {.index = 412, .length = 4},
  [235] = {.index = 416, .length = 3},
  [236] = {.index = 419, .length = 2},
  [237] = {.index = 421, .length = 3},
  [238] = {.index = 424, .length = 3},
  [239] = {.index = 427, .length = 3},
  [240] = {.index = 69, .length = 2},
  [241] = {.index = 430, .length = 3},
  [242] = {.index = 433, .length = 4},
  [243] = {.index = 437, .length = 3},
  [244] = {.index = 440, .length = 4},
  [245] = {.index = 440, .length = 4},
  [246] = {.index = 440, .length = 4},
  [247] = {.index = 440, .length = 4},
  [248] = {.index = 444, .length = 1},
  [249] = {.index = 445, .length = 2},
  [250] = {.index = 447, .length = 5},
  [251] = {.index = 39, .length = 2},
  [252] = {.index = 445, .length = 2},
  [253] = {.index = 452, .length = 4},
  [254] = {.index = 456, .length = 2},
  [255] = {.index = 458, .length = 3},
  [256] = {.index = 461, .length = 2},
  [257] = {.index = 461, .length = 2},
  [258] = {.index = 396, .length = 3},
  [259] = {.index = 463, .length = 2},
  [260] = {.index = 465, .length = 3},
  [261] = {.index = 468, .length = 2},
  [262] = {.index = 470, .length = 4},
  [263] = {.index = 69, .length = 2},
  [264] = {.index = 474, .length = 1},
  [265] = {.index = 475, .length = 2},
  [266] = {.index = 477, .length = 2},
  [267] = {.index = 479, .length = 2},
  [268] = {.index = 481, .length = 2},
  [269] = {.index = 483, .length = 3},
  [270] = {.index = 486, .length = 1},
  [271] = {.index = 487, .length = 3},
  [272] = {.index = 490, .length = 2},
  [273] = {.index = 492, .length = 3},
  [274] = {.index = 495, .length = 3},
  [275] = {.index = 498, .length = 3},
  [276] = {.index = 501, .length = 3},
  [277] = {.index = 504, .length = 4},
  [278] = {.index = 508, .length = 3},
  [279] = {.index = 511, .length = 2},
  [280] = {.index = 513, .length = 2},
  [281] = {.index = 515, .length = 4},
  [282] = {.index = 519, .length = 4},
  [283] = {.index = 523, .length = 4},
  [284] = {.index = 527, .length = 3},
  [285] = {.index = 530, .length = 2},
  [286] = {.index = 532, .length = 4},
  [287] = {.index = 536, .length = 2},
  [288] = {.index = 538, .length = 3},
  [289] = {.index = 536, .length = 2},
  [290] = {.index = 541, .length = 3},
  [291] = {.index = 541, .length = 3},
  [292] = {.index = 544, .length = 3},
  [293] = {.index = 547, .length = 5},
  [294] = {.index = 552, .length = 3},
  [295] = {.index = 555, .length = 2},
  [296] = {.index = 557, .length = 1},
  [297] = {.index = 558, .length = 3},
  [298] = {.index = 561, .length = 4},
  [299] = {.index = 565, .length = 2},
  [300] = {.index = 567, .length = 2},
  [301] = {.index = 569, .length = 4},
  [302] = {.index = 573, .length = 4},
  [303] = {.index = 577, .length = 2},
  [304] = {.index = 579, .length = 2},
  [305] = {.index = 581, .length = 3},
  [306] = {.index = 584, .length = 3},
  [307] = {.index = 587, .length = 2},
  [308] = {.index = 589, .length = 2},
  [309] = {.index = 591, .length = 1},
  [310] = {.index = 592, .length = 1},
  [311] = {.index = 593, .length = 3},
  [312] = {.index = 596, .length = 3},
  [313] = {.index = 599, .length = 3},
  [314] = {.index = 602, .length = 3},
  [315] = {.index = 605, .length = 4},
  [316] = {.index = 609, .length = 2},
  [317] = {.index = 611, .length = 4},
  [318] = {.index = 615, .length = 3},
  [319] = {.index = 618, .length = 2},
  [320] = {.index = 620, .length = 4},
  [321] = {.index = 624, .length = 4},
  [322] = {.index = 628, .length = 4},
  [323] = {.index = 632, .length = 3},
  [324] = {.index = 635, .length = 1},
  [325] = {.index = 636, .length = 4},
  [326] = {.index = 640, .length = 4},
  [327] = {.index = 644, .length = 5},
  [328] = {.index = 649, .length = 5},
  [330] = {.index = 654, .length = 4},
  [331] = {.index = 658, .length = 3},
  [332] = {.index = 661, .length = 3},
  [333] = {.index = 664, .length = 3},
  [334] = {.index = 661, .length = 3},
  [335] = {.index = 667, .length = 2},
  [336] = {.index = 669, .length = 4},
  [337] = {.index = 673, .length = 4},
  [338] = {.index = 677, .length = 3},
  [339] = {.index = 680, .length = 2},
  [340] = {.index = 682, .length = 2},
  [341] = {.index = 684, .length = 3},
  [342] = {.index = 687, .length = 2},
  [343] = {.index = 689, .length = 2},
  [344] = {.index = 691, .length = 1},
  [345] = {.index = 692, .length = 3},
  [346] = {.index = 695, .length = 3},
  [347] = {.index = 698, .length = 4},
  [348] = {.index = 702, .length = 4},
  [349] = {.index = 706, .length = 3},
  [350] = {.index = 709, .length = 3},
  [351] = {.index = 712, .length = 2},
  [352] = {.index = 714, .length = 4},
  [353] = {.index = 718, .length = 5},
  [354] = {.index = 723, .length = 5},
  [355] = {.index = 728, .length = 5},
  [356] = {.index = 733, .length = 4},
  [357] = {.index = 737, .length = 4},
  [358] = {.index = 741, .length = 3},
  [359] = {.index = 744, .length = 3},
  [360] = {.index = 744, .length = 3},
  [361] = {.index = 747, .length = 2},
  [362] = {.index = 749, .length = 2},
  [363] = {.index = 751, .length = 3},
  [364] = {.index = 754, .length = 2},
  [365] = {.index = 756, .length = 2},
  [366] = {.index = 758, .length = 4},
  [367] = {.index = 762, .length = 3},
  [368] = {.index = 765, .length = 3},
  [369] = {.index = 768, .length = 4},
  [370] = {.index = 772, .length = 3},
  [371] = {.index = 775, .length = 3},
  [372] = {.index = 778, .length = 2},
  [373] = {.index = 780, .length = 5},
  [374] = {.index = 785, .length = 5},
  [375] = {.index = 790, .length = 4},
  [376] = {.index = 790, .length = 4},
  [377] = {.index = 794, .length = 4},
  [378] = {.index = 798, .length = 3},
  [379] = {.index = 801, .length = 2},
  [380] = {.index = 803, .length = 2},
  [381] = {.index = 805, .length = 3},
  [382] = {.index = 808, .length = 4},
  [383] = {.index = 812, .length = 4},
  [384] = {.index = 816, .length = 3},
  [385] = {.index = 819, .length = 3},
  [386] = {.index = 822, .length = 4},
  [387] = {.index = 826, .length = 3},
  [388] = {.index = 829, .length = 3},
  [389] = {.index = 832, .length = 5},
  [390] = {.index = 837, .length = 3},
  [391] = {.index = 840, .length = 4},
  [392] = {.index = 844, .length = 4},
  [393] = {.index = 848, .length = 3},
  [394] = {.index = 851, .length = 3},
  [395] = {.index = 854, .length = 4},
  [396] = {.index = 858, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_root, 0},
  [1] =
    {field_annotation, 0},
  [2] =
    {field_root, 1},
  [3] =
    {field_initializer, 1},
    {field_type_name, 0},
  [5] =
    {field_annotation, 0, .inherited = true},
    {field_definition, 1},
  [7] =
    {field_annotation, 0, .inherited = true},
    {field_annotation, 1, .inherited = true},
  [9] =
    {field_root, 2},
  [10] =
    {field_body, 0, .inherited = true},
    {field_name, 0, .inherited = true},
  [12] =
    {field_source, 1},
  [13] =
    {field_major, 0},
  [14] =
    {field_initializer, 2},
    {field_type_name, 1},
  [16] =
    {field_name, 1},
  [17] =
    {field_name, 0},
  [18] =
    {field_annotation, 0, .inherited = true},
    {field_body, 1, .inherited = true},
    {field_definition, 1},
    {field_name, 1, .inherited = true},
  [22] =
    {field_source, 1},
    {field_version, 2},
  [24] =
    {field_name, 0},
    {field_value, 2},
  [26] =
    {field_decorator, 0},
  [27] =
    {field_parameters, 0},
  [28] =
    {field_name, 0},
    {field_value, 1, .inherited = true},
  [30] =
    {field_name, 0},
    {field_type, 1},
  [32] =
    {field_body, 2},
    {field_name, 1},
    {field_name, 2, .inherited = true},
  [35] =
    {field_alias, 3},
    {field_source, 1},
  [37] =
    {field_major, 0},
    {field_minor, 2},
  [39] =
    {field_name, 1},
    {field_value, 3},
  [41] =
    {field_body, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [43] =
    {field_argument, 1},
    {field_operator, 0},
  [45] =
    {field_pattern, 0},
  [46] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
  [48] =
    {field_body, 1},
  [49] =
    {field_constructor, 1},
  [50] =
    {field_argument, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
  [52] =
    {field_arguments, 1},
    {field_function, 0},
  [54] =
    {field_argument, 0},
    {field_operator, 1},
  [56] =
    {field_type_arguments, 1},
  [57] =
    {field_close_tag, 1},
    {field_open_tag, 0},
  [59] =
    {field_parameters, 0},
    {field_return_type, 1},
  [61] =
    {field_parameters, 1},
    {field_type_parameters, 0},
  [63] =
    {field_decorator, 0, .inherited = true},
    {field_decorator, 1, .inherited = true},
  [65] =
    {field_initializer, 3},
    {field_name, 2},
    {field_type_name, 0},
  [68] =
    {field_value, 1},
  [69] =
    {field_name, 0},
    {field_type, 2},
  [71] =
    {field_object, 1, .inherited = true},
    {field_property, 1, .inherited = true},
  [73] =
    {field_arguments, 1, .inherited = true},
    {field_function, 1, .inherited = true},
  [75] =
    {field_name, 0},
    {field_type, 1},
    {field_value, 2, .inherited = true},
  [78] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [83] =
    {field_name, 2},
    {field_type, 1},
  [85] =
    {field_object, 0},
    {field_property, 2},
  [87] =
    {field_module, 0},
    {field_name, 2},
  [89] =
    {field_name, 1},
    {field_parameters, 2},
  [91] =
    {field_component, 3},
    {field_name, 1},
  [93] =
    {field_alias, 4},
    {field_source, 1},
    {field_version, 2},
  [96] =
    {field_name, 1},
    {field_value, 3},
    {field_value, 4, .inherited = true},
  [99] =
    {field_value, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [101] =
    {field_left, 0},
    {field_right, 2},
  [103] =
    {field_body, 2},
    {field_parameter, 0},
  [105] =
    {field_body, 1},
    {field_name, 0},
  [107] =
    {field_declaration, 1},
  [108] =
    {field_body, 2},
    {field_object, 1},
  [110] =
    {field_condition, 1},
    {field_consequence, 2},
  [112] =
    {field_body, 2},
    {field_value, 1},
  [114] =
    {field_pattern, 1},
  [115] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [118] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 1},
  [121] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 1},
  [123] =
    {field_body, 1},
    {field_handler, 2},
  [125] =
    {field_body, 1},
    {field_finalizer, 2},
  [127] =
    {field_body, 2},
    {field_name, 1},
  [129] =
    {field_value, 0},
  [130] =
    {field_type_arguments, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [132] =
    {field_body, 2},
  [133] =
    {field_body, 2},
    {field_type_parameters, 1},
  [135] =
    {field_body, 2},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [139] =
    {field_arguments, 2},
    {field_constructor, 1},
  [141] =
    {field_constructor, 1},
    {field_type_arguments, 2},
  [143] =
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [146] =
    {field_index, 1, .inherited = true},
    {field_object, 1, .inherited = true},
  [148] =
    {field_function, 1, .inherited = true},
    {field_type_arguments, 1, .inherited = true},
  [150] =
    {field_name, 0},
    {field_type_arguments, 1},
  [152] =
    {field_name, 0},
    {field_value, 1},
  [154] =
    {field_constraint, 1},
    {field_name, 0},
  [156] =
    {field_arguments, 1},
    {field_function, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
  [160] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [163] =
    {field_object, 0},
    {field_optional_chain, 1},
    {field_property, 2},
  [166] =
    {field_arguments, 2},
    {field_function, 0},
    {field_type_arguments, 1},
  [169] =
    {field_arguments, 2},
    {field_function, 0},
  [171] =
    {field_close_tag, 2},
    {field_content, 1},
    {field_open_tag, 0},
  [174] =
    {field_body, 2},
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [178] =
    {field_parameters, 1},
    {field_return_type, 2},
    {field_type_parameters, 0},
  [181] =
    {field_body, 2},
    {field_decorator, 0, .inherited = true},
  [183] =
    {field_key, 0},
    {field_value, 2},
  [185] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [190] =
    {field_name, 2},
    {field_type, 1},
    {field_value, 4},
  [193] =
    {field_name, 1},
    {field_type, 0},
  [195] =
    {field_name, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [197] =
    {field_name, 3},
    {field_type, 2},
  [199] =
    {field_declaration, 2},
  [200] =
    {field_body, 2},
    {field_label, 0},
  [202] =
    {field_kind, 0},
  [203] =
    {field_body, 2},
    {field_kind, 1, .inherited = true},
    {field_left, 1, .inherited = true},
    {field_operator, 1, .inherited = true},
    {field_right, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [209] =
    {field_body, 2},
    {field_condition, 1},
  [211] =
    {field_label, 1},
  [212] =
    {field_body, 2},
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [217] =
    {field_declaration, 2},
    {field_decorator, 0, .inherited = true},
  [219] =
    {field_alternative, 3},
    {field_condition, 1},
    {field_consequence, 2},
  [222] =
    {field_type, 2},
  [223] =
    {field_pattern, 2},
  [224] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_value, 2, .inherited = true},
  [227] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 2},
  [230] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 1},
    {field_value, 2, .inherited = true},
  [234] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 2},
  [236] =
    {field_body, 1},
    {field_finalizer, 3},
    {field_handler, 2},
  [239] =
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [243] =
    {field_decorator, 0, .inherited = true},
  [244] =
    {field_decorator, 0, .inherited = true},
    {field_name, 1},
  [246] =
    {field_decorator, 1, .inherited = true},
  [247] =
    {field_body, 3},
    {field_name, 1},
  [249] =
    {field_body, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [252] =
    {field_type_arguments, 1},
    {field_value, 0},
  [254] =
    {field_type_arguments, 1, .inherited = true},
    {field_type_arguments, 2, .inherited = true},
    {field_value, 1, .inherited = true},
    {field_value, 2, .inherited = true},
  [258] =
    {field_body, 3},
    {field_type_parameters, 1},
  [260] =
    {field_body, 3},
    {field_parameter, 1},
  [262] =
    {field_body, 3},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [266] =
    {field_body, 3},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [270] =
    {field_arguments, 3},
    {field_constructor, 1},
    {field_type_arguments, 2},
  [273] =
    {field_left, 1},
    {field_right, 3},
  [275] =
    {field_flags, 3},
    {field_pattern, 1},
  [277] =
    {field_parameters, 1},
  [278] =
    {field_function, 0},
    {field_type_arguments, 1},
  [280] =
    {field_function, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
    {field_type_arguments, 1},
  [284] =
    {field_arguments, 1},
    {field_function, 0},
    {field_index, 0, .inherited = true},
    {field_object, 0, .inherited = true},
  [288] =
    {field_function, 0},
    {field_index, 0, .inherited = true},
    {field_object, 0, .inherited = true},
    {field_type_arguments, 1},
  [292] =
    {field_name, 1},
    {field_value, 2},
  [294] =
    {field_constraint, 2},
    {field_name, 1},
  [296] =
    {field_constraint, 1},
    {field_name, 0},
    {field_value, 2},
  [299] =
    {field_parameters, 0},
    {field_return_type, 2},
  [301] =
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
    {field_property, 2},
  [305] =
    {field_arguments, 0, .inherited = true},
    {field_function, 0, .inherited = true},
    {field_object, 0},
    {field_property, 2},
  [309] =
    {field_index, 2},
    {field_object, 0},
  [311] =
    {field_arguments, 3},
    {field_function, 0},
    {field_type_arguments, 2},
  [314] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [317] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
  [319] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [322] =
    {field_body, 5},
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [327] =
    {field_name, 2},
    {field_type, 1},
    {field_value, 4},
    {field_value, 5},
  [331] =
    {field_argument, 2, .inherited = true},
    {field_name, 0},
    {field_operator, 2, .inherited = true},
    {field_value, 2},
  [335] =
    {field_name, 1},
    {field_name, 2, .inherited = true},
  [337] =
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
  [339] =
    {field_name, 1, .inherited = true},
    {field_name, 2, .inherited = true},
    {field_value, 1, .inherited = true},
  [342] =
    {field_name, 3},
    {field_type, 2},
    {field_value, 5},
  [345] =
    {field_source, 2, .inherited = true},
  [346] =
    {field_value, 2},
  [347] =
    {field_source, 2},
  [348] =
    {field_body, 3},
    {field_name, 2},
  [350] =
    {field_body, 3},
    {field_kind, 2, .inherited = true},
    {field_left, 2, .inherited = true},
    {field_operator, 2, .inherited = true},
    {field_right, 2, .inherited = true},
    {field_value, 2, .inherited = true},
  [356] =
    {field_body, 1},
    {field_condition, 3},
  [358] =
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [362] =
    {field_type, 1},
  [363] =
    {field_body, 3},
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [368] =
    {field_declaration, 3},
    {field_decorator, 0, .inherited = true},
  [370] =
    {field_pattern, 3},
  [371] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [375] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 3},
  [377] =
    {field_name, 2},
  [378] =
    {field_name, 1},
    {field_value, 2, .inherited = true},
  [380] =
    {field_name, 1},
    {field_type, 2},
  [382] =
    {field_name, 0},
    {field_value, 2, .inherited = true},
  [384] =
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [388] =
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [390] =
    {field_decorator, 0, .inherited = true},
    {field_name, 1},
    {field_value, 2, .inherited = true},
  [393] =
    {field_decorator, 0, .inherited = true},
    {field_name, 1},
    {field_type, 2},
  [396] =
    {field_body, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [399] =
    {field_type_arguments, 0, .inherited = true},
    {field_type_arguments, 1, .inherited = true},
    {field_value, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [403] =
    {field_body, 4},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [407] =
    {field_parameters, 1},
    {field_type, 2},
  [409] =
    {field_parameters, 2},
    {field_type_parameters, 1},
  [411] =
    {field_parameters, 2},
  [412] =
    {field_index, 0, .inherited = true},
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 2},
  [416] =
    {field_constraint, 2},
    {field_name, 1},
    {field_value, 3},
  [419] =
    {field_parameters, 1},
    {field_type, 3},
  [421] =
    {field_parameters, 1},
    {field_return_type, 3},
    {field_type_parameters, 0},
  [424] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [427] =
    {field_index, 3},
    {field_object, 0},
    {field_optional_chain, 1},
  [430] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [433] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [437] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [440] =
    {field_name, 3},
    {field_type, 2},
    {field_value, 5},
    {field_value, 6},
  [444] =
    {field_source, 3, .inherited = true},
  [445] =
    {field_alias, 2},
    {field_name, 0},
  [447] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [452] =
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [456] =
    {field_body, 4},
    {field_name, 2},
  [458] =
    {field_body, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [461] =
    {field_type, 1},
    {field_type, 2, .inherited = true},
  [463] =
    {field_decorator, 0, .inherited = true},
    {field_value, 3},
  [465] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
  [468] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 4},
  [470] =
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [474] =
    {field_type, 3},
  [475] =
    {field_name, 2},
    {field_value, 3, .inherited = true},
  [477] =
    {field_name, 2},
    {field_type, 3},
  [479] =
    {field_name, 1},
    {field_value, 3, .inherited = true},
  [481] =
    {field_name, 1},
    {field_type, 3},
  [483] =
    {field_name, 1},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [486] =
    {field_name, 3},
  [487] =
    {field_name, 0},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [490] =
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
  [492] =
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_value, 3, .inherited = true},
  [495] =
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type, 3},
  [498] =
    {field_decorator, 0, .inherited = true},
    {field_name, 1},
    {field_value, 3, .inherited = true},
  [501] =
    {field_decorator, 0, .inherited = true},
    {field_name, 1},
    {field_type, 3},
  [504] =
    {field_decorator, 0, .inherited = true},
    {field_name, 1},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [508] =
    {field_parameters, 2},
    {field_type, 3},
    {field_type_parameters, 1},
  [511] =
    {field_parameters, 2},
    {field_type, 3},
  [513] =
    {field_parameters, 3},
    {field_type_parameters, 2},
  [515] =
    {field_index, 2},
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
  [519] =
    {field_index, 0, .inherited = true},
    {field_index, 2},
    {field_object, 0},
    {field_object, 0, .inherited = true},
  [523] =
    {field_arguments, 0, .inherited = true},
    {field_function, 0, .inherited = true},
    {field_index, 2},
    {field_object, 0},
  [527] =
    {field_parameters, 2},
    {field_type, 4},
    {field_type_parameters, 1},
  [530] =
    {field_parameters, 2},
    {field_type, 4},
  [532] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [536] =
    {field_alias, 3},
    {field_name, 1},
  [538] =
    {field_name, 1},
    {field_type_parameters, 2},
    {field_value, 4},
  [541] =
    {field_left, 1},
    {field_operator, 2},
    {field_right, 3},
  [544] =
    {field_body, 5},
    {field_condition, 3},
    {field_initializer, 2},
  [547] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [552] =
    {field_body, 5},
    {field_name, 2},
    {field_type_parameters, 3},
  [555] =
    {field_type, 0, .inherited = true},
    {field_type, 1, .inherited = true},
  [557] =
    {field_name, 2, .inherited = true},
  [558] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
  [561] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type_parameters, 4},
  [565] =
    {field_body, 3},
    {field_value, 1},
  [567] =
    {field_body, 4},
    {field_parameter, 2},
  [569] =
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [573] =
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [577] =
    {field_name, 2},
    {field_value, 4, .inherited = true},
  [579] =
    {field_name, 2},
    {field_type, 4},
  [581] =
    {field_name, 2},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [584] =
    {field_name, 1},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [587] =
    {field_name, 3},
    {field_value, 4, .inherited = true},
  [589] =
    {field_name, 3},
    {field_type, 4},
  [591] =
    {field_type, 4},
  [592] =
    {field_name, 4},
  [593] =
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_value, 4, .inherited = true},
  [596] =
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type, 4},
  [599] =
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_value, 4, .inherited = true},
  [602] =
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type, 4},
  [605] =
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [609] =
    {field_decorator, 0, .inherited = true},
    {field_name, 4},
  [611] =
    {field_decorator, 0, .inherited = true},
    {field_name, 1},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [615] =
    {field_parameters, 3},
    {field_type, 4},
    {field_type_parameters, 2},
  [618] =
    {field_index, 3},
    {field_object, 0},
  [620] =
    {field_index, 3},
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
  [624] =
    {field_index, 0, .inherited = true},
    {field_index, 3},
    {field_object, 0},
    {field_object, 0, .inherited = true},
  [628] =
    {field_arguments, 0, .inherited = true},
    {field_function, 0, .inherited = true},
    {field_index, 3},
    {field_object, 0},
  [632] =
    {field_parameters, 3},
    {field_type, 5},
    {field_type_parameters, 2},
  [635] =
    {field_source, 4},
  [636] =
    {field_kind, 1},
    {field_left, 2},
    {field_operator, 3},
    {field_right, 4},
  [640] =
    {field_body, 6},
    {field_condition, 3},
    {field_increment, 4},
    {field_initializer, 2},
  [644] =
    {field_body, 6},
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [649] =
    {field_body, 6},
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [654] =
    {field_body, 6},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type_parameters, 4},
  [658] =
    {field_body, 5},
    {field_parameter, 2},
    {field_type, 3},
  [661] =
    {field_index_type, 3},
    {field_name, 1},
    {field_type, 5},
  [664] =
    {field_alias, 4},
    {field_name, 0},
    {field_type, 2},
  [667] =
    {field_sign, 0},
    {field_type, 5},
  [669] =
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [673] =
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [677] =
    {field_name, 2},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [680] =
    {field_name, 3},
    {field_value, 5, .inherited = true},
  [682] =
    {field_name, 3},
    {field_type, 5},
  [684] =
    {field_name, 3},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [687] =
    {field_name, 4},
    {field_value, 5, .inherited = true},
  [689] =
    {field_name, 4},
    {field_type, 5},
  [691] =
    {field_name, 5},
  [692] =
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_value, 5, .inherited = true},
  [695] =
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type, 5},
  [698] =
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [702] =
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [706] =
    {field_decorator, 0, .inherited = true},
    {field_name, 4},
    {field_value, 5, .inherited = true},
  [709] =
    {field_decorator, 0, .inherited = true},
    {field_name, 4},
    {field_type, 5},
  [712] =
    {field_decorator, 0, .inherited = true},
    {field_name, 5},
  [714] =
    {field_alternative, 6},
    {field_consequence, 4},
    {field_left, 0},
    {field_right, 2},
  [718] =
    {field_kind, 1},
    {field_left, 2},
    {field_operator, 4},
    {field_right, 5},
    {field_value, 3, .inherited = true},
  [723] =
    {field_body, 7},
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [728] =
    {field_body, 7},
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [733] =
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [737] =
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [741] =
    {field_name, 3},
    {field_type, 5},
    {field_value, 6, .inherited = true},
  [744] =
    {field_index_type, 4},
    {field_name, 2},
    {field_type, 6},
  [747] =
    {field_name, 4},
    {field_value, 6, .inherited = true},
  [749] =
    {field_name, 4},
    {field_type, 6},
  [751] =
    {field_name, 4},
    {field_type, 5},
    {field_value, 6, .inherited = true},
  [754] =
    {field_name, 5},
    {field_value, 6, .inherited = true},
  [756] =
    {field_name, 5},
    {field_type, 6},
  [758] =
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type, 5},
    {field_value, 6, .inherited = true},
  [762] =
    {field_decorator, 0, .inherited = true},
    {field_name, 4},
    {field_value, 6, .inherited = true},
  [765] =
    {field_decorator, 0, .inherited = true},
    {field_name, 4},
    {field_type, 6},
  [768] =
    {field_decorator, 0, .inherited = true},
    {field_name, 4},
    {field_type, 5},
    {field_value, 6, .inherited = true},
  [772] =
    {field_decorator, 0, .inherited = true},
    {field_name, 5},
    {field_value, 6, .inherited = true},
  [775] =
    {field_decorator, 0, .inherited = true},
    {field_name, 5},
    {field_type, 6},
  [778] =
    {field_decorator, 0, .inherited = true},
    {field_name, 6},
  [780] =
    {field_body, 8},
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [785] =
    {field_body, 8},
    {field_name, 6},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [790] =
    {field_index_type, 5},
    {field_name, 3},
    {field_sign, 0},
    {field_type, 7},
  [794] =
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [798] =
    {field_name, 4},
    {field_type, 6},
    {field_value, 7, .inherited = true},
  [801] =
    {field_name, 5},
    {field_value, 7, .inherited = true},
  [803] =
    {field_name, 5},
    {field_type, 7},
  [805] =
    {field_name, 5},
    {field_type, 6},
    {field_value, 7, .inherited = true},
  [808] =
    {field_name, 6},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [812] =
    {field_decorator, 0, .inherited = true},
    {field_name, 4},
    {field_type, 6},
    {field_value, 7, .inherited = true},
  [816] =
    {field_decorator, 0, .inherited = true},
    {field_name, 5},
    {field_value, 7, .inherited = true},
  [819] =
    {field_decorator, 0, .inherited = true},
    {field_name, 5},
    {field_type, 7},
  [822] =
    {field_decorator, 0, .inherited = true},
    {field_name, 5},
    {field_type, 6},
    {field_value, 7, .inherited = true},
  [826] =
    {field_decorator, 0, .inherited = true},
    {field_name, 6},
    {field_value, 7, .inherited = true},
  [829] =
    {field_decorator, 0, .inherited = true},
    {field_name, 6},
    {field_type, 7},
  [832] =
    {field_body, 9},
    {field_name, 6},
    {field_parameters, 8, .inherited = true},
    {field_return_type, 8, .inherited = true},
    {field_type_parameters, 8, .inherited = true},
  [837] =
    {field_name, 5},
    {field_type, 7},
    {field_value, 8, .inherited = true},
  [840] =
    {field_name, 6},
    {field_parameters, 8, .inherited = true},
    {field_return_type, 8, .inherited = true},
    {field_type_parameters, 8, .inherited = true},
  [844] =
    {field_decorator, 0, .inherited = true},
    {field_name, 5},
    {field_type, 7},
    {field_value, 8, .inherited = true},
  [848] =
    {field_decorator, 0, .inherited = true},
    {field_name, 6},
    {field_value, 8, .inherited = true},
  [851] =
    {field_decorator, 0, .inherited = true},
    {field_name, 6},
    {field_type, 8},
  [854] =
    {field_decorator, 0, .inherited = true},
    {field_name, 6},
    {field_type, 7},
    {field_value, 8, .inherited = true},
  [858] =
    {field_decorator, 0, .inherited = true},
    {field_name, 6},
    {field_type, 8},
    {field_value, 9, .inherited = true},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [4] = {
    [0] = sym_identifier,
  },
  [10] = {
    [0] = sym_identifier,
  },
  [11] = {
    [1] = sym_identifier,
  },
  [18] = {
    [1] = sym_identifier,
  },
  [20] = {
    [0] = sym_identifier,
  },
  [23] = {
    [0] = alias_sym_property_identifier,
  },
  [27] = {
    [1] = sym_identifier,
  },
  [29] = {
    [1] = sym_identifier,
  },
  [39] = {
    [0] = anon_sym_list,
  },
  [40] = {
    [0] = anon_sym_list,
  },
  [41] = {
    [0] = alias_sym_this_type,
  },
  [50] = {
    [0] = sym_identifier,
    [2] = sym_identifier,
  },
  [51] = {
    [0] = sym_identifier,
  },
  [52] = {
    [1] = alias_sym_shorthand_property_identifier_pattern,
  },
  [53] = {
    [1] = sym_identifier,
  },
  [60] = {
    [2] = sym_identifier,
  },
  [62] = {
    [1] = anon_sym_list,
    [2] = sym_identifier,
  },
  [63] = {
    [2] = alias_sym_property_identifier,
  },
  [64] = {
    [2] = anon_sym_list,
  },
  [65] = {
    [1] = anon_sym_list,
  },
  [66] = {
    [0] = sym_member_expression,
    [2] = alias_sym_property_identifier,
  },
  [67] = {
    [2] = sym_identifier,
  },
  [71] = {
    [1] = sym_identifier,
  },
  [75] = {
    [0] = sym_identifier,
  },
  [76] = {
    [0] = sym_identifier,
  },
  [78] = {
    [1] = alias_sym_shorthand_property_identifier,
  },
  [89] = {
    [1] = anon_sym_list,
  },
  [100] = {
    [1] = anon_sym_list,
  },
  [101] = {
    [0] = anon_sym_list,
  },
  [102] = {
    [0] = anon_sym_list,
  },
  [103] = {
    [0] = anon_sym_list,
  },
  [104] = {
    [1] = anon_sym_list,
  },
  [105] = {
    [1] = anon_sym_unique,
  },
  [112] = {
    [2] = alias_sym_property_identifier,
  },
  [120] = {
    [0] = alias_sym_shorthand_property_identifier_pattern,
  },
  [123] = {
    [1] = anon_sym_list,
    [2] = sym_identifier,
  },
  [124] = {
    [1] = anon_sym_list,
  },
  [125] = {
    [2] = anon_sym_list,
  },
  [126] = {
    [2] = sym_identifier,
  },
  [128] = {
    [0] = anon_sym_list,
  },
  [131] = {
    [2] = anon_sym_list,
    [3] = sym_identifier,
  },
  [132] = {
    [2] = anon_sym_list,
  },
  [133] = {
    [3] = sym_identifier,
  },
  [136] = {
    [0] = alias_sym_statement_identifier,
  },
  [140] = {
    [1] = alias_sym_statement_identifier,
  },
  [141] = {
    [1] = anon_sym_list,
    [2] = alias_sym_interface_body,
  },
  [157] = {
    [1] = anon_sym_list,
  },
  [158] = {
    [1] = anon_sym_list,
  },
  [162] = {
    [1] = sym_identifier,
  },
  [167] = {
    [1] = sym_identifier,
  },
  [175] = {
    [1] = anon_sym_list,
  },
  [176] = {
    [1] = anon_sym_list,
  },
  [177] = {
    [0] = anon_sym_list,
  },
  [179] = {
    [2] = alias_sym_property_identifier,
  },
  [181] = {
    [2] = alias_sym_property_identifier,
  },
  [185] = {
    [2] = anon_sym_list,
  },
  [189] = {
    [1] = anon_sym_list,
    [2] = sym_identifier,
  },
  [190] = {
    [1] = anon_sym_list,
  },
  [191] = {
    [2] = sym_identifier,
  },
  [193] = {
    [2] = anon_sym_list,
  },
  [198] = {
    [2] = anon_sym_list,
    [3] = sym_identifier,
  },
  [199] = {
    [2] = anon_sym_list,
  },
  [200] = {
    [3] = sym_identifier,
  },
  [209] = {
    [2] = anon_sym_list,
  },
  [210] = {
    [1] = anon_sym_list,
  },
  [212] = {
    [1] = anon_sym_list,
    [3] = alias_sym_interface_body,
  },
  [213] = {
    [1] = anon_sym_list,
    [3] = alias_sym_interface_body,
  },
  [227] = {
    [1] = anon_sym_list,
  },
  [233] = {
    [2] = alias_sym_property_identifier,
  },
  [235] = {
    [1] = anon_sym_list,
  },
  [240] = {
    [0] = sym_identifier,
  },
  [241] = {
    [2] = anon_sym_list,
  },
  [242] = {
    [2] = anon_sym_list,
  },
  [244] = {
    [2] = anon_sym_list,
    [3] = sym_identifier,
  },
  [245] = {
    [2] = anon_sym_list,
  },
  [246] = {
    [3] = sym_identifier,
  },
  [251] = {
    [1] = anon_sym_list,
  },
  [252] = {
    [0] = sym_identifier,
  },
  [254] = {
    [2] = anon_sym_list,
  },
  [255] = {
    [2] = anon_sym_list,
  },
  [256] = {
    [1] = anon_sym_list,
  },
  [258] = {
    [1] = anon_sym_list,
    [4] = alias_sym_interface_body,
  },
  [260] = {
    [3] = anon_sym_list,
  },
  [263] = {
    [0] = anon_sym_list,
  },
  [286] = {
    [2] = anon_sym_list,
  },
  [288] = {
    [1] = anon_sym_list,
  },
  [289] = {
    [1] = sym_identifier,
  },
  [290] = {
    [1] = sym_identifier,
  },
  [294] = {
    [2] = anon_sym_list,
  },
  [297] = {
    [3] = anon_sym_list,
  },
  [298] = {
    [3] = anon_sym_list,
  },
  [329] = {
    [3] = alias_sym_property_identifier,
  },
  [330] = {
    [3] = anon_sym_list,
  },
  [332] = {
    [1] = sym_identifier,
  },
  [333] = {
    [0] = anon_sym_list,
  },
  [359] = {
    [2] = sym_identifier,
  },
  [375] = {
    [3] = sym_identifier,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_nested_identifier, 2,
    sym_nested_identifier,
    sym_member_expression,
  sym_predefined_type, 2,
    sym_predefined_type,
    sym_identifier,
  sym_object_type, 2,
    sym_object_type,
    alias_sym_interface_body,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 2,
  [4] = 4,
  [5] = 4,
  [6] = 4,
  [7] = 4,
  [8] = 4,
  [9] = 4,
  [10] = 4,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 17,
  [19] = 16,
  [20] = 16,
  [21] = 17,
  [22] = 16,
  [23] = 16,
  [24] = 16,
  [25] = 16,
  [26] = 17,
  [27] = 16,
  [28] = 17,
  [29] = 17,
  [30] = 17,
  [31] = 17,
  [32] = 32,
  [33] = 33,
  [34] = 34,
  [35] = 35,
  [36] = 36,
  [37] = 36,
  [38] = 35,
  [39] = 35,
  [40] = 40,
  [41] = 41,
  [42] = 42,
  [43] = 42,
  [44] = 41,
  [45] = 40,
  [46] = 40,
  [47] = 47,
  [48] = 34,
  [49] = 32,
  [50] = 47,
  [51] = 51,
  [52] = 33,
  [53] = 34,
  [54] = 32,
  [55] = 41,
  [56] = 47,
  [57] = 51,
  [58] = 51,
  [59] = 33,
  [60] = 42,
  [61] = 61,
  [62] = 61,
  [63] = 61,
  [64] = 64,
  [65] = 64,
  [66] = 61,
  [67] = 64,
  [68] = 61,
  [69] = 61,
  [70] = 61,
  [71] = 64,
  [72] = 61,
  [73] = 61,
  [74] = 61,
  [75] = 75,
  [76] = 76,
  [77] = 77,
  [78] = 78,
  [79] = 76,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 83,
  [84] = 84,
  [85] = 83,
  [86] = 86,
  [87] = 86,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 90,
  [92] = 90,
  [93] = 86,
  [94] = 94,
  [95] = 95,
  [96] = 94,
  [97] = 95,
  [98] = 95,
  [99] = 95,
  [100] = 89,
  [101] = 86,
  [102] = 94,
  [103] = 103,
  [104] = 95,
  [105] = 88,
  [106] = 89,
  [107] = 86,
  [108] = 108,
  [109] = 109,
  [110] = 86,
  [111] = 111,
  [112] = 84,
  [113] = 86,
  [114] = 86,
  [115] = 115,
  [116] = 86,
  [117] = 83,
  [118] = 118,
  [119] = 88,
  [120] = 89,
  [121] = 86,
  [122] = 89,
  [123] = 108,
  [124] = 86,
  [125] = 103,
  [126] = 86,
  [127] = 86,
  [128] = 86,
  [129] = 89,
  [130] = 89,
  [131] = 111,
  [132] = 86,
  [133] = 86,
  [134] = 134,
  [135] = 135,
  [136] = 134,
  [137] = 134,
  [138] = 134,
  [139] = 134,
  [140] = 134,
  [141] = 134,
  [142] = 134,
  [143] = 134,
  [144] = 86,
  [145] = 89,
  [146] = 89,
  [147] = 147,
  [148] = 147,
  [149] = 147,
  [150] = 147,
  [151] = 147,
  [152] = 147,
  [153] = 147,
  [154] = 147,
  [155] = 147,
  [156] = 156,
  [157] = 157,
  [158] = 158,
  [159] = 159,
  [160] = 159,
  [161] = 159,
  [162] = 159,
  [163] = 159,
  [164] = 159,
  [165] = 159,
  [166] = 159,
  [167] = 159,
  [168] = 168,
  [169] = 169,
  [170] = 168,
  [171] = 169,
  [172] = 169,
  [173] = 168,
  [174] = 168,
  [175] = 169,
  [176] = 176,
  [177] = 177,
  [178] = 178,
  [179] = 179,
  [180] = 180,
  [181] = 181,
  [182] = 182,
  [183] = 183,
  [184] = 184,
  [185] = 185,
  [186] = 186,
  [187] = 186,
  [188] = 188,
  [189] = 188,
  [190] = 190,
  [191] = 191,
  [192] = 191,
  [193] = 190,
  [194] = 194,
  [195] = 191,
  [196] = 194,
  [197] = 194,
  [198] = 190,
  [199] = 199,
  [200] = 200,
  [201] = 199,
  [202] = 199,
  [203] = 199,
  [204] = 199,
  [205] = 199,
  [206] = 206,
  [207] = 207,
  [208] = 199,
  [209] = 209,
  [210] = 210,
  [211] = 206,
  [212] = 209,
  [213] = 213,
  [214] = 209,
  [215] = 215,
  [216] = 206,
  [217] = 217,
  [218] = 213,
  [219] = 219,
  [220] = 220,
  [221] = 221,
  [222] = 217,
  [223] = 215,
  [224] = 213,
  [225] = 225,
  [226] = 226,
  [227] = 227,
  [228] = 228,
  [229] = 229,
  [230] = 230,
  [231] = 231,
  [232] = 232,
  [233] = 233,
  [234] = 234,
  [235] = 235,
  [236] = 236,
  [237] = 237,
  [238] = 238,
  [239] = 239,
  [240] = 240,
  [241] = 241,
  [242] = 242,
  [243] = 243,
  [244] = 244,
  [245] = 245,
  [246] = 246,
  [247] = 247,
  [248] = 248,
  [249] = 249,
  [250] = 250,
  [251] = 251,
  [252] = 252,
  [253] = 253,
  [254] = 254,
  [255] = 255,
  [256] = 237,
  [257] = 257,
  [258] = 258,
  [259] = 206,
  [260] = 258,
  [261] = 258,
  [262] = 258,
  [263] = 206,
  [264] = 206,
  [265] = 265,
  [266] = 237,
  [267] = 258,
  [268] = 206,
  [269] = 213,
  [270] = 206,
  [271] = 206,
  [272] = 258,
  [273] = 206,
  [274] = 258,
  [275] = 213,
  [276] = 276,
  [277] = 276,
  [278] = 276,
  [279] = 213,
  [280] = 276,
  [281] = 230,
  [282] = 282,
  [283] = 276,
  [284] = 276,
  [285] = 213,
  [286] = 276,
  [287] = 276,
  [288] = 288,
  [289] = 289,
  [290] = 276,
  [291] = 276,
  [292] = 292,
  [293] = 292,
  [294] = 294,
  [295] = 276,
  [296] = 276,
  [297] = 276,
  [298] = 213,
  [299] = 292,
  [300] = 276,
  [301] = 301,
  [302] = 302,
  [303] = 302,
  [304] = 301,
  [305] = 305,
  [306] = 306,
  [307] = 307,
  [308] = 308,
  [309] = 213,
  [310] = 310,
  [311] = 305,
  [312] = 312,
  [313] = 313,
  [314] = 312,
  [315] = 315,
  [316] = 315,
  [317] = 312,
  [318] = 318,
  [319] = 318,
  [320] = 320,
  [321] = 321,
  [322] = 318,
  [323] = 323,
  [324] = 324,
  [325] = 325,
  [326] = 324,
  [327] = 318,
  [328] = 328,
  [329] = 329,
  [330] = 330,
  [331] = 331,
  [332] = 332,
  [333] = 333,
  [334] = 334,
  [335] = 329,
  [336] = 336,
  [337] = 337,
  [338] = 336,
  [339] = 339,
  [340] = 324,
  [341] = 341,
  [342] = 333,
  [343] = 339,
  [344] = 339,
  [345] = 336,
  [346] = 318,
  [347] = 347,
  [348] = 324,
  [349] = 325,
  [350] = 336,
  [351] = 318,
  [352] = 324,
  [353] = 324,
  [354] = 336,
  [355] = 324,
  [356] = 333,
  [357] = 347,
  [358] = 358,
  [359] = 333,
  [360] = 339,
  [361] = 339,
  [362] = 333,
  [363] = 324,
  [364] = 318,
  [365] = 339,
  [366] = 366,
  [367] = 339,
  [368] = 329,
  [369] = 336,
  [370] = 333,
  [371] = 329,
  [372] = 318,
  [373] = 324,
  [374] = 336,
  [375] = 333,
  [376] = 329,
  [377] = 377,
  [378] = 329,
  [379] = 329,
  [380] = 318,
  [381] = 336,
  [382] = 382,
  [383] = 339,
  [384] = 339,
  [385] = 337,
  [386] = 329,
  [387] = 320,
  [388] = 388,
  [389] = 336,
  [390] = 329,
  [391] = 325,
  [392] = 333,
  [393] = 333,
  [394] = 394,
  [395] = 395,
  [396] = 396,
  [397] = 397,
  [398] = 398,
  [399] = 399,
  [400] = 400,
  [401] = 401,
  [402] = 402,
  [403] = 403,
  [404] = 404,
  [405] = 405,
  [406] = 403,
  [407] = 407,
  [408] = 408,
  [409] = 409,
  [410] = 410,
  [411] = 411,
  [412] = 412,
  [413] = 410,
  [414] = 414,
  [415] = 415,
  [416] = 416,
  [417] = 417,
  [418] = 395,
  [419] = 419,
  [420] = 420,
  [421] = 396,
  [422] = 422,
  [423] = 405,
  [424] = 410,
  [425] = 405,
  [426] = 396,
  [427] = 397,
  [428] = 407,
  [429] = 401,
  [430] = 404,
  [431] = 404,
  [432] = 417,
  [433] = 410,
  [434] = 416,
  [435] = 420,
  [436] = 407,
  [437] = 437,
  [438] = 405,
  [439] = 415,
  [440] = 414,
  [441] = 398,
  [442] = 442,
  [443] = 396,
  [444] = 420,
  [445] = 445,
  [446] = 446,
  [447] = 419,
  [448] = 403,
  [449] = 403,
  [450] = 395,
  [451] = 422,
  [452] = 404,
  [453] = 400,
  [454] = 442,
  [455] = 412,
  [456] = 417,
  [457] = 403,
  [458] = 416,
  [459] = 415,
  [460] = 414,
  [461] = 402,
  [462] = 442,
  [463] = 412,
  [464] = 404,
  [465] = 400,
  [466] = 397,
  [467] = 407,
  [468] = 401,
  [469] = 409,
  [470] = 411,
  [471] = 409,
  [472] = 414,
  [473] = 398,
  [474] = 398,
  [475] = 399,
  [476] = 476,
  [477] = 408,
  [478] = 399,
  [479] = 397,
  [480] = 408,
  [481] = 401,
  [482] = 409,
  [483] = 415,
  [484] = 404,
  [485] = 485,
  [486] = 397,
  [487] = 399,
  [488] = 488,
  [489] = 400,
  [490] = 398,
  [491] = 409,
  [492] = 399,
  [493] = 408,
  [494] = 416,
  [495] = 409,
  [496] = 417,
  [497] = 437,
  [498] = 442,
  [499] = 408,
  [500] = 402,
  [501] = 437,
  [502] = 401,
  [503] = 414,
  [504] = 399,
  [505] = 397,
  [506] = 398,
  [507] = 399,
  [508] = 422,
  [509] = 415,
  [510] = 398,
  [511] = 403,
  [512] = 446,
  [513] = 395,
  [514] = 404,
  [515] = 400,
  [516] = 422,
  [517] = 442,
  [518] = 442,
  [519] = 419,
  [520] = 398,
  [521] = 404,
  [522] = 412,
  [523] = 402,
  [524] = 402,
  [525] = 525,
  [526] = 488,
  [527] = 400,
  [528] = 414,
  [529] = 419,
  [530] = 422,
  [531] = 420,
  [532] = 446,
  [533] = 401,
  [534] = 415,
  [535] = 535,
  [536] = 403,
  [537] = 488,
  [538] = 403,
  [539] = 446,
  [540] = 412,
  [541] = 412,
  [542] = 422,
  [543] = 416,
  [544] = 422,
  [545] = 446,
  [546] = 403,
  [547] = 547,
  [548] = 402,
  [549] = 408,
  [550] = 550,
  [551] = 412,
  [552] = 402,
  [553] = 416,
  [554] = 417,
  [555] = 555,
  [556] = 412,
  [557] = 557,
  [558] = 395,
  [559] = 442,
  [560] = 399,
  [561] = 419,
  [562] = 395,
  [563] = 417,
  [564] = 422,
  [565] = 395,
  [566] = 446,
  [567] = 437,
  [568] = 419,
  [569] = 420,
  [570] = 555,
  [571] = 400,
  [572] = 404,
  [573] = 401,
  [574] = 420,
  [575] = 396,
  [576] = 405,
  [577] = 396,
  [578] = 437,
  [579] = 579,
  [580] = 404,
  [581] = 407,
  [582] = 582,
  [583] = 405,
  [584] = 412,
  [585] = 410,
  [586] = 442,
  [587] = 437,
  [588] = 407,
  [589] = 589,
  [590] = 446,
  [591] = 408,
  [592] = 404,
  [593] = 401,
  [594] = 417,
  [595] = 419,
  [596] = 410,
  [597] = 437,
  [598] = 405,
  [599] = 396,
  [600] = 420,
  [601] = 442,
  [602] = 408,
  [603] = 400,
  [604] = 396,
  [605] = 407,
  [606] = 397,
  [607] = 397,
  [608] = 409,
  [609] = 446,
  [610] = 402,
  [611] = 416,
  [612] = 414,
  [613] = 415,
  [614] = 404,
  [615] = 615,
  [616] = 525,
  [617] = 446,
  [618] = 422,
  [619] = 407,
  [620] = 404,
  [621] = 420,
  [622] = 398,
  [623] = 419,
  [624] = 405,
  [625] = 410,
  [626] = 395,
  [627] = 399,
  [628] = 417,
  [629] = 629,
  [630] = 401,
  [631] = 415,
  [632] = 414,
  [633] = 409,
  [634] = 397,
  [635] = 416,
  [636] = 400,
  [637] = 416,
  [638] = 408,
  [639] = 415,
  [640] = 410,
  [641] = 407,
  [642] = 417,
  [643] = 404,
  [644] = 488,
  [645] = 437,
  [646] = 410,
  [647] = 402,
  [648] = 405,
  [649] = 396,
  [650] = 414,
  [651] = 420,
  [652] = 437,
  [653] = 419,
  [654] = 409,
  [655] = 395,
  [656] = 656,
  [657] = 656,
  [658] = 656,
  [659] = 656,
  [660] = 660,
  [661] = 660,
  [662] = 660,
  [663] = 660,
  [664] = 664,
  [665] = 665,
  [666] = 665,
  [667] = 664,
  [668] = 664,
  [669] = 665,
  [670] = 664,
  [671] = 665,
  [672] = 672,
  [673] = 672,
  [674] = 672,
  [675] = 672,
  [676] = 676,
  [677] = 677,
  [678] = 678,
  [679] = 679,
  [680] = 680,
  [681] = 681,
  [682] = 681,
  [683] = 683,
  [684] = 681,
  [685] = 683,
  [686] = 683,
  [687] = 683,
  [688] = 681,
  [689] = 689,
  [690] = 689,
  [691] = 689,
  [692] = 689,
  [693] = 693,
  [694] = 694,
  [695] = 695,
  [696] = 694,
  [697] = 693,
  [698] = 694,
  [699] = 699,
  [700] = 700,
  [701] = 699,
  [702] = 700,
  [703] = 699,
  [704] = 695,
  [705] = 705,
  [706] = 706,
  [707] = 705,
  [708] = 705,
  [709] = 699,
  [710] = 710,
  [711] = 699,
  [712] = 712,
  [713] = 713,
  [714] = 710,
  [715] = 699,
  [716] = 710,
  [717] = 699,
  [718] = 699,
  [719] = 719,
  [720] = 719,
  [721] = 699,
  [722] = 722,
  [723] = 723,
  [724] = 724,
  [725] = 719,
  [726] = 719,
  [727] = 693,
  [728] = 699,
  [729] = 729,
  [730] = 699,
  [731] = 241,
  [732] = 252,
  [733] = 729,
  [734] = 248,
  [735] = 699,
  [736] = 699,
  [737] = 699,
  [738] = 729,
  [739] = 245,
  [740] = 729,
  [741] = 741,
  [742] = 699,
  [743] = 741,
  [744] = 699,
  [745] = 741,
  [746] = 741,
  [747] = 741,
  [748] = 233,
  [749] = 749,
  [750] = 741,
  [751] = 741,
  [752] = 225,
  [753] = 242,
  [754] = 741,
  [755] = 226,
  [756] = 741,
  [757] = 699,
  [758] = 713,
  [759] = 759,
  [760] = 227,
  [761] = 761,
  [762] = 762,
  [763] = 763,
  [764] = 236,
  [765] = 765,
  [766] = 766,
  [767] = 767,
  [768] = 768,
  [769] = 233,
  [770] = 770,
  [771] = 771,
  [772] = 772,
  [773] = 249,
  [774] = 774,
  [775] = 242,
  [776] = 776,
  [777] = 248,
  [778] = 778,
  [779] = 241,
  [780] = 780,
  [781] = 781,
  [782] = 782,
  [783] = 783,
  [784] = 784,
  [785] = 785,
  [786] = 786,
  [787] = 787,
  [788] = 788,
  [789] = 789,
  [790] = 790,
  [791] = 791,
  [792] = 792,
  [793] = 793,
  [794] = 794,
  [795] = 795,
  [796] = 796,
  [797] = 797,
  [798] = 798,
  [799] = 799,
  [800] = 800,
  [801] = 240,
  [802] = 802,
  [803] = 803,
  [804] = 804,
  [805] = 805,
  [806] = 806,
  [807] = 229,
  [808] = 808,
  [809] = 809,
  [810] = 232,
  [811] = 811,
  [812] = 234,
  [813] = 813,
  [814] = 814,
  [815] = 815,
  [816] = 816,
  [817] = 817,
  [818] = 818,
  [819] = 819,
  [820] = 820,
  [821] = 821,
  [822] = 822,
  [823] = 823,
  [824] = 824,
  [825] = 825,
  [826] = 826,
  [827] = 827,
  [828] = 828,
  [829] = 829,
  [830] = 830,
  [831] = 831,
  [832] = 832,
  [833] = 833,
  [834] = 834,
  [835] = 835,
  [836] = 836,
  [837] = 837,
  [838] = 838,
  [839] = 839,
  [840] = 840,
  [841] = 841,
  [842] = 842,
  [843] = 843,
  [844] = 844,
  [845] = 845,
  [846] = 846,
  [847] = 847,
  [848] = 848,
  [849] = 849,
  [850] = 850,
  [851] = 851,
  [852] = 852,
  [853] = 853,
  [854] = 854,
  [855] = 855,
  [856] = 856,
  [857] = 857,
  [858] = 858,
  [859] = 859,
  [860] = 860,
  [861] = 861,
  [862] = 862,
  [863] = 863,
  [864] = 864,
  [865] = 865,
  [866] = 866,
  [867] = 867,
  [868] = 868,
  [869] = 869,
  [870] = 870,
  [871] = 871,
  [872] = 872,
  [873] = 873,
  [874] = 874,
  [875] = 875,
  [876] = 876,
  [877] = 877,
  [878] = 878,
  [879] = 879,
  [880] = 880,
  [881] = 881,
  [882] = 882,
  [883] = 883,
  [884] = 884,
  [885] = 885,
  [886] = 886,
  [887] = 887,
  [888] = 888,
  [889] = 245,
  [890] = 890,
  [891] = 891,
  [892] = 892,
  [893] = 893,
  [894] = 894,
  [895] = 895,
  [896] = 896,
  [897] = 897,
  [898] = 898,
  [899] = 899,
  [900] = 900,
  [901] = 252,
  [902] = 902,
  [903] = 903,
  [904] = 904,
  [905] = 905,
  [906] = 906,
  [907] = 907,
  [908] = 908,
  [909] = 909,
  [910] = 910,
  [911] = 911,
  [912] = 912,
  [913] = 913,
  [914] = 914,
  [915] = 915,
  [916] = 770,
  [917] = 917,
  [918] = 767,
  [919] = 227,
  [920] = 225,
  [921] = 226,
  [922] = 249,
  [923] = 234,
  [924] = 232,
  [925] = 236,
  [926] = 219,
  [927] = 229,
  [928] = 242,
  [929] = 929,
  [930] = 930,
  [931] = 931,
  [932] = 930,
  [933] = 231,
  [934] = 934,
  [935] = 935,
  [936] = 936,
  [937] = 937,
  [938] = 930,
  [939] = 939,
  [940] = 940,
  [941] = 253,
  [942] = 930,
  [943] = 228,
  [944] = 944,
  [945] = 255,
  [946] = 233,
  [947] = 250,
  [948] = 948,
  [949] = 238,
  [950] = 950,
  [951] = 239,
  [952] = 244,
  [953] = 252,
  [954] = 930,
  [955] = 955,
  [956] = 930,
  [957] = 955,
  [958] = 243,
  [959] = 235,
  [960] = 930,
  [961] = 251,
  [962] = 930,
  [963] = 248,
  [964] = 930,
  [965] = 245,
  [966] = 254,
  [967] = 930,
  [968] = 930,
  [969] = 930,
  [970] = 240,
  [971] = 955,
  [972] = 955,
  [973] = 930,
  [974] = 241,
  [975] = 955,
  [976] = 246,
  [977] = 977,
  [978] = 978,
  [979] = 977,
  [980] = 977,
  [981] = 978,
  [982] = 978,
  [983] = 978,
  [984] = 977,
  [985] = 978,
  [986] = 977,
  [987] = 987,
  [988] = 988,
  [989] = 988,
  [990] = 988,
  [991] = 991,
  [992] = 992,
  [993] = 992,
  [994] = 994,
  [995] = 991,
  [996] = 991,
  [997] = 997,
  [998] = 998,
  [999] = 998,
  [1000] = 1000,
  [1001] = 998,
  [1002] = 1000,
  [1003] = 994,
  [1004] = 992,
  [1005] = 1000,
  [1006] = 1000,
  [1007] = 992,
  [1008] = 994,
  [1009] = 994,
  [1010] = 1010,
  [1011] = 1011,
  [1012] = 998,
  [1013] = 992,
  [1014] = 992,
  [1015] = 997,
  [1016] = 997,
  [1017] = 991,
  [1018] = 997,
  [1019] = 998,
  [1020] = 997,
  [1021] = 998,
  [1022] = 997,
  [1023] = 1011,
  [1024] = 994,
  [1025] = 1000,
  [1026] = 991,
  [1027] = 1000,
  [1028] = 991,
  [1029] = 994,
  [1030] = 1030,
  [1031] = 1031,
  [1032] = 1032,
  [1033] = 1032,
  [1034] = 1032,
  [1035] = 1032,
  [1036] = 1032,
  [1037] = 1031,
  [1038] = 1032,
  [1039] = 1039,
  [1040] = 1039,
  [1041] = 1041,
  [1042] = 1039,
  [1043] = 1039,
  [1044] = 1041,
  [1045] = 1041,
  [1046] = 1041,
  [1047] = 1039,
  [1048] = 1041,
  [1049] = 1041,
  [1050] = 1039,
  [1051] = 1051,
  [1052] = 1052,
  [1053] = 1052,
  [1054] = 1051,
  [1055] = 1055,
  [1056] = 1056,
  [1057] = 1052,
  [1058] = 1056,
  [1059] = 1052,
  [1060] = 1056,
  [1061] = 1051,
  [1062] = 1055,
  [1063] = 1051,
  [1064] = 1055,
  [1065] = 1051,
  [1066] = 1055,
  [1067] = 1056,
  [1068] = 1068,
  [1069] = 1069,
  [1070] = 1070,
  [1071] = 1071,
  [1072] = 1072,
  [1073] = 1071,
  [1074] = 1074,
  [1075] = 1075,
  [1076] = 1069,
  [1077] = 1077,
  [1078] = 1070,
  [1079] = 1071,
  [1080] = 1080,
  [1081] = 1081,
  [1082] = 1082,
  [1083] = 1082,
  [1084] = 1084,
  [1085] = 1085,
  [1086] = 1086,
  [1087] = 1084,
  [1088] = 1088,
  [1089] = 1089,
  [1090] = 1080,
  [1091] = 1091,
  [1092] = 1070,
  [1093] = 1093,
  [1094] = 1094,
  [1095] = 1095,
  [1096] = 1089,
  [1097] = 1093,
  [1098] = 1098,
  [1099] = 1070,
  [1100] = 1100,
  [1101] = 1101,
  [1102] = 1102,
  [1103] = 1077,
  [1104] = 1080,
  [1105] = 1105,
  [1106] = 1068,
  [1107] = 1077,
  [1108] = 1071,
  [1109] = 1081,
  [1110] = 1085,
  [1111] = 1091,
  [1112] = 1112,
  [1113] = 1089,
  [1114] = 1089,
  [1115] = 1082,
  [1116] = 1116,
  [1117] = 1088,
  [1118] = 1118,
  [1119] = 1102,
  [1120] = 1080,
  [1121] = 1077,
  [1122] = 1091,
  [1123] = 1085,
  [1124] = 1102,
  [1125] = 1069,
  [1126] = 1081,
  [1127] = 1082,
  [1128] = 1128,
  [1129] = 1082,
  [1130] = 1130,
  [1131] = 1131,
  [1132] = 1132,
  [1133] = 1133,
  [1134] = 1085,
  [1135] = 1081,
  [1136] = 1118,
  [1137] = 1137,
  [1138] = 1071,
  [1139] = 1069,
  [1140] = 1070,
  [1141] = 1080,
  [1142] = 1077,
  [1143] = 1084,
  [1144] = 1098,
  [1145] = 1116,
  [1146] = 1100,
  [1147] = 1101,
  [1148] = 1100,
  [1149] = 1069,
  [1150] = 1150,
  [1151] = 1093,
  [1152] = 1082,
  [1153] = 1088,
  [1154] = 1101,
  [1155] = 1088,
  [1156] = 1118,
  [1157] = 1116,
  [1158] = 1116,
  [1159] = 1101,
  [1160] = 1100,
  [1161] = 1118,
  [1162] = 1084,
  [1163] = 1091,
  [1164] = 1164,
  [1165] = 1165,
  [1166] = 1166,
  [1167] = 1093,
  [1168] = 1088,
  [1169] = 1084,
  [1170] = 1081,
  [1171] = 1091,
  [1172] = 1093,
  [1173] = 1118,
  [1174] = 1116,
  [1175] = 1086,
  [1176] = 1089,
  [1177] = 1100,
  [1178] = 1178,
  [1179] = 1089,
  [1180] = 1101,
  [1181] = 1101,
  [1182] = 1069,
  [1183] = 1077,
  [1184] = 1112,
  [1185] = 1085,
  [1186] = 1080,
  [1187] = 1100,
  [1188] = 1116,
  [1189] = 1084,
  [1190] = 1070,
  [1191] = 1071,
  [1192] = 1091,
  [1193] = 1118,
  [1194] = 1098,
  [1195] = 1088,
  [1196] = 1086,
  [1197] = 1081,
  [1198] = 1198,
  [1199] = 1199,
  [1200] = 1093,
  [1201] = 1085,
  [1202] = 1202,
  [1203] = 1203,
  [1204] = 1204,
  [1205] = 1205,
  [1206] = 1203,
  [1207] = 1207,
  [1208] = 1208,
  [1209] = 1209,
  [1210] = 1210,
  [1211] = 1209,
  [1212] = 1212,
  [1213] = 1213,
  [1214] = 1210,
  [1215] = 1215,
  [1216] = 1216,
  [1217] = 1217,
  [1218] = 1218,
  [1219] = 1219,
  [1220] = 1219,
  [1221] = 1221,
  [1222] = 1217,
  [1223] = 1217,
  [1224] = 1218,
  [1225] = 1219,
  [1226] = 1218,
  [1227] = 1204,
  [1228] = 1228,
  [1229] = 1210,
  [1230] = 1210,
  [1231] = 1210,
  [1232] = 1210,
  [1233] = 1210,
  [1234] = 1234,
  [1235] = 1235,
  [1236] = 1236,
  [1237] = 1235,
  [1238] = 1235,
  [1239] = 1236,
  [1240] = 1235,
  [1241] = 1235,
  [1242] = 1236,
  [1243] = 1210,
  [1244] = 1236,
  [1245] = 1235,
  [1246] = 1235,
  [1247] = 1247,
  [1248] = 1248,
  [1249] = 1249,
  [1250] = 1250,
  [1251] = 1248,
  [1252] = 1252,
  [1253] = 1253,
  [1254] = 1254,
  [1255] = 1249,
  [1256] = 1210,
  [1257] = 1257,
  [1258] = 1247,
  [1259] = 1210,
  [1260] = 1249,
  [1261] = 1261,
  [1262] = 1262,
  [1263] = 1249,
  [1264] = 1247,
  [1265] = 1265,
  [1266] = 1210,
  [1267] = 1267,
  [1268] = 1248,
  [1269] = 1203,
  [1270] = 1248,
  [1271] = 1262,
  [1272] = 1272,
  [1273] = 1273,
  [1274] = 1210,
  [1275] = 1267,
  [1276] = 1262,
  [1277] = 1247,
  [1278] = 1278,
  [1279] = 1210,
  [1280] = 1221,
  [1281] = 1278,
  [1282] = 1282,
  [1283] = 1282,
  [1284] = 1284,
  [1285] = 1285,
  [1286] = 1210,
  [1287] = 1285,
  [1288] = 1288,
  [1289] = 1282,
  [1290] = 1285,
  [1291] = 1278,
  [1292] = 1278,
  [1293] = 1210,
  [1294] = 1267,
  [1295] = 1278,
  [1296] = 1285,
  [1297] = 1285,
  [1298] = 1282,
  [1299] = 1282,
  [1300] = 1282,
  [1301] = 1278,
  [1302] = 1210,
  [1303] = 1285,
  [1304] = 1267,
  [1305] = 1282,
  [1306] = 1210,
  [1307] = 1210,
  [1308] = 767,
  [1309] = 770,
  [1310] = 1310,
  [1311] = 1311,
  [1312] = 1267,
  [1313] = 1285,
  [1314] = 1278,
  [1315] = 1315,
  [1316] = 1316,
  [1317] = 1315,
  [1318] = 1210,
  [1319] = 1267,
  [1320] = 1320,
  [1321] = 1267,
  [1322] = 1315,
  [1323] = 1315,
  [1324] = 1324,
  [1325] = 1325,
  [1326] = 1310,
  [1327] = 1310,
  [1328] = 1328,
  [1329] = 1329,
  [1330] = 1316,
  [1331] = 1331,
  [1332] = 1315,
  [1333] = 1284,
  [1334] = 1315,
  [1335] = 1335,
  [1336] = 1315,
  [1337] = 1315,
  [1338] = 1324,
  [1339] = 1284,
  [1340] = 1340,
  [1341] = 1315,
  [1342] = 1267,
  [1343] = 1325,
  [1344] = 1344,
  [1345] = 1345,
  [1346] = 1346,
  [1347] = 1267,
  [1348] = 1344,
  [1349] = 1349,
  [1350] = 1325,
  [1351] = 1351,
  [1352] = 1349,
  [1353] = 1353,
  [1354] = 1267,
  [1355] = 1349,
  [1356] = 1340,
  [1357] = 1345,
  [1358] = 1353,
  [1359] = 1284,
  [1360] = 1349,
  [1361] = 1267,
  [1362] = 1349,
  [1363] = 1363,
  [1364] = 1353,
  [1365] = 1365,
  [1366] = 1363,
  [1367] = 1367,
  [1368] = 1346,
  [1369] = 1349,
  [1370] = 1367,
  [1371] = 1340,
  [1372] = 1349,
  [1373] = 1351,
  [1374] = 1284,
  [1375] = 1375,
  [1376] = 1267,
  [1377] = 1377,
  [1378] = 1267,
  [1379] = 1379,
  [1380] = 1331,
  [1381] = 1329,
  [1382] = 767,
  [1383] = 1367,
  [1384] = 1340,
  [1385] = 1385,
  [1386] = 1344,
  [1387] = 1272,
  [1388] = 1388,
  [1389] = 1311,
  [1390] = 1390,
  [1391] = 1284,
  [1392] = 1367,
  [1393] = 1344,
  [1394] = 1367,
  [1395] = 1253,
  [1396] = 1388,
  [1397] = 1397,
  [1398] = 1284,
  [1399] = 1344,
  [1400] = 1325,
  [1401] = 1401,
  [1402] = 1261,
  [1403] = 1284,
  [1404] = 1377,
  [1405] = 1390,
  [1406] = 1328,
  [1407] = 1388,
  [1408] = 1340,
  [1409] = 1284,
  [1410] = 1344,
  [1411] = 1367,
  [1412] = 1390,
  [1413] = 1267,
  [1414] = 1331,
  [1415] = 770,
  [1416] = 1257,
  [1417] = 1254,
  [1418] = 1329,
  [1419] = 1252,
  [1420] = 1250,
  [1421] = 1311,
  [1422] = 1422,
  [1423] = 1423,
  [1424] = 1424,
  [1425] = 1329,
  [1426] = 1426,
  [1427] = 1331,
  [1428] = 1424,
  [1429] = 1424,
  [1430] = 1375,
  [1431] = 1423,
  [1432] = 1426,
  [1433] = 1340,
  [1434] = 1320,
  [1435] = 1423,
  [1436] = 1340,
  [1437] = 1424,
  [1438] = 1438,
  [1439] = 1426,
  [1440] = 1340,
  [1441] = 1344,
  [1442] = 1422,
  [1443] = 1422,
  [1444] = 1340,
  [1445] = 1422,
  [1446] = 1367,
  [1447] = 1284,
  [1448] = 1448,
  [1449] = 1424,
  [1450] = 1344,
  [1451] = 1311,
  [1452] = 1423,
  [1453] = 1367,
  [1454] = 1423,
  [1455] = 1423,
  [1456] = 1422,
  [1457] = 1457,
  [1458] = 1458,
  [1459] = 1422,
  [1460] = 1422,
  [1461] = 1422,
  [1462] = 1424,
  [1463] = 1424,
  [1464] = 1311,
  [1465] = 1423,
  [1466] = 1423,
  [1467] = 1367,
  [1468] = 1344,
  [1469] = 1316,
  [1470] = 1344,
  [1471] = 1324,
  [1472] = 1472,
  [1473] = 1311,
  [1474] = 1340,
  [1475] = 1475,
  [1476] = 1367,
  [1477] = 1477,
  [1478] = 1331,
  [1479] = 1479,
  [1480] = 1329,
  [1481] = 1344,
  [1482] = 1344,
  [1483] = 1367,
  [1484] = 1367,
  [1485] = 1344,
  [1486] = 1367,
  [1487] = 1311,
  [1488] = 1397,
  [1489] = 1351,
  [1490] = 1344,
  [1491] = 1344,
  [1492] = 1367,
  [1493] = 1401,
  [1494] = 1367,
  [1495] = 1367,
  [1496] = 1344,
  [1497] = 1497,
  [1498] = 1438,
  [1499] = 1499,
  [1500] = 1344,
  [1501] = 1501,
  [1502] = 1502,
  [1503] = 1502,
  [1504] = 1367,
  [1505] = 1499,
  [1506] = 1499,
  [1507] = 1502,
  [1508] = 1499,
  [1509] = 1502,
  [1510] = 1502,
  [1511] = 1511,
  [1512] = 1499,
  [1513] = 1311,
  [1514] = 1499,
  [1515] = 1499,
  [1516] = 1502,
  [1517] = 1501,
  [1518] = 1502,
  [1519] = 1499,
  [1520] = 1311,
  [1521] = 1521,
  [1522] = 1502,
  [1523] = 1311,
  [1524] = 1499,
  [1525] = 1521,
  [1526] = 1502,
  [1527] = 1527,
  [1528] = 1527,
  [1529] = 1529,
  [1530] = 1527,
  [1531] = 1527,
  [1532] = 1529,
  [1533] = 1529,
  [1534] = 1529,
  [1535] = 1529,
  [1536] = 1529,
  [1537] = 1527,
  [1538] = 1527,
  [1539] = 1527,
  [1540] = 248,
  [1541] = 241,
  [1542] = 1527,
  [1543] = 1527,
  [1544] = 242,
  [1545] = 1545,
  [1546] = 233,
  [1547] = 233,
  [1548] = 241,
  [1549] = 1549,
  [1550] = 1550,
  [1551] = 1550,
  [1552] = 1549,
  [1553] = 1549,
  [1554] = 248,
  [1555] = 1550,
  [1556] = 242,
  [1557] = 1549,
  [1558] = 1550,
  [1559] = 1549,
  [1560] = 1550,
  [1561] = 1550,
  [1562] = 1549,
  [1563] = 1563,
  [1564] = 1564,
  [1565] = 1565,
  [1566] = 1566,
  [1567] = 1566,
  [1568] = 1566,
  [1569] = 1565,
  [1570] = 1566,
  [1571] = 1571,
  [1572] = 1565,
  [1573] = 1573,
  [1574] = 1565,
  [1575] = 1565,
  [1576] = 1565,
  [1577] = 1566,
  [1578] = 1566,
  [1579] = 1579,
  [1580] = 1580,
  [1581] = 1580,
  [1582] = 1582,
  [1583] = 1580,
  [1584] = 1584,
  [1585] = 1585,
  [1586] = 1586,
  [1587] = 1580,
  [1588] = 1588,
  [1589] = 1589,
  [1590] = 1590,
  [1591] = 1591,
  [1592] = 1592,
  [1593] = 1593,
  [1594] = 1584,
  [1595] = 1595,
  [1596] = 1580,
  [1597] = 1597,
  [1598] = 1598,
  [1599] = 1580,
  [1600] = 1600,
  [1601] = 1580,
  [1602] = 1602,
  [1603] = 1603,
  [1604] = 1604,
  [1605] = 1605,
  [1606] = 1606,
  [1607] = 1607,
  [1608] = 1608,
  [1609] = 1609,
  [1610] = 1610,
  [1611] = 1604,
  [1612] = 1608,
  [1613] = 1613,
  [1614] = 1614,
  [1615] = 1615,
  [1616] = 1616,
  [1617] = 1608,
  [1618] = 1618,
  [1619] = 1608,
  [1620] = 1620,
  [1621] = 1621,
  [1622] = 1604,
  [1623] = 1608,
  [1624] = 1604,
  [1625] = 1602,
  [1626] = 1626,
  [1627] = 1627,
  [1628] = 1606,
  [1629] = 1629,
  [1630] = 1602,
  [1631] = 1606,
  [1632] = 1632,
  [1633] = 1603,
  [1634] = 1602,
  [1635] = 1604,
  [1636] = 1636,
  [1637] = 1608,
  [1638] = 1638,
  [1639] = 1639,
  [1640] = 232,
  [1641] = 1602,
  [1642] = 234,
  [1643] = 1643,
  [1644] = 1606,
  [1645] = 1645,
  [1646] = 1608,
  [1647] = 1647,
  [1648] = 1648,
  [1649] = 1649,
  [1650] = 1604,
  [1651] = 1651,
  [1652] = 1652,
  [1653] = 1632,
  [1654] = 1654,
  [1655] = 1655,
  [1656] = 1656,
  [1657] = 1657,
  [1658] = 1629,
  [1659] = 1659,
  [1660] = 1660,
  [1661] = 1655,
  [1662] = 1662,
  [1663] = 1663,
  [1664] = 1664,
  [1665] = 1604,
  [1666] = 1602,
  [1667] = 1667,
  [1668] = 1606,
  [1669] = 1606,
  [1670] = 1670,
  [1671] = 1671,
  [1672] = 1672,
  [1673] = 1673,
  [1674] = 1674,
  [1675] = 1675,
  [1676] = 1672,
  [1677] = 1672,
  [1678] = 1674,
  [1679] = 1679,
  [1680] = 1672,
  [1681] = 1681,
  [1682] = 1682,
  [1683] = 1683,
  [1684] = 1684,
  [1685] = 1685,
  [1686] = 1686,
  [1687] = 1686,
  [1688] = 1688,
  [1689] = 1685,
  [1690] = 1672,
  [1691] = 1691,
  [1692] = 1692,
  [1693] = 1693,
  [1694] = 1694,
  [1695] = 1695,
  [1696] = 1696,
  [1697] = 1697,
  [1698] = 1672,
  [1699] = 1699,
  [1700] = 1700,
  [1701] = 1701,
  [1702] = 1702,
  [1703] = 1703,
  [1704] = 1691,
  [1705] = 1672,
  [1706] = 1706,
  [1707] = 1707,
  [1708] = 1708,
  [1709] = 1709,
  [1710] = 1710,
  [1711] = 1711,
  [1712] = 1712,
  [1713] = 1713,
  [1714] = 1714,
  [1715] = 1215,
  [1716] = 1716,
  [1717] = 1717,
  [1718] = 1718,
  [1719] = 1719,
  [1720] = 1720,
  [1721] = 1721,
  [1722] = 1722,
  [1723] = 1723,
  [1724] = 1724,
  [1725] = 234,
  [1726] = 219,
  [1727] = 1727,
  [1728] = 1728,
  [1729] = 1729,
  [1730] = 232,
  [1731] = 1731,
  [1732] = 1732,
  [1733] = 1733,
  [1734] = 227,
  [1735] = 1735,
  [1736] = 1212,
  [1737] = 1737,
  [1738] = 226,
  [1739] = 1739,
  [1740] = 225,
  [1741] = 1741,
  [1742] = 1213,
  [1743] = 1743,
  [1744] = 1744,
  [1745] = 1745,
  [1746] = 1746,
  [1747] = 931,
  [1748] = 1748,
  [1749] = 934,
  [1750] = 1750,
  [1751] = 944,
  [1752] = 948,
  [1753] = 950,
  [1754] = 936,
  [1755] = 1602,
  [1756] = 939,
  [1757] = 1757,
  [1758] = 1758,
  [1759] = 1759,
  [1760] = 1760,
  [1761] = 1761,
  [1762] = 1762,
  [1763] = 1763,
  [1764] = 1764,
  [1765] = 1765,
  [1766] = 1766,
  [1767] = 1767,
  [1768] = 678,
  [1769] = 1769,
  [1770] = 1770,
  [1771] = 1771,
  [1772] = 1772,
  [1773] = 1773,
  [1774] = 1774,
  [1775] = 1775,
  [1776] = 1776,
  [1777] = 1777,
  [1778] = 1778,
  [1779] = 1779,
  [1780] = 1780,
  [1781] = 1781,
  [1782] = 1748,
  [1783] = 1783,
  [1784] = 1784,
  [1785] = 1606,
  [1786] = 1748,
  [1787] = 1606,
  [1788] = 1602,
  [1789] = 1602,
  [1790] = 1606,
  [1791] = 1791,
  [1792] = 680,
  [1793] = 1793,
  [1794] = 1794,
  [1795] = 1795,
  [1796] = 1796,
  [1797] = 1797,
  [1798] = 1798,
  [1799] = 1799,
  [1800] = 1800,
  [1801] = 1801,
  [1802] = 1802,
  [1803] = 1803,
  [1804] = 1804,
  [1805] = 1748,
  [1806] = 1806,
  [1807] = 1807,
  [1808] = 1808,
  [1809] = 1809,
  [1810] = 1810,
  [1811] = 1811,
  [1812] = 1812,
  [1813] = 1813,
  [1814] = 1814,
  [1815] = 1815,
  [1816] = 1602,
  [1817] = 1606,
  [1818] = 1818,
  [1819] = 1819,
  [1820] = 1820,
  [1821] = 1821,
  [1822] = 1602,
  [1823] = 1823,
  [1824] = 1824,
  [1825] = 1606,
  [1826] = 1606,
  [1827] = 1602,
  [1828] = 248,
  [1829] = 1829,
  [1830] = 241,
  [1831] = 677,
  [1832] = 1832,
  [1833] = 1833,
  [1834] = 1834,
  [1835] = 1835,
  [1836] = 1836,
  [1837] = 1837,
  [1838] = 1838,
  [1839] = 1839,
  [1840] = 1840,
  [1841] = 1841,
  [1842] = 1842,
  [1843] = 1843,
  [1844] = 1844,
  [1845] = 1764,
  [1846] = 1846,
  [1847] = 1847,
  [1848] = 1848,
  [1849] = 1849,
  [1850] = 1850,
  [1851] = 1851,
  [1852] = 1852,
  [1853] = 1853,
  [1854] = 1854,
  [1855] = 1855,
  [1856] = 1856,
  [1857] = 1857,
  [1858] = 1858,
  [1859] = 1859,
  [1860] = 1860,
  [1861] = 1861,
  [1862] = 676,
  [1863] = 1863,
  [1864] = 1765,
  [1865] = 929,
  [1866] = 1866,
  [1867] = 227,
  [1868] = 226,
  [1869] = 225,
  [1870] = 1748,
  [1871] = 1871,
  [1872] = 1872,
  [1873] = 1873,
  [1874] = 1874,
  [1875] = 1875,
  [1876] = 1876,
  [1877] = 1877,
  [1878] = 1878,
  [1879] = 1879,
  [1880] = 1880,
  [1881] = 1881,
  [1882] = 1882,
  [1883] = 1883,
  [1884] = 1884,
  [1885] = 1885,
  [1886] = 1886,
  [1887] = 1887,
  [1888] = 1888,
  [1889] = 1889,
  [1890] = 1890,
  [1891] = 1891,
  [1892] = 1892,
  [1893] = 679,
  [1894] = 1894,
  [1895] = 1895,
  [1896] = 1896,
  [1897] = 1897,
  [1898] = 1898,
  [1899] = 1899,
  [1900] = 1900,
  [1901] = 1901,
  [1902] = 1902,
  [1903] = 1903,
  [1904] = 1904,
  [1905] = 1905,
  [1906] = 1906,
  [1907] = 1907,
  [1908] = 1908,
  [1909] = 1909,
  [1910] = 1910,
  [1911] = 1911,
  [1912] = 1912,
  [1913] = 249,
  [1914] = 1914,
  [1915] = 1915,
  [1916] = 236,
  [1917] = 1917,
  [1918] = 1918,
  [1919] = 1919,
  [1920] = 1920,
  [1921] = 1921,
  [1922] = 1922,
  [1923] = 1923,
  [1924] = 1924,
  [1925] = 1925,
  [1926] = 1926,
  [1927] = 1927,
  [1928] = 1602,
  [1929] = 1606,
  [1930] = 1930,
  [1931] = 935,
  [1932] = 937,
  [1933] = 940,
  [1934] = 1927,
  [1935] = 1935,
  [1936] = 1936,
  [1937] = 233,
  [1938] = 1938,
  [1939] = 1939,
  [1940] = 1926,
  [1941] = 1925,
  [1942] = 1923,
  [1943] = 242,
  [1944] = 1697,
  [1945] = 1684,
  [1946] = 1701,
  [1947] = 252,
  [1948] = 1948,
  [1949] = 1949,
  [1950] = 1924,
  [1951] = 1951,
  [1952] = 1923,
  [1953] = 1922,
  [1954] = 1954,
  [1955] = 1955,
  [1956] = 1956,
  [1957] = 248,
  [1958] = 241,
  [1959] = 1959,
  [1960] = 1960,
  [1961] = 1961,
  [1962] = 1912,
  [1963] = 1921,
  [1964] = 1964,
  [1965] = 1871,
  [1966] = 1966,
  [1967] = 1872,
  [1968] = 1968,
  [1969] = 1969,
  [1970] = 1911,
  [1971] = 1971,
  [1972] = 1972,
  [1973] = 1973,
  [1974] = 1920,
  [1975] = 1873,
  [1976] = 1976,
  [1977] = 1874,
  [1978] = 1978,
  [1979] = 1919,
  [1980] = 1980,
  [1981] = 1981,
  [1982] = 1915,
  [1983] = 240,
  [1984] = 1984,
  [1985] = 1912,
  [1986] = 1910,
  [1987] = 1909,
  [1988] = 1904,
  [1989] = 1911,
  [1990] = 1904,
  [1991] = 1909,
  [1992] = 1910,
  [1993] = 1993,
  [1994] = 1915,
  [1995] = 1919,
  [1996] = 229,
  [1997] = 1920,
  [1998] = 1921,
  [1999] = 1999,
  [2000] = 1922,
  [2001] = 1956,
  [2002] = 2002,
  [2003] = 2003,
  [2004] = 2004,
  [2005] = 2005,
  [2006] = 2006,
  [2007] = 2007,
  [2008] = 2008,
  [2009] = 1874,
  [2010] = 2010,
  [2011] = 2011,
  [2012] = 249,
  [2013] = 236,
  [2014] = 2014,
  [2015] = 2015,
  [2016] = 2016,
  [2017] = 2017,
  [2018] = 2018,
  [2019] = 1939,
  [2020] = 2020,
  [2021] = 1925,
  [2022] = 2022,
  [2023] = 2023,
  [2024] = 1926,
  [2025] = 2025,
  [2026] = 2026,
  [2027] = 1873,
  [2028] = 1872,
  [2029] = 1891,
  [2030] = 2030,
  [2031] = 2031,
  [2032] = 2032,
  [2033] = 1871,
  [2034] = 1891,
  [2035] = 1918,
  [2036] = 2036,
  [2037] = 240,
  [2038] = 1935,
  [2039] = 2039,
  [2040] = 2040,
  [2041] = 1959,
  [2042] = 1978,
  [2043] = 1961,
  [2044] = 1703,
  [2045] = 2045,
  [2046] = 252,
  [2047] = 2047,
  [2048] = 1866,
  [2049] = 1707,
  [2050] = 1927,
  [2051] = 2051,
  [2052] = 1878,
  [2053] = 2053,
  [2054] = 2054,
  [2055] = 1746,
  [2056] = 1917,
  [2057] = 2057,
  [2058] = 1902,
  [2059] = 1848,
  [2060] = 1843,
  [2061] = 2061,
  [2062] = 2062,
  [2063] = 1842,
  [2064] = 245,
  [2065] = 242,
  [2066] = 1917,
  [2067] = 2067,
  [2068] = 1924,
  [2069] = 1866,
  [2070] = 229,
  [2071] = 1878,
  [2072] = 2072,
  [2073] = 1902,
  [2074] = 1746,
  [2075] = 2075,
  [2076] = 1848,
  [2077] = 1843,
  [2078] = 2078,
  [2079] = 1791,
  [2080] = 2080,
  [2081] = 2081,
  [2082] = 233,
  [2083] = 1842,
  [2084] = 1791,
  [2085] = 245,
  [2086] = 1918,
  [2087] = 2087,
  [2088] = 2088,
  [2089] = 1215,
  [2090] = 2090,
  [2091] = 2091,
  [2092] = 2092,
  [2093] = 1803,
  [2094] = 2094,
  [2095] = 1918,
  [2096] = 1917,
  [2097] = 1801,
  [2098] = 2098,
  [2099] = 2099,
  [2100] = 1713,
  [2101] = 1902,
  [2102] = 2102,
  [2103] = 2103,
  [2104] = 2104,
  [2105] = 2105,
  [2106] = 1722,
  [2107] = 2107,
  [2108] = 2108,
  [2109] = 2109,
  [2110] = 1791,
  [2111] = 2111,
  [2112] = 2112,
  [2113] = 2113,
  [2114] = 1891,
  [2115] = 1911,
  [2116] = 1935,
  [2117] = 1912,
  [2118] = 1924,
  [2119] = 2119,
  [2120] = 2120,
  [2121] = 1744,
  [2122] = 2122,
  [2123] = 1743,
  [2124] = 1737,
  [2125] = 2125,
  [2126] = 1739,
  [2127] = 1927,
  [2128] = 2125,
  [2129] = 2129,
  [2130] = 1926,
  [2131] = 1925,
  [2132] = 2132,
  [2133] = 1923,
  [2134] = 1922,
  [2135] = 2119,
  [2136] = 2136,
  [2137] = 2136,
  [2138] = 2125,
  [2139] = 2139,
  [2140] = 2111,
  [2141] = 1814,
  [2142] = 2142,
  [2143] = 2143,
  [2144] = 2144,
  [2145] = 2145,
  [2146] = 2146,
  [2147] = 2147,
  [2148] = 2148,
  [2149] = 1921,
  [2150] = 2129,
  [2151] = 2151,
  [2152] = 2125,
  [2153] = 1920,
  [2154] = 1213,
  [2155] = 2155,
  [2156] = 2156,
  [2157] = 2157,
  [2158] = 1919,
  [2159] = 2159,
  [2160] = 2160,
  [2161] = 1915,
  [2162] = 2156,
  [2163] = 2163,
  [2164] = 1729,
  [2165] = 2165,
  [2166] = 1910,
  [2167] = 2147,
  [2168] = 2168,
  [2169] = 1842,
  [2170] = 1909,
  [2171] = 1904,
  [2172] = 1843,
  [2173] = 1848,
  [2174] = 1956,
  [2175] = 1981,
  [2176] = 1711,
  [2177] = 1710,
  [2178] = 1746,
  [2179] = 2179,
  [2180] = 2180,
  [2181] = 1878,
  [2182] = 2182,
  [2183] = 2183,
  [2184] = 2184,
  [2185] = 2185,
  [2186] = 1866,
  [2187] = 1871,
  [2188] = 1212,
  [2189] = 2189,
  [2190] = 2190,
  [2191] = 1872,
  [2192] = 2192,
  [2193] = 2193,
  [2194] = 2194,
  [2195] = 2195,
  [2196] = 2196,
  [2197] = 2197,
  [2198] = 2198,
  [2199] = 2136,
  [2200] = 2200,
  [2201] = 1981,
  [2202] = 1873,
  [2203] = 1801,
  [2204] = 2125,
  [2205] = 1803,
  [2206] = 2206,
  [2207] = 2207,
  [2208] = 2208,
  [2209] = 1874,
  [2210] = 2210,
  [2211] = 2211,
  [2212] = 2212,
  [2213] = 2213,
  [2214] = 2214,
  [2215] = 1939,
  [2216] = 2216,
  [2217] = 2125,
  [2218] = 2218,
  [2219] = 2219,
  [2220] = 2220,
  [2221] = 2221,
  [2222] = 2125,
  [2223] = 2223,
  [2224] = 2224,
  [2225] = 1727,
  [2226] = 2226,
  [2227] = 2227,
  [2228] = 2228,
  [2229] = 934,
  [2230] = 1795,
  [2231] = 1798,
  [2232] = 1794,
  [2233] = 2233,
  [2234] = 1883,
  [2235] = 1793,
  [2236] = 1924,
  [2237] = 1799,
  [2238] = 680,
  [2239] = 1801,
  [2240] = 219,
  [2241] = 1896,
  [2242] = 1842,
  [2243] = 2243,
  [2244] = 2216,
  [2245] = 2245,
  [2246] = 1939,
  [2247] = 1791,
  [2248] = 1803,
  [2249] = 1902,
  [2250] = 219,
  [2251] = 1917,
  [2252] = 1806,
  [2253] = 1807,
  [2254] = 2254,
  [2255] = 2233,
  [2256] = 1914,
  [2257] = 2002,
  [2258] = 1908,
  [2259] = 1918,
  [2260] = 2260,
  [2261] = 1907,
  [2262] = 1906,
  [2263] = 1905,
  [2264] = 1903,
  [2265] = 1758,
  [2266] = 1750,
  [2267] = 1896,
  [2268] = 1900,
  [2269] = 2051,
  [2270] = 1899,
  [2271] = 1898,
  [2272] = 1897,
  [2273] = 2273,
  [2274] = 950,
  [2275] = 948,
  [2276] = 1895,
  [2277] = 2081,
  [2278] = 1894,
  [2279] = 2279,
  [2280] = 1647,
  [2281] = 679,
  [2282] = 944,
  [2283] = 1750,
  [2284] = 1808,
  [2285] = 1757,
  [2286] = 1811,
  [2287] = 1796,
  [2288] = 1892,
  [2289] = 1890,
  [2290] = 1889,
  [2291] = 1888,
  [2292] = 1887,
  [2293] = 1886,
  [2294] = 2294,
  [2295] = 1803,
  [2296] = 1818,
  [2297] = 1801,
  [2298] = 1882,
  [2299] = 1881,
  [2300] = 1880,
  [2301] = 1876,
  [2302] = 2302,
  [2303] = 1875,
  [2304] = 2146,
  [2305] = 1863,
  [2306] = 2254,
  [2307] = 1759,
  [2308] = 1843,
  [2309] = 1763,
  [2310] = 1848,
  [2311] = 676,
  [2312] = 1956,
  [2313] = 1804,
  [2314] = 1878,
  [2315] = 1809,
  [2316] = 1649,
  [2317] = 1861,
  [2318] = 1860,
  [2319] = 1866,
  [2320] = 929,
  [2321] = 931,
  [2322] = 1812,
  [2323] = 1660,
  [2324] = 1760,
  [2325] = 1797,
  [2326] = 1927,
  [2327] = 1859,
  [2328] = 1858,
  [2329] = 1926,
  [2330] = 1857,
  [2331] = 1854,
  [2332] = 1935,
  [2333] = 1853,
  [2334] = 1925,
  [2335] = 1852,
  [2336] = 1851,
  [2337] = 2233,
  [2338] = 2338,
  [2339] = 1850,
  [2340] = 936,
  [2341] = 2254,
  [2342] = 1923,
  [2343] = 939,
  [2344] = 1849,
  [2345] = 2345,
  [2346] = 1847,
  [2347] = 1764,
  [2348] = 1765,
  [2349] = 1746,
  [2350] = 1846,
  [2351] = 1841,
  [2352] = 1840,
  [2353] = 1761,
  [2354] = 1750,
  [2355] = 1838,
  [2356] = 2356,
  [2357] = 2081,
  [2358] = 1801,
  [2359] = 2245,
  [2360] = 2216,
  [2361] = 1837,
  [2362] = 2051,
  [2363] = 1836,
  [2364] = 1758,
  [2365] = 1803,
  [2366] = 2366,
  [2367] = 2367,
  [2368] = 1885,
  [2369] = 1659,
  [2370] = 2370,
  [2371] = 2371,
  [2372] = 1835,
  [2373] = 678,
  [2374] = 1803,
  [2375] = 1801,
  [2376] = 1922,
  [2377] = 1921,
  [2378] = 1769,
  [2379] = 1834,
  [2380] = 1770,
  [2381] = 2381,
  [2382] = 1772,
  [2383] = 1773,
  [2384] = 1774,
  [2385] = 1775,
  [2386] = 1776,
  [2387] = 1777,
  [2388] = 1920,
  [2389] = 1778,
  [2390] = 1779,
  [2391] = 1833,
  [2392] = 1780,
  [2393] = 1781,
  [2394] = 1832,
  [2395] = 677,
  [2396] = 1783,
  [2397] = 1745,
  [2398] = 2398,
  [2399] = 2399,
  [2400] = 2400,
  [2401] = 1762,
  [2402] = 1919,
  [2403] = 1915,
  [2404] = 1910,
  [2405] = 1909,
  [2406] = 1904,
  [2407] = 1821,
  [2408] = 935,
  [2409] = 1874,
  [2410] = 1873,
  [2411] = 1872,
  [2412] = 1829,
  [2413] = 1871,
  [2414] = 1891,
  [2415] = 1820,
  [2416] = 937,
  [2417] = 940,
  [2418] = 2146,
  [2419] = 2002,
  [2420] = 1911,
  [2421] = 1912,
  [2422] = 1819,
  [2423] = 1842,
  [2424] = 1912,
  [2425] = 1674,
  [2426] = 1688,
  [2427] = 2045,
  [2428] = 2428,
  [2429] = 1791,
  [2430] = 2081,
  [2431] = 2216,
  [2432] = 2432,
  [2433] = 2057,
  [2434] = 1902,
  [2435] = 2022,
  [2436] = 2023,
  [2437] = 2025,
  [2438] = 2428,
  [2439] = 2081,
  [2440] = 1683,
  [2441] = 1923,
  [2442] = 1917,
  [2443] = 1688,
  [2444] = 1686,
  [2445] = 2051,
  [2446] = 1926,
  [2447] = 1925,
  [2448] = 1699,
  [2449] = 1915,
  [2450] = 1918,
  [2451] = 2146,
  [2452] = 2099,
  [2453] = 1923,
  [2454] = 1910,
  [2455] = 2455,
  [2456] = 1980,
  [2457] = 253,
  [2458] = 228,
  [2459] = 1922,
  [2460] = 1921,
  [2461] = 2018,
  [2462] = 2462,
  [2463] = 2054,
  [2464] = 1922,
  [2465] = 1921,
  [2466] = 1920,
  [2467] = 2051,
  [2468] = 1927,
  [2469] = 2469,
  [2470] = 2455,
  [2471] = 2471,
  [2472] = 1909,
  [2473] = 1904,
  [2474] = 2474,
  [2475] = 2475,
  [2476] = 1758,
  [2477] = 1924,
  [2478] = 2478,
  [2479] = 246,
  [2480] = 1976,
  [2481] = 1912,
  [2482] = 2428,
  [2483] = 1874,
  [2484] = 1920,
  [2485] = 2485,
  [2486] = 1915,
  [2487] = 1910,
  [2488] = 2036,
  [2489] = 2008,
  [2490] = 1956,
  [2491] = 1939,
  [2492] = 1695,
  [2493] = 1909,
  [2494] = 1935,
  [2495] = 255,
  [2496] = 250,
  [2497] = 238,
  [2498] = 239,
  [2499] = 244,
  [2500] = 1904,
  [2501] = 1911,
  [2502] = 2502,
  [2503] = 1675,
  [2504] = 2428,
  [2505] = 1843,
  [2506] = 1873,
  [2507] = 1686,
  [2508] = 2011,
  [2509] = 2016,
  [2510] = 231,
  [2511] = 1848,
  [2512] = 1960,
  [2513] = 1872,
  [2514] = 2053,
  [2515] = 2515,
  [2516] = 1871,
  [2517] = 2020,
  [2518] = 2518,
  [2519] = 2519,
  [2520] = 1866,
  [2521] = 2519,
  [2522] = 1679,
  [2523] = 2523,
  [2524] = 1671,
  [2525] = 1878,
  [2526] = 1746,
  [2527] = 1848,
  [2528] = 1843,
  [2529] = 1842,
  [2530] = 1891,
  [2531] = 1874,
  [2532] = 254,
  [2533] = 251,
  [2534] = 235,
  [2535] = 1973,
  [2536] = 243,
  [2537] = 235,
  [2538] = 251,
  [2539] = 254,
  [2540] = 243,
  [2541] = 2428,
  [2542] = 1891,
  [2543] = 2543,
  [2544] = 2428,
  [2545] = 2146,
  [2546] = 2062,
  [2547] = 1694,
  [2548] = 1896,
  [2549] = 1873,
  [2550] = 1911,
  [2551] = 1925,
  [2552] = 1912,
  [2553] = 1801,
  [2554] = 1746,
  [2555] = 1803,
  [2556] = 1972,
  [2557] = 244,
  [2558] = 1924,
  [2559] = 2067,
  [2560] = 239,
  [2561] = 1178,
  [2562] = 238,
  [2563] = 2563,
  [2564] = 250,
  [2565] = 1694,
  [2566] = 255,
  [2567] = 2061,
  [2568] = 1969,
  [2569] = 228,
  [2570] = 2428,
  [2571] = 1968,
  [2572] = 1691,
  [2573] = 2432,
  [2574] = 1904,
  [2575] = 1891,
  [2576] = 253,
  [2577] = 246,
  [2578] = 1878,
  [2579] = 2579,
  [2580] = 1866,
  [2581] = 1911,
  [2582] = 1695,
  [2583] = 1871,
  [2584] = 2088,
  [2585] = 1926,
  [2586] = 1685,
  [2587] = 2039,
  [2588] = 722,
  [2589] = 1919,
  [2590] = 2040,
  [2591] = 2087,
  [2592] = 1909,
  [2593] = 2047,
  [2594] = 1910,
  [2595] = 1924,
  [2596] = 1801,
  [2597] = 1803,
  [2598] = 1927,
  [2599] = 1691,
  [2600] = 1971,
  [2601] = 2017,
  [2602] = 1915,
  [2603] = 1918,
  [2604] = 1917,
  [2605] = 1902,
  [2606] = 2032,
  [2607] = 2078,
  [2608] = 2608,
  [2609] = 2002,
  [2610] = 1896,
  [2611] = 2031,
  [2612] = 2612,
  [2613] = 1918,
  [2614] = 1917,
  [2615] = 1842,
  [2616] = 2616,
  [2617] = 2428,
  [2618] = 1791,
  [2619] = 2345,
  [2620] = 2620,
  [2621] = 2621,
  [2622] = 2502,
  [2623] = 1843,
  [2624] = 1874,
  [2625] = 2099,
  [2626] = 1872,
  [2627] = 2075,
  [2628] = 1966,
  [2629] = 1936,
  [2630] = 1927,
  [2631] = 2563,
  [2632] = 2003,
  [2633] = 1926,
  [2634] = 1981,
  [2635] = 1964,
  [2636] = 1902,
  [2637] = 2030,
  [2638] = 2014,
  [2639] = 2010,
  [2640] = 1848,
  [2641] = 2072,
  [2642] = 2081,
  [2643] = 1925,
  [2644] = 1923,
  [2645] = 2005,
  [2646] = 1919,
  [2647] = 2428,
  [2648] = 2080,
  [2649] = 1955,
  [2650] = 1954,
  [2651] = 2651,
  [2652] = 2051,
  [2653] = 1922,
  [2654] = 231,
  [2655] = 1791,
  [2656] = 1951,
  [2657] = 1921,
  [2658] = 1674,
  [2659] = 2004,
  [2660] = 1873,
  [2661] = 1920,
  [2662] = 1948,
  [2663] = 1919,
  [2664] = 1702,
  [2665] = 2006,
  [2666] = 2007,
  [2667] = 1675,
  [2668] = 2668,
  [2669] = 1872,
  [2670] = 1746,
  [2671] = 2345,
  [2672] = 1878,
  [2673] = 1685,
  [2674] = 1866,
  [2675] = 1871,
  [2676] = 1922,
  [2677] = 2677,
  [2678] = 1921,
  [2679] = 2679,
  [2680] = 2680,
  [2681] = 1920,
  [2682] = 1919,
  [2683] = 1915,
  [2684] = 1912,
  [2685] = 2685,
  [2686] = 1910,
  [2687] = 1956,
  [2688] = 2688,
  [2689] = 1911,
  [2690] = 1909,
  [2691] = 2190,
  [2692] = 1923,
  [2693] = 1939,
  [2694] = 1105,
  [2695] = 1935,
  [2696] = 1927,
  [2697] = 1891,
  [2698] = 2698,
  [2699] = 2699,
  [2700] = 2698,
  [2701] = 1896,
  [2702] = 2146,
  [2703] = 1873,
  [2704] = 1803,
  [2705] = 2002,
  [2706] = 2146,
  [2707] = 1801,
  [2708] = 1935,
  [2709] = 1872,
  [2710] = 1871,
  [2711] = 2711,
  [2712] = 2712,
  [2713] = 1842,
  [2714] = 1925,
  [2715] = 1874,
  [2716] = 2002,
  [2717] = 2717,
  [2718] = 2717,
  [2719] = 1918,
  [2720] = 1917,
  [2721] = 1902,
  [2722] = 2051,
  [2723] = 2146,
  [2724] = 2099,
  [2725] = 1924,
  [2726] = 2726,
  [2727] = 1750,
  [2728] = 1791,
  [2729] = 2081,
  [2730] = 1904,
  [2731] = 2731,
  [2732] = 2688,
  [2733] = 2699,
  [2734] = 2146,
  [2735] = 2711,
  [2736] = 2736,
  [2737] = 2717,
  [2738] = 2698,
  [2739] = 2680,
  [2740] = 1926,
  [2741] = 2741,
  [2742] = 2742,
  [2743] = 2699,
  [2744] = 2744,
  [2745] = 1758,
  [2746] = 2711,
  [2747] = 1843,
  [2748] = 1848,
  [2749] = 1746,
  [2750] = 1878,
  [2751] = 1205,
  [2752] = 1866,
  [2753] = 2688,
  [2754] = 2345,
  [2755] = 2755,
  [2756] = 2756,
  [2757] = 2119,
  [2758] = 2758,
  [2759] = 2081,
  [2760] = 2760,
  [2761] = 2761,
  [2762] = 2762,
  [2763] = 2763,
  [2764] = 2764,
  [2765] = 2765,
  [2766] = 1750,
  [2767] = 2051,
  [2768] = 1896,
  [2769] = 2769,
  [2770] = 2002,
  [2771] = 2771,
  [2772] = 2772,
  [2773] = 2773,
  [2774] = 2774,
  [2775] = 2775,
  [2776] = 1693,
  [2777] = 2777,
  [2778] = 2146,
  [2779] = 2779,
  [2780] = 2780,
  [2781] = 226,
  [2782] = 225,
  [2783] = 249,
  [2784] = 236,
  [2785] = 2002,
  [2786] = 2786,
  [2787] = 2787,
  [2788] = 2788,
  [2789] = 2789,
  [2790] = 2790,
  [2791] = 2791,
  [2792] = 2792,
  [2793] = 749,
  [2794] = 2099,
  [2795] = 2795,
  [2796] = 2796,
  [2797] = 2515,
  [2798] = 1939,
  [2799] = 768,
  [2800] = 2800,
  [2801] = 782,
  [2802] = 2802,
  [2803] = 2803,
  [2804] = 2804,
  [2805] = 2805,
  [2806] = 2806,
  [2807] = 2807,
  [2808] = 2808,
  [2809] = 2809,
  [2810] = 2810,
  [2811] = 2811,
  [2812] = 1727,
  [2813] = 1956,
  [2814] = 2814,
  [2815] = 2804,
  [2816] = 2816,
  [2817] = 2817,
  [2818] = 2818,
  [2819] = 2819,
  [2820] = 2820,
  [2821] = 2821,
  [2822] = 2822,
  [2823] = 2823,
  [2824] = 2824,
  [2825] = 776,
  [2826] = 770,
  [2827] = 2345,
  [2828] = 2828,
  [2829] = 1896,
  [2830] = 2830,
  [2831] = 2807,
  [2832] = 2832,
  [2833] = 784,
  [2834] = 785,
  [2835] = 227,
  [2836] = 2836,
  [2837] = 774,
  [2838] = 2838,
  [2839] = 2839,
  [2840] = 2840,
  [2841] = 763,
  [2842] = 1212,
  [2843] = 2843,
  [2844] = 1208,
  [2845] = 1215,
  [2846] = 2846,
  [2847] = 2847,
  [2848] = 767,
  [2849] = 2849,
  [2850] = 1202,
  [2851] = 2839,
  [2852] = 2852,
  [2853] = 1213,
  [2854] = 759,
  [2855] = 1896,
  [2856] = 1207,
  [2857] = 2832,
  [2858] = 2858,
  [2859] = 2828,
  [2860] = 1935,
  [2861] = 2861,
  [2862] = 2862,
  [2863] = 2858,
  [2864] = 2864,
  [2865] = 2865,
  [2866] = 2866,
  [2867] = 2830,
  [2868] = 2861,
  [2869] = 2824,
  [2870] = 2847,
  [2871] = 2840,
  [2872] = 2872,
  [2873] = 2873,
  [2874] = 2874,
  [2875] = 1896,
  [2876] = 2876,
  [2877] = 2877,
  [2878] = 2878,
  [2879] = 2852,
  [2880] = 2880,
  [2881] = 2881,
  [2882] = 2882,
  [2883] = 781,
  [2884] = 780,
  [2885] = 783,
  [2886] = 2882,
  [2887] = 2882,
  [2888] = 761,
  [2889] = 2882,
  [2890] = 803,
  [2891] = 802,
  [2892] = 778,
  [2893] = 790,
  [2894] = 245,
  [2895] = 2882,
  [2896] = 2882,
  [2897] = 858,
  [2898] = 234,
  [2899] = 771,
  [2900] = 2882,
  [2901] = 2882,
  [2902] = 809,
  [2903] = 232,
  [2904] = 816,
  [2905] = 786,
  [2906] = 252,
  [2907] = 817,
  [2908] = 765,
  [2909] = 814,
  [2910] = 799,
  [2911] = 808,
  [2912] = 811,
  [2913] = 844,
  [2914] = 793,
  [2915] = 2882,
  [2916] = 766,
  [2917] = 787,
  [2918] = 772,
  [2919] = 762,
  [2920] = 788,
  [2921] = 870,
  [2922] = 860,
  [2923] = 838,
  [2924] = 836,
  [2925] = 875,
  [2926] = 877,
  [2927] = 882,
  [2928] = 822,
  [2929] = 828,
  [2930] = 848,
  [2931] = 835,
  [2932] = 832,
  [2933] = 830,
  [2934] = 821,
  [2935] = 815,
  [2936] = 813,
  [2937] = 798,
  [2938] = 839,
  [2939] = 805,
  [2940] = 804,
  [2941] = 229,
  [2942] = 795,
  [2943] = 862,
  [2944] = 794,
  [2945] = 240,
  [2946] = 792,
  [2947] = 866,
  [2948] = 827,
  [2949] = 829,
  [2950] = 678,
  [2951] = 868,
  [2952] = 878,
  [2953] = 879,
  [2954] = 880,
  [2955] = 884,
  [2956] = 796,
  [2957] = 887,
  [2958] = 680,
  [2959] = 677,
  [2960] = 888,
  [2961] = 676,
  [2962] = 679,
  [2963] = 893,
  [2964] = 894,
  [2965] = 895,
  [2966] = 2966,
  [2967] = 896,
  [2968] = 898,
  [2969] = 847,
  [2970] = 820,
  [2971] = 845,
  [2972] = 850,
  [2973] = 849,
  [2974] = 846,
  [2975] = 852,
  [2976] = 841,
  [2977] = 902,
  [2978] = 869,
  [2979] = 900,
  [2980] = 881,
  [2981] = 872,
  [2982] = 897,
  [2983] = 891,
  [2984] = 876,
  [2985] = 874,
  [2986] = 873,
  [2987] = 252,
  [2988] = 861,
  [2989] = 791,
  [2990] = 859,
  [2991] = 843,
  [2992] = 837,
  [2993] = 856,
  [2994] = 789,
  [2995] = 840,
  [2996] = 818,
  [2997] = 819,
  [2998] = 834,
  [2999] = 842,
  [3000] = 854,
  [3001] = 855,
  [3002] = 823,
  [3003] = 824,
  [3004] = 825,
  [3005] = 826,
  [3006] = 857,
  [3007] = 863,
  [3008] = 245,
  [3009] = 864,
  [3010] = 865,
  [3011] = 867,
  [3012] = 883,
  [3013] = 886,
  [3014] = 885,
  [3015] = 871,
  [3016] = 800,
  [3017] = 797,
  [3018] = 806,
  [3019] = 833,
  [3020] = 831,
  [3021] = 851,
  [3022] = 853,
  [3023] = 890,
  [3024] = 892,
  [3025] = 904,
  [3026] = 903,
  [3027] = 899,
  [3028] = 3028,
  [3029] = 3029,
  [3030] = 3030,
  [3031] = 3031,
  [3032] = 3032,
  [3033] = 3033,
  [3034] = 3034,
  [3035] = 3035,
  [3036] = 3036,
  [3037] = 3037,
  [3038] = 3038,
  [3039] = 3039,
  [3040] = 3040,
  [3041] = 3041,
  [3042] = 3042,
  [3043] = 3043,
  [3044] = 3044,
  [3045] = 3045,
  [3046] = 3046,
  [3047] = 3047,
  [3048] = 3048,
  [3049] = 3049,
  [3050] = 3050,
  [3051] = 3051,
  [3052] = 3052,
  [3053] = 3053,
  [3054] = 3054,
  [3055] = 3055,
  [3056] = 3056,
  [3057] = 3057,
  [3058] = 3058,
  [3059] = 3059,
  [3060] = 3060,
  [3061] = 3061,
  [3062] = 3062,
  [3063] = 3063,
  [3064] = 3064,
  [3065] = 3065,
  [3066] = 3066,
  [3067] = 3067,
  [3068] = 3068,
  [3069] = 3069,
  [3070] = 3070,
  [3071] = 3071,
  [3072] = 3072,
  [3073] = 3073,
  [3074] = 3074,
  [3075] = 3075,
  [3076] = 3076,
  [3077] = 3077,
  [3078] = 3078,
  [3079] = 3079,
  [3080] = 3080,
  [3081] = 3081,
  [3082] = 3082,
  [3083] = 3083,
  [3084] = 3084,
  [3085] = 3085,
  [3086] = 3086,
  [3087] = 3087,
  [3088] = 3088,
  [3089] = 3089,
  [3090] = 3088,
  [3091] = 3089,
  [3092] = 3089,
  [3093] = 3088,
  [3094] = 3088,
  [3095] = 3089,
  [3096] = 3096,
  [3097] = 3097,
  [3098] = 3098,
  [3099] = 3099,
  [3100] = 3100,
  [3101] = 3101,
  [3102] = 3102,
  [3103] = 3103,
  [3104] = 3104,
  [3105] = 3105,
  [3106] = 3106,
  [3107] = 3107,
  [3108] = 3108,
  [3109] = 3109,
  [3110] = 3110,
  [3111] = 3111,
  [3112] = 3112,
  [3113] = 3113,
  [3114] = 3114,
  [3115] = 3115,
  [3116] = 3116,
  [3117] = 3117,
  [3118] = 3118,
  [3119] = 3119,
  [3120] = 3120,
  [3121] = 3121,
  [3122] = 1215,
  [3123] = 1212,
  [3124] = 1213,
  [3125] = 1701,
  [3126] = 1684,
  [3127] = 232,
  [3128] = 234,
  [3129] = 1697,
  [3130] = 1905,
  [3131] = 1847,
  [3132] = 1837,
  [3133] = 1880,
  [3134] = 1838,
  [3135] = 1840,
  [3136] = 1881,
  [3137] = 1841,
  [3138] = 1882,
  [3139] = 1833,
  [3140] = 1834,
  [3141] = 1846,
  [3142] = 1835,
  [3143] = 1883,
  [3144] = 1886,
  [3145] = 1887,
  [3146] = 1888,
  [3147] = 1875,
  [3148] = 1863,
  [3149] = 1897,
  [3150] = 1849,
  [3151] = 1894,
  [3152] = 1850,
  [3153] = 1895,
  [3154] = 1851,
  [3155] = 1876,
  [3156] = 1907,
  [3157] = 1906,
  [3158] = 232,
  [3159] = 1903,
  [3160] = 1900,
  [3161] = 1899,
  [3162] = 1898,
  [3163] = 1832,
  [3164] = 1836,
  [3165] = 234,
  [3166] = 3166,
  [3167] = 1707,
  [3168] = 3166,
  [3169] = 1684,
  [3170] = 1798,
  [3171] = 1697,
  [3172] = 1739,
  [3173] = 1795,
  [3174] = 1793,
  [3175] = 1701,
  [3176] = 1769,
  [3177] = 1722,
  [3178] = 1744,
  [3179] = 1729,
  [3180] = 1711,
  [3181] = 1880,
  [3182] = 3182,
  [3183] = 3183,
  [3184] = 3184,
  [3185] = 3185,
  [3186] = 1770,
  [3187] = 3184,
  [3188] = 3182,
  [3189] = 3182,
  [3190] = 1763,
  [3191] = 1697,
  [3192] = 1907,
  [3193] = 1906,
  [3194] = 1905,
  [3195] = 1684,
  [3196] = 1701,
  [3197] = 1903,
  [3198] = 1707,
  [3199] = 1900,
  [3200] = 1899,
  [3201] = 1898,
  [3202] = 1897,
  [3203] = 1895,
  [3204] = 1892,
  [3205] = 1890,
  [3206] = 1894,
  [3207] = 1889,
  [3208] = 1710,
  [3209] = 1858,
  [3210] = 1857,
  [3211] = 1908,
  [3212] = 1761,
  [3213] = 1772,
  [3214] = 3214,
  [3215] = 1745,
  [3216] = 3185,
  [3217] = 1888,
  [3218] = 1887,
  [3219] = 1886,
  [3220] = 1883,
  [3221] = 1882,
  [3222] = 1881,
  [3223] = 3182,
  [3224] = 1876,
  [3225] = 1875,
  [3226] = 3183,
  [3227] = 1863,
  [3228] = 1762,
  [3229] = 1853,
  [3230] = 1773,
  [3231] = 3183,
  [3232] = 1852,
  [3233] = 1760,
  [3234] = 1759,
  [3235] = 1775,
  [3236] = 1776,
  [3237] = 3182,
  [3238] = 1757,
  [3239] = 3214,
  [3240] = 1777,
  [3241] = 3184,
  [3242] = 3182,
  [3243] = 3184,
  [3244] = 3184,
  [3245] = 3182,
  [3246] = 3182,
  [3247] = 3185,
  [3248] = 1851,
  [3249] = 1850,
  [3250] = 1849,
  [3251] = 1847,
  [3252] = 1846,
  [3253] = 1841,
  [3254] = 1840,
  [3255] = 1838,
  [3256] = 1837,
  [3257] = 1836,
  [3258] = 1835,
  [3259] = 1834,
  [3260] = 1833,
  [3261] = 1779,
  [3262] = 1832,
  [3263] = 1794,
  [3264] = 3183,
  [3265] = 3183,
  [3266] = 3185,
  [3267] = 3214,
  [3268] = 3214,
  [3269] = 1797,
  [3270] = 1799,
  [3271] = 3182,
  [3272] = 3185,
  [3273] = 1806,
  [3274] = 1807,
  [3275] = 3214,
  [3276] = 1808,
  [3277] = 1829,
  [3278] = 1811,
  [3279] = 1818,
  [3280] = 1820,
  [3281] = 1781,
  [3282] = 1713,
  [3283] = 1783,
  [3284] = 1739,
  [3285] = 3285,
  [3286] = 3285,
  [3287] = 1774,
  [3288] = 3288,
  [3289] = 3289,
  [3290] = 3290,
  [3291] = 3289,
  [3292] = 3289,
  [3293] = 1819,
  [3294] = 1778,
  [3295] = 3295,
  [3296] = 1812,
  [3297] = 3297,
  [3298] = 3298,
  [3299] = 3299,
  [3300] = 3300,
  [3301] = 3301,
  [3302] = 3302,
  [3303] = 3303,
  [3304] = 3304,
  [3305] = 1914,
  [3306] = 3306,
  [3307] = 3307,
  [3308] = 3308,
  [3309] = 3285,
  [3310] = 3289,
  [3311] = 3311,
  [3312] = 1780,
  [3313] = 3313,
  [3314] = 3314,
  [3315] = 3315,
  [3316] = 3316,
  [3317] = 3317,
  [3318] = 3285,
  [3319] = 3289,
  [3320] = 3320,
  [3321] = 1854,
  [3322] = 3289,
  [3323] = 1861,
  [3324] = 3324,
  [3325] = 3299,
  [3326] = 3285,
  [3327] = 3285,
  [3328] = 3328,
  [3329] = 3329,
  [3330] = 3330,
  [3331] = 1859,
  [3332] = 1860,
  [3333] = 1903,
  [3334] = 1899,
  [3335] = 1769,
  [3336] = 1837,
  [3337] = 1838,
  [3338] = 929,
  [3339] = 1215,
  [3340] = 1847,
  [3341] = 1882,
  [3342] = 3342,
  [3343] = 944,
  [3344] = 937,
  [3345] = 3345,
  [3346] = 1836,
  [3347] = 3347,
  [3348] = 1835,
  [3349] = 940,
  [3350] = 950,
  [3351] = 1834,
  [3352] = 3352,
  [3353] = 1907,
  [3354] = 1880,
  [3355] = 948,
  [3356] = 1212,
  [3357] = 1906,
  [3358] = 3302,
  [3359] = 3359,
  [3360] = 3360,
  [3361] = 1905,
  [3362] = 1793,
  [3363] = 1900,
  [3364] = 935,
  [3365] = 1840,
  [3366] = 1744,
  [3367] = 1764,
  [3368] = 1765,
  [3369] = 3369,
  [3370] = 1898,
  [3371] = 3371,
  [3372] = 1897,
  [3373] = 1841,
  [3374] = 1895,
  [3375] = 1894,
  [3376] = 1876,
  [3377] = 1833,
  [3378] = 3378,
  [3379] = 1888,
  [3380] = 931,
  [3381] = 934,
  [3382] = 1846,
  [3383] = 1832,
  [3384] = 936,
  [3385] = 1849,
  [3386] = 1213,
  [3387] = 939,
  [3388] = 1875,
  [3389] = 1850,
  [3390] = 1881,
  [3391] = 1887,
  [3392] = 1886,
  [3393] = 1795,
  [3394] = 1851,
  [3395] = 1883,
  [3396] = 3396,
  [3397] = 1707,
  [3398] = 1863,
  [3399] = 3399,
  [3400] = 1798,
  [3401] = 3401,
  [3402] = 3402,
  [3403] = 3403,
  [3404] = 1713,
  [3405] = 3405,
  [3406] = 3406,
  [3407] = 3407,
  [3408] = 3408,
  [3409] = 3409,
  [3410] = 3410,
  [3411] = 3411,
  [3412] = 3412,
  [3413] = 3413,
  [3414] = 3414,
  [3415] = 3403,
  [3416] = 3416,
  [3417] = 1722,
  [3418] = 3418,
  [3419] = 3419,
  [3420] = 3420,
  [3421] = 3421,
  [3422] = 3422,
  [3423] = 3403,
  [3424] = 3424,
  [3425] = 1729,
  [3426] = 1710,
  [3427] = 3427,
  [3428] = 1711,
  [3429] = 3429,
  [3430] = 3430,
  [3431] = 3403,
  [3432] = 1739,
  [3433] = 1697,
  [3434] = 3434,
  [3435] = 3435,
  [3436] = 3436,
  [3437] = 3437,
  [3438] = 3438,
  [3439] = 3439,
  [3440] = 3440,
  [3441] = 3441,
  [3442] = 3403,
  [3443] = 3443,
  [3444] = 3444,
  [3445] = 3445,
  [3446] = 3446,
  [3447] = 1701,
  [3448] = 1684,
  [3449] = 3403,
  [3450] = 3450,
  [3451] = 3418,
  [3452] = 3452,
  [3453] = 1811,
  [3454] = 1808,
  [3455] = 1812,
  [3456] = 677,
  [3457] = 1892,
  [3458] = 1212,
  [3459] = 1890,
  [3460] = 1215,
  [3461] = 1889,
  [3462] = 1213,
  [3463] = 1807,
  [3464] = 1806,
  [3465] = 1763,
  [3466] = 1745,
  [3467] = 1762,
  [3468] = 1761,
  [3469] = 1793,
  [3470] = 678,
  [3471] = 679,
  [3472] = 1760,
  [3473] = 1795,
  [3474] = 1770,
  [3475] = 1744,
  [3476] = 1852,
  [3477] = 1853,
  [3478] = 1764,
  [3479] = 1765,
  [3480] = 676,
  [3481] = 680,
  [3482] = 3482,
  [3483] = 1908,
  [3484] = 1759,
  [3485] = 1854,
  [3486] = 1757,
  [3487] = 1818,
  [3488] = 1819,
  [3489] = 1769,
  [3490] = 1857,
  [3491] = 1765,
  [3492] = 1764,
  [3493] = 1820,
  [3494] = 1772,
  [3495] = 1773,
  [3496] = 1858,
  [3497] = 1914,
  [3498] = 1774,
  [3499] = 1775,
  [3500] = 1776,
  [3501] = 3501,
  [3502] = 1777,
  [3503] = 1859,
  [3504] = 1778,
  [3505] = 3505,
  [3506] = 1779,
  [3507] = 1780,
  [3508] = 1860,
  [3509] = 3509,
  [3510] = 1781,
  [3511] = 1794,
  [3512] = 1783,
  [3513] = 1861,
  [3514] = 3514,
  [3515] = 1798,
  [3516] = 1797,
  [3517] = 1829,
  [3518] = 1799,
  [3519] = 1711,
  [3520] = 3520,
  [3521] = 3521,
  [3522] = 1707,
  [3523] = 3523,
  [3524] = 1729,
  [3525] = 3521,
  [3526] = 3302,
  [3527] = 3523,
  [3528] = 3528,
  [3529] = 3529,
  [3530] = 3530,
  [3531] = 3531,
  [3532] = 3532,
  [3533] = 3533,
  [3534] = 3523,
  [3535] = 3521,
  [3536] = 3536,
  [3537] = 3537,
  [3538] = 1710,
  [3539] = 3539,
  [3540] = 3540,
  [3541] = 3541,
  [3542] = 3521,
  [3543] = 3523,
  [3544] = 3544,
  [3545] = 1713,
  [3546] = 3546,
  [3547] = 3547,
  [3548] = 3528,
  [3549] = 1722,
  [3550] = 3530,
  [3551] = 1892,
  [3552] = 3552,
  [3553] = 1770,
  [3554] = 1772,
  [3555] = 1773,
  [3556] = 3556,
  [3557] = 1774,
  [3558] = 1775,
  [3559] = 1776,
  [3560] = 1777,
  [3561] = 1778,
  [3562] = 1779,
  [3563] = 3403,
  [3564] = 3564,
  [3565] = 3565,
  [3566] = 3566,
  [3567] = 3567,
  [3568] = 3568,
  [3569] = 3569,
  [3570] = 1780,
  [3571] = 3540,
  [3572] = 1781,
  [3573] = 3573,
  [3574] = 3574,
  [3575] = 3575,
  [3576] = 3576,
  [3577] = 1783,
  [3578] = 3578,
  [3579] = 935,
  [3580] = 3580,
  [3581] = 937,
  [3582] = 3582,
  [3583] = 3537,
  [3584] = 940,
  [3585] = 3546,
  [3586] = 3586,
  [3587] = 3587,
  [3588] = 3588,
  [3589] = 3520,
  [3590] = 3590,
  [3591] = 680,
  [3592] = 1794,
  [3593] = 1797,
  [3594] = 3594,
  [3595] = 1799,
  [3596] = 3596,
  [3597] = 1806,
  [3598] = 1807,
  [3599] = 3599,
  [3600] = 1808,
  [3601] = 1811,
  [3602] = 3602,
  [3603] = 1812,
  [3604] = 939,
  [3605] = 936,
  [3606] = 934,
  [3607] = 3578,
  [3608] = 3608,
  [3609] = 931,
  [3610] = 929,
  [3611] = 1818,
  [3612] = 1819,
  [3613] = 3580,
  [3614] = 1820,
  [3615] = 3615,
  [3616] = 1829,
  [3617] = 1757,
  [3618] = 677,
  [3619] = 3619,
  [3620] = 1852,
  [3621] = 3621,
  [3622] = 1853,
  [3623] = 3403,
  [3624] = 1854,
  [3625] = 3403,
  [3626] = 3626,
  [3627] = 944,
  [3628] = 948,
  [3629] = 950,
  [3630] = 1857,
  [3631] = 3621,
  [3632] = 1858,
  [3633] = 3403,
  [3634] = 1859,
  [3635] = 1860,
  [3636] = 1861,
  [3637] = 676,
  [3638] = 3638,
  [3639] = 3639,
  [3640] = 3615,
  [3641] = 3615,
  [3642] = 3602,
  [3643] = 3643,
  [3644] = 3644,
  [3645] = 3645,
  [3646] = 1889,
  [3647] = 1890,
  [3648] = 3648,
  [3649] = 679,
  [3650] = 1759,
  [3651] = 3596,
  [3652] = 3652,
  [3653] = 1908,
  [3654] = 3578,
  [3655] = 3655,
  [3656] = 1914,
  [3657] = 3578,
  [3658] = 3658,
  [3659] = 3659,
  [3660] = 3660,
  [3661] = 935,
  [3662] = 937,
  [3663] = 3663,
  [3664] = 3664,
  [3665] = 3655,
  [3666] = 936,
  [3667] = 3580,
  [3668] = 3580,
  [3669] = 3648,
  [3670] = 934,
  [3671] = 3403,
  [3672] = 3596,
  [3673] = 3673,
  [3674] = 931,
  [3675] = 3615,
  [3676] = 3676,
  [3677] = 929,
  [3678] = 3678,
  [3679] = 3648,
  [3680] = 944,
  [3681] = 948,
  [3682] = 950,
  [3683] = 234,
  [3684] = 3684,
  [3685] = 232,
  [3686] = 3686,
  [3687] = 3621,
  [3688] = 3578,
  [3689] = 3403,
  [3690] = 3690,
  [3691] = 3569,
  [3692] = 3568,
  [3693] = 3567,
  [3694] = 3566,
  [3695] = 3565,
  [3696] = 3564,
  [3697] = 3578,
  [3698] = 3698,
  [3699] = 3699,
  [3700] = 678,
  [3701] = 1760,
  [3702] = 3660,
  [3703] = 3703,
  [3704] = 1763,
  [3705] = 3705,
  [3706] = 1745,
  [3707] = 3707,
  [3708] = 3708,
  [3709] = 1762,
  [3710] = 3590,
  [3711] = 3655,
  [3712] = 940,
  [3713] = 3713,
  [3714] = 3714,
  [3715] = 3715,
  [3716] = 1739,
  [3717] = 3717,
  [3718] = 3718,
  [3719] = 3719,
  [3720] = 3720,
  [3721] = 3721,
  [3722] = 3722,
  [3723] = 3608,
  [3724] = 3724,
  [3725] = 3660,
  [3726] = 3726,
  [3727] = 3727,
  [3728] = 3728,
  [3729] = 939,
  [3730] = 3730,
  [3731] = 3731,
  [3732] = 3732,
  [3733] = 3733,
  [3734] = 3734,
  [3735] = 1761,
  [3736] = 3736,
  [3737] = 3737,
  [3738] = 3403,
  [3739] = 3615,
  [3740] = 3621,
  [3741] = 3741,
  [3742] = 3742,
  [3743] = 3743,
  [3744] = 3744,
  [3745] = 3745,
  [3746] = 3746,
  [3747] = 1744,
  [3748] = 3748,
  [3749] = 3749,
  [3750] = 3744,
  [3751] = 3751,
  [3752] = 3752,
  [3753] = 3753,
  [3754] = 3754,
  [3755] = 3755,
  [3756] = 3756,
  [3757] = 3757,
  [3758] = 3744,
  [3759] = 226,
  [3760] = 3742,
  [3761] = 3744,
  [3762] = 3744,
  [3763] = 3763,
  [3764] = 3744,
  [3765] = 3765,
  [3766] = 3766,
  [3767] = 3767,
  [3768] = 3744,
  [3769] = 225,
  [3770] = 3744,
  [3771] = 3742,
  [3772] = 3537,
  [3773] = 3546,
  [3774] = 3766,
  [3775] = 3775,
  [3776] = 3767,
  [3777] = 3777,
  [3778] = 3778,
  [3779] = 3779,
  [3780] = 3780,
  [3781] = 3781,
  [3782] = 3782,
  [3783] = 3783,
  [3784] = 3779,
  [3785] = 3785,
  [3786] = 3786,
  [3787] = 3787,
  [3788] = 3788,
  [3789] = 3789,
  [3790] = 3790,
  [3791] = 3791,
  [3792] = 3792,
  [3793] = 3793,
  [3794] = 1713,
  [3795] = 3795,
  [3796] = 3780,
  [3797] = 3797,
  [3798] = 3798,
  [3799] = 3799,
  [3800] = 3800,
  [3801] = 1711,
  [3802] = 3802,
  [3803] = 1710,
  [3804] = 3804,
  [3805] = 3805,
  [3806] = 3806,
  [3807] = 3807,
  [3808] = 3808,
  [3809] = 3809,
  [3810] = 3810,
  [3811] = 3811,
  [3812] = 3812,
  [3813] = 3813,
  [3814] = 3814,
  [3815] = 3812,
  [3816] = 3816,
  [3817] = 3817,
  [3818] = 3818,
  [3819] = 3819,
  [3820] = 3820,
  [3821] = 3821,
  [3822] = 3790,
  [3823] = 3823,
  [3824] = 3824,
  [3825] = 3804,
  [3826] = 3826,
  [3827] = 3564,
  [3828] = 3565,
  [3829] = 3829,
  [3830] = 3830,
  [3831] = 3813,
  [3832] = 3566,
  [3833] = 3833,
  [3834] = 3834,
  [3835] = 3567,
  [3836] = 3836,
  [3837] = 3837,
  [3838] = 3838,
  [3839] = 3839,
  [3840] = 3840,
  [3841] = 3841,
  [3842] = 3568,
  [3843] = 3569,
  [3844] = 3844,
  [3845] = 3845,
  [3846] = 3846,
  [3847] = 3847,
  [3848] = 3848,
  [3849] = 3849,
  [3850] = 3850,
  [3851] = 3851,
  [3852] = 3852,
  [3853] = 3853,
  [3854] = 3799,
  [3855] = 3855,
  [3856] = 3798,
  [3857] = 3857,
  [3858] = 3780,
  [3859] = 249,
  [3860] = 236,
  [3861] = 3861,
  [3862] = 3862,
  [3863] = 3863,
  [3864] = 227,
  [3865] = 3795,
  [3866] = 3804,
  [3867] = 3867,
  [3868] = 3806,
  [3869] = 3805,
  [3870] = 3870,
  [3871] = 3871,
  [3872] = 3872,
  [3873] = 3873,
  [3874] = 3874,
  [3875] = 3778,
  [3876] = 3876,
  [3877] = 3877,
  [3878] = 3878,
  [3879] = 3879,
  [3880] = 3880,
  [3881] = 3778,
  [3882] = 3882,
  [3883] = 3883,
  [3884] = 3812,
  [3885] = 3885,
  [3886] = 3886,
  [3887] = 3887,
  [3888] = 3888,
  [3889] = 3889,
  [3890] = 3890,
  [3891] = 3891,
  [3892] = 3892,
  [3893] = 3893,
  [3894] = 3894,
  [3895] = 3895,
  [3896] = 3798,
  [3897] = 3799,
  [3898] = 3898,
  [3899] = 3899,
  [3900] = 3900,
  [3901] = 3901,
  [3902] = 3902,
  [3903] = 3813,
  [3904] = 3904,
  [3905] = 3905,
  [3906] = 3573,
  [3907] = 3574,
  [3908] = 3482,
  [3909] = 3909,
  [3910] = 3910,
  [3911] = 3575,
  [3912] = 3912,
  [3913] = 3913,
  [3914] = 3783,
  [3915] = 3915,
  [3916] = 3802,
  [3917] = 3917,
  [3918] = 3805,
  [3919] = 3806,
  [3920] = 3905,
  [3921] = 3541,
  [3922] = 3779,
  [3923] = 3923,
  [3924] = 3804,
  [3925] = 3586,
  [3926] = 3587,
  [3927] = 3806,
  [3928] = 3928,
  [3929] = 3929,
  [3930] = 3930,
  [3931] = 3931,
  [3932] = 3932,
  [3933] = 3933,
  [3934] = 3817,
  [3935] = 1178,
  [3936] = 3778,
  [3937] = 3937,
  [3938] = 3804,
  [3939] = 3807,
  [3940] = 3833,
  [3941] = 3941,
  [3942] = 3942,
  [3943] = 3943,
  [3944] = 3944,
  [3945] = 3799,
  [3946] = 3898,
  [3947] = 3898,
  [3948] = 3948,
  [3949] = 3949,
  [3950] = 3950,
  [3951] = 3818,
  [3952] = 3952,
  [3953] = 3953,
  [3954] = 3954,
  [3955] = 3505,
  [3956] = 3956,
  [3957] = 3957,
  [3958] = 3958,
  [3959] = 3959,
  [3960] = 3960,
  [3961] = 3961,
  [3962] = 3962,
  [3963] = 3819,
  [3964] = 3905,
  [3965] = 3965,
  [3966] = 3966,
  [3967] = 3743,
  [3968] = 3968,
  [3969] = 3898,
  [3970] = 3905,
  [3971] = 3971,
  [3972] = 3972,
  [3973] = 3599,
  [3974] = 3804,
  [3975] = 3975,
  [3976] = 3976,
  [3977] = 3977,
  [3978] = 3978,
  [3979] = 3979,
  [3980] = 3980,
  [3981] = 3981,
  [3982] = 3982,
  [3983] = 3983,
  [3984] = 3984,
  [3985] = 3985,
  [3986] = 3986,
  [3987] = 3987,
  [3988] = 3988,
  [3989] = 3790,
  [3990] = 3990,
  [3991] = 3991,
  [3992] = 3992,
  [3993] = 3993,
  [3994] = 3994,
  [3995] = 3995,
  [3996] = 3996,
  [3997] = 3997,
  [3998] = 3998,
  [3999] = 3999,
  [4000] = 4000,
  [4001] = 4001,
  [4002] = 4002,
  [4003] = 4003,
  [4004] = 4004,
  [4005] = 4005,
  [4006] = 4006,
  [4007] = 4007,
  [4008] = 4008,
  [4009] = 4009,
  [4010] = 4010,
  [4011] = 4011,
  [4012] = 4012,
  [4013] = 4013,
  [4014] = 678,
  [4015] = 4015,
  [4016] = 4016,
  [4017] = 4017,
  [4018] = 4018,
  [4019] = 4019,
  [4020] = 4017,
  [4021] = 4013,
  [4022] = 3960,
  [4023] = 4002,
  [4024] = 4024,
  [4025] = 4025,
  [4026] = 4026,
  [4027] = 4027,
  [4028] = 4028,
  [4029] = 4029,
  [4030] = 4030,
  [4031] = 4031,
  [4032] = 4032,
  [4033] = 4004,
  [4034] = 4034,
  [4035] = 4006,
  [4036] = 4036,
  [4037] = 4037,
  [4038] = 4038,
  [4039] = 4039,
  [4040] = 4040,
  [4041] = 4041,
  [4042] = 4037,
  [4043] = 4038,
  [4044] = 4044,
  [4045] = 4045,
  [4046] = 3540,
  [4047] = 3743,
  [4048] = 4048,
  [4049] = 4048,
  [4050] = 4050,
  [4051] = 4051,
  [4052] = 4015,
  [4053] = 4016,
  [4054] = 4029,
  [4055] = 4028,
  [4056] = 3968,
  [4057] = 4057,
  [4058] = 3520,
  [4059] = 1105,
  [4060] = 4013,
  [4061] = 4061,
  [4062] = 4062,
  [4063] = 4028,
  [4064] = 4029,
  [4065] = 4029,
  [4066] = 4062,
  [4067] = 4061,
  [4068] = 4068,
  [4069] = 4028,
  [4070] = 4038,
  [4071] = 3514,
  [4072] = 4072,
  [4073] = 4073,
  [4074] = 4074,
  [4075] = 4013,
  [4076] = 3988,
  [4077] = 4077,
  [4078] = 4078,
  [4079] = 4079,
  [4080] = 4037,
  [4081] = 3767,
  [4082] = 3766,
  [4083] = 4038,
  [4084] = 4084,
  [4085] = 4013,
  [4086] = 4017,
  [4087] = 4016,
  [4088] = 4015,
  [4089] = 4048,
  [4090] = 4048,
  [4091] = 4091,
  [4092] = 4037,
  [4093] = 4015,
  [4094] = 4094,
  [4095] = 4016,
  [4096] = 4096,
  [4097] = 4078,
  [4098] = 4098,
  [4099] = 3977,
  [4100] = 4013,
  [4101] = 4016,
  [4102] = 4015,
  [4103] = 4103,
  [4104] = 4061,
  [4105] = 4105,
  [4106] = 4062,
  [4107] = 4028,
  [4108] = 4029,
  [4109] = 4016,
  [4110] = 4015,
  [4111] = 4048,
  [4112] = 4112,
  [4113] = 3979,
  [4114] = 1205,
  [4115] = 4115,
  [4116] = 4116,
  [4117] = 4117,
  [4118] = 4118,
  [4119] = 4119,
  [4120] = 3987,
  [4121] = 3980,
  [4122] = 4122,
  [4123] = 3981,
  [4124] = 4124,
  [4125] = 4048,
  [4126] = 4126,
  [4127] = 4127,
  [4128] = 4024,
  [4129] = 1914,
  [4130] = 4130,
  [4131] = 4131,
  [4132] = 4132,
  [4133] = 4133,
  [4134] = 4050,
  [4135] = 1861,
  [4136] = 1860,
  [4137] = 1859,
  [4138] = 1854,
  [4139] = 3982,
  [4140] = 3983,
  [4141] = 4133,
  [4142] = 4051,
  [4143] = 4048,
  [4144] = 4124,
  [4145] = 3984,
  [4146] = 3986,
  [4147] = 4147,
  [4148] = 1819,
  [4149] = 1812,
  [4150] = 3978,
  [4151] = 4015,
  [4152] = 4016,
  [4153] = 4098,
  [4154] = 4096,
  [4155] = 4068,
  [4156] = 4074,
  [4157] = 4157,
  [4158] = 3995,
  [4159] = 4159,
  [4160] = 4160,
  [4161] = 1774,
  [4162] = 1778,
  [4163] = 4000,
  [4164] = 3996,
  [4165] = 1780,
  [4166] = 3994,
  [4167] = 4131,
  [4168] = 3870,
  [4169] = 4013,
  [4170] = 3904,
  [4171] = 4171,
  [4172] = 4077,
  [4173] = 4091,
  [4174] = 4174,
  [4175] = 4050,
  [4176] = 4061,
  [4177] = 4062,
  [4178] = 4057,
  [4179] = 4028,
  [4180] = 4029,
  [4181] = 4117,
  [4182] = 4132,
  [4183] = 4045,
  [4184] = 4184,
  [4185] = 4159,
  [4186] = 4103,
  [4187] = 4011,
  [4188] = 4003,
  [4189] = 4130,
  [4190] = 3997,
  [4191] = 679,
  [4192] = 676,
  [4193] = 3991,
  [4194] = 677,
  [4195] = 680,
  [4196] = 4196,
  [4197] = 4197,
  [4198] = 4198,
  [4199] = 4199,
  [4200] = 816,
  [4201] = 4201,
  [4202] = 4202,
  [4203] = 4203,
  [4204] = 4204,
  [4205] = 829,
  [4206] = 4206,
  [4207] = 4207,
  [4208] = 4208,
  [4209] = 4209,
  [4210] = 4210,
  [4211] = 4211,
  [4212] = 4212,
  [4213] = 4213,
  [4214] = 4214,
  [4215] = 4215,
  [4216] = 4216,
  [4217] = 4217,
  [4218] = 4218,
  [4219] = 4219,
  [4220] = 4220,
  [4221] = 4221,
  [4222] = 4222,
  [4223] = 902,
  [4224] = 4224,
  [4225] = 4225,
  [4226] = 4226,
  [4227] = 4227,
  [4228] = 4228,
  [4229] = 4229,
  [4230] = 3933,
  [4231] = 4231,
  [4232] = 4232,
  [4233] = 4233,
  [4234] = 4234,
  [4235] = 4235,
  [4236] = 4236,
  [4237] = 4237,
  [4238] = 4238,
  [4239] = 4239,
  [4240] = 4240,
  [4241] = 4044,
  [4242] = 4242,
  [4243] = 4243,
  [4244] = 3954,
  [4245] = 4245,
  [4246] = 4246,
  [4247] = 3956,
  [4248] = 4248,
  [4249] = 4249,
  [4250] = 4250,
  [4251] = 858,
  [4252] = 4252,
  [4253] = 4253,
  [4254] = 4254,
  [4255] = 4255,
  [4256] = 4256,
  [4257] = 4257,
  [4258] = 4258,
  [4259] = 4259,
  [4260] = 4260,
  [4261] = 4261,
  [4262] = 4262,
  [4263] = 4263,
  [4264] = 4264,
  [4265] = 4265,
  [4266] = 4221,
  [4267] = 4267,
  [4268] = 4268,
  [4269] = 805,
  [4270] = 795,
  [4271] = 833,
  [4272] = 792,
  [4273] = 778,
  [4274] = 4274,
  [4275] = 4275,
  [4276] = 4276,
  [4277] = 831,
  [4278] = 4278,
  [4279] = 4279,
  [4280] = 4280,
  [4281] = 4281,
  [4282] = 4282,
  [4283] = 4283,
  [4284] = 4284,
  [4285] = 4285,
  [4286] = 819,
  [4287] = 818,
  [4288] = 229,
  [4289] = 4289,
  [4290] = 4290,
  [4291] = 240,
  [4292] = 4292,
  [4293] = 4217,
  [4294] = 4294,
  [4295] = 4295,
  [4296] = 4296,
  [4297] = 4297,
  [4298] = 4203,
  [4299] = 4299,
  [4300] = 4300,
  [4301] = 4301,
  [4302] = 4302,
  [4303] = 4303,
  [4304] = 4304,
  [4305] = 4305,
  [4306] = 4306,
  [4307] = 4307,
  [4308] = 4308,
  [4309] = 4217,
  [4310] = 4310,
  [4311] = 4311,
  [4312] = 225,
  [4313] = 4243,
  [4314] = 850,
  [4315] = 4315,
  [4316] = 4316,
  [4317] = 849,
  [4318] = 4318,
  [4319] = 841,
  [4320] = 4320,
  [4321] = 4321,
  [4322] = 4322,
  [4323] = 4323,
  [4324] = 4324,
  [4325] = 4325,
  [4326] = 4326,
  [4327] = 4327,
  [4328] = 4328,
  [4329] = 4329,
  [4330] = 4330,
  [4331] = 4331,
  [4332] = 4332,
  [4333] = 4333,
  [4334] = 4203,
  [4335] = 4335,
  [4336] = 4336,
  [4337] = 4337,
  [4338] = 4338,
  [4339] = 4339,
  [4340] = 4340,
  [4341] = 4341,
  [4342] = 4342,
  [4343] = 4343,
  [4344] = 4243,
  [4345] = 4345,
  [4346] = 4346,
  [4347] = 4347,
  [4348] = 4311,
  [4349] = 4349,
  [4350] = 4350,
  [4351] = 4351,
  [4352] = 4352,
  [4353] = 4353,
  [4354] = 4354,
  [4355] = 4355,
  [4356] = 4356,
  [4357] = 4357,
  [4358] = 4358,
  [4359] = 226,
  [4360] = 4360,
  [4361] = 900,
  [4362] = 4362,
  [4363] = 4363,
  [4364] = 4364,
  [4365] = 4365,
  [4366] = 4366,
  [4367] = 4367,
  [4368] = 4264,
  [4369] = 881,
  [4370] = 4370,
  [4371] = 4245,
  [4372] = 4372,
  [4373] = 4262,
  [4374] = 4374,
  [4375] = 872,
  [4376] = 4376,
  [4377] = 4377,
  [4378] = 4378,
  [4379] = 4379,
  [4380] = 4380,
  [4381] = 4276,
  [4382] = 4382,
  [4383] = 4383,
  [4384] = 4384,
  [4385] = 4385,
  [4386] = 4279,
  [4387] = 4387,
  [4388] = 4388,
  [4389] = 4389,
  [4390] = 4390,
  [4391] = 834,
  [4392] = 780,
  [4393] = 4393,
  [4394] = 4394,
  [4395] = 4294,
  [4396] = 4396,
  [4397] = 4397,
  [4398] = 783,
  [4399] = 761,
  [4400] = 4400,
  [4401] = 4401,
  [4402] = 4402,
  [4403] = 4403,
  [4404] = 4397,
  [4405] = 4405,
  [4406] = 4294,
  [4407] = 4407,
  [4408] = 4408,
  [4409] = 4409,
  [4410] = 4410,
  [4411] = 4411,
  [4412] = 4034,
  [4413] = 4413,
  [4414] = 4032,
  [4415] = 4415,
  [4416] = 4416,
  [4417] = 4417,
  [4418] = 4418,
  [4419] = 4419,
  [4420] = 4420,
  [4421] = 4031,
  [4422] = 4422,
  [4423] = 4423,
  [4424] = 4424,
  [4425] = 4203,
  [4426] = 817,
  [4427] = 4427,
  [4428] = 848,
  [4429] = 822,
  [4430] = 4430,
  [4431] = 4431,
  [4432] = 4432,
  [4433] = 4433,
  [4434] = 4434,
  [4435] = 4435,
  [4436] = 4436,
  [4437] = 4437,
  [4438] = 875,
  [4439] = 4439,
  [4440] = 867,
  [4441] = 815,
  [4442] = 4442,
  [4443] = 885,
  [4444] = 4444,
  [4445] = 4445,
  [4446] = 4446,
  [4447] = 4447,
  [4448] = 871,
  [4449] = 813,
  [4450] = 4450,
  [4451] = 4197,
  [4452] = 4452,
  [4453] = 4217,
  [4454] = 4454,
  [4455] = 800,
  [4456] = 4456,
  [4457] = 797,
  [4458] = 806,
  [4459] = 4459,
  [4460] = 4460,
  [4461] = 4217,
  [4462] = 4343,
  [4463] = 4463,
  [4464] = 4464,
  [4465] = 4465,
  [4466] = 4466,
  [4467] = 851,
  [4468] = 853,
  [4469] = 4469,
  [4470] = 4427,
  [4471] = 798,
  [4472] = 4472,
  [4473] = 4473,
  [4474] = 4474,
  [4475] = 4475,
  [4476] = 892,
  [4477] = 904,
  [4478] = 903,
  [4479] = 4479,
  [4480] = 4480,
  [4481] = 4481,
  [4482] = 4445,
  [4483] = 863,
  [4484] = 4456,
  [4485] = 4485,
  [4486] = 4393,
  [4487] = 4487,
  [4488] = 4390,
  [4489] = 4489,
  [4490] = 4372,
  [4491] = 4360,
  [4492] = 776,
  [4493] = 840,
  [4494] = 781,
  [4495] = 4495,
  [4496] = 4318,
  [4497] = 771,
  [4498] = 4498,
  [4499] = 4456,
  [4500] = 4279,
  [4501] = 4382,
  [4502] = 4502,
  [4503] = 4503,
  [4504] = 4504,
  [4505] = 4505,
  [4506] = 4506,
  [4507] = 4393,
  [4508] = 4445,
  [4509] = 4509,
  [4510] = 4276,
  [4511] = 4511,
  [4512] = 4512,
  [4513] = 786,
  [4514] = 4514,
  [4515] = 4377,
  [4516] = 4390,
  [4517] = 4517,
  [4518] = 4518,
  [4519] = 4519,
  [4520] = 4520,
  [4521] = 4521,
  [4522] = 789,
  [4523] = 856,
  [4524] = 4524,
  [4525] = 791,
  [4526] = 4396,
  [4527] = 4527,
  [4528] = 4372,
  [4529] = 790,
  [4530] = 4530,
  [4531] = 4446,
  [4532] = 821,
  [4533] = 4360,
  [4534] = 4534,
  [4535] = 4535,
  [4536] = 4536,
  [4537] = 4537,
  [4538] = 794,
  [4539] = 4539,
  [4540] = 4540,
  [4541] = 4541,
  [4542] = 4542,
  [4543] = 4543,
  [4544] = 4544,
  [4545] = 4545,
  [4546] = 4546,
  [4547] = 4547,
  [4548] = 4548,
  [4549] = 4549,
  [4550] = 4550,
  [4551] = 4551,
  [4552] = 4552,
  [4553] = 4553,
  [4554] = 4554,
  [4555] = 4555,
  [4556] = 4556,
  [4557] = 4557,
  [4558] = 4558,
  [4559] = 4559,
  [4560] = 4333,
  [4561] = 4561,
  [4562] = 4562,
  [4563] = 4563,
  [4564] = 4564,
  [4565] = 4203,
  [4566] = 4566,
  [4567] = 4567,
  [4568] = 4568,
  [4569] = 4220,
  [4570] = 4570,
  [4571] = 4328,
  [4572] = 4264,
  [4573] = 4573,
  [4574] = 4558,
  [4575] = 4575,
  [4576] = 4576,
  [4577] = 4366,
  [4578] = 4353,
  [4579] = 4567,
  [4580] = 4580,
  [4581] = 4581,
  [4582] = 4385,
  [4583] = 4445,
  [4584] = 4584,
  [4585] = 4585,
  [4586] = 4586,
  [4587] = 4587,
  [4588] = 4588,
  [4589] = 4262,
  [4590] = 4353,
  [4591] = 4456,
  [4592] = 4350,
  [4593] = 4593,
  [4594] = 4393,
  [4595] = 4390,
  [4596] = 4366,
  [4597] = 4264,
  [4598] = 4598,
  [4599] = 4599,
  [4600] = 4600,
  [4601] = 4601,
  [4602] = 4602,
  [4603] = 4372,
  [4604] = 4604,
  [4605] = 4605,
  [4606] = 4606,
  [4607] = 4607,
  [4608] = 4608,
  [4609] = 4609,
  [4610] = 4610,
  [4611] = 4563,
  [4612] = 4612,
  [4613] = 4613,
  [4614] = 4329,
  [4615] = 803,
  [4616] = 4616,
  [4617] = 784,
  [4618] = 785,
  [4619] = 4619,
  [4620] = 4620,
  [4621] = 4621,
  [4622] = 4622,
  [4623] = 4585,
  [4624] = 4624,
  [4625] = 4360,
  [4626] = 4327,
  [4627] = 4627,
  [4628] = 4628,
  [4629] = 4284,
  [4630] = 4630,
  [4631] = 4631,
  [4632] = 4530,
  [4633] = 4633,
  [4634] = 4377,
  [4635] = 4318,
  [4636] = 4636,
  [4637] = 802,
  [4638] = 860,
  [4639] = 4276,
  [4640] = 4294,
  [4641] = 862,
  [4642] = 4642,
  [4643] = 4397,
  [4644] = 4644,
  [4645] = 4645,
  [4646] = 4646,
  [4647] = 4382,
  [4648] = 866,
  [4649] = 4649,
  [4650] = 868,
  [4651] = 4279,
  [4652] = 772,
  [4653] = 878,
  [4654] = 869,
  [4655] = 4655,
  [4656] = 845,
  [4657] = 4311,
  [4658] = 4658,
  [4659] = 896,
  [4660] = 4660,
  [4661] = 4661,
  [4662] = 4662,
  [4663] = 3932,
  [4664] = 759,
  [4665] = 4318,
  [4666] = 880,
  [4667] = 4667,
  [4668] = 898,
  [4669] = 4669,
  [4670] = 884,
  [4671] = 879,
  [4672] = 870,
  [4673] = 873,
  [4674] = 4674,
  [4675] = 4675,
  [4676] = 874,
  [4677] = 876,
  [4678] = 891,
  [4679] = 897,
  [4680] = 4444,
  [4681] = 4681,
  [4682] = 227,
  [4683] = 4683,
  [4684] = 4684,
  [4685] = 4685,
  [4686] = 4686,
  [4687] = 4687,
  [4688] = 4688,
  [4689] = 4689,
  [4690] = 4690,
  [4691] = 4255,
  [4692] = 4692,
  [4693] = 4693,
  [4694] = 4694,
  [4695] = 4686,
  [4696] = 4252,
  [4697] = 4686,
  [4698] = 4698,
  [4699] = 4699,
  [4700] = 4700,
  [4701] = 4701,
  [4702] = 4702,
  [4703] = 4686,
  [4704] = 4704,
  [4705] = 4694,
  [4706] = 4693,
  [4707] = 4684,
  [4708] = 4683,
  [4709] = 4709,
  [4710] = 4710,
  [4711] = 4711,
  [4712] = 4712,
  [4713] = 4713,
  [4714] = 4714,
  [4715] = 4715,
  [4716] = 4716,
  [4717] = 4717,
  [4718] = 4700,
  [4719] = 4715,
  [4720] = 4720,
  [4721] = 4721,
  [4722] = 4700,
  [4723] = 4723,
  [4724] = 4690,
  [4725] = 4725,
  [4726] = 4726,
  [4727] = 4039,
  [4728] = 4723,
  [4729] = 4685,
  [4730] = 4711,
  [4731] = 4687,
  [4732] = 4732,
  [4733] = 4683,
  [4734] = 4684,
  [4735] = 4690,
  [4736] = 4736,
  [4737] = 4693,
  [4738] = 4694,
  [4739] = 4739,
  [4740] = 4740,
  [4741] = 4741,
  [4742] = 4742,
  [4743] = 4743,
  [4744] = 4744,
  [4745] = 4745,
  [4746] = 4746,
  [4747] = 4747,
  [4748] = 4748,
  [4749] = 4749,
  [4750] = 4750,
  [4751] = 4751,
  [4752] = 4690,
  [4753] = 4753,
  [4754] = 4754,
  [4755] = 4755,
  [4756] = 4694,
  [4757] = 4693,
  [4758] = 4684,
  [4759] = 4683,
  [4760] = 4723,
  [4761] = 4761,
  [4762] = 4762,
  [4763] = 4763,
  [4764] = 4764,
  [4765] = 4765,
  [4766] = 4766,
  [4767] = 4687,
  [4768] = 4715,
  [4769] = 4769,
  [4770] = 4683,
  [4771] = 4685,
  [4772] = 4684,
  [4773] = 4773,
  [4774] = 4746,
  [4775] = 4775,
  [4776] = 4776,
  [4777] = 4777,
  [4778] = 4778,
  [4779] = 4693,
  [4780] = 4686,
  [4781] = 4694,
  [4782] = 4782,
  [4783] = 4699,
  [4784] = 4036,
  [4785] = 4746,
  [4786] = 4786,
  [4787] = 4713,
  [4788] = 4788,
  [4789] = 4789,
  [4790] = 4723,
  [4791] = 4791,
  [4792] = 4715,
  [4793] = 4715,
  [4794] = 4687,
  [4795] = 4782,
  [4796] = 4749,
  [4797] = 4712,
  [4798] = 4715,
  [4799] = 4799,
  [4800] = 4744,
  [4801] = 4742,
  [4802] = 4714,
  [4803] = 4716,
  [4804] = 4683,
  [4805] = 4684,
  [4806] = 4694,
  [4807] = 4693,
  [4808] = 4694,
  [4809] = 4700,
  [4810] = 4693,
  [4811] = 4684,
  [4812] = 4740,
  [4813] = 4813,
  [4814] = 4736,
  [4815] = 4683,
  [4816] = 4816,
  [4817] = 4736,
  [4818] = 4749,
  [4819] = 4819,
  [4820] = 4820,
  [4821] = 4685,
  [4822] = 4822,
  [4823] = 4687,
  [4824] = 4746,
  [4825] = 4750,
  [4826] = 4745,
  [4827] = 4827,
  [4828] = 4746,
  [4829] = 4723,
  [4830] = 4685,
  [4831] = 4831,
  [4832] = 4690,
  [4833] = 4690,
  [4834] = 4834,
  [4835] = 4726,
  [4836] = 4683,
  [4837] = 4684,
  [4838] = 4687,
  [4839] = 4693,
  [4840] = 4686,
  [4841] = 4700,
  [4842] = 4701,
  [4843] = 4843,
  [4844] = 4844,
  [4845] = 4694,
  [4846] = 4846,
  [4847] = 4716,
  [4848] = 4748,
  [4849] = 4746,
  [4850] = 4747,
  [4851] = 4745,
  [4852] = 4852,
  [4853] = 4723,
  [4854] = 4683,
  [4855] = 4855,
  [4856] = 4684,
  [4857] = 4693,
  [4858] = 4694,
  [4859] = 4699,
  [4860] = 4717,
  [4861] = 4750,
  [4862] = 4862,
  [4863] = 4863,
  [4864] = 4864,
  [4865] = 4865,
  [4866] = 4866,
  [4867] = 4867,
  [4868] = 4868,
  [4869] = 4869,
  [4870] = 4870,
  [4871] = 4871,
  [4872] = 4872,
  [4873] = 4873,
  [4874] = 4874,
  [4875] = 4875,
  [4876] = 4876,
  [4877] = 4877,
  [4878] = 4878,
  [4879] = 4879,
  [4880] = 4880,
  [4881] = 4881,
  [4882] = 4882,
  [4883] = 4883,
  [4884] = 765,
  [4885] = 4885,
  [4886] = 4886,
  [4887] = 4887,
  [4888] = 4888,
  [4889] = 4889,
  [4890] = 4890,
  [4891] = 3978,
  [4892] = 4892,
  [4893] = 4893,
  [4894] = 4894,
  [4895] = 4895,
  [4896] = 4896,
  [4897] = 4897,
  [4898] = 4898,
  [4899] = 4899,
  [4900] = 4900,
  [4901] = 4901,
  [4902] = 4902,
  [4903] = 4903,
  [4904] = 4904,
  [4905] = 4905,
  [4906] = 4906,
  [4907] = 4907,
  [4908] = 4908,
  [4909] = 4862,
  [4910] = 4910,
  [4911] = 4911,
  [4912] = 4912,
  [4913] = 4913,
  [4914] = 4914,
  [4915] = 4915,
  [4916] = 4916,
  [4917] = 4917,
  [4918] = 4918,
  [4919] = 4919,
  [4920] = 4920,
  [4921] = 4921,
  [4922] = 4922,
  [4923] = 4923,
  [4924] = 4924,
  [4925] = 4925,
  [4926] = 4926,
  [4927] = 4927,
  [4928] = 4928,
  [4929] = 4929,
  [4930] = 4930,
  [4931] = 4931,
  [4932] = 4932,
  [4933] = 4933,
  [4934] = 4934,
  [4935] = 4935,
  [4936] = 4936,
  [4937] = 4937,
  [4938] = 4938,
  [4939] = 4939,
  [4940] = 4940,
  [4941] = 4941,
  [4942] = 4942,
  [4943] = 4943,
  [4944] = 4944,
  [4945] = 4945,
  [4946] = 4946,
  [4947] = 4947,
  [4948] = 4948,
  [4949] = 4949,
  [4950] = 4950,
  [4951] = 4951,
  [4952] = 4952,
  [4953] = 4953,
  [4954] = 4954,
  [4955] = 4955,
  [4956] = 4956,
  [4957] = 4957,
  [4958] = 4958,
  [4959] = 4959,
  [4960] = 4960,
  [4961] = 4961,
  [4962] = 4962,
  [4963] = 4963,
  [4964] = 4964,
  [4965] = 4965,
  [4966] = 4966,
  [4967] = 4967,
  [4968] = 4968,
  [4969] = 4969,
  [4970] = 4970,
  [4971] = 4971,
  [4972] = 4972,
  [4973] = 4973,
  [4974] = 4942,
  [4975] = 4975,
  [4976] = 4976,
  [4977] = 4977,
  [4978] = 4978,
  [4979] = 4978,
  [4980] = 4980,
  [4981] = 4981,
  [4982] = 4982,
  [4983] = 4983,
  [4984] = 4984,
  [4985] = 4985,
  [4986] = 4986,
  [4987] = 4987,
  [4988] = 4988,
  [4989] = 4989,
  [4990] = 4990,
  [4991] = 4991,
  [4992] = 4992,
  [4993] = 4993,
  [4994] = 4994,
  [4995] = 4995,
  [4996] = 4996,
  [4997] = 4997,
  [4998] = 4915,
  [4999] = 4999,
  [5000] = 5000,
  [5001] = 5001,
  [5002] = 5002,
  [5003] = 5003,
  [5004] = 5004,
  [5005] = 5005,
  [5006] = 4887,
  [5007] = 5007,
  [5008] = 5008,
  [5009] = 4885,
  [5010] = 5010,
  [5011] = 5011,
  [5012] = 5012,
  [5013] = 5013,
  [5014] = 5014,
  [5015] = 5015,
  [5016] = 5016,
  [5017] = 5017,
  [5018] = 5018,
  [5019] = 5019,
  [5020] = 5020,
  [5021] = 5021,
  [5022] = 4939,
  [5023] = 4869,
  [5024] = 5024,
  [5025] = 4869,
  [5026] = 5026,
  [5027] = 5027,
  [5028] = 5028,
  [5029] = 4863,
  [5030] = 5030,
  [5031] = 5031,
  [5032] = 5032,
  [5033] = 5033,
  [5034] = 5034,
  [5035] = 5035,
  [5036] = 5036,
  [5037] = 5037,
  [5038] = 4955,
  [5039] = 4993,
  [5040] = 4992,
  [5041] = 5041,
  [5042] = 5042,
  [5043] = 5043,
  [5044] = 5044,
  [5045] = 5045,
  [5046] = 5046,
  [5047] = 5047,
  [5048] = 5048,
  [5049] = 5049,
  [5050] = 4952,
  [5051] = 3979,
  [5052] = 5052,
  [5053] = 5053,
  [5054] = 5054,
  [5055] = 5055,
  [5056] = 4950,
  [5057] = 5057,
  [5058] = 5058,
  [5059] = 5059,
  [5060] = 5060,
  [5061] = 5061,
  [5062] = 5062,
  [5063] = 5063,
  [5064] = 5064,
  [5065] = 5065,
  [5066] = 5066,
  [5067] = 5067,
  [5068] = 5059,
  [5069] = 4863,
  [5070] = 5070,
  [5071] = 5071,
  [5072] = 5072,
  [5073] = 4938,
  [5074] = 5074,
  [5075] = 5075,
  [5076] = 5076,
  [5077] = 5077,
  [5078] = 5078,
  [5079] = 4973,
  [5080] = 5080,
  [5081] = 5081,
  [5082] = 5082,
  [5083] = 5083,
  [5084] = 4991,
  [5085] = 5085,
  [5086] = 4942,
  [5087] = 4890,
  [5088] = 5088,
  [5089] = 5032,
  [5090] = 5090,
  [5091] = 5091,
  [5092] = 5092,
  [5093] = 5093,
  [5094] = 5094,
  [5095] = 5095,
  [5096] = 5096,
  [5097] = 4908,
  [5098] = 5098,
  [5099] = 5099,
  [5100] = 5034,
  [5101] = 5101,
  [5102] = 5102,
  [5103] = 5103,
  [5104] = 4897,
  [5105] = 5105,
  [5106] = 4895,
  [5107] = 5107,
  [5108] = 4942,
  [5109] = 5109,
  [5110] = 5110,
  [5111] = 5111,
  [5112] = 5112,
  [5113] = 5113,
  [5114] = 5114,
  [5115] = 5115,
  [5116] = 5116,
  [5117] = 5117,
  [5118] = 5118,
  [5119] = 5119,
  [5120] = 4992,
  [5121] = 4993,
  [5122] = 5122,
  [5123] = 5123,
  [5124] = 5034,
  [5125] = 5125,
  [5126] = 5126,
  [5127] = 5032,
  [5128] = 5128,
  [5129] = 5129,
  [5130] = 5130,
  [5131] = 5131,
  [5132] = 4863,
  [5133] = 5133,
  [5134] = 5134,
  [5135] = 5135,
  [5136] = 5136,
  [5137] = 5137,
  [5138] = 5138,
  [5139] = 5139,
  [5140] = 5140,
  [5141] = 5141,
  [5142] = 5142,
  [5143] = 4924,
  [5144] = 5144,
  [5145] = 5145,
  [5146] = 5146,
  [5147] = 5010,
  [5148] = 5148,
  [5149] = 5149,
  [5150] = 5150,
  [5151] = 5151,
  [5152] = 5152,
  [5153] = 5153,
  [5154] = 5154,
  [5155] = 5155,
  [5156] = 5156,
  [5157] = 5157,
  [5158] = 5158,
  [5159] = 5159,
  [5160] = 5160,
  [5161] = 5161,
  [5162] = 5162,
  [5163] = 5163,
  [5164] = 5164,
  [5165] = 5165,
  [5166] = 5166,
  [5167] = 5167,
  [5168] = 5168,
  [5169] = 5169,
  [5170] = 5170,
  [5171] = 5171,
  [5172] = 5172,
  [5173] = 4993,
  [5174] = 5174,
  [5175] = 4992,
  [5176] = 4993,
  [5177] = 5177,
  [5178] = 5178,
  [5179] = 5179,
  [5180] = 4992,
  [5181] = 5181,
  [5182] = 5034,
  [5183] = 5032,
  [5184] = 5184,
  [5185] = 5185,
  [5186] = 5186,
  [5187] = 5137,
  [5188] = 5135,
  [5189] = 4869,
  [5190] = 5190,
  [5191] = 5135,
  [5192] = 5192,
  [5193] = 4939,
  [5194] = 5194,
  [5195] = 5195,
  [5196] = 5137,
  [5197] = 5197,
  [5198] = 5198,
  [5199] = 5199,
  [5200] = 5200,
  [5201] = 5201,
  [5202] = 5202,
  [5203] = 5203,
  [5204] = 5204,
  [5205] = 5205,
  [5206] = 5206,
  [5207] = 3818,
  [5208] = 5208,
  [5209] = 5209,
  [5210] = 5210,
  [5211] = 5211,
  [5212] = 4866,
  [5213] = 4868,
  [5214] = 5214,
  [5215] = 4877,
  [5216] = 5216,
  [5217] = 5217,
  [5218] = 5218,
  [5219] = 5219,
  [5220] = 5010,
  [5221] = 3968,
  [5222] = 5222,
  [5223] = 5223,
  [5224] = 5224,
  [5225] = 5225,
  [5226] = 5226,
  [5227] = 5096,
  [5228] = 5228,
  [5229] = 5229,
  [5230] = 5230,
  [5231] = 4887,
  [5232] = 5232,
  [5233] = 5233,
  [5234] = 5234,
  [5235] = 5235,
  [5236] = 5236,
  [5237] = 5237,
  [5238] = 5238,
  [5239] = 5239,
  [5240] = 5240,
  [5241] = 5241,
  [5242] = 5242,
  [5243] = 5243,
  [5244] = 5244,
  [5245] = 5245,
  [5246] = 5122,
  [5247] = 5247,
  [5248] = 5159,
  [5249] = 5249,
  [5250] = 5250,
  [5251] = 4915,
  [5252] = 5252,
  [5253] = 5253,
  [5254] = 5254,
  [5255] = 5255,
  [5256] = 5256,
  [5257] = 5257,
  [5258] = 5258,
  [5259] = 5096,
  [5260] = 5260,
  [5261] = 5258,
  [5262] = 5262,
  [5263] = 5263,
  [5264] = 5264,
  [5265] = 5265,
  [5266] = 4972,
  [5267] = 5267,
  [5268] = 5268,
  [5269] = 5269,
  [5270] = 5270,
  [5271] = 5271,
  [5272] = 5272,
  [5273] = 5273,
  [5274] = 5274,
  [5275] = 5275,
  [5276] = 5276,
  [5277] = 5277,
  [5278] = 5278,
  [5279] = 5279,
  [5280] = 5280,
  [5281] = 5281,
  [5282] = 5282,
  [5283] = 5283,
  [5284] = 5178,
  [5285] = 5285,
  [5286] = 5286,
  [5287] = 5287,
  [5288] = 5288,
  [5289] = 4933,
  [5290] = 5290,
  [5291] = 5291,
  [5292] = 5292,
  [5293] = 5293,
  [5294] = 4941,
  [5295] = 5295,
  [5296] = 5296,
  [5297] = 5297,
  [5298] = 5298,
  [5299] = 5299,
  [5300] = 5300,
  [5301] = 5301,
  [5302] = 5302,
  [5303] = 5303,
  [5304] = 4957,
  [5305] = 5305,
  [5306] = 5306,
  [5307] = 4895,
  [5308] = 5308,
  [5309] = 5309,
  [5310] = 5310,
  [5311] = 5311,
  [5312] = 5312,
  [5313] = 4897,
  [5314] = 5314,
  [5315] = 4939,
  [5316] = 5316,
  [5317] = 5317,
  [5318] = 4869,
  [5319] = 4963,
  [5320] = 4863,
  [5321] = 5321,
  [5322] = 5032,
  [5323] = 5323,
  [5324] = 5034,
  [5325] = 5325,
  [5326] = 5326,
  [5327] = 5327,
  [5328] = 4993,
  [5329] = 4992,
  [5330] = 5330,
  [5331] = 5331,
  [5332] = 5332,
  [5333] = 5059,
  [5334] = 5334,
  [5335] = 4978,
  [5336] = 5336,
  [5337] = 5337,
  [5338] = 5338,
  [5339] = 5339,
  [5340] = 5340,
  [5341] = 5341,
  [5342] = 5342,
  [5343] = 5343,
  [5344] = 5344,
  [5345] = 5345,
  [5346] = 5346,
  [5347] = 5347,
  [5348] = 5348,
  [5349] = 5349,
  [5350] = 5350,
  [5351] = 5018,
  [5352] = 5352,
  [5353] = 5019,
  [5354] = 4973,
  [5355] = 5024,
  [5356] = 5356,
  [5357] = 5357,
  [5358] = 4955,
  [5359] = 3960,
  [5360] = 5360,
  [5361] = 4942,
  [5362] = 4952,
  [5363] = 5363,
  [5364] = 5364,
  [5365] = 5365,
  [5366] = 5366,
  [5367] = 4950,
  [5368] = 5368,
  [5369] = 5369,
  [5370] = 5370,
  [5371] = 5371,
  [5372] = 5372,
  [5373] = 5071,
  [5374] = 5072,
  [5375] = 4938,
  [5376] = 5376,
  [5377] = 4908,
  [5378] = 5378,
  [5379] = 5379,
  [5380] = 5380,
  [5381] = 5381,
  [5382] = 5382,
  [5383] = 5383,
  [5384] = 5384,
  [5385] = 5385,
  [5386] = 5386,
  [5387] = 5387,
  [5388] = 5388,
  [5389] = 5186,
  [5390] = 4862,
  [5391] = 5391,
  [5392] = 5392,
  [5393] = 5393,
  [5394] = 5394,
  [5395] = 4942,
  [5396] = 5396,
  [5397] = 5397,
  [5398] = 5398,
  [5399] = 5399,
  [5400] = 5400,
  [5401] = 5401,
  [5402] = 5103,
  [5403] = 5403,
  [5404] = 5404,
  [5405] = 5405,
  [5406] = 5110,
  [5407] = 1783,
  [5408] = 4996,
  [5409] = 5126,
  [5410] = 1777,
  [5411] = 5411,
  [5412] = 5412,
  [5413] = 5413,
  [5414] = 5414,
  [5415] = 5415,
  [5416] = 5416,
  [5417] = 5417,
  [5418] = 5418,
  [5419] = 4924,
  [5420] = 5420,
  [5421] = 5258,
  [5422] = 5422,
  [5423] = 5423,
  [5424] = 5424,
  [5425] = 5159,
  [5426] = 5426,
  [5427] = 5427,
  [5428] = 5428,
  [5429] = 5429,
  [5430] = 5430,
  [5431] = 5431,
  [5432] = 5432,
  [5433] = 5433,
  [5434] = 5434,
  [5435] = 5435,
  [5436] = 5436,
  [5437] = 5437,
  [5438] = 5438,
  [5439] = 5439,
  [5440] = 5440,
  [5441] = 4973,
  [5442] = 5442,
  [5443] = 5443,
  [5444] = 5444,
  [5445] = 4339,
  [5446] = 5446,
  [5447] = 5447,
  [5448] = 5448,
  [5449] = 5449,
  [5450] = 4942,
  [5451] = 5451,
  [5452] = 5452,
  [5453] = 5453,
  [5454] = 5454,
  [5455] = 5455,
  [5456] = 5456,
  [5457] = 4973,
  [5458] = 5458,
  [5459] = 5459,
  [5460] = 5460,
  [5461] = 5461,
  [5462] = 5462,
  [5463] = 4991,
  [5464] = 5464,
  [5465] = 5465,
  [5466] = 5466,
  [5467] = 5467,
  [5468] = 5468,
  [5469] = 5469,
  [5470] = 4947,
  [5471] = 5471,
  [5472] = 5078,
  [5473] = 5473,
  [5474] = 4506,
  [5475] = 4564,
  [5476] = 5476,
  [5477] = 5477,
  [5478] = 5478,
  [5479] = 5479,
  [5480] = 5480,
  [5481] = 5005,
  [5482] = 5482,
  [5483] = 5483,
  [5484] = 5484,
  [5485] = 5485,
  [5486] = 5486,
  [5487] = 5007,
  [5488] = 4939,
  [5489] = 5489,
  [5490] = 4869,
  [5491] = 5491,
  [5492] = 4863,
  [5493] = 5493,
  [5494] = 5032,
  [5495] = 5495,
  [5496] = 5034,
  [5497] = 5497,
  [5498] = 5498,
  [5499] = 4993,
  [5500] = 4992,
  [5501] = 5501,
  [5502] = 5502,
  [5503] = 5503,
  [5504] = 5504,
  [5505] = 5203,
  [5506] = 5506,
  [5507] = 5007,
  [5508] = 5005,
  [5509] = 4947,
  [5510] = 5510,
  [5511] = 5511,
  [5512] = 5512,
  [5513] = 5513,
  [5514] = 5514,
  [5515] = 5515,
  [5516] = 5516,
  [5517] = 5517,
  [5518] = 5518,
  [5519] = 5519,
  [5520] = 5520,
  [5521] = 5521,
  [5522] = 5522,
  [5523] = 5523,
  [5524] = 5524,
  [5525] = 5525,
  [5526] = 5515,
  [5527] = 5527,
  [5528] = 5528,
  [5529] = 5529,
  [5530] = 5530,
  [5531] = 5531,
  [5532] = 5518,
  [5533] = 5533,
  [5534] = 5534,
  [5535] = 5535,
  [5536] = 5536,
  [5537] = 5537,
  [5538] = 5538,
  [5539] = 5539,
  [5540] = 5540,
  [5541] = 5541,
  [5542] = 5542,
  [5543] = 5543,
  [5544] = 5544,
  [5545] = 5545,
  [5546] = 5546,
  [5547] = 5547,
  [5548] = 5548,
  [5549] = 5549,
  [5550] = 5550,
  [5551] = 5551,
  [5552] = 4044,
  [5553] = 5553,
  [5554] = 5554,
  [5555] = 5555,
  [5556] = 5556,
  [5557] = 5557,
  [5558] = 5558,
  [5559] = 5559,
  [5560] = 5518,
  [5561] = 5561,
  [5562] = 5562,
  [5563] = 5563,
  [5564] = 5564,
  [5565] = 5565,
  [5566] = 5566,
  [5567] = 5567,
  [5568] = 5568,
  [5569] = 5569,
  [5570] = 5570,
  [5571] = 5571,
  [5572] = 5572,
  [5573] = 5573,
  [5574] = 5574,
  [5575] = 5575,
  [5576] = 5576,
  [5577] = 5577,
  [5578] = 5521,
  [5579] = 5579,
  [5580] = 5580,
  [5581] = 5581,
  [5582] = 5582,
  [5583] = 5583,
  [5584] = 5584,
  [5585] = 5585,
  [5586] = 5586,
  [5587] = 5587,
  [5588] = 5588,
  [5589] = 5541,
  [5590] = 5590,
  [5591] = 5591,
  [5592] = 5523,
  [5593] = 5593,
  [5594] = 5519,
  [5595] = 5517,
  [5596] = 5596,
  [5597] = 5597,
  [5598] = 5598,
  [5599] = 5599,
  [5600] = 5515,
  [5601] = 5570,
  [5602] = 4034,
  [5603] = 4032,
  [5604] = 4031,
  [5605] = 5605,
  [5606] = 5588,
  [5607] = 5607,
  [5608] = 5608,
  [5609] = 5609,
  [5610] = 5610,
  [5611] = 5611,
  [5612] = 5612,
  [5613] = 5613,
  [5614] = 5614,
  [5615] = 5518,
  [5616] = 5616,
  [5617] = 5559,
  [5618] = 5618,
  [5619] = 5619,
  [5620] = 5515,
  [5621] = 5621,
  [5622] = 5622,
  [5623] = 5623,
  [5624] = 5624,
  [5625] = 5625,
  [5626] = 5626,
  [5627] = 5627,
  [5628] = 5628,
  [5629] = 5629,
  [5630] = 5630,
  [5631] = 5631,
  [5632] = 5632,
  [5633] = 5596,
  [5634] = 5634,
  [5635] = 5635,
  [5636] = 5572,
  [5637] = 5637,
  [5638] = 5573,
  [5639] = 5639,
  [5640] = 5640,
  [5641] = 5641,
  [5642] = 2120,
  [5643] = 5565,
  [5644] = 5644,
  [5645] = 5645,
  [5646] = 5646,
  [5647] = 5647,
  [5648] = 5648,
  [5649] = 5649,
  [5650] = 5650,
  [5651] = 5651,
  [5652] = 5652,
  [5653] = 5585,
  [5654] = 5654,
  [5655] = 5586,
  [5656] = 5587,
  [5657] = 5657,
  [5658] = 5511,
  [5659] = 5659,
  [5660] = 5660,
  [5661] = 5541,
  [5662] = 5517,
  [5663] = 5519,
  [5664] = 5523,
  [5665] = 5521,
  [5666] = 5519,
  [5667] = 5517,
  [5668] = 5596,
  [5669] = 5631,
  [5670] = 5624,
  [5671] = 5623,
  [5672] = 5619,
  [5673] = 5521,
  [5674] = 5598,
  [5675] = 5523,
  [5676] = 5588,
  [5677] = 5597,
  [5678] = 5593,
  [5679] = 5591,
  [5680] = 5680,
  [5681] = 5681,
  [5682] = 5559,
  [5683] = 5571,
  [5684] = 5570,
  [5685] = 5685,
  [5686] = 5686,
  [5687] = 5687,
  [5688] = 5688,
  [5689] = 5598,
  [5690] = 5690,
  [5691] = 5541,
  [5692] = 5692,
  [5693] = 5693,
  [5694] = 5694,
  [5695] = 5695,
  [5696] = 5696,
  [5697] = 5697,
  [5698] = 5542,
  [5699] = 5598,
  [5700] = 5700,
  [5701] = 5534,
  [5702] = 5702,
  [5703] = 5703,
  [5704] = 5704,
  [5705] = 5705,
  [5706] = 5706,
  [5707] = 5707,
  [5708] = 5708,
  [5709] = 5709,
  [5710] = 5710,
  [5711] = 5621,
  [5712] = 5712,
  [5713] = 5713,
  [5714] = 5622,
  [5715] = 5715,
  [5716] = 5588,
  [5717] = 5717,
  [5718] = 5659,
  [5719] = 5528,
  [5720] = 5529,
  [5721] = 5530,
  [5722] = 5722,
  [5723] = 2185,
  [5724] = 5559,
  [5725] = 5725,
  [5726] = 5657,
  [5727] = 5727,
  [5728] = 2159,
  [5729] = 5729,
  [5730] = 5730,
  [5731] = 5635,
  [5732] = 5572,
  [5733] = 5637,
  [5734] = 5734,
  [5735] = 5573,
  [5736] = 5736,
  [5737] = 5737,
  [5738] = 5738,
  [5739] = 5739,
  [5740] = 5640,
  [5741] = 5641,
  [5742] = 5742,
  [5743] = 5743,
  [5744] = 5744,
  [5745] = 5745,
  [5746] = 5586,
  [5747] = 5654,
  [5748] = 2163,
  [5749] = 5585,
  [5750] = 5750,
  [5751] = 5751,
  [5752] = 5752,
  [5753] = 5587,
  [5754] = 5605,
  [5755] = 5585,
  [5756] = 5756,
  [5757] = 5654,
  [5758] = 5559,
  [5759] = 5586,
  [5760] = 5745,
  [5761] = 5587,
  [5762] = 5739,
  [5763] = 5737,
  [5764] = 5729,
  [5765] = 5727,
  [5766] = 5657,
  [5767] = 5511,
  [5768] = 5659,
  [5769] = 5693,
  [5770] = 5692,
  [5771] = 5771,
  [5772] = 5772,
  [5773] = 5541,
  [5774] = 5774,
  [5775] = 5742,
  [5776] = 5523,
  [5777] = 5521,
  [5778] = 5519,
  [5779] = 5517,
  [5780] = 5556,
  [5781] = 5652,
  [5782] = 5651,
  [5783] = 5681,
  [5784] = 5784,
  [5785] = 5561,
  [5786] = 5650,
  [5787] = 5639,
  [5788] = 5596,
  [5789] = 5563,
  [5790] = 5722,
  [5791] = 5791,
  [5792] = 5632,
  [5793] = 5641,
  [5794] = 5631,
  [5795] = 5630,
  [5796] = 5629,
  [5797] = 5625,
  [5798] = 5624,
  [5799] = 5623,
  [5800] = 5619,
  [5801] = 5608,
  [5802] = 5556,
  [5803] = 5599,
  [5804] = 5640,
  [5805] = 2179,
  [5806] = 5583,
  [5807] = 5510,
  [5808] = 5588,
  [5809] = 5809,
  [5810] = 5597,
  [5811] = 5593,
  [5812] = 5591,
  [5813] = 5813,
  [5814] = 5814,
  [5815] = 5815,
  [5816] = 5582,
  [5817] = 5581,
  [5818] = 5580,
  [5819] = 5579,
  [5820] = 5577,
  [5821] = 5608,
  [5822] = 5576,
  [5823] = 5823,
  [5824] = 5824,
  [5825] = 5736,
  [5826] = 5574,
  [5827] = 5571,
  [5828] = 5626,
  [5829] = 5570,
  [5830] = 5569,
  [5831] = 5568,
  [5832] = 5567,
  [5833] = 5566,
  [5834] = 2180,
  [5835] = 5565,
  [5836] = 5573,
  [5837] = 5734,
  [5838] = 5637,
  [5839] = 5550,
  [5840] = 5690,
  [5841] = 5549,
  [5842] = 5842,
  [5843] = 5572,
  [5844] = 5598,
  [5845] = 5725,
  [5846] = 5598,
  [5847] = 5725,
  [5848] = 5635,
  [5849] = 5849,
  [5850] = 5730,
  [5851] = 5851,
  [5852] = 5588,
  [5853] = 5853,
  [5854] = 5547,
  [5855] = 5855,
  [5856] = 5856,
  [5857] = 5561,
  [5858] = 5546,
  [5859] = 5859,
  [5860] = 5544,
  [5861] = 5559,
  [5862] = 5548,
  [5863] = 5542,
  [5864] = 5864,
  [5865] = 5865,
  [5866] = 5622,
  [5867] = 5534,
  [5868] = 5533,
  [5869] = 5869,
  [5870] = 5870,
  [5871] = 5871,
  [5872] = 5543,
  [5873] = 5529,
  [5874] = 5528,
  [5875] = 5875,
  [5876] = 2045,
  [5877] = 1971,
  [5878] = 2008,
  [5879] = 2184,
  [5880] = 2132,
  [5881] = 2151,
  [5882] = 2145,
  [5883] = 2192,
  [5884] = 2195,
  [5885] = 2189,
  [5886] = 2182,
  [5887] = 3031,
  [5888] = 3048,
  [5889] = 2197,
  [5890] = 2800,
  [5891] = 2880,
  [5892] = 2843,
  [5893] = 2802,
  [5894] = 5894,
  [5895] = 5895,
  [5896] = 2142,
  [5897] = 5705,
  [5898] = 2090,
  [5899] = 5899,
  [5900] = 5900,
  [5901] = 5901,
  [5902] = 5902,
  [5903] = 5903,
  [5904] = 5706,
  [5905] = 2214,
  [5906] = 5707,
  [5907] = 2212,
  [5908] = 5908,
  [5909] = 5909,
  [5910] = 5910,
  [5911] = 5911,
  [5912] = 5912,
  [5913] = 5913,
  [5914] = 5914,
  [5915] = 5915,
  [5916] = 5916,
  [5917] = 5917,
  [5918] = 5708,
  [5919] = 2208,
  [5920] = 5709,
  [5921] = 2198,
  [5922] = 5922,
  [5923] = 5923,
  [5924] = 5924,
  [5925] = 5925,
  [5926] = 5926,
  [5927] = 5927,
  [5928] = 5928,
  [5929] = 5929,
  [5930] = 5930,
  [5931] = 5710,
  [5932] = 5621,
  [5933] = 5933,
  [5934] = 5712,
  [5935] = 2193,
  [5936] = 5713,
  [5937] = 5937,
  [5938] = 5938,
  [5939] = 5939,
  [5940] = 5940,
  [5941] = 5941,
  [5942] = 5942,
  [5943] = 5943,
  [5944] = 5944,
  [5945] = 5945,
  [5946] = 5946,
  [5947] = 5947,
  [5948] = 5948,
  [5949] = 5940,
  [5950] = 5950,
  [5951] = 5951,
  [5952] = 5952,
  [5953] = 5953,
  [5954] = 5954,
  [5955] = 5955,
  [5956] = 5948,
  [5957] = 5939,
  [5958] = 5958,
  [5959] = 5959,
  [5960] = 5960,
  [5961] = 5961,
  [5962] = 5962,
  [5963] = 5963,
  [5964] = 5964,
  [5965] = 5965,
  [5966] = 5966,
  [5967] = 5967,
  [5968] = 5968,
  [5969] = 5969,
  [5970] = 5970,
  [5971] = 5971,
  [5972] = 5972,
  [5973] = 5973,
  [5974] = 5974,
  [5975] = 5975,
  [5976] = 5976,
  [5977] = 5977,
  [5978] = 5978,
  [5979] = 5979,
  [5980] = 5941,
  [5981] = 5942,
  [5982] = 5982,
  [5983] = 5983,
  [5984] = 5950,
  [5985] = 5985,
  [5986] = 5986,
  [5987] = 5987,
  [5988] = 5959,
  [5989] = 5989,
  [5990] = 5990,
  [5991] = 5947,
  [5992] = 5992,
  [5993] = 5993,
  [5994] = 5978,
  [5995] = 5995,
  [5996] = 5996,
  [5997] = 5997,
  [5998] = 5998,
  [5999] = 5999,
  [6000] = 6000,
  [6001] = 5992,
  [6002] = 5987,
  [6003] = 6003,
  [6004] = 6004,
  [6005] = 6005,
  [6006] = 5946,
  [6007] = 5985,
  [6008] = 6008,
  [6009] = 6009,
  [6010] = 6010,
  [6011] = 6011,
  [6012] = 6010,
  [6013] = 6011,
  [6014] = 6014,
  [6015] = 6015,
  [6016] = 5979,
  [6017] = 6017,
  [6018] = 5977,
  [6019] = 5975,
  [6020] = 5974,
  [6021] = 5997,
  [6022] = 5996,
  [6023] = 6023,
  [6024] = 6024,
  [6025] = 6025,
  [6026] = 6026,
  [6027] = 6027,
  [6028] = 6028,
  [6029] = 6029,
  [6030] = 6030,
  [6031] = 6031,
  [6032] = 6032,
  [6033] = 6033,
  [6034] = 5946,
  [6035] = 5995,
  [6036] = 6036,
  [6037] = 6033,
  [6038] = 6032,
  [6039] = 6031,
  [6040] = 6040,
  [6041] = 6030,
  [6042] = 6029,
  [6043] = 6028,
  [6044] = 6044,
  [6045] = 6027,
  [6046] = 5947,
  [6047] = 5948,
  [6048] = 6026,
  [6049] = 5939,
  [6050] = 5940,
  [6051] = 5941,
  [6052] = 5942,
  [6053] = 6025,
  [6054] = 6054,
  [6055] = 6024,
  [6056] = 5974,
  [6057] = 6057,
  [6058] = 6058,
  [6059] = 5965,
  [6060] = 5950,
  [6061] = 6061,
  [6062] = 5964,
  [6063] = 6003,
  [6064] = 6064,
  [6065] = 6065,
  [6066] = 5958,
  [6067] = 5973,
  [6068] = 5960,
  [6069] = 5972,
  [6070] = 5971,
  [6071] = 5960,
  [6072] = 5969,
  [6073] = 5937,
  [6074] = 5967,
  [6075] = 6075,
  [6076] = 5958,
  [6077] = 5963,
  [6078] = 5962,
  [6079] = 5961,
  [6080] = 5966,
  [6081] = 5948,
  [6082] = 5939,
  [6083] = 5968,
  [6084] = 5970,
  [6085] = 6085,
  [6086] = 5976,
  [6087] = 5940,
  [6088] = 5941,
  [6089] = 5942,
  [6090] = 5950,
  [6091] = 5978,
  [6092] = 6023,
  [6093] = 5989,
  [6094] = 5990,
  [6095] = 5998,
  [6096] = 5996,
  [6097] = 5993,
  [6098] = 5997,
  [6099] = 5958,
  [6100] = 5995,
  [6101] = 5960,
  [6102] = 5999,
  [6103] = 6000,
  [6104] = 5947,
  [6105] = 5974,
  [6106] = 6009,
  [6107] = 6011,
  [6108] = 6000,
  [6109] = 5999,
  [6110] = 6010,
  [6111] = 6014,
  [6112] = 5997,
  [6113] = 5996,
  [6114] = 5978,
  [6115] = 6033,
  [6116] = 6116,
  [6117] = 6032,
  [6118] = 6031,
  [6119] = 6119,
  [6120] = 6120,
  [6121] = 6030,
  [6122] = 6029,
  [6123] = 5958,
  [6124] = 6028,
  [6125] = 6027,
  [6126] = 6026,
  [6127] = 6127,
  [6128] = 5992,
  [6129] = 6025,
  [6130] = 5967,
  [6131] = 6003,
  [6132] = 5973,
  [6133] = 5972,
  [6134] = 6134,
  [6135] = 5971,
  [6136] = 5969,
  [6137] = 5937,
  [6138] = 5967,
  [6139] = 5966,
  [6140] = 5947,
  [6141] = 6141,
  [6142] = 6142,
  [6143] = 5948,
  [6144] = 6144,
  [6145] = 5939,
  [6146] = 6146,
  [6147] = 6000,
  [6148] = 6148,
  [6149] = 6149,
  [6150] = 5999,
  [6151] = 6151,
  [6152] = 5987,
  [6153] = 5940,
  [6154] = 5941,
  [6155] = 5942,
  [6156] = 5963,
  [6157] = 5962,
  [6158] = 5961,
  [6159] = 6159,
  [6160] = 6160,
  [6161] = 5985,
  [6162] = 5947,
  [6163] = 5950,
  [6164] = 5948,
  [6165] = 6165,
  [6166] = 5998,
  [6167] = 5939,
  [6168] = 5968,
  [6169] = 6169,
  [6170] = 5970,
  [6171] = 6024,
  [6172] = 5940,
  [6173] = 5941,
  [6174] = 5942,
  [6175] = 5950,
  [6176] = 5989,
  [6177] = 5970,
  [6178] = 5968,
  [6179] = 6179,
  [6180] = 6180,
  [6181] = 5990,
  [6182] = 5998,
  [6183] = 5993,
  [6184] = 5995,
  [6185] = 5999,
  [6186] = 6159,
  [6187] = 6000,
  [6188] = 6149,
  [6189] = 5946,
  [6190] = 6015,
  [6191] = 6014,
  [6192] = 6192,
  [6193] = 6009,
  [6194] = 6010,
  [6195] = 6011,
  [6196] = 6010,
  [6197] = 6044,
  [6198] = 5976,
  [6199] = 5997,
  [6200] = 5996,
  [6201] = 6011,
  [6202] = 5978,
  [6203] = 5946,
  [6204] = 6009,
  [6205] = 6033,
  [6206] = 6206,
  [6207] = 6032,
  [6208] = 6031,
  [6209] = 6030,
  [6210] = 6029,
  [6211] = 6211,
  [6212] = 6028,
  [6213] = 6213,
  [6214] = 6026,
  [6215] = 6025,
  [6216] = 6216,
  [6217] = 6180,
  [6218] = 6024,
  [6219] = 5974,
  [6220] = 5979,
  [6221] = 5973,
  [6222] = 6179,
  [6223] = 5972,
  [6224] = 5971,
  [6225] = 5969,
  [6226] = 5961,
  [6227] = 6017,
  [6228] = 5962,
  [6229] = 5977,
  [6230] = 5963,
  [6231] = 6231,
  [6232] = 5966,
  [6233] = 5999,
  [6234] = 5990,
  [6235] = 5937,
  [6236] = 5969,
  [6237] = 6237,
  [6238] = 5975,
  [6239] = 6239,
  [6240] = 6169,
  [6241] = 6000,
  [6242] = 5971,
  [6243] = 6243,
  [6244] = 5972,
  [6245] = 6245,
  [6246] = 5973,
  [6247] = 6247,
  [6248] = 5937,
  [6249] = 5974,
  [6250] = 5967,
  [6251] = 6024,
  [6252] = 6025,
  [6253] = 6026,
  [6254] = 6027,
  [6255] = 6028,
  [6256] = 6029,
  [6257] = 5995,
  [6258] = 5993,
  [6259] = 5998,
  [6260] = 6165,
  [6261] = 5990,
  [6262] = 5989,
  [6263] = 5950,
  [6264] = 5982,
  [6265] = 6030,
  [6266] = 5942,
  [6267] = 5941,
  [6268] = 5940,
  [6269] = 6269,
  [6270] = 6031,
  [6271] = 5947,
  [6272] = 5948,
  [6273] = 6032,
  [6274] = 5939,
  [6275] = 5940,
  [6276] = 5941,
  [6277] = 5942,
  [6278] = 5976,
  [6279] = 6033,
  [6280] = 6280,
  [6281] = 5965,
  [6282] = 5964,
  [6283] = 6151,
  [6284] = 5966,
  [6285] = 5950,
  [6286] = 5963,
  [6287] = 5978,
  [6288] = 5962,
  [6289] = 5961,
  [6290] = 5947,
  [6291] = 5970,
  [6292] = 5968,
  [6293] = 5948,
  [6294] = 6146,
  [6295] = 5939,
  [6296] = 6296,
  [6297] = 6297,
  [6298] = 5996,
  [6299] = 5997,
  [6300] = 5939,
  [6301] = 5948,
  [6302] = 5947,
  [6303] = 5960,
  [6304] = 6151,
  [6305] = 6165,
  [6306] = 6169,
  [6307] = 5968,
  [6308] = 5970,
  [6309] = 5976,
  [6310] = 5940,
  [6311] = 5941,
  [6312] = 6179,
  [6313] = 6180,
  [6314] = 5998,
  [6315] = 5942,
  [6316] = 6316,
  [6317] = 6159,
  [6318] = 5950,
  [6319] = 6149,
  [6320] = 5989,
  [6321] = 6321,
  [6322] = 6044,
  [6323] = 6323,
  [6324] = 6027,
  [6325] = 6000,
  [6326] = 6326,
  [6327] = 5999,
  [6328] = 6165,
  [6329] = 5995,
  [6330] = 6010,
  [6331] = 5958,
  [6332] = 6332,
  [6333] = 6011,
  [6334] = 6134,
  [6335] = 5993,
  [6336] = 6165,
  [6337] = 6337,
  [6338] = 6134,
  [6339] = 6339,
  [6340] = 6146,
  [6341] = 6165,
  [6342] = 6342,
  [6343] = 6239,
  [6344] = 6237,
  [6345] = 6345,
  [6346] = 6009,
  [6347] = 6116,
  [6348] = 6348,
  [6349] = 6349,
  [6350] = 5952,
  [6351] = 5955,
  [6352] = 6239,
  [6353] = 6237,
  [6354] = 6354,
  [6355] = 6355,
  [6356] = 6116,
  [6357] = 6237,
  [6358] = 6358,
  [6359] = 6359,
  [6360] = 6360,
};

static TSCharacterRange extras_character_set_1[] = {
  {'\t', '\r'}, {' ', ' '}, {0xa0, 0xa0}, {0x1680, 0x1680}, {0x2000, 0x200b}, {0x2028, 0x2029}, {0x202f, 0x202f}, {0x205f, 0x2060},
  {0x3000, 0x3000}, {0xfeff, 0xfeff},
};

static TSCharacterRange sym_identifier_character_set_1[] = {
  {'$', '$'}, {'A', 'Z'}, {'\\', '\\'}, {'_', '_'}, {'a', 'z'}, {0x7f, 0x9f}, {0xa1, 0x167f}, {0x1681, 0x1fff},
  {0x200c, 0x2027}, {0x202a, 0x202e}, {0x2030, 0x205e}, {0x2061, 0x2fff}, {0x3001, 0xfefe}, {0xff00, 0x10ffff},
};

static TSCharacterRange sym_identifier_character_set_2[] = {
  {'$', '$'}, {'0', '9'}, {'A', 'Z'}, {'\\', '\\'}, {'_', '_'}, {'a', 'z'}, {0x7f, 0x9f}, {0xa1, 0x167f},
  {0x1681, 0x1fff}, {0x200c, 0x2027}, {0x202a, 0x202e}, {0x2030, 0x205e}, {0x2061, 0x2fff}, {0x3001, 0xfefe}, {0xff00, 0x10ffff},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(96);
      ADVANCE_MAP(
        '!', 109,
        '"', 128,
        '#', 10,
        '$', 235,
        '%', 180,
        '&', 159,
        '\'', 129,
        '(', 110,
        ')', 111,
        '*', 99,
        '+', 172,
        ',', 106,
        '-', 176,
        '.', 126,
        '/', 221,
        '0', 226,
        ':', 113,
        ';', 112,
        '<', 185,
        '=', 102,
        '>', 123,
        '?', 241,
        '@', 238,
        '[', 114,
        '\\', 55,
        ']', 115,
        '^', 162,
        '`', 219,
        '{', 105,
        '|', 165,
        '}', 107,
        '~', 197,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(227);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(94);
      if (lookahead > '@') ADVANCE(236);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(1);
      if (lookahead == '/') ADVANCE(117);
      if (lookahead == '<') ADVANCE(119);
      if (set_contains(extras_character_set_1, 10, lookahead)) ADVANCE(118);
      if (lookahead != 0) ADVANCE(116);
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(29);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '[') ADVANCE(39);
      if (lookahead == '\\') ADVANCE(93);
      if (set_contains(extras_character_set_1, 10, lookahead)) ADVANCE(222);
      if (lookahead != 0) ADVANCE(223);
      END_STATE();
    case 3:
      ADVANCE_MAP(
        '!', 109,
        '"', 128,
        '#', 38,
        '%', 180,
        '&', 159,
        '\'', 129,
        '(', 110,
        ')', 111,
        '*', 99,
        '+', 171,
        ',', 106,
        '-', 175,
        '.', 126,
        '/', 178,
        '0', 226,
        ':', 113,
        ';', 112,
        '<', 185,
        '=', 102,
        '>', 123,
        '?', 241,
        '@', 238,
        '[', 114,
        '\\', 57,
        ']', 115,
        '^', 162,
        '`', 219,
        '{', 104,
        '|', 164,
        '}', 107,
        '~', 197,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(227);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(3);
      if (lookahead > '#') ADVANCE(236);
      END_STATE();
    case 4:
      ADVANCE_MAP(
        '!', 109,
        '"', 128,
        '#', 38,
        '%', 180,
        '&', 159,
        '\'', 129,
        '(', 110,
        ')', 111,
        '*', 99,
        '+', 171,
        ',', 106,
        '-', 175,
        '.', 127,
        '/', 178,
        '0', 226,
        ':', 113,
        ';', 112,
        '<', 184,
        '=', 102,
        '>', 123,
        '?', 241,
        '[', 114,
        '\\', 57,
        ']', 115,
        '^', 162,
        '`', 219,
        '{', 105,
        '|', 164,
        '}', 107,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(227);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(4);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(236);
      END_STATE();
    case 5:
      ADVANCE_MAP(
        '!', 109,
        '"', 128,
        '#', 38,
        '%', 179,
        '&', 160,
        '\'', 129,
        '(', 110,
        ')', 111,
        '*', 100,
        '+', 170,
        ',', 106,
        '-', 174,
        '.', 127,
        '/', 177,
        '0', 226,
        ':', 113,
        ';', 112,
        '<', 187,
        '=', 101,
        '>', 124,
        '?', 26,
        '@', 238,
        '[', 114,
        '\\', 57,
        ']', 115,
        '^', 161,
        '`', 219,
        '{', 104,
        '|', 166,
        '}', 107,
        '~', 197,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(227);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(5);
      if (lookahead > '#') ADVANCE(236);
      END_STATE();
    case 6:
      ADVANCE_MAP(
        '!', 109,
        '"', 128,
        '%', 180,
        '&', 159,
        '\'', 129,
        '(', 110,
        ')', 111,
        '*', 99,
        '+', 171,
        ',', 106,
        '-', 175,
        '.', 125,
        '/', 178,
        ':', 113,
        ';', 112,
        '<', 184,
        '=', 102,
        '>', 123,
        '?', 241,
        '@', 238,
        '[', 114,
        '\\', 57,
        ']', 115,
        '^', 162,
        '`', 219,
        '{', 104,
        '|', 165,
        '}', 107,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(248);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(6);
      if (lookahead > '#' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(236);
      END_STATE();
    case 7:
      ADVANCE_MAP(
        '!', 109,
        '%', 179,
        '&', 160,
        '(', 110,
        ')', 111,
        '*', 100,
        '+', 170,
        ',', 106,
        '-', 174,
        '.', 125,
        '/', 177,
        ':', 113,
        ';', 112,
        '<', 186,
        '=', 101,
        '>', 124,
        '?', 242,
        '@', 238,
        '[', 114,
        '\\', 57,
        ']', 115,
        '^', 161,
        '`', 219,
        '{', 104,
        '|', 167,
        '}', 107,
      );
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(7);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(236);
      END_STATE();
    case 8:
      ADVANCE_MAP(
        '!', 109,
        '%', 179,
        '&', 160,
        '(', 110,
        ')', 111,
        '*', 100,
        '+', 170,
        ',', 106,
        '-', 174,
        '.', 125,
        '/', 177,
        ':', 113,
        ';', 112,
        '<', 186,
        '=', 33,
        '>', 124,
        '?', 26,
        '[', 114,
        '\\', 57,
        ']', 115,
        '^', 161,
        '`', 219,
        '{', 104,
        '|', 166,
        '}', 107,
      );
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(224);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(9);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '`' || '~' < lookahead)) ADVANCE(236);
      END_STATE();
    case 9:
      ADVANCE_MAP(
        '!', 109,
        '%', 179,
        '&', 160,
        '(', 110,
        ')', 111,
        '*', 100,
        '+', 170,
        ',', 106,
        '-', 174,
        '.', 125,
        '/', 177,
        ':', 113,
        ';', 112,
        '<', 186,
        '=', 33,
        '>', 124,
        '?', 26,
        '[', 114,
        '\\', 57,
        ']', 115,
        '^', 161,
        '`', 219,
        '{', 104,
        '|', 166,
        '}', 107,
      );
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(9);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(236);
      END_STATE();
    case 10:
      if (lookahead == '!') ADVANCE(97);
      if (lookahead == '\\') ADVANCE(56);
      if (set_contains(sym_identifier_character_set_1, 14, lookahead)) ADVANCE(237);
      END_STATE();
    case 11:
      ADVANCE_MAP(
        '!', 108,
        '"', 128,
        '#', 38,
        '&', 158,
        '\'', 129,
        '(', 110,
        ')', 111,
        '*', 98,
        '+', 170,
        ',', 106,
        '-', 174,
        '.', 126,
        '/', 177,
        '0', 226,
        ':', 113,
        ';', 112,
        '<', 188,
        '=', 103,
        '>', 122,
        '?', 239,
        '@', 238,
        '[', 114,
        '\\', 57,
        ']', 115,
        '`', 219,
        '{', 104,
        '|', 168,
        '}', 107,
        '~', 197,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(227);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(11);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead)) ADVANCE(236);
      END_STATE();
    case 12:
      ADVANCE_MAP(
        '!', 108,
        '"', 128,
        '#', 38,
        '&', 158,
        '\'', 129,
        '(', 110,
        ')', 111,
        '*', 98,
        '+', 170,
        ',', 106,
        '-', 174,
        '.', 25,
        '/', 177,
        '0', 226,
        '<', 188,
        '?', 239,
        '@', 238,
        '[', 114,
        '\\', 57,
        ']', 115,
        '`', 219,
        '{', 105,
        '|', 163,
        '~', 197,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(227);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(12);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(236);
      END_STATE();
    case 13:
      ADVANCE_MAP(
        '!', 108,
        '"', 128,
        '#', 38,
        '&', 158,
        '\'', 129,
        '(', 110,
        ')', 111,
        '*', 98,
        '+', 169,
        ',', 106,
        '-', 173,
        '.', 25,
        '/', 22,
        '0', 226,
        ':', 113,
        ';', 112,
        '<', 183,
        '=', 103,
        '>', 122,
        '?', 239,
        '@', 238,
        '[', 114,
        '\\', 57,
        ']', 115,
        '{', 104,
        '|', 168,
        '}', 107,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(227);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(13);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(236);
      END_STATE();
    case 14:
      ADVANCE_MAP(
        '!', 108,
        '&', 158,
        '(', 110,
        ')', 111,
        ',', 106,
        '.', 125,
        '/', 22,
        ':', 113,
        ';', 112,
        '<', 183,
        '=', 103,
        '>', 122,
        '?', 239,
        '[', 114,
        '\\', 57,
        ']', 115,
        '{', 104,
        '|', 168,
        '}', 107,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(248);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(14);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(236);
      END_STATE();
    case 15:
      ADVANCE_MAP(
        '"', 128,
        '&', 158,
        '\'', 129,
        '(', 110,
        ')', 111,
        '*', 98,
        ',', 106,
        '.', 125,
        '/', 22,
        ':', 113,
        ';', 112,
        '<', 183,
        '=', 103,
        '>', 122,
        '?', 240,
        '@', 238,
        '[', 114,
        '\\', 57,
        ']', 115,
        '`', 219,
        '{', 104,
        '|', 168,
        '}', 107,
      );
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(15);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(236);
      END_STATE();
    case 16:
      ADVANCE_MAP(
        '"', 128,
        '&', 158,
        '\'', 129,
        '(', 110,
        '*', 98,
        '+', 169,
        ',', 106,
        '-', 173,
        '.', 25,
        '/', 22,
        '0', 226,
        '<', 183,
        '>', 122,
        '?', 239,
        '[', 114,
        '\\', 57,
        ']', 115,
        '`', 219,
        '{', 105,
        '|', 163,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(227);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(16);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(236);
      END_STATE();
    case 17:
      if (lookahead == '"') ADVANCE(128);
      if (lookahead == '/') ADVANCE(200);
      if (lookahead == '\\') ADVANCE(58);
      if (set_contains(extras_character_set_1, 10, lookahead)) ADVANCE(203);
      if (lookahead != 0) ADVANCE(205);
      END_STATE();
    case 18:
      if (lookahead == '$') ADVANCE(59);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '\\') ADVANCE(58);
      if (lookahead == '`') ADVANCE(219);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(19);
      END_STATE();
    case 19:
      if (lookahead == '$') ADVANCE(59);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '`') ADVANCE(219);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(19);
      END_STATE();
    case 20:
      ADVANCE_MAP(
        '&', 158,
        '+', 36,
        ',', 106,
        '-', 37,
        '.', 125,
        '/', 22,
        ':', 113,
        '<', 183,
        '?', 32,
        '[', 114,
        '\\', 57,
        ']', 115,
        '{', 105,
        '|', 163,
      );
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(20);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(236);
      END_STATE();
    case 21:
      if (lookahead == '\'') ADVANCE(129);
      if (lookahead == '/') ADVANCE(206);
      if (lookahead == '\\') ADVANCE(58);
      if (set_contains(extras_character_set_1, 10, lookahead)) ADVANCE(209);
      if (lookahead != 0) ADVANCE(211);
      END_STATE();
    case 22:
      if (lookahead == '*') ADVANCE(24);
      if (lookahead == '/') ADVANCE(218);
      END_STATE();
    case 23:
      if (lookahead == '*') ADVANCE(23);
      if (lookahead == '/') ADVANCE(217);
      if (lookahead != 0) ADVANCE(24);
      END_STATE();
    case 24:
      if (lookahead == '*') ADVANCE(23);
      if (lookahead != 0) ADVANCE(24);
      END_STATE();
    case 25:
      if (lookahead == '.') ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(232);
      END_STATE();
    case 26:
      if (lookahead == '.') ADVANCE(131);
      if (lookahead == '?') ADVANCE(195);
      END_STATE();
    case 27:
      if (lookahead == '.') ADVANCE(147);
      END_STATE();
    case 28:
      if (lookahead == '/') ADVANCE(221);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(29);
      END_STATE();
    case 29:
      if (lookahead == '/') ADVANCE(22);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(29);
      END_STATE();
    case 30:
      if (lookahead == ':') ADVANCE(244);
      END_STATE();
    case 31:
      if (lookahead == ':') ADVANCE(243);
      END_STATE();
    case 32:
      if (lookahead == ':') ADVANCE(245);
      END_STATE();
    case 33:
      if (lookahead == '=') ADVANCE(190);
      END_STATE();
    case 34:
      if (lookahead == '>') ADVANCE(120);
      END_STATE();
    case 35:
      if (lookahead == '>') ADVANCE(121);
      END_STATE();
    case 36:
      if (lookahead == '?') ADVANCE(30);
      END_STATE();
    case 37:
      if (lookahead == '?') ADVANCE(31);
      END_STATE();
    case 38:
      if (lookahead == '\\') ADVANCE(56);
      if (set_contains(sym_identifier_character_set_1, 14, lookahead)) ADVANCE(237);
      END_STATE();
    case 39:
      if (lookahead == '\\') ADVANCE(92);
      if (lookahead == ']') ADVANCE(223);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(39);
      END_STATE();
    case 40:
      if (lookahead == 'a') ADVANCE(52);
      END_STATE();
    case 41:
      if (lookahead == 'a') ADVANCE(53);
      END_STATE();
    case 42:
      if (lookahead == 'e') ADVANCE(48);
      END_STATE();
    case 43:
      if (lookahead == 'e') ADVANCE(34);
      END_STATE();
    case 44:
      if (lookahead == 'e') ADVANCE(35);
      END_STATE();
    case 45:
      if (lookahead == 'e') ADVANCE(49);
      END_STATE();
    case 46:
      if (lookahead == 'l') ADVANCE(40);
      END_STATE();
    case 47:
      if (lookahead == 'l') ADVANCE(41);
      END_STATE();
    case 48:
      if (lookahead == 'm') ADVANCE(50);
      END_STATE();
    case 49:
      if (lookahead == 'm') ADVANCE(51);
      END_STATE();
    case 50:
      if (lookahead == 'p') ADVANCE(46);
      END_STATE();
    case 51:
      if (lookahead == 'p') ADVANCE(47);
      END_STATE();
    case 52:
      if (lookahead == 't') ADVANCE(43);
      END_STATE();
    case 53:
      if (lookahead == 't') ADVANCE(44);
      END_STATE();
    case 54:
      if (lookahead == 't') ADVANCE(45);
      END_STATE();
    case 55:
      if (lookahead == 'u') ADVANCE(60);
      if (lookahead == 'x') ADVANCE(84);
      if (lookahead == '\r' ||
          lookahead == '?') ADVANCE(214);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(216);
      if (lookahead != 0) ADVANCE(212);
      END_STATE();
    case 56:
      if (lookahead == 'u') ADVANCE(61);
      END_STATE();
    case 57:
      if (lookahead == 'u') ADVANCE(62);
      END_STATE();
    case 58:
      if (lookahead == 'u') ADVANCE(63);
      if (lookahead == 'x') ADVANCE(84);
      if (lookahead == '\r' ||
          lookahead == '?') ADVANCE(214);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(216);
      if (lookahead != 0) ADVANCE(212);
      END_STATE();
    case 59:
      if (lookahead == '{') ADVANCE(220);
      END_STATE();
    case 60:
      if (lookahead == '{') ADVANCE(79);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(89);
      END_STATE();
    case 61:
      if (lookahead == '{') ADVANCE(82);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(90);
      END_STATE();
    case 62:
      if (lookahead == '{') ADVANCE(83);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(91);
      END_STATE();
    case 63:
      if (lookahead == '{') ADVANCE(85);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(81);
      END_STATE();
    case 64:
      if (lookahead == '}') ADVANCE(236);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(64);
      END_STATE();
    case 65:
      if (lookahead == '}') ADVANCE(237);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(65);
      END_STATE();
    case 66:
      if (lookahead == '}') ADVANCE(212);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(66);
      END_STATE();
    case 67:
      if (lookahead == '}') ADVANCE(213);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(67);
      END_STATE();
    case 68:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(74);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(233);
      END_STATE();
    case 69:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(229);
      END_STATE();
    case 70:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(230);
      END_STATE();
    case 71:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(227);
      END_STATE();
    case 72:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(232);
      END_STATE();
    case 73:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(228);
      END_STATE();
    case 74:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(233);
      END_STATE();
    case 75:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(236);
      END_STATE();
    case 76:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(237);
      END_STATE();
    case 77:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(212);
      END_STATE();
    case 78:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(231);
      END_STATE();
    case 79:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(67);
      END_STATE();
    case 80:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(213);
      END_STATE();
    case 81:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(84);
      END_STATE();
    case 82:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(65);
      END_STATE();
    case 83:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(64);
      END_STATE();
    case 84:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(77);
      END_STATE();
    case 85:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(66);
      END_STATE();
    case 86:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(80);
      END_STATE();
    case 87:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(76);
      END_STATE();
    case 88:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(75);
      END_STATE();
    case 89:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(86);
      END_STATE();
    case 90:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(87);
      END_STATE();
    case 91:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(88);
      END_STATE();
    case 92:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(39);
      END_STATE();
    case 93:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(223);
      END_STATE();
    case 94:
      if (eof) ADVANCE(96);
      ADVANCE_MAP(
        '!', 109,
        '"', 128,
        '#', 10,
        '$', 235,
        '%', 180,
        '&', 159,
        '\'', 129,
        '(', 110,
        ')', 111,
        '*', 99,
        '+', 172,
        ',', 106,
        '-', 176,
        '.', 126,
        '/', 178,
        '0', 226,
        ':', 113,
        ';', 112,
        '<', 185,
        '=', 102,
        '>', 123,
        '?', 241,
        '@', 238,
        '[', 114,
        '\\', 57,
        ']', 115,
        '^', 162,
        '`', 219,
        '{', 105,
        '|', 165,
        '}', 107,
        '~', 197,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(227);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(94);
      if (lookahead > '@') ADVANCE(236);
      END_STATE();
    case 95:
      if (eof) ADVANCE(96);
      ADVANCE_MAP(
        '!', 109,
        '"', 128,
        '#', 10,
        '%', 180,
        '&', 159,
        '\'', 129,
        '(', 110,
        ')', 111,
        '*', 99,
        '+', 171,
        ',', 106,
        '-', 175,
        '.', 126,
        '/', 178,
        '0', 226,
        ':', 113,
        ';', 112,
        '<', 185,
        '=', 102,
        '>', 123,
        '?', 241,
        '@', 238,
        '[', 114,
        '\\', 57,
        ']', 115,
        '^', 162,
        '`', 219,
        '{', 105,
        '|', 165,
        '}', 107,
        '~', 197,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(227);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(95);
      if (lookahead > '#') ADVANCE(236);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(sym_hash_bang_line);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(97);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(182);
      if (lookahead == '=') ADVANCE(134);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(181);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(190);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(190);
      if (lookahead == '>') ADVANCE(130);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(130);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '|') ADVANCE(246);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(192);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(sym__glimmer_template_content);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(sym__glimmer_template_content);
      if (lookahead == '*') ADVANCE(24);
      if (lookahead == '/') ADVANCE(218);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(sym__glimmer_template_content);
      if (lookahead == '/') ADVANCE(117);
      if (lookahead == '<') ADVANCE(119);
      if ((set_contains(extras_character_set_1, 10, lookahead)) &&
          lookahead != '\n') ADVANCE(118);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(116);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(sym__glimmer_template_content);
      if (lookahead == '/') ADVANCE(54);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_LTtemplate_GT);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_LT_SLASHtemplate_GT);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(194);
      if (lookahead == '>') ADVANCE(152);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(194);
      if (lookahead == '>') ADVANCE(153);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(232);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(232);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_QMARK_DOT);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_AMP_AMP_EQ);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE_EQ);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK_EQ);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      if (lookahead == '=') ADVANCE(144);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      if (lookahead == '=') ADVANCE(145);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(140);
      if (lookahead == '>') ADVANCE(155);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>') ADVANCE(154);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=') ADVANCE(141);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(142);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(149);
      if (lookahead == '=') ADVANCE(138);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(148);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(137);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(139);
      if (lookahead == '|') ADVANCE(151);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(139);
      if (lookahead == '|') ADVANCE(151);
      if (lookahead == '}') ADVANCE(247);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(150);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(150);
      if (lookahead == '}') ADVANCE(247);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '}') ADVANCE(247);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(198);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(198);
      if (lookahead == '=') ADVANCE(132);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(198);
      if (lookahead == '=') ADVANCE(132);
      if (lookahead == '?') ADVANCE(30);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(199);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(199);
      if (lookahead == '=') ADVANCE(133);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(199);
      if (lookahead == '=') ADVANCE(133);
      if (lookahead == '?') ADVANCE(31);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(24);
      if (lookahead == '/') ADVANCE(218);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(24);
      if (lookahead == '/') ADVANCE(218);
      if (lookahead == '=') ADVANCE(135);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(136);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(143);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(157);
      if (lookahead == '=') ADVANCE(189);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(157);
      if (lookahead == '=') ADVANCE(189);
      if (lookahead == 't') ADVANCE(42);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '=') ADVANCE(189);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '=') ADVANCE(189);
      if (lookahead == 't') ADVANCE(42);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == 't') ADVANCE(42);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=') ADVANCE(191);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '=') ADVANCE(193);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_BANG_EQ_EQ);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      if (lookahead == '=') ADVANCE(146);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '*') ADVANCE(202);
      if (lookahead == '/') ADVANCE(204);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(205);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '*') ADVANCE(201);
      if (lookahead == '/') ADVANCE(205);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(202);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '*') ADVANCE(201);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(202);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '/') ADVANCE(200);
      if (set_contains(extras_character_set_1, 10, lookahead)) ADVANCE(203);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(205);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(205);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(204);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(205);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '*') ADVANCE(208);
      if (lookahead == '/') ADVANCE(210);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(211);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '*') ADVANCE(207);
      if (lookahead == '/') ADVANCE(211);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(208);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '*') ADVANCE(207);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(208);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '/') ADVANCE(206);
      if (set_contains(extras_character_set_1, 10, lookahead)) ADVANCE(209);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(211);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(211);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(210);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(211);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(57);
      if (set_contains(sym_identifier_character_set_2, 15, lookahead)) ADVANCE(236);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\n' ||
          lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(212);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(212);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(215);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(aux_sym_comment_token1);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(aux_sym_comment_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != 0x2028 &&
          lookahead != 0x2029) ADVANCE(218);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(anon_sym_SLASH2);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '\n') SKIP(29);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '[') ADVANCE(39);
      if (lookahead == '\\') ADVANCE(93);
      if (set_contains(extras_character_set_1, 10, lookahead)) ADVANCE(222);
      if (lookahead != 0) ADVANCE(223);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '[') ADVANCE(39);
      if (lookahead == '\\') ADVANCE(93);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/') ADVANCE(223);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == '\\') ADVANCE(57);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(224);
      if (set_contains(sym_identifier_character_set_2, 15, lookahead)) ADVANCE(236);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(sym_number);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(sym_number);
      ADVANCE_MAP(
        '.', 234,
        '0', 228,
        '_', 73,
        'n', 225,
        'B', 69,
        'b', 69,
        'E', 68,
        'e', 68,
        'O', 70,
        'o', 70,
        'X', 78,
        'x', 78,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(227);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(234);
      if (lookahead == '_') ADVANCE(71);
      if (lookahead == 'n') ADVANCE(225);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(68);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(227);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(73);
      if (lookahead == 'n') ADVANCE(225);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(228);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(69);
      if (lookahead == 'n') ADVANCE(225);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(229);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(70);
      if (lookahead == 'n') ADVANCE(225);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(230);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(78);
      if (lookahead == 'n') ADVANCE(225);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(231);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(72);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(68);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(232);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(74);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(233);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(68);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(232);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(57);
      if (lookahead == '{') ADVANCE(220);
      if (set_contains(sym_identifier_character_set_2, 15, lookahead)) ADVANCE(236);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(57);
      if (set_contains(sym_identifier_character_set_2, 15, lookahead)) ADVANCE(236);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(sym_private_property_identifier);
      if (lookahead == '\\') ADVANCE(56);
      if (set_contains(sym_identifier_character_set_2, 15, lookahead)) ADVANCE(237);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(131);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(131);
      if (lookahead == '?') ADVANCE(196);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(131);
      if (lookahead == '?') ADVANCE(195);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(anon_sym_DASH_QMARK_COLON);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(anon_sym_PLUS_QMARK_COLON);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(anon_sym_QMARK_COLON);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_LBRACE_PIPE);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(anon_sym_PIPE_RBRACE);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(aux_sym_ui_version_specifier_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(248);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      ADVANCE_MAP(
        'a', 1,
        'b', 2,
        'c', 3,
        'd', 4,
        'e', 5,
        'f', 6,
        'g', 7,
        'i', 8,
        'k', 9,
        'l', 10,
        'm', 11,
        'n', 12,
        'o', 13,
        'p', 14,
        'r', 15,
        's', 16,
        't', 17,
        'u', 18,
        'v', 19,
        'w', 20,
        'y', 21,
      );
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 'b') ADVANCE(22);
      if (lookahead == 'n') ADVANCE(23);
      if (lookahead == 's') ADVANCE(24);
      if (lookahead == 'w') ADVANCE(25);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(26);
      if (lookahead == 'r') ADVANCE(27);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(28);
      if (lookahead == 'l') ADVANCE(29);
      if (lookahead == 'o') ADVANCE(30);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(31);
      if (lookahead == 'o') ADVANCE(32);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(33);
      if (lookahead == 'n') ADVANCE(34);
      if (lookahead == 'x') ADVANCE(35);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(36);
      if (lookahead == 'i') ADVANCE(37);
      if (lookahead == 'o') ADVANCE(38);
      if (lookahead == 'r') ADVANCE(39);
      if (lookahead == 'u') ADVANCE(40);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(41);
      if (lookahead == 'l') ADVANCE(42);
      END_STATE();
    case 8:
      if (lookahead == 'f') ADVANCE(43);
      if (lookahead == 'm') ADVANCE(44);
      if (lookahead == 'n') ADVANCE(45);
      if (lookahead == 's') ADVANCE(46);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(47);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(48);
      if (lookahead == 'i') ADVANCE(49);
      END_STATE();
    case 11:
      if (lookahead == 'o') ADVANCE(50);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(51);
      if (lookahead == 'e') ADVANCE(52);
      if (lookahead == 'u') ADVANCE(53);
      END_STATE();
    case 13:
      if (lookahead == 'b') ADVANCE(54);
      if (lookahead == 'f') ADVANCE(55);
      if (lookahead == 'n') ADVANCE(56);
      if (lookahead == 'v') ADVANCE(57);
      END_STATE();
    case 14:
      if (lookahead == 'r') ADVANCE(58);
      if (lookahead == 'u') ADVANCE(59);
      END_STATE();
    case 15:
      if (lookahead == 'e') ADVANCE(60);
      END_STATE();
    case 16:
      if (lookahead == 'a') ADVANCE(61);
      if (lookahead == 'e') ADVANCE(62);
      if (lookahead == 'i') ADVANCE(63);
      if (lookahead == 't') ADVANCE(64);
      if (lookahead == 'u') ADVANCE(65);
      if (lookahead == 'w') ADVANCE(66);
      if (lookahead == 'y') ADVANCE(67);
      END_STATE();
    case 17:
      if (lookahead == 'a') ADVANCE(68);
      if (lookahead == 'h') ADVANCE(69);
      if (lookahead == 'r') ADVANCE(70);
      if (lookahead == 'y') ADVANCE(71);
      END_STATE();
    case 18:
      if (lookahead == 'n') ADVANCE(72);
      if (lookahead == 's') ADVANCE(73);
      END_STATE();
    case 19:
      if (lookahead == 'a') ADVANCE(74);
      if (lookahead == 'o') ADVANCE(75);
      END_STATE();
    case 20:
      if (lookahead == 'h') ADVANCE(76);
      if (lookahead == 'i') ADVANCE(77);
      END_STATE();
    case 21:
      if (lookahead == 'i') ADVANCE(78);
      END_STATE();
    case 22:
      if (lookahead == 's') ADVANCE(79);
      END_STATE();
    case 23:
      if (lookahead == 'y') ADVANCE(80);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 's') ADVANCE(81);
      if (lookahead == 'y') ADVANCE(82);
      END_STATE();
    case 25:
      if (lookahead == 'a') ADVANCE(83);
      END_STATE();
    case 26:
      if (lookahead == 'o') ADVANCE(84);
      END_STATE();
    case 27:
      if (lookahead == 'e') ADVANCE(85);
      END_STATE();
    case 28:
      if (lookahead == 's') ADVANCE(86);
      if (lookahead == 't') ADVANCE(87);
      END_STATE();
    case 29:
      if (lookahead == 'a') ADVANCE(88);
      END_STATE();
    case 30:
      if (lookahead == 'm') ADVANCE(89);
      if (lookahead == 'n') ADVANCE(90);
      END_STATE();
    case 31:
      if (lookahead == 'b') ADVANCE(91);
      if (lookahead == 'c') ADVANCE(92);
      if (lookahead == 'f') ADVANCE(93);
      if (lookahead == 'l') ADVANCE(94);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 33:
      if (lookahead == 's') ADVANCE(95);
      END_STATE();
    case 34:
      if (lookahead == 'u') ADVANCE(96);
      END_STATE();
    case 35:
      if (lookahead == 'p') ADVANCE(97);
      if (lookahead == 't') ADVANCE(98);
      END_STATE();
    case 36:
      if (lookahead == 'l') ADVANCE(99);
      END_STATE();
    case 37:
      if (lookahead == 'n') ADVANCE(100);
      END_STATE();
    case 38:
      if (lookahead == 'r') ADVANCE(101);
      END_STATE();
    case 39:
      if (lookahead == 'o') ADVANCE(102);
      END_STATE();
    case 40:
      if (lookahead == 'n') ADVANCE(103);
      END_STATE();
    case 41:
      if (lookahead == 't') ADVANCE(104);
      END_STATE();
    case 42:
      if (lookahead == 'o') ADVANCE(105);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 44:
      if (lookahead == 'p') ADVANCE(106);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 'f') ADVANCE(107);
      if (lookahead == 's') ADVANCE(108);
      if (lookahead == 't') ADVANCE(109);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 47:
      if (lookahead == 'y') ADVANCE(110);
      END_STATE();
    case 48:
      if (lookahead == 't') ADVANCE(111);
      END_STATE();
    case 49:
      if (lookahead == 's') ADVANCE(112);
      END_STATE();
    case 50:
      if (lookahead == 'd') ADVANCE(113);
      END_STATE();
    case 51:
      if (lookahead == 'm') ADVANCE(114);
      END_STATE();
    case 52:
      if (lookahead == 'v') ADVANCE(115);
      if (lookahead == 'w') ADVANCE(116);
      END_STATE();
    case 53:
      if (lookahead == 'l') ADVANCE(117);
      if (lookahead == 'm') ADVANCE(118);
      END_STATE();
    case 54:
      if (lookahead == 'j') ADVANCE(119);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_on);
      END_STATE();
    case 57:
      if (lookahead == 'e') ADVANCE(120);
      END_STATE();
    case 58:
      if (lookahead == 'a') ADVANCE(121);
      if (lookahead == 'i') ADVANCE(122);
      if (lookahead == 'o') ADVANCE(123);
      END_STATE();
    case 59:
      if (lookahead == 'b') ADVANCE(124);
      END_STATE();
    case 60:
      if (lookahead == 'a') ADVANCE(125);
      if (lookahead == 'q') ADVANCE(126);
      if (lookahead == 't') ADVANCE(127);
      END_STATE();
    case 61:
      if (lookahead == 't') ADVANCE(128);
      END_STATE();
    case 62:
      if (lookahead == 't') ADVANCE(129);
      END_STATE();
    case 63:
      if (lookahead == 'g') ADVANCE(130);
      END_STATE();
    case 64:
      if (lookahead == 'a') ADVANCE(131);
      if (lookahead == 'r') ADVANCE(132);
      END_STATE();
    case 65:
      if (lookahead == 'p') ADVANCE(133);
      END_STATE();
    case 66:
      if (lookahead == 'i') ADVANCE(134);
      END_STATE();
    case 67:
      if (lookahead == 'm') ADVANCE(135);
      END_STATE();
    case 68:
      if (lookahead == 'r') ADVANCE(136);
      END_STATE();
    case 69:
      if (lookahead == 'i') ADVANCE(137);
      if (lookahead == 'r') ADVANCE(138);
      END_STATE();
    case 70:
      if (lookahead == 'u') ADVANCE(139);
      if (lookahead == 'y') ADVANCE(140);
      END_STATE();
    case 71:
      if (lookahead == 'p') ADVANCE(141);
      END_STATE();
    case 72:
      if (lookahead == 'd') ADVANCE(142);
      if (lookahead == 'i') ADVANCE(143);
      if (lookahead == 'k') ADVANCE(144);
      END_STATE();
    case 73:
      if (lookahead == 'i') ADVANCE(145);
      END_STATE();
    case 74:
      if (lookahead == 'r') ADVANCE(146);
      END_STATE();
    case 75:
      if (lookahead == 'i') ADVANCE(147);
      END_STATE();
    case 76:
      if (lookahead == 'i') ADVANCE(148);
      END_STATE();
    case 77:
      if (lookahead == 't') ADVANCE(149);
      END_STATE();
    case 78:
      if (lookahead == 'e') ADVANCE(150);
      END_STATE();
    case 79:
      if (lookahead == 't') ADVANCE(151);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_any);
      END_STATE();
    case 81:
      if (lookahead == 'e') ADVANCE(152);
      END_STATE();
    case 82:
      if (lookahead == 'n') ADVANCE(153);
      END_STATE();
    case 83:
      if (lookahead == 'i') ADVANCE(154);
      END_STATE();
    case 84:
      if (lookahead == 'l') ADVANCE(155);
      END_STATE();
    case 85:
      if (lookahead == 'a') ADVANCE(156);
      END_STATE();
    case 86:
      if (lookahead == 'e') ADVANCE(157);
      END_STATE();
    case 87:
      if (lookahead == 'c') ADVANCE(158);
      END_STATE();
    case 88:
      if (lookahead == 's') ADVANCE(159);
      END_STATE();
    case 89:
      if (lookahead == 'p') ADVANCE(160);
      END_STATE();
    case 90:
      if (lookahead == 's') ADVANCE(161);
      if (lookahead == 't') ADVANCE(162);
      END_STATE();
    case 91:
      if (lookahead == 'u') ADVANCE(163);
      END_STATE();
    case 92:
      if (lookahead == 'l') ADVANCE(164);
      END_STATE();
    case 93:
      if (lookahead == 'a') ADVANCE(165);
      END_STATE();
    case 94:
      if (lookahead == 'e') ADVANCE(166);
      END_STATE();
    case 95:
      if (lookahead == 'e') ADVANCE(167);
      END_STATE();
    case 96:
      if (lookahead == 'm') ADVANCE(168);
      END_STATE();
    case 97:
      if (lookahead == 'o') ADVANCE(169);
      END_STATE();
    case 98:
      if (lookahead == 'e') ADVANCE(170);
      END_STATE();
    case 99:
      if (lookahead == 's') ADVANCE(171);
      END_STATE();
    case 100:
      if (lookahead == 'a') ADVANCE(172);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 102:
      if (lookahead == 'm') ADVANCE(173);
      END_STATE();
    case 103:
      if (lookahead == 'c') ADVANCE(174);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 105:
      if (lookahead == 'b') ADVANCE(175);
      END_STATE();
    case 106:
      if (lookahead == 'l') ADVANCE(176);
      if (lookahead == 'o') ADVANCE(177);
      END_STATE();
    case 107:
      if (lookahead == 'e') ADVANCE(178);
      END_STATE();
    case 108:
      if (lookahead == 't') ADVANCE(179);
      END_STATE();
    case 109:
      if (lookahead == 'e') ADVANCE(180);
      END_STATE();
    case 110:
      if (lookahead == 'o') ADVANCE(181);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 112:
      if (lookahead == 't') ADVANCE(182);
      END_STATE();
    case 113:
      if (lookahead == 'u') ADVANCE(183);
      END_STATE();
    case 114:
      if (lookahead == 'e') ADVANCE(184);
      END_STATE();
    case 115:
      if (lookahead == 'e') ADVANCE(185);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 117:
      if (lookahead == 'l') ADVANCE(186);
      END_STATE();
    case 118:
      if (lookahead == 'b') ADVANCE(187);
      END_STATE();
    case 119:
      if (lookahead == 'e') ADVANCE(188);
      END_STATE();
    case 120:
      if (lookahead == 'r') ADVANCE(189);
      END_STATE();
    case 121:
      if (lookahead == 'g') ADVANCE(190);
      END_STATE();
    case 122:
      if (lookahead == 'v') ADVANCE(191);
      END_STATE();
    case 123:
      if (lookahead == 'p') ADVANCE(192);
      if (lookahead == 't') ADVANCE(193);
      END_STATE();
    case 124:
      if (lookahead == 'l') ADVANCE(194);
      END_STATE();
    case 125:
      if (lookahead == 'd') ADVANCE(195);
      END_STATE();
    case 126:
      if (lookahead == 'u') ADVANCE(196);
      END_STATE();
    case 127:
      if (lookahead == 'u') ADVANCE(197);
      END_STATE();
    case 128:
      if (lookahead == 'i') ADVANCE(198);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 130:
      if (lookahead == 'n') ADVANCE(199);
      END_STATE();
    case 131:
      if (lookahead == 't') ADVANCE(200);
      END_STATE();
    case 132:
      if (lookahead == 'i') ADVANCE(201);
      END_STATE();
    case 133:
      if (lookahead == 'e') ADVANCE(202);
      END_STATE();
    case 134:
      if (lookahead == 't') ADVANCE(203);
      END_STATE();
    case 135:
      if (lookahead == 'b') ADVANCE(204);
      END_STATE();
    case 136:
      if (lookahead == 'g') ADVANCE(205);
      END_STATE();
    case 137:
      if (lookahead == 's') ADVANCE(206);
      END_STATE();
    case 138:
      if (lookahead == 'o') ADVANCE(207);
      END_STATE();
    case 139:
      if (lookahead == 'e') ADVANCE(208);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 141:
      if (lookahead == 'e') ADVANCE(209);
      END_STATE();
    case 142:
      if (lookahead == 'e') ADVANCE(210);
      END_STATE();
    case 143:
      if (lookahead == 'q') ADVANCE(211);
      END_STATE();
    case 144:
      if (lookahead == 'n') ADVANCE(212);
      END_STATE();
    case 145:
      if (lookahead == 'n') ADVANCE(213);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 147:
      if (lookahead == 'd') ADVANCE(214);
      END_STATE();
    case 148:
      if (lookahead == 'l') ADVANCE(215);
      END_STATE();
    case 149:
      if (lookahead == 'h') ADVANCE(216);
      END_STATE();
    case 150:
      if (lookahead == 'l') ADVANCE(217);
      END_STATE();
    case 151:
      if (lookahead == 'r') ADVANCE(218);
      END_STATE();
    case 152:
      if (lookahead == 'r') ADVANCE(219);
      END_STATE();
    case 153:
      if (lookahead == 'c') ADVANCE(220);
      END_STATE();
    case 154:
      if (lookahead == 't') ADVANCE(221);
      END_STATE();
    case 155:
      if (lookahead == 'e') ADVANCE(222);
      END_STATE();
    case 156:
      if (lookahead == 'k') ADVANCE(223);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 158:
      if (lookahead == 'h') ADVANCE(224);
      END_STATE();
    case 159:
      if (lookahead == 's') ADVANCE(225);
      END_STATE();
    case 160:
      if (lookahead == 'o') ADVANCE(226);
      END_STATE();
    case 161:
      if (lookahead == 't') ADVANCE(227);
      END_STATE();
    case 162:
      if (lookahead == 'i') ADVANCE(228);
      END_STATE();
    case 163:
      if (lookahead == 'g') ADVANCE(229);
      END_STATE();
    case 164:
      if (lookahead == 'a') ADVANCE(230);
      END_STATE();
    case 165:
      if (lookahead == 'u') ADVANCE(231);
      END_STATE();
    case 166:
      if (lookahead == 't') ADVANCE(232);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 169:
      if (lookahead == 'r') ADVANCE(233);
      END_STATE();
    case 170:
      if (lookahead == 'n') ADVANCE(234);
      END_STATE();
    case 171:
      if (lookahead == 'e') ADVANCE(235);
      END_STATE();
    case 172:
      if (lookahead == 'l') ADVANCE(236);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 174:
      if (lookahead == 't') ADVANCE(237);
      END_STATE();
    case 175:
      if (lookahead == 'a') ADVANCE(238);
      END_STATE();
    case 176:
      if (lookahead == 'e') ADVANCE(239);
      END_STATE();
    case 177:
      if (lookahead == 'r') ADVANCE(240);
      END_STATE();
    case 178:
      if (lookahead == 'r') ADVANCE(241);
      END_STATE();
    case 179:
      if (lookahead == 'a') ADVANCE(242);
      END_STATE();
    case 180:
      if (lookahead == 'r') ADVANCE(243);
      END_STATE();
    case 181:
      if (lookahead == 'f') ADVANCE(244);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_list);
      END_STATE();
    case 183:
      if (lookahead == 'l') ADVANCE(245);
      END_STATE();
    case 184:
      if (lookahead == 's') ADVANCE(246);
      END_STATE();
    case 185:
      if (lookahead == 'r') ADVANCE(247);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 187:
      if (lookahead == 'e') ADVANCE(248);
      END_STATE();
    case 188:
      if (lookahead == 'c') ADVANCE(249);
      END_STATE();
    case 189:
      if (lookahead == 'r') ADVANCE(250);
      END_STATE();
    case 190:
      if (lookahead == 'm') ADVANCE(251);
      END_STATE();
    case 191:
      if (lookahead == 'a') ADVANCE(252);
      END_STATE();
    case 192:
      if (lookahead == 'e') ADVANCE(253);
      END_STATE();
    case 193:
      if (lookahead == 'e') ADVANCE(254);
      END_STATE();
    case 194:
      if (lookahead == 'i') ADVANCE(255);
      END_STATE();
    case 195:
      if (lookahead == 'o') ADVANCE(256);
      END_STATE();
    case 196:
      if (lookahead == 'i') ADVANCE(257);
      END_STATE();
    case 197:
      if (lookahead == 'r') ADVANCE(258);
      END_STATE();
    case 198:
      if (lookahead == 's') ADVANCE(259);
      END_STATE();
    case 199:
      if (lookahead == 'a') ADVANCE(260);
      END_STATE();
    case 200:
      if (lookahead == 'i') ADVANCE(261);
      END_STATE();
    case 201:
      if (lookahead == 'n') ADVANCE(262);
      END_STATE();
    case 202:
      if (lookahead == 'r') ADVANCE(263);
      END_STATE();
    case 203:
      if (lookahead == 'c') ADVANCE(264);
      END_STATE();
    case 204:
      if (lookahead == 'o') ADVANCE(265);
      END_STATE();
    case 205:
      if (lookahead == 'e') ADVANCE(266);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 207:
      if (lookahead == 'w') ADVANCE(267);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_type);
      if (lookahead == 'o') ADVANCE(268);
      END_STATE();
    case 210:
      if (lookahead == 'f') ADVANCE(269);
      END_STATE();
    case 211:
      if (lookahead == 'u') ADVANCE(270);
      END_STATE();
    case 212:
      if (lookahead == 'o') ADVANCE(271);
      END_STATE();
    case 213:
      if (lookahead == 'g') ADVANCE(272);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 215:
      if (lookahead == 'e') ADVANCE(273);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 217:
      if (lookahead == 'd') ADVANCE(274);
      END_STATE();
    case 218:
      if (lookahead == 'a') ADVANCE(275);
      END_STATE();
    case 219:
      if (lookahead == 't') ADVANCE(276);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 222:
      if (lookahead == 'a') ADVANCE(277);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 226:
      if (lookahead == 'n') ADVANCE(278);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 228:
      if (lookahead == 'n') ADVANCE(279);
      END_STATE();
    case 229:
      if (lookahead == 'g') ADVANCE(280);
      END_STATE();
    case 230:
      if (lookahead == 'r') ADVANCE(281);
      END_STATE();
    case 231:
      if (lookahead == 'l') ADVANCE(282);
      END_STATE();
    case 232:
      if (lookahead == 'e') ADVANCE(283);
      END_STATE();
    case 233:
      if (lookahead == 't') ADVANCE(284);
      END_STATE();
    case 234:
      if (lookahead == 'd') ADVANCE(285);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 236:
      if (lookahead == 'l') ADVANCE(286);
      END_STATE();
    case 237:
      if (lookahead == 'i') ADVANCE(287);
      END_STATE();
    case 238:
      if (lookahead == 'l') ADVANCE(288);
      END_STATE();
    case 239:
      if (lookahead == 'm') ADVANCE(289);
      END_STATE();
    case 240:
      if (lookahead == 't') ADVANCE(290);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_infer);
      END_STATE();
    case 242:
      if (lookahead == 'n') ADVANCE(291);
      END_STATE();
    case 243:
      if (lookahead == 'f') ADVANCE(292);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(anon_sym_keyof);
      END_STATE();
    case 245:
      if (lookahead == 'e') ADVANCE(293);
      END_STATE();
    case 246:
      if (lookahead == 'p') ADVANCE(294);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(anon_sym_never);
      END_STATE();
    case 248:
      if (lookahead == 'r') ADVANCE(295);
      END_STATE();
    case 249:
      if (lookahead == 't') ADVANCE(296);
      END_STATE();
    case 250:
      if (lookahead == 'i') ADVANCE(297);
      END_STATE();
    case 251:
      if (lookahead == 'a') ADVANCE(298);
      END_STATE();
    case 252:
      if (lookahead == 't') ADVANCE(299);
      END_STATE();
    case 253:
      if (lookahead == 'r') ADVANCE(300);
      END_STATE();
    case 254:
      if (lookahead == 'c') ADVANCE(301);
      END_STATE();
    case 255:
      if (lookahead == 'c') ADVANCE(302);
      END_STATE();
    case 256:
      if (lookahead == 'n') ADVANCE(303);
      END_STATE();
    case 257:
      if (lookahead == 'r') ADVANCE(304);
      END_STATE();
    case 258:
      if (lookahead == 'n') ADVANCE(305);
      END_STATE();
    case 259:
      if (lookahead == 'f') ADVANCE(306);
      END_STATE();
    case 260:
      if (lookahead == 'l') ADVANCE(307);
      END_STATE();
    case 261:
      if (lookahead == 'c') ADVANCE(308);
      END_STATE();
    case 262:
      if (lookahead == 'g') ADVANCE(309);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 264:
      if (lookahead == 'h') ADVANCE(310);
      END_STATE();
    case 265:
      if (lookahead == 'l') ADVANCE(311);
      END_STATE();
    case 266:
      if (lookahead == 't') ADVANCE(312);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 268:
      if (lookahead == 'f') ADVANCE(313);
      END_STATE();
    case 269:
      if (lookahead == 'i') ADVANCE(314);
      END_STATE();
    case 270:
      if (lookahead == 'e') ADVANCE(315);
      END_STATE();
    case 271:
      if (lookahead == 'w') ADVANCE(316);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(anon_sym_using);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 275:
      if (lookahead == 'c') ADVANCE(317);
      END_STATE();
    case 276:
      if (lookahead == 's') ADVANCE(318);
      END_STATE();
    case 277:
      if (lookahead == 'n') ADVANCE(319);
      END_STATE();
    case 278:
      if (lookahead == 'e') ADVANCE(320);
      END_STATE();
    case 279:
      if (lookahead == 'u') ADVANCE(321);
      END_STATE();
    case 280:
      if (lookahead == 'e') ADVANCE(322);
      END_STATE();
    case 281:
      if (lookahead == 'e') ADVANCE(323);
      END_STATE();
    case 282:
      if (lookahead == 't') ADVANCE(324);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 285:
      if (lookahead == 's') ADVANCE(325);
      END_STATE();
    case 286:
      if (lookahead == 'y') ADVANCE(326);
      END_STATE();
    case 287:
      if (lookahead == 'o') ADVANCE(327);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 289:
      if (lookahead == 'e') ADVANCE(328);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 291:
      if (lookahead == 'c') ADVANCE(329);
      END_STATE();
    case 292:
      if (lookahead == 'a') ADVANCE(330);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 294:
      if (lookahead == 'a') ADVANCE(331);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_number);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(anon_sym_object);
      END_STATE();
    case 297:
      if (lookahead == 'd') ADVANCE(332);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(anon_sym_pragma);
      END_STATE();
    case 299:
      if (lookahead == 'e') ADVANCE(333);
      END_STATE();
    case 300:
      if (lookahead == 't') ADVANCE(334);
      END_STATE();
    case 301:
      if (lookahead == 't') ADVANCE(335);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 303:
      if (lookahead == 'l') ADVANCE(336);
      END_STATE();
    case 304:
      if (lookahead == 'e') ADVANCE(337);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 306:
      if (lookahead == 'i') ADVANCE(338);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(anon_sym_signal);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 309:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(anon_sym_symbol);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(anon_sym_target);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(anon_sym_typeof);
      END_STATE();
    case 314:
      if (lookahead == 'n') ADVANCE(339);
      END_STATE();
    case 315:
      ACCEPT_TOKEN(anon_sym_unique);
      END_STATE();
    case 316:
      if (lookahead == 'n') ADVANCE(340);
      END_STATE();
    case 317:
      if (lookahead == 't') ADVANCE(341);
      END_STATE();
    case 318:
      ACCEPT_TOKEN(anon_sym_asserts);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(anon_sym_boolean);
      END_STATE();
    case 320:
      if (lookahead == 'n') ADVANCE(342);
      END_STATE();
    case 321:
      if (lookahead == 'e') ADVANCE(343);
      END_STATE();
    case 322:
      if (lookahead == 'r') ADVANCE(344);
      END_STATE();
    case 323:
      ACCEPT_TOKEN(anon_sym_declare);
      END_STATE();
    case 324:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 325:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 326:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 327:
      if (lookahead == 'n') ADVANCE(345);
      END_STATE();
    case 328:
      if (lookahead == 'n') ADVANCE(346);
      END_STATE();
    case 329:
      if (lookahead == 'e') ADVANCE(347);
      END_STATE();
    case 330:
      if (lookahead == 'c') ADVANCE(348);
      END_STATE();
    case 331:
      if (lookahead == 'c') ADVANCE(349);
      END_STATE();
    case 332:
      if (lookahead == 'e') ADVANCE(350);
      END_STATE();
    case 333:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 334:
      if (lookahead == 'y') ADVANCE(351);
      END_STATE();
    case 335:
      if (lookahead == 'e') ADVANCE(352);
      END_STATE();
    case 336:
      if (lookahead == 'y') ADVANCE(353);
      END_STATE();
    case 337:
      ACCEPT_TOKEN(anon_sym_require);
      if (lookahead == 'd') ADVANCE(354);
      END_STATE();
    case 338:
      if (lookahead == 'e') ADVANCE(355);
      END_STATE();
    case 339:
      if (lookahead == 'e') ADVANCE(356);
      END_STATE();
    case 340:
      ACCEPT_TOKEN(anon_sym_unknown);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 342:
      if (lookahead == 't') ADVANCE(357);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 344:
      ACCEPT_TOKEN(anon_sym_debugger);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 346:
      if (lookahead == 't') ADVANCE(358);
      END_STATE();
    case 347:
      if (lookahead == 'o') ADVANCE(359);
      END_STATE();
    case 348:
      if (lookahead == 'e') ADVANCE(360);
      END_STATE();
    case 349:
      if (lookahead == 'e') ADVANCE(361);
      END_STATE();
    case 350:
      ACCEPT_TOKEN(anon_sym_override);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(anon_sym_property);
      END_STATE();
    case 352:
      if (lookahead == 'd') ADVANCE(362);
      END_STATE();
    case 353:
      ACCEPT_TOKEN(anon_sym_readonly);
      END_STATE();
    case 354:
      ACCEPT_TOKEN(anon_sym_required);
      END_STATE();
    case 355:
      if (lookahead == 's') ADVANCE(363);
      END_STATE();
    case 356:
      if (lookahead == 'd') ADVANCE(364);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(anon_sym_component);
      END_STATE();
    case 358:
      if (lookahead == 's') ADVANCE(365);
      END_STATE();
    case 359:
      if (lookahead == 'f') ADVANCE(366);
      END_STATE();
    case 360:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 362:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 363:
      ACCEPT_TOKEN(anon_sym_satisfies);
      END_STATE();
    case 364:
      ACCEPT_TOKEN(sym_undefined);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(anon_sym_implements);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(anon_sym_instanceof);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 95, .external_lex_state = 2},
  [2] = {.lex_state = 95, .external_lex_state = 3},
  [3] = {.lex_state = 95, .external_lex_state = 3},
  [4] = {.lex_state = 11, .external_lex_state = 2},
  [5] = {.lex_state = 11, .external_lex_state = 2},
  [6] = {.lex_state = 11, .external_lex_state = 2},
  [7] = {.lex_state = 11, .external_lex_state = 2},
  [8] = {.lex_state = 11, .external_lex_state = 2},
  [9] = {.lex_state = 11, .external_lex_state = 2},
  [10] = {.lex_state = 11, .external_lex_state = 2},
  [11] = {.lex_state = 11, .external_lex_state = 2},
  [12] = {.lex_state = 11, .external_lex_state = 2},
  [13] = {.lex_state = 11, .external_lex_state = 2},
  [14] = {.lex_state = 11, .external_lex_state = 2},
  [15] = {.lex_state = 11, .external_lex_state = 2},
  [16] = {.lex_state = 11, .external_lex_state = 2},
  [17] = {.lex_state = 11, .external_lex_state = 2},
  [18] = {.lex_state = 11, .external_lex_state = 2},
  [19] = {.lex_state = 11, .external_lex_state = 2},
  [20] = {.lex_state = 11, .external_lex_state = 2},
  [21] = {.lex_state = 11, .external_lex_state = 2},
  [22] = {.lex_state = 11, .external_lex_state = 2},
  [23] = {.lex_state = 11, .external_lex_state = 2},
  [24] = {.lex_state = 11, .external_lex_state = 2},
  [25] = {.lex_state = 11, .external_lex_state = 2},
  [26] = {.lex_state = 11, .external_lex_state = 2},
  [27] = {.lex_state = 11, .external_lex_state = 2},
  [28] = {.lex_state = 11, .external_lex_state = 2},
  [29] = {.lex_state = 11, .external_lex_state = 2},
  [30] = {.lex_state = 11, .external_lex_state = 2},
  [31] = {.lex_state = 11, .external_lex_state = 2},
  [32] = {.lex_state = 11, .external_lex_state = 2},
  [33] = {.lex_state = 11, .external_lex_state = 2},
  [34] = {.lex_state = 11, .external_lex_state = 2},
  [35] = {.lex_state = 11, .external_lex_state = 2},
  [36] = {.lex_state = 11, .external_lex_state = 2},
  [37] = {.lex_state = 11, .external_lex_state = 2},
  [38] = {.lex_state = 11, .external_lex_state = 2},
  [39] = {.lex_state = 11, .external_lex_state = 2},
  [40] = {.lex_state = 11, .external_lex_state = 2},
  [41] = {.lex_state = 11, .external_lex_state = 2},
  [42] = {.lex_state = 11, .external_lex_state = 2},
  [43] = {.lex_state = 11, .external_lex_state = 2},
  [44] = {.lex_state = 11, .external_lex_state = 2},
  [45] = {.lex_state = 11, .external_lex_state = 2},
  [46] = {.lex_state = 11, .external_lex_state = 2},
  [47] = {.lex_state = 11, .external_lex_state = 2},
  [48] = {.lex_state = 11, .external_lex_state = 2},
  [49] = {.lex_state = 11, .external_lex_state = 2},
  [50] = {.lex_state = 11, .external_lex_state = 2},
  [51] = {.lex_state = 11, .external_lex_state = 2},
  [52] = {.lex_state = 11, .external_lex_state = 2},
  [53] = {.lex_state = 11, .external_lex_state = 2},
  [54] = {.lex_state = 11, .external_lex_state = 2},
  [55] = {.lex_state = 11, .external_lex_state = 2},
  [56] = {.lex_state = 11, .external_lex_state = 2},
  [57] = {.lex_state = 11, .external_lex_state = 2},
  [58] = {.lex_state = 11, .external_lex_state = 2},
  [59] = {.lex_state = 11, .external_lex_state = 2},
  [60] = {.lex_state = 11, .external_lex_state = 2},
  [61] = {.lex_state = 12, .external_lex_state = 2},
  [62] = {.lex_state = 12, .external_lex_state = 2},
  [63] = {.lex_state = 12, .external_lex_state = 2},
  [64] = {.lex_state = 3, .external_lex_state = 4},
  [65] = {.lex_state = 3, .external_lex_state = 4},
  [66] = {.lex_state = 12, .external_lex_state = 2},
  [67] = {.lex_state = 3, .external_lex_state = 4},
  [68] = {.lex_state = 12, .external_lex_state = 2},
  [69] = {.lex_state = 12, .external_lex_state = 2},
  [70] = {.lex_state = 12, .external_lex_state = 2},
  [71] = {.lex_state = 3, .external_lex_state = 4},
  [72] = {.lex_state = 12, .external_lex_state = 2},
  [73] = {.lex_state = 12, .external_lex_state = 2},
  [74] = {.lex_state = 12, .external_lex_state = 2},
  [75] = {.lex_state = 3, .external_lex_state = 3},
  [76] = {.lex_state = 3, .external_lex_state = 3},
  [77] = {.lex_state = 3, .external_lex_state = 3},
  [78] = {.lex_state = 3, .external_lex_state = 3},
  [79] = {.lex_state = 3, .external_lex_state = 3},
  [80] = {.lex_state = 3, .external_lex_state = 3},
  [81] = {.lex_state = 3, .external_lex_state = 3},
  [82] = {.lex_state = 3, .external_lex_state = 3},
  [83] = {.lex_state = 3, .external_lex_state = 3},
  [84] = {.lex_state = 3, .external_lex_state = 3},
  [85] = {.lex_state = 3, .external_lex_state = 3},
  [86] = {.lex_state = 3, .external_lex_state = 3},
  [87] = {.lex_state = 3, .external_lex_state = 3},
  [88] = {.lex_state = 3, .external_lex_state = 3},
  [89] = {.lex_state = 3, .external_lex_state = 3},
  [90] = {.lex_state = 12, .external_lex_state = 2},
  [91] = {.lex_state = 12, .external_lex_state = 2},
  [92] = {.lex_state = 12, .external_lex_state = 2},
  [93] = {.lex_state = 3, .external_lex_state = 4},
  [94] = {.lex_state = 3, .external_lex_state = 4},
  [95] = {.lex_state = 12, .external_lex_state = 2},
  [96] = {.lex_state = 3, .external_lex_state = 4},
  [97] = {.lex_state = 12, .external_lex_state = 2},
  [98] = {.lex_state = 12, .external_lex_state = 2},
  [99] = {.lex_state = 12, .external_lex_state = 2},
  [100] = {.lex_state = 3, .external_lex_state = 4},
  [101] = {.lex_state = 3, .external_lex_state = 4},
  [102] = {.lex_state = 3, .external_lex_state = 4},
  [103] = {.lex_state = 3, .external_lex_state = 4},
  [104] = {.lex_state = 12, .external_lex_state = 2},
  [105] = {.lex_state = 3, .external_lex_state = 3},
  [106] = {.lex_state = 3, .external_lex_state = 4},
  [107] = {.lex_state = 3, .external_lex_state = 4},
  [108] = {.lex_state = 3, .external_lex_state = 3},
  [109] = {.lex_state = 3, .external_lex_state = 3},
  [110] = {.lex_state = 3, .external_lex_state = 4},
  [111] = {.lex_state = 3, .external_lex_state = 4},
  [112] = {.lex_state = 3, .external_lex_state = 3},
  [113] = {.lex_state = 3, .external_lex_state = 4},
  [114] = {.lex_state = 3, .external_lex_state = 3},
  [115] = {.lex_state = 3, .external_lex_state = 3},
  [116] = {.lex_state = 3, .external_lex_state = 4},
  [117] = {.lex_state = 3, .external_lex_state = 3},
  [118] = {.lex_state = 3, .external_lex_state = 3},
  [119] = {.lex_state = 3, .external_lex_state = 3},
  [120] = {.lex_state = 3, .external_lex_state = 4},
  [121] = {.lex_state = 3, .external_lex_state = 3},
  [122] = {.lex_state = 3, .external_lex_state = 3},
  [123] = {.lex_state = 3, .external_lex_state = 3},
  [124] = {.lex_state = 3, .external_lex_state = 3},
  [125] = {.lex_state = 3, .external_lex_state = 3},
  [126] = {.lex_state = 3, .external_lex_state = 3},
  [127] = {.lex_state = 3, .external_lex_state = 3},
  [128] = {.lex_state = 3, .external_lex_state = 3},
  [129] = {.lex_state = 3, .external_lex_state = 3},
  [130] = {.lex_state = 3, .external_lex_state = 3},
  [131] = {.lex_state = 3, .external_lex_state = 3},
  [132] = {.lex_state = 3, .external_lex_state = 3},
  [133] = {.lex_state = 3, .external_lex_state = 3},
  [134] = {.lex_state = 3, .external_lex_state = 3},
  [135] = {.lex_state = 12, .external_lex_state = 2},
  [136] = {.lex_state = 3, .external_lex_state = 3},
  [137] = {.lex_state = 3, .external_lex_state = 3},
  [138] = {.lex_state = 3, .external_lex_state = 3},
  [139] = {.lex_state = 3, .external_lex_state = 3},
  [140] = {.lex_state = 3, .external_lex_state = 3},
  [141] = {.lex_state = 3, .external_lex_state = 3},
  [142] = {.lex_state = 3, .external_lex_state = 3},
  [143] = {.lex_state = 3, .external_lex_state = 3},
  [144] = {.lex_state = 3, .external_lex_state = 3},
  [145] = {.lex_state = 3, .external_lex_state = 3},
  [146] = {.lex_state = 3, .external_lex_state = 3},
  [147] = {.lex_state = 12, .external_lex_state = 2},
  [148] = {.lex_state = 12, .external_lex_state = 2},
  [149] = {.lex_state = 12, .external_lex_state = 2},
  [150] = {.lex_state = 12, .external_lex_state = 2},
  [151] = {.lex_state = 12, .external_lex_state = 2},
  [152] = {.lex_state = 12, .external_lex_state = 2},
  [153] = {.lex_state = 12, .external_lex_state = 2},
  [154] = {.lex_state = 12, .external_lex_state = 2},
  [155] = {.lex_state = 12, .external_lex_state = 2},
  [156] = {.lex_state = 12, .external_lex_state = 2},
  [157] = {.lex_state = 12, .external_lex_state = 2},
  [158] = {.lex_state = 12, .external_lex_state = 2},
  [159] = {.lex_state = 5, .external_lex_state = 3},
  [160] = {.lex_state = 5, .external_lex_state = 4},
  [161] = {.lex_state = 5, .external_lex_state = 4},
  [162] = {.lex_state = 5, .external_lex_state = 4},
  [163] = {.lex_state = 5, .external_lex_state = 3},
  [164] = {.lex_state = 5, .external_lex_state = 3},
  [165] = {.lex_state = 5, .external_lex_state = 3},
  [166] = {.lex_state = 5, .external_lex_state = 3},
  [167] = {.lex_state = 5, .external_lex_state = 3},
  [168] = {.lex_state = 11, .external_lex_state = 2},
  [169] = {.lex_state = 11, .external_lex_state = 2},
  [170] = {.lex_state = 11, .external_lex_state = 2},
  [171] = {.lex_state = 11, .external_lex_state = 2},
  [172] = {.lex_state = 11, .external_lex_state = 2},
  [173] = {.lex_state = 11, .external_lex_state = 2},
  [174] = {.lex_state = 11, .external_lex_state = 2},
  [175] = {.lex_state = 11, .external_lex_state = 2},
  [176] = {.lex_state = 11, .external_lex_state = 2},
  [177] = {.lex_state = 11, .external_lex_state = 2},
  [178] = {.lex_state = 11, .external_lex_state = 2},
  [179] = {.lex_state = 11, .external_lex_state = 2},
  [180] = {.lex_state = 11, .external_lex_state = 2},
  [181] = {.lex_state = 11, .external_lex_state = 2},
  [182] = {.lex_state = 11, .external_lex_state = 2},
  [183] = {.lex_state = 11, .external_lex_state = 2},
  [184] = {.lex_state = 11, .external_lex_state = 2},
  [185] = {.lex_state = 11, .external_lex_state = 2},
  [186] = {.lex_state = 11, .external_lex_state = 2},
  [187] = {.lex_state = 11, .external_lex_state = 2},
  [188] = {.lex_state = 11, .external_lex_state = 2},
  [189] = {.lex_state = 11, .external_lex_state = 2},
  [190] = {.lex_state = 11, .external_lex_state = 2},
  [191] = {.lex_state = 11, .external_lex_state = 2},
  [192] = {.lex_state = 11, .external_lex_state = 2},
  [193] = {.lex_state = 11, .external_lex_state = 2},
  [194] = {.lex_state = 11, .external_lex_state = 2},
  [195] = {.lex_state = 11, .external_lex_state = 2},
  [196] = {.lex_state = 11, .external_lex_state = 2},
  [197] = {.lex_state = 11, .external_lex_state = 2},
  [198] = {.lex_state = 11, .external_lex_state = 2},
  [199] = {.lex_state = 11, .external_lex_state = 2},
  [200] = {.lex_state = 11, .external_lex_state = 2},
  [201] = {.lex_state = 11, .external_lex_state = 2},
  [202] = {.lex_state = 11, .external_lex_state = 2},
  [203] = {.lex_state = 11, .external_lex_state = 2},
  [204] = {.lex_state = 11, .external_lex_state = 2},
  [205] = {.lex_state = 11, .external_lex_state = 2},
  [206] = {.lex_state = 11, .external_lex_state = 2},
  [207] = {.lex_state = 11, .external_lex_state = 2},
  [208] = {.lex_state = 11, .external_lex_state = 2},
  [209] = {.lex_state = 11, .external_lex_state = 2},
  [210] = {.lex_state = 11, .external_lex_state = 2},
  [211] = {.lex_state = 11, .external_lex_state = 5},
  [212] = {.lex_state = 11, .external_lex_state = 2},
  [213] = {.lex_state = 4, .external_lex_state = 3},
  [214] = {.lex_state = 11, .external_lex_state = 2},
  [215] = {.lex_state = 11, .external_lex_state = 2},
  [216] = {.lex_state = 11, .external_lex_state = 2},
  [217] = {.lex_state = 11, .external_lex_state = 2},
  [218] = {.lex_state = 4, .external_lex_state = 4},
  [219] = {.lex_state = 5, .external_lex_state = 4},
  [220] = {.lex_state = 11, .external_lex_state = 2},
  [221] = {.lex_state = 11, .external_lex_state = 2},
  [222] = {.lex_state = 11, .external_lex_state = 2},
  [223] = {.lex_state = 11, .external_lex_state = 2},
  [224] = {.lex_state = 4, .external_lex_state = 4},
  [225] = {.lex_state = 5, .external_lex_state = 4},
  [226] = {.lex_state = 5, .external_lex_state = 4},
  [227] = {.lex_state = 5, .external_lex_state = 4},
  [228] = {.lex_state = 5, .external_lex_state = 4},
  [229] = {.lex_state = 5, .external_lex_state = 4},
  [230] = {.lex_state = 4, .external_lex_state = 3},
  [231] = {.lex_state = 5, .external_lex_state = 4},
  [232] = {.lex_state = 5, .external_lex_state = 4},
  [233] = {.lex_state = 5, .external_lex_state = 4},
  [234] = {.lex_state = 5, .external_lex_state = 4},
  [235] = {.lex_state = 5, .external_lex_state = 4},
  [236] = {.lex_state = 5, .external_lex_state = 4},
  [237] = {.lex_state = 4, .external_lex_state = 3},
  [238] = {.lex_state = 5, .external_lex_state = 4},
  [239] = {.lex_state = 5, .external_lex_state = 4},
  [240] = {.lex_state = 5, .external_lex_state = 4},
  [241] = {.lex_state = 5, .external_lex_state = 4},
  [242] = {.lex_state = 5, .external_lex_state = 4},
  [243] = {.lex_state = 5, .external_lex_state = 4},
  [244] = {.lex_state = 5, .external_lex_state = 4},
  [245] = {.lex_state = 5, .external_lex_state = 4},
  [246] = {.lex_state = 5, .external_lex_state = 4},
  [247] = {.lex_state = 11, .external_lex_state = 2},
  [248] = {.lex_state = 5, .external_lex_state = 4},
  [249] = {.lex_state = 5, .external_lex_state = 4},
  [250] = {.lex_state = 5, .external_lex_state = 4},
  [251] = {.lex_state = 5, .external_lex_state = 4},
  [252] = {.lex_state = 5, .external_lex_state = 4},
  [253] = {.lex_state = 5, .external_lex_state = 4},
  [254] = {.lex_state = 5, .external_lex_state = 4},
  [255] = {.lex_state = 5, .external_lex_state = 4},
  [256] = {.lex_state = 4, .external_lex_state = 3},
  [257] = {.lex_state = 11, .external_lex_state = 2},
  [258] = {.lex_state = 11, .external_lex_state = 2},
  [259] = {.lex_state = 11, .external_lex_state = 2},
  [260] = {.lex_state = 11, .external_lex_state = 2},
  [261] = {.lex_state = 11, .external_lex_state = 2},
  [262] = {.lex_state = 11, .external_lex_state = 2},
  [263] = {.lex_state = 11, .external_lex_state = 2},
  [264] = {.lex_state = 11, .external_lex_state = 2},
  [265] = {.lex_state = 11, .external_lex_state = 2},
  [266] = {.lex_state = 4, .external_lex_state = 3},
  [267] = {.lex_state = 11, .external_lex_state = 2},
  [268] = {.lex_state = 11, .external_lex_state = 2},
  [269] = {.lex_state = 4, .external_lex_state = 4},
  [270] = {.lex_state = 11, .external_lex_state = 2},
  [271] = {.lex_state = 11, .external_lex_state = 2},
  [272] = {.lex_state = 11, .external_lex_state = 2},
  [273] = {.lex_state = 11, .external_lex_state = 2},
  [274] = {.lex_state = 11, .external_lex_state = 2},
  [275] = {.lex_state = 4, .external_lex_state = 3},
  [276] = {.lex_state = 11, .external_lex_state = 2},
  [277] = {.lex_state = 11, .external_lex_state = 2},
  [278] = {.lex_state = 11, .external_lex_state = 2},
  [279] = {.lex_state = 4, .external_lex_state = 3},
  [280] = {.lex_state = 11, .external_lex_state = 2},
  [281] = {.lex_state = 4, .external_lex_state = 3},
  [282] = {.lex_state = 11, .external_lex_state = 2},
  [283] = {.lex_state = 11, .external_lex_state = 2},
  [284] = {.lex_state = 11, .external_lex_state = 2},
  [285] = {.lex_state = 4, .external_lex_state = 3},
  [286] = {.lex_state = 11, .external_lex_state = 2},
  [287] = {.lex_state = 11, .external_lex_state = 2},
  [288] = {.lex_state = 11, .external_lex_state = 2},
  [289] = {.lex_state = 11, .external_lex_state = 2},
  [290] = {.lex_state = 11, .external_lex_state = 2},
  [291] = {.lex_state = 11, .external_lex_state = 2},
  [292] = {.lex_state = 11, .external_lex_state = 2},
  [293] = {.lex_state = 11, .external_lex_state = 2},
  [294] = {.lex_state = 11, .external_lex_state = 2},
  [295] = {.lex_state = 11, .external_lex_state = 2},
  [296] = {.lex_state = 11, .external_lex_state = 2},
  [297] = {.lex_state = 11, .external_lex_state = 2},
  [298] = {.lex_state = 4, .external_lex_state = 3},
  [299] = {.lex_state = 11, .external_lex_state = 2},
  [300] = {.lex_state = 11, .external_lex_state = 2},
  [301] = {.lex_state = 3, .external_lex_state = 3},
  [302] = {.lex_state = 3, .external_lex_state = 3},
  [303] = {.lex_state = 3, .external_lex_state = 3},
  [304] = {.lex_state = 3, .external_lex_state = 3},
  [305] = {.lex_state = 11, .external_lex_state = 5},
  [306] = {.lex_state = 11, .external_lex_state = 2},
  [307] = {.lex_state = 11, .external_lex_state = 2},
  [308] = {.lex_state = 11, .external_lex_state = 2},
  [309] = {.lex_state = 4, .external_lex_state = 3},
  [310] = {.lex_state = 11, .external_lex_state = 2},
  [311] = {.lex_state = 11, .external_lex_state = 5},
  [312] = {.lex_state = 11, .external_lex_state = 2},
  [313] = {.lex_state = 11, .external_lex_state = 2},
  [314] = {.lex_state = 11, .external_lex_state = 2},
  [315] = {.lex_state = 11, .external_lex_state = 2},
  [316] = {.lex_state = 11, .external_lex_state = 2},
  [317] = {.lex_state = 11, .external_lex_state = 2},
  [318] = {.lex_state = 11, .external_lex_state = 2},
  [319] = {.lex_state = 11, .external_lex_state = 2},
  [320] = {.lex_state = 11, .external_lex_state = 2},
  [321] = {.lex_state = 11, .external_lex_state = 2},
  [322] = {.lex_state = 11, .external_lex_state = 2},
  [323] = {.lex_state = 11, .external_lex_state = 2},
  [324] = {.lex_state = 11, .external_lex_state = 2},
  [325] = {.lex_state = 11, .external_lex_state = 2},
  [326] = {.lex_state = 11, .external_lex_state = 2},
  [327] = {.lex_state = 11, .external_lex_state = 2},
  [328] = {.lex_state = 11, .external_lex_state = 2},
  [329] = {.lex_state = 11, .external_lex_state = 2},
  [330] = {.lex_state = 11, .external_lex_state = 2},
  [331] = {.lex_state = 11, .external_lex_state = 2},
  [332] = {.lex_state = 11, .external_lex_state = 2},
  [333] = {.lex_state = 11, .external_lex_state = 2},
  [334] = {.lex_state = 11, .external_lex_state = 2},
  [335] = {.lex_state = 11, .external_lex_state = 2},
  [336] = {.lex_state = 11, .external_lex_state = 2},
  [337] = {.lex_state = 11, .external_lex_state = 2},
  [338] = {.lex_state = 11, .external_lex_state = 2},
  [339] = {.lex_state = 11, .external_lex_state = 2},
  [340] = {.lex_state = 11, .external_lex_state = 2},
  [341] = {.lex_state = 11, .external_lex_state = 2},
  [342] = {.lex_state = 11, .external_lex_state = 2},
  [343] = {.lex_state = 11, .external_lex_state = 2},
  [344] = {.lex_state = 11, .external_lex_state = 2},
  [345] = {.lex_state = 11, .external_lex_state = 2},
  [346] = {.lex_state = 11, .external_lex_state = 2},
  [347] = {.lex_state = 11, .external_lex_state = 2},
  [348] = {.lex_state = 11, .external_lex_state = 2},
  [349] = {.lex_state = 11, .external_lex_state = 2},
  [350] = {.lex_state = 11, .external_lex_state = 2},
  [351] = {.lex_state = 11, .external_lex_state = 2},
  [352] = {.lex_state = 11, .external_lex_state = 2},
  [353] = {.lex_state = 11, .external_lex_state = 2},
  [354] = {.lex_state = 11, .external_lex_state = 2},
  [355] = {.lex_state = 11, .external_lex_state = 2},
  [356] = {.lex_state = 11, .external_lex_state = 2},
  [357] = {.lex_state = 11, .external_lex_state = 2},
  [358] = {.lex_state = 11, .external_lex_state = 2},
  [359] = {.lex_state = 11, .external_lex_state = 2},
  [360] = {.lex_state = 11, .external_lex_state = 2},
  [361] = {.lex_state = 11, .external_lex_state = 2},
  [362] = {.lex_state = 11, .external_lex_state = 2},
  [363] = {.lex_state = 11, .external_lex_state = 2},
  [364] = {.lex_state = 11, .external_lex_state = 2},
  [365] = {.lex_state = 11, .external_lex_state = 2},
  [366] = {.lex_state = 11, .external_lex_state = 2},
  [367] = {.lex_state = 11, .external_lex_state = 2},
  [368] = {.lex_state = 11, .external_lex_state = 2},
  [369] = {.lex_state = 11, .external_lex_state = 2},
  [370] = {.lex_state = 11, .external_lex_state = 2},
  [371] = {.lex_state = 11, .external_lex_state = 2},
  [372] = {.lex_state = 11, .external_lex_state = 2},
  [373] = {.lex_state = 11, .external_lex_state = 2},
  [374] = {.lex_state = 11, .external_lex_state = 2},
  [375] = {.lex_state = 11, .external_lex_state = 2},
  [376] = {.lex_state = 11, .external_lex_state = 2},
  [377] = {.lex_state = 11, .external_lex_state = 2},
  [378] = {.lex_state = 11, .external_lex_state = 2},
  [379] = {.lex_state = 11, .external_lex_state = 2},
  [380] = {.lex_state = 11, .external_lex_state = 2},
  [381] = {.lex_state = 11, .external_lex_state = 2},
  [382] = {.lex_state = 11, .external_lex_state = 2},
  [383] = {.lex_state = 11, .external_lex_state = 2},
  [384] = {.lex_state = 11, .external_lex_state = 2},
  [385] = {.lex_state = 11, .external_lex_state = 2},
  [386] = {.lex_state = 11, .external_lex_state = 2},
  [387] = {.lex_state = 11, .external_lex_state = 2},
  [388] = {.lex_state = 11, .external_lex_state = 2},
  [389] = {.lex_state = 11, .external_lex_state = 2},
  [390] = {.lex_state = 11, .external_lex_state = 2},
  [391] = {.lex_state = 11, .external_lex_state = 2},
  [392] = {.lex_state = 11, .external_lex_state = 2},
  [393] = {.lex_state = 11, .external_lex_state = 2},
  [394] = {.lex_state = 11, .external_lex_state = 2},
  [395] = {.lex_state = 11, .external_lex_state = 2},
  [396] = {.lex_state = 11, .external_lex_state = 2},
  [397] = {.lex_state = 11, .external_lex_state = 2},
  [398] = {.lex_state = 11, .external_lex_state = 2},
  [399] = {.lex_state = 11, .external_lex_state = 2},
  [400] = {.lex_state = 11, .external_lex_state = 2},
  [401] = {.lex_state = 11, .external_lex_state = 2},
  [402] = {.lex_state = 11, .external_lex_state = 2},
  [403] = {.lex_state = 11, .external_lex_state = 2},
  [404] = {.lex_state = 11, .external_lex_state = 2},
  [405] = {.lex_state = 11, .external_lex_state = 2},
  [406] = {.lex_state = 11, .external_lex_state = 2},
  [407] = {.lex_state = 11, .external_lex_state = 2},
  [408] = {.lex_state = 11, .external_lex_state = 2},
  [409] = {.lex_state = 11, .external_lex_state = 2},
  [410] = {.lex_state = 11, .external_lex_state = 2},
  [411] = {.lex_state = 11, .external_lex_state = 2},
  [412] = {.lex_state = 11, .external_lex_state = 2},
  [413] = {.lex_state = 11, .external_lex_state = 2},
  [414] = {.lex_state = 11, .external_lex_state = 2},
  [415] = {.lex_state = 11, .external_lex_state = 2},
  [416] = {.lex_state = 11, .external_lex_state = 2},
  [417] = {.lex_state = 11, .external_lex_state = 2},
  [418] = {.lex_state = 11, .external_lex_state = 2},
  [419] = {.lex_state = 11, .external_lex_state = 2},
  [420] = {.lex_state = 11, .external_lex_state = 2},
  [421] = {.lex_state = 11, .external_lex_state = 2},
  [422] = {.lex_state = 11, .external_lex_state = 2},
  [423] = {.lex_state = 11, .external_lex_state = 2},
  [424] = {.lex_state = 11, .external_lex_state = 2},
  [425] = {.lex_state = 11, .external_lex_state = 2},
  [426] = {.lex_state = 11, .external_lex_state = 2},
  [427] = {.lex_state = 11, .external_lex_state = 2},
  [428] = {.lex_state = 11, .external_lex_state = 2},
  [429] = {.lex_state = 11, .external_lex_state = 2},
  [430] = {.lex_state = 11, .external_lex_state = 2},
  [431] = {.lex_state = 11, .external_lex_state = 2},
  [432] = {.lex_state = 11, .external_lex_state = 2},
  [433] = {.lex_state = 11, .external_lex_state = 2},
  [434] = {.lex_state = 11, .external_lex_state = 2},
  [435] = {.lex_state = 11, .external_lex_state = 2},
  [436] = {.lex_state = 11, .external_lex_state = 2},
  [437] = {.lex_state = 11, .external_lex_state = 2},
  [438] = {.lex_state = 11, .external_lex_state = 2},
  [439] = {.lex_state = 11, .external_lex_state = 2},
  [440] = {.lex_state = 11, .external_lex_state = 2},
  [441] = {.lex_state = 11, .external_lex_state = 2},
  [442] = {.lex_state = 11, .external_lex_state = 2},
  [443] = {.lex_state = 11, .external_lex_state = 2},
  [444] = {.lex_state = 11, .external_lex_state = 2},
  [445] = {.lex_state = 11, .external_lex_state = 2},
  [446] = {.lex_state = 11, .external_lex_state = 2},
  [447] = {.lex_state = 11, .external_lex_state = 2},
  [448] = {.lex_state = 11, .external_lex_state = 2},
  [449] = {.lex_state = 11, .external_lex_state = 2},
  [450] = {.lex_state = 11, .external_lex_state = 2},
  [451] = {.lex_state = 11, .external_lex_state = 2},
  [452] = {.lex_state = 11, .external_lex_state = 2},
  [453] = {.lex_state = 11, .external_lex_state = 2},
  [454] = {.lex_state = 11, .external_lex_state = 2},
  [455] = {.lex_state = 11, .external_lex_state = 2},
  [456] = {.lex_state = 11, .external_lex_state = 2},
  [457] = {.lex_state = 11, .external_lex_state = 2},
  [458] = {.lex_state = 11, .external_lex_state = 2},
  [459] = {.lex_state = 11, .external_lex_state = 2},
  [460] = {.lex_state = 11, .external_lex_state = 2},
  [461] = {.lex_state = 11, .external_lex_state = 2},
  [462] = {.lex_state = 11, .external_lex_state = 2},
  [463] = {.lex_state = 11, .external_lex_state = 2},
  [464] = {.lex_state = 11, .external_lex_state = 2},
  [465] = {.lex_state = 11, .external_lex_state = 2},
  [466] = {.lex_state = 11, .external_lex_state = 2},
  [467] = {.lex_state = 11, .external_lex_state = 2},
  [468] = {.lex_state = 11, .external_lex_state = 2},
  [469] = {.lex_state = 11, .external_lex_state = 2},
  [470] = {.lex_state = 11, .external_lex_state = 2},
  [471] = {.lex_state = 11, .external_lex_state = 2},
  [472] = {.lex_state = 11, .external_lex_state = 2},
  [473] = {.lex_state = 11, .external_lex_state = 2},
  [474] = {.lex_state = 11, .external_lex_state = 2},
  [475] = {.lex_state = 11, .external_lex_state = 2},
  [476] = {.lex_state = 11, .external_lex_state = 2},
  [477] = {.lex_state = 11, .external_lex_state = 2},
  [478] = {.lex_state = 11, .external_lex_state = 2},
  [479] = {.lex_state = 11, .external_lex_state = 2},
  [480] = {.lex_state = 11, .external_lex_state = 2},
  [481] = {.lex_state = 11, .external_lex_state = 2},
  [482] = {.lex_state = 11, .external_lex_state = 2},
  [483] = {.lex_state = 11, .external_lex_state = 2},
  [484] = {.lex_state = 11, .external_lex_state = 2},
  [485] = {.lex_state = 11, .external_lex_state = 2},
  [486] = {.lex_state = 11, .external_lex_state = 2},
  [487] = {.lex_state = 11, .external_lex_state = 2},
  [488] = {.lex_state = 11, .external_lex_state = 2},
  [489] = {.lex_state = 11, .external_lex_state = 2},
  [490] = {.lex_state = 11, .external_lex_state = 2},
  [491] = {.lex_state = 11, .external_lex_state = 2},
  [492] = {.lex_state = 11, .external_lex_state = 2},
  [493] = {.lex_state = 11, .external_lex_state = 2},
  [494] = {.lex_state = 11, .external_lex_state = 2},
  [495] = {.lex_state = 11, .external_lex_state = 2},
  [496] = {.lex_state = 11, .external_lex_state = 2},
  [497] = {.lex_state = 11, .external_lex_state = 2},
  [498] = {.lex_state = 11, .external_lex_state = 2},
  [499] = {.lex_state = 11, .external_lex_state = 2},
  [500] = {.lex_state = 11, .external_lex_state = 2},
  [501] = {.lex_state = 11, .external_lex_state = 2},
  [502] = {.lex_state = 11, .external_lex_state = 2},
  [503] = {.lex_state = 11, .external_lex_state = 2},
  [504] = {.lex_state = 11, .external_lex_state = 2},
  [505] = {.lex_state = 11, .external_lex_state = 2},
  [506] = {.lex_state = 11, .external_lex_state = 2},
  [507] = {.lex_state = 11, .external_lex_state = 2},
  [508] = {.lex_state = 11, .external_lex_state = 2},
  [509] = {.lex_state = 11, .external_lex_state = 2},
  [510] = {.lex_state = 11, .external_lex_state = 2},
  [511] = {.lex_state = 11, .external_lex_state = 2},
  [512] = {.lex_state = 11, .external_lex_state = 2},
  [513] = {.lex_state = 11, .external_lex_state = 2},
  [514] = {.lex_state = 11, .external_lex_state = 2},
  [515] = {.lex_state = 11, .external_lex_state = 2},
  [516] = {.lex_state = 11, .external_lex_state = 2},
  [517] = {.lex_state = 11, .external_lex_state = 2},
  [518] = {.lex_state = 11, .external_lex_state = 2},
  [519] = {.lex_state = 11, .external_lex_state = 2},
  [520] = {.lex_state = 11, .external_lex_state = 2},
  [521] = {.lex_state = 11, .external_lex_state = 2},
  [522] = {.lex_state = 11, .external_lex_state = 2},
  [523] = {.lex_state = 11, .external_lex_state = 2},
  [524] = {.lex_state = 11, .external_lex_state = 2},
  [525] = {.lex_state = 11, .external_lex_state = 2},
  [526] = {.lex_state = 11, .external_lex_state = 2},
  [527] = {.lex_state = 11, .external_lex_state = 2},
  [528] = {.lex_state = 11, .external_lex_state = 2},
  [529] = {.lex_state = 11, .external_lex_state = 2},
  [530] = {.lex_state = 11, .external_lex_state = 2},
  [531] = {.lex_state = 11, .external_lex_state = 2},
  [532] = {.lex_state = 11, .external_lex_state = 2},
  [533] = {.lex_state = 11, .external_lex_state = 2},
  [534] = {.lex_state = 11, .external_lex_state = 2},
  [535] = {.lex_state = 11, .external_lex_state = 2},
  [536] = {.lex_state = 11, .external_lex_state = 2},
  [537] = {.lex_state = 11, .external_lex_state = 2},
  [538] = {.lex_state = 11, .external_lex_state = 2},
  [539] = {.lex_state = 11, .external_lex_state = 2},
  [540] = {.lex_state = 11, .external_lex_state = 2},
  [541] = {.lex_state = 11, .external_lex_state = 2},
  [542] = {.lex_state = 11, .external_lex_state = 2},
  [543] = {.lex_state = 11, .external_lex_state = 2},
  [544] = {.lex_state = 11, .external_lex_state = 2},
  [545] = {.lex_state = 11, .external_lex_state = 2},
  [546] = {.lex_state = 11, .external_lex_state = 2},
  [547] = {.lex_state = 11, .external_lex_state = 2},
  [548] = {.lex_state = 11, .external_lex_state = 2},
  [549] = {.lex_state = 11, .external_lex_state = 2},
  [550] = {.lex_state = 11, .external_lex_state = 2},
  [551] = {.lex_state = 11, .external_lex_state = 2},
  [552] = {.lex_state = 11, .external_lex_state = 2},
  [553] = {.lex_state = 11, .external_lex_state = 2},
  [554] = {.lex_state = 11, .external_lex_state = 2},
  [555] = {.lex_state = 11, .external_lex_state = 2},
  [556] = {.lex_state = 11, .external_lex_state = 2},
  [557] = {.lex_state = 11, .external_lex_state = 2},
  [558] = {.lex_state = 11, .external_lex_state = 2},
  [559] = {.lex_state = 11, .external_lex_state = 2},
  [560] = {.lex_state = 11, .external_lex_state = 2},
  [561] = {.lex_state = 11, .external_lex_state = 2},
  [562] = {.lex_state = 11, .external_lex_state = 2},
  [563] = {.lex_state = 11, .external_lex_state = 2},
  [564] = {.lex_state = 11, .external_lex_state = 2},
  [565] = {.lex_state = 11, .external_lex_state = 2},
  [566] = {.lex_state = 11, .external_lex_state = 2},
  [567] = {.lex_state = 11, .external_lex_state = 2},
  [568] = {.lex_state = 11, .external_lex_state = 2},
  [569] = {.lex_state = 11, .external_lex_state = 2},
  [570] = {.lex_state = 11, .external_lex_state = 2},
  [571] = {.lex_state = 11, .external_lex_state = 2},
  [572] = {.lex_state = 11, .external_lex_state = 2},
  [573] = {.lex_state = 11, .external_lex_state = 2},
  [574] = {.lex_state = 11, .external_lex_state = 2},
  [575] = {.lex_state = 11, .external_lex_state = 2},
  [576] = {.lex_state = 11, .external_lex_state = 2},
  [577] = {.lex_state = 11, .external_lex_state = 2},
  [578] = {.lex_state = 11, .external_lex_state = 2},
  [579] = {.lex_state = 11, .external_lex_state = 2},
  [580] = {.lex_state = 11, .external_lex_state = 2},
  [581] = {.lex_state = 11, .external_lex_state = 2},
  [582] = {.lex_state = 11, .external_lex_state = 2},
  [583] = {.lex_state = 11, .external_lex_state = 2},
  [584] = {.lex_state = 11, .external_lex_state = 2},
  [585] = {.lex_state = 11, .external_lex_state = 2},
  [586] = {.lex_state = 11, .external_lex_state = 2},
  [587] = {.lex_state = 11, .external_lex_state = 2},
  [588] = {.lex_state = 11, .external_lex_state = 2},
  [589] = {.lex_state = 11, .external_lex_state = 2},
  [590] = {.lex_state = 11, .external_lex_state = 2},
  [591] = {.lex_state = 11, .external_lex_state = 2},
  [592] = {.lex_state = 11, .external_lex_state = 2},
  [593] = {.lex_state = 11, .external_lex_state = 2},
  [594] = {.lex_state = 11, .external_lex_state = 2},
  [595] = {.lex_state = 11, .external_lex_state = 2},
  [596] = {.lex_state = 11, .external_lex_state = 2},
  [597] = {.lex_state = 11, .external_lex_state = 2},
  [598] = {.lex_state = 11, .external_lex_state = 2},
  [599] = {.lex_state = 11, .external_lex_state = 2},
  [600] = {.lex_state = 11, .external_lex_state = 2},
  [601] = {.lex_state = 11, .external_lex_state = 2},
  [602] = {.lex_state = 11, .external_lex_state = 2},
  [603] = {.lex_state = 11, .external_lex_state = 2},
  [604] = {.lex_state = 11, .external_lex_state = 2},
  [605] = {.lex_state = 11, .external_lex_state = 2},
  [606] = {.lex_state = 11, .external_lex_state = 2},
  [607] = {.lex_state = 11, .external_lex_state = 2},
  [608] = {.lex_state = 11, .external_lex_state = 2},
  [609] = {.lex_state = 11, .external_lex_state = 2},
  [610] = {.lex_state = 11, .external_lex_state = 2},
  [611] = {.lex_state = 11, .external_lex_state = 2},
  [612] = {.lex_state = 11, .external_lex_state = 2},
  [613] = {.lex_state = 11, .external_lex_state = 2},
  [614] = {.lex_state = 11, .external_lex_state = 2},
  [615] = {.lex_state = 11, .external_lex_state = 2},
  [616] = {.lex_state = 11, .external_lex_state = 2},
  [617] = {.lex_state = 11, .external_lex_state = 2},
  [618] = {.lex_state = 11, .external_lex_state = 2},
  [619] = {.lex_state = 11, .external_lex_state = 2},
  [620] = {.lex_state = 11, .external_lex_state = 2},
  [621] = {.lex_state = 11, .external_lex_state = 2},
  [622] = {.lex_state = 11, .external_lex_state = 2},
  [623] = {.lex_state = 11, .external_lex_state = 2},
  [624] = {.lex_state = 11, .external_lex_state = 2},
  [625] = {.lex_state = 11, .external_lex_state = 2},
  [626] = {.lex_state = 11, .external_lex_state = 2},
  [627] = {.lex_state = 11, .external_lex_state = 2},
  [628] = {.lex_state = 11, .external_lex_state = 2},
  [629] = {.lex_state = 11, .external_lex_state = 2},
  [630] = {.lex_state = 11, .external_lex_state = 2},
  [631] = {.lex_state = 11, .external_lex_state = 2},
  [632] = {.lex_state = 11, .external_lex_state = 2},
  [633] = {.lex_state = 11, .external_lex_state = 2},
  [634] = {.lex_state = 11, .external_lex_state = 2},
  [635] = {.lex_state = 11, .external_lex_state = 2},
  [636] = {.lex_state = 11, .external_lex_state = 2},
  [637] = {.lex_state = 11, .external_lex_state = 2},
  [638] = {.lex_state = 11, .external_lex_state = 2},
  [639] = {.lex_state = 11, .external_lex_state = 2},
  [640] = {.lex_state = 11, .external_lex_state = 2},
  [641] = {.lex_state = 11, .external_lex_state = 2},
  [642] = {.lex_state = 11, .external_lex_state = 2},
  [643] = {.lex_state = 11, .external_lex_state = 2},
  [644] = {.lex_state = 11, .external_lex_state = 2},
  [645] = {.lex_state = 11, .external_lex_state = 2},
  [646] = {.lex_state = 11, .external_lex_state = 2},
  [647] = {.lex_state = 11, .external_lex_state = 2},
  [648] = {.lex_state = 11, .external_lex_state = 2},
  [649] = {.lex_state = 11, .external_lex_state = 2},
  [650] = {.lex_state = 11, .external_lex_state = 2},
  [651] = {.lex_state = 11, .external_lex_state = 2},
  [652] = {.lex_state = 11, .external_lex_state = 2},
  [653] = {.lex_state = 11, .external_lex_state = 2},
  [654] = {.lex_state = 11, .external_lex_state = 2},
  [655] = {.lex_state = 11, .external_lex_state = 2},
  [656] = {.lex_state = 4, .external_lex_state = 4},
  [657] = {.lex_state = 4, .external_lex_state = 4},
  [658] = {.lex_state = 4, .external_lex_state = 4},
  [659] = {.lex_state = 4, .external_lex_state = 4},
  [660] = {.lex_state = 4, .external_lex_state = 4},
  [661] = {.lex_state = 4, .external_lex_state = 4},
  [662] = {.lex_state = 4, .external_lex_state = 4},
  [663] = {.lex_state = 4, .external_lex_state = 4},
  [664] = {.lex_state = 4, .external_lex_state = 4},
  [665] = {.lex_state = 4, .external_lex_state = 4},
  [666] = {.lex_state = 4, .external_lex_state = 4},
  [667] = {.lex_state = 4, .external_lex_state = 4},
  [668] = {.lex_state = 4, .external_lex_state = 4},
  [669] = {.lex_state = 4, .external_lex_state = 4},
  [670] = {.lex_state = 4, .external_lex_state = 4},
  [671] = {.lex_state = 4, .external_lex_state = 4},
  [672] = {.lex_state = 6, .external_lex_state = 4},
  [673] = {.lex_state = 6, .external_lex_state = 4},
  [674] = {.lex_state = 6, .external_lex_state = 4},
  [675] = {.lex_state = 6, .external_lex_state = 4},
  [676] = {.lex_state = 11, .external_lex_state = 2},
  [677] = {.lex_state = 11, .external_lex_state = 2},
  [678] = {.lex_state = 11, .external_lex_state = 2},
  [679] = {.lex_state = 11, .external_lex_state = 2},
  [680] = {.lex_state = 11, .external_lex_state = 2},
  [681] = {.lex_state = 4, .external_lex_state = 4},
  [682] = {.lex_state = 4, .external_lex_state = 4},
  [683] = {.lex_state = 4, .external_lex_state = 4},
  [684] = {.lex_state = 4, .external_lex_state = 4},
  [685] = {.lex_state = 4, .external_lex_state = 4},
  [686] = {.lex_state = 4, .external_lex_state = 4},
  [687] = {.lex_state = 4, .external_lex_state = 4},
  [688] = {.lex_state = 4, .external_lex_state = 4},
  [689] = {.lex_state = 6, .external_lex_state = 4},
  [690] = {.lex_state = 6, .external_lex_state = 4},
  [691] = {.lex_state = 6, .external_lex_state = 4},
  [692] = {.lex_state = 6, .external_lex_state = 4},
  [693] = {.lex_state = 6, .external_lex_state = 3},
  [694] = {.lex_state = 6, .external_lex_state = 4},
  [695] = {.lex_state = 6, .external_lex_state = 3},
  [696] = {.lex_state = 6, .external_lex_state = 4},
  [697] = {.lex_state = 6, .external_lex_state = 3},
  [698] = {.lex_state = 6, .external_lex_state = 4},
  [699] = {.lex_state = 6, .external_lex_state = 3},
  [700] = {.lex_state = 6, .external_lex_state = 4},
  [701] = {.lex_state = 6, .external_lex_state = 3},
  [702] = {.lex_state = 6, .external_lex_state = 4},
  [703] = {.lex_state = 6, .external_lex_state = 4},
  [704] = {.lex_state = 6, .external_lex_state = 3},
  [705] = {.lex_state = 6, .external_lex_state = 4},
  [706] = {.lex_state = 6, .external_lex_state = 3},
  [707] = {.lex_state = 6, .external_lex_state = 4},
  [708] = {.lex_state = 6, .external_lex_state = 4},
  [709] = {.lex_state = 6, .external_lex_state = 4},
  [710] = {.lex_state = 6, .external_lex_state = 4},
  [711] = {.lex_state = 6, .external_lex_state = 3},
  [712] = {.lex_state = 6, .external_lex_state = 3},
  [713] = {.lex_state = 6, .external_lex_state = 4},
  [714] = {.lex_state = 6, .external_lex_state = 4},
  [715] = {.lex_state = 6, .external_lex_state = 3},
  [716] = {.lex_state = 6, .external_lex_state = 4},
  [717] = {.lex_state = 6, .external_lex_state = 4},
  [718] = {.lex_state = 6, .external_lex_state = 4},
  [719] = {.lex_state = 6, .external_lex_state = 4},
  [720] = {.lex_state = 6, .external_lex_state = 4},
  [721] = {.lex_state = 6, .external_lex_state = 4},
  [722] = {.lex_state = 11, .external_lex_state = 2},
  [723] = {.lex_state = 6, .external_lex_state = 3},
  [724] = {.lex_state = 6, .external_lex_state = 3},
  [725] = {.lex_state = 6, .external_lex_state = 4},
  [726] = {.lex_state = 6, .external_lex_state = 4},
  [727] = {.lex_state = 6, .external_lex_state = 3},
  [728] = {.lex_state = 6, .external_lex_state = 4},
  [729] = {.lex_state = 6, .external_lex_state = 4},
  [730] = {.lex_state = 6, .external_lex_state = 3},
  [731] = {.lex_state = 11, .external_lex_state = 5},
  [732] = {.lex_state = 11, .external_lex_state = 5},
  [733] = {.lex_state = 6, .external_lex_state = 4},
  [734] = {.lex_state = 11, .external_lex_state = 5},
  [735] = {.lex_state = 6, .external_lex_state = 3},
  [736] = {.lex_state = 6, .external_lex_state = 3},
  [737] = {.lex_state = 6, .external_lex_state = 3},
  [738] = {.lex_state = 6, .external_lex_state = 4},
  [739] = {.lex_state = 11, .external_lex_state = 5},
  [740] = {.lex_state = 6, .external_lex_state = 4},
  [741] = {.lex_state = 6, .external_lex_state = 3},
  [742] = {.lex_state = 6, .external_lex_state = 3},
  [743] = {.lex_state = 6, .external_lex_state = 3},
  [744] = {.lex_state = 6, .external_lex_state = 3},
  [745] = {.lex_state = 6, .external_lex_state = 3},
  [746] = {.lex_state = 6, .external_lex_state = 3},
  [747] = {.lex_state = 6, .external_lex_state = 3},
  [748] = {.lex_state = 11, .external_lex_state = 2},
  [749] = {.lex_state = 11, .external_lex_state = 2},
  [750] = {.lex_state = 6, .external_lex_state = 3},
  [751] = {.lex_state = 6, .external_lex_state = 3},
  [752] = {.lex_state = 11, .external_lex_state = 2},
  [753] = {.lex_state = 11, .external_lex_state = 2},
  [754] = {.lex_state = 6, .external_lex_state = 3},
  [755] = {.lex_state = 11, .external_lex_state = 2},
  [756] = {.lex_state = 6, .external_lex_state = 3},
  [757] = {.lex_state = 6, .external_lex_state = 3},
  [758] = {.lex_state = 6, .external_lex_state = 3},
  [759] = {.lex_state = 11, .external_lex_state = 5},
  [760] = {.lex_state = 11, .external_lex_state = 2},
  [761] = {.lex_state = 11, .external_lex_state = 5},
  [762] = {.lex_state = 11, .external_lex_state = 2},
  [763] = {.lex_state = 11, .external_lex_state = 2},
  [764] = {.lex_state = 11, .external_lex_state = 2},
  [765] = {.lex_state = 11, .external_lex_state = 2},
  [766] = {.lex_state = 11, .external_lex_state = 2},
  [767] = {.lex_state = 11, .external_lex_state = 5},
  [768] = {.lex_state = 11, .external_lex_state = 2},
  [769] = {.lex_state = 11, .external_lex_state = 5},
  [770] = {.lex_state = 11, .external_lex_state = 5},
  [771] = {.lex_state = 11, .external_lex_state = 5},
  [772] = {.lex_state = 11, .external_lex_state = 5},
  [773] = {.lex_state = 11, .external_lex_state = 2},
  [774] = {.lex_state = 11, .external_lex_state = 2},
  [775] = {.lex_state = 11, .external_lex_state = 5},
  [776] = {.lex_state = 11, .external_lex_state = 5},
  [777] = {.lex_state = 11, .external_lex_state = 5},
  [778] = {.lex_state = 11, .external_lex_state = 5},
  [779] = {.lex_state = 11, .external_lex_state = 5},
  [780] = {.lex_state = 11, .external_lex_state = 5},
  [781] = {.lex_state = 11, .external_lex_state = 5},
  [782] = {.lex_state = 11, .external_lex_state = 5},
  [783] = {.lex_state = 11, .external_lex_state = 5},
  [784] = {.lex_state = 11, .external_lex_state = 5},
  [785] = {.lex_state = 11, .external_lex_state = 5},
  [786] = {.lex_state = 11, .external_lex_state = 5},
  [787] = {.lex_state = 11, .external_lex_state = 2},
  [788] = {.lex_state = 11, .external_lex_state = 2},
  [789] = {.lex_state = 11, .external_lex_state = 2},
  [790] = {.lex_state = 11, .external_lex_state = 2},
  [791] = {.lex_state = 11, .external_lex_state = 2},
  [792] = {.lex_state = 11, .external_lex_state = 2},
  [793] = {.lex_state = 11, .external_lex_state = 2},
  [794] = {.lex_state = 11, .external_lex_state = 2},
  [795] = {.lex_state = 11, .external_lex_state = 2},
  [796] = {.lex_state = 11, .external_lex_state = 2},
  [797] = {.lex_state = 11, .external_lex_state = 2},
  [798] = {.lex_state = 11, .external_lex_state = 2},
  [799] = {.lex_state = 11, .external_lex_state = 2},
  [800] = {.lex_state = 11, .external_lex_state = 2},
  [801] = {.lex_state = 11, .external_lex_state = 2},
  [802] = {.lex_state = 11, .external_lex_state = 2},
  [803] = {.lex_state = 11, .external_lex_state = 2},
  [804] = {.lex_state = 11, .external_lex_state = 2},
  [805] = {.lex_state = 11, .external_lex_state = 2},
  [806] = {.lex_state = 11, .external_lex_state = 2},
  [807] = {.lex_state = 11, .external_lex_state = 2},
  [808] = {.lex_state = 11, .external_lex_state = 2},
  [809] = {.lex_state = 11, .external_lex_state = 2},
  [810] = {.lex_state = 11, .external_lex_state = 2},
  [811] = {.lex_state = 11, .external_lex_state = 2},
  [812] = {.lex_state = 11, .external_lex_state = 2},
  [813] = {.lex_state = 11, .external_lex_state = 2},
  [814] = {.lex_state = 11, .external_lex_state = 2},
  [815] = {.lex_state = 11, .external_lex_state = 2},
  [816] = {.lex_state = 11, .external_lex_state = 2},
  [817] = {.lex_state = 11, .external_lex_state = 2},
  [818] = {.lex_state = 11, .external_lex_state = 2},
  [819] = {.lex_state = 11, .external_lex_state = 2},
  [820] = {.lex_state = 11, .external_lex_state = 2},
  [821] = {.lex_state = 11, .external_lex_state = 2},
  [822] = {.lex_state = 11, .external_lex_state = 2},
  [823] = {.lex_state = 11, .external_lex_state = 2},
  [824] = {.lex_state = 11, .external_lex_state = 2},
  [825] = {.lex_state = 11, .external_lex_state = 2},
  [826] = {.lex_state = 11, .external_lex_state = 2},
  [827] = {.lex_state = 11, .external_lex_state = 2},
  [828] = {.lex_state = 11, .external_lex_state = 2},
  [829] = {.lex_state = 11, .external_lex_state = 2},
  [830] = {.lex_state = 11, .external_lex_state = 2},
  [831] = {.lex_state = 11, .external_lex_state = 2},
  [832] = {.lex_state = 11, .external_lex_state = 2},
  [833] = {.lex_state = 11, .external_lex_state = 2},
  [834] = {.lex_state = 11, .external_lex_state = 2},
  [835] = {.lex_state = 11, .external_lex_state = 2},
  [836] = {.lex_state = 11, .external_lex_state = 2},
  [837] = {.lex_state = 11, .external_lex_state = 2},
  [838] = {.lex_state = 11, .external_lex_state = 2},
  [839] = {.lex_state = 11, .external_lex_state = 2},
  [840] = {.lex_state = 11, .external_lex_state = 2},
  [841] = {.lex_state = 11, .external_lex_state = 2},
  [842] = {.lex_state = 11, .external_lex_state = 2},
  [843] = {.lex_state = 11, .external_lex_state = 2},
  [844] = {.lex_state = 11, .external_lex_state = 2},
  [845] = {.lex_state = 11, .external_lex_state = 2},
  [846] = {.lex_state = 11, .external_lex_state = 2},
  [847] = {.lex_state = 11, .external_lex_state = 2},
  [848] = {.lex_state = 11, .external_lex_state = 2},
  [849] = {.lex_state = 11, .external_lex_state = 2},
  [850] = {.lex_state = 11, .external_lex_state = 2},
  [851] = {.lex_state = 11, .external_lex_state = 2},
  [852] = {.lex_state = 11, .external_lex_state = 2},
  [853] = {.lex_state = 11, .external_lex_state = 2},
  [854] = {.lex_state = 11, .external_lex_state = 2},
  [855] = {.lex_state = 11, .external_lex_state = 2},
  [856] = {.lex_state = 11, .external_lex_state = 2},
  [857] = {.lex_state = 11, .external_lex_state = 2},
  [858] = {.lex_state = 11, .external_lex_state = 2},
  [859] = {.lex_state = 11, .external_lex_state = 2},
  [860] = {.lex_state = 11, .external_lex_state = 2},
  [861] = {.lex_state = 11, .external_lex_state = 2},
  [862] = {.lex_state = 11, .external_lex_state = 2},
  [863] = {.lex_state = 11, .external_lex_state = 2},
  [864] = {.lex_state = 11, .external_lex_state = 2},
  [865] = {.lex_state = 11, .external_lex_state = 2},
  [866] = {.lex_state = 11, .external_lex_state = 2},
  [867] = {.lex_state = 11, .external_lex_state = 2},
  [868] = {.lex_state = 11, .external_lex_state = 2},
  [869] = {.lex_state = 11, .external_lex_state = 2},
  [870] = {.lex_state = 11, .external_lex_state = 2},
  [871] = {.lex_state = 11, .external_lex_state = 2},
  [872] = {.lex_state = 11, .external_lex_state = 2},
  [873] = {.lex_state = 11, .external_lex_state = 2},
  [874] = {.lex_state = 11, .external_lex_state = 2},
  [875] = {.lex_state = 11, .external_lex_state = 2},
  [876] = {.lex_state = 11, .external_lex_state = 2},
  [877] = {.lex_state = 11, .external_lex_state = 2},
  [878] = {.lex_state = 11, .external_lex_state = 2},
  [879] = {.lex_state = 11, .external_lex_state = 2},
  [880] = {.lex_state = 11, .external_lex_state = 2},
  [881] = {.lex_state = 11, .external_lex_state = 2},
  [882] = {.lex_state = 11, .external_lex_state = 2},
  [883] = {.lex_state = 11, .external_lex_state = 2},
  [884] = {.lex_state = 11, .external_lex_state = 2},
  [885] = {.lex_state = 11, .external_lex_state = 2},
  [886] = {.lex_state = 11, .external_lex_state = 2},
  [887] = {.lex_state = 11, .external_lex_state = 2},
  [888] = {.lex_state = 11, .external_lex_state = 2},
  [889] = {.lex_state = 11, .external_lex_state = 2},
  [890] = {.lex_state = 11, .external_lex_state = 2},
  [891] = {.lex_state = 11, .external_lex_state = 2},
  [892] = {.lex_state = 11, .external_lex_state = 2},
  [893] = {.lex_state = 11, .external_lex_state = 2},
  [894] = {.lex_state = 11, .external_lex_state = 2},
  [895] = {.lex_state = 11, .external_lex_state = 2},
  [896] = {.lex_state = 11, .external_lex_state = 2},
  [897] = {.lex_state = 11, .external_lex_state = 2},
  [898] = {.lex_state = 11, .external_lex_state = 2},
  [899] = {.lex_state = 11, .external_lex_state = 2},
  [900] = {.lex_state = 11, .external_lex_state = 2},
  [901] = {.lex_state = 11, .external_lex_state = 2},
  [902] = {.lex_state = 11, .external_lex_state = 2},
  [903] = {.lex_state = 11, .external_lex_state = 2},
  [904] = {.lex_state = 11, .external_lex_state = 2},
  [905] = {.lex_state = 11, .external_lex_state = 2},
  [906] = {.lex_state = 11, .external_lex_state = 2},
  [907] = {.lex_state = 11, .external_lex_state = 2},
  [908] = {.lex_state = 11, .external_lex_state = 2},
  [909] = {.lex_state = 11, .external_lex_state = 2},
  [910] = {.lex_state = 11, .external_lex_state = 2},
  [911] = {.lex_state = 11, .external_lex_state = 2},
  [912] = {.lex_state = 11, .external_lex_state = 2},
  [913] = {.lex_state = 11, .external_lex_state = 2},
  [914] = {.lex_state = 11, .external_lex_state = 2},
  [915] = {.lex_state = 11, .external_lex_state = 2},
  [916] = {.lex_state = 11, .external_lex_state = 2},
  [917] = {.lex_state = 11, .external_lex_state = 2},
  [918] = {.lex_state = 11, .external_lex_state = 2},
  [919] = {.lex_state = 7, .external_lex_state = 4},
  [920] = {.lex_state = 7, .external_lex_state = 4},
  [921] = {.lex_state = 7, .external_lex_state = 4},
  [922] = {.lex_state = 7, .external_lex_state = 4},
  [923] = {.lex_state = 7, .external_lex_state = 4},
  [924] = {.lex_state = 7, .external_lex_state = 4},
  [925] = {.lex_state = 7, .external_lex_state = 4},
  [926] = {.lex_state = 7, .external_lex_state = 4},
  [927] = {.lex_state = 7, .external_lex_state = 4},
  [928] = {.lex_state = 7, .external_lex_state = 4},
  [929] = {.lex_state = 11, .external_lex_state = 2},
  [930] = {.lex_state = 13, .external_lex_state = 2},
  [931] = {.lex_state = 11, .external_lex_state = 2},
  [932] = {.lex_state = 13, .external_lex_state = 2},
  [933] = {.lex_state = 7, .external_lex_state = 4},
  [934] = {.lex_state = 11, .external_lex_state = 2},
  [935] = {.lex_state = 11, .external_lex_state = 2},
  [936] = {.lex_state = 11, .external_lex_state = 2},
  [937] = {.lex_state = 11, .external_lex_state = 2},
  [938] = {.lex_state = 13, .external_lex_state = 2},
  [939] = {.lex_state = 11, .external_lex_state = 2},
  [940] = {.lex_state = 11, .external_lex_state = 2},
  [941] = {.lex_state = 7, .external_lex_state = 4},
  [942] = {.lex_state = 13, .external_lex_state = 2},
  [943] = {.lex_state = 7, .external_lex_state = 4},
  [944] = {.lex_state = 11, .external_lex_state = 2},
  [945] = {.lex_state = 7, .external_lex_state = 4},
  [946] = {.lex_state = 7, .external_lex_state = 4},
  [947] = {.lex_state = 7, .external_lex_state = 4},
  [948] = {.lex_state = 11, .external_lex_state = 2},
  [949] = {.lex_state = 7, .external_lex_state = 4},
  [950] = {.lex_state = 11, .external_lex_state = 2},
  [951] = {.lex_state = 7, .external_lex_state = 4},
  [952] = {.lex_state = 7, .external_lex_state = 4},
  [953] = {.lex_state = 7, .external_lex_state = 4},
  [954] = {.lex_state = 13, .external_lex_state = 2},
  [955] = {.lex_state = 16, .external_lex_state = 2},
  [956] = {.lex_state = 13, .external_lex_state = 2},
  [957] = {.lex_state = 16, .external_lex_state = 2},
  [958] = {.lex_state = 7, .external_lex_state = 4},
  [959] = {.lex_state = 7, .external_lex_state = 4},
  [960] = {.lex_state = 13, .external_lex_state = 2},
  [961] = {.lex_state = 7, .external_lex_state = 4},
  [962] = {.lex_state = 13, .external_lex_state = 2},
  [963] = {.lex_state = 7, .external_lex_state = 4},
  [964] = {.lex_state = 13, .external_lex_state = 2},
  [965] = {.lex_state = 7, .external_lex_state = 4},
  [966] = {.lex_state = 7, .external_lex_state = 4},
  [967] = {.lex_state = 13, .external_lex_state = 2},
  [968] = {.lex_state = 13, .external_lex_state = 2},
  [969] = {.lex_state = 13, .external_lex_state = 2},
  [970] = {.lex_state = 7, .external_lex_state = 4},
  [971] = {.lex_state = 16, .external_lex_state = 2},
  [972] = {.lex_state = 16, .external_lex_state = 2},
  [973] = {.lex_state = 13, .external_lex_state = 2},
  [974] = {.lex_state = 7, .external_lex_state = 4},
  [975] = {.lex_state = 16, .external_lex_state = 2},
  [976] = {.lex_state = 7, .external_lex_state = 4},
  [977] = {.lex_state = 16, .external_lex_state = 2},
  [978] = {.lex_state = 16, .external_lex_state = 2},
  [979] = {.lex_state = 16, .external_lex_state = 2},
  [980] = {.lex_state = 16, .external_lex_state = 2},
  [981] = {.lex_state = 16, .external_lex_state = 2},
  [982] = {.lex_state = 16, .external_lex_state = 2},
  [983] = {.lex_state = 16, .external_lex_state = 2},
  [984] = {.lex_state = 16, .external_lex_state = 2},
  [985] = {.lex_state = 16, .external_lex_state = 2},
  [986] = {.lex_state = 16, .external_lex_state = 2},
  [987] = {.lex_state = 16, .external_lex_state = 2},
  [988] = {.lex_state = 16, .external_lex_state = 2},
  [989] = {.lex_state = 16, .external_lex_state = 2},
  [990] = {.lex_state = 16, .external_lex_state = 2},
  [991] = {.lex_state = 16, .external_lex_state = 2},
  [992] = {.lex_state = 16, .external_lex_state = 2},
  [993] = {.lex_state = 16, .external_lex_state = 2},
  [994] = {.lex_state = 16, .external_lex_state = 2},
  [995] = {.lex_state = 16, .external_lex_state = 2},
  [996] = {.lex_state = 16, .external_lex_state = 2},
  [997] = {.lex_state = 16, .external_lex_state = 2},
  [998] = {.lex_state = 16, .external_lex_state = 2},
  [999] = {.lex_state = 16, .external_lex_state = 2},
  [1000] = {.lex_state = 16, .external_lex_state = 2},
  [1001] = {.lex_state = 16, .external_lex_state = 2},
  [1002] = {.lex_state = 16, .external_lex_state = 2},
  [1003] = {.lex_state = 16, .external_lex_state = 2},
  [1004] = {.lex_state = 16, .external_lex_state = 2},
  [1005] = {.lex_state = 16, .external_lex_state = 2},
  [1006] = {.lex_state = 16, .external_lex_state = 2},
  [1007] = {.lex_state = 16, .external_lex_state = 2},
  [1008] = {.lex_state = 16, .external_lex_state = 2},
  [1009] = {.lex_state = 16, .external_lex_state = 2},
  [1010] = {.lex_state = 16, .external_lex_state = 2},
  [1011] = {.lex_state = 13, .external_lex_state = 2},
  [1012] = {.lex_state = 16, .external_lex_state = 2},
  [1013] = {.lex_state = 16, .external_lex_state = 2},
  [1014] = {.lex_state = 16, .external_lex_state = 2},
  [1015] = {.lex_state = 16, .external_lex_state = 2},
  [1016] = {.lex_state = 16, .external_lex_state = 2},
  [1017] = {.lex_state = 16, .external_lex_state = 2},
  [1018] = {.lex_state = 16, .external_lex_state = 2},
  [1019] = {.lex_state = 16, .external_lex_state = 2},
  [1020] = {.lex_state = 16, .external_lex_state = 2},
  [1021] = {.lex_state = 16, .external_lex_state = 2},
  [1022] = {.lex_state = 16, .external_lex_state = 2},
  [1023] = {.lex_state = 13, .external_lex_state = 2},
  [1024] = {.lex_state = 16, .external_lex_state = 2},
  [1025] = {.lex_state = 16, .external_lex_state = 2},
  [1026] = {.lex_state = 16, .external_lex_state = 2},
  [1027] = {.lex_state = 16, .external_lex_state = 2},
  [1028] = {.lex_state = 16, .external_lex_state = 2},
  [1029] = {.lex_state = 16, .external_lex_state = 2},
  [1030] = {.lex_state = 16, .external_lex_state = 2},
  [1031] = {.lex_state = 16, .external_lex_state = 2},
  [1032] = {.lex_state = 16, .external_lex_state = 2},
  [1033] = {.lex_state = 16, .external_lex_state = 2},
  [1034] = {.lex_state = 16, .external_lex_state = 2},
  [1035] = {.lex_state = 16, .external_lex_state = 2},
  [1036] = {.lex_state = 16, .external_lex_state = 2},
  [1037] = {.lex_state = 16, .external_lex_state = 2},
  [1038] = {.lex_state = 16, .external_lex_state = 2},
  [1039] = {.lex_state = 16, .external_lex_state = 2},
  [1040] = {.lex_state = 16, .external_lex_state = 2},
  [1041] = {.lex_state = 16, .external_lex_state = 2},
  [1042] = {.lex_state = 16, .external_lex_state = 2},
  [1043] = {.lex_state = 16, .external_lex_state = 2},
  [1044] = {.lex_state = 16, .external_lex_state = 2},
  [1045] = {.lex_state = 16, .external_lex_state = 2},
  [1046] = {.lex_state = 16, .external_lex_state = 2},
  [1047] = {.lex_state = 16, .external_lex_state = 2},
  [1048] = {.lex_state = 16, .external_lex_state = 2},
  [1049] = {.lex_state = 16, .external_lex_state = 2},
  [1050] = {.lex_state = 16, .external_lex_state = 2},
  [1051] = {.lex_state = 16, .external_lex_state = 2},
  [1052] = {.lex_state = 6, .external_lex_state = 4},
  [1053] = {.lex_state = 6, .external_lex_state = 4},
  [1054] = {.lex_state = 16, .external_lex_state = 2},
  [1055] = {.lex_state = 6, .external_lex_state = 4},
  [1056] = {.lex_state = 6, .external_lex_state = 4},
  [1057] = {.lex_state = 6, .external_lex_state = 4},
  [1058] = {.lex_state = 6, .external_lex_state = 4},
  [1059] = {.lex_state = 6, .external_lex_state = 4},
  [1060] = {.lex_state = 6, .external_lex_state = 4},
  [1061] = {.lex_state = 16, .external_lex_state = 2},
  [1062] = {.lex_state = 6, .external_lex_state = 4},
  [1063] = {.lex_state = 16, .external_lex_state = 2},
  [1064] = {.lex_state = 6, .external_lex_state = 4},
  [1065] = {.lex_state = 16, .external_lex_state = 2},
  [1066] = {.lex_state = 6, .external_lex_state = 4},
  [1067] = {.lex_state = 6, .external_lex_state = 4},
  [1068] = {.lex_state = 16, .external_lex_state = 2},
  [1069] = {.lex_state = 16, .external_lex_state = 2},
  [1070] = {.lex_state = 16, .external_lex_state = 2},
  [1071] = {.lex_state = 16, .external_lex_state = 2},
  [1072] = {.lex_state = 16, .external_lex_state = 2},
  [1073] = {.lex_state = 16, .external_lex_state = 2},
  [1074] = {.lex_state = 16, .external_lex_state = 2},
  [1075] = {.lex_state = 16, .external_lex_state = 2},
  [1076] = {.lex_state = 16, .external_lex_state = 2},
  [1077] = {.lex_state = 16, .external_lex_state = 2},
  [1078] = {.lex_state = 16, .external_lex_state = 2},
  [1079] = {.lex_state = 16, .external_lex_state = 2},
  [1080] = {.lex_state = 16, .external_lex_state = 2},
  [1081] = {.lex_state = 16, .external_lex_state = 2},
  [1082] = {.lex_state = 16, .external_lex_state = 2},
  [1083] = {.lex_state = 16, .external_lex_state = 2},
  [1084] = {.lex_state = 16, .external_lex_state = 2},
  [1085] = {.lex_state = 16, .external_lex_state = 2},
  [1086] = {.lex_state = 16, .external_lex_state = 2},
  [1087] = {.lex_state = 16, .external_lex_state = 2},
  [1088] = {.lex_state = 16, .external_lex_state = 2},
  [1089] = {.lex_state = 16, .external_lex_state = 2},
  [1090] = {.lex_state = 16, .external_lex_state = 2},
  [1091] = {.lex_state = 16, .external_lex_state = 2},
  [1092] = {.lex_state = 16, .external_lex_state = 2},
  [1093] = {.lex_state = 16, .external_lex_state = 2},
  [1094] = {.lex_state = 16, .external_lex_state = 2},
  [1095] = {.lex_state = 16, .external_lex_state = 2},
  [1096] = {.lex_state = 16, .external_lex_state = 2},
  [1097] = {.lex_state = 16, .external_lex_state = 2},
  [1098] = {.lex_state = 16, .external_lex_state = 2},
  [1099] = {.lex_state = 16, .external_lex_state = 2},
  [1100] = {.lex_state = 16, .external_lex_state = 2},
  [1101] = {.lex_state = 16, .external_lex_state = 2},
  [1102] = {.lex_state = 16, .external_lex_state = 2},
  [1103] = {.lex_state = 16, .external_lex_state = 2},
  [1104] = {.lex_state = 16, .external_lex_state = 2},
  [1105] = {.lex_state = 11, .external_lex_state = 2},
  [1106] = {.lex_state = 16, .external_lex_state = 2},
  [1107] = {.lex_state = 16, .external_lex_state = 2},
  [1108] = {.lex_state = 16, .external_lex_state = 2},
  [1109] = {.lex_state = 16, .external_lex_state = 2},
  [1110] = {.lex_state = 16, .external_lex_state = 2},
  [1111] = {.lex_state = 16, .external_lex_state = 2},
  [1112] = {.lex_state = 16, .external_lex_state = 2},
  [1113] = {.lex_state = 16, .external_lex_state = 2},
  [1114] = {.lex_state = 16, .external_lex_state = 2},
  [1115] = {.lex_state = 16, .external_lex_state = 2},
  [1116] = {.lex_state = 16, .external_lex_state = 2},
  [1117] = {.lex_state = 16, .external_lex_state = 2},
  [1118] = {.lex_state = 16, .external_lex_state = 2},
  [1119] = {.lex_state = 16, .external_lex_state = 2},
  [1120] = {.lex_state = 16, .external_lex_state = 2},
  [1121] = {.lex_state = 16, .external_lex_state = 2},
  [1122] = {.lex_state = 16, .external_lex_state = 2},
  [1123] = {.lex_state = 16, .external_lex_state = 2},
  [1124] = {.lex_state = 16, .external_lex_state = 2},
  [1125] = {.lex_state = 16, .external_lex_state = 2},
  [1126] = {.lex_state = 16, .external_lex_state = 2},
  [1127] = {.lex_state = 16, .external_lex_state = 2},
  [1128] = {.lex_state = 16, .external_lex_state = 2},
  [1129] = {.lex_state = 16, .external_lex_state = 2},
  [1130] = {.lex_state = 16, .external_lex_state = 2},
  [1131] = {.lex_state = 16, .external_lex_state = 2},
  [1132] = {.lex_state = 16, .external_lex_state = 2},
  [1133] = {.lex_state = 16, .external_lex_state = 2},
  [1134] = {.lex_state = 16, .external_lex_state = 2},
  [1135] = {.lex_state = 16, .external_lex_state = 2},
  [1136] = {.lex_state = 16, .external_lex_state = 2},
  [1137] = {.lex_state = 16, .external_lex_state = 2},
  [1138] = {.lex_state = 16, .external_lex_state = 2},
  [1139] = {.lex_state = 16, .external_lex_state = 2},
  [1140] = {.lex_state = 16, .external_lex_state = 2},
  [1141] = {.lex_state = 16, .external_lex_state = 2},
  [1142] = {.lex_state = 16, .external_lex_state = 2},
  [1143] = {.lex_state = 16, .external_lex_state = 2},
  [1144] = {.lex_state = 16, .external_lex_state = 2},
  [1145] = {.lex_state = 16, .external_lex_state = 2},
  [1146] = {.lex_state = 16, .external_lex_state = 2},
  [1147] = {.lex_state = 16, .external_lex_state = 2},
  [1148] = {.lex_state = 16, .external_lex_state = 2},
  [1149] = {.lex_state = 16, .external_lex_state = 2},
  [1150] = {.lex_state = 16, .external_lex_state = 2},
  [1151] = {.lex_state = 16, .external_lex_state = 2},
  [1152] = {.lex_state = 16, .external_lex_state = 2},
  [1153] = {.lex_state = 16, .external_lex_state = 2},
  [1154] = {.lex_state = 16, .external_lex_state = 2},
  [1155] = {.lex_state = 16, .external_lex_state = 2},
  [1156] = {.lex_state = 16, .external_lex_state = 2},
  [1157] = {.lex_state = 16, .external_lex_state = 2},
  [1158] = {.lex_state = 16, .external_lex_state = 2},
  [1159] = {.lex_state = 16, .external_lex_state = 2},
  [1160] = {.lex_state = 16, .external_lex_state = 2},
  [1161] = {.lex_state = 16, .external_lex_state = 2},
  [1162] = {.lex_state = 16, .external_lex_state = 2},
  [1163] = {.lex_state = 16, .external_lex_state = 2},
  [1164] = {.lex_state = 16, .external_lex_state = 2},
  [1165] = {.lex_state = 16, .external_lex_state = 2},
  [1166] = {.lex_state = 16, .external_lex_state = 2},
  [1167] = {.lex_state = 16, .external_lex_state = 2},
  [1168] = {.lex_state = 16, .external_lex_state = 2},
  [1169] = {.lex_state = 16, .external_lex_state = 2},
  [1170] = {.lex_state = 16, .external_lex_state = 2},
  [1171] = {.lex_state = 16, .external_lex_state = 2},
  [1172] = {.lex_state = 16, .external_lex_state = 2},
  [1173] = {.lex_state = 16, .external_lex_state = 2},
  [1174] = {.lex_state = 16, .external_lex_state = 2},
  [1175] = {.lex_state = 16, .external_lex_state = 2},
  [1176] = {.lex_state = 16, .external_lex_state = 2},
  [1177] = {.lex_state = 16, .external_lex_state = 2},
  [1178] = {.lex_state = 11, .external_lex_state = 2},
  [1179] = {.lex_state = 16, .external_lex_state = 2},
  [1180] = {.lex_state = 16, .external_lex_state = 2},
  [1181] = {.lex_state = 16, .external_lex_state = 2},
  [1182] = {.lex_state = 16, .external_lex_state = 2},
  [1183] = {.lex_state = 16, .external_lex_state = 2},
  [1184] = {.lex_state = 16, .external_lex_state = 2},
  [1185] = {.lex_state = 16, .external_lex_state = 2},
  [1186] = {.lex_state = 16, .external_lex_state = 2},
  [1187] = {.lex_state = 16, .external_lex_state = 2},
  [1188] = {.lex_state = 16, .external_lex_state = 2},
  [1189] = {.lex_state = 16, .external_lex_state = 2},
  [1190] = {.lex_state = 16, .external_lex_state = 2},
  [1191] = {.lex_state = 16, .external_lex_state = 2},
  [1192] = {.lex_state = 16, .external_lex_state = 2},
  [1193] = {.lex_state = 16, .external_lex_state = 2},
  [1194] = {.lex_state = 16, .external_lex_state = 2},
  [1195] = {.lex_state = 16, .external_lex_state = 2},
  [1196] = {.lex_state = 16, .external_lex_state = 2},
  [1197] = {.lex_state = 16, .external_lex_state = 2},
  [1198] = {.lex_state = 11, .external_lex_state = 2},
  [1199] = {.lex_state = 16, .external_lex_state = 2},
  [1200] = {.lex_state = 16, .external_lex_state = 2},
  [1201] = {.lex_state = 16, .external_lex_state = 2},
  [1202] = {.lex_state = 11, .external_lex_state = 2},
  [1203] = {.lex_state = 6, .external_lex_state = 3},
  [1204] = {.lex_state = 6, .external_lex_state = 3},
  [1205] = {.lex_state = 11, .external_lex_state = 2},
  [1206] = {.lex_state = 6, .external_lex_state = 3},
  [1207] = {.lex_state = 11, .external_lex_state = 2},
  [1208] = {.lex_state = 11, .external_lex_state = 2},
  [1209] = {.lex_state = 6, .external_lex_state = 4},
  [1210] = {.lex_state = 6, .external_lex_state = 3},
  [1211] = {.lex_state = 6, .external_lex_state = 4},
  [1212] = {.lex_state = 11, .external_lex_state = 2},
  [1213] = {.lex_state = 11, .external_lex_state = 2},
  [1214] = {.lex_state = 6, .external_lex_state = 3},
  [1215] = {.lex_state = 11, .external_lex_state = 2},
  [1216] = {.lex_state = 6, .external_lex_state = 4},
  [1217] = {.lex_state = 6, .external_lex_state = 4},
  [1218] = {.lex_state = 6, .external_lex_state = 4},
  [1219] = {.lex_state = 6, .external_lex_state = 4},
  [1220] = {.lex_state = 6, .external_lex_state = 4},
  [1221] = {.lex_state = 6, .external_lex_state = 4},
  [1222] = {.lex_state = 6, .external_lex_state = 4},
  [1223] = {.lex_state = 6, .external_lex_state = 4},
  [1224] = {.lex_state = 6, .external_lex_state = 4},
  [1225] = {.lex_state = 6, .external_lex_state = 4},
  [1226] = {.lex_state = 6, .external_lex_state = 4},
  [1227] = {.lex_state = 6, .external_lex_state = 3},
  [1228] = {.lex_state = 6, .external_lex_state = 3},
  [1229] = {.lex_state = 6, .external_lex_state = 4},
  [1230] = {.lex_state = 6, .external_lex_state = 4},
  [1231] = {.lex_state = 6, .external_lex_state = 4},
  [1232] = {.lex_state = 6, .external_lex_state = 4},
  [1233] = {.lex_state = 6, .external_lex_state = 3},
  [1234] = {.lex_state = 6, .external_lex_state = 3},
  [1235] = {.lex_state = 13, .external_lex_state = 2},
  [1236] = {.lex_state = 6, .external_lex_state = 4},
  [1237] = {.lex_state = 13, .external_lex_state = 2},
  [1238] = {.lex_state = 13, .external_lex_state = 2},
  [1239] = {.lex_state = 6, .external_lex_state = 4},
  [1240] = {.lex_state = 13, .external_lex_state = 2},
  [1241] = {.lex_state = 13, .external_lex_state = 2},
  [1242] = {.lex_state = 6, .external_lex_state = 4},
  [1243] = {.lex_state = 6, .external_lex_state = 3},
  [1244] = {.lex_state = 6, .external_lex_state = 4},
  [1245] = {.lex_state = 13, .external_lex_state = 2},
  [1246] = {.lex_state = 13, .external_lex_state = 2},
  [1247] = {.lex_state = 6, .external_lex_state = 4},
  [1248] = {.lex_state = 6, .external_lex_state = 4},
  [1249] = {.lex_state = 6, .external_lex_state = 4},
  [1250] = {.lex_state = 6, .external_lex_state = 3},
  [1251] = {.lex_state = 6, .external_lex_state = 4},
  [1252] = {.lex_state = 6, .external_lex_state = 3},
  [1253] = {.lex_state = 6, .external_lex_state = 3},
  [1254] = {.lex_state = 6, .external_lex_state = 3},
  [1255] = {.lex_state = 6, .external_lex_state = 4},
  [1256] = {.lex_state = 6, .external_lex_state = 4},
  [1257] = {.lex_state = 6, .external_lex_state = 3},
  [1258] = {.lex_state = 6, .external_lex_state = 4},
  [1259] = {.lex_state = 6, .external_lex_state = 4},
  [1260] = {.lex_state = 6, .external_lex_state = 4},
  [1261] = {.lex_state = 6, .external_lex_state = 3},
  [1262] = {.lex_state = 6, .external_lex_state = 4},
  [1263] = {.lex_state = 6, .external_lex_state = 4},
  [1264] = {.lex_state = 6, .external_lex_state = 4},
  [1265] = {.lex_state = 6, .external_lex_state = 3},
  [1266] = {.lex_state = 6, .external_lex_state = 4},
  [1267] = {.lex_state = 6, .external_lex_state = 4},
  [1268] = {.lex_state = 6, .external_lex_state = 4},
  [1269] = {.lex_state = 6, .external_lex_state = 3},
  [1270] = {.lex_state = 6, .external_lex_state = 4},
  [1271] = {.lex_state = 6, .external_lex_state = 4},
  [1272] = {.lex_state = 6, .external_lex_state = 3},
  [1273] = {.lex_state = 6, .external_lex_state = 3},
  [1274] = {.lex_state = 6, .external_lex_state = 4},
  [1275] = {.lex_state = 6, .external_lex_state = 3},
  [1276] = {.lex_state = 6, .external_lex_state = 4},
  [1277] = {.lex_state = 6, .external_lex_state = 4},
  [1278] = {.lex_state = 13, .external_lex_state = 2},
  [1279] = {.lex_state = 6, .external_lex_state = 3},
  [1280] = {.lex_state = 6, .external_lex_state = 3},
  [1281] = {.lex_state = 13, .external_lex_state = 2},
  [1282] = {.lex_state = 13, .external_lex_state = 2},
  [1283] = {.lex_state = 13, .external_lex_state = 2},
  [1284] = {.lex_state = 6, .external_lex_state = 3},
  [1285] = {.lex_state = 13, .external_lex_state = 2},
  [1286] = {.lex_state = 6, .external_lex_state = 3},
  [1287] = {.lex_state = 13, .external_lex_state = 2},
  [1288] = {.lex_state = 6, .external_lex_state = 3},
  [1289] = {.lex_state = 13, .external_lex_state = 2},
  [1290] = {.lex_state = 13, .external_lex_state = 2},
  [1291] = {.lex_state = 13, .external_lex_state = 2},
  [1292] = {.lex_state = 13, .external_lex_state = 2},
  [1293] = {.lex_state = 6, .external_lex_state = 3},
  [1294] = {.lex_state = 6, .external_lex_state = 3},
  [1295] = {.lex_state = 13, .external_lex_state = 2},
  [1296] = {.lex_state = 13, .external_lex_state = 2},
  [1297] = {.lex_state = 13, .external_lex_state = 2},
  [1298] = {.lex_state = 13, .external_lex_state = 2},
  [1299] = {.lex_state = 13, .external_lex_state = 2},
  [1300] = {.lex_state = 13, .external_lex_state = 2},
  [1301] = {.lex_state = 13, .external_lex_state = 2},
  [1302] = {.lex_state = 6, .external_lex_state = 3},
  [1303] = {.lex_state = 13, .external_lex_state = 2},
  [1304] = {.lex_state = 6, .external_lex_state = 4},
  [1305] = {.lex_state = 13, .external_lex_state = 2},
  [1306] = {.lex_state = 6, .external_lex_state = 3},
  [1307] = {.lex_state = 6, .external_lex_state = 3},
  [1308] = {.lex_state = 6, .external_lex_state = 3},
  [1309] = {.lex_state = 6, .external_lex_state = 3},
  [1310] = {.lex_state = 6, .external_lex_state = 4},
  [1311] = {.lex_state = 6, .external_lex_state = 3},
  [1312] = {.lex_state = 6, .external_lex_state = 4},
  [1313] = {.lex_state = 13, .external_lex_state = 2},
  [1314] = {.lex_state = 13, .external_lex_state = 2},
  [1315] = {.lex_state = 6, .external_lex_state = 3},
  [1316] = {.lex_state = 6, .external_lex_state = 3},
  [1317] = {.lex_state = 6, .external_lex_state = 3},
  [1318] = {.lex_state = 6, .external_lex_state = 3},
  [1319] = {.lex_state = 6, .external_lex_state = 3},
  [1320] = {.lex_state = 6, .external_lex_state = 3},
  [1321] = {.lex_state = 6, .external_lex_state = 3},
  [1322] = {.lex_state = 6, .external_lex_state = 3},
  [1323] = {.lex_state = 6, .external_lex_state = 3},
  [1324] = {.lex_state = 6, .external_lex_state = 3},
  [1325] = {.lex_state = 6, .external_lex_state = 4},
  [1326] = {.lex_state = 6, .external_lex_state = 3},
  [1327] = {.lex_state = 6, .external_lex_state = 3},
  [1328] = {.lex_state = 6, .external_lex_state = 3},
  [1329] = {.lex_state = 6, .external_lex_state = 3},
  [1330] = {.lex_state = 6, .external_lex_state = 3},
  [1331] = {.lex_state = 6, .external_lex_state = 3},
  [1332] = {.lex_state = 6, .external_lex_state = 3},
  [1333] = {.lex_state = 6, .external_lex_state = 4},
  [1334] = {.lex_state = 6, .external_lex_state = 3},
  [1335] = {.lex_state = 6, .external_lex_state = 3},
  [1336] = {.lex_state = 6, .external_lex_state = 3},
  [1337] = {.lex_state = 6, .external_lex_state = 3},
  [1338] = {.lex_state = 6, .external_lex_state = 3},
  [1339] = {.lex_state = 6, .external_lex_state = 4},
  [1340] = {.lex_state = 6, .external_lex_state = 3},
  [1341] = {.lex_state = 6, .external_lex_state = 3},
  [1342] = {.lex_state = 6, .external_lex_state = 4},
  [1343] = {.lex_state = 6, .external_lex_state = 3},
  [1344] = {.lex_state = 6, .external_lex_state = 3},
  [1345] = {.lex_state = 6, .external_lex_state = 4},
  [1346] = {.lex_state = 6, .external_lex_state = 4},
  [1347] = {.lex_state = 6, .external_lex_state = 3},
  [1348] = {.lex_state = 6, .external_lex_state = 3},
  [1349] = {.lex_state = 13, .external_lex_state = 2},
  [1350] = {.lex_state = 6, .external_lex_state = 3},
  [1351] = {.lex_state = 6, .external_lex_state = 3},
  [1352] = {.lex_state = 13, .external_lex_state = 2},
  [1353] = {.lex_state = 6, .external_lex_state = 4},
  [1354] = {.lex_state = 6, .external_lex_state = 3},
  [1355] = {.lex_state = 13, .external_lex_state = 2},
  [1356] = {.lex_state = 6, .external_lex_state = 4},
  [1357] = {.lex_state = 6, .external_lex_state = 4},
  [1358] = {.lex_state = 6, .external_lex_state = 4},
  [1359] = {.lex_state = 6, .external_lex_state = 4},
  [1360] = {.lex_state = 13, .external_lex_state = 2},
  [1361] = {.lex_state = 6, .external_lex_state = 3},
  [1362] = {.lex_state = 13, .external_lex_state = 2},
  [1363] = {.lex_state = 6, .external_lex_state = 3},
  [1364] = {.lex_state = 6, .external_lex_state = 4},
  [1365] = {.lex_state = 13, .external_lex_state = 2},
  [1366] = {.lex_state = 6, .external_lex_state = 3},
  [1367] = {.lex_state = 6, .external_lex_state = 3},
  [1368] = {.lex_state = 6, .external_lex_state = 4},
  [1369] = {.lex_state = 13, .external_lex_state = 2},
  [1370] = {.lex_state = 6, .external_lex_state = 3},
  [1371] = {.lex_state = 6, .external_lex_state = 4},
  [1372] = {.lex_state = 13, .external_lex_state = 2},
  [1373] = {.lex_state = 6, .external_lex_state = 3},
  [1374] = {.lex_state = 6, .external_lex_state = 3},
  [1375] = {.lex_state = 6, .external_lex_state = 3},
  [1376] = {.lex_state = 6, .external_lex_state = 3},
  [1377] = {.lex_state = 6, .external_lex_state = 3},
  [1378] = {.lex_state = 6, .external_lex_state = 3},
  [1379] = {.lex_state = 6, .external_lex_state = 3},
  [1380] = {.lex_state = 6, .external_lex_state = 4},
  [1381] = {.lex_state = 6, .external_lex_state = 4},
  [1382] = {.lex_state = 6, .external_lex_state = 4},
  [1383] = {.lex_state = 6, .external_lex_state = 4},
  [1384] = {.lex_state = 6, .external_lex_state = 4},
  [1385] = {.lex_state = 6, .external_lex_state = 3},
  [1386] = {.lex_state = 6, .external_lex_state = 4},
  [1387] = {.lex_state = 6, .external_lex_state = 4},
  [1388] = {.lex_state = 6, .external_lex_state = 4},
  [1389] = {.lex_state = 6, .external_lex_state = 3},
  [1390] = {.lex_state = 6, .external_lex_state = 4},
  [1391] = {.lex_state = 6, .external_lex_state = 3},
  [1392] = {.lex_state = 6, .external_lex_state = 4},
  [1393] = {.lex_state = 6, .external_lex_state = 4},
  [1394] = {.lex_state = 6, .external_lex_state = 4},
  [1395] = {.lex_state = 6, .external_lex_state = 4},
  [1396] = {.lex_state = 6, .external_lex_state = 4},
  [1397] = {.lex_state = 6, .external_lex_state = 4},
  [1398] = {.lex_state = 6, .external_lex_state = 3},
  [1399] = {.lex_state = 6, .external_lex_state = 4},
  [1400] = {.lex_state = 6, .external_lex_state = 3},
  [1401] = {.lex_state = 6, .external_lex_state = 4},
  [1402] = {.lex_state = 6, .external_lex_state = 4},
  [1403] = {.lex_state = 6, .external_lex_state = 3},
  [1404] = {.lex_state = 6, .external_lex_state = 3},
  [1405] = {.lex_state = 6, .external_lex_state = 4},
  [1406] = {.lex_state = 6, .external_lex_state = 3},
  [1407] = {.lex_state = 6, .external_lex_state = 4},
  [1408] = {.lex_state = 6, .external_lex_state = 3},
  [1409] = {.lex_state = 6, .external_lex_state = 3},
  [1410] = {.lex_state = 6, .external_lex_state = 4},
  [1411] = {.lex_state = 6, .external_lex_state = 4},
  [1412] = {.lex_state = 6, .external_lex_state = 4},
  [1413] = {.lex_state = 6, .external_lex_state = 3},
  [1414] = {.lex_state = 6, .external_lex_state = 4},
  [1415] = {.lex_state = 6, .external_lex_state = 4},
  [1416] = {.lex_state = 6, .external_lex_state = 4},
  [1417] = {.lex_state = 6, .external_lex_state = 4},
  [1418] = {.lex_state = 6, .external_lex_state = 4},
  [1419] = {.lex_state = 6, .external_lex_state = 4},
  [1420] = {.lex_state = 6, .external_lex_state = 4},
  [1421] = {.lex_state = 6, .external_lex_state = 4},
  [1422] = {.lex_state = 13, .external_lex_state = 2},
  [1423] = {.lex_state = 13, .external_lex_state = 2},
  [1424] = {.lex_state = 11, .external_lex_state = 2},
  [1425] = {.lex_state = 6, .external_lex_state = 3},
  [1426] = {.lex_state = 6, .external_lex_state = 4},
  [1427] = {.lex_state = 6, .external_lex_state = 3},
  [1428] = {.lex_state = 11, .external_lex_state = 2},
  [1429] = {.lex_state = 11, .external_lex_state = 2},
  [1430] = {.lex_state = 6, .external_lex_state = 3},
  [1431] = {.lex_state = 13, .external_lex_state = 2},
  [1432] = {.lex_state = 6, .external_lex_state = 4},
  [1433] = {.lex_state = 6, .external_lex_state = 3},
  [1434] = {.lex_state = 6, .external_lex_state = 3},
  [1435] = {.lex_state = 13, .external_lex_state = 2},
  [1436] = {.lex_state = 6, .external_lex_state = 3},
  [1437] = {.lex_state = 11, .external_lex_state = 2},
  [1438] = {.lex_state = 6, .external_lex_state = 4},
  [1439] = {.lex_state = 6, .external_lex_state = 4},
  [1440] = {.lex_state = 6, .external_lex_state = 3},
  [1441] = {.lex_state = 6, .external_lex_state = 3},
  [1442] = {.lex_state = 13, .external_lex_state = 2},
  [1443] = {.lex_state = 13, .external_lex_state = 2},
  [1444] = {.lex_state = 6, .external_lex_state = 3},
  [1445] = {.lex_state = 13, .external_lex_state = 2},
  [1446] = {.lex_state = 6, .external_lex_state = 3},
  [1447] = {.lex_state = 6, .external_lex_state = 3},
  [1448] = {.lex_state = 6, .external_lex_state = 3},
  [1449] = {.lex_state = 11, .external_lex_state = 2},
  [1450] = {.lex_state = 6, .external_lex_state = 3},
  [1451] = {.lex_state = 6, .external_lex_state = 4},
  [1452] = {.lex_state = 13, .external_lex_state = 2},
  [1453] = {.lex_state = 6, .external_lex_state = 3},
  [1454] = {.lex_state = 13, .external_lex_state = 2},
  [1455] = {.lex_state = 13, .external_lex_state = 2},
  [1456] = {.lex_state = 13, .external_lex_state = 2},
  [1457] = {.lex_state = 6, .external_lex_state = 3},
  [1458] = {.lex_state = 13, .external_lex_state = 2},
  [1459] = {.lex_state = 13, .external_lex_state = 2},
  [1460] = {.lex_state = 13, .external_lex_state = 2},
  [1461] = {.lex_state = 13, .external_lex_state = 2},
  [1462] = {.lex_state = 11, .external_lex_state = 2},
  [1463] = {.lex_state = 11, .external_lex_state = 2},
  [1464] = {.lex_state = 6, .external_lex_state = 4},
  [1465] = {.lex_state = 13, .external_lex_state = 2},
  [1466] = {.lex_state = 13, .external_lex_state = 2},
  [1467] = {.lex_state = 6, .external_lex_state = 4},
  [1468] = {.lex_state = 6, .external_lex_state = 4},
  [1469] = {.lex_state = 6, .external_lex_state = 3},
  [1470] = {.lex_state = 6, .external_lex_state = 4},
  [1471] = {.lex_state = 6, .external_lex_state = 3},
  [1472] = {.lex_state = 6, .external_lex_state = 3},
  [1473] = {.lex_state = 6, .external_lex_state = 3},
  [1474] = {.lex_state = 6, .external_lex_state = 3},
  [1475] = {.lex_state = 6, .external_lex_state = 3},
  [1476] = {.lex_state = 6, .external_lex_state = 4},
  [1477] = {.lex_state = 6, .external_lex_state = 3},
  [1478] = {.lex_state = 6, .external_lex_state = 4},
  [1479] = {.lex_state = 6, .external_lex_state = 3},
  [1480] = {.lex_state = 6, .external_lex_state = 4},
  [1481] = {.lex_state = 6, .external_lex_state = 3},
  [1482] = {.lex_state = 6, .external_lex_state = 3},
  [1483] = {.lex_state = 6, .external_lex_state = 3},
  [1484] = {.lex_state = 6, .external_lex_state = 3},
  [1485] = {.lex_state = 6, .external_lex_state = 3},
  [1486] = {.lex_state = 6, .external_lex_state = 3},
  [1487] = {.lex_state = 6, .external_lex_state = 4},
  [1488] = {.lex_state = 6, .external_lex_state = 3},
  [1489] = {.lex_state = 6, .external_lex_state = 3},
  [1490] = {.lex_state = 6, .external_lex_state = 3},
  [1491] = {.lex_state = 6, .external_lex_state = 3},
  [1492] = {.lex_state = 6, .external_lex_state = 3},
  [1493] = {.lex_state = 6, .external_lex_state = 3},
  [1494] = {.lex_state = 6, .external_lex_state = 3},
  [1495] = {.lex_state = 6, .external_lex_state = 3},
  [1496] = {.lex_state = 6, .external_lex_state = 3},
  [1497] = {.lex_state = 11, .external_lex_state = 2},
  [1498] = {.lex_state = 6, .external_lex_state = 3},
  [1499] = {.lex_state = 6, .external_lex_state = 3},
  [1500] = {.lex_state = 6, .external_lex_state = 3},
  [1501] = {.lex_state = 95, .external_lex_state = 2},
  [1502] = {.lex_state = 6, .external_lex_state = 3},
  [1503] = {.lex_state = 6, .external_lex_state = 3},
  [1504] = {.lex_state = 6, .external_lex_state = 3},
  [1505] = {.lex_state = 6, .external_lex_state = 3},
  [1506] = {.lex_state = 6, .external_lex_state = 3},
  [1507] = {.lex_state = 6, .external_lex_state = 3},
  [1508] = {.lex_state = 6, .external_lex_state = 3},
  [1509] = {.lex_state = 6, .external_lex_state = 3},
  [1510] = {.lex_state = 6, .external_lex_state = 3},
  [1511] = {.lex_state = 95, .external_lex_state = 2},
  [1512] = {.lex_state = 6, .external_lex_state = 3},
  [1513] = {.lex_state = 6, .external_lex_state = 3},
  [1514] = {.lex_state = 6, .external_lex_state = 3},
  [1515] = {.lex_state = 6, .external_lex_state = 3},
  [1516] = {.lex_state = 6, .external_lex_state = 3},
  [1517] = {.lex_state = 95, .external_lex_state = 2},
  [1518] = {.lex_state = 6, .external_lex_state = 3},
  [1519] = {.lex_state = 6, .external_lex_state = 3},
  [1520] = {.lex_state = 6, .external_lex_state = 3},
  [1521] = {.lex_state = 95, .external_lex_state = 2},
  [1522] = {.lex_state = 6, .external_lex_state = 3},
  [1523] = {.lex_state = 6, .external_lex_state = 3},
  [1524] = {.lex_state = 6, .external_lex_state = 3},
  [1525] = {.lex_state = 95, .external_lex_state = 2},
  [1526] = {.lex_state = 6, .external_lex_state = 3},
  [1527] = {.lex_state = 6, .external_lex_state = 3},
  [1528] = {.lex_state = 6, .external_lex_state = 3},
  [1529] = {.lex_state = 13, .external_lex_state = 5},
  [1530] = {.lex_state = 6, .external_lex_state = 3},
  [1531] = {.lex_state = 6, .external_lex_state = 3},
  [1532] = {.lex_state = 13, .external_lex_state = 5},
  [1533] = {.lex_state = 13, .external_lex_state = 5},
  [1534] = {.lex_state = 13, .external_lex_state = 5},
  [1535] = {.lex_state = 13, .external_lex_state = 5},
  [1536] = {.lex_state = 13, .external_lex_state = 5},
  [1537] = {.lex_state = 6, .external_lex_state = 3},
  [1538] = {.lex_state = 6, .external_lex_state = 3},
  [1539] = {.lex_state = 6, .external_lex_state = 3},
  [1540] = {.lex_state = 13, .external_lex_state = 5},
  [1541] = {.lex_state = 13, .external_lex_state = 5},
  [1542] = {.lex_state = 6, .external_lex_state = 3},
  [1543] = {.lex_state = 6, .external_lex_state = 3},
  [1544] = {.lex_state = 13, .external_lex_state = 2},
  [1545] = {.lex_state = 13, .external_lex_state = 5},
  [1546] = {.lex_state = 13, .external_lex_state = 5},
  [1547] = {.lex_state = 13, .external_lex_state = 2},
  [1548] = {.lex_state = 13, .external_lex_state = 5},
  [1549] = {.lex_state = 13, .external_lex_state = 5},
  [1550] = {.lex_state = 13, .external_lex_state = 5},
  [1551] = {.lex_state = 13, .external_lex_state = 5},
  [1552] = {.lex_state = 13, .external_lex_state = 5},
  [1553] = {.lex_state = 13, .external_lex_state = 5},
  [1554] = {.lex_state = 13, .external_lex_state = 5},
  [1555] = {.lex_state = 13, .external_lex_state = 5},
  [1556] = {.lex_state = 13, .external_lex_state = 5},
  [1557] = {.lex_state = 13, .external_lex_state = 5},
  [1558] = {.lex_state = 13, .external_lex_state = 5},
  [1559] = {.lex_state = 13, .external_lex_state = 5},
  [1560] = {.lex_state = 13, .external_lex_state = 5},
  [1561] = {.lex_state = 13, .external_lex_state = 5},
  [1562] = {.lex_state = 13, .external_lex_state = 5},
  [1563] = {.lex_state = 13, .external_lex_state = 5},
  [1564] = {.lex_state = 13, .external_lex_state = 5},
  [1565] = {.lex_state = 13, .external_lex_state = 5},
  [1566] = {.lex_state = 13, .external_lex_state = 5},
  [1567] = {.lex_state = 13, .external_lex_state = 5},
  [1568] = {.lex_state = 13, .external_lex_state = 5},
  [1569] = {.lex_state = 13, .external_lex_state = 5},
  [1570] = {.lex_state = 13, .external_lex_state = 5},
  [1571] = {.lex_state = 13, .external_lex_state = 5},
  [1572] = {.lex_state = 13, .external_lex_state = 5},
  [1573] = {.lex_state = 95, .external_lex_state = 2},
  [1574] = {.lex_state = 13, .external_lex_state = 5},
  [1575] = {.lex_state = 13, .external_lex_state = 5},
  [1576] = {.lex_state = 13, .external_lex_state = 5},
  [1577] = {.lex_state = 13, .external_lex_state = 5},
  [1578] = {.lex_state = 13, .external_lex_state = 5},
  [1579] = {.lex_state = 13, .external_lex_state = 5},
  [1580] = {.lex_state = 13, .external_lex_state = 2},
  [1581] = {.lex_state = 13, .external_lex_state = 2},
  [1582] = {.lex_state = 13, .external_lex_state = 5},
  [1583] = {.lex_state = 13, .external_lex_state = 2},
  [1584] = {.lex_state = 11, .external_lex_state = 2},
  [1585] = {.lex_state = 13, .external_lex_state = 5},
  [1586] = {.lex_state = 13, .external_lex_state = 5},
  [1587] = {.lex_state = 13, .external_lex_state = 2},
  [1588] = {.lex_state = 13, .external_lex_state = 5},
  [1589] = {.lex_state = 13, .external_lex_state = 5},
  [1590] = {.lex_state = 13, .external_lex_state = 5},
  [1591] = {.lex_state = 13, .external_lex_state = 5},
  [1592] = {.lex_state = 13, .external_lex_state = 5},
  [1593] = {.lex_state = 13, .external_lex_state = 5},
  [1594] = {.lex_state = 11, .external_lex_state = 2},
  [1595] = {.lex_state = 13, .external_lex_state = 5},
  [1596] = {.lex_state = 13, .external_lex_state = 2},
  [1597] = {.lex_state = 13, .external_lex_state = 5},
  [1598] = {.lex_state = 13, .external_lex_state = 5},
  [1599] = {.lex_state = 13, .external_lex_state = 2},
  [1600] = {.lex_state = 13, .external_lex_state = 5},
  [1601] = {.lex_state = 13, .external_lex_state = 2},
  [1602] = {.lex_state = 13, .external_lex_state = 5},
  [1603] = {.lex_state = 13, .external_lex_state = 5},
  [1604] = {.lex_state = 13, .external_lex_state = 2},
  [1605] = {.lex_state = 13, .external_lex_state = 5},
  [1606] = {.lex_state = 13, .external_lex_state = 5},
  [1607] = {.lex_state = 13, .external_lex_state = 5},
  [1608] = {.lex_state = 13, .external_lex_state = 2},
  [1609] = {.lex_state = 13, .external_lex_state = 5},
  [1610] = {.lex_state = 13, .external_lex_state = 5},
  [1611] = {.lex_state = 13, .external_lex_state = 2},
  [1612] = {.lex_state = 13, .external_lex_state = 2},
  [1613] = {.lex_state = 13, .external_lex_state = 5},
  [1614] = {.lex_state = 13, .external_lex_state = 5},
  [1615] = {.lex_state = 13, .external_lex_state = 5},
  [1616] = {.lex_state = 13, .external_lex_state = 5},
  [1617] = {.lex_state = 13, .external_lex_state = 2},
  [1618] = {.lex_state = 13, .external_lex_state = 5},
  [1619] = {.lex_state = 13, .external_lex_state = 2},
  [1620] = {.lex_state = 13, .external_lex_state = 5},
  [1621] = {.lex_state = 13, .external_lex_state = 5},
  [1622] = {.lex_state = 13, .external_lex_state = 2},
  [1623] = {.lex_state = 13, .external_lex_state = 2},
  [1624] = {.lex_state = 13, .external_lex_state = 2},
  [1625] = {.lex_state = 13, .external_lex_state = 5},
  [1626] = {.lex_state = 13, .external_lex_state = 5},
  [1627] = {.lex_state = 13, .external_lex_state = 5},
  [1628] = {.lex_state = 13, .external_lex_state = 5},
  [1629] = {.lex_state = 13, .external_lex_state = 5},
  [1630] = {.lex_state = 13, .external_lex_state = 5},
  [1631] = {.lex_state = 13, .external_lex_state = 5},
  [1632] = {.lex_state = 13, .external_lex_state = 5},
  [1633] = {.lex_state = 13, .external_lex_state = 5},
  [1634] = {.lex_state = 13, .external_lex_state = 5},
  [1635] = {.lex_state = 13, .external_lex_state = 2},
  [1636] = {.lex_state = 13, .external_lex_state = 5},
  [1637] = {.lex_state = 13, .external_lex_state = 2},
  [1638] = {.lex_state = 13, .external_lex_state = 5},
  [1639] = {.lex_state = 13, .external_lex_state = 5},
  [1640] = {.lex_state = 7, .external_lex_state = 4},
  [1641] = {.lex_state = 13, .external_lex_state = 5},
  [1642] = {.lex_state = 7, .external_lex_state = 4},
  [1643] = {.lex_state = 13, .external_lex_state = 5},
  [1644] = {.lex_state = 13, .external_lex_state = 5},
  [1645] = {.lex_state = 11, .external_lex_state = 2},
  [1646] = {.lex_state = 13, .external_lex_state = 2},
  [1647] = {.lex_state = 13, .external_lex_state = 5},
  [1648] = {.lex_state = 13, .external_lex_state = 5},
  [1649] = {.lex_state = 13, .external_lex_state = 5},
  [1650] = {.lex_state = 13, .external_lex_state = 2},
  [1651] = {.lex_state = 13, .external_lex_state = 5},
  [1652] = {.lex_state = 11, .external_lex_state = 2},
  [1653] = {.lex_state = 13, .external_lex_state = 5},
  [1654] = {.lex_state = 13, .external_lex_state = 5},
  [1655] = {.lex_state = 13, .external_lex_state = 5},
  [1656] = {.lex_state = 13, .external_lex_state = 5},
  [1657] = {.lex_state = 13, .external_lex_state = 5},
  [1658] = {.lex_state = 13, .external_lex_state = 5},
  [1659] = {.lex_state = 13, .external_lex_state = 5},
  [1660] = {.lex_state = 13, .external_lex_state = 5},
  [1661] = {.lex_state = 13, .external_lex_state = 5},
  [1662] = {.lex_state = 13, .external_lex_state = 5},
  [1663] = {.lex_state = 13, .external_lex_state = 5},
  [1664] = {.lex_state = 13, .external_lex_state = 5},
  [1665] = {.lex_state = 13, .external_lex_state = 2},
  [1666] = {.lex_state = 13, .external_lex_state = 5},
  [1667] = {.lex_state = 13, .external_lex_state = 5},
  [1668] = {.lex_state = 13, .external_lex_state = 5},
  [1669] = {.lex_state = 13, .external_lex_state = 5},
  [1670] = {.lex_state = 13, .external_lex_state = 5},
  [1671] = {.lex_state = 13, .external_lex_state = 5},
  [1672] = {.lex_state = 13, .external_lex_state = 2},
  [1673] = {.lex_state = 13, .external_lex_state = 5},
  [1674] = {.lex_state = 13, .external_lex_state = 5},
  [1675] = {.lex_state = 13, .external_lex_state = 5},
  [1676] = {.lex_state = 13, .external_lex_state = 2},
  [1677] = {.lex_state = 13, .external_lex_state = 2},
  [1678] = {.lex_state = 13, .external_lex_state = 5},
  [1679] = {.lex_state = 13, .external_lex_state = 5},
  [1680] = {.lex_state = 13, .external_lex_state = 2},
  [1681] = {.lex_state = 13, .external_lex_state = 2},
  [1682] = {.lex_state = 11, .external_lex_state = 2},
  [1683] = {.lex_state = 13, .external_lex_state = 5},
  [1684] = {.lex_state = 7, .external_lex_state = 3},
  [1685] = {.lex_state = 13, .external_lex_state = 5},
  [1686] = {.lex_state = 13, .external_lex_state = 5},
  [1687] = {.lex_state = 13, .external_lex_state = 5},
  [1688] = {.lex_state = 13, .external_lex_state = 5},
  [1689] = {.lex_state = 13, .external_lex_state = 5},
  [1690] = {.lex_state = 13, .external_lex_state = 2},
  [1691] = {.lex_state = 13, .external_lex_state = 5},
  [1692] = {.lex_state = 13, .external_lex_state = 5},
  [1693] = {.lex_state = 13, .external_lex_state = 5},
  [1694] = {.lex_state = 13, .external_lex_state = 5},
  [1695] = {.lex_state = 13, .external_lex_state = 5},
  [1696] = {.lex_state = 13, .external_lex_state = 5},
  [1697] = {.lex_state = 7, .external_lex_state = 3},
  [1698] = {.lex_state = 13, .external_lex_state = 2},
  [1699] = {.lex_state = 13, .external_lex_state = 5},
  [1700] = {.lex_state = 13, .external_lex_state = 5},
  [1701] = {.lex_state = 7, .external_lex_state = 3},
  [1702] = {.lex_state = 13, .external_lex_state = 5},
  [1703] = {.lex_state = 7, .external_lex_state = 3},
  [1704] = {.lex_state = 13, .external_lex_state = 5},
  [1705] = {.lex_state = 13, .external_lex_state = 2},
  [1706] = {.lex_state = 13, .external_lex_state = 2},
  [1707] = {.lex_state = 7, .external_lex_state = 3},
  [1708] = {.lex_state = 13, .external_lex_state = 5},
  [1709] = {.lex_state = 13, .external_lex_state = 5},
  [1710] = {.lex_state = 7, .external_lex_state = 3},
  [1711] = {.lex_state = 7, .external_lex_state = 3},
  [1712] = {.lex_state = 13, .external_lex_state = 2},
  [1713] = {.lex_state = 7, .external_lex_state = 3},
  [1714] = {.lex_state = 13, .external_lex_state = 2},
  [1715] = {.lex_state = 7, .external_lex_state = 3},
  [1716] = {.lex_state = 13, .external_lex_state = 2},
  [1717] = {.lex_state = 11, .external_lex_state = 5},
  [1718] = {.lex_state = 11, .external_lex_state = 5},
  [1719] = {.lex_state = 11, .external_lex_state = 5},
  [1720] = {.lex_state = 11, .external_lex_state = 5},
  [1721] = {.lex_state = 11, .external_lex_state = 5},
  [1722] = {.lex_state = 7, .external_lex_state = 3},
  [1723] = {.lex_state = 11, .external_lex_state = 5},
  [1724] = {.lex_state = 11, .external_lex_state = 5},
  [1725] = {.lex_state = 7, .external_lex_state = 3},
  [1726] = {.lex_state = 7, .external_lex_state = 4},
  [1727] = {.lex_state = 7, .external_lex_state = 3},
  [1728] = {.lex_state = 11, .external_lex_state = 5},
  [1729] = {.lex_state = 7, .external_lex_state = 3},
  [1730] = {.lex_state = 7, .external_lex_state = 3},
  [1731] = {.lex_state = 13, .external_lex_state = 2},
  [1732] = {.lex_state = 11, .external_lex_state = 2},
  [1733] = {.lex_state = 13, .external_lex_state = 2},
  [1734] = {.lex_state = 7, .external_lex_state = 4},
  [1735] = {.lex_state = 11, .external_lex_state = 5},
  [1736] = {.lex_state = 7, .external_lex_state = 3},
  [1737] = {.lex_state = 13, .external_lex_state = 5},
  [1738] = {.lex_state = 7, .external_lex_state = 4},
  [1739] = {.lex_state = 7, .external_lex_state = 3},
  [1740] = {.lex_state = 7, .external_lex_state = 4},
  [1741] = {.lex_state = 11, .external_lex_state = 5},
  [1742] = {.lex_state = 7, .external_lex_state = 3},
  [1743] = {.lex_state = 13, .external_lex_state = 5},
  [1744] = {.lex_state = 7, .external_lex_state = 3},
  [1745] = {.lex_state = 7, .external_lex_state = 3},
  [1746] = {.lex_state = 7, .external_lex_state = 3},
  [1747] = {.lex_state = 7, .external_lex_state = 3},
  [1748] = {.lex_state = 7, .external_lex_state = 3},
  [1749] = {.lex_state = 7, .external_lex_state = 3},
  [1750] = {.lex_state = 7, .external_lex_state = 3},
  [1751] = {.lex_state = 7, .external_lex_state = 3},
  [1752] = {.lex_state = 7, .external_lex_state = 3},
  [1753] = {.lex_state = 7, .external_lex_state = 3},
  [1754] = {.lex_state = 7, .external_lex_state = 3},
  [1755] = {.lex_state = 13, .external_lex_state = 2},
  [1756] = {.lex_state = 7, .external_lex_state = 3},
  [1757] = {.lex_state = 7, .external_lex_state = 3},
  [1758] = {.lex_state = 7, .external_lex_state = 3},
  [1759] = {.lex_state = 7, .external_lex_state = 3},
  [1760] = {.lex_state = 7, .external_lex_state = 3},
  [1761] = {.lex_state = 7, .external_lex_state = 3},
  [1762] = {.lex_state = 7, .external_lex_state = 3},
  [1763] = {.lex_state = 7, .external_lex_state = 3},
  [1764] = {.lex_state = 7, .external_lex_state = 3},
  [1765] = {.lex_state = 7, .external_lex_state = 3},
  [1766] = {.lex_state = 13, .external_lex_state = 2},
  [1767] = {.lex_state = 11, .external_lex_state = 5},
  [1768] = {.lex_state = 7, .external_lex_state = 3},
  [1769] = {.lex_state = 7, .external_lex_state = 3},
  [1770] = {.lex_state = 7, .external_lex_state = 3},
  [1771] = {.lex_state = 11, .external_lex_state = 5},
  [1772] = {.lex_state = 7, .external_lex_state = 3},
  [1773] = {.lex_state = 7, .external_lex_state = 3},
  [1774] = {.lex_state = 7, .external_lex_state = 3},
  [1775] = {.lex_state = 7, .external_lex_state = 3},
  [1776] = {.lex_state = 7, .external_lex_state = 3},
  [1777] = {.lex_state = 7, .external_lex_state = 3},
  [1778] = {.lex_state = 7, .external_lex_state = 3},
  [1779] = {.lex_state = 7, .external_lex_state = 3},
  [1780] = {.lex_state = 7, .external_lex_state = 3},
  [1781] = {.lex_state = 7, .external_lex_state = 3},
  [1782] = {.lex_state = 7, .external_lex_state = 3},
  [1783] = {.lex_state = 7, .external_lex_state = 3},
  [1784] = {.lex_state = 11, .external_lex_state = 5},
  [1785] = {.lex_state = 13, .external_lex_state = 2},
  [1786] = {.lex_state = 7, .external_lex_state = 3},
  [1787] = {.lex_state = 13, .external_lex_state = 2},
  [1788] = {.lex_state = 13, .external_lex_state = 2},
  [1789] = {.lex_state = 13, .external_lex_state = 2},
  [1790] = {.lex_state = 13, .external_lex_state = 2},
  [1791] = {.lex_state = 7, .external_lex_state = 3},
  [1792] = {.lex_state = 7, .external_lex_state = 3},
  [1793] = {.lex_state = 7, .external_lex_state = 3},
  [1794] = {.lex_state = 7, .external_lex_state = 3},
  [1795] = {.lex_state = 7, .external_lex_state = 3},
  [1796] = {.lex_state = 7, .external_lex_state = 3},
  [1797] = {.lex_state = 7, .external_lex_state = 3},
  [1798] = {.lex_state = 7, .external_lex_state = 3},
  [1799] = {.lex_state = 7, .external_lex_state = 3},
  [1800] = {.lex_state = 11, .external_lex_state = 5},
  [1801] = {.lex_state = 7, .external_lex_state = 3},
  [1802] = {.lex_state = 11, .external_lex_state = 5},
  [1803] = {.lex_state = 7, .external_lex_state = 3},
  [1804] = {.lex_state = 7, .external_lex_state = 3},
  [1805] = {.lex_state = 7, .external_lex_state = 3},
  [1806] = {.lex_state = 7, .external_lex_state = 3},
  [1807] = {.lex_state = 7, .external_lex_state = 3},
  [1808] = {.lex_state = 7, .external_lex_state = 3},
  [1809] = {.lex_state = 7, .external_lex_state = 3},
  [1810] = {.lex_state = 11, .external_lex_state = 5},
  [1811] = {.lex_state = 7, .external_lex_state = 3},
  [1812] = {.lex_state = 7, .external_lex_state = 3},
  [1813] = {.lex_state = 11, .external_lex_state = 5},
  [1814] = {.lex_state = 7, .external_lex_state = 3},
  [1815] = {.lex_state = 11, .external_lex_state = 5},
  [1816] = {.lex_state = 13, .external_lex_state = 2},
  [1817] = {.lex_state = 13, .external_lex_state = 2},
  [1818] = {.lex_state = 7, .external_lex_state = 3},
  [1819] = {.lex_state = 7, .external_lex_state = 3},
  [1820] = {.lex_state = 7, .external_lex_state = 3},
  [1821] = {.lex_state = 7, .external_lex_state = 3},
  [1822] = {.lex_state = 13, .external_lex_state = 2},
  [1823] = {.lex_state = 13, .external_lex_state = 2},
  [1824] = {.lex_state = 13, .external_lex_state = 2},
  [1825] = {.lex_state = 13, .external_lex_state = 2},
  [1826] = {.lex_state = 13, .external_lex_state = 2},
  [1827] = {.lex_state = 13, .external_lex_state = 2},
  [1828] = {.lex_state = 7, .external_lex_state = 4},
  [1829] = {.lex_state = 7, .external_lex_state = 3},
  [1830] = {.lex_state = 7, .external_lex_state = 4},
  [1831] = {.lex_state = 7, .external_lex_state = 3},
  [1832] = {.lex_state = 7, .external_lex_state = 3},
  [1833] = {.lex_state = 7, .external_lex_state = 3},
  [1834] = {.lex_state = 7, .external_lex_state = 3},
  [1835] = {.lex_state = 7, .external_lex_state = 3},
  [1836] = {.lex_state = 7, .external_lex_state = 3},
  [1837] = {.lex_state = 7, .external_lex_state = 3},
  [1838] = {.lex_state = 7, .external_lex_state = 3},
  [1839] = {.lex_state = 11, .external_lex_state = 5},
  [1840] = {.lex_state = 7, .external_lex_state = 3},
  [1841] = {.lex_state = 7, .external_lex_state = 3},
  [1842] = {.lex_state = 7, .external_lex_state = 3},
  [1843] = {.lex_state = 7, .external_lex_state = 3},
  [1844] = {.lex_state = 11, .external_lex_state = 5},
  [1845] = {.lex_state = 14, .external_lex_state = 2},
  [1846] = {.lex_state = 7, .external_lex_state = 3},
  [1847] = {.lex_state = 7, .external_lex_state = 3},
  [1848] = {.lex_state = 7, .external_lex_state = 3},
  [1849] = {.lex_state = 7, .external_lex_state = 3},
  [1850] = {.lex_state = 7, .external_lex_state = 3},
  [1851] = {.lex_state = 7, .external_lex_state = 3},
  [1852] = {.lex_state = 7, .external_lex_state = 3},
  [1853] = {.lex_state = 7, .external_lex_state = 3},
  [1854] = {.lex_state = 7, .external_lex_state = 3},
  [1855] = {.lex_state = 11, .external_lex_state = 5},
  [1856] = {.lex_state = 11, .external_lex_state = 5},
  [1857] = {.lex_state = 7, .external_lex_state = 3},
  [1858] = {.lex_state = 7, .external_lex_state = 3},
  [1859] = {.lex_state = 7, .external_lex_state = 3},
  [1860] = {.lex_state = 7, .external_lex_state = 3},
  [1861] = {.lex_state = 7, .external_lex_state = 3},
  [1862] = {.lex_state = 7, .external_lex_state = 3},
  [1863] = {.lex_state = 7, .external_lex_state = 3},
  [1864] = {.lex_state = 14, .external_lex_state = 2},
  [1865] = {.lex_state = 7, .external_lex_state = 3},
  [1866] = {.lex_state = 7, .external_lex_state = 3},
  [1867] = {.lex_state = 7, .external_lex_state = 3},
  [1868] = {.lex_state = 7, .external_lex_state = 3},
  [1869] = {.lex_state = 7, .external_lex_state = 3},
  [1870] = {.lex_state = 7, .external_lex_state = 3},
  [1871] = {.lex_state = 7, .external_lex_state = 3},
  [1872] = {.lex_state = 7, .external_lex_state = 3},
  [1873] = {.lex_state = 7, .external_lex_state = 3},
  [1874] = {.lex_state = 7, .external_lex_state = 3},
  [1875] = {.lex_state = 7, .external_lex_state = 3},
  [1876] = {.lex_state = 7, .external_lex_state = 3},
  [1877] = {.lex_state = 11, .external_lex_state = 5},
  [1878] = {.lex_state = 7, .external_lex_state = 3},
  [1879] = {.lex_state = 11, .external_lex_state = 5},
  [1880] = {.lex_state = 7, .external_lex_state = 3},
  [1881] = {.lex_state = 7, .external_lex_state = 3},
  [1882] = {.lex_state = 7, .external_lex_state = 3},
  [1883] = {.lex_state = 7, .external_lex_state = 3},
  [1884] = {.lex_state = 11, .external_lex_state = 5},
  [1885] = {.lex_state = 7, .external_lex_state = 3},
  [1886] = {.lex_state = 7, .external_lex_state = 3},
  [1887] = {.lex_state = 7, .external_lex_state = 3},
  [1888] = {.lex_state = 7, .external_lex_state = 3},
  [1889] = {.lex_state = 7, .external_lex_state = 3},
  [1890] = {.lex_state = 7, .external_lex_state = 3},
  [1891] = {.lex_state = 7, .external_lex_state = 3},
  [1892] = {.lex_state = 7, .external_lex_state = 3},
  [1893] = {.lex_state = 7, .external_lex_state = 3},
  [1894] = {.lex_state = 7, .external_lex_state = 3},
  [1895] = {.lex_state = 7, .external_lex_state = 3},
  [1896] = {.lex_state = 7, .external_lex_state = 3},
  [1897] = {.lex_state = 7, .external_lex_state = 3},
  [1898] = {.lex_state = 7, .external_lex_state = 3},
  [1899] = {.lex_state = 7, .external_lex_state = 3},
  [1900] = {.lex_state = 7, .external_lex_state = 3},
  [1901] = {.lex_state = 13, .external_lex_state = 2},
  [1902] = {.lex_state = 7, .external_lex_state = 3},
  [1903] = {.lex_state = 7, .external_lex_state = 3},
  [1904] = {.lex_state = 7, .external_lex_state = 3},
  [1905] = {.lex_state = 7, .external_lex_state = 3},
  [1906] = {.lex_state = 7, .external_lex_state = 3},
  [1907] = {.lex_state = 7, .external_lex_state = 3},
  [1908] = {.lex_state = 7, .external_lex_state = 3},
  [1909] = {.lex_state = 7, .external_lex_state = 3},
  [1910] = {.lex_state = 7, .external_lex_state = 3},
  [1911] = {.lex_state = 7, .external_lex_state = 3},
  [1912] = {.lex_state = 7, .external_lex_state = 3},
  [1913] = {.lex_state = 7, .external_lex_state = 4},
  [1914] = {.lex_state = 7, .external_lex_state = 3},
  [1915] = {.lex_state = 7, .external_lex_state = 3},
  [1916] = {.lex_state = 7, .external_lex_state = 4},
  [1917] = {.lex_state = 7, .external_lex_state = 3},
  [1918] = {.lex_state = 7, .external_lex_state = 3},
  [1919] = {.lex_state = 7, .external_lex_state = 3},
  [1920] = {.lex_state = 7, .external_lex_state = 3},
  [1921] = {.lex_state = 7, .external_lex_state = 3},
  [1922] = {.lex_state = 7, .external_lex_state = 3},
  [1923] = {.lex_state = 7, .external_lex_state = 3},
  [1924] = {.lex_state = 7, .external_lex_state = 3},
  [1925] = {.lex_state = 7, .external_lex_state = 3},
  [1926] = {.lex_state = 7, .external_lex_state = 3},
  [1927] = {.lex_state = 7, .external_lex_state = 3},
  [1928] = {.lex_state = 13, .external_lex_state = 2},
  [1929] = {.lex_state = 13, .external_lex_state = 2},
  [1930] = {.lex_state = 11, .external_lex_state = 5},
  [1931] = {.lex_state = 7, .external_lex_state = 3},
  [1932] = {.lex_state = 7, .external_lex_state = 3},
  [1933] = {.lex_state = 7, .external_lex_state = 3},
  [1934] = {.lex_state = 7, .external_lex_state = 4},
  [1935] = {.lex_state = 7, .external_lex_state = 3},
  [1936] = {.lex_state = 7, .external_lex_state = 3},
  [1937] = {.lex_state = 7, .external_lex_state = 3},
  [1938] = {.lex_state = 7, .external_lex_state = 4},
  [1939] = {.lex_state = 7, .external_lex_state = 3},
  [1940] = {.lex_state = 7, .external_lex_state = 4},
  [1941] = {.lex_state = 7, .external_lex_state = 4},
  [1942] = {.lex_state = 7, .external_lex_state = 4},
  [1943] = {.lex_state = 7, .external_lex_state = 3},
  [1944] = {.lex_state = 7, .external_lex_state = 4},
  [1945] = {.lex_state = 7, .external_lex_state = 4},
  [1946] = {.lex_state = 7, .external_lex_state = 4},
  [1947] = {.lex_state = 7, .external_lex_state = 3},
  [1948] = {.lex_state = 7, .external_lex_state = 3},
  [1949] = {.lex_state = 7, .external_lex_state = 3},
  [1950] = {.lex_state = 7, .external_lex_state = 4},
  [1951] = {.lex_state = 7, .external_lex_state = 3},
  [1952] = {.lex_state = 7, .external_lex_state = 4},
  [1953] = {.lex_state = 7, .external_lex_state = 4},
  [1954] = {.lex_state = 7, .external_lex_state = 3},
  [1955] = {.lex_state = 7, .external_lex_state = 3},
  [1956] = {.lex_state = 7, .external_lex_state = 3},
  [1957] = {.lex_state = 7, .external_lex_state = 4},
  [1958] = {.lex_state = 7, .external_lex_state = 4},
  [1959] = {.lex_state = 7, .external_lex_state = 4},
  [1960] = {.lex_state = 7, .external_lex_state = 3},
  [1961] = {.lex_state = 7, .external_lex_state = 4},
  [1962] = {.lex_state = 7, .external_lex_state = 4},
  [1963] = {.lex_state = 7, .external_lex_state = 4},
  [1964] = {.lex_state = 7, .external_lex_state = 3},
  [1965] = {.lex_state = 7, .external_lex_state = 4},
  [1966] = {.lex_state = 7, .external_lex_state = 3},
  [1967] = {.lex_state = 7, .external_lex_state = 4},
  [1968] = {.lex_state = 7, .external_lex_state = 3},
  [1969] = {.lex_state = 7, .external_lex_state = 3},
  [1970] = {.lex_state = 7, .external_lex_state = 4},
  [1971] = {.lex_state = 7, .external_lex_state = 3},
  [1972] = {.lex_state = 7, .external_lex_state = 3},
  [1973] = {.lex_state = 7, .external_lex_state = 3},
  [1974] = {.lex_state = 7, .external_lex_state = 4},
  [1975] = {.lex_state = 7, .external_lex_state = 4},
  [1976] = {.lex_state = 7, .external_lex_state = 3},
  [1977] = {.lex_state = 7, .external_lex_state = 4},
  [1978] = {.lex_state = 7, .external_lex_state = 4},
  [1979] = {.lex_state = 7, .external_lex_state = 4},
  [1980] = {.lex_state = 7, .external_lex_state = 3},
  [1981] = {.lex_state = 7, .external_lex_state = 4},
  [1982] = {.lex_state = 7, .external_lex_state = 4},
  [1983] = {.lex_state = 7, .external_lex_state = 4},
  [1984] = {.lex_state = 7, .external_lex_state = 4},
  [1985] = {.lex_state = 7, .external_lex_state = 4},
  [1986] = {.lex_state = 7, .external_lex_state = 4},
  [1987] = {.lex_state = 7, .external_lex_state = 4},
  [1988] = {.lex_state = 7, .external_lex_state = 4},
  [1989] = {.lex_state = 7, .external_lex_state = 4},
  [1990] = {.lex_state = 7, .external_lex_state = 4},
  [1991] = {.lex_state = 7, .external_lex_state = 4},
  [1992] = {.lex_state = 7, .external_lex_state = 4},
  [1993] = {.lex_state = 7, .external_lex_state = 4},
  [1994] = {.lex_state = 7, .external_lex_state = 4},
  [1995] = {.lex_state = 7, .external_lex_state = 4},
  [1996] = {.lex_state = 7, .external_lex_state = 3},
  [1997] = {.lex_state = 7, .external_lex_state = 4},
  [1998] = {.lex_state = 7, .external_lex_state = 4},
  [1999] = {.lex_state = 7, .external_lex_state = 4},
  [2000] = {.lex_state = 7, .external_lex_state = 4},
  [2001] = {.lex_state = 7, .external_lex_state = 3},
  [2002] = {.lex_state = 7, .external_lex_state = 3},
  [2003] = {.lex_state = 7, .external_lex_state = 3},
  [2004] = {.lex_state = 7, .external_lex_state = 3},
  [2005] = {.lex_state = 7, .external_lex_state = 3},
  [2006] = {.lex_state = 7, .external_lex_state = 3},
  [2007] = {.lex_state = 7, .external_lex_state = 3},
  [2008] = {.lex_state = 7, .external_lex_state = 3},
  [2009] = {.lex_state = 7, .external_lex_state = 4},
  [2010] = {.lex_state = 7, .external_lex_state = 3},
  [2011] = {.lex_state = 7, .external_lex_state = 3},
  [2012] = {.lex_state = 7, .external_lex_state = 3},
  [2013] = {.lex_state = 7, .external_lex_state = 3},
  [2014] = {.lex_state = 7, .external_lex_state = 3},
  [2015] = {.lex_state = 7, .external_lex_state = 4},
  [2016] = {.lex_state = 7, .external_lex_state = 3},
  [2017] = {.lex_state = 7, .external_lex_state = 3},
  [2018] = {.lex_state = 7, .external_lex_state = 3},
  [2019] = {.lex_state = 7, .external_lex_state = 3},
  [2020] = {.lex_state = 7, .external_lex_state = 3},
  [2021] = {.lex_state = 7, .external_lex_state = 4},
  [2022] = {.lex_state = 7, .external_lex_state = 3},
  [2023] = {.lex_state = 7, .external_lex_state = 3},
  [2024] = {.lex_state = 7, .external_lex_state = 4},
  [2025] = {.lex_state = 7, .external_lex_state = 3},
  [2026] = {.lex_state = 13, .external_lex_state = 2},
  [2027] = {.lex_state = 7, .external_lex_state = 4},
  [2028] = {.lex_state = 7, .external_lex_state = 4},
  [2029] = {.lex_state = 7, .external_lex_state = 4},
  [2030] = {.lex_state = 7, .external_lex_state = 3},
  [2031] = {.lex_state = 7, .external_lex_state = 3},
  [2032] = {.lex_state = 7, .external_lex_state = 3},
  [2033] = {.lex_state = 7, .external_lex_state = 4},
  [2034] = {.lex_state = 7, .external_lex_state = 4},
  [2035] = {.lex_state = 7, .external_lex_state = 4},
  [2036] = {.lex_state = 7, .external_lex_state = 3},
  [2037] = {.lex_state = 7, .external_lex_state = 3},
  [2038] = {.lex_state = 7, .external_lex_state = 3},
  [2039] = {.lex_state = 7, .external_lex_state = 3},
  [2040] = {.lex_state = 7, .external_lex_state = 3},
  [2041] = {.lex_state = 7, .external_lex_state = 4},
  [2042] = {.lex_state = 7, .external_lex_state = 4},
  [2043] = {.lex_state = 7, .external_lex_state = 4},
  [2044] = {.lex_state = 7, .external_lex_state = 4},
  [2045] = {.lex_state = 7, .external_lex_state = 3},
  [2046] = {.lex_state = 7, .external_lex_state = 4},
  [2047] = {.lex_state = 7, .external_lex_state = 3},
  [2048] = {.lex_state = 7, .external_lex_state = 4},
  [2049] = {.lex_state = 7, .external_lex_state = 4},
  [2050] = {.lex_state = 7, .external_lex_state = 4},
  [2051] = {.lex_state = 7, .external_lex_state = 3},
  [2052] = {.lex_state = 7, .external_lex_state = 4},
  [2053] = {.lex_state = 7, .external_lex_state = 3},
  [2054] = {.lex_state = 7, .external_lex_state = 3},
  [2055] = {.lex_state = 7, .external_lex_state = 4},
  [2056] = {.lex_state = 7, .external_lex_state = 4},
  [2057] = {.lex_state = 7, .external_lex_state = 3},
  [2058] = {.lex_state = 7, .external_lex_state = 4},
  [2059] = {.lex_state = 7, .external_lex_state = 4},
  [2060] = {.lex_state = 7, .external_lex_state = 4},
  [2061] = {.lex_state = 7, .external_lex_state = 3},
  [2062] = {.lex_state = 7, .external_lex_state = 3},
  [2063] = {.lex_state = 7, .external_lex_state = 4},
  [2064] = {.lex_state = 7, .external_lex_state = 3},
  [2065] = {.lex_state = 7, .external_lex_state = 4},
  [2066] = {.lex_state = 7, .external_lex_state = 4},
  [2067] = {.lex_state = 7, .external_lex_state = 3},
  [2068] = {.lex_state = 7, .external_lex_state = 4},
  [2069] = {.lex_state = 7, .external_lex_state = 4},
  [2070] = {.lex_state = 7, .external_lex_state = 4},
  [2071] = {.lex_state = 7, .external_lex_state = 4},
  [2072] = {.lex_state = 7, .external_lex_state = 3},
  [2073] = {.lex_state = 7, .external_lex_state = 4},
  [2074] = {.lex_state = 7, .external_lex_state = 4},
  [2075] = {.lex_state = 7, .external_lex_state = 3},
  [2076] = {.lex_state = 7, .external_lex_state = 4},
  [2077] = {.lex_state = 7, .external_lex_state = 4},
  [2078] = {.lex_state = 7, .external_lex_state = 3},
  [2079] = {.lex_state = 7, .external_lex_state = 4},
  [2080] = {.lex_state = 7, .external_lex_state = 3},
  [2081] = {.lex_state = 7, .external_lex_state = 3},
  [2082] = {.lex_state = 7, .external_lex_state = 4},
  [2083] = {.lex_state = 7, .external_lex_state = 4},
  [2084] = {.lex_state = 7, .external_lex_state = 4},
  [2085] = {.lex_state = 7, .external_lex_state = 4},
  [2086] = {.lex_state = 7, .external_lex_state = 4},
  [2087] = {.lex_state = 7, .external_lex_state = 3},
  [2088] = {.lex_state = 7, .external_lex_state = 3},
  [2089] = {.lex_state = 7, .external_lex_state = 4},
  [2090] = {.lex_state = 13, .external_lex_state = 5},
  [2091] = {.lex_state = 13, .external_lex_state = 5},
  [2092] = {.lex_state = 13, .external_lex_state = 5},
  [2093] = {.lex_state = 7, .external_lex_state = 4},
  [2094] = {.lex_state = 13, .external_lex_state = 5},
  [2095] = {.lex_state = 7, .external_lex_state = 3},
  [2096] = {.lex_state = 7, .external_lex_state = 3},
  [2097] = {.lex_state = 7, .external_lex_state = 4},
  [2098] = {.lex_state = 13, .external_lex_state = 5},
  [2099] = {.lex_state = 7, .external_lex_state = 3},
  [2100] = {.lex_state = 7, .external_lex_state = 4},
  [2101] = {.lex_state = 7, .external_lex_state = 3},
  [2102] = {.lex_state = 13, .external_lex_state = 5},
  [2103] = {.lex_state = 7, .external_lex_state = 3},
  [2104] = {.lex_state = 13, .external_lex_state = 5},
  [2105] = {.lex_state = 13, .external_lex_state = 5},
  [2106] = {.lex_state = 7, .external_lex_state = 4},
  [2107] = {.lex_state = 13, .external_lex_state = 5},
  [2108] = {.lex_state = 13, .external_lex_state = 2},
  [2109] = {.lex_state = 13, .external_lex_state = 5},
  [2110] = {.lex_state = 7, .external_lex_state = 3},
  [2111] = {.lex_state = 7, .external_lex_state = 3},
  [2112] = {.lex_state = 7, .external_lex_state = 3},
  [2113] = {.lex_state = 7, .external_lex_state = 3},
  [2114] = {.lex_state = 7, .external_lex_state = 3},
  [2115] = {.lex_state = 7, .external_lex_state = 3},
  [2116] = {.lex_state = 7, .external_lex_state = 3},
  [2117] = {.lex_state = 7, .external_lex_state = 3},
  [2118] = {.lex_state = 7, .external_lex_state = 3},
  [2119] = {.lex_state = 7, .external_lex_state = 3},
  [2120] = {.lex_state = 13, .external_lex_state = 5},
  [2121] = {.lex_state = 7, .external_lex_state = 4},
  [2122] = {.lex_state = 7, .external_lex_state = 3},
  [2123] = {.lex_state = 13, .external_lex_state = 2},
  [2124] = {.lex_state = 13, .external_lex_state = 2},
  [2125] = {.lex_state = 7, .external_lex_state = 3},
  [2126] = {.lex_state = 7, .external_lex_state = 4},
  [2127] = {.lex_state = 7, .external_lex_state = 3},
  [2128] = {.lex_state = 7, .external_lex_state = 3},
  [2129] = {.lex_state = 7, .external_lex_state = 3},
  [2130] = {.lex_state = 7, .external_lex_state = 3},
  [2131] = {.lex_state = 7, .external_lex_state = 3},
  [2132] = {.lex_state = 13, .external_lex_state = 5},
  [2133] = {.lex_state = 7, .external_lex_state = 3},
  [2134] = {.lex_state = 7, .external_lex_state = 3},
  [2135] = {.lex_state = 7, .external_lex_state = 3},
  [2136] = {.lex_state = 7, .external_lex_state = 3},
  [2137] = {.lex_state = 7, .external_lex_state = 3},
  [2138] = {.lex_state = 7, .external_lex_state = 3},
  [2139] = {.lex_state = 7, .external_lex_state = 3},
  [2140] = {.lex_state = 7, .external_lex_state = 3},
  [2141] = {.lex_state = 7, .external_lex_state = 4},
  [2142] = {.lex_state = 13, .external_lex_state = 5},
  [2143] = {.lex_state = 13, .external_lex_state = 5},
  [2144] = {.lex_state = 13, .external_lex_state = 5},
  [2145] = {.lex_state = 13, .external_lex_state = 5},
  [2146] = {.lex_state = 7, .external_lex_state = 3},
  [2147] = {.lex_state = 7, .external_lex_state = 3},
  [2148] = {.lex_state = 13, .external_lex_state = 5},
  [2149] = {.lex_state = 7, .external_lex_state = 3},
  [2150] = {.lex_state = 7, .external_lex_state = 3},
  [2151] = {.lex_state = 13, .external_lex_state = 5},
  [2152] = {.lex_state = 7, .external_lex_state = 3},
  [2153] = {.lex_state = 7, .external_lex_state = 3},
  [2154] = {.lex_state = 7, .external_lex_state = 4},
  [2155] = {.lex_state = 13, .external_lex_state = 5},
  [2156] = {.lex_state = 7, .external_lex_state = 4},
  [2157] = {.lex_state = 13, .external_lex_state = 5},
  [2158] = {.lex_state = 7, .external_lex_state = 3},
  [2159] = {.lex_state = 13, .external_lex_state = 5},
  [2160] = {.lex_state = 13, .external_lex_state = 5},
  [2161] = {.lex_state = 7, .external_lex_state = 3},
  [2162] = {.lex_state = 7, .external_lex_state = 4},
  [2163] = {.lex_state = 13, .external_lex_state = 5},
  [2164] = {.lex_state = 7, .external_lex_state = 4},
  [2165] = {.lex_state = 13, .external_lex_state = 5},
  [2166] = {.lex_state = 7, .external_lex_state = 3},
  [2167] = {.lex_state = 7, .external_lex_state = 3},
  [2168] = {.lex_state = 13, .external_lex_state = 5},
  [2169] = {.lex_state = 7, .external_lex_state = 3},
  [2170] = {.lex_state = 7, .external_lex_state = 3},
  [2171] = {.lex_state = 7, .external_lex_state = 3},
  [2172] = {.lex_state = 7, .external_lex_state = 3},
  [2173] = {.lex_state = 7, .external_lex_state = 3},
  [2174] = {.lex_state = 7, .external_lex_state = 3},
  [2175] = {.lex_state = 7, .external_lex_state = 4},
  [2176] = {.lex_state = 7, .external_lex_state = 4},
  [2177] = {.lex_state = 7, .external_lex_state = 4},
  [2178] = {.lex_state = 7, .external_lex_state = 3},
  [2179] = {.lex_state = 13, .external_lex_state = 5},
  [2180] = {.lex_state = 13, .external_lex_state = 5},
  [2181] = {.lex_state = 7, .external_lex_state = 3},
  [2182] = {.lex_state = 13, .external_lex_state = 5},
  [2183] = {.lex_state = 13, .external_lex_state = 5},
  [2184] = {.lex_state = 13, .external_lex_state = 5},
  [2185] = {.lex_state = 13, .external_lex_state = 5},
  [2186] = {.lex_state = 7, .external_lex_state = 3},
  [2187] = {.lex_state = 7, .external_lex_state = 3},
  [2188] = {.lex_state = 7, .external_lex_state = 4},
  [2189] = {.lex_state = 13, .external_lex_state = 5},
  [2190] = {.lex_state = 7, .external_lex_state = 3},
  [2191] = {.lex_state = 7, .external_lex_state = 3},
  [2192] = {.lex_state = 13, .external_lex_state = 5},
  [2193] = {.lex_state = 13, .external_lex_state = 5},
  [2194] = {.lex_state = 7, .external_lex_state = 3},
  [2195] = {.lex_state = 13, .external_lex_state = 5},
  [2196] = {.lex_state = 13, .external_lex_state = 5},
  [2197] = {.lex_state = 13, .external_lex_state = 5},
  [2198] = {.lex_state = 13, .external_lex_state = 5},
  [2199] = {.lex_state = 7, .external_lex_state = 3},
  [2200] = {.lex_state = 7, .external_lex_state = 3},
  [2201] = {.lex_state = 7, .external_lex_state = 3},
  [2202] = {.lex_state = 7, .external_lex_state = 3},
  [2203] = {.lex_state = 7, .external_lex_state = 4},
  [2204] = {.lex_state = 7, .external_lex_state = 3},
  [2205] = {.lex_state = 7, .external_lex_state = 4},
  [2206] = {.lex_state = 7, .external_lex_state = 3},
  [2207] = {.lex_state = 13, .external_lex_state = 2},
  [2208] = {.lex_state = 13, .external_lex_state = 5},
  [2209] = {.lex_state = 7, .external_lex_state = 3},
  [2210] = {.lex_state = 13, .external_lex_state = 5},
  [2211] = {.lex_state = 13, .external_lex_state = 2},
  [2212] = {.lex_state = 13, .external_lex_state = 5},
  [2213] = {.lex_state = 13, .external_lex_state = 5},
  [2214] = {.lex_state = 13, .external_lex_state = 5},
  [2215] = {.lex_state = 7, .external_lex_state = 3},
  [2216] = {.lex_state = 7, .external_lex_state = 4},
  [2217] = {.lex_state = 7, .external_lex_state = 3},
  [2218] = {.lex_state = 7, .external_lex_state = 3},
  [2219] = {.lex_state = 13, .external_lex_state = 5},
  [2220] = {.lex_state = 7, .external_lex_state = 3},
  [2221] = {.lex_state = 7, .external_lex_state = 3},
  [2222] = {.lex_state = 7, .external_lex_state = 3},
  [2223] = {.lex_state = 7, .external_lex_state = 3},
  [2224] = {.lex_state = 13, .external_lex_state = 5},
  [2225] = {.lex_state = 7, .external_lex_state = 4},
  [2226] = {.lex_state = 13, .external_lex_state = 5},
  [2227] = {.lex_state = 7, .external_lex_state = 3},
  [2228] = {.lex_state = 13, .external_lex_state = 2},
  [2229] = {.lex_state = 7, .external_lex_state = 4},
  [2230] = {.lex_state = 7, .external_lex_state = 4},
  [2231] = {.lex_state = 7, .external_lex_state = 4},
  [2232] = {.lex_state = 7, .external_lex_state = 4},
  [2233] = {.lex_state = 7, .external_lex_state = 4},
  [2234] = {.lex_state = 7, .external_lex_state = 4},
  [2235] = {.lex_state = 7, .external_lex_state = 4},
  [2236] = {.lex_state = 7, .external_lex_state = 4},
  [2237] = {.lex_state = 7, .external_lex_state = 4},
  [2238] = {.lex_state = 7, .external_lex_state = 4},
  [2239] = {.lex_state = 7, .external_lex_state = 3},
  [2240] = {.lex_state = 7, .external_lex_state = 4},
  [2241] = {.lex_state = 7, .external_lex_state = 3},
  [2242] = {.lex_state = 7, .external_lex_state = 4},
  [2243] = {.lex_state = 13, .external_lex_state = 2},
  [2244] = {.lex_state = 7, .external_lex_state = 3},
  [2245] = {.lex_state = 7, .external_lex_state = 3},
  [2246] = {.lex_state = 7, .external_lex_state = 4},
  [2247] = {.lex_state = 7, .external_lex_state = 4},
  [2248] = {.lex_state = 7, .external_lex_state = 3},
  [2249] = {.lex_state = 7, .external_lex_state = 4},
  [2250] = {.lex_state = 7, .external_lex_state = 4},
  [2251] = {.lex_state = 7, .external_lex_state = 4},
  [2252] = {.lex_state = 7, .external_lex_state = 4},
  [2253] = {.lex_state = 7, .external_lex_state = 4},
  [2254] = {.lex_state = 7, .external_lex_state = 4},
  [2255] = {.lex_state = 7, .external_lex_state = 4},
  [2256] = {.lex_state = 7, .external_lex_state = 4},
  [2257] = {.lex_state = 7, .external_lex_state = 4},
  [2258] = {.lex_state = 7, .external_lex_state = 4},
  [2259] = {.lex_state = 7, .external_lex_state = 4},
  [2260] = {.lex_state = 13, .external_lex_state = 2},
  [2261] = {.lex_state = 7, .external_lex_state = 4},
  [2262] = {.lex_state = 7, .external_lex_state = 4},
  [2263] = {.lex_state = 7, .external_lex_state = 4},
  [2264] = {.lex_state = 7, .external_lex_state = 4},
  [2265] = {.lex_state = 7, .external_lex_state = 4},
  [2266] = {.lex_state = 7, .external_lex_state = 3},
  [2267] = {.lex_state = 7, .external_lex_state = 4},
  [2268] = {.lex_state = 7, .external_lex_state = 4},
  [2269] = {.lex_state = 7, .external_lex_state = 4},
  [2270] = {.lex_state = 7, .external_lex_state = 4},
  [2271] = {.lex_state = 7, .external_lex_state = 4},
  [2272] = {.lex_state = 7, .external_lex_state = 4},
  [2273] = {.lex_state = 13, .external_lex_state = 2},
  [2274] = {.lex_state = 7, .external_lex_state = 4},
  [2275] = {.lex_state = 7, .external_lex_state = 4},
  [2276] = {.lex_state = 7, .external_lex_state = 4},
  [2277] = {.lex_state = 7, .external_lex_state = 4},
  [2278] = {.lex_state = 7, .external_lex_state = 4},
  [2279] = {.lex_state = 13, .external_lex_state = 2},
  [2280] = {.lex_state = 13, .external_lex_state = 2},
  [2281] = {.lex_state = 7, .external_lex_state = 4},
  [2282] = {.lex_state = 7, .external_lex_state = 4},
  [2283] = {.lex_state = 7, .external_lex_state = 4},
  [2284] = {.lex_state = 7, .external_lex_state = 4},
  [2285] = {.lex_state = 7, .external_lex_state = 4},
  [2286] = {.lex_state = 7, .external_lex_state = 4},
  [2287] = {.lex_state = 7, .external_lex_state = 4},
  [2288] = {.lex_state = 7, .external_lex_state = 4},
  [2289] = {.lex_state = 7, .external_lex_state = 4},
  [2290] = {.lex_state = 7, .external_lex_state = 4},
  [2291] = {.lex_state = 7, .external_lex_state = 4},
  [2292] = {.lex_state = 7, .external_lex_state = 4},
  [2293] = {.lex_state = 7, .external_lex_state = 4},
  [2294] = {.lex_state = 7, .external_lex_state = 4},
  [2295] = {.lex_state = 7, .external_lex_state = 3},
  [2296] = {.lex_state = 7, .external_lex_state = 4},
  [2297] = {.lex_state = 7, .external_lex_state = 3},
  [2298] = {.lex_state = 7, .external_lex_state = 4},
  [2299] = {.lex_state = 7, .external_lex_state = 4},
  [2300] = {.lex_state = 7, .external_lex_state = 4},
  [2301] = {.lex_state = 7, .external_lex_state = 4},
  [2302] = {.lex_state = 7, .external_lex_state = 3},
  [2303] = {.lex_state = 7, .external_lex_state = 4},
  [2304] = {.lex_state = 7, .external_lex_state = 4},
  [2305] = {.lex_state = 7, .external_lex_state = 4},
  [2306] = {.lex_state = 7, .external_lex_state = 4},
  [2307] = {.lex_state = 7, .external_lex_state = 4},
  [2308] = {.lex_state = 7, .external_lex_state = 4},
  [2309] = {.lex_state = 7, .external_lex_state = 4},
  [2310] = {.lex_state = 7, .external_lex_state = 4},
  [2311] = {.lex_state = 7, .external_lex_state = 4},
  [2312] = {.lex_state = 7, .external_lex_state = 4},
  [2313] = {.lex_state = 7, .external_lex_state = 4},
  [2314] = {.lex_state = 7, .external_lex_state = 4},
  [2315] = {.lex_state = 7, .external_lex_state = 4},
  [2316] = {.lex_state = 13, .external_lex_state = 2},
  [2317] = {.lex_state = 7, .external_lex_state = 4},
  [2318] = {.lex_state = 7, .external_lex_state = 4},
  [2319] = {.lex_state = 7, .external_lex_state = 4},
  [2320] = {.lex_state = 7, .external_lex_state = 4},
  [2321] = {.lex_state = 7, .external_lex_state = 4},
  [2322] = {.lex_state = 7, .external_lex_state = 4},
  [2323] = {.lex_state = 13, .external_lex_state = 2},
  [2324] = {.lex_state = 7, .external_lex_state = 4},
  [2325] = {.lex_state = 7, .external_lex_state = 4},
  [2326] = {.lex_state = 7, .external_lex_state = 4},
  [2327] = {.lex_state = 7, .external_lex_state = 4},
  [2328] = {.lex_state = 7, .external_lex_state = 4},
  [2329] = {.lex_state = 7, .external_lex_state = 4},
  [2330] = {.lex_state = 7, .external_lex_state = 4},
  [2331] = {.lex_state = 7, .external_lex_state = 4},
  [2332] = {.lex_state = 7, .external_lex_state = 4},
  [2333] = {.lex_state = 7, .external_lex_state = 4},
  [2334] = {.lex_state = 7, .external_lex_state = 4},
  [2335] = {.lex_state = 7, .external_lex_state = 4},
  [2336] = {.lex_state = 7, .external_lex_state = 4},
  [2337] = {.lex_state = 7, .external_lex_state = 4},
  [2338] = {.lex_state = 13, .external_lex_state = 2},
  [2339] = {.lex_state = 7, .external_lex_state = 4},
  [2340] = {.lex_state = 7, .external_lex_state = 4},
  [2341] = {.lex_state = 7, .external_lex_state = 4},
  [2342] = {.lex_state = 7, .external_lex_state = 4},
  [2343] = {.lex_state = 7, .external_lex_state = 4},
  [2344] = {.lex_state = 7, .external_lex_state = 4},
  [2345] = {.lex_state = 8, .external_lex_state = 3},
  [2346] = {.lex_state = 7, .external_lex_state = 4},
  [2347] = {.lex_state = 7, .external_lex_state = 4},
  [2348] = {.lex_state = 7, .external_lex_state = 4},
  [2349] = {.lex_state = 7, .external_lex_state = 4},
  [2350] = {.lex_state = 7, .external_lex_state = 4},
  [2351] = {.lex_state = 7, .external_lex_state = 4},
  [2352] = {.lex_state = 7, .external_lex_state = 4},
  [2353] = {.lex_state = 7, .external_lex_state = 4},
  [2354] = {.lex_state = 7, .external_lex_state = 4},
  [2355] = {.lex_state = 7, .external_lex_state = 4},
  [2356] = {.lex_state = 13, .external_lex_state = 2},
  [2357] = {.lex_state = 7, .external_lex_state = 4},
  [2358] = {.lex_state = 7, .external_lex_state = 3},
  [2359] = {.lex_state = 7, .external_lex_state = 3},
  [2360] = {.lex_state = 7, .external_lex_state = 3},
  [2361] = {.lex_state = 7, .external_lex_state = 4},
  [2362] = {.lex_state = 7, .external_lex_state = 4},
  [2363] = {.lex_state = 7, .external_lex_state = 4},
  [2364] = {.lex_state = 7, .external_lex_state = 4},
  [2365] = {.lex_state = 7, .external_lex_state = 3},
  [2366] = {.lex_state = 13, .external_lex_state = 2},
  [2367] = {.lex_state = 13, .external_lex_state = 2},
  [2368] = {.lex_state = 7, .external_lex_state = 4},
  [2369] = {.lex_state = 13, .external_lex_state = 2},
  [2370] = {.lex_state = 13, .external_lex_state = 2},
  [2371] = {.lex_state = 13, .external_lex_state = 2},
  [2372] = {.lex_state = 7, .external_lex_state = 4},
  [2373] = {.lex_state = 7, .external_lex_state = 4},
  [2374] = {.lex_state = 7, .external_lex_state = 3},
  [2375] = {.lex_state = 7, .external_lex_state = 3},
  [2376] = {.lex_state = 7, .external_lex_state = 4},
  [2377] = {.lex_state = 7, .external_lex_state = 4},
  [2378] = {.lex_state = 7, .external_lex_state = 4},
  [2379] = {.lex_state = 7, .external_lex_state = 4},
  [2380] = {.lex_state = 7, .external_lex_state = 4},
  [2381] = {.lex_state = 7, .external_lex_state = 3},
  [2382] = {.lex_state = 7, .external_lex_state = 4},
  [2383] = {.lex_state = 7, .external_lex_state = 4},
  [2384] = {.lex_state = 7, .external_lex_state = 4},
  [2385] = {.lex_state = 7, .external_lex_state = 4},
  [2386] = {.lex_state = 7, .external_lex_state = 4},
  [2387] = {.lex_state = 7, .external_lex_state = 4},
  [2388] = {.lex_state = 7, .external_lex_state = 4},
  [2389] = {.lex_state = 7, .external_lex_state = 4},
  [2390] = {.lex_state = 7, .external_lex_state = 4},
  [2391] = {.lex_state = 7, .external_lex_state = 4},
  [2392] = {.lex_state = 7, .external_lex_state = 4},
  [2393] = {.lex_state = 7, .external_lex_state = 4},
  [2394] = {.lex_state = 7, .external_lex_state = 4},
  [2395] = {.lex_state = 7, .external_lex_state = 4},
  [2396] = {.lex_state = 7, .external_lex_state = 4},
  [2397] = {.lex_state = 7, .external_lex_state = 4},
  [2398] = {.lex_state = 13, .external_lex_state = 2},
  [2399] = {.lex_state = 7, .external_lex_state = 3},
  [2400] = {.lex_state = 7, .external_lex_state = 3},
  [2401] = {.lex_state = 7, .external_lex_state = 4},
  [2402] = {.lex_state = 7, .external_lex_state = 4},
  [2403] = {.lex_state = 7, .external_lex_state = 4},
  [2404] = {.lex_state = 7, .external_lex_state = 4},
  [2405] = {.lex_state = 7, .external_lex_state = 4},
  [2406] = {.lex_state = 7, .external_lex_state = 4},
  [2407] = {.lex_state = 7, .external_lex_state = 4},
  [2408] = {.lex_state = 7, .external_lex_state = 4},
  [2409] = {.lex_state = 7, .external_lex_state = 4},
  [2410] = {.lex_state = 7, .external_lex_state = 4},
  [2411] = {.lex_state = 7, .external_lex_state = 4},
  [2412] = {.lex_state = 7, .external_lex_state = 4},
  [2413] = {.lex_state = 7, .external_lex_state = 4},
  [2414] = {.lex_state = 7, .external_lex_state = 4},
  [2415] = {.lex_state = 7, .external_lex_state = 4},
  [2416] = {.lex_state = 7, .external_lex_state = 4},
  [2417] = {.lex_state = 7, .external_lex_state = 4},
  [2418] = {.lex_state = 7, .external_lex_state = 4},
  [2419] = {.lex_state = 7, .external_lex_state = 4},
  [2420] = {.lex_state = 7, .external_lex_state = 4},
  [2421] = {.lex_state = 7, .external_lex_state = 4},
  [2422] = {.lex_state = 7, .external_lex_state = 4},
  [2423] = {.lex_state = 7, .external_lex_state = 3},
  [2424] = {.lex_state = 7, .external_lex_state = 3},
  [2425] = {.lex_state = 13, .external_lex_state = 2},
  [2426] = {.lex_state = 13, .external_lex_state = 2},
  [2427] = {.lex_state = 7, .external_lex_state = 4},
  [2428] = {.lex_state = 7, .external_lex_state = 3},
  [2429] = {.lex_state = 7, .external_lex_state = 3},
  [2430] = {.lex_state = 7, .external_lex_state = 3},
  [2431] = {.lex_state = 7, .external_lex_state = 3},
  [2432] = {.lex_state = 7, .external_lex_state = 3},
  [2433] = {.lex_state = 7, .external_lex_state = 4},
  [2434] = {.lex_state = 7, .external_lex_state = 3},
  [2435] = {.lex_state = 7, .external_lex_state = 4},
  [2436] = {.lex_state = 7, .external_lex_state = 4},
  [2437] = {.lex_state = 7, .external_lex_state = 4},
  [2438] = {.lex_state = 7, .external_lex_state = 3},
  [2439] = {.lex_state = 7, .external_lex_state = 3},
  [2440] = {.lex_state = 13, .external_lex_state = 2},
  [2441] = {.lex_state = 7, .external_lex_state = 3},
  [2442] = {.lex_state = 7, .external_lex_state = 3},
  [2443] = {.lex_state = 13, .external_lex_state = 2},
  [2444] = {.lex_state = 13, .external_lex_state = 2},
  [2445] = {.lex_state = 7, .external_lex_state = 3},
  [2446] = {.lex_state = 7, .external_lex_state = 3},
  [2447] = {.lex_state = 7, .external_lex_state = 3},
  [2448] = {.lex_state = 13, .external_lex_state = 2},
  [2449] = {.lex_state = 7, .external_lex_state = 3},
  [2450] = {.lex_state = 7, .external_lex_state = 3},
  [2451] = {.lex_state = 7, .external_lex_state = 4},
  [2452] = {.lex_state = 7, .external_lex_state = 4},
  [2453] = {.lex_state = 7, .external_lex_state = 3},
  [2454] = {.lex_state = 7, .external_lex_state = 3},
  [2455] = {.lex_state = 7, .external_lex_state = 3},
  [2456] = {.lex_state = 7, .external_lex_state = 4},
  [2457] = {.lex_state = 7, .external_lex_state = 4},
  [2458] = {.lex_state = 7, .external_lex_state = 4},
  [2459] = {.lex_state = 7, .external_lex_state = 3},
  [2460] = {.lex_state = 7, .external_lex_state = 3},
  [2461] = {.lex_state = 7, .external_lex_state = 4},
  [2462] = {.lex_state = 7, .external_lex_state = 3},
  [2463] = {.lex_state = 7, .external_lex_state = 4},
  [2464] = {.lex_state = 7, .external_lex_state = 3},
  [2465] = {.lex_state = 7, .external_lex_state = 3},
  [2466] = {.lex_state = 7, .external_lex_state = 3},
  [2467] = {.lex_state = 7, .external_lex_state = 3},
  [2468] = {.lex_state = 7, .external_lex_state = 3},
  [2469] = {.lex_state = 7, .external_lex_state = 3},
  [2470] = {.lex_state = 7, .external_lex_state = 3},
  [2471] = {.lex_state = 7, .external_lex_state = 3},
  [2472] = {.lex_state = 7, .external_lex_state = 3},
  [2473] = {.lex_state = 7, .external_lex_state = 3},
  [2474] = {.lex_state = 13, .external_lex_state = 2},
  [2475] = {.lex_state = 7, .external_lex_state = 3},
  [2476] = {.lex_state = 7, .external_lex_state = 3},
  [2477] = {.lex_state = 7, .external_lex_state = 3},
  [2478] = {.lex_state = 7, .external_lex_state = 3},
  [2479] = {.lex_state = 7, .external_lex_state = 4},
  [2480] = {.lex_state = 7, .external_lex_state = 4},
  [2481] = {.lex_state = 7, .external_lex_state = 3},
  [2482] = {.lex_state = 7, .external_lex_state = 3},
  [2483] = {.lex_state = 7, .external_lex_state = 3},
  [2484] = {.lex_state = 7, .external_lex_state = 3},
  [2485] = {.lex_state = 7, .external_lex_state = 4},
  [2486] = {.lex_state = 7, .external_lex_state = 3},
  [2487] = {.lex_state = 7, .external_lex_state = 3},
  [2488] = {.lex_state = 7, .external_lex_state = 4},
  [2489] = {.lex_state = 7, .external_lex_state = 4},
  [2490] = {.lex_state = 7, .external_lex_state = 4},
  [2491] = {.lex_state = 7, .external_lex_state = 4},
  [2492] = {.lex_state = 13, .external_lex_state = 2},
  [2493] = {.lex_state = 7, .external_lex_state = 3},
  [2494] = {.lex_state = 7, .external_lex_state = 4},
  [2495] = {.lex_state = 7, .external_lex_state = 4},
  [2496] = {.lex_state = 7, .external_lex_state = 4},
  [2497] = {.lex_state = 7, .external_lex_state = 4},
  [2498] = {.lex_state = 7, .external_lex_state = 4},
  [2499] = {.lex_state = 7, .external_lex_state = 4},
  [2500] = {.lex_state = 7, .external_lex_state = 3},
  [2501] = {.lex_state = 7, .external_lex_state = 3},
  [2502] = {.lex_state = 13, .external_lex_state = 2},
  [2503] = {.lex_state = 13, .external_lex_state = 2},
  [2504] = {.lex_state = 7, .external_lex_state = 3},
  [2505] = {.lex_state = 7, .external_lex_state = 3},
  [2506] = {.lex_state = 7, .external_lex_state = 3},
  [2507] = {.lex_state = 13, .external_lex_state = 2},
  [2508] = {.lex_state = 7, .external_lex_state = 4},
  [2509] = {.lex_state = 7, .external_lex_state = 4},
  [2510] = {.lex_state = 7, .external_lex_state = 4},
  [2511] = {.lex_state = 7, .external_lex_state = 3},
  [2512] = {.lex_state = 7, .external_lex_state = 4},
  [2513] = {.lex_state = 7, .external_lex_state = 3},
  [2514] = {.lex_state = 7, .external_lex_state = 4},
  [2515] = {.lex_state = 7, .external_lex_state = 4},
  [2516] = {.lex_state = 7, .external_lex_state = 3},
  [2517] = {.lex_state = 7, .external_lex_state = 4},
  [2518] = {.lex_state = 7, .external_lex_state = 4},
  [2519] = {.lex_state = 7, .external_lex_state = 3},
  [2520] = {.lex_state = 7, .external_lex_state = 3},
  [2521] = {.lex_state = 7, .external_lex_state = 3},
  [2522] = {.lex_state = 13, .external_lex_state = 2},
  [2523] = {.lex_state = 11, .external_lex_state = 2},
  [2524] = {.lex_state = 13, .external_lex_state = 2},
  [2525] = {.lex_state = 7, .external_lex_state = 3},
  [2526] = {.lex_state = 7, .external_lex_state = 3},
  [2527] = {.lex_state = 7, .external_lex_state = 3},
  [2528] = {.lex_state = 7, .external_lex_state = 3},
  [2529] = {.lex_state = 7, .external_lex_state = 3},
  [2530] = {.lex_state = 7, .external_lex_state = 3},
  [2531] = {.lex_state = 7, .external_lex_state = 3},
  [2532] = {.lex_state = 7, .external_lex_state = 4},
  [2533] = {.lex_state = 7, .external_lex_state = 4},
  [2534] = {.lex_state = 7, .external_lex_state = 4},
  [2535] = {.lex_state = 7, .external_lex_state = 4},
  [2536] = {.lex_state = 7, .external_lex_state = 4},
  [2537] = {.lex_state = 7, .external_lex_state = 4},
  [2538] = {.lex_state = 7, .external_lex_state = 4},
  [2539] = {.lex_state = 7, .external_lex_state = 4},
  [2540] = {.lex_state = 7, .external_lex_state = 4},
  [2541] = {.lex_state = 7, .external_lex_state = 3},
  [2542] = {.lex_state = 7, .external_lex_state = 3},
  [2543] = {.lex_state = 13, .external_lex_state = 2},
  [2544] = {.lex_state = 7, .external_lex_state = 3},
  [2545] = {.lex_state = 7, .external_lex_state = 3},
  [2546] = {.lex_state = 7, .external_lex_state = 4},
  [2547] = {.lex_state = 13, .external_lex_state = 2},
  [2548] = {.lex_state = 7, .external_lex_state = 4},
  [2549] = {.lex_state = 7, .external_lex_state = 3},
  [2550] = {.lex_state = 7, .external_lex_state = 3},
  [2551] = {.lex_state = 7, .external_lex_state = 3},
  [2552] = {.lex_state = 7, .external_lex_state = 3},
  [2553] = {.lex_state = 7, .external_lex_state = 3},
  [2554] = {.lex_state = 7, .external_lex_state = 3},
  [2555] = {.lex_state = 7, .external_lex_state = 3},
  [2556] = {.lex_state = 7, .external_lex_state = 4},
  [2557] = {.lex_state = 7, .external_lex_state = 4},
  [2558] = {.lex_state = 7, .external_lex_state = 3},
  [2559] = {.lex_state = 7, .external_lex_state = 4},
  [2560] = {.lex_state = 7, .external_lex_state = 4},
  [2561] = {.lex_state = 11, .external_lex_state = 2},
  [2562] = {.lex_state = 7, .external_lex_state = 4},
  [2563] = {.lex_state = 13, .external_lex_state = 2},
  [2564] = {.lex_state = 7, .external_lex_state = 4},
  [2565] = {.lex_state = 13, .external_lex_state = 2},
  [2566] = {.lex_state = 7, .external_lex_state = 4},
  [2567] = {.lex_state = 7, .external_lex_state = 4},
  [2568] = {.lex_state = 7, .external_lex_state = 4},
  [2569] = {.lex_state = 7, .external_lex_state = 4},
  [2570] = {.lex_state = 7, .external_lex_state = 3},
  [2571] = {.lex_state = 7, .external_lex_state = 4},
  [2572] = {.lex_state = 13, .external_lex_state = 2},
  [2573] = {.lex_state = 7, .external_lex_state = 3},
  [2574] = {.lex_state = 7, .external_lex_state = 3},
  [2575] = {.lex_state = 7, .external_lex_state = 3},
  [2576] = {.lex_state = 7, .external_lex_state = 4},
  [2577] = {.lex_state = 7, .external_lex_state = 4},
  [2578] = {.lex_state = 7, .external_lex_state = 3},
  [2579] = {.lex_state = 7, .external_lex_state = 3},
  [2580] = {.lex_state = 7, .external_lex_state = 3},
  [2581] = {.lex_state = 7, .external_lex_state = 3},
  [2582] = {.lex_state = 13, .external_lex_state = 2},
  [2583] = {.lex_state = 7, .external_lex_state = 3},
  [2584] = {.lex_state = 7, .external_lex_state = 4},
  [2585] = {.lex_state = 7, .external_lex_state = 3},
  [2586] = {.lex_state = 13, .external_lex_state = 2},
  [2587] = {.lex_state = 7, .external_lex_state = 4},
  [2588] = {.lex_state = 95, .external_lex_state = 2},
  [2589] = {.lex_state = 7, .external_lex_state = 3},
  [2590] = {.lex_state = 7, .external_lex_state = 4},
  [2591] = {.lex_state = 7, .external_lex_state = 4},
  [2592] = {.lex_state = 7, .external_lex_state = 3},
  [2593] = {.lex_state = 7, .external_lex_state = 4},
  [2594] = {.lex_state = 7, .external_lex_state = 3},
  [2595] = {.lex_state = 7, .external_lex_state = 3},
  [2596] = {.lex_state = 7, .external_lex_state = 4},
  [2597] = {.lex_state = 7, .external_lex_state = 4},
  [2598] = {.lex_state = 7, .external_lex_state = 3},
  [2599] = {.lex_state = 13, .external_lex_state = 2},
  [2600] = {.lex_state = 7, .external_lex_state = 4},
  [2601] = {.lex_state = 7, .external_lex_state = 4},
  [2602] = {.lex_state = 7, .external_lex_state = 3},
  [2603] = {.lex_state = 7, .external_lex_state = 3},
  [2604] = {.lex_state = 7, .external_lex_state = 3},
  [2605] = {.lex_state = 7, .external_lex_state = 3},
  [2606] = {.lex_state = 7, .external_lex_state = 4},
  [2607] = {.lex_state = 7, .external_lex_state = 4},
  [2608] = {.lex_state = 7, .external_lex_state = 3},
  [2609] = {.lex_state = 7, .external_lex_state = 3},
  [2610] = {.lex_state = 7, .external_lex_state = 4},
  [2611] = {.lex_state = 7, .external_lex_state = 4},
  [2612] = {.lex_state = 7, .external_lex_state = 3},
  [2613] = {.lex_state = 7, .external_lex_state = 3},
  [2614] = {.lex_state = 7, .external_lex_state = 3},
  [2615] = {.lex_state = 7, .external_lex_state = 3},
  [2616] = {.lex_state = 7, .external_lex_state = 3},
  [2617] = {.lex_state = 7, .external_lex_state = 3},
  [2618] = {.lex_state = 7, .external_lex_state = 3},
  [2619] = {.lex_state = 8, .external_lex_state = 4},
  [2620] = {.lex_state = 7, .external_lex_state = 3},
  [2621] = {.lex_state = 7, .external_lex_state = 3},
  [2622] = {.lex_state = 13, .external_lex_state = 2},
  [2623] = {.lex_state = 7, .external_lex_state = 3},
  [2624] = {.lex_state = 7, .external_lex_state = 3},
  [2625] = {.lex_state = 7, .external_lex_state = 4},
  [2626] = {.lex_state = 7, .external_lex_state = 3},
  [2627] = {.lex_state = 7, .external_lex_state = 4},
  [2628] = {.lex_state = 7, .external_lex_state = 4},
  [2629] = {.lex_state = 7, .external_lex_state = 4},
  [2630] = {.lex_state = 7, .external_lex_state = 3},
  [2631] = {.lex_state = 13, .external_lex_state = 2},
  [2632] = {.lex_state = 7, .external_lex_state = 4},
  [2633] = {.lex_state = 7, .external_lex_state = 3},
  [2634] = {.lex_state = 7, .external_lex_state = 3},
  [2635] = {.lex_state = 7, .external_lex_state = 4},
  [2636] = {.lex_state = 7, .external_lex_state = 3},
  [2637] = {.lex_state = 7, .external_lex_state = 4},
  [2638] = {.lex_state = 7, .external_lex_state = 4},
  [2639] = {.lex_state = 7, .external_lex_state = 4},
  [2640] = {.lex_state = 7, .external_lex_state = 3},
  [2641] = {.lex_state = 7, .external_lex_state = 4},
  [2642] = {.lex_state = 7, .external_lex_state = 3},
  [2643] = {.lex_state = 7, .external_lex_state = 3},
  [2644] = {.lex_state = 7, .external_lex_state = 3},
  [2645] = {.lex_state = 7, .external_lex_state = 4},
  [2646] = {.lex_state = 7, .external_lex_state = 3},
  [2647] = {.lex_state = 7, .external_lex_state = 3},
  [2648] = {.lex_state = 7, .external_lex_state = 4},
  [2649] = {.lex_state = 7, .external_lex_state = 4},
  [2650] = {.lex_state = 7, .external_lex_state = 4},
  [2651] = {.lex_state = 7, .external_lex_state = 3},
  [2652] = {.lex_state = 7, .external_lex_state = 3},
  [2653] = {.lex_state = 7, .external_lex_state = 3},
  [2654] = {.lex_state = 7, .external_lex_state = 4},
  [2655] = {.lex_state = 7, .external_lex_state = 3},
  [2656] = {.lex_state = 7, .external_lex_state = 4},
  [2657] = {.lex_state = 7, .external_lex_state = 3},
  [2658] = {.lex_state = 13, .external_lex_state = 2},
  [2659] = {.lex_state = 7, .external_lex_state = 4},
  [2660] = {.lex_state = 7, .external_lex_state = 3},
  [2661] = {.lex_state = 7, .external_lex_state = 3},
  [2662] = {.lex_state = 7, .external_lex_state = 4},
  [2663] = {.lex_state = 7, .external_lex_state = 3},
  [2664] = {.lex_state = 13, .external_lex_state = 2},
  [2665] = {.lex_state = 7, .external_lex_state = 4},
  [2666] = {.lex_state = 7, .external_lex_state = 4},
  [2667] = {.lex_state = 13, .external_lex_state = 2},
  [2668] = {.lex_state = 11, .external_lex_state = 2},
  [2669] = {.lex_state = 7, .external_lex_state = 3},
  [2670] = {.lex_state = 7, .external_lex_state = 3},
  [2671] = {.lex_state = 8, .external_lex_state = 4},
  [2672] = {.lex_state = 7, .external_lex_state = 3},
  [2673] = {.lex_state = 13, .external_lex_state = 2},
  [2674] = {.lex_state = 7, .external_lex_state = 3},
  [2675] = {.lex_state = 7, .external_lex_state = 3},
  [2676] = {.lex_state = 7, .external_lex_state = 3},
  [2677] = {.lex_state = 11, .external_lex_state = 2},
  [2678] = {.lex_state = 7, .external_lex_state = 3},
  [2679] = {.lex_state = 95, .external_lex_state = 2},
  [2680] = {.lex_state = 7, .external_lex_state = 3},
  [2681] = {.lex_state = 7, .external_lex_state = 3},
  [2682] = {.lex_state = 7, .external_lex_state = 3},
  [2683] = {.lex_state = 7, .external_lex_state = 3},
  [2684] = {.lex_state = 7, .external_lex_state = 3},
  [2685] = {.lex_state = 11, .external_lex_state = 2},
  [2686] = {.lex_state = 7, .external_lex_state = 3},
  [2687] = {.lex_state = 7, .external_lex_state = 3},
  [2688] = {.lex_state = 95, .external_lex_state = 2},
  [2689] = {.lex_state = 7, .external_lex_state = 3},
  [2690] = {.lex_state = 7, .external_lex_state = 3},
  [2691] = {.lex_state = 7, .external_lex_state = 3},
  [2692] = {.lex_state = 7, .external_lex_state = 3},
  [2693] = {.lex_state = 7, .external_lex_state = 3},
  [2694] = {.lex_state = 11, .external_lex_state = 2},
  [2695] = {.lex_state = 7, .external_lex_state = 3},
  [2696] = {.lex_state = 7, .external_lex_state = 3},
  [2697] = {.lex_state = 7, .external_lex_state = 3},
  [2698] = {.lex_state = 95, .external_lex_state = 2},
  [2699] = {.lex_state = 95, .external_lex_state = 2},
  [2700] = {.lex_state = 95, .external_lex_state = 2},
  [2701] = {.lex_state = 7, .external_lex_state = 3},
  [2702] = {.lex_state = 7, .external_lex_state = 3},
  [2703] = {.lex_state = 7, .external_lex_state = 3},
  [2704] = {.lex_state = 7, .external_lex_state = 3},
  [2705] = {.lex_state = 7, .external_lex_state = 3},
  [2706] = {.lex_state = 7, .external_lex_state = 3},
  [2707] = {.lex_state = 7, .external_lex_state = 3},
  [2708] = {.lex_state = 7, .external_lex_state = 3},
  [2709] = {.lex_state = 7, .external_lex_state = 3},
  [2710] = {.lex_state = 7, .external_lex_state = 3},
  [2711] = {.lex_state = 95, .external_lex_state = 2},
  [2712] = {.lex_state = 95, .external_lex_state = 2},
  [2713] = {.lex_state = 7, .external_lex_state = 3},
  [2714] = {.lex_state = 7, .external_lex_state = 3},
  [2715] = {.lex_state = 7, .external_lex_state = 3},
  [2716] = {.lex_state = 7, .external_lex_state = 4},
  [2717] = {.lex_state = 95, .external_lex_state = 2},
  [2718] = {.lex_state = 95, .external_lex_state = 2},
  [2719] = {.lex_state = 7, .external_lex_state = 3},
  [2720] = {.lex_state = 7, .external_lex_state = 3},
  [2721] = {.lex_state = 7, .external_lex_state = 3},
  [2722] = {.lex_state = 7, .external_lex_state = 4},
  [2723] = {.lex_state = 7, .external_lex_state = 3},
  [2724] = {.lex_state = 7, .external_lex_state = 3},
  [2725] = {.lex_state = 7, .external_lex_state = 3},
  [2726] = {.lex_state = 95, .external_lex_state = 2},
  [2727] = {.lex_state = 7, .external_lex_state = 4},
  [2728] = {.lex_state = 7, .external_lex_state = 3},
  [2729] = {.lex_state = 7, .external_lex_state = 4},
  [2730] = {.lex_state = 7, .external_lex_state = 3},
  [2731] = {.lex_state = 11, .external_lex_state = 2},
  [2732] = {.lex_state = 95, .external_lex_state = 2},
  [2733] = {.lex_state = 95, .external_lex_state = 2},
  [2734] = {.lex_state = 7, .external_lex_state = 3},
  [2735] = {.lex_state = 95, .external_lex_state = 2},
  [2736] = {.lex_state = 11, .external_lex_state = 2},
  [2737] = {.lex_state = 95, .external_lex_state = 2},
  [2738] = {.lex_state = 95, .external_lex_state = 2},
  [2739] = {.lex_state = 7, .external_lex_state = 3},
  [2740] = {.lex_state = 7, .external_lex_state = 3},
  [2741] = {.lex_state = 95, .external_lex_state = 2},
  [2742] = {.lex_state = 95, .external_lex_state = 2},
  [2743] = {.lex_state = 95, .external_lex_state = 2},
  [2744] = {.lex_state = 11, .external_lex_state = 2},
  [2745] = {.lex_state = 7, .external_lex_state = 3},
  [2746] = {.lex_state = 95, .external_lex_state = 2},
  [2747] = {.lex_state = 7, .external_lex_state = 3},
  [2748] = {.lex_state = 7, .external_lex_state = 3},
  [2749] = {.lex_state = 7, .external_lex_state = 3},
  [2750] = {.lex_state = 7, .external_lex_state = 3},
  [2751] = {.lex_state = 11, .external_lex_state = 2},
  [2752] = {.lex_state = 7, .external_lex_state = 3},
  [2753] = {.lex_state = 95, .external_lex_state = 2},
  [2754] = {.lex_state = 8, .external_lex_state = 3},
  [2755] = {.lex_state = 11, .external_lex_state = 2},
  [2756] = {.lex_state = 11, .external_lex_state = 2},
  [2757] = {.lex_state = 7, .external_lex_state = 3},
  [2758] = {.lex_state = 7, .external_lex_state = 3},
  [2759] = {.lex_state = 7, .external_lex_state = 3},
  [2760] = {.lex_state = 95, .external_lex_state = 2},
  [2761] = {.lex_state = 11, .external_lex_state = 2},
  [2762] = {.lex_state = 7, .external_lex_state = 3},
  [2763] = {.lex_state = 11, .external_lex_state = 2},
  [2764] = {.lex_state = 7, .external_lex_state = 3},
  [2765] = {.lex_state = 7, .external_lex_state = 3},
  [2766] = {.lex_state = 7, .external_lex_state = 3},
  [2767] = {.lex_state = 7, .external_lex_state = 3},
  [2768] = {.lex_state = 7, .external_lex_state = 4},
  [2769] = {.lex_state = 11, .external_lex_state = 2},
  [2770] = {.lex_state = 7, .external_lex_state = 3},
  [2771] = {.lex_state = 11, .external_lex_state = 2},
  [2772] = {.lex_state = 11, .external_lex_state = 2},
  [2773] = {.lex_state = 11, .external_lex_state = 2},
  [2774] = {.lex_state = 11, .external_lex_state = 2},
  [2775] = {.lex_state = 11, .external_lex_state = 2},
  [2776] = {.lex_state = 13, .external_lex_state = 2},
  [2777] = {.lex_state = 7, .external_lex_state = 3},
  [2778] = {.lex_state = 7, .external_lex_state = 3},
  [2779] = {.lex_state = 11, .external_lex_state = 2},
  [2780] = {.lex_state = 11, .external_lex_state = 2},
  [2781] = {.lex_state = 6, .external_lex_state = 2},
  [2782] = {.lex_state = 6, .external_lex_state = 2},
  [2783] = {.lex_state = 6, .external_lex_state = 2},
  [2784] = {.lex_state = 6, .external_lex_state = 2},
  [2785] = {.lex_state = 7, .external_lex_state = 3},
  [2786] = {.lex_state = 11, .external_lex_state = 2},
  [2787] = {.lex_state = 11, .external_lex_state = 2},
  [2788] = {.lex_state = 7, .external_lex_state = 3},
  [2789] = {.lex_state = 11, .external_lex_state = 2},
  [2790] = {.lex_state = 11, .external_lex_state = 2},
  [2791] = {.lex_state = 7, .external_lex_state = 3},
  [2792] = {.lex_state = 11, .external_lex_state = 2},
  [2793] = {.lex_state = 95, .external_lex_state = 2},
  [2794] = {.lex_state = 7, .external_lex_state = 4},
  [2795] = {.lex_state = 11, .external_lex_state = 2},
  [2796] = {.lex_state = 7, .external_lex_state = 3},
  [2797] = {.lex_state = 7, .external_lex_state = 3},
  [2798] = {.lex_state = 7, .external_lex_state = 3},
  [2799] = {.lex_state = 95, .external_lex_state = 2},
  [2800] = {.lex_state = 95, .external_lex_state = 2},
  [2801] = {.lex_state = 95, .external_lex_state = 5},
  [2802] = {.lex_state = 95, .external_lex_state = 2},
  [2803] = {.lex_state = 95, .external_lex_state = 2},
  [2804] = {.lex_state = 95, .external_lex_state = 2},
  [2805] = {.lex_state = 95, .external_lex_state = 2},
  [2806] = {.lex_state = 95, .external_lex_state = 2},
  [2807] = {.lex_state = 95, .external_lex_state = 2},
  [2808] = {.lex_state = 95, .external_lex_state = 2},
  [2809] = {.lex_state = 95, .external_lex_state = 2},
  [2810] = {.lex_state = 95, .external_lex_state = 2},
  [2811] = {.lex_state = 95, .external_lex_state = 2},
  [2812] = {.lex_state = 7, .external_lex_state = 3},
  [2813] = {.lex_state = 7, .external_lex_state = 3},
  [2814] = {.lex_state = 95, .external_lex_state = 2},
  [2815] = {.lex_state = 95, .external_lex_state = 2},
  [2816] = {.lex_state = 95, .external_lex_state = 2},
  [2817] = {.lex_state = 95, .external_lex_state = 2},
  [2818] = {.lex_state = 95, .external_lex_state = 2},
  [2819] = {.lex_state = 95, .external_lex_state = 2},
  [2820] = {.lex_state = 95, .external_lex_state = 2},
  [2821] = {.lex_state = 95, .external_lex_state = 2},
  [2822] = {.lex_state = 95, .external_lex_state = 2},
  [2823] = {.lex_state = 95, .external_lex_state = 2},
  [2824] = {.lex_state = 95, .external_lex_state = 2},
  [2825] = {.lex_state = 95, .external_lex_state = 5},
  [2826] = {.lex_state = 95, .external_lex_state = 5},
  [2827] = {.lex_state = 8, .external_lex_state = 3},
  [2828] = {.lex_state = 95, .external_lex_state = 2},
  [2829] = {.lex_state = 7, .external_lex_state = 3},
  [2830] = {.lex_state = 95, .external_lex_state = 2},
  [2831] = {.lex_state = 95, .external_lex_state = 2},
  [2832] = {.lex_state = 95, .external_lex_state = 2},
  [2833] = {.lex_state = 95, .external_lex_state = 5},
  [2834] = {.lex_state = 95, .external_lex_state = 5},
  [2835] = {.lex_state = 11, .external_lex_state = 2},
  [2836] = {.lex_state = 95, .external_lex_state = 2},
  [2837] = {.lex_state = 95, .external_lex_state = 2},
  [2838] = {.lex_state = 95, .external_lex_state = 2},
  [2839] = {.lex_state = 95, .external_lex_state = 2},
  [2840] = {.lex_state = 95, .external_lex_state = 2},
  [2841] = {.lex_state = 95, .external_lex_state = 2},
  [2842] = {.lex_state = 11, .external_lex_state = 2},
  [2843] = {.lex_state = 95, .external_lex_state = 2},
  [2844] = {.lex_state = 11, .external_lex_state = 2},
  [2845] = {.lex_state = 11, .external_lex_state = 2},
  [2846] = {.lex_state = 95, .external_lex_state = 2},
  [2847] = {.lex_state = 95, .external_lex_state = 2},
  [2848] = {.lex_state = 95, .external_lex_state = 5},
  [2849] = {.lex_state = 95, .external_lex_state = 2},
  [2850] = {.lex_state = 11, .external_lex_state = 2},
  [2851] = {.lex_state = 95, .external_lex_state = 2},
  [2852] = {.lex_state = 95, .external_lex_state = 2},
  [2853] = {.lex_state = 11, .external_lex_state = 2},
  [2854] = {.lex_state = 95, .external_lex_state = 5},
  [2855] = {.lex_state = 7, .external_lex_state = 3},
  [2856] = {.lex_state = 11, .external_lex_state = 2},
  [2857] = {.lex_state = 95, .external_lex_state = 2},
  [2858] = {.lex_state = 95, .external_lex_state = 2},
  [2859] = {.lex_state = 95, .external_lex_state = 2},
  [2860] = {.lex_state = 7, .external_lex_state = 3},
  [2861] = {.lex_state = 95, .external_lex_state = 2},
  [2862] = {.lex_state = 95, .external_lex_state = 2},
  [2863] = {.lex_state = 95, .external_lex_state = 2},
  [2864] = {.lex_state = 95, .external_lex_state = 2},
  [2865] = {.lex_state = 95, .external_lex_state = 2},
  [2866] = {.lex_state = 95, .external_lex_state = 2},
  [2867] = {.lex_state = 95, .external_lex_state = 2},
  [2868] = {.lex_state = 95, .external_lex_state = 2},
  [2869] = {.lex_state = 95, .external_lex_state = 2},
  [2870] = {.lex_state = 95, .external_lex_state = 2},
  [2871] = {.lex_state = 95, .external_lex_state = 2},
  [2872] = {.lex_state = 95, .external_lex_state = 2},
  [2873] = {.lex_state = 95, .external_lex_state = 2},
  [2874] = {.lex_state = 95, .external_lex_state = 2},
  [2875] = {.lex_state = 7, .external_lex_state = 3},
  [2876] = {.lex_state = 95, .external_lex_state = 2},
  [2877] = {.lex_state = 95, .external_lex_state = 2},
  [2878] = {.lex_state = 95, .external_lex_state = 2},
  [2879] = {.lex_state = 95, .external_lex_state = 2},
  [2880] = {.lex_state = 95, .external_lex_state = 2},
  [2881] = {.lex_state = 95, .external_lex_state = 2},
  [2882] = {.lex_state = 7, .external_lex_state = 3},
  [2883] = {.lex_state = 95, .external_lex_state = 5},
  [2884] = {.lex_state = 95, .external_lex_state = 5},
  [2885] = {.lex_state = 95, .external_lex_state = 5},
  [2886] = {.lex_state = 7, .external_lex_state = 3},
  [2887] = {.lex_state = 7, .external_lex_state = 3},
  [2888] = {.lex_state = 95, .external_lex_state = 5},
  [2889] = {.lex_state = 7, .external_lex_state = 3},
  [2890] = {.lex_state = 95, .external_lex_state = 2},
  [2891] = {.lex_state = 95, .external_lex_state = 2},
  [2892] = {.lex_state = 95, .external_lex_state = 5},
  [2893] = {.lex_state = 95, .external_lex_state = 2},
  [2894] = {.lex_state = 95, .external_lex_state = 5},
  [2895] = {.lex_state = 7, .external_lex_state = 3},
  [2896] = {.lex_state = 7, .external_lex_state = 3},
  [2897] = {.lex_state = 95, .external_lex_state = 2},
  [2898] = {.lex_state = 11, .external_lex_state = 2},
  [2899] = {.lex_state = 95, .external_lex_state = 5},
  [2900] = {.lex_state = 7, .external_lex_state = 3},
  [2901] = {.lex_state = 7, .external_lex_state = 3},
  [2902] = {.lex_state = 95, .external_lex_state = 2},
  [2903] = {.lex_state = 11, .external_lex_state = 2},
  [2904] = {.lex_state = 95, .external_lex_state = 2},
  [2905] = {.lex_state = 95, .external_lex_state = 5},
  [2906] = {.lex_state = 95, .external_lex_state = 5},
  [2907] = {.lex_state = 95, .external_lex_state = 2},
  [2908] = {.lex_state = 95, .external_lex_state = 2},
  [2909] = {.lex_state = 95, .external_lex_state = 2},
  [2910] = {.lex_state = 95, .external_lex_state = 2},
  [2911] = {.lex_state = 95, .external_lex_state = 2},
  [2912] = {.lex_state = 95, .external_lex_state = 2},
  [2913] = {.lex_state = 95, .external_lex_state = 2},
  [2914] = {.lex_state = 95, .external_lex_state = 2},
  [2915] = {.lex_state = 7, .external_lex_state = 3},
  [2916] = {.lex_state = 95, .external_lex_state = 2},
  [2917] = {.lex_state = 95, .external_lex_state = 2},
  [2918] = {.lex_state = 95, .external_lex_state = 5},
  [2919] = {.lex_state = 95, .external_lex_state = 2},
  [2920] = {.lex_state = 95, .external_lex_state = 2},
  [2921] = {.lex_state = 95, .external_lex_state = 2},
  [2922] = {.lex_state = 95, .external_lex_state = 2},
  [2923] = {.lex_state = 95, .external_lex_state = 2},
  [2924] = {.lex_state = 95, .external_lex_state = 2},
  [2925] = {.lex_state = 95, .external_lex_state = 2},
  [2926] = {.lex_state = 95, .external_lex_state = 2},
  [2927] = {.lex_state = 95, .external_lex_state = 2},
  [2928] = {.lex_state = 95, .external_lex_state = 2},
  [2929] = {.lex_state = 95, .external_lex_state = 2},
  [2930] = {.lex_state = 95, .external_lex_state = 2},
  [2931] = {.lex_state = 95, .external_lex_state = 2},
  [2932] = {.lex_state = 95, .external_lex_state = 2},
  [2933] = {.lex_state = 95, .external_lex_state = 2},
  [2934] = {.lex_state = 95, .external_lex_state = 2},
  [2935] = {.lex_state = 95, .external_lex_state = 2},
  [2936] = {.lex_state = 95, .external_lex_state = 2},
  [2937] = {.lex_state = 95, .external_lex_state = 2},
  [2938] = {.lex_state = 95, .external_lex_state = 2},
  [2939] = {.lex_state = 95, .external_lex_state = 2},
  [2940] = {.lex_state = 95, .external_lex_state = 2},
  [2941] = {.lex_state = 95, .external_lex_state = 2},
  [2942] = {.lex_state = 95, .external_lex_state = 2},
  [2943] = {.lex_state = 95, .external_lex_state = 2},
  [2944] = {.lex_state = 95, .external_lex_state = 2},
  [2945] = {.lex_state = 95, .external_lex_state = 2},
  [2946] = {.lex_state = 95, .external_lex_state = 2},
  [2947] = {.lex_state = 95, .external_lex_state = 2},
  [2948] = {.lex_state = 95, .external_lex_state = 2},
  [2949] = {.lex_state = 95, .external_lex_state = 2},
  [2950] = {.lex_state = 95, .external_lex_state = 2},
  [2951] = {.lex_state = 95, .external_lex_state = 2},
  [2952] = {.lex_state = 95, .external_lex_state = 2},
  [2953] = {.lex_state = 95, .external_lex_state = 2},
  [2954] = {.lex_state = 95, .external_lex_state = 2},
  [2955] = {.lex_state = 95, .external_lex_state = 2},
  [2956] = {.lex_state = 95, .external_lex_state = 2},
  [2957] = {.lex_state = 95, .external_lex_state = 2},
  [2958] = {.lex_state = 95, .external_lex_state = 2},
  [2959] = {.lex_state = 95, .external_lex_state = 2},
  [2960] = {.lex_state = 95, .external_lex_state = 2},
  [2961] = {.lex_state = 95, .external_lex_state = 2},
  [2962] = {.lex_state = 95, .external_lex_state = 2},
  [2963] = {.lex_state = 95, .external_lex_state = 2},
  [2964] = {.lex_state = 95, .external_lex_state = 2},
  [2965] = {.lex_state = 95, .external_lex_state = 2},
  [2966] = {.lex_state = 95, .external_lex_state = 2},
  [2967] = {.lex_state = 95, .external_lex_state = 2},
  [2968] = {.lex_state = 95, .external_lex_state = 2},
  [2969] = {.lex_state = 95, .external_lex_state = 2},
  [2970] = {.lex_state = 95, .external_lex_state = 2},
  [2971] = {.lex_state = 95, .external_lex_state = 2},
  [2972] = {.lex_state = 95, .external_lex_state = 2},
  [2973] = {.lex_state = 95, .external_lex_state = 2},
  [2974] = {.lex_state = 95, .external_lex_state = 2},
  [2975] = {.lex_state = 95, .external_lex_state = 2},
  [2976] = {.lex_state = 95, .external_lex_state = 2},
  [2977] = {.lex_state = 95, .external_lex_state = 2},
  [2978] = {.lex_state = 95, .external_lex_state = 2},
  [2979] = {.lex_state = 95, .external_lex_state = 2},
  [2980] = {.lex_state = 95, .external_lex_state = 2},
  [2981] = {.lex_state = 95, .external_lex_state = 2},
  [2982] = {.lex_state = 95, .external_lex_state = 2},
  [2983] = {.lex_state = 95, .external_lex_state = 2},
  [2984] = {.lex_state = 95, .external_lex_state = 2},
  [2985] = {.lex_state = 95, .external_lex_state = 2},
  [2986] = {.lex_state = 95, .external_lex_state = 2},
  [2987] = {.lex_state = 95, .external_lex_state = 2},
  [2988] = {.lex_state = 95, .external_lex_state = 2},
  [2989] = {.lex_state = 95, .external_lex_state = 2},
  [2990] = {.lex_state = 95, .external_lex_state = 2},
  [2991] = {.lex_state = 95, .external_lex_state = 2},
  [2992] = {.lex_state = 95, .external_lex_state = 2},
  [2993] = {.lex_state = 95, .external_lex_state = 2},
  [2994] = {.lex_state = 95, .external_lex_state = 2},
  [2995] = {.lex_state = 95, .external_lex_state = 2},
  [2996] = {.lex_state = 95, .external_lex_state = 2},
  [2997] = {.lex_state = 95, .external_lex_state = 2},
  [2998] = {.lex_state = 95, .external_lex_state = 2},
  [2999] = {.lex_state = 95, .external_lex_state = 2},
  [3000] = {.lex_state = 95, .external_lex_state = 2},
  [3001] = {.lex_state = 95, .external_lex_state = 2},
  [3002] = {.lex_state = 95, .external_lex_state = 2},
  [3003] = {.lex_state = 95, .external_lex_state = 2},
  [3004] = {.lex_state = 95, .external_lex_state = 2},
  [3005] = {.lex_state = 95, .external_lex_state = 2},
  [3006] = {.lex_state = 95, .external_lex_state = 2},
  [3007] = {.lex_state = 95, .external_lex_state = 2},
  [3008] = {.lex_state = 95, .external_lex_state = 2},
  [3009] = {.lex_state = 95, .external_lex_state = 2},
  [3010] = {.lex_state = 95, .external_lex_state = 2},
  [3011] = {.lex_state = 95, .external_lex_state = 2},
  [3012] = {.lex_state = 95, .external_lex_state = 2},
  [3013] = {.lex_state = 95, .external_lex_state = 2},
  [3014] = {.lex_state = 95, .external_lex_state = 2},
  [3015] = {.lex_state = 95, .external_lex_state = 2},
  [3016] = {.lex_state = 95, .external_lex_state = 2},
  [3017] = {.lex_state = 95, .external_lex_state = 2},
  [3018] = {.lex_state = 95, .external_lex_state = 2},
  [3019] = {.lex_state = 95, .external_lex_state = 2},
  [3020] = {.lex_state = 95, .external_lex_state = 2},
  [3021] = {.lex_state = 95, .external_lex_state = 2},
  [3022] = {.lex_state = 95, .external_lex_state = 2},
  [3023] = {.lex_state = 95, .external_lex_state = 2},
  [3024] = {.lex_state = 95, .external_lex_state = 2},
  [3025] = {.lex_state = 95, .external_lex_state = 2},
  [3026] = {.lex_state = 95, .external_lex_state = 2},
  [3027] = {.lex_state = 95, .external_lex_state = 2},
  [3028] = {.lex_state = 95, .external_lex_state = 2},
  [3029] = {.lex_state = 95, .external_lex_state = 2},
  [3030] = {.lex_state = 95, .external_lex_state = 2},
  [3031] = {.lex_state = 95, .external_lex_state = 2},
  [3032] = {.lex_state = 95, .external_lex_state = 2},
  [3033] = {.lex_state = 95, .external_lex_state = 2},
  [3034] = {.lex_state = 95, .external_lex_state = 2},
  [3035] = {.lex_state = 95, .external_lex_state = 2},
  [3036] = {.lex_state = 95, .external_lex_state = 2},
  [3037] = {.lex_state = 95, .external_lex_state = 2},
  [3038] = {.lex_state = 95, .external_lex_state = 2},
  [3039] = {.lex_state = 95, .external_lex_state = 2},
  [3040] = {.lex_state = 95, .external_lex_state = 2},
  [3041] = {.lex_state = 95, .external_lex_state = 2},
  [3042] = {.lex_state = 95, .external_lex_state = 2},
  [3043] = {.lex_state = 95, .external_lex_state = 2},
  [3044] = {.lex_state = 95, .external_lex_state = 2},
  [3045] = {.lex_state = 95, .external_lex_state = 2},
  [3046] = {.lex_state = 95, .external_lex_state = 2},
  [3047] = {.lex_state = 95, .external_lex_state = 2},
  [3048] = {.lex_state = 95, .external_lex_state = 2},
  [3049] = {.lex_state = 95, .external_lex_state = 2},
  [3050] = {.lex_state = 95, .external_lex_state = 2},
  [3051] = {.lex_state = 95, .external_lex_state = 2},
  [3052] = {.lex_state = 95, .external_lex_state = 2},
  [3053] = {.lex_state = 95, .external_lex_state = 2},
  [3054] = {.lex_state = 95, .external_lex_state = 2},
  [3055] = {.lex_state = 95, .external_lex_state = 2},
  [3056] = {.lex_state = 95, .external_lex_state = 2},
  [3057] = {.lex_state = 95, .external_lex_state = 2},
  [3058] = {.lex_state = 95, .external_lex_state = 2},
  [3059] = {.lex_state = 95, .external_lex_state = 2},
  [3060] = {.lex_state = 95, .external_lex_state = 2},
  [3061] = {.lex_state = 95, .external_lex_state = 2},
  [3062] = {.lex_state = 95, .external_lex_state = 2},
  [3063] = {.lex_state = 95, .external_lex_state = 2},
  [3064] = {.lex_state = 95, .external_lex_state = 2},
  [3065] = {.lex_state = 95, .external_lex_state = 2},
  [3066] = {.lex_state = 95, .external_lex_state = 2},
  [3067] = {.lex_state = 95, .external_lex_state = 2},
  [3068] = {.lex_state = 95, .external_lex_state = 2},
  [3069] = {.lex_state = 95, .external_lex_state = 2},
  [3070] = {.lex_state = 95, .external_lex_state = 2},
  [3071] = {.lex_state = 95, .external_lex_state = 2},
  [3072] = {.lex_state = 95, .external_lex_state = 2},
  [3073] = {.lex_state = 95, .external_lex_state = 2},
  [3074] = {.lex_state = 95, .external_lex_state = 2},
  [3075] = {.lex_state = 95, .external_lex_state = 2},
  [3076] = {.lex_state = 95, .external_lex_state = 2},
  [3077] = {.lex_state = 95, .external_lex_state = 2},
  [3078] = {.lex_state = 95, .external_lex_state = 2},
  [3079] = {.lex_state = 95, .external_lex_state = 2},
  [3080] = {.lex_state = 95, .external_lex_state = 2},
  [3081] = {.lex_state = 95, .external_lex_state = 2},
  [3082] = {.lex_state = 95, .external_lex_state = 2},
  [3083] = {.lex_state = 95, .external_lex_state = 2},
  [3084] = {.lex_state = 95, .external_lex_state = 2},
  [3085] = {.lex_state = 6, .external_lex_state = 2},
  [3086] = {.lex_state = 95, .external_lex_state = 2},
  [3087] = {.lex_state = 95, .external_lex_state = 2},
  [3088] = {.lex_state = 95, .external_lex_state = 2},
  [3089] = {.lex_state = 95, .external_lex_state = 2},
  [3090] = {.lex_state = 95, .external_lex_state = 2},
  [3091] = {.lex_state = 95, .external_lex_state = 2},
  [3092] = {.lex_state = 95, .external_lex_state = 2},
  [3093] = {.lex_state = 95, .external_lex_state = 2},
  [3094] = {.lex_state = 95, .external_lex_state = 2},
  [3095] = {.lex_state = 95, .external_lex_state = 2},
  [3096] = {.lex_state = 95, .external_lex_state = 2},
  [3097] = {.lex_state = 95, .external_lex_state = 2},
  [3098] = {.lex_state = 95, .external_lex_state = 2},
  [3099] = {.lex_state = 95, .external_lex_state = 2},
  [3100] = {.lex_state = 95, .external_lex_state = 5},
  [3101] = {.lex_state = 95, .external_lex_state = 2},
  [3102] = {.lex_state = 95, .external_lex_state = 2},
  [3103] = {.lex_state = 95, .external_lex_state = 2},
  [3104] = {.lex_state = 95, .external_lex_state = 2},
  [3105] = {.lex_state = 95, .external_lex_state = 2},
  [3106] = {.lex_state = 95, .external_lex_state = 2},
  [3107] = {.lex_state = 95, .external_lex_state = 2},
  [3108] = {.lex_state = 95, .external_lex_state = 2},
  [3109] = {.lex_state = 95, .external_lex_state = 2},
  [3110] = {.lex_state = 95, .external_lex_state = 2},
  [3111] = {.lex_state = 95, .external_lex_state = 2},
  [3112] = {.lex_state = 95, .external_lex_state = 2},
  [3113] = {.lex_state = 95, .external_lex_state = 2},
  [3114] = {.lex_state = 95, .external_lex_state = 2},
  [3115] = {.lex_state = 6, .external_lex_state = 2},
  [3116] = {.lex_state = 95, .external_lex_state = 2},
  [3117] = {.lex_state = 6, .external_lex_state = 2},
  [3118] = {.lex_state = 95, .external_lex_state = 2},
  [3119] = {.lex_state = 95, .external_lex_state = 2},
  [3120] = {.lex_state = 95, .external_lex_state = 2},
  [3121] = {.lex_state = 95, .external_lex_state = 2},
  [3122] = {.lex_state = 15, .external_lex_state = 2},
  [3123] = {.lex_state = 15, .external_lex_state = 2},
  [3124] = {.lex_state = 15, .external_lex_state = 2},
  [3125] = {.lex_state = 15, .external_lex_state = 2},
  [3126] = {.lex_state = 15, .external_lex_state = 2},
  [3127] = {.lex_state = 13, .external_lex_state = 2},
  [3128] = {.lex_state = 13, .external_lex_state = 2},
  [3129] = {.lex_state = 15, .external_lex_state = 2},
  [3130] = {.lex_state = 15, .external_lex_state = 2},
  [3131] = {.lex_state = 15, .external_lex_state = 2},
  [3132] = {.lex_state = 15, .external_lex_state = 2},
  [3133] = {.lex_state = 15, .external_lex_state = 2},
  [3134] = {.lex_state = 15, .external_lex_state = 2},
  [3135] = {.lex_state = 15, .external_lex_state = 2},
  [3136] = {.lex_state = 15, .external_lex_state = 2},
  [3137] = {.lex_state = 15, .external_lex_state = 2},
  [3138] = {.lex_state = 15, .external_lex_state = 2},
  [3139] = {.lex_state = 15, .external_lex_state = 2},
  [3140] = {.lex_state = 15, .external_lex_state = 2},
  [3141] = {.lex_state = 15, .external_lex_state = 2},
  [3142] = {.lex_state = 15, .external_lex_state = 2},
  [3143] = {.lex_state = 15, .external_lex_state = 2},
  [3144] = {.lex_state = 15, .external_lex_state = 2},
  [3145] = {.lex_state = 15, .external_lex_state = 2},
  [3146] = {.lex_state = 15, .external_lex_state = 2},
  [3147] = {.lex_state = 15, .external_lex_state = 2},
  [3148] = {.lex_state = 15, .external_lex_state = 2},
  [3149] = {.lex_state = 15, .external_lex_state = 2},
  [3150] = {.lex_state = 15, .external_lex_state = 2},
  [3151] = {.lex_state = 15, .external_lex_state = 2},
  [3152] = {.lex_state = 15, .external_lex_state = 2},
  [3153] = {.lex_state = 15, .external_lex_state = 2},
  [3154] = {.lex_state = 15, .external_lex_state = 2},
  [3155] = {.lex_state = 15, .external_lex_state = 2},
  [3156] = {.lex_state = 15, .external_lex_state = 2},
  [3157] = {.lex_state = 15, .external_lex_state = 2},
  [3158] = {.lex_state = 14, .external_lex_state = 5},
  [3159] = {.lex_state = 15, .external_lex_state = 2},
  [3160] = {.lex_state = 15, .external_lex_state = 2},
  [3161] = {.lex_state = 15, .external_lex_state = 2},
  [3162] = {.lex_state = 15, .external_lex_state = 2},
  [3163] = {.lex_state = 15, .external_lex_state = 2},
  [3164] = {.lex_state = 15, .external_lex_state = 2},
  [3165] = {.lex_state = 14, .external_lex_state = 5},
  [3166] = {.lex_state = 15, .external_lex_state = 2},
  [3167] = {.lex_state = 14, .external_lex_state = 2},
  [3168] = {.lex_state = 15, .external_lex_state = 2},
  [3169] = {.lex_state = 15, .external_lex_state = 5},
  [3170] = {.lex_state = 15, .external_lex_state = 2},
  [3171] = {.lex_state = 15, .external_lex_state = 5},
  [3172] = {.lex_state = 14, .external_lex_state = 2},
  [3173] = {.lex_state = 15, .external_lex_state = 2},
  [3174] = {.lex_state = 15, .external_lex_state = 2},
  [3175] = {.lex_state = 15, .external_lex_state = 5},
  [3176] = {.lex_state = 15, .external_lex_state = 2},
  [3177] = {.lex_state = 11, .external_lex_state = 2},
  [3178] = {.lex_state = 13, .external_lex_state = 2},
  [3179] = {.lex_state = 11, .external_lex_state = 2},
  [3180] = {.lex_state = 11, .external_lex_state = 2},
  [3181] = {.lex_state = 15, .external_lex_state = 5},
  [3182] = {.lex_state = 95, .external_lex_state = 2},
  [3183] = {.lex_state = 95, .external_lex_state = 2},
  [3184] = {.lex_state = 95, .external_lex_state = 2},
  [3185] = {.lex_state = 95, .external_lex_state = 2},
  [3186] = {.lex_state = 11, .external_lex_state = 2},
  [3187] = {.lex_state = 95, .external_lex_state = 2},
  [3188] = {.lex_state = 95, .external_lex_state = 2},
  [3189] = {.lex_state = 95, .external_lex_state = 2},
  [3190] = {.lex_state = 11, .external_lex_state = 2},
  [3191] = {.lex_state = 15, .external_lex_state = 6},
  [3192] = {.lex_state = 15, .external_lex_state = 5},
  [3193] = {.lex_state = 15, .external_lex_state = 5},
  [3194] = {.lex_state = 15, .external_lex_state = 5},
  [3195] = {.lex_state = 15, .external_lex_state = 6},
  [3196] = {.lex_state = 15, .external_lex_state = 6},
  [3197] = {.lex_state = 15, .external_lex_state = 5},
  [3198] = {.lex_state = 14, .external_lex_state = 5},
  [3199] = {.lex_state = 15, .external_lex_state = 5},
  [3200] = {.lex_state = 15, .external_lex_state = 5},
  [3201] = {.lex_state = 15, .external_lex_state = 5},
  [3202] = {.lex_state = 15, .external_lex_state = 5},
  [3203] = {.lex_state = 15, .external_lex_state = 5},
  [3204] = {.lex_state = 11, .external_lex_state = 2},
  [3205] = {.lex_state = 11, .external_lex_state = 2},
  [3206] = {.lex_state = 15, .external_lex_state = 5},
  [3207] = {.lex_state = 11, .external_lex_state = 2},
  [3208] = {.lex_state = 11, .external_lex_state = 2},
  [3209] = {.lex_state = 11, .external_lex_state = 2},
  [3210] = {.lex_state = 11, .external_lex_state = 2},
  [3211] = {.lex_state = 11, .external_lex_state = 2},
  [3212] = {.lex_state = 11, .external_lex_state = 2},
  [3213] = {.lex_state = 11, .external_lex_state = 2},
  [3214] = {.lex_state = 95, .external_lex_state = 2},
  [3215] = {.lex_state = 11, .external_lex_state = 2},
  [3216] = {.lex_state = 95, .external_lex_state = 2},
  [3217] = {.lex_state = 15, .external_lex_state = 5},
  [3218] = {.lex_state = 15, .external_lex_state = 5},
  [3219] = {.lex_state = 15, .external_lex_state = 5},
  [3220] = {.lex_state = 15, .external_lex_state = 5},
  [3221] = {.lex_state = 15, .external_lex_state = 5},
  [3222] = {.lex_state = 15, .external_lex_state = 5},
  [3223] = {.lex_state = 95, .external_lex_state = 2},
  [3224] = {.lex_state = 15, .external_lex_state = 5},
  [3225] = {.lex_state = 15, .external_lex_state = 5},
  [3226] = {.lex_state = 95, .external_lex_state = 2},
  [3227] = {.lex_state = 15, .external_lex_state = 5},
  [3228] = {.lex_state = 11, .external_lex_state = 2},
  [3229] = {.lex_state = 11, .external_lex_state = 2},
  [3230] = {.lex_state = 11, .external_lex_state = 2},
  [3231] = {.lex_state = 95, .external_lex_state = 2},
  [3232] = {.lex_state = 11, .external_lex_state = 2},
  [3233] = {.lex_state = 11, .external_lex_state = 2},
  [3234] = {.lex_state = 11, .external_lex_state = 2},
  [3235] = {.lex_state = 11, .external_lex_state = 2},
  [3236] = {.lex_state = 11, .external_lex_state = 2},
  [3237] = {.lex_state = 95, .external_lex_state = 2},
  [3238] = {.lex_state = 11, .external_lex_state = 2},
  [3239] = {.lex_state = 95, .external_lex_state = 2},
  [3240] = {.lex_state = 11, .external_lex_state = 2},
  [3241] = {.lex_state = 95, .external_lex_state = 2},
  [3242] = {.lex_state = 95, .external_lex_state = 2},
  [3243] = {.lex_state = 95, .external_lex_state = 2},
  [3244] = {.lex_state = 95, .external_lex_state = 2},
  [3245] = {.lex_state = 95, .external_lex_state = 2},
  [3246] = {.lex_state = 95, .external_lex_state = 2},
  [3247] = {.lex_state = 95, .external_lex_state = 2},
  [3248] = {.lex_state = 15, .external_lex_state = 5},
  [3249] = {.lex_state = 15, .external_lex_state = 5},
  [3250] = {.lex_state = 15, .external_lex_state = 5},
  [3251] = {.lex_state = 15, .external_lex_state = 5},
  [3252] = {.lex_state = 15, .external_lex_state = 5},
  [3253] = {.lex_state = 15, .external_lex_state = 5},
  [3254] = {.lex_state = 15, .external_lex_state = 5},
  [3255] = {.lex_state = 15, .external_lex_state = 5},
  [3256] = {.lex_state = 15, .external_lex_state = 5},
  [3257] = {.lex_state = 15, .external_lex_state = 5},
  [3258] = {.lex_state = 15, .external_lex_state = 5},
  [3259] = {.lex_state = 15, .external_lex_state = 5},
  [3260] = {.lex_state = 15, .external_lex_state = 5},
  [3261] = {.lex_state = 11, .external_lex_state = 2},
  [3262] = {.lex_state = 15, .external_lex_state = 5},
  [3263] = {.lex_state = 11, .external_lex_state = 2},
  [3264] = {.lex_state = 95, .external_lex_state = 2},
  [3265] = {.lex_state = 95, .external_lex_state = 2},
  [3266] = {.lex_state = 95, .external_lex_state = 2},
  [3267] = {.lex_state = 95, .external_lex_state = 2},
  [3268] = {.lex_state = 95, .external_lex_state = 2},
  [3269] = {.lex_state = 11, .external_lex_state = 2},
  [3270] = {.lex_state = 11, .external_lex_state = 2},
  [3271] = {.lex_state = 95, .external_lex_state = 2},
  [3272] = {.lex_state = 95, .external_lex_state = 2},
  [3273] = {.lex_state = 11, .external_lex_state = 2},
  [3274] = {.lex_state = 11, .external_lex_state = 2},
  [3275] = {.lex_state = 95, .external_lex_state = 2},
  [3276] = {.lex_state = 11, .external_lex_state = 2},
  [3277] = {.lex_state = 11, .external_lex_state = 2},
  [3278] = {.lex_state = 11, .external_lex_state = 2},
  [3279] = {.lex_state = 11, .external_lex_state = 2},
  [3280] = {.lex_state = 11, .external_lex_state = 2},
  [3281] = {.lex_state = 11, .external_lex_state = 2},
  [3282] = {.lex_state = 11, .external_lex_state = 2},
  [3283] = {.lex_state = 11, .external_lex_state = 2},
  [3284] = {.lex_state = 14, .external_lex_state = 5},
  [3285] = {.lex_state = 95, .external_lex_state = 2},
  [3286] = {.lex_state = 95, .external_lex_state = 2},
  [3287] = {.lex_state = 11, .external_lex_state = 2},
  [3288] = {.lex_state = 13, .external_lex_state = 5},
  [3289] = {.lex_state = 13, .external_lex_state = 5},
  [3290] = {.lex_state = 13, .external_lex_state = 5},
  [3291] = {.lex_state = 13, .external_lex_state = 5},
  [3292] = {.lex_state = 13, .external_lex_state = 5},
  [3293] = {.lex_state = 11, .external_lex_state = 2},
  [3294] = {.lex_state = 11, .external_lex_state = 2},
  [3295] = {.lex_state = 13, .external_lex_state = 5},
  [3296] = {.lex_state = 11, .external_lex_state = 2},
  [3297] = {.lex_state = 13, .external_lex_state = 5},
  [3298] = {.lex_state = 13, .external_lex_state = 5},
  [3299] = {.lex_state = 11, .external_lex_state = 2},
  [3300] = {.lex_state = 13, .external_lex_state = 5},
  [3301] = {.lex_state = 13, .external_lex_state = 5},
  [3302] = {.lex_state = 11, .external_lex_state = 2},
  [3303] = {.lex_state = 13, .external_lex_state = 5},
  [3304] = {.lex_state = 13, .external_lex_state = 5},
  [3305] = {.lex_state = 11, .external_lex_state = 2},
  [3306] = {.lex_state = 13, .external_lex_state = 5},
  [3307] = {.lex_state = 13, .external_lex_state = 5},
  [3308] = {.lex_state = 13, .external_lex_state = 5},
  [3309] = {.lex_state = 95, .external_lex_state = 2},
  [3310] = {.lex_state = 13, .external_lex_state = 5},
  [3311] = {.lex_state = 13, .external_lex_state = 5},
  [3312] = {.lex_state = 11, .external_lex_state = 2},
  [3313] = {.lex_state = 13, .external_lex_state = 5},
  [3314] = {.lex_state = 13, .external_lex_state = 5},
  [3315] = {.lex_state = 13, .external_lex_state = 5},
  [3316] = {.lex_state = 13, .external_lex_state = 5},
  [3317] = {.lex_state = 13, .external_lex_state = 5},
  [3318] = {.lex_state = 95, .external_lex_state = 2},
  [3319] = {.lex_state = 13, .external_lex_state = 5},
  [3320] = {.lex_state = 13, .external_lex_state = 5},
  [3321] = {.lex_state = 11, .external_lex_state = 2},
  [3322] = {.lex_state = 13, .external_lex_state = 5},
  [3323] = {.lex_state = 11, .external_lex_state = 2},
  [3324] = {.lex_state = 13, .external_lex_state = 5},
  [3325] = {.lex_state = 11, .external_lex_state = 2},
  [3326] = {.lex_state = 95, .external_lex_state = 2},
  [3327] = {.lex_state = 95, .external_lex_state = 2},
  [3328] = {.lex_state = 13, .external_lex_state = 5},
  [3329] = {.lex_state = 13, .external_lex_state = 5},
  [3330] = {.lex_state = 13, .external_lex_state = 5},
  [3331] = {.lex_state = 11, .external_lex_state = 2},
  [3332] = {.lex_state = 11, .external_lex_state = 2},
  [3333] = {.lex_state = 15, .external_lex_state = 6},
  [3334] = {.lex_state = 15, .external_lex_state = 6},
  [3335] = {.lex_state = 15, .external_lex_state = 5},
  [3336] = {.lex_state = 15, .external_lex_state = 6},
  [3337] = {.lex_state = 15, .external_lex_state = 6},
  [3338] = {.lex_state = 11, .external_lex_state = 5},
  [3339] = {.lex_state = 15, .external_lex_state = 5},
  [3340] = {.lex_state = 15, .external_lex_state = 6},
  [3341] = {.lex_state = 15, .external_lex_state = 6},
  [3342] = {.lex_state = 13, .external_lex_state = 5},
  [3343] = {.lex_state = 11, .external_lex_state = 5},
  [3344] = {.lex_state = 11, .external_lex_state = 5},
  [3345] = {.lex_state = 13, .external_lex_state = 5},
  [3346] = {.lex_state = 15, .external_lex_state = 6},
  [3347] = {.lex_state = 13, .external_lex_state = 5},
  [3348] = {.lex_state = 15, .external_lex_state = 6},
  [3349] = {.lex_state = 11, .external_lex_state = 5},
  [3350] = {.lex_state = 11, .external_lex_state = 5},
  [3351] = {.lex_state = 15, .external_lex_state = 6},
  [3352] = {.lex_state = 13, .external_lex_state = 5},
  [3353] = {.lex_state = 15, .external_lex_state = 6},
  [3354] = {.lex_state = 15, .external_lex_state = 6},
  [3355] = {.lex_state = 11, .external_lex_state = 5},
  [3356] = {.lex_state = 15, .external_lex_state = 5},
  [3357] = {.lex_state = 15, .external_lex_state = 6},
  [3358] = {.lex_state = 11, .external_lex_state = 5},
  [3359] = {.lex_state = 13, .external_lex_state = 5},
  [3360] = {.lex_state = 13, .external_lex_state = 5},
  [3361] = {.lex_state = 15, .external_lex_state = 6},
  [3362] = {.lex_state = 15, .external_lex_state = 5},
  [3363] = {.lex_state = 15, .external_lex_state = 6},
  [3364] = {.lex_state = 11, .external_lex_state = 5},
  [3365] = {.lex_state = 15, .external_lex_state = 6},
  [3366] = {.lex_state = 13, .external_lex_state = 5},
  [3367] = {.lex_state = 14, .external_lex_state = 5},
  [3368] = {.lex_state = 14, .external_lex_state = 5},
  [3369] = {.lex_state = 13, .external_lex_state = 5},
  [3370] = {.lex_state = 15, .external_lex_state = 6},
  [3371] = {.lex_state = 13, .external_lex_state = 5},
  [3372] = {.lex_state = 15, .external_lex_state = 6},
  [3373] = {.lex_state = 15, .external_lex_state = 6},
  [3374] = {.lex_state = 15, .external_lex_state = 6},
  [3375] = {.lex_state = 15, .external_lex_state = 6},
  [3376] = {.lex_state = 15, .external_lex_state = 6},
  [3377] = {.lex_state = 15, .external_lex_state = 6},
  [3378] = {.lex_state = 13, .external_lex_state = 5},
  [3379] = {.lex_state = 15, .external_lex_state = 6},
  [3380] = {.lex_state = 11, .external_lex_state = 5},
  [3381] = {.lex_state = 11, .external_lex_state = 5},
  [3382] = {.lex_state = 15, .external_lex_state = 6},
  [3383] = {.lex_state = 15, .external_lex_state = 6},
  [3384] = {.lex_state = 11, .external_lex_state = 5},
  [3385] = {.lex_state = 15, .external_lex_state = 6},
  [3386] = {.lex_state = 15, .external_lex_state = 5},
  [3387] = {.lex_state = 11, .external_lex_state = 5},
  [3388] = {.lex_state = 15, .external_lex_state = 6},
  [3389] = {.lex_state = 15, .external_lex_state = 6},
  [3390] = {.lex_state = 15, .external_lex_state = 6},
  [3391] = {.lex_state = 15, .external_lex_state = 6},
  [3392] = {.lex_state = 15, .external_lex_state = 6},
  [3393] = {.lex_state = 15, .external_lex_state = 5},
  [3394] = {.lex_state = 15, .external_lex_state = 6},
  [3395] = {.lex_state = 15, .external_lex_state = 6},
  [3396] = {.lex_state = 14, .external_lex_state = 2},
  [3397] = {.lex_state = 14, .external_lex_state = 6},
  [3398] = {.lex_state = 15, .external_lex_state = 6},
  [3399] = {.lex_state = 13, .external_lex_state = 5},
  [3400] = {.lex_state = 15, .external_lex_state = 5},
  [3401] = {.lex_state = 13, .external_lex_state = 5},
  [3402] = {.lex_state = 13, .external_lex_state = 5},
  [3403] = {.lex_state = 13, .external_lex_state = 5},
  [3404] = {.lex_state = 11, .external_lex_state = 5},
  [3405] = {.lex_state = 13, .external_lex_state = 5},
  [3406] = {.lex_state = 13, .external_lex_state = 5},
  [3407] = {.lex_state = 13, .external_lex_state = 5},
  [3408] = {.lex_state = 13, .external_lex_state = 5},
  [3409] = {.lex_state = 13, .external_lex_state = 5},
  [3410] = {.lex_state = 13, .external_lex_state = 5},
  [3411] = {.lex_state = 13, .external_lex_state = 5},
  [3412] = {.lex_state = 13, .external_lex_state = 5},
  [3413] = {.lex_state = 13, .external_lex_state = 5},
  [3414] = {.lex_state = 13, .external_lex_state = 5},
  [3415] = {.lex_state = 13, .external_lex_state = 5},
  [3416] = {.lex_state = 13, .external_lex_state = 5},
  [3417] = {.lex_state = 11, .external_lex_state = 5},
  [3418] = {.lex_state = 11, .external_lex_state = 2},
  [3419] = {.lex_state = 13, .external_lex_state = 5},
  [3420] = {.lex_state = 13, .external_lex_state = 5},
  [3421] = {.lex_state = 13, .external_lex_state = 5},
  [3422] = {.lex_state = 13, .external_lex_state = 5},
  [3423] = {.lex_state = 13, .external_lex_state = 5},
  [3424] = {.lex_state = 13, .external_lex_state = 5},
  [3425] = {.lex_state = 11, .external_lex_state = 5},
  [3426] = {.lex_state = 11, .external_lex_state = 5},
  [3427] = {.lex_state = 13, .external_lex_state = 5},
  [3428] = {.lex_state = 11, .external_lex_state = 5},
  [3429] = {.lex_state = 13, .external_lex_state = 5},
  [3430] = {.lex_state = 13, .external_lex_state = 5},
  [3431] = {.lex_state = 13, .external_lex_state = 5},
  [3432] = {.lex_state = 14, .external_lex_state = 6},
  [3433] = {.lex_state = 15, .external_lex_state = 2},
  [3434] = {.lex_state = 13, .external_lex_state = 5},
  [3435] = {.lex_state = 13, .external_lex_state = 5},
  [3436] = {.lex_state = 13, .external_lex_state = 5},
  [3437] = {.lex_state = 13, .external_lex_state = 5},
  [3438] = {.lex_state = 13, .external_lex_state = 5},
  [3439] = {.lex_state = 13, .external_lex_state = 5},
  [3440] = {.lex_state = 13, .external_lex_state = 5},
  [3441] = {.lex_state = 13, .external_lex_state = 5},
  [3442] = {.lex_state = 13, .external_lex_state = 5},
  [3443] = {.lex_state = 13, .external_lex_state = 5},
  [3444] = {.lex_state = 13, .external_lex_state = 5},
  [3445] = {.lex_state = 13, .external_lex_state = 5},
  [3446] = {.lex_state = 14, .external_lex_state = 2},
  [3447] = {.lex_state = 15, .external_lex_state = 2},
  [3448] = {.lex_state = 15, .external_lex_state = 2},
  [3449] = {.lex_state = 13, .external_lex_state = 5},
  [3450] = {.lex_state = 13, .external_lex_state = 5},
  [3451] = {.lex_state = 11, .external_lex_state = 2},
  [3452] = {.lex_state = 13, .external_lex_state = 5},
  [3453] = {.lex_state = 11, .external_lex_state = 5},
  [3454] = {.lex_state = 11, .external_lex_state = 5},
  [3455] = {.lex_state = 11, .external_lex_state = 5},
  [3456] = {.lex_state = 11, .external_lex_state = 5},
  [3457] = {.lex_state = 11, .external_lex_state = 5},
  [3458] = {.lex_state = 15, .external_lex_state = 6},
  [3459] = {.lex_state = 11, .external_lex_state = 5},
  [3460] = {.lex_state = 15, .external_lex_state = 6},
  [3461] = {.lex_state = 11, .external_lex_state = 5},
  [3462] = {.lex_state = 15, .external_lex_state = 6},
  [3463] = {.lex_state = 11, .external_lex_state = 5},
  [3464] = {.lex_state = 11, .external_lex_state = 5},
  [3465] = {.lex_state = 11, .external_lex_state = 5},
  [3466] = {.lex_state = 11, .external_lex_state = 5},
  [3467] = {.lex_state = 11, .external_lex_state = 5},
  [3468] = {.lex_state = 11, .external_lex_state = 5},
  [3469] = {.lex_state = 15, .external_lex_state = 6},
  [3470] = {.lex_state = 11, .external_lex_state = 5},
  [3471] = {.lex_state = 11, .external_lex_state = 5},
  [3472] = {.lex_state = 11, .external_lex_state = 5},
  [3473] = {.lex_state = 15, .external_lex_state = 6},
  [3474] = {.lex_state = 11, .external_lex_state = 5},
  [3475] = {.lex_state = 13, .external_lex_state = 6},
  [3476] = {.lex_state = 11, .external_lex_state = 5},
  [3477] = {.lex_state = 11, .external_lex_state = 5},
  [3478] = {.lex_state = 14, .external_lex_state = 6},
  [3479] = {.lex_state = 14, .external_lex_state = 6},
  [3480] = {.lex_state = 11, .external_lex_state = 5},
  [3481] = {.lex_state = 11, .external_lex_state = 5},
  [3482] = {.lex_state = 13, .external_lex_state = 5},
  [3483] = {.lex_state = 11, .external_lex_state = 5},
  [3484] = {.lex_state = 11, .external_lex_state = 5},
  [3485] = {.lex_state = 11, .external_lex_state = 5},
  [3486] = {.lex_state = 11, .external_lex_state = 5},
  [3487] = {.lex_state = 11, .external_lex_state = 5},
  [3488] = {.lex_state = 11, .external_lex_state = 5},
  [3489] = {.lex_state = 15, .external_lex_state = 6},
  [3490] = {.lex_state = 11, .external_lex_state = 5},
  [3491] = {.lex_state = 20, .external_lex_state = 2},
  [3492] = {.lex_state = 20, .external_lex_state = 2},
  [3493] = {.lex_state = 11, .external_lex_state = 5},
  [3494] = {.lex_state = 11, .external_lex_state = 5},
  [3495] = {.lex_state = 11, .external_lex_state = 5},
  [3496] = {.lex_state = 11, .external_lex_state = 5},
  [3497] = {.lex_state = 11, .external_lex_state = 5},
  [3498] = {.lex_state = 11, .external_lex_state = 5},
  [3499] = {.lex_state = 11, .external_lex_state = 5},
  [3500] = {.lex_state = 11, .external_lex_state = 5},
  [3501] = {.lex_state = 13, .external_lex_state = 5},
  [3502] = {.lex_state = 11, .external_lex_state = 5},
  [3503] = {.lex_state = 11, .external_lex_state = 5},
  [3504] = {.lex_state = 11, .external_lex_state = 5},
  [3505] = {.lex_state = 13, .external_lex_state = 5},
  [3506] = {.lex_state = 11, .external_lex_state = 5},
  [3507] = {.lex_state = 11, .external_lex_state = 5},
  [3508] = {.lex_state = 11, .external_lex_state = 5},
  [3509] = {.lex_state = 95, .external_lex_state = 2},
  [3510] = {.lex_state = 11, .external_lex_state = 5},
  [3511] = {.lex_state = 11, .external_lex_state = 5},
  [3512] = {.lex_state = 11, .external_lex_state = 5},
  [3513] = {.lex_state = 11, .external_lex_state = 5},
  [3514] = {.lex_state = 13, .external_lex_state = 5},
  [3515] = {.lex_state = 15, .external_lex_state = 6},
  [3516] = {.lex_state = 11, .external_lex_state = 5},
  [3517] = {.lex_state = 11, .external_lex_state = 5},
  [3518] = {.lex_state = 11, .external_lex_state = 5},
  [3519] = {.lex_state = 11, .external_lex_state = 6},
  [3520] = {.lex_state = 11, .external_lex_state = 5},
  [3521] = {.lex_state = 13, .external_lex_state = 2},
  [3522] = {.lex_state = 14, .external_lex_state = 2},
  [3523] = {.lex_state = 13, .external_lex_state = 2},
  [3524] = {.lex_state = 11, .external_lex_state = 6},
  [3525] = {.lex_state = 13, .external_lex_state = 2},
  [3526] = {.lex_state = 11, .external_lex_state = 2},
  [3527] = {.lex_state = 13, .external_lex_state = 2},
  [3528] = {.lex_state = 13, .external_lex_state = 2},
  [3529] = {.lex_state = 95, .external_lex_state = 2},
  [3530] = {.lex_state = 13, .external_lex_state = 2},
  [3531] = {.lex_state = 11, .external_lex_state = 5},
  [3532] = {.lex_state = 11, .external_lex_state = 5},
  [3533] = {.lex_state = 95, .external_lex_state = 2},
  [3534] = {.lex_state = 13, .external_lex_state = 2},
  [3535] = {.lex_state = 13, .external_lex_state = 2},
  [3536] = {.lex_state = 95, .external_lex_state = 2},
  [3537] = {.lex_state = 11, .external_lex_state = 5},
  [3538] = {.lex_state = 11, .external_lex_state = 6},
  [3539] = {.lex_state = 13, .external_lex_state = 2},
  [3540] = {.lex_state = 11, .external_lex_state = 5},
  [3541] = {.lex_state = 13, .external_lex_state = 5},
  [3542] = {.lex_state = 13, .external_lex_state = 2},
  [3543] = {.lex_state = 13, .external_lex_state = 2},
  [3544] = {.lex_state = 6, .external_lex_state = 2},
  [3545] = {.lex_state = 11, .external_lex_state = 6},
  [3546] = {.lex_state = 6, .external_lex_state = 5},
  [3547] = {.lex_state = 95, .external_lex_state = 2},
  [3548] = {.lex_state = 13, .external_lex_state = 2},
  [3549] = {.lex_state = 11, .external_lex_state = 6},
  [3550] = {.lex_state = 13, .external_lex_state = 2},
  [3551] = {.lex_state = 11, .external_lex_state = 6},
  [3552] = {.lex_state = 11, .external_lex_state = 5},
  [3553] = {.lex_state = 11, .external_lex_state = 6},
  [3554] = {.lex_state = 11, .external_lex_state = 6},
  [3555] = {.lex_state = 11, .external_lex_state = 6},
  [3556] = {.lex_state = 6, .external_lex_state = 2},
  [3557] = {.lex_state = 11, .external_lex_state = 6},
  [3558] = {.lex_state = 11, .external_lex_state = 6},
  [3559] = {.lex_state = 11, .external_lex_state = 6},
  [3560] = {.lex_state = 11, .external_lex_state = 6},
  [3561] = {.lex_state = 11, .external_lex_state = 6},
  [3562] = {.lex_state = 11, .external_lex_state = 6},
  [3563] = {.lex_state = 13, .external_lex_state = 2},
  [3564] = {.lex_state = 6, .external_lex_state = 5},
  [3565] = {.lex_state = 6, .external_lex_state = 5},
  [3566] = {.lex_state = 6, .external_lex_state = 5},
  [3567] = {.lex_state = 6, .external_lex_state = 5},
  [3568] = {.lex_state = 6, .external_lex_state = 5},
  [3569] = {.lex_state = 6, .external_lex_state = 5},
  [3570] = {.lex_state = 11, .external_lex_state = 6},
  [3571] = {.lex_state = 11, .external_lex_state = 6},
  [3572] = {.lex_state = 11, .external_lex_state = 6},
  [3573] = {.lex_state = 11, .external_lex_state = 2},
  [3574] = {.lex_state = 11, .external_lex_state = 2},
  [3575] = {.lex_state = 11, .external_lex_state = 2},
  [3576] = {.lex_state = 11, .external_lex_state = 5},
  [3577] = {.lex_state = 11, .external_lex_state = 6},
  [3578] = {.lex_state = 15, .external_lex_state = 2},
  [3579] = {.lex_state = 12, .external_lex_state = 2},
  [3580] = {.lex_state = 13, .external_lex_state = 2},
  [3581] = {.lex_state = 12, .external_lex_state = 2},
  [3582] = {.lex_state = 11, .external_lex_state = 5},
  [3583] = {.lex_state = 11, .external_lex_state = 2},
  [3584] = {.lex_state = 12, .external_lex_state = 2},
  [3585] = {.lex_state = 6, .external_lex_state = 2},
  [3586] = {.lex_state = 11, .external_lex_state = 2},
  [3587] = {.lex_state = 11, .external_lex_state = 2},
  [3588] = {.lex_state = 11, .external_lex_state = 5},
  [3589] = {.lex_state = 11, .external_lex_state = 6},
  [3590] = {.lex_state = 15, .external_lex_state = 2},
  [3591] = {.lex_state = 11, .external_lex_state = 6},
  [3592] = {.lex_state = 11, .external_lex_state = 6},
  [3593] = {.lex_state = 11, .external_lex_state = 6},
  [3594] = {.lex_state = 11, .external_lex_state = 5},
  [3595] = {.lex_state = 11, .external_lex_state = 6},
  [3596] = {.lex_state = 13, .external_lex_state = 2},
  [3597] = {.lex_state = 11, .external_lex_state = 6},
  [3598] = {.lex_state = 11, .external_lex_state = 6},
  [3599] = {.lex_state = 11, .external_lex_state = 2},
  [3600] = {.lex_state = 11, .external_lex_state = 6},
  [3601] = {.lex_state = 11, .external_lex_state = 6},
  [3602] = {.lex_state = 13, .external_lex_state = 2},
  [3603] = {.lex_state = 11, .external_lex_state = 6},
  [3604] = {.lex_state = 12, .external_lex_state = 2},
  [3605] = {.lex_state = 12, .external_lex_state = 2},
  [3606] = {.lex_state = 12, .external_lex_state = 2},
  [3607] = {.lex_state = 15, .external_lex_state = 2},
  [3608] = {.lex_state = 13, .external_lex_state = 2},
  [3609] = {.lex_state = 12, .external_lex_state = 2},
  [3610] = {.lex_state = 12, .external_lex_state = 2},
  [3611] = {.lex_state = 11, .external_lex_state = 6},
  [3612] = {.lex_state = 11, .external_lex_state = 6},
  [3613] = {.lex_state = 13, .external_lex_state = 2},
  [3614] = {.lex_state = 11, .external_lex_state = 6},
  [3615] = {.lex_state = 15, .external_lex_state = 2},
  [3616] = {.lex_state = 11, .external_lex_state = 6},
  [3617] = {.lex_state = 11, .external_lex_state = 6},
  [3618] = {.lex_state = 11, .external_lex_state = 6},
  [3619] = {.lex_state = 11, .external_lex_state = 5},
  [3620] = {.lex_state = 11, .external_lex_state = 6},
  [3621] = {.lex_state = 13, .external_lex_state = 2},
  [3622] = {.lex_state = 11, .external_lex_state = 6},
  [3623] = {.lex_state = 13, .external_lex_state = 2},
  [3624] = {.lex_state = 11, .external_lex_state = 6},
  [3625] = {.lex_state = 13, .external_lex_state = 2},
  [3626] = {.lex_state = 11, .external_lex_state = 5},
  [3627] = {.lex_state = 12, .external_lex_state = 2},
  [3628] = {.lex_state = 12, .external_lex_state = 2},
  [3629] = {.lex_state = 12, .external_lex_state = 2},
  [3630] = {.lex_state = 11, .external_lex_state = 6},
  [3631] = {.lex_state = 13, .external_lex_state = 2},
  [3632] = {.lex_state = 11, .external_lex_state = 6},
  [3633] = {.lex_state = 13, .external_lex_state = 2},
  [3634] = {.lex_state = 11, .external_lex_state = 6},
  [3635] = {.lex_state = 11, .external_lex_state = 6},
  [3636] = {.lex_state = 11, .external_lex_state = 6},
  [3637] = {.lex_state = 11, .external_lex_state = 6},
  [3638] = {.lex_state = 11, .external_lex_state = 5},
  [3639] = {.lex_state = 11, .external_lex_state = 5},
  [3640] = {.lex_state = 15, .external_lex_state = 2},
  [3641] = {.lex_state = 15, .external_lex_state = 2},
  [3642] = {.lex_state = 13, .external_lex_state = 2},
  [3643] = {.lex_state = 11, .external_lex_state = 5},
  [3644] = {.lex_state = 11, .external_lex_state = 5},
  [3645] = {.lex_state = 11, .external_lex_state = 5},
  [3646] = {.lex_state = 11, .external_lex_state = 6},
  [3647] = {.lex_state = 11, .external_lex_state = 6},
  [3648] = {.lex_state = 13, .external_lex_state = 2},
  [3649] = {.lex_state = 11, .external_lex_state = 6},
  [3650] = {.lex_state = 11, .external_lex_state = 6},
  [3651] = {.lex_state = 13, .external_lex_state = 2},
  [3652] = {.lex_state = 11, .external_lex_state = 5},
  [3653] = {.lex_state = 11, .external_lex_state = 6},
  [3654] = {.lex_state = 15, .external_lex_state = 2},
  [3655] = {.lex_state = 13, .external_lex_state = 2},
  [3656] = {.lex_state = 11, .external_lex_state = 6},
  [3657] = {.lex_state = 15, .external_lex_state = 2},
  [3658] = {.lex_state = 11, .external_lex_state = 5},
  [3659] = {.lex_state = 11, .external_lex_state = 5},
  [3660] = {.lex_state = 13, .external_lex_state = 2},
  [3661] = {.lex_state = 11, .external_lex_state = 6},
  [3662] = {.lex_state = 11, .external_lex_state = 6},
  [3663] = {.lex_state = 11, .external_lex_state = 5},
  [3664] = {.lex_state = 11, .external_lex_state = 5},
  [3665] = {.lex_state = 13, .external_lex_state = 2},
  [3666] = {.lex_state = 11, .external_lex_state = 6},
  [3667] = {.lex_state = 13, .external_lex_state = 2},
  [3668] = {.lex_state = 13, .external_lex_state = 2},
  [3669] = {.lex_state = 13, .external_lex_state = 2},
  [3670] = {.lex_state = 11, .external_lex_state = 6},
  [3671] = {.lex_state = 13, .external_lex_state = 2},
  [3672] = {.lex_state = 13, .external_lex_state = 2},
  [3673] = {.lex_state = 13, .external_lex_state = 2},
  [3674] = {.lex_state = 11, .external_lex_state = 6},
  [3675] = {.lex_state = 15, .external_lex_state = 2},
  [3676] = {.lex_state = 11, .external_lex_state = 5},
  [3677] = {.lex_state = 11, .external_lex_state = 6},
  [3678] = {.lex_state = 11, .external_lex_state = 5},
  [3679] = {.lex_state = 13, .external_lex_state = 2},
  [3680] = {.lex_state = 11, .external_lex_state = 6},
  [3681] = {.lex_state = 11, .external_lex_state = 6},
  [3682] = {.lex_state = 11, .external_lex_state = 6},
  [3683] = {.lex_state = 11, .external_lex_state = 6},
  [3684] = {.lex_state = 11, .external_lex_state = 5},
  [3685] = {.lex_state = 11, .external_lex_state = 6},
  [3686] = {.lex_state = 11, .external_lex_state = 5},
  [3687] = {.lex_state = 13, .external_lex_state = 2},
  [3688] = {.lex_state = 15, .external_lex_state = 2},
  [3689] = {.lex_state = 13, .external_lex_state = 2},
  [3690] = {.lex_state = 11, .external_lex_state = 5},
  [3691] = {.lex_state = 14, .external_lex_state = 2},
  [3692] = {.lex_state = 14, .external_lex_state = 2},
  [3693] = {.lex_state = 14, .external_lex_state = 2},
  [3694] = {.lex_state = 14, .external_lex_state = 2},
  [3695] = {.lex_state = 14, .external_lex_state = 2},
  [3696] = {.lex_state = 14, .external_lex_state = 2},
  [3697] = {.lex_state = 15, .external_lex_state = 2},
  [3698] = {.lex_state = 11, .external_lex_state = 5},
  [3699] = {.lex_state = 95, .external_lex_state = 2},
  [3700] = {.lex_state = 11, .external_lex_state = 6},
  [3701] = {.lex_state = 11, .external_lex_state = 6},
  [3702] = {.lex_state = 13, .external_lex_state = 2},
  [3703] = {.lex_state = 11, .external_lex_state = 5},
  [3704] = {.lex_state = 11, .external_lex_state = 6},
  [3705] = {.lex_state = 95, .external_lex_state = 5},
  [3706] = {.lex_state = 11, .external_lex_state = 6},
  [3707] = {.lex_state = 95, .external_lex_state = 5},
  [3708] = {.lex_state = 95, .external_lex_state = 2},
  [3709] = {.lex_state = 11, .external_lex_state = 6},
  [3710] = {.lex_state = 15, .external_lex_state = 2},
  [3711] = {.lex_state = 13, .external_lex_state = 2},
  [3712] = {.lex_state = 11, .external_lex_state = 6},
  [3713] = {.lex_state = 11, .external_lex_state = 5},
  [3714] = {.lex_state = 11, .external_lex_state = 5},
  [3715] = {.lex_state = 11, .external_lex_state = 5},
  [3716] = {.lex_state = 14, .external_lex_state = 2},
  [3717] = {.lex_state = 11, .external_lex_state = 5},
  [3718] = {.lex_state = 11, .external_lex_state = 5},
  [3719] = {.lex_state = 11, .external_lex_state = 5},
  [3720] = {.lex_state = 11, .external_lex_state = 5},
  [3721] = {.lex_state = 11, .external_lex_state = 5},
  [3722] = {.lex_state = 11, .external_lex_state = 5},
  [3723] = {.lex_state = 13, .external_lex_state = 2},
  [3724] = {.lex_state = 95, .external_lex_state = 2},
  [3725] = {.lex_state = 13, .external_lex_state = 2},
  [3726] = {.lex_state = 11, .external_lex_state = 5},
  [3727] = {.lex_state = 11, .external_lex_state = 5},
  [3728] = {.lex_state = 11, .external_lex_state = 5},
  [3729] = {.lex_state = 11, .external_lex_state = 6},
  [3730] = {.lex_state = 11, .external_lex_state = 5},
  [3731] = {.lex_state = 11, .external_lex_state = 5},
  [3732] = {.lex_state = 11, .external_lex_state = 5},
  [3733] = {.lex_state = 11, .external_lex_state = 5},
  [3734] = {.lex_state = 11, .external_lex_state = 5},
  [3735] = {.lex_state = 11, .external_lex_state = 6},
  [3736] = {.lex_state = 11, .external_lex_state = 5},
  [3737] = {.lex_state = 11, .external_lex_state = 5},
  [3738] = {.lex_state = 13, .external_lex_state = 2},
  [3739] = {.lex_state = 15, .external_lex_state = 2},
  [3740] = {.lex_state = 13, .external_lex_state = 2},
  [3741] = {.lex_state = 11, .external_lex_state = 5},
  [3742] = {.lex_state = 11, .external_lex_state = 2},
  [3743] = {.lex_state = 6, .external_lex_state = 5},
  [3744] = {.lex_state = 18, .external_lex_state = 7},
  [3745] = {.lex_state = 20, .external_lex_state = 2},
  [3746] = {.lex_state = 11, .external_lex_state = 5},
  [3747] = {.lex_state = 13, .external_lex_state = 2},
  [3748] = {.lex_state = 11, .external_lex_state = 5},
  [3749] = {.lex_state = 20, .external_lex_state = 2},
  [3750] = {.lex_state = 18, .external_lex_state = 7},
  [3751] = {.lex_state = 11, .external_lex_state = 5},
  [3752] = {.lex_state = 20, .external_lex_state = 2},
  [3753] = {.lex_state = 20, .external_lex_state = 2},
  [3754] = {.lex_state = 20, .external_lex_state = 2},
  [3755] = {.lex_state = 20, .external_lex_state = 2},
  [3756] = {.lex_state = 20, .external_lex_state = 2},
  [3757] = {.lex_state = 95, .external_lex_state = 2},
  [3758] = {.lex_state = 18, .external_lex_state = 7},
  [3759] = {.lex_state = 6, .external_lex_state = 5},
  [3760] = {.lex_state = 11, .external_lex_state = 2},
  [3761] = {.lex_state = 18, .external_lex_state = 7},
  [3762] = {.lex_state = 18, .external_lex_state = 7},
  [3763] = {.lex_state = 20, .external_lex_state = 2},
  [3764] = {.lex_state = 18, .external_lex_state = 7},
  [3765] = {.lex_state = 20, .external_lex_state = 2},
  [3766] = {.lex_state = 14, .external_lex_state = 2},
  [3767] = {.lex_state = 14, .external_lex_state = 2},
  [3768] = {.lex_state = 18, .external_lex_state = 7},
  [3769] = {.lex_state = 6, .external_lex_state = 5},
  [3770] = {.lex_state = 18, .external_lex_state = 7},
  [3771] = {.lex_state = 11, .external_lex_state = 2},
  [3772] = {.lex_state = 11, .external_lex_state = 6},
  [3773] = {.lex_state = 6, .external_lex_state = 6},
  [3774] = {.lex_state = 6, .external_lex_state = 5},
  [3775] = {.lex_state = 11, .external_lex_state = 5},
  [3776] = {.lex_state = 6, .external_lex_state = 5},
  [3777] = {.lex_state = 95, .external_lex_state = 5},
  [3778] = {.lex_state = 11, .external_lex_state = 2},
  [3779] = {.lex_state = 11, .external_lex_state = 2},
  [3780] = {.lex_state = 11, .external_lex_state = 2},
  [3781] = {.lex_state = 95, .external_lex_state = 5},
  [3782] = {.lex_state = 95, .external_lex_state = 5},
  [3783] = {.lex_state = 11, .external_lex_state = 2},
  [3784] = {.lex_state = 11, .external_lex_state = 2},
  [3785] = {.lex_state = 95, .external_lex_state = 5},
  [3786] = {.lex_state = 95, .external_lex_state = 5},
  [3787] = {.lex_state = 95, .external_lex_state = 5},
  [3788] = {.lex_state = 95, .external_lex_state = 5},
  [3789] = {.lex_state = 95, .external_lex_state = 5},
  [3790] = {.lex_state = 11, .external_lex_state = 2},
  [3791] = {.lex_state = 95, .external_lex_state = 5},
  [3792] = {.lex_state = 95, .external_lex_state = 5},
  [3793] = {.lex_state = 95, .external_lex_state = 5},
  [3794] = {.lex_state = 11, .external_lex_state = 2},
  [3795] = {.lex_state = 11, .external_lex_state = 2},
  [3796] = {.lex_state = 11, .external_lex_state = 2},
  [3797] = {.lex_state = 95, .external_lex_state = 5},
  [3798] = {.lex_state = 11, .external_lex_state = 2},
  [3799] = {.lex_state = 11, .external_lex_state = 2},
  [3800] = {.lex_state = 95, .external_lex_state = 5},
  [3801] = {.lex_state = 11, .external_lex_state = 2},
  [3802] = {.lex_state = 11, .external_lex_state = 2},
  [3803] = {.lex_state = 11, .external_lex_state = 2},
  [3804] = {.lex_state = 95, .external_lex_state = 2},
  [3805] = {.lex_state = 16, .external_lex_state = 2},
  [3806] = {.lex_state = 6, .external_lex_state = 2},
  [3807] = {.lex_state = 13, .external_lex_state = 2},
  [3808] = {.lex_state = 95, .external_lex_state = 5},
  [3809] = {.lex_state = 95, .external_lex_state = 5},
  [3810] = {.lex_state = 95, .external_lex_state = 5},
  [3811] = {.lex_state = 95, .external_lex_state = 5},
  [3812] = {.lex_state = 11, .external_lex_state = 2},
  [3813] = {.lex_state = 11, .external_lex_state = 2},
  [3814] = {.lex_state = 95, .external_lex_state = 5},
  [3815] = {.lex_state = 11, .external_lex_state = 2},
  [3816] = {.lex_state = 95, .external_lex_state = 5},
  [3817] = {.lex_state = 13, .external_lex_state = 2},
  [3818] = {.lex_state = 11, .external_lex_state = 2},
  [3819] = {.lex_state = 13, .external_lex_state = 2},
  [3820] = {.lex_state = 95, .external_lex_state = 5},
  [3821] = {.lex_state = 95, .external_lex_state = 5},
  [3822] = {.lex_state = 11, .external_lex_state = 2},
  [3823] = {.lex_state = 95, .external_lex_state = 5},
  [3824] = {.lex_state = 95, .external_lex_state = 5},
  [3825] = {.lex_state = 95, .external_lex_state = 2},
  [3826] = {.lex_state = 13, .external_lex_state = 2},
  [3827] = {.lex_state = 6, .external_lex_state = 6},
  [3828] = {.lex_state = 6, .external_lex_state = 6},
  [3829] = {.lex_state = 95, .external_lex_state = 5},
  [3830] = {.lex_state = 95, .external_lex_state = 5},
  [3831] = {.lex_state = 11, .external_lex_state = 2},
  [3832] = {.lex_state = 6, .external_lex_state = 6},
  [3833] = {.lex_state = 11, .external_lex_state = 2},
  [3834] = {.lex_state = 95, .external_lex_state = 5},
  [3835] = {.lex_state = 6, .external_lex_state = 6},
  [3836] = {.lex_state = 95, .external_lex_state = 5},
  [3837] = {.lex_state = 95, .external_lex_state = 5},
  [3838] = {.lex_state = 95, .external_lex_state = 5},
  [3839] = {.lex_state = 95, .external_lex_state = 5},
  [3840] = {.lex_state = 95, .external_lex_state = 5},
  [3841] = {.lex_state = 95, .external_lex_state = 5},
  [3842] = {.lex_state = 6, .external_lex_state = 6},
  [3843] = {.lex_state = 6, .external_lex_state = 6},
  [3844] = {.lex_state = 95, .external_lex_state = 5},
  [3845] = {.lex_state = 95, .external_lex_state = 5},
  [3846] = {.lex_state = 95, .external_lex_state = 5},
  [3847] = {.lex_state = 95, .external_lex_state = 5},
  [3848] = {.lex_state = 95, .external_lex_state = 5},
  [3849] = {.lex_state = 95, .external_lex_state = 5},
  [3850] = {.lex_state = 95, .external_lex_state = 5},
  [3851] = {.lex_state = 95, .external_lex_state = 5},
  [3852] = {.lex_state = 95, .external_lex_state = 5},
  [3853] = {.lex_state = 11, .external_lex_state = 2},
  [3854] = {.lex_state = 11, .external_lex_state = 2},
  [3855] = {.lex_state = 20, .external_lex_state = 2},
  [3856] = {.lex_state = 11, .external_lex_state = 2},
  [3857] = {.lex_state = 95, .external_lex_state = 5},
  [3858] = {.lex_state = 11, .external_lex_state = 2},
  [3859] = {.lex_state = 6, .external_lex_state = 5},
  [3860] = {.lex_state = 6, .external_lex_state = 5},
  [3861] = {.lex_state = 95, .external_lex_state = 5},
  [3862] = {.lex_state = 95, .external_lex_state = 5},
  [3863] = {.lex_state = 95, .external_lex_state = 5},
  [3864] = {.lex_state = 11, .external_lex_state = 5},
  [3865] = {.lex_state = 11, .external_lex_state = 2},
  [3866] = {.lex_state = 95, .external_lex_state = 2},
  [3867] = {.lex_state = 95, .external_lex_state = 5},
  [3868] = {.lex_state = 6, .external_lex_state = 2},
  [3869] = {.lex_state = 16, .external_lex_state = 2},
  [3870] = {.lex_state = 11, .external_lex_state = 5},
  [3871] = {.lex_state = 95, .external_lex_state = 5},
  [3872] = {.lex_state = 95, .external_lex_state = 5},
  [3873] = {.lex_state = 95, .external_lex_state = 5},
  [3874] = {.lex_state = 11, .external_lex_state = 2},
  [3875] = {.lex_state = 11, .external_lex_state = 2},
  [3876] = {.lex_state = 13, .external_lex_state = 2},
  [3877] = {.lex_state = 95, .external_lex_state = 5},
  [3878] = {.lex_state = 95, .external_lex_state = 5},
  [3879] = {.lex_state = 95, .external_lex_state = 5},
  [3880] = {.lex_state = 95, .external_lex_state = 5},
  [3881] = {.lex_state = 11, .external_lex_state = 2},
  [3882] = {.lex_state = 11, .external_lex_state = 2},
  [3883] = {.lex_state = 11, .external_lex_state = 2},
  [3884] = {.lex_state = 11, .external_lex_state = 2},
  [3885] = {.lex_state = 95, .external_lex_state = 5},
  [3886] = {.lex_state = 95, .external_lex_state = 5},
  [3887] = {.lex_state = 95, .external_lex_state = 5},
  [3888] = {.lex_state = 95, .external_lex_state = 5},
  [3889] = {.lex_state = 95, .external_lex_state = 5},
  [3890] = {.lex_state = 95, .external_lex_state = 5},
  [3891] = {.lex_state = 95, .external_lex_state = 5},
  [3892] = {.lex_state = 95, .external_lex_state = 5},
  [3893] = {.lex_state = 95, .external_lex_state = 2},
  [3894] = {.lex_state = 95, .external_lex_state = 5},
  [3895] = {.lex_state = 95, .external_lex_state = 5},
  [3896] = {.lex_state = 11, .external_lex_state = 2},
  [3897] = {.lex_state = 11, .external_lex_state = 2},
  [3898] = {.lex_state = 13, .external_lex_state = 2},
  [3899] = {.lex_state = 95, .external_lex_state = 5},
  [3900] = {.lex_state = 95, .external_lex_state = 5},
  [3901] = {.lex_state = 95, .external_lex_state = 5},
  [3902] = {.lex_state = 95, .external_lex_state = 5},
  [3903] = {.lex_state = 11, .external_lex_state = 2},
  [3904] = {.lex_state = 11, .external_lex_state = 5},
  [3905] = {.lex_state = 13, .external_lex_state = 2},
  [3906] = {.lex_state = 95, .external_lex_state = 5},
  [3907] = {.lex_state = 95, .external_lex_state = 5},
  [3908] = {.lex_state = 13, .external_lex_state = 2},
  [3909] = {.lex_state = 95, .external_lex_state = 5},
  [3910] = {.lex_state = 95, .external_lex_state = 5},
  [3911] = {.lex_state = 95, .external_lex_state = 5},
  [3912] = {.lex_state = 95, .external_lex_state = 5},
  [3913] = {.lex_state = 95, .external_lex_state = 5},
  [3914] = {.lex_state = 11, .external_lex_state = 2},
  [3915] = {.lex_state = 11, .external_lex_state = 2},
  [3916] = {.lex_state = 11, .external_lex_state = 2},
  [3917] = {.lex_state = 95, .external_lex_state = 5},
  [3918] = {.lex_state = 16, .external_lex_state = 2},
  [3919] = {.lex_state = 6, .external_lex_state = 2},
  [3920] = {.lex_state = 13, .external_lex_state = 2},
  [3921] = {.lex_state = 13, .external_lex_state = 2},
  [3922] = {.lex_state = 11, .external_lex_state = 2},
  [3923] = {.lex_state = 11, .external_lex_state = 2},
  [3924] = {.lex_state = 95, .external_lex_state = 2},
  [3925] = {.lex_state = 95, .external_lex_state = 5},
  [3926] = {.lex_state = 95, .external_lex_state = 5},
  [3927] = {.lex_state = 6, .external_lex_state = 2},
  [3928] = {.lex_state = 95, .external_lex_state = 5},
  [3929] = {.lex_state = 95, .external_lex_state = 5},
  [3930] = {.lex_state = 95, .external_lex_state = 5},
  [3931] = {.lex_state = 95, .external_lex_state = 5},
  [3932] = {.lex_state = 11, .external_lex_state = 2},
  [3933] = {.lex_state = 95, .external_lex_state = 5},
  [3934] = {.lex_state = 13, .external_lex_state = 2},
  [3935] = {.lex_state = 6, .external_lex_state = 2},
  [3936] = {.lex_state = 11, .external_lex_state = 2},
  [3937] = {.lex_state = 11, .external_lex_state = 2},
  [3938] = {.lex_state = 95, .external_lex_state = 2},
  [3939] = {.lex_state = 13, .external_lex_state = 2},
  [3940] = {.lex_state = 11, .external_lex_state = 2},
  [3941] = {.lex_state = 95, .external_lex_state = 5},
  [3942] = {.lex_state = 95, .external_lex_state = 5},
  [3943] = {.lex_state = 11, .external_lex_state = 2},
  [3944] = {.lex_state = 13, .external_lex_state = 2},
  [3945] = {.lex_state = 11, .external_lex_state = 2},
  [3946] = {.lex_state = 13, .external_lex_state = 2},
  [3947] = {.lex_state = 13, .external_lex_state = 2},
  [3948] = {.lex_state = 11, .external_lex_state = 2},
  [3949] = {.lex_state = 11, .external_lex_state = 2},
  [3950] = {.lex_state = 95, .external_lex_state = 5},
  [3951] = {.lex_state = 11, .external_lex_state = 2},
  [3952] = {.lex_state = 95, .external_lex_state = 5},
  [3953] = {.lex_state = 95, .external_lex_state = 5},
  [3954] = {.lex_state = 95, .external_lex_state = 5},
  [3955] = {.lex_state = 13, .external_lex_state = 2},
  [3956] = {.lex_state = 95, .external_lex_state = 5},
  [3957] = {.lex_state = 95, .external_lex_state = 5},
  [3958] = {.lex_state = 95, .external_lex_state = 5},
  [3959] = {.lex_state = 95, .external_lex_state = 5},
  [3960] = {.lex_state = 11, .external_lex_state = 5},
  [3961] = {.lex_state = 95, .external_lex_state = 5},
  [3962] = {.lex_state = 95, .external_lex_state = 5},
  [3963] = {.lex_state = 13, .external_lex_state = 2},
  [3964] = {.lex_state = 13, .external_lex_state = 2},
  [3965] = {.lex_state = 95, .external_lex_state = 5},
  [3966] = {.lex_state = 95, .external_lex_state = 5},
  [3967] = {.lex_state = 6, .external_lex_state = 2},
  [3968] = {.lex_state = 11, .external_lex_state = 5},
  [3969] = {.lex_state = 13, .external_lex_state = 2},
  [3970] = {.lex_state = 13, .external_lex_state = 2},
  [3971] = {.lex_state = 95, .external_lex_state = 5},
  [3972] = {.lex_state = 95, .external_lex_state = 5},
  [3973] = {.lex_state = 95, .external_lex_state = 5},
  [3974] = {.lex_state = 95, .external_lex_state = 2},
  [3975] = {.lex_state = 95, .external_lex_state = 5},
  [3976] = {.lex_state = 95, .external_lex_state = 5},
  [3977] = {.lex_state = 11, .external_lex_state = 5},
  [3978] = {.lex_state = 11, .external_lex_state = 5},
  [3979] = {.lex_state = 11, .external_lex_state = 5},
  [3980] = {.lex_state = 11, .external_lex_state = 5},
  [3981] = {.lex_state = 11, .external_lex_state = 5},
  [3982] = {.lex_state = 11, .external_lex_state = 5},
  [3983] = {.lex_state = 11, .external_lex_state = 5},
  [3984] = {.lex_state = 11, .external_lex_state = 5},
  [3985] = {.lex_state = 95, .external_lex_state = 5},
  [3986] = {.lex_state = 11, .external_lex_state = 5},
  [3987] = {.lex_state = 11, .external_lex_state = 5},
  [3988] = {.lex_state = 11, .external_lex_state = 5},
  [3989] = {.lex_state = 11, .external_lex_state = 2},
  [3990] = {.lex_state = 95, .external_lex_state = 5},
  [3991] = {.lex_state = 11, .external_lex_state = 5},
  [3992] = {.lex_state = 95, .external_lex_state = 5},
  [3993] = {.lex_state = 95, .external_lex_state = 5},
  [3994] = {.lex_state = 11, .external_lex_state = 5},
  [3995] = {.lex_state = 11, .external_lex_state = 5},
  [3996] = {.lex_state = 11, .external_lex_state = 5},
  [3997] = {.lex_state = 11, .external_lex_state = 5},
  [3998] = {.lex_state = 95, .external_lex_state = 5},
  [3999] = {.lex_state = 95, .external_lex_state = 5},
  [4000] = {.lex_state = 11, .external_lex_state = 5},
  [4001] = {.lex_state = 95, .external_lex_state = 5},
  [4002] = {.lex_state = 11, .external_lex_state = 5},
  [4003] = {.lex_state = 11, .external_lex_state = 5},
  [4004] = {.lex_state = 11, .external_lex_state = 5},
  [4005] = {.lex_state = 95, .external_lex_state = 5},
  [4006] = {.lex_state = 11, .external_lex_state = 5},
  [4007] = {.lex_state = 95, .external_lex_state = 5},
  [4008] = {.lex_state = 95, .external_lex_state = 5},
  [4009] = {.lex_state = 95, .external_lex_state = 5},
  [4010] = {.lex_state = 95, .external_lex_state = 5},
  [4011] = {.lex_state = 11, .external_lex_state = 5},
  [4012] = {.lex_state = 95, .external_lex_state = 5},
  [4013] = {.lex_state = 95, .external_lex_state = 5},
  [4014] = {.lex_state = 11, .external_lex_state = 2},
  [4015] = {.lex_state = 95, .external_lex_state = 5},
  [4016] = {.lex_state = 95, .external_lex_state = 5},
  [4017] = {.lex_state = 15, .external_lex_state = 2},
  [4018] = {.lex_state = 6, .external_lex_state = 5},
  [4019] = {.lex_state = 6, .external_lex_state = 5},
  [4020] = {.lex_state = 15, .external_lex_state = 2},
  [4021] = {.lex_state = 95, .external_lex_state = 5},
  [4022] = {.lex_state = 11, .external_lex_state = 6},
  [4023] = {.lex_state = 11, .external_lex_state = 6},
  [4024] = {.lex_state = 13, .external_lex_state = 2},
  [4025] = {.lex_state = 6, .external_lex_state = 2},
  [4026] = {.lex_state = 6, .external_lex_state = 2},
  [4027] = {.lex_state = 6, .external_lex_state = 2},
  [4028] = {.lex_state = 11, .external_lex_state = 2},
  [4029] = {.lex_state = 14, .external_lex_state = 2},
  [4030] = {.lex_state = 95, .external_lex_state = 2},
  [4031] = {.lex_state = 11, .external_lex_state = 5},
  [4032] = {.lex_state = 11, .external_lex_state = 5},
  [4033] = {.lex_state = 11, .external_lex_state = 6},
  [4034] = {.lex_state = 11, .external_lex_state = 5},
  [4035] = {.lex_state = 11, .external_lex_state = 6},
  [4036] = {.lex_state = 95, .external_lex_state = 2},
  [4037] = {.lex_state = 13, .external_lex_state = 2},
  [4038] = {.lex_state = 13, .external_lex_state = 2},
  [4039] = {.lex_state = 95, .external_lex_state = 2},
  [4040] = {.lex_state = 95, .external_lex_state = 2},
  [4041] = {.lex_state = 13, .external_lex_state = 2},
  [4042] = {.lex_state = 13, .external_lex_state = 2},
  [4043] = {.lex_state = 13, .external_lex_state = 2},
  [4044] = {.lex_state = 11, .external_lex_state = 5},
  [4045] = {.lex_state = 18, .external_lex_state = 7},
  [4046] = {.lex_state = 11, .external_lex_state = 2},
  [4047] = {.lex_state = 6, .external_lex_state = 6},
  [4048] = {.lex_state = 95, .external_lex_state = 5},
  [4049] = {.lex_state = 95, .external_lex_state = 5},
  [4050] = {.lex_state = 95, .external_lex_state = 2},
  [4051] = {.lex_state = 13, .external_lex_state = 2},
  [4052] = {.lex_state = 95, .external_lex_state = 5},
  [4053] = {.lex_state = 95, .external_lex_state = 5},
  [4054] = {.lex_state = 14, .external_lex_state = 2},
  [4055] = {.lex_state = 11, .external_lex_state = 2},
  [4056] = {.lex_state = 11, .external_lex_state = 6},
  [4057] = {.lex_state = 18, .external_lex_state = 7},
  [4058] = {.lex_state = 11, .external_lex_state = 2},
  [4059] = {.lex_state = 95, .external_lex_state = 2},
  [4060] = {.lex_state = 95, .external_lex_state = 5},
  [4061] = {.lex_state = 95, .external_lex_state = 2},
  [4062] = {.lex_state = 95, .external_lex_state = 2},
  [4063] = {.lex_state = 11, .external_lex_state = 2},
  [4064] = {.lex_state = 14, .external_lex_state = 2},
  [4065] = {.lex_state = 14, .external_lex_state = 2},
  [4066] = {.lex_state = 95, .external_lex_state = 2},
  [4067] = {.lex_state = 95, .external_lex_state = 2},
  [4068] = {.lex_state = 13, .external_lex_state = 2},
  [4069] = {.lex_state = 11, .external_lex_state = 2},
  [4070] = {.lex_state = 13, .external_lex_state = 2},
  [4071] = {.lex_state = 13, .external_lex_state = 2},
  [4072] = {.lex_state = 95, .external_lex_state = 2},
  [4073] = {.lex_state = 11, .external_lex_state = 2},
  [4074] = {.lex_state = 13, .external_lex_state = 2},
  [4075] = {.lex_state = 95, .external_lex_state = 5},
  [4076] = {.lex_state = 11, .external_lex_state = 6},
  [4077] = {.lex_state = 95, .external_lex_state = 2},
  [4078] = {.lex_state = 11, .external_lex_state = 2},
  [4079] = {.lex_state = 18, .external_lex_state = 7},
  [4080] = {.lex_state = 13, .external_lex_state = 2},
  [4081] = {.lex_state = 6, .external_lex_state = 6},
  [4082] = {.lex_state = 6, .external_lex_state = 6},
  [4083] = {.lex_state = 13, .external_lex_state = 2},
  [4084] = {.lex_state = 11, .external_lex_state = 2},
  [4085] = {.lex_state = 95, .external_lex_state = 5},
  [4086] = {.lex_state = 15, .external_lex_state = 2},
  [4087] = {.lex_state = 95, .external_lex_state = 5},
  [4088] = {.lex_state = 95, .external_lex_state = 5},
  [4089] = {.lex_state = 95, .external_lex_state = 5},
  [4090] = {.lex_state = 95, .external_lex_state = 5},
  [4091] = {.lex_state = 13, .external_lex_state = 2},
  [4092] = {.lex_state = 13, .external_lex_state = 2},
  [4093] = {.lex_state = 95, .external_lex_state = 5},
  [4094] = {.lex_state = 13, .external_lex_state = 2},
  [4095] = {.lex_state = 95, .external_lex_state = 5},
  [4096] = {.lex_state = 95, .external_lex_state = 2},
  [4097] = {.lex_state = 11, .external_lex_state = 2},
  [4098] = {.lex_state = 13, .external_lex_state = 2},
  [4099] = {.lex_state = 11, .external_lex_state = 6},
  [4100] = {.lex_state = 95, .external_lex_state = 5},
  [4101] = {.lex_state = 95, .external_lex_state = 5},
  [4102] = {.lex_state = 95, .external_lex_state = 5},
  [4103] = {.lex_state = 13, .external_lex_state = 2},
  [4104] = {.lex_state = 95, .external_lex_state = 2},
  [4105] = {.lex_state = 13, .external_lex_state = 2},
  [4106] = {.lex_state = 95, .external_lex_state = 2},
  [4107] = {.lex_state = 11, .external_lex_state = 2},
  [4108] = {.lex_state = 14, .external_lex_state = 2},
  [4109] = {.lex_state = 95, .external_lex_state = 5},
  [4110] = {.lex_state = 95, .external_lex_state = 5},
  [4111] = {.lex_state = 95, .external_lex_state = 5},
  [4112] = {.lex_state = 11, .external_lex_state = 2},
  [4113] = {.lex_state = 11, .external_lex_state = 6},
  [4114] = {.lex_state = 6, .external_lex_state = 2},
  [4115] = {.lex_state = 11, .external_lex_state = 2},
  [4116] = {.lex_state = 11, .external_lex_state = 2},
  [4117] = {.lex_state = 13, .external_lex_state = 2},
  [4118] = {.lex_state = 16, .external_lex_state = 2},
  [4119] = {.lex_state = 95, .external_lex_state = 2},
  [4120] = {.lex_state = 11, .external_lex_state = 6},
  [4121] = {.lex_state = 11, .external_lex_state = 6},
  [4122] = {.lex_state = 13, .external_lex_state = 2},
  [4123] = {.lex_state = 11, .external_lex_state = 6},
  [4124] = {.lex_state = 13, .external_lex_state = 2},
  [4125] = {.lex_state = 95, .external_lex_state = 5},
  [4126] = {.lex_state = 13, .external_lex_state = 2},
  [4127] = {.lex_state = 95, .external_lex_state = 5},
  [4128] = {.lex_state = 13, .external_lex_state = 2},
  [4129] = {.lex_state = 11, .external_lex_state = 2},
  [4130] = {.lex_state = 13, .external_lex_state = 2},
  [4131] = {.lex_state = 13, .external_lex_state = 2},
  [4132] = {.lex_state = 13, .external_lex_state = 2},
  [4133] = {.lex_state = 13, .external_lex_state = 2},
  [4134] = {.lex_state = 95, .external_lex_state = 2},
  [4135] = {.lex_state = 11, .external_lex_state = 2},
  [4136] = {.lex_state = 11, .external_lex_state = 2},
  [4137] = {.lex_state = 11, .external_lex_state = 2},
  [4138] = {.lex_state = 11, .external_lex_state = 2},
  [4139] = {.lex_state = 11, .external_lex_state = 6},
  [4140] = {.lex_state = 11, .external_lex_state = 6},
  [4141] = {.lex_state = 13, .external_lex_state = 2},
  [4142] = {.lex_state = 13, .external_lex_state = 2},
  [4143] = {.lex_state = 95, .external_lex_state = 5},
  [4144] = {.lex_state = 13, .external_lex_state = 2},
  [4145] = {.lex_state = 11, .external_lex_state = 6},
  [4146] = {.lex_state = 11, .external_lex_state = 6},
  [4147] = {.lex_state = 13, .external_lex_state = 2},
  [4148] = {.lex_state = 11, .external_lex_state = 2},
  [4149] = {.lex_state = 11, .external_lex_state = 2},
  [4150] = {.lex_state = 11, .external_lex_state = 6},
  [4151] = {.lex_state = 95, .external_lex_state = 5},
  [4152] = {.lex_state = 95, .external_lex_state = 5},
  [4153] = {.lex_state = 13, .external_lex_state = 2},
  [4154] = {.lex_state = 95, .external_lex_state = 2},
  [4155] = {.lex_state = 13, .external_lex_state = 2},
  [4156] = {.lex_state = 13, .external_lex_state = 2},
  [4157] = {.lex_state = 13, .external_lex_state = 2},
  [4158] = {.lex_state = 11, .external_lex_state = 6},
  [4159] = {.lex_state = 13, .external_lex_state = 2},
  [4160] = {.lex_state = 20, .external_lex_state = 2},
  [4161] = {.lex_state = 11, .external_lex_state = 2},
  [4162] = {.lex_state = 11, .external_lex_state = 2},
  [4163] = {.lex_state = 11, .external_lex_state = 6},
  [4164] = {.lex_state = 11, .external_lex_state = 6},
  [4165] = {.lex_state = 11, .external_lex_state = 2},
  [4166] = {.lex_state = 11, .external_lex_state = 6},
  [4167] = {.lex_state = 13, .external_lex_state = 2},
  [4168] = {.lex_state = 11, .external_lex_state = 6},
  [4169] = {.lex_state = 95, .external_lex_state = 5},
  [4170] = {.lex_state = 11, .external_lex_state = 6},
  [4171] = {.lex_state = 13, .external_lex_state = 2},
  [4172] = {.lex_state = 95, .external_lex_state = 2},
  [4173] = {.lex_state = 13, .external_lex_state = 2},
  [4174] = {.lex_state = 13, .external_lex_state = 2},
  [4175] = {.lex_state = 95, .external_lex_state = 2},
  [4176] = {.lex_state = 95, .external_lex_state = 2},
  [4177] = {.lex_state = 95, .external_lex_state = 2},
  [4178] = {.lex_state = 18, .external_lex_state = 7},
  [4179] = {.lex_state = 11, .external_lex_state = 2},
  [4180] = {.lex_state = 14, .external_lex_state = 2},
  [4181] = {.lex_state = 13, .external_lex_state = 2},
  [4182] = {.lex_state = 13, .external_lex_state = 2},
  [4183] = {.lex_state = 18, .external_lex_state = 7},
  [4184] = {.lex_state = 13, .external_lex_state = 2},
  [4185] = {.lex_state = 13, .external_lex_state = 2},
  [4186] = {.lex_state = 13, .external_lex_state = 2},
  [4187] = {.lex_state = 11, .external_lex_state = 6},
  [4188] = {.lex_state = 11, .external_lex_state = 6},
  [4189] = {.lex_state = 13, .external_lex_state = 2},
  [4190] = {.lex_state = 11, .external_lex_state = 6},
  [4191] = {.lex_state = 11, .external_lex_state = 2},
  [4192] = {.lex_state = 11, .external_lex_state = 2},
  [4193] = {.lex_state = 11, .external_lex_state = 6},
  [4194] = {.lex_state = 11, .external_lex_state = 2},
  [4195] = {.lex_state = 11, .external_lex_state = 2},
  [4196] = {.lex_state = 95, .external_lex_state = 5},
  [4197] = {.lex_state = 95, .external_lex_state = 2},
  [4198] = {.lex_state = 95, .external_lex_state = 5},
  [4199] = {.lex_state = 95, .external_lex_state = 5},
  [4200] = {.lex_state = 95, .external_lex_state = 5},
  [4201] = {.lex_state = 95, .external_lex_state = 5},
  [4202] = {.lex_state = 6, .external_lex_state = 5},
  [4203] = {.lex_state = 18, .external_lex_state = 8},
  [4204] = {.lex_state = 95, .external_lex_state = 5},
  [4205] = {.lex_state = 95, .external_lex_state = 5},
  [4206] = {.lex_state = 6, .external_lex_state = 2},
  [4207] = {.lex_state = 95, .external_lex_state = 5},
  [4208] = {.lex_state = 95, .external_lex_state = 5},
  [4209] = {.lex_state = 95, .external_lex_state = 5},
  [4210] = {.lex_state = 95, .external_lex_state = 5},
  [4211] = {.lex_state = 95, .external_lex_state = 5},
  [4212] = {.lex_state = 6, .external_lex_state = 2},
  [4213] = {.lex_state = 95, .external_lex_state = 5},
  [4214] = {.lex_state = 95, .external_lex_state = 5},
  [4215] = {.lex_state = 95, .external_lex_state = 5},
  [4216] = {.lex_state = 95, .external_lex_state = 5},
  [4217] = {.lex_state = 18, .external_lex_state = 8},
  [4218] = {.lex_state = 95, .external_lex_state = 5},
  [4219] = {.lex_state = 95, .external_lex_state = 5},
  [4220] = {.lex_state = 13, .external_lex_state = 2},
  [4221] = {.lex_state = 13, .external_lex_state = 2},
  [4222] = {.lex_state = 95, .external_lex_state = 5},
  [4223] = {.lex_state = 95, .external_lex_state = 5},
  [4224] = {.lex_state = 95, .external_lex_state = 5},
  [4225] = {.lex_state = 13, .external_lex_state = 2},
  [4226] = {.lex_state = 95, .external_lex_state = 5},
  [4227] = {.lex_state = 95, .external_lex_state = 5},
  [4228] = {.lex_state = 95, .external_lex_state = 5},
  [4229] = {.lex_state = 95, .external_lex_state = 5},
  [4230] = {.lex_state = 95, .external_lex_state = 2},
  [4231] = {.lex_state = 95, .external_lex_state = 2},
  [4232] = {.lex_state = 95, .external_lex_state = 5},
  [4233] = {.lex_state = 95, .external_lex_state = 5},
  [4234] = {.lex_state = 95, .external_lex_state = 5},
  [4235] = {.lex_state = 13, .external_lex_state = 2},
  [4236] = {.lex_state = 95, .external_lex_state = 5},
  [4237] = {.lex_state = 95, .external_lex_state = 5},
  [4238] = {.lex_state = 95, .external_lex_state = 5},
  [4239] = {.lex_state = 15, .external_lex_state = 2},
  [4240] = {.lex_state = 95, .external_lex_state = 5},
  [4241] = {.lex_state = 11, .external_lex_state = 6},
  [4242] = {.lex_state = 95, .external_lex_state = 5},
  [4243] = {.lex_state = 95, .external_lex_state = 2},
  [4244] = {.lex_state = 95, .external_lex_state = 2},
  [4245] = {.lex_state = 95, .external_lex_state = 2},
  [4246] = {.lex_state = 95, .external_lex_state = 5},
  [4247] = {.lex_state = 95, .external_lex_state = 2},
  [4248] = {.lex_state = 95, .external_lex_state = 5},
  [4249] = {.lex_state = 95, .external_lex_state = 5},
  [4250] = {.lex_state = 95, .external_lex_state = 5},
  [4251] = {.lex_state = 95, .external_lex_state = 5},
  [4252] = {.lex_state = 6, .external_lex_state = 5},
  [4253] = {.lex_state = 95, .external_lex_state = 5},
  [4254] = {.lex_state = 95, .external_lex_state = 5},
  [4255] = {.lex_state = 6, .external_lex_state = 5},
  [4256] = {.lex_state = 95, .external_lex_state = 5},
  [4257] = {.lex_state = 95, .external_lex_state = 5},
  [4258] = {.lex_state = 95, .external_lex_state = 5},
  [4259] = {.lex_state = 95, .external_lex_state = 5},
  [4260] = {.lex_state = 13, .external_lex_state = 2},
  [4261] = {.lex_state = 95, .external_lex_state = 5},
  [4262] = {.lex_state = 13, .external_lex_state = 2},
  [4263] = {.lex_state = 95, .external_lex_state = 5},
  [4264] = {.lex_state = 11, .external_lex_state = 6},
  [4265] = {.lex_state = 95, .external_lex_state = 2},
  [4266] = {.lex_state = 13, .external_lex_state = 2},
  [4267] = {.lex_state = 95, .external_lex_state = 5},
  [4268] = {.lex_state = 95, .external_lex_state = 5},
  [4269] = {.lex_state = 95, .external_lex_state = 5},
  [4270] = {.lex_state = 95, .external_lex_state = 5},
  [4271] = {.lex_state = 95, .external_lex_state = 5},
  [4272] = {.lex_state = 95, .external_lex_state = 5},
  [4273] = {.lex_state = 95, .external_lex_state = 5},
  [4274] = {.lex_state = 13, .external_lex_state = 2},
  [4275] = {.lex_state = 95, .external_lex_state = 5},
  [4276] = {.lex_state = 11, .external_lex_state = 6},
  [4277] = {.lex_state = 95, .external_lex_state = 5},
  [4278] = {.lex_state = 95, .external_lex_state = 5},
  [4279] = {.lex_state = 11, .external_lex_state = 6},
  [4280] = {.lex_state = 11, .external_lex_state = 2},
  [4281] = {.lex_state = 95, .external_lex_state = 5},
  [4282] = {.lex_state = 95, .external_lex_state = 5},
  [4283] = {.lex_state = 95, .external_lex_state = 5},
  [4284] = {.lex_state = 13, .external_lex_state = 2},
  [4285] = {.lex_state = 95, .external_lex_state = 5},
  [4286] = {.lex_state = 95, .external_lex_state = 5},
  [4287] = {.lex_state = 95, .external_lex_state = 5},
  [4288] = {.lex_state = 95, .external_lex_state = 5},
  [4289] = {.lex_state = 95, .external_lex_state = 5},
  [4290] = {.lex_state = 95, .external_lex_state = 5},
  [4291] = {.lex_state = 95, .external_lex_state = 5},
  [4292] = {.lex_state = 95, .external_lex_state = 5},
  [4293] = {.lex_state = 18, .external_lex_state = 8},
  [4294] = {.lex_state = 11, .external_lex_state = 6},
  [4295] = {.lex_state = 95, .external_lex_state = 5},
  [4296] = {.lex_state = 95, .external_lex_state = 5},
  [4297] = {.lex_state = 95, .external_lex_state = 5},
  [4298] = {.lex_state = 18, .external_lex_state = 8},
  [4299] = {.lex_state = 95, .external_lex_state = 5},
  [4300] = {.lex_state = 95, .external_lex_state = 5},
  [4301] = {.lex_state = 95, .external_lex_state = 5},
  [4302] = {.lex_state = 95, .external_lex_state = 5},
  [4303] = {.lex_state = 95, .external_lex_state = 5},
  [4304] = {.lex_state = 95, .external_lex_state = 5},
  [4305] = {.lex_state = 95, .external_lex_state = 5},
  [4306] = {.lex_state = 95, .external_lex_state = 5},
  [4307] = {.lex_state = 13, .external_lex_state = 2},
  [4308] = {.lex_state = 95, .external_lex_state = 5},
  [4309] = {.lex_state = 18, .external_lex_state = 8},
  [4310] = {.lex_state = 95, .external_lex_state = 5},
  [4311] = {.lex_state = 13, .external_lex_state = 2},
  [4312] = {.lex_state = 6, .external_lex_state = 2},
  [4313] = {.lex_state = 95, .external_lex_state = 2},
  [4314] = {.lex_state = 95, .external_lex_state = 5},
  [4315] = {.lex_state = 95, .external_lex_state = 5},
  [4316] = {.lex_state = 95, .external_lex_state = 5},
  [4317] = {.lex_state = 95, .external_lex_state = 5},
  [4318] = {.lex_state = 13, .external_lex_state = 2},
  [4319] = {.lex_state = 95, .external_lex_state = 5},
  [4320] = {.lex_state = 95, .external_lex_state = 5},
  [4321] = {.lex_state = 13, .external_lex_state = 2},
  [4322] = {.lex_state = 11, .external_lex_state = 2},
  [4323] = {.lex_state = 95, .external_lex_state = 5},
  [4324] = {.lex_state = 95, .external_lex_state = 5},
  [4325] = {.lex_state = 95, .external_lex_state = 5},
  [4326] = {.lex_state = 11, .external_lex_state = 2},
  [4327] = {.lex_state = 13, .external_lex_state = 2},
  [4328] = {.lex_state = 13, .external_lex_state = 2},
  [4329] = {.lex_state = 13, .external_lex_state = 2},
  [4330] = {.lex_state = 95, .external_lex_state = 5},
  [4331] = {.lex_state = 95, .external_lex_state = 5},
  [4332] = {.lex_state = 95, .external_lex_state = 5},
  [4333] = {.lex_state = 95, .external_lex_state = 2},
  [4334] = {.lex_state = 18, .external_lex_state = 8},
  [4335] = {.lex_state = 95, .external_lex_state = 5},
  [4336] = {.lex_state = 95, .external_lex_state = 5},
  [4337] = {.lex_state = 13, .external_lex_state = 2},
  [4338] = {.lex_state = 95, .external_lex_state = 5},
  [4339] = {.lex_state = 11, .external_lex_state = 2},
  [4340] = {.lex_state = 95, .external_lex_state = 5},
  [4341] = {.lex_state = 95, .external_lex_state = 5},
  [4342] = {.lex_state = 95, .external_lex_state = 5},
  [4343] = {.lex_state = 13, .external_lex_state = 2},
  [4344] = {.lex_state = 95, .external_lex_state = 2},
  [4345] = {.lex_state = 95, .external_lex_state = 5},
  [4346] = {.lex_state = 95, .external_lex_state = 5},
  [4347] = {.lex_state = 95, .external_lex_state = 5},
  [4348] = {.lex_state = 13, .external_lex_state = 2},
  [4349] = {.lex_state = 95, .external_lex_state = 5},
  [4350] = {.lex_state = 13, .external_lex_state = 2},
  [4351] = {.lex_state = 95, .external_lex_state = 5},
  [4352] = {.lex_state = 13, .external_lex_state = 2},
  [4353] = {.lex_state = 11, .external_lex_state = 5},
  [4354] = {.lex_state = 95, .external_lex_state = 2},
  [4355] = {.lex_state = 13, .external_lex_state = 2},
  [4356] = {.lex_state = 95, .external_lex_state = 5},
  [4357] = {.lex_state = 95, .external_lex_state = 5},
  [4358] = {.lex_state = 95, .external_lex_state = 5},
  [4359] = {.lex_state = 6, .external_lex_state = 2},
  [4360] = {.lex_state = 95, .external_lex_state = 2},
  [4361] = {.lex_state = 95, .external_lex_state = 5},
  [4362] = {.lex_state = 95, .external_lex_state = 5},
  [4363] = {.lex_state = 95, .external_lex_state = 2},
  [4364] = {.lex_state = 95, .external_lex_state = 5},
  [4365] = {.lex_state = 95, .external_lex_state = 5},
  [4366] = {.lex_state = 11, .external_lex_state = 5},
  [4367] = {.lex_state = 95, .external_lex_state = 5},
  [4368] = {.lex_state = 11, .external_lex_state = 6},
  [4369] = {.lex_state = 95, .external_lex_state = 5},
  [4370] = {.lex_state = 95, .external_lex_state = 5},
  [4371] = {.lex_state = 95, .external_lex_state = 2},
  [4372] = {.lex_state = 13, .external_lex_state = 2},
  [4373] = {.lex_state = 13, .external_lex_state = 2},
  [4374] = {.lex_state = 95, .external_lex_state = 5},
  [4375] = {.lex_state = 95, .external_lex_state = 5},
  [4376] = {.lex_state = 95, .external_lex_state = 5},
  [4377] = {.lex_state = 95, .external_lex_state = 2},
  [4378] = {.lex_state = 95, .external_lex_state = 5},
  [4379] = {.lex_state = 95, .external_lex_state = 5},
  [4380] = {.lex_state = 95, .external_lex_state = 5},
  [4381] = {.lex_state = 11, .external_lex_state = 6},
  [4382] = {.lex_state = 11, .external_lex_state = 5},
  [4383] = {.lex_state = 95, .external_lex_state = 5},
  [4384] = {.lex_state = 95, .external_lex_state = 5},
  [4385] = {.lex_state = 13, .external_lex_state = 2},
  [4386] = {.lex_state = 11, .external_lex_state = 6},
  [4387] = {.lex_state = 95, .external_lex_state = 5},
  [4388] = {.lex_state = 95, .external_lex_state = 5},
  [4389] = {.lex_state = 95, .external_lex_state = 5},
  [4390] = {.lex_state = 13, .external_lex_state = 2},
  [4391] = {.lex_state = 95, .external_lex_state = 5},
  [4392] = {.lex_state = 95, .external_lex_state = 5},
  [4393] = {.lex_state = 13, .external_lex_state = 2},
  [4394] = {.lex_state = 95, .external_lex_state = 5},
  [4395] = {.lex_state = 11, .external_lex_state = 6},
  [4396] = {.lex_state = 13, .external_lex_state = 2},
  [4397] = {.lex_state = 95, .external_lex_state = 2},
  [4398] = {.lex_state = 95, .external_lex_state = 5},
  [4399] = {.lex_state = 95, .external_lex_state = 5},
  [4400] = {.lex_state = 95, .external_lex_state = 5},
  [4401] = {.lex_state = 95, .external_lex_state = 5},
  [4402] = {.lex_state = 95, .external_lex_state = 5},
  [4403] = {.lex_state = 95, .external_lex_state = 5},
  [4404] = {.lex_state = 95, .external_lex_state = 2},
  [4405] = {.lex_state = 95, .external_lex_state = 5},
  [4406] = {.lex_state = 11, .external_lex_state = 6},
  [4407] = {.lex_state = 95, .external_lex_state = 5},
  [4408] = {.lex_state = 95, .external_lex_state = 5},
  [4409] = {.lex_state = 95, .external_lex_state = 5},
  [4410] = {.lex_state = 95, .external_lex_state = 5},
  [4411] = {.lex_state = 11, .external_lex_state = 2},
  [4412] = {.lex_state = 11, .external_lex_state = 6},
  [4413] = {.lex_state = 11, .external_lex_state = 2},
  [4414] = {.lex_state = 11, .external_lex_state = 6},
  [4415] = {.lex_state = 95, .external_lex_state = 5},
  [4416] = {.lex_state = 11, .external_lex_state = 2},
  [4417] = {.lex_state = 95, .external_lex_state = 5},
  [4418] = {.lex_state = 11, .external_lex_state = 2},
  [4419] = {.lex_state = 95, .external_lex_state = 5},
  [4420] = {.lex_state = 95, .external_lex_state = 5},
  [4421] = {.lex_state = 11, .external_lex_state = 6},
  [4422] = {.lex_state = 95, .external_lex_state = 5},
  [4423] = {.lex_state = 95, .external_lex_state = 5},
  [4424] = {.lex_state = 95, .external_lex_state = 5},
  [4425] = {.lex_state = 18, .external_lex_state = 8},
  [4426] = {.lex_state = 95, .external_lex_state = 5},
  [4427] = {.lex_state = 13, .external_lex_state = 2},
  [4428] = {.lex_state = 95, .external_lex_state = 5},
  [4429] = {.lex_state = 95, .external_lex_state = 5},
  [4430] = {.lex_state = 95, .external_lex_state = 5},
  [4431] = {.lex_state = 95, .external_lex_state = 5},
  [4432] = {.lex_state = 95, .external_lex_state = 5},
  [4433] = {.lex_state = 95, .external_lex_state = 5},
  [4434] = {.lex_state = 95, .external_lex_state = 5},
  [4435] = {.lex_state = 95, .external_lex_state = 5},
  [4436] = {.lex_state = 95, .external_lex_state = 5},
  [4437] = {.lex_state = 95, .external_lex_state = 5},
  [4438] = {.lex_state = 95, .external_lex_state = 5},
  [4439] = {.lex_state = 95, .external_lex_state = 5},
  [4440] = {.lex_state = 95, .external_lex_state = 5},
  [4441] = {.lex_state = 95, .external_lex_state = 5},
  [4442] = {.lex_state = 95, .external_lex_state = 2},
  [4443] = {.lex_state = 95, .external_lex_state = 5},
  [4444] = {.lex_state = 95, .external_lex_state = 2},
  [4445] = {.lex_state = 13, .external_lex_state = 2},
  [4446] = {.lex_state = 13, .external_lex_state = 2},
  [4447] = {.lex_state = 95, .external_lex_state = 5},
  [4448] = {.lex_state = 95, .external_lex_state = 5},
  [4449] = {.lex_state = 95, .external_lex_state = 5},
  [4450] = {.lex_state = 95, .external_lex_state = 5},
  [4451] = {.lex_state = 95, .external_lex_state = 2},
  [4452] = {.lex_state = 95, .external_lex_state = 5},
  [4453] = {.lex_state = 18, .external_lex_state = 8},
  [4454] = {.lex_state = 95, .external_lex_state = 5},
  [4455] = {.lex_state = 95, .external_lex_state = 5},
  [4456] = {.lex_state = 13, .external_lex_state = 2},
  [4457] = {.lex_state = 95, .external_lex_state = 5},
  [4458] = {.lex_state = 95, .external_lex_state = 5},
  [4459] = {.lex_state = 11, .external_lex_state = 2},
  [4460] = {.lex_state = 95, .external_lex_state = 5},
  [4461] = {.lex_state = 18, .external_lex_state = 8},
  [4462] = {.lex_state = 13, .external_lex_state = 2},
  [4463] = {.lex_state = 95, .external_lex_state = 5},
  [4464] = {.lex_state = 11, .external_lex_state = 2},
  [4465] = {.lex_state = 95, .external_lex_state = 5},
  [4466] = {.lex_state = 18, .external_lex_state = 8},
  [4467] = {.lex_state = 95, .external_lex_state = 5},
  [4468] = {.lex_state = 95, .external_lex_state = 5},
  [4469] = {.lex_state = 11, .external_lex_state = 2},
  [4470] = {.lex_state = 13, .external_lex_state = 2},
  [4471] = {.lex_state = 95, .external_lex_state = 5},
  [4472] = {.lex_state = 95, .external_lex_state = 5},
  [4473] = {.lex_state = 95, .external_lex_state = 5},
  [4474] = {.lex_state = 14, .external_lex_state = 2},
  [4475] = {.lex_state = 11, .external_lex_state = 2},
  [4476] = {.lex_state = 95, .external_lex_state = 5},
  [4477] = {.lex_state = 95, .external_lex_state = 5},
  [4478] = {.lex_state = 95, .external_lex_state = 5},
  [4479] = {.lex_state = 95, .external_lex_state = 5},
  [4480] = {.lex_state = 95, .external_lex_state = 5},
  [4481] = {.lex_state = 95, .external_lex_state = 5},
  [4482] = {.lex_state = 13, .external_lex_state = 2},
  [4483] = {.lex_state = 95, .external_lex_state = 5},
  [4484] = {.lex_state = 13, .external_lex_state = 2},
  [4485] = {.lex_state = 95, .external_lex_state = 5},
  [4486] = {.lex_state = 13, .external_lex_state = 2},
  [4487] = {.lex_state = 95, .external_lex_state = 5},
  [4488] = {.lex_state = 13, .external_lex_state = 2},
  [4489] = {.lex_state = 95, .external_lex_state = 5},
  [4490] = {.lex_state = 13, .external_lex_state = 2},
  [4491] = {.lex_state = 95, .external_lex_state = 2},
  [4492] = {.lex_state = 95, .external_lex_state = 5},
  [4493] = {.lex_state = 95, .external_lex_state = 5},
  [4494] = {.lex_state = 95, .external_lex_state = 5},
  [4495] = {.lex_state = 95, .external_lex_state = 5},
  [4496] = {.lex_state = 13, .external_lex_state = 2},
  [4497] = {.lex_state = 95, .external_lex_state = 5},
  [4498] = {.lex_state = 95, .external_lex_state = 2},
  [4499] = {.lex_state = 13, .external_lex_state = 2},
  [4500] = {.lex_state = 11, .external_lex_state = 6},
  [4501] = {.lex_state = 11, .external_lex_state = 5},
  [4502] = {.lex_state = 95, .external_lex_state = 5},
  [4503] = {.lex_state = 95, .external_lex_state = 5},
  [4504] = {.lex_state = 95, .external_lex_state = 5},
  [4505] = {.lex_state = 95, .external_lex_state = 5},
  [4506] = {.lex_state = 11, .external_lex_state = 2},
  [4507] = {.lex_state = 13, .external_lex_state = 2},
  [4508] = {.lex_state = 13, .external_lex_state = 2},
  [4509] = {.lex_state = 95, .external_lex_state = 5},
  [4510] = {.lex_state = 11, .external_lex_state = 6},
  [4511] = {.lex_state = 95, .external_lex_state = 5},
  [4512] = {.lex_state = 95, .external_lex_state = 5},
  [4513] = {.lex_state = 95, .external_lex_state = 5},
  [4514] = {.lex_state = 95, .external_lex_state = 5},
  [4515] = {.lex_state = 95, .external_lex_state = 2},
  [4516] = {.lex_state = 13, .external_lex_state = 2},
  [4517] = {.lex_state = 95, .external_lex_state = 5},
  [4518] = {.lex_state = 95, .external_lex_state = 5},
  [4519] = {.lex_state = 11, .external_lex_state = 2},
  [4520] = {.lex_state = 13, .external_lex_state = 2},
  [4521] = {.lex_state = 11, .external_lex_state = 2},
  [4522] = {.lex_state = 95, .external_lex_state = 5},
  [4523] = {.lex_state = 95, .external_lex_state = 5},
  [4524] = {.lex_state = 11, .external_lex_state = 2},
  [4525] = {.lex_state = 95, .external_lex_state = 5},
  [4526] = {.lex_state = 13, .external_lex_state = 2},
  [4527] = {.lex_state = 11, .external_lex_state = 2},
  [4528] = {.lex_state = 13, .external_lex_state = 2},
  [4529] = {.lex_state = 95, .external_lex_state = 5},
  [4530] = {.lex_state = 13, .external_lex_state = 2},
  [4531] = {.lex_state = 13, .external_lex_state = 2},
  [4532] = {.lex_state = 95, .external_lex_state = 5},
  [4533] = {.lex_state = 95, .external_lex_state = 2},
  [4534] = {.lex_state = 95, .external_lex_state = 5},
  [4535] = {.lex_state = 95, .external_lex_state = 5},
  [4536] = {.lex_state = 95, .external_lex_state = 5},
  [4537] = {.lex_state = 95, .external_lex_state = 5},
  [4538] = {.lex_state = 95, .external_lex_state = 5},
  [4539] = {.lex_state = 95, .external_lex_state = 5},
  [4540] = {.lex_state = 95, .external_lex_state = 5},
  [4541] = {.lex_state = 95, .external_lex_state = 5},
  [4542] = {.lex_state = 95, .external_lex_state = 5},
  [4543] = {.lex_state = 95, .external_lex_state = 5},
  [4544] = {.lex_state = 95, .external_lex_state = 5},
  [4545] = {.lex_state = 11, .external_lex_state = 2},
  [4546] = {.lex_state = 13, .external_lex_state = 2},
  [4547] = {.lex_state = 95, .external_lex_state = 5},
  [4548] = {.lex_state = 95, .external_lex_state = 5},
  [4549] = {.lex_state = 95, .external_lex_state = 5},
  [4550] = {.lex_state = 95, .external_lex_state = 5},
  [4551] = {.lex_state = 95, .external_lex_state = 5},
  [4552] = {.lex_state = 95, .external_lex_state = 5},
  [4553] = {.lex_state = 95, .external_lex_state = 5},
  [4554] = {.lex_state = 95, .external_lex_state = 5},
  [4555] = {.lex_state = 95, .external_lex_state = 5},
  [4556] = {.lex_state = 95, .external_lex_state = 5},
  [4557] = {.lex_state = 95, .external_lex_state = 5},
  [4558] = {.lex_state = 13, .external_lex_state = 2},
  [4559] = {.lex_state = 95, .external_lex_state = 5},
  [4560] = {.lex_state = 95, .external_lex_state = 2},
  [4561] = {.lex_state = 95, .external_lex_state = 5},
  [4562] = {.lex_state = 95, .external_lex_state = 5},
  [4563] = {.lex_state = 95, .external_lex_state = 2},
  [4564] = {.lex_state = 11, .external_lex_state = 2},
  [4565] = {.lex_state = 18, .external_lex_state = 8},
  [4566] = {.lex_state = 95, .external_lex_state = 5},
  [4567] = {.lex_state = 13, .external_lex_state = 2},
  [4568] = {.lex_state = 95, .external_lex_state = 5},
  [4569] = {.lex_state = 13, .external_lex_state = 2},
  [4570] = {.lex_state = 95, .external_lex_state = 5},
  [4571] = {.lex_state = 13, .external_lex_state = 2},
  [4572] = {.lex_state = 11, .external_lex_state = 6},
  [4573] = {.lex_state = 95, .external_lex_state = 5},
  [4574] = {.lex_state = 13, .external_lex_state = 2},
  [4575] = {.lex_state = 95, .external_lex_state = 5},
  [4576] = {.lex_state = 95, .external_lex_state = 5},
  [4577] = {.lex_state = 11, .external_lex_state = 5},
  [4578] = {.lex_state = 11, .external_lex_state = 5},
  [4579] = {.lex_state = 13, .external_lex_state = 2},
  [4580] = {.lex_state = 95, .external_lex_state = 5},
  [4581] = {.lex_state = 95, .external_lex_state = 5},
  [4582] = {.lex_state = 13, .external_lex_state = 2},
  [4583] = {.lex_state = 13, .external_lex_state = 2},
  [4584] = {.lex_state = 95, .external_lex_state = 5},
  [4585] = {.lex_state = 13, .external_lex_state = 2},
  [4586] = {.lex_state = 16, .external_lex_state = 2},
  [4587] = {.lex_state = 95, .external_lex_state = 5},
  [4588] = {.lex_state = 95, .external_lex_state = 5},
  [4589] = {.lex_state = 13, .external_lex_state = 2},
  [4590] = {.lex_state = 11, .external_lex_state = 5},
  [4591] = {.lex_state = 13, .external_lex_state = 2},
  [4592] = {.lex_state = 13, .external_lex_state = 2},
  [4593] = {.lex_state = 95, .external_lex_state = 5},
  [4594] = {.lex_state = 13, .external_lex_state = 2},
  [4595] = {.lex_state = 13, .external_lex_state = 2},
  [4596] = {.lex_state = 11, .external_lex_state = 5},
  [4597] = {.lex_state = 11, .external_lex_state = 6},
  [4598] = {.lex_state = 95, .external_lex_state = 5},
  [4599] = {.lex_state = 95, .external_lex_state = 5},
  [4600] = {.lex_state = 11, .external_lex_state = 2},
  [4601] = {.lex_state = 95, .external_lex_state = 5},
  [4602] = {.lex_state = 95, .external_lex_state = 5},
  [4603] = {.lex_state = 13, .external_lex_state = 2},
  [4604] = {.lex_state = 11, .external_lex_state = 2},
  [4605] = {.lex_state = 95, .external_lex_state = 5},
  [4606] = {.lex_state = 95, .external_lex_state = 5},
  [4607] = {.lex_state = 95, .external_lex_state = 5},
  [4608] = {.lex_state = 95, .external_lex_state = 5},
  [4609] = {.lex_state = 95, .external_lex_state = 5},
  [4610] = {.lex_state = 95, .external_lex_state = 5},
  [4611] = {.lex_state = 95, .external_lex_state = 2},
  [4612] = {.lex_state = 95, .external_lex_state = 5},
  [4613] = {.lex_state = 95, .external_lex_state = 5},
  [4614] = {.lex_state = 13, .external_lex_state = 2},
  [4615] = {.lex_state = 95, .external_lex_state = 5},
  [4616] = {.lex_state = 95, .external_lex_state = 5},
  [4617] = {.lex_state = 95, .external_lex_state = 5},
  [4618] = {.lex_state = 95, .external_lex_state = 5},
  [4619] = {.lex_state = 95, .external_lex_state = 5},
  [4620] = {.lex_state = 13, .external_lex_state = 2},
  [4621] = {.lex_state = 95, .external_lex_state = 5},
  [4622] = {.lex_state = 95, .external_lex_state = 5},
  [4623] = {.lex_state = 13, .external_lex_state = 2},
  [4624] = {.lex_state = 95, .external_lex_state = 5},
  [4625] = {.lex_state = 95, .external_lex_state = 2},
  [4626] = {.lex_state = 13, .external_lex_state = 2},
  [4627] = {.lex_state = 95, .external_lex_state = 5},
  [4628] = {.lex_state = 95, .external_lex_state = 5},
  [4629] = {.lex_state = 13, .external_lex_state = 2},
  [4630] = {.lex_state = 95, .external_lex_state = 2},
  [4631] = {.lex_state = 95, .external_lex_state = 5},
  [4632] = {.lex_state = 13, .external_lex_state = 2},
  [4633] = {.lex_state = 95, .external_lex_state = 5},
  [4634] = {.lex_state = 95, .external_lex_state = 2},
  [4635] = {.lex_state = 13, .external_lex_state = 2},
  [4636] = {.lex_state = 95, .external_lex_state = 5},
  [4637] = {.lex_state = 95, .external_lex_state = 5},
  [4638] = {.lex_state = 95, .external_lex_state = 5},
  [4639] = {.lex_state = 11, .external_lex_state = 6},
  [4640] = {.lex_state = 11, .external_lex_state = 6},
  [4641] = {.lex_state = 95, .external_lex_state = 5},
  [4642] = {.lex_state = 95, .external_lex_state = 5},
  [4643] = {.lex_state = 95, .external_lex_state = 2},
  [4644] = {.lex_state = 95, .external_lex_state = 5},
  [4645] = {.lex_state = 95, .external_lex_state = 5},
  [4646] = {.lex_state = 95, .external_lex_state = 5},
  [4647] = {.lex_state = 11, .external_lex_state = 5},
  [4648] = {.lex_state = 95, .external_lex_state = 5},
  [4649] = {.lex_state = 95, .external_lex_state = 5},
  [4650] = {.lex_state = 95, .external_lex_state = 5},
  [4651] = {.lex_state = 11, .external_lex_state = 6},
  [4652] = {.lex_state = 95, .external_lex_state = 5},
  [4653] = {.lex_state = 95, .external_lex_state = 5},
  [4654] = {.lex_state = 95, .external_lex_state = 5},
  [4655] = {.lex_state = 95, .external_lex_state = 5},
  [4656] = {.lex_state = 95, .external_lex_state = 5},
  [4657] = {.lex_state = 13, .external_lex_state = 2},
  [4658] = {.lex_state = 95, .external_lex_state = 5},
  [4659] = {.lex_state = 95, .external_lex_state = 5},
  [4660] = {.lex_state = 95, .external_lex_state = 5},
  [4661] = {.lex_state = 95, .external_lex_state = 5},
  [4662] = {.lex_state = 95, .external_lex_state = 5},
  [4663] = {.lex_state = 95, .external_lex_state = 2},
  [4664] = {.lex_state = 95, .external_lex_state = 5},
  [4665] = {.lex_state = 13, .external_lex_state = 2},
  [4666] = {.lex_state = 95, .external_lex_state = 5},
  [4667] = {.lex_state = 95, .external_lex_state = 5},
  [4668] = {.lex_state = 95, .external_lex_state = 5},
  [4669] = {.lex_state = 95, .external_lex_state = 5},
  [4670] = {.lex_state = 95, .external_lex_state = 5},
  [4671] = {.lex_state = 95, .external_lex_state = 5},
  [4672] = {.lex_state = 95, .external_lex_state = 5},
  [4673] = {.lex_state = 95, .external_lex_state = 5},
  [4674] = {.lex_state = 95, .external_lex_state = 5},
  [4675] = {.lex_state = 13, .external_lex_state = 2},
  [4676] = {.lex_state = 95, .external_lex_state = 5},
  [4677] = {.lex_state = 95, .external_lex_state = 5},
  [4678] = {.lex_state = 95, .external_lex_state = 5},
  [4679] = {.lex_state = 95, .external_lex_state = 5},
  [4680] = {.lex_state = 95, .external_lex_state = 2},
  [4681] = {.lex_state = 95, .external_lex_state = 2},
  [4682] = {.lex_state = 11, .external_lex_state = 2},
  [4683] = {.lex_state = 17, .external_lex_state = 9},
  [4684] = {.lex_state = 21, .external_lex_state = 9},
  [4685] = {.lex_state = 11, .external_lex_state = 2},
  [4686] = {.lex_state = 11, .external_lex_state = 2},
  [4687] = {.lex_state = 13, .external_lex_state = 2},
  [4688] = {.lex_state = 95, .external_lex_state = 2},
  [4689] = {.lex_state = 95, .external_lex_state = 2},
  [4690] = {.lex_state = 14, .external_lex_state = 2},
  [4691] = {.lex_state = 6, .external_lex_state = 2},
  [4692] = {.lex_state = 6, .external_lex_state = 5},
  [4693] = {.lex_state = 17, .external_lex_state = 9},
  [4694] = {.lex_state = 21, .external_lex_state = 9},
  [4695] = {.lex_state = 11, .external_lex_state = 2},
  [4696] = {.lex_state = 6, .external_lex_state = 2},
  [4697] = {.lex_state = 11, .external_lex_state = 2},
  [4698] = {.lex_state = 95, .external_lex_state = 2},
  [4699] = {.lex_state = 95, .external_lex_state = 5},
  [4700] = {.lex_state = 11, .external_lex_state = 2},
  [4701] = {.lex_state = 11, .external_lex_state = 2},
  [4702] = {.lex_state = 95, .external_lex_state = 5},
  [4703] = {.lex_state = 11, .external_lex_state = 2},
  [4704] = {.lex_state = 17, .external_lex_state = 9},
  [4705] = {.lex_state = 21, .external_lex_state = 9},
  [4706] = {.lex_state = 17, .external_lex_state = 9},
  [4707] = {.lex_state = 21, .external_lex_state = 9},
  [4708] = {.lex_state = 17, .external_lex_state = 9},
  [4709] = {.lex_state = 21, .external_lex_state = 9},
  [4710] = {.lex_state = 95, .external_lex_state = 5},
  [4711] = {.lex_state = 1, .external_lex_state = 2},
  [4712] = {.lex_state = 1, .external_lex_state = 2},
  [4713] = {.lex_state = 95, .external_lex_state = 2},
  [4714] = {.lex_state = 95, .external_lex_state = 2},
  [4715] = {.lex_state = 11, .external_lex_state = 2},
  [4716] = {.lex_state = 95, .external_lex_state = 5},
  [4717] = {.lex_state = 95, .external_lex_state = 5},
  [4718] = {.lex_state = 11, .external_lex_state = 2},
  [4719] = {.lex_state = 11, .external_lex_state = 2},
  [4720] = {.lex_state = 95, .external_lex_state = 5},
  [4721] = {.lex_state = 95, .external_lex_state = 2},
  [4722] = {.lex_state = 11, .external_lex_state = 2},
  [4723] = {.lex_state = 13, .external_lex_state = 2},
  [4724] = {.lex_state = 14, .external_lex_state = 2},
  [4725] = {.lex_state = 18, .external_lex_state = 7},
  [4726] = {.lex_state = 95, .external_lex_state = 2},
  [4727] = {.lex_state = 95, .external_lex_state = 5},
  [4728] = {.lex_state = 13, .external_lex_state = 2},
  [4729] = {.lex_state = 11, .external_lex_state = 2},
  [4730] = {.lex_state = 1, .external_lex_state = 2},
  [4731] = {.lex_state = 13, .external_lex_state = 2},
  [4732] = {.lex_state = 95, .external_lex_state = 2},
  [4733] = {.lex_state = 17, .external_lex_state = 9},
  [4734] = {.lex_state = 21, .external_lex_state = 9},
  [4735] = {.lex_state = 14, .external_lex_state = 2},
  [4736] = {.lex_state = 95, .external_lex_state = 5},
  [4737] = {.lex_state = 17, .external_lex_state = 9},
  [4738] = {.lex_state = 21, .external_lex_state = 9},
  [4739] = {.lex_state = 95, .external_lex_state = 5},
  [4740] = {.lex_state = 95, .external_lex_state = 5},
  [4741] = {.lex_state = 95, .external_lex_state = 2},
  [4742] = {.lex_state = 95, .external_lex_state = 5},
  [4743] = {.lex_state = 95, .external_lex_state = 5},
  [4744] = {.lex_state = 95, .external_lex_state = 5},
  [4745] = {.lex_state = 95, .external_lex_state = 5},
  [4746] = {.lex_state = 13, .external_lex_state = 2},
  [4747] = {.lex_state = 95, .external_lex_state = 5},
  [4748] = {.lex_state = 95, .external_lex_state = 5},
  [4749] = {.lex_state = 95, .external_lex_state = 5},
  [4750] = {.lex_state = 95, .external_lex_state = 5},
  [4751] = {.lex_state = 11, .external_lex_state = 2},
  [4752] = {.lex_state = 14, .external_lex_state = 2},
  [4753] = {.lex_state = 13, .external_lex_state = 2},
  [4754] = {.lex_state = 13, .external_lex_state = 2},
  [4755] = {.lex_state = 11, .external_lex_state = 2},
  [4756] = {.lex_state = 21, .external_lex_state = 9},
  [4757] = {.lex_state = 17, .external_lex_state = 9},
  [4758] = {.lex_state = 21, .external_lex_state = 9},
  [4759] = {.lex_state = 17, .external_lex_state = 9},
  [4760] = {.lex_state = 13, .external_lex_state = 2},
  [4761] = {.lex_state = 95, .external_lex_state = 2},
  [4762] = {.lex_state = 95, .external_lex_state = 2},
  [4763] = {.lex_state = 95, .external_lex_state = 6},
  [4764] = {.lex_state = 11, .external_lex_state = 2},
  [4765] = {.lex_state = 11, .external_lex_state = 2},
  [4766] = {.lex_state = 95, .external_lex_state = 2},
  [4767] = {.lex_state = 13, .external_lex_state = 2},
  [4768] = {.lex_state = 11, .external_lex_state = 2},
  [4769] = {.lex_state = 11, .external_lex_state = 2},
  [4770] = {.lex_state = 17, .external_lex_state = 9},
  [4771] = {.lex_state = 11, .external_lex_state = 2},
  [4772] = {.lex_state = 21, .external_lex_state = 9},
  [4773] = {.lex_state = 11, .external_lex_state = 2},
  [4774] = {.lex_state = 13, .external_lex_state = 2},
  [4775] = {.lex_state = 95, .external_lex_state = 2},
  [4776] = {.lex_state = 95, .external_lex_state = 2},
  [4777] = {.lex_state = 11, .external_lex_state = 2},
  [4778] = {.lex_state = 95, .external_lex_state = 2},
  [4779] = {.lex_state = 17, .external_lex_state = 9},
  [4780] = {.lex_state = 11, .external_lex_state = 2},
  [4781] = {.lex_state = 21, .external_lex_state = 9},
  [4782] = {.lex_state = 11, .external_lex_state = 2},
  [4783] = {.lex_state = 95, .external_lex_state = 5},
  [4784] = {.lex_state = 95, .external_lex_state = 5},
  [4785] = {.lex_state = 13, .external_lex_state = 2},
  [4786] = {.lex_state = 95, .external_lex_state = 2},
  [4787] = {.lex_state = 95, .external_lex_state = 2},
  [4788] = {.lex_state = 95, .external_lex_state = 2},
  [4789] = {.lex_state = 95, .external_lex_state = 2},
  [4790] = {.lex_state = 13, .external_lex_state = 2},
  [4791] = {.lex_state = 95, .external_lex_state = 2},
  [4792] = {.lex_state = 11, .external_lex_state = 2},
  [4793] = {.lex_state = 11, .external_lex_state = 2},
  [4794] = {.lex_state = 13, .external_lex_state = 2},
  [4795] = {.lex_state = 11, .external_lex_state = 2},
  [4796] = {.lex_state = 95, .external_lex_state = 5},
  [4797] = {.lex_state = 1, .external_lex_state = 2},
  [4798] = {.lex_state = 11, .external_lex_state = 2},
  [4799] = {.lex_state = 95, .external_lex_state = 2},
  [4800] = {.lex_state = 95, .external_lex_state = 5},
  [4801] = {.lex_state = 95, .external_lex_state = 5},
  [4802] = {.lex_state = 95, .external_lex_state = 2},
  [4803] = {.lex_state = 95, .external_lex_state = 5},
  [4804] = {.lex_state = 17, .external_lex_state = 9},
  [4805] = {.lex_state = 21, .external_lex_state = 9},
  [4806] = {.lex_state = 21, .external_lex_state = 9},
  [4807] = {.lex_state = 17, .external_lex_state = 9},
  [4808] = {.lex_state = 21, .external_lex_state = 9},
  [4809] = {.lex_state = 11, .external_lex_state = 2},
  [4810] = {.lex_state = 17, .external_lex_state = 9},
  [4811] = {.lex_state = 21, .external_lex_state = 9},
  [4812] = {.lex_state = 95, .external_lex_state = 5},
  [4813] = {.lex_state = 11, .external_lex_state = 2},
  [4814] = {.lex_state = 95, .external_lex_state = 5},
  [4815] = {.lex_state = 17, .external_lex_state = 9},
  [4816] = {.lex_state = 95, .external_lex_state = 2},
  [4817] = {.lex_state = 95, .external_lex_state = 5},
  [4818] = {.lex_state = 95, .external_lex_state = 5},
  [4819] = {.lex_state = 95, .external_lex_state = 2},
  [4820] = {.lex_state = 11, .external_lex_state = 2},
  [4821] = {.lex_state = 11, .external_lex_state = 2},
  [4822] = {.lex_state = 13, .external_lex_state = 2},
  [4823] = {.lex_state = 13, .external_lex_state = 2},
  [4824] = {.lex_state = 13, .external_lex_state = 2},
  [4825] = {.lex_state = 95, .external_lex_state = 5},
  [4826] = {.lex_state = 95, .external_lex_state = 5},
  [4827] = {.lex_state = 11, .external_lex_state = 2},
  [4828] = {.lex_state = 13, .external_lex_state = 2},
  [4829] = {.lex_state = 13, .external_lex_state = 2},
  [4830] = {.lex_state = 11, .external_lex_state = 2},
  [4831] = {.lex_state = 18, .external_lex_state = 7},
  [4832] = {.lex_state = 14, .external_lex_state = 2},
  [4833] = {.lex_state = 14, .external_lex_state = 2},
  [4834] = {.lex_state = 11, .external_lex_state = 2},
  [4835] = {.lex_state = 95, .external_lex_state = 2},
  [4836] = {.lex_state = 17, .external_lex_state = 9},
  [4837] = {.lex_state = 21, .external_lex_state = 9},
  [4838] = {.lex_state = 13, .external_lex_state = 2},
  [4839] = {.lex_state = 17, .external_lex_state = 9},
  [4840] = {.lex_state = 11, .external_lex_state = 2},
  [4841] = {.lex_state = 11, .external_lex_state = 2},
  [4842] = {.lex_state = 11, .external_lex_state = 2},
  [4843] = {.lex_state = 18, .external_lex_state = 7},
  [4844] = {.lex_state = 11, .external_lex_state = 2},
  [4845] = {.lex_state = 21, .external_lex_state = 9},
  [4846] = {.lex_state = 11, .external_lex_state = 2},
  [4847] = {.lex_state = 95, .external_lex_state = 5},
  [4848] = {.lex_state = 95, .external_lex_state = 5},
  [4849] = {.lex_state = 13, .external_lex_state = 2},
  [4850] = {.lex_state = 95, .external_lex_state = 5},
  [4851] = {.lex_state = 95, .external_lex_state = 5},
  [4852] = {.lex_state = 95, .external_lex_state = 2},
  [4853] = {.lex_state = 13, .external_lex_state = 2},
  [4854] = {.lex_state = 17, .external_lex_state = 9},
  [4855] = {.lex_state = 11, .external_lex_state = 2},
  [4856] = {.lex_state = 21, .external_lex_state = 9},
  [4857] = {.lex_state = 17, .external_lex_state = 9},
  [4858] = {.lex_state = 21, .external_lex_state = 9},
  [4859] = {.lex_state = 95, .external_lex_state = 5},
  [4860] = {.lex_state = 95, .external_lex_state = 5},
  [4861] = {.lex_state = 95, .external_lex_state = 5},
  [4862] = {.lex_state = 6, .external_lex_state = 5},
  [4863] = {.lex_state = 11, .external_lex_state = 2},
  [4864] = {.lex_state = 95, .external_lex_state = 5},
  [4865] = {.lex_state = 95, .external_lex_state = 5},
  [4866] = {.lex_state = 95, .external_lex_state = 2},
  [4867] = {.lex_state = 95, .external_lex_state = 5},
  [4868] = {.lex_state = 95, .external_lex_state = 2},
  [4869] = {.lex_state = 11, .external_lex_state = 2},
  [4870] = {.lex_state = 95, .external_lex_state = 5},
  [4871] = {.lex_state = 95, .external_lex_state = 5},
  [4872] = {.lex_state = 95, .external_lex_state = 5},
  [4873] = {.lex_state = 95, .external_lex_state = 5},
  [4874] = {.lex_state = 95, .external_lex_state = 5},
  [4875] = {.lex_state = 95, .external_lex_state = 5},
  [4876] = {.lex_state = 95, .external_lex_state = 5},
  [4877] = {.lex_state = 11, .external_lex_state = 2},
  [4878] = {.lex_state = 95, .external_lex_state = 5},
  [4879] = {.lex_state = 95, .external_lex_state = 5},
  [4880] = {.lex_state = 95, .external_lex_state = 5},
  [4881] = {.lex_state = 95, .external_lex_state = 5},
  [4882] = {.lex_state = 95, .external_lex_state = 5},
  [4883] = {.lex_state = 95, .external_lex_state = 5},
  [4884] = {.lex_state = 95, .external_lex_state = 2},
  [4885] = {.lex_state = 95, .external_lex_state = 2},
  [4886] = {.lex_state = 95, .external_lex_state = 5},
  [4887] = {.lex_state = 95, .external_lex_state = 2},
  [4888] = {.lex_state = 95, .external_lex_state = 5},
  [4889] = {.lex_state = 95, .external_lex_state = 5},
  [4890] = {.lex_state = 95, .external_lex_state = 2},
  [4891] = {.lex_state = 11, .external_lex_state = 2},
  [4892] = {.lex_state = 95, .external_lex_state = 5},
  [4893] = {.lex_state = 95, .external_lex_state = 5},
  [4894] = {.lex_state = 95, .external_lex_state = 5},
  [4895] = {.lex_state = 95, .external_lex_state = 2},
  [4896] = {.lex_state = 95, .external_lex_state = 5},
  [4897] = {.lex_state = 95, .external_lex_state = 2},
  [4898] = {.lex_state = 95, .external_lex_state = 5},
  [4899] = {.lex_state = 95, .external_lex_state = 5},
  [4900] = {.lex_state = 95, .external_lex_state = 5},
  [4901] = {.lex_state = 95, .external_lex_state = 5},
  [4902] = {.lex_state = 95, .external_lex_state = 5},
  [4903] = {.lex_state = 95, .external_lex_state = 5},
  [4904] = {.lex_state = 95, .external_lex_state = 5},
  [4905] = {.lex_state = 95, .external_lex_state = 5},
  [4906] = {.lex_state = 95, .external_lex_state = 5},
  [4907] = {.lex_state = 95, .external_lex_state = 5},
  [4908] = {.lex_state = 6, .external_lex_state = 5},
  [4909] = {.lex_state = 6, .external_lex_state = 5},
  [4910] = {.lex_state = 95, .external_lex_state = 2},
  [4911] = {.lex_state = 95, .external_lex_state = 5},
  [4912] = {.lex_state = 95, .external_lex_state = 2},
  [4913] = {.lex_state = 95, .external_lex_state = 2},
  [4914] = {.lex_state = 95, .external_lex_state = 2},
  [4915] = {.lex_state = 95, .external_lex_state = 2},
  [4916] = {.lex_state = 95, .external_lex_state = 5},
  [4917] = {.lex_state = 95, .external_lex_state = 5},
  [4918] = {.lex_state = 95, .external_lex_state = 5},
  [4919] = {.lex_state = 95, .external_lex_state = 5},
  [4920] = {.lex_state = 95, .external_lex_state = 5},
  [4921] = {.lex_state = 95, .external_lex_state = 2},
  [4922] = {.lex_state = 95, .external_lex_state = 5},
  [4923] = {.lex_state = 95, .external_lex_state = 5},
  [4924] = {.lex_state = 95, .external_lex_state = 2},
  [4925] = {.lex_state = 95, .external_lex_state = 2},
  [4926] = {.lex_state = 95, .external_lex_state = 5},
  [4927] = {.lex_state = 95, .external_lex_state = 5},
  [4928] = {.lex_state = 95, .external_lex_state = 5},
  [4929] = {.lex_state = 95, .external_lex_state = 5},
  [4930] = {.lex_state = 95, .external_lex_state = 2},
  [4931] = {.lex_state = 95, .external_lex_state = 5},
  [4932] = {.lex_state = 95, .external_lex_state = 2},
  [4933] = {.lex_state = 95, .external_lex_state = 2},
  [4934] = {.lex_state = 95, .external_lex_state = 5},
  [4935] = {.lex_state = 95, .external_lex_state = 5},
  [4936] = {.lex_state = 95, .external_lex_state = 2},
  [4937] = {.lex_state = 95, .external_lex_state = 5},
  [4938] = {.lex_state = 95, .external_lex_state = 2},
  [4939] = {.lex_state = 95, .external_lex_state = 2},
  [4940] = {.lex_state = 6, .external_lex_state = 2},
  [4941] = {.lex_state = 95, .external_lex_state = 2},
  [4942] = {.lex_state = 95, .external_lex_state = 2},
  [4943] = {.lex_state = 95, .external_lex_state = 5},
  [4944] = {.lex_state = 95, .external_lex_state = 5},
  [4945] = {.lex_state = 11, .external_lex_state = 2},
  [4946] = {.lex_state = 95, .external_lex_state = 5},
  [4947] = {.lex_state = 95, .external_lex_state = 2},
  [4948] = {.lex_state = 11, .external_lex_state = 2},
  [4949] = {.lex_state = 95, .external_lex_state = 5},
  [4950] = {.lex_state = 95, .external_lex_state = 2},
  [4951] = {.lex_state = 95, .external_lex_state = 5},
  [4952] = {.lex_state = 95, .external_lex_state = 2},
  [4953] = {.lex_state = 95, .external_lex_state = 5},
  [4954] = {.lex_state = 11, .external_lex_state = 2},
  [4955] = {.lex_state = 95, .external_lex_state = 2},
  [4956] = {.lex_state = 95, .external_lex_state = 5},
  [4957] = {.lex_state = 95, .external_lex_state = 2},
  [4958] = {.lex_state = 95, .external_lex_state = 5},
  [4959] = {.lex_state = 95, .external_lex_state = 5},
  [4960] = {.lex_state = 95, .external_lex_state = 5},
  [4961] = {.lex_state = 95, .external_lex_state = 5},
  [4962] = {.lex_state = 14, .external_lex_state = 2},
  [4963] = {.lex_state = 95, .external_lex_state = 2},
  [4964] = {.lex_state = 95, .external_lex_state = 5},
  [4965] = {.lex_state = 95, .external_lex_state = 5},
  [4966] = {.lex_state = 95, .external_lex_state = 5},
  [4967] = {.lex_state = 95, .external_lex_state = 5},
  [4968] = {.lex_state = 95, .external_lex_state = 5},
  [4969] = {.lex_state = 95, .external_lex_state = 5},
  [4970] = {.lex_state = 95, .external_lex_state = 5},
  [4971] = {.lex_state = 95, .external_lex_state = 5},
  [4972] = {.lex_state = 11, .external_lex_state = 2},
  [4973] = {.lex_state = 95, .external_lex_state = 2},
  [4974] = {.lex_state = 95, .external_lex_state = 2},
  [4975] = {.lex_state = 95, .external_lex_state = 5},
  [4976] = {.lex_state = 95, .external_lex_state = 5},
  [4977] = {.lex_state = 95, .external_lex_state = 5},
  [4978] = {.lex_state = 6, .external_lex_state = 2},
  [4979] = {.lex_state = 6, .external_lex_state = 2},
  [4980] = {.lex_state = 95, .external_lex_state = 5},
  [4981] = {.lex_state = 95, .external_lex_state = 5},
  [4982] = {.lex_state = 95, .external_lex_state = 5},
  [4983] = {.lex_state = 95, .external_lex_state = 5},
  [4984] = {.lex_state = 95, .external_lex_state = 5},
  [4985] = {.lex_state = 95, .external_lex_state = 5},
  [4986] = {.lex_state = 95, .external_lex_state = 5},
  [4987] = {.lex_state = 95, .external_lex_state = 5},
  [4988] = {.lex_state = 95, .external_lex_state = 5},
  [4989] = {.lex_state = 95, .external_lex_state = 5},
  [4990] = {.lex_state = 95, .external_lex_state = 5},
  [4991] = {.lex_state = 95, .external_lex_state = 2},
  [4992] = {.lex_state = 95, .external_lex_state = 2},
  [4993] = {.lex_state = 95, .external_lex_state = 2},
  [4994] = {.lex_state = 95, .external_lex_state = 5},
  [4995] = {.lex_state = 95, .external_lex_state = 5},
  [4996] = {.lex_state = 95, .external_lex_state = 2},
  [4997] = {.lex_state = 95, .external_lex_state = 2},
  [4998] = {.lex_state = 95, .external_lex_state = 2},
  [4999] = {.lex_state = 18, .external_lex_state = 8},
  [5000] = {.lex_state = 95, .external_lex_state = 5},
  [5001] = {.lex_state = 95, .external_lex_state = 5},
  [5002] = {.lex_state = 95, .external_lex_state = 5},
  [5003] = {.lex_state = 95, .external_lex_state = 5},
  [5004] = {.lex_state = 95, .external_lex_state = 5},
  [5005] = {.lex_state = 95, .external_lex_state = 2},
  [5006] = {.lex_state = 95, .external_lex_state = 2},
  [5007] = {.lex_state = 95, .external_lex_state = 2},
  [5008] = {.lex_state = 95, .external_lex_state = 5},
  [5009] = {.lex_state = 95, .external_lex_state = 2},
  [5010] = {.lex_state = 95, .external_lex_state = 2},
  [5011] = {.lex_state = 95, .external_lex_state = 5},
  [5012] = {.lex_state = 95, .external_lex_state = 5},
  [5013] = {.lex_state = 95, .external_lex_state = 2},
  [5014] = {.lex_state = 11, .external_lex_state = 2},
  [5015] = {.lex_state = 95, .external_lex_state = 5},
  [5016] = {.lex_state = 95, .external_lex_state = 5},
  [5017] = {.lex_state = 95, .external_lex_state = 5},
  [5018] = {.lex_state = 95, .external_lex_state = 2},
  [5019] = {.lex_state = 95, .external_lex_state = 2},
  [5020] = {.lex_state = 95, .external_lex_state = 5},
  [5021] = {.lex_state = 11, .external_lex_state = 2},
  [5022] = {.lex_state = 95, .external_lex_state = 2},
  [5023] = {.lex_state = 11, .external_lex_state = 2},
  [5024] = {.lex_state = 95, .external_lex_state = 2},
  [5025] = {.lex_state = 11, .external_lex_state = 2},
  [5026] = {.lex_state = 95, .external_lex_state = 5},
  [5027] = {.lex_state = 95, .external_lex_state = 5},
  [5028] = {.lex_state = 95, .external_lex_state = 5},
  [5029] = {.lex_state = 11, .external_lex_state = 2},
  [5030] = {.lex_state = 95, .external_lex_state = 5},
  [5031] = {.lex_state = 95, .external_lex_state = 5},
  [5032] = {.lex_state = 11, .external_lex_state = 2},
  [5033] = {.lex_state = 95, .external_lex_state = 5},
  [5034] = {.lex_state = 11, .external_lex_state = 2},
  [5035] = {.lex_state = 95, .external_lex_state = 5},
  [5036] = {.lex_state = 95, .external_lex_state = 2},
  [5037] = {.lex_state = 95, .external_lex_state = 5},
  [5038] = {.lex_state = 95, .external_lex_state = 2},
  [5039] = {.lex_state = 95, .external_lex_state = 2},
  [5040] = {.lex_state = 95, .external_lex_state = 2},
  [5041] = {.lex_state = 95, .external_lex_state = 5},
  [5042] = {.lex_state = 95, .external_lex_state = 5},
  [5043] = {.lex_state = 95, .external_lex_state = 5},
  [5044] = {.lex_state = 95, .external_lex_state = 5},
  [5045] = {.lex_state = 95, .external_lex_state = 5},
  [5046] = {.lex_state = 95, .external_lex_state = 5},
  [5047] = {.lex_state = 95, .external_lex_state = 5},
  [5048] = {.lex_state = 95, .external_lex_state = 2},
  [5049] = {.lex_state = 95, .external_lex_state = 2},
  [5050] = {.lex_state = 95, .external_lex_state = 2},
  [5051] = {.lex_state = 11, .external_lex_state = 2},
  [5052] = {.lex_state = 95, .external_lex_state = 5},
  [5053] = {.lex_state = 95, .external_lex_state = 5},
  [5054] = {.lex_state = 95, .external_lex_state = 5},
  [5055] = {.lex_state = 95, .external_lex_state = 2},
  [5056] = {.lex_state = 95, .external_lex_state = 2},
  [5057] = {.lex_state = 95, .external_lex_state = 5},
  [5058] = {.lex_state = 95, .external_lex_state = 5},
  [5059] = {.lex_state = 95, .external_lex_state = 2},
  [5060] = {.lex_state = 95, .external_lex_state = 5},
  [5061] = {.lex_state = 95, .external_lex_state = 5},
  [5062] = {.lex_state = 95, .external_lex_state = 5},
  [5063] = {.lex_state = 95, .external_lex_state = 5},
  [5064] = {.lex_state = 95, .external_lex_state = 5},
  [5065] = {.lex_state = 95, .external_lex_state = 5},
  [5066] = {.lex_state = 95, .external_lex_state = 5},
  [5067] = {.lex_state = 95, .external_lex_state = 5},
  [5068] = {.lex_state = 95, .external_lex_state = 2},
  [5069] = {.lex_state = 11, .external_lex_state = 2},
  [5070] = {.lex_state = 95, .external_lex_state = 5},
  [5071] = {.lex_state = 95, .external_lex_state = 5},
  [5072] = {.lex_state = 95, .external_lex_state = 5},
  [5073] = {.lex_state = 95, .external_lex_state = 2},
  [5074] = {.lex_state = 95, .external_lex_state = 5},
  [5075] = {.lex_state = 95, .external_lex_state = 5},
  [5076] = {.lex_state = 95, .external_lex_state = 5},
  [5077] = {.lex_state = 95, .external_lex_state = 5},
  [5078] = {.lex_state = 95, .external_lex_state = 2},
  [5079] = {.lex_state = 95, .external_lex_state = 2},
  [5080] = {.lex_state = 95, .external_lex_state = 5},
  [5081] = {.lex_state = 95, .external_lex_state = 5},
  [5082] = {.lex_state = 95, .external_lex_state = 5},
  [5083] = {.lex_state = 95, .external_lex_state = 5},
  [5084] = {.lex_state = 95, .external_lex_state = 2},
  [5085] = {.lex_state = 95, .external_lex_state = 5},
  [5086] = {.lex_state = 95, .external_lex_state = 2},
  [5087] = {.lex_state = 95, .external_lex_state = 2},
  [5088] = {.lex_state = 95, .external_lex_state = 5},
  [5089] = {.lex_state = 11, .external_lex_state = 2},
  [5090] = {.lex_state = 95, .external_lex_state = 5},
  [5091] = {.lex_state = 95, .external_lex_state = 5},
  [5092] = {.lex_state = 95, .external_lex_state = 5},
  [5093] = {.lex_state = 95, .external_lex_state = 5},
  [5094] = {.lex_state = 95, .external_lex_state = 5},
  [5095] = {.lex_state = 95, .external_lex_state = 5},
  [5096] = {.lex_state = 95, .external_lex_state = 2},
  [5097] = {.lex_state = 6, .external_lex_state = 5},
  [5098] = {.lex_state = 95, .external_lex_state = 2},
  [5099] = {.lex_state = 95, .external_lex_state = 2},
  [5100] = {.lex_state = 11, .external_lex_state = 2},
  [5101] = {.lex_state = 95, .external_lex_state = 5},
  [5102] = {.lex_state = 95, .external_lex_state = 5},
  [5103] = {.lex_state = 95, .external_lex_state = 2},
  [5104] = {.lex_state = 95, .external_lex_state = 2},
  [5105] = {.lex_state = 95, .external_lex_state = 2},
  [5106] = {.lex_state = 95, .external_lex_state = 2},
  [5107] = {.lex_state = 95, .external_lex_state = 5},
  [5108] = {.lex_state = 95, .external_lex_state = 2},
  [5109] = {.lex_state = 95, .external_lex_state = 5},
  [5110] = {.lex_state = 95, .external_lex_state = 2},
  [5111] = {.lex_state = 95, .external_lex_state = 2},
  [5112] = {.lex_state = 95, .external_lex_state = 5},
  [5113] = {.lex_state = 95, .external_lex_state = 2},
  [5114] = {.lex_state = 95, .external_lex_state = 2},
  [5115] = {.lex_state = 95, .external_lex_state = 2},
  [5116] = {.lex_state = 95, .external_lex_state = 5},
  [5117] = {.lex_state = 95, .external_lex_state = 5},
  [5118] = {.lex_state = 95, .external_lex_state = 5},
  [5119] = {.lex_state = 95, .external_lex_state = 5},
  [5120] = {.lex_state = 95, .external_lex_state = 2},
  [5121] = {.lex_state = 95, .external_lex_state = 2},
  [5122] = {.lex_state = 95, .external_lex_state = 2},
  [5123] = {.lex_state = 95, .external_lex_state = 5},
  [5124] = {.lex_state = 11, .external_lex_state = 2},
  [5125] = {.lex_state = 95, .external_lex_state = 5},
  [5126] = {.lex_state = 95, .external_lex_state = 2},
  [5127] = {.lex_state = 11, .external_lex_state = 2},
  [5128] = {.lex_state = 95, .external_lex_state = 5},
  [5129] = {.lex_state = 95, .external_lex_state = 5},
  [5130] = {.lex_state = 95, .external_lex_state = 5},
  [5131] = {.lex_state = 95, .external_lex_state = 2},
  [5132] = {.lex_state = 11, .external_lex_state = 2},
  [5133] = {.lex_state = 95, .external_lex_state = 2},
  [5134] = {.lex_state = 95, .external_lex_state = 5},
  [5135] = {.lex_state = 95, .external_lex_state = 2},
  [5136] = {.lex_state = 95, .external_lex_state = 5},
  [5137] = {.lex_state = 95, .external_lex_state = 2},
  [5138] = {.lex_state = 95, .external_lex_state = 5},
  [5139] = {.lex_state = 95, .external_lex_state = 2},
  [5140] = {.lex_state = 95, .external_lex_state = 5},
  [5141] = {.lex_state = 95, .external_lex_state = 2},
  [5142] = {.lex_state = 95, .external_lex_state = 5},
  [5143] = {.lex_state = 95, .external_lex_state = 2},
  [5144] = {.lex_state = 95, .external_lex_state = 2},
  [5145] = {.lex_state = 95, .external_lex_state = 5},
  [5146] = {.lex_state = 95, .external_lex_state = 5},
  [5147] = {.lex_state = 95, .external_lex_state = 2},
  [5148] = {.lex_state = 95, .external_lex_state = 2},
  [5149] = {.lex_state = 95, .external_lex_state = 2},
  [5150] = {.lex_state = 13, .external_lex_state = 2},
  [5151] = {.lex_state = 95, .external_lex_state = 2},
  [5152] = {.lex_state = 95, .external_lex_state = 5},
  [5153] = {.lex_state = 95, .external_lex_state = 5},
  [5154] = {.lex_state = 95, .external_lex_state = 5},
  [5155] = {.lex_state = 95, .external_lex_state = 5},
  [5156] = {.lex_state = 95, .external_lex_state = 5},
  [5157] = {.lex_state = 95, .external_lex_state = 5},
  [5158] = {.lex_state = 95, .external_lex_state = 2},
  [5159] = {.lex_state = 13, .external_lex_state = 2},
  [5160] = {.lex_state = 95, .external_lex_state = 5},
  [5161] = {.lex_state = 95, .external_lex_state = 5},
  [5162] = {.lex_state = 95, .external_lex_state = 5},
  [5163] = {.lex_state = 95, .external_lex_state = 2},
  [5164] = {.lex_state = 95, .external_lex_state = 5},
  [5165] = {.lex_state = 95, .external_lex_state = 5},
  [5166] = {.lex_state = 95, .external_lex_state = 5},
  [5167] = {.lex_state = 95, .external_lex_state = 5},
  [5168] = {.lex_state = 95, .external_lex_state = 5},
  [5169] = {.lex_state = 95, .external_lex_state = 5},
  [5170] = {.lex_state = 95, .external_lex_state = 5},
  [5171] = {.lex_state = 1, .external_lex_state = 2},
  [5172] = {.lex_state = 95, .external_lex_state = 2},
  [5173] = {.lex_state = 95, .external_lex_state = 2},
  [5174] = {.lex_state = 95, .external_lex_state = 5},
  [5175] = {.lex_state = 95, .external_lex_state = 2},
  [5176] = {.lex_state = 95, .external_lex_state = 2},
  [5177] = {.lex_state = 95, .external_lex_state = 5},
  [5178] = {.lex_state = 11, .external_lex_state = 2},
  [5179] = {.lex_state = 95, .external_lex_state = 5},
  [5180] = {.lex_state = 95, .external_lex_state = 2},
  [5181] = {.lex_state = 95, .external_lex_state = 5},
  [5182] = {.lex_state = 11, .external_lex_state = 2},
  [5183] = {.lex_state = 11, .external_lex_state = 2},
  [5184] = {.lex_state = 95, .external_lex_state = 5},
  [5185] = {.lex_state = 95, .external_lex_state = 5},
  [5186] = {.lex_state = 95, .external_lex_state = 2},
  [5187] = {.lex_state = 95, .external_lex_state = 2},
  [5188] = {.lex_state = 95, .external_lex_state = 2},
  [5189] = {.lex_state = 11, .external_lex_state = 2},
  [5190] = {.lex_state = 95, .external_lex_state = 5},
  [5191] = {.lex_state = 95, .external_lex_state = 2},
  [5192] = {.lex_state = 18, .external_lex_state = 8},
  [5193] = {.lex_state = 95, .external_lex_state = 2},
  [5194] = {.lex_state = 95, .external_lex_state = 5},
  [5195] = {.lex_state = 95, .external_lex_state = 5},
  [5196] = {.lex_state = 95, .external_lex_state = 2},
  [5197] = {.lex_state = 95, .external_lex_state = 5},
  [5198] = {.lex_state = 95, .external_lex_state = 5},
  [5199] = {.lex_state = 95, .external_lex_state = 5},
  [5200] = {.lex_state = 95, .external_lex_state = 5},
  [5201] = {.lex_state = 95, .external_lex_state = 5},
  [5202] = {.lex_state = 95, .external_lex_state = 5},
  [5203] = {.lex_state = 6, .external_lex_state = 2},
  [5204] = {.lex_state = 95, .external_lex_state = 5},
  [5205] = {.lex_state = 95, .external_lex_state = 5},
  [5206] = {.lex_state = 95, .external_lex_state = 5},
  [5207] = {.lex_state = 95, .external_lex_state = 2},
  [5208] = {.lex_state = 95, .external_lex_state = 5},
  [5209] = {.lex_state = 95, .external_lex_state = 5},
  [5210] = {.lex_state = 95, .external_lex_state = 5},
  [5211] = {.lex_state = 95, .external_lex_state = 5},
  [5212] = {.lex_state = 95, .external_lex_state = 2},
  [5213] = {.lex_state = 95, .external_lex_state = 2},
  [5214] = {.lex_state = 95, .external_lex_state = 2},
  [5215] = {.lex_state = 11, .external_lex_state = 2},
  [5216] = {.lex_state = 95, .external_lex_state = 5},
  [5217] = {.lex_state = 95, .external_lex_state = 5},
  [5218] = {.lex_state = 95, .external_lex_state = 5},
  [5219] = {.lex_state = 95, .external_lex_state = 5},
  [5220] = {.lex_state = 95, .external_lex_state = 2},
  [5221] = {.lex_state = 11, .external_lex_state = 2},
  [5222] = {.lex_state = 95, .external_lex_state = 5},
  [5223] = {.lex_state = 95, .external_lex_state = 5},
  [5224] = {.lex_state = 95, .external_lex_state = 2},
  [5225] = {.lex_state = 95, .external_lex_state = 5},
  [5226] = {.lex_state = 95, .external_lex_state = 5},
  [5227] = {.lex_state = 95, .external_lex_state = 2},
  [5228] = {.lex_state = 95, .external_lex_state = 5},
  [5229] = {.lex_state = 95, .external_lex_state = 5},
  [5230] = {.lex_state = 95, .external_lex_state = 5},
  [5231] = {.lex_state = 95, .external_lex_state = 2},
  [5232] = {.lex_state = 95, .external_lex_state = 5},
  [5233] = {.lex_state = 95, .external_lex_state = 5},
  [5234] = {.lex_state = 95, .external_lex_state = 5},
  [5235] = {.lex_state = 95, .external_lex_state = 5},
  [5236] = {.lex_state = 95, .external_lex_state = 5},
  [5237] = {.lex_state = 95, .external_lex_state = 5},
  [5238] = {.lex_state = 95, .external_lex_state = 5},
  [5239] = {.lex_state = 95, .external_lex_state = 5},
  [5240] = {.lex_state = 95, .external_lex_state = 5},
  [5241] = {.lex_state = 95, .external_lex_state = 5},
  [5242] = {.lex_state = 95, .external_lex_state = 5},
  [5243] = {.lex_state = 95, .external_lex_state = 5},
  [5244] = {.lex_state = 95, .external_lex_state = 5},
  [5245] = {.lex_state = 95, .external_lex_state = 5},
  [5246] = {.lex_state = 95, .external_lex_state = 2},
  [5247] = {.lex_state = 95, .external_lex_state = 5},
  [5248] = {.lex_state = 13, .external_lex_state = 2},
  [5249] = {.lex_state = 95, .external_lex_state = 5},
  [5250] = {.lex_state = 95, .external_lex_state = 5},
  [5251] = {.lex_state = 95, .external_lex_state = 2},
  [5252] = {.lex_state = 95, .external_lex_state = 5},
  [5253] = {.lex_state = 95, .external_lex_state = 5},
  [5254] = {.lex_state = 95, .external_lex_state = 5},
  [5255] = {.lex_state = 95, .external_lex_state = 5},
  [5256] = {.lex_state = 95, .external_lex_state = 5},
  [5257] = {.lex_state = 95, .external_lex_state = 5},
  [5258] = {.lex_state = 11, .external_lex_state = 2},
  [5259] = {.lex_state = 95, .external_lex_state = 2},
  [5260] = {.lex_state = 95, .external_lex_state = 5},
  [5261] = {.lex_state = 11, .external_lex_state = 2},
  [5262] = {.lex_state = 95, .external_lex_state = 5},
  [5263] = {.lex_state = 95, .external_lex_state = 5},
  [5264] = {.lex_state = 95, .external_lex_state = 5},
  [5265] = {.lex_state = 95, .external_lex_state = 5},
  [5266] = {.lex_state = 11, .external_lex_state = 2},
  [5267] = {.lex_state = 95, .external_lex_state = 2},
  [5268] = {.lex_state = 95, .external_lex_state = 5},
  [5269] = {.lex_state = 95, .external_lex_state = 2},
  [5270] = {.lex_state = 6, .external_lex_state = 2},
  [5271] = {.lex_state = 95, .external_lex_state = 5},
  [5272] = {.lex_state = 95, .external_lex_state = 5},
  [5273] = {.lex_state = 95, .external_lex_state = 5},
  [5274] = {.lex_state = 95, .external_lex_state = 5},
  [5275] = {.lex_state = 95, .external_lex_state = 5},
  [5276] = {.lex_state = 95, .external_lex_state = 5},
  [5277] = {.lex_state = 95, .external_lex_state = 5},
  [5278] = {.lex_state = 95, .external_lex_state = 5},
  [5279] = {.lex_state = 95, .external_lex_state = 5},
  [5280] = {.lex_state = 95, .external_lex_state = 5},
  [5281] = {.lex_state = 95, .external_lex_state = 5},
  [5282] = {.lex_state = 95, .external_lex_state = 5},
  [5283] = {.lex_state = 95, .external_lex_state = 5},
  [5284] = {.lex_state = 11, .external_lex_state = 2},
  [5285] = {.lex_state = 95, .external_lex_state = 5},
  [5286] = {.lex_state = 95, .external_lex_state = 5},
  [5287] = {.lex_state = 95, .external_lex_state = 2},
  [5288] = {.lex_state = 95, .external_lex_state = 5},
  [5289] = {.lex_state = 95, .external_lex_state = 2},
  [5290] = {.lex_state = 95, .external_lex_state = 5},
  [5291] = {.lex_state = 95, .external_lex_state = 2},
  [5292] = {.lex_state = 95, .external_lex_state = 5},
  [5293] = {.lex_state = 95, .external_lex_state = 2},
  [5294] = {.lex_state = 95, .external_lex_state = 2},
  [5295] = {.lex_state = 95, .external_lex_state = 5},
  [5296] = {.lex_state = 95, .external_lex_state = 5},
  [5297] = {.lex_state = 95, .external_lex_state = 5},
  [5298] = {.lex_state = 95, .external_lex_state = 5},
  [5299] = {.lex_state = 95, .external_lex_state = 5},
  [5300] = {.lex_state = 95, .external_lex_state = 5},
  [5301] = {.lex_state = 95, .external_lex_state = 5},
  [5302] = {.lex_state = 95, .external_lex_state = 5},
  [5303] = {.lex_state = 95, .external_lex_state = 5},
  [5304] = {.lex_state = 95, .external_lex_state = 2},
  [5305] = {.lex_state = 95, .external_lex_state = 5},
  [5306] = {.lex_state = 95, .external_lex_state = 5},
  [5307] = {.lex_state = 95, .external_lex_state = 2},
  [5308] = {.lex_state = 95, .external_lex_state = 5},
  [5309] = {.lex_state = 95, .external_lex_state = 5},
  [5310] = {.lex_state = 95, .external_lex_state = 5},
  [5311] = {.lex_state = 95, .external_lex_state = 5},
  [5312] = {.lex_state = 95, .external_lex_state = 5},
  [5313] = {.lex_state = 95, .external_lex_state = 2},
  [5314] = {.lex_state = 95, .external_lex_state = 5},
  [5315] = {.lex_state = 95, .external_lex_state = 2},
  [5316] = {.lex_state = 95, .external_lex_state = 5},
  [5317] = {.lex_state = 95, .external_lex_state = 5},
  [5318] = {.lex_state = 11, .external_lex_state = 2},
  [5319] = {.lex_state = 95, .external_lex_state = 2},
  [5320] = {.lex_state = 11, .external_lex_state = 2},
  [5321] = {.lex_state = 95, .external_lex_state = 5},
  [5322] = {.lex_state = 11, .external_lex_state = 2},
  [5323] = {.lex_state = 95, .external_lex_state = 2},
  [5324] = {.lex_state = 11, .external_lex_state = 2},
  [5325] = {.lex_state = 95, .external_lex_state = 5},
  [5326] = {.lex_state = 95, .external_lex_state = 5},
  [5327] = {.lex_state = 95, .external_lex_state = 5},
  [5328] = {.lex_state = 95, .external_lex_state = 2},
  [5329] = {.lex_state = 95, .external_lex_state = 2},
  [5330] = {.lex_state = 95, .external_lex_state = 5},
  [5331] = {.lex_state = 95, .external_lex_state = 5},
  [5332] = {.lex_state = 95, .external_lex_state = 5},
  [5333] = {.lex_state = 95, .external_lex_state = 2},
  [5334] = {.lex_state = 95, .external_lex_state = 5},
  [5335] = {.lex_state = 6, .external_lex_state = 2},
  [5336] = {.lex_state = 95, .external_lex_state = 5},
  [5337] = {.lex_state = 95, .external_lex_state = 5},
  [5338] = {.lex_state = 95, .external_lex_state = 5},
  [5339] = {.lex_state = 95, .external_lex_state = 5},
  [5340] = {.lex_state = 95, .external_lex_state = 5},
  [5341] = {.lex_state = 95, .external_lex_state = 5},
  [5342] = {.lex_state = 95, .external_lex_state = 5},
  [5343] = {.lex_state = 95, .external_lex_state = 5},
  [5344] = {.lex_state = 95, .external_lex_state = 5},
  [5345] = {.lex_state = 95, .external_lex_state = 5},
  [5346] = {.lex_state = 95, .external_lex_state = 5},
  [5347] = {.lex_state = 95, .external_lex_state = 5},
  [5348] = {.lex_state = 95, .external_lex_state = 5},
  [5349] = {.lex_state = 11, .external_lex_state = 2},
  [5350] = {.lex_state = 95, .external_lex_state = 5},
  [5351] = {.lex_state = 95, .external_lex_state = 2},
  [5352] = {.lex_state = 95, .external_lex_state = 5},
  [5353] = {.lex_state = 95, .external_lex_state = 2},
  [5354] = {.lex_state = 95, .external_lex_state = 2},
  [5355] = {.lex_state = 95, .external_lex_state = 2},
  [5356] = {.lex_state = 95, .external_lex_state = 5},
  [5357] = {.lex_state = 95, .external_lex_state = 5},
  [5358] = {.lex_state = 95, .external_lex_state = 2},
  [5359] = {.lex_state = 11, .external_lex_state = 2},
  [5360] = {.lex_state = 95, .external_lex_state = 5},
  [5361] = {.lex_state = 95, .external_lex_state = 2},
  [5362] = {.lex_state = 95, .external_lex_state = 2},
  [5363] = {.lex_state = 95, .external_lex_state = 5},
  [5364] = {.lex_state = 95, .external_lex_state = 5},
  [5365] = {.lex_state = 95, .external_lex_state = 5},
  [5366] = {.lex_state = 95, .external_lex_state = 5},
  [5367] = {.lex_state = 95, .external_lex_state = 2},
  [5368] = {.lex_state = 95, .external_lex_state = 5},
  [5369] = {.lex_state = 95, .external_lex_state = 5},
  [5370] = {.lex_state = 95, .external_lex_state = 5},
  [5371] = {.lex_state = 95, .external_lex_state = 5},
  [5372] = {.lex_state = 95, .external_lex_state = 5},
  [5373] = {.lex_state = 95, .external_lex_state = 5},
  [5374] = {.lex_state = 95, .external_lex_state = 5},
  [5375] = {.lex_state = 95, .external_lex_state = 2},
  [5376] = {.lex_state = 95, .external_lex_state = 5},
  [5377] = {.lex_state = 6, .external_lex_state = 5},
  [5378] = {.lex_state = 95, .external_lex_state = 5},
  [5379] = {.lex_state = 95, .external_lex_state = 5},
  [5380] = {.lex_state = 95, .external_lex_state = 5},
  [5381] = {.lex_state = 95, .external_lex_state = 5},
  [5382] = {.lex_state = 95, .external_lex_state = 5},
  [5383] = {.lex_state = 95, .external_lex_state = 2},
  [5384] = {.lex_state = 95, .external_lex_state = 5},
  [5385] = {.lex_state = 95, .external_lex_state = 5},
  [5386] = {.lex_state = 95, .external_lex_state = 5},
  [5387] = {.lex_state = 6, .external_lex_state = 2},
  [5388] = {.lex_state = 6, .external_lex_state = 2},
  [5389] = {.lex_state = 95, .external_lex_state = 2},
  [5390] = {.lex_state = 6, .external_lex_state = 5},
  [5391] = {.lex_state = 95, .external_lex_state = 5},
  [5392] = {.lex_state = 95, .external_lex_state = 5},
  [5393] = {.lex_state = 95, .external_lex_state = 5},
  [5394] = {.lex_state = 95, .external_lex_state = 5},
  [5395] = {.lex_state = 95, .external_lex_state = 2},
  [5396] = {.lex_state = 95, .external_lex_state = 5},
  [5397] = {.lex_state = 95, .external_lex_state = 5},
  [5398] = {.lex_state = 95, .external_lex_state = 5},
  [5399] = {.lex_state = 95, .external_lex_state = 5},
  [5400] = {.lex_state = 95, .external_lex_state = 5},
  [5401] = {.lex_state = 95, .external_lex_state = 5},
  [5402] = {.lex_state = 95, .external_lex_state = 2},
  [5403] = {.lex_state = 95, .external_lex_state = 5},
  [5404] = {.lex_state = 95, .external_lex_state = 5},
  [5405] = {.lex_state = 95, .external_lex_state = 5},
  [5406] = {.lex_state = 95, .external_lex_state = 2},
  [5407] = {.lex_state = 95, .external_lex_state = 2},
  [5408] = {.lex_state = 95, .external_lex_state = 2},
  [5409] = {.lex_state = 95, .external_lex_state = 2},
  [5410] = {.lex_state = 95, .external_lex_state = 2},
  [5411] = {.lex_state = 95, .external_lex_state = 5},
  [5412] = {.lex_state = 95, .external_lex_state = 5},
  [5413] = {.lex_state = 6, .external_lex_state = 2},
  [5414] = {.lex_state = 6, .external_lex_state = 2},
  [5415] = {.lex_state = 95, .external_lex_state = 5},
  [5416] = {.lex_state = 95, .external_lex_state = 5},
  [5417] = {.lex_state = 95, .external_lex_state = 5},
  [5418] = {.lex_state = 95, .external_lex_state = 5},
  [5419] = {.lex_state = 95, .external_lex_state = 2},
  [5420] = {.lex_state = 95, .external_lex_state = 5},
  [5421] = {.lex_state = 11, .external_lex_state = 2},
  [5422] = {.lex_state = 95, .external_lex_state = 5},
  [5423] = {.lex_state = 6, .external_lex_state = 2},
  [5424] = {.lex_state = 95, .external_lex_state = 5},
  [5425] = {.lex_state = 13, .external_lex_state = 2},
  [5426] = {.lex_state = 95, .external_lex_state = 5},
  [5427] = {.lex_state = 95, .external_lex_state = 5},
  [5428] = {.lex_state = 95, .external_lex_state = 5},
  [5429] = {.lex_state = 95, .external_lex_state = 5},
  [5430] = {.lex_state = 95, .external_lex_state = 5},
  [5431] = {.lex_state = 95, .external_lex_state = 5},
  [5432] = {.lex_state = 95, .external_lex_state = 5},
  [5433] = {.lex_state = 95, .external_lex_state = 5},
  [5434] = {.lex_state = 95, .external_lex_state = 5},
  [5435] = {.lex_state = 95, .external_lex_state = 5},
  [5436] = {.lex_state = 95, .external_lex_state = 5},
  [5437] = {.lex_state = 95, .external_lex_state = 5},
  [5438] = {.lex_state = 95, .external_lex_state = 5},
  [5439] = {.lex_state = 95, .external_lex_state = 5},
  [5440] = {.lex_state = 95, .external_lex_state = 5},
  [5441] = {.lex_state = 95, .external_lex_state = 2},
  [5442] = {.lex_state = 95, .external_lex_state = 5},
  [5443] = {.lex_state = 95, .external_lex_state = 5},
  [5444] = {.lex_state = 95, .external_lex_state = 5},
  [5445] = {.lex_state = 95, .external_lex_state = 2},
  [5446] = {.lex_state = 95, .external_lex_state = 5},
  [5447] = {.lex_state = 95, .external_lex_state = 5},
  [5448] = {.lex_state = 95, .external_lex_state = 5},
  [5449] = {.lex_state = 95, .external_lex_state = 5},
  [5450] = {.lex_state = 95, .external_lex_state = 2},
  [5451] = {.lex_state = 95, .external_lex_state = 5},
  [5452] = {.lex_state = 95, .external_lex_state = 5},
  [5453] = {.lex_state = 95, .external_lex_state = 5},
  [5454] = {.lex_state = 95, .external_lex_state = 5},
  [5455] = {.lex_state = 95, .external_lex_state = 5},
  [5456] = {.lex_state = 95, .external_lex_state = 5},
  [5457] = {.lex_state = 95, .external_lex_state = 2},
  [5458] = {.lex_state = 21, .external_lex_state = 9},
  [5459] = {.lex_state = 95, .external_lex_state = 5},
  [5460] = {.lex_state = 17, .external_lex_state = 9},
  [5461] = {.lex_state = 95, .external_lex_state = 5},
  [5462] = {.lex_state = 95, .external_lex_state = 5},
  [5463] = {.lex_state = 95, .external_lex_state = 2},
  [5464] = {.lex_state = 95, .external_lex_state = 5},
  [5465] = {.lex_state = 95, .external_lex_state = 5},
  [5466] = {.lex_state = 95, .external_lex_state = 5},
  [5467] = {.lex_state = 95, .external_lex_state = 5},
  [5468] = {.lex_state = 95, .external_lex_state = 5},
  [5469] = {.lex_state = 95, .external_lex_state = 5},
  [5470] = {.lex_state = 95, .external_lex_state = 2},
  [5471] = {.lex_state = 95, .external_lex_state = 5},
  [5472] = {.lex_state = 95, .external_lex_state = 2},
  [5473] = {.lex_state = 95, .external_lex_state = 5},
  [5474] = {.lex_state = 95, .external_lex_state = 2},
  [5475] = {.lex_state = 95, .external_lex_state = 2},
  [5476] = {.lex_state = 95, .external_lex_state = 5},
  [5477] = {.lex_state = 95, .external_lex_state = 5},
  [5478] = {.lex_state = 95, .external_lex_state = 5},
  [5479] = {.lex_state = 95, .external_lex_state = 5},
  [5480] = {.lex_state = 95, .external_lex_state = 5},
  [5481] = {.lex_state = 95, .external_lex_state = 2},
  [5482] = {.lex_state = 95, .external_lex_state = 5},
  [5483] = {.lex_state = 95, .external_lex_state = 5},
  [5484] = {.lex_state = 95, .external_lex_state = 5},
  [5485] = {.lex_state = 95, .external_lex_state = 5},
  [5486] = {.lex_state = 95, .external_lex_state = 5},
  [5487] = {.lex_state = 95, .external_lex_state = 2},
  [5488] = {.lex_state = 95, .external_lex_state = 2},
  [5489] = {.lex_state = 95, .external_lex_state = 5},
  [5490] = {.lex_state = 11, .external_lex_state = 2},
  [5491] = {.lex_state = 6, .external_lex_state = 2},
  [5492] = {.lex_state = 11, .external_lex_state = 2},
  [5493] = {.lex_state = 95, .external_lex_state = 5},
  [5494] = {.lex_state = 11, .external_lex_state = 2},
  [5495] = {.lex_state = 95, .external_lex_state = 5},
  [5496] = {.lex_state = 11, .external_lex_state = 2},
  [5497] = {.lex_state = 95, .external_lex_state = 5},
  [5498] = {.lex_state = 95, .external_lex_state = 5},
  [5499] = {.lex_state = 95, .external_lex_state = 2},
  [5500] = {.lex_state = 95, .external_lex_state = 2},
  [5501] = {.lex_state = 95, .external_lex_state = 5},
  [5502] = {.lex_state = 95, .external_lex_state = 5},
  [5503] = {.lex_state = 95, .external_lex_state = 5},
  [5504] = {.lex_state = 95, .external_lex_state = 5},
  [5505] = {.lex_state = 6, .external_lex_state = 2},
  [5506] = {.lex_state = 95, .external_lex_state = 5},
  [5507] = {.lex_state = 95, .external_lex_state = 2},
  [5508] = {.lex_state = 95, .external_lex_state = 2},
  [5509] = {.lex_state = 95, .external_lex_state = 2},
  [5510] = {.lex_state = 95, .external_lex_state = 5},
  [5511] = {.lex_state = 95, .external_lex_state = 5},
  [5512] = {.lex_state = 95, .external_lex_state = 2},
  [5513] = {.lex_state = 11, .external_lex_state = 2},
  [5514] = {.lex_state = 11, .external_lex_state = 2},
  [5515] = {.lex_state = 11, .external_lex_state = 2},
  [5516] = {.lex_state = 95, .external_lex_state = 5},
  [5517] = {.lex_state = 95, .external_lex_state = 2},
  [5518] = {.lex_state = 11, .external_lex_state = 2},
  [5519] = {.lex_state = 95, .external_lex_state = 2},
  [5520] = {.lex_state = 95, .external_lex_state = 5},
  [5521] = {.lex_state = 95, .external_lex_state = 2},
  [5522] = {.lex_state = 11, .external_lex_state = 2},
  [5523] = {.lex_state = 95, .external_lex_state = 2},
  [5524] = {.lex_state = 95, .external_lex_state = 5},
  [5525] = {.lex_state = 95, .external_lex_state = 5},
  [5526] = {.lex_state = 11, .external_lex_state = 2},
  [5527] = {.lex_state = 6, .external_lex_state = 2},
  [5528] = {.lex_state = 95, .external_lex_state = 2},
  [5529] = {.lex_state = 95, .external_lex_state = 2},
  [5530] = {.lex_state = 95, .external_lex_state = 2},
  [5531] = {.lex_state = 1, .external_lex_state = 2},
  [5532] = {.lex_state = 11, .external_lex_state = 2},
  [5533] = {.lex_state = 95, .external_lex_state = 5},
  [5534] = {.lex_state = 95, .external_lex_state = 2},
  [5535] = {.lex_state = 95, .external_lex_state = 2},
  [5536] = {.lex_state = 11, .external_lex_state = 2},
  [5537] = {.lex_state = 95, .external_lex_state = 5},
  [5538] = {.lex_state = 95, .external_lex_state = 2},
  [5539] = {.lex_state = 95, .external_lex_state = 5},
  [5540] = {.lex_state = 95, .external_lex_state = 5},
  [5541] = {.lex_state = 95, .external_lex_state = 2},
  [5542] = {.lex_state = 95, .external_lex_state = 2},
  [5543] = {.lex_state = 11, .external_lex_state = 2},
  [5544] = {.lex_state = 11, .external_lex_state = 2},
  [5545] = {.lex_state = 95, .external_lex_state = 2},
  [5546] = {.lex_state = 11, .external_lex_state = 2},
  [5547] = {.lex_state = 11, .external_lex_state = 2},
  [5548] = {.lex_state = 95, .external_lex_state = 5},
  [5549] = {.lex_state = 95, .external_lex_state = 2},
  [5550] = {.lex_state = 95, .external_lex_state = 2},
  [5551] = {.lex_state = 1, .external_lex_state = 2},
  [5552] = {.lex_state = 11, .external_lex_state = 2},
  [5553] = {.lex_state = 95, .external_lex_state = 2},
  [5554] = {.lex_state = 95, .external_lex_state = 2},
  [5555] = {.lex_state = 11, .external_lex_state = 2},
  [5556] = {.lex_state = 11, .external_lex_state = 2},
  [5557] = {.lex_state = 14, .external_lex_state = 2},
  [5558] = {.lex_state = 95, .external_lex_state = 5},
  [5559] = {.lex_state = 95, .external_lex_state = 2},
  [5560] = {.lex_state = 11, .external_lex_state = 2},
  [5561] = {.lex_state = 95, .external_lex_state = 2},
  [5562] = {.lex_state = 95, .external_lex_state = 2},
  [5563] = {.lex_state = 95, .external_lex_state = 2},
  [5564] = {.lex_state = 95, .external_lex_state = 2},
  [5565] = {.lex_state = 95, .external_lex_state = 2},
  [5566] = {.lex_state = 95, .external_lex_state = 5},
  [5567] = {.lex_state = 95, .external_lex_state = 5},
  [5568] = {.lex_state = 95, .external_lex_state = 5},
  [5569] = {.lex_state = 95, .external_lex_state = 5},
  [5570] = {.lex_state = 11, .external_lex_state = 2},
  [5571] = {.lex_state = 11, .external_lex_state = 2},
  [5572] = {.lex_state = 11, .external_lex_state = 2},
  [5573] = {.lex_state = 11, .external_lex_state = 2},
  [5574] = {.lex_state = 11, .external_lex_state = 2},
  [5575] = {.lex_state = 95, .external_lex_state = 2},
  [5576] = {.lex_state = 11, .external_lex_state = 2},
  [5577] = {.lex_state = 11, .external_lex_state = 2},
  [5578] = {.lex_state = 95, .external_lex_state = 2},
  [5579] = {.lex_state = 11, .external_lex_state = 2},
  [5580] = {.lex_state = 11, .external_lex_state = 2},
  [5581] = {.lex_state = 11, .external_lex_state = 2},
  [5582] = {.lex_state = 11, .external_lex_state = 2},
  [5583] = {.lex_state = 95, .external_lex_state = 2},
  [5584] = {.lex_state = 95, .external_lex_state = 2},
  [5585] = {.lex_state = 11, .external_lex_state = 2},
  [5586] = {.lex_state = 11, .external_lex_state = 2},
  [5587] = {.lex_state = 11, .external_lex_state = 2},
  [5588] = {.lex_state = 95, .external_lex_state = 2},
  [5589] = {.lex_state = 95, .external_lex_state = 2},
  [5590] = {.lex_state = 11, .external_lex_state = 2},
  [5591] = {.lex_state = 95, .external_lex_state = 2},
  [5592] = {.lex_state = 95, .external_lex_state = 2},
  [5593] = {.lex_state = 95, .external_lex_state = 2},
  [5594] = {.lex_state = 95, .external_lex_state = 2},
  [5595] = {.lex_state = 95, .external_lex_state = 2},
  [5596] = {.lex_state = 11, .external_lex_state = 2},
  [5597] = {.lex_state = 95, .external_lex_state = 2},
  [5598] = {.lex_state = 95, .external_lex_state = 2},
  [5599] = {.lex_state = 95, .external_lex_state = 2},
  [5600] = {.lex_state = 11, .external_lex_state = 2},
  [5601] = {.lex_state = 11, .external_lex_state = 2},
  [5602] = {.lex_state = 11, .external_lex_state = 2},
  [5603] = {.lex_state = 11, .external_lex_state = 2},
  [5604] = {.lex_state = 11, .external_lex_state = 2},
  [5605] = {.lex_state = 11, .external_lex_state = 2},
  [5606] = {.lex_state = 95, .external_lex_state = 2},
  [5607] = {.lex_state = 95, .external_lex_state = 2},
  [5608] = {.lex_state = 11, .external_lex_state = 2},
  [5609] = {.lex_state = 95, .external_lex_state = 2},
  [5610] = {.lex_state = 95, .external_lex_state = 5},
  [5611] = {.lex_state = 95, .external_lex_state = 5},
  [5612] = {.lex_state = 95, .external_lex_state = 5},
  [5613] = {.lex_state = 95, .external_lex_state = 2},
  [5614] = {.lex_state = 95, .external_lex_state = 2},
  [5615] = {.lex_state = 11, .external_lex_state = 2},
  [5616] = {.lex_state = 95, .external_lex_state = 5},
  [5617] = {.lex_state = 95, .external_lex_state = 2},
  [5618] = {.lex_state = 95, .external_lex_state = 2},
  [5619] = {.lex_state = 95, .external_lex_state = 5},
  [5620] = {.lex_state = 11, .external_lex_state = 2},
  [5621] = {.lex_state = 11, .external_lex_state = 2},
  [5622] = {.lex_state = 11, .external_lex_state = 2},
  [5623] = {.lex_state = 95, .external_lex_state = 5},
  [5624] = {.lex_state = 95, .external_lex_state = 5},
  [5625] = {.lex_state = 11, .external_lex_state = 2},
  [5626] = {.lex_state = 95, .external_lex_state = 2},
  [5627] = {.lex_state = 95, .external_lex_state = 2},
  [5628] = {.lex_state = 11, .external_lex_state = 2},
  [5629] = {.lex_state = 95, .external_lex_state = 5},
  [5630] = {.lex_state = 95, .external_lex_state = 5},
  [5631] = {.lex_state = 11, .external_lex_state = 2},
  [5632] = {.lex_state = 95, .external_lex_state = 2},
  [5633] = {.lex_state = 11, .external_lex_state = 2},
  [5634] = {.lex_state = 95, .external_lex_state = 5},
  [5635] = {.lex_state = 11, .external_lex_state = 2},
  [5636] = {.lex_state = 11, .external_lex_state = 2},
  [5637] = {.lex_state = 11, .external_lex_state = 2},
  [5638] = {.lex_state = 11, .external_lex_state = 2},
  [5639] = {.lex_state = 11, .external_lex_state = 2},
  [5640] = {.lex_state = 11, .external_lex_state = 2},
  [5641] = {.lex_state = 11, .external_lex_state = 2},
  [5642] = {.lex_state = 95, .external_lex_state = 2},
  [5643] = {.lex_state = 95, .external_lex_state = 2},
  [5644] = {.lex_state = 95, .external_lex_state = 2},
  [5645] = {.lex_state = 95, .external_lex_state = 2},
  [5646] = {.lex_state = 95, .external_lex_state = 2},
  [5647] = {.lex_state = 11, .external_lex_state = 2},
  [5648] = {.lex_state = 95, .external_lex_state = 2},
  [5649] = {.lex_state = 11, .external_lex_state = 2},
  [5650] = {.lex_state = 11, .external_lex_state = 2},
  [5651] = {.lex_state = 11, .external_lex_state = 2},
  [5652] = {.lex_state = 11, .external_lex_state = 2},
  [5653] = {.lex_state = 11, .external_lex_state = 2},
  [5654] = {.lex_state = 11, .external_lex_state = 2},
  [5655] = {.lex_state = 11, .external_lex_state = 2},
  [5656] = {.lex_state = 11, .external_lex_state = 2},
  [5657] = {.lex_state = 11, .external_lex_state = 2},
  [5658] = {.lex_state = 95, .external_lex_state = 5},
  [5659] = {.lex_state = 95, .external_lex_state = 5},
  [5660] = {.lex_state = 95, .external_lex_state = 2},
  [5661] = {.lex_state = 95, .external_lex_state = 2},
  [5662] = {.lex_state = 95, .external_lex_state = 2},
  [5663] = {.lex_state = 95, .external_lex_state = 2},
  [5664] = {.lex_state = 95, .external_lex_state = 2},
  [5665] = {.lex_state = 95, .external_lex_state = 2},
  [5666] = {.lex_state = 95, .external_lex_state = 2},
  [5667] = {.lex_state = 95, .external_lex_state = 2},
  [5668] = {.lex_state = 11, .external_lex_state = 2},
  [5669] = {.lex_state = 11, .external_lex_state = 2},
  [5670] = {.lex_state = 95, .external_lex_state = 5},
  [5671] = {.lex_state = 95, .external_lex_state = 5},
  [5672] = {.lex_state = 95, .external_lex_state = 5},
  [5673] = {.lex_state = 95, .external_lex_state = 2},
  [5674] = {.lex_state = 95, .external_lex_state = 2},
  [5675] = {.lex_state = 95, .external_lex_state = 2},
  [5676] = {.lex_state = 95, .external_lex_state = 2},
  [5677] = {.lex_state = 95, .external_lex_state = 2},
  [5678] = {.lex_state = 95, .external_lex_state = 2},
  [5679] = {.lex_state = 95, .external_lex_state = 2},
  [5680] = {.lex_state = 11, .external_lex_state = 2},
  [5681] = {.lex_state = 11, .external_lex_state = 2},
  [5682] = {.lex_state = 95, .external_lex_state = 2},
  [5683] = {.lex_state = 11, .external_lex_state = 2},
  [5684] = {.lex_state = 11, .external_lex_state = 2},
  [5685] = {.lex_state = 95, .external_lex_state = 2},
  [5686] = {.lex_state = 95, .external_lex_state = 2},
  [5687] = {.lex_state = 95, .external_lex_state = 2},
  [5688] = {.lex_state = 11, .external_lex_state = 2},
  [5689] = {.lex_state = 95, .external_lex_state = 2},
  [5690] = {.lex_state = 95, .external_lex_state = 2},
  [5691] = {.lex_state = 95, .external_lex_state = 2},
  [5692] = {.lex_state = 11, .external_lex_state = 2},
  [5693] = {.lex_state = 11, .external_lex_state = 2},
  [5694] = {.lex_state = 95, .external_lex_state = 2},
  [5695] = {.lex_state = 95, .external_lex_state = 2},
  [5696] = {.lex_state = 95, .external_lex_state = 5},
  [5697] = {.lex_state = 95, .external_lex_state = 2},
  [5698] = {.lex_state = 95, .external_lex_state = 2},
  [5699] = {.lex_state = 95, .external_lex_state = 2},
  [5700] = {.lex_state = 95, .external_lex_state = 2},
  [5701] = {.lex_state = 95, .external_lex_state = 2},
  [5702] = {.lex_state = 95, .external_lex_state = 2},
  [5703] = {.lex_state = 95, .external_lex_state = 5},
  [5704] = {.lex_state = 95, .external_lex_state = 5},
  [5705] = {.lex_state = 11, .external_lex_state = 2},
  [5706] = {.lex_state = 11, .external_lex_state = 2},
  [5707] = {.lex_state = 11, .external_lex_state = 2},
  [5708] = {.lex_state = 11, .external_lex_state = 2},
  [5709] = {.lex_state = 11, .external_lex_state = 2},
  [5710] = {.lex_state = 11, .external_lex_state = 2},
  [5711] = {.lex_state = 11, .external_lex_state = 2},
  [5712] = {.lex_state = 11, .external_lex_state = 2},
  [5713] = {.lex_state = 11, .external_lex_state = 2},
  [5714] = {.lex_state = 11, .external_lex_state = 2},
  [5715] = {.lex_state = 95, .external_lex_state = 5},
  [5716] = {.lex_state = 95, .external_lex_state = 2},
  [5717] = {.lex_state = 95, .external_lex_state = 5},
  [5718] = {.lex_state = 95, .external_lex_state = 5},
  [5719] = {.lex_state = 95, .external_lex_state = 2},
  [5720] = {.lex_state = 95, .external_lex_state = 2},
  [5721] = {.lex_state = 95, .external_lex_state = 2},
  [5722] = {.lex_state = 11, .external_lex_state = 2},
  [5723] = {.lex_state = 95, .external_lex_state = 2},
  [5724] = {.lex_state = 95, .external_lex_state = 2},
  [5725] = {.lex_state = 95, .external_lex_state = 2},
  [5726] = {.lex_state = 11, .external_lex_state = 2},
  [5727] = {.lex_state = 11, .external_lex_state = 2},
  [5728] = {.lex_state = 95, .external_lex_state = 2},
  [5729] = {.lex_state = 95, .external_lex_state = 5},
  [5730] = {.lex_state = 11, .external_lex_state = 2},
  [5731] = {.lex_state = 11, .external_lex_state = 2},
  [5732] = {.lex_state = 11, .external_lex_state = 2},
  [5733] = {.lex_state = 11, .external_lex_state = 2},
  [5734] = {.lex_state = 11, .external_lex_state = 2},
  [5735] = {.lex_state = 11, .external_lex_state = 2},
  [5736] = {.lex_state = 11, .external_lex_state = 2},
  [5737] = {.lex_state = 95, .external_lex_state = 5},
  [5738] = {.lex_state = 95, .external_lex_state = 2},
  [5739] = {.lex_state = 95, .external_lex_state = 5},
  [5740] = {.lex_state = 11, .external_lex_state = 2},
  [5741] = {.lex_state = 11, .external_lex_state = 2},
  [5742] = {.lex_state = 11, .external_lex_state = 2},
  [5743] = {.lex_state = 95, .external_lex_state = 5},
  [5744] = {.lex_state = 11, .external_lex_state = 2},
  [5745] = {.lex_state = 11, .external_lex_state = 2},
  [5746] = {.lex_state = 11, .external_lex_state = 2},
  [5747] = {.lex_state = 11, .external_lex_state = 2},
  [5748] = {.lex_state = 95, .external_lex_state = 2},
  [5749] = {.lex_state = 11, .external_lex_state = 2},
  [5750] = {.lex_state = 95, .external_lex_state = 2},
  [5751] = {.lex_state = 11, .external_lex_state = 2},
  [5752] = {.lex_state = 11, .external_lex_state = 2},
  [5753] = {.lex_state = 11, .external_lex_state = 2},
  [5754] = {.lex_state = 11, .external_lex_state = 2},
  [5755] = {.lex_state = 11, .external_lex_state = 2},
  [5756] = {.lex_state = 95, .external_lex_state = 2},
  [5757] = {.lex_state = 11, .external_lex_state = 2},
  [5758] = {.lex_state = 95, .external_lex_state = 2},
  [5759] = {.lex_state = 11, .external_lex_state = 2},
  [5760] = {.lex_state = 11, .external_lex_state = 2},
  [5761] = {.lex_state = 11, .external_lex_state = 2},
  [5762] = {.lex_state = 95, .external_lex_state = 5},
  [5763] = {.lex_state = 95, .external_lex_state = 5},
  [5764] = {.lex_state = 95, .external_lex_state = 5},
  [5765] = {.lex_state = 11, .external_lex_state = 2},
  [5766] = {.lex_state = 11, .external_lex_state = 2},
  [5767] = {.lex_state = 95, .external_lex_state = 5},
  [5768] = {.lex_state = 95, .external_lex_state = 5},
  [5769] = {.lex_state = 11, .external_lex_state = 2},
  [5770] = {.lex_state = 11, .external_lex_state = 2},
  [5771] = {.lex_state = 11, .external_lex_state = 2},
  [5772] = {.lex_state = 95, .external_lex_state = 2},
  [5773] = {.lex_state = 95, .external_lex_state = 2},
  [5774] = {.lex_state = 95, .external_lex_state = 2},
  [5775] = {.lex_state = 11, .external_lex_state = 2},
  [5776] = {.lex_state = 95, .external_lex_state = 2},
  [5777] = {.lex_state = 95, .external_lex_state = 2},
  [5778] = {.lex_state = 95, .external_lex_state = 2},
  [5779] = {.lex_state = 95, .external_lex_state = 2},
  [5780] = {.lex_state = 11, .external_lex_state = 2},
  [5781] = {.lex_state = 11, .external_lex_state = 2},
  [5782] = {.lex_state = 11, .external_lex_state = 2},
  [5783] = {.lex_state = 11, .external_lex_state = 2},
  [5784] = {.lex_state = 95, .external_lex_state = 2},
  [5785] = {.lex_state = 95, .external_lex_state = 2},
  [5786] = {.lex_state = 11, .external_lex_state = 2},
  [5787] = {.lex_state = 11, .external_lex_state = 2},
  [5788] = {.lex_state = 11, .external_lex_state = 2},
  [5789] = {.lex_state = 95, .external_lex_state = 2},
  [5790] = {.lex_state = 11, .external_lex_state = 2},
  [5791] = {.lex_state = 95, .external_lex_state = 2},
  [5792] = {.lex_state = 95, .external_lex_state = 2},
  [5793] = {.lex_state = 11, .external_lex_state = 2},
  [5794] = {.lex_state = 11, .external_lex_state = 2},
  [5795] = {.lex_state = 95, .external_lex_state = 5},
  [5796] = {.lex_state = 95, .external_lex_state = 5},
  [5797] = {.lex_state = 11, .external_lex_state = 2},
  [5798] = {.lex_state = 95, .external_lex_state = 5},
  [5799] = {.lex_state = 95, .external_lex_state = 5},
  [5800] = {.lex_state = 95, .external_lex_state = 5},
  [5801] = {.lex_state = 11, .external_lex_state = 2},
  [5802] = {.lex_state = 11, .external_lex_state = 2},
  [5803] = {.lex_state = 95, .external_lex_state = 2},
  [5804] = {.lex_state = 11, .external_lex_state = 2},
  [5805] = {.lex_state = 95, .external_lex_state = 2},
  [5806] = {.lex_state = 95, .external_lex_state = 2},
  [5807] = {.lex_state = 95, .external_lex_state = 5},
  [5808] = {.lex_state = 95, .external_lex_state = 2},
  [5809] = {.lex_state = 95, .external_lex_state = 2},
  [5810] = {.lex_state = 95, .external_lex_state = 2},
  [5811] = {.lex_state = 95, .external_lex_state = 2},
  [5812] = {.lex_state = 95, .external_lex_state = 2},
  [5813] = {.lex_state = 95, .external_lex_state = 2},
  [5814] = {.lex_state = 95, .external_lex_state = 2},
  [5815] = {.lex_state = 95, .external_lex_state = 2},
  [5816] = {.lex_state = 11, .external_lex_state = 2},
  [5817] = {.lex_state = 11, .external_lex_state = 2},
  [5818] = {.lex_state = 11, .external_lex_state = 2},
  [5819] = {.lex_state = 11, .external_lex_state = 2},
  [5820] = {.lex_state = 11, .external_lex_state = 2},
  [5821] = {.lex_state = 11, .external_lex_state = 2},
  [5822] = {.lex_state = 11, .external_lex_state = 2},
  [5823] = {.lex_state = 95, .external_lex_state = 5},
  [5824] = {.lex_state = 95, .external_lex_state = 2},
  [5825] = {.lex_state = 11, .external_lex_state = 2},
  [5826] = {.lex_state = 11, .external_lex_state = 2},
  [5827] = {.lex_state = 11, .external_lex_state = 2},
  [5828] = {.lex_state = 95, .external_lex_state = 2},
  [5829] = {.lex_state = 11, .external_lex_state = 2},
  [5830] = {.lex_state = 95, .external_lex_state = 5},
  [5831] = {.lex_state = 95, .external_lex_state = 5},
  [5832] = {.lex_state = 95, .external_lex_state = 5},
  [5833] = {.lex_state = 95, .external_lex_state = 5},
  [5834] = {.lex_state = 95, .external_lex_state = 2},
  [5835] = {.lex_state = 95, .external_lex_state = 2},
  [5836] = {.lex_state = 11, .external_lex_state = 2},
  [5837] = {.lex_state = 11, .external_lex_state = 2},
  [5838] = {.lex_state = 11, .external_lex_state = 2},
  [5839] = {.lex_state = 95, .external_lex_state = 2},
  [5840] = {.lex_state = 95, .external_lex_state = 2},
  [5841] = {.lex_state = 95, .external_lex_state = 2},
  [5842] = {.lex_state = 95, .external_lex_state = 2},
  [5843] = {.lex_state = 11, .external_lex_state = 2},
  [5844] = {.lex_state = 95, .external_lex_state = 2},
  [5845] = {.lex_state = 95, .external_lex_state = 2},
  [5846] = {.lex_state = 95, .external_lex_state = 2},
  [5847] = {.lex_state = 95, .external_lex_state = 2},
  [5848] = {.lex_state = 11, .external_lex_state = 2},
  [5849] = {.lex_state = 11, .external_lex_state = 2},
  [5850] = {.lex_state = 11, .external_lex_state = 2},
  [5851] = {.lex_state = 95, .external_lex_state = 2},
  [5852] = {.lex_state = 95, .external_lex_state = 2},
  [5853] = {.lex_state = 95, .external_lex_state = 2},
  [5854] = {.lex_state = 11, .external_lex_state = 2},
  [5855] = {.lex_state = 11, .external_lex_state = 2},
  [5856] = {.lex_state = 11, .external_lex_state = 2},
  [5857] = {.lex_state = 95, .external_lex_state = 2},
  [5858] = {.lex_state = 11, .external_lex_state = 2},
  [5859] = {.lex_state = 11, .external_lex_state = 2},
  [5860] = {.lex_state = 11, .external_lex_state = 2},
  [5861] = {.lex_state = 95, .external_lex_state = 2},
  [5862] = {.lex_state = 95, .external_lex_state = 5},
  [5863] = {.lex_state = 95, .external_lex_state = 2},
  [5864] = {.lex_state = 11, .external_lex_state = 2},
  [5865] = {.lex_state = 95, .external_lex_state = 2},
  [5866] = {.lex_state = 11, .external_lex_state = 2},
  [5867] = {.lex_state = 95, .external_lex_state = 2},
  [5868] = {.lex_state = 95, .external_lex_state = 5},
  [5869] = {.lex_state = 95, .external_lex_state = 2},
  [5870] = {.lex_state = 95, .external_lex_state = 2},
  [5871] = {.lex_state = 95, .external_lex_state = 5},
  [5872] = {.lex_state = 11, .external_lex_state = 2},
  [5873] = {.lex_state = 95, .external_lex_state = 2},
  [5874] = {.lex_state = 95, .external_lex_state = 2},
  [5875] = {.lex_state = 95, .external_lex_state = 2},
  [5876] = {.lex_state = 95, .external_lex_state = 5},
  [5877] = {.lex_state = 95, .external_lex_state = 5},
  [5878] = {.lex_state = 95, .external_lex_state = 5},
  [5879] = {.lex_state = 95, .external_lex_state = 2},
  [5880] = {.lex_state = 95, .external_lex_state = 2},
  [5881] = {.lex_state = 95, .external_lex_state = 2},
  [5882] = {.lex_state = 95, .external_lex_state = 2},
  [5883] = {.lex_state = 95, .external_lex_state = 2},
  [5884] = {.lex_state = 95, .external_lex_state = 2},
  [5885] = {.lex_state = 95, .external_lex_state = 2},
  [5886] = {.lex_state = 95, .external_lex_state = 2},
  [5887] = {.lex_state = 95, .external_lex_state = 5},
  [5888] = {.lex_state = 95, .external_lex_state = 5},
  [5889] = {.lex_state = 95, .external_lex_state = 2},
  [5890] = {.lex_state = 95, .external_lex_state = 5},
  [5891] = {.lex_state = 95, .external_lex_state = 5},
  [5892] = {.lex_state = 95, .external_lex_state = 5},
  [5893] = {.lex_state = 95, .external_lex_state = 5},
  [5894] = {.lex_state = 11, .external_lex_state = 2},
  [5895] = {.lex_state = 11, .external_lex_state = 2},
  [5896] = {.lex_state = 95, .external_lex_state = 2},
  [5897] = {.lex_state = 11, .external_lex_state = 2},
  [5898] = {.lex_state = 95, .external_lex_state = 2},
  [5899] = {.lex_state = 11, .external_lex_state = 2},
  [5900] = {.lex_state = 11, .external_lex_state = 2},
  [5901] = {.lex_state = 11, .external_lex_state = 2},
  [5902] = {.lex_state = 11, .external_lex_state = 2},
  [5903] = {.lex_state = 11, .external_lex_state = 2},
  [5904] = {.lex_state = 11, .external_lex_state = 2},
  [5905] = {.lex_state = 95, .external_lex_state = 2},
  [5906] = {.lex_state = 11, .external_lex_state = 2},
  [5907] = {.lex_state = 95, .external_lex_state = 2},
  [5908] = {.lex_state = 11, .external_lex_state = 2},
  [5909] = {.lex_state = 11, .external_lex_state = 2},
  [5910] = {.lex_state = 11, .external_lex_state = 2},
  [5911] = {.lex_state = 11, .external_lex_state = 2},
  [5912] = {.lex_state = 11, .external_lex_state = 2},
  [5913] = {.lex_state = 11, .external_lex_state = 2},
  [5914] = {.lex_state = 11, .external_lex_state = 2},
  [5915] = {.lex_state = 11, .external_lex_state = 2},
  [5916] = {.lex_state = 11, .external_lex_state = 2},
  [5917] = {.lex_state = 11, .external_lex_state = 2},
  [5918] = {.lex_state = 11, .external_lex_state = 2},
  [5919] = {.lex_state = 95, .external_lex_state = 2},
  [5920] = {.lex_state = 11, .external_lex_state = 2},
  [5921] = {.lex_state = 95, .external_lex_state = 2},
  [5922] = {.lex_state = 11, .external_lex_state = 2},
  [5923] = {.lex_state = 11, .external_lex_state = 2},
  [5924] = {.lex_state = 11, .external_lex_state = 2},
  [5925] = {.lex_state = 11, .external_lex_state = 2},
  [5926] = {.lex_state = 11, .external_lex_state = 2},
  [5927] = {.lex_state = 11, .external_lex_state = 2},
  [5928] = {.lex_state = 11, .external_lex_state = 2},
  [5929] = {.lex_state = 11, .external_lex_state = 2},
  [5930] = {.lex_state = 11, .external_lex_state = 2},
  [5931] = {.lex_state = 11, .external_lex_state = 2},
  [5932] = {.lex_state = 11, .external_lex_state = 2},
  [5933] = {.lex_state = 95, .external_lex_state = 2},
  [5934] = {.lex_state = 11, .external_lex_state = 2},
  [5935] = {.lex_state = 95, .external_lex_state = 2},
  [5936] = {.lex_state = 11, .external_lex_state = 2},
  [5937] = {.lex_state = 95, .external_lex_state = 2},
  [5938] = {.lex_state = 95, .external_lex_state = 2},
  [5939] = {.lex_state = 95, .external_lex_state = 2},
  [5940] = {.lex_state = 95, .external_lex_state = 2},
  [5941] = {.lex_state = 95, .external_lex_state = 2},
  [5942] = {.lex_state = 95, .external_lex_state = 2},
  [5943] = {.lex_state = 95, .external_lex_state = 2},
  [5944] = {.lex_state = 95, .external_lex_state = 2},
  [5945] = {.lex_state = 95, .external_lex_state = 2},
  [5946] = {.lex_state = 95, .external_lex_state = 2},
  [5947] = {.lex_state = 95, .external_lex_state = 2},
  [5948] = {.lex_state = 95, .external_lex_state = 2},
  [5949] = {.lex_state = 95, .external_lex_state = 2},
  [5950] = {.lex_state = 95, .external_lex_state = 2},
  [5951] = {.lex_state = 95, .external_lex_state = 2},
  [5952] = {.lex_state = 95, .external_lex_state = 2},
  [5953] = {.lex_state = 95, .external_lex_state = 2},
  [5954] = {.lex_state = 95, .external_lex_state = 2},
  [5955] = {.lex_state = 95, .external_lex_state = 2},
  [5956] = {.lex_state = 95, .external_lex_state = 2},
  [5957] = {.lex_state = 95, .external_lex_state = 2},
  [5958] = {.lex_state = 6, .external_lex_state = 2},
  [5959] = {.lex_state = 95, .external_lex_state = 2},
  [5960] = {.lex_state = 2, .external_lex_state = 10},
  [5961] = {.lex_state = 95, .external_lex_state = 2},
  [5962] = {.lex_state = 95, .external_lex_state = 2},
  [5963] = {.lex_state = 95, .external_lex_state = 2},
  [5964] = {.lex_state = 95, .external_lex_state = 2},
  [5965] = {.lex_state = 95, .external_lex_state = 2},
  [5966] = {.lex_state = 95, .external_lex_state = 2},
  [5967] = {.lex_state = 95, .external_lex_state = 2},
  [5968] = {.lex_state = 95, .external_lex_state = 2},
  [5969] = {.lex_state = 95, .external_lex_state = 2},
  [5970] = {.lex_state = 95, .external_lex_state = 2},
  [5971] = {.lex_state = 95, .external_lex_state = 2},
  [5972] = {.lex_state = 95, .external_lex_state = 2},
  [5973] = {.lex_state = 95, .external_lex_state = 2},
  [5974] = {.lex_state = 95, .external_lex_state = 2},
  [5975] = {.lex_state = 95, .external_lex_state = 2},
  [5976] = {.lex_state = 95, .external_lex_state = 2},
  [5977] = {.lex_state = 95, .external_lex_state = 2},
  [5978] = {.lex_state = 95, .external_lex_state = 2},
  [5979] = {.lex_state = 95, .external_lex_state = 2},
  [5980] = {.lex_state = 95, .external_lex_state = 2},
  [5981] = {.lex_state = 95, .external_lex_state = 2},
  [5982] = {.lex_state = 95, .external_lex_state = 2},
  [5983] = {.lex_state = 95, .external_lex_state = 2},
  [5984] = {.lex_state = 95, .external_lex_state = 2},
  [5985] = {.lex_state = 95, .external_lex_state = 2},
  [5986] = {.lex_state = 95, .external_lex_state = 2},
  [5987] = {.lex_state = 95, .external_lex_state = 2},
  [5988] = {.lex_state = 95, .external_lex_state = 2},
  [5989] = {.lex_state = 28, .external_lex_state = 2},
  [5990] = {.lex_state = 95, .external_lex_state = 2},
  [5991] = {.lex_state = 95, .external_lex_state = 2},
  [5992] = {.lex_state = 95, .external_lex_state = 2},
  [5993] = {.lex_state = 95, .external_lex_state = 2},
  [5994] = {.lex_state = 95, .external_lex_state = 2},
  [5995] = {.lex_state = 95, .external_lex_state = 2},
  [5996] = {.lex_state = 95, .external_lex_state = 2},
  [5997] = {.lex_state = 95, .external_lex_state = 2},
  [5998] = {.lex_state = 95, .external_lex_state = 2},
  [5999] = {.lex_state = 95, .external_lex_state = 2},
  [6000] = {.lex_state = 95, .external_lex_state = 2},
  [6001] = {.lex_state = 95, .external_lex_state = 2},
  [6002] = {.lex_state = 95, .external_lex_state = 2},
  [6003] = {.lex_state = 95, .external_lex_state = 2},
  [6004] = {.lex_state = 95, .external_lex_state = 2},
  [6005] = {.lex_state = 95, .external_lex_state = 2},
  [6006] = {.lex_state = 95, .external_lex_state = 2},
  [6007] = {.lex_state = 95, .external_lex_state = 2},
  [6008] = {.lex_state = 95, .external_lex_state = 2},
  [6009] = {.lex_state = 95, .external_lex_state = 2},
  [6010] = {.lex_state = 95, .external_lex_state = 2},
  [6011] = {.lex_state = 95, .external_lex_state = 2},
  [6012] = {.lex_state = 95, .external_lex_state = 2},
  [6013] = {.lex_state = 95, .external_lex_state = 2},
  [6014] = {.lex_state = 95, .external_lex_state = 2},
  [6015] = {.lex_state = 95, .external_lex_state = 2},
  [6016] = {.lex_state = 95, .external_lex_state = 2},
  [6017] = {.lex_state = 95, .external_lex_state = 2},
  [6018] = {.lex_state = 95, .external_lex_state = 2},
  [6019] = {.lex_state = 95, .external_lex_state = 2},
  [6020] = {.lex_state = 95, .external_lex_state = 2},
  [6021] = {.lex_state = 95, .external_lex_state = 2},
  [6022] = {.lex_state = 95, .external_lex_state = 2},
  [6023] = {.lex_state = 95, .external_lex_state = 2},
  [6024] = {.lex_state = 95, .external_lex_state = 2},
  [6025] = {.lex_state = 95, .external_lex_state = 2},
  [6026] = {.lex_state = 95, .external_lex_state = 2},
  [6027] = {.lex_state = 95, .external_lex_state = 2},
  [6028] = {.lex_state = 95, .external_lex_state = 2},
  [6029] = {.lex_state = 95, .external_lex_state = 2},
  [6030] = {.lex_state = 95, .external_lex_state = 2},
  [6031] = {.lex_state = 95, .external_lex_state = 2},
  [6032] = {.lex_state = 95, .external_lex_state = 2},
  [6033] = {.lex_state = 95, .external_lex_state = 2},
  [6034] = {.lex_state = 95, .external_lex_state = 2},
  [6035] = {.lex_state = 95, .external_lex_state = 2},
  [6036] = {.lex_state = 95, .external_lex_state = 2},
  [6037] = {.lex_state = 95, .external_lex_state = 2},
  [6038] = {.lex_state = 95, .external_lex_state = 2},
  [6039] = {.lex_state = 95, .external_lex_state = 2},
  [6040] = {.lex_state = 95, .external_lex_state = 2},
  [6041] = {.lex_state = 95, .external_lex_state = 2},
  [6042] = {.lex_state = 95, .external_lex_state = 2},
  [6043] = {.lex_state = 95, .external_lex_state = 2},
  [6044] = {.lex_state = 95, .external_lex_state = 2},
  [6045] = {.lex_state = 95, .external_lex_state = 2},
  [6046] = {.lex_state = 95, .external_lex_state = 2},
  [6047] = {.lex_state = 95, .external_lex_state = 2},
  [6048] = {.lex_state = 95, .external_lex_state = 2},
  [6049] = {.lex_state = 95, .external_lex_state = 2},
  [6050] = {.lex_state = 95, .external_lex_state = 2},
  [6051] = {.lex_state = 95, .external_lex_state = 2},
  [6052] = {.lex_state = 95, .external_lex_state = 2},
  [6053] = {.lex_state = 95, .external_lex_state = 2},
  [6054] = {.lex_state = 95, .external_lex_state = 2},
  [6055] = {.lex_state = 95, .external_lex_state = 2},
  [6056] = {.lex_state = 95, .external_lex_state = 2},
  [6057] = {.lex_state = 95, .external_lex_state = 2},
  [6058] = {.lex_state = 95, .external_lex_state = 2},
  [6059] = {.lex_state = 95, .external_lex_state = 2},
  [6060] = {.lex_state = 95, .external_lex_state = 2},
  [6061] = {.lex_state = 95, .external_lex_state = 2},
  [6062] = {.lex_state = 95, .external_lex_state = 2},
  [6063] = {.lex_state = 95, .external_lex_state = 2},
  [6064] = {.lex_state = 95, .external_lex_state = 2},
  [6065] = {.lex_state = 95, .external_lex_state = 2},
  [6066] = {.lex_state = 6, .external_lex_state = 2},
  [6067] = {.lex_state = 95, .external_lex_state = 2},
  [6068] = {.lex_state = 2, .external_lex_state = 10},
  [6069] = {.lex_state = 95, .external_lex_state = 2},
  [6070] = {.lex_state = 95, .external_lex_state = 2},
  [6071] = {.lex_state = 2, .external_lex_state = 10},
  [6072] = {.lex_state = 95, .external_lex_state = 2},
  [6073] = {.lex_state = 95, .external_lex_state = 2},
  [6074] = {.lex_state = 95, .external_lex_state = 2},
  [6075] = {.lex_state = 95, .external_lex_state = 2},
  [6076] = {.lex_state = 6, .external_lex_state = 2},
  [6077] = {.lex_state = 95, .external_lex_state = 2},
  [6078] = {.lex_state = 95, .external_lex_state = 2},
  [6079] = {.lex_state = 95, .external_lex_state = 2},
  [6080] = {.lex_state = 95, .external_lex_state = 2},
  [6081] = {.lex_state = 95, .external_lex_state = 2},
  [6082] = {.lex_state = 95, .external_lex_state = 2},
  [6083] = {.lex_state = 95, .external_lex_state = 2},
  [6084] = {.lex_state = 95, .external_lex_state = 2},
  [6085] = {.lex_state = 95, .external_lex_state = 2},
  [6086] = {.lex_state = 95, .external_lex_state = 2},
  [6087] = {.lex_state = 95, .external_lex_state = 2},
  [6088] = {.lex_state = 95, .external_lex_state = 2},
  [6089] = {.lex_state = 95, .external_lex_state = 2},
  [6090] = {.lex_state = 95, .external_lex_state = 2},
  [6091] = {.lex_state = 95, .external_lex_state = 2},
  [6092] = {.lex_state = 95, .external_lex_state = 2},
  [6093] = {.lex_state = 28, .external_lex_state = 2},
  [6094] = {.lex_state = 95, .external_lex_state = 2},
  [6095] = {.lex_state = 95, .external_lex_state = 2},
  [6096] = {.lex_state = 95, .external_lex_state = 2},
  [6097] = {.lex_state = 95, .external_lex_state = 2},
  [6098] = {.lex_state = 95, .external_lex_state = 2},
  [6099] = {.lex_state = 6, .external_lex_state = 2},
  [6100] = {.lex_state = 95, .external_lex_state = 2},
  [6101] = {.lex_state = 2, .external_lex_state = 10},
  [6102] = {.lex_state = 95, .external_lex_state = 2},
  [6103] = {.lex_state = 95, .external_lex_state = 2},
  [6104] = {.lex_state = 95, .external_lex_state = 2},
  [6105] = {.lex_state = 95, .external_lex_state = 2},
  [6106] = {.lex_state = 95, .external_lex_state = 2},
  [6107] = {.lex_state = 95, .external_lex_state = 2},
  [6108] = {.lex_state = 95, .external_lex_state = 2},
  [6109] = {.lex_state = 95, .external_lex_state = 2},
  [6110] = {.lex_state = 95, .external_lex_state = 2},
  [6111] = {.lex_state = 95, .external_lex_state = 2},
  [6112] = {.lex_state = 95, .external_lex_state = 2},
  [6113] = {.lex_state = 95, .external_lex_state = 2},
  [6114] = {.lex_state = 95, .external_lex_state = 2},
  [6115] = {.lex_state = 95, .external_lex_state = 2},
  [6116] = {.lex_state = 95, .external_lex_state = 2},
  [6117] = {.lex_state = 95, .external_lex_state = 2},
  [6118] = {.lex_state = 95, .external_lex_state = 2},
  [6119] = {.lex_state = 95, .external_lex_state = 2},
  [6120] = {.lex_state = 95, .external_lex_state = 2},
  [6121] = {.lex_state = 95, .external_lex_state = 2},
  [6122] = {.lex_state = 95, .external_lex_state = 2},
  [6123] = {.lex_state = 6, .external_lex_state = 2},
  [6124] = {.lex_state = 95, .external_lex_state = 2},
  [6125] = {.lex_state = 95, .external_lex_state = 2},
  [6126] = {.lex_state = 95, .external_lex_state = 2},
  [6127] = {.lex_state = 95, .external_lex_state = 2},
  [6128] = {.lex_state = 95, .external_lex_state = 2},
  [6129] = {.lex_state = 95, .external_lex_state = 2},
  [6130] = {.lex_state = 95, .external_lex_state = 2},
  [6131] = {.lex_state = 95, .external_lex_state = 2},
  [6132] = {.lex_state = 95, .external_lex_state = 2},
  [6133] = {.lex_state = 95, .external_lex_state = 2},
  [6134] = {.lex_state = 95, .external_lex_state = 2},
  [6135] = {.lex_state = 95, .external_lex_state = 2},
  [6136] = {.lex_state = 95, .external_lex_state = 2},
  [6137] = {.lex_state = 95, .external_lex_state = 2},
  [6138] = {.lex_state = 95, .external_lex_state = 2},
  [6139] = {.lex_state = 95, .external_lex_state = 2},
  [6140] = {.lex_state = 95, .external_lex_state = 2},
  [6141] = {.lex_state = 95, .external_lex_state = 2},
  [6142] = {.lex_state = 95, .external_lex_state = 2},
  [6143] = {.lex_state = 95, .external_lex_state = 2},
  [6144] = {.lex_state = 95, .external_lex_state = 2},
  [6145] = {.lex_state = 95, .external_lex_state = 2},
  [6146] = {.lex_state = 95, .external_lex_state = 2},
  [6147] = {.lex_state = 95, .external_lex_state = 2},
  [6148] = {.lex_state = 95, .external_lex_state = 2},
  [6149] = {.lex_state = 95, .external_lex_state = 2},
  [6150] = {.lex_state = 95, .external_lex_state = 2},
  [6151] = {.lex_state = 95, .external_lex_state = 2},
  [6152] = {.lex_state = 95, .external_lex_state = 2},
  [6153] = {.lex_state = 95, .external_lex_state = 2},
  [6154] = {.lex_state = 95, .external_lex_state = 2},
  [6155] = {.lex_state = 95, .external_lex_state = 2},
  [6156] = {.lex_state = 95, .external_lex_state = 2},
  [6157] = {.lex_state = 95, .external_lex_state = 2},
  [6158] = {.lex_state = 95, .external_lex_state = 2},
  [6159] = {.lex_state = 95, .external_lex_state = 2},
  [6160] = {.lex_state = 95, .external_lex_state = 2},
  [6161] = {.lex_state = 95, .external_lex_state = 2},
  [6162] = {.lex_state = 95, .external_lex_state = 2},
  [6163] = {.lex_state = 95, .external_lex_state = 2},
  [6164] = {.lex_state = 95, .external_lex_state = 2},
  [6165] = {.lex_state = 95, .external_lex_state = 2},
  [6166] = {.lex_state = 95, .external_lex_state = 2},
  [6167] = {.lex_state = 95, .external_lex_state = 2},
  [6168] = {.lex_state = 95, .external_lex_state = 2},
  [6169] = {.lex_state = 95, .external_lex_state = 2},
  [6170] = {.lex_state = 95, .external_lex_state = 2},
  [6171] = {.lex_state = 95, .external_lex_state = 2},
  [6172] = {.lex_state = 95, .external_lex_state = 2},
  [6173] = {.lex_state = 95, .external_lex_state = 2},
  [6174] = {.lex_state = 95, .external_lex_state = 2},
  [6175] = {.lex_state = 95, .external_lex_state = 2},
  [6176] = {.lex_state = 28, .external_lex_state = 2},
  [6177] = {.lex_state = 95, .external_lex_state = 2},
  [6178] = {.lex_state = 95, .external_lex_state = 2},
  [6179] = {.lex_state = 95, .external_lex_state = 2},
  [6180] = {.lex_state = 95, .external_lex_state = 2},
  [6181] = {.lex_state = 95, .external_lex_state = 2},
  [6182] = {.lex_state = 95, .external_lex_state = 2},
  [6183] = {.lex_state = 95, .external_lex_state = 2},
  [6184] = {.lex_state = 95, .external_lex_state = 2},
  [6185] = {.lex_state = 95, .external_lex_state = 2},
  [6186] = {.lex_state = 95, .external_lex_state = 2},
  [6187] = {.lex_state = 95, .external_lex_state = 2},
  [6188] = {.lex_state = 95, .external_lex_state = 2},
  [6189] = {.lex_state = 95, .external_lex_state = 2},
  [6190] = {.lex_state = 95, .external_lex_state = 2},
  [6191] = {.lex_state = 95, .external_lex_state = 2},
  [6192] = {.lex_state = 95, .external_lex_state = 2},
  [6193] = {.lex_state = 95, .external_lex_state = 2},
  [6194] = {.lex_state = 95, .external_lex_state = 2},
  [6195] = {.lex_state = 95, .external_lex_state = 2},
  [6196] = {.lex_state = 95, .external_lex_state = 2},
  [6197] = {.lex_state = 95, .external_lex_state = 2},
  [6198] = {.lex_state = 95, .external_lex_state = 2},
  [6199] = {.lex_state = 95, .external_lex_state = 2},
  [6200] = {.lex_state = 95, .external_lex_state = 2},
  [6201] = {.lex_state = 95, .external_lex_state = 2},
  [6202] = {.lex_state = 95, .external_lex_state = 2},
  [6203] = {.lex_state = 95, .external_lex_state = 2},
  [6204] = {.lex_state = 95, .external_lex_state = 2},
  [6205] = {.lex_state = 95, .external_lex_state = 2},
  [6206] = {.lex_state = 95, .external_lex_state = 2},
  [6207] = {.lex_state = 95, .external_lex_state = 2},
  [6208] = {.lex_state = 95, .external_lex_state = 2},
  [6209] = {.lex_state = 95, .external_lex_state = 2},
  [6210] = {.lex_state = 95, .external_lex_state = 2},
  [6211] = {.lex_state = 11, .external_lex_state = 2},
  [6212] = {.lex_state = 95, .external_lex_state = 2},
  [6213] = {.lex_state = 95, .external_lex_state = 2},
  [6214] = {.lex_state = 95, .external_lex_state = 2},
  [6215] = {.lex_state = 95, .external_lex_state = 2},
  [6216] = {.lex_state = 95, .external_lex_state = 2},
  [6217] = {.lex_state = 95, .external_lex_state = 2},
  [6218] = {.lex_state = 95, .external_lex_state = 2},
  [6219] = {.lex_state = 95, .external_lex_state = 2},
  [6220] = {.lex_state = 95, .external_lex_state = 2},
  [6221] = {.lex_state = 95, .external_lex_state = 2},
  [6222] = {.lex_state = 95, .external_lex_state = 2},
  [6223] = {.lex_state = 95, .external_lex_state = 2},
  [6224] = {.lex_state = 95, .external_lex_state = 2},
  [6225] = {.lex_state = 95, .external_lex_state = 2},
  [6226] = {.lex_state = 95, .external_lex_state = 2},
  [6227] = {.lex_state = 95, .external_lex_state = 2},
  [6228] = {.lex_state = 95, .external_lex_state = 2},
  [6229] = {.lex_state = 95, .external_lex_state = 2},
  [6230] = {.lex_state = 95, .external_lex_state = 2},
  [6231] = {.lex_state = 95, .external_lex_state = 2},
  [6232] = {.lex_state = 95, .external_lex_state = 2},
  [6233] = {.lex_state = 95, .external_lex_state = 2},
  [6234] = {.lex_state = 95, .external_lex_state = 2},
  [6235] = {.lex_state = 95, .external_lex_state = 2},
  [6236] = {.lex_state = 95, .external_lex_state = 2},
  [6237] = {.lex_state = 95, .external_lex_state = 2},
  [6238] = {.lex_state = 95, .external_lex_state = 2},
  [6239] = {.lex_state = 95, .external_lex_state = 2},
  [6240] = {.lex_state = 95, .external_lex_state = 2},
  [6241] = {.lex_state = 95, .external_lex_state = 2},
  [6242] = {.lex_state = 95, .external_lex_state = 2},
  [6243] = {.lex_state = 95, .external_lex_state = 2},
  [6244] = {.lex_state = 95, .external_lex_state = 2},
  [6245] = {.lex_state = 11, .external_lex_state = 2},
  [6246] = {.lex_state = 95, .external_lex_state = 2},
  [6247] = {.lex_state = 95, .external_lex_state = 2},
  [6248] = {.lex_state = 95, .external_lex_state = 2},
  [6249] = {.lex_state = 95, .external_lex_state = 2},
  [6250] = {.lex_state = 95, .external_lex_state = 2},
  [6251] = {.lex_state = 95, .external_lex_state = 2},
  [6252] = {.lex_state = 95, .external_lex_state = 2},
  [6253] = {.lex_state = 95, .external_lex_state = 2},
  [6254] = {.lex_state = 95, .external_lex_state = 2},
  [6255] = {.lex_state = 95, .external_lex_state = 2},
  [6256] = {.lex_state = 95, .external_lex_state = 2},
  [6257] = {.lex_state = 95, .external_lex_state = 2},
  [6258] = {.lex_state = 95, .external_lex_state = 2},
  [6259] = {.lex_state = 95, .external_lex_state = 2},
  [6260] = {.lex_state = 95, .external_lex_state = 2},
  [6261] = {.lex_state = 95, .external_lex_state = 2},
  [6262] = {.lex_state = 28, .external_lex_state = 2},
  [6263] = {.lex_state = 95, .external_lex_state = 2},
  [6264] = {.lex_state = 95, .external_lex_state = 2},
  [6265] = {.lex_state = 95, .external_lex_state = 2},
  [6266] = {.lex_state = 95, .external_lex_state = 2},
  [6267] = {.lex_state = 95, .external_lex_state = 2},
  [6268] = {.lex_state = 95, .external_lex_state = 2},
  [6269] = {.lex_state = 11, .external_lex_state = 2},
  [6270] = {.lex_state = 95, .external_lex_state = 2},
  [6271] = {.lex_state = 95, .external_lex_state = 2},
  [6272] = {.lex_state = 95, .external_lex_state = 2},
  [6273] = {.lex_state = 95, .external_lex_state = 2},
  [6274] = {.lex_state = 95, .external_lex_state = 2},
  [6275] = {.lex_state = 95, .external_lex_state = 2},
  [6276] = {.lex_state = 95, .external_lex_state = 2},
  [6277] = {.lex_state = 95, .external_lex_state = 2},
  [6278] = {.lex_state = 95, .external_lex_state = 2},
  [6279] = {.lex_state = 95, .external_lex_state = 2},
  [6280] = {.lex_state = 95, .external_lex_state = 2},
  [6281] = {.lex_state = 95, .external_lex_state = 2},
  [6282] = {.lex_state = 95, .external_lex_state = 2},
  [6283] = {.lex_state = 95, .external_lex_state = 2},
  [6284] = {.lex_state = 95, .external_lex_state = 2},
  [6285] = {.lex_state = 95, .external_lex_state = 2},
  [6286] = {.lex_state = 95, .external_lex_state = 2},
  [6287] = {.lex_state = 95, .external_lex_state = 2},
  [6288] = {.lex_state = 95, .external_lex_state = 2},
  [6289] = {.lex_state = 95, .external_lex_state = 2},
  [6290] = {.lex_state = 95, .external_lex_state = 2},
  [6291] = {.lex_state = 95, .external_lex_state = 2},
  [6292] = {.lex_state = 95, .external_lex_state = 2},
  [6293] = {.lex_state = 95, .external_lex_state = 2},
  [6294] = {.lex_state = 95, .external_lex_state = 2},
  [6295] = {.lex_state = 95, .external_lex_state = 2},
  [6296] = {.lex_state = 95, .external_lex_state = 2},
  [6297] = {.lex_state = 95, .external_lex_state = 2},
  [6298] = {.lex_state = 95, .external_lex_state = 2},
  [6299] = {.lex_state = 95, .external_lex_state = 2},
  [6300] = {.lex_state = 95, .external_lex_state = 2},
  [6301] = {.lex_state = 95, .external_lex_state = 2},
  [6302] = {.lex_state = 95, .external_lex_state = 2},
  [6303] = {.lex_state = 2, .external_lex_state = 10},
  [6304] = {.lex_state = 95, .external_lex_state = 2},
  [6305] = {.lex_state = 95, .external_lex_state = 2},
  [6306] = {.lex_state = 95, .external_lex_state = 2},
  [6307] = {.lex_state = 95, .external_lex_state = 2},
  [6308] = {.lex_state = 95, .external_lex_state = 2},
  [6309] = {.lex_state = 95, .external_lex_state = 2},
  [6310] = {.lex_state = 95, .external_lex_state = 2},
  [6311] = {.lex_state = 95, .external_lex_state = 2},
  [6312] = {.lex_state = 95, .external_lex_state = 2},
  [6313] = {.lex_state = 95, .external_lex_state = 2},
  [6314] = {.lex_state = 95, .external_lex_state = 2},
  [6315] = {.lex_state = 95, .external_lex_state = 2},
  [6316] = {.lex_state = 95, .external_lex_state = 2},
  [6317] = {.lex_state = 95, .external_lex_state = 2},
  [6318] = {.lex_state = 95, .external_lex_state = 2},
  [6319] = {.lex_state = 95, .external_lex_state = 2},
  [6320] = {.lex_state = 28, .external_lex_state = 2},
  [6321] = {.lex_state = 95, .external_lex_state = 2},
  [6322] = {.lex_state = 95, .external_lex_state = 2},
  [6323] = {.lex_state = 6, .external_lex_state = 2},
  [6324] = {.lex_state = 95, .external_lex_state = 2},
  [6325] = {.lex_state = 95, .external_lex_state = 2},
  [6326] = {.lex_state = 95, .external_lex_state = 2},
  [6327] = {.lex_state = 95, .external_lex_state = 2},
  [6328] = {.lex_state = 95, .external_lex_state = 2},
  [6329] = {.lex_state = 95, .external_lex_state = 2},
  [6330] = {.lex_state = 95, .external_lex_state = 2},
  [6331] = {.lex_state = 6, .external_lex_state = 2},
  [6332] = {.lex_state = 13, .external_lex_state = 2},
  [6333] = {.lex_state = 95, .external_lex_state = 2},
  [6334] = {.lex_state = 95, .external_lex_state = 2},
  [6335] = {.lex_state = 95, .external_lex_state = 2},
  [6336] = {.lex_state = 95, .external_lex_state = 2},
  [6337] = {.lex_state = 95, .external_lex_state = 2},
  [6338] = {.lex_state = 95, .external_lex_state = 2},
  [6339] = {.lex_state = 95, .external_lex_state = 2},
  [6340] = {.lex_state = 95, .external_lex_state = 2},
  [6341] = {.lex_state = 95, .external_lex_state = 2},
  [6342] = {.lex_state = 95, .external_lex_state = 2},
  [6343] = {.lex_state = 95, .external_lex_state = 2},
  [6344] = {.lex_state = 95, .external_lex_state = 2},
  [6345] = {.lex_state = 95, .external_lex_state = 2},
  [6346] = {.lex_state = 95, .external_lex_state = 2},
  [6347] = {.lex_state = 95, .external_lex_state = 2},
  [6348] = {.lex_state = 95, .external_lex_state = 2},
  [6349] = {.lex_state = 95, .external_lex_state = 2},
  [6350] = {.lex_state = 95, .external_lex_state = 2},
  [6351] = {.lex_state = 95, .external_lex_state = 2},
  [6352] = {.lex_state = 95, .external_lex_state = 2},
  [6353] = {.lex_state = 95, .external_lex_state = 2},
  [6354] = {.lex_state = 95, .external_lex_state = 2},
  [6355] = {.lex_state = 95, .external_lex_state = 2},
  [6356] = {.lex_state = 95, .external_lex_state = 2},
  [6357] = {.lex_state = 95, .external_lex_state = 2},
  [6358] = {.lex_state = 95, .external_lex_state = 2},
  [6359] = {.lex_state = 95, .external_lex_state = 2},
  [6360] = {(TSStateId)(-1)},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_comment] = STATE(0),
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [sym_hash_bang_line] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_typeof] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_debugger] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LTtemplate_GT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_QMARK_DOT] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_using] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK] = ACTIONS(1),
    [anon_sym_instanceof] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [anon_sym_SLASH2] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [sym_private_property_identifier] = ACTIONS(1),
    [anon_sym_target] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [sym_undefined] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_readonly] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_override] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_any] = ACTIONS(1),
    [anon_sym_number] = ACTIONS(1),
    [anon_sym_boolean] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_symbol] = ACTIONS(1),
    [anon_sym_object] = ACTIONS(1),
    [anon_sym_property] = ACTIONS(1),
    [anon_sym_signal] = ACTIONS(1),
    [anon_sym_on] = ACTIONS(1),
    [anon_sym_required] = ACTIONS(1),
    [anon_sym_component] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_satisfies] = ACTIONS(1),
    [anon_sym_require] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_implements] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_DASH_QMARK_COLON] = ACTIONS(1),
    [anon_sym_PLUS_QMARK_COLON] = ACTIONS(1),
    [anon_sym_asserts] = ACTIONS(1),
    [anon_sym_infer] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_keyof] = ACTIONS(1),
    [anon_sym_unique] = ACTIONS(1),
    [anon_sym_unknown] = ACTIONS(1),
    [anon_sym_never] = ACTIONS(1),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1),
    [anon_sym_pragma] = ACTIONS(1),
    [aux_sym_ui_version_specifier_token1] = ACTIONS(1),
    [anon_sym_list] = ACTIONS(1),
    [sym__automatic_semicolon] = ACTIONS(1),
    [sym__template_chars] = ACTIONS(1),
    [sym__ternary_qmark] = ACTIONS(1),
    [sym_html_comment] = ACTIONS(5),
    [sym__function_signature_automatic_semicolon] = ACTIONS(1),
    [sym___error_recovery] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(6358),
    [sym_comment] = STATE(1),
    [sym_ui_pragma] = STATE(3106),
    [sym_ui_import] = STATE(3106),
    [sym_ui_object_definition] = STATE(6355),
    [sym_ui_annotated_object] = STATE(6355),
    [sym_ui_annotation] = STATE(3086),
    [sym_ui_nested_identifier] = STATE(5505),
    [aux_sym_program_repeat1] = STATE(2742),
    [aux_sym_ui_annotated_object_repeat1] = STATE(3084),
    [sym_identifier] = ACTIONS(7),
    [sym_hash_bang_line] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(13),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_let] = ACTIONS(11),
    [anon_sym_of] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(11),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_AT] = ACTIONS(17),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_readonly] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_override] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_object] = ACTIONS(11),
    [anon_sym_property] = ACTIONS(11),
    [anon_sym_signal] = ACTIONS(11),
    [anon_sym_on] = ACTIONS(11),
    [anon_sym_required] = ACTIONS(11),
    [anon_sym_component] = ACTIONS(11),
    [anon_sym_pragma] = ACTIONS(19),
    [sym_html_comment] = ACTIONS(5),
  },
  [2] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_nested_identifier] = STATE(6331),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3951),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(2642),
    [sym_comment] = STATE(2),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4333),
    [sym_pattern] = STATE(4322),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(3294),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_type_arguments] = STATE(540),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5583),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_EQ] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(32),
    [anon_sym_LBRACE] = ACTIONS(34),
    [anon_sym_COMMA] = ACTIONS(36),
    [anon_sym_typeof] = ACTIONS(39),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(23),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(48),
    [anon_sym_RPAREN] = ACTIONS(36),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(23),
    [anon_sym_COLON] = ACTIONS(36),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(54),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(64),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(68),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(72),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(80),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(82),
    [anon_sym_PLUS] = ACTIONS(84),
    [anon_sym_DASH] = ACTIONS(84),
    [anon_sym_SLASH] = ACTIONS(86),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(97),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [sym_number] = ACTIONS(102),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(106),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(110),
    [sym_false] = ACTIONS(110),
    [sym_null] = ACTIONS(110),
    [sym_undefined] = ACTIONS(112),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(23),
    [anon_sym_readonly] = ACTIONS(116),
    [anon_sym_get] = ACTIONS(23),
    [anon_sym_set] = ACTIONS(23),
    [anon_sym_QMARK] = ACTIONS(118),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_public] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(23),
    [anon_sym_protected] = ACTIONS(23),
    [anon_sym_override] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(120),
    [anon_sym_number] = ACTIONS(120),
    [anon_sym_boolean] = ACTIONS(120),
    [anon_sym_string] = ACTIONS(120),
    [anon_sym_symbol] = ACTIONS(120),
    [anon_sym_object] = ACTIONS(120),
    [anon_sym_property] = ACTIONS(23),
    [anon_sym_signal] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [anon_sym_required] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(23),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_satisfies] = ACTIONS(30),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [3] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_nested_identifier] = STATE(6331),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3951),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(2642),
    [sym_comment] = STATE(3),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4333),
    [sym_pattern] = STATE(4322),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(3294),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_type_arguments] = STATE(540),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5583),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_EQ] = ACTIONS(134),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(32),
    [anon_sym_LBRACE] = ACTIONS(34),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_typeof] = ACTIONS(39),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(23),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(48),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(23),
    [anon_sym_COLON] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(54),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(64),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(72),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(80),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(82),
    [anon_sym_PLUS] = ACTIONS(84),
    [anon_sym_DASH] = ACTIONS(84),
    [anon_sym_SLASH] = ACTIONS(86),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(97),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [sym_number] = ACTIONS(102),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(106),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(110),
    [sym_false] = ACTIONS(110),
    [sym_null] = ACTIONS(110),
    [sym_undefined] = ACTIONS(112),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(23),
    [anon_sym_readonly] = ACTIONS(116),
    [anon_sym_get] = ACTIONS(23),
    [anon_sym_set] = ACTIONS(23),
    [anon_sym_QMARK] = ACTIONS(118),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_public] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(23),
    [anon_sym_protected] = ACTIONS(23),
    [anon_sym_override] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(120),
    [anon_sym_number] = ACTIONS(120),
    [anon_sym_boolean] = ACTIONS(120),
    [anon_sym_string] = ACTIONS(120),
    [anon_sym_symbol] = ACTIONS(120),
    [anon_sym_object] = ACTIONS(120),
    [anon_sym_property] = ACTIONS(23),
    [anon_sym_signal] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [anon_sym_required] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(23),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_satisfies] = ACTIONS(30),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [4] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(905),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_object_assignment_pattern] = STATE(5126),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6280),
    [sym_spread_element] = STATE(5056),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5868),
    [sym_string] = STATE(2485),
    [sym_comment] = STATE(4),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_rest_pattern] = STATE(5126),
    [sym_method_definition] = STATE(5056),
    [sym_pair] = STATE(5056),
    [sym_pair_pattern] = STATE(5126),
    [sym__property_name] = STATE(3944),
    [sym_computed_property_name] = STATE(3955),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(231),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_accessibility_modifier] = STATE(2731),
    [sym_override_modifier] = STATE(2774),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4050),
    [aux_sym_statement_block_repeat1] = STATE(26),
    [aux_sym_object_repeat1] = STATE(5050),
    [aux_sym_object_pattern_repeat1] = STATE(4996),
    [sym_identifier] = ACTIONS(141),
    [anon_sym_export] = ACTIONS(143),
    [anon_sym_STAR] = ACTIONS(145),
    [anon_sym_type] = ACTIONS(147),
    [anon_sym_namespace] = ACTIONS(149),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_COMMA] = ACTIONS(153),
    [anon_sym_RBRACE] = ACTIONS(155),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(161),
    [anon_sym_with] = ACTIONS(163),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(167),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(173),
    [anon_sym_switch] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(161),
    [anon_sym_while] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(187),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(203),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_async] = ACTIONS(211),
    [anon_sym_function] = ACTIONS(213),
    [anon_sym_new] = ACTIONS(215),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(219),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(227),
    [sym_private_property_identifier] = ACTIONS(229),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(235),
    [anon_sym_readonly] = ACTIONS(237),
    [anon_sym_get] = ACTIONS(239),
    [anon_sym_set] = ACTIONS(239),
    [anon_sym_declare] = ACTIONS(241),
    [anon_sym_public] = ACTIONS(243),
    [anon_sym_private] = ACTIONS(243),
    [anon_sym_protected] = ACTIONS(243),
    [anon_sym_override] = ACTIONS(245),
    [anon_sym_module] = ACTIONS(247),
    [anon_sym_any] = ACTIONS(161),
    [anon_sym_number] = ACTIONS(161),
    [anon_sym_boolean] = ACTIONS(161),
    [anon_sym_string] = ACTIONS(161),
    [anon_sym_symbol] = ACTIONS(161),
    [anon_sym_object] = ACTIONS(161),
    [anon_sym_property] = ACTIONS(161),
    [anon_sym_signal] = ACTIONS(161),
    [anon_sym_on] = ACTIONS(161),
    [anon_sym_required] = ACTIONS(161),
    [anon_sym_component] = ACTIONS(161),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [5] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(905),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_object_assignment_pattern] = STATE(5126),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6280),
    [sym_spread_element] = STATE(5367),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5868),
    [sym_string] = STATE(2485),
    [sym_comment] = STATE(5),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_rest_pattern] = STATE(5126),
    [sym_method_definition] = STATE(5367),
    [sym_pair] = STATE(5367),
    [sym_pair_pattern] = STATE(5126),
    [sym__property_name] = STATE(3944),
    [sym_computed_property_name] = STATE(3955),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(231),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_accessibility_modifier] = STATE(2731),
    [sym_override_modifier] = STATE(2774),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4050),
    [aux_sym_statement_block_repeat1] = STATE(28),
    [aux_sym_object_repeat1] = STATE(5362),
    [aux_sym_object_pattern_repeat1] = STATE(4996),
    [sym_identifier] = ACTIONS(255),
    [anon_sym_export] = ACTIONS(257),
    [anon_sym_STAR] = ACTIONS(145),
    [anon_sym_type] = ACTIONS(259),
    [anon_sym_namespace] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_COMMA] = ACTIONS(153),
    [anon_sym_RBRACE] = ACTIONS(263),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(265),
    [anon_sym_with] = ACTIONS(163),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(173),
    [anon_sym_switch] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(187),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(203),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_async] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(213),
    [anon_sym_new] = ACTIONS(271),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(219),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(227),
    [sym_private_property_identifier] = ACTIONS(229),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(273),
    [anon_sym_readonly] = ACTIONS(275),
    [anon_sym_get] = ACTIONS(277),
    [anon_sym_set] = ACTIONS(277),
    [anon_sym_declare] = ACTIONS(279),
    [anon_sym_public] = ACTIONS(281),
    [anon_sym_private] = ACTIONS(281),
    [anon_sym_protected] = ACTIONS(281),
    [anon_sym_override] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_any] = ACTIONS(265),
    [anon_sym_number] = ACTIONS(265),
    [anon_sym_boolean] = ACTIONS(265),
    [anon_sym_string] = ACTIONS(265),
    [anon_sym_symbol] = ACTIONS(265),
    [anon_sym_object] = ACTIONS(265),
    [anon_sym_property] = ACTIONS(265),
    [anon_sym_signal] = ACTIONS(265),
    [anon_sym_on] = ACTIONS(265),
    [anon_sym_required] = ACTIONS(265),
    [anon_sym_component] = ACTIONS(265),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [6] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(905),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_object_assignment_pattern] = STATE(5126),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6280),
    [sym_spread_element] = STATE(5056),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5868),
    [sym_string] = STATE(2485),
    [sym_comment] = STATE(6),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_rest_pattern] = STATE(5126),
    [sym_method_definition] = STATE(5056),
    [sym_pair] = STATE(5056),
    [sym_pair_pattern] = STATE(5126),
    [sym__property_name] = STATE(3944),
    [sym_computed_property_name] = STATE(3955),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(231),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_accessibility_modifier] = STATE(2731),
    [sym_override_modifier] = STATE(2774),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4050),
    [aux_sym_statement_block_repeat1] = STATE(26),
    [aux_sym_object_repeat1] = STATE(5050),
    [aux_sym_object_pattern_repeat1] = STATE(4996),
    [sym_identifier] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_STAR] = ACTIONS(145),
    [anon_sym_type] = ACTIONS(291),
    [anon_sym_namespace] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_COMMA] = ACTIONS(153),
    [anon_sym_RBRACE] = ACTIONS(155),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(295),
    [anon_sym_with] = ACTIONS(163),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(297),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(173),
    [anon_sym_switch] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(295),
    [anon_sym_while] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(187),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(203),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_async] = ACTIONS(299),
    [anon_sym_function] = ACTIONS(213),
    [anon_sym_new] = ACTIONS(301),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(219),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(227),
    [sym_private_property_identifier] = ACTIONS(229),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(303),
    [anon_sym_readonly] = ACTIONS(305),
    [anon_sym_get] = ACTIONS(307),
    [anon_sym_set] = ACTIONS(307),
    [anon_sym_declare] = ACTIONS(309),
    [anon_sym_public] = ACTIONS(311),
    [anon_sym_private] = ACTIONS(311),
    [anon_sym_protected] = ACTIONS(311),
    [anon_sym_override] = ACTIONS(313),
    [anon_sym_module] = ACTIONS(315),
    [anon_sym_any] = ACTIONS(295),
    [anon_sym_number] = ACTIONS(295),
    [anon_sym_boolean] = ACTIONS(295),
    [anon_sym_string] = ACTIONS(295),
    [anon_sym_symbol] = ACTIONS(295),
    [anon_sym_object] = ACTIONS(295),
    [anon_sym_property] = ACTIONS(295),
    [anon_sym_signal] = ACTIONS(295),
    [anon_sym_on] = ACTIONS(295),
    [anon_sym_required] = ACTIONS(295),
    [anon_sym_component] = ACTIONS(295),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [7] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(905),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_object_assignment_pattern] = STATE(5126),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6280),
    [sym_spread_element] = STATE(5056),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5868),
    [sym_string] = STATE(2485),
    [sym_comment] = STATE(7),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_rest_pattern] = STATE(5126),
    [sym_method_definition] = STATE(5056),
    [sym_pair] = STATE(5056),
    [sym_pair_pattern] = STATE(5126),
    [sym__property_name] = STATE(3944),
    [sym_computed_property_name] = STATE(3955),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(231),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_accessibility_modifier] = STATE(2731),
    [sym_override_modifier] = STATE(2774),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4050),
    [aux_sym_statement_block_repeat1] = STATE(26),
    [aux_sym_object_repeat1] = STATE(5050),
    [aux_sym_object_pattern_repeat1] = STATE(4996),
    [sym_identifier] = ACTIONS(317),
    [anon_sym_export] = ACTIONS(319),
    [anon_sym_STAR] = ACTIONS(145),
    [anon_sym_type] = ACTIONS(321),
    [anon_sym_namespace] = ACTIONS(323),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_COMMA] = ACTIONS(153),
    [anon_sym_RBRACE] = ACTIONS(155),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(325),
    [anon_sym_with] = ACTIONS(163),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(327),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(173),
    [anon_sym_switch] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(325),
    [anon_sym_while] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(187),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(203),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_async] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(213),
    [anon_sym_new] = ACTIONS(331),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(219),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(227),
    [sym_private_property_identifier] = ACTIONS(229),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(333),
    [anon_sym_readonly] = ACTIONS(335),
    [anon_sym_get] = ACTIONS(337),
    [anon_sym_set] = ACTIONS(337),
    [anon_sym_declare] = ACTIONS(339),
    [anon_sym_public] = ACTIONS(341),
    [anon_sym_private] = ACTIONS(341),
    [anon_sym_protected] = ACTIONS(341),
    [anon_sym_override] = ACTIONS(343),
    [anon_sym_module] = ACTIONS(345),
    [anon_sym_any] = ACTIONS(325),
    [anon_sym_number] = ACTIONS(325),
    [anon_sym_boolean] = ACTIONS(325),
    [anon_sym_string] = ACTIONS(325),
    [anon_sym_symbol] = ACTIONS(325),
    [anon_sym_object] = ACTIONS(325),
    [anon_sym_property] = ACTIONS(325),
    [anon_sym_signal] = ACTIONS(325),
    [anon_sym_on] = ACTIONS(325),
    [anon_sym_required] = ACTIONS(325),
    [anon_sym_component] = ACTIONS(325),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [8] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(905),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_object_assignment_pattern] = STATE(5126),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6280),
    [sym_spread_element] = STATE(5367),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5868),
    [sym_string] = STATE(2485),
    [sym_comment] = STATE(8),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_rest_pattern] = STATE(5126),
    [sym_method_definition] = STATE(5367),
    [sym_pair] = STATE(5367),
    [sym_pair_pattern] = STATE(5126),
    [sym__property_name] = STATE(3944),
    [sym_computed_property_name] = STATE(3955),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(231),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_accessibility_modifier] = STATE(2731),
    [sym_override_modifier] = STATE(2774),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4050),
    [aux_sym_statement_block_repeat1] = STATE(17),
    [aux_sym_object_repeat1] = STATE(5362),
    [aux_sym_object_pattern_repeat1] = STATE(4996),
    [sym_identifier] = ACTIONS(255),
    [anon_sym_export] = ACTIONS(257),
    [anon_sym_STAR] = ACTIONS(145),
    [anon_sym_type] = ACTIONS(259),
    [anon_sym_namespace] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_COMMA] = ACTIONS(153),
    [anon_sym_RBRACE] = ACTIONS(347),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(265),
    [anon_sym_with] = ACTIONS(163),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(173),
    [anon_sym_switch] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(187),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(203),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_async] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(213),
    [anon_sym_new] = ACTIONS(271),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(219),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(227),
    [sym_private_property_identifier] = ACTIONS(229),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(273),
    [anon_sym_readonly] = ACTIONS(275),
    [anon_sym_get] = ACTIONS(277),
    [anon_sym_set] = ACTIONS(277),
    [anon_sym_declare] = ACTIONS(279),
    [anon_sym_public] = ACTIONS(281),
    [anon_sym_private] = ACTIONS(281),
    [anon_sym_protected] = ACTIONS(281),
    [anon_sym_override] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_any] = ACTIONS(265),
    [anon_sym_number] = ACTIONS(265),
    [anon_sym_boolean] = ACTIONS(265),
    [anon_sym_string] = ACTIONS(265),
    [anon_sym_symbol] = ACTIONS(265),
    [anon_sym_object] = ACTIONS(265),
    [anon_sym_property] = ACTIONS(265),
    [anon_sym_signal] = ACTIONS(265),
    [anon_sym_on] = ACTIONS(265),
    [anon_sym_required] = ACTIONS(265),
    [anon_sym_component] = ACTIONS(265),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [9] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(905),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_object_assignment_pattern] = STATE(5126),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6280),
    [sym_spread_element] = STATE(5367),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5868),
    [sym_string] = STATE(2485),
    [sym_comment] = STATE(9),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_rest_pattern] = STATE(5126),
    [sym_method_definition] = STATE(5367),
    [sym_pair] = STATE(5367),
    [sym_pair_pattern] = STATE(5126),
    [sym__property_name] = STATE(3944),
    [sym_computed_property_name] = STATE(3955),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(231),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_accessibility_modifier] = STATE(2731),
    [sym_override_modifier] = STATE(2774),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4050),
    [aux_sym_statement_block_repeat1] = STATE(28),
    [aux_sym_object_repeat1] = STATE(5362),
    [aux_sym_object_pattern_repeat1] = STATE(4996),
    [sym_identifier] = ACTIONS(255),
    [anon_sym_export] = ACTIONS(257),
    [anon_sym_STAR] = ACTIONS(145),
    [anon_sym_type] = ACTIONS(259),
    [anon_sym_namespace] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_COMMA] = ACTIONS(153),
    [anon_sym_RBRACE] = ACTIONS(349),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(265),
    [anon_sym_with] = ACTIONS(163),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(173),
    [anon_sym_switch] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(187),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(203),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_async] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(213),
    [anon_sym_new] = ACTIONS(271),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(219),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(227),
    [sym_private_property_identifier] = ACTIONS(229),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(273),
    [anon_sym_readonly] = ACTIONS(275),
    [anon_sym_get] = ACTIONS(277),
    [anon_sym_set] = ACTIONS(277),
    [anon_sym_declare] = ACTIONS(279),
    [anon_sym_public] = ACTIONS(281),
    [anon_sym_private] = ACTIONS(281),
    [anon_sym_protected] = ACTIONS(281),
    [anon_sym_override] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_any] = ACTIONS(265),
    [anon_sym_number] = ACTIONS(265),
    [anon_sym_boolean] = ACTIONS(265),
    [anon_sym_string] = ACTIONS(265),
    [anon_sym_symbol] = ACTIONS(265),
    [anon_sym_object] = ACTIONS(265),
    [anon_sym_property] = ACTIONS(265),
    [anon_sym_signal] = ACTIONS(265),
    [anon_sym_on] = ACTIONS(265),
    [anon_sym_required] = ACTIONS(265),
    [anon_sym_component] = ACTIONS(265),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [10] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(905),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_object_assignment_pattern] = STATE(5126),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6280),
    [sym_spread_element] = STATE(5367),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5868),
    [sym_string] = STATE(2485),
    [sym_comment] = STATE(10),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_rest_pattern] = STATE(5126),
    [sym_method_definition] = STATE(5367),
    [sym_pair] = STATE(5367),
    [sym_pair_pattern] = STATE(5126),
    [sym__property_name] = STATE(3944),
    [sym_computed_property_name] = STATE(3955),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(231),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_accessibility_modifier] = STATE(2731),
    [sym_override_modifier] = STATE(2774),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4050),
    [aux_sym_statement_block_repeat1] = STATE(29),
    [aux_sym_object_repeat1] = STATE(5362),
    [aux_sym_object_pattern_repeat1] = STATE(4996),
    [sym_identifier] = ACTIONS(255),
    [anon_sym_export] = ACTIONS(257),
    [anon_sym_STAR] = ACTIONS(145),
    [anon_sym_type] = ACTIONS(259),
    [anon_sym_namespace] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_COMMA] = ACTIONS(153),
    [anon_sym_RBRACE] = ACTIONS(351),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(265),
    [anon_sym_with] = ACTIONS(163),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(173),
    [anon_sym_switch] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(187),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(203),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_async] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(213),
    [anon_sym_new] = ACTIONS(271),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(219),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(227),
    [sym_private_property_identifier] = ACTIONS(229),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(273),
    [anon_sym_readonly] = ACTIONS(275),
    [anon_sym_get] = ACTIONS(277),
    [anon_sym_set] = ACTIONS(277),
    [anon_sym_declare] = ACTIONS(279),
    [anon_sym_public] = ACTIONS(281),
    [anon_sym_private] = ACTIONS(281),
    [anon_sym_protected] = ACTIONS(281),
    [anon_sym_override] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(285),
    [anon_sym_any] = ACTIONS(265),
    [anon_sym_number] = ACTIONS(265),
    [anon_sym_boolean] = ACTIONS(265),
    [anon_sym_string] = ACTIONS(265),
    [anon_sym_symbol] = ACTIONS(265),
    [anon_sym_object] = ACTIONS(265),
    [anon_sym_property] = ACTIONS(265),
    [anon_sym_signal] = ACTIONS(265),
    [anon_sym_on] = ACTIONS(265),
    [anon_sym_required] = ACTIONS(265),
    [anon_sym_component] = ACTIONS(265),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [11] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(905),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5868),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(11),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(231),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4050),
    [aux_sym_statement_block_repeat1] = STATE(15),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_export] = ACTIONS(355),
    [anon_sym_default] = ACTIONS(357),
    [anon_sym_type] = ACTIONS(359),
    [anon_sym_namespace] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(365),
    [anon_sym_with] = ACTIONS(163),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(367),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(173),
    [anon_sym_switch] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(187),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(357),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_async] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(213),
    [anon_sym_new] = ACTIONS(373),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(365),
    [anon_sym_readonly] = ACTIONS(365),
    [anon_sym_get] = ACTIONS(365),
    [anon_sym_set] = ACTIONS(365),
    [anon_sym_declare] = ACTIONS(379),
    [anon_sym_public] = ACTIONS(365),
    [anon_sym_private] = ACTIONS(365),
    [anon_sym_protected] = ACTIONS(365),
    [anon_sym_override] = ACTIONS(365),
    [anon_sym_module] = ACTIONS(381),
    [anon_sym_any] = ACTIONS(365),
    [anon_sym_number] = ACTIONS(365),
    [anon_sym_boolean] = ACTIONS(365),
    [anon_sym_string] = ACTIONS(365),
    [anon_sym_symbol] = ACTIONS(365),
    [anon_sym_object] = ACTIONS(365),
    [anon_sym_property] = ACTIONS(365),
    [anon_sym_signal] = ACTIONS(365),
    [anon_sym_on] = ACTIONS(365),
    [anon_sym_required] = ACTIONS(365),
    [anon_sym_component] = ACTIONS(365),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [12] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(905),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5868),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(12),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(231),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4050),
    [aux_sym_statement_block_repeat1] = STATE(14),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_export] = ACTIONS(355),
    [anon_sym_default] = ACTIONS(383),
    [anon_sym_type] = ACTIONS(359),
    [anon_sym_namespace] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(385),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(365),
    [anon_sym_with] = ACTIONS(163),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(367),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(173),
    [anon_sym_switch] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(187),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(383),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_async] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(213),
    [anon_sym_new] = ACTIONS(373),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(365),
    [anon_sym_readonly] = ACTIONS(365),
    [anon_sym_get] = ACTIONS(365),
    [anon_sym_set] = ACTIONS(365),
    [anon_sym_declare] = ACTIONS(379),
    [anon_sym_public] = ACTIONS(365),
    [anon_sym_private] = ACTIONS(365),
    [anon_sym_protected] = ACTIONS(365),
    [anon_sym_override] = ACTIONS(365),
    [anon_sym_module] = ACTIONS(381),
    [anon_sym_any] = ACTIONS(365),
    [anon_sym_number] = ACTIONS(365),
    [anon_sym_boolean] = ACTIONS(365),
    [anon_sym_string] = ACTIONS(365),
    [anon_sym_symbol] = ACTIONS(365),
    [anon_sym_object] = ACTIONS(365),
    [anon_sym_property] = ACTIONS(365),
    [anon_sym_signal] = ACTIONS(365),
    [anon_sym_on] = ACTIONS(365),
    [anon_sym_required] = ACTIONS(365),
    [anon_sym_component] = ACTIONS(365),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [13] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(905),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5868),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(13),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(231),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4050),
    [aux_sym_statement_block_repeat1] = STATE(11),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_export] = ACTIONS(355),
    [anon_sym_default] = ACTIONS(387),
    [anon_sym_type] = ACTIONS(359),
    [anon_sym_namespace] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(389),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(365),
    [anon_sym_with] = ACTIONS(163),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(367),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(173),
    [anon_sym_switch] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(187),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(387),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_async] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(213),
    [anon_sym_new] = ACTIONS(373),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(365),
    [anon_sym_readonly] = ACTIONS(365),
    [anon_sym_get] = ACTIONS(365),
    [anon_sym_set] = ACTIONS(365),
    [anon_sym_declare] = ACTIONS(379),
    [anon_sym_public] = ACTIONS(365),
    [anon_sym_private] = ACTIONS(365),
    [anon_sym_protected] = ACTIONS(365),
    [anon_sym_override] = ACTIONS(365),
    [anon_sym_module] = ACTIONS(381),
    [anon_sym_any] = ACTIONS(365),
    [anon_sym_number] = ACTIONS(365),
    [anon_sym_boolean] = ACTIONS(365),
    [anon_sym_string] = ACTIONS(365),
    [anon_sym_symbol] = ACTIONS(365),
    [anon_sym_object] = ACTIONS(365),
    [anon_sym_property] = ACTIONS(365),
    [anon_sym_signal] = ACTIONS(365),
    [anon_sym_on] = ACTIONS(365),
    [anon_sym_required] = ACTIONS(365),
    [anon_sym_component] = ACTIONS(365),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [14] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(905),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5868),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(14),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(231),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4050),
    [aux_sym_statement_block_repeat1] = STATE(15),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_export] = ACTIONS(355),
    [anon_sym_default] = ACTIONS(391),
    [anon_sym_type] = ACTIONS(359),
    [anon_sym_namespace] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(365),
    [anon_sym_with] = ACTIONS(163),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(367),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(173),
    [anon_sym_switch] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(187),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_case] = ACTIONS(391),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_async] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(213),
    [anon_sym_new] = ACTIONS(373),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(365),
    [anon_sym_readonly] = ACTIONS(365),
    [anon_sym_get] = ACTIONS(365),
    [anon_sym_set] = ACTIONS(365),
    [anon_sym_declare] = ACTIONS(379),
    [anon_sym_public] = ACTIONS(365),
    [anon_sym_private] = ACTIONS(365),
    [anon_sym_protected] = ACTIONS(365),
    [anon_sym_override] = ACTIONS(365),
    [anon_sym_module] = ACTIONS(381),
    [anon_sym_any] = ACTIONS(365),
    [anon_sym_number] = ACTIONS(365),
    [anon_sym_boolean] = ACTIONS(365),
    [anon_sym_string] = ACTIONS(365),
    [anon_sym_symbol] = ACTIONS(365),
    [anon_sym_object] = ACTIONS(365),
    [anon_sym_property] = ACTIONS(365),
    [anon_sym_signal] = ACTIONS(365),
    [anon_sym_on] = ACTIONS(365),
    [anon_sym_required] = ACTIONS(365),
    [anon_sym_component] = ACTIONS(365),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [15] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(905),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5868),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(15),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(231),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4050),
    [aux_sym_statement_block_repeat1] = STATE(15),
    [sym_identifier] = ACTIONS(395),
    [anon_sym_export] = ACTIONS(398),
    [anon_sym_default] = ACTIONS(401),
    [anon_sym_type] = ACTIONS(403),
    [anon_sym_namespace] = ACTIONS(406),
    [anon_sym_LBRACE] = ACTIONS(409),
    [anon_sym_RBRACE] = ACTIONS(412),
    [anon_sym_typeof] = ACTIONS(414),
    [anon_sym_import] = ACTIONS(417),
    [anon_sym_from] = ACTIONS(420),
    [anon_sym_with] = ACTIONS(423),
    [anon_sym_var] = ACTIONS(426),
    [anon_sym_let] = ACTIONS(429),
    [anon_sym_const] = ACTIONS(432),
    [anon_sym_BANG] = ACTIONS(435),
    [anon_sym_if] = ACTIONS(438),
    [anon_sym_switch] = ACTIONS(441),
    [anon_sym_for] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_await] = ACTIONS(450),
    [anon_sym_of] = ACTIONS(420),
    [anon_sym_while] = ACTIONS(453),
    [anon_sym_do] = ACTIONS(456),
    [anon_sym_try] = ACTIONS(459),
    [anon_sym_break] = ACTIONS(462),
    [anon_sym_continue] = ACTIONS(465),
    [anon_sym_debugger] = ACTIONS(468),
    [anon_sym_return] = ACTIONS(471),
    [anon_sym_throw] = ACTIONS(474),
    [anon_sym_SEMI] = ACTIONS(477),
    [anon_sym_case] = ACTIONS(401),
    [anon_sym_yield] = ACTIONS(480),
    [anon_sym_LBRACK] = ACTIONS(483),
    [anon_sym_LTtemplate_GT] = ACTIONS(486),
    [anon_sym_DQUOTE] = ACTIONS(489),
    [anon_sym_SQUOTE] = ACTIONS(492),
    [anon_sym_class] = ACTIONS(495),
    [anon_sym_async] = ACTIONS(498),
    [anon_sym_function] = ACTIONS(501),
    [anon_sym_new] = ACTIONS(504),
    [anon_sym_using] = ACTIONS(507),
    [anon_sym_PLUS] = ACTIONS(414),
    [anon_sym_DASH] = ACTIONS(414),
    [anon_sym_SLASH] = ACTIONS(510),
    [anon_sym_LT] = ACTIONS(513),
    [anon_sym_TILDE] = ACTIONS(435),
    [anon_sym_void] = ACTIONS(414),
    [anon_sym_delete] = ACTIONS(414),
    [anon_sym_PLUS_PLUS] = ACTIONS(516),
    [anon_sym_DASH_DASH] = ACTIONS(516),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [sym_number] = ACTIONS(522),
    [sym_private_property_identifier] = ACTIONS(525),
    [sym_this] = ACTIONS(528),
    [sym_super] = ACTIONS(528),
    [sym_true] = ACTIONS(528),
    [sym_false] = ACTIONS(528),
    [sym_null] = ACTIONS(528),
    [sym_undefined] = ACTIONS(531),
    [anon_sym_AT] = ACTIONS(534),
    [anon_sym_static] = ACTIONS(420),
    [anon_sym_readonly] = ACTIONS(420),
    [anon_sym_get] = ACTIONS(420),
    [anon_sym_set] = ACTIONS(420),
    [anon_sym_declare] = ACTIONS(537),
    [anon_sym_public] = ACTIONS(420),
    [anon_sym_private] = ACTIONS(420),
    [anon_sym_protected] = ACTIONS(420),
    [anon_sym_override] = ACTIONS(420),
    [anon_sym_module] = ACTIONS(540),
    [anon_sym_any] = ACTIONS(420),
    [anon_sym_number] = ACTIONS(420),
    [anon_sym_boolean] = ACTIONS(420),
    [anon_sym_string] = ACTIONS(420),
    [anon_sym_symbol] = ACTIONS(420),
    [anon_sym_object] = ACTIONS(420),
    [anon_sym_property] = ACTIONS(420),
    [anon_sym_signal] = ACTIONS(420),
    [anon_sym_on] = ACTIONS(420),
    [anon_sym_required] = ACTIONS(420),
    [anon_sym_component] = ACTIONS(420),
    [anon_sym_abstract] = ACTIONS(543),
    [anon_sym_interface] = ACTIONS(546),
    [anon_sym_enum] = ACTIONS(549),
    [sym_html_comment] = ACTIONS(5),
  },
  [16] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(905),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5868),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(16),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(231),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4050),
    [aux_sym_statement_block_repeat1] = STATE(21),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_export] = ACTIONS(355),
    [anon_sym_type] = ACTIONS(359),
    [anon_sym_namespace] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(552),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(365),
    [anon_sym_with] = ACTIONS(163),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(367),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(173),
    [anon_sym_switch] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(187),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_async] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(213),
    [anon_sym_new] = ACTIONS(373),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(365),
    [anon_sym_readonly] = ACTIONS(365),
    [anon_sym_get] = ACTIONS(365),
    [anon_sym_set] = ACTIONS(365),
    [anon_sym_declare] = ACTIONS(379),
    [anon_sym_public] = ACTIONS(365),
    [anon_sym_private] = ACTIONS(365),
    [anon_sym_protected] = ACTIONS(365),
    [anon_sym_override] = ACTIONS(365),
    [anon_sym_module] = ACTIONS(381),
    [anon_sym_any] = ACTIONS(365),
    [anon_sym_number] = ACTIONS(365),
    [anon_sym_boolean] = ACTIONS(365),
    [anon_sym_string] = ACTIONS(365),
    [anon_sym_symbol] = ACTIONS(365),
    [anon_sym_object] = ACTIONS(365),
    [anon_sym_property] = ACTIONS(365),
    [anon_sym_signal] = ACTIONS(365),
    [anon_sym_on] = ACTIONS(365),
    [anon_sym_required] = ACTIONS(365),
    [anon_sym_component] = ACTIONS(365),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [17] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(905),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5868),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(17),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(231),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4050),
    [aux_sym_statement_block_repeat1] = STATE(15),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_export] = ACTIONS(355),
    [anon_sym_type] = ACTIONS(359),
    [anon_sym_namespace] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(554),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(365),
    [anon_sym_with] = ACTIONS(163),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(367),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(173),
    [anon_sym_switch] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(187),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_async] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(213),
    [anon_sym_new] = ACTIONS(373),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(365),
    [anon_sym_readonly] = ACTIONS(365),
    [anon_sym_get] = ACTIONS(365),
    [anon_sym_set] = ACTIONS(365),
    [anon_sym_declare] = ACTIONS(379),
    [anon_sym_public] = ACTIONS(365),
    [anon_sym_private] = ACTIONS(365),
    [anon_sym_protected] = ACTIONS(365),
    [anon_sym_override] = ACTIONS(365),
    [anon_sym_module] = ACTIONS(381),
    [anon_sym_any] = ACTIONS(365),
    [anon_sym_number] = ACTIONS(365),
    [anon_sym_boolean] = ACTIONS(365),
    [anon_sym_string] = ACTIONS(365),
    [anon_sym_symbol] = ACTIONS(365),
    [anon_sym_object] = ACTIONS(365),
    [anon_sym_property] = ACTIONS(365),
    [anon_sym_signal] = ACTIONS(365),
    [anon_sym_on] = ACTIONS(365),
    [anon_sym_required] = ACTIONS(365),
    [anon_sym_component] = ACTIONS(365),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [18] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(905),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5868),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(18),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(231),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4050),
    [aux_sym_statement_block_repeat1] = STATE(15),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_export] = ACTIONS(355),
    [anon_sym_type] = ACTIONS(359),
    [anon_sym_namespace] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(556),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(365),
    [anon_sym_with] = ACTIONS(163),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(367),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(173),
    [anon_sym_switch] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(187),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_async] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(213),
    [anon_sym_new] = ACTIONS(373),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(365),
    [anon_sym_readonly] = ACTIONS(365),
    [anon_sym_get] = ACTIONS(365),
    [anon_sym_set] = ACTIONS(365),
    [anon_sym_declare] = ACTIONS(379),
    [anon_sym_public] = ACTIONS(365),
    [anon_sym_private] = ACTIONS(365),
    [anon_sym_protected] = ACTIONS(365),
    [anon_sym_override] = ACTIONS(365),
    [anon_sym_module] = ACTIONS(381),
    [anon_sym_any] = ACTIONS(365),
    [anon_sym_number] = ACTIONS(365),
    [anon_sym_boolean] = ACTIONS(365),
    [anon_sym_string] = ACTIONS(365),
    [anon_sym_symbol] = ACTIONS(365),
    [anon_sym_object] = ACTIONS(365),
    [anon_sym_property] = ACTIONS(365),
    [anon_sym_signal] = ACTIONS(365),
    [anon_sym_on] = ACTIONS(365),
    [anon_sym_required] = ACTIONS(365),
    [anon_sym_component] = ACTIONS(365),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [19] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(905),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5868),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(19),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(231),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4050),
    [aux_sym_statement_block_repeat1] = STATE(26),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_export] = ACTIONS(355),
    [anon_sym_type] = ACTIONS(359),
    [anon_sym_namespace] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(558),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(365),
    [anon_sym_with] = ACTIONS(163),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(367),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(173),
    [anon_sym_switch] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(187),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_async] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(213),
    [anon_sym_new] = ACTIONS(373),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(365),
    [anon_sym_readonly] = ACTIONS(365),
    [anon_sym_get] = ACTIONS(365),
    [anon_sym_set] = ACTIONS(365),
    [anon_sym_declare] = ACTIONS(379),
    [anon_sym_public] = ACTIONS(365),
    [anon_sym_private] = ACTIONS(365),
    [anon_sym_protected] = ACTIONS(365),
    [anon_sym_override] = ACTIONS(365),
    [anon_sym_module] = ACTIONS(381),
    [anon_sym_any] = ACTIONS(365),
    [anon_sym_number] = ACTIONS(365),
    [anon_sym_boolean] = ACTIONS(365),
    [anon_sym_string] = ACTIONS(365),
    [anon_sym_symbol] = ACTIONS(365),
    [anon_sym_object] = ACTIONS(365),
    [anon_sym_property] = ACTIONS(365),
    [anon_sym_signal] = ACTIONS(365),
    [anon_sym_on] = ACTIONS(365),
    [anon_sym_required] = ACTIONS(365),
    [anon_sym_component] = ACTIONS(365),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [20] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(905),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5868),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(20),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(231),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4050),
    [aux_sym_statement_block_repeat1] = STATE(18),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_export] = ACTIONS(355),
    [anon_sym_type] = ACTIONS(359),
    [anon_sym_namespace] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(560),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(365),
    [anon_sym_with] = ACTIONS(163),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(367),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(173),
    [anon_sym_switch] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(187),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_async] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(213),
    [anon_sym_new] = ACTIONS(373),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(365),
    [anon_sym_readonly] = ACTIONS(365),
    [anon_sym_get] = ACTIONS(365),
    [anon_sym_set] = ACTIONS(365),
    [anon_sym_declare] = ACTIONS(379),
    [anon_sym_public] = ACTIONS(365),
    [anon_sym_private] = ACTIONS(365),
    [anon_sym_protected] = ACTIONS(365),
    [anon_sym_override] = ACTIONS(365),
    [anon_sym_module] = ACTIONS(381),
    [anon_sym_any] = ACTIONS(365),
    [anon_sym_number] = ACTIONS(365),
    [anon_sym_boolean] = ACTIONS(365),
    [anon_sym_string] = ACTIONS(365),
    [anon_sym_symbol] = ACTIONS(365),
    [anon_sym_object] = ACTIONS(365),
    [anon_sym_property] = ACTIONS(365),
    [anon_sym_signal] = ACTIONS(365),
    [anon_sym_on] = ACTIONS(365),
    [anon_sym_required] = ACTIONS(365),
    [anon_sym_component] = ACTIONS(365),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [21] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(905),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5868),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(21),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(231),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4050),
    [aux_sym_statement_block_repeat1] = STATE(15),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_export] = ACTIONS(355),
    [anon_sym_type] = ACTIONS(359),
    [anon_sym_namespace] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(562),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(365),
    [anon_sym_with] = ACTIONS(163),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(367),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(173),
    [anon_sym_switch] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(187),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_async] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(213),
    [anon_sym_new] = ACTIONS(373),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(365),
    [anon_sym_readonly] = ACTIONS(365),
    [anon_sym_get] = ACTIONS(365),
    [anon_sym_set] = ACTIONS(365),
    [anon_sym_declare] = ACTIONS(379),
    [anon_sym_public] = ACTIONS(365),
    [anon_sym_private] = ACTIONS(365),
    [anon_sym_protected] = ACTIONS(365),
    [anon_sym_override] = ACTIONS(365),
    [anon_sym_module] = ACTIONS(381),
    [anon_sym_any] = ACTIONS(365),
    [anon_sym_number] = ACTIONS(365),
    [anon_sym_boolean] = ACTIONS(365),
    [anon_sym_string] = ACTIONS(365),
    [anon_sym_symbol] = ACTIONS(365),
    [anon_sym_object] = ACTIONS(365),
    [anon_sym_property] = ACTIONS(365),
    [anon_sym_signal] = ACTIONS(365),
    [anon_sym_on] = ACTIONS(365),
    [anon_sym_required] = ACTIONS(365),
    [anon_sym_component] = ACTIONS(365),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [22] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(905),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5868),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(22),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(231),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4050),
    [aux_sym_statement_block_repeat1] = STATE(17),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_export] = ACTIONS(355),
    [anon_sym_type] = ACTIONS(359),
    [anon_sym_namespace] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(564),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(365),
    [anon_sym_with] = ACTIONS(163),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(367),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(173),
    [anon_sym_switch] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(187),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_async] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(213),
    [anon_sym_new] = ACTIONS(373),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(365),
    [anon_sym_readonly] = ACTIONS(365),
    [anon_sym_get] = ACTIONS(365),
    [anon_sym_set] = ACTIONS(365),
    [anon_sym_declare] = ACTIONS(379),
    [anon_sym_public] = ACTIONS(365),
    [anon_sym_private] = ACTIONS(365),
    [anon_sym_protected] = ACTIONS(365),
    [anon_sym_override] = ACTIONS(365),
    [anon_sym_module] = ACTIONS(381),
    [anon_sym_any] = ACTIONS(365),
    [anon_sym_number] = ACTIONS(365),
    [anon_sym_boolean] = ACTIONS(365),
    [anon_sym_string] = ACTIONS(365),
    [anon_sym_symbol] = ACTIONS(365),
    [anon_sym_object] = ACTIONS(365),
    [anon_sym_property] = ACTIONS(365),
    [anon_sym_signal] = ACTIONS(365),
    [anon_sym_on] = ACTIONS(365),
    [anon_sym_required] = ACTIONS(365),
    [anon_sym_component] = ACTIONS(365),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [23] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(905),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5868),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(23),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(231),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4050),
    [aux_sym_statement_block_repeat1] = STATE(30),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_export] = ACTIONS(355),
    [anon_sym_type] = ACTIONS(359),
    [anon_sym_namespace] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(566),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(365),
    [anon_sym_with] = ACTIONS(163),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(367),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(173),
    [anon_sym_switch] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(187),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_async] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(213),
    [anon_sym_new] = ACTIONS(373),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(365),
    [anon_sym_readonly] = ACTIONS(365),
    [anon_sym_get] = ACTIONS(365),
    [anon_sym_set] = ACTIONS(365),
    [anon_sym_declare] = ACTIONS(379),
    [anon_sym_public] = ACTIONS(365),
    [anon_sym_private] = ACTIONS(365),
    [anon_sym_protected] = ACTIONS(365),
    [anon_sym_override] = ACTIONS(365),
    [anon_sym_module] = ACTIONS(381),
    [anon_sym_any] = ACTIONS(365),
    [anon_sym_number] = ACTIONS(365),
    [anon_sym_boolean] = ACTIONS(365),
    [anon_sym_string] = ACTIONS(365),
    [anon_sym_symbol] = ACTIONS(365),
    [anon_sym_object] = ACTIONS(365),
    [anon_sym_property] = ACTIONS(365),
    [anon_sym_signal] = ACTIONS(365),
    [anon_sym_on] = ACTIONS(365),
    [anon_sym_required] = ACTIONS(365),
    [anon_sym_component] = ACTIONS(365),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [24] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(905),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5868),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(24),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(231),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4050),
    [aux_sym_statement_block_repeat1] = STATE(29),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_export] = ACTIONS(355),
    [anon_sym_type] = ACTIONS(359),
    [anon_sym_namespace] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(568),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(365),
    [anon_sym_with] = ACTIONS(163),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(367),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(173),
    [anon_sym_switch] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(187),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_async] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(213),
    [anon_sym_new] = ACTIONS(373),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(365),
    [anon_sym_readonly] = ACTIONS(365),
    [anon_sym_get] = ACTIONS(365),
    [anon_sym_set] = ACTIONS(365),
    [anon_sym_declare] = ACTIONS(379),
    [anon_sym_public] = ACTIONS(365),
    [anon_sym_private] = ACTIONS(365),
    [anon_sym_protected] = ACTIONS(365),
    [anon_sym_override] = ACTIONS(365),
    [anon_sym_module] = ACTIONS(381),
    [anon_sym_any] = ACTIONS(365),
    [anon_sym_number] = ACTIONS(365),
    [anon_sym_boolean] = ACTIONS(365),
    [anon_sym_string] = ACTIONS(365),
    [anon_sym_symbol] = ACTIONS(365),
    [anon_sym_object] = ACTIONS(365),
    [anon_sym_property] = ACTIONS(365),
    [anon_sym_signal] = ACTIONS(365),
    [anon_sym_on] = ACTIONS(365),
    [anon_sym_required] = ACTIONS(365),
    [anon_sym_component] = ACTIONS(365),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [25] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(905),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5868),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(25),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(231),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4050),
    [aux_sym_statement_block_repeat1] = STATE(31),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_export] = ACTIONS(355),
    [anon_sym_type] = ACTIONS(359),
    [anon_sym_namespace] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(570),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(365),
    [anon_sym_with] = ACTIONS(163),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(367),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(173),
    [anon_sym_switch] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(187),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_async] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(213),
    [anon_sym_new] = ACTIONS(373),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(365),
    [anon_sym_readonly] = ACTIONS(365),
    [anon_sym_get] = ACTIONS(365),
    [anon_sym_set] = ACTIONS(365),
    [anon_sym_declare] = ACTIONS(379),
    [anon_sym_public] = ACTIONS(365),
    [anon_sym_private] = ACTIONS(365),
    [anon_sym_protected] = ACTIONS(365),
    [anon_sym_override] = ACTIONS(365),
    [anon_sym_module] = ACTIONS(381),
    [anon_sym_any] = ACTIONS(365),
    [anon_sym_number] = ACTIONS(365),
    [anon_sym_boolean] = ACTIONS(365),
    [anon_sym_string] = ACTIONS(365),
    [anon_sym_symbol] = ACTIONS(365),
    [anon_sym_object] = ACTIONS(365),
    [anon_sym_property] = ACTIONS(365),
    [anon_sym_signal] = ACTIONS(365),
    [anon_sym_on] = ACTIONS(365),
    [anon_sym_required] = ACTIONS(365),
    [anon_sym_component] = ACTIONS(365),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [26] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(905),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5868),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(26),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(231),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4050),
    [aux_sym_statement_block_repeat1] = STATE(15),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_export] = ACTIONS(355),
    [anon_sym_type] = ACTIONS(359),
    [anon_sym_namespace] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(572),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(365),
    [anon_sym_with] = ACTIONS(163),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(367),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(173),
    [anon_sym_switch] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(187),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_async] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(213),
    [anon_sym_new] = ACTIONS(373),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(365),
    [anon_sym_readonly] = ACTIONS(365),
    [anon_sym_get] = ACTIONS(365),
    [anon_sym_set] = ACTIONS(365),
    [anon_sym_declare] = ACTIONS(379),
    [anon_sym_public] = ACTIONS(365),
    [anon_sym_private] = ACTIONS(365),
    [anon_sym_protected] = ACTIONS(365),
    [anon_sym_override] = ACTIONS(365),
    [anon_sym_module] = ACTIONS(381),
    [anon_sym_any] = ACTIONS(365),
    [anon_sym_number] = ACTIONS(365),
    [anon_sym_boolean] = ACTIONS(365),
    [anon_sym_string] = ACTIONS(365),
    [anon_sym_symbol] = ACTIONS(365),
    [anon_sym_object] = ACTIONS(365),
    [anon_sym_property] = ACTIONS(365),
    [anon_sym_signal] = ACTIONS(365),
    [anon_sym_on] = ACTIONS(365),
    [anon_sym_required] = ACTIONS(365),
    [anon_sym_component] = ACTIONS(365),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [27] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(905),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5868),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(27),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(231),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4050),
    [aux_sym_statement_block_repeat1] = STATE(28),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_export] = ACTIONS(355),
    [anon_sym_type] = ACTIONS(359),
    [anon_sym_namespace] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(574),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(365),
    [anon_sym_with] = ACTIONS(163),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(367),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(173),
    [anon_sym_switch] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(187),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_async] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(213),
    [anon_sym_new] = ACTIONS(373),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(365),
    [anon_sym_readonly] = ACTIONS(365),
    [anon_sym_get] = ACTIONS(365),
    [anon_sym_set] = ACTIONS(365),
    [anon_sym_declare] = ACTIONS(379),
    [anon_sym_public] = ACTIONS(365),
    [anon_sym_private] = ACTIONS(365),
    [anon_sym_protected] = ACTIONS(365),
    [anon_sym_override] = ACTIONS(365),
    [anon_sym_module] = ACTIONS(381),
    [anon_sym_any] = ACTIONS(365),
    [anon_sym_number] = ACTIONS(365),
    [anon_sym_boolean] = ACTIONS(365),
    [anon_sym_string] = ACTIONS(365),
    [anon_sym_symbol] = ACTIONS(365),
    [anon_sym_object] = ACTIONS(365),
    [anon_sym_property] = ACTIONS(365),
    [anon_sym_signal] = ACTIONS(365),
    [anon_sym_on] = ACTIONS(365),
    [anon_sym_required] = ACTIONS(365),
    [anon_sym_component] = ACTIONS(365),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [28] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(905),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5868),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(28),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(231),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4050),
    [aux_sym_statement_block_repeat1] = STATE(15),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_export] = ACTIONS(355),
    [anon_sym_type] = ACTIONS(359),
    [anon_sym_namespace] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(576),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(365),
    [anon_sym_with] = ACTIONS(163),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(367),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(173),
    [anon_sym_switch] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(187),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_async] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(213),
    [anon_sym_new] = ACTIONS(373),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(365),
    [anon_sym_readonly] = ACTIONS(365),
    [anon_sym_get] = ACTIONS(365),
    [anon_sym_set] = ACTIONS(365),
    [anon_sym_declare] = ACTIONS(379),
    [anon_sym_public] = ACTIONS(365),
    [anon_sym_private] = ACTIONS(365),
    [anon_sym_protected] = ACTIONS(365),
    [anon_sym_override] = ACTIONS(365),
    [anon_sym_module] = ACTIONS(381),
    [anon_sym_any] = ACTIONS(365),
    [anon_sym_number] = ACTIONS(365),
    [anon_sym_boolean] = ACTIONS(365),
    [anon_sym_string] = ACTIONS(365),
    [anon_sym_symbol] = ACTIONS(365),
    [anon_sym_object] = ACTIONS(365),
    [anon_sym_property] = ACTIONS(365),
    [anon_sym_signal] = ACTIONS(365),
    [anon_sym_on] = ACTIONS(365),
    [anon_sym_required] = ACTIONS(365),
    [anon_sym_component] = ACTIONS(365),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [29] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(905),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5868),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(29),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(231),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4050),
    [aux_sym_statement_block_repeat1] = STATE(15),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_export] = ACTIONS(355),
    [anon_sym_type] = ACTIONS(359),
    [anon_sym_namespace] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(578),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(365),
    [anon_sym_with] = ACTIONS(163),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(367),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(173),
    [anon_sym_switch] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(187),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_async] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(213),
    [anon_sym_new] = ACTIONS(373),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(365),
    [anon_sym_readonly] = ACTIONS(365),
    [anon_sym_get] = ACTIONS(365),
    [anon_sym_set] = ACTIONS(365),
    [anon_sym_declare] = ACTIONS(379),
    [anon_sym_public] = ACTIONS(365),
    [anon_sym_private] = ACTIONS(365),
    [anon_sym_protected] = ACTIONS(365),
    [anon_sym_override] = ACTIONS(365),
    [anon_sym_module] = ACTIONS(381),
    [anon_sym_any] = ACTIONS(365),
    [anon_sym_number] = ACTIONS(365),
    [anon_sym_boolean] = ACTIONS(365),
    [anon_sym_string] = ACTIONS(365),
    [anon_sym_symbol] = ACTIONS(365),
    [anon_sym_object] = ACTIONS(365),
    [anon_sym_property] = ACTIONS(365),
    [anon_sym_signal] = ACTIONS(365),
    [anon_sym_on] = ACTIONS(365),
    [anon_sym_required] = ACTIONS(365),
    [anon_sym_component] = ACTIONS(365),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [30] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(905),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5868),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(30),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(231),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4050),
    [aux_sym_statement_block_repeat1] = STATE(15),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_export] = ACTIONS(355),
    [anon_sym_type] = ACTIONS(359),
    [anon_sym_namespace] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(580),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(365),
    [anon_sym_with] = ACTIONS(163),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(367),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(173),
    [anon_sym_switch] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(187),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_async] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(213),
    [anon_sym_new] = ACTIONS(373),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(365),
    [anon_sym_readonly] = ACTIONS(365),
    [anon_sym_get] = ACTIONS(365),
    [anon_sym_set] = ACTIONS(365),
    [anon_sym_declare] = ACTIONS(379),
    [anon_sym_public] = ACTIONS(365),
    [anon_sym_private] = ACTIONS(365),
    [anon_sym_protected] = ACTIONS(365),
    [anon_sym_override] = ACTIONS(365),
    [anon_sym_module] = ACTIONS(381),
    [anon_sym_any] = ACTIONS(365),
    [anon_sym_number] = ACTIONS(365),
    [anon_sym_boolean] = ACTIONS(365),
    [anon_sym_string] = ACTIONS(365),
    [anon_sym_symbol] = ACTIONS(365),
    [anon_sym_object] = ACTIONS(365),
    [anon_sym_property] = ACTIONS(365),
    [anon_sym_signal] = ACTIONS(365),
    [anon_sym_on] = ACTIONS(365),
    [anon_sym_required] = ACTIONS(365),
    [anon_sym_component] = ACTIONS(365),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [31] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(905),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5868),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(31),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(231),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4050),
    [aux_sym_statement_block_repeat1] = STATE(15),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_export] = ACTIONS(355),
    [anon_sym_type] = ACTIONS(359),
    [anon_sym_namespace] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(582),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(365),
    [anon_sym_with] = ACTIONS(163),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(367),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(173),
    [anon_sym_switch] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(187),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_async] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(213),
    [anon_sym_new] = ACTIONS(373),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(365),
    [anon_sym_readonly] = ACTIONS(365),
    [anon_sym_get] = ACTIONS(365),
    [anon_sym_set] = ACTIONS(365),
    [anon_sym_declare] = ACTIONS(379),
    [anon_sym_public] = ACTIONS(365),
    [anon_sym_private] = ACTIONS(365),
    [anon_sym_protected] = ACTIONS(365),
    [anon_sym_override] = ACTIONS(365),
    [anon_sym_module] = ACTIONS(381),
    [anon_sym_any] = ACTIONS(365),
    [anon_sym_number] = ACTIONS(365),
    [anon_sym_boolean] = ACTIONS(365),
    [anon_sym_string] = ACTIONS(365),
    [anon_sym_symbol] = ACTIONS(365),
    [anon_sym_object] = ACTIONS(365),
    [anon_sym_property] = ACTIONS(365),
    [anon_sym_signal] = ACTIONS(365),
    [anon_sym_on] = ACTIONS(365),
    [anon_sym_required] = ACTIONS(365),
    [anon_sym_component] = ACTIONS(365),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [32] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(765),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5868),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(32),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(231),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4050),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_export] = ACTIONS(355),
    [anon_sym_type] = ACTIONS(359),
    [anon_sym_namespace] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(365),
    [anon_sym_with] = ACTIONS(163),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(367),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(173),
    [anon_sym_switch] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(187),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_async] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(213),
    [anon_sym_new] = ACTIONS(373),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(365),
    [anon_sym_readonly] = ACTIONS(365),
    [anon_sym_get] = ACTIONS(365),
    [anon_sym_set] = ACTIONS(365),
    [anon_sym_declare] = ACTIONS(379),
    [anon_sym_public] = ACTIONS(365),
    [anon_sym_private] = ACTIONS(365),
    [anon_sym_protected] = ACTIONS(365),
    [anon_sym_override] = ACTIONS(365),
    [anon_sym_module] = ACTIONS(381),
    [anon_sym_any] = ACTIONS(365),
    [anon_sym_number] = ACTIONS(365),
    [anon_sym_boolean] = ACTIONS(365),
    [anon_sym_string] = ACTIONS(365),
    [anon_sym_symbol] = ACTIONS(365),
    [anon_sym_object] = ACTIONS(365),
    [anon_sym_property] = ACTIONS(365),
    [anon_sym_signal] = ACTIONS(365),
    [anon_sym_on] = ACTIONS(365),
    [anon_sym_required] = ACTIONS(365),
    [anon_sym_component] = ACTIONS(365),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [33] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(788),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5868),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(33),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(231),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4050),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_export] = ACTIONS(355),
    [anon_sym_type] = ACTIONS(359),
    [anon_sym_namespace] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(365),
    [anon_sym_with] = ACTIONS(163),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(367),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(173),
    [anon_sym_switch] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(187),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_async] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(213),
    [anon_sym_new] = ACTIONS(373),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(365),
    [anon_sym_readonly] = ACTIONS(365),
    [anon_sym_get] = ACTIONS(365),
    [anon_sym_set] = ACTIONS(365),
    [anon_sym_declare] = ACTIONS(379),
    [anon_sym_public] = ACTIONS(365),
    [anon_sym_private] = ACTIONS(365),
    [anon_sym_protected] = ACTIONS(365),
    [anon_sym_override] = ACTIONS(365),
    [anon_sym_module] = ACTIONS(381),
    [anon_sym_any] = ACTIONS(365),
    [anon_sym_number] = ACTIONS(365),
    [anon_sym_boolean] = ACTIONS(365),
    [anon_sym_string] = ACTIONS(365),
    [anon_sym_symbol] = ACTIONS(365),
    [anon_sym_object] = ACTIONS(365),
    [anon_sym_property] = ACTIONS(365),
    [anon_sym_signal] = ACTIONS(365),
    [anon_sym_on] = ACTIONS(365),
    [anon_sym_required] = ACTIONS(365),
    [anon_sym_component] = ACTIONS(365),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [34] = {
    [sym_export_statement] = STATE(2948),
    [sym_declaration] = STATE(2948),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(2948),
    [sym_statement] = STATE(2910),
    [sym_expression_statement] = STATE(2948),
    [sym_variable_declaration] = STATE(2949),
    [sym_lexical_declaration] = STATE(2949),
    [sym_statement_block] = STATE(2948),
    [sym_if_statement] = STATE(2948),
    [sym_switch_statement] = STATE(2948),
    [sym_for_statement] = STATE(2948),
    [sym_for_in_statement] = STATE(2948),
    [sym_while_statement] = STATE(2948),
    [sym_do_statement] = STATE(2948),
    [sym_try_statement] = STATE(2948),
    [sym_with_statement] = STATE(2948),
    [sym_break_statement] = STATE(2948),
    [sym_continue_statement] = STATE(2948),
    [sym_debugger_statement] = STATE(2948),
    [sym_return_statement] = STATE(2948),
    [sym_throw_statement] = STATE(2948),
    [sym_empty_statement] = STATE(2948),
    [sym_labeled_statement] = STATE(2948),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1978),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(2949),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(2949),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(2949),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5533),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(34),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(2949),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(2949),
    [sym_abstract_class_declaration] = STATE(2949),
    [sym_module] = STATE(2949),
    [sym_internal_module] = STATE(933),
    [sym_import_alias] = STATE(2949),
    [sym_interface_declaration] = STATE(2949),
    [sym_enum_declaration] = STATE(2949),
    [sym_type_alias_declaration] = STATE(2949),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4175),
    [sym_identifier] = ACTIONS(584),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_type] = ACTIONS(588),
    [anon_sym_namespace] = ACTIONS(590),
    [anon_sym_LBRACE] = ACTIONS(592),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(594),
    [anon_sym_from] = ACTIONS(596),
    [anon_sym_with] = ACTIONS(598),
    [anon_sym_var] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(602),
    [anon_sym_const] = ACTIONS(604),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(606),
    [anon_sym_switch] = ACTIONS(608),
    [anon_sym_for] = ACTIONS(610),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(596),
    [anon_sym_while] = ACTIONS(612),
    [anon_sym_do] = ACTIONS(614),
    [anon_sym_try] = ACTIONS(616),
    [anon_sym_break] = ACTIONS(618),
    [anon_sym_continue] = ACTIONS(620),
    [anon_sym_debugger] = ACTIONS(622),
    [anon_sym_return] = ACTIONS(624),
    [anon_sym_throw] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(628),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(630),
    [anon_sym_async] = ACTIONS(632),
    [anon_sym_function] = ACTIONS(634),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_readonly] = ACTIONS(596),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(638),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_override] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(640),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [anon_sym_object] = ACTIONS(596),
    [anon_sym_property] = ACTIONS(596),
    [anon_sym_signal] = ACTIONS(596),
    [anon_sym_on] = ACTIONS(596),
    [anon_sym_required] = ACTIONS(596),
    [anon_sym_component] = ACTIONS(596),
    [anon_sym_abstract] = ACTIONS(642),
    [anon_sym_interface] = ACTIONS(644),
    [anon_sym_enum] = ACTIONS(646),
    [sym_html_comment] = ACTIONS(5),
  },
  [35] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(859),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5868),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(35),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(231),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4050),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_export] = ACTIONS(355),
    [anon_sym_type] = ACTIONS(359),
    [anon_sym_namespace] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(365),
    [anon_sym_with] = ACTIONS(163),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(367),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(173),
    [anon_sym_switch] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(187),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_async] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(213),
    [anon_sym_new] = ACTIONS(373),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(365),
    [anon_sym_readonly] = ACTIONS(365),
    [anon_sym_get] = ACTIONS(365),
    [anon_sym_set] = ACTIONS(365),
    [anon_sym_declare] = ACTIONS(379),
    [anon_sym_public] = ACTIONS(365),
    [anon_sym_private] = ACTIONS(365),
    [anon_sym_protected] = ACTIONS(365),
    [anon_sym_override] = ACTIONS(365),
    [anon_sym_module] = ACTIONS(381),
    [anon_sym_any] = ACTIONS(365),
    [anon_sym_number] = ACTIONS(365),
    [anon_sym_boolean] = ACTIONS(365),
    [anon_sym_string] = ACTIONS(365),
    [anon_sym_symbol] = ACTIONS(365),
    [anon_sym_object] = ACTIONS(365),
    [anon_sym_property] = ACTIONS(365),
    [anon_sym_signal] = ACTIONS(365),
    [anon_sym_on] = ACTIONS(365),
    [anon_sym_required] = ACTIONS(365),
    [anon_sym_component] = ACTIONS(365),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [36] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(6227),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1978),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5533),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(36),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(2510),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4134),
    [sym_identifier] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_type] = ACTIONS(652),
    [anon_sym_namespace] = ACTIONS(654),
    [anon_sym_LBRACE] = ACTIONS(656),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(658),
    [anon_sym_with] = ACTIONS(660),
    [anon_sym_var] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(662),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(664),
    [anon_sym_switch] = ACTIONS(608),
    [anon_sym_for] = ACTIONS(666),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(658),
    [anon_sym_while] = ACTIONS(668),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(616),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(628),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(670),
    [anon_sym_async] = ACTIONS(672),
    [anon_sym_function] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(676),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(658),
    [anon_sym_readonly] = ACTIONS(658),
    [anon_sym_get] = ACTIONS(658),
    [anon_sym_set] = ACTIONS(658),
    [anon_sym_declare] = ACTIONS(678),
    [anon_sym_public] = ACTIONS(658),
    [anon_sym_private] = ACTIONS(658),
    [anon_sym_protected] = ACTIONS(658),
    [anon_sym_override] = ACTIONS(658),
    [anon_sym_module] = ACTIONS(680),
    [anon_sym_any] = ACTIONS(658),
    [anon_sym_number] = ACTIONS(658),
    [anon_sym_boolean] = ACTIONS(658),
    [anon_sym_string] = ACTIONS(658),
    [anon_sym_symbol] = ACTIONS(658),
    [anon_sym_object] = ACTIONS(658),
    [anon_sym_property] = ACTIONS(658),
    [anon_sym_signal] = ACTIONS(658),
    [anon_sym_on] = ACTIONS(658),
    [anon_sym_required] = ACTIONS(658),
    [anon_sym_component] = ACTIONS(658),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [37] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(6017),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1978),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5533),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(37),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(2510),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4134),
    [sym_identifier] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_type] = ACTIONS(652),
    [anon_sym_namespace] = ACTIONS(654),
    [anon_sym_LBRACE] = ACTIONS(656),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(658),
    [anon_sym_with] = ACTIONS(660),
    [anon_sym_var] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(662),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(664),
    [anon_sym_switch] = ACTIONS(608),
    [anon_sym_for] = ACTIONS(666),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(658),
    [anon_sym_while] = ACTIONS(668),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(616),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(628),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(670),
    [anon_sym_async] = ACTIONS(672),
    [anon_sym_function] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(676),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(658),
    [anon_sym_readonly] = ACTIONS(658),
    [anon_sym_get] = ACTIONS(658),
    [anon_sym_set] = ACTIONS(658),
    [anon_sym_declare] = ACTIONS(678),
    [anon_sym_public] = ACTIONS(658),
    [anon_sym_private] = ACTIONS(658),
    [anon_sym_protected] = ACTIONS(658),
    [anon_sym_override] = ACTIONS(658),
    [anon_sym_module] = ACTIONS(680),
    [anon_sym_any] = ACTIONS(658),
    [anon_sym_number] = ACTIONS(658),
    [anon_sym_boolean] = ACTIONS(658),
    [anon_sym_string] = ACTIONS(658),
    [anon_sym_symbol] = ACTIONS(658),
    [anon_sym_object] = ACTIONS(658),
    [anon_sym_property] = ACTIONS(658),
    [anon_sym_signal] = ACTIONS(658),
    [anon_sym_on] = ACTIONS(658),
    [anon_sym_required] = ACTIONS(658),
    [anon_sym_component] = ACTIONS(658),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [38] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(859),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1978),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5533),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(38),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(2510),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4134),
    [sym_identifier] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_type] = ACTIONS(652),
    [anon_sym_namespace] = ACTIONS(654),
    [anon_sym_LBRACE] = ACTIONS(656),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(658),
    [anon_sym_with] = ACTIONS(660),
    [anon_sym_var] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(662),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(664),
    [anon_sym_switch] = ACTIONS(608),
    [anon_sym_for] = ACTIONS(666),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(658),
    [anon_sym_while] = ACTIONS(668),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(616),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(628),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(670),
    [anon_sym_async] = ACTIONS(672),
    [anon_sym_function] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(676),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(658),
    [anon_sym_readonly] = ACTIONS(658),
    [anon_sym_get] = ACTIONS(658),
    [anon_sym_set] = ACTIONS(658),
    [anon_sym_declare] = ACTIONS(678),
    [anon_sym_public] = ACTIONS(658),
    [anon_sym_private] = ACTIONS(658),
    [anon_sym_protected] = ACTIONS(658),
    [anon_sym_override] = ACTIONS(658),
    [anon_sym_module] = ACTIONS(680),
    [anon_sym_any] = ACTIONS(658),
    [anon_sym_number] = ACTIONS(658),
    [anon_sym_boolean] = ACTIONS(658),
    [anon_sym_string] = ACTIONS(658),
    [anon_sym_symbol] = ACTIONS(658),
    [anon_sym_object] = ACTIONS(658),
    [anon_sym_property] = ACTIONS(658),
    [anon_sym_signal] = ACTIONS(658),
    [anon_sym_on] = ACTIONS(658),
    [anon_sym_required] = ACTIONS(658),
    [anon_sym_component] = ACTIONS(658),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [39] = {
    [sym_export_statement] = STATE(2948),
    [sym_declaration] = STATE(2948),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(2948),
    [sym_statement] = STATE(2990),
    [sym_expression_statement] = STATE(2948),
    [sym_variable_declaration] = STATE(2949),
    [sym_lexical_declaration] = STATE(2949),
    [sym_statement_block] = STATE(2948),
    [sym_if_statement] = STATE(2948),
    [sym_switch_statement] = STATE(2948),
    [sym_for_statement] = STATE(2948),
    [sym_for_in_statement] = STATE(2948),
    [sym_while_statement] = STATE(2948),
    [sym_do_statement] = STATE(2948),
    [sym_try_statement] = STATE(2948),
    [sym_with_statement] = STATE(2948),
    [sym_break_statement] = STATE(2948),
    [sym_continue_statement] = STATE(2948),
    [sym_debugger_statement] = STATE(2948),
    [sym_return_statement] = STATE(2948),
    [sym_throw_statement] = STATE(2948),
    [sym_empty_statement] = STATE(2948),
    [sym_labeled_statement] = STATE(2948),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1978),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(2949),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(2949),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(2949),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5533),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(39),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(2949),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(2949),
    [sym_abstract_class_declaration] = STATE(2949),
    [sym_module] = STATE(2949),
    [sym_internal_module] = STATE(933),
    [sym_import_alias] = STATE(2949),
    [sym_interface_declaration] = STATE(2949),
    [sym_enum_declaration] = STATE(2949),
    [sym_type_alias_declaration] = STATE(2949),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4175),
    [sym_identifier] = ACTIONS(584),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_type] = ACTIONS(588),
    [anon_sym_namespace] = ACTIONS(590),
    [anon_sym_LBRACE] = ACTIONS(592),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(594),
    [anon_sym_from] = ACTIONS(596),
    [anon_sym_with] = ACTIONS(598),
    [anon_sym_var] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(602),
    [anon_sym_const] = ACTIONS(604),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(606),
    [anon_sym_switch] = ACTIONS(608),
    [anon_sym_for] = ACTIONS(610),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(596),
    [anon_sym_while] = ACTIONS(612),
    [anon_sym_do] = ACTIONS(614),
    [anon_sym_try] = ACTIONS(616),
    [anon_sym_break] = ACTIONS(618),
    [anon_sym_continue] = ACTIONS(620),
    [anon_sym_debugger] = ACTIONS(622),
    [anon_sym_return] = ACTIONS(624),
    [anon_sym_throw] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(628),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(630),
    [anon_sym_async] = ACTIONS(632),
    [anon_sym_function] = ACTIONS(634),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_readonly] = ACTIONS(596),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(638),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_override] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(640),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [anon_sym_object] = ACTIONS(596),
    [anon_sym_property] = ACTIONS(596),
    [anon_sym_signal] = ACTIONS(596),
    [anon_sym_on] = ACTIONS(596),
    [anon_sym_required] = ACTIONS(596),
    [anon_sym_component] = ACTIONS(596),
    [anon_sym_abstract] = ACTIONS(642),
    [anon_sym_interface] = ACTIONS(644),
    [anon_sym_enum] = ACTIONS(646),
    [sym_html_comment] = ACTIONS(5),
  },
  [40] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(796),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5868),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(40),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(231),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4050),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_export] = ACTIONS(355),
    [anon_sym_type] = ACTIONS(359),
    [anon_sym_namespace] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(365),
    [anon_sym_with] = ACTIONS(163),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(367),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(173),
    [anon_sym_switch] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(187),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_async] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(213),
    [anon_sym_new] = ACTIONS(373),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(365),
    [anon_sym_readonly] = ACTIONS(365),
    [anon_sym_get] = ACTIONS(365),
    [anon_sym_set] = ACTIONS(365),
    [anon_sym_declare] = ACTIONS(379),
    [anon_sym_public] = ACTIONS(365),
    [anon_sym_private] = ACTIONS(365),
    [anon_sym_protected] = ACTIONS(365),
    [anon_sym_override] = ACTIONS(365),
    [anon_sym_module] = ACTIONS(381),
    [anon_sym_any] = ACTIONS(365),
    [anon_sym_number] = ACTIONS(365),
    [anon_sym_boolean] = ACTIONS(365),
    [anon_sym_string] = ACTIONS(365),
    [anon_sym_symbol] = ACTIONS(365),
    [anon_sym_object] = ACTIONS(365),
    [anon_sym_property] = ACTIONS(365),
    [anon_sym_signal] = ACTIONS(365),
    [anon_sym_on] = ACTIONS(365),
    [anon_sym_required] = ACTIONS(365),
    [anon_sym_component] = ACTIONS(365),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [41] = {
    [sym_export_statement] = STATE(2948),
    [sym_declaration] = STATE(2948),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(2948),
    [sym_statement] = STATE(2923),
    [sym_expression_statement] = STATE(2948),
    [sym_variable_declaration] = STATE(2949),
    [sym_lexical_declaration] = STATE(2949),
    [sym_statement_block] = STATE(2948),
    [sym_if_statement] = STATE(2948),
    [sym_switch_statement] = STATE(2948),
    [sym_for_statement] = STATE(2948),
    [sym_for_in_statement] = STATE(2948),
    [sym_while_statement] = STATE(2948),
    [sym_do_statement] = STATE(2948),
    [sym_try_statement] = STATE(2948),
    [sym_with_statement] = STATE(2948),
    [sym_break_statement] = STATE(2948),
    [sym_continue_statement] = STATE(2948),
    [sym_debugger_statement] = STATE(2948),
    [sym_return_statement] = STATE(2948),
    [sym_throw_statement] = STATE(2948),
    [sym_empty_statement] = STATE(2948),
    [sym_labeled_statement] = STATE(2948),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1978),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(2949),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(2949),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(2949),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5533),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(41),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(2949),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(2949),
    [sym_abstract_class_declaration] = STATE(2949),
    [sym_module] = STATE(2949),
    [sym_internal_module] = STATE(933),
    [sym_import_alias] = STATE(2949),
    [sym_interface_declaration] = STATE(2949),
    [sym_enum_declaration] = STATE(2949),
    [sym_type_alias_declaration] = STATE(2949),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4175),
    [sym_identifier] = ACTIONS(584),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_type] = ACTIONS(588),
    [anon_sym_namespace] = ACTIONS(590),
    [anon_sym_LBRACE] = ACTIONS(592),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(594),
    [anon_sym_from] = ACTIONS(596),
    [anon_sym_with] = ACTIONS(598),
    [anon_sym_var] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(602),
    [anon_sym_const] = ACTIONS(604),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(606),
    [anon_sym_switch] = ACTIONS(608),
    [anon_sym_for] = ACTIONS(610),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(596),
    [anon_sym_while] = ACTIONS(612),
    [anon_sym_do] = ACTIONS(614),
    [anon_sym_try] = ACTIONS(616),
    [anon_sym_break] = ACTIONS(618),
    [anon_sym_continue] = ACTIONS(620),
    [anon_sym_debugger] = ACTIONS(622),
    [anon_sym_return] = ACTIONS(624),
    [anon_sym_throw] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(628),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(630),
    [anon_sym_async] = ACTIONS(632),
    [anon_sym_function] = ACTIONS(634),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_readonly] = ACTIONS(596),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(638),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_override] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(640),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [anon_sym_object] = ACTIONS(596),
    [anon_sym_property] = ACTIONS(596),
    [anon_sym_signal] = ACTIONS(596),
    [anon_sym_on] = ACTIONS(596),
    [anon_sym_required] = ACTIONS(596),
    [anon_sym_component] = ACTIONS(596),
    [anon_sym_abstract] = ACTIONS(642),
    [anon_sym_interface] = ACTIONS(644),
    [anon_sym_enum] = ACTIONS(646),
    [sym_html_comment] = ACTIONS(5),
  },
  [42] = {
    [sym_export_statement] = STATE(2948),
    [sym_declaration] = STATE(2948),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(2948),
    [sym_statement] = STATE(2969),
    [sym_expression_statement] = STATE(2948),
    [sym_variable_declaration] = STATE(2949),
    [sym_lexical_declaration] = STATE(2949),
    [sym_statement_block] = STATE(2948),
    [sym_if_statement] = STATE(2948),
    [sym_switch_statement] = STATE(2948),
    [sym_for_statement] = STATE(2948),
    [sym_for_in_statement] = STATE(2948),
    [sym_while_statement] = STATE(2948),
    [sym_do_statement] = STATE(2948),
    [sym_try_statement] = STATE(2948),
    [sym_with_statement] = STATE(2948),
    [sym_break_statement] = STATE(2948),
    [sym_continue_statement] = STATE(2948),
    [sym_debugger_statement] = STATE(2948),
    [sym_return_statement] = STATE(2948),
    [sym_throw_statement] = STATE(2948),
    [sym_empty_statement] = STATE(2948),
    [sym_labeled_statement] = STATE(2948),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1978),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(2949),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(2949),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(2949),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5533),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(42),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(2949),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(2949),
    [sym_abstract_class_declaration] = STATE(2949),
    [sym_module] = STATE(2949),
    [sym_internal_module] = STATE(933),
    [sym_import_alias] = STATE(2949),
    [sym_interface_declaration] = STATE(2949),
    [sym_enum_declaration] = STATE(2949),
    [sym_type_alias_declaration] = STATE(2949),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4175),
    [sym_identifier] = ACTIONS(584),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_type] = ACTIONS(588),
    [anon_sym_namespace] = ACTIONS(590),
    [anon_sym_LBRACE] = ACTIONS(592),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(594),
    [anon_sym_from] = ACTIONS(596),
    [anon_sym_with] = ACTIONS(598),
    [anon_sym_var] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(602),
    [anon_sym_const] = ACTIONS(604),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(606),
    [anon_sym_switch] = ACTIONS(608),
    [anon_sym_for] = ACTIONS(610),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(596),
    [anon_sym_while] = ACTIONS(612),
    [anon_sym_do] = ACTIONS(614),
    [anon_sym_try] = ACTIONS(616),
    [anon_sym_break] = ACTIONS(618),
    [anon_sym_continue] = ACTIONS(620),
    [anon_sym_debugger] = ACTIONS(622),
    [anon_sym_return] = ACTIONS(624),
    [anon_sym_throw] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(628),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(630),
    [anon_sym_async] = ACTIONS(632),
    [anon_sym_function] = ACTIONS(634),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_readonly] = ACTIONS(596),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(638),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_override] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(640),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [anon_sym_object] = ACTIONS(596),
    [anon_sym_property] = ACTIONS(596),
    [anon_sym_signal] = ACTIONS(596),
    [anon_sym_on] = ACTIONS(596),
    [anon_sym_required] = ACTIONS(596),
    [anon_sym_component] = ACTIONS(596),
    [anon_sym_abstract] = ACTIONS(642),
    [anon_sym_interface] = ACTIONS(644),
    [anon_sym_enum] = ACTIONS(646),
    [sym_html_comment] = ACTIONS(5),
  },
  [43] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(847),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1978),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5533),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(43),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(2510),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4134),
    [sym_identifier] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_type] = ACTIONS(652),
    [anon_sym_namespace] = ACTIONS(654),
    [anon_sym_LBRACE] = ACTIONS(656),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(658),
    [anon_sym_with] = ACTIONS(660),
    [anon_sym_var] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(662),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(664),
    [anon_sym_switch] = ACTIONS(608),
    [anon_sym_for] = ACTIONS(666),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(658),
    [anon_sym_while] = ACTIONS(668),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(616),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(628),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(670),
    [anon_sym_async] = ACTIONS(672),
    [anon_sym_function] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(676),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(658),
    [anon_sym_readonly] = ACTIONS(658),
    [anon_sym_get] = ACTIONS(658),
    [anon_sym_set] = ACTIONS(658),
    [anon_sym_declare] = ACTIONS(678),
    [anon_sym_public] = ACTIONS(658),
    [anon_sym_private] = ACTIONS(658),
    [anon_sym_protected] = ACTIONS(658),
    [anon_sym_override] = ACTIONS(658),
    [anon_sym_module] = ACTIONS(680),
    [anon_sym_any] = ACTIONS(658),
    [anon_sym_number] = ACTIONS(658),
    [anon_sym_boolean] = ACTIONS(658),
    [anon_sym_string] = ACTIONS(658),
    [anon_sym_symbol] = ACTIONS(658),
    [anon_sym_object] = ACTIONS(658),
    [anon_sym_property] = ACTIONS(658),
    [anon_sym_signal] = ACTIONS(658),
    [anon_sym_on] = ACTIONS(658),
    [anon_sym_required] = ACTIONS(658),
    [anon_sym_component] = ACTIONS(658),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [44] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(838),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5868),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(44),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(231),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4050),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_export] = ACTIONS(355),
    [anon_sym_type] = ACTIONS(359),
    [anon_sym_namespace] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(365),
    [anon_sym_with] = ACTIONS(163),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(367),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(173),
    [anon_sym_switch] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(187),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_async] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(213),
    [anon_sym_new] = ACTIONS(373),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(365),
    [anon_sym_readonly] = ACTIONS(365),
    [anon_sym_get] = ACTIONS(365),
    [anon_sym_set] = ACTIONS(365),
    [anon_sym_declare] = ACTIONS(379),
    [anon_sym_public] = ACTIONS(365),
    [anon_sym_private] = ACTIONS(365),
    [anon_sym_protected] = ACTIONS(365),
    [anon_sym_override] = ACTIONS(365),
    [anon_sym_module] = ACTIONS(381),
    [anon_sym_any] = ACTIONS(365),
    [anon_sym_number] = ACTIONS(365),
    [anon_sym_boolean] = ACTIONS(365),
    [anon_sym_string] = ACTIONS(365),
    [anon_sym_symbol] = ACTIONS(365),
    [anon_sym_object] = ACTIONS(365),
    [anon_sym_property] = ACTIONS(365),
    [anon_sym_signal] = ACTIONS(365),
    [anon_sym_on] = ACTIONS(365),
    [anon_sym_required] = ACTIONS(365),
    [anon_sym_component] = ACTIONS(365),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [45] = {
    [sym_export_statement] = STATE(2948),
    [sym_declaration] = STATE(2948),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(2948),
    [sym_statement] = STATE(2956),
    [sym_expression_statement] = STATE(2948),
    [sym_variable_declaration] = STATE(2949),
    [sym_lexical_declaration] = STATE(2949),
    [sym_statement_block] = STATE(2948),
    [sym_if_statement] = STATE(2948),
    [sym_switch_statement] = STATE(2948),
    [sym_for_statement] = STATE(2948),
    [sym_for_in_statement] = STATE(2948),
    [sym_while_statement] = STATE(2948),
    [sym_do_statement] = STATE(2948),
    [sym_try_statement] = STATE(2948),
    [sym_with_statement] = STATE(2948),
    [sym_break_statement] = STATE(2948),
    [sym_continue_statement] = STATE(2948),
    [sym_debugger_statement] = STATE(2948),
    [sym_return_statement] = STATE(2948),
    [sym_throw_statement] = STATE(2948),
    [sym_empty_statement] = STATE(2948),
    [sym_labeled_statement] = STATE(2948),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1978),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(2949),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(2949),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(2949),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5533),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(45),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(2949),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(2949),
    [sym_abstract_class_declaration] = STATE(2949),
    [sym_module] = STATE(2949),
    [sym_internal_module] = STATE(933),
    [sym_import_alias] = STATE(2949),
    [sym_interface_declaration] = STATE(2949),
    [sym_enum_declaration] = STATE(2949),
    [sym_type_alias_declaration] = STATE(2949),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4175),
    [sym_identifier] = ACTIONS(584),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_type] = ACTIONS(588),
    [anon_sym_namespace] = ACTIONS(590),
    [anon_sym_LBRACE] = ACTIONS(592),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(594),
    [anon_sym_from] = ACTIONS(596),
    [anon_sym_with] = ACTIONS(598),
    [anon_sym_var] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(602),
    [anon_sym_const] = ACTIONS(604),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(606),
    [anon_sym_switch] = ACTIONS(608),
    [anon_sym_for] = ACTIONS(610),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(596),
    [anon_sym_while] = ACTIONS(612),
    [anon_sym_do] = ACTIONS(614),
    [anon_sym_try] = ACTIONS(616),
    [anon_sym_break] = ACTIONS(618),
    [anon_sym_continue] = ACTIONS(620),
    [anon_sym_debugger] = ACTIONS(622),
    [anon_sym_return] = ACTIONS(624),
    [anon_sym_throw] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(628),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(630),
    [anon_sym_async] = ACTIONS(632),
    [anon_sym_function] = ACTIONS(634),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_readonly] = ACTIONS(596),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(638),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_override] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(640),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [anon_sym_object] = ACTIONS(596),
    [anon_sym_property] = ACTIONS(596),
    [anon_sym_signal] = ACTIONS(596),
    [anon_sym_on] = ACTIONS(596),
    [anon_sym_required] = ACTIONS(596),
    [anon_sym_component] = ACTIONS(596),
    [anon_sym_abstract] = ACTIONS(642),
    [anon_sym_interface] = ACTIONS(644),
    [anon_sym_enum] = ACTIONS(646),
    [sym_html_comment] = ACTIONS(5),
  },
  [46] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(796),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1978),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5533),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(46),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(2510),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4134),
    [sym_identifier] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_type] = ACTIONS(652),
    [anon_sym_namespace] = ACTIONS(654),
    [anon_sym_LBRACE] = ACTIONS(656),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(658),
    [anon_sym_with] = ACTIONS(660),
    [anon_sym_var] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(662),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(664),
    [anon_sym_switch] = ACTIONS(608),
    [anon_sym_for] = ACTIONS(666),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(658),
    [anon_sym_while] = ACTIONS(668),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(616),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(628),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(670),
    [anon_sym_async] = ACTIONS(672),
    [anon_sym_function] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(676),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(658),
    [anon_sym_readonly] = ACTIONS(658),
    [anon_sym_get] = ACTIONS(658),
    [anon_sym_set] = ACTIONS(658),
    [anon_sym_declare] = ACTIONS(678),
    [anon_sym_public] = ACTIONS(658),
    [anon_sym_private] = ACTIONS(658),
    [anon_sym_protected] = ACTIONS(658),
    [anon_sym_override] = ACTIONS(658),
    [anon_sym_module] = ACTIONS(680),
    [anon_sym_any] = ACTIONS(658),
    [anon_sym_number] = ACTIONS(658),
    [anon_sym_boolean] = ACTIONS(658),
    [anon_sym_string] = ACTIONS(658),
    [anon_sym_symbol] = ACTIONS(658),
    [anon_sym_object] = ACTIONS(658),
    [anon_sym_property] = ACTIONS(658),
    [anon_sym_signal] = ACTIONS(658),
    [anon_sym_on] = ACTIONS(658),
    [anon_sym_required] = ACTIONS(658),
    [anon_sym_component] = ACTIONS(658),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [47] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(839),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5868),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(47),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(231),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4050),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_export] = ACTIONS(355),
    [anon_sym_type] = ACTIONS(359),
    [anon_sym_namespace] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(365),
    [anon_sym_with] = ACTIONS(163),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(367),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(173),
    [anon_sym_switch] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(187),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_async] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(213),
    [anon_sym_new] = ACTIONS(373),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(365),
    [anon_sym_readonly] = ACTIONS(365),
    [anon_sym_get] = ACTIONS(365),
    [anon_sym_set] = ACTIONS(365),
    [anon_sym_declare] = ACTIONS(379),
    [anon_sym_public] = ACTIONS(365),
    [anon_sym_private] = ACTIONS(365),
    [anon_sym_protected] = ACTIONS(365),
    [anon_sym_override] = ACTIONS(365),
    [anon_sym_module] = ACTIONS(381),
    [anon_sym_any] = ACTIONS(365),
    [anon_sym_number] = ACTIONS(365),
    [anon_sym_boolean] = ACTIONS(365),
    [anon_sym_string] = ACTIONS(365),
    [anon_sym_symbol] = ACTIONS(365),
    [anon_sym_object] = ACTIONS(365),
    [anon_sym_property] = ACTIONS(365),
    [anon_sym_signal] = ACTIONS(365),
    [anon_sym_on] = ACTIONS(365),
    [anon_sym_required] = ACTIONS(365),
    [anon_sym_component] = ACTIONS(365),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [48] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(2910),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1978),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5533),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(48),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(2510),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4134),
    [sym_identifier] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_type] = ACTIONS(652),
    [anon_sym_namespace] = ACTIONS(654),
    [anon_sym_LBRACE] = ACTIONS(656),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(658),
    [anon_sym_with] = ACTIONS(660),
    [anon_sym_var] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(662),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(664),
    [anon_sym_switch] = ACTIONS(608),
    [anon_sym_for] = ACTIONS(666),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(658),
    [anon_sym_while] = ACTIONS(668),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(616),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(628),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(670),
    [anon_sym_async] = ACTIONS(672),
    [anon_sym_function] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(676),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(658),
    [anon_sym_readonly] = ACTIONS(658),
    [anon_sym_get] = ACTIONS(658),
    [anon_sym_set] = ACTIONS(658),
    [anon_sym_declare] = ACTIONS(678),
    [anon_sym_public] = ACTIONS(658),
    [anon_sym_private] = ACTIONS(658),
    [anon_sym_protected] = ACTIONS(658),
    [anon_sym_override] = ACTIONS(658),
    [anon_sym_module] = ACTIONS(680),
    [anon_sym_any] = ACTIONS(658),
    [anon_sym_number] = ACTIONS(658),
    [anon_sym_boolean] = ACTIONS(658),
    [anon_sym_string] = ACTIONS(658),
    [anon_sym_symbol] = ACTIONS(658),
    [anon_sym_object] = ACTIONS(658),
    [anon_sym_property] = ACTIONS(658),
    [anon_sym_signal] = ACTIONS(658),
    [anon_sym_on] = ACTIONS(658),
    [anon_sym_required] = ACTIONS(658),
    [anon_sym_component] = ACTIONS(658),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [49] = {
    [sym_export_statement] = STATE(2948),
    [sym_declaration] = STATE(2948),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(2948),
    [sym_statement] = STATE(2908),
    [sym_expression_statement] = STATE(2948),
    [sym_variable_declaration] = STATE(2949),
    [sym_lexical_declaration] = STATE(2949),
    [sym_statement_block] = STATE(2948),
    [sym_if_statement] = STATE(2948),
    [sym_switch_statement] = STATE(2948),
    [sym_for_statement] = STATE(2948),
    [sym_for_in_statement] = STATE(2948),
    [sym_while_statement] = STATE(2948),
    [sym_do_statement] = STATE(2948),
    [sym_try_statement] = STATE(2948),
    [sym_with_statement] = STATE(2948),
    [sym_break_statement] = STATE(2948),
    [sym_continue_statement] = STATE(2948),
    [sym_debugger_statement] = STATE(2948),
    [sym_return_statement] = STATE(2948),
    [sym_throw_statement] = STATE(2948),
    [sym_empty_statement] = STATE(2948),
    [sym_labeled_statement] = STATE(2948),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1978),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(2949),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(2949),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(2949),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5533),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(49),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(2949),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(2949),
    [sym_abstract_class_declaration] = STATE(2949),
    [sym_module] = STATE(2949),
    [sym_internal_module] = STATE(933),
    [sym_import_alias] = STATE(2949),
    [sym_interface_declaration] = STATE(2949),
    [sym_enum_declaration] = STATE(2949),
    [sym_type_alias_declaration] = STATE(2949),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4175),
    [sym_identifier] = ACTIONS(584),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_type] = ACTIONS(588),
    [anon_sym_namespace] = ACTIONS(590),
    [anon_sym_LBRACE] = ACTIONS(592),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(594),
    [anon_sym_from] = ACTIONS(596),
    [anon_sym_with] = ACTIONS(598),
    [anon_sym_var] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(602),
    [anon_sym_const] = ACTIONS(604),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(606),
    [anon_sym_switch] = ACTIONS(608),
    [anon_sym_for] = ACTIONS(610),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(596),
    [anon_sym_while] = ACTIONS(612),
    [anon_sym_do] = ACTIONS(614),
    [anon_sym_try] = ACTIONS(616),
    [anon_sym_break] = ACTIONS(618),
    [anon_sym_continue] = ACTIONS(620),
    [anon_sym_debugger] = ACTIONS(622),
    [anon_sym_return] = ACTIONS(624),
    [anon_sym_throw] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(628),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(630),
    [anon_sym_async] = ACTIONS(632),
    [anon_sym_function] = ACTIONS(634),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_readonly] = ACTIONS(596),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(638),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_override] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(640),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [anon_sym_object] = ACTIONS(596),
    [anon_sym_property] = ACTIONS(596),
    [anon_sym_signal] = ACTIONS(596),
    [anon_sym_on] = ACTIONS(596),
    [anon_sym_required] = ACTIONS(596),
    [anon_sym_component] = ACTIONS(596),
    [anon_sym_abstract] = ACTIONS(642),
    [anon_sym_interface] = ACTIONS(644),
    [anon_sym_enum] = ACTIONS(646),
    [sym_html_comment] = ACTIONS(5),
  },
  [50] = {
    [sym_export_statement] = STATE(2948),
    [sym_declaration] = STATE(2948),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(2948),
    [sym_statement] = STATE(2938),
    [sym_expression_statement] = STATE(2948),
    [sym_variable_declaration] = STATE(2949),
    [sym_lexical_declaration] = STATE(2949),
    [sym_statement_block] = STATE(2948),
    [sym_if_statement] = STATE(2948),
    [sym_switch_statement] = STATE(2948),
    [sym_for_statement] = STATE(2948),
    [sym_for_in_statement] = STATE(2948),
    [sym_while_statement] = STATE(2948),
    [sym_do_statement] = STATE(2948),
    [sym_try_statement] = STATE(2948),
    [sym_with_statement] = STATE(2948),
    [sym_break_statement] = STATE(2948),
    [sym_continue_statement] = STATE(2948),
    [sym_debugger_statement] = STATE(2948),
    [sym_return_statement] = STATE(2948),
    [sym_throw_statement] = STATE(2948),
    [sym_empty_statement] = STATE(2948),
    [sym_labeled_statement] = STATE(2948),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1978),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(2949),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(2949),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(2949),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5533),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(50),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(2949),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(2949),
    [sym_abstract_class_declaration] = STATE(2949),
    [sym_module] = STATE(2949),
    [sym_internal_module] = STATE(933),
    [sym_import_alias] = STATE(2949),
    [sym_interface_declaration] = STATE(2949),
    [sym_enum_declaration] = STATE(2949),
    [sym_type_alias_declaration] = STATE(2949),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4175),
    [sym_identifier] = ACTIONS(584),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_type] = ACTIONS(588),
    [anon_sym_namespace] = ACTIONS(590),
    [anon_sym_LBRACE] = ACTIONS(592),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(594),
    [anon_sym_from] = ACTIONS(596),
    [anon_sym_with] = ACTIONS(598),
    [anon_sym_var] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(602),
    [anon_sym_const] = ACTIONS(604),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(606),
    [anon_sym_switch] = ACTIONS(608),
    [anon_sym_for] = ACTIONS(610),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(596),
    [anon_sym_while] = ACTIONS(612),
    [anon_sym_do] = ACTIONS(614),
    [anon_sym_try] = ACTIONS(616),
    [anon_sym_break] = ACTIONS(618),
    [anon_sym_continue] = ACTIONS(620),
    [anon_sym_debugger] = ACTIONS(622),
    [anon_sym_return] = ACTIONS(624),
    [anon_sym_throw] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(628),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(630),
    [anon_sym_async] = ACTIONS(632),
    [anon_sym_function] = ACTIONS(634),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_readonly] = ACTIONS(596),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(638),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_override] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(640),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [anon_sym_object] = ACTIONS(596),
    [anon_sym_property] = ACTIONS(596),
    [anon_sym_signal] = ACTIONS(596),
    [anon_sym_on] = ACTIONS(596),
    [anon_sym_required] = ACTIONS(596),
    [anon_sym_component] = ACTIONS(596),
    [anon_sym_abstract] = ACTIONS(642),
    [anon_sym_interface] = ACTIONS(644),
    [anon_sym_enum] = ACTIONS(646),
    [sym_html_comment] = ACTIONS(5),
  },
  [51] = {
    [sym_export_statement] = STATE(2948),
    [sym_declaration] = STATE(2948),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(2948),
    [sym_statement] = STATE(2929),
    [sym_expression_statement] = STATE(2948),
    [sym_variable_declaration] = STATE(2949),
    [sym_lexical_declaration] = STATE(2949),
    [sym_statement_block] = STATE(2948),
    [sym_if_statement] = STATE(2948),
    [sym_switch_statement] = STATE(2948),
    [sym_for_statement] = STATE(2948),
    [sym_for_in_statement] = STATE(2948),
    [sym_while_statement] = STATE(2948),
    [sym_do_statement] = STATE(2948),
    [sym_try_statement] = STATE(2948),
    [sym_with_statement] = STATE(2948),
    [sym_break_statement] = STATE(2948),
    [sym_continue_statement] = STATE(2948),
    [sym_debugger_statement] = STATE(2948),
    [sym_return_statement] = STATE(2948),
    [sym_throw_statement] = STATE(2948),
    [sym_empty_statement] = STATE(2948),
    [sym_labeled_statement] = STATE(2948),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1978),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(2949),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(2949),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(2949),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5533),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(51),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(2949),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(2949),
    [sym_abstract_class_declaration] = STATE(2949),
    [sym_module] = STATE(2949),
    [sym_internal_module] = STATE(933),
    [sym_import_alias] = STATE(2949),
    [sym_interface_declaration] = STATE(2949),
    [sym_enum_declaration] = STATE(2949),
    [sym_type_alias_declaration] = STATE(2949),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4175),
    [sym_identifier] = ACTIONS(584),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_type] = ACTIONS(588),
    [anon_sym_namespace] = ACTIONS(590),
    [anon_sym_LBRACE] = ACTIONS(592),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(594),
    [anon_sym_from] = ACTIONS(596),
    [anon_sym_with] = ACTIONS(598),
    [anon_sym_var] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(602),
    [anon_sym_const] = ACTIONS(604),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(606),
    [anon_sym_switch] = ACTIONS(608),
    [anon_sym_for] = ACTIONS(610),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(596),
    [anon_sym_while] = ACTIONS(612),
    [anon_sym_do] = ACTIONS(614),
    [anon_sym_try] = ACTIONS(616),
    [anon_sym_break] = ACTIONS(618),
    [anon_sym_continue] = ACTIONS(620),
    [anon_sym_debugger] = ACTIONS(622),
    [anon_sym_return] = ACTIONS(624),
    [anon_sym_throw] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(628),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(630),
    [anon_sym_async] = ACTIONS(632),
    [anon_sym_function] = ACTIONS(634),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_readonly] = ACTIONS(596),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(638),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_override] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(640),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [anon_sym_object] = ACTIONS(596),
    [anon_sym_property] = ACTIONS(596),
    [anon_sym_signal] = ACTIONS(596),
    [anon_sym_on] = ACTIONS(596),
    [anon_sym_required] = ACTIONS(596),
    [anon_sym_component] = ACTIONS(596),
    [anon_sym_abstract] = ACTIONS(642),
    [anon_sym_interface] = ACTIONS(644),
    [anon_sym_enum] = ACTIONS(646),
    [sym_html_comment] = ACTIONS(5),
  },
  [52] = {
    [sym_export_statement] = STATE(2948),
    [sym_declaration] = STATE(2948),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(2948),
    [sym_statement] = STATE(2920),
    [sym_expression_statement] = STATE(2948),
    [sym_variable_declaration] = STATE(2949),
    [sym_lexical_declaration] = STATE(2949),
    [sym_statement_block] = STATE(2948),
    [sym_if_statement] = STATE(2948),
    [sym_switch_statement] = STATE(2948),
    [sym_for_statement] = STATE(2948),
    [sym_for_in_statement] = STATE(2948),
    [sym_while_statement] = STATE(2948),
    [sym_do_statement] = STATE(2948),
    [sym_try_statement] = STATE(2948),
    [sym_with_statement] = STATE(2948),
    [sym_break_statement] = STATE(2948),
    [sym_continue_statement] = STATE(2948),
    [sym_debugger_statement] = STATE(2948),
    [sym_return_statement] = STATE(2948),
    [sym_throw_statement] = STATE(2948),
    [sym_empty_statement] = STATE(2948),
    [sym_labeled_statement] = STATE(2948),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1978),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(2949),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(2949),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(2949),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5533),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(52),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(2949),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(2949),
    [sym_abstract_class_declaration] = STATE(2949),
    [sym_module] = STATE(2949),
    [sym_internal_module] = STATE(933),
    [sym_import_alias] = STATE(2949),
    [sym_interface_declaration] = STATE(2949),
    [sym_enum_declaration] = STATE(2949),
    [sym_type_alias_declaration] = STATE(2949),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4175),
    [sym_identifier] = ACTIONS(584),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_type] = ACTIONS(588),
    [anon_sym_namespace] = ACTIONS(590),
    [anon_sym_LBRACE] = ACTIONS(592),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(594),
    [anon_sym_from] = ACTIONS(596),
    [anon_sym_with] = ACTIONS(598),
    [anon_sym_var] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(602),
    [anon_sym_const] = ACTIONS(604),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(606),
    [anon_sym_switch] = ACTIONS(608),
    [anon_sym_for] = ACTIONS(610),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(596),
    [anon_sym_while] = ACTIONS(612),
    [anon_sym_do] = ACTIONS(614),
    [anon_sym_try] = ACTIONS(616),
    [anon_sym_break] = ACTIONS(618),
    [anon_sym_continue] = ACTIONS(620),
    [anon_sym_debugger] = ACTIONS(622),
    [anon_sym_return] = ACTIONS(624),
    [anon_sym_throw] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(628),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(630),
    [anon_sym_async] = ACTIONS(632),
    [anon_sym_function] = ACTIONS(634),
    [anon_sym_new] = ACTIONS(636),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_readonly] = ACTIONS(596),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(638),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_override] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(640),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [anon_sym_object] = ACTIONS(596),
    [anon_sym_property] = ACTIONS(596),
    [anon_sym_signal] = ACTIONS(596),
    [anon_sym_on] = ACTIONS(596),
    [anon_sym_required] = ACTIONS(596),
    [anon_sym_component] = ACTIONS(596),
    [anon_sym_abstract] = ACTIONS(642),
    [anon_sym_interface] = ACTIONS(644),
    [anon_sym_enum] = ACTIONS(646),
    [sym_html_comment] = ACTIONS(5),
  },
  [53] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(799),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5868),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(53),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(231),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4050),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_export] = ACTIONS(355),
    [anon_sym_type] = ACTIONS(359),
    [anon_sym_namespace] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(365),
    [anon_sym_with] = ACTIONS(163),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(367),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(173),
    [anon_sym_switch] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(187),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_async] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(213),
    [anon_sym_new] = ACTIONS(373),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(365),
    [anon_sym_readonly] = ACTIONS(365),
    [anon_sym_get] = ACTIONS(365),
    [anon_sym_set] = ACTIONS(365),
    [anon_sym_declare] = ACTIONS(379),
    [anon_sym_public] = ACTIONS(365),
    [anon_sym_private] = ACTIONS(365),
    [anon_sym_protected] = ACTIONS(365),
    [anon_sym_override] = ACTIONS(365),
    [anon_sym_module] = ACTIONS(381),
    [anon_sym_any] = ACTIONS(365),
    [anon_sym_number] = ACTIONS(365),
    [anon_sym_boolean] = ACTIONS(365),
    [anon_sym_string] = ACTIONS(365),
    [anon_sym_symbol] = ACTIONS(365),
    [anon_sym_object] = ACTIONS(365),
    [anon_sym_property] = ACTIONS(365),
    [anon_sym_signal] = ACTIONS(365),
    [anon_sym_on] = ACTIONS(365),
    [anon_sym_required] = ACTIONS(365),
    [anon_sym_component] = ACTIONS(365),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [54] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(4884),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1978),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5533),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(54),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(2510),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4134),
    [sym_identifier] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_type] = ACTIONS(652),
    [anon_sym_namespace] = ACTIONS(654),
    [anon_sym_LBRACE] = ACTIONS(656),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(658),
    [anon_sym_with] = ACTIONS(660),
    [anon_sym_var] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(662),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(664),
    [anon_sym_switch] = ACTIONS(608),
    [anon_sym_for] = ACTIONS(666),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(658),
    [anon_sym_while] = ACTIONS(668),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(616),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(628),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(670),
    [anon_sym_async] = ACTIONS(672),
    [anon_sym_function] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(676),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(658),
    [anon_sym_readonly] = ACTIONS(658),
    [anon_sym_get] = ACTIONS(658),
    [anon_sym_set] = ACTIONS(658),
    [anon_sym_declare] = ACTIONS(678),
    [anon_sym_public] = ACTIONS(658),
    [anon_sym_private] = ACTIONS(658),
    [anon_sym_protected] = ACTIONS(658),
    [anon_sym_override] = ACTIONS(658),
    [anon_sym_module] = ACTIONS(680),
    [anon_sym_any] = ACTIONS(658),
    [anon_sym_number] = ACTIONS(658),
    [anon_sym_boolean] = ACTIONS(658),
    [anon_sym_string] = ACTIONS(658),
    [anon_sym_symbol] = ACTIONS(658),
    [anon_sym_object] = ACTIONS(658),
    [anon_sym_property] = ACTIONS(658),
    [anon_sym_signal] = ACTIONS(658),
    [anon_sym_on] = ACTIONS(658),
    [anon_sym_required] = ACTIONS(658),
    [anon_sym_component] = ACTIONS(658),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [55] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(838),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1978),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5533),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(55),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(2510),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4134),
    [sym_identifier] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_type] = ACTIONS(652),
    [anon_sym_namespace] = ACTIONS(654),
    [anon_sym_LBRACE] = ACTIONS(656),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(658),
    [anon_sym_with] = ACTIONS(660),
    [anon_sym_var] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(662),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(664),
    [anon_sym_switch] = ACTIONS(608),
    [anon_sym_for] = ACTIONS(666),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(658),
    [anon_sym_while] = ACTIONS(668),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(616),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(628),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(670),
    [anon_sym_async] = ACTIONS(672),
    [anon_sym_function] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(676),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(658),
    [anon_sym_readonly] = ACTIONS(658),
    [anon_sym_get] = ACTIONS(658),
    [anon_sym_set] = ACTIONS(658),
    [anon_sym_declare] = ACTIONS(678),
    [anon_sym_public] = ACTIONS(658),
    [anon_sym_private] = ACTIONS(658),
    [anon_sym_protected] = ACTIONS(658),
    [anon_sym_override] = ACTIONS(658),
    [anon_sym_module] = ACTIONS(680),
    [anon_sym_any] = ACTIONS(658),
    [anon_sym_number] = ACTIONS(658),
    [anon_sym_boolean] = ACTIONS(658),
    [anon_sym_string] = ACTIONS(658),
    [anon_sym_symbol] = ACTIONS(658),
    [anon_sym_object] = ACTIONS(658),
    [anon_sym_property] = ACTIONS(658),
    [anon_sym_signal] = ACTIONS(658),
    [anon_sym_on] = ACTIONS(658),
    [anon_sym_required] = ACTIONS(658),
    [anon_sym_component] = ACTIONS(658),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [56] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(839),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1978),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5533),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(56),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(2510),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4134),
    [sym_identifier] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_type] = ACTIONS(652),
    [anon_sym_namespace] = ACTIONS(654),
    [anon_sym_LBRACE] = ACTIONS(656),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(658),
    [anon_sym_with] = ACTIONS(660),
    [anon_sym_var] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(662),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(664),
    [anon_sym_switch] = ACTIONS(608),
    [anon_sym_for] = ACTIONS(666),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(658),
    [anon_sym_while] = ACTIONS(668),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(616),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(628),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(670),
    [anon_sym_async] = ACTIONS(672),
    [anon_sym_function] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(676),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(658),
    [anon_sym_readonly] = ACTIONS(658),
    [anon_sym_get] = ACTIONS(658),
    [anon_sym_set] = ACTIONS(658),
    [anon_sym_declare] = ACTIONS(678),
    [anon_sym_public] = ACTIONS(658),
    [anon_sym_private] = ACTIONS(658),
    [anon_sym_protected] = ACTIONS(658),
    [anon_sym_override] = ACTIONS(658),
    [anon_sym_module] = ACTIONS(680),
    [anon_sym_any] = ACTIONS(658),
    [anon_sym_number] = ACTIONS(658),
    [anon_sym_boolean] = ACTIONS(658),
    [anon_sym_string] = ACTIONS(658),
    [anon_sym_symbol] = ACTIONS(658),
    [anon_sym_object] = ACTIONS(658),
    [anon_sym_property] = ACTIONS(658),
    [anon_sym_signal] = ACTIONS(658),
    [anon_sym_on] = ACTIONS(658),
    [anon_sym_required] = ACTIONS(658),
    [anon_sym_component] = ACTIONS(658),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [57] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(828),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1978),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5533),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(57),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(2510),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4134),
    [sym_identifier] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_type] = ACTIONS(652),
    [anon_sym_namespace] = ACTIONS(654),
    [anon_sym_LBRACE] = ACTIONS(656),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(658),
    [anon_sym_with] = ACTIONS(660),
    [anon_sym_var] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(662),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(664),
    [anon_sym_switch] = ACTIONS(608),
    [anon_sym_for] = ACTIONS(666),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(658),
    [anon_sym_while] = ACTIONS(668),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(616),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(628),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(670),
    [anon_sym_async] = ACTIONS(672),
    [anon_sym_function] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(676),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(658),
    [anon_sym_readonly] = ACTIONS(658),
    [anon_sym_get] = ACTIONS(658),
    [anon_sym_set] = ACTIONS(658),
    [anon_sym_declare] = ACTIONS(678),
    [anon_sym_public] = ACTIONS(658),
    [anon_sym_private] = ACTIONS(658),
    [anon_sym_protected] = ACTIONS(658),
    [anon_sym_override] = ACTIONS(658),
    [anon_sym_module] = ACTIONS(680),
    [anon_sym_any] = ACTIONS(658),
    [anon_sym_number] = ACTIONS(658),
    [anon_sym_boolean] = ACTIONS(658),
    [anon_sym_string] = ACTIONS(658),
    [anon_sym_symbol] = ACTIONS(658),
    [anon_sym_object] = ACTIONS(658),
    [anon_sym_property] = ACTIONS(658),
    [anon_sym_signal] = ACTIONS(658),
    [anon_sym_on] = ACTIONS(658),
    [anon_sym_required] = ACTIONS(658),
    [anon_sym_component] = ACTIONS(658),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [58] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(828),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5868),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(58),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(231),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4050),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_export] = ACTIONS(355),
    [anon_sym_type] = ACTIONS(359),
    [anon_sym_namespace] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(365),
    [anon_sym_with] = ACTIONS(163),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(367),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(173),
    [anon_sym_switch] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(187),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_async] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(213),
    [anon_sym_new] = ACTIONS(373),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(365),
    [anon_sym_readonly] = ACTIONS(365),
    [anon_sym_get] = ACTIONS(365),
    [anon_sym_set] = ACTIONS(365),
    [anon_sym_declare] = ACTIONS(379),
    [anon_sym_public] = ACTIONS(365),
    [anon_sym_private] = ACTIONS(365),
    [anon_sym_protected] = ACTIONS(365),
    [anon_sym_override] = ACTIONS(365),
    [anon_sym_module] = ACTIONS(381),
    [anon_sym_any] = ACTIONS(365),
    [anon_sym_number] = ACTIONS(365),
    [anon_sym_boolean] = ACTIONS(365),
    [anon_sym_string] = ACTIONS(365),
    [anon_sym_symbol] = ACTIONS(365),
    [anon_sym_object] = ACTIONS(365),
    [anon_sym_property] = ACTIONS(365),
    [anon_sym_signal] = ACTIONS(365),
    [anon_sym_on] = ACTIONS(365),
    [anon_sym_required] = ACTIONS(365),
    [anon_sym_component] = ACTIONS(365),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [59] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(2920),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1978),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5533),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(59),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(2510),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4134),
    [sym_identifier] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_type] = ACTIONS(652),
    [anon_sym_namespace] = ACTIONS(654),
    [anon_sym_LBRACE] = ACTIONS(656),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(658),
    [anon_sym_with] = ACTIONS(660),
    [anon_sym_var] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(662),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(664),
    [anon_sym_switch] = ACTIONS(608),
    [anon_sym_for] = ACTIONS(666),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(658),
    [anon_sym_while] = ACTIONS(668),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(616),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(628),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(670),
    [anon_sym_async] = ACTIONS(672),
    [anon_sym_function] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(676),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(658),
    [anon_sym_readonly] = ACTIONS(658),
    [anon_sym_get] = ACTIONS(658),
    [anon_sym_set] = ACTIONS(658),
    [anon_sym_declare] = ACTIONS(678),
    [anon_sym_public] = ACTIONS(658),
    [anon_sym_private] = ACTIONS(658),
    [anon_sym_protected] = ACTIONS(658),
    [anon_sym_override] = ACTIONS(658),
    [anon_sym_module] = ACTIONS(680),
    [anon_sym_any] = ACTIONS(658),
    [anon_sym_number] = ACTIONS(658),
    [anon_sym_boolean] = ACTIONS(658),
    [anon_sym_string] = ACTIONS(658),
    [anon_sym_symbol] = ACTIONS(658),
    [anon_sym_object] = ACTIONS(658),
    [anon_sym_property] = ACTIONS(658),
    [anon_sym_signal] = ACTIONS(658),
    [anon_sym_on] = ACTIONS(658),
    [anon_sym_required] = ACTIONS(658),
    [anon_sym_component] = ACTIONS(658),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [60] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(827),
    [sym_import] = STATE(3590),
    [sym_import_statement] = STATE(827),
    [sym_statement] = STATE(847),
    [sym_expression_statement] = STATE(827),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_statement_block] = STATE(827),
    [sym_if_statement] = STATE(827),
    [sym_switch_statement] = STATE(827),
    [sym_for_statement] = STATE(827),
    [sym_for_in_statement] = STATE(827),
    [sym_while_statement] = STATE(827),
    [sym_do_statement] = STATE(827),
    [sym_try_statement] = STATE(827),
    [sym_with_statement] = STATE(827),
    [sym_break_statement] = STATE(827),
    [sym_continue_statement] = STATE(827),
    [sym_debugger_statement] = STATE(827),
    [sym_return_statement] = STATE(827),
    [sym_throw_statement] = STATE(827),
    [sym_empty_statement] = STATE(827),
    [sym_labeled_statement] = STATE(827),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5868),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(60),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(231),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4050),
    [sym_identifier] = ACTIONS(353),
    [anon_sym_export] = ACTIONS(355),
    [anon_sym_type] = ACTIONS(359),
    [anon_sym_namespace] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(159),
    [anon_sym_from] = ACTIONS(365),
    [anon_sym_with] = ACTIONS(163),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(367),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(173),
    [anon_sym_switch] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(183),
    [anon_sym_do] = ACTIONS(185),
    [anon_sym_try] = ACTIONS(187),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_continue] = ACTIONS(191),
    [anon_sym_debugger] = ACTIONS(193),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_throw] = ACTIONS(197),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_async] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(213),
    [anon_sym_new] = ACTIONS(373),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(365),
    [anon_sym_readonly] = ACTIONS(365),
    [anon_sym_get] = ACTIONS(365),
    [anon_sym_set] = ACTIONS(365),
    [anon_sym_declare] = ACTIONS(379),
    [anon_sym_public] = ACTIONS(365),
    [anon_sym_private] = ACTIONS(365),
    [anon_sym_protected] = ACTIONS(365),
    [anon_sym_override] = ACTIONS(365),
    [anon_sym_module] = ACTIONS(381),
    [anon_sym_any] = ACTIONS(365),
    [anon_sym_number] = ACTIONS(365),
    [anon_sym_boolean] = ACTIONS(365),
    [anon_sym_string] = ACTIONS(365),
    [anon_sym_symbol] = ACTIONS(365),
    [anon_sym_object] = ACTIONS(365),
    [anon_sym_property] = ACTIONS(365),
    [anon_sym_signal] = ACTIONS(365),
    [anon_sym_on] = ACTIONS(365),
    [anon_sym_required] = ACTIONS(365),
    [anon_sym_component] = ACTIONS(365),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [61] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2129),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_assignment_pattern] = STATE(5110),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_nested_identifier] = STATE(6331),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1373),
    [sym_subscript_expression] = STATE(1373),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3818),
    [sym_spread_element] = STATE(5024),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(2642),
    [sym_comment] = STATE(61),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4333),
    [sym_pattern] = STATE(4802),
    [sym_rest_pattern] = STATE(4442),
    [sym_non_null_expression] = STATE(1373),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4084),
    [sym_tuple_parameter] = STATE(5584),
    [sym_optional_tuple_parameter] = STATE(5584),
    [sym_optional_type] = STATE(5584),
    [sym_rest_type] = STATE(5584),
    [sym__tuple_type_member] = STATE(5193),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_type_arguments] = STATE(463),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5583),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [aux_sym_array_repeat1] = STATE(5018),
    [aux_sym_array_pattern_repeat1] = STATE(5103),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_export] = ACTIONS(684),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_type] = ACTIONS(684),
    [anon_sym_namespace] = ACTIONS(688),
    [anon_sym_LBRACE] = ACTIONS(690),
    [anon_sym_COMMA] = ACTIONS(692),
    [anon_sym_typeof] = ACTIONS(694),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(684),
    [anon_sym_let] = ACTIONS(684),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(48),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(684),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(704),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(706),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(708),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(712),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(718),
    [anon_sym_DASH] = ACTIONS(718),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [sym_number] = ACTIONS(102),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(730),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(110),
    [sym_false] = ACTIONS(110),
    [sym_null] = ACTIONS(110),
    [sym_undefined] = ACTIONS(732),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(684),
    [anon_sym_readonly] = ACTIONS(734),
    [anon_sym_get] = ACTIONS(684),
    [anon_sym_set] = ACTIONS(684),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(684),
    [anon_sym_public] = ACTIONS(684),
    [anon_sym_private] = ACTIONS(684),
    [anon_sym_protected] = ACTIONS(684),
    [anon_sym_override] = ACTIONS(684),
    [anon_sym_module] = ACTIONS(684),
    [anon_sym_any] = ACTIONS(738),
    [anon_sym_number] = ACTIONS(738),
    [anon_sym_boolean] = ACTIONS(738),
    [anon_sym_string] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(738),
    [anon_sym_object] = ACTIONS(738),
    [anon_sym_property] = ACTIONS(684),
    [anon_sym_signal] = ACTIONS(684),
    [anon_sym_on] = ACTIONS(684),
    [anon_sym_required] = ACTIONS(684),
    [anon_sym_component] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [62] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2129),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_assignment_pattern] = STATE(5110),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_nested_identifier] = STATE(6331),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1373),
    [sym_subscript_expression] = STATE(1373),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3818),
    [sym_spread_element] = STATE(5024),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(2642),
    [sym_comment] = STATE(62),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4333),
    [sym_pattern] = STATE(4802),
    [sym_rest_pattern] = STATE(4442),
    [sym_non_null_expression] = STATE(1373),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4084),
    [sym_tuple_parameter] = STATE(5584),
    [sym_optional_tuple_parameter] = STATE(5584),
    [sym_optional_type] = STATE(5584),
    [sym_rest_type] = STATE(5584),
    [sym__tuple_type_member] = STATE(5193),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_type_arguments] = STATE(463),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5583),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [aux_sym_array_repeat1] = STATE(5018),
    [aux_sym_array_pattern_repeat1] = STATE(5103),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_export] = ACTIONS(684),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_type] = ACTIONS(684),
    [anon_sym_namespace] = ACTIONS(688),
    [anon_sym_LBRACE] = ACTIONS(690),
    [anon_sym_COMMA] = ACTIONS(692),
    [anon_sym_typeof] = ACTIONS(694),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(684),
    [anon_sym_let] = ACTIONS(684),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(48),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(684),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(740),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(706),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(708),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(712),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(718),
    [anon_sym_DASH] = ACTIONS(718),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [sym_number] = ACTIONS(102),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(730),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(110),
    [sym_false] = ACTIONS(110),
    [sym_null] = ACTIONS(110),
    [sym_undefined] = ACTIONS(732),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(684),
    [anon_sym_readonly] = ACTIONS(734),
    [anon_sym_get] = ACTIONS(684),
    [anon_sym_set] = ACTIONS(684),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(684),
    [anon_sym_public] = ACTIONS(684),
    [anon_sym_private] = ACTIONS(684),
    [anon_sym_protected] = ACTIONS(684),
    [anon_sym_override] = ACTIONS(684),
    [anon_sym_module] = ACTIONS(684),
    [anon_sym_any] = ACTIONS(738),
    [anon_sym_number] = ACTIONS(738),
    [anon_sym_boolean] = ACTIONS(738),
    [anon_sym_string] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(738),
    [anon_sym_object] = ACTIONS(738),
    [anon_sym_property] = ACTIONS(684),
    [anon_sym_signal] = ACTIONS(684),
    [anon_sym_on] = ACTIONS(684),
    [anon_sym_required] = ACTIONS(684),
    [anon_sym_component] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [63] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2129),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_assignment_pattern] = STATE(5110),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_nested_identifier] = STATE(6331),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1373),
    [sym_subscript_expression] = STATE(1373),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3818),
    [sym_spread_element] = STATE(5024),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(2642),
    [sym_comment] = STATE(63),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4333),
    [sym_pattern] = STATE(4802),
    [sym_rest_pattern] = STATE(4442),
    [sym_non_null_expression] = STATE(1373),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4084),
    [sym_tuple_parameter] = STATE(5584),
    [sym_optional_tuple_parameter] = STATE(5584),
    [sym_optional_type] = STATE(5584),
    [sym_rest_type] = STATE(5584),
    [sym__tuple_type_member] = STATE(5193),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_type_arguments] = STATE(463),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5583),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [aux_sym_array_repeat1] = STATE(5018),
    [aux_sym_array_pattern_repeat1] = STATE(5103),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_export] = ACTIONS(684),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_type] = ACTIONS(684),
    [anon_sym_namespace] = ACTIONS(688),
    [anon_sym_LBRACE] = ACTIONS(690),
    [anon_sym_COMMA] = ACTIONS(692),
    [anon_sym_typeof] = ACTIONS(694),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(684),
    [anon_sym_let] = ACTIONS(684),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(48),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(684),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(742),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(706),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(708),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(712),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(718),
    [anon_sym_DASH] = ACTIONS(718),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [sym_number] = ACTIONS(102),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(730),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(110),
    [sym_false] = ACTIONS(110),
    [sym_null] = ACTIONS(110),
    [sym_undefined] = ACTIONS(732),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(684),
    [anon_sym_readonly] = ACTIONS(734),
    [anon_sym_get] = ACTIONS(684),
    [anon_sym_set] = ACTIONS(684),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(684),
    [anon_sym_public] = ACTIONS(684),
    [anon_sym_private] = ACTIONS(684),
    [anon_sym_protected] = ACTIONS(684),
    [anon_sym_override] = ACTIONS(684),
    [anon_sym_module] = ACTIONS(684),
    [anon_sym_any] = ACTIONS(738),
    [anon_sym_number] = ACTIONS(738),
    [anon_sym_boolean] = ACTIONS(738),
    [anon_sym_string] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(738),
    [anon_sym_object] = ACTIONS(738),
    [anon_sym_property] = ACTIONS(684),
    [anon_sym_signal] = ACTIONS(684),
    [anon_sym_on] = ACTIONS(684),
    [anon_sym_required] = ACTIONS(684),
    [anon_sym_component] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [64] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1421),
    [sym_expression] = STATE(2680),
    [sym_primary_expression] = STATE(2044),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1421),
    [sym_subscript_expression] = STATE(1421),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(64),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1421),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [aux_sym_object_repeat1] = STATE(4915),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(744),
    [anon_sym_export] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(746),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(750),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(754),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(746),
    [anon_sym_let] = ACTIONS(746),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(746),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(769),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(773),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(746),
    [anon_sym_readonly] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(746),
    [anon_sym_set] = ACTIONS(746),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_declare] = ACTIONS(746),
    [anon_sym_public] = ACTIONS(746),
    [anon_sym_private] = ACTIONS(746),
    [anon_sym_protected] = ACTIONS(746),
    [anon_sym_override] = ACTIONS(746),
    [anon_sym_module] = ACTIONS(746),
    [anon_sym_any] = ACTIONS(746),
    [anon_sym_number] = ACTIONS(746),
    [anon_sym_boolean] = ACTIONS(746),
    [anon_sym_string] = ACTIONS(746),
    [anon_sym_symbol] = ACTIONS(746),
    [anon_sym_object] = ACTIONS(746),
    [anon_sym_property] = ACTIONS(746),
    [anon_sym_signal] = ACTIONS(746),
    [anon_sym_on] = ACTIONS(746),
    [anon_sym_required] = ACTIONS(746),
    [anon_sym_component] = ACTIONS(746),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [65] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1421),
    [sym_expression] = STATE(2680),
    [sym_primary_expression] = STATE(2044),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1421),
    [sym_subscript_expression] = STATE(1421),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(65),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1421),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [aux_sym_object_repeat1] = STATE(4915),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(744),
    [anon_sym_export] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(746),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(750),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(777),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(746),
    [anon_sym_let] = ACTIONS(746),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(746),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(769),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(773),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(746),
    [anon_sym_readonly] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(746),
    [anon_sym_set] = ACTIONS(746),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_declare] = ACTIONS(746),
    [anon_sym_public] = ACTIONS(746),
    [anon_sym_private] = ACTIONS(746),
    [anon_sym_protected] = ACTIONS(746),
    [anon_sym_override] = ACTIONS(746),
    [anon_sym_module] = ACTIONS(746),
    [anon_sym_any] = ACTIONS(746),
    [anon_sym_number] = ACTIONS(746),
    [anon_sym_boolean] = ACTIONS(746),
    [anon_sym_string] = ACTIONS(746),
    [anon_sym_symbol] = ACTIONS(746),
    [anon_sym_object] = ACTIONS(746),
    [anon_sym_property] = ACTIONS(746),
    [anon_sym_signal] = ACTIONS(746),
    [anon_sym_on] = ACTIONS(746),
    [anon_sym_required] = ACTIONS(746),
    [anon_sym_component] = ACTIONS(746),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [66] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2129),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_assignment_pattern] = STATE(5110),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_nested_identifier] = STATE(6331),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1373),
    [sym_subscript_expression] = STATE(1373),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3818),
    [sym_spread_element] = STATE(5024),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(2642),
    [sym_comment] = STATE(66),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4333),
    [sym_pattern] = STATE(4802),
    [sym_rest_pattern] = STATE(4442),
    [sym_non_null_expression] = STATE(1373),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4084),
    [sym_tuple_parameter] = STATE(5584),
    [sym_optional_tuple_parameter] = STATE(5584),
    [sym_optional_type] = STATE(5584),
    [sym_rest_type] = STATE(5584),
    [sym__tuple_type_member] = STATE(5193),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_type_arguments] = STATE(463),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5583),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [aux_sym_array_repeat1] = STATE(5018),
    [aux_sym_array_pattern_repeat1] = STATE(5103),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_export] = ACTIONS(684),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_type] = ACTIONS(684),
    [anon_sym_namespace] = ACTIONS(688),
    [anon_sym_LBRACE] = ACTIONS(690),
    [anon_sym_COMMA] = ACTIONS(692),
    [anon_sym_typeof] = ACTIONS(694),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(684),
    [anon_sym_let] = ACTIONS(684),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(48),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(684),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(779),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(706),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(708),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(712),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(718),
    [anon_sym_DASH] = ACTIONS(718),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [sym_number] = ACTIONS(102),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(730),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(110),
    [sym_false] = ACTIONS(110),
    [sym_null] = ACTIONS(110),
    [sym_undefined] = ACTIONS(732),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(684),
    [anon_sym_readonly] = ACTIONS(734),
    [anon_sym_get] = ACTIONS(684),
    [anon_sym_set] = ACTIONS(684),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(684),
    [anon_sym_public] = ACTIONS(684),
    [anon_sym_private] = ACTIONS(684),
    [anon_sym_protected] = ACTIONS(684),
    [anon_sym_override] = ACTIONS(684),
    [anon_sym_module] = ACTIONS(684),
    [anon_sym_any] = ACTIONS(738),
    [anon_sym_number] = ACTIONS(738),
    [anon_sym_boolean] = ACTIONS(738),
    [anon_sym_string] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(738),
    [anon_sym_object] = ACTIONS(738),
    [anon_sym_property] = ACTIONS(684),
    [anon_sym_signal] = ACTIONS(684),
    [anon_sym_on] = ACTIONS(684),
    [anon_sym_required] = ACTIONS(684),
    [anon_sym_component] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [67] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1421),
    [sym_expression] = STATE(2680),
    [sym_primary_expression] = STATE(2044),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1421),
    [sym_subscript_expression] = STATE(1421),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(67),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1421),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [aux_sym_object_repeat1] = STATE(4915),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(744),
    [anon_sym_export] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(746),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(750),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(746),
    [anon_sym_let] = ACTIONS(746),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(746),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(769),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(773),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(746),
    [anon_sym_readonly] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(746),
    [anon_sym_set] = ACTIONS(746),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_declare] = ACTIONS(746),
    [anon_sym_public] = ACTIONS(746),
    [anon_sym_private] = ACTIONS(746),
    [anon_sym_protected] = ACTIONS(746),
    [anon_sym_override] = ACTIONS(746),
    [anon_sym_module] = ACTIONS(746),
    [anon_sym_any] = ACTIONS(746),
    [anon_sym_number] = ACTIONS(746),
    [anon_sym_boolean] = ACTIONS(746),
    [anon_sym_string] = ACTIONS(746),
    [anon_sym_symbol] = ACTIONS(746),
    [anon_sym_object] = ACTIONS(746),
    [anon_sym_property] = ACTIONS(746),
    [anon_sym_signal] = ACTIONS(746),
    [anon_sym_on] = ACTIONS(746),
    [anon_sym_required] = ACTIONS(746),
    [anon_sym_component] = ACTIONS(746),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [68] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2150),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_assignment_pattern] = STATE(5110),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_nested_identifier] = STATE(6331),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1373),
    [sym_subscript_expression] = STATE(1373),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3818),
    [sym_spread_element] = STATE(5355),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(2642),
    [sym_comment] = STATE(68),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4333),
    [sym_pattern] = STATE(4802),
    [sym_rest_pattern] = STATE(4442),
    [sym_non_null_expression] = STATE(1373),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4084),
    [sym_tuple_parameter] = STATE(5584),
    [sym_optional_tuple_parameter] = STATE(5584),
    [sym_optional_type] = STATE(5584),
    [sym_rest_type] = STATE(5584),
    [sym__tuple_type_member] = STATE(5193),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_type_arguments] = STATE(463),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5583),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [aux_sym_array_repeat1] = STATE(5351),
    [aux_sym_array_pattern_repeat1] = STATE(5103),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_export] = ACTIONS(684),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_type] = ACTIONS(684),
    [anon_sym_namespace] = ACTIONS(688),
    [anon_sym_LBRACE] = ACTIONS(690),
    [anon_sym_COMMA] = ACTIONS(692),
    [anon_sym_typeof] = ACTIONS(694),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(684),
    [anon_sym_let] = ACTIONS(684),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(48),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(684),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(783),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(706),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(708),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(712),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(718),
    [anon_sym_DASH] = ACTIONS(718),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [sym_number] = ACTIONS(102),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(730),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(110),
    [sym_false] = ACTIONS(110),
    [sym_null] = ACTIONS(110),
    [sym_undefined] = ACTIONS(732),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(684),
    [anon_sym_readonly] = ACTIONS(734),
    [anon_sym_get] = ACTIONS(684),
    [anon_sym_set] = ACTIONS(684),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(684),
    [anon_sym_public] = ACTIONS(684),
    [anon_sym_private] = ACTIONS(684),
    [anon_sym_protected] = ACTIONS(684),
    [anon_sym_override] = ACTIONS(684),
    [anon_sym_module] = ACTIONS(684),
    [anon_sym_any] = ACTIONS(738),
    [anon_sym_number] = ACTIONS(738),
    [anon_sym_boolean] = ACTIONS(738),
    [anon_sym_string] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(738),
    [anon_sym_object] = ACTIONS(738),
    [anon_sym_property] = ACTIONS(684),
    [anon_sym_signal] = ACTIONS(684),
    [anon_sym_on] = ACTIONS(684),
    [anon_sym_required] = ACTIONS(684),
    [anon_sym_component] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [69] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2129),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_assignment_pattern] = STATE(5110),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_nested_identifier] = STATE(6331),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1373),
    [sym_subscript_expression] = STATE(1373),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3818),
    [sym_spread_element] = STATE(5024),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(2642),
    [sym_comment] = STATE(69),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4333),
    [sym_pattern] = STATE(4802),
    [sym_rest_pattern] = STATE(4442),
    [sym_non_null_expression] = STATE(1373),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4084),
    [sym_tuple_parameter] = STATE(5584),
    [sym_optional_tuple_parameter] = STATE(5584),
    [sym_optional_type] = STATE(5584),
    [sym_rest_type] = STATE(5584),
    [sym__tuple_type_member] = STATE(5193),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_type_arguments] = STATE(463),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5583),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [aux_sym_array_repeat1] = STATE(5018),
    [aux_sym_array_pattern_repeat1] = STATE(5103),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_export] = ACTIONS(684),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_type] = ACTIONS(684),
    [anon_sym_namespace] = ACTIONS(688),
    [anon_sym_LBRACE] = ACTIONS(690),
    [anon_sym_COMMA] = ACTIONS(692),
    [anon_sym_typeof] = ACTIONS(694),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(684),
    [anon_sym_let] = ACTIONS(684),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(48),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(684),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(785),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(706),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(708),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(712),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(718),
    [anon_sym_DASH] = ACTIONS(718),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [sym_number] = ACTIONS(102),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(730),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(110),
    [sym_false] = ACTIONS(110),
    [sym_null] = ACTIONS(110),
    [sym_undefined] = ACTIONS(732),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(684),
    [anon_sym_readonly] = ACTIONS(734),
    [anon_sym_get] = ACTIONS(684),
    [anon_sym_set] = ACTIONS(684),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(684),
    [anon_sym_public] = ACTIONS(684),
    [anon_sym_private] = ACTIONS(684),
    [anon_sym_protected] = ACTIONS(684),
    [anon_sym_override] = ACTIONS(684),
    [anon_sym_module] = ACTIONS(684),
    [anon_sym_any] = ACTIONS(738),
    [anon_sym_number] = ACTIONS(738),
    [anon_sym_boolean] = ACTIONS(738),
    [anon_sym_string] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(738),
    [anon_sym_object] = ACTIONS(738),
    [anon_sym_property] = ACTIONS(684),
    [anon_sym_signal] = ACTIONS(684),
    [anon_sym_on] = ACTIONS(684),
    [anon_sym_required] = ACTIONS(684),
    [anon_sym_component] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [70] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2129),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_assignment_pattern] = STATE(5110),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_nested_identifier] = STATE(6331),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1373),
    [sym_subscript_expression] = STATE(1373),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3818),
    [sym_spread_element] = STATE(5024),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(2642),
    [sym_comment] = STATE(70),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4333),
    [sym_pattern] = STATE(4802),
    [sym_rest_pattern] = STATE(4442),
    [sym_non_null_expression] = STATE(1373),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4084),
    [sym_tuple_parameter] = STATE(5584),
    [sym_optional_tuple_parameter] = STATE(5584),
    [sym_optional_type] = STATE(5584),
    [sym_rest_type] = STATE(5584),
    [sym__tuple_type_member] = STATE(4939),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_type_arguments] = STATE(463),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5583),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [aux_sym_array_repeat1] = STATE(5018),
    [aux_sym_array_pattern_repeat1] = STATE(5103),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_export] = ACTIONS(684),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_type] = ACTIONS(684),
    [anon_sym_namespace] = ACTIONS(688),
    [anon_sym_LBRACE] = ACTIONS(690),
    [anon_sym_COMMA] = ACTIONS(787),
    [anon_sym_typeof] = ACTIONS(694),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(684),
    [anon_sym_let] = ACTIONS(684),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(48),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(684),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(789),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(706),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(708),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(712),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(718),
    [anon_sym_DASH] = ACTIONS(718),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [sym_number] = ACTIONS(102),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(730),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(110),
    [sym_false] = ACTIONS(110),
    [sym_null] = ACTIONS(110),
    [sym_undefined] = ACTIONS(732),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(684),
    [anon_sym_readonly] = ACTIONS(734),
    [anon_sym_get] = ACTIONS(684),
    [anon_sym_set] = ACTIONS(684),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(684),
    [anon_sym_public] = ACTIONS(684),
    [anon_sym_private] = ACTIONS(684),
    [anon_sym_protected] = ACTIONS(684),
    [anon_sym_override] = ACTIONS(684),
    [anon_sym_module] = ACTIONS(684),
    [anon_sym_any] = ACTIONS(738),
    [anon_sym_number] = ACTIONS(738),
    [anon_sym_boolean] = ACTIONS(738),
    [anon_sym_string] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(738),
    [anon_sym_object] = ACTIONS(738),
    [anon_sym_property] = ACTIONS(684),
    [anon_sym_signal] = ACTIONS(684),
    [anon_sym_on] = ACTIONS(684),
    [anon_sym_required] = ACTIONS(684),
    [anon_sym_component] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [71] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1421),
    [sym_expression] = STATE(2680),
    [sym_primary_expression] = STATE(2044),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1421),
    [sym_subscript_expression] = STATE(1421),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(71),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1421),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [aux_sym_object_repeat1] = STATE(5251),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(744),
    [anon_sym_export] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(746),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(750),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(746),
    [anon_sym_let] = ACTIONS(746),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(746),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(769),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(773),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(746),
    [anon_sym_readonly] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(746),
    [anon_sym_set] = ACTIONS(746),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_declare] = ACTIONS(746),
    [anon_sym_public] = ACTIONS(746),
    [anon_sym_private] = ACTIONS(746),
    [anon_sym_protected] = ACTIONS(746),
    [anon_sym_override] = ACTIONS(746),
    [anon_sym_module] = ACTIONS(746),
    [anon_sym_any] = ACTIONS(746),
    [anon_sym_number] = ACTIONS(746),
    [anon_sym_boolean] = ACTIONS(746),
    [anon_sym_string] = ACTIONS(746),
    [anon_sym_symbol] = ACTIONS(746),
    [anon_sym_object] = ACTIONS(746),
    [anon_sym_property] = ACTIONS(746),
    [anon_sym_signal] = ACTIONS(746),
    [anon_sym_on] = ACTIONS(746),
    [anon_sym_required] = ACTIONS(746),
    [anon_sym_component] = ACTIONS(746),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [72] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2129),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_assignment_pattern] = STATE(5110),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_nested_identifier] = STATE(6331),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1373),
    [sym_subscript_expression] = STATE(1373),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3818),
    [sym_spread_element] = STATE(5024),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(2642),
    [sym_comment] = STATE(72),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4333),
    [sym_pattern] = STATE(4802),
    [sym_rest_pattern] = STATE(4442),
    [sym_non_null_expression] = STATE(1373),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4084),
    [sym_tuple_parameter] = STATE(5584),
    [sym_optional_tuple_parameter] = STATE(5584),
    [sym_optional_type] = STATE(5584),
    [sym_rest_type] = STATE(5584),
    [sym__tuple_type_member] = STATE(5193),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_type_arguments] = STATE(463),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5583),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [aux_sym_array_repeat1] = STATE(5018),
    [aux_sym_array_pattern_repeat1] = STATE(5103),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_export] = ACTIONS(684),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_type] = ACTIONS(684),
    [anon_sym_namespace] = ACTIONS(688),
    [anon_sym_LBRACE] = ACTIONS(690),
    [anon_sym_COMMA] = ACTIONS(692),
    [anon_sym_typeof] = ACTIONS(694),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(684),
    [anon_sym_let] = ACTIONS(684),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(48),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(684),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(793),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(706),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(708),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(712),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(718),
    [anon_sym_DASH] = ACTIONS(718),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [sym_number] = ACTIONS(102),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(730),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(110),
    [sym_false] = ACTIONS(110),
    [sym_null] = ACTIONS(110),
    [sym_undefined] = ACTIONS(732),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(684),
    [anon_sym_readonly] = ACTIONS(734),
    [anon_sym_get] = ACTIONS(684),
    [anon_sym_set] = ACTIONS(684),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(684),
    [anon_sym_public] = ACTIONS(684),
    [anon_sym_private] = ACTIONS(684),
    [anon_sym_protected] = ACTIONS(684),
    [anon_sym_override] = ACTIONS(684),
    [anon_sym_module] = ACTIONS(684),
    [anon_sym_any] = ACTIONS(738),
    [anon_sym_number] = ACTIONS(738),
    [anon_sym_boolean] = ACTIONS(738),
    [anon_sym_string] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(738),
    [anon_sym_object] = ACTIONS(738),
    [anon_sym_property] = ACTIONS(684),
    [anon_sym_signal] = ACTIONS(684),
    [anon_sym_on] = ACTIONS(684),
    [anon_sym_required] = ACTIONS(684),
    [anon_sym_component] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [73] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2150),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_assignment_pattern] = STATE(5110),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_nested_identifier] = STATE(6331),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1373),
    [sym_subscript_expression] = STATE(1373),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3818),
    [sym_spread_element] = STATE(5355),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(2642),
    [sym_comment] = STATE(73),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4333),
    [sym_pattern] = STATE(4802),
    [sym_rest_pattern] = STATE(4442),
    [sym_non_null_expression] = STATE(1373),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4084),
    [sym_tuple_parameter] = STATE(5584),
    [sym_optional_tuple_parameter] = STATE(5584),
    [sym_optional_type] = STATE(5584),
    [sym_rest_type] = STATE(5584),
    [sym__tuple_type_member] = STATE(5193),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_type_arguments] = STATE(463),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5583),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [aux_sym_array_repeat1] = STATE(5351),
    [aux_sym_array_pattern_repeat1] = STATE(5103),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_export] = ACTIONS(684),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_type] = ACTIONS(684),
    [anon_sym_namespace] = ACTIONS(688),
    [anon_sym_LBRACE] = ACTIONS(690),
    [anon_sym_COMMA] = ACTIONS(692),
    [anon_sym_typeof] = ACTIONS(694),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(684),
    [anon_sym_let] = ACTIONS(684),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(48),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(684),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(795),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(706),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(708),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(712),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(718),
    [anon_sym_DASH] = ACTIONS(718),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [sym_number] = ACTIONS(102),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(730),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(110),
    [sym_false] = ACTIONS(110),
    [sym_null] = ACTIONS(110),
    [sym_undefined] = ACTIONS(732),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(684),
    [anon_sym_readonly] = ACTIONS(734),
    [anon_sym_get] = ACTIONS(684),
    [anon_sym_set] = ACTIONS(684),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(684),
    [anon_sym_public] = ACTIONS(684),
    [anon_sym_private] = ACTIONS(684),
    [anon_sym_protected] = ACTIONS(684),
    [anon_sym_override] = ACTIONS(684),
    [anon_sym_module] = ACTIONS(684),
    [anon_sym_any] = ACTIONS(738),
    [anon_sym_number] = ACTIONS(738),
    [anon_sym_boolean] = ACTIONS(738),
    [anon_sym_string] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(738),
    [anon_sym_object] = ACTIONS(738),
    [anon_sym_property] = ACTIONS(684),
    [anon_sym_signal] = ACTIONS(684),
    [anon_sym_on] = ACTIONS(684),
    [anon_sym_required] = ACTIONS(684),
    [anon_sym_component] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [74] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2129),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_assignment_pattern] = STATE(5110),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_nested_identifier] = STATE(6331),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1373),
    [sym_subscript_expression] = STATE(1373),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3818),
    [sym_spread_element] = STATE(5024),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(2642),
    [sym_comment] = STATE(74),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4333),
    [sym_pattern] = STATE(4802),
    [sym_rest_pattern] = STATE(4442),
    [sym_non_null_expression] = STATE(1373),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4084),
    [sym_tuple_parameter] = STATE(5584),
    [sym_optional_tuple_parameter] = STATE(5584),
    [sym_optional_type] = STATE(5584),
    [sym_rest_type] = STATE(5584),
    [sym__tuple_type_member] = STATE(5193),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_type_arguments] = STATE(463),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5583),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [aux_sym_array_repeat1] = STATE(5018),
    [aux_sym_array_pattern_repeat1] = STATE(5103),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_export] = ACTIONS(684),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_type] = ACTIONS(684),
    [anon_sym_namespace] = ACTIONS(688),
    [anon_sym_LBRACE] = ACTIONS(690),
    [anon_sym_COMMA] = ACTIONS(692),
    [anon_sym_typeof] = ACTIONS(694),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(684),
    [anon_sym_let] = ACTIONS(684),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(48),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(684),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(702),
    [anon_sym_RBRACK] = ACTIONS(797),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(706),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(708),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(712),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(718),
    [anon_sym_DASH] = ACTIONS(718),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [sym_number] = ACTIONS(102),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(730),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(110),
    [sym_false] = ACTIONS(110),
    [sym_null] = ACTIONS(110),
    [sym_undefined] = ACTIONS(732),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(684),
    [anon_sym_readonly] = ACTIONS(734),
    [anon_sym_get] = ACTIONS(684),
    [anon_sym_set] = ACTIONS(684),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(684),
    [anon_sym_public] = ACTIONS(684),
    [anon_sym_private] = ACTIONS(684),
    [anon_sym_protected] = ACTIONS(684),
    [anon_sym_override] = ACTIONS(684),
    [anon_sym_module] = ACTIONS(684),
    [anon_sym_any] = ACTIONS(738),
    [anon_sym_number] = ACTIONS(738),
    [anon_sym_boolean] = ACTIONS(738),
    [anon_sym_string] = ACTIONS(738),
    [anon_sym_symbol] = ACTIONS(738),
    [anon_sym_object] = ACTIONS(738),
    [anon_sym_property] = ACTIONS(684),
    [anon_sym_signal] = ACTIONS(684),
    [anon_sym_on] = ACTIONS(684),
    [anon_sym_required] = ACTIONS(684),
    [anon_sym_component] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [75] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3951),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(75),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(4600),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(799),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_EQ] = ACTIONS(134),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(32),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(803),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(23),
    [anon_sym_COLON] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(806),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(64),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(809),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(45),
    [anon_sym_DASH] = ACTIONS(45),
    [anon_sym_SLASH] = ACTIONS(86),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(811),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(97),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(814),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(819),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(821),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(23),
    [anon_sym_readonly] = ACTIONS(23),
    [anon_sym_get] = ACTIONS(23),
    [anon_sym_set] = ACTIONS(23),
    [anon_sym_QMARK] = ACTIONS(823),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_public] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(23),
    [anon_sym_protected] = ACTIONS(23),
    [anon_sym_override] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(23),
    [anon_sym_number] = ACTIONS(23),
    [anon_sym_boolean] = ACTIONS(23),
    [anon_sym_string] = ACTIONS(23),
    [anon_sym_symbol] = ACTIONS(23),
    [anon_sym_object] = ACTIONS(23),
    [anon_sym_property] = ACTIONS(23),
    [anon_sym_signal] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [anon_sym_required] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(23),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [76] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3951),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(76),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(4322),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(799),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_EQ] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(32),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_COMMA] = ACTIONS(36),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(803),
    [anon_sym_RPAREN] = ACTIONS(36),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(23),
    [anon_sym_COLON] = ACTIONS(36),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(806),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(64),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(68),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(809),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(45),
    [anon_sym_DASH] = ACTIONS(45),
    [anon_sym_SLASH] = ACTIONS(86),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(811),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(97),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(814),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(825),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(821),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(23),
    [anon_sym_readonly] = ACTIONS(23),
    [anon_sym_get] = ACTIONS(23),
    [anon_sym_set] = ACTIONS(23),
    [anon_sym_QMARK] = ACTIONS(823),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_public] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(23),
    [anon_sym_protected] = ACTIONS(23),
    [anon_sym_override] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(23),
    [anon_sym_number] = ACTIONS(23),
    [anon_sym_boolean] = ACTIONS(23),
    [anon_sym_string] = ACTIONS(23),
    [anon_sym_symbol] = ACTIONS(23),
    [anon_sym_object] = ACTIONS(23),
    [anon_sym_property] = ACTIONS(23),
    [anon_sym_signal] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [anon_sym_required] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(23),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [77] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3951),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(77),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(4521),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(799),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_EQ] = ACTIONS(134),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(32),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(803),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(23),
    [anon_sym_COLON] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(806),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(64),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(809),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(45),
    [anon_sym_DASH] = ACTIONS(45),
    [anon_sym_SLASH] = ACTIONS(86),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(811),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(97),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(814),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(827),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(821),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(23),
    [anon_sym_readonly] = ACTIONS(23),
    [anon_sym_get] = ACTIONS(23),
    [anon_sym_set] = ACTIONS(23),
    [anon_sym_QMARK] = ACTIONS(823),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_public] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(23),
    [anon_sym_protected] = ACTIONS(23),
    [anon_sym_override] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(23),
    [anon_sym_number] = ACTIONS(23),
    [anon_sym_boolean] = ACTIONS(23),
    [anon_sym_string] = ACTIONS(23),
    [anon_sym_symbol] = ACTIONS(23),
    [anon_sym_object] = ACTIONS(23),
    [anon_sym_property] = ACTIONS(23),
    [anon_sym_signal] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [anon_sym_required] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(23),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [78] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3951),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(78),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(4411),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(799),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_EQ] = ACTIONS(134),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(32),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(803),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(23),
    [anon_sym_COLON] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(806),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(64),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(809),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(45),
    [anon_sym_DASH] = ACTIONS(45),
    [anon_sym_SLASH] = ACTIONS(86),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(811),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(97),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(814),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(829),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(821),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(23),
    [anon_sym_readonly] = ACTIONS(23),
    [anon_sym_get] = ACTIONS(23),
    [anon_sym_set] = ACTIONS(23),
    [anon_sym_QMARK] = ACTIONS(823),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_public] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(23),
    [anon_sym_protected] = ACTIONS(23),
    [anon_sym_override] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(23),
    [anon_sym_number] = ACTIONS(23),
    [anon_sym_boolean] = ACTIONS(23),
    [anon_sym_string] = ACTIONS(23),
    [anon_sym_symbol] = ACTIONS(23),
    [anon_sym_object] = ACTIONS(23),
    [anon_sym_property] = ACTIONS(23),
    [anon_sym_signal] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [anon_sym_required] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(23),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [79] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3951),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(79),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(4322),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(799),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_EQ] = ACTIONS(134),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(32),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(803),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(23),
    [anon_sym_COLON] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(806),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(64),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(809),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(45),
    [anon_sym_DASH] = ACTIONS(45),
    [anon_sym_SLASH] = ACTIONS(86),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(811),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(97),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(814),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(825),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(821),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(23),
    [anon_sym_readonly] = ACTIONS(23),
    [anon_sym_get] = ACTIONS(23),
    [anon_sym_set] = ACTIONS(23),
    [anon_sym_QMARK] = ACTIONS(823),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_public] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(23),
    [anon_sym_protected] = ACTIONS(23),
    [anon_sym_override] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(23),
    [anon_sym_number] = ACTIONS(23),
    [anon_sym_boolean] = ACTIONS(23),
    [anon_sym_string] = ACTIONS(23),
    [anon_sym_symbol] = ACTIONS(23),
    [anon_sym_object] = ACTIONS(23),
    [anon_sym_property] = ACTIONS(23),
    [anon_sym_signal] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [anon_sym_required] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(23),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [80] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3951),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(80),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(4413),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(799),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_EQ] = ACTIONS(134),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(32),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(803),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(23),
    [anon_sym_COLON] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(806),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(64),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(809),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(45),
    [anon_sym_DASH] = ACTIONS(45),
    [anon_sym_SLASH] = ACTIONS(86),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(811),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(97),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(814),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(831),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(821),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(23),
    [anon_sym_readonly] = ACTIONS(23),
    [anon_sym_get] = ACTIONS(23),
    [anon_sym_set] = ACTIONS(23),
    [anon_sym_QMARK] = ACTIONS(823),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_public] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(23),
    [anon_sym_protected] = ACTIONS(23),
    [anon_sym_override] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(23),
    [anon_sym_number] = ACTIONS(23),
    [anon_sym_boolean] = ACTIONS(23),
    [anon_sym_string] = ACTIONS(23),
    [anon_sym_symbol] = ACTIONS(23),
    [anon_sym_object] = ACTIONS(23),
    [anon_sym_property] = ACTIONS(23),
    [anon_sym_signal] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [anon_sym_required] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(23),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [81] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3951),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(81),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(4519),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(799),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_EQ] = ACTIONS(134),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(32),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(803),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(23),
    [anon_sym_COLON] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(806),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(64),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(809),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(45),
    [anon_sym_DASH] = ACTIONS(45),
    [anon_sym_SLASH] = ACTIONS(86),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(811),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(97),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(814),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(833),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(821),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(23),
    [anon_sym_readonly] = ACTIONS(23),
    [anon_sym_get] = ACTIONS(23),
    [anon_sym_set] = ACTIONS(23),
    [anon_sym_QMARK] = ACTIONS(823),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_public] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(23),
    [anon_sym_protected] = ACTIONS(23),
    [anon_sym_override] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(23),
    [anon_sym_number] = ACTIONS(23),
    [anon_sym_boolean] = ACTIONS(23),
    [anon_sym_string] = ACTIONS(23),
    [anon_sym_symbol] = ACTIONS(23),
    [anon_sym_object] = ACTIONS(23),
    [anon_sym_property] = ACTIONS(23),
    [anon_sym_signal] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [anon_sym_required] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(23),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [82] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3951),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(82),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(4527),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(799),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_EQ] = ACTIONS(134),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(32),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(45),
    [anon_sym_LPAREN] = ACTIONS(803),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(23),
    [anon_sym_COLON] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(806),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(64),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(809),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(45),
    [anon_sym_DASH] = ACTIONS(45),
    [anon_sym_SLASH] = ACTIONS(86),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(811),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(97),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(814),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(835),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(821),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(23),
    [anon_sym_readonly] = ACTIONS(23),
    [anon_sym_get] = ACTIONS(23),
    [anon_sym_set] = ACTIONS(23),
    [anon_sym_QMARK] = ACTIONS(823),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_public] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(23),
    [anon_sym_protected] = ACTIONS(23),
    [anon_sym_override] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(23),
    [anon_sym_number] = ACTIONS(23),
    [anon_sym_boolean] = ACTIONS(23),
    [anon_sym_string] = ACTIONS(23),
    [anon_sym_symbol] = ACTIONS(23),
    [anon_sym_object] = ACTIONS(23),
    [anon_sym_property] = ACTIONS(23),
    [anon_sym_signal] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [anon_sym_required] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(23),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [83] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1703),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(83),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(837),
    [anon_sym_export] = ACTIONS(839),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(839),
    [anon_sym_EQ] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(841),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(36),
    [anon_sym_RBRACE] = ACTIONS(36),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(839),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_RPAREN] = ACTIONS(36),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(839),
    [anon_sym_COLON] = ACTIONS(36),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_RBRACK] = ACTIONS(36),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(68),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(853),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(839),
    [anon_sym_readonly] = ACTIONS(839),
    [anon_sym_get] = ACTIONS(839),
    [anon_sym_set] = ACTIONS(839),
    [anon_sym_QMARK] = ACTIONS(823),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_override] = ACTIONS(839),
    [anon_sym_module] = ACTIONS(839),
    [anon_sym_any] = ACTIONS(839),
    [anon_sym_number] = ACTIONS(839),
    [anon_sym_boolean] = ACTIONS(839),
    [anon_sym_string] = ACTIONS(839),
    [anon_sym_symbol] = ACTIONS(839),
    [anon_sym_object] = ACTIONS(839),
    [anon_sym_property] = ACTIONS(839),
    [anon_sym_signal] = ACTIONS(839),
    [anon_sym_on] = ACTIONS(839),
    [anon_sym_required] = ACTIONS(839),
    [anon_sym_component] = ACTIONS(839),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [84] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1703),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(84),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_EQ] = ACTIONS(863),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_COMMA] = ACTIONS(867),
    [anon_sym_RBRACE] = ACTIONS(867),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_RPAREN] = ACTIONS(867),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_COLON] = ACTIONS(867),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_RBRACK] = ACTIONS(867),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_QMARK] = ACTIONS(875),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [85] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1703),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(85),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_EQ] = ACTIONS(134),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_RBRACE] = ACTIONS(137),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_COLON] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_RBRACK] = ACTIONS(137),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_QMARK] = ACTIONS(823),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [86] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1703),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(86),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(837),
    [anon_sym_export] = ACTIONS(839),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(839),
    [anon_sym_EQ] = ACTIONS(877),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(841),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(839),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_RPAREN] = ACTIONS(70),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(839),
    [anon_sym_COLON] = ACTIONS(70),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_RBRACK] = ACTIONS(70),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(68),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(853),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(839),
    [anon_sym_readonly] = ACTIONS(839),
    [anon_sym_get] = ACTIONS(839),
    [anon_sym_set] = ACTIONS(839),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_override] = ACTIONS(839),
    [anon_sym_module] = ACTIONS(839),
    [anon_sym_any] = ACTIONS(839),
    [anon_sym_number] = ACTIONS(839),
    [anon_sym_boolean] = ACTIONS(839),
    [anon_sym_string] = ACTIONS(839),
    [anon_sym_symbol] = ACTIONS(839),
    [anon_sym_object] = ACTIONS(839),
    [anon_sym_property] = ACTIONS(839),
    [anon_sym_signal] = ACTIONS(839),
    [anon_sym_on] = ACTIONS(839),
    [anon_sym_required] = ACTIONS(839),
    [anon_sym_component] = ACTIONS(839),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [87] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1703),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(87),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_EQ] = ACTIONS(863),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_RPAREN] = ACTIONS(70),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_COLON] = ACTIONS(70),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_RBRACK] = ACTIONS(70),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(68),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [88] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1703),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(88),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4444),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5690),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(837),
    [anon_sym_export] = ACTIONS(839),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(839),
    [anon_sym_EQ] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(841),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(36),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(839),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_RPAREN] = ACTIONS(36),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(839),
    [anon_sym_COLON] = ACTIONS(36),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_RBRACK] = ACTIONS(36),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(68),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(853),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(839),
    [anon_sym_readonly] = ACTIONS(839),
    [anon_sym_get] = ACTIONS(839),
    [anon_sym_set] = ACTIONS(839),
    [anon_sym_QMARK] = ACTIONS(823),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_override] = ACTIONS(839),
    [anon_sym_module] = ACTIONS(839),
    [anon_sym_any] = ACTIONS(839),
    [anon_sym_number] = ACTIONS(839),
    [anon_sym_boolean] = ACTIONS(839),
    [anon_sym_string] = ACTIONS(839),
    [anon_sym_symbol] = ACTIONS(839),
    [anon_sym_object] = ACTIONS(839),
    [anon_sym_property] = ACTIONS(839),
    [anon_sym_signal] = ACTIONS(839),
    [anon_sym_on] = ACTIONS(839),
    [anon_sym_required] = ACTIONS(839),
    [anon_sym_component] = ACTIONS(839),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [89] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1703),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(89),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4444),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5690),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(837),
    [anon_sym_export] = ACTIONS(839),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(839),
    [anon_sym_EQ] = ACTIONS(877),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(841),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(839),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_RPAREN] = ACTIONS(70),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(839),
    [anon_sym_COLON] = ACTIONS(70),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_RBRACK] = ACTIONS(70),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(68),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(853),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(839),
    [anon_sym_readonly] = ACTIONS(839),
    [anon_sym_get] = ACTIONS(839),
    [anon_sym_set] = ACTIONS(839),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_override] = ACTIONS(839),
    [anon_sym_module] = ACTIONS(839),
    [anon_sym_any] = ACTIONS(839),
    [anon_sym_number] = ACTIONS(839),
    [anon_sym_boolean] = ACTIONS(839),
    [anon_sym_string] = ACTIONS(839),
    [anon_sym_symbol] = ACTIONS(839),
    [anon_sym_object] = ACTIONS(839),
    [anon_sym_property] = ACTIONS(839),
    [anon_sym_signal] = ACTIONS(839),
    [anon_sym_on] = ACTIONS(839),
    [anon_sym_required] = ACTIONS(839),
    [anon_sym_component] = ACTIONS(839),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [90] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1748),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_nested_identifier] = STATE(6331),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym__formal_parameter] = STATE(5358),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1373),
    [sym_subscript_expression] = STATE(1373),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3818),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_sequence_expression] = STATE(6278),
    [sym_string] = STATE(2439),
    [sym_comment] = STATE(90),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4333),
    [sym_pattern] = STATE(4280),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1373),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_nested_type_identifier] = STATE(3178),
    [sym_accessibility_modifier] = STATE(289),
    [sym_override_modifier] = STATE(310),
    [sym_required_parameter] = STATE(5545),
    [sym_optional_parameter] = STATE(5545),
    [sym__parameter_name] = STATE(3943),
    [sym__type] = STATE(4771),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_type_arguments] = STATE(463),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5583),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [aux_sym_export_statement_repeat1] = STATE(257),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_export] = ACTIONS(684),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_type] = ACTIONS(684),
    [anon_sym_namespace] = ACTIONS(688),
    [anon_sym_LBRACE] = ACTIONS(881),
    [anon_sym_typeof] = ACTIONS(883),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(684),
    [anon_sym_let] = ACTIONS(684),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(48),
    [anon_sym_RPAREN] = ACTIONS(885),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(684),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(887),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(706),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(708),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(895),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(897),
    [sym_false] = ACTIONS(897),
    [sym_null] = ACTIONS(897),
    [sym_undefined] = ACTIONS(899),
    [anon_sym_AT] = ACTIONS(901),
    [anon_sym_static] = ACTIONS(684),
    [anon_sym_readonly] = ACTIONS(903),
    [anon_sym_get] = ACTIONS(684),
    [anon_sym_set] = ACTIONS(684),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(684),
    [anon_sym_public] = ACTIONS(905),
    [anon_sym_private] = ACTIONS(905),
    [anon_sym_protected] = ACTIONS(905),
    [anon_sym_override] = ACTIONS(907),
    [anon_sym_module] = ACTIONS(684),
    [anon_sym_any] = ACTIONS(909),
    [anon_sym_number] = ACTIONS(909),
    [anon_sym_boolean] = ACTIONS(909),
    [anon_sym_string] = ACTIONS(909),
    [anon_sym_symbol] = ACTIONS(909),
    [anon_sym_object] = ACTIONS(909),
    [anon_sym_property] = ACTIONS(684),
    [anon_sym_signal] = ACTIONS(684),
    [anon_sym_on] = ACTIONS(684),
    [anon_sym_required] = ACTIONS(684),
    [anon_sym_component] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [91] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1782),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_nested_identifier] = STATE(6331),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym__formal_parameter] = STATE(5358),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1373),
    [sym_subscript_expression] = STATE(1373),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3818),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_sequence_expression] = STATE(5976),
    [sym_string] = STATE(2439),
    [sym_comment] = STATE(91),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4333),
    [sym_pattern] = STATE(4280),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1373),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_nested_type_identifier] = STATE(3178),
    [sym_accessibility_modifier] = STATE(289),
    [sym_override_modifier] = STATE(310),
    [sym_required_parameter] = STATE(5545),
    [sym_optional_parameter] = STATE(5545),
    [sym__parameter_name] = STATE(3943),
    [sym__type] = STATE(4771),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_type_arguments] = STATE(463),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5583),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [aux_sym_export_statement_repeat1] = STATE(257),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_export] = ACTIONS(684),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_type] = ACTIONS(684),
    [anon_sym_namespace] = ACTIONS(688),
    [anon_sym_LBRACE] = ACTIONS(881),
    [anon_sym_typeof] = ACTIONS(883),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(684),
    [anon_sym_let] = ACTIONS(684),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(48),
    [anon_sym_RPAREN] = ACTIONS(885),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(684),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(887),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(706),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(708),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(895),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(897),
    [sym_false] = ACTIONS(897),
    [sym_null] = ACTIONS(897),
    [sym_undefined] = ACTIONS(899),
    [anon_sym_AT] = ACTIONS(901),
    [anon_sym_static] = ACTIONS(684),
    [anon_sym_readonly] = ACTIONS(903),
    [anon_sym_get] = ACTIONS(684),
    [anon_sym_set] = ACTIONS(684),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(684),
    [anon_sym_public] = ACTIONS(905),
    [anon_sym_private] = ACTIONS(905),
    [anon_sym_protected] = ACTIONS(905),
    [anon_sym_override] = ACTIONS(907),
    [anon_sym_module] = ACTIONS(684),
    [anon_sym_any] = ACTIONS(909),
    [anon_sym_number] = ACTIONS(909),
    [anon_sym_boolean] = ACTIONS(909),
    [anon_sym_string] = ACTIONS(909),
    [anon_sym_symbol] = ACTIONS(909),
    [anon_sym_object] = ACTIONS(909),
    [anon_sym_property] = ACTIONS(684),
    [anon_sym_signal] = ACTIONS(684),
    [anon_sym_on] = ACTIONS(684),
    [anon_sym_required] = ACTIONS(684),
    [anon_sym_component] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [92] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1782),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_nested_identifier] = STATE(6331),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym__formal_parameter] = STATE(5358),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1373),
    [sym_subscript_expression] = STATE(1373),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3818),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_sequence_expression] = STATE(5976),
    [sym_string] = STATE(2439),
    [sym_comment] = STATE(92),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4333),
    [sym_pattern] = STATE(4280),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1373),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_nested_type_identifier] = STATE(3178),
    [sym_accessibility_modifier] = STATE(289),
    [sym_override_modifier] = STATE(310),
    [sym_required_parameter] = STATE(5545),
    [sym_optional_parameter] = STATE(5545),
    [sym__parameter_name] = STATE(3943),
    [sym__type] = STATE(4830),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_type_arguments] = STATE(463),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5583),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [aux_sym_export_statement_repeat1] = STATE(257),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_export] = ACTIONS(684),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_type] = ACTIONS(684),
    [anon_sym_namespace] = ACTIONS(688),
    [anon_sym_LBRACE] = ACTIONS(881),
    [anon_sym_typeof] = ACTIONS(883),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(684),
    [anon_sym_let] = ACTIONS(684),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(48),
    [anon_sym_RPAREN] = ACTIONS(885),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(684),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(887),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(706),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(708),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(895),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(897),
    [sym_false] = ACTIONS(897),
    [sym_null] = ACTIONS(897),
    [sym_undefined] = ACTIONS(899),
    [anon_sym_AT] = ACTIONS(901),
    [anon_sym_static] = ACTIONS(684),
    [anon_sym_readonly] = ACTIONS(903),
    [anon_sym_get] = ACTIONS(684),
    [anon_sym_set] = ACTIONS(684),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(684),
    [anon_sym_public] = ACTIONS(905),
    [anon_sym_private] = ACTIONS(905),
    [anon_sym_protected] = ACTIONS(905),
    [anon_sym_override] = ACTIONS(907),
    [anon_sym_module] = ACTIONS(684),
    [anon_sym_any] = ACTIONS(909),
    [anon_sym_number] = ACTIONS(909),
    [anon_sym_boolean] = ACTIONS(909),
    [anon_sym_string] = ACTIONS(909),
    [anon_sym_symbol] = ACTIONS(909),
    [anon_sym_object] = ACTIONS(909),
    [anon_sym_property] = ACTIONS(684),
    [anon_sym_signal] = ACTIONS(684),
    [anon_sym_on] = ACTIONS(684),
    [anon_sym_required] = ACTIONS(684),
    [anon_sym_component] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [93] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1703),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(93),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_EQ] = ACTIONS(863),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [94] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1421),
    [sym_expression] = STATE(2680),
    [sym_primary_expression] = STATE(2044),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1421),
    [sym_subscript_expression] = STATE(1421),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(94),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1421),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(744),
    [anon_sym_export] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(746),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(750),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(746),
    [anon_sym_let] = ACTIONS(746),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(746),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(913),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(769),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(773),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(746),
    [anon_sym_readonly] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(746),
    [anon_sym_set] = ACTIONS(746),
    [anon_sym_declare] = ACTIONS(746),
    [anon_sym_public] = ACTIONS(746),
    [anon_sym_private] = ACTIONS(746),
    [anon_sym_protected] = ACTIONS(746),
    [anon_sym_override] = ACTIONS(746),
    [anon_sym_module] = ACTIONS(746),
    [anon_sym_any] = ACTIONS(746),
    [anon_sym_number] = ACTIONS(746),
    [anon_sym_boolean] = ACTIONS(746),
    [anon_sym_string] = ACTIONS(746),
    [anon_sym_symbol] = ACTIONS(746),
    [anon_sym_object] = ACTIONS(746),
    [anon_sym_property] = ACTIONS(746),
    [anon_sym_signal] = ACTIONS(746),
    [anon_sym_on] = ACTIONS(746),
    [anon_sym_required] = ACTIONS(746),
    [anon_sym_component] = ACTIONS(746),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [95] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_nested_identifier] = STATE(6331),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym__formal_parameter] = STATE(5358),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3951),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(2642),
    [sym_comment] = STATE(95),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4333),
    [sym_pattern] = STATE(4280),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_nested_type_identifier] = STATE(3178),
    [sym_accessibility_modifier] = STATE(289),
    [sym_override_modifier] = STATE(310),
    [sym_required_parameter] = STATE(5545),
    [sym_optional_parameter] = STATE(5545),
    [sym__parameter_name] = STATE(3943),
    [sym__type] = STATE(4830),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_type_arguments] = STATE(540),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5583),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [aux_sym_export_statement_repeat1] = STATE(257),
    [sym_identifier] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_namespace] = ACTIONS(32),
    [anon_sym_LBRACE] = ACTIONS(34),
    [anon_sym_typeof] = ACTIONS(39),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(23),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(48),
    [anon_sym_RPAREN] = ACTIONS(885),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(23),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(54),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(64),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(72),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(84),
    [anon_sym_DASH] = ACTIONS(84),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [sym_number] = ACTIONS(102),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(915),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(110),
    [sym_false] = ACTIONS(110),
    [sym_null] = ACTIONS(110),
    [sym_undefined] = ACTIONS(112),
    [anon_sym_AT] = ACTIONS(901),
    [anon_sym_static] = ACTIONS(23),
    [anon_sym_readonly] = ACTIONS(917),
    [anon_sym_get] = ACTIONS(23),
    [anon_sym_set] = ACTIONS(23),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_public] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(919),
    [anon_sym_protected] = ACTIONS(919),
    [anon_sym_override] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(120),
    [anon_sym_number] = ACTIONS(120),
    [anon_sym_boolean] = ACTIONS(120),
    [anon_sym_string] = ACTIONS(120),
    [anon_sym_symbol] = ACTIONS(120),
    [anon_sym_object] = ACTIONS(120),
    [anon_sym_property] = ACTIONS(23),
    [anon_sym_signal] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [anon_sym_required] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(23),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [96] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1421),
    [sym_expression] = STATE(2680),
    [sym_primary_expression] = STATE(2044),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1421),
    [sym_subscript_expression] = STATE(1421),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(96),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1421),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(744),
    [anon_sym_export] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(746),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(750),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(746),
    [anon_sym_let] = ACTIONS(746),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(746),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(923),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(769),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(773),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(746),
    [anon_sym_readonly] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(746),
    [anon_sym_set] = ACTIONS(746),
    [anon_sym_declare] = ACTIONS(746),
    [anon_sym_public] = ACTIONS(746),
    [anon_sym_private] = ACTIONS(746),
    [anon_sym_protected] = ACTIONS(746),
    [anon_sym_override] = ACTIONS(746),
    [anon_sym_module] = ACTIONS(746),
    [anon_sym_any] = ACTIONS(746),
    [anon_sym_number] = ACTIONS(746),
    [anon_sym_boolean] = ACTIONS(746),
    [anon_sym_string] = ACTIONS(746),
    [anon_sym_symbol] = ACTIONS(746),
    [anon_sym_object] = ACTIONS(746),
    [anon_sym_property] = ACTIONS(746),
    [anon_sym_signal] = ACTIONS(746),
    [anon_sym_on] = ACTIONS(746),
    [anon_sym_required] = ACTIONS(746),
    [anon_sym_component] = ACTIONS(746),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [97] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_nested_identifier] = STATE(6331),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym__formal_parameter] = STATE(5358),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3951),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(2642),
    [sym_comment] = STATE(97),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4333),
    [sym_pattern] = STATE(4280),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_nested_type_identifier] = STATE(3178),
    [sym_accessibility_modifier] = STATE(289),
    [sym_override_modifier] = STATE(310),
    [sym_required_parameter] = STATE(5545),
    [sym_optional_parameter] = STATE(5545),
    [sym__parameter_name] = STATE(3943),
    [sym__type] = STATE(4821),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_type_arguments] = STATE(540),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5583),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [aux_sym_export_statement_repeat1] = STATE(257),
    [sym_identifier] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_namespace] = ACTIONS(32),
    [anon_sym_LBRACE] = ACTIONS(34),
    [anon_sym_typeof] = ACTIONS(39),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(23),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(48),
    [anon_sym_RPAREN] = ACTIONS(885),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(23),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(54),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(64),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(72),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(84),
    [anon_sym_DASH] = ACTIONS(84),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [sym_number] = ACTIONS(102),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(915),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(110),
    [sym_false] = ACTIONS(110),
    [sym_null] = ACTIONS(110),
    [sym_undefined] = ACTIONS(112),
    [anon_sym_AT] = ACTIONS(901),
    [anon_sym_static] = ACTIONS(23),
    [anon_sym_readonly] = ACTIONS(917),
    [anon_sym_get] = ACTIONS(23),
    [anon_sym_set] = ACTIONS(23),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_public] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(919),
    [anon_sym_protected] = ACTIONS(919),
    [anon_sym_override] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(120),
    [anon_sym_number] = ACTIONS(120),
    [anon_sym_boolean] = ACTIONS(120),
    [anon_sym_string] = ACTIONS(120),
    [anon_sym_symbol] = ACTIONS(120),
    [anon_sym_object] = ACTIONS(120),
    [anon_sym_property] = ACTIONS(23),
    [anon_sym_signal] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [anon_sym_required] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(23),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [98] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_nested_identifier] = STATE(6331),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym__formal_parameter] = STATE(5358),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3951),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(2642),
    [sym_comment] = STATE(98),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4333),
    [sym_pattern] = STATE(4280),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_nested_type_identifier] = STATE(3178),
    [sym_accessibility_modifier] = STATE(289),
    [sym_override_modifier] = STATE(310),
    [sym_required_parameter] = STATE(5545),
    [sym_optional_parameter] = STATE(5545),
    [sym__parameter_name] = STATE(3943),
    [sym__type] = STATE(4729),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_type_arguments] = STATE(540),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5583),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [aux_sym_export_statement_repeat1] = STATE(257),
    [sym_identifier] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_namespace] = ACTIONS(32),
    [anon_sym_LBRACE] = ACTIONS(34),
    [anon_sym_typeof] = ACTIONS(39),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(23),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(48),
    [anon_sym_RPAREN] = ACTIONS(885),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(23),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(54),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(64),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(72),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(84),
    [anon_sym_DASH] = ACTIONS(84),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [sym_number] = ACTIONS(102),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(915),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(110),
    [sym_false] = ACTIONS(110),
    [sym_null] = ACTIONS(110),
    [sym_undefined] = ACTIONS(112),
    [anon_sym_AT] = ACTIONS(901),
    [anon_sym_static] = ACTIONS(23),
    [anon_sym_readonly] = ACTIONS(917),
    [anon_sym_get] = ACTIONS(23),
    [anon_sym_set] = ACTIONS(23),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_public] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(919),
    [anon_sym_protected] = ACTIONS(919),
    [anon_sym_override] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(120),
    [anon_sym_number] = ACTIONS(120),
    [anon_sym_boolean] = ACTIONS(120),
    [anon_sym_string] = ACTIONS(120),
    [anon_sym_symbol] = ACTIONS(120),
    [anon_sym_object] = ACTIONS(120),
    [anon_sym_property] = ACTIONS(23),
    [anon_sym_signal] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [anon_sym_required] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(23),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [99] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_nested_identifier] = STATE(6331),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym__formal_parameter] = STATE(5358),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3951),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(2642),
    [sym_comment] = STATE(99),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4333),
    [sym_pattern] = STATE(4280),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_nested_type_identifier] = STATE(3178),
    [sym_accessibility_modifier] = STATE(289),
    [sym_override_modifier] = STATE(310),
    [sym_required_parameter] = STATE(5545),
    [sym_optional_parameter] = STATE(5545),
    [sym__parameter_name] = STATE(3943),
    [sym__type] = STATE(4771),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_type_arguments] = STATE(540),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5583),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [aux_sym_export_statement_repeat1] = STATE(257),
    [sym_identifier] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_namespace] = ACTIONS(32),
    [anon_sym_LBRACE] = ACTIONS(34),
    [anon_sym_typeof] = ACTIONS(39),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(23),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(48),
    [anon_sym_RPAREN] = ACTIONS(885),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(23),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(54),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(64),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(72),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(84),
    [anon_sym_DASH] = ACTIONS(84),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [sym_number] = ACTIONS(102),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(915),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(110),
    [sym_false] = ACTIONS(110),
    [sym_null] = ACTIONS(110),
    [sym_undefined] = ACTIONS(112),
    [anon_sym_AT] = ACTIONS(901),
    [anon_sym_static] = ACTIONS(23),
    [anon_sym_readonly] = ACTIONS(917),
    [anon_sym_get] = ACTIONS(23),
    [anon_sym_set] = ACTIONS(23),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_public] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(919),
    [anon_sym_protected] = ACTIONS(919),
    [anon_sym_override] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(120),
    [anon_sym_number] = ACTIONS(120),
    [anon_sym_boolean] = ACTIONS(120),
    [anon_sym_string] = ACTIONS(120),
    [anon_sym_symbol] = ACTIONS(120),
    [anon_sym_object] = ACTIONS(120),
    [anon_sym_property] = ACTIONS(23),
    [anon_sym_signal] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [anon_sym_required] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(23),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [100] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1421),
    [sym_expression] = STATE(2680),
    [sym_primary_expression] = STATE(2044),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1421),
    [sym_subscript_expression] = STATE(1421),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(100),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4444),
    [sym_non_null_expression] = STATE(1421),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5690),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(744),
    [anon_sym_export] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(746),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(750),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(746),
    [anon_sym_let] = ACTIONS(746),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(746),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(769),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(773),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(746),
    [anon_sym_readonly] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(746),
    [anon_sym_set] = ACTIONS(746),
    [anon_sym_declare] = ACTIONS(746),
    [anon_sym_public] = ACTIONS(746),
    [anon_sym_private] = ACTIONS(746),
    [anon_sym_protected] = ACTIONS(746),
    [anon_sym_override] = ACTIONS(746),
    [anon_sym_module] = ACTIONS(746),
    [anon_sym_any] = ACTIONS(746),
    [anon_sym_number] = ACTIONS(746),
    [anon_sym_boolean] = ACTIONS(746),
    [anon_sym_string] = ACTIONS(746),
    [anon_sym_symbol] = ACTIONS(746),
    [anon_sym_object] = ACTIONS(746),
    [anon_sym_property] = ACTIONS(746),
    [anon_sym_signal] = ACTIONS(746),
    [anon_sym_on] = ACTIONS(746),
    [anon_sym_required] = ACTIONS(746),
    [anon_sym_component] = ACTIONS(746),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [101] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1421),
    [sym_expression] = STATE(2680),
    [sym_primary_expression] = STATE(2044),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1421),
    [sym_subscript_expression] = STATE(1421),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(101),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1421),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(744),
    [anon_sym_export] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(746),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(750),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(746),
    [anon_sym_let] = ACTIONS(746),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(746),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(769),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(773),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(746),
    [anon_sym_readonly] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(746),
    [anon_sym_set] = ACTIONS(746),
    [anon_sym_declare] = ACTIONS(746),
    [anon_sym_public] = ACTIONS(746),
    [anon_sym_private] = ACTIONS(746),
    [anon_sym_protected] = ACTIONS(746),
    [anon_sym_override] = ACTIONS(746),
    [anon_sym_module] = ACTIONS(746),
    [anon_sym_any] = ACTIONS(746),
    [anon_sym_number] = ACTIONS(746),
    [anon_sym_boolean] = ACTIONS(746),
    [anon_sym_string] = ACTIONS(746),
    [anon_sym_symbol] = ACTIONS(746),
    [anon_sym_object] = ACTIONS(746),
    [anon_sym_property] = ACTIONS(746),
    [anon_sym_signal] = ACTIONS(746),
    [anon_sym_on] = ACTIONS(746),
    [anon_sym_required] = ACTIONS(746),
    [anon_sym_component] = ACTIONS(746),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [102] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1421),
    [sym_expression] = STATE(2680),
    [sym_primary_expression] = STATE(2044),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1421),
    [sym_subscript_expression] = STATE(1421),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(102),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1421),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(744),
    [anon_sym_export] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(746),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(750),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(746),
    [anon_sym_let] = ACTIONS(746),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(746),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(769),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(773),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(746),
    [anon_sym_readonly] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(746),
    [anon_sym_set] = ACTIONS(746),
    [anon_sym_declare] = ACTIONS(746),
    [anon_sym_public] = ACTIONS(746),
    [anon_sym_private] = ACTIONS(746),
    [anon_sym_protected] = ACTIONS(746),
    [anon_sym_override] = ACTIONS(746),
    [anon_sym_module] = ACTIONS(746),
    [anon_sym_any] = ACTIONS(746),
    [anon_sym_number] = ACTIONS(746),
    [anon_sym_boolean] = ACTIONS(746),
    [anon_sym_string] = ACTIONS(746),
    [anon_sym_symbol] = ACTIONS(746),
    [anon_sym_object] = ACTIONS(746),
    [anon_sym_property] = ACTIONS(746),
    [anon_sym_signal] = ACTIONS(746),
    [anon_sym_on] = ACTIONS(746),
    [anon_sym_required] = ACTIONS(746),
    [anon_sym_component] = ACTIONS(746),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [103] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2206),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_sequence_expression] = STATE(6005),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(103),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_EQ] = ACTIONS(863),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_LPAREN] = ACTIONS(803),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(936),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_SLASH] = ACTIONS(86),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(811),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(943),
    [anon_sym_DASH_DASH] = ACTIONS(943),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(814),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [104] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_nested_identifier] = STATE(6331),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym__formal_parameter] = STATE(5358),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3951),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(2642),
    [sym_comment] = STATE(104),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4333),
    [sym_pattern] = STATE(4280),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_nested_type_identifier] = STATE(3178),
    [sym_accessibility_modifier] = STATE(289),
    [sym_override_modifier] = STATE(310),
    [sym_required_parameter] = STATE(5545),
    [sym_optional_parameter] = STATE(5545),
    [sym__parameter_name] = STATE(3943),
    [sym__type] = STATE(4685),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_type_arguments] = STATE(540),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5583),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [aux_sym_export_statement_repeat1] = STATE(257),
    [sym_identifier] = ACTIONS(21),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_namespace] = ACTIONS(32),
    [anon_sym_LBRACE] = ACTIONS(34),
    [anon_sym_typeof] = ACTIONS(39),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(23),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(48),
    [anon_sym_RPAREN] = ACTIONS(885),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(23),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(54),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(64),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(72),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(84),
    [anon_sym_DASH] = ACTIONS(84),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [sym_number] = ACTIONS(102),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(915),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(110),
    [sym_false] = ACTIONS(110),
    [sym_null] = ACTIONS(110),
    [sym_undefined] = ACTIONS(112),
    [anon_sym_AT] = ACTIONS(901),
    [anon_sym_static] = ACTIONS(23),
    [anon_sym_readonly] = ACTIONS(917),
    [anon_sym_get] = ACTIONS(23),
    [anon_sym_set] = ACTIONS(23),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_public] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(919),
    [anon_sym_protected] = ACTIONS(919),
    [anon_sym_override] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(120),
    [anon_sym_number] = ACTIONS(120),
    [anon_sym_boolean] = ACTIONS(120),
    [anon_sym_string] = ACTIONS(120),
    [anon_sym_symbol] = ACTIONS(120),
    [anon_sym_object] = ACTIONS(120),
    [anon_sym_property] = ACTIONS(23),
    [anon_sym_signal] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [anon_sym_required] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(23),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [105] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1703),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(105),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4444),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5690),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_EQ] = ACTIONS(134),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_COLON] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_QMARK] = ACTIONS(823),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [106] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1421),
    [sym_expression] = STATE(2680),
    [sym_primary_expression] = STATE(2044),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6164),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1421),
    [sym_subscript_expression] = STATE(1421),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(106),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4444),
    [sym_non_null_expression] = STATE(1421),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5690),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(948),
    [anon_sym_export] = ACTIONS(950),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(950),
    [anon_sym_EQ] = ACTIONS(952),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(950),
    [anon_sym_let] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(950),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(956),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_EQ_GT] = ACTIONS(958),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(960),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(962),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(773),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(950),
    [anon_sym_readonly] = ACTIONS(950),
    [anon_sym_get] = ACTIONS(950),
    [anon_sym_set] = ACTIONS(950),
    [anon_sym_declare] = ACTIONS(950),
    [anon_sym_public] = ACTIONS(950),
    [anon_sym_private] = ACTIONS(950),
    [anon_sym_protected] = ACTIONS(950),
    [anon_sym_override] = ACTIONS(950),
    [anon_sym_module] = ACTIONS(950),
    [anon_sym_any] = ACTIONS(950),
    [anon_sym_number] = ACTIONS(950),
    [anon_sym_boolean] = ACTIONS(950),
    [anon_sym_string] = ACTIONS(950),
    [anon_sym_symbol] = ACTIONS(950),
    [anon_sym_object] = ACTIONS(950),
    [anon_sym_property] = ACTIONS(950),
    [anon_sym_signal] = ACTIONS(950),
    [anon_sym_on] = ACTIONS(950),
    [anon_sym_required] = ACTIONS(950),
    [anon_sym_component] = ACTIONS(950),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [107] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1703),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(107),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_EQ] = ACTIONS(863),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(958),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [108] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1703),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(108),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4444),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5690),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(837),
    [anon_sym_export] = ACTIONS(839),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(839),
    [anon_sym_EQ] = ACTIONS(877),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(841),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(839),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(839),
    [anon_sym_COLON] = ACTIONS(867),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_RBRACK] = ACTIONS(964),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(68),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(853),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(839),
    [anon_sym_readonly] = ACTIONS(839),
    [anon_sym_get] = ACTIONS(839),
    [anon_sym_set] = ACTIONS(839),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_override] = ACTIONS(839),
    [anon_sym_module] = ACTIONS(839),
    [anon_sym_any] = ACTIONS(839),
    [anon_sym_number] = ACTIONS(839),
    [anon_sym_boolean] = ACTIONS(839),
    [anon_sym_string] = ACTIONS(839),
    [anon_sym_symbol] = ACTIONS(839),
    [anon_sym_object] = ACTIONS(839),
    [anon_sym_property] = ACTIONS(839),
    [anon_sym_signal] = ACTIONS(839),
    [anon_sym_on] = ACTIONS(839),
    [anon_sym_required] = ACTIONS(839),
    [anon_sym_component] = ACTIONS(839),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [109] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1703),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(109),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(967),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_EQ] = ACTIONS(971),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(974),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(969),
    [anon_sym_let] = ACTIONS(969),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(969),
    [anon_sym_COLON] = ACTIONS(976),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_RBRACK] = ACTIONS(36),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(978),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(980),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(982),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(969),
    [anon_sym_readonly] = ACTIONS(969),
    [anon_sym_get] = ACTIONS(969),
    [anon_sym_set] = ACTIONS(969),
    [anon_sym_declare] = ACTIONS(969),
    [anon_sym_public] = ACTIONS(969),
    [anon_sym_private] = ACTIONS(969),
    [anon_sym_protected] = ACTIONS(969),
    [anon_sym_override] = ACTIONS(969),
    [anon_sym_module] = ACTIONS(969),
    [anon_sym_any] = ACTIONS(969),
    [anon_sym_number] = ACTIONS(969),
    [anon_sym_boolean] = ACTIONS(969),
    [anon_sym_string] = ACTIONS(969),
    [anon_sym_symbol] = ACTIONS(969),
    [anon_sym_object] = ACTIONS(969),
    [anon_sym_property] = ACTIONS(969),
    [anon_sym_signal] = ACTIONS(969),
    [anon_sym_on] = ACTIONS(969),
    [anon_sym_required] = ACTIONS(969),
    [anon_sym_component] = ACTIONS(969),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [110] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1421),
    [sym_expression] = STATE(2680),
    [sym_primary_expression] = STATE(2044),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6164),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1421),
    [sym_subscript_expression] = STATE(1421),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(110),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1421),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(948),
    [anon_sym_export] = ACTIONS(950),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(950),
    [anon_sym_EQ] = ACTIONS(952),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(950),
    [anon_sym_let] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(950),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(956),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_EQ_GT] = ACTIONS(958),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(960),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(962),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(773),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(950),
    [anon_sym_readonly] = ACTIONS(950),
    [anon_sym_get] = ACTIONS(950),
    [anon_sym_set] = ACTIONS(950),
    [anon_sym_declare] = ACTIONS(950),
    [anon_sym_public] = ACTIONS(950),
    [anon_sym_private] = ACTIONS(950),
    [anon_sym_protected] = ACTIONS(950),
    [anon_sym_override] = ACTIONS(950),
    [anon_sym_module] = ACTIONS(950),
    [anon_sym_any] = ACTIONS(950),
    [anon_sym_number] = ACTIONS(950),
    [anon_sym_boolean] = ACTIONS(950),
    [anon_sym_string] = ACTIONS(950),
    [anon_sym_symbol] = ACTIONS(950),
    [anon_sym_object] = ACTIONS(950),
    [anon_sym_property] = ACTIONS(950),
    [anon_sym_signal] = ACTIONS(950),
    [anon_sym_on] = ACTIONS(950),
    [anon_sym_required] = ACTIONS(950),
    [anon_sym_component] = ACTIONS(950),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [111] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1421),
    [sym_expression] = STATE(2680),
    [sym_primary_expression] = STATE(2044),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1421),
    [sym_subscript_expression] = STATE(1421),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(111),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1421),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(744),
    [anon_sym_export] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(746),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(750),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(746),
    [anon_sym_let] = ACTIONS(746),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(984),
    [anon_sym_of] = ACTIONS(987),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(763),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(769),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(773),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(746),
    [anon_sym_readonly] = ACTIONS(746),
    [anon_sym_get] = ACTIONS(746),
    [anon_sym_set] = ACTIONS(746),
    [anon_sym_declare] = ACTIONS(746),
    [anon_sym_public] = ACTIONS(746),
    [anon_sym_private] = ACTIONS(746),
    [anon_sym_protected] = ACTIONS(746),
    [anon_sym_override] = ACTIONS(746),
    [anon_sym_module] = ACTIONS(746),
    [anon_sym_any] = ACTIONS(746),
    [anon_sym_number] = ACTIONS(746),
    [anon_sym_boolean] = ACTIONS(746),
    [anon_sym_string] = ACTIONS(746),
    [anon_sym_symbol] = ACTIONS(746),
    [anon_sym_object] = ACTIONS(746),
    [anon_sym_property] = ACTIONS(746),
    [anon_sym_signal] = ACTIONS(746),
    [anon_sym_on] = ACTIONS(746),
    [anon_sym_required] = ACTIONS(746),
    [anon_sym_component] = ACTIONS(746),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [112] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1703),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(112),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(837),
    [anon_sym_export] = ACTIONS(839),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(839),
    [anon_sym_EQ] = ACTIONS(877),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(841),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(964),
    [anon_sym_RBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(839),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(839),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_RBRACK] = ACTIONS(964),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(68),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(853),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(839),
    [anon_sym_readonly] = ACTIONS(839),
    [anon_sym_get] = ACTIONS(839),
    [anon_sym_set] = ACTIONS(839),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_override] = ACTIONS(839),
    [anon_sym_module] = ACTIONS(839),
    [anon_sym_any] = ACTIONS(839),
    [anon_sym_number] = ACTIONS(839),
    [anon_sym_boolean] = ACTIONS(839),
    [anon_sym_string] = ACTIONS(839),
    [anon_sym_symbol] = ACTIONS(839),
    [anon_sym_object] = ACTIONS(839),
    [anon_sym_property] = ACTIONS(839),
    [anon_sym_signal] = ACTIONS(839),
    [anon_sym_on] = ACTIONS(839),
    [anon_sym_required] = ACTIONS(839),
    [anon_sym_component] = ACTIONS(839),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [113] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1421),
    [sym_expression] = STATE(2680),
    [sym_primary_expression] = STATE(2044),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1421),
    [sym_subscript_expression] = STATE(1421),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(113),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1421),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_export] = ACTIONS(991),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(991),
    [anon_sym_EQ] = ACTIONS(993),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(995),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(991),
    [anon_sym_let] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(991),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(997),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_EQ_GT] = ACTIONS(999),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(1001),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(773),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(991),
    [anon_sym_readonly] = ACTIONS(991),
    [anon_sym_get] = ACTIONS(991),
    [anon_sym_set] = ACTIONS(991),
    [anon_sym_declare] = ACTIONS(991),
    [anon_sym_public] = ACTIONS(991),
    [anon_sym_private] = ACTIONS(991),
    [anon_sym_protected] = ACTIONS(991),
    [anon_sym_override] = ACTIONS(991),
    [anon_sym_module] = ACTIONS(991),
    [anon_sym_any] = ACTIONS(991),
    [anon_sym_number] = ACTIONS(991),
    [anon_sym_boolean] = ACTIONS(991),
    [anon_sym_string] = ACTIONS(991),
    [anon_sym_symbol] = ACTIONS(991),
    [anon_sym_object] = ACTIONS(991),
    [anon_sym_property] = ACTIONS(991),
    [anon_sym_signal] = ACTIONS(991),
    [anon_sym_on] = ACTIONS(991),
    [anon_sym_required] = ACTIONS(991),
    [anon_sym_component] = ACTIONS(991),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [114] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1703),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(114),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_EQ] = ACTIONS(863),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(1003),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [anon_sym_satisfies] = ACTIONS(30),
    [anon_sym_implements] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [115] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1703),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(115),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(967),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_EQ] = ACTIONS(1005),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(974),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(969),
    [anon_sym_let] = ACTIONS(969),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(969),
    [anon_sym_COLON] = ACTIONS(1007),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_RBRACK] = ACTIONS(70),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(978),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(980),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(982),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(969),
    [anon_sym_readonly] = ACTIONS(969),
    [anon_sym_get] = ACTIONS(969),
    [anon_sym_set] = ACTIONS(969),
    [anon_sym_declare] = ACTIONS(969),
    [anon_sym_public] = ACTIONS(969),
    [anon_sym_private] = ACTIONS(969),
    [anon_sym_protected] = ACTIONS(969),
    [anon_sym_override] = ACTIONS(969),
    [anon_sym_module] = ACTIONS(969),
    [anon_sym_any] = ACTIONS(969),
    [anon_sym_number] = ACTIONS(969),
    [anon_sym_boolean] = ACTIONS(969),
    [anon_sym_string] = ACTIONS(969),
    [anon_sym_symbol] = ACTIONS(969),
    [anon_sym_object] = ACTIONS(969),
    [anon_sym_property] = ACTIONS(969),
    [anon_sym_signal] = ACTIONS(969),
    [anon_sym_on] = ACTIONS(969),
    [anon_sym_required] = ACTIONS(969),
    [anon_sym_component] = ACTIONS(969),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [116] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1703),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(116),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_EQ] = ACTIONS(863),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(999),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [117] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1703),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(117),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(967),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_EQ] = ACTIONS(971),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(974),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(969),
    [anon_sym_let] = ACTIONS(969),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(969),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_RBRACK] = ACTIONS(36),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(978),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(980),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(982),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(969),
    [anon_sym_readonly] = ACTIONS(969),
    [anon_sym_get] = ACTIONS(969),
    [anon_sym_set] = ACTIONS(969),
    [anon_sym_declare] = ACTIONS(969),
    [anon_sym_public] = ACTIONS(969),
    [anon_sym_private] = ACTIONS(969),
    [anon_sym_protected] = ACTIONS(969),
    [anon_sym_override] = ACTIONS(969),
    [anon_sym_module] = ACTIONS(969),
    [anon_sym_any] = ACTIONS(969),
    [anon_sym_number] = ACTIONS(969),
    [anon_sym_boolean] = ACTIONS(969),
    [anon_sym_string] = ACTIONS(969),
    [anon_sym_symbol] = ACTIONS(969),
    [anon_sym_object] = ACTIONS(969),
    [anon_sym_property] = ACTIONS(969),
    [anon_sym_signal] = ACTIONS(969),
    [anon_sym_on] = ACTIONS(969),
    [anon_sym_required] = ACTIONS(969),
    [anon_sym_component] = ACTIONS(969),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [118] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1703),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(118),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(967),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_EQ] = ACTIONS(1005),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(974),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(969),
    [anon_sym_let] = ACTIONS(969),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(969),
    [anon_sym_COLON] = ACTIONS(976),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_RBRACK] = ACTIONS(70),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(978),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(980),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(982),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(969),
    [anon_sym_readonly] = ACTIONS(969),
    [anon_sym_get] = ACTIONS(969),
    [anon_sym_set] = ACTIONS(969),
    [anon_sym_declare] = ACTIONS(969),
    [anon_sym_public] = ACTIONS(969),
    [anon_sym_private] = ACTIONS(969),
    [anon_sym_protected] = ACTIONS(969),
    [anon_sym_override] = ACTIONS(969),
    [anon_sym_module] = ACTIONS(969),
    [anon_sym_any] = ACTIONS(969),
    [anon_sym_number] = ACTIONS(969),
    [anon_sym_boolean] = ACTIONS(969),
    [anon_sym_string] = ACTIONS(969),
    [anon_sym_symbol] = ACTIONS(969),
    [anon_sym_object] = ACTIONS(969),
    [anon_sym_property] = ACTIONS(969),
    [anon_sym_signal] = ACTIONS(969),
    [anon_sym_on] = ACTIONS(969),
    [anon_sym_required] = ACTIONS(969),
    [anon_sym_component] = ACTIONS(969),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [119] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1703),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(119),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4680),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5840),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(837),
    [anon_sym_export] = ACTIONS(839),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(839),
    [anon_sym_EQ] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(841),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(36),
    [anon_sym_RBRACE] = ACTIONS(36),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(839),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(839),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(68),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(853),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(839),
    [anon_sym_readonly] = ACTIONS(839),
    [anon_sym_get] = ACTIONS(839),
    [anon_sym_set] = ACTIONS(839),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_override] = ACTIONS(839),
    [anon_sym_module] = ACTIONS(839),
    [anon_sym_any] = ACTIONS(839),
    [anon_sym_number] = ACTIONS(839),
    [anon_sym_boolean] = ACTIONS(839),
    [anon_sym_string] = ACTIONS(839),
    [anon_sym_symbol] = ACTIONS(839),
    [anon_sym_object] = ACTIONS(839),
    [anon_sym_property] = ACTIONS(839),
    [anon_sym_signal] = ACTIONS(839),
    [anon_sym_on] = ACTIONS(839),
    [anon_sym_required] = ACTIONS(839),
    [anon_sym_component] = ACTIONS(839),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [120] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1421),
    [sym_expression] = STATE(2680),
    [sym_primary_expression] = STATE(2044),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1421),
    [sym_subscript_expression] = STATE(1421),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(120),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4444),
    [sym_non_null_expression] = STATE(1421),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5690),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_export] = ACTIONS(991),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(991),
    [anon_sym_EQ] = ACTIONS(993),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(995),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(991),
    [anon_sym_let] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(991),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(997),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_EQ_GT] = ACTIONS(999),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(1001),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(773),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(991),
    [anon_sym_readonly] = ACTIONS(991),
    [anon_sym_get] = ACTIONS(991),
    [anon_sym_set] = ACTIONS(991),
    [anon_sym_declare] = ACTIONS(991),
    [anon_sym_public] = ACTIONS(991),
    [anon_sym_private] = ACTIONS(991),
    [anon_sym_protected] = ACTIONS(991),
    [anon_sym_override] = ACTIONS(991),
    [anon_sym_module] = ACTIONS(991),
    [anon_sym_any] = ACTIONS(991),
    [anon_sym_number] = ACTIONS(991),
    [anon_sym_boolean] = ACTIONS(991),
    [anon_sym_string] = ACTIONS(991),
    [anon_sym_symbol] = ACTIONS(991),
    [anon_sym_object] = ACTIONS(991),
    [anon_sym_property] = ACTIONS(991),
    [anon_sym_signal] = ACTIONS(991),
    [anon_sym_on] = ACTIONS(991),
    [anon_sym_required] = ACTIONS(991),
    [anon_sym_component] = ACTIONS(991),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [121] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1703),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6272),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(121),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_export] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(1011),
    [anon_sym_EQ] = ACTIONS(1013),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(1015),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1011),
    [anon_sym_let] = ACTIONS(1011),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1017),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(1003),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(1019),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1011),
    [anon_sym_readonly] = ACTIONS(1011),
    [anon_sym_get] = ACTIONS(1011),
    [anon_sym_set] = ACTIONS(1011),
    [anon_sym_declare] = ACTIONS(1011),
    [anon_sym_public] = ACTIONS(1011),
    [anon_sym_private] = ACTIONS(1011),
    [anon_sym_protected] = ACTIONS(1011),
    [anon_sym_override] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_any] = ACTIONS(1011),
    [anon_sym_number] = ACTIONS(1011),
    [anon_sym_boolean] = ACTIONS(1011),
    [anon_sym_string] = ACTIONS(1011),
    [anon_sym_symbol] = ACTIONS(1011),
    [anon_sym_object] = ACTIONS(1011),
    [anon_sym_property] = ACTIONS(1011),
    [anon_sym_signal] = ACTIONS(1011),
    [anon_sym_on] = ACTIONS(1011),
    [anon_sym_required] = ACTIONS(1011),
    [anon_sym_component] = ACTIONS(1011),
    [anon_sym_satisfies] = ACTIONS(30),
    [anon_sym_implements] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [122] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1703),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6272),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(122),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4444),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5690),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_export] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(1011),
    [anon_sym_EQ] = ACTIONS(1013),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(1015),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1011),
    [anon_sym_let] = ACTIONS(1011),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1017),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(1003),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(1019),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1011),
    [anon_sym_readonly] = ACTIONS(1011),
    [anon_sym_get] = ACTIONS(1011),
    [anon_sym_set] = ACTIONS(1011),
    [anon_sym_declare] = ACTIONS(1011),
    [anon_sym_public] = ACTIONS(1011),
    [anon_sym_private] = ACTIONS(1011),
    [anon_sym_protected] = ACTIONS(1011),
    [anon_sym_override] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_any] = ACTIONS(1011),
    [anon_sym_number] = ACTIONS(1011),
    [anon_sym_boolean] = ACTIONS(1011),
    [anon_sym_string] = ACTIONS(1011),
    [anon_sym_symbol] = ACTIONS(1011),
    [anon_sym_object] = ACTIONS(1011),
    [anon_sym_property] = ACTIONS(1011),
    [anon_sym_signal] = ACTIONS(1011),
    [anon_sym_on] = ACTIONS(1011),
    [anon_sym_required] = ACTIONS(1011),
    [anon_sym_component] = ACTIONS(1011),
    [anon_sym_satisfies] = ACTIONS(30),
    [anon_sym_implements] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [123] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1703),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(123),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4444),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5690),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_EQ] = ACTIONS(863),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_COLON] = ACTIONS(867),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [124] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1703),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(124),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(967),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_EQ] = ACTIONS(1005),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(974),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(969),
    [anon_sym_let] = ACTIONS(969),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(969),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_RBRACK] = ACTIONS(70),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(978),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(980),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(982),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(969),
    [anon_sym_readonly] = ACTIONS(969),
    [anon_sym_get] = ACTIONS(969),
    [anon_sym_set] = ACTIONS(969),
    [anon_sym_declare] = ACTIONS(969),
    [anon_sym_public] = ACTIONS(969),
    [anon_sym_private] = ACTIONS(969),
    [anon_sym_protected] = ACTIONS(969),
    [anon_sym_override] = ACTIONS(969),
    [anon_sym_module] = ACTIONS(969),
    [anon_sym_any] = ACTIONS(969),
    [anon_sym_number] = ACTIONS(969),
    [anon_sym_boolean] = ACTIONS(969),
    [anon_sym_string] = ACTIONS(969),
    [anon_sym_symbol] = ACTIONS(969),
    [anon_sym_object] = ACTIONS(969),
    [anon_sym_property] = ACTIONS(969),
    [anon_sym_signal] = ACTIONS(969),
    [anon_sym_on] = ACTIONS(969),
    [anon_sym_required] = ACTIONS(969),
    [anon_sym_component] = ACTIONS(969),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [125] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2206),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_sequence_expression] = STATE(6005),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(125),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_EQ] = ACTIONS(863),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_LPAREN] = ACTIONS(803),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(936),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_SLASH] = ACTIONS(86),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(811),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(943),
    [anon_sym_DASH_DASH] = ACTIONS(943),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(814),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [126] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1703),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(126),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1023),
    [anon_sym_export] = ACTIONS(1025),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(1025),
    [anon_sym_EQ] = ACTIONS(1027),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1025),
    [anon_sym_let] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(1025),
    [anon_sym_COLON] = ACTIONS(70),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1035),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(1037),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(1039),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1025),
    [anon_sym_readonly] = ACTIONS(1025),
    [anon_sym_get] = ACTIONS(1025),
    [anon_sym_set] = ACTIONS(1025),
    [anon_sym_declare] = ACTIONS(1025),
    [anon_sym_public] = ACTIONS(1025),
    [anon_sym_private] = ACTIONS(1025),
    [anon_sym_protected] = ACTIONS(1025),
    [anon_sym_override] = ACTIONS(1025),
    [anon_sym_module] = ACTIONS(1025),
    [anon_sym_any] = ACTIONS(1025),
    [anon_sym_number] = ACTIONS(1025),
    [anon_sym_boolean] = ACTIONS(1025),
    [anon_sym_string] = ACTIONS(1025),
    [anon_sym_symbol] = ACTIONS(1025),
    [anon_sym_object] = ACTIONS(1025),
    [anon_sym_property] = ACTIONS(1025),
    [anon_sym_signal] = ACTIONS(1025),
    [anon_sym_on] = ACTIONS(1025),
    [anon_sym_required] = ACTIONS(1025),
    [anon_sym_component] = ACTIONS(1025),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [127] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1703),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(127),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_EQ] = ACTIONS(863),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_COLON] = ACTIONS(70),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(1037),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [128] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1703),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(128),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_EQ] = ACTIONS(863),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_RBRACK] = ACTIONS(70),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(980),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [129] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1703),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(129),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4444),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5690),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(967),
    [anon_sym_export] = ACTIONS(969),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(969),
    [anon_sym_EQ] = ACTIONS(1005),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(974),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(969),
    [anon_sym_let] = ACTIONS(969),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(969),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_RBRACK] = ACTIONS(70),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(978),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(980),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(982),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(969),
    [anon_sym_readonly] = ACTIONS(969),
    [anon_sym_get] = ACTIONS(969),
    [anon_sym_set] = ACTIONS(969),
    [anon_sym_declare] = ACTIONS(969),
    [anon_sym_public] = ACTIONS(969),
    [anon_sym_private] = ACTIONS(969),
    [anon_sym_protected] = ACTIONS(969),
    [anon_sym_override] = ACTIONS(969),
    [anon_sym_module] = ACTIONS(969),
    [anon_sym_any] = ACTIONS(969),
    [anon_sym_number] = ACTIONS(969),
    [anon_sym_boolean] = ACTIONS(969),
    [anon_sym_string] = ACTIONS(969),
    [anon_sym_symbol] = ACTIONS(969),
    [anon_sym_object] = ACTIONS(969),
    [anon_sym_property] = ACTIONS(969),
    [anon_sym_signal] = ACTIONS(969),
    [anon_sym_on] = ACTIONS(969),
    [anon_sym_required] = ACTIONS(969),
    [anon_sym_component] = ACTIONS(969),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [130] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1703),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(130),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4444),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5690),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1023),
    [anon_sym_export] = ACTIONS(1025),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(1025),
    [anon_sym_EQ] = ACTIONS(1027),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1025),
    [anon_sym_let] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(1025),
    [anon_sym_COLON] = ACTIONS(70),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1035),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(1037),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(1039),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1025),
    [anon_sym_readonly] = ACTIONS(1025),
    [anon_sym_get] = ACTIONS(1025),
    [anon_sym_set] = ACTIONS(1025),
    [anon_sym_declare] = ACTIONS(1025),
    [anon_sym_public] = ACTIONS(1025),
    [anon_sym_private] = ACTIONS(1025),
    [anon_sym_protected] = ACTIONS(1025),
    [anon_sym_override] = ACTIONS(1025),
    [anon_sym_module] = ACTIONS(1025),
    [anon_sym_any] = ACTIONS(1025),
    [anon_sym_number] = ACTIONS(1025),
    [anon_sym_boolean] = ACTIONS(1025),
    [anon_sym_string] = ACTIONS(1025),
    [anon_sym_symbol] = ACTIONS(1025),
    [anon_sym_object] = ACTIONS(1025),
    [anon_sym_property] = ACTIONS(1025),
    [anon_sym_signal] = ACTIONS(1025),
    [anon_sym_on] = ACTIONS(1025),
    [anon_sym_required] = ACTIONS(1025),
    [anon_sym_component] = ACTIONS(1025),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [131] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1703),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(131),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_EQ] = ACTIONS(863),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(984),
    [anon_sym_of] = ACTIONS(1041),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [132] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1703),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6293),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(132),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1043),
    [anon_sym_export] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1047),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1045),
    [anon_sym_let] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(1045),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(1053),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(1055),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_readonly] = ACTIONS(1045),
    [anon_sym_get] = ACTIONS(1045),
    [anon_sym_set] = ACTIONS(1045),
    [anon_sym_declare] = ACTIONS(1045),
    [anon_sym_public] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1045),
    [anon_sym_protected] = ACTIONS(1045),
    [anon_sym_override] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1045),
    [anon_sym_any] = ACTIONS(1045),
    [anon_sym_number] = ACTIONS(1045),
    [anon_sym_boolean] = ACTIONS(1045),
    [anon_sym_string] = ACTIONS(1045),
    [anon_sym_symbol] = ACTIONS(1045),
    [anon_sym_object] = ACTIONS(1045),
    [anon_sym_property] = ACTIONS(1045),
    [anon_sym_signal] = ACTIONS(1045),
    [anon_sym_on] = ACTIONS(1045),
    [anon_sym_required] = ACTIONS(1045),
    [anon_sym_component] = ACTIONS(1045),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [133] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1703),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(133),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_EQ] = ACTIONS(863),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [134] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1703),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(134),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_EQ] = ACTIONS(1059),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [135] = {
    [sym_import] = STATE(3739),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2302),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_assignment_pattern] = STATE(5607),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_nested_identifier] = STATE(6076),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1373),
    [sym_subscript_expression] = STATE(1373),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3818),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(2277),
    [sym_comment] = STATE(135),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4560),
    [sym_pattern] = STATE(5163),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1373),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_nested_type_identifier] = STATE(3366),
    [sym__type_query_member_expression_in_type_annotation] = STATE(3546),
    [sym__type_query_call_expression_in_type_annotation] = STATE(3743),
    [sym__type] = STATE(3537),
    [sym_constructor_type] = STATE(3468),
    [sym__primary_type] = STATE(3467),
    [sym_template_literal_type] = STATE(3466),
    [sym_infer_type] = STATE(3468),
    [sym_conditional_type] = STATE(3466),
    [sym_generic_type] = STATE(3466),
    [sym_type_query] = STATE(3466),
    [sym_index_type_query] = STATE(3466),
    [sym_lookup_type] = STATE(3466),
    [sym_literal_type] = STATE(3466),
    [sym__number] = STATE(3465),
    [sym_existential_type] = STATE(3466),
    [sym_flow_maybe_type] = STATE(3466),
    [sym_parenthesized_type] = STATE(3466),
    [sym_predefined_type] = STATE(3466),
    [sym_type_arguments] = STATE(463),
    [sym_object_type] = STATE(3466),
    [sym_type_parameters] = STATE(5806),
    [sym_array_type] = STATE(3466),
    [sym_tuple_type] = STATE(3466),
    [sym_readonly_type] = STATE(3468),
    [sym_union_type] = STATE(3466),
    [sym_intersection_type] = STATE(3466),
    [sym_function_type] = STATE(3468),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(684),
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(684),
    [anon_sym_namespace] = ACTIONS(688),
    [anon_sym_LBRACE] = ACTIONS(1065),
    [anon_sym_typeof] = ACTIONS(1067),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(684),
    [anon_sym_let] = ACTIONS(684),
    [anon_sym_const] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(1071),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(684),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(1073),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(706),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1075),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_AMP] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(1083),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1085),
    [sym_number] = ACTIONS(1087),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(1089),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(1091),
    [sym_false] = ACTIONS(1091),
    [sym_null] = ACTIONS(1091),
    [sym_undefined] = ACTIONS(1093),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(684),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(684),
    [anon_sym_set] = ACTIONS(684),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(684),
    [anon_sym_public] = ACTIONS(684),
    [anon_sym_private] = ACTIONS(684),
    [anon_sym_protected] = ACTIONS(684),
    [anon_sym_override] = ACTIONS(684),
    [anon_sym_module] = ACTIONS(684),
    [anon_sym_any] = ACTIONS(1099),
    [anon_sym_number] = ACTIONS(1099),
    [anon_sym_boolean] = ACTIONS(1099),
    [anon_sym_string] = ACTIONS(1099),
    [anon_sym_symbol] = ACTIONS(1099),
    [anon_sym_object] = ACTIONS(1099),
    [anon_sym_property] = ACTIONS(684),
    [anon_sym_signal] = ACTIONS(684),
    [anon_sym_on] = ACTIONS(684),
    [anon_sym_required] = ACTIONS(684),
    [anon_sym_component] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(1101),
    [anon_sym_infer] = ACTIONS(1103),
    [anon_sym_keyof] = ACTIONS(1105),
    [anon_sym_unique] = ACTIONS(1107),
    [anon_sym_unknown] = ACTIONS(1109),
    [anon_sym_never] = ACTIONS(1109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1111),
    [sym_html_comment] = ACTIONS(5),
  },
  [136] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1703),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(136),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_EQ] = ACTIONS(1113),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [137] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1703),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(137),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_EQ] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [138] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1703),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(138),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_EQ] = ACTIONS(1117),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [139] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1703),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(139),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_EQ] = ACTIONS(1119),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [140] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1703),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(140),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_EQ] = ACTIONS(1121),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [141] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1703),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(141),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_EQ] = ACTIONS(1123),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [142] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1703),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(142),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_EQ] = ACTIONS(1125),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [143] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1703),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(143),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_EQ] = ACTIONS(1127),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [144] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1703),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(144),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_EQ] = ACTIONS(863),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(1053),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [145] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1703),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6293),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(145),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4444),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5690),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1043),
    [anon_sym_export] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1047),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1045),
    [anon_sym_let] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(1045),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(1053),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(1055),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_readonly] = ACTIONS(1045),
    [anon_sym_get] = ACTIONS(1045),
    [anon_sym_set] = ACTIONS(1045),
    [anon_sym_declare] = ACTIONS(1045),
    [anon_sym_public] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1045),
    [anon_sym_protected] = ACTIONS(1045),
    [anon_sym_override] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1045),
    [anon_sym_any] = ACTIONS(1045),
    [anon_sym_number] = ACTIONS(1045),
    [anon_sym_boolean] = ACTIONS(1045),
    [anon_sym_string] = ACTIONS(1045),
    [anon_sym_symbol] = ACTIONS(1045),
    [anon_sym_object] = ACTIONS(1045),
    [anon_sym_property] = ACTIONS(1045),
    [anon_sym_signal] = ACTIONS(1045),
    [anon_sym_on] = ACTIONS(1045),
    [anon_sym_required] = ACTIONS(1045),
    [anon_sym_component] = ACTIONS(1045),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [146] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1703),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(146),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4444),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5690),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_EQ] = ACTIONS(863),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(849),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [147] = {
    [sym_import] = STATE(3615),
    [sym_parenthesized_expression] = STATE(1487),
    [sym_expression] = STATE(2334),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_nested_identifier] = STATE(6331),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1487),
    [sym_subscript_expression] = STATE(1487),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3189),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6145),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2729),
    [sym_comment] = STATE(147),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4333),
    [sym_non_null_expression] = STATE(1487),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4180),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4833),
    [sym__type] = STATE(4179),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_type_arguments] = STATE(412),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5583),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_export] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_type] = ACTIONS(1131),
    [anon_sym_namespace] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(1135),
    [anon_sym_typeof] = ACTIONS(1137),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_let] = ACTIONS(1131),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(1141),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_of] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1149),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_using] = ACTIONS(1153),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(1155),
    [anon_sym_DASH] = ACTIONS(1155),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1157),
    [anon_sym_delete] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1163),
    [sym_number] = ACTIONS(1165),
    [sym_private_property_identifier] = ACTIONS(1167),
    [sym_this] = ACTIONS(1169),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(1171),
    [sym_false] = ACTIONS(1171),
    [sym_null] = ACTIONS(1171),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1131),
    [anon_sym_readonly] = ACTIONS(1175),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(1131),
    [anon_sym_public] = ACTIONS(1131),
    [anon_sym_private] = ACTIONS(1131),
    [anon_sym_protected] = ACTIONS(1131),
    [anon_sym_override] = ACTIONS(1131),
    [anon_sym_module] = ACTIONS(1131),
    [anon_sym_any] = ACTIONS(1177),
    [anon_sym_number] = ACTIONS(1177),
    [anon_sym_boolean] = ACTIONS(1177),
    [anon_sym_string] = ACTIONS(1177),
    [anon_sym_symbol] = ACTIONS(1177),
    [anon_sym_object] = ACTIONS(1177),
    [anon_sym_property] = ACTIONS(1131),
    [anon_sym_signal] = ACTIONS(1131),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_required] = ACTIONS(1131),
    [anon_sym_component] = ACTIONS(1131),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [148] = {
    [sym_import] = STATE(3640),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_expression] = STATE(2447),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_nested_identifier] = STATE(6331),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5939),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(2430),
    [sym_comment] = STATE(148),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4333),
    [sym_non_null_expression] = STATE(1523),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4108),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4832),
    [sym__type] = STATE(4107),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_type_arguments] = STATE(551),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5583),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1179),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1185),
    [anon_sym_typeof] = ACTIONS(1187),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(48),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_of] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1195),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1199),
    [anon_sym_using] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(1203),
    [anon_sym_DASH] = ACTIONS(1203),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1205),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1211),
    [sym_number] = ACTIONS(1213),
    [sym_private_property_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(1217),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(1219),
    [sym_false] = ACTIONS(1219),
    [sym_null] = ACTIONS(1219),
    [sym_undefined] = ACTIONS(1221),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1223),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1225),
    [anon_sym_number] = ACTIONS(1225),
    [anon_sym_boolean] = ACTIONS(1225),
    [anon_sym_string] = ACTIONS(1225),
    [anon_sym_symbol] = ACTIONS(1225),
    [anon_sym_object] = ACTIONS(1225),
    [anon_sym_property] = ACTIONS(1181),
    [anon_sym_signal] = ACTIONS(1181),
    [anon_sym_on] = ACTIONS(1181),
    [anon_sym_required] = ACTIONS(1181),
    [anon_sym_component] = ACTIONS(1181),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [149] = {
    [sym_import] = STATE(3640),
    [sym_parenthesized_expression] = STATE(1520),
    [sym_expression] = STATE(2643),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_nested_identifier] = STATE(6331),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1520),
    [sym_subscript_expression] = STATE(1520),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6049),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(2430),
    [sym_comment] = STATE(149),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4333),
    [sym_non_null_expression] = STATE(1520),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4108),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4832),
    [sym__type] = STATE(4107),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_type_arguments] = STATE(556),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5583),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1227),
    [anon_sym_export] = ACTIONS(1229),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_type] = ACTIONS(1229),
    [anon_sym_namespace] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(1233),
    [anon_sym_typeof] = ACTIONS(1235),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1229),
    [anon_sym_let] = ACTIONS(1229),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(48),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_of] = ACTIONS(1229),
    [anon_sym_yield] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(1195),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1245),
    [anon_sym_using] = ACTIONS(1247),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(1249),
    [anon_sym_DASH] = ACTIONS(1249),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1251),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1211),
    [sym_number] = ACTIONS(1213),
    [sym_private_property_identifier] = ACTIONS(1257),
    [sym_this] = ACTIONS(1217),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(1219),
    [sym_false] = ACTIONS(1219),
    [sym_null] = ACTIONS(1219),
    [sym_undefined] = ACTIONS(1259),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_readonly] = ACTIONS(1261),
    [anon_sym_get] = ACTIONS(1229),
    [anon_sym_set] = ACTIONS(1229),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(1229),
    [anon_sym_public] = ACTIONS(1229),
    [anon_sym_private] = ACTIONS(1229),
    [anon_sym_protected] = ACTIONS(1229),
    [anon_sym_override] = ACTIONS(1229),
    [anon_sym_module] = ACTIONS(1229),
    [anon_sym_any] = ACTIONS(1263),
    [anon_sym_number] = ACTIONS(1263),
    [anon_sym_boolean] = ACTIONS(1263),
    [anon_sym_string] = ACTIONS(1263),
    [anon_sym_symbol] = ACTIONS(1263),
    [anon_sym_object] = ACTIONS(1263),
    [anon_sym_property] = ACTIONS(1229),
    [anon_sym_signal] = ACTIONS(1229),
    [anon_sym_on] = ACTIONS(1229),
    [anon_sym_required] = ACTIONS(1229),
    [anon_sym_component] = ACTIONS(1229),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [150] = {
    [sym_import] = STATE(3675),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1925),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_nested_identifier] = STATE(6331),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(2081),
    [sym_comment] = STATE(150),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4333),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4108),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4832),
    [sym__type] = STATE(4107),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_type_arguments] = STATE(463),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5583),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1265),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(1267),
    [anon_sym_typeof] = ACTIONS(1269),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(48),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(1271),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_DASH] = ACTIONS(1275),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1277),
    [sym_number] = ACTIONS(1279),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(1281),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(1283),
    [sym_false] = ACTIONS(1283),
    [sym_null] = ACTIONS(1283),
    [sym_undefined] = ACTIONS(1285),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(1287),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(1289),
    [anon_sym_number] = ACTIONS(1289),
    [anon_sym_boolean] = ACTIONS(1289),
    [anon_sym_string] = ACTIONS(1289),
    [anon_sym_symbol] = ACTIONS(1289),
    [anon_sym_object] = ACTIONS(1289),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [151] = {
    [sym_import] = STATE(3641),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_nested_identifier] = STATE(6331),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2357),
    [sym_comment] = STATE(151),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4333),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4180),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4833),
    [sym__type] = STATE(4179),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_type_arguments] = STATE(584),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5583),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1291),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(1297),
    [anon_sym_typeof] = ACTIONS(1299),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(1141),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(1301),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1305),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(1307),
    [anon_sym_DASH] = ACTIONS(1307),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(1309),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1311),
    [sym_number] = ACTIONS(1313),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(1315),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(1317),
    [sym_false] = ACTIONS(1317),
    [sym_null] = ACTIONS(1317),
    [sym_undefined] = ACTIONS(1319),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1323),
    [anon_sym_number] = ACTIONS(1323),
    [anon_sym_boolean] = ACTIONS(1323),
    [anon_sym_string] = ACTIONS(1323),
    [anon_sym_symbol] = ACTIONS(1323),
    [anon_sym_object] = ACTIONS(1323),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [152] = {
    [sym_import] = STATE(3641),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_expression] = STATE(1941),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_nested_identifier] = STATE(6331),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6164),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3271),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6167),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2357),
    [sym_comment] = STATE(152),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4333),
    [sym_non_null_expression] = STATE(1451),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4180),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4833),
    [sym__type] = STATE(4179),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_type_arguments] = STATE(522),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5583),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1325),
    [anon_sym_export] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_type] = ACTIONS(1327),
    [anon_sym_namespace] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(1297),
    [anon_sym_typeof] = ACTIONS(1331),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_let] = ACTIONS(1327),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(1333),
    [anon_sym_LPAREN] = ACTIONS(1141),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_of] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(1301),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1341),
    [anon_sym_using] = ACTIONS(1343),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_SLASH] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_void] = ACTIONS(1347),
    [anon_sym_delete] = ACTIONS(1349),
    [anon_sym_PLUS_PLUS] = ACTIONS(1351),
    [anon_sym_DASH_DASH] = ACTIONS(1351),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1311),
    [sym_number] = ACTIONS(1313),
    [sym_private_property_identifier] = ACTIONS(1353),
    [sym_this] = ACTIONS(1315),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(1317),
    [sym_false] = ACTIONS(1317),
    [sym_null] = ACTIONS(1317),
    [sym_undefined] = ACTIONS(1355),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1327),
    [anon_sym_readonly] = ACTIONS(1357),
    [anon_sym_get] = ACTIONS(1327),
    [anon_sym_set] = ACTIONS(1327),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(1327),
    [anon_sym_public] = ACTIONS(1327),
    [anon_sym_private] = ACTIONS(1327),
    [anon_sym_protected] = ACTIONS(1327),
    [anon_sym_override] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_any] = ACTIONS(1359),
    [anon_sym_number] = ACTIONS(1359),
    [anon_sym_boolean] = ACTIONS(1359),
    [anon_sym_string] = ACTIONS(1359),
    [anon_sym_symbol] = ACTIONS(1359),
    [anon_sym_object] = ACTIONS(1359),
    [anon_sym_property] = ACTIONS(1327),
    [anon_sym_signal] = ACTIONS(1327),
    [anon_sym_on] = ACTIONS(1327),
    [anon_sym_required] = ACTIONS(1327),
    [anon_sym_component] = ACTIONS(1327),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [153] = {
    [sym_import] = STATE(3640),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2714),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_nested_identifier] = STATE(6331),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(2430),
    [sym_comment] = STATE(153),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4333),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4108),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4832),
    [sym__type] = STATE(4107),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_type_arguments] = STATE(540),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5583),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1361),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(1363),
    [anon_sym_typeof] = ACTIONS(1365),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(48),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(1195),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1367),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(1369),
    [anon_sym_DASH] = ACTIONS(1369),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1211),
    [sym_number] = ACTIONS(1213),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(1217),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(1219),
    [sym_false] = ACTIONS(1219),
    [sym_null] = ACTIONS(1219),
    [sym_undefined] = ACTIONS(1371),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(1373),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(1375),
    [anon_sym_number] = ACTIONS(1375),
    [anon_sym_boolean] = ACTIONS(1375),
    [anon_sym_string] = ACTIONS(1375),
    [anon_sym_symbol] = ACTIONS(1375),
    [anon_sym_object] = ACTIONS(1375),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [154] = {
    [sym_import] = STATE(3640),
    [sym_parenthesized_expression] = STATE(1513),
    [sym_expression] = STATE(2551),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_nested_identifier] = STATE(6331),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6293),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1513),
    [sym_subscript_expression] = STATE(1513),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3245),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6295),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(2430),
    [sym_comment] = STATE(154),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4333),
    [sym_non_null_expression] = STATE(1513),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4108),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4832),
    [sym__type] = STATE(4107),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_type_arguments] = STATE(455),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5583),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1377),
    [anon_sym_export] = ACTIONS(1379),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_type] = ACTIONS(1379),
    [anon_sym_namespace] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(1363),
    [anon_sym_typeof] = ACTIONS(1383),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1379),
    [anon_sym_let] = ACTIONS(1379),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(1385),
    [anon_sym_LPAREN] = ACTIONS(48),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_of] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1389),
    [anon_sym_LBRACK] = ACTIONS(1195),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1391),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1393),
    [anon_sym_using] = ACTIONS(1395),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(1397),
    [anon_sym_DASH] = ACTIONS(1397),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_void] = ACTIONS(1399),
    [anon_sym_delete] = ACTIONS(1401),
    [anon_sym_PLUS_PLUS] = ACTIONS(1403),
    [anon_sym_DASH_DASH] = ACTIONS(1403),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1211),
    [sym_number] = ACTIONS(1213),
    [sym_private_property_identifier] = ACTIONS(1405),
    [sym_this] = ACTIONS(1217),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(1219),
    [sym_false] = ACTIONS(1219),
    [sym_null] = ACTIONS(1219),
    [sym_undefined] = ACTIONS(1407),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1379),
    [anon_sym_readonly] = ACTIONS(1409),
    [anon_sym_get] = ACTIONS(1379),
    [anon_sym_set] = ACTIONS(1379),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_public] = ACTIONS(1379),
    [anon_sym_private] = ACTIONS(1379),
    [anon_sym_protected] = ACTIONS(1379),
    [anon_sym_override] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1379),
    [anon_sym_any] = ACTIONS(1411),
    [anon_sym_number] = ACTIONS(1411),
    [anon_sym_boolean] = ACTIONS(1411),
    [anon_sym_string] = ACTIONS(1411),
    [anon_sym_symbol] = ACTIONS(1411),
    [anon_sym_object] = ACTIONS(1411),
    [anon_sym_property] = ACTIONS(1379),
    [anon_sym_signal] = ACTIONS(1379),
    [anon_sym_on] = ACTIONS(1379),
    [anon_sym_required] = ACTIONS(1379),
    [anon_sym_component] = ACTIONS(1379),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [155] = {
    [sym_import] = STATE(3675),
    [sym_parenthesized_expression] = STATE(1473),
    [sym_expression] = STATE(2131),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_nested_identifier] = STATE(6331),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6272),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1473),
    [sym_subscript_expression] = STATE(1473),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3246),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6274),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(2081),
    [sym_comment] = STATE(155),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4333),
    [sym_non_null_expression] = STATE(1473),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4108),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4832),
    [sym__type] = STATE(4107),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_type_arguments] = STATE(541),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5583),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1413),
    [anon_sym_export] = ACTIONS(1415),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_type] = ACTIONS(1415),
    [anon_sym_namespace] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(1267),
    [anon_sym_typeof] = ACTIONS(1419),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1415),
    [anon_sym_let] = ACTIONS(1415),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(1421),
    [anon_sym_LPAREN] = ACTIONS(48),
    [anon_sym_await] = ACTIONS(1423),
    [anon_sym_of] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1425),
    [anon_sym_LBRACK] = ACTIONS(1271),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1427),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1429),
    [anon_sym_using] = ACTIONS(1431),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1421),
    [anon_sym_void] = ACTIONS(1435),
    [anon_sym_delete] = ACTIONS(1437),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1277),
    [sym_number] = ACTIONS(1279),
    [sym_private_property_identifier] = ACTIONS(1441),
    [sym_this] = ACTIONS(1281),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(1283),
    [sym_false] = ACTIONS(1283),
    [sym_null] = ACTIONS(1283),
    [sym_undefined] = ACTIONS(1443),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1415),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1415),
    [anon_sym_set] = ACTIONS(1415),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(1415),
    [anon_sym_public] = ACTIONS(1415),
    [anon_sym_private] = ACTIONS(1415),
    [anon_sym_protected] = ACTIONS(1415),
    [anon_sym_override] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_any] = ACTIONS(1447),
    [anon_sym_number] = ACTIONS(1447),
    [anon_sym_boolean] = ACTIONS(1447),
    [anon_sym_string] = ACTIONS(1447),
    [anon_sym_symbol] = ACTIONS(1447),
    [anon_sym_object] = ACTIONS(1447),
    [anon_sym_property] = ACTIONS(1415),
    [anon_sym_signal] = ACTIONS(1415),
    [anon_sym_on] = ACTIONS(1415),
    [anon_sym_required] = ACTIONS(1415),
    [anon_sym_component] = ACTIONS(1415),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [156] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2194),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_nested_identifier] = STATE(6331),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_sequence_expression] = STATE(6192),
    [sym_string] = STATE(2439),
    [sym_comment] = STATE(156),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4333),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(5189),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(4464),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(4834),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_type_arguments] = STATE(463),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5583),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1449),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(1451),
    [anon_sym_typeof] = ACTIONS(883),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(48),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(1453),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(1455),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(897),
    [sym_false] = ACTIONS(897),
    [sym_null] = ACTIONS(897),
    [sym_undefined] = ACTIONS(1457),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(1287),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(1459),
    [anon_sym_number] = ACTIONS(1459),
    [anon_sym_boolean] = ACTIONS(1459),
    [anon_sym_string] = ACTIONS(1459),
    [anon_sym_symbol] = ACTIONS(1459),
    [anon_sym_object] = ACTIONS(1459),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [157] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_nested_identifier] = STATE(6331),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1375),
    [sym_subscript_expression] = STATE(1375),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3932),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(2759),
    [sym_comment] = STATE(157),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4333),
    [sym_non_null_expression] = STATE(1375),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4459),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_type_arguments] = STATE(540),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5583),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1461),
    [anon_sym_export] = ACTIONS(1463),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_type] = ACTIONS(1463),
    [anon_sym_namespace] = ACTIONS(1465),
    [anon_sym_LBRACE] = ACTIONS(1467),
    [anon_sym_typeof] = ACTIONS(1469),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1463),
    [anon_sym_let] = ACTIONS(1463),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(48),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(1463),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(1471),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1473),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1475),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(1477),
    [anon_sym_DASH] = ACTIONS(1477),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(93),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1479),
    [sym_number] = ACTIONS(1481),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(1483),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(1485),
    [sym_false] = ACTIONS(1485),
    [sym_null] = ACTIONS(1485),
    [sym_undefined] = ACTIONS(1487),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1463),
    [anon_sym_readonly] = ACTIONS(1489),
    [anon_sym_get] = ACTIONS(1463),
    [anon_sym_set] = ACTIONS(1463),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(1463),
    [anon_sym_public] = ACTIONS(1463),
    [anon_sym_private] = ACTIONS(1463),
    [anon_sym_protected] = ACTIONS(1463),
    [anon_sym_override] = ACTIONS(1463),
    [anon_sym_module] = ACTIONS(1463),
    [anon_sym_any] = ACTIONS(1491),
    [anon_sym_number] = ACTIONS(1491),
    [anon_sym_boolean] = ACTIONS(1491),
    [anon_sym_string] = ACTIONS(1491),
    [anon_sym_symbol] = ACTIONS(1491),
    [anon_sym_object] = ACTIONS(1491),
    [anon_sym_property] = ACTIONS(1463),
    [anon_sym_signal] = ACTIONS(1463),
    [anon_sym_on] = ACTIONS(1463),
    [anon_sym_required] = ACTIONS(1463),
    [anon_sym_component] = ACTIONS(1463),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [158] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1949),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_nested_identifier] = STATE(6331),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1430),
    [sym_subscript_expression] = STATE(1430),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(4663),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(2642),
    [sym_comment] = STATE(158),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4333),
    [sym_non_null_expression] = STATE(1430),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4459),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_type_arguments] = STATE(463),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5583),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1493),
    [anon_sym_export] = ACTIONS(1495),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_type] = ACTIONS(1495),
    [anon_sym_namespace] = ACTIONS(1497),
    [anon_sym_LBRACE] = ACTIONS(1499),
    [anon_sym_typeof] = ACTIONS(694),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1495),
    [anon_sym_let] = ACTIONS(1495),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(48),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(1495),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(702),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1501),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1503),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(718),
    [anon_sym_DASH] = ACTIONS(718),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [sym_number] = ACTIONS(102),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(730),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(110),
    [sym_false] = ACTIONS(110),
    [sym_null] = ACTIONS(110),
    [sym_undefined] = ACTIONS(1505),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1495),
    [anon_sym_readonly] = ACTIONS(1507),
    [anon_sym_get] = ACTIONS(1495),
    [anon_sym_set] = ACTIONS(1495),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(1495),
    [anon_sym_public] = ACTIONS(1495),
    [anon_sym_private] = ACTIONS(1495),
    [anon_sym_protected] = ACTIONS(1495),
    [anon_sym_override] = ACTIONS(1495),
    [anon_sym_module] = ACTIONS(1495),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [anon_sym_property] = ACTIONS(1495),
    [anon_sym_signal] = ACTIONS(1495),
    [anon_sym_on] = ACTIONS(1495),
    [anon_sym_required] = ACTIONS(1495),
    [anon_sym_component] = ACTIONS(1495),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [159] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1917),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(159),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_STAR] = ACTIONS(1511),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_as] = ACTIONS(1513),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(1515),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_RPAREN] = ACTIONS(1515),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_in] = ACTIONS(1513),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_COLON] = ACTIONS(1515),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_RBRACK] = ACTIONS(1515),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(1513),
    [anon_sym_DOT] = ACTIONS(1513),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_QMARK_DOT] = ACTIONS(1515),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_AMP_AMP] = ACTIONS(1515),
    [anon_sym_PIPE_PIPE] = ACTIONS(1515),
    [anon_sym_GT_GT] = ACTIONS(1513),
    [anon_sym_GT_GT_GT] = ACTIONS(1515),
    [anon_sym_LT_LT] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1513),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_PIPE] = ACTIONS(1513),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(1515),
    [anon_sym_STAR_STAR] = ACTIONS(1515),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(1515),
    [anon_sym_EQ_EQ] = ACTIONS(1513),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1515),
    [anon_sym_BANG_EQ] = ACTIONS(1513),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1515),
    [anon_sym_GT_EQ] = ACTIONS(1515),
    [anon_sym_QMARK_QMARK] = ACTIONS(1515),
    [anon_sym_instanceof] = ACTIONS(1513),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [anon_sym_satisfies] = ACTIONS(1513),
    [sym__ternary_qmark] = ACTIONS(1515),
    [sym_html_comment] = ACTIONS(5),
  },
  [160] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2056),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(160),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_STAR] = ACTIONS(1519),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_as] = ACTIONS(1513),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_COMMA] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(1515),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_in] = ACTIONS(1513),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_SEMI] = ACTIONS(1515),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(1513),
    [anon_sym_DOT] = ACTIONS(1513),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_QMARK_DOT] = ACTIONS(1515),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_AMP_AMP] = ACTIONS(1515),
    [anon_sym_PIPE_PIPE] = ACTIONS(1515),
    [anon_sym_GT_GT] = ACTIONS(1513),
    [anon_sym_GT_GT_GT] = ACTIONS(1515),
    [anon_sym_LT_LT] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1513),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_PIPE] = ACTIONS(1513),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_PERCENT] = ACTIONS(1515),
    [anon_sym_STAR_STAR] = ACTIONS(1515),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(1515),
    [anon_sym_EQ_EQ] = ACTIONS(1513),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1515),
    [anon_sym_BANG_EQ] = ACTIONS(1513),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1515),
    [anon_sym_GT_EQ] = ACTIONS(1515),
    [anon_sym_QMARK_QMARK] = ACTIONS(1515),
    [anon_sym_instanceof] = ACTIONS(1513),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [anon_sym_satisfies] = ACTIONS(1513),
    [sym__automatic_semicolon] = ACTIONS(1515),
    [sym__ternary_qmark] = ACTIONS(1515),
    [sym_html_comment] = ACTIONS(5),
  },
  [161] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_expression] = STATE(2066),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6164),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3271),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6167),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(161),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1451),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(522),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_export] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1525),
    [anon_sym_type] = ACTIONS(1327),
    [anon_sym_as] = ACTIONS(1513),
    [anon_sym_namespace] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_COMMA] = ACTIONS(1515),
    [anon_sym_typeof] = ACTIONS(1349),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_let] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_in] = ACTIONS(1513),
    [anon_sym_of] = ACTIONS(1327),
    [anon_sym_SEMI] = ACTIONS(1515),
    [anon_sym_yield] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(1513),
    [anon_sym_DOT] = ACTIONS(1513),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_QMARK_DOT] = ACTIONS(1515),
    [anon_sym_new] = ACTIONS(1527),
    [anon_sym_using] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1515),
    [anon_sym_PIPE_PIPE] = ACTIONS(1515),
    [anon_sym_GT_GT] = ACTIONS(1513),
    [anon_sym_GT_GT_GT] = ACTIONS(1515),
    [anon_sym_LT_LT] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1513),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_PIPE] = ACTIONS(1513),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_SLASH] = ACTIONS(962),
    [anon_sym_PERCENT] = ACTIONS(1515),
    [anon_sym_STAR_STAR] = ACTIONS(1515),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(1515),
    [anon_sym_EQ_EQ] = ACTIONS(1513),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1515),
    [anon_sym_BANG_EQ] = ACTIONS(1513),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1515),
    [anon_sym_GT_EQ] = ACTIONS(1515),
    [anon_sym_QMARK_QMARK] = ACTIONS(1515),
    [anon_sym_instanceof] = ACTIONS(1513),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_void] = ACTIONS(1349),
    [anon_sym_delete] = ACTIONS(1349),
    [anon_sym_PLUS_PLUS] = ACTIONS(1351),
    [anon_sym_DASH_DASH] = ACTIONS(1351),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1353),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1327),
    [anon_sym_readonly] = ACTIONS(1327),
    [anon_sym_get] = ACTIONS(1327),
    [anon_sym_set] = ACTIONS(1327),
    [anon_sym_declare] = ACTIONS(1327),
    [anon_sym_public] = ACTIONS(1327),
    [anon_sym_private] = ACTIONS(1327),
    [anon_sym_protected] = ACTIONS(1327),
    [anon_sym_override] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_any] = ACTIONS(1327),
    [anon_sym_number] = ACTIONS(1327),
    [anon_sym_boolean] = ACTIONS(1327),
    [anon_sym_string] = ACTIONS(1327),
    [anon_sym_symbol] = ACTIONS(1327),
    [anon_sym_object] = ACTIONS(1327),
    [anon_sym_property] = ACTIONS(1327),
    [anon_sym_signal] = ACTIONS(1327),
    [anon_sym_on] = ACTIONS(1327),
    [anon_sym_required] = ACTIONS(1327),
    [anon_sym_component] = ACTIONS(1327),
    [anon_sym_satisfies] = ACTIONS(1513),
    [sym__automatic_semicolon] = ACTIONS(1515),
    [sym__ternary_qmark] = ACTIONS(1515),
    [sym_html_comment] = ACTIONS(5),
  },
  [162] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1487),
    [sym_expression] = STATE(2251),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1487),
    [sym_subscript_expression] = STATE(1487),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3189),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6145),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(162),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1487),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1533),
    [anon_sym_type] = ACTIONS(1131),
    [anon_sym_as] = ACTIONS(1513),
    [anon_sym_namespace] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1159),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_let] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_in] = ACTIONS(1513),
    [anon_sym_of] = ACTIONS(1131),
    [anon_sym_SEMI] = ACTIONS(1515),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(1513),
    [anon_sym_DOT] = ACTIONS(1513),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1149),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_QMARK_DOT] = ACTIONS(1515),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_using] = ACTIONS(1153),
    [anon_sym_AMP_AMP] = ACTIONS(1515),
    [anon_sym_PIPE_PIPE] = ACTIONS(1515),
    [anon_sym_GT_GT] = ACTIONS(1513),
    [anon_sym_GT_GT_GT] = ACTIONS(1515),
    [anon_sym_LT_LT] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1513),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_PIPE] = ACTIONS(1513),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_PERCENT] = ACTIONS(1515),
    [anon_sym_STAR_STAR] = ACTIONS(1515),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(1515),
    [anon_sym_EQ_EQ] = ACTIONS(1513),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1515),
    [anon_sym_BANG_EQ] = ACTIONS(1513),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1515),
    [anon_sym_GT_EQ] = ACTIONS(1515),
    [anon_sym_QMARK_QMARK] = ACTIONS(1515),
    [anon_sym_instanceof] = ACTIONS(1513),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1159),
    [anon_sym_delete] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1167),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1131),
    [anon_sym_readonly] = ACTIONS(1131),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_declare] = ACTIONS(1131),
    [anon_sym_public] = ACTIONS(1131),
    [anon_sym_private] = ACTIONS(1131),
    [anon_sym_protected] = ACTIONS(1131),
    [anon_sym_override] = ACTIONS(1131),
    [anon_sym_module] = ACTIONS(1131),
    [anon_sym_any] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_boolean] = ACTIONS(1131),
    [anon_sym_string] = ACTIONS(1131),
    [anon_sym_symbol] = ACTIONS(1131),
    [anon_sym_object] = ACTIONS(1131),
    [anon_sym_property] = ACTIONS(1131),
    [anon_sym_signal] = ACTIONS(1131),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_required] = ACTIONS(1131),
    [anon_sym_component] = ACTIONS(1131),
    [anon_sym_satisfies] = ACTIONS(1513),
    [sym__automatic_semicolon] = ACTIONS(1515),
    [sym__ternary_qmark] = ACTIONS(1515),
    [sym_html_comment] = ACTIONS(5),
  },
  [163] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1473),
    [sym_expression] = STATE(2096),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6272),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1473),
    [sym_subscript_expression] = STATE(1473),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3246),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6274),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(163),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1473),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(541),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_export] = ACTIONS(1415),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_type] = ACTIONS(1415),
    [anon_sym_as] = ACTIONS(1513),
    [anon_sym_namespace] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(1515),
    [anon_sym_typeof] = ACTIONS(1437),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1415),
    [anon_sym_let] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1437),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1423),
    [anon_sym_in] = ACTIONS(1513),
    [anon_sym_of] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1425),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(1513),
    [anon_sym_DOT] = ACTIONS(1513),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1427),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_QMARK_DOT] = ACTIONS(1515),
    [anon_sym_new] = ACTIONS(1543),
    [anon_sym_using] = ACTIONS(1431),
    [anon_sym_AMP_AMP] = ACTIONS(1515),
    [anon_sym_PIPE_PIPE] = ACTIONS(1515),
    [anon_sym_GT_GT] = ACTIONS(1513),
    [anon_sym_GT_GT_GT] = ACTIONS(1515),
    [anon_sym_LT_LT] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1513),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_PIPE] = ACTIONS(1513),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_PERCENT] = ACTIONS(1515),
    [anon_sym_STAR_STAR] = ACTIONS(1515),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(1515),
    [anon_sym_EQ_EQ] = ACTIONS(1513),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1515),
    [anon_sym_BANG_EQ] = ACTIONS(1513),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1515),
    [anon_sym_GT_EQ] = ACTIONS(1515),
    [anon_sym_QMARK_QMARK] = ACTIONS(1515),
    [anon_sym_instanceof] = ACTIONS(1513),
    [anon_sym_TILDE] = ACTIONS(1421),
    [anon_sym_void] = ACTIONS(1437),
    [anon_sym_delete] = ACTIONS(1437),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1441),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1415),
    [anon_sym_readonly] = ACTIONS(1415),
    [anon_sym_get] = ACTIONS(1415),
    [anon_sym_set] = ACTIONS(1415),
    [anon_sym_declare] = ACTIONS(1415),
    [anon_sym_public] = ACTIONS(1415),
    [anon_sym_private] = ACTIONS(1415),
    [anon_sym_protected] = ACTIONS(1415),
    [anon_sym_override] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_any] = ACTIONS(1415),
    [anon_sym_number] = ACTIONS(1415),
    [anon_sym_boolean] = ACTIONS(1415),
    [anon_sym_string] = ACTIONS(1415),
    [anon_sym_symbol] = ACTIONS(1415),
    [anon_sym_object] = ACTIONS(1415),
    [anon_sym_property] = ACTIONS(1415),
    [anon_sym_signal] = ACTIONS(1415),
    [anon_sym_on] = ACTIONS(1415),
    [anon_sym_required] = ACTIONS(1415),
    [anon_sym_component] = ACTIONS(1415),
    [anon_sym_satisfies] = ACTIONS(1513),
    [anon_sym_implements] = ACTIONS(1513),
    [sym__ternary_qmark] = ACTIONS(1515),
    [sym_html_comment] = ACTIONS(5),
  },
  [164] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1520),
    [sym_expression] = STATE(2604),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1520),
    [sym_subscript_expression] = STATE(1520),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6049),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(164),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1520),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(556),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1229),
    [anon_sym_STAR] = ACTIONS(1549),
    [anon_sym_type] = ACTIONS(1229),
    [anon_sym_as] = ACTIONS(1513),
    [anon_sym_namespace] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1229),
    [anon_sym_let] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1253),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_in] = ACTIONS(1513),
    [anon_sym_of] = ACTIONS(1229),
    [anon_sym_yield] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_RBRACK] = ACTIONS(1515),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(1513),
    [anon_sym_DOT] = ACTIONS(1513),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_QMARK_DOT] = ACTIONS(1515),
    [anon_sym_new] = ACTIONS(1551),
    [anon_sym_using] = ACTIONS(1247),
    [anon_sym_AMP_AMP] = ACTIONS(1515),
    [anon_sym_PIPE_PIPE] = ACTIONS(1515),
    [anon_sym_GT_GT] = ACTIONS(1513),
    [anon_sym_GT_GT_GT] = ACTIONS(1515),
    [anon_sym_LT_LT] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1513),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_PIPE] = ACTIONS(1513),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(1515),
    [anon_sym_STAR_STAR] = ACTIONS(1515),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(1515),
    [anon_sym_EQ_EQ] = ACTIONS(1513),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1515),
    [anon_sym_BANG_EQ] = ACTIONS(1513),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1515),
    [anon_sym_GT_EQ] = ACTIONS(1515),
    [anon_sym_QMARK_QMARK] = ACTIONS(1515),
    [anon_sym_instanceof] = ACTIONS(1513),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1257),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_readonly] = ACTIONS(1229),
    [anon_sym_get] = ACTIONS(1229),
    [anon_sym_set] = ACTIONS(1229),
    [anon_sym_declare] = ACTIONS(1229),
    [anon_sym_public] = ACTIONS(1229),
    [anon_sym_private] = ACTIONS(1229),
    [anon_sym_protected] = ACTIONS(1229),
    [anon_sym_override] = ACTIONS(1229),
    [anon_sym_module] = ACTIONS(1229),
    [anon_sym_any] = ACTIONS(1229),
    [anon_sym_number] = ACTIONS(1229),
    [anon_sym_boolean] = ACTIONS(1229),
    [anon_sym_string] = ACTIONS(1229),
    [anon_sym_symbol] = ACTIONS(1229),
    [anon_sym_object] = ACTIONS(1229),
    [anon_sym_property] = ACTIONS(1229),
    [anon_sym_signal] = ACTIONS(1229),
    [anon_sym_on] = ACTIONS(1229),
    [anon_sym_required] = ACTIONS(1229),
    [anon_sym_component] = ACTIONS(1229),
    [anon_sym_satisfies] = ACTIONS(1513),
    [sym__ternary_qmark] = ACTIONS(1515),
    [sym_html_comment] = ACTIONS(5),
  },
  [165] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_expression] = STATE(2442),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5939),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(165),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1523),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1555),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(1557),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_as] = ACTIONS(1513),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_in] = ACTIONS(1513),
    [anon_sym_of] = ACTIONS(1181),
    [anon_sym_COLON] = ACTIONS(1515),
    [anon_sym_yield] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(1513),
    [anon_sym_DOT] = ACTIONS(1513),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_QMARK_DOT] = ACTIONS(1515),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_using] = ACTIONS(1201),
    [anon_sym_AMP_AMP] = ACTIONS(1515),
    [anon_sym_PIPE_PIPE] = ACTIONS(1515),
    [anon_sym_GT_GT] = ACTIONS(1513),
    [anon_sym_GT_GT_GT] = ACTIONS(1515),
    [anon_sym_LT_LT] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1513),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_PIPE] = ACTIONS(1513),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(1515),
    [anon_sym_STAR_STAR] = ACTIONS(1515),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(1515),
    [anon_sym_EQ_EQ] = ACTIONS(1513),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1515),
    [anon_sym_BANG_EQ] = ACTIONS(1513),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1515),
    [anon_sym_GT_EQ] = ACTIONS(1515),
    [anon_sym_QMARK_QMARK] = ACTIONS(1515),
    [anon_sym_instanceof] = ACTIONS(1513),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_property] = ACTIONS(1181),
    [anon_sym_signal] = ACTIONS(1181),
    [anon_sym_on] = ACTIONS(1181),
    [anon_sym_required] = ACTIONS(1181),
    [anon_sym_component] = ACTIONS(1181),
    [anon_sym_satisfies] = ACTIONS(1513),
    [sym__ternary_qmark] = ACTIONS(1515),
    [sym_html_comment] = ACTIONS(5),
  },
  [166] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2720),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(166),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_STAR] = ACTIONS(1563),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_as] = ACTIONS(1513),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_in] = ACTIONS(1513),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(1513),
    [anon_sym_DOT] = ACTIONS(1513),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_QMARK_DOT] = ACTIONS(1515),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_AMP_AMP] = ACTIONS(1515),
    [anon_sym_PIPE_PIPE] = ACTIONS(1515),
    [anon_sym_GT_GT] = ACTIONS(1513),
    [anon_sym_GT_GT_GT] = ACTIONS(1515),
    [anon_sym_LT_LT] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1513),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_PIPE] = ACTIONS(1513),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(1515),
    [anon_sym_STAR_STAR] = ACTIONS(1515),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(1515),
    [anon_sym_EQ_EQ] = ACTIONS(1513),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1515),
    [anon_sym_BANG_EQ] = ACTIONS(1513),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1515),
    [anon_sym_GT_EQ] = ACTIONS(1515),
    [anon_sym_QMARK_QMARK] = ACTIONS(1515),
    [anon_sym_instanceof] = ACTIONS(1513),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [anon_sym_satisfies] = ACTIONS(1513),
    [sym__ternary_qmark] = ACTIONS(1515),
    [sym_html_comment] = ACTIONS(5),
  },
  [167] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1513),
    [sym_expression] = STATE(2614),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6293),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1513),
    [sym_subscript_expression] = STATE(1513),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3245),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6295),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(167),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1513),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(455),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1565),
    [anon_sym_export] = ACTIONS(1379),
    [anon_sym_STAR] = ACTIONS(1567),
    [anon_sym_type] = ACTIONS(1379),
    [anon_sym_as] = ACTIONS(1513),
    [anon_sym_namespace] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1379),
    [anon_sym_let] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_in] = ACTIONS(1513),
    [anon_sym_of] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1389),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(1513),
    [anon_sym_DOT] = ACTIONS(1513),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1391),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_QMARK_DOT] = ACTIONS(1515),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_using] = ACTIONS(1395),
    [anon_sym_AMP_AMP] = ACTIONS(1515),
    [anon_sym_PIPE_PIPE] = ACTIONS(1515),
    [anon_sym_GT_GT] = ACTIONS(1513),
    [anon_sym_GT_GT_GT] = ACTIONS(1515),
    [anon_sym_LT_LT] = ACTIONS(1515),
    [anon_sym_AMP] = ACTIONS(1513),
    [anon_sym_CARET] = ACTIONS(1515),
    [anon_sym_PIPE] = ACTIONS(1513),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_PERCENT] = ACTIONS(1515),
    [anon_sym_STAR_STAR] = ACTIONS(1515),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_LT_EQ] = ACTIONS(1515),
    [anon_sym_EQ_EQ] = ACTIONS(1513),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1515),
    [anon_sym_BANG_EQ] = ACTIONS(1513),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1515),
    [anon_sym_GT_EQ] = ACTIONS(1515),
    [anon_sym_QMARK_QMARK] = ACTIONS(1515),
    [anon_sym_instanceof] = ACTIONS(1513),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_void] = ACTIONS(1401),
    [anon_sym_delete] = ACTIONS(1401),
    [anon_sym_PLUS_PLUS] = ACTIONS(1403),
    [anon_sym_DASH_DASH] = ACTIONS(1403),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1405),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1571),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1379),
    [anon_sym_readonly] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(1379),
    [anon_sym_set] = ACTIONS(1379),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_public] = ACTIONS(1379),
    [anon_sym_private] = ACTIONS(1379),
    [anon_sym_protected] = ACTIONS(1379),
    [anon_sym_override] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1379),
    [anon_sym_any] = ACTIONS(1379),
    [anon_sym_number] = ACTIONS(1379),
    [anon_sym_boolean] = ACTIONS(1379),
    [anon_sym_string] = ACTIONS(1379),
    [anon_sym_symbol] = ACTIONS(1379),
    [anon_sym_object] = ACTIONS(1379),
    [anon_sym_property] = ACTIONS(1379),
    [anon_sym_signal] = ACTIONS(1379),
    [anon_sym_on] = ACTIONS(1379),
    [anon_sym_required] = ACTIONS(1379),
    [anon_sym_component] = ACTIONS(1379),
    [anon_sym_satisfies] = ACTIONS(1513),
    [sym__ternary_qmark] = ACTIONS(1515),
    [sym_html_comment] = ACTIONS(5),
  },
  [168] = {
    [sym_declaration] = STATE(2930),
    [sym_import] = STATE(3590),
    [sym_variable_declaration] = STATE(2949),
    [sym_lexical_declaration] = STATE(2949),
    [sym_parenthesized_expression] = STATE(1487),
    [sym_expression] = STATE(2255),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(2949),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(2949),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(2949),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1487),
    [sym_subscript_expression] = STATE(1487),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3189),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6145),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(168),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1487),
    [sym_function_signature] = STATE(2949),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(2949),
    [sym_abstract_class_declaration] = STATE(2949),
    [sym_module] = STATE(2949),
    [sym_internal_module] = STATE(933),
    [sym_import_alias] = STATE(2949),
    [sym_interface_declaration] = STATE(2949),
    [sym_enum_declaration] = STATE(2949),
    [sym_type_alias_declaration] = STATE(2949),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4625),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1573),
    [anon_sym_namespace] = ACTIONS(1575),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1159),
    [anon_sym_import] = ACTIONS(1577),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_var] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(1579),
    [anon_sym_const] = ACTIONS(604),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_of] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(630),
    [anon_sym_async] = ACTIONS(1581),
    [anon_sym_function] = ACTIONS(634),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_using] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1159),
    [anon_sym_delete] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1167),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1131),
    [anon_sym_readonly] = ACTIONS(1131),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_declare] = ACTIONS(1583),
    [anon_sym_public] = ACTIONS(1131),
    [anon_sym_private] = ACTIONS(1131),
    [anon_sym_protected] = ACTIONS(1131),
    [anon_sym_override] = ACTIONS(1131),
    [anon_sym_module] = ACTIONS(1585),
    [anon_sym_any] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_boolean] = ACTIONS(1131),
    [anon_sym_string] = ACTIONS(1131),
    [anon_sym_symbol] = ACTIONS(1131),
    [anon_sym_object] = ACTIONS(1131),
    [anon_sym_property] = ACTIONS(1131),
    [anon_sym_signal] = ACTIONS(1131),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_required] = ACTIONS(1131),
    [anon_sym_component] = ACTIONS(1131),
    [anon_sym_abstract] = ACTIONS(642),
    [anon_sym_interface] = ACTIONS(644),
    [anon_sym_enum] = ACTIONS(646),
    [sym_html_comment] = ACTIONS(5),
  },
  [169] = {
    [sym_declaration] = STATE(870),
    [sym_import] = STATE(3590),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_parenthesized_expression] = STATE(1487),
    [sym_expression] = STATE(2341),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1487),
    [sym_subscript_expression] = STATE(1487),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3189),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6145),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(169),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1487),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(231),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4360),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1587),
    [anon_sym_namespace] = ACTIONS(1589),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1159),
    [anon_sym_import] = ACTIONS(1591),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(1593),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_of] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_async] = ACTIONS(1595),
    [anon_sym_function] = ACTIONS(213),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_using] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1159),
    [anon_sym_delete] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1167),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1131),
    [anon_sym_readonly] = ACTIONS(1131),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_declare] = ACTIONS(1597),
    [anon_sym_public] = ACTIONS(1131),
    [anon_sym_private] = ACTIONS(1131),
    [anon_sym_protected] = ACTIONS(1131),
    [anon_sym_override] = ACTIONS(1131),
    [anon_sym_module] = ACTIONS(1599),
    [anon_sym_any] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_boolean] = ACTIONS(1131),
    [anon_sym_string] = ACTIONS(1131),
    [anon_sym_symbol] = ACTIONS(1131),
    [anon_sym_object] = ACTIONS(1131),
    [anon_sym_property] = ACTIONS(1131),
    [anon_sym_signal] = ACTIONS(1131),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_required] = ACTIONS(1131),
    [anon_sym_component] = ACTIONS(1131),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [170] = {
    [sym_declaration] = STATE(848),
    [sym_import] = STATE(3590),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_parenthesized_expression] = STATE(1487),
    [sym_expression] = STATE(2337),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1487),
    [sym_subscript_expression] = STATE(1487),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3189),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6145),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(170),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1487),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(2510),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4533),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1587),
    [anon_sym_namespace] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1159),
    [anon_sym_import] = ACTIONS(1591),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_var] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(1593),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_of] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(670),
    [anon_sym_async] = ACTIONS(1601),
    [anon_sym_function] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_using] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1159),
    [anon_sym_delete] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1167),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1131),
    [anon_sym_readonly] = ACTIONS(1131),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_declare] = ACTIONS(1603),
    [anon_sym_public] = ACTIONS(1131),
    [anon_sym_private] = ACTIONS(1131),
    [anon_sym_protected] = ACTIONS(1131),
    [anon_sym_override] = ACTIONS(1131),
    [anon_sym_module] = ACTIONS(1605),
    [anon_sym_any] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_boolean] = ACTIONS(1131),
    [anon_sym_string] = ACTIONS(1131),
    [anon_sym_symbol] = ACTIONS(1131),
    [anon_sym_object] = ACTIONS(1131),
    [anon_sym_property] = ACTIONS(1131),
    [anon_sym_signal] = ACTIONS(1131),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_required] = ACTIONS(1131),
    [anon_sym_component] = ACTIONS(1131),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [171] = {
    [sym_declaration] = STATE(2921),
    [sym_import] = STATE(3590),
    [sym_variable_declaration] = STATE(2949),
    [sym_lexical_declaration] = STATE(2949),
    [sym_parenthesized_expression] = STATE(1487),
    [sym_expression] = STATE(2254),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(2949),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(2949),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(2949),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1487),
    [sym_subscript_expression] = STATE(1487),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3189),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6145),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(171),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1487),
    [sym_function_signature] = STATE(2949),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(2949),
    [sym_abstract_class_declaration] = STATE(2949),
    [sym_module] = STATE(2949),
    [sym_internal_module] = STATE(933),
    [sym_import_alias] = STATE(2949),
    [sym_interface_declaration] = STATE(2949),
    [sym_enum_declaration] = STATE(2949),
    [sym_type_alias_declaration] = STATE(2949),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4625),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1573),
    [anon_sym_namespace] = ACTIONS(1575),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1159),
    [anon_sym_import] = ACTIONS(1577),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_var] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(1579),
    [anon_sym_const] = ACTIONS(604),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_of] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(630),
    [anon_sym_async] = ACTIONS(1581),
    [anon_sym_function] = ACTIONS(634),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_using] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1159),
    [anon_sym_delete] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1167),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1131),
    [anon_sym_readonly] = ACTIONS(1131),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_declare] = ACTIONS(1583),
    [anon_sym_public] = ACTIONS(1131),
    [anon_sym_private] = ACTIONS(1131),
    [anon_sym_protected] = ACTIONS(1131),
    [anon_sym_override] = ACTIONS(1131),
    [anon_sym_module] = ACTIONS(1585),
    [anon_sym_any] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_boolean] = ACTIONS(1131),
    [anon_sym_string] = ACTIONS(1131),
    [anon_sym_symbol] = ACTIONS(1131),
    [anon_sym_object] = ACTIONS(1131),
    [anon_sym_property] = ACTIONS(1131),
    [anon_sym_signal] = ACTIONS(1131),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_required] = ACTIONS(1131),
    [anon_sym_component] = ACTIONS(1131),
    [anon_sym_abstract] = ACTIONS(642),
    [anon_sym_interface] = ACTIONS(644),
    [anon_sym_enum] = ACTIONS(646),
    [sym_html_comment] = ACTIONS(5),
  },
  [172] = {
    [sym_declaration] = STATE(4672),
    [sym_import] = STATE(3590),
    [sym_variable_declaration] = STATE(4205),
    [sym_lexical_declaration] = STATE(4205),
    [sym_parenthesized_expression] = STATE(1487),
    [sym_expression] = STATE(2306),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(4205),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(4205),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(4205),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1487),
    [sym_subscript_expression] = STATE(1487),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3189),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6145),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(172),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1487),
    [sym_function_signature] = STATE(4205),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(4205),
    [sym_abstract_class_declaration] = STATE(4205),
    [sym_module] = STATE(4205),
    [sym_internal_module] = STATE(2654),
    [sym_import_alias] = STATE(4205),
    [sym_interface_declaration] = STATE(4205),
    [sym_enum_declaration] = STATE(4205),
    [sym_type_alias_declaration] = STATE(4205),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4491),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1607),
    [anon_sym_namespace] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1159),
    [anon_sym_import] = ACTIONS(1609),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_var] = ACTIONS(1611),
    [anon_sym_let] = ACTIONS(1613),
    [anon_sym_const] = ACTIONS(1615),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_of] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1619),
    [anon_sym_function] = ACTIONS(1621),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_using] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1159),
    [anon_sym_delete] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1167),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1131),
    [anon_sym_readonly] = ACTIONS(1131),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_declare] = ACTIONS(1623),
    [anon_sym_public] = ACTIONS(1131),
    [anon_sym_private] = ACTIONS(1131),
    [anon_sym_protected] = ACTIONS(1131),
    [anon_sym_override] = ACTIONS(1131),
    [anon_sym_module] = ACTIONS(1625),
    [anon_sym_any] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_boolean] = ACTIONS(1131),
    [anon_sym_string] = ACTIONS(1131),
    [anon_sym_symbol] = ACTIONS(1131),
    [anon_sym_object] = ACTIONS(1131),
    [anon_sym_property] = ACTIONS(1131),
    [anon_sym_signal] = ACTIONS(1131),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_required] = ACTIONS(1131),
    [anon_sym_component] = ACTIONS(1131),
    [anon_sym_abstract] = ACTIONS(1627),
    [anon_sym_interface] = ACTIONS(1629),
    [anon_sym_enum] = ACTIONS(1631),
    [sym_html_comment] = ACTIONS(5),
  },
  [173] = {
    [sym_declaration] = STATE(848),
    [sym_import] = STATE(3590),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_parenthesized_expression] = STATE(1487),
    [sym_expression] = STATE(2337),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1487),
    [sym_subscript_expression] = STATE(1487),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3189),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6145),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(173),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1487),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(231),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4360),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1587),
    [anon_sym_namespace] = ACTIONS(1589),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1159),
    [anon_sym_import] = ACTIONS(1591),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_var] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(1593),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_of] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(209),
    [anon_sym_async] = ACTIONS(1595),
    [anon_sym_function] = ACTIONS(213),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_using] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1159),
    [anon_sym_delete] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1167),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1131),
    [anon_sym_readonly] = ACTIONS(1131),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_declare] = ACTIONS(1597),
    [anon_sym_public] = ACTIONS(1131),
    [anon_sym_private] = ACTIONS(1131),
    [anon_sym_protected] = ACTIONS(1131),
    [anon_sym_override] = ACTIONS(1131),
    [anon_sym_module] = ACTIONS(1599),
    [anon_sym_any] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_boolean] = ACTIONS(1131),
    [anon_sym_string] = ACTIONS(1131),
    [anon_sym_symbol] = ACTIONS(1131),
    [anon_sym_object] = ACTIONS(1131),
    [anon_sym_property] = ACTIONS(1131),
    [anon_sym_signal] = ACTIONS(1131),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_required] = ACTIONS(1131),
    [anon_sym_component] = ACTIONS(1131),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [174] = {
    [sym_declaration] = STATE(4428),
    [sym_import] = STATE(3590),
    [sym_variable_declaration] = STATE(4205),
    [sym_lexical_declaration] = STATE(4205),
    [sym_parenthesized_expression] = STATE(1487),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(4205),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(4205),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(4205),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1487),
    [sym_subscript_expression] = STATE(1487),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3189),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6145),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(174),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1487),
    [sym_function_signature] = STATE(4205),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(4205),
    [sym_abstract_class_declaration] = STATE(4205),
    [sym_module] = STATE(4205),
    [sym_internal_module] = STATE(2654),
    [sym_import_alias] = STATE(4205),
    [sym_interface_declaration] = STATE(4205),
    [sym_enum_declaration] = STATE(4205),
    [sym_type_alias_declaration] = STATE(4205),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4491),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1607),
    [anon_sym_namespace] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1159),
    [anon_sym_import] = ACTIONS(1609),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_var] = ACTIONS(1611),
    [anon_sym_let] = ACTIONS(1613),
    [anon_sym_const] = ACTIONS(1615),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_of] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(1619),
    [anon_sym_function] = ACTIONS(1621),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_using] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1159),
    [anon_sym_delete] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1167),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1131),
    [anon_sym_readonly] = ACTIONS(1131),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_declare] = ACTIONS(1623),
    [anon_sym_public] = ACTIONS(1131),
    [anon_sym_private] = ACTIONS(1131),
    [anon_sym_protected] = ACTIONS(1131),
    [anon_sym_override] = ACTIONS(1131),
    [anon_sym_module] = ACTIONS(1625),
    [anon_sym_any] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_boolean] = ACTIONS(1131),
    [anon_sym_string] = ACTIONS(1131),
    [anon_sym_symbol] = ACTIONS(1131),
    [anon_sym_object] = ACTIONS(1131),
    [anon_sym_property] = ACTIONS(1131),
    [anon_sym_signal] = ACTIONS(1131),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_required] = ACTIONS(1131),
    [anon_sym_component] = ACTIONS(1131),
    [anon_sym_abstract] = ACTIONS(1627),
    [anon_sym_interface] = ACTIONS(1629),
    [anon_sym_enum] = ACTIONS(1631),
    [sym_html_comment] = ACTIONS(5),
  },
  [175] = {
    [sym_declaration] = STATE(870),
    [sym_import] = STATE(3590),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_parenthesized_expression] = STATE(1487),
    [sym_expression] = STATE(2341),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_class_declaration] = STATE(829),
    [sym_function_expression] = STATE(2480),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function] = STATE(2480),
    [sym_generator_function_declaration] = STATE(829),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1487),
    [sym_subscript_expression] = STATE(1487),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3189),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6145),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(175),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1487),
    [sym_function_signature] = STATE(829),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(2510),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4533),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1587),
    [anon_sym_namespace] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1159),
    [anon_sym_import] = ACTIONS(1591),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_var] = ACTIONS(600),
    [anon_sym_let] = ACTIONS(1593),
    [anon_sym_const] = ACTIONS(169),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_of] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(670),
    [anon_sym_async] = ACTIONS(1601),
    [anon_sym_function] = ACTIONS(674),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_using] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1159),
    [anon_sym_delete] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1167),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1131),
    [anon_sym_readonly] = ACTIONS(1131),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_declare] = ACTIONS(1603),
    [anon_sym_public] = ACTIONS(1131),
    [anon_sym_private] = ACTIONS(1131),
    [anon_sym_protected] = ACTIONS(1131),
    [anon_sym_override] = ACTIONS(1131),
    [anon_sym_module] = ACTIONS(1605),
    [anon_sym_any] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_boolean] = ACTIONS(1131),
    [anon_sym_string] = ACTIONS(1131),
    [anon_sym_symbol] = ACTIONS(1131),
    [anon_sym_object] = ACTIONS(1131),
    [anon_sym_property] = ACTIONS(1131),
    [anon_sym_signal] = ACTIONS(1131),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_required] = ACTIONS(1131),
    [anon_sym_component] = ACTIONS(1131),
    [anon_sym_abstract] = ACTIONS(249),
    [anon_sym_interface] = ACTIONS(251),
    [anon_sym_enum] = ACTIONS(253),
    [sym_html_comment] = ACTIONS(5),
  },
  [176] = {
    [sym_import] = STATE(3590),
    [sym_expression_statement] = STATE(3044),
    [sym_statement_block] = STATE(3044),
    [sym_if_statement] = STATE(3044),
    [sym_switch_statement] = STATE(3044),
    [sym_try_statement] = STATE(3044),
    [sym_with_statement] = STATE(3044),
    [sym_empty_statement] = STATE(3044),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1978),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5533),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(176),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [sym_ui_object_definition] = STATE(5704),
    [sym_ui_object_array] = STATE(5704),
    [sym_ui_nested_identifier] = STATE(5203),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1633),
    [anon_sym_export] = ACTIONS(1635),
    [anon_sym_type] = ACTIONS(1635),
    [anon_sym_namespace] = ACTIONS(1637),
    [anon_sym_LBRACE] = ACTIONS(592),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1635),
    [anon_sym_with] = ACTIONS(598),
    [anon_sym_let] = ACTIONS(1635),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(606),
    [anon_sym_switch] = ACTIONS(608),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1635),
    [anon_sym_try] = ACTIONS(616),
    [anon_sym_SEMI] = ACTIONS(628),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(1639),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1641),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1635),
    [anon_sym_readonly] = ACTIONS(1635),
    [anon_sym_get] = ACTIONS(1635),
    [anon_sym_set] = ACTIONS(1635),
    [anon_sym_declare] = ACTIONS(1635),
    [anon_sym_public] = ACTIONS(1635),
    [anon_sym_private] = ACTIONS(1635),
    [anon_sym_protected] = ACTIONS(1635),
    [anon_sym_override] = ACTIONS(1635),
    [anon_sym_module] = ACTIONS(1635),
    [anon_sym_any] = ACTIONS(1635),
    [anon_sym_number] = ACTIONS(1635),
    [anon_sym_boolean] = ACTIONS(1635),
    [anon_sym_string] = ACTIONS(1635),
    [anon_sym_symbol] = ACTIONS(1635),
    [anon_sym_object] = ACTIONS(1635),
    [anon_sym_property] = ACTIONS(1635),
    [anon_sym_signal] = ACTIONS(1635),
    [anon_sym_on] = ACTIONS(1635),
    [anon_sym_required] = ACTIONS(1635),
    [anon_sym_component] = ACTIONS(1635),
    [sym_html_comment] = ACTIONS(5),
  },
  [177] = {
    [sym_import] = STATE(3590),
    [sym_expression_statement] = STATE(3047),
    [sym_statement_block] = STATE(3047),
    [sym_if_statement] = STATE(3047),
    [sym_switch_statement] = STATE(3047),
    [sym_try_statement] = STATE(3047),
    [sym_with_statement] = STATE(3047),
    [sym_empty_statement] = STATE(3047),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1978),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5533),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(177),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [sym_ui_object_definition] = STATE(5703),
    [sym_ui_object_array] = STATE(5703),
    [sym_ui_nested_identifier] = STATE(5203),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1633),
    [anon_sym_export] = ACTIONS(1635),
    [anon_sym_type] = ACTIONS(1635),
    [anon_sym_namespace] = ACTIONS(1637),
    [anon_sym_LBRACE] = ACTIONS(592),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1635),
    [anon_sym_with] = ACTIONS(598),
    [anon_sym_let] = ACTIONS(1635),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(606),
    [anon_sym_switch] = ACTIONS(608),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1635),
    [anon_sym_try] = ACTIONS(616),
    [anon_sym_SEMI] = ACTIONS(628),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(1639),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1641),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1635),
    [anon_sym_readonly] = ACTIONS(1635),
    [anon_sym_get] = ACTIONS(1635),
    [anon_sym_set] = ACTIONS(1635),
    [anon_sym_declare] = ACTIONS(1635),
    [anon_sym_public] = ACTIONS(1635),
    [anon_sym_private] = ACTIONS(1635),
    [anon_sym_protected] = ACTIONS(1635),
    [anon_sym_override] = ACTIONS(1635),
    [anon_sym_module] = ACTIONS(1635),
    [anon_sym_any] = ACTIONS(1635),
    [anon_sym_number] = ACTIONS(1635),
    [anon_sym_boolean] = ACTIONS(1635),
    [anon_sym_string] = ACTIONS(1635),
    [anon_sym_symbol] = ACTIONS(1635),
    [anon_sym_object] = ACTIONS(1635),
    [anon_sym_property] = ACTIONS(1635),
    [anon_sym_signal] = ACTIONS(1635),
    [anon_sym_on] = ACTIONS(1635),
    [anon_sym_required] = ACTIONS(1635),
    [anon_sym_component] = ACTIONS(1635),
    [sym_html_comment] = ACTIONS(5),
  },
  [178] = {
    [sym_import] = STATE(3590),
    [sym_expression_statement] = STATE(3041),
    [sym_statement_block] = STATE(3041),
    [sym_if_statement] = STATE(3041),
    [sym_switch_statement] = STATE(3041),
    [sym_try_statement] = STATE(3041),
    [sym_with_statement] = STATE(3041),
    [sym_empty_statement] = STATE(3041),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1978),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5533),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(178),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [sym_ui_object_definition] = STATE(5717),
    [sym_ui_object_array] = STATE(5717),
    [sym_ui_nested_identifier] = STATE(5203),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1633),
    [anon_sym_export] = ACTIONS(1635),
    [anon_sym_type] = ACTIONS(1635),
    [anon_sym_namespace] = ACTIONS(1637),
    [anon_sym_LBRACE] = ACTIONS(592),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1635),
    [anon_sym_with] = ACTIONS(598),
    [anon_sym_let] = ACTIONS(1635),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(606),
    [anon_sym_switch] = ACTIONS(608),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1635),
    [anon_sym_try] = ACTIONS(616),
    [anon_sym_SEMI] = ACTIONS(628),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(1639),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1641),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1635),
    [anon_sym_readonly] = ACTIONS(1635),
    [anon_sym_get] = ACTIONS(1635),
    [anon_sym_set] = ACTIONS(1635),
    [anon_sym_declare] = ACTIONS(1635),
    [anon_sym_public] = ACTIONS(1635),
    [anon_sym_private] = ACTIONS(1635),
    [anon_sym_protected] = ACTIONS(1635),
    [anon_sym_override] = ACTIONS(1635),
    [anon_sym_module] = ACTIONS(1635),
    [anon_sym_any] = ACTIONS(1635),
    [anon_sym_number] = ACTIONS(1635),
    [anon_sym_boolean] = ACTIONS(1635),
    [anon_sym_string] = ACTIONS(1635),
    [anon_sym_symbol] = ACTIONS(1635),
    [anon_sym_object] = ACTIONS(1635),
    [anon_sym_property] = ACTIONS(1635),
    [anon_sym_signal] = ACTIONS(1635),
    [anon_sym_on] = ACTIONS(1635),
    [anon_sym_required] = ACTIONS(1635),
    [anon_sym_component] = ACTIONS(1635),
    [sym_html_comment] = ACTIONS(5),
  },
  [179] = {
    [sym_import] = STATE(3590),
    [sym_expression_statement] = STATE(3042),
    [sym_statement_block] = STATE(3042),
    [sym_if_statement] = STATE(3042),
    [sym_switch_statement] = STATE(3042),
    [sym_try_statement] = STATE(3042),
    [sym_with_statement] = STATE(3042),
    [sym_empty_statement] = STATE(3042),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1978),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5533),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(179),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [sym_ui_object_definition] = STATE(5715),
    [sym_ui_object_array] = STATE(5715),
    [sym_ui_nested_identifier] = STATE(5203),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1633),
    [anon_sym_export] = ACTIONS(1635),
    [anon_sym_type] = ACTIONS(1635),
    [anon_sym_namespace] = ACTIONS(1637),
    [anon_sym_LBRACE] = ACTIONS(592),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1635),
    [anon_sym_with] = ACTIONS(598),
    [anon_sym_let] = ACTIONS(1635),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(606),
    [anon_sym_switch] = ACTIONS(608),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1635),
    [anon_sym_try] = ACTIONS(616),
    [anon_sym_SEMI] = ACTIONS(628),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(1639),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1641),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1635),
    [anon_sym_readonly] = ACTIONS(1635),
    [anon_sym_get] = ACTIONS(1635),
    [anon_sym_set] = ACTIONS(1635),
    [anon_sym_declare] = ACTIONS(1635),
    [anon_sym_public] = ACTIONS(1635),
    [anon_sym_private] = ACTIONS(1635),
    [anon_sym_protected] = ACTIONS(1635),
    [anon_sym_override] = ACTIONS(1635),
    [anon_sym_module] = ACTIONS(1635),
    [anon_sym_any] = ACTIONS(1635),
    [anon_sym_number] = ACTIONS(1635),
    [anon_sym_boolean] = ACTIONS(1635),
    [anon_sym_string] = ACTIONS(1635),
    [anon_sym_symbol] = ACTIONS(1635),
    [anon_sym_object] = ACTIONS(1635),
    [anon_sym_property] = ACTIONS(1635),
    [anon_sym_signal] = ACTIONS(1635),
    [anon_sym_on] = ACTIONS(1635),
    [anon_sym_required] = ACTIONS(1635),
    [anon_sym_component] = ACTIONS(1635),
    [sym_html_comment] = ACTIONS(5),
  },
  [180] = {
    [sym_import] = STATE(3590),
    [sym_expression_statement] = STATE(3034),
    [sym_statement_block] = STATE(3034),
    [sym_if_statement] = STATE(3034),
    [sym_switch_statement] = STATE(3034),
    [sym_try_statement] = STATE(3034),
    [sym_with_statement] = STATE(3034),
    [sym_empty_statement] = STATE(3034),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1978),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5533),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(180),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [sym_ui_object_definition] = STATE(3034),
    [sym_ui_object_array] = STATE(3034),
    [sym_ui_nested_identifier] = STATE(5505),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1643),
    [anon_sym_export] = ACTIONS(1645),
    [anon_sym_type] = ACTIONS(1645),
    [anon_sym_namespace] = ACTIONS(1647),
    [anon_sym_LBRACE] = ACTIONS(592),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1645),
    [anon_sym_with] = ACTIONS(598),
    [anon_sym_let] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(606),
    [anon_sym_switch] = ACTIONS(608),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1645),
    [anon_sym_try] = ACTIONS(616),
    [anon_sym_SEMI] = ACTIONS(628),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1651),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1645),
    [anon_sym_readonly] = ACTIONS(1645),
    [anon_sym_get] = ACTIONS(1645),
    [anon_sym_set] = ACTIONS(1645),
    [anon_sym_declare] = ACTIONS(1645),
    [anon_sym_public] = ACTIONS(1645),
    [anon_sym_private] = ACTIONS(1645),
    [anon_sym_protected] = ACTIONS(1645),
    [anon_sym_override] = ACTIONS(1645),
    [anon_sym_module] = ACTIONS(1645),
    [anon_sym_any] = ACTIONS(1645),
    [anon_sym_number] = ACTIONS(1645),
    [anon_sym_boolean] = ACTIONS(1645),
    [anon_sym_string] = ACTIONS(1645),
    [anon_sym_symbol] = ACTIONS(1645),
    [anon_sym_object] = ACTIONS(1645),
    [anon_sym_property] = ACTIONS(1645),
    [anon_sym_signal] = ACTIONS(1645),
    [anon_sym_on] = ACTIONS(1645),
    [anon_sym_required] = ACTIONS(1645),
    [anon_sym_component] = ACTIONS(1645),
    [sym_html_comment] = ACTIONS(5),
  },
  [181] = {
    [sym_import] = STATE(3590),
    [sym_expression_statement] = STATE(3045),
    [sym_statement_block] = STATE(3045),
    [sym_if_statement] = STATE(3045),
    [sym_switch_statement] = STATE(3045),
    [sym_try_statement] = STATE(3045),
    [sym_with_statement] = STATE(3045),
    [sym_empty_statement] = STATE(3045),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1978),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5533),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(181),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [sym_ui_object_definition] = STATE(5634),
    [sym_ui_object_array] = STATE(5634),
    [sym_ui_nested_identifier] = STATE(5203),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1633),
    [anon_sym_export] = ACTIONS(1635),
    [anon_sym_type] = ACTIONS(1635),
    [anon_sym_namespace] = ACTIONS(1637),
    [anon_sym_LBRACE] = ACTIONS(592),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1635),
    [anon_sym_with] = ACTIONS(598),
    [anon_sym_let] = ACTIONS(1635),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(606),
    [anon_sym_switch] = ACTIONS(608),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1635),
    [anon_sym_try] = ACTIONS(616),
    [anon_sym_SEMI] = ACTIONS(628),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(1639),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1641),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1635),
    [anon_sym_readonly] = ACTIONS(1635),
    [anon_sym_get] = ACTIONS(1635),
    [anon_sym_set] = ACTIONS(1635),
    [anon_sym_declare] = ACTIONS(1635),
    [anon_sym_public] = ACTIONS(1635),
    [anon_sym_private] = ACTIONS(1635),
    [anon_sym_protected] = ACTIONS(1635),
    [anon_sym_override] = ACTIONS(1635),
    [anon_sym_module] = ACTIONS(1635),
    [anon_sym_any] = ACTIONS(1635),
    [anon_sym_number] = ACTIONS(1635),
    [anon_sym_boolean] = ACTIONS(1635),
    [anon_sym_string] = ACTIONS(1635),
    [anon_sym_symbol] = ACTIONS(1635),
    [anon_sym_object] = ACTIONS(1635),
    [anon_sym_property] = ACTIONS(1635),
    [anon_sym_signal] = ACTIONS(1635),
    [anon_sym_on] = ACTIONS(1635),
    [anon_sym_required] = ACTIONS(1635),
    [anon_sym_component] = ACTIONS(1635),
    [sym_html_comment] = ACTIONS(5),
  },
  [182] = {
    [sym_import] = STATE(3590),
    [sym_expression_statement] = STATE(3074),
    [sym_statement_block] = STATE(3074),
    [sym_if_statement] = STATE(3074),
    [sym_switch_statement] = STATE(3074),
    [sym_try_statement] = STATE(3074),
    [sym_with_statement] = STATE(3074),
    [sym_empty_statement] = STATE(3074),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1978),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5533),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(182),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [sym_ui_object_definition] = STATE(3074),
    [sym_ui_object_array] = STATE(3074),
    [sym_ui_nested_identifier] = STATE(5505),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1643),
    [anon_sym_export] = ACTIONS(1645),
    [anon_sym_type] = ACTIONS(1645),
    [anon_sym_namespace] = ACTIONS(1647),
    [anon_sym_LBRACE] = ACTIONS(592),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1645),
    [anon_sym_with] = ACTIONS(598),
    [anon_sym_let] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(606),
    [anon_sym_switch] = ACTIONS(608),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1645),
    [anon_sym_try] = ACTIONS(616),
    [anon_sym_SEMI] = ACTIONS(628),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1651),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1645),
    [anon_sym_readonly] = ACTIONS(1645),
    [anon_sym_get] = ACTIONS(1645),
    [anon_sym_set] = ACTIONS(1645),
    [anon_sym_declare] = ACTIONS(1645),
    [anon_sym_public] = ACTIONS(1645),
    [anon_sym_private] = ACTIONS(1645),
    [anon_sym_protected] = ACTIONS(1645),
    [anon_sym_override] = ACTIONS(1645),
    [anon_sym_module] = ACTIONS(1645),
    [anon_sym_any] = ACTIONS(1645),
    [anon_sym_number] = ACTIONS(1645),
    [anon_sym_boolean] = ACTIONS(1645),
    [anon_sym_string] = ACTIONS(1645),
    [anon_sym_symbol] = ACTIONS(1645),
    [anon_sym_object] = ACTIONS(1645),
    [anon_sym_property] = ACTIONS(1645),
    [anon_sym_signal] = ACTIONS(1645),
    [anon_sym_on] = ACTIONS(1645),
    [anon_sym_required] = ACTIONS(1645),
    [anon_sym_component] = ACTIONS(1645),
    [sym_html_comment] = ACTIONS(5),
  },
  [183] = {
    [sym_import] = STATE(3590),
    [sym_expression_statement] = STATE(3030),
    [sym_statement_block] = STATE(3030),
    [sym_if_statement] = STATE(3030),
    [sym_switch_statement] = STATE(3030),
    [sym_try_statement] = STATE(3030),
    [sym_with_statement] = STATE(3030),
    [sym_empty_statement] = STATE(3030),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1978),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5533),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(183),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [sym_ui_object_definition] = STATE(5610),
    [sym_ui_object_array] = STATE(5610),
    [sym_ui_nested_identifier] = STATE(5203),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1633),
    [anon_sym_export] = ACTIONS(1635),
    [anon_sym_type] = ACTIONS(1635),
    [anon_sym_namespace] = ACTIONS(1637),
    [anon_sym_LBRACE] = ACTIONS(592),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1635),
    [anon_sym_with] = ACTIONS(598),
    [anon_sym_let] = ACTIONS(1635),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(606),
    [anon_sym_switch] = ACTIONS(608),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1635),
    [anon_sym_try] = ACTIONS(616),
    [anon_sym_SEMI] = ACTIONS(628),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(1639),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1641),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1635),
    [anon_sym_readonly] = ACTIONS(1635),
    [anon_sym_get] = ACTIONS(1635),
    [anon_sym_set] = ACTIONS(1635),
    [anon_sym_declare] = ACTIONS(1635),
    [anon_sym_public] = ACTIONS(1635),
    [anon_sym_private] = ACTIONS(1635),
    [anon_sym_protected] = ACTIONS(1635),
    [anon_sym_override] = ACTIONS(1635),
    [anon_sym_module] = ACTIONS(1635),
    [anon_sym_any] = ACTIONS(1635),
    [anon_sym_number] = ACTIONS(1635),
    [anon_sym_boolean] = ACTIONS(1635),
    [anon_sym_string] = ACTIONS(1635),
    [anon_sym_symbol] = ACTIONS(1635),
    [anon_sym_object] = ACTIONS(1635),
    [anon_sym_property] = ACTIONS(1635),
    [anon_sym_signal] = ACTIONS(1635),
    [anon_sym_on] = ACTIONS(1635),
    [anon_sym_required] = ACTIONS(1635),
    [anon_sym_component] = ACTIONS(1635),
    [sym_html_comment] = ACTIONS(5),
  },
  [184] = {
    [sym_import] = STATE(3590),
    [sym_expression_statement] = STATE(3075),
    [sym_statement_block] = STATE(3075),
    [sym_if_statement] = STATE(3075),
    [sym_switch_statement] = STATE(3075),
    [sym_try_statement] = STATE(3075),
    [sym_with_statement] = STATE(3075),
    [sym_empty_statement] = STATE(3075),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1978),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5533),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(184),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [sym_ui_object_definition] = STATE(5611),
    [sym_ui_object_array] = STATE(5611),
    [sym_ui_nested_identifier] = STATE(5203),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1633),
    [anon_sym_export] = ACTIONS(1635),
    [anon_sym_type] = ACTIONS(1635),
    [anon_sym_namespace] = ACTIONS(1637),
    [anon_sym_LBRACE] = ACTIONS(592),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1635),
    [anon_sym_with] = ACTIONS(598),
    [anon_sym_let] = ACTIONS(1635),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(606),
    [anon_sym_switch] = ACTIONS(608),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1635),
    [anon_sym_try] = ACTIONS(616),
    [anon_sym_SEMI] = ACTIONS(628),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(1639),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1641),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1635),
    [anon_sym_readonly] = ACTIONS(1635),
    [anon_sym_get] = ACTIONS(1635),
    [anon_sym_set] = ACTIONS(1635),
    [anon_sym_declare] = ACTIONS(1635),
    [anon_sym_public] = ACTIONS(1635),
    [anon_sym_private] = ACTIONS(1635),
    [anon_sym_protected] = ACTIONS(1635),
    [anon_sym_override] = ACTIONS(1635),
    [anon_sym_module] = ACTIONS(1635),
    [anon_sym_any] = ACTIONS(1635),
    [anon_sym_number] = ACTIONS(1635),
    [anon_sym_boolean] = ACTIONS(1635),
    [anon_sym_string] = ACTIONS(1635),
    [anon_sym_symbol] = ACTIONS(1635),
    [anon_sym_object] = ACTIONS(1635),
    [anon_sym_property] = ACTIONS(1635),
    [anon_sym_signal] = ACTIONS(1635),
    [anon_sym_on] = ACTIONS(1635),
    [anon_sym_required] = ACTIONS(1635),
    [anon_sym_component] = ACTIONS(1635),
    [sym_html_comment] = ACTIONS(5),
  },
  [185] = {
    [sym_import] = STATE(3590),
    [sym_expression_statement] = STATE(3069),
    [sym_statement_block] = STATE(3069),
    [sym_if_statement] = STATE(3069),
    [sym_switch_statement] = STATE(3069),
    [sym_try_statement] = STATE(3069),
    [sym_with_statement] = STATE(3069),
    [sym_empty_statement] = STATE(3069),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1978),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5533),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(185),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [sym_ui_object_definition] = STATE(5612),
    [sym_ui_object_array] = STATE(5612),
    [sym_ui_nested_identifier] = STATE(5203),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1633),
    [anon_sym_export] = ACTIONS(1635),
    [anon_sym_type] = ACTIONS(1635),
    [anon_sym_namespace] = ACTIONS(1637),
    [anon_sym_LBRACE] = ACTIONS(592),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1635),
    [anon_sym_with] = ACTIONS(598),
    [anon_sym_let] = ACTIONS(1635),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_if] = ACTIONS(606),
    [anon_sym_switch] = ACTIONS(608),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1635),
    [anon_sym_try] = ACTIONS(616),
    [anon_sym_SEMI] = ACTIONS(628),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(1639),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1641),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1635),
    [anon_sym_readonly] = ACTIONS(1635),
    [anon_sym_get] = ACTIONS(1635),
    [anon_sym_set] = ACTIONS(1635),
    [anon_sym_declare] = ACTIONS(1635),
    [anon_sym_public] = ACTIONS(1635),
    [anon_sym_private] = ACTIONS(1635),
    [anon_sym_protected] = ACTIONS(1635),
    [anon_sym_override] = ACTIONS(1635),
    [anon_sym_module] = ACTIONS(1635),
    [anon_sym_any] = ACTIONS(1635),
    [anon_sym_number] = ACTIONS(1635),
    [anon_sym_boolean] = ACTIONS(1635),
    [anon_sym_string] = ACTIONS(1635),
    [anon_sym_symbol] = ACTIONS(1635),
    [anon_sym_object] = ACTIONS(1635),
    [anon_sym_property] = ACTIONS(1635),
    [anon_sym_signal] = ACTIONS(1635),
    [anon_sym_on] = ACTIONS(1635),
    [anon_sym_required] = ACTIONS(1635),
    [anon_sym_component] = ACTIONS(1635),
    [sym_html_comment] = ACTIONS(5),
  },
  [186] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2150),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_assignment_pattern] = STATE(5110),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1373),
    [sym_subscript_expression] = STATE(1373),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3818),
    [sym_spread_element] = STATE(5355),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(186),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(4802),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1373),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [sym_ui_object_definition] = STATE(5353),
    [sym_ui_nested_identifier] = STATE(5505),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [aux_sym_array_repeat1] = STATE(5351),
    [aux_sym_array_pattern_repeat1] = STATE(5103),
    [sym_identifier] = ACTIONS(1653),
    [anon_sym_export] = ACTIONS(1655),
    [anon_sym_type] = ACTIONS(1655),
    [anon_sym_namespace] = ACTIONS(1657),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_COMMA] = ACTIONS(1661),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1655),
    [anon_sym_let] = ACTIONS(1655),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(1655),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_RBRACK] = ACTIONS(1665),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1667),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1669),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(219),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1671),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1655),
    [anon_sym_readonly] = ACTIONS(1655),
    [anon_sym_get] = ACTIONS(1655),
    [anon_sym_set] = ACTIONS(1655),
    [anon_sym_declare] = ACTIONS(1655),
    [anon_sym_public] = ACTIONS(1655),
    [anon_sym_private] = ACTIONS(1655),
    [anon_sym_protected] = ACTIONS(1655),
    [anon_sym_override] = ACTIONS(1655),
    [anon_sym_module] = ACTIONS(1655),
    [anon_sym_any] = ACTIONS(1655),
    [anon_sym_number] = ACTIONS(1655),
    [anon_sym_boolean] = ACTIONS(1655),
    [anon_sym_string] = ACTIONS(1655),
    [anon_sym_symbol] = ACTIONS(1655),
    [anon_sym_object] = ACTIONS(1655),
    [anon_sym_property] = ACTIONS(1655),
    [anon_sym_signal] = ACTIONS(1655),
    [anon_sym_on] = ACTIONS(1655),
    [anon_sym_required] = ACTIONS(1655),
    [anon_sym_component] = ACTIONS(1655),
    [sym_html_comment] = ACTIONS(5),
  },
  [187] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2150),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_assignment_pattern] = STATE(5110),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1373),
    [sym_subscript_expression] = STATE(1373),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3818),
    [sym_spread_element] = STATE(5355),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(187),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(4802),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1373),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [sym_ui_object_definition] = STATE(5019),
    [sym_ui_nested_identifier] = STATE(5505),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [aux_sym_array_repeat1] = STATE(5351),
    [aux_sym_array_pattern_repeat1] = STATE(5103),
    [sym_identifier] = ACTIONS(1653),
    [anon_sym_export] = ACTIONS(1655),
    [anon_sym_type] = ACTIONS(1655),
    [anon_sym_namespace] = ACTIONS(1657),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_COMMA] = ACTIONS(1661),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1655),
    [anon_sym_let] = ACTIONS(1655),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(1655),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_RBRACK] = ACTIONS(1665),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1667),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1669),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(219),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1671),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1655),
    [anon_sym_readonly] = ACTIONS(1655),
    [anon_sym_get] = ACTIONS(1655),
    [anon_sym_set] = ACTIONS(1655),
    [anon_sym_declare] = ACTIONS(1655),
    [anon_sym_public] = ACTIONS(1655),
    [anon_sym_private] = ACTIONS(1655),
    [anon_sym_protected] = ACTIONS(1655),
    [anon_sym_override] = ACTIONS(1655),
    [anon_sym_module] = ACTIONS(1655),
    [anon_sym_any] = ACTIONS(1655),
    [anon_sym_number] = ACTIONS(1655),
    [anon_sym_boolean] = ACTIONS(1655),
    [anon_sym_string] = ACTIONS(1655),
    [anon_sym_symbol] = ACTIONS(1655),
    [anon_sym_object] = ACTIONS(1655),
    [anon_sym_property] = ACTIONS(1655),
    [anon_sym_signal] = ACTIONS(1655),
    [anon_sym_on] = ACTIONS(1655),
    [anon_sym_required] = ACTIONS(1655),
    [anon_sym_component] = ACTIONS(1655),
    [sym_html_comment] = ACTIONS(5),
  },
  [188] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1782),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym__formal_parameter] = STATE(5358),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1373),
    [sym_subscript_expression] = STATE(1373),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3818),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_sequence_expression] = STATE(5976),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(188),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(4280),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1373),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_accessibility_modifier] = STATE(289),
    [sym_override_modifier] = STATE(310),
    [sym_required_parameter] = STATE(5545),
    [sym_optional_parameter] = STATE(5545),
    [sym__parameter_name] = STATE(3943),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(257),
    [sym_identifier] = ACTIONS(1673),
    [anon_sym_export] = ACTIONS(684),
    [anon_sym_type] = ACTIONS(684),
    [anon_sym_namespace] = ACTIONS(688),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(684),
    [anon_sym_let] = ACTIONS(684),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_RPAREN] = ACTIONS(885),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(684),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(706),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1669),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(1675),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1671),
    [anon_sym_AT] = ACTIONS(901),
    [anon_sym_static] = ACTIONS(684),
    [anon_sym_readonly] = ACTIONS(1677),
    [anon_sym_get] = ACTIONS(684),
    [anon_sym_set] = ACTIONS(684),
    [anon_sym_declare] = ACTIONS(684),
    [anon_sym_public] = ACTIONS(905),
    [anon_sym_private] = ACTIONS(905),
    [anon_sym_protected] = ACTIONS(905),
    [anon_sym_override] = ACTIONS(907),
    [anon_sym_module] = ACTIONS(684),
    [anon_sym_any] = ACTIONS(684),
    [anon_sym_number] = ACTIONS(684),
    [anon_sym_boolean] = ACTIONS(684),
    [anon_sym_string] = ACTIONS(684),
    [anon_sym_symbol] = ACTIONS(684),
    [anon_sym_object] = ACTIONS(684),
    [anon_sym_property] = ACTIONS(684),
    [anon_sym_signal] = ACTIONS(684),
    [anon_sym_on] = ACTIONS(684),
    [anon_sym_required] = ACTIONS(684),
    [anon_sym_component] = ACTIONS(684),
    [sym_html_comment] = ACTIONS(5),
  },
  [189] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1748),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym__formal_parameter] = STATE(5358),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1373),
    [sym_subscript_expression] = STATE(1373),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3818),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_sequence_expression] = STATE(6278),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(189),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(4280),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1373),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_accessibility_modifier] = STATE(289),
    [sym_override_modifier] = STATE(310),
    [sym_required_parameter] = STATE(5545),
    [sym_optional_parameter] = STATE(5545),
    [sym__parameter_name] = STATE(3943),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(257),
    [sym_identifier] = ACTIONS(1673),
    [anon_sym_export] = ACTIONS(684),
    [anon_sym_type] = ACTIONS(684),
    [anon_sym_namespace] = ACTIONS(688),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(684),
    [anon_sym_let] = ACTIONS(684),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_RPAREN] = ACTIONS(885),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(684),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(706),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1669),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(1675),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1671),
    [anon_sym_AT] = ACTIONS(901),
    [anon_sym_static] = ACTIONS(684),
    [anon_sym_readonly] = ACTIONS(1677),
    [anon_sym_get] = ACTIONS(684),
    [anon_sym_set] = ACTIONS(684),
    [anon_sym_declare] = ACTIONS(684),
    [anon_sym_public] = ACTIONS(905),
    [anon_sym_private] = ACTIONS(905),
    [anon_sym_protected] = ACTIONS(905),
    [anon_sym_override] = ACTIONS(907),
    [anon_sym_module] = ACTIONS(684),
    [anon_sym_any] = ACTIONS(684),
    [anon_sym_number] = ACTIONS(684),
    [anon_sym_boolean] = ACTIONS(684),
    [anon_sym_string] = ACTIONS(684),
    [anon_sym_symbol] = ACTIONS(684),
    [anon_sym_object] = ACTIONS(684),
    [anon_sym_property] = ACTIONS(684),
    [anon_sym_signal] = ACTIONS(684),
    [anon_sym_on] = ACTIONS(684),
    [anon_sym_required] = ACTIONS(684),
    [anon_sym_component] = ACTIONS(684),
    [sym_html_comment] = ACTIONS(5),
  },
  [190] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym__formal_parameter] = STATE(5644),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3951),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(190),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(4280),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_accessibility_modifier] = STATE(289),
    [sym_override_modifier] = STATE(310),
    [sym_required_parameter] = STATE(5545),
    [sym_optional_parameter] = STATE(5545),
    [sym__parameter_name] = STATE(3943),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(257),
    [sym_identifier] = ACTIONS(799),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_namespace] = ACTIONS(32),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_RPAREN] = ACTIONS(1679),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(23),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(64),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(809),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(1681),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(821),
    [anon_sym_AT] = ACTIONS(901),
    [anon_sym_static] = ACTIONS(23),
    [anon_sym_readonly] = ACTIONS(1683),
    [anon_sym_get] = ACTIONS(23),
    [anon_sym_set] = ACTIONS(23),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_public] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(919),
    [anon_sym_protected] = ACTIONS(919),
    [anon_sym_override] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(23),
    [anon_sym_number] = ACTIONS(23),
    [anon_sym_boolean] = ACTIONS(23),
    [anon_sym_string] = ACTIONS(23),
    [anon_sym_symbol] = ACTIONS(23),
    [anon_sym_object] = ACTIONS(23),
    [anon_sym_property] = ACTIONS(23),
    [anon_sym_signal] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [anon_sym_required] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(23),
    [sym_html_comment] = ACTIONS(5),
  },
  [191] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym__formal_parameter] = STATE(5644),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3951),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(191),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(4280),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_accessibility_modifier] = STATE(289),
    [sym_override_modifier] = STATE(310),
    [sym_required_parameter] = STATE(5545),
    [sym_optional_parameter] = STATE(5545),
    [sym__parameter_name] = STATE(3943),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(257),
    [sym_identifier] = ACTIONS(799),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_namespace] = ACTIONS(32),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_RPAREN] = ACTIONS(1685),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(23),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(64),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(809),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(1681),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(821),
    [anon_sym_AT] = ACTIONS(901),
    [anon_sym_static] = ACTIONS(23),
    [anon_sym_readonly] = ACTIONS(1683),
    [anon_sym_get] = ACTIONS(23),
    [anon_sym_set] = ACTIONS(23),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_public] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(919),
    [anon_sym_protected] = ACTIONS(919),
    [anon_sym_override] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(23),
    [anon_sym_number] = ACTIONS(23),
    [anon_sym_boolean] = ACTIONS(23),
    [anon_sym_string] = ACTIONS(23),
    [anon_sym_symbol] = ACTIONS(23),
    [anon_sym_object] = ACTIONS(23),
    [anon_sym_property] = ACTIONS(23),
    [anon_sym_signal] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [anon_sym_required] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(23),
    [sym_html_comment] = ACTIONS(5),
  },
  [192] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym__formal_parameter] = STATE(5644),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3951),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(192),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(4280),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_accessibility_modifier] = STATE(289),
    [sym_override_modifier] = STATE(310),
    [sym_required_parameter] = STATE(5545),
    [sym_optional_parameter] = STATE(5545),
    [sym__parameter_name] = STATE(3943),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(257),
    [sym_identifier] = ACTIONS(799),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_namespace] = ACTIONS(32),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_RPAREN] = ACTIONS(1687),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(23),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(64),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(809),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(1681),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(821),
    [anon_sym_AT] = ACTIONS(901),
    [anon_sym_static] = ACTIONS(23),
    [anon_sym_readonly] = ACTIONS(1683),
    [anon_sym_get] = ACTIONS(23),
    [anon_sym_set] = ACTIONS(23),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_public] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(919),
    [anon_sym_protected] = ACTIONS(919),
    [anon_sym_override] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(23),
    [anon_sym_number] = ACTIONS(23),
    [anon_sym_boolean] = ACTIONS(23),
    [anon_sym_string] = ACTIONS(23),
    [anon_sym_symbol] = ACTIONS(23),
    [anon_sym_object] = ACTIONS(23),
    [anon_sym_property] = ACTIONS(23),
    [anon_sym_signal] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [anon_sym_required] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(23),
    [sym_html_comment] = ACTIONS(5),
  },
  [193] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym__formal_parameter] = STATE(5644),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3951),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(193),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(4280),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_accessibility_modifier] = STATE(289),
    [sym_override_modifier] = STATE(310),
    [sym_required_parameter] = STATE(5545),
    [sym_optional_parameter] = STATE(5545),
    [sym__parameter_name] = STATE(3943),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(257),
    [sym_identifier] = ACTIONS(799),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_namespace] = ACTIONS(32),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_RPAREN] = ACTIONS(1689),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(23),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(64),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(809),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(1681),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(821),
    [anon_sym_AT] = ACTIONS(901),
    [anon_sym_static] = ACTIONS(23),
    [anon_sym_readonly] = ACTIONS(1683),
    [anon_sym_get] = ACTIONS(23),
    [anon_sym_set] = ACTIONS(23),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_public] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(919),
    [anon_sym_protected] = ACTIONS(919),
    [anon_sym_override] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(23),
    [anon_sym_number] = ACTIONS(23),
    [anon_sym_boolean] = ACTIONS(23),
    [anon_sym_string] = ACTIONS(23),
    [anon_sym_symbol] = ACTIONS(23),
    [anon_sym_object] = ACTIONS(23),
    [anon_sym_property] = ACTIONS(23),
    [anon_sym_signal] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [anon_sym_required] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(23),
    [sym_html_comment] = ACTIONS(5),
  },
  [194] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym__formal_parameter] = STATE(4955),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3951),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(194),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(4280),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_accessibility_modifier] = STATE(289),
    [sym_override_modifier] = STATE(310),
    [sym_required_parameter] = STATE(5545),
    [sym_optional_parameter] = STATE(5545),
    [sym__parameter_name] = STATE(3943),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(257),
    [sym_identifier] = ACTIONS(799),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_namespace] = ACTIONS(32),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_RPAREN] = ACTIONS(1691),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(23),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(64),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(809),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(1681),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(821),
    [anon_sym_AT] = ACTIONS(901),
    [anon_sym_static] = ACTIONS(23),
    [anon_sym_readonly] = ACTIONS(1683),
    [anon_sym_get] = ACTIONS(23),
    [anon_sym_set] = ACTIONS(23),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_public] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(919),
    [anon_sym_protected] = ACTIONS(919),
    [anon_sym_override] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(23),
    [anon_sym_number] = ACTIONS(23),
    [anon_sym_boolean] = ACTIONS(23),
    [anon_sym_string] = ACTIONS(23),
    [anon_sym_symbol] = ACTIONS(23),
    [anon_sym_object] = ACTIONS(23),
    [anon_sym_property] = ACTIONS(23),
    [anon_sym_signal] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [anon_sym_required] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(23),
    [sym_html_comment] = ACTIONS(5),
  },
  [195] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym__formal_parameter] = STATE(5644),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3951),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(195),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(4280),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_accessibility_modifier] = STATE(289),
    [sym_override_modifier] = STATE(310),
    [sym_required_parameter] = STATE(5545),
    [sym_optional_parameter] = STATE(5545),
    [sym__parameter_name] = STATE(3943),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(257),
    [sym_identifier] = ACTIONS(799),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_namespace] = ACTIONS(32),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_RPAREN] = ACTIONS(1693),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(23),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(64),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(809),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(1681),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(821),
    [anon_sym_AT] = ACTIONS(901),
    [anon_sym_static] = ACTIONS(23),
    [anon_sym_readonly] = ACTIONS(1683),
    [anon_sym_get] = ACTIONS(23),
    [anon_sym_set] = ACTIONS(23),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_public] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(919),
    [anon_sym_protected] = ACTIONS(919),
    [anon_sym_override] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(23),
    [anon_sym_number] = ACTIONS(23),
    [anon_sym_boolean] = ACTIONS(23),
    [anon_sym_string] = ACTIONS(23),
    [anon_sym_symbol] = ACTIONS(23),
    [anon_sym_object] = ACTIONS(23),
    [anon_sym_property] = ACTIONS(23),
    [anon_sym_signal] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [anon_sym_required] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(23),
    [sym_html_comment] = ACTIONS(5),
  },
  [196] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym__formal_parameter] = STATE(5038),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3951),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(196),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(4280),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_accessibility_modifier] = STATE(289),
    [sym_override_modifier] = STATE(310),
    [sym_required_parameter] = STATE(5545),
    [sym_optional_parameter] = STATE(5545),
    [sym__parameter_name] = STATE(3943),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(257),
    [sym_identifier] = ACTIONS(799),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_namespace] = ACTIONS(32),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_RPAREN] = ACTIONS(1695),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(23),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(64),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(809),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(1681),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(821),
    [anon_sym_AT] = ACTIONS(901),
    [anon_sym_static] = ACTIONS(23),
    [anon_sym_readonly] = ACTIONS(1683),
    [anon_sym_get] = ACTIONS(23),
    [anon_sym_set] = ACTIONS(23),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_public] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(919),
    [anon_sym_protected] = ACTIONS(919),
    [anon_sym_override] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(23),
    [anon_sym_number] = ACTIONS(23),
    [anon_sym_boolean] = ACTIONS(23),
    [anon_sym_string] = ACTIONS(23),
    [anon_sym_symbol] = ACTIONS(23),
    [anon_sym_object] = ACTIONS(23),
    [anon_sym_property] = ACTIONS(23),
    [anon_sym_signal] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [anon_sym_required] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(23),
    [sym_html_comment] = ACTIONS(5),
  },
  [197] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym__formal_parameter] = STATE(5358),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3951),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(197),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(4280),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_accessibility_modifier] = STATE(289),
    [sym_override_modifier] = STATE(310),
    [sym_required_parameter] = STATE(5545),
    [sym_optional_parameter] = STATE(5545),
    [sym__parameter_name] = STATE(3943),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(257),
    [sym_identifier] = ACTIONS(799),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_namespace] = ACTIONS(32),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_RPAREN] = ACTIONS(885),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(23),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(64),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(809),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(1681),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(821),
    [anon_sym_AT] = ACTIONS(901),
    [anon_sym_static] = ACTIONS(23),
    [anon_sym_readonly] = ACTIONS(1683),
    [anon_sym_get] = ACTIONS(23),
    [anon_sym_set] = ACTIONS(23),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_public] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(919),
    [anon_sym_protected] = ACTIONS(919),
    [anon_sym_override] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(23),
    [anon_sym_number] = ACTIONS(23),
    [anon_sym_boolean] = ACTIONS(23),
    [anon_sym_string] = ACTIONS(23),
    [anon_sym_symbol] = ACTIONS(23),
    [anon_sym_object] = ACTIONS(23),
    [anon_sym_property] = ACTIONS(23),
    [anon_sym_signal] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [anon_sym_required] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(23),
    [sym_html_comment] = ACTIONS(5),
  },
  [198] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym__formal_parameter] = STATE(5644),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3951),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(198),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(4280),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_accessibility_modifier] = STATE(289),
    [sym_override_modifier] = STATE(310),
    [sym_required_parameter] = STATE(5545),
    [sym_optional_parameter] = STATE(5545),
    [sym__parameter_name] = STATE(3943),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(257),
    [sym_identifier] = ACTIONS(799),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_namespace] = ACTIONS(32),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_RPAREN] = ACTIONS(1697),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(23),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(64),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(809),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(1681),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(821),
    [anon_sym_AT] = ACTIONS(901),
    [anon_sym_static] = ACTIONS(23),
    [anon_sym_readonly] = ACTIONS(1683),
    [anon_sym_get] = ACTIONS(23),
    [anon_sym_set] = ACTIONS(23),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_public] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(919),
    [anon_sym_protected] = ACTIONS(919),
    [anon_sym_override] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(23),
    [anon_sym_number] = ACTIONS(23),
    [anon_sym_boolean] = ACTIONS(23),
    [anon_sym_string] = ACTIONS(23),
    [anon_sym_symbol] = ACTIONS(23),
    [anon_sym_object] = ACTIONS(23),
    [anon_sym_property] = ACTIONS(23),
    [anon_sym_signal] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [anon_sym_required] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(23),
    [sym_html_comment] = ACTIONS(5),
  },
  [199] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2129),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_assignment_pattern] = STATE(5110),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1373),
    [sym_subscript_expression] = STATE(1373),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3818),
    [sym_spread_element] = STATE(5024),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(199),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(4802),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1373),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [aux_sym_array_repeat1] = STATE(5018),
    [aux_sym_array_pattern_repeat1] = STATE(5103),
    [sym_identifier] = ACTIONS(1673),
    [anon_sym_export] = ACTIONS(684),
    [anon_sym_type] = ACTIONS(684),
    [anon_sym_namespace] = ACTIONS(688),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_COMMA] = ACTIONS(1661),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(684),
    [anon_sym_let] = ACTIONS(684),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(684),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_RBRACK] = ACTIONS(1699),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(706),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1669),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(219),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1671),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(684),
    [anon_sym_readonly] = ACTIONS(684),
    [anon_sym_get] = ACTIONS(684),
    [anon_sym_set] = ACTIONS(684),
    [anon_sym_declare] = ACTIONS(684),
    [anon_sym_public] = ACTIONS(684),
    [anon_sym_private] = ACTIONS(684),
    [anon_sym_protected] = ACTIONS(684),
    [anon_sym_override] = ACTIONS(684),
    [anon_sym_module] = ACTIONS(684),
    [anon_sym_any] = ACTIONS(684),
    [anon_sym_number] = ACTIONS(684),
    [anon_sym_boolean] = ACTIONS(684),
    [anon_sym_string] = ACTIONS(684),
    [anon_sym_symbol] = ACTIONS(684),
    [anon_sym_object] = ACTIONS(684),
    [anon_sym_property] = ACTIONS(684),
    [anon_sym_signal] = ACTIONS(684),
    [anon_sym_on] = ACTIONS(684),
    [anon_sym_required] = ACTIONS(684),
    [anon_sym_component] = ACTIONS(684),
    [sym_html_comment] = ACTIONS(5),
  },
  [200] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2112),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_assignment_pattern] = STATE(5110),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1373),
    [sym_subscript_expression] = STATE(1373),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3818),
    [sym_spread_element] = STATE(5355),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(200),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(4802),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1373),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [aux_sym_array_repeat1] = STATE(5351),
    [aux_sym_array_pattern_repeat1] = STATE(5103),
    [sym_identifier] = ACTIONS(1673),
    [anon_sym_export] = ACTIONS(684),
    [anon_sym_type] = ACTIONS(684),
    [anon_sym_namespace] = ACTIONS(688),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_COMMA] = ACTIONS(1661),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(684),
    [anon_sym_let] = ACTIONS(684),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(684),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_RBRACK] = ACTIONS(1665),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(706),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1669),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(219),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1671),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(684),
    [anon_sym_readonly] = ACTIONS(684),
    [anon_sym_get] = ACTIONS(684),
    [anon_sym_set] = ACTIONS(684),
    [anon_sym_declare] = ACTIONS(684),
    [anon_sym_public] = ACTIONS(684),
    [anon_sym_private] = ACTIONS(684),
    [anon_sym_protected] = ACTIONS(684),
    [anon_sym_override] = ACTIONS(684),
    [anon_sym_module] = ACTIONS(684),
    [anon_sym_any] = ACTIONS(684),
    [anon_sym_number] = ACTIONS(684),
    [anon_sym_boolean] = ACTIONS(684),
    [anon_sym_string] = ACTIONS(684),
    [anon_sym_symbol] = ACTIONS(684),
    [anon_sym_object] = ACTIONS(684),
    [anon_sym_property] = ACTIONS(684),
    [anon_sym_signal] = ACTIONS(684),
    [anon_sym_on] = ACTIONS(684),
    [anon_sym_required] = ACTIONS(684),
    [anon_sym_component] = ACTIONS(684),
    [sym_html_comment] = ACTIONS(5),
  },
  [201] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2129),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_assignment_pattern] = STATE(5110),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1373),
    [sym_subscript_expression] = STATE(1373),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3818),
    [sym_spread_element] = STATE(5024),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(201),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(4802),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1373),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [aux_sym_array_repeat1] = STATE(5018),
    [aux_sym_array_pattern_repeat1] = STATE(5103),
    [sym_identifier] = ACTIONS(1673),
    [anon_sym_export] = ACTIONS(684),
    [anon_sym_type] = ACTIONS(684),
    [anon_sym_namespace] = ACTIONS(688),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_COMMA] = ACTIONS(1661),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(684),
    [anon_sym_let] = ACTIONS(684),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(684),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_RBRACK] = ACTIONS(1701),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(706),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1669),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(219),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1671),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(684),
    [anon_sym_readonly] = ACTIONS(684),
    [anon_sym_get] = ACTIONS(684),
    [anon_sym_set] = ACTIONS(684),
    [anon_sym_declare] = ACTIONS(684),
    [anon_sym_public] = ACTIONS(684),
    [anon_sym_private] = ACTIONS(684),
    [anon_sym_protected] = ACTIONS(684),
    [anon_sym_override] = ACTIONS(684),
    [anon_sym_module] = ACTIONS(684),
    [anon_sym_any] = ACTIONS(684),
    [anon_sym_number] = ACTIONS(684),
    [anon_sym_boolean] = ACTIONS(684),
    [anon_sym_string] = ACTIONS(684),
    [anon_sym_symbol] = ACTIONS(684),
    [anon_sym_object] = ACTIONS(684),
    [anon_sym_property] = ACTIONS(684),
    [anon_sym_signal] = ACTIONS(684),
    [anon_sym_on] = ACTIONS(684),
    [anon_sym_required] = ACTIONS(684),
    [anon_sym_component] = ACTIONS(684),
    [sym_html_comment] = ACTIONS(5),
  },
  [202] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2129),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_assignment_pattern] = STATE(5110),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1373),
    [sym_subscript_expression] = STATE(1373),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3818),
    [sym_spread_element] = STATE(5024),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(202),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(4802),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1373),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [aux_sym_array_repeat1] = STATE(5018),
    [aux_sym_array_pattern_repeat1] = STATE(5103),
    [sym_identifier] = ACTIONS(1673),
    [anon_sym_export] = ACTIONS(684),
    [anon_sym_type] = ACTIONS(684),
    [anon_sym_namespace] = ACTIONS(688),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_COMMA] = ACTIONS(1661),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(684),
    [anon_sym_let] = ACTIONS(684),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(684),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_RBRACK] = ACTIONS(1703),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(706),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1669),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(219),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1671),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(684),
    [anon_sym_readonly] = ACTIONS(684),
    [anon_sym_get] = ACTIONS(684),
    [anon_sym_set] = ACTIONS(684),
    [anon_sym_declare] = ACTIONS(684),
    [anon_sym_public] = ACTIONS(684),
    [anon_sym_private] = ACTIONS(684),
    [anon_sym_protected] = ACTIONS(684),
    [anon_sym_override] = ACTIONS(684),
    [anon_sym_module] = ACTIONS(684),
    [anon_sym_any] = ACTIONS(684),
    [anon_sym_number] = ACTIONS(684),
    [anon_sym_boolean] = ACTIONS(684),
    [anon_sym_string] = ACTIONS(684),
    [anon_sym_symbol] = ACTIONS(684),
    [anon_sym_object] = ACTIONS(684),
    [anon_sym_property] = ACTIONS(684),
    [anon_sym_signal] = ACTIONS(684),
    [anon_sym_on] = ACTIONS(684),
    [anon_sym_required] = ACTIONS(684),
    [anon_sym_component] = ACTIONS(684),
    [sym_html_comment] = ACTIONS(5),
  },
  [203] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2129),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_assignment_pattern] = STATE(5110),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1373),
    [sym_subscript_expression] = STATE(1373),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3818),
    [sym_spread_element] = STATE(5024),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(203),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(4802),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1373),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [aux_sym_array_repeat1] = STATE(5018),
    [aux_sym_array_pattern_repeat1] = STATE(5103),
    [sym_identifier] = ACTIONS(1673),
    [anon_sym_export] = ACTIONS(684),
    [anon_sym_type] = ACTIONS(684),
    [anon_sym_namespace] = ACTIONS(688),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_COMMA] = ACTIONS(1661),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(684),
    [anon_sym_let] = ACTIONS(684),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(684),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_RBRACK] = ACTIONS(1705),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(706),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1669),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(219),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1671),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(684),
    [anon_sym_readonly] = ACTIONS(684),
    [anon_sym_get] = ACTIONS(684),
    [anon_sym_set] = ACTIONS(684),
    [anon_sym_declare] = ACTIONS(684),
    [anon_sym_public] = ACTIONS(684),
    [anon_sym_private] = ACTIONS(684),
    [anon_sym_protected] = ACTIONS(684),
    [anon_sym_override] = ACTIONS(684),
    [anon_sym_module] = ACTIONS(684),
    [anon_sym_any] = ACTIONS(684),
    [anon_sym_number] = ACTIONS(684),
    [anon_sym_boolean] = ACTIONS(684),
    [anon_sym_string] = ACTIONS(684),
    [anon_sym_symbol] = ACTIONS(684),
    [anon_sym_object] = ACTIONS(684),
    [anon_sym_property] = ACTIONS(684),
    [anon_sym_signal] = ACTIONS(684),
    [anon_sym_on] = ACTIONS(684),
    [anon_sym_required] = ACTIONS(684),
    [anon_sym_component] = ACTIONS(684),
    [sym_html_comment] = ACTIONS(5),
  },
  [204] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2150),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_assignment_pattern] = STATE(5110),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1373),
    [sym_subscript_expression] = STATE(1373),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3818),
    [sym_spread_element] = STATE(5355),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(204),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(4802),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1373),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [aux_sym_array_repeat1] = STATE(5351),
    [aux_sym_array_pattern_repeat1] = STATE(5103),
    [sym_identifier] = ACTIONS(1673),
    [anon_sym_export] = ACTIONS(684),
    [anon_sym_type] = ACTIONS(684),
    [anon_sym_namespace] = ACTIONS(688),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_COMMA] = ACTIONS(1661),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(684),
    [anon_sym_let] = ACTIONS(684),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(684),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_RBRACK] = ACTIONS(1665),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(706),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1669),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(219),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1671),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(684),
    [anon_sym_readonly] = ACTIONS(684),
    [anon_sym_get] = ACTIONS(684),
    [anon_sym_set] = ACTIONS(684),
    [anon_sym_declare] = ACTIONS(684),
    [anon_sym_public] = ACTIONS(684),
    [anon_sym_private] = ACTIONS(684),
    [anon_sym_protected] = ACTIONS(684),
    [anon_sym_override] = ACTIONS(684),
    [anon_sym_module] = ACTIONS(684),
    [anon_sym_any] = ACTIONS(684),
    [anon_sym_number] = ACTIONS(684),
    [anon_sym_boolean] = ACTIONS(684),
    [anon_sym_string] = ACTIONS(684),
    [anon_sym_symbol] = ACTIONS(684),
    [anon_sym_object] = ACTIONS(684),
    [anon_sym_property] = ACTIONS(684),
    [anon_sym_signal] = ACTIONS(684),
    [anon_sym_on] = ACTIONS(684),
    [anon_sym_required] = ACTIONS(684),
    [anon_sym_component] = ACTIONS(684),
    [sym_html_comment] = ACTIONS(5),
  },
  [205] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2129),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_assignment_pattern] = STATE(5110),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1373),
    [sym_subscript_expression] = STATE(1373),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3818),
    [sym_spread_element] = STATE(5024),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(205),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(4802),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1373),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [aux_sym_array_repeat1] = STATE(5018),
    [aux_sym_array_pattern_repeat1] = STATE(5103),
    [sym_identifier] = ACTIONS(1673),
    [anon_sym_export] = ACTIONS(684),
    [anon_sym_type] = ACTIONS(684),
    [anon_sym_namespace] = ACTIONS(688),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_COMMA] = ACTIONS(1661),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(684),
    [anon_sym_let] = ACTIONS(684),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(684),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_RBRACK] = ACTIONS(1707),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(706),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1669),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(219),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1671),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(684),
    [anon_sym_readonly] = ACTIONS(684),
    [anon_sym_get] = ACTIONS(684),
    [anon_sym_set] = ACTIONS(684),
    [anon_sym_declare] = ACTIONS(684),
    [anon_sym_public] = ACTIONS(684),
    [anon_sym_private] = ACTIONS(684),
    [anon_sym_protected] = ACTIONS(684),
    [anon_sym_override] = ACTIONS(684),
    [anon_sym_module] = ACTIONS(684),
    [anon_sym_any] = ACTIONS(684),
    [anon_sym_number] = ACTIONS(684),
    [anon_sym_boolean] = ACTIONS(684),
    [anon_sym_string] = ACTIONS(684),
    [anon_sym_symbol] = ACTIONS(684),
    [anon_sym_object] = ACTIONS(684),
    [anon_sym_property] = ACTIONS(684),
    [anon_sym_signal] = ACTIONS(684),
    [anon_sym_on] = ACTIONS(684),
    [anon_sym_required] = ACTIONS(684),
    [anon_sym_component] = ACTIONS(684),
    [sym_html_comment] = ACTIONS(5),
  },
  [206] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1791),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(206),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(1709),
    [anon_sym_RBRACE] = ACTIONS(1709),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_RPAREN] = ACTIONS(1709),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(1709),
    [anon_sym_RBRACK] = ACTIONS(1709),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(1709),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_AMP] = ACTIONS(1709),
    [anon_sym_PIPE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_QMARK] = ACTIONS(1709),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [anon_sym_extends] = ACTIONS(1711),
    [sym_html_comment] = ACTIONS(5),
  },
  [207] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym__formal_parameter] = STATE(5644),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3951),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(207),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(4280),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_accessibility_modifier] = STATE(289),
    [sym_override_modifier] = STATE(310),
    [sym_required_parameter] = STATE(5545),
    [sym_optional_parameter] = STATE(5545),
    [sym__parameter_name] = STATE(3943),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(257),
    [sym_identifier] = ACTIONS(799),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_namespace] = ACTIONS(32),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(23),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(64),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(809),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(1681),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(821),
    [anon_sym_AT] = ACTIONS(901),
    [anon_sym_static] = ACTIONS(23),
    [anon_sym_readonly] = ACTIONS(1683),
    [anon_sym_get] = ACTIONS(23),
    [anon_sym_set] = ACTIONS(23),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_public] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(919),
    [anon_sym_protected] = ACTIONS(919),
    [anon_sym_override] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(23),
    [anon_sym_number] = ACTIONS(23),
    [anon_sym_boolean] = ACTIONS(23),
    [anon_sym_string] = ACTIONS(23),
    [anon_sym_symbol] = ACTIONS(23),
    [anon_sym_object] = ACTIONS(23),
    [anon_sym_property] = ACTIONS(23),
    [anon_sym_signal] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [anon_sym_required] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(23),
    [sym_html_comment] = ACTIONS(5),
  },
  [208] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2150),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_assignment_pattern] = STATE(5110),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1373),
    [sym_subscript_expression] = STATE(1373),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3818),
    [sym_spread_element] = STATE(5355),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(208),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(4802),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1373),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [aux_sym_array_repeat1] = STATE(5351),
    [aux_sym_array_pattern_repeat1] = STATE(5103),
    [sym_identifier] = ACTIONS(1673),
    [anon_sym_export] = ACTIONS(684),
    [anon_sym_type] = ACTIONS(684),
    [anon_sym_namespace] = ACTIONS(688),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_COMMA] = ACTIONS(1661),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(684),
    [anon_sym_let] = ACTIONS(684),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(684),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_RBRACK] = ACTIONS(1713),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(706),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1669),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(219),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1671),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(684),
    [anon_sym_readonly] = ACTIONS(684),
    [anon_sym_get] = ACTIONS(684),
    [anon_sym_set] = ACTIONS(684),
    [anon_sym_declare] = ACTIONS(684),
    [anon_sym_public] = ACTIONS(684),
    [anon_sym_private] = ACTIONS(684),
    [anon_sym_protected] = ACTIONS(684),
    [anon_sym_override] = ACTIONS(684),
    [anon_sym_module] = ACTIONS(684),
    [anon_sym_any] = ACTIONS(684),
    [anon_sym_number] = ACTIONS(684),
    [anon_sym_boolean] = ACTIONS(684),
    [anon_sym_string] = ACTIONS(684),
    [anon_sym_symbol] = ACTIONS(684),
    [anon_sym_object] = ACTIONS(684),
    [anon_sym_property] = ACTIONS(684),
    [anon_sym_signal] = ACTIONS(684),
    [anon_sym_on] = ACTIONS(684),
    [anon_sym_required] = ACTIONS(684),
    [anon_sym_component] = ACTIONS(684),
    [sym_html_comment] = ACTIONS(5),
  },
  [209] = {
    [sym_import] = STATE(3590),
    [sym_expression_statement] = STATE(292),
    [sym_variable_declaration] = STATE(292),
    [sym_lexical_declaration] = STATE(292),
    [sym_empty_statement] = STATE(292),
    [sym_parenthesized_expression] = STATE(1438),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1438),
    [sym_subscript_expression] = STATE(1438),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(5078),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5868),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(209),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1438),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1715),
    [anon_sym_export] = ACTIONS(1717),
    [anon_sym_type] = ACTIONS(1717),
    [anon_sym_namespace] = ACTIONS(1719),
    [anon_sym_LBRACE] = ACTIONS(1721),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1717),
    [anon_sym_var] = ACTIONS(1723),
    [anon_sym_let] = ACTIONS(1725),
    [anon_sym_const] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1717),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(1729),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1731),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1733),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1735),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1717),
    [anon_sym_readonly] = ACTIONS(1717),
    [anon_sym_get] = ACTIONS(1717),
    [anon_sym_set] = ACTIONS(1717),
    [anon_sym_declare] = ACTIONS(1717),
    [anon_sym_public] = ACTIONS(1717),
    [anon_sym_private] = ACTIONS(1717),
    [anon_sym_protected] = ACTIONS(1717),
    [anon_sym_override] = ACTIONS(1717),
    [anon_sym_module] = ACTIONS(1717),
    [anon_sym_any] = ACTIONS(1717),
    [anon_sym_number] = ACTIONS(1717),
    [anon_sym_boolean] = ACTIONS(1717),
    [anon_sym_string] = ACTIONS(1717),
    [anon_sym_symbol] = ACTIONS(1717),
    [anon_sym_object] = ACTIONS(1717),
    [anon_sym_property] = ACTIONS(1717),
    [anon_sym_signal] = ACTIONS(1717),
    [anon_sym_on] = ACTIONS(1717),
    [anon_sym_required] = ACTIONS(1717),
    [anon_sym_component] = ACTIONS(1717),
    [sym_html_comment] = ACTIONS(5),
  },
  [210] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1520),
    [sym_expression] = STATE(2432),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_assignment_pattern] = STATE(5110),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1489),
    [sym_subscript_expression] = STATE(1489),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5207),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(210),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(4802),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1489),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_mapped_type_clause] = STATE(6120),
    [sym_type_arguments] = STATE(556),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [aux_sym_array_pattern_repeat1] = STATE(5103),
    [sym_identifier] = ACTIONS(1737),
    [anon_sym_export] = ACTIONS(1739),
    [anon_sym_type] = ACTIONS(1739),
    [anon_sym_namespace] = ACTIONS(1741),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_COMMA] = ACTIONS(1743),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1739),
    [anon_sym_let] = ACTIONS(1739),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_of] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_RBRACK] = ACTIONS(1745),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1747),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1749),
    [anon_sym_using] = ACTIONS(1247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1257),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1751),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1739),
    [anon_sym_readonly] = ACTIONS(1739),
    [anon_sym_get] = ACTIONS(1739),
    [anon_sym_set] = ACTIONS(1739),
    [anon_sym_declare] = ACTIONS(1739),
    [anon_sym_public] = ACTIONS(1739),
    [anon_sym_private] = ACTIONS(1739),
    [anon_sym_protected] = ACTIONS(1739),
    [anon_sym_override] = ACTIONS(1739),
    [anon_sym_module] = ACTIONS(1739),
    [anon_sym_any] = ACTIONS(1739),
    [anon_sym_number] = ACTIONS(1739),
    [anon_sym_boolean] = ACTIONS(1739),
    [anon_sym_string] = ACTIONS(1739),
    [anon_sym_symbol] = ACTIONS(1739),
    [anon_sym_object] = ACTIONS(1739),
    [anon_sym_property] = ACTIONS(1739),
    [anon_sym_signal] = ACTIONS(1739),
    [anon_sym_on] = ACTIONS(1739),
    [anon_sym_required] = ACTIONS(1739),
    [anon_sym_component] = ACTIONS(1739),
    [sym_html_comment] = ACTIONS(5),
  },
  [211] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1791),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(211),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(1709),
    [anon_sym_RBRACE] = ACTIONS(1709),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_SEMI] = ACTIONS(1709),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(1709),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_AMP] = ACTIONS(1709),
    [anon_sym_PIPE] = ACTIONS(1711),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [anon_sym_extends] = ACTIONS(1711),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1709),
    [sym__automatic_semicolon] = ACTIONS(1709),
    [sym_html_comment] = ACTIONS(5),
  },
  [212] = {
    [sym_import] = STATE(3590),
    [sym_expression_statement] = STATE(293),
    [sym_variable_declaration] = STATE(293),
    [sym_lexical_declaration] = STATE(293),
    [sym_empty_statement] = STATE(293),
    [sym_parenthesized_expression] = STATE(1438),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1438),
    [sym_subscript_expression] = STATE(1438),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(5078),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5868),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(212),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1438),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1715),
    [anon_sym_export] = ACTIONS(1717),
    [anon_sym_type] = ACTIONS(1717),
    [anon_sym_namespace] = ACTIONS(1719),
    [anon_sym_LBRACE] = ACTIONS(1721),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1717),
    [anon_sym_var] = ACTIONS(1723),
    [anon_sym_let] = ACTIONS(1725),
    [anon_sym_const] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1717),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(1729),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1731),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1733),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1735),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1717),
    [anon_sym_readonly] = ACTIONS(1717),
    [anon_sym_get] = ACTIONS(1717),
    [anon_sym_set] = ACTIONS(1717),
    [anon_sym_declare] = ACTIONS(1717),
    [anon_sym_public] = ACTIONS(1717),
    [anon_sym_private] = ACTIONS(1717),
    [anon_sym_protected] = ACTIONS(1717),
    [anon_sym_override] = ACTIONS(1717),
    [anon_sym_module] = ACTIONS(1717),
    [anon_sym_any] = ACTIONS(1717),
    [anon_sym_number] = ACTIONS(1717),
    [anon_sym_boolean] = ACTIONS(1717),
    [anon_sym_string] = ACTIONS(1717),
    [anon_sym_symbol] = ACTIONS(1717),
    [anon_sym_object] = ACTIONS(1717),
    [anon_sym_property] = ACTIONS(1717),
    [anon_sym_signal] = ACTIONS(1717),
    [anon_sym_on] = ACTIONS(1717),
    [anon_sym_required] = ACTIONS(1717),
    [anon_sym_component] = ACTIONS(1717),
    [sym_html_comment] = ACTIONS(5),
  },
  [213] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(213),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(3294),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_EQ] = ACTIONS(877),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_RPAREN] = ACTIONS(70),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_COLON] = ACTIONS(70),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_RBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_EQ_GT] = ACTIONS(68),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(80),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(82),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(1771),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_void] = ACTIONS(130),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(118),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_satisfies] = ACTIONS(30),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [214] = {
    [sym_import] = STATE(3590),
    [sym_expression_statement] = STATE(299),
    [sym_variable_declaration] = STATE(299),
    [sym_lexical_declaration] = STATE(299),
    [sym_empty_statement] = STATE(299),
    [sym_parenthesized_expression] = STATE(1438),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1438),
    [sym_subscript_expression] = STATE(1438),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(5078),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5868),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(214),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1438),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1715),
    [anon_sym_export] = ACTIONS(1717),
    [anon_sym_type] = ACTIONS(1717),
    [anon_sym_namespace] = ACTIONS(1719),
    [anon_sym_LBRACE] = ACTIONS(1721),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1717),
    [anon_sym_var] = ACTIONS(1723),
    [anon_sym_let] = ACTIONS(1725),
    [anon_sym_const] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1717),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(1729),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1731),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1733),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1735),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1717),
    [anon_sym_readonly] = ACTIONS(1717),
    [anon_sym_get] = ACTIONS(1717),
    [anon_sym_set] = ACTIONS(1717),
    [anon_sym_declare] = ACTIONS(1717),
    [anon_sym_public] = ACTIONS(1717),
    [anon_sym_private] = ACTIONS(1717),
    [anon_sym_protected] = ACTIONS(1717),
    [anon_sym_override] = ACTIONS(1717),
    [anon_sym_module] = ACTIONS(1717),
    [anon_sym_any] = ACTIONS(1717),
    [anon_sym_number] = ACTIONS(1717),
    [anon_sym_boolean] = ACTIONS(1717),
    [anon_sym_string] = ACTIONS(1717),
    [anon_sym_symbol] = ACTIONS(1717),
    [anon_sym_object] = ACTIONS(1717),
    [anon_sym_property] = ACTIONS(1717),
    [anon_sym_signal] = ACTIONS(1717),
    [anon_sym_on] = ACTIONS(1717),
    [anon_sym_required] = ACTIONS(1717),
    [anon_sym_component] = ACTIONS(1717),
    [sym_html_comment] = ACTIONS(5),
  },
  [215] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_assignment_pattern] = STATE(5406),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3951),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(215),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(4714),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [aux_sym_array_pattern_repeat1] = STATE(5402),
    [sym_identifier] = ACTIONS(799),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_namespace] = ACTIONS(32),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_COMMA] = ACTIONS(1743),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(23),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_RBRACK] = ACTIONS(1783),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(64),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(809),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(821),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(23),
    [anon_sym_readonly] = ACTIONS(23),
    [anon_sym_get] = ACTIONS(23),
    [anon_sym_set] = ACTIONS(23),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_public] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(23),
    [anon_sym_protected] = ACTIONS(23),
    [anon_sym_override] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(23),
    [anon_sym_number] = ACTIONS(23),
    [anon_sym_boolean] = ACTIONS(23),
    [anon_sym_string] = ACTIONS(23),
    [anon_sym_symbol] = ACTIONS(23),
    [anon_sym_object] = ACTIONS(23),
    [anon_sym_property] = ACTIONS(23),
    [anon_sym_signal] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [anon_sym_required] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(23),
    [sym_html_comment] = ACTIONS(5),
  },
  [216] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2728),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(216),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_COMMA] = ACTIONS(1709),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_RPAREN] = ACTIONS(1709),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(1709),
    [anon_sym_RBRACK] = ACTIONS(1709),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(1709),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_AMP] = ACTIONS(1709),
    [anon_sym_PIPE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [anon_sym_extends] = ACTIONS(1711),
    [sym_html_comment] = ACTIONS(5),
  },
  [217] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2227),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_assignment_pattern] = STATE(5554),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1373),
    [sym_subscript_expression] = STATE(1373),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3818),
    [sym_spread_element] = STATE(5214),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(217),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(5291),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1373),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1673),
    [anon_sym_export] = ACTIONS(684),
    [anon_sym_type] = ACTIONS(684),
    [anon_sym_namespace] = ACTIONS(688),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_COMMA] = ACTIONS(1785),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(684),
    [anon_sym_let] = ACTIONS(684),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(684),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_RBRACK] = ACTIONS(1788),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(706),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1669),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(219),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1671),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(684),
    [anon_sym_readonly] = ACTIONS(684),
    [anon_sym_get] = ACTIONS(684),
    [anon_sym_set] = ACTIONS(684),
    [anon_sym_declare] = ACTIONS(684),
    [anon_sym_public] = ACTIONS(684),
    [anon_sym_private] = ACTIONS(684),
    [anon_sym_protected] = ACTIONS(684),
    [anon_sym_override] = ACTIONS(684),
    [anon_sym_module] = ACTIONS(684),
    [anon_sym_any] = ACTIONS(684),
    [anon_sym_number] = ACTIONS(684),
    [anon_sym_boolean] = ACTIONS(684),
    [anon_sym_string] = ACTIONS(684),
    [anon_sym_symbol] = ACTIONS(684),
    [anon_sym_object] = ACTIONS(684),
    [anon_sym_property] = ACTIONS(684),
    [anon_sym_signal] = ACTIONS(684),
    [anon_sym_on] = ACTIONS(684),
    [anon_sym_required] = ACTIONS(684),
    [anon_sym_component] = ACTIONS(684),
    [sym_html_comment] = ACTIONS(5),
  },
  [218] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(218),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(3294),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(80),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(82),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(1771),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_void] = ACTIONS(130),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(118),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_satisfies] = ACTIONS(30),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [219] = {
    [sym_comment] = STATE(219),
    [sym_identifier] = ACTIONS(1792),
    [anon_sym_export] = ACTIONS(1792),
    [anon_sym_STAR] = ACTIONS(1794),
    [anon_sym_default] = ACTIONS(1792),
    [anon_sym_type] = ACTIONS(1792),
    [anon_sym_EQ] = ACTIONS(1796),
    [anon_sym_as] = ACTIONS(1794),
    [anon_sym_namespace] = ACTIONS(1792),
    [anon_sym_LBRACE] = ACTIONS(1798),
    [anon_sym_COMMA] = ACTIONS(1800),
    [anon_sym_RBRACE] = ACTIONS(1798),
    [anon_sym_typeof] = ACTIONS(1792),
    [anon_sym_import] = ACTIONS(1792),
    [anon_sym_from] = ACTIONS(1792),
    [anon_sym_with] = ACTIONS(1792),
    [anon_sym_var] = ACTIONS(1792),
    [anon_sym_let] = ACTIONS(1792),
    [anon_sym_const] = ACTIONS(1792),
    [anon_sym_BANG] = ACTIONS(1792),
    [anon_sym_else] = ACTIONS(1792),
    [anon_sym_if] = ACTIONS(1792),
    [anon_sym_switch] = ACTIONS(1792),
    [anon_sym_for] = ACTIONS(1792),
    [anon_sym_LPAREN] = ACTIONS(1798),
    [anon_sym_await] = ACTIONS(1792),
    [anon_sym_in] = ACTIONS(1794),
    [anon_sym_of] = ACTIONS(1792),
    [anon_sym_while] = ACTIONS(1792),
    [anon_sym_do] = ACTIONS(1792),
    [anon_sym_try] = ACTIONS(1792),
    [anon_sym_break] = ACTIONS(1792),
    [anon_sym_continue] = ACTIONS(1792),
    [anon_sym_debugger] = ACTIONS(1792),
    [anon_sym_return] = ACTIONS(1792),
    [anon_sym_throw] = ACTIONS(1792),
    [anon_sym_SEMI] = ACTIONS(1798),
    [anon_sym_case] = ACTIONS(1792),
    [anon_sym_yield] = ACTIONS(1792),
    [anon_sym_LBRACK] = ACTIONS(1798),
    [anon_sym_LTtemplate_GT] = ACTIONS(1798),
    [anon_sym_GT] = ACTIONS(1794),
    [anon_sym_DOT] = ACTIONS(1794),
    [anon_sym_DQUOTE] = ACTIONS(1798),
    [anon_sym_SQUOTE] = ACTIONS(1798),
    [anon_sym_class] = ACTIONS(1792),
    [anon_sym_async] = ACTIONS(1792),
    [anon_sym_function] = ACTIONS(1792),
    [anon_sym_QMARK_DOT] = ACTIONS(1800),
    [anon_sym_new] = ACTIONS(1792),
    [anon_sym_using] = ACTIONS(1792),
    [anon_sym_AMP_AMP] = ACTIONS(1800),
    [anon_sym_PIPE_PIPE] = ACTIONS(1800),
    [anon_sym_GT_GT] = ACTIONS(1794),
    [anon_sym_GT_GT_GT] = ACTIONS(1800),
    [anon_sym_LT_LT] = ACTIONS(1800),
    [anon_sym_AMP] = ACTIONS(1794),
    [anon_sym_CARET] = ACTIONS(1800),
    [anon_sym_PIPE] = ACTIONS(1794),
    [anon_sym_PLUS] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(1792),
    [anon_sym_SLASH] = ACTIONS(1792),
    [anon_sym_PERCENT] = ACTIONS(1800),
    [anon_sym_STAR_STAR] = ACTIONS(1800),
    [anon_sym_LT] = ACTIONS(1792),
    [anon_sym_LT_EQ] = ACTIONS(1800),
    [anon_sym_EQ_EQ] = ACTIONS(1794),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1800),
    [anon_sym_BANG_EQ] = ACTIONS(1794),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1800),
    [anon_sym_GT_EQ] = ACTIONS(1800),
    [anon_sym_QMARK_QMARK] = ACTIONS(1800),
    [anon_sym_instanceof] = ACTIONS(1794),
    [anon_sym_TILDE] = ACTIONS(1798),
    [anon_sym_void] = ACTIONS(1792),
    [anon_sym_delete] = ACTIONS(1792),
    [anon_sym_PLUS_PLUS] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1798),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1798),
    [sym_number] = ACTIONS(1798),
    [sym_private_property_identifier] = ACTIONS(1798),
    [sym_this] = ACTIONS(1792),
    [sym_super] = ACTIONS(1792),
    [sym_true] = ACTIONS(1792),
    [sym_false] = ACTIONS(1792),
    [sym_null] = ACTIONS(1792),
    [sym_undefined] = ACTIONS(1792),
    [anon_sym_AT] = ACTIONS(1798),
    [anon_sym_static] = ACTIONS(1792),
    [anon_sym_readonly] = ACTIONS(1792),
    [anon_sym_get] = ACTIONS(1792),
    [anon_sym_set] = ACTIONS(1792),
    [anon_sym_declare] = ACTIONS(1792),
    [anon_sym_public] = ACTIONS(1792),
    [anon_sym_private] = ACTIONS(1792),
    [anon_sym_protected] = ACTIONS(1792),
    [anon_sym_override] = ACTIONS(1792),
    [anon_sym_module] = ACTIONS(1792),
    [anon_sym_any] = ACTIONS(1792),
    [anon_sym_number] = ACTIONS(1792),
    [anon_sym_boolean] = ACTIONS(1792),
    [anon_sym_string] = ACTIONS(1792),
    [anon_sym_symbol] = ACTIONS(1792),
    [anon_sym_object] = ACTIONS(1792),
    [anon_sym_property] = ACTIONS(1792),
    [anon_sym_signal] = ACTIONS(1792),
    [anon_sym_on] = ACTIONS(1792),
    [anon_sym_required] = ACTIONS(1792),
    [anon_sym_component] = ACTIONS(1792),
    [anon_sym_abstract] = ACTIONS(1792),
    [anon_sym_satisfies] = ACTIONS(1794),
    [anon_sym_interface] = ACTIONS(1792),
    [anon_sym_enum] = ACTIONS(1792),
    [sym__automatic_semicolon] = ACTIONS(1802),
    [sym__ternary_qmark] = ACTIONS(1800),
    [sym_html_comment] = ACTIONS(5),
  },
  [220] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1520),
    [sym_expression] = STATE(2573),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_assignment_pattern] = STATE(5110),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1489),
    [sym_subscript_expression] = STATE(1489),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5207),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(220),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(4802),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1489),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(556),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [aux_sym_array_pattern_repeat1] = STATE(5103),
    [sym_identifier] = ACTIONS(1804),
    [anon_sym_export] = ACTIONS(1806),
    [anon_sym_type] = ACTIONS(1806),
    [anon_sym_namespace] = ACTIONS(1808),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_COMMA] = ACTIONS(1743),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1806),
    [anon_sym_let] = ACTIONS(1806),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_of] = ACTIONS(1806),
    [anon_sym_yield] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_RBRACK] = ACTIONS(1745),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1810),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1812),
    [anon_sym_using] = ACTIONS(1247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1257),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1751),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1806),
    [anon_sym_readonly] = ACTIONS(1806),
    [anon_sym_get] = ACTIONS(1806),
    [anon_sym_set] = ACTIONS(1806),
    [anon_sym_declare] = ACTIONS(1806),
    [anon_sym_public] = ACTIONS(1806),
    [anon_sym_private] = ACTIONS(1806),
    [anon_sym_protected] = ACTIONS(1806),
    [anon_sym_override] = ACTIONS(1806),
    [anon_sym_module] = ACTIONS(1806),
    [anon_sym_any] = ACTIONS(1806),
    [anon_sym_number] = ACTIONS(1806),
    [anon_sym_boolean] = ACTIONS(1806),
    [anon_sym_string] = ACTIONS(1806),
    [anon_sym_symbol] = ACTIONS(1806),
    [anon_sym_object] = ACTIONS(1806),
    [anon_sym_property] = ACTIONS(1806),
    [anon_sym_signal] = ACTIONS(1806),
    [anon_sym_on] = ACTIONS(1806),
    [anon_sym_required] = ACTIONS(1806),
    [anon_sym_component] = ACTIONS(1806),
    [sym_html_comment] = ACTIONS(5),
  },
  [221] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2227),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_assignment_pattern] = STATE(5554),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1373),
    [sym_subscript_expression] = STATE(1373),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3818),
    [sym_spread_element] = STATE(5214),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(221),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(5291),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1373),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1673),
    [anon_sym_export] = ACTIONS(684),
    [anon_sym_type] = ACTIONS(684),
    [anon_sym_namespace] = ACTIONS(688),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_COMMA] = ACTIONS(1785),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(684),
    [anon_sym_let] = ACTIONS(684),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(684),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_RBRACK] = ACTIONS(1785),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(706),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1669),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(219),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1671),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(684),
    [anon_sym_readonly] = ACTIONS(684),
    [anon_sym_get] = ACTIONS(684),
    [anon_sym_set] = ACTIONS(684),
    [anon_sym_declare] = ACTIONS(684),
    [anon_sym_public] = ACTIONS(684),
    [anon_sym_private] = ACTIONS(684),
    [anon_sym_protected] = ACTIONS(684),
    [anon_sym_override] = ACTIONS(684),
    [anon_sym_module] = ACTIONS(684),
    [anon_sym_any] = ACTIONS(684),
    [anon_sym_number] = ACTIONS(684),
    [anon_sym_boolean] = ACTIONS(684),
    [anon_sym_string] = ACTIONS(684),
    [anon_sym_symbol] = ACTIONS(684),
    [anon_sym_object] = ACTIONS(684),
    [anon_sym_property] = ACTIONS(684),
    [anon_sym_signal] = ACTIONS(684),
    [anon_sym_on] = ACTIONS(684),
    [anon_sym_required] = ACTIONS(684),
    [anon_sym_component] = ACTIONS(684),
    [sym_html_comment] = ACTIONS(5),
  },
  [222] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2227),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_assignment_pattern] = STATE(5554),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1373),
    [sym_subscript_expression] = STATE(1373),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3818),
    [sym_spread_element] = STATE(5214),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(222),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(5291),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1373),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1673),
    [anon_sym_export] = ACTIONS(684),
    [anon_sym_type] = ACTIONS(684),
    [anon_sym_namespace] = ACTIONS(688),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_COMMA] = ACTIONS(1785),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(684),
    [anon_sym_let] = ACTIONS(684),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(684),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_RBRACK] = ACTIONS(1814),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(706),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1669),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(219),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1671),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(684),
    [anon_sym_readonly] = ACTIONS(684),
    [anon_sym_get] = ACTIONS(684),
    [anon_sym_set] = ACTIONS(684),
    [anon_sym_declare] = ACTIONS(684),
    [anon_sym_public] = ACTIONS(684),
    [anon_sym_private] = ACTIONS(684),
    [anon_sym_protected] = ACTIONS(684),
    [anon_sym_override] = ACTIONS(684),
    [anon_sym_module] = ACTIONS(684),
    [anon_sym_any] = ACTIONS(684),
    [anon_sym_number] = ACTIONS(684),
    [anon_sym_boolean] = ACTIONS(684),
    [anon_sym_string] = ACTIONS(684),
    [anon_sym_symbol] = ACTIONS(684),
    [anon_sym_object] = ACTIONS(684),
    [anon_sym_property] = ACTIONS(684),
    [anon_sym_signal] = ACTIONS(684),
    [anon_sym_on] = ACTIONS(684),
    [anon_sym_required] = ACTIONS(684),
    [anon_sym_component] = ACTIONS(684),
    [sym_html_comment] = ACTIONS(5),
  },
  [223] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_assignment_pattern] = STATE(5110),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3951),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(223),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(4802),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [aux_sym_array_pattern_repeat1] = STATE(5103),
    [sym_identifier] = ACTIONS(799),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_namespace] = ACTIONS(32),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_COMMA] = ACTIONS(1743),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(23),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_RBRACK] = ACTIONS(1745),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(64),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(809),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(821),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(23),
    [anon_sym_readonly] = ACTIONS(23),
    [anon_sym_get] = ACTIONS(23),
    [anon_sym_set] = ACTIONS(23),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_public] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(23),
    [anon_sym_protected] = ACTIONS(23),
    [anon_sym_override] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(23),
    [anon_sym_number] = ACTIONS(23),
    [anon_sym_boolean] = ACTIONS(23),
    [anon_sym_string] = ACTIONS(23),
    [anon_sym_symbol] = ACTIONS(23),
    [anon_sym_object] = ACTIONS(23),
    [anon_sym_property] = ACTIONS(23),
    [anon_sym_signal] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [anon_sym_required] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(23),
    [sym_html_comment] = ACTIONS(5),
  },
  [224] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(224),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(3294),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_EQ] = ACTIONS(952),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_EQ_GT] = ACTIONS(958),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(80),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(82),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(1771),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_void] = ACTIONS(130),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(118),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_satisfies] = ACTIONS(30),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [225] = {
    [sym_statement_block] = STATE(240),
    [sym_comment] = STATE(225),
    [sym_identifier] = ACTIONS(1818),
    [anon_sym_export] = ACTIONS(1818),
    [anon_sym_STAR] = ACTIONS(1818),
    [anon_sym_default] = ACTIONS(1818),
    [anon_sym_type] = ACTIONS(1818),
    [anon_sym_as] = ACTIONS(1818),
    [anon_sym_namespace] = ACTIONS(1818),
    [anon_sym_LBRACE] = ACTIONS(1820),
    [anon_sym_COMMA] = ACTIONS(1822),
    [anon_sym_RBRACE] = ACTIONS(1822),
    [anon_sym_typeof] = ACTIONS(1818),
    [anon_sym_import] = ACTIONS(1818),
    [anon_sym_from] = ACTIONS(1818),
    [anon_sym_with] = ACTIONS(1818),
    [anon_sym_var] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(1818),
    [anon_sym_const] = ACTIONS(1818),
    [anon_sym_BANG] = ACTIONS(1818),
    [anon_sym_else] = ACTIONS(1818),
    [anon_sym_if] = ACTIONS(1818),
    [anon_sym_switch] = ACTIONS(1818),
    [anon_sym_for] = ACTIONS(1818),
    [anon_sym_LPAREN] = ACTIONS(1822),
    [anon_sym_await] = ACTIONS(1818),
    [anon_sym_in] = ACTIONS(1818),
    [anon_sym_of] = ACTIONS(1818),
    [anon_sym_while] = ACTIONS(1818),
    [anon_sym_do] = ACTIONS(1818),
    [anon_sym_try] = ACTIONS(1818),
    [anon_sym_break] = ACTIONS(1818),
    [anon_sym_continue] = ACTIONS(1818),
    [anon_sym_debugger] = ACTIONS(1818),
    [anon_sym_return] = ACTIONS(1818),
    [anon_sym_throw] = ACTIONS(1818),
    [anon_sym_SEMI] = ACTIONS(1822),
    [anon_sym_case] = ACTIONS(1818),
    [anon_sym_yield] = ACTIONS(1818),
    [anon_sym_LBRACK] = ACTIONS(1822),
    [anon_sym_LTtemplate_GT] = ACTIONS(1822),
    [anon_sym_GT] = ACTIONS(1818),
    [anon_sym_DOT] = ACTIONS(1824),
    [anon_sym_DQUOTE] = ACTIONS(1822),
    [anon_sym_SQUOTE] = ACTIONS(1822),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_async] = ACTIONS(1818),
    [anon_sym_function] = ACTIONS(1818),
    [anon_sym_QMARK_DOT] = ACTIONS(1822),
    [anon_sym_new] = ACTIONS(1818),
    [anon_sym_using] = ACTIONS(1818),
    [anon_sym_AMP_AMP] = ACTIONS(1822),
    [anon_sym_PIPE_PIPE] = ACTIONS(1822),
    [anon_sym_GT_GT] = ACTIONS(1818),
    [anon_sym_GT_GT_GT] = ACTIONS(1822),
    [anon_sym_LT_LT] = ACTIONS(1822),
    [anon_sym_AMP] = ACTIONS(1818),
    [anon_sym_CARET] = ACTIONS(1822),
    [anon_sym_PIPE] = ACTIONS(1818),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_DASH] = ACTIONS(1818),
    [anon_sym_SLASH] = ACTIONS(1818),
    [anon_sym_PERCENT] = ACTIONS(1822),
    [anon_sym_STAR_STAR] = ACTIONS(1822),
    [anon_sym_LT] = ACTIONS(1818),
    [anon_sym_LT_EQ] = ACTIONS(1822),
    [anon_sym_EQ_EQ] = ACTIONS(1818),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1822),
    [anon_sym_BANG_EQ] = ACTIONS(1818),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1822),
    [anon_sym_GT_EQ] = ACTIONS(1822),
    [anon_sym_QMARK_QMARK] = ACTIONS(1822),
    [anon_sym_instanceof] = ACTIONS(1818),
    [anon_sym_TILDE] = ACTIONS(1822),
    [anon_sym_void] = ACTIONS(1818),
    [anon_sym_delete] = ACTIONS(1818),
    [anon_sym_PLUS_PLUS] = ACTIONS(1822),
    [anon_sym_DASH_DASH] = ACTIONS(1822),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1822),
    [sym_number] = ACTIONS(1822),
    [sym_private_property_identifier] = ACTIONS(1822),
    [sym_this] = ACTIONS(1818),
    [sym_super] = ACTIONS(1818),
    [sym_true] = ACTIONS(1818),
    [sym_false] = ACTIONS(1818),
    [sym_null] = ACTIONS(1818),
    [sym_undefined] = ACTIONS(1818),
    [anon_sym_AT] = ACTIONS(1822),
    [anon_sym_static] = ACTIONS(1818),
    [anon_sym_readonly] = ACTIONS(1818),
    [anon_sym_get] = ACTIONS(1818),
    [anon_sym_set] = ACTIONS(1818),
    [anon_sym_declare] = ACTIONS(1818),
    [anon_sym_public] = ACTIONS(1818),
    [anon_sym_private] = ACTIONS(1818),
    [anon_sym_protected] = ACTIONS(1818),
    [anon_sym_override] = ACTIONS(1818),
    [anon_sym_module] = ACTIONS(1818),
    [anon_sym_any] = ACTIONS(1818),
    [anon_sym_number] = ACTIONS(1818),
    [anon_sym_boolean] = ACTIONS(1818),
    [anon_sym_string] = ACTIONS(1818),
    [anon_sym_symbol] = ACTIONS(1818),
    [anon_sym_object] = ACTIONS(1818),
    [anon_sym_property] = ACTIONS(1818),
    [anon_sym_signal] = ACTIONS(1818),
    [anon_sym_on] = ACTIONS(1818),
    [anon_sym_required] = ACTIONS(1818),
    [anon_sym_component] = ACTIONS(1818),
    [anon_sym_abstract] = ACTIONS(1818),
    [anon_sym_satisfies] = ACTIONS(1818),
    [anon_sym_interface] = ACTIONS(1818),
    [anon_sym_enum] = ACTIONS(1818),
    [sym__automatic_semicolon] = ACTIONS(1822),
    [sym__ternary_qmark] = ACTIONS(1822),
    [sym_html_comment] = ACTIONS(5),
  },
  [226] = {
    [sym_statement_block] = STATE(240),
    [sym_comment] = STATE(226),
    [sym_identifier] = ACTIONS(1818),
    [anon_sym_export] = ACTIONS(1818),
    [anon_sym_STAR] = ACTIONS(1818),
    [anon_sym_default] = ACTIONS(1818),
    [anon_sym_type] = ACTIONS(1818),
    [anon_sym_as] = ACTIONS(1818),
    [anon_sym_namespace] = ACTIONS(1818),
    [anon_sym_LBRACE] = ACTIONS(1820),
    [anon_sym_COMMA] = ACTIONS(1822),
    [anon_sym_RBRACE] = ACTIONS(1822),
    [anon_sym_typeof] = ACTIONS(1818),
    [anon_sym_import] = ACTIONS(1818),
    [anon_sym_from] = ACTIONS(1818),
    [anon_sym_with] = ACTIONS(1818),
    [anon_sym_var] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(1818),
    [anon_sym_const] = ACTIONS(1818),
    [anon_sym_BANG] = ACTIONS(1818),
    [anon_sym_else] = ACTIONS(1818),
    [anon_sym_if] = ACTIONS(1818),
    [anon_sym_switch] = ACTIONS(1818),
    [anon_sym_for] = ACTIONS(1818),
    [anon_sym_LPAREN] = ACTIONS(1822),
    [anon_sym_await] = ACTIONS(1818),
    [anon_sym_in] = ACTIONS(1818),
    [anon_sym_of] = ACTIONS(1818),
    [anon_sym_while] = ACTIONS(1818),
    [anon_sym_do] = ACTIONS(1818),
    [anon_sym_try] = ACTIONS(1818),
    [anon_sym_break] = ACTIONS(1818),
    [anon_sym_continue] = ACTIONS(1818),
    [anon_sym_debugger] = ACTIONS(1818),
    [anon_sym_return] = ACTIONS(1818),
    [anon_sym_throw] = ACTIONS(1818),
    [anon_sym_SEMI] = ACTIONS(1822),
    [anon_sym_case] = ACTIONS(1818),
    [anon_sym_yield] = ACTIONS(1818),
    [anon_sym_LBRACK] = ACTIONS(1822),
    [anon_sym_LTtemplate_GT] = ACTIONS(1822),
    [anon_sym_GT] = ACTIONS(1818),
    [anon_sym_DOT] = ACTIONS(1826),
    [anon_sym_DQUOTE] = ACTIONS(1822),
    [anon_sym_SQUOTE] = ACTIONS(1822),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_async] = ACTIONS(1818),
    [anon_sym_function] = ACTIONS(1818),
    [anon_sym_QMARK_DOT] = ACTIONS(1822),
    [anon_sym_new] = ACTIONS(1818),
    [anon_sym_using] = ACTIONS(1818),
    [anon_sym_AMP_AMP] = ACTIONS(1822),
    [anon_sym_PIPE_PIPE] = ACTIONS(1822),
    [anon_sym_GT_GT] = ACTIONS(1818),
    [anon_sym_GT_GT_GT] = ACTIONS(1822),
    [anon_sym_LT_LT] = ACTIONS(1822),
    [anon_sym_AMP] = ACTIONS(1818),
    [anon_sym_CARET] = ACTIONS(1822),
    [anon_sym_PIPE] = ACTIONS(1818),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_DASH] = ACTIONS(1818),
    [anon_sym_SLASH] = ACTIONS(1818),
    [anon_sym_PERCENT] = ACTIONS(1822),
    [anon_sym_STAR_STAR] = ACTIONS(1822),
    [anon_sym_LT] = ACTIONS(1818),
    [anon_sym_LT_EQ] = ACTIONS(1822),
    [anon_sym_EQ_EQ] = ACTIONS(1818),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1822),
    [anon_sym_BANG_EQ] = ACTIONS(1818),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1822),
    [anon_sym_GT_EQ] = ACTIONS(1822),
    [anon_sym_QMARK_QMARK] = ACTIONS(1822),
    [anon_sym_instanceof] = ACTIONS(1818),
    [anon_sym_TILDE] = ACTIONS(1822),
    [anon_sym_void] = ACTIONS(1818),
    [anon_sym_delete] = ACTIONS(1818),
    [anon_sym_PLUS_PLUS] = ACTIONS(1822),
    [anon_sym_DASH_DASH] = ACTIONS(1822),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1822),
    [sym_number] = ACTIONS(1822),
    [sym_private_property_identifier] = ACTIONS(1822),
    [sym_this] = ACTIONS(1818),
    [sym_super] = ACTIONS(1818),
    [sym_true] = ACTIONS(1818),
    [sym_false] = ACTIONS(1818),
    [sym_null] = ACTIONS(1818),
    [sym_undefined] = ACTIONS(1818),
    [anon_sym_AT] = ACTIONS(1822),
    [anon_sym_static] = ACTIONS(1818),
    [anon_sym_readonly] = ACTIONS(1818),
    [anon_sym_get] = ACTIONS(1818),
    [anon_sym_set] = ACTIONS(1818),
    [anon_sym_declare] = ACTIONS(1818),
    [anon_sym_public] = ACTIONS(1818),
    [anon_sym_private] = ACTIONS(1818),
    [anon_sym_protected] = ACTIONS(1818),
    [anon_sym_override] = ACTIONS(1818),
    [anon_sym_module] = ACTIONS(1818),
    [anon_sym_any] = ACTIONS(1818),
    [anon_sym_number] = ACTIONS(1818),
    [anon_sym_boolean] = ACTIONS(1818),
    [anon_sym_string] = ACTIONS(1818),
    [anon_sym_symbol] = ACTIONS(1818),
    [anon_sym_object] = ACTIONS(1818),
    [anon_sym_property] = ACTIONS(1818),
    [anon_sym_signal] = ACTIONS(1818),
    [anon_sym_on] = ACTIONS(1818),
    [anon_sym_required] = ACTIONS(1818),
    [anon_sym_component] = ACTIONS(1818),
    [anon_sym_abstract] = ACTIONS(1818),
    [anon_sym_satisfies] = ACTIONS(1818),
    [anon_sym_interface] = ACTIONS(1818),
    [anon_sym_enum] = ACTIONS(1818),
    [sym__automatic_semicolon] = ACTIONS(1822),
    [sym__ternary_qmark] = ACTIONS(1822),
    [sym_html_comment] = ACTIONS(5),
  },
  [227] = {
    [sym_statement_block] = STATE(240),
    [sym_comment] = STATE(227),
    [sym_identifier] = ACTIONS(1818),
    [anon_sym_export] = ACTIONS(1818),
    [anon_sym_STAR] = ACTIONS(1818),
    [anon_sym_default] = ACTIONS(1818),
    [anon_sym_type] = ACTIONS(1818),
    [anon_sym_as] = ACTIONS(1818),
    [anon_sym_namespace] = ACTIONS(1818),
    [anon_sym_LBRACE] = ACTIONS(1820),
    [anon_sym_COMMA] = ACTIONS(1822),
    [anon_sym_RBRACE] = ACTIONS(1822),
    [anon_sym_typeof] = ACTIONS(1818),
    [anon_sym_import] = ACTIONS(1818),
    [anon_sym_from] = ACTIONS(1818),
    [anon_sym_with] = ACTIONS(1818),
    [anon_sym_var] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(1818),
    [anon_sym_const] = ACTIONS(1818),
    [anon_sym_BANG] = ACTIONS(1818),
    [anon_sym_else] = ACTIONS(1818),
    [anon_sym_if] = ACTIONS(1818),
    [anon_sym_switch] = ACTIONS(1818),
    [anon_sym_for] = ACTIONS(1818),
    [anon_sym_LPAREN] = ACTIONS(1822),
    [anon_sym_await] = ACTIONS(1818),
    [anon_sym_in] = ACTIONS(1818),
    [anon_sym_of] = ACTIONS(1818),
    [anon_sym_while] = ACTIONS(1818),
    [anon_sym_do] = ACTIONS(1818),
    [anon_sym_try] = ACTIONS(1818),
    [anon_sym_break] = ACTIONS(1818),
    [anon_sym_continue] = ACTIONS(1818),
    [anon_sym_debugger] = ACTIONS(1818),
    [anon_sym_return] = ACTIONS(1818),
    [anon_sym_throw] = ACTIONS(1818),
    [anon_sym_SEMI] = ACTIONS(1822),
    [anon_sym_case] = ACTIONS(1818),
    [anon_sym_yield] = ACTIONS(1818),
    [anon_sym_LBRACK] = ACTIONS(1822),
    [anon_sym_LTtemplate_GT] = ACTIONS(1822),
    [anon_sym_GT] = ACTIONS(1818),
    [anon_sym_DOT] = ACTIONS(1818),
    [anon_sym_DQUOTE] = ACTIONS(1822),
    [anon_sym_SQUOTE] = ACTIONS(1822),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_async] = ACTIONS(1818),
    [anon_sym_function] = ACTIONS(1818),
    [anon_sym_QMARK_DOT] = ACTIONS(1822),
    [anon_sym_new] = ACTIONS(1818),
    [anon_sym_using] = ACTIONS(1818),
    [anon_sym_AMP_AMP] = ACTIONS(1822),
    [anon_sym_PIPE_PIPE] = ACTIONS(1822),
    [anon_sym_GT_GT] = ACTIONS(1818),
    [anon_sym_GT_GT_GT] = ACTIONS(1822),
    [anon_sym_LT_LT] = ACTIONS(1822),
    [anon_sym_AMP] = ACTIONS(1818),
    [anon_sym_CARET] = ACTIONS(1822),
    [anon_sym_PIPE] = ACTIONS(1818),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_DASH] = ACTIONS(1818),
    [anon_sym_SLASH] = ACTIONS(1818),
    [anon_sym_PERCENT] = ACTIONS(1822),
    [anon_sym_STAR_STAR] = ACTIONS(1822),
    [anon_sym_LT] = ACTIONS(1818),
    [anon_sym_LT_EQ] = ACTIONS(1822),
    [anon_sym_EQ_EQ] = ACTIONS(1818),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1822),
    [anon_sym_BANG_EQ] = ACTIONS(1818),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1822),
    [anon_sym_GT_EQ] = ACTIONS(1822),
    [anon_sym_QMARK_QMARK] = ACTIONS(1822),
    [anon_sym_instanceof] = ACTIONS(1818),
    [anon_sym_TILDE] = ACTIONS(1822),
    [anon_sym_void] = ACTIONS(1818),
    [anon_sym_delete] = ACTIONS(1818),
    [anon_sym_PLUS_PLUS] = ACTIONS(1822),
    [anon_sym_DASH_DASH] = ACTIONS(1822),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1822),
    [sym_number] = ACTIONS(1822),
    [sym_private_property_identifier] = ACTIONS(1822),
    [sym_this] = ACTIONS(1818),
    [sym_super] = ACTIONS(1818),
    [sym_true] = ACTIONS(1818),
    [sym_false] = ACTIONS(1818),
    [sym_null] = ACTIONS(1818),
    [sym_undefined] = ACTIONS(1818),
    [anon_sym_AT] = ACTIONS(1822),
    [anon_sym_static] = ACTIONS(1818),
    [anon_sym_readonly] = ACTIONS(1818),
    [anon_sym_get] = ACTIONS(1818),
    [anon_sym_set] = ACTIONS(1818),
    [anon_sym_declare] = ACTIONS(1818),
    [anon_sym_public] = ACTIONS(1818),
    [anon_sym_private] = ACTIONS(1818),
    [anon_sym_protected] = ACTIONS(1818),
    [anon_sym_override] = ACTIONS(1818),
    [anon_sym_module] = ACTIONS(1818),
    [anon_sym_any] = ACTIONS(1818),
    [anon_sym_number] = ACTIONS(1818),
    [anon_sym_boolean] = ACTIONS(1818),
    [anon_sym_string] = ACTIONS(1818),
    [anon_sym_symbol] = ACTIONS(1818),
    [anon_sym_object] = ACTIONS(1818),
    [anon_sym_property] = ACTIONS(1818),
    [anon_sym_signal] = ACTIONS(1818),
    [anon_sym_on] = ACTIONS(1818),
    [anon_sym_required] = ACTIONS(1818),
    [anon_sym_component] = ACTIONS(1818),
    [anon_sym_abstract] = ACTIONS(1818),
    [anon_sym_satisfies] = ACTIONS(1818),
    [anon_sym_interface] = ACTIONS(1818),
    [anon_sym_enum] = ACTIONS(1818),
    [sym__automatic_semicolon] = ACTIONS(1822),
    [sym__ternary_qmark] = ACTIONS(1822),
    [sym_html_comment] = ACTIONS(5),
  },
  [228] = {
    [sym_comment] = STATE(228),
    [sym_identifier] = ACTIONS(1828),
    [anon_sym_export] = ACTIONS(1828),
    [anon_sym_STAR] = ACTIONS(1830),
    [anon_sym_default] = ACTIONS(1828),
    [anon_sym_type] = ACTIONS(1828),
    [anon_sym_as] = ACTIONS(1830),
    [anon_sym_namespace] = ACTIONS(1828),
    [anon_sym_LBRACE] = ACTIONS(1832),
    [anon_sym_COMMA] = ACTIONS(1834),
    [anon_sym_RBRACE] = ACTIONS(1832),
    [anon_sym_typeof] = ACTIONS(1828),
    [anon_sym_import] = ACTIONS(1828),
    [anon_sym_from] = ACTIONS(1828),
    [anon_sym_with] = ACTIONS(1828),
    [anon_sym_var] = ACTIONS(1828),
    [anon_sym_let] = ACTIONS(1828),
    [anon_sym_const] = ACTIONS(1828),
    [anon_sym_BANG] = ACTIONS(1828),
    [anon_sym_else] = ACTIONS(1828),
    [anon_sym_if] = ACTIONS(1828),
    [anon_sym_switch] = ACTIONS(1828),
    [anon_sym_for] = ACTIONS(1828),
    [anon_sym_LPAREN] = ACTIONS(1832),
    [anon_sym_await] = ACTIONS(1828),
    [anon_sym_in] = ACTIONS(1830),
    [anon_sym_of] = ACTIONS(1828),
    [anon_sym_while] = ACTIONS(1828),
    [anon_sym_do] = ACTIONS(1828),
    [anon_sym_try] = ACTIONS(1828),
    [anon_sym_break] = ACTIONS(1828),
    [anon_sym_continue] = ACTIONS(1828),
    [anon_sym_debugger] = ACTIONS(1828),
    [anon_sym_return] = ACTIONS(1828),
    [anon_sym_throw] = ACTIONS(1828),
    [anon_sym_SEMI] = ACTIONS(1832),
    [anon_sym_case] = ACTIONS(1828),
    [anon_sym_yield] = ACTIONS(1828),
    [anon_sym_LBRACK] = ACTIONS(1832),
    [anon_sym_LTtemplate_GT] = ACTIONS(1832),
    [anon_sym_GT] = ACTIONS(1830),
    [anon_sym_DOT] = ACTIONS(1830),
    [anon_sym_DQUOTE] = ACTIONS(1832),
    [anon_sym_SQUOTE] = ACTIONS(1832),
    [anon_sym_class] = ACTIONS(1828),
    [anon_sym_async] = ACTIONS(1828),
    [anon_sym_function] = ACTIONS(1828),
    [anon_sym_QMARK_DOT] = ACTIONS(1834),
    [anon_sym_new] = ACTIONS(1828),
    [anon_sym_using] = ACTIONS(1828),
    [anon_sym_AMP_AMP] = ACTIONS(1834),
    [anon_sym_PIPE_PIPE] = ACTIONS(1834),
    [anon_sym_GT_GT] = ACTIONS(1830),
    [anon_sym_GT_GT_GT] = ACTIONS(1834),
    [anon_sym_LT_LT] = ACTIONS(1834),
    [anon_sym_AMP] = ACTIONS(1830),
    [anon_sym_CARET] = ACTIONS(1834),
    [anon_sym_PIPE] = ACTIONS(1830),
    [anon_sym_PLUS] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_SLASH] = ACTIONS(1828),
    [anon_sym_PERCENT] = ACTIONS(1834),
    [anon_sym_STAR_STAR] = ACTIONS(1834),
    [anon_sym_LT] = ACTIONS(1828),
    [anon_sym_LT_EQ] = ACTIONS(1834),
    [anon_sym_EQ_EQ] = ACTIONS(1830),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1834),
    [anon_sym_BANG_EQ] = ACTIONS(1830),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1834),
    [anon_sym_GT_EQ] = ACTIONS(1834),
    [anon_sym_QMARK_QMARK] = ACTIONS(1834),
    [anon_sym_instanceof] = ACTIONS(1830),
    [anon_sym_TILDE] = ACTIONS(1832),
    [anon_sym_void] = ACTIONS(1828),
    [anon_sym_delete] = ACTIONS(1828),
    [anon_sym_PLUS_PLUS] = ACTIONS(1832),
    [anon_sym_DASH_DASH] = ACTIONS(1832),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1832),
    [sym_number] = ACTIONS(1832),
    [sym_private_property_identifier] = ACTIONS(1832),
    [sym_this] = ACTIONS(1828),
    [sym_super] = ACTIONS(1828),
    [sym_true] = ACTIONS(1828),
    [sym_false] = ACTIONS(1828),
    [sym_null] = ACTIONS(1828),
    [sym_undefined] = ACTIONS(1828),
    [anon_sym_AT] = ACTIONS(1832),
    [anon_sym_static] = ACTIONS(1828),
    [anon_sym_readonly] = ACTIONS(1828),
    [anon_sym_get] = ACTIONS(1828),
    [anon_sym_set] = ACTIONS(1828),
    [anon_sym_declare] = ACTIONS(1828),
    [anon_sym_public] = ACTIONS(1828),
    [anon_sym_private] = ACTIONS(1828),
    [anon_sym_protected] = ACTIONS(1828),
    [anon_sym_override] = ACTIONS(1828),
    [anon_sym_module] = ACTIONS(1828),
    [anon_sym_any] = ACTIONS(1828),
    [anon_sym_number] = ACTIONS(1828),
    [anon_sym_boolean] = ACTIONS(1828),
    [anon_sym_string] = ACTIONS(1828),
    [anon_sym_symbol] = ACTIONS(1828),
    [anon_sym_object] = ACTIONS(1828),
    [anon_sym_property] = ACTIONS(1828),
    [anon_sym_signal] = ACTIONS(1828),
    [anon_sym_on] = ACTIONS(1828),
    [anon_sym_required] = ACTIONS(1828),
    [anon_sym_component] = ACTIONS(1828),
    [anon_sym_abstract] = ACTIONS(1828),
    [anon_sym_satisfies] = ACTIONS(1830),
    [anon_sym_interface] = ACTIONS(1828),
    [anon_sym_enum] = ACTIONS(1828),
    [sym__automatic_semicolon] = ACTIONS(1836),
    [sym__ternary_qmark] = ACTIONS(1834),
    [sym_html_comment] = ACTIONS(5),
  },
  [229] = {
    [sym_comment] = STATE(229),
    [sym_identifier] = ACTIONS(1838),
    [anon_sym_export] = ACTIONS(1838),
    [anon_sym_STAR] = ACTIONS(1838),
    [anon_sym_default] = ACTIONS(1838),
    [anon_sym_type] = ACTIONS(1838),
    [anon_sym_as] = ACTIONS(1838),
    [anon_sym_namespace] = ACTIONS(1838),
    [anon_sym_LBRACE] = ACTIONS(1840),
    [anon_sym_COMMA] = ACTIONS(1840),
    [anon_sym_RBRACE] = ACTIONS(1840),
    [anon_sym_typeof] = ACTIONS(1838),
    [anon_sym_import] = ACTIONS(1838),
    [anon_sym_from] = ACTIONS(1838),
    [anon_sym_with] = ACTIONS(1838),
    [anon_sym_var] = ACTIONS(1838),
    [anon_sym_let] = ACTIONS(1838),
    [anon_sym_const] = ACTIONS(1838),
    [anon_sym_BANG] = ACTIONS(1838),
    [anon_sym_else] = ACTIONS(1838),
    [anon_sym_if] = ACTIONS(1838),
    [anon_sym_switch] = ACTIONS(1838),
    [anon_sym_for] = ACTIONS(1838),
    [anon_sym_LPAREN] = ACTIONS(1840),
    [anon_sym_await] = ACTIONS(1838),
    [anon_sym_in] = ACTIONS(1838),
    [anon_sym_of] = ACTIONS(1838),
    [anon_sym_while] = ACTIONS(1838),
    [anon_sym_do] = ACTIONS(1838),
    [anon_sym_try] = ACTIONS(1838),
    [anon_sym_break] = ACTIONS(1838),
    [anon_sym_continue] = ACTIONS(1838),
    [anon_sym_debugger] = ACTIONS(1838),
    [anon_sym_return] = ACTIONS(1838),
    [anon_sym_throw] = ACTIONS(1838),
    [anon_sym_SEMI] = ACTIONS(1840),
    [anon_sym_case] = ACTIONS(1838),
    [anon_sym_yield] = ACTIONS(1838),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LTtemplate_GT] = ACTIONS(1840),
    [anon_sym_GT] = ACTIONS(1838),
    [anon_sym_DOT] = ACTIONS(1838),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [anon_sym_SQUOTE] = ACTIONS(1840),
    [anon_sym_class] = ACTIONS(1838),
    [anon_sym_async] = ACTIONS(1838),
    [anon_sym_function] = ACTIONS(1838),
    [anon_sym_QMARK_DOT] = ACTIONS(1840),
    [anon_sym_new] = ACTIONS(1838),
    [anon_sym_using] = ACTIONS(1838),
    [anon_sym_AMP_AMP] = ACTIONS(1840),
    [anon_sym_PIPE_PIPE] = ACTIONS(1840),
    [anon_sym_GT_GT] = ACTIONS(1838),
    [anon_sym_GT_GT_GT] = ACTIONS(1840),
    [anon_sym_LT_LT] = ACTIONS(1840),
    [anon_sym_AMP] = ACTIONS(1838),
    [anon_sym_CARET] = ACTIONS(1840),
    [anon_sym_PIPE] = ACTIONS(1838),
    [anon_sym_PLUS] = ACTIONS(1838),
    [anon_sym_DASH] = ACTIONS(1838),
    [anon_sym_SLASH] = ACTIONS(1838),
    [anon_sym_PERCENT] = ACTIONS(1840),
    [anon_sym_STAR_STAR] = ACTIONS(1840),
    [anon_sym_LT] = ACTIONS(1838),
    [anon_sym_LT_EQ] = ACTIONS(1840),
    [anon_sym_EQ_EQ] = ACTIONS(1838),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1840),
    [anon_sym_BANG_EQ] = ACTIONS(1838),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1840),
    [anon_sym_GT_EQ] = ACTIONS(1840),
    [anon_sym_QMARK_QMARK] = ACTIONS(1840),
    [anon_sym_instanceof] = ACTIONS(1838),
    [anon_sym_TILDE] = ACTIONS(1840),
    [anon_sym_void] = ACTIONS(1838),
    [anon_sym_delete] = ACTIONS(1838),
    [anon_sym_PLUS_PLUS] = ACTIONS(1840),
    [anon_sym_DASH_DASH] = ACTIONS(1840),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1840),
    [sym_number] = ACTIONS(1840),
    [sym_private_property_identifier] = ACTIONS(1840),
    [sym_this] = ACTIONS(1838),
    [sym_super] = ACTIONS(1838),
    [sym_true] = ACTIONS(1838),
    [sym_false] = ACTIONS(1838),
    [sym_null] = ACTIONS(1838),
    [sym_undefined] = ACTIONS(1838),
    [anon_sym_AT] = ACTIONS(1840),
    [anon_sym_static] = ACTIONS(1838),
    [anon_sym_readonly] = ACTIONS(1838),
    [anon_sym_get] = ACTIONS(1838),
    [anon_sym_set] = ACTIONS(1838),
    [anon_sym_declare] = ACTIONS(1838),
    [anon_sym_public] = ACTIONS(1838),
    [anon_sym_private] = ACTIONS(1838),
    [anon_sym_protected] = ACTIONS(1838),
    [anon_sym_override] = ACTIONS(1838),
    [anon_sym_module] = ACTIONS(1838),
    [anon_sym_any] = ACTIONS(1838),
    [anon_sym_number] = ACTIONS(1838),
    [anon_sym_boolean] = ACTIONS(1838),
    [anon_sym_string] = ACTIONS(1838),
    [anon_sym_symbol] = ACTIONS(1838),
    [anon_sym_object] = ACTIONS(1838),
    [anon_sym_property] = ACTIONS(1838),
    [anon_sym_signal] = ACTIONS(1838),
    [anon_sym_on] = ACTIONS(1838),
    [anon_sym_required] = ACTIONS(1838),
    [anon_sym_component] = ACTIONS(1838),
    [anon_sym_abstract] = ACTIONS(1838),
    [anon_sym_satisfies] = ACTIONS(1838),
    [anon_sym_interface] = ACTIONS(1838),
    [anon_sym_enum] = ACTIONS(1838),
    [sym__automatic_semicolon] = ACTIONS(1840),
    [sym__ternary_qmark] = ACTIONS(1840),
    [sym_html_comment] = ACTIONS(5),
  },
  [230] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(230),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(3294),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_EQ] = ACTIONS(877),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_COMMA] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_COLON] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_RBRACK] = ACTIONS(964),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_EQ_GT] = ACTIONS(68),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(80),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(82),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(1771),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_void] = ACTIONS(130),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(118),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_satisfies] = ACTIONS(30),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [231] = {
    [sym_comment] = STATE(231),
    [sym_identifier] = ACTIONS(1842),
    [anon_sym_export] = ACTIONS(1842),
    [anon_sym_STAR] = ACTIONS(1844),
    [anon_sym_default] = ACTIONS(1842),
    [anon_sym_type] = ACTIONS(1842),
    [anon_sym_as] = ACTIONS(1844),
    [anon_sym_namespace] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(1846),
    [anon_sym_COMMA] = ACTIONS(1848),
    [anon_sym_RBRACE] = ACTIONS(1846),
    [anon_sym_typeof] = ACTIONS(1842),
    [anon_sym_import] = ACTIONS(1842),
    [anon_sym_from] = ACTIONS(1842),
    [anon_sym_with] = ACTIONS(1842),
    [anon_sym_var] = ACTIONS(1842),
    [anon_sym_let] = ACTIONS(1842),
    [anon_sym_const] = ACTIONS(1842),
    [anon_sym_BANG] = ACTIONS(1842),
    [anon_sym_else] = ACTIONS(1842),
    [anon_sym_if] = ACTIONS(1842),
    [anon_sym_switch] = ACTIONS(1842),
    [anon_sym_for] = ACTIONS(1842),
    [anon_sym_LPAREN] = ACTIONS(1846),
    [anon_sym_await] = ACTIONS(1842),
    [anon_sym_in] = ACTIONS(1844),
    [anon_sym_of] = ACTIONS(1842),
    [anon_sym_while] = ACTIONS(1842),
    [anon_sym_do] = ACTIONS(1842),
    [anon_sym_try] = ACTIONS(1842),
    [anon_sym_break] = ACTIONS(1842),
    [anon_sym_continue] = ACTIONS(1842),
    [anon_sym_debugger] = ACTIONS(1842),
    [anon_sym_return] = ACTIONS(1842),
    [anon_sym_throw] = ACTIONS(1842),
    [anon_sym_SEMI] = ACTIONS(1846),
    [anon_sym_case] = ACTIONS(1842),
    [anon_sym_yield] = ACTIONS(1842),
    [anon_sym_LBRACK] = ACTIONS(1846),
    [anon_sym_LTtemplate_GT] = ACTIONS(1846),
    [anon_sym_GT] = ACTIONS(1844),
    [anon_sym_DOT] = ACTIONS(1844),
    [anon_sym_DQUOTE] = ACTIONS(1846),
    [anon_sym_SQUOTE] = ACTIONS(1846),
    [anon_sym_class] = ACTIONS(1842),
    [anon_sym_async] = ACTIONS(1842),
    [anon_sym_function] = ACTIONS(1842),
    [anon_sym_QMARK_DOT] = ACTIONS(1848),
    [anon_sym_new] = ACTIONS(1842),
    [anon_sym_using] = ACTIONS(1842),
    [anon_sym_AMP_AMP] = ACTIONS(1848),
    [anon_sym_PIPE_PIPE] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1844),
    [anon_sym_GT_GT_GT] = ACTIONS(1848),
    [anon_sym_LT_LT] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(1844),
    [anon_sym_CARET] = ACTIONS(1848),
    [anon_sym_PIPE] = ACTIONS(1844),
    [anon_sym_PLUS] = ACTIONS(1842),
    [anon_sym_DASH] = ACTIONS(1842),
    [anon_sym_SLASH] = ACTIONS(1842),
    [anon_sym_PERCENT] = ACTIONS(1848),
    [anon_sym_STAR_STAR] = ACTIONS(1848),
    [anon_sym_LT] = ACTIONS(1842),
    [anon_sym_LT_EQ] = ACTIONS(1848),
    [anon_sym_EQ_EQ] = ACTIONS(1844),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1848),
    [anon_sym_BANG_EQ] = ACTIONS(1844),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1848),
    [anon_sym_GT_EQ] = ACTIONS(1848),
    [anon_sym_QMARK_QMARK] = ACTIONS(1848),
    [anon_sym_instanceof] = ACTIONS(1844),
    [anon_sym_TILDE] = ACTIONS(1846),
    [anon_sym_void] = ACTIONS(1842),
    [anon_sym_delete] = ACTIONS(1842),
    [anon_sym_PLUS_PLUS] = ACTIONS(1846),
    [anon_sym_DASH_DASH] = ACTIONS(1846),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1846),
    [sym_number] = ACTIONS(1846),
    [sym_private_property_identifier] = ACTIONS(1846),
    [sym_this] = ACTIONS(1842),
    [sym_super] = ACTIONS(1842),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [sym_null] = ACTIONS(1842),
    [sym_undefined] = ACTIONS(1842),
    [anon_sym_AT] = ACTIONS(1846),
    [anon_sym_static] = ACTIONS(1842),
    [anon_sym_readonly] = ACTIONS(1842),
    [anon_sym_get] = ACTIONS(1842),
    [anon_sym_set] = ACTIONS(1842),
    [anon_sym_declare] = ACTIONS(1842),
    [anon_sym_public] = ACTIONS(1842),
    [anon_sym_private] = ACTIONS(1842),
    [anon_sym_protected] = ACTIONS(1842),
    [anon_sym_override] = ACTIONS(1842),
    [anon_sym_module] = ACTIONS(1842),
    [anon_sym_any] = ACTIONS(1842),
    [anon_sym_number] = ACTIONS(1842),
    [anon_sym_boolean] = ACTIONS(1842),
    [anon_sym_string] = ACTIONS(1842),
    [anon_sym_symbol] = ACTIONS(1842),
    [anon_sym_object] = ACTIONS(1842),
    [anon_sym_property] = ACTIONS(1842),
    [anon_sym_signal] = ACTIONS(1842),
    [anon_sym_on] = ACTIONS(1842),
    [anon_sym_required] = ACTIONS(1842),
    [anon_sym_component] = ACTIONS(1842),
    [anon_sym_abstract] = ACTIONS(1842),
    [anon_sym_satisfies] = ACTIONS(1844),
    [anon_sym_interface] = ACTIONS(1842),
    [anon_sym_enum] = ACTIONS(1842),
    [sym__automatic_semicolon] = ACTIONS(1848),
    [sym__ternary_qmark] = ACTIONS(1848),
    [sym_html_comment] = ACTIONS(5),
  },
  [232] = {
    [sym_comment] = STATE(232),
    [sym_identifier] = ACTIONS(1850),
    [anon_sym_export] = ACTIONS(1850),
    [anon_sym_STAR] = ACTIONS(1850),
    [anon_sym_default] = ACTIONS(1850),
    [anon_sym_type] = ACTIONS(1850),
    [anon_sym_as] = ACTIONS(1850),
    [anon_sym_namespace] = ACTIONS(1850),
    [anon_sym_LBRACE] = ACTIONS(1852),
    [anon_sym_COMMA] = ACTIONS(1852),
    [anon_sym_RBRACE] = ACTIONS(1852),
    [anon_sym_typeof] = ACTIONS(1850),
    [anon_sym_import] = ACTIONS(1850),
    [anon_sym_from] = ACTIONS(1850),
    [anon_sym_with] = ACTIONS(1850),
    [anon_sym_var] = ACTIONS(1850),
    [anon_sym_let] = ACTIONS(1850),
    [anon_sym_const] = ACTIONS(1850),
    [anon_sym_BANG] = ACTIONS(1850),
    [anon_sym_else] = ACTIONS(1850),
    [anon_sym_if] = ACTIONS(1850),
    [anon_sym_switch] = ACTIONS(1850),
    [anon_sym_for] = ACTIONS(1850),
    [anon_sym_LPAREN] = ACTIONS(1852),
    [anon_sym_await] = ACTIONS(1850),
    [anon_sym_in] = ACTIONS(1850),
    [anon_sym_of] = ACTIONS(1850),
    [anon_sym_while] = ACTIONS(1850),
    [anon_sym_do] = ACTIONS(1850),
    [anon_sym_try] = ACTIONS(1850),
    [anon_sym_break] = ACTIONS(1850),
    [anon_sym_continue] = ACTIONS(1850),
    [anon_sym_debugger] = ACTIONS(1850),
    [anon_sym_return] = ACTIONS(1850),
    [anon_sym_throw] = ACTIONS(1850),
    [anon_sym_SEMI] = ACTIONS(1852),
    [anon_sym_case] = ACTIONS(1850),
    [anon_sym_yield] = ACTIONS(1850),
    [anon_sym_LBRACK] = ACTIONS(1852),
    [anon_sym_LTtemplate_GT] = ACTIONS(1852),
    [anon_sym_GT] = ACTIONS(1850),
    [anon_sym_DOT] = ACTIONS(1850),
    [anon_sym_DQUOTE] = ACTIONS(1852),
    [anon_sym_SQUOTE] = ACTIONS(1852),
    [anon_sym_class] = ACTIONS(1850),
    [anon_sym_async] = ACTIONS(1850),
    [anon_sym_function] = ACTIONS(1850),
    [anon_sym_QMARK_DOT] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1850),
    [anon_sym_using] = ACTIONS(1850),
    [anon_sym_AMP_AMP] = ACTIONS(1852),
    [anon_sym_PIPE_PIPE] = ACTIONS(1852),
    [anon_sym_GT_GT] = ACTIONS(1850),
    [anon_sym_GT_GT_GT] = ACTIONS(1852),
    [anon_sym_LT_LT] = ACTIONS(1852),
    [anon_sym_AMP] = ACTIONS(1850),
    [anon_sym_CARET] = ACTIONS(1852),
    [anon_sym_PIPE] = ACTIONS(1850),
    [anon_sym_PLUS] = ACTIONS(1850),
    [anon_sym_DASH] = ACTIONS(1850),
    [anon_sym_SLASH] = ACTIONS(1850),
    [anon_sym_PERCENT] = ACTIONS(1852),
    [anon_sym_STAR_STAR] = ACTIONS(1852),
    [anon_sym_LT] = ACTIONS(1850),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_EQ_EQ] = ACTIONS(1850),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1852),
    [anon_sym_BANG_EQ] = ACTIONS(1850),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_QMARK_QMARK] = ACTIONS(1852),
    [anon_sym_instanceof] = ACTIONS(1850),
    [anon_sym_TILDE] = ACTIONS(1852),
    [anon_sym_void] = ACTIONS(1850),
    [anon_sym_delete] = ACTIONS(1850),
    [anon_sym_PLUS_PLUS] = ACTIONS(1852),
    [anon_sym_DASH_DASH] = ACTIONS(1852),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1852),
    [sym_number] = ACTIONS(1852),
    [sym_private_property_identifier] = ACTIONS(1852),
    [sym_this] = ACTIONS(1850),
    [sym_super] = ACTIONS(1850),
    [sym_true] = ACTIONS(1850),
    [sym_false] = ACTIONS(1850),
    [sym_null] = ACTIONS(1850),
    [sym_undefined] = ACTIONS(1850),
    [anon_sym_AT] = ACTIONS(1852),
    [anon_sym_static] = ACTIONS(1850),
    [anon_sym_readonly] = ACTIONS(1850),
    [anon_sym_get] = ACTIONS(1850),
    [anon_sym_set] = ACTIONS(1850),
    [anon_sym_declare] = ACTIONS(1850),
    [anon_sym_public] = ACTIONS(1850),
    [anon_sym_private] = ACTIONS(1850),
    [anon_sym_protected] = ACTIONS(1850),
    [anon_sym_override] = ACTIONS(1850),
    [anon_sym_module] = ACTIONS(1850),
    [anon_sym_any] = ACTIONS(1850),
    [anon_sym_number] = ACTIONS(1850),
    [anon_sym_boolean] = ACTIONS(1850),
    [anon_sym_string] = ACTIONS(1850),
    [anon_sym_symbol] = ACTIONS(1850),
    [anon_sym_object] = ACTIONS(1850),
    [anon_sym_property] = ACTIONS(1850),
    [anon_sym_signal] = ACTIONS(1850),
    [anon_sym_on] = ACTIONS(1850),
    [anon_sym_required] = ACTIONS(1850),
    [anon_sym_component] = ACTIONS(1850),
    [anon_sym_abstract] = ACTIONS(1850),
    [anon_sym_satisfies] = ACTIONS(1850),
    [anon_sym_interface] = ACTIONS(1850),
    [anon_sym_enum] = ACTIONS(1850),
    [sym__automatic_semicolon] = ACTIONS(1852),
    [sym__ternary_qmark] = ACTIONS(1852),
    [sym_html_comment] = ACTIONS(5),
  },
  [233] = {
    [sym_comment] = STATE(233),
    [sym_identifier] = ACTIONS(1854),
    [anon_sym_export] = ACTIONS(1854),
    [anon_sym_STAR] = ACTIONS(1854),
    [anon_sym_default] = ACTIONS(1854),
    [anon_sym_type] = ACTIONS(1854),
    [anon_sym_as] = ACTIONS(1854),
    [anon_sym_namespace] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [anon_sym_COMMA] = ACTIONS(1856),
    [anon_sym_RBRACE] = ACTIONS(1856),
    [anon_sym_typeof] = ACTIONS(1854),
    [anon_sym_import] = ACTIONS(1854),
    [anon_sym_from] = ACTIONS(1854),
    [anon_sym_with] = ACTIONS(1854),
    [anon_sym_var] = ACTIONS(1854),
    [anon_sym_let] = ACTIONS(1854),
    [anon_sym_const] = ACTIONS(1854),
    [anon_sym_BANG] = ACTIONS(1854),
    [anon_sym_else] = ACTIONS(1854),
    [anon_sym_if] = ACTIONS(1854),
    [anon_sym_switch] = ACTIONS(1854),
    [anon_sym_for] = ACTIONS(1854),
    [anon_sym_LPAREN] = ACTIONS(1856),
    [anon_sym_await] = ACTIONS(1854),
    [anon_sym_in] = ACTIONS(1854),
    [anon_sym_of] = ACTIONS(1854),
    [anon_sym_while] = ACTIONS(1854),
    [anon_sym_do] = ACTIONS(1854),
    [anon_sym_try] = ACTIONS(1854),
    [anon_sym_break] = ACTIONS(1854),
    [anon_sym_continue] = ACTIONS(1854),
    [anon_sym_debugger] = ACTIONS(1854),
    [anon_sym_return] = ACTIONS(1854),
    [anon_sym_throw] = ACTIONS(1854),
    [anon_sym_SEMI] = ACTIONS(1856),
    [anon_sym_case] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1854),
    [anon_sym_LBRACK] = ACTIONS(1856),
    [anon_sym_LTtemplate_GT] = ACTIONS(1856),
    [anon_sym_GT] = ACTIONS(1854),
    [anon_sym_DOT] = ACTIONS(1854),
    [anon_sym_DQUOTE] = ACTIONS(1856),
    [anon_sym_SQUOTE] = ACTIONS(1856),
    [anon_sym_class] = ACTIONS(1854),
    [anon_sym_async] = ACTIONS(1854),
    [anon_sym_function] = ACTIONS(1854),
    [anon_sym_QMARK_DOT] = ACTIONS(1856),
    [anon_sym_new] = ACTIONS(1854),
    [anon_sym_using] = ACTIONS(1854),
    [anon_sym_AMP_AMP] = ACTIONS(1856),
    [anon_sym_PIPE_PIPE] = ACTIONS(1856),
    [anon_sym_GT_GT] = ACTIONS(1854),
    [anon_sym_GT_GT_GT] = ACTIONS(1856),
    [anon_sym_LT_LT] = ACTIONS(1856),
    [anon_sym_AMP] = ACTIONS(1854),
    [anon_sym_CARET] = ACTIONS(1856),
    [anon_sym_PIPE] = ACTIONS(1854),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_DASH] = ACTIONS(1854),
    [anon_sym_SLASH] = ACTIONS(1854),
    [anon_sym_PERCENT] = ACTIONS(1856),
    [anon_sym_STAR_STAR] = ACTIONS(1856),
    [anon_sym_LT] = ACTIONS(1854),
    [anon_sym_LT_EQ] = ACTIONS(1856),
    [anon_sym_EQ_EQ] = ACTIONS(1854),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1856),
    [anon_sym_BANG_EQ] = ACTIONS(1854),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1856),
    [anon_sym_GT_EQ] = ACTIONS(1856),
    [anon_sym_QMARK_QMARK] = ACTIONS(1856),
    [anon_sym_instanceof] = ACTIONS(1854),
    [anon_sym_TILDE] = ACTIONS(1856),
    [anon_sym_void] = ACTIONS(1854),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_PLUS_PLUS] = ACTIONS(1856),
    [anon_sym_DASH_DASH] = ACTIONS(1856),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1856),
    [sym_number] = ACTIONS(1856),
    [sym_private_property_identifier] = ACTIONS(1856),
    [sym_this] = ACTIONS(1854),
    [sym_super] = ACTIONS(1854),
    [sym_true] = ACTIONS(1854),
    [sym_false] = ACTIONS(1854),
    [sym_null] = ACTIONS(1854),
    [sym_undefined] = ACTIONS(1854),
    [anon_sym_AT] = ACTIONS(1856),
    [anon_sym_static] = ACTIONS(1854),
    [anon_sym_readonly] = ACTIONS(1854),
    [anon_sym_get] = ACTIONS(1854),
    [anon_sym_set] = ACTIONS(1854),
    [anon_sym_declare] = ACTIONS(1854),
    [anon_sym_public] = ACTIONS(1854),
    [anon_sym_private] = ACTIONS(1854),
    [anon_sym_protected] = ACTIONS(1854),
    [anon_sym_override] = ACTIONS(1854),
    [anon_sym_module] = ACTIONS(1854),
    [anon_sym_any] = ACTIONS(1854),
    [anon_sym_number] = ACTIONS(1854),
    [anon_sym_boolean] = ACTIONS(1854),
    [anon_sym_string] = ACTIONS(1854),
    [anon_sym_symbol] = ACTIONS(1854),
    [anon_sym_object] = ACTIONS(1854),
    [anon_sym_property] = ACTIONS(1854),
    [anon_sym_signal] = ACTIONS(1854),
    [anon_sym_on] = ACTIONS(1854),
    [anon_sym_required] = ACTIONS(1854),
    [anon_sym_component] = ACTIONS(1854),
    [anon_sym_abstract] = ACTIONS(1854),
    [anon_sym_satisfies] = ACTIONS(1854),
    [anon_sym_interface] = ACTIONS(1854),
    [anon_sym_enum] = ACTIONS(1854),
    [sym__automatic_semicolon] = ACTIONS(1856),
    [sym__ternary_qmark] = ACTIONS(1856),
    [sym_html_comment] = ACTIONS(5),
  },
  [234] = {
    [sym_comment] = STATE(234),
    [sym_identifier] = ACTIONS(1858),
    [anon_sym_export] = ACTIONS(1858),
    [anon_sym_STAR] = ACTIONS(1858),
    [anon_sym_default] = ACTIONS(1858),
    [anon_sym_type] = ACTIONS(1858),
    [anon_sym_as] = ACTIONS(1858),
    [anon_sym_namespace] = ACTIONS(1858),
    [anon_sym_LBRACE] = ACTIONS(1860),
    [anon_sym_COMMA] = ACTIONS(1860),
    [anon_sym_RBRACE] = ACTIONS(1860),
    [anon_sym_typeof] = ACTIONS(1858),
    [anon_sym_import] = ACTIONS(1858),
    [anon_sym_from] = ACTIONS(1858),
    [anon_sym_with] = ACTIONS(1858),
    [anon_sym_var] = ACTIONS(1858),
    [anon_sym_let] = ACTIONS(1858),
    [anon_sym_const] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(1858),
    [anon_sym_else] = ACTIONS(1858),
    [anon_sym_if] = ACTIONS(1858),
    [anon_sym_switch] = ACTIONS(1858),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_LPAREN] = ACTIONS(1860),
    [anon_sym_await] = ACTIONS(1858),
    [anon_sym_in] = ACTIONS(1858),
    [anon_sym_of] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1858),
    [anon_sym_do] = ACTIONS(1858),
    [anon_sym_try] = ACTIONS(1858),
    [anon_sym_break] = ACTIONS(1858),
    [anon_sym_continue] = ACTIONS(1858),
    [anon_sym_debugger] = ACTIONS(1858),
    [anon_sym_return] = ACTIONS(1858),
    [anon_sym_throw] = ACTIONS(1858),
    [anon_sym_SEMI] = ACTIONS(1860),
    [anon_sym_case] = ACTIONS(1858),
    [anon_sym_yield] = ACTIONS(1858),
    [anon_sym_LBRACK] = ACTIONS(1860),
    [anon_sym_LTtemplate_GT] = ACTIONS(1860),
    [anon_sym_GT] = ACTIONS(1858),
    [anon_sym_DOT] = ACTIONS(1858),
    [anon_sym_DQUOTE] = ACTIONS(1860),
    [anon_sym_SQUOTE] = ACTIONS(1860),
    [anon_sym_class] = ACTIONS(1858),
    [anon_sym_async] = ACTIONS(1858),
    [anon_sym_function] = ACTIONS(1858),
    [anon_sym_QMARK_DOT] = ACTIONS(1860),
    [anon_sym_new] = ACTIONS(1858),
    [anon_sym_using] = ACTIONS(1858),
    [anon_sym_AMP_AMP] = ACTIONS(1860),
    [anon_sym_PIPE_PIPE] = ACTIONS(1860),
    [anon_sym_GT_GT] = ACTIONS(1858),
    [anon_sym_GT_GT_GT] = ACTIONS(1860),
    [anon_sym_LT_LT] = ACTIONS(1860),
    [anon_sym_AMP] = ACTIONS(1858),
    [anon_sym_CARET] = ACTIONS(1860),
    [anon_sym_PIPE] = ACTIONS(1858),
    [anon_sym_PLUS] = ACTIONS(1858),
    [anon_sym_DASH] = ACTIONS(1858),
    [anon_sym_SLASH] = ACTIONS(1858),
    [anon_sym_PERCENT] = ACTIONS(1860),
    [anon_sym_STAR_STAR] = ACTIONS(1860),
    [anon_sym_LT] = ACTIONS(1858),
    [anon_sym_LT_EQ] = ACTIONS(1860),
    [anon_sym_EQ_EQ] = ACTIONS(1858),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1860),
    [anon_sym_BANG_EQ] = ACTIONS(1858),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1860),
    [anon_sym_GT_EQ] = ACTIONS(1860),
    [anon_sym_QMARK_QMARK] = ACTIONS(1860),
    [anon_sym_instanceof] = ACTIONS(1858),
    [anon_sym_TILDE] = ACTIONS(1860),
    [anon_sym_void] = ACTIONS(1858),
    [anon_sym_delete] = ACTIONS(1858),
    [anon_sym_PLUS_PLUS] = ACTIONS(1860),
    [anon_sym_DASH_DASH] = ACTIONS(1860),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1860),
    [sym_number] = ACTIONS(1860),
    [sym_private_property_identifier] = ACTIONS(1860),
    [sym_this] = ACTIONS(1858),
    [sym_super] = ACTIONS(1858),
    [sym_true] = ACTIONS(1858),
    [sym_false] = ACTIONS(1858),
    [sym_null] = ACTIONS(1858),
    [sym_undefined] = ACTIONS(1858),
    [anon_sym_AT] = ACTIONS(1860),
    [anon_sym_static] = ACTIONS(1858),
    [anon_sym_readonly] = ACTIONS(1858),
    [anon_sym_get] = ACTIONS(1858),
    [anon_sym_set] = ACTIONS(1858),
    [anon_sym_declare] = ACTIONS(1858),
    [anon_sym_public] = ACTIONS(1858),
    [anon_sym_private] = ACTIONS(1858),
    [anon_sym_protected] = ACTIONS(1858),
    [anon_sym_override] = ACTIONS(1858),
    [anon_sym_module] = ACTIONS(1858),
    [anon_sym_any] = ACTIONS(1858),
    [anon_sym_number] = ACTIONS(1858),
    [anon_sym_boolean] = ACTIONS(1858),
    [anon_sym_string] = ACTIONS(1858),
    [anon_sym_symbol] = ACTIONS(1858),
    [anon_sym_object] = ACTIONS(1858),
    [anon_sym_property] = ACTIONS(1858),
    [anon_sym_signal] = ACTIONS(1858),
    [anon_sym_on] = ACTIONS(1858),
    [anon_sym_required] = ACTIONS(1858),
    [anon_sym_component] = ACTIONS(1858),
    [anon_sym_abstract] = ACTIONS(1858),
    [anon_sym_satisfies] = ACTIONS(1858),
    [anon_sym_interface] = ACTIONS(1858),
    [anon_sym_enum] = ACTIONS(1858),
    [sym__automatic_semicolon] = ACTIONS(1860),
    [sym__ternary_qmark] = ACTIONS(1860),
    [sym_html_comment] = ACTIONS(5),
  },
  [235] = {
    [sym_comment] = STATE(235),
    [sym_identifier] = ACTIONS(1862),
    [anon_sym_export] = ACTIONS(1862),
    [anon_sym_STAR] = ACTIONS(1864),
    [anon_sym_default] = ACTIONS(1862),
    [anon_sym_type] = ACTIONS(1862),
    [anon_sym_as] = ACTIONS(1864),
    [anon_sym_namespace] = ACTIONS(1862),
    [anon_sym_LBRACE] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(1868),
    [anon_sym_RBRACE] = ACTIONS(1866),
    [anon_sym_typeof] = ACTIONS(1862),
    [anon_sym_import] = ACTIONS(1862),
    [anon_sym_from] = ACTIONS(1862),
    [anon_sym_with] = ACTIONS(1862),
    [anon_sym_var] = ACTIONS(1862),
    [anon_sym_let] = ACTIONS(1862),
    [anon_sym_const] = ACTIONS(1862),
    [anon_sym_BANG] = ACTIONS(1862),
    [anon_sym_else] = ACTIONS(1862),
    [anon_sym_if] = ACTIONS(1862),
    [anon_sym_switch] = ACTIONS(1862),
    [anon_sym_for] = ACTIONS(1862),
    [anon_sym_LPAREN] = ACTIONS(1866),
    [anon_sym_await] = ACTIONS(1862),
    [anon_sym_in] = ACTIONS(1864),
    [anon_sym_of] = ACTIONS(1862),
    [anon_sym_while] = ACTIONS(1862),
    [anon_sym_do] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1862),
    [anon_sym_break] = ACTIONS(1862),
    [anon_sym_continue] = ACTIONS(1862),
    [anon_sym_debugger] = ACTIONS(1862),
    [anon_sym_return] = ACTIONS(1862),
    [anon_sym_throw] = ACTIONS(1862),
    [anon_sym_SEMI] = ACTIONS(1866),
    [anon_sym_case] = ACTIONS(1862),
    [anon_sym_yield] = ACTIONS(1862),
    [anon_sym_LBRACK] = ACTIONS(1866),
    [anon_sym_LTtemplate_GT] = ACTIONS(1866),
    [anon_sym_GT] = ACTIONS(1864),
    [anon_sym_DOT] = ACTIONS(1864),
    [anon_sym_DQUOTE] = ACTIONS(1866),
    [anon_sym_SQUOTE] = ACTIONS(1866),
    [anon_sym_class] = ACTIONS(1862),
    [anon_sym_async] = ACTIONS(1862),
    [anon_sym_function] = ACTIONS(1862),
    [anon_sym_QMARK_DOT] = ACTIONS(1868),
    [anon_sym_new] = ACTIONS(1862),
    [anon_sym_using] = ACTIONS(1862),
    [anon_sym_AMP_AMP] = ACTIONS(1868),
    [anon_sym_PIPE_PIPE] = ACTIONS(1868),
    [anon_sym_GT_GT] = ACTIONS(1864),
    [anon_sym_GT_GT_GT] = ACTIONS(1868),
    [anon_sym_LT_LT] = ACTIONS(1868),
    [anon_sym_AMP] = ACTIONS(1864),
    [anon_sym_CARET] = ACTIONS(1868),
    [anon_sym_PIPE] = ACTIONS(1864),
    [anon_sym_PLUS] = ACTIONS(1862),
    [anon_sym_DASH] = ACTIONS(1862),
    [anon_sym_SLASH] = ACTIONS(1862),
    [anon_sym_PERCENT] = ACTIONS(1868),
    [anon_sym_STAR_STAR] = ACTIONS(1868),
    [anon_sym_LT] = ACTIONS(1862),
    [anon_sym_LT_EQ] = ACTIONS(1868),
    [anon_sym_EQ_EQ] = ACTIONS(1864),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1868),
    [anon_sym_BANG_EQ] = ACTIONS(1864),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1868),
    [anon_sym_GT_EQ] = ACTIONS(1868),
    [anon_sym_QMARK_QMARK] = ACTIONS(1868),
    [anon_sym_instanceof] = ACTIONS(1864),
    [anon_sym_TILDE] = ACTIONS(1866),
    [anon_sym_void] = ACTIONS(1862),
    [anon_sym_delete] = ACTIONS(1862),
    [anon_sym_PLUS_PLUS] = ACTIONS(1866),
    [anon_sym_DASH_DASH] = ACTIONS(1866),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1866),
    [sym_number] = ACTIONS(1866),
    [sym_private_property_identifier] = ACTIONS(1866),
    [sym_this] = ACTIONS(1862),
    [sym_super] = ACTIONS(1862),
    [sym_true] = ACTIONS(1862),
    [sym_false] = ACTIONS(1862),
    [sym_null] = ACTIONS(1862),
    [sym_undefined] = ACTIONS(1862),
    [anon_sym_AT] = ACTIONS(1866),
    [anon_sym_static] = ACTIONS(1862),
    [anon_sym_readonly] = ACTIONS(1862),
    [anon_sym_get] = ACTIONS(1862),
    [anon_sym_set] = ACTIONS(1862),
    [anon_sym_declare] = ACTIONS(1862),
    [anon_sym_public] = ACTIONS(1862),
    [anon_sym_private] = ACTIONS(1862),
    [anon_sym_protected] = ACTIONS(1862),
    [anon_sym_override] = ACTIONS(1862),
    [anon_sym_module] = ACTIONS(1862),
    [anon_sym_any] = ACTIONS(1862),
    [anon_sym_number] = ACTIONS(1862),
    [anon_sym_boolean] = ACTIONS(1862),
    [anon_sym_string] = ACTIONS(1862),
    [anon_sym_symbol] = ACTIONS(1862),
    [anon_sym_object] = ACTIONS(1862),
    [anon_sym_property] = ACTIONS(1862),
    [anon_sym_signal] = ACTIONS(1862),
    [anon_sym_on] = ACTIONS(1862),
    [anon_sym_required] = ACTIONS(1862),
    [anon_sym_component] = ACTIONS(1862),
    [anon_sym_abstract] = ACTIONS(1862),
    [anon_sym_satisfies] = ACTIONS(1864),
    [anon_sym_interface] = ACTIONS(1862),
    [anon_sym_enum] = ACTIONS(1862),
    [sym__automatic_semicolon] = ACTIONS(1870),
    [sym__ternary_qmark] = ACTIONS(1868),
    [sym_html_comment] = ACTIONS(5),
  },
  [236] = {
    [sym_comment] = STATE(236),
    [sym_identifier] = ACTIONS(1872),
    [anon_sym_export] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1872),
    [anon_sym_default] = ACTIONS(1872),
    [anon_sym_type] = ACTIONS(1872),
    [anon_sym_as] = ACTIONS(1872),
    [anon_sym_namespace] = ACTIONS(1872),
    [anon_sym_LBRACE] = ACTIONS(1874),
    [anon_sym_COMMA] = ACTIONS(1874),
    [anon_sym_RBRACE] = ACTIONS(1874),
    [anon_sym_typeof] = ACTIONS(1872),
    [anon_sym_import] = ACTIONS(1872),
    [anon_sym_from] = ACTIONS(1872),
    [anon_sym_with] = ACTIONS(1872),
    [anon_sym_var] = ACTIONS(1872),
    [anon_sym_let] = ACTIONS(1872),
    [anon_sym_const] = ACTIONS(1872),
    [anon_sym_BANG] = ACTIONS(1872),
    [anon_sym_else] = ACTIONS(1872),
    [anon_sym_if] = ACTIONS(1872),
    [anon_sym_switch] = ACTIONS(1872),
    [anon_sym_for] = ACTIONS(1872),
    [anon_sym_LPAREN] = ACTIONS(1874),
    [anon_sym_await] = ACTIONS(1872),
    [anon_sym_in] = ACTIONS(1872),
    [anon_sym_of] = ACTIONS(1872),
    [anon_sym_while] = ACTIONS(1872),
    [anon_sym_do] = ACTIONS(1872),
    [anon_sym_try] = ACTIONS(1872),
    [anon_sym_break] = ACTIONS(1872),
    [anon_sym_continue] = ACTIONS(1872),
    [anon_sym_debugger] = ACTIONS(1872),
    [anon_sym_return] = ACTIONS(1872),
    [anon_sym_throw] = ACTIONS(1872),
    [anon_sym_SEMI] = ACTIONS(1874),
    [anon_sym_case] = ACTIONS(1872),
    [anon_sym_yield] = ACTIONS(1872),
    [anon_sym_LBRACK] = ACTIONS(1874),
    [anon_sym_LTtemplate_GT] = ACTIONS(1874),
    [anon_sym_GT] = ACTIONS(1872),
    [anon_sym_DOT] = ACTIONS(1872),
    [anon_sym_DQUOTE] = ACTIONS(1874),
    [anon_sym_SQUOTE] = ACTIONS(1874),
    [anon_sym_class] = ACTIONS(1872),
    [anon_sym_async] = ACTIONS(1872),
    [anon_sym_function] = ACTIONS(1872),
    [anon_sym_QMARK_DOT] = ACTIONS(1874),
    [anon_sym_new] = ACTIONS(1872),
    [anon_sym_using] = ACTIONS(1872),
    [anon_sym_AMP_AMP] = ACTIONS(1874),
    [anon_sym_PIPE_PIPE] = ACTIONS(1874),
    [anon_sym_GT_GT] = ACTIONS(1872),
    [anon_sym_GT_GT_GT] = ACTIONS(1874),
    [anon_sym_LT_LT] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1872),
    [anon_sym_CARET] = ACTIONS(1874),
    [anon_sym_PIPE] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_SLASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1874),
    [anon_sym_STAR_STAR] = ACTIONS(1874),
    [anon_sym_LT] = ACTIONS(1872),
    [anon_sym_LT_EQ] = ACTIONS(1874),
    [anon_sym_EQ_EQ] = ACTIONS(1872),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1874),
    [anon_sym_BANG_EQ] = ACTIONS(1872),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1874),
    [anon_sym_GT_EQ] = ACTIONS(1874),
    [anon_sym_QMARK_QMARK] = ACTIONS(1874),
    [anon_sym_instanceof] = ACTIONS(1872),
    [anon_sym_TILDE] = ACTIONS(1874),
    [anon_sym_void] = ACTIONS(1872),
    [anon_sym_delete] = ACTIONS(1872),
    [anon_sym_PLUS_PLUS] = ACTIONS(1874),
    [anon_sym_DASH_DASH] = ACTIONS(1874),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1874),
    [sym_number] = ACTIONS(1874),
    [sym_private_property_identifier] = ACTIONS(1874),
    [sym_this] = ACTIONS(1872),
    [sym_super] = ACTIONS(1872),
    [sym_true] = ACTIONS(1872),
    [sym_false] = ACTIONS(1872),
    [sym_null] = ACTIONS(1872),
    [sym_undefined] = ACTIONS(1872),
    [anon_sym_AT] = ACTIONS(1874),
    [anon_sym_static] = ACTIONS(1872),
    [anon_sym_readonly] = ACTIONS(1872),
    [anon_sym_get] = ACTIONS(1872),
    [anon_sym_set] = ACTIONS(1872),
    [anon_sym_declare] = ACTIONS(1872),
    [anon_sym_public] = ACTIONS(1872),
    [anon_sym_private] = ACTIONS(1872),
    [anon_sym_protected] = ACTIONS(1872),
    [anon_sym_override] = ACTIONS(1872),
    [anon_sym_module] = ACTIONS(1872),
    [anon_sym_any] = ACTIONS(1872),
    [anon_sym_number] = ACTIONS(1872),
    [anon_sym_boolean] = ACTIONS(1872),
    [anon_sym_string] = ACTIONS(1872),
    [anon_sym_symbol] = ACTIONS(1872),
    [anon_sym_object] = ACTIONS(1872),
    [anon_sym_property] = ACTIONS(1872),
    [anon_sym_signal] = ACTIONS(1872),
    [anon_sym_on] = ACTIONS(1872),
    [anon_sym_required] = ACTIONS(1872),
    [anon_sym_component] = ACTIONS(1872),
    [anon_sym_abstract] = ACTIONS(1872),
    [anon_sym_satisfies] = ACTIONS(1872),
    [anon_sym_interface] = ACTIONS(1872),
    [anon_sym_enum] = ACTIONS(1872),
    [sym__automatic_semicolon] = ACTIONS(1874),
    [sym__ternary_qmark] = ACTIONS(1874),
    [sym_html_comment] = ACTIONS(5),
  },
  [237] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(237),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(3294),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_EQ] = ACTIONS(134),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_COLON] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(80),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(82),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(1771),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_void] = ACTIONS(130),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(118),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_satisfies] = ACTIONS(30),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [238] = {
    [sym_comment] = STATE(238),
    [sym_identifier] = ACTIONS(1876),
    [anon_sym_export] = ACTIONS(1876),
    [anon_sym_STAR] = ACTIONS(1878),
    [anon_sym_default] = ACTIONS(1876),
    [anon_sym_type] = ACTIONS(1876),
    [anon_sym_as] = ACTIONS(1878),
    [anon_sym_namespace] = ACTIONS(1876),
    [anon_sym_LBRACE] = ACTIONS(1880),
    [anon_sym_COMMA] = ACTIONS(1882),
    [anon_sym_RBRACE] = ACTIONS(1880),
    [anon_sym_typeof] = ACTIONS(1876),
    [anon_sym_import] = ACTIONS(1876),
    [anon_sym_from] = ACTIONS(1876),
    [anon_sym_with] = ACTIONS(1876),
    [anon_sym_var] = ACTIONS(1876),
    [anon_sym_let] = ACTIONS(1876),
    [anon_sym_const] = ACTIONS(1876),
    [anon_sym_BANG] = ACTIONS(1876),
    [anon_sym_else] = ACTIONS(1876),
    [anon_sym_if] = ACTIONS(1876),
    [anon_sym_switch] = ACTIONS(1876),
    [anon_sym_for] = ACTIONS(1876),
    [anon_sym_LPAREN] = ACTIONS(1880),
    [anon_sym_await] = ACTIONS(1876),
    [anon_sym_in] = ACTIONS(1878),
    [anon_sym_of] = ACTIONS(1876),
    [anon_sym_while] = ACTIONS(1876),
    [anon_sym_do] = ACTIONS(1876),
    [anon_sym_try] = ACTIONS(1876),
    [anon_sym_break] = ACTIONS(1876),
    [anon_sym_continue] = ACTIONS(1876),
    [anon_sym_debugger] = ACTIONS(1876),
    [anon_sym_return] = ACTIONS(1876),
    [anon_sym_throw] = ACTIONS(1876),
    [anon_sym_SEMI] = ACTIONS(1880),
    [anon_sym_case] = ACTIONS(1876),
    [anon_sym_yield] = ACTIONS(1876),
    [anon_sym_LBRACK] = ACTIONS(1880),
    [anon_sym_LTtemplate_GT] = ACTIONS(1880),
    [anon_sym_GT] = ACTIONS(1878),
    [anon_sym_DOT] = ACTIONS(1878),
    [anon_sym_DQUOTE] = ACTIONS(1880),
    [anon_sym_SQUOTE] = ACTIONS(1880),
    [anon_sym_class] = ACTIONS(1876),
    [anon_sym_async] = ACTIONS(1876),
    [anon_sym_function] = ACTIONS(1876),
    [anon_sym_QMARK_DOT] = ACTIONS(1882),
    [anon_sym_new] = ACTIONS(1876),
    [anon_sym_using] = ACTIONS(1876),
    [anon_sym_AMP_AMP] = ACTIONS(1882),
    [anon_sym_PIPE_PIPE] = ACTIONS(1882),
    [anon_sym_GT_GT] = ACTIONS(1878),
    [anon_sym_GT_GT_GT] = ACTIONS(1882),
    [anon_sym_LT_LT] = ACTIONS(1882),
    [anon_sym_AMP] = ACTIONS(1878),
    [anon_sym_CARET] = ACTIONS(1882),
    [anon_sym_PIPE] = ACTIONS(1878),
    [anon_sym_PLUS] = ACTIONS(1876),
    [anon_sym_DASH] = ACTIONS(1876),
    [anon_sym_SLASH] = ACTIONS(1876),
    [anon_sym_PERCENT] = ACTIONS(1882),
    [anon_sym_STAR_STAR] = ACTIONS(1882),
    [anon_sym_LT] = ACTIONS(1876),
    [anon_sym_LT_EQ] = ACTIONS(1882),
    [anon_sym_EQ_EQ] = ACTIONS(1878),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1882),
    [anon_sym_BANG_EQ] = ACTIONS(1878),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1882),
    [anon_sym_GT_EQ] = ACTIONS(1882),
    [anon_sym_QMARK_QMARK] = ACTIONS(1882),
    [anon_sym_instanceof] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1880),
    [anon_sym_void] = ACTIONS(1876),
    [anon_sym_delete] = ACTIONS(1876),
    [anon_sym_PLUS_PLUS] = ACTIONS(1880),
    [anon_sym_DASH_DASH] = ACTIONS(1880),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1880),
    [sym_number] = ACTIONS(1880),
    [sym_private_property_identifier] = ACTIONS(1880),
    [sym_this] = ACTIONS(1876),
    [sym_super] = ACTIONS(1876),
    [sym_true] = ACTIONS(1876),
    [sym_false] = ACTIONS(1876),
    [sym_null] = ACTIONS(1876),
    [sym_undefined] = ACTIONS(1876),
    [anon_sym_AT] = ACTIONS(1880),
    [anon_sym_static] = ACTIONS(1876),
    [anon_sym_readonly] = ACTIONS(1876),
    [anon_sym_get] = ACTIONS(1876),
    [anon_sym_set] = ACTIONS(1876),
    [anon_sym_declare] = ACTIONS(1876),
    [anon_sym_public] = ACTIONS(1876),
    [anon_sym_private] = ACTIONS(1876),
    [anon_sym_protected] = ACTIONS(1876),
    [anon_sym_override] = ACTIONS(1876),
    [anon_sym_module] = ACTIONS(1876),
    [anon_sym_any] = ACTIONS(1876),
    [anon_sym_number] = ACTIONS(1876),
    [anon_sym_boolean] = ACTIONS(1876),
    [anon_sym_string] = ACTIONS(1876),
    [anon_sym_symbol] = ACTIONS(1876),
    [anon_sym_object] = ACTIONS(1876),
    [anon_sym_property] = ACTIONS(1876),
    [anon_sym_signal] = ACTIONS(1876),
    [anon_sym_on] = ACTIONS(1876),
    [anon_sym_required] = ACTIONS(1876),
    [anon_sym_component] = ACTIONS(1876),
    [anon_sym_abstract] = ACTIONS(1876),
    [anon_sym_satisfies] = ACTIONS(1878),
    [anon_sym_interface] = ACTIONS(1876),
    [anon_sym_enum] = ACTIONS(1876),
    [sym__automatic_semicolon] = ACTIONS(1884),
    [sym__ternary_qmark] = ACTIONS(1882),
    [sym_html_comment] = ACTIONS(5),
  },
  [239] = {
    [sym_comment] = STATE(239),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_export] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(1888),
    [anon_sym_default] = ACTIONS(1886),
    [anon_sym_type] = ACTIONS(1886),
    [anon_sym_as] = ACTIONS(1888),
    [anon_sym_namespace] = ACTIONS(1886),
    [anon_sym_LBRACE] = ACTIONS(1890),
    [anon_sym_COMMA] = ACTIONS(1892),
    [anon_sym_RBRACE] = ACTIONS(1890),
    [anon_sym_typeof] = ACTIONS(1886),
    [anon_sym_import] = ACTIONS(1886),
    [anon_sym_from] = ACTIONS(1886),
    [anon_sym_with] = ACTIONS(1886),
    [anon_sym_var] = ACTIONS(1886),
    [anon_sym_let] = ACTIONS(1886),
    [anon_sym_const] = ACTIONS(1886),
    [anon_sym_BANG] = ACTIONS(1886),
    [anon_sym_else] = ACTIONS(1886),
    [anon_sym_if] = ACTIONS(1886),
    [anon_sym_switch] = ACTIONS(1886),
    [anon_sym_for] = ACTIONS(1886),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_await] = ACTIONS(1886),
    [anon_sym_in] = ACTIONS(1888),
    [anon_sym_of] = ACTIONS(1886),
    [anon_sym_while] = ACTIONS(1886),
    [anon_sym_do] = ACTIONS(1886),
    [anon_sym_try] = ACTIONS(1886),
    [anon_sym_break] = ACTIONS(1886),
    [anon_sym_continue] = ACTIONS(1886),
    [anon_sym_debugger] = ACTIONS(1886),
    [anon_sym_return] = ACTIONS(1886),
    [anon_sym_throw] = ACTIONS(1886),
    [anon_sym_SEMI] = ACTIONS(1890),
    [anon_sym_case] = ACTIONS(1886),
    [anon_sym_yield] = ACTIONS(1886),
    [anon_sym_LBRACK] = ACTIONS(1890),
    [anon_sym_LTtemplate_GT] = ACTIONS(1890),
    [anon_sym_GT] = ACTIONS(1888),
    [anon_sym_DOT] = ACTIONS(1888),
    [anon_sym_DQUOTE] = ACTIONS(1890),
    [anon_sym_SQUOTE] = ACTIONS(1890),
    [anon_sym_class] = ACTIONS(1886),
    [anon_sym_async] = ACTIONS(1886),
    [anon_sym_function] = ACTIONS(1886),
    [anon_sym_QMARK_DOT] = ACTIONS(1892),
    [anon_sym_new] = ACTIONS(1886),
    [anon_sym_using] = ACTIONS(1886),
    [anon_sym_AMP_AMP] = ACTIONS(1892),
    [anon_sym_PIPE_PIPE] = ACTIONS(1892),
    [anon_sym_GT_GT] = ACTIONS(1888),
    [anon_sym_GT_GT_GT] = ACTIONS(1892),
    [anon_sym_LT_LT] = ACTIONS(1892),
    [anon_sym_AMP] = ACTIONS(1888),
    [anon_sym_CARET] = ACTIONS(1892),
    [anon_sym_PIPE] = ACTIONS(1888),
    [anon_sym_PLUS] = ACTIONS(1886),
    [anon_sym_DASH] = ACTIONS(1886),
    [anon_sym_SLASH] = ACTIONS(1886),
    [anon_sym_PERCENT] = ACTIONS(1892),
    [anon_sym_STAR_STAR] = ACTIONS(1892),
    [anon_sym_LT] = ACTIONS(1886),
    [anon_sym_LT_EQ] = ACTIONS(1892),
    [anon_sym_EQ_EQ] = ACTIONS(1888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1892),
    [anon_sym_BANG_EQ] = ACTIONS(1888),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1892),
    [anon_sym_GT_EQ] = ACTIONS(1892),
    [anon_sym_QMARK_QMARK] = ACTIONS(1892),
    [anon_sym_instanceof] = ACTIONS(1888),
    [anon_sym_TILDE] = ACTIONS(1890),
    [anon_sym_void] = ACTIONS(1886),
    [anon_sym_delete] = ACTIONS(1886),
    [anon_sym_PLUS_PLUS] = ACTIONS(1890),
    [anon_sym_DASH_DASH] = ACTIONS(1890),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1890),
    [sym_number] = ACTIONS(1890),
    [sym_private_property_identifier] = ACTIONS(1890),
    [sym_this] = ACTIONS(1886),
    [sym_super] = ACTIONS(1886),
    [sym_true] = ACTIONS(1886),
    [sym_false] = ACTIONS(1886),
    [sym_null] = ACTIONS(1886),
    [sym_undefined] = ACTIONS(1886),
    [anon_sym_AT] = ACTIONS(1890),
    [anon_sym_static] = ACTIONS(1886),
    [anon_sym_readonly] = ACTIONS(1886),
    [anon_sym_get] = ACTIONS(1886),
    [anon_sym_set] = ACTIONS(1886),
    [anon_sym_declare] = ACTIONS(1886),
    [anon_sym_public] = ACTIONS(1886),
    [anon_sym_private] = ACTIONS(1886),
    [anon_sym_protected] = ACTIONS(1886),
    [anon_sym_override] = ACTIONS(1886),
    [anon_sym_module] = ACTIONS(1886),
    [anon_sym_any] = ACTIONS(1886),
    [anon_sym_number] = ACTIONS(1886),
    [anon_sym_boolean] = ACTIONS(1886),
    [anon_sym_string] = ACTIONS(1886),
    [anon_sym_symbol] = ACTIONS(1886),
    [anon_sym_object] = ACTIONS(1886),
    [anon_sym_property] = ACTIONS(1886),
    [anon_sym_signal] = ACTIONS(1886),
    [anon_sym_on] = ACTIONS(1886),
    [anon_sym_required] = ACTIONS(1886),
    [anon_sym_component] = ACTIONS(1886),
    [anon_sym_abstract] = ACTIONS(1886),
    [anon_sym_satisfies] = ACTIONS(1888),
    [anon_sym_interface] = ACTIONS(1886),
    [anon_sym_enum] = ACTIONS(1886),
    [sym__automatic_semicolon] = ACTIONS(1894),
    [sym__ternary_qmark] = ACTIONS(1892),
    [sym_html_comment] = ACTIONS(5),
  },
  [240] = {
    [sym_comment] = STATE(240),
    [sym_identifier] = ACTIONS(1896),
    [anon_sym_export] = ACTIONS(1896),
    [anon_sym_STAR] = ACTIONS(1896),
    [anon_sym_default] = ACTIONS(1896),
    [anon_sym_type] = ACTIONS(1896),
    [anon_sym_as] = ACTIONS(1896),
    [anon_sym_namespace] = ACTIONS(1896),
    [anon_sym_LBRACE] = ACTIONS(1898),
    [anon_sym_COMMA] = ACTIONS(1898),
    [anon_sym_RBRACE] = ACTIONS(1898),
    [anon_sym_typeof] = ACTIONS(1896),
    [anon_sym_import] = ACTIONS(1896),
    [anon_sym_from] = ACTIONS(1896),
    [anon_sym_with] = ACTIONS(1896),
    [anon_sym_var] = ACTIONS(1896),
    [anon_sym_let] = ACTIONS(1896),
    [anon_sym_const] = ACTIONS(1896),
    [anon_sym_BANG] = ACTIONS(1896),
    [anon_sym_else] = ACTIONS(1896),
    [anon_sym_if] = ACTIONS(1896),
    [anon_sym_switch] = ACTIONS(1896),
    [anon_sym_for] = ACTIONS(1896),
    [anon_sym_LPAREN] = ACTIONS(1898),
    [anon_sym_await] = ACTIONS(1896),
    [anon_sym_in] = ACTIONS(1896),
    [anon_sym_of] = ACTIONS(1896),
    [anon_sym_while] = ACTIONS(1896),
    [anon_sym_do] = ACTIONS(1896),
    [anon_sym_try] = ACTIONS(1896),
    [anon_sym_break] = ACTIONS(1896),
    [anon_sym_continue] = ACTIONS(1896),
    [anon_sym_debugger] = ACTIONS(1896),
    [anon_sym_return] = ACTIONS(1896),
    [anon_sym_throw] = ACTIONS(1896),
    [anon_sym_SEMI] = ACTIONS(1898),
    [anon_sym_case] = ACTIONS(1896),
    [anon_sym_yield] = ACTIONS(1896),
    [anon_sym_LBRACK] = ACTIONS(1898),
    [anon_sym_LTtemplate_GT] = ACTIONS(1898),
    [anon_sym_GT] = ACTIONS(1896),
    [anon_sym_DOT] = ACTIONS(1896),
    [anon_sym_DQUOTE] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1898),
    [anon_sym_class] = ACTIONS(1896),
    [anon_sym_async] = ACTIONS(1896),
    [anon_sym_function] = ACTIONS(1896),
    [anon_sym_QMARK_DOT] = ACTIONS(1898),
    [anon_sym_new] = ACTIONS(1896),
    [anon_sym_using] = ACTIONS(1896),
    [anon_sym_AMP_AMP] = ACTIONS(1898),
    [anon_sym_PIPE_PIPE] = ACTIONS(1898),
    [anon_sym_GT_GT] = ACTIONS(1896),
    [anon_sym_GT_GT_GT] = ACTIONS(1898),
    [anon_sym_LT_LT] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(1896),
    [anon_sym_CARET] = ACTIONS(1898),
    [anon_sym_PIPE] = ACTIONS(1896),
    [anon_sym_PLUS] = ACTIONS(1896),
    [anon_sym_DASH] = ACTIONS(1896),
    [anon_sym_SLASH] = ACTIONS(1896),
    [anon_sym_PERCENT] = ACTIONS(1898),
    [anon_sym_STAR_STAR] = ACTIONS(1898),
    [anon_sym_LT] = ACTIONS(1896),
    [anon_sym_LT_EQ] = ACTIONS(1898),
    [anon_sym_EQ_EQ] = ACTIONS(1896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1898),
    [anon_sym_BANG_EQ] = ACTIONS(1896),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1898),
    [anon_sym_GT_EQ] = ACTIONS(1898),
    [anon_sym_QMARK_QMARK] = ACTIONS(1898),
    [anon_sym_instanceof] = ACTIONS(1896),
    [anon_sym_TILDE] = ACTIONS(1898),
    [anon_sym_void] = ACTIONS(1896),
    [anon_sym_delete] = ACTIONS(1896),
    [anon_sym_PLUS_PLUS] = ACTIONS(1898),
    [anon_sym_DASH_DASH] = ACTIONS(1898),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1898),
    [sym_number] = ACTIONS(1898),
    [sym_private_property_identifier] = ACTIONS(1898),
    [sym_this] = ACTIONS(1896),
    [sym_super] = ACTIONS(1896),
    [sym_true] = ACTIONS(1896),
    [sym_false] = ACTIONS(1896),
    [sym_null] = ACTIONS(1896),
    [sym_undefined] = ACTIONS(1896),
    [anon_sym_AT] = ACTIONS(1898),
    [anon_sym_static] = ACTIONS(1896),
    [anon_sym_readonly] = ACTIONS(1896),
    [anon_sym_get] = ACTIONS(1896),
    [anon_sym_set] = ACTIONS(1896),
    [anon_sym_declare] = ACTIONS(1896),
    [anon_sym_public] = ACTIONS(1896),
    [anon_sym_private] = ACTIONS(1896),
    [anon_sym_protected] = ACTIONS(1896),
    [anon_sym_override] = ACTIONS(1896),
    [anon_sym_module] = ACTIONS(1896),
    [anon_sym_any] = ACTIONS(1896),
    [anon_sym_number] = ACTIONS(1896),
    [anon_sym_boolean] = ACTIONS(1896),
    [anon_sym_string] = ACTIONS(1896),
    [anon_sym_symbol] = ACTIONS(1896),
    [anon_sym_object] = ACTIONS(1896),
    [anon_sym_property] = ACTIONS(1896),
    [anon_sym_signal] = ACTIONS(1896),
    [anon_sym_on] = ACTIONS(1896),
    [anon_sym_required] = ACTIONS(1896),
    [anon_sym_component] = ACTIONS(1896),
    [anon_sym_abstract] = ACTIONS(1896),
    [anon_sym_satisfies] = ACTIONS(1896),
    [anon_sym_interface] = ACTIONS(1896),
    [anon_sym_enum] = ACTIONS(1896),
    [sym__automatic_semicolon] = ACTIONS(1898),
    [sym__ternary_qmark] = ACTIONS(1898),
    [sym_html_comment] = ACTIONS(5),
  },
  [241] = {
    [sym_comment] = STATE(241),
    [sym_identifier] = ACTIONS(1854),
    [anon_sym_export] = ACTIONS(1854),
    [anon_sym_STAR] = ACTIONS(1854),
    [anon_sym_default] = ACTIONS(1854),
    [anon_sym_type] = ACTIONS(1854),
    [anon_sym_as] = ACTIONS(1854),
    [anon_sym_namespace] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [anon_sym_COMMA] = ACTIONS(1856),
    [anon_sym_RBRACE] = ACTIONS(1856),
    [anon_sym_typeof] = ACTIONS(1854),
    [anon_sym_import] = ACTIONS(1854),
    [anon_sym_from] = ACTIONS(1854),
    [anon_sym_with] = ACTIONS(1854),
    [anon_sym_var] = ACTIONS(1854),
    [anon_sym_let] = ACTIONS(1854),
    [anon_sym_const] = ACTIONS(1854),
    [anon_sym_BANG] = ACTIONS(1854),
    [anon_sym_else] = ACTIONS(1854),
    [anon_sym_if] = ACTIONS(1854),
    [anon_sym_switch] = ACTIONS(1854),
    [anon_sym_for] = ACTIONS(1854),
    [anon_sym_LPAREN] = ACTIONS(1856),
    [anon_sym_await] = ACTIONS(1854),
    [anon_sym_in] = ACTIONS(1854),
    [anon_sym_of] = ACTIONS(1854),
    [anon_sym_while] = ACTIONS(1854),
    [anon_sym_do] = ACTIONS(1854),
    [anon_sym_try] = ACTIONS(1854),
    [anon_sym_break] = ACTIONS(1854),
    [anon_sym_continue] = ACTIONS(1854),
    [anon_sym_debugger] = ACTIONS(1854),
    [anon_sym_return] = ACTIONS(1854),
    [anon_sym_throw] = ACTIONS(1854),
    [anon_sym_SEMI] = ACTIONS(1856),
    [anon_sym_case] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1854),
    [anon_sym_LBRACK] = ACTIONS(1856),
    [anon_sym_LTtemplate_GT] = ACTIONS(1856),
    [anon_sym_GT] = ACTIONS(1854),
    [anon_sym_DOT] = ACTIONS(1854),
    [anon_sym_DQUOTE] = ACTIONS(1856),
    [anon_sym_SQUOTE] = ACTIONS(1856),
    [anon_sym_class] = ACTIONS(1854),
    [anon_sym_async] = ACTIONS(1854),
    [anon_sym_function] = ACTIONS(1854),
    [anon_sym_QMARK_DOT] = ACTIONS(1856),
    [anon_sym_new] = ACTIONS(1854),
    [anon_sym_using] = ACTIONS(1854),
    [anon_sym_AMP_AMP] = ACTIONS(1856),
    [anon_sym_PIPE_PIPE] = ACTIONS(1856),
    [anon_sym_GT_GT] = ACTIONS(1854),
    [anon_sym_GT_GT_GT] = ACTIONS(1856),
    [anon_sym_LT_LT] = ACTIONS(1856),
    [anon_sym_AMP] = ACTIONS(1854),
    [anon_sym_CARET] = ACTIONS(1856),
    [anon_sym_PIPE] = ACTIONS(1854),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_DASH] = ACTIONS(1854),
    [anon_sym_SLASH] = ACTIONS(1854),
    [anon_sym_PERCENT] = ACTIONS(1856),
    [anon_sym_STAR_STAR] = ACTIONS(1856),
    [anon_sym_LT] = ACTIONS(1854),
    [anon_sym_LT_EQ] = ACTIONS(1856),
    [anon_sym_EQ_EQ] = ACTIONS(1854),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1856),
    [anon_sym_BANG_EQ] = ACTIONS(1854),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1856),
    [anon_sym_GT_EQ] = ACTIONS(1856),
    [anon_sym_QMARK_QMARK] = ACTIONS(1856),
    [anon_sym_instanceof] = ACTIONS(1854),
    [anon_sym_TILDE] = ACTIONS(1856),
    [anon_sym_void] = ACTIONS(1854),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_PLUS_PLUS] = ACTIONS(1856),
    [anon_sym_DASH_DASH] = ACTIONS(1856),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1856),
    [sym_number] = ACTIONS(1856),
    [sym_private_property_identifier] = ACTIONS(1856),
    [sym_this] = ACTIONS(1854),
    [sym_super] = ACTIONS(1854),
    [sym_true] = ACTIONS(1854),
    [sym_false] = ACTIONS(1854),
    [sym_null] = ACTIONS(1854),
    [sym_undefined] = ACTIONS(1854),
    [anon_sym_AT] = ACTIONS(1856),
    [anon_sym_static] = ACTIONS(1854),
    [anon_sym_readonly] = ACTIONS(1854),
    [anon_sym_get] = ACTIONS(1854),
    [anon_sym_set] = ACTIONS(1854),
    [anon_sym_declare] = ACTIONS(1854),
    [anon_sym_public] = ACTIONS(1854),
    [anon_sym_private] = ACTIONS(1854),
    [anon_sym_protected] = ACTIONS(1854),
    [anon_sym_override] = ACTIONS(1854),
    [anon_sym_module] = ACTIONS(1854),
    [anon_sym_any] = ACTIONS(1854),
    [anon_sym_number] = ACTIONS(1854),
    [anon_sym_boolean] = ACTIONS(1854),
    [anon_sym_string] = ACTIONS(1854),
    [anon_sym_symbol] = ACTIONS(1854),
    [anon_sym_object] = ACTIONS(1854),
    [anon_sym_property] = ACTIONS(1854),
    [anon_sym_signal] = ACTIONS(1854),
    [anon_sym_on] = ACTIONS(1854),
    [anon_sym_required] = ACTIONS(1854),
    [anon_sym_component] = ACTIONS(1854),
    [anon_sym_abstract] = ACTIONS(1854),
    [anon_sym_satisfies] = ACTIONS(1854),
    [anon_sym_interface] = ACTIONS(1854),
    [anon_sym_enum] = ACTIONS(1854),
    [sym__automatic_semicolon] = ACTIONS(1900),
    [sym__ternary_qmark] = ACTIONS(1856),
    [sym_html_comment] = ACTIONS(5),
  },
  [242] = {
    [sym_comment] = STATE(242),
    [sym_identifier] = ACTIONS(1902),
    [anon_sym_export] = ACTIONS(1902),
    [anon_sym_STAR] = ACTIONS(1902),
    [anon_sym_default] = ACTIONS(1902),
    [anon_sym_type] = ACTIONS(1902),
    [anon_sym_as] = ACTIONS(1902),
    [anon_sym_namespace] = ACTIONS(1902),
    [anon_sym_LBRACE] = ACTIONS(1904),
    [anon_sym_COMMA] = ACTIONS(1904),
    [anon_sym_RBRACE] = ACTIONS(1904),
    [anon_sym_typeof] = ACTIONS(1902),
    [anon_sym_import] = ACTIONS(1902),
    [anon_sym_from] = ACTIONS(1902),
    [anon_sym_with] = ACTIONS(1902),
    [anon_sym_var] = ACTIONS(1902),
    [anon_sym_let] = ACTIONS(1902),
    [anon_sym_const] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1902),
    [anon_sym_else] = ACTIONS(1902),
    [anon_sym_if] = ACTIONS(1902),
    [anon_sym_switch] = ACTIONS(1902),
    [anon_sym_for] = ACTIONS(1902),
    [anon_sym_LPAREN] = ACTIONS(1904),
    [anon_sym_await] = ACTIONS(1902),
    [anon_sym_in] = ACTIONS(1902),
    [anon_sym_of] = ACTIONS(1902),
    [anon_sym_while] = ACTIONS(1902),
    [anon_sym_do] = ACTIONS(1902),
    [anon_sym_try] = ACTIONS(1902),
    [anon_sym_break] = ACTIONS(1902),
    [anon_sym_continue] = ACTIONS(1902),
    [anon_sym_debugger] = ACTIONS(1902),
    [anon_sym_return] = ACTIONS(1902),
    [anon_sym_throw] = ACTIONS(1902),
    [anon_sym_SEMI] = ACTIONS(1904),
    [anon_sym_case] = ACTIONS(1902),
    [anon_sym_yield] = ACTIONS(1902),
    [anon_sym_LBRACK] = ACTIONS(1904),
    [anon_sym_LTtemplate_GT] = ACTIONS(1904),
    [anon_sym_GT] = ACTIONS(1902),
    [anon_sym_DOT] = ACTIONS(1902),
    [anon_sym_DQUOTE] = ACTIONS(1904),
    [anon_sym_SQUOTE] = ACTIONS(1904),
    [anon_sym_class] = ACTIONS(1902),
    [anon_sym_async] = ACTIONS(1902),
    [anon_sym_function] = ACTIONS(1902),
    [anon_sym_QMARK_DOT] = ACTIONS(1904),
    [anon_sym_new] = ACTIONS(1902),
    [anon_sym_using] = ACTIONS(1902),
    [anon_sym_AMP_AMP] = ACTIONS(1904),
    [anon_sym_PIPE_PIPE] = ACTIONS(1904),
    [anon_sym_GT_GT] = ACTIONS(1902),
    [anon_sym_GT_GT_GT] = ACTIONS(1904),
    [anon_sym_LT_LT] = ACTIONS(1904),
    [anon_sym_AMP] = ACTIONS(1902),
    [anon_sym_CARET] = ACTIONS(1904),
    [anon_sym_PIPE] = ACTIONS(1902),
    [anon_sym_PLUS] = ACTIONS(1902),
    [anon_sym_DASH] = ACTIONS(1902),
    [anon_sym_SLASH] = ACTIONS(1902),
    [anon_sym_PERCENT] = ACTIONS(1904),
    [anon_sym_STAR_STAR] = ACTIONS(1904),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_LT_EQ] = ACTIONS(1904),
    [anon_sym_EQ_EQ] = ACTIONS(1902),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1904),
    [anon_sym_BANG_EQ] = ACTIONS(1902),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1904),
    [anon_sym_GT_EQ] = ACTIONS(1904),
    [anon_sym_QMARK_QMARK] = ACTIONS(1904),
    [anon_sym_instanceof] = ACTIONS(1902),
    [anon_sym_TILDE] = ACTIONS(1904),
    [anon_sym_void] = ACTIONS(1902),
    [anon_sym_delete] = ACTIONS(1902),
    [anon_sym_PLUS_PLUS] = ACTIONS(1904),
    [anon_sym_DASH_DASH] = ACTIONS(1904),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1904),
    [sym_private_property_identifier] = ACTIONS(1904),
    [sym_this] = ACTIONS(1902),
    [sym_super] = ACTIONS(1902),
    [sym_true] = ACTIONS(1902),
    [sym_false] = ACTIONS(1902),
    [sym_null] = ACTIONS(1902),
    [sym_undefined] = ACTIONS(1902),
    [anon_sym_AT] = ACTIONS(1904),
    [anon_sym_static] = ACTIONS(1902),
    [anon_sym_readonly] = ACTIONS(1902),
    [anon_sym_get] = ACTIONS(1902),
    [anon_sym_set] = ACTIONS(1902),
    [anon_sym_declare] = ACTIONS(1902),
    [anon_sym_public] = ACTIONS(1902),
    [anon_sym_private] = ACTIONS(1902),
    [anon_sym_protected] = ACTIONS(1902),
    [anon_sym_override] = ACTIONS(1902),
    [anon_sym_module] = ACTIONS(1902),
    [anon_sym_any] = ACTIONS(1902),
    [anon_sym_number] = ACTIONS(1902),
    [anon_sym_boolean] = ACTIONS(1902),
    [anon_sym_string] = ACTIONS(1902),
    [anon_sym_symbol] = ACTIONS(1902),
    [anon_sym_object] = ACTIONS(1902),
    [anon_sym_property] = ACTIONS(1902),
    [anon_sym_signal] = ACTIONS(1902),
    [anon_sym_on] = ACTIONS(1902),
    [anon_sym_required] = ACTIONS(1902),
    [anon_sym_component] = ACTIONS(1902),
    [anon_sym_abstract] = ACTIONS(1902),
    [anon_sym_satisfies] = ACTIONS(1902),
    [anon_sym_interface] = ACTIONS(1902),
    [anon_sym_enum] = ACTIONS(1902),
    [sym__automatic_semicolon] = ACTIONS(1904),
    [sym__ternary_qmark] = ACTIONS(1904),
    [sym_html_comment] = ACTIONS(5),
  },
  [243] = {
    [sym_comment] = STATE(243),
    [sym_identifier] = ACTIONS(1906),
    [anon_sym_export] = ACTIONS(1906),
    [anon_sym_STAR] = ACTIONS(1908),
    [anon_sym_default] = ACTIONS(1906),
    [anon_sym_type] = ACTIONS(1906),
    [anon_sym_as] = ACTIONS(1908),
    [anon_sym_namespace] = ACTIONS(1906),
    [anon_sym_LBRACE] = ACTIONS(1910),
    [anon_sym_COMMA] = ACTIONS(1912),
    [anon_sym_RBRACE] = ACTIONS(1910),
    [anon_sym_typeof] = ACTIONS(1906),
    [anon_sym_import] = ACTIONS(1906),
    [anon_sym_from] = ACTIONS(1906),
    [anon_sym_with] = ACTIONS(1906),
    [anon_sym_var] = ACTIONS(1906),
    [anon_sym_let] = ACTIONS(1906),
    [anon_sym_const] = ACTIONS(1906),
    [anon_sym_BANG] = ACTIONS(1906),
    [anon_sym_else] = ACTIONS(1906),
    [anon_sym_if] = ACTIONS(1906),
    [anon_sym_switch] = ACTIONS(1906),
    [anon_sym_for] = ACTIONS(1906),
    [anon_sym_LPAREN] = ACTIONS(1910),
    [anon_sym_await] = ACTIONS(1906),
    [anon_sym_in] = ACTIONS(1908),
    [anon_sym_of] = ACTIONS(1906),
    [anon_sym_while] = ACTIONS(1906),
    [anon_sym_do] = ACTIONS(1906),
    [anon_sym_try] = ACTIONS(1906),
    [anon_sym_break] = ACTIONS(1906),
    [anon_sym_continue] = ACTIONS(1906),
    [anon_sym_debugger] = ACTIONS(1906),
    [anon_sym_return] = ACTIONS(1906),
    [anon_sym_throw] = ACTIONS(1906),
    [anon_sym_SEMI] = ACTIONS(1910),
    [anon_sym_case] = ACTIONS(1906),
    [anon_sym_yield] = ACTIONS(1906),
    [anon_sym_LBRACK] = ACTIONS(1910),
    [anon_sym_LTtemplate_GT] = ACTIONS(1910),
    [anon_sym_GT] = ACTIONS(1908),
    [anon_sym_DOT] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(1910),
    [anon_sym_SQUOTE] = ACTIONS(1910),
    [anon_sym_class] = ACTIONS(1906),
    [anon_sym_async] = ACTIONS(1906),
    [anon_sym_function] = ACTIONS(1906),
    [anon_sym_QMARK_DOT] = ACTIONS(1912),
    [anon_sym_new] = ACTIONS(1906),
    [anon_sym_using] = ACTIONS(1906),
    [anon_sym_AMP_AMP] = ACTIONS(1912),
    [anon_sym_PIPE_PIPE] = ACTIONS(1912),
    [anon_sym_GT_GT] = ACTIONS(1908),
    [anon_sym_GT_GT_GT] = ACTIONS(1912),
    [anon_sym_LT_LT] = ACTIONS(1912),
    [anon_sym_AMP] = ACTIONS(1908),
    [anon_sym_CARET] = ACTIONS(1912),
    [anon_sym_PIPE] = ACTIONS(1908),
    [anon_sym_PLUS] = ACTIONS(1906),
    [anon_sym_DASH] = ACTIONS(1906),
    [anon_sym_SLASH] = ACTIONS(1906),
    [anon_sym_PERCENT] = ACTIONS(1912),
    [anon_sym_STAR_STAR] = ACTIONS(1912),
    [anon_sym_LT] = ACTIONS(1906),
    [anon_sym_LT_EQ] = ACTIONS(1912),
    [anon_sym_EQ_EQ] = ACTIONS(1908),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1912),
    [anon_sym_BANG_EQ] = ACTIONS(1908),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1912),
    [anon_sym_GT_EQ] = ACTIONS(1912),
    [anon_sym_QMARK_QMARK] = ACTIONS(1912),
    [anon_sym_instanceof] = ACTIONS(1908),
    [anon_sym_TILDE] = ACTIONS(1910),
    [anon_sym_void] = ACTIONS(1906),
    [anon_sym_delete] = ACTIONS(1906),
    [anon_sym_PLUS_PLUS] = ACTIONS(1910),
    [anon_sym_DASH_DASH] = ACTIONS(1910),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1910),
    [sym_number] = ACTIONS(1910),
    [sym_private_property_identifier] = ACTIONS(1910),
    [sym_this] = ACTIONS(1906),
    [sym_super] = ACTIONS(1906),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_AT] = ACTIONS(1910),
    [anon_sym_static] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1906),
    [anon_sym_get] = ACTIONS(1906),
    [anon_sym_set] = ACTIONS(1906),
    [anon_sym_declare] = ACTIONS(1906),
    [anon_sym_public] = ACTIONS(1906),
    [anon_sym_private] = ACTIONS(1906),
    [anon_sym_protected] = ACTIONS(1906),
    [anon_sym_override] = ACTIONS(1906),
    [anon_sym_module] = ACTIONS(1906),
    [anon_sym_any] = ACTIONS(1906),
    [anon_sym_number] = ACTIONS(1906),
    [anon_sym_boolean] = ACTIONS(1906),
    [anon_sym_string] = ACTIONS(1906),
    [anon_sym_symbol] = ACTIONS(1906),
    [anon_sym_object] = ACTIONS(1906),
    [anon_sym_property] = ACTIONS(1906),
    [anon_sym_signal] = ACTIONS(1906),
    [anon_sym_on] = ACTIONS(1906),
    [anon_sym_required] = ACTIONS(1906),
    [anon_sym_component] = ACTIONS(1906),
    [anon_sym_abstract] = ACTIONS(1906),
    [anon_sym_satisfies] = ACTIONS(1908),
    [anon_sym_interface] = ACTIONS(1906),
    [anon_sym_enum] = ACTIONS(1906),
    [sym__automatic_semicolon] = ACTIONS(1914),
    [sym__ternary_qmark] = ACTIONS(1912),
    [sym_html_comment] = ACTIONS(5),
  },
  [244] = {
    [sym_comment] = STATE(244),
    [sym_identifier] = ACTIONS(1916),
    [anon_sym_export] = ACTIONS(1916),
    [anon_sym_STAR] = ACTIONS(1918),
    [anon_sym_default] = ACTIONS(1916),
    [anon_sym_type] = ACTIONS(1916),
    [anon_sym_as] = ACTIONS(1918),
    [anon_sym_namespace] = ACTIONS(1916),
    [anon_sym_LBRACE] = ACTIONS(1920),
    [anon_sym_COMMA] = ACTIONS(1922),
    [anon_sym_RBRACE] = ACTIONS(1920),
    [anon_sym_typeof] = ACTIONS(1916),
    [anon_sym_import] = ACTIONS(1916),
    [anon_sym_from] = ACTIONS(1916),
    [anon_sym_with] = ACTIONS(1916),
    [anon_sym_var] = ACTIONS(1916),
    [anon_sym_let] = ACTIONS(1916),
    [anon_sym_const] = ACTIONS(1916),
    [anon_sym_BANG] = ACTIONS(1916),
    [anon_sym_else] = ACTIONS(1916),
    [anon_sym_if] = ACTIONS(1916),
    [anon_sym_switch] = ACTIONS(1916),
    [anon_sym_for] = ACTIONS(1916),
    [anon_sym_LPAREN] = ACTIONS(1920),
    [anon_sym_await] = ACTIONS(1916),
    [anon_sym_in] = ACTIONS(1918),
    [anon_sym_of] = ACTIONS(1916),
    [anon_sym_while] = ACTIONS(1916),
    [anon_sym_do] = ACTIONS(1916),
    [anon_sym_try] = ACTIONS(1916),
    [anon_sym_break] = ACTIONS(1916),
    [anon_sym_continue] = ACTIONS(1916),
    [anon_sym_debugger] = ACTIONS(1916),
    [anon_sym_return] = ACTIONS(1916),
    [anon_sym_throw] = ACTIONS(1916),
    [anon_sym_SEMI] = ACTIONS(1920),
    [anon_sym_case] = ACTIONS(1916),
    [anon_sym_yield] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1920),
    [anon_sym_LTtemplate_GT] = ACTIONS(1920),
    [anon_sym_GT] = ACTIONS(1918),
    [anon_sym_DOT] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1920),
    [anon_sym_class] = ACTIONS(1916),
    [anon_sym_async] = ACTIONS(1916),
    [anon_sym_function] = ACTIONS(1916),
    [anon_sym_QMARK_DOT] = ACTIONS(1922),
    [anon_sym_new] = ACTIONS(1916),
    [anon_sym_using] = ACTIONS(1916),
    [anon_sym_AMP_AMP] = ACTIONS(1922),
    [anon_sym_PIPE_PIPE] = ACTIONS(1922),
    [anon_sym_GT_GT] = ACTIONS(1918),
    [anon_sym_GT_GT_GT] = ACTIONS(1922),
    [anon_sym_LT_LT] = ACTIONS(1922),
    [anon_sym_AMP] = ACTIONS(1918),
    [anon_sym_CARET] = ACTIONS(1922),
    [anon_sym_PIPE] = ACTIONS(1918),
    [anon_sym_PLUS] = ACTIONS(1916),
    [anon_sym_DASH] = ACTIONS(1916),
    [anon_sym_SLASH] = ACTIONS(1916),
    [anon_sym_PERCENT] = ACTIONS(1922),
    [anon_sym_STAR_STAR] = ACTIONS(1922),
    [anon_sym_LT] = ACTIONS(1916),
    [anon_sym_LT_EQ] = ACTIONS(1922),
    [anon_sym_EQ_EQ] = ACTIONS(1918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1922),
    [anon_sym_BANG_EQ] = ACTIONS(1918),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1922),
    [anon_sym_GT_EQ] = ACTIONS(1922),
    [anon_sym_QMARK_QMARK] = ACTIONS(1922),
    [anon_sym_instanceof] = ACTIONS(1918),
    [anon_sym_TILDE] = ACTIONS(1920),
    [anon_sym_void] = ACTIONS(1916),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_PLUS_PLUS] = ACTIONS(1920),
    [anon_sym_DASH_DASH] = ACTIONS(1920),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1920),
    [sym_number] = ACTIONS(1920),
    [sym_private_property_identifier] = ACTIONS(1920),
    [sym_this] = ACTIONS(1916),
    [sym_super] = ACTIONS(1916),
    [sym_true] = ACTIONS(1916),
    [sym_false] = ACTIONS(1916),
    [sym_null] = ACTIONS(1916),
    [sym_undefined] = ACTIONS(1916),
    [anon_sym_AT] = ACTIONS(1920),
    [anon_sym_static] = ACTIONS(1916),
    [anon_sym_readonly] = ACTIONS(1916),
    [anon_sym_get] = ACTIONS(1916),
    [anon_sym_set] = ACTIONS(1916),
    [anon_sym_declare] = ACTIONS(1916),
    [anon_sym_public] = ACTIONS(1916),
    [anon_sym_private] = ACTIONS(1916),
    [anon_sym_protected] = ACTIONS(1916),
    [anon_sym_override] = ACTIONS(1916),
    [anon_sym_module] = ACTIONS(1916),
    [anon_sym_any] = ACTIONS(1916),
    [anon_sym_number] = ACTIONS(1916),
    [anon_sym_boolean] = ACTIONS(1916),
    [anon_sym_string] = ACTIONS(1916),
    [anon_sym_symbol] = ACTIONS(1916),
    [anon_sym_object] = ACTIONS(1916),
    [anon_sym_property] = ACTIONS(1916),
    [anon_sym_signal] = ACTIONS(1916),
    [anon_sym_on] = ACTIONS(1916),
    [anon_sym_required] = ACTIONS(1916),
    [anon_sym_component] = ACTIONS(1916),
    [anon_sym_abstract] = ACTIONS(1916),
    [anon_sym_satisfies] = ACTIONS(1918),
    [anon_sym_interface] = ACTIONS(1916),
    [anon_sym_enum] = ACTIONS(1916),
    [sym__automatic_semicolon] = ACTIONS(1924),
    [sym__ternary_qmark] = ACTIONS(1922),
    [sym_html_comment] = ACTIONS(5),
  },
  [245] = {
    [sym_comment] = STATE(245),
    [sym_identifier] = ACTIONS(1926),
    [anon_sym_export] = ACTIONS(1926),
    [anon_sym_STAR] = ACTIONS(1926),
    [anon_sym_default] = ACTIONS(1926),
    [anon_sym_type] = ACTIONS(1926),
    [anon_sym_as] = ACTIONS(1926),
    [anon_sym_namespace] = ACTIONS(1926),
    [anon_sym_LBRACE] = ACTIONS(1928),
    [anon_sym_COMMA] = ACTIONS(1928),
    [anon_sym_RBRACE] = ACTIONS(1928),
    [anon_sym_typeof] = ACTIONS(1926),
    [anon_sym_import] = ACTIONS(1926),
    [anon_sym_from] = ACTIONS(1926),
    [anon_sym_with] = ACTIONS(1926),
    [anon_sym_var] = ACTIONS(1926),
    [anon_sym_let] = ACTIONS(1926),
    [anon_sym_const] = ACTIONS(1926),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_else] = ACTIONS(1926),
    [anon_sym_if] = ACTIONS(1926),
    [anon_sym_switch] = ACTIONS(1926),
    [anon_sym_for] = ACTIONS(1926),
    [anon_sym_LPAREN] = ACTIONS(1928),
    [anon_sym_await] = ACTIONS(1926),
    [anon_sym_in] = ACTIONS(1926),
    [anon_sym_of] = ACTIONS(1926),
    [anon_sym_while] = ACTIONS(1926),
    [anon_sym_do] = ACTIONS(1926),
    [anon_sym_try] = ACTIONS(1926),
    [anon_sym_break] = ACTIONS(1926),
    [anon_sym_continue] = ACTIONS(1926),
    [anon_sym_debugger] = ACTIONS(1926),
    [anon_sym_return] = ACTIONS(1926),
    [anon_sym_throw] = ACTIONS(1926),
    [anon_sym_SEMI] = ACTIONS(1928),
    [anon_sym_case] = ACTIONS(1926),
    [anon_sym_yield] = ACTIONS(1926),
    [anon_sym_LBRACK] = ACTIONS(1928),
    [anon_sym_LTtemplate_GT] = ACTIONS(1928),
    [anon_sym_GT] = ACTIONS(1926),
    [anon_sym_DOT] = ACTIONS(1926),
    [anon_sym_DQUOTE] = ACTIONS(1928),
    [anon_sym_SQUOTE] = ACTIONS(1928),
    [anon_sym_class] = ACTIONS(1926),
    [anon_sym_async] = ACTIONS(1926),
    [anon_sym_function] = ACTIONS(1926),
    [anon_sym_QMARK_DOT] = ACTIONS(1928),
    [anon_sym_new] = ACTIONS(1926),
    [anon_sym_using] = ACTIONS(1926),
    [anon_sym_AMP_AMP] = ACTIONS(1928),
    [anon_sym_PIPE_PIPE] = ACTIONS(1928),
    [anon_sym_GT_GT] = ACTIONS(1926),
    [anon_sym_GT_GT_GT] = ACTIONS(1928),
    [anon_sym_LT_LT] = ACTIONS(1928),
    [anon_sym_AMP] = ACTIONS(1926),
    [anon_sym_CARET] = ACTIONS(1928),
    [anon_sym_PIPE] = ACTIONS(1926),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_SLASH] = ACTIONS(1926),
    [anon_sym_PERCENT] = ACTIONS(1928),
    [anon_sym_STAR_STAR] = ACTIONS(1928),
    [anon_sym_LT] = ACTIONS(1926),
    [anon_sym_LT_EQ] = ACTIONS(1928),
    [anon_sym_EQ_EQ] = ACTIONS(1926),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1928),
    [anon_sym_BANG_EQ] = ACTIONS(1926),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1928),
    [anon_sym_GT_EQ] = ACTIONS(1928),
    [anon_sym_QMARK_QMARK] = ACTIONS(1928),
    [anon_sym_instanceof] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1928),
    [anon_sym_void] = ACTIONS(1926),
    [anon_sym_delete] = ACTIONS(1926),
    [anon_sym_PLUS_PLUS] = ACTIONS(1928),
    [anon_sym_DASH_DASH] = ACTIONS(1928),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1928),
    [sym_private_property_identifier] = ACTIONS(1928),
    [sym_this] = ACTIONS(1926),
    [sym_super] = ACTIONS(1926),
    [sym_true] = ACTIONS(1926),
    [sym_false] = ACTIONS(1926),
    [sym_null] = ACTIONS(1926),
    [sym_undefined] = ACTIONS(1926),
    [anon_sym_AT] = ACTIONS(1928),
    [anon_sym_static] = ACTIONS(1926),
    [anon_sym_readonly] = ACTIONS(1926),
    [anon_sym_get] = ACTIONS(1926),
    [anon_sym_set] = ACTIONS(1926),
    [anon_sym_declare] = ACTIONS(1926),
    [anon_sym_public] = ACTIONS(1926),
    [anon_sym_private] = ACTIONS(1926),
    [anon_sym_protected] = ACTIONS(1926),
    [anon_sym_override] = ACTIONS(1926),
    [anon_sym_module] = ACTIONS(1926),
    [anon_sym_any] = ACTIONS(1926),
    [anon_sym_number] = ACTIONS(1926),
    [anon_sym_boolean] = ACTIONS(1926),
    [anon_sym_string] = ACTIONS(1926),
    [anon_sym_symbol] = ACTIONS(1926),
    [anon_sym_object] = ACTIONS(1926),
    [anon_sym_property] = ACTIONS(1926),
    [anon_sym_signal] = ACTIONS(1926),
    [anon_sym_on] = ACTIONS(1926),
    [anon_sym_required] = ACTIONS(1926),
    [anon_sym_component] = ACTIONS(1926),
    [anon_sym_abstract] = ACTIONS(1926),
    [anon_sym_satisfies] = ACTIONS(1926),
    [anon_sym_interface] = ACTIONS(1926),
    [anon_sym_enum] = ACTIONS(1926),
    [sym__automatic_semicolon] = ACTIONS(1928),
    [sym__ternary_qmark] = ACTIONS(1928),
    [sym_html_comment] = ACTIONS(5),
  },
  [246] = {
    [sym_comment] = STATE(246),
    [sym_identifier] = ACTIONS(1930),
    [anon_sym_export] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(1932),
    [anon_sym_default] = ACTIONS(1930),
    [anon_sym_type] = ACTIONS(1930),
    [anon_sym_as] = ACTIONS(1932),
    [anon_sym_namespace] = ACTIONS(1930),
    [anon_sym_LBRACE] = ACTIONS(1934),
    [anon_sym_COMMA] = ACTIONS(1936),
    [anon_sym_RBRACE] = ACTIONS(1934),
    [anon_sym_typeof] = ACTIONS(1930),
    [anon_sym_import] = ACTIONS(1930),
    [anon_sym_from] = ACTIONS(1930),
    [anon_sym_with] = ACTIONS(1930),
    [anon_sym_var] = ACTIONS(1930),
    [anon_sym_let] = ACTIONS(1930),
    [anon_sym_const] = ACTIONS(1930),
    [anon_sym_BANG] = ACTIONS(1930),
    [anon_sym_else] = ACTIONS(1930),
    [anon_sym_if] = ACTIONS(1930),
    [anon_sym_switch] = ACTIONS(1930),
    [anon_sym_for] = ACTIONS(1930),
    [anon_sym_LPAREN] = ACTIONS(1934),
    [anon_sym_await] = ACTIONS(1930),
    [anon_sym_in] = ACTIONS(1932),
    [anon_sym_of] = ACTIONS(1930),
    [anon_sym_while] = ACTIONS(1930),
    [anon_sym_do] = ACTIONS(1930),
    [anon_sym_try] = ACTIONS(1930),
    [anon_sym_break] = ACTIONS(1930),
    [anon_sym_continue] = ACTIONS(1930),
    [anon_sym_debugger] = ACTIONS(1930),
    [anon_sym_return] = ACTIONS(1930),
    [anon_sym_throw] = ACTIONS(1930),
    [anon_sym_SEMI] = ACTIONS(1934),
    [anon_sym_case] = ACTIONS(1930),
    [anon_sym_yield] = ACTIONS(1930),
    [anon_sym_LBRACK] = ACTIONS(1934),
    [anon_sym_LTtemplate_GT] = ACTIONS(1934),
    [anon_sym_GT] = ACTIONS(1932),
    [anon_sym_DOT] = ACTIONS(1932),
    [anon_sym_DQUOTE] = ACTIONS(1934),
    [anon_sym_SQUOTE] = ACTIONS(1934),
    [anon_sym_class] = ACTIONS(1930),
    [anon_sym_async] = ACTIONS(1930),
    [anon_sym_function] = ACTIONS(1930),
    [anon_sym_QMARK_DOT] = ACTIONS(1936),
    [anon_sym_new] = ACTIONS(1930),
    [anon_sym_using] = ACTIONS(1930),
    [anon_sym_AMP_AMP] = ACTIONS(1936),
    [anon_sym_PIPE_PIPE] = ACTIONS(1936),
    [anon_sym_GT_GT] = ACTIONS(1932),
    [anon_sym_GT_GT_GT] = ACTIONS(1936),
    [anon_sym_LT_LT] = ACTIONS(1936),
    [anon_sym_AMP] = ACTIONS(1932),
    [anon_sym_CARET] = ACTIONS(1936),
    [anon_sym_PIPE] = ACTIONS(1932),
    [anon_sym_PLUS] = ACTIONS(1930),
    [anon_sym_DASH] = ACTIONS(1930),
    [anon_sym_SLASH] = ACTIONS(1930),
    [anon_sym_PERCENT] = ACTIONS(1936),
    [anon_sym_STAR_STAR] = ACTIONS(1936),
    [anon_sym_LT] = ACTIONS(1930),
    [anon_sym_LT_EQ] = ACTIONS(1936),
    [anon_sym_EQ_EQ] = ACTIONS(1932),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1936),
    [anon_sym_BANG_EQ] = ACTIONS(1932),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1936),
    [anon_sym_GT_EQ] = ACTIONS(1936),
    [anon_sym_QMARK_QMARK] = ACTIONS(1936),
    [anon_sym_instanceof] = ACTIONS(1932),
    [anon_sym_TILDE] = ACTIONS(1934),
    [anon_sym_void] = ACTIONS(1930),
    [anon_sym_delete] = ACTIONS(1930),
    [anon_sym_PLUS_PLUS] = ACTIONS(1934),
    [anon_sym_DASH_DASH] = ACTIONS(1934),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1934),
    [sym_number] = ACTIONS(1934),
    [sym_private_property_identifier] = ACTIONS(1934),
    [sym_this] = ACTIONS(1930),
    [sym_super] = ACTIONS(1930),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_AT] = ACTIONS(1934),
    [anon_sym_static] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1930),
    [anon_sym_get] = ACTIONS(1930),
    [anon_sym_set] = ACTIONS(1930),
    [anon_sym_declare] = ACTIONS(1930),
    [anon_sym_public] = ACTIONS(1930),
    [anon_sym_private] = ACTIONS(1930),
    [anon_sym_protected] = ACTIONS(1930),
    [anon_sym_override] = ACTIONS(1930),
    [anon_sym_module] = ACTIONS(1930),
    [anon_sym_any] = ACTIONS(1930),
    [anon_sym_number] = ACTIONS(1930),
    [anon_sym_boolean] = ACTIONS(1930),
    [anon_sym_string] = ACTIONS(1930),
    [anon_sym_symbol] = ACTIONS(1930),
    [anon_sym_object] = ACTIONS(1930),
    [anon_sym_property] = ACTIONS(1930),
    [anon_sym_signal] = ACTIONS(1930),
    [anon_sym_on] = ACTIONS(1930),
    [anon_sym_required] = ACTIONS(1930),
    [anon_sym_component] = ACTIONS(1930),
    [anon_sym_abstract] = ACTIONS(1930),
    [anon_sym_satisfies] = ACTIONS(1932),
    [anon_sym_interface] = ACTIONS(1930),
    [anon_sym_enum] = ACTIONS(1930),
    [sym__automatic_semicolon] = ACTIONS(1938),
    [sym__ternary_qmark] = ACTIONS(1936),
    [sym_html_comment] = ACTIONS(5),
  },
  [247] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_assignment_pattern] = STATE(5554),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3951),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(247),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(5291),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(799),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_namespace] = ACTIONS(32),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_COMMA] = ACTIONS(1940),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(23),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_RBRACK] = ACTIONS(1940),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(64),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(809),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(821),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(23),
    [anon_sym_readonly] = ACTIONS(23),
    [anon_sym_get] = ACTIONS(23),
    [anon_sym_set] = ACTIONS(23),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_public] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(23),
    [anon_sym_protected] = ACTIONS(23),
    [anon_sym_override] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(23),
    [anon_sym_number] = ACTIONS(23),
    [anon_sym_boolean] = ACTIONS(23),
    [anon_sym_string] = ACTIONS(23),
    [anon_sym_symbol] = ACTIONS(23),
    [anon_sym_object] = ACTIONS(23),
    [anon_sym_property] = ACTIONS(23),
    [anon_sym_signal] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [anon_sym_required] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(23),
    [sym_html_comment] = ACTIONS(5),
  },
  [248] = {
    [sym_comment] = STATE(248),
    [sym_identifier] = ACTIONS(1792),
    [anon_sym_export] = ACTIONS(1792),
    [anon_sym_STAR] = ACTIONS(1792),
    [anon_sym_default] = ACTIONS(1792),
    [anon_sym_type] = ACTIONS(1792),
    [anon_sym_as] = ACTIONS(1792),
    [anon_sym_namespace] = ACTIONS(1792),
    [anon_sym_LBRACE] = ACTIONS(1798),
    [anon_sym_COMMA] = ACTIONS(1798),
    [anon_sym_RBRACE] = ACTIONS(1798),
    [anon_sym_typeof] = ACTIONS(1792),
    [anon_sym_import] = ACTIONS(1792),
    [anon_sym_from] = ACTIONS(1792),
    [anon_sym_with] = ACTIONS(1792),
    [anon_sym_var] = ACTIONS(1792),
    [anon_sym_let] = ACTIONS(1792),
    [anon_sym_const] = ACTIONS(1792),
    [anon_sym_BANG] = ACTIONS(1792),
    [anon_sym_else] = ACTIONS(1792),
    [anon_sym_if] = ACTIONS(1792),
    [anon_sym_switch] = ACTIONS(1792),
    [anon_sym_for] = ACTIONS(1792),
    [anon_sym_LPAREN] = ACTIONS(1798),
    [anon_sym_await] = ACTIONS(1792),
    [anon_sym_in] = ACTIONS(1792),
    [anon_sym_of] = ACTIONS(1792),
    [anon_sym_while] = ACTIONS(1792),
    [anon_sym_do] = ACTIONS(1792),
    [anon_sym_try] = ACTIONS(1792),
    [anon_sym_break] = ACTIONS(1792),
    [anon_sym_continue] = ACTIONS(1792),
    [anon_sym_debugger] = ACTIONS(1792),
    [anon_sym_return] = ACTIONS(1792),
    [anon_sym_throw] = ACTIONS(1792),
    [anon_sym_SEMI] = ACTIONS(1798),
    [anon_sym_case] = ACTIONS(1792),
    [anon_sym_yield] = ACTIONS(1792),
    [anon_sym_LBRACK] = ACTIONS(1798),
    [anon_sym_LTtemplate_GT] = ACTIONS(1798),
    [anon_sym_GT] = ACTIONS(1792),
    [anon_sym_DOT] = ACTIONS(1792),
    [anon_sym_DQUOTE] = ACTIONS(1798),
    [anon_sym_SQUOTE] = ACTIONS(1798),
    [anon_sym_class] = ACTIONS(1792),
    [anon_sym_async] = ACTIONS(1792),
    [anon_sym_function] = ACTIONS(1792),
    [anon_sym_QMARK_DOT] = ACTIONS(1798),
    [anon_sym_new] = ACTIONS(1792),
    [anon_sym_using] = ACTIONS(1792),
    [anon_sym_AMP_AMP] = ACTIONS(1798),
    [anon_sym_PIPE_PIPE] = ACTIONS(1798),
    [anon_sym_GT_GT] = ACTIONS(1792),
    [anon_sym_GT_GT_GT] = ACTIONS(1798),
    [anon_sym_LT_LT] = ACTIONS(1798),
    [anon_sym_AMP] = ACTIONS(1792),
    [anon_sym_CARET] = ACTIONS(1798),
    [anon_sym_PIPE] = ACTIONS(1792),
    [anon_sym_PLUS] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(1792),
    [anon_sym_SLASH] = ACTIONS(1792),
    [anon_sym_PERCENT] = ACTIONS(1798),
    [anon_sym_STAR_STAR] = ACTIONS(1798),
    [anon_sym_LT] = ACTIONS(1792),
    [anon_sym_LT_EQ] = ACTIONS(1798),
    [anon_sym_EQ_EQ] = ACTIONS(1792),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1798),
    [anon_sym_BANG_EQ] = ACTIONS(1792),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1798),
    [anon_sym_GT_EQ] = ACTIONS(1798),
    [anon_sym_QMARK_QMARK] = ACTIONS(1798),
    [anon_sym_instanceof] = ACTIONS(1792),
    [anon_sym_TILDE] = ACTIONS(1798),
    [anon_sym_void] = ACTIONS(1792),
    [anon_sym_delete] = ACTIONS(1792),
    [anon_sym_PLUS_PLUS] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1798),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1798),
    [sym_number] = ACTIONS(1798),
    [sym_private_property_identifier] = ACTIONS(1798),
    [sym_this] = ACTIONS(1792),
    [sym_super] = ACTIONS(1792),
    [sym_true] = ACTIONS(1792),
    [sym_false] = ACTIONS(1792),
    [sym_null] = ACTIONS(1792),
    [sym_undefined] = ACTIONS(1792),
    [anon_sym_AT] = ACTIONS(1798),
    [anon_sym_static] = ACTIONS(1792),
    [anon_sym_readonly] = ACTIONS(1792),
    [anon_sym_get] = ACTIONS(1792),
    [anon_sym_set] = ACTIONS(1792),
    [anon_sym_declare] = ACTIONS(1792),
    [anon_sym_public] = ACTIONS(1792),
    [anon_sym_private] = ACTIONS(1792),
    [anon_sym_protected] = ACTIONS(1792),
    [anon_sym_override] = ACTIONS(1792),
    [anon_sym_module] = ACTIONS(1792),
    [anon_sym_any] = ACTIONS(1792),
    [anon_sym_number] = ACTIONS(1792),
    [anon_sym_boolean] = ACTIONS(1792),
    [anon_sym_string] = ACTIONS(1792),
    [anon_sym_symbol] = ACTIONS(1792),
    [anon_sym_object] = ACTIONS(1792),
    [anon_sym_property] = ACTIONS(1792),
    [anon_sym_signal] = ACTIONS(1792),
    [anon_sym_on] = ACTIONS(1792),
    [anon_sym_required] = ACTIONS(1792),
    [anon_sym_component] = ACTIONS(1792),
    [anon_sym_abstract] = ACTIONS(1792),
    [anon_sym_satisfies] = ACTIONS(1792),
    [anon_sym_interface] = ACTIONS(1792),
    [anon_sym_enum] = ACTIONS(1792),
    [sym__automatic_semicolon] = ACTIONS(1942),
    [sym__ternary_qmark] = ACTIONS(1798),
    [sym_html_comment] = ACTIONS(5),
  },
  [249] = {
    [sym_comment] = STATE(249),
    [sym_identifier] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(1944),
    [anon_sym_default] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_as] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1944),
    [anon_sym_LBRACE] = ACTIONS(1946),
    [anon_sym_COMMA] = ACTIONS(1946),
    [anon_sym_RBRACE] = ACTIONS(1946),
    [anon_sym_typeof] = ACTIONS(1944),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_from] = ACTIONS(1944),
    [anon_sym_with] = ACTIONS(1944),
    [anon_sym_var] = ACTIONS(1944),
    [anon_sym_let] = ACTIONS(1944),
    [anon_sym_const] = ACTIONS(1944),
    [anon_sym_BANG] = ACTIONS(1944),
    [anon_sym_else] = ACTIONS(1944),
    [anon_sym_if] = ACTIONS(1944),
    [anon_sym_switch] = ACTIONS(1944),
    [anon_sym_for] = ACTIONS(1944),
    [anon_sym_LPAREN] = ACTIONS(1946),
    [anon_sym_await] = ACTIONS(1944),
    [anon_sym_in] = ACTIONS(1944),
    [anon_sym_of] = ACTIONS(1944),
    [anon_sym_while] = ACTIONS(1944),
    [anon_sym_do] = ACTIONS(1944),
    [anon_sym_try] = ACTIONS(1944),
    [anon_sym_break] = ACTIONS(1944),
    [anon_sym_continue] = ACTIONS(1944),
    [anon_sym_debugger] = ACTIONS(1944),
    [anon_sym_return] = ACTIONS(1944),
    [anon_sym_throw] = ACTIONS(1944),
    [anon_sym_SEMI] = ACTIONS(1946),
    [anon_sym_case] = ACTIONS(1944),
    [anon_sym_yield] = ACTIONS(1944),
    [anon_sym_LBRACK] = ACTIONS(1946),
    [anon_sym_LTtemplate_GT] = ACTIONS(1946),
    [anon_sym_GT] = ACTIONS(1944),
    [anon_sym_DOT] = ACTIONS(1944),
    [anon_sym_DQUOTE] = ACTIONS(1946),
    [anon_sym_SQUOTE] = ACTIONS(1946),
    [anon_sym_class] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(1944),
    [anon_sym_QMARK_DOT] = ACTIONS(1946),
    [anon_sym_new] = ACTIONS(1944),
    [anon_sym_using] = ACTIONS(1944),
    [anon_sym_AMP_AMP] = ACTIONS(1946),
    [anon_sym_PIPE_PIPE] = ACTIONS(1946),
    [anon_sym_GT_GT] = ACTIONS(1944),
    [anon_sym_GT_GT_GT] = ACTIONS(1946),
    [anon_sym_LT_LT] = ACTIONS(1946),
    [anon_sym_AMP] = ACTIONS(1944),
    [anon_sym_CARET] = ACTIONS(1946),
    [anon_sym_PIPE] = ACTIONS(1944),
    [anon_sym_PLUS] = ACTIONS(1944),
    [anon_sym_DASH] = ACTIONS(1944),
    [anon_sym_SLASH] = ACTIONS(1944),
    [anon_sym_PERCENT] = ACTIONS(1946),
    [anon_sym_STAR_STAR] = ACTIONS(1946),
    [anon_sym_LT] = ACTIONS(1944),
    [anon_sym_LT_EQ] = ACTIONS(1946),
    [anon_sym_EQ_EQ] = ACTIONS(1944),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1946),
    [anon_sym_BANG_EQ] = ACTIONS(1944),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1946),
    [anon_sym_GT_EQ] = ACTIONS(1946),
    [anon_sym_QMARK_QMARK] = ACTIONS(1946),
    [anon_sym_instanceof] = ACTIONS(1944),
    [anon_sym_TILDE] = ACTIONS(1946),
    [anon_sym_void] = ACTIONS(1944),
    [anon_sym_delete] = ACTIONS(1944),
    [anon_sym_PLUS_PLUS] = ACTIONS(1946),
    [anon_sym_DASH_DASH] = ACTIONS(1946),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1946),
    [sym_number] = ACTIONS(1946),
    [sym_private_property_identifier] = ACTIONS(1946),
    [sym_this] = ACTIONS(1944),
    [sym_super] = ACTIONS(1944),
    [sym_true] = ACTIONS(1944),
    [sym_false] = ACTIONS(1944),
    [sym_null] = ACTIONS(1944),
    [sym_undefined] = ACTIONS(1944),
    [anon_sym_AT] = ACTIONS(1946),
    [anon_sym_static] = ACTIONS(1944),
    [anon_sym_readonly] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_override] = ACTIONS(1944),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_object] = ACTIONS(1944),
    [anon_sym_property] = ACTIONS(1944),
    [anon_sym_signal] = ACTIONS(1944),
    [anon_sym_on] = ACTIONS(1944),
    [anon_sym_required] = ACTIONS(1944),
    [anon_sym_component] = ACTIONS(1944),
    [anon_sym_abstract] = ACTIONS(1944),
    [anon_sym_satisfies] = ACTIONS(1944),
    [anon_sym_interface] = ACTIONS(1944),
    [anon_sym_enum] = ACTIONS(1944),
    [sym__automatic_semicolon] = ACTIONS(1946),
    [sym__ternary_qmark] = ACTIONS(1946),
    [sym_html_comment] = ACTIONS(5),
  },
  [250] = {
    [sym_comment] = STATE(250),
    [sym_identifier] = ACTIONS(1948),
    [anon_sym_export] = ACTIONS(1948),
    [anon_sym_STAR] = ACTIONS(1950),
    [anon_sym_default] = ACTIONS(1948),
    [anon_sym_type] = ACTIONS(1948),
    [anon_sym_as] = ACTIONS(1950),
    [anon_sym_namespace] = ACTIONS(1948),
    [anon_sym_LBRACE] = ACTIONS(1952),
    [anon_sym_COMMA] = ACTIONS(1954),
    [anon_sym_RBRACE] = ACTIONS(1952),
    [anon_sym_typeof] = ACTIONS(1948),
    [anon_sym_import] = ACTIONS(1948),
    [anon_sym_from] = ACTIONS(1948),
    [anon_sym_with] = ACTIONS(1948),
    [anon_sym_var] = ACTIONS(1948),
    [anon_sym_let] = ACTIONS(1948),
    [anon_sym_const] = ACTIONS(1948),
    [anon_sym_BANG] = ACTIONS(1948),
    [anon_sym_else] = ACTIONS(1948),
    [anon_sym_if] = ACTIONS(1948),
    [anon_sym_switch] = ACTIONS(1948),
    [anon_sym_for] = ACTIONS(1948),
    [anon_sym_LPAREN] = ACTIONS(1952),
    [anon_sym_await] = ACTIONS(1948),
    [anon_sym_in] = ACTIONS(1950),
    [anon_sym_of] = ACTIONS(1948),
    [anon_sym_while] = ACTIONS(1948),
    [anon_sym_do] = ACTIONS(1948),
    [anon_sym_try] = ACTIONS(1948),
    [anon_sym_break] = ACTIONS(1948),
    [anon_sym_continue] = ACTIONS(1948),
    [anon_sym_debugger] = ACTIONS(1948),
    [anon_sym_return] = ACTIONS(1948),
    [anon_sym_throw] = ACTIONS(1948),
    [anon_sym_SEMI] = ACTIONS(1952),
    [anon_sym_case] = ACTIONS(1948),
    [anon_sym_yield] = ACTIONS(1948),
    [anon_sym_LBRACK] = ACTIONS(1952),
    [anon_sym_LTtemplate_GT] = ACTIONS(1952),
    [anon_sym_GT] = ACTIONS(1950),
    [anon_sym_DOT] = ACTIONS(1950),
    [anon_sym_DQUOTE] = ACTIONS(1952),
    [anon_sym_SQUOTE] = ACTIONS(1952),
    [anon_sym_class] = ACTIONS(1948),
    [anon_sym_async] = ACTIONS(1948),
    [anon_sym_function] = ACTIONS(1948),
    [anon_sym_QMARK_DOT] = ACTIONS(1954),
    [anon_sym_new] = ACTIONS(1948),
    [anon_sym_using] = ACTIONS(1948),
    [anon_sym_AMP_AMP] = ACTIONS(1954),
    [anon_sym_PIPE_PIPE] = ACTIONS(1954),
    [anon_sym_GT_GT] = ACTIONS(1950),
    [anon_sym_GT_GT_GT] = ACTIONS(1954),
    [anon_sym_LT_LT] = ACTIONS(1954),
    [anon_sym_AMP] = ACTIONS(1950),
    [anon_sym_CARET] = ACTIONS(1954),
    [anon_sym_PIPE] = ACTIONS(1950),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_SLASH] = ACTIONS(1948),
    [anon_sym_PERCENT] = ACTIONS(1954),
    [anon_sym_STAR_STAR] = ACTIONS(1954),
    [anon_sym_LT] = ACTIONS(1948),
    [anon_sym_LT_EQ] = ACTIONS(1954),
    [anon_sym_EQ_EQ] = ACTIONS(1950),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1954),
    [anon_sym_BANG_EQ] = ACTIONS(1950),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1954),
    [anon_sym_GT_EQ] = ACTIONS(1954),
    [anon_sym_QMARK_QMARK] = ACTIONS(1954),
    [anon_sym_instanceof] = ACTIONS(1950),
    [anon_sym_TILDE] = ACTIONS(1952),
    [anon_sym_void] = ACTIONS(1948),
    [anon_sym_delete] = ACTIONS(1948),
    [anon_sym_PLUS_PLUS] = ACTIONS(1952),
    [anon_sym_DASH_DASH] = ACTIONS(1952),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1952),
    [sym_number] = ACTIONS(1952),
    [sym_private_property_identifier] = ACTIONS(1952),
    [sym_this] = ACTIONS(1948),
    [sym_super] = ACTIONS(1948),
    [sym_true] = ACTIONS(1948),
    [sym_false] = ACTIONS(1948),
    [sym_null] = ACTIONS(1948),
    [sym_undefined] = ACTIONS(1948),
    [anon_sym_AT] = ACTIONS(1952),
    [anon_sym_static] = ACTIONS(1948),
    [anon_sym_readonly] = ACTIONS(1948),
    [anon_sym_get] = ACTIONS(1948),
    [anon_sym_set] = ACTIONS(1948),
    [anon_sym_declare] = ACTIONS(1948),
    [anon_sym_public] = ACTIONS(1948),
    [anon_sym_private] = ACTIONS(1948),
    [anon_sym_protected] = ACTIONS(1948),
    [anon_sym_override] = ACTIONS(1948),
    [anon_sym_module] = ACTIONS(1948),
    [anon_sym_any] = ACTIONS(1948),
    [anon_sym_number] = ACTIONS(1948),
    [anon_sym_boolean] = ACTIONS(1948),
    [anon_sym_string] = ACTIONS(1948),
    [anon_sym_symbol] = ACTIONS(1948),
    [anon_sym_object] = ACTIONS(1948),
    [anon_sym_property] = ACTIONS(1948),
    [anon_sym_signal] = ACTIONS(1948),
    [anon_sym_on] = ACTIONS(1948),
    [anon_sym_required] = ACTIONS(1948),
    [anon_sym_component] = ACTIONS(1948),
    [anon_sym_abstract] = ACTIONS(1948),
    [anon_sym_satisfies] = ACTIONS(1950),
    [anon_sym_interface] = ACTIONS(1948),
    [anon_sym_enum] = ACTIONS(1948),
    [sym__automatic_semicolon] = ACTIONS(1956),
    [sym__ternary_qmark] = ACTIONS(1954),
    [sym_html_comment] = ACTIONS(5),
  },
  [251] = {
    [sym_comment] = STATE(251),
    [sym_identifier] = ACTIONS(1958),
    [anon_sym_export] = ACTIONS(1958),
    [anon_sym_STAR] = ACTIONS(1960),
    [anon_sym_default] = ACTIONS(1958),
    [anon_sym_type] = ACTIONS(1958),
    [anon_sym_as] = ACTIONS(1960),
    [anon_sym_namespace] = ACTIONS(1958),
    [anon_sym_LBRACE] = ACTIONS(1962),
    [anon_sym_COMMA] = ACTIONS(1964),
    [anon_sym_RBRACE] = ACTIONS(1962),
    [anon_sym_typeof] = ACTIONS(1958),
    [anon_sym_import] = ACTIONS(1958),
    [anon_sym_from] = ACTIONS(1958),
    [anon_sym_with] = ACTIONS(1958),
    [anon_sym_var] = ACTIONS(1958),
    [anon_sym_let] = ACTIONS(1958),
    [anon_sym_const] = ACTIONS(1958),
    [anon_sym_BANG] = ACTIONS(1958),
    [anon_sym_else] = ACTIONS(1958),
    [anon_sym_if] = ACTIONS(1958),
    [anon_sym_switch] = ACTIONS(1958),
    [anon_sym_for] = ACTIONS(1958),
    [anon_sym_LPAREN] = ACTIONS(1962),
    [anon_sym_await] = ACTIONS(1958),
    [anon_sym_in] = ACTIONS(1960),
    [anon_sym_of] = ACTIONS(1958),
    [anon_sym_while] = ACTIONS(1958),
    [anon_sym_do] = ACTIONS(1958),
    [anon_sym_try] = ACTIONS(1958),
    [anon_sym_break] = ACTIONS(1958),
    [anon_sym_continue] = ACTIONS(1958),
    [anon_sym_debugger] = ACTIONS(1958),
    [anon_sym_return] = ACTIONS(1958),
    [anon_sym_throw] = ACTIONS(1958),
    [anon_sym_SEMI] = ACTIONS(1962),
    [anon_sym_case] = ACTIONS(1958),
    [anon_sym_yield] = ACTIONS(1958),
    [anon_sym_LBRACK] = ACTIONS(1962),
    [anon_sym_LTtemplate_GT] = ACTIONS(1962),
    [anon_sym_GT] = ACTIONS(1960),
    [anon_sym_DOT] = ACTIONS(1960),
    [anon_sym_DQUOTE] = ACTIONS(1962),
    [anon_sym_SQUOTE] = ACTIONS(1962),
    [anon_sym_class] = ACTIONS(1958),
    [anon_sym_async] = ACTIONS(1958),
    [anon_sym_function] = ACTIONS(1958),
    [anon_sym_QMARK_DOT] = ACTIONS(1964),
    [anon_sym_new] = ACTIONS(1958),
    [anon_sym_using] = ACTIONS(1958),
    [anon_sym_AMP_AMP] = ACTIONS(1964),
    [anon_sym_PIPE_PIPE] = ACTIONS(1964),
    [anon_sym_GT_GT] = ACTIONS(1960),
    [anon_sym_GT_GT_GT] = ACTIONS(1964),
    [anon_sym_LT_LT] = ACTIONS(1964),
    [anon_sym_AMP] = ACTIONS(1960),
    [anon_sym_CARET] = ACTIONS(1964),
    [anon_sym_PIPE] = ACTIONS(1960),
    [anon_sym_PLUS] = ACTIONS(1958),
    [anon_sym_DASH] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(1958),
    [anon_sym_PERCENT] = ACTIONS(1964),
    [anon_sym_STAR_STAR] = ACTIONS(1964),
    [anon_sym_LT] = ACTIONS(1958),
    [anon_sym_LT_EQ] = ACTIONS(1964),
    [anon_sym_EQ_EQ] = ACTIONS(1960),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1964),
    [anon_sym_BANG_EQ] = ACTIONS(1960),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1964),
    [anon_sym_GT_EQ] = ACTIONS(1964),
    [anon_sym_QMARK_QMARK] = ACTIONS(1964),
    [anon_sym_instanceof] = ACTIONS(1960),
    [anon_sym_TILDE] = ACTIONS(1962),
    [anon_sym_void] = ACTIONS(1958),
    [anon_sym_delete] = ACTIONS(1958),
    [anon_sym_PLUS_PLUS] = ACTIONS(1962),
    [anon_sym_DASH_DASH] = ACTIONS(1962),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1962),
    [sym_number] = ACTIONS(1962),
    [sym_private_property_identifier] = ACTIONS(1962),
    [sym_this] = ACTIONS(1958),
    [sym_super] = ACTIONS(1958),
    [sym_true] = ACTIONS(1958),
    [sym_false] = ACTIONS(1958),
    [sym_null] = ACTIONS(1958),
    [sym_undefined] = ACTIONS(1958),
    [anon_sym_AT] = ACTIONS(1962),
    [anon_sym_static] = ACTIONS(1958),
    [anon_sym_readonly] = ACTIONS(1958),
    [anon_sym_get] = ACTIONS(1958),
    [anon_sym_set] = ACTIONS(1958),
    [anon_sym_declare] = ACTIONS(1958),
    [anon_sym_public] = ACTIONS(1958),
    [anon_sym_private] = ACTIONS(1958),
    [anon_sym_protected] = ACTIONS(1958),
    [anon_sym_override] = ACTIONS(1958),
    [anon_sym_module] = ACTIONS(1958),
    [anon_sym_any] = ACTIONS(1958),
    [anon_sym_number] = ACTIONS(1958),
    [anon_sym_boolean] = ACTIONS(1958),
    [anon_sym_string] = ACTIONS(1958),
    [anon_sym_symbol] = ACTIONS(1958),
    [anon_sym_object] = ACTIONS(1958),
    [anon_sym_property] = ACTIONS(1958),
    [anon_sym_signal] = ACTIONS(1958),
    [anon_sym_on] = ACTIONS(1958),
    [anon_sym_required] = ACTIONS(1958),
    [anon_sym_component] = ACTIONS(1958),
    [anon_sym_abstract] = ACTIONS(1958),
    [anon_sym_satisfies] = ACTIONS(1960),
    [anon_sym_interface] = ACTIONS(1958),
    [anon_sym_enum] = ACTIONS(1958),
    [sym__automatic_semicolon] = ACTIONS(1966),
    [sym__ternary_qmark] = ACTIONS(1964),
    [sym_html_comment] = ACTIONS(5),
  },
  [252] = {
    [sym_comment] = STATE(252),
    [sym_identifier] = ACTIONS(1968),
    [anon_sym_export] = ACTIONS(1968),
    [anon_sym_STAR] = ACTIONS(1968),
    [anon_sym_default] = ACTIONS(1968),
    [anon_sym_type] = ACTIONS(1968),
    [anon_sym_as] = ACTIONS(1968),
    [anon_sym_namespace] = ACTIONS(1968),
    [anon_sym_LBRACE] = ACTIONS(1970),
    [anon_sym_COMMA] = ACTIONS(1970),
    [anon_sym_RBRACE] = ACTIONS(1970),
    [anon_sym_typeof] = ACTIONS(1968),
    [anon_sym_import] = ACTIONS(1968),
    [anon_sym_from] = ACTIONS(1968),
    [anon_sym_with] = ACTIONS(1968),
    [anon_sym_var] = ACTIONS(1968),
    [anon_sym_let] = ACTIONS(1968),
    [anon_sym_const] = ACTIONS(1968),
    [anon_sym_BANG] = ACTIONS(1968),
    [anon_sym_else] = ACTIONS(1968),
    [anon_sym_if] = ACTIONS(1968),
    [anon_sym_switch] = ACTIONS(1968),
    [anon_sym_for] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1970),
    [anon_sym_await] = ACTIONS(1968),
    [anon_sym_in] = ACTIONS(1968),
    [anon_sym_of] = ACTIONS(1968),
    [anon_sym_while] = ACTIONS(1968),
    [anon_sym_do] = ACTIONS(1968),
    [anon_sym_try] = ACTIONS(1968),
    [anon_sym_break] = ACTIONS(1968),
    [anon_sym_continue] = ACTIONS(1968),
    [anon_sym_debugger] = ACTIONS(1968),
    [anon_sym_return] = ACTIONS(1968),
    [anon_sym_throw] = ACTIONS(1968),
    [anon_sym_SEMI] = ACTIONS(1970),
    [anon_sym_case] = ACTIONS(1968),
    [anon_sym_yield] = ACTIONS(1968),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_LTtemplate_GT] = ACTIONS(1970),
    [anon_sym_GT] = ACTIONS(1968),
    [anon_sym_DOT] = ACTIONS(1968),
    [anon_sym_DQUOTE] = ACTIONS(1970),
    [anon_sym_SQUOTE] = ACTIONS(1970),
    [anon_sym_class] = ACTIONS(1968),
    [anon_sym_async] = ACTIONS(1968),
    [anon_sym_function] = ACTIONS(1968),
    [anon_sym_QMARK_DOT] = ACTIONS(1970),
    [anon_sym_new] = ACTIONS(1968),
    [anon_sym_using] = ACTIONS(1968),
    [anon_sym_AMP_AMP] = ACTIONS(1970),
    [anon_sym_PIPE_PIPE] = ACTIONS(1970),
    [anon_sym_GT_GT] = ACTIONS(1968),
    [anon_sym_GT_GT_GT] = ACTIONS(1970),
    [anon_sym_LT_LT] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(1968),
    [anon_sym_CARET] = ACTIONS(1970),
    [anon_sym_PIPE] = ACTIONS(1968),
    [anon_sym_PLUS] = ACTIONS(1968),
    [anon_sym_DASH] = ACTIONS(1968),
    [anon_sym_SLASH] = ACTIONS(1968),
    [anon_sym_PERCENT] = ACTIONS(1970),
    [anon_sym_STAR_STAR] = ACTIONS(1970),
    [anon_sym_LT] = ACTIONS(1968),
    [anon_sym_LT_EQ] = ACTIONS(1970),
    [anon_sym_EQ_EQ] = ACTIONS(1968),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1970),
    [anon_sym_BANG_EQ] = ACTIONS(1968),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1970),
    [anon_sym_GT_EQ] = ACTIONS(1970),
    [anon_sym_QMARK_QMARK] = ACTIONS(1970),
    [anon_sym_instanceof] = ACTIONS(1968),
    [anon_sym_TILDE] = ACTIONS(1970),
    [anon_sym_void] = ACTIONS(1968),
    [anon_sym_delete] = ACTIONS(1968),
    [anon_sym_PLUS_PLUS] = ACTIONS(1970),
    [anon_sym_DASH_DASH] = ACTIONS(1970),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1970),
    [sym_number] = ACTIONS(1970),
    [sym_private_property_identifier] = ACTIONS(1970),
    [sym_this] = ACTIONS(1968),
    [sym_super] = ACTIONS(1968),
    [sym_true] = ACTIONS(1968),
    [sym_false] = ACTIONS(1968),
    [sym_null] = ACTIONS(1968),
    [sym_undefined] = ACTIONS(1968),
    [anon_sym_AT] = ACTIONS(1970),
    [anon_sym_static] = ACTIONS(1968),
    [anon_sym_readonly] = ACTIONS(1968),
    [anon_sym_get] = ACTIONS(1968),
    [anon_sym_set] = ACTIONS(1968),
    [anon_sym_declare] = ACTIONS(1968),
    [anon_sym_public] = ACTIONS(1968),
    [anon_sym_private] = ACTIONS(1968),
    [anon_sym_protected] = ACTIONS(1968),
    [anon_sym_override] = ACTIONS(1968),
    [anon_sym_module] = ACTIONS(1968),
    [anon_sym_any] = ACTIONS(1968),
    [anon_sym_number] = ACTIONS(1968),
    [anon_sym_boolean] = ACTIONS(1968),
    [anon_sym_string] = ACTIONS(1968),
    [anon_sym_symbol] = ACTIONS(1968),
    [anon_sym_object] = ACTIONS(1968),
    [anon_sym_property] = ACTIONS(1968),
    [anon_sym_signal] = ACTIONS(1968),
    [anon_sym_on] = ACTIONS(1968),
    [anon_sym_required] = ACTIONS(1968),
    [anon_sym_component] = ACTIONS(1968),
    [anon_sym_abstract] = ACTIONS(1968),
    [anon_sym_satisfies] = ACTIONS(1968),
    [anon_sym_interface] = ACTIONS(1968),
    [anon_sym_enum] = ACTIONS(1968),
    [sym__automatic_semicolon] = ACTIONS(1970),
    [sym__ternary_qmark] = ACTIONS(1970),
    [sym_html_comment] = ACTIONS(5),
  },
  [253] = {
    [sym_comment] = STATE(253),
    [sym_identifier] = ACTIONS(1972),
    [anon_sym_export] = ACTIONS(1972),
    [anon_sym_STAR] = ACTIONS(1974),
    [anon_sym_default] = ACTIONS(1972),
    [anon_sym_type] = ACTIONS(1972),
    [anon_sym_as] = ACTIONS(1974),
    [anon_sym_namespace] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1976),
    [anon_sym_COMMA] = ACTIONS(1978),
    [anon_sym_RBRACE] = ACTIONS(1976),
    [anon_sym_typeof] = ACTIONS(1972),
    [anon_sym_import] = ACTIONS(1972),
    [anon_sym_from] = ACTIONS(1972),
    [anon_sym_with] = ACTIONS(1972),
    [anon_sym_var] = ACTIONS(1972),
    [anon_sym_let] = ACTIONS(1972),
    [anon_sym_const] = ACTIONS(1972),
    [anon_sym_BANG] = ACTIONS(1972),
    [anon_sym_else] = ACTIONS(1972),
    [anon_sym_if] = ACTIONS(1972),
    [anon_sym_switch] = ACTIONS(1972),
    [anon_sym_for] = ACTIONS(1972),
    [anon_sym_LPAREN] = ACTIONS(1976),
    [anon_sym_await] = ACTIONS(1972),
    [anon_sym_in] = ACTIONS(1974),
    [anon_sym_of] = ACTIONS(1972),
    [anon_sym_while] = ACTIONS(1972),
    [anon_sym_do] = ACTIONS(1972),
    [anon_sym_try] = ACTIONS(1972),
    [anon_sym_break] = ACTIONS(1972),
    [anon_sym_continue] = ACTIONS(1972),
    [anon_sym_debugger] = ACTIONS(1972),
    [anon_sym_return] = ACTIONS(1972),
    [anon_sym_throw] = ACTIONS(1972),
    [anon_sym_SEMI] = ACTIONS(1976),
    [anon_sym_case] = ACTIONS(1972),
    [anon_sym_yield] = ACTIONS(1972),
    [anon_sym_LBRACK] = ACTIONS(1976),
    [anon_sym_LTtemplate_GT] = ACTIONS(1976),
    [anon_sym_GT] = ACTIONS(1974),
    [anon_sym_DOT] = ACTIONS(1974),
    [anon_sym_DQUOTE] = ACTIONS(1976),
    [anon_sym_SQUOTE] = ACTIONS(1976),
    [anon_sym_class] = ACTIONS(1972),
    [anon_sym_async] = ACTIONS(1972),
    [anon_sym_function] = ACTIONS(1972),
    [anon_sym_QMARK_DOT] = ACTIONS(1978),
    [anon_sym_new] = ACTIONS(1972),
    [anon_sym_using] = ACTIONS(1972),
    [anon_sym_AMP_AMP] = ACTIONS(1978),
    [anon_sym_PIPE_PIPE] = ACTIONS(1978),
    [anon_sym_GT_GT] = ACTIONS(1974),
    [anon_sym_GT_GT_GT] = ACTIONS(1978),
    [anon_sym_LT_LT] = ACTIONS(1978),
    [anon_sym_AMP] = ACTIONS(1974),
    [anon_sym_CARET] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(1974),
    [anon_sym_PLUS] = ACTIONS(1972),
    [anon_sym_DASH] = ACTIONS(1972),
    [anon_sym_SLASH] = ACTIONS(1972),
    [anon_sym_PERCENT] = ACTIONS(1978),
    [anon_sym_STAR_STAR] = ACTIONS(1978),
    [anon_sym_LT] = ACTIONS(1972),
    [anon_sym_LT_EQ] = ACTIONS(1978),
    [anon_sym_EQ_EQ] = ACTIONS(1974),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1978),
    [anon_sym_BANG_EQ] = ACTIONS(1974),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1978),
    [anon_sym_GT_EQ] = ACTIONS(1978),
    [anon_sym_QMARK_QMARK] = ACTIONS(1978),
    [anon_sym_instanceof] = ACTIONS(1974),
    [anon_sym_TILDE] = ACTIONS(1976),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_delete] = ACTIONS(1972),
    [anon_sym_PLUS_PLUS] = ACTIONS(1976),
    [anon_sym_DASH_DASH] = ACTIONS(1976),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1976),
    [sym_number] = ACTIONS(1976),
    [sym_private_property_identifier] = ACTIONS(1976),
    [sym_this] = ACTIONS(1972),
    [sym_super] = ACTIONS(1972),
    [sym_true] = ACTIONS(1972),
    [sym_false] = ACTIONS(1972),
    [sym_null] = ACTIONS(1972),
    [sym_undefined] = ACTIONS(1972),
    [anon_sym_AT] = ACTIONS(1976),
    [anon_sym_static] = ACTIONS(1972),
    [anon_sym_readonly] = ACTIONS(1972),
    [anon_sym_get] = ACTIONS(1972),
    [anon_sym_set] = ACTIONS(1972),
    [anon_sym_declare] = ACTIONS(1972),
    [anon_sym_public] = ACTIONS(1972),
    [anon_sym_private] = ACTIONS(1972),
    [anon_sym_protected] = ACTIONS(1972),
    [anon_sym_override] = ACTIONS(1972),
    [anon_sym_module] = ACTIONS(1972),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_boolean] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_object] = ACTIONS(1972),
    [anon_sym_property] = ACTIONS(1972),
    [anon_sym_signal] = ACTIONS(1972),
    [anon_sym_on] = ACTIONS(1972),
    [anon_sym_required] = ACTIONS(1972),
    [anon_sym_component] = ACTIONS(1972),
    [anon_sym_abstract] = ACTIONS(1972),
    [anon_sym_satisfies] = ACTIONS(1974),
    [anon_sym_interface] = ACTIONS(1972),
    [anon_sym_enum] = ACTIONS(1972),
    [sym__automatic_semicolon] = ACTIONS(1980),
    [sym__ternary_qmark] = ACTIONS(1978),
    [sym_html_comment] = ACTIONS(5),
  },
  [254] = {
    [sym_comment] = STATE(254),
    [sym_identifier] = ACTIONS(1982),
    [anon_sym_export] = ACTIONS(1982),
    [anon_sym_STAR] = ACTIONS(1984),
    [anon_sym_default] = ACTIONS(1982),
    [anon_sym_type] = ACTIONS(1982),
    [anon_sym_as] = ACTIONS(1984),
    [anon_sym_namespace] = ACTIONS(1982),
    [anon_sym_LBRACE] = ACTIONS(1986),
    [anon_sym_COMMA] = ACTIONS(1988),
    [anon_sym_RBRACE] = ACTIONS(1986),
    [anon_sym_typeof] = ACTIONS(1982),
    [anon_sym_import] = ACTIONS(1982),
    [anon_sym_from] = ACTIONS(1982),
    [anon_sym_with] = ACTIONS(1982),
    [anon_sym_var] = ACTIONS(1982),
    [anon_sym_let] = ACTIONS(1982),
    [anon_sym_const] = ACTIONS(1982),
    [anon_sym_BANG] = ACTIONS(1982),
    [anon_sym_else] = ACTIONS(1982),
    [anon_sym_if] = ACTIONS(1982),
    [anon_sym_switch] = ACTIONS(1982),
    [anon_sym_for] = ACTIONS(1982),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_await] = ACTIONS(1982),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_of] = ACTIONS(1982),
    [anon_sym_while] = ACTIONS(1982),
    [anon_sym_do] = ACTIONS(1982),
    [anon_sym_try] = ACTIONS(1982),
    [anon_sym_break] = ACTIONS(1982),
    [anon_sym_continue] = ACTIONS(1982),
    [anon_sym_debugger] = ACTIONS(1982),
    [anon_sym_return] = ACTIONS(1982),
    [anon_sym_throw] = ACTIONS(1982),
    [anon_sym_SEMI] = ACTIONS(1986),
    [anon_sym_case] = ACTIONS(1982),
    [anon_sym_yield] = ACTIONS(1982),
    [anon_sym_LBRACK] = ACTIONS(1986),
    [anon_sym_LTtemplate_GT] = ACTIONS(1986),
    [anon_sym_GT] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_DQUOTE] = ACTIONS(1986),
    [anon_sym_SQUOTE] = ACTIONS(1986),
    [anon_sym_class] = ACTIONS(1982),
    [anon_sym_async] = ACTIONS(1982),
    [anon_sym_function] = ACTIONS(1982),
    [anon_sym_QMARK_DOT] = ACTIONS(1988),
    [anon_sym_new] = ACTIONS(1982),
    [anon_sym_using] = ACTIONS(1982),
    [anon_sym_AMP_AMP] = ACTIONS(1988),
    [anon_sym_PIPE_PIPE] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_GT_GT_GT] = ACTIONS(1988),
    [anon_sym_LT_LT] = ACTIONS(1988),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1988),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1982),
    [anon_sym_DASH] = ACTIONS(1982),
    [anon_sym_SLASH] = ACTIONS(1982),
    [anon_sym_PERCENT] = ACTIONS(1988),
    [anon_sym_STAR_STAR] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_LT_EQ] = ACTIONS(1988),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1988),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1988),
    [anon_sym_GT_EQ] = ACTIONS(1988),
    [anon_sym_QMARK_QMARK] = ACTIONS(1988),
    [anon_sym_instanceof] = ACTIONS(1984),
    [anon_sym_TILDE] = ACTIONS(1986),
    [anon_sym_void] = ACTIONS(1982),
    [anon_sym_delete] = ACTIONS(1982),
    [anon_sym_PLUS_PLUS] = ACTIONS(1986),
    [anon_sym_DASH_DASH] = ACTIONS(1986),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1986),
    [sym_number] = ACTIONS(1986),
    [sym_private_property_identifier] = ACTIONS(1986),
    [sym_this] = ACTIONS(1982),
    [sym_super] = ACTIONS(1982),
    [sym_true] = ACTIONS(1982),
    [sym_false] = ACTIONS(1982),
    [sym_null] = ACTIONS(1982),
    [sym_undefined] = ACTIONS(1982),
    [anon_sym_AT] = ACTIONS(1986),
    [anon_sym_static] = ACTIONS(1982),
    [anon_sym_readonly] = ACTIONS(1982),
    [anon_sym_get] = ACTIONS(1982),
    [anon_sym_set] = ACTIONS(1982),
    [anon_sym_declare] = ACTIONS(1982),
    [anon_sym_public] = ACTIONS(1982),
    [anon_sym_private] = ACTIONS(1982),
    [anon_sym_protected] = ACTIONS(1982),
    [anon_sym_override] = ACTIONS(1982),
    [anon_sym_module] = ACTIONS(1982),
    [anon_sym_any] = ACTIONS(1982),
    [anon_sym_number] = ACTIONS(1982),
    [anon_sym_boolean] = ACTIONS(1982),
    [anon_sym_string] = ACTIONS(1982),
    [anon_sym_symbol] = ACTIONS(1982),
    [anon_sym_object] = ACTIONS(1982),
    [anon_sym_property] = ACTIONS(1982),
    [anon_sym_signal] = ACTIONS(1982),
    [anon_sym_on] = ACTIONS(1982),
    [anon_sym_required] = ACTIONS(1982),
    [anon_sym_component] = ACTIONS(1982),
    [anon_sym_abstract] = ACTIONS(1982),
    [anon_sym_satisfies] = ACTIONS(1984),
    [anon_sym_interface] = ACTIONS(1982),
    [anon_sym_enum] = ACTIONS(1982),
    [sym__automatic_semicolon] = ACTIONS(1990),
    [sym__ternary_qmark] = ACTIONS(1988),
    [sym_html_comment] = ACTIONS(5),
  },
  [255] = {
    [sym_comment] = STATE(255),
    [sym_identifier] = ACTIONS(1992),
    [anon_sym_export] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1994),
    [anon_sym_default] = ACTIONS(1992),
    [anon_sym_type] = ACTIONS(1992),
    [anon_sym_as] = ACTIONS(1994),
    [anon_sym_namespace] = ACTIONS(1992),
    [anon_sym_LBRACE] = ACTIONS(1996),
    [anon_sym_COMMA] = ACTIONS(1998),
    [anon_sym_RBRACE] = ACTIONS(1996),
    [anon_sym_typeof] = ACTIONS(1992),
    [anon_sym_import] = ACTIONS(1992),
    [anon_sym_from] = ACTIONS(1992),
    [anon_sym_with] = ACTIONS(1992),
    [anon_sym_var] = ACTIONS(1992),
    [anon_sym_let] = ACTIONS(1992),
    [anon_sym_const] = ACTIONS(1992),
    [anon_sym_BANG] = ACTIONS(1992),
    [anon_sym_else] = ACTIONS(1992),
    [anon_sym_if] = ACTIONS(1992),
    [anon_sym_switch] = ACTIONS(1992),
    [anon_sym_for] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1996),
    [anon_sym_await] = ACTIONS(1992),
    [anon_sym_in] = ACTIONS(1994),
    [anon_sym_of] = ACTIONS(1992),
    [anon_sym_while] = ACTIONS(1992),
    [anon_sym_do] = ACTIONS(1992),
    [anon_sym_try] = ACTIONS(1992),
    [anon_sym_break] = ACTIONS(1992),
    [anon_sym_continue] = ACTIONS(1992),
    [anon_sym_debugger] = ACTIONS(1992),
    [anon_sym_return] = ACTIONS(1992),
    [anon_sym_throw] = ACTIONS(1992),
    [anon_sym_SEMI] = ACTIONS(1996),
    [anon_sym_case] = ACTIONS(1992),
    [anon_sym_yield] = ACTIONS(1992),
    [anon_sym_LBRACK] = ACTIONS(1996),
    [anon_sym_LTtemplate_GT] = ACTIONS(1996),
    [anon_sym_GT] = ACTIONS(1994),
    [anon_sym_DOT] = ACTIONS(1994),
    [anon_sym_DQUOTE] = ACTIONS(1996),
    [anon_sym_SQUOTE] = ACTIONS(1996),
    [anon_sym_class] = ACTIONS(1992),
    [anon_sym_async] = ACTIONS(1992),
    [anon_sym_function] = ACTIONS(1992),
    [anon_sym_QMARK_DOT] = ACTIONS(1998),
    [anon_sym_new] = ACTIONS(1992),
    [anon_sym_using] = ACTIONS(1992),
    [anon_sym_AMP_AMP] = ACTIONS(1998),
    [anon_sym_PIPE_PIPE] = ACTIONS(1998),
    [anon_sym_GT_GT] = ACTIONS(1994),
    [anon_sym_GT_GT_GT] = ACTIONS(1998),
    [anon_sym_LT_LT] = ACTIONS(1998),
    [anon_sym_AMP] = ACTIONS(1994),
    [anon_sym_CARET] = ACTIONS(1998),
    [anon_sym_PIPE] = ACTIONS(1994),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_SLASH] = ACTIONS(1992),
    [anon_sym_PERCENT] = ACTIONS(1998),
    [anon_sym_STAR_STAR] = ACTIONS(1998),
    [anon_sym_LT] = ACTIONS(1992),
    [anon_sym_LT_EQ] = ACTIONS(1998),
    [anon_sym_EQ_EQ] = ACTIONS(1994),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1998),
    [anon_sym_BANG_EQ] = ACTIONS(1994),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1998),
    [anon_sym_GT_EQ] = ACTIONS(1998),
    [anon_sym_QMARK_QMARK] = ACTIONS(1998),
    [anon_sym_instanceof] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1996),
    [anon_sym_void] = ACTIONS(1992),
    [anon_sym_delete] = ACTIONS(1992),
    [anon_sym_PLUS_PLUS] = ACTIONS(1996),
    [anon_sym_DASH_DASH] = ACTIONS(1996),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1996),
    [sym_number] = ACTIONS(1996),
    [sym_private_property_identifier] = ACTIONS(1996),
    [sym_this] = ACTIONS(1992),
    [sym_super] = ACTIONS(1992),
    [sym_true] = ACTIONS(1992),
    [sym_false] = ACTIONS(1992),
    [sym_null] = ACTIONS(1992),
    [sym_undefined] = ACTIONS(1992),
    [anon_sym_AT] = ACTIONS(1996),
    [anon_sym_static] = ACTIONS(1992),
    [anon_sym_readonly] = ACTIONS(1992),
    [anon_sym_get] = ACTIONS(1992),
    [anon_sym_set] = ACTIONS(1992),
    [anon_sym_declare] = ACTIONS(1992),
    [anon_sym_public] = ACTIONS(1992),
    [anon_sym_private] = ACTIONS(1992),
    [anon_sym_protected] = ACTIONS(1992),
    [anon_sym_override] = ACTIONS(1992),
    [anon_sym_module] = ACTIONS(1992),
    [anon_sym_any] = ACTIONS(1992),
    [anon_sym_number] = ACTIONS(1992),
    [anon_sym_boolean] = ACTIONS(1992),
    [anon_sym_string] = ACTIONS(1992),
    [anon_sym_symbol] = ACTIONS(1992),
    [anon_sym_object] = ACTIONS(1992),
    [anon_sym_property] = ACTIONS(1992),
    [anon_sym_signal] = ACTIONS(1992),
    [anon_sym_on] = ACTIONS(1992),
    [anon_sym_required] = ACTIONS(1992),
    [anon_sym_component] = ACTIONS(1992),
    [anon_sym_abstract] = ACTIONS(1992),
    [anon_sym_satisfies] = ACTIONS(1994),
    [anon_sym_interface] = ACTIONS(1992),
    [anon_sym_enum] = ACTIONS(1992),
    [sym__automatic_semicolon] = ACTIONS(2000),
    [sym__ternary_qmark] = ACTIONS(1998),
    [sym_html_comment] = ACTIONS(5),
  },
  [256] = {
    [sym_nested_identifier] = STATE(6076),
    [sym_string] = STATE(3484),
    [sym_comment] = STATE(256),
    [sym_formal_parameters] = STATE(5995),
    [sym_nested_type_identifier] = STATE(3366),
    [sym__type] = STATE(3504),
    [sym_constructor_type] = STATE(3468),
    [sym__primary_type] = STATE(3467),
    [sym_template_literal_type] = STATE(3466),
    [sym_infer_type] = STATE(3468),
    [sym_conditional_type] = STATE(3466),
    [sym_generic_type] = STATE(3466),
    [sym_type_query] = STATE(3466),
    [sym_index_type_query] = STATE(3466),
    [sym_lookup_type] = STATE(3466),
    [sym_literal_type] = STATE(3466),
    [sym__number] = STATE(3465),
    [sym_existential_type] = STATE(3466),
    [sym_flow_maybe_type] = STATE(3466),
    [sym_parenthesized_type] = STATE(3466),
    [sym_predefined_type] = STATE(3466),
    [sym_object_type] = STATE(3466),
    [sym_type_parameters] = STATE(5758),
    [sym_array_type] = STATE(3466),
    [sym_tuple_type] = STATE(3466),
    [sym_readonly_type] = STATE(3468),
    [sym_union_type] = STATE(3466),
    [sym_intersection_type] = STATE(3466),
    [sym_function_type] = STATE(3468),
    [sym_identifier] = ACTIONS(2002),
    [anon_sym_STAR] = ACTIONS(2004),
    [anon_sym_EQ] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_LBRACE] = ACTIONS(2006),
    [anon_sym_COMMA] = ACTIONS(36),
    [anon_sym_RBRACE] = ACTIONS(36),
    [anon_sym_typeof] = ACTIONS(2008),
    [anon_sym_const] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2010),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_EQ_GT] = ACTIONS(68),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2018),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(2020),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(2022),
    [anon_sym_PLUS] = ACTIONS(2024),
    [anon_sym_DASH] = ACTIONS(2024),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(1771),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_void] = ACTIONS(1109),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [sym_number] = ACTIONS(2028),
    [sym_this] = ACTIONS(2030),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [sym_null] = ACTIONS(2032),
    [sym_undefined] = ACTIONS(2032),
    [anon_sym_readonly] = ACTIONS(2034),
    [anon_sym_QMARK] = ACTIONS(2036),
    [anon_sym_any] = ACTIONS(1109),
    [anon_sym_number] = ACTIONS(1109),
    [anon_sym_boolean] = ACTIONS(1109),
    [anon_sym_string] = ACTIONS(1109),
    [anon_sym_symbol] = ACTIONS(1109),
    [anon_sym_object] = ACTIONS(1109),
    [anon_sym_abstract] = ACTIONS(1101),
    [anon_sym_satisfies] = ACTIONS(30),
    [anon_sym_infer] = ACTIONS(1103),
    [anon_sym_keyof] = ACTIONS(1105),
    [anon_sym_unique] = ACTIONS(1107),
    [anon_sym_unknown] = ACTIONS(1109),
    [anon_sym_never] = ACTIONS(1109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1111),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [257] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3951),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(257),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(4326),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_accessibility_modifier] = STATE(294),
    [sym_override_modifier] = STATE(307),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(1198),
    [sym_identifier] = ACTIONS(799),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_namespace] = ACTIONS(32),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(23),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(2038),
    [anon_sym_async] = ACTIONS(64),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(809),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(2040),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(821),
    [anon_sym_AT] = ACTIONS(901),
    [anon_sym_static] = ACTIONS(23),
    [anon_sym_readonly] = ACTIONS(2042),
    [anon_sym_get] = ACTIONS(23),
    [anon_sym_set] = ACTIONS(23),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_public] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(919),
    [anon_sym_protected] = ACTIONS(919),
    [anon_sym_override] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(23),
    [anon_sym_number] = ACTIONS(23),
    [anon_sym_boolean] = ACTIONS(23),
    [anon_sym_string] = ACTIONS(23),
    [anon_sym_symbol] = ACTIONS(23),
    [anon_sym_object] = ACTIONS(23),
    [anon_sym_property] = ACTIONS(23),
    [anon_sym_signal] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [anon_sym_required] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(23),
    [sym_html_comment] = ACTIONS(5),
  },
  [258] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2128),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_spread_element] = STATE(4993),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(258),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [aux_sym_array_repeat1] = STATE(4992),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(2044),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_RPAREN] = ACTIONS(2046),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2048),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [259] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1473),
    [sym_expression] = STATE(2110),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6272),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1473),
    [sym_subscript_expression] = STATE(1473),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3246),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6274),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(259),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1473),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(541),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_export] = ACTIONS(1415),
    [anon_sym_type] = ACTIONS(1415),
    [anon_sym_namespace] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(1709),
    [anon_sym_typeof] = ACTIONS(1437),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1415),
    [anon_sym_let] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1421),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1423),
    [anon_sym_of] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1425),
    [anon_sym_LBRACK] = ACTIONS(1709),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(1709),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1427),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1543),
    [anon_sym_using] = ACTIONS(1431),
    [anon_sym_AMP] = ACTIONS(1709),
    [anon_sym_PIPE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1421),
    [anon_sym_void] = ACTIONS(1437),
    [anon_sym_delete] = ACTIONS(1437),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1441),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1415),
    [anon_sym_readonly] = ACTIONS(1415),
    [anon_sym_get] = ACTIONS(1415),
    [anon_sym_set] = ACTIONS(1415),
    [anon_sym_declare] = ACTIONS(1415),
    [anon_sym_public] = ACTIONS(1415),
    [anon_sym_private] = ACTIONS(1415),
    [anon_sym_protected] = ACTIONS(1415),
    [anon_sym_override] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_any] = ACTIONS(1415),
    [anon_sym_number] = ACTIONS(1415),
    [anon_sym_boolean] = ACTIONS(1415),
    [anon_sym_string] = ACTIONS(1415),
    [anon_sym_symbol] = ACTIONS(1415),
    [anon_sym_object] = ACTIONS(1415),
    [anon_sym_property] = ACTIONS(1415),
    [anon_sym_signal] = ACTIONS(1415),
    [anon_sym_on] = ACTIONS(1415),
    [anon_sym_required] = ACTIONS(1415),
    [anon_sym_component] = ACTIONS(1415),
    [anon_sym_extends] = ACTIONS(1711),
    [sym_html_comment] = ACTIONS(5),
  },
  [260] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2152),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_spread_element] = STATE(5176),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(260),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [aux_sym_array_repeat1] = STATE(5175),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(2044),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_RPAREN] = ACTIONS(2050),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2048),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [261] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2217),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_spread_element] = STATE(5499),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(261),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [aux_sym_array_repeat1] = STATE(5500),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(2044),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_RPAREN] = ACTIONS(2052),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2048),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [262] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2222),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_spread_element] = STATE(5039),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(262),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [aux_sym_array_repeat1] = STATE(5040),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(2044),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_RPAREN] = ACTIONS(2054),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2048),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [263] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1520),
    [sym_expression] = STATE(2618),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1520),
    [sym_subscript_expression] = STATE(1520),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6049),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(263),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1520),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(556),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1229),
    [anon_sym_namespace] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(1709),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1229),
    [anon_sym_let] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_of] = ACTIONS(1229),
    [anon_sym_yield] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(1709),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(1709),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1551),
    [anon_sym_using] = ACTIONS(1247),
    [anon_sym_AMP] = ACTIONS(1709),
    [anon_sym_PIPE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1257),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_readonly] = ACTIONS(1229),
    [anon_sym_get] = ACTIONS(1229),
    [anon_sym_set] = ACTIONS(1229),
    [anon_sym_declare] = ACTIONS(1229),
    [anon_sym_public] = ACTIONS(1229),
    [anon_sym_private] = ACTIONS(1229),
    [anon_sym_protected] = ACTIONS(1229),
    [anon_sym_override] = ACTIONS(1229),
    [anon_sym_module] = ACTIONS(1229),
    [anon_sym_any] = ACTIONS(1229),
    [anon_sym_number] = ACTIONS(1229),
    [anon_sym_boolean] = ACTIONS(1229),
    [anon_sym_string] = ACTIONS(1229),
    [anon_sym_symbol] = ACTIONS(1229),
    [anon_sym_object] = ACTIONS(1229),
    [anon_sym_property] = ACTIONS(1229),
    [anon_sym_signal] = ACTIONS(1229),
    [anon_sym_on] = ACTIONS(1229),
    [anon_sym_required] = ACTIONS(1229),
    [anon_sym_component] = ACTIONS(1229),
    [anon_sym_extends] = ACTIONS(1711),
    [sym_html_comment] = ACTIONS(5),
  },
  [264] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2079),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(264),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_COMMA] = ACTIONS(1709),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(1709),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(1709),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_AMP] = ACTIONS(1709),
    [anon_sym_PIPE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [anon_sym_extends] = ACTIONS(1711),
    [sym_html_comment] = ACTIONS(5),
  },
  [265] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2227),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_spread_element] = STATE(5214),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(265),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(2056),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_RPAREN] = ACTIONS(2056),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_RBRACK] = ACTIONS(2056),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2048),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [266] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(266),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(3294),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_EQ] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_COMMA] = ACTIONS(36),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_RBRACK] = ACTIONS(36),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_EQ_GT] = ACTIONS(68),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(80),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(82),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(1771),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_void] = ACTIONS(130),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(118),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_satisfies] = ACTIONS(30),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [267] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2138),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_spread_element] = STATE(5121),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(267),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [aux_sym_array_repeat1] = STATE(5120),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(2044),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_RPAREN] = ACTIONS(2058),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2048),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [268] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1487),
    [sym_expression] = STATE(2247),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1487),
    [sym_subscript_expression] = STATE(1487),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3189),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6145),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(268),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1487),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1131),
    [anon_sym_namespace] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_COMMA] = ACTIONS(1709),
    [anon_sym_typeof] = ACTIONS(1159),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_let] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_of] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1709),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(1709),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1149),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_using] = ACTIONS(1153),
    [anon_sym_AMP] = ACTIONS(1709),
    [anon_sym_PIPE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1159),
    [anon_sym_delete] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1167),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1131),
    [anon_sym_readonly] = ACTIONS(1131),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_declare] = ACTIONS(1131),
    [anon_sym_public] = ACTIONS(1131),
    [anon_sym_private] = ACTIONS(1131),
    [anon_sym_protected] = ACTIONS(1131),
    [anon_sym_override] = ACTIONS(1131),
    [anon_sym_module] = ACTIONS(1131),
    [anon_sym_any] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_boolean] = ACTIONS(1131),
    [anon_sym_string] = ACTIONS(1131),
    [anon_sym_symbol] = ACTIONS(1131),
    [anon_sym_object] = ACTIONS(1131),
    [anon_sym_property] = ACTIONS(1131),
    [anon_sym_signal] = ACTIONS(1131),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_required] = ACTIONS(1131),
    [anon_sym_component] = ACTIONS(1131),
    [anon_sym_extends] = ACTIONS(1711),
    [sym_html_comment] = ACTIONS(5),
  },
  [269] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(269),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(3294),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_EQ] = ACTIONS(993),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_EQ_GT] = ACTIONS(999),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(80),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(82),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(1771),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_void] = ACTIONS(130),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(118),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_satisfies] = ACTIONS(30),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [270] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_expression] = STATE(2084),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6164),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3271),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6167),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(270),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1451),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(522),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_export] = ACTIONS(1327),
    [anon_sym_type] = ACTIONS(1327),
    [anon_sym_namespace] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_COMMA] = ACTIONS(1709),
    [anon_sym_typeof] = ACTIONS(1349),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_let] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1333),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_of] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(1709),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(1709),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1527),
    [anon_sym_using] = ACTIONS(1343),
    [anon_sym_AMP] = ACTIONS(1709),
    [anon_sym_PIPE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_SLASH] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_void] = ACTIONS(1349),
    [anon_sym_delete] = ACTIONS(1349),
    [anon_sym_PLUS_PLUS] = ACTIONS(1351),
    [anon_sym_DASH_DASH] = ACTIONS(1351),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1353),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1327),
    [anon_sym_readonly] = ACTIONS(1327),
    [anon_sym_get] = ACTIONS(1327),
    [anon_sym_set] = ACTIONS(1327),
    [anon_sym_declare] = ACTIONS(1327),
    [anon_sym_public] = ACTIONS(1327),
    [anon_sym_private] = ACTIONS(1327),
    [anon_sym_protected] = ACTIONS(1327),
    [anon_sym_override] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_any] = ACTIONS(1327),
    [anon_sym_number] = ACTIONS(1327),
    [anon_sym_boolean] = ACTIONS(1327),
    [anon_sym_string] = ACTIONS(1327),
    [anon_sym_symbol] = ACTIONS(1327),
    [anon_sym_object] = ACTIONS(1327),
    [anon_sym_property] = ACTIONS(1327),
    [anon_sym_signal] = ACTIONS(1327),
    [anon_sym_on] = ACTIONS(1327),
    [anon_sym_required] = ACTIONS(1327),
    [anon_sym_component] = ACTIONS(1327),
    [anon_sym_extends] = ACTIONS(1711),
    [sym_html_comment] = ACTIONS(5),
  },
  [271] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1513),
    [sym_expression] = STATE(2655),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6293),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1513),
    [sym_subscript_expression] = STATE(1513),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3245),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6295),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(271),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1513),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(455),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1565),
    [anon_sym_export] = ACTIONS(1379),
    [anon_sym_type] = ACTIONS(1379),
    [anon_sym_namespace] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_COMMA] = ACTIONS(1709),
    [anon_sym_typeof] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1379),
    [anon_sym_let] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1385),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_of] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1389),
    [anon_sym_LBRACK] = ACTIONS(1709),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(1709),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1391),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_using] = ACTIONS(1395),
    [anon_sym_AMP] = ACTIONS(1709),
    [anon_sym_PIPE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_void] = ACTIONS(1401),
    [anon_sym_delete] = ACTIONS(1401),
    [anon_sym_PLUS_PLUS] = ACTIONS(1403),
    [anon_sym_DASH_DASH] = ACTIONS(1403),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1405),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1571),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1379),
    [anon_sym_readonly] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(1379),
    [anon_sym_set] = ACTIONS(1379),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_public] = ACTIONS(1379),
    [anon_sym_private] = ACTIONS(1379),
    [anon_sym_protected] = ACTIONS(1379),
    [anon_sym_override] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1379),
    [anon_sym_any] = ACTIONS(1379),
    [anon_sym_number] = ACTIONS(1379),
    [anon_sym_boolean] = ACTIONS(1379),
    [anon_sym_string] = ACTIONS(1379),
    [anon_sym_symbol] = ACTIONS(1379),
    [anon_sym_object] = ACTIONS(1379),
    [anon_sym_property] = ACTIONS(1379),
    [anon_sym_signal] = ACTIONS(1379),
    [anon_sym_on] = ACTIONS(1379),
    [anon_sym_required] = ACTIONS(1379),
    [anon_sym_component] = ACTIONS(1379),
    [anon_sym_extends] = ACTIONS(1711),
    [sym_html_comment] = ACTIONS(5),
  },
  [272] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2204),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_spread_element] = STATE(5328),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(272),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [aux_sym_array_repeat1] = STATE(5329),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(2044),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_RPAREN] = ACTIONS(2060),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2048),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [273] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_expression] = STATE(2429),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5939),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(273),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1523),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1555),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_COMMA] = ACTIONS(1709),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_of] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1709),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_GT] = ACTIONS(1709),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_using] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1709),
    [anon_sym_PIPE] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_property] = ACTIONS(1181),
    [anon_sym_signal] = ACTIONS(1181),
    [anon_sym_on] = ACTIONS(1181),
    [anon_sym_required] = ACTIONS(1181),
    [anon_sym_component] = ACTIONS(1181),
    [anon_sym_extends] = ACTIONS(1711),
    [sym_html_comment] = ACTIONS(5),
  },
  [274] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2125),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_spread_element] = STATE(5173),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(274),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [aux_sym_array_repeat1] = STATE(5180),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(2044),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_RPAREN] = ACTIONS(2062),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2048),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [275] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(275),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(3294),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_EQ] = ACTIONS(1013),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_EQ_GT] = ACTIONS(1003),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(80),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(82),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(1771),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_void] = ACTIONS(130),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(118),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_satisfies] = ACTIONS(30),
    [anon_sym_implements] = ACTIONS(30),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [276] = {
    [sym_import] = STATE(3688),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2728),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(276),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym__type_query_member_expression] = STATE(3126),
    [sym__type_query_subscript_expression] = STATE(3129),
    [sym__type_query_call_expression] = STATE(3176),
    [sym__type_query_instantiation_expression] = STATE(3186),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(2064),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [sym_html_comment] = ACTIONS(5),
  },
  [277] = {
    [sym_import] = STATE(3657),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2079),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(277),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym__type_query_member_expression] = STATE(3126),
    [sym__type_query_subscript_expression] = STATE(3129),
    [sym__type_query_call_expression] = STATE(3176),
    [sym__type_query_instantiation_expression] = STATE(3186),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(2066),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [278] = {
    [sym_import] = STATE(3654),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1791),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(278),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym__type_query_member_expression] = STATE(3169),
    [sym__type_query_subscript_expression] = STATE(3171),
    [sym__type_query_call_expression] = STATE(3335),
    [sym__type_query_instantiation_expression] = STATE(3474),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(2068),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [279] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(279),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(3294),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_EQ] = ACTIONS(1027),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_COLON] = ACTIONS(70),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_EQ_GT] = ACTIONS(1037),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(80),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(82),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(1771),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_void] = ACTIONS(130),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(118),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_satisfies] = ACTIONS(30),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [280] = {
    [sym_import] = STATE(3607),
    [sym_parenthesized_expression] = STATE(1520),
    [sym_expression] = STATE(2618),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1520),
    [sym_subscript_expression] = STATE(1520),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6049),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(280),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1520),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym__type_query_member_expression] = STATE(3126),
    [sym__type_query_subscript_expression] = STATE(3129),
    [sym__type_query_call_expression] = STATE(3176),
    [sym__type_query_instantiation_expression] = STATE(3186),
    [sym_type_arguments] = STATE(556),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(2070),
    [anon_sym_export] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1229),
    [anon_sym_namespace] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1229),
    [anon_sym_let] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_of] = ACTIONS(1229),
    [anon_sym_yield] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1551),
    [anon_sym_using] = ACTIONS(1247),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1257),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_readonly] = ACTIONS(1229),
    [anon_sym_get] = ACTIONS(1229),
    [anon_sym_set] = ACTIONS(1229),
    [anon_sym_declare] = ACTIONS(1229),
    [anon_sym_public] = ACTIONS(1229),
    [anon_sym_private] = ACTIONS(1229),
    [anon_sym_protected] = ACTIONS(1229),
    [anon_sym_override] = ACTIONS(1229),
    [anon_sym_module] = ACTIONS(1229),
    [anon_sym_any] = ACTIONS(1229),
    [anon_sym_number] = ACTIONS(1229),
    [anon_sym_boolean] = ACTIONS(1229),
    [anon_sym_string] = ACTIONS(1229),
    [anon_sym_symbol] = ACTIONS(1229),
    [anon_sym_object] = ACTIONS(1229),
    [anon_sym_property] = ACTIONS(1229),
    [anon_sym_signal] = ACTIONS(1229),
    [anon_sym_on] = ACTIONS(1229),
    [anon_sym_required] = ACTIONS(1229),
    [anon_sym_component] = ACTIONS(1229),
    [sym_html_comment] = ACTIONS(5),
  },
  [281] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(281),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(3294),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_EQ] = ACTIONS(863),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_COLON] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(80),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(82),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(1771),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_void] = ACTIONS(130),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(118),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_satisfies] = ACTIONS(30),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [282] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2302),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_assignment_pattern] = STATE(5607),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1373),
    [sym_subscript_expression] = STATE(1373),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3818),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(282),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(5163),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1373),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1673),
    [anon_sym_export] = ACTIONS(684),
    [anon_sym_type] = ACTIONS(684),
    [anon_sym_namespace] = ACTIONS(688),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(684),
    [anon_sym_let] = ACTIONS(684),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(684),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(706),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1669),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1671),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(684),
    [anon_sym_readonly] = ACTIONS(684),
    [anon_sym_get] = ACTIONS(684),
    [anon_sym_set] = ACTIONS(684),
    [anon_sym_declare] = ACTIONS(684),
    [anon_sym_public] = ACTIONS(684),
    [anon_sym_private] = ACTIONS(684),
    [anon_sym_protected] = ACTIONS(684),
    [anon_sym_override] = ACTIONS(684),
    [anon_sym_module] = ACTIONS(684),
    [anon_sym_any] = ACTIONS(684),
    [anon_sym_number] = ACTIONS(684),
    [anon_sym_boolean] = ACTIONS(684),
    [anon_sym_string] = ACTIONS(684),
    [anon_sym_symbol] = ACTIONS(684),
    [anon_sym_object] = ACTIONS(684),
    [anon_sym_property] = ACTIONS(684),
    [anon_sym_signal] = ACTIONS(684),
    [anon_sym_on] = ACTIONS(684),
    [anon_sym_required] = ACTIONS(684),
    [anon_sym_component] = ACTIONS(684),
    [sym_html_comment] = ACTIONS(5),
  },
  [283] = {
    [sym_import] = STATE(3578),
    [sym_parenthesized_expression] = STATE(1487),
    [sym_expression] = STATE(2247),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1487),
    [sym_subscript_expression] = STATE(1487),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3189),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6145),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(283),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1487),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym__type_query_member_expression] = STATE(3126),
    [sym__type_query_subscript_expression] = STATE(3129),
    [sym__type_query_call_expression] = STATE(3176),
    [sym__type_query_instantiation_expression] = STATE(3186),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(2072),
    [anon_sym_export] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1131),
    [anon_sym_namespace] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1159),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_let] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_of] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1149),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_using] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1159),
    [anon_sym_delete] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1167),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1131),
    [anon_sym_readonly] = ACTIONS(1131),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_declare] = ACTIONS(1131),
    [anon_sym_public] = ACTIONS(1131),
    [anon_sym_private] = ACTIONS(1131),
    [anon_sym_protected] = ACTIONS(1131),
    [anon_sym_override] = ACTIONS(1131),
    [anon_sym_module] = ACTIONS(1131),
    [anon_sym_any] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_boolean] = ACTIONS(1131),
    [anon_sym_string] = ACTIONS(1131),
    [anon_sym_symbol] = ACTIONS(1131),
    [anon_sym_object] = ACTIONS(1131),
    [anon_sym_property] = ACTIONS(1131),
    [anon_sym_signal] = ACTIONS(1131),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_required] = ACTIONS(1131),
    [anon_sym_component] = ACTIONS(1131),
    [sym_html_comment] = ACTIONS(5),
  },
  [284] = {
    [sym_import] = STATE(3688),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2728),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(284),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym__type_query_member_expression] = STATE(3126),
    [sym__type_query_subscript_expression] = STATE(3129),
    [sym__type_query_call_expression] = STATE(3176),
    [sym__type_query_instantiation_expression] = STATE(3186),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(2074),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [sym_html_comment] = ACTIONS(5),
  },
  [285] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(285),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(3294),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_EQ] = ACTIONS(1005),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_RBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_EQ_GT] = ACTIONS(980),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(80),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(82),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(1771),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_void] = ACTIONS(130),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(118),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_satisfies] = ACTIONS(30),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [286] = {
    [sym_import] = STATE(3697),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1791),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(286),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym__type_query_member_expression] = STATE(3126),
    [sym__type_query_subscript_expression] = STATE(3129),
    [sym__type_query_call_expression] = STATE(3176),
    [sym__type_query_instantiation_expression] = STATE(3186),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(2076),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [287] = {
    [sym_import] = STATE(3688),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2728),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(287),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym__type_query_member_expression] = STATE(3126),
    [sym__type_query_subscript_expression] = STATE(3129),
    [sym__type_query_call_expression] = STATE(3176),
    [sym__type_query_instantiation_expression] = STATE(3186),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(2078),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [sym_html_comment] = ACTIONS(5),
  },
  [288] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_assignment_pattern] = STATE(5607),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3951),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(288),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(5163),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(799),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_namespace] = ACTIONS(32),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(23),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(64),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(809),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(821),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(23),
    [anon_sym_readonly] = ACTIONS(23),
    [anon_sym_get] = ACTIONS(23),
    [anon_sym_set] = ACTIONS(23),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_public] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(23),
    [anon_sym_protected] = ACTIONS(23),
    [anon_sym_override] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(23),
    [anon_sym_number] = ACTIONS(23),
    [anon_sym_boolean] = ACTIONS(23),
    [anon_sym_string] = ACTIONS(23),
    [anon_sym_symbol] = ACTIONS(23),
    [anon_sym_object] = ACTIONS(23),
    [anon_sym_property] = ACTIONS(23),
    [anon_sym_signal] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [anon_sym_required] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(23),
    [sym_html_comment] = ACTIONS(5),
  },
  [289] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3951),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(289),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(4322),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_override_modifier] = STATE(306),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(799),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_namespace] = ACTIONS(32),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(23),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(64),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(809),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(825),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(821),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(23),
    [anon_sym_readonly] = ACTIONS(2080),
    [anon_sym_get] = ACTIONS(23),
    [anon_sym_set] = ACTIONS(23),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_public] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(23),
    [anon_sym_protected] = ACTIONS(23),
    [anon_sym_override] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(23),
    [anon_sym_number] = ACTIONS(23),
    [anon_sym_boolean] = ACTIONS(23),
    [anon_sym_string] = ACTIONS(23),
    [anon_sym_symbol] = ACTIONS(23),
    [anon_sym_object] = ACTIONS(23),
    [anon_sym_property] = ACTIONS(23),
    [anon_sym_signal] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [anon_sym_required] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(23),
    [sym_html_comment] = ACTIONS(5),
  },
  [290] = {
    [sym_import] = STATE(3657),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_expression] = STATE(2084),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6164),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3271),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6167),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(290),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1451),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym__type_query_member_expression] = STATE(3126),
    [sym__type_query_subscript_expression] = STATE(3129),
    [sym__type_query_call_expression] = STATE(3176),
    [sym__type_query_instantiation_expression] = STATE(3186),
    [sym_type_arguments] = STATE(522),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(2082),
    [anon_sym_export] = ACTIONS(1327),
    [anon_sym_type] = ACTIONS(1327),
    [anon_sym_namespace] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1349),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_let] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1333),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_of] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1527),
    [anon_sym_using] = ACTIONS(1343),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_SLASH] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_void] = ACTIONS(1349),
    [anon_sym_delete] = ACTIONS(1349),
    [anon_sym_PLUS_PLUS] = ACTIONS(1351),
    [anon_sym_DASH_DASH] = ACTIONS(1351),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1353),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1327),
    [anon_sym_readonly] = ACTIONS(1327),
    [anon_sym_get] = ACTIONS(1327),
    [anon_sym_set] = ACTIONS(1327),
    [anon_sym_declare] = ACTIONS(1327),
    [anon_sym_public] = ACTIONS(1327),
    [anon_sym_private] = ACTIONS(1327),
    [anon_sym_protected] = ACTIONS(1327),
    [anon_sym_override] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_any] = ACTIONS(1327),
    [anon_sym_number] = ACTIONS(1327),
    [anon_sym_boolean] = ACTIONS(1327),
    [anon_sym_string] = ACTIONS(1327),
    [anon_sym_symbol] = ACTIONS(1327),
    [anon_sym_object] = ACTIONS(1327),
    [anon_sym_property] = ACTIONS(1327),
    [anon_sym_signal] = ACTIONS(1327),
    [anon_sym_on] = ACTIONS(1327),
    [anon_sym_required] = ACTIONS(1327),
    [anon_sym_component] = ACTIONS(1327),
    [sym_html_comment] = ACTIONS(5),
  },
  [291] = {
    [sym_import] = STATE(3697),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1791),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(291),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym__type_query_member_expression] = STATE(3126),
    [sym__type_query_subscript_expression] = STATE(3129),
    [sym__type_query_call_expression] = STATE(3176),
    [sym__type_query_instantiation_expression] = STATE(3186),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [292] = {
    [sym_import] = STATE(3590),
    [sym_expression_statement] = STATE(317),
    [sym_empty_statement] = STATE(317),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5868),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(292),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [293] = {
    [sym_import] = STATE(3590),
    [sym_expression_statement] = STATE(314),
    [sym_empty_statement] = STATE(314),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5868),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(293),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [294] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3951),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(294),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(4416),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_override_modifier] = STATE(308),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(799),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_namespace] = ACTIONS(32),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(23),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(64),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(809),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(2086),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(821),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(23),
    [anon_sym_readonly] = ACTIONS(2088),
    [anon_sym_get] = ACTIONS(23),
    [anon_sym_set] = ACTIONS(23),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_public] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(23),
    [anon_sym_protected] = ACTIONS(23),
    [anon_sym_override] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(23),
    [anon_sym_number] = ACTIONS(23),
    [anon_sym_boolean] = ACTIONS(23),
    [anon_sym_string] = ACTIONS(23),
    [anon_sym_symbol] = ACTIONS(23),
    [anon_sym_object] = ACTIONS(23),
    [anon_sym_property] = ACTIONS(23),
    [anon_sym_signal] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [anon_sym_required] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(23),
    [sym_html_comment] = ACTIONS(5),
  },
  [295] = {
    [sym_import] = STATE(3688),
    [sym_parenthesized_expression] = STATE(1513),
    [sym_expression] = STATE(2655),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6293),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1513),
    [sym_subscript_expression] = STATE(1513),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3245),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6295),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(295),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1513),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym__type_query_member_expression] = STATE(3126),
    [sym__type_query_subscript_expression] = STATE(3129),
    [sym__type_query_call_expression] = STATE(3176),
    [sym__type_query_instantiation_expression] = STATE(3186),
    [sym_type_arguments] = STATE(455),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(2090),
    [anon_sym_export] = ACTIONS(1379),
    [anon_sym_type] = ACTIONS(1379),
    [anon_sym_namespace] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1379),
    [anon_sym_let] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1385),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_of] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1389),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1391),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_using] = ACTIONS(1395),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_void] = ACTIONS(1401),
    [anon_sym_delete] = ACTIONS(1401),
    [anon_sym_PLUS_PLUS] = ACTIONS(1403),
    [anon_sym_DASH_DASH] = ACTIONS(1403),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1405),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1571),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1379),
    [anon_sym_readonly] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(1379),
    [anon_sym_set] = ACTIONS(1379),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_public] = ACTIONS(1379),
    [anon_sym_private] = ACTIONS(1379),
    [anon_sym_protected] = ACTIONS(1379),
    [anon_sym_override] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1379),
    [anon_sym_any] = ACTIONS(1379),
    [anon_sym_number] = ACTIONS(1379),
    [anon_sym_boolean] = ACTIONS(1379),
    [anon_sym_string] = ACTIONS(1379),
    [anon_sym_symbol] = ACTIONS(1379),
    [anon_sym_object] = ACTIONS(1379),
    [anon_sym_property] = ACTIONS(1379),
    [anon_sym_signal] = ACTIONS(1379),
    [anon_sym_on] = ACTIONS(1379),
    [anon_sym_required] = ACTIONS(1379),
    [anon_sym_component] = ACTIONS(1379),
    [sym_html_comment] = ACTIONS(5),
  },
  [296] = {
    [sym_import] = STATE(3688),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_expression] = STATE(2429),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5939),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(296),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1523),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym__type_query_member_expression] = STATE(3126),
    [sym__type_query_subscript_expression] = STATE(3129),
    [sym__type_query_call_expression] = STATE(3176),
    [sym__type_query_instantiation_expression] = STATE(3186),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(2092),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_of] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_using] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_property] = ACTIONS(1181),
    [anon_sym_signal] = ACTIONS(1181),
    [anon_sym_on] = ACTIONS(1181),
    [anon_sym_required] = ACTIONS(1181),
    [anon_sym_component] = ACTIONS(1181),
    [sym_html_comment] = ACTIONS(5),
  },
  [297] = {
    [sym_import] = STATE(3697),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1791),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(297),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym__type_query_member_expression] = STATE(3126),
    [sym__type_query_subscript_expression] = STATE(3129),
    [sym__type_query_call_expression] = STATE(3176),
    [sym__type_query_instantiation_expression] = STATE(3186),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(2094),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [298] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(298),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(3294),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_EQ] = ACTIONS(1047),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(30),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_EQ_GT] = ACTIONS(1053),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(80),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(82),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(1771),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_void] = ACTIONS(130),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(118),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_satisfies] = ACTIONS(30),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [299] = {
    [sym_import] = STATE(3590),
    [sym_expression_statement] = STATE(312),
    [sym_empty_statement] = STATE(312),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5868),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(299),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [300] = {
    [sym_import] = STATE(3697),
    [sym_parenthesized_expression] = STATE(1473),
    [sym_expression] = STATE(2110),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6272),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1473),
    [sym_subscript_expression] = STATE(1473),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3246),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6274),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(300),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1473),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym__type_query_member_expression] = STATE(3126),
    [sym__type_query_subscript_expression] = STATE(3129),
    [sym__type_query_call_expression] = STATE(3176),
    [sym__type_query_instantiation_expression] = STATE(3186),
    [sym_type_arguments] = STATE(541),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(2096),
    [anon_sym_export] = ACTIONS(1415),
    [anon_sym_type] = ACTIONS(1415),
    [anon_sym_namespace] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1437),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1415),
    [anon_sym_let] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1421),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1423),
    [anon_sym_of] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1425),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1427),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1543),
    [anon_sym_using] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1421),
    [anon_sym_void] = ACTIONS(1437),
    [anon_sym_delete] = ACTIONS(1437),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1441),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1415),
    [anon_sym_readonly] = ACTIONS(1415),
    [anon_sym_get] = ACTIONS(1415),
    [anon_sym_set] = ACTIONS(1415),
    [anon_sym_declare] = ACTIONS(1415),
    [anon_sym_public] = ACTIONS(1415),
    [anon_sym_private] = ACTIONS(1415),
    [anon_sym_protected] = ACTIONS(1415),
    [anon_sym_override] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_any] = ACTIONS(1415),
    [anon_sym_number] = ACTIONS(1415),
    [anon_sym_boolean] = ACTIONS(1415),
    [anon_sym_string] = ACTIONS(1415),
    [anon_sym_symbol] = ACTIONS(1415),
    [anon_sym_object] = ACTIONS(1415),
    [anon_sym_property] = ACTIONS(1415),
    [anon_sym_signal] = ACTIONS(1415),
    [anon_sym_on] = ACTIONS(1415),
    [anon_sym_required] = ACTIONS(1415),
    [anon_sym_component] = ACTIONS(1415),
    [sym_html_comment] = ACTIONS(5),
  },
  [301] = {
    [sym_comment] = STATE(301),
    [sym_identifier] = ACTIONS(2098),
    [anon_sym_export] = ACTIONS(2098),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2098),
    [anon_sym_EQ] = ACTIONS(134),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2098),
    [anon_sym_LBRACE] = ACTIONS(2100),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_typeof] = ACTIONS(2098),
    [anon_sym_import] = ACTIONS(2098),
    [anon_sym_from] = ACTIONS(2098),
    [anon_sym_let] = ACTIONS(2098),
    [anon_sym_BANG] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(2100),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(2098),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2098),
    [anon_sym_COLON] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(2098),
    [anon_sym_LBRACK] = ACTIONS(2100),
    [anon_sym_LTtemplate_GT] = ACTIONS(2100),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(2100),
    [anon_sym_SQUOTE] = ACTIONS(2100),
    [anon_sym_class] = ACTIONS(2098),
    [anon_sym_async] = ACTIONS(2098),
    [anon_sym_function] = ACTIONS(2098),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2098),
    [anon_sym_using] = ACTIONS(2098),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(2098),
    [anon_sym_DASH] = ACTIONS(2098),
    [anon_sym_SLASH] = ACTIONS(2098),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2098),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(2100),
    [anon_sym_void] = ACTIONS(2098),
    [anon_sym_delete] = ACTIONS(2098),
    [anon_sym_PLUS_PLUS] = ACTIONS(2100),
    [anon_sym_DASH_DASH] = ACTIONS(2100),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2100),
    [sym_number] = ACTIONS(2100),
    [sym_private_property_identifier] = ACTIONS(2100),
    [sym_this] = ACTIONS(2098),
    [sym_super] = ACTIONS(2098),
    [sym_true] = ACTIONS(2098),
    [sym_false] = ACTIONS(2098),
    [sym_null] = ACTIONS(2098),
    [sym_undefined] = ACTIONS(2098),
    [anon_sym_AT] = ACTIONS(2100),
    [anon_sym_static] = ACTIONS(2098),
    [anon_sym_readonly] = ACTIONS(2098),
    [anon_sym_get] = ACTIONS(2098),
    [anon_sym_set] = ACTIONS(2098),
    [anon_sym_QMARK] = ACTIONS(823),
    [anon_sym_declare] = ACTIONS(2098),
    [anon_sym_public] = ACTIONS(2098),
    [anon_sym_private] = ACTIONS(2098),
    [anon_sym_protected] = ACTIONS(2098),
    [anon_sym_override] = ACTIONS(2098),
    [anon_sym_module] = ACTIONS(2098),
    [anon_sym_any] = ACTIONS(2098),
    [anon_sym_number] = ACTIONS(2098),
    [anon_sym_boolean] = ACTIONS(2098),
    [anon_sym_string] = ACTIONS(2098),
    [anon_sym_symbol] = ACTIONS(2098),
    [anon_sym_object] = ACTIONS(2098),
    [anon_sym_property] = ACTIONS(2098),
    [anon_sym_signal] = ACTIONS(2098),
    [anon_sym_on] = ACTIONS(2098),
    [anon_sym_required] = ACTIONS(2098),
    [anon_sym_component] = ACTIONS(2098),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [302] = {
    [sym_comment] = STATE(302),
    [sym_identifier] = ACTIONS(2102),
    [anon_sym_export] = ACTIONS(2102),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2102),
    [anon_sym_EQ] = ACTIONS(134),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2102),
    [anon_sym_LBRACE] = ACTIONS(2104),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_typeof] = ACTIONS(2102),
    [anon_sym_import] = ACTIONS(2102),
    [anon_sym_from] = ACTIONS(2102),
    [anon_sym_let] = ACTIONS(2102),
    [anon_sym_BANG] = ACTIONS(2102),
    [anon_sym_LPAREN] = ACTIONS(2104),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(2102),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2102),
    [anon_sym_COLON] = ACTIONS(137),
    [anon_sym_yield] = ACTIONS(2102),
    [anon_sym_LBRACK] = ACTIONS(2104),
    [anon_sym_LTtemplate_GT] = ACTIONS(2104),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(2104),
    [anon_sym_SQUOTE] = ACTIONS(2104),
    [anon_sym_class] = ACTIONS(2102),
    [anon_sym_async] = ACTIONS(2102),
    [anon_sym_function] = ACTIONS(2102),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2102),
    [anon_sym_using] = ACTIONS(2102),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2104),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(2102),
    [anon_sym_DASH] = ACTIONS(2102),
    [anon_sym_SLASH] = ACTIONS(2102),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2102),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(2104),
    [anon_sym_void] = ACTIONS(2102),
    [anon_sym_delete] = ACTIONS(2102),
    [anon_sym_PLUS_PLUS] = ACTIONS(2104),
    [anon_sym_DASH_DASH] = ACTIONS(2104),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2104),
    [sym_number] = ACTIONS(2104),
    [sym_private_property_identifier] = ACTIONS(2104),
    [sym_this] = ACTIONS(2102),
    [sym_super] = ACTIONS(2102),
    [sym_true] = ACTIONS(2102),
    [sym_false] = ACTIONS(2102),
    [sym_null] = ACTIONS(2102),
    [sym_undefined] = ACTIONS(2102),
    [anon_sym_AT] = ACTIONS(2104),
    [anon_sym_static] = ACTIONS(2102),
    [anon_sym_readonly] = ACTIONS(2102),
    [anon_sym_get] = ACTIONS(2102),
    [anon_sym_set] = ACTIONS(2102),
    [anon_sym_QMARK] = ACTIONS(823),
    [anon_sym_declare] = ACTIONS(2102),
    [anon_sym_public] = ACTIONS(2102),
    [anon_sym_private] = ACTIONS(2102),
    [anon_sym_protected] = ACTIONS(2102),
    [anon_sym_override] = ACTIONS(2102),
    [anon_sym_module] = ACTIONS(2102),
    [anon_sym_any] = ACTIONS(2102),
    [anon_sym_number] = ACTIONS(2102),
    [anon_sym_boolean] = ACTIONS(2102),
    [anon_sym_string] = ACTIONS(2102),
    [anon_sym_symbol] = ACTIONS(2102),
    [anon_sym_object] = ACTIONS(2102),
    [anon_sym_property] = ACTIONS(2102),
    [anon_sym_signal] = ACTIONS(2102),
    [anon_sym_on] = ACTIONS(2102),
    [anon_sym_required] = ACTIONS(2102),
    [anon_sym_component] = ACTIONS(2102),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [303] = {
    [sym_comment] = STATE(303),
    [sym_identifier] = ACTIONS(2102),
    [anon_sym_export] = ACTIONS(2102),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2102),
    [anon_sym_EQ] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2102),
    [anon_sym_LBRACE] = ACTIONS(2104),
    [anon_sym_COMMA] = ACTIONS(36),
    [anon_sym_typeof] = ACTIONS(2102),
    [anon_sym_import] = ACTIONS(2102),
    [anon_sym_from] = ACTIONS(2102),
    [anon_sym_let] = ACTIONS(2102),
    [anon_sym_BANG] = ACTIONS(2102),
    [anon_sym_LPAREN] = ACTIONS(2104),
    [anon_sym_RPAREN] = ACTIONS(36),
    [anon_sym_await] = ACTIONS(2102),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2102),
    [anon_sym_COLON] = ACTIONS(36),
    [anon_sym_yield] = ACTIONS(2102),
    [anon_sym_LBRACK] = ACTIONS(2104),
    [anon_sym_LTtemplate_GT] = ACTIONS(2104),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(2104),
    [anon_sym_SQUOTE] = ACTIONS(2104),
    [anon_sym_class] = ACTIONS(2102),
    [anon_sym_async] = ACTIONS(2102),
    [anon_sym_function] = ACTIONS(2102),
    [anon_sym_EQ_GT] = ACTIONS(68),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2102),
    [anon_sym_using] = ACTIONS(2102),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2104),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(2102),
    [anon_sym_DASH] = ACTIONS(2102),
    [anon_sym_SLASH] = ACTIONS(2102),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2102),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(2104),
    [anon_sym_void] = ACTIONS(2102),
    [anon_sym_delete] = ACTIONS(2102),
    [anon_sym_PLUS_PLUS] = ACTIONS(2104),
    [anon_sym_DASH_DASH] = ACTIONS(2104),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2104),
    [sym_number] = ACTIONS(2104),
    [sym_private_property_identifier] = ACTIONS(2104),
    [sym_this] = ACTIONS(2102),
    [sym_super] = ACTIONS(2102),
    [sym_true] = ACTIONS(2102),
    [sym_false] = ACTIONS(2102),
    [sym_null] = ACTIONS(2102),
    [sym_undefined] = ACTIONS(2102),
    [anon_sym_AT] = ACTIONS(2104),
    [anon_sym_static] = ACTIONS(2102),
    [anon_sym_readonly] = ACTIONS(2102),
    [anon_sym_get] = ACTIONS(2102),
    [anon_sym_set] = ACTIONS(2102),
    [anon_sym_QMARK] = ACTIONS(823),
    [anon_sym_declare] = ACTIONS(2102),
    [anon_sym_public] = ACTIONS(2102),
    [anon_sym_private] = ACTIONS(2102),
    [anon_sym_protected] = ACTIONS(2102),
    [anon_sym_override] = ACTIONS(2102),
    [anon_sym_module] = ACTIONS(2102),
    [anon_sym_any] = ACTIONS(2102),
    [anon_sym_number] = ACTIONS(2102),
    [anon_sym_boolean] = ACTIONS(2102),
    [anon_sym_string] = ACTIONS(2102),
    [anon_sym_symbol] = ACTIONS(2102),
    [anon_sym_object] = ACTIONS(2102),
    [anon_sym_property] = ACTIONS(2102),
    [anon_sym_signal] = ACTIONS(2102),
    [anon_sym_on] = ACTIONS(2102),
    [anon_sym_required] = ACTIONS(2102),
    [anon_sym_component] = ACTIONS(2102),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [304] = {
    [sym_comment] = STATE(304),
    [sym_identifier] = ACTIONS(2098),
    [anon_sym_export] = ACTIONS(2098),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2098),
    [anon_sym_EQ] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2098),
    [anon_sym_LBRACE] = ACTIONS(2100),
    [anon_sym_COMMA] = ACTIONS(36),
    [anon_sym_typeof] = ACTIONS(2098),
    [anon_sym_import] = ACTIONS(2098),
    [anon_sym_from] = ACTIONS(2098),
    [anon_sym_let] = ACTIONS(2098),
    [anon_sym_BANG] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(2100),
    [anon_sym_RPAREN] = ACTIONS(36),
    [anon_sym_await] = ACTIONS(2098),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2098),
    [anon_sym_COLON] = ACTIONS(36),
    [anon_sym_yield] = ACTIONS(2098),
    [anon_sym_LBRACK] = ACTIONS(2100),
    [anon_sym_LTtemplate_GT] = ACTIONS(2100),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(2100),
    [anon_sym_SQUOTE] = ACTIONS(2100),
    [anon_sym_class] = ACTIONS(2098),
    [anon_sym_async] = ACTIONS(2098),
    [anon_sym_function] = ACTIONS(2098),
    [anon_sym_EQ_GT] = ACTIONS(68),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2098),
    [anon_sym_using] = ACTIONS(2098),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2100),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(2098),
    [anon_sym_DASH] = ACTIONS(2098),
    [anon_sym_SLASH] = ACTIONS(2098),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2098),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_TILDE] = ACTIONS(2100),
    [anon_sym_void] = ACTIONS(2098),
    [anon_sym_delete] = ACTIONS(2098),
    [anon_sym_PLUS_PLUS] = ACTIONS(2100),
    [anon_sym_DASH_DASH] = ACTIONS(2100),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2100),
    [sym_number] = ACTIONS(2100),
    [sym_private_property_identifier] = ACTIONS(2100),
    [sym_this] = ACTIONS(2098),
    [sym_super] = ACTIONS(2098),
    [sym_true] = ACTIONS(2098),
    [sym_false] = ACTIONS(2098),
    [sym_null] = ACTIONS(2098),
    [sym_undefined] = ACTIONS(2098),
    [anon_sym_AT] = ACTIONS(2100),
    [anon_sym_static] = ACTIONS(2098),
    [anon_sym_readonly] = ACTIONS(2098),
    [anon_sym_get] = ACTIONS(2098),
    [anon_sym_set] = ACTIONS(2098),
    [anon_sym_QMARK] = ACTIONS(823),
    [anon_sym_declare] = ACTIONS(2098),
    [anon_sym_public] = ACTIONS(2098),
    [anon_sym_private] = ACTIONS(2098),
    [anon_sym_protected] = ACTIONS(2098),
    [anon_sym_override] = ACTIONS(2098),
    [anon_sym_module] = ACTIONS(2098),
    [anon_sym_any] = ACTIONS(2098),
    [anon_sym_number] = ACTIONS(2098),
    [anon_sym_boolean] = ACTIONS(2098),
    [anon_sym_string] = ACTIONS(2098),
    [anon_sym_symbol] = ACTIONS(2098),
    [anon_sym_object] = ACTIONS(2098),
    [anon_sym_property] = ACTIONS(2098),
    [anon_sym_signal] = ACTIONS(2098),
    [anon_sym_on] = ACTIONS(2098),
    [anon_sym_required] = ACTIONS(2098),
    [anon_sym_component] = ACTIONS(2098),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [305] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2043),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5831),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(305),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym__automatic_semicolon] = ACTIONS(2106),
    [sym_html_comment] = ACTIONS(5),
  },
  [306] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3951),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(306),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(4411),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(799),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_namespace] = ACTIONS(32),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(23),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(64),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(809),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(829),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(821),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(23),
    [anon_sym_readonly] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(23),
    [anon_sym_set] = ACTIONS(23),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_public] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(23),
    [anon_sym_protected] = ACTIONS(23),
    [anon_sym_override] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(23),
    [anon_sym_number] = ACTIONS(23),
    [anon_sym_boolean] = ACTIONS(23),
    [anon_sym_string] = ACTIONS(23),
    [anon_sym_symbol] = ACTIONS(23),
    [anon_sym_object] = ACTIONS(23),
    [anon_sym_property] = ACTIONS(23),
    [anon_sym_signal] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [anon_sym_required] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(23),
    [sym_html_comment] = ACTIONS(5),
  },
  [307] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3951),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(307),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(4418),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(799),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_namespace] = ACTIONS(32),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(23),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(64),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(809),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(2110),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(821),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(23),
    [anon_sym_readonly] = ACTIONS(2112),
    [anon_sym_get] = ACTIONS(23),
    [anon_sym_set] = ACTIONS(23),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_public] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(23),
    [anon_sym_protected] = ACTIONS(23),
    [anon_sym_override] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(23),
    [anon_sym_number] = ACTIONS(23),
    [anon_sym_boolean] = ACTIONS(23),
    [anon_sym_string] = ACTIONS(23),
    [anon_sym_symbol] = ACTIONS(23),
    [anon_sym_object] = ACTIONS(23),
    [anon_sym_property] = ACTIONS(23),
    [anon_sym_signal] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [anon_sym_required] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(23),
    [sym_html_comment] = ACTIONS(5),
  },
  [308] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3951),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(308),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(4524),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(799),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_namespace] = ACTIONS(32),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(23),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(64),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(809),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(2114),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(821),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(23),
    [anon_sym_readonly] = ACTIONS(2116),
    [anon_sym_get] = ACTIONS(23),
    [anon_sym_set] = ACTIONS(23),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_public] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(23),
    [anon_sym_protected] = ACTIONS(23),
    [anon_sym_override] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(23),
    [anon_sym_number] = ACTIONS(23),
    [anon_sym_boolean] = ACTIONS(23),
    [anon_sym_string] = ACTIONS(23),
    [anon_sym_symbol] = ACTIONS(23),
    [anon_sym_object] = ACTIONS(23),
    [anon_sym_property] = ACTIONS(23),
    [anon_sym_signal] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [anon_sym_required] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(23),
    [sym_html_comment] = ACTIONS(5),
  },
  [309] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(309),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(3294),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_EQ] = ACTIONS(863),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(80),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(82),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(1771),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_void] = ACTIONS(130),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(118),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_satisfies] = ACTIONS(30),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [310] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3951),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(310),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_pattern] = STATE(4322),
    [sym_rest_pattern] = STATE(3949),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(799),
    [anon_sym_export] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(23),
    [anon_sym_namespace] = ACTIONS(32),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(23),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(23),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(64),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(809),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(78),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(825),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(821),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(23),
    [anon_sym_readonly] = ACTIONS(2080),
    [anon_sym_get] = ACTIONS(23),
    [anon_sym_set] = ACTIONS(23),
    [anon_sym_declare] = ACTIONS(23),
    [anon_sym_public] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(23),
    [anon_sym_protected] = ACTIONS(23),
    [anon_sym_override] = ACTIONS(23),
    [anon_sym_module] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(23),
    [anon_sym_number] = ACTIONS(23),
    [anon_sym_boolean] = ACTIONS(23),
    [anon_sym_string] = ACTIONS(23),
    [anon_sym_symbol] = ACTIONS(23),
    [anon_sym_object] = ACTIONS(23),
    [anon_sym_property] = ACTIONS(23),
    [anon_sym_signal] = ACTIONS(23),
    [anon_sym_on] = ACTIONS(23),
    [anon_sym_required] = ACTIONS(23),
    [anon_sym_component] = ACTIONS(23),
    [sym_html_comment] = ACTIONS(5),
  },
  [311] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1961),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5568),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(311),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_SEMI] = ACTIONS(2118),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym__automatic_semicolon] = ACTIONS(2118),
    [sym_html_comment] = ACTIONS(5),
  },
  [312] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2136),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_sequence_expression] = STATE(6131),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(312),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_RPAREN] = ACTIONS(2120),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [313] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1498),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1498),
    [sym_subscript_expression] = STATE(1498),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5472),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(313),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1498),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(2122),
    [anon_sym_export] = ACTIONS(2124),
    [anon_sym_type] = ACTIONS(2124),
    [anon_sym_namespace] = ACTIONS(2126),
    [anon_sym_LBRACE] = ACTIONS(2128),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(2124),
    [anon_sym_var] = ACTIONS(2130),
    [anon_sym_let] = ACTIONS(2132),
    [anon_sym_const] = ACTIONS(2134),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(2124),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(2136),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(2138),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(2140),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(2142),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(2124),
    [anon_sym_readonly] = ACTIONS(2124),
    [anon_sym_get] = ACTIONS(2124),
    [anon_sym_set] = ACTIONS(2124),
    [anon_sym_declare] = ACTIONS(2124),
    [anon_sym_public] = ACTIONS(2124),
    [anon_sym_private] = ACTIONS(2124),
    [anon_sym_protected] = ACTIONS(2124),
    [anon_sym_override] = ACTIONS(2124),
    [anon_sym_module] = ACTIONS(2124),
    [anon_sym_any] = ACTIONS(2124),
    [anon_sym_number] = ACTIONS(2124),
    [anon_sym_boolean] = ACTIONS(2124),
    [anon_sym_string] = ACTIONS(2124),
    [anon_sym_symbol] = ACTIONS(2124),
    [anon_sym_object] = ACTIONS(2124),
    [anon_sym_property] = ACTIONS(2124),
    [anon_sym_signal] = ACTIONS(2124),
    [anon_sym_on] = ACTIONS(2124),
    [anon_sym_required] = ACTIONS(2124),
    [anon_sym_component] = ACTIONS(2124),
    [sym_html_comment] = ACTIONS(5),
  },
  [314] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2137),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_sequence_expression] = STATE(6063),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(314),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_RPAREN] = ACTIONS(2144),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [315] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2206),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_sequence_expression] = STATE(6005),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(315),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(2146),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [316] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2206),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_sequence_expression] = STATE(6005),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(316),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_EQ_GT] = ACTIONS(2148),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [317] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2199),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_sequence_expression] = STATE(6003),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(317),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_RPAREN] = ACTIONS(2150),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [318] = {
    [sym_import] = STATE(3710),
    [sym_statement_block] = STATE(1964),
    [sym_parenthesized_expression] = STATE(1513),
    [sym_expression] = STATE(2672),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6293),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1513),
    [sym_subscript_expression] = STATE(1513),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3245),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6295),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(318),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1513),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(455),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1565),
    [anon_sym_export] = ACTIONS(1379),
    [anon_sym_type] = ACTIONS(1379),
    [anon_sym_namespace] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_typeof] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1379),
    [anon_sym_let] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1385),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_of] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1389),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1391),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_using] = ACTIONS(1395),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_void] = ACTIONS(1401),
    [anon_sym_delete] = ACTIONS(1401),
    [anon_sym_PLUS_PLUS] = ACTIONS(1403),
    [anon_sym_DASH_DASH] = ACTIONS(1403),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1405),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1571),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1379),
    [anon_sym_readonly] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(1379),
    [anon_sym_set] = ACTIONS(1379),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_public] = ACTIONS(1379),
    [anon_sym_private] = ACTIONS(1379),
    [anon_sym_protected] = ACTIONS(1379),
    [anon_sym_override] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1379),
    [anon_sym_any] = ACTIONS(1379),
    [anon_sym_number] = ACTIONS(1379),
    [anon_sym_boolean] = ACTIONS(1379),
    [anon_sym_string] = ACTIONS(1379),
    [anon_sym_symbol] = ACTIONS(1379),
    [anon_sym_object] = ACTIONS(1379),
    [anon_sym_property] = ACTIONS(1379),
    [anon_sym_signal] = ACTIONS(1379),
    [anon_sym_on] = ACTIONS(1379),
    [anon_sym_required] = ACTIONS(1379),
    [anon_sym_component] = ACTIONS(1379),
    [sym_html_comment] = ACTIONS(5),
  },
  [319] = {
    [sym_import] = STATE(3590),
    [sym_statement_block] = STATE(2635),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_expression] = STATE(2071),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6164),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3271),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6167),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(319),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1451),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(522),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_export] = ACTIONS(1327),
    [anon_sym_type] = ACTIONS(1327),
    [anon_sym_namespace] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(2154),
    [anon_sym_typeof] = ACTIONS(1349),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_let] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1333),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_of] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1527),
    [anon_sym_using] = ACTIONS(1343),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_SLASH] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_void] = ACTIONS(1349),
    [anon_sym_delete] = ACTIONS(1349),
    [anon_sym_PLUS_PLUS] = ACTIONS(1351),
    [anon_sym_DASH_DASH] = ACTIONS(1351),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1353),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1327),
    [anon_sym_readonly] = ACTIONS(1327),
    [anon_sym_get] = ACTIONS(1327),
    [anon_sym_set] = ACTIONS(1327),
    [anon_sym_declare] = ACTIONS(1327),
    [anon_sym_public] = ACTIONS(1327),
    [anon_sym_private] = ACTIONS(1327),
    [anon_sym_protected] = ACTIONS(1327),
    [anon_sym_override] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_any] = ACTIONS(1327),
    [anon_sym_number] = ACTIONS(1327),
    [anon_sym_boolean] = ACTIONS(1327),
    [anon_sym_string] = ACTIONS(1327),
    [anon_sym_symbol] = ACTIONS(1327),
    [anon_sym_object] = ACTIONS(1327),
    [anon_sym_property] = ACTIONS(1327),
    [anon_sym_signal] = ACTIONS(1327),
    [anon_sym_on] = ACTIONS(1327),
    [anon_sym_required] = ACTIONS(1327),
    [anon_sym_component] = ACTIONS(1327),
    [sym_html_comment] = ACTIONS(5),
  },
  [320] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1959),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5569),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(320),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [321] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2122),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_sequence_expression] = STATE(6040),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(321),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [322] = {
    [sym_import] = STATE(3710),
    [sym_statement_block] = STATE(1964),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1878),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(322),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(2156),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [323] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2113),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_sequence_expression] = STATE(5951),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(323),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [324] = {
    [sym_import] = STATE(3710),
    [sym_statement_block] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1513),
    [sym_expression] = STATE(2674),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6293),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1513),
    [sym_subscript_expression] = STATE(1513),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3245),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6295),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(324),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1513),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(455),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1565),
    [anon_sym_export] = ACTIONS(1379),
    [anon_sym_type] = ACTIONS(1379),
    [anon_sym_namespace] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_typeof] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1379),
    [anon_sym_let] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1385),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_of] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1389),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1391),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_using] = ACTIONS(1395),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_void] = ACTIONS(1401),
    [anon_sym_delete] = ACTIONS(1401),
    [anon_sym_PLUS_PLUS] = ACTIONS(1403),
    [anon_sym_DASH_DASH] = ACTIONS(1403),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1405),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1571),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1379),
    [anon_sym_readonly] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(1379),
    [anon_sym_set] = ACTIONS(1379),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_public] = ACTIONS(1379),
    [anon_sym_private] = ACTIONS(1379),
    [anon_sym_protected] = ACTIONS(1379),
    [anon_sym_override] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1379),
    [anon_sym_any] = ACTIONS(1379),
    [anon_sym_number] = ACTIONS(1379),
    [anon_sym_boolean] = ACTIONS(1379),
    [anon_sym_string] = ACTIONS(1379),
    [anon_sym_symbol] = ACTIONS(1379),
    [anon_sym_object] = ACTIONS(1379),
    [anon_sym_property] = ACTIONS(1379),
    [anon_sym_signal] = ACTIONS(1379),
    [anon_sym_on] = ACTIONS(1379),
    [anon_sym_required] = ACTIONS(1379),
    [anon_sym_component] = ACTIONS(1379),
    [sym_html_comment] = ACTIONS(5),
  },
  [325] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1805),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_sequence_expression] = STATE(6309),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(325),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [326] = {
    [sym_import] = STATE(3710),
    [sym_statement_block] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1866),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(326),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(2156),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [327] = {
    [sym_import] = STATE(3710),
    [sym_statement_block] = STATE(1964),
    [sym_parenthesized_expression] = STATE(1520),
    [sym_expression] = STATE(2578),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1520),
    [sym_subscript_expression] = STATE(1520),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6049),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(327),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1520),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(556),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1229),
    [anon_sym_namespace] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(2156),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1229),
    [anon_sym_let] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_of] = ACTIONS(1229),
    [anon_sym_yield] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1551),
    [anon_sym_using] = ACTIONS(1247),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1257),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_readonly] = ACTIONS(1229),
    [anon_sym_get] = ACTIONS(1229),
    [anon_sym_set] = ACTIONS(1229),
    [anon_sym_declare] = ACTIONS(1229),
    [anon_sym_public] = ACTIONS(1229),
    [anon_sym_private] = ACTIONS(1229),
    [anon_sym_protected] = ACTIONS(1229),
    [anon_sym_override] = ACTIONS(1229),
    [anon_sym_module] = ACTIONS(1229),
    [anon_sym_any] = ACTIONS(1229),
    [anon_sym_number] = ACTIONS(1229),
    [anon_sym_boolean] = ACTIONS(1229),
    [anon_sym_string] = ACTIONS(1229),
    [anon_sym_symbol] = ACTIONS(1229),
    [anon_sym_object] = ACTIONS(1229),
    [anon_sym_property] = ACTIONS(1229),
    [anon_sym_signal] = ACTIONS(1229),
    [anon_sym_on] = ACTIONS(1229),
    [anon_sym_required] = ACTIONS(1229),
    [anon_sym_component] = ACTIONS(1229),
    [sym_html_comment] = ACTIONS(5),
  },
  [328] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2218),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_sequence_expression] = STATE(5944),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(328),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [329] = {
    [sym_import] = STATE(3710),
    [sym_statement_block] = STATE(2022),
    [sym_parenthesized_expression] = STATE(1473),
    [sym_expression] = STATE(2191),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6272),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1473),
    [sym_subscript_expression] = STATE(1473),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3246),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6274),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(329),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1473),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(541),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_export] = ACTIONS(1415),
    [anon_sym_type] = ACTIONS(1415),
    [anon_sym_namespace] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(2156),
    [anon_sym_typeof] = ACTIONS(1437),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1415),
    [anon_sym_let] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1421),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1423),
    [anon_sym_of] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1425),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1427),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1543),
    [anon_sym_using] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1421),
    [anon_sym_void] = ACTIONS(1437),
    [anon_sym_delete] = ACTIONS(1437),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1441),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1415),
    [anon_sym_readonly] = ACTIONS(1415),
    [anon_sym_get] = ACTIONS(1415),
    [anon_sym_set] = ACTIONS(1415),
    [anon_sym_declare] = ACTIONS(1415),
    [anon_sym_public] = ACTIONS(1415),
    [anon_sym_private] = ACTIONS(1415),
    [anon_sym_protected] = ACTIONS(1415),
    [anon_sym_override] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_any] = ACTIONS(1415),
    [anon_sym_number] = ACTIONS(1415),
    [anon_sym_boolean] = ACTIONS(1415),
    [anon_sym_string] = ACTIONS(1415),
    [anon_sym_symbol] = ACTIONS(1415),
    [anon_sym_object] = ACTIONS(1415),
    [anon_sym_property] = ACTIONS(1415),
    [anon_sym_signal] = ACTIONS(1415),
    [anon_sym_on] = ACTIONS(1415),
    [anon_sym_required] = ACTIONS(1415),
    [anon_sym_component] = ACTIONS(1415),
    [sym_html_comment] = ACTIONS(5),
  },
  [330] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2220),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_sequence_expression] = STATE(5943),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(330),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [331] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2221),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_sequence_expression] = STATE(6148),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(331),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [332] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2223),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_sequence_expression] = STATE(5945),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(332),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [333] = {
    [sym_import] = STATE(3710),
    [sym_statement_block] = STATE(1966),
    [sym_parenthesized_expression] = STATE(1520),
    [sym_expression] = STATE(2554),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1520),
    [sym_subscript_expression] = STATE(1520),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6049),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(333),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1520),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(556),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1229),
    [anon_sym_namespace] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(2156),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1229),
    [anon_sym_let] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_of] = ACTIONS(1229),
    [anon_sym_yield] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1551),
    [anon_sym_using] = ACTIONS(1247),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1257),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_readonly] = ACTIONS(1229),
    [anon_sym_get] = ACTIONS(1229),
    [anon_sym_set] = ACTIONS(1229),
    [anon_sym_declare] = ACTIONS(1229),
    [anon_sym_public] = ACTIONS(1229),
    [anon_sym_private] = ACTIONS(1229),
    [anon_sym_protected] = ACTIONS(1229),
    [anon_sym_override] = ACTIONS(1229),
    [anon_sym_module] = ACTIONS(1229),
    [anon_sym_any] = ACTIONS(1229),
    [anon_sym_number] = ACTIONS(1229),
    [anon_sym_boolean] = ACTIONS(1229),
    [anon_sym_string] = ACTIONS(1229),
    [anon_sym_symbol] = ACTIONS(1229),
    [anon_sym_object] = ACTIONS(1229),
    [anon_sym_property] = ACTIONS(1229),
    [anon_sym_signal] = ACTIONS(1229),
    [anon_sym_on] = ACTIONS(1229),
    [anon_sym_required] = ACTIONS(1229),
    [anon_sym_component] = ACTIONS(1229),
    [sym_html_comment] = ACTIONS(5),
  },
  [334] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1473),
    [sym_expression] = STATE(2139),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6272),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1473),
    [sym_subscript_expression] = STATE(1473),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3246),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6274),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(334),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1473),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym__extends_clause_single] = STATE(4764),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(541),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_export] = ACTIONS(1415),
    [anon_sym_type] = ACTIONS(1415),
    [anon_sym_namespace] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1437),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1415),
    [anon_sym_let] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1421),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1423),
    [anon_sym_of] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1425),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1427),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1543),
    [anon_sym_using] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1421),
    [anon_sym_void] = ACTIONS(1437),
    [anon_sym_delete] = ACTIONS(1437),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1441),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1415),
    [anon_sym_readonly] = ACTIONS(1415),
    [anon_sym_get] = ACTIONS(1415),
    [anon_sym_set] = ACTIONS(1415),
    [anon_sym_declare] = ACTIONS(1415),
    [anon_sym_public] = ACTIONS(1415),
    [anon_sym_private] = ACTIONS(1415),
    [anon_sym_protected] = ACTIONS(1415),
    [anon_sym_override] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_any] = ACTIONS(1415),
    [anon_sym_number] = ACTIONS(1415),
    [anon_sym_boolean] = ACTIONS(1415),
    [anon_sym_string] = ACTIONS(1415),
    [anon_sym_symbol] = ACTIONS(1415),
    [anon_sym_object] = ACTIONS(1415),
    [anon_sym_property] = ACTIONS(1415),
    [anon_sym_signal] = ACTIONS(1415),
    [anon_sym_on] = ACTIONS(1415),
    [anon_sym_required] = ACTIONS(1415),
    [anon_sym_component] = ACTIONS(1415),
    [sym_html_comment] = ACTIONS(5),
  },
  [335] = {
    [sym_import] = STATE(3710),
    [sym_statement_block] = STATE(2022),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_expression] = STATE(2513),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5939),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(335),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1523),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1555),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_of] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_using] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_property] = ACTIONS(1181),
    [anon_sym_signal] = ACTIONS(1181),
    [anon_sym_on] = ACTIONS(1181),
    [anon_sym_required] = ACTIONS(1181),
    [anon_sym_component] = ACTIONS(1181),
    [sym_html_comment] = ACTIONS(5),
  },
  [336] = {
    [sym_import] = STATE(3710),
    [sym_statement_block] = STATE(2062),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1926),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(336),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(2156),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [337] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2111),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_sequence_expression] = STATE(6015),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(337),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [338] = {
    [sym_import] = STATE(3710),
    [sym_statement_block] = STATE(2062),
    [sym_parenthesized_expression] = STATE(1513),
    [sym_expression] = STATE(2585),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6293),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1513),
    [sym_subscript_expression] = STATE(1513),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3245),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6295),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(338),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1513),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(455),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1565),
    [anon_sym_export] = ACTIONS(1379),
    [anon_sym_type] = ACTIONS(1379),
    [anon_sym_namespace] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_typeof] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1379),
    [anon_sym_let] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1385),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_of] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1389),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1391),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_using] = ACTIONS(1395),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_void] = ACTIONS(1401),
    [anon_sym_delete] = ACTIONS(1401),
    [anon_sym_PLUS_PLUS] = ACTIONS(1403),
    [anon_sym_DASH_DASH] = ACTIONS(1403),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1405),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1571),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1379),
    [anon_sym_readonly] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(1379),
    [anon_sym_set] = ACTIONS(1379),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_public] = ACTIONS(1379),
    [anon_sym_private] = ACTIONS(1379),
    [anon_sym_protected] = ACTIONS(1379),
    [anon_sym_override] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1379),
    [anon_sym_any] = ACTIONS(1379),
    [anon_sym_number] = ACTIONS(1379),
    [anon_sym_boolean] = ACTIONS(1379),
    [anon_sym_string] = ACTIONS(1379),
    [anon_sym_symbol] = ACTIONS(1379),
    [anon_sym_object] = ACTIONS(1379),
    [anon_sym_property] = ACTIONS(1379),
    [anon_sym_signal] = ACTIONS(1379),
    [anon_sym_on] = ACTIONS(1379),
    [anon_sym_required] = ACTIONS(1379),
    [anon_sym_component] = ACTIONS(1379),
    [sym_html_comment] = ACTIONS(5),
  },
  [339] = {
    [sym_import] = STATE(3710),
    [sym_statement_block] = STATE(2036),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2684),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(339),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [sym_html_comment] = ACTIONS(5),
  },
  [340] = {
    [sym_import] = STATE(3710),
    [sym_statement_block] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2752),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(340),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [sym_html_comment] = ACTIONS(5),
  },
  [341] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1520),
    [sym_expression] = STATE(2432),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1520),
    [sym_subscript_expression] = STATE(1520),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6049),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(341),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1520),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_mapped_type_clause] = STATE(6120),
    [sym_type_arguments] = STATE(556),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2162),
    [anon_sym_type] = ACTIONS(2162),
    [anon_sym_namespace] = ACTIONS(2164),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(2162),
    [anon_sym_let] = ACTIONS(2162),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_of] = ACTIONS(2162),
    [anon_sym_yield] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(2166),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(2168),
    [anon_sym_using] = ACTIONS(1247),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1257),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(2162),
    [anon_sym_readonly] = ACTIONS(2162),
    [anon_sym_get] = ACTIONS(2162),
    [anon_sym_set] = ACTIONS(2162),
    [anon_sym_declare] = ACTIONS(2162),
    [anon_sym_public] = ACTIONS(2162),
    [anon_sym_private] = ACTIONS(2162),
    [anon_sym_protected] = ACTIONS(2162),
    [anon_sym_override] = ACTIONS(2162),
    [anon_sym_module] = ACTIONS(2162),
    [anon_sym_any] = ACTIONS(2162),
    [anon_sym_number] = ACTIONS(2162),
    [anon_sym_boolean] = ACTIONS(2162),
    [anon_sym_string] = ACTIONS(2162),
    [anon_sym_symbol] = ACTIONS(2162),
    [anon_sym_object] = ACTIONS(2162),
    [anon_sym_property] = ACTIONS(2162),
    [anon_sym_signal] = ACTIONS(2162),
    [anon_sym_on] = ACTIONS(2162),
    [anon_sym_required] = ACTIONS(2162),
    [anon_sym_component] = ACTIONS(2162),
    [sym_html_comment] = ACTIONS(5),
  },
  [342] = {
    [sym_import] = STATE(3590),
    [sym_statement_block] = STATE(2628),
    [sym_parenthesized_expression] = STATE(1487),
    [sym_expression] = STATE(2349),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1487),
    [sym_subscript_expression] = STATE(1487),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3189),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6145),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(342),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1487),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1131),
    [anon_sym_namespace] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(2154),
    [anon_sym_typeof] = ACTIONS(1159),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_let] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_of] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1149),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_using] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1159),
    [anon_sym_delete] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1167),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1131),
    [anon_sym_readonly] = ACTIONS(1131),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_declare] = ACTIONS(1131),
    [anon_sym_public] = ACTIONS(1131),
    [anon_sym_private] = ACTIONS(1131),
    [anon_sym_protected] = ACTIONS(1131),
    [anon_sym_override] = ACTIONS(1131),
    [anon_sym_module] = ACTIONS(1131),
    [anon_sym_any] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_boolean] = ACTIONS(1131),
    [anon_sym_string] = ACTIONS(1131),
    [anon_sym_symbol] = ACTIONS(1131),
    [anon_sym_object] = ACTIONS(1131),
    [anon_sym_property] = ACTIONS(1131),
    [anon_sym_signal] = ACTIONS(1131),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_required] = ACTIONS(1131),
    [anon_sym_component] = ACTIONS(1131),
    [sym_html_comment] = ACTIONS(5),
  },
  [343] = {
    [sym_import] = STATE(3710),
    [sym_statement_block] = STATE(2036),
    [sym_parenthesized_expression] = STATE(1513),
    [sym_expression] = STATE(2552),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6293),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1513),
    [sym_subscript_expression] = STATE(1513),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3245),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6295),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(343),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1513),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(455),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1565),
    [anon_sym_export] = ACTIONS(1379),
    [anon_sym_type] = ACTIONS(1379),
    [anon_sym_namespace] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_typeof] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1379),
    [anon_sym_let] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1385),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_of] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1389),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1391),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_using] = ACTIONS(1395),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_void] = ACTIONS(1401),
    [anon_sym_delete] = ACTIONS(1401),
    [anon_sym_PLUS_PLUS] = ACTIONS(1403),
    [anon_sym_DASH_DASH] = ACTIONS(1403),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1405),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1571),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1379),
    [anon_sym_readonly] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(1379),
    [anon_sym_set] = ACTIONS(1379),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_public] = ACTIONS(1379),
    [anon_sym_private] = ACTIONS(1379),
    [anon_sym_protected] = ACTIONS(1379),
    [anon_sym_override] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1379),
    [anon_sym_any] = ACTIONS(1379),
    [anon_sym_number] = ACTIONS(1379),
    [anon_sym_boolean] = ACTIONS(1379),
    [anon_sym_string] = ACTIONS(1379),
    [anon_sym_symbol] = ACTIONS(1379),
    [anon_sym_object] = ACTIONS(1379),
    [anon_sym_property] = ACTIONS(1379),
    [anon_sym_signal] = ACTIONS(1379),
    [anon_sym_on] = ACTIONS(1379),
    [anon_sym_required] = ACTIONS(1379),
    [anon_sym_component] = ACTIONS(1379),
    [sym_html_comment] = ACTIONS(5),
  },
  [344] = {
    [sym_import] = STATE(3590),
    [sym_statement_block] = STATE(2488),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1985),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(344),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(2154),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [345] = {
    [sym_import] = STATE(3710),
    [sym_statement_block] = STATE(2062),
    [sym_parenthesized_expression] = STATE(1473),
    [sym_expression] = STATE(2130),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6272),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1473),
    [sym_subscript_expression] = STATE(1473),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3246),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6274),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(345),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1473),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(541),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_export] = ACTIONS(1415),
    [anon_sym_type] = ACTIONS(1415),
    [anon_sym_namespace] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(2156),
    [anon_sym_typeof] = ACTIONS(1437),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1415),
    [anon_sym_let] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1421),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1423),
    [anon_sym_of] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1425),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1427),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1543),
    [anon_sym_using] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1421),
    [anon_sym_void] = ACTIONS(1437),
    [anon_sym_delete] = ACTIONS(1437),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1441),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1415),
    [anon_sym_readonly] = ACTIONS(1415),
    [anon_sym_get] = ACTIONS(1415),
    [anon_sym_set] = ACTIONS(1415),
    [anon_sym_declare] = ACTIONS(1415),
    [anon_sym_public] = ACTIONS(1415),
    [anon_sym_private] = ACTIONS(1415),
    [anon_sym_protected] = ACTIONS(1415),
    [anon_sym_override] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_any] = ACTIONS(1415),
    [anon_sym_number] = ACTIONS(1415),
    [anon_sym_boolean] = ACTIONS(1415),
    [anon_sym_string] = ACTIONS(1415),
    [anon_sym_symbol] = ACTIONS(1415),
    [anon_sym_object] = ACTIONS(1415),
    [anon_sym_property] = ACTIONS(1415),
    [anon_sym_signal] = ACTIONS(1415),
    [anon_sym_on] = ACTIONS(1415),
    [anon_sym_required] = ACTIONS(1415),
    [anon_sym_component] = ACTIONS(1415),
    [sym_html_comment] = ACTIONS(5),
  },
  [346] = {
    [sym_import] = STATE(3590),
    [sym_statement_block] = STATE(2635),
    [sym_parenthesized_expression] = STATE(1487),
    [sym_expression] = STATE(2314),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1487),
    [sym_subscript_expression] = STATE(1487),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3189),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6145),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(346),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1487),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1131),
    [anon_sym_namespace] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(2154),
    [anon_sym_typeof] = ACTIONS(1159),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_let] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_of] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1149),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_using] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1159),
    [anon_sym_delete] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1167),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1131),
    [anon_sym_readonly] = ACTIONS(1131),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_declare] = ACTIONS(1131),
    [anon_sym_public] = ACTIONS(1131),
    [anon_sym_private] = ACTIONS(1131),
    [anon_sym_protected] = ACTIONS(1131),
    [anon_sym_override] = ACTIONS(1131),
    [anon_sym_module] = ACTIONS(1131),
    [anon_sym_any] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_boolean] = ACTIONS(1131),
    [anon_sym_string] = ACTIONS(1131),
    [anon_sym_symbol] = ACTIONS(1131),
    [anon_sym_object] = ACTIONS(1131),
    [anon_sym_property] = ACTIONS(1131),
    [anon_sym_signal] = ACTIONS(1131),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_required] = ACTIONS(1131),
    [anon_sym_component] = ACTIONS(1131),
    [sym_html_comment] = ACTIONS(5),
  },
  [347] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2147),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_sequence_expression] = STATE(6092),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(347),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [348] = {
    [sym_import] = STATE(3590),
    [sym_statement_block] = STATE(2649),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_expression] = STATE(2069),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6164),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3271),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6167),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(348),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1451),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(522),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_export] = ACTIONS(1327),
    [anon_sym_type] = ACTIONS(1327),
    [anon_sym_namespace] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(2154),
    [anon_sym_typeof] = ACTIONS(1349),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_let] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1333),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_of] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1527),
    [anon_sym_using] = ACTIONS(1343),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_SLASH] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_void] = ACTIONS(1349),
    [anon_sym_delete] = ACTIONS(1349),
    [anon_sym_PLUS_PLUS] = ACTIONS(1351),
    [anon_sym_DASH_DASH] = ACTIONS(1351),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1353),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1327),
    [anon_sym_readonly] = ACTIONS(1327),
    [anon_sym_get] = ACTIONS(1327),
    [anon_sym_set] = ACTIONS(1327),
    [anon_sym_declare] = ACTIONS(1327),
    [anon_sym_public] = ACTIONS(1327),
    [anon_sym_private] = ACTIONS(1327),
    [anon_sym_protected] = ACTIONS(1327),
    [anon_sym_override] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_any] = ACTIONS(1327),
    [anon_sym_number] = ACTIONS(1327),
    [anon_sym_boolean] = ACTIONS(1327),
    [anon_sym_string] = ACTIONS(1327),
    [anon_sym_symbol] = ACTIONS(1327),
    [anon_sym_object] = ACTIONS(1327),
    [anon_sym_property] = ACTIONS(1327),
    [anon_sym_signal] = ACTIONS(1327),
    [anon_sym_on] = ACTIONS(1327),
    [anon_sym_required] = ACTIONS(1327),
    [anon_sym_component] = ACTIONS(1327),
    [sym_html_comment] = ACTIONS(5),
  },
  [349] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1786),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_sequence_expression] = STATE(6086),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(349),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [350] = {
    [sym_import] = STATE(3710),
    [sym_statement_block] = STATE(2062),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2740),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(350),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [sym_html_comment] = ACTIONS(5),
  },
  [351] = {
    [sym_import] = STATE(3710),
    [sym_statement_block] = STATE(1964),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2750),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(351),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [sym_html_comment] = ACTIONS(5),
  },
  [352] = {
    [sym_import] = STATE(3710),
    [sym_statement_block] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_expression] = STATE(2520),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5939),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(352),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1523),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1555),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_of] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_using] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_property] = ACTIONS(1181),
    [anon_sym_signal] = ACTIONS(1181),
    [anon_sym_on] = ACTIONS(1181),
    [anon_sym_required] = ACTIONS(1181),
    [anon_sym_component] = ACTIONS(1181),
    [sym_html_comment] = ACTIONS(5),
  },
  [353] = {
    [sym_import] = STATE(3590),
    [sym_statement_block] = STATE(2649),
    [sym_parenthesized_expression] = STATE(1487),
    [sym_expression] = STATE(2319),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1487),
    [sym_subscript_expression] = STATE(1487),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3189),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6145),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(353),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1487),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1131),
    [anon_sym_namespace] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(2154),
    [anon_sym_typeof] = ACTIONS(1159),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_let] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_of] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1149),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_using] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1159),
    [anon_sym_delete] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1167),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1131),
    [anon_sym_readonly] = ACTIONS(1131),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_declare] = ACTIONS(1131),
    [anon_sym_public] = ACTIONS(1131),
    [anon_sym_private] = ACTIONS(1131),
    [anon_sym_protected] = ACTIONS(1131),
    [anon_sym_override] = ACTIONS(1131),
    [anon_sym_module] = ACTIONS(1131),
    [anon_sym_any] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_boolean] = ACTIONS(1131),
    [anon_sym_string] = ACTIONS(1131),
    [anon_sym_symbol] = ACTIONS(1131),
    [anon_sym_object] = ACTIONS(1131),
    [anon_sym_property] = ACTIONS(1131),
    [anon_sym_signal] = ACTIONS(1131),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_required] = ACTIONS(1131),
    [anon_sym_component] = ACTIONS(1131),
    [sym_html_comment] = ACTIONS(5),
  },
  [354] = {
    [sym_import] = STATE(3710),
    [sym_statement_block] = STATE(2062),
    [sym_parenthesized_expression] = STATE(1520),
    [sym_expression] = STATE(2633),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1520),
    [sym_subscript_expression] = STATE(1520),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6049),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(354),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1520),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(556),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1229),
    [anon_sym_namespace] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(2156),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1229),
    [anon_sym_let] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_of] = ACTIONS(1229),
    [anon_sym_yield] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1551),
    [anon_sym_using] = ACTIONS(1247),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1257),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_readonly] = ACTIONS(1229),
    [anon_sym_get] = ACTIONS(1229),
    [anon_sym_set] = ACTIONS(1229),
    [anon_sym_declare] = ACTIONS(1229),
    [anon_sym_public] = ACTIONS(1229),
    [anon_sym_private] = ACTIONS(1229),
    [anon_sym_protected] = ACTIONS(1229),
    [anon_sym_override] = ACTIONS(1229),
    [anon_sym_module] = ACTIONS(1229),
    [anon_sym_any] = ACTIONS(1229),
    [anon_sym_number] = ACTIONS(1229),
    [anon_sym_boolean] = ACTIONS(1229),
    [anon_sym_string] = ACTIONS(1229),
    [anon_sym_symbol] = ACTIONS(1229),
    [anon_sym_object] = ACTIONS(1229),
    [anon_sym_property] = ACTIONS(1229),
    [anon_sym_signal] = ACTIONS(1229),
    [anon_sym_on] = ACTIONS(1229),
    [anon_sym_required] = ACTIONS(1229),
    [anon_sym_component] = ACTIONS(1229),
    [sym_html_comment] = ACTIONS(5),
  },
  [355] = {
    [sym_import] = STATE(3710),
    [sym_statement_block] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1520),
    [sym_expression] = STATE(2580),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1520),
    [sym_subscript_expression] = STATE(1520),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6049),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(355),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1520),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(556),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1229),
    [anon_sym_namespace] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(2156),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1229),
    [anon_sym_let] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_of] = ACTIONS(1229),
    [anon_sym_yield] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1551),
    [anon_sym_using] = ACTIONS(1247),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1257),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_readonly] = ACTIONS(1229),
    [anon_sym_get] = ACTIONS(1229),
    [anon_sym_set] = ACTIONS(1229),
    [anon_sym_declare] = ACTIONS(1229),
    [anon_sym_public] = ACTIONS(1229),
    [anon_sym_private] = ACTIONS(1229),
    [anon_sym_protected] = ACTIONS(1229),
    [anon_sym_override] = ACTIONS(1229),
    [anon_sym_module] = ACTIONS(1229),
    [anon_sym_any] = ACTIONS(1229),
    [anon_sym_number] = ACTIONS(1229),
    [anon_sym_boolean] = ACTIONS(1229),
    [anon_sym_string] = ACTIONS(1229),
    [anon_sym_symbol] = ACTIONS(1229),
    [anon_sym_object] = ACTIONS(1229),
    [anon_sym_property] = ACTIONS(1229),
    [anon_sym_signal] = ACTIONS(1229),
    [anon_sym_on] = ACTIONS(1229),
    [anon_sym_required] = ACTIONS(1229),
    [anon_sym_component] = ACTIONS(1229),
    [sym_html_comment] = ACTIONS(5),
  },
  [356] = {
    [sym_import] = STATE(3590),
    [sym_statement_block] = STATE(2628),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_expression] = STATE(2074),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6164),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3271),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6167),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(356),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1451),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(522),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_export] = ACTIONS(1327),
    [anon_sym_type] = ACTIONS(1327),
    [anon_sym_namespace] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(2154),
    [anon_sym_typeof] = ACTIONS(1349),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_let] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1333),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_of] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1527),
    [anon_sym_using] = ACTIONS(1343),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_SLASH] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_void] = ACTIONS(1349),
    [anon_sym_delete] = ACTIONS(1349),
    [anon_sym_PLUS_PLUS] = ACTIONS(1351),
    [anon_sym_DASH_DASH] = ACTIONS(1351),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1353),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1327),
    [anon_sym_readonly] = ACTIONS(1327),
    [anon_sym_get] = ACTIONS(1327),
    [anon_sym_set] = ACTIONS(1327),
    [anon_sym_declare] = ACTIONS(1327),
    [anon_sym_public] = ACTIONS(1327),
    [anon_sym_private] = ACTIONS(1327),
    [anon_sym_protected] = ACTIONS(1327),
    [anon_sym_override] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_any] = ACTIONS(1327),
    [anon_sym_number] = ACTIONS(1327),
    [anon_sym_boolean] = ACTIONS(1327),
    [anon_sym_string] = ACTIONS(1327),
    [anon_sym_symbol] = ACTIONS(1327),
    [anon_sym_object] = ACTIONS(1327),
    [anon_sym_property] = ACTIONS(1327),
    [anon_sym_signal] = ACTIONS(1327),
    [anon_sym_on] = ACTIONS(1327),
    [anon_sym_required] = ACTIONS(1327),
    [anon_sym_component] = ACTIONS(1327),
    [sym_html_comment] = ACTIONS(5),
  },
  [357] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2167),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_sequence_expression] = STATE(6023),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(357),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [358] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1473),
    [sym_expression] = STATE(2139),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6272),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1473),
    [sym_subscript_expression] = STATE(1473),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3246),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6274),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(358),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1473),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym__extends_clause_single] = STATE(5014),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(541),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_export] = ACTIONS(1415),
    [anon_sym_type] = ACTIONS(1415),
    [anon_sym_namespace] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1437),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1415),
    [anon_sym_let] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1421),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1423),
    [anon_sym_of] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1425),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1427),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1543),
    [anon_sym_using] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1421),
    [anon_sym_void] = ACTIONS(1437),
    [anon_sym_delete] = ACTIONS(1437),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1441),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1415),
    [anon_sym_readonly] = ACTIONS(1415),
    [anon_sym_get] = ACTIONS(1415),
    [anon_sym_set] = ACTIONS(1415),
    [anon_sym_declare] = ACTIONS(1415),
    [anon_sym_public] = ACTIONS(1415),
    [anon_sym_private] = ACTIONS(1415),
    [anon_sym_protected] = ACTIONS(1415),
    [anon_sym_override] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_any] = ACTIONS(1415),
    [anon_sym_number] = ACTIONS(1415),
    [anon_sym_boolean] = ACTIONS(1415),
    [anon_sym_string] = ACTIONS(1415),
    [anon_sym_symbol] = ACTIONS(1415),
    [anon_sym_object] = ACTIONS(1415),
    [anon_sym_property] = ACTIONS(1415),
    [anon_sym_signal] = ACTIONS(1415),
    [anon_sym_on] = ACTIONS(1415),
    [anon_sym_required] = ACTIONS(1415),
    [anon_sym_component] = ACTIONS(1415),
    [sym_html_comment] = ACTIONS(5),
  },
  [359] = {
    [sym_import] = STATE(3710),
    [sym_statement_block] = STATE(1966),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2749),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(359),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [sym_html_comment] = ACTIONS(5),
  },
  [360] = {
    [sym_import] = STATE(3710),
    [sym_statement_block] = STATE(2036),
    [sym_parenthesized_expression] = STATE(1473),
    [sym_expression] = STATE(2117),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6272),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1473),
    [sym_subscript_expression] = STATE(1473),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3246),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6274),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(360),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1473),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(541),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_export] = ACTIONS(1415),
    [anon_sym_type] = ACTIONS(1415),
    [anon_sym_namespace] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(2156),
    [anon_sym_typeof] = ACTIONS(1437),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1415),
    [anon_sym_let] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1421),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1423),
    [anon_sym_of] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1425),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1427),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1543),
    [anon_sym_using] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1421),
    [anon_sym_void] = ACTIONS(1437),
    [anon_sym_delete] = ACTIONS(1437),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1441),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1415),
    [anon_sym_readonly] = ACTIONS(1415),
    [anon_sym_get] = ACTIONS(1415),
    [anon_sym_set] = ACTIONS(1415),
    [anon_sym_declare] = ACTIONS(1415),
    [anon_sym_public] = ACTIONS(1415),
    [anon_sym_private] = ACTIONS(1415),
    [anon_sym_protected] = ACTIONS(1415),
    [anon_sym_override] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_any] = ACTIONS(1415),
    [anon_sym_number] = ACTIONS(1415),
    [anon_sym_boolean] = ACTIONS(1415),
    [anon_sym_string] = ACTIONS(1415),
    [anon_sym_symbol] = ACTIONS(1415),
    [anon_sym_object] = ACTIONS(1415),
    [anon_sym_property] = ACTIONS(1415),
    [anon_sym_signal] = ACTIONS(1415),
    [anon_sym_on] = ACTIONS(1415),
    [anon_sym_required] = ACTIONS(1415),
    [anon_sym_component] = ACTIONS(1415),
    [sym_html_comment] = ACTIONS(5),
  },
  [361] = {
    [sym_import] = STATE(3590),
    [sym_statement_block] = STATE(2488),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_expression] = STATE(1962),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6164),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3271),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6167),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(361),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1451),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(522),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_export] = ACTIONS(1327),
    [anon_sym_type] = ACTIONS(1327),
    [anon_sym_namespace] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(2154),
    [anon_sym_typeof] = ACTIONS(1349),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_let] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1333),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_of] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1527),
    [anon_sym_using] = ACTIONS(1343),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_SLASH] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_void] = ACTIONS(1349),
    [anon_sym_delete] = ACTIONS(1349),
    [anon_sym_PLUS_PLUS] = ACTIONS(1351),
    [anon_sym_DASH_DASH] = ACTIONS(1351),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1353),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1327),
    [anon_sym_readonly] = ACTIONS(1327),
    [anon_sym_get] = ACTIONS(1327),
    [anon_sym_set] = ACTIONS(1327),
    [anon_sym_declare] = ACTIONS(1327),
    [anon_sym_public] = ACTIONS(1327),
    [anon_sym_private] = ACTIONS(1327),
    [anon_sym_protected] = ACTIONS(1327),
    [anon_sym_override] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_any] = ACTIONS(1327),
    [anon_sym_number] = ACTIONS(1327),
    [anon_sym_boolean] = ACTIONS(1327),
    [anon_sym_string] = ACTIONS(1327),
    [anon_sym_symbol] = ACTIONS(1327),
    [anon_sym_object] = ACTIONS(1327),
    [anon_sym_property] = ACTIONS(1327),
    [anon_sym_signal] = ACTIONS(1327),
    [anon_sym_on] = ACTIONS(1327),
    [anon_sym_required] = ACTIONS(1327),
    [anon_sym_component] = ACTIONS(1327),
    [sym_html_comment] = ACTIONS(5),
  },
  [362] = {
    [sym_import] = STATE(3710),
    [sym_statement_block] = STATE(1966),
    [sym_parenthesized_expression] = STATE(1473),
    [sym_expression] = STATE(2178),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6272),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1473),
    [sym_subscript_expression] = STATE(1473),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3246),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6274),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(362),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1473),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(541),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_export] = ACTIONS(1415),
    [anon_sym_type] = ACTIONS(1415),
    [anon_sym_namespace] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(2156),
    [anon_sym_typeof] = ACTIONS(1437),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1415),
    [anon_sym_let] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1421),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1423),
    [anon_sym_of] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1425),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1427),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1543),
    [anon_sym_using] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1421),
    [anon_sym_void] = ACTIONS(1437),
    [anon_sym_delete] = ACTIONS(1437),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1441),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1415),
    [anon_sym_readonly] = ACTIONS(1415),
    [anon_sym_get] = ACTIONS(1415),
    [anon_sym_set] = ACTIONS(1415),
    [anon_sym_declare] = ACTIONS(1415),
    [anon_sym_public] = ACTIONS(1415),
    [anon_sym_private] = ACTIONS(1415),
    [anon_sym_protected] = ACTIONS(1415),
    [anon_sym_override] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_any] = ACTIONS(1415),
    [anon_sym_number] = ACTIONS(1415),
    [anon_sym_boolean] = ACTIONS(1415),
    [anon_sym_string] = ACTIONS(1415),
    [anon_sym_symbol] = ACTIONS(1415),
    [anon_sym_object] = ACTIONS(1415),
    [anon_sym_property] = ACTIONS(1415),
    [anon_sym_signal] = ACTIONS(1415),
    [anon_sym_on] = ACTIONS(1415),
    [anon_sym_required] = ACTIONS(1415),
    [anon_sym_component] = ACTIONS(1415),
    [sym_html_comment] = ACTIONS(5),
  },
  [363] = {
    [sym_import] = STATE(3590),
    [sym_statement_block] = STATE(2649),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2048),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(363),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(2154),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [364] = {
    [sym_import] = STATE(3590),
    [sym_statement_block] = STATE(2635),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2052),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(364),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(2154),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [365] = {
    [sym_import] = STATE(3710),
    [sym_statement_block] = STATE(2036),
    [sym_parenthesized_expression] = STATE(1520),
    [sym_expression] = STATE(2424),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1520),
    [sym_subscript_expression] = STATE(1520),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6049),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(365),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1520),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(556),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1229),
    [anon_sym_namespace] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(2156),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1229),
    [anon_sym_let] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_of] = ACTIONS(1229),
    [anon_sym_yield] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1551),
    [anon_sym_using] = ACTIONS(1247),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1257),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_readonly] = ACTIONS(1229),
    [anon_sym_get] = ACTIONS(1229),
    [anon_sym_set] = ACTIONS(1229),
    [anon_sym_declare] = ACTIONS(1229),
    [anon_sym_public] = ACTIONS(1229),
    [anon_sym_private] = ACTIONS(1229),
    [anon_sym_protected] = ACTIONS(1229),
    [anon_sym_override] = ACTIONS(1229),
    [anon_sym_module] = ACTIONS(1229),
    [anon_sym_any] = ACTIONS(1229),
    [anon_sym_number] = ACTIONS(1229),
    [anon_sym_boolean] = ACTIONS(1229),
    [anon_sym_string] = ACTIONS(1229),
    [anon_sym_symbol] = ACTIONS(1229),
    [anon_sym_object] = ACTIONS(1229),
    [anon_sym_property] = ACTIONS(1229),
    [anon_sym_signal] = ACTIONS(1229),
    [anon_sym_on] = ACTIONS(1229),
    [anon_sym_required] = ACTIONS(1229),
    [anon_sym_component] = ACTIONS(1229),
    [sym_html_comment] = ACTIONS(5),
  },
  [366] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2206),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_sequence_expression] = STATE(6005),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(366),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [367] = {
    [sym_import] = STATE(3590),
    [sym_statement_block] = STATE(2488),
    [sym_parenthesized_expression] = STATE(1487),
    [sym_expression] = STATE(2421),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1487),
    [sym_subscript_expression] = STATE(1487),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3189),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6145),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(367),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1487),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1131),
    [anon_sym_namespace] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(2154),
    [anon_sym_typeof] = ACTIONS(1159),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_let] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_of] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1149),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_using] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1159),
    [anon_sym_delete] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1167),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1131),
    [anon_sym_readonly] = ACTIONS(1131),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_declare] = ACTIONS(1131),
    [anon_sym_public] = ACTIONS(1131),
    [anon_sym_private] = ACTIONS(1131),
    [anon_sym_protected] = ACTIONS(1131),
    [anon_sym_override] = ACTIONS(1131),
    [anon_sym_module] = ACTIONS(1131),
    [anon_sym_any] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_boolean] = ACTIONS(1131),
    [anon_sym_string] = ACTIONS(1131),
    [anon_sym_symbol] = ACTIONS(1131),
    [anon_sym_object] = ACTIONS(1131),
    [anon_sym_property] = ACTIONS(1131),
    [anon_sym_signal] = ACTIONS(1131),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_required] = ACTIONS(1131),
    [anon_sym_component] = ACTIONS(1131),
    [sym_html_comment] = ACTIONS(5),
  },
  [368] = {
    [sym_import] = STATE(3710),
    [sym_statement_block] = STATE(2022),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1872),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(368),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(2156),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [369] = {
    [sym_import] = STATE(3590),
    [sym_statement_block] = STATE(2546),
    [sym_parenthesized_expression] = STATE(1487),
    [sym_expression] = STATE(2329),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1487),
    [sym_subscript_expression] = STATE(1487),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3189),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6145),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(369),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1487),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1131),
    [anon_sym_namespace] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(2154),
    [anon_sym_typeof] = ACTIONS(1159),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_let] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_of] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1149),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_using] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1159),
    [anon_sym_delete] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1167),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1131),
    [anon_sym_readonly] = ACTIONS(1131),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_declare] = ACTIONS(1131),
    [anon_sym_public] = ACTIONS(1131),
    [anon_sym_private] = ACTIONS(1131),
    [anon_sym_protected] = ACTIONS(1131),
    [anon_sym_override] = ACTIONS(1131),
    [anon_sym_module] = ACTIONS(1131),
    [anon_sym_any] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_boolean] = ACTIONS(1131),
    [anon_sym_string] = ACTIONS(1131),
    [anon_sym_symbol] = ACTIONS(1131),
    [anon_sym_object] = ACTIONS(1131),
    [anon_sym_property] = ACTIONS(1131),
    [anon_sym_signal] = ACTIONS(1131),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_required] = ACTIONS(1131),
    [anon_sym_component] = ACTIONS(1131),
    [sym_html_comment] = ACTIONS(5),
  },
  [370] = {
    [sym_import] = STATE(3590),
    [sym_statement_block] = STATE(2628),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2055),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(370),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(2154),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [371] = {
    [sym_import] = STATE(3590),
    [sym_statement_block] = STATE(2435),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1967),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(371),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(2154),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [372] = {
    [sym_import] = STATE(3710),
    [sym_statement_block] = STATE(1964),
    [sym_parenthesized_expression] = STATE(1473),
    [sym_expression] = STATE(2181),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6272),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1473),
    [sym_subscript_expression] = STATE(1473),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3246),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6274),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(372),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1473),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(541),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_export] = ACTIONS(1415),
    [anon_sym_type] = ACTIONS(1415),
    [anon_sym_namespace] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(2156),
    [anon_sym_typeof] = ACTIONS(1437),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1415),
    [anon_sym_let] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1421),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1423),
    [anon_sym_of] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1425),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1427),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1543),
    [anon_sym_using] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1421),
    [anon_sym_void] = ACTIONS(1437),
    [anon_sym_delete] = ACTIONS(1437),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1441),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1415),
    [anon_sym_readonly] = ACTIONS(1415),
    [anon_sym_get] = ACTIONS(1415),
    [anon_sym_set] = ACTIONS(1415),
    [anon_sym_declare] = ACTIONS(1415),
    [anon_sym_public] = ACTIONS(1415),
    [anon_sym_private] = ACTIONS(1415),
    [anon_sym_protected] = ACTIONS(1415),
    [anon_sym_override] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_any] = ACTIONS(1415),
    [anon_sym_number] = ACTIONS(1415),
    [anon_sym_boolean] = ACTIONS(1415),
    [anon_sym_string] = ACTIONS(1415),
    [anon_sym_symbol] = ACTIONS(1415),
    [anon_sym_object] = ACTIONS(1415),
    [anon_sym_property] = ACTIONS(1415),
    [anon_sym_signal] = ACTIONS(1415),
    [anon_sym_on] = ACTIONS(1415),
    [anon_sym_required] = ACTIONS(1415),
    [anon_sym_component] = ACTIONS(1415),
    [sym_html_comment] = ACTIONS(5),
  },
  [373] = {
    [sym_import] = STATE(3710),
    [sym_statement_block] = STATE(1955),
    [sym_parenthesized_expression] = STATE(1473),
    [sym_expression] = STATE(2186),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6272),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1473),
    [sym_subscript_expression] = STATE(1473),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3246),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6274),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(373),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1473),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(541),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_export] = ACTIONS(1415),
    [anon_sym_type] = ACTIONS(1415),
    [anon_sym_namespace] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(2156),
    [anon_sym_typeof] = ACTIONS(1437),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1415),
    [anon_sym_let] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1421),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1423),
    [anon_sym_of] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1425),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1427),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1543),
    [anon_sym_using] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1421),
    [anon_sym_void] = ACTIONS(1437),
    [anon_sym_delete] = ACTIONS(1437),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1441),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1415),
    [anon_sym_readonly] = ACTIONS(1415),
    [anon_sym_get] = ACTIONS(1415),
    [anon_sym_set] = ACTIONS(1415),
    [anon_sym_declare] = ACTIONS(1415),
    [anon_sym_public] = ACTIONS(1415),
    [anon_sym_private] = ACTIONS(1415),
    [anon_sym_protected] = ACTIONS(1415),
    [anon_sym_override] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_any] = ACTIONS(1415),
    [anon_sym_number] = ACTIONS(1415),
    [anon_sym_boolean] = ACTIONS(1415),
    [anon_sym_string] = ACTIONS(1415),
    [anon_sym_symbol] = ACTIONS(1415),
    [anon_sym_object] = ACTIONS(1415),
    [anon_sym_property] = ACTIONS(1415),
    [anon_sym_signal] = ACTIONS(1415),
    [anon_sym_on] = ACTIONS(1415),
    [anon_sym_required] = ACTIONS(1415),
    [anon_sym_component] = ACTIONS(1415),
    [sym_html_comment] = ACTIONS(5),
  },
  [374] = {
    [sym_import] = STATE(3590),
    [sym_statement_block] = STATE(2546),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_expression] = STATE(1940),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6164),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3271),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6167),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(374),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1451),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(522),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_export] = ACTIONS(1327),
    [anon_sym_type] = ACTIONS(1327),
    [anon_sym_namespace] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(2154),
    [anon_sym_typeof] = ACTIONS(1349),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_let] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1333),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_of] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1527),
    [anon_sym_using] = ACTIONS(1343),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_SLASH] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_void] = ACTIONS(1349),
    [anon_sym_delete] = ACTIONS(1349),
    [anon_sym_PLUS_PLUS] = ACTIONS(1351),
    [anon_sym_DASH_DASH] = ACTIONS(1351),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1353),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1327),
    [anon_sym_readonly] = ACTIONS(1327),
    [anon_sym_get] = ACTIONS(1327),
    [anon_sym_set] = ACTIONS(1327),
    [anon_sym_declare] = ACTIONS(1327),
    [anon_sym_public] = ACTIONS(1327),
    [anon_sym_private] = ACTIONS(1327),
    [anon_sym_protected] = ACTIONS(1327),
    [anon_sym_override] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_any] = ACTIONS(1327),
    [anon_sym_number] = ACTIONS(1327),
    [anon_sym_boolean] = ACTIONS(1327),
    [anon_sym_string] = ACTIONS(1327),
    [anon_sym_symbol] = ACTIONS(1327),
    [anon_sym_object] = ACTIONS(1327),
    [anon_sym_property] = ACTIONS(1327),
    [anon_sym_signal] = ACTIONS(1327),
    [anon_sym_on] = ACTIONS(1327),
    [anon_sym_required] = ACTIONS(1327),
    [anon_sym_component] = ACTIONS(1327),
    [sym_html_comment] = ACTIONS(5),
  },
  [375] = {
    [sym_import] = STATE(3710),
    [sym_statement_block] = STATE(1966),
    [sym_parenthesized_expression] = STATE(1513),
    [sym_expression] = STATE(2670),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6293),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1513),
    [sym_subscript_expression] = STATE(1513),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3245),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6295),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(375),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1513),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(455),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1565),
    [anon_sym_export] = ACTIONS(1379),
    [anon_sym_type] = ACTIONS(1379),
    [anon_sym_namespace] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_typeof] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1379),
    [anon_sym_let] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1385),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_of] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1389),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1391),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_using] = ACTIONS(1395),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_void] = ACTIONS(1401),
    [anon_sym_delete] = ACTIONS(1401),
    [anon_sym_PLUS_PLUS] = ACTIONS(1403),
    [anon_sym_DASH_DASH] = ACTIONS(1403),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1405),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1571),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1379),
    [anon_sym_readonly] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(1379),
    [anon_sym_set] = ACTIONS(1379),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_public] = ACTIONS(1379),
    [anon_sym_private] = ACTIONS(1379),
    [anon_sym_protected] = ACTIONS(1379),
    [anon_sym_override] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1379),
    [anon_sym_any] = ACTIONS(1379),
    [anon_sym_number] = ACTIONS(1379),
    [anon_sym_boolean] = ACTIONS(1379),
    [anon_sym_string] = ACTIONS(1379),
    [anon_sym_symbol] = ACTIONS(1379),
    [anon_sym_object] = ACTIONS(1379),
    [anon_sym_property] = ACTIONS(1379),
    [anon_sym_signal] = ACTIONS(1379),
    [anon_sym_on] = ACTIONS(1379),
    [anon_sym_required] = ACTIONS(1379),
    [anon_sym_component] = ACTIONS(1379),
    [sym_html_comment] = ACTIONS(5),
  },
  [376] = {
    [sym_import] = STATE(3710),
    [sym_statement_block] = STATE(2022),
    [sym_parenthesized_expression] = STATE(1513),
    [sym_expression] = STATE(2669),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6293),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1513),
    [sym_subscript_expression] = STATE(1513),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3245),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6295),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(376),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1513),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(455),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1565),
    [anon_sym_export] = ACTIONS(1379),
    [anon_sym_type] = ACTIONS(1379),
    [anon_sym_namespace] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_typeof] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1379),
    [anon_sym_let] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1385),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_of] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1389),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1391),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_using] = ACTIONS(1395),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_void] = ACTIONS(1401),
    [anon_sym_delete] = ACTIONS(1401),
    [anon_sym_PLUS_PLUS] = ACTIONS(1403),
    [anon_sym_DASH_DASH] = ACTIONS(1403),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1405),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1571),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1379),
    [anon_sym_readonly] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(1379),
    [anon_sym_set] = ACTIONS(1379),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_public] = ACTIONS(1379),
    [anon_sym_private] = ACTIONS(1379),
    [anon_sym_protected] = ACTIONS(1379),
    [anon_sym_override] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1379),
    [anon_sym_any] = ACTIONS(1379),
    [anon_sym_number] = ACTIONS(1379),
    [anon_sym_boolean] = ACTIONS(1379),
    [anon_sym_string] = ACTIONS(1379),
    [anon_sym_symbol] = ACTIONS(1379),
    [anon_sym_object] = ACTIONS(1379),
    [anon_sym_property] = ACTIONS(1379),
    [anon_sym_signal] = ACTIONS(1379),
    [anon_sym_on] = ACTIONS(1379),
    [anon_sym_required] = ACTIONS(1379),
    [anon_sym_component] = ACTIONS(1379),
    [sym_html_comment] = ACTIONS(5),
  },
  [377] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1520),
    [sym_expression] = STATE(2432),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1520),
    [sym_subscript_expression] = STATE(1520),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6049),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(377),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1520),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_mapped_type_clause] = STATE(6036),
    [sym_type_arguments] = STATE(556),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(2170),
    [anon_sym_export] = ACTIONS(2172),
    [anon_sym_type] = ACTIONS(2172),
    [anon_sym_namespace] = ACTIONS(2174),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(2172),
    [anon_sym_let] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_of] = ACTIONS(2172),
    [anon_sym_yield] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(2176),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(2178),
    [anon_sym_using] = ACTIONS(1247),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1257),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(2172),
    [anon_sym_readonly] = ACTIONS(2172),
    [anon_sym_get] = ACTIONS(2172),
    [anon_sym_set] = ACTIONS(2172),
    [anon_sym_declare] = ACTIONS(2172),
    [anon_sym_public] = ACTIONS(2172),
    [anon_sym_private] = ACTIONS(2172),
    [anon_sym_protected] = ACTIONS(2172),
    [anon_sym_override] = ACTIONS(2172),
    [anon_sym_module] = ACTIONS(2172),
    [anon_sym_any] = ACTIONS(2172),
    [anon_sym_number] = ACTIONS(2172),
    [anon_sym_boolean] = ACTIONS(2172),
    [anon_sym_string] = ACTIONS(2172),
    [anon_sym_symbol] = ACTIONS(2172),
    [anon_sym_object] = ACTIONS(2172),
    [anon_sym_property] = ACTIONS(2172),
    [anon_sym_signal] = ACTIONS(2172),
    [anon_sym_on] = ACTIONS(2172),
    [anon_sym_required] = ACTIONS(2172),
    [anon_sym_component] = ACTIONS(2172),
    [sym_html_comment] = ACTIONS(5),
  },
  [378] = {
    [sym_import] = STATE(3710),
    [sym_statement_block] = STATE(2022),
    [sym_parenthesized_expression] = STATE(1520),
    [sym_expression] = STATE(2626),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1520),
    [sym_subscript_expression] = STATE(1520),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6049),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(378),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1520),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(556),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1229),
    [anon_sym_namespace] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(2156),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1229),
    [anon_sym_let] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_of] = ACTIONS(1229),
    [anon_sym_yield] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1551),
    [anon_sym_using] = ACTIONS(1247),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1257),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_readonly] = ACTIONS(1229),
    [anon_sym_get] = ACTIONS(1229),
    [anon_sym_set] = ACTIONS(1229),
    [anon_sym_declare] = ACTIONS(1229),
    [anon_sym_public] = ACTIONS(1229),
    [anon_sym_private] = ACTIONS(1229),
    [anon_sym_protected] = ACTIONS(1229),
    [anon_sym_override] = ACTIONS(1229),
    [anon_sym_module] = ACTIONS(1229),
    [anon_sym_any] = ACTIONS(1229),
    [anon_sym_number] = ACTIONS(1229),
    [anon_sym_boolean] = ACTIONS(1229),
    [anon_sym_string] = ACTIONS(1229),
    [anon_sym_symbol] = ACTIONS(1229),
    [anon_sym_object] = ACTIONS(1229),
    [anon_sym_property] = ACTIONS(1229),
    [anon_sym_signal] = ACTIONS(1229),
    [anon_sym_on] = ACTIONS(1229),
    [anon_sym_required] = ACTIONS(1229),
    [anon_sym_component] = ACTIONS(1229),
    [sym_html_comment] = ACTIONS(5),
  },
  [379] = {
    [sym_import] = STATE(3710),
    [sym_statement_block] = STATE(2022),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2709),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(379),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [sym_html_comment] = ACTIONS(5),
  },
  [380] = {
    [sym_import] = STATE(3710),
    [sym_statement_block] = STATE(1964),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_expression] = STATE(2525),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5939),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(380),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1523),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1555),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_of] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_using] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_property] = ACTIONS(1181),
    [anon_sym_signal] = ACTIONS(1181),
    [anon_sym_on] = ACTIONS(1181),
    [anon_sym_required] = ACTIONS(1181),
    [anon_sym_component] = ACTIONS(1181),
    [sym_html_comment] = ACTIONS(5),
  },
  [381] = {
    [sym_import] = STATE(3710),
    [sym_statement_block] = STATE(2062),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_expression] = STATE(2446),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5939),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(381),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1523),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1555),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_of] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_using] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_property] = ACTIONS(1181),
    [anon_sym_signal] = ACTIONS(1181),
    [anon_sym_on] = ACTIONS(1181),
    [anon_sym_required] = ACTIONS(1181),
    [anon_sym_component] = ACTIONS(1181),
    [sym_html_comment] = ACTIONS(5),
  },
  [382] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2200),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_sequence_expression] = STATE(6004),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(382),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [383] = {
    [sym_import] = STATE(3710),
    [sym_statement_block] = STATE(2036),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_expression] = STATE(2481),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5939),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(383),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1523),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1555),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_of] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_using] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_property] = ACTIONS(1181),
    [anon_sym_signal] = ACTIONS(1181),
    [anon_sym_on] = ACTIONS(1181),
    [anon_sym_required] = ACTIONS(1181),
    [anon_sym_component] = ACTIONS(1181),
    [sym_html_comment] = ACTIONS(5),
  },
  [384] = {
    [sym_import] = STATE(3710),
    [sym_statement_block] = STATE(2036),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1912),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(384),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(2156),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [385] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2140),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_sequence_expression] = STATE(6190),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(385),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [386] = {
    [sym_import] = STATE(3590),
    [sym_statement_block] = STATE(2435),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_expression] = STATE(2028),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6164),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3271),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6167),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(386),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1451),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(522),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_export] = ACTIONS(1327),
    [anon_sym_type] = ACTIONS(1327),
    [anon_sym_namespace] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(2154),
    [anon_sym_typeof] = ACTIONS(1349),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_let] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1333),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_of] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1527),
    [anon_sym_using] = ACTIONS(1343),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_SLASH] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_void] = ACTIONS(1349),
    [anon_sym_delete] = ACTIONS(1349),
    [anon_sym_PLUS_PLUS] = ACTIONS(1351),
    [anon_sym_DASH_DASH] = ACTIONS(1351),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1353),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1327),
    [anon_sym_readonly] = ACTIONS(1327),
    [anon_sym_get] = ACTIONS(1327),
    [anon_sym_set] = ACTIONS(1327),
    [anon_sym_declare] = ACTIONS(1327),
    [anon_sym_public] = ACTIONS(1327),
    [anon_sym_private] = ACTIONS(1327),
    [anon_sym_protected] = ACTIONS(1327),
    [anon_sym_override] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_any] = ACTIONS(1327),
    [anon_sym_number] = ACTIONS(1327),
    [anon_sym_boolean] = ACTIONS(1327),
    [anon_sym_string] = ACTIONS(1327),
    [anon_sym_symbol] = ACTIONS(1327),
    [anon_sym_object] = ACTIONS(1327),
    [anon_sym_property] = ACTIONS(1327),
    [anon_sym_signal] = ACTIONS(1327),
    [anon_sym_on] = ACTIONS(1327),
    [anon_sym_required] = ACTIONS(1327),
    [anon_sym_component] = ACTIONS(1327),
    [sym_html_comment] = ACTIONS(5),
  },
  [387] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2041),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_sequence_expression] = STATE(5830),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(387),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [388] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2194),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_sequence_expression] = STATE(6192),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(388),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [389] = {
    [sym_import] = STATE(3590),
    [sym_statement_block] = STATE(2546),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2024),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(389),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(2154),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [390] = {
    [sym_import] = STATE(3590),
    [sym_statement_block] = STATE(2435),
    [sym_parenthesized_expression] = STATE(1487),
    [sym_expression] = STATE(2411),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1487),
    [sym_subscript_expression] = STATE(1487),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3189),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6145),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(390),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1487),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1131),
    [anon_sym_namespace] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(2154),
    [anon_sym_typeof] = ACTIONS(1159),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_let] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_of] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1149),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_using] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1159),
    [anon_sym_delete] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1167),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1131),
    [anon_sym_readonly] = ACTIONS(1131),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_declare] = ACTIONS(1131),
    [anon_sym_public] = ACTIONS(1131),
    [anon_sym_private] = ACTIONS(1131),
    [anon_sym_protected] = ACTIONS(1131),
    [anon_sym_override] = ACTIONS(1131),
    [anon_sym_module] = ACTIONS(1131),
    [anon_sym_any] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_boolean] = ACTIONS(1131),
    [anon_sym_string] = ACTIONS(1131),
    [anon_sym_symbol] = ACTIONS(1131),
    [anon_sym_object] = ACTIONS(1131),
    [anon_sym_property] = ACTIONS(1131),
    [anon_sym_signal] = ACTIONS(1131),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_required] = ACTIONS(1131),
    [anon_sym_component] = ACTIONS(1131),
    [sym_html_comment] = ACTIONS(5),
  },
  [391] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1870),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_sequence_expression] = STATE(6198),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(391),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [392] = {
    [sym_import] = STATE(3710),
    [sym_statement_block] = STATE(1966),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_expression] = STATE(2526),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5939),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(392),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1523),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1555),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_of] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_using] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_property] = ACTIONS(1181),
    [anon_sym_signal] = ACTIONS(1181),
    [anon_sym_on] = ACTIONS(1181),
    [anon_sym_required] = ACTIONS(1181),
    [anon_sym_component] = ACTIONS(1181),
    [sym_html_comment] = ACTIONS(5),
  },
  [393] = {
    [sym_import] = STATE(3710),
    [sym_statement_block] = STATE(1966),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1746),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(393),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(2156),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [394] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2399),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(394),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [395] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_expression] = STATE(1982),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6164),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3271),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6167),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(395),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1451),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(522),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_export] = ACTIONS(1327),
    [anon_sym_type] = ACTIONS(1327),
    [anon_sym_namespace] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1349),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_let] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1333),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_of] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1527),
    [anon_sym_using] = ACTIONS(1343),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_SLASH] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_void] = ACTIONS(1349),
    [anon_sym_delete] = ACTIONS(1349),
    [anon_sym_PLUS_PLUS] = ACTIONS(1351),
    [anon_sym_DASH_DASH] = ACTIONS(1351),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1353),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1327),
    [anon_sym_readonly] = ACTIONS(1327),
    [anon_sym_get] = ACTIONS(1327),
    [anon_sym_set] = ACTIONS(1327),
    [anon_sym_declare] = ACTIONS(1327),
    [anon_sym_public] = ACTIONS(1327),
    [anon_sym_private] = ACTIONS(1327),
    [anon_sym_protected] = ACTIONS(1327),
    [anon_sym_override] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_any] = ACTIONS(1327),
    [anon_sym_number] = ACTIONS(1327),
    [anon_sym_boolean] = ACTIONS(1327),
    [anon_sym_string] = ACTIONS(1327),
    [anon_sym_symbol] = ACTIONS(1327),
    [anon_sym_object] = ACTIONS(1327),
    [anon_sym_property] = ACTIONS(1327),
    [anon_sym_signal] = ACTIONS(1327),
    [anon_sym_on] = ACTIONS(1327),
    [anon_sym_required] = ACTIONS(1327),
    [anon_sym_component] = ACTIONS(1327),
    [sym_html_comment] = ACTIONS(5),
  },
  [396] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1520),
    [sym_expression] = STATE(2574),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1520),
    [sym_subscript_expression] = STATE(1520),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6049),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(396),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1520),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(556),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1229),
    [anon_sym_namespace] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1229),
    [anon_sym_let] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_of] = ACTIONS(1229),
    [anon_sym_yield] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1551),
    [anon_sym_using] = ACTIONS(1247),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1257),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_readonly] = ACTIONS(1229),
    [anon_sym_get] = ACTIONS(1229),
    [anon_sym_set] = ACTIONS(1229),
    [anon_sym_declare] = ACTIONS(1229),
    [anon_sym_public] = ACTIONS(1229),
    [anon_sym_private] = ACTIONS(1229),
    [anon_sym_protected] = ACTIONS(1229),
    [anon_sym_override] = ACTIONS(1229),
    [anon_sym_module] = ACTIONS(1229),
    [anon_sym_any] = ACTIONS(1229),
    [anon_sym_number] = ACTIONS(1229),
    [anon_sym_boolean] = ACTIONS(1229),
    [anon_sym_string] = ACTIONS(1229),
    [anon_sym_symbol] = ACTIONS(1229),
    [anon_sym_object] = ACTIONS(1229),
    [anon_sym_property] = ACTIONS(1229),
    [anon_sym_signal] = ACTIONS(1229),
    [anon_sym_on] = ACTIONS(1229),
    [anon_sym_required] = ACTIONS(1229),
    [anon_sym_component] = ACTIONS(1229),
    [sym_html_comment] = ACTIONS(5),
  },
  [397] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(397),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [398] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_expression] = STATE(2434),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5939),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(398),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1523),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1555),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_of] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_using] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_property] = ACTIONS(1181),
    [anon_sym_signal] = ACTIONS(1181),
    [anon_sym_on] = ACTIONS(1181),
    [anon_sym_required] = ACTIONS(1181),
    [anon_sym_component] = ACTIONS(1181),
    [sym_html_comment] = ACTIONS(5),
  },
  [399] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_expression] = STATE(2429),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5939),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(399),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1523),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1555),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_of] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_using] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_property] = ACTIONS(1181),
    [anon_sym_signal] = ACTIONS(1181),
    [anon_sym_on] = ACTIONS(1181),
    [anon_sym_required] = ACTIONS(1181),
    [anon_sym_component] = ACTIONS(1181),
    [sym_html_comment] = ACTIONS(5),
  },
  [400] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_expression] = STATE(2468),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5939),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(400),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1523),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1555),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_of] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_using] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_property] = ACTIONS(1181),
    [anon_sym_signal] = ACTIONS(1181),
    [anon_sym_on] = ACTIONS(1181),
    [anon_sym_required] = ACTIONS(1181),
    [anon_sym_component] = ACTIONS(1181),
    [sym_html_comment] = ACTIONS(5),
  },
  [401] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1538),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1538),
    [sym_subscript_expression] = STATE(1538),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6175),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(401),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1538),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(2180),
    [anon_sym_export] = ACTIONS(2182),
    [anon_sym_type] = ACTIONS(2182),
    [anon_sym_namespace] = ACTIONS(2184),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(2182),
    [anon_sym_let] = ACTIONS(2182),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(2182),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(2188),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(2190),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(2182),
    [anon_sym_readonly] = ACTIONS(2182),
    [anon_sym_get] = ACTIONS(2182),
    [anon_sym_set] = ACTIONS(2182),
    [anon_sym_declare] = ACTIONS(2182),
    [anon_sym_public] = ACTIONS(2182),
    [anon_sym_private] = ACTIONS(2182),
    [anon_sym_protected] = ACTIONS(2182),
    [anon_sym_override] = ACTIONS(2182),
    [anon_sym_module] = ACTIONS(2182),
    [anon_sym_any] = ACTIONS(2182),
    [anon_sym_number] = ACTIONS(2182),
    [anon_sym_boolean] = ACTIONS(2182),
    [anon_sym_string] = ACTIONS(2182),
    [anon_sym_symbol] = ACTIONS(2182),
    [anon_sym_object] = ACTIONS(2182),
    [anon_sym_property] = ACTIONS(2182),
    [anon_sym_signal] = ACTIONS(2182),
    [anon_sym_on] = ACTIONS(2182),
    [anon_sym_required] = ACTIONS(2182),
    [anon_sym_component] = ACTIONS(2182),
    [sym_html_comment] = ACTIONS(5),
  },
  [402] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1487),
    [sym_expression] = STATE(2420),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1487),
    [sym_subscript_expression] = STATE(1487),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3189),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6145),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(402),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1487),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1131),
    [anon_sym_namespace] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1159),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_let] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_of] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1149),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_using] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1159),
    [anon_sym_delete] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1167),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1131),
    [anon_sym_readonly] = ACTIONS(1131),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_declare] = ACTIONS(1131),
    [anon_sym_public] = ACTIONS(1131),
    [anon_sym_private] = ACTIONS(1131),
    [anon_sym_protected] = ACTIONS(1131),
    [anon_sym_override] = ACTIONS(1131),
    [anon_sym_module] = ACTIONS(1131),
    [anon_sym_any] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_boolean] = ACTIONS(1131),
    [anon_sym_string] = ACTIONS(1131),
    [anon_sym_symbol] = ACTIONS(1131),
    [anon_sym_object] = ACTIONS(1131),
    [anon_sym_property] = ACTIONS(1131),
    [anon_sym_signal] = ACTIONS(1131),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_required] = ACTIONS(1131),
    [anon_sym_component] = ACTIONS(1131),
    [sym_html_comment] = ACTIONS(5),
  },
  [403] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1473),
    [sym_expression] = STATE(2095),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6272),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1473),
    [sym_subscript_expression] = STATE(1473),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3246),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6274),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(403),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1473),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(541),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_export] = ACTIONS(1415),
    [anon_sym_type] = ACTIONS(1415),
    [anon_sym_namespace] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1437),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1415),
    [anon_sym_let] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1421),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1423),
    [anon_sym_of] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1425),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1427),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1543),
    [anon_sym_using] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1421),
    [anon_sym_void] = ACTIONS(1437),
    [anon_sym_delete] = ACTIONS(1437),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1441),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1415),
    [anon_sym_readonly] = ACTIONS(1415),
    [anon_sym_get] = ACTIONS(1415),
    [anon_sym_set] = ACTIONS(1415),
    [anon_sym_declare] = ACTIONS(1415),
    [anon_sym_public] = ACTIONS(1415),
    [anon_sym_private] = ACTIONS(1415),
    [anon_sym_protected] = ACTIONS(1415),
    [anon_sym_override] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_any] = ACTIONS(1415),
    [anon_sym_number] = ACTIONS(1415),
    [anon_sym_boolean] = ACTIONS(1415),
    [anon_sym_string] = ACTIONS(1415),
    [anon_sym_symbol] = ACTIONS(1415),
    [anon_sym_object] = ACTIONS(1415),
    [anon_sym_property] = ACTIONS(1415),
    [anon_sym_signal] = ACTIONS(1415),
    [anon_sym_on] = ACTIONS(1415),
    [anon_sym_required] = ACTIONS(1415),
    [anon_sym_component] = ACTIONS(1415),
    [sym_html_comment] = ACTIONS(5),
  },
  [404] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2728),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(404),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(2192),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [sym_html_comment] = ACTIONS(5),
  },
  [405] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1520),
    [sym_expression] = STATE(2624),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1520),
    [sym_subscript_expression] = STATE(1520),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6049),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(405),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1520),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(556),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1229),
    [anon_sym_namespace] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1229),
    [anon_sym_let] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_of] = ACTIONS(1229),
    [anon_sym_yield] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1551),
    [anon_sym_using] = ACTIONS(1247),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1257),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_readonly] = ACTIONS(1229),
    [anon_sym_get] = ACTIONS(1229),
    [anon_sym_set] = ACTIONS(1229),
    [anon_sym_declare] = ACTIONS(1229),
    [anon_sym_public] = ACTIONS(1229),
    [anon_sym_private] = ACTIONS(1229),
    [anon_sym_protected] = ACTIONS(1229),
    [anon_sym_override] = ACTIONS(1229),
    [anon_sym_module] = ACTIONS(1229),
    [anon_sym_any] = ACTIONS(1229),
    [anon_sym_number] = ACTIONS(1229),
    [anon_sym_boolean] = ACTIONS(1229),
    [anon_sym_string] = ACTIONS(1229),
    [anon_sym_symbol] = ACTIONS(1229),
    [anon_sym_object] = ACTIONS(1229),
    [anon_sym_property] = ACTIONS(1229),
    [anon_sym_signal] = ACTIONS(1229),
    [anon_sym_on] = ACTIONS(1229),
    [anon_sym_required] = ACTIONS(1229),
    [anon_sym_component] = ACTIONS(1229),
    [sym_html_comment] = ACTIONS(5),
  },
  [406] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_expression] = STATE(2450),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5939),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(406),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1523),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1555),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_of] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_using] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_property] = ACTIONS(1181),
    [anon_sym_signal] = ACTIONS(1181),
    [anon_sym_on] = ACTIONS(1181),
    [anon_sym_required] = ACTIONS(1181),
    [anon_sym_component] = ACTIONS(1181),
    [sym_html_comment] = ACTIONS(5),
  },
  [407] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6164),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3271),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6167),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(407),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1451),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(522),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_export] = ACTIONS(1327),
    [anon_sym_type] = ACTIONS(1327),
    [anon_sym_namespace] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1349),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_let] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1333),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_of] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1527),
    [anon_sym_using] = ACTIONS(1343),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_SLASH] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_void] = ACTIONS(1349),
    [anon_sym_delete] = ACTIONS(1349),
    [anon_sym_PLUS_PLUS] = ACTIONS(1351),
    [anon_sym_DASH_DASH] = ACTIONS(1351),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1353),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1327),
    [anon_sym_readonly] = ACTIONS(1327),
    [anon_sym_get] = ACTIONS(1327),
    [anon_sym_set] = ACTIONS(1327),
    [anon_sym_declare] = ACTIONS(1327),
    [anon_sym_public] = ACTIONS(1327),
    [anon_sym_private] = ACTIONS(1327),
    [anon_sym_protected] = ACTIONS(1327),
    [anon_sym_override] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_any] = ACTIONS(1327),
    [anon_sym_number] = ACTIONS(1327),
    [anon_sym_boolean] = ACTIONS(1327),
    [anon_sym_string] = ACTIONS(1327),
    [anon_sym_symbol] = ACTIONS(1327),
    [anon_sym_object] = ACTIONS(1327),
    [anon_sym_property] = ACTIONS(1327),
    [anon_sym_signal] = ACTIONS(1327),
    [anon_sym_on] = ACTIONS(1327),
    [anon_sym_required] = ACTIONS(1327),
    [anon_sym_component] = ACTIONS(1327),
    [sym_html_comment] = ACTIONS(5),
  },
  [408] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_expression] = STATE(2504),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5939),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(408),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1523),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1555),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_of] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_using] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_property] = ACTIONS(1181),
    [anon_sym_signal] = ACTIONS(1181),
    [anon_sym_on] = ACTIONS(1181),
    [anon_sym_required] = ACTIONS(1181),
    [anon_sym_component] = ACTIONS(1181),
    [sym_html_comment] = ACTIONS(5),
  },
  [409] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1942),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(409),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [410] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1520),
    [sym_expression] = STATE(2660),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1520),
    [sym_subscript_expression] = STATE(1520),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6049),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(410),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1520),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(556),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1229),
    [anon_sym_namespace] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1229),
    [anon_sym_let] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_of] = ACTIONS(1229),
    [anon_sym_yield] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1551),
    [anon_sym_using] = ACTIONS(1247),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1257),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_readonly] = ACTIONS(1229),
    [anon_sym_get] = ACTIONS(1229),
    [anon_sym_set] = ACTIONS(1229),
    [anon_sym_declare] = ACTIONS(1229),
    [anon_sym_public] = ACTIONS(1229),
    [anon_sym_private] = ACTIONS(1229),
    [anon_sym_protected] = ACTIONS(1229),
    [anon_sym_override] = ACTIONS(1229),
    [anon_sym_module] = ACTIONS(1229),
    [anon_sym_any] = ACTIONS(1229),
    [anon_sym_number] = ACTIONS(1229),
    [anon_sym_boolean] = ACTIONS(1229),
    [anon_sym_string] = ACTIONS(1229),
    [anon_sym_symbol] = ACTIONS(1229),
    [anon_sym_object] = ACTIONS(1229),
    [anon_sym_property] = ACTIONS(1229),
    [anon_sym_signal] = ACTIONS(1229),
    [anon_sym_on] = ACTIONS(1229),
    [anon_sym_required] = ACTIONS(1229),
    [anon_sym_component] = ACTIONS(1229),
    [sym_html_comment] = ACTIONS(5),
  },
  [411] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2141),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(411),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [412] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1487),
    [sym_expression] = STATE(2414),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1487),
    [sym_subscript_expression] = STATE(1487),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3189),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6145),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(412),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1487),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1131),
    [anon_sym_namespace] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1159),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_let] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_of] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1149),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_using] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1159),
    [anon_sym_delete] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1167),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1131),
    [anon_sym_readonly] = ACTIONS(1131),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_declare] = ACTIONS(1131),
    [anon_sym_public] = ACTIONS(1131),
    [anon_sym_private] = ACTIONS(1131),
    [anon_sym_protected] = ACTIONS(1131),
    [anon_sym_override] = ACTIONS(1131),
    [anon_sym_module] = ACTIONS(1131),
    [anon_sym_any] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_boolean] = ACTIONS(1131),
    [anon_sym_string] = ACTIONS(1131),
    [anon_sym_symbol] = ACTIONS(1131),
    [anon_sym_object] = ACTIONS(1131),
    [anon_sym_property] = ACTIONS(1131),
    [anon_sym_signal] = ACTIONS(1131),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_required] = ACTIONS(1131),
    [anon_sym_component] = ACTIONS(1131),
    [sym_html_comment] = ACTIONS(5),
  },
  [413] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_expression] = STATE(2027),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6164),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3271),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6167),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(413),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1451),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(522),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_export] = ACTIONS(1327),
    [anon_sym_type] = ACTIONS(1327),
    [anon_sym_namespace] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1349),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_let] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1333),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_of] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1527),
    [anon_sym_using] = ACTIONS(1343),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_SLASH] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_void] = ACTIONS(1349),
    [anon_sym_delete] = ACTIONS(1349),
    [anon_sym_PLUS_PLUS] = ACTIONS(1351),
    [anon_sym_DASH_DASH] = ACTIONS(1351),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1353),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1327),
    [anon_sym_readonly] = ACTIONS(1327),
    [anon_sym_get] = ACTIONS(1327),
    [anon_sym_set] = ACTIONS(1327),
    [anon_sym_declare] = ACTIONS(1327),
    [anon_sym_public] = ACTIONS(1327),
    [anon_sym_private] = ACTIONS(1327),
    [anon_sym_protected] = ACTIONS(1327),
    [anon_sym_override] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_any] = ACTIONS(1327),
    [anon_sym_number] = ACTIONS(1327),
    [anon_sym_boolean] = ACTIONS(1327),
    [anon_sym_string] = ACTIONS(1327),
    [anon_sym_symbol] = ACTIONS(1327),
    [anon_sym_object] = ACTIONS(1327),
    [anon_sym_property] = ACTIONS(1327),
    [anon_sym_signal] = ACTIONS(1327),
    [anon_sym_on] = ACTIONS(1327),
    [anon_sym_required] = ACTIONS(1327),
    [anon_sym_component] = ACTIONS(1327),
    [sym_html_comment] = ACTIONS(5),
  },
  [414] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2000),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(414),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [415] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1998),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(415),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [416] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1997),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(416),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [417] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1995),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(417),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [418] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1994),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(418),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [419] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1992),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(419),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [420] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1991),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(420),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [421] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1990),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(421),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [422] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1487),
    [sym_expression] = STATE(2308),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1487),
    [sym_subscript_expression] = STATE(1487),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3189),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6145),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(422),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1487),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1131),
    [anon_sym_namespace] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1159),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_let] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_of] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1149),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_using] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1159),
    [anon_sym_delete] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1167),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1131),
    [anon_sym_readonly] = ACTIONS(1131),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_declare] = ACTIONS(1131),
    [anon_sym_public] = ACTIONS(1131),
    [anon_sym_private] = ACTIONS(1131),
    [anon_sym_protected] = ACTIONS(1131),
    [anon_sym_override] = ACTIONS(1131),
    [anon_sym_module] = ACTIONS(1131),
    [anon_sym_any] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_boolean] = ACTIONS(1131),
    [anon_sym_string] = ACTIONS(1131),
    [anon_sym_symbol] = ACTIONS(1131),
    [anon_sym_object] = ACTIONS(1131),
    [anon_sym_property] = ACTIONS(1131),
    [anon_sym_signal] = ACTIONS(1131),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_required] = ACTIONS(1131),
    [anon_sym_component] = ACTIONS(1131),
    [sym_html_comment] = ACTIONS(5),
  },
  [423] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1977),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(423),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [424] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1975),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(424),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [425] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_expression] = STATE(2009),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6164),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3271),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6167),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(425),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1451),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(522),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_export] = ACTIONS(1327),
    [anon_sym_type] = ACTIONS(1327),
    [anon_sym_namespace] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1349),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_let] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1333),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_of] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1527),
    [anon_sym_using] = ACTIONS(1343),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_SLASH] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_void] = ACTIONS(1349),
    [anon_sym_delete] = ACTIONS(1349),
    [anon_sym_PLUS_PLUS] = ACTIONS(1351),
    [anon_sym_DASH_DASH] = ACTIONS(1351),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1353),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1327),
    [anon_sym_readonly] = ACTIONS(1327),
    [anon_sym_get] = ACTIONS(1327),
    [anon_sym_set] = ACTIONS(1327),
    [anon_sym_declare] = ACTIONS(1327),
    [anon_sym_public] = ACTIONS(1327),
    [anon_sym_private] = ACTIONS(1327),
    [anon_sym_protected] = ACTIONS(1327),
    [anon_sym_override] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_any] = ACTIONS(1327),
    [anon_sym_number] = ACTIONS(1327),
    [anon_sym_boolean] = ACTIONS(1327),
    [anon_sym_string] = ACTIONS(1327),
    [anon_sym_symbol] = ACTIONS(1327),
    [anon_sym_object] = ACTIONS(1327),
    [anon_sym_property] = ACTIONS(1327),
    [anon_sym_signal] = ACTIONS(1327),
    [anon_sym_on] = ACTIONS(1327),
    [anon_sym_required] = ACTIONS(1327),
    [anon_sym_component] = ACTIONS(1327),
    [sym_html_comment] = ACTIONS(5),
  },
  [426] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_expression] = STATE(1988),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6164),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3271),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6167),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(426),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1451),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(522),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_export] = ACTIONS(1327),
    [anon_sym_type] = ACTIONS(1327),
    [anon_sym_namespace] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1349),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_let] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1333),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_of] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1527),
    [anon_sym_using] = ACTIONS(1343),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_SLASH] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_void] = ACTIONS(1349),
    [anon_sym_delete] = ACTIONS(1349),
    [anon_sym_PLUS_PLUS] = ACTIONS(1351),
    [anon_sym_DASH_DASH] = ACTIONS(1351),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1353),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1327),
    [anon_sym_readonly] = ACTIONS(1327),
    [anon_sym_get] = ACTIONS(1327),
    [anon_sym_set] = ACTIONS(1327),
    [anon_sym_declare] = ACTIONS(1327),
    [anon_sym_public] = ACTIONS(1327),
    [anon_sym_private] = ACTIONS(1327),
    [anon_sym_protected] = ACTIONS(1327),
    [anon_sym_override] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_any] = ACTIONS(1327),
    [anon_sym_number] = ACTIONS(1327),
    [anon_sym_boolean] = ACTIONS(1327),
    [anon_sym_string] = ACTIONS(1327),
    [anon_sym_symbol] = ACTIONS(1327),
    [anon_sym_object] = ACTIONS(1327),
    [anon_sym_property] = ACTIONS(1327),
    [anon_sym_signal] = ACTIONS(1327),
    [anon_sym_on] = ACTIONS(1327),
    [anon_sym_required] = ACTIONS(1327),
    [anon_sym_component] = ACTIONS(1327),
    [sym_html_comment] = ACTIONS(5),
  },
  [427] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_expression] = STATE(2447),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5939),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(427),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1523),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1555),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_of] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_using] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_property] = ACTIONS(1181),
    [anon_sym_signal] = ACTIONS(1181),
    [anon_sym_on] = ACTIONS(1181),
    [anon_sym_required] = ACTIONS(1181),
    [anon_sym_component] = ACTIONS(1181),
    [sym_html_comment] = ACTIONS(5),
  },
  [428] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2710),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(428),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [sym_html_comment] = ACTIONS(5),
  },
  [429] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1539),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1539),
    [sym_subscript_expression] = STATE(1539),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5984),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(429),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1539),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(2194),
    [anon_sym_export] = ACTIONS(2196),
    [anon_sym_type] = ACTIONS(2196),
    [anon_sym_namespace] = ACTIONS(2198),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(2196),
    [anon_sym_let] = ACTIONS(2196),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(2196),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(2200),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(2202),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(2196),
    [anon_sym_readonly] = ACTIONS(2196),
    [anon_sym_get] = ACTIONS(2196),
    [anon_sym_set] = ACTIONS(2196),
    [anon_sym_declare] = ACTIONS(2196),
    [anon_sym_public] = ACTIONS(2196),
    [anon_sym_private] = ACTIONS(2196),
    [anon_sym_protected] = ACTIONS(2196),
    [anon_sym_override] = ACTIONS(2196),
    [anon_sym_module] = ACTIONS(2196),
    [anon_sym_any] = ACTIONS(2196),
    [anon_sym_number] = ACTIONS(2196),
    [anon_sym_boolean] = ACTIONS(2196),
    [anon_sym_string] = ACTIONS(2196),
    [anon_sym_symbol] = ACTIONS(2196),
    [anon_sym_object] = ACTIONS(2196),
    [anon_sym_property] = ACTIONS(2196),
    [anon_sym_signal] = ACTIONS(2196),
    [anon_sym_on] = ACTIONS(2196),
    [anon_sym_required] = ACTIONS(2196),
    [anon_sym_component] = ACTIONS(2196),
    [sym_html_comment] = ACTIONS(5),
  },
  [430] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1791),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(430),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(2206),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [431] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1513),
    [sym_expression] = STATE(2655),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6293),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1513),
    [sym_subscript_expression] = STATE(1513),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3245),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6295),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(431),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1513),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(455),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1565),
    [anon_sym_export] = ACTIONS(1379),
    [anon_sym_type] = ACTIONS(1379),
    [anon_sym_namespace] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1379),
    [anon_sym_let] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1385),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_of] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1389),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1391),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_using] = ACTIONS(1395),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_void] = ACTIONS(1401),
    [anon_sym_delete] = ACTIONS(1401),
    [anon_sym_PLUS_PLUS] = ACTIONS(1403),
    [anon_sym_DASH_DASH] = ACTIONS(1403),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(2208),
    [sym_private_property_identifier] = ACTIONS(1405),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1571),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1379),
    [anon_sym_readonly] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(1379),
    [anon_sym_set] = ACTIONS(1379),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_public] = ACTIONS(1379),
    [anon_sym_private] = ACTIONS(1379),
    [anon_sym_protected] = ACTIONS(1379),
    [anon_sym_override] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1379),
    [anon_sym_any] = ACTIONS(1379),
    [anon_sym_number] = ACTIONS(1379),
    [anon_sym_boolean] = ACTIONS(1379),
    [anon_sym_string] = ACTIONS(1379),
    [anon_sym_symbol] = ACTIONS(1379),
    [anon_sym_object] = ACTIONS(1379),
    [anon_sym_property] = ACTIONS(1379),
    [anon_sym_signal] = ACTIONS(1379),
    [anon_sym_on] = ACTIONS(1379),
    [anon_sym_required] = ACTIONS(1379),
    [anon_sym_component] = ACTIONS(1379),
    [sym_html_comment] = ACTIONS(5),
  },
  [432] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1520),
    [sym_expression] = STATE(2663),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1520),
    [sym_subscript_expression] = STATE(1520),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6049),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(432),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1520),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(556),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1229),
    [anon_sym_namespace] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1229),
    [anon_sym_let] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_of] = ACTIONS(1229),
    [anon_sym_yield] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1551),
    [anon_sym_using] = ACTIONS(1247),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1257),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_readonly] = ACTIONS(1229),
    [anon_sym_get] = ACTIONS(1229),
    [anon_sym_set] = ACTIONS(1229),
    [anon_sym_declare] = ACTIONS(1229),
    [anon_sym_public] = ACTIONS(1229),
    [anon_sym_private] = ACTIONS(1229),
    [anon_sym_protected] = ACTIONS(1229),
    [anon_sym_override] = ACTIONS(1229),
    [anon_sym_module] = ACTIONS(1229),
    [anon_sym_any] = ACTIONS(1229),
    [anon_sym_number] = ACTIONS(1229),
    [anon_sym_boolean] = ACTIONS(1229),
    [anon_sym_string] = ACTIONS(1229),
    [anon_sym_symbol] = ACTIONS(1229),
    [anon_sym_object] = ACTIONS(1229),
    [anon_sym_property] = ACTIONS(1229),
    [anon_sym_signal] = ACTIONS(1229),
    [anon_sym_on] = ACTIONS(1229),
    [anon_sym_required] = ACTIONS(1229),
    [anon_sym_component] = ACTIONS(1229),
    [sym_html_comment] = ACTIONS(5),
  },
  [433] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2703),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(433),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [sym_html_comment] = ACTIONS(5),
  },
  [434] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1520),
    [sym_expression] = STATE(2661),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1520),
    [sym_subscript_expression] = STATE(1520),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6049),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(434),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1520),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(556),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1229),
    [anon_sym_namespace] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1229),
    [anon_sym_let] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_of] = ACTIONS(1229),
    [anon_sym_yield] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1551),
    [anon_sym_using] = ACTIONS(1247),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1257),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_readonly] = ACTIONS(1229),
    [anon_sym_get] = ACTIONS(1229),
    [anon_sym_set] = ACTIONS(1229),
    [anon_sym_declare] = ACTIONS(1229),
    [anon_sym_public] = ACTIONS(1229),
    [anon_sym_private] = ACTIONS(1229),
    [anon_sym_protected] = ACTIONS(1229),
    [anon_sym_override] = ACTIONS(1229),
    [anon_sym_module] = ACTIONS(1229),
    [anon_sym_any] = ACTIONS(1229),
    [anon_sym_number] = ACTIONS(1229),
    [anon_sym_boolean] = ACTIONS(1229),
    [anon_sym_string] = ACTIONS(1229),
    [anon_sym_symbol] = ACTIONS(1229),
    [anon_sym_object] = ACTIONS(1229),
    [anon_sym_property] = ACTIONS(1229),
    [anon_sym_signal] = ACTIONS(1229),
    [anon_sym_on] = ACTIONS(1229),
    [anon_sym_required] = ACTIONS(1229),
    [anon_sym_component] = ACTIONS(1229),
    [sym_html_comment] = ACTIONS(5),
  },
  [435] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_expression] = STATE(1987),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6164),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3271),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6167),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(435),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1451),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(522),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_export] = ACTIONS(1327),
    [anon_sym_type] = ACTIONS(1327),
    [anon_sym_namespace] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1349),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_let] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1333),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_of] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1527),
    [anon_sym_using] = ACTIONS(1343),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_SLASH] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_void] = ACTIONS(1349),
    [anon_sym_delete] = ACTIONS(1349),
    [anon_sym_PLUS_PLUS] = ACTIONS(1351),
    [anon_sym_DASH_DASH] = ACTIONS(1351),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1353),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1327),
    [anon_sym_readonly] = ACTIONS(1327),
    [anon_sym_get] = ACTIONS(1327),
    [anon_sym_set] = ACTIONS(1327),
    [anon_sym_declare] = ACTIONS(1327),
    [anon_sym_public] = ACTIONS(1327),
    [anon_sym_private] = ACTIONS(1327),
    [anon_sym_protected] = ACTIONS(1327),
    [anon_sym_override] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_any] = ACTIONS(1327),
    [anon_sym_number] = ACTIONS(1327),
    [anon_sym_boolean] = ACTIONS(1327),
    [anon_sym_string] = ACTIONS(1327),
    [anon_sym_symbol] = ACTIONS(1327),
    [anon_sym_object] = ACTIONS(1327),
    [anon_sym_property] = ACTIONS(1327),
    [anon_sym_signal] = ACTIONS(1327),
    [anon_sym_on] = ACTIONS(1327),
    [anon_sym_required] = ACTIONS(1327),
    [anon_sym_component] = ACTIONS(1327),
    [sym_html_comment] = ACTIONS(5),
  },
  [436] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1965),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(436),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [437] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1842),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(437),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [438] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2715),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(438),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [sym_html_comment] = ACTIONS(5),
  },
  [439] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1520),
    [sym_expression] = STATE(2657),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1520),
    [sym_subscript_expression] = STATE(1520),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6049),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(439),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1520),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(556),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1229),
    [anon_sym_namespace] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1229),
    [anon_sym_let] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_of] = ACTIONS(1229),
    [anon_sym_yield] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1551),
    [anon_sym_using] = ACTIONS(1247),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1257),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_readonly] = ACTIONS(1229),
    [anon_sym_get] = ACTIONS(1229),
    [anon_sym_set] = ACTIONS(1229),
    [anon_sym_declare] = ACTIONS(1229),
    [anon_sym_public] = ACTIONS(1229),
    [anon_sym_private] = ACTIONS(1229),
    [anon_sym_protected] = ACTIONS(1229),
    [anon_sym_override] = ACTIONS(1229),
    [anon_sym_module] = ACTIONS(1229),
    [anon_sym_any] = ACTIONS(1229),
    [anon_sym_number] = ACTIONS(1229),
    [anon_sym_boolean] = ACTIONS(1229),
    [anon_sym_string] = ACTIONS(1229),
    [anon_sym_symbol] = ACTIONS(1229),
    [anon_sym_object] = ACTIONS(1229),
    [anon_sym_property] = ACTIONS(1229),
    [anon_sym_signal] = ACTIONS(1229),
    [anon_sym_on] = ACTIONS(1229),
    [anon_sym_required] = ACTIONS(1229),
    [anon_sym_component] = ACTIONS(1229),
    [sym_html_comment] = ACTIONS(5),
  },
  [440] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1520),
    [sym_expression] = STATE(2653),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1520),
    [sym_subscript_expression] = STATE(1520),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6049),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(440),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1520),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(556),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1229),
    [anon_sym_namespace] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1229),
    [anon_sym_let] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_of] = ACTIONS(1229),
    [anon_sym_yield] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1551),
    [anon_sym_using] = ACTIONS(1247),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1257),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_readonly] = ACTIONS(1229),
    [anon_sym_get] = ACTIONS(1229),
    [anon_sym_set] = ACTIONS(1229),
    [anon_sym_declare] = ACTIONS(1229),
    [anon_sym_public] = ACTIONS(1229),
    [anon_sym_private] = ACTIONS(1229),
    [anon_sym_protected] = ACTIONS(1229),
    [anon_sym_override] = ACTIONS(1229),
    [anon_sym_module] = ACTIONS(1229),
    [anon_sym_any] = ACTIONS(1229),
    [anon_sym_number] = ACTIONS(1229),
    [anon_sym_boolean] = ACTIONS(1229),
    [anon_sym_string] = ACTIONS(1229),
    [anon_sym_symbol] = ACTIONS(1229),
    [anon_sym_object] = ACTIONS(1229),
    [anon_sym_property] = ACTIONS(1229),
    [anon_sym_signal] = ACTIONS(1229),
    [anon_sym_on] = ACTIONS(1229),
    [anon_sym_required] = ACTIONS(1229),
    [anon_sym_component] = ACTIONS(1229),
    [sym_html_comment] = ACTIONS(5),
  },
  [441] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1520),
    [sym_expression] = STATE(2605),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1520),
    [sym_subscript_expression] = STATE(1520),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6049),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(441),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1520),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(556),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1229),
    [anon_sym_namespace] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1229),
    [anon_sym_let] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_of] = ACTIONS(1229),
    [anon_sym_yield] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1551),
    [anon_sym_using] = ACTIONS(1247),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1257),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_readonly] = ACTIONS(1229),
    [anon_sym_get] = ACTIONS(1229),
    [anon_sym_set] = ACTIONS(1229),
    [anon_sym_declare] = ACTIONS(1229),
    [anon_sym_public] = ACTIONS(1229),
    [anon_sym_private] = ACTIONS(1229),
    [anon_sym_protected] = ACTIONS(1229),
    [anon_sym_override] = ACTIONS(1229),
    [anon_sym_module] = ACTIONS(1229),
    [anon_sym_any] = ACTIONS(1229),
    [anon_sym_number] = ACTIONS(1229),
    [anon_sym_boolean] = ACTIONS(1229),
    [anon_sym_string] = ACTIONS(1229),
    [anon_sym_symbol] = ACTIONS(1229),
    [anon_sym_object] = ACTIONS(1229),
    [anon_sym_property] = ACTIONS(1229),
    [anon_sym_signal] = ACTIONS(1229),
    [anon_sym_on] = ACTIONS(1229),
    [anon_sym_required] = ACTIONS(1229),
    [anon_sym_component] = ACTIONS(1229),
    [sym_html_comment] = ACTIONS(5),
  },
  [442] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1487),
    [sym_expression] = STATE(2236),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1487),
    [sym_subscript_expression] = STATE(1487),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3189),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6145),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(442),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1487),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1131),
    [anon_sym_namespace] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1159),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_let] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_of] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1149),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_using] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1159),
    [anon_sym_delete] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1167),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1131),
    [anon_sym_readonly] = ACTIONS(1131),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_declare] = ACTIONS(1131),
    [anon_sym_public] = ACTIONS(1131),
    [anon_sym_private] = ACTIONS(1131),
    [anon_sym_protected] = ACTIONS(1131),
    [anon_sym_override] = ACTIONS(1131),
    [anon_sym_module] = ACTIONS(1131),
    [anon_sym_any] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_boolean] = ACTIONS(1131),
    [anon_sym_string] = ACTIONS(1131),
    [anon_sym_symbol] = ACTIONS(1131),
    [anon_sym_object] = ACTIONS(1131),
    [anon_sym_property] = ACTIONS(1131),
    [anon_sym_signal] = ACTIONS(1131),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_required] = ACTIONS(1131),
    [anon_sym_component] = ACTIONS(1131),
    [sym_html_comment] = ACTIONS(5),
  },
  [443] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2730),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(443),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [sym_html_comment] = ACTIONS(5),
  },
  [444] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2690),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(444),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [sym_html_comment] = ACTIONS(5),
  },
  [445] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2400),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(445),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [446] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1513),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6293),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1513),
    [sym_subscript_expression] = STATE(1513),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3245),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6295),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(446),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1513),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(455),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1565),
    [anon_sym_export] = ACTIONS(1379),
    [anon_sym_type] = ACTIONS(1379),
    [anon_sym_namespace] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1379),
    [anon_sym_let] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1385),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_of] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1389),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1391),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_using] = ACTIONS(1395),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_void] = ACTIONS(1401),
    [anon_sym_delete] = ACTIONS(1401),
    [anon_sym_PLUS_PLUS] = ACTIONS(1403),
    [anon_sym_DASH_DASH] = ACTIONS(1403),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1405),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1571),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1379),
    [anon_sym_readonly] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(1379),
    [anon_sym_set] = ACTIONS(1379),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_public] = ACTIONS(1379),
    [anon_sym_private] = ACTIONS(1379),
    [anon_sym_protected] = ACTIONS(1379),
    [anon_sym_override] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1379),
    [anon_sym_any] = ACTIONS(1379),
    [anon_sym_number] = ACTIONS(1379),
    [anon_sym_boolean] = ACTIONS(1379),
    [anon_sym_string] = ACTIONS(1379),
    [anon_sym_symbol] = ACTIONS(1379),
    [anon_sym_object] = ACTIONS(1379),
    [anon_sym_property] = ACTIONS(1379),
    [anon_sym_signal] = ACTIONS(1379),
    [anon_sym_on] = ACTIONS(1379),
    [anon_sym_required] = ACTIONS(1379),
    [anon_sym_component] = ACTIONS(1379),
    [sym_html_comment] = ACTIONS(5),
  },
  [447] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2686),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(447),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [sym_html_comment] = ACTIONS(5),
  },
  [448] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1487),
    [sym_expression] = STATE(2259),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1487),
    [sym_subscript_expression] = STATE(1487),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3189),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6145),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(448),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1487),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1131),
    [anon_sym_namespace] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1159),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_let] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_of] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1149),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_using] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1159),
    [anon_sym_delete] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1167),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1131),
    [anon_sym_readonly] = ACTIONS(1131),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_declare] = ACTIONS(1131),
    [anon_sym_public] = ACTIONS(1131),
    [anon_sym_private] = ACTIONS(1131),
    [anon_sym_protected] = ACTIONS(1131),
    [anon_sym_override] = ACTIONS(1131),
    [anon_sym_module] = ACTIONS(1131),
    [anon_sym_any] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_boolean] = ACTIONS(1131),
    [anon_sym_string] = ACTIONS(1131),
    [anon_sym_symbol] = ACTIONS(1131),
    [anon_sym_object] = ACTIONS(1131),
    [anon_sym_property] = ACTIONS(1131),
    [anon_sym_signal] = ACTIONS(1131),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_required] = ACTIONS(1131),
    [anon_sym_component] = ACTIONS(1131),
    [sym_html_comment] = ACTIONS(5),
  },
  [449] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1513),
    [sym_expression] = STATE(2613),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6293),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1513),
    [sym_subscript_expression] = STATE(1513),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3245),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6295),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(449),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1513),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(455),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1565),
    [anon_sym_export] = ACTIONS(1379),
    [anon_sym_type] = ACTIONS(1379),
    [anon_sym_namespace] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1379),
    [anon_sym_let] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1385),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_of] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1389),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1391),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_using] = ACTIONS(1395),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_void] = ACTIONS(1401),
    [anon_sym_delete] = ACTIONS(1401),
    [anon_sym_PLUS_PLUS] = ACTIONS(1403),
    [anon_sym_DASH_DASH] = ACTIONS(1403),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1405),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1571),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1379),
    [anon_sym_readonly] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(1379),
    [anon_sym_set] = ACTIONS(1379),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_public] = ACTIONS(1379),
    [anon_sym_private] = ACTIONS(1379),
    [anon_sym_protected] = ACTIONS(1379),
    [anon_sym_override] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1379),
    [anon_sym_any] = ACTIONS(1379),
    [anon_sym_number] = ACTIONS(1379),
    [anon_sym_boolean] = ACTIONS(1379),
    [anon_sym_string] = ACTIONS(1379),
    [anon_sym_symbol] = ACTIONS(1379),
    [anon_sym_object] = ACTIONS(1379),
    [anon_sym_property] = ACTIONS(1379),
    [anon_sym_signal] = ACTIONS(1379),
    [anon_sym_on] = ACTIONS(1379),
    [anon_sym_required] = ACTIONS(1379),
    [anon_sym_component] = ACTIONS(1379),
    [sym_html_comment] = ACTIONS(5),
  },
  [450] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2683),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(450),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [sym_html_comment] = ACTIONS(5),
  },
  [451] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1513),
    [sym_expression] = STATE(2623),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6293),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1513),
    [sym_subscript_expression] = STATE(1513),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3245),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6295),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(451),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1513),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(455),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1565),
    [anon_sym_export] = ACTIONS(1379),
    [anon_sym_type] = ACTIONS(1379),
    [anon_sym_namespace] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1379),
    [anon_sym_let] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1385),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_of] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1389),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1391),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_using] = ACTIONS(1395),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_void] = ACTIONS(1401),
    [anon_sym_delete] = ACTIONS(1401),
    [anon_sym_PLUS_PLUS] = ACTIONS(1403),
    [anon_sym_DASH_DASH] = ACTIONS(1403),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1405),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1571),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1379),
    [anon_sym_readonly] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(1379),
    [anon_sym_set] = ACTIONS(1379),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_public] = ACTIONS(1379),
    [anon_sym_private] = ACTIONS(1379),
    [anon_sym_protected] = ACTIONS(1379),
    [anon_sym_override] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1379),
    [anon_sym_any] = ACTIONS(1379),
    [anon_sym_number] = ACTIONS(1379),
    [anon_sym_boolean] = ACTIONS(1379),
    [anon_sym_string] = ACTIONS(1379),
    [anon_sym_symbol] = ACTIONS(1379),
    [anon_sym_object] = ACTIONS(1379),
    [anon_sym_property] = ACTIONS(1379),
    [anon_sym_signal] = ACTIONS(1379),
    [anon_sym_on] = ACTIONS(1379),
    [anon_sym_required] = ACTIONS(1379),
    [anon_sym_component] = ACTIONS(1379),
    [sym_html_comment] = ACTIONS(5),
  },
  [452] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1791),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(452),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(2192),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [453] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1487),
    [sym_expression] = STATE(2326),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1487),
    [sym_subscript_expression] = STATE(1487),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3189),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6145),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(453),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1487),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1131),
    [anon_sym_namespace] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1159),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_let] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_of] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1149),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_using] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1159),
    [anon_sym_delete] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1167),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1131),
    [anon_sym_readonly] = ACTIONS(1131),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_declare] = ACTIONS(1131),
    [anon_sym_public] = ACTIONS(1131),
    [anon_sym_private] = ACTIONS(1131),
    [anon_sym_protected] = ACTIONS(1131),
    [anon_sym_override] = ACTIONS(1131),
    [anon_sym_module] = ACTIONS(1131),
    [anon_sym_any] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_boolean] = ACTIONS(1131),
    [anon_sym_string] = ACTIONS(1131),
    [anon_sym_symbol] = ACTIONS(1131),
    [anon_sym_object] = ACTIONS(1131),
    [anon_sym_property] = ACTIONS(1131),
    [anon_sym_signal] = ACTIONS(1131),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_required] = ACTIONS(1131),
    [anon_sym_component] = ACTIONS(1131),
    [sym_html_comment] = ACTIONS(5),
  },
  [454] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_expression] = STATE(2477),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5939),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(454),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1523),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1555),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_of] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_using] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_property] = ACTIONS(1181),
    [anon_sym_signal] = ACTIONS(1181),
    [anon_sym_on] = ACTIONS(1181),
    [anon_sym_required] = ACTIONS(1181),
    [anon_sym_component] = ACTIONS(1181),
    [sym_html_comment] = ACTIONS(5),
  },
  [455] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1513),
    [sym_expression] = STATE(2542),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6293),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1513),
    [sym_subscript_expression] = STATE(1513),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3245),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6295),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(455),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1513),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(455),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1565),
    [anon_sym_export] = ACTIONS(1379),
    [anon_sym_type] = ACTIONS(1379),
    [anon_sym_namespace] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1379),
    [anon_sym_let] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1385),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_of] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1389),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1391),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_using] = ACTIONS(1395),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_void] = ACTIONS(1401),
    [anon_sym_delete] = ACTIONS(1401),
    [anon_sym_PLUS_PLUS] = ACTIONS(1403),
    [anon_sym_DASH_DASH] = ACTIONS(1403),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1405),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1571),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1379),
    [anon_sym_readonly] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(1379),
    [anon_sym_set] = ACTIONS(1379),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_public] = ACTIONS(1379),
    [anon_sym_private] = ACTIONS(1379),
    [anon_sym_protected] = ACTIONS(1379),
    [anon_sym_override] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1379),
    [anon_sym_any] = ACTIONS(1379),
    [anon_sym_number] = ACTIONS(1379),
    [anon_sym_boolean] = ACTIONS(1379),
    [anon_sym_string] = ACTIONS(1379),
    [anon_sym_symbol] = ACTIONS(1379),
    [anon_sym_object] = ACTIONS(1379),
    [anon_sym_property] = ACTIONS(1379),
    [anon_sym_signal] = ACTIONS(1379),
    [anon_sym_on] = ACTIONS(1379),
    [anon_sym_required] = ACTIONS(1379),
    [anon_sym_component] = ACTIONS(1379),
    [sym_html_comment] = ACTIONS(5),
  },
  [456] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2682),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(456),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [sym_html_comment] = ACTIONS(5),
  },
  [457] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1918),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(457),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [458] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2681),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(458),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [sym_html_comment] = ACTIONS(5),
  },
  [459] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2678),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(459),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [sym_html_comment] = ACTIONS(5),
  },
  [460] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2676),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(460),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [sym_html_comment] = ACTIONS(5),
  },
  [461] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1513),
    [sym_expression] = STATE(2550),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6293),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1513),
    [sym_subscript_expression] = STATE(1513),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3245),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6295),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(461),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1513),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(455),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1565),
    [anon_sym_export] = ACTIONS(1379),
    [anon_sym_type] = ACTIONS(1379),
    [anon_sym_namespace] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1379),
    [anon_sym_let] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1385),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_of] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1389),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1391),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_using] = ACTIONS(1395),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_void] = ACTIONS(1401),
    [anon_sym_delete] = ACTIONS(1401),
    [anon_sym_PLUS_PLUS] = ACTIONS(1403),
    [anon_sym_DASH_DASH] = ACTIONS(1403),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1405),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1571),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1379),
    [anon_sym_readonly] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(1379),
    [anon_sym_set] = ACTIONS(1379),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_public] = ACTIONS(1379),
    [anon_sym_private] = ACTIONS(1379),
    [anon_sym_protected] = ACTIONS(1379),
    [anon_sym_override] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1379),
    [anon_sym_any] = ACTIONS(1379),
    [anon_sym_number] = ACTIONS(1379),
    [anon_sym_boolean] = ACTIONS(1379),
    [anon_sym_string] = ACTIONS(1379),
    [anon_sym_symbol] = ACTIONS(1379),
    [anon_sym_object] = ACTIONS(1379),
    [anon_sym_property] = ACTIONS(1379),
    [anon_sym_signal] = ACTIONS(1379),
    [anon_sym_on] = ACTIONS(1379),
    [anon_sym_required] = ACTIONS(1379),
    [anon_sym_component] = ACTIONS(1379),
    [sym_html_comment] = ACTIONS(5),
  },
  [462] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1513),
    [sym_expression] = STATE(2558),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6293),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1513),
    [sym_subscript_expression] = STATE(1513),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3245),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6295),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(462),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1513),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(455),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1565),
    [anon_sym_export] = ACTIONS(1379),
    [anon_sym_type] = ACTIONS(1379),
    [anon_sym_namespace] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1379),
    [anon_sym_let] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1385),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_of] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1389),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1391),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_using] = ACTIONS(1395),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_void] = ACTIONS(1401),
    [anon_sym_delete] = ACTIONS(1401),
    [anon_sym_PLUS_PLUS] = ACTIONS(1403),
    [anon_sym_DASH_DASH] = ACTIONS(1403),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1405),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1571),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1379),
    [anon_sym_readonly] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(1379),
    [anon_sym_set] = ACTIONS(1379),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_public] = ACTIONS(1379),
    [anon_sym_private] = ACTIONS(1379),
    [anon_sym_protected] = ACTIONS(1379),
    [anon_sym_override] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1379),
    [anon_sym_any] = ACTIONS(1379),
    [anon_sym_number] = ACTIONS(1379),
    [anon_sym_boolean] = ACTIONS(1379),
    [anon_sym_string] = ACTIONS(1379),
    [anon_sym_symbol] = ACTIONS(1379),
    [anon_sym_object] = ACTIONS(1379),
    [anon_sym_property] = ACTIONS(1379),
    [anon_sym_signal] = ACTIONS(1379),
    [anon_sym_on] = ACTIONS(1379),
    [anon_sym_required] = ACTIONS(1379),
    [anon_sym_component] = ACTIONS(1379),
    [sym_html_comment] = ACTIONS(5),
  },
  [463] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1891),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(463),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [464] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_expression] = STATE(2429),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5939),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(464),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1523),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1555),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_of] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_using] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(2208),
    [sym_private_property_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_property] = ACTIONS(1181),
    [anon_sym_signal] = ACTIONS(1181),
    [anon_sym_on] = ACTIONS(1181),
    [anon_sym_required] = ACTIONS(1181),
    [anon_sym_component] = ACTIONS(1181),
    [sym_html_comment] = ACTIONS(5),
  },
  [465] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1513),
    [sym_expression] = STATE(2598),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6293),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1513),
    [sym_subscript_expression] = STATE(1513),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3245),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6295),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(465),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1513),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(455),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1565),
    [anon_sym_export] = ACTIONS(1379),
    [anon_sym_type] = ACTIONS(1379),
    [anon_sym_namespace] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1379),
    [anon_sym_let] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1385),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_of] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1389),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1391),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_using] = ACTIONS(1395),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_void] = ACTIONS(1401),
    [anon_sym_delete] = ACTIONS(1401),
    [anon_sym_PLUS_PLUS] = ACTIONS(1403),
    [anon_sym_DASH_DASH] = ACTIONS(1403),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1405),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1571),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1379),
    [anon_sym_readonly] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(1379),
    [anon_sym_set] = ACTIONS(1379),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_public] = ACTIONS(1379),
    [anon_sym_private] = ACTIONS(1379),
    [anon_sym_protected] = ACTIONS(1379),
    [anon_sym_override] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1379),
    [anon_sym_any] = ACTIONS(1379),
    [anon_sym_number] = ACTIONS(1379),
    [anon_sym_boolean] = ACTIONS(1379),
    [anon_sym_string] = ACTIONS(1379),
    [anon_sym_symbol] = ACTIONS(1379),
    [anon_sym_object] = ACTIONS(1379),
    [anon_sym_property] = ACTIONS(1379),
    [anon_sym_signal] = ACTIONS(1379),
    [anon_sym_on] = ACTIONS(1379),
    [anon_sym_required] = ACTIONS(1379),
    [anon_sym_component] = ACTIONS(1379),
    [sym_html_comment] = ACTIONS(5),
  },
  [466] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1513),
    [sym_expression] = STATE(2551),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6293),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1513),
    [sym_subscript_expression] = STATE(1513),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3245),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6295),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(466),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1513),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(455),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1565),
    [anon_sym_export] = ACTIONS(1379),
    [anon_sym_type] = ACTIONS(1379),
    [anon_sym_namespace] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1379),
    [anon_sym_let] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1385),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_of] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1389),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1391),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_using] = ACTIONS(1395),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_void] = ACTIONS(1401),
    [anon_sym_delete] = ACTIONS(1401),
    [anon_sym_PLUS_PLUS] = ACTIONS(1403),
    [anon_sym_DASH_DASH] = ACTIONS(1403),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1405),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1571),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1379),
    [anon_sym_readonly] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(1379),
    [anon_sym_set] = ACTIONS(1379),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_public] = ACTIONS(1379),
    [anon_sym_private] = ACTIONS(1379),
    [anon_sym_protected] = ACTIONS(1379),
    [anon_sym_override] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1379),
    [anon_sym_any] = ACTIONS(1379),
    [anon_sym_number] = ACTIONS(1379),
    [anon_sym_boolean] = ACTIONS(1379),
    [anon_sym_string] = ACTIONS(1379),
    [anon_sym_symbol] = ACTIONS(1379),
    [anon_sym_object] = ACTIONS(1379),
    [anon_sym_property] = ACTIONS(1379),
    [anon_sym_signal] = ACTIONS(1379),
    [anon_sym_on] = ACTIONS(1379),
    [anon_sym_required] = ACTIONS(1379),
    [anon_sym_component] = ACTIONS(1379),
    [sym_html_comment] = ACTIONS(5),
  },
  [467] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1520),
    [sym_expression] = STATE(2583),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1520),
    [sym_subscript_expression] = STATE(1520),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6049),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(467),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1520),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(556),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1229),
    [anon_sym_namespace] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1229),
    [anon_sym_let] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_of] = ACTIONS(1229),
    [anon_sym_yield] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1551),
    [anon_sym_using] = ACTIONS(1247),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1257),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_readonly] = ACTIONS(1229),
    [anon_sym_get] = ACTIONS(1229),
    [anon_sym_set] = ACTIONS(1229),
    [anon_sym_declare] = ACTIONS(1229),
    [anon_sym_public] = ACTIONS(1229),
    [anon_sym_private] = ACTIONS(1229),
    [anon_sym_protected] = ACTIONS(1229),
    [anon_sym_override] = ACTIONS(1229),
    [anon_sym_module] = ACTIONS(1229),
    [anon_sym_any] = ACTIONS(1229),
    [anon_sym_number] = ACTIONS(1229),
    [anon_sym_boolean] = ACTIONS(1229),
    [anon_sym_string] = ACTIONS(1229),
    [anon_sym_symbol] = ACTIONS(1229),
    [anon_sym_object] = ACTIONS(1229),
    [anon_sym_property] = ACTIONS(1229),
    [anon_sym_signal] = ACTIONS(1229),
    [anon_sym_on] = ACTIONS(1229),
    [anon_sym_required] = ACTIONS(1229),
    [anon_sym_component] = ACTIONS(1229),
    [sym_html_comment] = ACTIONS(5),
  },
  [468] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1527),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1527),
    [sym_subscript_expression] = STATE(1527),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5950),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(468),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1527),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(2210),
    [anon_sym_export] = ACTIONS(2212),
    [anon_sym_type] = ACTIONS(2212),
    [anon_sym_namespace] = ACTIONS(2214),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(2212),
    [anon_sym_let] = ACTIONS(2212),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(2212),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(2216),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(2218),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(2220),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(2212),
    [anon_sym_readonly] = ACTIONS(2212),
    [anon_sym_get] = ACTIONS(2212),
    [anon_sym_set] = ACTIONS(2212),
    [anon_sym_declare] = ACTIONS(2212),
    [anon_sym_public] = ACTIONS(2212),
    [anon_sym_private] = ACTIONS(2212),
    [anon_sym_protected] = ACTIONS(2212),
    [anon_sym_override] = ACTIONS(2212),
    [anon_sym_module] = ACTIONS(2212),
    [anon_sym_any] = ACTIONS(2212),
    [anon_sym_number] = ACTIONS(2212),
    [anon_sym_boolean] = ACTIONS(2212),
    [anon_sym_string] = ACTIONS(2212),
    [anon_sym_symbol] = ACTIONS(2212),
    [anon_sym_object] = ACTIONS(2212),
    [anon_sym_property] = ACTIONS(2212),
    [anon_sym_signal] = ACTIONS(2212),
    [anon_sym_on] = ACTIONS(2212),
    [anon_sym_required] = ACTIONS(2212),
    [anon_sym_component] = ACTIONS(2212),
    [sym_html_comment] = ACTIONS(5),
  },
  [469] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1513),
    [sym_expression] = STATE(2441),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6293),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1513),
    [sym_subscript_expression] = STATE(1513),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3245),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6295),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(469),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1513),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(455),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1565),
    [anon_sym_export] = ACTIONS(1379),
    [anon_sym_type] = ACTIONS(1379),
    [anon_sym_namespace] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1379),
    [anon_sym_let] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1385),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_of] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1389),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1391),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_using] = ACTIONS(1395),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_void] = ACTIONS(1401),
    [anon_sym_delete] = ACTIONS(1401),
    [anon_sym_PLUS_PLUS] = ACTIONS(1403),
    [anon_sym_DASH_DASH] = ACTIONS(1403),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1405),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1571),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1379),
    [anon_sym_readonly] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(1379),
    [anon_sym_set] = ACTIONS(1379),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_public] = ACTIONS(1379),
    [anon_sym_private] = ACTIONS(1379),
    [anon_sym_protected] = ACTIONS(1379),
    [anon_sym_override] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1379),
    [anon_sym_any] = ACTIONS(1379),
    [anon_sym_number] = ACTIONS(1379),
    [anon_sym_boolean] = ACTIONS(1379),
    [anon_sym_string] = ACTIONS(1379),
    [anon_sym_symbol] = ACTIONS(1379),
    [anon_sym_object] = ACTIONS(1379),
    [anon_sym_property] = ACTIONS(1379),
    [anon_sym_signal] = ACTIONS(1379),
    [anon_sym_on] = ACTIONS(1379),
    [anon_sym_required] = ACTIONS(1379),
    [anon_sym_component] = ACTIONS(1379),
    [sym_html_comment] = ACTIONS(5),
  },
  [470] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1814),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(470),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [471] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2692),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(471),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [sym_html_comment] = ACTIONS(5),
  },
  [472] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1513),
    [sym_expression] = STATE(2464),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6293),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1513),
    [sym_subscript_expression] = STATE(1513),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3245),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6295),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(472),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1513),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(455),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1565),
    [anon_sym_export] = ACTIONS(1379),
    [anon_sym_type] = ACTIONS(1379),
    [anon_sym_namespace] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1379),
    [anon_sym_let] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1385),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_of] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1389),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1391),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_using] = ACTIONS(1395),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_void] = ACTIONS(1401),
    [anon_sym_delete] = ACTIONS(1401),
    [anon_sym_PLUS_PLUS] = ACTIONS(1403),
    [anon_sym_DASH_DASH] = ACTIONS(1403),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1405),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1571),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1379),
    [anon_sym_readonly] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(1379),
    [anon_sym_set] = ACTIONS(1379),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_public] = ACTIONS(1379),
    [anon_sym_private] = ACTIONS(1379),
    [anon_sym_protected] = ACTIONS(1379),
    [anon_sym_override] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1379),
    [anon_sym_any] = ACTIONS(1379),
    [anon_sym_number] = ACTIONS(1379),
    [anon_sym_boolean] = ACTIONS(1379),
    [anon_sym_string] = ACTIONS(1379),
    [anon_sym_symbol] = ACTIONS(1379),
    [anon_sym_object] = ACTIONS(1379),
    [anon_sym_property] = ACTIONS(1379),
    [anon_sym_signal] = ACTIONS(1379),
    [anon_sym_on] = ACTIONS(1379),
    [anon_sym_required] = ACTIONS(1379),
    [anon_sym_component] = ACTIONS(1379),
    [sym_html_comment] = ACTIONS(5),
  },
  [473] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1513),
    [sym_expression] = STATE(2636),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6293),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1513),
    [sym_subscript_expression] = STATE(1513),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3245),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6295),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(473),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1513),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(455),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1565),
    [anon_sym_export] = ACTIONS(1379),
    [anon_sym_type] = ACTIONS(1379),
    [anon_sym_namespace] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1379),
    [anon_sym_let] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1385),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_of] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1389),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1391),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_using] = ACTIONS(1395),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_void] = ACTIONS(1401),
    [anon_sym_delete] = ACTIONS(1401),
    [anon_sym_PLUS_PLUS] = ACTIONS(1403),
    [anon_sym_DASH_DASH] = ACTIONS(1403),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1405),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1571),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1379),
    [anon_sym_readonly] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(1379),
    [anon_sym_set] = ACTIONS(1379),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_public] = ACTIONS(1379),
    [anon_sym_private] = ACTIONS(1379),
    [anon_sym_protected] = ACTIONS(1379),
    [anon_sym_override] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1379),
    [anon_sym_any] = ACTIONS(1379),
    [anon_sym_number] = ACTIONS(1379),
    [anon_sym_boolean] = ACTIONS(1379),
    [anon_sym_string] = ACTIONS(1379),
    [anon_sym_symbol] = ACTIONS(1379),
    [anon_sym_object] = ACTIONS(1379),
    [anon_sym_property] = ACTIONS(1379),
    [anon_sym_signal] = ACTIONS(1379),
    [anon_sym_on] = ACTIONS(1379),
    [anon_sym_required] = ACTIONS(1379),
    [anon_sym_component] = ACTIONS(1379),
    [sym_html_comment] = ACTIONS(5),
  },
  [474] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1487),
    [sym_expression] = STATE(2249),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1487),
    [sym_subscript_expression] = STATE(1487),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3189),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6145),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(474),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1487),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1131),
    [anon_sym_namespace] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1159),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_let] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_of] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1149),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_using] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1159),
    [anon_sym_delete] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1167),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1131),
    [anon_sym_readonly] = ACTIONS(1131),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_declare] = ACTIONS(1131),
    [anon_sym_public] = ACTIONS(1131),
    [anon_sym_private] = ACTIONS(1131),
    [anon_sym_protected] = ACTIONS(1131),
    [anon_sym_override] = ACTIONS(1131),
    [anon_sym_module] = ACTIONS(1131),
    [anon_sym_any] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_boolean] = ACTIONS(1131),
    [anon_sym_string] = ACTIONS(1131),
    [anon_sym_symbol] = ACTIONS(1131),
    [anon_sym_object] = ACTIONS(1131),
    [anon_sym_property] = ACTIONS(1131),
    [anon_sym_signal] = ACTIONS(1131),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_required] = ACTIONS(1131),
    [anon_sym_component] = ACTIONS(1131),
    [sym_html_comment] = ACTIONS(5),
  },
  [475] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1487),
    [sym_expression] = STATE(2247),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1487),
    [sym_subscript_expression] = STATE(1487),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3189),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6145),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(475),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1487),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1131),
    [anon_sym_namespace] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1159),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_let] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_of] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1149),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_using] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1159),
    [anon_sym_delete] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1167),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1131),
    [anon_sym_readonly] = ACTIONS(1131),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_declare] = ACTIONS(1131),
    [anon_sym_public] = ACTIONS(1131),
    [anon_sym_private] = ACTIONS(1131),
    [anon_sym_protected] = ACTIONS(1131),
    [anon_sym_override] = ACTIONS(1131),
    [anon_sym_module] = ACTIONS(1131),
    [anon_sym_any] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_boolean] = ACTIONS(1131),
    [anon_sym_string] = ACTIONS(1131),
    [anon_sym_symbol] = ACTIONS(1131),
    [anon_sym_object] = ACTIONS(1131),
    [anon_sym_property] = ACTIONS(1131),
    [anon_sym_signal] = ACTIONS(1131),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_required] = ACTIONS(1131),
    [anon_sym_component] = ACTIONS(1131),
    [sym_html_comment] = ACTIONS(5),
  },
  [476] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2103),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(476),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [477] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_expression] = STATE(2428),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5939),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(477),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1523),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1555),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_of] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_using] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_property] = ACTIONS(1181),
    [anon_sym_signal] = ACTIONS(1181),
    [anon_sym_on] = ACTIONS(1181),
    [anon_sym_required] = ACTIONS(1181),
    [anon_sym_component] = ACTIONS(1181),
    [sym_html_comment] = ACTIONS(5),
  },
  [478] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1513),
    [sym_expression] = STATE(2655),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6293),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1513),
    [sym_subscript_expression] = STATE(1513),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3245),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6295),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(478),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1513),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(455),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1565),
    [anon_sym_export] = ACTIONS(1379),
    [anon_sym_type] = ACTIONS(1379),
    [anon_sym_namespace] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1379),
    [anon_sym_let] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1385),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_of] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1389),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1391),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_using] = ACTIONS(1395),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_void] = ACTIONS(1401),
    [anon_sym_delete] = ACTIONS(1401),
    [anon_sym_PLUS_PLUS] = ACTIONS(1403),
    [anon_sym_DASH_DASH] = ACTIONS(1403),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1405),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1571),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1379),
    [anon_sym_readonly] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(1379),
    [anon_sym_set] = ACTIONS(1379),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_public] = ACTIONS(1379),
    [anon_sym_private] = ACTIONS(1379),
    [anon_sym_protected] = ACTIONS(1379),
    [anon_sym_override] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1379),
    [anon_sym_any] = ACTIONS(1379),
    [anon_sym_number] = ACTIONS(1379),
    [anon_sym_boolean] = ACTIONS(1379),
    [anon_sym_string] = ACTIONS(1379),
    [anon_sym_symbol] = ACTIONS(1379),
    [anon_sym_object] = ACTIONS(1379),
    [anon_sym_property] = ACTIONS(1379),
    [anon_sym_signal] = ACTIONS(1379),
    [anon_sym_on] = ACTIONS(1379),
    [anon_sym_required] = ACTIONS(1379),
    [anon_sym_component] = ACTIONS(1379),
    [sym_html_comment] = ACTIONS(5),
  },
  [479] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1487),
    [sym_expression] = STATE(2334),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1487),
    [sym_subscript_expression] = STATE(1487),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3189),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6145),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(479),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1487),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1131),
    [anon_sym_namespace] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1159),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_let] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_of] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1149),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_using] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1159),
    [anon_sym_delete] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1167),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1131),
    [anon_sym_readonly] = ACTIONS(1131),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_declare] = ACTIONS(1131),
    [anon_sym_public] = ACTIONS(1131),
    [anon_sym_private] = ACTIONS(1131),
    [anon_sym_protected] = ACTIONS(1131),
    [anon_sym_override] = ACTIONS(1131),
    [anon_sym_module] = ACTIONS(1131),
    [anon_sym_any] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_boolean] = ACTIONS(1131),
    [anon_sym_string] = ACTIONS(1131),
    [anon_sym_symbol] = ACTIONS(1131),
    [anon_sym_object] = ACTIONS(1131),
    [anon_sym_property] = ACTIONS(1131),
    [anon_sym_signal] = ACTIONS(1131),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_required] = ACTIONS(1131),
    [anon_sym_component] = ACTIONS(1131),
    [sym_html_comment] = ACTIONS(5),
  },
  [480] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_expression] = STATE(2482),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5939),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(480),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1523),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1555),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_of] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_using] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_property] = ACTIONS(1181),
    [anon_sym_signal] = ACTIONS(1181),
    [anon_sym_on] = ACTIONS(1181),
    [anon_sym_required] = ACTIONS(1181),
    [anon_sym_component] = ACTIONS(1181),
    [sym_html_comment] = ACTIONS(5),
  },
  [481] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1531),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1531),
    [sym_subscript_expression] = STATE(1531),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6318),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(481),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1531),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(2222),
    [anon_sym_export] = ACTIONS(2224),
    [anon_sym_type] = ACTIONS(2224),
    [anon_sym_namespace] = ACTIONS(2226),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(2224),
    [anon_sym_let] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(2224),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(2228),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(2230),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(2232),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(2224),
    [anon_sym_readonly] = ACTIONS(2224),
    [anon_sym_get] = ACTIONS(2224),
    [anon_sym_set] = ACTIONS(2224),
    [anon_sym_declare] = ACTIONS(2224),
    [anon_sym_public] = ACTIONS(2224),
    [anon_sym_private] = ACTIONS(2224),
    [anon_sym_protected] = ACTIONS(2224),
    [anon_sym_override] = ACTIONS(2224),
    [anon_sym_module] = ACTIONS(2224),
    [anon_sym_any] = ACTIONS(2224),
    [anon_sym_number] = ACTIONS(2224),
    [anon_sym_boolean] = ACTIONS(2224),
    [anon_sym_string] = ACTIONS(2224),
    [anon_sym_symbol] = ACTIONS(2224),
    [anon_sym_object] = ACTIONS(2224),
    [anon_sym_property] = ACTIONS(2224),
    [anon_sym_signal] = ACTIONS(2224),
    [anon_sym_on] = ACTIONS(2224),
    [anon_sym_required] = ACTIONS(2224),
    [anon_sym_component] = ACTIONS(2224),
    [sym_html_comment] = ACTIONS(5),
  },
  [482] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_expression] = STATE(2453),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5939),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(482),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1523),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1555),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_of] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_using] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_property] = ACTIONS(1181),
    [anon_sym_signal] = ACTIONS(1181),
    [anon_sym_on] = ACTIONS(1181),
    [anon_sym_required] = ACTIONS(1181),
    [anon_sym_component] = ACTIONS(1181),
    [sym_html_comment] = ACTIONS(5),
  },
  [483] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1513),
    [sym_expression] = STATE(2465),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6293),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1513),
    [sym_subscript_expression] = STATE(1513),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3245),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6295),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(483),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1513),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(455),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1565),
    [anon_sym_export] = ACTIONS(1379),
    [anon_sym_type] = ACTIONS(1379),
    [anon_sym_namespace] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1379),
    [anon_sym_let] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1385),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_of] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1389),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1391),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_using] = ACTIONS(1395),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_void] = ACTIONS(1401),
    [anon_sym_delete] = ACTIONS(1401),
    [anon_sym_PLUS_PLUS] = ACTIONS(1403),
    [anon_sym_DASH_DASH] = ACTIONS(1403),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1405),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1571),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1379),
    [anon_sym_readonly] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(1379),
    [anon_sym_set] = ACTIONS(1379),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_public] = ACTIONS(1379),
    [anon_sym_private] = ACTIONS(1379),
    [anon_sym_protected] = ACTIONS(1379),
    [anon_sym_override] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1379),
    [anon_sym_any] = ACTIONS(1379),
    [anon_sym_number] = ACTIONS(1379),
    [anon_sym_boolean] = ACTIONS(1379),
    [anon_sym_string] = ACTIONS(1379),
    [anon_sym_symbol] = ACTIONS(1379),
    [anon_sym_object] = ACTIONS(1379),
    [anon_sym_property] = ACTIONS(1379),
    [anon_sym_signal] = ACTIONS(1379),
    [anon_sym_on] = ACTIONS(1379),
    [anon_sym_required] = ACTIONS(1379),
    [anon_sym_component] = ACTIONS(1379),
    [sym_html_comment] = ACTIONS(5),
  },
  [484] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2728),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(484),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(2206),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [sym_html_comment] = ACTIONS(5),
  },
  [485] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2302),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(485),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [486] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2714),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(486),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [sym_html_comment] = ACTIONS(5),
  },
  [487] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1791),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(487),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [488] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1513),
    [sym_expression] = STATE(2634),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6293),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1513),
    [sym_subscript_expression] = STATE(1513),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3245),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6295),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(488),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1513),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(455),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1565),
    [anon_sym_export] = ACTIONS(1379),
    [anon_sym_type] = ACTIONS(1379),
    [anon_sym_namespace] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1379),
    [anon_sym_let] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1385),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_of] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1389),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1391),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_using] = ACTIONS(1395),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_void] = ACTIONS(1401),
    [anon_sym_delete] = ACTIONS(1401),
    [anon_sym_PLUS_PLUS] = ACTIONS(1403),
    [anon_sym_DASH_DASH] = ACTIONS(1403),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1405),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1571),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1379),
    [anon_sym_readonly] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(1379),
    [anon_sym_set] = ACTIONS(1379),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_public] = ACTIONS(1379),
    [anon_sym_private] = ACTIONS(1379),
    [anon_sym_protected] = ACTIONS(1379),
    [anon_sym_override] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1379),
    [anon_sym_any] = ACTIONS(1379),
    [anon_sym_number] = ACTIONS(1379),
    [anon_sym_boolean] = ACTIONS(1379),
    [anon_sym_string] = ACTIONS(1379),
    [anon_sym_symbol] = ACTIONS(1379),
    [anon_sym_object] = ACTIONS(1379),
    [anon_sym_property] = ACTIONS(1379),
    [anon_sym_signal] = ACTIONS(1379),
    [anon_sym_on] = ACTIONS(1379),
    [anon_sym_required] = ACTIONS(1379),
    [anon_sym_component] = ACTIONS(1379),
    [sym_html_comment] = ACTIONS(5),
  },
  [489] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2696),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(489),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [sym_html_comment] = ACTIONS(5),
  },
  [490] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1902),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(490),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [491] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1487),
    [sym_expression] = STATE(2342),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1487),
    [sym_subscript_expression] = STATE(1487),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3189),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6145),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(491),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1487),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1131),
    [anon_sym_namespace] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1159),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_let] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_of] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1149),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_using] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1159),
    [anon_sym_delete] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1167),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1131),
    [anon_sym_readonly] = ACTIONS(1131),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_declare] = ACTIONS(1131),
    [anon_sym_public] = ACTIONS(1131),
    [anon_sym_private] = ACTIONS(1131),
    [anon_sym_protected] = ACTIONS(1131),
    [anon_sym_override] = ACTIONS(1131),
    [anon_sym_module] = ACTIONS(1131),
    [anon_sym_any] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_boolean] = ACTIONS(1131),
    [anon_sym_string] = ACTIONS(1131),
    [anon_sym_symbol] = ACTIONS(1131),
    [anon_sym_object] = ACTIONS(1131),
    [anon_sym_property] = ACTIONS(1131),
    [anon_sym_signal] = ACTIONS(1131),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_required] = ACTIONS(1131),
    [anon_sym_component] = ACTIONS(1131),
    [sym_html_comment] = ACTIONS(5),
  },
  [492] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2079),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(492),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [493] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_expression] = STATE(2541),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5939),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(493),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1523),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1555),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_of] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_using] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_property] = ACTIONS(1181),
    [anon_sym_signal] = ACTIONS(1181),
    [anon_sym_on] = ACTIONS(1181),
    [anon_sym_required] = ACTIONS(1181),
    [anon_sym_component] = ACTIONS(1181),
    [sym_html_comment] = ACTIONS(5),
  },
  [494] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1513),
    [sym_expression] = STATE(2484),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6293),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1513),
    [sym_subscript_expression] = STATE(1513),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3245),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6295),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(494),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1513),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(455),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1565),
    [anon_sym_export] = ACTIONS(1379),
    [anon_sym_type] = ACTIONS(1379),
    [anon_sym_namespace] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1379),
    [anon_sym_let] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1385),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_of] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1389),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1391),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_using] = ACTIONS(1395),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_void] = ACTIONS(1401),
    [anon_sym_delete] = ACTIONS(1401),
    [anon_sym_PLUS_PLUS] = ACTIONS(1403),
    [anon_sym_DASH_DASH] = ACTIONS(1403),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1405),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1571),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1379),
    [anon_sym_readonly] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(1379),
    [anon_sym_set] = ACTIONS(1379),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_public] = ACTIONS(1379),
    [anon_sym_private] = ACTIONS(1379),
    [anon_sym_protected] = ACTIONS(1379),
    [anon_sym_override] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1379),
    [anon_sym_any] = ACTIONS(1379),
    [anon_sym_number] = ACTIONS(1379),
    [anon_sym_boolean] = ACTIONS(1379),
    [anon_sym_string] = ACTIONS(1379),
    [anon_sym_symbol] = ACTIONS(1379),
    [anon_sym_object] = ACTIONS(1379),
    [anon_sym_property] = ACTIONS(1379),
    [anon_sym_signal] = ACTIONS(1379),
    [anon_sym_on] = ACTIONS(1379),
    [anon_sym_required] = ACTIONS(1379),
    [anon_sym_component] = ACTIONS(1379),
    [sym_html_comment] = ACTIONS(5),
  },
  [495] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1520),
    [sym_expression] = STATE(2644),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1520),
    [sym_subscript_expression] = STATE(1520),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6049),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(495),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1520),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(556),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1229),
    [anon_sym_namespace] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1229),
    [anon_sym_let] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_of] = ACTIONS(1229),
    [anon_sym_yield] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1551),
    [anon_sym_using] = ACTIONS(1247),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1257),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_readonly] = ACTIONS(1229),
    [anon_sym_get] = ACTIONS(1229),
    [anon_sym_set] = ACTIONS(1229),
    [anon_sym_declare] = ACTIONS(1229),
    [anon_sym_public] = ACTIONS(1229),
    [anon_sym_private] = ACTIONS(1229),
    [anon_sym_protected] = ACTIONS(1229),
    [anon_sym_override] = ACTIONS(1229),
    [anon_sym_module] = ACTIONS(1229),
    [anon_sym_any] = ACTIONS(1229),
    [anon_sym_number] = ACTIONS(1229),
    [anon_sym_boolean] = ACTIONS(1229),
    [anon_sym_string] = ACTIONS(1229),
    [anon_sym_symbol] = ACTIONS(1229),
    [anon_sym_object] = ACTIONS(1229),
    [anon_sym_property] = ACTIONS(1229),
    [anon_sym_signal] = ACTIONS(1229),
    [anon_sym_on] = ACTIONS(1229),
    [anon_sym_required] = ACTIONS(1229),
    [anon_sym_component] = ACTIONS(1229),
    [sym_html_comment] = ACTIONS(5),
  },
  [496] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1513),
    [sym_expression] = STATE(2646),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6293),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1513),
    [sym_subscript_expression] = STATE(1513),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3245),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6295),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(496),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1513),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(455),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1565),
    [anon_sym_export] = ACTIONS(1379),
    [anon_sym_type] = ACTIONS(1379),
    [anon_sym_namespace] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1379),
    [anon_sym_let] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1385),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_of] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1389),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1391),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_using] = ACTIONS(1395),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_void] = ACTIONS(1401),
    [anon_sym_delete] = ACTIONS(1401),
    [anon_sym_PLUS_PLUS] = ACTIONS(1403),
    [anon_sym_DASH_DASH] = ACTIONS(1403),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1405),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1571),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1379),
    [anon_sym_readonly] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(1379),
    [anon_sym_set] = ACTIONS(1379),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_public] = ACTIONS(1379),
    [anon_sym_private] = ACTIONS(1379),
    [anon_sym_protected] = ACTIONS(1379),
    [anon_sym_override] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1379),
    [anon_sym_any] = ACTIONS(1379),
    [anon_sym_number] = ACTIONS(1379),
    [anon_sym_boolean] = ACTIONS(1379),
    [anon_sym_string] = ACTIONS(1379),
    [anon_sym_symbol] = ACTIONS(1379),
    [anon_sym_object] = ACTIONS(1379),
    [anon_sym_property] = ACTIONS(1379),
    [anon_sym_signal] = ACTIONS(1379),
    [anon_sym_on] = ACTIONS(1379),
    [anon_sym_required] = ACTIONS(1379),
    [anon_sym_component] = ACTIONS(1379),
    [sym_html_comment] = ACTIONS(5),
  },
  [497] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1473),
    [sym_expression] = STATE(2169),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6272),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1473),
    [sym_subscript_expression] = STATE(1473),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3246),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6274),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(497),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1473),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(541),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_export] = ACTIONS(1415),
    [anon_sym_type] = ACTIONS(1415),
    [anon_sym_namespace] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1437),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1415),
    [anon_sym_let] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1421),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1423),
    [anon_sym_of] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1425),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1427),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1543),
    [anon_sym_using] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1421),
    [anon_sym_void] = ACTIONS(1437),
    [anon_sym_delete] = ACTIONS(1437),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1441),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1415),
    [anon_sym_readonly] = ACTIONS(1415),
    [anon_sym_get] = ACTIONS(1415),
    [anon_sym_set] = ACTIONS(1415),
    [anon_sym_declare] = ACTIONS(1415),
    [anon_sym_public] = ACTIONS(1415),
    [anon_sym_private] = ACTIONS(1415),
    [anon_sym_protected] = ACTIONS(1415),
    [anon_sym_override] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_any] = ACTIONS(1415),
    [anon_sym_number] = ACTIONS(1415),
    [anon_sym_boolean] = ACTIONS(1415),
    [anon_sym_string] = ACTIONS(1415),
    [anon_sym_symbol] = ACTIONS(1415),
    [anon_sym_object] = ACTIONS(1415),
    [anon_sym_property] = ACTIONS(1415),
    [anon_sym_signal] = ACTIONS(1415),
    [anon_sym_on] = ACTIONS(1415),
    [anon_sym_required] = ACTIONS(1415),
    [anon_sym_component] = ACTIONS(1415),
    [sym_html_comment] = ACTIONS(5),
  },
  [498] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2725),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(498),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [sym_html_comment] = ACTIONS(5),
  },
  [499] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_expression] = STATE(2438),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5939),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(499),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1523),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1555),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_of] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_using] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_property] = ACTIONS(1181),
    [anon_sym_signal] = ACTIONS(1181),
    [anon_sym_on] = ACTIONS(1181),
    [anon_sym_required] = ACTIONS(1181),
    [anon_sym_component] = ACTIONS(1181),
    [sym_html_comment] = ACTIONS(5),
  },
  [500] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1911),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(500),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [501] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_expression] = STATE(2529),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5939),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(501),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1523),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1555),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_of] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_using] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_property] = ACTIONS(1181),
    [anon_sym_signal] = ACTIONS(1181),
    [anon_sym_on] = ACTIONS(1181),
    [anon_sym_required] = ACTIONS(1181),
    [anon_sym_component] = ACTIONS(1181),
    [sym_html_comment] = ACTIONS(5),
  },
  [502] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1528),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1528),
    [sym_subscript_expression] = STATE(1528),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6163),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(502),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1528),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(2234),
    [anon_sym_export] = ACTIONS(2236),
    [anon_sym_type] = ACTIONS(2236),
    [anon_sym_namespace] = ACTIONS(2238),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(2236),
    [anon_sym_let] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(2236),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(2240),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(2242),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(2244),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(2236),
    [anon_sym_readonly] = ACTIONS(2236),
    [anon_sym_get] = ACTIONS(2236),
    [anon_sym_set] = ACTIONS(2236),
    [anon_sym_declare] = ACTIONS(2236),
    [anon_sym_public] = ACTIONS(2236),
    [anon_sym_private] = ACTIONS(2236),
    [anon_sym_protected] = ACTIONS(2236),
    [anon_sym_override] = ACTIONS(2236),
    [anon_sym_module] = ACTIONS(2236),
    [anon_sym_any] = ACTIONS(2236),
    [anon_sym_number] = ACTIONS(2236),
    [anon_sym_boolean] = ACTIONS(2236),
    [anon_sym_string] = ACTIONS(2236),
    [anon_sym_symbol] = ACTIONS(2236),
    [anon_sym_object] = ACTIONS(2236),
    [anon_sym_property] = ACTIONS(2236),
    [anon_sym_signal] = ACTIONS(2236),
    [anon_sym_on] = ACTIONS(2236),
    [anon_sym_required] = ACTIONS(2236),
    [anon_sym_component] = ACTIONS(2236),
    [sym_html_comment] = ACTIONS(5),
  },
  [503] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_expression] = STATE(2459),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5939),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(503),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1523),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1555),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_of] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_using] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_property] = ACTIONS(1181),
    [anon_sym_signal] = ACTIONS(1181),
    [anon_sym_on] = ACTIONS(1181),
    [anon_sym_required] = ACTIONS(1181),
    [anon_sym_component] = ACTIONS(1181),
    [sym_html_comment] = ACTIONS(5),
  },
  [504] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2728),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(504),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [sym_html_comment] = ACTIONS(5),
  },
  [505] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1520),
    [sym_expression] = STATE(2643),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1520),
    [sym_subscript_expression] = STATE(1520),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6049),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(505),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1520),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(556),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1229),
    [anon_sym_namespace] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1229),
    [anon_sym_let] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_of] = ACTIONS(1229),
    [anon_sym_yield] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1551),
    [anon_sym_using] = ACTIONS(1247),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1257),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_readonly] = ACTIONS(1229),
    [anon_sym_get] = ACTIONS(1229),
    [anon_sym_set] = ACTIONS(1229),
    [anon_sym_declare] = ACTIONS(1229),
    [anon_sym_public] = ACTIONS(1229),
    [anon_sym_private] = ACTIONS(1229),
    [anon_sym_protected] = ACTIONS(1229),
    [anon_sym_override] = ACTIONS(1229),
    [anon_sym_module] = ACTIONS(1229),
    [anon_sym_any] = ACTIONS(1229),
    [anon_sym_number] = ACTIONS(1229),
    [anon_sym_boolean] = ACTIONS(1229),
    [anon_sym_string] = ACTIONS(1229),
    [anon_sym_symbol] = ACTIONS(1229),
    [anon_sym_object] = ACTIONS(1229),
    [anon_sym_property] = ACTIONS(1229),
    [anon_sym_signal] = ACTIONS(1229),
    [anon_sym_on] = ACTIONS(1229),
    [anon_sym_required] = ACTIONS(1229),
    [anon_sym_component] = ACTIONS(1229),
    [sym_html_comment] = ACTIONS(5),
  },
  [506] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2721),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(506),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [sym_html_comment] = ACTIONS(5),
  },
  [507] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1473),
    [sym_expression] = STATE(2110),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6272),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1473),
    [sym_subscript_expression] = STATE(1473),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3246),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6274),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(507),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1473),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(541),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_export] = ACTIONS(1415),
    [anon_sym_type] = ACTIONS(1415),
    [anon_sym_namespace] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1437),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1415),
    [anon_sym_let] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1421),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1423),
    [anon_sym_of] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1425),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1427),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1543),
    [anon_sym_using] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1421),
    [anon_sym_void] = ACTIONS(1437),
    [anon_sym_delete] = ACTIONS(1437),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1441),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1415),
    [anon_sym_readonly] = ACTIONS(1415),
    [anon_sym_get] = ACTIONS(1415),
    [anon_sym_set] = ACTIONS(1415),
    [anon_sym_declare] = ACTIONS(1415),
    [anon_sym_public] = ACTIONS(1415),
    [anon_sym_private] = ACTIONS(1415),
    [anon_sym_protected] = ACTIONS(1415),
    [anon_sym_override] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_any] = ACTIONS(1415),
    [anon_sym_number] = ACTIONS(1415),
    [anon_sym_boolean] = ACTIONS(1415),
    [anon_sym_string] = ACTIONS(1415),
    [anon_sym_symbol] = ACTIONS(1415),
    [anon_sym_object] = ACTIONS(1415),
    [anon_sym_property] = ACTIONS(1415),
    [anon_sym_signal] = ACTIONS(1415),
    [anon_sym_on] = ACTIONS(1415),
    [anon_sym_required] = ACTIONS(1415),
    [anon_sym_component] = ACTIONS(1415),
    [sym_html_comment] = ACTIONS(5),
  },
  [508] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_expression] = STATE(2528),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5939),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(508),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1523),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1555),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_of] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_using] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_property] = ACTIONS(1181),
    [anon_sym_signal] = ACTIONS(1181),
    [anon_sym_on] = ACTIONS(1181),
    [anon_sym_required] = ACTIONS(1181),
    [anon_sym_component] = ACTIONS(1181),
    [sym_html_comment] = ACTIONS(5),
  },
  [509] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_expression] = STATE(2460),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5939),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(509),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1523),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1555),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_of] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_using] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_property] = ACTIONS(1181),
    [anon_sym_signal] = ACTIONS(1181),
    [anon_sym_on] = ACTIONS(1181),
    [anon_sym_required] = ACTIONS(1181),
    [anon_sym_component] = ACTIONS(1181),
    [sym_html_comment] = ACTIONS(5),
  },
  [510] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2058),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(510),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [511] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_expression] = STATE(2086),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6164),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3271),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6167),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(511),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1451),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(522),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_export] = ACTIONS(1327),
    [anon_sym_type] = ACTIONS(1327),
    [anon_sym_namespace] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1349),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_let] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1333),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_of] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1527),
    [anon_sym_using] = ACTIONS(1343),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_SLASH] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_void] = ACTIONS(1349),
    [anon_sym_delete] = ACTIONS(1349),
    [anon_sym_PLUS_PLUS] = ACTIONS(1351),
    [anon_sym_DASH_DASH] = ACTIONS(1351),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1353),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1327),
    [anon_sym_readonly] = ACTIONS(1327),
    [anon_sym_get] = ACTIONS(1327),
    [anon_sym_set] = ACTIONS(1327),
    [anon_sym_declare] = ACTIONS(1327),
    [anon_sym_public] = ACTIONS(1327),
    [anon_sym_private] = ACTIONS(1327),
    [anon_sym_protected] = ACTIONS(1327),
    [anon_sym_override] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_any] = ACTIONS(1327),
    [anon_sym_number] = ACTIONS(1327),
    [anon_sym_boolean] = ACTIONS(1327),
    [anon_sym_string] = ACTIONS(1327),
    [anon_sym_symbol] = ACTIONS(1327),
    [anon_sym_object] = ACTIONS(1327),
    [anon_sym_property] = ACTIONS(1327),
    [anon_sym_signal] = ACTIONS(1327),
    [anon_sym_on] = ACTIONS(1327),
    [anon_sym_required] = ACTIONS(1327),
    [anon_sym_component] = ACTIONS(1327),
    [sym_html_comment] = ACTIONS(5),
  },
  [512] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1520),
    [sym_expression] = STATE(2511),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1520),
    [sym_subscript_expression] = STATE(1520),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6049),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(512),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1520),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(556),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1229),
    [anon_sym_namespace] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1229),
    [anon_sym_let] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_of] = ACTIONS(1229),
    [anon_sym_yield] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1551),
    [anon_sym_using] = ACTIONS(1247),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1257),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_readonly] = ACTIONS(1229),
    [anon_sym_get] = ACTIONS(1229),
    [anon_sym_set] = ACTIONS(1229),
    [anon_sym_declare] = ACTIONS(1229),
    [anon_sym_public] = ACTIONS(1229),
    [anon_sym_private] = ACTIONS(1229),
    [anon_sym_protected] = ACTIONS(1229),
    [anon_sym_override] = ACTIONS(1229),
    [anon_sym_module] = ACTIONS(1229),
    [anon_sym_any] = ACTIONS(1229),
    [anon_sym_number] = ACTIONS(1229),
    [anon_sym_boolean] = ACTIONS(1229),
    [anon_sym_string] = ACTIONS(1229),
    [anon_sym_symbol] = ACTIONS(1229),
    [anon_sym_object] = ACTIONS(1229),
    [anon_sym_property] = ACTIONS(1229),
    [anon_sym_signal] = ACTIONS(1229),
    [anon_sym_on] = ACTIONS(1229),
    [anon_sym_required] = ACTIONS(1229),
    [anon_sym_component] = ACTIONS(1229),
    [sym_html_comment] = ACTIONS(5),
  },
  [513] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1513),
    [sym_expression] = STATE(2486),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6293),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1513),
    [sym_subscript_expression] = STATE(1513),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3245),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6295),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(513),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1513),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(455),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1565),
    [anon_sym_export] = ACTIONS(1379),
    [anon_sym_type] = ACTIONS(1379),
    [anon_sym_namespace] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1379),
    [anon_sym_let] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1385),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_of] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1389),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1391),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_using] = ACTIONS(1395),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_void] = ACTIONS(1401),
    [anon_sym_delete] = ACTIONS(1401),
    [anon_sym_PLUS_PLUS] = ACTIONS(1403),
    [anon_sym_DASH_DASH] = ACTIONS(1403),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1405),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1571),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1379),
    [anon_sym_readonly] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(1379),
    [anon_sym_set] = ACTIONS(1379),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_public] = ACTIONS(1379),
    [anon_sym_private] = ACTIONS(1379),
    [anon_sym_protected] = ACTIONS(1379),
    [anon_sym_override] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1379),
    [anon_sym_any] = ACTIONS(1379),
    [anon_sym_number] = ACTIONS(1379),
    [anon_sym_boolean] = ACTIONS(1379),
    [anon_sym_string] = ACTIONS(1379),
    [anon_sym_symbol] = ACTIONS(1379),
    [anon_sym_object] = ACTIONS(1379),
    [anon_sym_property] = ACTIONS(1379),
    [anon_sym_signal] = ACTIONS(1379),
    [anon_sym_on] = ACTIONS(1379),
    [anon_sym_required] = ACTIONS(1379),
    [anon_sym_component] = ACTIONS(1379),
    [sym_html_comment] = ACTIONS(5),
  },
  [514] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2728),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(514),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(2208),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [sym_html_comment] = ACTIONS(5),
  },
  [515] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1520),
    [sym_expression] = STATE(2630),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1520),
    [sym_subscript_expression] = STATE(1520),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6049),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(515),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1520),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(556),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1229),
    [anon_sym_namespace] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1229),
    [anon_sym_let] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_of] = ACTIONS(1229),
    [anon_sym_yield] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1551),
    [anon_sym_using] = ACTIONS(1247),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1257),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_readonly] = ACTIONS(1229),
    [anon_sym_get] = ACTIONS(1229),
    [anon_sym_set] = ACTIONS(1229),
    [anon_sym_declare] = ACTIONS(1229),
    [anon_sym_public] = ACTIONS(1229),
    [anon_sym_private] = ACTIONS(1229),
    [anon_sym_protected] = ACTIONS(1229),
    [anon_sym_override] = ACTIONS(1229),
    [anon_sym_module] = ACTIONS(1229),
    [anon_sym_any] = ACTIONS(1229),
    [anon_sym_number] = ACTIONS(1229),
    [anon_sym_boolean] = ACTIONS(1229),
    [anon_sym_string] = ACTIONS(1229),
    [anon_sym_symbol] = ACTIONS(1229),
    [anon_sym_object] = ACTIONS(1229),
    [anon_sym_property] = ACTIONS(1229),
    [anon_sym_signal] = ACTIONS(1229),
    [anon_sym_on] = ACTIONS(1229),
    [anon_sym_required] = ACTIONS(1229),
    [anon_sym_component] = ACTIONS(1229),
    [sym_html_comment] = ACTIONS(5),
  },
  [516] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1520),
    [sym_expression] = STATE(2505),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1520),
    [sym_subscript_expression] = STATE(1520),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6049),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(516),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1520),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(556),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1229),
    [anon_sym_namespace] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1229),
    [anon_sym_let] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_of] = ACTIONS(1229),
    [anon_sym_yield] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1551),
    [anon_sym_using] = ACTIONS(1247),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1257),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_readonly] = ACTIONS(1229),
    [anon_sym_get] = ACTIONS(1229),
    [anon_sym_set] = ACTIONS(1229),
    [anon_sym_declare] = ACTIONS(1229),
    [anon_sym_public] = ACTIONS(1229),
    [anon_sym_private] = ACTIONS(1229),
    [anon_sym_protected] = ACTIONS(1229),
    [anon_sym_override] = ACTIONS(1229),
    [anon_sym_module] = ACTIONS(1229),
    [anon_sym_any] = ACTIONS(1229),
    [anon_sym_number] = ACTIONS(1229),
    [anon_sym_boolean] = ACTIONS(1229),
    [anon_sym_string] = ACTIONS(1229),
    [anon_sym_symbol] = ACTIONS(1229),
    [anon_sym_object] = ACTIONS(1229),
    [anon_sym_property] = ACTIONS(1229),
    [anon_sym_signal] = ACTIONS(1229),
    [anon_sym_on] = ACTIONS(1229),
    [anon_sym_required] = ACTIONS(1229),
    [anon_sym_component] = ACTIONS(1229),
    [sym_html_comment] = ACTIONS(5),
  },
  [517] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2068),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(517),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [518] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1520),
    [sym_expression] = STATE(2595),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1520),
    [sym_subscript_expression] = STATE(1520),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6049),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(518),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1520),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(556),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1229),
    [anon_sym_namespace] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1229),
    [anon_sym_let] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_of] = ACTIONS(1229),
    [anon_sym_yield] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1551),
    [anon_sym_using] = ACTIONS(1247),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1257),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_readonly] = ACTIONS(1229),
    [anon_sym_get] = ACTIONS(1229),
    [anon_sym_set] = ACTIONS(1229),
    [anon_sym_declare] = ACTIONS(1229),
    [anon_sym_public] = ACTIONS(1229),
    [anon_sym_private] = ACTIONS(1229),
    [anon_sym_protected] = ACTIONS(1229),
    [anon_sym_override] = ACTIONS(1229),
    [anon_sym_module] = ACTIONS(1229),
    [anon_sym_any] = ACTIONS(1229),
    [anon_sym_number] = ACTIONS(1229),
    [anon_sym_boolean] = ACTIONS(1229),
    [anon_sym_string] = ACTIONS(1229),
    [anon_sym_symbol] = ACTIONS(1229),
    [anon_sym_object] = ACTIONS(1229),
    [anon_sym_property] = ACTIONS(1229),
    [anon_sym_signal] = ACTIONS(1229),
    [anon_sym_on] = ACTIONS(1229),
    [anon_sym_required] = ACTIONS(1229),
    [anon_sym_component] = ACTIONS(1229),
    [sym_html_comment] = ACTIONS(5),
  },
  [519] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_expression] = STATE(1986),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6164),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3271),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6167),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(519),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1451),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(522),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_export] = ACTIONS(1327),
    [anon_sym_type] = ACTIONS(1327),
    [anon_sym_namespace] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1349),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_let] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1333),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_of] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1527),
    [anon_sym_using] = ACTIONS(1343),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_SLASH] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_void] = ACTIONS(1349),
    [anon_sym_delete] = ACTIONS(1349),
    [anon_sym_PLUS_PLUS] = ACTIONS(1351),
    [anon_sym_DASH_DASH] = ACTIONS(1351),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1353),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1327),
    [anon_sym_readonly] = ACTIONS(1327),
    [anon_sym_get] = ACTIONS(1327),
    [anon_sym_set] = ACTIONS(1327),
    [anon_sym_declare] = ACTIONS(1327),
    [anon_sym_public] = ACTIONS(1327),
    [anon_sym_private] = ACTIONS(1327),
    [anon_sym_protected] = ACTIONS(1327),
    [anon_sym_override] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_any] = ACTIONS(1327),
    [anon_sym_number] = ACTIONS(1327),
    [anon_sym_boolean] = ACTIONS(1327),
    [anon_sym_string] = ACTIONS(1327),
    [anon_sym_symbol] = ACTIONS(1327),
    [anon_sym_object] = ACTIONS(1327),
    [anon_sym_property] = ACTIONS(1327),
    [anon_sym_signal] = ACTIONS(1327),
    [anon_sym_on] = ACTIONS(1327),
    [anon_sym_required] = ACTIONS(1327),
    [anon_sym_component] = ACTIONS(1327),
    [sym_html_comment] = ACTIONS(5),
  },
  [520] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1473),
    [sym_expression] = STATE(2101),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6272),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1473),
    [sym_subscript_expression] = STATE(1473),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3246),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6274),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(520),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1473),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(541),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_export] = ACTIONS(1415),
    [anon_sym_type] = ACTIONS(1415),
    [anon_sym_namespace] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1437),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1415),
    [anon_sym_let] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1421),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1423),
    [anon_sym_of] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1425),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1427),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1543),
    [anon_sym_using] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1421),
    [anon_sym_void] = ACTIONS(1437),
    [anon_sym_delete] = ACTIONS(1437),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1441),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1415),
    [anon_sym_readonly] = ACTIONS(1415),
    [anon_sym_get] = ACTIONS(1415),
    [anon_sym_set] = ACTIONS(1415),
    [anon_sym_declare] = ACTIONS(1415),
    [anon_sym_public] = ACTIONS(1415),
    [anon_sym_private] = ACTIONS(1415),
    [anon_sym_protected] = ACTIONS(1415),
    [anon_sym_override] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_any] = ACTIONS(1415),
    [anon_sym_number] = ACTIONS(1415),
    [anon_sym_boolean] = ACTIONS(1415),
    [anon_sym_string] = ACTIONS(1415),
    [anon_sym_symbol] = ACTIONS(1415),
    [anon_sym_object] = ACTIONS(1415),
    [anon_sym_property] = ACTIONS(1415),
    [anon_sym_signal] = ACTIONS(1415),
    [anon_sym_on] = ACTIONS(1415),
    [anon_sym_required] = ACTIONS(1415),
    [anon_sym_component] = ACTIONS(1415),
    [sym_html_comment] = ACTIONS(5),
  },
  [521] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1520),
    [sym_expression] = STATE(2618),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1520),
    [sym_subscript_expression] = STATE(1520),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6049),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(521),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1520),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(556),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1229),
    [anon_sym_namespace] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1229),
    [anon_sym_let] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_of] = ACTIONS(1229),
    [anon_sym_yield] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1551),
    [anon_sym_using] = ACTIONS(1247),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(2208),
    [sym_private_property_identifier] = ACTIONS(1257),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_readonly] = ACTIONS(1229),
    [anon_sym_get] = ACTIONS(1229),
    [anon_sym_set] = ACTIONS(1229),
    [anon_sym_declare] = ACTIONS(1229),
    [anon_sym_public] = ACTIONS(1229),
    [anon_sym_private] = ACTIONS(1229),
    [anon_sym_protected] = ACTIONS(1229),
    [anon_sym_override] = ACTIONS(1229),
    [anon_sym_module] = ACTIONS(1229),
    [anon_sym_any] = ACTIONS(1229),
    [anon_sym_number] = ACTIONS(1229),
    [anon_sym_boolean] = ACTIONS(1229),
    [anon_sym_string] = ACTIONS(1229),
    [anon_sym_symbol] = ACTIONS(1229),
    [anon_sym_object] = ACTIONS(1229),
    [anon_sym_property] = ACTIONS(1229),
    [anon_sym_signal] = ACTIONS(1229),
    [anon_sym_on] = ACTIONS(1229),
    [anon_sym_required] = ACTIONS(1229),
    [anon_sym_component] = ACTIONS(1229),
    [sym_html_comment] = ACTIONS(5),
  },
  [522] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_expression] = STATE(2034),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6164),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3271),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6167),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(522),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1451),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(522),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_export] = ACTIONS(1327),
    [anon_sym_type] = ACTIONS(1327),
    [anon_sym_namespace] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1349),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_let] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1333),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_of] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1527),
    [anon_sym_using] = ACTIONS(1343),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_SLASH] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_void] = ACTIONS(1349),
    [anon_sym_delete] = ACTIONS(1349),
    [anon_sym_PLUS_PLUS] = ACTIONS(1351),
    [anon_sym_DASH_DASH] = ACTIONS(1351),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1353),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1327),
    [anon_sym_readonly] = ACTIONS(1327),
    [anon_sym_get] = ACTIONS(1327),
    [anon_sym_set] = ACTIONS(1327),
    [anon_sym_declare] = ACTIONS(1327),
    [anon_sym_public] = ACTIONS(1327),
    [anon_sym_private] = ACTIONS(1327),
    [anon_sym_protected] = ACTIONS(1327),
    [anon_sym_override] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_any] = ACTIONS(1327),
    [anon_sym_number] = ACTIONS(1327),
    [anon_sym_boolean] = ACTIONS(1327),
    [anon_sym_string] = ACTIONS(1327),
    [anon_sym_symbol] = ACTIONS(1327),
    [anon_sym_object] = ACTIONS(1327),
    [anon_sym_property] = ACTIONS(1327),
    [anon_sym_signal] = ACTIONS(1327),
    [anon_sym_on] = ACTIONS(1327),
    [anon_sym_required] = ACTIONS(1327),
    [anon_sym_component] = ACTIONS(1327),
    [sym_html_comment] = ACTIONS(5),
  },
  [523] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1520),
    [sym_expression] = STATE(2581),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1520),
    [sym_subscript_expression] = STATE(1520),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6049),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(523),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1520),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(556),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1229),
    [anon_sym_namespace] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1229),
    [anon_sym_let] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_of] = ACTIONS(1229),
    [anon_sym_yield] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1551),
    [anon_sym_using] = ACTIONS(1247),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1257),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_readonly] = ACTIONS(1229),
    [anon_sym_get] = ACTIONS(1229),
    [anon_sym_set] = ACTIONS(1229),
    [anon_sym_declare] = ACTIONS(1229),
    [anon_sym_public] = ACTIONS(1229),
    [anon_sym_private] = ACTIONS(1229),
    [anon_sym_protected] = ACTIONS(1229),
    [anon_sym_override] = ACTIONS(1229),
    [anon_sym_module] = ACTIONS(1229),
    [anon_sym_any] = ACTIONS(1229),
    [anon_sym_number] = ACTIONS(1229),
    [anon_sym_boolean] = ACTIONS(1229),
    [anon_sym_string] = ACTIONS(1229),
    [anon_sym_symbol] = ACTIONS(1229),
    [anon_sym_object] = ACTIONS(1229),
    [anon_sym_property] = ACTIONS(1229),
    [anon_sym_signal] = ACTIONS(1229),
    [anon_sym_on] = ACTIONS(1229),
    [anon_sym_required] = ACTIONS(1229),
    [anon_sym_component] = ACTIONS(1229),
    [sym_html_comment] = ACTIONS(5),
  },
  [524] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2689),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(524),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [sym_html_comment] = ACTIONS(5),
  },
  [525] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2156),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(525),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [526] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(2201),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(526),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [527] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2050),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(527),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [528] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1487),
    [sym_expression] = STATE(2376),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1487),
    [sym_subscript_expression] = STATE(1487),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3189),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6145),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(528),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1487),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1131),
    [anon_sym_namespace] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1159),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_let] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_of] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1149),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_using] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1159),
    [anon_sym_delete] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1167),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1131),
    [anon_sym_readonly] = ACTIONS(1131),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_declare] = ACTIONS(1131),
    [anon_sym_public] = ACTIONS(1131),
    [anon_sym_private] = ACTIONS(1131),
    [anon_sym_protected] = ACTIONS(1131),
    [anon_sym_override] = ACTIONS(1131),
    [anon_sym_module] = ACTIONS(1131),
    [anon_sym_any] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_boolean] = ACTIONS(1131),
    [anon_sym_string] = ACTIONS(1131),
    [anon_sym_symbol] = ACTIONS(1131),
    [anon_sym_object] = ACTIONS(1131),
    [anon_sym_property] = ACTIONS(1131),
    [anon_sym_signal] = ACTIONS(1131),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_required] = ACTIONS(1131),
    [anon_sym_component] = ACTIONS(1131),
    [sym_html_comment] = ACTIONS(5),
  },
  [529] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1513),
    [sym_expression] = STATE(2487),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6293),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1513),
    [sym_subscript_expression] = STATE(1513),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3245),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6295),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(529),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1513),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(455),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1565),
    [anon_sym_export] = ACTIONS(1379),
    [anon_sym_type] = ACTIONS(1379),
    [anon_sym_namespace] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1379),
    [anon_sym_let] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1385),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_of] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1389),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1391),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_using] = ACTIONS(1395),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_void] = ACTIONS(1401),
    [anon_sym_delete] = ACTIONS(1401),
    [anon_sym_PLUS_PLUS] = ACTIONS(1403),
    [anon_sym_DASH_DASH] = ACTIONS(1403),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1405),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1571),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1379),
    [anon_sym_readonly] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(1379),
    [anon_sym_set] = ACTIONS(1379),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_public] = ACTIONS(1379),
    [anon_sym_private] = ACTIONS(1379),
    [anon_sym_protected] = ACTIONS(1379),
    [anon_sym_override] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1379),
    [anon_sym_any] = ACTIONS(1379),
    [anon_sym_number] = ACTIONS(1379),
    [anon_sym_boolean] = ACTIONS(1379),
    [anon_sym_string] = ACTIONS(1379),
    [anon_sym_symbol] = ACTIONS(1379),
    [anon_sym_object] = ACTIONS(1379),
    [anon_sym_property] = ACTIONS(1379),
    [anon_sym_signal] = ACTIONS(1379),
    [anon_sym_on] = ACTIONS(1379),
    [anon_sym_required] = ACTIONS(1379),
    [anon_sym_component] = ACTIONS(1379),
    [sym_html_comment] = ACTIONS(5),
  },
  [530] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2060),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(530),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [531] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1513),
    [sym_expression] = STATE(2493),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6293),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1513),
    [sym_subscript_expression] = STATE(1513),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3245),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6295),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(531),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1513),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(455),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1565),
    [anon_sym_export] = ACTIONS(1379),
    [anon_sym_type] = ACTIONS(1379),
    [anon_sym_namespace] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1379),
    [anon_sym_let] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1385),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_of] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1389),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1391),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_using] = ACTIONS(1395),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_void] = ACTIONS(1401),
    [anon_sym_delete] = ACTIONS(1401),
    [anon_sym_PLUS_PLUS] = ACTIONS(1403),
    [anon_sym_DASH_DASH] = ACTIONS(1403),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1405),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1571),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1379),
    [anon_sym_readonly] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(1379),
    [anon_sym_set] = ACTIONS(1379),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_public] = ACTIONS(1379),
    [anon_sym_private] = ACTIONS(1379),
    [anon_sym_protected] = ACTIONS(1379),
    [anon_sym_override] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1379),
    [anon_sym_any] = ACTIONS(1379),
    [anon_sym_number] = ACTIONS(1379),
    [anon_sym_boolean] = ACTIONS(1379),
    [anon_sym_string] = ACTIONS(1379),
    [anon_sym_symbol] = ACTIONS(1379),
    [anon_sym_object] = ACTIONS(1379),
    [anon_sym_property] = ACTIONS(1379),
    [anon_sym_signal] = ACTIONS(1379),
    [anon_sym_on] = ACTIONS(1379),
    [anon_sym_required] = ACTIONS(1379),
    [anon_sym_component] = ACTIONS(1379),
    [sym_html_comment] = ACTIONS(5),
  },
  [532] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2059),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(532),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [533] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1537),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1537),
    [sym_subscript_expression] = STATE(1537),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6263),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(533),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1537),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(2246),
    [anon_sym_export] = ACTIONS(2248),
    [anon_sym_type] = ACTIONS(2248),
    [anon_sym_namespace] = ACTIONS(2250),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(2248),
    [anon_sym_let] = ACTIONS(2248),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(2248),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(2252),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(2254),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(2256),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(2248),
    [anon_sym_readonly] = ACTIONS(2248),
    [anon_sym_get] = ACTIONS(2248),
    [anon_sym_set] = ACTIONS(2248),
    [anon_sym_declare] = ACTIONS(2248),
    [anon_sym_public] = ACTIONS(2248),
    [anon_sym_private] = ACTIONS(2248),
    [anon_sym_protected] = ACTIONS(2248),
    [anon_sym_override] = ACTIONS(2248),
    [anon_sym_module] = ACTIONS(2248),
    [anon_sym_any] = ACTIONS(2248),
    [anon_sym_number] = ACTIONS(2248),
    [anon_sym_boolean] = ACTIONS(2248),
    [anon_sym_string] = ACTIONS(2248),
    [anon_sym_symbol] = ACTIONS(2248),
    [anon_sym_object] = ACTIONS(2248),
    [anon_sym_property] = ACTIONS(2248),
    [anon_sym_signal] = ACTIONS(2248),
    [anon_sym_on] = ACTIONS(2248),
    [anon_sym_required] = ACTIONS(2248),
    [anon_sym_component] = ACTIONS(2248),
    [sym_html_comment] = ACTIONS(5),
  },
  [534] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1487),
    [sym_expression] = STATE(2377),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1487),
    [sym_subscript_expression] = STATE(1487),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3189),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6145),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(534),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1487),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1131),
    [anon_sym_namespace] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1159),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_let] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_of] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1149),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_using] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1159),
    [anon_sym_delete] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1167),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1131),
    [anon_sym_readonly] = ACTIONS(1131),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_declare] = ACTIONS(1131),
    [anon_sym_public] = ACTIONS(1131),
    [anon_sym_private] = ACTIONS(1131),
    [anon_sym_protected] = ACTIONS(1131),
    [anon_sym_override] = ACTIONS(1131),
    [anon_sym_module] = ACTIONS(1131),
    [anon_sym_any] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_boolean] = ACTIONS(1131),
    [anon_sym_string] = ACTIONS(1131),
    [anon_sym_symbol] = ACTIONS(1131),
    [anon_sym_object] = ACTIONS(1131),
    [anon_sym_property] = ACTIONS(1131),
    [anon_sym_signal] = ACTIONS(1131),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_required] = ACTIONS(1131),
    [anon_sym_component] = ACTIONS(1131),
    [sym_html_comment] = ACTIONS(5),
  },
  [535] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1984),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(535),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [536] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2035),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(536),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [537] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_expression] = STATE(1981),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6164),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3271),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6167),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(537),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1451),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(522),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_export] = ACTIONS(1327),
    [anon_sym_type] = ACTIONS(1327),
    [anon_sym_namespace] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1349),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_let] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1333),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_of] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1527),
    [anon_sym_using] = ACTIONS(1343),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_SLASH] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_void] = ACTIONS(1349),
    [anon_sym_delete] = ACTIONS(1349),
    [anon_sym_PLUS_PLUS] = ACTIONS(1351),
    [anon_sym_DASH_DASH] = ACTIONS(1351),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1353),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1327),
    [anon_sym_readonly] = ACTIONS(1327),
    [anon_sym_get] = ACTIONS(1327),
    [anon_sym_set] = ACTIONS(1327),
    [anon_sym_declare] = ACTIONS(1327),
    [anon_sym_public] = ACTIONS(1327),
    [anon_sym_private] = ACTIONS(1327),
    [anon_sym_protected] = ACTIONS(1327),
    [anon_sym_override] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_any] = ACTIONS(1327),
    [anon_sym_number] = ACTIONS(1327),
    [anon_sym_boolean] = ACTIONS(1327),
    [anon_sym_string] = ACTIONS(1327),
    [anon_sym_symbol] = ACTIONS(1327),
    [anon_sym_object] = ACTIONS(1327),
    [anon_sym_property] = ACTIONS(1327),
    [anon_sym_signal] = ACTIONS(1327),
    [anon_sym_on] = ACTIONS(1327),
    [anon_sym_required] = ACTIONS(1327),
    [anon_sym_component] = ACTIONS(1327),
    [sym_html_comment] = ACTIONS(5),
  },
  [538] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1520),
    [sym_expression] = STATE(2603),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1520),
    [sym_subscript_expression] = STATE(1520),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6049),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(538),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1520),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(556),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1229),
    [anon_sym_namespace] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1229),
    [anon_sym_let] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_of] = ACTIONS(1229),
    [anon_sym_yield] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1551),
    [anon_sym_using] = ACTIONS(1247),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1257),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_readonly] = ACTIONS(1229),
    [anon_sym_get] = ACTIONS(1229),
    [anon_sym_set] = ACTIONS(1229),
    [anon_sym_declare] = ACTIONS(1229),
    [anon_sym_public] = ACTIONS(1229),
    [anon_sym_private] = ACTIONS(1229),
    [anon_sym_protected] = ACTIONS(1229),
    [anon_sym_override] = ACTIONS(1229),
    [anon_sym_module] = ACTIONS(1229),
    [anon_sym_any] = ACTIONS(1229),
    [anon_sym_number] = ACTIONS(1229),
    [anon_sym_boolean] = ACTIONS(1229),
    [anon_sym_string] = ACTIONS(1229),
    [anon_sym_symbol] = ACTIONS(1229),
    [anon_sym_object] = ACTIONS(1229),
    [anon_sym_property] = ACTIONS(1229),
    [anon_sym_signal] = ACTIONS(1229),
    [anon_sym_on] = ACTIONS(1229),
    [anon_sym_required] = ACTIONS(1229),
    [anon_sym_component] = ACTIONS(1229),
    [sym_html_comment] = ACTIONS(5),
  },
  [539] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2748),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(539),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [sym_html_comment] = ACTIONS(5),
  },
  [540] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2697),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(540),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [sym_html_comment] = ACTIONS(5),
  },
  [541] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1473),
    [sym_expression] = STATE(2114),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6272),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1473),
    [sym_subscript_expression] = STATE(1473),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3246),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6274),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(541),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1473),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(541),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_export] = ACTIONS(1415),
    [anon_sym_type] = ACTIONS(1415),
    [anon_sym_namespace] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1437),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1415),
    [anon_sym_let] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1421),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1423),
    [anon_sym_of] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1425),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1427),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1543),
    [anon_sym_using] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1421),
    [anon_sym_void] = ACTIONS(1437),
    [anon_sym_delete] = ACTIONS(1437),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1441),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1415),
    [anon_sym_readonly] = ACTIONS(1415),
    [anon_sym_get] = ACTIONS(1415),
    [anon_sym_set] = ACTIONS(1415),
    [anon_sym_declare] = ACTIONS(1415),
    [anon_sym_public] = ACTIONS(1415),
    [anon_sym_private] = ACTIONS(1415),
    [anon_sym_protected] = ACTIONS(1415),
    [anon_sym_override] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_any] = ACTIONS(1415),
    [anon_sym_number] = ACTIONS(1415),
    [anon_sym_boolean] = ACTIONS(1415),
    [anon_sym_string] = ACTIONS(1415),
    [anon_sym_symbol] = ACTIONS(1415),
    [anon_sym_object] = ACTIONS(1415),
    [anon_sym_property] = ACTIONS(1415),
    [anon_sym_signal] = ACTIONS(1415),
    [anon_sym_on] = ACTIONS(1415),
    [anon_sym_required] = ACTIONS(1415),
    [anon_sym_component] = ACTIONS(1415),
    [sym_html_comment] = ACTIONS(5),
  },
  [542] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2747),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(542),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [sym_html_comment] = ACTIONS(5),
  },
  [543] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1487),
    [sym_expression] = STATE(2388),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1487),
    [sym_subscript_expression] = STATE(1487),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3189),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6145),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(543),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1487),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1131),
    [anon_sym_namespace] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1159),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_let] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_of] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1149),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_using] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1159),
    [anon_sym_delete] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1167),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1131),
    [anon_sym_readonly] = ACTIONS(1131),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_declare] = ACTIONS(1131),
    [anon_sym_public] = ACTIONS(1131),
    [anon_sym_private] = ACTIONS(1131),
    [anon_sym_protected] = ACTIONS(1131),
    [anon_sym_override] = ACTIONS(1131),
    [anon_sym_module] = ACTIONS(1131),
    [anon_sym_any] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_boolean] = ACTIONS(1131),
    [anon_sym_string] = ACTIONS(1131),
    [anon_sym_symbol] = ACTIONS(1131),
    [anon_sym_object] = ACTIONS(1131),
    [anon_sym_property] = ACTIONS(1131),
    [anon_sym_signal] = ACTIONS(1131),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_required] = ACTIONS(1131),
    [anon_sym_component] = ACTIONS(1131),
    [sym_html_comment] = ACTIONS(5),
  },
  [544] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1473),
    [sym_expression] = STATE(2172),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6272),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1473),
    [sym_subscript_expression] = STATE(1473),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3246),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6274),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(544),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1473),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(541),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_export] = ACTIONS(1415),
    [anon_sym_type] = ACTIONS(1415),
    [anon_sym_namespace] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1437),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1415),
    [anon_sym_let] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1421),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1423),
    [anon_sym_of] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1425),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1427),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1543),
    [anon_sym_using] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1421),
    [anon_sym_void] = ACTIONS(1437),
    [anon_sym_delete] = ACTIONS(1437),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1441),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1415),
    [anon_sym_readonly] = ACTIONS(1415),
    [anon_sym_get] = ACTIONS(1415),
    [anon_sym_set] = ACTIONS(1415),
    [anon_sym_declare] = ACTIONS(1415),
    [anon_sym_public] = ACTIONS(1415),
    [anon_sym_private] = ACTIONS(1415),
    [anon_sym_protected] = ACTIONS(1415),
    [anon_sym_override] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_any] = ACTIONS(1415),
    [anon_sym_number] = ACTIONS(1415),
    [anon_sym_boolean] = ACTIONS(1415),
    [anon_sym_string] = ACTIONS(1415),
    [anon_sym_symbol] = ACTIONS(1415),
    [anon_sym_object] = ACTIONS(1415),
    [anon_sym_property] = ACTIONS(1415),
    [anon_sym_signal] = ACTIONS(1415),
    [anon_sym_on] = ACTIONS(1415),
    [anon_sym_required] = ACTIONS(1415),
    [anon_sym_component] = ACTIONS(1415),
    [sym_html_comment] = ACTIONS(5),
  },
  [545] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1473),
    [sym_expression] = STATE(2173),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6272),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1473),
    [sym_subscript_expression] = STATE(1473),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3246),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6274),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(545),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1473),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(541),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_export] = ACTIONS(1415),
    [anon_sym_type] = ACTIONS(1415),
    [anon_sym_namespace] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1437),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1415),
    [anon_sym_let] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1421),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1423),
    [anon_sym_of] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1425),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1427),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1543),
    [anon_sym_using] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1421),
    [anon_sym_void] = ACTIONS(1437),
    [anon_sym_delete] = ACTIONS(1437),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1441),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1415),
    [anon_sym_readonly] = ACTIONS(1415),
    [anon_sym_get] = ACTIONS(1415),
    [anon_sym_set] = ACTIONS(1415),
    [anon_sym_declare] = ACTIONS(1415),
    [anon_sym_public] = ACTIONS(1415),
    [anon_sym_private] = ACTIONS(1415),
    [anon_sym_protected] = ACTIONS(1415),
    [anon_sym_override] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_any] = ACTIONS(1415),
    [anon_sym_number] = ACTIONS(1415),
    [anon_sym_boolean] = ACTIONS(1415),
    [anon_sym_string] = ACTIONS(1415),
    [anon_sym_symbol] = ACTIONS(1415),
    [anon_sym_object] = ACTIONS(1415),
    [anon_sym_property] = ACTIONS(1415),
    [anon_sym_signal] = ACTIONS(1415),
    [anon_sym_on] = ACTIONS(1415),
    [anon_sym_required] = ACTIONS(1415),
    [anon_sym_component] = ACTIONS(1415),
    [sym_html_comment] = ACTIONS(5),
  },
  [546] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2719),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(546),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [sym_html_comment] = ACTIONS(5),
  },
  [547] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1938),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(547),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [548] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1473),
    [sym_expression] = STATE(2115),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6272),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1473),
    [sym_subscript_expression] = STATE(1473),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3246),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6274),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(548),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1473),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(541),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_export] = ACTIONS(1415),
    [anon_sym_type] = ACTIONS(1415),
    [anon_sym_namespace] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1437),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1415),
    [anon_sym_let] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1421),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1423),
    [anon_sym_of] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1425),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1427),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1543),
    [anon_sym_using] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1421),
    [anon_sym_void] = ACTIONS(1437),
    [anon_sym_delete] = ACTIONS(1437),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1441),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1415),
    [anon_sym_readonly] = ACTIONS(1415),
    [anon_sym_get] = ACTIONS(1415),
    [anon_sym_set] = ACTIONS(1415),
    [anon_sym_declare] = ACTIONS(1415),
    [anon_sym_public] = ACTIONS(1415),
    [anon_sym_private] = ACTIONS(1415),
    [anon_sym_protected] = ACTIONS(1415),
    [anon_sym_override] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_any] = ACTIONS(1415),
    [anon_sym_number] = ACTIONS(1415),
    [anon_sym_boolean] = ACTIONS(1415),
    [anon_sym_string] = ACTIONS(1415),
    [anon_sym_symbol] = ACTIONS(1415),
    [anon_sym_object] = ACTIONS(1415),
    [anon_sym_property] = ACTIONS(1415),
    [anon_sym_signal] = ACTIONS(1415),
    [anon_sym_on] = ACTIONS(1415),
    [anon_sym_required] = ACTIONS(1415),
    [anon_sym_component] = ACTIONS(1415),
    [sym_html_comment] = ACTIONS(5),
  },
  [549] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_expression] = STATE(2570),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5939),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(549),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1523),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1555),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_of] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_using] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_property] = ACTIONS(1181),
    [anon_sym_signal] = ACTIONS(1181),
    [anon_sym_on] = ACTIONS(1181),
    [anon_sym_required] = ACTIONS(1181),
    [anon_sym_component] = ACTIONS(1181),
    [sym_html_comment] = ACTIONS(5),
  },
  [550] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1949),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(550),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [551] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_expression] = STATE(2530),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5939),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(551),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1523),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1555),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_of] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_using] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_property] = ACTIONS(1181),
    [anon_sym_signal] = ACTIONS(1181),
    [anon_sym_on] = ACTIONS(1181),
    [anon_sym_required] = ACTIONS(1181),
    [anon_sym_component] = ACTIONS(1181),
    [sym_html_comment] = ACTIONS(5),
  },
  [552] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_expression] = STATE(1970),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6164),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3271),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6167),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(552),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1451),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(522),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_export] = ACTIONS(1327),
    [anon_sym_type] = ACTIONS(1327),
    [anon_sym_namespace] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1349),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_let] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1333),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_of] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1527),
    [anon_sym_using] = ACTIONS(1343),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_SLASH] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_void] = ACTIONS(1349),
    [anon_sym_delete] = ACTIONS(1349),
    [anon_sym_PLUS_PLUS] = ACTIONS(1351),
    [anon_sym_DASH_DASH] = ACTIONS(1351),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1353),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1327),
    [anon_sym_readonly] = ACTIONS(1327),
    [anon_sym_get] = ACTIONS(1327),
    [anon_sym_set] = ACTIONS(1327),
    [anon_sym_declare] = ACTIONS(1327),
    [anon_sym_public] = ACTIONS(1327),
    [anon_sym_private] = ACTIONS(1327),
    [anon_sym_protected] = ACTIONS(1327),
    [anon_sym_override] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_any] = ACTIONS(1327),
    [anon_sym_number] = ACTIONS(1327),
    [anon_sym_boolean] = ACTIONS(1327),
    [anon_sym_string] = ACTIONS(1327),
    [anon_sym_symbol] = ACTIONS(1327),
    [anon_sym_object] = ACTIONS(1327),
    [anon_sym_property] = ACTIONS(1327),
    [anon_sym_signal] = ACTIONS(1327),
    [anon_sym_on] = ACTIONS(1327),
    [anon_sym_required] = ACTIONS(1327),
    [anon_sym_component] = ACTIONS(1327),
    [sym_html_comment] = ACTIONS(5),
  },
  [553] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_expression] = STATE(2466),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5939),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(553),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1523),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1555),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_of] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_using] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_property] = ACTIONS(1181),
    [anon_sym_signal] = ACTIONS(1181),
    [anon_sym_on] = ACTIONS(1181),
    [anon_sym_required] = ACTIONS(1181),
    [anon_sym_component] = ACTIONS(1181),
    [sym_html_comment] = ACTIONS(5),
  },
  [554] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1487),
    [sym_expression] = STATE(2402),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1487),
    [sym_subscript_expression] = STATE(1487),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3189),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6145),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(554),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1487),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1131),
    [anon_sym_namespace] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1159),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_let] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_of] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1149),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_using] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1159),
    [anon_sym_delete] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1167),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1131),
    [anon_sym_readonly] = ACTIONS(1131),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_declare] = ACTIONS(1131),
    [anon_sym_public] = ACTIONS(1131),
    [anon_sym_private] = ACTIONS(1131),
    [anon_sym_protected] = ACTIONS(1131),
    [anon_sym_override] = ACTIONS(1131),
    [anon_sym_module] = ACTIONS(1131),
    [anon_sym_any] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_boolean] = ACTIONS(1131),
    [anon_sym_string] = ACTIONS(1131),
    [anon_sym_symbol] = ACTIONS(1131),
    [anon_sym_object] = ACTIONS(1131),
    [anon_sym_property] = ACTIONS(1131),
    [anon_sym_signal] = ACTIONS(1131),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_required] = ACTIONS(1131),
    [anon_sym_component] = ACTIONS(1131),
    [sym_html_comment] = ACTIONS(5),
  },
  [555] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1520),
    [sym_expression] = STATE(2573),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1520),
    [sym_subscript_expression] = STATE(1520),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6049),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(555),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1520),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(556),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1229),
    [anon_sym_namespace] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1229),
    [anon_sym_let] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_of] = ACTIONS(1229),
    [anon_sym_yield] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1551),
    [anon_sym_using] = ACTIONS(1247),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1257),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_readonly] = ACTIONS(1229),
    [anon_sym_get] = ACTIONS(1229),
    [anon_sym_set] = ACTIONS(1229),
    [anon_sym_declare] = ACTIONS(1229),
    [anon_sym_public] = ACTIONS(1229),
    [anon_sym_private] = ACTIONS(1229),
    [anon_sym_protected] = ACTIONS(1229),
    [anon_sym_override] = ACTIONS(1229),
    [anon_sym_module] = ACTIONS(1229),
    [anon_sym_any] = ACTIONS(1229),
    [anon_sym_number] = ACTIONS(1229),
    [anon_sym_boolean] = ACTIONS(1229),
    [anon_sym_string] = ACTIONS(1229),
    [anon_sym_symbol] = ACTIONS(1229),
    [anon_sym_object] = ACTIONS(1229),
    [anon_sym_property] = ACTIONS(1229),
    [anon_sym_signal] = ACTIONS(1229),
    [anon_sym_on] = ACTIONS(1229),
    [anon_sym_required] = ACTIONS(1229),
    [anon_sym_component] = ACTIONS(1229),
    [sym_html_comment] = ACTIONS(5),
  },
  [556] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1520),
    [sym_expression] = STATE(2575),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1520),
    [sym_subscript_expression] = STATE(1520),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6049),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(556),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1520),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(556),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1229),
    [anon_sym_namespace] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1229),
    [anon_sym_let] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_of] = ACTIONS(1229),
    [anon_sym_yield] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1551),
    [anon_sym_using] = ACTIONS(1247),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1257),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_readonly] = ACTIONS(1229),
    [anon_sym_get] = ACTIONS(1229),
    [anon_sym_set] = ACTIONS(1229),
    [anon_sym_declare] = ACTIONS(1229),
    [anon_sym_public] = ACTIONS(1229),
    [anon_sym_private] = ACTIONS(1229),
    [anon_sym_protected] = ACTIONS(1229),
    [anon_sym_override] = ACTIONS(1229),
    [anon_sym_module] = ACTIONS(1229),
    [anon_sym_any] = ACTIONS(1229),
    [anon_sym_number] = ACTIONS(1229),
    [anon_sym_boolean] = ACTIONS(1229),
    [anon_sym_string] = ACTIONS(1229),
    [anon_sym_symbol] = ACTIONS(1229),
    [anon_sym_object] = ACTIONS(1229),
    [anon_sym_property] = ACTIONS(1229),
    [anon_sym_signal] = ACTIONS(1229),
    [anon_sym_on] = ACTIONS(1229),
    [anon_sym_required] = ACTIONS(1229),
    [anon_sym_component] = ACTIONS(1229),
    [sym_html_comment] = ACTIONS(5),
  },
  [557] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1993),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(557),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [558] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1487),
    [sym_expression] = STATE(2403),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1487),
    [sym_subscript_expression] = STATE(1487),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3189),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6145),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(558),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1487),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1131),
    [anon_sym_namespace] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1159),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_let] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_of] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1149),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_using] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1159),
    [anon_sym_delete] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1167),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1131),
    [anon_sym_readonly] = ACTIONS(1131),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_declare] = ACTIONS(1131),
    [anon_sym_public] = ACTIONS(1131),
    [anon_sym_private] = ACTIONS(1131),
    [anon_sym_protected] = ACTIONS(1131),
    [anon_sym_override] = ACTIONS(1131),
    [anon_sym_module] = ACTIONS(1131),
    [anon_sym_any] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_boolean] = ACTIONS(1131),
    [anon_sym_string] = ACTIONS(1131),
    [anon_sym_symbol] = ACTIONS(1131),
    [anon_sym_object] = ACTIONS(1131),
    [anon_sym_property] = ACTIONS(1131),
    [anon_sym_signal] = ACTIONS(1131),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_required] = ACTIONS(1131),
    [anon_sym_component] = ACTIONS(1131),
    [sym_html_comment] = ACTIONS(5),
  },
  [559] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1473),
    [sym_expression] = STATE(2118),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6272),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1473),
    [sym_subscript_expression] = STATE(1473),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3246),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6274),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(559),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1473),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(541),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_export] = ACTIONS(1415),
    [anon_sym_type] = ACTIONS(1415),
    [anon_sym_namespace] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1437),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1415),
    [anon_sym_let] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1421),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1423),
    [anon_sym_of] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1425),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1427),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1543),
    [anon_sym_using] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1421),
    [anon_sym_void] = ACTIONS(1437),
    [anon_sym_delete] = ACTIONS(1437),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1441),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1415),
    [anon_sym_readonly] = ACTIONS(1415),
    [anon_sym_get] = ACTIONS(1415),
    [anon_sym_set] = ACTIONS(1415),
    [anon_sym_declare] = ACTIONS(1415),
    [anon_sym_public] = ACTIONS(1415),
    [anon_sym_private] = ACTIONS(1415),
    [anon_sym_protected] = ACTIONS(1415),
    [anon_sym_override] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_any] = ACTIONS(1415),
    [anon_sym_number] = ACTIONS(1415),
    [anon_sym_boolean] = ACTIONS(1415),
    [anon_sym_string] = ACTIONS(1415),
    [anon_sym_symbol] = ACTIONS(1415),
    [anon_sym_object] = ACTIONS(1415),
    [anon_sym_property] = ACTIONS(1415),
    [anon_sym_signal] = ACTIONS(1415),
    [anon_sym_on] = ACTIONS(1415),
    [anon_sym_required] = ACTIONS(1415),
    [anon_sym_component] = ACTIONS(1415),
    [sym_html_comment] = ACTIONS(5),
  },
  [560] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1520),
    [sym_expression] = STATE(2618),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1520),
    [sym_subscript_expression] = STATE(1520),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6049),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(560),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1520),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(556),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1229),
    [anon_sym_namespace] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1229),
    [anon_sym_let] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_of] = ACTIONS(1229),
    [anon_sym_yield] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1551),
    [anon_sym_using] = ACTIONS(1247),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1257),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_readonly] = ACTIONS(1229),
    [anon_sym_get] = ACTIONS(1229),
    [anon_sym_set] = ACTIONS(1229),
    [anon_sym_declare] = ACTIONS(1229),
    [anon_sym_public] = ACTIONS(1229),
    [anon_sym_private] = ACTIONS(1229),
    [anon_sym_protected] = ACTIONS(1229),
    [anon_sym_override] = ACTIONS(1229),
    [anon_sym_module] = ACTIONS(1229),
    [anon_sym_any] = ACTIONS(1229),
    [anon_sym_number] = ACTIONS(1229),
    [anon_sym_boolean] = ACTIONS(1229),
    [anon_sym_string] = ACTIONS(1229),
    [anon_sym_symbol] = ACTIONS(1229),
    [anon_sym_object] = ACTIONS(1229),
    [anon_sym_property] = ACTIONS(1229),
    [anon_sym_signal] = ACTIONS(1229),
    [anon_sym_on] = ACTIONS(1229),
    [anon_sym_required] = ACTIONS(1229),
    [anon_sym_component] = ACTIONS(1229),
    [sym_html_comment] = ACTIONS(5),
  },
  [561] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1487),
    [sym_expression] = STATE(2404),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1487),
    [sym_subscript_expression] = STATE(1487),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3189),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6145),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(561),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1487),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1131),
    [anon_sym_namespace] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1159),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_let] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_of] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1149),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_using] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1159),
    [anon_sym_delete] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1167),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1131),
    [anon_sym_readonly] = ACTIONS(1131),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_declare] = ACTIONS(1131),
    [anon_sym_public] = ACTIONS(1131),
    [anon_sym_private] = ACTIONS(1131),
    [anon_sym_protected] = ACTIONS(1131),
    [anon_sym_override] = ACTIONS(1131),
    [anon_sym_module] = ACTIONS(1131),
    [anon_sym_any] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_boolean] = ACTIONS(1131),
    [anon_sym_string] = ACTIONS(1131),
    [anon_sym_symbol] = ACTIONS(1131),
    [anon_sym_object] = ACTIONS(1131),
    [anon_sym_property] = ACTIONS(1131),
    [anon_sym_signal] = ACTIONS(1131),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_required] = ACTIONS(1131),
    [anon_sym_component] = ACTIONS(1131),
    [sym_html_comment] = ACTIONS(5),
  },
  [562] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1520),
    [sym_expression] = STATE(2602),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1520),
    [sym_subscript_expression] = STATE(1520),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6049),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(562),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1520),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(556),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1229),
    [anon_sym_namespace] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1229),
    [anon_sym_let] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_of] = ACTIONS(1229),
    [anon_sym_yield] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1551),
    [anon_sym_using] = ACTIONS(1247),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1257),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_readonly] = ACTIONS(1229),
    [anon_sym_get] = ACTIONS(1229),
    [anon_sym_set] = ACTIONS(1229),
    [anon_sym_declare] = ACTIONS(1229),
    [anon_sym_public] = ACTIONS(1229),
    [anon_sym_private] = ACTIONS(1229),
    [anon_sym_protected] = ACTIONS(1229),
    [anon_sym_override] = ACTIONS(1229),
    [anon_sym_module] = ACTIONS(1229),
    [anon_sym_any] = ACTIONS(1229),
    [anon_sym_number] = ACTIONS(1229),
    [anon_sym_boolean] = ACTIONS(1229),
    [anon_sym_string] = ACTIONS(1229),
    [anon_sym_symbol] = ACTIONS(1229),
    [anon_sym_object] = ACTIONS(1229),
    [anon_sym_property] = ACTIONS(1229),
    [anon_sym_signal] = ACTIONS(1229),
    [anon_sym_on] = ACTIONS(1229),
    [anon_sym_required] = ACTIONS(1229),
    [anon_sym_component] = ACTIONS(1229),
    [sym_html_comment] = ACTIONS(5),
  },
  [563] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_expression] = STATE(2589),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5939),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(563),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1523),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1555),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_of] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_using] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_property] = ACTIONS(1181),
    [anon_sym_signal] = ACTIONS(1181),
    [anon_sym_on] = ACTIONS(1181),
    [anon_sym_required] = ACTIONS(1181),
    [anon_sym_component] = ACTIONS(1181),
    [sym_html_comment] = ACTIONS(5),
  },
  [564] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1843),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(564),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [565] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_expression] = STATE(2449),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5939),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(565),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1523),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1555),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_of] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_using] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_property] = ACTIONS(1181),
    [anon_sym_signal] = ACTIONS(1181),
    [anon_sym_on] = ACTIONS(1181),
    [anon_sym_required] = ACTIONS(1181),
    [anon_sym_component] = ACTIONS(1181),
    [sym_html_comment] = ACTIONS(5),
  },
  [566] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1848),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(566),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [567] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2063),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(567),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [568] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_expression] = STATE(2454),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5939),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(568),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1523),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1555),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_of] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_using] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_property] = ACTIONS(1181),
    [anon_sym_signal] = ACTIONS(1181),
    [anon_sym_on] = ACTIONS(1181),
    [anon_sym_required] = ACTIONS(1181),
    [anon_sym_component] = ACTIONS(1181),
    [sym_html_comment] = ACTIONS(5),
  },
  [569] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1487),
    [sym_expression] = STATE(2405),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1487),
    [sym_subscript_expression] = STATE(1487),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3189),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6145),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(569),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1487),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1131),
    [anon_sym_namespace] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1159),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_let] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_of] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1149),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_using] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1159),
    [anon_sym_delete] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1167),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1131),
    [anon_sym_readonly] = ACTIONS(1131),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_declare] = ACTIONS(1131),
    [anon_sym_public] = ACTIONS(1131),
    [anon_sym_private] = ACTIONS(1131),
    [anon_sym_protected] = ACTIONS(1131),
    [anon_sym_override] = ACTIONS(1131),
    [anon_sym_module] = ACTIONS(1131),
    [anon_sym_any] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_boolean] = ACTIONS(1131),
    [anon_sym_string] = ACTIONS(1131),
    [anon_sym_symbol] = ACTIONS(1131),
    [anon_sym_object] = ACTIONS(1131),
    [anon_sym_property] = ACTIONS(1131),
    [anon_sym_signal] = ACTIONS(1131),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_required] = ACTIONS(1131),
    [anon_sym_component] = ACTIONS(1131),
    [sym_html_comment] = ACTIONS(5),
  },
  [570] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1520),
    [sym_expression] = STATE(2432),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1520),
    [sym_subscript_expression] = STATE(1520),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6049),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(570),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1520),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(556),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1229),
    [anon_sym_namespace] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1229),
    [anon_sym_let] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_of] = ACTIONS(1229),
    [anon_sym_yield] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1551),
    [anon_sym_using] = ACTIONS(1247),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1257),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_readonly] = ACTIONS(1229),
    [anon_sym_get] = ACTIONS(1229),
    [anon_sym_set] = ACTIONS(1229),
    [anon_sym_declare] = ACTIONS(1229),
    [anon_sym_public] = ACTIONS(1229),
    [anon_sym_private] = ACTIONS(1229),
    [anon_sym_protected] = ACTIONS(1229),
    [anon_sym_override] = ACTIONS(1229),
    [anon_sym_module] = ACTIONS(1229),
    [anon_sym_any] = ACTIONS(1229),
    [anon_sym_number] = ACTIONS(1229),
    [anon_sym_boolean] = ACTIONS(1229),
    [anon_sym_string] = ACTIONS(1229),
    [anon_sym_symbol] = ACTIONS(1229),
    [anon_sym_object] = ACTIONS(1229),
    [anon_sym_property] = ACTIONS(1229),
    [anon_sym_signal] = ACTIONS(1229),
    [anon_sym_on] = ACTIONS(1229),
    [anon_sym_required] = ACTIONS(1229),
    [anon_sym_component] = ACTIONS(1229),
    [sym_html_comment] = ACTIONS(5),
  },
  [571] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1473),
    [sym_expression] = STATE(2127),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6272),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1473),
    [sym_subscript_expression] = STATE(1473),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3246),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6274),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(571),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1473),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(541),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_export] = ACTIONS(1415),
    [anon_sym_type] = ACTIONS(1415),
    [anon_sym_namespace] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1437),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1415),
    [anon_sym_let] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1421),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1423),
    [anon_sym_of] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1425),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1427),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1543),
    [anon_sym_using] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1421),
    [anon_sym_void] = ACTIONS(1437),
    [anon_sym_delete] = ACTIONS(1437),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1441),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1415),
    [anon_sym_readonly] = ACTIONS(1415),
    [anon_sym_get] = ACTIONS(1415),
    [anon_sym_set] = ACTIONS(1415),
    [anon_sym_declare] = ACTIONS(1415),
    [anon_sym_public] = ACTIONS(1415),
    [anon_sym_private] = ACTIONS(1415),
    [anon_sym_protected] = ACTIONS(1415),
    [anon_sym_override] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_any] = ACTIONS(1415),
    [anon_sym_number] = ACTIONS(1415),
    [anon_sym_boolean] = ACTIONS(1415),
    [anon_sym_string] = ACTIONS(1415),
    [anon_sym_symbol] = ACTIONS(1415),
    [anon_sym_object] = ACTIONS(1415),
    [anon_sym_property] = ACTIONS(1415),
    [anon_sym_signal] = ACTIONS(1415),
    [anon_sym_on] = ACTIONS(1415),
    [anon_sym_required] = ACTIONS(1415),
    [anon_sym_component] = ACTIONS(1415),
    [sym_html_comment] = ACTIONS(5),
  },
  [572] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1791),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(572),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(2208),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [573] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1530),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1530),
    [sym_subscript_expression] = STATE(1530),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6285),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(573),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1530),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(2258),
    [anon_sym_export] = ACTIONS(2260),
    [anon_sym_type] = ACTIONS(2260),
    [anon_sym_namespace] = ACTIONS(2262),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(2260),
    [anon_sym_let] = ACTIONS(2260),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(2260),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(2264),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(2266),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(2268),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(2260),
    [anon_sym_readonly] = ACTIONS(2260),
    [anon_sym_get] = ACTIONS(2260),
    [anon_sym_set] = ACTIONS(2260),
    [anon_sym_declare] = ACTIONS(2260),
    [anon_sym_public] = ACTIONS(2260),
    [anon_sym_private] = ACTIONS(2260),
    [anon_sym_protected] = ACTIONS(2260),
    [anon_sym_override] = ACTIONS(2260),
    [anon_sym_module] = ACTIONS(2260),
    [anon_sym_any] = ACTIONS(2260),
    [anon_sym_number] = ACTIONS(2260),
    [anon_sym_boolean] = ACTIONS(2260),
    [anon_sym_string] = ACTIONS(2260),
    [anon_sym_symbol] = ACTIONS(2260),
    [anon_sym_object] = ACTIONS(2260),
    [anon_sym_property] = ACTIONS(2260),
    [anon_sym_signal] = ACTIONS(2260),
    [anon_sym_on] = ACTIONS(2260),
    [anon_sym_required] = ACTIONS(2260),
    [anon_sym_component] = ACTIONS(2260),
    [sym_html_comment] = ACTIONS(5),
  },
  [574] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_expression] = STATE(2472),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5939),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(574),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1523),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1555),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_of] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_using] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_property] = ACTIONS(1181),
    [anon_sym_signal] = ACTIONS(1181),
    [anon_sym_on] = ACTIONS(1181),
    [anon_sym_required] = ACTIONS(1181),
    [anon_sym_component] = ACTIONS(1181),
    [sym_html_comment] = ACTIONS(5),
  },
  [575] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_expression] = STATE(2473),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5939),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(575),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1523),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1555),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_of] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_using] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_property] = ACTIONS(1181),
    [anon_sym_signal] = ACTIONS(1181),
    [anon_sym_on] = ACTIONS(1181),
    [anon_sym_required] = ACTIONS(1181),
    [anon_sym_component] = ACTIONS(1181),
    [sym_html_comment] = ACTIONS(5),
  },
  [576] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_expression] = STATE(2483),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5939),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(576),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1523),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1555),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_of] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_using] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_property] = ACTIONS(1181),
    [anon_sym_signal] = ACTIONS(1181),
    [anon_sym_on] = ACTIONS(1181),
    [anon_sym_required] = ACTIONS(1181),
    [anon_sym_component] = ACTIONS(1181),
    [sym_html_comment] = ACTIONS(5),
  },
  [577] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1487),
    [sym_expression] = STATE(2406),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1487),
    [sym_subscript_expression] = STATE(1487),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3189),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6145),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(577),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1487),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1131),
    [anon_sym_namespace] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1159),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_let] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_of] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1149),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_using] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1159),
    [anon_sym_delete] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1167),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1131),
    [anon_sym_readonly] = ACTIONS(1131),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_declare] = ACTIONS(1131),
    [anon_sym_public] = ACTIONS(1131),
    [anon_sym_private] = ACTIONS(1131),
    [anon_sym_protected] = ACTIONS(1131),
    [anon_sym_override] = ACTIONS(1131),
    [anon_sym_module] = ACTIONS(1131),
    [anon_sym_any] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_boolean] = ACTIONS(1131),
    [anon_sym_string] = ACTIONS(1131),
    [anon_sym_symbol] = ACTIONS(1131),
    [anon_sym_object] = ACTIONS(1131),
    [anon_sym_property] = ACTIONS(1131),
    [anon_sym_signal] = ACTIONS(1131),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_required] = ACTIONS(1131),
    [anon_sym_component] = ACTIONS(1131),
    [sym_html_comment] = ACTIONS(5),
  },
  [578] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1520),
    [sym_expression] = STATE(2423),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1520),
    [sym_subscript_expression] = STATE(1520),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6049),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(578),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1520),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(556),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1229),
    [anon_sym_namespace] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1229),
    [anon_sym_let] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_of] = ACTIONS(1229),
    [anon_sym_yield] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1551),
    [anon_sym_using] = ACTIONS(1247),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1257),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_readonly] = ACTIONS(1229),
    [anon_sym_get] = ACTIONS(1229),
    [anon_sym_set] = ACTIONS(1229),
    [anon_sym_declare] = ACTIONS(1229),
    [anon_sym_public] = ACTIONS(1229),
    [anon_sym_private] = ACTIONS(1229),
    [anon_sym_protected] = ACTIONS(1229),
    [anon_sym_override] = ACTIONS(1229),
    [anon_sym_module] = ACTIONS(1229),
    [anon_sym_any] = ACTIONS(1229),
    [anon_sym_number] = ACTIONS(1229),
    [anon_sym_boolean] = ACTIONS(1229),
    [anon_sym_string] = ACTIONS(1229),
    [anon_sym_symbol] = ACTIONS(1229),
    [anon_sym_object] = ACTIONS(1229),
    [anon_sym_property] = ACTIONS(1229),
    [anon_sym_signal] = ACTIONS(1229),
    [anon_sym_on] = ACTIONS(1229),
    [anon_sym_required] = ACTIONS(1229),
    [anon_sym_component] = ACTIONS(1229),
    [sym_html_comment] = ACTIONS(5),
  },
  [579] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1487),
    [sym_expression] = STATE(2294),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1487),
    [sym_subscript_expression] = STATE(1487),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3189),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6145),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(579),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1487),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1131),
    [anon_sym_namespace] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1159),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_let] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_of] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1149),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_using] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1159),
    [anon_sym_delete] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1167),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1131),
    [anon_sym_readonly] = ACTIONS(1131),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_declare] = ACTIONS(1131),
    [anon_sym_public] = ACTIONS(1131),
    [anon_sym_private] = ACTIONS(1131),
    [anon_sym_protected] = ACTIONS(1131),
    [anon_sym_override] = ACTIONS(1131),
    [anon_sym_module] = ACTIONS(1131),
    [anon_sym_any] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_boolean] = ACTIONS(1131),
    [anon_sym_string] = ACTIONS(1131),
    [anon_sym_symbol] = ACTIONS(1131),
    [anon_sym_object] = ACTIONS(1131),
    [anon_sym_property] = ACTIONS(1131),
    [anon_sym_signal] = ACTIONS(1131),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_required] = ACTIONS(1131),
    [anon_sym_component] = ACTIONS(1131),
    [sym_html_comment] = ACTIONS(5),
  },
  [580] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2079),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(580),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(2270),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [581] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1473),
    [sym_expression] = STATE(2187),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6272),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1473),
    [sym_subscript_expression] = STATE(1473),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3246),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6274),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(581),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1473),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(541),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_export] = ACTIONS(1415),
    [anon_sym_type] = ACTIONS(1415),
    [anon_sym_namespace] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1437),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1415),
    [anon_sym_let] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1421),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1423),
    [anon_sym_of] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1425),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1427),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1543),
    [anon_sym_using] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1421),
    [anon_sym_void] = ACTIONS(1437),
    [anon_sym_delete] = ACTIONS(1437),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1441),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1415),
    [anon_sym_readonly] = ACTIONS(1415),
    [anon_sym_get] = ACTIONS(1415),
    [anon_sym_set] = ACTIONS(1415),
    [anon_sym_declare] = ACTIONS(1415),
    [anon_sym_public] = ACTIONS(1415),
    [anon_sym_private] = ACTIONS(1415),
    [anon_sym_protected] = ACTIONS(1415),
    [anon_sym_override] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_any] = ACTIONS(1415),
    [anon_sym_number] = ACTIONS(1415),
    [anon_sym_boolean] = ACTIONS(1415),
    [anon_sym_string] = ACTIONS(1415),
    [anon_sym_symbol] = ACTIONS(1415),
    [anon_sym_object] = ACTIONS(1415),
    [anon_sym_property] = ACTIONS(1415),
    [anon_sym_signal] = ACTIONS(1415),
    [anon_sym_on] = ACTIONS(1415),
    [anon_sym_required] = ACTIONS(1415),
    [anon_sym_component] = ACTIONS(1415),
    [sym_html_comment] = ACTIONS(5),
  },
  [582] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1949),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1430),
    [sym_subscript_expression] = STATE(1430),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(4663),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(582),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1430),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(2272),
    [anon_sym_export] = ACTIONS(1495),
    [anon_sym_type] = ACTIONS(1495),
    [anon_sym_namespace] = ACTIONS(1497),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1495),
    [anon_sym_let] = ACTIONS(1495),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(1495),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1501),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(2274),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(2276),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1495),
    [anon_sym_readonly] = ACTIONS(1495),
    [anon_sym_get] = ACTIONS(1495),
    [anon_sym_set] = ACTIONS(1495),
    [anon_sym_declare] = ACTIONS(1495),
    [anon_sym_public] = ACTIONS(1495),
    [anon_sym_private] = ACTIONS(1495),
    [anon_sym_protected] = ACTIONS(1495),
    [anon_sym_override] = ACTIONS(1495),
    [anon_sym_module] = ACTIONS(1495),
    [anon_sym_any] = ACTIONS(1495),
    [anon_sym_number] = ACTIONS(1495),
    [anon_sym_boolean] = ACTIONS(1495),
    [anon_sym_string] = ACTIONS(1495),
    [anon_sym_symbol] = ACTIONS(1495),
    [anon_sym_object] = ACTIONS(1495),
    [anon_sym_property] = ACTIONS(1495),
    [anon_sym_signal] = ACTIONS(1495),
    [anon_sym_on] = ACTIONS(1495),
    [anon_sym_required] = ACTIONS(1495),
    [anon_sym_component] = ACTIONS(1495),
    [sym_html_comment] = ACTIONS(5),
  },
  [583] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1487),
    [sym_expression] = STATE(2409),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1487),
    [sym_subscript_expression] = STATE(1487),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3189),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6145),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(583),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1487),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1131),
    [anon_sym_namespace] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1159),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_let] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_of] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1149),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_using] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1159),
    [anon_sym_delete] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1167),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1131),
    [anon_sym_readonly] = ACTIONS(1131),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_declare] = ACTIONS(1131),
    [anon_sym_public] = ACTIONS(1131),
    [anon_sym_private] = ACTIONS(1131),
    [anon_sym_protected] = ACTIONS(1131),
    [anon_sym_override] = ACTIONS(1131),
    [anon_sym_module] = ACTIONS(1131),
    [anon_sym_any] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_boolean] = ACTIONS(1131),
    [anon_sym_string] = ACTIONS(1131),
    [anon_sym_symbol] = ACTIONS(1131),
    [anon_sym_object] = ACTIONS(1131),
    [anon_sym_property] = ACTIONS(1131),
    [anon_sym_signal] = ACTIONS(1131),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_required] = ACTIONS(1131),
    [anon_sym_component] = ACTIONS(1131),
    [sym_html_comment] = ACTIONS(5),
  },
  [584] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2029),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(584),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [585] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_expression] = STATE(2506),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5939),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(585),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1523),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1555),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_of] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_using] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_property] = ACTIONS(1181),
    [anon_sym_signal] = ACTIONS(1181),
    [anon_sym_on] = ACTIONS(1181),
    [anon_sym_required] = ACTIONS(1181),
    [anon_sym_component] = ACTIONS(1181),
    [sym_html_comment] = ACTIONS(5),
  },
  [586] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1924),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(586),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [587] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_expression] = STATE(2083),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6164),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3271),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6167),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(587),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1451),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(522),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_export] = ACTIONS(1327),
    [anon_sym_type] = ACTIONS(1327),
    [anon_sym_namespace] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1349),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_let] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1333),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_of] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1527),
    [anon_sym_using] = ACTIONS(1343),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_SLASH] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_void] = ACTIONS(1349),
    [anon_sym_delete] = ACTIONS(1349),
    [anon_sym_PLUS_PLUS] = ACTIONS(1351),
    [anon_sym_DASH_DASH] = ACTIONS(1351),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1353),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1327),
    [anon_sym_readonly] = ACTIONS(1327),
    [anon_sym_get] = ACTIONS(1327),
    [anon_sym_set] = ACTIONS(1327),
    [anon_sym_declare] = ACTIONS(1327),
    [anon_sym_public] = ACTIONS(1327),
    [anon_sym_private] = ACTIONS(1327),
    [anon_sym_protected] = ACTIONS(1327),
    [anon_sym_override] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_any] = ACTIONS(1327),
    [anon_sym_number] = ACTIONS(1327),
    [anon_sym_boolean] = ACTIONS(1327),
    [anon_sym_string] = ACTIONS(1327),
    [anon_sym_symbol] = ACTIONS(1327),
    [anon_sym_object] = ACTIONS(1327),
    [anon_sym_property] = ACTIONS(1327),
    [anon_sym_signal] = ACTIONS(1327),
    [anon_sym_on] = ACTIONS(1327),
    [anon_sym_required] = ACTIONS(1327),
    [anon_sym_component] = ACTIONS(1327),
    [sym_html_comment] = ACTIONS(5),
  },
  [588] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_expression] = STATE(2516),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5939),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(588),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1523),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1555),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_of] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_using] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_property] = ACTIONS(1181),
    [anon_sym_signal] = ACTIONS(1181),
    [anon_sym_on] = ACTIONS(1181),
    [anon_sym_required] = ACTIONS(1181),
    [anon_sym_component] = ACTIONS(1181),
    [sym_html_comment] = ACTIONS(5),
  },
  [589] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1375),
    [sym_subscript_expression] = STATE(1375),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(3932),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(589),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1375),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(2278),
    [anon_sym_export] = ACTIONS(1463),
    [anon_sym_type] = ACTIONS(1463),
    [anon_sym_namespace] = ACTIONS(1465),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1463),
    [anon_sym_let] = ACTIONS(1463),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(1463),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1473),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(2280),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(2282),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1463),
    [anon_sym_readonly] = ACTIONS(1463),
    [anon_sym_get] = ACTIONS(1463),
    [anon_sym_set] = ACTIONS(1463),
    [anon_sym_declare] = ACTIONS(1463),
    [anon_sym_public] = ACTIONS(1463),
    [anon_sym_private] = ACTIONS(1463),
    [anon_sym_protected] = ACTIONS(1463),
    [anon_sym_override] = ACTIONS(1463),
    [anon_sym_module] = ACTIONS(1463),
    [anon_sym_any] = ACTIONS(1463),
    [anon_sym_number] = ACTIONS(1463),
    [anon_sym_boolean] = ACTIONS(1463),
    [anon_sym_string] = ACTIONS(1463),
    [anon_sym_symbol] = ACTIONS(1463),
    [anon_sym_object] = ACTIONS(1463),
    [anon_sym_property] = ACTIONS(1463),
    [anon_sym_signal] = ACTIONS(1463),
    [anon_sym_on] = ACTIONS(1463),
    [anon_sym_required] = ACTIONS(1463),
    [anon_sym_component] = ACTIONS(1463),
    [sym_html_comment] = ACTIONS(5),
  },
  [590] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5939),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(590),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1523),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1555),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_of] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_using] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_property] = ACTIONS(1181),
    [anon_sym_signal] = ACTIONS(1181),
    [anon_sym_on] = ACTIONS(1181),
    [anon_sym_required] = ACTIONS(1181),
    [anon_sym_component] = ACTIONS(1181),
    [sym_html_comment] = ACTIONS(5),
  },
  [591] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_expression] = STATE(2647),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5939),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(591),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1523),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1555),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_of] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_using] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_property] = ACTIONS(1181),
    [anon_sym_signal] = ACTIONS(1181),
    [anon_sym_on] = ACTIONS(1181),
    [anon_sym_required] = ACTIONS(1181),
    [anon_sym_component] = ACTIONS(1181),
    [sym_html_comment] = ACTIONS(5),
  },
  [592] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1791),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(592),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(2284),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [593] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1542),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1542),
    [sym_subscript_expression] = STATE(1542),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6090),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(593),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1542),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(2286),
    [anon_sym_export] = ACTIONS(2288),
    [anon_sym_type] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2290),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(2288),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(2292),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(2294),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(2296),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_readonly] = ACTIONS(2288),
    [anon_sym_get] = ACTIONS(2288),
    [anon_sym_set] = ACTIONS(2288),
    [anon_sym_declare] = ACTIONS(2288),
    [anon_sym_public] = ACTIONS(2288),
    [anon_sym_private] = ACTIONS(2288),
    [anon_sym_protected] = ACTIONS(2288),
    [anon_sym_override] = ACTIONS(2288),
    [anon_sym_module] = ACTIONS(2288),
    [anon_sym_any] = ACTIONS(2288),
    [anon_sym_number] = ACTIONS(2288),
    [anon_sym_boolean] = ACTIONS(2288),
    [anon_sym_string] = ACTIONS(2288),
    [anon_sym_symbol] = ACTIONS(2288),
    [anon_sym_object] = ACTIONS(2288),
    [anon_sym_property] = ACTIONS(2288),
    [anon_sym_signal] = ACTIONS(2288),
    [anon_sym_on] = ACTIONS(2288),
    [anon_sym_required] = ACTIONS(2288),
    [anon_sym_component] = ACTIONS(2288),
    [sym_html_comment] = ACTIONS(5),
  },
  [594] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_expression] = STATE(1979),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6164),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3271),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6167),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(594),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1451),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(522),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_export] = ACTIONS(1327),
    [anon_sym_type] = ACTIONS(1327),
    [anon_sym_namespace] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1349),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_let] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1333),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_of] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1527),
    [anon_sym_using] = ACTIONS(1343),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_SLASH] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_void] = ACTIONS(1349),
    [anon_sym_delete] = ACTIONS(1349),
    [anon_sym_PLUS_PLUS] = ACTIONS(1351),
    [anon_sym_DASH_DASH] = ACTIONS(1351),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1353),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1327),
    [anon_sym_readonly] = ACTIONS(1327),
    [anon_sym_get] = ACTIONS(1327),
    [anon_sym_set] = ACTIONS(1327),
    [anon_sym_declare] = ACTIONS(1327),
    [anon_sym_public] = ACTIONS(1327),
    [anon_sym_private] = ACTIONS(1327),
    [anon_sym_protected] = ACTIONS(1327),
    [anon_sym_override] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_any] = ACTIONS(1327),
    [anon_sym_number] = ACTIONS(1327),
    [anon_sym_boolean] = ACTIONS(1327),
    [anon_sym_string] = ACTIONS(1327),
    [anon_sym_symbol] = ACTIONS(1327),
    [anon_sym_object] = ACTIONS(1327),
    [anon_sym_property] = ACTIONS(1327),
    [anon_sym_signal] = ACTIONS(1327),
    [anon_sym_on] = ACTIONS(1327),
    [anon_sym_required] = ACTIONS(1327),
    [anon_sym_component] = ACTIONS(1327),
    [sym_html_comment] = ACTIONS(5),
  },
  [595] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1520),
    [sym_expression] = STATE(2594),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1520),
    [sym_subscript_expression] = STATE(1520),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6049),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(595),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1520),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(556),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1229),
    [anon_sym_namespace] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1229),
    [anon_sym_let] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_of] = ACTIONS(1229),
    [anon_sym_yield] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1551),
    [anon_sym_using] = ACTIONS(1247),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1257),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_readonly] = ACTIONS(1229),
    [anon_sym_get] = ACTIONS(1229),
    [anon_sym_set] = ACTIONS(1229),
    [anon_sym_declare] = ACTIONS(1229),
    [anon_sym_public] = ACTIONS(1229),
    [anon_sym_private] = ACTIONS(1229),
    [anon_sym_protected] = ACTIONS(1229),
    [anon_sym_override] = ACTIONS(1229),
    [anon_sym_module] = ACTIONS(1229),
    [anon_sym_any] = ACTIONS(1229),
    [anon_sym_number] = ACTIONS(1229),
    [anon_sym_boolean] = ACTIONS(1229),
    [anon_sym_string] = ACTIONS(1229),
    [anon_sym_symbol] = ACTIONS(1229),
    [anon_sym_object] = ACTIONS(1229),
    [anon_sym_property] = ACTIONS(1229),
    [anon_sym_signal] = ACTIONS(1229),
    [anon_sym_on] = ACTIONS(1229),
    [anon_sym_required] = ACTIONS(1229),
    [anon_sym_component] = ACTIONS(1229),
    [sym_html_comment] = ACTIONS(5),
  },
  [596] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1473),
    [sym_expression] = STATE(2202),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6272),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1473),
    [sym_subscript_expression] = STATE(1473),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3246),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6274),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(596),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1473),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(541),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_export] = ACTIONS(1415),
    [anon_sym_type] = ACTIONS(1415),
    [anon_sym_namespace] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1437),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1415),
    [anon_sym_let] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1421),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1423),
    [anon_sym_of] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1425),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1427),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1543),
    [anon_sym_using] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1421),
    [anon_sym_void] = ACTIONS(1437),
    [anon_sym_delete] = ACTIONS(1437),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1441),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1415),
    [anon_sym_readonly] = ACTIONS(1415),
    [anon_sym_get] = ACTIONS(1415),
    [anon_sym_set] = ACTIONS(1415),
    [anon_sym_declare] = ACTIONS(1415),
    [anon_sym_public] = ACTIONS(1415),
    [anon_sym_private] = ACTIONS(1415),
    [anon_sym_protected] = ACTIONS(1415),
    [anon_sym_override] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_any] = ACTIONS(1415),
    [anon_sym_number] = ACTIONS(1415),
    [anon_sym_boolean] = ACTIONS(1415),
    [anon_sym_string] = ACTIONS(1415),
    [anon_sym_symbol] = ACTIONS(1415),
    [anon_sym_object] = ACTIONS(1415),
    [anon_sym_property] = ACTIONS(1415),
    [anon_sym_signal] = ACTIONS(1415),
    [anon_sym_on] = ACTIONS(1415),
    [anon_sym_required] = ACTIONS(1415),
    [anon_sym_component] = ACTIONS(1415),
    [sym_html_comment] = ACTIONS(5),
  },
  [597] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(2713),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5957),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(597),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_type] = ACTIONS(861),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(873),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_readonly] = ACTIONS(861),
    [anon_sym_get] = ACTIONS(861),
    [anon_sym_set] = ACTIONS(861),
    [anon_sym_declare] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_protected] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_module] = ACTIONS(861),
    [anon_sym_any] = ACTIONS(861),
    [anon_sym_number] = ACTIONS(861),
    [anon_sym_boolean] = ACTIONS(861),
    [anon_sym_string] = ACTIONS(861),
    [anon_sym_symbol] = ACTIONS(861),
    [anon_sym_object] = ACTIONS(861),
    [anon_sym_property] = ACTIONS(861),
    [anon_sym_signal] = ACTIONS(861),
    [anon_sym_on] = ACTIONS(861),
    [anon_sym_required] = ACTIONS(861),
    [anon_sym_component] = ACTIONS(861),
    [sym_html_comment] = ACTIONS(5),
  },
  [598] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1473),
    [sym_expression] = STATE(2209),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6272),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1473),
    [sym_subscript_expression] = STATE(1473),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3246),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6274),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(598),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1473),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(541),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_export] = ACTIONS(1415),
    [anon_sym_type] = ACTIONS(1415),
    [anon_sym_namespace] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1437),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1415),
    [anon_sym_let] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1421),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1423),
    [anon_sym_of] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1425),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1427),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1543),
    [anon_sym_using] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1421),
    [anon_sym_void] = ACTIONS(1437),
    [anon_sym_delete] = ACTIONS(1437),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1441),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1415),
    [anon_sym_readonly] = ACTIONS(1415),
    [anon_sym_get] = ACTIONS(1415),
    [anon_sym_set] = ACTIONS(1415),
    [anon_sym_declare] = ACTIONS(1415),
    [anon_sym_public] = ACTIONS(1415),
    [anon_sym_private] = ACTIONS(1415),
    [anon_sym_protected] = ACTIONS(1415),
    [anon_sym_override] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_any] = ACTIONS(1415),
    [anon_sym_number] = ACTIONS(1415),
    [anon_sym_boolean] = ACTIONS(1415),
    [anon_sym_string] = ACTIONS(1415),
    [anon_sym_symbol] = ACTIONS(1415),
    [anon_sym_object] = ACTIONS(1415),
    [anon_sym_property] = ACTIONS(1415),
    [anon_sym_signal] = ACTIONS(1415),
    [anon_sym_on] = ACTIONS(1415),
    [anon_sym_required] = ACTIONS(1415),
    [anon_sym_component] = ACTIONS(1415),
    [sym_html_comment] = ACTIONS(5),
  },
  [599] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1513),
    [sym_expression] = STATE(2500),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6293),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1513),
    [sym_subscript_expression] = STATE(1513),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3245),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6295),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(599),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1513),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(455),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1565),
    [anon_sym_export] = ACTIONS(1379),
    [anon_sym_type] = ACTIONS(1379),
    [anon_sym_namespace] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1379),
    [anon_sym_let] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1385),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_of] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1389),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1391),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_using] = ACTIONS(1395),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_void] = ACTIONS(1401),
    [anon_sym_delete] = ACTIONS(1401),
    [anon_sym_PLUS_PLUS] = ACTIONS(1403),
    [anon_sym_DASH_DASH] = ACTIONS(1403),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1405),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1571),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1379),
    [anon_sym_readonly] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(1379),
    [anon_sym_set] = ACTIONS(1379),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_public] = ACTIONS(1379),
    [anon_sym_private] = ACTIONS(1379),
    [anon_sym_protected] = ACTIONS(1379),
    [anon_sym_override] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1379),
    [anon_sym_any] = ACTIONS(1379),
    [anon_sym_number] = ACTIONS(1379),
    [anon_sym_boolean] = ACTIONS(1379),
    [anon_sym_string] = ACTIONS(1379),
    [anon_sym_symbol] = ACTIONS(1379),
    [anon_sym_object] = ACTIONS(1379),
    [anon_sym_property] = ACTIONS(1379),
    [anon_sym_signal] = ACTIONS(1379),
    [anon_sym_on] = ACTIONS(1379),
    [anon_sym_required] = ACTIONS(1379),
    [anon_sym_component] = ACTIONS(1379),
    [sym_html_comment] = ACTIONS(5),
  },
  [600] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1520),
    [sym_expression] = STATE(2592),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5948),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1520),
    [sym_subscript_expression] = STATE(1520),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6049),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(600),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1520),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(556),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1229),
    [anon_sym_namespace] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1229),
    [anon_sym_let] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_of] = ACTIONS(1229),
    [anon_sym_yield] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1551),
    [anon_sym_using] = ACTIONS(1247),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1257),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1229),
    [anon_sym_readonly] = ACTIONS(1229),
    [anon_sym_get] = ACTIONS(1229),
    [anon_sym_set] = ACTIONS(1229),
    [anon_sym_declare] = ACTIONS(1229),
    [anon_sym_public] = ACTIONS(1229),
    [anon_sym_private] = ACTIONS(1229),
    [anon_sym_protected] = ACTIONS(1229),
    [anon_sym_override] = ACTIONS(1229),
    [anon_sym_module] = ACTIONS(1229),
    [anon_sym_any] = ACTIONS(1229),
    [anon_sym_number] = ACTIONS(1229),
    [anon_sym_boolean] = ACTIONS(1229),
    [anon_sym_string] = ACTIONS(1229),
    [anon_sym_symbol] = ACTIONS(1229),
    [anon_sym_object] = ACTIONS(1229),
    [anon_sym_property] = ACTIONS(1229),
    [anon_sym_signal] = ACTIONS(1229),
    [anon_sym_on] = ACTIONS(1229),
    [anon_sym_required] = ACTIONS(1229),
    [anon_sym_component] = ACTIONS(1229),
    [sym_html_comment] = ACTIONS(5),
  },
  [601] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_expression] = STATE(1950),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6164),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3271),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6167),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(601),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1451),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(522),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_export] = ACTIONS(1327),
    [anon_sym_type] = ACTIONS(1327),
    [anon_sym_namespace] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1349),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_let] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1333),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_of] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1527),
    [anon_sym_using] = ACTIONS(1343),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_SLASH] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_void] = ACTIONS(1349),
    [anon_sym_delete] = ACTIONS(1349),
    [anon_sym_PLUS_PLUS] = ACTIONS(1351),
    [anon_sym_DASH_DASH] = ACTIONS(1351),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1353),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1327),
    [anon_sym_readonly] = ACTIONS(1327),
    [anon_sym_get] = ACTIONS(1327),
    [anon_sym_set] = ACTIONS(1327),
    [anon_sym_declare] = ACTIONS(1327),
    [anon_sym_public] = ACTIONS(1327),
    [anon_sym_private] = ACTIONS(1327),
    [anon_sym_protected] = ACTIONS(1327),
    [anon_sym_override] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_any] = ACTIONS(1327),
    [anon_sym_number] = ACTIONS(1327),
    [anon_sym_boolean] = ACTIONS(1327),
    [anon_sym_string] = ACTIONS(1327),
    [anon_sym_symbol] = ACTIONS(1327),
    [anon_sym_object] = ACTIONS(1327),
    [anon_sym_property] = ACTIONS(1327),
    [anon_sym_signal] = ACTIONS(1327),
    [anon_sym_on] = ACTIONS(1327),
    [anon_sym_required] = ACTIONS(1327),
    [anon_sym_component] = ACTIONS(1327),
    [sym_html_comment] = ACTIONS(5),
  },
  [602] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_expression] = STATE(2617),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5939),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(602),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1523),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1555),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_of] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_using] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_property] = ACTIONS(1181),
    [anon_sym_signal] = ACTIONS(1181),
    [anon_sym_on] = ACTIONS(1181),
    [anon_sym_required] = ACTIONS(1181),
    [anon_sym_component] = ACTIONS(1181),
    [sym_html_comment] = ACTIONS(5),
  },
  [603] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1927),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(603),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [604] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1473),
    [sym_expression] = STATE(2171),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6272),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1473),
    [sym_subscript_expression] = STATE(1473),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3246),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6274),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(604),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1473),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(541),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_export] = ACTIONS(1415),
    [anon_sym_type] = ACTIONS(1415),
    [anon_sym_namespace] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1437),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1415),
    [anon_sym_let] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1421),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1423),
    [anon_sym_of] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1425),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1427),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1543),
    [anon_sym_using] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1421),
    [anon_sym_void] = ACTIONS(1437),
    [anon_sym_delete] = ACTIONS(1437),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1441),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1415),
    [anon_sym_readonly] = ACTIONS(1415),
    [anon_sym_get] = ACTIONS(1415),
    [anon_sym_set] = ACTIONS(1415),
    [anon_sym_declare] = ACTIONS(1415),
    [anon_sym_public] = ACTIONS(1415),
    [anon_sym_private] = ACTIONS(1415),
    [anon_sym_protected] = ACTIONS(1415),
    [anon_sym_override] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_any] = ACTIONS(1415),
    [anon_sym_number] = ACTIONS(1415),
    [anon_sym_boolean] = ACTIONS(1415),
    [anon_sym_string] = ACTIONS(1415),
    [anon_sym_symbol] = ACTIONS(1415),
    [anon_sym_object] = ACTIONS(1415),
    [anon_sym_property] = ACTIONS(1415),
    [anon_sym_signal] = ACTIONS(1415),
    [anon_sym_on] = ACTIONS(1415),
    [anon_sym_required] = ACTIONS(1415),
    [anon_sym_component] = ACTIONS(1415),
    [sym_html_comment] = ACTIONS(5),
  },
  [605] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1513),
    [sym_expression] = STATE(2675),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6293),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1513),
    [sym_subscript_expression] = STATE(1513),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3245),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6295),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(605),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1513),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(455),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1565),
    [anon_sym_export] = ACTIONS(1379),
    [anon_sym_type] = ACTIONS(1379),
    [anon_sym_namespace] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1379),
    [anon_sym_let] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1385),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_of] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1389),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1391),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_using] = ACTIONS(1395),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_void] = ACTIONS(1401),
    [anon_sym_delete] = ACTIONS(1401),
    [anon_sym_PLUS_PLUS] = ACTIONS(1403),
    [anon_sym_DASH_DASH] = ACTIONS(1403),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1405),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1571),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1379),
    [anon_sym_readonly] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(1379),
    [anon_sym_set] = ACTIONS(1379),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_public] = ACTIONS(1379),
    [anon_sym_private] = ACTIONS(1379),
    [anon_sym_protected] = ACTIONS(1379),
    [anon_sym_override] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1379),
    [anon_sym_any] = ACTIONS(1379),
    [anon_sym_number] = ACTIONS(1379),
    [anon_sym_boolean] = ACTIONS(1379),
    [anon_sym_string] = ACTIONS(1379),
    [anon_sym_symbol] = ACTIONS(1379),
    [anon_sym_object] = ACTIONS(1379),
    [anon_sym_property] = ACTIONS(1379),
    [anon_sym_signal] = ACTIONS(1379),
    [anon_sym_on] = ACTIONS(1379),
    [anon_sym_required] = ACTIONS(1379),
    [anon_sym_component] = ACTIONS(1379),
    [sym_html_comment] = ACTIONS(5),
  },
  [606] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1473),
    [sym_expression] = STATE(2131),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6272),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1473),
    [sym_subscript_expression] = STATE(1473),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3246),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6274),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(606),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1473),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(541),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_export] = ACTIONS(1415),
    [anon_sym_type] = ACTIONS(1415),
    [anon_sym_namespace] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1437),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1415),
    [anon_sym_let] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1421),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1423),
    [anon_sym_of] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1425),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1427),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1543),
    [anon_sym_using] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1421),
    [anon_sym_void] = ACTIONS(1437),
    [anon_sym_delete] = ACTIONS(1437),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1441),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1415),
    [anon_sym_readonly] = ACTIONS(1415),
    [anon_sym_get] = ACTIONS(1415),
    [anon_sym_set] = ACTIONS(1415),
    [anon_sym_declare] = ACTIONS(1415),
    [anon_sym_public] = ACTIONS(1415),
    [anon_sym_private] = ACTIONS(1415),
    [anon_sym_protected] = ACTIONS(1415),
    [anon_sym_override] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_any] = ACTIONS(1415),
    [anon_sym_number] = ACTIONS(1415),
    [anon_sym_boolean] = ACTIONS(1415),
    [anon_sym_string] = ACTIONS(1415),
    [anon_sym_symbol] = ACTIONS(1415),
    [anon_sym_object] = ACTIONS(1415),
    [anon_sym_property] = ACTIONS(1415),
    [anon_sym_signal] = ACTIONS(1415),
    [anon_sym_on] = ACTIONS(1415),
    [anon_sym_required] = ACTIONS(1415),
    [anon_sym_component] = ACTIONS(1415),
    [sym_html_comment] = ACTIONS(5),
  },
  [607] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1925),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(607),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [608] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1923),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(608),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [609] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1487),
    [sym_expression] = STATE(2310),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1487),
    [sym_subscript_expression] = STATE(1487),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3189),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6145),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(609),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1487),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1131),
    [anon_sym_namespace] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1159),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_let] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_of] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1149),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_using] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1159),
    [anon_sym_delete] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1167),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1131),
    [anon_sym_readonly] = ACTIONS(1131),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_declare] = ACTIONS(1131),
    [anon_sym_public] = ACTIONS(1131),
    [anon_sym_private] = ACTIONS(1131),
    [anon_sym_protected] = ACTIONS(1131),
    [anon_sym_override] = ACTIONS(1131),
    [anon_sym_module] = ACTIONS(1131),
    [anon_sym_any] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_boolean] = ACTIONS(1131),
    [anon_sym_string] = ACTIONS(1131),
    [anon_sym_symbol] = ACTIONS(1131),
    [anon_sym_object] = ACTIONS(1131),
    [anon_sym_property] = ACTIONS(1131),
    [anon_sym_signal] = ACTIONS(1131),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_required] = ACTIONS(1131),
    [anon_sym_component] = ACTIONS(1131),
    [sym_html_comment] = ACTIONS(5),
  },
  [610] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1989),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(610),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [611] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_expression] = STATE(1974),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6164),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3271),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6167),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(611),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1451),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(522),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_export] = ACTIONS(1327),
    [anon_sym_type] = ACTIONS(1327),
    [anon_sym_namespace] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1349),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_let] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1333),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_of] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1527),
    [anon_sym_using] = ACTIONS(1343),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_SLASH] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_void] = ACTIONS(1349),
    [anon_sym_delete] = ACTIONS(1349),
    [anon_sym_PLUS_PLUS] = ACTIONS(1351),
    [anon_sym_DASH_DASH] = ACTIONS(1351),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1353),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1327),
    [anon_sym_readonly] = ACTIONS(1327),
    [anon_sym_get] = ACTIONS(1327),
    [anon_sym_set] = ACTIONS(1327),
    [anon_sym_declare] = ACTIONS(1327),
    [anon_sym_public] = ACTIONS(1327),
    [anon_sym_private] = ACTIONS(1327),
    [anon_sym_protected] = ACTIONS(1327),
    [anon_sym_override] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_any] = ACTIONS(1327),
    [anon_sym_number] = ACTIONS(1327),
    [anon_sym_boolean] = ACTIONS(1327),
    [anon_sym_string] = ACTIONS(1327),
    [anon_sym_symbol] = ACTIONS(1327),
    [anon_sym_object] = ACTIONS(1327),
    [anon_sym_property] = ACTIONS(1327),
    [anon_sym_signal] = ACTIONS(1327),
    [anon_sym_on] = ACTIONS(1327),
    [anon_sym_required] = ACTIONS(1327),
    [anon_sym_component] = ACTIONS(1327),
    [sym_html_comment] = ACTIONS(5),
  },
  [612] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1922),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(612),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [613] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1921),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(613),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [614] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1473),
    [sym_expression] = STATE(2110),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6272),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1473),
    [sym_subscript_expression] = STATE(1473),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3246),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6274),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(614),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1473),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(541),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_export] = ACTIONS(1415),
    [anon_sym_type] = ACTIONS(1415),
    [anon_sym_namespace] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1437),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1415),
    [anon_sym_let] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1421),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1423),
    [anon_sym_of] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1425),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1427),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1543),
    [anon_sym_using] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1421),
    [anon_sym_void] = ACTIONS(1437),
    [anon_sym_delete] = ACTIONS(1437),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(2208),
    [sym_private_property_identifier] = ACTIONS(1441),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1415),
    [anon_sym_readonly] = ACTIONS(1415),
    [anon_sym_get] = ACTIONS(1415),
    [anon_sym_set] = ACTIONS(1415),
    [anon_sym_declare] = ACTIONS(1415),
    [anon_sym_public] = ACTIONS(1415),
    [anon_sym_private] = ACTIONS(1415),
    [anon_sym_protected] = ACTIONS(1415),
    [anon_sym_override] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_any] = ACTIONS(1415),
    [anon_sym_number] = ACTIONS(1415),
    [anon_sym_boolean] = ACTIONS(1415),
    [anon_sym_string] = ACTIONS(1415),
    [anon_sym_symbol] = ACTIONS(1415),
    [anon_sym_object] = ACTIONS(1415),
    [anon_sym_property] = ACTIONS(1415),
    [anon_sym_signal] = ACTIONS(1415),
    [anon_sym_on] = ACTIONS(1415),
    [anon_sym_required] = ACTIONS(1415),
    [anon_sym_component] = ACTIONS(1415),
    [sym_html_comment] = ACTIONS(5),
  },
  [615] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(1999),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(615),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [616] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2162),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(616),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [617] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_expression] = STATE(2076),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6164),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3271),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6167),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(617),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1451),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(522),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_export] = ACTIONS(1327),
    [anon_sym_type] = ACTIONS(1327),
    [anon_sym_namespace] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1349),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_let] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1333),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_of] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1527),
    [anon_sym_using] = ACTIONS(1343),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_SLASH] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_void] = ACTIONS(1349),
    [anon_sym_delete] = ACTIONS(1349),
    [anon_sym_PLUS_PLUS] = ACTIONS(1351),
    [anon_sym_DASH_DASH] = ACTIONS(1351),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1353),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1327),
    [anon_sym_readonly] = ACTIONS(1327),
    [anon_sym_get] = ACTIONS(1327),
    [anon_sym_set] = ACTIONS(1327),
    [anon_sym_declare] = ACTIONS(1327),
    [anon_sym_public] = ACTIONS(1327),
    [anon_sym_private] = ACTIONS(1327),
    [anon_sym_protected] = ACTIONS(1327),
    [anon_sym_override] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_any] = ACTIONS(1327),
    [anon_sym_number] = ACTIONS(1327),
    [anon_sym_boolean] = ACTIONS(1327),
    [anon_sym_string] = ACTIONS(1327),
    [anon_sym_symbol] = ACTIONS(1327),
    [anon_sym_object] = ACTIONS(1327),
    [anon_sym_property] = ACTIONS(1327),
    [anon_sym_signal] = ACTIONS(1327),
    [anon_sym_on] = ACTIONS(1327),
    [anon_sym_required] = ACTIONS(1327),
    [anon_sym_component] = ACTIONS(1327),
    [sym_html_comment] = ACTIONS(5),
  },
  [618] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_expression] = STATE(2077),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6164),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3271),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6167),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(618),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1451),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(522),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_export] = ACTIONS(1327),
    [anon_sym_type] = ACTIONS(1327),
    [anon_sym_namespace] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1349),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_let] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1333),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_of] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1527),
    [anon_sym_using] = ACTIONS(1343),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_SLASH] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_void] = ACTIONS(1349),
    [anon_sym_delete] = ACTIONS(1349),
    [anon_sym_PLUS_PLUS] = ACTIONS(1351),
    [anon_sym_DASH_DASH] = ACTIONS(1351),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1353),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1327),
    [anon_sym_readonly] = ACTIONS(1327),
    [anon_sym_get] = ACTIONS(1327),
    [anon_sym_set] = ACTIONS(1327),
    [anon_sym_declare] = ACTIONS(1327),
    [anon_sym_public] = ACTIONS(1327),
    [anon_sym_private] = ACTIONS(1327),
    [anon_sym_protected] = ACTIONS(1327),
    [anon_sym_override] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_any] = ACTIONS(1327),
    [anon_sym_number] = ACTIONS(1327),
    [anon_sym_boolean] = ACTIONS(1327),
    [anon_sym_string] = ACTIONS(1327),
    [anon_sym_symbol] = ACTIONS(1327),
    [anon_sym_object] = ACTIONS(1327),
    [anon_sym_property] = ACTIONS(1327),
    [anon_sym_signal] = ACTIONS(1327),
    [anon_sym_on] = ACTIONS(1327),
    [anon_sym_required] = ACTIONS(1327),
    [anon_sym_component] = ACTIONS(1327),
    [sym_html_comment] = ACTIONS(5),
  },
  [619] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1871),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(619),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [620] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_expression] = STATE(2084),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6164),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3271),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6167),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(620),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1451),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(522),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_export] = ACTIONS(1327),
    [anon_sym_type] = ACTIONS(1327),
    [anon_sym_namespace] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1349),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_let] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1333),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_of] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1527),
    [anon_sym_using] = ACTIONS(1343),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_SLASH] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_void] = ACTIONS(1349),
    [anon_sym_delete] = ACTIONS(1349),
    [anon_sym_PLUS_PLUS] = ACTIONS(1351),
    [anon_sym_DASH_DASH] = ACTIONS(1351),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(2270),
    [sym_private_property_identifier] = ACTIONS(1353),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1327),
    [anon_sym_readonly] = ACTIONS(1327),
    [anon_sym_get] = ACTIONS(1327),
    [anon_sym_set] = ACTIONS(1327),
    [anon_sym_declare] = ACTIONS(1327),
    [anon_sym_public] = ACTIONS(1327),
    [anon_sym_private] = ACTIONS(1327),
    [anon_sym_protected] = ACTIONS(1327),
    [anon_sym_override] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_any] = ACTIONS(1327),
    [anon_sym_number] = ACTIONS(1327),
    [anon_sym_boolean] = ACTIONS(1327),
    [anon_sym_string] = ACTIONS(1327),
    [anon_sym_symbol] = ACTIONS(1327),
    [anon_sym_object] = ACTIONS(1327),
    [anon_sym_property] = ACTIONS(1327),
    [anon_sym_signal] = ACTIONS(1327),
    [anon_sym_on] = ACTIONS(1327),
    [anon_sym_required] = ACTIONS(1327),
    [anon_sym_component] = ACTIONS(1327),
    [sym_html_comment] = ACTIONS(5),
  },
  [621] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1473),
    [sym_expression] = STATE(2170),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6272),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1473),
    [sym_subscript_expression] = STATE(1473),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3246),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6274),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(621),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1473),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(541),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_export] = ACTIONS(1415),
    [anon_sym_type] = ACTIONS(1415),
    [anon_sym_namespace] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1437),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1415),
    [anon_sym_let] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1421),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1423),
    [anon_sym_of] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1425),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1427),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1543),
    [anon_sym_using] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1421),
    [anon_sym_void] = ACTIONS(1437),
    [anon_sym_delete] = ACTIONS(1437),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1441),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1415),
    [anon_sym_readonly] = ACTIONS(1415),
    [anon_sym_get] = ACTIONS(1415),
    [anon_sym_set] = ACTIONS(1415),
    [anon_sym_declare] = ACTIONS(1415),
    [anon_sym_public] = ACTIONS(1415),
    [anon_sym_private] = ACTIONS(1415),
    [anon_sym_protected] = ACTIONS(1415),
    [anon_sym_override] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_any] = ACTIONS(1415),
    [anon_sym_number] = ACTIONS(1415),
    [anon_sym_boolean] = ACTIONS(1415),
    [anon_sym_string] = ACTIONS(1415),
    [anon_sym_symbol] = ACTIONS(1415),
    [anon_sym_object] = ACTIONS(1415),
    [anon_sym_property] = ACTIONS(1415),
    [anon_sym_signal] = ACTIONS(1415),
    [anon_sym_on] = ACTIONS(1415),
    [anon_sym_required] = ACTIONS(1415),
    [anon_sym_component] = ACTIONS(1415),
    [sym_html_comment] = ACTIONS(5),
  },
  [622] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_expression] = STATE(2073),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6164),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3271),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6167),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(622),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1451),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(522),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_export] = ACTIONS(1327),
    [anon_sym_type] = ACTIONS(1327),
    [anon_sym_namespace] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1349),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_let] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1333),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_of] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1527),
    [anon_sym_using] = ACTIONS(1343),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_SLASH] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_void] = ACTIONS(1349),
    [anon_sym_delete] = ACTIONS(1349),
    [anon_sym_PLUS_PLUS] = ACTIONS(1351),
    [anon_sym_DASH_DASH] = ACTIONS(1351),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1353),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1327),
    [anon_sym_readonly] = ACTIONS(1327),
    [anon_sym_get] = ACTIONS(1327),
    [anon_sym_set] = ACTIONS(1327),
    [anon_sym_declare] = ACTIONS(1327),
    [anon_sym_public] = ACTIONS(1327),
    [anon_sym_private] = ACTIONS(1327),
    [anon_sym_protected] = ACTIONS(1327),
    [anon_sym_override] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_any] = ACTIONS(1327),
    [anon_sym_number] = ACTIONS(1327),
    [anon_sym_boolean] = ACTIONS(1327),
    [anon_sym_string] = ACTIONS(1327),
    [anon_sym_symbol] = ACTIONS(1327),
    [anon_sym_object] = ACTIONS(1327),
    [anon_sym_property] = ACTIONS(1327),
    [anon_sym_signal] = ACTIONS(1327),
    [anon_sym_on] = ACTIONS(1327),
    [anon_sym_required] = ACTIONS(1327),
    [anon_sym_component] = ACTIONS(1327),
    [sym_html_comment] = ACTIONS(5),
  },
  [623] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1473),
    [sym_expression] = STATE(2166),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6272),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1473),
    [sym_subscript_expression] = STATE(1473),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3246),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6274),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(623),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1473),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(541),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_export] = ACTIONS(1415),
    [anon_sym_type] = ACTIONS(1415),
    [anon_sym_namespace] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1437),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1415),
    [anon_sym_let] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1421),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1423),
    [anon_sym_of] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1425),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1427),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1543),
    [anon_sym_using] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1421),
    [anon_sym_void] = ACTIONS(1437),
    [anon_sym_delete] = ACTIONS(1437),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1441),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1415),
    [anon_sym_readonly] = ACTIONS(1415),
    [anon_sym_get] = ACTIONS(1415),
    [anon_sym_set] = ACTIONS(1415),
    [anon_sym_declare] = ACTIONS(1415),
    [anon_sym_public] = ACTIONS(1415),
    [anon_sym_private] = ACTIONS(1415),
    [anon_sym_protected] = ACTIONS(1415),
    [anon_sym_override] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_any] = ACTIONS(1415),
    [anon_sym_number] = ACTIONS(1415),
    [anon_sym_boolean] = ACTIONS(1415),
    [anon_sym_string] = ACTIONS(1415),
    [anon_sym_symbol] = ACTIONS(1415),
    [anon_sym_object] = ACTIONS(1415),
    [anon_sym_property] = ACTIONS(1415),
    [anon_sym_signal] = ACTIONS(1415),
    [anon_sym_on] = ACTIONS(1415),
    [anon_sym_required] = ACTIONS(1415),
    [anon_sym_component] = ACTIONS(1415),
    [sym_html_comment] = ACTIONS(5),
  },
  [624] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1513),
    [sym_expression] = STATE(2531),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6293),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1513),
    [sym_subscript_expression] = STATE(1513),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3245),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6295),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(624),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1513),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(455),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1565),
    [anon_sym_export] = ACTIONS(1379),
    [anon_sym_type] = ACTIONS(1379),
    [anon_sym_namespace] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1379),
    [anon_sym_let] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1385),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_of] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1389),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1391),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_using] = ACTIONS(1395),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_void] = ACTIONS(1401),
    [anon_sym_delete] = ACTIONS(1401),
    [anon_sym_PLUS_PLUS] = ACTIONS(1403),
    [anon_sym_DASH_DASH] = ACTIONS(1403),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1405),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1571),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1379),
    [anon_sym_readonly] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(1379),
    [anon_sym_set] = ACTIONS(1379),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_public] = ACTIONS(1379),
    [anon_sym_private] = ACTIONS(1379),
    [anon_sym_protected] = ACTIONS(1379),
    [anon_sym_override] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1379),
    [anon_sym_any] = ACTIONS(1379),
    [anon_sym_number] = ACTIONS(1379),
    [anon_sym_boolean] = ACTIONS(1379),
    [anon_sym_string] = ACTIONS(1379),
    [anon_sym_symbol] = ACTIONS(1379),
    [anon_sym_object] = ACTIONS(1379),
    [anon_sym_property] = ACTIONS(1379),
    [anon_sym_signal] = ACTIONS(1379),
    [anon_sym_on] = ACTIONS(1379),
    [anon_sym_required] = ACTIONS(1379),
    [anon_sym_component] = ACTIONS(1379),
    [sym_html_comment] = ACTIONS(5),
  },
  [625] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1513),
    [sym_expression] = STATE(2549),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6293),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1513),
    [sym_subscript_expression] = STATE(1513),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3245),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6295),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(625),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1513),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(455),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1565),
    [anon_sym_export] = ACTIONS(1379),
    [anon_sym_type] = ACTIONS(1379),
    [anon_sym_namespace] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1379),
    [anon_sym_let] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1385),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_of] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1389),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1391),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_using] = ACTIONS(1395),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_void] = ACTIONS(1401),
    [anon_sym_delete] = ACTIONS(1401),
    [anon_sym_PLUS_PLUS] = ACTIONS(1403),
    [anon_sym_DASH_DASH] = ACTIONS(1403),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1405),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1571),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1379),
    [anon_sym_readonly] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(1379),
    [anon_sym_set] = ACTIONS(1379),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_public] = ACTIONS(1379),
    [anon_sym_private] = ACTIONS(1379),
    [anon_sym_protected] = ACTIONS(1379),
    [anon_sym_override] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1379),
    [anon_sym_any] = ACTIONS(1379),
    [anon_sym_number] = ACTIONS(1379),
    [anon_sym_boolean] = ACTIONS(1379),
    [anon_sym_string] = ACTIONS(1379),
    [anon_sym_symbol] = ACTIONS(1379),
    [anon_sym_object] = ACTIONS(1379),
    [anon_sym_property] = ACTIONS(1379),
    [anon_sym_signal] = ACTIONS(1379),
    [anon_sym_on] = ACTIONS(1379),
    [anon_sym_required] = ACTIONS(1379),
    [anon_sym_component] = ACTIONS(1379),
    [sym_html_comment] = ACTIONS(5),
  },
  [626] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1473),
    [sym_expression] = STATE(2161),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6272),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1473),
    [sym_subscript_expression] = STATE(1473),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3246),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6274),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(626),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1473),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(541),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_export] = ACTIONS(1415),
    [anon_sym_type] = ACTIONS(1415),
    [anon_sym_namespace] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1437),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1415),
    [anon_sym_let] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1421),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1423),
    [anon_sym_of] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1425),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1427),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1543),
    [anon_sym_using] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1421),
    [anon_sym_void] = ACTIONS(1437),
    [anon_sym_delete] = ACTIONS(1437),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1441),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1415),
    [anon_sym_readonly] = ACTIONS(1415),
    [anon_sym_get] = ACTIONS(1415),
    [anon_sym_set] = ACTIONS(1415),
    [anon_sym_declare] = ACTIONS(1415),
    [anon_sym_public] = ACTIONS(1415),
    [anon_sym_private] = ACTIONS(1415),
    [anon_sym_protected] = ACTIONS(1415),
    [anon_sym_override] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_any] = ACTIONS(1415),
    [anon_sym_number] = ACTIONS(1415),
    [anon_sym_boolean] = ACTIONS(1415),
    [anon_sym_string] = ACTIONS(1415),
    [anon_sym_symbol] = ACTIONS(1415),
    [anon_sym_object] = ACTIONS(1415),
    [anon_sym_property] = ACTIONS(1415),
    [anon_sym_signal] = ACTIONS(1415),
    [anon_sym_on] = ACTIONS(1415),
    [anon_sym_required] = ACTIONS(1415),
    [anon_sym_component] = ACTIONS(1415),
    [sym_html_comment] = ACTIONS(5),
  },
  [627] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_expression] = STATE(2084),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6164),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3271),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6167),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(627),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1451),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(522),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_export] = ACTIONS(1327),
    [anon_sym_type] = ACTIONS(1327),
    [anon_sym_namespace] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1349),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_let] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1333),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_of] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1527),
    [anon_sym_using] = ACTIONS(1343),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_SLASH] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_void] = ACTIONS(1349),
    [anon_sym_delete] = ACTIONS(1349),
    [anon_sym_PLUS_PLUS] = ACTIONS(1351),
    [anon_sym_DASH_DASH] = ACTIONS(1351),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1353),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1327),
    [anon_sym_readonly] = ACTIONS(1327),
    [anon_sym_get] = ACTIONS(1327),
    [anon_sym_set] = ACTIONS(1327),
    [anon_sym_declare] = ACTIONS(1327),
    [anon_sym_public] = ACTIONS(1327),
    [anon_sym_private] = ACTIONS(1327),
    [anon_sym_protected] = ACTIONS(1327),
    [anon_sym_override] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_any] = ACTIONS(1327),
    [anon_sym_number] = ACTIONS(1327),
    [anon_sym_boolean] = ACTIONS(1327),
    [anon_sym_string] = ACTIONS(1327),
    [anon_sym_symbol] = ACTIONS(1327),
    [anon_sym_object] = ACTIONS(1327),
    [anon_sym_property] = ACTIONS(1327),
    [anon_sym_signal] = ACTIONS(1327),
    [anon_sym_on] = ACTIONS(1327),
    [anon_sym_required] = ACTIONS(1327),
    [anon_sym_component] = ACTIONS(1327),
    [sym_html_comment] = ACTIONS(5),
  },
  [628] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1473),
    [sym_expression] = STATE(2158),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6272),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1473),
    [sym_subscript_expression] = STATE(1473),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3246),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6274),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(628),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1473),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(541),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_export] = ACTIONS(1415),
    [anon_sym_type] = ACTIONS(1415),
    [anon_sym_namespace] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1437),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1415),
    [anon_sym_let] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1421),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1423),
    [anon_sym_of] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1425),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1427),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1543),
    [anon_sym_using] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1421),
    [anon_sym_void] = ACTIONS(1437),
    [anon_sym_delete] = ACTIONS(1437),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1441),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1415),
    [anon_sym_readonly] = ACTIONS(1415),
    [anon_sym_get] = ACTIONS(1415),
    [anon_sym_set] = ACTIONS(1415),
    [anon_sym_declare] = ACTIONS(1415),
    [anon_sym_public] = ACTIONS(1415),
    [anon_sym_private] = ACTIONS(1415),
    [anon_sym_protected] = ACTIONS(1415),
    [anon_sym_override] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_any] = ACTIONS(1415),
    [anon_sym_number] = ACTIONS(1415),
    [anon_sym_boolean] = ACTIONS(1415),
    [anon_sym_string] = ACTIONS(1415),
    [anon_sym_symbol] = ACTIONS(1415),
    [anon_sym_object] = ACTIONS(1415),
    [anon_sym_property] = ACTIONS(1415),
    [anon_sym_signal] = ACTIONS(1415),
    [anon_sym_on] = ACTIONS(1415),
    [anon_sym_required] = ACTIONS(1415),
    [anon_sym_component] = ACTIONS(1415),
    [sym_html_comment] = ACTIONS(5),
  },
  [629] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(629),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [630] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1543),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(5956),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1543),
    [sym_subscript_expression] = STATE(1543),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3237),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6060),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(630),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1543),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(540),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(2298),
    [anon_sym_export] = ACTIONS(2300),
    [anon_sym_type] = ACTIONS(2300),
    [anon_sym_namespace] = ACTIONS(2302),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(95),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(2300),
    [anon_sym_let] = ACTIONS(2300),
    [anon_sym_BANG] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(50),
    [anon_sym_of] = ACTIONS(2300),
    [anon_sym_yield] = ACTIONS(52),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(2304),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(2306),
    [anon_sym_using] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_void] = ACTIONS(95),
    [anon_sym_delete] = ACTIONS(95),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(104),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(2308),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(2300),
    [anon_sym_readonly] = ACTIONS(2300),
    [anon_sym_get] = ACTIONS(2300),
    [anon_sym_set] = ACTIONS(2300),
    [anon_sym_declare] = ACTIONS(2300),
    [anon_sym_public] = ACTIONS(2300),
    [anon_sym_private] = ACTIONS(2300),
    [anon_sym_protected] = ACTIONS(2300),
    [anon_sym_override] = ACTIONS(2300),
    [anon_sym_module] = ACTIONS(2300),
    [anon_sym_any] = ACTIONS(2300),
    [anon_sym_number] = ACTIONS(2300),
    [anon_sym_boolean] = ACTIONS(2300),
    [anon_sym_string] = ACTIONS(2300),
    [anon_sym_symbol] = ACTIONS(2300),
    [anon_sym_object] = ACTIONS(2300),
    [anon_sym_property] = ACTIONS(2300),
    [anon_sym_signal] = ACTIONS(2300),
    [anon_sym_on] = ACTIONS(2300),
    [anon_sym_required] = ACTIONS(2300),
    [anon_sym_component] = ACTIONS(2300),
    [sym_html_comment] = ACTIONS(5),
  },
  [631] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_expression] = STATE(1963),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6164),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3271),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6167),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(631),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1451),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(522),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_export] = ACTIONS(1327),
    [anon_sym_type] = ACTIONS(1327),
    [anon_sym_namespace] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1349),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_let] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1333),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_of] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1527),
    [anon_sym_using] = ACTIONS(1343),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_SLASH] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_void] = ACTIONS(1349),
    [anon_sym_delete] = ACTIONS(1349),
    [anon_sym_PLUS_PLUS] = ACTIONS(1351),
    [anon_sym_DASH_DASH] = ACTIONS(1351),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1353),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1327),
    [anon_sym_readonly] = ACTIONS(1327),
    [anon_sym_get] = ACTIONS(1327),
    [anon_sym_set] = ACTIONS(1327),
    [anon_sym_declare] = ACTIONS(1327),
    [anon_sym_public] = ACTIONS(1327),
    [anon_sym_private] = ACTIONS(1327),
    [anon_sym_protected] = ACTIONS(1327),
    [anon_sym_override] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_any] = ACTIONS(1327),
    [anon_sym_number] = ACTIONS(1327),
    [anon_sym_boolean] = ACTIONS(1327),
    [anon_sym_string] = ACTIONS(1327),
    [anon_sym_symbol] = ACTIONS(1327),
    [anon_sym_object] = ACTIONS(1327),
    [anon_sym_property] = ACTIONS(1327),
    [anon_sym_signal] = ACTIONS(1327),
    [anon_sym_on] = ACTIONS(1327),
    [anon_sym_required] = ACTIONS(1327),
    [anon_sym_component] = ACTIONS(1327),
    [sym_html_comment] = ACTIONS(5),
  },
  [632] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_expression] = STATE(1953),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6164),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3271),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6167),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(632),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1451),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(522),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_export] = ACTIONS(1327),
    [anon_sym_type] = ACTIONS(1327),
    [anon_sym_namespace] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1349),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_let] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1333),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_of] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1527),
    [anon_sym_using] = ACTIONS(1343),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_SLASH] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_void] = ACTIONS(1349),
    [anon_sym_delete] = ACTIONS(1349),
    [anon_sym_PLUS_PLUS] = ACTIONS(1351),
    [anon_sym_DASH_DASH] = ACTIONS(1351),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1353),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1327),
    [anon_sym_readonly] = ACTIONS(1327),
    [anon_sym_get] = ACTIONS(1327),
    [anon_sym_set] = ACTIONS(1327),
    [anon_sym_declare] = ACTIONS(1327),
    [anon_sym_public] = ACTIONS(1327),
    [anon_sym_private] = ACTIONS(1327),
    [anon_sym_protected] = ACTIONS(1327),
    [anon_sym_override] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_any] = ACTIONS(1327),
    [anon_sym_number] = ACTIONS(1327),
    [anon_sym_boolean] = ACTIONS(1327),
    [anon_sym_string] = ACTIONS(1327),
    [anon_sym_symbol] = ACTIONS(1327),
    [anon_sym_object] = ACTIONS(1327),
    [anon_sym_property] = ACTIONS(1327),
    [anon_sym_signal] = ACTIONS(1327),
    [anon_sym_on] = ACTIONS(1327),
    [anon_sym_required] = ACTIONS(1327),
    [anon_sym_component] = ACTIONS(1327),
    [sym_html_comment] = ACTIONS(5),
  },
  [633] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_expression] = STATE(1952),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6164),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3271),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6167),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(633),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1451),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(522),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_export] = ACTIONS(1327),
    [anon_sym_type] = ACTIONS(1327),
    [anon_sym_namespace] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1349),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_let] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1333),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_of] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1527),
    [anon_sym_using] = ACTIONS(1343),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_SLASH] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_void] = ACTIONS(1349),
    [anon_sym_delete] = ACTIONS(1349),
    [anon_sym_PLUS_PLUS] = ACTIONS(1351),
    [anon_sym_DASH_DASH] = ACTIONS(1351),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1353),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1327),
    [anon_sym_readonly] = ACTIONS(1327),
    [anon_sym_get] = ACTIONS(1327),
    [anon_sym_set] = ACTIONS(1327),
    [anon_sym_declare] = ACTIONS(1327),
    [anon_sym_public] = ACTIONS(1327),
    [anon_sym_private] = ACTIONS(1327),
    [anon_sym_protected] = ACTIONS(1327),
    [anon_sym_override] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_any] = ACTIONS(1327),
    [anon_sym_number] = ACTIONS(1327),
    [anon_sym_boolean] = ACTIONS(1327),
    [anon_sym_string] = ACTIONS(1327),
    [anon_sym_symbol] = ACTIONS(1327),
    [anon_sym_object] = ACTIONS(1327),
    [anon_sym_property] = ACTIONS(1327),
    [anon_sym_signal] = ACTIONS(1327),
    [anon_sym_on] = ACTIONS(1327),
    [anon_sym_required] = ACTIONS(1327),
    [anon_sym_component] = ACTIONS(1327),
    [sym_html_comment] = ACTIONS(5),
  },
  [634] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_expression] = STATE(1941),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6164),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3271),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6167),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(634),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1451),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(522),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_export] = ACTIONS(1327),
    [anon_sym_type] = ACTIONS(1327),
    [anon_sym_namespace] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1349),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_let] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1333),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_of] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1527),
    [anon_sym_using] = ACTIONS(1343),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_SLASH] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_void] = ACTIONS(1349),
    [anon_sym_delete] = ACTIONS(1349),
    [anon_sym_PLUS_PLUS] = ACTIONS(1351),
    [anon_sym_DASH_DASH] = ACTIONS(1351),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1353),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1327),
    [anon_sym_readonly] = ACTIONS(1327),
    [anon_sym_get] = ACTIONS(1327),
    [anon_sym_set] = ACTIONS(1327),
    [anon_sym_declare] = ACTIONS(1327),
    [anon_sym_public] = ACTIONS(1327),
    [anon_sym_private] = ACTIONS(1327),
    [anon_sym_protected] = ACTIONS(1327),
    [anon_sym_override] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_any] = ACTIONS(1327),
    [anon_sym_number] = ACTIONS(1327),
    [anon_sym_boolean] = ACTIONS(1327),
    [anon_sym_string] = ACTIONS(1327),
    [anon_sym_symbol] = ACTIONS(1327),
    [anon_sym_object] = ACTIONS(1327),
    [anon_sym_property] = ACTIONS(1327),
    [anon_sym_signal] = ACTIONS(1327),
    [anon_sym_on] = ACTIONS(1327),
    [anon_sym_required] = ACTIONS(1327),
    [anon_sym_component] = ACTIONS(1327),
    [sym_html_comment] = ACTIONS(5),
  },
  [635] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1473),
    [sym_expression] = STATE(2153),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6272),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1473),
    [sym_subscript_expression] = STATE(1473),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3246),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6274),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(635),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1473),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(541),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_export] = ACTIONS(1415),
    [anon_sym_type] = ACTIONS(1415),
    [anon_sym_namespace] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1437),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1415),
    [anon_sym_let] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1421),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1423),
    [anon_sym_of] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1425),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1427),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1543),
    [anon_sym_using] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1421),
    [anon_sym_void] = ACTIONS(1437),
    [anon_sym_delete] = ACTIONS(1437),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1441),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1415),
    [anon_sym_readonly] = ACTIONS(1415),
    [anon_sym_get] = ACTIONS(1415),
    [anon_sym_set] = ACTIONS(1415),
    [anon_sym_declare] = ACTIONS(1415),
    [anon_sym_public] = ACTIONS(1415),
    [anon_sym_private] = ACTIONS(1415),
    [anon_sym_protected] = ACTIONS(1415),
    [anon_sym_override] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_any] = ACTIONS(1415),
    [anon_sym_number] = ACTIONS(1415),
    [anon_sym_boolean] = ACTIONS(1415),
    [anon_sym_string] = ACTIONS(1415),
    [anon_sym_symbol] = ACTIONS(1415),
    [anon_sym_object] = ACTIONS(1415),
    [anon_sym_property] = ACTIONS(1415),
    [anon_sym_signal] = ACTIONS(1415),
    [anon_sym_on] = ACTIONS(1415),
    [anon_sym_required] = ACTIONS(1415),
    [anon_sym_component] = ACTIONS(1415),
    [sym_html_comment] = ACTIONS(5),
  },
  [636] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_expression] = STATE(1934),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6164),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3271),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6167),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(636),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1451),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(522),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_export] = ACTIONS(1327),
    [anon_sym_type] = ACTIONS(1327),
    [anon_sym_namespace] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1349),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_let] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1333),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1335),
    [anon_sym_of] = ACTIONS(1327),
    [anon_sym_yield] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1527),
    [anon_sym_using] = ACTIONS(1343),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_SLASH] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1333),
    [anon_sym_void] = ACTIONS(1349),
    [anon_sym_delete] = ACTIONS(1349),
    [anon_sym_PLUS_PLUS] = ACTIONS(1351),
    [anon_sym_DASH_DASH] = ACTIONS(1351),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1353),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1327),
    [anon_sym_readonly] = ACTIONS(1327),
    [anon_sym_get] = ACTIONS(1327),
    [anon_sym_set] = ACTIONS(1327),
    [anon_sym_declare] = ACTIONS(1327),
    [anon_sym_public] = ACTIONS(1327),
    [anon_sym_private] = ACTIONS(1327),
    [anon_sym_protected] = ACTIONS(1327),
    [anon_sym_override] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_any] = ACTIONS(1327),
    [anon_sym_number] = ACTIONS(1327),
    [anon_sym_boolean] = ACTIONS(1327),
    [anon_sym_string] = ACTIONS(1327),
    [anon_sym_symbol] = ACTIONS(1327),
    [anon_sym_object] = ACTIONS(1327),
    [anon_sym_property] = ACTIONS(1327),
    [anon_sym_signal] = ACTIONS(1327),
    [anon_sym_on] = ACTIONS(1327),
    [anon_sym_required] = ACTIONS(1327),
    [anon_sym_component] = ACTIONS(1327),
    [sym_html_comment] = ACTIONS(5),
  },
  [637] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1920),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(637),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [638] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_expression] = STATE(2544),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5939),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(638),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1523),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1555),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_of] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_using] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_property] = ACTIONS(1181),
    [anon_sym_signal] = ACTIONS(1181),
    [anon_sym_on] = ACTIONS(1181),
    [anon_sym_required] = ACTIONS(1181),
    [anon_sym_component] = ACTIONS(1181),
    [sym_html_comment] = ACTIONS(5),
  },
  [639] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1473),
    [sym_expression] = STATE(2149),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6272),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1473),
    [sym_subscript_expression] = STATE(1473),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3246),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6274),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(639),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1473),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(541),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_export] = ACTIONS(1415),
    [anon_sym_type] = ACTIONS(1415),
    [anon_sym_namespace] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1437),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1415),
    [anon_sym_let] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1421),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1423),
    [anon_sym_of] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1425),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1427),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1543),
    [anon_sym_using] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1421),
    [anon_sym_void] = ACTIONS(1437),
    [anon_sym_delete] = ACTIONS(1437),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1441),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1415),
    [anon_sym_readonly] = ACTIONS(1415),
    [anon_sym_get] = ACTIONS(1415),
    [anon_sym_set] = ACTIONS(1415),
    [anon_sym_declare] = ACTIONS(1415),
    [anon_sym_public] = ACTIONS(1415),
    [anon_sym_private] = ACTIONS(1415),
    [anon_sym_protected] = ACTIONS(1415),
    [anon_sym_override] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_any] = ACTIONS(1415),
    [anon_sym_number] = ACTIONS(1415),
    [anon_sym_boolean] = ACTIONS(1415),
    [anon_sym_string] = ACTIONS(1415),
    [anon_sym_symbol] = ACTIONS(1415),
    [anon_sym_object] = ACTIONS(1415),
    [anon_sym_property] = ACTIONS(1415),
    [anon_sym_signal] = ACTIONS(1415),
    [anon_sym_on] = ACTIONS(1415),
    [anon_sym_required] = ACTIONS(1415),
    [anon_sym_component] = ACTIONS(1415),
    [sym_html_comment] = ACTIONS(5),
  },
  [640] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1873),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(640),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [641] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1487),
    [sym_expression] = STATE(2413),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1487),
    [sym_subscript_expression] = STATE(1487),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3189),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6145),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(641),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1487),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1131),
    [anon_sym_namespace] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1159),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_let] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_of] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1149),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_using] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1159),
    [anon_sym_delete] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1167),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1131),
    [anon_sym_readonly] = ACTIONS(1131),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_declare] = ACTIONS(1131),
    [anon_sym_public] = ACTIONS(1131),
    [anon_sym_private] = ACTIONS(1131),
    [anon_sym_protected] = ACTIONS(1131),
    [anon_sym_override] = ACTIONS(1131),
    [anon_sym_module] = ACTIONS(1131),
    [anon_sym_any] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_boolean] = ACTIONS(1131),
    [anon_sym_string] = ACTIONS(1131),
    [anon_sym_symbol] = ACTIONS(1131),
    [anon_sym_object] = ACTIONS(1131),
    [anon_sym_property] = ACTIONS(1131),
    [anon_sym_signal] = ACTIONS(1131),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_required] = ACTIONS(1131),
    [anon_sym_component] = ACTIONS(1131),
    [sym_html_comment] = ACTIONS(5),
  },
  [642] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1919),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(642),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [643] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1487),
    [sym_expression] = STATE(2247),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1487),
    [sym_subscript_expression] = STATE(1487),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3189),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6145),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(643),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1487),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1131),
    [anon_sym_namespace] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1159),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_let] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_of] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1149),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_using] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1159),
    [anon_sym_delete] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(2270),
    [sym_private_property_identifier] = ACTIONS(1167),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1131),
    [anon_sym_readonly] = ACTIONS(1131),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_declare] = ACTIONS(1131),
    [anon_sym_public] = ACTIONS(1131),
    [anon_sym_private] = ACTIONS(1131),
    [anon_sym_protected] = ACTIONS(1131),
    [anon_sym_override] = ACTIONS(1131),
    [anon_sym_module] = ACTIONS(1131),
    [anon_sym_any] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_boolean] = ACTIONS(1131),
    [anon_sym_string] = ACTIONS(1131),
    [anon_sym_symbol] = ACTIONS(1131),
    [anon_sym_object] = ACTIONS(1131),
    [anon_sym_property] = ACTIONS(1131),
    [anon_sym_signal] = ACTIONS(1131),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_required] = ACTIONS(1131),
    [anon_sym_component] = ACTIONS(1131),
    [sym_html_comment] = ACTIONS(5),
  },
  [644] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1464),
    [sym_expression] = STATE(2175),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6301),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1464),
    [sym_subscript_expression] = STATE(1464),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3242),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6300),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(644),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_export] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [anon_sym_of] = ACTIONS(1293),
    [anon_sym_yield] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1521),
    [anon_sym_using] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(171),
    [anon_sym_void] = ACTIONS(157),
    [anon_sym_delete] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(223),
    [anon_sym_DASH_DASH] = ACTIONS(223),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(377),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_get] = ACTIONS(1293),
    [anon_sym_set] = ACTIONS(1293),
    [anon_sym_declare] = ACTIONS(1293),
    [anon_sym_public] = ACTIONS(1293),
    [anon_sym_private] = ACTIONS(1293),
    [anon_sym_protected] = ACTIONS(1293),
    [anon_sym_override] = ACTIONS(1293),
    [anon_sym_module] = ACTIONS(1293),
    [anon_sym_any] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1293),
    [anon_sym_string] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1293),
    [anon_sym_object] = ACTIONS(1293),
    [anon_sym_property] = ACTIONS(1293),
    [anon_sym_signal] = ACTIONS(1293),
    [anon_sym_on] = ACTIONS(1293),
    [anon_sym_required] = ACTIONS(1293),
    [anon_sym_component] = ACTIONS(1293),
    [sym_html_comment] = ACTIONS(5),
  },
  [645] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1487),
    [sym_expression] = STATE(2242),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1487),
    [sym_subscript_expression] = STATE(1487),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3189),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6145),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(645),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1487),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1131),
    [anon_sym_namespace] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1159),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_let] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_of] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1149),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_using] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1159),
    [anon_sym_delete] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1167),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1131),
    [anon_sym_readonly] = ACTIONS(1131),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_declare] = ACTIONS(1131),
    [anon_sym_public] = ACTIONS(1131),
    [anon_sym_private] = ACTIONS(1131),
    [anon_sym_protected] = ACTIONS(1131),
    [anon_sym_override] = ACTIONS(1131),
    [anon_sym_module] = ACTIONS(1131),
    [anon_sym_any] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_boolean] = ACTIONS(1131),
    [anon_sym_string] = ACTIONS(1131),
    [anon_sym_symbol] = ACTIONS(1131),
    [anon_sym_object] = ACTIONS(1131),
    [anon_sym_property] = ACTIONS(1131),
    [anon_sym_signal] = ACTIONS(1131),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_required] = ACTIONS(1131),
    [anon_sym_component] = ACTIONS(1131),
    [sym_html_comment] = ACTIONS(5),
  },
  [646] = {
    [sym_import] = STATE(3590),
    [sym_parenthesized_expression] = STATE(1487),
    [sym_expression] = STATE(2410),
    [sym_primary_expression] = STATE(2368),
    [sym_yield_expression] = STATE(2456),
    [sym_object] = STATE(2480),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(2480),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(2456),
    [sym_glimmer_opening_tag] = STATE(4712),
    [sym_class] = STATE(2480),
    [sym_function_expression] = STATE(2480),
    [sym_generator_function] = STATE(2480),
    [sym_arrow_function] = STATE(2480),
    [sym__call_signature] = STATE(6143),
    [sym_call_expression] = STATE(2480),
    [sym_new_expression] = STATE(2456),
    [sym_await_expression] = STATE(2456),
    [sym_member_expression] = STATE(1487),
    [sym_subscript_expression] = STATE(1487),
    [sym_assignment_expression] = STATE(2456),
    [sym__augmented_assignment_lhs] = STATE(3189),
    [sym_augmented_assignment_expression] = STATE(2456),
    [sym__destructuring_pattern] = STATE(6145),
    [sym_ternary_expression] = STATE(2456),
    [sym_binary_expression] = STATE(2456),
    [sym_unary_expression] = STATE(2456),
    [sym_update_expression] = STATE(2456),
    [sym_string] = STATE(2480),
    [sym_comment] = STATE(646),
    [sym_template_string] = STATE(2480),
    [sym_regex] = STATE(2480),
    [sym_meta_property] = STATE(2480),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1487),
    [sym_type_assertion] = STATE(2456),
    [sym_as_expression] = STATE(2456),
    [sym_satisfies_expression] = STATE(2456),
    [sym_instantiation_expression] = STATE(2456),
    [sym_internal_module] = STATE(2456),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4713),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(1131),
    [anon_sym_type] = ACTIONS(1131),
    [anon_sym_namespace] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(1159),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1131),
    [anon_sym_let] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_of] = ACTIONS(1131),
    [anon_sym_yield] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_async] = ACTIONS(1149),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_new] = ACTIONS(1535),
    [anon_sym_using] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1159),
    [anon_sym_delete] = ACTIONS(1159),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(225),
    [sym_number] = ACTIONS(375),
    [sym_private_property_identifier] = ACTIONS(1167),
    [sym_this] = ACTIONS(231),
    [sym_super] = ACTIONS(231),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [sym_null] = ACTIONS(231),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1131),
    [anon_sym_readonly] = ACTIONS(1131),
    [anon_sym_get] = ACTIONS(1131),
    [anon_sym_set] = ACTIONS(1131),
    [anon_sym_declare] = ACTIONS(1131),
    [anon_sym_public] = ACTIONS(1131),
    [anon_sym_private] = ACTIONS(1131),
    [anon_sym_protected] = ACTIONS(1131),
    [anon_sym_override] = ACTIONS(1131),
    [anon_sym_module] = ACTIONS(1131),
    [anon_sym_any] = ACTIONS(1131),
    [anon_sym_number] = ACTIONS(1131),
    [anon_sym_boolean] = ACTIONS(1131),
    [anon_sym_string] = ACTIONS(1131),
    [anon_sym_symbol] = ACTIONS(1131),
    [anon_sym_object] = ACTIONS(1131),
    [anon_sym_property] = ACTIONS(1131),
    [anon_sym_signal] = ACTIONS(1131),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_required] = ACTIONS(1131),
    [anon_sym_component] = ACTIONS(1131),
    [sym_html_comment] = ACTIONS(5),
  },
  [647] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1523),
    [sym_expression] = STATE(2501),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6047),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1523),
    [sym_subscript_expression] = STATE(1523),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(5939),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(647),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1523),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(551),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1555),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_of] = ACTIONS(1181),
    [anon_sym_yield] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_using] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1561),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_property] = ACTIONS(1181),
    [anon_sym_signal] = ACTIONS(1181),
    [anon_sym_on] = ACTIONS(1181),
    [anon_sym_required] = ACTIONS(1181),
    [anon_sym_component] = ACTIONS(1181),
    [sym_html_comment] = ACTIONS(5),
  },
  [648] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1874),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(648),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [649] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1904),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(649),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [650] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1473),
    [sym_expression] = STATE(2134),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6272),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1473),
    [sym_subscript_expression] = STATE(1473),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3246),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6274),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(650),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1473),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(541),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_export] = ACTIONS(1415),
    [anon_sym_type] = ACTIONS(1415),
    [anon_sym_namespace] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1437),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1415),
    [anon_sym_let] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1421),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1423),
    [anon_sym_of] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1425),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1427),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1543),
    [anon_sym_using] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1421),
    [anon_sym_void] = ACTIONS(1437),
    [anon_sym_delete] = ACTIONS(1437),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1441),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1415),
    [anon_sym_readonly] = ACTIONS(1415),
    [anon_sym_get] = ACTIONS(1415),
    [anon_sym_set] = ACTIONS(1415),
    [anon_sym_declare] = ACTIONS(1415),
    [anon_sym_public] = ACTIONS(1415),
    [anon_sym_private] = ACTIONS(1415),
    [anon_sym_protected] = ACTIONS(1415),
    [anon_sym_override] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_any] = ACTIONS(1415),
    [anon_sym_number] = ACTIONS(1415),
    [anon_sym_boolean] = ACTIONS(1415),
    [anon_sym_string] = ACTIONS(1415),
    [anon_sym_symbol] = ACTIONS(1415),
    [anon_sym_object] = ACTIONS(1415),
    [anon_sym_property] = ACTIONS(1415),
    [anon_sym_signal] = ACTIONS(1415),
    [anon_sym_on] = ACTIONS(1415),
    [anon_sym_required] = ACTIONS(1415),
    [anon_sym_component] = ACTIONS(1415),
    [sym_html_comment] = ACTIONS(5),
  },
  [651] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1909),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(651),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [652] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1513),
    [sym_expression] = STATE(2615),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6293),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1513),
    [sym_subscript_expression] = STATE(1513),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3245),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6295),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(652),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1513),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(455),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1565),
    [anon_sym_export] = ACTIONS(1379),
    [anon_sym_type] = ACTIONS(1379),
    [anon_sym_namespace] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(1401),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1379),
    [anon_sym_let] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1385),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1387),
    [anon_sym_of] = ACTIONS(1379),
    [anon_sym_yield] = ACTIONS(1389),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1391),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1569),
    [anon_sym_using] = ACTIONS(1395),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_SLASH] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1385),
    [anon_sym_void] = ACTIONS(1401),
    [anon_sym_delete] = ACTIONS(1401),
    [anon_sym_PLUS_PLUS] = ACTIONS(1403),
    [anon_sym_DASH_DASH] = ACTIONS(1403),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1405),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1571),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1379),
    [anon_sym_readonly] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(1379),
    [anon_sym_set] = ACTIONS(1379),
    [anon_sym_declare] = ACTIONS(1379),
    [anon_sym_public] = ACTIONS(1379),
    [anon_sym_private] = ACTIONS(1379),
    [anon_sym_protected] = ACTIONS(1379),
    [anon_sym_override] = ACTIONS(1379),
    [anon_sym_module] = ACTIONS(1379),
    [anon_sym_any] = ACTIONS(1379),
    [anon_sym_number] = ACTIONS(1379),
    [anon_sym_boolean] = ACTIONS(1379),
    [anon_sym_string] = ACTIONS(1379),
    [anon_sym_symbol] = ACTIONS(1379),
    [anon_sym_object] = ACTIONS(1379),
    [anon_sym_property] = ACTIONS(1379),
    [anon_sym_signal] = ACTIONS(1379),
    [anon_sym_on] = ACTIONS(1379),
    [anon_sym_required] = ACTIONS(1379),
    [anon_sym_component] = ACTIONS(1379),
    [sym_html_comment] = ACTIONS(5),
  },
  [653] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1910),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(653),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [654] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1473),
    [sym_expression] = STATE(2133),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6272),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1473),
    [sym_subscript_expression] = STATE(1473),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3246),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6274),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(654),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1473),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(541),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_export] = ACTIONS(1415),
    [anon_sym_type] = ACTIONS(1415),
    [anon_sym_namespace] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(1437),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(1415),
    [anon_sym_let] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1421),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(1423),
    [anon_sym_of] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1425),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(1427),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(1543),
    [anon_sym_using] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_SLASH] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(1421),
    [anon_sym_void] = ACTIONS(1437),
    [anon_sym_delete] = ACTIONS(1437),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(1441),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(1415),
    [anon_sym_readonly] = ACTIONS(1415),
    [anon_sym_get] = ACTIONS(1415),
    [anon_sym_set] = ACTIONS(1415),
    [anon_sym_declare] = ACTIONS(1415),
    [anon_sym_public] = ACTIONS(1415),
    [anon_sym_private] = ACTIONS(1415),
    [anon_sym_protected] = ACTIONS(1415),
    [anon_sym_override] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_any] = ACTIONS(1415),
    [anon_sym_number] = ACTIONS(1415),
    [anon_sym_boolean] = ACTIONS(1415),
    [anon_sym_string] = ACTIONS(1415),
    [anon_sym_symbol] = ACTIONS(1415),
    [anon_sym_object] = ACTIONS(1415),
    [anon_sym_property] = ACTIONS(1415),
    [anon_sym_signal] = ACTIONS(1415),
    [anon_sym_on] = ACTIONS(1415),
    [anon_sym_required] = ACTIONS(1415),
    [anon_sym_component] = ACTIONS(1415),
    [sym_html_comment] = ACTIONS(5),
  },
  [655] = {
    [sym_import] = STATE(3710),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_expression] = STATE(1915),
    [sym_primary_expression] = STATE(1885),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1976),
    [sym_object_pattern] = STATE(3599),
    [sym_array] = STATE(1976),
    [sym_array_pattern] = STATE(3599),
    [sym_glimmer_template] = STATE(1980),
    [sym_glimmer_opening_tag] = STATE(4797),
    [sym_class] = STATE(1976),
    [sym_function_expression] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_arrow_function] = STATE(1976),
    [sym__call_signature] = STATE(6081),
    [sym_call_expression] = STATE(1976),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1389),
    [sym_subscript_expression] = STATE(1389),
    [sym_assignment_expression] = STATE(1980),
    [sym__augmented_assignment_lhs] = STATE(3188),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym__destructuring_pattern] = STATE(6082),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_string] = STATE(1976),
    [sym_comment] = STATE(655),
    [sym_template_string] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(4046),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_satisfies_expression] = STATE(1980),
    [sym_instantiation_expression] = STATE(1980),
    [sym_internal_module] = STATE(1980),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_export_statement_repeat1] = STATE(4787),
    [sym_identifier] = ACTIONS(927),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_type] = ACTIONS(929),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(724),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_from] = ACTIONS(929),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_await] = ACTIONS(698),
    [anon_sym_of] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_LTtemplate_GT] = ACTIONS(56),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_class] = ACTIONS(62),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_function] = ACTIONS(66),
    [anon_sym_new] = ACTIONS(941),
    [anon_sym_using] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(724),
    [anon_sym_delete] = ACTIONS(724),
    [anon_sym_PLUS_PLUS] = ACTIONS(726),
    [anon_sym_DASH_DASH] = ACTIONS(726),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(855),
    [sym_number] = ACTIONS(817),
    [sym_private_property_identifier] = ACTIONS(728),
    [sym_this] = ACTIONS(108),
    [sym_super] = ACTIONS(108),
    [sym_true] = ACTIONS(108),
    [sym_false] = ACTIONS(108),
    [sym_null] = ACTIONS(108),
    [sym_undefined] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(929),
    [anon_sym_readonly] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(929),
    [anon_sym_set] = ACTIONS(929),
    [anon_sym_declare] = ACTIONS(929),
    [anon_sym_public] = ACTIONS(929),
    [anon_sym_private] = ACTIONS(929),
    [anon_sym_protected] = ACTIONS(929),
    [anon_sym_override] = ACTIONS(929),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_any] = ACTIONS(929),
    [anon_sym_number] = ACTIONS(929),
    [anon_sym_boolean] = ACTIONS(929),
    [anon_sym_string] = ACTIONS(929),
    [anon_sym_symbol] = ACTIONS(929),
    [anon_sym_object] = ACTIONS(929),
    [anon_sym_property] = ACTIONS(929),
    [anon_sym_signal] = ACTIONS(929),
    [anon_sym_on] = ACTIONS(929),
    [anon_sym_required] = ACTIONS(929),
    [anon_sym_component] = ACTIONS(929),
    [sym_html_comment] = ACTIONS(5),
  },
  [656] = {
    [sym__call_signature] = STATE(6266),
    [sym_string] = STATE(3955),
    [sym_comment] = STATE(656),
    [sym_formal_parameters] = STATE(4046),
    [sym__property_name] = STATE(4068),
    [sym_computed_property_name] = STATE(3955),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_object_repeat1] = STATE(4915),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(2310),
    [anon_sym_export] = ACTIONS(2312),
    [anon_sym_STAR] = ACTIONS(2314),
    [anon_sym_type] = ACTIONS(2312),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2312),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(781),
    [anon_sym_from] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2317),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2312),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(2321),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_async] = ACTIONS(2312),
    [anon_sym_function] = ACTIONS(2324),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2312),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [sym_number] = ACTIONS(2330),
    [sym_private_property_identifier] = ACTIONS(2330),
    [anon_sym_static] = ACTIONS(2312),
    [anon_sym_readonly] = ACTIONS(2312),
    [anon_sym_get] = ACTIONS(2332),
    [anon_sym_set] = ACTIONS(2332),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_declare] = ACTIONS(2312),
    [anon_sym_public] = ACTIONS(2312),
    [anon_sym_private] = ACTIONS(2312),
    [anon_sym_protected] = ACTIONS(2312),
    [anon_sym_override] = ACTIONS(2312),
    [anon_sym_module] = ACTIONS(2312),
    [anon_sym_any] = ACTIONS(2312),
    [anon_sym_number] = ACTIONS(2312),
    [anon_sym_boolean] = ACTIONS(2312),
    [anon_sym_string] = ACTIONS(2312),
    [anon_sym_symbol] = ACTIONS(2312),
    [anon_sym_object] = ACTIONS(2312),
    [anon_sym_property] = ACTIONS(2312),
    [anon_sym_signal] = ACTIONS(2312),
    [anon_sym_on] = ACTIONS(2312),
    [anon_sym_required] = ACTIONS(2312),
    [anon_sym_component] = ACTIONS(2312),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [657] = {
    [sym__call_signature] = STATE(6266),
    [sym_string] = STATE(3955),
    [sym_comment] = STATE(657),
    [sym_formal_parameters] = STATE(4046),
    [sym__property_name] = STATE(4068),
    [sym_computed_property_name] = STATE(3955),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_object_repeat1] = STATE(5251),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(2310),
    [anon_sym_export] = ACTIONS(2312),
    [anon_sym_STAR] = ACTIONS(2314),
    [anon_sym_type] = ACTIONS(2312),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2312),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(791),
    [anon_sym_from] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2317),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2312),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(2321),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_async] = ACTIONS(2312),
    [anon_sym_function] = ACTIONS(2324),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2312),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [sym_number] = ACTIONS(2330),
    [sym_private_property_identifier] = ACTIONS(2330),
    [anon_sym_static] = ACTIONS(2312),
    [anon_sym_readonly] = ACTIONS(2312),
    [anon_sym_get] = ACTIONS(2332),
    [anon_sym_set] = ACTIONS(2332),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_declare] = ACTIONS(2312),
    [anon_sym_public] = ACTIONS(2312),
    [anon_sym_private] = ACTIONS(2312),
    [anon_sym_protected] = ACTIONS(2312),
    [anon_sym_override] = ACTIONS(2312),
    [anon_sym_module] = ACTIONS(2312),
    [anon_sym_any] = ACTIONS(2312),
    [anon_sym_number] = ACTIONS(2312),
    [anon_sym_boolean] = ACTIONS(2312),
    [anon_sym_string] = ACTIONS(2312),
    [anon_sym_symbol] = ACTIONS(2312),
    [anon_sym_object] = ACTIONS(2312),
    [anon_sym_property] = ACTIONS(2312),
    [anon_sym_signal] = ACTIONS(2312),
    [anon_sym_on] = ACTIONS(2312),
    [anon_sym_required] = ACTIONS(2312),
    [anon_sym_component] = ACTIONS(2312),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [658] = {
    [sym__call_signature] = STATE(6266),
    [sym_string] = STATE(3955),
    [sym_comment] = STATE(658),
    [sym_formal_parameters] = STATE(4046),
    [sym__property_name] = STATE(4068),
    [sym_computed_property_name] = STATE(3955),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_object_repeat1] = STATE(4915),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(2310),
    [anon_sym_export] = ACTIONS(2312),
    [anon_sym_STAR] = ACTIONS(2314),
    [anon_sym_type] = ACTIONS(2312),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2312),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(777),
    [anon_sym_from] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2317),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2312),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(2321),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_async] = ACTIONS(2312),
    [anon_sym_function] = ACTIONS(2324),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2312),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [sym_number] = ACTIONS(2330),
    [sym_private_property_identifier] = ACTIONS(2330),
    [anon_sym_static] = ACTIONS(2312),
    [anon_sym_readonly] = ACTIONS(2312),
    [anon_sym_get] = ACTIONS(2332),
    [anon_sym_set] = ACTIONS(2332),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_declare] = ACTIONS(2312),
    [anon_sym_public] = ACTIONS(2312),
    [anon_sym_private] = ACTIONS(2312),
    [anon_sym_protected] = ACTIONS(2312),
    [anon_sym_override] = ACTIONS(2312),
    [anon_sym_module] = ACTIONS(2312),
    [anon_sym_any] = ACTIONS(2312),
    [anon_sym_number] = ACTIONS(2312),
    [anon_sym_boolean] = ACTIONS(2312),
    [anon_sym_string] = ACTIONS(2312),
    [anon_sym_symbol] = ACTIONS(2312),
    [anon_sym_object] = ACTIONS(2312),
    [anon_sym_property] = ACTIONS(2312),
    [anon_sym_signal] = ACTIONS(2312),
    [anon_sym_on] = ACTIONS(2312),
    [anon_sym_required] = ACTIONS(2312),
    [anon_sym_component] = ACTIONS(2312),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [659] = {
    [sym__call_signature] = STATE(6266),
    [sym_string] = STATE(3955),
    [sym_comment] = STATE(659),
    [sym_formal_parameters] = STATE(4046),
    [sym__property_name] = STATE(4068),
    [sym_computed_property_name] = STATE(3955),
    [sym_type_parameters] = STATE(5534),
    [aux_sym_object_repeat1] = STATE(4915),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(2310),
    [anon_sym_export] = ACTIONS(2312),
    [anon_sym_STAR] = ACTIONS(2314),
    [anon_sym_type] = ACTIONS(2312),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2312),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(754),
    [anon_sym_from] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2317),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2312),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(2321),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_async] = ACTIONS(2312),
    [anon_sym_function] = ACTIONS(2324),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2312),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [sym_number] = ACTIONS(2330),
    [sym_private_property_identifier] = ACTIONS(2330),
    [anon_sym_static] = ACTIONS(2312),
    [anon_sym_readonly] = ACTIONS(2312),
    [anon_sym_get] = ACTIONS(2332),
    [anon_sym_set] = ACTIONS(2332),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_declare] = ACTIONS(2312),
    [anon_sym_public] = ACTIONS(2312),
    [anon_sym_private] = ACTIONS(2312),
    [anon_sym_protected] = ACTIONS(2312),
    [anon_sym_override] = ACTIONS(2312),
    [anon_sym_module] = ACTIONS(2312),
    [anon_sym_any] = ACTIONS(2312),
    [anon_sym_number] = ACTIONS(2312),
    [anon_sym_boolean] = ACTIONS(2312),
    [anon_sym_string] = ACTIONS(2312),
    [anon_sym_symbol] = ACTIONS(2312),
    [anon_sym_object] = ACTIONS(2312),
    [anon_sym_property] = ACTIONS(2312),
    [anon_sym_signal] = ACTIONS(2312),
    [anon_sym_on] = ACTIONS(2312),
    [anon_sym_required] = ACTIONS(2312),
    [anon_sym_component] = ACTIONS(2312),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [660] = {
    [sym_string] = STATE(3955),
    [sym_comment] = STATE(660),
    [sym__property_name] = STATE(4068),
    [sym_computed_property_name] = STATE(3955),
    [sym_override_modifier] = STATE(2779),
    [aux_sym_object_repeat1] = STATE(4915),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(2334),
    [anon_sym_export] = ACTIONS(2334),
    [anon_sym_STAR] = ACTIONS(2314),
    [anon_sym_type] = ACTIONS(2334),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2334),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(754),
    [anon_sym_from] = ACTIONS(2334),
    [anon_sym_let] = ACTIONS(2334),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2334),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(2321),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_async] = ACTIONS(2339),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2334),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [sym_number] = ACTIONS(2330),
    [sym_private_property_identifier] = ACTIONS(2330),
    [anon_sym_static] = ACTIONS(2334),
    [anon_sym_readonly] = ACTIONS(2344),
    [anon_sym_get] = ACTIONS(2346),
    [anon_sym_set] = ACTIONS(2346),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_declare] = ACTIONS(2334),
    [anon_sym_public] = ACTIONS(2334),
    [anon_sym_private] = ACTIONS(2334),
    [anon_sym_protected] = ACTIONS(2334),
    [anon_sym_override] = ACTIONS(2348),
    [anon_sym_module] = ACTIONS(2334),
    [anon_sym_any] = ACTIONS(2334),
    [anon_sym_number] = ACTIONS(2334),
    [anon_sym_boolean] = ACTIONS(2334),
    [anon_sym_string] = ACTIONS(2334),
    [anon_sym_symbol] = ACTIONS(2334),
    [anon_sym_object] = ACTIONS(2334),
    [anon_sym_property] = ACTIONS(2334),
    [anon_sym_signal] = ACTIONS(2334),
    [anon_sym_on] = ACTIONS(2334),
    [anon_sym_required] = ACTIONS(2334),
    [anon_sym_component] = ACTIONS(2334),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [661] = {
    [sym_string] = STATE(3955),
    [sym_comment] = STATE(661),
    [sym__property_name] = STATE(4068),
    [sym_computed_property_name] = STATE(3955),
    [sym_override_modifier] = STATE(2779),
    [aux_sym_object_repeat1] = STATE(5251),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(2334),
    [anon_sym_export] = ACTIONS(2334),
    [anon_sym_STAR] = ACTIONS(2314),
    [anon_sym_type] = ACTIONS(2334),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2334),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(791),
    [anon_sym_from] = ACTIONS(2334),
    [anon_sym_let] = ACTIONS(2334),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2334),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(2321),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_async] = ACTIONS(2339),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2334),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [sym_number] = ACTIONS(2330),
    [sym_private_property_identifier] = ACTIONS(2330),
    [anon_sym_static] = ACTIONS(2334),
    [anon_sym_readonly] = ACTIONS(2344),
    [anon_sym_get] = ACTIONS(2346),
    [anon_sym_set] = ACTIONS(2346),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_declare] = ACTIONS(2334),
    [anon_sym_public] = ACTIONS(2334),
    [anon_sym_private] = ACTIONS(2334),
    [anon_sym_protected] = ACTIONS(2334),
    [anon_sym_override] = ACTIONS(2348),
    [anon_sym_module] = ACTIONS(2334),
    [anon_sym_any] = ACTIONS(2334),
    [anon_sym_number] = ACTIONS(2334),
    [anon_sym_boolean] = ACTIONS(2334),
    [anon_sym_string] = ACTIONS(2334),
    [anon_sym_symbol] = ACTIONS(2334),
    [anon_sym_object] = ACTIONS(2334),
    [anon_sym_property] = ACTIONS(2334),
    [anon_sym_signal] = ACTIONS(2334),
    [anon_sym_on] = ACTIONS(2334),
    [anon_sym_required] = ACTIONS(2334),
    [anon_sym_component] = ACTIONS(2334),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [662] = {
    [sym_string] = STATE(3955),
    [sym_comment] = STATE(662),
    [sym__property_name] = STATE(4068),
    [sym_computed_property_name] = STATE(3955),
    [sym_override_modifier] = STATE(2779),
    [aux_sym_object_repeat1] = STATE(4915),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(2334),
    [anon_sym_export] = ACTIONS(2334),
    [anon_sym_STAR] = ACTIONS(2314),
    [anon_sym_type] = ACTIONS(2334),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2334),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(781),
    [anon_sym_from] = ACTIONS(2334),
    [anon_sym_let] = ACTIONS(2334),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2334),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(2321),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_async] = ACTIONS(2339),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2334),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [sym_number] = ACTIONS(2330),
    [sym_private_property_identifier] = ACTIONS(2330),
    [anon_sym_static] = ACTIONS(2334),
    [anon_sym_readonly] = ACTIONS(2344),
    [anon_sym_get] = ACTIONS(2346),
    [anon_sym_set] = ACTIONS(2346),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_declare] = ACTIONS(2334),
    [anon_sym_public] = ACTIONS(2334),
    [anon_sym_private] = ACTIONS(2334),
    [anon_sym_protected] = ACTIONS(2334),
    [anon_sym_override] = ACTIONS(2348),
    [anon_sym_module] = ACTIONS(2334),
    [anon_sym_any] = ACTIONS(2334),
    [anon_sym_number] = ACTIONS(2334),
    [anon_sym_boolean] = ACTIONS(2334),
    [anon_sym_string] = ACTIONS(2334),
    [anon_sym_symbol] = ACTIONS(2334),
    [anon_sym_object] = ACTIONS(2334),
    [anon_sym_property] = ACTIONS(2334),
    [anon_sym_signal] = ACTIONS(2334),
    [anon_sym_on] = ACTIONS(2334),
    [anon_sym_required] = ACTIONS(2334),
    [anon_sym_component] = ACTIONS(2334),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [663] = {
    [sym_string] = STATE(3955),
    [sym_comment] = STATE(663),
    [sym__property_name] = STATE(4068),
    [sym_computed_property_name] = STATE(3955),
    [sym_override_modifier] = STATE(2779),
    [aux_sym_object_repeat1] = STATE(4915),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(2334),
    [anon_sym_export] = ACTIONS(2334),
    [anon_sym_STAR] = ACTIONS(2314),
    [anon_sym_type] = ACTIONS(2334),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2334),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(777),
    [anon_sym_from] = ACTIONS(2334),
    [anon_sym_let] = ACTIONS(2334),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2334),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(2321),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_async] = ACTIONS(2339),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2334),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [sym_number] = ACTIONS(2330),
    [sym_private_property_identifier] = ACTIONS(2330),
    [anon_sym_static] = ACTIONS(2334),
    [anon_sym_readonly] = ACTIONS(2344),
    [anon_sym_get] = ACTIONS(2346),
    [anon_sym_set] = ACTIONS(2346),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_declare] = ACTIONS(2334),
    [anon_sym_public] = ACTIONS(2334),
    [anon_sym_private] = ACTIONS(2334),
    [anon_sym_protected] = ACTIONS(2334),
    [anon_sym_override] = ACTIONS(2348),
    [anon_sym_module] = ACTIONS(2334),
    [anon_sym_any] = ACTIONS(2334),
    [anon_sym_number] = ACTIONS(2334),
    [anon_sym_boolean] = ACTIONS(2334),
    [anon_sym_string] = ACTIONS(2334),
    [anon_sym_symbol] = ACTIONS(2334),
    [anon_sym_object] = ACTIONS(2334),
    [anon_sym_property] = ACTIONS(2334),
    [anon_sym_signal] = ACTIONS(2334),
    [anon_sym_on] = ACTIONS(2334),
    [anon_sym_required] = ACTIONS(2334),
    [anon_sym_component] = ACTIONS(2334),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [664] = {
    [sym_string] = STATE(3955),
    [sym_comment] = STATE(664),
    [sym__property_name] = STATE(4068),
    [sym_computed_property_name] = STATE(3955),
    [aux_sym_object_repeat1] = STATE(4915),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(2334),
    [anon_sym_export] = ACTIONS(2334),
    [anon_sym_STAR] = ACTIONS(2314),
    [anon_sym_type] = ACTIONS(2334),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2334),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(754),
    [anon_sym_from] = ACTIONS(2334),
    [anon_sym_let] = ACTIONS(2334),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2334),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(2321),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_async] = ACTIONS(2339),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2334),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [sym_number] = ACTIONS(2330),
    [sym_private_property_identifier] = ACTIONS(2330),
    [anon_sym_static] = ACTIONS(2334),
    [anon_sym_readonly] = ACTIONS(2334),
    [anon_sym_get] = ACTIONS(2346),
    [anon_sym_set] = ACTIONS(2346),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_declare] = ACTIONS(2334),
    [anon_sym_public] = ACTIONS(2334),
    [anon_sym_private] = ACTIONS(2334),
    [anon_sym_protected] = ACTIONS(2334),
    [anon_sym_override] = ACTIONS(2334),
    [anon_sym_module] = ACTIONS(2334),
    [anon_sym_any] = ACTIONS(2334),
    [anon_sym_number] = ACTIONS(2334),
    [anon_sym_boolean] = ACTIONS(2334),
    [anon_sym_string] = ACTIONS(2334),
    [anon_sym_symbol] = ACTIONS(2334),
    [anon_sym_object] = ACTIONS(2334),
    [anon_sym_property] = ACTIONS(2334),
    [anon_sym_signal] = ACTIONS(2334),
    [anon_sym_on] = ACTIONS(2334),
    [anon_sym_required] = ACTIONS(2334),
    [anon_sym_component] = ACTIONS(2334),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [665] = {
    [sym_string] = STATE(3955),
    [sym_comment] = STATE(665),
    [sym__property_name] = STATE(4068),
    [sym_computed_property_name] = STATE(3955),
    [aux_sym_object_repeat1] = STATE(4915),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(2334),
    [anon_sym_export] = ACTIONS(2334),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2334),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2334),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(781),
    [anon_sym_from] = ACTIONS(2334),
    [anon_sym_let] = ACTIONS(2334),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2334),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(2321),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_async] = ACTIONS(2334),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2334),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [sym_number] = ACTIONS(2330),
    [sym_private_property_identifier] = ACTIONS(2330),
    [anon_sym_static] = ACTIONS(2334),
    [anon_sym_readonly] = ACTIONS(2334),
    [anon_sym_get] = ACTIONS(2334),
    [anon_sym_set] = ACTIONS(2334),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_declare] = ACTIONS(2334),
    [anon_sym_public] = ACTIONS(2334),
    [anon_sym_private] = ACTIONS(2334),
    [anon_sym_protected] = ACTIONS(2334),
    [anon_sym_override] = ACTIONS(2334),
    [anon_sym_module] = ACTIONS(2334),
    [anon_sym_any] = ACTIONS(2334),
    [anon_sym_number] = ACTIONS(2334),
    [anon_sym_boolean] = ACTIONS(2334),
    [anon_sym_string] = ACTIONS(2334),
    [anon_sym_symbol] = ACTIONS(2334),
    [anon_sym_object] = ACTIONS(2334),
    [anon_sym_property] = ACTIONS(2334),
    [anon_sym_signal] = ACTIONS(2334),
    [anon_sym_on] = ACTIONS(2334),
    [anon_sym_required] = ACTIONS(2334),
    [anon_sym_component] = ACTIONS(2334),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [666] = {
    [sym_string] = STATE(3955),
    [sym_comment] = STATE(666),
    [sym__property_name] = STATE(4068),
    [sym_computed_property_name] = STATE(3955),
    [aux_sym_object_repeat1] = STATE(5251),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(2334),
    [anon_sym_export] = ACTIONS(2334),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2334),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2334),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(791),
    [anon_sym_from] = ACTIONS(2334),
    [anon_sym_let] = ACTIONS(2334),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2334),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(2321),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_async] = ACTIONS(2334),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2334),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [sym_number] = ACTIONS(2330),
    [sym_private_property_identifier] = ACTIONS(2330),
    [anon_sym_static] = ACTIONS(2334),
    [anon_sym_readonly] = ACTIONS(2334),
    [anon_sym_get] = ACTIONS(2334),
    [anon_sym_set] = ACTIONS(2334),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_declare] = ACTIONS(2334),
    [anon_sym_public] = ACTIONS(2334),
    [anon_sym_private] = ACTIONS(2334),
    [anon_sym_protected] = ACTIONS(2334),
    [anon_sym_override] = ACTIONS(2334),
    [anon_sym_module] = ACTIONS(2334),
    [anon_sym_any] = ACTIONS(2334),
    [anon_sym_number] = ACTIONS(2334),
    [anon_sym_boolean] = ACTIONS(2334),
    [anon_sym_string] = ACTIONS(2334),
    [anon_sym_symbol] = ACTIONS(2334),
    [anon_sym_object] = ACTIONS(2334),
    [anon_sym_property] = ACTIONS(2334),
    [anon_sym_signal] = ACTIONS(2334),
    [anon_sym_on] = ACTIONS(2334),
    [anon_sym_required] = ACTIONS(2334),
    [anon_sym_component] = ACTIONS(2334),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [667] = {
    [sym_string] = STATE(3955),
    [sym_comment] = STATE(667),
    [sym__property_name] = STATE(4068),
    [sym_computed_property_name] = STATE(3955),
    [aux_sym_object_repeat1] = STATE(5251),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(2334),
    [anon_sym_export] = ACTIONS(2334),
    [anon_sym_STAR] = ACTIONS(2314),
    [anon_sym_type] = ACTIONS(2334),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2334),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(791),
    [anon_sym_from] = ACTIONS(2334),
    [anon_sym_let] = ACTIONS(2334),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2334),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(2321),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_async] = ACTIONS(2339),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2334),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [sym_number] = ACTIONS(2330),
    [sym_private_property_identifier] = ACTIONS(2330),
    [anon_sym_static] = ACTIONS(2334),
    [anon_sym_readonly] = ACTIONS(2334),
    [anon_sym_get] = ACTIONS(2346),
    [anon_sym_set] = ACTIONS(2346),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_declare] = ACTIONS(2334),
    [anon_sym_public] = ACTIONS(2334),
    [anon_sym_private] = ACTIONS(2334),
    [anon_sym_protected] = ACTIONS(2334),
    [anon_sym_override] = ACTIONS(2334),
    [anon_sym_module] = ACTIONS(2334),
    [anon_sym_any] = ACTIONS(2334),
    [anon_sym_number] = ACTIONS(2334),
    [anon_sym_boolean] = ACTIONS(2334),
    [anon_sym_string] = ACTIONS(2334),
    [anon_sym_symbol] = ACTIONS(2334),
    [anon_sym_object] = ACTIONS(2334),
    [anon_sym_property] = ACTIONS(2334),
    [anon_sym_signal] = ACTIONS(2334),
    [anon_sym_on] = ACTIONS(2334),
    [anon_sym_required] = ACTIONS(2334),
    [anon_sym_component] = ACTIONS(2334),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [668] = {
    [sym_string] = STATE(3955),
    [sym_comment] = STATE(668),
    [sym__property_name] = STATE(4068),
    [sym_computed_property_name] = STATE(3955),
    [aux_sym_object_repeat1] = STATE(4915),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(2334),
    [anon_sym_export] = ACTIONS(2334),
    [anon_sym_STAR] = ACTIONS(2314),
    [anon_sym_type] = ACTIONS(2334),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2334),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(781),
    [anon_sym_from] = ACTIONS(2334),
    [anon_sym_let] = ACTIONS(2334),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2334),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(2321),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_async] = ACTIONS(2339),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2334),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [sym_number] = ACTIONS(2330),
    [sym_private_property_identifier] = ACTIONS(2330),
    [anon_sym_static] = ACTIONS(2334),
    [anon_sym_readonly] = ACTIONS(2334),
    [anon_sym_get] = ACTIONS(2346),
    [anon_sym_set] = ACTIONS(2346),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_declare] = ACTIONS(2334),
    [anon_sym_public] = ACTIONS(2334),
    [anon_sym_private] = ACTIONS(2334),
    [anon_sym_protected] = ACTIONS(2334),
    [anon_sym_override] = ACTIONS(2334),
    [anon_sym_module] = ACTIONS(2334),
    [anon_sym_any] = ACTIONS(2334),
    [anon_sym_number] = ACTIONS(2334),
    [anon_sym_boolean] = ACTIONS(2334),
    [anon_sym_string] = ACTIONS(2334),
    [anon_sym_symbol] = ACTIONS(2334),
    [anon_sym_object] = ACTIONS(2334),
    [anon_sym_property] = ACTIONS(2334),
    [anon_sym_signal] = ACTIONS(2334),
    [anon_sym_on] = ACTIONS(2334),
    [anon_sym_required] = ACTIONS(2334),
    [anon_sym_component] = ACTIONS(2334),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [669] = {
    [sym_string] = STATE(3955),
    [sym_comment] = STATE(669),
    [sym__property_name] = STATE(4068),
    [sym_computed_property_name] = STATE(3955),
    [aux_sym_object_repeat1] = STATE(4915),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(2334),
    [anon_sym_export] = ACTIONS(2334),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2334),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2334),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(754),
    [anon_sym_from] = ACTIONS(2334),
    [anon_sym_let] = ACTIONS(2334),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2334),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(2321),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_async] = ACTIONS(2334),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2334),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [sym_number] = ACTIONS(2330),
    [sym_private_property_identifier] = ACTIONS(2330),
    [anon_sym_static] = ACTIONS(2334),
    [anon_sym_readonly] = ACTIONS(2334),
    [anon_sym_get] = ACTIONS(2334),
    [anon_sym_set] = ACTIONS(2334),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_declare] = ACTIONS(2334),
    [anon_sym_public] = ACTIONS(2334),
    [anon_sym_private] = ACTIONS(2334),
    [anon_sym_protected] = ACTIONS(2334),
    [anon_sym_override] = ACTIONS(2334),
    [anon_sym_module] = ACTIONS(2334),
    [anon_sym_any] = ACTIONS(2334),
    [anon_sym_number] = ACTIONS(2334),
    [anon_sym_boolean] = ACTIONS(2334),
    [anon_sym_string] = ACTIONS(2334),
    [anon_sym_symbol] = ACTIONS(2334),
    [anon_sym_object] = ACTIONS(2334),
    [anon_sym_property] = ACTIONS(2334),
    [anon_sym_signal] = ACTIONS(2334),
    [anon_sym_on] = ACTIONS(2334),
    [anon_sym_required] = ACTIONS(2334),
    [anon_sym_component] = ACTIONS(2334),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [670] = {
    [sym_string] = STATE(3955),
    [sym_comment] = STATE(670),
    [sym__property_name] = STATE(4068),
    [sym_computed_property_name] = STATE(3955),
    [aux_sym_object_repeat1] = STATE(4915),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(2334),
    [anon_sym_export] = ACTIONS(2334),
    [anon_sym_STAR] = ACTIONS(2314),
    [anon_sym_type] = ACTIONS(2334),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2334),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(777),
    [anon_sym_from] = ACTIONS(2334),
    [anon_sym_let] = ACTIONS(2334),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2334),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(2321),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_async] = ACTIONS(2339),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2334),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [sym_number] = ACTIONS(2330),
    [sym_private_property_identifier] = ACTIONS(2330),
    [anon_sym_static] = ACTIONS(2334),
    [anon_sym_readonly] = ACTIONS(2334),
    [anon_sym_get] = ACTIONS(2346),
    [anon_sym_set] = ACTIONS(2346),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_declare] = ACTIONS(2334),
    [anon_sym_public] = ACTIONS(2334),
    [anon_sym_private] = ACTIONS(2334),
    [anon_sym_protected] = ACTIONS(2334),
    [anon_sym_override] = ACTIONS(2334),
    [anon_sym_module] = ACTIONS(2334),
    [anon_sym_any] = ACTIONS(2334),
    [anon_sym_number] = ACTIONS(2334),
    [anon_sym_boolean] = ACTIONS(2334),
    [anon_sym_string] = ACTIONS(2334),
    [anon_sym_symbol] = ACTIONS(2334),
    [anon_sym_object] = ACTIONS(2334),
    [anon_sym_property] = ACTIONS(2334),
    [anon_sym_signal] = ACTIONS(2334),
    [anon_sym_on] = ACTIONS(2334),
    [anon_sym_required] = ACTIONS(2334),
    [anon_sym_component] = ACTIONS(2334),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [671] = {
    [sym_string] = STATE(3955),
    [sym_comment] = STATE(671),
    [sym__property_name] = STATE(4068),
    [sym_computed_property_name] = STATE(3955),
    [aux_sym_object_repeat1] = STATE(4915),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(2334),
    [anon_sym_export] = ACTIONS(2334),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2334),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2334),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(777),
    [anon_sym_from] = ACTIONS(2334),
    [anon_sym_let] = ACTIONS(2334),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2334),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(2321),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_async] = ACTIONS(2334),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2334),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [sym_number] = ACTIONS(2330),
    [sym_private_property_identifier] = ACTIONS(2330),
    [anon_sym_static] = ACTIONS(2334),
    [anon_sym_readonly] = ACTIONS(2334),
    [anon_sym_get] = ACTIONS(2334),
    [anon_sym_set] = ACTIONS(2334),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_declare] = ACTIONS(2334),
    [anon_sym_public] = ACTIONS(2334),
    [anon_sym_private] = ACTIONS(2334),
    [anon_sym_protected] = ACTIONS(2334),
    [anon_sym_override] = ACTIONS(2334),
    [anon_sym_module] = ACTIONS(2334),
    [anon_sym_any] = ACTIONS(2334),
    [anon_sym_number] = ACTIONS(2334),
    [anon_sym_boolean] = ACTIONS(2334),
    [anon_sym_string] = ACTIONS(2334),
    [anon_sym_symbol] = ACTIONS(2334),
    [anon_sym_object] = ACTIONS(2334),
    [anon_sym_property] = ACTIONS(2334),
    [anon_sym_signal] = ACTIONS(2334),
    [anon_sym_on] = ACTIONS(2334),
    [anon_sym_required] = ACTIONS(2334),
    [anon_sym_component] = ACTIONS(2334),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [672] = {
    [sym_namespace_export] = STATE(5561),
    [sym_export_clause] = STATE(4745),
    [sym_declaration] = STATE(833),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_class_declaration] = STATE(829),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function_declaration] = STATE(829),
    [sym_comment] = STATE(672),
    [sym_decorator] = STATE(1202),
    [sym_function_signature] = STATE(829),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(831),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [aux_sym_export_statement_repeat1] = STATE(4313),
    [aux_sym_object_repeat1] = STATE(5251),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [anon_sym_STAR] = ACTIONS(2350),
    [anon_sym_default] = ACTIONS(2352),
    [anon_sym_type] = ACTIONS(2354),
    [anon_sym_EQ] = ACTIONS(2356),
    [anon_sym_as] = ACTIONS(2358),
    [anon_sym_namespace] = ACTIONS(2360),
    [anon_sym_LBRACE] = ACTIONS(2362),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(791),
    [anon_sym_import] = ACTIONS(2364),
    [anon_sym_var] = ACTIONS(2366),
    [anon_sym_let] = ACTIONS(2368),
    [anon_sym_const] = ACTIONS(2370),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_class] = ACTIONS(2372),
    [anon_sym_async] = ACTIONS(2374),
    [anon_sym_function] = ACTIONS(2376),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(70),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_declare] = ACTIONS(2378),
    [anon_sym_module] = ACTIONS(2380),
    [anon_sym_abstract] = ACTIONS(2382),
    [anon_sym_satisfies] = ACTIONS(70),
    [anon_sym_interface] = ACTIONS(2384),
    [anon_sym_enum] = ACTIONS(2386),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [673] = {
    [sym_namespace_export] = STATE(5561),
    [sym_export_clause] = STATE(4745),
    [sym_declaration] = STATE(833),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_class_declaration] = STATE(829),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function_declaration] = STATE(829),
    [sym_comment] = STATE(673),
    [sym_decorator] = STATE(1202),
    [sym_function_signature] = STATE(829),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(831),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [aux_sym_export_statement_repeat1] = STATE(4313),
    [aux_sym_object_repeat1] = STATE(4915),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [anon_sym_STAR] = ACTIONS(2350),
    [anon_sym_default] = ACTIONS(2352),
    [anon_sym_type] = ACTIONS(2354),
    [anon_sym_EQ] = ACTIONS(2356),
    [anon_sym_as] = ACTIONS(2358),
    [anon_sym_namespace] = ACTIONS(2360),
    [anon_sym_LBRACE] = ACTIONS(2362),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(781),
    [anon_sym_import] = ACTIONS(2364),
    [anon_sym_var] = ACTIONS(2366),
    [anon_sym_let] = ACTIONS(2368),
    [anon_sym_const] = ACTIONS(2370),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_class] = ACTIONS(2372),
    [anon_sym_async] = ACTIONS(2374),
    [anon_sym_function] = ACTIONS(2376),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(70),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_declare] = ACTIONS(2378),
    [anon_sym_module] = ACTIONS(2380),
    [anon_sym_abstract] = ACTIONS(2382),
    [anon_sym_satisfies] = ACTIONS(70),
    [anon_sym_interface] = ACTIONS(2384),
    [anon_sym_enum] = ACTIONS(2386),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [674] = {
    [sym_namespace_export] = STATE(5561),
    [sym_export_clause] = STATE(4745),
    [sym_declaration] = STATE(833),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_class_declaration] = STATE(829),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function_declaration] = STATE(829),
    [sym_comment] = STATE(674),
    [sym_decorator] = STATE(1202),
    [sym_function_signature] = STATE(829),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(831),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [aux_sym_export_statement_repeat1] = STATE(4313),
    [aux_sym_object_repeat1] = STATE(4915),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [anon_sym_STAR] = ACTIONS(2350),
    [anon_sym_default] = ACTIONS(2352),
    [anon_sym_type] = ACTIONS(2354),
    [anon_sym_EQ] = ACTIONS(2356),
    [anon_sym_as] = ACTIONS(2358),
    [anon_sym_namespace] = ACTIONS(2360),
    [anon_sym_LBRACE] = ACTIONS(2362),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(754),
    [anon_sym_import] = ACTIONS(2364),
    [anon_sym_var] = ACTIONS(2366),
    [anon_sym_let] = ACTIONS(2368),
    [anon_sym_const] = ACTIONS(2370),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_class] = ACTIONS(2372),
    [anon_sym_async] = ACTIONS(2374),
    [anon_sym_function] = ACTIONS(2376),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(70),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_declare] = ACTIONS(2378),
    [anon_sym_module] = ACTIONS(2380),
    [anon_sym_abstract] = ACTIONS(2382),
    [anon_sym_satisfies] = ACTIONS(70),
    [anon_sym_interface] = ACTIONS(2384),
    [anon_sym_enum] = ACTIONS(2386),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [675] = {
    [sym_namespace_export] = STATE(5561),
    [sym_export_clause] = STATE(4745),
    [sym_declaration] = STATE(833),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_class_declaration] = STATE(829),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function_declaration] = STATE(829),
    [sym_comment] = STATE(675),
    [sym_decorator] = STATE(1202),
    [sym_function_signature] = STATE(829),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(831),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [aux_sym_export_statement_repeat1] = STATE(4313),
    [aux_sym_object_repeat1] = STATE(4915),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [anon_sym_STAR] = ACTIONS(2350),
    [anon_sym_default] = ACTIONS(2352),
    [anon_sym_type] = ACTIONS(2354),
    [anon_sym_EQ] = ACTIONS(2356),
    [anon_sym_as] = ACTIONS(2358),
    [anon_sym_namespace] = ACTIONS(2360),
    [anon_sym_LBRACE] = ACTIONS(2362),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(777),
    [anon_sym_import] = ACTIONS(2364),
    [anon_sym_var] = ACTIONS(2366),
    [anon_sym_let] = ACTIONS(2368),
    [anon_sym_const] = ACTIONS(2370),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_class] = ACTIONS(2372),
    [anon_sym_async] = ACTIONS(2374),
    [anon_sym_function] = ACTIONS(2376),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(70),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_declare] = ACTIONS(2378),
    [anon_sym_module] = ACTIONS(2380),
    [anon_sym_abstract] = ACTIONS(2382),
    [anon_sym_satisfies] = ACTIONS(70),
    [anon_sym_interface] = ACTIONS(2384),
    [anon_sym_enum] = ACTIONS(2386),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [676] = {
    [sym_comment] = STATE(676),
    [sym_identifier] = ACTIONS(2388),
    [anon_sym_export] = ACTIONS(2388),
    [anon_sym_default] = ACTIONS(2388),
    [anon_sym_type] = ACTIONS(2388),
    [anon_sym_EQ] = ACTIONS(2388),
    [anon_sym_namespace] = ACTIONS(2388),
    [anon_sym_LBRACE] = ACTIONS(2390),
    [anon_sym_COMMA] = ACTIONS(2390),
    [anon_sym_RBRACE] = ACTIONS(2390),
    [anon_sym_typeof] = ACTIONS(2388),
    [anon_sym_import] = ACTIONS(2388),
    [anon_sym_from] = ACTIONS(2388),
    [anon_sym_with] = ACTIONS(2388),
    [anon_sym_var] = ACTIONS(2388),
    [anon_sym_let] = ACTIONS(2388),
    [anon_sym_const] = ACTIONS(2388),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_else] = ACTIONS(2388),
    [anon_sym_if] = ACTIONS(2388),
    [anon_sym_switch] = ACTIONS(2388),
    [anon_sym_for] = ACTIONS(2388),
    [anon_sym_LPAREN] = ACTIONS(2390),
    [anon_sym_RPAREN] = ACTIONS(2390),
    [anon_sym_await] = ACTIONS(2388),
    [anon_sym_of] = ACTIONS(2388),
    [anon_sym_while] = ACTIONS(2388),
    [anon_sym_do] = ACTIONS(2388),
    [anon_sym_try] = ACTIONS(2388),
    [anon_sym_break] = ACTIONS(2388),
    [anon_sym_continue] = ACTIONS(2388),
    [anon_sym_debugger] = ACTIONS(2388),
    [anon_sym_return] = ACTIONS(2388),
    [anon_sym_throw] = ACTIONS(2388),
    [anon_sym_SEMI] = ACTIONS(2390),
    [anon_sym_COLON] = ACTIONS(2390),
    [anon_sym_case] = ACTIONS(2388),
    [anon_sym_yield] = ACTIONS(2388),
    [anon_sym_LBRACK] = ACTIONS(2390),
    [anon_sym_RBRACK] = ACTIONS(2390),
    [anon_sym_LTtemplate_GT] = ACTIONS(2390),
    [anon_sym_GT] = ACTIONS(2390),
    [anon_sym_DQUOTE] = ACTIONS(2390),
    [anon_sym_SQUOTE] = ACTIONS(2390),
    [anon_sym_class] = ACTIONS(2388),
    [anon_sym_async] = ACTIONS(2388),
    [anon_sym_function] = ACTIONS(2388),
    [anon_sym_EQ_GT] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2388),
    [anon_sym_using] = ACTIONS(2388),
    [anon_sym_AMP] = ACTIONS(2390),
    [anon_sym_PIPE] = ACTIONS(2390),
    [anon_sym_PLUS] = ACTIONS(2388),
    [anon_sym_DASH] = ACTIONS(2388),
    [anon_sym_SLASH] = ACTIONS(2388),
    [anon_sym_LT] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2390),
    [anon_sym_void] = ACTIONS(2388),
    [anon_sym_delete] = ACTIONS(2388),
    [anon_sym_PLUS_PLUS] = ACTIONS(2390),
    [anon_sym_DASH_DASH] = ACTIONS(2390),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2390),
    [sym_number] = ACTIONS(2390),
    [sym_private_property_identifier] = ACTIONS(2390),
    [sym_this] = ACTIONS(2388),
    [sym_super] = ACTIONS(2388),
    [sym_true] = ACTIONS(2388),
    [sym_false] = ACTIONS(2388),
    [sym_null] = ACTIONS(2388),
    [sym_undefined] = ACTIONS(2388),
    [anon_sym_AT] = ACTIONS(2390),
    [anon_sym_static] = ACTIONS(2388),
    [anon_sym_readonly] = ACTIONS(2388),
    [anon_sym_get] = ACTIONS(2388),
    [anon_sym_set] = ACTIONS(2388),
    [anon_sym_QMARK] = ACTIONS(2390),
    [anon_sym_declare] = ACTIONS(2388),
    [anon_sym_public] = ACTIONS(2388),
    [anon_sym_private] = ACTIONS(2388),
    [anon_sym_protected] = ACTIONS(2388),
    [anon_sym_override] = ACTIONS(2388),
    [anon_sym_module] = ACTIONS(2388),
    [anon_sym_any] = ACTIONS(2388),
    [anon_sym_number] = ACTIONS(2388),
    [anon_sym_boolean] = ACTIONS(2388),
    [anon_sym_string] = ACTIONS(2388),
    [anon_sym_symbol] = ACTIONS(2388),
    [anon_sym_object] = ACTIONS(2388),
    [anon_sym_property] = ACTIONS(2388),
    [anon_sym_signal] = ACTIONS(2388),
    [anon_sym_on] = ACTIONS(2388),
    [anon_sym_required] = ACTIONS(2388),
    [anon_sym_component] = ACTIONS(2388),
    [anon_sym_abstract] = ACTIONS(2388),
    [anon_sym_extends] = ACTIONS(2388),
    [anon_sym_interface] = ACTIONS(2388),
    [anon_sym_enum] = ACTIONS(2388),
    [sym_html_comment] = ACTIONS(5),
  },
  [677] = {
    [sym_comment] = STATE(677),
    [sym_identifier] = ACTIONS(2392),
    [anon_sym_export] = ACTIONS(2392),
    [anon_sym_default] = ACTIONS(2392),
    [anon_sym_type] = ACTIONS(2392),
    [anon_sym_EQ] = ACTIONS(2392),
    [anon_sym_namespace] = ACTIONS(2392),
    [anon_sym_LBRACE] = ACTIONS(2394),
    [anon_sym_COMMA] = ACTIONS(2394),
    [anon_sym_RBRACE] = ACTIONS(2394),
    [anon_sym_typeof] = ACTIONS(2392),
    [anon_sym_import] = ACTIONS(2392),
    [anon_sym_from] = ACTIONS(2392),
    [anon_sym_with] = ACTIONS(2392),
    [anon_sym_var] = ACTIONS(2392),
    [anon_sym_let] = ACTIONS(2392),
    [anon_sym_const] = ACTIONS(2392),
    [anon_sym_BANG] = ACTIONS(2394),
    [anon_sym_else] = ACTIONS(2392),
    [anon_sym_if] = ACTIONS(2392),
    [anon_sym_switch] = ACTIONS(2392),
    [anon_sym_for] = ACTIONS(2392),
    [anon_sym_LPAREN] = ACTIONS(2394),
    [anon_sym_RPAREN] = ACTIONS(2394),
    [anon_sym_await] = ACTIONS(2392),
    [anon_sym_of] = ACTIONS(2392),
    [anon_sym_while] = ACTIONS(2392),
    [anon_sym_do] = ACTIONS(2392),
    [anon_sym_try] = ACTIONS(2392),
    [anon_sym_break] = ACTIONS(2392),
    [anon_sym_continue] = ACTIONS(2392),
    [anon_sym_debugger] = ACTIONS(2392),
    [anon_sym_return] = ACTIONS(2392),
    [anon_sym_throw] = ACTIONS(2392),
    [anon_sym_SEMI] = ACTIONS(2394),
    [anon_sym_COLON] = ACTIONS(2394),
    [anon_sym_case] = ACTIONS(2392),
    [anon_sym_yield] = ACTIONS(2392),
    [anon_sym_LBRACK] = ACTIONS(2394),
    [anon_sym_RBRACK] = ACTIONS(2394),
    [anon_sym_LTtemplate_GT] = ACTIONS(2394),
    [anon_sym_GT] = ACTIONS(2394),
    [anon_sym_DQUOTE] = ACTIONS(2394),
    [anon_sym_SQUOTE] = ACTIONS(2394),
    [anon_sym_class] = ACTIONS(2392),
    [anon_sym_async] = ACTIONS(2392),
    [anon_sym_function] = ACTIONS(2392),
    [anon_sym_EQ_GT] = ACTIONS(2394),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_using] = ACTIONS(2392),
    [anon_sym_AMP] = ACTIONS(2394),
    [anon_sym_PIPE] = ACTIONS(2394),
    [anon_sym_PLUS] = ACTIONS(2392),
    [anon_sym_DASH] = ACTIONS(2392),
    [anon_sym_SLASH] = ACTIONS(2392),
    [anon_sym_LT] = ACTIONS(2392),
    [anon_sym_TILDE] = ACTIONS(2394),
    [anon_sym_void] = ACTIONS(2392),
    [anon_sym_delete] = ACTIONS(2392),
    [anon_sym_PLUS_PLUS] = ACTIONS(2394),
    [anon_sym_DASH_DASH] = ACTIONS(2394),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2394),
    [sym_number] = ACTIONS(2394),
    [sym_private_property_identifier] = ACTIONS(2394),
    [sym_this] = ACTIONS(2392),
    [sym_super] = ACTIONS(2392),
    [sym_true] = ACTIONS(2392),
    [sym_false] = ACTIONS(2392),
    [sym_null] = ACTIONS(2392),
    [sym_undefined] = ACTIONS(2392),
    [anon_sym_AT] = ACTIONS(2394),
    [anon_sym_static] = ACTIONS(2392),
    [anon_sym_readonly] = ACTIONS(2392),
    [anon_sym_get] = ACTIONS(2392),
    [anon_sym_set] = ACTIONS(2392),
    [anon_sym_QMARK] = ACTIONS(2394),
    [anon_sym_declare] = ACTIONS(2392),
    [anon_sym_public] = ACTIONS(2392),
    [anon_sym_private] = ACTIONS(2392),
    [anon_sym_protected] = ACTIONS(2392),
    [anon_sym_override] = ACTIONS(2392),
    [anon_sym_module] = ACTIONS(2392),
    [anon_sym_any] = ACTIONS(2392),
    [anon_sym_number] = ACTIONS(2392),
    [anon_sym_boolean] = ACTIONS(2392),
    [anon_sym_string] = ACTIONS(2392),
    [anon_sym_symbol] = ACTIONS(2392),
    [anon_sym_object] = ACTIONS(2392),
    [anon_sym_property] = ACTIONS(2392),
    [anon_sym_signal] = ACTIONS(2392),
    [anon_sym_on] = ACTIONS(2392),
    [anon_sym_required] = ACTIONS(2392),
    [anon_sym_component] = ACTIONS(2392),
    [anon_sym_abstract] = ACTIONS(2392),
    [anon_sym_extends] = ACTIONS(2392),
    [anon_sym_interface] = ACTIONS(2392),
    [anon_sym_enum] = ACTIONS(2392),
    [sym_html_comment] = ACTIONS(5),
  },
  [678] = {
    [sym_comment] = STATE(678),
    [sym_identifier] = ACTIONS(2396),
    [anon_sym_export] = ACTIONS(2396),
    [anon_sym_default] = ACTIONS(2396),
    [anon_sym_type] = ACTIONS(2396),
    [anon_sym_EQ] = ACTIONS(2396),
    [anon_sym_namespace] = ACTIONS(2396),
    [anon_sym_LBRACE] = ACTIONS(2398),
    [anon_sym_COMMA] = ACTIONS(2398),
    [anon_sym_RBRACE] = ACTIONS(2398),
    [anon_sym_typeof] = ACTIONS(2396),
    [anon_sym_import] = ACTIONS(2396),
    [anon_sym_from] = ACTIONS(2396),
    [anon_sym_with] = ACTIONS(2396),
    [anon_sym_var] = ACTIONS(2396),
    [anon_sym_let] = ACTIONS(2396),
    [anon_sym_const] = ACTIONS(2396),
    [anon_sym_BANG] = ACTIONS(2398),
    [anon_sym_else] = ACTIONS(2396),
    [anon_sym_if] = ACTIONS(2396),
    [anon_sym_switch] = ACTIONS(2396),
    [anon_sym_for] = ACTIONS(2396),
    [anon_sym_LPAREN] = ACTIONS(2398),
    [anon_sym_RPAREN] = ACTIONS(2398),
    [anon_sym_await] = ACTIONS(2396),
    [anon_sym_of] = ACTIONS(2396),
    [anon_sym_while] = ACTIONS(2396),
    [anon_sym_do] = ACTIONS(2396),
    [anon_sym_try] = ACTIONS(2396),
    [anon_sym_break] = ACTIONS(2396),
    [anon_sym_continue] = ACTIONS(2396),
    [anon_sym_debugger] = ACTIONS(2396),
    [anon_sym_return] = ACTIONS(2396),
    [anon_sym_throw] = ACTIONS(2396),
    [anon_sym_SEMI] = ACTIONS(2398),
    [anon_sym_COLON] = ACTIONS(2398),
    [anon_sym_case] = ACTIONS(2396),
    [anon_sym_yield] = ACTIONS(2396),
    [anon_sym_LBRACK] = ACTIONS(2398),
    [anon_sym_RBRACK] = ACTIONS(2398),
    [anon_sym_LTtemplate_GT] = ACTIONS(2398),
    [anon_sym_GT] = ACTIONS(2398),
    [anon_sym_DQUOTE] = ACTIONS(2398),
    [anon_sym_SQUOTE] = ACTIONS(2398),
    [anon_sym_class] = ACTIONS(2396),
    [anon_sym_async] = ACTIONS(2396),
    [anon_sym_function] = ACTIONS(2396),
    [anon_sym_EQ_GT] = ACTIONS(2398),
    [anon_sym_new] = ACTIONS(2396),
    [anon_sym_using] = ACTIONS(2396),
    [anon_sym_AMP] = ACTIONS(2398),
    [anon_sym_PIPE] = ACTIONS(2398),
    [anon_sym_PLUS] = ACTIONS(2396),
    [anon_sym_DASH] = ACTIONS(2396),
    [anon_sym_SLASH] = ACTIONS(2396),
    [anon_sym_LT] = ACTIONS(2396),
    [anon_sym_TILDE] = ACTIONS(2398),
    [anon_sym_void] = ACTIONS(2396),
    [anon_sym_delete] = ACTIONS(2396),
    [anon_sym_PLUS_PLUS] = ACTIONS(2398),
    [anon_sym_DASH_DASH] = ACTIONS(2398),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2398),
    [sym_number] = ACTIONS(2398),
    [sym_private_property_identifier] = ACTIONS(2398),
    [sym_this] = ACTIONS(2396),
    [sym_super] = ACTIONS(2396),
    [sym_true] = ACTIONS(2396),
    [sym_false] = ACTIONS(2396),
    [sym_null] = ACTIONS(2396),
    [sym_undefined] = ACTIONS(2396),
    [anon_sym_AT] = ACTIONS(2398),
    [anon_sym_static] = ACTIONS(2396),
    [anon_sym_readonly] = ACTIONS(2396),
    [anon_sym_get] = ACTIONS(2396),
    [anon_sym_set] = ACTIONS(2396),
    [anon_sym_QMARK] = ACTIONS(2398),
    [anon_sym_declare] = ACTIONS(2396),
    [anon_sym_public] = ACTIONS(2396),
    [anon_sym_private] = ACTIONS(2396),
    [anon_sym_protected] = ACTIONS(2396),
    [anon_sym_override] = ACTIONS(2396),
    [anon_sym_module] = ACTIONS(2396),
    [anon_sym_any] = ACTIONS(2396),
    [anon_sym_number] = ACTIONS(2396),
    [anon_sym_boolean] = ACTIONS(2396),
    [anon_sym_string] = ACTIONS(2396),
    [anon_sym_symbol] = ACTIONS(2396),
    [anon_sym_object] = ACTIONS(2396),
    [anon_sym_property] = ACTIONS(2396),
    [anon_sym_signal] = ACTIONS(2396),
    [anon_sym_on] = ACTIONS(2396),
    [anon_sym_required] = ACTIONS(2396),
    [anon_sym_component] = ACTIONS(2396),
    [anon_sym_abstract] = ACTIONS(2396),
    [anon_sym_extends] = ACTIONS(2396),
    [anon_sym_interface] = ACTIONS(2396),
    [anon_sym_enum] = ACTIONS(2396),
    [sym_html_comment] = ACTIONS(5),
  },
  [679] = {
    [sym_comment] = STATE(679),
    [sym_identifier] = ACTIONS(2400),
    [anon_sym_export] = ACTIONS(2400),
    [anon_sym_default] = ACTIONS(2400),
    [anon_sym_type] = ACTIONS(2400),
    [anon_sym_EQ] = ACTIONS(2400),
    [anon_sym_namespace] = ACTIONS(2400),
    [anon_sym_LBRACE] = ACTIONS(2402),
    [anon_sym_COMMA] = ACTIONS(2402),
    [anon_sym_RBRACE] = ACTIONS(2402),
    [anon_sym_typeof] = ACTIONS(2400),
    [anon_sym_import] = ACTIONS(2400),
    [anon_sym_from] = ACTIONS(2400),
    [anon_sym_with] = ACTIONS(2400),
    [anon_sym_var] = ACTIONS(2400),
    [anon_sym_let] = ACTIONS(2400),
    [anon_sym_const] = ACTIONS(2400),
    [anon_sym_BANG] = ACTIONS(2402),
    [anon_sym_else] = ACTIONS(2400),
    [anon_sym_if] = ACTIONS(2400),
    [anon_sym_switch] = ACTIONS(2400),
    [anon_sym_for] = ACTIONS(2400),
    [anon_sym_LPAREN] = ACTIONS(2402),
    [anon_sym_RPAREN] = ACTIONS(2402),
    [anon_sym_await] = ACTIONS(2400),
    [anon_sym_of] = ACTIONS(2400),
    [anon_sym_while] = ACTIONS(2400),
    [anon_sym_do] = ACTIONS(2400),
    [anon_sym_try] = ACTIONS(2400),
    [anon_sym_break] = ACTIONS(2400),
    [anon_sym_continue] = ACTIONS(2400),
    [anon_sym_debugger] = ACTIONS(2400),
    [anon_sym_return] = ACTIONS(2400),
    [anon_sym_throw] = ACTIONS(2400),
    [anon_sym_SEMI] = ACTIONS(2402),
    [anon_sym_COLON] = ACTIONS(2402),
    [anon_sym_case] = ACTIONS(2400),
    [anon_sym_yield] = ACTIONS(2400),
    [anon_sym_LBRACK] = ACTIONS(2402),
    [anon_sym_RBRACK] = ACTIONS(2402),
    [anon_sym_LTtemplate_GT] = ACTIONS(2402),
    [anon_sym_GT] = ACTIONS(2402),
    [anon_sym_DQUOTE] = ACTIONS(2402),
    [anon_sym_SQUOTE] = ACTIONS(2402),
    [anon_sym_class] = ACTIONS(2400),
    [anon_sym_async] = ACTIONS(2400),
    [anon_sym_function] = ACTIONS(2400),
    [anon_sym_EQ_GT] = ACTIONS(2402),
    [anon_sym_new] = ACTIONS(2400),
    [anon_sym_using] = ACTIONS(2400),
    [anon_sym_AMP] = ACTIONS(2402),
    [anon_sym_PIPE] = ACTIONS(2402),
    [anon_sym_PLUS] = ACTIONS(2400),
    [anon_sym_DASH] = ACTIONS(2400),
    [anon_sym_SLASH] = ACTIONS(2400),
    [anon_sym_LT] = ACTIONS(2400),
    [anon_sym_TILDE] = ACTIONS(2402),
    [anon_sym_void] = ACTIONS(2400),
    [anon_sym_delete] = ACTIONS(2400),
    [anon_sym_PLUS_PLUS] = ACTIONS(2402),
    [anon_sym_DASH_DASH] = ACTIONS(2402),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2402),
    [sym_number] = ACTIONS(2402),
    [sym_private_property_identifier] = ACTIONS(2402),
    [sym_this] = ACTIONS(2400),
    [sym_super] = ACTIONS(2400),
    [sym_true] = ACTIONS(2400),
    [sym_false] = ACTIONS(2400),
    [sym_null] = ACTIONS(2400),
    [sym_undefined] = ACTIONS(2400),
    [anon_sym_AT] = ACTIONS(2402),
    [anon_sym_static] = ACTIONS(2400),
    [anon_sym_readonly] = ACTIONS(2400),
    [anon_sym_get] = ACTIONS(2400),
    [anon_sym_set] = ACTIONS(2400),
    [anon_sym_QMARK] = ACTIONS(2402),
    [anon_sym_declare] = ACTIONS(2400),
    [anon_sym_public] = ACTIONS(2400),
    [anon_sym_private] = ACTIONS(2400),
    [anon_sym_protected] = ACTIONS(2400),
    [anon_sym_override] = ACTIONS(2400),
    [anon_sym_module] = ACTIONS(2400),
    [anon_sym_any] = ACTIONS(2400),
    [anon_sym_number] = ACTIONS(2400),
    [anon_sym_boolean] = ACTIONS(2400),
    [anon_sym_string] = ACTIONS(2400),
    [anon_sym_symbol] = ACTIONS(2400),
    [anon_sym_object] = ACTIONS(2400),
    [anon_sym_property] = ACTIONS(2400),
    [anon_sym_signal] = ACTIONS(2400),
    [anon_sym_on] = ACTIONS(2400),
    [anon_sym_required] = ACTIONS(2400),
    [anon_sym_component] = ACTIONS(2400),
    [anon_sym_abstract] = ACTIONS(2400),
    [anon_sym_extends] = ACTIONS(2400),
    [anon_sym_interface] = ACTIONS(2400),
    [anon_sym_enum] = ACTIONS(2400),
    [sym_html_comment] = ACTIONS(5),
  },
  [680] = {
    [sym_comment] = STATE(680),
    [sym_identifier] = ACTIONS(2404),
    [anon_sym_export] = ACTIONS(2404),
    [anon_sym_default] = ACTIONS(2404),
    [anon_sym_type] = ACTIONS(2404),
    [anon_sym_EQ] = ACTIONS(2404),
    [anon_sym_namespace] = ACTIONS(2404),
    [anon_sym_LBRACE] = ACTIONS(2406),
    [anon_sym_COMMA] = ACTIONS(2406),
    [anon_sym_RBRACE] = ACTIONS(2406),
    [anon_sym_typeof] = ACTIONS(2404),
    [anon_sym_import] = ACTIONS(2404),
    [anon_sym_from] = ACTIONS(2404),
    [anon_sym_with] = ACTIONS(2404),
    [anon_sym_var] = ACTIONS(2404),
    [anon_sym_let] = ACTIONS(2404),
    [anon_sym_const] = ACTIONS(2404),
    [anon_sym_BANG] = ACTIONS(2406),
    [anon_sym_else] = ACTIONS(2404),
    [anon_sym_if] = ACTIONS(2404),
    [anon_sym_switch] = ACTIONS(2404),
    [anon_sym_for] = ACTIONS(2404),
    [anon_sym_LPAREN] = ACTIONS(2406),
    [anon_sym_RPAREN] = ACTIONS(2406),
    [anon_sym_await] = ACTIONS(2404),
    [anon_sym_of] = ACTIONS(2404),
    [anon_sym_while] = ACTIONS(2404),
    [anon_sym_do] = ACTIONS(2404),
    [anon_sym_try] = ACTIONS(2404),
    [anon_sym_break] = ACTIONS(2404),
    [anon_sym_continue] = ACTIONS(2404),
    [anon_sym_debugger] = ACTIONS(2404),
    [anon_sym_return] = ACTIONS(2404),
    [anon_sym_throw] = ACTIONS(2404),
    [anon_sym_SEMI] = ACTIONS(2406),
    [anon_sym_COLON] = ACTIONS(2406),
    [anon_sym_case] = ACTIONS(2404),
    [anon_sym_yield] = ACTIONS(2404),
    [anon_sym_LBRACK] = ACTIONS(2406),
    [anon_sym_RBRACK] = ACTIONS(2406),
    [anon_sym_LTtemplate_GT] = ACTIONS(2406),
    [anon_sym_GT] = ACTIONS(2406),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [anon_sym_SQUOTE] = ACTIONS(2406),
    [anon_sym_class] = ACTIONS(2404),
    [anon_sym_async] = ACTIONS(2404),
    [anon_sym_function] = ACTIONS(2404),
    [anon_sym_EQ_GT] = ACTIONS(2406),
    [anon_sym_new] = ACTIONS(2404),
    [anon_sym_using] = ACTIONS(2404),
    [anon_sym_AMP] = ACTIONS(2406),
    [anon_sym_PIPE] = ACTIONS(2406),
    [anon_sym_PLUS] = ACTIONS(2404),
    [anon_sym_DASH] = ACTIONS(2404),
    [anon_sym_SLASH] = ACTIONS(2404),
    [anon_sym_LT] = ACTIONS(2404),
    [anon_sym_TILDE] = ACTIONS(2406),
    [anon_sym_void] = ACTIONS(2404),
    [anon_sym_delete] = ACTIONS(2404),
    [anon_sym_PLUS_PLUS] = ACTIONS(2406),
    [anon_sym_DASH_DASH] = ACTIONS(2406),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2406),
    [sym_number] = ACTIONS(2406),
    [sym_private_property_identifier] = ACTIONS(2406),
    [sym_this] = ACTIONS(2404),
    [sym_super] = ACTIONS(2404),
    [sym_true] = ACTIONS(2404),
    [sym_false] = ACTIONS(2404),
    [sym_null] = ACTIONS(2404),
    [sym_undefined] = ACTIONS(2404),
    [anon_sym_AT] = ACTIONS(2406),
    [anon_sym_static] = ACTIONS(2404),
    [anon_sym_readonly] = ACTIONS(2404),
    [anon_sym_get] = ACTIONS(2404),
    [anon_sym_set] = ACTIONS(2404),
    [anon_sym_QMARK] = ACTIONS(2406),
    [anon_sym_declare] = ACTIONS(2404),
    [anon_sym_public] = ACTIONS(2404),
    [anon_sym_private] = ACTIONS(2404),
    [anon_sym_protected] = ACTIONS(2404),
    [anon_sym_override] = ACTIONS(2404),
    [anon_sym_module] = ACTIONS(2404),
    [anon_sym_any] = ACTIONS(2404),
    [anon_sym_number] = ACTIONS(2404),
    [anon_sym_boolean] = ACTIONS(2404),
    [anon_sym_string] = ACTIONS(2404),
    [anon_sym_symbol] = ACTIONS(2404),
    [anon_sym_object] = ACTIONS(2404),
    [anon_sym_property] = ACTIONS(2404),
    [anon_sym_signal] = ACTIONS(2404),
    [anon_sym_on] = ACTIONS(2404),
    [anon_sym_required] = ACTIONS(2404),
    [anon_sym_component] = ACTIONS(2404),
    [anon_sym_abstract] = ACTIONS(2404),
    [anon_sym_extends] = ACTIONS(2404),
    [anon_sym_interface] = ACTIONS(2404),
    [anon_sym_enum] = ACTIONS(2404),
    [sym_html_comment] = ACTIONS(5),
  },
  [681] = {
    [sym_comment] = STATE(681),
    [aux_sym_object_repeat1] = STATE(4915),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(2098),
    [anon_sym_export] = ACTIONS(2098),
    [anon_sym_STAR] = ACTIONS(2098),
    [anon_sym_type] = ACTIONS(2098),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2098),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(754),
    [anon_sym_from] = ACTIONS(2098),
    [anon_sym_let] = ACTIONS(2098),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2098),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(2100),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(2100),
    [anon_sym_SQUOTE] = ACTIONS(2100),
    [anon_sym_async] = ACTIONS(2098),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2098),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [sym_number] = ACTIONS(2100),
    [sym_private_property_identifier] = ACTIONS(2100),
    [anon_sym_static] = ACTIONS(2098),
    [anon_sym_readonly] = ACTIONS(2098),
    [anon_sym_get] = ACTIONS(2098),
    [anon_sym_set] = ACTIONS(2098),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_declare] = ACTIONS(2098),
    [anon_sym_public] = ACTIONS(2098),
    [anon_sym_private] = ACTIONS(2098),
    [anon_sym_protected] = ACTIONS(2098),
    [anon_sym_override] = ACTIONS(2098),
    [anon_sym_module] = ACTIONS(2098),
    [anon_sym_any] = ACTIONS(2098),
    [anon_sym_number] = ACTIONS(2098),
    [anon_sym_boolean] = ACTIONS(2098),
    [anon_sym_string] = ACTIONS(2098),
    [anon_sym_symbol] = ACTIONS(2098),
    [anon_sym_object] = ACTIONS(2098),
    [anon_sym_property] = ACTIONS(2098),
    [anon_sym_signal] = ACTIONS(2098),
    [anon_sym_on] = ACTIONS(2098),
    [anon_sym_required] = ACTIONS(2098),
    [anon_sym_component] = ACTIONS(2098),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [682] = {
    [sym_comment] = STATE(682),
    [aux_sym_object_repeat1] = STATE(4915),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(2098),
    [anon_sym_export] = ACTIONS(2098),
    [anon_sym_STAR] = ACTIONS(2098),
    [anon_sym_type] = ACTIONS(2098),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2098),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(781),
    [anon_sym_from] = ACTIONS(2098),
    [anon_sym_let] = ACTIONS(2098),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2098),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(2100),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(2100),
    [anon_sym_SQUOTE] = ACTIONS(2100),
    [anon_sym_async] = ACTIONS(2098),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2098),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [sym_number] = ACTIONS(2100),
    [sym_private_property_identifier] = ACTIONS(2100),
    [anon_sym_static] = ACTIONS(2098),
    [anon_sym_readonly] = ACTIONS(2098),
    [anon_sym_get] = ACTIONS(2098),
    [anon_sym_set] = ACTIONS(2098),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_declare] = ACTIONS(2098),
    [anon_sym_public] = ACTIONS(2098),
    [anon_sym_private] = ACTIONS(2098),
    [anon_sym_protected] = ACTIONS(2098),
    [anon_sym_override] = ACTIONS(2098),
    [anon_sym_module] = ACTIONS(2098),
    [anon_sym_any] = ACTIONS(2098),
    [anon_sym_number] = ACTIONS(2098),
    [anon_sym_boolean] = ACTIONS(2098),
    [anon_sym_string] = ACTIONS(2098),
    [anon_sym_symbol] = ACTIONS(2098),
    [anon_sym_object] = ACTIONS(2098),
    [anon_sym_property] = ACTIONS(2098),
    [anon_sym_signal] = ACTIONS(2098),
    [anon_sym_on] = ACTIONS(2098),
    [anon_sym_required] = ACTIONS(2098),
    [anon_sym_component] = ACTIONS(2098),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [683] = {
    [sym_comment] = STATE(683),
    [aux_sym_object_repeat1] = STATE(5251),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(2102),
    [anon_sym_export] = ACTIONS(2102),
    [anon_sym_STAR] = ACTIONS(2102),
    [anon_sym_type] = ACTIONS(2102),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2102),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(791),
    [anon_sym_from] = ACTIONS(2102),
    [anon_sym_let] = ACTIONS(2102),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2102),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(2104),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(2104),
    [anon_sym_SQUOTE] = ACTIONS(2104),
    [anon_sym_async] = ACTIONS(2102),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2102),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [sym_number] = ACTIONS(2104),
    [sym_private_property_identifier] = ACTIONS(2104),
    [anon_sym_static] = ACTIONS(2102),
    [anon_sym_readonly] = ACTIONS(2102),
    [anon_sym_get] = ACTIONS(2102),
    [anon_sym_set] = ACTIONS(2102),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_declare] = ACTIONS(2102),
    [anon_sym_public] = ACTIONS(2102),
    [anon_sym_private] = ACTIONS(2102),
    [anon_sym_protected] = ACTIONS(2102),
    [anon_sym_override] = ACTIONS(2102),
    [anon_sym_module] = ACTIONS(2102),
    [anon_sym_any] = ACTIONS(2102),
    [anon_sym_number] = ACTIONS(2102),
    [anon_sym_boolean] = ACTIONS(2102),
    [anon_sym_string] = ACTIONS(2102),
    [anon_sym_symbol] = ACTIONS(2102),
    [anon_sym_object] = ACTIONS(2102),
    [anon_sym_property] = ACTIONS(2102),
    [anon_sym_signal] = ACTIONS(2102),
    [anon_sym_on] = ACTIONS(2102),
    [anon_sym_required] = ACTIONS(2102),
    [anon_sym_component] = ACTIONS(2102),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [684] = {
    [sym_comment] = STATE(684),
    [aux_sym_object_repeat1] = STATE(5251),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(2098),
    [anon_sym_export] = ACTIONS(2098),
    [anon_sym_STAR] = ACTIONS(2098),
    [anon_sym_type] = ACTIONS(2098),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2098),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(791),
    [anon_sym_from] = ACTIONS(2098),
    [anon_sym_let] = ACTIONS(2098),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2098),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(2100),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(2100),
    [anon_sym_SQUOTE] = ACTIONS(2100),
    [anon_sym_async] = ACTIONS(2098),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2098),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [sym_number] = ACTIONS(2100),
    [sym_private_property_identifier] = ACTIONS(2100),
    [anon_sym_static] = ACTIONS(2098),
    [anon_sym_readonly] = ACTIONS(2098),
    [anon_sym_get] = ACTIONS(2098),
    [anon_sym_set] = ACTIONS(2098),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_declare] = ACTIONS(2098),
    [anon_sym_public] = ACTIONS(2098),
    [anon_sym_private] = ACTIONS(2098),
    [anon_sym_protected] = ACTIONS(2098),
    [anon_sym_override] = ACTIONS(2098),
    [anon_sym_module] = ACTIONS(2098),
    [anon_sym_any] = ACTIONS(2098),
    [anon_sym_number] = ACTIONS(2098),
    [anon_sym_boolean] = ACTIONS(2098),
    [anon_sym_string] = ACTIONS(2098),
    [anon_sym_symbol] = ACTIONS(2098),
    [anon_sym_object] = ACTIONS(2098),
    [anon_sym_property] = ACTIONS(2098),
    [anon_sym_signal] = ACTIONS(2098),
    [anon_sym_on] = ACTIONS(2098),
    [anon_sym_required] = ACTIONS(2098),
    [anon_sym_component] = ACTIONS(2098),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [685] = {
    [sym_comment] = STATE(685),
    [aux_sym_object_repeat1] = STATE(4915),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(2102),
    [anon_sym_export] = ACTIONS(2102),
    [anon_sym_STAR] = ACTIONS(2102),
    [anon_sym_type] = ACTIONS(2102),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2102),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(781),
    [anon_sym_from] = ACTIONS(2102),
    [anon_sym_let] = ACTIONS(2102),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2102),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(2104),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(2104),
    [anon_sym_SQUOTE] = ACTIONS(2104),
    [anon_sym_async] = ACTIONS(2102),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2102),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [sym_number] = ACTIONS(2104),
    [sym_private_property_identifier] = ACTIONS(2104),
    [anon_sym_static] = ACTIONS(2102),
    [anon_sym_readonly] = ACTIONS(2102),
    [anon_sym_get] = ACTIONS(2102),
    [anon_sym_set] = ACTIONS(2102),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_declare] = ACTIONS(2102),
    [anon_sym_public] = ACTIONS(2102),
    [anon_sym_private] = ACTIONS(2102),
    [anon_sym_protected] = ACTIONS(2102),
    [anon_sym_override] = ACTIONS(2102),
    [anon_sym_module] = ACTIONS(2102),
    [anon_sym_any] = ACTIONS(2102),
    [anon_sym_number] = ACTIONS(2102),
    [anon_sym_boolean] = ACTIONS(2102),
    [anon_sym_string] = ACTIONS(2102),
    [anon_sym_symbol] = ACTIONS(2102),
    [anon_sym_object] = ACTIONS(2102),
    [anon_sym_property] = ACTIONS(2102),
    [anon_sym_signal] = ACTIONS(2102),
    [anon_sym_on] = ACTIONS(2102),
    [anon_sym_required] = ACTIONS(2102),
    [anon_sym_component] = ACTIONS(2102),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [686] = {
    [sym_comment] = STATE(686),
    [aux_sym_object_repeat1] = STATE(4915),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(2102),
    [anon_sym_export] = ACTIONS(2102),
    [anon_sym_STAR] = ACTIONS(2102),
    [anon_sym_type] = ACTIONS(2102),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2102),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(777),
    [anon_sym_from] = ACTIONS(2102),
    [anon_sym_let] = ACTIONS(2102),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2102),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(2104),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(2104),
    [anon_sym_SQUOTE] = ACTIONS(2104),
    [anon_sym_async] = ACTIONS(2102),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2102),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [sym_number] = ACTIONS(2104),
    [sym_private_property_identifier] = ACTIONS(2104),
    [anon_sym_static] = ACTIONS(2102),
    [anon_sym_readonly] = ACTIONS(2102),
    [anon_sym_get] = ACTIONS(2102),
    [anon_sym_set] = ACTIONS(2102),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_declare] = ACTIONS(2102),
    [anon_sym_public] = ACTIONS(2102),
    [anon_sym_private] = ACTIONS(2102),
    [anon_sym_protected] = ACTIONS(2102),
    [anon_sym_override] = ACTIONS(2102),
    [anon_sym_module] = ACTIONS(2102),
    [anon_sym_any] = ACTIONS(2102),
    [anon_sym_number] = ACTIONS(2102),
    [anon_sym_boolean] = ACTIONS(2102),
    [anon_sym_string] = ACTIONS(2102),
    [anon_sym_symbol] = ACTIONS(2102),
    [anon_sym_object] = ACTIONS(2102),
    [anon_sym_property] = ACTIONS(2102),
    [anon_sym_signal] = ACTIONS(2102),
    [anon_sym_on] = ACTIONS(2102),
    [anon_sym_required] = ACTIONS(2102),
    [anon_sym_component] = ACTIONS(2102),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [687] = {
    [sym_comment] = STATE(687),
    [aux_sym_object_repeat1] = STATE(4915),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(2102),
    [anon_sym_export] = ACTIONS(2102),
    [anon_sym_STAR] = ACTIONS(2102),
    [anon_sym_type] = ACTIONS(2102),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2102),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(754),
    [anon_sym_from] = ACTIONS(2102),
    [anon_sym_let] = ACTIONS(2102),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2102),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(2104),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(2104),
    [anon_sym_SQUOTE] = ACTIONS(2104),
    [anon_sym_async] = ACTIONS(2102),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2102),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [sym_number] = ACTIONS(2104),
    [sym_private_property_identifier] = ACTIONS(2104),
    [anon_sym_static] = ACTIONS(2102),
    [anon_sym_readonly] = ACTIONS(2102),
    [anon_sym_get] = ACTIONS(2102),
    [anon_sym_set] = ACTIONS(2102),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_declare] = ACTIONS(2102),
    [anon_sym_public] = ACTIONS(2102),
    [anon_sym_private] = ACTIONS(2102),
    [anon_sym_protected] = ACTIONS(2102),
    [anon_sym_override] = ACTIONS(2102),
    [anon_sym_module] = ACTIONS(2102),
    [anon_sym_any] = ACTIONS(2102),
    [anon_sym_number] = ACTIONS(2102),
    [anon_sym_boolean] = ACTIONS(2102),
    [anon_sym_string] = ACTIONS(2102),
    [anon_sym_symbol] = ACTIONS(2102),
    [anon_sym_object] = ACTIONS(2102),
    [anon_sym_property] = ACTIONS(2102),
    [anon_sym_signal] = ACTIONS(2102),
    [anon_sym_on] = ACTIONS(2102),
    [anon_sym_required] = ACTIONS(2102),
    [anon_sym_component] = ACTIONS(2102),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [688] = {
    [sym_comment] = STATE(688),
    [aux_sym_object_repeat1] = STATE(4915),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(2098),
    [anon_sym_export] = ACTIONS(2098),
    [anon_sym_STAR] = ACTIONS(2098),
    [anon_sym_type] = ACTIONS(2098),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2098),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(777),
    [anon_sym_from] = ACTIONS(2098),
    [anon_sym_let] = ACTIONS(2098),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2098),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(2100),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(30),
    [anon_sym_DQUOTE] = ACTIONS(2100),
    [anon_sym_SQUOTE] = ACTIONS(2100),
    [anon_sym_async] = ACTIONS(2098),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2098),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [sym_number] = ACTIONS(2100),
    [sym_private_property_identifier] = ACTIONS(2100),
    [anon_sym_static] = ACTIONS(2098),
    [anon_sym_readonly] = ACTIONS(2098),
    [anon_sym_get] = ACTIONS(2098),
    [anon_sym_set] = ACTIONS(2098),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_declare] = ACTIONS(2098),
    [anon_sym_public] = ACTIONS(2098),
    [anon_sym_private] = ACTIONS(2098),
    [anon_sym_protected] = ACTIONS(2098),
    [anon_sym_override] = ACTIONS(2098),
    [anon_sym_module] = ACTIONS(2098),
    [anon_sym_any] = ACTIONS(2098),
    [anon_sym_number] = ACTIONS(2098),
    [anon_sym_boolean] = ACTIONS(2098),
    [anon_sym_string] = ACTIONS(2098),
    [anon_sym_symbol] = ACTIONS(2098),
    [anon_sym_object] = ACTIONS(2098),
    [anon_sym_property] = ACTIONS(2098),
    [anon_sym_signal] = ACTIONS(2098),
    [anon_sym_on] = ACTIONS(2098),
    [anon_sym_required] = ACTIONS(2098),
    [anon_sym_component] = ACTIONS(2098),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [689] = {
    [sym_declaration] = STATE(819),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_class_declaration] = STATE(829),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function_declaration] = STATE(829),
    [sym_comment] = STATE(689),
    [sym_decorator] = STATE(1202),
    [sym_function_signature] = STATE(829),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(831),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [aux_sym_export_statement_repeat1] = STATE(4313),
    [aux_sym_object_repeat1] = STATE(4915),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2408),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2360),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(777),
    [anon_sym_import] = ACTIONS(2364),
    [anon_sym_var] = ACTIONS(2366),
    [anon_sym_let] = ACTIONS(2368),
    [anon_sym_const] = ACTIONS(2370),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_class] = ACTIONS(2372),
    [anon_sym_async] = ACTIONS(2374),
    [anon_sym_function] = ACTIONS(2376),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(70),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_declare] = ACTIONS(2378),
    [anon_sym_module] = ACTIONS(2410),
    [anon_sym_abstract] = ACTIONS(2382),
    [anon_sym_satisfies] = ACTIONS(70),
    [anon_sym_global] = ACTIONS(2412),
    [anon_sym_interface] = ACTIONS(2384),
    [anon_sym_enum] = ACTIONS(2386),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [690] = {
    [sym_declaration] = STATE(819),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_class_declaration] = STATE(829),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function_declaration] = STATE(829),
    [sym_comment] = STATE(690),
    [sym_decorator] = STATE(1202),
    [sym_function_signature] = STATE(829),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(831),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [aux_sym_export_statement_repeat1] = STATE(4313),
    [aux_sym_object_repeat1] = STATE(4915),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2408),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2360),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(754),
    [anon_sym_import] = ACTIONS(2364),
    [anon_sym_var] = ACTIONS(2366),
    [anon_sym_let] = ACTIONS(2368),
    [anon_sym_const] = ACTIONS(2370),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_class] = ACTIONS(2372),
    [anon_sym_async] = ACTIONS(2374),
    [anon_sym_function] = ACTIONS(2376),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(70),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_declare] = ACTIONS(2378),
    [anon_sym_module] = ACTIONS(2410),
    [anon_sym_abstract] = ACTIONS(2382),
    [anon_sym_satisfies] = ACTIONS(70),
    [anon_sym_global] = ACTIONS(2412),
    [anon_sym_interface] = ACTIONS(2384),
    [anon_sym_enum] = ACTIONS(2386),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [691] = {
    [sym_declaration] = STATE(819),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_class_declaration] = STATE(829),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function_declaration] = STATE(829),
    [sym_comment] = STATE(691),
    [sym_decorator] = STATE(1202),
    [sym_function_signature] = STATE(829),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(831),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [aux_sym_export_statement_repeat1] = STATE(4313),
    [aux_sym_object_repeat1] = STATE(4915),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2408),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2360),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(781),
    [anon_sym_import] = ACTIONS(2364),
    [anon_sym_var] = ACTIONS(2366),
    [anon_sym_let] = ACTIONS(2368),
    [anon_sym_const] = ACTIONS(2370),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_class] = ACTIONS(2372),
    [anon_sym_async] = ACTIONS(2374),
    [anon_sym_function] = ACTIONS(2376),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(70),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_declare] = ACTIONS(2378),
    [anon_sym_module] = ACTIONS(2410),
    [anon_sym_abstract] = ACTIONS(2382),
    [anon_sym_satisfies] = ACTIONS(70),
    [anon_sym_global] = ACTIONS(2412),
    [anon_sym_interface] = ACTIONS(2384),
    [anon_sym_enum] = ACTIONS(2386),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [692] = {
    [sym_declaration] = STATE(819),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_class_declaration] = STATE(829),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function_declaration] = STATE(829),
    [sym_comment] = STATE(692),
    [sym_decorator] = STATE(1202),
    [sym_function_signature] = STATE(829),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(831),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [aux_sym_export_statement_repeat1] = STATE(4313),
    [aux_sym_object_repeat1] = STATE(5251),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2408),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2360),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(791),
    [anon_sym_import] = ACTIONS(2364),
    [anon_sym_var] = ACTIONS(2366),
    [anon_sym_let] = ACTIONS(2368),
    [anon_sym_const] = ACTIONS(2370),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_class] = ACTIONS(2372),
    [anon_sym_async] = ACTIONS(2374),
    [anon_sym_function] = ACTIONS(2376),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(70),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_declare] = ACTIONS(2378),
    [anon_sym_module] = ACTIONS(2410),
    [anon_sym_abstract] = ACTIONS(2382),
    [anon_sym_satisfies] = ACTIONS(70),
    [anon_sym_global] = ACTIONS(2412),
    [anon_sym_interface] = ACTIONS(2384),
    [anon_sym_enum] = ACTIONS(2386),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [693] = {
    [sym__call_signature] = STATE(6089),
    [sym_comment] = STATE(693),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_identifier] = ACTIONS(2414),
    [anon_sym_export] = ACTIONS(2416),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2416),
    [anon_sym_EQ] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2416),
    [anon_sym_COMMA] = ACTIONS(36),
    [anon_sym_RBRACE] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(2416),
    [anon_sym_let] = ACTIONS(2416),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_RPAREN] = ACTIONS(36),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2416),
    [anon_sym_COLON] = ACTIONS(36),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_RBRACK] = ACTIONS(36),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_async] = ACTIONS(2416),
    [anon_sym_function] = ACTIONS(2421),
    [anon_sym_EQ_GT] = ACTIONS(68),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2416),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2416),
    [anon_sym_readonly] = ACTIONS(2416),
    [anon_sym_get] = ACTIONS(2416),
    [anon_sym_set] = ACTIONS(2416),
    [anon_sym_QMARK] = ACTIONS(823),
    [anon_sym_declare] = ACTIONS(2416),
    [anon_sym_public] = ACTIONS(2416),
    [anon_sym_private] = ACTIONS(2416),
    [anon_sym_protected] = ACTIONS(2416),
    [anon_sym_override] = ACTIONS(2416),
    [anon_sym_module] = ACTIONS(2416),
    [anon_sym_any] = ACTIONS(2416),
    [anon_sym_number] = ACTIONS(2416),
    [anon_sym_boolean] = ACTIONS(2416),
    [anon_sym_string] = ACTIONS(2416),
    [anon_sym_symbol] = ACTIONS(2416),
    [anon_sym_object] = ACTIONS(2416),
    [anon_sym_property] = ACTIONS(2416),
    [anon_sym_signal] = ACTIONS(2416),
    [anon_sym_on] = ACTIONS(2416),
    [anon_sym_required] = ACTIONS(2416),
    [anon_sym_component] = ACTIONS(2416),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [694] = {
    [sym_namespace_export] = STATE(5561),
    [sym_export_clause] = STATE(4745),
    [sym_declaration] = STATE(833),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_class_declaration] = STATE(829),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function_declaration] = STATE(829),
    [sym_comment] = STATE(694),
    [sym_decorator] = STATE(1202),
    [sym_function_signature] = STATE(829),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(831),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [aux_sym_export_statement_repeat1] = STATE(4313),
    [anon_sym_STAR] = ACTIONS(2350),
    [anon_sym_default] = ACTIONS(2352),
    [anon_sym_type] = ACTIONS(2354),
    [anon_sym_EQ] = ACTIONS(2426),
    [anon_sym_as] = ACTIONS(2358),
    [anon_sym_namespace] = ACTIONS(2360),
    [anon_sym_LBRACE] = ACTIONS(2362),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_import] = ACTIONS(2364),
    [anon_sym_var] = ACTIONS(2366),
    [anon_sym_let] = ACTIONS(2368),
    [anon_sym_const] = ACTIONS(2370),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(70),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(913),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_class] = ACTIONS(2372),
    [anon_sym_async] = ACTIONS(2374),
    [anon_sym_function] = ACTIONS(2376),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(70),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_declare] = ACTIONS(2378),
    [anon_sym_module] = ACTIONS(2380),
    [anon_sym_abstract] = ACTIONS(2382),
    [anon_sym_satisfies] = ACTIONS(70),
    [anon_sym_interface] = ACTIONS(2384),
    [anon_sym_enum] = ACTIONS(2386),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [695] = {
    [sym__call_signature] = STATE(5981),
    [sym_comment] = STATE(695),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_identifier] = ACTIONS(2428),
    [anon_sym_export] = ACTIONS(2430),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2430),
    [anon_sym_EQ] = ACTIONS(863),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2430),
    [anon_sym_COMMA] = ACTIONS(867),
    [anon_sym_RBRACE] = ACTIONS(867),
    [anon_sym_from] = ACTIONS(2430),
    [anon_sym_let] = ACTIONS(2430),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_RPAREN] = ACTIONS(867),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2430),
    [anon_sym_COLON] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_RBRACK] = ACTIONS(867),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_async] = ACTIONS(2430),
    [anon_sym_function] = ACTIONS(2421),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2430),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2430),
    [anon_sym_readonly] = ACTIONS(2430),
    [anon_sym_get] = ACTIONS(2430),
    [anon_sym_set] = ACTIONS(2430),
    [anon_sym_QMARK] = ACTIONS(875),
    [anon_sym_declare] = ACTIONS(2430),
    [anon_sym_public] = ACTIONS(2430),
    [anon_sym_private] = ACTIONS(2430),
    [anon_sym_protected] = ACTIONS(2430),
    [anon_sym_override] = ACTIONS(2430),
    [anon_sym_module] = ACTIONS(2430),
    [anon_sym_any] = ACTIONS(2430),
    [anon_sym_number] = ACTIONS(2430),
    [anon_sym_boolean] = ACTIONS(2430),
    [anon_sym_string] = ACTIONS(2430),
    [anon_sym_symbol] = ACTIONS(2430),
    [anon_sym_object] = ACTIONS(2430),
    [anon_sym_property] = ACTIONS(2430),
    [anon_sym_signal] = ACTIONS(2430),
    [anon_sym_on] = ACTIONS(2430),
    [anon_sym_required] = ACTIONS(2430),
    [anon_sym_component] = ACTIONS(2430),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [696] = {
    [sym_namespace_export] = STATE(5561),
    [sym_export_clause] = STATE(4745),
    [sym_declaration] = STATE(833),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_class_declaration] = STATE(829),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function_declaration] = STATE(829),
    [sym_comment] = STATE(696),
    [sym_decorator] = STATE(1202),
    [sym_function_signature] = STATE(829),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(831),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [aux_sym_export_statement_repeat1] = STATE(4313),
    [anon_sym_STAR] = ACTIONS(2350),
    [anon_sym_default] = ACTIONS(2432),
    [anon_sym_type] = ACTIONS(2354),
    [anon_sym_EQ] = ACTIONS(2426),
    [anon_sym_as] = ACTIONS(2358),
    [anon_sym_namespace] = ACTIONS(2434),
    [anon_sym_LBRACE] = ACTIONS(2362),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_import] = ACTIONS(2364),
    [anon_sym_var] = ACTIONS(2436),
    [anon_sym_let] = ACTIONS(2368),
    [anon_sym_const] = ACTIONS(2370),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(70),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_class] = ACTIONS(2372),
    [anon_sym_async] = ACTIONS(2438),
    [anon_sym_function] = ACTIONS(2440),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(70),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_declare] = ACTIONS(2442),
    [anon_sym_module] = ACTIONS(2444),
    [anon_sym_abstract] = ACTIONS(2382),
    [anon_sym_satisfies] = ACTIONS(70),
    [anon_sym_interface] = ACTIONS(2384),
    [anon_sym_enum] = ACTIONS(2386),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [697] = {
    [sym__call_signature] = STATE(5981),
    [sym_comment] = STATE(697),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_identifier] = ACTIONS(2428),
    [anon_sym_export] = ACTIONS(2430),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2430),
    [anon_sym_EQ] = ACTIONS(134),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2430),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_RBRACE] = ACTIONS(137),
    [anon_sym_from] = ACTIONS(2430),
    [anon_sym_let] = ACTIONS(2430),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2430),
    [anon_sym_COLON] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_RBRACK] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_async] = ACTIONS(2430),
    [anon_sym_function] = ACTIONS(2421),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2430),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2430),
    [anon_sym_readonly] = ACTIONS(2430),
    [anon_sym_get] = ACTIONS(2430),
    [anon_sym_set] = ACTIONS(2430),
    [anon_sym_QMARK] = ACTIONS(823),
    [anon_sym_declare] = ACTIONS(2430),
    [anon_sym_public] = ACTIONS(2430),
    [anon_sym_private] = ACTIONS(2430),
    [anon_sym_protected] = ACTIONS(2430),
    [anon_sym_override] = ACTIONS(2430),
    [anon_sym_module] = ACTIONS(2430),
    [anon_sym_any] = ACTIONS(2430),
    [anon_sym_number] = ACTIONS(2430),
    [anon_sym_boolean] = ACTIONS(2430),
    [anon_sym_string] = ACTIONS(2430),
    [anon_sym_symbol] = ACTIONS(2430),
    [anon_sym_object] = ACTIONS(2430),
    [anon_sym_property] = ACTIONS(2430),
    [anon_sym_signal] = ACTIONS(2430),
    [anon_sym_on] = ACTIONS(2430),
    [anon_sym_required] = ACTIONS(2430),
    [anon_sym_component] = ACTIONS(2430),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [698] = {
    [sym_namespace_export] = STATE(5785),
    [sym_export_clause] = STATE(4851),
    [sym_declaration] = STATE(3019),
    [sym_variable_declaration] = STATE(2949),
    [sym_lexical_declaration] = STATE(2949),
    [sym_class_declaration] = STATE(2949),
    [sym_function_declaration] = STATE(2949),
    [sym_generator_function_declaration] = STATE(2949),
    [sym_comment] = STATE(698),
    [sym_decorator] = STATE(1202),
    [sym_function_signature] = STATE(2949),
    [sym_ambient_declaration] = STATE(2949),
    [sym_abstract_class_declaration] = STATE(2949),
    [sym_module] = STATE(2949),
    [sym_internal_module] = STATE(3020),
    [sym_import_alias] = STATE(2949),
    [sym_interface_declaration] = STATE(2949),
    [sym_enum_declaration] = STATE(2949),
    [sym_type_alias_declaration] = STATE(2949),
    [aux_sym_export_statement_repeat1] = STATE(4344),
    [anon_sym_STAR] = ACTIONS(2446),
    [anon_sym_default] = ACTIONS(2448),
    [anon_sym_type] = ACTIONS(2450),
    [anon_sym_EQ] = ACTIONS(2452),
    [anon_sym_as] = ACTIONS(2454),
    [anon_sym_namespace] = ACTIONS(2456),
    [anon_sym_LBRACE] = ACTIONS(2362),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_import] = ACTIONS(2458),
    [anon_sym_var] = ACTIONS(2436),
    [anon_sym_let] = ACTIONS(2460),
    [anon_sym_const] = ACTIONS(2462),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(70),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_class] = ACTIONS(2464),
    [anon_sym_async] = ACTIONS(2466),
    [anon_sym_function] = ACTIONS(2468),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(70),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_declare] = ACTIONS(2470),
    [anon_sym_module] = ACTIONS(2472),
    [anon_sym_abstract] = ACTIONS(2474),
    [anon_sym_satisfies] = ACTIONS(70),
    [anon_sym_interface] = ACTIONS(2476),
    [anon_sym_enum] = ACTIONS(2478),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [699] = {
    [sym__call_signature] = STATE(6089),
    [sym_comment] = STATE(699),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_identifier] = ACTIONS(2414),
    [anon_sym_export] = ACTIONS(2416),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2416),
    [anon_sym_EQ] = ACTIONS(863),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2416),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(70),
    [anon_sym_from] = ACTIONS(2416),
    [anon_sym_let] = ACTIONS(2416),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_RPAREN] = ACTIONS(70),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2416),
    [anon_sym_COLON] = ACTIONS(70),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_RBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_async] = ACTIONS(2416),
    [anon_sym_function] = ACTIONS(2421),
    [anon_sym_EQ_GT] = ACTIONS(68),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2416),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2416),
    [anon_sym_readonly] = ACTIONS(2416),
    [anon_sym_get] = ACTIONS(2416),
    [anon_sym_set] = ACTIONS(2416),
    [anon_sym_declare] = ACTIONS(2416),
    [anon_sym_public] = ACTIONS(2416),
    [anon_sym_private] = ACTIONS(2416),
    [anon_sym_protected] = ACTIONS(2416),
    [anon_sym_override] = ACTIONS(2416),
    [anon_sym_module] = ACTIONS(2416),
    [anon_sym_any] = ACTIONS(2416),
    [anon_sym_number] = ACTIONS(2416),
    [anon_sym_boolean] = ACTIONS(2416),
    [anon_sym_string] = ACTIONS(2416),
    [anon_sym_symbol] = ACTIONS(2416),
    [anon_sym_object] = ACTIONS(2416),
    [anon_sym_property] = ACTIONS(2416),
    [anon_sym_signal] = ACTIONS(2416),
    [anon_sym_on] = ACTIONS(2416),
    [anon_sym_required] = ACTIONS(2416),
    [anon_sym_component] = ACTIONS(2416),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [700] = {
    [sym__call_signature] = STATE(6266),
    [sym_comment] = STATE(700),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_ui_object_initializer] = STATE(2802),
    [sym_identifier] = ACTIONS(2480),
    [anon_sym_export] = ACTIONS(2482),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2482),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2482),
    [anon_sym_LBRACE] = ACTIONS(2484),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_from] = ACTIONS(2482),
    [anon_sym_let] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2482),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(2486),
    [anon_sym_async] = ACTIONS(2482),
    [anon_sym_function] = ACTIONS(2489),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2482),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2482),
    [anon_sym_readonly] = ACTIONS(2482),
    [anon_sym_get] = ACTIONS(2482),
    [anon_sym_set] = ACTIONS(2482),
    [anon_sym_declare] = ACTIONS(2482),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_override] = ACTIONS(2482),
    [anon_sym_module] = ACTIONS(2482),
    [anon_sym_any] = ACTIONS(2482),
    [anon_sym_number] = ACTIONS(2482),
    [anon_sym_boolean] = ACTIONS(2482),
    [anon_sym_string] = ACTIONS(2482),
    [anon_sym_symbol] = ACTIONS(2482),
    [anon_sym_object] = ACTIONS(2482),
    [anon_sym_property] = ACTIONS(2482),
    [anon_sym_signal] = ACTIONS(2482),
    [anon_sym_on] = ACTIONS(2482),
    [anon_sym_required] = ACTIONS(2482),
    [anon_sym_component] = ACTIONS(2482),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [701] = {
    [sym__call_signature] = STATE(6089),
    [sym_comment] = STATE(701),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_identifier] = ACTIONS(2414),
    [anon_sym_export] = ACTIONS(2416),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2416),
    [anon_sym_EQ] = ACTIONS(877),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2416),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(70),
    [anon_sym_from] = ACTIONS(2416),
    [anon_sym_let] = ACTIONS(2416),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_RPAREN] = ACTIONS(70),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2416),
    [anon_sym_COLON] = ACTIONS(70),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_RBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_async] = ACTIONS(2416),
    [anon_sym_function] = ACTIONS(2421),
    [anon_sym_EQ_GT] = ACTIONS(68),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2416),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2416),
    [anon_sym_readonly] = ACTIONS(2416),
    [anon_sym_get] = ACTIONS(2416),
    [anon_sym_set] = ACTIONS(2416),
    [anon_sym_declare] = ACTIONS(2416),
    [anon_sym_public] = ACTIONS(2416),
    [anon_sym_private] = ACTIONS(2416),
    [anon_sym_protected] = ACTIONS(2416),
    [anon_sym_override] = ACTIONS(2416),
    [anon_sym_module] = ACTIONS(2416),
    [anon_sym_any] = ACTIONS(2416),
    [anon_sym_number] = ACTIONS(2416),
    [anon_sym_boolean] = ACTIONS(2416),
    [anon_sym_string] = ACTIONS(2416),
    [anon_sym_symbol] = ACTIONS(2416),
    [anon_sym_object] = ACTIONS(2416),
    [anon_sym_property] = ACTIONS(2416),
    [anon_sym_signal] = ACTIONS(2416),
    [anon_sym_on] = ACTIONS(2416),
    [anon_sym_required] = ACTIONS(2416),
    [anon_sym_component] = ACTIONS(2416),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [702] = {
    [sym__call_signature] = STATE(6266),
    [sym_comment] = STATE(702),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_ui_object_initializer] = STATE(5893),
    [sym_identifier] = ACTIONS(2480),
    [anon_sym_export] = ACTIONS(2482),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2482),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2482),
    [anon_sym_LBRACE] = ACTIONS(2491),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_from] = ACTIONS(2482),
    [anon_sym_let] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2482),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(2486),
    [anon_sym_async] = ACTIONS(2482),
    [anon_sym_function] = ACTIONS(2489),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2482),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2482),
    [anon_sym_readonly] = ACTIONS(2482),
    [anon_sym_get] = ACTIONS(2482),
    [anon_sym_set] = ACTIONS(2482),
    [anon_sym_declare] = ACTIONS(2482),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_override] = ACTIONS(2482),
    [anon_sym_module] = ACTIONS(2482),
    [anon_sym_any] = ACTIONS(2482),
    [anon_sym_number] = ACTIONS(2482),
    [anon_sym_boolean] = ACTIONS(2482),
    [anon_sym_string] = ACTIONS(2482),
    [anon_sym_symbol] = ACTIONS(2482),
    [anon_sym_object] = ACTIONS(2482),
    [anon_sym_property] = ACTIONS(2482),
    [anon_sym_signal] = ACTIONS(2482),
    [anon_sym_on] = ACTIONS(2482),
    [anon_sym_required] = ACTIONS(2482),
    [anon_sym_component] = ACTIONS(2482),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [703] = {
    [sym__call_signature] = STATE(6266),
    [sym_comment] = STATE(703),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_identifier] = ACTIONS(2480),
    [anon_sym_export] = ACTIONS(2482),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2482),
    [anon_sym_EQ] = ACTIONS(863),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2482),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(70),
    [anon_sym_from] = ACTIONS(2482),
    [anon_sym_let] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2482),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_async] = ACTIONS(2482),
    [anon_sym_function] = ACTIONS(2489),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2482),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2482),
    [anon_sym_readonly] = ACTIONS(2482),
    [anon_sym_get] = ACTIONS(2482),
    [anon_sym_set] = ACTIONS(2482),
    [anon_sym_declare] = ACTIONS(2482),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_override] = ACTIONS(2482),
    [anon_sym_module] = ACTIONS(2482),
    [anon_sym_any] = ACTIONS(2482),
    [anon_sym_number] = ACTIONS(2482),
    [anon_sym_boolean] = ACTIONS(2482),
    [anon_sym_string] = ACTIONS(2482),
    [anon_sym_symbol] = ACTIONS(2482),
    [anon_sym_object] = ACTIONS(2482),
    [anon_sym_property] = ACTIONS(2482),
    [anon_sym_signal] = ACTIONS(2482),
    [anon_sym_on] = ACTIONS(2482),
    [anon_sym_required] = ACTIONS(2482),
    [anon_sym_component] = ACTIONS(2482),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [704] = {
    [sym__call_signature] = STATE(6089),
    [sym_comment] = STATE(704),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_identifier] = ACTIONS(2414),
    [anon_sym_export] = ACTIONS(2416),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2416),
    [anon_sym_EQ] = ACTIONS(877),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2416),
    [anon_sym_COMMA] = ACTIONS(964),
    [anon_sym_RBRACE] = ACTIONS(964),
    [anon_sym_from] = ACTIONS(2416),
    [anon_sym_let] = ACTIONS(2416),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2416),
    [anon_sym_COLON] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_RBRACK] = ACTIONS(964),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_async] = ACTIONS(2416),
    [anon_sym_function] = ACTIONS(2421),
    [anon_sym_EQ_GT] = ACTIONS(68),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2416),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2416),
    [anon_sym_readonly] = ACTIONS(2416),
    [anon_sym_get] = ACTIONS(2416),
    [anon_sym_set] = ACTIONS(2416),
    [anon_sym_declare] = ACTIONS(2416),
    [anon_sym_public] = ACTIONS(2416),
    [anon_sym_private] = ACTIONS(2416),
    [anon_sym_protected] = ACTIONS(2416),
    [anon_sym_override] = ACTIONS(2416),
    [anon_sym_module] = ACTIONS(2416),
    [anon_sym_any] = ACTIONS(2416),
    [anon_sym_number] = ACTIONS(2416),
    [anon_sym_boolean] = ACTIONS(2416),
    [anon_sym_string] = ACTIONS(2416),
    [anon_sym_symbol] = ACTIONS(2416),
    [anon_sym_object] = ACTIONS(2416),
    [anon_sym_property] = ACTIONS(2416),
    [anon_sym_signal] = ACTIONS(2416),
    [anon_sym_on] = ACTIONS(2416),
    [anon_sym_required] = ACTIONS(2416),
    [anon_sym_component] = ACTIONS(2416),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [705] = {
    [sym__call_signature] = STATE(6266),
    [sym_comment] = STATE(705),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_identifier] = ACTIONS(2480),
    [anon_sym_export] = ACTIONS(2482),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2482),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2482),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_from] = ACTIONS(2482),
    [anon_sym_let] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2482),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(913),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_async] = ACTIONS(2482),
    [anon_sym_function] = ACTIONS(2324),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2482),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2482),
    [anon_sym_readonly] = ACTIONS(2482),
    [anon_sym_get] = ACTIONS(2482),
    [anon_sym_set] = ACTIONS(2482),
    [anon_sym_declare] = ACTIONS(2482),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_override] = ACTIONS(2482),
    [anon_sym_module] = ACTIONS(2482),
    [anon_sym_any] = ACTIONS(2482),
    [anon_sym_number] = ACTIONS(2482),
    [anon_sym_boolean] = ACTIONS(2482),
    [anon_sym_string] = ACTIONS(2482),
    [anon_sym_symbol] = ACTIONS(2482),
    [anon_sym_object] = ACTIONS(2482),
    [anon_sym_property] = ACTIONS(2482),
    [anon_sym_signal] = ACTIONS(2482),
    [anon_sym_on] = ACTIONS(2482),
    [anon_sym_required] = ACTIONS(2482),
    [anon_sym_component] = ACTIONS(2482),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [706] = {
    [sym__call_signature] = STATE(6089),
    [sym_comment] = STATE(706),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_ui_object_initializer] = STATE(2802),
    [sym_identifier] = ACTIONS(2414),
    [anon_sym_export] = ACTIONS(2416),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2416),
    [anon_sym_EQ] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2416),
    [anon_sym_LBRACE] = ACTIONS(2484),
    [anon_sym_COMMA] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(2416),
    [anon_sym_let] = ACTIONS(2416),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2416),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_RBRACK] = ACTIONS(36),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(2486),
    [anon_sym_async] = ACTIONS(2416),
    [anon_sym_function] = ACTIONS(2421),
    [anon_sym_EQ_GT] = ACTIONS(68),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2416),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2416),
    [anon_sym_readonly] = ACTIONS(2416),
    [anon_sym_get] = ACTIONS(2416),
    [anon_sym_set] = ACTIONS(2416),
    [anon_sym_declare] = ACTIONS(2416),
    [anon_sym_public] = ACTIONS(2416),
    [anon_sym_private] = ACTIONS(2416),
    [anon_sym_protected] = ACTIONS(2416),
    [anon_sym_override] = ACTIONS(2416),
    [anon_sym_module] = ACTIONS(2416),
    [anon_sym_any] = ACTIONS(2416),
    [anon_sym_number] = ACTIONS(2416),
    [anon_sym_boolean] = ACTIONS(2416),
    [anon_sym_string] = ACTIONS(2416),
    [anon_sym_symbol] = ACTIONS(2416),
    [anon_sym_object] = ACTIONS(2416),
    [anon_sym_property] = ACTIONS(2416),
    [anon_sym_signal] = ACTIONS(2416),
    [anon_sym_on] = ACTIONS(2416),
    [anon_sym_required] = ACTIONS(2416),
    [anon_sym_component] = ACTIONS(2416),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [707] = {
    [sym__call_signature] = STATE(6266),
    [sym_comment] = STATE(707),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_identifier] = ACTIONS(2480),
    [anon_sym_export] = ACTIONS(2482),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2482),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2482),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_from] = ACTIONS(2482),
    [anon_sym_let] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2482),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_async] = ACTIONS(2482),
    [anon_sym_function] = ACTIONS(2493),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2482),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2482),
    [anon_sym_readonly] = ACTIONS(2482),
    [anon_sym_get] = ACTIONS(2482),
    [anon_sym_set] = ACTIONS(2482),
    [anon_sym_declare] = ACTIONS(2482),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_override] = ACTIONS(2482),
    [anon_sym_module] = ACTIONS(2482),
    [anon_sym_any] = ACTIONS(2482),
    [anon_sym_number] = ACTIONS(2482),
    [anon_sym_boolean] = ACTIONS(2482),
    [anon_sym_string] = ACTIONS(2482),
    [anon_sym_symbol] = ACTIONS(2482),
    [anon_sym_object] = ACTIONS(2482),
    [anon_sym_property] = ACTIONS(2482),
    [anon_sym_signal] = ACTIONS(2482),
    [anon_sym_on] = ACTIONS(2482),
    [anon_sym_required] = ACTIONS(2482),
    [anon_sym_component] = ACTIONS(2482),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [708] = {
    [sym__call_signature] = STATE(6266),
    [sym_comment] = STATE(708),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_identifier] = ACTIONS(2480),
    [anon_sym_export] = ACTIONS(2482),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2482),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2482),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_from] = ACTIONS(2482),
    [anon_sym_let] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2482),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_async] = ACTIONS(2482),
    [anon_sym_function] = ACTIONS(2495),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2482),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2482),
    [anon_sym_readonly] = ACTIONS(2482),
    [anon_sym_get] = ACTIONS(2482),
    [anon_sym_set] = ACTIONS(2482),
    [anon_sym_declare] = ACTIONS(2482),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_override] = ACTIONS(2482),
    [anon_sym_module] = ACTIONS(2482),
    [anon_sym_any] = ACTIONS(2482),
    [anon_sym_number] = ACTIONS(2482),
    [anon_sym_boolean] = ACTIONS(2482),
    [anon_sym_string] = ACTIONS(2482),
    [anon_sym_symbol] = ACTIONS(2482),
    [anon_sym_object] = ACTIONS(2482),
    [anon_sym_property] = ACTIONS(2482),
    [anon_sym_signal] = ACTIONS(2482),
    [anon_sym_on] = ACTIONS(2482),
    [anon_sym_required] = ACTIONS(2482),
    [anon_sym_component] = ACTIONS(2482),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [709] = {
    [sym__call_signature] = STATE(6266),
    [sym_comment] = STATE(709),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_identifier] = ACTIONS(2480),
    [anon_sym_export] = ACTIONS(2482),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2482),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2482),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(70),
    [anon_sym_from] = ACTIONS(2482),
    [anon_sym_let] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2482),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_async] = ACTIONS(2482),
    [anon_sym_function] = ACTIONS(2489),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2482),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2482),
    [anon_sym_readonly] = ACTIONS(2482),
    [anon_sym_get] = ACTIONS(2482),
    [anon_sym_set] = ACTIONS(2482),
    [anon_sym_declare] = ACTIONS(2482),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_override] = ACTIONS(2482),
    [anon_sym_module] = ACTIONS(2482),
    [anon_sym_any] = ACTIONS(2482),
    [anon_sym_number] = ACTIONS(2482),
    [anon_sym_boolean] = ACTIONS(2482),
    [anon_sym_string] = ACTIONS(2482),
    [anon_sym_symbol] = ACTIONS(2482),
    [anon_sym_object] = ACTIONS(2482),
    [anon_sym_property] = ACTIONS(2482),
    [anon_sym_signal] = ACTIONS(2482),
    [anon_sym_on] = ACTIONS(2482),
    [anon_sym_required] = ACTIONS(2482),
    [anon_sym_component] = ACTIONS(2482),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [710] = {
    [sym_declaration] = STATE(2997),
    [sym_variable_declaration] = STATE(2949),
    [sym_lexical_declaration] = STATE(2949),
    [sym_class_declaration] = STATE(2949),
    [sym_function_declaration] = STATE(2949),
    [sym_generator_function_declaration] = STATE(2949),
    [sym_comment] = STATE(710),
    [sym_decorator] = STATE(1202),
    [sym_function_signature] = STATE(2949),
    [sym_ambient_declaration] = STATE(2949),
    [sym_abstract_class_declaration] = STATE(2949),
    [sym_module] = STATE(2949),
    [sym_internal_module] = STATE(3020),
    [sym_import_alias] = STATE(2949),
    [sym_interface_declaration] = STATE(2949),
    [sym_enum_declaration] = STATE(2949),
    [sym_type_alias_declaration] = STATE(2949),
    [aux_sym_export_statement_repeat1] = STATE(4344),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2497),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2456),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_import] = ACTIONS(2458),
    [anon_sym_var] = ACTIONS(2436),
    [anon_sym_let] = ACTIONS(2460),
    [anon_sym_const] = ACTIONS(2462),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(70),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_class] = ACTIONS(2464),
    [anon_sym_async] = ACTIONS(2466),
    [anon_sym_function] = ACTIONS(2468),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(70),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_declare] = ACTIONS(2470),
    [anon_sym_module] = ACTIONS(2499),
    [anon_sym_abstract] = ACTIONS(2474),
    [anon_sym_satisfies] = ACTIONS(70),
    [anon_sym_global] = ACTIONS(2501),
    [anon_sym_interface] = ACTIONS(2476),
    [anon_sym_enum] = ACTIONS(2478),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [711] = {
    [sym__call_signature] = STATE(6277),
    [sym_comment] = STATE(711),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_identifier] = ACTIONS(2503),
    [anon_sym_export] = ACTIONS(2505),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2505),
    [anon_sym_EQ] = ACTIONS(1013),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(70),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_from] = ACTIONS(2505),
    [anon_sym_let] = ACTIONS(2505),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2505),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_async] = ACTIONS(2505),
    [anon_sym_function] = ACTIONS(2421),
    [anon_sym_EQ_GT] = ACTIONS(1003),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2505),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2505),
    [anon_sym_readonly] = ACTIONS(2505),
    [anon_sym_get] = ACTIONS(2505),
    [anon_sym_set] = ACTIONS(2505),
    [anon_sym_declare] = ACTIONS(2505),
    [anon_sym_public] = ACTIONS(2505),
    [anon_sym_private] = ACTIONS(2505),
    [anon_sym_protected] = ACTIONS(2505),
    [anon_sym_override] = ACTIONS(2505),
    [anon_sym_module] = ACTIONS(2505),
    [anon_sym_any] = ACTIONS(2505),
    [anon_sym_number] = ACTIONS(2505),
    [anon_sym_boolean] = ACTIONS(2505),
    [anon_sym_string] = ACTIONS(2505),
    [anon_sym_symbol] = ACTIONS(2505),
    [anon_sym_object] = ACTIONS(2505),
    [anon_sym_property] = ACTIONS(2505),
    [anon_sym_signal] = ACTIONS(2505),
    [anon_sym_on] = ACTIONS(2505),
    [anon_sym_required] = ACTIONS(2505),
    [anon_sym_component] = ACTIONS(2505),
    [anon_sym_satisfies] = ACTIONS(30),
    [anon_sym_implements] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [712] = {
    [sym__call_signature] = STATE(5942),
    [sym_comment] = STATE(712),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_identifier] = ACTIONS(2507),
    [anon_sym_export] = ACTIONS(2509),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2509),
    [anon_sym_EQ] = ACTIONS(971),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2509),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_from] = ACTIONS(2509),
    [anon_sym_let] = ACTIONS(2509),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2509),
    [anon_sym_COLON] = ACTIONS(976),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_RBRACK] = ACTIONS(36),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_async] = ACTIONS(2509),
    [anon_sym_function] = ACTIONS(2421),
    [anon_sym_EQ_GT] = ACTIONS(980),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2509),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2509),
    [anon_sym_readonly] = ACTIONS(2509),
    [anon_sym_get] = ACTIONS(2509),
    [anon_sym_set] = ACTIONS(2509),
    [anon_sym_declare] = ACTIONS(2509),
    [anon_sym_public] = ACTIONS(2509),
    [anon_sym_private] = ACTIONS(2509),
    [anon_sym_protected] = ACTIONS(2509),
    [anon_sym_override] = ACTIONS(2509),
    [anon_sym_module] = ACTIONS(2509),
    [anon_sym_any] = ACTIONS(2509),
    [anon_sym_number] = ACTIONS(2509),
    [anon_sym_boolean] = ACTIONS(2509),
    [anon_sym_string] = ACTIONS(2509),
    [anon_sym_symbol] = ACTIONS(2509),
    [anon_sym_object] = ACTIONS(2509),
    [anon_sym_property] = ACTIONS(2509),
    [anon_sym_signal] = ACTIONS(2509),
    [anon_sym_on] = ACTIONS(2509),
    [anon_sym_required] = ACTIONS(2509),
    [anon_sym_component] = ACTIONS(2509),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [713] = {
    [sym__call_signature] = STATE(6266),
    [sym_comment] = STATE(713),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_identifier] = ACTIONS(2480),
    [anon_sym_export] = ACTIONS(2482),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2482),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2482),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_from] = ACTIONS(2482),
    [anon_sym_let] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(984),
    [anon_sym_of] = ACTIONS(2511),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_async] = ACTIONS(2482),
    [anon_sym_function] = ACTIONS(2489),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2482),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2482),
    [anon_sym_readonly] = ACTIONS(2482),
    [anon_sym_get] = ACTIONS(2482),
    [anon_sym_set] = ACTIONS(2482),
    [anon_sym_declare] = ACTIONS(2482),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_override] = ACTIONS(2482),
    [anon_sym_module] = ACTIONS(2482),
    [anon_sym_any] = ACTIONS(2482),
    [anon_sym_number] = ACTIONS(2482),
    [anon_sym_boolean] = ACTIONS(2482),
    [anon_sym_string] = ACTIONS(2482),
    [anon_sym_symbol] = ACTIONS(2482),
    [anon_sym_object] = ACTIONS(2482),
    [anon_sym_property] = ACTIONS(2482),
    [anon_sym_signal] = ACTIONS(2482),
    [anon_sym_on] = ACTIONS(2482),
    [anon_sym_required] = ACTIONS(2482),
    [anon_sym_component] = ACTIONS(2482),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [714] = {
    [sym_declaration] = STATE(819),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_class_declaration] = STATE(829),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function_declaration] = STATE(829),
    [sym_comment] = STATE(714),
    [sym_decorator] = STATE(1202),
    [sym_function_signature] = STATE(829),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(831),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [aux_sym_export_statement_repeat1] = STATE(4313),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2408),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2360),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_import] = ACTIONS(2364),
    [anon_sym_var] = ACTIONS(2366),
    [anon_sym_let] = ACTIONS(2368),
    [anon_sym_const] = ACTIONS(2370),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(70),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(913),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_class] = ACTIONS(2372),
    [anon_sym_async] = ACTIONS(2374),
    [anon_sym_function] = ACTIONS(2376),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(70),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_declare] = ACTIONS(2378),
    [anon_sym_module] = ACTIONS(2410),
    [anon_sym_abstract] = ACTIONS(2382),
    [anon_sym_satisfies] = ACTIONS(70),
    [anon_sym_global] = ACTIONS(2412),
    [anon_sym_interface] = ACTIONS(2384),
    [anon_sym_enum] = ACTIONS(2386),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [715] = {
    [sym__call_signature] = STATE(6277),
    [sym_comment] = STATE(715),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_identifier] = ACTIONS(2503),
    [anon_sym_export] = ACTIONS(2505),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2505),
    [anon_sym_EQ] = ACTIONS(863),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(70),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_from] = ACTIONS(2505),
    [anon_sym_let] = ACTIONS(2505),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2505),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_async] = ACTIONS(2505),
    [anon_sym_function] = ACTIONS(2421),
    [anon_sym_EQ_GT] = ACTIONS(1003),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2505),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2505),
    [anon_sym_readonly] = ACTIONS(2505),
    [anon_sym_get] = ACTIONS(2505),
    [anon_sym_set] = ACTIONS(2505),
    [anon_sym_declare] = ACTIONS(2505),
    [anon_sym_public] = ACTIONS(2505),
    [anon_sym_private] = ACTIONS(2505),
    [anon_sym_protected] = ACTIONS(2505),
    [anon_sym_override] = ACTIONS(2505),
    [anon_sym_module] = ACTIONS(2505),
    [anon_sym_any] = ACTIONS(2505),
    [anon_sym_number] = ACTIONS(2505),
    [anon_sym_boolean] = ACTIONS(2505),
    [anon_sym_string] = ACTIONS(2505),
    [anon_sym_symbol] = ACTIONS(2505),
    [anon_sym_object] = ACTIONS(2505),
    [anon_sym_property] = ACTIONS(2505),
    [anon_sym_signal] = ACTIONS(2505),
    [anon_sym_on] = ACTIONS(2505),
    [anon_sym_required] = ACTIONS(2505),
    [anon_sym_component] = ACTIONS(2505),
    [anon_sym_satisfies] = ACTIONS(30),
    [anon_sym_implements] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [716] = {
    [sym_declaration] = STATE(819),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_class_declaration] = STATE(829),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function_declaration] = STATE(829),
    [sym_comment] = STATE(716),
    [sym_decorator] = STATE(1202),
    [sym_function_signature] = STATE(829),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(831),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [aux_sym_export_statement_repeat1] = STATE(4313),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2408),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2434),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_import] = ACTIONS(2364),
    [anon_sym_var] = ACTIONS(2436),
    [anon_sym_let] = ACTIONS(2368),
    [anon_sym_const] = ACTIONS(2370),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(70),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_class] = ACTIONS(2372),
    [anon_sym_async] = ACTIONS(2438),
    [anon_sym_function] = ACTIONS(2440),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(70),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_declare] = ACTIONS(2442),
    [anon_sym_module] = ACTIONS(2513),
    [anon_sym_abstract] = ACTIONS(2382),
    [anon_sym_satisfies] = ACTIONS(70),
    [anon_sym_global] = ACTIONS(2515),
    [anon_sym_interface] = ACTIONS(2384),
    [anon_sym_enum] = ACTIONS(2386),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [717] = {
    [sym__call_signature] = STATE(6174),
    [sym_comment] = STATE(717),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_identifier] = ACTIONS(2517),
    [anon_sym_export] = ACTIONS(2519),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2519),
    [anon_sym_EQ] = ACTIONS(863),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2519),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_from] = ACTIONS(2519),
    [anon_sym_let] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2521),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_async] = ACTIONS(2519),
    [anon_sym_function] = ACTIONS(2489),
    [anon_sym_EQ_GT] = ACTIONS(958),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2519),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2519),
    [anon_sym_readonly] = ACTIONS(2519),
    [anon_sym_get] = ACTIONS(2519),
    [anon_sym_set] = ACTIONS(2519),
    [anon_sym_declare] = ACTIONS(2519),
    [anon_sym_public] = ACTIONS(2519),
    [anon_sym_private] = ACTIONS(2519),
    [anon_sym_protected] = ACTIONS(2519),
    [anon_sym_override] = ACTIONS(2519),
    [anon_sym_module] = ACTIONS(2519),
    [anon_sym_any] = ACTIONS(2519),
    [anon_sym_number] = ACTIONS(2519),
    [anon_sym_boolean] = ACTIONS(2519),
    [anon_sym_string] = ACTIONS(2519),
    [anon_sym_symbol] = ACTIONS(2519),
    [anon_sym_object] = ACTIONS(2519),
    [anon_sym_property] = ACTIONS(2519),
    [anon_sym_signal] = ACTIONS(2519),
    [anon_sym_on] = ACTIONS(2519),
    [anon_sym_required] = ACTIONS(2519),
    [anon_sym_component] = ACTIONS(2519),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [718] = {
    [sym__call_signature] = STATE(6174),
    [sym_comment] = STATE(718),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_identifier] = ACTIONS(2517),
    [anon_sym_export] = ACTIONS(2519),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2519),
    [anon_sym_EQ] = ACTIONS(952),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2519),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_from] = ACTIONS(2519),
    [anon_sym_let] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2521),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_async] = ACTIONS(2519),
    [anon_sym_function] = ACTIONS(2489),
    [anon_sym_EQ_GT] = ACTIONS(958),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2519),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2519),
    [anon_sym_readonly] = ACTIONS(2519),
    [anon_sym_get] = ACTIONS(2519),
    [anon_sym_set] = ACTIONS(2519),
    [anon_sym_declare] = ACTIONS(2519),
    [anon_sym_public] = ACTIONS(2519),
    [anon_sym_private] = ACTIONS(2519),
    [anon_sym_protected] = ACTIONS(2519),
    [anon_sym_override] = ACTIONS(2519),
    [anon_sym_module] = ACTIONS(2519),
    [anon_sym_any] = ACTIONS(2519),
    [anon_sym_number] = ACTIONS(2519),
    [anon_sym_boolean] = ACTIONS(2519),
    [anon_sym_string] = ACTIONS(2519),
    [anon_sym_symbol] = ACTIONS(2519),
    [anon_sym_object] = ACTIONS(2519),
    [anon_sym_property] = ACTIONS(2519),
    [anon_sym_signal] = ACTIONS(2519),
    [anon_sym_on] = ACTIONS(2519),
    [anon_sym_required] = ACTIONS(2519),
    [anon_sym_component] = ACTIONS(2519),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [719] = {
    [sym__call_signature] = STATE(6155),
    [sym_comment] = STATE(719),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2526),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2526),
    [anon_sym_EQ] = ACTIONS(993),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2526),
    [anon_sym_from] = ACTIONS(2526),
    [anon_sym_let] = ACTIONS(2526),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2526),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_async] = ACTIONS(2526),
    [anon_sym_function] = ACTIONS(2528),
    [anon_sym_EQ_GT] = ACTIONS(999),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2526),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2526),
    [anon_sym_readonly] = ACTIONS(2526),
    [anon_sym_get] = ACTIONS(2526),
    [anon_sym_set] = ACTIONS(2526),
    [anon_sym_declare] = ACTIONS(2526),
    [anon_sym_public] = ACTIONS(2526),
    [anon_sym_private] = ACTIONS(2526),
    [anon_sym_protected] = ACTIONS(2526),
    [anon_sym_override] = ACTIONS(2526),
    [anon_sym_module] = ACTIONS(2526),
    [anon_sym_any] = ACTIONS(2526),
    [anon_sym_number] = ACTIONS(2526),
    [anon_sym_boolean] = ACTIONS(2526),
    [anon_sym_string] = ACTIONS(2526),
    [anon_sym_symbol] = ACTIONS(2526),
    [anon_sym_object] = ACTIONS(2526),
    [anon_sym_property] = ACTIONS(2526),
    [anon_sym_signal] = ACTIONS(2526),
    [anon_sym_on] = ACTIONS(2526),
    [anon_sym_required] = ACTIONS(2526),
    [anon_sym_component] = ACTIONS(2526),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [720] = {
    [sym__call_signature] = STATE(6155),
    [sym_comment] = STATE(720),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2526),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2526),
    [anon_sym_EQ] = ACTIONS(993),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2526),
    [anon_sym_from] = ACTIONS(2526),
    [anon_sym_let] = ACTIONS(2526),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2526),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_async] = ACTIONS(2526),
    [anon_sym_function] = ACTIONS(2324),
    [anon_sym_EQ_GT] = ACTIONS(999),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2526),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2526),
    [anon_sym_readonly] = ACTIONS(2526),
    [anon_sym_get] = ACTIONS(2526),
    [anon_sym_set] = ACTIONS(2526),
    [anon_sym_declare] = ACTIONS(2526),
    [anon_sym_public] = ACTIONS(2526),
    [anon_sym_private] = ACTIONS(2526),
    [anon_sym_protected] = ACTIONS(2526),
    [anon_sym_override] = ACTIONS(2526),
    [anon_sym_module] = ACTIONS(2526),
    [anon_sym_any] = ACTIONS(2526),
    [anon_sym_number] = ACTIONS(2526),
    [anon_sym_boolean] = ACTIONS(2526),
    [anon_sym_string] = ACTIONS(2526),
    [anon_sym_symbol] = ACTIONS(2526),
    [anon_sym_object] = ACTIONS(2526),
    [anon_sym_property] = ACTIONS(2526),
    [anon_sym_signal] = ACTIONS(2526),
    [anon_sym_on] = ACTIONS(2526),
    [anon_sym_required] = ACTIONS(2526),
    [anon_sym_component] = ACTIONS(2526),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [721] = {
    [sym__call_signature] = STATE(6155),
    [sym_comment] = STATE(721),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2526),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2526),
    [anon_sym_EQ] = ACTIONS(993),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2526),
    [anon_sym_from] = ACTIONS(2526),
    [anon_sym_let] = ACTIONS(2526),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2526),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_async] = ACTIONS(2526),
    [anon_sym_function] = ACTIONS(2489),
    [anon_sym_EQ_GT] = ACTIONS(999),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2526),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2526),
    [anon_sym_readonly] = ACTIONS(2526),
    [anon_sym_get] = ACTIONS(2526),
    [anon_sym_set] = ACTIONS(2526),
    [anon_sym_declare] = ACTIONS(2526),
    [anon_sym_public] = ACTIONS(2526),
    [anon_sym_private] = ACTIONS(2526),
    [anon_sym_protected] = ACTIONS(2526),
    [anon_sym_override] = ACTIONS(2526),
    [anon_sym_module] = ACTIONS(2526),
    [anon_sym_any] = ACTIONS(2526),
    [anon_sym_number] = ACTIONS(2526),
    [anon_sym_boolean] = ACTIONS(2526),
    [anon_sym_string] = ACTIONS(2526),
    [anon_sym_symbol] = ACTIONS(2526),
    [anon_sym_object] = ACTIONS(2526),
    [anon_sym_property] = ACTIONS(2526),
    [anon_sym_signal] = ACTIONS(2526),
    [anon_sym_on] = ACTIONS(2526),
    [anon_sym_required] = ACTIONS(2526),
    [anon_sym_component] = ACTIONS(2526),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [722] = {
    [sym_catch_clause] = STATE(749),
    [sym_finally_clause] = STATE(787),
    [sym_comment] = STATE(722),
    [sym_identifier] = ACTIONS(2530),
    [anon_sym_export] = ACTIONS(2530),
    [anon_sym_default] = ACTIONS(2530),
    [anon_sym_type] = ACTIONS(2530),
    [anon_sym_namespace] = ACTIONS(2530),
    [anon_sym_LBRACE] = ACTIONS(2532),
    [anon_sym_RBRACE] = ACTIONS(2532),
    [anon_sym_typeof] = ACTIONS(2530),
    [anon_sym_import] = ACTIONS(2530),
    [anon_sym_from] = ACTIONS(2530),
    [anon_sym_with] = ACTIONS(2530),
    [anon_sym_var] = ACTIONS(2530),
    [anon_sym_let] = ACTIONS(2530),
    [anon_sym_const] = ACTIONS(2530),
    [anon_sym_BANG] = ACTIONS(2532),
    [anon_sym_else] = ACTIONS(2530),
    [anon_sym_if] = ACTIONS(2530),
    [anon_sym_switch] = ACTIONS(2530),
    [anon_sym_for] = ACTIONS(2530),
    [anon_sym_LPAREN] = ACTIONS(2532),
    [anon_sym_await] = ACTIONS(2530),
    [anon_sym_of] = ACTIONS(2530),
    [anon_sym_while] = ACTIONS(2530),
    [anon_sym_do] = ACTIONS(2530),
    [anon_sym_try] = ACTIONS(2530),
    [anon_sym_break] = ACTIONS(2530),
    [anon_sym_continue] = ACTIONS(2530),
    [anon_sym_debugger] = ACTIONS(2530),
    [anon_sym_return] = ACTIONS(2530),
    [anon_sym_throw] = ACTIONS(2530),
    [anon_sym_SEMI] = ACTIONS(2532),
    [anon_sym_case] = ACTIONS(2530),
    [anon_sym_catch] = ACTIONS(2534),
    [anon_sym_finally] = ACTIONS(2536),
    [anon_sym_yield] = ACTIONS(2530),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_LTtemplate_GT] = ACTIONS(2532),
    [anon_sym_DQUOTE] = ACTIONS(2532),
    [anon_sym_SQUOTE] = ACTIONS(2532),
    [anon_sym_class] = ACTIONS(2530),
    [anon_sym_async] = ACTIONS(2530),
    [anon_sym_function] = ACTIONS(2530),
    [anon_sym_new] = ACTIONS(2530),
    [anon_sym_using] = ACTIONS(2530),
    [anon_sym_PLUS] = ACTIONS(2530),
    [anon_sym_DASH] = ACTIONS(2530),
    [anon_sym_SLASH] = ACTIONS(2530),
    [anon_sym_LT] = ACTIONS(2530),
    [anon_sym_TILDE] = ACTIONS(2532),
    [anon_sym_void] = ACTIONS(2530),
    [anon_sym_delete] = ACTIONS(2530),
    [anon_sym_PLUS_PLUS] = ACTIONS(2532),
    [anon_sym_DASH_DASH] = ACTIONS(2532),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2532),
    [sym_number] = ACTIONS(2532),
    [sym_private_property_identifier] = ACTIONS(2532),
    [sym_this] = ACTIONS(2530),
    [sym_super] = ACTIONS(2530),
    [sym_true] = ACTIONS(2530),
    [sym_false] = ACTIONS(2530),
    [sym_null] = ACTIONS(2530),
    [sym_undefined] = ACTIONS(2530),
    [anon_sym_AT] = ACTIONS(2532),
    [anon_sym_static] = ACTIONS(2530),
    [anon_sym_readonly] = ACTIONS(2530),
    [anon_sym_get] = ACTIONS(2530),
    [anon_sym_set] = ACTIONS(2530),
    [anon_sym_declare] = ACTIONS(2530),
    [anon_sym_public] = ACTIONS(2530),
    [anon_sym_private] = ACTIONS(2530),
    [anon_sym_protected] = ACTIONS(2530),
    [anon_sym_override] = ACTIONS(2530),
    [anon_sym_module] = ACTIONS(2530),
    [anon_sym_any] = ACTIONS(2530),
    [anon_sym_number] = ACTIONS(2530),
    [anon_sym_boolean] = ACTIONS(2530),
    [anon_sym_string] = ACTIONS(2530),
    [anon_sym_symbol] = ACTIONS(2530),
    [anon_sym_object] = ACTIONS(2530),
    [anon_sym_property] = ACTIONS(2530),
    [anon_sym_signal] = ACTIONS(2530),
    [anon_sym_on] = ACTIONS(2530),
    [anon_sym_required] = ACTIONS(2530),
    [anon_sym_component] = ACTIONS(2530),
    [anon_sym_abstract] = ACTIONS(2530),
    [anon_sym_interface] = ACTIONS(2530),
    [anon_sym_enum] = ACTIONS(2530),
    [sym_html_comment] = ACTIONS(5),
  },
  [723] = {
    [sym__call_signature] = STATE(5942),
    [sym_comment] = STATE(723),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_identifier] = ACTIONS(2507),
    [anon_sym_export] = ACTIONS(2509),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2509),
    [anon_sym_EQ] = ACTIONS(1005),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2509),
    [anon_sym_from] = ACTIONS(2509),
    [anon_sym_let] = ACTIONS(2509),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2509),
    [anon_sym_COLON] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_RBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_async] = ACTIONS(2509),
    [anon_sym_function] = ACTIONS(2421),
    [anon_sym_EQ_GT] = ACTIONS(980),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2509),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2509),
    [anon_sym_readonly] = ACTIONS(2509),
    [anon_sym_get] = ACTIONS(2509),
    [anon_sym_set] = ACTIONS(2509),
    [anon_sym_declare] = ACTIONS(2509),
    [anon_sym_public] = ACTIONS(2509),
    [anon_sym_private] = ACTIONS(2509),
    [anon_sym_protected] = ACTIONS(2509),
    [anon_sym_override] = ACTIONS(2509),
    [anon_sym_module] = ACTIONS(2509),
    [anon_sym_any] = ACTIONS(2509),
    [anon_sym_number] = ACTIONS(2509),
    [anon_sym_boolean] = ACTIONS(2509),
    [anon_sym_string] = ACTIONS(2509),
    [anon_sym_symbol] = ACTIONS(2509),
    [anon_sym_object] = ACTIONS(2509),
    [anon_sym_property] = ACTIONS(2509),
    [anon_sym_signal] = ACTIONS(2509),
    [anon_sym_on] = ACTIONS(2509),
    [anon_sym_required] = ACTIONS(2509),
    [anon_sym_component] = ACTIONS(2509),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [724] = {
    [sym__call_signature] = STATE(5942),
    [sym_comment] = STATE(724),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_identifier] = ACTIONS(2507),
    [anon_sym_export] = ACTIONS(2509),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2509),
    [anon_sym_EQ] = ACTIONS(1005),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2509),
    [anon_sym_from] = ACTIONS(2509),
    [anon_sym_let] = ACTIONS(2509),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2509),
    [anon_sym_COLON] = ACTIONS(976),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_RBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_async] = ACTIONS(2509),
    [anon_sym_function] = ACTIONS(2421),
    [anon_sym_EQ_GT] = ACTIONS(980),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2509),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2509),
    [anon_sym_readonly] = ACTIONS(2509),
    [anon_sym_get] = ACTIONS(2509),
    [anon_sym_set] = ACTIONS(2509),
    [anon_sym_declare] = ACTIONS(2509),
    [anon_sym_public] = ACTIONS(2509),
    [anon_sym_private] = ACTIONS(2509),
    [anon_sym_protected] = ACTIONS(2509),
    [anon_sym_override] = ACTIONS(2509),
    [anon_sym_module] = ACTIONS(2509),
    [anon_sym_any] = ACTIONS(2509),
    [anon_sym_number] = ACTIONS(2509),
    [anon_sym_boolean] = ACTIONS(2509),
    [anon_sym_string] = ACTIONS(2509),
    [anon_sym_symbol] = ACTIONS(2509),
    [anon_sym_object] = ACTIONS(2509),
    [anon_sym_property] = ACTIONS(2509),
    [anon_sym_signal] = ACTIONS(2509),
    [anon_sym_on] = ACTIONS(2509),
    [anon_sym_required] = ACTIONS(2509),
    [anon_sym_component] = ACTIONS(2509),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [725] = {
    [sym__call_signature] = STATE(6155),
    [sym_comment] = STATE(725),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2526),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2526),
    [anon_sym_EQ] = ACTIONS(993),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2526),
    [anon_sym_from] = ACTIONS(2526),
    [anon_sym_let] = ACTIONS(2526),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2526),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_async] = ACTIONS(2526),
    [anon_sym_function] = ACTIONS(2493),
    [anon_sym_EQ_GT] = ACTIONS(999),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2526),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2526),
    [anon_sym_readonly] = ACTIONS(2526),
    [anon_sym_get] = ACTIONS(2526),
    [anon_sym_set] = ACTIONS(2526),
    [anon_sym_declare] = ACTIONS(2526),
    [anon_sym_public] = ACTIONS(2526),
    [anon_sym_private] = ACTIONS(2526),
    [anon_sym_protected] = ACTIONS(2526),
    [anon_sym_override] = ACTIONS(2526),
    [anon_sym_module] = ACTIONS(2526),
    [anon_sym_any] = ACTIONS(2526),
    [anon_sym_number] = ACTIONS(2526),
    [anon_sym_boolean] = ACTIONS(2526),
    [anon_sym_string] = ACTIONS(2526),
    [anon_sym_symbol] = ACTIONS(2526),
    [anon_sym_object] = ACTIONS(2526),
    [anon_sym_property] = ACTIONS(2526),
    [anon_sym_signal] = ACTIONS(2526),
    [anon_sym_on] = ACTIONS(2526),
    [anon_sym_required] = ACTIONS(2526),
    [anon_sym_component] = ACTIONS(2526),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [726] = {
    [sym__call_signature] = STATE(6155),
    [sym_comment] = STATE(726),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2526),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2526),
    [anon_sym_EQ] = ACTIONS(993),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2526),
    [anon_sym_from] = ACTIONS(2526),
    [anon_sym_let] = ACTIONS(2526),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2526),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_async] = ACTIONS(2526),
    [anon_sym_function] = ACTIONS(2495),
    [anon_sym_EQ_GT] = ACTIONS(999),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2526),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2526),
    [anon_sym_readonly] = ACTIONS(2526),
    [anon_sym_get] = ACTIONS(2526),
    [anon_sym_set] = ACTIONS(2526),
    [anon_sym_declare] = ACTIONS(2526),
    [anon_sym_public] = ACTIONS(2526),
    [anon_sym_private] = ACTIONS(2526),
    [anon_sym_protected] = ACTIONS(2526),
    [anon_sym_override] = ACTIONS(2526),
    [anon_sym_module] = ACTIONS(2526),
    [anon_sym_any] = ACTIONS(2526),
    [anon_sym_number] = ACTIONS(2526),
    [anon_sym_boolean] = ACTIONS(2526),
    [anon_sym_string] = ACTIONS(2526),
    [anon_sym_symbol] = ACTIONS(2526),
    [anon_sym_object] = ACTIONS(2526),
    [anon_sym_property] = ACTIONS(2526),
    [anon_sym_signal] = ACTIONS(2526),
    [anon_sym_on] = ACTIONS(2526),
    [anon_sym_required] = ACTIONS(2526),
    [anon_sym_component] = ACTIONS(2526),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [727] = {
    [sym__call_signature] = STATE(5942),
    [sym_comment] = STATE(727),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_identifier] = ACTIONS(2507),
    [anon_sym_export] = ACTIONS(2509),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2509),
    [anon_sym_EQ] = ACTIONS(971),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2509),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_from] = ACTIONS(2509),
    [anon_sym_let] = ACTIONS(2509),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2509),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_RBRACK] = ACTIONS(36),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_async] = ACTIONS(2509),
    [anon_sym_function] = ACTIONS(2421),
    [anon_sym_EQ_GT] = ACTIONS(980),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2509),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2509),
    [anon_sym_readonly] = ACTIONS(2509),
    [anon_sym_get] = ACTIONS(2509),
    [anon_sym_set] = ACTIONS(2509),
    [anon_sym_declare] = ACTIONS(2509),
    [anon_sym_public] = ACTIONS(2509),
    [anon_sym_private] = ACTIONS(2509),
    [anon_sym_protected] = ACTIONS(2509),
    [anon_sym_override] = ACTIONS(2509),
    [anon_sym_module] = ACTIONS(2509),
    [anon_sym_any] = ACTIONS(2509),
    [anon_sym_number] = ACTIONS(2509),
    [anon_sym_boolean] = ACTIONS(2509),
    [anon_sym_string] = ACTIONS(2509),
    [anon_sym_symbol] = ACTIONS(2509),
    [anon_sym_object] = ACTIONS(2509),
    [anon_sym_property] = ACTIONS(2509),
    [anon_sym_signal] = ACTIONS(2509),
    [anon_sym_on] = ACTIONS(2509),
    [anon_sym_required] = ACTIONS(2509),
    [anon_sym_component] = ACTIONS(2509),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [728] = {
    [sym__call_signature] = STATE(6155),
    [sym_comment] = STATE(728),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2526),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2526),
    [anon_sym_EQ] = ACTIONS(863),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2526),
    [anon_sym_from] = ACTIONS(2526),
    [anon_sym_let] = ACTIONS(2526),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2526),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_async] = ACTIONS(2526),
    [anon_sym_function] = ACTIONS(2489),
    [anon_sym_EQ_GT] = ACTIONS(999),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2526),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2526),
    [anon_sym_readonly] = ACTIONS(2526),
    [anon_sym_get] = ACTIONS(2526),
    [anon_sym_set] = ACTIONS(2526),
    [anon_sym_declare] = ACTIONS(2526),
    [anon_sym_public] = ACTIONS(2526),
    [anon_sym_private] = ACTIONS(2526),
    [anon_sym_protected] = ACTIONS(2526),
    [anon_sym_override] = ACTIONS(2526),
    [anon_sym_module] = ACTIONS(2526),
    [anon_sym_any] = ACTIONS(2526),
    [anon_sym_number] = ACTIONS(2526),
    [anon_sym_boolean] = ACTIONS(2526),
    [anon_sym_string] = ACTIONS(2526),
    [anon_sym_symbol] = ACTIONS(2526),
    [anon_sym_object] = ACTIONS(2526),
    [anon_sym_property] = ACTIONS(2526),
    [anon_sym_signal] = ACTIONS(2526),
    [anon_sym_on] = ACTIONS(2526),
    [anon_sym_required] = ACTIONS(2526),
    [anon_sym_component] = ACTIONS(2526),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [729] = {
    [sym_declaration] = STATE(819),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_class_declaration] = STATE(829),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function_declaration] = STATE(829),
    [sym_comment] = STATE(729),
    [sym_decorator] = STATE(1202),
    [sym_function_signature] = STATE(829),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(831),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [aux_sym_export_statement_repeat1] = STATE(4313),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2408),
    [anon_sym_EQ] = ACTIONS(993),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2434),
    [anon_sym_import] = ACTIONS(2364),
    [anon_sym_var] = ACTIONS(2436),
    [anon_sym_let] = ACTIONS(2368),
    [anon_sym_const] = ACTIONS(2370),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(70),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_class] = ACTIONS(2372),
    [anon_sym_async] = ACTIONS(2438),
    [anon_sym_function] = ACTIONS(2440),
    [anon_sym_EQ_GT] = ACTIONS(999),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(70),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_declare] = ACTIONS(2442),
    [anon_sym_module] = ACTIONS(2513),
    [anon_sym_abstract] = ACTIONS(2382),
    [anon_sym_satisfies] = ACTIONS(70),
    [anon_sym_global] = ACTIONS(2515),
    [anon_sym_interface] = ACTIONS(2384),
    [anon_sym_enum] = ACTIONS(2386),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [730] = {
    [sym__call_signature] = STATE(6052),
    [sym_comment] = STATE(730),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_identifier] = ACTIONS(2538),
    [anon_sym_export] = ACTIONS(2540),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2540),
    [anon_sym_EQ] = ACTIONS(1027),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2540),
    [anon_sym_from] = ACTIONS(2540),
    [anon_sym_let] = ACTIONS(2540),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2540),
    [anon_sym_COLON] = ACTIONS(70),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_async] = ACTIONS(2540),
    [anon_sym_function] = ACTIONS(2421),
    [anon_sym_EQ_GT] = ACTIONS(1037),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2540),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2540),
    [anon_sym_readonly] = ACTIONS(2540),
    [anon_sym_get] = ACTIONS(2540),
    [anon_sym_set] = ACTIONS(2540),
    [anon_sym_declare] = ACTIONS(2540),
    [anon_sym_public] = ACTIONS(2540),
    [anon_sym_private] = ACTIONS(2540),
    [anon_sym_protected] = ACTIONS(2540),
    [anon_sym_override] = ACTIONS(2540),
    [anon_sym_module] = ACTIONS(2540),
    [anon_sym_any] = ACTIONS(2540),
    [anon_sym_number] = ACTIONS(2540),
    [anon_sym_boolean] = ACTIONS(2540),
    [anon_sym_string] = ACTIONS(2540),
    [anon_sym_symbol] = ACTIONS(2540),
    [anon_sym_object] = ACTIONS(2540),
    [anon_sym_property] = ACTIONS(2540),
    [anon_sym_signal] = ACTIONS(2540),
    [anon_sym_on] = ACTIONS(2540),
    [anon_sym_required] = ACTIONS(2540),
    [anon_sym_component] = ACTIONS(2540),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [731] = {
    [sym_comment] = STATE(731),
    [sym_identifier] = ACTIONS(1854),
    [anon_sym_export] = ACTIONS(1854),
    [anon_sym_default] = ACTIONS(1854),
    [anon_sym_type] = ACTIONS(1854),
    [anon_sym_namespace] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [anon_sym_RBRACE] = ACTIONS(1856),
    [anon_sym_typeof] = ACTIONS(1854),
    [anon_sym_import] = ACTIONS(1854),
    [anon_sym_from] = ACTIONS(1854),
    [anon_sym_with] = ACTIONS(1854),
    [anon_sym_var] = ACTIONS(1854),
    [anon_sym_let] = ACTIONS(1854),
    [anon_sym_const] = ACTIONS(1854),
    [anon_sym_BANG] = ACTIONS(1856),
    [anon_sym_else] = ACTIONS(1854),
    [anon_sym_if] = ACTIONS(1854),
    [anon_sym_switch] = ACTIONS(1854),
    [anon_sym_for] = ACTIONS(1854),
    [anon_sym_LPAREN] = ACTIONS(1856),
    [anon_sym_await] = ACTIONS(1854),
    [anon_sym_of] = ACTIONS(1854),
    [anon_sym_while] = ACTIONS(1854),
    [anon_sym_do] = ACTIONS(1854),
    [anon_sym_try] = ACTIONS(1854),
    [anon_sym_break] = ACTIONS(1854),
    [anon_sym_continue] = ACTIONS(1854),
    [anon_sym_debugger] = ACTIONS(1854),
    [anon_sym_return] = ACTIONS(1854),
    [anon_sym_throw] = ACTIONS(1854),
    [anon_sym_SEMI] = ACTIONS(1856),
    [anon_sym_case] = ACTIONS(1854),
    [anon_sym_catch] = ACTIONS(1854),
    [anon_sym_finally] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1854),
    [anon_sym_LBRACK] = ACTIONS(1856),
    [anon_sym_LTtemplate_GT] = ACTIONS(1856),
    [anon_sym_DQUOTE] = ACTIONS(1856),
    [anon_sym_SQUOTE] = ACTIONS(1856),
    [anon_sym_class] = ACTIONS(1854),
    [anon_sym_async] = ACTIONS(1854),
    [anon_sym_function] = ACTIONS(1854),
    [anon_sym_new] = ACTIONS(1854),
    [anon_sym_using] = ACTIONS(1854),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_DASH] = ACTIONS(1854),
    [anon_sym_SLASH] = ACTIONS(1854),
    [anon_sym_LT] = ACTIONS(1854),
    [anon_sym_TILDE] = ACTIONS(1856),
    [anon_sym_void] = ACTIONS(1854),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_PLUS_PLUS] = ACTIONS(1856),
    [anon_sym_DASH_DASH] = ACTIONS(1856),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1856),
    [sym_number] = ACTIONS(1856),
    [sym_private_property_identifier] = ACTIONS(1856),
    [sym_this] = ACTIONS(1854),
    [sym_super] = ACTIONS(1854),
    [sym_true] = ACTIONS(1854),
    [sym_false] = ACTIONS(1854),
    [sym_null] = ACTIONS(1854),
    [sym_undefined] = ACTIONS(1854),
    [anon_sym_AT] = ACTIONS(1856),
    [anon_sym_static] = ACTIONS(1854),
    [anon_sym_readonly] = ACTIONS(1854),
    [anon_sym_get] = ACTIONS(1854),
    [anon_sym_set] = ACTIONS(1854),
    [anon_sym_declare] = ACTIONS(1854),
    [anon_sym_public] = ACTIONS(1854),
    [anon_sym_private] = ACTIONS(1854),
    [anon_sym_protected] = ACTIONS(1854),
    [anon_sym_override] = ACTIONS(1854),
    [anon_sym_module] = ACTIONS(1854),
    [anon_sym_any] = ACTIONS(1854),
    [anon_sym_number] = ACTIONS(1854),
    [anon_sym_boolean] = ACTIONS(1854),
    [anon_sym_string] = ACTIONS(1854),
    [anon_sym_symbol] = ACTIONS(1854),
    [anon_sym_object] = ACTIONS(1854),
    [anon_sym_property] = ACTIONS(1854),
    [anon_sym_signal] = ACTIONS(1854),
    [anon_sym_on] = ACTIONS(1854),
    [anon_sym_required] = ACTIONS(1854),
    [anon_sym_component] = ACTIONS(1854),
    [anon_sym_abstract] = ACTIONS(1854),
    [anon_sym_interface] = ACTIONS(1854),
    [anon_sym_enum] = ACTIONS(1854),
    [sym__automatic_semicolon] = ACTIONS(2542),
    [sym_html_comment] = ACTIONS(5),
  },
  [732] = {
    [sym_comment] = STATE(732),
    [sym_identifier] = ACTIONS(1968),
    [anon_sym_export] = ACTIONS(1968),
    [anon_sym_default] = ACTIONS(1968),
    [anon_sym_type] = ACTIONS(1968),
    [anon_sym_namespace] = ACTIONS(1968),
    [anon_sym_LBRACE] = ACTIONS(1970),
    [anon_sym_COMMA] = ACTIONS(1970),
    [anon_sym_RBRACE] = ACTIONS(1970),
    [anon_sym_typeof] = ACTIONS(1968),
    [anon_sym_import] = ACTIONS(1968),
    [anon_sym_from] = ACTIONS(1968),
    [anon_sym_with] = ACTIONS(1968),
    [anon_sym_var] = ACTIONS(1968),
    [anon_sym_let] = ACTIONS(1968),
    [anon_sym_const] = ACTIONS(1968),
    [anon_sym_BANG] = ACTIONS(1970),
    [anon_sym_else] = ACTIONS(1968),
    [anon_sym_if] = ACTIONS(1968),
    [anon_sym_switch] = ACTIONS(1968),
    [anon_sym_for] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1970),
    [anon_sym_await] = ACTIONS(1968),
    [anon_sym_of] = ACTIONS(1968),
    [anon_sym_while] = ACTIONS(1968),
    [anon_sym_do] = ACTIONS(1968),
    [anon_sym_try] = ACTIONS(1968),
    [anon_sym_break] = ACTIONS(1968),
    [anon_sym_continue] = ACTIONS(1968),
    [anon_sym_debugger] = ACTIONS(1968),
    [anon_sym_return] = ACTIONS(1968),
    [anon_sym_throw] = ACTIONS(1968),
    [anon_sym_SEMI] = ACTIONS(1970),
    [anon_sym_case] = ACTIONS(1968),
    [anon_sym_yield] = ACTIONS(1968),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_LTtemplate_GT] = ACTIONS(1970),
    [anon_sym_DQUOTE] = ACTIONS(1970),
    [anon_sym_SQUOTE] = ACTIONS(1970),
    [anon_sym_class] = ACTIONS(1968),
    [anon_sym_async] = ACTIONS(1968),
    [anon_sym_function] = ACTIONS(1968),
    [anon_sym_new] = ACTIONS(1968),
    [anon_sym_using] = ACTIONS(1968),
    [anon_sym_PLUS] = ACTIONS(1968),
    [anon_sym_DASH] = ACTIONS(1968),
    [anon_sym_SLASH] = ACTIONS(1968),
    [anon_sym_LT] = ACTIONS(1968),
    [anon_sym_TILDE] = ACTIONS(1970),
    [anon_sym_void] = ACTIONS(1968),
    [anon_sym_delete] = ACTIONS(1968),
    [anon_sym_PLUS_PLUS] = ACTIONS(1970),
    [anon_sym_DASH_DASH] = ACTIONS(1970),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1970),
    [sym_number] = ACTIONS(1970),
    [sym_private_property_identifier] = ACTIONS(1970),
    [sym_this] = ACTIONS(1968),
    [sym_super] = ACTIONS(1968),
    [sym_true] = ACTIONS(1968),
    [sym_false] = ACTIONS(1968),
    [sym_null] = ACTIONS(1968),
    [sym_undefined] = ACTIONS(1968),
    [anon_sym_AT] = ACTIONS(1970),
    [anon_sym_static] = ACTIONS(1968),
    [anon_sym_readonly] = ACTIONS(1968),
    [anon_sym_get] = ACTIONS(1968),
    [anon_sym_set] = ACTIONS(1968),
    [anon_sym_declare] = ACTIONS(1968),
    [anon_sym_public] = ACTIONS(1968),
    [anon_sym_private] = ACTIONS(1968),
    [anon_sym_protected] = ACTIONS(1968),
    [anon_sym_override] = ACTIONS(1968),
    [anon_sym_module] = ACTIONS(1968),
    [anon_sym_any] = ACTIONS(1968),
    [anon_sym_number] = ACTIONS(1968),
    [anon_sym_boolean] = ACTIONS(1968),
    [anon_sym_string] = ACTIONS(1968),
    [anon_sym_symbol] = ACTIONS(1968),
    [anon_sym_object] = ACTIONS(1968),
    [anon_sym_property] = ACTIONS(1968),
    [anon_sym_signal] = ACTIONS(1968),
    [anon_sym_on] = ACTIONS(1968),
    [anon_sym_required] = ACTIONS(1968),
    [anon_sym_component] = ACTIONS(1968),
    [anon_sym_abstract] = ACTIONS(1968),
    [anon_sym_interface] = ACTIONS(1968),
    [anon_sym_enum] = ACTIONS(1968),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1970),
    [sym__automatic_semicolon] = ACTIONS(1970),
    [sym_html_comment] = ACTIONS(5),
  },
  [733] = {
    [sym_declaration] = STATE(819),
    [sym_variable_declaration] = STATE(829),
    [sym_lexical_declaration] = STATE(829),
    [sym_class_declaration] = STATE(829),
    [sym_function_declaration] = STATE(829),
    [sym_generator_function_declaration] = STATE(829),
    [sym_comment] = STATE(733),
    [sym_decorator] = STATE(1202),
    [sym_function_signature] = STATE(829),
    [sym_ambient_declaration] = STATE(829),
    [sym_abstract_class_declaration] = STATE(829),
    [sym_module] = STATE(829),
    [sym_internal_module] = STATE(831),
    [sym_import_alias] = STATE(829),
    [sym_interface_declaration] = STATE(829),
    [sym_enum_declaration] = STATE(829),
    [sym_type_alias_declaration] = STATE(829),
    [aux_sym_export_statement_repeat1] = STATE(4313),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2408),
    [anon_sym_EQ] = ACTIONS(993),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2360),
    [anon_sym_import] = ACTIONS(2364),
    [anon_sym_var] = ACTIONS(2366),
    [anon_sym_let] = ACTIONS(2368),
    [anon_sym_const] = ACTIONS(2370),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(70),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_class] = ACTIONS(2372),
    [anon_sym_async] = ACTIONS(2374),
    [anon_sym_function] = ACTIONS(2376),
    [anon_sym_EQ_GT] = ACTIONS(999),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(70),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_declare] = ACTIONS(2378),
    [anon_sym_module] = ACTIONS(2410),
    [anon_sym_abstract] = ACTIONS(2382),
    [anon_sym_satisfies] = ACTIONS(70),
    [anon_sym_global] = ACTIONS(2412),
    [anon_sym_interface] = ACTIONS(2384),
    [anon_sym_enum] = ACTIONS(2386),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [734] = {
    [sym_comment] = STATE(734),
    [sym_identifier] = ACTIONS(1792),
    [anon_sym_export] = ACTIONS(1792),
    [anon_sym_default] = ACTIONS(1792),
    [anon_sym_type] = ACTIONS(1792),
    [anon_sym_namespace] = ACTIONS(1792),
    [anon_sym_LBRACE] = ACTIONS(1798),
    [anon_sym_RBRACE] = ACTIONS(1798),
    [anon_sym_typeof] = ACTIONS(1792),
    [anon_sym_import] = ACTIONS(1792),
    [anon_sym_from] = ACTIONS(1792),
    [anon_sym_with] = ACTIONS(1792),
    [anon_sym_var] = ACTIONS(1792),
    [anon_sym_let] = ACTIONS(1792),
    [anon_sym_const] = ACTIONS(1792),
    [anon_sym_BANG] = ACTIONS(1798),
    [anon_sym_else] = ACTIONS(1792),
    [anon_sym_if] = ACTIONS(1792),
    [anon_sym_switch] = ACTIONS(1792),
    [anon_sym_for] = ACTIONS(1792),
    [anon_sym_LPAREN] = ACTIONS(1798),
    [anon_sym_await] = ACTIONS(1792),
    [anon_sym_of] = ACTIONS(1792),
    [anon_sym_while] = ACTIONS(1792),
    [anon_sym_do] = ACTIONS(1792),
    [anon_sym_try] = ACTIONS(1792),
    [anon_sym_break] = ACTIONS(1792),
    [anon_sym_continue] = ACTIONS(1792),
    [anon_sym_debugger] = ACTIONS(1792),
    [anon_sym_return] = ACTIONS(1792),
    [anon_sym_throw] = ACTIONS(1792),
    [anon_sym_SEMI] = ACTIONS(1798),
    [anon_sym_case] = ACTIONS(1792),
    [anon_sym_catch] = ACTIONS(1792),
    [anon_sym_finally] = ACTIONS(1792),
    [anon_sym_yield] = ACTIONS(1792),
    [anon_sym_LBRACK] = ACTIONS(1798),
    [anon_sym_LTtemplate_GT] = ACTIONS(1798),
    [anon_sym_DQUOTE] = ACTIONS(1798),
    [anon_sym_SQUOTE] = ACTIONS(1798),
    [anon_sym_class] = ACTIONS(1792),
    [anon_sym_async] = ACTIONS(1792),
    [anon_sym_function] = ACTIONS(1792),
    [anon_sym_new] = ACTIONS(1792),
    [anon_sym_using] = ACTIONS(1792),
    [anon_sym_PLUS] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(1792),
    [anon_sym_SLASH] = ACTIONS(1792),
    [anon_sym_LT] = ACTIONS(1792),
    [anon_sym_TILDE] = ACTIONS(1798),
    [anon_sym_void] = ACTIONS(1792),
    [anon_sym_delete] = ACTIONS(1792),
    [anon_sym_PLUS_PLUS] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1798),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1798),
    [sym_number] = ACTIONS(1798),
    [sym_private_property_identifier] = ACTIONS(1798),
    [sym_this] = ACTIONS(1792),
    [sym_super] = ACTIONS(1792),
    [sym_true] = ACTIONS(1792),
    [sym_false] = ACTIONS(1792),
    [sym_null] = ACTIONS(1792),
    [sym_undefined] = ACTIONS(1792),
    [anon_sym_AT] = ACTIONS(1798),
    [anon_sym_static] = ACTIONS(1792),
    [anon_sym_readonly] = ACTIONS(1792),
    [anon_sym_get] = ACTIONS(1792),
    [anon_sym_set] = ACTIONS(1792),
    [anon_sym_declare] = ACTIONS(1792),
    [anon_sym_public] = ACTIONS(1792),
    [anon_sym_private] = ACTIONS(1792),
    [anon_sym_protected] = ACTIONS(1792),
    [anon_sym_override] = ACTIONS(1792),
    [anon_sym_module] = ACTIONS(1792),
    [anon_sym_any] = ACTIONS(1792),
    [anon_sym_number] = ACTIONS(1792),
    [anon_sym_boolean] = ACTIONS(1792),
    [anon_sym_string] = ACTIONS(1792),
    [anon_sym_symbol] = ACTIONS(1792),
    [anon_sym_object] = ACTIONS(1792),
    [anon_sym_property] = ACTIONS(1792),
    [anon_sym_signal] = ACTIONS(1792),
    [anon_sym_on] = ACTIONS(1792),
    [anon_sym_required] = ACTIONS(1792),
    [anon_sym_component] = ACTIONS(1792),
    [anon_sym_abstract] = ACTIONS(1792),
    [anon_sym_interface] = ACTIONS(1792),
    [anon_sym_enum] = ACTIONS(1792),
    [sym__automatic_semicolon] = ACTIONS(1802),
    [sym_html_comment] = ACTIONS(5),
  },
  [735] = {
    [sym__call_signature] = STATE(6052),
    [sym_comment] = STATE(735),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_identifier] = ACTIONS(2538),
    [anon_sym_export] = ACTIONS(2540),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2540),
    [anon_sym_EQ] = ACTIONS(863),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2540),
    [anon_sym_from] = ACTIONS(2540),
    [anon_sym_let] = ACTIONS(2540),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2540),
    [anon_sym_COLON] = ACTIONS(70),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_async] = ACTIONS(2540),
    [anon_sym_function] = ACTIONS(2421),
    [anon_sym_EQ_GT] = ACTIONS(1037),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2540),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2540),
    [anon_sym_readonly] = ACTIONS(2540),
    [anon_sym_get] = ACTIONS(2540),
    [anon_sym_set] = ACTIONS(2540),
    [anon_sym_declare] = ACTIONS(2540),
    [anon_sym_public] = ACTIONS(2540),
    [anon_sym_private] = ACTIONS(2540),
    [anon_sym_protected] = ACTIONS(2540),
    [anon_sym_override] = ACTIONS(2540),
    [anon_sym_module] = ACTIONS(2540),
    [anon_sym_any] = ACTIONS(2540),
    [anon_sym_number] = ACTIONS(2540),
    [anon_sym_boolean] = ACTIONS(2540),
    [anon_sym_string] = ACTIONS(2540),
    [anon_sym_symbol] = ACTIONS(2540),
    [anon_sym_object] = ACTIONS(2540),
    [anon_sym_property] = ACTIONS(2540),
    [anon_sym_signal] = ACTIONS(2540),
    [anon_sym_on] = ACTIONS(2540),
    [anon_sym_required] = ACTIONS(2540),
    [anon_sym_component] = ACTIONS(2540),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [736] = {
    [sym__call_signature] = STATE(5942),
    [sym_comment] = STATE(736),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_identifier] = ACTIONS(2507),
    [anon_sym_export] = ACTIONS(2509),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2509),
    [anon_sym_EQ] = ACTIONS(863),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2509),
    [anon_sym_from] = ACTIONS(2509),
    [anon_sym_let] = ACTIONS(2509),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2509),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_RBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_async] = ACTIONS(2509),
    [anon_sym_function] = ACTIONS(2421),
    [anon_sym_EQ_GT] = ACTIONS(980),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2509),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2509),
    [anon_sym_readonly] = ACTIONS(2509),
    [anon_sym_get] = ACTIONS(2509),
    [anon_sym_set] = ACTIONS(2509),
    [anon_sym_declare] = ACTIONS(2509),
    [anon_sym_public] = ACTIONS(2509),
    [anon_sym_private] = ACTIONS(2509),
    [anon_sym_protected] = ACTIONS(2509),
    [anon_sym_override] = ACTIONS(2509),
    [anon_sym_module] = ACTIONS(2509),
    [anon_sym_any] = ACTIONS(2509),
    [anon_sym_number] = ACTIONS(2509),
    [anon_sym_boolean] = ACTIONS(2509),
    [anon_sym_string] = ACTIONS(2509),
    [anon_sym_symbol] = ACTIONS(2509),
    [anon_sym_object] = ACTIONS(2509),
    [anon_sym_property] = ACTIONS(2509),
    [anon_sym_signal] = ACTIONS(2509),
    [anon_sym_on] = ACTIONS(2509),
    [anon_sym_required] = ACTIONS(2509),
    [anon_sym_component] = ACTIONS(2509),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [737] = {
    [sym__call_signature] = STATE(5942),
    [sym_comment] = STATE(737),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_identifier] = ACTIONS(2507),
    [anon_sym_export] = ACTIONS(2509),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2509),
    [anon_sym_EQ] = ACTIONS(1005),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2509),
    [anon_sym_from] = ACTIONS(2509),
    [anon_sym_let] = ACTIONS(2509),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2509),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_RBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_async] = ACTIONS(2509),
    [anon_sym_function] = ACTIONS(2421),
    [anon_sym_EQ_GT] = ACTIONS(980),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2509),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2509),
    [anon_sym_readonly] = ACTIONS(2509),
    [anon_sym_get] = ACTIONS(2509),
    [anon_sym_set] = ACTIONS(2509),
    [anon_sym_declare] = ACTIONS(2509),
    [anon_sym_public] = ACTIONS(2509),
    [anon_sym_private] = ACTIONS(2509),
    [anon_sym_protected] = ACTIONS(2509),
    [anon_sym_override] = ACTIONS(2509),
    [anon_sym_module] = ACTIONS(2509),
    [anon_sym_any] = ACTIONS(2509),
    [anon_sym_number] = ACTIONS(2509),
    [anon_sym_boolean] = ACTIONS(2509),
    [anon_sym_string] = ACTIONS(2509),
    [anon_sym_symbol] = ACTIONS(2509),
    [anon_sym_object] = ACTIONS(2509),
    [anon_sym_property] = ACTIONS(2509),
    [anon_sym_signal] = ACTIONS(2509),
    [anon_sym_on] = ACTIONS(2509),
    [anon_sym_required] = ACTIONS(2509),
    [anon_sym_component] = ACTIONS(2509),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [738] = {
    [sym_declaration] = STATE(2997),
    [sym_variable_declaration] = STATE(2949),
    [sym_lexical_declaration] = STATE(2949),
    [sym_class_declaration] = STATE(2949),
    [sym_function_declaration] = STATE(2949),
    [sym_generator_function_declaration] = STATE(2949),
    [sym_comment] = STATE(738),
    [sym_decorator] = STATE(1202),
    [sym_function_signature] = STATE(2949),
    [sym_ambient_declaration] = STATE(2949),
    [sym_abstract_class_declaration] = STATE(2949),
    [sym_module] = STATE(2949),
    [sym_internal_module] = STATE(3020),
    [sym_import_alias] = STATE(2949),
    [sym_interface_declaration] = STATE(2949),
    [sym_enum_declaration] = STATE(2949),
    [sym_type_alias_declaration] = STATE(2949),
    [aux_sym_export_statement_repeat1] = STATE(4344),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2497),
    [anon_sym_EQ] = ACTIONS(993),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2456),
    [anon_sym_import] = ACTIONS(2458),
    [anon_sym_var] = ACTIONS(2436),
    [anon_sym_let] = ACTIONS(2460),
    [anon_sym_const] = ACTIONS(2462),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(70),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_class] = ACTIONS(2464),
    [anon_sym_async] = ACTIONS(2466),
    [anon_sym_function] = ACTIONS(2468),
    [anon_sym_EQ_GT] = ACTIONS(999),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(70),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_declare] = ACTIONS(2470),
    [anon_sym_module] = ACTIONS(2499),
    [anon_sym_abstract] = ACTIONS(2474),
    [anon_sym_satisfies] = ACTIONS(70),
    [anon_sym_global] = ACTIONS(2501),
    [anon_sym_interface] = ACTIONS(2476),
    [anon_sym_enum] = ACTIONS(2478),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [739] = {
    [sym_comment] = STATE(739),
    [sym_identifier] = ACTIONS(1926),
    [anon_sym_export] = ACTIONS(1926),
    [anon_sym_default] = ACTIONS(1926),
    [anon_sym_type] = ACTIONS(1926),
    [anon_sym_namespace] = ACTIONS(1926),
    [anon_sym_LBRACE] = ACTIONS(1928),
    [anon_sym_COMMA] = ACTIONS(1928),
    [anon_sym_RBRACE] = ACTIONS(1928),
    [anon_sym_typeof] = ACTIONS(1926),
    [anon_sym_import] = ACTIONS(1926),
    [anon_sym_from] = ACTIONS(1926),
    [anon_sym_with] = ACTIONS(1926),
    [anon_sym_var] = ACTIONS(1926),
    [anon_sym_let] = ACTIONS(1926),
    [anon_sym_const] = ACTIONS(1926),
    [anon_sym_BANG] = ACTIONS(1928),
    [anon_sym_else] = ACTIONS(1926),
    [anon_sym_if] = ACTIONS(1926),
    [anon_sym_switch] = ACTIONS(1926),
    [anon_sym_for] = ACTIONS(1926),
    [anon_sym_LPAREN] = ACTIONS(1928),
    [anon_sym_await] = ACTIONS(1926),
    [anon_sym_of] = ACTIONS(1926),
    [anon_sym_while] = ACTIONS(1926),
    [anon_sym_do] = ACTIONS(1926),
    [anon_sym_try] = ACTIONS(1926),
    [anon_sym_break] = ACTIONS(1926),
    [anon_sym_continue] = ACTIONS(1926),
    [anon_sym_debugger] = ACTIONS(1926),
    [anon_sym_return] = ACTIONS(1926),
    [anon_sym_throw] = ACTIONS(1926),
    [anon_sym_SEMI] = ACTIONS(1928),
    [anon_sym_case] = ACTIONS(1926),
    [anon_sym_yield] = ACTIONS(1926),
    [anon_sym_LBRACK] = ACTIONS(1928),
    [anon_sym_LTtemplate_GT] = ACTIONS(1928),
    [anon_sym_DQUOTE] = ACTIONS(1928),
    [anon_sym_SQUOTE] = ACTIONS(1928),
    [anon_sym_class] = ACTIONS(1926),
    [anon_sym_async] = ACTIONS(1926),
    [anon_sym_function] = ACTIONS(1926),
    [anon_sym_new] = ACTIONS(1926),
    [anon_sym_using] = ACTIONS(1926),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_SLASH] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1928),
    [anon_sym_void] = ACTIONS(1926),
    [anon_sym_delete] = ACTIONS(1926),
    [anon_sym_PLUS_PLUS] = ACTIONS(1928),
    [anon_sym_DASH_DASH] = ACTIONS(1928),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1928),
    [sym_private_property_identifier] = ACTIONS(1928),
    [sym_this] = ACTIONS(1926),
    [sym_super] = ACTIONS(1926),
    [sym_true] = ACTIONS(1926),
    [sym_false] = ACTIONS(1926),
    [sym_null] = ACTIONS(1926),
    [sym_undefined] = ACTIONS(1926),
    [anon_sym_AT] = ACTIONS(1928),
    [anon_sym_static] = ACTIONS(1926),
    [anon_sym_readonly] = ACTIONS(1926),
    [anon_sym_get] = ACTIONS(1926),
    [anon_sym_set] = ACTIONS(1926),
    [anon_sym_declare] = ACTIONS(1926),
    [anon_sym_public] = ACTIONS(1926),
    [anon_sym_private] = ACTIONS(1926),
    [anon_sym_protected] = ACTIONS(1926),
    [anon_sym_override] = ACTIONS(1926),
    [anon_sym_module] = ACTIONS(1926),
    [anon_sym_any] = ACTIONS(1926),
    [anon_sym_number] = ACTIONS(1926),
    [anon_sym_boolean] = ACTIONS(1926),
    [anon_sym_string] = ACTIONS(1926),
    [anon_sym_symbol] = ACTIONS(1926),
    [anon_sym_object] = ACTIONS(1926),
    [anon_sym_property] = ACTIONS(1926),
    [anon_sym_signal] = ACTIONS(1926),
    [anon_sym_on] = ACTIONS(1926),
    [anon_sym_required] = ACTIONS(1926),
    [anon_sym_component] = ACTIONS(1926),
    [anon_sym_abstract] = ACTIONS(1926),
    [anon_sym_interface] = ACTIONS(1926),
    [anon_sym_enum] = ACTIONS(1926),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1928),
    [sym__automatic_semicolon] = ACTIONS(1928),
    [sym_html_comment] = ACTIONS(5),
  },
  [740] = {
    [sym_declaration] = STATE(4286),
    [sym_variable_declaration] = STATE(4205),
    [sym_lexical_declaration] = STATE(4205),
    [sym_class_declaration] = STATE(4205),
    [sym_function_declaration] = STATE(4205),
    [sym_generator_function_declaration] = STATE(4205),
    [sym_comment] = STATE(740),
    [sym_decorator] = STATE(1202),
    [sym_function_signature] = STATE(4205),
    [sym_ambient_declaration] = STATE(4205),
    [sym_abstract_class_declaration] = STATE(4205),
    [sym_module] = STATE(4205),
    [sym_internal_module] = STATE(4277),
    [sym_import_alias] = STATE(4205),
    [sym_interface_declaration] = STATE(4205),
    [sym_enum_declaration] = STATE(4205),
    [sym_type_alias_declaration] = STATE(4205),
    [aux_sym_export_statement_repeat1] = STATE(4243),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2544),
    [anon_sym_EQ] = ACTIONS(993),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2546),
    [anon_sym_import] = ACTIONS(2548),
    [anon_sym_var] = ACTIONS(2550),
    [anon_sym_let] = ACTIONS(2552),
    [anon_sym_const] = ACTIONS(2554),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(70),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_class] = ACTIONS(2556),
    [anon_sym_async] = ACTIONS(2558),
    [anon_sym_function] = ACTIONS(2560),
    [anon_sym_EQ_GT] = ACTIONS(999),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(70),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_declare] = ACTIONS(2562),
    [anon_sym_module] = ACTIONS(2564),
    [anon_sym_abstract] = ACTIONS(2566),
    [anon_sym_satisfies] = ACTIONS(70),
    [anon_sym_global] = ACTIONS(2568),
    [anon_sym_interface] = ACTIONS(2570),
    [anon_sym_enum] = ACTIONS(2572),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [741] = {
    [sym__call_signature] = STATE(5981),
    [sym_comment] = STATE(741),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_identifier] = ACTIONS(2428),
    [anon_sym_export] = ACTIONS(2430),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2430),
    [anon_sym_EQ] = ACTIONS(1125),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2430),
    [anon_sym_from] = ACTIONS(2430),
    [anon_sym_let] = ACTIONS(2430),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2430),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_async] = ACTIONS(2430),
    [anon_sym_function] = ACTIONS(2421),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2430),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2430),
    [anon_sym_readonly] = ACTIONS(2430),
    [anon_sym_get] = ACTIONS(2430),
    [anon_sym_set] = ACTIONS(2430),
    [anon_sym_declare] = ACTIONS(2430),
    [anon_sym_public] = ACTIONS(2430),
    [anon_sym_private] = ACTIONS(2430),
    [anon_sym_protected] = ACTIONS(2430),
    [anon_sym_override] = ACTIONS(2430),
    [anon_sym_module] = ACTIONS(2430),
    [anon_sym_any] = ACTIONS(2430),
    [anon_sym_number] = ACTIONS(2430),
    [anon_sym_boolean] = ACTIONS(2430),
    [anon_sym_string] = ACTIONS(2430),
    [anon_sym_symbol] = ACTIONS(2430),
    [anon_sym_object] = ACTIONS(2430),
    [anon_sym_property] = ACTIONS(2430),
    [anon_sym_signal] = ACTIONS(2430),
    [anon_sym_on] = ACTIONS(2430),
    [anon_sym_required] = ACTIONS(2430),
    [anon_sym_component] = ACTIONS(2430),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [742] = {
    [sym__call_signature] = STATE(6315),
    [sym_comment] = STATE(742),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_identifier] = ACTIONS(2574),
    [anon_sym_export] = ACTIONS(2576),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2576),
    [anon_sym_EQ] = ACTIONS(863),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2576),
    [anon_sym_from] = ACTIONS(2576),
    [anon_sym_let] = ACTIONS(2576),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2578),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_async] = ACTIONS(2576),
    [anon_sym_function] = ACTIONS(2421),
    [anon_sym_EQ_GT] = ACTIONS(1053),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2576),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2576),
    [anon_sym_readonly] = ACTIONS(2576),
    [anon_sym_get] = ACTIONS(2576),
    [anon_sym_set] = ACTIONS(2576),
    [anon_sym_declare] = ACTIONS(2576),
    [anon_sym_public] = ACTIONS(2576),
    [anon_sym_private] = ACTIONS(2576),
    [anon_sym_protected] = ACTIONS(2576),
    [anon_sym_override] = ACTIONS(2576),
    [anon_sym_module] = ACTIONS(2576),
    [anon_sym_any] = ACTIONS(2576),
    [anon_sym_number] = ACTIONS(2576),
    [anon_sym_boolean] = ACTIONS(2576),
    [anon_sym_string] = ACTIONS(2576),
    [anon_sym_symbol] = ACTIONS(2576),
    [anon_sym_object] = ACTIONS(2576),
    [anon_sym_property] = ACTIONS(2576),
    [anon_sym_signal] = ACTIONS(2576),
    [anon_sym_on] = ACTIONS(2576),
    [anon_sym_required] = ACTIONS(2576),
    [anon_sym_component] = ACTIONS(2576),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [743] = {
    [sym__call_signature] = STATE(5981),
    [sym_comment] = STATE(743),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_identifier] = ACTIONS(2428),
    [anon_sym_export] = ACTIONS(2430),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2430),
    [anon_sym_EQ] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2430),
    [anon_sym_from] = ACTIONS(2430),
    [anon_sym_let] = ACTIONS(2430),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2430),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_async] = ACTIONS(2430),
    [anon_sym_function] = ACTIONS(2421),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2430),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2430),
    [anon_sym_readonly] = ACTIONS(2430),
    [anon_sym_get] = ACTIONS(2430),
    [anon_sym_set] = ACTIONS(2430),
    [anon_sym_declare] = ACTIONS(2430),
    [anon_sym_public] = ACTIONS(2430),
    [anon_sym_private] = ACTIONS(2430),
    [anon_sym_protected] = ACTIONS(2430),
    [anon_sym_override] = ACTIONS(2430),
    [anon_sym_module] = ACTIONS(2430),
    [anon_sym_any] = ACTIONS(2430),
    [anon_sym_number] = ACTIONS(2430),
    [anon_sym_boolean] = ACTIONS(2430),
    [anon_sym_string] = ACTIONS(2430),
    [anon_sym_symbol] = ACTIONS(2430),
    [anon_sym_object] = ACTIONS(2430),
    [anon_sym_property] = ACTIONS(2430),
    [anon_sym_signal] = ACTIONS(2430),
    [anon_sym_on] = ACTIONS(2430),
    [anon_sym_required] = ACTIONS(2430),
    [anon_sym_component] = ACTIONS(2430),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [744] = {
    [sym__call_signature] = STATE(6315),
    [sym_comment] = STATE(744),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_identifier] = ACTIONS(2574),
    [anon_sym_export] = ACTIONS(2576),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2576),
    [anon_sym_EQ] = ACTIONS(1047),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2576),
    [anon_sym_from] = ACTIONS(2576),
    [anon_sym_let] = ACTIONS(2576),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2578),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_async] = ACTIONS(2576),
    [anon_sym_function] = ACTIONS(2421),
    [anon_sym_EQ_GT] = ACTIONS(1053),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2576),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2576),
    [anon_sym_readonly] = ACTIONS(2576),
    [anon_sym_get] = ACTIONS(2576),
    [anon_sym_set] = ACTIONS(2576),
    [anon_sym_declare] = ACTIONS(2576),
    [anon_sym_public] = ACTIONS(2576),
    [anon_sym_private] = ACTIONS(2576),
    [anon_sym_protected] = ACTIONS(2576),
    [anon_sym_override] = ACTIONS(2576),
    [anon_sym_module] = ACTIONS(2576),
    [anon_sym_any] = ACTIONS(2576),
    [anon_sym_number] = ACTIONS(2576),
    [anon_sym_boolean] = ACTIONS(2576),
    [anon_sym_string] = ACTIONS(2576),
    [anon_sym_symbol] = ACTIONS(2576),
    [anon_sym_object] = ACTIONS(2576),
    [anon_sym_property] = ACTIONS(2576),
    [anon_sym_signal] = ACTIONS(2576),
    [anon_sym_on] = ACTIONS(2576),
    [anon_sym_required] = ACTIONS(2576),
    [anon_sym_component] = ACTIONS(2576),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [745] = {
    [sym__call_signature] = STATE(5981),
    [sym_comment] = STATE(745),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_identifier] = ACTIONS(2428),
    [anon_sym_export] = ACTIONS(2430),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2430),
    [anon_sym_EQ] = ACTIONS(1117),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2430),
    [anon_sym_from] = ACTIONS(2430),
    [anon_sym_let] = ACTIONS(2430),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2430),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_async] = ACTIONS(2430),
    [anon_sym_function] = ACTIONS(2421),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2430),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2430),
    [anon_sym_readonly] = ACTIONS(2430),
    [anon_sym_get] = ACTIONS(2430),
    [anon_sym_set] = ACTIONS(2430),
    [anon_sym_declare] = ACTIONS(2430),
    [anon_sym_public] = ACTIONS(2430),
    [anon_sym_private] = ACTIONS(2430),
    [anon_sym_protected] = ACTIONS(2430),
    [anon_sym_override] = ACTIONS(2430),
    [anon_sym_module] = ACTIONS(2430),
    [anon_sym_any] = ACTIONS(2430),
    [anon_sym_number] = ACTIONS(2430),
    [anon_sym_boolean] = ACTIONS(2430),
    [anon_sym_string] = ACTIONS(2430),
    [anon_sym_symbol] = ACTIONS(2430),
    [anon_sym_object] = ACTIONS(2430),
    [anon_sym_property] = ACTIONS(2430),
    [anon_sym_signal] = ACTIONS(2430),
    [anon_sym_on] = ACTIONS(2430),
    [anon_sym_required] = ACTIONS(2430),
    [anon_sym_component] = ACTIONS(2430),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [746] = {
    [sym__call_signature] = STATE(5981),
    [sym_comment] = STATE(746),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_identifier] = ACTIONS(2428),
    [anon_sym_export] = ACTIONS(2430),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2430),
    [anon_sym_EQ] = ACTIONS(1119),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2430),
    [anon_sym_from] = ACTIONS(2430),
    [anon_sym_let] = ACTIONS(2430),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2430),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_async] = ACTIONS(2430),
    [anon_sym_function] = ACTIONS(2421),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2430),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2430),
    [anon_sym_readonly] = ACTIONS(2430),
    [anon_sym_get] = ACTIONS(2430),
    [anon_sym_set] = ACTIONS(2430),
    [anon_sym_declare] = ACTIONS(2430),
    [anon_sym_public] = ACTIONS(2430),
    [anon_sym_private] = ACTIONS(2430),
    [anon_sym_protected] = ACTIONS(2430),
    [anon_sym_override] = ACTIONS(2430),
    [anon_sym_module] = ACTIONS(2430),
    [anon_sym_any] = ACTIONS(2430),
    [anon_sym_number] = ACTIONS(2430),
    [anon_sym_boolean] = ACTIONS(2430),
    [anon_sym_string] = ACTIONS(2430),
    [anon_sym_symbol] = ACTIONS(2430),
    [anon_sym_object] = ACTIONS(2430),
    [anon_sym_property] = ACTIONS(2430),
    [anon_sym_signal] = ACTIONS(2430),
    [anon_sym_on] = ACTIONS(2430),
    [anon_sym_required] = ACTIONS(2430),
    [anon_sym_component] = ACTIONS(2430),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [747] = {
    [sym__call_signature] = STATE(5981),
    [sym_comment] = STATE(747),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_identifier] = ACTIONS(2428),
    [anon_sym_export] = ACTIONS(2430),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2430),
    [anon_sym_EQ] = ACTIONS(1123),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2430),
    [anon_sym_from] = ACTIONS(2430),
    [anon_sym_let] = ACTIONS(2430),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2430),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_async] = ACTIONS(2430),
    [anon_sym_function] = ACTIONS(2421),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2430),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2430),
    [anon_sym_readonly] = ACTIONS(2430),
    [anon_sym_get] = ACTIONS(2430),
    [anon_sym_set] = ACTIONS(2430),
    [anon_sym_declare] = ACTIONS(2430),
    [anon_sym_public] = ACTIONS(2430),
    [anon_sym_private] = ACTIONS(2430),
    [anon_sym_protected] = ACTIONS(2430),
    [anon_sym_override] = ACTIONS(2430),
    [anon_sym_module] = ACTIONS(2430),
    [anon_sym_any] = ACTIONS(2430),
    [anon_sym_number] = ACTIONS(2430),
    [anon_sym_boolean] = ACTIONS(2430),
    [anon_sym_string] = ACTIONS(2430),
    [anon_sym_symbol] = ACTIONS(2430),
    [anon_sym_object] = ACTIONS(2430),
    [anon_sym_property] = ACTIONS(2430),
    [anon_sym_signal] = ACTIONS(2430),
    [anon_sym_on] = ACTIONS(2430),
    [anon_sym_required] = ACTIONS(2430),
    [anon_sym_component] = ACTIONS(2430),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [748] = {
    [sym_comment] = STATE(748),
    [sym_identifier] = ACTIONS(1854),
    [anon_sym_export] = ACTIONS(1854),
    [anon_sym_default] = ACTIONS(1854),
    [anon_sym_type] = ACTIONS(1854),
    [anon_sym_namespace] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [anon_sym_RBRACE] = ACTIONS(1856),
    [anon_sym_typeof] = ACTIONS(1854),
    [anon_sym_import] = ACTIONS(1854),
    [anon_sym_from] = ACTIONS(1854),
    [anon_sym_with] = ACTIONS(1854),
    [anon_sym_var] = ACTIONS(1854),
    [anon_sym_let] = ACTIONS(1854),
    [anon_sym_const] = ACTIONS(1854),
    [anon_sym_BANG] = ACTIONS(1856),
    [anon_sym_else] = ACTIONS(1854),
    [anon_sym_if] = ACTIONS(1854),
    [anon_sym_switch] = ACTIONS(1854),
    [anon_sym_for] = ACTIONS(1854),
    [anon_sym_LPAREN] = ACTIONS(1856),
    [anon_sym_await] = ACTIONS(1854),
    [anon_sym_of] = ACTIONS(1854),
    [anon_sym_while] = ACTIONS(1854),
    [anon_sym_do] = ACTIONS(1854),
    [anon_sym_try] = ACTIONS(1854),
    [anon_sym_break] = ACTIONS(1854),
    [anon_sym_continue] = ACTIONS(1854),
    [anon_sym_debugger] = ACTIONS(1854),
    [anon_sym_return] = ACTIONS(1854),
    [anon_sym_throw] = ACTIONS(1854),
    [anon_sym_SEMI] = ACTIONS(1856),
    [anon_sym_case] = ACTIONS(1854),
    [anon_sym_catch] = ACTIONS(1854),
    [anon_sym_finally] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1854),
    [anon_sym_LBRACK] = ACTIONS(1856),
    [anon_sym_LTtemplate_GT] = ACTIONS(1856),
    [anon_sym_DQUOTE] = ACTIONS(1856),
    [anon_sym_SQUOTE] = ACTIONS(1856),
    [anon_sym_class] = ACTIONS(1854),
    [anon_sym_async] = ACTIONS(1854),
    [anon_sym_function] = ACTIONS(1854),
    [anon_sym_new] = ACTIONS(1854),
    [anon_sym_using] = ACTIONS(1854),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_DASH] = ACTIONS(1854),
    [anon_sym_SLASH] = ACTIONS(1854),
    [anon_sym_LT] = ACTIONS(1854),
    [anon_sym_TILDE] = ACTIONS(1856),
    [anon_sym_void] = ACTIONS(1854),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_PLUS_PLUS] = ACTIONS(1856),
    [anon_sym_DASH_DASH] = ACTIONS(1856),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1856),
    [sym_number] = ACTIONS(1856),
    [sym_private_property_identifier] = ACTIONS(1856),
    [sym_this] = ACTIONS(1854),
    [sym_super] = ACTIONS(1854),
    [sym_true] = ACTIONS(1854),
    [sym_false] = ACTIONS(1854),
    [sym_null] = ACTIONS(1854),
    [sym_undefined] = ACTIONS(1854),
    [anon_sym_AT] = ACTIONS(1856),
    [anon_sym_static] = ACTIONS(1854),
    [anon_sym_readonly] = ACTIONS(1854),
    [anon_sym_get] = ACTIONS(1854),
    [anon_sym_set] = ACTIONS(1854),
    [anon_sym_declare] = ACTIONS(1854),
    [anon_sym_public] = ACTIONS(1854),
    [anon_sym_private] = ACTIONS(1854),
    [anon_sym_protected] = ACTIONS(1854),
    [anon_sym_override] = ACTIONS(1854),
    [anon_sym_module] = ACTIONS(1854),
    [anon_sym_any] = ACTIONS(1854),
    [anon_sym_number] = ACTIONS(1854),
    [anon_sym_boolean] = ACTIONS(1854),
    [anon_sym_string] = ACTIONS(1854),
    [anon_sym_symbol] = ACTIONS(1854),
    [anon_sym_object] = ACTIONS(1854),
    [anon_sym_property] = ACTIONS(1854),
    [anon_sym_signal] = ACTIONS(1854),
    [anon_sym_on] = ACTIONS(1854),
    [anon_sym_required] = ACTIONS(1854),
    [anon_sym_component] = ACTIONS(1854),
    [anon_sym_abstract] = ACTIONS(1854),
    [anon_sym_interface] = ACTIONS(1854),
    [anon_sym_enum] = ACTIONS(1854),
    [sym_html_comment] = ACTIONS(5),
  },
  [749] = {
    [sym_finally_clause] = STATE(808),
    [sym_comment] = STATE(749),
    [sym_identifier] = ACTIONS(2581),
    [anon_sym_export] = ACTIONS(2581),
    [anon_sym_default] = ACTIONS(2581),
    [anon_sym_type] = ACTIONS(2581),
    [anon_sym_namespace] = ACTIONS(2581),
    [anon_sym_LBRACE] = ACTIONS(2583),
    [anon_sym_RBRACE] = ACTIONS(2583),
    [anon_sym_typeof] = ACTIONS(2581),
    [anon_sym_import] = ACTIONS(2581),
    [anon_sym_from] = ACTIONS(2581),
    [anon_sym_with] = ACTIONS(2581),
    [anon_sym_var] = ACTIONS(2581),
    [anon_sym_let] = ACTIONS(2581),
    [anon_sym_const] = ACTIONS(2581),
    [anon_sym_BANG] = ACTIONS(2583),
    [anon_sym_else] = ACTIONS(2581),
    [anon_sym_if] = ACTIONS(2581),
    [anon_sym_switch] = ACTIONS(2581),
    [anon_sym_for] = ACTIONS(2581),
    [anon_sym_LPAREN] = ACTIONS(2583),
    [anon_sym_await] = ACTIONS(2581),
    [anon_sym_of] = ACTIONS(2581),
    [anon_sym_while] = ACTIONS(2581),
    [anon_sym_do] = ACTIONS(2581),
    [anon_sym_try] = ACTIONS(2581),
    [anon_sym_break] = ACTIONS(2581),
    [anon_sym_continue] = ACTIONS(2581),
    [anon_sym_debugger] = ACTIONS(2581),
    [anon_sym_return] = ACTIONS(2581),
    [anon_sym_throw] = ACTIONS(2581),
    [anon_sym_SEMI] = ACTIONS(2583),
    [anon_sym_case] = ACTIONS(2581),
    [anon_sym_finally] = ACTIONS(2536),
    [anon_sym_yield] = ACTIONS(2581),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_LTtemplate_GT] = ACTIONS(2583),
    [anon_sym_DQUOTE] = ACTIONS(2583),
    [anon_sym_SQUOTE] = ACTIONS(2583),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_async] = ACTIONS(2581),
    [anon_sym_function] = ACTIONS(2581),
    [anon_sym_new] = ACTIONS(2581),
    [anon_sym_using] = ACTIONS(2581),
    [anon_sym_PLUS] = ACTIONS(2581),
    [anon_sym_DASH] = ACTIONS(2581),
    [anon_sym_SLASH] = ACTIONS(2581),
    [anon_sym_LT] = ACTIONS(2581),
    [anon_sym_TILDE] = ACTIONS(2583),
    [anon_sym_void] = ACTIONS(2581),
    [anon_sym_delete] = ACTIONS(2581),
    [anon_sym_PLUS_PLUS] = ACTIONS(2583),
    [anon_sym_DASH_DASH] = ACTIONS(2583),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2583),
    [sym_number] = ACTIONS(2583),
    [sym_private_property_identifier] = ACTIONS(2583),
    [sym_this] = ACTIONS(2581),
    [sym_super] = ACTIONS(2581),
    [sym_true] = ACTIONS(2581),
    [sym_false] = ACTIONS(2581),
    [sym_null] = ACTIONS(2581),
    [sym_undefined] = ACTIONS(2581),
    [anon_sym_AT] = ACTIONS(2583),
    [anon_sym_static] = ACTIONS(2581),
    [anon_sym_readonly] = ACTIONS(2581),
    [anon_sym_get] = ACTIONS(2581),
    [anon_sym_set] = ACTIONS(2581),
    [anon_sym_declare] = ACTIONS(2581),
    [anon_sym_public] = ACTIONS(2581),
    [anon_sym_private] = ACTIONS(2581),
    [anon_sym_protected] = ACTIONS(2581),
    [anon_sym_override] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2581),
    [anon_sym_any] = ACTIONS(2581),
    [anon_sym_number] = ACTIONS(2581),
    [anon_sym_boolean] = ACTIONS(2581),
    [anon_sym_string] = ACTIONS(2581),
    [anon_sym_symbol] = ACTIONS(2581),
    [anon_sym_object] = ACTIONS(2581),
    [anon_sym_property] = ACTIONS(2581),
    [anon_sym_signal] = ACTIONS(2581),
    [anon_sym_on] = ACTIONS(2581),
    [anon_sym_required] = ACTIONS(2581),
    [anon_sym_component] = ACTIONS(2581),
    [anon_sym_abstract] = ACTIONS(2581),
    [anon_sym_interface] = ACTIONS(2581),
    [anon_sym_enum] = ACTIONS(2581),
    [sym_html_comment] = ACTIONS(5),
  },
  [750] = {
    [sym__call_signature] = STATE(5981),
    [sym_comment] = STATE(750),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_identifier] = ACTIONS(2428),
    [anon_sym_export] = ACTIONS(2430),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2430),
    [anon_sym_EQ] = ACTIONS(1121),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2430),
    [anon_sym_from] = ACTIONS(2430),
    [anon_sym_let] = ACTIONS(2430),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2430),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_async] = ACTIONS(2430),
    [anon_sym_function] = ACTIONS(2421),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2430),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2430),
    [anon_sym_readonly] = ACTIONS(2430),
    [anon_sym_get] = ACTIONS(2430),
    [anon_sym_set] = ACTIONS(2430),
    [anon_sym_declare] = ACTIONS(2430),
    [anon_sym_public] = ACTIONS(2430),
    [anon_sym_private] = ACTIONS(2430),
    [anon_sym_protected] = ACTIONS(2430),
    [anon_sym_override] = ACTIONS(2430),
    [anon_sym_module] = ACTIONS(2430),
    [anon_sym_any] = ACTIONS(2430),
    [anon_sym_number] = ACTIONS(2430),
    [anon_sym_boolean] = ACTIONS(2430),
    [anon_sym_string] = ACTIONS(2430),
    [anon_sym_symbol] = ACTIONS(2430),
    [anon_sym_object] = ACTIONS(2430),
    [anon_sym_property] = ACTIONS(2430),
    [anon_sym_signal] = ACTIONS(2430),
    [anon_sym_on] = ACTIONS(2430),
    [anon_sym_required] = ACTIONS(2430),
    [anon_sym_component] = ACTIONS(2430),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [751] = {
    [sym__call_signature] = STATE(5981),
    [sym_comment] = STATE(751),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_identifier] = ACTIONS(2428),
    [anon_sym_export] = ACTIONS(2430),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2430),
    [anon_sym_EQ] = ACTIONS(1113),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2430),
    [anon_sym_from] = ACTIONS(2430),
    [anon_sym_let] = ACTIONS(2430),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2430),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_async] = ACTIONS(2430),
    [anon_sym_function] = ACTIONS(2421),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2430),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2430),
    [anon_sym_readonly] = ACTIONS(2430),
    [anon_sym_get] = ACTIONS(2430),
    [anon_sym_set] = ACTIONS(2430),
    [anon_sym_declare] = ACTIONS(2430),
    [anon_sym_public] = ACTIONS(2430),
    [anon_sym_private] = ACTIONS(2430),
    [anon_sym_protected] = ACTIONS(2430),
    [anon_sym_override] = ACTIONS(2430),
    [anon_sym_module] = ACTIONS(2430),
    [anon_sym_any] = ACTIONS(2430),
    [anon_sym_number] = ACTIONS(2430),
    [anon_sym_boolean] = ACTIONS(2430),
    [anon_sym_string] = ACTIONS(2430),
    [anon_sym_symbol] = ACTIONS(2430),
    [anon_sym_object] = ACTIONS(2430),
    [anon_sym_property] = ACTIONS(2430),
    [anon_sym_signal] = ACTIONS(2430),
    [anon_sym_on] = ACTIONS(2430),
    [anon_sym_required] = ACTIONS(2430),
    [anon_sym_component] = ACTIONS(2430),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [752] = {
    [sym_statement_block] = STATE(801),
    [sym_comment] = STATE(752),
    [sym_identifier] = ACTIONS(1818),
    [anon_sym_export] = ACTIONS(1818),
    [anon_sym_default] = ACTIONS(1818),
    [anon_sym_type] = ACTIONS(1818),
    [anon_sym_namespace] = ACTIONS(1818),
    [anon_sym_LBRACE] = ACTIONS(2585),
    [anon_sym_RBRACE] = ACTIONS(1822),
    [anon_sym_typeof] = ACTIONS(1818),
    [anon_sym_import] = ACTIONS(1818),
    [anon_sym_from] = ACTIONS(1818),
    [anon_sym_with] = ACTIONS(1818),
    [anon_sym_var] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(1818),
    [anon_sym_const] = ACTIONS(1818),
    [anon_sym_BANG] = ACTIONS(1822),
    [anon_sym_else] = ACTIONS(1818),
    [anon_sym_if] = ACTIONS(1818),
    [anon_sym_switch] = ACTIONS(1818),
    [anon_sym_for] = ACTIONS(1818),
    [anon_sym_LPAREN] = ACTIONS(1822),
    [anon_sym_await] = ACTIONS(1818),
    [anon_sym_of] = ACTIONS(1818),
    [anon_sym_while] = ACTIONS(1818),
    [anon_sym_do] = ACTIONS(1818),
    [anon_sym_try] = ACTIONS(1818),
    [anon_sym_break] = ACTIONS(1818),
    [anon_sym_continue] = ACTIONS(1818),
    [anon_sym_debugger] = ACTIONS(1818),
    [anon_sym_return] = ACTIONS(1818),
    [anon_sym_throw] = ACTIONS(1818),
    [anon_sym_SEMI] = ACTIONS(1822),
    [anon_sym_case] = ACTIONS(1818),
    [anon_sym_yield] = ACTIONS(1818),
    [anon_sym_LBRACK] = ACTIONS(1822),
    [anon_sym_LTtemplate_GT] = ACTIONS(1822),
    [anon_sym_DOT] = ACTIONS(2587),
    [anon_sym_DQUOTE] = ACTIONS(1822),
    [anon_sym_SQUOTE] = ACTIONS(1822),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_async] = ACTIONS(1818),
    [anon_sym_function] = ACTIONS(1818),
    [anon_sym_new] = ACTIONS(1818),
    [anon_sym_using] = ACTIONS(1818),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_DASH] = ACTIONS(1818),
    [anon_sym_SLASH] = ACTIONS(1818),
    [anon_sym_LT] = ACTIONS(1818),
    [anon_sym_TILDE] = ACTIONS(1822),
    [anon_sym_void] = ACTIONS(1818),
    [anon_sym_delete] = ACTIONS(1818),
    [anon_sym_PLUS_PLUS] = ACTIONS(1822),
    [anon_sym_DASH_DASH] = ACTIONS(1822),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1822),
    [sym_number] = ACTIONS(1822),
    [sym_private_property_identifier] = ACTIONS(1822),
    [sym_this] = ACTIONS(1818),
    [sym_super] = ACTIONS(1818),
    [sym_true] = ACTIONS(1818),
    [sym_false] = ACTIONS(1818),
    [sym_null] = ACTIONS(1818),
    [sym_undefined] = ACTIONS(1818),
    [anon_sym_AT] = ACTIONS(1822),
    [anon_sym_static] = ACTIONS(1818),
    [anon_sym_readonly] = ACTIONS(1818),
    [anon_sym_get] = ACTIONS(1818),
    [anon_sym_set] = ACTIONS(1818),
    [anon_sym_declare] = ACTIONS(1818),
    [anon_sym_public] = ACTIONS(1818),
    [anon_sym_private] = ACTIONS(1818),
    [anon_sym_protected] = ACTIONS(1818),
    [anon_sym_override] = ACTIONS(1818),
    [anon_sym_module] = ACTIONS(1818),
    [anon_sym_any] = ACTIONS(1818),
    [anon_sym_number] = ACTIONS(1818),
    [anon_sym_boolean] = ACTIONS(1818),
    [anon_sym_string] = ACTIONS(1818),
    [anon_sym_symbol] = ACTIONS(1818),
    [anon_sym_object] = ACTIONS(1818),
    [anon_sym_property] = ACTIONS(1818),
    [anon_sym_signal] = ACTIONS(1818),
    [anon_sym_on] = ACTIONS(1818),
    [anon_sym_required] = ACTIONS(1818),
    [anon_sym_component] = ACTIONS(1818),
    [anon_sym_abstract] = ACTIONS(1818),
    [anon_sym_interface] = ACTIONS(1818),
    [anon_sym_enum] = ACTIONS(1818),
    [sym_html_comment] = ACTIONS(5),
  },
  [753] = {
    [sym_comment] = STATE(753),
    [sym_identifier] = ACTIONS(1902),
    [anon_sym_export] = ACTIONS(1902),
    [anon_sym_default] = ACTIONS(1902),
    [anon_sym_type] = ACTIONS(1902),
    [anon_sym_namespace] = ACTIONS(1902),
    [anon_sym_LBRACE] = ACTIONS(1904),
    [anon_sym_RBRACE] = ACTIONS(1904),
    [anon_sym_typeof] = ACTIONS(1902),
    [anon_sym_import] = ACTIONS(1902),
    [anon_sym_from] = ACTIONS(1902),
    [anon_sym_with] = ACTIONS(1902),
    [anon_sym_var] = ACTIONS(1902),
    [anon_sym_let] = ACTIONS(1902),
    [anon_sym_const] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_else] = ACTIONS(1902),
    [anon_sym_if] = ACTIONS(1902),
    [anon_sym_switch] = ACTIONS(1902),
    [anon_sym_for] = ACTIONS(1902),
    [anon_sym_LPAREN] = ACTIONS(1904),
    [anon_sym_await] = ACTIONS(1902),
    [anon_sym_of] = ACTIONS(1902),
    [anon_sym_while] = ACTIONS(1902),
    [anon_sym_do] = ACTIONS(1902),
    [anon_sym_try] = ACTIONS(1902),
    [anon_sym_break] = ACTIONS(1902),
    [anon_sym_continue] = ACTIONS(1902),
    [anon_sym_debugger] = ACTIONS(1902),
    [anon_sym_return] = ACTIONS(1902),
    [anon_sym_throw] = ACTIONS(1902),
    [anon_sym_SEMI] = ACTIONS(1904),
    [anon_sym_case] = ACTIONS(1902),
    [anon_sym_catch] = ACTIONS(1902),
    [anon_sym_finally] = ACTIONS(1902),
    [anon_sym_yield] = ACTIONS(1902),
    [anon_sym_LBRACK] = ACTIONS(1904),
    [anon_sym_LTtemplate_GT] = ACTIONS(1904),
    [anon_sym_DQUOTE] = ACTIONS(1904),
    [anon_sym_SQUOTE] = ACTIONS(1904),
    [anon_sym_class] = ACTIONS(1902),
    [anon_sym_async] = ACTIONS(1902),
    [anon_sym_function] = ACTIONS(1902),
    [anon_sym_new] = ACTIONS(1902),
    [anon_sym_using] = ACTIONS(1902),
    [anon_sym_PLUS] = ACTIONS(1902),
    [anon_sym_DASH] = ACTIONS(1902),
    [anon_sym_SLASH] = ACTIONS(1902),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_TILDE] = ACTIONS(1904),
    [anon_sym_void] = ACTIONS(1902),
    [anon_sym_delete] = ACTIONS(1902),
    [anon_sym_PLUS_PLUS] = ACTIONS(1904),
    [anon_sym_DASH_DASH] = ACTIONS(1904),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1904),
    [sym_private_property_identifier] = ACTIONS(1904),
    [sym_this] = ACTIONS(1902),
    [sym_super] = ACTIONS(1902),
    [sym_true] = ACTIONS(1902),
    [sym_false] = ACTIONS(1902),
    [sym_null] = ACTIONS(1902),
    [sym_undefined] = ACTIONS(1902),
    [anon_sym_AT] = ACTIONS(1904),
    [anon_sym_static] = ACTIONS(1902),
    [anon_sym_readonly] = ACTIONS(1902),
    [anon_sym_get] = ACTIONS(1902),
    [anon_sym_set] = ACTIONS(1902),
    [anon_sym_declare] = ACTIONS(1902),
    [anon_sym_public] = ACTIONS(1902),
    [anon_sym_private] = ACTIONS(1902),
    [anon_sym_protected] = ACTIONS(1902),
    [anon_sym_override] = ACTIONS(1902),
    [anon_sym_module] = ACTIONS(1902),
    [anon_sym_any] = ACTIONS(1902),
    [anon_sym_number] = ACTIONS(1902),
    [anon_sym_boolean] = ACTIONS(1902),
    [anon_sym_string] = ACTIONS(1902),
    [anon_sym_symbol] = ACTIONS(1902),
    [anon_sym_object] = ACTIONS(1902),
    [anon_sym_property] = ACTIONS(1902),
    [anon_sym_signal] = ACTIONS(1902),
    [anon_sym_on] = ACTIONS(1902),
    [anon_sym_required] = ACTIONS(1902),
    [anon_sym_component] = ACTIONS(1902),
    [anon_sym_abstract] = ACTIONS(1902),
    [anon_sym_interface] = ACTIONS(1902),
    [anon_sym_enum] = ACTIONS(1902),
    [sym_html_comment] = ACTIONS(5),
  },
  [754] = {
    [sym__call_signature] = STATE(5981),
    [sym_comment] = STATE(754),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_identifier] = ACTIONS(2428),
    [anon_sym_export] = ACTIONS(2430),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2430),
    [anon_sym_EQ] = ACTIONS(1127),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2430),
    [anon_sym_from] = ACTIONS(2430),
    [anon_sym_let] = ACTIONS(2430),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2430),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_async] = ACTIONS(2430),
    [anon_sym_function] = ACTIONS(2421),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2430),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2430),
    [anon_sym_readonly] = ACTIONS(2430),
    [anon_sym_get] = ACTIONS(2430),
    [anon_sym_set] = ACTIONS(2430),
    [anon_sym_declare] = ACTIONS(2430),
    [anon_sym_public] = ACTIONS(2430),
    [anon_sym_private] = ACTIONS(2430),
    [anon_sym_protected] = ACTIONS(2430),
    [anon_sym_override] = ACTIONS(2430),
    [anon_sym_module] = ACTIONS(2430),
    [anon_sym_any] = ACTIONS(2430),
    [anon_sym_number] = ACTIONS(2430),
    [anon_sym_boolean] = ACTIONS(2430),
    [anon_sym_string] = ACTIONS(2430),
    [anon_sym_symbol] = ACTIONS(2430),
    [anon_sym_object] = ACTIONS(2430),
    [anon_sym_property] = ACTIONS(2430),
    [anon_sym_signal] = ACTIONS(2430),
    [anon_sym_on] = ACTIONS(2430),
    [anon_sym_required] = ACTIONS(2430),
    [anon_sym_component] = ACTIONS(2430),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [755] = {
    [sym_statement_block] = STATE(801),
    [sym_comment] = STATE(755),
    [sym_identifier] = ACTIONS(1818),
    [anon_sym_export] = ACTIONS(1818),
    [anon_sym_default] = ACTIONS(1818),
    [anon_sym_type] = ACTIONS(1818),
    [anon_sym_namespace] = ACTIONS(1818),
    [anon_sym_LBRACE] = ACTIONS(2585),
    [anon_sym_RBRACE] = ACTIONS(1822),
    [anon_sym_typeof] = ACTIONS(1818),
    [anon_sym_import] = ACTIONS(1818),
    [anon_sym_from] = ACTIONS(1818),
    [anon_sym_with] = ACTIONS(1818),
    [anon_sym_var] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(1818),
    [anon_sym_const] = ACTIONS(1818),
    [anon_sym_BANG] = ACTIONS(1822),
    [anon_sym_else] = ACTIONS(1818),
    [anon_sym_if] = ACTIONS(1818),
    [anon_sym_switch] = ACTIONS(1818),
    [anon_sym_for] = ACTIONS(1818),
    [anon_sym_LPAREN] = ACTIONS(1822),
    [anon_sym_await] = ACTIONS(1818),
    [anon_sym_of] = ACTIONS(1818),
    [anon_sym_while] = ACTIONS(1818),
    [anon_sym_do] = ACTIONS(1818),
    [anon_sym_try] = ACTIONS(1818),
    [anon_sym_break] = ACTIONS(1818),
    [anon_sym_continue] = ACTIONS(1818),
    [anon_sym_debugger] = ACTIONS(1818),
    [anon_sym_return] = ACTIONS(1818),
    [anon_sym_throw] = ACTIONS(1818),
    [anon_sym_SEMI] = ACTIONS(1822),
    [anon_sym_case] = ACTIONS(1818),
    [anon_sym_yield] = ACTIONS(1818),
    [anon_sym_LBRACK] = ACTIONS(1822),
    [anon_sym_LTtemplate_GT] = ACTIONS(1822),
    [anon_sym_DOT] = ACTIONS(2589),
    [anon_sym_DQUOTE] = ACTIONS(1822),
    [anon_sym_SQUOTE] = ACTIONS(1822),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_async] = ACTIONS(1818),
    [anon_sym_function] = ACTIONS(1818),
    [anon_sym_new] = ACTIONS(1818),
    [anon_sym_using] = ACTIONS(1818),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_DASH] = ACTIONS(1818),
    [anon_sym_SLASH] = ACTIONS(1818),
    [anon_sym_LT] = ACTIONS(1818),
    [anon_sym_TILDE] = ACTIONS(1822),
    [anon_sym_void] = ACTIONS(1818),
    [anon_sym_delete] = ACTIONS(1818),
    [anon_sym_PLUS_PLUS] = ACTIONS(1822),
    [anon_sym_DASH_DASH] = ACTIONS(1822),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1822),
    [sym_number] = ACTIONS(1822),
    [sym_private_property_identifier] = ACTIONS(1822),
    [sym_this] = ACTIONS(1818),
    [sym_super] = ACTIONS(1818),
    [sym_true] = ACTIONS(1818),
    [sym_false] = ACTIONS(1818),
    [sym_null] = ACTIONS(1818),
    [sym_undefined] = ACTIONS(1818),
    [anon_sym_AT] = ACTIONS(1822),
    [anon_sym_static] = ACTIONS(1818),
    [anon_sym_readonly] = ACTIONS(1818),
    [anon_sym_get] = ACTIONS(1818),
    [anon_sym_set] = ACTIONS(1818),
    [anon_sym_declare] = ACTIONS(1818),
    [anon_sym_public] = ACTIONS(1818),
    [anon_sym_private] = ACTIONS(1818),
    [anon_sym_protected] = ACTIONS(1818),
    [anon_sym_override] = ACTIONS(1818),
    [anon_sym_module] = ACTIONS(1818),
    [anon_sym_any] = ACTIONS(1818),
    [anon_sym_number] = ACTIONS(1818),
    [anon_sym_boolean] = ACTIONS(1818),
    [anon_sym_string] = ACTIONS(1818),
    [anon_sym_symbol] = ACTIONS(1818),
    [anon_sym_object] = ACTIONS(1818),
    [anon_sym_property] = ACTIONS(1818),
    [anon_sym_signal] = ACTIONS(1818),
    [anon_sym_on] = ACTIONS(1818),
    [anon_sym_required] = ACTIONS(1818),
    [anon_sym_component] = ACTIONS(1818),
    [anon_sym_abstract] = ACTIONS(1818),
    [anon_sym_interface] = ACTIONS(1818),
    [anon_sym_enum] = ACTIONS(1818),
    [sym_html_comment] = ACTIONS(5),
  },
  [756] = {
    [sym__call_signature] = STATE(5981),
    [sym_comment] = STATE(756),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_identifier] = ACTIONS(2428),
    [anon_sym_export] = ACTIONS(2430),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2430),
    [anon_sym_EQ] = ACTIONS(1059),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2430),
    [anon_sym_from] = ACTIONS(2430),
    [anon_sym_let] = ACTIONS(2430),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2430),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_async] = ACTIONS(2430),
    [anon_sym_function] = ACTIONS(2421),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2430),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2430),
    [anon_sym_readonly] = ACTIONS(2430),
    [anon_sym_get] = ACTIONS(2430),
    [anon_sym_set] = ACTIONS(2430),
    [anon_sym_declare] = ACTIONS(2430),
    [anon_sym_public] = ACTIONS(2430),
    [anon_sym_private] = ACTIONS(2430),
    [anon_sym_protected] = ACTIONS(2430),
    [anon_sym_override] = ACTIONS(2430),
    [anon_sym_module] = ACTIONS(2430),
    [anon_sym_any] = ACTIONS(2430),
    [anon_sym_number] = ACTIONS(2430),
    [anon_sym_boolean] = ACTIONS(2430),
    [anon_sym_string] = ACTIONS(2430),
    [anon_sym_symbol] = ACTIONS(2430),
    [anon_sym_object] = ACTIONS(2430),
    [anon_sym_property] = ACTIONS(2430),
    [anon_sym_signal] = ACTIONS(2430),
    [anon_sym_on] = ACTIONS(2430),
    [anon_sym_required] = ACTIONS(2430),
    [anon_sym_component] = ACTIONS(2430),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [757] = {
    [sym__call_signature] = STATE(5981),
    [sym_comment] = STATE(757),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_identifier] = ACTIONS(2428),
    [anon_sym_export] = ACTIONS(2430),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2430),
    [anon_sym_EQ] = ACTIONS(863),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2430),
    [anon_sym_from] = ACTIONS(2430),
    [anon_sym_let] = ACTIONS(2430),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(2430),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_async] = ACTIONS(2430),
    [anon_sym_function] = ACTIONS(2421),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2430),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2430),
    [anon_sym_readonly] = ACTIONS(2430),
    [anon_sym_get] = ACTIONS(2430),
    [anon_sym_set] = ACTIONS(2430),
    [anon_sym_declare] = ACTIONS(2430),
    [anon_sym_public] = ACTIONS(2430),
    [anon_sym_private] = ACTIONS(2430),
    [anon_sym_protected] = ACTIONS(2430),
    [anon_sym_override] = ACTIONS(2430),
    [anon_sym_module] = ACTIONS(2430),
    [anon_sym_any] = ACTIONS(2430),
    [anon_sym_number] = ACTIONS(2430),
    [anon_sym_boolean] = ACTIONS(2430),
    [anon_sym_string] = ACTIONS(2430),
    [anon_sym_symbol] = ACTIONS(2430),
    [anon_sym_object] = ACTIONS(2430),
    [anon_sym_property] = ACTIONS(2430),
    [anon_sym_signal] = ACTIONS(2430),
    [anon_sym_on] = ACTIONS(2430),
    [anon_sym_required] = ACTIONS(2430),
    [anon_sym_component] = ACTIONS(2430),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [758] = {
    [sym__call_signature] = STATE(5981),
    [sym_comment] = STATE(758),
    [sym_formal_parameters] = STATE(4046),
    [sym_type_parameters] = STATE(5534),
    [sym_identifier] = ACTIONS(2428),
    [anon_sym_export] = ACTIONS(2430),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_type] = ACTIONS(2430),
    [anon_sym_EQ] = ACTIONS(863),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_namespace] = ACTIONS(2430),
    [anon_sym_from] = ACTIONS(2430),
    [anon_sym_let] = ACTIONS(2430),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(984),
    [anon_sym_of] = ACTIONS(2591),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_async] = ACTIONS(2430),
    [anon_sym_function] = ACTIONS(2421),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_new] = ACTIONS(2430),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_static] = ACTIONS(2430),
    [anon_sym_readonly] = ACTIONS(2430),
    [anon_sym_get] = ACTIONS(2430),
    [anon_sym_set] = ACTIONS(2430),
    [anon_sym_declare] = ACTIONS(2430),
    [anon_sym_public] = ACTIONS(2430),
    [anon_sym_private] = ACTIONS(2430),
    [anon_sym_protected] = ACTIONS(2430),
    [anon_sym_override] = ACTIONS(2430),
    [anon_sym_module] = ACTIONS(2430),
    [anon_sym_any] = ACTIONS(2430),
    [anon_sym_number] = ACTIONS(2430),
    [anon_sym_boolean] = ACTIONS(2430),
    [anon_sym_string] = ACTIONS(2430),
    [anon_sym_symbol] = ACTIONS(2430),
    [anon_sym_object] = ACTIONS(2430),
    [anon_sym_property] = ACTIONS(2430),
    [anon_sym_signal] = ACTIONS(2430),
    [anon_sym_on] = ACTIONS(2430),
    [anon_sym_required] = ACTIONS(2430),
    [anon_sym_component] = ACTIONS(2430),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [759] = {
    [sym_comment] = STATE(759),
    [sym_identifier] = ACTIONS(1828),
    [anon_sym_export] = ACTIONS(1828),
    [anon_sym_default] = ACTIONS(1828),
    [anon_sym_type] = ACTIONS(1828),
    [anon_sym_namespace] = ACTIONS(1828),
    [anon_sym_LBRACE] = ACTIONS(1832),
    [anon_sym_RBRACE] = ACTIONS(1832),
    [anon_sym_typeof] = ACTIONS(1828),
    [anon_sym_import] = ACTIONS(1828),
    [anon_sym_from] = ACTIONS(1828),
    [anon_sym_with] = ACTIONS(1828),
    [anon_sym_var] = ACTIONS(1828),
    [anon_sym_let] = ACTIONS(1828),
    [anon_sym_const] = ACTIONS(1828),
    [anon_sym_BANG] = ACTIONS(1832),
    [anon_sym_else] = ACTIONS(1828),
    [anon_sym_if] = ACTIONS(1828),
    [anon_sym_switch] = ACTIONS(1828),
    [anon_sym_for] = ACTIONS(1828),
    [anon_sym_LPAREN] = ACTIONS(1832),
    [anon_sym_await] = ACTIONS(1828),
    [anon_sym_of] = ACTIONS(1828),
    [anon_sym_while] = ACTIONS(1828),
    [anon_sym_do] = ACTIONS(1828),
    [anon_sym_try] = ACTIONS(1828),
    [anon_sym_break] = ACTIONS(1828),
    [anon_sym_continue] = ACTIONS(1828),
    [anon_sym_debugger] = ACTIONS(1828),
    [anon_sym_return] = ACTIONS(1828),
    [anon_sym_throw] = ACTIONS(1828),
    [anon_sym_SEMI] = ACTIONS(1832),
    [anon_sym_case] = ACTIONS(1828),
    [anon_sym_yield] = ACTIONS(1828),
    [anon_sym_LBRACK] = ACTIONS(1832),
    [anon_sym_LTtemplate_GT] = ACTIONS(1832),
    [anon_sym_DQUOTE] = ACTIONS(1832),
    [anon_sym_SQUOTE] = ACTIONS(1832),
    [anon_sym_class] = ACTIONS(1828),
    [anon_sym_async] = ACTIONS(1828),
    [anon_sym_function] = ACTIONS(1828),
    [anon_sym_new] = ACTIONS(1828),
    [anon_sym_using] = ACTIONS(1828),
    [anon_sym_PLUS] = ACTIONS(1828),
    [anon_sym_DASH] = ACTIONS(1828),
    [anon_sym_SLASH] = ACTIONS(1828),
    [anon_sym_LT] = ACTIONS(1828),
    [anon_sym_TILDE] = ACTIONS(1832),
    [anon_sym_void] = ACTIONS(1828),
    [anon_sym_delete] = ACTIONS(1828),
    [anon_sym_PLUS_PLUS] = ACTIONS(1832),
    [anon_sym_DASH_DASH] = ACTIONS(1832),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1832),
    [sym_number] = ACTIONS(1832),
    [sym_private_property_identifier] = ACTIONS(1832),
    [sym_this] = ACTIONS(1828),
    [sym_super] = ACTIONS(1828),
    [sym_true] = ACTIONS(1828),
    [sym_false] = ACTIONS(1828),
    [sym_null] = ACTIONS(1828),
    [sym_undefined] = ACTIONS(1828),
    [anon_sym_AT] = ACTIONS(1832),
    [anon_sym_static] = ACTIONS(1828),
    [anon_sym_readonly] = ACTIONS(1828),
    [anon_sym_get] = ACTIONS(1828),
    [anon_sym_set] = ACTIONS(1828),
    [anon_sym_declare] = ACTIONS(1828),
    [anon_sym_public] = ACTIONS(1828),
    [anon_sym_private] = ACTIONS(1828),
    [anon_sym_protected] = ACTIONS(1828),
    [anon_sym_override] = ACTIONS(1828),
    [anon_sym_module] = ACTIONS(1828),
    [anon_sym_any] = ACTIONS(1828),
    [anon_sym_number] = ACTIONS(1828),
    [anon_sym_boolean] = ACTIONS(1828),
    [anon_sym_string] = ACTIONS(1828),
    [anon_sym_symbol] = ACTIONS(1828),
    [anon_sym_object] = ACTIONS(1828),
    [anon_sym_property] = ACTIONS(1828),
    [anon_sym_signal] = ACTIONS(1828),
    [anon_sym_on] = ACTIONS(1828),
    [anon_sym_required] = ACTIONS(1828),
    [anon_sym_component] = ACTIONS(1828),
    [anon_sym_abstract] = ACTIONS(1828),
    [anon_sym_interface] = ACTIONS(1828),
    [anon_sym_enum] = ACTIONS(1828),
    [sym__automatic_semicolon] = ACTIONS(1836),
    [sym_html_comment] = ACTIONS(5),
  },
  [760] = {
    [sym_statement_block] = STATE(801),
    [sym_comment] = STATE(760),
    [sym_identifier] = ACTIONS(1818),
    [anon_sym_export] = ACTIONS(1818),
    [anon_sym_default] = ACTIONS(1818),
    [anon_sym_type] = ACTIONS(1818),
    [anon_sym_namespace] = ACTIONS(1818),
    [anon_sym_LBRACE] = ACTIONS(2585),
    [anon_sym_RBRACE] = ACTIONS(1822),
    [anon_sym_typeof] = ACTIONS(1818),
    [anon_sym_import] = ACTIONS(1818),
    [anon_sym_from] = ACTIONS(1818),
    [anon_sym_with] = ACTIONS(1818),
    [anon_sym_var] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(1818),
    [anon_sym_const] = ACTIONS(1818),
    [anon_sym_BANG] = ACTIONS(1822),
    [anon_sym_else] = ACTIONS(1818),
    [anon_sym_if] = ACTIONS(1818),
    [anon_sym_switch] = ACTIONS(1818),
    [anon_sym_for] = ACTIONS(1818),
    [anon_sym_LPAREN] = ACTIONS(1822),
    [anon_sym_await] = ACTIONS(1818),
    [anon_sym_of] = ACTIONS(1818),
    [anon_sym_while] = ACTIONS(1818),
    [anon_sym_do] = ACTIONS(1818),
    [anon_sym_try] = ACTIONS(1818),
    [anon_sym_break] = ACTIONS(1818),
    [anon_sym_continue] = ACTIONS(1818),
    [anon_sym_debugger] = ACTIONS(1818),
    [anon_sym_return] = ACTIONS(1818),
    [anon_sym_throw] = ACTIONS(1818),
    [anon_sym_SEMI] = ACTIONS(1822),
    [anon_sym_case] = ACTIONS(1818),
    [anon_sym_yield] = ACTIONS(1818),
    [anon_sym_LBRACK] = ACTIONS(1822),
    [anon_sym_LTtemplate_GT] = ACTIONS(1822),
    [anon_sym_DQUOTE] = ACTIONS(1822),
    [anon_sym_SQUOTE] = ACTIONS(1822),
    [anon_sym_class] = ACTIONS(1818),
    [anon_sym_async] = ACTIONS(1818),
    [anon_sym_function] = ACTIONS(1818),
    [anon_sym_new] = ACTIONS(1818),
    [anon_sym_using] = ACTIONS(1818),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_DASH] = ACTIONS(1818),
    [anon_sym_SLASH] = ACTIONS(1818),
    [anon_sym_LT] = ACTIONS(1818),
    [anon_sym_TILDE] = ACTIONS(1822),
    [anon_sym_void] = ACTIONS(1818),
    [anon_sym_delete] = ACTIONS(1818),
    [anon_sym_PLUS_PLUS] = ACTIONS(1822),
    [anon_sym_DASH_DASH] = ACTIONS(1822),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1822),
    [sym_number] = ACTIONS(1822),
    [sym_private_property_identifier] = ACTIONS(1822),
    [sym_this] = ACTIONS(1818),
    [sym_super] = ACTIONS(1818),
    [sym_true] = ACTIONS(1818),
    [sym_false] = ACTIONS(1818),
    [sym_null] = ACTIONS(1818),
    [sym_undefined] = ACTIONS(1818),
    [anon_sym_AT] = ACTIONS(1822),
    [anon_sym_static] = ACTIONS(1818),
    [anon_sym_readonly] = ACTIONS(1818),
    [anon_sym_get] = ACTIONS(1818),
    [anon_sym_set] = ACTIONS(1818),
    [anon_sym_declare] = ACTIONS(1818),
    [anon_sym_public] = ACTIONS(1818),
    [anon_sym_private] = ACTIONS(1818),
    [anon_sym_protected] = ACTIONS(1818),
    [anon_sym_override] = ACTIONS(1818),
    [anon_sym_module] = ACTIONS(1818),
    [anon_sym_any] = ACTIONS(1818),
    [anon_sym_number] = ACTIONS(1818),
    [anon_sym_boolean] = ACTIONS(1818),
    [anon_sym_string] = ACTIONS(1818),
    [anon_sym_symbol] = ACTIONS(1818),
    [anon_sym_object] = ACTIONS(1818),
    [anon_sym_property] = ACTIONS(1818),
    [anon_sym_signal] = ACTIONS(1818),
    [anon_sym_on] = ACTIONS(1818),
    [anon_sym_required] = ACTIONS(1818),
    [anon_sym_component] = ACTIONS(1818),
    [anon_sym_abstract] = ACTIONS(1818),
    [anon_sym_interface] = ACTIONS(1818),
    [anon_sym_enum] = ACTIONS(1818),
    [sym_html_comment] = ACTIONS(5),
  },
  [761] = {
    [sym_comment] = STATE(761),
    [sym_identifier] = ACTIONS(1916),
    [anon_sym_export] = ACTIONS(1916),
    [anon_sym_default] = ACTIONS(1916),
    [anon_sym_type] = ACTIONS(1916),
    [anon_sym_namespace] = ACTIONS(1916),
    [anon_sym_LBRACE] = ACTIONS(1920),
    [anon_sym_RBRACE] = ACTIONS(1920),
    [anon_sym_typeof] = ACTIONS(1916),
    [anon_sym_import] = ACTIONS(1916),
    [anon_sym_from] = ACTIONS(1916),
    [anon_sym_with] = ACTIONS(1916),
    [anon_sym_var] = ACTIONS(1916),
    [anon_sym_let] = ACTIONS(1916),
    [anon_sym_const] = ACTIONS(1916),
    [anon_sym_BANG] = ACTIONS(1920),
    [anon_sym_else] = ACTIONS(1916),
    [anon_sym_if] = ACTIONS(1916),
    [anon_sym_switch] = ACTIONS(1916),
    [anon_sym_for] = ACTIONS(1916),
    [anon_sym_LPAREN] = ACTIONS(1920),
    [anon_sym_await] = ACTIONS(1916),
    [anon_sym_of] = ACTIONS(1916),
    [anon_sym_while] = ACTIONS(1916),
    [anon_sym_do] = ACTIONS(1916),
    [anon_sym_try] = ACTIONS(1916),
    [anon_sym_break] = ACTIONS(1916),
    [anon_sym_continue] = ACTIONS(1916),
    [anon_sym_debugger] = ACTIONS(1916),
    [anon_sym_return] = ACTIONS(1916),
    [anon_sym_throw] = ACTIONS(1916),
    [anon_sym_SEMI] = ACTIONS(1920),
    [anon_sym_case] = ACTIONS(1916),
    [anon_sym_yield] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1920),
    [anon_sym_LTtemplate_GT] = ACTIONS(1920),
    [anon_sym_DQUOTE] = ACTIONS(1920),
    [anon_sym_SQUOTE] = ACTIONS(1920),
    [anon_sym_class] = ACTIONS(1916),
    [anon_sym_async] = ACTIONS(1916),
    [anon_sym_function] = ACTIONS(1916),
    [anon_sym_new] = ACTIONS(1916),
    [anon_sym_using] = ACTIONS(1916),
    [anon_sym_PLUS] = ACTIONS(1916),
    [anon_sym_DASH] = ACTIONS(1916),
    [anon_sym_SLASH] = ACTIONS(1916),
    [anon_sym_LT] = ACTIONS(1916),
    [anon_sym_TILDE] = ACTIONS(1920),
    [anon_sym_void] = ACTIONS(1916),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_PLUS_PLUS] = ACTIONS(1920),
    [anon_sym_DASH_DASH] = ACTIONS(1920),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1920),
    [sym_number] = ACTIONS(1920),
    [sym_private_property_identifier] = ACTIONS(1920),
    [sym_this] = ACTIONS(1916),
    [sym_super] = ACTIONS(1916),
    [sym_true] = ACTIONS(1916),
    [sym_false] = ACTIONS(1916),
    [sym_null] = ACTIONS(1916),
    [sym_undefined] = ACTIONS(1916),
    [anon_sym_AT] = ACTIONS(1920),
    [anon_sym_static] = ACTIONS(1916),
    [anon_sym_readonly] = ACTIONS(1916),
    [anon_sym_get] = ACTIONS(1916),
    [anon_sym_set] = ACTIONS(1916),
    [anon_sym_declare] = ACTIONS(1916),
    [anon_sym_public] = ACTIONS(1916),
    [anon_sym_private] = ACTIONS(1916),
    [anon_sym_protected] = ACTIONS(1916),
    [anon_sym_override] = ACTIONS(1916),
    [anon_sym_module] = ACTIONS(1916),
    [anon_sym_any] = ACTIONS(1916),
    [anon_sym_number] = ACTIONS(1916),
    [anon_sym_boolean] = ACTIONS(1916),
    [anon_sym_string] = ACTIONS(1916),
    [anon_sym_symbol] = ACTIONS(1916),
    [anon_sym_object] = ACTIONS(1916),
    [anon_sym_property] = ACTIONS(1916),
    [anon_sym_signal] = ACTIONS(1916),
    [anon_sym_on] = ACTIONS(1916),
    [anon_sym_required] = ACTIONS(1916),
    [anon_sym_component] = ACTIONS(1916),
    [anon_sym_abstract] = ACTIONS(1916),
    [anon_sym_interface] = ACTIONS(1916),
    [anon_sym_enum] = ACTIONS(1916),
    [sym__automatic_semicolon] = ACTIONS(1924),
    [sym_html_comment] = ACTIONS(5),
  },
  [762] = {
    [sym_comment] = STATE(762),
    [sym_identifier] = ACTIONS(2593),
    [anon_sym_export] = ACTIONS(2593),
    [anon_sym_default] = ACTIONS(2593),
    [anon_sym_type] = ACTIONS(2593),
    [anon_sym_namespace] = ACTIONS(2593),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_RBRACE] = ACTIONS(2595),
    [anon_sym_typeof] = ACTIONS(2593),
    [anon_sym_import] = ACTIONS(2593),
    [anon_sym_from] = ACTIONS(2593),
    [anon_sym_with] = ACTIONS(2593),
    [anon_sym_var] = ACTIONS(2593),
    [anon_sym_let] = ACTIONS(2593),
    [anon_sym_const] = ACTIONS(2593),
    [anon_sym_BANG] = ACTIONS(2595),
    [anon_sym_else] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2593),
    [anon_sym_switch] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2593),
    [anon_sym_LPAREN] = ACTIONS(2595),
    [anon_sym_RPAREN] = ACTIONS(2595),
    [anon_sym_await] = ACTIONS(2593),
    [anon_sym_of] = ACTIONS(2593),
    [anon_sym_while] = ACTIONS(2593),
    [anon_sym_do] = ACTIONS(2593),
    [anon_sym_try] = ACTIONS(2593),
    [anon_sym_break] = ACTIONS(2593),
    [anon_sym_continue] = ACTIONS(2593),
    [anon_sym_debugger] = ACTIONS(2593),
    [anon_sym_return] = ACTIONS(2593),
    [anon_sym_throw] = ACTIONS(2593),
    [anon_sym_SEMI] = ACTIONS(2595),
    [anon_sym_case] = ACTIONS(2593),
    [anon_sym_yield] = ACTIONS(2593),
    [anon_sym_LBRACK] = ACTIONS(2595),
    [anon_sym_LTtemplate_GT] = ACTIONS(2595),
    [anon_sym_DQUOTE] = ACTIONS(2595),
    [anon_sym_SQUOTE] = ACTIONS(2595),
    [anon_sym_class] = ACTIONS(2593),
    [anon_sym_async] = ACTIONS(2593),
    [anon_sym_function] = ACTIONS(2593),
    [anon_sym_new] = ACTIONS(2593),
    [anon_sym_using] = ACTIONS(2593),
    [anon_sym_PLUS] = ACTIONS(2593),
    [anon_sym_DASH] = ACTIONS(2593),
    [anon_sym_SLASH] = ACTIONS(2593),
    [anon_sym_LT] = ACTIONS(2593),
    [anon_sym_TILDE] = ACTIONS(2595),
    [anon_sym_void] = ACTIONS(2593),
    [anon_sym_delete] = ACTIONS(2593),
    [anon_sym_PLUS_PLUS] = ACTIONS(2595),
    [anon_sym_DASH_DASH] = ACTIONS(2595),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2595),
    [sym_number] = ACTIONS(2595),
    [sym_private_property_identifier] = ACTIONS(2595),
    [sym_this] = ACTIONS(2593),
    [sym_super] = ACTIONS(2593),
    [sym_true] = ACTIONS(2593),
    [sym_false] = ACTIONS(2593),
    [sym_null] = ACTIONS(2593),
    [sym_undefined] = ACTIONS(2593),
    [anon_sym_AT] = ACTIONS(2595),
    [anon_sym_static] = ACTIONS(2593),
    [anon_sym_readonly] = ACTIONS(2593),
    [anon_sym_get] = ACTIONS(2593),
    [anon_sym_set] = ACTIONS(2593),
    [anon_sym_declare] = ACTIONS(2593),
    [anon_sym_public] = ACTIONS(2593),
    [anon_sym_private] = ACTIONS(2593),
    [anon_sym_protected] = ACTIONS(2593),
    [anon_sym_override] = ACTIONS(2593),
    [anon_sym_module] = ACTIONS(2593),
    [anon_sym_any] = ACTIONS(2593),
    [anon_sym_number] = ACTIONS(2593),
    [anon_sym_boolean] = ACTIONS(2593),
    [anon_sym_string] = ACTIONS(2593),
    [anon_sym_symbol] = ACTIONS(2593),
    [anon_sym_object] = ACTIONS(2593),
    [anon_sym_property] = ACTIONS(2593),
    [anon_sym_signal] = ACTIONS(2593),
    [anon_sym_on] = ACTIONS(2593),
    [anon_sym_required] = ACTIONS(2593),
    [anon_sym_component] = ACTIONS(2593),
    [anon_sym_abstract] = ACTIONS(2593),
    [anon_sym_interface] = ACTIONS(2593),
    [anon_sym_enum] = ACTIONS(2593),
    [sym_html_comment] = ACTIONS(5),
  },
  [763] = {
    [sym_comment] = STATE(763),
    [sym_identifier] = ACTIONS(2597),
    [anon_sym_export] = ACTIONS(2597),
    [anon_sym_default] = ACTIONS(2597),
    [anon_sym_type] = ACTIONS(2597),
    [anon_sym_namespace] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(2599),
    [anon_sym_RBRACE] = ACTIONS(2599),
    [anon_sym_typeof] = ACTIONS(2597),
    [anon_sym_import] = ACTIONS(2597),
    [anon_sym_from] = ACTIONS(2597),
    [anon_sym_with] = ACTIONS(2597),
    [anon_sym_var] = ACTIONS(2597),
    [anon_sym_let] = ACTIONS(2597),
    [anon_sym_const] = ACTIONS(2597),
    [anon_sym_BANG] = ACTIONS(2599),
    [anon_sym_else] = ACTIONS(2597),
    [anon_sym_if] = ACTIONS(2597),
    [anon_sym_switch] = ACTIONS(2597),
    [anon_sym_for] = ACTIONS(2597),
    [anon_sym_LPAREN] = ACTIONS(2599),
    [anon_sym_await] = ACTIONS(2597),
    [anon_sym_of] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2597),
    [anon_sym_do] = ACTIONS(2597),
    [anon_sym_try] = ACTIONS(2597),
    [anon_sym_break] = ACTIONS(2597),
    [anon_sym_continue] = ACTIONS(2597),
    [anon_sym_debugger] = ACTIONS(2597),
    [anon_sym_return] = ACTIONS(2597),
    [anon_sym_throw] = ACTIONS(2597),
    [anon_sym_SEMI] = ACTIONS(2599),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_finally] = ACTIONS(2597),
    [anon_sym_yield] = ACTIONS(2597),
    [anon_sym_LBRACK] = ACTIONS(2599),
    [anon_sym_LTtemplate_GT] = ACTIONS(2599),
    [anon_sym_DQUOTE] = ACTIONS(2599),
    [anon_sym_SQUOTE] = ACTIONS(2599),
    [anon_sym_class] = ACTIONS(2597),
    [anon_sym_async] = ACTIONS(2597),
    [anon_sym_function] = ACTIONS(2597),
    [anon_sym_new] = ACTIONS(2597),
    [anon_sym_using] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(2597),
    [anon_sym_DASH] = ACTIONS(2597),
    [anon_sym_SLASH] = ACTIONS(2597),
    [anon_sym_LT] = ACTIONS(2597),
    [anon_sym_TILDE] = ACTIONS(2599),
    [anon_sym_void] = ACTIONS(2597),
    [anon_sym_delete] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2599),
    [anon_sym_DASH_DASH] = ACTIONS(2599),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2599),
    [sym_number] = ACTIONS(2599),
    [sym_private_property_identifier] = ACTIONS(2599),
    [sym_this] = ACTIONS(2597),
    [sym_super] = ACTIONS(2597),
    [sym_true] = ACTIONS(2597),
    [sym_false] = ACTIONS(2597),
    [sym_null] = ACTIONS(2597),
    [sym_undefined] = ACTIONS(2597),
    [anon_sym_AT] = ACTIONS(2599),
    [anon_sym_static] = ACTIONS(2597),
    [anon_sym_readonly] = ACTIONS(2597),
    [anon_sym_get] = ACTIONS(2597),
    [anon_sym_set] = ACTIONS(2597),
    [anon_sym_declare] = ACTIONS(2597),
    [anon_sym_public] = ACTIONS(2597),
    [anon_sym_private] = ACTIONS(2597),
    [anon_sym_protected] = ACTIONS(2597),
    [anon_sym_override] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(2597),
    [anon_sym_any] = ACTIONS(2597),
    [anon_sym_number] = ACTIONS(2597),
    [anon_sym_boolean] = ACTIONS(2597),
    [anon_sym_string] = ACTIONS(2597),
    [anon_sym_symbol] = ACTIONS(2597),
    [anon_sym_object] = ACTIONS(2597),
    [anon_sym_property] = ACTIONS(2597),
    [anon_sym_signal] = ACTIONS(2597),
    [anon_sym_on] = ACTIONS(2597),
    [anon_sym_required] = ACTIONS(2597),
    [anon_sym_component] = ACTIONS(2597),
    [anon_sym_abstract] = ACTIONS(2597),
    [anon_sym_interface] = ACTIONS(2597),
    [anon_sym_enum] = ACTIONS(2597),
    [sym_html_comment] = ACTIONS(5),
  },
  [764] = {
    [sym_comment] = STATE(764),
    [sym_identifier] = ACTIONS(1872),
    [anon_sym_export] = ACTIONS(1872),
    [anon_sym_default] = ACTIONS(1872),
    [anon_sym_type] = ACTIONS(1872),
    [anon_sym_namespace] = ACTIONS(1872),
    [anon_sym_LBRACE] = ACTIONS(1874),
    [anon_sym_RBRACE] = ACTIONS(1874),
    [anon_sym_typeof] = ACTIONS(1872),
    [anon_sym_import] = ACTIONS(1872),
    [anon_sym_from] = ACTIONS(1872),
    [anon_sym_with] = ACTIONS(1872),
    [anon_sym_var] = ACTIONS(1872),
    [anon_sym_let] = ACTIONS(1872),
    [anon_sym_const] = ACTIONS(1872),
    [anon_sym_BANG] = ACTIONS(1874),
    [anon_sym_else] = ACTIONS(1872),
    [anon_sym_if] = ACTIONS(1872),
    [anon_sym_switch] = ACTIONS(1872),
    [anon_sym_for] = ACTIONS(1872),
    [anon_sym_LPAREN] = ACTIONS(1874),
    [anon_sym_await] = ACTIONS(1872),
    [anon_sym_of] = ACTIONS(1872),
    [anon_sym_while] = ACTIONS(1872),
    [anon_sym_do] = ACTIONS(1872),
    [anon_sym_try] = ACTIONS(1872),
    [anon_sym_break] = ACTIONS(1872),
    [anon_sym_continue] = ACTIONS(1872),
    [anon_sym_debugger] = ACTIONS(1872),
    [anon_sym_return] = ACTIONS(1872),
    [anon_sym_throw] = ACTIONS(1872),
    [anon_sym_SEMI] = ACTIONS(1874),
    [anon_sym_case] = ACTIONS(1872),
    [anon_sym_yield] = ACTIONS(1872),
    [anon_sym_LBRACK] = ACTIONS(1874),
    [anon_sym_LTtemplate_GT] = ACTIONS(1874),
    [anon_sym_DOT] = ACTIONS(1872),
    [anon_sym_DQUOTE] = ACTIONS(1874),
    [anon_sym_SQUOTE] = ACTIONS(1874),
    [anon_sym_class] = ACTIONS(1872),
    [anon_sym_async] = ACTIONS(1872),
    [anon_sym_function] = ACTIONS(1872),
    [anon_sym_new] = ACTIONS(1872),
    [anon_sym_using] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_SLASH] = ACTIONS(1872),
    [anon_sym_LT] = ACTIONS(1872),
    [anon_sym_TILDE] = ACTIONS(1874),
    [anon_sym_void] = ACTIONS(1872),
    [anon_sym_delete] = ACTIONS(1872),
    [anon_sym_PLUS_PLUS] = ACTIONS(1874),
    [anon_sym_DASH_DASH] = ACTIONS(1874),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1874),
    [sym_number] = ACTIONS(1874),
    [sym_private_property_identifier] = ACTIONS(1874),
    [sym_this] = ACTIONS(1872),
    [sym_super] = ACTIONS(1872),
    [sym_true] = ACTIONS(1872),
    [sym_false] = ACTIONS(1872),
    [sym_null] = ACTIONS(1872),
    [sym_undefined] = ACTIONS(1872),
    [anon_sym_AT] = ACTIONS(1874),
    [anon_sym_static] = ACTIONS(1872),
    [anon_sym_readonly] = ACTIONS(1872),
    [anon_sym_get] = ACTIONS(1872),
    [anon_sym_set] = ACTIONS(1872),
    [anon_sym_declare] = ACTIONS(1872),
    [anon_sym_public] = ACTIONS(1872),
    [anon_sym_private] = ACTIONS(1872),
    [anon_sym_protected] = ACTIONS(1872),
    [anon_sym_override] = ACTIONS(1872),
    [anon_sym_module] = ACTIONS(1872),
    [anon_sym_any] = ACTIONS(1872),
    [anon_sym_number] = ACTIONS(1872),
    [anon_sym_boolean] = ACTIONS(1872),
    [anon_sym_string] = ACTIONS(1872),
    [anon_sym_symbol] = ACTIONS(1872),
    [anon_sym_object] = ACTIONS(1872),
    [anon_sym_property] = ACTIONS(1872),
    [anon_sym_signal] = ACTIONS(1872),
    [anon_sym_on] = ACTIONS(1872),
    [anon_sym_required] = ACTIONS(1872),
    [anon_sym_component] = ACTIONS(1872),
    [anon_sym_abstract] = ACTIONS(1872),
    [anon_sym_interface] = ACTIONS(1872),
    [anon_sym_enum] = ACTIONS(1872),
    [sym_html_comment] = ACTIONS(5),
  },
  [765] = {
    [sym_else_clause] = STATE(814),
    [sym_comment] = STATE(765),
    [sym_identifier] = ACTIONS(2601),
    [anon_sym_export] = ACTIONS(2601),
    [anon_sym_default] = ACTIONS(2601),
    [anon_sym_type] = ACTIONS(2601),
    [anon_sym_namespace] = ACTIONS(2601),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_RBRACE] = ACTIONS(2603),
    [anon_sym_typeof] = ACTIONS(2601),
    [anon_sym_import] = ACTIONS(2601),
    [anon_sym_from] = ACTIONS(2601),
    [anon_sym_with] = ACTIONS(2601),
    [anon_sym_var] = ACTIONS(2601),
    [anon_sym_let] = ACTIONS(2601),
    [anon_sym_const] = ACTIONS(2601),
    [anon_sym_BANG] = ACTIONS(2603),
    [anon_sym_else] = ACTIONS(2605),
    [anon_sym_if] = ACTIONS(2601),
    [anon_sym_switch] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2601),
    [anon_sym_LPAREN] = ACTIONS(2603),
    [anon_sym_await] = ACTIONS(2601),
    [anon_sym_of] = ACTIONS(2601),
    [anon_sym_while] = ACTIONS(2601),
    [anon_sym_do] = ACTIONS(2601),
    [anon_sym_try] = ACTIONS(2601),
    [anon_sym_break] = ACTIONS(2601),
    [anon_sym_continue] = ACTIONS(2601),
    [anon_sym_debugger] = ACTIONS(2601),
    [anon_sym_return] = ACTIONS(2601),
    [anon_sym_throw] = ACTIONS(2601),
    [anon_sym_SEMI] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2601),
    [anon_sym_yield] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2603),
    [anon_sym_LTtemplate_GT] = ACTIONS(2603),
    [anon_sym_DQUOTE] = ACTIONS(2603),
    [anon_sym_SQUOTE] = ACTIONS(2603),
    [anon_sym_class] = ACTIONS(2601),
    [anon_sym_async] = ACTIONS(2601),
    [anon_sym_function] = ACTIONS(2601),
    [anon_sym_new] = ACTIONS(2601),
    [anon_sym_using] = ACTIONS(2601),
    [anon_sym_PLUS] = ACTIONS(2601),
    [anon_sym_DASH] = ACTIONS(2601),
    [anon_sym_SLASH] = ACTIONS(2601),
    [anon_sym_LT] = ACTIONS(2601),
    [anon_sym_TILDE] = ACTIONS(2603),
    [anon_sym_void] = ACTIONS(2601),
    [anon_sym_delete] = ACTIONS(2601),
    [anon_sym_PLUS_PLUS] = ACTIONS(2603),
    [anon_sym_DASH_DASH] = ACTIONS(2603),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2603),
    [sym_number] = ACTIONS(2603),
    [sym_private_property_identifier] = ACTIONS(2603),
    [sym_this] = ACTIONS(2601),
    [sym_super] = ACTIONS(2601),
    [sym_true] = ACTIONS(2601),
    [sym_false] = ACTIONS(2601),
    [sym_null] = ACTIONS(2601),
    [sym_undefined] = ACTIONS(2601),
    [anon_sym_AT] = ACTIONS(2603),
    [anon_sym_static] = ACTIONS(2601),
    [anon_sym_readonly] = ACTIONS(2601),
    [anon_sym_get] = ACTIONS(2601),
    [anon_sym_set] = ACTIONS(2601),
    [anon_sym_declare] = ACTIONS(2601),
    [anon_sym_public] = ACTIONS(2601),
    [anon_sym_private] = ACTIONS(2601),
    [anon_sym_protected] = ACTIONS(2601),
    [anon_sym_override] = ACTIONS(2601),
    [anon_sym_module] = ACTIONS(2601),
    [anon_sym_any] = ACTIONS(2601),
    [anon_sym_number] = ACTIONS(2601),
    [anon_sym_boolean] = ACTIONS(2601),
    [anon_sym_string] = ACTIONS(2601),
    [anon_sym_symbol] = ACTIONS(2601),
    [anon_sym_object] = ACTIONS(2601),
    [anon_sym_property] = ACTIONS(2601),
    [anon_sym_signal] = ACTIONS(2601),
    [anon_sym_on] = ACTIONS(2601),
    [anon_sym_required] = ACTIONS(2601),
    [anon_sym_component] = ACTIONS(2601),
    [anon_sym_abstract] = ACTIONS(2601),
    [anon_sym_interface] = ACTIONS(2601),
    [anon_sym_enum] = ACTIONS(2601),
    [sym_html_comment] = ACTIONS(5),
  },
  [766] = {
    [sym_comment] = STATE(766),
    [sym_identifier] = ACTIONS(2607),
    [anon_sym_export] = ACTIONS(2607),
    [anon_sym_default] = ACTIONS(2607),
    [anon_sym_type] = ACTIONS(2607),
    [anon_sym_namespace] = ACTIONS(2607),
    [anon_sym_LBRACE] = ACTIONS(2609),
    [anon_sym_RBRACE] = ACTIONS(2609),
    [anon_sym_typeof] = ACTIONS(2607),
    [anon_sym_import] = ACTIONS(2607),
    [anon_sym_from] = ACTIONS(2607),
    [anon_sym_with] = ACTIONS(2607),
    [anon_sym_var] = ACTIONS(2607),
    [anon_sym_let] = ACTIONS(2607),
    [anon_sym_const] = ACTIONS(2607),
    [anon_sym_BANG] = ACTIONS(2609),
    [anon_sym_else] = ACTIONS(2607),
    [anon_sym_if] = ACTIONS(2607),
    [anon_sym_switch] = ACTIONS(2607),
    [anon_sym_for] = ACTIONS(2607),
    [anon_sym_LPAREN] = ACTIONS(2609),
    [anon_sym_RPAREN] = ACTIONS(2609),
    [anon_sym_await] = ACTIONS(2607),
    [anon_sym_of] = ACTIONS(2607),
    [anon_sym_while] = ACTIONS(2607),
    [anon_sym_do] = ACTIONS(2607),
    [anon_sym_try] = ACTIONS(2607),
    [anon_sym_break] = ACTIONS(2607),
    [anon_sym_continue] = ACTIONS(2607),
    [anon_sym_debugger] = ACTIONS(2607),
    [anon_sym_return] = ACTIONS(2607),
    [anon_sym_throw] = ACTIONS(2607),
    [anon_sym_SEMI] = ACTIONS(2609),
    [anon_sym_case] = ACTIONS(2607),
    [anon_sym_yield] = ACTIONS(2607),
    [anon_sym_LBRACK] = ACTIONS(2609),
    [anon_sym_LTtemplate_GT] = ACTIONS(2609),
    [anon_sym_DQUOTE] = ACTIONS(2609),
    [anon_sym_SQUOTE] = ACTIONS(2609),
    [anon_sym_class] = ACTIONS(2607),
    [anon_sym_async] = ACTIONS(2607),
    [anon_sym_function] = ACTIONS(2607),
    [anon_sym_new] = ACTIONS(2607),
    [anon_sym_using] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(2607),
    [anon_sym_DASH] = ACTIONS(2607),
    [anon_sym_SLASH] = ACTIONS(2607),
    [anon_sym_LT] = ACTIONS(2607),
    [anon_sym_TILDE] = ACTIONS(2609),
    [anon_sym_void] = ACTIONS(2607),
    [anon_sym_delete] = ACTIONS(2607),
    [anon_sym_PLUS_PLUS] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(2609),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2609),
    [sym_number] = ACTIONS(2609),
    [sym_private_property_identifier] = ACTIONS(2609),
    [sym_this] = ACTIONS(2607),
    [sym_super] = ACTIONS(2607),
    [sym_true] = ACTIONS(2607),
    [sym_false] = ACTIONS(2607),
    [sym_null] = ACTIONS(2607),
    [sym_undefined] = ACTIONS(2607),
    [anon_sym_AT] = ACTIONS(2609),
    [anon_sym_static] = ACTIONS(2607),
    [anon_sym_readonly] = ACTIONS(2607),
    [anon_sym_get] = ACTIONS(2607),
    [anon_sym_set] = ACTIONS(2607),
    [anon_sym_declare] = ACTIONS(2607),
    [anon_sym_public] = ACTIONS(2607),
    [anon_sym_private] = ACTIONS(2607),
    [anon_sym_protected] = ACTIONS(2607),
    [anon_sym_override] = ACTIONS(2607),
    [anon_sym_module] = ACTIONS(2607),
    [anon_sym_any] = ACTIONS(2607),
    [anon_sym_number] = ACTIONS(2607),
    [anon_sym_boolean] = ACTIONS(2607),
    [anon_sym_string] = ACTIONS(2607),
    [anon_sym_symbol] = ACTIONS(2607),
    [anon_sym_object] = ACTIONS(2607),
    [anon_sym_property] = ACTIONS(2607),
    [anon_sym_signal] = ACTIONS(2607),
    [anon_sym_on] = ACTIONS(2607),
    [anon_sym_required] = ACTIONS(2607),
    [anon_sym_component] = ACTIONS(2607),
    [anon_sym_abstract] = ACTIONS(2607),
    [anon_sym_interface] = ACTIONS(2607),
    [anon_sym_enum] = ACTIONS(2607),
    [sym_html_comment] = ACTIONS(5),
  },
  [767] = {
    [sym_comment] = STATE(767),
    [sym_identifier] = ACTIONS(2611),
    [anon_sym_export] = ACTIONS(2611),
    [anon_sym_default] = ACTIONS(2611),
    [anon_sym_type] = ACTIONS(2611),
    [anon_sym_namespace] = ACTIONS(2611),
    [anon_sym_LBRACE] = ACTIONS(2613),
    [anon_sym_RBRACE] = ACTIONS(2613),
    [anon_sym_typeof] = ACTIONS(2611),
    [anon_sym_import] = ACTIONS(2611),
    [anon_sym_from] = ACTIONS(2611),
    [anon_sym_with] = ACTIONS(2611),
    [anon_sym_var] = ACTIONS(2611),
    [anon_sym_let] = ACTIONS(2611),
    [anon_sym_const] = ACTIONS(2611),
    [anon_sym_BANG] = ACTIONS(2613),
    [anon_sym_else] = ACTIONS(2611),
    [anon_sym_if] = ACTIONS(2611),
    [anon_sym_switch] = ACTIONS(2611),
    [anon_sym_for] = ACTIONS(2611),
    [anon_sym_LPAREN] = ACTIONS(2613),
    [anon_sym_await] = ACTIONS(2611),
    [anon_sym_of] = ACTIONS(2611),
    [anon_sym_while] = ACTIONS(2611),
    [anon_sym_do] = ACTIONS(2611),
    [anon_sym_try] = ACTIONS(2611),
    [anon_sym_break] = ACTIONS(2611),
    [anon_sym_continue] = ACTIONS(2611),
    [anon_sym_debugger] = ACTIONS(2611),
    [anon_sym_return] = ACTIONS(2611),
    [anon_sym_throw] = ACTIONS(2611),
    [anon_sym_SEMI] = ACTIONS(2613),
    [anon_sym_case] = ACTIONS(2611),
    [anon_sym_yield] = ACTIONS(2611),
    [anon_sym_LBRACK] = ACTIONS(2613),
    [anon_sym_LTtemplate_GT] = ACTIONS(2613),
    [anon_sym_DQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_class] = ACTIONS(2611),
    [anon_sym_async] = ACTIONS(2611),
    [anon_sym_function] = ACTIONS(2611),
    [anon_sym_new] = ACTIONS(2611),
    [anon_sym_using] = ACTIONS(2611),
    [anon_sym_PLUS] = ACTIONS(2611),
    [anon_sym_DASH] = ACTIONS(2611),
    [anon_sym_SLASH] = ACTIONS(2611),
    [anon_sym_LT] = ACTIONS(2611),
    [anon_sym_TILDE] = ACTIONS(2613),
    [anon_sym_void] = ACTIONS(2611),
    [anon_sym_delete] = ACTIONS(2611),
    [anon_sym_PLUS_PLUS] = ACTIONS(2613),
    [anon_sym_DASH_DASH] = ACTIONS(2613),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2613),
    [sym_number] = ACTIONS(2613),
    [sym_private_property_identifier] = ACTIONS(2613),
    [sym_this] = ACTIONS(2611),
    [sym_super] = ACTIONS(2611),
    [sym_true] = ACTIONS(2611),
    [sym_false] = ACTIONS(2611),
    [sym_null] = ACTIONS(2611),
    [sym_undefined] = ACTIONS(2611),
    [anon_sym_AT] = ACTIONS(2613),
    [anon_sym_static] = ACTIONS(2611),
    [anon_sym_readonly] = ACTIONS(2611),
    [anon_sym_get] = ACTIONS(2611),
    [anon_sym_set] = ACTIONS(2611),
    [anon_sym_declare] = ACTIONS(2611),
    [anon_sym_public] = ACTIONS(2611),
    [anon_sym_private] = ACTIONS(2611),
    [anon_sym_protected] = ACTIONS(2611),
    [anon_sym_override] = ACTIONS(2611),
    [anon_sym_module] = ACTIONS(2611),
    [anon_sym_any] = ACTIONS(2611),
    [anon_sym_number] = ACTIONS(2611),
    [anon_sym_boolean] = ACTIONS(2611),
    [anon_sym_string] = ACTIONS(2611),
    [anon_sym_symbol] = ACTIONS(2611),
    [anon_sym_object] = ACTIONS(2611),
    [anon_sym_property] = ACTIONS(2611),
    [anon_sym_signal] = ACTIONS(2611),
    [anon_sym_on] = ACTIONS(2611),
    [anon_sym_required] = ACTIONS(2611),
    [anon_sym_component] = ACTIONS(2611),
    [anon_sym_abstract] = ACTIONS(2611),
    [anon_sym_interface] = ACTIONS(2611),
    [anon_sym_enum] = ACTIONS(2611),
    [sym__automatic_semicolon] = ACTIONS(2613),
    [sym_html_comment] = ACTIONS(5),
  },
  [768] = {
    [sym_comment] = STATE(768),
    [sym_identifier] = ACTIONS(2615),
    [anon_sym_export] = ACTIONS(2615),
    [anon_sym_default] = ACTIONS(2615),
    [anon_sym_type] = ACTIONS(2615),
    [anon_sym_namespace] = ACTIONS(2615),
    [anon_sym_LBRACE] = ACTIONS(2617),
    [anon_sym_RBRACE] = ACTIONS(2617),
    [anon_sym_typeof] = ACTIONS(2615),
    [anon_sym_import] = ACTIONS(2615),
    [anon_sym_from] = ACTIONS(2615),
    [anon_sym_with] = ACTIONS(2615),
    [anon_sym_var] = ACTIONS(2615),
    [anon_sym_let] = ACTIONS(2615),
    [anon_sym_const] = ACTIONS(2615),
    [anon_sym_BANG] = ACTIONS(2617),
    [anon_sym_else] = ACTIONS(2615),
    [anon_sym_if] = ACTIONS(2615),
    [anon_sym_switch] = ACTIONS(2615),
    [anon_sym_for] = ACTIONS(2615),
    [anon_sym_LPAREN] = ACTIONS(2617),
    [anon_sym_await] = ACTIONS(2615),
    [anon_sym_of] = ACTIONS(2615),
    [anon_sym_while] = ACTIONS(2615),
    [anon_sym_do] = ACTIONS(2615),
    [anon_sym_try] = ACTIONS(2615),
    [anon_sym_break] = ACTIONS(2615),
    [anon_sym_continue] = ACTIONS(2615),
    [anon_sym_debugger] = ACTIONS(2615),
    [anon_sym_return] = ACTIONS(2615),
    [anon_sym_throw] = ACTIONS(2615),
    [anon_sym_SEMI] = ACTIONS(2617),
    [anon_sym_case] = ACTIONS(2615),
    [anon_sym_finally] = ACTIONS(2615),
    [anon_sym_yield] = ACTIONS(2615),
    [anon_sym_LBRACK] = ACTIONS(2617),
    [anon_sym_LTtemplate_GT] = ACTIONS(2617),
    [anon_sym_DQUOTE] = ACTIONS(2617),
    [anon_sym_SQUOTE] = ACTIONS(2617),
    [anon_sym_class] = ACTIONS(2615),
    [anon_sym_async] = ACTIONS(2615),
    [anon_sym_function] = ACTIONS(2615),
    [anon_sym_new] = ACTIONS(2615),
    [anon_sym_using] = ACTIONS(2615),
    [anon_sym_PLUS] = ACTIONS(2615),
    [anon_sym_DASH] = ACTIONS(2615),
    [anon_sym_SLASH] = ACTIONS(2615),
    [anon_sym_LT] = ACTIONS(2615),
    [anon_sym_TILDE] = ACTIONS(2617),
    [anon_sym_void] = ACTIONS(2615),
    [anon_sym_delete] = ACTIONS(2615),
    [anon_sym_PLUS_PLUS] = ACTIONS(2617),
    [anon_sym_DASH_DASH] = ACTIONS(2617),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2617),
    [sym_number] = ACTIONS(2617),
    [sym_private_property_identifier] = ACTIONS(2617),
    [sym_this] = ACTIONS(2615),
    [sym_super] = ACTIONS(2615),
    [sym_true] = ACTIONS(2615),
    [sym_false] = ACTIONS(2615),
    [sym_null] = ACTIONS(2615),
    [sym_undefined] = ACTIONS(2615),
    [anon_sym_AT] = ACTIONS(2617),
    [anon_sym_static] = ACTIONS(2615),
    [anon_sym_readonly] = ACTIONS(2615),
    [anon_sym_get] = ACTIONS(2615),
    [anon_sym_set] = ACTIONS(2615),
    [anon_sym_declare] = ACTIONS(2615),
    [anon_sym_public] = ACTIONS(2615),
    [anon_sym_private] = ACTIONS(2615),
    [anon_sym_protected] = ACTIONS(2615),
    [anon_sym_override] = ACTIONS(2615),
    [anon_sym_module] = ACTIONS(2615),
    [anon_sym_any] = ACTIONS(2615),
    [anon_sym_number] = ACTIONS(2615),
    [anon_sym_boolean] = ACTIONS(2615),
    [anon_sym_string] = ACTIONS(2615),
    [anon_sym_symbol] = ACTIONS(2615),
    [anon_sym_object] = ACTIONS(2615),
    [anon_sym_property] = ACTIONS(2615),
    [anon_sym_signal] = ACTIONS(2615),
    [anon_sym_on] = ACTIONS(2615),
    [anon_sym_required] = ACTIONS(2615),
    [anon_sym_component] = ACTIONS(2615),
    [anon_sym_abstract] = ACTIONS(2615),
    [anon_sym_interface] = ACTIONS(2615),
    [anon_sym_enum] = ACTIONS(2615),
    [sym_html_comment] = ACTIONS(5),
  },
  [769] = {
    [sym_comment] = STATE(769),
    [sym_identifier] = ACTIONS(1854),
    [anon_sym_export] = ACTIONS(1854),
    [anon_sym_default] = ACTIONS(1854),
    [anon_sym_type] = ACTIONS(1854),
    [anon_sym_namespace] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [anon_sym_RBRACE] = ACTIONS(1856),
    [anon_sym_typeof] = ACTIONS(1854),
    [anon_sym_import] = ACTIONS(1854),
    [anon_sym_from] = ACTIONS(1854),
    [anon_sym_with] = ACTIONS(1854),
    [anon_sym_var] = ACTIONS(1854),
    [anon_sym_let] = ACTIONS(1854),
    [anon_sym_const] = ACTIONS(1854),
    [anon_sym_BANG] = ACTIONS(1856),
    [anon_sym_else] = ACTIONS(1854),
    [anon_sym_if] = ACTIONS(1854),
    [anon_sym_switch] = ACTIONS(1854),
    [anon_sym_for] = ACTIONS(1854),
    [anon_sym_LPAREN] = ACTIONS(1856),
    [anon_sym_await] = ACTIONS(1854),
    [anon_sym_of] = ACTIONS(1854),
    [anon_sym_while] = ACTIONS(1854),
    [anon_sym_do] = ACTIONS(1854),
    [anon_sym_try] = ACTIONS(1854),
    [anon_sym_break] = ACTIONS(1854),
    [anon_sym_continue] = ACTIONS(1854),
    [anon_sym_debugger] = ACTIONS(1854),
    [anon_sym_return] = ACTIONS(1854),
    [anon_sym_throw] = ACTIONS(1854),
    [anon_sym_SEMI] = ACTIONS(1856),
    [anon_sym_case] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1854),
    [anon_sym_LBRACK] = ACTIONS(1856),
    [anon_sym_LTtemplate_GT] = ACTIONS(1856),
    [anon_sym_DQUOTE] = ACTIONS(1856),
    [anon_sym_SQUOTE] = ACTIONS(1856),
    [anon_sym_class] = ACTIONS(1854),
    [anon_sym_async] = ACTIONS(1854),
    [anon_sym_function] = ACTIONS(1854),
    [anon_sym_new] = ACTIONS(1854),
    [anon_sym_using] = ACTIONS(1854),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_DASH] = ACTIONS(1854),
    [anon_sym_SLASH] = ACTIONS(1854),
    [anon_sym_LT] = ACTIONS(1854),
    [anon_sym_TILDE] = ACTIONS(1856),
    [anon_sym_void] = ACTIONS(1854),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_PLUS_PLUS] = ACTIONS(1856),
    [anon_sym_DASH_DASH] = ACTIONS(1856),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1856),
    [sym_number] = ACTIONS(1856),
    [sym_private_property_identifier] = ACTIONS(1856),
    [sym_this] = ACTIONS(1854),
    [sym_super] = ACTIONS(1854),
    [sym_true] = ACTIONS(1854),
    [sym_false] = ACTIONS(1854),
    [sym_null] = ACTIONS(1854),
    [sym_undefined] = ACTIONS(1854),
    [anon_sym_AT] = ACTIONS(1856),
    [anon_sym_static] = ACTIONS(1854),
    [anon_sym_readonly] = ACTIONS(1854),
    [anon_sym_get] = ACTIONS(1854),
    [anon_sym_set] = ACTIONS(1854),
    [anon_sym_declare] = ACTIONS(1854),
    [anon_sym_public] = ACTIONS(1854),
    [anon_sym_private] = ACTIONS(1854),
    [anon_sym_protected] = ACTIONS(1854),
    [anon_sym_override] = ACTIONS(1854),
    [anon_sym_module] = ACTIONS(1854),
    [anon_sym_any] = ACTIONS(1854),
    [anon_sym_number] = ACTIONS(1854),
    [anon_sym_boolean] = ACTIONS(1854),
    [anon_sym_string] = ACTIONS(1854),
    [anon_sym_symbol] = ACTIONS(1854),
    [anon_sym_object] = ACTIONS(1854),
    [anon_sym_property] = ACTIONS(1854),
    [anon_sym_signal] = ACTIONS(1854),
    [anon_sym_on] = ACTIONS(1854),
    [anon_sym_required] = ACTIONS(1854),
    [anon_sym_component] = ACTIONS(1854),
    [anon_sym_abstract] = ACTIONS(1854),
    [anon_sym_interface] = ACTIONS(1854),
    [anon_sym_enum] = ACTIONS(1854),
    [sym__automatic_semicolon] = ACTIONS(1856),
    [sym_html_comment] = ACTIONS(5),
  },
  [770] = {
    [sym_comment] = STATE(770),
    [sym_identifier] = ACTIONS(2619),
    [anon_sym_export] = ACTIONS(2619),
    [anon_sym_default] = ACTIONS(2619),
    [anon_sym_type] = ACTIONS(2619),
    [anon_sym_namespace] = ACTIONS(2619),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_RBRACE] = ACTIONS(2621),
    [anon_sym_typeof] = ACTIONS(2619),
    [anon_sym_import] = ACTIONS(2619),
    [anon_sym_from] = ACTIONS(2619),
    [anon_sym_with] = ACTIONS(2619),
    [anon_sym_var] = ACTIONS(2619),
    [anon_sym_let] = ACTIONS(2619),
    [anon_sym_const] = ACTIONS(2619),
    [anon_sym_BANG] = ACTIONS(2621),
    [anon_sym_else] = ACTIONS(2619),
    [anon_sym_if] = ACTIONS(2619),
    [anon_sym_switch] = ACTIONS(2619),
    [anon_sym_for] = ACTIONS(2619),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_await] = ACTIONS(2619),
    [anon_sym_of] = ACTIONS(2619),
    [anon_sym_while] = ACTIONS(2619),
    [anon_sym_do] = ACTIONS(2619),
    [anon_sym_try] = ACTIONS(2619),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_continue] = ACTIONS(2619),
    [anon_sym_debugger] = ACTIONS(2619),
    [anon_sym_return] = ACTIONS(2619),
    [anon_sym_throw] = ACTIONS(2619),
    [anon_sym_SEMI] = ACTIONS(2621),
    [anon_sym_case] = ACTIONS(2619),
    [anon_sym_yield] = ACTIONS(2619),
    [anon_sym_LBRACK] = ACTIONS(2621),
    [anon_sym_LTtemplate_GT] = ACTIONS(2621),
    [anon_sym_DQUOTE] = ACTIONS(2621),
    [anon_sym_SQUOTE] = ACTIONS(2621),
    [anon_sym_class] = ACTIONS(2619),
    [anon_sym_async] = ACTIONS(2619),
    [anon_sym_function] = ACTIONS(2619),
    [anon_sym_new] = ACTIONS(2619),
    [anon_sym_using] = ACTIONS(2619),
    [anon_sym_PLUS] = ACTIONS(2619),
    [anon_sym_DASH] = ACTIONS(2619),
    [anon_sym_SLASH] = ACTIONS(2619),
    [anon_sym_LT] = ACTIONS(2619),
    [anon_sym_TILDE] = ACTIONS(2621),
    [anon_sym_void] = ACTIONS(2619),
    [anon_sym_delete] = ACTIONS(2619),
    [anon_sym_PLUS_PLUS] = ACTIONS(2621),
    [anon_sym_DASH_DASH] = ACTIONS(2621),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2621),
    [sym_number] = ACTIONS(2621),
    [sym_private_property_identifier] = ACTIONS(2621),
    [sym_this] = ACTIONS(2619),
    [sym_super] = ACTIONS(2619),
    [sym_true] = ACTIONS(2619),
    [sym_false] = ACTIONS(2619),
    [sym_null] = ACTIONS(2619),
    [sym_undefined] = ACTIONS(2619),
    [anon_sym_AT] = ACTIONS(2621),
    [anon_sym_static] = ACTIONS(2619),
    [anon_sym_readonly] = ACTIONS(2619),
    [anon_sym_get] = ACTIONS(2619),
    [anon_sym_set] = ACTIONS(2619),
    [anon_sym_declare] = ACTIONS(2619),
    [anon_sym_public] = ACTIONS(2619),
    [anon_sym_private] = ACTIONS(2619),
    [anon_sym_protected] = ACTIONS(2619),
    [anon_sym_override] = ACTIONS(2619),
    [anon_sym_module] = ACTIONS(2619),
    [anon_sym_any] = ACTIONS(2619),
    [anon_sym_number] = ACTIONS(2619),
    [anon_sym_boolean] = ACTIONS(2619),
    [anon_sym_string] = ACTIONS(2619),
    [anon_sym_symbol] = ACTIONS(2619),
    [anon_sym_object] = ACTIONS(2619),
    [anon_sym_property] = ACTIONS(2619),
    [anon_sym_signal] = ACTIONS(2619),
    [anon_sym_on] = ACTIONS(2619),
    [anon_sym_required] = ACTIONS(2619),
    [anon_sym_component] = ACTIONS(2619),
    [anon_sym_abstract] = ACTIONS(2619),
    [anon_sym_interface] = ACTIONS(2619),
    [anon_sym_enum] = ACTIONS(2619),
    [sym__automatic_semicolon] = ACTIONS(2621),
    [sym_html_comment] = ACTIONS(5),
  },
  [771] = {
    [sym_comment] = STATE(771),
    [sym_identifier] = ACTIONS(1958),
    [anon_sym_export] = ACTIONS(1958),
    [anon_sym_default] = ACTIONS(1958),
    [anon_sym_type] = ACTIONS(1958),
    [anon_sym_namespace] = ACTIONS(1958),
    [anon_sym_LBRACE] = ACTIONS(1962),
    [anon_sym_RBRACE] = ACTIONS(1962),
    [anon_sym_typeof] = ACTIONS(1958),
    [anon_sym_import] = ACTIONS(1958),
    [anon_sym_from] = ACTIONS(1958),
    [anon_sym_with] = ACTIONS(1958),
    [anon_sym_var] = ACTIONS(1958),
    [anon_sym_let] = ACTIONS(1958),
    [anon_sym_const] = ACTIONS(1958),
    [anon_sym_BANG] = ACTIONS(1962),
    [anon_sym_else] = ACTIONS(1958),
    [anon_sym_if] = ACTIONS(1958),
    [anon_sym_switch] = ACTIONS(1958),
    [anon_sym_for] = ACTIONS(1958),
    [anon_sym_LPAREN] = ACTIONS(1962),
    [anon_sym_await] = ACTIONS(1958),
    [anon_sym_of] = ACTIONS(1958),
    [anon_sym_while] = ACTIONS(1958),
    [anon_sym_do] = ACTIONS(1958),
    [anon_sym_try] = ACTIONS(1958),
    [anon_sym_break] = ACTIONS(1958),
    [anon_sym_continue] = ACTIONS(1958),
    [anon_sym_debugger] = ACTIONS(1958),
    [anon_sym_return] = ACTIONS(1958),
    [anon_sym_throw] = ACTIONS(1958),
    [anon_sym_SEMI] = ACTIONS(1962),
    [anon_sym_case] = ACTIONS(1958),
    [anon_sym_yield] = ACTIONS(1958),
    [anon_sym_LBRACK] = ACTIONS(1962),
    [anon_sym_LTtemplate_GT] = ACTIONS(1962),
    [anon_sym_DQUOTE] = ACTIONS(1962),
    [anon_sym_SQUOTE] = ACTIONS(1962),
    [anon_sym_class] = ACTIONS(1958),
    [anon_sym_async] = ACTIONS(1958),
    [anon_sym_function] = ACTIONS(1958),
    [anon_sym_new] = ACTIONS(1958),
    [anon_sym_using] = ACTIONS(1958),
    [anon_sym_PLUS] = ACTIONS(1958),
    [anon_sym_DASH] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(1958),
    [anon_sym_LT] = ACTIONS(1958),
    [anon_sym_TILDE] = ACTIONS(1962),
    [anon_sym_void] = ACTIONS(1958),
    [anon_sym_delete] = ACTIONS(1958),
    [anon_sym_PLUS_PLUS] = ACTIONS(1962),
    [anon_sym_DASH_DASH] = ACTIONS(1962),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1962),
    [sym_number] = ACTIONS(1962),
    [sym_private_property_identifier] = ACTIONS(1962),
    [sym_this] = ACTIONS(1958),
    [sym_super] = ACTIONS(1958),
    [sym_true] = ACTIONS(1958),
    [sym_false] = ACTIONS(1958),
    [sym_null] = ACTIONS(1958),
    [sym_undefined] = ACTIONS(1958),
    [anon_sym_AT] = ACTIONS(1962),
    [anon_sym_static] = ACTIONS(1958),
    [anon_sym_readonly] = ACTIONS(1958),
    [anon_sym_get] = ACTIONS(1958),
    [anon_sym_set] = ACTIONS(1958),
    [anon_sym_declare] = ACTIONS(1958),
    [anon_sym_public] = ACTIONS(1958),
    [anon_sym_private] = ACTIONS(1958),
    [anon_sym_protected] = ACTIONS(1958),
    [anon_sym_override] = ACTIONS(1958),
    [anon_sym_module] = ACTIONS(1958),
    [anon_sym_any] = ACTIONS(1958),
    [anon_sym_number] = ACTIONS(1958),
    [anon_sym_boolean] = ACTIONS(1958),
    [anon_sym_string] = ACTIONS(1958),
    [anon_sym_symbol] = ACTIONS(1958),
    [anon_sym_object] = ACTIONS(1958),
    [anon_sym_property] = ACTIONS(1958),
    [anon_sym_signal] = ACTIONS(1958),
    [anon_sym_on] = ACTIONS(1958),
    [anon_sym_required] = ACTIONS(1958),
    [anon_sym_component] = ACTIONS(1958),
    [anon_sym_abstract] = ACTIONS(1958),
    [anon_sym_interface] = ACTIONS(1958),
    [anon_sym_enum] = ACTIONS(1958),
    [sym__automatic_semicolon] = ACTIONS(1966),
    [sym_html_comment] = ACTIONS(5),
  },
  [772] = {
    [sym_comment] = STATE(772),
    [sym_identifier] = ACTIONS(1930),
    [anon_sym_export] = ACTIONS(1930),
    [anon_sym_default] = ACTIONS(1930),
    [anon_sym_type] = ACTIONS(1930),
    [anon_sym_namespace] = ACTIONS(1930),
    [anon_sym_LBRACE] = ACTIONS(1934),
    [anon_sym_RBRACE] = ACTIONS(1934),
    [anon_sym_typeof] = ACTIONS(1930),
    [anon_sym_import] = ACTIONS(1930),
    [anon_sym_from] = ACTIONS(1930),
    [anon_sym_with] = ACTIONS(1930),
    [anon_sym_var] = ACTIONS(1930),
    [anon_sym_let] = ACTIONS(1930),
    [anon_sym_const] = ACTIONS(1930),
    [anon_sym_BANG] = ACTIONS(1934),
    [anon_sym_else] = ACTIONS(1930),
    [anon_sym_if] = ACTIONS(1930),
    [anon_sym_switch] = ACTIONS(1930),
    [anon_sym_for] = ACTIONS(1930),
    [anon_sym_LPAREN] = ACTIONS(1934),
    [anon_sym_await] = ACTIONS(1930),
    [anon_sym_of] = ACTIONS(1930),
    [anon_sym_while] = ACTIONS(1930),
    [anon_sym_do] = ACTIONS(1930),
    [anon_sym_try] = ACTIONS(1930),
    [anon_sym_break] = ACTIONS(1930),
    [anon_sym_continue] = ACTIONS(1930),
    [anon_sym_debugger] = ACTIONS(1930),
    [anon_sym_return] = ACTIONS(1930),
    [anon_sym_throw] = ACTIONS(1930),
    [anon_sym_SEMI] = ACTIONS(1934),
    [anon_sym_case] = ACTIONS(1930),
    [anon_sym_yield] = ACTIONS(1930),
    [anon_sym_LBRACK] = ACTIONS(1934),
    [anon_sym_LTtemplate_GT] = ACTIONS(1934),
    [anon_sym_DQUOTE] = ACTIONS(1934),
    [anon_sym_SQUOTE] = ACTIONS(1934),
    [anon_sym_class] = ACTIONS(1930),
    [anon_sym_async] = ACTIONS(1930),
    [anon_sym_function] = ACTIONS(1930),
    [anon_sym_new] = ACTIONS(1930),
    [anon_sym_using] = ACTIONS(1930),
    [anon_sym_PLUS] = ACTIONS(1930),
    [anon_sym_DASH] = ACTIONS(1930),
    [anon_sym_SLASH] = ACTIONS(1930),
    [anon_sym_LT] = ACTIONS(1930),
    [anon_sym_TILDE] = ACTIONS(1934),
    [anon_sym_void] = ACTIONS(1930),
    [anon_sym_delete] = ACTIONS(1930),
    [anon_sym_PLUS_PLUS] = ACTIONS(1934),
    [anon_sym_DASH_DASH] = ACTIONS(1934),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1934),
    [sym_number] = ACTIONS(1934),
    [sym_private_property_identifier] = ACTIONS(1934),
    [sym_this] = ACTIONS(1930),
    [sym_super] = ACTIONS(1930),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_AT] = ACTIONS(1934),
    [anon_sym_static] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1930),
    [anon_sym_get] = ACTIONS(1930),
    [anon_sym_set] = ACTIONS(1930),
    [anon_sym_declare] = ACTIONS(1930),
    [anon_sym_public] = ACTIONS(1930),
    [anon_sym_private] = ACTIONS(1930),
    [anon_sym_protected] = ACTIONS(1930),
    [anon_sym_override] = ACTIONS(1930),
    [anon_sym_module] = ACTIONS(1930),
    [anon_sym_any] = ACTIONS(1930),
    [anon_sym_number] = ACTIONS(1930),
    [anon_sym_boolean] = ACTIONS(1930),
    [anon_sym_string] = ACTIONS(1930),
    [anon_sym_symbol] = ACTIONS(1930),
    [anon_sym_object] = ACTIONS(1930),
    [anon_sym_property] = ACTIONS(1930),
    [anon_sym_signal] = ACTIONS(1930),
    [anon_sym_on] = ACTIONS(1930),
    [anon_sym_required] = ACTIONS(1930),
    [anon_sym_component] = ACTIONS(1930),
    [anon_sym_abstract] = ACTIONS(1930),
    [anon_sym_interface] = ACTIONS(1930),
    [anon_sym_enum] = ACTIONS(1930),
    [sym__automatic_semicolon] = ACTIONS(1938),
    [sym_html_comment] = ACTIONS(5),
  },
  [773] = {
    [sym_comment] = STATE(773),
    [sym_identifier] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_default] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1944),
    [anon_sym_LBRACE] = ACTIONS(1946),
    [anon_sym_RBRACE] = ACTIONS(1946),
    [anon_sym_typeof] = ACTIONS(1944),
    [anon_sym_import] = ACTIONS(1944),
    [anon_sym_from] = ACTIONS(1944),
    [anon_sym_with] = ACTIONS(1944),
    [anon_sym_var] = ACTIONS(1944),
    [anon_sym_let] = ACTIONS(1944),
    [anon_sym_const] = ACTIONS(1944),
    [anon_sym_BANG] = ACTIONS(1946),
    [anon_sym_else] = ACTIONS(1944),
    [anon_sym_if] = ACTIONS(1944),
    [anon_sym_switch] = ACTIONS(1944),
    [anon_sym_for] = ACTIONS(1944),
    [anon_sym_LPAREN] = ACTIONS(1946),
    [anon_sym_await] = ACTIONS(1944),
    [anon_sym_of] = ACTIONS(1944),
    [anon_sym_while] = ACTIONS(1944),
    [anon_sym_do] = ACTIONS(1944),
    [anon_sym_try] = ACTIONS(1944),
    [anon_sym_break] = ACTIONS(1944),
    [anon_sym_continue] = ACTIONS(1944),
    [anon_sym_debugger] = ACTIONS(1944),
    [anon_sym_return] = ACTIONS(1944),
    [anon_sym_throw] = ACTIONS(1944),
    [anon_sym_SEMI] = ACTIONS(1946),
    [anon_sym_case] = ACTIONS(1944),
    [anon_sym_yield] = ACTIONS(1944),
    [anon_sym_LBRACK] = ACTIONS(1946),
    [anon_sym_LTtemplate_GT] = ACTIONS(1946),
    [anon_sym_DOT] = ACTIONS(1944),
    [anon_sym_DQUOTE] = ACTIONS(1946),
    [anon_sym_SQUOTE] = ACTIONS(1946),
    [anon_sym_class] = ACTIONS(1944),
    [anon_sym_async] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(1944),
    [anon_sym_new] = ACTIONS(1944),
    [anon_sym_using] = ACTIONS(1944),
    [anon_sym_PLUS] = ACTIONS(1944),
    [anon_sym_DASH] = ACTIONS(1944),
    [anon_sym_SLASH] = ACTIONS(1944),
    [anon_sym_LT] = ACTIONS(1944),
    [anon_sym_TILDE] = ACTIONS(1946),
    [anon_sym_void] = ACTIONS(1944),
    [anon_sym_delete] = ACTIONS(1944),
    [anon_sym_PLUS_PLUS] = ACTIONS(1946),
    [anon_sym_DASH_DASH] = ACTIONS(1946),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1946),
    [sym_number] = ACTIONS(1946),
    [sym_private_property_identifier] = ACTIONS(1946),
    [sym_this] = ACTIONS(1944),
    [sym_super] = ACTIONS(1944),
    [sym_true] = ACTIONS(1944),
    [sym_false] = ACTIONS(1944),
    [sym_null] = ACTIONS(1944),
    [sym_undefined] = ACTIONS(1944),
    [anon_sym_AT] = ACTIONS(1946),
    [anon_sym_static] = ACTIONS(1944),
    [anon_sym_readonly] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_override] = ACTIONS(1944),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_object] = ACTIONS(1944),
    [anon_sym_property] = ACTIONS(1944),
    [anon_sym_signal] = ACTIONS(1944),
    [anon_sym_on] = ACTIONS(1944),
    [anon_sym_required] = ACTIONS(1944),
    [anon_sym_component] = ACTIONS(1944),
    [anon_sym_abstract] = ACTIONS(1944),
    [anon_sym_interface] = ACTIONS(1944),
    [anon_sym_enum] = ACTIONS(1944),
    [sym_html_comment] = ACTIONS(5),
  },
  [774] = {
    [sym_comment] = STATE(774),
    [sym_identifier] = ACTIONS(2623),
    [anon_sym_export] = ACTIONS(2623),
    [anon_sym_default] = ACTIONS(2623),
    [anon_sym_type] = ACTIONS(2623),
    [anon_sym_namespace] = ACTIONS(2623),
    [anon_sym_LBRACE] = ACTIONS(2625),
    [anon_sym_RBRACE] = ACTIONS(2625),
    [anon_sym_typeof] = ACTIONS(2623),
    [anon_sym_import] = ACTIONS(2623),
    [anon_sym_from] = ACTIONS(2623),
    [anon_sym_with] = ACTIONS(2623),
    [anon_sym_var] = ACTIONS(2623),
    [anon_sym_let] = ACTIONS(2623),
    [anon_sym_const] = ACTIONS(2623),
    [anon_sym_BANG] = ACTIONS(2625),
    [anon_sym_else] = ACTIONS(2623),
    [anon_sym_if] = ACTIONS(2623),
    [anon_sym_switch] = ACTIONS(2623),
    [anon_sym_for] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_await] = ACTIONS(2623),
    [anon_sym_of] = ACTIONS(2623),
    [anon_sym_while] = ACTIONS(2623),
    [anon_sym_do] = ACTIONS(2623),
    [anon_sym_try] = ACTIONS(2623),
    [anon_sym_break] = ACTIONS(2623),
    [anon_sym_continue] = ACTIONS(2623),
    [anon_sym_debugger] = ACTIONS(2623),
    [anon_sym_return] = ACTIONS(2623),
    [anon_sym_throw] = ACTIONS(2623),
    [anon_sym_SEMI] = ACTIONS(2625),
    [anon_sym_case] = ACTIONS(2623),
    [anon_sym_finally] = ACTIONS(2623),
    [anon_sym_yield] = ACTIONS(2623),
    [anon_sym_LBRACK] = ACTIONS(2625),
    [anon_sym_LTtemplate_GT] = ACTIONS(2625),
    [anon_sym_DQUOTE] = ACTIONS(2625),
    [anon_sym_SQUOTE] = ACTIONS(2625),
    [anon_sym_class] = ACTIONS(2623),
    [anon_sym_async] = ACTIONS(2623),
    [anon_sym_function] = ACTIONS(2623),
    [anon_sym_new] = ACTIONS(2623),
    [anon_sym_using] = ACTIONS(2623),
    [anon_sym_PLUS] = ACTIONS(2623),
    [anon_sym_DASH] = ACTIONS(2623),
    [anon_sym_SLASH] = ACTIONS(2623),
    [anon_sym_LT] = ACTIONS(2623),
    [anon_sym_TILDE] = ACTIONS(2625),
    [anon_sym_void] = ACTIONS(2623),
    [anon_sym_delete] = ACTIONS(2623),
    [anon_sym_PLUS_PLUS] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(2625),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2625),
    [sym_number] = ACTIONS(2625),
    [sym_private_property_identifier] = ACTIONS(2625),
    [sym_this] = ACTIONS(2623),
    [sym_super] = ACTIONS(2623),
    [sym_true] = ACTIONS(2623),
    [sym_false] = ACTIONS(2623),
    [sym_null] = ACTIONS(2623),
    [sym_undefined] = ACTIONS(2623),
    [anon_sym_AT] = ACTIONS(2625),
    [anon_sym_static] = ACTIONS(2623),
    [anon_sym_readonly] = ACTIONS(2623),
    [anon_sym_get] = ACTIONS(2623),
    [anon_sym_set] = ACTIONS(2623),
    [anon_sym_declare] = ACTIONS(2623),
    [anon_sym_public] = ACTIONS(2623),
    [anon_sym_private] = ACTIONS(2623),
    [anon_sym_protected] = ACTIONS(2623),
    [anon_sym_override] = ACTIONS(2623),
    [anon_sym_module] = ACTIONS(2623),
    [anon_sym_any] = ACTIONS(2623),
    [anon_sym_number] = ACTIONS(2623),
    [anon_sym_boolean] = ACTIONS(2623),
    [anon_sym_string] = ACTIONS(2623),
    [anon_sym_symbol] = ACTIONS(2623),
    [anon_sym_object] = ACTIONS(2623),
    [anon_sym_property] = ACTIONS(2623),
    [anon_sym_signal] = ACTIONS(2623),
    [anon_sym_on] = ACTIONS(2623),
    [anon_sym_required] = ACTIONS(2623),
    [anon_sym_component] = ACTIONS(2623),
    [anon_sym_abstract] = ACTIONS(2623),
    [anon_sym_interface] = ACTIONS(2623),
    [anon_sym_enum] = ACTIONS(2623),
    [sym_html_comment] = ACTIONS(5),
  },
  [775] = {
    [sym_comment] = STATE(775),
    [sym_identifier] = ACTIONS(1902),
    [anon_sym_export] = ACTIONS(1902),
    [anon_sym_default] = ACTIONS(1902),
    [anon_sym_type] = ACTIONS(1902),
    [anon_sym_namespace] = ACTIONS(1902),
    [anon_sym_LBRACE] = ACTIONS(1904),
    [anon_sym_RBRACE] = ACTIONS(1904),
    [anon_sym_typeof] = ACTIONS(1902),
    [anon_sym_import] = ACTIONS(1902),
    [anon_sym_from] = ACTIONS(1902),
    [anon_sym_with] = ACTIONS(1902),
    [anon_sym_var] = ACTIONS(1902),
    [anon_sym_let] = ACTIONS(1902),
    [anon_sym_const] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1904),
    [anon_sym_else] = ACTIONS(1902),
    [anon_sym_if] = ACTIONS(1902),
    [anon_sym_switch] = ACTIONS(1902),
    [anon_sym_for] = ACTIONS(1902),
    [anon_sym_LPAREN] = ACTIONS(1904),
    [anon_sym_await] = ACTIONS(1902),
    [anon_sym_of] = ACTIONS(1902),
    [anon_sym_while] = ACTIONS(1902),
    [anon_sym_do] = ACTIONS(1902),
    [anon_sym_try] = ACTIONS(1902),
    [anon_sym_break] = ACTIONS(1902),
    [anon_sym_continue] = ACTIONS(1902),
    [anon_sym_debugger] = ACTIONS(1902),
    [anon_sym_return] = ACTIONS(1902),
    [anon_sym_throw] = ACTIONS(1902),
    [anon_sym_SEMI] = ACTIONS(1904),
    [anon_sym_case] = ACTIONS(1902),
    [anon_sym_yield] = ACTIONS(1902),
    [anon_sym_LBRACK] = ACTIONS(1904),
    [anon_sym_LTtemplate_GT] = ACTIONS(1904),
    [anon_sym_DQUOTE] = ACTIONS(1904),
    [anon_sym_SQUOTE] = ACTIONS(1904),
    [anon_sym_class] = ACTIONS(1902),
    [anon_sym_async] = ACTIONS(1902),
    [anon_sym_function] = ACTIONS(1902),
    [anon_sym_new] = ACTIONS(1902),
    [anon_sym_using] = ACTIONS(1902),
    [anon_sym_PLUS] = ACTIONS(1902),
    [anon_sym_DASH] = ACTIONS(1902),
    [anon_sym_SLASH] = ACTIONS(1902),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_TILDE] = ACTIONS(1904),
    [anon_sym_void] = ACTIONS(1902),
    [anon_sym_delete] = ACTIONS(1902),
    [anon_sym_PLUS_PLUS] = ACTIONS(1904),
    [anon_sym_DASH_DASH] = ACTIONS(1904),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [sym_number] = ACTIONS(1904),
    [sym_private_property_identifier] = ACTIONS(1904),
    [sym_this] = ACTIONS(1902),
    [sym_super] = ACTIONS(1902),
    [sym_true] = ACTIONS(1902),
    [sym_false] = ACTIONS(1902),
    [sym_null] = ACTIONS(1902),
    [sym_undefined] = ACTIONS(1902),
    [anon_sym_AT] = ACTIONS(1904),
    [anon_sym_static] = ACTIONS(1902),
    [anon_sym_readonly] = ACTIONS(1902),
    [anon_sym_get] = ACTIONS(1902),
    [anon_sym_set] = ACTIONS(1902),
    [anon_sym_declare] = ACTIONS(1902),
    [anon_sym_public] = ACTIONS(1902),
    [anon_sym_private] = ACTIONS(1902),
    [anon_sym_protected] = ACTIONS(1902),
    [anon_sym_override] = ACTIONS(1902),
    [anon_sym_module] = ACTIONS(1902),
    [anon_sym_any] = ACTIONS(1902),
    [anon_sym_number] = ACTIONS(1902),
    [anon_sym_boolean] = ACTIONS(1902),
    [anon_sym_string] = ACTIONS(1902),
    [anon_sym_symbol] = ACTIONS(1902),
    [anon_sym_object] = ACTIONS(1902),
    [anon_sym_property] = ACTIONS(1902),
    [anon_sym_signal] = ACTIONS(1902),
    [anon_sym_on] = ACTIONS(1902),
    [anon_sym_required] = ACTIONS(1902),
    [anon_sym_component] = ACTIONS(1902),
    [anon_sym_abstract] = ACTIONS(1902),
    [anon_sym_interface] = ACTIONS(1902),
    [anon_sym_enum] = ACTIONS(1902),
    [sym__automatic_semicolon] = ACTIONS(1904),
    [sym_html_comment] = ACTIONS(5),
  },
  [776] = {
    [sym_comment] = STATE(776),
    [sym_identifier] = ACTIONS(1862),
    [anon_sym_export] = ACTIONS(1862),
    [anon_sym_default] = ACTIONS(1862),
    [anon_sym_type] = ACTIONS(1862),
    [anon_sym_namespace] = ACTIONS(1862),
    [anon_sym_LBRACE] = ACTIONS(1866),
    [anon_sym_RBRACE] = ACTIONS(1866),
    [anon_sym_typeof] = ACTIONS(1862),
    [anon_sym_import] = ACTIONS(1862),
    [anon_sym_from] = ACTIONS(1862),
    [anon_sym_with] = ACTIONS(1862),
    [anon_sym_var] = ACTIONS(1862),
    [anon_sym_let] = ACTIONS(1862),
    [anon_sym_const] = ACTIONS(1862),
    [anon_sym_BANG] = ACTIONS(1866),
    [anon_sym_else] = ACTIONS(1862),
    [anon_sym_if] = ACTIONS(1862),
    [anon_sym_switch] = ACTIONS(1862),
    [anon_sym_for] = ACTIONS(1862),
    [anon_sym_LPAREN] = ACTIONS(1866),
    [anon_sym_await] = ACTIONS(1862),
    [anon_sym_of] = ACTIONS(1862),
    [anon_sym_while] = ACTIONS(1862),
    [anon_sym_do] = ACTIONS(1862),
    [anon_sym_try] = ACTIONS(1862),
    [anon_sym_break] = ACTIONS(1862),
    [anon_sym_continue] = ACTIONS(1862),
    [anon_sym_debugger] = ACTIONS(1862),
    [anon_sym_return] = ACTIONS(1862),
    [anon_sym_throw] = ACTIONS(1862),
    [anon_sym_SEMI] = ACTIONS(1866),
    [anon_sym_case] = ACTIONS(1862),
    [anon_sym_yield] = ACTIONS(1862),
    [anon_sym_LBRACK] = ACTIONS(1866),
    [anon_sym_LTtemplate_GT] = ACTIONS(1866),
    [anon_sym_DQUOTE] = ACTIONS(1866),
    [anon_sym_SQUOTE] = ACTIONS(1866),
    [anon_sym_class] = ACTIONS(1862),
    [anon_sym_async] = ACTIONS(1862),
    [anon_sym_function] = ACTIONS(1862),
    [anon_sym_new] = ACTIONS(1862),
    [anon_sym_using] = ACTIONS(1862),
    [anon_sym_PLUS] = ACTIONS(1862),
    [anon_sym_DASH] = ACTIONS(1862),
    [anon_sym_SLASH] = ACTIONS(1862),
    [anon_sym_LT] = ACTIONS(1862),
    [anon_sym_TILDE] = ACTIONS(1866),
    [anon_sym_void] = ACTIONS(1862),
    [anon_sym_delete] = ACTIONS(1862),
    [anon_sym_PLUS_PLUS] = ACTIONS(1866),
    [anon_sym_DASH_DASH] = ACTIONS(1866),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1866),
    [sym_number] = ACTIONS(1866),
    [sym_private_property_identifier] = ACTIONS(1866),
    [sym_this] = ACTIONS(1862),
    [sym_super] = ACTIONS(1862),
    [sym_true] = ACTIONS(1862),
    [sym_false] = ACTIONS(1862),
    [sym_null] = ACTIONS(1862),
    [sym_undefined] = ACTIONS(1862),
    [anon_sym_AT] = ACTIONS(1866),
    [anon_sym_static] = ACTIONS(1862),
    [anon_sym_readonly] = ACTIONS(1862),
    [anon_sym_get] = ACTIONS(1862),
    [anon_sym_set] = ACTIONS(1862),
    [anon_sym_declare] = ACTIONS(1862),
    [anon_sym_public] = ACTIONS(1862),
    [anon_sym_private] = ACTIONS(1862),
    [anon_sym_protected] = ACTIONS(1862),
    [anon_sym_override] = ACTIONS(1862),
    [anon_sym_module] = ACTIONS(1862),
    [anon_sym_any] = ACTIONS(1862),
    [anon_sym_number] = ACTIONS(1862),
    [anon_sym_boolean] = ACTIONS(1862),
    [anon_sym_string] = ACTIONS(1862),
    [anon_sym_symbol] = ACTIONS(1862),
    [anon_sym_object] = ACTIONS(1862),
    [anon_sym_property] = ACTIONS(1862),
    [anon_sym_signal] = ACTIONS(1862),
    [anon_sym_on] = ACTIONS(1862),
    [anon_sym_required] = ACTIONS(1862),
    [anon_sym_component] = ACTIONS(1862),
    [anon_sym_abstract] = ACTIONS(1862),
    [anon_sym_interface] = ACTIONS(1862),
    [anon_sym_enum] = ACTIONS(1862),
    [sym__automatic_semicolon] = ACTIONS(1870),
    [sym_html_comment] = ACTIONS(5),
  },
  [777] = {
    [sym_comment] = STATE(777),
    [sym_identifier] = ACTIONS(1792),
    [anon_sym_export] = ACTIONS(1792),
    [anon_sym_default] = ACTIONS(1792),
    [anon_sym_type] = ACTIONS(1792),
    [anon_sym_namespace] = ACTIONS(1792),
    [anon_sym_LBRACE] = ACTIONS(1798),
    [anon_sym_RBRACE] = ACTIONS(1798),
    [anon_sym_typeof] = ACTIONS(1792),
    [anon_sym_import] = ACTIONS(1792),
    [anon_sym_from] = ACTIONS(1792),
    [anon_sym_with] = ACTIONS(1792),
    [anon_sym_var] = ACTIONS(1792),
    [anon_sym_let] = ACTIONS(1792),
    [anon_sym_const] = ACTIONS(1792),
    [anon_sym_BANG] = ACTIONS(1798),
    [anon_sym_else] = ACTIONS(1792),
    [anon_sym_if] = ACTIONS(1792),
    [anon_sym_switch] = ACTIONS(1792),
    [anon_sym_for] = ACTIONS(1792),
    [anon_sym_LPAREN] = ACTIONS(1798),
    [anon_sym_await] = ACTIONS(1792),
    [anon_sym_of] = ACTIONS(1792),
    [anon_sym_while] = ACTIONS(1792),
    [anon_sym_do] = ACTIONS(1792),
    [anon_sym_try] = ACTIONS(1792),
    [anon_sym_break] = ACTIONS(1792),
    [anon_sym_continue] = ACTIONS(1792),
    [anon_sym_debugger] = ACTIONS(1792),
    [anon_sym_return] = ACTIONS(1792),
    [anon_sym_throw] = ACTIONS(1792),
    [anon_sym_SEMI] = ACTIONS(1798),
    [anon_sym_case] = ACTIONS(1792),
    [anon_sym_yield] = ACTIONS(1792),
    [anon_sym_LBRACK] = ACTIONS(1798),
    [anon_sym_LTtemplate_GT] = ACTIONS(1798),
    [anon_sym_DQUOTE] = ACTIONS(1798),
    [anon_sym_SQUOTE] = ACTIONS(1798),
    [anon_sym_class] = ACTIONS(1792),
    [anon_sym_async] = ACTIONS(1792),
    [anon_sym_function] = ACTIONS(1792),
    [anon_sym_new] = ACTIONS(1792),
    [anon_sym_using] = ACTIONS(1792),
    [anon_sym_PLUS] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(1792),
    [anon_sym_SLASH] = ACTIONS(1792),
    [anon_sym_LT] = ACTIONS(1792),
    [anon_sym_TILDE] = ACTIONS(1798),
    [anon_sym_void] = ACTIONS(1792),
    [anon_sym_delete] = ACTIONS(1792),
    [anon_sym_PLUS_PLUS] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1798),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1798),
    [sym_number] = ACTIONS(1798),
    [sym_private_property_identifier] = ACTIONS(1798),
    [sym_this] = ACTIONS(1792),
    [sym_super] = ACTIONS(1792),
    [sym_true] = ACTIONS(1792),
    [sym_false] = ACTIONS(1792),
    [sym_null] = ACTIONS(1792),
    [sym_undefined] = ACTIONS(1792),
    [anon_sym_AT] = ACTIONS(1798),
    [anon_sym_static] = ACTIONS(1792),
    [anon_sym_readonly] = ACTIONS(1792),
    [anon_sym_get] = ACTIONS(1792),
    [anon_sym_set] = ACTIONS(1792),
    [anon_sym_declare] = ACTIONS(1792),
    [anon_sym_public] = ACTIONS(1792),
    [anon_sym_private] = ACTIONS(1792),
    [anon_sym_protected] = ACTIONS(1792),
    [anon_sym_override] = ACTIONS(1792),
    [anon_sym_module] = ACTIONS(1792),
    [anon_sym_any] = ACTIONS(1792),
    [anon_sym_number] = ACTIONS(1792),
    [anon_sym_boolean] = ACTIONS(1792),
    [anon_sym_string] = ACTIONS(1792),
    [anon_sym_symbol] = ACTIONS(1792),
    [anon_sym_object] = ACTIONS(1792),
    [anon_sym_property] = ACTIONS(1792),
    [anon_sym_signal] = ACTIONS(1792),
    [anon_sym_on] = ACTIONS(1792),
    [anon_sym_required] = ACTIONS(1792),
    [anon_sym_component] = ACTIONS(1792),
    [anon_sym_abstract] = ACTIONS(1792),
    [anon_sym_interface] = ACTIONS(1792),
    [anon_sym_enum] = ACTIONS(1792),
    [sym__automatic_semicolon] = ACTIONS(2627),
    [sym_html_comment] = ACTIONS(5),
  },
  [778] = {
    [sym_comment] = STATE(778),
    [sym_identifier] = ACTIONS(1972),
    [anon_sym_export] = ACTIONS(1972),
    [anon_sym_default] = ACTIONS(1972),
    [anon_sym_type] = ACTIONS(1972),
    [anon_sym_namespace] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1976),
    [anon_sym_RBRACE] = ACTIONS(1976),
    [anon_sym_typeof] = ACTIONS(1972),
    [anon_sym_import] = ACTIONS(1972),
    [anon_sym_from] = ACTIONS(1972),
    [anon_sym_with] = ACTIONS(1972),
    [anon_sym_var] = ACTIONS(1972),
    [anon_sym_let] = ACTIONS(1972),
    [anon_sym_const] = ACTIONS(1972),
    [anon_sym_BANG] = ACTIONS(1976),
    [anon_sym_else] = ACTIONS(1972),
    [anon_sym_if] = ACTIONS(1972),
    [anon_sym_switch] = ACTIONS(1972),
    [anon_sym_for] = ACTIONS(1972),
    [anon_sym_LPAREN] = ACTIONS(1976),
    [anon_sym_await] = ACTIONS(1972),
    [anon_sym_of] = ACTIONS(1972),
    [anon_sym_while] = ACTIONS(1972),
    [anon_sym_do] = ACTIONS(1972),
    [anon_sym_try] = ACTIONS(1972),
    [anon_sym_break] = ACTIONS(1972),
    [anon_sym_continue] = ACTIONS(1972),
    [anon_sym_debugger] = ACTIONS(1972),
    [anon_sym_return] = ACTIONS(1972),
    [anon_sym_throw] = ACTIONS(1972),
    [anon_sym_SEMI] = ACTIONS(1976),
    [anon_sym_case] = ACTIONS(1972),
    [anon_sym_yield] = ACTIONS(1972),
    [anon_sym_LBRACK] = ACTIONS(1976),
    [anon_sym_LTtemplate_GT] = ACTIONS(1976),
    [anon_sym_DQUOTE] = ACTIONS(1976),
    [anon_sym_SQUOTE] = ACTIONS(1976),
    [anon_sym_class] = ACTIONS(1972),
    [anon_sym_async] = ACTIONS(1972),
    [anon_sym_function] = ACTIONS(1972),
    [anon_sym_new] = ACTIONS(1972),
    [anon_sym_using] = ACTIONS(1972),
    [anon_sym_PLUS] = ACTIONS(1972),
    [anon_sym_DASH] = ACTIONS(1972),
    [anon_sym_SLASH] = ACTIONS(1972),
    [anon_sym_LT] = ACTIONS(1972),
    [anon_sym_TILDE] = ACTIONS(1976),
    [anon_sym_void] = ACTIONS(1972),
    [anon_sym_delete] = ACTIONS(1972),
    [anon_sym_PLUS_PLUS] = ACTIONS(1976),
    [anon_sym_DASH_DASH] = ACTIONS(1976),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1976),
    [sym_number] = ACTIONS(1976),
    [sym_private_property_identifier] = ACTIONS(1976),
    [sym_this] = ACTIONS(1972),
    [sym_super] = ACTIONS(1972),
    [sym_true] = ACTIONS(1972),
    [sym_false] = ACTIONS(1972),
    [sym_null] = ACTIONS(1972),
    [sym_undefined] = ACTIONS(1972),
    [anon_sym_AT] = ACTIONS(1976),
    [anon_sym_static] = ACTIONS(1972),
    [anon_sym_readonly] = ACTIONS(1972),
    [anon_sym_get] = ACTIONS(1972),
    [anon_sym_set] = ACTIONS(1972),
    [anon_sym_declare] = ACTIONS(1972),
    [anon_sym_public] = ACTIONS(1972),
    [anon_sym_private] = ACTIONS(1972),
    [anon_sym_protected] = ACTIONS(1972),
    [anon_sym_override] = ACTIONS(1972),
    [anon_sym_module] = ACTIONS(1972),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_boolean] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_object] = ACTIONS(1972),
    [anon_sym_property] = ACTIONS(1972),
    [anon_sym_signal] = ACTIONS(1972),
    [anon_sym_on] = ACTIONS(1972),
    [anon_sym_required] = ACTIONS(1972),
    [anon_sym_component] = ACTIONS(1972),
    [anon_sym_abstract] = ACTIONS(1972),
    [anon_sym_interface] = ACTIONS(1972),
    [anon_sym_enum] = ACTIONS(1972),
    [sym__automatic_semicolon] = ACTIONS(1980),
    [sym_html_comment] = ACTIONS(5),
  },
  [779] = {
    [sym_comment] = STATE(779),
    [sym_identifier] = ACTIONS(1854),
    [anon_sym_export] = ACTIONS(1854),
    [anon_sym_default] = ACTIONS(1854),
    [anon_sym_type] = ACTIONS(1854),
    [anon_sym_namespace] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(1856),
    [anon_sym_RBRACE] = ACTIONS(1856),
    [anon_sym_typeof] = ACTIONS(1854),
    [anon_sym_import] = ACTIONS(1854),
    [anon_sym_from] = ACTIONS(1854),
    [anon_sym_with] = ACTIONS(1854),
    [anon_sym_var] = ACTIONS(1854),
    [anon_sym_let] = ACTIONS(1854),
    [anon_sym_const] = ACTIONS(1854),
    [anon_sym_BANG] = ACTIONS(1856),
    [anon_sym_else] = ACTIONS(1854),
    [anon_sym_if] = ACTIONS(1854),
    [anon_sym_switch] = ACTIONS(1854),
    [anon_sym_for] = ACTIONS(1854),
    [anon_sym_LPAREN] = ACTIONS(1856),
    [anon_sym_await] = ACTIONS(1854),
    [anon_sym_of] = ACTIONS(1854),
    [anon_sym_while] = ACTIONS(1854),
    [anon_sym_do] = ACTIONS(1854),
    [anon_sym_try] = ACTIONS(1854),
    [anon_sym_break] = ACTIONS(1854),
    [anon_sym_continue] = ACTIONS(1854),
    [anon_sym_debugger] = ACTIONS(1854),
    [anon_sym_return] = ACTIONS(1854),
    [anon_sym_throw] = ACTIONS(1854),
    [anon_sym_SEMI] = ACTIONS(1856),
    [anon_sym_case] = ACTIONS(1854),
    [anon_sym_yield] = ACTIONS(1854),
    [anon_sym_LBRACK] = ACTIONS(1856),
    [anon_sym_LTtemplate_GT] = ACTIONS(1856),
    [anon_sym_DQUOTE] = ACTIONS(1856),
    [anon_sym_SQUOTE] = ACTIONS(1856),
    [anon_sym_class] = ACTIONS(1854),
    [anon_sym_async] = ACTIONS(1854),
    [anon_sym_function] = ACTIONS(1854),
    [anon_sym_new] = ACTIONS(1854),
    [anon_sym_using] = ACTIONS(1854),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_DASH] = ACTIONS(1854),
    [anon_sym_SLASH] = ACTIONS(1854),
    [anon_sym_LT] = ACTIONS(1854),
    [anon_sym_TILDE] = ACTIONS(1856),
    [anon_sym_void] = ACTIONS(1854),
    [anon_sym_delete] = ACTIONS(1854),
    [anon_sym_PLUS_PLUS] = ACTIONS(1856),
    [anon_sym_DASH_DASH] = ACTIONS(1856),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1856),
    [sym_number] = ACTIONS(1856),
    [sym_private_property_identifier] = ACTIONS(1856),
    [sym_this] = ACTIONS(1854),
    [sym_super] = ACTIONS(1854),
    [sym_true] = ACTIONS(1854),
    [sym_false] = ACTIONS(1854),
    [sym_null] = ACTIONS(1854),
    [sym_undefined] = ACTIONS(1854),
    [anon_sym_AT] = ACTIONS(1856),
    [anon_sym_static] = ACTIONS(1854),
    [anon_sym_readonly] = ACTIONS(1854),
    [anon_sym_get] = ACTIONS(1854),
    [anon_sym_set] = ACTIONS(1854),
    [anon_sym_declare] = ACTIONS(1854),
    [anon_sym_public] = ACTIONS(1854),
    [anon_sym_private] = ACTIONS(1854),
    [anon_sym_protected] = ACTIONS(1854),
    [anon_sym_override] = ACTIONS(1854),
    [anon_sym_module] = ACTIONS(1854),
    [anon_sym_any] = ACTIONS(1854),
    [anon_sym_number] = ACTIONS(1854),
    [anon_sym_boolean] = ACTIONS(1854),
    [anon_sym_string] = ACTIONS(1854),
    [anon_sym_symbol] = ACTIONS(1854),
    [anon_sym_object] = ACTIONS(1854),
    [anon_sym_property] = ACTIONS(1854),
    [anon_sym_signal] = ACTIONS(1854),
    [anon_sym_on] = ACTIONS(1854),
    [anon_sym_required] = ACTIONS(1854),
    [anon_sym_component] = ACTIONS(1854),
    [anon_sym_abstract] = ACTIONS(1854),
    [anon_sym_interface] = ACTIONS(1854),
    [anon_sym_enum] = ACTIONS(1854),
    [sym__automatic_semicolon] = ACTIONS(2629),
    [sym_html_comment] = ACTIONS(5),
  },
  [780] = {
    [sym_comment] = STATE(780),
    [sym_identifier] = ACTIONS(1992),
    [anon_sym_export] = ACTIONS(1992),
    [anon_sym_default] = ACTIONS(1992),
    [anon_sym_type] = ACTIONS(1992),
    [anon_sym_namespace] = ACTIONS(1992),
    [anon_sym_LBRACE] = ACTIONS(1996),
    [anon_sym_RBRACE] = ACTIONS(1996),
    [anon_sym_typeof] = ACTIONS(1992),
    [anon_sym_import] = ACTIONS(1992),
    [anon_sym_from] = ACTIONS(1992),
    [anon_sym_with] = ACTIONS(1992),
    [anon_sym_var] = ACTIONS(1992),
    [anon_sym_let] = ACTIONS(1992),
    [anon_sym_const] = ACTIONS(1992),
    [anon_sym_BANG] = ACTIONS(1996),
    [anon_sym_else] = ACTIONS(1992),
    [anon_sym_if] = ACTIONS(1992),
    [anon_sym_switch] = ACTIONS(1992),
    [anon_sym_for] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1996),
    [anon_sym_await] = ACTIONS(1992),
    [anon_sym_of] = ACTIONS(1992),
    [anon_sym_while] = ACTIONS(1992),
    [anon_sym_do] = ACTIONS(1992),
    [anon_sym_try] = ACTIONS(1992),
    [anon_sym_break] = ACTIONS(1992),
    [anon_sym_continue] = ACTIONS(1992),
    [anon_sym_debugger] = ACTIONS(1992),
    [anon_sym_return] = ACTIONS(1992),
    [anon_sym_throw] = ACTIONS(1992),
    [anon_sym_SEMI] = ACTIONS(1996),
    [anon_sym_case] = ACTIONS(1992),
    [anon_sym_yield] = ACTIONS(1992),
    [anon_sym_LBRACK] = ACTIONS(1996),
    [anon_sym_LTtemplate_GT] = ACTIONS(1996),
    [anon_sym_DQUOTE] = ACTIONS(1996),
    [anon_sym_SQUOTE] = ACTIONS(1996),
    [anon_sym_class] = ACTIONS(1992),
    [anon_sym_async] = ACTIONS(1992),
    [anon_sym_function] = ACTIONS(1992),
    [anon_sym_new] = ACTIONS(1992),
    [anon_sym_using] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_SLASH] = ACTIONS(1992),
    [anon_sym_LT] = ACTIONS(1992),
    [anon_sym_TILDE] = ACTIONS(1996),
    [anon_sym_void] = ACTIONS(1992),
    [anon_sym_delete] = ACTIONS(1992),
    [anon_sym_PLUS_PLUS] = ACTIONS(1996),
    [anon_sym_DASH_DASH] = ACTIONS(1996),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1996),
    [sym_number] = ACTIONS(1996),
    [sym_private_property_identifier] = ACTIONS(1996),
    [sym_this] = ACTIONS(1992),
    [sym_super] = ACTIONS(1992),
    [sym_true] = ACTIONS(1992),
    [sym_false] = ACTIONS(1992),
    [sym_null] = ACTIONS(1992),
    [sym_undefined] = ACTIONS(1992),
    [anon_sym_AT] = ACTIONS(1996),
    [anon_sym_static] = ACTIONS(1992),
    [anon_sym_readonly] = ACTIONS(1992),
    [anon_sym_get] = ACTIONS(1992),
    [anon_sym_set] = ACTIONS(1992),
    [anon_sym_declare] = ACTIONS(1992),
    [anon_sym_public] = ACTIONS(1992),
    [anon_sym_private] = ACTIONS(1992),
    [anon_sym_protected] = ACTIONS(1992),
    [anon_sym_override] = ACTIONS(1992),
    [anon_sym_module] = ACTIONS(1992),
    [anon_sym_any] = ACTIONS(1992),
    [anon_sym_number] = ACTIONS(1992),
    [anon_sym_boolean] = ACTIONS(1992),
    [anon_sym_string] = ACTIONS(1992),
    [anon_sym_symbol] = ACTIONS(1992),
    [anon_sym_object] = ACTIONS(1992),
    [anon_sym_property] = ACTIONS(1992),
    [anon_sym_signal] = ACTIONS(1992),
    [anon_sym_on] = ACTIONS(1992),
    [anon_sym_required] = ACTIONS(1992),
    [anon_sym_component] = ACTIONS(1992),
    [anon_sym_abstract] = ACTIONS(1992),
    [anon_sym_interface] = ACTIONS(1992),
    [anon_sym_enum] = ACTIONS(1992),
    [sym__automatic_semicolon] = ACTIONS(2000),
    [sym_html_comment] = ACTIONS(5),
  },
  [781] = {
    [sym_comment] = STATE(781),
    [sym_identifier] = ACTIONS(1906),
    [anon_sym_export] = ACTIONS(1906),
    [anon_sym_default] = ACTIONS(1906),
    [anon_sym_type] = ACTIONS(1906),
    [anon_sym_namespace] = ACTIONS(1906),
    [anon_sym_LBRACE] = ACTIONS(1910),
    [anon_sym_RBRACE] = ACTIONS(1910),
    [anon_sym_typeof] = ACTIONS(1906),
    [anon_sym_import] = ACTIONS(1906),
    [anon_sym_from] = ACTIONS(1906),
    [anon_sym_with] = ACTIONS(1906),
    [anon_sym_var] = ACTIONS(1906),
    [anon_sym_let] = ACTIONS(1906),
    [anon_sym_const] = ACTIONS(1906),
    [anon_sym_BANG] = ACTIONS(1910),
    [anon_sym_else] = ACTIONS(1906),
    [anon_sym_if] = ACTIONS(1906),
    [anon_sym_switch] = ACTIONS(1906),
    [anon_sym_for] = ACTIONS(1906),
    [anon_sym_LPAREN] = ACTIONS(1910),
    [anon_sym_await] = ACTIONS(1906),
    [anon_sym_of] = ACTIONS(1906),
    [anon_sym_while] = ACTIONS(1906),
    [anon_sym_do] = ACTIONS(1906),
    [anon_sym_try] = ACTIONS(1906),
    [anon_sym_break] = ACTIONS(1906),
    [anon_sym_continue] = ACTIONS(1906),
    [anon_sym_debugger] = ACTIONS(1906),
    [anon_sym_return] = ACTIONS(1906),
    [anon_sym_throw] = ACTIONS(1906),
    [anon_sym_SEMI] = ACTIONS(1910),
    [anon_sym_case] = ACTIONS(1906),
    [anon_sym_yield] = ACTIONS(1906),
    [anon_sym_LBRACK] = ACTIONS(1910),
    [anon_sym_LTtemplate_GT] = ACTIONS(1910),
    [anon_sym_DQUOTE] = ACTIONS(1910),
    [anon_sym_SQUOTE] = ACTIONS(1910),
    [anon_sym_class] = ACTIONS(1906),
    [anon_sym_async] = ACTIONS(1906),
    [anon_sym_function] = ACTIONS(1906),
    [anon_sym_new] = ACTIONS(1906),
    [anon_sym_using] = ACTIONS(1906),
    [anon_sym_PLUS] = ACTIONS(1906),
    [anon_sym_DASH] = ACTIONS(1906),
    [anon_sym_SLASH] = ACTIONS(1906),
    [anon_sym_LT] = ACTIONS(1906),
    [anon_sym_TILDE] = ACTIONS(1910),
    [anon_sym_void] = ACTIONS(1906),
    [anon_sym_delete] = ACTIONS(1906),
    [anon_sym_PLUS_PLUS] = ACTIONS(1910),
    [anon_sym_DASH_DASH] = ACTIONS(1910),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1910),
    [sym_number] = ACTIONS(1910),
    [sym_private_property_identifier] = ACTIONS(1910),
    [sym_this] = ACTIONS(1906),
    [sym_super] = ACTIONS(1906),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_AT] = ACTIONS(1910),
    [anon_sym_static] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1906),
    [anon_sym_get] = ACTIONS(1906),
    [anon_sym_set] = ACTIONS(1906),
    [anon_sym_declare] = ACTIONS(1906),
    [anon_sym_public] = ACTIONS(1906),
    [anon_sym_private] = ACTIONS(1906),
    [anon_sym_protected] = ACTIONS(1906),
    [anon_sym_override] = ACTIONS(1906),
    [anon_sym_module] = ACTIONS(1906),
    [anon_sym_any] = ACTIONS(1906),
    [anon_sym_number] = ACTIONS(1906),
    [anon_sym_boolean] = ACTIONS(1906),
    [anon_sym_string] = ACTIONS(1906),
    [anon_sym_symbol] = ACTIONS(1906),
    [anon_sym_object] = ACTIONS(1906),
    [anon_sym_property] = ACTIONS(1906),
    [anon_sym_signal] = ACTIONS(1906),
    [anon_sym_on] = ACTIONS(1906),
    [anon_sym_required] = ACTIONS(1906),
    [anon_sym_component] = ACTIONS(1906),
    [anon_sym_abstract] = ACTIONS(1906),
    [anon_sym_interface] = ACTIONS(1906),
    [anon_sym_enum] = ACTIONS(1906),
    [sym__automatic_semicolon] = ACTIONS(1914),
    [sym_html_comment] = ACTIONS(5),
  },
  [782] = {
    [sym_comment] = STATE(782),
    [sym_identifier] = ACTIONS(2631),
    [anon_sym_export] = ACTIONS(2631),
    [anon_sym_default] = ACTIONS(2631),
    [anon_sym_type] = ACTIONS(2631),
    [anon_sym_namespace] = ACTIONS(2631),
    [anon_sym_LBRACE] = ACTIONS(2633),
    [anon_sym_RBRACE] = ACTIONS(2633),
    [anon_sym_typeof] = ACTIONS(2631),
    [anon_sym_import] = ACTIONS(2631),
    [anon_sym_from] = ACTIONS(2631),
    [anon_sym_with] = ACTIONS(2631),
    [anon_sym_var] = ACTIONS(2631),
    [anon_sym_let] = ACTIONS(2631),
    [anon_sym_const] = ACTIONS(2631),
    [anon_sym_BANG] = ACTIONS(2633),
    [anon_sym_else] = ACTIONS(2631),
    [anon_sym_if] = ACTIONS(2631),
    [anon_sym_switch] = ACTIONS(2631),
    [anon_sym_for] = ACTIONS(2631),
    [anon_sym_LPAREN] = ACTIONS(2633),
    [anon_sym_await] = ACTIONS(2631),
    [anon_sym_of] = ACTIONS(2631),
    [anon_sym_while] = ACTIONS(2631),
    [anon_sym_do] = ACTIONS(2631),
    [anon_sym_try] = ACTIONS(2631),
    [anon_sym_break] = ACTIONS(2631),
    [anon_sym_continue] = ACTIONS(2631),
    [anon_sym_debugger] = ACTIONS(2631),
    [anon_sym_return] = ACTIONS(2631),
    [anon_sym_throw] = ACTIONS(2631),
    [anon_sym_SEMI] = ACTIONS(2635),
    [anon_sym_case] = ACTIONS(2631),
    [anon_sym_yield] = ACTIONS(2631),
    [anon_sym_LBRACK] = ACTIONS(2633),
    [anon_sym_LTtemplate_GT] = ACTIONS(2633),
    [anon_sym_DQUOTE] = ACTIONS(2633),
    [anon_sym_SQUOTE] = ACTIONS(2633),
    [anon_sym_class] = ACTIONS(2631),
    [anon_sym_async] = ACTIONS(2631),
    [anon_sym_function] = ACTIONS(2631),
    [anon_sym_new] = ACTIONS(2631),
    [anon_sym_using] = ACTIONS(2631),
    [anon_sym_PLUS] = ACTIONS(2631),
    [anon_sym_DASH] = ACTIONS(2631),
    [anon_sym_SLASH] = ACTIONS(2631),
    [anon_sym_LT] = ACTIONS(2631),
    [anon_sym_TILDE] = ACTIONS(2633),
    [anon_sym_void] = ACTIONS(2631),
    [anon_sym_delete] = ACTIONS(2631),
    [anon_sym_PLUS_PLUS] = ACTIONS(2633),
    [anon_sym_DASH_DASH] = ACTIONS(2633),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2633),
    [sym_number] = ACTIONS(2633),
    [sym_private_property_identifier] = ACTIONS(2633),
    [sym_this] = ACTIONS(2631),
    [sym_super] = ACTIONS(2631),
    [sym_true] = ACTIONS(2631),
    [sym_false] = ACTIONS(2631),
    [sym_null] = ACTIONS(2631),
    [sym_undefined] = ACTIONS(2631),
    [anon_sym_AT] = ACTIONS(2633),
    [anon_sym_static] = ACTIONS(2631),
    [anon_sym_readonly] = ACTIONS(2631),
    [anon_sym_get] = ACTIONS(2631),
    [anon_sym_set] = ACTIONS(2631),
    [anon_sym_declare] = ACTIONS(2631),
    [anon_sym_public] = ACTIONS(2631),
    [anon_sym_private] = ACTIONS(2631),
    [anon_sym_protected] = ACTIONS(2631),
    [anon_sym_override] = ACTIONS(2631),
    [anon_sym_module] = ACTIONS(2631),
    [anon_sym_any] = ACTIONS(2631),
    [anon_sym_number] = ACTIONS(2631),
    [anon_sym_boolean] = ACTIONS(2631),
    [anon_sym_string] = ACTIONS(2631),
    [anon_sym_symbol] = ACTIONS(2631),
    [anon_sym_object] = ACTIONS(2631),
    [anon_sym_property] = ACTIONS(2631),
    [anon_sym_signal] = ACTIONS(2631),
    [anon_sym_on] = ACTIONS(2631),
    [anon_sym_required] = ACTIONS(2631),
    [anon_sym_component] = ACTIONS(2631),
    [anon_sym_abstract] = ACTIONS(2631),
    [anon_sym_interface] = ACTIONS(2631),
    [anon_sym_enum] = ACTIONS(2631),
    [sym__automatic_semicolon] = ACTIONS(2635),
    [sym_html_comment] = ACTIONS(5),
  },
  [783] = {
    [sym_comment] = STATE(783),
    [sym_identifier] = ACTIONS(1948),
    [anon_sym_export] = ACTIONS(1948),
    [anon_sym_default] = ACTIONS(1948),
    [anon_sym_type] = ACTIONS(1948),
    [anon_sym_namespace] = ACTIONS(1948),
    [anon_sym_LBRACE] = ACTIONS(1952),
    [anon_sym_RBRACE] = ACTIONS(1952),
    [anon_sym_typeof] = ACTIONS(1948),
    [anon_sym_import] = ACTIONS(1948),
    [anon_sym_from] = ACTIONS(1948),
    [anon_sym_with] = ACTIONS(1948),
    [anon_sym_var] = ACTIONS(1948),
    [anon_sym_let] = ACTIONS(1948),
    [anon_sym_const] = ACTIONS(1948),
    [anon_sym_BANG] = ACTIONS(1952),
    [anon_sym_else] = ACTIONS(1948),
    [anon_sym_if] = ACTIONS(1948),
    [anon_sym_switch] = ACTIONS(1948),
    [anon_sym_for] = ACTIONS(1948),
    [anon_sym_LPAREN] = ACTIONS(1952),
    [anon_sym_await] = ACTIONS(1948),
    [anon_sym_of] = ACTIONS(1948),
    [anon_sym_while] = ACTIONS(1948),
    [anon_sym_do] = ACTIONS(1948),
    [anon_sym_try] = ACTIONS(1948),
    [anon_sym_break] = ACTIONS(1948),
    [anon_sym_continue] = ACTIONS(1948),
    [anon_sym_debugger] = ACTIONS(1948),
    [anon_sym_return] = ACTIONS(1948),
    [anon_sym_throw] = ACTIONS(1948),
    [anon_sym_SEMI] = ACTIONS(1952),
    [anon_sym_case] = ACTIONS(1948),
    [anon_sym_yield] = ACTIONS(1948),
    [anon_sym_LBRACK] = ACTIONS(1952),
    [anon_sym_LTtemplate_GT] = ACTIONS(1952),
    [anon_sym_DQUOTE] = ACTIONS(1952),
    [anon_sym_SQUOTE] = ACTIONS(1952),
    [anon_sym_class] = ACTIONS(1948),
    [anon_sym_async] = ACTIONS(1948),
    [anon_sym_function] = ACTIONS(1948),
    [anon_sym_new] = ACTIONS(1948),
    [anon_sym_using] = ACTIONS(1948),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_DASH] = ACTIONS(1948),
    [anon_sym_SLASH] = ACTIONS(1948),
    [anon_sym_LT] = ACTIONS(1948),
    [anon_sym_TILDE] = ACTIONS(1952),
    [anon_sym_void] = ACTIONS(1948),
    [anon_sym_delete] = ACTIONS(1948),
    [anon_sym_PLUS_PLUS] = ACTIONS(1952),
    [anon_sym_DASH_DASH] = ACTIONS(1952),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1952),
    [sym_number] = ACTIONS(1952),
    [sym_private_property_identifier] = ACTIONS(1952),
    [sym_this] = ACTIONS(1948),
    [sym_super] = ACTIONS(1948),
    [sym_true] = ACTIONS(1948),
    [sym_false] = ACTIONS(1948),
    [sym_null] = ACTIONS(1948),
    [sym_undefined] = ACTIONS(1948),
    [anon_sym_AT] = ACTIONS(1952),
    [anon_sym_static] = ACTIONS(1948),
    [anon_sym_readonly] = ACTIONS(1948),
    [anon_sym_get] = ACTIONS(1948),
    [anon_sym_set] = ACTIONS(1948),
    [anon_sym_declare] = ACTIONS(1948),
    [anon_sym_public] = ACTIONS(1948),
    [anon_sym_private] = ACTIONS(1948),
    [anon_sym_protected] = ACTIONS(1948),
    [anon_sym_override] = ACTIONS(1948),
    [anon_sym_module] = ACTIONS(1948),
    [anon_sym_any] = ACTIONS(1948),
    [anon_sym_number] = ACTIONS(1948),
    [anon_sym_boolean] = ACTIONS(1948),
    [anon_sym_string] = ACTIONS(1948),
    [anon_sym_symbol] = ACTIONS(1948),
    [anon_sym_object] = ACTIONS(1948),
    [anon_sym_property] = ACTIONS(1948),
    [anon_sym_signal] = ACTIONS(1948),
    [anon_sym_on] = ACTIONS(1948),
    [anon_sym_required] = ACTIONS(1948),
    [anon_sym_component] = ACTIONS(1948),
    [anon_sym_abstract] = ACTIONS(1948),
    [anon_sym_interface] = ACTIONS(1948),
    [anon_sym_enum] = ACTIONS(1948),
    [sym__automatic_semicolon] = ACTIONS(1956),
    [sym_html_comment] = ACTIONS(5),
  },
  [784] = {
    [sym_comment] = STATE(784),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_export] = ACTIONS(1886),
    [anon_sym_default] = ACTIONS(1886),
    [anon_sym_type] = ACTIONS(1886),
    [anon_sym_namespace] = ACTIONS(1886),
    [anon_sym_LBRACE] = ACTIONS(1890),
    [anon_sym_RBRACE] = ACTIONS(1890),
    [anon_sym_typeof] = ACTIONS(1886),
    [anon_sym_import] = ACTIONS(1886),
    [anon_sym_from] = ACTIONS(1886),
    [anon_sym_with] = ACTIONS(1886),
    [anon_sym_var] = ACTIONS(1886),
    [anon_sym_let] = ACTIONS(1886),
    [anon_sym_const] = ACTIONS(1886),
    [anon_sym_BANG] = ACTIONS(1890),
    [anon_sym_else] = ACTIONS(1886),
    [anon_sym_if] = ACTIONS(1886),
    [anon_sym_switch] = ACTIONS(1886),
    [anon_sym_for] = ACTIONS(1886),
    [anon_sym_LPAREN] = ACTIONS(1890),
    [anon_sym_await] = ACTIONS(1886),
    [anon_sym_of] = ACTIONS(1886),
    [anon_sym_while] = ACTIONS(1886),
    [anon_sym_do] = ACTIONS(1886),
    [anon_sym_try] = ACTIONS(1886),
    [anon_sym_break] = ACTIONS(1886),
    [anon_sym_continue] = ACTIONS(1886),
    [anon_sym_debugger] = ACTIONS(1886),
    [anon_sym_return] = ACTIONS(1886),
    [anon_sym_throw] = ACTIONS(1886),
    [anon_sym_SEMI] = ACTIONS(1890),
    [anon_sym_case] = ACTIONS(1886),
    [anon_sym_yield] = ACTIONS(1886),
    [anon_sym_LBRACK] = ACTIONS(1890),
    [anon_sym_LTtemplate_GT] = ACTIONS(1890),
    [anon_sym_DQUOTE] = ACTIONS(1890),
    [anon_sym_SQUOTE] = ACTIONS(1890),
    [anon_sym_class] = ACTIONS(1886),
    [anon_sym_async] = ACTIONS(1886),
    [anon_sym_function] = ACTIONS(1886),
    [anon_sym_new] = ACTIONS(1886),
    [anon_sym_using] = ACTIONS(1886),
    [anon_sym_PLUS] = ACTIONS(1886),
    [anon_sym_DASH] = ACTIONS(1886),
    [anon_sym_SLASH] = ACTIONS(1886),
    [anon_sym_LT] = ACTIONS(1886),
    [anon_sym_TILDE] = ACTIONS(1890),
    [anon_sym_void] = ACTIONS(1886),
    [anon_sym_delete] = ACTIONS(1886),
    [anon_sym_PLUS_PLUS] = ACTIONS(1890),
    [anon_sym_DASH_DASH] = ACTIONS(1890),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1890),
    [sym_number] = ACTIONS(1890),
    [sym_private_property_identifier] = ACTIONS(1890),
    [sym_this] = ACTIONS(1886),
    [sym_super] = ACTIONS(1886),
    [sym_true] = ACTIONS(1886),
    [sym_false] = ACTIONS(1886),
    [sym_null] = ACTIONS(1886),
    [sym_undefined] = ACTIONS(1886),
    [anon_sym_AT] = ACTIONS(1890),
    [anon_sym_static] = ACTIONS(1886),
    [anon_sym_readonly] = ACTIONS(1886),
    [anon_sym_get] = ACTIONS(1886),
    [anon_sym_set] = ACTIONS(1886),
    [anon_sym_declare] = ACTIONS(1886),
    [anon_sym_public] = ACTIONS(1886),
    [anon_sym_private] = ACTIONS(1886),
    [anon_sym_protected] = ACTIONS(1886),
    [anon_sym_override] = ACTIONS(1886),
    [anon_sym_module] = ACTIONS(1886),
    [anon_sym_any] = ACTIONS(1886),
    [anon_sym_number] = ACTIONS(1886),
    [anon_sym_boolean] = ACTIONS(1886),
    [anon_sym_string] = ACTIONS(1886),
    [anon_sym_symbol] = ACTIONS(1886),
    [anon_sym_object] = ACTIONS(1886),
    [anon_sym_property] = ACTIONS(1886),
    [anon_sym_signal] = ACTIONS(1886),
    [anon_sym_on] = ACTIONS(1886),
    [anon_sym_required] = ACTIONS(1886),
    [anon_sym_component] = ACTIONS(1886),
    [anon_sym_abstract] = ACTIONS(1886),
    [anon_sym_interface] = ACTIONS(1886),
    [anon_sym_enum] = ACTIONS(1886),
    [sym__automatic_semicolon] = ACTIONS(1894),
    [sym_html_comment] = ACTIONS(5),
  },
  [785] = {
    [sym_comment] = STATE(785),
    [sym_identifier] = ACTIONS(1876),
    [anon_sym_export] = ACTIONS(1876),
    [anon_sym_default] = ACTIONS(1876),
    [anon_sym_type] = ACTIONS(1876),
    [anon_sym_namespace] = ACTIONS(1876),
    [anon_sym_LBRACE] = ACTIONS(1880),
    [anon_sym_RBRACE] = ACTIONS(1880),
    [anon_sym_typeof] = ACTIONS(1876),
    [anon_sym_import] = ACTIONS(1876),
    [anon_sym_from] = ACTIONS(1876),
    [anon_sym_with] = ACTIONS(1876),
    [anon_sym_var] = ACTIONS(1876),
    [anon_sym_let] = ACTIONS(1876),
    [anon_sym_const] = ACTIONS(1876),
    [anon_sym_BANG] = ACTIONS(1880),
    [anon_sym_else] = ACTIONS(1876),
    [anon_sym_if] = ACTIONS(1876),
    [anon_sym_switch] = ACTIONS(1876),
    [anon_sym_for] = ACTIONS(1876),
    [anon_sym_LPAREN] = ACTIONS(1880),
    [anon_sym_await] = ACTIONS(1876),
    [anon_sym_of] = ACTIONS(1876),
    [anon_sym_while] = ACTIONS(1876),
    [anon_sym_do] = ACTIONS(1876),
    [anon_sym_try] = ACTIONS(1876),
    [anon_sym_break] = ACTIONS(1876),
    [anon_sym_continue] = ACTIONS(1876),
    [anon_sym_debugger] = ACTIONS(1876),
    [anon_sym_return] = ACTIONS(1876),
    [anon_sym_throw] = ACTIONS(1876),
    [anon_sym_SEMI] = ACTIONS(1880),
    [anon_sym_case] = ACTIONS(1876),
    [anon_sym_yield] = ACTIONS(1876),
    [anon_sym_LBRACK] = ACTIONS(1880),
    [anon_sym_LTtemplate_GT] = ACTIONS(1880),
    [anon_sym_DQUOTE] = ACTIONS(1880),
    [anon_sym_SQUOTE] = ACTIONS(1880),
    [anon_sym_class] = ACTIONS(1876),
    [anon_sym_async] = ACTIONS(1876),
    [anon_sym_function] = ACTIONS(1876),
    [anon_sym_new] = ACTIONS(1876),
    [anon_sym_using] = ACTIONS(1876),
    [anon_sym_PLUS] = ACTIONS(1876),
    [anon_sym_DASH] = ACTIONS(1876),
    [anon_sym_SLASH] = ACTIONS(1876),
    [anon_sym_LT] = ACTIONS(1876),
    [anon_sym_TILDE] = ACTIONS(1880),
    [anon_sym_void] = ACTIONS(1876),
    [anon_sym_delete] = ACTIONS(1876),
    [anon_sym_PLUS_PLUS] = ACTIONS(1880),
    [anon_sym_DASH_DASH] = ACTIONS(1880),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1880),
    [sym_number] = ACTIONS(1880),
    [sym_private_property_identifier] = ACTIONS(1880),
    [sym_this] = ACTIONS(1876),
    [sym_super] = ACTIONS(1876),
    [sym_true] = ACTIONS(1876),
    [sym_false] = ACTIONS(1876),
    [sym_null] = ACTIONS(1876),
    [sym_undefined] = ACTIONS(1876),
    [anon_sym_AT] = ACTIONS(1880),
    [anon_sym_static] = ACTIONS(1876),
    [anon_sym_readonly] = ACTIONS(1876),
    [anon_sym_get] = ACTIONS(1876),
    [anon_sym_set] = ACTIONS(1876),
    [anon_sym_declare] = ACTIONS(1876),
    [anon_sym_public] = ACTIONS(1876),
    [anon_sym_private] = ACTIONS(1876),
    [anon_sym_protected] = ACTIONS(1876),
    [anon_sym_override] = ACTIONS(1876),
    [anon_sym_module] = ACTIONS(1876),
    [anon_sym_any] = ACTIONS(1876),
    [anon_sym_number] = ACTIONS(1876),
    [anon_sym_boolean] = ACTIONS(1876),
    [anon_sym_string] = ACTIONS(1876),
    [anon_sym_symbol] = ACTIONS(1876),
    [anon_sym_object] = ACTIONS(1876),
    [anon_sym_property] = ACTIONS(1876),
    [anon_sym_signal] = ACTIONS(1876),
    [anon_sym_on] = ACTIONS(1876),
    [anon_sym_required] = ACTIONS(1876),
    [anon_sym_component] = ACTIONS(1876),
    [anon_sym_abstract] = ACTIONS(1876),
    [anon_sym_interface] = ACTIONS(1876),
    [anon_sym_enum] = ACTIONS(1876),
    [sym__automatic_semicolon] = ACTIONS(1884),
    [sym_html_comment] = ACTIONS(5),
  },
  [786] = {
    [sym_comment] = STATE(786),
    [sym_identifier] = ACTIONS(1982),
    [anon_sym_export] = ACTIONS(1982),
    [anon_sym_default] = ACTIONS(1982),
    [anon_sym_type] = ACTIONS(1982),
    [anon_sym_namespace] = ACTIONS(1982),
    [anon_sym_LBRACE] = ACTIONS(1986),
    [anon_sym_RBRACE] = ACTIONS(1986),
    [anon_sym_typeof] = ACTIONS(1982),
    [anon_sym_import] = ACTIONS(1982),
    [anon_sym_from] = ACTIONS(1982),
    [anon_sym_with] = ACTIONS(1982),
    [anon_sym_var] = ACTIONS(1982),
    [anon_sym_let] = ACTIONS(1982),
    [anon_sym_const] = ACTIONS(1982),
    [anon_sym_BANG] = ACTIONS(1986),
    [anon_sym_else] = ACTIONS(1982),
    [anon_sym_if] = ACTIONS(1982),
    [anon_sym_switch] = ACTIONS(1982),
    [anon_sym_for] = ACTIONS(1982),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_await] = ACTIONS(1982),
    [anon_sym_of] = ACTIONS(1982),
    [anon_sym_while] = ACTIONS(1982),
    [anon_sym_do] = ACTIONS(1982),
    [anon_sym_try] = ACTIONS(1982),
    [anon_sym_break] = ACTIONS(1982),
    [anon_sym_continue] = ACTIONS(1982),
    [anon_sym_debugger] = ACTIONS(1982),
    [anon_sym_return] = ACTIONS(1982),
    [anon_sym_throw] = ACTIONS(1982),
    [anon_sym_SEMI] = ACTIONS(1986),
    [anon_sym_case] = ACTIONS(1982),
    [anon_sym_yield] = ACTIONS(1982),
    [anon_sym_LBRACK] = ACTIONS(1986),
    [anon_sym_LTtemplate_GT] = ACTIONS(1986),
    [anon_sym_DQUOTE] = ACTIONS(1986),
    [anon_sym_SQUOTE] = ACTIONS(1986),
    [anon_sym_class] = ACTIONS(1982),
    [anon_sym_async] = ACTIONS(1982),
    [anon_sym_function] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(1982),
    [anon_sym_using] = ACTIONS(1982),
    [anon_sym_PLUS] = ACTIONS(1982),
    [anon_sym_DASH] = ACTIONS(1982),
    [anon_sym_SLASH] = ACTIONS(1982),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_TILDE] = ACTIONS(1986),
    [anon_sym_void] = ACTIONS(1982),
    [anon_sym_delete] = ACTIONS(1982),
    [anon_sym_PLUS_PLUS] = ACTIONS(1986),
    [anon_sym_DASH_DASH] = ACTIONS(1986),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1986),
    [sym_number] = ACTIONS(1986),
    [sym_private_property_identifier] = ACTIONS(1986),
    [sym_this] = ACTIONS(1982),
    [sym_super] = ACTIONS(1982),
    [sym_true] = ACTIONS(1982),
    [sym_false] = ACTIONS(1982),
    [sym_null] = ACTIONS(1982),
    [sym_undefined] = ACTIONS(1982),
    [anon_sym_AT] = ACTIONS(1986),
    [anon_sym_static] = ACTIONS(1982),
    [anon_sym_readonly] = ACTIONS(1982),
    [anon_sym_get] = ACTIONS(1982),
    [anon_sym_set] = ACTIONS(1982),
    [anon_sym_declare] = ACTIONS(1982),
    [anon_sym_public] = ACTIONS(1982),
    [anon_sym_private] = ACTIONS(1982),
    [anon_sym_protected] = ACTIONS(1982),
    [anon_sym_override] = ACTIONS(1982),
    [anon_sym_module] = ACTIONS(1982),
    [anon_sym_any] = ACTIONS(1982),
    [anon_sym_number] = ACTIONS(1982),
    [anon_sym_boolean] = ACTIONS(1982),
    [anon_sym_string] = ACTIONS(1982),
    [anon_sym_symbol] = ACTIONS(1982),
    [anon_sym_object] = ACTIONS(1982),
    [anon_sym_property] = ACTIONS(1982),
    [anon_sym_signal] = ACTIONS(1982),
    [anon_sym_on] = ACTIONS(1982),
    [anon_sym_required] = ACTIONS(1982),
    [anon_sym_component] = ACTIONS(1982),
    [anon_sym_abstract] = ACTIONS(1982),
    [anon_sym_interface] = ACTIONS(1982),
    [anon_sym_enum] = ACTIONS(1982),
    [sym__automatic_semicolon] = ACTIONS(1990),
    [sym_html_comment] = ACTIONS(5),
  },
  [787] = {
    [sym_comment] = STATE(787),
    [sym_identifier] = ACTIONS(2637),
    [anon_sym_export] = ACTIONS(2637),
    [anon_sym_default] = ACTIONS(2637),
    [anon_sym_type] = ACTIONS(2637),
    [anon_sym_namespace] = ACTIONS(2637),
    [anon_sym_LBRACE] = ACTIONS(2639),
    [anon_sym_RBRACE] = ACTIONS(2639),
    [anon_sym_typeof] = ACTIONS(2637),
    [anon_sym_import] = ACTIONS(2637),
    [anon_sym_from] = ACTIONS(2637),
    [anon_sym_with] = ACTIONS(2637),
    [anon_sym_var] = ACTIONS(2637),
    [anon_sym_let] = ACTIONS(2637),
    [anon_sym_const] = ACTIONS(2637),
    [anon_sym_BANG] = ACTIONS(2639),
    [anon_sym_else] = ACTIONS(2637),
    [anon_sym_if] = ACTIONS(2637),
    [anon_sym_switch] = ACTIONS(2637),
    [anon_sym_for] = ACTIONS(2637),
    [anon_sym_LPAREN] = ACTIONS(2639),
    [anon_sym_await] = ACTIONS(2637),
    [anon_sym_of] = ACTIONS(2637),
    [anon_sym_while] = ACTIONS(2637),
    [anon_sym_do] = ACTIONS(2637),
    [anon_sym_try] = ACTIONS(2637),
    [anon_sym_break] = ACTIONS(2637),
    [anon_sym_continue] = ACTIONS(2637),
    [anon_sym_debugger] = ACTIONS(2637),
    [anon_sym_return] = ACTIONS(2637),
    [anon_sym_throw] = ACTIONS(2637),
    [anon_sym_SEMI] = ACTIONS(2639),
    [anon_sym_case] = ACTIONS(2637),
    [anon_sym_yield] = ACTIONS(2637),
    [anon_sym_LBRACK] = ACTIONS(2639),
    [anon_sym_LTtemplate_GT] = ACTIONS(2639),
    [anon_sym_DQUOTE] = ACTIONS(2639),
    [anon_sym_SQUOTE] = ACTIONS(2639),
    [anon_sym_class] = ACTIONS(2637),
    [anon_sym_async] = ACTIONS(2637),
    [anon_sym_function] = ACTIONS(2637),
    [anon_sym_new] = ACTIONS(2637),
    [anon_sym_using] = ACTIONS(2637),
    [anon_sym_PLUS] = ACTIONS(2637),
    [anon_sym_DASH] = ACTIONS(2637),
    [anon_sym_SLASH] = ACTIONS(2637),
    [anon_sym_LT] = ACTIONS(2637),
    [anon_sym_TILDE] = ACTIONS(2639),
    [anon_sym_void] = ACTIONS(2637),
    [anon_sym_delete] = ACTIONS(2637),
    [anon_sym_PLUS_PLUS] = ACTIONS(2639),
    [anon_sym_DASH_DASH] = ACTIONS(2639),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2639),
    [sym_number] = ACTIONS(2639),
    [sym_private_property_identifier] = ACTIONS(2639),
    [sym_this] = ACTIONS(2637),
    [sym_super] = ACTIONS(2637),
    [sym_true] = ACTIONS(2637),
    [sym_false] = ACTIONS(2637),
    [sym_null] = ACTIONS(2637),
    [sym_undefined] = ACTIONS(2637),
    [anon_sym_AT] = ACTIONS(2639),
    [anon_sym_static] = ACTIONS(2637),
    [anon_sym_readonly] = ACTIONS(2637),
    [anon_sym_get] = ACTIONS(2637),
    [anon_sym_set] = ACTIONS(2637),
    [anon_sym_declare] = ACTIONS(2637),
    [anon_sym_public] = ACTIONS(2637),
    [anon_sym_private] = ACTIONS(2637),
    [anon_sym_protected] = ACTIONS(2637),
    [anon_sym_override] = ACTIONS(2637),
    [anon_sym_module] = ACTIONS(2637),
    [anon_sym_any] = ACTIONS(2637),
    [anon_sym_number] = ACTIONS(2637),
    [anon_sym_boolean] = ACTIONS(2637),
    [anon_sym_string] = ACTIONS(2637),
    [anon_sym_symbol] = ACTIONS(2637),
    [anon_sym_object] = ACTIONS(2637),
    [anon_sym_property] = ACTIONS(2637),
    [anon_sym_signal] = ACTIONS(2637),
    [anon_sym_on] = ACTIONS(2637),
    [anon_sym_required] = ACTIONS(2637),
    [anon_sym_component] = ACTIONS(2637),
    [anon_sym_abstract] = ACTIONS(2637),
    [anon_sym_interface] = ACTIONS(2637),
    [anon_sym_enum] = ACTIONS(2637),
    [sym_html_comment] = ACTIONS(5),
  },
  [788] = {
    [sym_comment] = STATE(788),
    [sym_identifier] = ACTIONS(2641),
    [anon_sym_export] = ACTIONS(2641),
    [anon_sym_default] = ACTIONS(2641),
    [anon_sym_type] = ACTIONS(2641),
    [anon_sym_namespace] = ACTIONS(2641),
    [anon_sym_LBRACE] = ACTIONS(2643),
    [anon_sym_RBRACE] = ACTIONS(2643),
    [anon_sym_typeof] = ACTIONS(2641),
    [anon_sym_import] = ACTIONS(2641),
    [anon_sym_from] = ACTIONS(2641),
    [anon_sym_with] = ACTIONS(2641),
    [anon_sym_var] = ACTIONS(2641),
    [anon_sym_let] = ACTIONS(2641),
    [anon_sym_const] = ACTIONS(2641),
    [anon_sym_BANG] = ACTIONS(2643),
    [anon_sym_else] = ACTIONS(2641),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_switch] = ACTIONS(2641),
    [anon_sym_for] = ACTIONS(2641),
    [anon_sym_LPAREN] = ACTIONS(2643),
    [anon_sym_await] = ACTIONS(2641),
    [anon_sym_of] = ACTIONS(2641),
    [anon_sym_while] = ACTIONS(2641),
    [anon_sym_do] = ACTIONS(2641),
    [anon_sym_try] = ACTIONS(2641),
    [anon_sym_break] = ACTIONS(2641),
    [anon_sym_continue] = ACTIONS(2641),
    [anon_sym_debugger] = ACTIONS(2641),
    [anon_sym_return] = ACTIONS(2641),
    [anon_sym_throw] = ACTIONS(2641),
    [anon_sym_SEMI] = ACTIONS(2643),
    [anon_sym_case] = ACTIONS(2641),
    [anon_sym_yield] = ACTIONS(2641),
    [anon_sym_LBRACK] = ACTIONS(2643),
    [anon_sym_LTtemplate_GT] = ACTIONS(2643),
    [anon_sym_DQUOTE] = ACTIONS(2643),
    [anon_sym_SQUOTE] = ACTIONS(2643),
    [anon_sym_class] = ACTIONS(2641),
    [anon_sym_async] = ACTIONS(2641),
    [anon_sym_function] = ACTIONS(2641),
    [anon_sym_new] = ACTIONS(2641),
    [anon_sym_using] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(2641),
    [anon_sym_DASH] = ACTIONS(2641),
    [anon_sym_SLASH] = ACTIONS(2641),
    [anon_sym_LT] = ACTIONS(2641),
    [anon_sym_TILDE] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2641),
    [anon_sym_delete] = ACTIONS(2641),
    [anon_sym_PLUS_PLUS] = ACTIONS(2643),
    [anon_sym_DASH_DASH] = ACTIONS(2643),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2643),
    [sym_number] = ACTIONS(2643),
    [sym_private_property_identifier] = ACTIONS(2643),
    [sym_this] = ACTIONS(2641),
    [sym_super] = ACTIONS(2641),
    [sym_true] = ACTIONS(2641),
    [sym_false] = ACTIONS(2641),
    [sym_null] = ACTIONS(2641),
    [sym_undefined] = ACTIONS(2641),
    [anon_sym_AT] = ACTIONS(2643),
    [anon_sym_static] = ACTIONS(2641),
    [anon_sym_readonly] = ACTIONS(2641),
    [anon_sym_get] = ACTIONS(2641),
    [anon_sym_set] = ACTIONS(2641),
    [anon_sym_declare] = ACTIONS(2641),
    [anon_sym_public] = ACTIONS(2641),
    [anon_sym_private] = ACTIONS(2641),
    [anon_sym_protected] = ACTIONS(2641),
    [anon_sym_override] = ACTIONS(2641),
    [anon_sym_module] = ACTIONS(2641),
    [anon_sym_any] = ACTIONS(2641),
    [anon_sym_number] = ACTIONS(2641),
    [anon_sym_boolean] = ACTIONS(2641),
    [anon_sym_string] = ACTIONS(2641),
    [anon_sym_symbol] = ACTIONS(2641),
    [anon_sym_object] = ACTIONS(2641),
    [anon_sym_property] = ACTIONS(2641),
    [anon_sym_signal] = ACTIONS(2641),
    [anon_sym_on] = ACTIONS(2641),
    [anon_sym_required] = ACTIONS(2641),
    [anon_sym_component] = ACTIONS(2641),
    [anon_sym_abstract] = ACTIONS(2641),
    [anon_sym_interface] = ACTIONS(2641),
    [anon_sym_enum] = ACTIONS(2641),
    [sym_html_comment] = ACTIONS(5),
  },
  [789] = {
    [sym_comment] = STATE(789),
    [sym_identifier] = ACTIONS(2645),
    [anon_sym_export] = ACTIONS(2645),
    [anon_sym_default] = ACTIONS(2645),
    [anon_sym_type] = ACTIONS(2645),
    [anon_sym_namespace] = ACTIONS(2645),
    [anon_sym_LBRACE] = ACTIONS(2647),
    [anon_sym_RBRACE] = ACTIONS(2647),
    [anon_sym_typeof] = ACTIONS(2645),
    [anon_sym_import] = ACTIONS(2645),
    [anon_sym_from] = ACTIONS(2645),
    [anon_sym_with] = ACTIONS(2645),
    [anon_sym_var] = ACTIONS(2645),
    [anon_sym_let] = ACTIONS(2645),
    [anon_sym_const] = ACTIONS(2645),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_else] = ACTIONS(2645),
    [anon_sym_if] = ACTIONS(2645),
    [anon_sym_switch] = ACTIONS(2645),
    [anon_sym_for] = ACTIONS(2645),
    [anon_sym_LPAREN] = ACTIONS(2647),
    [anon_sym_await] = ACTIONS(2645),
    [anon_sym_of] = ACTIONS(2645),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_do] = ACTIONS(2645),
    [anon_sym_try] = ACTIONS(2645),
    [anon_sym_break] = ACTIONS(2645),
    [anon_sym_continue] = ACTIONS(2645),
    [anon_sym_debugger] = ACTIONS(2645),
    [anon_sym_return] = ACTIONS(2645),
    [anon_sym_throw] = ACTIONS(2645),
    [anon_sym_SEMI] = ACTIONS(2647),
    [anon_sym_case] = ACTIONS(2645),
    [anon_sym_yield] = ACTIONS(2645),
    [anon_sym_LBRACK] = ACTIONS(2647),
    [anon_sym_LTtemplate_GT] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(2647),
    [anon_sym_SQUOTE] = ACTIONS(2647),
    [anon_sym_class] = ACTIONS(2645),
    [anon_sym_async] = ACTIONS(2645),
    [anon_sym_function] = ACTIONS(2645),
    [anon_sym_new] = ACTIONS(2645),
    [anon_sym_using] = ACTIONS(2645),
    [anon_sym_PLUS] = ACTIONS(2645),
    [anon_sym_DASH] = ACTIONS(2645),
    [anon_sym_SLASH] = ACTIONS(2645),
    [anon_sym_LT] = ACTIONS(2645),
    [anon_sym_TILDE] = ACTIONS(2647),
    [anon_sym_void] = ACTIONS(2645),
    [anon_sym_delete] = ACTIONS(2645),
    [anon_sym_PLUS_PLUS] = ACTIONS(2647),
    [anon_sym_DASH_DASH] = ACTIONS(2647),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2647),
    [sym_number] = ACTIONS(2647),
    [sym_private_property_identifier] = ACTIONS(2647),
    [sym_this] = ACTIONS(2645),
    [sym_super] = ACTIONS(2645),
    [sym_true] = ACTIONS(2645),
    [sym_false] = ACTIONS(2645),
    [sym_null] = ACTIONS(2645),
    [sym_undefined] = ACTIONS(2645),
    [anon_sym_AT] = ACTIONS(2647),
    [anon_sym_static] = ACTIONS(2645),
    [anon_sym_readonly] = ACTIONS(2645),
    [anon_sym_get] = ACTIONS(2645),
    [anon_sym_set] = ACTIONS(2645),
    [anon_sym_declare] = ACTIONS(2645),
    [anon_sym_public] = ACTIONS(2645),
    [anon_sym_private] = ACTIONS(2645),
    [anon_sym_protected] = ACTIONS(2645),
    [anon_sym_override] = ACTIONS(2645),
    [anon_sym_module] = ACTIONS(2645),
    [anon_sym_any] = ACTIONS(2645),
    [anon_sym_number] = ACTIONS(2645),
    [anon_sym_boolean] = ACTIONS(2645),
    [anon_sym_string] = ACTIONS(2645),
    [anon_sym_symbol] = ACTIONS(2645),
    [anon_sym_object] = ACTIONS(2645),
    [anon_sym_property] = ACTIONS(2645),
    [anon_sym_signal] = ACTIONS(2645),
    [anon_sym_on] = ACTIONS(2645),
    [anon_sym_required] = ACTIONS(2645),
    [anon_sym_component] = ACTIONS(2645),
    [anon_sym_abstract] = ACTIONS(2645),
    [anon_sym_interface] = ACTIONS(2645),
    [anon_sym_enum] = ACTIONS(2645),
    [sym_html_comment] = ACTIONS(5),
  },
  [790] = {
    [sym_comment] = STATE(790),
    [sym_identifier] = ACTIONS(2649),
    [anon_sym_export] = ACTIONS(2649),
    [anon_sym_default] = ACTIONS(2649),
    [anon_sym_type] = ACTIONS(2649),
    [anon_sym_namespace] = ACTIONS(2649),
    [anon_sym_LBRACE] = ACTIONS(2651),
    [anon_sym_RBRACE] = ACTIONS(2651),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_import] = ACTIONS(2649),
    [anon_sym_from] = ACTIONS(2649),
    [anon_sym_with] = ACTIONS(2649),
    [anon_sym_var] = ACTIONS(2649),
    [anon_sym_let] = ACTIONS(2649),
    [anon_sym_const] = ACTIONS(2649),
    [anon_sym_BANG] = ACTIONS(2651),
    [anon_sym_else] = ACTIONS(2649),
    [anon_sym_if] = ACTIONS(2649),
    [anon_sym_switch] = ACTIONS(2649),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_LPAREN] = ACTIONS(2651),
    [anon_sym_await] = ACTIONS(2649),
    [anon_sym_of] = ACTIONS(2649),
    [anon_sym_while] = ACTIONS(2649),
    [anon_sym_do] = ACTIONS(2649),
    [anon_sym_try] = ACTIONS(2649),
    [anon_sym_break] = ACTIONS(2649),
    [anon_sym_continue] = ACTIONS(2649),
    [anon_sym_debugger] = ACTIONS(2649),
    [anon_sym_return] = ACTIONS(2649),
    [anon_sym_throw] = ACTIONS(2649),
    [anon_sym_SEMI] = ACTIONS(2651),
    [anon_sym_case] = ACTIONS(2649),
    [anon_sym_yield] = ACTIONS(2649),
    [anon_sym_LBRACK] = ACTIONS(2651),
    [anon_sym_LTtemplate_GT] = ACTIONS(2651),
    [anon_sym_DQUOTE] = ACTIONS(2651),
    [anon_sym_SQUOTE] = ACTIONS(2651),
    [anon_sym_class] = ACTIONS(2649),
    [anon_sym_async] = ACTIONS(2649),
    [anon_sym_function] = ACTIONS(2649),
    [anon_sym_new] = ACTIONS(2649),
    [anon_sym_using] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2649),
    [anon_sym_SLASH] = ACTIONS(2649),
    [anon_sym_LT] = ACTIONS(2649),
    [anon_sym_TILDE] = ACTIONS(2651),
    [anon_sym_void] = ACTIONS(2649),
    [anon_sym_delete] = ACTIONS(2649),
    [anon_sym_PLUS_PLUS] = ACTIONS(2651),
    [anon_sym_DASH_DASH] = ACTIONS(2651),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2651),
    [sym_number] = ACTIONS(2651),
    [sym_private_property_identifier] = ACTIONS(2651),
    [sym_this] = ACTIONS(2649),
    [sym_super] = ACTIONS(2649),
    [sym_true] = ACTIONS(2649),
    [sym_false] = ACTIONS(2649),
    [sym_null] = ACTIONS(2649),
    [sym_undefined] = ACTIONS(2649),
    [anon_sym_AT] = ACTIONS(2651),
    [anon_sym_static] = ACTIONS(2649),
    [anon_sym_readonly] = ACTIONS(2649),
    [anon_sym_get] = ACTIONS(2649),
    [anon_sym_set] = ACTIONS(2649),
    [anon_sym_declare] = ACTIONS(2649),
    [anon_sym_public] = ACTIONS(2649),
    [anon_sym_private] = ACTIONS(2649),
    [anon_sym_protected] = ACTIONS(2649),
    [anon_sym_override] = ACTIONS(2649),
    [anon_sym_module] = ACTIONS(2649),
    [anon_sym_any] = ACTIONS(2649),
    [anon_sym_number] = ACTIONS(2649),
    [anon_sym_boolean] = ACTIONS(2649),
    [anon_sym_string] = ACTIONS(2649),
    [anon_sym_symbol] = ACTIONS(2649),
    [anon_sym_object] = ACTIONS(2649),
    [anon_sym_property] = ACTIONS(2649),
    [anon_sym_signal] = ACTIONS(2649),
    [anon_sym_on] = ACTIONS(2649),
    [anon_sym_required] = ACTIONS(2649),
    [anon_sym_component] = ACTIONS(2649),
    [anon_sym_abstract] = ACTIONS(2649),
    [anon_sym_interface] = ACTIONS(2649),
    [anon_sym_enum] = ACTIONS(2649),
    [sym_html_comment] = ACTIONS(5),
  },
  [791] = {
    [sym_comment] = STATE(791),
    [sym_identifier] = ACTIONS(2653),
    [anon_sym_export] = ACTIONS(2653),
    [anon_sym_default] = ACTIONS(2653),
    [anon_sym_type] = ACTIONS(2653),
    [anon_sym_namespace] = ACTIONS(2653),
    [anon_sym_LBRACE] = ACTIONS(2655),
    [anon_sym_RBRACE] = ACTIONS(2655),
    [anon_sym_typeof] = ACTIONS(2653),
    [anon_sym_import] = ACTIONS(2653),
    [anon_sym_from] = ACTIONS(2653),
    [anon_sym_with] = ACTIONS(2653),
    [anon_sym_var] = ACTIONS(2653),
    [anon_sym_let] = ACTIONS(2653),
    [anon_sym_const] = ACTIONS(2653),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_else] = ACTIONS(2653),
    [anon_sym_if] = ACTIONS(2653),
    [anon_sym_switch] = ACTIONS(2653),
    [anon_sym_for] = ACTIONS(2653),
    [anon_sym_LPAREN] = ACTIONS(2655),
    [anon_sym_await] = ACTIONS(2653),
    [anon_sym_of] = ACTIONS(2653),
    [anon_sym_while] = ACTIONS(2653),
    [anon_sym_do] = ACTIONS(2653),
    [anon_sym_try] = ACTIONS(2653),
    [anon_sym_break] = ACTIONS(2653),
    [anon_sym_continue] = ACTIONS(2653),
    [anon_sym_debugger] = ACTIONS(2653),
    [anon_sym_return] = ACTIONS(2653),
    [anon_sym_throw] = ACTIONS(2653),
    [anon_sym_SEMI] = ACTIONS(2655),
    [anon_sym_case] = ACTIONS(2653),
    [anon_sym_yield] = ACTIONS(2653),
    [anon_sym_LBRACK] = ACTIONS(2655),
    [anon_sym_LTtemplate_GT] = ACTIONS(2655),
    [anon_sym_DQUOTE] = ACTIONS(2655),
    [anon_sym_SQUOTE] = ACTIONS(2655),
    [anon_sym_class] = ACTIONS(2653),
    [anon_sym_async] = ACTIONS(2653),
    [anon_sym_function] = ACTIONS(2653),
    [anon_sym_new] = ACTIONS(2653),
    [anon_sym_using] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_SLASH] = ACTIONS(2653),
    [anon_sym_LT] = ACTIONS(2653),
    [anon_sym_TILDE] = ACTIONS(2655),
    [anon_sym_void] = ACTIONS(2653),
    [anon_sym_delete] = ACTIONS(2653),
    [anon_sym_PLUS_PLUS] = ACTIONS(2655),
    [anon_sym_DASH_DASH] = ACTIONS(2655),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2655),
    [sym_number] = ACTIONS(2655),
    [sym_private_property_identifier] = ACTIONS(2655),
    [sym_this] = ACTIONS(2653),
    [sym_super] = ACTIONS(2653),
    [sym_true] = ACTIONS(2653),
    [sym_false] = ACTIONS(2653),
    [sym_null] = ACTIONS(2653),
    [sym_undefined] = ACTIONS(2653),
    [anon_sym_AT] = ACTIONS(2655),
    [anon_sym_static] = ACTIONS(2653),
    [anon_sym_readonly] = ACTIONS(2653),
    [anon_sym_get] = ACTIONS(2653),
    [anon_sym_set] = ACTIONS(2653),
    [anon_sym_declare] = ACTIONS(2653),
    [anon_sym_public] = ACTIONS(2653),
    [anon_sym_private] = ACTIONS(2653),
    [anon_sym_protected] = ACTIONS(2653),
    [anon_sym_override] = ACTIONS(2653),
    [anon_sym_module] = ACTIONS(2653),
    [anon_sym_any] = ACTIONS(2653),
    [anon_sym_number] = ACTIONS(2653),
    [anon_sym_boolean] = ACTIONS(2653),
    [anon_sym_string] = ACTIONS(2653),
    [anon_sym_symbol] = ACTIONS(2653),
    [anon_sym_object] = ACTIONS(2653),
    [anon_sym_property] = ACTIONS(2653),
    [anon_sym_signal] = ACTIONS(2653),
    [anon_sym_on] = ACTIONS(2653),
    [anon_sym_required] = ACTIONS(2653),
    [anon_sym_component] = ACTIONS(2653),
    [anon_sym_abstract] = ACTIONS(2653),
    [anon_sym_interface] = ACTIONS(2653),
    [anon_sym_enum] = ACTIONS(2653),
    [sym_html_comment] = ACTIONS(5),
  },
  [792] = {
    [sym_comment] = STATE(792),
    [sym_identifier] = ACTIONS(2657),
    [anon_sym_export] = ACTIONS(2657),
    [anon_sym_default] = ACTIONS(2657),
    [anon_sym_type] = ACTIONS(2657),
    [anon_sym_namespace] = ACTIONS(2657),
    [anon_sym_LBRACE] = ACTIONS(2659),
    [anon_sym_RBRACE] = ACTIONS(2659),
    [anon_sym_typeof] = ACTIONS(2657),
    [anon_sym_import] = ACTIONS(2657),
    [anon_sym_from] = ACTIONS(2657),
    [anon_sym_with] = ACTIONS(2657),
    [anon_sym_var] = ACTIONS(2657),
    [anon_sym_let] = ACTIONS(2657),
    [anon_sym_const] = ACTIONS(2657),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_else] = ACTIONS(2657),
    [anon_sym_if] = ACTIONS(2657),
    [anon_sym_switch] = ACTIONS(2657),
    [anon_sym_for] = ACTIONS(2657),
    [anon_sym_LPAREN] = ACTIONS(2659),
    [anon_sym_await] = ACTIONS(2657),
    [anon_sym_of] = ACTIONS(2657),
    [anon_sym_while] = ACTIONS(2657),
    [anon_sym_do] = ACTIONS(2657),
    [anon_sym_try] = ACTIONS(2657),
    [anon_sym_break] = ACTIONS(2657),
    [anon_sym_continue] = ACTIONS(2657),
    [anon_sym_debugger] = ACTIONS(2657),
    [anon_sym_return] = ACTIONS(2657),
    [anon_sym_throw] = ACTIONS(2657),
    [anon_sym_SEMI] = ACTIONS(2659),
    [anon_sym_case] = ACTIONS(2657),
    [anon_sym_yield] = ACTIONS(2657),
    [anon_sym_LBRACK] = ACTIONS(2659),
    [anon_sym_LTtemplate_GT] = ACTIONS(2659),
    [anon_sym_DQUOTE] = ACTIONS(2659),
    [anon_sym_SQUOTE] = ACTIONS(2659),
    [anon_sym_class] = ACTIONS(2657),
    [anon_sym_async] = ACTIONS(2657),
    [anon_sym_function] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(2657),
    [anon_sym_using] = ACTIONS(2657),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_DASH] = ACTIONS(2657),
    [anon_sym_SLASH] = ACTIONS(2657),
    [anon_sym_LT] = ACTIONS(2657),
    [anon_sym_TILDE] = ACTIONS(2659),
    [anon_sym_void] = ACTIONS(2657),
    [anon_sym_delete] = ACTIONS(2657),
    [anon_sym_PLUS_PLUS] = ACTIONS(2659),
    [anon_sym_DASH_DASH] = ACTIONS(2659),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2659),
    [sym_number] = ACTIONS(2659),
    [sym_private_property_identifier] = ACTIONS(2659),
    [sym_this] = ACTIONS(2657),
    [sym_super] = ACTIONS(2657),
    [sym_true] = ACTIONS(2657),
    [sym_false] = ACTIONS(2657),
    [sym_null] = ACTIONS(2657),
    [sym_undefined] = ACTIONS(2657),
    [anon_sym_AT] = ACTIONS(2659),
    [anon_sym_static] = ACTIONS(2657),
    [anon_sym_readonly] = ACTIONS(2657),
    [anon_sym_get] = ACTIONS(2657),
    [anon_sym_set] = ACTIONS(2657),
    [anon_sym_declare] = ACTIONS(2657),
    [anon_sym_public] = ACTIONS(2657),
    [anon_sym_private] = ACTIONS(2657),
    [anon_sym_protected] = ACTIONS(2657),
    [anon_sym_override] = ACTIONS(2657),
    [anon_sym_module] = ACTIONS(2657),
    [anon_sym_any] = ACTIONS(2657),
    [anon_sym_number] = ACTIONS(2657),
    [anon_sym_boolean] = ACTIONS(2657),
    [anon_sym_string] = ACTIONS(2657),
    [anon_sym_symbol] = ACTIONS(2657),
    [anon_sym_object] = ACTIONS(2657),
    [anon_sym_property] = ACTIONS(2657),
    [anon_sym_signal] = ACTIONS(2657),
    [anon_sym_on] = ACTIONS(2657),
    [anon_sym_required] = ACTIONS(2657),
    [anon_sym_component] = ACTIONS(2657),
    [anon_sym_abstract] = ACTIONS(2657),
    [anon_sym_interface] = ACTIONS(2657),
    [anon_sym_enum] = ACTIONS(2657),
    [sym_html_comment] = ACTIONS(5),
  },
  [793] = {
    [sym_comment] = STATE(793),
    [sym_identifier] = ACTIONS(2661),
    [anon_sym_export] = ACTIONS(2661),
    [anon_sym_default] = ACTIONS(2661),
    [anon_sym_type] = ACTIONS(2661),
    [anon_sym_namespace] = ACTIONS(2661),
    [anon_sym_LBRACE] = ACTIONS(2663),
    [anon_sym_RBRACE] = ACTIONS(2663),
    [anon_sym_typeof] = ACTIONS(2661),
    [anon_sym_import] = ACTIONS(2661),
    [anon_sym_from] = ACTIONS(2661),
    [anon_sym_with] = ACTIONS(2661),
    [anon_sym_var] = ACTIONS(2661),
    [anon_sym_let] = ACTIONS(2661),
    [anon_sym_const] = ACTIONS(2661),
    [anon_sym_BANG] = ACTIONS(2663),
    [anon_sym_else] = ACTIONS(2661),
    [anon_sym_if] = ACTIONS(2661),
    [anon_sym_switch] = ACTIONS(2661),
    [anon_sym_for] = ACTIONS(2661),
    [anon_sym_LPAREN] = ACTIONS(2663),
    [anon_sym_await] = ACTIONS(2661),
    [anon_sym_of] = ACTIONS(2661),
    [anon_sym_while] = ACTIONS(2661),
    [anon_sym_do] = ACTIONS(2661),
    [anon_sym_try] = ACTIONS(2661),
    [anon_sym_break] = ACTIONS(2661),
    [anon_sym_continue] = ACTIONS(2661),
    [anon_sym_debugger] = ACTIONS(2661),
    [anon_sym_return] = ACTIONS(2661),
    [anon_sym_throw] = ACTIONS(2661),
    [anon_sym_SEMI] = ACTIONS(2663),
    [anon_sym_case] = ACTIONS(2661),
    [anon_sym_yield] = ACTIONS(2661),
    [anon_sym_LBRACK] = ACTIONS(2663),
    [anon_sym_LTtemplate_GT] = ACTIONS(2663),
    [anon_sym_DQUOTE] = ACTIONS(2663),
    [anon_sym_SQUOTE] = ACTIONS(2663),
    [anon_sym_class] = ACTIONS(2661),
    [anon_sym_async] = ACTIONS(2661),
    [anon_sym_function] = ACTIONS(2661),
    [anon_sym_new] = ACTIONS(2661),
    [anon_sym_using] = ACTIONS(2661),
    [anon_sym_PLUS] = ACTIONS(2661),
    [anon_sym_DASH] = ACTIONS(2661),
    [anon_sym_SLASH] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(2661),
    [anon_sym_TILDE] = ACTIONS(2663),
    [anon_sym_void] = ACTIONS(2661),
    [anon_sym_delete] = ACTIONS(2661),
    [anon_sym_PLUS_PLUS] = ACTIONS(2663),
    [anon_sym_DASH_DASH] = ACTIONS(2663),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2663),
    [sym_number] = ACTIONS(2663),
    [sym_private_property_identifier] = ACTIONS(2663),
    [sym_this] = ACTIONS(2661),
    [sym_super] = ACTIONS(2661),
    [sym_true] = ACTIONS(2661),
    [sym_false] = ACTIONS(2661),
    [sym_null] = ACTIONS(2661),
    [sym_undefined] = ACTIONS(2661),
    [anon_sym_AT] = ACTIONS(2663),
    [anon_sym_static] = ACTIONS(2661),
    [anon_sym_readonly] = ACTIONS(2661),
    [anon_sym_get] = ACTIONS(2661),
    [anon_sym_set] = ACTIONS(2661),
    [anon_sym_declare] = ACTIONS(2661),
    [anon_sym_public] = ACTIONS(2661),
    [anon_sym_private] = ACTIONS(2661),
    [anon_sym_protected] = ACTIONS(2661),
    [anon_sym_override] = ACTIONS(2661),
    [anon_sym_module] = ACTIONS(2661),
    [anon_sym_any] = ACTIONS(2661),
    [anon_sym_number] = ACTIONS(2661),
    [anon_sym_boolean] = ACTIONS(2661),
    [anon_sym_string] = ACTIONS(2661),
    [anon_sym_symbol] = ACTIONS(2661),
    [anon_sym_object] = ACTIONS(2661),
    [anon_sym_property] = ACTIONS(2661),
    [anon_sym_signal] = ACTIONS(2661),
    [anon_sym_on] = ACTIONS(2661),
    [anon_sym_required] = ACTIONS(2661),
    [anon_sym_component] = ACTIONS(2661),
    [anon_sym_abstract] = ACTIONS(2661),
    [anon_sym_interface] = ACTIONS(2661),
    [anon_sym_enum] = ACTIONS(2661),
    [sym_html_comment] = ACTIONS(5),
  },
  [794] = {
    [sym_comment] = STATE(794),
    [sym_identifier] = ACTIONS(2665),
    [anon_sym_export] = ACTIONS(2665),
    [anon_sym_default] = ACTIONS(2665),
    [anon_sym_type] = ACTIONS(2665),
    [anon_sym_namespace] = ACTIONS(2665),
    [anon_sym_LBRACE] = ACTIONS(2667),
    [anon_sym_RBRACE] = ACTIONS(2667),
    [anon_sym_typeof] = ACTIONS(2665),
    [anon_sym_import] = ACTIONS(2665),
    [anon_sym_from] = ACTIONS(2665),
    [anon_sym_with] = ACTIONS(2665),
    [anon_sym_var] = ACTIONS(2665),
    [anon_sym_let] = ACTIONS(2665),
    [anon_sym_const] = ACTIONS(2665),
    [anon_sym_BANG] = ACTIONS(2667),
    [anon_sym_else] = ACTIONS(2665),
    [anon_sym_if] = ACTIONS(2665),
    [anon_sym_switch] = ACTIONS(2665),
    [anon_sym_for] = ACTIONS(2665),
    [anon_sym_LPAREN] = ACTIONS(2667),
    [anon_sym_await] = ACTIONS(2665),
    [anon_sym_of] = ACTIONS(2665),
    [anon_sym_while] = ACTIONS(2665),
    [anon_sym_do] = ACTIONS(2665),
    [anon_sym_try] = ACTIONS(2665),
    [anon_sym_break] = ACTIONS(2665),
    [anon_sym_continue] = ACTIONS(2665),
    [anon_sym_debugger] = ACTIONS(2665),
    [anon_sym_return] = ACTIONS(2665),
    [anon_sym_throw] = ACTIONS(2665),
    [anon_sym_SEMI] = ACTIONS(2667),
    [anon_sym_case] = ACTIONS(2665),
    [anon_sym_yield] = ACTIONS(2665),
    [anon_sym_LBRACK] = ACTIONS(2667),
    [anon_sym_LTtemplate_GT] = ACTIONS(2667),
    [anon_sym_DQUOTE] = ACTIONS(2667),
    [anon_sym_SQUOTE] = ACTIONS(2667),
    [anon_sym_class] = ACTIONS(2665),
    [anon_sym_async] = ACTIONS(2665),
    [anon_sym_function] = ACTIONS(2665),
    [anon_sym_new] = ACTIONS(2665),
    [anon_sym_using] = ACTIONS(2665),
    [anon_sym_PLUS] = ACTIONS(2665),
    [anon_sym_DASH] = ACTIONS(2665),
    [anon_sym_SLASH] = ACTIONS(2665),
    [anon_sym_LT] = ACTIONS(2665),
    [anon_sym_TILDE] = ACTIONS(2667),
    [anon_sym_void] = ACTIONS(2665),
    [anon_sym_delete] = ACTIONS(2665),
    [anon_sym_PLUS_PLUS] = ACTIONS(2667),
    [anon_sym_DASH_DASH] = ACTIONS(2667),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2667),
    [sym_number] = ACTIONS(2667),
    [sym_private_property_identifier] = ACTIONS(2667),
    [sym_this] = ACTIONS(2665),
    [sym_super] = ACTIONS(2665),
    [sym_true] = ACTIONS(2665),
    [sym_false] = ACTIONS(2665),
    [sym_null] = ACTIONS(2665),
    [sym_undefined] = ACTIONS(2665),
    [anon_sym_AT] = ACTIONS(2667),
    [anon_sym_static] = ACTIONS(2665),
    [anon_sym_readonly] = ACTIONS(2665),
    [anon_sym_get] = ACTIONS(2665),
    [anon_sym_set] = ACTIONS(2665),
    [anon_sym_declare] = ACTIONS(2665),
    [anon_sym_public] = ACTIONS(2665),
    [anon_sym_private] = ACTIONS(2665),
    [anon_sym_protected] = ACTIONS(2665),
    [anon_sym_override] = ACTIONS(2665),
    [anon_sym_module] = ACTIONS(2665),
    [anon_sym_any] = ACTIONS(2665),
    [anon_sym_number] = ACTIONS(2665),
    [anon_sym_boolean] = ACTIONS(2665),
    [anon_sym_string] = ACTIONS(2665),
    [anon_sym_symbol] = ACTIONS(2665),
    [anon_sym_object] = ACTIONS(2665),
    [anon_sym_property] = ACTIONS(2665),
    [anon_sym_signal] = ACTIONS(2665),
    [anon_sym_on] = ACTIONS(2665),
    [anon_sym_required] = ACTIONS(2665),
    [anon_sym_component] = ACTIONS(2665),
    [anon_sym_abstract] = ACTIONS(2665),
    [anon_sym_interface] = ACTIONS(2665),
    [anon_sym_enum] = ACTIONS(2665),
    [sym_html_comment] = ACTIONS(5),
  },
  [795] = {
    [sym_comment] = STATE(795),
    [sym_identifier] = ACTIONS(2669),
    [anon_sym_export] = ACTIONS(2669),
    [anon_sym_default] = ACTIONS(2669),
    [anon_sym_type] = ACTIONS(2669),
    [anon_sym_namespace] = ACTIONS(2669),
    [anon_sym_LBRACE] = ACTIONS(2671),
    [anon_sym_RBRACE] = ACTIONS(2671),
    [anon_sym_typeof] = ACTIONS(2669),
    [anon_sym_import] = ACTIONS(2669),
    [anon_sym_from] = ACTIONS(2669),
    [anon_sym_with] = ACTIONS(2669),
    [anon_sym_var] = ACTIONS(2669),
    [anon_sym_let] = ACTIONS(2669),
    [anon_sym_const] = ACTIONS(2669),
    [anon_sym_BANG] = ACTIONS(2671),
    [anon_sym_else] = ACTIONS(2669),
    [anon_sym_if] = ACTIONS(2669),
    [anon_sym_switch] = ACTIONS(2669),
    [anon_sym_for] = ACTIONS(2669),
    [anon_sym_LPAREN] = ACTIONS(2671),
    [anon_sym_await] = ACTIONS(2669),
    [anon_sym_of] = ACTIONS(2669),
    [anon_sym_while] = ACTIONS(2669),
    [anon_sym_do] = ACTIONS(2669),
    [anon_sym_try] = ACTIONS(2669),
    [anon_sym_break] = ACTIONS(2669),
    [anon_sym_continue] = ACTIONS(2669),
    [anon_sym_debugger] = ACTIONS(2669),
    [anon_sym_return] = ACTIONS(2669),
    [anon_sym_throw] = ACTIONS(2669),
    [anon_sym_SEMI] = ACTIONS(2671),
    [anon_sym_case] = ACTIONS(2669),
    [anon_sym_yield] = ACTIONS(2669),
    [anon_sym_LBRACK] = ACTIONS(2671),
    [anon_sym_LTtemplate_GT] = ACTIONS(2671),
    [anon_sym_DQUOTE] = ACTIONS(2671),
    [anon_sym_SQUOTE] = ACTIONS(2671),
    [anon_sym_class] = ACTIONS(2669),
    [anon_sym_async] = ACTIONS(2669),
    [anon_sym_function] = ACTIONS(2669),
    [anon_sym_new] = ACTIONS(2669),
    [anon_sym_using] = ACTIONS(2669),
    [anon_sym_PLUS] = ACTIONS(2669),
    [anon_sym_DASH] = ACTIONS(2669),
    [anon_sym_SLASH] = ACTIONS(2669),
    [anon_sym_LT] = ACTIONS(2669),
    [anon_sym_TILDE] = ACTIONS(2671),
    [anon_sym_void] = ACTIONS(2669),
    [anon_sym_delete] = ACTIONS(2669),
    [anon_sym_PLUS_PLUS] = ACTIONS(2671),
    [anon_sym_DASH_DASH] = ACTIONS(2671),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2671),
    [sym_number] = ACTIONS(2671),
    [sym_private_property_identifier] = ACTIONS(2671),
    [sym_this] = ACTIONS(2669),
    [sym_super] = ACTIONS(2669),
    [sym_true] = ACTIONS(2669),
    [sym_false] = ACTIONS(2669),
    [sym_null] = ACTIONS(2669),
    [sym_undefined] = ACTIONS(2669),
    [anon_sym_AT] = ACTIONS(2671),
    [anon_sym_static] = ACTIONS(2669),
    [anon_sym_readonly] = ACTIONS(2669),
    [anon_sym_get] = ACTIONS(2669),
    [anon_sym_set] = ACTIONS(2669),
    [anon_sym_declare] = ACTIONS(2669),
    [anon_sym_public] = ACTIONS(2669),
    [anon_sym_private] = ACTIONS(2669),
    [anon_sym_protected] = ACTIONS(2669),
    [anon_sym_override] = ACTIONS(2669),
    [anon_sym_module] = ACTIONS(2669),
    [anon_sym_any] = ACTIONS(2669),
    [anon_sym_number] = ACTIONS(2669),
    [anon_sym_boolean] = ACTIONS(2669),
    [anon_sym_string] = ACTIONS(2669),
    [anon_sym_symbol] = ACTIONS(2669),
    [anon_sym_object] = ACTIONS(2669),
    [anon_sym_property] = ACTIONS(2669),
    [anon_sym_signal] = ACTIONS(2669),
    [anon_sym_on] = ACTIONS(2669),
    [anon_sym_required] = ACTIONS(2669),
    [anon_sym_component] = ACTIONS(2669),
    [anon_sym_abstract] = ACTIONS(2669),
    [anon_sym_interface] = ACTIONS(2669),
    [anon_sym_enum] = ACTIONS(2669),
    [sym_html_comment] = ACTIONS(5),
  },
  [796] = {
    [sym_comment] = STATE(796),
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_export] = ACTIONS(2673),
    [anon_sym_default] = ACTIONS(2673),
    [anon_sym_type] = ACTIONS(2673),
    [anon_sym_namespace] = ACTIONS(2673),
    [anon_sym_LBRACE] = ACTIONS(2675),
    [anon_sym_RBRACE] = ACTIONS(2675),
    [anon_sym_typeof] = ACTIONS(2673),
    [anon_sym_import] = ACTIONS(2673),
    [anon_sym_from] = ACTIONS(2673),
    [anon_sym_with] = ACTIONS(2673),
    [anon_sym_var] = ACTIONS(2673),
    [anon_sym_let] = ACTIONS(2673),
    [anon_sym_const] = ACTIONS(2673),
    [anon_sym_BANG] = ACTIONS(2675),
    [anon_sym_else] = ACTIONS(2673),
    [anon_sym_if] = ACTIONS(2673),
    [anon_sym_switch] = ACTIONS(2673),
    [anon_sym_for] = ACTIONS(2673),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_await] = ACTIONS(2673),
    [anon_sym_of] = ACTIONS(2673),
    [anon_sym_while] = ACTIONS(2673),
    [anon_sym_do] = ACTIONS(2673),
    [anon_sym_try] = ACTIONS(2673),
    [anon_sym_break] = ACTIONS(2673),
    [anon_sym_continue] = ACTIONS(2673),
    [anon_sym_debugger] = ACTIONS(2673),
    [anon_sym_return] = ACTIONS(2673),
    [anon_sym_throw] = ACTIONS(2673),
    [anon_sym_SEMI] = ACTIONS(2675),
    [anon_sym_case] = ACTIONS(2673),
    [anon_sym_yield] = ACTIONS(2673),
    [anon_sym_LBRACK] = ACTIONS(2675),
    [anon_sym_LTtemplate_GT] = ACTIONS(2675),
    [anon_sym_DQUOTE] = ACTIONS(2675),
    [anon_sym_SQUOTE] = ACTIONS(2675),
    [anon_sym_class] = ACTIONS(2673),
    [anon_sym_async] = ACTIONS(2673),
    [anon_sym_function] = ACTIONS(2673),
    [anon_sym_new] = ACTIONS(2673),
    [anon_sym_using] = ACTIONS(2673),
    [anon_sym_PLUS] = ACTIONS(2673),
    [anon_sym_DASH] = ACTIONS(2673),
    [anon_sym_SLASH] = ACTIONS(2673),
    [anon_sym_LT] = ACTIONS(2673),
    [anon_sym_TILDE] = ACTIONS(2675),
    [anon_sym_void] = ACTIONS(2673),
    [anon_sym_delete] = ACTIONS(2673),
    [anon_sym_PLUS_PLUS] = ACTIONS(2675),
    [anon_sym_DASH_DASH] = ACTIONS(2675),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2675),
    [sym_number] = ACTIONS(2675),
    [sym_private_property_identifier] = ACTIONS(2675),
    [sym_this] = ACTIONS(2673),
    [sym_super] = ACTIONS(2673),
    [sym_true] = ACTIONS(2673),
    [sym_false] = ACTIONS(2673),
    [sym_null] = ACTIONS(2673),
    [sym_undefined] = ACTIONS(2673),
    [anon_sym_AT] = ACTIONS(2675),
    [anon_sym_static] = ACTIONS(2673),
    [anon_sym_readonly] = ACTIONS(2673),
    [anon_sym_get] = ACTIONS(2673),
    [anon_sym_set] = ACTIONS(2673),
    [anon_sym_declare] = ACTIONS(2673),
    [anon_sym_public] = ACTIONS(2673),
    [anon_sym_private] = ACTIONS(2673),
    [anon_sym_protected] = ACTIONS(2673),
    [anon_sym_override] = ACTIONS(2673),
    [anon_sym_module] = ACTIONS(2673),
    [anon_sym_any] = ACTIONS(2673),
    [anon_sym_number] = ACTIONS(2673),
    [anon_sym_boolean] = ACTIONS(2673),
    [anon_sym_string] = ACTIONS(2673),
    [anon_sym_symbol] = ACTIONS(2673),
    [anon_sym_object] = ACTIONS(2673),
    [anon_sym_property] = ACTIONS(2673),
    [anon_sym_signal] = ACTIONS(2673),
    [anon_sym_on] = ACTIONS(2673),
    [anon_sym_required] = ACTIONS(2673),
    [anon_sym_component] = ACTIONS(2673),
    [anon_sym_abstract] = ACTIONS(2673),
    [anon_sym_interface] = ACTIONS(2673),
    [anon_sym_enum] = ACTIONS(2673),
    [sym_html_comment] = ACTIONS(5),
  },
  [797] = {
    [sym_comment] = STATE(797),
    [sym_identifier] = ACTIONS(2677),
    [anon_sym_export] = ACTIONS(2677),
    [anon_sym_default] = ACTIONS(2677),
    [anon_sym_type] = ACTIONS(2677),
    [anon_sym_namespace] = ACTIONS(2677),
    [anon_sym_LBRACE] = ACTIONS(2679),
    [anon_sym_RBRACE] = ACTIONS(2679),
    [anon_sym_typeof] = ACTIONS(2677),
    [anon_sym_import] = ACTIONS(2677),
    [anon_sym_from] = ACTIONS(2677),
    [anon_sym_with] = ACTIONS(2677),
    [anon_sym_var] = ACTIONS(2677),
    [anon_sym_let] = ACTIONS(2677),
    [anon_sym_const] = ACTIONS(2677),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_else] = ACTIONS(2677),
    [anon_sym_if] = ACTIONS(2677),
    [anon_sym_switch] = ACTIONS(2677),
    [anon_sym_for] = ACTIONS(2677),
    [anon_sym_LPAREN] = ACTIONS(2679),
    [anon_sym_await] = ACTIONS(2677),
    [anon_sym_of] = ACTIONS(2677),
    [anon_sym_while] = ACTIONS(2677),
    [anon_sym_do] = ACTIONS(2677),
    [anon_sym_try] = ACTIONS(2677),
    [anon_sym_break] = ACTIONS(2677),
    [anon_sym_continue] = ACTIONS(2677),
    [anon_sym_debugger] = ACTIONS(2677),
    [anon_sym_return] = ACTIONS(2677),
    [anon_sym_throw] = ACTIONS(2677),
    [anon_sym_SEMI] = ACTIONS(2679),
    [anon_sym_case] = ACTIONS(2677),
    [anon_sym_yield] = ACTIONS(2677),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_LTtemplate_GT] = ACTIONS(2679),
    [anon_sym_DQUOTE] = ACTIONS(2679),
    [anon_sym_SQUOTE] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(2677),
    [anon_sym_async] = ACTIONS(2677),
    [anon_sym_function] = ACTIONS(2677),
    [anon_sym_new] = ACTIONS(2677),
    [anon_sym_using] = ACTIONS(2677),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_DASH] = ACTIONS(2677),
    [anon_sym_SLASH] = ACTIONS(2677),
    [anon_sym_LT] = ACTIONS(2677),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_void] = ACTIONS(2677),
    [anon_sym_delete] = ACTIONS(2677),
    [anon_sym_PLUS_PLUS] = ACTIONS(2679),
    [anon_sym_DASH_DASH] = ACTIONS(2679),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2679),
    [sym_number] = ACTIONS(2679),
    [sym_private_property_identifier] = ACTIONS(2679),
    [sym_this] = ACTIONS(2677),
    [sym_super] = ACTIONS(2677),
    [sym_true] = ACTIONS(2677),
    [sym_false] = ACTIONS(2677),
    [sym_null] = ACTIONS(2677),
    [sym_undefined] = ACTIONS(2677),
    [anon_sym_AT] = ACTIONS(2679),
    [anon_sym_static] = ACTIONS(2677),
    [anon_sym_readonly] = ACTIONS(2677),
    [anon_sym_get] = ACTIONS(2677),
    [anon_sym_set] = ACTIONS(2677),
    [anon_sym_declare] = ACTIONS(2677),
    [anon_sym_public] = ACTIONS(2677),
    [anon_sym_private] = ACTIONS(2677),
    [anon_sym_protected] = ACTIONS(2677),
    [anon_sym_override] = ACTIONS(2677),
    [anon_sym_module] = ACTIONS(2677),
    [anon_sym_any] = ACTIONS(2677),
    [anon_sym_number] = ACTIONS(2677),
    [anon_sym_boolean] = ACTIONS(2677),
    [anon_sym_string] = ACTIONS(2677),
    [anon_sym_symbol] = ACTIONS(2677),
    [anon_sym_object] = ACTIONS(2677),
    [anon_sym_property] = ACTIONS(2677),
    [anon_sym_signal] = ACTIONS(2677),
    [anon_sym_on] = ACTIONS(2677),
    [anon_sym_required] = ACTIONS(2677),
    [anon_sym_component] = ACTIONS(2677),
    [anon_sym_abstract] = ACTIONS(2677),
    [anon_sym_interface] = ACTIONS(2677),
    [anon_sym_enum] = ACTIONS(2677),
    [sym_html_comment] = ACTIONS(5),
  },
  [798] = {
    [sym_comment] = STATE(798),
    [sym_identifier] = ACTIONS(2681),
    [anon_sym_export] = ACTIONS(2681),
    [anon_sym_default] = ACTIONS(2681),
    [anon_sym_type] = ACTIONS(2681),
    [anon_sym_namespace] = ACTIONS(2681),
    [anon_sym_LBRACE] = ACTIONS(2683),
    [anon_sym_RBRACE] = ACTIONS(2683),
    [anon_sym_typeof] = ACTIONS(2681),
    [anon_sym_import] = ACTIONS(2681),
    [anon_sym_from] = ACTIONS(2681),
    [anon_sym_with] = ACTIONS(2681),
    [anon_sym_var] = ACTIONS(2681),
    [anon_sym_let] = ACTIONS(2681),
    [anon_sym_const] = ACTIONS(2681),
    [anon_sym_BANG] = ACTIONS(2683),
    [anon_sym_else] = ACTIONS(2681),
    [anon_sym_if] = ACTIONS(2681),
    [anon_sym_switch] = ACTIONS(2681),
    [anon_sym_for] = ACTIONS(2681),
    [anon_sym_LPAREN] = ACTIONS(2683),
    [anon_sym_await] = ACTIONS(2681),
    [anon_sym_of] = ACTIONS(2681),
    [anon_sym_while] = ACTIONS(2681),
    [anon_sym_do] = ACTIONS(2681),
    [anon_sym_try] = ACTIONS(2681),
    [anon_sym_break] = ACTIONS(2681),
    [anon_sym_continue] = ACTIONS(2681),
    [anon_sym_debugger] = ACTIONS(2681),
    [anon_sym_return] = ACTIONS(2681),
    [anon_sym_throw] = ACTIONS(2681),
    [anon_sym_SEMI] = ACTIONS(2683),
    [anon_sym_case] = ACTIONS(2681),
    [anon_sym_yield] = ACTIONS(2681),
    [anon_sym_LBRACK] = ACTIONS(2683),
    [anon_sym_LTtemplate_GT] = ACTIONS(2683),
    [anon_sym_DQUOTE] = ACTIONS(2683),
    [anon_sym_SQUOTE] = ACTIONS(2683),
    [anon_sym_class] = ACTIONS(2681),
    [anon_sym_async] = ACTIONS(2681),
    [anon_sym_function] = ACTIONS(2681),
    [anon_sym_new] = ACTIONS(2681),
    [anon_sym_using] = ACTIONS(2681),
    [anon_sym_PLUS] = ACTIONS(2681),
    [anon_sym_DASH] = ACTIONS(2681),
    [anon_sym_SLASH] = ACTIONS(2681),
    [anon_sym_LT] = ACTIONS(2681),
    [anon_sym_TILDE] = ACTIONS(2683),
    [anon_sym_void] = ACTIONS(2681),
    [anon_sym_delete] = ACTIONS(2681),
    [anon_sym_PLUS_PLUS] = ACTIONS(2683),
    [anon_sym_DASH_DASH] = ACTIONS(2683),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2683),
    [sym_number] = ACTIONS(2683),
    [sym_private_property_identifier] = ACTIONS(2683),
    [sym_this] = ACTIONS(2681),
    [sym_super] = ACTIONS(2681),
    [sym_true] = ACTIONS(2681),
    [sym_false] = ACTIONS(2681),
    [sym_null] = ACTIONS(2681),
    [sym_undefined] = ACTIONS(2681),
    [anon_sym_AT] = ACTIONS(2683),
    [anon_sym_static] = ACTIONS(2681),
    [anon_sym_readonly] = ACTIONS(2681),
    [anon_sym_get] = ACTIONS(2681),
    [anon_sym_set] = ACTIONS(2681),
    [anon_sym_declare] = ACTIONS(2681),
    [anon_sym_public] = ACTIONS(2681),
    [anon_sym_private] = ACTIONS(2681),
    [anon_sym_protected] = ACTIONS(2681),
    [anon_sym_override] = ACTIONS(2681),
    [anon_sym_module] = ACTIONS(2681),
    [anon_sym_any] = ACTIONS(2681),
    [anon_sym_number] = ACTIONS(2681),
    [anon_sym_boolean] = ACTIONS(2681),
    [anon_sym_string] = ACTIONS(2681),
    [anon_sym_symbol] = ACTIONS(2681),
    [anon_sym_object] = ACTIONS(2681),
    [anon_sym_property] = ACTIONS(2681),
    [anon_sym_signal] = ACTIONS(2681),
    [anon_sym_on] = ACTIONS(2681),
    [anon_sym_required] = ACTIONS(2681),
    [anon_sym_component] = ACTIONS(2681),
    [anon_sym_abstract] = ACTIONS(2681),
    [anon_sym_interface] = ACTIONS(2681),
    [anon_sym_enum] = ACTIONS(2681),
    [sym_html_comment] = ACTIONS(5),
  },
  [799] = {
    [sym_comment] = STATE(799),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_export] = ACTIONS(2685),
    [anon_sym_default] = ACTIONS(2685),
    [anon_sym_type] = ACTIONS(2685),
    [anon_sym_namespace] = ACTIONS(2685),
    [anon_sym_LBRACE] = ACTIONS(2687),
    [anon_sym_RBRACE] = ACTIONS(2687),
    [anon_sym_typeof] = ACTIONS(2685),
    [anon_sym_import] = ACTIONS(2685),
    [anon_sym_from] = ACTIONS(2685),
    [anon_sym_with] = ACTIONS(2685),
    [anon_sym_var] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_const] = ACTIONS(2685),
    [anon_sym_BANG] = ACTIONS(2687),
    [anon_sym_else] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_switch] = ACTIONS(2685),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_LPAREN] = ACTIONS(2687),
    [anon_sym_await] = ACTIONS(2685),
    [anon_sym_of] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_break] = ACTIONS(2685),
    [anon_sym_continue] = ACTIONS(2685),
    [anon_sym_debugger] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_throw] = ACTIONS(2685),
    [anon_sym_SEMI] = ACTIONS(2687),
    [anon_sym_case] = ACTIONS(2685),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2687),
    [anon_sym_LTtemplate_GT] = ACTIONS(2687),
    [anon_sym_DQUOTE] = ACTIONS(2687),
    [anon_sym_SQUOTE] = ACTIONS(2687),
    [anon_sym_class] = ACTIONS(2685),
    [anon_sym_async] = ACTIONS(2685),
    [anon_sym_function] = ACTIONS(2685),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_using] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_SLASH] = ACTIONS(2685),
    [anon_sym_LT] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2687),
    [anon_sym_void] = ACTIONS(2685),
    [anon_sym_delete] = ACTIONS(2685),
    [anon_sym_PLUS_PLUS] = ACTIONS(2687),
    [anon_sym_DASH_DASH] = ACTIONS(2687),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2687),
    [sym_number] = ACTIONS(2687),
    [sym_private_property_identifier] = ACTIONS(2687),
    [sym_this] = ACTIONS(2685),
    [sym_super] = ACTIONS(2685),
    [sym_true] = ACTIONS(2685),
    [sym_false] = ACTIONS(2685),
    [sym_null] = ACTIONS(2685),
    [sym_undefined] = ACTIONS(2685),
    [anon_sym_AT] = ACTIONS(2687),
    [anon_sym_static] = ACTIONS(2685),
    [anon_sym_readonly] = ACTIONS(2685),
    [anon_sym_get] = ACTIONS(2685),
    [anon_sym_set] = ACTIONS(2685),
    [anon_sym_declare] = ACTIONS(2685),
    [anon_sym_public] = ACTIONS(2685),
    [anon_sym_private] = ACTIONS(2685),
    [anon_sym_protected] = ACTIONS(2685),
    [anon_sym_override] = ACTIONS(2685),
    [anon_sym_module] = ACTIONS(2685),
    [anon_sym_any] = ACTIONS(2685),
    [anon_sym_number] = ACTIONS(2685),
    [anon_sym_boolean] = ACTIONS(2685),
    [anon_sym_string] = ACTIONS(2685),
    [anon_sym_symbol] = ACTIONS(2685),
    [anon_sym_object] = ACTIONS(2685),
    [anon_sym_property] = ACTIONS(2685),
    [anon_sym_signal] = ACTIONS(2685),
    [anon_sym_on] = ACTIONS(2685),
    [anon_sym_required] = ACTIONS(2685),
    [anon_sym_component] = ACTIONS(2685),
    [anon_sym_abstract] = ACTIONS(2685),
    [anon_sym_interface] = ACTIONS(2685),
    [anon_sym_enum] = ACTIONS(2685),
    [sym_html_comment] = ACTIONS(5),
  },
  [800] = {
    [sym_comment] = STATE(800),
    [sym_identifier] = ACTIONS(2689),
    [anon_sym_export] = ACTIONS(2689),
    [anon_sym_default] = ACTIONS(2689),
    [anon_sym_type] = ACTIONS(2689),
    [anon_sym_namespace] = ACTIONS(2689),
    [anon_sym_LBRACE] = ACTIONS(2691),
    [anon_sym_RBRACE] = ACTIONS(2691),
    [anon_sym_typeof] = ACTIONS(2689),
    [anon_sym_import] = ACTIONS(2689),
    [anon_sym_from] = ACTIONS(2689),
    [anon_sym_with] = ACTIONS(2689),
    [anon_sym_var] = ACTIONS(2689),
    [anon_sym_let] = ACTIONS(2689),
    [anon_sym_const] = ACTIONS(2689),
    [anon_sym_BANG] = ACTIONS(2691),
    [anon_sym_else] = ACTIONS(2689),
    [anon_sym_if] = ACTIONS(2689),
    [anon_sym_switch] = ACTIONS(2689),
    [anon_sym_for] = ACTIONS(2689),
    [anon_sym_LPAREN] = ACTIONS(2691),
    [anon_sym_await] = ACTIONS(2689),
    [anon_sym_of] = ACTIONS(2689),
    [anon_sym_while] = ACTIONS(2689),
    [anon_sym_do] = ACTIONS(2689),
    [anon_sym_try] = ACTIONS(2689),
    [anon_sym_break] = ACTIONS(2689),
    [anon_sym_continue] = ACTIONS(2689),
    [anon_sym_debugger] = ACTIONS(2689),
    [anon_sym_return] = ACTIONS(2689),
    [anon_sym_throw] = ACTIONS(2689),
    [anon_sym_SEMI] = ACTIONS(2691),
    [anon_sym_case] = ACTIONS(2689),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_LBRACK] = ACTIONS(2691),
    [anon_sym_LTtemplate_GT] = ACTIONS(2691),
    [anon_sym_DQUOTE] = ACTIONS(2691),
    [anon_sym_SQUOTE] = ACTIONS(2691),
    [anon_sym_class] = ACTIONS(2689),
    [anon_sym_async] = ACTIONS(2689),
    [anon_sym_function] = ACTIONS(2689),
    [anon_sym_new] = ACTIONS(2689),
    [anon_sym_using] = ACTIONS(2689),
    [anon_sym_PLUS] = ACTIONS(2689),
    [anon_sym_DASH] = ACTIONS(2689),
    [anon_sym_SLASH] = ACTIONS(2689),
    [anon_sym_LT] = ACTIONS(2689),
    [anon_sym_TILDE] = ACTIONS(2691),
    [anon_sym_void] = ACTIONS(2689),
    [anon_sym_delete] = ACTIONS(2689),
    [anon_sym_PLUS_PLUS] = ACTIONS(2691),
    [anon_sym_DASH_DASH] = ACTIONS(2691),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2691),
    [sym_number] = ACTIONS(2691),
    [sym_private_property_identifier] = ACTIONS(2691),
    [sym_this] = ACTIONS(2689),
    [sym_super] = ACTIONS(2689),
    [sym_true] = ACTIONS(2689),
    [sym_false] = ACTIONS(2689),
    [sym_null] = ACTIONS(2689),
    [sym_undefined] = ACTIONS(2689),
    [anon_sym_AT] = ACTIONS(2691),
    [anon_sym_static] = ACTIONS(2689),
    [anon_sym_readonly] = ACTIONS(2689),
    [anon_sym_get] = ACTIONS(2689),
    [anon_sym_set] = ACTIONS(2689),
    [anon_sym_declare] = ACTIONS(2689),
    [anon_sym_public] = ACTIONS(2689),
    [anon_sym_private] = ACTIONS(2689),
    [anon_sym_protected] = ACTIONS(2689),
    [anon_sym_override] = ACTIONS(2689),
    [anon_sym_module] = ACTIONS(2689),
    [anon_sym_any] = ACTIONS(2689),
    [anon_sym_number] = ACTIONS(2689),
    [anon_sym_boolean] = ACTIONS(2689),
    [anon_sym_string] = ACTIONS(2689),
    [anon_sym_symbol] = ACTIONS(2689),
    [anon_sym_object] = ACTIONS(2689),
    [anon_sym_property] = ACTIONS(2689),
    [anon_sym_signal] = ACTIONS(2689),
    [anon_sym_on] = ACTIONS(2689),
    [anon_sym_required] = ACTIONS(2689),
    [anon_sym_component] = ACTIONS(2689),
    [anon_sym_abstract] = ACTIONS(2689),
    [anon_sym_interface] = ACTIONS(2689),
    [anon_sym_enum] = ACTIONS(2689),
    [sym_html_comment] = ACTIONS(5),
  },
  [801] = {
    [sym_comment] = STATE(801),
    [sym_identifier] = ACTIONS(1896),
    [anon_sym_export] = ACTIONS(1896),
    [anon_sym_default] = ACTIONS(1896),
    [anon_sym_type] = ACTIONS(1896),
    [anon_sym_namespace] = ACTIONS(1896),
    [anon_sym_LBRACE] = ACTIONS(1898),
    [anon_sym_RBRACE] = ACTIONS(1898),
    [anon_sym_typeof] = ACTIONS(1896),
    [anon_sym_import] = ACTIONS(1896),
    [anon_sym_from] = ACTIONS(1896),
    [anon_sym_with] = ACTIONS(1896),
    [anon_sym_var] = ACTIONS(1896),
    [anon_sym_let] = ACTIONS(1896),
    [anon_sym_const] = ACTIONS(1896),
    [anon_sym_BANG] = ACTIONS(1898),
    [anon_sym_else] = ACTIONS(1896),
    [anon_sym_if] = ACTIONS(1896),
    [anon_sym_switch] = ACTIONS(1896),
    [anon_sym_for] = ACTIONS(1896),
    [anon_sym_LPAREN] = ACTIONS(1898),
    [anon_sym_await] = ACTIONS(1896),
    [anon_sym_of] = ACTIONS(1896),
    [anon_sym_while] = ACTIONS(1896),
    [anon_sym_do] = ACTIONS(1896),
    [anon_sym_try] = ACTIONS(1896),
    [anon_sym_break] = ACTIONS(1896),
    [anon_sym_continue] = ACTIONS(1896),
    [anon_sym_debugger] = ACTIONS(1896),
    [anon_sym_return] = ACTIONS(1896),
    [anon_sym_throw] = ACTIONS(1896),
    [anon_sym_SEMI] = ACTIONS(1898),
    [anon_sym_case] = ACTIONS(1896),
    [anon_sym_yield] = ACTIONS(1896),
    [anon_sym_LBRACK] = ACTIONS(1898),
    [anon_sym_LTtemplate_GT] = ACTIONS(1898),
    [anon_sym_DQUOTE] = ACTIONS(1898),
    [anon_sym_SQUOTE] = ACTIONS(1898),
    [anon_sym_class] = ACTIONS(1896),
    [anon_sym_async] = ACTIONS(1896),
    [anon_sym_function] = ACTIONS(1896),
    [anon_sym_new] = ACTIONS(1896),
    [anon_sym_using] = ACTIONS(1896),
    [anon_sym_PLUS] = ACTIONS(1896),
    [anon_sym_DASH] = ACTIONS(1896),
    [anon_sym_SLASH] = ACTIONS(1896),
    [anon_sym_LT] = ACTIONS(1896),
    [anon_sym_TILDE] = ACTIONS(1898),
    [anon_sym_void] = ACTIONS(1896),
    [anon_sym_delete] = ACTIONS(1896),
    [anon_sym_PLUS_PLUS] = ACTIONS(1898),
    [anon_sym_DASH_DASH] = ACTIONS(1898),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1898),
    [sym_number] = ACTIONS(1898),
    [sym_private_property_identifier] = ACTIONS(1898),
    [sym_this] = ACTIONS(1896),
    [sym_super] = ACTIONS(1896),
    [sym_true] = ACTIONS(1896),
    [sym_false] = ACTIONS(1896),
    [sym_null] = ACTIONS(1896),
    [sym_undefined] = ACTIONS(1896),
    [anon_sym_AT] = ACTIONS(1898),
    [anon_sym_static] = ACTIONS(1896),
    [anon_sym_readonly] = ACTIONS(1896),
    [anon_sym_get] = ACTIONS(1896),
    [anon_sym_set] = ACTIONS(1896),
    [anon_sym_declare] = ACTIONS(1896),
    [anon_sym_public] = ACTIONS(1896),
    [anon_sym_private] = ACTIONS(1896),
    [anon_sym_protected] = ACTIONS(1896),
    [anon_sym_override] = ACTIONS(1896),
    [anon_sym_module] = ACTIONS(1896),
    [anon_sym_any] = ACTIONS(1896),
    [anon_sym_number] = ACTIONS(1896),
    [anon_sym_boolean] = ACTIONS(1896),
    [anon_sym_string] = ACTIONS(1896),
    [anon_sym_symbol] = ACTIONS(1896),
    [anon_sym_object] = ACTIONS(1896),
    [anon_sym_property] = ACTIONS(1896),
    [anon_sym_signal] = ACTIONS(1896),
    [anon_sym_on] = ACTIONS(1896),
    [anon_sym_required] = ACTIONS(1896),
    [anon_sym_component] = ACTIONS(1896),
    [anon_sym_abstract] = ACTIONS(1896),
    [anon_sym_interface] = ACTIONS(1896),
    [anon_sym_enum] = ACTIONS(1896),
    [sym_html_comment] = ACTIONS(5),
  },
  [802] = {
    [sym_comment] = STATE(802),
    [sym_identifier] = ACTIONS(2693),
    [anon_sym_export] = ACTIONS(2693),
    [anon_sym_default] = ACTIONS(2693),
    [anon_sym_type] = ACTIONS(2693),
    [anon_sym_namespace] = ACTIONS(2693),
    [anon_sym_LBRACE] = ACTIONS(2695),
    [anon_sym_RBRACE] = ACTIONS(2695),
    [anon_sym_typeof] = ACTIONS(2693),
    [anon_sym_import] = ACTIONS(2693),
    [anon_sym_from] = ACTIONS(2693),
    [anon_sym_with] = ACTIONS(2693),
    [anon_sym_var] = ACTIONS(2693),
    [anon_sym_let] = ACTIONS(2693),
    [anon_sym_const] = ACTIONS(2693),
    [anon_sym_BANG] = ACTIONS(2695),
    [anon_sym_else] = ACTIONS(2693),
    [anon_sym_if] = ACTIONS(2693),
    [anon_sym_switch] = ACTIONS(2693),
    [anon_sym_for] = ACTIONS(2693),
    [anon_sym_LPAREN] = ACTIONS(2695),
    [anon_sym_await] = ACTIONS(2693),
    [anon_sym_of] = ACTIONS(2693),
    [anon_sym_while] = ACTIONS(2693),
    [anon_sym_do] = ACTIONS(2693),
    [anon_sym_try] = ACTIONS(2693),
    [anon_sym_break] = ACTIONS(2693),
    [anon_sym_continue] = ACTIONS(2693),
    [anon_sym_debugger] = ACTIONS(2693),
    [anon_sym_return] = ACTIONS(2693),
    [anon_sym_throw] = ACTIONS(2693),
    [anon_sym_SEMI] = ACTIONS(2695),
    [anon_sym_case] = ACTIONS(2693),
    [anon_sym_yield] = ACTIONS(2693),
    [anon_sym_LBRACK] = ACTIONS(2695),
    [anon_sym_LTtemplate_GT] = ACTIONS(2695),
    [anon_sym_DQUOTE] = ACTIONS(2695),
    [anon_sym_SQUOTE] = ACTIONS(2695),
    [anon_sym_class] = ACTIONS(2693),
    [anon_sym_async] = ACTIONS(2693),
    [anon_sym_function] = ACTIONS(2693),
    [anon_sym_new] = ACTIONS(2693),
    [anon_sym_using] = ACTIONS(2693),
    [anon_sym_PLUS] = ACTIONS(2693),
    [anon_sym_DASH] = ACTIONS(2693),
    [anon_sym_SLASH] = ACTIONS(2693),
    [anon_sym_LT] = ACTIONS(2693),
    [anon_sym_TILDE] = ACTIONS(2695),
    [anon_sym_void] = ACTIONS(2693),
    [anon_sym_delete] = ACTIONS(2693),
    [anon_sym_PLUS_PLUS] = ACTIONS(2695),
    [anon_sym_DASH_DASH] = ACTIONS(2695),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2695),
    [sym_number] = ACTIONS(2695),
    [sym_private_property_identifier] = ACTIONS(2695),
    [sym_this] = ACTIONS(2693),
    [sym_super] = ACTIONS(2693),
    [sym_true] = ACTIONS(2693),
    [sym_false] = ACTIONS(2693),
    [sym_null] = ACTIONS(2693),
    [sym_undefined] = ACTIONS(2693),
    [anon_sym_AT] = ACTIONS(2695),
    [anon_sym_static] = ACTIONS(2693),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_get] = ACTIONS(2693),
    [anon_sym_set] = ACTIONS(2693),
    [anon_sym_declare] = ACTIONS(2693),
    [anon_sym_public] = ACTIONS(2693),
    [anon_sym_private] = ACTIONS(2693),
    [anon_sym_protected] = ACTIONS(2693),
    [anon_sym_override] = ACTIONS(2693),
    [anon_sym_module] = ACTIONS(2693),
    [anon_sym_any] = ACTIONS(2693),
    [anon_sym_number] = ACTIONS(2693),
    [anon_sym_boolean] = ACTIONS(2693),
    [anon_sym_string] = ACTIONS(2693),
    [anon_sym_symbol] = ACTIONS(2693),
    [anon_sym_object] = ACTIONS(2693),
    [anon_sym_property] = ACTIONS(2693),
    [anon_sym_signal] = ACTIONS(2693),
    [anon_sym_on] = ACTIONS(2693),
    [anon_sym_required] = ACTIONS(2693),
    [anon_sym_component] = ACTIONS(2693),
    [anon_sym_abstract] = ACTIONS(2693),
    [anon_sym_interface] = ACTIONS(2693),
    [anon_sym_enum] = ACTIONS(2693),
    [sym_html_comment] = ACTIONS(5),
  },
  [803] = {
    [sym_comment] = STATE(803),
    [sym_identifier] = ACTIONS(2697),
    [anon_sym_export] = ACTIONS(2697),
    [anon_sym_default] = ACTIONS(2697),
    [anon_sym_type] = ACTIONS(2697),
    [anon_sym_namespace] = ACTIONS(2697),
    [anon_sym_LBRACE] = ACTIONS(2699),
    [anon_sym_RBRACE] = ACTIONS(2699),
    [anon_sym_typeof] = ACTIONS(2697),
    [anon_sym_import] = ACTIONS(2697),
    [anon_sym_from] = ACTIONS(2697),
    [anon_sym_with] = ACTIONS(2697),
    [anon_sym_var] = ACTIONS(2697),
    [anon_sym_let] = ACTIONS(2697),
    [anon_sym_const] = ACTIONS(2697),
    [anon_sym_BANG] = ACTIONS(2699),
    [anon_sym_else] = ACTIONS(2697),
    [anon_sym_if] = ACTIONS(2697),
    [anon_sym_switch] = ACTIONS(2697),
    [anon_sym_for] = ACTIONS(2697),
    [anon_sym_LPAREN] = ACTIONS(2699),
    [anon_sym_await] = ACTIONS(2697),
    [anon_sym_of] = ACTIONS(2697),
    [anon_sym_while] = ACTIONS(2697),
    [anon_sym_do] = ACTIONS(2697),
    [anon_sym_try] = ACTIONS(2697),
    [anon_sym_break] = ACTIONS(2697),
    [anon_sym_continue] = ACTIONS(2697),
    [anon_sym_debugger] = ACTIONS(2697),
    [anon_sym_return] = ACTIONS(2697),
    [anon_sym_throw] = ACTIONS(2697),
    [anon_sym_SEMI] = ACTIONS(2699),
    [anon_sym_case] = ACTIONS(2697),
    [anon_sym_yield] = ACTIONS(2697),
    [anon_sym_LBRACK] = ACTIONS(2699),
    [anon_sym_LTtemplate_GT] = ACTIONS(2699),
    [anon_sym_DQUOTE] = ACTIONS(2699),
    [anon_sym_SQUOTE] = ACTIONS(2699),
    [anon_sym_class] = ACTIONS(2697),
    [anon_sym_async] = ACTIONS(2697),
    [anon_sym_function] = ACTIONS(2697),
    [anon_sym_new] = ACTIONS(2697),
    [anon_sym_using] = ACTIONS(2697),
    [anon_sym_PLUS] = ACTIONS(2697),
    [anon_sym_DASH] = ACTIONS(2697),
    [anon_sym_SLASH] = ACTIONS(2697),
    [anon_sym_LT] = ACTIONS(2697),
    [anon_sym_TILDE] = ACTIONS(2699),
    [anon_sym_void] = ACTIONS(2697),
    [anon_sym_delete] = ACTIONS(2697),
    [anon_sym_PLUS_PLUS] = ACTIONS(2699),
    [anon_sym_DASH_DASH] = ACTIONS(2699),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2699),
    [sym_number] = ACTIONS(2699),
    [sym_private_property_identifier] = ACTIONS(2699),
    [sym_this] = ACTIONS(2697),
    [sym_super] = ACTIONS(2697),
    [sym_true] = ACTIONS(2697),
    [sym_false] = ACTIONS(2697),
    [sym_null] = ACTIONS(2697),
    [sym_undefined] = ACTIONS(2697),
    [anon_sym_AT] = ACTIONS(2699),
    [anon_sym_static] = ACTIONS(2697),
    [anon_sym_readonly] = ACTIONS(2697),
    [anon_sym_get] = ACTIONS(2697),
    [anon_sym_set] = ACTIONS(2697),
    [anon_sym_declare] = ACTIONS(2697),
    [anon_sym_public] = ACTIONS(2697),
    [anon_sym_private] = ACTIONS(2697),
    [anon_sym_protected] = ACTIONS(2697),
    [anon_sym_override] = ACTIONS(2697),
    [anon_sym_module] = ACTIONS(2697),
    [anon_sym_any] = ACTIONS(2697),
    [anon_sym_number] = ACTIONS(2697),
    [anon_sym_boolean] = ACTIONS(2697),
    [anon_sym_string] = ACTIONS(2697),
    [anon_sym_symbol] = ACTIONS(2697),
    [anon_sym_object] = ACTIONS(2697),
    [anon_sym_property] = ACTIONS(2697),
    [anon_sym_signal] = ACTIONS(2697),
    [anon_sym_on] = ACTIONS(2697),
    [anon_sym_required] = ACTIONS(2697),
    [anon_sym_component] = ACTIONS(2697),
    [anon_sym_abstract] = ACTIONS(2697),
    [anon_sym_interface] = ACTIONS(2697),
    [anon_sym_enum] = ACTIONS(2697),
    [sym_html_comment] = ACTIONS(5),
  },
  [804] = {
    [sym_comment] = STATE(804),
    [sym_identifier] = ACTIONS(2701),
    [anon_sym_export] = ACTIONS(2701),
    [anon_sym_default] = ACTIONS(2701),
    [anon_sym_type] = ACTIONS(2701),
    [anon_sym_namespace] = ACTIONS(2701),
    [anon_sym_LBRACE] = ACTIONS(2703),
    [anon_sym_RBRACE] = ACTIONS(2703),
    [anon_sym_typeof] = ACTIONS(2701),
    [anon_sym_import] = ACTIONS(2701),
    [anon_sym_from] = ACTIONS(2701),
    [anon_sym_with] = ACTIONS(2701),
    [anon_sym_var] = ACTIONS(2701),
    [anon_sym_let] = ACTIONS(2701),
    [anon_sym_const] = ACTIONS(2701),
    [anon_sym_BANG] = ACTIONS(2703),
    [anon_sym_else] = ACTIONS(2701),
    [anon_sym_if] = ACTIONS(2701),
    [anon_sym_switch] = ACTIONS(2701),
    [anon_sym_for] = ACTIONS(2701),
    [anon_sym_LPAREN] = ACTIONS(2703),
    [anon_sym_await] = ACTIONS(2701),
    [anon_sym_of] = ACTIONS(2701),
    [anon_sym_while] = ACTIONS(2701),
    [anon_sym_do] = ACTIONS(2701),
    [anon_sym_try] = ACTIONS(2701),
    [anon_sym_break] = ACTIONS(2701),
    [anon_sym_continue] = ACTIONS(2701),
    [anon_sym_debugger] = ACTIONS(2701),
    [anon_sym_return] = ACTIONS(2701),
    [anon_sym_throw] = ACTIONS(2701),
    [anon_sym_SEMI] = ACTIONS(2703),
    [anon_sym_case] = ACTIONS(2701),
    [anon_sym_yield] = ACTIONS(2701),
    [anon_sym_LBRACK] = ACTIONS(2703),
    [anon_sym_LTtemplate_GT] = ACTIONS(2703),
    [anon_sym_DQUOTE] = ACTIONS(2703),
    [anon_sym_SQUOTE] = ACTIONS(2703),
    [anon_sym_class] = ACTIONS(2701),
    [anon_sym_async] = ACTIONS(2701),
    [anon_sym_function] = ACTIONS(2701),
    [anon_sym_new] = ACTIONS(2701),
    [anon_sym_using] = ACTIONS(2701),
    [anon_sym_PLUS] = ACTIONS(2701),
    [anon_sym_DASH] = ACTIONS(2701),
    [anon_sym_SLASH] = ACTIONS(2701),
    [anon_sym_LT] = ACTIONS(2701),
    [anon_sym_TILDE] = ACTIONS(2703),
    [anon_sym_void] = ACTIONS(2701),
    [anon_sym_delete] = ACTIONS(2701),
    [anon_sym_PLUS_PLUS] = ACTIONS(2703),
    [anon_sym_DASH_DASH] = ACTIONS(2703),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2703),
    [sym_number] = ACTIONS(2703),
    [sym_private_property_identifier] = ACTIONS(2703),
    [sym_this] = ACTIONS(2701),
    [sym_super] = ACTIONS(2701),
    [sym_true] = ACTIONS(2701),
    [sym_false] = ACTIONS(2701),
    [sym_null] = ACTIONS(2701),
    [sym_undefined] = ACTIONS(2701),
    [anon_sym_AT] = ACTIONS(2703),
    [anon_sym_static] = ACTIONS(2701),
    [anon_sym_readonly] = ACTIONS(2701),
    [anon_sym_get] = ACTIONS(2701),
    [anon_sym_set] = ACTIONS(2701),
    [anon_sym_declare] = ACTIONS(2701),
    [anon_sym_public] = ACTIONS(2701),
    [anon_sym_private] = ACTIONS(2701),
    [anon_sym_protected] = ACTIONS(2701),
    [anon_sym_override] = ACTIONS(2701),
    [anon_sym_module] = ACTIONS(2701),
    [anon_sym_any] = ACTIONS(2701),
    [anon_sym_number] = ACTIONS(2701),
    [anon_sym_boolean] = ACTIONS(2701),
    [anon_sym_string] = ACTIONS(2701),
    [anon_sym_symbol] = ACTIONS(2701),
    [anon_sym_object] = ACTIONS(2701),
    [anon_sym_property] = ACTIONS(2701),
    [anon_sym_signal] = ACTIONS(2701),
    [anon_sym_on] = ACTIONS(2701),
    [anon_sym_required] = ACTIONS(2701),
    [anon_sym_component] = ACTIONS(2701),
    [anon_sym_abstract] = ACTIONS(2701),
    [anon_sym_interface] = ACTIONS(2701),
    [anon_sym_enum] = ACTIONS(2701),
    [sym_html_comment] = ACTIONS(5),
  },
  [805] = {
    [sym_comment] = STATE(805),
    [sym_identifier] = ACTIONS(2705),
    [anon_sym_export] = ACTIONS(2705),
    [anon_sym_default] = ACTIONS(2705),
    [anon_sym_type] = ACTIONS(2705),
    [anon_sym_namespace] = ACTIONS(2705),
    [anon_sym_LBRACE] = ACTIONS(2707),
    [anon_sym_RBRACE] = ACTIONS(2707),
    [anon_sym_typeof] = ACTIONS(2705),
    [anon_sym_import] = ACTIONS(2705),
    [anon_sym_from] = ACTIONS(2705),
    [anon_sym_with] = ACTIONS(2705),
    [anon_sym_var] = ACTIONS(2705),
    [anon_sym_let] = ACTIONS(2705),
    [anon_sym_const] = ACTIONS(2705),
    [anon_sym_BANG] = ACTIONS(2707),
    [anon_sym_else] = ACTIONS(2705),
    [anon_sym_if] = ACTIONS(2705),
    [anon_sym_switch] = ACTIONS(2705),
    [anon_sym_for] = ACTIONS(2705),
    [anon_sym_LPAREN] = ACTIONS(2707),
    [anon_sym_await] = ACTIONS(2705),
    [anon_sym_of] = ACTIONS(2705),
    [anon_sym_while] = ACTIONS(2705),
    [anon_sym_do] = ACTIONS(2705),
    [anon_sym_try] = ACTIONS(2705),
    [anon_sym_break] = ACTIONS(2705),
    [anon_sym_continue] = ACTIONS(2705),
    [anon_sym_debugger] = ACTIONS(2705),
    [anon_sym_return] = ACTIONS(2705),
    [anon_sym_throw] = ACTIONS(2705),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_case] = ACTIONS(2705),
    [anon_sym_yield] = ACTIONS(2705),
    [anon_sym_LBRACK] = ACTIONS(2707),
    [anon_sym_LTtemplate_GT] = ACTIONS(2707),
    [anon_sym_DQUOTE] = ACTIONS(2707),
    [anon_sym_SQUOTE] = ACTIONS(2707),
    [anon_sym_class] = ACTIONS(2705),
    [anon_sym_async] = ACTIONS(2705),
    [anon_sym_function] = ACTIONS(2705),
    [anon_sym_new] = ACTIONS(2705),
    [anon_sym_using] = ACTIONS(2705),
    [anon_sym_PLUS] = ACTIONS(2705),
    [anon_sym_DASH] = ACTIONS(2705),
    [anon_sym_SLASH] = ACTIONS(2705),
    [anon_sym_LT] = ACTIONS(2705),
    [anon_sym_TILDE] = ACTIONS(2707),
    [anon_sym_void] = ACTIONS(2705),
    [anon_sym_delete] = ACTIONS(2705),
    [anon_sym_PLUS_PLUS] = ACTIONS(2707),
    [anon_sym_DASH_DASH] = ACTIONS(2707),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2707),
    [sym_number] = ACTIONS(2707),
    [sym_private_property_identifier] = ACTIONS(2707),
    [sym_this] = ACTIONS(2705),
    [sym_super] = ACTIONS(2705),
    [sym_true] = ACTIONS(2705),
    [sym_false] = ACTIONS(2705),
    [sym_null] = ACTIONS(2705),
    [sym_undefined] = ACTIONS(2705),
    [anon_sym_AT] = ACTIONS(2707),
    [anon_sym_static] = ACTIONS(2705),
    [anon_sym_readonly] = ACTIONS(2705),
    [anon_sym_get] = ACTIONS(2705),
    [anon_sym_set] = ACTIONS(2705),
    [anon_sym_declare] = ACTIONS(2705),
    [anon_sym_public] = ACTIONS(2705),
    [anon_sym_private] = ACTIONS(2705),
    [anon_sym_protected] = ACTIONS(2705),
    [anon_sym_override] = ACTIONS(2705),
    [anon_sym_module] = ACTIONS(2705),
    [anon_sym_any] = ACTIONS(2705),
    [anon_sym_number] = ACTIONS(2705),
    [anon_sym_boolean] = ACTIONS(2705),
    [anon_sym_string] = ACTIONS(2705),
    [anon_sym_symbol] = ACTIONS(2705),
    [anon_sym_object] = ACTIONS(2705),
    [anon_sym_property] = ACTIONS(2705),
    [anon_sym_signal] = ACTIONS(2705),
    [anon_sym_on] = ACTIONS(2705),
    [anon_sym_required] = ACTIONS(2705),
    [anon_sym_component] = ACTIONS(2705),
    [anon_sym_abstract] = ACTIONS(2705),
    [anon_sym_interface] = ACTIONS(2705),
    [anon_sym_enum] = ACTIONS(2705),
    [sym_html_comment] = ACTIONS(5),
  },
  [806] = {
    [sym_comment] = STATE(806),
    [sym_identifier] = ACTIONS(2709),
    [anon_sym_export] = ACTIONS(2709),
    [anon_sym_default] = ACTIONS(2709),
    [anon_sym_type] = ACTIONS(2709),
    [anon_sym_namespace] = ACTIONS(2709),
    [anon_sym_LBRACE] = ACTIONS(2711),
    [anon_sym_RBRACE] = ACTIONS(2711),
    [anon_sym_typeof] = ACTIONS(2709),
    [anon_sym_import] = ACTIONS(2709),
    [anon_sym_from] = ACTIONS(2709),
    [anon_sym_with] = ACTIONS(2709),
    [anon_sym_var] = ACTIONS(2709),
    [anon_sym_let] = ACTIONS(2709),
    [anon_sym_const] = ACTIONS(2709),
    [anon_sym_BANG] = ACTIONS(2711),
    [anon_sym_else] = ACTIONS(2709),
    [anon_sym_if] = ACTIONS(2709),
    [anon_sym_switch] = ACTIONS(2709),
    [anon_sym_for] = ACTIONS(2709),
    [anon_sym_LPAREN] = ACTIONS(2711),
    [anon_sym_await] = ACTIONS(2709),
    [anon_sym_of] = ACTIONS(2709),
    [anon_sym_while] = ACTIONS(2709),
    [anon_sym_do] = ACTIONS(2709),
    [anon_sym_try] = ACTIONS(2709),
    [anon_sym_break] = ACTIONS(2709),
    [anon_sym_continue] = ACTIONS(2709),
    [anon_sym_debugger] = ACTIONS(2709),
    [anon_sym_return] = ACTIONS(2709),
    [anon_sym_throw] = ACTIONS(2709),
    [anon_sym_SEMI] = ACTIONS(2711),
    [anon_sym_case] = ACTIONS(2709),
    [anon_sym_yield] = ACTIONS(2709),
    [anon_sym_LBRACK] = ACTIONS(2711),
    [anon_sym_LTtemplate_GT] = ACTIONS(2711),
    [anon_sym_DQUOTE] = ACTIONS(2711),
    [anon_sym_SQUOTE] = ACTIONS(2711),
    [anon_sym_class] = ACTIONS(2709),
    [anon_sym_async] = ACTIONS(2709),
    [anon_sym_function] = ACTIONS(2709),
    [anon_sym_new] = ACTIONS(2709),
    [anon_sym_using] = ACTIONS(2709),
    [anon_sym_PLUS] = ACTIONS(2709),
    [anon_sym_DASH] = ACTIONS(2709),
    [anon_sym_SLASH] = ACTIONS(2709),
    [anon_sym_LT] = ACTIONS(2709),
    [anon_sym_TILDE] = ACTIONS(2711),
    [anon_sym_void] = ACTIONS(2709),
    [anon_sym_delete] = ACTIONS(2709),
    [anon_sym_PLUS_PLUS] = ACTIONS(2711),
    [anon_sym_DASH_DASH] = ACTIONS(2711),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2711),
    [sym_number] = ACTIONS(2711),
    [sym_private_property_identifier] = ACTIONS(2711),
    [sym_this] = ACTIONS(2709),
    [sym_super] = ACTIONS(2709),
    [sym_true] = ACTIONS(2709),
    [sym_false] = ACTIONS(2709),
    [sym_null] = ACTIONS(2709),
    [sym_undefined] = ACTIONS(2709),
    [anon_sym_AT] = ACTIONS(2711),
    [anon_sym_static] = ACTIONS(2709),
    [anon_sym_readonly] = ACTIONS(2709),
    [anon_sym_get] = ACTIONS(2709),
    [anon_sym_set] = ACTIONS(2709),
    [anon_sym_declare] = ACTIONS(2709),
    [anon_sym_public] = ACTIONS(2709),
    [anon_sym_private] = ACTIONS(2709),
    [anon_sym_protected] = ACTIONS(2709),
    [anon_sym_override] = ACTIONS(2709),
    [anon_sym_module] = ACTIONS(2709),
    [anon_sym_any] = ACTIONS(2709),
    [anon_sym_number] = ACTIONS(2709),
    [anon_sym_boolean] = ACTIONS(2709),
    [anon_sym_string] = ACTIONS(2709),
    [anon_sym_symbol] = ACTIONS(2709),
    [anon_sym_object] = ACTIONS(2709),
    [anon_sym_property] = ACTIONS(2709),
    [anon_sym_signal] = ACTIONS(2709),
    [anon_sym_on] = ACTIONS(2709),
    [anon_sym_required] = ACTIONS(2709),
    [anon_sym_component] = ACTIONS(2709),
    [anon_sym_abstract] = ACTIONS(2709),
    [anon_sym_interface] = ACTIONS(2709),
    [anon_sym_enum] = ACTIONS(2709),
    [sym_html_comment] = ACTIONS(5),
  },
  [807] = {
    [sym_comment] = STATE(807),
    [sym_identifier] = ACTIONS(1838),
    [anon_sym_export] = ACTIONS(1838),
    [anon_sym_default] = ACTIONS(1838),
    [anon_sym_type] = ACTIONS(1838),
    [anon_sym_namespace] = ACTIONS(1838),
    [anon_sym_LBRACE] = ACTIONS(1840),
    [anon_sym_RBRACE] = ACTIONS(1840),
    [anon_sym_typeof] = ACTIONS(1838),
    [anon_sym_import] = ACTIONS(1838),
    [anon_sym_from] = ACTIONS(1838),
    [anon_sym_with] = ACTIONS(1838),
    [anon_sym_var] = ACTIONS(1838),
    [anon_sym_let] = ACTIONS(1838),
    [anon_sym_const] = ACTIONS(1838),
    [anon_sym_BANG] = ACTIONS(1840),
    [anon_sym_else] = ACTIONS(1838),
    [anon_sym_if] = ACTIONS(1838),
    [anon_sym_switch] = ACTIONS(1838),
    [anon_sym_for] = ACTIONS(1838),
    [anon_sym_LPAREN] = ACTIONS(1840),
    [anon_sym_await] = ACTIONS(1838),
    [anon_sym_of] = ACTIONS(1838),
    [anon_sym_while] = ACTIONS(1838),
    [anon_sym_do] = ACTIONS(1838),
    [anon_sym_try] = ACTIONS(1838),
    [anon_sym_break] = ACTIONS(1838),
    [anon_sym_continue] = ACTIONS(1838),
    [anon_sym_debugger] = ACTIONS(1838),
    [anon_sym_return] = ACTIONS(1838),
    [anon_sym_throw] = ACTIONS(1838),
    [anon_sym_SEMI] = ACTIONS(1840),
    [anon_sym_case] = ACTIONS(1838),
    [anon_sym_yield] = ACTIONS(1838),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_LTtemplate_GT] = ACTIONS(1840),
    [anon_sym_DQUOTE] = ACTIONS(1840),
    [anon_sym_SQUOTE] = ACTIONS(1840),
    [anon_sym_class] = ACTIONS(1838),
    [anon_sym_async] = ACTIONS(1838),
    [anon_sym_function] = ACTIONS(1838),
    [anon_sym_new] = ACTIONS(1838),
    [anon_sym_using] = ACTIONS(1838),
    [anon_sym_PLUS] = ACTIONS(1838),
    [anon_sym_DASH] = ACTIONS(1838),
    [anon_sym_SLASH] = ACTIONS(1838),
    [anon_sym_LT] = ACTIONS(1838),
    [anon_sym_TILDE] = ACTIONS(1840),
    [anon_sym_void] = ACTIONS(1838),
    [anon_sym_delete] = ACTIONS(1838),
    [anon_sym_PLUS_PLUS] = ACTIONS(1840),
    [anon_sym_DASH_DASH] = ACTIONS(1840),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1840),
    [sym_number] = ACTIONS(1840),
    [sym_private_property_identifier] = ACTIONS(1840),
    [sym_this] = ACTIONS(1838),
    [sym_super] = ACTIONS(1838),
    [sym_true] = ACTIONS(1838),
    [sym_false] = ACTIONS(1838),
    [sym_null] = ACTIONS(1838),
    [sym_undefined] = ACTIONS(1838),
    [anon_sym_AT] = ACTIONS(1840),
    [anon_sym_static] = ACTIONS(1838),
    [anon_sym_readonly] = ACTIONS(1838),
    [anon_sym_get] = ACTIONS(1838),
    [anon_sym_set] = ACTIONS(1838),
    [anon_sym_declare] = ACTIONS(1838),
    [anon_sym_public] = ACTIONS(1838),
    [anon_sym_private] = ACTIONS(1838),
    [anon_sym_protected] = ACTIONS(1838),
    [anon_sym_override] = ACTIONS(1838),
    [anon_sym_module] = ACTIONS(1838),
    [anon_sym_any] = ACTIONS(1838),
    [anon_sym_number] = ACTIONS(1838),
    [anon_sym_boolean] = ACTIONS(1838),
    [anon_sym_string] = ACTIONS(1838),
    [anon_sym_symbol] = ACTIONS(1838),
    [anon_sym_object] = ACTIONS(1838),
    [anon_sym_property] = ACTIONS(1838),
    [anon_sym_signal] = ACTIONS(1838),
    [anon_sym_on] = ACTIONS(1838),
    [anon_sym_required] = ACTIONS(1838),
    [anon_sym_component] = ACTIONS(1838),
    [anon_sym_abstract] = ACTIONS(1838),
    [anon_sym_interface] = ACTIONS(1838),
    [anon_sym_enum] = ACTIONS(1838),
    [sym_html_comment] = ACTIONS(5),
  },
  [808] = {
    [sym_comment] = STATE(808),
    [sym_identifier] = ACTIONS(2713),
    [anon_sym_export] = ACTIONS(2713),
    [anon_sym_default] = ACTIONS(2713),
    [anon_sym_type] = ACTIONS(2713),
    [anon_sym_namespace] = ACTIONS(2713),
    [anon_sym_LBRACE] = ACTIONS(2715),
    [anon_sym_RBRACE] = ACTIONS(2715),
    [anon_sym_typeof] = ACTIONS(2713),
    [anon_sym_import] = ACTIONS(2713),
    [anon_sym_from] = ACTIONS(2713),
    [anon_sym_with] = ACTIONS(2713),
    [anon_sym_var] = ACTIONS(2713),
    [anon_sym_let] = ACTIONS(2713),
    [anon_sym_const] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_else] = ACTIONS(2713),
    [anon_sym_if] = ACTIONS(2713),
    [anon_sym_switch] = ACTIONS(2713),
    [anon_sym_for] = ACTIONS(2713),
    [anon_sym_LPAREN] = ACTIONS(2715),
    [anon_sym_await] = ACTIONS(2713),
    [anon_sym_of] = ACTIONS(2713),
    [anon_sym_while] = ACTIONS(2713),
    [anon_sym_do] = ACTIONS(2713),
    [anon_sym_try] = ACTIONS(2713),
    [anon_sym_break] = ACTIONS(2713),
    [anon_sym_continue] = ACTIONS(2713),
    [anon_sym_debugger] = ACTIONS(2713),
    [anon_sym_return] = ACTIONS(2713),
    [anon_sym_throw] = ACTIONS(2713),
    [anon_sym_SEMI] = ACTIONS(2715),
    [anon_sym_case] = ACTIONS(2713),
    [anon_sym_yield] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(2715),
    [anon_sym_LTtemplate_GT] = ACTIONS(2715),
    [anon_sym_DQUOTE] = ACTIONS(2715),
    [anon_sym_SQUOTE] = ACTIONS(2715),
    [anon_sym_class] = ACTIONS(2713),
    [anon_sym_async] = ACTIONS(2713),
    [anon_sym_function] = ACTIONS(2713),
    [anon_sym_new] = ACTIONS(2713),
    [anon_sym_using] = ACTIONS(2713),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_SLASH] = ACTIONS(2713),
    [anon_sym_LT] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_void] = ACTIONS(2713),
    [anon_sym_delete] = ACTIONS(2713),
    [anon_sym_PLUS_PLUS] = ACTIONS(2715),
    [anon_sym_DASH_DASH] = ACTIONS(2715),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2715),
    [sym_number] = ACTIONS(2715),
    [sym_private_property_identifier] = ACTIONS(2715),
    [sym_this] = ACTIONS(2713),
    [sym_super] = ACTIONS(2713),
    [sym_true] = ACTIONS(2713),
    [sym_false] = ACTIONS(2713),
    [sym_null] = ACTIONS(2713),
    [sym_undefined] = ACTIONS(2713),
    [anon_sym_AT] = ACTIONS(2715),
    [anon_sym_static] = ACTIONS(2713),
    [anon_sym_readonly] = ACTIONS(2713),
    [anon_sym_get] = ACTIONS(2713),
    [anon_sym_set] = ACTIONS(2713),
    [anon_sym_declare] = ACTIONS(2713),
    [anon_sym_public] = ACTIONS(2713),
    [anon_sym_private] = ACTIONS(2713),
    [anon_sym_protected] = ACTIONS(2713),
    [anon_sym_override] = ACTIONS(2713),
    [anon_sym_module] = ACTIONS(2713),
    [anon_sym_any] = ACTIONS(2713),
    [anon_sym_number] = ACTIONS(2713),
    [anon_sym_boolean] = ACTIONS(2713),
    [anon_sym_string] = ACTIONS(2713),
    [anon_sym_symbol] = ACTIONS(2713),
    [anon_sym_object] = ACTIONS(2713),
    [anon_sym_property] = ACTIONS(2713),
    [anon_sym_signal] = ACTIONS(2713),
    [anon_sym_on] = ACTIONS(2713),
    [anon_sym_required] = ACTIONS(2713),
    [anon_sym_component] = ACTIONS(2713),
    [anon_sym_abstract] = ACTIONS(2713),
    [anon_sym_interface] = ACTIONS(2713),
    [anon_sym_enum] = ACTIONS(2713),
    [sym_html_comment] = ACTIONS(5),
  },
  [809] = {
    [sym_comment] = STATE(809),
    [sym_identifier] = ACTIONS(2717),
    [anon_sym_export] = ACTIONS(2717),
    [anon_sym_default] = ACTIONS(2717),
    [anon_sym_type] = ACTIONS(2717),
    [anon_sym_namespace] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(2719),
    [anon_sym_RBRACE] = ACTIONS(2719),
    [anon_sym_typeof] = ACTIONS(2717),
    [anon_sym_import] = ACTIONS(2717),
    [anon_sym_from] = ACTIONS(2717),
    [anon_sym_with] = ACTIONS(2717),
    [anon_sym_var] = ACTIONS(2717),
    [anon_sym_let] = ACTIONS(2717),
    [anon_sym_const] = ACTIONS(2717),
    [anon_sym_BANG] = ACTIONS(2719),
    [anon_sym_else] = ACTIONS(2717),
    [anon_sym_if] = ACTIONS(2717),
    [anon_sym_switch] = ACTIONS(2717),
    [anon_sym_for] = ACTIONS(2717),
    [anon_sym_LPAREN] = ACTIONS(2719),
    [anon_sym_await] = ACTIONS(2717),
    [anon_sym_of] = ACTIONS(2717),
    [anon_sym_while] = ACTIONS(2717),
    [anon_sym_do] = ACTIONS(2717),
    [anon_sym_try] = ACTIONS(2717),
    [anon_sym_break] = ACTIONS(2717),
    [anon_sym_continue] = ACTIONS(2717),
    [anon_sym_debugger] = ACTIONS(2717),
    [anon_sym_return] = ACTIONS(2717),
    [anon_sym_throw] = ACTIONS(2717),
    [anon_sym_SEMI] = ACTIONS(2719),
    [anon_sym_case] = ACTIONS(2717),
    [anon_sym_yield] = ACTIONS(2717),
    [anon_sym_LBRACK] = ACTIONS(2719),
    [anon_sym_LTtemplate_GT] = ACTIONS(2719),
    [anon_sym_DQUOTE] = ACTIONS(2719),
    [anon_sym_SQUOTE] = ACTIONS(2719),
    [anon_sym_class] = ACTIONS(2717),
    [anon_sym_async] = ACTIONS(2717),
    [anon_sym_function] = ACTIONS(2717),
    [anon_sym_new] = ACTIONS(2717),
    [anon_sym_using] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_SLASH] = ACTIONS(2717),
    [anon_sym_LT] = ACTIONS(2717),
    [anon_sym_TILDE] = ACTIONS(2719),
    [anon_sym_void] = ACTIONS(2717),
    [anon_sym_delete] = ACTIONS(2717),
    [anon_sym_PLUS_PLUS] = ACTIONS(2719),
    [anon_sym_DASH_DASH] = ACTIONS(2719),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2719),
    [sym_number] = ACTIONS(2719),
    [sym_private_property_identifier] = ACTIONS(2719),
    [sym_this] = ACTIONS(2717),
    [sym_super] = ACTIONS(2717),
    [sym_true] = ACTIONS(2717),
    [sym_false] = ACTIONS(2717),
    [sym_null] = ACTIONS(2717),
    [sym_undefined] = ACTIONS(2717),
    [anon_sym_AT] = ACTIONS(2719),
    [anon_sym_static] = ACTIONS(2717),
    [anon_sym_readonly] = ACTIONS(2717),
    [anon_sym_get] = ACTIONS(2717),
    [anon_sym_set] = ACTIONS(2717),
    [anon_sym_declare] = ACTIONS(2717),
    [anon_sym_public] = ACTIONS(2717),
    [anon_sym_private] = ACTIONS(2717),
    [anon_sym_protected] = ACTIONS(2717),
    [anon_sym_override] = ACTIONS(2717),
    [anon_sym_module] = ACTIONS(2717),
    [anon_sym_any] = ACTIONS(2717),
    [anon_sym_number] = ACTIONS(2717),
    [anon_sym_boolean] = ACTIONS(2717),
    [anon_sym_string] = ACTIONS(2717),
    [anon_sym_symbol] = ACTIONS(2717),
    [anon_sym_object] = ACTIONS(2717),
    [anon_sym_property] = ACTIONS(2717),
    [anon_sym_signal] = ACTIONS(2717),
    [anon_sym_on] = ACTIONS(2717),
    [anon_sym_required] = ACTIONS(2717),
    [anon_sym_component] = ACTIONS(2717),
    [anon_sym_abstract] = ACTIONS(2717),
    [anon_sym_interface] = ACTIONS(2717),
    [anon_sym_enum] = ACTIONS(2717),
    [sym_html_comment] = ACTIONS(5),
  },
  [810] = {
    [sym_comment] = STATE(810),
    [sym_identifier] = ACTIONS(1850),
    [anon_sym_export] = ACTIONS(1850),
    [anon_sym_default] = ACTIONS(1850),
    [anon_sym_type] = ACTIONS(1850),
    [anon_sym_namespace] = ACTIONS(1850),
    [anon_sym_LBRACE] = ACTIONS(1852),
    [anon_sym_RBRACE] = ACTIONS(1852),
    [anon_sym_typeof] = ACTIONS(1850),
    [anon_sym_import] = ACTIONS(1850),
    [anon_sym_from] = ACTIONS(1850),
    [anon_sym_with] = ACTIONS(1850),
    [anon_sym_var] = ACTIONS(1850),
    [anon_sym_let] = ACTIONS(1850),
    [anon_sym_const] = ACTIONS(1850),
    [anon_sym_BANG] = ACTIONS(1852),
    [anon_sym_else] = ACTIONS(1850),
    [anon_sym_if] = ACTIONS(1850),
    [anon_sym_switch] = ACTIONS(1850),
    [anon_sym_for] = ACTIONS(1850),
    [anon_sym_LPAREN] = ACTIONS(1852),
    [anon_sym_await] = ACTIONS(1850),
    [anon_sym_of] = ACTIONS(1850),
    [anon_sym_while] = ACTIONS(1850),
    [anon_sym_do] = ACTIONS(1850),
    [anon_sym_try] = ACTIONS(1850),
    [anon_sym_break] = ACTIONS(1850),
    [anon_sym_continue] = ACTIONS(1850),
    [anon_sym_debugger] = ACTIONS(1850),
    [anon_sym_return] = ACTIONS(1850),
    [anon_sym_throw] = ACTIONS(1850),
    [anon_sym_SEMI] = ACTIONS(1852),
    [anon_sym_case] = ACTIONS(1850),
    [anon_sym_yield] = ACTIONS(1850),
    [anon_sym_LBRACK] = ACTIONS(1852),
    [anon_sym_LTtemplate_GT] = ACTIONS(1852),
    [anon_sym_DQUOTE] = ACTIONS(1852),
    [anon_sym_SQUOTE] = ACTIONS(1852),
    [anon_sym_class] = ACTIONS(1850),
    [anon_sym_async] = ACTIONS(1850),
    [anon_sym_function] = ACTIONS(1850),
    [anon_sym_new] = ACTIONS(1850),
    [anon_sym_using] = ACTIONS(1850),
    [anon_sym_PLUS] = ACTIONS(1850),
    [anon_sym_DASH] = ACTIONS(1850),
    [anon_sym_SLASH] = ACTIONS(1850),
    [anon_sym_LT] = ACTIONS(1850),
    [anon_sym_TILDE] = ACTIONS(1852),
    [anon_sym_void] = ACTIONS(1850),
    [anon_sym_delete] = ACTIONS(1850),
    [anon_sym_PLUS_PLUS] = ACTIONS(1852),
    [anon_sym_DASH_DASH] = ACTIONS(1852),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1852),
    [sym_number] = ACTIONS(1852),
    [sym_private_property_identifier] = ACTIONS(1852),
    [sym_this] = ACTIONS(1850),
    [sym_super] = ACTIONS(1850),
    [sym_true] = ACTIONS(1850),
    [sym_false] = ACTIONS(1850),
    [sym_null] = ACTIONS(1850),
    [sym_undefined] = ACTIONS(1850),
    [anon_sym_AT] = ACTIONS(1852),
    [anon_sym_static] = ACTIONS(1850),
    [anon_sym_readonly] = ACTIONS(1850),
    [anon_sym_get] = ACTIONS(1850),
    [anon_sym_set] = ACTIONS(1850),
    [anon_sym_declare] = ACTIONS(1850),
    [anon_sym_public] = ACTIONS(1850),
    [anon_sym_private] = ACTIONS(1850),
    [anon_sym_protected] = ACTIONS(1850),
    [anon_sym_override] = ACTIONS(1850),
    [anon_sym_module] = ACTIONS(1850),
    [anon_sym_any] = ACTIONS(1850),
    [anon_sym_number] = ACTIONS(1850),
    [anon_sym_boolean] = ACTIONS(1850),
    [anon_sym_string] = ACTIONS(1850),
    [anon_sym_symbol] = ACTIONS(1850),
    [anon_sym_object] = ACTIONS(1850),
    [anon_sym_property] = ACTIONS(1850),
    [anon_sym_signal] = ACTIONS(1850),
    [anon_sym_on] = ACTIONS(1850),
    [anon_sym_required] = ACTIONS(1850),
    [anon_sym_component] = ACTIONS(1850),
    [anon_sym_abstract] = ACTIONS(1850),
    [anon_sym_interface] = ACTIONS(1850),
    [anon_sym_enum] = ACTIONS(1850),
    [sym_html_comment] = ACTIONS(5),
  },
  [811] = {
    [sym_comment] = STATE(811),
    [sym_identifier] = ACTIONS(2721),
    [anon_sym_export] = ACTIONS(2721),
    [anon_sym_default] = ACTIONS(2721),
    [anon_sym_type] = ACTIONS(2721),
    [anon_sym_namespace] = ACTIONS(2721),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_RBRACE] = ACTIONS(2723),
    [anon_sym_typeof] = ACTIONS(2721),
    [anon_sym_import] = ACTIONS(2721),
    [anon_sym_from] = ACTIONS(2721),
    [anon_sym_with] = ACTIONS(2721),
    [anon_sym_var] = ACTIONS(2721),
    [anon_sym_let] = ACTIONS(2721),
    [anon_sym_const] = ACTIONS(2721),
    [anon_sym_BANG] = ACTIONS(2723),
    [anon_sym_else] = ACTIONS(2721),
    [anon_sym_if] = ACTIONS(2721),
    [anon_sym_switch] = ACTIONS(2721),
    [anon_sym_for] = ACTIONS(2721),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_await] = ACTIONS(2721),
    [anon_sym_of] = ACTIONS(2721),
    [anon_sym_while] = ACTIONS(2721),
    [anon_sym_do] = ACTIONS(2721),
    [anon_sym_try] = ACTIONS(2721),
    [anon_sym_break] = ACTIONS(2721),
    [anon_sym_continue] = ACTIONS(2721),
    [anon_sym_debugger] = ACTIONS(2721),
    [anon_sym_return] = ACTIONS(2721),
    [anon_sym_throw] = ACTIONS(2721),
    [anon_sym_SEMI] = ACTIONS(2723),
    [anon_sym_case] = ACTIONS(2721),
    [anon_sym_yield] = ACTIONS(2721),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_LTtemplate_GT] = ACTIONS(2723),
    [anon_sym_DQUOTE] = ACTIONS(2723),
    [anon_sym_SQUOTE] = ACTIONS(2723),
    [anon_sym_class] = ACTIONS(2721),
    [anon_sym_async] = ACTIONS(2721),
    [anon_sym_function] = ACTIONS(2721),
    [anon_sym_new] = ACTIONS(2721),
    [anon_sym_using] = ACTIONS(2721),
    [anon_sym_PLUS] = ACTIONS(2721),
    [anon_sym_DASH] = ACTIONS(2721),
    [anon_sym_SLASH] = ACTIONS(2721),
    [anon_sym_LT] = ACTIONS(2721),
    [anon_sym_TILDE] = ACTIONS(2723),
    [anon_sym_void] = ACTIONS(2721),
    [anon_sym_delete] = ACTIONS(2721),
    [anon_sym_PLUS_PLUS] = ACTIONS(2723),
    [anon_sym_DASH_DASH] = ACTIONS(2723),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2723),
    [sym_number] = ACTIONS(2723),
    [sym_private_property_identifier] = ACTIONS(2723),
    [sym_this] = ACTIONS(2721),
    [sym_super] = ACTIONS(2721),
    [sym_true] = ACTIONS(2721),
    [sym_false] = ACTIONS(2721),
    [sym_null] = ACTIONS(2721),
    [sym_undefined] = ACTIONS(2721),
    [anon_sym_AT] = ACTIONS(2723),
    [anon_sym_static] = ACTIONS(2721),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_get] = ACTIONS(2721),
    [anon_sym_set] = ACTIONS(2721),
    [anon_sym_declare] = ACTIONS(2721),
    [anon_sym_public] = ACTIONS(2721),
    [anon_sym_private] = ACTIONS(2721),
    [anon_sym_protected] = ACTIONS(2721),
    [anon_sym_override] = ACTIONS(2721),
    [anon_sym_module] = ACTIONS(2721),
    [anon_sym_any] = ACTIONS(2721),
    [anon_sym_number] = ACTIONS(2721),
    [anon_sym_boolean] = ACTIONS(2721),
    [anon_sym_string] = ACTIONS(2721),
    [anon_sym_symbol] = ACTIONS(2721),
    [anon_sym_object] = ACTIONS(2721),
    [anon_sym_property] = ACTIONS(2721),
    [anon_sym_signal] = ACTIONS(2721),
    [anon_sym_on] = ACTIONS(2721),
    [anon_sym_required] = ACTIONS(2721),
    [anon_sym_component] = ACTIONS(2721),
    [anon_sym_abstract] = ACTIONS(2721),
    [anon_sym_interface] = ACTIONS(2721),
    [anon_sym_enum] = ACTIONS(2721),
    [sym_html_comment] = ACTIONS(5),
  },
  [812] = {
    [sym_comment] = STATE(812),
    [sym_identifier] = ACTIONS(1858),
    [anon_sym_export] = ACTIONS(1858),
    [anon_sym_default] = ACTIONS(1858),
    [anon_sym_type] = ACTIONS(1858),
    [anon_sym_namespace] = ACTIONS(1858),
    [anon_sym_LBRACE] = ACTIONS(1860),
    [anon_sym_RBRACE] = ACTIONS(1860),
    [anon_sym_typeof] = ACTIONS(1858),
    [anon_sym_import] = ACTIONS(1858),
    [anon_sym_from] = ACTIONS(1858),
    [anon_sym_with] = ACTIONS(1858),
    [anon_sym_var] = ACTIONS(1858),
    [anon_sym_let] = ACTIONS(1858),
    [anon_sym_const] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(1860),
    [anon_sym_else] = ACTIONS(1858),
    [anon_sym_if] = ACTIONS(1858),
    [anon_sym_switch] = ACTIONS(1858),
    [anon_sym_for] = ACTIONS(1858),
    [anon_sym_LPAREN] = ACTIONS(1860),
    [anon_sym_await] = ACTIONS(1858),
    [anon_sym_of] = ACTIONS(1858),
    [anon_sym_while] = ACTIONS(1858),
    [anon_sym_do] = ACTIONS(1858),
    [anon_sym_try] = ACTIONS(1858),
    [anon_sym_break] = ACTIONS(1858),
    [anon_sym_continue] = ACTIONS(1858),
    [anon_sym_debugger] = ACTIONS(1858),
    [anon_sym_return] = ACTIONS(1858),
    [anon_sym_throw] = ACTIONS(1858),
    [anon_sym_SEMI] = ACTIONS(1860),
    [anon_sym_case] = ACTIONS(1858),
    [anon_sym_yield] = ACTIONS(1858),
    [anon_sym_LBRACK] = ACTIONS(1860),
    [anon_sym_LTtemplate_GT] = ACTIONS(1860),
    [anon_sym_DQUOTE] = ACTIONS(1860),
    [anon_sym_SQUOTE] = ACTIONS(1860),
    [anon_sym_class] = ACTIONS(1858),
    [anon_sym_async] = ACTIONS(1858),
    [anon_sym_function] = ACTIONS(1858),
    [anon_sym_new] = ACTIONS(1858),
    [anon_sym_using] = ACTIONS(1858),
    [anon_sym_PLUS] = ACTIONS(1858),
    [anon_sym_DASH] = ACTIONS(1858),
    [anon_sym_SLASH] = ACTIONS(1858),
    [anon_sym_LT] = ACTIONS(1858),
    [anon_sym_TILDE] = ACTIONS(1860),
    [anon_sym_void] = ACTIONS(1858),
    [anon_sym_delete] = ACTIONS(1858),
    [anon_sym_PLUS_PLUS] = ACTIONS(1860),
    [anon_sym_DASH_DASH] = ACTIONS(1860),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1860),
    [sym_number] = ACTIONS(1860),
    [sym_private_property_identifier] = ACTIONS(1860),
    [sym_this] = ACTIONS(1858),
    [sym_super] = ACTIONS(1858),
    [sym_true] = ACTIONS(1858),
    [sym_false] = ACTIONS(1858),
    [sym_null] = ACTIONS(1858),
    [sym_undefined] = ACTIONS(1858),
    [anon_sym_AT] = ACTIONS(1860),
    [anon_sym_static] = ACTIONS(1858),
    [anon_sym_readonly] = ACTIONS(1858),
    [anon_sym_get] = ACTIONS(1858),
    [anon_sym_set] = ACTIONS(1858),
    [anon_sym_declare] = ACTIONS(1858),
    [anon_sym_public] = ACTIONS(1858),
    [anon_sym_private] = ACTIONS(1858),
    [anon_sym_protected] = ACTIONS(1858),
    [anon_sym_override] = ACTIONS(1858),
    [anon_sym_module] = ACTIONS(1858),
    [anon_sym_any] = ACTIONS(1858),
    [anon_sym_number] = ACTIONS(1858),
    [anon_sym_boolean] = ACTIONS(1858),
    [anon_sym_string] = ACTIONS(1858),
    [anon_sym_symbol] = ACTIONS(1858),
    [anon_sym_object] = ACTIONS(1858),
    [anon_sym_property] = ACTIONS(1858),
    [anon_sym_signal] = ACTIONS(1858),
    [anon_sym_on] = ACTIONS(1858),
    [anon_sym_required] = ACTIONS(1858),
    [anon_sym_component] = ACTIONS(1858),
    [anon_sym_abstract] = ACTIONS(1858),
    [anon_sym_interface] = ACTIONS(1858),
    [anon_sym_enum] = ACTIONS(1858),
    [sym_html_comment] = ACTIONS(5),
  },
  [813] = {
    [sym_comment] = STATE(813),
    [sym_identifier] = ACTIONS(2725),
    [anon_sym_export] = ACTIONS(2725),
    [anon_sym_default] = ACTIONS(2725),
    [anon_sym_type] = ACTIONS(2725),
    [anon_sym_namespace] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(2727),
    [anon_sym_RBRACE] = ACTIONS(2727),
    [anon_sym_typeof] = ACTIONS(2725),
    [anon_sym_import] = ACTIONS(2725),
    [anon_sym_from] = ACTIONS(2725),
    [anon_sym_with] = ACTIONS(2725),
    [anon_sym_var] = ACTIONS(2725),
    [anon_sym_let] = ACTIONS(2725),
    [anon_sym_const] = ACTIONS(2725),
    [anon_sym_BANG] = ACTIONS(2727),
    [anon_sym_else] = ACTIONS(2725),
    [anon_sym_if] = ACTIONS(2725),
    [anon_sym_switch] = ACTIONS(2725),
    [anon_sym_for] = ACTIONS(2725),
    [anon_sym_LPAREN] = ACTIONS(2727),
    [anon_sym_await] = ACTIONS(2725),
    [anon_sym_of] = ACTIONS(2725),
    [anon_sym_while] = ACTIONS(2725),
    [anon_sym_do] = ACTIONS(2725),
    [anon_sym_try] = ACTIONS(2725),
    [anon_sym_break] = ACTIONS(2725),
    [anon_sym_continue] = ACTIONS(2725),
    [anon_sym_debugger] = ACTIONS(2725),
    [anon_sym_return] = ACTIONS(2725),
    [anon_sym_throw] = ACTIONS(2725),
    [anon_sym_SEMI] = ACTIONS(2727),
    [anon_sym_case] = ACTIONS(2725),
    [anon_sym_yield] = ACTIONS(2725),
    [anon_sym_LBRACK] = ACTIONS(2727),
    [anon_sym_LTtemplate_GT] = ACTIONS(2727),
    [anon_sym_DQUOTE] = ACTIONS(2727),
    [anon_sym_SQUOTE] = ACTIONS(2727),
    [anon_sym_class] = ACTIONS(2725),
    [anon_sym_async] = ACTIONS(2725),
    [anon_sym_function] = ACTIONS(2725),
    [anon_sym_new] = ACTIONS(2725),
    [anon_sym_using] = ACTIONS(2725),
    [anon_sym_PLUS] = ACTIONS(2725),
    [anon_sym_DASH] = ACTIONS(2725),
    [anon_sym_SLASH] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2725),
    [anon_sym_TILDE] = ACTIONS(2727),
    [anon_sym_void] = ACTIONS(2725),
    [anon_sym_delete] = ACTIONS(2725),
    [anon_sym_PLUS_PLUS] = ACTIONS(2727),
    [anon_sym_DASH_DASH] = ACTIONS(2727),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2727),
    [sym_number] = ACTIONS(2727),
    [sym_private_property_identifier] = ACTIONS(2727),
    [sym_this] = ACTIONS(2725),
    [sym_super] = ACTIONS(2725),
    [sym_true] = ACTIONS(2725),
    [sym_false] = ACTIONS(2725),
    [sym_null] = ACTIONS(2725),
    [sym_undefined] = ACTIONS(2725),
    [anon_sym_AT] = ACTIONS(2727),
    [anon_sym_static] = ACTIONS(2725),
    [anon_sym_readonly] = ACTIONS(2725),
    [anon_sym_get] = ACTIONS(2725),
    [anon_sym_set] = ACTIONS(2725),
    [anon_sym_declare] = ACTIONS(2725),
    [anon_sym_public] = ACTIONS(2725),
    [anon_sym_private] = ACTIONS(2725),
    [anon_sym_protected] = ACTIONS(2725),
    [anon_sym_override] = ACTIONS(2725),
    [anon_sym_module] = ACTIONS(2725),
    [anon_sym_any] = ACTIONS(2725),
    [anon_sym_number] = ACTIONS(2725),
    [anon_sym_boolean] = ACTIONS(2725),
    [anon_sym_string] = ACTIONS(2725),
    [anon_sym_symbol] = ACTIONS(2725),
    [anon_sym_object] = ACTIONS(2725),
    [anon_sym_property] = ACTIONS(2725),
    [anon_sym_signal] = ACTIONS(2725),
    [anon_sym_on] = ACTIONS(2725),
    [anon_sym_required] = ACTIONS(2725),
    [anon_sym_component] = ACTIONS(2725),
    [anon_sym_abstract] = ACTIONS(2725),
    [anon_sym_interface] = ACTIONS(2725),
    [anon_sym_enum] = ACTIONS(2725),
    [sym_html_comment] = ACTIONS(5),
  },
  [814] = {
    [sym_comment] = STATE(814),
    [sym_identifier] = ACTIONS(2729),
    [anon_sym_export] = ACTIONS(2729),
    [anon_sym_default] = ACTIONS(2729),
    [anon_sym_type] = ACTIONS(2729),
    [anon_sym_namespace] = ACTIONS(2729),
    [anon_sym_LBRACE] = ACTIONS(2731),
    [anon_sym_RBRACE] = ACTIONS(2731),
    [anon_sym_typeof] = ACTIONS(2729),
    [anon_sym_import] = ACTIONS(2729),
    [anon_sym_from] = ACTIONS(2729),
    [anon_sym_with] = ACTIONS(2729),
    [anon_sym_var] = ACTIONS(2729),
    [anon_sym_let] = ACTIONS(2729),
    [anon_sym_const] = ACTIONS(2729),
    [anon_sym_BANG] = ACTIONS(2731),
    [anon_sym_else] = ACTIONS(2729),
    [anon_sym_if] = ACTIONS(2729),
    [anon_sym_switch] = ACTIONS(2729),
    [anon_sym_for] = ACTIONS(2729),
    [anon_sym_LPAREN] = ACTIONS(2731),
    [anon_sym_await] = ACTIONS(2729),
    [anon_sym_of] = ACTIONS(2729),
    [anon_sym_while] = ACTIONS(2729),
    [anon_sym_do] = ACTIONS(2729),
    [anon_sym_try] = ACTIONS(2729),
    [anon_sym_break] = ACTIONS(2729),
    [anon_sym_continue] = ACTIONS(2729),
    [anon_sym_debugger] = ACTIONS(2729),
    [anon_sym_return] = ACTIONS(2729),
    [anon_sym_throw] = ACTIONS(2729),
    [anon_sym_SEMI] = ACTIONS(2731),
    [anon_sym_case] = ACTIONS(2729),
    [anon_sym_yield] = ACTIONS(2729),
    [anon_sym_LBRACK] = ACTIONS(2731),
    [anon_sym_LTtemplate_GT] = ACTIONS(2731),
    [anon_sym_DQUOTE] = ACTIONS(2731),
    [anon_sym_SQUOTE] = ACTIONS(2731),
    [anon_sym_class] = ACTIONS(2729),
    [anon_sym_async] = ACTIONS(2729),
    [anon_sym_function] = ACTIONS(2729),
    [anon_sym_new] = ACTIONS(2729),
    [anon_sym_using] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2729),
    [anon_sym_DASH] = ACTIONS(2729),
    [anon_sym_SLASH] = ACTIONS(2729),
    [anon_sym_LT] = ACTIONS(2729),
    [anon_sym_TILDE] = ACTIONS(2731),
    [anon_sym_void] = ACTIONS(2729),
    [anon_sym_delete] = ACTIONS(2729),
    [anon_sym_PLUS_PLUS] = ACTIONS(2731),
    [anon_sym_DASH_DASH] = ACTIONS(2731),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2731),
    [sym_number] = ACTIONS(2731),
    [sym_private_property_identifier] = ACTIONS(2731),
    [sym_this] = ACTIONS(2729),
    [sym_super] = ACTIONS(2729),
    [sym_true] = ACTIONS(2729),
    [sym_false] = ACTIONS(2729),
    [sym_null] = ACTIONS(2729),
    [sym_undefined] = ACTIONS(2729),
    [anon_sym_AT] = ACTIONS(2731),
    [anon_sym_static] = ACTIONS(2729),
    [anon_sym_readonly] = ACTIONS(2729),
    [anon_sym_get] = ACTIONS(2729),
    [anon_sym_set] = ACTIONS(2729),
    [anon_sym_declare] = ACTIONS(2729),
    [anon_sym_public] = ACTIONS(2729),
    [anon_sym_private] = ACTIONS(2729),
    [anon_sym_protected] = ACTIONS(2729),
    [anon_sym_override] = ACTIONS(2729),
    [anon_sym_module] = ACTIONS(2729),
    [anon_sym_any] = ACTIONS(2729),
    [anon_sym_number] = ACTIONS(2729),
    [anon_sym_boolean] = ACTIONS(2729),
    [anon_sym_string] = ACTIONS(2729),
    [anon_sym_symbol] = ACTIONS(2729),
    [anon_sym_object] = ACTIONS(2729),
    [anon_sym_property] = ACTIONS(2729),
    [anon_sym_signal] = ACTIONS(2729),
    [anon_sym_on] = ACTIONS(2729),
    [anon_sym_required] = ACTIONS(2729),
    [anon_sym_component] = ACTIONS(2729),
    [anon_sym_abstract] = ACTIONS(2729),
    [anon_sym_interface] = ACTIONS(2729),
    [anon_sym_enum] = ACTIONS(2729),
    [sym_html_comment] = ACTIONS(5),
  },
  [815] = {
    [sym_comment] = STATE(815),
    [sym_identifier] = ACTIONS(2733),
    [anon_sym_export] = ACTIONS(2733),
    [anon_sym_default] = ACTIONS(2733),
    [anon_sym_type] = ACTIONS(2733),
    [anon_sym_namespace] = ACTIONS(2733),
    [anon_sym_LBRACE] = ACTIONS(2735),
    [anon_sym_RBRACE] = ACTIONS(2735),
    [anon_sym_typeof] = ACTIONS(2733),
    [anon_sym_import] = ACTIONS(2733),
    [anon_sym_from] = ACTIONS(2733),
    [anon_sym_with] = ACTIONS(2733),
    [anon_sym_var] = ACTIONS(2733),
    [anon_sym_let] = ACTIONS(2733),
    [anon_sym_const] = ACTIONS(2733),
    [anon_sym_BANG] = ACTIONS(2735),
    [anon_sym_else] = ACTIONS(2733),
    [anon_sym_if] = ACTIONS(2733),
    [anon_sym_switch] = ACTIONS(2733),
    [anon_sym_for] = ACTIONS(2733),
    [anon_sym_LPAREN] = ACTIONS(2735),
    [anon_sym_await] = ACTIONS(2733),
    [anon_sym_of] = ACTIONS(2733),
    [anon_sym_while] = ACTIONS(2733),
    [anon_sym_do] = ACTIONS(2733),
    [anon_sym_try] = ACTIONS(2733),
    [anon_sym_break] = ACTIONS(2733),
    [anon_sym_continue] = ACTIONS(2733),
    [anon_sym_debugger] = ACTIONS(2733),
    [anon_sym_return] = ACTIONS(2733),
    [anon_sym_throw] = ACTIONS(2733),
    [anon_sym_SEMI] = ACTIONS(2735),
    [anon_sym_case] = ACTIONS(2733),
    [anon_sym_yield] = ACTIONS(2733),
    [anon_sym_LBRACK] = ACTIONS(2735),
    [anon_sym_LTtemplate_GT] = ACTIONS(2735),
    [anon_sym_DQUOTE] = ACTIONS(2735),
    [anon_sym_SQUOTE] = ACTIONS(2735),
    [anon_sym_class] = ACTIONS(2733),
    [anon_sym_async] = ACTIONS(2733),
    [anon_sym_function] = ACTIONS(2733),
    [anon_sym_new] = ACTIONS(2733),
    [anon_sym_using] = ACTIONS(2733),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_SLASH] = ACTIONS(2733),
    [anon_sym_LT] = ACTIONS(2733),
    [anon_sym_TILDE] = ACTIONS(2735),
    [anon_sym_void] = ACTIONS(2733),
    [anon_sym_delete] = ACTIONS(2733),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2735),
    [sym_number] = ACTIONS(2735),
    [sym_private_property_identifier] = ACTIONS(2735),
    [sym_this] = ACTIONS(2733),
    [sym_super] = ACTIONS(2733),
    [sym_true] = ACTIONS(2733),
    [sym_false] = ACTIONS(2733),
    [sym_null] = ACTIONS(2733),
    [sym_undefined] = ACTIONS(2733),
    [anon_sym_AT] = ACTIONS(2735),
    [anon_sym_static] = ACTIONS(2733),
    [anon_sym_readonly] = ACTIONS(2733),
    [anon_sym_get] = ACTIONS(2733),
    [anon_sym_set] = ACTIONS(2733),
    [anon_sym_declare] = ACTIONS(2733),
    [anon_sym_public] = ACTIONS(2733),
    [anon_sym_private] = ACTIONS(2733),
    [anon_sym_protected] = ACTIONS(2733),
    [anon_sym_override] = ACTIONS(2733),
    [anon_sym_module] = ACTIONS(2733),
    [anon_sym_any] = ACTIONS(2733),
    [anon_sym_number] = ACTIONS(2733),
    [anon_sym_boolean] = ACTIONS(2733),
    [anon_sym_string] = ACTIONS(2733),
    [anon_sym_symbol] = ACTIONS(2733),
    [anon_sym_object] = ACTIONS(2733),
    [anon_sym_property] = ACTIONS(2733),
    [anon_sym_signal] = ACTIONS(2733),
    [anon_sym_on] = ACTIONS(2733),
    [anon_sym_required] = ACTIONS(2733),
    [anon_sym_component] = ACTIONS(2733),
    [anon_sym_abstract] = ACTIONS(2733),
    [anon_sym_interface] = ACTIONS(2733),
    [anon_sym_enum] = ACTIONS(2733),
    [sym_html_comment] = ACTIONS(5),
  },
  [816] = {
    [sym_comment] = STATE(816),
    [sym_identifier] = ACTIONS(2737),
    [anon_sym_export] = ACTIONS(2737),
    [anon_sym_default] = ACTIONS(2737),
    [anon_sym_type] = ACTIONS(2737),
    [anon_sym_namespace] = ACTIONS(2737),
    [anon_sym_LBRACE] = ACTIONS(2739),
    [anon_sym_RBRACE] = ACTIONS(2739),
    [anon_sym_typeof] = ACTIONS(2737),
    [anon_sym_import] = ACTIONS(2737),
    [anon_sym_from] = ACTIONS(2737),
    [anon_sym_with] = ACTIONS(2737),
    [anon_sym_var] = ACTIONS(2737),
    [anon_sym_let] = ACTIONS(2737),
    [anon_sym_const] = ACTIONS(2737),
    [anon_sym_BANG] = ACTIONS(2739),
    [anon_sym_else] = ACTIONS(2737),
    [anon_sym_if] = ACTIONS(2737),
    [anon_sym_switch] = ACTIONS(2737),
    [anon_sym_for] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(2739),
    [anon_sym_await] = ACTIONS(2737),
    [anon_sym_of] = ACTIONS(2737),
    [anon_sym_while] = ACTIONS(2737),
    [anon_sym_do] = ACTIONS(2737),
    [anon_sym_try] = ACTIONS(2737),
    [anon_sym_break] = ACTIONS(2737),
    [anon_sym_continue] = ACTIONS(2737),
    [anon_sym_debugger] = ACTIONS(2737),
    [anon_sym_return] = ACTIONS(2737),
    [anon_sym_throw] = ACTIONS(2737),
    [anon_sym_SEMI] = ACTIONS(2739),
    [anon_sym_case] = ACTIONS(2737),
    [anon_sym_yield] = ACTIONS(2737),
    [anon_sym_LBRACK] = ACTIONS(2739),
    [anon_sym_LTtemplate_GT] = ACTIONS(2739),
    [anon_sym_DQUOTE] = ACTIONS(2739),
    [anon_sym_SQUOTE] = ACTIONS(2739),
    [anon_sym_class] = ACTIONS(2737),
    [anon_sym_async] = ACTIONS(2737),
    [anon_sym_function] = ACTIONS(2737),
    [anon_sym_new] = ACTIONS(2737),
    [anon_sym_using] = ACTIONS(2737),
    [anon_sym_PLUS] = ACTIONS(2737),
    [anon_sym_DASH] = ACTIONS(2737),
    [anon_sym_SLASH] = ACTIONS(2737),
    [anon_sym_LT] = ACTIONS(2737),
    [anon_sym_TILDE] = ACTIONS(2739),
    [anon_sym_void] = ACTIONS(2737),
    [anon_sym_delete] = ACTIONS(2737),
    [anon_sym_PLUS_PLUS] = ACTIONS(2739),
    [anon_sym_DASH_DASH] = ACTIONS(2739),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2739),
    [sym_number] = ACTIONS(2739),
    [sym_private_property_identifier] = ACTIONS(2739),
    [sym_this] = ACTIONS(2737),
    [sym_super] = ACTIONS(2737),
    [sym_true] = ACTIONS(2737),
    [sym_false] = ACTIONS(2737),
    [sym_null] = ACTIONS(2737),
    [sym_undefined] = ACTIONS(2737),
    [anon_sym_AT] = ACTIONS(2739),
    [anon_sym_static] = ACTIONS(2737),
    [anon_sym_readonly] = ACTIONS(2737),
    [anon_sym_get] = ACTIONS(2737),
    [anon_sym_set] = ACTIONS(2737),
    [anon_sym_declare] = ACTIONS(2737),
    [anon_sym_public] = ACTIONS(2737),
    [anon_sym_private] = ACTIONS(2737),
    [anon_sym_protected] = ACTIONS(2737),
    [anon_sym_override] = ACTIONS(2737),
    [anon_sym_module] = ACTIONS(2737),
    [anon_sym_any] = ACTIONS(2737),
    [anon_sym_number] = ACTIONS(2737),
    [anon_sym_boolean] = ACTIONS(2737),
    [anon_sym_string] = ACTIONS(2737),
    [anon_sym_symbol] = ACTIONS(2737),
    [anon_sym_object] = ACTIONS(2737),
    [anon_sym_property] = ACTIONS(2737),
    [anon_sym_signal] = ACTIONS(2737),
    [anon_sym_on] = ACTIONS(2737),
    [anon_sym_required] = ACTIONS(2737),
    [anon_sym_component] = ACTIONS(2737),
    [anon_sym_abstract] = ACTIONS(2737),
    [anon_sym_interface] = ACTIONS(2737),
    [anon_sym_enum] = ACTIONS(2737),
    [sym_html_comment] = ACTIONS(5),
  },
  [817] = {
    [sym_comment] = STATE(817),
    [sym_identifier] = ACTIONS(2741),
    [anon_sym_export] = ACTIONS(2741),
    [anon_sym_default] = ACTIONS(2741),
    [anon_sym_type] = ACTIONS(2741),
    [anon_sym_namespace] = ACTIONS(2741),
    [anon_sym_LBRACE] = ACTIONS(2743),
    [anon_sym_RBRACE] = ACTIONS(2743),
    [anon_sym_typeof] = ACTIONS(2741),
    [anon_sym_import] = ACTIONS(2741),
    [anon_sym_from] = ACTIONS(2741),
    [anon_sym_with] = ACTIONS(2741),
    [anon_sym_var] = ACTIONS(2741),
    [anon_sym_let] = ACTIONS(2741),
    [anon_sym_const] = ACTIONS(2741),
    [anon_sym_BANG] = ACTIONS(2743),
    [anon_sym_else] = ACTIONS(2741),
    [anon_sym_if] = ACTIONS(2741),
    [anon_sym_switch] = ACTIONS(2741),
    [anon_sym_for] = ACTIONS(2741),
    [anon_sym_LPAREN] = ACTIONS(2743),
    [anon_sym_await] = ACTIONS(2741),
    [anon_sym_of] = ACTIONS(2741),
    [anon_sym_while] = ACTIONS(2741),
    [anon_sym_do] = ACTIONS(2741),
    [anon_sym_try] = ACTIONS(2741),
    [anon_sym_break] = ACTIONS(2741),
    [anon_sym_continue] = ACTIONS(2741),
    [anon_sym_debugger] = ACTIONS(2741),
    [anon_sym_return] = ACTIONS(2741),
    [anon_sym_throw] = ACTIONS(2741),
    [anon_sym_SEMI] = ACTIONS(2743),
    [anon_sym_case] = ACTIONS(2741),
    [anon_sym_yield] = ACTIONS(2741),
    [anon_sym_LBRACK] = ACTIONS(2743),
    [anon_sym_LTtemplate_GT] = ACTIONS(2743),
    [anon_sym_DQUOTE] = ACTIONS(2743),
    [anon_sym_SQUOTE] = ACTIONS(2743),
    [anon_sym_class] = ACTIONS(2741),
    [anon_sym_async] = ACTIONS(2741),
    [anon_sym_function] = ACTIONS(2741),
    [anon_sym_new] = ACTIONS(2741),
    [anon_sym_using] = ACTIONS(2741),
    [anon_sym_PLUS] = ACTIONS(2741),
    [anon_sym_DASH] = ACTIONS(2741),
    [anon_sym_SLASH] = ACTIONS(2741),
    [anon_sym_LT] = ACTIONS(2741),
    [anon_sym_TILDE] = ACTIONS(2743),
    [anon_sym_void] = ACTIONS(2741),
    [anon_sym_delete] = ACTIONS(2741),
    [anon_sym_PLUS_PLUS] = ACTIONS(2743),
    [anon_sym_DASH_DASH] = ACTIONS(2743),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2743),
    [sym_number] = ACTIONS(2743),
    [sym_private_property_identifier] = ACTIONS(2743),
    [sym_this] = ACTIONS(2741),
    [sym_super] = ACTIONS(2741),
    [sym_true] = ACTIONS(2741),
    [sym_false] = ACTIONS(2741),
    [sym_null] = ACTIONS(2741),
    [sym_undefined] = ACTIONS(2741),
    [anon_sym_AT] = ACTIONS(2743),
    [anon_sym_static] = ACTIONS(2741),
    [anon_sym_readonly] = ACTIONS(2741),
    [anon_sym_get] = ACTIONS(2741),
    [anon_sym_set] = ACTIONS(2741),
    [anon_sym_declare] = ACTIONS(2741),
    [anon_sym_public] = ACTIONS(2741),
    [anon_sym_private] = ACTIONS(2741),
    [anon_sym_protected] = ACTIONS(2741),
    [anon_sym_override] = ACTIONS(2741),
    [anon_sym_module] = ACTIONS(2741),
    [anon_sym_any] = ACTIONS(2741),
    [anon_sym_number] = ACTIONS(2741),
    [anon_sym_boolean] = ACTIONS(2741),
    [anon_sym_string] = ACTIONS(2741),
    [anon_sym_symbol] = ACTIONS(2741),
    [anon_sym_object] = ACTIONS(2741),
    [anon_sym_property] = ACTIONS(2741),
    [anon_sym_signal] = ACTIONS(2741),
    [anon_sym_on] = ACTIONS(2741),
    [anon_sym_required] = ACTIONS(2741),
    [anon_sym_component] = ACTIONS(2741),
    [anon_sym_abstract] = ACTIONS(2741),
    [anon_sym_interface] = ACTIONS(2741),
    [anon_sym_enum] = ACTIONS(2741),
    [sym_html_comment] = ACTIONS(5),
  },
  [818] = {
    [sym_comment] = STATE(818),
    [sym_identifier] = ACTIONS(2745),
    [anon_sym_export] = ACTIONS(2745),
    [anon_sym_default] = ACTIONS(2745),
    [anon_sym_type] = ACTIONS(2745),
    [anon_sym_namespace] = ACTIONS(2745),
    [anon_sym_LBRACE] = ACTIONS(2747),
    [anon_sym_RBRACE] = ACTIONS(2747),
    [anon_sym_typeof] = ACTIONS(2745),
    [anon_sym_import] = ACTIONS(2745),
    [anon_sym_from] = ACTIONS(2745),
    [anon_sym_with] = ACTIONS(2745),
    [anon_sym_var] = ACTIONS(2745),
    [anon_sym_let] = ACTIONS(2745),
    [anon_sym_const] = ACTIONS(2745),
    [anon_sym_BANG] = ACTIONS(2747),
    [anon_sym_else] = ACTIONS(2745),
    [anon_sym_if] = ACTIONS(2745),
    [anon_sym_switch] = ACTIONS(2745),
    [anon_sym_for] = ACTIONS(2745),
    [anon_sym_LPAREN] = ACTIONS(2747),
    [anon_sym_await] = ACTIONS(2745),
    [anon_sym_of] = ACTIONS(2745),
    [anon_sym_while] = ACTIONS(2745),
    [anon_sym_do] = ACTIONS(2745),
    [anon_sym_try] = ACTIONS(2745),
    [anon_sym_break] = ACTIONS(2745),
    [anon_sym_continue] = ACTIONS(2745),
    [anon_sym_debugger] = ACTIONS(2745),
    [anon_sym_return] = ACTIONS(2745),
    [anon_sym_throw] = ACTIONS(2745),
    [anon_sym_SEMI] = ACTIONS(2747),
    [anon_sym_case] = ACTIONS(2745),
    [anon_sym_yield] = ACTIONS(2745),
    [anon_sym_LBRACK] = ACTIONS(2747),
    [anon_sym_LTtemplate_GT] = ACTIONS(2747),
    [anon_sym_DQUOTE] = ACTIONS(2747),
    [anon_sym_SQUOTE] = ACTIONS(2747),
    [anon_sym_class] = ACTIONS(2745),
    [anon_sym_async] = ACTIONS(2745),
    [anon_sym_function] = ACTIONS(2745),
    [anon_sym_new] = ACTIONS(2745),
    [anon_sym_using] = ACTIONS(2745),
    [anon_sym_PLUS] = ACTIONS(2745),
    [anon_sym_DASH] = ACTIONS(2745),
    [anon_sym_SLASH] = ACTIONS(2745),
    [anon_sym_LT] = ACTIONS(2745),
    [anon_sym_TILDE] = ACTIONS(2747),
    [anon_sym_void] = ACTIONS(2745),
    [anon_sym_delete] = ACTIONS(2745),
    [anon_sym_PLUS_PLUS] = ACTIONS(2747),
    [anon_sym_DASH_DASH] = ACTIONS(2747),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2747),
    [sym_number] = ACTIONS(2747),
    [sym_private_property_identifier] = ACTIONS(2747),
    [sym_this] = ACTIONS(2745),
    [sym_super] = ACTIONS(2745),
    [sym_true] = ACTIONS(2745),
    [sym_false] = ACTIONS(2745),
    [sym_null] = ACTIONS(2745),
    [sym_undefined] = ACTIONS(2745),
    [anon_sym_AT] = ACTIONS(2747),
    [anon_sym_static] = ACTIONS(2745),
    [anon_sym_readonly] = ACTIONS(2745),
    [anon_sym_get] = ACTIONS(2745),
    [anon_sym_set] = ACTIONS(2745),
    [anon_sym_declare] = ACTIONS(2745),
    [anon_sym_public] = ACTIONS(2745),
    [anon_sym_private] = ACTIONS(2745),
    [anon_sym_protected] = ACTIONS(2745),
    [anon_sym_override] = ACTIONS(2745),
    [anon_sym_module] = ACTIONS(2745),
    [anon_sym_any] = ACTIONS(2745),
    [anon_sym_number] = ACTIONS(2745),
    [anon_sym_boolean] = ACTIONS(2745),
    [anon_sym_string] = ACTIONS(2745),
    [anon_sym_symbol] = ACTIONS(2745),
    [anon_sym_object] = ACTIONS(2745),
    [anon_sym_property] = ACTIONS(2745),
    [anon_sym_signal] = ACTIONS(2745),
    [anon_sym_on] = ACTIONS(2745),
    [anon_sym_required] = ACTIONS(2745),
    [anon_sym_component] = ACTIONS(2745),
    [anon_sym_abstract] = ACTIONS(2745),
    [anon_sym_interface] = ACTIONS(2745),
    [anon_sym_enum] = ACTIONS(2745),
    [sym_html_comment] = ACTIONS(5),
  },
  [819] = {
    [sym_comment] = STATE(819),
    [sym_identifier] = ACTIONS(2749),
    [anon_sym_export] = ACTIONS(2749),
    [anon_sym_default] = ACTIONS(2749),
    [anon_sym_type] = ACTIONS(2749),
    [anon_sym_namespace] = ACTIONS(2749),
    [anon_sym_LBRACE] = ACTIONS(2751),
    [anon_sym_RBRACE] = ACTIONS(2751),
    [anon_sym_typeof] = ACTIONS(2749),
    [anon_sym_import] = ACTIONS(2749),
    [anon_sym_from] = ACTIONS(2749),
    [anon_sym_with] = ACTIONS(2749),
    [anon_sym_var] = ACTIONS(2749),
    [anon_sym_let] = ACTIONS(2749),
    [anon_sym_const] = ACTIONS(2749),
    [anon_sym_BANG] = ACTIONS(2751),
    [anon_sym_else] = ACTIONS(2749),
    [anon_sym_if] = ACTIONS(2749),
    [anon_sym_switch] = ACTIONS(2749),
    [anon_sym_for] = ACTIONS(2749),
    [anon_sym_LPAREN] = ACTIONS(2751),
    [anon_sym_await] = ACTIONS(2749),
    [anon_sym_of] = ACTIONS(2749),
    [anon_sym_while] = ACTIONS(2749),
    [anon_sym_do] = ACTIONS(2749),
    [anon_sym_try] = ACTIONS(2749),
    [anon_sym_break] = ACTIONS(2749),
    [anon_sym_continue] = ACTIONS(2749),
    [anon_sym_debugger] = ACTIONS(2749),
    [anon_sym_return] = ACTIONS(2749),
    [anon_sym_throw] = ACTIONS(2749),
    [anon_sym_SEMI] = ACTIONS(2751),
    [anon_sym_case] = ACTIONS(2749),
    [anon_sym_yield] = ACTIONS(2749),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_LTtemplate_GT] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [anon_sym_SQUOTE] = ACTIONS(2751),
    [anon_sym_class] = ACTIONS(2749),
    [anon_sym_async] = ACTIONS(2749),
    [anon_sym_function] = ACTIONS(2749),
    [anon_sym_new] = ACTIONS(2749),
    [anon_sym_using] = ACTIONS(2749),
    [anon_sym_PLUS] = ACTIONS(2749),
    [anon_sym_DASH] = ACTIONS(2749),
    [anon_sym_SLASH] = ACTIONS(2749),
    [anon_sym_LT] = ACTIONS(2749),
    [anon_sym_TILDE] = ACTIONS(2751),
    [anon_sym_void] = ACTIONS(2749),
    [anon_sym_delete] = ACTIONS(2749),
    [anon_sym_PLUS_PLUS] = ACTIONS(2751),
    [anon_sym_DASH_DASH] = ACTIONS(2751),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2751),
    [sym_number] = ACTIONS(2751),
    [sym_private_property_identifier] = ACTIONS(2751),
    [sym_this] = ACTIONS(2749),
    [sym_super] = ACTIONS(2749),
    [sym_true] = ACTIONS(2749),
    [sym_false] = ACTIONS(2749),
    [sym_null] = ACTIONS(2749),
    [sym_undefined] = ACTIONS(2749),
    [anon_sym_AT] = ACTIONS(2751),
    [anon_sym_static] = ACTIONS(2749),
    [anon_sym_readonly] = ACTIONS(2749),
    [anon_sym_get] = ACTIONS(2749),
    [anon_sym_set] = ACTIONS(2749),
    [anon_sym_declare] = ACTIONS(2749),
    [anon_sym_public] = ACTIONS(2749),
    [anon_sym_private] = ACTIONS(2749),
    [anon_sym_protected] = ACTIONS(2749),
    [anon_sym_override] = ACTIONS(2749),
    [anon_sym_module] = ACTIONS(2749),
    [anon_sym_any] = ACTIONS(2749),
    [anon_sym_number] = ACTIONS(2749),
    [anon_sym_boolean] = ACTIONS(2749),
    [anon_sym_string] = ACTIONS(2749),
    [anon_sym_symbol] = ACTIONS(2749),
    [anon_sym_object] = ACTIONS(2749),
    [anon_sym_property] = ACTIONS(2749),
    [anon_sym_signal] = ACTIONS(2749),
    [anon_sym_on] = ACTIONS(2749),
    [anon_sym_required] = ACTIONS(2749),
    [anon_sym_component] = ACTIONS(2749),
    [anon_sym_abstract] = ACTIONS(2749),
    [anon_sym_interface] = ACTIONS(2749),
    [anon_sym_enum] = ACTIONS(2749),
    [sym_html_comment] = ACTIONS(5),
  },
  [820] = {
    [sym_comment] = STATE(820),
    [sym_identifier] = ACTIONS(2753),
    [anon_sym_export] = ACTIONS(2753),
    [anon_sym_default] = ACTIONS(2753),
    [anon_sym_type] = ACTIONS(2753),
    [anon_sym_namespace] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2755),
    [anon_sym_RBRACE] = ACTIONS(2755),
    [anon_sym_typeof] = ACTIONS(2753),
    [anon_sym_import] = ACTIONS(2753),
    [anon_sym_from] = ACTIONS(2753),
    [anon_sym_with] = ACTIONS(2753),
    [anon_sym_var] = ACTIONS(2753),
    [anon_sym_let] = ACTIONS(2753),
    [anon_sym_const] = ACTIONS(2753),
    [anon_sym_BANG] = ACTIONS(2755),
    [anon_sym_else] = ACTIONS(2753),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_switch] = ACTIONS(2753),
    [anon_sym_for] = ACTIONS(2753),
    [anon_sym_LPAREN] = ACTIONS(2755),
    [anon_sym_await] = ACTIONS(2753),
    [anon_sym_of] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_try] = ACTIONS(2753),
    [anon_sym_break] = ACTIONS(2753),
    [anon_sym_continue] = ACTIONS(2753),
    [anon_sym_debugger] = ACTIONS(2753),
    [anon_sym_return] = ACTIONS(2753),
    [anon_sym_throw] = ACTIONS(2753),
    [anon_sym_SEMI] = ACTIONS(2755),
    [anon_sym_case] = ACTIONS(2753),
    [anon_sym_yield] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2755),
    [anon_sym_LTtemplate_GT] = ACTIONS(2755),
    [anon_sym_DQUOTE] = ACTIONS(2755),
    [anon_sym_SQUOTE] = ACTIONS(2755),
    [anon_sym_class] = ACTIONS(2753),
    [anon_sym_async] = ACTIONS(2753),
    [anon_sym_function] = ACTIONS(2753),
    [anon_sym_new] = ACTIONS(2753),
    [anon_sym_using] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_DASH] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(2753),
    [anon_sym_LT] = ACTIONS(2753),
    [anon_sym_TILDE] = ACTIONS(2755),
    [anon_sym_void] = ACTIONS(2753),
    [anon_sym_delete] = ACTIONS(2753),
    [anon_sym_PLUS_PLUS] = ACTIONS(2755),
    [anon_sym_DASH_DASH] = ACTIONS(2755),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2755),
    [sym_number] = ACTIONS(2755),
    [sym_private_property_identifier] = ACTIONS(2755),
    [sym_this] = ACTIONS(2753),
    [sym_super] = ACTIONS(2753),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [sym_null] = ACTIONS(2753),
    [sym_undefined] = ACTIONS(2753),
    [anon_sym_AT] = ACTIONS(2755),
    [anon_sym_static] = ACTIONS(2753),
    [anon_sym_readonly] = ACTIONS(2753),
    [anon_sym_get] = ACTIONS(2753),
    [anon_sym_set] = ACTIONS(2753),
    [anon_sym_declare] = ACTIONS(2753),
    [anon_sym_public] = ACTIONS(2753),
    [anon_sym_private] = ACTIONS(2753),
    [anon_sym_protected] = ACTIONS(2753),
    [anon_sym_override] = ACTIONS(2753),
    [anon_sym_module] = ACTIONS(2753),
    [anon_sym_any] = ACTIONS(2753),
    [anon_sym_number] = ACTIONS(2753),
    [anon_sym_boolean] = ACTIONS(2753),
    [anon_sym_string] = ACTIONS(2753),
    [anon_sym_symbol] = ACTIONS(2753),
    [anon_sym_object] = ACTIONS(2753),
    [anon_sym_property] = ACTIONS(2753),
    [anon_sym_signal] = ACTIONS(2753),
    [anon_sym_on] = ACTIONS(2753),
    [anon_sym_required] = ACTIONS(2753),
    [anon_sym_component] = ACTIONS(2753),
    [anon_sym_abstract] = ACTIONS(2753),
    [anon_sym_interface] = ACTIONS(2753),
    [anon_sym_enum] = ACTIONS(2753),
    [sym_html_comment] = ACTIONS(5),
  },
  [821] = {
    [sym_comment] = STATE(821),
    [sym_identifier] = ACTIONS(2757),
    [anon_sym_export] = ACTIONS(2757),
    [anon_sym_default] = ACTIONS(2757),
    [anon_sym_type] = ACTIONS(2757),
    [anon_sym_namespace] = ACTIONS(2757),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_RBRACE] = ACTIONS(2759),
    [anon_sym_typeof] = ACTIONS(2757),
    [anon_sym_import] = ACTIONS(2757),
    [anon_sym_from] = ACTIONS(2757),
    [anon_sym_with] = ACTIONS(2757),
    [anon_sym_var] = ACTIONS(2757),
    [anon_sym_let] = ACTIONS(2757),
    [anon_sym_const] = ACTIONS(2757),
    [anon_sym_BANG] = ACTIONS(2759),
    [anon_sym_else] = ACTIONS(2757),
    [anon_sym_if] = ACTIONS(2757),
    [anon_sym_switch] = ACTIONS(2757),
    [anon_sym_for] = ACTIONS(2757),
    [anon_sym_LPAREN] = ACTIONS(2759),
    [anon_sym_await] = ACTIONS(2757),
    [anon_sym_of] = ACTIONS(2757),
    [anon_sym_while] = ACTIONS(2757),
    [anon_sym_do] = ACTIONS(2757),
    [anon_sym_try] = ACTIONS(2757),
    [anon_sym_break] = ACTIONS(2757),
    [anon_sym_continue] = ACTIONS(2757),
    [anon_sym_debugger] = ACTIONS(2757),
    [anon_sym_return] = ACTIONS(2757),
    [anon_sym_throw] = ACTIONS(2757),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_case] = ACTIONS(2757),
    [anon_sym_yield] = ACTIONS(2757),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_LTtemplate_GT] = ACTIONS(2759),
    [anon_sym_DQUOTE] = ACTIONS(2759),
    [anon_sym_SQUOTE] = ACTIONS(2759),
    [anon_sym_class] = ACTIONS(2757),
    [anon_sym_async] = ACTIONS(2757),
    [anon_sym_function] = ACTIONS(2757),
    [anon_sym_new] = ACTIONS(2757),
    [anon_sym_using] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2757),
    [anon_sym_DASH] = ACTIONS(2757),
    [anon_sym_SLASH] = ACTIONS(2757),
    [anon_sym_LT] = ACTIONS(2757),
    [anon_sym_TILDE] = ACTIONS(2759),
    [anon_sym_void] = ACTIONS(2757),
    [anon_sym_delete] = ACTIONS(2757),
    [anon_sym_PLUS_PLUS] = ACTIONS(2759),
    [anon_sym_DASH_DASH] = ACTIONS(2759),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2759),
    [sym_number] = ACTIONS(2759),
    [sym_private_property_identifier] = ACTIONS(2759),
    [sym_this] = ACTIONS(2757),
    [sym_super] = ACTIONS(2757),
    [sym_true] = ACTIONS(2757),
    [sym_false] = ACTIONS(2757),
    [sym_null] = ACTIONS(2757),
    [sym_undefined] = ACTIONS(2757),
    [anon_sym_AT] = ACTIONS(2759),
    [anon_sym_static] = ACTIONS(2757),
    [anon_sym_readonly] = ACTIONS(2757),
    [anon_sym_get] = ACTIONS(2757),
    [anon_sym_set] = ACTIONS(2757),
    [anon_sym_declare] = ACTIONS(2757),
    [anon_sym_public] = ACTIONS(2757),
    [anon_sym_private] = ACTIONS(2757),
    [anon_sym_protected] = ACTIONS(2757),
    [anon_sym_override] = ACTIONS(2757),
    [anon_sym_module] = ACTIONS(2757),
    [anon_sym_any] = ACTIONS(2757),
    [anon_sym_number] = ACTIONS(2757),
    [anon_sym_boolean] = ACTIONS(2757),
    [anon_sym_string] = ACTIONS(2757),
    [anon_sym_symbol] = ACTIONS(2757),
    [anon_sym_object] = ACTIONS(2757),
    [anon_sym_property] = ACTIONS(2757),
    [anon_sym_signal] = ACTIONS(2757),
    [anon_sym_on] = ACTIONS(2757),
    [anon_sym_required] = ACTIONS(2757),
    [anon_sym_component] = ACTIONS(2757),
    [anon_sym_abstract] = ACTIONS(2757),
    [anon_sym_interface] = ACTIONS(2757),
    [anon_sym_enum] = ACTIONS(2757),
    [sym_html_comment] = ACTIONS(5),
  },
  [822] = {
    [sym_comment] = STATE(822),
    [sym_identifier] = ACTIONS(2761),
    [anon_sym_export] = ACTIONS(2761),
    [anon_sym_default] = ACTIONS(2761),
    [anon_sym_type] = ACTIONS(2761),
    [anon_sym_namespace] = ACTIONS(2761),
    [anon_sym_LBRACE] = ACTIONS(2763),
    [anon_sym_RBRACE] = ACTIONS(2763),
    [anon_sym_typeof] = ACTIONS(2761),
    [anon_sym_import] = ACTIONS(2761),
    [anon_sym_from] = ACTIONS(2761),
    [anon_sym_with] = ACTIONS(2761),
    [anon_sym_var] = ACTIONS(2761),
    [anon_sym_let] = ACTIONS(2761),
    [anon_sym_const] = ACTIONS(2761),
    [anon_sym_BANG] = ACTIONS(2763),
    [anon_sym_else] = ACTIONS(2761),
    [anon_sym_if] = ACTIONS(2761),
    [anon_sym_switch] = ACTIONS(2761),
    [anon_sym_for] = ACTIONS(2761),
    [anon_sym_LPAREN] = ACTIONS(2763),
    [anon_sym_await] = ACTIONS(2761),
    [anon_sym_of] = ACTIONS(2761),
    [anon_sym_while] = ACTIONS(2761),
    [anon_sym_do] = ACTIONS(2761),
    [anon_sym_try] = ACTIONS(2761),
    [anon_sym_break] = ACTIONS(2761),
    [anon_sym_continue] = ACTIONS(2761),
    [anon_sym_debugger] = ACTIONS(2761),
    [anon_sym_return] = ACTIONS(2761),
    [anon_sym_throw] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2763),
    [anon_sym_case] = ACTIONS(2761),
    [anon_sym_yield] = ACTIONS(2761),
    [anon_sym_LBRACK] = ACTIONS(2763),
    [anon_sym_LTtemplate_GT] = ACTIONS(2763),
    [anon_sym_DQUOTE] = ACTIONS(2763),
    [anon_sym_SQUOTE] = ACTIONS(2763),
    [anon_sym_class] = ACTIONS(2761),
    [anon_sym_async] = ACTIONS(2761),
    [anon_sym_function] = ACTIONS(2761),
    [anon_sym_new] = ACTIONS(2761),
    [anon_sym_using] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_DASH] = ACTIONS(2761),
    [anon_sym_SLASH] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_TILDE] = ACTIONS(2763),
    [anon_sym_void] = ACTIONS(2761),
    [anon_sym_delete] = ACTIONS(2761),
    [anon_sym_PLUS_PLUS] = ACTIONS(2763),
    [anon_sym_DASH_DASH] = ACTIONS(2763),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2763),
    [sym_number] = ACTIONS(2763),
    [sym_private_property_identifier] = ACTIONS(2763),
    [sym_this] = ACTIONS(2761),
    [sym_super] = ACTIONS(2761),
    [sym_true] = ACTIONS(2761),
    [sym_false] = ACTIONS(2761),
    [sym_null] = ACTIONS(2761),
    [sym_undefined] = ACTIONS(2761),
    [anon_sym_AT] = ACTIONS(2763),
    [anon_sym_static] = ACTIONS(2761),
    [anon_sym_readonly] = ACTIONS(2761),
    [anon_sym_get] = ACTIONS(2761),
    [anon_sym_set] = ACTIONS(2761),
    [anon_sym_declare] = ACTIONS(2761),
    [anon_sym_public] = ACTIONS(2761),
    [anon_sym_private] = ACTIONS(2761),
    [anon_sym_protected] = ACTIONS(2761),
    [anon_sym_override] = ACTIONS(2761),
    [anon_sym_module] = ACTIONS(2761),
    [anon_sym_any] = ACTIONS(2761),
    [anon_sym_number] = ACTIONS(2761),
    [anon_sym_boolean] = ACTIONS(2761),
    [anon_sym_string] = ACTIONS(2761),
    [anon_sym_symbol] = ACTIONS(2761),
    [anon_sym_object] = ACTIONS(2761),
    [anon_sym_property] = ACTIONS(2761),
    [anon_sym_signal] = ACTIONS(2761),
    [anon_sym_on] = ACTIONS(2761),
    [anon_sym_required] = ACTIONS(2761),
    [anon_sym_component] = ACTIONS(2761),
    [anon_sym_abstract] = ACTIONS(2761),
    [anon_sym_interface] = ACTIONS(2761),
    [anon_sym_enum] = ACTIONS(2761),
    [sym_html_comment] = ACTIONS(5),
  },
  [823] = {
    [sym_comment] = STATE(823),
    [sym_identifier] = ACTIONS(2765),
    [anon_sym_export] = ACTIONS(2765),
    [anon_sym_default] = ACTIONS(2765),
    [anon_sym_type] = ACTIONS(2765),
    [anon_sym_namespace] = ACTIONS(2765),
    [anon_sym_LBRACE] = ACTIONS(2767),
    [anon_sym_RBRACE] = ACTIONS(2767),
    [anon_sym_typeof] = ACTIONS(2765),
    [anon_sym_import] = ACTIONS(2765),
    [anon_sym_from] = ACTIONS(2765),
    [anon_sym_with] = ACTIONS(2765),
    [anon_sym_var] = ACTIONS(2765),
    [anon_sym_let] = ACTIONS(2765),
    [anon_sym_const] = ACTIONS(2765),
    [anon_sym_BANG] = ACTIONS(2767),
    [anon_sym_else] = ACTIONS(2765),
    [anon_sym_if] = ACTIONS(2765),
    [anon_sym_switch] = ACTIONS(2765),
    [anon_sym_for] = ACTIONS(2765),
    [anon_sym_LPAREN] = ACTIONS(2767),
    [anon_sym_await] = ACTIONS(2765),
    [anon_sym_of] = ACTIONS(2765),
    [anon_sym_while] = ACTIONS(2765),
    [anon_sym_do] = ACTIONS(2765),
    [anon_sym_try] = ACTIONS(2765),
    [anon_sym_break] = ACTIONS(2765),
    [anon_sym_continue] = ACTIONS(2765),
    [anon_sym_debugger] = ACTIONS(2765),
    [anon_sym_return] = ACTIONS(2765),
    [anon_sym_throw] = ACTIONS(2765),
    [anon_sym_SEMI] = ACTIONS(2767),
    [anon_sym_case] = ACTIONS(2765),
    [anon_sym_yield] = ACTIONS(2765),
    [anon_sym_LBRACK] = ACTIONS(2767),
    [anon_sym_LTtemplate_GT] = ACTIONS(2767),
    [anon_sym_DQUOTE] = ACTIONS(2767),
    [anon_sym_SQUOTE] = ACTIONS(2767),
    [anon_sym_class] = ACTIONS(2765),
    [anon_sym_async] = ACTIONS(2765),
    [anon_sym_function] = ACTIONS(2765),
    [anon_sym_new] = ACTIONS(2765),
    [anon_sym_using] = ACTIONS(2765),
    [anon_sym_PLUS] = ACTIONS(2765),
    [anon_sym_DASH] = ACTIONS(2765),
    [anon_sym_SLASH] = ACTIONS(2765),
    [anon_sym_LT] = ACTIONS(2765),
    [anon_sym_TILDE] = ACTIONS(2767),
    [anon_sym_void] = ACTIONS(2765),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_PLUS_PLUS] = ACTIONS(2767),
    [anon_sym_DASH_DASH] = ACTIONS(2767),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2767),
    [sym_number] = ACTIONS(2767),
    [sym_private_property_identifier] = ACTIONS(2767),
    [sym_this] = ACTIONS(2765),
    [sym_super] = ACTIONS(2765),
    [sym_true] = ACTIONS(2765),
    [sym_false] = ACTIONS(2765),
    [sym_null] = ACTIONS(2765),
    [sym_undefined] = ACTIONS(2765),
    [anon_sym_AT] = ACTIONS(2767),
    [anon_sym_static] = ACTIONS(2765),
    [anon_sym_readonly] = ACTIONS(2765),
    [anon_sym_get] = ACTIONS(2765),
    [anon_sym_set] = ACTIONS(2765),
    [anon_sym_declare] = ACTIONS(2765),
    [anon_sym_public] = ACTIONS(2765),
    [anon_sym_private] = ACTIONS(2765),
    [anon_sym_protected] = ACTIONS(2765),
    [anon_sym_override] = ACTIONS(2765),
    [anon_sym_module] = ACTIONS(2765),
    [anon_sym_any] = ACTIONS(2765),
    [anon_sym_number] = ACTIONS(2765),
    [anon_sym_boolean] = ACTIONS(2765),
    [anon_sym_string] = ACTIONS(2765),
    [anon_sym_symbol] = ACTIONS(2765),
    [anon_sym_object] = ACTIONS(2765),
    [anon_sym_property] = ACTIONS(2765),
    [anon_sym_signal] = ACTIONS(2765),
    [anon_sym_on] = ACTIONS(2765),
    [anon_sym_required] = ACTIONS(2765),
    [anon_sym_component] = ACTIONS(2765),
    [anon_sym_abstract] = ACTIONS(2765),
    [anon_sym_interface] = ACTIONS(2765),
    [anon_sym_enum] = ACTIONS(2765),
    [sym_html_comment] = ACTIONS(5),
  },
  [824] = {
    [sym_comment] = STATE(824),
    [sym_identifier] = ACTIONS(2769),
    [anon_sym_export] = ACTIONS(2769),
    [anon_sym_default] = ACTIONS(2769),
    [anon_sym_type] = ACTIONS(2769),
    [anon_sym_namespace] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(2771),
    [anon_sym_RBRACE] = ACTIONS(2771),
    [anon_sym_typeof] = ACTIONS(2769),
    [anon_sym_import] = ACTIONS(2769),
    [anon_sym_from] = ACTIONS(2769),
    [anon_sym_with] = ACTIONS(2769),
    [anon_sym_var] = ACTIONS(2769),
    [anon_sym_let] = ACTIONS(2769),
    [anon_sym_const] = ACTIONS(2769),
    [anon_sym_BANG] = ACTIONS(2771),
    [anon_sym_else] = ACTIONS(2769),
    [anon_sym_if] = ACTIONS(2769),
    [anon_sym_switch] = ACTIONS(2769),
    [anon_sym_for] = ACTIONS(2769),
    [anon_sym_LPAREN] = ACTIONS(2771),
    [anon_sym_await] = ACTIONS(2769),
    [anon_sym_of] = ACTIONS(2769),
    [anon_sym_while] = ACTIONS(2769),
    [anon_sym_do] = ACTIONS(2769),
    [anon_sym_try] = ACTIONS(2769),
    [anon_sym_break] = ACTIONS(2769),
    [anon_sym_continue] = ACTIONS(2769),
    [anon_sym_debugger] = ACTIONS(2769),
    [anon_sym_return] = ACTIONS(2769),
    [anon_sym_throw] = ACTIONS(2769),
    [anon_sym_SEMI] = ACTIONS(2771),
    [anon_sym_case] = ACTIONS(2769),
    [anon_sym_yield] = ACTIONS(2769),
    [anon_sym_LBRACK] = ACTIONS(2771),
    [anon_sym_LTtemplate_GT] = ACTIONS(2771),
    [anon_sym_DQUOTE] = ACTIONS(2771),
    [anon_sym_SQUOTE] = ACTIONS(2771),
    [anon_sym_class] = ACTIONS(2769),
    [anon_sym_async] = ACTIONS(2769),
    [anon_sym_function] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2769),
    [anon_sym_using] = ACTIONS(2769),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_SLASH] = ACTIONS(2769),
    [anon_sym_LT] = ACTIONS(2769),
    [anon_sym_TILDE] = ACTIONS(2771),
    [anon_sym_void] = ACTIONS(2769),
    [anon_sym_delete] = ACTIONS(2769),
    [anon_sym_PLUS_PLUS] = ACTIONS(2771),
    [anon_sym_DASH_DASH] = ACTIONS(2771),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2771),
    [sym_number] = ACTIONS(2771),
    [sym_private_property_identifier] = ACTIONS(2771),
    [sym_this] = ACTIONS(2769),
    [sym_super] = ACTIONS(2769),
    [sym_true] = ACTIONS(2769),
    [sym_false] = ACTIONS(2769),
    [sym_null] = ACTIONS(2769),
    [sym_undefined] = ACTIONS(2769),
    [anon_sym_AT] = ACTIONS(2771),
    [anon_sym_static] = ACTIONS(2769),
    [anon_sym_readonly] = ACTIONS(2769),
    [anon_sym_get] = ACTIONS(2769),
    [anon_sym_set] = ACTIONS(2769),
    [anon_sym_declare] = ACTIONS(2769),
    [anon_sym_public] = ACTIONS(2769),
    [anon_sym_private] = ACTIONS(2769),
    [anon_sym_protected] = ACTIONS(2769),
    [anon_sym_override] = ACTIONS(2769),
    [anon_sym_module] = ACTIONS(2769),
    [anon_sym_any] = ACTIONS(2769),
    [anon_sym_number] = ACTIONS(2769),
    [anon_sym_boolean] = ACTIONS(2769),
    [anon_sym_string] = ACTIONS(2769),
    [anon_sym_symbol] = ACTIONS(2769),
    [anon_sym_object] = ACTIONS(2769),
    [anon_sym_property] = ACTIONS(2769),
    [anon_sym_signal] = ACTIONS(2769),
    [anon_sym_on] = ACTIONS(2769),
    [anon_sym_required] = ACTIONS(2769),
    [anon_sym_component] = ACTIONS(2769),
    [anon_sym_abstract] = ACTIONS(2769),
    [anon_sym_interface] = ACTIONS(2769),
    [anon_sym_enum] = ACTIONS(2769),
    [sym_html_comment] = ACTIONS(5),
  },
  [825] = {
    [sym_comment] = STATE(825),
    [sym_identifier] = ACTIONS(2773),
    [anon_sym_export] = ACTIONS(2773),
    [anon_sym_default] = ACTIONS(2773),
    [anon_sym_type] = ACTIONS(2773),
    [anon_sym_namespace] = ACTIONS(2773),
    [anon_sym_LBRACE] = ACTIONS(2775),
    [anon_sym_RBRACE] = ACTIONS(2775),
    [anon_sym_typeof] = ACTIONS(2773),
    [anon_sym_import] = ACTIONS(2773),
    [anon_sym_from] = ACTIONS(2773),
    [anon_sym_with] = ACTIONS(2773),
    [anon_sym_var] = ACTIONS(2773),
    [anon_sym_let] = ACTIONS(2773),
    [anon_sym_const] = ACTIONS(2773),
    [anon_sym_BANG] = ACTIONS(2775),
    [anon_sym_else] = ACTIONS(2773),
    [anon_sym_if] = ACTIONS(2773),
    [anon_sym_switch] = ACTIONS(2773),
    [anon_sym_for] = ACTIONS(2773),
    [anon_sym_LPAREN] = ACTIONS(2775),
    [anon_sym_await] = ACTIONS(2773),
    [anon_sym_of] = ACTIONS(2773),
    [anon_sym_while] = ACTIONS(2773),
    [anon_sym_do] = ACTIONS(2773),
    [anon_sym_try] = ACTIONS(2773),
    [anon_sym_break] = ACTIONS(2773),
    [anon_sym_continue] = ACTIONS(2773),
    [anon_sym_debugger] = ACTIONS(2773),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_throw] = ACTIONS(2773),
    [anon_sym_SEMI] = ACTIONS(2775),
    [anon_sym_case] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2773),
    [anon_sym_LBRACK] = ACTIONS(2775),
    [anon_sym_LTtemplate_GT] = ACTIONS(2775),
    [anon_sym_DQUOTE] = ACTIONS(2775),
    [anon_sym_SQUOTE] = ACTIONS(2775),
    [anon_sym_class] = ACTIONS(2773),
    [anon_sym_async] = ACTIONS(2773),
    [anon_sym_function] = ACTIONS(2773),
    [anon_sym_new] = ACTIONS(2773),
    [anon_sym_using] = ACTIONS(2773),
    [anon_sym_PLUS] = ACTIONS(2773),
    [anon_sym_DASH] = ACTIONS(2773),
    [anon_sym_SLASH] = ACTIONS(2773),
    [anon_sym_LT] = ACTIONS(2773),
    [anon_sym_TILDE] = ACTIONS(2775),
    [anon_sym_void] = ACTIONS(2773),
    [anon_sym_delete] = ACTIONS(2773),
    [anon_sym_PLUS_PLUS] = ACTIONS(2775),
    [anon_sym_DASH_DASH] = ACTIONS(2775),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2775),
    [sym_number] = ACTIONS(2775),
    [sym_private_property_identifier] = ACTIONS(2775),
    [sym_this] = ACTIONS(2773),
    [sym_super] = ACTIONS(2773),
    [sym_true] = ACTIONS(2773),
    [sym_false] = ACTIONS(2773),
    [sym_null] = ACTIONS(2773),
    [sym_undefined] = ACTIONS(2773),
    [anon_sym_AT] = ACTIONS(2775),
    [anon_sym_static] = ACTIONS(2773),
    [anon_sym_readonly] = ACTIONS(2773),
    [anon_sym_get] = ACTIONS(2773),
    [anon_sym_set] = ACTIONS(2773),
    [anon_sym_declare] = ACTIONS(2773),
    [anon_sym_public] = ACTIONS(2773),
    [anon_sym_private] = ACTIONS(2773),
    [anon_sym_protected] = ACTIONS(2773),
    [anon_sym_override] = ACTIONS(2773),
    [anon_sym_module] = ACTIONS(2773),
    [anon_sym_any] = ACTIONS(2773),
    [anon_sym_number] = ACTIONS(2773),
    [anon_sym_boolean] = ACTIONS(2773),
    [anon_sym_string] = ACTIONS(2773),
    [anon_sym_symbol] = ACTIONS(2773),
    [anon_sym_object] = ACTIONS(2773),
    [anon_sym_property] = ACTIONS(2773),
    [anon_sym_signal] = ACTIONS(2773),
    [anon_sym_on] = ACTIONS(2773),
    [anon_sym_required] = ACTIONS(2773),
    [anon_sym_component] = ACTIONS(2773),
    [anon_sym_abstract] = ACTIONS(2773),
    [anon_sym_interface] = ACTIONS(2773),
    [anon_sym_enum] = ACTIONS(2773),
    [sym_html_comment] = ACTIONS(5),
  },
  [826] = {
    [sym_comment] = STATE(826),
    [sym_identifier] = ACTIONS(2777),
    [anon_sym_export] = ACTIONS(2777),
    [anon_sym_default] = ACTIONS(2777),
    [anon_sym_type] = ACTIONS(2777),
    [anon_sym_namespace] = ACTIONS(2777),
    [anon_sym_LBRACE] = ACTIONS(2779),
    [anon_sym_RBRACE] = ACTIONS(2779),
    [anon_sym_typeof] = ACTIONS(2777),
    [anon_sym_import] = ACTIONS(2777),
    [anon_sym_from] = ACTIONS(2777),
    [anon_sym_with] = ACTIONS(2777),
    [anon_sym_var] = ACTIONS(2777),
    [anon_sym_let] = ACTIONS(2777),
    [anon_sym_const] = ACTIONS(2777),
    [anon_sym_BANG] = ACTIONS(2779),
    [anon_sym_else] = ACTIONS(2777),
    [anon_sym_if] = ACTIONS(2777),
    [anon_sym_switch] = ACTIONS(2777),
    [anon_sym_for] = ACTIONS(2777),
    [anon_sym_LPAREN] = ACTIONS(2779),
    [anon_sym_await] = ACTIONS(2777),
    [anon_sym_of] = ACTIONS(2777),
    [anon_sym_while] = ACTIONS(2777),
    [anon_sym_do] = ACTIONS(2777),
    [anon_sym_try] = ACTIONS(2777),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_continue] = ACTIONS(2777),
    [anon_sym_debugger] = ACTIONS(2777),
    [anon_sym_return] = ACTIONS(2777),
    [anon_sym_throw] = ACTIONS(2777),
    [anon_sym_SEMI] = ACTIONS(2779),
    [anon_sym_case] = ACTIONS(2777),
    [anon_sym_yield] = ACTIONS(2777),
    [anon_sym_LBRACK] = ACTIONS(2779),
    [anon_sym_LTtemplate_GT] = ACTIONS(2779),
    [anon_sym_DQUOTE] = ACTIONS(2779),
    [anon_sym_SQUOTE] = ACTIONS(2779),
    [anon_sym_class] = ACTIONS(2777),
    [anon_sym_async] = ACTIONS(2777),
    [anon_sym_function] = ACTIONS(2777),
    [anon_sym_new] = ACTIONS(2777),
    [anon_sym_using] = ACTIONS(2777),
    [anon_sym_PLUS] = ACTIONS(2777),
    [anon_sym_DASH] = ACTIONS(2777),
    [anon_sym_SLASH] = ACTIONS(2777),
    [anon_sym_LT] = ACTIONS(2777),
    [anon_sym_TILDE] = ACTIONS(2779),
    [anon_sym_void] = ACTIONS(2777),
    [anon_sym_delete] = ACTIONS(2777),
    [anon_sym_PLUS_PLUS] = ACTIONS(2779),
    [anon_sym_DASH_DASH] = ACTIONS(2779),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2779),
    [sym_number] = ACTIONS(2779),
    [sym_private_property_identifier] = ACTIONS(2779),
    [sym_this] = ACTIONS(2777),
    [sym_super] = ACTIONS(2777),
    [sym_true] = ACTIONS(2777),
    [sym_false] = ACTIONS(2777),
    [sym_null] = ACTIONS(2777),
    [sym_undefined] = ACTIONS(2777),
    [anon_sym_AT] = ACTIONS(2779),
    [anon_sym_static] = ACTIONS(2777),
    [anon_sym_readonly] = ACTIONS(2777),
    [anon_sym_get] = ACTIONS(2777),
    [anon_sym_set] = ACTIONS(2777),
    [anon_sym_declare] = ACTIONS(2777),
    [anon_sym_public] = ACTIONS(2777),
    [anon_sym_private] = ACTIONS(2777),
    [anon_sym_protected] = ACTIONS(2777),
    [anon_sym_override] = ACTIONS(2777),
    [anon_sym_module] = ACTIONS(2777),
    [anon_sym_any] = ACTIONS(2777),
    [anon_sym_number] = ACTIONS(2777),
    [anon_sym_boolean] = ACTIONS(2777),
    [anon_sym_string] = ACTIONS(2777),
    [anon_sym_symbol] = ACTIONS(2777),
    [anon_sym_object] = ACTIONS(2777),
    [anon_sym_property] = ACTIONS(2777),
    [anon_sym_signal] = ACTIONS(2777),
    [anon_sym_on] = ACTIONS(2777),
    [anon_sym_required] = ACTIONS(2777),
    [anon_sym_component] = ACTIONS(2777),
    [anon_sym_abstract] = ACTIONS(2777),
    [anon_sym_interface] = ACTIONS(2777),
    [anon_sym_enum] = ACTIONS(2777),
    [sym_html_comment] = ACTIONS(5),
  },
  [827] = {
    [sym_comment] = STATE(827),
    [sym_identifier] = ACTIONS(2781),
    [anon_sym_export] = ACTIONS(2781),
    [anon_sym_default] = ACTIONS(2781),
    [anon_sym_type] = ACTIONS(2781),
    [anon_sym_namespace] = ACTIONS(2781),
    [anon_sym_LBRACE] = ACTIONS(2783),
    [anon_sym_RBRACE] = ACTIONS(2783),
    [anon_sym_typeof] = ACTIONS(2781),
    [anon_sym_import] = ACTIONS(2781),
    [anon_sym_from] = ACTIONS(2781),
    [anon_sym_with] = ACTIONS(2781),
    [anon_sym_var] = ACTIONS(2781),
    [anon_sym_let] = ACTIONS(2781),
    [anon_sym_const] = ACTIONS(2781),
    [anon_sym_BANG] = ACTIONS(2783),
    [anon_sym_else] = ACTIONS(2781),
    [anon_sym_if] = ACTIONS(2781),
    [anon_sym_switch] = ACTIONS(2781),
    [anon_sym_for] = ACTIONS(2781),
    [anon_sym_LPAREN] = ACTIONS(2783),
    [anon_sym_await] = ACTIONS(2781),
    [anon_sym_of] = ACTIONS(2781),
    [anon_sym_while] = ACTIONS(2781),
    [anon_sym_do] = ACTIONS(2781),
    [anon_sym_try] = ACTIONS(2781),
    [anon_sym_break] = ACTIONS(2781),
    [anon_sym_continue] = ACTIONS(2781),
    [anon_sym_debugger] = ACTIONS(2781),
    [anon_sym_return] = ACTIONS(2781),
    [anon_sym_throw] = ACTIONS(2781),
    [anon_sym_SEMI] = ACTIONS(2783),
    [anon_sym_case] = ACTIONS(2781),
    [anon_sym_yield] = ACTIONS(2781),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_LTtemplate_GT] = ACTIONS(2783),
    [anon_sym_DQUOTE] = ACTIONS(2783),
    [anon_sym_SQUOTE] = ACTIONS(2783),
    [anon_sym_class] = ACTIONS(2781),
    [anon_sym_async] = ACTIONS(2781),
    [anon_sym_function] = ACTIONS(2781),
    [anon_sym_new] = ACTIONS(2781),
    [anon_sym_using] = ACTIONS(2781),
    [anon_sym_PLUS] = ACTIONS(2781),
    [anon_sym_DASH] = ACTIONS(2781),
    [anon_sym_SLASH] = ACTIONS(2781),
    [anon_sym_LT] = ACTIONS(2781),
    [anon_sym_TILDE] = ACTIONS(2783),
    [anon_sym_void] = ACTIONS(2781),
    [anon_sym_delete] = ACTIONS(2781),
    [anon_sym_PLUS_PLUS] = ACTIONS(2783),
    [anon_sym_DASH_DASH] = ACTIONS(2783),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2783),
    [sym_number] = ACTIONS(2783),
    [sym_private_property_identifier] = ACTIONS(2783),
    [sym_this] = ACTIONS(2781),
    [sym_super] = ACTIONS(2781),
    [sym_true] = ACTIONS(2781),
    [sym_false] = ACTIONS(2781),
    [sym_null] = ACTIONS(2781),
    [sym_undefined] = ACTIONS(2781),
    [anon_sym_AT] = ACTIONS(2783),
    [anon_sym_static] = ACTIONS(2781),
    [anon_sym_readonly] = ACTIONS(2781),
    [anon_sym_get] = ACTIONS(2781),
    [anon_sym_set] = ACTIONS(2781),
    [anon_sym_declare] = ACTIONS(2781),
    [anon_sym_public] = ACTIONS(2781),
    [anon_sym_private] = ACTIONS(2781),
    [anon_sym_protected] = ACTIONS(2781),
    [anon_sym_override] = ACTIONS(2781),
    [anon_sym_module] = ACTIONS(2781),
    [anon_sym_any] = ACTIONS(2781),
    [anon_sym_number] = ACTIONS(2781),
    [anon_sym_boolean] = ACTIONS(2781),
    [anon_sym_string] = ACTIONS(2781),
    [anon_sym_symbol] = ACTIONS(2781),
    [anon_sym_object] = ACTIONS(2781),
    [anon_sym_property] = ACTIONS(2781),
    [anon_sym_signal] = ACTIONS(2781),
    [anon_sym_on] = ACTIONS(2781),
    [anon_sym_required] = ACTIONS(2781),
    [anon_sym_component] = ACTIONS(2781),
    [anon_sym_abstract] = ACTIONS(2781),
    [anon_sym_interface] = ACTIONS(2781),
    [anon_sym_enum] = ACTIONS(2781),
    [sym_html_comment] = ACTIONS(5),
  },
  [828] = {
    [sym_comment] = STATE(828),
    [sym_identifier] = ACTIONS(2785),
    [anon_sym_export] = ACTIONS(2785),
    [anon_sym_default] = ACTIONS(2785),
    [anon_sym_type] = ACTIONS(2785),
    [anon_sym_namespace] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(2787),
    [anon_sym_RBRACE] = ACTIONS(2787),
    [anon_sym_typeof] = ACTIONS(2785),
    [anon_sym_import] = ACTIONS(2785),
    [anon_sym_from] = ACTIONS(2785),
    [anon_sym_with] = ACTIONS(2785),
    [anon_sym_var] = ACTIONS(2785),
    [anon_sym_let] = ACTIONS(2785),
    [anon_sym_const] = ACTIONS(2785),
    [anon_sym_BANG] = ACTIONS(2787),
    [anon_sym_else] = ACTIONS(2785),
    [anon_sym_if] = ACTIONS(2785),
    [anon_sym_switch] = ACTIONS(2785),
    [anon_sym_for] = ACTIONS(2785),
    [anon_sym_LPAREN] = ACTIONS(2787),
    [anon_sym_await] = ACTIONS(2785),
    [anon_sym_of] = ACTIONS(2785),
    [anon_sym_while] = ACTIONS(2785),
    [anon_sym_do] = ACTIONS(2785),
    [anon_sym_try] = ACTIONS(2785),
    [anon_sym_break] = ACTIONS(2785),
    [anon_sym_continue] = ACTIONS(2785),
    [anon_sym_debugger] = ACTIONS(2785),
    [anon_sym_return] = ACTIONS(2785),
    [anon_sym_throw] = ACTIONS(2785),
    [anon_sym_SEMI] = ACTIONS(2787),
    [anon_sym_case] = ACTIONS(2785),
    [anon_sym_yield] = ACTIONS(2785),
    [anon_sym_LBRACK] = ACTIONS(2787),
    [anon_sym_LTtemplate_GT] = ACTIONS(2787),
    [anon_sym_DQUOTE] = ACTIONS(2787),
    [anon_sym_SQUOTE] = ACTIONS(2787),
    [anon_sym_class] = ACTIONS(2785),
    [anon_sym_async] = ACTIONS(2785),
    [anon_sym_function] = ACTIONS(2785),
    [anon_sym_new] = ACTIONS(2785),
    [anon_sym_using] = ACTIONS(2785),
    [anon_sym_PLUS] = ACTIONS(2785),
    [anon_sym_DASH] = ACTIONS(2785),
    [anon_sym_SLASH] = ACTIONS(2785),
    [anon_sym_LT] = ACTIONS(2785),
    [anon_sym_TILDE] = ACTIONS(2787),
    [anon_sym_void] = ACTIONS(2785),
    [anon_sym_delete] = ACTIONS(2785),
    [anon_sym_PLUS_PLUS] = ACTIONS(2787),
    [anon_sym_DASH_DASH] = ACTIONS(2787),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2787),
    [sym_number] = ACTIONS(2787),
    [sym_private_property_identifier] = ACTIONS(2787),
    [sym_this] = ACTIONS(2785),
    [sym_super] = ACTIONS(2785),
    [sym_true] = ACTIONS(2785),
    [sym_false] = ACTIONS(2785),
    [sym_null] = ACTIONS(2785),
    [sym_undefined] = ACTIONS(2785),
    [anon_sym_AT] = ACTIONS(2787),
    [anon_sym_static] = ACTIONS(2785),
    [anon_sym_readonly] = ACTIONS(2785),
    [anon_sym_get] = ACTIONS(2785),
    [anon_sym_set] = ACTIONS(2785),
    [anon_sym_declare] = ACTIONS(2785),
    [anon_sym_public] = ACTIONS(2785),
    [anon_sym_private] = ACTIONS(2785),
    [anon_sym_protected] = ACTIONS(2785),
    [anon_sym_override] = ACTIONS(2785),
    [anon_sym_module] = ACTIONS(2785),
    [anon_sym_any] = ACTIONS(2785),
    [anon_sym_number] = ACTIONS(2785),
    [anon_sym_boolean] = ACTIONS(2785),
    [anon_sym_string] = ACTIONS(2785),
    [anon_sym_symbol] = ACTIONS(2785),
    [anon_sym_object] = ACTIONS(2785),
    [anon_sym_property] = ACTIONS(2785),
    [anon_sym_signal] = ACTIONS(2785),
    [anon_sym_on] = ACTIONS(2785),
    [anon_sym_required] = ACTIONS(2785),
    [anon_sym_component] = ACTIONS(2785),
    [anon_sym_abstract] = ACTIONS(2785),
    [anon_sym_interface] = ACTIONS(2785),
    [anon_sym_enum] = ACTIONS(2785),
    [sym_html_comment] = ACTIONS(5),
  },
  [829] = {
    [sym_comment] = STATE(829),
    [sym_identifier] = ACTIONS(1842),
    [anon_sym_export] = ACTIONS(1842),
    [anon_sym_default] = ACTIONS(1842),
    [anon_sym_type] = ACTIONS(1842),
    [anon_sym_namespace] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(1846),
    [anon_sym_RBRACE] = ACTIONS(1846),
    [anon_sym_typeof] = ACTIONS(1842),
    [anon_sym_import] = ACTIONS(1842),
    [anon_sym_from] = ACTIONS(1842),
    [anon_sym_with] = ACTIONS(1842),
    [anon_sym_var] = ACTIONS(1842),
    [anon_sym_let] = ACTIONS(1842),
    [anon_sym_const] = ACTIONS(1842),
    [anon_sym_BANG] = ACTIONS(1846),
    [anon_sym_else] = ACTIONS(1842),
    [anon_sym_if] = ACTIONS(1842),
    [anon_sym_switch] = ACTIONS(1842),
    [anon_sym_for] = ACTIONS(1842),
    [anon_sym_LPAREN] = ACTIONS(1846),
    [anon_sym_await] = ACTIONS(1842),
    [anon_sym_of] = ACTIONS(1842),
    [anon_sym_while] = ACTIONS(1842),
    [anon_sym_do] = ACTIONS(1842),
    [anon_sym_try] = ACTIONS(1842),
    [anon_sym_break] = ACTIONS(1842),
    [anon_sym_continue] = ACTIONS(1842),
    [anon_sym_debugger] = ACTIONS(1842),
    [anon_sym_return] = ACTIONS(1842),
    [anon_sym_throw] = ACTIONS(1842),
    [anon_sym_SEMI] = ACTIONS(1846),
    [anon_sym_case] = ACTIONS(1842),
    [anon_sym_yield] = ACTIONS(1842),
    [anon_sym_LBRACK] = ACTIONS(1846),
    [anon_sym_LTtemplate_GT] = ACTIONS(1846),
    [anon_sym_DQUOTE] = ACTIONS(1846),
    [anon_sym_SQUOTE] = ACTIONS(1846),
    [anon_sym_class] = ACTIONS(1842),
    [anon_sym_async] = ACTIONS(1842),
    [anon_sym_function] = ACTIONS(1842),
    [anon_sym_new] = ACTIONS(1842),
    [anon_sym_using] = ACTIONS(1842),
    [anon_sym_PLUS] = ACTIONS(1842),
    [anon_sym_DASH] = ACTIONS(1842),
    [anon_sym_SLASH] = ACTIONS(1842),
    [anon_sym_LT] = ACTIONS(1842),
    [anon_sym_TILDE] = ACTIONS(1846),
    [anon_sym_void] = ACTIONS(1842),
    [anon_sym_delete] = ACTIONS(1842),
    [anon_sym_PLUS_PLUS] = ACTIONS(1846),
    [anon_sym_DASH_DASH] = ACTIONS(1846),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1846),
    [sym_number] = ACTIONS(1846),
    [sym_private_property_identifier] = ACTIONS(1846),
    [sym_this] = ACTIONS(1842),
    [sym_super] = ACTIONS(1842),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [sym_null] = ACTIONS(1842),
    [sym_undefined] = ACTIONS(1842),
    [anon_sym_AT] = ACTIONS(1846),
    [anon_sym_static] = ACTIONS(1842),
    [anon_sym_readonly] = ACTIONS(1842),
    [anon_sym_get] = ACTIONS(1842),
    [anon_sym_set] = ACTIONS(1842),
    [anon_sym_declare] = ACTIONS(1842),
    [anon_sym_public] = ACTIONS(1842),
    [anon_sym_private] = ACTIONS(1842),
    [anon_sym_protected] = ACTIONS(1842),
    [anon_sym_override] = ACTIONS(1842),
    [anon_sym_module] = ACTIONS(1842),
    [anon_sym_any] = ACTIONS(1842),
    [anon_sym_number] = ACTIONS(1842),
    [anon_sym_boolean] = ACTIONS(1842),
    [anon_sym_string] = ACTIONS(1842),
    [anon_sym_symbol] = ACTIONS(1842),
    [anon_sym_object] = ACTIONS(1842),
    [anon_sym_property] = ACTIONS(1842),
    [anon_sym_signal] = ACTIONS(1842),
    [anon_sym_on] = ACTIONS(1842),
    [anon_sym_required] = ACTIONS(1842),
    [anon_sym_component] = ACTIONS(1842),
    [anon_sym_abstract] = ACTIONS(1842),
    [anon_sym_interface] = ACTIONS(1842),
    [anon_sym_enum] = ACTIONS(1842),
    [sym_html_comment] = ACTIONS(5),
  },
  [830] = {
    [sym_comment] = STATE(830),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_export] = ACTIONS(2789),
    [anon_sym_default] = ACTIONS(2789),
    [anon_sym_type] = ACTIONS(2789),
    [anon_sym_namespace] = ACTIONS(2789),
    [anon_sym_LBRACE] = ACTIONS(2791),
    [anon_sym_RBRACE] = ACTIONS(2791),
    [anon_sym_typeof] = ACTIONS(2789),
    [anon_sym_import] = ACTIONS(2789),
    [anon_sym_from] = ACTIONS(2789),
    [anon_sym_with] = ACTIONS(2789),
    [anon_sym_var] = ACTIONS(2789),
    [anon_sym_let] = ACTIONS(2789),
    [anon_sym_const] = ACTIONS(2789),
    [anon_sym_BANG] = ACTIONS(2791),
    [anon_sym_else] = ACTIONS(2789),
    [anon_sym_if] = ACTIONS(2789),
    [anon_sym_switch] = ACTIONS(2789),
    [anon_sym_for] = ACTIONS(2789),
    [anon_sym_LPAREN] = ACTIONS(2791),
    [anon_sym_await] = ACTIONS(2789),
    [anon_sym_of] = ACTIONS(2789),
    [anon_sym_while] = ACTIONS(2789),
    [anon_sym_do] = ACTIONS(2789),
    [anon_sym_try] = ACTIONS(2789),
    [anon_sym_break] = ACTIONS(2789),
    [anon_sym_continue] = ACTIONS(2789),
    [anon_sym_debugger] = ACTIONS(2789),
    [anon_sym_return] = ACTIONS(2789),
    [anon_sym_throw] = ACTIONS(2789),
    [anon_sym_SEMI] = ACTIONS(2791),
    [anon_sym_case] = ACTIONS(2789),
    [anon_sym_yield] = ACTIONS(2789),
    [anon_sym_LBRACK] = ACTIONS(2791),
    [anon_sym_LTtemplate_GT] = ACTIONS(2791),
    [anon_sym_DQUOTE] = ACTIONS(2791),
    [anon_sym_SQUOTE] = ACTIONS(2791),
    [anon_sym_class] = ACTIONS(2789),
    [anon_sym_async] = ACTIONS(2789),
    [anon_sym_function] = ACTIONS(2789),
    [anon_sym_new] = ACTIONS(2789),
    [anon_sym_using] = ACTIONS(2789),
    [anon_sym_PLUS] = ACTIONS(2789),
    [anon_sym_DASH] = ACTIONS(2789),
    [anon_sym_SLASH] = ACTIONS(2789),
    [anon_sym_LT] = ACTIONS(2789),
    [anon_sym_TILDE] = ACTIONS(2791),
    [anon_sym_void] = ACTIONS(2789),
    [anon_sym_delete] = ACTIONS(2789),
    [anon_sym_PLUS_PLUS] = ACTIONS(2791),
    [anon_sym_DASH_DASH] = ACTIONS(2791),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2791),
    [sym_number] = ACTIONS(2791),
    [sym_private_property_identifier] = ACTIONS(2791),
    [sym_this] = ACTIONS(2789),
    [sym_super] = ACTIONS(2789),
    [sym_true] = ACTIONS(2789),
    [sym_false] = ACTIONS(2789),
    [sym_null] = ACTIONS(2789),
    [sym_undefined] = ACTIONS(2789),
    [anon_sym_AT] = ACTIONS(2791),
    [anon_sym_static] = ACTIONS(2789),
    [anon_sym_readonly] = ACTIONS(2789),
    [anon_sym_get] = ACTIONS(2789),
    [anon_sym_set] = ACTIONS(2789),
    [anon_sym_declare] = ACTIONS(2789),
    [anon_sym_public] = ACTIONS(2789),
    [anon_sym_private] = ACTIONS(2789),
    [anon_sym_protected] = ACTIONS(2789),
    [anon_sym_override] = ACTIONS(2789),
    [anon_sym_module] = ACTIONS(2789),
    [anon_sym_any] = ACTIONS(2789),
    [anon_sym_number] = ACTIONS(2789),
    [anon_sym_boolean] = ACTIONS(2789),
    [anon_sym_string] = ACTIONS(2789),
    [anon_sym_symbol] = ACTIONS(2789),
    [anon_sym_object] = ACTIONS(2789),
    [anon_sym_property] = ACTIONS(2789),
    [anon_sym_signal] = ACTIONS(2789),
    [anon_sym_on] = ACTIONS(2789),
    [anon_sym_required] = ACTIONS(2789),
    [anon_sym_component] = ACTIONS(2789),
    [anon_sym_abstract] = ACTIONS(2789),
    [anon_sym_interface] = ACTIONS(2789),
    [anon_sym_enum] = ACTIONS(2789),
    [sym_html_comment] = ACTIONS(5),
  },
  [831] = {
    [sym_comment] = STATE(831),
    [sym_identifier] = ACTIONS(1842),
    [anon_sym_export] = ACTIONS(1842),
    [anon_sym_default] = ACTIONS(1842),
    [anon_sym_type] = ACTIONS(1842),
    [anon_sym_namespace] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(1846),
    [anon_sym_RBRACE] = ACTIONS(1846),
    [anon_sym_typeof] = ACTIONS(1842),
    [anon_sym_import] = ACTIONS(1842),
    [anon_sym_from] = ACTIONS(1842),
    [anon_sym_with] = ACTIONS(1842),
    [anon_sym_var] = ACTIONS(1842),
    [anon_sym_let] = ACTIONS(1842),
    [anon_sym_const] = ACTIONS(1842),
    [anon_sym_BANG] = ACTIONS(1846),
    [anon_sym_else] = ACTIONS(1842),
    [anon_sym_if] = ACTIONS(1842),
    [anon_sym_switch] = ACTIONS(1842),
    [anon_sym_for] = ACTIONS(1842),
    [anon_sym_LPAREN] = ACTIONS(1846),
    [anon_sym_await] = ACTIONS(1842),
    [anon_sym_of] = ACTIONS(1842),
    [anon_sym_while] = ACTIONS(1842),
    [anon_sym_do] = ACTIONS(1842),
    [anon_sym_try] = ACTIONS(1842),
    [anon_sym_break] = ACTIONS(1842),
    [anon_sym_continue] = ACTIONS(1842),
    [anon_sym_debugger] = ACTIONS(1842),
    [anon_sym_return] = ACTIONS(1842),
    [anon_sym_throw] = ACTIONS(1842),
    [anon_sym_SEMI] = ACTIONS(1846),
    [anon_sym_case] = ACTIONS(1842),
    [anon_sym_yield] = ACTIONS(1842),
    [anon_sym_LBRACK] = ACTIONS(1846),
    [anon_sym_LTtemplate_GT] = ACTIONS(1846),
    [anon_sym_DQUOTE] = ACTIONS(1846),
    [anon_sym_SQUOTE] = ACTIONS(1846),
    [anon_sym_class] = ACTIONS(1842),
    [anon_sym_async] = ACTIONS(1842),
    [anon_sym_function] = ACTIONS(1842),
    [anon_sym_new] = ACTIONS(1842),
    [anon_sym_using] = ACTIONS(1842),
    [anon_sym_PLUS] = ACTIONS(1842),
    [anon_sym_DASH] = ACTIONS(1842),
    [anon_sym_SLASH] = ACTIONS(1842),
    [anon_sym_LT] = ACTIONS(1842),
    [anon_sym_TILDE] = ACTIONS(1846),
    [anon_sym_void] = ACTIONS(1842),
    [anon_sym_delete] = ACTIONS(1842),
    [anon_sym_PLUS_PLUS] = ACTIONS(1846),
    [anon_sym_DASH_DASH] = ACTIONS(1846),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1846),
    [sym_number] = ACTIONS(1846),
    [sym_private_property_identifier] = ACTIONS(1846),
    [sym_this] = ACTIONS(1842),
    [sym_super] = ACTIONS(1842),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [sym_null] = ACTIONS(1842),
    [sym_undefined] = ACTIONS(1842),
    [anon_sym_AT] = ACTIONS(1846),
    [anon_sym_static] = ACTIONS(1842),
    [anon_sym_readonly] = ACTIONS(1842),
    [anon_sym_get] = ACTIONS(1842),
    [anon_sym_set] = ACTIONS(1842),
    [anon_sym_declare] = ACTIONS(1842),
    [anon_sym_public] = ACTIONS(1842),
    [anon_sym_private] = ACTIONS(1842),
    [anon_sym_protected] = ACTIONS(1842),
    [anon_sym_override] = ACTIONS(1842),
    [anon_sym_module] = ACTIONS(1842),
    [anon_sym_any] = ACTIONS(1842),
    [anon_sym_number] = ACTIONS(1842),
    [anon_sym_boolean] = ACTIONS(1842),
    [anon_sym_string] = ACTIONS(1842),
    [anon_sym_symbol] = ACTIONS(1842),
    [anon_sym_object] = ACTIONS(1842),
    [anon_sym_property] = ACTIONS(1842),
    [anon_sym_signal] = ACTIONS(1842),
    [anon_sym_on] = ACTIONS(1842),
    [anon_sym_required] = ACTIONS(1842),
    [anon_sym_component] = ACTIONS(1842),
    [anon_sym_abstract] = ACTIONS(1842),
    [anon_sym_interface] = ACTIONS(1842),
    [anon_sym_enum] = ACTIONS(1842),
    [sym_html_comment] = ACTIONS(5),
  },
  [832] = {
    [sym_comment] = STATE(832),
    [sym_identifier] = ACTIONS(2793),
    [anon_sym_export] = ACTIONS(2793),
    [anon_sym_default] = ACTIONS(2793),
    [anon_sym_type] = ACTIONS(2793),
    [anon_sym_namespace] = ACTIONS(2793),
    [anon_sym_LBRACE] = ACTIONS(2795),
    [anon_sym_RBRACE] = ACTIONS(2795),
    [anon_sym_typeof] = ACTIONS(2793),
    [anon_sym_import] = ACTIONS(2793),
    [anon_sym_from] = ACTIONS(2793),
    [anon_sym_with] = ACTIONS(2793),
    [anon_sym_var] = ACTIONS(2793),
    [anon_sym_let] = ACTIONS(2793),
    [anon_sym_const] = ACTIONS(2793),
    [anon_sym_BANG] = ACTIONS(2795),
    [anon_sym_else] = ACTIONS(2793),
    [anon_sym_if] = ACTIONS(2793),
    [anon_sym_switch] = ACTIONS(2793),
    [anon_sym_for] = ACTIONS(2793),
    [anon_sym_LPAREN] = ACTIONS(2795),
    [anon_sym_await] = ACTIONS(2793),
    [anon_sym_of] = ACTIONS(2793),
    [anon_sym_while] = ACTIONS(2793),
    [anon_sym_do] = ACTIONS(2793),
    [anon_sym_try] = ACTIONS(2793),
    [anon_sym_break] = ACTIONS(2793),
    [anon_sym_continue] = ACTIONS(2793),
    [anon_sym_debugger] = ACTIONS(2793),
    [anon_sym_return] = ACTIONS(2793),
    [anon_sym_throw] = ACTIONS(2793),
    [anon_sym_SEMI] = ACTIONS(2795),
    [anon_sym_case] = ACTIONS(2793),
    [anon_sym_yield] = ACTIONS(2793),
    [anon_sym_LBRACK] = ACTIONS(2795),
    [anon_sym_LTtemplate_GT] = ACTIONS(2795),
    [anon_sym_DQUOTE] = ACTIONS(2795),
    [anon_sym_SQUOTE] = ACTIONS(2795),
    [anon_sym_class] = ACTIONS(2793),
    [anon_sym_async] = ACTIONS(2793),
    [anon_sym_function] = ACTIONS(2793),
    [anon_sym_new] = ACTIONS(2793),
    [anon_sym_using] = ACTIONS(2793),
    [anon_sym_PLUS] = ACTIONS(2793),
    [anon_sym_DASH] = ACTIONS(2793),
    [anon_sym_SLASH] = ACTIONS(2793),
    [anon_sym_LT] = ACTIONS(2793),
    [anon_sym_TILDE] = ACTIONS(2795),
    [anon_sym_void] = ACTIONS(2793),
    [anon_sym_delete] = ACTIONS(2793),
    [anon_sym_PLUS_PLUS] = ACTIONS(2795),
    [anon_sym_DASH_DASH] = ACTIONS(2795),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2795),
    [sym_number] = ACTIONS(2795),
    [sym_private_property_identifier] = ACTIONS(2795),
    [sym_this] = ACTIONS(2793),
    [sym_super] = ACTIONS(2793),
    [sym_true] = ACTIONS(2793),
    [sym_false] = ACTIONS(2793),
    [sym_null] = ACTIONS(2793),
    [sym_undefined] = ACTIONS(2793),
    [anon_sym_AT] = ACTIONS(2795),
    [anon_sym_static] = ACTIONS(2793),
    [anon_sym_readonly] = ACTIONS(2793),
    [anon_sym_get] = ACTIONS(2793),
    [anon_sym_set] = ACTIONS(2793),
    [anon_sym_declare] = ACTIONS(2793),
    [anon_sym_public] = ACTIONS(2793),
    [anon_sym_private] = ACTIONS(2793),
    [anon_sym_protected] = ACTIONS(2793),
    [anon_sym_override] = ACTIONS(2793),
    [anon_sym_module] = ACTIONS(2793),
    [anon_sym_any] = ACTIONS(2793),
    [anon_sym_number] = ACTIONS(2793),
    [anon_sym_boolean] = ACTIONS(2793),
    [anon_sym_string] = ACTIONS(2793),
    [anon_sym_symbol] = ACTIONS(2793),
    [anon_sym_object] = ACTIONS(2793),
    [anon_sym_property] = ACTIONS(2793),
    [anon_sym_signal] = ACTIONS(2793),
    [anon_sym_on] = ACTIONS(2793),
    [anon_sym_required] = ACTIONS(2793),
    [anon_sym_component] = ACTIONS(2793),
    [anon_sym_abstract] = ACTIONS(2793),
    [anon_sym_interface] = ACTIONS(2793),
    [anon_sym_enum] = ACTIONS(2793),
    [sym_html_comment] = ACTIONS(5),
  },
  [833] = {
    [sym_comment] = STATE(833),
    [sym_identifier] = ACTIONS(2797),
    [anon_sym_export] = ACTIONS(2797),
    [anon_sym_default] = ACTIONS(2797),
    [anon_sym_type] = ACTIONS(2797),
    [anon_sym_namespace] = ACTIONS(2797),
    [anon_sym_LBRACE] = ACTIONS(2799),
    [anon_sym_RBRACE] = ACTIONS(2799),
    [anon_sym_typeof] = ACTIONS(2797),
    [anon_sym_import] = ACTIONS(2797),
    [anon_sym_from] = ACTIONS(2797),
    [anon_sym_with] = ACTIONS(2797),
    [anon_sym_var] = ACTIONS(2797),
    [anon_sym_let] = ACTIONS(2797),
    [anon_sym_const] = ACTIONS(2797),
    [anon_sym_BANG] = ACTIONS(2799),
    [anon_sym_else] = ACTIONS(2797),
    [anon_sym_if] = ACTIONS(2797),
    [anon_sym_switch] = ACTIONS(2797),
    [anon_sym_for] = ACTIONS(2797),
    [anon_sym_LPAREN] = ACTIONS(2799),
    [anon_sym_await] = ACTIONS(2797),
    [anon_sym_of] = ACTIONS(2797),
    [anon_sym_while] = ACTIONS(2797),
    [anon_sym_do] = ACTIONS(2797),
    [anon_sym_try] = ACTIONS(2797),
    [anon_sym_break] = ACTIONS(2797),
    [anon_sym_continue] = ACTIONS(2797),
    [anon_sym_debugger] = ACTIONS(2797),
    [anon_sym_return] = ACTIONS(2797),
    [anon_sym_throw] = ACTIONS(2797),
    [anon_sym_SEMI] = ACTIONS(2799),
    [anon_sym_case] = ACTIONS(2797),
    [anon_sym_yield] = ACTIONS(2797),
    [anon_sym_LBRACK] = ACTIONS(2799),
    [anon_sym_LTtemplate_GT] = ACTIONS(2799),
    [anon_sym_DQUOTE] = ACTIONS(2799),
    [anon_sym_SQUOTE] = ACTIONS(2799),
    [anon_sym_class] = ACTIONS(2797),
    [anon_sym_async] = ACTIONS(2797),
    [anon_sym_function] = ACTIONS(2797),
    [anon_sym_new] = ACTIONS(2797),
    [anon_sym_using] = ACTIONS(2797),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_DASH] = ACTIONS(2797),
    [anon_sym_SLASH] = ACTIONS(2797),
    [anon_sym_LT] = ACTIONS(2797),
    [anon_sym_TILDE] = ACTIONS(2799),
    [anon_sym_void] = ACTIONS(2797),
    [anon_sym_delete] = ACTIONS(2797),
    [anon_sym_PLUS_PLUS] = ACTIONS(2799),
    [anon_sym_DASH_DASH] = ACTIONS(2799),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2799),
    [sym_number] = ACTIONS(2799),
    [sym_private_property_identifier] = ACTIONS(2799),
    [sym_this] = ACTIONS(2797),
    [sym_super] = ACTIONS(2797),
    [sym_true] = ACTIONS(2797),
    [sym_false] = ACTIONS(2797),
    [sym_null] = ACTIONS(2797),
    [sym_undefined] = ACTIONS(2797),
    [anon_sym_AT] = ACTIONS(2799),
    [anon_sym_static] = ACTIONS(2797),
    [anon_sym_readonly] = ACTIONS(2797),
    [anon_sym_get] = ACTIONS(2797),
    [anon_sym_set] = ACTIONS(2797),
    [anon_sym_declare] = ACTIONS(2797),
    [anon_sym_public] = ACTIONS(2797),
    [anon_sym_private] = ACTIONS(2797),
    [anon_sym_protected] = ACTIONS(2797),
    [anon_sym_override] = ACTIONS(2797),
    [anon_sym_module] = ACTIONS(2797),
    [anon_sym_any] = ACTIONS(2797),
    [anon_sym_number] = ACTIONS(2797),
    [anon_sym_boolean] = ACTIONS(2797),
    [anon_sym_string] = ACTIONS(2797),
    [anon_sym_symbol] = ACTIONS(2797),
    [anon_sym_object] = ACTIONS(2797),
    [anon_sym_property] = ACTIONS(2797),
    [anon_sym_signal] = ACTIONS(2797),
    [anon_sym_on] = ACTIONS(2797),
    [anon_sym_required] = ACTIONS(2797),
    [anon_sym_component] = ACTIONS(2797),
    [anon_sym_abstract] = ACTIONS(2797),
    [anon_sym_interface] = ACTIONS(2797),
    [anon_sym_enum] = ACTIONS(2797),
    [sym_html_comment] = ACTIONS(5),
  },
  [834] = {
    [sym_comment] = STATE(834),
    [sym_identifier] = ACTIONS(2801),
    [anon_sym_export] = ACTIONS(2801),
    [anon_sym_default] = ACTIONS(2801),
    [anon_sym_type] = ACTIONS(2801),
    [anon_sym_namespace] = ACTIONS(2801),
    [anon_sym_LBRACE] = ACTIONS(2803),
    [anon_sym_RBRACE] = ACTIONS(2803),
    [anon_sym_typeof] = ACTIONS(2801),
    [anon_sym_import] = ACTIONS(2801),
    [anon_sym_from] = ACTIONS(2801),
    [anon_sym_with] = ACTIONS(2801),
    [anon_sym_var] = ACTIONS(2801),
    [anon_sym_let] = ACTIONS(2801),
    [anon_sym_const] = ACTIONS(2801),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_else] = ACTIONS(2801),
    [anon_sym_if] = ACTIONS(2801),
    [anon_sym_switch] = ACTIONS(2801),
    [anon_sym_for] = ACTIONS(2801),
    [anon_sym_LPAREN] = ACTIONS(2803),
    [anon_sym_await] = ACTIONS(2801),
    [anon_sym_of] = ACTIONS(2801),
    [anon_sym_while] = ACTIONS(2801),
    [anon_sym_do] = ACTIONS(2801),
    [anon_sym_try] = ACTIONS(2801),
    [anon_sym_break] = ACTIONS(2801),
    [anon_sym_continue] = ACTIONS(2801),
    [anon_sym_debugger] = ACTIONS(2801),
    [anon_sym_return] = ACTIONS(2801),
    [anon_sym_throw] = ACTIONS(2801),
    [anon_sym_SEMI] = ACTIONS(2803),
    [anon_sym_case] = ACTIONS(2801),
    [anon_sym_yield] = ACTIONS(2801),
    [anon_sym_LBRACK] = ACTIONS(2803),
    [anon_sym_LTtemplate_GT] = ACTIONS(2803),
    [anon_sym_DQUOTE] = ACTIONS(2803),
    [anon_sym_SQUOTE] = ACTIONS(2803),
    [anon_sym_class] = ACTIONS(2801),
    [anon_sym_async] = ACTIONS(2801),
    [anon_sym_function] = ACTIONS(2801),
    [anon_sym_new] = ACTIONS(2801),
    [anon_sym_using] = ACTIONS(2801),
    [anon_sym_PLUS] = ACTIONS(2801),
    [anon_sym_DASH] = ACTIONS(2801),
    [anon_sym_SLASH] = ACTIONS(2801),
    [anon_sym_LT] = ACTIONS(2801),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_void] = ACTIONS(2801),
    [anon_sym_delete] = ACTIONS(2801),
    [anon_sym_PLUS_PLUS] = ACTIONS(2803),
    [anon_sym_DASH_DASH] = ACTIONS(2803),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2803),
    [sym_number] = ACTIONS(2803),
    [sym_private_property_identifier] = ACTIONS(2803),
    [sym_this] = ACTIONS(2801),
    [sym_super] = ACTIONS(2801),
    [sym_true] = ACTIONS(2801),
    [sym_false] = ACTIONS(2801),
    [sym_null] = ACTIONS(2801),
    [sym_undefined] = ACTIONS(2801),
    [anon_sym_AT] = ACTIONS(2803),
    [anon_sym_static] = ACTIONS(2801),
    [anon_sym_readonly] = ACTIONS(2801),
    [anon_sym_get] = ACTIONS(2801),
    [anon_sym_set] = ACTIONS(2801),
    [anon_sym_declare] = ACTIONS(2801),
    [anon_sym_public] = ACTIONS(2801),
    [anon_sym_private] = ACTIONS(2801),
    [anon_sym_protected] = ACTIONS(2801),
    [anon_sym_override] = ACTIONS(2801),
    [anon_sym_module] = ACTIONS(2801),
    [anon_sym_any] = ACTIONS(2801),
    [anon_sym_number] = ACTIONS(2801),
    [anon_sym_boolean] = ACTIONS(2801),
    [anon_sym_string] = ACTIONS(2801),
    [anon_sym_symbol] = ACTIONS(2801),
    [anon_sym_object] = ACTIONS(2801),
    [anon_sym_property] = ACTIONS(2801),
    [anon_sym_signal] = ACTIONS(2801),
    [anon_sym_on] = ACTIONS(2801),
    [anon_sym_required] = ACTIONS(2801),
    [anon_sym_component] = ACTIONS(2801),
    [anon_sym_abstract] = ACTIONS(2801),
    [anon_sym_interface] = ACTIONS(2801),
    [anon_sym_enum] = ACTIONS(2801),
    [sym_html_comment] = ACTIONS(5),
  },
  [835] = {
    [sym_comment] = STATE(835),
    [sym_identifier] = ACTIONS(2805),
    [anon_sym_export] = ACTIONS(2805),
    [anon_sym_default] = ACTIONS(2805),
    [anon_sym_type] = ACTIONS(2805),
    [anon_sym_namespace] = ACTIONS(2805),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_RBRACE] = ACTIONS(2807),
    [anon_sym_typeof] = ACTIONS(2805),
    [anon_sym_import] = ACTIONS(2805),
    [anon_sym_from] = ACTIONS(2805),
    [anon_sym_with] = ACTIONS(2805),
    [anon_sym_var] = ACTIONS(2805),
    [anon_sym_let] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2805),
    [anon_sym_BANG] = ACTIONS(2807),
    [anon_sym_else] = ACTIONS(2805),
    [anon_sym_if] = ACTIONS(2805),
    [anon_sym_switch] = ACTIONS(2805),
    [anon_sym_for] = ACTIONS(2805),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_await] = ACTIONS(2805),
    [anon_sym_of] = ACTIONS(2805),
    [anon_sym_while] = ACTIONS(2805),
    [anon_sym_do] = ACTIONS(2805),
    [anon_sym_try] = ACTIONS(2805),
    [anon_sym_break] = ACTIONS(2805),
    [anon_sym_continue] = ACTIONS(2805),
    [anon_sym_debugger] = ACTIONS(2805),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_throw] = ACTIONS(2805),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_case] = ACTIONS(2805),
    [anon_sym_yield] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_LTtemplate_GT] = ACTIONS(2807),
    [anon_sym_DQUOTE] = ACTIONS(2807),
    [anon_sym_SQUOTE] = ACTIONS(2807),
    [anon_sym_class] = ACTIONS(2805),
    [anon_sym_async] = ACTIONS(2805),
    [anon_sym_function] = ACTIONS(2805),
    [anon_sym_new] = ACTIONS(2805),
    [anon_sym_using] = ACTIONS(2805),
    [anon_sym_PLUS] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(2805),
    [anon_sym_SLASH] = ACTIONS(2805),
    [anon_sym_LT] = ACTIONS(2805),
    [anon_sym_TILDE] = ACTIONS(2807),
    [anon_sym_void] = ACTIONS(2805),
    [anon_sym_delete] = ACTIONS(2805),
    [anon_sym_PLUS_PLUS] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2807),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2807),
    [sym_number] = ACTIONS(2807),
    [sym_private_property_identifier] = ACTIONS(2807),
    [sym_this] = ACTIONS(2805),
    [sym_super] = ACTIONS(2805),
    [sym_true] = ACTIONS(2805),
    [sym_false] = ACTIONS(2805),
    [sym_null] = ACTIONS(2805),
    [sym_undefined] = ACTIONS(2805),
    [anon_sym_AT] = ACTIONS(2807),
    [anon_sym_static] = ACTIONS(2805),
    [anon_sym_readonly] = ACTIONS(2805),
    [anon_sym_get] = ACTIONS(2805),
    [anon_sym_set] = ACTIONS(2805),
    [anon_sym_declare] = ACTIONS(2805),
    [anon_sym_public] = ACTIONS(2805),
    [anon_sym_private] = ACTIONS(2805),
    [anon_sym_protected] = ACTIONS(2805),
    [anon_sym_override] = ACTIONS(2805),
    [anon_sym_module] = ACTIONS(2805),
    [anon_sym_any] = ACTIONS(2805),
    [anon_sym_number] = ACTIONS(2805),
    [anon_sym_boolean] = ACTIONS(2805),
    [anon_sym_string] = ACTIONS(2805),
    [anon_sym_symbol] = ACTIONS(2805),
    [anon_sym_object] = ACTIONS(2805),
    [anon_sym_property] = ACTIONS(2805),
    [anon_sym_signal] = ACTIONS(2805),
    [anon_sym_on] = ACTIONS(2805),
    [anon_sym_required] = ACTIONS(2805),
    [anon_sym_component] = ACTIONS(2805),
    [anon_sym_abstract] = ACTIONS(2805),
    [anon_sym_interface] = ACTIONS(2805),
    [anon_sym_enum] = ACTIONS(2805),
    [sym_html_comment] = ACTIONS(5),
  },
  [836] = {
    [sym_comment] = STATE(836),
    [sym_identifier] = ACTIONS(2809),
    [anon_sym_export] = ACTIONS(2809),
    [anon_sym_default] = ACTIONS(2809),
    [anon_sym_type] = ACTIONS(2809),
    [anon_sym_namespace] = ACTIONS(2809),
    [anon_sym_LBRACE] = ACTIONS(2811),
    [anon_sym_RBRACE] = ACTIONS(2811),
    [anon_sym_typeof] = ACTIONS(2809),
    [anon_sym_import] = ACTIONS(2809),
    [anon_sym_from] = ACTIONS(2809),
    [anon_sym_with] = ACTIONS(2809),
    [anon_sym_var] = ACTIONS(2809),
    [anon_sym_let] = ACTIONS(2809),
    [anon_sym_const] = ACTIONS(2809),
    [anon_sym_BANG] = ACTIONS(2811),
    [anon_sym_else] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2809),
    [anon_sym_switch] = ACTIONS(2809),
    [anon_sym_for] = ACTIONS(2809),
    [anon_sym_LPAREN] = ACTIONS(2811),
    [anon_sym_await] = ACTIONS(2809),
    [anon_sym_of] = ACTIONS(2809),
    [anon_sym_while] = ACTIONS(2809),
    [anon_sym_do] = ACTIONS(2809),
    [anon_sym_try] = ACTIONS(2809),
    [anon_sym_break] = ACTIONS(2809),
    [anon_sym_continue] = ACTIONS(2809),
    [anon_sym_debugger] = ACTIONS(2809),
    [anon_sym_return] = ACTIONS(2809),
    [anon_sym_throw] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2811),
    [anon_sym_case] = ACTIONS(2809),
    [anon_sym_yield] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_LTtemplate_GT] = ACTIONS(2811),
    [anon_sym_DQUOTE] = ACTIONS(2811),
    [anon_sym_SQUOTE] = ACTIONS(2811),
    [anon_sym_class] = ACTIONS(2809),
    [anon_sym_async] = ACTIONS(2809),
    [anon_sym_function] = ACTIONS(2809),
    [anon_sym_new] = ACTIONS(2809),
    [anon_sym_using] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_DASH] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_TILDE] = ACTIONS(2811),
    [anon_sym_void] = ACTIONS(2809),
    [anon_sym_delete] = ACTIONS(2809),
    [anon_sym_PLUS_PLUS] = ACTIONS(2811),
    [anon_sym_DASH_DASH] = ACTIONS(2811),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2811),
    [sym_number] = ACTIONS(2811),
    [sym_private_property_identifier] = ACTIONS(2811),
    [sym_this] = ACTIONS(2809),
    [sym_super] = ACTIONS(2809),
    [sym_true] = ACTIONS(2809),
    [sym_false] = ACTIONS(2809),
    [sym_null] = ACTIONS(2809),
    [sym_undefined] = ACTIONS(2809),
    [anon_sym_AT] = ACTIONS(2811),
    [anon_sym_static] = ACTIONS(2809),
    [anon_sym_readonly] = ACTIONS(2809),
    [anon_sym_get] = ACTIONS(2809),
    [anon_sym_set] = ACTIONS(2809),
    [anon_sym_declare] = ACTIONS(2809),
    [anon_sym_public] = ACTIONS(2809),
    [anon_sym_private] = ACTIONS(2809),
    [anon_sym_protected] = ACTIONS(2809),
    [anon_sym_override] = ACTIONS(2809),
    [anon_sym_module] = ACTIONS(2809),
    [anon_sym_any] = ACTIONS(2809),
    [anon_sym_number] = ACTIONS(2809),
    [anon_sym_boolean] = ACTIONS(2809),
    [anon_sym_string] = ACTIONS(2809),
    [anon_sym_symbol] = ACTIONS(2809),
    [anon_sym_object] = ACTIONS(2809),
    [anon_sym_property] = ACTIONS(2809),
    [anon_sym_signal] = ACTIONS(2809),
    [anon_sym_on] = ACTIONS(2809),
    [anon_sym_required] = ACTIONS(2809),
    [anon_sym_component] = ACTIONS(2809),
    [anon_sym_abstract] = ACTIONS(2809),
    [anon_sym_interface] = ACTIONS(2809),
    [anon_sym_enum] = ACTIONS(2809),
    [sym_html_comment] = ACTIONS(5),
  },
  [837] = {
    [sym_comment] = STATE(837),
    [sym_identifier] = ACTIONS(2813),
    [anon_sym_export] = ACTIONS(2813),
    [anon_sym_default] = ACTIONS(2813),
    [anon_sym_type] = ACTIONS(2813),
    [anon_sym_namespace] = ACTIONS(2813),
    [anon_sym_LBRACE] = ACTIONS(2815),
    [anon_sym_RBRACE] = ACTIONS(2815),
    [anon_sym_typeof] = ACTIONS(2813),
    [anon_sym_import] = ACTIONS(2813),
    [anon_sym_from] = ACTIONS(2813),
    [anon_sym_with] = ACTIONS(2813),
    [anon_sym_var] = ACTIONS(2813),
    [anon_sym_let] = ACTIONS(2813),
    [anon_sym_const] = ACTIONS(2813),
    [anon_sym_BANG] = ACTIONS(2815),
    [anon_sym_else] = ACTIONS(2813),
    [anon_sym_if] = ACTIONS(2813),
    [anon_sym_switch] = ACTIONS(2813),
    [anon_sym_for] = ACTIONS(2813),
    [anon_sym_LPAREN] = ACTIONS(2815),
    [anon_sym_await] = ACTIONS(2813),
    [anon_sym_of] = ACTIONS(2813),
    [anon_sym_while] = ACTIONS(2813),
    [anon_sym_do] = ACTIONS(2813),
    [anon_sym_try] = ACTIONS(2813),
    [anon_sym_break] = ACTIONS(2813),
    [anon_sym_continue] = ACTIONS(2813),
    [anon_sym_debugger] = ACTIONS(2813),
    [anon_sym_return] = ACTIONS(2813),
    [anon_sym_throw] = ACTIONS(2813),
    [anon_sym_SEMI] = ACTIONS(2815),
    [anon_sym_case] = ACTIONS(2813),
    [anon_sym_yield] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2815),
    [anon_sym_LTtemplate_GT] = ACTIONS(2815),
    [anon_sym_DQUOTE] = ACTIONS(2815),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_class] = ACTIONS(2813),
    [anon_sym_async] = ACTIONS(2813),
    [anon_sym_function] = ACTIONS(2813),
    [anon_sym_new] = ACTIONS(2813),
    [anon_sym_using] = ACTIONS(2813),
    [anon_sym_PLUS] = ACTIONS(2813),
    [anon_sym_DASH] = ACTIONS(2813),
    [anon_sym_SLASH] = ACTIONS(2813),
    [anon_sym_LT] = ACTIONS(2813),
    [anon_sym_TILDE] = ACTIONS(2815),
    [anon_sym_void] = ACTIONS(2813),
    [anon_sym_delete] = ACTIONS(2813),
    [anon_sym_PLUS_PLUS] = ACTIONS(2815),
    [anon_sym_DASH_DASH] = ACTIONS(2815),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2815),
    [sym_number] = ACTIONS(2815),
    [sym_private_property_identifier] = ACTIONS(2815),
    [sym_this] = ACTIONS(2813),
    [sym_super] = ACTIONS(2813),
    [sym_true] = ACTIONS(2813),
    [sym_false] = ACTIONS(2813),
    [sym_null] = ACTIONS(2813),
    [sym_undefined] = ACTIONS(2813),
    [anon_sym_AT] = ACTIONS(2815),
    [anon_sym_static] = ACTIONS(2813),
    [anon_sym_readonly] = ACTIONS(2813),
    [anon_sym_get] = ACTIONS(2813),
    [anon_sym_set] = ACTIONS(2813),
    [anon_sym_declare] = ACTIONS(2813),
    [anon_sym_public] = ACTIONS(2813),
    [anon_sym_private] = ACTIONS(2813),
    [anon_sym_protected] = ACTIONS(2813),
    [anon_sym_override] = ACTIONS(2813),
    [anon_sym_module] = ACTIONS(2813),
    [anon_sym_any] = ACTIONS(2813),
    [anon_sym_number] = ACTIONS(2813),
    [anon_sym_boolean] = ACTIONS(2813),
    [anon_sym_string] = ACTIONS(2813),
    [anon_sym_symbol] = ACTIONS(2813),
    [anon_sym_object] = ACTIONS(2813),
    [anon_sym_property] = ACTIONS(2813),
    [anon_sym_signal] = ACTIONS(2813),
    [anon_sym_on] = ACTIONS(2813),
    [anon_sym_required] = ACTIONS(2813),
    [anon_sym_component] = ACTIONS(2813),
    [anon_sym_abstract] = ACTIONS(2813),
    [anon_sym_interface] = ACTIONS(2813),
    [anon_sym_enum] = ACTIONS(2813),
    [sym_html_comment] = ACTIONS(5),
  },
  [838] = {
    [sym_comment] = STATE(838),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_export] = ACTIONS(2817),
    [anon_sym_default] = ACTIONS(2817),
    [anon_sym_type] = ACTIONS(2817),
    [anon_sym_namespace] = ACTIONS(2817),
    [anon_sym_LBRACE] = ACTIONS(2819),
    [anon_sym_RBRACE] = ACTIONS(2819),
    [anon_sym_typeof] = ACTIONS(2817),
    [anon_sym_import] = ACTIONS(2817),
    [anon_sym_from] = ACTIONS(2817),
    [anon_sym_with] = ACTIONS(2817),
    [anon_sym_var] = ACTIONS(2817),
    [anon_sym_let] = ACTIONS(2817),
    [anon_sym_const] = ACTIONS(2817),
    [anon_sym_BANG] = ACTIONS(2819),
    [anon_sym_else] = ACTIONS(2817),
    [anon_sym_if] = ACTIONS(2817),
    [anon_sym_switch] = ACTIONS(2817),
    [anon_sym_for] = ACTIONS(2817),
    [anon_sym_LPAREN] = ACTIONS(2819),
    [anon_sym_await] = ACTIONS(2817),
    [anon_sym_of] = ACTIONS(2817),
    [anon_sym_while] = ACTIONS(2817),
    [anon_sym_do] = ACTIONS(2817),
    [anon_sym_try] = ACTIONS(2817),
    [anon_sym_break] = ACTIONS(2817),
    [anon_sym_continue] = ACTIONS(2817),
    [anon_sym_debugger] = ACTIONS(2817),
    [anon_sym_return] = ACTIONS(2817),
    [anon_sym_throw] = ACTIONS(2817),
    [anon_sym_SEMI] = ACTIONS(2819),
    [anon_sym_case] = ACTIONS(2817),
    [anon_sym_yield] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(2819),
    [anon_sym_LTtemplate_GT] = ACTIONS(2819),
    [anon_sym_DQUOTE] = ACTIONS(2819),
    [anon_sym_SQUOTE] = ACTIONS(2819),
    [anon_sym_class] = ACTIONS(2817),
    [anon_sym_async] = ACTIONS(2817),
    [anon_sym_function] = ACTIONS(2817),
    [anon_sym_new] = ACTIONS(2817),
    [anon_sym_using] = ACTIONS(2817),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_SLASH] = ACTIONS(2817),
    [anon_sym_LT] = ACTIONS(2817),
    [anon_sym_TILDE] = ACTIONS(2819),
    [anon_sym_void] = ACTIONS(2817),
    [anon_sym_delete] = ACTIONS(2817),
    [anon_sym_PLUS_PLUS] = ACTIONS(2819),
    [anon_sym_DASH_DASH] = ACTIONS(2819),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2819),
    [sym_number] = ACTIONS(2819),
    [sym_private_property_identifier] = ACTIONS(2819),
    [sym_this] = ACTIONS(2817),
    [sym_super] = ACTIONS(2817),
    [sym_true] = ACTIONS(2817),
    [sym_false] = ACTIONS(2817),
    [sym_null] = ACTIONS(2817),
    [sym_undefined] = ACTIONS(2817),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_static] = ACTIONS(2817),
    [anon_sym_readonly] = ACTIONS(2817),
    [anon_sym_get] = ACTIONS(2817),
    [anon_sym_set] = ACTIONS(2817),
    [anon_sym_declare] = ACTIONS(2817),
    [anon_sym_public] = ACTIONS(2817),
    [anon_sym_private] = ACTIONS(2817),
    [anon_sym_protected] = ACTIONS(2817),
    [anon_sym_override] = ACTIONS(2817),
    [anon_sym_module] = ACTIONS(2817),
    [anon_sym_any] = ACTIONS(2817),
    [anon_sym_number] = ACTIONS(2817),
    [anon_sym_boolean] = ACTIONS(2817),
    [anon_sym_string] = ACTIONS(2817),
    [anon_sym_symbol] = ACTIONS(2817),
    [anon_sym_object] = ACTIONS(2817),
    [anon_sym_property] = ACTIONS(2817),
    [anon_sym_signal] = ACTIONS(2817),
    [anon_sym_on] = ACTIONS(2817),
    [anon_sym_required] = ACTIONS(2817),
    [anon_sym_component] = ACTIONS(2817),
    [anon_sym_abstract] = ACTIONS(2817),
    [anon_sym_interface] = ACTIONS(2817),
    [anon_sym_enum] = ACTIONS(2817),
    [sym_html_comment] = ACTIONS(5),
  },
  [839] = {
    [sym_comment] = STATE(839),
    [sym_identifier] = ACTIONS(2821),
    [anon_sym_export] = ACTIONS(2821),
    [anon_sym_default] = ACTIONS(2821),
    [anon_sym_type] = ACTIONS(2821),
    [anon_sym_namespace] = ACTIONS(2821),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_RBRACE] = ACTIONS(2823),
    [anon_sym_typeof] = ACTIONS(2821),
    [anon_sym_import] = ACTIONS(2821),
    [anon_sym_from] = ACTIONS(2821),
    [anon_sym_with] = ACTIONS(2821),
    [anon_sym_var] = ACTIONS(2821),
    [anon_sym_let] = ACTIONS(2821),
    [anon_sym_const] = ACTIONS(2821),
    [anon_sym_BANG] = ACTIONS(2823),
    [anon_sym_else] = ACTIONS(2821),
    [anon_sym_if] = ACTIONS(2821),
    [anon_sym_switch] = ACTIONS(2821),
    [anon_sym_for] = ACTIONS(2821),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_await] = ACTIONS(2821),
    [anon_sym_of] = ACTIONS(2821),
    [anon_sym_while] = ACTIONS(2821),
    [anon_sym_do] = ACTIONS(2821),
    [anon_sym_try] = ACTIONS(2821),
    [anon_sym_break] = ACTIONS(2821),
    [anon_sym_continue] = ACTIONS(2821),
    [anon_sym_debugger] = ACTIONS(2821),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_throw] = ACTIONS(2821),
    [anon_sym_SEMI] = ACTIONS(2823),
    [anon_sym_case] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2821),
    [anon_sym_LBRACK] = ACTIONS(2823),
    [anon_sym_LTtemplate_GT] = ACTIONS(2823),
    [anon_sym_DQUOTE] = ACTIONS(2823),
    [anon_sym_SQUOTE] = ACTIONS(2823),
    [anon_sym_class] = ACTIONS(2821),
    [anon_sym_async] = ACTIONS(2821),
    [anon_sym_function] = ACTIONS(2821),
    [anon_sym_new] = ACTIONS(2821),
    [anon_sym_using] = ACTIONS(2821),
    [anon_sym_PLUS] = ACTIONS(2821),
    [anon_sym_DASH] = ACTIONS(2821),
    [anon_sym_SLASH] = ACTIONS(2821),
    [anon_sym_LT] = ACTIONS(2821),
    [anon_sym_TILDE] = ACTIONS(2823),
    [anon_sym_void] = ACTIONS(2821),
    [anon_sym_delete] = ACTIONS(2821),
    [anon_sym_PLUS_PLUS] = ACTIONS(2823),
    [anon_sym_DASH_DASH] = ACTIONS(2823),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2823),
    [sym_number] = ACTIONS(2823),
    [sym_private_property_identifier] = ACTIONS(2823),
    [sym_this] = ACTIONS(2821),
    [sym_super] = ACTIONS(2821),
    [sym_true] = ACTIONS(2821),
    [sym_false] = ACTIONS(2821),
    [sym_null] = ACTIONS(2821),
    [sym_undefined] = ACTIONS(2821),
    [anon_sym_AT] = ACTIONS(2823),
    [anon_sym_static] = ACTIONS(2821),
    [anon_sym_readonly] = ACTIONS(2821),
    [anon_sym_get] = ACTIONS(2821),
    [anon_sym_set] = ACTIONS(2821),
    [anon_sym_declare] = ACTIONS(2821),
    [anon_sym_public] = ACTIONS(2821),
    [anon_sym_private] = ACTIONS(2821),
    [anon_sym_protected] = ACTIONS(2821),
    [anon_sym_override] = ACTIONS(2821),
    [anon_sym_module] = ACTIONS(2821),
    [anon_sym_any] = ACTIONS(2821),
    [anon_sym_number] = ACTIONS(2821),
    [anon_sym_boolean] = ACTIONS(2821),
    [anon_sym_string] = ACTIONS(2821),
    [anon_sym_symbol] = ACTIONS(2821),
    [anon_sym_object] = ACTIONS(2821),
    [anon_sym_property] = ACTIONS(2821),
    [anon_sym_signal] = ACTIONS(2821),
    [anon_sym_on] = ACTIONS(2821),
    [anon_sym_required] = ACTIONS(2821),
    [anon_sym_component] = ACTIONS(2821),
    [anon_sym_abstract] = ACTIONS(2821),
    [anon_sym_interface] = ACTIONS(2821),
    [anon_sym_enum] = ACTIONS(2821),
    [sym_html_comment] = ACTIONS(5),
  },
  [840] = {
    [sym_comment] = STATE(840),
    [sym_identifier] = ACTIONS(2825),
    [anon_sym_export] = ACTIONS(2825),
    [anon_sym_default] = ACTIONS(2825),
    [anon_sym_type] = ACTIONS(2825),
    [anon_sym_namespace] = ACTIONS(2825),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_RBRACE] = ACTIONS(2827),
    [anon_sym_typeof] = ACTIONS(2825),
    [anon_sym_import] = ACTIONS(2825),
    [anon_sym_from] = ACTIONS(2825),
    [anon_sym_with] = ACTIONS(2825),
    [anon_sym_var] = ACTIONS(2825),
    [anon_sym_let] = ACTIONS(2825),
    [anon_sym_const] = ACTIONS(2825),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_else] = ACTIONS(2825),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_switch] = ACTIONS(2825),
    [anon_sym_for] = ACTIONS(2825),
    [anon_sym_LPAREN] = ACTIONS(2827),
    [anon_sym_await] = ACTIONS(2825),
    [anon_sym_of] = ACTIONS(2825),
    [anon_sym_while] = ACTIONS(2825),
    [anon_sym_do] = ACTIONS(2825),
    [anon_sym_try] = ACTIONS(2825),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_continue] = ACTIONS(2825),
    [anon_sym_debugger] = ACTIONS(2825),
    [anon_sym_return] = ACTIONS(2825),
    [anon_sym_throw] = ACTIONS(2825),
    [anon_sym_SEMI] = ACTIONS(2827),
    [anon_sym_case] = ACTIONS(2825),
    [anon_sym_yield] = ACTIONS(2825),
    [anon_sym_LBRACK] = ACTIONS(2827),
    [anon_sym_LTtemplate_GT] = ACTIONS(2827),
    [anon_sym_DQUOTE] = ACTIONS(2827),
    [anon_sym_SQUOTE] = ACTIONS(2827),
    [anon_sym_class] = ACTIONS(2825),
    [anon_sym_async] = ACTIONS(2825),
    [anon_sym_function] = ACTIONS(2825),
    [anon_sym_new] = ACTIONS(2825),
    [anon_sym_using] = ACTIONS(2825),
    [anon_sym_PLUS] = ACTIONS(2825),
    [anon_sym_DASH] = ACTIONS(2825),
    [anon_sym_SLASH] = ACTIONS(2825),
    [anon_sym_LT] = ACTIONS(2825),
    [anon_sym_TILDE] = ACTIONS(2827),
    [anon_sym_void] = ACTIONS(2825),
    [anon_sym_delete] = ACTIONS(2825),
    [anon_sym_PLUS_PLUS] = ACTIONS(2827),
    [anon_sym_DASH_DASH] = ACTIONS(2827),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2827),
    [sym_number] = ACTIONS(2827),
    [sym_private_property_identifier] = ACTIONS(2827),
    [sym_this] = ACTIONS(2825),
    [sym_super] = ACTIONS(2825),
    [sym_true] = ACTIONS(2825),
    [sym_false] = ACTIONS(2825),
    [sym_null] = ACTIONS(2825),
    [sym_undefined] = ACTIONS(2825),
    [anon_sym_AT] = ACTIONS(2827),
    [anon_sym_static] = ACTIONS(2825),
    [anon_sym_readonly] = ACTIONS(2825),
    [anon_sym_get] = ACTIONS(2825),
    [anon_sym_set] = ACTIONS(2825),
    [anon_sym_declare] = ACTIONS(2825),
    [anon_sym_public] = ACTIONS(2825),
    [anon_sym_private] = ACTIONS(2825),
    [anon_sym_protected] = ACTIONS(2825),
    [anon_sym_override] = ACTIONS(2825),
    [anon_sym_module] = ACTIONS(2825),
    [anon_sym_any] = ACTIONS(2825),
    [anon_sym_number] = ACTIONS(2825),
    [anon_sym_boolean] = ACTIONS(2825),
    [anon_sym_string] = ACTIONS(2825),
    [anon_sym_symbol] = ACTIONS(2825),
    [anon_sym_object] = ACTIONS(2825),
    [anon_sym_property] = ACTIONS(2825),
    [anon_sym_signal] = ACTIONS(2825),
    [anon_sym_on] = ACTIONS(2825),
    [anon_sym_required] = ACTIONS(2825),
    [anon_sym_component] = ACTIONS(2825),
    [anon_sym_abstract] = ACTIONS(2825),
    [anon_sym_interface] = ACTIONS(2825),
    [anon_sym_enum] = ACTIONS(2825),
    [sym_html_comment] = ACTIONS(5),
  },
  [841] = {
    [sym_comment] = STATE(841),
    [sym_identifier] = ACTIONS(2829),
    [anon_sym_export] = ACTIONS(2829),
    [anon_sym_default] = ACTIONS(2829),
    [anon_sym_type] = ACTIONS(2829),
    [anon_sym_namespace] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(2831),
    [anon_sym_RBRACE] = ACTIONS(2831),
    [anon_sym_typeof] = ACTIONS(2829),
    [anon_sym_import] = ACTIONS(2829),
    [anon_sym_from] = ACTIONS(2829),
    [anon_sym_with] = ACTIONS(2829),
    [anon_sym_var] = ACTIONS(2829),
    [anon_sym_let] = ACTIONS(2829),
    [anon_sym_const] = ACTIONS(2829),
    [anon_sym_BANG] = ACTIONS(2831),
    [anon_sym_else] = ACTIONS(2829),
    [anon_sym_if] = ACTIONS(2829),
    [anon_sym_switch] = ACTIONS(2829),
    [anon_sym_for] = ACTIONS(2829),
    [anon_sym_LPAREN] = ACTIONS(2831),
    [anon_sym_await] = ACTIONS(2829),
    [anon_sym_of] = ACTIONS(2829),
    [anon_sym_while] = ACTIONS(2829),
    [anon_sym_do] = ACTIONS(2829),
    [anon_sym_try] = ACTIONS(2829),
    [anon_sym_break] = ACTIONS(2829),
    [anon_sym_continue] = ACTIONS(2829),
    [anon_sym_debugger] = ACTIONS(2829),
    [anon_sym_return] = ACTIONS(2829),
    [anon_sym_throw] = ACTIONS(2829),
    [anon_sym_SEMI] = ACTIONS(2831),
    [anon_sym_case] = ACTIONS(2829),
    [anon_sym_yield] = ACTIONS(2829),
    [anon_sym_LBRACK] = ACTIONS(2831),
    [anon_sym_LTtemplate_GT] = ACTIONS(2831),
    [anon_sym_DQUOTE] = ACTIONS(2831),
    [anon_sym_SQUOTE] = ACTIONS(2831),
    [anon_sym_class] = ACTIONS(2829),
    [anon_sym_async] = ACTIONS(2829),
    [anon_sym_function] = ACTIONS(2829),
    [anon_sym_new] = ACTIONS(2829),
    [anon_sym_using] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2829),
    [anon_sym_DASH] = ACTIONS(2829),
    [anon_sym_SLASH] = ACTIONS(2829),
    [anon_sym_LT] = ACTIONS(2829),
    [anon_sym_TILDE] = ACTIONS(2831),
    [anon_sym_void] = ACTIONS(2829),
    [anon_sym_delete] = ACTIONS(2829),
    [anon_sym_PLUS_PLUS] = ACTIONS(2831),
    [anon_sym_DASH_DASH] = ACTIONS(2831),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2831),
    [sym_number] = ACTIONS(2831),
    [sym_private_property_identifier] = ACTIONS(2831),
    [sym_this] = ACTIONS(2829),
    [sym_super] = ACTIONS(2829),
    [sym_true] = ACTIONS(2829),
    [sym_false] = ACTIONS(2829),
    [sym_null] = ACTIONS(2829),
    [sym_undefined] = ACTIONS(2829),
    [anon_sym_AT] = ACTIONS(2831),
    [anon_sym_static] = ACTIONS(2829),
    [anon_sym_readonly] = ACTIONS(2829),
    [anon_sym_get] = ACTIONS(2829),
    [anon_sym_set] = ACTIONS(2829),
    [anon_sym_declare] = ACTIONS(2829),
    [anon_sym_public] = ACTIONS(2829),
    [anon_sym_private] = ACTIONS(2829),
    [anon_sym_protected] = ACTIONS(2829),
    [anon_sym_override] = ACTIONS(2829),
    [anon_sym_module] = ACTIONS(2829),
    [anon_sym_any] = ACTIONS(2829),
    [anon_sym_number] = ACTIONS(2829),
    [anon_sym_boolean] = ACTIONS(2829),
    [anon_sym_string] = ACTIONS(2829),
    [anon_sym_symbol] = ACTIONS(2829),
    [anon_sym_object] = ACTIONS(2829),
    [anon_sym_property] = ACTIONS(2829),
    [anon_sym_signal] = ACTIONS(2829),
    [anon_sym_on] = ACTIONS(2829),
    [anon_sym_required] = ACTIONS(2829),
    [anon_sym_component] = ACTIONS(2829),
    [anon_sym_abstract] = ACTIONS(2829),
    [anon_sym_interface] = ACTIONS(2829),
    [anon_sym_enum] = ACTIONS(2829),
    [sym_html_comment] = ACTIONS(5),
  },
  [842] = {
    [sym_comment] = STATE(842),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_export] = ACTIONS(2833),
    [anon_sym_default] = ACTIONS(2833),
    [anon_sym_type] = ACTIONS(2833),
    [anon_sym_namespace] = ACTIONS(2833),
    [anon_sym_LBRACE] = ACTIONS(2835),
    [anon_sym_RBRACE] = ACTIONS(2835),
    [anon_sym_typeof] = ACTIONS(2833),
    [anon_sym_import] = ACTIONS(2833),
    [anon_sym_from] = ACTIONS(2833),
    [anon_sym_with] = ACTIONS(2833),
    [anon_sym_var] = ACTIONS(2833),
    [anon_sym_let] = ACTIONS(2833),
    [anon_sym_const] = ACTIONS(2833),
    [anon_sym_BANG] = ACTIONS(2835),
    [anon_sym_else] = ACTIONS(2833),
    [anon_sym_if] = ACTIONS(2833),
    [anon_sym_switch] = ACTIONS(2833),
    [anon_sym_for] = ACTIONS(2833),
    [anon_sym_LPAREN] = ACTIONS(2835),
    [anon_sym_await] = ACTIONS(2833),
    [anon_sym_of] = ACTIONS(2833),
    [anon_sym_while] = ACTIONS(2833),
    [anon_sym_do] = ACTIONS(2833),
    [anon_sym_try] = ACTIONS(2833),
    [anon_sym_break] = ACTIONS(2833),
    [anon_sym_continue] = ACTIONS(2833),
    [anon_sym_debugger] = ACTIONS(2833),
    [anon_sym_return] = ACTIONS(2833),
    [anon_sym_throw] = ACTIONS(2833),
    [anon_sym_SEMI] = ACTIONS(2835),
    [anon_sym_case] = ACTIONS(2833),
    [anon_sym_yield] = ACTIONS(2833),
    [anon_sym_LBRACK] = ACTIONS(2835),
    [anon_sym_LTtemplate_GT] = ACTIONS(2835),
    [anon_sym_DQUOTE] = ACTIONS(2835),
    [anon_sym_SQUOTE] = ACTIONS(2835),
    [anon_sym_class] = ACTIONS(2833),
    [anon_sym_async] = ACTIONS(2833),
    [anon_sym_function] = ACTIONS(2833),
    [anon_sym_new] = ACTIONS(2833),
    [anon_sym_using] = ACTIONS(2833),
    [anon_sym_PLUS] = ACTIONS(2833),
    [anon_sym_DASH] = ACTIONS(2833),
    [anon_sym_SLASH] = ACTIONS(2833),
    [anon_sym_LT] = ACTIONS(2833),
    [anon_sym_TILDE] = ACTIONS(2835),
    [anon_sym_void] = ACTIONS(2833),
    [anon_sym_delete] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2835),
    [anon_sym_DASH_DASH] = ACTIONS(2835),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2835),
    [sym_number] = ACTIONS(2835),
    [sym_private_property_identifier] = ACTIONS(2835),
    [sym_this] = ACTIONS(2833),
    [sym_super] = ACTIONS(2833),
    [sym_true] = ACTIONS(2833),
    [sym_false] = ACTIONS(2833),
    [sym_null] = ACTIONS(2833),
    [sym_undefined] = ACTIONS(2833),
    [anon_sym_AT] = ACTIONS(2835),
    [anon_sym_static] = ACTIONS(2833),
    [anon_sym_readonly] = ACTIONS(2833),
    [anon_sym_get] = ACTIONS(2833),
    [anon_sym_set] = ACTIONS(2833),
    [anon_sym_declare] = ACTIONS(2833),
    [anon_sym_public] = ACTIONS(2833),
    [anon_sym_private] = ACTIONS(2833),
    [anon_sym_protected] = ACTIONS(2833),
    [anon_sym_override] = ACTIONS(2833),
    [anon_sym_module] = ACTIONS(2833),
    [anon_sym_any] = ACTIONS(2833),
    [anon_sym_number] = ACTIONS(2833),
    [anon_sym_boolean] = ACTIONS(2833),
    [anon_sym_string] = ACTIONS(2833),
    [anon_sym_symbol] = ACTIONS(2833),
    [anon_sym_object] = ACTIONS(2833),
    [anon_sym_property] = ACTIONS(2833),
    [anon_sym_signal] = ACTIONS(2833),
    [anon_sym_on] = ACTIONS(2833),
    [anon_sym_required] = ACTIONS(2833),
    [anon_sym_component] = ACTIONS(2833),
    [anon_sym_abstract] = ACTIONS(2833),
    [anon_sym_interface] = ACTIONS(2833),
    [anon_sym_enum] = ACTIONS(2833),
    [sym_html_comment] = ACTIONS(5),
  },
  [843] = {
    [sym_comment] = STATE(843),
    [sym_identifier] = ACTIONS(2813),
    [anon_sym_export] = ACTIONS(2813),
    [anon_sym_default] = ACTIONS(2813),
    [anon_sym_type] = ACTIONS(2813),
    [anon_sym_namespace] = ACTIONS(2813),
    [anon_sym_LBRACE] = ACTIONS(2815),
    [anon_sym_RBRACE] = ACTIONS(2815),
    [anon_sym_typeof] = ACTIONS(2813),
    [anon_sym_import] = ACTIONS(2813),
    [anon_sym_from] = ACTIONS(2813),
    [anon_sym_with] = ACTIONS(2813),
    [anon_sym_var] = ACTIONS(2813),
    [anon_sym_let] = ACTIONS(2813),
    [anon_sym_const] = ACTIONS(2813),
    [anon_sym_BANG] = ACTIONS(2815),
    [anon_sym_else] = ACTIONS(2813),
    [anon_sym_if] = ACTIONS(2813),
    [anon_sym_switch] = ACTIONS(2813),
    [anon_sym_for] = ACTIONS(2813),
    [anon_sym_LPAREN] = ACTIONS(2815),
    [anon_sym_await] = ACTIONS(2813),
    [anon_sym_of] = ACTIONS(2813),
    [anon_sym_while] = ACTIONS(2813),
    [anon_sym_do] = ACTIONS(2813),
    [anon_sym_try] = ACTIONS(2813),
    [anon_sym_break] = ACTIONS(2813),
    [anon_sym_continue] = ACTIONS(2813),
    [anon_sym_debugger] = ACTIONS(2813),
    [anon_sym_return] = ACTIONS(2813),
    [anon_sym_throw] = ACTIONS(2813),
    [anon_sym_SEMI] = ACTIONS(2815),
    [anon_sym_case] = ACTIONS(2813),
    [anon_sym_yield] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2815),
    [anon_sym_LTtemplate_GT] = ACTIONS(2815),
    [anon_sym_DQUOTE] = ACTIONS(2815),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_class] = ACTIONS(2813),
    [anon_sym_async] = ACTIONS(2813),
    [anon_sym_function] = ACTIONS(2813),
    [anon_sym_new] = ACTIONS(2813),
    [anon_sym_using] = ACTIONS(2813),
    [anon_sym_PLUS] = ACTIONS(2813),
    [anon_sym_DASH] = ACTIONS(2813),
    [anon_sym_SLASH] = ACTIONS(2813),
    [anon_sym_LT] = ACTIONS(2813),
    [anon_sym_TILDE] = ACTIONS(2815),
    [anon_sym_void] = ACTIONS(2813),
    [anon_sym_delete] = ACTIONS(2813),
    [anon_sym_PLUS_PLUS] = ACTIONS(2815),
    [anon_sym_DASH_DASH] = ACTIONS(2815),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2815),
    [sym_number] = ACTIONS(2815),
    [sym_private_property_identifier] = ACTIONS(2815),
    [sym_this] = ACTIONS(2813),
    [sym_super] = ACTIONS(2813),
    [sym_true] = ACTIONS(2813),
    [sym_false] = ACTIONS(2813),
    [sym_null] = ACTIONS(2813),
    [sym_undefined] = ACTIONS(2813),
    [anon_sym_AT] = ACTIONS(2815),
    [anon_sym_static] = ACTIONS(2813),
    [anon_sym_readonly] = ACTIONS(2813),
    [anon_sym_get] = ACTIONS(2813),
    [anon_sym_set] = ACTIONS(2813),
    [anon_sym_declare] = ACTIONS(2813),
    [anon_sym_public] = ACTIONS(2813),
    [anon_sym_private] = ACTIONS(2813),
    [anon_sym_protected] = ACTIONS(2813),
    [anon_sym_override] = ACTIONS(2813),
    [anon_sym_module] = ACTIONS(2813),
    [anon_sym_any] = ACTIONS(2813),
    [anon_sym_number] = ACTIONS(2813),
    [anon_sym_boolean] = ACTIONS(2813),
    [anon_sym_string] = ACTIONS(2813),
    [anon_sym_symbol] = ACTIONS(2813),
    [anon_sym_object] = ACTIONS(2813),
    [anon_sym_property] = ACTIONS(2813),
    [anon_sym_signal] = ACTIONS(2813),
    [anon_sym_on] = ACTIONS(2813),
    [anon_sym_required] = ACTIONS(2813),
    [anon_sym_component] = ACTIONS(2813),
    [anon_sym_abstract] = ACTIONS(2813),
    [anon_sym_interface] = ACTIONS(2813),
    [anon_sym_enum] = ACTIONS(2813),
    [sym_html_comment] = ACTIONS(5),
  },
  [844] = {
    [sym_comment] = STATE(844),
    [sym_identifier] = ACTIONS(2837),
    [anon_sym_export] = ACTIONS(2837),
    [anon_sym_default] = ACTIONS(2837),
    [anon_sym_type] = ACTIONS(2837),
    [anon_sym_namespace] = ACTIONS(2837),
    [anon_sym_LBRACE] = ACTIONS(2839),
    [anon_sym_RBRACE] = ACTIONS(2839),
    [anon_sym_typeof] = ACTIONS(2837),
    [anon_sym_import] = ACTIONS(2837),
    [anon_sym_from] = ACTIONS(2837),
    [anon_sym_with] = ACTIONS(2837),
    [anon_sym_var] = ACTIONS(2837),
    [anon_sym_let] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(2837),
    [anon_sym_BANG] = ACTIONS(2839),
    [anon_sym_else] = ACTIONS(2837),
    [anon_sym_if] = ACTIONS(2837),
    [anon_sym_switch] = ACTIONS(2837),
    [anon_sym_for] = ACTIONS(2837),
    [anon_sym_LPAREN] = ACTIONS(2839),
    [anon_sym_await] = ACTIONS(2837),
    [anon_sym_of] = ACTIONS(2837),
    [anon_sym_while] = ACTIONS(2837),
    [anon_sym_do] = ACTIONS(2837),
    [anon_sym_try] = ACTIONS(2837),
    [anon_sym_break] = ACTIONS(2837),
    [anon_sym_continue] = ACTIONS(2837),
    [anon_sym_debugger] = ACTIONS(2837),
    [anon_sym_return] = ACTIONS(2837),
    [anon_sym_throw] = ACTIONS(2837),
    [anon_sym_SEMI] = ACTIONS(2839),
    [anon_sym_case] = ACTIONS(2837),
    [anon_sym_yield] = ACTIONS(2837),
    [anon_sym_LBRACK] = ACTIONS(2839),
    [anon_sym_LTtemplate_GT] = ACTIONS(2839),
    [anon_sym_DQUOTE] = ACTIONS(2839),
    [anon_sym_SQUOTE] = ACTIONS(2839),
    [anon_sym_class] = ACTIONS(2837),
    [anon_sym_async] = ACTIONS(2837),
    [anon_sym_function] = ACTIONS(2837),
    [anon_sym_new] = ACTIONS(2837),
    [anon_sym_using] = ACTIONS(2837),
    [anon_sym_PLUS] = ACTIONS(2837),
    [anon_sym_DASH] = ACTIONS(2837),
    [anon_sym_SLASH] = ACTIONS(2837),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_TILDE] = ACTIONS(2839),
    [anon_sym_void] = ACTIONS(2837),
    [anon_sym_delete] = ACTIONS(2837),
    [anon_sym_PLUS_PLUS] = ACTIONS(2839),
    [anon_sym_DASH_DASH] = ACTIONS(2839),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [sym_number] = ACTIONS(2839),
    [sym_private_property_identifier] = ACTIONS(2839),
    [sym_this] = ACTIONS(2837),
    [sym_super] = ACTIONS(2837),
    [sym_true] = ACTIONS(2837),
    [sym_false] = ACTIONS(2837),
    [sym_null] = ACTIONS(2837),
    [sym_undefined] = ACTIONS(2837),
    [anon_sym_AT] = ACTIONS(2839),
    [anon_sym_static] = ACTIONS(2837),
    [anon_sym_readonly] = ACTIONS(2837),
    [anon_sym_get] = ACTIONS(2837),
    [anon_sym_set] = ACTIONS(2837),
    [anon_sym_declare] = ACTIONS(2837),
    [anon_sym_public] = ACTIONS(2837),
    [anon_sym_private] = ACTIONS(2837),
    [anon_sym_protected] = ACTIONS(2837),
    [anon_sym_override] = ACTIONS(2837),
    [anon_sym_module] = ACTIONS(2837),
    [anon_sym_any] = ACTIONS(2837),
    [anon_sym_number] = ACTIONS(2837),
    [anon_sym_boolean] = ACTIONS(2837),
    [anon_sym_string] = ACTIONS(2837),
    [anon_sym_symbol] = ACTIONS(2837),
    [anon_sym_object] = ACTIONS(2837),
    [anon_sym_property] = ACTIONS(2837),
    [anon_sym_signal] = ACTIONS(2837),
    [anon_sym_on] = ACTIONS(2837),
    [anon_sym_required] = ACTIONS(2837),
    [anon_sym_component] = ACTIONS(2837),
    [anon_sym_abstract] = ACTIONS(2837),
    [anon_sym_interface] = ACTIONS(2837),
    [anon_sym_enum] = ACTIONS(2837),
    [sym_html_comment] = ACTIONS(5),
  },
  [845] = {
    [sym_comment] = STATE(845),
    [sym_identifier] = ACTIONS(2841),
    [anon_sym_export] = ACTIONS(2841),
    [anon_sym_default] = ACTIONS(2841),
    [anon_sym_type] = ACTIONS(2841),
    [anon_sym_namespace] = ACTIONS(2841),
    [anon_sym_LBRACE] = ACTIONS(2843),
    [anon_sym_RBRACE] = ACTIONS(2843),
    [anon_sym_typeof] = ACTIONS(2841),
    [anon_sym_import] = ACTIONS(2841),
    [anon_sym_from] = ACTIONS(2841),
    [anon_sym_with] = ACTIONS(2841),
    [anon_sym_var] = ACTIONS(2841),
    [anon_sym_let] = ACTIONS(2841),
    [anon_sym_const] = ACTIONS(2841),
    [anon_sym_BANG] = ACTIONS(2843),
    [anon_sym_else] = ACTIONS(2841),
    [anon_sym_if] = ACTIONS(2841),
    [anon_sym_switch] = ACTIONS(2841),
    [anon_sym_for] = ACTIONS(2841),
    [anon_sym_LPAREN] = ACTIONS(2843),
    [anon_sym_await] = ACTIONS(2841),
    [anon_sym_of] = ACTIONS(2841),
    [anon_sym_while] = ACTIONS(2841),
    [anon_sym_do] = ACTIONS(2841),
    [anon_sym_try] = ACTIONS(2841),
    [anon_sym_break] = ACTIONS(2841),
    [anon_sym_continue] = ACTIONS(2841),
    [anon_sym_debugger] = ACTIONS(2841),
    [anon_sym_return] = ACTIONS(2841),
    [anon_sym_throw] = ACTIONS(2841),
    [anon_sym_SEMI] = ACTIONS(2843),
    [anon_sym_case] = ACTIONS(2841),
    [anon_sym_yield] = ACTIONS(2841),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_LTtemplate_GT] = ACTIONS(2843),
    [anon_sym_DQUOTE] = ACTIONS(2843),
    [anon_sym_SQUOTE] = ACTIONS(2843),
    [anon_sym_class] = ACTIONS(2841),
    [anon_sym_async] = ACTIONS(2841),
    [anon_sym_function] = ACTIONS(2841),
    [anon_sym_new] = ACTIONS(2841),
    [anon_sym_using] = ACTIONS(2841),
    [anon_sym_PLUS] = ACTIONS(2841),
    [anon_sym_DASH] = ACTIONS(2841),
    [anon_sym_SLASH] = ACTIONS(2841),
    [anon_sym_LT] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_void] = ACTIONS(2841),
    [anon_sym_delete] = ACTIONS(2841),
    [anon_sym_PLUS_PLUS] = ACTIONS(2843),
    [anon_sym_DASH_DASH] = ACTIONS(2843),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2843),
    [sym_number] = ACTIONS(2843),
    [sym_private_property_identifier] = ACTIONS(2843),
    [sym_this] = ACTIONS(2841),
    [sym_super] = ACTIONS(2841),
    [sym_true] = ACTIONS(2841),
    [sym_false] = ACTIONS(2841),
    [sym_null] = ACTIONS(2841),
    [sym_undefined] = ACTIONS(2841),
    [anon_sym_AT] = ACTIONS(2843),
    [anon_sym_static] = ACTIONS(2841),
    [anon_sym_readonly] = ACTIONS(2841),
    [anon_sym_get] = ACTIONS(2841),
    [anon_sym_set] = ACTIONS(2841),
    [anon_sym_declare] = ACTIONS(2841),
    [anon_sym_public] = ACTIONS(2841),
    [anon_sym_private] = ACTIONS(2841),
    [anon_sym_protected] = ACTIONS(2841),
    [anon_sym_override] = ACTIONS(2841),
    [anon_sym_module] = ACTIONS(2841),
    [anon_sym_any] = ACTIONS(2841),
    [anon_sym_number] = ACTIONS(2841),
    [anon_sym_boolean] = ACTIONS(2841),
    [anon_sym_string] = ACTIONS(2841),
    [anon_sym_symbol] = ACTIONS(2841),
    [anon_sym_object] = ACTIONS(2841),
    [anon_sym_property] = ACTIONS(2841),
    [anon_sym_signal] = ACTIONS(2841),
    [anon_sym_on] = ACTIONS(2841),
    [anon_sym_required] = ACTIONS(2841),
    [anon_sym_component] = ACTIONS(2841),
    [anon_sym_abstract] = ACTIONS(2841),
    [anon_sym_interface] = ACTIONS(2841),
    [anon_sym_enum] = ACTIONS(2841),
    [sym_html_comment] = ACTIONS(5),
  },
  [846] = {
    [sym_comment] = STATE(846),
    [sym_identifier] = ACTIONS(2845),
    [anon_sym_export] = ACTIONS(2845),
    [anon_sym_default] = ACTIONS(2845),
    [anon_sym_type] = ACTIONS(2845),
    [anon_sym_namespace] = ACTIONS(2845),
    [anon_sym_LBRACE] = ACTIONS(2847),
    [anon_sym_RBRACE] = ACTIONS(2847),
    [anon_sym_typeof] = ACTIONS(2845),
    [anon_sym_import] = ACTIONS(2845),
    [anon_sym_from] = ACTIONS(2845),
    [anon_sym_with] = ACTIONS(2845),
    [anon_sym_var] = ACTIONS(2845),
    [anon_sym_let] = ACTIONS(2845),
    [anon_sym_const] = ACTIONS(2845),
    [anon_sym_BANG] = ACTIONS(2847),
    [anon_sym_else] = ACTIONS(2845),
    [anon_sym_if] = ACTIONS(2845),
    [anon_sym_switch] = ACTIONS(2845),
    [anon_sym_for] = ACTIONS(2845),
    [anon_sym_LPAREN] = ACTIONS(2847),
    [anon_sym_await] = ACTIONS(2845),
    [anon_sym_of] = ACTIONS(2845),
    [anon_sym_while] = ACTIONS(2845),
    [anon_sym_do] = ACTIONS(2845),
    [anon_sym_try] = ACTIONS(2845),
    [anon_sym_break] = ACTIONS(2845),
    [anon_sym_continue] = ACTIONS(2845),
    [anon_sym_debugger] = ACTIONS(2845),
    [anon_sym_return] = ACTIONS(2845),
    [anon_sym_throw] = ACTIONS(2845),
    [anon_sym_SEMI] = ACTIONS(2847),
    [anon_sym_case] = ACTIONS(2845),
    [anon_sym_yield] = ACTIONS(2845),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_LTtemplate_GT] = ACTIONS(2847),
    [anon_sym_DQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [anon_sym_class] = ACTIONS(2845),
    [anon_sym_async] = ACTIONS(2845),
    [anon_sym_function] = ACTIONS(2845),
    [anon_sym_new] = ACTIONS(2845),
    [anon_sym_using] = ACTIONS(2845),
    [anon_sym_PLUS] = ACTIONS(2845),
    [anon_sym_DASH] = ACTIONS(2845),
    [anon_sym_SLASH] = ACTIONS(2845),
    [anon_sym_LT] = ACTIONS(2845),
    [anon_sym_TILDE] = ACTIONS(2847),
    [anon_sym_void] = ACTIONS(2845),
    [anon_sym_delete] = ACTIONS(2845),
    [anon_sym_PLUS_PLUS] = ACTIONS(2847),
    [anon_sym_DASH_DASH] = ACTIONS(2847),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2847),
    [sym_number] = ACTIONS(2847),
    [sym_private_property_identifier] = ACTIONS(2847),
    [sym_this] = ACTIONS(2845),
    [sym_super] = ACTIONS(2845),
    [sym_true] = ACTIONS(2845),
    [sym_false] = ACTIONS(2845),
    [sym_null] = ACTIONS(2845),
    [sym_undefined] = ACTIONS(2845),
    [anon_sym_AT] = ACTIONS(2847),
    [anon_sym_static] = ACTIONS(2845),
    [anon_sym_readonly] = ACTIONS(2845),
    [anon_sym_get] = ACTIONS(2845),
    [anon_sym_set] = ACTIONS(2845),
    [anon_sym_declare] = ACTIONS(2845),
    [anon_sym_public] = ACTIONS(2845),
    [anon_sym_private] = ACTIONS(2845),
    [anon_sym_protected] = ACTIONS(2845),
    [anon_sym_override] = ACTIONS(2845),
    [anon_sym_module] = ACTIONS(2845),
    [anon_sym_any] = ACTIONS(2845),
    [anon_sym_number] = ACTIONS(2845),
    [anon_sym_boolean] = ACTIONS(2845),
    [anon_sym_string] = ACTIONS(2845),
    [anon_sym_symbol] = ACTIONS(2845),
    [anon_sym_object] = ACTIONS(2845),
    [anon_sym_property] = ACTIONS(2845),
    [anon_sym_signal] = ACTIONS(2845),
    [anon_sym_on] = ACTIONS(2845),
    [anon_sym_required] = ACTIONS(2845),
    [anon_sym_component] = ACTIONS(2845),
    [anon_sym_abstract] = ACTIONS(2845),
    [anon_sym_interface] = ACTIONS(2845),
    [anon_sym_enum] = ACTIONS(2845),
    [sym_html_comment] = ACTIONS(5),
  },
  [847] = {
    [sym_comment] = STATE(847),
    [sym_identifier] = ACTIONS(2849),
    [anon_sym_export] = ACTIONS(2849),
    [anon_sym_default] = ACTIONS(2849),
    [anon_sym_type] = ACTIONS(2849),
    [anon_sym_namespace] = ACTIONS(2849),
    [anon_sym_LBRACE] = ACTIONS(2851),
    [anon_sym_RBRACE] = ACTIONS(2851),
    [anon_sym_typeof] = ACTIONS(2849),
    [anon_sym_import] = ACTIONS(2849),
    [anon_sym_from] = ACTIONS(2849),
    [anon_sym_with] = ACTIONS(2849),
    [anon_sym_var] = ACTIONS(2849),
    [anon_sym_let] = ACTIONS(2849),
    [anon_sym_const] = ACTIONS(2849),
    [anon_sym_BANG] = ACTIONS(2851),
    [anon_sym_else] = ACTIONS(2849),
    [anon_sym_if] = ACTIONS(2849),
    [anon_sym_switch] = ACTIONS(2849),
    [anon_sym_for] = ACTIONS(2849),
    [anon_sym_LPAREN] = ACTIONS(2851),
    [anon_sym_await] = ACTIONS(2849),
    [anon_sym_of] = ACTIONS(2849),
    [anon_sym_while] = ACTIONS(2849),
    [anon_sym_do] = ACTIONS(2849),
    [anon_sym_try] = ACTIONS(2849),
    [anon_sym_break] = ACTIONS(2849),
    [anon_sym_continue] = ACTIONS(2849),
    [anon_sym_debugger] = ACTIONS(2849),
    [anon_sym_return] = ACTIONS(2849),
    [anon_sym_throw] = ACTIONS(2849),
    [anon_sym_SEMI] = ACTIONS(2851),
    [anon_sym_case] = ACTIONS(2849),
    [anon_sym_yield] = ACTIONS(2849),
    [anon_sym_LBRACK] = ACTIONS(2851),
    [anon_sym_LTtemplate_GT] = ACTIONS(2851),
    [anon_sym_DQUOTE] = ACTIONS(2851),
    [anon_sym_SQUOTE] = ACTIONS(2851),
    [anon_sym_class] = ACTIONS(2849),
    [anon_sym_async] = ACTIONS(2849),
    [anon_sym_function] = ACTIONS(2849),
    [anon_sym_new] = ACTIONS(2849),
    [anon_sym_using] = ACTIONS(2849),
    [anon_sym_PLUS] = ACTIONS(2849),
    [anon_sym_DASH] = ACTIONS(2849),
    [anon_sym_SLASH] = ACTIONS(2849),
    [anon_sym_LT] = ACTIONS(2849),
    [anon_sym_TILDE] = ACTIONS(2851),
    [anon_sym_void] = ACTIONS(2849),
    [anon_sym_delete] = ACTIONS(2849),
    [anon_sym_PLUS_PLUS] = ACTIONS(2851),
    [anon_sym_DASH_DASH] = ACTIONS(2851),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2851),
    [sym_number] = ACTIONS(2851),
    [sym_private_property_identifier] = ACTIONS(2851),
    [sym_this] = ACTIONS(2849),
    [sym_super] = ACTIONS(2849),
    [sym_true] = ACTIONS(2849),
    [sym_false] = ACTIONS(2849),
    [sym_null] = ACTIONS(2849),
    [sym_undefined] = ACTIONS(2849),
    [anon_sym_AT] = ACTIONS(2851),
    [anon_sym_static] = ACTIONS(2849),
    [anon_sym_readonly] = ACTIONS(2849),
    [anon_sym_get] = ACTIONS(2849),
    [anon_sym_set] = ACTIONS(2849),
    [anon_sym_declare] = ACTIONS(2849),
    [anon_sym_public] = ACTIONS(2849),
    [anon_sym_private] = ACTIONS(2849),
    [anon_sym_protected] = ACTIONS(2849),
    [anon_sym_override] = ACTIONS(2849),
    [anon_sym_module] = ACTIONS(2849),
    [anon_sym_any] = ACTIONS(2849),
    [anon_sym_number] = ACTIONS(2849),
    [anon_sym_boolean] = ACTIONS(2849),
    [anon_sym_string] = ACTIONS(2849),
    [anon_sym_symbol] = ACTIONS(2849),
    [anon_sym_object] = ACTIONS(2849),
    [anon_sym_property] = ACTIONS(2849),
    [anon_sym_signal] = ACTIONS(2849),
    [anon_sym_on] = ACTIONS(2849),
    [anon_sym_required] = ACTIONS(2849),
    [anon_sym_component] = ACTIONS(2849),
    [anon_sym_abstract] = ACTIONS(2849),
    [anon_sym_interface] = ACTIONS(2849),
    [anon_sym_enum] = ACTIONS(2849),
    [sym_html_comment] = ACTIONS(5),
  },
  [848] = {
    [sym_comment] = STATE(848),
    [sym_identifier] = ACTIONS(2853),
    [anon_sym_export] = ACTIONS(2853),
    [anon_sym_default] = ACTIONS(2853),
    [anon_sym_type] = ACTIONS(2853),
    [anon_sym_namespace] = ACTIONS(2853),
    [anon_sym_LBRACE] = ACTIONS(2855),
    [anon_sym_RBRACE] = ACTIONS(2855),
    [anon_sym_typeof] = ACTIONS(2853),
    [anon_sym_import] = ACTIONS(2853),
    [anon_sym_from] = ACTIONS(2853),
    [anon_sym_with] = ACTIONS(2853),
    [anon_sym_var] = ACTIONS(2853),
    [anon_sym_let] = ACTIONS(2853),
    [anon_sym_const] = ACTIONS(2853),
    [anon_sym_BANG] = ACTIONS(2855),
    [anon_sym_else] = ACTIONS(2853),
    [anon_sym_if] = ACTIONS(2853),
    [anon_sym_switch] = ACTIONS(2853),
    [anon_sym_for] = ACTIONS(2853),
    [anon_sym_LPAREN] = ACTIONS(2855),
    [anon_sym_await] = ACTIONS(2853),
    [anon_sym_of] = ACTIONS(2853),
    [anon_sym_while] = ACTIONS(2853),
    [anon_sym_do] = ACTIONS(2853),
    [anon_sym_try] = ACTIONS(2853),
    [anon_sym_break] = ACTIONS(2853),
    [anon_sym_continue] = ACTIONS(2853),
    [anon_sym_debugger] = ACTIONS(2853),
    [anon_sym_return] = ACTIONS(2853),
    [anon_sym_throw] = ACTIONS(2853),
    [anon_sym_SEMI] = ACTIONS(2855),
    [anon_sym_case] = ACTIONS(2853),
    [anon_sym_yield] = ACTIONS(2853),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_LTtemplate_GT] = ACTIONS(2855),
    [anon_sym_DQUOTE] = ACTIONS(2855),
    [anon_sym_SQUOTE] = ACTIONS(2855),
    [anon_sym_class] = ACTIONS(2853),
    [anon_sym_async] = ACTIONS(2853),
    [anon_sym_function] = ACTIONS(2853),
    [anon_sym_new] = ACTIONS(2853),
    [anon_sym_using] = ACTIONS(2853),
    [anon_sym_PLUS] = ACTIONS(2853),
    [anon_sym_DASH] = ACTIONS(2853),
    [anon_sym_SLASH] = ACTIONS(2853),
    [anon_sym_LT] = ACTIONS(2853),
    [anon_sym_TILDE] = ACTIONS(2855),
    [anon_sym_void] = ACTIONS(2853),
    [anon_sym_delete] = ACTIONS(2853),
    [anon_sym_PLUS_PLUS] = ACTIONS(2855),
    [anon_sym_DASH_DASH] = ACTIONS(2855),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2855),
    [sym_number] = ACTIONS(2855),
    [sym_private_property_identifier] = ACTIONS(2855),
    [sym_this] = ACTIONS(2853),
    [sym_super] = ACTIONS(2853),
    [sym_true] = ACTIONS(2853),
    [sym_false] = ACTIONS(2853),
    [sym_null] = ACTIONS(2853),
    [sym_undefined] = ACTIONS(2853),
    [anon_sym_AT] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(2853),
    [anon_sym_readonly] = ACTIONS(2853),
    [anon_sym_get] = ACTIONS(2853),
    [anon_sym_set] = ACTIONS(2853),
    [anon_sym_declare] = ACTIONS(2853),
    [anon_sym_public] = ACTIONS(2853),
    [anon_sym_private] = ACTIONS(2853),
    [anon_sym_protected] = ACTIONS(2853),
    [anon_sym_override] = ACTIONS(2853),
    [anon_sym_module] = ACTIONS(2853),
    [anon_sym_any] = ACTIONS(2853),
    [anon_sym_number] = ACTIONS(2853),
    [anon_sym_boolean] = ACTIONS(2853),
    [anon_sym_string] = ACTIONS(2853),
    [anon_sym_symbol] = ACTIONS(2853),
    [anon_sym_object] = ACTIONS(2853),
    [anon_sym_property] = ACTIONS(2853),
    [anon_sym_signal] = ACTIONS(2853),
    [anon_sym_on] = ACTIONS(2853),
    [anon_sym_required] = ACTIONS(2853),
    [anon_sym_component] = ACTIONS(2853),
    [anon_sym_abstract] = ACTIONS(2853),
    [anon_sym_interface] = ACTIONS(2853),
    [anon_sym_enum] = ACTIONS(2853),
    [sym_html_comment] = ACTIONS(5),
  },
  [849] = {
    [sym_comment] = STATE(849),
    [sym_identifier] = ACTIONS(2857),
    [anon_sym_export] = ACTIONS(2857),
    [anon_sym_default] = ACTIONS(2857),
    [anon_sym_type] = ACTIONS(2857),
    [anon_sym_namespace] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(2859),
    [anon_sym_RBRACE] = ACTIONS(2859),
    [anon_sym_typeof] = ACTIONS(2857),
    [anon_sym_import] = ACTIONS(2857),
    [anon_sym_from] = ACTIONS(2857),
    [anon_sym_with] = ACTIONS(2857),
    [anon_sym_var] = ACTIONS(2857),
    [anon_sym_let] = ACTIONS(2857),
    [anon_sym_const] = ACTIONS(2857),
    [anon_sym_BANG] = ACTIONS(2859),
    [anon_sym_else] = ACTIONS(2857),
    [anon_sym_if] = ACTIONS(2857),
    [anon_sym_switch] = ACTIONS(2857),
    [anon_sym_for] = ACTIONS(2857),
    [anon_sym_LPAREN] = ACTIONS(2859),
    [anon_sym_await] = ACTIONS(2857),
    [anon_sym_of] = ACTIONS(2857),
    [anon_sym_while] = ACTIONS(2857),
    [anon_sym_do] = ACTIONS(2857),
    [anon_sym_try] = ACTIONS(2857),
    [anon_sym_break] = ACTIONS(2857),
    [anon_sym_continue] = ACTIONS(2857),
    [anon_sym_debugger] = ACTIONS(2857),
    [anon_sym_return] = ACTIONS(2857),
    [anon_sym_throw] = ACTIONS(2857),
    [anon_sym_SEMI] = ACTIONS(2859),
    [anon_sym_case] = ACTIONS(2857),
    [anon_sym_yield] = ACTIONS(2857),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_LTtemplate_GT] = ACTIONS(2859),
    [anon_sym_DQUOTE] = ACTIONS(2859),
    [anon_sym_SQUOTE] = ACTIONS(2859),
    [anon_sym_class] = ACTIONS(2857),
    [anon_sym_async] = ACTIONS(2857),
    [anon_sym_function] = ACTIONS(2857),
    [anon_sym_new] = ACTIONS(2857),
    [anon_sym_using] = ACTIONS(2857),
    [anon_sym_PLUS] = ACTIONS(2857),
    [anon_sym_DASH] = ACTIONS(2857),
    [anon_sym_SLASH] = ACTIONS(2857),
    [anon_sym_LT] = ACTIONS(2857),
    [anon_sym_TILDE] = ACTIONS(2859),
    [anon_sym_void] = ACTIONS(2857),
    [anon_sym_delete] = ACTIONS(2857),
    [anon_sym_PLUS_PLUS] = ACTIONS(2859),
    [anon_sym_DASH_DASH] = ACTIONS(2859),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2859),
    [sym_number] = ACTIONS(2859),
    [sym_private_property_identifier] = ACTIONS(2859),
    [sym_this] = ACTIONS(2857),
    [sym_super] = ACTIONS(2857),
    [sym_true] = ACTIONS(2857),
    [sym_false] = ACTIONS(2857),
    [sym_null] = ACTIONS(2857),
    [sym_undefined] = ACTIONS(2857),
    [anon_sym_AT] = ACTIONS(2859),
    [anon_sym_static] = ACTIONS(2857),
    [anon_sym_readonly] = ACTIONS(2857),
    [anon_sym_get] = ACTIONS(2857),
    [anon_sym_set] = ACTIONS(2857),
    [anon_sym_declare] = ACTIONS(2857),
    [anon_sym_public] = ACTIONS(2857),
    [anon_sym_private] = ACTIONS(2857),
    [anon_sym_protected] = ACTIONS(2857),
    [anon_sym_override] = ACTIONS(2857),
    [anon_sym_module] = ACTIONS(2857),
    [anon_sym_any] = ACTIONS(2857),
    [anon_sym_number] = ACTIONS(2857),
    [anon_sym_boolean] = ACTIONS(2857),
    [anon_sym_string] = ACTIONS(2857),
    [anon_sym_symbol] = ACTIONS(2857),
    [anon_sym_object] = ACTIONS(2857),
    [anon_sym_property] = ACTIONS(2857),
    [anon_sym_signal] = ACTIONS(2857),
    [anon_sym_on] = ACTIONS(2857),
    [anon_sym_required] = ACTIONS(2857),
    [anon_sym_component] = ACTIONS(2857),
    [anon_sym_abstract] = ACTIONS(2857),
    [anon_sym_interface] = ACTIONS(2857),
    [anon_sym_enum] = ACTIONS(2857),
    [sym_html_comment] = ACTIONS(5),
  },
  [850] = {
    [sym_comment] = STATE(850),
    [sym_identifier] = ACTIONS(2861),
    [anon_sym_export] = ACTIONS(2861),
    [anon_sym_default] = ACTIONS(2861),
    [anon_sym_type] = ACTIONS(2861),
    [anon_sym_namespace] = ACTIONS(2861),
    [anon_sym_LBRACE] = ACTIONS(2863),
    [anon_sym_RBRACE] = ACTIONS(2863),
    [anon_sym_typeof] = ACTIONS(2861),
    [anon_sym_import] = ACTIONS(2861),
    [anon_sym_from] = ACTIONS(2861),
    [anon_sym_with] = ACTIONS(2861),
    [anon_sym_var] = ACTIONS(2861),
    [anon_sym_let] = ACTIONS(2861),
    [anon_sym_const] = ACTIONS(2861),
    [anon_sym_BANG] = ACTIONS(2863),
    [anon_sym_else] = ACTIONS(2861),
    [anon_sym_if] = ACTIONS(2861),
    [anon_sym_switch] = ACTIONS(2861),
    [anon_sym_for] = ACTIONS(2861),
    [anon_sym_LPAREN] = ACTIONS(2863),
    [anon_sym_await] = ACTIONS(2861),
    [anon_sym_of] = ACTIONS(2861),
    [anon_sym_while] = ACTIONS(2861),
    [anon_sym_do] = ACTIONS(2861),
    [anon_sym_try] = ACTIONS(2861),
    [anon_sym_break] = ACTIONS(2861),
    [anon_sym_continue] = ACTIONS(2861),
    [anon_sym_debugger] = ACTIONS(2861),
    [anon_sym_return] = ACTIONS(2861),
    [anon_sym_throw] = ACTIONS(2861),
    [anon_sym_SEMI] = ACTIONS(2863),
    [anon_sym_case] = ACTIONS(2861),
    [anon_sym_yield] = ACTIONS(2861),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_LTtemplate_GT] = ACTIONS(2863),
    [anon_sym_DQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_class] = ACTIONS(2861),
    [anon_sym_async] = ACTIONS(2861),
    [anon_sym_function] = ACTIONS(2861),
    [anon_sym_new] = ACTIONS(2861),
    [anon_sym_using] = ACTIONS(2861),
    [anon_sym_PLUS] = ACTIONS(2861),
    [anon_sym_DASH] = ACTIONS(2861),
    [anon_sym_SLASH] = ACTIONS(2861),
    [anon_sym_LT] = ACTIONS(2861),
    [anon_sym_TILDE] = ACTIONS(2863),
    [anon_sym_void] = ACTIONS(2861),
    [anon_sym_delete] = ACTIONS(2861),
    [anon_sym_PLUS_PLUS] = ACTIONS(2863),
    [anon_sym_DASH_DASH] = ACTIONS(2863),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2863),
    [sym_number] = ACTIONS(2863),
    [sym_private_property_identifier] = ACTIONS(2863),
    [sym_this] = ACTIONS(2861),
    [sym_super] = ACTIONS(2861),
    [sym_true] = ACTIONS(2861),
    [sym_false] = ACTIONS(2861),
    [sym_null] = ACTIONS(2861),
    [sym_undefined] = ACTIONS(2861),
    [anon_sym_AT] = ACTIONS(2863),
    [anon_sym_static] = ACTIONS(2861),
    [anon_sym_readonly] = ACTIONS(2861),
    [anon_sym_get] = ACTIONS(2861),
    [anon_sym_set] = ACTIONS(2861),
    [anon_sym_declare] = ACTIONS(2861),
    [anon_sym_public] = ACTIONS(2861),
    [anon_sym_private] = ACTIONS(2861),
    [anon_sym_protected] = ACTIONS(2861),
    [anon_sym_override] = ACTIONS(2861),
    [anon_sym_module] = ACTIONS(2861),
    [anon_sym_any] = ACTIONS(2861),
    [anon_sym_number] = ACTIONS(2861),
    [anon_sym_boolean] = ACTIONS(2861),
    [anon_sym_string] = ACTIONS(2861),
    [anon_sym_symbol] = ACTIONS(2861),
    [anon_sym_object] = ACTIONS(2861),
    [anon_sym_property] = ACTIONS(2861),
    [anon_sym_signal] = ACTIONS(2861),
    [anon_sym_on] = ACTIONS(2861),
    [anon_sym_required] = ACTIONS(2861),
    [anon_sym_component] = ACTIONS(2861),
    [anon_sym_abstract] = ACTIONS(2861),
    [anon_sym_interface] = ACTIONS(2861),
    [anon_sym_enum] = ACTIONS(2861),
    [sym_html_comment] = ACTIONS(5),
  },
  [851] = {
    [sym_comment] = STATE(851),
    [sym_identifier] = ACTIONS(2865),
    [anon_sym_export] = ACTIONS(2865),
    [anon_sym_default] = ACTIONS(2865),
    [anon_sym_type] = ACTIONS(2865),
    [anon_sym_namespace] = ACTIONS(2865),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_RBRACE] = ACTIONS(2867),
    [anon_sym_typeof] = ACTIONS(2865),
    [anon_sym_import] = ACTIONS(2865),
    [anon_sym_from] = ACTIONS(2865),
    [anon_sym_with] = ACTIONS(2865),
    [anon_sym_var] = ACTIONS(2865),
    [anon_sym_let] = ACTIONS(2865),
    [anon_sym_const] = ACTIONS(2865),
    [anon_sym_BANG] = ACTIONS(2867),
    [anon_sym_else] = ACTIONS(2865),
    [anon_sym_if] = ACTIONS(2865),
    [anon_sym_switch] = ACTIONS(2865),
    [anon_sym_for] = ACTIONS(2865),
    [anon_sym_LPAREN] = ACTIONS(2867),
    [anon_sym_await] = ACTIONS(2865),
    [anon_sym_of] = ACTIONS(2865),
    [anon_sym_while] = ACTIONS(2865),
    [anon_sym_do] = ACTIONS(2865),
    [anon_sym_try] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2865),
    [anon_sym_continue] = ACTIONS(2865),
    [anon_sym_debugger] = ACTIONS(2865),
    [anon_sym_return] = ACTIONS(2865),
    [anon_sym_throw] = ACTIONS(2865),
    [anon_sym_SEMI] = ACTIONS(2867),
    [anon_sym_case] = ACTIONS(2865),
    [anon_sym_yield] = ACTIONS(2865),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_LTtemplate_GT] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [anon_sym_SQUOTE] = ACTIONS(2867),
    [anon_sym_class] = ACTIONS(2865),
    [anon_sym_async] = ACTIONS(2865),
    [anon_sym_function] = ACTIONS(2865),
    [anon_sym_new] = ACTIONS(2865),
    [anon_sym_using] = ACTIONS(2865),
    [anon_sym_PLUS] = ACTIONS(2865),
    [anon_sym_DASH] = ACTIONS(2865),
    [anon_sym_SLASH] = ACTIONS(2865),
    [anon_sym_LT] = ACTIONS(2865),
    [anon_sym_TILDE] = ACTIONS(2867),
    [anon_sym_void] = ACTIONS(2865),
    [anon_sym_delete] = ACTIONS(2865),
    [anon_sym_PLUS_PLUS] = ACTIONS(2867),
    [anon_sym_DASH_DASH] = ACTIONS(2867),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2867),
    [sym_number] = ACTIONS(2867),
    [sym_private_property_identifier] = ACTIONS(2867),
    [sym_this] = ACTIONS(2865),
    [sym_super] = ACTIONS(2865),
    [sym_true] = ACTIONS(2865),
    [sym_false] = ACTIONS(2865),
    [sym_null] = ACTIONS(2865),
    [sym_undefined] = ACTIONS(2865),
    [anon_sym_AT] = ACTIONS(2867),
    [anon_sym_static] = ACTIONS(2865),
    [anon_sym_readonly] = ACTIONS(2865),
    [anon_sym_get] = ACTIONS(2865),
    [anon_sym_set] = ACTIONS(2865),
    [anon_sym_declare] = ACTIONS(2865),
    [anon_sym_public] = ACTIONS(2865),
    [anon_sym_private] = ACTIONS(2865),
    [anon_sym_protected] = ACTIONS(2865),
    [anon_sym_override] = ACTIONS(2865),
    [anon_sym_module] = ACTIONS(2865),
    [anon_sym_any] = ACTIONS(2865),
    [anon_sym_number] = ACTIONS(2865),
    [anon_sym_boolean] = ACTIONS(2865),
    [anon_sym_string] = ACTIONS(2865),
    [anon_sym_symbol] = ACTIONS(2865),
    [anon_sym_object] = ACTIONS(2865),
    [anon_sym_property] = ACTIONS(2865),
    [anon_sym_signal] = ACTIONS(2865),
    [anon_sym_on] = ACTIONS(2865),
    [anon_sym_required] = ACTIONS(2865),
    [anon_sym_component] = ACTIONS(2865),
    [anon_sym_abstract] = ACTIONS(2865),
    [anon_sym_interface] = ACTIONS(2865),
    [anon_sym_enum] = ACTIONS(2865),
    [sym_html_comment] = ACTIONS(5),
  },
  [852] = {
    [sym_comment] = STATE(852),
    [sym_identifier] = ACTIONS(2869),
    [anon_sym_export] = ACTIONS(2869),
    [anon_sym_default] = ACTIONS(2869),
    [anon_sym_type] = ACTIONS(2869),
    [anon_sym_namespace] = ACTIONS(2869),
    [anon_sym_LBRACE] = ACTIONS(2871),
    [anon_sym_RBRACE] = ACTIONS(2871),
    [anon_sym_typeof] = ACTIONS(2869),
    [anon_sym_import] = ACTIONS(2869),
    [anon_sym_from] = ACTIONS(2869),
    [anon_sym_with] = ACTIONS(2869),
    [anon_sym_var] = ACTIONS(2869),
    [anon_sym_let] = ACTIONS(2869),
    [anon_sym_const] = ACTIONS(2869),
    [anon_sym_BANG] = ACTIONS(2871),
    [anon_sym_else] = ACTIONS(2869),
    [anon_sym_if] = ACTIONS(2869),
    [anon_sym_switch] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2869),
    [anon_sym_LPAREN] = ACTIONS(2871),
    [anon_sym_await] = ACTIONS(2869),
    [anon_sym_of] = ACTIONS(2869),
    [anon_sym_while] = ACTIONS(2869),
    [anon_sym_do] = ACTIONS(2869),
    [anon_sym_try] = ACTIONS(2869),
    [anon_sym_break] = ACTIONS(2869),
    [anon_sym_continue] = ACTIONS(2869),
    [anon_sym_debugger] = ACTIONS(2869),
    [anon_sym_return] = ACTIONS(2869),
    [anon_sym_throw] = ACTIONS(2869),
    [anon_sym_SEMI] = ACTIONS(2871),
    [anon_sym_case] = ACTIONS(2869),
    [anon_sym_yield] = ACTIONS(2869),
    [anon_sym_LBRACK] = ACTIONS(2871),
    [anon_sym_LTtemplate_GT] = ACTIONS(2871),
    [anon_sym_DQUOTE] = ACTIONS(2871),
    [anon_sym_SQUOTE] = ACTIONS(2871),
    [anon_sym_class] = ACTIONS(2869),
    [anon_sym_async] = ACTIONS(2869),
    [anon_sym_function] = ACTIONS(2869),
    [anon_sym_new] = ACTIONS(2869),
    [anon_sym_using] = ACTIONS(2869),
    [anon_sym_PLUS] = ACTIONS(2869),
    [anon_sym_DASH] = ACTIONS(2869),
    [anon_sym_SLASH] = ACTIONS(2869),
    [anon_sym_LT] = ACTIONS(2869),
    [anon_sym_TILDE] = ACTIONS(2871),
    [anon_sym_void] = ACTIONS(2869),
    [anon_sym_delete] = ACTIONS(2869),
    [anon_sym_PLUS_PLUS] = ACTIONS(2871),
    [anon_sym_DASH_DASH] = ACTIONS(2871),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2871),
    [sym_number] = ACTIONS(2871),
    [sym_private_property_identifier] = ACTIONS(2871),
    [sym_this] = ACTIONS(2869),
    [sym_super] = ACTIONS(2869),
    [sym_true] = ACTIONS(2869),
    [sym_false] = ACTIONS(2869),
    [sym_null] = ACTIONS(2869),
    [sym_undefined] = ACTIONS(2869),
    [anon_sym_AT] = ACTIONS(2871),
    [anon_sym_static] = ACTIONS(2869),
    [anon_sym_readonly] = ACTIONS(2869),
    [anon_sym_get] = ACTIONS(2869),
    [anon_sym_set] = ACTIONS(2869),
    [anon_sym_declare] = ACTIONS(2869),
    [anon_sym_public] = ACTIONS(2869),
    [anon_sym_private] = ACTIONS(2869),
    [anon_sym_protected] = ACTIONS(2869),
    [anon_sym_override] = ACTIONS(2869),
    [anon_sym_module] = ACTIONS(2869),
    [anon_sym_any] = ACTIONS(2869),
    [anon_sym_number] = ACTIONS(2869),
    [anon_sym_boolean] = ACTIONS(2869),
    [anon_sym_string] = ACTIONS(2869),
    [anon_sym_symbol] = ACTIONS(2869),
    [anon_sym_object] = ACTIONS(2869),
    [anon_sym_property] = ACTIONS(2869),
    [anon_sym_signal] = ACTIONS(2869),
    [anon_sym_on] = ACTIONS(2869),
    [anon_sym_required] = ACTIONS(2869),
    [anon_sym_component] = ACTIONS(2869),
    [anon_sym_abstract] = ACTIONS(2869),
    [anon_sym_interface] = ACTIONS(2869),
    [anon_sym_enum] = ACTIONS(2869),
    [sym_html_comment] = ACTIONS(5),
  },
  [853] = {
    [sym_comment] = STATE(853),
    [sym_identifier] = ACTIONS(2873),
    [anon_sym_export] = ACTIONS(2873),
    [anon_sym_default] = ACTIONS(2873),
    [anon_sym_type] = ACTIONS(2873),
    [anon_sym_namespace] = ACTIONS(2873),
    [anon_sym_LBRACE] = ACTIONS(2875),
    [anon_sym_RBRACE] = ACTIONS(2875),
    [anon_sym_typeof] = ACTIONS(2873),
    [anon_sym_import] = ACTIONS(2873),
    [anon_sym_from] = ACTIONS(2873),
    [anon_sym_with] = ACTIONS(2873),
    [anon_sym_var] = ACTIONS(2873),
    [anon_sym_let] = ACTIONS(2873),
    [anon_sym_const] = ACTIONS(2873),
    [anon_sym_BANG] = ACTIONS(2875),
    [anon_sym_else] = ACTIONS(2873),
    [anon_sym_if] = ACTIONS(2873),
    [anon_sym_switch] = ACTIONS(2873),
    [anon_sym_for] = ACTIONS(2873),
    [anon_sym_LPAREN] = ACTIONS(2875),
    [anon_sym_await] = ACTIONS(2873),
    [anon_sym_of] = ACTIONS(2873),
    [anon_sym_while] = ACTIONS(2873),
    [anon_sym_do] = ACTIONS(2873),
    [anon_sym_try] = ACTIONS(2873),
    [anon_sym_break] = ACTIONS(2873),
    [anon_sym_continue] = ACTIONS(2873),
    [anon_sym_debugger] = ACTIONS(2873),
    [anon_sym_return] = ACTIONS(2873),
    [anon_sym_throw] = ACTIONS(2873),
    [anon_sym_SEMI] = ACTIONS(2875),
    [anon_sym_case] = ACTIONS(2873),
    [anon_sym_yield] = ACTIONS(2873),
    [anon_sym_LBRACK] = ACTIONS(2875),
    [anon_sym_LTtemplate_GT] = ACTIONS(2875),
    [anon_sym_DQUOTE] = ACTIONS(2875),
    [anon_sym_SQUOTE] = ACTIONS(2875),
    [anon_sym_class] = ACTIONS(2873),
    [anon_sym_async] = ACTIONS(2873),
    [anon_sym_function] = ACTIONS(2873),
    [anon_sym_new] = ACTIONS(2873),
    [anon_sym_using] = ACTIONS(2873),
    [anon_sym_PLUS] = ACTIONS(2873),
    [anon_sym_DASH] = ACTIONS(2873),
    [anon_sym_SLASH] = ACTIONS(2873),
    [anon_sym_LT] = ACTIONS(2873),
    [anon_sym_TILDE] = ACTIONS(2875),
    [anon_sym_void] = ACTIONS(2873),
    [anon_sym_delete] = ACTIONS(2873),
    [anon_sym_PLUS_PLUS] = ACTIONS(2875),
    [anon_sym_DASH_DASH] = ACTIONS(2875),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2875),
    [sym_number] = ACTIONS(2875),
    [sym_private_property_identifier] = ACTIONS(2875),
    [sym_this] = ACTIONS(2873),
    [sym_super] = ACTIONS(2873),
    [sym_true] = ACTIONS(2873),
    [sym_false] = ACTIONS(2873),
    [sym_null] = ACTIONS(2873),
    [sym_undefined] = ACTIONS(2873),
    [anon_sym_AT] = ACTIONS(2875),
    [anon_sym_static] = ACTIONS(2873),
    [anon_sym_readonly] = ACTIONS(2873),
    [anon_sym_get] = ACTIONS(2873),
    [anon_sym_set] = ACTIONS(2873),
    [anon_sym_declare] = ACTIONS(2873),
    [anon_sym_public] = ACTIONS(2873),
    [anon_sym_private] = ACTIONS(2873),
    [anon_sym_protected] = ACTIONS(2873),
    [anon_sym_override] = ACTIONS(2873),
    [anon_sym_module] = ACTIONS(2873),
    [anon_sym_any] = ACTIONS(2873),
    [anon_sym_number] = ACTIONS(2873),
    [anon_sym_boolean] = ACTIONS(2873),
    [anon_sym_string] = ACTIONS(2873),
    [anon_sym_symbol] = ACTIONS(2873),
    [anon_sym_object] = ACTIONS(2873),
    [anon_sym_property] = ACTIONS(2873),
    [anon_sym_signal] = ACTIONS(2873),
    [anon_sym_on] = ACTIONS(2873),
    [anon_sym_required] = ACTIONS(2873),
    [anon_sym_component] = ACTIONS(2873),
    [anon_sym_abstract] = ACTIONS(2873),
    [anon_sym_interface] = ACTIONS(2873),
    [anon_sym_enum] = ACTIONS(2873),
    [sym_html_comment] = ACTIONS(5),
  },
  [854] = {
    [sym_comment] = STATE(854),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_export] = ACTIONS(2833),
    [anon_sym_default] = ACTIONS(2833),
    [anon_sym_type] = ACTIONS(2833),
    [anon_sym_namespace] = ACTIONS(2833),
    [anon_sym_LBRACE] = ACTIONS(2835),
    [anon_sym_RBRACE] = ACTIONS(2835),
    [anon_sym_typeof] = ACTIONS(2833),
    [anon_sym_import] = ACTIONS(2833),
    [anon_sym_from] = ACTIONS(2833),
    [anon_sym_with] = ACTIONS(2833),
    [anon_sym_var] = ACTIONS(2833),
    [anon_sym_let] = ACTIONS(2833),
    [anon_sym_const] = ACTIONS(2833),
    [anon_sym_BANG] = ACTIONS(2835),
    [anon_sym_else] = ACTIONS(2833),
    [anon_sym_if] = ACTIONS(2833),
    [anon_sym_switch] = ACTIONS(2833),
    [anon_sym_for] = ACTIONS(2833),
    [anon_sym_LPAREN] = ACTIONS(2835),
    [anon_sym_await] = ACTIONS(2833),
    [anon_sym_of] = ACTIONS(2833),
    [anon_sym_while] = ACTIONS(2833),
    [anon_sym_do] = ACTIONS(2833),
    [anon_sym_try] = ACTIONS(2833),
    [anon_sym_break] = ACTIONS(2833),
    [anon_sym_continue] = ACTIONS(2833),
    [anon_sym_debugger] = ACTIONS(2833),
    [anon_sym_return] = ACTIONS(2833),
    [anon_sym_throw] = ACTIONS(2833),
    [anon_sym_SEMI] = ACTIONS(2835),
    [anon_sym_case] = ACTIONS(2833),
    [anon_sym_yield] = ACTIONS(2833),
    [anon_sym_LBRACK] = ACTIONS(2835),
    [anon_sym_LTtemplate_GT] = ACTIONS(2835),
    [anon_sym_DQUOTE] = ACTIONS(2835),
    [anon_sym_SQUOTE] = ACTIONS(2835),
    [anon_sym_class] = ACTIONS(2833),
    [anon_sym_async] = ACTIONS(2833),
    [anon_sym_function] = ACTIONS(2833),
    [anon_sym_new] = ACTIONS(2833),
    [anon_sym_using] = ACTIONS(2833),
    [anon_sym_PLUS] = ACTIONS(2833),
    [anon_sym_DASH] = ACTIONS(2833),
    [anon_sym_SLASH] = ACTIONS(2833),
    [anon_sym_LT] = ACTIONS(2833),
    [anon_sym_TILDE] = ACTIONS(2835),
    [anon_sym_void] = ACTIONS(2833),
    [anon_sym_delete] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2835),
    [anon_sym_DASH_DASH] = ACTIONS(2835),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2835),
    [sym_number] = ACTIONS(2835),
    [sym_private_property_identifier] = ACTIONS(2835),
    [sym_this] = ACTIONS(2833),
    [sym_super] = ACTIONS(2833),
    [sym_true] = ACTIONS(2833),
    [sym_false] = ACTIONS(2833),
    [sym_null] = ACTIONS(2833),
    [sym_undefined] = ACTIONS(2833),
    [anon_sym_AT] = ACTIONS(2835),
    [anon_sym_static] = ACTIONS(2833),
    [anon_sym_readonly] = ACTIONS(2833),
    [anon_sym_get] = ACTIONS(2833),
    [anon_sym_set] = ACTIONS(2833),
    [anon_sym_declare] = ACTIONS(2833),
    [anon_sym_public] = ACTIONS(2833),
    [anon_sym_private] = ACTIONS(2833),
    [anon_sym_protected] = ACTIONS(2833),
    [anon_sym_override] = ACTIONS(2833),
    [anon_sym_module] = ACTIONS(2833),
    [anon_sym_any] = ACTIONS(2833),
    [anon_sym_number] = ACTIONS(2833),
    [anon_sym_boolean] = ACTIONS(2833),
    [anon_sym_string] = ACTIONS(2833),
    [anon_sym_symbol] = ACTIONS(2833),
    [anon_sym_object] = ACTIONS(2833),
    [anon_sym_property] = ACTIONS(2833),
    [anon_sym_signal] = ACTIONS(2833),
    [anon_sym_on] = ACTIONS(2833),
    [anon_sym_required] = ACTIONS(2833),
    [anon_sym_component] = ACTIONS(2833),
    [anon_sym_abstract] = ACTIONS(2833),
    [anon_sym_interface] = ACTIONS(2833),
    [anon_sym_enum] = ACTIONS(2833),
    [sym_html_comment] = ACTIONS(5),
  },
  [855] = {
    [sym_comment] = STATE(855),
    [sym_identifier] = ACTIONS(2877),
    [anon_sym_export] = ACTIONS(2877),
    [anon_sym_default] = ACTIONS(2877),
    [anon_sym_type] = ACTIONS(2877),
    [anon_sym_namespace] = ACTIONS(2877),
    [anon_sym_LBRACE] = ACTIONS(2879),
    [anon_sym_RBRACE] = ACTIONS(2879),
    [anon_sym_typeof] = ACTIONS(2877),
    [anon_sym_import] = ACTIONS(2877),
    [anon_sym_from] = ACTIONS(2877),
    [anon_sym_with] = ACTIONS(2877),
    [anon_sym_var] = ACTIONS(2877),
    [anon_sym_let] = ACTIONS(2877),
    [anon_sym_const] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2879),
    [anon_sym_else] = ACTIONS(2877),
    [anon_sym_if] = ACTIONS(2877),
    [anon_sym_switch] = ACTIONS(2877),
    [anon_sym_for] = ACTIONS(2877),
    [anon_sym_LPAREN] = ACTIONS(2879),
    [anon_sym_await] = ACTIONS(2877),
    [anon_sym_of] = ACTIONS(2877),
    [anon_sym_while] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_try] = ACTIONS(2877),
    [anon_sym_break] = ACTIONS(2877),
    [anon_sym_continue] = ACTIONS(2877),
    [anon_sym_debugger] = ACTIONS(2877),
    [anon_sym_return] = ACTIONS(2877),
    [anon_sym_throw] = ACTIONS(2877),
    [anon_sym_SEMI] = ACTIONS(2879),
    [anon_sym_case] = ACTIONS(2877),
    [anon_sym_yield] = ACTIONS(2877),
    [anon_sym_LBRACK] = ACTIONS(2879),
    [anon_sym_LTtemplate_GT] = ACTIONS(2879),
    [anon_sym_DQUOTE] = ACTIONS(2879),
    [anon_sym_SQUOTE] = ACTIONS(2879),
    [anon_sym_class] = ACTIONS(2877),
    [anon_sym_async] = ACTIONS(2877),
    [anon_sym_function] = ACTIONS(2877),
    [anon_sym_new] = ACTIONS(2877),
    [anon_sym_using] = ACTIONS(2877),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_SLASH] = ACTIONS(2877),
    [anon_sym_LT] = ACTIONS(2877),
    [anon_sym_TILDE] = ACTIONS(2879),
    [anon_sym_void] = ACTIONS(2877),
    [anon_sym_delete] = ACTIONS(2877),
    [anon_sym_PLUS_PLUS] = ACTIONS(2879),
    [anon_sym_DASH_DASH] = ACTIONS(2879),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2879),
    [sym_number] = ACTIONS(2879),
    [sym_private_property_identifier] = ACTIONS(2879),
    [sym_this] = ACTIONS(2877),
    [sym_super] = ACTIONS(2877),
    [sym_true] = ACTIONS(2877),
    [sym_false] = ACTIONS(2877),
    [sym_null] = ACTIONS(2877),
    [sym_undefined] = ACTIONS(2877),
    [anon_sym_AT] = ACTIONS(2879),
    [anon_sym_static] = ACTIONS(2877),
    [anon_sym_readonly] = ACTIONS(2877),
    [anon_sym_get] = ACTIONS(2877),
    [anon_sym_set] = ACTIONS(2877),
    [anon_sym_declare] = ACTIONS(2877),
    [anon_sym_public] = ACTIONS(2877),
    [anon_sym_private] = ACTIONS(2877),
    [anon_sym_protected] = ACTIONS(2877),
    [anon_sym_override] = ACTIONS(2877),
    [anon_sym_module] = ACTIONS(2877),
    [anon_sym_any] = ACTIONS(2877),
    [anon_sym_number] = ACTIONS(2877),
    [anon_sym_boolean] = ACTIONS(2877),
    [anon_sym_string] = ACTIONS(2877),
    [anon_sym_symbol] = ACTIONS(2877),
    [anon_sym_object] = ACTIONS(2877),
    [anon_sym_property] = ACTIONS(2877),
    [anon_sym_signal] = ACTIONS(2877),
    [anon_sym_on] = ACTIONS(2877),
    [anon_sym_required] = ACTIONS(2877),
    [anon_sym_component] = ACTIONS(2877),
    [anon_sym_abstract] = ACTIONS(2877),
    [anon_sym_interface] = ACTIONS(2877),
    [anon_sym_enum] = ACTIONS(2877),
    [sym_html_comment] = ACTIONS(5),
  },
  [856] = {
    [sym_comment] = STATE(856),
    [sym_identifier] = ACTIONS(2653),
    [anon_sym_export] = ACTIONS(2653),
    [anon_sym_default] = ACTIONS(2653),
    [anon_sym_type] = ACTIONS(2653),
    [anon_sym_namespace] = ACTIONS(2653),
    [anon_sym_LBRACE] = ACTIONS(2655),
    [anon_sym_RBRACE] = ACTIONS(2655),
    [anon_sym_typeof] = ACTIONS(2653),
    [anon_sym_import] = ACTIONS(2653),
    [anon_sym_from] = ACTIONS(2653),
    [anon_sym_with] = ACTIONS(2653),
    [anon_sym_var] = ACTIONS(2653),
    [anon_sym_let] = ACTIONS(2653),
    [anon_sym_const] = ACTIONS(2653),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_else] = ACTIONS(2653),
    [anon_sym_if] = ACTIONS(2653),
    [anon_sym_switch] = ACTIONS(2653),
    [anon_sym_for] = ACTIONS(2653),
    [anon_sym_LPAREN] = ACTIONS(2655),
    [anon_sym_await] = ACTIONS(2653),
    [anon_sym_of] = ACTIONS(2653),
    [anon_sym_while] = ACTIONS(2653),
    [anon_sym_do] = ACTIONS(2653),
    [anon_sym_try] = ACTIONS(2653),
    [anon_sym_break] = ACTIONS(2653),
    [anon_sym_continue] = ACTIONS(2653),
    [anon_sym_debugger] = ACTIONS(2653),
    [anon_sym_return] = ACTIONS(2653),
    [anon_sym_throw] = ACTIONS(2653),
    [anon_sym_SEMI] = ACTIONS(2655),
    [anon_sym_case] = ACTIONS(2653),
    [anon_sym_yield] = ACTIONS(2653),
    [anon_sym_LBRACK] = ACTIONS(2655),
    [anon_sym_LTtemplate_GT] = ACTIONS(2655),
    [anon_sym_DQUOTE] = ACTIONS(2655),
    [anon_sym_SQUOTE] = ACTIONS(2655),
    [anon_sym_class] = ACTIONS(2653),
    [anon_sym_async] = ACTIONS(2653),
    [anon_sym_function] = ACTIONS(2653),
    [anon_sym_new] = ACTIONS(2653),
    [anon_sym_using] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_SLASH] = ACTIONS(2653),
    [anon_sym_LT] = ACTIONS(2653),
    [anon_sym_TILDE] = ACTIONS(2655),
    [anon_sym_void] = ACTIONS(2653),
    [anon_sym_delete] = ACTIONS(2653),
    [anon_sym_PLUS_PLUS] = ACTIONS(2655),
    [anon_sym_DASH_DASH] = ACTIONS(2655),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2655),
    [sym_number] = ACTIONS(2655),
    [sym_private_property_identifier] = ACTIONS(2655),
    [sym_this] = ACTIONS(2653),
    [sym_super] = ACTIONS(2653),
    [sym_true] = ACTIONS(2653),
    [sym_false] = ACTIONS(2653),
    [sym_null] = ACTIONS(2653),
    [sym_undefined] = ACTIONS(2653),
    [anon_sym_AT] = ACTIONS(2655),
    [anon_sym_static] = ACTIONS(2653),
    [anon_sym_readonly] = ACTIONS(2653),
    [anon_sym_get] = ACTIONS(2653),
    [anon_sym_set] = ACTIONS(2653),
    [anon_sym_declare] = ACTIONS(2653),
    [anon_sym_public] = ACTIONS(2653),
    [anon_sym_private] = ACTIONS(2653),
    [anon_sym_protected] = ACTIONS(2653),
    [anon_sym_override] = ACTIONS(2653),
    [anon_sym_module] = ACTIONS(2653),
    [anon_sym_any] = ACTIONS(2653),
    [anon_sym_number] = ACTIONS(2653),
    [anon_sym_boolean] = ACTIONS(2653),
    [anon_sym_string] = ACTIONS(2653),
    [anon_sym_symbol] = ACTIONS(2653),
    [anon_sym_object] = ACTIONS(2653),
    [anon_sym_property] = ACTIONS(2653),
    [anon_sym_signal] = ACTIONS(2653),
    [anon_sym_on] = ACTIONS(2653),
    [anon_sym_required] = ACTIONS(2653),
    [anon_sym_component] = ACTIONS(2653),
    [anon_sym_abstract] = ACTIONS(2653),
    [anon_sym_interface] = ACTIONS(2653),
    [anon_sym_enum] = ACTIONS(2653),
    [sym_html_comment] = ACTIONS(5),
  },
  [857] = {
    [sym_comment] = STATE(857),
    [sym_identifier] = ACTIONS(2881),
    [anon_sym_export] = ACTIONS(2881),
    [anon_sym_default] = ACTIONS(2881),
    [anon_sym_type] = ACTIONS(2881),
    [anon_sym_namespace] = ACTIONS(2881),
    [anon_sym_LBRACE] = ACTIONS(2883),
    [anon_sym_RBRACE] = ACTIONS(2883),
    [anon_sym_typeof] = ACTIONS(2881),
    [anon_sym_import] = ACTIONS(2881),
    [anon_sym_from] = ACTIONS(2881),
    [anon_sym_with] = ACTIONS(2881),
    [anon_sym_var] = ACTIONS(2881),
    [anon_sym_let] = ACTIONS(2881),
    [anon_sym_const] = ACTIONS(2881),
    [anon_sym_BANG] = ACTIONS(2883),
    [anon_sym_else] = ACTIONS(2881),
    [anon_sym_if] = ACTIONS(2881),
    [anon_sym_switch] = ACTIONS(2881),
    [anon_sym_for] = ACTIONS(2881),
    [anon_sym_LPAREN] = ACTIONS(2883),
    [anon_sym_await] = ACTIONS(2881),
    [anon_sym_of] = ACTIONS(2881),
    [anon_sym_while] = ACTIONS(2881),
    [anon_sym_do] = ACTIONS(2881),
    [anon_sym_try] = ACTIONS(2881),
    [anon_sym_break] = ACTIONS(2881),
    [anon_sym_continue] = ACTIONS(2881),
    [anon_sym_debugger] = ACTIONS(2881),
    [anon_sym_return] = ACTIONS(2881),
    [anon_sym_throw] = ACTIONS(2881),
    [anon_sym_SEMI] = ACTIONS(2883),
    [anon_sym_case] = ACTIONS(2881),
    [anon_sym_yield] = ACTIONS(2881),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_LTtemplate_GT] = ACTIONS(2883),
    [anon_sym_DQUOTE] = ACTIONS(2883),
    [anon_sym_SQUOTE] = ACTIONS(2883),
    [anon_sym_class] = ACTIONS(2881),
    [anon_sym_async] = ACTIONS(2881),
    [anon_sym_function] = ACTIONS(2881),
    [anon_sym_new] = ACTIONS(2881),
    [anon_sym_using] = ACTIONS(2881),
    [anon_sym_PLUS] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2881),
    [anon_sym_SLASH] = ACTIONS(2881),
    [anon_sym_LT] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2883),
    [anon_sym_void] = ACTIONS(2881),
    [anon_sym_delete] = ACTIONS(2881),
    [anon_sym_PLUS_PLUS] = ACTIONS(2883),
    [anon_sym_DASH_DASH] = ACTIONS(2883),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2883),
    [sym_number] = ACTIONS(2883),
    [sym_private_property_identifier] = ACTIONS(2883),
    [sym_this] = ACTIONS(2881),
    [sym_super] = ACTIONS(2881),
    [sym_true] = ACTIONS(2881),
    [sym_false] = ACTIONS(2881),
    [sym_null] = ACTIONS(2881),
    [sym_undefined] = ACTIONS(2881),
    [anon_sym_AT] = ACTIONS(2883),
    [anon_sym_static] = ACTIONS(2881),
    [anon_sym_readonly] = ACTIONS(2881),
    [anon_sym_get] = ACTIONS(2881),
    [anon_sym_set] = ACTIONS(2881),
    [anon_sym_declare] = ACTIONS(2881),
    [anon_sym_public] = ACTIONS(2881),
    [anon_sym_private] = ACTIONS(2881),
    [anon_sym_protected] = ACTIONS(2881),
    [anon_sym_override] = ACTIONS(2881),
    [anon_sym_module] = ACTIONS(2881),
    [anon_sym_any] = ACTIONS(2881),
    [anon_sym_number] = ACTIONS(2881),
    [anon_sym_boolean] = ACTIONS(2881),
    [anon_sym_string] = ACTIONS(2881),
    [anon_sym_symbol] = ACTIONS(2881),
    [anon_sym_object] = ACTIONS(2881),
    [anon_sym_property] = ACTIONS(2881),
    [anon_sym_signal] = ACTIONS(2881),
    [anon_sym_on] = ACTIONS(2881),
    [anon_sym_required] = ACTIONS(2881),
    [anon_sym_component] = ACTIONS(2881),
    [anon_sym_abstract] = ACTIONS(2881),
    [anon_sym_interface] = ACTIONS(2881),
    [anon_sym_enum] = ACTIONS(2881),
    [sym_html_comment] = ACTIONS(5),
  },
  [858] = {
    [sym_comment] = STATE(858),
    [sym_identifier] = ACTIONS(2885),
    [anon_sym_export] = ACTIONS(2885),
    [anon_sym_default] = ACTIONS(2885),
    [anon_sym_type] = ACTIONS(2885),
    [anon_sym_namespace] = ACTIONS(2885),
    [anon_sym_LBRACE] = ACTIONS(2887),
    [anon_sym_RBRACE] = ACTIONS(2887),
    [anon_sym_typeof] = ACTIONS(2885),
    [anon_sym_import] = ACTIONS(2885),
    [anon_sym_from] = ACTIONS(2885),
    [anon_sym_with] = ACTIONS(2885),
    [anon_sym_var] = ACTIONS(2885),
    [anon_sym_let] = ACTIONS(2885),
    [anon_sym_const] = ACTIONS(2885),
    [anon_sym_BANG] = ACTIONS(2887),
    [anon_sym_else] = ACTIONS(2885),
    [anon_sym_if] = ACTIONS(2885),
    [anon_sym_switch] = ACTIONS(2885),
    [anon_sym_for] = ACTIONS(2885),
    [anon_sym_LPAREN] = ACTIONS(2887),
    [anon_sym_await] = ACTIONS(2885),
    [anon_sym_of] = ACTIONS(2885),
    [anon_sym_while] = ACTIONS(2885),
    [anon_sym_do] = ACTIONS(2885),
    [anon_sym_try] = ACTIONS(2885),
    [anon_sym_break] = ACTIONS(2885),
    [anon_sym_continue] = ACTIONS(2885),
    [anon_sym_debugger] = ACTIONS(2885),
    [anon_sym_return] = ACTIONS(2885),
    [anon_sym_throw] = ACTIONS(2885),
    [anon_sym_SEMI] = ACTIONS(2887),
    [anon_sym_case] = ACTIONS(2885),
    [anon_sym_yield] = ACTIONS(2885),
    [anon_sym_LBRACK] = ACTIONS(2887),
    [anon_sym_LTtemplate_GT] = ACTIONS(2887),
    [anon_sym_DQUOTE] = ACTIONS(2887),
    [anon_sym_SQUOTE] = ACTIONS(2887),
    [anon_sym_class] = ACTIONS(2885),
    [anon_sym_async] = ACTIONS(2885),
    [anon_sym_function] = ACTIONS(2885),
    [anon_sym_new] = ACTIONS(2885),
    [anon_sym_using] = ACTIONS(2885),
    [anon_sym_PLUS] = ACTIONS(2885),
    [anon_sym_DASH] = ACTIONS(2885),
    [anon_sym_SLASH] = ACTIONS(2885),
    [anon_sym_LT] = ACTIONS(2885),
    [anon_sym_TILDE] = ACTIONS(2887),
    [anon_sym_void] = ACTIONS(2885),
    [anon_sym_delete] = ACTIONS(2885),
    [anon_sym_PLUS_PLUS] = ACTIONS(2887),
    [anon_sym_DASH_DASH] = ACTIONS(2887),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2887),
    [sym_number] = ACTIONS(2887),
    [sym_private_property_identifier] = ACTIONS(2887),
    [sym_this] = ACTIONS(2885),
    [sym_super] = ACTIONS(2885),
    [sym_true] = ACTIONS(2885),
    [sym_false] = ACTIONS(2885),
    [sym_null] = ACTIONS(2885),
    [sym_undefined] = ACTIONS(2885),
    [anon_sym_AT] = ACTIONS(2887),
    [anon_sym_static] = ACTIONS(2885),
    [anon_sym_readonly] = ACTIONS(2885),
    [anon_sym_get] = ACTIONS(2885),
    [anon_sym_set] = ACTIONS(2885),
    [anon_sym_declare] = ACTIONS(2885),
    [anon_sym_public] = ACTIONS(2885),
    [anon_sym_private] = ACTIONS(2885),
    [anon_sym_protected] = ACTIONS(2885),
    [anon_sym_override] = ACTIONS(2885),
    [anon_sym_module] = ACTIONS(2885),
    [anon_sym_any] = ACTIONS(2885),
    [anon_sym_number] = ACTIONS(2885),
    [anon_sym_boolean] = ACTIONS(2885),
    [anon_sym_string] = ACTIONS(2885),
    [anon_sym_symbol] = ACTIONS(2885),
    [anon_sym_object] = ACTIONS(2885),
    [anon_sym_property] = ACTIONS(2885),
    [anon_sym_signal] = ACTIONS(2885),
    [anon_sym_on] = ACTIONS(2885),
    [anon_sym_required] = ACTIONS(2885),
    [anon_sym_component] = ACTIONS(2885),
    [anon_sym_abstract] = ACTIONS(2885),
    [anon_sym_interface] = ACTIONS(2885),
    [anon_sym_enum] = ACTIONS(2885),
    [sym_html_comment] = ACTIONS(5),
  },
  [859] = {
    [sym_comment] = STATE(859),
    [sym_identifier] = ACTIONS(2889),
    [anon_sym_export] = ACTIONS(2889),
    [anon_sym_default] = ACTIONS(2889),
    [anon_sym_type] = ACTIONS(2889),
    [anon_sym_namespace] = ACTIONS(2889),
    [anon_sym_LBRACE] = ACTIONS(2891),
    [anon_sym_RBRACE] = ACTIONS(2891),
    [anon_sym_typeof] = ACTIONS(2889),
    [anon_sym_import] = ACTIONS(2889),
    [anon_sym_from] = ACTIONS(2889),
    [anon_sym_with] = ACTIONS(2889),
    [anon_sym_var] = ACTIONS(2889),
    [anon_sym_let] = ACTIONS(2889),
    [anon_sym_const] = ACTIONS(2889),
    [anon_sym_BANG] = ACTIONS(2891),
    [anon_sym_else] = ACTIONS(2889),
    [anon_sym_if] = ACTIONS(2889),
    [anon_sym_switch] = ACTIONS(2889),
    [anon_sym_for] = ACTIONS(2889),
    [anon_sym_LPAREN] = ACTIONS(2891),
    [anon_sym_await] = ACTIONS(2889),
    [anon_sym_of] = ACTIONS(2889),
    [anon_sym_while] = ACTIONS(2889),
    [anon_sym_do] = ACTIONS(2889),
    [anon_sym_try] = ACTIONS(2889),
    [anon_sym_break] = ACTIONS(2889),
    [anon_sym_continue] = ACTIONS(2889),
    [anon_sym_debugger] = ACTIONS(2889),
    [anon_sym_return] = ACTIONS(2889),
    [anon_sym_throw] = ACTIONS(2889),
    [anon_sym_SEMI] = ACTIONS(2891),
    [anon_sym_case] = ACTIONS(2889),
    [anon_sym_yield] = ACTIONS(2889),
    [anon_sym_LBRACK] = ACTIONS(2891),
    [anon_sym_LTtemplate_GT] = ACTIONS(2891),
    [anon_sym_DQUOTE] = ACTIONS(2891),
    [anon_sym_SQUOTE] = ACTIONS(2891),
    [anon_sym_class] = ACTIONS(2889),
    [anon_sym_async] = ACTIONS(2889),
    [anon_sym_function] = ACTIONS(2889),
    [anon_sym_new] = ACTIONS(2889),
    [anon_sym_using] = ACTIONS(2889),
    [anon_sym_PLUS] = ACTIONS(2889),
    [anon_sym_DASH] = ACTIONS(2889),
    [anon_sym_SLASH] = ACTIONS(2889),
    [anon_sym_LT] = ACTIONS(2889),
    [anon_sym_TILDE] = ACTIONS(2891),
    [anon_sym_void] = ACTIONS(2889),
    [anon_sym_delete] = ACTIONS(2889),
    [anon_sym_PLUS_PLUS] = ACTIONS(2891),
    [anon_sym_DASH_DASH] = ACTIONS(2891),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2891),
    [sym_number] = ACTIONS(2891),
    [sym_private_property_identifier] = ACTIONS(2891),
    [sym_this] = ACTIONS(2889),
    [sym_super] = ACTIONS(2889),
    [sym_true] = ACTIONS(2889),
    [sym_false] = ACTIONS(2889),
    [sym_null] = ACTIONS(2889),
    [sym_undefined] = ACTIONS(2889),
    [anon_sym_AT] = ACTIONS(2891),
    [anon_sym_static] = ACTIONS(2889),
    [anon_sym_readonly] = ACTIONS(2889),
    [anon_sym_get] = ACTIONS(2889),
    [anon_sym_set] = ACTIONS(2889),
    [anon_sym_declare] = ACTIONS(2889),
    [anon_sym_public] = ACTIONS(2889),
    [anon_sym_private] = ACTIONS(2889),
    [anon_sym_protected] = ACTIONS(2889),
    [anon_sym_override] = ACTIONS(2889),
    [anon_sym_module] = ACTIONS(2889),
    [anon_sym_any] = ACTIONS(2889),
    [anon_sym_number] = ACTIONS(2889),
    [anon_sym_boolean] = ACTIONS(2889),
    [anon_sym_string] = ACTIONS(2889),
    [anon_sym_symbol] = ACTIONS(2889),
    [anon_sym_object] = ACTIONS(2889),
    [anon_sym_property] = ACTIONS(2889),
    [anon_sym_signal] = ACTIONS(2889),
    [anon_sym_on] = ACTIONS(2889),
    [anon_sym_required] = ACTIONS(2889),
    [anon_sym_component] = ACTIONS(2889),
    [anon_sym_abstract] = ACTIONS(2889),
    [anon_sym_interface] = ACTIONS(2889),
    [anon_sym_enum] = ACTIONS(2889),
    [sym_html_comment] = ACTIONS(5),
  },
  [860] = {
    [sym_comment] = STATE(860),
    [sym_identifier] = ACTIONS(2893),
    [anon_sym_export] = ACTIONS(2893),
    [anon_sym_default] = ACTIONS(2893),
    [anon_sym_type] = ACTIONS(2893),
    [anon_sym_namespace] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_RBRACE] = ACTIONS(2895),
    [anon_sym_typeof] = ACTIONS(2893),
    [anon_sym_import] = ACTIONS(2893),
    [anon_sym_from] = ACTIONS(2893),
    [anon_sym_with] = ACTIONS(2893),
    [anon_sym_var] = ACTIONS(2893),
    [anon_sym_let] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_BANG] = ACTIONS(2895),
    [anon_sym_else] = ACTIONS(2893),
    [anon_sym_if] = ACTIONS(2893),
    [anon_sym_switch] = ACTIONS(2893),
    [anon_sym_for] = ACTIONS(2893),
    [anon_sym_LPAREN] = ACTIONS(2895),
    [anon_sym_await] = ACTIONS(2893),
    [anon_sym_of] = ACTIONS(2893),
    [anon_sym_while] = ACTIONS(2893),
    [anon_sym_do] = ACTIONS(2893),
    [anon_sym_try] = ACTIONS(2893),
    [anon_sym_break] = ACTIONS(2893),
    [anon_sym_continue] = ACTIONS(2893),
    [anon_sym_debugger] = ACTIONS(2893),
    [anon_sym_return] = ACTIONS(2893),
    [anon_sym_throw] = ACTIONS(2893),
    [anon_sym_SEMI] = ACTIONS(2895),
    [anon_sym_case] = ACTIONS(2893),
    [anon_sym_yield] = ACTIONS(2893),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_LTtemplate_GT] = ACTIONS(2895),
    [anon_sym_DQUOTE] = ACTIONS(2895),
    [anon_sym_SQUOTE] = ACTIONS(2895),
    [anon_sym_class] = ACTIONS(2893),
    [anon_sym_async] = ACTIONS(2893),
    [anon_sym_function] = ACTIONS(2893),
    [anon_sym_new] = ACTIONS(2893),
    [anon_sym_using] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2893),
    [anon_sym_DASH] = ACTIONS(2893),
    [anon_sym_SLASH] = ACTIONS(2893),
    [anon_sym_LT] = ACTIONS(2893),
    [anon_sym_TILDE] = ACTIONS(2895),
    [anon_sym_void] = ACTIONS(2893),
    [anon_sym_delete] = ACTIONS(2893),
    [anon_sym_PLUS_PLUS] = ACTIONS(2895),
    [anon_sym_DASH_DASH] = ACTIONS(2895),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2895),
    [sym_number] = ACTIONS(2895),
    [sym_private_property_identifier] = ACTIONS(2895),
    [sym_this] = ACTIONS(2893),
    [sym_super] = ACTIONS(2893),
    [sym_true] = ACTIONS(2893),
    [sym_false] = ACTIONS(2893),
    [sym_null] = ACTIONS(2893),
    [sym_undefined] = ACTIONS(2893),
    [anon_sym_AT] = ACTIONS(2895),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_readonly] = ACTIONS(2893),
    [anon_sym_get] = ACTIONS(2893),
    [anon_sym_set] = ACTIONS(2893),
    [anon_sym_declare] = ACTIONS(2893),
    [anon_sym_public] = ACTIONS(2893),
    [anon_sym_private] = ACTIONS(2893),
    [anon_sym_protected] = ACTIONS(2893),
    [anon_sym_override] = ACTIONS(2893),
    [anon_sym_module] = ACTIONS(2893),
    [anon_sym_any] = ACTIONS(2893),
    [anon_sym_number] = ACTIONS(2893),
    [anon_sym_boolean] = ACTIONS(2893),
    [anon_sym_string] = ACTIONS(2893),
    [anon_sym_symbol] = ACTIONS(2893),
    [anon_sym_object] = ACTIONS(2893),
    [anon_sym_property] = ACTIONS(2893),
    [anon_sym_signal] = ACTIONS(2893),
    [anon_sym_on] = ACTIONS(2893),
    [anon_sym_required] = ACTIONS(2893),
    [anon_sym_component] = ACTIONS(2893),
    [anon_sym_abstract] = ACTIONS(2893),
    [anon_sym_interface] = ACTIONS(2893),
    [anon_sym_enum] = ACTIONS(2893),
    [sym_html_comment] = ACTIONS(5),
  },
  [861] = {
    [sym_comment] = STATE(861),
    [sym_identifier] = ACTIONS(2897),
    [anon_sym_export] = ACTIONS(2897),
    [anon_sym_default] = ACTIONS(2897),
    [anon_sym_type] = ACTIONS(2897),
    [anon_sym_namespace] = ACTIONS(2897),
    [anon_sym_LBRACE] = ACTIONS(2899),
    [anon_sym_RBRACE] = ACTIONS(2899),
    [anon_sym_typeof] = ACTIONS(2897),
    [anon_sym_import] = ACTIONS(2897),
    [anon_sym_from] = ACTIONS(2897),
    [anon_sym_with] = ACTIONS(2897),
    [anon_sym_var] = ACTIONS(2897),
    [anon_sym_let] = ACTIONS(2897),
    [anon_sym_const] = ACTIONS(2897),
    [anon_sym_BANG] = ACTIONS(2899),
    [anon_sym_else] = ACTIONS(2897),
    [anon_sym_if] = ACTIONS(2897),
    [anon_sym_switch] = ACTIONS(2897),
    [anon_sym_for] = ACTIONS(2897),
    [anon_sym_LPAREN] = ACTIONS(2899),
    [anon_sym_await] = ACTIONS(2897),
    [anon_sym_of] = ACTIONS(2897),
    [anon_sym_while] = ACTIONS(2897),
    [anon_sym_do] = ACTIONS(2897),
    [anon_sym_try] = ACTIONS(2897),
    [anon_sym_break] = ACTIONS(2897),
    [anon_sym_continue] = ACTIONS(2897),
    [anon_sym_debugger] = ACTIONS(2897),
    [anon_sym_return] = ACTIONS(2897),
    [anon_sym_throw] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_case] = ACTIONS(2897),
    [anon_sym_yield] = ACTIONS(2897),
    [anon_sym_LBRACK] = ACTIONS(2899),
    [anon_sym_LTtemplate_GT] = ACTIONS(2899),
    [anon_sym_DQUOTE] = ACTIONS(2899),
    [anon_sym_SQUOTE] = ACTIONS(2899),
    [anon_sym_class] = ACTIONS(2897),
    [anon_sym_async] = ACTIONS(2897),
    [anon_sym_function] = ACTIONS(2897),
    [anon_sym_new] = ACTIONS(2897),
    [anon_sym_using] = ACTIONS(2897),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_DASH] = ACTIONS(2897),
    [anon_sym_SLASH] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_TILDE] = ACTIONS(2899),
    [anon_sym_void] = ACTIONS(2897),
    [anon_sym_delete] = ACTIONS(2897),
    [anon_sym_PLUS_PLUS] = ACTIONS(2899),
    [anon_sym_DASH_DASH] = ACTIONS(2899),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2899),
    [sym_number] = ACTIONS(2899),
    [sym_private_property_identifier] = ACTIONS(2899),
    [sym_this] = ACTIONS(2897),
    [sym_super] = ACTIONS(2897),
    [sym_true] = ACTIONS(2897),
    [sym_false] = ACTIONS(2897),
    [sym_null] = ACTIONS(2897),
    [sym_undefined] = ACTIONS(2897),
    [anon_sym_AT] = ACTIONS(2899),
    [anon_sym_static] = ACTIONS(2897),
    [anon_sym_readonly] = ACTIONS(2897),
    [anon_sym_get] = ACTIONS(2897),
    [anon_sym_set] = ACTIONS(2897),
    [anon_sym_declare] = ACTIONS(2897),
    [anon_sym_public] = ACTIONS(2897),
    [anon_sym_private] = ACTIONS(2897),
    [anon_sym_protected] = ACTIONS(2897),
    [anon_sym_override] = ACTIONS(2897),
    [anon_sym_module] = ACTIONS(2897),
    [anon_sym_any] = ACTIONS(2897),
    [anon_sym_number] = ACTIONS(2897),
    [anon_sym_boolean] = ACTIONS(2897),
    [anon_sym_string] = ACTIONS(2897),
    [anon_sym_symbol] = ACTIONS(2897),
    [anon_sym_object] = ACTIONS(2897),
    [anon_sym_property] = ACTIONS(2897),
    [anon_sym_signal] = ACTIONS(2897),
    [anon_sym_on] = ACTIONS(2897),
    [anon_sym_required] = ACTIONS(2897),
    [anon_sym_component] = ACTIONS(2897),
    [anon_sym_abstract] = ACTIONS(2897),
    [anon_sym_interface] = ACTIONS(2897),
    [anon_sym_enum] = ACTIONS(2897),
    [sym_html_comment] = ACTIONS(5),
  },
  [862] = {
    [sym_comment] = STATE(862),
    [sym_identifier] = ACTIONS(2893),
    [anon_sym_export] = ACTIONS(2893),
    [anon_sym_default] = ACTIONS(2893),
    [anon_sym_type] = ACTIONS(2893),
    [anon_sym_namespace] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_RBRACE] = ACTIONS(2895),
    [anon_sym_typeof] = ACTIONS(2893),
    [anon_sym_import] = ACTIONS(2893),
    [anon_sym_from] = ACTIONS(2893),
    [anon_sym_with] = ACTIONS(2893),
    [anon_sym_var] = ACTIONS(2893),
    [anon_sym_let] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_BANG] = ACTIONS(2895),
    [anon_sym_else] = ACTIONS(2893),
    [anon_sym_if] = ACTIONS(2893),
    [anon_sym_switch] = ACTIONS(2893),
    [anon_sym_for] = ACTIONS(2893),
    [anon_sym_LPAREN] = ACTIONS(2895),
    [anon_sym_await] = ACTIONS(2893),
    [anon_sym_of] = ACTIONS(2893),
    [anon_sym_while] = ACTIONS(2893),
    [anon_sym_do] = ACTIONS(2893),
    [anon_sym_try] = ACTIONS(2893),
    [anon_sym_break] = ACTIONS(2893),
    [anon_sym_continue] = ACTIONS(2893),
    [anon_sym_debugger] = ACTIONS(2893),
    [anon_sym_return] = ACTIONS(2893),
    [anon_sym_throw] = ACTIONS(2893),
    [anon_sym_SEMI] = ACTIONS(2895),
    [anon_sym_case] = ACTIONS(2893),
    [anon_sym_yield] = ACTIONS(2893),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_LTtemplate_GT] = ACTIONS(2895),
    [anon_sym_DQUOTE] = ACTIONS(2895),
    [anon_sym_SQUOTE] = ACTIONS(2895),
    [anon_sym_class] = ACTIONS(2893),
    [anon_sym_async] = ACTIONS(2893),
    [anon_sym_function] = ACTIONS(2893),
    [anon_sym_new] = ACTIONS(2893),
    [anon_sym_using] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2893),
    [anon_sym_DASH] = ACTIONS(2893),
    [anon_sym_SLASH] = ACTIONS(2893),
    [anon_sym_LT] = ACTIONS(2893),
    [anon_sym_TILDE] = ACTIONS(2895),
    [anon_sym_void] = ACTIONS(2893),
    [anon_sym_delete] = ACTIONS(2893),
    [anon_sym_PLUS_PLUS] = ACTIONS(2895),
    [anon_sym_DASH_DASH] = ACTIONS(2895),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2895),
    [sym_number] = ACTIONS(2895),
    [sym_private_property_identifier] = ACTIONS(2895),
    [sym_this] = ACTIONS(2893),
    [sym_super] = ACTIONS(2893),
    [sym_true] = ACTIONS(2893),
    [sym_false] = ACTIONS(2893),
    [sym_null] = ACTIONS(2893),
    [sym_undefined] = ACTIONS(2893),
    [anon_sym_AT] = ACTIONS(2895),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_readonly] = ACTIONS(2893),
    [anon_sym_get] = ACTIONS(2893),
    [anon_sym_set] = ACTIONS(2893),
    [anon_sym_declare] = ACTIONS(2893),
    [anon_sym_public] = ACTIONS(2893),
    [anon_sym_private] = ACTIONS(2893),
    [anon_sym_protected] = ACTIONS(2893),
    [anon_sym_override] = ACTIONS(2893),
    [anon_sym_module] = ACTIONS(2893),
    [anon_sym_any] = ACTIONS(2893),
    [anon_sym_number] = ACTIONS(2893),
    [anon_sym_boolean] = ACTIONS(2893),
    [anon_sym_string] = ACTIONS(2893),
    [anon_sym_symbol] = ACTIONS(2893),
    [anon_sym_object] = ACTIONS(2893),
    [anon_sym_property] = ACTIONS(2893),
    [anon_sym_signal] = ACTIONS(2893),
    [anon_sym_on] = ACTIONS(2893),
    [anon_sym_required] = ACTIONS(2893),
    [anon_sym_component] = ACTIONS(2893),
    [anon_sym_abstract] = ACTIONS(2893),
    [anon_sym_interface] = ACTIONS(2893),
    [anon_sym_enum] = ACTIONS(2893),
    [sym_html_comment] = ACTIONS(5),
  },
  [863] = {
    [sym_comment] = STATE(863),
    [sym_identifier] = ACTIONS(2901),
    [anon_sym_export] = ACTIONS(2901),
    [anon_sym_default] = ACTIONS(2901),
    [anon_sym_type] = ACTIONS(2901),
    [anon_sym_namespace] = ACTIONS(2901),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_RBRACE] = ACTIONS(2903),
    [anon_sym_typeof] = ACTIONS(2901),
    [anon_sym_import] = ACTIONS(2901),
    [anon_sym_from] = ACTIONS(2901),
    [anon_sym_with] = ACTIONS(2901),
    [anon_sym_var] = ACTIONS(2901),
    [anon_sym_let] = ACTIONS(2901),
    [anon_sym_const] = ACTIONS(2901),
    [anon_sym_BANG] = ACTIONS(2903),
    [anon_sym_else] = ACTIONS(2901),
    [anon_sym_if] = ACTIONS(2901),
    [anon_sym_switch] = ACTIONS(2901),
    [anon_sym_for] = ACTIONS(2901),
    [anon_sym_LPAREN] = ACTIONS(2903),
    [anon_sym_await] = ACTIONS(2901),
    [anon_sym_of] = ACTIONS(2901),
    [anon_sym_while] = ACTIONS(2901),
    [anon_sym_do] = ACTIONS(2901),
    [anon_sym_try] = ACTIONS(2901),
    [anon_sym_break] = ACTIONS(2901),
    [anon_sym_continue] = ACTIONS(2901),
    [anon_sym_debugger] = ACTIONS(2901),
    [anon_sym_return] = ACTIONS(2901),
    [anon_sym_throw] = ACTIONS(2901),
    [anon_sym_SEMI] = ACTIONS(2903),
    [anon_sym_case] = ACTIONS(2901),
    [anon_sym_yield] = ACTIONS(2901),
    [anon_sym_LBRACK] = ACTIONS(2903),
    [anon_sym_LTtemplate_GT] = ACTIONS(2903),
    [anon_sym_DQUOTE] = ACTIONS(2903),
    [anon_sym_SQUOTE] = ACTIONS(2903),
    [anon_sym_class] = ACTIONS(2901),
    [anon_sym_async] = ACTIONS(2901),
    [anon_sym_function] = ACTIONS(2901),
    [anon_sym_new] = ACTIONS(2901),
    [anon_sym_using] = ACTIONS(2901),
    [anon_sym_PLUS] = ACTIONS(2901),
    [anon_sym_DASH] = ACTIONS(2901),
    [anon_sym_SLASH] = ACTIONS(2901),
    [anon_sym_LT] = ACTIONS(2901),
    [anon_sym_TILDE] = ACTIONS(2903),
    [anon_sym_void] = ACTIONS(2901),
    [anon_sym_delete] = ACTIONS(2901),
    [anon_sym_PLUS_PLUS] = ACTIONS(2903),
    [anon_sym_DASH_DASH] = ACTIONS(2903),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2903),
    [sym_number] = ACTIONS(2903),
    [sym_private_property_identifier] = ACTIONS(2903),
    [sym_this] = ACTIONS(2901),
    [sym_super] = ACTIONS(2901),
    [sym_true] = ACTIONS(2901),
    [sym_false] = ACTIONS(2901),
    [sym_null] = ACTIONS(2901),
    [sym_undefined] = ACTIONS(2901),
    [anon_sym_AT] = ACTIONS(2903),
    [anon_sym_static] = ACTIONS(2901),
    [anon_sym_readonly] = ACTIONS(2901),
    [anon_sym_get] = ACTIONS(2901),
    [anon_sym_set] = ACTIONS(2901),
    [anon_sym_declare] = ACTIONS(2901),
    [anon_sym_public] = ACTIONS(2901),
    [anon_sym_private] = ACTIONS(2901),
    [anon_sym_protected] = ACTIONS(2901),
    [anon_sym_override] = ACTIONS(2901),
    [anon_sym_module] = ACTIONS(2901),
    [anon_sym_any] = ACTIONS(2901),
    [anon_sym_number] = ACTIONS(2901),
    [anon_sym_boolean] = ACTIONS(2901),
    [anon_sym_string] = ACTIONS(2901),
    [anon_sym_symbol] = ACTIONS(2901),
    [anon_sym_object] = ACTIONS(2901),
    [anon_sym_property] = ACTIONS(2901),
    [anon_sym_signal] = ACTIONS(2901),
    [anon_sym_on] = ACTIONS(2901),
    [anon_sym_required] = ACTIONS(2901),
    [anon_sym_component] = ACTIONS(2901),
    [anon_sym_abstract] = ACTIONS(2901),
    [anon_sym_interface] = ACTIONS(2901),
    [anon_sym_enum] = ACTIONS(2901),
    [sym_html_comment] = ACTIONS(5),
  },
  [864] = {
    [sym_comment] = STATE(864),
    [sym_identifier] = ACTIONS(2905),
    [anon_sym_export] = ACTIONS(2905),
    [anon_sym_default] = ACTIONS(2905),
    [anon_sym_type] = ACTIONS(2905),
    [anon_sym_namespace] = ACTIONS(2905),
    [anon_sym_LBRACE] = ACTIONS(2907),
    [anon_sym_RBRACE] = ACTIONS(2907),
    [anon_sym_typeof] = ACTIONS(2905),
    [anon_sym_import] = ACTIONS(2905),
    [anon_sym_from] = ACTIONS(2905),
    [anon_sym_with] = ACTIONS(2905),
    [anon_sym_var] = ACTIONS(2905),
    [anon_sym_let] = ACTIONS(2905),
    [anon_sym_const] = ACTIONS(2905),
    [anon_sym_BANG] = ACTIONS(2907),
    [anon_sym_else] = ACTIONS(2905),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2905),
    [anon_sym_for] = ACTIONS(2905),
    [anon_sym_LPAREN] = ACTIONS(2907),
    [anon_sym_await] = ACTIONS(2905),
    [anon_sym_of] = ACTIONS(2905),
    [anon_sym_while] = ACTIONS(2905),
    [anon_sym_do] = ACTIONS(2905),
    [anon_sym_try] = ACTIONS(2905),
    [anon_sym_break] = ACTIONS(2905),
    [anon_sym_continue] = ACTIONS(2905),
    [anon_sym_debugger] = ACTIONS(2905),
    [anon_sym_return] = ACTIONS(2905),
    [anon_sym_throw] = ACTIONS(2905),
    [anon_sym_SEMI] = ACTIONS(2907),
    [anon_sym_case] = ACTIONS(2905),
    [anon_sym_yield] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2907),
    [anon_sym_LTtemplate_GT] = ACTIONS(2907),
    [anon_sym_DQUOTE] = ACTIONS(2907),
    [anon_sym_SQUOTE] = ACTIONS(2907),
    [anon_sym_class] = ACTIONS(2905),
    [anon_sym_async] = ACTIONS(2905),
    [anon_sym_function] = ACTIONS(2905),
    [anon_sym_new] = ACTIONS(2905),
    [anon_sym_using] = ACTIONS(2905),
    [anon_sym_PLUS] = ACTIONS(2905),
    [anon_sym_DASH] = ACTIONS(2905),
    [anon_sym_SLASH] = ACTIONS(2905),
    [anon_sym_LT] = ACTIONS(2905),
    [anon_sym_TILDE] = ACTIONS(2907),
    [anon_sym_void] = ACTIONS(2905),
    [anon_sym_delete] = ACTIONS(2905),
    [anon_sym_PLUS_PLUS] = ACTIONS(2907),
    [anon_sym_DASH_DASH] = ACTIONS(2907),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2907),
    [sym_number] = ACTIONS(2907),
    [sym_private_property_identifier] = ACTIONS(2907),
    [sym_this] = ACTIONS(2905),
    [sym_super] = ACTIONS(2905),
    [sym_true] = ACTIONS(2905),
    [sym_false] = ACTIONS(2905),
    [sym_null] = ACTIONS(2905),
    [sym_undefined] = ACTIONS(2905),
    [anon_sym_AT] = ACTIONS(2907),
    [anon_sym_static] = ACTIONS(2905),
    [anon_sym_readonly] = ACTIONS(2905),
    [anon_sym_get] = ACTIONS(2905),
    [anon_sym_set] = ACTIONS(2905),
    [anon_sym_declare] = ACTIONS(2905),
    [anon_sym_public] = ACTIONS(2905),
    [anon_sym_private] = ACTIONS(2905),
    [anon_sym_protected] = ACTIONS(2905),
    [anon_sym_override] = ACTIONS(2905),
    [anon_sym_module] = ACTIONS(2905),
    [anon_sym_any] = ACTIONS(2905),
    [anon_sym_number] = ACTIONS(2905),
    [anon_sym_boolean] = ACTIONS(2905),
    [anon_sym_string] = ACTIONS(2905),
    [anon_sym_symbol] = ACTIONS(2905),
    [anon_sym_object] = ACTIONS(2905),
    [anon_sym_property] = ACTIONS(2905),
    [anon_sym_signal] = ACTIONS(2905),
    [anon_sym_on] = ACTIONS(2905),
    [anon_sym_required] = ACTIONS(2905),
    [anon_sym_component] = ACTIONS(2905),
    [anon_sym_abstract] = ACTIONS(2905),
    [anon_sym_interface] = ACTIONS(2905),
    [anon_sym_enum] = ACTIONS(2905),
    [sym_html_comment] = ACTIONS(5),
  },
  [865] = {
    [sym_comment] = STATE(865),
    [sym_identifier] = ACTIONS(2905),
    [anon_sym_export] = ACTIONS(2905),
    [anon_sym_default] = ACTIONS(2905),
    [anon_sym_type] = ACTIONS(2905),
    [anon_sym_namespace] = ACTIONS(2905),
    [anon_sym_LBRACE] = ACTIONS(2907),
    [anon_sym_RBRACE] = ACTIONS(2907),
    [anon_sym_typeof] = ACTIONS(2905),
    [anon_sym_import] = ACTIONS(2905),
    [anon_sym_from] = ACTIONS(2905),
    [anon_sym_with] = ACTIONS(2905),
    [anon_sym_var] = ACTIONS(2905),
    [anon_sym_let] = ACTIONS(2905),
    [anon_sym_const] = ACTIONS(2905),
    [anon_sym_BANG] = ACTIONS(2907),
    [anon_sym_else] = ACTIONS(2905),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2905),
    [anon_sym_for] = ACTIONS(2905),
    [anon_sym_LPAREN] = ACTIONS(2907),
    [anon_sym_await] = ACTIONS(2905),
    [anon_sym_of] = ACTIONS(2905),
    [anon_sym_while] = ACTIONS(2905),
    [anon_sym_do] = ACTIONS(2905),
    [anon_sym_try] = ACTIONS(2905),
    [anon_sym_break] = ACTIONS(2905),
    [anon_sym_continue] = ACTIONS(2905),
    [anon_sym_debugger] = ACTIONS(2905),
    [anon_sym_return] = ACTIONS(2905),
    [anon_sym_throw] = ACTIONS(2905),
    [anon_sym_SEMI] = ACTIONS(2907),
    [anon_sym_case] = ACTIONS(2905),
    [anon_sym_yield] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2907),
    [anon_sym_LTtemplate_GT] = ACTIONS(2907),
    [anon_sym_DQUOTE] = ACTIONS(2907),
    [anon_sym_SQUOTE] = ACTIONS(2907),
    [anon_sym_class] = ACTIONS(2905),
    [anon_sym_async] = ACTIONS(2905),
    [anon_sym_function] = ACTIONS(2905),
    [anon_sym_new] = ACTIONS(2905),
    [anon_sym_using] = ACTIONS(2905),
    [anon_sym_PLUS] = ACTIONS(2905),
    [anon_sym_DASH] = ACTIONS(2905),
    [anon_sym_SLASH] = ACTIONS(2905),
    [anon_sym_LT] = ACTIONS(2905),
    [anon_sym_TILDE] = ACTIONS(2907),
    [anon_sym_void] = ACTIONS(2905),
    [anon_sym_delete] = ACTIONS(2905),
    [anon_sym_PLUS_PLUS] = ACTIONS(2907),
    [anon_sym_DASH_DASH] = ACTIONS(2907),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2907),
    [sym_number] = ACTIONS(2907),
    [sym_private_property_identifier] = ACTIONS(2907),
    [sym_this] = ACTIONS(2905),
    [sym_super] = ACTIONS(2905),
    [sym_true] = ACTIONS(2905),
    [sym_false] = ACTIONS(2905),
    [sym_null] = ACTIONS(2905),
    [sym_undefined] = ACTIONS(2905),
    [anon_sym_AT] = ACTIONS(2907),
    [anon_sym_static] = ACTIONS(2905),
    [anon_sym_readonly] = ACTIONS(2905),
    [anon_sym_get] = ACTIONS(2905),
    [anon_sym_set] = ACTIONS(2905),
    [anon_sym_declare] = ACTIONS(2905),
    [anon_sym_public] = ACTIONS(2905),
    [anon_sym_private] = ACTIONS(2905),
    [anon_sym_protected] = ACTIONS(2905),
    [anon_sym_override] = ACTIONS(2905),
    [anon_sym_module] = ACTIONS(2905),
    [anon_sym_any] = ACTIONS(2905),
    [anon_sym_number] = ACTIONS(2905),
    [anon_sym_boolean] = ACTIONS(2905),
    [anon_sym_string] = ACTIONS(2905),
    [anon_sym_symbol] = ACTIONS(2905),
    [anon_sym_object] = ACTIONS(2905),
    [anon_sym_property] = ACTIONS(2905),
    [anon_sym_signal] = ACTIONS(2905),
    [anon_sym_on] = ACTIONS(2905),
    [anon_sym_required] = ACTIONS(2905),
    [anon_sym_component] = ACTIONS(2905),
    [anon_sym_abstract] = ACTIONS(2905),
    [anon_sym_interface] = ACTIONS(2905),
    [anon_sym_enum] = ACTIONS(2905),
    [sym_html_comment] = ACTIONS(5),
  },
  [866] = {
    [sym_comment] = STATE(866),
    [sym_identifier] = ACTIONS(2909),
    [anon_sym_export] = ACTIONS(2909),
    [anon_sym_default] = ACTIONS(2909),
    [anon_sym_type] = ACTIONS(2909),
    [anon_sym_namespace] = ACTIONS(2909),
    [anon_sym_LBRACE] = ACTIONS(2911),
    [anon_sym_RBRACE] = ACTIONS(2911),
    [anon_sym_typeof] = ACTIONS(2909),
    [anon_sym_import] = ACTIONS(2909),
    [anon_sym_from] = ACTIONS(2909),
    [anon_sym_with] = ACTIONS(2909),
    [anon_sym_var] = ACTIONS(2909),
    [anon_sym_let] = ACTIONS(2909),
    [anon_sym_const] = ACTIONS(2909),
    [anon_sym_BANG] = ACTIONS(2911),
    [anon_sym_else] = ACTIONS(2909),
    [anon_sym_if] = ACTIONS(2909),
    [anon_sym_switch] = ACTIONS(2909),
    [anon_sym_for] = ACTIONS(2909),
    [anon_sym_LPAREN] = ACTIONS(2911),
    [anon_sym_await] = ACTIONS(2909),
    [anon_sym_of] = ACTIONS(2909),
    [anon_sym_while] = ACTIONS(2909),
    [anon_sym_do] = ACTIONS(2909),
    [anon_sym_try] = ACTIONS(2909),
    [anon_sym_break] = ACTIONS(2909),
    [anon_sym_continue] = ACTIONS(2909),
    [anon_sym_debugger] = ACTIONS(2909),
    [anon_sym_return] = ACTIONS(2909),
    [anon_sym_throw] = ACTIONS(2909),
    [anon_sym_SEMI] = ACTIONS(2911),
    [anon_sym_case] = ACTIONS(2909),
    [anon_sym_yield] = ACTIONS(2909),
    [anon_sym_LBRACK] = ACTIONS(2911),
    [anon_sym_LTtemplate_GT] = ACTIONS(2911),
    [anon_sym_DQUOTE] = ACTIONS(2911),
    [anon_sym_SQUOTE] = ACTIONS(2911),
    [anon_sym_class] = ACTIONS(2909),
    [anon_sym_async] = ACTIONS(2909),
    [anon_sym_function] = ACTIONS(2909),
    [anon_sym_new] = ACTIONS(2909),
    [anon_sym_using] = ACTIONS(2909),
    [anon_sym_PLUS] = ACTIONS(2909),
    [anon_sym_DASH] = ACTIONS(2909),
    [anon_sym_SLASH] = ACTIONS(2909),
    [anon_sym_LT] = ACTIONS(2909),
    [anon_sym_TILDE] = ACTIONS(2911),
    [anon_sym_void] = ACTIONS(2909),
    [anon_sym_delete] = ACTIONS(2909),
    [anon_sym_PLUS_PLUS] = ACTIONS(2911),
    [anon_sym_DASH_DASH] = ACTIONS(2911),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2911),
    [sym_number] = ACTIONS(2911),
    [sym_private_property_identifier] = ACTIONS(2911),
    [sym_this] = ACTIONS(2909),
    [sym_super] = ACTIONS(2909),
    [sym_true] = ACTIONS(2909),
    [sym_false] = ACTIONS(2909),
    [sym_null] = ACTIONS(2909),
    [sym_undefined] = ACTIONS(2909),
    [anon_sym_AT] = ACTIONS(2911),
    [anon_sym_static] = ACTIONS(2909),
    [anon_sym_readonly] = ACTIONS(2909),
    [anon_sym_get] = ACTIONS(2909),
    [anon_sym_set] = ACTIONS(2909),
    [anon_sym_declare] = ACTIONS(2909),
    [anon_sym_public] = ACTIONS(2909),
    [anon_sym_private] = ACTIONS(2909),
    [anon_sym_protected] = ACTIONS(2909),
    [anon_sym_override] = ACTIONS(2909),
    [anon_sym_module] = ACTIONS(2909),
    [anon_sym_any] = ACTIONS(2909),
    [anon_sym_number] = ACTIONS(2909),
    [anon_sym_boolean] = ACTIONS(2909),
    [anon_sym_string] = ACTIONS(2909),
    [anon_sym_symbol] = ACTIONS(2909),
    [anon_sym_object] = ACTIONS(2909),
    [anon_sym_property] = ACTIONS(2909),
    [anon_sym_signal] = ACTIONS(2909),
    [anon_sym_on] = ACTIONS(2909),
    [anon_sym_required] = ACTIONS(2909),
    [anon_sym_component] = ACTIONS(2909),
    [anon_sym_abstract] = ACTIONS(2909),
    [anon_sym_interface] = ACTIONS(2909),
    [anon_sym_enum] = ACTIONS(2909),
    [sym_html_comment] = ACTIONS(5),
  },
  [867] = {
    [sym_comment] = STATE(867),
    [sym_identifier] = ACTIONS(2913),
    [anon_sym_export] = ACTIONS(2913),
    [anon_sym_default] = ACTIONS(2913),
    [anon_sym_type] = ACTIONS(2913),
    [anon_sym_namespace] = ACTIONS(2913),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [anon_sym_RBRACE] = ACTIONS(2915),
    [anon_sym_typeof] = ACTIONS(2913),
    [anon_sym_import] = ACTIONS(2913),
    [anon_sym_from] = ACTIONS(2913),
    [anon_sym_with] = ACTIONS(2913),
    [anon_sym_var] = ACTIONS(2913),
    [anon_sym_let] = ACTIONS(2913),
    [anon_sym_const] = ACTIONS(2913),
    [anon_sym_BANG] = ACTIONS(2915),
    [anon_sym_else] = ACTIONS(2913),
    [anon_sym_if] = ACTIONS(2913),
    [anon_sym_switch] = ACTIONS(2913),
    [anon_sym_for] = ACTIONS(2913),
    [anon_sym_LPAREN] = ACTIONS(2915),
    [anon_sym_await] = ACTIONS(2913),
    [anon_sym_of] = ACTIONS(2913),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_do] = ACTIONS(2913),
    [anon_sym_try] = ACTIONS(2913),
    [anon_sym_break] = ACTIONS(2913),
    [anon_sym_continue] = ACTIONS(2913),
    [anon_sym_debugger] = ACTIONS(2913),
    [anon_sym_return] = ACTIONS(2913),
    [anon_sym_throw] = ACTIONS(2913),
    [anon_sym_SEMI] = ACTIONS(2915),
    [anon_sym_case] = ACTIONS(2913),
    [anon_sym_yield] = ACTIONS(2913),
    [anon_sym_LBRACK] = ACTIONS(2915),
    [anon_sym_LTtemplate_GT] = ACTIONS(2915),
    [anon_sym_DQUOTE] = ACTIONS(2915),
    [anon_sym_SQUOTE] = ACTIONS(2915),
    [anon_sym_class] = ACTIONS(2913),
    [anon_sym_async] = ACTIONS(2913),
    [anon_sym_function] = ACTIONS(2913),
    [anon_sym_new] = ACTIONS(2913),
    [anon_sym_using] = ACTIONS(2913),
    [anon_sym_PLUS] = ACTIONS(2913),
    [anon_sym_DASH] = ACTIONS(2913),
    [anon_sym_SLASH] = ACTIONS(2913),
    [anon_sym_LT] = ACTIONS(2913),
    [anon_sym_TILDE] = ACTIONS(2915),
    [anon_sym_void] = ACTIONS(2913),
    [anon_sym_delete] = ACTIONS(2913),
    [anon_sym_PLUS_PLUS] = ACTIONS(2915),
    [anon_sym_DASH_DASH] = ACTIONS(2915),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2915),
    [sym_number] = ACTIONS(2915),
    [sym_private_property_identifier] = ACTIONS(2915),
    [sym_this] = ACTIONS(2913),
    [sym_super] = ACTIONS(2913),
    [sym_true] = ACTIONS(2913),
    [sym_false] = ACTIONS(2913),
    [sym_null] = ACTIONS(2913),
    [sym_undefined] = ACTIONS(2913),
    [anon_sym_AT] = ACTIONS(2915),
    [anon_sym_static] = ACTIONS(2913),
    [anon_sym_readonly] = ACTIONS(2913),
    [anon_sym_get] = ACTIONS(2913),
    [anon_sym_set] = ACTIONS(2913),
    [anon_sym_declare] = ACTIONS(2913),
    [anon_sym_public] = ACTIONS(2913),
    [anon_sym_private] = ACTIONS(2913),
    [anon_sym_protected] = ACTIONS(2913),
    [anon_sym_override] = ACTIONS(2913),
    [anon_sym_module] = ACTIONS(2913),
    [anon_sym_any] = ACTIONS(2913),
    [anon_sym_number] = ACTIONS(2913),
    [anon_sym_boolean] = ACTIONS(2913),
    [anon_sym_string] = ACTIONS(2913),
    [anon_sym_symbol] = ACTIONS(2913),
    [anon_sym_object] = ACTIONS(2913),
    [anon_sym_property] = ACTIONS(2913),
    [anon_sym_signal] = ACTIONS(2913),
    [anon_sym_on] = ACTIONS(2913),
    [anon_sym_required] = ACTIONS(2913),
    [anon_sym_component] = ACTIONS(2913),
    [anon_sym_abstract] = ACTIONS(2913),
    [anon_sym_interface] = ACTIONS(2913),
    [anon_sym_enum] = ACTIONS(2913),
    [sym_html_comment] = ACTIONS(5),
  },
  [868] = {
    [sym_comment] = STATE(868),
    [sym_identifier] = ACTIONS(2917),
    [anon_sym_export] = ACTIONS(2917),
    [anon_sym_default] = ACTIONS(2917),
    [anon_sym_type] = ACTIONS(2917),
    [anon_sym_namespace] = ACTIONS(2917),
    [anon_sym_LBRACE] = ACTIONS(2919),
    [anon_sym_RBRACE] = ACTIONS(2919),
    [anon_sym_typeof] = ACTIONS(2917),
    [anon_sym_import] = ACTIONS(2917),
    [anon_sym_from] = ACTIONS(2917),
    [anon_sym_with] = ACTIONS(2917),
    [anon_sym_var] = ACTIONS(2917),
    [anon_sym_let] = ACTIONS(2917),
    [anon_sym_const] = ACTIONS(2917),
    [anon_sym_BANG] = ACTIONS(2919),
    [anon_sym_else] = ACTIONS(2917),
    [anon_sym_if] = ACTIONS(2917),
    [anon_sym_switch] = ACTIONS(2917),
    [anon_sym_for] = ACTIONS(2917),
    [anon_sym_LPAREN] = ACTIONS(2919),
    [anon_sym_await] = ACTIONS(2917),
    [anon_sym_of] = ACTIONS(2917),
    [anon_sym_while] = ACTIONS(2917),
    [anon_sym_do] = ACTIONS(2917),
    [anon_sym_try] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2917),
    [anon_sym_continue] = ACTIONS(2917),
    [anon_sym_debugger] = ACTIONS(2917),
    [anon_sym_return] = ACTIONS(2917),
    [anon_sym_throw] = ACTIONS(2917),
    [anon_sym_SEMI] = ACTIONS(2919),
    [anon_sym_case] = ACTIONS(2917),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_LBRACK] = ACTIONS(2919),
    [anon_sym_LTtemplate_GT] = ACTIONS(2919),
    [anon_sym_DQUOTE] = ACTIONS(2919),
    [anon_sym_SQUOTE] = ACTIONS(2919),
    [anon_sym_class] = ACTIONS(2917),
    [anon_sym_async] = ACTIONS(2917),
    [anon_sym_function] = ACTIONS(2917),
    [anon_sym_new] = ACTIONS(2917),
    [anon_sym_using] = ACTIONS(2917),
    [anon_sym_PLUS] = ACTIONS(2917),
    [anon_sym_DASH] = ACTIONS(2917),
    [anon_sym_SLASH] = ACTIONS(2917),
    [anon_sym_LT] = ACTIONS(2917),
    [anon_sym_TILDE] = ACTIONS(2919),
    [anon_sym_void] = ACTIONS(2917),
    [anon_sym_delete] = ACTIONS(2917),
    [anon_sym_PLUS_PLUS] = ACTIONS(2919),
    [anon_sym_DASH_DASH] = ACTIONS(2919),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2919),
    [sym_number] = ACTIONS(2919),
    [sym_private_property_identifier] = ACTIONS(2919),
    [sym_this] = ACTIONS(2917),
    [sym_super] = ACTIONS(2917),
    [sym_true] = ACTIONS(2917),
    [sym_false] = ACTIONS(2917),
    [sym_null] = ACTIONS(2917),
    [sym_undefined] = ACTIONS(2917),
    [anon_sym_AT] = ACTIONS(2919),
    [anon_sym_static] = ACTIONS(2917),
    [anon_sym_readonly] = ACTIONS(2917),
    [anon_sym_get] = ACTIONS(2917),
    [anon_sym_set] = ACTIONS(2917),
    [anon_sym_declare] = ACTIONS(2917),
    [anon_sym_public] = ACTIONS(2917),
    [anon_sym_private] = ACTIONS(2917),
    [anon_sym_protected] = ACTIONS(2917),
    [anon_sym_override] = ACTIONS(2917),
    [anon_sym_module] = ACTIONS(2917),
    [anon_sym_any] = ACTIONS(2917),
    [anon_sym_number] = ACTIONS(2917),
    [anon_sym_boolean] = ACTIONS(2917),
    [anon_sym_string] = ACTIONS(2917),
    [anon_sym_symbol] = ACTIONS(2917),
    [anon_sym_object] = ACTIONS(2917),
    [anon_sym_property] = ACTIONS(2917),
    [anon_sym_signal] = ACTIONS(2917),
    [anon_sym_on] = ACTIONS(2917),
    [anon_sym_required] = ACTIONS(2917),
    [anon_sym_component] = ACTIONS(2917),
    [anon_sym_abstract] = ACTIONS(2917),
    [anon_sym_interface] = ACTIONS(2917),
    [anon_sym_enum] = ACTIONS(2917),
    [sym_html_comment] = ACTIONS(5),
  },
  [869] = {
    [sym_comment] = STATE(869),
    [sym_identifier] = ACTIONS(2841),
    [anon_sym_export] = ACTIONS(2841),
    [anon_sym_default] = ACTIONS(2841),
    [anon_sym_type] = ACTIONS(2841),
    [anon_sym_namespace] = ACTIONS(2841),
    [anon_sym_LBRACE] = ACTIONS(2843),
    [anon_sym_RBRACE] = ACTIONS(2843),
    [anon_sym_typeof] = ACTIONS(2841),
    [anon_sym_import] = ACTIONS(2841),
    [anon_sym_from] = ACTIONS(2841),
    [anon_sym_with] = ACTIONS(2841),
    [anon_sym_var] = ACTIONS(2841),
    [anon_sym_let] = ACTIONS(2841),
    [anon_sym_const] = ACTIONS(2841),
    [anon_sym_BANG] = ACTIONS(2843),
    [anon_sym_else] = ACTIONS(2841),
    [anon_sym_if] = ACTIONS(2841),
    [anon_sym_switch] = ACTIONS(2841),
    [anon_sym_for] = ACTIONS(2841),
    [anon_sym_LPAREN] = ACTIONS(2843),
    [anon_sym_await] = ACTIONS(2841),
    [anon_sym_of] = ACTIONS(2841),
    [anon_sym_while] = ACTIONS(2841),
    [anon_sym_do] = ACTIONS(2841),
    [anon_sym_try] = ACTIONS(2841),
    [anon_sym_break] = ACTIONS(2841),
    [anon_sym_continue] = ACTIONS(2841),
    [anon_sym_debugger] = ACTIONS(2841),
    [anon_sym_return] = ACTIONS(2841),
    [anon_sym_throw] = ACTIONS(2841),
    [anon_sym_SEMI] = ACTIONS(2843),
    [anon_sym_case] = ACTIONS(2841),
    [anon_sym_yield] = ACTIONS(2841),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_LTtemplate_GT] = ACTIONS(2843),
    [anon_sym_DQUOTE] = ACTIONS(2843),
    [anon_sym_SQUOTE] = ACTIONS(2843),
    [anon_sym_class] = ACTIONS(2841),
    [anon_sym_async] = ACTIONS(2841),
    [anon_sym_function] = ACTIONS(2841),
    [anon_sym_new] = ACTIONS(2841),
    [anon_sym_using] = ACTIONS(2841),
    [anon_sym_PLUS] = ACTIONS(2841),
    [anon_sym_DASH] = ACTIONS(2841),
    [anon_sym_SLASH] = ACTIONS(2841),
    [anon_sym_LT] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_void] = ACTIONS(2841),
    [anon_sym_delete] = ACTIONS(2841),
    [anon_sym_PLUS_PLUS] = ACTIONS(2843),
    [anon_sym_DASH_DASH] = ACTIONS(2843),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2843),
    [sym_number] = ACTIONS(2843),
    [sym_private_property_identifier] = ACTIONS(2843),
    [sym_this] = ACTIONS(2841),
    [sym_super] = ACTIONS(2841),
    [sym_true] = ACTIONS(2841),
    [sym_false] = ACTIONS(2841),
    [sym_null] = ACTIONS(2841),
    [sym_undefined] = ACTIONS(2841),
    [anon_sym_AT] = ACTIONS(2843),
    [anon_sym_static] = ACTIONS(2841),
    [anon_sym_readonly] = ACTIONS(2841),
    [anon_sym_get] = ACTIONS(2841),
    [anon_sym_set] = ACTIONS(2841),
    [anon_sym_declare] = ACTIONS(2841),
    [anon_sym_public] = ACTIONS(2841),
    [anon_sym_private] = ACTIONS(2841),
    [anon_sym_protected] = ACTIONS(2841),
    [anon_sym_override] = ACTIONS(2841),
    [anon_sym_module] = ACTIONS(2841),
    [anon_sym_any] = ACTIONS(2841),
    [anon_sym_number] = ACTIONS(2841),
    [anon_sym_boolean] = ACTIONS(2841),
    [anon_sym_string] = ACTIONS(2841),
    [anon_sym_symbol] = ACTIONS(2841),
    [anon_sym_object] = ACTIONS(2841),
    [anon_sym_property] = ACTIONS(2841),
    [anon_sym_signal] = ACTIONS(2841),
    [anon_sym_on] = ACTIONS(2841),
    [anon_sym_required] = ACTIONS(2841),
    [anon_sym_component] = ACTIONS(2841),
    [anon_sym_abstract] = ACTIONS(2841),
    [anon_sym_interface] = ACTIONS(2841),
    [anon_sym_enum] = ACTIONS(2841),
    [sym_html_comment] = ACTIONS(5),
  },
  [870] = {
    [sym_comment] = STATE(870),
    [sym_identifier] = ACTIONS(2921),
    [anon_sym_export] = ACTIONS(2921),
    [anon_sym_default] = ACTIONS(2921),
    [anon_sym_type] = ACTIONS(2921),
    [anon_sym_namespace] = ACTIONS(2921),
    [anon_sym_LBRACE] = ACTIONS(2923),
    [anon_sym_RBRACE] = ACTIONS(2923),
    [anon_sym_typeof] = ACTIONS(2921),
    [anon_sym_import] = ACTIONS(2921),
    [anon_sym_from] = ACTIONS(2921),
    [anon_sym_with] = ACTIONS(2921),
    [anon_sym_var] = ACTIONS(2921),
    [anon_sym_let] = ACTIONS(2921),
    [anon_sym_const] = ACTIONS(2921),
    [anon_sym_BANG] = ACTIONS(2923),
    [anon_sym_else] = ACTIONS(2921),
    [anon_sym_if] = ACTIONS(2921),
    [anon_sym_switch] = ACTIONS(2921),
    [anon_sym_for] = ACTIONS(2921),
    [anon_sym_LPAREN] = ACTIONS(2923),
    [anon_sym_await] = ACTIONS(2921),
    [anon_sym_of] = ACTIONS(2921),
    [anon_sym_while] = ACTIONS(2921),
    [anon_sym_do] = ACTIONS(2921),
    [anon_sym_try] = ACTIONS(2921),
    [anon_sym_break] = ACTIONS(2921),
    [anon_sym_continue] = ACTIONS(2921),
    [anon_sym_debugger] = ACTIONS(2921),
    [anon_sym_return] = ACTIONS(2921),
    [anon_sym_throw] = ACTIONS(2921),
    [anon_sym_SEMI] = ACTIONS(2923),
    [anon_sym_case] = ACTIONS(2921),
    [anon_sym_yield] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2923),
    [anon_sym_LTtemplate_GT] = ACTIONS(2923),
    [anon_sym_DQUOTE] = ACTIONS(2923),
    [anon_sym_SQUOTE] = ACTIONS(2923),
    [anon_sym_class] = ACTIONS(2921),
    [anon_sym_async] = ACTIONS(2921),
    [anon_sym_function] = ACTIONS(2921),
    [anon_sym_new] = ACTIONS(2921),
    [anon_sym_using] = ACTIONS(2921),
    [anon_sym_PLUS] = ACTIONS(2921),
    [anon_sym_DASH] = ACTIONS(2921),
    [anon_sym_SLASH] = ACTIONS(2921),
    [anon_sym_LT] = ACTIONS(2921),
    [anon_sym_TILDE] = ACTIONS(2923),
    [anon_sym_void] = ACTIONS(2921),
    [anon_sym_delete] = ACTIONS(2921),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2923),
    [sym_number] = ACTIONS(2923),
    [sym_private_property_identifier] = ACTIONS(2923),
    [sym_this] = ACTIONS(2921),
    [sym_super] = ACTIONS(2921),
    [sym_true] = ACTIONS(2921),
    [sym_false] = ACTIONS(2921),
    [sym_null] = ACTIONS(2921),
    [sym_undefined] = ACTIONS(2921),
    [anon_sym_AT] = ACTIONS(2923),
    [anon_sym_static] = ACTIONS(2921),
    [anon_sym_readonly] = ACTIONS(2921),
    [anon_sym_get] = ACTIONS(2921),
    [anon_sym_set] = ACTIONS(2921),
    [anon_sym_declare] = ACTIONS(2921),
    [anon_sym_public] = ACTIONS(2921),
    [anon_sym_private] = ACTIONS(2921),
    [anon_sym_protected] = ACTIONS(2921),
    [anon_sym_override] = ACTIONS(2921),
    [anon_sym_module] = ACTIONS(2921),
    [anon_sym_any] = ACTIONS(2921),
    [anon_sym_number] = ACTIONS(2921),
    [anon_sym_boolean] = ACTIONS(2921),
    [anon_sym_string] = ACTIONS(2921),
    [anon_sym_symbol] = ACTIONS(2921),
    [anon_sym_object] = ACTIONS(2921),
    [anon_sym_property] = ACTIONS(2921),
    [anon_sym_signal] = ACTIONS(2921),
    [anon_sym_on] = ACTIONS(2921),
    [anon_sym_required] = ACTIONS(2921),
    [anon_sym_component] = ACTIONS(2921),
    [anon_sym_abstract] = ACTIONS(2921),
    [anon_sym_interface] = ACTIONS(2921),
    [anon_sym_enum] = ACTIONS(2921),
    [sym_html_comment] = ACTIONS(5),
  },
  [871] = {
    [sym_comment] = STATE(871),
    [sym_identifier] = ACTIONS(2925),
    [anon_sym_export] = ACTIONS(2925),
    [anon_sym_default] = ACTIONS(2925),
    [anon_sym_type] = ACTIONS(2925),
    [anon_sym_namespace] = ACTIONS(2925),
    [anon_sym_LBRACE] = ACTIONS(2927),
    [anon_sym_RBRACE] = ACTIONS(2927),
    [anon_sym_typeof] = ACTIONS(2925),
    [anon_sym_import] = ACTIONS(2925),
    [anon_sym_from] = ACTIONS(2925),
    [anon_sym_with] = ACTIONS(2925),
    [anon_sym_var] = ACTIONS(2925),
    [anon_sym_let] = ACTIONS(2925),
    [anon_sym_const] = ACTIONS(2925),
    [anon_sym_BANG] = ACTIONS(2927),
    [anon_sym_else] = ACTIONS(2925),
    [anon_sym_if] = ACTIONS(2925),
    [anon_sym_switch] = ACTIONS(2925),
    [anon_sym_for] = ACTIONS(2925),
    [anon_sym_LPAREN] = ACTIONS(2927),
    [anon_sym_await] = ACTIONS(2925),
    [anon_sym_of] = ACTIONS(2925),
    [anon_sym_while] = ACTIONS(2925),
    [anon_sym_do] = ACTIONS(2925),
    [anon_sym_try] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2925),
    [anon_sym_continue] = ACTIONS(2925),
    [anon_sym_debugger] = ACTIONS(2925),
    [anon_sym_return] = ACTIONS(2925),
    [anon_sym_throw] = ACTIONS(2925),
    [anon_sym_SEMI] = ACTIONS(2927),
    [anon_sym_case] = ACTIONS(2925),
    [anon_sym_yield] = ACTIONS(2925),
    [anon_sym_LBRACK] = ACTIONS(2927),
    [anon_sym_LTtemplate_GT] = ACTIONS(2927),
    [anon_sym_DQUOTE] = ACTIONS(2927),
    [anon_sym_SQUOTE] = ACTIONS(2927),
    [anon_sym_class] = ACTIONS(2925),
    [anon_sym_async] = ACTIONS(2925),
    [anon_sym_function] = ACTIONS(2925),
    [anon_sym_new] = ACTIONS(2925),
    [anon_sym_using] = ACTIONS(2925),
    [anon_sym_PLUS] = ACTIONS(2925),
    [anon_sym_DASH] = ACTIONS(2925),
    [anon_sym_SLASH] = ACTIONS(2925),
    [anon_sym_LT] = ACTIONS(2925),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_void] = ACTIONS(2925),
    [anon_sym_delete] = ACTIONS(2925),
    [anon_sym_PLUS_PLUS] = ACTIONS(2927),
    [anon_sym_DASH_DASH] = ACTIONS(2927),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2927),
    [sym_number] = ACTIONS(2927),
    [sym_private_property_identifier] = ACTIONS(2927),
    [sym_this] = ACTIONS(2925),
    [sym_super] = ACTIONS(2925),
    [sym_true] = ACTIONS(2925),
    [sym_false] = ACTIONS(2925),
    [sym_null] = ACTIONS(2925),
    [sym_undefined] = ACTIONS(2925),
    [anon_sym_AT] = ACTIONS(2927),
    [anon_sym_static] = ACTIONS(2925),
    [anon_sym_readonly] = ACTIONS(2925),
    [anon_sym_get] = ACTIONS(2925),
    [anon_sym_set] = ACTIONS(2925),
    [anon_sym_declare] = ACTIONS(2925),
    [anon_sym_public] = ACTIONS(2925),
    [anon_sym_private] = ACTIONS(2925),
    [anon_sym_protected] = ACTIONS(2925),
    [anon_sym_override] = ACTIONS(2925),
    [anon_sym_module] = ACTIONS(2925),
    [anon_sym_any] = ACTIONS(2925),
    [anon_sym_number] = ACTIONS(2925),
    [anon_sym_boolean] = ACTIONS(2925),
    [anon_sym_string] = ACTIONS(2925),
    [anon_sym_symbol] = ACTIONS(2925),
    [anon_sym_object] = ACTIONS(2925),
    [anon_sym_property] = ACTIONS(2925),
    [anon_sym_signal] = ACTIONS(2925),
    [anon_sym_on] = ACTIONS(2925),
    [anon_sym_required] = ACTIONS(2925),
    [anon_sym_component] = ACTIONS(2925),
    [anon_sym_abstract] = ACTIONS(2925),
    [anon_sym_interface] = ACTIONS(2925),
    [anon_sym_enum] = ACTIONS(2925),
    [sym_html_comment] = ACTIONS(5),
  },
  [872] = {
    [sym_comment] = STATE(872),
    [sym_identifier] = ACTIONS(2929),
    [anon_sym_export] = ACTIONS(2929),
    [anon_sym_default] = ACTIONS(2929),
    [anon_sym_type] = ACTIONS(2929),
    [anon_sym_namespace] = ACTIONS(2929),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [anon_sym_RBRACE] = ACTIONS(2931),
    [anon_sym_typeof] = ACTIONS(2929),
    [anon_sym_import] = ACTIONS(2929),
    [anon_sym_from] = ACTIONS(2929),
    [anon_sym_with] = ACTIONS(2929),
    [anon_sym_var] = ACTIONS(2929),
    [anon_sym_let] = ACTIONS(2929),
    [anon_sym_const] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2931),
    [anon_sym_else] = ACTIONS(2929),
    [anon_sym_if] = ACTIONS(2929),
    [anon_sym_switch] = ACTIONS(2929),
    [anon_sym_for] = ACTIONS(2929),
    [anon_sym_LPAREN] = ACTIONS(2931),
    [anon_sym_await] = ACTIONS(2929),
    [anon_sym_of] = ACTIONS(2929),
    [anon_sym_while] = ACTIONS(2929),
    [anon_sym_do] = ACTIONS(2929),
    [anon_sym_try] = ACTIONS(2929),
    [anon_sym_break] = ACTIONS(2929),
    [anon_sym_continue] = ACTIONS(2929),
    [anon_sym_debugger] = ACTIONS(2929),
    [anon_sym_return] = ACTIONS(2929),
    [anon_sym_throw] = ACTIONS(2929),
    [anon_sym_SEMI] = ACTIONS(2931),
    [anon_sym_case] = ACTIONS(2929),
    [anon_sym_yield] = ACTIONS(2929),
    [anon_sym_LBRACK] = ACTIONS(2931),
    [anon_sym_LTtemplate_GT] = ACTIONS(2931),
    [anon_sym_DQUOTE] = ACTIONS(2931),
    [anon_sym_SQUOTE] = ACTIONS(2931),
    [anon_sym_class] = ACTIONS(2929),
    [anon_sym_async] = ACTIONS(2929),
    [anon_sym_function] = ACTIONS(2929),
    [anon_sym_new] = ACTIONS(2929),
    [anon_sym_using] = ACTIONS(2929),
    [anon_sym_PLUS] = ACTIONS(2929),
    [anon_sym_DASH] = ACTIONS(2929),
    [anon_sym_SLASH] = ACTIONS(2929),
    [anon_sym_LT] = ACTIONS(2929),
    [anon_sym_TILDE] = ACTIONS(2931),
    [anon_sym_void] = ACTIONS(2929),
    [anon_sym_delete] = ACTIONS(2929),
    [anon_sym_PLUS_PLUS] = ACTIONS(2931),
    [anon_sym_DASH_DASH] = ACTIONS(2931),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2931),
    [sym_number] = ACTIONS(2931),
    [sym_private_property_identifier] = ACTIONS(2931),
    [sym_this] = ACTIONS(2929),
    [sym_super] = ACTIONS(2929),
    [sym_true] = ACTIONS(2929),
    [sym_false] = ACTIONS(2929),
    [sym_null] = ACTIONS(2929),
    [sym_undefined] = ACTIONS(2929),
    [anon_sym_AT] = ACTIONS(2931),
    [anon_sym_static] = ACTIONS(2929),
    [anon_sym_readonly] = ACTIONS(2929),
    [anon_sym_get] = ACTIONS(2929),
    [anon_sym_set] = ACTIONS(2929),
    [anon_sym_declare] = ACTIONS(2929),
    [anon_sym_public] = ACTIONS(2929),
    [anon_sym_private] = ACTIONS(2929),
    [anon_sym_protected] = ACTIONS(2929),
    [anon_sym_override] = ACTIONS(2929),
    [anon_sym_module] = ACTIONS(2929),
    [anon_sym_any] = ACTIONS(2929),
    [anon_sym_number] = ACTIONS(2929),
    [anon_sym_boolean] = ACTIONS(2929),
    [anon_sym_string] = ACTIONS(2929),
    [anon_sym_symbol] = ACTIONS(2929),
    [anon_sym_object] = ACTIONS(2929),
    [anon_sym_property] = ACTIONS(2929),
    [anon_sym_signal] = ACTIONS(2929),
    [anon_sym_on] = ACTIONS(2929),
    [anon_sym_required] = ACTIONS(2929),
    [anon_sym_component] = ACTIONS(2929),
    [anon_sym_abstract] = ACTIONS(2929),
    [anon_sym_interface] = ACTIONS(2929),
    [anon_sym_enum] = ACTIONS(2929),
    [sym_html_comment] = ACTIONS(5),
  },
  [873] = {
    [sym_comment] = STATE(873),
    [sym_identifier] = ACTIONS(2933),
    [anon_sym_export] = ACTIONS(2933),
    [anon_sym_default] = ACTIONS(2933),
    [anon_sym_type] = ACTIONS(2933),
    [anon_sym_namespace] = ACTIONS(2933),
    [anon_sym_LBRACE] = ACTIONS(2935),
    [anon_sym_RBRACE] = ACTIONS(2935),
    [anon_sym_typeof] = ACTIONS(2933),
    [anon_sym_import] = ACTIONS(2933),
    [anon_sym_from] = ACTIONS(2933),
    [anon_sym_with] = ACTIONS(2933),
    [anon_sym_var] = ACTIONS(2933),
    [anon_sym_let] = ACTIONS(2933),
    [anon_sym_const] = ACTIONS(2933),
    [anon_sym_BANG] = ACTIONS(2935),
    [anon_sym_else] = ACTIONS(2933),
    [anon_sym_if] = ACTIONS(2933),
    [anon_sym_switch] = ACTIONS(2933),
    [anon_sym_for] = ACTIONS(2933),
    [anon_sym_LPAREN] = ACTIONS(2935),
    [anon_sym_await] = ACTIONS(2933),
    [anon_sym_of] = ACTIONS(2933),
    [anon_sym_while] = ACTIONS(2933),
    [anon_sym_do] = ACTIONS(2933),
    [anon_sym_try] = ACTIONS(2933),
    [anon_sym_break] = ACTIONS(2933),
    [anon_sym_continue] = ACTIONS(2933),
    [anon_sym_debugger] = ACTIONS(2933),
    [anon_sym_return] = ACTIONS(2933),
    [anon_sym_throw] = ACTIONS(2933),
    [anon_sym_SEMI] = ACTIONS(2935),
    [anon_sym_case] = ACTIONS(2933),
    [anon_sym_yield] = ACTIONS(2933),
    [anon_sym_LBRACK] = ACTIONS(2935),
    [anon_sym_LTtemplate_GT] = ACTIONS(2935),
    [anon_sym_DQUOTE] = ACTIONS(2935),
    [anon_sym_SQUOTE] = ACTIONS(2935),
    [anon_sym_class] = ACTIONS(2933),
    [anon_sym_async] = ACTIONS(2933),
    [anon_sym_function] = ACTIONS(2933),
    [anon_sym_new] = ACTIONS(2933),
    [anon_sym_using] = ACTIONS(2933),
    [anon_sym_PLUS] = ACTIONS(2933),
    [anon_sym_DASH] = ACTIONS(2933),
    [anon_sym_SLASH] = ACTIONS(2933),
    [anon_sym_LT] = ACTIONS(2933),
    [anon_sym_TILDE] = ACTIONS(2935),
    [anon_sym_void] = ACTIONS(2933),
    [anon_sym_delete] = ACTIONS(2933),
    [anon_sym_PLUS_PLUS] = ACTIONS(2935),
    [anon_sym_DASH_DASH] = ACTIONS(2935),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2935),
    [sym_number] = ACTIONS(2935),
    [sym_private_property_identifier] = ACTIONS(2935),
    [sym_this] = ACTIONS(2933),
    [sym_super] = ACTIONS(2933),
    [sym_true] = ACTIONS(2933),
    [sym_false] = ACTIONS(2933),
    [sym_null] = ACTIONS(2933),
    [sym_undefined] = ACTIONS(2933),
    [anon_sym_AT] = ACTIONS(2935),
    [anon_sym_static] = ACTIONS(2933),
    [anon_sym_readonly] = ACTIONS(2933),
    [anon_sym_get] = ACTIONS(2933),
    [anon_sym_set] = ACTIONS(2933),
    [anon_sym_declare] = ACTIONS(2933),
    [anon_sym_public] = ACTIONS(2933),
    [anon_sym_private] = ACTIONS(2933),
    [anon_sym_protected] = ACTIONS(2933),
    [anon_sym_override] = ACTIONS(2933),
    [anon_sym_module] = ACTIONS(2933),
    [anon_sym_any] = ACTIONS(2933),
    [anon_sym_number] = ACTIONS(2933),
    [anon_sym_boolean] = ACTIONS(2933),
    [anon_sym_string] = ACTIONS(2933),
    [anon_sym_symbol] = ACTIONS(2933),
    [anon_sym_object] = ACTIONS(2933),
    [anon_sym_property] = ACTIONS(2933),
    [anon_sym_signal] = ACTIONS(2933),
    [anon_sym_on] = ACTIONS(2933),
    [anon_sym_required] = ACTIONS(2933),
    [anon_sym_component] = ACTIONS(2933),
    [anon_sym_abstract] = ACTIONS(2933),
    [anon_sym_interface] = ACTIONS(2933),
    [anon_sym_enum] = ACTIONS(2933),
    [sym_html_comment] = ACTIONS(5),
  },
  [874] = {
    [sym_comment] = STATE(874),
    [sym_identifier] = ACTIONS(2937),
    [anon_sym_export] = ACTIONS(2937),
    [anon_sym_default] = ACTIONS(2937),
    [anon_sym_type] = ACTIONS(2937),
    [anon_sym_namespace] = ACTIONS(2937),
    [anon_sym_LBRACE] = ACTIONS(2939),
    [anon_sym_RBRACE] = ACTIONS(2939),
    [anon_sym_typeof] = ACTIONS(2937),
    [anon_sym_import] = ACTIONS(2937),
    [anon_sym_from] = ACTIONS(2937),
    [anon_sym_with] = ACTIONS(2937),
    [anon_sym_var] = ACTIONS(2937),
    [anon_sym_let] = ACTIONS(2937),
    [anon_sym_const] = ACTIONS(2937),
    [anon_sym_BANG] = ACTIONS(2939),
    [anon_sym_else] = ACTIONS(2937),
    [anon_sym_if] = ACTIONS(2937),
    [anon_sym_switch] = ACTIONS(2937),
    [anon_sym_for] = ACTIONS(2937),
    [anon_sym_LPAREN] = ACTIONS(2939),
    [anon_sym_await] = ACTIONS(2937),
    [anon_sym_of] = ACTIONS(2937),
    [anon_sym_while] = ACTIONS(2937),
    [anon_sym_do] = ACTIONS(2937),
    [anon_sym_try] = ACTIONS(2937),
    [anon_sym_break] = ACTIONS(2937),
    [anon_sym_continue] = ACTIONS(2937),
    [anon_sym_debugger] = ACTIONS(2937),
    [anon_sym_return] = ACTIONS(2937),
    [anon_sym_throw] = ACTIONS(2937),
    [anon_sym_SEMI] = ACTIONS(2939),
    [anon_sym_case] = ACTIONS(2937),
    [anon_sym_yield] = ACTIONS(2937),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_LTtemplate_GT] = ACTIONS(2939),
    [anon_sym_DQUOTE] = ACTIONS(2939),
    [anon_sym_SQUOTE] = ACTIONS(2939),
    [anon_sym_class] = ACTIONS(2937),
    [anon_sym_async] = ACTIONS(2937),
    [anon_sym_function] = ACTIONS(2937),
    [anon_sym_new] = ACTIONS(2937),
    [anon_sym_using] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(2937),
    [anon_sym_DASH] = ACTIONS(2937),
    [anon_sym_SLASH] = ACTIONS(2937),
    [anon_sym_LT] = ACTIONS(2937),
    [anon_sym_TILDE] = ACTIONS(2939),
    [anon_sym_void] = ACTIONS(2937),
    [anon_sym_delete] = ACTIONS(2937),
    [anon_sym_PLUS_PLUS] = ACTIONS(2939),
    [anon_sym_DASH_DASH] = ACTIONS(2939),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2939),
    [sym_number] = ACTIONS(2939),
    [sym_private_property_identifier] = ACTIONS(2939),
    [sym_this] = ACTIONS(2937),
    [sym_super] = ACTIONS(2937),
    [sym_true] = ACTIONS(2937),
    [sym_false] = ACTIONS(2937),
    [sym_null] = ACTIONS(2937),
    [sym_undefined] = ACTIONS(2937),
    [anon_sym_AT] = ACTIONS(2939),
    [anon_sym_static] = ACTIONS(2937),
    [anon_sym_readonly] = ACTIONS(2937),
    [anon_sym_get] = ACTIONS(2937),
    [anon_sym_set] = ACTIONS(2937),
    [anon_sym_declare] = ACTIONS(2937),
    [anon_sym_public] = ACTIONS(2937),
    [anon_sym_private] = ACTIONS(2937),
    [anon_sym_protected] = ACTIONS(2937),
    [anon_sym_override] = ACTIONS(2937),
    [anon_sym_module] = ACTIONS(2937),
    [anon_sym_any] = ACTIONS(2937),
    [anon_sym_number] = ACTIONS(2937),
    [anon_sym_boolean] = ACTIONS(2937),
    [anon_sym_string] = ACTIONS(2937),
    [anon_sym_symbol] = ACTIONS(2937),
    [anon_sym_object] = ACTIONS(2937),
    [anon_sym_property] = ACTIONS(2937),
    [anon_sym_signal] = ACTIONS(2937),
    [anon_sym_on] = ACTIONS(2937),
    [anon_sym_required] = ACTIONS(2937),
    [anon_sym_component] = ACTIONS(2937),
    [anon_sym_abstract] = ACTIONS(2937),
    [anon_sym_interface] = ACTIONS(2937),
    [anon_sym_enum] = ACTIONS(2937),
    [sym_html_comment] = ACTIONS(5),
  },
  [875] = {
    [sym_comment] = STATE(875),
    [sym_identifier] = ACTIONS(2941),
    [anon_sym_export] = ACTIONS(2941),
    [anon_sym_default] = ACTIONS(2941),
    [anon_sym_type] = ACTIONS(2941),
    [anon_sym_namespace] = ACTIONS(2941),
    [anon_sym_LBRACE] = ACTIONS(2943),
    [anon_sym_RBRACE] = ACTIONS(2943),
    [anon_sym_typeof] = ACTIONS(2941),
    [anon_sym_import] = ACTIONS(2941),
    [anon_sym_from] = ACTIONS(2941),
    [anon_sym_with] = ACTIONS(2941),
    [anon_sym_var] = ACTIONS(2941),
    [anon_sym_let] = ACTIONS(2941),
    [anon_sym_const] = ACTIONS(2941),
    [anon_sym_BANG] = ACTIONS(2943),
    [anon_sym_else] = ACTIONS(2941),
    [anon_sym_if] = ACTIONS(2941),
    [anon_sym_switch] = ACTIONS(2941),
    [anon_sym_for] = ACTIONS(2941),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_await] = ACTIONS(2941),
    [anon_sym_of] = ACTIONS(2941),
    [anon_sym_while] = ACTIONS(2941),
    [anon_sym_do] = ACTIONS(2941),
    [anon_sym_try] = ACTIONS(2941),
    [anon_sym_break] = ACTIONS(2941),
    [anon_sym_continue] = ACTIONS(2941),
    [anon_sym_debugger] = ACTIONS(2941),
    [anon_sym_return] = ACTIONS(2941),
    [anon_sym_throw] = ACTIONS(2941),
    [anon_sym_SEMI] = ACTIONS(2943),
    [anon_sym_case] = ACTIONS(2941),
    [anon_sym_yield] = ACTIONS(2941),
    [anon_sym_LBRACK] = ACTIONS(2943),
    [anon_sym_LTtemplate_GT] = ACTIONS(2943),
    [anon_sym_DQUOTE] = ACTIONS(2943),
    [anon_sym_SQUOTE] = ACTIONS(2943),
    [anon_sym_class] = ACTIONS(2941),
    [anon_sym_async] = ACTIONS(2941),
    [anon_sym_function] = ACTIONS(2941),
    [anon_sym_new] = ACTIONS(2941),
    [anon_sym_using] = ACTIONS(2941),
    [anon_sym_PLUS] = ACTIONS(2941),
    [anon_sym_DASH] = ACTIONS(2941),
    [anon_sym_SLASH] = ACTIONS(2941),
    [anon_sym_LT] = ACTIONS(2941),
    [anon_sym_TILDE] = ACTIONS(2943),
    [anon_sym_void] = ACTIONS(2941),
    [anon_sym_delete] = ACTIONS(2941),
    [anon_sym_PLUS_PLUS] = ACTIONS(2943),
    [anon_sym_DASH_DASH] = ACTIONS(2943),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2943),
    [sym_number] = ACTIONS(2943),
    [sym_private_property_identifier] = ACTIONS(2943),
    [sym_this] = ACTIONS(2941),
    [sym_super] = ACTIONS(2941),
    [sym_true] = ACTIONS(2941),
    [sym_false] = ACTIONS(2941),
    [sym_null] = ACTIONS(2941),
    [sym_undefined] = ACTIONS(2941),
    [anon_sym_AT] = ACTIONS(2943),
    [anon_sym_static] = ACTIONS(2941),
    [anon_sym_readonly] = ACTIONS(2941),
    [anon_sym_get] = ACTIONS(2941),
    [anon_sym_set] = ACTIONS(2941),
    [anon_sym_declare] = ACTIONS(2941),
    [anon_sym_public] = ACTIONS(2941),
    [anon_sym_private] = ACTIONS(2941),
    [anon_sym_protected] = ACTIONS(2941),
    [anon_sym_override] = ACTIONS(2941),
    [anon_sym_module] = ACTIONS(2941),
    [anon_sym_any] = ACTIONS(2941),
    [anon_sym_number] = ACTIONS(2941),
    [anon_sym_boolean] = ACTIONS(2941),
    [anon_sym_string] = ACTIONS(2941),
    [anon_sym_symbol] = ACTIONS(2941),
    [anon_sym_object] = ACTIONS(2941),
    [anon_sym_property] = ACTIONS(2941),
    [anon_sym_signal] = ACTIONS(2941),
    [anon_sym_on] = ACTIONS(2941),
    [anon_sym_required] = ACTIONS(2941),
    [anon_sym_component] = ACTIONS(2941),
    [anon_sym_abstract] = ACTIONS(2941),
    [anon_sym_interface] = ACTIONS(2941),
    [anon_sym_enum] = ACTIONS(2941),
    [sym_html_comment] = ACTIONS(5),
  },
  [876] = {
    [sym_comment] = STATE(876),
    [sym_identifier] = ACTIONS(2945),
    [anon_sym_export] = ACTIONS(2945),
    [anon_sym_default] = ACTIONS(2945),
    [anon_sym_type] = ACTIONS(2945),
    [anon_sym_namespace] = ACTIONS(2945),
    [anon_sym_LBRACE] = ACTIONS(2947),
    [anon_sym_RBRACE] = ACTIONS(2947),
    [anon_sym_typeof] = ACTIONS(2945),
    [anon_sym_import] = ACTIONS(2945),
    [anon_sym_from] = ACTIONS(2945),
    [anon_sym_with] = ACTIONS(2945),
    [anon_sym_var] = ACTIONS(2945),
    [anon_sym_let] = ACTIONS(2945),
    [anon_sym_const] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2947),
    [anon_sym_else] = ACTIONS(2945),
    [anon_sym_if] = ACTIONS(2945),
    [anon_sym_switch] = ACTIONS(2945),
    [anon_sym_for] = ACTIONS(2945),
    [anon_sym_LPAREN] = ACTIONS(2947),
    [anon_sym_await] = ACTIONS(2945),
    [anon_sym_of] = ACTIONS(2945),
    [anon_sym_while] = ACTIONS(2945),
    [anon_sym_do] = ACTIONS(2945),
    [anon_sym_try] = ACTIONS(2945),
    [anon_sym_break] = ACTIONS(2945),
    [anon_sym_continue] = ACTIONS(2945),
    [anon_sym_debugger] = ACTIONS(2945),
    [anon_sym_return] = ACTIONS(2945),
    [anon_sym_throw] = ACTIONS(2945),
    [anon_sym_SEMI] = ACTIONS(2947),
    [anon_sym_case] = ACTIONS(2945),
    [anon_sym_yield] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(2947),
    [anon_sym_LTtemplate_GT] = ACTIONS(2947),
    [anon_sym_DQUOTE] = ACTIONS(2947),
    [anon_sym_SQUOTE] = ACTIONS(2947),
    [anon_sym_class] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(2945),
    [anon_sym_function] = ACTIONS(2945),
    [anon_sym_new] = ACTIONS(2945),
    [anon_sym_using] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(2945),
    [anon_sym_DASH] = ACTIONS(2945),
    [anon_sym_SLASH] = ACTIONS(2945),
    [anon_sym_LT] = ACTIONS(2945),
    [anon_sym_TILDE] = ACTIONS(2947),
    [anon_sym_void] = ACTIONS(2945),
    [anon_sym_delete] = ACTIONS(2945),
    [anon_sym_PLUS_PLUS] = ACTIONS(2947),
    [anon_sym_DASH_DASH] = ACTIONS(2947),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2947),
    [sym_number] = ACTIONS(2947),
    [sym_private_property_identifier] = ACTIONS(2947),
    [sym_this] = ACTIONS(2945),
    [sym_super] = ACTIONS(2945),
    [sym_true] = ACTIONS(2945),
    [sym_false] = ACTIONS(2945),
    [sym_null] = ACTIONS(2945),
    [sym_undefined] = ACTIONS(2945),
    [anon_sym_AT] = ACTIONS(2947),
    [anon_sym_static] = ACTIONS(2945),
    [anon_sym_readonly] = ACTIONS(2945),
    [anon_sym_get] = ACTIONS(2945),
    [anon_sym_set] = ACTIONS(2945),
    [anon_sym_declare] = ACTIONS(2945),
    [anon_sym_public] = ACTIONS(2945),
    [anon_sym_private] = ACTIONS(2945),
    [anon_sym_protected] = ACTIONS(2945),
    [anon_sym_override] = ACTIONS(2945),
    [anon_sym_module] = ACTIONS(2945),
    [anon_sym_any] = ACTIONS(2945),
    [anon_sym_number] = ACTIONS(2945),
    [anon_sym_boolean] = ACTIONS(2945),
    [anon_sym_string] = ACTIONS(2945),
    [anon_sym_symbol] = ACTIONS(2945),
    [anon_sym_object] = ACTIONS(2945),
    [anon_sym_property] = ACTIONS(2945),
    [anon_sym_signal] = ACTIONS(2945),
    [anon_sym_on] = ACTIONS(2945),
    [anon_sym_required] = ACTIONS(2945),
    [anon_sym_component] = ACTIONS(2945),
    [anon_sym_abstract] = ACTIONS(2945),
    [anon_sym_interface] = ACTIONS(2945),
    [anon_sym_enum] = ACTIONS(2945),
    [sym_html_comment] = ACTIONS(5),
  },
  [877] = {
    [sym_comment] = STATE(877),
    [sym_identifier] = ACTIONS(2949),
    [anon_sym_export] = ACTIONS(2949),
    [anon_sym_default] = ACTIONS(2949),
    [anon_sym_type] = ACTIONS(2949),
    [anon_sym_namespace] = ACTIONS(2949),
    [anon_sym_LBRACE] = ACTIONS(2951),
    [anon_sym_RBRACE] = ACTIONS(2951),
    [anon_sym_typeof] = ACTIONS(2949),
    [anon_sym_import] = ACTIONS(2949),
    [anon_sym_from] = ACTIONS(2949),
    [anon_sym_with] = ACTIONS(2949),
    [anon_sym_var] = ACTIONS(2949),
    [anon_sym_let] = ACTIONS(2949),
    [anon_sym_const] = ACTIONS(2949),
    [anon_sym_BANG] = ACTIONS(2951),
    [anon_sym_else] = ACTIONS(2949),
    [anon_sym_if] = ACTIONS(2949),
    [anon_sym_switch] = ACTIONS(2949),
    [anon_sym_for] = ACTIONS(2949),
    [anon_sym_LPAREN] = ACTIONS(2951),
    [anon_sym_await] = ACTIONS(2949),
    [anon_sym_of] = ACTIONS(2949),
    [anon_sym_while] = ACTIONS(2949),
    [anon_sym_do] = ACTIONS(2949),
    [anon_sym_try] = ACTIONS(2949),
    [anon_sym_break] = ACTIONS(2949),
    [anon_sym_continue] = ACTIONS(2949),
    [anon_sym_debugger] = ACTIONS(2949),
    [anon_sym_return] = ACTIONS(2949),
    [anon_sym_throw] = ACTIONS(2949),
    [anon_sym_SEMI] = ACTIONS(2951),
    [anon_sym_case] = ACTIONS(2949),
    [anon_sym_yield] = ACTIONS(2949),
    [anon_sym_LBRACK] = ACTIONS(2951),
    [anon_sym_LTtemplate_GT] = ACTIONS(2951),
    [anon_sym_DQUOTE] = ACTIONS(2951),
    [anon_sym_SQUOTE] = ACTIONS(2951),
    [anon_sym_class] = ACTIONS(2949),
    [anon_sym_async] = ACTIONS(2949),
    [anon_sym_function] = ACTIONS(2949),
    [anon_sym_new] = ACTIONS(2949),
    [anon_sym_using] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2949),
    [anon_sym_DASH] = ACTIONS(2949),
    [anon_sym_SLASH] = ACTIONS(2949),
    [anon_sym_LT] = ACTIONS(2949),
    [anon_sym_TILDE] = ACTIONS(2951),
    [anon_sym_void] = ACTIONS(2949),
    [anon_sym_delete] = ACTIONS(2949),
    [anon_sym_PLUS_PLUS] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2951),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2951),
    [sym_number] = ACTIONS(2951),
    [sym_private_property_identifier] = ACTIONS(2951),
    [sym_this] = ACTIONS(2949),
    [sym_super] = ACTIONS(2949),
    [sym_true] = ACTIONS(2949),
    [sym_false] = ACTIONS(2949),
    [sym_null] = ACTIONS(2949),
    [sym_undefined] = ACTIONS(2949),
    [anon_sym_AT] = ACTIONS(2951),
    [anon_sym_static] = ACTIONS(2949),
    [anon_sym_readonly] = ACTIONS(2949),
    [anon_sym_get] = ACTIONS(2949),
    [anon_sym_set] = ACTIONS(2949),
    [anon_sym_declare] = ACTIONS(2949),
    [anon_sym_public] = ACTIONS(2949),
    [anon_sym_private] = ACTIONS(2949),
    [anon_sym_protected] = ACTIONS(2949),
    [anon_sym_override] = ACTIONS(2949),
    [anon_sym_module] = ACTIONS(2949),
    [anon_sym_any] = ACTIONS(2949),
    [anon_sym_number] = ACTIONS(2949),
    [anon_sym_boolean] = ACTIONS(2949),
    [anon_sym_string] = ACTIONS(2949),
    [anon_sym_symbol] = ACTIONS(2949),
    [anon_sym_object] = ACTIONS(2949),
    [anon_sym_property] = ACTIONS(2949),
    [anon_sym_signal] = ACTIONS(2949),
    [anon_sym_on] = ACTIONS(2949),
    [anon_sym_required] = ACTIONS(2949),
    [anon_sym_component] = ACTIONS(2949),
    [anon_sym_abstract] = ACTIONS(2949),
    [anon_sym_interface] = ACTIONS(2949),
    [anon_sym_enum] = ACTIONS(2949),
    [sym_html_comment] = ACTIONS(5),
  },
  [878] = {
    [sym_comment] = STATE(878),
    [sym_identifier] = ACTIONS(2893),
    [anon_sym_export] = ACTIONS(2893),
    [anon_sym_default] = ACTIONS(2893),
    [anon_sym_type] = ACTIONS(2893),
    [anon_sym_namespace] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_RBRACE] = ACTIONS(2895),
    [anon_sym_typeof] = ACTIONS(2893),
    [anon_sym_import] = ACTIONS(2893),
    [anon_sym_from] = ACTIONS(2893),
    [anon_sym_with] = ACTIONS(2893),
    [anon_sym_var] = ACTIONS(2893),
    [anon_sym_let] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_BANG] = ACTIONS(2895),
    [anon_sym_else] = ACTIONS(2893),
    [anon_sym_if] = ACTIONS(2893),
    [anon_sym_switch] = ACTIONS(2893),
    [anon_sym_for] = ACTIONS(2893),
    [anon_sym_LPAREN] = ACTIONS(2895),
    [anon_sym_await] = ACTIONS(2893),
    [anon_sym_of] = ACTIONS(2893),
    [anon_sym_while] = ACTIONS(2893),
    [anon_sym_do] = ACTIONS(2893),
    [anon_sym_try] = ACTIONS(2893),
    [anon_sym_break] = ACTIONS(2893),
    [anon_sym_continue] = ACTIONS(2893),
    [anon_sym_debugger] = ACTIONS(2893),
    [anon_sym_return] = ACTIONS(2893),
    [anon_sym_throw] = ACTIONS(2893),
    [anon_sym_SEMI] = ACTIONS(2895),
    [anon_sym_case] = ACTIONS(2893),
    [anon_sym_yield] = ACTIONS(2893),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_LTtemplate_GT] = ACTIONS(2895),
    [anon_sym_DQUOTE] = ACTIONS(2895),
    [anon_sym_SQUOTE] = ACTIONS(2895),
    [anon_sym_class] = ACTIONS(2893),
    [anon_sym_async] = ACTIONS(2893),
    [anon_sym_function] = ACTIONS(2893),
    [anon_sym_new] = ACTIONS(2893),
    [anon_sym_using] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2893),
    [anon_sym_DASH] = ACTIONS(2893),
    [anon_sym_SLASH] = ACTIONS(2893),
    [anon_sym_LT] = ACTIONS(2893),
    [anon_sym_TILDE] = ACTIONS(2895),
    [anon_sym_void] = ACTIONS(2893),
    [anon_sym_delete] = ACTIONS(2893),
    [anon_sym_PLUS_PLUS] = ACTIONS(2895),
    [anon_sym_DASH_DASH] = ACTIONS(2895),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2895),
    [sym_number] = ACTIONS(2895),
    [sym_private_property_identifier] = ACTIONS(2895),
    [sym_this] = ACTIONS(2893),
    [sym_super] = ACTIONS(2893),
    [sym_true] = ACTIONS(2893),
    [sym_false] = ACTIONS(2893),
    [sym_null] = ACTIONS(2893),
    [sym_undefined] = ACTIONS(2893),
    [anon_sym_AT] = ACTIONS(2895),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_readonly] = ACTIONS(2893),
    [anon_sym_get] = ACTIONS(2893),
    [anon_sym_set] = ACTIONS(2893),
    [anon_sym_declare] = ACTIONS(2893),
    [anon_sym_public] = ACTIONS(2893),
    [anon_sym_private] = ACTIONS(2893),
    [anon_sym_protected] = ACTIONS(2893),
    [anon_sym_override] = ACTIONS(2893),
    [anon_sym_module] = ACTIONS(2893),
    [anon_sym_any] = ACTIONS(2893),
    [anon_sym_number] = ACTIONS(2893),
    [anon_sym_boolean] = ACTIONS(2893),
    [anon_sym_string] = ACTIONS(2893),
    [anon_sym_symbol] = ACTIONS(2893),
    [anon_sym_object] = ACTIONS(2893),
    [anon_sym_property] = ACTIONS(2893),
    [anon_sym_signal] = ACTIONS(2893),
    [anon_sym_on] = ACTIONS(2893),
    [anon_sym_required] = ACTIONS(2893),
    [anon_sym_component] = ACTIONS(2893),
    [anon_sym_abstract] = ACTIONS(2893),
    [anon_sym_interface] = ACTIONS(2893),
    [anon_sym_enum] = ACTIONS(2893),
    [sym_html_comment] = ACTIONS(5),
  },
  [879] = {
    [sym_comment] = STATE(879),
    [sym_identifier] = ACTIONS(2893),
    [anon_sym_export] = ACTIONS(2893),
    [anon_sym_default] = ACTIONS(2893),
    [anon_sym_type] = ACTIONS(2893),
    [anon_sym_namespace] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_RBRACE] = ACTIONS(2895),
    [anon_sym_typeof] = ACTIONS(2893),
    [anon_sym_import] = ACTIONS(2893),
    [anon_sym_from] = ACTIONS(2893),
    [anon_sym_with] = ACTIONS(2893),
    [anon_sym_var] = ACTIONS(2893),
    [anon_sym_let] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_BANG] = ACTIONS(2895),
    [anon_sym_else] = ACTIONS(2893),
    [anon_sym_if] = ACTIONS(2893),
    [anon_sym_switch] = ACTIONS(2893),
    [anon_sym_for] = ACTIONS(2893),
    [anon_sym_LPAREN] = ACTIONS(2895),
    [anon_sym_await] = ACTIONS(2893),
    [anon_sym_of] = ACTIONS(2893),
    [anon_sym_while] = ACTIONS(2893),
    [anon_sym_do] = ACTIONS(2893),
    [anon_sym_try] = ACTIONS(2893),
    [anon_sym_break] = ACTIONS(2893),
    [anon_sym_continue] = ACTIONS(2893),
    [anon_sym_debugger] = ACTIONS(2893),
    [anon_sym_return] = ACTIONS(2893),
    [anon_sym_throw] = ACTIONS(2893),
    [anon_sym_SEMI] = ACTIONS(2895),
    [anon_sym_case] = ACTIONS(2893),
    [anon_sym_yield] = ACTIONS(2893),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_LTtemplate_GT] = ACTIONS(2895),
    [anon_sym_DQUOTE] = ACTIONS(2895),
    [anon_sym_SQUOTE] = ACTIONS(2895),
    [anon_sym_class] = ACTIONS(2893),
    [anon_sym_async] = ACTIONS(2893),
    [anon_sym_function] = ACTIONS(2893),
    [anon_sym_new] = ACTIONS(2893),
    [anon_sym_using] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2893),
    [anon_sym_DASH] = ACTIONS(2893),
    [anon_sym_SLASH] = ACTIONS(2893),
    [anon_sym_LT] = ACTIONS(2893),
    [anon_sym_TILDE] = ACTIONS(2895),
    [anon_sym_void] = ACTIONS(2893),
    [anon_sym_delete] = ACTIONS(2893),
    [anon_sym_PLUS_PLUS] = ACTIONS(2895),
    [anon_sym_DASH_DASH] = ACTIONS(2895),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2895),
    [sym_number] = ACTIONS(2895),
    [sym_private_property_identifier] = ACTIONS(2895),
    [sym_this] = ACTIONS(2893),
    [sym_super] = ACTIONS(2893),
    [sym_true] = ACTIONS(2893),
    [sym_false] = ACTIONS(2893),
    [sym_null] = ACTIONS(2893),
    [sym_undefined] = ACTIONS(2893),
    [anon_sym_AT] = ACTIONS(2895),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_readonly] = ACTIONS(2893),
    [anon_sym_get] = ACTIONS(2893),
    [anon_sym_set] = ACTIONS(2893),
    [anon_sym_declare] = ACTIONS(2893),
    [anon_sym_public] = ACTIONS(2893),
    [anon_sym_private] = ACTIONS(2893),
    [anon_sym_protected] = ACTIONS(2893),
    [anon_sym_override] = ACTIONS(2893),
    [anon_sym_module] = ACTIONS(2893),
    [anon_sym_any] = ACTIONS(2893),
    [anon_sym_number] = ACTIONS(2893),
    [anon_sym_boolean] = ACTIONS(2893),
    [anon_sym_string] = ACTIONS(2893),
    [anon_sym_symbol] = ACTIONS(2893),
    [anon_sym_object] = ACTIONS(2893),
    [anon_sym_property] = ACTIONS(2893),
    [anon_sym_signal] = ACTIONS(2893),
    [anon_sym_on] = ACTIONS(2893),
    [anon_sym_required] = ACTIONS(2893),
    [anon_sym_component] = ACTIONS(2893),
    [anon_sym_abstract] = ACTIONS(2893),
    [anon_sym_interface] = ACTIONS(2893),
    [anon_sym_enum] = ACTIONS(2893),
    [sym_html_comment] = ACTIONS(5),
  },
  [880] = {
    [sym_comment] = STATE(880),
    [sym_identifier] = ACTIONS(2893),
    [anon_sym_export] = ACTIONS(2893),
    [anon_sym_default] = ACTIONS(2893),
    [anon_sym_type] = ACTIONS(2893),
    [anon_sym_namespace] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_RBRACE] = ACTIONS(2895),
    [anon_sym_typeof] = ACTIONS(2893),
    [anon_sym_import] = ACTIONS(2893),
    [anon_sym_from] = ACTIONS(2893),
    [anon_sym_with] = ACTIONS(2893),
    [anon_sym_var] = ACTIONS(2893),
    [anon_sym_let] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_BANG] = ACTIONS(2895),
    [anon_sym_else] = ACTIONS(2893),
    [anon_sym_if] = ACTIONS(2893),
    [anon_sym_switch] = ACTIONS(2893),
    [anon_sym_for] = ACTIONS(2893),
    [anon_sym_LPAREN] = ACTIONS(2895),
    [anon_sym_await] = ACTIONS(2893),
    [anon_sym_of] = ACTIONS(2893),
    [anon_sym_while] = ACTIONS(2893),
    [anon_sym_do] = ACTIONS(2893),
    [anon_sym_try] = ACTIONS(2893),
    [anon_sym_break] = ACTIONS(2893),
    [anon_sym_continue] = ACTIONS(2893),
    [anon_sym_debugger] = ACTIONS(2893),
    [anon_sym_return] = ACTIONS(2893),
    [anon_sym_throw] = ACTIONS(2893),
    [anon_sym_SEMI] = ACTIONS(2895),
    [anon_sym_case] = ACTIONS(2893),
    [anon_sym_yield] = ACTIONS(2893),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_LTtemplate_GT] = ACTIONS(2895),
    [anon_sym_DQUOTE] = ACTIONS(2895),
    [anon_sym_SQUOTE] = ACTIONS(2895),
    [anon_sym_class] = ACTIONS(2893),
    [anon_sym_async] = ACTIONS(2893),
    [anon_sym_function] = ACTIONS(2893),
    [anon_sym_new] = ACTIONS(2893),
    [anon_sym_using] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2893),
    [anon_sym_DASH] = ACTIONS(2893),
    [anon_sym_SLASH] = ACTIONS(2893),
    [anon_sym_LT] = ACTIONS(2893),
    [anon_sym_TILDE] = ACTIONS(2895),
    [anon_sym_void] = ACTIONS(2893),
    [anon_sym_delete] = ACTIONS(2893),
    [anon_sym_PLUS_PLUS] = ACTIONS(2895),
    [anon_sym_DASH_DASH] = ACTIONS(2895),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2895),
    [sym_number] = ACTIONS(2895),
    [sym_private_property_identifier] = ACTIONS(2895),
    [sym_this] = ACTIONS(2893),
    [sym_super] = ACTIONS(2893),
    [sym_true] = ACTIONS(2893),
    [sym_false] = ACTIONS(2893),
    [sym_null] = ACTIONS(2893),
    [sym_undefined] = ACTIONS(2893),
    [anon_sym_AT] = ACTIONS(2895),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_readonly] = ACTIONS(2893),
    [anon_sym_get] = ACTIONS(2893),
    [anon_sym_set] = ACTIONS(2893),
    [anon_sym_declare] = ACTIONS(2893),
    [anon_sym_public] = ACTIONS(2893),
    [anon_sym_private] = ACTIONS(2893),
    [anon_sym_protected] = ACTIONS(2893),
    [anon_sym_override] = ACTIONS(2893),
    [anon_sym_module] = ACTIONS(2893),
    [anon_sym_any] = ACTIONS(2893),
    [anon_sym_number] = ACTIONS(2893),
    [anon_sym_boolean] = ACTIONS(2893),
    [anon_sym_string] = ACTIONS(2893),
    [anon_sym_symbol] = ACTIONS(2893),
    [anon_sym_object] = ACTIONS(2893),
    [anon_sym_property] = ACTIONS(2893),
    [anon_sym_signal] = ACTIONS(2893),
    [anon_sym_on] = ACTIONS(2893),
    [anon_sym_required] = ACTIONS(2893),
    [anon_sym_component] = ACTIONS(2893),
    [anon_sym_abstract] = ACTIONS(2893),
    [anon_sym_interface] = ACTIONS(2893),
    [anon_sym_enum] = ACTIONS(2893),
    [sym_html_comment] = ACTIONS(5),
  },
  [881] = {
    [sym_comment] = STATE(881),
    [sym_identifier] = ACTIONS(2953),
    [anon_sym_export] = ACTIONS(2953),
    [anon_sym_default] = ACTIONS(2953),
    [anon_sym_type] = ACTIONS(2953),
    [anon_sym_namespace] = ACTIONS(2953),
    [anon_sym_LBRACE] = ACTIONS(2955),
    [anon_sym_RBRACE] = ACTIONS(2955),
    [anon_sym_typeof] = ACTIONS(2953),
    [anon_sym_import] = ACTIONS(2953),
    [anon_sym_from] = ACTIONS(2953),
    [anon_sym_with] = ACTIONS(2953),
    [anon_sym_var] = ACTIONS(2953),
    [anon_sym_let] = ACTIONS(2953),
    [anon_sym_const] = ACTIONS(2953),
    [anon_sym_BANG] = ACTIONS(2955),
    [anon_sym_else] = ACTIONS(2953),
    [anon_sym_if] = ACTIONS(2953),
    [anon_sym_switch] = ACTIONS(2953),
    [anon_sym_for] = ACTIONS(2953),
    [anon_sym_LPAREN] = ACTIONS(2955),
    [anon_sym_await] = ACTIONS(2953),
    [anon_sym_of] = ACTIONS(2953),
    [anon_sym_while] = ACTIONS(2953),
    [anon_sym_do] = ACTIONS(2953),
    [anon_sym_try] = ACTIONS(2953),
    [anon_sym_break] = ACTIONS(2953),
    [anon_sym_continue] = ACTIONS(2953),
    [anon_sym_debugger] = ACTIONS(2953),
    [anon_sym_return] = ACTIONS(2953),
    [anon_sym_throw] = ACTIONS(2953),
    [anon_sym_SEMI] = ACTIONS(2955),
    [anon_sym_case] = ACTIONS(2953),
    [anon_sym_yield] = ACTIONS(2953),
    [anon_sym_LBRACK] = ACTIONS(2955),
    [anon_sym_LTtemplate_GT] = ACTIONS(2955),
    [anon_sym_DQUOTE] = ACTIONS(2955),
    [anon_sym_SQUOTE] = ACTIONS(2955),
    [anon_sym_class] = ACTIONS(2953),
    [anon_sym_async] = ACTIONS(2953),
    [anon_sym_function] = ACTIONS(2953),
    [anon_sym_new] = ACTIONS(2953),
    [anon_sym_using] = ACTIONS(2953),
    [anon_sym_PLUS] = ACTIONS(2953),
    [anon_sym_DASH] = ACTIONS(2953),
    [anon_sym_SLASH] = ACTIONS(2953),
    [anon_sym_LT] = ACTIONS(2953),
    [anon_sym_TILDE] = ACTIONS(2955),
    [anon_sym_void] = ACTIONS(2953),
    [anon_sym_delete] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2955),
    [anon_sym_DASH_DASH] = ACTIONS(2955),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2955),
    [sym_number] = ACTIONS(2955),
    [sym_private_property_identifier] = ACTIONS(2955),
    [sym_this] = ACTIONS(2953),
    [sym_super] = ACTIONS(2953),
    [sym_true] = ACTIONS(2953),
    [sym_false] = ACTIONS(2953),
    [sym_null] = ACTIONS(2953),
    [sym_undefined] = ACTIONS(2953),
    [anon_sym_AT] = ACTIONS(2955),
    [anon_sym_static] = ACTIONS(2953),
    [anon_sym_readonly] = ACTIONS(2953),
    [anon_sym_get] = ACTIONS(2953),
    [anon_sym_set] = ACTIONS(2953),
    [anon_sym_declare] = ACTIONS(2953),
    [anon_sym_public] = ACTIONS(2953),
    [anon_sym_private] = ACTIONS(2953),
    [anon_sym_protected] = ACTIONS(2953),
    [anon_sym_override] = ACTIONS(2953),
    [anon_sym_module] = ACTIONS(2953),
    [anon_sym_any] = ACTIONS(2953),
    [anon_sym_number] = ACTIONS(2953),
    [anon_sym_boolean] = ACTIONS(2953),
    [anon_sym_string] = ACTIONS(2953),
    [anon_sym_symbol] = ACTIONS(2953),
    [anon_sym_object] = ACTIONS(2953),
    [anon_sym_property] = ACTIONS(2953),
    [anon_sym_signal] = ACTIONS(2953),
    [anon_sym_on] = ACTIONS(2953),
    [anon_sym_required] = ACTIONS(2953),
    [anon_sym_component] = ACTIONS(2953),
    [anon_sym_abstract] = ACTIONS(2953),
    [anon_sym_interface] = ACTIONS(2953),
    [anon_sym_enum] = ACTIONS(2953),
    [sym_html_comment] = ACTIONS(5),
  },
  [882] = {
    [sym_comment] = STATE(882),
    [sym_identifier] = ACTIONS(2957),
    [anon_sym_export] = ACTIONS(2957),
    [anon_sym_default] = ACTIONS(2957),
    [anon_sym_type] = ACTIONS(2957),
    [anon_sym_namespace] = ACTIONS(2957),
    [anon_sym_LBRACE] = ACTIONS(2959),
    [anon_sym_RBRACE] = ACTIONS(2959),
    [anon_sym_typeof] = ACTIONS(2957),
    [anon_sym_import] = ACTIONS(2957),
    [anon_sym_from] = ACTIONS(2957),
    [anon_sym_with] = ACTIONS(2957),
    [anon_sym_var] = ACTIONS(2957),
    [anon_sym_let] = ACTIONS(2957),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_BANG] = ACTIONS(2959),
    [anon_sym_else] = ACTIONS(2957),
    [anon_sym_if] = ACTIONS(2957),
    [anon_sym_switch] = ACTIONS(2957),
    [anon_sym_for] = ACTIONS(2957),
    [anon_sym_LPAREN] = ACTIONS(2959),
    [anon_sym_await] = ACTIONS(2957),
    [anon_sym_of] = ACTIONS(2957),
    [anon_sym_while] = ACTIONS(2957),
    [anon_sym_do] = ACTIONS(2957),
    [anon_sym_try] = ACTIONS(2957),
    [anon_sym_break] = ACTIONS(2957),
    [anon_sym_continue] = ACTIONS(2957),
    [anon_sym_debugger] = ACTIONS(2957),
    [anon_sym_return] = ACTIONS(2957),
    [anon_sym_throw] = ACTIONS(2957),
    [anon_sym_SEMI] = ACTIONS(2959),
    [anon_sym_case] = ACTIONS(2957),
    [anon_sym_yield] = ACTIONS(2957),
    [anon_sym_LBRACK] = ACTIONS(2959),
    [anon_sym_LTtemplate_GT] = ACTIONS(2959),
    [anon_sym_DQUOTE] = ACTIONS(2959),
    [anon_sym_SQUOTE] = ACTIONS(2959),
    [anon_sym_class] = ACTIONS(2957),
    [anon_sym_async] = ACTIONS(2957),
    [anon_sym_function] = ACTIONS(2957),
    [anon_sym_new] = ACTIONS(2957),
    [anon_sym_using] = ACTIONS(2957),
    [anon_sym_PLUS] = ACTIONS(2957),
    [anon_sym_DASH] = ACTIONS(2957),
    [anon_sym_SLASH] = ACTIONS(2957),
    [anon_sym_LT] = ACTIONS(2957),
    [anon_sym_TILDE] = ACTIONS(2959),
    [anon_sym_void] = ACTIONS(2957),
    [anon_sym_delete] = ACTIONS(2957),
    [anon_sym_PLUS_PLUS] = ACTIONS(2959),
    [anon_sym_DASH_DASH] = ACTIONS(2959),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2959),
    [sym_number] = ACTIONS(2959),
    [sym_private_property_identifier] = ACTIONS(2959),
    [sym_this] = ACTIONS(2957),
    [sym_super] = ACTIONS(2957),
    [sym_true] = ACTIONS(2957),
    [sym_false] = ACTIONS(2957),
    [sym_null] = ACTIONS(2957),
    [sym_undefined] = ACTIONS(2957),
    [anon_sym_AT] = ACTIONS(2959),
    [anon_sym_static] = ACTIONS(2957),
    [anon_sym_readonly] = ACTIONS(2957),
    [anon_sym_get] = ACTIONS(2957),
    [anon_sym_set] = ACTIONS(2957),
    [anon_sym_declare] = ACTIONS(2957),
    [anon_sym_public] = ACTIONS(2957),
    [anon_sym_private] = ACTIONS(2957),
    [anon_sym_protected] = ACTIONS(2957),
    [anon_sym_override] = ACTIONS(2957),
    [anon_sym_module] = ACTIONS(2957),
    [anon_sym_any] = ACTIONS(2957),
    [anon_sym_number] = ACTIONS(2957),
    [anon_sym_boolean] = ACTIONS(2957),
    [anon_sym_string] = ACTIONS(2957),
    [anon_sym_symbol] = ACTIONS(2957),
    [anon_sym_object] = ACTIONS(2957),
    [anon_sym_property] = ACTIONS(2957),
    [anon_sym_signal] = ACTIONS(2957),
    [anon_sym_on] = ACTIONS(2957),
    [anon_sym_required] = ACTIONS(2957),
    [anon_sym_component] = ACTIONS(2957),
    [anon_sym_abstract] = ACTIONS(2957),
    [anon_sym_interface] = ACTIONS(2957),
    [anon_sym_enum] = ACTIONS(2957),
    [sym_html_comment] = ACTIONS(5),
  },
  [883] = {
    [sym_comment] = STATE(883),
    [sym_identifier] = ACTIONS(2961),
    [anon_sym_export] = ACTIONS(2961),
    [anon_sym_default] = ACTIONS(2961),
    [anon_sym_type] = ACTIONS(2961),
    [anon_sym_namespace] = ACTIONS(2961),
    [anon_sym_LBRACE] = ACTIONS(2963),
    [anon_sym_RBRACE] = ACTIONS(2963),
    [anon_sym_typeof] = ACTIONS(2961),
    [anon_sym_import] = ACTIONS(2961),
    [anon_sym_from] = ACTIONS(2961),
    [anon_sym_with] = ACTIONS(2961),
    [anon_sym_var] = ACTIONS(2961),
    [anon_sym_let] = ACTIONS(2961),
    [anon_sym_const] = ACTIONS(2961),
    [anon_sym_BANG] = ACTIONS(2963),
    [anon_sym_else] = ACTIONS(2961),
    [anon_sym_if] = ACTIONS(2961),
    [anon_sym_switch] = ACTIONS(2961),
    [anon_sym_for] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(2963),
    [anon_sym_await] = ACTIONS(2961),
    [anon_sym_of] = ACTIONS(2961),
    [anon_sym_while] = ACTIONS(2961),
    [anon_sym_do] = ACTIONS(2961),
    [anon_sym_try] = ACTIONS(2961),
    [anon_sym_break] = ACTIONS(2961),
    [anon_sym_continue] = ACTIONS(2961),
    [anon_sym_debugger] = ACTIONS(2961),
    [anon_sym_return] = ACTIONS(2961),
    [anon_sym_throw] = ACTIONS(2961),
    [anon_sym_SEMI] = ACTIONS(2963),
    [anon_sym_case] = ACTIONS(2961),
    [anon_sym_yield] = ACTIONS(2961),
    [anon_sym_LBRACK] = ACTIONS(2963),
    [anon_sym_LTtemplate_GT] = ACTIONS(2963),
    [anon_sym_DQUOTE] = ACTIONS(2963),
    [anon_sym_SQUOTE] = ACTIONS(2963),
    [anon_sym_class] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(2961),
    [anon_sym_function] = ACTIONS(2961),
    [anon_sym_new] = ACTIONS(2961),
    [anon_sym_using] = ACTIONS(2961),
    [anon_sym_PLUS] = ACTIONS(2961),
    [anon_sym_DASH] = ACTIONS(2961),
    [anon_sym_SLASH] = ACTIONS(2961),
    [anon_sym_LT] = ACTIONS(2961),
    [anon_sym_TILDE] = ACTIONS(2963),
    [anon_sym_void] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2961),
    [anon_sym_PLUS_PLUS] = ACTIONS(2963),
    [anon_sym_DASH_DASH] = ACTIONS(2963),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2963),
    [sym_number] = ACTIONS(2963),
    [sym_private_property_identifier] = ACTIONS(2963),
    [sym_this] = ACTIONS(2961),
    [sym_super] = ACTIONS(2961),
    [sym_true] = ACTIONS(2961),
    [sym_false] = ACTIONS(2961),
    [sym_null] = ACTIONS(2961),
    [sym_undefined] = ACTIONS(2961),
    [anon_sym_AT] = ACTIONS(2963),
    [anon_sym_static] = ACTIONS(2961),
    [anon_sym_readonly] = ACTIONS(2961),
    [anon_sym_get] = ACTIONS(2961),
    [anon_sym_set] = ACTIONS(2961),
    [anon_sym_declare] = ACTIONS(2961),
    [anon_sym_public] = ACTIONS(2961),
    [anon_sym_private] = ACTIONS(2961),
    [anon_sym_protected] = ACTIONS(2961),
    [anon_sym_override] = ACTIONS(2961),
    [anon_sym_module] = ACTIONS(2961),
    [anon_sym_any] = ACTIONS(2961),
    [anon_sym_number] = ACTIONS(2961),
    [anon_sym_boolean] = ACTIONS(2961),
    [anon_sym_string] = ACTIONS(2961),
    [anon_sym_symbol] = ACTIONS(2961),
    [anon_sym_object] = ACTIONS(2961),
    [anon_sym_property] = ACTIONS(2961),
    [anon_sym_signal] = ACTIONS(2961),
    [anon_sym_on] = ACTIONS(2961),
    [anon_sym_required] = ACTIONS(2961),
    [anon_sym_component] = ACTIONS(2961),
    [anon_sym_abstract] = ACTIONS(2961),
    [anon_sym_interface] = ACTIONS(2961),
    [anon_sym_enum] = ACTIONS(2961),
    [sym_html_comment] = ACTIONS(5),
  },
  [884] = {
    [sym_comment] = STATE(884),
    [sym_identifier] = ACTIONS(2893),
    [anon_sym_export] = ACTIONS(2893),
    [anon_sym_default] = ACTIONS(2893),
    [anon_sym_type] = ACTIONS(2893),
    [anon_sym_namespace] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_RBRACE] = ACTIONS(2895),
    [anon_sym_typeof] = ACTIONS(2893),
    [anon_sym_import] = ACTIONS(2893),
    [anon_sym_from] = ACTIONS(2893),
    [anon_sym_with] = ACTIONS(2893),
    [anon_sym_var] = ACTIONS(2893),
    [anon_sym_let] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_BANG] = ACTIONS(2895),
    [anon_sym_else] = ACTIONS(2893),
    [anon_sym_if] = ACTIONS(2893),
    [anon_sym_switch] = ACTIONS(2893),
    [anon_sym_for] = ACTIONS(2893),
    [anon_sym_LPAREN] = ACTIONS(2895),
    [anon_sym_await] = ACTIONS(2893),
    [anon_sym_of] = ACTIONS(2893),
    [anon_sym_while] = ACTIONS(2893),
    [anon_sym_do] = ACTIONS(2893),
    [anon_sym_try] = ACTIONS(2893),
    [anon_sym_break] = ACTIONS(2893),
    [anon_sym_continue] = ACTIONS(2893),
    [anon_sym_debugger] = ACTIONS(2893),
    [anon_sym_return] = ACTIONS(2893),
    [anon_sym_throw] = ACTIONS(2893),
    [anon_sym_SEMI] = ACTIONS(2895),
    [anon_sym_case] = ACTIONS(2893),
    [anon_sym_yield] = ACTIONS(2893),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_LTtemplate_GT] = ACTIONS(2895),
    [anon_sym_DQUOTE] = ACTIONS(2895),
    [anon_sym_SQUOTE] = ACTIONS(2895),
    [anon_sym_class] = ACTIONS(2893),
    [anon_sym_async] = ACTIONS(2893),
    [anon_sym_function] = ACTIONS(2893),
    [anon_sym_new] = ACTIONS(2893),
    [anon_sym_using] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2893),
    [anon_sym_DASH] = ACTIONS(2893),
    [anon_sym_SLASH] = ACTIONS(2893),
    [anon_sym_LT] = ACTIONS(2893),
    [anon_sym_TILDE] = ACTIONS(2895),
    [anon_sym_void] = ACTIONS(2893),
    [anon_sym_delete] = ACTIONS(2893),
    [anon_sym_PLUS_PLUS] = ACTIONS(2895),
    [anon_sym_DASH_DASH] = ACTIONS(2895),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2895),
    [sym_number] = ACTIONS(2895),
    [sym_private_property_identifier] = ACTIONS(2895),
    [sym_this] = ACTIONS(2893),
    [sym_super] = ACTIONS(2893),
    [sym_true] = ACTIONS(2893),
    [sym_false] = ACTIONS(2893),
    [sym_null] = ACTIONS(2893),
    [sym_undefined] = ACTIONS(2893),
    [anon_sym_AT] = ACTIONS(2895),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_readonly] = ACTIONS(2893),
    [anon_sym_get] = ACTIONS(2893),
    [anon_sym_set] = ACTIONS(2893),
    [anon_sym_declare] = ACTIONS(2893),
    [anon_sym_public] = ACTIONS(2893),
    [anon_sym_private] = ACTIONS(2893),
    [anon_sym_protected] = ACTIONS(2893),
    [anon_sym_override] = ACTIONS(2893),
    [anon_sym_module] = ACTIONS(2893),
    [anon_sym_any] = ACTIONS(2893),
    [anon_sym_number] = ACTIONS(2893),
    [anon_sym_boolean] = ACTIONS(2893),
    [anon_sym_string] = ACTIONS(2893),
    [anon_sym_symbol] = ACTIONS(2893),
    [anon_sym_object] = ACTIONS(2893),
    [anon_sym_property] = ACTIONS(2893),
    [anon_sym_signal] = ACTIONS(2893),
    [anon_sym_on] = ACTIONS(2893),
    [anon_sym_required] = ACTIONS(2893),
    [anon_sym_component] = ACTIONS(2893),
    [anon_sym_abstract] = ACTIONS(2893),
    [anon_sym_interface] = ACTIONS(2893),
    [anon_sym_enum] = ACTIONS(2893),
    [sym_html_comment] = ACTIONS(5),
  },
  [885] = {
    [sym_comment] = STATE(885),
    [sym_identifier] = ACTIONS(2925),
    [anon_sym_export] = ACTIONS(2925),
    [anon_sym_default] = ACTIONS(2925),
    [anon_sym_type] = ACTIONS(2925),
    [anon_sym_namespace] = ACTIONS(2925),
    [anon_sym_LBRACE] = ACTIONS(2927),
    [anon_sym_RBRACE] = ACTIONS(2927),
    [anon_sym_typeof] = ACTIONS(2925),
    [anon_sym_import] = ACTIONS(2925),
    [anon_sym_from] = ACTIONS(2925),
    [anon_sym_with] = ACTIONS(2925),
    [anon_sym_var] = ACTIONS(2925),
    [anon_sym_let] = ACTIONS(2925),
    [anon_sym_const] = ACTIONS(2925),
    [anon_sym_BANG] = ACTIONS(2927),
    [anon_sym_else] = ACTIONS(2925),
    [anon_sym_if] = ACTIONS(2925),
    [anon_sym_switch] = ACTIONS(2925),
    [anon_sym_for] = ACTIONS(2925),
    [anon_sym_LPAREN] = ACTIONS(2927),
    [anon_sym_await] = ACTIONS(2925),
    [anon_sym_of] = ACTIONS(2925),
    [anon_sym_while] = ACTIONS(2925),
    [anon_sym_do] = ACTIONS(2925),
    [anon_sym_try] = ACTIONS(2925),
    [anon_sym_break] = ACTIONS(2925),
    [anon_sym_continue] = ACTIONS(2925),
    [anon_sym_debugger] = ACTIONS(2925),
    [anon_sym_return] = ACTIONS(2925),
    [anon_sym_throw] = ACTIONS(2925),
    [anon_sym_SEMI] = ACTIONS(2927),
    [anon_sym_case] = ACTIONS(2925),
    [anon_sym_yield] = ACTIONS(2925),
    [anon_sym_LBRACK] = ACTIONS(2927),
    [anon_sym_LTtemplate_GT] = ACTIONS(2927),
    [anon_sym_DQUOTE] = ACTIONS(2927),
    [anon_sym_SQUOTE] = ACTIONS(2927),
    [anon_sym_class] = ACTIONS(2925),
    [anon_sym_async] = ACTIONS(2925),
    [anon_sym_function] = ACTIONS(2925),
    [anon_sym_new] = ACTIONS(2925),
    [anon_sym_using] = ACTIONS(2925),
    [anon_sym_PLUS] = ACTIONS(2925),
    [anon_sym_DASH] = ACTIONS(2925),
    [anon_sym_SLASH] = ACTIONS(2925),
    [anon_sym_LT] = ACTIONS(2925),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_void] = ACTIONS(2925),
    [anon_sym_delete] = ACTIONS(2925),
    [anon_sym_PLUS_PLUS] = ACTIONS(2927),
    [anon_sym_DASH_DASH] = ACTIONS(2927),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2927),
    [sym_number] = ACTIONS(2927),
    [sym_private_property_identifier] = ACTIONS(2927),
    [sym_this] = ACTIONS(2925),
    [sym_super] = ACTIONS(2925),
    [sym_true] = ACTIONS(2925),
    [sym_false] = ACTIONS(2925),
    [sym_null] = ACTIONS(2925),
    [sym_undefined] = ACTIONS(2925),
    [anon_sym_AT] = ACTIONS(2927),
    [anon_sym_static] = ACTIONS(2925),
    [anon_sym_readonly] = ACTIONS(2925),
    [anon_sym_get] = ACTIONS(2925),
    [anon_sym_set] = ACTIONS(2925),
    [anon_sym_declare] = ACTIONS(2925),
    [anon_sym_public] = ACTIONS(2925),
    [anon_sym_private] = ACTIONS(2925),
    [anon_sym_protected] = ACTIONS(2925),
    [anon_sym_override] = ACTIONS(2925),
    [anon_sym_module] = ACTIONS(2925),
    [anon_sym_any] = ACTIONS(2925),
    [anon_sym_number] = ACTIONS(2925),
    [anon_sym_boolean] = ACTIONS(2925),
    [anon_sym_string] = ACTIONS(2925),
    [anon_sym_symbol] = ACTIONS(2925),
    [anon_sym_object] = ACTIONS(2925),
    [anon_sym_property] = ACTIONS(2925),
    [anon_sym_signal] = ACTIONS(2925),
    [anon_sym_on] = ACTIONS(2925),
    [anon_sym_required] = ACTIONS(2925),
    [anon_sym_component] = ACTIONS(2925),
    [anon_sym_abstract] = ACTIONS(2925),
    [anon_sym_interface] = ACTIONS(2925),
    [anon_sym_enum] = ACTIONS(2925),
    [sym_html_comment] = ACTIONS(5),
  },
  [886] = {
    [sym_comment] = STATE(886),
    [sym_identifier] = ACTIONS(2965),
    [anon_sym_export] = ACTIONS(2965),
    [anon_sym_default] = ACTIONS(2965),
    [anon_sym_type] = ACTIONS(2965),
    [anon_sym_namespace] = ACTIONS(2965),
    [anon_sym_LBRACE] = ACTIONS(2967),
    [anon_sym_RBRACE] = ACTIONS(2967),
    [anon_sym_typeof] = ACTIONS(2965),
    [anon_sym_import] = ACTIONS(2965),
    [anon_sym_from] = ACTIONS(2965),
    [anon_sym_with] = ACTIONS(2965),
    [anon_sym_var] = ACTIONS(2965),
    [anon_sym_let] = ACTIONS(2965),
    [anon_sym_const] = ACTIONS(2965),
    [anon_sym_BANG] = ACTIONS(2967),
    [anon_sym_else] = ACTIONS(2965),
    [anon_sym_if] = ACTIONS(2965),
    [anon_sym_switch] = ACTIONS(2965),
    [anon_sym_for] = ACTIONS(2965),
    [anon_sym_LPAREN] = ACTIONS(2967),
    [anon_sym_await] = ACTIONS(2965),
    [anon_sym_of] = ACTIONS(2965),
    [anon_sym_while] = ACTIONS(2965),
    [anon_sym_do] = ACTIONS(2965),
    [anon_sym_try] = ACTIONS(2965),
    [anon_sym_break] = ACTIONS(2965),
    [anon_sym_continue] = ACTIONS(2965),
    [anon_sym_debugger] = ACTIONS(2965),
    [anon_sym_return] = ACTIONS(2965),
    [anon_sym_throw] = ACTIONS(2965),
    [anon_sym_SEMI] = ACTIONS(2967),
    [anon_sym_case] = ACTIONS(2965),
    [anon_sym_yield] = ACTIONS(2965),
    [anon_sym_LBRACK] = ACTIONS(2967),
    [anon_sym_LTtemplate_GT] = ACTIONS(2967),
    [anon_sym_DQUOTE] = ACTIONS(2967),
    [anon_sym_SQUOTE] = ACTIONS(2967),
    [anon_sym_class] = ACTIONS(2965),
    [anon_sym_async] = ACTIONS(2965),
    [anon_sym_function] = ACTIONS(2965),
    [anon_sym_new] = ACTIONS(2965),
    [anon_sym_using] = ACTIONS(2965),
    [anon_sym_PLUS] = ACTIONS(2965),
    [anon_sym_DASH] = ACTIONS(2965),
    [anon_sym_SLASH] = ACTIONS(2965),
    [anon_sym_LT] = ACTIONS(2965),
    [anon_sym_TILDE] = ACTIONS(2967),
    [anon_sym_void] = ACTIONS(2965),
    [anon_sym_delete] = ACTIONS(2965),
    [anon_sym_PLUS_PLUS] = ACTIONS(2967),
    [anon_sym_DASH_DASH] = ACTIONS(2967),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2967),
    [sym_number] = ACTIONS(2967),
    [sym_private_property_identifier] = ACTIONS(2967),
    [sym_this] = ACTIONS(2965),
    [sym_super] = ACTIONS(2965),
    [sym_true] = ACTIONS(2965),
    [sym_false] = ACTIONS(2965),
    [sym_null] = ACTIONS(2965),
    [sym_undefined] = ACTIONS(2965),
    [anon_sym_AT] = ACTIONS(2967),
    [anon_sym_static] = ACTIONS(2965),
    [anon_sym_readonly] = ACTIONS(2965),
    [anon_sym_get] = ACTIONS(2965),
    [anon_sym_set] = ACTIONS(2965),
    [anon_sym_declare] = ACTIONS(2965),
    [anon_sym_public] = ACTIONS(2965),
    [anon_sym_private] = ACTIONS(2965),
    [anon_sym_protected] = ACTIONS(2965),
    [anon_sym_override] = ACTIONS(2965),
    [anon_sym_module] = ACTIONS(2965),
    [anon_sym_any] = ACTIONS(2965),
    [anon_sym_number] = ACTIONS(2965),
    [anon_sym_boolean] = ACTIONS(2965),
    [anon_sym_string] = ACTIONS(2965),
    [anon_sym_symbol] = ACTIONS(2965),
    [anon_sym_object] = ACTIONS(2965),
    [anon_sym_property] = ACTIONS(2965),
    [anon_sym_signal] = ACTIONS(2965),
    [anon_sym_on] = ACTIONS(2965),
    [anon_sym_required] = ACTIONS(2965),
    [anon_sym_component] = ACTIONS(2965),
    [anon_sym_abstract] = ACTIONS(2965),
    [anon_sym_interface] = ACTIONS(2965),
    [anon_sym_enum] = ACTIONS(2965),
    [sym_html_comment] = ACTIONS(5),
  },
  [887] = {
    [sym_comment] = STATE(887),
    [sym_identifier] = ACTIONS(2969),
    [anon_sym_export] = ACTIONS(2969),
    [anon_sym_default] = ACTIONS(2969),
    [anon_sym_type] = ACTIONS(2969),
    [anon_sym_namespace] = ACTIONS(2969),
    [anon_sym_LBRACE] = ACTIONS(2971),
    [anon_sym_RBRACE] = ACTIONS(2971),
    [anon_sym_typeof] = ACTIONS(2969),
    [anon_sym_import] = ACTIONS(2969),
    [anon_sym_from] = ACTIONS(2969),
    [anon_sym_with] = ACTIONS(2969),
    [anon_sym_var] = ACTIONS(2969),
    [anon_sym_let] = ACTIONS(2969),
    [anon_sym_const] = ACTIONS(2969),
    [anon_sym_BANG] = ACTIONS(2971),
    [anon_sym_else] = ACTIONS(2969),
    [anon_sym_if] = ACTIONS(2969),
    [anon_sym_switch] = ACTIONS(2969),
    [anon_sym_for] = ACTIONS(2969),
    [anon_sym_LPAREN] = ACTIONS(2971),
    [anon_sym_await] = ACTIONS(2969),
    [anon_sym_of] = ACTIONS(2969),
    [anon_sym_while] = ACTIONS(2969),
    [anon_sym_do] = ACTIONS(2969),
    [anon_sym_try] = ACTIONS(2969),
    [anon_sym_break] = ACTIONS(2969),
    [anon_sym_continue] = ACTIONS(2969),
    [anon_sym_debugger] = ACTIONS(2969),
    [anon_sym_return] = ACTIONS(2969),
    [anon_sym_throw] = ACTIONS(2969),
    [anon_sym_SEMI] = ACTIONS(2971),
    [anon_sym_case] = ACTIONS(2969),
    [anon_sym_yield] = ACTIONS(2969),
    [anon_sym_LBRACK] = ACTIONS(2971),
    [anon_sym_LTtemplate_GT] = ACTIONS(2971),
    [anon_sym_DQUOTE] = ACTIONS(2971),
    [anon_sym_SQUOTE] = ACTIONS(2971),
    [anon_sym_class] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(2969),
    [anon_sym_function] = ACTIONS(2969),
    [anon_sym_new] = ACTIONS(2969),
    [anon_sym_using] = ACTIONS(2969),
    [anon_sym_PLUS] = ACTIONS(2969),
    [anon_sym_DASH] = ACTIONS(2969),
    [anon_sym_SLASH] = ACTIONS(2969),
    [anon_sym_LT] = ACTIONS(2969),
    [anon_sym_TILDE] = ACTIONS(2971),
    [anon_sym_void] = ACTIONS(2969),
    [anon_sym_delete] = ACTIONS(2969),
    [anon_sym_PLUS_PLUS] = ACTIONS(2971),
    [anon_sym_DASH_DASH] = ACTIONS(2971),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2971),
    [sym_number] = ACTIONS(2971),
    [sym_private_property_identifier] = ACTIONS(2971),
    [sym_this] = ACTIONS(2969),
    [sym_super] = ACTIONS(2969),
    [sym_true] = ACTIONS(2969),
    [sym_false] = ACTIONS(2969),
    [sym_null] = ACTIONS(2969),
    [sym_undefined] = ACTIONS(2969),
    [anon_sym_AT] = ACTIONS(2971),
    [anon_sym_static] = ACTIONS(2969),
    [anon_sym_readonly] = ACTIONS(2969),
    [anon_sym_get] = ACTIONS(2969),
    [anon_sym_set] = ACTIONS(2969),
    [anon_sym_declare] = ACTIONS(2969),
    [anon_sym_public] = ACTIONS(2969),
    [anon_sym_private] = ACTIONS(2969),
    [anon_sym_protected] = ACTIONS(2969),
    [anon_sym_override] = ACTIONS(2969),
    [anon_sym_module] = ACTIONS(2969),
    [anon_sym_any] = ACTIONS(2969),
    [anon_sym_number] = ACTIONS(2969),
    [anon_sym_boolean] = ACTIONS(2969),
    [anon_sym_string] = ACTIONS(2969),
    [anon_sym_symbol] = ACTIONS(2969),
    [anon_sym_object] = ACTIONS(2969),
    [anon_sym_property] = ACTIONS(2969),
    [anon_sym_signal] = ACTIONS(2969),
    [anon_sym_on] = ACTIONS(2969),
    [anon_sym_required] = ACTIONS(2969),
    [anon_sym_component] = ACTIONS(2969),
    [anon_sym_abstract] = ACTIONS(2969),
    [anon_sym_interface] = ACTIONS(2969),
    [anon_sym_enum] = ACTIONS(2969),
    [sym_html_comment] = ACTIONS(5),
  },
  [888] = {
    [sym_comment] = STATE(888),
    [sym_identifier] = ACTIONS(2973),
    [anon_sym_export] = ACTIONS(2973),
    [anon_sym_default] = ACTIONS(2973),
    [anon_sym_type] = ACTIONS(2973),
    [anon_sym_namespace] = ACTIONS(2973),
    [anon_sym_LBRACE] = ACTIONS(2975),
    [anon_sym_RBRACE] = ACTIONS(2975),
    [anon_sym_typeof] = ACTIONS(2973),
    [anon_sym_import] = ACTIONS(2973),
    [anon_sym_from] = ACTIONS(2973),
    [anon_sym_with] = ACTIONS(2973),
    [anon_sym_var] = ACTIONS(2973),
    [anon_sym_let] = ACTIONS(2973),
    [anon_sym_const] = ACTIONS(2973),
    [anon_sym_BANG] = ACTIONS(2975),
    [anon_sym_else] = ACTIONS(2973),
    [anon_sym_if] = ACTIONS(2973),
    [anon_sym_switch] = ACTIONS(2973),
    [anon_sym_for] = ACTIONS(2973),
    [anon_sym_LPAREN] = ACTIONS(2975),
    [anon_sym_await] = ACTIONS(2973),
    [anon_sym_of] = ACTIONS(2973),
    [anon_sym_while] = ACTIONS(2973),
    [anon_sym_do] = ACTIONS(2973),
    [anon_sym_try] = ACTIONS(2973),
    [anon_sym_break] = ACTIONS(2973),
    [anon_sym_continue] = ACTIONS(2973),
    [anon_sym_debugger] = ACTIONS(2973),
    [anon_sym_return] = ACTIONS(2973),
    [anon_sym_throw] = ACTIONS(2973),
    [anon_sym_SEMI] = ACTIONS(2975),
    [anon_sym_case] = ACTIONS(2973),
    [anon_sym_yield] = ACTIONS(2973),
    [anon_sym_LBRACK] = ACTIONS(2975),
    [anon_sym_LTtemplate_GT] = ACTIONS(2975),
    [anon_sym_DQUOTE] = ACTIONS(2975),
    [anon_sym_SQUOTE] = ACTIONS(2975),
    [anon_sym_class] = ACTIONS(2973),
    [anon_sym_async] = ACTIONS(2973),
    [anon_sym_function] = ACTIONS(2973),
    [anon_sym_new] = ACTIONS(2973),
    [anon_sym_using] = ACTIONS(2973),
    [anon_sym_PLUS] = ACTIONS(2973),
    [anon_sym_DASH] = ACTIONS(2973),
    [anon_sym_SLASH] = ACTIONS(2973),
    [anon_sym_LT] = ACTIONS(2973),
    [anon_sym_TILDE] = ACTIONS(2975),
    [anon_sym_void] = ACTIONS(2973),
    [anon_sym_delete] = ACTIONS(2973),
    [anon_sym_PLUS_PLUS] = ACTIONS(2975),
    [anon_sym_DASH_DASH] = ACTIONS(2975),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2975),
    [sym_number] = ACTIONS(2975),
    [sym_private_property_identifier] = ACTIONS(2975),
    [sym_this] = ACTIONS(2973),
    [sym_super] = ACTIONS(2973),
    [sym_true] = ACTIONS(2973),
    [sym_false] = ACTIONS(2973),
    [sym_null] = ACTIONS(2973),
    [sym_undefined] = ACTIONS(2973),
    [anon_sym_AT] = ACTIONS(2975),
    [anon_sym_static] = ACTIONS(2973),
    [anon_sym_readonly] = ACTIONS(2973),
    [anon_sym_get] = ACTIONS(2973),
    [anon_sym_set] = ACTIONS(2973),
    [anon_sym_declare] = ACTIONS(2973),
    [anon_sym_public] = ACTIONS(2973),
    [anon_sym_private] = ACTIONS(2973),
    [anon_sym_protected] = ACTIONS(2973),
    [anon_sym_override] = ACTIONS(2973),
    [anon_sym_module] = ACTIONS(2973),
    [anon_sym_any] = ACTIONS(2973),
    [anon_sym_number] = ACTIONS(2973),
    [anon_sym_boolean] = ACTIONS(2973),
    [anon_sym_string] = ACTIONS(2973),
    [anon_sym_symbol] = ACTIONS(2973),
    [anon_sym_object] = ACTIONS(2973),
    [anon_sym_property] = ACTIONS(2973),
    [anon_sym_signal] = ACTIONS(2973),
    [anon_sym_on] = ACTIONS(2973),
    [anon_sym_required] = ACTIONS(2973),
    [anon_sym_component] = ACTIONS(2973),
    [anon_sym_abstract] = ACTIONS(2973),
    [anon_sym_interface] = ACTIONS(2973),
    [anon_sym_enum] = ACTIONS(2973),
    [sym_html_comment] = ACTIONS(5),
  },
  [889] = {
    [sym_comment] = STATE(889),
    [sym_identifier] = ACTIONS(1926),
    [anon_sym_export] = ACTIONS(1926),
    [anon_sym_default] = ACTIONS(1926),
    [anon_sym_type] = ACTIONS(1926),
    [anon_sym_namespace] = ACTIONS(1926),
    [anon_sym_LBRACE] = ACTIONS(1928),
    [anon_sym_RBRACE] = ACTIONS(1928),
    [anon_sym_typeof] = ACTIONS(1926),
    [anon_sym_import] = ACTIONS(1926),
    [anon_sym_from] = ACTIONS(1926),
    [anon_sym_with] = ACTIONS(1926),
    [anon_sym_var] = ACTIONS(1926),
    [anon_sym_let] = ACTIONS(1926),
    [anon_sym_const] = ACTIONS(1926),
    [anon_sym_BANG] = ACTIONS(1928),
    [anon_sym_else] = ACTIONS(1926),
    [anon_sym_if] = ACTIONS(1926),
    [anon_sym_switch] = ACTIONS(1926),
    [anon_sym_for] = ACTIONS(1926),
    [anon_sym_LPAREN] = ACTIONS(1928),
    [anon_sym_await] = ACTIONS(1926),
    [anon_sym_of] = ACTIONS(1926),
    [anon_sym_while] = ACTIONS(1926),
    [anon_sym_do] = ACTIONS(1926),
    [anon_sym_try] = ACTIONS(1926),
    [anon_sym_break] = ACTIONS(1926),
    [anon_sym_continue] = ACTIONS(1926),
    [anon_sym_debugger] = ACTIONS(1926),
    [anon_sym_return] = ACTIONS(1926),
    [anon_sym_throw] = ACTIONS(1926),
    [anon_sym_SEMI] = ACTIONS(1928),
    [anon_sym_case] = ACTIONS(1926),
    [anon_sym_yield] = ACTIONS(1926),
    [anon_sym_LBRACK] = ACTIONS(1928),
    [anon_sym_LTtemplate_GT] = ACTIONS(1928),
    [anon_sym_DQUOTE] = ACTIONS(1928),
    [anon_sym_SQUOTE] = ACTIONS(1928),
    [anon_sym_class] = ACTIONS(1926),
    [anon_sym_async] = ACTIONS(1926),
    [anon_sym_function] = ACTIONS(1926),
    [anon_sym_new] = ACTIONS(1926),
    [anon_sym_using] = ACTIONS(1926),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_SLASH] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1928),
    [anon_sym_void] = ACTIONS(1926),
    [anon_sym_delete] = ACTIONS(1926),
    [anon_sym_PLUS_PLUS] = ACTIONS(1928),
    [anon_sym_DASH_DASH] = ACTIONS(1928),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [sym_number] = ACTIONS(1928),
    [sym_private_property_identifier] = ACTIONS(1928),
    [sym_this] = ACTIONS(1926),
    [sym_super] = ACTIONS(1926),
    [sym_true] = ACTIONS(1926),
    [sym_false] = ACTIONS(1926),
    [sym_null] = ACTIONS(1926),
    [sym_undefined] = ACTIONS(1926),
    [anon_sym_AT] = ACTIONS(1928),
    [anon_sym_static] = ACTIONS(1926),
    [anon_sym_readonly] = ACTIONS(1926),
    [anon_sym_get] = ACTIONS(1926),
    [anon_sym_set] = ACTIONS(1926),
    [anon_sym_declare] = ACTIONS(1926),
    [anon_sym_public] = ACTIONS(1926),
    [anon_sym_private] = ACTIONS(1926),
    [anon_sym_protected] = ACTIONS(1926),
    [anon_sym_override] = ACTIONS(1926),
    [anon_sym_module] = ACTIONS(1926),
    [anon_sym_any] = ACTIONS(1926),
    [anon_sym_number] = ACTIONS(1926),
    [anon_sym_boolean] = ACTIONS(1926),
    [anon_sym_string] = ACTIONS(1926),
    [anon_sym_symbol] = ACTIONS(1926),
    [anon_sym_object] = ACTIONS(1926),
    [anon_sym_property] = ACTIONS(1926),
    [anon_sym_signal] = ACTIONS(1926),
    [anon_sym_on] = ACTIONS(1926),
    [anon_sym_required] = ACTIONS(1926),
    [anon_sym_component] = ACTIONS(1926),
    [anon_sym_abstract] = ACTIONS(1926),
    [anon_sym_interface] = ACTIONS(1926),
    [anon_sym_enum] = ACTIONS(1926),
    [sym_html_comment] = ACTIONS(5),
  },
  [890] = {
    [sym_comment] = STATE(890),
    [sym_identifier] = ACTIONS(2977),
    [anon_sym_export] = ACTIONS(2977),
    [anon_sym_default] = ACTIONS(2977),
    [anon_sym_type] = ACTIONS(2977),
    [anon_sym_namespace] = ACTIONS(2977),
    [anon_sym_LBRACE] = ACTIONS(2979),
    [anon_sym_RBRACE] = ACTIONS(2979),
    [anon_sym_typeof] = ACTIONS(2977),
    [anon_sym_import] = ACTIONS(2977),
    [anon_sym_from] = ACTIONS(2977),
    [anon_sym_with] = ACTIONS(2977),
    [anon_sym_var] = ACTIONS(2977),
    [anon_sym_let] = ACTIONS(2977),
    [anon_sym_const] = ACTIONS(2977),
    [anon_sym_BANG] = ACTIONS(2979),
    [anon_sym_else] = ACTIONS(2977),
    [anon_sym_if] = ACTIONS(2977),
    [anon_sym_switch] = ACTIONS(2977),
    [anon_sym_for] = ACTIONS(2977),
    [anon_sym_LPAREN] = ACTIONS(2979),
    [anon_sym_await] = ACTIONS(2977),
    [anon_sym_of] = ACTIONS(2977),
    [anon_sym_while] = ACTIONS(2977),
    [anon_sym_do] = ACTIONS(2977),
    [anon_sym_try] = ACTIONS(2977),
    [anon_sym_break] = ACTIONS(2977),
    [anon_sym_continue] = ACTIONS(2977),
    [anon_sym_debugger] = ACTIONS(2977),
    [anon_sym_return] = ACTIONS(2977),
    [anon_sym_throw] = ACTIONS(2977),
    [anon_sym_SEMI] = ACTIONS(2979),
    [anon_sym_case] = ACTIONS(2977),
    [anon_sym_yield] = ACTIONS(2977),
    [anon_sym_LBRACK] = ACTIONS(2979),
    [anon_sym_LTtemplate_GT] = ACTIONS(2979),
    [anon_sym_DQUOTE] = ACTIONS(2979),
    [anon_sym_SQUOTE] = ACTIONS(2979),
    [anon_sym_class] = ACTIONS(2977),
    [anon_sym_async] = ACTIONS(2977),
    [anon_sym_function] = ACTIONS(2977),
    [anon_sym_new] = ACTIONS(2977),
    [anon_sym_using] = ACTIONS(2977),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_SLASH] = ACTIONS(2977),
    [anon_sym_LT] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_void] = ACTIONS(2977),
    [anon_sym_delete] = ACTIONS(2977),
    [anon_sym_PLUS_PLUS] = ACTIONS(2979),
    [anon_sym_DASH_DASH] = ACTIONS(2979),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2979),
    [sym_number] = ACTIONS(2979),
    [sym_private_property_identifier] = ACTIONS(2979),
    [sym_this] = ACTIONS(2977),
    [sym_super] = ACTIONS(2977),
    [sym_true] = ACTIONS(2977),
    [sym_false] = ACTIONS(2977),
    [sym_null] = ACTIONS(2977),
    [sym_undefined] = ACTIONS(2977),
    [anon_sym_AT] = ACTIONS(2979),
    [anon_sym_static] = ACTIONS(2977),
    [anon_sym_readonly] = ACTIONS(2977),
    [anon_sym_get] = ACTIONS(2977),
    [anon_sym_set] = ACTIONS(2977),
    [anon_sym_declare] = ACTIONS(2977),
    [anon_sym_public] = ACTIONS(2977),
    [anon_sym_private] = ACTIONS(2977),
    [anon_sym_protected] = ACTIONS(2977),
    [anon_sym_override] = ACTIONS(2977),
    [anon_sym_module] = ACTIONS(2977),
    [anon_sym_any] = ACTIONS(2977),
    [anon_sym_number] = ACTIONS(2977),
    [anon_sym_boolean] = ACTIONS(2977),
    [anon_sym_string] = ACTIONS(2977),
    [anon_sym_symbol] = ACTIONS(2977),
    [anon_sym_object] = ACTIONS(2977),
    [anon_sym_property] = ACTIONS(2977),
    [anon_sym_signal] = ACTIONS(2977),
    [anon_sym_on] = ACTIONS(2977),
    [anon_sym_required] = ACTIONS(2977),
    [anon_sym_component] = ACTIONS(2977),
    [anon_sym_abstract] = ACTIONS(2977),
    [anon_sym_interface] = ACTIONS(2977),
    [anon_sym_enum] = ACTIONS(2977),
    [sym_html_comment] = ACTIONS(5),
  },
  [891] = {
    [sym_comment] = STATE(891),
    [sym_identifier] = ACTIONS(2981),
    [anon_sym_export] = ACTIONS(2981),
    [anon_sym_default] = ACTIONS(2981),
    [anon_sym_type] = ACTIONS(2981),
    [anon_sym_namespace] = ACTIONS(2981),
    [anon_sym_LBRACE] = ACTIONS(2983),
    [anon_sym_RBRACE] = ACTIONS(2983),
    [anon_sym_typeof] = ACTIONS(2981),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_from] = ACTIONS(2981),
    [anon_sym_with] = ACTIONS(2981),
    [anon_sym_var] = ACTIONS(2981),
    [anon_sym_let] = ACTIONS(2981),
    [anon_sym_const] = ACTIONS(2981),
    [anon_sym_BANG] = ACTIONS(2983),
    [anon_sym_else] = ACTIONS(2981),
    [anon_sym_if] = ACTIONS(2981),
    [anon_sym_switch] = ACTIONS(2981),
    [anon_sym_for] = ACTIONS(2981),
    [anon_sym_LPAREN] = ACTIONS(2983),
    [anon_sym_await] = ACTIONS(2981),
    [anon_sym_of] = ACTIONS(2981),
    [anon_sym_while] = ACTIONS(2981),
    [anon_sym_do] = ACTIONS(2981),
    [anon_sym_try] = ACTIONS(2981),
    [anon_sym_break] = ACTIONS(2981),
    [anon_sym_continue] = ACTIONS(2981),
    [anon_sym_debugger] = ACTIONS(2981),
    [anon_sym_return] = ACTIONS(2981),
    [anon_sym_throw] = ACTIONS(2981),
    [anon_sym_SEMI] = ACTIONS(2983),
    [anon_sym_case] = ACTIONS(2981),
    [anon_sym_yield] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(2983),
    [anon_sym_LTtemplate_GT] = ACTIONS(2983),
    [anon_sym_DQUOTE] = ACTIONS(2983),
    [anon_sym_SQUOTE] = ACTIONS(2983),
    [anon_sym_class] = ACTIONS(2981),
    [anon_sym_async] = ACTIONS(2981),
    [anon_sym_function] = ACTIONS(2981),
    [anon_sym_new] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_PLUS] = ACTIONS(2981),
    [anon_sym_DASH] = ACTIONS(2981),
    [anon_sym_SLASH] = ACTIONS(2981),
    [anon_sym_LT] = ACTIONS(2981),
    [anon_sym_TILDE] = ACTIONS(2983),
    [anon_sym_void] = ACTIONS(2981),
    [anon_sym_delete] = ACTIONS(2981),
    [anon_sym_PLUS_PLUS] = ACTIONS(2983),
    [anon_sym_DASH_DASH] = ACTIONS(2983),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2983),
    [sym_number] = ACTIONS(2983),
    [sym_private_property_identifier] = ACTIONS(2983),
    [sym_this] = ACTIONS(2981),
    [sym_super] = ACTIONS(2981),
    [sym_true] = ACTIONS(2981),
    [sym_false] = ACTIONS(2981),
    [sym_null] = ACTIONS(2981),
    [sym_undefined] = ACTIONS(2981),
    [anon_sym_AT] = ACTIONS(2983),
    [anon_sym_static] = ACTIONS(2981),
    [anon_sym_readonly] = ACTIONS(2981),
    [anon_sym_get] = ACTIONS(2981),
    [anon_sym_set] = ACTIONS(2981),
    [anon_sym_declare] = ACTIONS(2981),
    [anon_sym_public] = ACTIONS(2981),
    [anon_sym_private] = ACTIONS(2981),
    [anon_sym_protected] = ACTIONS(2981),
    [anon_sym_override] = ACTIONS(2981),
    [anon_sym_module] = ACTIONS(2981),
    [anon_sym_any] = ACTIONS(2981),
    [anon_sym_number] = ACTIONS(2981),
    [anon_sym_boolean] = ACTIONS(2981),
    [anon_sym_string] = ACTIONS(2981),
    [anon_sym_symbol] = ACTIONS(2981),
    [anon_sym_object] = ACTIONS(2981),
    [anon_sym_property] = ACTIONS(2981),
    [anon_sym_signal] = ACTIONS(2981),
    [anon_sym_on] = ACTIONS(2981),
    [anon_sym_required] = ACTIONS(2981),
    [anon_sym_component] = ACTIONS(2981),
    [anon_sym_abstract] = ACTIONS(2981),
    [anon_sym_interface] = ACTIONS(2981),
    [anon_sym_enum] = ACTIONS(2981),
    [sym_html_comment] = ACTIONS(5),
  },
  [892] = {
    [sym_comment] = STATE(892),
    [sym_identifier] = ACTIONS(2985),
    [anon_sym_export] = ACTIONS(2985),
    [anon_sym_default] = ACTIONS(2985),
    [anon_sym_type] = ACTIONS(2985),
    [anon_sym_namespace] = ACTIONS(2985),
    [anon_sym_LBRACE] = ACTIONS(2987),
    [anon_sym_RBRACE] = ACTIONS(2987),
    [anon_sym_typeof] = ACTIONS(2985),
    [anon_sym_import] = ACTIONS(2985),
    [anon_sym_from] = ACTIONS(2985),
    [anon_sym_with] = ACTIONS(2985),
    [anon_sym_var] = ACTIONS(2985),
    [anon_sym_let] = ACTIONS(2985),
    [anon_sym_const] = ACTIONS(2985),
    [anon_sym_BANG] = ACTIONS(2987),
    [anon_sym_else] = ACTIONS(2985),
    [anon_sym_if] = ACTIONS(2985),
    [anon_sym_switch] = ACTIONS(2985),
    [anon_sym_for] = ACTIONS(2985),
    [anon_sym_LPAREN] = ACTIONS(2987),
    [anon_sym_await] = ACTIONS(2985),
    [anon_sym_of] = ACTIONS(2985),
    [anon_sym_while] = ACTIONS(2985),
    [anon_sym_do] = ACTIONS(2985),
    [anon_sym_try] = ACTIONS(2985),
    [anon_sym_break] = ACTIONS(2985),
    [anon_sym_continue] = ACTIONS(2985),
    [anon_sym_debugger] = ACTIONS(2985),
    [anon_sym_return] = ACTIONS(2985),
    [anon_sym_throw] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(2987),
    [anon_sym_case] = ACTIONS(2985),
    [anon_sym_yield] = ACTIONS(2985),
    [anon_sym_LBRACK] = ACTIONS(2987),
    [anon_sym_LTtemplate_GT] = ACTIONS(2987),
    [anon_sym_DQUOTE] = ACTIONS(2987),
    [anon_sym_SQUOTE] = ACTIONS(2987),
    [anon_sym_class] = ACTIONS(2985),
    [anon_sym_async] = ACTIONS(2985),
    [anon_sym_function] = ACTIONS(2985),
    [anon_sym_new] = ACTIONS(2985),
    [anon_sym_using] = ACTIONS(2985),
    [anon_sym_PLUS] = ACTIONS(2985),
    [anon_sym_DASH] = ACTIONS(2985),
    [anon_sym_SLASH] = ACTIONS(2985),
    [anon_sym_LT] = ACTIONS(2985),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_void] = ACTIONS(2985),
    [anon_sym_delete] = ACTIONS(2985),
    [anon_sym_PLUS_PLUS] = ACTIONS(2987),
    [anon_sym_DASH_DASH] = ACTIONS(2987),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2987),
    [sym_number] = ACTIONS(2987),
    [sym_private_property_identifier] = ACTIONS(2987),
    [sym_this] = ACTIONS(2985),
    [sym_super] = ACTIONS(2985),
    [sym_true] = ACTIONS(2985),
    [sym_false] = ACTIONS(2985),
    [sym_null] = ACTIONS(2985),
    [sym_undefined] = ACTIONS(2985),
    [anon_sym_AT] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(2985),
    [anon_sym_readonly] = ACTIONS(2985),
    [anon_sym_get] = ACTIONS(2985),
    [anon_sym_set] = ACTIONS(2985),
    [anon_sym_declare] = ACTIONS(2985),
    [anon_sym_public] = ACTIONS(2985),
    [anon_sym_private] = ACTIONS(2985),
    [anon_sym_protected] = ACTIONS(2985),
    [anon_sym_override] = ACTIONS(2985),
    [anon_sym_module] = ACTIONS(2985),
    [anon_sym_any] = ACTIONS(2985),
    [anon_sym_number] = ACTIONS(2985),
    [anon_sym_boolean] = ACTIONS(2985),
    [anon_sym_string] = ACTIONS(2985),
    [anon_sym_symbol] = ACTIONS(2985),
    [anon_sym_object] = ACTIONS(2985),
    [anon_sym_property] = ACTIONS(2985),
    [anon_sym_signal] = ACTIONS(2985),
    [anon_sym_on] = ACTIONS(2985),
    [anon_sym_required] = ACTIONS(2985),
    [anon_sym_component] = ACTIONS(2985),
    [anon_sym_abstract] = ACTIONS(2985),
    [anon_sym_interface] = ACTIONS(2985),
    [anon_sym_enum] = ACTIONS(2985),
    [sym_html_comment] = ACTIONS(5),
  },
  [893] = {
    [sym_comment] = STATE(893),
    [sym_identifier] = ACTIONS(2989),
    [anon_sym_export] = ACTIONS(2989),
    [anon_sym_default] = ACTIONS(2989),
    [anon_sym_type] = ACTIONS(2989),
    [anon_sym_namespace] = ACTIONS(2989),
    [anon_sym_LBRACE] = ACTIONS(2991),
    [anon_sym_RBRACE] = ACTIONS(2991),
    [anon_sym_typeof] = ACTIONS(2989),
    [anon_sym_import] = ACTIONS(2989),
    [anon_sym_from] = ACTIONS(2989),
    [anon_sym_with] = ACTIONS(2989),
    [anon_sym_var] = ACTIONS(2989),
    [anon_sym_let] = ACTIONS(2989),
    [anon_sym_const] = ACTIONS(2989),
    [anon_sym_BANG] = ACTIONS(2991),
    [anon_sym_else] = ACTIONS(2989),
    [anon_sym_if] = ACTIONS(2989),
    [anon_sym_switch] = ACTIONS(2989),
    [anon_sym_for] = ACTIONS(2989),
    [anon_sym_LPAREN] = ACTIONS(2991),
    [anon_sym_await] = ACTIONS(2989),
    [anon_sym_of] = ACTIONS(2989),
    [anon_sym_while] = ACTIONS(2989),
    [anon_sym_do] = ACTIONS(2989),
    [anon_sym_try] = ACTIONS(2989),
    [anon_sym_break] = ACTIONS(2989),
    [anon_sym_continue] = ACTIONS(2989),
    [anon_sym_debugger] = ACTIONS(2989),
    [anon_sym_return] = ACTIONS(2989),
    [anon_sym_throw] = ACTIONS(2989),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_case] = ACTIONS(2989),
    [anon_sym_yield] = ACTIONS(2989),
    [anon_sym_LBRACK] = ACTIONS(2991),
    [anon_sym_LTtemplate_GT] = ACTIONS(2991),
    [anon_sym_DQUOTE] = ACTIONS(2991),
    [anon_sym_SQUOTE] = ACTIONS(2991),
    [anon_sym_class] = ACTIONS(2989),
    [anon_sym_async] = ACTIONS(2989),
    [anon_sym_function] = ACTIONS(2989),
    [anon_sym_new] = ACTIONS(2989),
    [anon_sym_using] = ACTIONS(2989),
    [anon_sym_PLUS] = ACTIONS(2989),
    [anon_sym_DASH] = ACTIONS(2989),
    [anon_sym_SLASH] = ACTIONS(2989),
    [anon_sym_LT] = ACTIONS(2989),
    [anon_sym_TILDE] = ACTIONS(2991),
    [anon_sym_void] = ACTIONS(2989),
    [anon_sym_delete] = ACTIONS(2989),
    [anon_sym_PLUS_PLUS] = ACTIONS(2991),
    [anon_sym_DASH_DASH] = ACTIONS(2991),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2991),
    [sym_number] = ACTIONS(2991),
    [sym_private_property_identifier] = ACTIONS(2991),
    [sym_this] = ACTIONS(2989),
    [sym_super] = ACTIONS(2989),
    [sym_true] = ACTIONS(2989),
    [sym_false] = ACTIONS(2989),
    [sym_null] = ACTIONS(2989),
    [sym_undefined] = ACTIONS(2989),
    [anon_sym_AT] = ACTIONS(2991),
    [anon_sym_static] = ACTIONS(2989),
    [anon_sym_readonly] = ACTIONS(2989),
    [anon_sym_get] = ACTIONS(2989),
    [anon_sym_set] = ACTIONS(2989),
    [anon_sym_declare] = ACTIONS(2989),
    [anon_sym_public] = ACTIONS(2989),
    [anon_sym_private] = ACTIONS(2989),
    [anon_sym_protected] = ACTIONS(2989),
    [anon_sym_override] = ACTIONS(2989),
    [anon_sym_module] = ACTIONS(2989),
    [anon_sym_any] = ACTIONS(2989),
    [anon_sym_number] = ACTIONS(2989),
    [anon_sym_boolean] = ACTIONS(2989),
    [anon_sym_string] = ACTIONS(2989),
    [anon_sym_symbol] = ACTIONS(2989),
    [anon_sym_object] = ACTIONS(2989),
    [anon_sym_property] = ACTIONS(2989),
    [anon_sym_signal] = ACTIONS(2989),
    [anon_sym_on] = ACTIONS(2989),
    [anon_sym_required] = ACTIONS(2989),
    [anon_sym_component] = ACTIONS(2989),
    [anon_sym_abstract] = ACTIONS(2989),
    [anon_sym_interface] = ACTIONS(2989),
    [anon_sym_enum] = ACTIONS(2989),
    [sym_html_comment] = ACTIONS(5),
  },
  [894] = {
    [sym_comment] = STATE(894),
    [sym_identifier] = ACTIONS(2989),
    [anon_sym_export] = ACTIONS(2989),
    [anon_sym_default] = ACTIONS(2989),
    [anon_sym_type] = ACTIONS(2989),
    [anon_sym_namespace] = ACTIONS(2989),
    [anon_sym_LBRACE] = ACTIONS(2991),
    [anon_sym_RBRACE] = ACTIONS(2991),
    [anon_sym_typeof] = ACTIONS(2989),
    [anon_sym_import] = ACTIONS(2989),
    [anon_sym_from] = ACTIONS(2989),
    [anon_sym_with] = ACTIONS(2989),
    [anon_sym_var] = ACTIONS(2989),
    [anon_sym_let] = ACTIONS(2989),
    [anon_sym_const] = ACTIONS(2989),
    [anon_sym_BANG] = ACTIONS(2991),
    [anon_sym_else] = ACTIONS(2989),
    [anon_sym_if] = ACTIONS(2989),
    [anon_sym_switch] = ACTIONS(2989),
    [anon_sym_for] = ACTIONS(2989),
    [anon_sym_LPAREN] = ACTIONS(2991),
    [anon_sym_await] = ACTIONS(2989),
    [anon_sym_of] = ACTIONS(2989),
    [anon_sym_while] = ACTIONS(2989),
    [anon_sym_do] = ACTIONS(2989),
    [anon_sym_try] = ACTIONS(2989),
    [anon_sym_break] = ACTIONS(2989),
    [anon_sym_continue] = ACTIONS(2989),
    [anon_sym_debugger] = ACTIONS(2989),
    [anon_sym_return] = ACTIONS(2989),
    [anon_sym_throw] = ACTIONS(2989),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_case] = ACTIONS(2989),
    [anon_sym_yield] = ACTIONS(2989),
    [anon_sym_LBRACK] = ACTIONS(2991),
    [anon_sym_LTtemplate_GT] = ACTIONS(2991),
    [anon_sym_DQUOTE] = ACTIONS(2991),
    [anon_sym_SQUOTE] = ACTIONS(2991),
    [anon_sym_class] = ACTIONS(2989),
    [anon_sym_async] = ACTIONS(2989),
    [anon_sym_function] = ACTIONS(2989),
    [anon_sym_new] = ACTIONS(2989),
    [anon_sym_using] = ACTIONS(2989),
    [anon_sym_PLUS] = ACTIONS(2989),
    [anon_sym_DASH] = ACTIONS(2989),
    [anon_sym_SLASH] = ACTIONS(2989),
    [anon_sym_LT] = ACTIONS(2989),
    [anon_sym_TILDE] = ACTIONS(2991),
    [anon_sym_void] = ACTIONS(2989),
    [anon_sym_delete] = ACTIONS(2989),
    [anon_sym_PLUS_PLUS] = ACTIONS(2991),
    [anon_sym_DASH_DASH] = ACTIONS(2991),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2991),
    [sym_number] = ACTIONS(2991),
    [sym_private_property_identifier] = ACTIONS(2991),
    [sym_this] = ACTIONS(2989),
    [sym_super] = ACTIONS(2989),
    [sym_true] = ACTIONS(2989),
    [sym_false] = ACTIONS(2989),
    [sym_null] = ACTIONS(2989),
    [sym_undefined] = ACTIONS(2989),
    [anon_sym_AT] = ACTIONS(2991),
    [anon_sym_static] = ACTIONS(2989),
    [anon_sym_readonly] = ACTIONS(2989),
    [anon_sym_get] = ACTIONS(2989),
    [anon_sym_set] = ACTIONS(2989),
    [anon_sym_declare] = ACTIONS(2989),
    [anon_sym_public] = ACTIONS(2989),
    [anon_sym_private] = ACTIONS(2989),
    [anon_sym_protected] = ACTIONS(2989),
    [anon_sym_override] = ACTIONS(2989),
    [anon_sym_module] = ACTIONS(2989),
    [anon_sym_any] = ACTIONS(2989),
    [anon_sym_number] = ACTIONS(2989),
    [anon_sym_boolean] = ACTIONS(2989),
    [anon_sym_string] = ACTIONS(2989),
    [anon_sym_symbol] = ACTIONS(2989),
    [anon_sym_object] = ACTIONS(2989),
    [anon_sym_property] = ACTIONS(2989),
    [anon_sym_signal] = ACTIONS(2989),
    [anon_sym_on] = ACTIONS(2989),
    [anon_sym_required] = ACTIONS(2989),
    [anon_sym_component] = ACTIONS(2989),
    [anon_sym_abstract] = ACTIONS(2989),
    [anon_sym_interface] = ACTIONS(2989),
    [anon_sym_enum] = ACTIONS(2989),
    [sym_html_comment] = ACTIONS(5),
  },
  [895] = {
    [sym_comment] = STATE(895),
    [sym_identifier] = ACTIONS(2993),
    [anon_sym_export] = ACTIONS(2993),
    [anon_sym_default] = ACTIONS(2993),
    [anon_sym_type] = ACTIONS(2993),
    [anon_sym_namespace] = ACTIONS(2993),
    [anon_sym_LBRACE] = ACTIONS(2995),
    [anon_sym_RBRACE] = ACTIONS(2995),
    [anon_sym_typeof] = ACTIONS(2993),
    [anon_sym_import] = ACTIONS(2993),
    [anon_sym_from] = ACTIONS(2993),
    [anon_sym_with] = ACTIONS(2993),
    [anon_sym_var] = ACTIONS(2993),
    [anon_sym_let] = ACTIONS(2993),
    [anon_sym_const] = ACTIONS(2993),
    [anon_sym_BANG] = ACTIONS(2995),
    [anon_sym_else] = ACTIONS(2993),
    [anon_sym_if] = ACTIONS(2993),
    [anon_sym_switch] = ACTIONS(2993),
    [anon_sym_for] = ACTIONS(2993),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_await] = ACTIONS(2993),
    [anon_sym_of] = ACTIONS(2993),
    [anon_sym_while] = ACTIONS(2993),
    [anon_sym_do] = ACTIONS(2993),
    [anon_sym_try] = ACTIONS(2993),
    [anon_sym_break] = ACTIONS(2993),
    [anon_sym_continue] = ACTIONS(2993),
    [anon_sym_debugger] = ACTIONS(2993),
    [anon_sym_return] = ACTIONS(2993),
    [anon_sym_throw] = ACTIONS(2993),
    [anon_sym_SEMI] = ACTIONS(2995),
    [anon_sym_case] = ACTIONS(2993),
    [anon_sym_yield] = ACTIONS(2993),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_LTtemplate_GT] = ACTIONS(2995),
    [anon_sym_DQUOTE] = ACTIONS(2995),
    [anon_sym_SQUOTE] = ACTIONS(2995),
    [anon_sym_class] = ACTIONS(2993),
    [anon_sym_async] = ACTIONS(2993),
    [anon_sym_function] = ACTIONS(2993),
    [anon_sym_new] = ACTIONS(2993),
    [anon_sym_using] = ACTIONS(2993),
    [anon_sym_PLUS] = ACTIONS(2993),
    [anon_sym_DASH] = ACTIONS(2993),
    [anon_sym_SLASH] = ACTIONS(2993),
    [anon_sym_LT] = ACTIONS(2993),
    [anon_sym_TILDE] = ACTIONS(2995),
    [anon_sym_void] = ACTIONS(2993),
    [anon_sym_delete] = ACTIONS(2993),
    [anon_sym_PLUS_PLUS] = ACTIONS(2995),
    [anon_sym_DASH_DASH] = ACTIONS(2995),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2995),
    [sym_number] = ACTIONS(2995),
    [sym_private_property_identifier] = ACTIONS(2995),
    [sym_this] = ACTIONS(2993),
    [sym_super] = ACTIONS(2993),
    [sym_true] = ACTIONS(2993),
    [sym_false] = ACTIONS(2993),
    [sym_null] = ACTIONS(2993),
    [sym_undefined] = ACTIONS(2993),
    [anon_sym_AT] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(2993),
    [anon_sym_readonly] = ACTIONS(2993),
    [anon_sym_get] = ACTIONS(2993),
    [anon_sym_set] = ACTIONS(2993),
    [anon_sym_declare] = ACTIONS(2993),
    [anon_sym_public] = ACTIONS(2993),
    [anon_sym_private] = ACTIONS(2993),
    [anon_sym_protected] = ACTIONS(2993),
    [anon_sym_override] = ACTIONS(2993),
    [anon_sym_module] = ACTIONS(2993),
    [anon_sym_any] = ACTIONS(2993),
    [anon_sym_number] = ACTIONS(2993),
    [anon_sym_boolean] = ACTIONS(2993),
    [anon_sym_string] = ACTIONS(2993),
    [anon_sym_symbol] = ACTIONS(2993),
    [anon_sym_object] = ACTIONS(2993),
    [anon_sym_property] = ACTIONS(2993),
    [anon_sym_signal] = ACTIONS(2993),
    [anon_sym_on] = ACTIONS(2993),
    [anon_sym_required] = ACTIONS(2993),
    [anon_sym_component] = ACTIONS(2993),
    [anon_sym_abstract] = ACTIONS(2993),
    [anon_sym_interface] = ACTIONS(2993),
    [anon_sym_enum] = ACTIONS(2993),
    [sym_html_comment] = ACTIONS(5),
  },
  [896] = {
    [sym_comment] = STATE(896),
    [sym_identifier] = ACTIONS(2997),
    [anon_sym_export] = ACTIONS(2997),
    [anon_sym_default] = ACTIONS(2997),
    [anon_sym_type] = ACTIONS(2997),
    [anon_sym_namespace] = ACTIONS(2997),
    [anon_sym_LBRACE] = ACTIONS(2999),
    [anon_sym_RBRACE] = ACTIONS(2999),
    [anon_sym_typeof] = ACTIONS(2997),
    [anon_sym_import] = ACTIONS(2997),
    [anon_sym_from] = ACTIONS(2997),
    [anon_sym_with] = ACTIONS(2997),
    [anon_sym_var] = ACTIONS(2997),
    [anon_sym_let] = ACTIONS(2997),
    [anon_sym_const] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(2999),
    [anon_sym_else] = ACTIONS(2997),
    [anon_sym_if] = ACTIONS(2997),
    [anon_sym_switch] = ACTIONS(2997),
    [anon_sym_for] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(2999),
    [anon_sym_await] = ACTIONS(2997),
    [anon_sym_of] = ACTIONS(2997),
    [anon_sym_while] = ACTIONS(2997),
    [anon_sym_do] = ACTIONS(2997),
    [anon_sym_try] = ACTIONS(2997),
    [anon_sym_break] = ACTIONS(2997),
    [anon_sym_continue] = ACTIONS(2997),
    [anon_sym_debugger] = ACTIONS(2997),
    [anon_sym_return] = ACTIONS(2997),
    [anon_sym_throw] = ACTIONS(2997),
    [anon_sym_SEMI] = ACTIONS(2999),
    [anon_sym_case] = ACTIONS(2997),
    [anon_sym_yield] = ACTIONS(2997),
    [anon_sym_LBRACK] = ACTIONS(2999),
    [anon_sym_LTtemplate_GT] = ACTIONS(2999),
    [anon_sym_DQUOTE] = ACTIONS(2999),
    [anon_sym_SQUOTE] = ACTIONS(2999),
    [anon_sym_class] = ACTIONS(2997),
    [anon_sym_async] = ACTIONS(2997),
    [anon_sym_function] = ACTIONS(2997),
    [anon_sym_new] = ACTIONS(2997),
    [anon_sym_using] = ACTIONS(2997),
    [anon_sym_PLUS] = ACTIONS(2997),
    [anon_sym_DASH] = ACTIONS(2997),
    [anon_sym_SLASH] = ACTIONS(2997),
    [anon_sym_LT] = ACTIONS(2997),
    [anon_sym_TILDE] = ACTIONS(2999),
    [anon_sym_void] = ACTIONS(2997),
    [anon_sym_delete] = ACTIONS(2997),
    [anon_sym_PLUS_PLUS] = ACTIONS(2999),
    [anon_sym_DASH_DASH] = ACTIONS(2999),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2999),
    [sym_number] = ACTIONS(2999),
    [sym_private_property_identifier] = ACTIONS(2999),
    [sym_this] = ACTIONS(2997),
    [sym_super] = ACTIONS(2997),
    [sym_true] = ACTIONS(2997),
    [sym_false] = ACTIONS(2997),
    [sym_null] = ACTIONS(2997),
    [sym_undefined] = ACTIONS(2997),
    [anon_sym_AT] = ACTIONS(2999),
    [anon_sym_static] = ACTIONS(2997),
    [anon_sym_readonly] = ACTIONS(2997),
    [anon_sym_get] = ACTIONS(2997),
    [anon_sym_set] = ACTIONS(2997),
    [anon_sym_declare] = ACTIONS(2997),
    [anon_sym_public] = ACTIONS(2997),
    [anon_sym_private] = ACTIONS(2997),
    [anon_sym_protected] = ACTIONS(2997),
    [anon_sym_override] = ACTIONS(2997),
    [anon_sym_module] = ACTIONS(2997),
    [anon_sym_any] = ACTIONS(2997),
    [anon_sym_number] = ACTIONS(2997),
    [anon_sym_boolean] = ACTIONS(2997),
    [anon_sym_string] = ACTIONS(2997),
    [anon_sym_symbol] = ACTIONS(2997),
    [anon_sym_object] = ACTIONS(2997),
    [anon_sym_property] = ACTIONS(2997),
    [anon_sym_signal] = ACTIONS(2997),
    [anon_sym_on] = ACTIONS(2997),
    [anon_sym_required] = ACTIONS(2997),
    [anon_sym_component] = ACTIONS(2997),
    [anon_sym_abstract] = ACTIONS(2997),
    [anon_sym_interface] = ACTIONS(2997),
    [anon_sym_enum] = ACTIONS(2997),
    [sym_html_comment] = ACTIONS(5),
  },
  [897] = {
    [sym_comment] = STATE(897),
    [sym_identifier] = ACTIONS(2841),
    [anon_sym_export] = ACTIONS(2841),
    [anon_sym_default] = ACTIONS(2841),
    [anon_sym_type] = ACTIONS(2841),
    [anon_sym_namespace] = ACTIONS(2841),
    [anon_sym_LBRACE] = ACTIONS(2843),
    [anon_sym_RBRACE] = ACTIONS(2843),
    [anon_sym_typeof] = ACTIONS(2841),
    [anon_sym_import] = ACTIONS(2841),
    [anon_sym_from] = ACTIONS(2841),
    [anon_sym_with] = ACTIONS(2841),
    [anon_sym_var] = ACTIONS(2841),
    [anon_sym_let] = ACTIONS(2841),
    [anon_sym_const] = ACTIONS(2841),
    [anon_sym_BANG] = ACTIONS(2843),
    [anon_sym_else] = ACTIONS(2841),
    [anon_sym_if] = ACTIONS(2841),
    [anon_sym_switch] = ACTIONS(2841),
    [anon_sym_for] = ACTIONS(2841),
    [anon_sym_LPAREN] = ACTIONS(2843),
    [anon_sym_await] = ACTIONS(2841),
    [anon_sym_of] = ACTIONS(2841),
    [anon_sym_while] = ACTIONS(2841),
    [anon_sym_do] = ACTIONS(2841),
    [anon_sym_try] = ACTIONS(2841),
    [anon_sym_break] = ACTIONS(2841),
    [anon_sym_continue] = ACTIONS(2841),
    [anon_sym_debugger] = ACTIONS(2841),
    [anon_sym_return] = ACTIONS(2841),
    [anon_sym_throw] = ACTIONS(2841),
    [anon_sym_SEMI] = ACTIONS(2843),
    [anon_sym_case] = ACTIONS(2841),
    [anon_sym_yield] = ACTIONS(2841),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_LTtemplate_GT] = ACTIONS(2843),
    [anon_sym_DQUOTE] = ACTIONS(2843),
    [anon_sym_SQUOTE] = ACTIONS(2843),
    [anon_sym_class] = ACTIONS(2841),
    [anon_sym_async] = ACTIONS(2841),
    [anon_sym_function] = ACTIONS(2841),
    [anon_sym_new] = ACTIONS(2841),
    [anon_sym_using] = ACTIONS(2841),
    [anon_sym_PLUS] = ACTIONS(2841),
    [anon_sym_DASH] = ACTIONS(2841),
    [anon_sym_SLASH] = ACTIONS(2841),
    [anon_sym_LT] = ACTIONS(2841),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_void] = ACTIONS(2841),
    [anon_sym_delete] = ACTIONS(2841),
    [anon_sym_PLUS_PLUS] = ACTIONS(2843),
    [anon_sym_DASH_DASH] = ACTIONS(2843),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2843),
    [sym_number] = ACTIONS(2843),
    [sym_private_property_identifier] = ACTIONS(2843),
    [sym_this] = ACTIONS(2841),
    [sym_super] = ACTIONS(2841),
    [sym_true] = ACTIONS(2841),
    [sym_false] = ACTIONS(2841),
    [sym_null] = ACTIONS(2841),
    [sym_undefined] = ACTIONS(2841),
    [anon_sym_AT] = ACTIONS(2843),
    [anon_sym_static] = ACTIONS(2841),
    [anon_sym_readonly] = ACTIONS(2841),
    [anon_sym_get] = ACTIONS(2841),
    [anon_sym_set] = ACTIONS(2841),
    [anon_sym_declare] = ACTIONS(2841),
    [anon_sym_public] = ACTIONS(2841),
    [anon_sym_private] = ACTIONS(2841),
    [anon_sym_protected] = ACTIONS(2841),
    [anon_sym_override] = ACTIONS(2841),
    [anon_sym_module] = ACTIONS(2841),
    [anon_sym_any] = ACTIONS(2841),
    [anon_sym_number] = ACTIONS(2841),
    [anon_sym_boolean] = ACTIONS(2841),
    [anon_sym_string] = ACTIONS(2841),
    [anon_sym_symbol] = ACTIONS(2841),
    [anon_sym_object] = ACTIONS(2841),
    [anon_sym_property] = ACTIONS(2841),
    [anon_sym_signal] = ACTIONS(2841),
    [anon_sym_on] = ACTIONS(2841),
    [anon_sym_required] = ACTIONS(2841),
    [anon_sym_component] = ACTIONS(2841),
    [anon_sym_abstract] = ACTIONS(2841),
    [anon_sym_interface] = ACTIONS(2841),
    [anon_sym_enum] = ACTIONS(2841),
    [sym_html_comment] = ACTIONS(5),
  },
  [898] = {
    [sym_comment] = STATE(898),
    [sym_identifier] = ACTIONS(3001),
    [anon_sym_export] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3001),
    [anon_sym_type] = ACTIONS(3001),
    [anon_sym_namespace] = ACTIONS(3001),
    [anon_sym_LBRACE] = ACTIONS(3003),
    [anon_sym_RBRACE] = ACTIONS(3003),
    [anon_sym_typeof] = ACTIONS(3001),
    [anon_sym_import] = ACTIONS(3001),
    [anon_sym_from] = ACTIONS(3001),
    [anon_sym_with] = ACTIONS(3001),
    [anon_sym_var] = ACTIONS(3001),
    [anon_sym_let] = ACTIONS(3001),
    [anon_sym_const] = ACTIONS(3001),
    [anon_sym_BANG] = ACTIONS(3003),
    [anon_sym_else] = ACTIONS(3001),
    [anon_sym_if] = ACTIONS(3001),
    [anon_sym_switch] = ACTIONS(3001),
    [anon_sym_for] = ACTIONS(3001),
    [anon_sym_LPAREN] = ACTIONS(3003),
    [anon_sym_await] = ACTIONS(3001),
    [anon_sym_of] = ACTIONS(3001),
    [anon_sym_while] = ACTIONS(3001),
    [anon_sym_do] = ACTIONS(3001),
    [anon_sym_try] = ACTIONS(3001),
    [anon_sym_break] = ACTIONS(3001),
    [anon_sym_continue] = ACTIONS(3001),
    [anon_sym_debugger] = ACTIONS(3001),
    [anon_sym_return] = ACTIONS(3001),
    [anon_sym_throw] = ACTIONS(3001),
    [anon_sym_SEMI] = ACTIONS(3003),
    [anon_sym_case] = ACTIONS(3001),
    [anon_sym_yield] = ACTIONS(3001),
    [anon_sym_LBRACK] = ACTIONS(3003),
    [anon_sym_LTtemplate_GT] = ACTIONS(3003),
    [anon_sym_DQUOTE] = ACTIONS(3003),
    [anon_sym_SQUOTE] = ACTIONS(3003),
    [anon_sym_class] = ACTIONS(3001),
    [anon_sym_async] = ACTIONS(3001),
    [anon_sym_function] = ACTIONS(3001),
    [anon_sym_new] = ACTIONS(3001),
    [anon_sym_using] = ACTIONS(3001),
    [anon_sym_PLUS] = ACTIONS(3001),
    [anon_sym_DASH] = ACTIONS(3001),
    [anon_sym_SLASH] = ACTIONS(3001),
    [anon_sym_LT] = ACTIONS(3001),
    [anon_sym_TILDE] = ACTIONS(3003),
    [anon_sym_void] = ACTIONS(3001),
    [anon_sym_delete] = ACTIONS(3001),
    [anon_sym_PLUS_PLUS] = ACTIONS(3003),
    [anon_sym_DASH_DASH] = ACTIONS(3003),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3003),
    [sym_number] = ACTIONS(3003),
    [sym_private_property_identifier] = ACTIONS(3003),
    [sym_this] = ACTIONS(3001),
    [sym_super] = ACTIONS(3001),
    [sym_true] = ACTIONS(3001),
    [sym_false] = ACTIONS(3001),
    [sym_null] = ACTIONS(3001),
    [sym_undefined] = ACTIONS(3001),
    [anon_sym_AT] = ACTIONS(3003),
    [anon_sym_static] = ACTIONS(3001),
    [anon_sym_readonly] = ACTIONS(3001),
    [anon_sym_get] = ACTIONS(3001),
    [anon_sym_set] = ACTIONS(3001),
    [anon_sym_declare] = ACTIONS(3001),
    [anon_sym_public] = ACTIONS(3001),
    [anon_sym_private] = ACTIONS(3001),
    [anon_sym_protected] = ACTIONS(3001),
    [anon_sym_override] = ACTIONS(3001),
    [anon_sym_module] = ACTIONS(3001),
    [anon_sym_any] = ACTIONS(3001),
    [anon_sym_number] = ACTIONS(3001),
    [anon_sym_boolean] = ACTIONS(3001),
    [anon_sym_string] = ACTIONS(3001),
    [anon_sym_symbol] = ACTIONS(3001),
    [anon_sym_object] = ACTIONS(3001),
    [anon_sym_property] = ACTIONS(3001),
    [anon_sym_signal] = ACTIONS(3001),
    [anon_sym_on] = ACTIONS(3001),
    [anon_sym_required] = ACTIONS(3001),
    [anon_sym_component] = ACTIONS(3001),
    [anon_sym_abstract] = ACTIONS(3001),
    [anon_sym_interface] = ACTIONS(3001),
    [anon_sym_enum] = ACTIONS(3001),
    [sym_html_comment] = ACTIONS(5),
  },
  [899] = {
    [sym_comment] = STATE(899),
    [sym_identifier] = ACTIONS(3005),
    [anon_sym_export] = ACTIONS(3005),
    [anon_sym_default] = ACTIONS(3005),
    [anon_sym_type] = ACTIONS(3005),
    [anon_sym_namespace] = ACTIONS(3005),
    [anon_sym_LBRACE] = ACTIONS(3007),
    [anon_sym_RBRACE] = ACTIONS(3007),
    [anon_sym_typeof] = ACTIONS(3005),
    [anon_sym_import] = ACTIONS(3005),
    [anon_sym_from] = ACTIONS(3005),
    [anon_sym_with] = ACTIONS(3005),
    [anon_sym_var] = ACTIONS(3005),
    [anon_sym_let] = ACTIONS(3005),
    [anon_sym_const] = ACTIONS(3005),
    [anon_sym_BANG] = ACTIONS(3007),
    [anon_sym_else] = ACTIONS(3005),
    [anon_sym_if] = ACTIONS(3005),
    [anon_sym_switch] = ACTIONS(3005),
    [anon_sym_for] = ACTIONS(3005),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_await] = ACTIONS(3005),
    [anon_sym_of] = ACTIONS(3005),
    [anon_sym_while] = ACTIONS(3005),
    [anon_sym_do] = ACTIONS(3005),
    [anon_sym_try] = ACTIONS(3005),
    [anon_sym_break] = ACTIONS(3005),
    [anon_sym_continue] = ACTIONS(3005),
    [anon_sym_debugger] = ACTIONS(3005),
    [anon_sym_return] = ACTIONS(3005),
    [anon_sym_throw] = ACTIONS(3005),
    [anon_sym_SEMI] = ACTIONS(3007),
    [anon_sym_case] = ACTIONS(3005),
    [anon_sym_yield] = ACTIONS(3005),
    [anon_sym_LBRACK] = ACTIONS(3007),
    [anon_sym_LTtemplate_GT] = ACTIONS(3007),
    [anon_sym_DQUOTE] = ACTIONS(3007),
    [anon_sym_SQUOTE] = ACTIONS(3007),
    [anon_sym_class] = ACTIONS(3005),
    [anon_sym_async] = ACTIONS(3005),
    [anon_sym_function] = ACTIONS(3005),
    [anon_sym_new] = ACTIONS(3005),
    [anon_sym_using] = ACTIONS(3005),
    [anon_sym_PLUS] = ACTIONS(3005),
    [anon_sym_DASH] = ACTIONS(3005),
    [anon_sym_SLASH] = ACTIONS(3005),
    [anon_sym_LT] = ACTIONS(3005),
    [anon_sym_TILDE] = ACTIONS(3007),
    [anon_sym_void] = ACTIONS(3005),
    [anon_sym_delete] = ACTIONS(3005),
    [anon_sym_PLUS_PLUS] = ACTIONS(3007),
    [anon_sym_DASH_DASH] = ACTIONS(3007),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3007),
    [sym_number] = ACTIONS(3007),
    [sym_private_property_identifier] = ACTIONS(3007),
    [sym_this] = ACTIONS(3005),
    [sym_super] = ACTIONS(3005),
    [sym_true] = ACTIONS(3005),
    [sym_false] = ACTIONS(3005),
    [sym_null] = ACTIONS(3005),
    [sym_undefined] = ACTIONS(3005),
    [anon_sym_AT] = ACTIONS(3007),
    [anon_sym_static] = ACTIONS(3005),
    [anon_sym_readonly] = ACTIONS(3005),
    [anon_sym_get] = ACTIONS(3005),
    [anon_sym_set] = ACTIONS(3005),
    [anon_sym_declare] = ACTIONS(3005),
    [anon_sym_public] = ACTIONS(3005),
    [anon_sym_private] = ACTIONS(3005),
    [anon_sym_protected] = ACTIONS(3005),
    [anon_sym_override] = ACTIONS(3005),
    [anon_sym_module] = ACTIONS(3005),
    [anon_sym_any] = ACTIONS(3005),
    [anon_sym_number] = ACTIONS(3005),
    [anon_sym_boolean] = ACTIONS(3005),
    [anon_sym_string] = ACTIONS(3005),
    [anon_sym_symbol] = ACTIONS(3005),
    [anon_sym_object] = ACTIONS(3005),
    [anon_sym_property] = ACTIONS(3005),
    [anon_sym_signal] = ACTIONS(3005),
    [anon_sym_on] = ACTIONS(3005),
    [anon_sym_required] = ACTIONS(3005),
    [anon_sym_component] = ACTIONS(3005),
    [anon_sym_abstract] = ACTIONS(3005),
    [anon_sym_interface] = ACTIONS(3005),
    [anon_sym_enum] = ACTIONS(3005),
    [sym_html_comment] = ACTIONS(5),
  },
  [900] = {
    [sym_comment] = STATE(900),
    [sym_identifier] = ACTIONS(3009),
    [anon_sym_export] = ACTIONS(3009),
    [anon_sym_default] = ACTIONS(3009),
    [anon_sym_type] = ACTIONS(3009),
    [anon_sym_namespace] = ACTIONS(3009),
    [anon_sym_LBRACE] = ACTIONS(3011),
    [anon_sym_RBRACE] = ACTIONS(3011),
    [anon_sym_typeof] = ACTIONS(3009),
    [anon_sym_import] = ACTIONS(3009),
    [anon_sym_from] = ACTIONS(3009),
    [anon_sym_with] = ACTIONS(3009),
    [anon_sym_var] = ACTIONS(3009),
    [anon_sym_let] = ACTIONS(3009),
    [anon_sym_const] = ACTIONS(3009),
    [anon_sym_BANG] = ACTIONS(3011),
    [anon_sym_else] = ACTIONS(3009),
    [anon_sym_if] = ACTIONS(3009),
    [anon_sym_switch] = ACTIONS(3009),
    [anon_sym_for] = ACTIONS(3009),
    [anon_sym_LPAREN] = ACTIONS(3011),
    [anon_sym_await] = ACTIONS(3009),
    [anon_sym_of] = ACTIONS(3009),
    [anon_sym_while] = ACTIONS(3009),
    [anon_sym_do] = ACTIONS(3009),
    [anon_sym_try] = ACTIONS(3009),
    [anon_sym_break] = ACTIONS(3009),
    [anon_sym_continue] = ACTIONS(3009),
    [anon_sym_debugger] = ACTIONS(3009),
    [anon_sym_return] = ACTIONS(3009),
    [anon_sym_throw] = ACTIONS(3009),
    [anon_sym_SEMI] = ACTIONS(3011),
    [anon_sym_case] = ACTIONS(3009),
    [anon_sym_yield] = ACTIONS(3009),
    [anon_sym_LBRACK] = ACTIONS(3011),
    [anon_sym_LTtemplate_GT] = ACTIONS(3011),
    [anon_sym_DQUOTE] = ACTIONS(3011),
    [anon_sym_SQUOTE] = ACTIONS(3011),
    [anon_sym_class] = ACTIONS(3009),
    [anon_sym_async] = ACTIONS(3009),
    [anon_sym_function] = ACTIONS(3009),
    [anon_sym_new] = ACTIONS(3009),
    [anon_sym_using] = ACTIONS(3009),
    [anon_sym_PLUS] = ACTIONS(3009),
    [anon_sym_DASH] = ACTIONS(3009),
    [anon_sym_SLASH] = ACTIONS(3009),
    [anon_sym_LT] = ACTIONS(3009),
    [anon_sym_TILDE] = ACTIONS(3011),
    [anon_sym_void] = ACTIONS(3009),
    [anon_sym_delete] = ACTIONS(3009),
    [anon_sym_PLUS_PLUS] = ACTIONS(3011),
    [anon_sym_DASH_DASH] = ACTIONS(3011),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3011),
    [sym_number] = ACTIONS(3011),
    [sym_private_property_identifier] = ACTIONS(3011),
    [sym_this] = ACTIONS(3009),
    [sym_super] = ACTIONS(3009),
    [sym_true] = ACTIONS(3009),
    [sym_false] = ACTIONS(3009),
    [sym_null] = ACTIONS(3009),
    [sym_undefined] = ACTIONS(3009),
    [anon_sym_AT] = ACTIONS(3011),
    [anon_sym_static] = ACTIONS(3009),
    [anon_sym_readonly] = ACTIONS(3009),
    [anon_sym_get] = ACTIONS(3009),
    [anon_sym_set] = ACTIONS(3009),
    [anon_sym_declare] = ACTIONS(3009),
    [anon_sym_public] = ACTIONS(3009),
    [anon_sym_private] = ACTIONS(3009),
    [anon_sym_protected] = ACTIONS(3009),
    [anon_sym_override] = ACTIONS(3009),
    [anon_sym_module] = ACTIONS(3009),
    [anon_sym_any] = ACTIONS(3009),
    [anon_sym_number] = ACTIONS(3009),
    [anon_sym_boolean] = ACTIONS(3009),
    [anon_sym_string] = ACTIONS(3009),
    [anon_sym_symbol] = ACTIONS(3009),
    [anon_sym_object] = ACTIONS(3009),
    [anon_sym_property] = ACTIONS(3009),
    [anon_sym_signal] = ACTIONS(3009),
    [anon_sym_on] = ACTIONS(3009),
    [anon_sym_required] = ACTIONS(3009),
    [anon_sym_component] = ACTIONS(3009),
    [anon_sym_abstract] = ACTIONS(3009),
    [anon_sym_interface] = ACTIONS(3009),
    [anon_sym_enum] = ACTIONS(3009),
    [sym_html_comment] = ACTIONS(5),
  },
  [901] = {
    [sym_comment] = STATE(901),
    [sym_identifier] = ACTIONS(1968),
    [anon_sym_export] = ACTIONS(1968),
    [anon_sym_default] = ACTIONS(1968),
    [anon_sym_type] = ACTIONS(1968),
    [anon_sym_namespace] = ACTIONS(1968),
    [anon_sym_LBRACE] = ACTIONS(1970),
    [anon_sym_RBRACE] = ACTIONS(1970),
    [anon_sym_typeof] = ACTIONS(1968),
    [anon_sym_import] = ACTIONS(1968),
    [anon_sym_from] = ACTIONS(1968),
    [anon_sym_with] = ACTIONS(1968),
    [anon_sym_var] = ACTIONS(1968),
    [anon_sym_let] = ACTIONS(1968),
    [anon_sym_const] = ACTIONS(1968),
    [anon_sym_BANG] = ACTIONS(1970),
    [anon_sym_else] = ACTIONS(1968),
    [anon_sym_if] = ACTIONS(1968),
    [anon_sym_switch] = ACTIONS(1968),
    [anon_sym_for] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1970),
    [anon_sym_await] = ACTIONS(1968),
    [anon_sym_of] = ACTIONS(1968),
    [anon_sym_while] = ACTIONS(1968),
    [anon_sym_do] = ACTIONS(1968),
    [anon_sym_try] = ACTIONS(1968),
    [anon_sym_break] = ACTIONS(1968),
    [anon_sym_continue] = ACTIONS(1968),
    [anon_sym_debugger] = ACTIONS(1968),
    [anon_sym_return] = ACTIONS(1968),
    [anon_sym_throw] = ACTIONS(1968),
    [anon_sym_SEMI] = ACTIONS(1970),
    [anon_sym_case] = ACTIONS(1968),
    [anon_sym_yield] = ACTIONS(1968),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_LTtemplate_GT] = ACTIONS(1970),
    [anon_sym_DQUOTE] = ACTIONS(1970),
    [anon_sym_SQUOTE] = ACTIONS(1970),
    [anon_sym_class] = ACTIONS(1968),
    [anon_sym_async] = ACTIONS(1968),
    [anon_sym_function] = ACTIONS(1968),
    [anon_sym_new] = ACTIONS(1968),
    [anon_sym_using] = ACTIONS(1968),
    [anon_sym_PLUS] = ACTIONS(1968),
    [anon_sym_DASH] = ACTIONS(1968),
    [anon_sym_SLASH] = ACTIONS(1968),
    [anon_sym_LT] = ACTIONS(1968),
    [anon_sym_TILDE] = ACTIONS(1970),
    [anon_sym_void] = ACTIONS(1968),
    [anon_sym_delete] = ACTIONS(1968),
    [anon_sym_PLUS_PLUS] = ACTIONS(1970),
    [anon_sym_DASH_DASH] = ACTIONS(1970),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1970),
    [sym_number] = ACTIONS(1970),
    [sym_private_property_identifier] = ACTIONS(1970),
    [sym_this] = ACTIONS(1968),
    [sym_super] = ACTIONS(1968),
    [sym_true] = ACTIONS(1968),
    [sym_false] = ACTIONS(1968),
    [sym_null] = ACTIONS(1968),
    [sym_undefined] = ACTIONS(1968),
    [anon_sym_AT] = ACTIONS(1970),
    [anon_sym_static] = ACTIONS(1968),
    [anon_sym_readonly] = ACTIONS(1968),
    [anon_sym_get] = ACTIONS(1968),
    [anon_sym_set] = ACTIONS(1968),
    [anon_sym_declare] = ACTIONS(1968),
    [anon_sym_public] = ACTIONS(1968),
    [anon_sym_private] = ACTIONS(1968),
    [anon_sym_protected] = ACTIONS(1968),
    [anon_sym_override] = ACTIONS(1968),
    [anon_sym_module] = ACTIONS(1968),
    [anon_sym_any] = ACTIONS(1968),
    [anon_sym_number] = ACTIONS(1968),
    [anon_sym_boolean] = ACTIONS(1968),
    [anon_sym_string] = ACTIONS(1968),
    [anon_sym_symbol] = ACTIONS(1968),
    [anon_sym_object] = ACTIONS(1968),
    [anon_sym_property] = ACTIONS(1968),
    [anon_sym_signal] = ACTIONS(1968),
    [anon_sym_on] = ACTIONS(1968),
    [anon_sym_required] = ACTIONS(1968),
    [anon_sym_component] = ACTIONS(1968),
    [anon_sym_abstract] = ACTIONS(1968),
    [anon_sym_interface] = ACTIONS(1968),
    [anon_sym_enum] = ACTIONS(1968),
    [sym_html_comment] = ACTIONS(5),
  },
  [902] = {
    [sym_comment] = STATE(902),
    [sym_identifier] = ACTIONS(3013),
    [anon_sym_export] = ACTIONS(3013),
    [anon_sym_default] = ACTIONS(3013),
    [anon_sym_type] = ACTIONS(3013),
    [anon_sym_namespace] = ACTIONS(3013),
    [anon_sym_LBRACE] = ACTIONS(3015),
    [anon_sym_RBRACE] = ACTIONS(3015),
    [anon_sym_typeof] = ACTIONS(3013),
    [anon_sym_import] = ACTIONS(3013),
    [anon_sym_from] = ACTIONS(3013),
    [anon_sym_with] = ACTIONS(3013),
    [anon_sym_var] = ACTIONS(3013),
    [anon_sym_let] = ACTIONS(3013),
    [anon_sym_const] = ACTIONS(3013),
    [anon_sym_BANG] = ACTIONS(3015),
    [anon_sym_else] = ACTIONS(3013),
    [anon_sym_if] = ACTIONS(3013),
    [anon_sym_switch] = ACTIONS(3013),
    [anon_sym_for] = ACTIONS(3013),
    [anon_sym_LPAREN] = ACTIONS(3015),
    [anon_sym_await] = ACTIONS(3013),
    [anon_sym_of] = ACTIONS(3013),
    [anon_sym_while] = ACTIONS(3013),
    [anon_sym_do] = ACTIONS(3013),
    [anon_sym_try] = ACTIONS(3013),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3013),
    [anon_sym_debugger] = ACTIONS(3013),
    [anon_sym_return] = ACTIONS(3013),
    [anon_sym_throw] = ACTIONS(3013),
    [anon_sym_SEMI] = ACTIONS(3015),
    [anon_sym_case] = ACTIONS(3013),
    [anon_sym_yield] = ACTIONS(3013),
    [anon_sym_LBRACK] = ACTIONS(3015),
    [anon_sym_LTtemplate_GT] = ACTIONS(3015),
    [anon_sym_DQUOTE] = ACTIONS(3015),
    [anon_sym_SQUOTE] = ACTIONS(3015),
    [anon_sym_class] = ACTIONS(3013),
    [anon_sym_async] = ACTIONS(3013),
    [anon_sym_function] = ACTIONS(3013),
    [anon_sym_new] = ACTIONS(3013),
    [anon_sym_using] = ACTIONS(3013),
    [anon_sym_PLUS] = ACTIONS(3013),
    [anon_sym_DASH] = ACTIONS(3013),
    [anon_sym_SLASH] = ACTIONS(3013),
    [anon_sym_LT] = ACTIONS(3013),
    [anon_sym_TILDE] = ACTIONS(3015),
    [anon_sym_void] = ACTIONS(3013),
    [anon_sym_delete] = ACTIONS(3013),
    [anon_sym_PLUS_PLUS] = ACTIONS(3015),
    [anon_sym_DASH_DASH] = ACTIONS(3015),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3015),
    [sym_number] = ACTIONS(3015),
    [sym_private_property_identifier] = ACTIONS(3015),
    [sym_this] = ACTIONS(3013),
    [sym_super] = ACTIONS(3013),
    [sym_true] = ACTIONS(3013),
    [sym_false] = ACTIONS(3013),
    [sym_null] = ACTIONS(3013),
    [sym_undefined] = ACTIONS(3013),
    [anon_sym_AT] = ACTIONS(3015),
    [anon_sym_static] = ACTIONS(3013),
    [anon_sym_readonly] = ACTIONS(3013),
    [anon_sym_get] = ACTIONS(3013),
    [anon_sym_set] = ACTIONS(3013),
    [anon_sym_declare] = ACTIONS(3013),
    [anon_sym_public] = ACTIONS(3013),
    [anon_sym_private] = ACTIONS(3013),
    [anon_sym_protected] = ACTIONS(3013),
    [anon_sym_override] = ACTIONS(3013),
    [anon_sym_module] = ACTIONS(3013),
    [anon_sym_any] = ACTIONS(3013),
    [anon_sym_number] = ACTIONS(3013),
    [anon_sym_boolean] = ACTIONS(3013),
    [anon_sym_string] = ACTIONS(3013),
    [anon_sym_symbol] = ACTIONS(3013),
    [anon_sym_object] = ACTIONS(3013),
    [anon_sym_property] = ACTIONS(3013),
    [anon_sym_signal] = ACTIONS(3013),
    [anon_sym_on] = ACTIONS(3013),
    [anon_sym_required] = ACTIONS(3013),
    [anon_sym_component] = ACTIONS(3013),
    [anon_sym_abstract] = ACTIONS(3013),
    [anon_sym_interface] = ACTIONS(3013),
    [anon_sym_enum] = ACTIONS(3013),
    [sym_html_comment] = ACTIONS(5),
  },
  [903] = {
    [sym_comment] = STATE(903),
    [sym_identifier] = ACTIONS(2985),
    [anon_sym_export] = ACTIONS(2985),
    [anon_sym_default] = ACTIONS(2985),
    [anon_sym_type] = ACTIONS(2985),
    [anon_sym_namespace] = ACTIONS(2985),
    [anon_sym_LBRACE] = ACTIONS(2987),
    [anon_sym_RBRACE] = ACTIONS(2987),
    [anon_sym_typeof] = ACTIONS(2985),
    [anon_sym_import] = ACTIONS(2985),
    [anon_sym_from] = ACTIONS(2985),
    [anon_sym_with] = ACTIONS(2985),
    [anon_sym_var] = ACTIONS(2985),
    [anon_sym_let] = ACTIONS(2985),
    [anon_sym_const] = ACTIONS(2985),
    [anon_sym_BANG] = ACTIONS(2987),
    [anon_sym_else] = ACTIONS(2985),
    [anon_sym_if] = ACTIONS(2985),
    [anon_sym_switch] = ACTIONS(2985),
    [anon_sym_for] = ACTIONS(2985),
    [anon_sym_LPAREN] = ACTIONS(2987),
    [anon_sym_await] = ACTIONS(2985),
    [anon_sym_of] = ACTIONS(2985),
    [anon_sym_while] = ACTIONS(2985),
    [anon_sym_do] = ACTIONS(2985),
    [anon_sym_try] = ACTIONS(2985),
    [anon_sym_break] = ACTIONS(2985),
    [anon_sym_continue] = ACTIONS(2985),
    [anon_sym_debugger] = ACTIONS(2985),
    [anon_sym_return] = ACTIONS(2985),
    [anon_sym_throw] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(2987),
    [anon_sym_case] = ACTIONS(2985),
    [anon_sym_yield] = ACTIONS(2985),
    [anon_sym_LBRACK] = ACTIONS(2987),
    [anon_sym_LTtemplate_GT] = ACTIONS(2987),
    [anon_sym_DQUOTE] = ACTIONS(2987),
    [anon_sym_SQUOTE] = ACTIONS(2987),
    [anon_sym_class] = ACTIONS(2985),
    [anon_sym_async] = ACTIONS(2985),
    [anon_sym_function] = ACTIONS(2985),
    [anon_sym_new] = ACTIONS(2985),
    [anon_sym_using] = ACTIONS(2985),
    [anon_sym_PLUS] = ACTIONS(2985),
    [anon_sym_DASH] = ACTIONS(2985),
    [anon_sym_SLASH] = ACTIONS(2985),
    [anon_sym_LT] = ACTIONS(2985),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_void] = ACTIONS(2985),
    [anon_sym_delete] = ACTIONS(2985),
    [anon_sym_PLUS_PLUS] = ACTIONS(2987),
    [anon_sym_DASH_DASH] = ACTIONS(2987),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2987),
    [sym_number] = ACTIONS(2987),
    [sym_private_property_identifier] = ACTIONS(2987),
    [sym_this] = ACTIONS(2985),
    [sym_super] = ACTIONS(2985),
    [sym_true] = ACTIONS(2985),
    [sym_false] = ACTIONS(2985),
    [sym_null] = ACTIONS(2985),
    [sym_undefined] = ACTIONS(2985),
    [anon_sym_AT] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(2985),
    [anon_sym_readonly] = ACTIONS(2985),
    [anon_sym_get] = ACTIONS(2985),
    [anon_sym_set] = ACTIONS(2985),
    [anon_sym_declare] = ACTIONS(2985),
    [anon_sym_public] = ACTIONS(2985),
    [anon_sym_private] = ACTIONS(2985),
    [anon_sym_protected] = ACTIONS(2985),
    [anon_sym_override] = ACTIONS(2985),
    [anon_sym_module] = ACTIONS(2985),
    [anon_sym_any] = ACTIONS(2985),
    [anon_sym_number] = ACTIONS(2985),
    [anon_sym_boolean] = ACTIONS(2985),
    [anon_sym_string] = ACTIONS(2985),
    [anon_sym_symbol] = ACTIONS(2985),
    [anon_sym_object] = ACTIONS(2985),
    [anon_sym_property] = ACTIONS(2985),
    [anon_sym_signal] = ACTIONS(2985),
    [anon_sym_on] = ACTIONS(2985),
    [anon_sym_required] = ACTIONS(2985),
    [anon_sym_component] = ACTIONS(2985),
    [anon_sym_abstract] = ACTIONS(2985),
    [anon_sym_interface] = ACTIONS(2985),
    [anon_sym_enum] = ACTIONS(2985),
    [sym_html_comment] = ACTIONS(5),
  },
  [904] = {
    [sym_comment] = STATE(904),
    [sym_identifier] = ACTIONS(2985),
    [anon_sym_export] = ACTIONS(2985),
    [anon_sym_default] = ACTIONS(2985),
    [anon_sym_type] = ACTIONS(2985),
    [anon_sym_namespace] = ACTIONS(2985),
    [anon_sym_LBRACE] = ACTIONS(2987),
    [anon_sym_RBRACE] = ACTIONS(2987),
    [anon_sym_typeof] = ACTIONS(2985),
    [anon_sym_import] = ACTIONS(2985),
    [anon_sym_from] = ACTIONS(2985),
    [anon_sym_with] = ACTIONS(2985),
    [anon_sym_var] = ACTIONS(2985),
    [anon_sym_let] = ACTIONS(2985),
    [anon_sym_const] = ACTIONS(2985),
    [anon_sym_BANG] = ACTIONS(2987),
    [anon_sym_else] = ACTIONS(2985),
    [anon_sym_if] = ACTIONS(2985),
    [anon_sym_switch] = ACTIONS(2985),
    [anon_sym_for] = ACTIONS(2985),
    [anon_sym_LPAREN] = ACTIONS(2987),
    [anon_sym_await] = ACTIONS(2985),
    [anon_sym_of] = ACTIONS(2985),
    [anon_sym_while] = ACTIONS(2985),
    [anon_sym_do] = ACTIONS(2985),
    [anon_sym_try] = ACTIONS(2985),
    [anon_sym_break] = ACTIONS(2985),
    [anon_sym_continue] = ACTIONS(2985),
    [anon_sym_debugger] = ACTIONS(2985),
    [anon_sym_return] = ACTIONS(2985),
    [anon_sym_throw] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(2987),
    [anon_sym_case] = ACTIONS(2985),
    [anon_sym_yield] = ACTIONS(2985),
    [anon_sym_LBRACK] = ACTIONS(2987),
    [anon_sym_LTtemplate_GT] = ACTIONS(2987),
    [anon_sym_DQUOTE] = ACTIONS(2987),
    [anon_sym_SQUOTE] = ACTIONS(2987),
    [anon_sym_class] = ACTIONS(2985),
    [anon_sym_async] = ACTIONS(2985),
    [anon_sym_function] = ACTIONS(2985),
    [anon_sym_new] = ACTIONS(2985),
    [anon_sym_using] = ACTIONS(2985),
    [anon_sym_PLUS] = ACTIONS(2985),
    [anon_sym_DASH] = ACTIONS(2985),
    [anon_sym_SLASH] = ACTIONS(2985),
    [anon_sym_LT] = ACTIONS(2985),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_void] = ACTIONS(2985),
    [anon_sym_delete] = ACTIONS(2985),
    [anon_sym_PLUS_PLUS] = ACTIONS(2987),
    [anon_sym_DASH_DASH] = ACTIONS(2987),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2987),
    [sym_number] = ACTIONS(2987),
    [sym_private_property_identifier] = ACTIONS(2987),
    [sym_this] = ACTIONS(2985),
    [sym_super] = ACTIONS(2985),
    [sym_true] = ACTIONS(2985),
    [sym_false] = ACTIONS(2985),
    [sym_null] = ACTIONS(2985),
    [sym_undefined] = ACTIONS(2985),
    [anon_sym_AT] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(2985),
    [anon_sym_readonly] = ACTIONS(2985),
    [anon_sym_get] = ACTIONS(2985),
    [anon_sym_set] = ACTIONS(2985),
    [anon_sym_declare] = ACTIONS(2985),
    [anon_sym_public] = ACTIONS(2985),
    [anon_sym_private] = ACTIONS(2985),
    [anon_sym_protected] = ACTIONS(2985),
    [anon_sym_override] = ACTIONS(2985),
    [anon_sym_module] = ACTIONS(2985),
    [anon_sym_any] = ACTIONS(2985),
    [anon_sym_number] = ACTIONS(2985),
    [anon_sym_boolean] = ACTIONS(2985),
    [anon_sym_string] = ACTIONS(2985),
    [anon_sym_symbol] = ACTIONS(2985),
    [anon_sym_object] = ACTIONS(2985),
    [anon_sym_property] = ACTIONS(2985),
    [anon_sym_signal] = ACTIONS(2985),
    [anon_sym_on] = ACTIONS(2985),
    [anon_sym_required] = ACTIONS(2985),
    [anon_sym_component] = ACTIONS(2985),
    [anon_sym_abstract] = ACTIONS(2985),
    [anon_sym_interface] = ACTIONS(2985),
    [anon_sym_enum] = ACTIONS(2985),
    [sym_html_comment] = ACTIONS(5),
  },
  [905] = {
    [sym_comment] = STATE(905),
    [sym_identifier] = ACTIONS(3017),
    [anon_sym_export] = ACTIONS(3017),
    [anon_sym_default] = ACTIONS(3017),
    [anon_sym_type] = ACTIONS(3017),
    [anon_sym_namespace] = ACTIONS(3017),
    [anon_sym_LBRACE] = ACTIONS(3019),
    [anon_sym_RBRACE] = ACTIONS(3019),
    [anon_sym_typeof] = ACTIONS(3017),
    [anon_sym_import] = ACTIONS(3017),
    [anon_sym_from] = ACTIONS(3017),
    [anon_sym_with] = ACTIONS(3017),
    [anon_sym_var] = ACTIONS(3017),
    [anon_sym_let] = ACTIONS(3017),
    [anon_sym_const] = ACTIONS(3017),
    [anon_sym_BANG] = ACTIONS(3019),
    [anon_sym_if] = ACTIONS(3017),
    [anon_sym_switch] = ACTIONS(3017),
    [anon_sym_for] = ACTIONS(3017),
    [anon_sym_LPAREN] = ACTIONS(3019),
    [anon_sym_await] = ACTIONS(3017),
    [anon_sym_of] = ACTIONS(3017),
    [anon_sym_while] = ACTIONS(3017),
    [anon_sym_do] = ACTIONS(3017),
    [anon_sym_try] = ACTIONS(3017),
    [anon_sym_break] = ACTIONS(3017),
    [anon_sym_continue] = ACTIONS(3017),
    [anon_sym_debugger] = ACTIONS(3017),
    [anon_sym_return] = ACTIONS(3017),
    [anon_sym_throw] = ACTIONS(3017),
    [anon_sym_SEMI] = ACTIONS(3019),
    [anon_sym_case] = ACTIONS(3017),
    [anon_sym_yield] = ACTIONS(3017),
    [anon_sym_LBRACK] = ACTIONS(3019),
    [anon_sym_LTtemplate_GT] = ACTIONS(3019),
    [anon_sym_DQUOTE] = ACTIONS(3019),
    [anon_sym_SQUOTE] = ACTIONS(3019),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_async] = ACTIONS(3017),
    [anon_sym_function] = ACTIONS(3017),
    [anon_sym_new] = ACTIONS(3017),
    [anon_sym_using] = ACTIONS(3017),
    [anon_sym_PLUS] = ACTIONS(3017),
    [anon_sym_DASH] = ACTIONS(3017),
    [anon_sym_SLASH] = ACTIONS(3017),
    [anon_sym_LT] = ACTIONS(3017),
    [anon_sym_TILDE] = ACTIONS(3019),
    [anon_sym_void] = ACTIONS(3017),
    [anon_sym_delete] = ACTIONS(3017),
    [anon_sym_PLUS_PLUS] = ACTIONS(3019),
    [anon_sym_DASH_DASH] = ACTIONS(3019),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3019),
    [sym_number] = ACTIONS(3019),
    [sym_private_property_identifier] = ACTIONS(3019),
    [sym_this] = ACTIONS(3017),
    [sym_super] = ACTIONS(3017),
    [sym_true] = ACTIONS(3017),
    [sym_false] = ACTIONS(3017),
    [sym_null] = ACTIONS(3017),
    [sym_undefined] = ACTIONS(3017),
    [anon_sym_AT] = ACTIONS(3019),
    [anon_sym_static] = ACTIONS(3017),
    [anon_sym_readonly] = ACTIONS(3017),
    [anon_sym_get] = ACTIONS(3017),
    [anon_sym_set] = ACTIONS(3017),
    [anon_sym_declare] = ACTIONS(3017),
    [anon_sym_public] = ACTIONS(3017),
    [anon_sym_private] = ACTIONS(3017),
    [anon_sym_protected] = ACTIONS(3017),
    [anon_sym_override] = ACTIONS(3017),
    [anon_sym_module] = ACTIONS(3017),
    [anon_sym_any] = ACTIONS(3017),
    [anon_sym_number] = ACTIONS(3017),
    [anon_sym_boolean] = ACTIONS(3017),
    [anon_sym_string] = ACTIONS(3017),
    [anon_sym_symbol] = ACTIONS(3017),
    [anon_sym_object] = ACTIONS(3017),
    [anon_sym_property] = ACTIONS(3017),
    [anon_sym_signal] = ACTIONS(3017),
    [anon_sym_on] = ACTIONS(3017),
    [anon_sym_required] = ACTIONS(3017),
    [anon_sym_component] = ACTIONS(3017),
    [anon_sym_abstract] = ACTIONS(3017),
    [anon_sym_interface] = ACTIONS(3017),
    [anon_sym_enum] = ACTIONS(3017),
    [sym_html_comment] = ACTIONS(5),
  },
  [906] = {
    [sym_comment] = STATE(906),
    [sym_identifier] = ACTIONS(3021),
    [anon_sym_export] = ACTIONS(3021),
    [anon_sym_type] = ACTIONS(3021),
    [anon_sym_namespace] = ACTIONS(3021),
    [anon_sym_LBRACE] = ACTIONS(3023),
    [anon_sym_typeof] = ACTIONS(3021),
    [anon_sym_import] = ACTIONS(3021),
    [anon_sym_from] = ACTIONS(3021),
    [anon_sym_with] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3021),
    [anon_sym_let] = ACTIONS(3021),
    [anon_sym_const] = ACTIONS(3021),
    [anon_sym_BANG] = ACTIONS(3023),
    [anon_sym_if] = ACTIONS(3021),
    [anon_sym_switch] = ACTIONS(3021),
    [anon_sym_for] = ACTIONS(3021),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_await] = ACTIONS(3021),
    [anon_sym_of] = ACTIONS(3021),
    [anon_sym_while] = ACTIONS(3021),
    [anon_sym_do] = ACTIONS(3021),
    [anon_sym_try] = ACTIONS(3021),
    [anon_sym_break] = ACTIONS(3021),
    [anon_sym_continue] = ACTIONS(3021),
    [anon_sym_debugger] = ACTIONS(3021),
    [anon_sym_return] = ACTIONS(3021),
    [anon_sym_throw] = ACTIONS(3021),
    [anon_sym_SEMI] = ACTIONS(3023),
    [anon_sym_yield] = ACTIONS(3021),
    [anon_sym_LBRACK] = ACTIONS(3023),
    [anon_sym_LTtemplate_GT] = ACTIONS(3023),
    [anon_sym_DQUOTE] = ACTIONS(3023),
    [anon_sym_SQUOTE] = ACTIONS(3023),
    [anon_sym_class] = ACTIONS(3021),
    [anon_sym_async] = ACTIONS(3021),
    [anon_sym_function] = ACTIONS(3021),
    [anon_sym_new] = ACTIONS(3021),
    [anon_sym_using] = ACTIONS(3021),
    [anon_sym_PLUS] = ACTIONS(3021),
    [anon_sym_DASH] = ACTIONS(3021),
    [anon_sym_SLASH] = ACTIONS(3021),
    [anon_sym_LT] = ACTIONS(3021),
    [anon_sym_TILDE] = ACTIONS(3023),
    [anon_sym_void] = ACTIONS(3021),
    [anon_sym_delete] = ACTIONS(3021),
    [anon_sym_PLUS_PLUS] = ACTIONS(3023),
    [anon_sym_DASH_DASH] = ACTIONS(3023),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3023),
    [sym_number] = ACTIONS(3023),
    [sym_private_property_identifier] = ACTIONS(3023),
    [sym_this] = ACTIONS(3021),
    [sym_super] = ACTIONS(3021),
    [sym_true] = ACTIONS(3021),
    [sym_false] = ACTIONS(3021),
    [sym_null] = ACTIONS(3021),
    [sym_undefined] = ACTIONS(3021),
    [anon_sym_AT] = ACTIONS(3023),
    [anon_sym_static] = ACTIONS(3021),
    [anon_sym_readonly] = ACTIONS(3021),
    [anon_sym_get] = ACTIONS(3021),
    [anon_sym_set] = ACTIONS(3021),
    [anon_sym_declare] = ACTIONS(3021),
    [anon_sym_public] = ACTIONS(3021),
    [anon_sym_private] = ACTIONS(3021),
    [anon_sym_protected] = ACTIONS(3021),
    [anon_sym_override] = ACTIONS(3021),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_any] = ACTIONS(3021),
    [anon_sym_number] = ACTIONS(3021),
    [anon_sym_boolean] = ACTIONS(3021),
    [anon_sym_string] = ACTIONS(3021),
    [anon_sym_symbol] = ACTIONS(3021),
    [anon_sym_object] = ACTIONS(3021),
    [anon_sym_property] = ACTIONS(3021),
    [anon_sym_signal] = ACTIONS(3021),
    [anon_sym_on] = ACTIONS(3021),
    [anon_sym_required] = ACTIONS(3021),
    [anon_sym_component] = ACTIONS(3021),
    [anon_sym_abstract] = ACTIONS(3021),
    [anon_sym_interface] = ACTIONS(3021),
    [anon_sym_enum] = ACTIONS(3021),
    [sym_html_comment] = ACTIONS(5),
  },
  [907] = {
    [sym_comment] = STATE(907),
    [sym_identifier] = ACTIONS(3025),
    [anon_sym_export] = ACTIONS(3025),
    [anon_sym_type] = ACTIONS(3025),
    [anon_sym_namespace] = ACTIONS(3025),
    [anon_sym_LBRACE] = ACTIONS(3027),
    [anon_sym_typeof] = ACTIONS(3025),
    [anon_sym_import] = ACTIONS(3025),
    [anon_sym_from] = ACTIONS(3025),
    [anon_sym_with] = ACTIONS(3025),
    [anon_sym_var] = ACTIONS(3025),
    [anon_sym_let] = ACTIONS(3025),
    [anon_sym_const] = ACTIONS(3025),
    [anon_sym_BANG] = ACTIONS(3027),
    [anon_sym_if] = ACTIONS(3025),
    [anon_sym_switch] = ACTIONS(3025),
    [anon_sym_for] = ACTIONS(3025),
    [anon_sym_LPAREN] = ACTIONS(3027),
    [anon_sym_await] = ACTIONS(3025),
    [anon_sym_of] = ACTIONS(3025),
    [anon_sym_while] = ACTIONS(3025),
    [anon_sym_do] = ACTIONS(3025),
    [anon_sym_try] = ACTIONS(3025),
    [anon_sym_break] = ACTIONS(3025),
    [anon_sym_continue] = ACTIONS(3025),
    [anon_sym_debugger] = ACTIONS(3025),
    [anon_sym_return] = ACTIONS(3025),
    [anon_sym_throw] = ACTIONS(3025),
    [anon_sym_SEMI] = ACTIONS(3027),
    [anon_sym_yield] = ACTIONS(3025),
    [anon_sym_LBRACK] = ACTIONS(3027),
    [anon_sym_LTtemplate_GT] = ACTIONS(3027),
    [anon_sym_DQUOTE] = ACTIONS(3027),
    [anon_sym_SQUOTE] = ACTIONS(3027),
    [anon_sym_class] = ACTIONS(3025),
    [anon_sym_async] = ACTIONS(3025),
    [anon_sym_function] = ACTIONS(3025),
    [anon_sym_new] = ACTIONS(3025),
    [anon_sym_using] = ACTIONS(3025),
    [anon_sym_PLUS] = ACTIONS(3025),
    [anon_sym_DASH] = ACTIONS(3025),
    [anon_sym_SLASH] = ACTIONS(3025),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_TILDE] = ACTIONS(3027),
    [anon_sym_void] = ACTIONS(3025),
    [anon_sym_delete] = ACTIONS(3025),
    [anon_sym_PLUS_PLUS] = ACTIONS(3027),
    [anon_sym_DASH_DASH] = ACTIONS(3027),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3027),
    [sym_number] = ACTIONS(3027),
    [sym_private_property_identifier] = ACTIONS(3027),
    [sym_this] = ACTIONS(3025),
    [sym_super] = ACTIONS(3025),
    [sym_true] = ACTIONS(3025),
    [sym_false] = ACTIONS(3025),
    [sym_null] = ACTIONS(3025),
    [sym_undefined] = ACTIONS(3025),
    [anon_sym_AT] = ACTIONS(3027),
    [anon_sym_static] = ACTIONS(3025),
    [anon_sym_readonly] = ACTIONS(3025),
    [anon_sym_get] = ACTIONS(3025),
    [anon_sym_set] = ACTIONS(3025),
    [anon_sym_declare] = ACTIONS(3025),
    [anon_sym_public] = ACTIONS(3025),
    [anon_sym_private] = ACTIONS(3025),
    [anon_sym_protected] = ACTIONS(3025),
    [anon_sym_override] = ACTIONS(3025),
    [anon_sym_module] = ACTIONS(3025),
    [anon_sym_any] = ACTIONS(3025),
    [anon_sym_number] = ACTIONS(3025),
    [anon_sym_boolean] = ACTIONS(3025),
    [anon_sym_string] = ACTIONS(3025),
    [anon_sym_symbol] = ACTIONS(3025),
    [anon_sym_object] = ACTIONS(3025),
    [anon_sym_property] = ACTIONS(3025),
    [anon_sym_signal] = ACTIONS(3025),
    [anon_sym_on] = ACTIONS(3025),
    [anon_sym_required] = ACTIONS(3025),
    [anon_sym_component] = ACTIONS(3025),
    [anon_sym_abstract] = ACTIONS(3025),
    [anon_sym_interface] = ACTIONS(3025),
    [anon_sym_enum] = ACTIONS(3025),
    [sym_html_comment] = ACTIONS(5),
  },
  [908] = {
    [sym_comment] = STATE(908),
    [sym_identifier] = ACTIONS(3021),
    [anon_sym_export] = ACTIONS(3021),
    [anon_sym_type] = ACTIONS(3021),
    [anon_sym_namespace] = ACTIONS(3021),
    [anon_sym_LBRACE] = ACTIONS(3023),
    [anon_sym_typeof] = ACTIONS(3021),
    [anon_sym_import] = ACTIONS(3021),
    [anon_sym_from] = ACTIONS(3021),
    [anon_sym_with] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3021),
    [anon_sym_let] = ACTIONS(3021),
    [anon_sym_const] = ACTIONS(3021),
    [anon_sym_BANG] = ACTIONS(3023),
    [anon_sym_if] = ACTIONS(3021),
    [anon_sym_switch] = ACTIONS(3021),
    [anon_sym_for] = ACTIONS(3021),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_await] = ACTIONS(3021),
    [anon_sym_of] = ACTIONS(3021),
    [anon_sym_while] = ACTIONS(3021),
    [anon_sym_do] = ACTIONS(3021),
    [anon_sym_try] = ACTIONS(3021),
    [anon_sym_break] = ACTIONS(3021),
    [anon_sym_continue] = ACTIONS(3021),
    [anon_sym_debugger] = ACTIONS(3021),
    [anon_sym_return] = ACTIONS(3021),
    [anon_sym_throw] = ACTIONS(3021),
    [anon_sym_SEMI] = ACTIONS(3023),
    [anon_sym_yield] = ACTIONS(3021),
    [anon_sym_LBRACK] = ACTIONS(3023),
    [anon_sym_LTtemplate_GT] = ACTIONS(3023),
    [anon_sym_DQUOTE] = ACTIONS(3023),
    [anon_sym_SQUOTE] = ACTIONS(3023),
    [anon_sym_class] = ACTIONS(3021),
    [anon_sym_async] = ACTIONS(3021),
    [anon_sym_function] = ACTIONS(3021),
    [anon_sym_new] = ACTIONS(3021),
    [anon_sym_using] = ACTIONS(3021),
    [anon_sym_PLUS] = ACTIONS(3021),
    [anon_sym_DASH] = ACTIONS(3021),
    [anon_sym_SLASH] = ACTIONS(3021),
    [anon_sym_LT] = ACTIONS(3021),
    [anon_sym_TILDE] = ACTIONS(3023),
    [anon_sym_void] = ACTIONS(3021),
    [anon_sym_delete] = ACTIONS(3021),
    [anon_sym_PLUS_PLUS] = ACTIONS(3023),
    [anon_sym_DASH_DASH] = ACTIONS(3023),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3023),
    [sym_number] = ACTIONS(3023),
    [sym_private_property_identifier] = ACTIONS(3023),
    [sym_this] = ACTIONS(3021),
    [sym_super] = ACTIONS(3021),
    [sym_true] = ACTIONS(3021),
    [sym_false] = ACTIONS(3021),
    [sym_null] = ACTIONS(3021),
    [sym_undefined] = ACTIONS(3021),
    [anon_sym_AT] = ACTIONS(3023),
    [anon_sym_static] = ACTIONS(3021),
    [anon_sym_readonly] = ACTIONS(3021),
    [anon_sym_get] = ACTIONS(3021),
    [anon_sym_set] = ACTIONS(3021),
    [anon_sym_declare] = ACTIONS(3021),
    [anon_sym_public] = ACTIONS(3021),
    [anon_sym_private] = ACTIONS(3021),
    [anon_sym_protected] = ACTIONS(3021),
    [anon_sym_override] = ACTIONS(3021),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_any] = ACTIONS(3021),
    [anon_sym_number] = ACTIONS(3021),
    [anon_sym_boolean] = ACTIONS(3021),
    [anon_sym_string] = ACTIONS(3021),
    [anon_sym_symbol] = ACTIONS(3021),
    [anon_sym_object] = ACTIONS(3021),
    [anon_sym_property] = ACTIONS(3021),
    [anon_sym_signal] = ACTIONS(3021),
    [anon_sym_on] = ACTIONS(3021),
    [anon_sym_required] = ACTIONS(3021),
    [anon_sym_component] = ACTIONS(3021),
    [anon_sym_abstract] = ACTIONS(3021),
    [anon_sym_interface] = ACTIONS(3021),
    [anon_sym_enum] = ACTIONS(3021),
    [sym_html_comment] = ACTIONS(5),
  },
  [909] = {
    [sym_comment] = STATE(909),
    [sym_identifier] = ACTIONS(3021),
    [anon_sym_export] = ACTIONS(3021),
    [anon_sym_type] = ACTIONS(3021),
    [anon_sym_namespace] = ACTIONS(3021),
    [anon_sym_LBRACE] = ACTIONS(3023),
    [anon_sym_typeof] = ACTIONS(3021),
    [anon_sym_import] = ACTIONS(3021),
    [anon_sym_from] = ACTIONS(3021),
    [anon_sym_with] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3021),
    [anon_sym_let] = ACTIONS(3021),
    [anon_sym_const] = ACTIONS(3021),
    [anon_sym_BANG] = ACTIONS(3023),
    [anon_sym_if] = ACTIONS(3021),
    [anon_sym_switch] = ACTIONS(3021),
    [anon_sym_for] = ACTIONS(3021),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_await] = ACTIONS(3021),
    [anon_sym_of] = ACTIONS(3021),
    [anon_sym_while] = ACTIONS(3021),
    [anon_sym_do] = ACTIONS(3021),
    [anon_sym_try] = ACTIONS(3021),
    [anon_sym_break] = ACTIONS(3021),
    [anon_sym_continue] = ACTIONS(3021),
    [anon_sym_debugger] = ACTIONS(3021),
    [anon_sym_return] = ACTIONS(3021),
    [anon_sym_throw] = ACTIONS(3021),
    [anon_sym_SEMI] = ACTIONS(3023),
    [anon_sym_yield] = ACTIONS(3021),
    [anon_sym_LBRACK] = ACTIONS(3023),
    [anon_sym_LTtemplate_GT] = ACTIONS(3023),
    [anon_sym_DQUOTE] = ACTIONS(3023),
    [anon_sym_SQUOTE] = ACTIONS(3023),
    [anon_sym_class] = ACTIONS(3021),
    [anon_sym_async] = ACTIONS(3021),
    [anon_sym_function] = ACTIONS(3021),
    [anon_sym_new] = ACTIONS(3021),
    [anon_sym_using] = ACTIONS(3021),
    [anon_sym_PLUS] = ACTIONS(3021),
    [anon_sym_DASH] = ACTIONS(3021),
    [anon_sym_SLASH] = ACTIONS(3021),
    [anon_sym_LT] = ACTIONS(3021),
    [anon_sym_TILDE] = ACTIONS(3023),
    [anon_sym_void] = ACTIONS(3021),
    [anon_sym_delete] = ACTIONS(3021),
    [anon_sym_PLUS_PLUS] = ACTIONS(3023),
    [anon_sym_DASH_DASH] = ACTIONS(3023),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3023),
    [sym_number] = ACTIONS(3023),
    [sym_private_property_identifier] = ACTIONS(3023),
    [sym_this] = ACTIONS(3021),
    [sym_super] = ACTIONS(3021),
    [sym_true] = ACTIONS(3021),
    [sym_false] = ACTIONS(3021),
    [sym_null] = ACTIONS(3021),
    [sym_undefined] = ACTIONS(3021),
    [anon_sym_AT] = ACTIONS(3023),
    [anon_sym_static] = ACTIONS(3021),
    [anon_sym_readonly] = ACTIONS(3021),
    [anon_sym_get] = ACTIONS(3021),
    [anon_sym_set] = ACTIONS(3021),
    [anon_sym_declare] = ACTIONS(3021),
    [anon_sym_public] = ACTIONS(3021),
    [anon_sym_private] = ACTIONS(3021),
    [anon_sym_protected] = ACTIONS(3021),
    [anon_sym_override] = ACTIONS(3021),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_any] = ACTIONS(3021),
    [anon_sym_number] = ACTIONS(3021),
    [anon_sym_boolean] = ACTIONS(3021),
    [anon_sym_string] = ACTIONS(3021),
    [anon_sym_symbol] = ACTIONS(3021),
    [anon_sym_object] = ACTIONS(3021),
    [anon_sym_property] = ACTIONS(3021),
    [anon_sym_signal] = ACTIONS(3021),
    [anon_sym_on] = ACTIONS(3021),
    [anon_sym_required] = ACTIONS(3021),
    [anon_sym_component] = ACTIONS(3021),
    [anon_sym_abstract] = ACTIONS(3021),
    [anon_sym_interface] = ACTIONS(3021),
    [anon_sym_enum] = ACTIONS(3021),
    [sym_html_comment] = ACTIONS(5),
  },
  [910] = {
    [sym_comment] = STATE(910),
    [sym_identifier] = ACTIONS(3021),
    [anon_sym_export] = ACTIONS(3021),
    [anon_sym_type] = ACTIONS(3021),
    [anon_sym_namespace] = ACTIONS(3021),
    [anon_sym_LBRACE] = ACTIONS(3023),
    [anon_sym_typeof] = ACTIONS(3021),
    [anon_sym_import] = ACTIONS(3021),
    [anon_sym_from] = ACTIONS(3021),
    [anon_sym_with] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3021),
    [anon_sym_let] = ACTIONS(3021),
    [anon_sym_const] = ACTIONS(3021),
    [anon_sym_BANG] = ACTIONS(3023),
    [anon_sym_if] = ACTIONS(3021),
    [anon_sym_switch] = ACTIONS(3021),
    [anon_sym_for] = ACTIONS(3021),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_await] = ACTIONS(3021),
    [anon_sym_of] = ACTIONS(3021),
    [anon_sym_while] = ACTIONS(3021),
    [anon_sym_do] = ACTIONS(3021),
    [anon_sym_try] = ACTIONS(3021),
    [anon_sym_break] = ACTIONS(3021),
    [anon_sym_continue] = ACTIONS(3021),
    [anon_sym_debugger] = ACTIONS(3021),
    [anon_sym_return] = ACTIONS(3021),
    [anon_sym_throw] = ACTIONS(3021),
    [anon_sym_SEMI] = ACTIONS(3023),
    [anon_sym_yield] = ACTIONS(3021),
    [anon_sym_LBRACK] = ACTIONS(3023),
    [anon_sym_LTtemplate_GT] = ACTIONS(3023),
    [anon_sym_DQUOTE] = ACTIONS(3023),
    [anon_sym_SQUOTE] = ACTIONS(3023),
    [anon_sym_class] = ACTIONS(3021),
    [anon_sym_async] = ACTIONS(3021),
    [anon_sym_function] = ACTIONS(3021),
    [anon_sym_new] = ACTIONS(3021),
    [anon_sym_using] = ACTIONS(3021),
    [anon_sym_PLUS] = ACTIONS(3021),
    [anon_sym_DASH] = ACTIONS(3021),
    [anon_sym_SLASH] = ACTIONS(3021),
    [anon_sym_LT] = ACTIONS(3021),
    [anon_sym_TILDE] = ACTIONS(3023),
    [anon_sym_void] = ACTIONS(3021),
    [anon_sym_delete] = ACTIONS(3021),
    [anon_sym_PLUS_PLUS] = ACTIONS(3023),
    [anon_sym_DASH_DASH] = ACTIONS(3023),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3023),
    [sym_number] = ACTIONS(3023),
    [sym_private_property_identifier] = ACTIONS(3023),
    [sym_this] = ACTIONS(3021),
    [sym_super] = ACTIONS(3021),
    [sym_true] = ACTIONS(3021),
    [sym_false] = ACTIONS(3021),
    [sym_null] = ACTIONS(3021),
    [sym_undefined] = ACTIONS(3021),
    [anon_sym_AT] = ACTIONS(3023),
    [anon_sym_static] = ACTIONS(3021),
    [anon_sym_readonly] = ACTIONS(3021),
    [anon_sym_get] = ACTIONS(3021),
    [anon_sym_set] = ACTIONS(3021),
    [anon_sym_declare] = ACTIONS(3021),
    [anon_sym_public] = ACTIONS(3021),
    [anon_sym_private] = ACTIONS(3021),
    [anon_sym_protected] = ACTIONS(3021),
    [anon_sym_override] = ACTIONS(3021),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_any] = ACTIONS(3021),
    [anon_sym_number] = ACTIONS(3021),
    [anon_sym_boolean] = ACTIONS(3021),
    [anon_sym_string] = ACTIONS(3021),
    [anon_sym_symbol] = ACTIONS(3021),
    [anon_sym_object] = ACTIONS(3021),
    [anon_sym_property] = ACTIONS(3021),
    [anon_sym_signal] = ACTIONS(3021),
    [anon_sym_on] = ACTIONS(3021),
    [anon_sym_required] = ACTIONS(3021),
    [anon_sym_component] = ACTIONS(3021),
    [anon_sym_abstract] = ACTIONS(3021),
    [anon_sym_interface] = ACTIONS(3021),
    [anon_sym_enum] = ACTIONS(3021),
    [sym_html_comment] = ACTIONS(5),
  },
  [911] = {
    [sym_comment] = STATE(911),
    [sym_identifier] = ACTIONS(3021),
    [anon_sym_export] = ACTIONS(3021),
    [anon_sym_type] = ACTIONS(3021),
    [anon_sym_namespace] = ACTIONS(3021),
    [anon_sym_LBRACE] = ACTIONS(3023),
    [anon_sym_typeof] = ACTIONS(3021),
    [anon_sym_import] = ACTIONS(3021),
    [anon_sym_from] = ACTIONS(3021),
    [anon_sym_with] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3021),
    [anon_sym_let] = ACTIONS(3021),
    [anon_sym_const] = ACTIONS(3021),
    [anon_sym_BANG] = ACTIONS(3023),
    [anon_sym_if] = ACTIONS(3021),
    [anon_sym_switch] = ACTIONS(3021),
    [anon_sym_for] = ACTIONS(3021),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_await] = ACTIONS(3021),
    [anon_sym_of] = ACTIONS(3021),
    [anon_sym_while] = ACTIONS(3021),
    [anon_sym_do] = ACTIONS(3021),
    [anon_sym_try] = ACTIONS(3021),
    [anon_sym_break] = ACTIONS(3021),
    [anon_sym_continue] = ACTIONS(3021),
    [anon_sym_debugger] = ACTIONS(3021),
    [anon_sym_return] = ACTIONS(3021),
    [anon_sym_throw] = ACTIONS(3021),
    [anon_sym_SEMI] = ACTIONS(3023),
    [anon_sym_yield] = ACTIONS(3021),
    [anon_sym_LBRACK] = ACTIONS(3023),
    [anon_sym_LTtemplate_GT] = ACTIONS(3023),
    [anon_sym_DQUOTE] = ACTIONS(3023),
    [anon_sym_SQUOTE] = ACTIONS(3023),
    [anon_sym_class] = ACTIONS(3021),
    [anon_sym_async] = ACTIONS(3021),
    [anon_sym_function] = ACTIONS(3021),
    [anon_sym_new] = ACTIONS(3021),
    [anon_sym_using] = ACTIONS(3021),
    [anon_sym_PLUS] = ACTIONS(3021),
    [anon_sym_DASH] = ACTIONS(3021),
    [anon_sym_SLASH] = ACTIONS(3021),
    [anon_sym_LT] = ACTIONS(3021),
    [anon_sym_TILDE] = ACTIONS(3023),
    [anon_sym_void] = ACTIONS(3021),
    [anon_sym_delete] = ACTIONS(3021),
    [anon_sym_PLUS_PLUS] = ACTIONS(3023),
    [anon_sym_DASH_DASH] = ACTIONS(3023),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3023),
    [sym_number] = ACTIONS(3023),
    [sym_private_property_identifier] = ACTIONS(3023),
    [sym_this] = ACTIONS(3021),
    [sym_super] = ACTIONS(3021),
    [sym_true] = ACTIONS(3021),
    [sym_false] = ACTIONS(3021),
    [sym_null] = ACTIONS(3021),
    [sym_undefined] = ACTIONS(3021),
    [anon_sym_AT] = ACTIONS(3023),
    [anon_sym_static] = ACTIONS(3021),
    [anon_sym_readonly] = ACTIONS(3021),
    [anon_sym_get] = ACTIONS(3021),
    [anon_sym_set] = ACTIONS(3021),
    [anon_sym_declare] = ACTIONS(3021),
    [anon_sym_public] = ACTIONS(3021),
    [anon_sym_private] = ACTIONS(3021),
    [anon_sym_protected] = ACTIONS(3021),
    [anon_sym_override] = ACTIONS(3021),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_any] = ACTIONS(3021),
    [anon_sym_number] = ACTIONS(3021),
    [anon_sym_boolean] = ACTIONS(3021),
    [anon_sym_string] = ACTIONS(3021),
    [anon_sym_symbol] = ACTIONS(3021),
    [anon_sym_object] = ACTIONS(3021),
    [anon_sym_property] = ACTIONS(3021),
    [anon_sym_signal] = ACTIONS(3021),
    [anon_sym_on] = ACTIONS(3021),
    [anon_sym_required] = ACTIONS(3021),
    [anon_sym_component] = ACTIONS(3021),
    [anon_sym_abstract] = ACTIONS(3021),
    [anon_sym_interface] = ACTIONS(3021),
    [anon_sym_enum] = ACTIONS(3021),
    [sym_html_comment] = ACTIONS(5),
  },
  [912] = {
    [sym_comment] = STATE(912),
    [sym_identifier] = ACTIONS(3021),
    [anon_sym_export] = ACTIONS(3021),
    [anon_sym_type] = ACTIONS(3021),
    [anon_sym_namespace] = ACTIONS(3021),
    [anon_sym_LBRACE] = ACTIONS(3023),
    [anon_sym_typeof] = ACTIONS(3021),
    [anon_sym_import] = ACTIONS(3021),
    [anon_sym_from] = ACTIONS(3021),
    [anon_sym_with] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3021),
    [anon_sym_let] = ACTIONS(3021),
    [anon_sym_const] = ACTIONS(3021),
    [anon_sym_BANG] = ACTIONS(3023),
    [anon_sym_if] = ACTIONS(3021),
    [anon_sym_switch] = ACTIONS(3021),
    [anon_sym_for] = ACTIONS(3021),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_await] = ACTIONS(3021),
    [anon_sym_of] = ACTIONS(3021),
    [anon_sym_while] = ACTIONS(3021),
    [anon_sym_do] = ACTIONS(3021),
    [anon_sym_try] = ACTIONS(3021),
    [anon_sym_break] = ACTIONS(3021),
    [anon_sym_continue] = ACTIONS(3021),
    [anon_sym_debugger] = ACTIONS(3021),
    [anon_sym_return] = ACTIONS(3021),
    [anon_sym_throw] = ACTIONS(3021),
    [anon_sym_SEMI] = ACTIONS(3023),
    [anon_sym_yield] = ACTIONS(3021),
    [anon_sym_LBRACK] = ACTIONS(3023),
    [anon_sym_LTtemplate_GT] = ACTIONS(3023),
    [anon_sym_DQUOTE] = ACTIONS(3023),
    [anon_sym_SQUOTE] = ACTIONS(3023),
    [anon_sym_class] = ACTIONS(3021),
    [anon_sym_async] = ACTIONS(3021),
    [anon_sym_function] = ACTIONS(3021),
    [anon_sym_new] = ACTIONS(3021),
    [anon_sym_using] = ACTIONS(3021),
    [anon_sym_PLUS] = ACTIONS(3021),
    [anon_sym_DASH] = ACTIONS(3021),
    [anon_sym_SLASH] = ACTIONS(3021),
    [anon_sym_LT] = ACTIONS(3021),
    [anon_sym_TILDE] = ACTIONS(3023),
    [anon_sym_void] = ACTIONS(3021),
    [anon_sym_delete] = ACTIONS(3021),
    [anon_sym_PLUS_PLUS] = ACTIONS(3023),
    [anon_sym_DASH_DASH] = ACTIONS(3023),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3023),
    [sym_number] = ACTIONS(3023),
    [sym_private_property_identifier] = ACTIONS(3023),
    [sym_this] = ACTIONS(3021),
    [sym_super] = ACTIONS(3021),
    [sym_true] = ACTIONS(3021),
    [sym_false] = ACTIONS(3021),
    [sym_null] = ACTIONS(3021),
    [sym_undefined] = ACTIONS(3021),
    [anon_sym_AT] = ACTIONS(3023),
    [anon_sym_static] = ACTIONS(3021),
    [anon_sym_readonly] = ACTIONS(3021),
    [anon_sym_get] = ACTIONS(3021),
    [anon_sym_set] = ACTIONS(3021),
    [anon_sym_declare] = ACTIONS(3021),
    [anon_sym_public] = ACTIONS(3021),
    [anon_sym_private] = ACTIONS(3021),
    [anon_sym_protected] = ACTIONS(3021),
    [anon_sym_override] = ACTIONS(3021),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_any] = ACTIONS(3021),
    [anon_sym_number] = ACTIONS(3021),
    [anon_sym_boolean] = ACTIONS(3021),
    [anon_sym_string] = ACTIONS(3021),
    [anon_sym_symbol] = ACTIONS(3021),
    [anon_sym_object] = ACTIONS(3021),
    [anon_sym_property] = ACTIONS(3021),
    [anon_sym_signal] = ACTIONS(3021),
    [anon_sym_on] = ACTIONS(3021),
    [anon_sym_required] = ACTIONS(3021),
    [anon_sym_component] = ACTIONS(3021),
    [anon_sym_abstract] = ACTIONS(3021),
    [anon_sym_interface] = ACTIONS(3021),
    [anon_sym_enum] = ACTIONS(3021),
    [sym_html_comment] = ACTIONS(5),
  },
  [913] = {
    [sym_comment] = STATE(913),
    [sym_identifier] = ACTIONS(3021),
    [anon_sym_export] = ACTIONS(3021),
    [anon_sym_type] = ACTIONS(3021),
    [anon_sym_namespace] = ACTIONS(3021),
    [anon_sym_LBRACE] = ACTIONS(3023),
    [anon_sym_typeof] = ACTIONS(3021),
    [anon_sym_import] = ACTIONS(3021),
    [anon_sym_from] = ACTIONS(3021),
    [anon_sym_with] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3021),
    [anon_sym_let] = ACTIONS(3021),
    [anon_sym_const] = ACTIONS(3021),
    [anon_sym_BANG] = ACTIONS(3023),
    [anon_sym_if] = ACTIONS(3021),
    [anon_sym_switch] = ACTIONS(3021),
    [anon_sym_for] = ACTIONS(3021),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_await] = ACTIONS(3021),
    [anon_sym_of] = ACTIONS(3021),
    [anon_sym_while] = ACTIONS(3021),
    [anon_sym_do] = ACTIONS(3021),
    [anon_sym_try] = ACTIONS(3021),
    [anon_sym_break] = ACTIONS(3021),
    [anon_sym_continue] = ACTIONS(3021),
    [anon_sym_debugger] = ACTIONS(3021),
    [anon_sym_return] = ACTIONS(3021),
    [anon_sym_throw] = ACTIONS(3021),
    [anon_sym_SEMI] = ACTIONS(3023),
    [anon_sym_yield] = ACTIONS(3021),
    [anon_sym_LBRACK] = ACTIONS(3023),
    [anon_sym_LTtemplate_GT] = ACTIONS(3023),
    [anon_sym_DQUOTE] = ACTIONS(3023),
    [anon_sym_SQUOTE] = ACTIONS(3023),
    [anon_sym_class] = ACTIONS(3021),
    [anon_sym_async] = ACTIONS(3021),
    [anon_sym_function] = ACTIONS(3021),
    [anon_sym_new] = ACTIONS(3021),
    [anon_sym_using] = ACTIONS(3021),
    [anon_sym_PLUS] = ACTIONS(3021),
    [anon_sym_DASH] = ACTIONS(3021),
    [anon_sym_SLASH] = ACTIONS(3021),
    [anon_sym_LT] = ACTIONS(3021),
    [anon_sym_TILDE] = ACTIONS(3023),
    [anon_sym_void] = ACTIONS(3021),
    [anon_sym_delete] = ACTIONS(3021),
    [anon_sym_PLUS_PLUS] = ACTIONS(3023),
    [anon_sym_DASH_DASH] = ACTIONS(3023),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3023),
    [sym_number] = ACTIONS(3023),
    [sym_private_property_identifier] = ACTIONS(3023),
    [sym_this] = ACTIONS(3021),
    [sym_super] = ACTIONS(3021),
    [sym_true] = ACTIONS(3021),
    [sym_false] = ACTIONS(3021),
    [sym_null] = ACTIONS(3021),
    [sym_undefined] = ACTIONS(3021),
    [anon_sym_AT] = ACTIONS(3023),
    [anon_sym_static] = ACTIONS(3021),
    [anon_sym_readonly] = ACTIONS(3021),
    [anon_sym_get] = ACTIONS(3021),
    [anon_sym_set] = ACTIONS(3021),
    [anon_sym_declare] = ACTIONS(3021),
    [anon_sym_public] = ACTIONS(3021),
    [anon_sym_private] = ACTIONS(3021),
    [anon_sym_protected] = ACTIONS(3021),
    [anon_sym_override] = ACTIONS(3021),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_any] = ACTIONS(3021),
    [anon_sym_number] = ACTIONS(3021),
    [anon_sym_boolean] = ACTIONS(3021),
    [anon_sym_string] = ACTIONS(3021),
    [anon_sym_symbol] = ACTIONS(3021),
    [anon_sym_object] = ACTIONS(3021),
    [anon_sym_property] = ACTIONS(3021),
    [anon_sym_signal] = ACTIONS(3021),
    [anon_sym_on] = ACTIONS(3021),
    [anon_sym_required] = ACTIONS(3021),
    [anon_sym_component] = ACTIONS(3021),
    [anon_sym_abstract] = ACTIONS(3021),
    [anon_sym_interface] = ACTIONS(3021),
    [anon_sym_enum] = ACTIONS(3021),
    [sym_html_comment] = ACTIONS(5),
  },
  [914] = {
    [sym_comment] = STATE(914),
    [sym_identifier] = ACTIONS(3029),
    [anon_sym_export] = ACTIONS(3029),
    [anon_sym_type] = ACTIONS(3029),
    [anon_sym_namespace] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [anon_sym_typeof] = ACTIONS(3029),
    [anon_sym_import] = ACTIONS(3029),
    [anon_sym_from] = ACTIONS(3029),
    [anon_sym_with] = ACTIONS(3029),
    [anon_sym_var] = ACTIONS(3029),
    [anon_sym_let] = ACTIONS(3029),
    [anon_sym_const] = ACTIONS(3029),
    [anon_sym_BANG] = ACTIONS(3031),
    [anon_sym_if] = ACTIONS(3029),
    [anon_sym_switch] = ACTIONS(3029),
    [anon_sym_for] = ACTIONS(3029),
    [anon_sym_LPAREN] = ACTIONS(3031),
    [anon_sym_await] = ACTIONS(3029),
    [anon_sym_of] = ACTIONS(3029),
    [anon_sym_while] = ACTIONS(3029),
    [anon_sym_do] = ACTIONS(3029),
    [anon_sym_try] = ACTIONS(3029),
    [anon_sym_break] = ACTIONS(3029),
    [anon_sym_continue] = ACTIONS(3029),
    [anon_sym_debugger] = ACTIONS(3029),
    [anon_sym_return] = ACTIONS(3029),
    [anon_sym_throw] = ACTIONS(3029),
    [anon_sym_SEMI] = ACTIONS(3031),
    [anon_sym_yield] = ACTIONS(3029),
    [anon_sym_LBRACK] = ACTIONS(3031),
    [anon_sym_LTtemplate_GT] = ACTIONS(3031),
    [anon_sym_DQUOTE] = ACTIONS(3031),
    [anon_sym_SQUOTE] = ACTIONS(3031),
    [anon_sym_class] = ACTIONS(3029),
    [anon_sym_async] = ACTIONS(3029),
    [anon_sym_function] = ACTIONS(3029),
    [anon_sym_new] = ACTIONS(3029),
    [anon_sym_using] = ACTIONS(3029),
    [anon_sym_PLUS] = ACTIONS(3029),
    [anon_sym_DASH] = ACTIONS(3029),
    [anon_sym_SLASH] = ACTIONS(3029),
    [anon_sym_LT] = ACTIONS(3029),
    [anon_sym_TILDE] = ACTIONS(3031),
    [anon_sym_void] = ACTIONS(3029),
    [anon_sym_delete] = ACTIONS(3029),
    [anon_sym_PLUS_PLUS] = ACTIONS(3031),
    [anon_sym_DASH_DASH] = ACTIONS(3031),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3031),
    [sym_number] = ACTIONS(3031),
    [sym_private_property_identifier] = ACTIONS(3031),
    [sym_this] = ACTIONS(3029),
    [sym_super] = ACTIONS(3029),
    [sym_true] = ACTIONS(3029),
    [sym_false] = ACTIONS(3029),
    [sym_null] = ACTIONS(3029),
    [sym_undefined] = ACTIONS(3029),
    [anon_sym_AT] = ACTIONS(3031),
    [anon_sym_static] = ACTIONS(3029),
    [anon_sym_readonly] = ACTIONS(3029),
    [anon_sym_get] = ACTIONS(3029),
    [anon_sym_set] = ACTIONS(3029),
    [anon_sym_declare] = ACTIONS(3029),
    [anon_sym_public] = ACTIONS(3029),
    [anon_sym_private] = ACTIONS(3029),
    [anon_sym_protected] = ACTIONS(3029),
    [anon_sym_override] = ACTIONS(3029),
    [anon_sym_module] = ACTIONS(3029),
    [anon_sym_any] = ACTIONS(3029),
    [anon_sym_number] = ACTIONS(3029),
    [anon_sym_boolean] = ACTIONS(3029),
    [anon_sym_string] = ACTIONS(3029),
    [anon_sym_symbol] = ACTIONS(3029),
    [anon_sym_object] = ACTIONS(3029),
    [anon_sym_property] = ACTIONS(3029),
    [anon_sym_signal] = ACTIONS(3029),
    [anon_sym_on] = ACTIONS(3029),
    [anon_sym_required] = ACTIONS(3029),
    [anon_sym_component] = ACTIONS(3029),
    [anon_sym_abstract] = ACTIONS(3029),
    [anon_sym_interface] = ACTIONS(3029),
    [anon_sym_enum] = ACTIONS(3029),
    [sym_html_comment] = ACTIONS(5),
  },
  [915] = {
    [sym_comment] = STATE(915),
    [sym_identifier] = ACTIONS(3021),
    [anon_sym_export] = ACTIONS(3021),
    [anon_sym_type] = ACTIONS(3021),
    [anon_sym_namespace] = ACTIONS(3021),
    [anon_sym_LBRACE] = ACTIONS(3023),
    [anon_sym_typeof] = ACTIONS(3021),
    [anon_sym_import] = ACTIONS(3021),
    [anon_sym_from] = ACTIONS(3021),
    [anon_sym_with] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3021),
    [anon_sym_let] = ACTIONS(3021),
    [anon_sym_const] = ACTIONS(3021),
    [anon_sym_BANG] = ACTIONS(3023),
    [anon_sym_if] = ACTIONS(3021),
    [anon_sym_switch] = ACTIONS(3021),
    [anon_sym_for] = ACTIONS(3021),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_await] = ACTIONS(3021),
    [anon_sym_of] = ACTIONS(3021),
    [anon_sym_while] = ACTIONS(3021),
    [anon_sym_do] = ACTIONS(3021),
    [anon_sym_try] = ACTIONS(3021),
    [anon_sym_break] = ACTIONS(3021),
    [anon_sym_continue] = ACTIONS(3021),
    [anon_sym_debugger] = ACTIONS(3021),
    [anon_sym_return] = ACTIONS(3021),
    [anon_sym_throw] = ACTIONS(3021),
    [anon_sym_SEMI] = ACTIONS(3023),
    [anon_sym_yield] = ACTIONS(3021),
    [anon_sym_LBRACK] = ACTIONS(3023),
    [anon_sym_LTtemplate_GT] = ACTIONS(3023),
    [anon_sym_DQUOTE] = ACTIONS(3023),
    [anon_sym_SQUOTE] = ACTIONS(3023),
    [anon_sym_class] = ACTIONS(3021),
    [anon_sym_async] = ACTIONS(3021),
    [anon_sym_function] = ACTIONS(3021),
    [anon_sym_new] = ACTIONS(3021),
    [anon_sym_using] = ACTIONS(3021),
    [anon_sym_PLUS] = ACTIONS(3021),
    [anon_sym_DASH] = ACTIONS(3021),
    [anon_sym_SLASH] = ACTIONS(3021),
    [anon_sym_LT] = ACTIONS(3021),
    [anon_sym_TILDE] = ACTIONS(3023),
    [anon_sym_void] = ACTIONS(3021),
    [anon_sym_delete] = ACTIONS(3021),
    [anon_sym_PLUS_PLUS] = ACTIONS(3023),
    [anon_sym_DASH_DASH] = ACTIONS(3023),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3023),
    [sym_number] = ACTIONS(3023),
    [sym_private_property_identifier] = ACTIONS(3023),
    [sym_this] = ACTIONS(3021),
    [sym_super] = ACTIONS(3021),
    [sym_true] = ACTIONS(3021),
    [sym_false] = ACTIONS(3021),
    [sym_null] = ACTIONS(3021),
    [sym_undefined] = ACTIONS(3021),
    [anon_sym_AT] = ACTIONS(3023),
    [anon_sym_static] = ACTIONS(3021),
    [anon_sym_readonly] = ACTIONS(3021),
    [anon_sym_get] = ACTIONS(3021),
    [anon_sym_set] = ACTIONS(3021),
    [anon_sym_declare] = ACTIONS(3021),
    [anon_sym_public] = ACTIONS(3021),
    [anon_sym_private] = ACTIONS(3021),
    [anon_sym_protected] = ACTIONS(3021),
    [anon_sym_override] = ACTIONS(3021),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_any] = ACTIONS(3021),
    [anon_sym_number] = ACTIONS(3021),
    [anon_sym_boolean] = ACTIONS(3021),
    [anon_sym_string] = ACTIONS(3021),
    [anon_sym_symbol] = ACTIONS(3021),
    [anon_sym_object] = ACTIONS(3021),
    [anon_sym_property] = ACTIONS(3021),
    [anon_sym_signal] = ACTIONS(3021),
    [anon_sym_on] = ACTIONS(3021),
    [anon_sym_required] = ACTIONS(3021),
    [anon_sym_component] = ACTIONS(3021),
    [anon_sym_abstract] = ACTIONS(3021),
    [anon_sym_interface] = ACTIONS(3021),
    [anon_sym_enum] = ACTIONS(3021),
    [sym_html_comment] = ACTIONS(5),
  },
  [916] = {
    [sym_comment] = STATE(916),
    [sym_identifier] = ACTIONS(2619),
    [anon_sym_export] = ACTIONS(2619),
    [anon_sym_type] = ACTIONS(2619),
    [anon_sym_namespace] = ACTIONS(2619),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_typeof] = ACTIONS(2619),
    [anon_sym_import] = ACTIONS(2619),
    [anon_sym_from] = ACTIONS(2619),
    [anon_sym_with] = ACTIONS(2619),
    [anon_sym_var] = ACTIONS(2619),
    [anon_sym_let] = ACTIONS(2619),
    [anon_sym_const] = ACTIONS(2619),
    [anon_sym_BANG] = ACTIONS(2621),
    [anon_sym_if] = ACTIONS(2619),
    [anon_sym_switch] = ACTIONS(2619),
    [anon_sym_for] = ACTIONS(2619),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_await] = ACTIONS(2619),
    [anon_sym_of] = ACTIONS(2619),
    [anon_sym_while] = ACTIONS(2619),
    [anon_sym_do] = ACTIONS(2619),
    [anon_sym_try] = ACTIONS(2619),
    [anon_sym_break] = ACTIONS(2619),
    [anon_sym_continue] = ACTIONS(2619),
    [anon_sym_debugger] = ACTIONS(2619),
    [anon_sym_return] = ACTIONS(2619),
    [anon_sym_throw] = ACTIONS(2619),
    [anon_sym_SEMI] = ACTIONS(2621),
    [anon_sym_yield] = ACTIONS(2619),
    [anon_sym_LBRACK] = ACTIONS(2621),
    [anon_sym_LTtemplate_GT] = ACTIONS(2621),
    [anon_sym_DQUOTE] = ACTIONS(2621),
    [anon_sym_SQUOTE] = ACTIONS(2621),
    [anon_sym_class] = ACTIONS(2619),
    [anon_sym_async] = ACTIONS(2619),
    [anon_sym_function] = ACTIONS(2619),
    [anon_sym_new] = ACTIONS(2619),
    [anon_sym_using] = ACTIONS(2619),
    [anon_sym_PLUS] = ACTIONS(2619),
    [anon_sym_DASH] = ACTIONS(2619),
    [anon_sym_SLASH] = ACTIONS(2619),
    [anon_sym_LT] = ACTIONS(2619),
    [anon_sym_TILDE] = ACTIONS(2621),
    [anon_sym_void] = ACTIONS(2619),
    [anon_sym_delete] = ACTIONS(2619),
    [anon_sym_PLUS_PLUS] = ACTIONS(2621),
    [anon_sym_DASH_DASH] = ACTIONS(2621),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2621),
    [sym_number] = ACTIONS(2621),
    [sym_private_property_identifier] = ACTIONS(2621),
    [sym_this] = ACTIONS(2619),
    [sym_super] = ACTIONS(2619),
    [sym_true] = ACTIONS(2619),
    [sym_false] = ACTIONS(2619),
    [sym_null] = ACTIONS(2619),
    [sym_undefined] = ACTIONS(2619),
    [anon_sym_AT] = ACTIONS(2621),
    [anon_sym_static] = ACTIONS(2619),
    [anon_sym_readonly] = ACTIONS(2619),
    [anon_sym_get] = ACTIONS(2619),
    [anon_sym_set] = ACTIONS(2619),
    [anon_sym_declare] = ACTIONS(2619),
    [anon_sym_public] = ACTIONS(2619),
    [anon_sym_private] = ACTIONS(2619),
    [anon_sym_protected] = ACTIONS(2619),
    [anon_sym_override] = ACTIONS(2619),
    [anon_sym_module] = ACTIONS(2619),
    [anon_sym_any] = ACTIONS(2619),
    [anon_sym_number] = ACTIONS(2619),
    [anon_sym_boolean] = ACTIONS(2619),
    [anon_sym_string] = ACTIONS(2619),
    [anon_sym_symbol] = ACTIONS(2619),
    [anon_sym_object] = ACTIONS(2619),
    [anon_sym_property] = ACTIONS(2619),
    [anon_sym_signal] = ACTIONS(2619),
    [anon_sym_on] = ACTIONS(2619),
    [anon_sym_required] = ACTIONS(2619),
    [anon_sym_component] = ACTIONS(2619),
    [anon_sym_abstract] = ACTIONS(2619),
    [anon_sym_interface] = ACTIONS(2619),
    [anon_sym_enum] = ACTIONS(2619),
    [sym_html_comment] = ACTIONS(5),
  },
  [917] = {
    [sym_comment] = STATE(917),
    [sym_identifier] = ACTIONS(3033),
    [anon_sym_export] = ACTIONS(3033),
    [anon_sym_type] = ACTIONS(3033),
    [anon_sym_namespace] = ACTIONS(3033),
    [anon_sym_LBRACE] = ACTIONS(3035),
    [anon_sym_typeof] = ACTIONS(3033),
    [anon_sym_import] = ACTIONS(3033),
    [anon_sym_from] = ACTIONS(3033),
    [anon_sym_with] = ACTIONS(3033),
    [anon_sym_var] = ACTIONS(3033),
    [anon_sym_let] = ACTIONS(3033),
    [anon_sym_const] = ACTIONS(3033),
    [anon_sym_BANG] = ACTIONS(3035),
    [anon_sym_if] = ACTIONS(3033),
    [anon_sym_switch] = ACTIONS(3033),
    [anon_sym_for] = ACTIONS(3033),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_await] = ACTIONS(3033),
    [anon_sym_of] = ACTIONS(3033),
    [anon_sym_while] = ACTIONS(3033),
    [anon_sym_do] = ACTIONS(3033),
    [anon_sym_try] = ACTIONS(3033),
    [anon_sym_break] = ACTIONS(3033),
    [anon_sym_continue] = ACTIONS(3033),
    [anon_sym_debugger] = ACTIONS(3033),
    [anon_sym_return] = ACTIONS(3033),
    [anon_sym_throw] = ACTIONS(3033),
    [anon_sym_SEMI] = ACTIONS(3035),
    [anon_sym_yield] = ACTIONS(3033),
    [anon_sym_LBRACK] = ACTIONS(3035),
    [anon_sym_LTtemplate_GT] = ACTIONS(3035),
    [anon_sym_DQUOTE] = ACTIONS(3035),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [anon_sym_class] = ACTIONS(3033),
    [anon_sym_async] = ACTIONS(3033),
    [anon_sym_function] = ACTIONS(3033),
    [anon_sym_new] = ACTIONS(3033),
    [anon_sym_using] = ACTIONS(3033),
    [anon_sym_PLUS] = ACTIONS(3033),
    [anon_sym_DASH] = ACTIONS(3033),
    [anon_sym_SLASH] = ACTIONS(3033),
    [anon_sym_LT] = ACTIONS(3033),
    [anon_sym_TILDE] = ACTIONS(3035),
    [anon_sym_void] = ACTIONS(3033),
    [anon_sym_delete] = ACTIONS(3033),
    [anon_sym_PLUS_PLUS] = ACTIONS(3035),
    [anon_sym_DASH_DASH] = ACTIONS(3035),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3035),
    [sym_number] = ACTIONS(3035),
    [sym_private_property_identifier] = ACTIONS(3035),
    [sym_this] = ACTIONS(3033),
    [sym_super] = ACTIONS(3033),
    [sym_true] = ACTIONS(3033),
    [sym_false] = ACTIONS(3033),
    [sym_null] = ACTIONS(3033),
    [sym_undefined] = ACTIONS(3033),
    [anon_sym_AT] = ACTIONS(3035),
    [anon_sym_static] = ACTIONS(3033),
    [anon_sym_readonly] = ACTIONS(3033),
    [anon_sym_get] = ACTIONS(3033),
    [anon_sym_set] = ACTIONS(3033),
    [anon_sym_declare] = ACTIONS(3033),
    [anon_sym_public] = ACTIONS(3033),
    [anon_sym_private] = ACTIONS(3033),
    [anon_sym_protected] = ACTIONS(3033),
    [anon_sym_override] = ACTIONS(3033),
    [anon_sym_module] = ACTIONS(3033),
    [anon_sym_any] = ACTIONS(3033),
    [anon_sym_number] = ACTIONS(3033),
    [anon_sym_boolean] = ACTIONS(3033),
    [anon_sym_string] = ACTIONS(3033),
    [anon_sym_symbol] = ACTIONS(3033),
    [anon_sym_object] = ACTIONS(3033),
    [anon_sym_property] = ACTIONS(3033),
    [anon_sym_signal] = ACTIONS(3033),
    [anon_sym_on] = ACTIONS(3033),
    [anon_sym_required] = ACTIONS(3033),
    [anon_sym_component] = ACTIONS(3033),
    [anon_sym_abstract] = ACTIONS(3033),
    [anon_sym_interface] = ACTIONS(3033),
    [anon_sym_enum] = ACTIONS(3033),
    [sym_html_comment] = ACTIONS(5),
  },
  [918] = {
    [sym_comment] = STATE(918),
    [sym_identifier] = ACTIONS(2611),
    [anon_sym_export] = ACTIONS(2611),
    [anon_sym_type] = ACTIONS(2611),
    [anon_sym_namespace] = ACTIONS(2611),
    [anon_sym_LBRACE] = ACTIONS(2613),
    [anon_sym_typeof] = ACTIONS(2611),
    [anon_sym_import] = ACTIONS(2611),
    [anon_sym_from] = ACTIONS(2611),
    [anon_sym_with] = ACTIONS(2611),
    [anon_sym_var] = ACTIONS(2611),
    [anon_sym_let] = ACTIONS(2611),
    [anon_sym_const] = ACTIONS(2611),
    [anon_sym_BANG] = ACTIONS(2613),
    [anon_sym_if] = ACTIONS(2611),
    [anon_sym_switch] = ACTIONS(2611),
    [anon_sym_for] = ACTIONS(2611),
    [anon_sym_LPAREN] = ACTIONS(2613),
    [anon_sym_await] = ACTIONS(2611),
    [anon_sym_of] = ACTIONS(2611),
    [anon_sym_while] = ACTIONS(2611),
    [anon_sym_do] = ACTIONS(2611),
    [anon_sym_try] = ACTIONS(2611),
    [anon_sym_break] = ACTIONS(2611),
    [anon_sym_continue] = ACTIONS(2611),
    [anon_sym_debugger] = ACTIONS(2611),
    [anon_sym_return] = ACTIONS(2611),
    [anon_sym_throw] = ACTIONS(2611),
    [anon_sym_SEMI] = ACTIONS(2613),
    [anon_sym_yield] = ACTIONS(2611),
    [anon_sym_LBRACK] = ACTIONS(2613),
    [anon_sym_LTtemplate_GT] = ACTIONS(2613),
    [anon_sym_DQUOTE] = ACTIONS(2613),
    [anon_sym_SQUOTE] = ACTIONS(2613),
    [anon_sym_class] = ACTIONS(2611),
    [anon_sym_async] = ACTIONS(2611),
    [anon_sym_function] = ACTIONS(2611),
    [anon_sym_new] = ACTIONS(2611),
    [anon_sym_using] = ACTIONS(2611),
    [anon_sym_PLUS] = ACTIONS(2611),
    [anon_sym_DASH] = ACTIONS(2611),
    [anon_sym_SLASH] = ACTIONS(2611),
    [anon_sym_LT] = ACTIONS(2611),
    [anon_sym_TILDE] = ACTIONS(2613),
    [anon_sym_void] = ACTIONS(2611),
    [anon_sym_delete] = ACTIONS(2611),
    [anon_sym_PLUS_PLUS] = ACTIONS(2613),
    [anon_sym_DASH_DASH] = ACTIONS(2613),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2613),
    [sym_number] = ACTIONS(2613),
    [sym_private_property_identifier] = ACTIONS(2613),
    [sym_this] = ACTIONS(2611),
    [sym_super] = ACTIONS(2611),
    [sym_true] = ACTIONS(2611),
    [sym_false] = ACTIONS(2611),
    [sym_null] = ACTIONS(2611),
    [sym_undefined] = ACTIONS(2611),
    [anon_sym_AT] = ACTIONS(2613),
    [anon_sym_static] = ACTIONS(2611),
    [anon_sym_readonly] = ACTIONS(2611),
    [anon_sym_get] = ACTIONS(2611),
    [anon_sym_set] = ACTIONS(2611),
    [anon_sym_declare] = ACTIONS(2611),
    [anon_sym_public] = ACTIONS(2611),
    [anon_sym_private] = ACTIONS(2611),
    [anon_sym_protected] = ACTIONS(2611),
    [anon_sym_override] = ACTIONS(2611),
    [anon_sym_module] = ACTIONS(2611),
    [anon_sym_any] = ACTIONS(2611),
    [anon_sym_number] = ACTIONS(2611),
    [anon_sym_boolean] = ACTIONS(2611),
    [anon_sym_string] = ACTIONS(2611),
    [anon_sym_symbol] = ACTIONS(2611),
    [anon_sym_object] = ACTIONS(2611),
    [anon_sym_property] = ACTIONS(2611),
    [anon_sym_signal] = ACTIONS(2611),
    [anon_sym_on] = ACTIONS(2611),
    [anon_sym_required] = ACTIONS(2611),
    [anon_sym_component] = ACTIONS(2611),
    [anon_sym_abstract] = ACTIONS(2611),
    [anon_sym_interface] = ACTIONS(2611),
    [anon_sym_enum] = ACTIONS(2611),
    [sym_html_comment] = ACTIONS(5),
  },
  [919] = {
    [sym_statement_block] = STATE(970),
    [sym_comment] = STATE(919),
    [sym_identifier] = ACTIONS(1818),
    [anon_sym_export] = ACTIONS(1818),
    [anon_sym_STAR] = ACTIONS(1818),
    [anon_sym_default] = ACTIONS(1818),
    [anon_sym_type] = ACTIONS(1818),
    [anon_sym_as] = ACTIONS(1818),
    [anon_sym_namespace] = ACTIONS(1818),
    [anon_sym_LBRACE] = ACTIONS(3037),
    [anon_sym_COMMA] = ACTIONS(1822),
    [anon_sym_RBRACE] = ACTIONS(1822),
    [anon_sym_from] = ACTIONS(1818),
    [anon_sym_var] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(1818),
    [anon_sym_BANG] = ACTIONS(1818),
    [anon_sym_else] = ACTIONS(1818),
    [anon_sym_LPAREN] = ACTIONS(1822),
    [anon_sym_in] = ACTIONS(1818),
    [anon_sym_of] = ACTIONS(1818),
    [anon_sym_SEMI] = ACTIONS(1822),
    [anon_sym_LBRACK] = ACTIONS(1822),
    [anon_sym_GT] = ACTIONS(1818),
    [anon_sym_DOT] = ACTIONS(1822),
    [anon_sym_async] = ACTIONS(1818),
    [anon_sym_function] = ACTIONS(1818),
    [anon_sym_QMARK_DOT] = ACTIONS(1822),
    [anon_sym_AMP_AMP] = ACTIONS(1822),
    [anon_sym_PIPE_PIPE] = ACTIONS(1822),
    [anon_sym_GT_GT] = ACTIONS(1818),
    [anon_sym_GT_GT_GT] = ACTIONS(1822),
    [anon_sym_LT_LT] = ACTIONS(1822),
    [anon_sym_AMP] = ACTIONS(1818),
    [anon_sym_CARET] = ACTIONS(1822),
    [anon_sym_PIPE] = ACTIONS(1818),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_DASH] = ACTIONS(1818),
    [anon_sym_SLASH] = ACTIONS(1818),
    [anon_sym_PERCENT] = ACTIONS(1822),
    [anon_sym_STAR_STAR] = ACTIONS(1822),
    [anon_sym_LT] = ACTIONS(1818),
    [anon_sym_LT_EQ] = ACTIONS(1822),
    [anon_sym_EQ_EQ] = ACTIONS(1818),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1822),
    [anon_sym_BANG_EQ] = ACTIONS(1818),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1822),
    [anon_sym_GT_EQ] = ACTIONS(1822),
    [anon_sym_QMARK_QMARK] = ACTIONS(1822),
    [anon_sym_instanceof] = ACTIONS(1818),
    [anon_sym_PLUS_PLUS] = ACTIONS(1822),
    [anon_sym_DASH_DASH] = ACTIONS(1822),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1822),
    [anon_sym_AT] = ACTIONS(1822),
    [anon_sym_static] = ACTIONS(1818),
    [anon_sym_readonly] = ACTIONS(1818),
    [anon_sym_get] = ACTIONS(1818),
    [anon_sym_set] = ACTIONS(1818),
    [anon_sym_declare] = ACTIONS(1818),
    [anon_sym_public] = ACTIONS(1818),
    [anon_sym_private] = ACTIONS(1818),
    [anon_sym_protected] = ACTIONS(1818),
    [anon_sym_override] = ACTIONS(1818),
    [anon_sym_module] = ACTIONS(1818),
    [anon_sym_any] = ACTIONS(1818),
    [anon_sym_number] = ACTIONS(1818),
    [anon_sym_boolean] = ACTIONS(1818),
    [anon_sym_string] = ACTIONS(1818),
    [anon_sym_symbol] = ACTIONS(1818),
    [anon_sym_object] = ACTIONS(1818),
    [anon_sym_property] = ACTIONS(1818),
    [anon_sym_signal] = ACTIONS(1818),
    [anon_sym_on] = ACTIONS(1818),
    [anon_sym_required] = ACTIONS(1818),
    [anon_sym_component] = ACTIONS(1818),
    [anon_sym_satisfies] = ACTIONS(1818),
    [anon_sym_enum] = ACTIONS(1818),
    [sym__automatic_semicolon] = ACTIONS(1822),
    [sym__ternary_qmark] = ACTIONS(1822),
    [sym_html_comment] = ACTIONS(5),
  },
  [920] = {
    [sym_statement_block] = STATE(970),
    [sym_comment] = STATE(920),
    [sym_identifier] = ACTIONS(1818),
    [anon_sym_export] = ACTIONS(1818),
    [anon_sym_STAR] = ACTIONS(1818),
    [anon_sym_default] = ACTIONS(1818),
    [anon_sym_type] = ACTIONS(1818),
    [anon_sym_as] = ACTIONS(1818),
    [anon_sym_namespace] = ACTIONS(1818),
    [anon_sym_LBRACE] = ACTIONS(3037),
    [anon_sym_COMMA] = ACTIONS(1822),
    [anon_sym_RBRACE] = ACTIONS(1822),
    [anon_sym_from] = ACTIONS(1818),
    [anon_sym_var] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(1818),
    [anon_sym_BANG] = ACTIONS(1818),
    [anon_sym_else] = ACTIONS(1818),
    [anon_sym_LPAREN] = ACTIONS(1822),
    [anon_sym_in] = ACTIONS(1818),
    [anon_sym_of] = ACTIONS(1818),
    [anon_sym_SEMI] = ACTIONS(1822),
    [anon_sym_LBRACK] = ACTIONS(1822),
    [anon_sym_GT] = ACTIONS(1818),
    [anon_sym_DOT] = ACTIONS(3039),
    [anon_sym_async] = ACTIONS(1818),
    [anon_sym_function] = ACTIONS(1818),
    [anon_sym_QMARK_DOT] = ACTIONS(1822),
    [anon_sym_AMP_AMP] = ACTIONS(1822),
    [anon_sym_PIPE_PIPE] = ACTIONS(1822),
    [anon_sym_GT_GT] = ACTIONS(1818),
    [anon_sym_GT_GT_GT] = ACTIONS(1822),
    [anon_sym_LT_LT] = ACTIONS(1822),
    [anon_sym_AMP] = ACTIONS(1818),
    [anon_sym_CARET] = ACTIONS(1822),
    [anon_sym_PIPE] = ACTIONS(1818),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_DASH] = ACTIONS(1818),
    [anon_sym_SLASH] = ACTIONS(1818),
    [anon_sym_PERCENT] = ACTIONS(1822),
    [anon_sym_STAR_STAR] = ACTIONS(1822),
    [anon_sym_LT] = ACTIONS(1818),
    [anon_sym_LT_EQ] = ACTIONS(1822),
    [anon_sym_EQ_EQ] = ACTIONS(1818),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1822),
    [anon_sym_BANG_EQ] = ACTIONS(1818),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1822),
    [anon_sym_GT_EQ] = ACTIONS(1822),
    [anon_sym_QMARK_QMARK] = ACTIONS(1822),
    [anon_sym_instanceof] = ACTIONS(1818),
    [anon_sym_PLUS_PLUS] = ACTIONS(1822),
    [anon_sym_DASH_DASH] = ACTIONS(1822),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1822),
    [anon_sym_AT] = ACTIONS(1822),
    [anon_sym_static] = ACTIONS(1818),
    [anon_sym_readonly] = ACTIONS(1818),
    [anon_sym_get] = ACTIONS(1818),
    [anon_sym_set] = ACTIONS(1818),
    [anon_sym_declare] = ACTIONS(1818),
    [anon_sym_public] = ACTIONS(1818),
    [anon_sym_private] = ACTIONS(1818),
    [anon_sym_protected] = ACTIONS(1818),
    [anon_sym_override] = ACTIONS(1818),
    [anon_sym_module] = ACTIONS(1818),
    [anon_sym_any] = ACTIONS(1818),
    [anon_sym_number] = ACTIONS(1818),
    [anon_sym_boolean] = ACTIONS(1818),
    [anon_sym_string] = ACTIONS(1818),
    [anon_sym_symbol] = ACTIONS(1818),
    [anon_sym_object] = ACTIONS(1818),
    [anon_sym_property] = ACTIONS(1818),
    [anon_sym_signal] = ACTIONS(1818),
    [anon_sym_on] = ACTIONS(1818),
    [anon_sym_required] = ACTIONS(1818),
    [anon_sym_component] = ACTIONS(1818),
    [anon_sym_satisfies] = ACTIONS(1818),
    [anon_sym_enum] = ACTIONS(1818),
    [sym__automatic_semicolon] = ACTIONS(1822),
    [sym__ternary_qmark] = ACTIONS(1822),
    [sym_html_comment] = ACTIONS(5),
  },
  [921] = {
    [sym_statement_block] = STATE(970),
    [sym_comment] = STATE(921),
    [sym_identifier] = ACTIONS(1818),
    [anon_sym_export] = ACTIONS(1818),
    [anon_sym_STAR] = ACTIONS(1818),
    [anon_sym_default] = ACTIONS(1818),
    [anon_sym_type] = ACTIONS(1818),
    [anon_sym_as] = ACTIONS(1818),
    [anon_sym_namespace] = ACTIONS(1818),
    [anon_sym_LBRACE] = ACTIONS(3037),
    [anon_sym_COMMA] = ACTIONS(1822),
    [anon_sym_RBRACE] = ACTIONS(1822),
    [anon_sym_from] = ACTIONS(1818),
    [anon_sym_var] = ACTIONS(1818),
    [anon_sym_let] = ACTIONS(1818),
    [anon_sym_BANG] = ACTIONS(1818),
    [anon_sym_else] = ACTIONS(1818),
    [anon_sym_LPAREN] = ACTIONS(1822),
    [anon_sym_in] = ACTIONS(1818),
    [anon_sym_of] = ACTIONS(1818),
    [anon_sym_SEMI] = ACTIONS(1822),
    [anon_sym_LBRACK] = ACTIONS(1822),
    [anon_sym_GT] = ACTIONS(1818),
    [anon_sym_DOT] = ACTIONS(3041),
    [anon_sym_async] = ACTIONS(1818),
    [anon_sym_function] = ACTIONS(1818),
    [anon_sym_QMARK_DOT] = ACTIONS(1822),
    [anon_sym_AMP_AMP] = ACTIONS(1822),
    [anon_sym_PIPE_PIPE] = ACTIONS(1822),
    [anon_sym_GT_GT] = ACTIONS(1818),
    [anon_sym_GT_GT_GT] = ACTIONS(1822),
    [anon_sym_LT_LT] = ACTIONS(1822),
    [anon_sym_AMP] = ACTIONS(1818),
    [anon_sym_CARET] = ACTIONS(1822),
    [anon_sym_PIPE] = ACTIONS(1818),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_DASH] = ACTIONS(1818),
    [anon_sym_SLASH] = ACTIONS(1818),
    [anon_sym_PERCENT] = ACTIONS(1822),
    [anon_sym_STAR_STAR] = ACTIONS(1822),
    [anon_sym_LT] = ACTIONS(1818),
    [anon_sym_LT_EQ] = ACTIONS(1822),
    [anon_sym_EQ_EQ] = ACTIONS(1818),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1822),
    [anon_sym_BANG_EQ] = ACTIONS(1818),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1822),
    [anon_sym_GT_EQ] = ACTIONS(1822),
    [anon_sym_QMARK_QMARK] = ACTIONS(1822),
    [anon_sym_instanceof] = ACTIONS(1818),
    [anon_sym_PLUS_PLUS] = ACTIONS(1822),
    [anon_sym_DASH_DASH] = ACTIONS(1822),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1822),
    [anon_sym_AT] = ACTIONS(1822),
    [anon_sym_static] = ACTIONS(1818),
    [anon_sym_readonly] = ACTIONS(1818),
    [anon_sym_get] = ACTIONS(1818),
    [anon_sym_set] = ACTIONS(1818),
    [anon_sym_declare] = ACTIONS(1818),
    [anon_sym_public] = ACTIONS(1818),
    [anon_sym_private] = ACTIONS(1818),
    [anon_sym_protected] = ACTIONS(1818),
    [anon_sym_override] = ACTIONS(1818),
    [anon_sym_module] = ACTIONS(1818),
    [anon_sym_any] = ACTIONS(1818),
    [anon_sym_number] = ACTIONS(1818),
    [anon_sym_boolean] = ACTIONS(1818),
    [anon_sym_string] = ACTIONS(1818),
    [anon_sym_symbol] = ACTIONS(1818),
    [anon_sym_object] = ACTIONS(1818),
    [anon_sym_property] = ACTIONS(1818),
    [anon_sym_signal] = ACTIONS(1818),
    [anon_sym_on] = ACTIONS(1818),
    [anon_sym_required] = ACTIONS(1818),
    [anon_sym_component] = ACTIONS(1818),
    [anon_sym_satisfies] = ACTIONS(1818),
    [anon_sym_enum] = ACTIONS(1818),
    [sym__automatic_semicolon] = ACTIONS(1822),
    [sym__ternary_qmark] = ACTIONS(1822),
    [sym_html_comment] = ACTIONS(5),
  },
  [922] = {
    [sym_comment] = STATE(922),
    [sym_identifier] = ACTIONS(1944),
    [anon_sym_export] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(1944),
    [anon_sym_default] = ACTIONS(1944),
    [anon_sym_type] = ACTIONS(1944),
    [anon_sym_as] = ACTIONS(1944),
    [anon_sym_namespace] = ACTIONS(1944),
    [anon_sym_LBRACE] = ACTIONS(1946),
    [anon_sym_COMMA] = ACTIONS(1946),
    [anon_sym_RBRACE] = ACTIONS(1946),
    [anon_sym_from] = ACTIONS(1944),
    [anon_sym_var] = ACTIONS(1944),
    [anon_sym_let] = ACTIONS(1944),
    [anon_sym_BANG] = ACTIONS(1944),
    [anon_sym_else] = ACTIONS(1944),
    [anon_sym_LPAREN] = ACTIONS(1946),
    [anon_sym_in] = ACTIONS(1944),
    [anon_sym_of] = ACTIONS(1944),
    [anon_sym_SEMI] = ACTIONS(1946),
    [anon_sym_LBRACK] = ACTIONS(1946),
    [anon_sym_GT] = ACTIONS(1944),
    [anon_sym_DOT] = ACTIONS(1946),
    [anon_sym_async] = ACTIONS(1944),
    [anon_sym_function] = ACTIONS(1944),
    [anon_sym_QMARK_DOT] = ACTIONS(1946),
    [anon_sym_AMP_AMP] = ACTIONS(1946),
    [anon_sym_PIPE_PIPE] = ACTIONS(1946),
    [anon_sym_GT_GT] = ACTIONS(1944),
    [anon_sym_GT_GT_GT] = ACTIONS(1946),
    [anon_sym_LT_LT] = ACTIONS(1946),
    [anon_sym_AMP] = ACTIONS(1944),
    [anon_sym_CARET] = ACTIONS(1946),
    [anon_sym_PIPE] = ACTIONS(1944),
    [anon_sym_PLUS] = ACTIONS(1944),
    [anon_sym_DASH] = ACTIONS(1944),
    [anon_sym_SLASH] = ACTIONS(1944),
    [anon_sym_PERCENT] = ACTIONS(1946),
    [anon_sym_STAR_STAR] = ACTIONS(1946),
    [anon_sym_LT] = ACTIONS(1944),
    [anon_sym_LT_EQ] = ACTIONS(1946),
    [anon_sym_EQ_EQ] = ACTIONS(1944),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1946),
    [anon_sym_BANG_EQ] = ACTIONS(1944),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1946),
    [anon_sym_GT_EQ] = ACTIONS(1946),
    [anon_sym_QMARK_QMARK] = ACTIONS(1946),
    [anon_sym_instanceof] = ACTIONS(1944),
    [anon_sym_PLUS_PLUS] = ACTIONS(1946),
    [anon_sym_DASH_DASH] = ACTIONS(1946),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1946),
    [anon_sym_AT] = ACTIONS(1946),
    [anon_sym_static] = ACTIONS(1944),
    [anon_sym_readonly] = ACTIONS(1944),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_declare] = ACTIONS(1944),
    [anon_sym_public] = ACTIONS(1944),
    [anon_sym_private] = ACTIONS(1944),
    [anon_sym_protected] = ACTIONS(1944),
    [anon_sym_override] = ACTIONS(1944),
    [anon_sym_module] = ACTIONS(1944),
    [anon_sym_any] = ACTIONS(1944),
    [anon_sym_number] = ACTIONS(1944),
    [anon_sym_boolean] = ACTIONS(1944),
    [anon_sym_string] = ACTIONS(1944),
    [anon_sym_symbol] = ACTIONS(1944),
    [anon_sym_object] = ACTIONS(1944),
    [anon_sym_property] = ACTIONS(1944),
    [anon_sym_signal] = ACTIONS(1944),
    [anon_sym_on] = ACTIONS(1944),
    [anon_sym_required] = ACTIONS(1944),
    [anon_sym_component] = ACTIONS(1944),
    [anon_sym_satisfies] = ACTIONS(1944),
    [anon_sym_enum] = ACTIONS(1944),
    [sym__automatic_semicolon] = ACTIONS(1946),
    [sym__ternary_qmark] = ACTIONS(1946),
    [sym_html_comment] = ACTIONS(5),
  },
  [923] = {
    [sym_comment] = STATE(923),
    [sym_identifier] = ACTIONS(1858),
    [anon_sym_export] = ACTIONS(1858),
    [anon_sym_STAR] = ACTIONS(1858),
    [anon_sym_default] = ACTIONS(1858),
    [anon_sym_type] = ACTIONS(1858),
    [anon_sym_as] = ACTIONS(1858),
    [anon_sym_namespace] = ACTIONS(1858),
    [anon_sym_LBRACE] = ACTIONS(1860),
    [anon_sym_COMMA] = ACTIONS(1860),
    [anon_sym_RBRACE] = ACTIONS(1860),
    [anon_sym_from] = ACTIONS(1858),
    [anon_sym_var] = ACTIONS(1858),
    [anon_sym_let] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(1858),
    [anon_sym_else] = ACTIONS(1858),
    [anon_sym_LPAREN] = ACTIONS(1860),
    [anon_sym_in] = ACTIONS(1858),
    [anon_sym_of] = ACTIONS(1858),
    [anon_sym_SEMI] = ACTIONS(1860),
    [anon_sym_LBRACK] = ACTIONS(1860),
    [anon_sym_GT] = ACTIONS(1858),
    [anon_sym_DOT] = ACTIONS(1860),
    [anon_sym_async] = ACTIONS(1858),
    [anon_sym_function] = ACTIONS(1858),
    [anon_sym_QMARK_DOT] = ACTIONS(1860),
    [anon_sym_AMP_AMP] = ACTIONS(1860),
    [anon_sym_PIPE_PIPE] = ACTIONS(1860),
    [anon_sym_GT_GT] = ACTIONS(1858),
    [anon_sym_GT_GT_GT] = ACTIONS(1860),
    [anon_sym_LT_LT] = ACTIONS(1860),
    [anon_sym_AMP] = ACTIONS(1858),
    [anon_sym_CARET] = ACTIONS(1860),
    [anon_sym_PIPE] = ACTIONS(1858),
    [anon_sym_PLUS] = ACTIONS(1858),
    [anon_sym_DASH] = ACTIONS(1858),
    [anon_sym_SLASH] = ACTIONS(1858),
    [anon_sym_PERCENT] = ACTIONS(1860),
    [anon_sym_STAR_STAR] = ACTIONS(1860),
    [anon_sym_LT] = ACTIONS(1858),
    [anon_sym_LT_EQ] = ACTIONS(1860),
    [anon_sym_EQ_EQ] = ACTIONS(1858),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1860),
    [anon_sym_BANG_EQ] = ACTIONS(1858),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1860),
    [anon_sym_GT_EQ] = ACTIONS(1860),
    [anon_sym_QMARK_QMARK] = ACTIONS(1860),
    [anon_sym_instanceof] = ACTIONS(1858),
    [anon_sym_PLUS_PLUS] = ACTIONS(1860),
    [anon_sym_DASH_DASH] = ACTIONS(1860),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1860),
    [anon_sym_AT] = ACTIONS(1860),
    [anon_sym_static] = ACTIONS(1858),
    [anon_sym_readonly] = ACTIONS(1858),
    [anon_sym_get] = ACTIONS(1858),
    [anon_sym_set] = ACTIONS(1858),
    [anon_sym_declare] = ACTIONS(1858),
    [anon_sym_public] = ACTIONS(1858),
    [anon_sym_private] = ACTIONS(1858),
    [anon_sym_protected] = ACTIONS(1858),
    [anon_sym_override] = ACTIONS(1858),
    [anon_sym_module] = ACTIONS(1858),
    [anon_sym_any] = ACTIONS(1858),
    [anon_sym_number] = ACTIONS(1858),
    [anon_sym_boolean] = ACTIONS(1858),
    [anon_sym_string] = ACTIONS(1858),
    [anon_sym_symbol] = ACTIONS(1858),
    [anon_sym_object] = ACTIONS(1858),
    [anon_sym_property] = ACTIONS(1858),
    [anon_sym_signal] = ACTIONS(1858),
    [anon_sym_on] = ACTIONS(1858),
    [anon_sym_required] = ACTIONS(1858),
    [anon_sym_component] = ACTIONS(1858),
    [anon_sym_satisfies] = ACTIONS(1858),
    [anon_sym_enum] = ACTIONS(1858),
    [sym__automatic_semicolon] = ACTIONS(1860),
    [sym__ternary_qmark] = ACTIONS(1860),
    [sym_html_comment] = ACTIONS(5),
  },
  [924] = {
    [sym_comment] = STATE(924),
    [sym_identifier] = ACTIONS(1850),
    [anon_sym_export] = ACTIONS(1850),
    [anon_sym_STAR] = ACTIONS(1850),
    [anon_sym_default] = ACTIONS(1850),
    [anon_sym_type] = ACTIONS(1850),
    [anon_sym_as] = ACTIONS(1850),
    [anon_sym_namespace] = ACTIONS(1850),
    [anon_sym_LBRACE] = ACTIONS(1852),
    [anon_sym_COMMA] = ACTIONS(1852),
    [anon_sym_RBRACE] = ACTIONS(1852),
    [anon_sym_from] = ACTIONS(1850),
    [anon_sym_var] = ACTIONS(1850),
    [anon_sym_let] = ACTIONS(1850),
    [anon_sym_BANG] = ACTIONS(1850),
    [anon_sym_else] = ACTIONS(1850),
    [anon_sym_LPAREN] = ACTIONS(1852),
    [anon_sym_in] = ACTIONS(1850),
    [anon_sym_of] = ACTIONS(1850),
    [anon_sym_SEMI] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1852),
    [anon_sym_GT] = ACTIONS(1850),
    [anon_sym_DOT] = ACTIONS(1852),
    [anon_sym_async] = ACTIONS(1850),
    [anon_sym_function] = ACTIONS(1850),
    [anon_sym_QMARK_DOT] = ACTIONS(1852),
    [anon_sym_AMP_AMP] = ACTIONS(1852),
    [anon_sym_PIPE_PIPE] = ACTIONS(1852),
    [anon_sym_GT_GT] = ACTIONS(1850),
    [anon_sym_GT_GT_GT] = ACTIONS(1852),
    [anon_sym_LT_LT] = ACTIONS(1852),
    [anon_sym_AMP] = ACTIONS(1850),
    [anon_sym_CARET] = ACTIONS(1852),
    [anon_sym_PIPE] = ACTIONS(1850),
    [anon_sym_PLUS] = ACTIONS(1850),
    [anon_sym_DASH] = ACTIONS(1850),
    [anon_sym_SLASH] = ACTIONS(1850),
    [anon_sym_PERCENT] = ACTIONS(1852),
    [anon_sym_STAR_STAR] = ACTIONS(1852),
    [anon_sym_LT] = ACTIONS(1850),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_EQ_EQ] = ACTIONS(1850),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1852),
    [anon_sym_BANG_EQ] = ACTIONS(1850),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_QMARK_QMARK] = ACTIONS(1852),
    [anon_sym_instanceof] = ACTIONS(1850),
    [anon_sym_PLUS_PLUS] = ACTIONS(1852),
    [anon_sym_DASH_DASH] = ACTIONS(1852),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1852),
    [anon_sym_AT] = ACTIONS(1852),
    [anon_sym_static] = ACTIONS(1850),
    [anon_sym_readonly] = ACTIONS(1850),
    [anon_sym_get] = ACTIONS(1850),
    [anon_sym_set] = ACTIONS(1850),
    [anon_sym_declare] = ACTIONS(1850),
    [anon_sym_public] = ACTIONS(1850),
    [anon_sym_private] = ACTIONS(1850),
    [anon_sym_protected] = ACTIONS(1850),
    [anon_sym_override] = ACTIONS(1850),
    [anon_sym_module] = ACTIONS(1850),
    [anon_sym_any] = ACTIONS(1850),
    [anon_sym_number] = ACTIONS(1850),
    [anon_sym_boolean] = ACTIONS(1850),
    [anon_sym_string] = ACTIONS(1850),
    [anon_sym_symbol] = ACTIONS(1850),
    [anon_sym_object] = ACTIONS(1850),
    [anon_sym_property] = ACTIONS(1850),
    [anon_sym_signal] = ACTIONS(1850),
    [anon_sym_on] = ACTIONS(1850),
    [anon_sym_required] = ACTIONS(1850),
    [anon_sym_component] = ACTIONS(1850),
    [anon_sym_satisfies] = ACTIONS(1850),
    [anon_sym_enum] = ACTIONS(1850),
    [sym__automatic_semicolon] = ACTIONS(1852),
    [sym__ternary_qmark] = ACTIONS(1852),
    [sym_html_comment] = ACTIONS(5),
  },
  [925] = {
    [sym_comment] = STATE(925),
    [sym_identifier] = ACTIONS(1872),
    [anon_sym_export] = ACTIONS(1872),
    [anon_sym_STAR] = ACTIONS(1872),
    [anon_sym_default] = ACTIONS(1872),
    [anon_sym_type] = ACTIONS(1872),
    [anon_sym_as] = ACTIONS(1872),
    [anon_sym_namespace] = ACTIONS(1872),
    [anon_sym_LBRACE] = ACTIONS(1874),
    [anon_sym_COMMA] = ACTIONS(1874),
    [anon_sym_RBRACE] = ACTIONS(1874),
    [anon_sym_from] = ACTIONS(1872),
    [anon_sym_var] = ACTIONS(1872),
    [anon_sym_let] = ACTIONS(1872),
    [anon_sym_BANG] = ACTIONS(1872),
    [anon_sym_else] = ACTIONS(1872),
    [anon_sym_LPAREN] = ACTIONS(1874),
    [anon_sym_in] = ACTIONS(1872),
    [anon_sym_of] = ACTIONS(1872),
    [anon_sym_SEMI] = ACTIONS(1874),
    [anon_sym_LBRACK] = ACTIONS(1874),
    [anon_sym_GT] = ACTIONS(1872),
    [anon_sym_DOT] = ACTIONS(1874),
    [anon_sym_async] = ACTIONS(1872),
    [anon_sym_function] = ACTIONS(1872),
    [anon_sym_QMARK_DOT] = ACTIONS(1874),
    [anon_sym_AMP_AMP] = ACTIONS(1874),
    [anon_sym_PIPE_PIPE] = ACTIONS(1874),
    [anon_sym_GT_GT] = ACTIONS(1872),
    [anon_sym_GT_GT_GT] = ACTIONS(1874),
    [anon_sym_LT_LT] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1872),
    [anon_sym_CARET] = ACTIONS(1874),
    [anon_sym_PIPE] = ACTIONS(1872),
    [anon_sym_PLUS] = ACTIONS(1872),
    [anon_sym_DASH] = ACTIONS(1872),
    [anon_sym_SLASH] = ACTIONS(1872),
    [anon_sym_PERCENT] = ACTIONS(1874),
    [anon_sym_STAR_STAR] = ACTIONS(1874),
    [anon_sym_LT] = ACTIONS(1872),
    [anon_sym_LT_EQ] = ACTIONS(1874),
    [anon_sym_EQ_EQ] = ACTIONS(1872),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1874),
    [anon_sym_BANG_EQ] = ACTIONS(1872),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1874),
    [anon_sym_GT_EQ] = ACTIONS(1874),
    [anon_sym_QMARK_QMARK] = ACTIONS(1874),
    [anon_sym_instanceof] = ACTIONS(1872),
    [anon_sym_PLUS_PLUS] = ACTIONS(1874),
    [anon_sym_DASH_DASH] = ACTIONS(1874),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1874),
    [anon_sym_AT] = ACTIONS(1874),
    [anon_sym_static] = ACTIONS(1872),
    [anon_sym_readonly] = ACTIONS(1872),
    [anon_sym_get] = ACTIONS(1872),
    [anon_sym_set] = ACTIONS(1872),
    [anon_sym_declare] = ACTIONS(1872),
    [anon_sym_public] = ACTIONS(1872),
    [anon_sym_private] = ACTIONS(1872),
    [anon_sym_protected] = ACTIONS(1872),
    [anon_sym_override] = ACTIONS(1872),
    [anon_sym_module] = ACTIONS(1872),
    [anon_sym_any] = ACTIONS(1872),
    [anon_sym_number] = ACTIONS(1872),
    [anon_sym_boolean] = ACTIONS(1872),
    [anon_sym_string] = ACTIONS(1872),
    [anon_sym_symbol] = ACTIONS(1872),
    [anon_sym_object] = ACTIONS(1872),
    [anon_sym_property] = ACTIONS(1872),
    [anon_sym_signal] = ACTIONS(1872),
    [anon_sym_on] = ACTIONS(1872),
    [anon_sym_required] = ACTIONS(1872),
    [anon_sym_component] = ACTIONS(1872),
    [anon_sym_satisfies] = ACTIONS(1872),
    [anon_sym_enum] = ACTIONS(1872),
    [sym__automatic_semicolon] = ACTIONS(1874),
    [sym__ternary_qmark] = ACTIONS(1874),
    [sym_html_comment] = ACTIONS(5),
  },
  [926] = {
    [sym_comment] = STATE(926),
    [sym_identifier] = ACTIONS(1792),
    [anon_sym_export] = ACTIONS(1792),
    [anon_sym_STAR] = ACTIONS(1794),
    [anon_sym_default] = ACTIONS(1792),
    [anon_sym_type] = ACTIONS(1792),
    [anon_sym_EQ] = ACTIONS(1796),
    [anon_sym_as] = ACTIONS(1794),
    [anon_sym_namespace] = ACTIONS(1792),
    [anon_sym_COMMA] = ACTIONS(1800),
    [anon_sym_RBRACE] = ACTIONS(1798),
    [anon_sym_from] = ACTIONS(1792),
    [anon_sym_var] = ACTIONS(1792),
    [anon_sym_let] = ACTIONS(1792),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_else] = ACTIONS(1792),
    [anon_sym_LPAREN] = ACTIONS(1800),
    [anon_sym_in] = ACTIONS(1794),
    [anon_sym_of] = ACTIONS(1792),
    [anon_sym_SEMI] = ACTIONS(1800),
    [anon_sym_LBRACK] = ACTIONS(1800),
    [anon_sym_GT] = ACTIONS(1794),
    [anon_sym_DOT] = ACTIONS(1800),
    [anon_sym_async] = ACTIONS(1792),
    [anon_sym_function] = ACTIONS(1792),
    [anon_sym_QMARK_DOT] = ACTIONS(1800),
    [anon_sym_AMP_AMP] = ACTIONS(1800),
    [anon_sym_PIPE_PIPE] = ACTIONS(1800),
    [anon_sym_GT_GT] = ACTIONS(1794),
    [anon_sym_GT_GT_GT] = ACTIONS(1800),
    [anon_sym_LT_LT] = ACTIONS(1800),
    [anon_sym_AMP] = ACTIONS(1794),
    [anon_sym_CARET] = ACTIONS(1800),
    [anon_sym_PIPE] = ACTIONS(1794),
    [anon_sym_PLUS] = ACTIONS(1794),
    [anon_sym_DASH] = ACTIONS(1794),
    [anon_sym_SLASH] = ACTIONS(1794),
    [anon_sym_PERCENT] = ACTIONS(1800),
    [anon_sym_STAR_STAR] = ACTIONS(1800),
    [anon_sym_LT] = ACTIONS(1794),
    [anon_sym_LT_EQ] = ACTIONS(1800),
    [anon_sym_EQ_EQ] = ACTIONS(1794),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1800),
    [anon_sym_BANG_EQ] = ACTIONS(1794),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1800),
    [anon_sym_GT_EQ] = ACTIONS(1800),
    [anon_sym_QMARK_QMARK] = ACTIONS(1800),
    [anon_sym_instanceof] = ACTIONS(1794),
    [anon_sym_PLUS_PLUS] = ACTIONS(1800),
    [anon_sym_DASH_DASH] = ACTIONS(1800),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1800),
    [anon_sym_AT] = ACTIONS(1798),
    [anon_sym_static] = ACTIONS(1792),
    [anon_sym_readonly] = ACTIONS(1792),
    [anon_sym_get] = ACTIONS(1792),
    [anon_sym_set] = ACTIONS(1792),
    [anon_sym_declare] = ACTIONS(1792),
    [anon_sym_public] = ACTIONS(1792),
    [anon_sym_private] = ACTIONS(1792),
    [anon_sym_protected] = ACTIONS(1792),
    [anon_sym_override] = ACTIONS(1792),
    [anon_sym_module] = ACTIONS(1792),
    [anon_sym_any] = ACTIONS(1792),
    [anon_sym_number] = ACTIONS(1792),
    [anon_sym_boolean] = ACTIONS(1792),
    [anon_sym_string] = ACTIONS(1792),
    [anon_sym_symbol] = ACTIONS(1792),
    [anon_sym_object] = ACTIONS(1792),
    [anon_sym_property] = ACTIONS(1792),
    [anon_sym_signal] = ACTIONS(1792),
    [anon_sym_on] = ACTIONS(1792),
    [anon_sym_required] = ACTIONS(1792),
    [anon_sym_component] = ACTIONS(1792),
    [anon_sym_satisfies] = ACTIONS(1794),
    [anon_sym_enum] = ACTIONS(1792),
    [sym__automatic_semicolon] = ACTIONS(3043),
    [sym__ternary_qmark] = ACTIONS(1800),
    [sym_html_comment] = ACTIONS(5),
  },
  [927] = {
    [sym_comment] = STATE(927),
    [sym_identifier] = ACTIONS(1838),
    [anon_sym_export] = ACTIONS(1838),
    [anon_sym_STAR] = ACTIONS(1838),
    [anon_sym_default] = ACTIONS(1838),
    [anon_sym_type] = ACTIONS(1838),
    [anon_sym_as] = ACTIONS(1838),
    [anon_sym_namespace] = ACTIONS(1838),
    [anon_sym_COMMA] = ACTIONS(1840),
    [anon_sym_RBRACE] = ACTIONS(1840),
    [anon_sym_from] = ACTIONS(1838),
    [anon_sym_var] = ACTIONS(1838),
    [anon_sym_let] = ACTIONS(1838),
    [anon_sym_BANG] = ACTIONS(1838),
    [anon_sym_else] = ACTIONS(1838),
    [anon_sym_LPAREN] = ACTIONS(1840),
    [anon_sym_in] = ACTIONS(1838),
    [anon_sym_of] = ACTIONS(1838),
    [anon_sym_SEMI] = ACTIONS(1840),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_GT] = ACTIONS(1838),
    [anon_sym_DOT] = ACTIONS(1840),
    [anon_sym_async] = ACTIONS(1838),
    [anon_sym_function] = ACTIONS(1838),
    [anon_sym_QMARK_DOT] = ACTIONS(1840),
    [anon_sym_AMP_AMP] = ACTIONS(1840),
    [anon_sym_PIPE_PIPE] = ACTIONS(1840),
    [anon_sym_GT_GT] = ACTIONS(1838),
    [anon_sym_GT_GT_GT] = ACTIONS(1840),
    [anon_sym_LT_LT] = ACTIONS(1840),
    [anon_sym_AMP] = ACTIONS(1838),
    [anon_sym_CARET] = ACTIONS(1840),
    [anon_sym_PIPE] = ACTIONS(1838),
    [anon_sym_PLUS] = ACTIONS(1838),
    [anon_sym_DASH] = ACTIONS(1838),
    [anon_sym_SLASH] = ACTIONS(1838),
    [anon_sym_PERCENT] = ACTIONS(1840),
    [anon_sym_STAR_STAR] = ACTIONS(1840),
    [anon_sym_LT] = ACTIONS(1838),
    [anon_sym_LT_EQ] = ACTIONS(1840),
    [anon_sym_EQ_EQ] = ACTIONS(1838),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1840),
    [anon_sym_BANG_EQ] = ACTIONS(1838),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1840),
    [anon_sym_GT_EQ] = ACTIONS(1840),
    [anon_sym_QMARK_QMARK] = ACTIONS(1840),
    [anon_sym_instanceof] = ACTIONS(1838),
    [anon_sym_PLUS_PLUS] = ACTIONS(1840),
    [anon_sym_DASH_DASH] = ACTIONS(1840),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1840),
    [anon_sym_AT] = ACTIONS(1840),
    [anon_sym_static] = ACTIONS(1838),
    [anon_sym_readonly] = ACTIONS(1838),
    [anon_sym_get] = ACTIONS(1838),
    [anon_sym_set] = ACTIONS(1838),
    [anon_sym_declare] = ACTIONS(1838),
    [anon_sym_public] = ACTIONS(1838),
    [anon_sym_private] = ACTIONS(1838),
    [anon_sym_protected] = ACTIONS(1838),
    [anon_sym_override] = ACTIONS(1838),
    [anon_sym_module] = ACTIONS(1838),
    [anon_sym_any] = ACTIONS(1838),
    [anon_sym_number] = ACTIONS(1838),
    [anon_sym_boolean] = ACTIONS(1838),
    [anon_sym_string] = ACTIONS(1838),
    [anon_sym_symbol] = ACTIONS(1838),
    [anon_sym_object] = ACTIONS(1838),
    [anon_sym_property] = ACTIONS(1838),
    [anon_sym_signal] = ACTIONS(1838),
    [anon_sym_on] = ACTIONS(1838),
    [anon_sym_required] = ACTIONS(1838),
    [anon_sym_component] = ACTIONS(1838),
    [anon_sym_satisfies] = ACTIONS(1838),
    [anon_sym_enum] = ACTIONS(1838),
    [sym__automatic_semicolon] = ACTIONS(1840),
    [sym__ternary_qmark] = ACTIONS(1840),
    [sym_html_comment] = ACTIONS(5),
  },
  [928] = {
    [sym_comment] = STATE(928),
    [sym_identifier] = ACTIONS(1902),
    [anon_sym_export] = ACTIONS(1902),
    [anon_sym_STAR] = ACTIONS(1902),
    [anon_sym_default] = ACTIONS(1902),
    [anon_sym_type] = ACTIONS(1902),
    [anon_sym_as] = ACTIONS(1902),
    [anon_sym_namespace] = ACTIONS(1902),
    [anon_sym_COMMA] = ACTIONS(1904),
    [anon_sym_RBRACE] = ACTIONS(1904),
    [anon_sym_from] = ACTIONS(1902),
    [anon_sym_var] = ACTIONS(1902),
    [anon_sym_let] = ACTIONS(1902),
    [anon_sym_BANG] = ACTIONS(1902),
    [anon_sym_else] = ACTIONS(1902),
    [anon_sym_LPAREN] = ACTIONS(1904),
    [anon_sym_in] = ACTIONS(1902),
    [anon_sym_of] = ACTIONS(1902),
    [anon_sym_SEMI] = ACTIONS(1904),
    [anon_sym_LBRACK] = ACTIONS(1904),
    [anon_sym_GT] = ACTIONS(1902),
    [anon_sym_DOT] = ACTIONS(1904),
    [anon_sym_async] = ACTIONS(1902),
    [anon_sym_function] = ACTIONS(1902),
    [anon_sym_QMARK_DOT] = ACTIONS(1904),
    [anon_sym_AMP_AMP] = ACTIONS(1904),
    [anon_sym_PIPE_PIPE] = ACTIONS(1904),
    [anon_sym_GT_GT] = ACTIONS(1902),
    [anon_sym_GT_GT_GT] = ACTIONS(1904),
    [anon_sym_LT_LT] = ACTIONS(1904),
    [anon_sym_AMP] = ACTIONS(1902),
    [anon_sym_CARET] = ACTIONS(1904),
    [anon_sym_PIPE] = ACTIONS(1902),
    [anon_sym_PLUS] = ACTIONS(1902),
    [anon_sym_DASH] = ACTIONS(1902),
    [anon_sym_SLASH] = ACTIONS(1902),
    [anon_sym_PERCENT] = ACTIONS(1904),
    [anon_sym_STAR_STAR] = ACTIONS(1904),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_LT_EQ] = ACTIONS(1904),
    [anon_sym_EQ_EQ] = ACTIONS(1902),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1904),
    [anon_sym_BANG_EQ] = ACTIONS(1902),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1904),
    [anon_sym_GT_EQ] = ACTIONS(1904),
    [anon_sym_QMARK_QMARK] = ACTIONS(1904),
    [anon_sym_instanceof] = ACTIONS(1902),
    [anon_sym_PLUS_PLUS] = ACTIONS(1904),
    [anon_sym_DASH_DASH] = ACTIONS(1904),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1904),
    [anon_sym_AT] = ACTIONS(1904),
    [anon_sym_static] = ACTIONS(1902),
    [anon_sym_readonly] = ACTIONS(1902),
    [anon_sym_get] = ACTIONS(1902),
    [anon_sym_set] = ACTIONS(1902),
    [anon_sym_declare] = ACTIONS(1902),
    [anon_sym_public] = ACTIONS(1902),
    [anon_sym_private] = ACTIONS(1902),
    [anon_sym_protected] = ACTIONS(1902),
    [anon_sym_override] = ACTIONS(1902),
    [anon_sym_module] = ACTIONS(1902),
    [anon_sym_any] = ACTIONS(1902),
    [anon_sym_number] = ACTIONS(1902),
    [anon_sym_boolean] = ACTIONS(1902),
    [anon_sym_string] = ACTIONS(1902),
    [anon_sym_symbol] = ACTIONS(1902),
    [anon_sym_object] = ACTIONS(1902),
    [anon_sym_property] = ACTIONS(1902),
    [anon_sym_signal] = ACTIONS(1902),
    [anon_sym_on] = ACTIONS(1902),
    [anon_sym_required] = ACTIONS(1902),
    [anon_sym_component] = ACTIONS(1902),
    [anon_sym_satisfies] = ACTIONS(1902),
    [anon_sym_enum] = ACTIONS(1902),
    [sym__automatic_semicolon] = ACTIONS(1904),
    [sym__ternary_qmark] = ACTIONS(1904),
    [sym_html_comment] = ACTIONS(5),
  },
  [929] = {
    [sym_comment] = STATE(929),
    [sym_identifier] = ACTIONS(3045),
    [anon_sym_export] = ACTIONS(3045),
    [anon_sym_type] = ACTIONS(3045),
    [anon_sym_EQ] = ACTIONS(3045),
    [anon_sym_namespace] = ACTIONS(3045),
    [anon_sym_LBRACE] = ACTIONS(3047),
    [anon_sym_COMMA] = ACTIONS(3047),
    [anon_sym_RBRACE] = ACTIONS(3047),
    [anon_sym_typeof] = ACTIONS(3045),
    [anon_sym_import] = ACTIONS(3045),
    [anon_sym_from] = ACTIONS(3045),
    [anon_sym_let] = ACTIONS(3045),
    [anon_sym_BANG] = ACTIONS(3047),
    [anon_sym_LPAREN] = ACTIONS(3047),
    [anon_sym_RPAREN] = ACTIONS(3047),
    [anon_sym_await] = ACTIONS(3045),
    [anon_sym_of] = ACTIONS(3045),
    [anon_sym_COLON] = ACTIONS(3047),
    [anon_sym_yield] = ACTIONS(3045),
    [anon_sym_LBRACK] = ACTIONS(3047),
    [anon_sym_RBRACK] = ACTIONS(3047),
    [anon_sym_LTtemplate_GT] = ACTIONS(3047),
    [anon_sym_GT] = ACTIONS(3047),
    [anon_sym_DQUOTE] = ACTIONS(3047),
    [anon_sym_SQUOTE] = ACTIONS(3047),
    [anon_sym_class] = ACTIONS(3045),
    [anon_sym_async] = ACTIONS(3045),
    [anon_sym_function] = ACTIONS(3045),
    [anon_sym_EQ_GT] = ACTIONS(3047),
    [anon_sym_new] = ACTIONS(3045),
    [anon_sym_using] = ACTIONS(3045),
    [anon_sym_AMP] = ACTIONS(3047),
    [anon_sym_PIPE] = ACTIONS(3047),
    [anon_sym_PLUS] = ACTIONS(3045),
    [anon_sym_DASH] = ACTIONS(3045),
    [anon_sym_SLASH] = ACTIONS(3045),
    [anon_sym_LT] = ACTIONS(3045),
    [anon_sym_TILDE] = ACTIONS(3047),
    [anon_sym_void] = ACTIONS(3045),
    [anon_sym_delete] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3047),
    [anon_sym_DASH_DASH] = ACTIONS(3047),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3047),
    [sym_number] = ACTIONS(3047),
    [sym_private_property_identifier] = ACTIONS(3047),
    [sym_this] = ACTIONS(3045),
    [sym_super] = ACTIONS(3045),
    [sym_true] = ACTIONS(3045),
    [sym_false] = ACTIONS(3045),
    [sym_null] = ACTIONS(3045),
    [sym_undefined] = ACTIONS(3045),
    [anon_sym_AT] = ACTIONS(3047),
    [anon_sym_static] = ACTIONS(3045),
    [anon_sym_readonly] = ACTIONS(3045),
    [anon_sym_get] = ACTIONS(3045),
    [anon_sym_set] = ACTIONS(3045),
    [anon_sym_QMARK] = ACTIONS(3047),
    [anon_sym_declare] = ACTIONS(3045),
    [anon_sym_public] = ACTIONS(3045),
    [anon_sym_private] = ACTIONS(3045),
    [anon_sym_protected] = ACTIONS(3045),
    [anon_sym_override] = ACTIONS(3045),
    [anon_sym_module] = ACTIONS(3045),
    [anon_sym_any] = ACTIONS(3045),
    [anon_sym_number] = ACTIONS(3045),
    [anon_sym_boolean] = ACTIONS(3045),
    [anon_sym_string] = ACTIONS(3045),
    [anon_sym_symbol] = ACTIONS(3045),
    [anon_sym_object] = ACTIONS(3045),
    [anon_sym_property] = ACTIONS(3045),
    [anon_sym_signal] = ACTIONS(3045),
    [anon_sym_on] = ACTIONS(3045),
    [anon_sym_required] = ACTIONS(3045),
    [anon_sym_component] = ACTIONS(3045),
    [anon_sym_extends] = ACTIONS(3045),
    [sym_html_comment] = ACTIONS(5),
  },
  [930] = {
    [sym_export_statement] = STATE(4075),
    [sym_object_pattern] = STATE(3599),
    [sym_object_assignment_pattern] = STATE(5126),
    [sym_array_pattern] = STATE(3599),
    [sym__call_signature] = STATE(4331),
    [sym__destructuring_pattern] = STATE(6297),
    [sym_spread_element] = STATE(5056),
    [sym_string] = STATE(3505),
    [sym_comment] = STATE(930),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(3540),
    [sym_rest_pattern] = STATE(5126),
    [sym_method_definition] = STATE(5056),
    [sym_pair] = STATE(5056),
    [sym_pair_pattern] = STATE(5126),
    [sym__property_name] = STATE(3352),
    [sym_computed_property_name] = STATE(3505),
    [sym_method_signature] = STATE(4075),
    [sym_accessibility_modifier] = STATE(2736),
    [sym_override_modifier] = STATE(2775),
    [sym_call_signature] = STATE(4075),
    [sym_property_signature] = STATE(4075),
    [sym_type_parameters] = STATE(5867),
    [sym_construct_signature] = STATE(4075),
    [sym_index_signature] = STATE(4075),
    [aux_sym_export_statement_repeat1] = STATE(4766),
    [aux_sym_object_repeat1] = STATE(5050),
    [aux_sym_object_pattern_repeat1] = STATE(4996),
    [sym_identifier] = ACTIONS(3049),
    [anon_sym_export] = ACTIONS(3051),
    [anon_sym_STAR] = ACTIONS(3053),
    [anon_sym_type] = ACTIONS(3049),
    [anon_sym_namespace] = ACTIONS(3049),
    [anon_sym_LBRACE] = ACTIONS(3055),
    [anon_sym_COMMA] = ACTIONS(3057),
    [anon_sym_RBRACE] = ACTIONS(3059),
    [anon_sym_from] = ACTIONS(3049),
    [anon_sym_let] = ACTIONS(3049),
    [anon_sym_LPAREN] = ACTIONS(3061),
    [anon_sym_of] = ACTIONS(3049),
    [anon_sym_SEMI] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3065),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_async] = ACTIONS(3067),
    [anon_sym_new] = ACTIONS(3069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(219),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_LT] = ACTIONS(3073),
    [aux_sym_comment_token1] = ACTIONS(15),
    [sym_number] = ACTIONS(3075),
    [sym_private_property_identifier] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(3077),
    [anon_sym_readonly] = ACTIONS(3079),
    [anon_sym_get] = ACTIONS(3081),
    [anon_sym_set] = ACTIONS(3081),
    [anon_sym_declare] = ACTIONS(3049),
    [anon_sym_public] = ACTIONS(3083),
    [anon_sym_private] = ACTIONS(3083),
    [anon_sym_protected] = ACTIONS(3083),
    [anon_sym_override] = ACTIONS(3085),
    [anon_sym_module] = ACTIONS(3049),
    [anon_sym_any] = ACTIONS(3049),
    [anon_sym_number] = ACTIONS(3049),
    [anon_sym_boolean] = ACTIONS(3049),
    [anon_sym_string] = ACTIONS(3049),
    [anon_sym_symbol] = ACTIONS(3049),
    [anon_sym_object] = ACTIONS(3049),
    [anon_sym_property] = ACTIONS(3049),
    [anon_sym_signal] = ACTIONS(3049),
    [anon_sym_on] = ACTIONS(3049),
    [anon_sym_required] = ACTIONS(3049),
    [anon_sym_component] = ACTIONS(3049),
    [anon_sym_abstract] = ACTIONS(3087),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3089),
    [sym_html_comment] = ACTIONS(5),
  },
  [931] = {
    [sym_comment] = STATE(931),
    [sym_identifier] = ACTIONS(3091),
    [anon_sym_export] = ACTIONS(3091),
    [anon_sym_type] = ACTIONS(3091),
    [anon_sym_EQ] = ACTIONS(3091),
    [anon_sym_namespace] = ACTIONS(3091),
    [anon_sym_LBRACE] = ACTIONS(3093),
    [anon_sym_COMMA] = ACTIONS(3093),
    [anon_sym_RBRACE] = ACTIONS(3093),
    [anon_sym_typeof] = ACTIONS(3091),
    [anon_sym_import] = ACTIONS(3091),
    [anon_sym_from] = ACTIONS(3091),
    [anon_sym_let] = ACTIONS(3091),
    [anon_sym_BANG] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3093),
    [anon_sym_RPAREN] = ACTIONS(3093),
    [anon_sym_await] = ACTIONS(3091),
    [anon_sym_of] = ACTIONS(3091),
    [anon_sym_COLON] = ACTIONS(3093),
    [anon_sym_yield] = ACTIONS(3091),
    [anon_sym_LBRACK] = ACTIONS(3093),
    [anon_sym_RBRACK] = ACTIONS(3093),
    [anon_sym_LTtemplate_GT] = ACTIONS(3093),
    [anon_sym_GT] = ACTIONS(3093),
    [anon_sym_DQUOTE] = ACTIONS(3093),
    [anon_sym_SQUOTE] = ACTIONS(3093),
    [anon_sym_class] = ACTIONS(3091),
    [anon_sym_async] = ACTIONS(3091),
    [anon_sym_function] = ACTIONS(3091),
    [anon_sym_EQ_GT] = ACTIONS(3093),
    [anon_sym_new] = ACTIONS(3091),
    [anon_sym_using] = ACTIONS(3091),
    [anon_sym_AMP] = ACTIONS(3093),
    [anon_sym_PIPE] = ACTIONS(3093),
    [anon_sym_PLUS] = ACTIONS(3091),
    [anon_sym_DASH] = ACTIONS(3091),
    [anon_sym_SLASH] = ACTIONS(3091),
    [anon_sym_LT] = ACTIONS(3091),
    [anon_sym_TILDE] = ACTIONS(3093),
    [anon_sym_void] = ACTIONS(3091),
    [anon_sym_delete] = ACTIONS(3091),
    [anon_sym_PLUS_PLUS] = ACTIONS(3093),
    [anon_sym_DASH_DASH] = ACTIONS(3093),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3093),
    [sym_number] = ACTIONS(3093),
    [sym_private_property_identifier] = ACTIONS(3093),
    [sym_this] = ACTIONS(3091),
    [sym_super] = ACTIONS(3091),
    [sym_true] = ACTIONS(3091),
    [sym_false] = ACTIONS(3091),
    [sym_null] = ACTIONS(3091),
    [sym_undefined] = ACTIONS(3091),
    [anon_sym_AT] = ACTIONS(3093),
    [anon_sym_static] = ACTIONS(3091),
    [anon_sym_readonly] = ACTIONS(3091),
    [anon_sym_get] = ACTIONS(3091),
    [anon_sym_set] = ACTIONS(3091),
    [anon_sym_QMARK] = ACTIONS(3093),
    [anon_sym_declare] = ACTIONS(3091),
    [anon_sym_public] = ACTIONS(3091),
    [anon_sym_private] = ACTIONS(3091),
    [anon_sym_protected] = ACTIONS(3091),
    [anon_sym_override] = ACTIONS(3091),
    [anon_sym_module] = ACTIONS(3091),
    [anon_sym_any] = ACTIONS(3091),
    [anon_sym_number] = ACTIONS(3091),
    [anon_sym_boolean] = ACTIONS(3091),
    [anon_sym_string] = ACTIONS(3091),
    [anon_sym_symbol] = ACTIONS(3091),
    [anon_sym_object] = ACTIONS(3091),
    [anon_sym_property] = ACTIONS(3091),
    [anon_sym_signal] = ACTIONS(3091),
    [anon_sym_on] = ACTIONS(3091),
    [anon_sym_required] = ACTIONS(3091),
    [anon_sym_component] = ACTIONS(3091),
    [anon_sym_extends] = ACTIONS(3091),
    [sym_html_comment] = ACTIONS(5),
  },
  [932] = {
    [sym_export_statement] = STATE(4075),
    [sym_object_pattern] = STATE(3599),
    [sym_object_assignment_pattern] = STATE(5126),
    [sym_array_pattern] = STATE(3599),
    [sym__call_signature] = STATE(4331),
    [sym__destructuring_pattern] = STATE(6297),
    [sym_spread_element] = STATE(5056),
    [sym_string] = STATE(3505),
    [sym_comment] = STATE(932),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(3540),
    [sym_rest_pattern] = STATE(5126),
    [sym_method_definition] = STATE(5056),
    [sym_pair] = STATE(5056),
    [sym_pair_pattern] = STATE(5126),
    [sym__property_name] = STATE(3352),
    [sym_computed_property_name] = STATE(3505),
    [sym_method_signature] = STATE(4075),
    [sym_accessibility_modifier] = STATE(2736),
    [sym_override_modifier] = STATE(2775),
    [sym_call_signature] = STATE(4075),
    [sym_property_signature] = STATE(4075),
    [sym_type_parameters] = STATE(5867),
    [sym_construct_signature] = STATE(4075),
    [sym_index_signature] = STATE(4075),
    [aux_sym_export_statement_repeat1] = STATE(4766),
    [aux_sym_object_repeat1] = STATE(5050),
    [aux_sym_object_pattern_repeat1] = STATE(4996),
    [sym_identifier] = ACTIONS(3095),
    [anon_sym_export] = ACTIONS(3097),
    [anon_sym_STAR] = ACTIONS(3053),
    [anon_sym_type] = ACTIONS(3095),
    [anon_sym_namespace] = ACTIONS(3095),
    [anon_sym_LBRACE] = ACTIONS(3055),
    [anon_sym_COMMA] = ACTIONS(3057),
    [anon_sym_RBRACE] = ACTIONS(3099),
    [anon_sym_from] = ACTIONS(3095),
    [anon_sym_let] = ACTIONS(3095),
    [anon_sym_LPAREN] = ACTIONS(3061),
    [anon_sym_of] = ACTIONS(3095),
    [anon_sym_SEMI] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3065),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_async] = ACTIONS(3101),
    [anon_sym_new] = ACTIONS(3103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(219),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_LT] = ACTIONS(3073),
    [aux_sym_comment_token1] = ACTIONS(15),
    [sym_number] = ACTIONS(3075),
    [sym_private_property_identifier] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(3105),
    [anon_sym_readonly] = ACTIONS(3107),
    [anon_sym_get] = ACTIONS(3109),
    [anon_sym_set] = ACTIONS(3109),
    [anon_sym_declare] = ACTIONS(3095),
    [anon_sym_public] = ACTIONS(3111),
    [anon_sym_private] = ACTIONS(3111),
    [anon_sym_protected] = ACTIONS(3111),
    [anon_sym_override] = ACTIONS(3113),
    [anon_sym_module] = ACTIONS(3095),
    [anon_sym_any] = ACTIONS(3095),
    [anon_sym_number] = ACTIONS(3095),
    [anon_sym_boolean] = ACTIONS(3095),
    [anon_sym_string] = ACTIONS(3095),
    [anon_sym_symbol] = ACTIONS(3095),
    [anon_sym_object] = ACTIONS(3095),
    [anon_sym_property] = ACTIONS(3095),
    [anon_sym_signal] = ACTIONS(3095),
    [anon_sym_on] = ACTIONS(3095),
    [anon_sym_required] = ACTIONS(3095),
    [anon_sym_component] = ACTIONS(3095),
    [anon_sym_abstract] = ACTIONS(3087),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3089),
    [sym_html_comment] = ACTIONS(5),
  },
  [933] = {
    [sym_comment] = STATE(933),
    [sym_identifier] = ACTIONS(1842),
    [anon_sym_export] = ACTIONS(1842),
    [anon_sym_STAR] = ACTIONS(1844),
    [anon_sym_default] = ACTIONS(1842),
    [anon_sym_type] = ACTIONS(1842),
    [anon_sym_as] = ACTIONS(1844),
    [anon_sym_namespace] = ACTIONS(1842),
    [anon_sym_COMMA] = ACTIONS(1848),
    [anon_sym_RBRACE] = ACTIONS(1846),
    [anon_sym_from] = ACTIONS(1842),
    [anon_sym_var] = ACTIONS(1842),
    [anon_sym_let] = ACTIONS(1842),
    [anon_sym_BANG] = ACTIONS(1844),
    [anon_sym_else] = ACTIONS(1842),
    [anon_sym_LPAREN] = ACTIONS(1848),
    [anon_sym_in] = ACTIONS(1844),
    [anon_sym_of] = ACTIONS(1842),
    [anon_sym_SEMI] = ACTIONS(1848),
    [anon_sym_LBRACK] = ACTIONS(1848),
    [anon_sym_GT] = ACTIONS(1844),
    [anon_sym_DOT] = ACTIONS(1848),
    [anon_sym_async] = ACTIONS(1842),
    [anon_sym_function] = ACTIONS(1842),
    [anon_sym_QMARK_DOT] = ACTIONS(1848),
    [anon_sym_AMP_AMP] = ACTIONS(1848),
    [anon_sym_PIPE_PIPE] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1844),
    [anon_sym_GT_GT_GT] = ACTIONS(1848),
    [anon_sym_LT_LT] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(1844),
    [anon_sym_CARET] = ACTIONS(1848),
    [anon_sym_PIPE] = ACTIONS(1844),
    [anon_sym_PLUS] = ACTIONS(1844),
    [anon_sym_DASH] = ACTIONS(1844),
    [anon_sym_SLASH] = ACTIONS(1844),
    [anon_sym_PERCENT] = ACTIONS(1848),
    [anon_sym_STAR_STAR] = ACTIONS(1848),
    [anon_sym_LT] = ACTIONS(1844),
    [anon_sym_LT_EQ] = ACTIONS(1848),
    [anon_sym_EQ_EQ] = ACTIONS(1844),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1848),
    [anon_sym_BANG_EQ] = ACTIONS(1844),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1848),
    [anon_sym_GT_EQ] = ACTIONS(1848),
    [anon_sym_QMARK_QMARK] = ACTIONS(1848),
    [anon_sym_instanceof] = ACTIONS(1844),
    [anon_sym_PLUS_PLUS] = ACTIONS(1848),
    [anon_sym_DASH_DASH] = ACTIONS(1848),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1848),
    [anon_sym_AT] = ACTIONS(1846),
    [anon_sym_static] = ACTIONS(1842),
    [anon_sym_readonly] = ACTIONS(1842),
    [anon_sym_get] = ACTIONS(1842),
    [anon_sym_set] = ACTIONS(1842),
    [anon_sym_declare] = ACTIONS(1842),
    [anon_sym_public] = ACTIONS(1842),
    [anon_sym_private] = ACTIONS(1842),
    [anon_sym_protected] = ACTIONS(1842),
    [anon_sym_override] = ACTIONS(1842),
    [anon_sym_module] = ACTIONS(1842),
    [anon_sym_any] = ACTIONS(1842),
    [anon_sym_number] = ACTIONS(1842),
    [anon_sym_boolean] = ACTIONS(1842),
    [anon_sym_string] = ACTIONS(1842),
    [anon_sym_symbol] = ACTIONS(1842),
    [anon_sym_object] = ACTIONS(1842),
    [anon_sym_property] = ACTIONS(1842),
    [anon_sym_signal] = ACTIONS(1842),
    [anon_sym_on] = ACTIONS(1842),
    [anon_sym_required] = ACTIONS(1842),
    [anon_sym_component] = ACTIONS(1842),
    [anon_sym_satisfies] = ACTIONS(1844),
    [anon_sym_enum] = ACTIONS(1842),
    [sym__automatic_semicolon] = ACTIONS(1848),
    [sym__ternary_qmark] = ACTIONS(1848),
    [sym_html_comment] = ACTIONS(5),
  },
  [934] = {
    [sym_comment] = STATE(934),
    [sym_identifier] = ACTIONS(3091),
    [anon_sym_export] = ACTIONS(3091),
    [anon_sym_type] = ACTIONS(3091),
    [anon_sym_EQ] = ACTIONS(3091),
    [anon_sym_namespace] = ACTIONS(3091),
    [anon_sym_LBRACE] = ACTIONS(3093),
    [anon_sym_COMMA] = ACTIONS(3093),
    [anon_sym_RBRACE] = ACTIONS(3093),
    [anon_sym_typeof] = ACTIONS(3091),
    [anon_sym_import] = ACTIONS(3091),
    [anon_sym_from] = ACTIONS(3091),
    [anon_sym_let] = ACTIONS(3091),
    [anon_sym_BANG] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3093),
    [anon_sym_RPAREN] = ACTIONS(3093),
    [anon_sym_await] = ACTIONS(3091),
    [anon_sym_of] = ACTIONS(3091),
    [anon_sym_COLON] = ACTIONS(3093),
    [anon_sym_yield] = ACTIONS(3091),
    [anon_sym_LBRACK] = ACTIONS(3093),
    [anon_sym_RBRACK] = ACTIONS(3093),
    [anon_sym_LTtemplate_GT] = ACTIONS(3093),
    [anon_sym_GT] = ACTIONS(3093),
    [anon_sym_DQUOTE] = ACTIONS(3093),
    [anon_sym_SQUOTE] = ACTIONS(3093),
    [anon_sym_class] = ACTIONS(3091),
    [anon_sym_async] = ACTIONS(3091),
    [anon_sym_function] = ACTIONS(3091),
    [anon_sym_EQ_GT] = ACTIONS(3093),
    [anon_sym_new] = ACTIONS(3091),
    [anon_sym_using] = ACTIONS(3091),
    [anon_sym_AMP] = ACTIONS(3093),
    [anon_sym_PIPE] = ACTIONS(3093),
    [anon_sym_PLUS] = ACTIONS(3091),
    [anon_sym_DASH] = ACTIONS(3091),
    [anon_sym_SLASH] = ACTIONS(3091),
    [anon_sym_LT] = ACTIONS(3091),
    [anon_sym_TILDE] = ACTIONS(3093),
    [anon_sym_void] = ACTIONS(3091),
    [anon_sym_delete] = ACTIONS(3091),
    [anon_sym_PLUS_PLUS] = ACTIONS(3093),
    [anon_sym_DASH_DASH] = ACTIONS(3093),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3093),
    [sym_number] = ACTIONS(3093),
    [sym_private_property_identifier] = ACTIONS(3093),
    [sym_this] = ACTIONS(3091),
    [sym_super] = ACTIONS(3091),
    [sym_true] = ACTIONS(3091),
    [sym_false] = ACTIONS(3091),
    [sym_null] = ACTIONS(3091),
    [sym_undefined] = ACTIONS(3091),
    [anon_sym_AT] = ACTIONS(3093),
    [anon_sym_static] = ACTIONS(3091),
    [anon_sym_readonly] = ACTIONS(3091),
    [anon_sym_get] = ACTIONS(3091),
    [anon_sym_set] = ACTIONS(3091),
    [anon_sym_QMARK] = ACTIONS(3093),
    [anon_sym_declare] = ACTIONS(3091),
    [anon_sym_public] = ACTIONS(3091),
    [anon_sym_private] = ACTIONS(3091),
    [anon_sym_protected] = ACTIONS(3091),
    [anon_sym_override] = ACTIONS(3091),
    [anon_sym_module] = ACTIONS(3091),
    [anon_sym_any] = ACTIONS(3091),
    [anon_sym_number] = ACTIONS(3091),
    [anon_sym_boolean] = ACTIONS(3091),
    [anon_sym_string] = ACTIONS(3091),
    [anon_sym_symbol] = ACTIONS(3091),
    [anon_sym_object] = ACTIONS(3091),
    [anon_sym_property] = ACTIONS(3091),
    [anon_sym_signal] = ACTIONS(3091),
    [anon_sym_on] = ACTIONS(3091),
    [anon_sym_required] = ACTIONS(3091),
    [anon_sym_component] = ACTIONS(3091),
    [anon_sym_extends] = ACTIONS(3091),
    [sym_html_comment] = ACTIONS(5),
  },
  [935] = {
    [sym_comment] = STATE(935),
    [sym_identifier] = ACTIONS(3115),
    [anon_sym_export] = ACTIONS(3115),
    [anon_sym_type] = ACTIONS(3115),
    [anon_sym_EQ] = ACTIONS(3115),
    [anon_sym_namespace] = ACTIONS(3115),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_COMMA] = ACTIONS(3117),
    [anon_sym_RBRACE] = ACTIONS(3117),
    [anon_sym_typeof] = ACTIONS(3115),
    [anon_sym_import] = ACTIONS(3115),
    [anon_sym_from] = ACTIONS(3115),
    [anon_sym_let] = ACTIONS(3115),
    [anon_sym_BANG] = ACTIONS(3117),
    [anon_sym_LPAREN] = ACTIONS(3117),
    [anon_sym_RPAREN] = ACTIONS(3117),
    [anon_sym_await] = ACTIONS(3115),
    [anon_sym_of] = ACTIONS(3115),
    [anon_sym_COLON] = ACTIONS(3117),
    [anon_sym_yield] = ACTIONS(3115),
    [anon_sym_LBRACK] = ACTIONS(3117),
    [anon_sym_RBRACK] = ACTIONS(3117),
    [anon_sym_LTtemplate_GT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_DQUOTE] = ACTIONS(3117),
    [anon_sym_SQUOTE] = ACTIONS(3117),
    [anon_sym_class] = ACTIONS(3115),
    [anon_sym_async] = ACTIONS(3115),
    [anon_sym_function] = ACTIONS(3115),
    [anon_sym_EQ_GT] = ACTIONS(3117),
    [anon_sym_new] = ACTIONS(3115),
    [anon_sym_using] = ACTIONS(3115),
    [anon_sym_AMP] = ACTIONS(3117),
    [anon_sym_PIPE] = ACTIONS(3117),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_SLASH] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3115),
    [anon_sym_TILDE] = ACTIONS(3117),
    [anon_sym_void] = ACTIONS(3115),
    [anon_sym_delete] = ACTIONS(3115),
    [anon_sym_PLUS_PLUS] = ACTIONS(3117),
    [anon_sym_DASH_DASH] = ACTIONS(3117),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3117),
    [sym_number] = ACTIONS(3117),
    [sym_private_property_identifier] = ACTIONS(3117),
    [sym_this] = ACTIONS(3115),
    [sym_super] = ACTIONS(3115),
    [sym_true] = ACTIONS(3115),
    [sym_false] = ACTIONS(3115),
    [sym_null] = ACTIONS(3115),
    [sym_undefined] = ACTIONS(3115),
    [anon_sym_AT] = ACTIONS(3117),
    [anon_sym_static] = ACTIONS(3115),
    [anon_sym_readonly] = ACTIONS(3115),
    [anon_sym_get] = ACTIONS(3115),
    [anon_sym_set] = ACTIONS(3115),
    [anon_sym_QMARK] = ACTIONS(3117),
    [anon_sym_declare] = ACTIONS(3115),
    [anon_sym_public] = ACTIONS(3115),
    [anon_sym_private] = ACTIONS(3115),
    [anon_sym_protected] = ACTIONS(3115),
    [anon_sym_override] = ACTIONS(3115),
    [anon_sym_module] = ACTIONS(3115),
    [anon_sym_any] = ACTIONS(3115),
    [anon_sym_number] = ACTIONS(3115),
    [anon_sym_boolean] = ACTIONS(3115),
    [anon_sym_string] = ACTIONS(3115),
    [anon_sym_symbol] = ACTIONS(3115),
    [anon_sym_object] = ACTIONS(3115),
    [anon_sym_property] = ACTIONS(3115),
    [anon_sym_signal] = ACTIONS(3115),
    [anon_sym_on] = ACTIONS(3115),
    [anon_sym_required] = ACTIONS(3115),
    [anon_sym_component] = ACTIONS(3115),
    [anon_sym_extends] = ACTIONS(3115),
    [sym_html_comment] = ACTIONS(5),
  },
  [936] = {
    [sym_comment] = STATE(936),
    [sym_identifier] = ACTIONS(3119),
    [anon_sym_export] = ACTIONS(3119),
    [anon_sym_type] = ACTIONS(3119),
    [anon_sym_EQ] = ACTIONS(3119),
    [anon_sym_namespace] = ACTIONS(3119),
    [anon_sym_LBRACE] = ACTIONS(3121),
    [anon_sym_COMMA] = ACTIONS(3121),
    [anon_sym_RBRACE] = ACTIONS(3121),
    [anon_sym_typeof] = ACTIONS(3119),
    [anon_sym_import] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_BANG] = ACTIONS(3121),
    [anon_sym_LPAREN] = ACTIONS(3121),
    [anon_sym_RPAREN] = ACTIONS(3121),
    [anon_sym_await] = ACTIONS(3119),
    [anon_sym_of] = ACTIONS(3119),
    [anon_sym_COLON] = ACTIONS(3121),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_LBRACK] = ACTIONS(3121),
    [anon_sym_RBRACK] = ACTIONS(3121),
    [anon_sym_LTtemplate_GT] = ACTIONS(3121),
    [anon_sym_GT] = ACTIONS(3121),
    [anon_sym_DQUOTE] = ACTIONS(3121),
    [anon_sym_SQUOTE] = ACTIONS(3121),
    [anon_sym_class] = ACTIONS(3119),
    [anon_sym_async] = ACTIONS(3119),
    [anon_sym_function] = ACTIONS(3119),
    [anon_sym_EQ_GT] = ACTIONS(3121),
    [anon_sym_new] = ACTIONS(3119),
    [anon_sym_using] = ACTIONS(3119),
    [anon_sym_AMP] = ACTIONS(3121),
    [anon_sym_PIPE] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3119),
    [anon_sym_DASH] = ACTIONS(3119),
    [anon_sym_SLASH] = ACTIONS(3119),
    [anon_sym_LT] = ACTIONS(3119),
    [anon_sym_TILDE] = ACTIONS(3121),
    [anon_sym_void] = ACTIONS(3119),
    [anon_sym_delete] = ACTIONS(3119),
    [anon_sym_PLUS_PLUS] = ACTIONS(3121),
    [anon_sym_DASH_DASH] = ACTIONS(3121),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3121),
    [sym_number] = ACTIONS(3121),
    [sym_private_property_identifier] = ACTIONS(3121),
    [sym_this] = ACTIONS(3119),
    [sym_super] = ACTIONS(3119),
    [sym_true] = ACTIONS(3119),
    [sym_false] = ACTIONS(3119),
    [sym_null] = ACTIONS(3119),
    [sym_undefined] = ACTIONS(3119),
    [anon_sym_AT] = ACTIONS(3121),
    [anon_sym_static] = ACTIONS(3119),
    [anon_sym_readonly] = ACTIONS(3119),
    [anon_sym_get] = ACTIONS(3119),
    [anon_sym_set] = ACTIONS(3119),
    [anon_sym_QMARK] = ACTIONS(3121),
    [anon_sym_declare] = ACTIONS(3119),
    [anon_sym_public] = ACTIONS(3119),
    [anon_sym_private] = ACTIONS(3119),
    [anon_sym_protected] = ACTIONS(3119),
    [anon_sym_override] = ACTIONS(3119),
    [anon_sym_module] = ACTIONS(3119),
    [anon_sym_any] = ACTIONS(3119),
    [anon_sym_number] = ACTIONS(3119),
    [anon_sym_boolean] = ACTIONS(3119),
    [anon_sym_string] = ACTIONS(3119),
    [anon_sym_symbol] = ACTIONS(3119),
    [anon_sym_object] = ACTIONS(3119),
    [anon_sym_property] = ACTIONS(3119),
    [anon_sym_signal] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_required] = ACTIONS(3119),
    [anon_sym_component] = ACTIONS(3119),
    [anon_sym_extends] = ACTIONS(3119),
    [sym_html_comment] = ACTIONS(5),
  },
  [937] = {
    [sym_comment] = STATE(937),
    [sym_identifier] = ACTIONS(3123),
    [anon_sym_export] = ACTIONS(3123),
    [anon_sym_type] = ACTIONS(3123),
    [anon_sym_EQ] = ACTIONS(3123),
    [anon_sym_namespace] = ACTIONS(3123),
    [anon_sym_LBRACE] = ACTIONS(3125),
    [anon_sym_COMMA] = ACTIONS(3125),
    [anon_sym_RBRACE] = ACTIONS(3125),
    [anon_sym_typeof] = ACTIONS(3123),
    [anon_sym_import] = ACTIONS(3123),
    [anon_sym_from] = ACTIONS(3123),
    [anon_sym_let] = ACTIONS(3123),
    [anon_sym_BANG] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3125),
    [anon_sym_RPAREN] = ACTIONS(3125),
    [anon_sym_await] = ACTIONS(3123),
    [anon_sym_of] = ACTIONS(3123),
    [anon_sym_COLON] = ACTIONS(3125),
    [anon_sym_yield] = ACTIONS(3123),
    [anon_sym_LBRACK] = ACTIONS(3125),
    [anon_sym_RBRACK] = ACTIONS(3125),
    [anon_sym_LTtemplate_GT] = ACTIONS(3125),
    [anon_sym_GT] = ACTIONS(3125),
    [anon_sym_DQUOTE] = ACTIONS(3125),
    [anon_sym_SQUOTE] = ACTIONS(3125),
    [anon_sym_class] = ACTIONS(3123),
    [anon_sym_async] = ACTIONS(3123),
    [anon_sym_function] = ACTIONS(3123),
    [anon_sym_EQ_GT] = ACTIONS(3125),
    [anon_sym_new] = ACTIONS(3123),
    [anon_sym_using] = ACTIONS(3123),
    [anon_sym_AMP] = ACTIONS(3125),
    [anon_sym_PIPE] = ACTIONS(3125),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_SLASH] = ACTIONS(3123),
    [anon_sym_LT] = ACTIONS(3123),
    [anon_sym_TILDE] = ACTIONS(3125),
    [anon_sym_void] = ACTIONS(3123),
    [anon_sym_delete] = ACTIONS(3123),
    [anon_sym_PLUS_PLUS] = ACTIONS(3125),
    [anon_sym_DASH_DASH] = ACTIONS(3125),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3125),
    [sym_number] = ACTIONS(3125),
    [sym_private_property_identifier] = ACTIONS(3125),
    [sym_this] = ACTIONS(3123),
    [sym_super] = ACTIONS(3123),
    [sym_true] = ACTIONS(3123),
    [sym_false] = ACTIONS(3123),
    [sym_null] = ACTIONS(3123),
    [sym_undefined] = ACTIONS(3123),
    [anon_sym_AT] = ACTIONS(3125),
    [anon_sym_static] = ACTIONS(3123),
    [anon_sym_readonly] = ACTIONS(3123),
    [anon_sym_get] = ACTIONS(3123),
    [anon_sym_set] = ACTIONS(3123),
    [anon_sym_QMARK] = ACTIONS(3125),
    [anon_sym_declare] = ACTIONS(3123),
    [anon_sym_public] = ACTIONS(3123),
    [anon_sym_private] = ACTIONS(3123),
    [anon_sym_protected] = ACTIONS(3123),
    [anon_sym_override] = ACTIONS(3123),
    [anon_sym_module] = ACTIONS(3123),
    [anon_sym_any] = ACTIONS(3123),
    [anon_sym_number] = ACTIONS(3123),
    [anon_sym_boolean] = ACTIONS(3123),
    [anon_sym_string] = ACTIONS(3123),
    [anon_sym_symbol] = ACTIONS(3123),
    [anon_sym_object] = ACTIONS(3123),
    [anon_sym_property] = ACTIONS(3123),
    [anon_sym_signal] = ACTIONS(3123),
    [anon_sym_on] = ACTIONS(3123),
    [anon_sym_required] = ACTIONS(3123),
    [anon_sym_component] = ACTIONS(3123),
    [anon_sym_extends] = ACTIONS(3123),
    [sym_html_comment] = ACTIONS(5),
  },
  [938] = {
    [sym_export_statement] = STATE(4169),
    [sym_object_pattern] = STATE(3599),
    [sym_object_assignment_pattern] = STATE(5126),
    [sym_array_pattern] = STATE(3599),
    [sym__call_signature] = STATE(4331),
    [sym__destructuring_pattern] = STATE(6297),
    [sym_spread_element] = STATE(5056),
    [sym_string] = STATE(3505),
    [sym_comment] = STATE(938),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(3540),
    [sym_rest_pattern] = STATE(5126),
    [sym_method_definition] = STATE(5056),
    [sym_pair] = STATE(5056),
    [sym_pair_pattern] = STATE(5126),
    [sym__property_name] = STATE(3352),
    [sym_computed_property_name] = STATE(3505),
    [sym_method_signature] = STATE(4169),
    [sym_accessibility_modifier] = STATE(2736),
    [sym_override_modifier] = STATE(2775),
    [sym_call_signature] = STATE(4169),
    [sym_property_signature] = STATE(4169),
    [sym_type_parameters] = STATE(5867),
    [sym_construct_signature] = STATE(4169),
    [sym_index_signature] = STATE(4169),
    [aux_sym_export_statement_repeat1] = STATE(4766),
    [aux_sym_object_repeat1] = STATE(5050),
    [aux_sym_object_pattern_repeat1] = STATE(4996),
    [sym_identifier] = ACTIONS(3049),
    [anon_sym_export] = ACTIONS(3051),
    [anon_sym_STAR] = ACTIONS(3053),
    [anon_sym_type] = ACTIONS(3049),
    [anon_sym_namespace] = ACTIONS(3049),
    [anon_sym_LBRACE] = ACTIONS(3055),
    [anon_sym_COMMA] = ACTIONS(3127),
    [anon_sym_RBRACE] = ACTIONS(3129),
    [anon_sym_from] = ACTIONS(3049),
    [anon_sym_let] = ACTIONS(3049),
    [anon_sym_LPAREN] = ACTIONS(3061),
    [anon_sym_of] = ACTIONS(3049),
    [anon_sym_SEMI] = ACTIONS(3131),
    [anon_sym_LBRACK] = ACTIONS(3065),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_async] = ACTIONS(3067),
    [anon_sym_new] = ACTIONS(3069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(219),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_LT] = ACTIONS(3073),
    [aux_sym_comment_token1] = ACTIONS(15),
    [sym_number] = ACTIONS(3075),
    [sym_private_property_identifier] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(3077),
    [anon_sym_readonly] = ACTIONS(3079),
    [anon_sym_get] = ACTIONS(3081),
    [anon_sym_set] = ACTIONS(3081),
    [anon_sym_declare] = ACTIONS(3049),
    [anon_sym_public] = ACTIONS(3083),
    [anon_sym_private] = ACTIONS(3083),
    [anon_sym_protected] = ACTIONS(3083),
    [anon_sym_override] = ACTIONS(3085),
    [anon_sym_module] = ACTIONS(3049),
    [anon_sym_any] = ACTIONS(3049),
    [anon_sym_number] = ACTIONS(3049),
    [anon_sym_boolean] = ACTIONS(3049),
    [anon_sym_string] = ACTIONS(3049),
    [anon_sym_symbol] = ACTIONS(3049),
    [anon_sym_object] = ACTIONS(3049),
    [anon_sym_property] = ACTIONS(3049),
    [anon_sym_signal] = ACTIONS(3049),
    [anon_sym_on] = ACTIONS(3049),
    [anon_sym_required] = ACTIONS(3049),
    [anon_sym_component] = ACTIONS(3049),
    [anon_sym_abstract] = ACTIONS(3087),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3133),
    [sym_html_comment] = ACTIONS(5),
  },
  [939] = {
    [sym_comment] = STATE(939),
    [sym_identifier] = ACTIONS(3119),
    [anon_sym_export] = ACTIONS(3119),
    [anon_sym_type] = ACTIONS(3119),
    [anon_sym_EQ] = ACTIONS(3119),
    [anon_sym_namespace] = ACTIONS(3119),
    [anon_sym_LBRACE] = ACTIONS(3121),
    [anon_sym_COMMA] = ACTIONS(3121),
    [anon_sym_RBRACE] = ACTIONS(3121),
    [anon_sym_typeof] = ACTIONS(3119),
    [anon_sym_import] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_BANG] = ACTIONS(3121),
    [anon_sym_LPAREN] = ACTIONS(3121),
    [anon_sym_RPAREN] = ACTIONS(3121),
    [anon_sym_await] = ACTIONS(3119),
    [anon_sym_of] = ACTIONS(3119),
    [anon_sym_COLON] = ACTIONS(3121),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_LBRACK] = ACTIONS(3121),
    [anon_sym_RBRACK] = ACTIONS(3121),
    [anon_sym_LTtemplate_GT] = ACTIONS(3121),
    [anon_sym_GT] = ACTIONS(3121),
    [anon_sym_DQUOTE] = ACTIONS(3121),
    [anon_sym_SQUOTE] = ACTIONS(3121),
    [anon_sym_class] = ACTIONS(3119),
    [anon_sym_async] = ACTIONS(3119),
    [anon_sym_function] = ACTIONS(3119),
    [anon_sym_EQ_GT] = ACTIONS(3121),
    [anon_sym_new] = ACTIONS(3119),
    [anon_sym_using] = ACTIONS(3119),
    [anon_sym_AMP] = ACTIONS(3121),
    [anon_sym_PIPE] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3119),
    [anon_sym_DASH] = ACTIONS(3119),
    [anon_sym_SLASH] = ACTIONS(3119),
    [anon_sym_LT] = ACTIONS(3119),
    [anon_sym_TILDE] = ACTIONS(3121),
    [anon_sym_void] = ACTIONS(3119),
    [anon_sym_delete] = ACTIONS(3119),
    [anon_sym_PLUS_PLUS] = ACTIONS(3121),
    [anon_sym_DASH_DASH] = ACTIONS(3121),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3121),
    [sym_number] = ACTIONS(3121),
    [sym_private_property_identifier] = ACTIONS(3121),
    [sym_this] = ACTIONS(3119),
    [sym_super] = ACTIONS(3119),
    [sym_true] = ACTIONS(3119),
    [sym_false] = ACTIONS(3119),
    [sym_null] = ACTIONS(3119),
    [sym_undefined] = ACTIONS(3119),
    [anon_sym_AT] = ACTIONS(3121),
    [anon_sym_static] = ACTIONS(3119),
    [anon_sym_readonly] = ACTIONS(3119),
    [anon_sym_get] = ACTIONS(3119),
    [anon_sym_set] = ACTIONS(3119),
    [anon_sym_QMARK] = ACTIONS(3121),
    [anon_sym_declare] = ACTIONS(3119),
    [anon_sym_public] = ACTIONS(3119),
    [anon_sym_private] = ACTIONS(3119),
    [anon_sym_protected] = ACTIONS(3119),
    [anon_sym_override] = ACTIONS(3119),
    [anon_sym_module] = ACTIONS(3119),
    [anon_sym_any] = ACTIONS(3119),
    [anon_sym_number] = ACTIONS(3119),
    [anon_sym_boolean] = ACTIONS(3119),
    [anon_sym_string] = ACTIONS(3119),
    [anon_sym_symbol] = ACTIONS(3119),
    [anon_sym_object] = ACTIONS(3119),
    [anon_sym_property] = ACTIONS(3119),
    [anon_sym_signal] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_required] = ACTIONS(3119),
    [anon_sym_component] = ACTIONS(3119),
    [anon_sym_extends] = ACTIONS(3119),
    [sym_html_comment] = ACTIONS(5),
  },
  [940] = {
    [sym_comment] = STATE(940),
    [sym_identifier] = ACTIONS(3135),
    [anon_sym_export] = ACTIONS(3135),
    [anon_sym_type] = ACTIONS(3135),
    [anon_sym_EQ] = ACTIONS(3135),
    [anon_sym_namespace] = ACTIONS(3135),
    [anon_sym_LBRACE] = ACTIONS(3137),
    [anon_sym_COMMA] = ACTIONS(3137),
    [anon_sym_RBRACE] = ACTIONS(3137),
    [anon_sym_typeof] = ACTIONS(3135),
    [anon_sym_import] = ACTIONS(3135),
    [anon_sym_from] = ACTIONS(3135),
    [anon_sym_let] = ACTIONS(3135),
    [anon_sym_BANG] = ACTIONS(3137),
    [anon_sym_LPAREN] = ACTIONS(3137),
    [anon_sym_RPAREN] = ACTIONS(3137),
    [anon_sym_await] = ACTIONS(3135),
    [anon_sym_of] = ACTIONS(3135),
    [anon_sym_COLON] = ACTIONS(3137),
    [anon_sym_yield] = ACTIONS(3135),
    [anon_sym_LBRACK] = ACTIONS(3137),
    [anon_sym_RBRACK] = ACTIONS(3137),
    [anon_sym_LTtemplate_GT] = ACTIONS(3137),
    [anon_sym_GT] = ACTIONS(3137),
    [anon_sym_DQUOTE] = ACTIONS(3137),
    [anon_sym_SQUOTE] = ACTIONS(3137),
    [anon_sym_class] = ACTIONS(3135),
    [anon_sym_async] = ACTIONS(3135),
    [anon_sym_function] = ACTIONS(3135),
    [anon_sym_EQ_GT] = ACTIONS(3137),
    [anon_sym_new] = ACTIONS(3135),
    [anon_sym_using] = ACTIONS(3135),
    [anon_sym_AMP] = ACTIONS(3137),
    [anon_sym_PIPE] = ACTIONS(3137),
    [anon_sym_PLUS] = ACTIONS(3135),
    [anon_sym_DASH] = ACTIONS(3135),
    [anon_sym_SLASH] = ACTIONS(3135),
    [anon_sym_LT] = ACTIONS(3135),
    [anon_sym_TILDE] = ACTIONS(3137),
    [anon_sym_void] = ACTIONS(3135),
    [anon_sym_delete] = ACTIONS(3135),
    [anon_sym_PLUS_PLUS] = ACTIONS(3137),
    [anon_sym_DASH_DASH] = ACTIONS(3137),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3137),
    [sym_number] = ACTIONS(3137),
    [sym_private_property_identifier] = ACTIONS(3137),
    [sym_this] = ACTIONS(3135),
    [sym_super] = ACTIONS(3135),
    [sym_true] = ACTIONS(3135),
    [sym_false] = ACTIONS(3135),
    [sym_null] = ACTIONS(3135),
    [sym_undefined] = ACTIONS(3135),
    [anon_sym_AT] = ACTIONS(3137),
    [anon_sym_static] = ACTIONS(3135),
    [anon_sym_readonly] = ACTIONS(3135),
    [anon_sym_get] = ACTIONS(3135),
    [anon_sym_set] = ACTIONS(3135),
    [anon_sym_QMARK] = ACTIONS(3137),
    [anon_sym_declare] = ACTIONS(3135),
    [anon_sym_public] = ACTIONS(3135),
    [anon_sym_private] = ACTIONS(3135),
    [anon_sym_protected] = ACTIONS(3135),
    [anon_sym_override] = ACTIONS(3135),
    [anon_sym_module] = ACTIONS(3135),
    [anon_sym_any] = ACTIONS(3135),
    [anon_sym_number] = ACTIONS(3135),
    [anon_sym_boolean] = ACTIONS(3135),
    [anon_sym_string] = ACTIONS(3135),
    [anon_sym_symbol] = ACTIONS(3135),
    [anon_sym_object] = ACTIONS(3135),
    [anon_sym_property] = ACTIONS(3135),
    [anon_sym_signal] = ACTIONS(3135),
    [anon_sym_on] = ACTIONS(3135),
    [anon_sym_required] = ACTIONS(3135),
    [anon_sym_component] = ACTIONS(3135),
    [anon_sym_extends] = ACTIONS(3135),
    [sym_html_comment] = ACTIONS(5),
  },
  [941] = {
    [sym_comment] = STATE(941),
    [sym_identifier] = ACTIONS(1972),
    [anon_sym_export] = ACTIONS(1972),
    [anon_sym_STAR] = ACTIONS(1974),
    [anon_sym_default] = ACTIONS(1972),
    [anon_sym_type] = ACTIONS(1972),
    [anon_sym_as] = ACTIONS(1974),
    [anon_sym_namespace] = ACTIONS(1972),
    [anon_sym_COMMA] = ACTIONS(1978),
    [anon_sym_RBRACE] = ACTIONS(1976),
    [anon_sym_from] = ACTIONS(1972),
    [anon_sym_var] = ACTIONS(1972),
    [anon_sym_let] = ACTIONS(1972),
    [anon_sym_BANG] = ACTIONS(1974),
    [anon_sym_else] = ACTIONS(1972),
    [anon_sym_LPAREN] = ACTIONS(1978),
    [anon_sym_in] = ACTIONS(1974),
    [anon_sym_of] = ACTIONS(1972),
    [anon_sym_SEMI] = ACTIONS(1978),
    [anon_sym_LBRACK] = ACTIONS(1978),
    [anon_sym_GT] = ACTIONS(1974),
    [anon_sym_DOT] = ACTIONS(1978),
    [anon_sym_async] = ACTIONS(1972),
    [anon_sym_function] = ACTIONS(1972),
    [anon_sym_QMARK_DOT] = ACTIONS(1978),
    [anon_sym_AMP_AMP] = ACTIONS(1978),
    [anon_sym_PIPE_PIPE] = ACTIONS(1978),
    [anon_sym_GT_GT] = ACTIONS(1974),
    [anon_sym_GT_GT_GT] = ACTIONS(1978),
    [anon_sym_LT_LT] = ACTIONS(1978),
    [anon_sym_AMP] = ACTIONS(1974),
    [anon_sym_CARET] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(1974),
    [anon_sym_PLUS] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1974),
    [anon_sym_SLASH] = ACTIONS(1974),
    [anon_sym_PERCENT] = ACTIONS(1978),
    [anon_sym_STAR_STAR] = ACTIONS(1978),
    [anon_sym_LT] = ACTIONS(1974),
    [anon_sym_LT_EQ] = ACTIONS(1978),
    [anon_sym_EQ_EQ] = ACTIONS(1974),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1978),
    [anon_sym_BANG_EQ] = ACTIONS(1974),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1978),
    [anon_sym_GT_EQ] = ACTIONS(1978),
    [anon_sym_QMARK_QMARK] = ACTIONS(1978),
    [anon_sym_instanceof] = ACTIONS(1974),
    [anon_sym_PLUS_PLUS] = ACTIONS(1978),
    [anon_sym_DASH_DASH] = ACTIONS(1978),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1978),
    [anon_sym_AT] = ACTIONS(1976),
    [anon_sym_static] = ACTIONS(1972),
    [anon_sym_readonly] = ACTIONS(1972),
    [anon_sym_get] = ACTIONS(1972),
    [anon_sym_set] = ACTIONS(1972),
    [anon_sym_declare] = ACTIONS(1972),
    [anon_sym_public] = ACTIONS(1972),
    [anon_sym_private] = ACTIONS(1972),
    [anon_sym_protected] = ACTIONS(1972),
    [anon_sym_override] = ACTIONS(1972),
    [anon_sym_module] = ACTIONS(1972),
    [anon_sym_any] = ACTIONS(1972),
    [anon_sym_number] = ACTIONS(1972),
    [anon_sym_boolean] = ACTIONS(1972),
    [anon_sym_string] = ACTIONS(1972),
    [anon_sym_symbol] = ACTIONS(1972),
    [anon_sym_object] = ACTIONS(1972),
    [anon_sym_property] = ACTIONS(1972),
    [anon_sym_signal] = ACTIONS(1972),
    [anon_sym_on] = ACTIONS(1972),
    [anon_sym_required] = ACTIONS(1972),
    [anon_sym_component] = ACTIONS(1972),
    [anon_sym_satisfies] = ACTIONS(1974),
    [anon_sym_enum] = ACTIONS(1972),
    [sym__automatic_semicolon] = ACTIONS(3139),
    [sym__ternary_qmark] = ACTIONS(1978),
    [sym_html_comment] = ACTIONS(5),
  },
  [942] = {
    [sym_export_statement] = STATE(4075),
    [sym_object_pattern] = STATE(3599),
    [sym_object_assignment_pattern] = STATE(5126),
    [sym_array_pattern] = STATE(3599),
    [sym__call_signature] = STATE(4331),
    [sym__destructuring_pattern] = STATE(6297),
    [sym_spread_element] = STATE(5056),
    [sym_string] = STATE(3505),
    [sym_comment] = STATE(942),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(3540),
    [sym_rest_pattern] = STATE(5126),
    [sym_method_definition] = STATE(5056),
    [sym_pair] = STATE(5056),
    [sym_pair_pattern] = STATE(5126),
    [sym__property_name] = STATE(3352),
    [sym_computed_property_name] = STATE(3505),
    [sym_method_signature] = STATE(4075),
    [sym_accessibility_modifier] = STATE(2736),
    [sym_override_modifier] = STATE(2775),
    [sym_call_signature] = STATE(4075),
    [sym_property_signature] = STATE(4075),
    [sym_type_parameters] = STATE(5867),
    [sym_construct_signature] = STATE(4075),
    [sym_index_signature] = STATE(4075),
    [aux_sym_export_statement_repeat1] = STATE(4766),
    [aux_sym_object_repeat1] = STATE(5050),
    [aux_sym_object_pattern_repeat1] = STATE(4996),
    [sym_identifier] = ACTIONS(3095),
    [anon_sym_export] = ACTIONS(3097),
    [anon_sym_STAR] = ACTIONS(3053),
    [anon_sym_type] = ACTIONS(3095),
    [anon_sym_namespace] = ACTIONS(3095),
    [anon_sym_LBRACE] = ACTIONS(3055),
    [anon_sym_COMMA] = ACTIONS(3057),
    [anon_sym_RBRACE] = ACTIONS(3141),
    [anon_sym_from] = ACTIONS(3095),
    [anon_sym_let] = ACTIONS(3095),
    [anon_sym_LPAREN] = ACTIONS(3061),
    [anon_sym_of] = ACTIONS(3095),
    [anon_sym_SEMI] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3065),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_async] = ACTIONS(3101),
    [anon_sym_new] = ACTIONS(3103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(219),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_LT] = ACTIONS(3073),
    [aux_sym_comment_token1] = ACTIONS(15),
    [sym_number] = ACTIONS(3075),
    [sym_private_property_identifier] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(3105),
    [anon_sym_readonly] = ACTIONS(3107),
    [anon_sym_get] = ACTIONS(3109),
    [anon_sym_set] = ACTIONS(3109),
    [anon_sym_declare] = ACTIONS(3095),
    [anon_sym_public] = ACTIONS(3111),
    [anon_sym_private] = ACTIONS(3111),
    [anon_sym_protected] = ACTIONS(3111),
    [anon_sym_override] = ACTIONS(3113),
    [anon_sym_module] = ACTIONS(3095),
    [anon_sym_any] = ACTIONS(3095),
    [anon_sym_number] = ACTIONS(3095),
    [anon_sym_boolean] = ACTIONS(3095),
    [anon_sym_string] = ACTIONS(3095),
    [anon_sym_symbol] = ACTIONS(3095),
    [anon_sym_object] = ACTIONS(3095),
    [anon_sym_property] = ACTIONS(3095),
    [anon_sym_signal] = ACTIONS(3095),
    [anon_sym_on] = ACTIONS(3095),
    [anon_sym_required] = ACTIONS(3095),
    [anon_sym_component] = ACTIONS(3095),
    [anon_sym_abstract] = ACTIONS(3087),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3089),
    [sym_html_comment] = ACTIONS(5),
  },
  [943] = {
    [sym_comment] = STATE(943),
    [sym_identifier] = ACTIONS(1828),
    [anon_sym_export] = ACTIONS(1828),
    [anon_sym_STAR] = ACTIONS(1830),
    [anon_sym_default] = ACTIONS(1828),
    [anon_sym_type] = ACTIONS(1828),
    [anon_sym_as] = ACTIONS(1830),
    [anon_sym_namespace] = ACTIONS(1828),
    [anon_sym_COMMA] = ACTIONS(1834),
    [anon_sym_RBRACE] = ACTIONS(1832),
    [anon_sym_from] = ACTIONS(1828),
    [anon_sym_var] = ACTIONS(1828),
    [anon_sym_let] = ACTIONS(1828),
    [anon_sym_BANG] = ACTIONS(1830),
    [anon_sym_else] = ACTIONS(1828),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_in] = ACTIONS(1830),
    [anon_sym_of] = ACTIONS(1828),
    [anon_sym_SEMI] = ACTIONS(1834),
    [anon_sym_LBRACK] = ACTIONS(1834),
    [anon_sym_GT] = ACTIONS(1830),
    [anon_sym_DOT] = ACTIONS(1834),
    [anon_sym_async] = ACTIONS(1828),
    [anon_sym_function] = ACTIONS(1828),
    [anon_sym_QMARK_DOT] = ACTIONS(1834),
    [anon_sym_AMP_AMP] = ACTIONS(1834),
    [anon_sym_PIPE_PIPE] = ACTIONS(1834),
    [anon_sym_GT_GT] = ACTIONS(1830),
    [anon_sym_GT_GT_GT] = ACTIONS(1834),
    [anon_sym_LT_LT] = ACTIONS(1834),
    [anon_sym_AMP] = ACTIONS(1830),
    [anon_sym_CARET] = ACTIONS(1834),
    [anon_sym_PIPE] = ACTIONS(1830),
    [anon_sym_PLUS] = ACTIONS(1830),
    [anon_sym_DASH] = ACTIONS(1830),
    [anon_sym_SLASH] = ACTIONS(1830),
    [anon_sym_PERCENT] = ACTIONS(1834),
    [anon_sym_STAR_STAR] = ACTIONS(1834),
    [anon_sym_LT] = ACTIONS(1830),
    [anon_sym_LT_EQ] = ACTIONS(1834),
    [anon_sym_EQ_EQ] = ACTIONS(1830),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1834),
    [anon_sym_BANG_EQ] = ACTIONS(1830),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1834),
    [anon_sym_GT_EQ] = ACTIONS(1834),
    [anon_sym_QMARK_QMARK] = ACTIONS(1834),
    [anon_sym_instanceof] = ACTIONS(1830),
    [anon_sym_PLUS_PLUS] = ACTIONS(1834),
    [anon_sym_DASH_DASH] = ACTIONS(1834),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1834),
    [anon_sym_AT] = ACTIONS(1832),
    [anon_sym_static] = ACTIONS(1828),
    [anon_sym_readonly] = ACTIONS(1828),
    [anon_sym_get] = ACTIONS(1828),
    [anon_sym_set] = ACTIONS(1828),
    [anon_sym_declare] = ACTIONS(1828),
    [anon_sym_public] = ACTIONS(1828),
    [anon_sym_private] = ACTIONS(1828),
    [anon_sym_protected] = ACTIONS(1828),
    [anon_sym_override] = ACTIONS(1828),
    [anon_sym_module] = ACTIONS(1828),
    [anon_sym_any] = ACTIONS(1828),
    [anon_sym_number] = ACTIONS(1828),
    [anon_sym_boolean] = ACTIONS(1828),
    [anon_sym_string] = ACTIONS(1828),
    [anon_sym_symbol] = ACTIONS(1828),
    [anon_sym_object] = ACTIONS(1828),
    [anon_sym_property] = ACTIONS(1828),
    [anon_sym_signal] = ACTIONS(1828),
    [anon_sym_on] = ACTIONS(1828),
    [anon_sym_required] = ACTIONS(1828),
    [anon_sym_component] = ACTIONS(1828),
    [anon_sym_satisfies] = ACTIONS(1830),
    [anon_sym_enum] = ACTIONS(1828),
    [sym__automatic_semicolon] = ACTIONS(3143),
    [sym__ternary_qmark] = ACTIONS(1834),
    [sym_html_comment] = ACTIONS(5),
  },
  [944] = {
    [sym_comment] = STATE(944),
    [sym_identifier] = ACTIONS(3145),
    [anon_sym_export] = ACTIONS(3145),
    [anon_sym_type] = ACTIONS(3145),
    [anon_sym_EQ] = ACTIONS(3145),
    [anon_sym_namespace] = ACTIONS(3145),
    [anon_sym_LBRACE] = ACTIONS(3147),
    [anon_sym_COMMA] = ACTIONS(3147),
    [anon_sym_RBRACE] = ACTIONS(3147),
    [anon_sym_typeof] = ACTIONS(3145),
    [anon_sym_import] = ACTIONS(3145),
    [anon_sym_from] = ACTIONS(3145),
    [anon_sym_let] = ACTIONS(3145),
    [anon_sym_BANG] = ACTIONS(3147),
    [anon_sym_LPAREN] = ACTIONS(3147),
    [anon_sym_RPAREN] = ACTIONS(3147),
    [anon_sym_await] = ACTIONS(3145),
    [anon_sym_of] = ACTIONS(3145),
    [anon_sym_COLON] = ACTIONS(3147),
    [anon_sym_yield] = ACTIONS(3145),
    [anon_sym_LBRACK] = ACTIONS(3147),
    [anon_sym_RBRACK] = ACTIONS(3147),
    [anon_sym_LTtemplate_GT] = ACTIONS(3147),
    [anon_sym_GT] = ACTIONS(3147),
    [anon_sym_DQUOTE] = ACTIONS(3147),
    [anon_sym_SQUOTE] = ACTIONS(3147),
    [anon_sym_class] = ACTIONS(3145),
    [anon_sym_async] = ACTIONS(3145),
    [anon_sym_function] = ACTIONS(3145),
    [anon_sym_EQ_GT] = ACTIONS(3147),
    [anon_sym_new] = ACTIONS(3145),
    [anon_sym_using] = ACTIONS(3145),
    [anon_sym_AMP] = ACTIONS(3147),
    [anon_sym_PIPE] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3145),
    [anon_sym_DASH] = ACTIONS(3145),
    [anon_sym_SLASH] = ACTIONS(3145),
    [anon_sym_LT] = ACTIONS(3145),
    [anon_sym_TILDE] = ACTIONS(3147),
    [anon_sym_void] = ACTIONS(3145),
    [anon_sym_delete] = ACTIONS(3145),
    [anon_sym_PLUS_PLUS] = ACTIONS(3147),
    [anon_sym_DASH_DASH] = ACTIONS(3147),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3147),
    [sym_number] = ACTIONS(3147),
    [sym_private_property_identifier] = ACTIONS(3147),
    [sym_this] = ACTIONS(3145),
    [sym_super] = ACTIONS(3145),
    [sym_true] = ACTIONS(3145),
    [sym_false] = ACTIONS(3145),
    [sym_null] = ACTIONS(3145),
    [sym_undefined] = ACTIONS(3145),
    [anon_sym_AT] = ACTIONS(3147),
    [anon_sym_static] = ACTIONS(3145),
    [anon_sym_readonly] = ACTIONS(3145),
    [anon_sym_get] = ACTIONS(3145),
    [anon_sym_set] = ACTIONS(3145),
    [anon_sym_QMARK] = ACTIONS(3147),
    [anon_sym_declare] = ACTIONS(3145),
    [anon_sym_public] = ACTIONS(3145),
    [anon_sym_private] = ACTIONS(3145),
    [anon_sym_protected] = ACTIONS(3145),
    [anon_sym_override] = ACTIONS(3145),
    [anon_sym_module] = ACTIONS(3145),
    [anon_sym_any] = ACTIONS(3145),
    [anon_sym_number] = ACTIONS(3145),
    [anon_sym_boolean] = ACTIONS(3145),
    [anon_sym_string] = ACTIONS(3145),
    [anon_sym_symbol] = ACTIONS(3145),
    [anon_sym_object] = ACTIONS(3145),
    [anon_sym_property] = ACTIONS(3145),
    [anon_sym_signal] = ACTIONS(3145),
    [anon_sym_on] = ACTIONS(3145),
    [anon_sym_required] = ACTIONS(3145),
    [anon_sym_component] = ACTIONS(3145),
    [anon_sym_extends] = ACTIONS(3145),
    [sym_html_comment] = ACTIONS(5),
  },
  [945] = {
    [sym_comment] = STATE(945),
    [sym_identifier] = ACTIONS(1992),
    [anon_sym_export] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1994),
    [anon_sym_default] = ACTIONS(1992),
    [anon_sym_type] = ACTIONS(1992),
    [anon_sym_as] = ACTIONS(1994),
    [anon_sym_namespace] = ACTIONS(1992),
    [anon_sym_COMMA] = ACTIONS(1998),
    [anon_sym_RBRACE] = ACTIONS(1996),
    [anon_sym_from] = ACTIONS(1992),
    [anon_sym_var] = ACTIONS(1992),
    [anon_sym_let] = ACTIONS(1992),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_else] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1998),
    [anon_sym_in] = ACTIONS(1994),
    [anon_sym_of] = ACTIONS(1992),
    [anon_sym_SEMI] = ACTIONS(1998),
    [anon_sym_LBRACK] = ACTIONS(1998),
    [anon_sym_GT] = ACTIONS(1994),
    [anon_sym_DOT] = ACTIONS(1998),
    [anon_sym_async] = ACTIONS(1992),
    [anon_sym_function] = ACTIONS(1992),
    [anon_sym_QMARK_DOT] = ACTIONS(1998),
    [anon_sym_AMP_AMP] = ACTIONS(1998),
    [anon_sym_PIPE_PIPE] = ACTIONS(1998),
    [anon_sym_GT_GT] = ACTIONS(1994),
    [anon_sym_GT_GT_GT] = ACTIONS(1998),
    [anon_sym_LT_LT] = ACTIONS(1998),
    [anon_sym_AMP] = ACTIONS(1994),
    [anon_sym_CARET] = ACTIONS(1998),
    [anon_sym_PIPE] = ACTIONS(1994),
    [anon_sym_PLUS] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1994),
    [anon_sym_SLASH] = ACTIONS(1994),
    [anon_sym_PERCENT] = ACTIONS(1998),
    [anon_sym_STAR_STAR] = ACTIONS(1998),
    [anon_sym_LT] = ACTIONS(1994),
    [anon_sym_LT_EQ] = ACTIONS(1998),
    [anon_sym_EQ_EQ] = ACTIONS(1994),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1998),
    [anon_sym_BANG_EQ] = ACTIONS(1994),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1998),
    [anon_sym_GT_EQ] = ACTIONS(1998),
    [anon_sym_QMARK_QMARK] = ACTIONS(1998),
    [anon_sym_instanceof] = ACTIONS(1994),
    [anon_sym_PLUS_PLUS] = ACTIONS(1998),
    [anon_sym_DASH_DASH] = ACTIONS(1998),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1998),
    [anon_sym_AT] = ACTIONS(1996),
    [anon_sym_static] = ACTIONS(1992),
    [anon_sym_readonly] = ACTIONS(1992),
    [anon_sym_get] = ACTIONS(1992),
    [anon_sym_set] = ACTIONS(1992),
    [anon_sym_declare] = ACTIONS(1992),
    [anon_sym_public] = ACTIONS(1992),
    [anon_sym_private] = ACTIONS(1992),
    [anon_sym_protected] = ACTIONS(1992),
    [anon_sym_override] = ACTIONS(1992),
    [anon_sym_module] = ACTIONS(1992),
    [anon_sym_any] = ACTIONS(1992),
    [anon_sym_number] = ACTIONS(1992),
    [anon_sym_boolean] = ACTIONS(1992),
    [anon_sym_string] = ACTIONS(1992),
    [anon_sym_symbol] = ACTIONS(1992),
    [anon_sym_object] = ACTIONS(1992),
    [anon_sym_property] = ACTIONS(1992),
    [anon_sym_signal] = ACTIONS(1992),
    [anon_sym_on] = ACTIONS(1992),
    [anon_sym_required] = ACTIONS(1992),
    [anon_sym_component] = ACTIONS(1992),
    [anon_sym_satisfies] = ACTIONS(1994),
    [anon_sym_enum] = ACTIONS(1992),
    [sym__automatic_semicolon] = ACTIONS(3149),
    [sym__ternary_qmark] = ACTIONS(1998),
    [sym_html_comment] = ACTIONS(5),
  },
  [946] = {
    [sym_comment] = STATE(946),
    [sym_identifier] = ACTIONS(1854),
    [anon_sym_export] = ACTIONS(1854),
    [anon_sym_STAR] = ACTIONS(1854),
    [anon_sym_default] = ACTIONS(1854),
    [anon_sym_type] = ACTIONS(1854),
    [anon_sym_as] = ACTIONS(1854),
    [anon_sym_namespace] = ACTIONS(1854),
    [anon_sym_COMMA] = ACTIONS(1856),
    [anon_sym_RBRACE] = ACTIONS(1856),
    [anon_sym_from] = ACTIONS(1854),
    [anon_sym_var] = ACTIONS(1854),
    [anon_sym_let] = ACTIONS(1854),
    [anon_sym_BANG] = ACTIONS(1854),
    [anon_sym_else] = ACTIONS(1854),
    [anon_sym_LPAREN] = ACTIONS(1856),
    [anon_sym_in] = ACTIONS(1854),
    [anon_sym_of] = ACTIONS(1854),
    [anon_sym_SEMI] = ACTIONS(1856),
    [anon_sym_LBRACK] = ACTIONS(1856),
    [anon_sym_GT] = ACTIONS(1854),
    [anon_sym_DOT] = ACTIONS(1856),
    [anon_sym_async] = ACTIONS(1854),
    [anon_sym_function] = ACTIONS(1854),
    [anon_sym_QMARK_DOT] = ACTIONS(1856),
    [anon_sym_AMP_AMP] = ACTIONS(1856),
    [anon_sym_PIPE_PIPE] = ACTIONS(1856),
    [anon_sym_GT_GT] = ACTIONS(1854),
    [anon_sym_GT_GT_GT] = ACTIONS(1856),
    [anon_sym_LT_LT] = ACTIONS(1856),
    [anon_sym_AMP] = ACTIONS(1854),
    [anon_sym_CARET] = ACTIONS(1856),
    [anon_sym_PIPE] = ACTIONS(1854),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_DASH] = ACTIONS(1854),
    [anon_sym_SLASH] = ACTIONS(1854),
    [anon_sym_PERCENT] = ACTIONS(1856),
    [anon_sym_STAR_STAR] = ACTIONS(1856),
    [anon_sym_LT] = ACTIONS(1854),
    [anon_sym_LT_EQ] = ACTIONS(1856),
    [anon_sym_EQ_EQ] = ACTIONS(1854),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1856),
    [anon_sym_BANG_EQ] = ACTIONS(1854),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1856),
    [anon_sym_GT_EQ] = ACTIONS(1856),
    [anon_sym_QMARK_QMARK] = ACTIONS(1856),
    [anon_sym_instanceof] = ACTIONS(1854),
    [anon_sym_PLUS_PLUS] = ACTIONS(1856),
    [anon_sym_DASH_DASH] = ACTIONS(1856),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1856),
    [anon_sym_AT] = ACTIONS(1856),
    [anon_sym_static] = ACTIONS(1854),
    [anon_sym_readonly] = ACTIONS(1854),
    [anon_sym_get] = ACTIONS(1854),
    [anon_sym_set] = ACTIONS(1854),
    [anon_sym_declare] = ACTIONS(1854),
    [anon_sym_public] = ACTIONS(1854),
    [anon_sym_private] = ACTIONS(1854),
    [anon_sym_protected] = ACTIONS(1854),
    [anon_sym_override] = ACTIONS(1854),
    [anon_sym_module] = ACTIONS(1854),
    [anon_sym_any] = ACTIONS(1854),
    [anon_sym_number] = ACTIONS(1854),
    [anon_sym_boolean] = ACTIONS(1854),
    [anon_sym_string] = ACTIONS(1854),
    [anon_sym_symbol] = ACTIONS(1854),
    [anon_sym_object] = ACTIONS(1854),
    [anon_sym_property] = ACTIONS(1854),
    [anon_sym_signal] = ACTIONS(1854),
    [anon_sym_on] = ACTIONS(1854),
    [anon_sym_required] = ACTIONS(1854),
    [anon_sym_component] = ACTIONS(1854),
    [anon_sym_satisfies] = ACTIONS(1854),
    [anon_sym_enum] = ACTIONS(1854),
    [sym__automatic_semicolon] = ACTIONS(1856),
    [sym__ternary_qmark] = ACTIONS(1856),
    [sym_html_comment] = ACTIONS(5),
  },
  [947] = {
    [sym_comment] = STATE(947),
    [sym_identifier] = ACTIONS(1948),
    [anon_sym_export] = ACTIONS(1948),
    [anon_sym_STAR] = ACTIONS(1950),
    [anon_sym_default] = ACTIONS(1948),
    [anon_sym_type] = ACTIONS(1948),
    [anon_sym_as] = ACTIONS(1950),
    [anon_sym_namespace] = ACTIONS(1948),
    [anon_sym_COMMA] = ACTIONS(1954),
    [anon_sym_RBRACE] = ACTIONS(1952),
    [anon_sym_from] = ACTIONS(1948),
    [anon_sym_var] = ACTIONS(1948),
    [anon_sym_let] = ACTIONS(1948),
    [anon_sym_BANG] = ACTIONS(1950),
    [anon_sym_else] = ACTIONS(1948),
    [anon_sym_LPAREN] = ACTIONS(1954),
    [anon_sym_in] = ACTIONS(1950),
    [anon_sym_of] = ACTIONS(1948),
    [anon_sym_SEMI] = ACTIONS(1954),
    [anon_sym_LBRACK] = ACTIONS(1954),
    [anon_sym_GT] = ACTIONS(1950),
    [anon_sym_DOT] = ACTIONS(1954),
    [anon_sym_async] = ACTIONS(1948),
    [anon_sym_function] = ACTIONS(1948),
    [anon_sym_QMARK_DOT] = ACTIONS(1954),
    [anon_sym_AMP_AMP] = ACTIONS(1954),
    [anon_sym_PIPE_PIPE] = ACTIONS(1954),
    [anon_sym_GT_GT] = ACTIONS(1950),
    [anon_sym_GT_GT_GT] = ACTIONS(1954),
    [anon_sym_LT_LT] = ACTIONS(1954),
    [anon_sym_AMP] = ACTIONS(1950),
    [anon_sym_CARET] = ACTIONS(1954),
    [anon_sym_PIPE] = ACTIONS(1950),
    [anon_sym_PLUS] = ACTIONS(1950),
    [anon_sym_DASH] = ACTIONS(1950),
    [anon_sym_SLASH] = ACTIONS(1950),
    [anon_sym_PERCENT] = ACTIONS(1954),
    [anon_sym_STAR_STAR] = ACTIONS(1954),
    [anon_sym_LT] = ACTIONS(1950),
    [anon_sym_LT_EQ] = ACTIONS(1954),
    [anon_sym_EQ_EQ] = ACTIONS(1950),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1954),
    [anon_sym_BANG_EQ] = ACTIONS(1950),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1954),
    [anon_sym_GT_EQ] = ACTIONS(1954),
    [anon_sym_QMARK_QMARK] = ACTIONS(1954),
    [anon_sym_instanceof] = ACTIONS(1950),
    [anon_sym_PLUS_PLUS] = ACTIONS(1954),
    [anon_sym_DASH_DASH] = ACTIONS(1954),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1954),
    [anon_sym_AT] = ACTIONS(1952),
    [anon_sym_static] = ACTIONS(1948),
    [anon_sym_readonly] = ACTIONS(1948),
    [anon_sym_get] = ACTIONS(1948),
    [anon_sym_set] = ACTIONS(1948),
    [anon_sym_declare] = ACTIONS(1948),
    [anon_sym_public] = ACTIONS(1948),
    [anon_sym_private] = ACTIONS(1948),
    [anon_sym_protected] = ACTIONS(1948),
    [anon_sym_override] = ACTIONS(1948),
    [anon_sym_module] = ACTIONS(1948),
    [anon_sym_any] = ACTIONS(1948),
    [anon_sym_number] = ACTIONS(1948),
    [anon_sym_boolean] = ACTIONS(1948),
    [anon_sym_string] = ACTIONS(1948),
    [anon_sym_symbol] = ACTIONS(1948),
    [anon_sym_object] = ACTIONS(1948),
    [anon_sym_property] = ACTIONS(1948),
    [anon_sym_signal] = ACTIONS(1948),
    [anon_sym_on] = ACTIONS(1948),
    [anon_sym_required] = ACTIONS(1948),
    [anon_sym_component] = ACTIONS(1948),
    [anon_sym_satisfies] = ACTIONS(1950),
    [anon_sym_enum] = ACTIONS(1948),
    [sym__automatic_semicolon] = ACTIONS(3151),
    [sym__ternary_qmark] = ACTIONS(1954),
    [sym_html_comment] = ACTIONS(5),
  },
  [948] = {
    [sym_comment] = STATE(948),
    [sym_identifier] = ACTIONS(3153),
    [anon_sym_export] = ACTIONS(3153),
    [anon_sym_type] = ACTIONS(3153),
    [anon_sym_EQ] = ACTIONS(3153),
    [anon_sym_namespace] = ACTIONS(3153),
    [anon_sym_LBRACE] = ACTIONS(3155),
    [anon_sym_COMMA] = ACTIONS(3155),
    [anon_sym_RBRACE] = ACTIONS(3155),
    [anon_sym_typeof] = ACTIONS(3153),
    [anon_sym_import] = ACTIONS(3153),
    [anon_sym_from] = ACTIONS(3153),
    [anon_sym_let] = ACTIONS(3153),
    [anon_sym_BANG] = ACTIONS(3155),
    [anon_sym_LPAREN] = ACTIONS(3155),
    [anon_sym_RPAREN] = ACTIONS(3155),
    [anon_sym_await] = ACTIONS(3153),
    [anon_sym_of] = ACTIONS(3153),
    [anon_sym_COLON] = ACTIONS(3155),
    [anon_sym_yield] = ACTIONS(3153),
    [anon_sym_LBRACK] = ACTIONS(3155),
    [anon_sym_RBRACK] = ACTIONS(3155),
    [anon_sym_LTtemplate_GT] = ACTIONS(3155),
    [anon_sym_GT] = ACTIONS(3155),
    [anon_sym_DQUOTE] = ACTIONS(3155),
    [anon_sym_SQUOTE] = ACTIONS(3155),
    [anon_sym_class] = ACTIONS(3153),
    [anon_sym_async] = ACTIONS(3153),
    [anon_sym_function] = ACTIONS(3153),
    [anon_sym_EQ_GT] = ACTIONS(3155),
    [anon_sym_new] = ACTIONS(3153),
    [anon_sym_using] = ACTIONS(3153),
    [anon_sym_AMP] = ACTIONS(3155),
    [anon_sym_PIPE] = ACTIONS(3155),
    [anon_sym_PLUS] = ACTIONS(3153),
    [anon_sym_DASH] = ACTIONS(3153),
    [anon_sym_SLASH] = ACTIONS(3153),
    [anon_sym_LT] = ACTIONS(3153),
    [anon_sym_TILDE] = ACTIONS(3155),
    [anon_sym_void] = ACTIONS(3153),
    [anon_sym_delete] = ACTIONS(3153),
    [anon_sym_PLUS_PLUS] = ACTIONS(3155),
    [anon_sym_DASH_DASH] = ACTIONS(3155),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3155),
    [sym_number] = ACTIONS(3155),
    [sym_private_property_identifier] = ACTIONS(3155),
    [sym_this] = ACTIONS(3153),
    [sym_super] = ACTIONS(3153),
    [sym_true] = ACTIONS(3153),
    [sym_false] = ACTIONS(3153),
    [sym_null] = ACTIONS(3153),
    [sym_undefined] = ACTIONS(3153),
    [anon_sym_AT] = ACTIONS(3155),
    [anon_sym_static] = ACTIONS(3153),
    [anon_sym_readonly] = ACTIONS(3153),
    [anon_sym_get] = ACTIONS(3153),
    [anon_sym_set] = ACTIONS(3153),
    [anon_sym_QMARK] = ACTIONS(3155),
    [anon_sym_declare] = ACTIONS(3153),
    [anon_sym_public] = ACTIONS(3153),
    [anon_sym_private] = ACTIONS(3153),
    [anon_sym_protected] = ACTIONS(3153),
    [anon_sym_override] = ACTIONS(3153),
    [anon_sym_module] = ACTIONS(3153),
    [anon_sym_any] = ACTIONS(3153),
    [anon_sym_number] = ACTIONS(3153),
    [anon_sym_boolean] = ACTIONS(3153),
    [anon_sym_string] = ACTIONS(3153),
    [anon_sym_symbol] = ACTIONS(3153),
    [anon_sym_object] = ACTIONS(3153),
    [anon_sym_property] = ACTIONS(3153),
    [anon_sym_signal] = ACTIONS(3153),
    [anon_sym_on] = ACTIONS(3153),
    [anon_sym_required] = ACTIONS(3153),
    [anon_sym_component] = ACTIONS(3153),
    [anon_sym_extends] = ACTIONS(3153),
    [sym_html_comment] = ACTIONS(5),
  },
  [949] = {
    [sym_comment] = STATE(949),
    [sym_identifier] = ACTIONS(1876),
    [anon_sym_export] = ACTIONS(1876),
    [anon_sym_STAR] = ACTIONS(1878),
    [anon_sym_default] = ACTIONS(1876),
    [anon_sym_type] = ACTIONS(1876),
    [anon_sym_as] = ACTIONS(1878),
    [anon_sym_namespace] = ACTIONS(1876),
    [anon_sym_COMMA] = ACTIONS(1882),
    [anon_sym_RBRACE] = ACTIONS(1880),
    [anon_sym_from] = ACTIONS(1876),
    [anon_sym_var] = ACTIONS(1876),
    [anon_sym_let] = ACTIONS(1876),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_else] = ACTIONS(1876),
    [anon_sym_LPAREN] = ACTIONS(1882),
    [anon_sym_in] = ACTIONS(1878),
    [anon_sym_of] = ACTIONS(1876),
    [anon_sym_SEMI] = ACTIONS(1882),
    [anon_sym_LBRACK] = ACTIONS(1882),
    [anon_sym_GT] = ACTIONS(1878),
    [anon_sym_DOT] = ACTIONS(1882),
    [anon_sym_async] = ACTIONS(1876),
    [anon_sym_function] = ACTIONS(1876),
    [anon_sym_QMARK_DOT] = ACTIONS(1882),
    [anon_sym_AMP_AMP] = ACTIONS(1882),
    [anon_sym_PIPE_PIPE] = ACTIONS(1882),
    [anon_sym_GT_GT] = ACTIONS(1878),
    [anon_sym_GT_GT_GT] = ACTIONS(1882),
    [anon_sym_LT_LT] = ACTIONS(1882),
    [anon_sym_AMP] = ACTIONS(1878),
    [anon_sym_CARET] = ACTIONS(1882),
    [anon_sym_PIPE] = ACTIONS(1878),
    [anon_sym_PLUS] = ACTIONS(1878),
    [anon_sym_DASH] = ACTIONS(1878),
    [anon_sym_SLASH] = ACTIONS(1878),
    [anon_sym_PERCENT] = ACTIONS(1882),
    [anon_sym_STAR_STAR] = ACTIONS(1882),
    [anon_sym_LT] = ACTIONS(1878),
    [anon_sym_LT_EQ] = ACTIONS(1882),
    [anon_sym_EQ_EQ] = ACTIONS(1878),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1882),
    [anon_sym_BANG_EQ] = ACTIONS(1878),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1882),
    [anon_sym_GT_EQ] = ACTIONS(1882),
    [anon_sym_QMARK_QMARK] = ACTIONS(1882),
    [anon_sym_instanceof] = ACTIONS(1878),
    [anon_sym_PLUS_PLUS] = ACTIONS(1882),
    [anon_sym_DASH_DASH] = ACTIONS(1882),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1882),
    [anon_sym_AT] = ACTIONS(1880),
    [anon_sym_static] = ACTIONS(1876),
    [anon_sym_readonly] = ACTIONS(1876),
    [anon_sym_get] = ACTIONS(1876),
    [anon_sym_set] = ACTIONS(1876),
    [anon_sym_declare] = ACTIONS(1876),
    [anon_sym_public] = ACTIONS(1876),
    [anon_sym_private] = ACTIONS(1876),
    [anon_sym_protected] = ACTIONS(1876),
    [anon_sym_override] = ACTIONS(1876),
    [anon_sym_module] = ACTIONS(1876),
    [anon_sym_any] = ACTIONS(1876),
    [anon_sym_number] = ACTIONS(1876),
    [anon_sym_boolean] = ACTIONS(1876),
    [anon_sym_string] = ACTIONS(1876),
    [anon_sym_symbol] = ACTIONS(1876),
    [anon_sym_object] = ACTIONS(1876),
    [anon_sym_property] = ACTIONS(1876),
    [anon_sym_signal] = ACTIONS(1876),
    [anon_sym_on] = ACTIONS(1876),
    [anon_sym_required] = ACTIONS(1876),
    [anon_sym_component] = ACTIONS(1876),
    [anon_sym_satisfies] = ACTIONS(1878),
    [anon_sym_enum] = ACTIONS(1876),
    [sym__automatic_semicolon] = ACTIONS(3157),
    [sym__ternary_qmark] = ACTIONS(1882),
    [sym_html_comment] = ACTIONS(5),
  },
  [950] = {
    [sym_comment] = STATE(950),
    [sym_identifier] = ACTIONS(3159),
    [anon_sym_export] = ACTIONS(3159),
    [anon_sym_type] = ACTIONS(3159),
    [anon_sym_EQ] = ACTIONS(3159),
    [anon_sym_namespace] = ACTIONS(3159),
    [anon_sym_LBRACE] = ACTIONS(3161),
    [anon_sym_COMMA] = ACTIONS(3161),
    [anon_sym_RBRACE] = ACTIONS(3161),
    [anon_sym_typeof] = ACTIONS(3159),
    [anon_sym_import] = ACTIONS(3159),
    [anon_sym_from] = ACTIONS(3159),
    [anon_sym_let] = ACTIONS(3159),
    [anon_sym_BANG] = ACTIONS(3161),
    [anon_sym_LPAREN] = ACTIONS(3161),
    [anon_sym_RPAREN] = ACTIONS(3161),
    [anon_sym_await] = ACTIONS(3159),
    [anon_sym_of] = ACTIONS(3159),
    [anon_sym_COLON] = ACTIONS(3161),
    [anon_sym_yield] = ACTIONS(3159),
    [anon_sym_LBRACK] = ACTIONS(3161),
    [anon_sym_RBRACK] = ACTIONS(3161),
    [anon_sym_LTtemplate_GT] = ACTIONS(3161),
    [anon_sym_GT] = ACTIONS(3161),
    [anon_sym_DQUOTE] = ACTIONS(3161),
    [anon_sym_SQUOTE] = ACTIONS(3161),
    [anon_sym_class] = ACTIONS(3159),
    [anon_sym_async] = ACTIONS(3159),
    [anon_sym_function] = ACTIONS(3159),
    [anon_sym_EQ_GT] = ACTIONS(3161),
    [anon_sym_new] = ACTIONS(3159),
    [anon_sym_using] = ACTIONS(3159),
    [anon_sym_AMP] = ACTIONS(3161),
    [anon_sym_PIPE] = ACTIONS(3161),
    [anon_sym_PLUS] = ACTIONS(3159),
    [anon_sym_DASH] = ACTIONS(3159),
    [anon_sym_SLASH] = ACTIONS(3159),
    [anon_sym_LT] = ACTIONS(3159),
    [anon_sym_TILDE] = ACTIONS(3161),
    [anon_sym_void] = ACTIONS(3159),
    [anon_sym_delete] = ACTIONS(3159),
    [anon_sym_PLUS_PLUS] = ACTIONS(3161),
    [anon_sym_DASH_DASH] = ACTIONS(3161),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3161),
    [sym_number] = ACTIONS(3161),
    [sym_private_property_identifier] = ACTIONS(3161),
    [sym_this] = ACTIONS(3159),
    [sym_super] = ACTIONS(3159),
    [sym_true] = ACTIONS(3159),
    [sym_false] = ACTIONS(3159),
    [sym_null] = ACTIONS(3159),
    [sym_undefined] = ACTIONS(3159),
    [anon_sym_AT] = ACTIONS(3161),
    [anon_sym_static] = ACTIONS(3159),
    [anon_sym_readonly] = ACTIONS(3159),
    [anon_sym_get] = ACTIONS(3159),
    [anon_sym_set] = ACTIONS(3159),
    [anon_sym_QMARK] = ACTIONS(3161),
    [anon_sym_declare] = ACTIONS(3159),
    [anon_sym_public] = ACTIONS(3159),
    [anon_sym_private] = ACTIONS(3159),
    [anon_sym_protected] = ACTIONS(3159),
    [anon_sym_override] = ACTIONS(3159),
    [anon_sym_module] = ACTIONS(3159),
    [anon_sym_any] = ACTIONS(3159),
    [anon_sym_number] = ACTIONS(3159),
    [anon_sym_boolean] = ACTIONS(3159),
    [anon_sym_string] = ACTIONS(3159),
    [anon_sym_symbol] = ACTIONS(3159),
    [anon_sym_object] = ACTIONS(3159),
    [anon_sym_property] = ACTIONS(3159),
    [anon_sym_signal] = ACTIONS(3159),
    [anon_sym_on] = ACTIONS(3159),
    [anon_sym_required] = ACTIONS(3159),
    [anon_sym_component] = ACTIONS(3159),
    [anon_sym_extends] = ACTIONS(3159),
    [sym_html_comment] = ACTIONS(5),
  },
  [951] = {
    [sym_comment] = STATE(951),
    [sym_identifier] = ACTIONS(1886),
    [anon_sym_export] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(1888),
    [anon_sym_default] = ACTIONS(1886),
    [anon_sym_type] = ACTIONS(1886),
    [anon_sym_as] = ACTIONS(1888),
    [anon_sym_namespace] = ACTIONS(1886),
    [anon_sym_COMMA] = ACTIONS(1892),
    [anon_sym_RBRACE] = ACTIONS(1890),
    [anon_sym_from] = ACTIONS(1886),
    [anon_sym_var] = ACTIONS(1886),
    [anon_sym_let] = ACTIONS(1886),
    [anon_sym_BANG] = ACTIONS(1888),
    [anon_sym_else] = ACTIONS(1886),
    [anon_sym_LPAREN] = ACTIONS(1892),
    [anon_sym_in] = ACTIONS(1888),
    [anon_sym_of] = ACTIONS(1886),
    [anon_sym_SEMI] = ACTIONS(1892),
    [anon_sym_LBRACK] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(1888),
    [anon_sym_DOT] = ACTIONS(1892),
    [anon_sym_async] = ACTIONS(1886),
    [anon_sym_function] = ACTIONS(1886),
    [anon_sym_QMARK_DOT] = ACTIONS(1892),
    [anon_sym_AMP_AMP] = ACTIONS(1892),
    [anon_sym_PIPE_PIPE] = ACTIONS(1892),
    [anon_sym_GT_GT] = ACTIONS(1888),
    [anon_sym_GT_GT_GT] = ACTIONS(1892),
    [anon_sym_LT_LT] = ACTIONS(1892),
    [anon_sym_AMP] = ACTIONS(1888),
    [anon_sym_CARET] = ACTIONS(1892),
    [anon_sym_PIPE] = ACTIONS(1888),
    [anon_sym_PLUS] = ACTIONS(1888),
    [anon_sym_DASH] = ACTIONS(1888),
    [anon_sym_SLASH] = ACTIONS(1888),
    [anon_sym_PERCENT] = ACTIONS(1892),
    [anon_sym_STAR_STAR] = ACTIONS(1892),
    [anon_sym_LT] = ACTIONS(1888),
    [anon_sym_LT_EQ] = ACTIONS(1892),
    [anon_sym_EQ_EQ] = ACTIONS(1888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1892),
    [anon_sym_BANG_EQ] = ACTIONS(1888),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1892),
    [anon_sym_GT_EQ] = ACTIONS(1892),
    [anon_sym_QMARK_QMARK] = ACTIONS(1892),
    [anon_sym_instanceof] = ACTIONS(1888),
    [anon_sym_PLUS_PLUS] = ACTIONS(1892),
    [anon_sym_DASH_DASH] = ACTIONS(1892),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1892),
    [anon_sym_AT] = ACTIONS(1890),
    [anon_sym_static] = ACTIONS(1886),
    [anon_sym_readonly] = ACTIONS(1886),
    [anon_sym_get] = ACTIONS(1886),
    [anon_sym_set] = ACTIONS(1886),
    [anon_sym_declare] = ACTIONS(1886),
    [anon_sym_public] = ACTIONS(1886),
    [anon_sym_private] = ACTIONS(1886),
    [anon_sym_protected] = ACTIONS(1886),
    [anon_sym_override] = ACTIONS(1886),
    [anon_sym_module] = ACTIONS(1886),
    [anon_sym_any] = ACTIONS(1886),
    [anon_sym_number] = ACTIONS(1886),
    [anon_sym_boolean] = ACTIONS(1886),
    [anon_sym_string] = ACTIONS(1886),
    [anon_sym_symbol] = ACTIONS(1886),
    [anon_sym_object] = ACTIONS(1886),
    [anon_sym_property] = ACTIONS(1886),
    [anon_sym_signal] = ACTIONS(1886),
    [anon_sym_on] = ACTIONS(1886),
    [anon_sym_required] = ACTIONS(1886),
    [anon_sym_component] = ACTIONS(1886),
    [anon_sym_satisfies] = ACTIONS(1888),
    [anon_sym_enum] = ACTIONS(1886),
    [sym__automatic_semicolon] = ACTIONS(3163),
    [sym__ternary_qmark] = ACTIONS(1892),
    [sym_html_comment] = ACTIONS(5),
  },
  [952] = {
    [sym_comment] = STATE(952),
    [sym_identifier] = ACTIONS(1916),
    [anon_sym_export] = ACTIONS(1916),
    [anon_sym_STAR] = ACTIONS(1918),
    [anon_sym_default] = ACTIONS(1916),
    [anon_sym_type] = ACTIONS(1916),
    [anon_sym_as] = ACTIONS(1918),
    [anon_sym_namespace] = ACTIONS(1916),
    [anon_sym_COMMA] = ACTIONS(1922),
    [anon_sym_RBRACE] = ACTIONS(1920),
    [anon_sym_from] = ACTIONS(1916),
    [anon_sym_var] = ACTIONS(1916),
    [anon_sym_let] = ACTIONS(1916),
    [anon_sym_BANG] = ACTIONS(1918),
    [anon_sym_else] = ACTIONS(1916),
    [anon_sym_LPAREN] = ACTIONS(1922),
    [anon_sym_in] = ACTIONS(1918),
    [anon_sym_of] = ACTIONS(1916),
    [anon_sym_SEMI] = ACTIONS(1922),
    [anon_sym_LBRACK] = ACTIONS(1922),
    [anon_sym_GT] = ACTIONS(1918),
    [anon_sym_DOT] = ACTIONS(1922),
    [anon_sym_async] = ACTIONS(1916),
    [anon_sym_function] = ACTIONS(1916),
    [anon_sym_QMARK_DOT] = ACTIONS(1922),
    [anon_sym_AMP_AMP] = ACTIONS(1922),
    [anon_sym_PIPE_PIPE] = ACTIONS(1922),
    [anon_sym_GT_GT] = ACTIONS(1918),
    [anon_sym_GT_GT_GT] = ACTIONS(1922),
    [anon_sym_LT_LT] = ACTIONS(1922),
    [anon_sym_AMP] = ACTIONS(1918),
    [anon_sym_CARET] = ACTIONS(1922),
    [anon_sym_PIPE] = ACTIONS(1918),
    [anon_sym_PLUS] = ACTIONS(1918),
    [anon_sym_DASH] = ACTIONS(1918),
    [anon_sym_SLASH] = ACTIONS(1918),
    [anon_sym_PERCENT] = ACTIONS(1922),
    [anon_sym_STAR_STAR] = ACTIONS(1922),
    [anon_sym_LT] = ACTIONS(1918),
    [anon_sym_LT_EQ] = ACTIONS(1922),
    [anon_sym_EQ_EQ] = ACTIONS(1918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1922),
    [anon_sym_BANG_EQ] = ACTIONS(1918),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1922),
    [anon_sym_GT_EQ] = ACTIONS(1922),
    [anon_sym_QMARK_QMARK] = ACTIONS(1922),
    [anon_sym_instanceof] = ACTIONS(1918),
    [anon_sym_PLUS_PLUS] = ACTIONS(1922),
    [anon_sym_DASH_DASH] = ACTIONS(1922),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1922),
    [anon_sym_AT] = ACTIONS(1920),
    [anon_sym_static] = ACTIONS(1916),
    [anon_sym_readonly] = ACTIONS(1916),
    [anon_sym_get] = ACTIONS(1916),
    [anon_sym_set] = ACTIONS(1916),
    [anon_sym_declare] = ACTIONS(1916),
    [anon_sym_public] = ACTIONS(1916),
    [anon_sym_private] = ACTIONS(1916),
    [anon_sym_protected] = ACTIONS(1916),
    [anon_sym_override] = ACTIONS(1916),
    [anon_sym_module] = ACTIONS(1916),
    [anon_sym_any] = ACTIONS(1916),
    [anon_sym_number] = ACTIONS(1916),
    [anon_sym_boolean] = ACTIONS(1916),
    [anon_sym_string] = ACTIONS(1916),
    [anon_sym_symbol] = ACTIONS(1916),
    [anon_sym_object] = ACTIONS(1916),
    [anon_sym_property] = ACTIONS(1916),
    [anon_sym_signal] = ACTIONS(1916),
    [anon_sym_on] = ACTIONS(1916),
    [anon_sym_required] = ACTIONS(1916),
    [anon_sym_component] = ACTIONS(1916),
    [anon_sym_satisfies] = ACTIONS(1918),
    [anon_sym_enum] = ACTIONS(1916),
    [sym__automatic_semicolon] = ACTIONS(3165),
    [sym__ternary_qmark] = ACTIONS(1922),
    [sym_html_comment] = ACTIONS(5),
  },
  [953] = {
    [sym_comment] = STATE(953),
    [sym_identifier] = ACTIONS(1968),
    [anon_sym_export] = ACTIONS(1968),
    [anon_sym_STAR] = ACTIONS(1968),
    [anon_sym_default] = ACTIONS(1968),
    [anon_sym_type] = ACTIONS(1968),
    [anon_sym_as] = ACTIONS(1968),
    [anon_sym_namespace] = ACTIONS(1968),
    [anon_sym_COMMA] = ACTIONS(1970),
    [anon_sym_RBRACE] = ACTIONS(1970),
    [anon_sym_from] = ACTIONS(1968),
    [anon_sym_var] = ACTIONS(1968),
    [anon_sym_let] = ACTIONS(1968),
    [anon_sym_BANG] = ACTIONS(1968),
    [anon_sym_else] = ACTIONS(1968),
    [anon_sym_LPAREN] = ACTIONS(1970),
    [anon_sym_in] = ACTIONS(1968),
    [anon_sym_of] = ACTIONS(1968),
    [anon_sym_SEMI] = ACTIONS(1970),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_GT] = ACTIONS(1968),
    [anon_sym_DOT] = ACTIONS(1970),
    [anon_sym_async] = ACTIONS(1968),
    [anon_sym_function] = ACTIONS(1968),
    [anon_sym_QMARK_DOT] = ACTIONS(1970),
    [anon_sym_AMP_AMP] = ACTIONS(1970),
    [anon_sym_PIPE_PIPE] = ACTIONS(1970),
    [anon_sym_GT_GT] = ACTIONS(1968),
    [anon_sym_GT_GT_GT] = ACTIONS(1970),
    [anon_sym_LT_LT] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(1968),
    [anon_sym_CARET] = ACTIONS(1970),
    [anon_sym_PIPE] = ACTIONS(1968),
    [anon_sym_PLUS] = ACTIONS(1968),
    [anon_sym_DASH] = ACTIONS(1968),
    [anon_sym_SLASH] = ACTIONS(1968),
    [anon_sym_PERCENT] = ACTIONS(1970),
    [anon_sym_STAR_STAR] = ACTIONS(1970),
    [anon_sym_LT] = ACTIONS(1968),
    [anon_sym_LT_EQ] = ACTIONS(1970),
    [anon_sym_EQ_EQ] = ACTIONS(1968),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1970),
    [anon_sym_BANG_EQ] = ACTIONS(1968),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1970),
    [anon_sym_GT_EQ] = ACTIONS(1970),
    [anon_sym_QMARK_QMARK] = ACTIONS(1970),
    [anon_sym_instanceof] = ACTIONS(1968),
    [anon_sym_PLUS_PLUS] = ACTIONS(1970),
    [anon_sym_DASH_DASH] = ACTIONS(1970),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1970),
    [anon_sym_AT] = ACTIONS(1970),
    [anon_sym_static] = ACTIONS(1968),
    [anon_sym_readonly] = ACTIONS(1968),
    [anon_sym_get] = ACTIONS(1968),
    [anon_sym_set] = ACTIONS(1968),
    [anon_sym_declare] = ACTIONS(1968),
    [anon_sym_public] = ACTIONS(1968),
    [anon_sym_private] = ACTIONS(1968),
    [anon_sym_protected] = ACTIONS(1968),
    [anon_sym_override] = ACTIONS(1968),
    [anon_sym_module] = ACTIONS(1968),
    [anon_sym_any] = ACTIONS(1968),
    [anon_sym_number] = ACTIONS(1968),
    [anon_sym_boolean] = ACTIONS(1968),
    [anon_sym_string] = ACTIONS(1968),
    [anon_sym_symbol] = ACTIONS(1968),
    [anon_sym_object] = ACTIONS(1968),
    [anon_sym_property] = ACTIONS(1968),
    [anon_sym_signal] = ACTIONS(1968),
    [anon_sym_on] = ACTIONS(1968),
    [anon_sym_required] = ACTIONS(1968),
    [anon_sym_component] = ACTIONS(1968),
    [anon_sym_satisfies] = ACTIONS(1968),
    [anon_sym_enum] = ACTIONS(1968),
    [sym__automatic_semicolon] = ACTIONS(1970),
    [sym__ternary_qmark] = ACTIONS(1970),
    [sym_html_comment] = ACTIONS(5),
  },
  [954] = {
    [sym_export_statement] = STATE(4075),
    [sym_object_pattern] = STATE(3599),
    [sym_object_assignment_pattern] = STATE(5126),
    [sym_array_pattern] = STATE(3599),
    [sym__call_signature] = STATE(4331),
    [sym__destructuring_pattern] = STATE(6297),
    [sym_spread_element] = STATE(5367),
    [sym_string] = STATE(3505),
    [sym_comment] = STATE(954),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(3540),
    [sym_rest_pattern] = STATE(5126),
    [sym_method_definition] = STATE(5367),
    [sym_pair] = STATE(5367),
    [sym_pair_pattern] = STATE(5126),
    [sym__property_name] = STATE(3352),
    [sym_computed_property_name] = STATE(3505),
    [sym_method_signature] = STATE(4075),
    [sym_accessibility_modifier] = STATE(2736),
    [sym_override_modifier] = STATE(2775),
    [sym_call_signature] = STATE(4075),
    [sym_property_signature] = STATE(4075),
    [sym_type_parameters] = STATE(5867),
    [sym_construct_signature] = STATE(4075),
    [sym_index_signature] = STATE(4075),
    [aux_sym_export_statement_repeat1] = STATE(4766),
    [aux_sym_object_repeat1] = STATE(5362),
    [aux_sym_object_pattern_repeat1] = STATE(4996),
    [sym_identifier] = ACTIONS(3167),
    [anon_sym_export] = ACTIONS(3169),
    [anon_sym_STAR] = ACTIONS(3053),
    [anon_sym_type] = ACTIONS(3167),
    [anon_sym_namespace] = ACTIONS(3167),
    [anon_sym_LBRACE] = ACTIONS(3055),
    [anon_sym_COMMA] = ACTIONS(3057),
    [anon_sym_RBRACE] = ACTIONS(3171),
    [anon_sym_from] = ACTIONS(3167),
    [anon_sym_let] = ACTIONS(3167),
    [anon_sym_LPAREN] = ACTIONS(3061),
    [anon_sym_of] = ACTIONS(3167),
    [anon_sym_SEMI] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3065),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_async] = ACTIONS(3173),
    [anon_sym_new] = ACTIONS(3175),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(219),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_LT] = ACTIONS(3073),
    [aux_sym_comment_token1] = ACTIONS(15),
    [sym_number] = ACTIONS(3075),
    [sym_private_property_identifier] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(3177),
    [anon_sym_readonly] = ACTIONS(3179),
    [anon_sym_get] = ACTIONS(3181),
    [anon_sym_set] = ACTIONS(3181),
    [anon_sym_declare] = ACTIONS(3167),
    [anon_sym_public] = ACTIONS(3183),
    [anon_sym_private] = ACTIONS(3183),
    [anon_sym_protected] = ACTIONS(3183),
    [anon_sym_override] = ACTIONS(3185),
    [anon_sym_module] = ACTIONS(3167),
    [anon_sym_any] = ACTIONS(3167),
    [anon_sym_number] = ACTIONS(3167),
    [anon_sym_boolean] = ACTIONS(3167),
    [anon_sym_string] = ACTIONS(3167),
    [anon_sym_symbol] = ACTIONS(3167),
    [anon_sym_object] = ACTIONS(3167),
    [anon_sym_property] = ACTIONS(3167),
    [anon_sym_signal] = ACTIONS(3167),
    [anon_sym_on] = ACTIONS(3167),
    [anon_sym_required] = ACTIONS(3167),
    [anon_sym_component] = ACTIONS(3167),
    [anon_sym_abstract] = ACTIONS(3087),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3089),
    [sym_html_comment] = ACTIONS(5),
  },
  [955] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(955),
    [sym_formal_parameters] = STATE(6257),
    [sym_rest_pattern] = STATE(5609),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4084),
    [sym_tuple_parameter] = STATE(5584),
    [sym_optional_tuple_parameter] = STATE(5584),
    [sym_optional_type] = STATE(5584),
    [sym_rest_type] = STATE(5584),
    [sym__tuple_type_member] = STATE(5193),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3187),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_COMMA] = ACTIONS(3189),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_RBRACK] = ACTIONS(3191),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [956] = {
    [sym_export_statement] = STATE(4075),
    [sym_object_pattern] = STATE(3599),
    [sym_object_assignment_pattern] = STATE(5126),
    [sym_array_pattern] = STATE(3599),
    [sym__call_signature] = STATE(4331),
    [sym__destructuring_pattern] = STATE(6297),
    [sym_spread_element] = STATE(5056),
    [sym_string] = STATE(3505),
    [sym_comment] = STATE(956),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(3540),
    [sym_rest_pattern] = STATE(5126),
    [sym_method_definition] = STATE(5056),
    [sym_pair] = STATE(5056),
    [sym_pair_pattern] = STATE(5126),
    [sym__property_name] = STATE(3352),
    [sym_computed_property_name] = STATE(3505),
    [sym_method_signature] = STATE(4075),
    [sym_accessibility_modifier] = STATE(2736),
    [sym_override_modifier] = STATE(2775),
    [sym_call_signature] = STATE(4075),
    [sym_property_signature] = STATE(4075),
    [sym_type_parameters] = STATE(5867),
    [sym_construct_signature] = STATE(4075),
    [sym_index_signature] = STATE(4075),
    [aux_sym_export_statement_repeat1] = STATE(4766),
    [aux_sym_object_repeat1] = STATE(5050),
    [aux_sym_object_pattern_repeat1] = STATE(4996),
    [sym_identifier] = ACTIONS(3049),
    [anon_sym_export] = ACTIONS(3051),
    [anon_sym_STAR] = ACTIONS(3053),
    [anon_sym_type] = ACTIONS(3049),
    [anon_sym_namespace] = ACTIONS(3049),
    [anon_sym_LBRACE] = ACTIONS(3055),
    [anon_sym_COMMA] = ACTIONS(3057),
    [anon_sym_RBRACE] = ACTIONS(3197),
    [anon_sym_from] = ACTIONS(3049),
    [anon_sym_let] = ACTIONS(3049),
    [anon_sym_LPAREN] = ACTIONS(3061),
    [anon_sym_of] = ACTIONS(3049),
    [anon_sym_SEMI] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3065),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_async] = ACTIONS(3067),
    [anon_sym_new] = ACTIONS(3069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(219),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_LT] = ACTIONS(3073),
    [aux_sym_comment_token1] = ACTIONS(15),
    [sym_number] = ACTIONS(3075),
    [sym_private_property_identifier] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(3077),
    [anon_sym_readonly] = ACTIONS(3079),
    [anon_sym_get] = ACTIONS(3081),
    [anon_sym_set] = ACTIONS(3081),
    [anon_sym_declare] = ACTIONS(3049),
    [anon_sym_public] = ACTIONS(3083),
    [anon_sym_private] = ACTIONS(3083),
    [anon_sym_protected] = ACTIONS(3083),
    [anon_sym_override] = ACTIONS(3085),
    [anon_sym_module] = ACTIONS(3049),
    [anon_sym_any] = ACTIONS(3049),
    [anon_sym_number] = ACTIONS(3049),
    [anon_sym_boolean] = ACTIONS(3049),
    [anon_sym_string] = ACTIONS(3049),
    [anon_sym_symbol] = ACTIONS(3049),
    [anon_sym_object] = ACTIONS(3049),
    [anon_sym_property] = ACTIONS(3049),
    [anon_sym_signal] = ACTIONS(3049),
    [anon_sym_on] = ACTIONS(3049),
    [anon_sym_required] = ACTIONS(3049),
    [anon_sym_component] = ACTIONS(3049),
    [anon_sym_abstract] = ACTIONS(3087),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3089),
    [sym_html_comment] = ACTIONS(5),
  },
  [957] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(957),
    [sym_formal_parameters] = STATE(6257),
    [sym_rest_pattern] = STATE(5609),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4084),
    [sym_tuple_parameter] = STATE(5584),
    [sym_optional_tuple_parameter] = STATE(5584),
    [sym_optional_type] = STATE(5584),
    [sym_rest_type] = STATE(5584),
    [sym__tuple_type_member] = STATE(5022),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3187),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_COMMA] = ACTIONS(3199),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_RBRACK] = ACTIONS(3201),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [958] = {
    [sym_comment] = STATE(958),
    [sym_identifier] = ACTIONS(1906),
    [anon_sym_export] = ACTIONS(1906),
    [anon_sym_STAR] = ACTIONS(1908),
    [anon_sym_default] = ACTIONS(1906),
    [anon_sym_type] = ACTIONS(1906),
    [anon_sym_as] = ACTIONS(1908),
    [anon_sym_namespace] = ACTIONS(1906),
    [anon_sym_COMMA] = ACTIONS(1912),
    [anon_sym_RBRACE] = ACTIONS(1910),
    [anon_sym_from] = ACTIONS(1906),
    [anon_sym_var] = ACTIONS(1906),
    [anon_sym_let] = ACTIONS(1906),
    [anon_sym_BANG] = ACTIONS(1908),
    [anon_sym_else] = ACTIONS(1906),
    [anon_sym_LPAREN] = ACTIONS(1912),
    [anon_sym_in] = ACTIONS(1908),
    [anon_sym_of] = ACTIONS(1906),
    [anon_sym_SEMI] = ACTIONS(1912),
    [anon_sym_LBRACK] = ACTIONS(1912),
    [anon_sym_GT] = ACTIONS(1908),
    [anon_sym_DOT] = ACTIONS(1912),
    [anon_sym_async] = ACTIONS(1906),
    [anon_sym_function] = ACTIONS(1906),
    [anon_sym_QMARK_DOT] = ACTIONS(1912),
    [anon_sym_AMP_AMP] = ACTIONS(1912),
    [anon_sym_PIPE_PIPE] = ACTIONS(1912),
    [anon_sym_GT_GT] = ACTIONS(1908),
    [anon_sym_GT_GT_GT] = ACTIONS(1912),
    [anon_sym_LT_LT] = ACTIONS(1912),
    [anon_sym_AMP] = ACTIONS(1908),
    [anon_sym_CARET] = ACTIONS(1912),
    [anon_sym_PIPE] = ACTIONS(1908),
    [anon_sym_PLUS] = ACTIONS(1908),
    [anon_sym_DASH] = ACTIONS(1908),
    [anon_sym_SLASH] = ACTIONS(1908),
    [anon_sym_PERCENT] = ACTIONS(1912),
    [anon_sym_STAR_STAR] = ACTIONS(1912),
    [anon_sym_LT] = ACTIONS(1908),
    [anon_sym_LT_EQ] = ACTIONS(1912),
    [anon_sym_EQ_EQ] = ACTIONS(1908),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1912),
    [anon_sym_BANG_EQ] = ACTIONS(1908),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1912),
    [anon_sym_GT_EQ] = ACTIONS(1912),
    [anon_sym_QMARK_QMARK] = ACTIONS(1912),
    [anon_sym_instanceof] = ACTIONS(1908),
    [anon_sym_PLUS_PLUS] = ACTIONS(1912),
    [anon_sym_DASH_DASH] = ACTIONS(1912),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1912),
    [anon_sym_AT] = ACTIONS(1910),
    [anon_sym_static] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1906),
    [anon_sym_get] = ACTIONS(1906),
    [anon_sym_set] = ACTIONS(1906),
    [anon_sym_declare] = ACTIONS(1906),
    [anon_sym_public] = ACTIONS(1906),
    [anon_sym_private] = ACTIONS(1906),
    [anon_sym_protected] = ACTIONS(1906),
    [anon_sym_override] = ACTIONS(1906),
    [anon_sym_module] = ACTIONS(1906),
    [anon_sym_any] = ACTIONS(1906),
    [anon_sym_number] = ACTIONS(1906),
    [anon_sym_boolean] = ACTIONS(1906),
    [anon_sym_string] = ACTIONS(1906),
    [anon_sym_symbol] = ACTIONS(1906),
    [anon_sym_object] = ACTIONS(1906),
    [anon_sym_property] = ACTIONS(1906),
    [anon_sym_signal] = ACTIONS(1906),
    [anon_sym_on] = ACTIONS(1906),
    [anon_sym_required] = ACTIONS(1906),
    [anon_sym_component] = ACTIONS(1906),
    [anon_sym_satisfies] = ACTIONS(1908),
    [anon_sym_enum] = ACTIONS(1906),
    [sym__automatic_semicolon] = ACTIONS(3203),
    [sym__ternary_qmark] = ACTIONS(1912),
    [sym_html_comment] = ACTIONS(5),
  },
  [959] = {
    [sym_comment] = STATE(959),
    [sym_identifier] = ACTIONS(1862),
    [anon_sym_export] = ACTIONS(1862),
    [anon_sym_STAR] = ACTIONS(1864),
    [anon_sym_default] = ACTIONS(1862),
    [anon_sym_type] = ACTIONS(1862),
    [anon_sym_as] = ACTIONS(1864),
    [anon_sym_namespace] = ACTIONS(1862),
    [anon_sym_COMMA] = ACTIONS(1868),
    [anon_sym_RBRACE] = ACTIONS(1866),
    [anon_sym_from] = ACTIONS(1862),
    [anon_sym_var] = ACTIONS(1862),
    [anon_sym_let] = ACTIONS(1862),
    [anon_sym_BANG] = ACTIONS(1864),
    [anon_sym_else] = ACTIONS(1862),
    [anon_sym_LPAREN] = ACTIONS(1868),
    [anon_sym_in] = ACTIONS(1864),
    [anon_sym_of] = ACTIONS(1862),
    [anon_sym_SEMI] = ACTIONS(1868),
    [anon_sym_LBRACK] = ACTIONS(1868),
    [anon_sym_GT] = ACTIONS(1864),
    [anon_sym_DOT] = ACTIONS(1868),
    [anon_sym_async] = ACTIONS(1862),
    [anon_sym_function] = ACTIONS(1862),
    [anon_sym_QMARK_DOT] = ACTIONS(1868),
    [anon_sym_AMP_AMP] = ACTIONS(1868),
    [anon_sym_PIPE_PIPE] = ACTIONS(1868),
    [anon_sym_GT_GT] = ACTIONS(1864),
    [anon_sym_GT_GT_GT] = ACTIONS(1868),
    [anon_sym_LT_LT] = ACTIONS(1868),
    [anon_sym_AMP] = ACTIONS(1864),
    [anon_sym_CARET] = ACTIONS(1868),
    [anon_sym_PIPE] = ACTIONS(1864),
    [anon_sym_PLUS] = ACTIONS(1864),
    [anon_sym_DASH] = ACTIONS(1864),
    [anon_sym_SLASH] = ACTIONS(1864),
    [anon_sym_PERCENT] = ACTIONS(1868),
    [anon_sym_STAR_STAR] = ACTIONS(1868),
    [anon_sym_LT] = ACTIONS(1864),
    [anon_sym_LT_EQ] = ACTIONS(1868),
    [anon_sym_EQ_EQ] = ACTIONS(1864),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1868),
    [anon_sym_BANG_EQ] = ACTIONS(1864),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1868),
    [anon_sym_GT_EQ] = ACTIONS(1868),
    [anon_sym_QMARK_QMARK] = ACTIONS(1868),
    [anon_sym_instanceof] = ACTIONS(1864),
    [anon_sym_PLUS_PLUS] = ACTIONS(1868),
    [anon_sym_DASH_DASH] = ACTIONS(1868),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1868),
    [anon_sym_AT] = ACTIONS(1866),
    [anon_sym_static] = ACTIONS(1862),
    [anon_sym_readonly] = ACTIONS(1862),
    [anon_sym_get] = ACTIONS(1862),
    [anon_sym_set] = ACTIONS(1862),
    [anon_sym_declare] = ACTIONS(1862),
    [anon_sym_public] = ACTIONS(1862),
    [anon_sym_private] = ACTIONS(1862),
    [anon_sym_protected] = ACTIONS(1862),
    [anon_sym_override] = ACTIONS(1862),
    [anon_sym_module] = ACTIONS(1862),
    [anon_sym_any] = ACTIONS(1862),
    [anon_sym_number] = ACTIONS(1862),
    [anon_sym_boolean] = ACTIONS(1862),
    [anon_sym_string] = ACTIONS(1862),
    [anon_sym_symbol] = ACTIONS(1862),
    [anon_sym_object] = ACTIONS(1862),
    [anon_sym_property] = ACTIONS(1862),
    [anon_sym_signal] = ACTIONS(1862),
    [anon_sym_on] = ACTIONS(1862),
    [anon_sym_required] = ACTIONS(1862),
    [anon_sym_component] = ACTIONS(1862),
    [anon_sym_satisfies] = ACTIONS(1864),
    [anon_sym_enum] = ACTIONS(1862),
    [sym__automatic_semicolon] = ACTIONS(3205),
    [sym__ternary_qmark] = ACTIONS(1868),
    [sym_html_comment] = ACTIONS(5),
  },
  [960] = {
    [sym_export_statement] = STATE(4075),
    [sym_object_pattern] = STATE(3599),
    [sym_object_assignment_pattern] = STATE(5126),
    [sym_array_pattern] = STATE(3599),
    [sym__call_signature] = STATE(4331),
    [sym__destructuring_pattern] = STATE(6297),
    [sym_spread_element] = STATE(5056),
    [sym_string] = STATE(3505),
    [sym_comment] = STATE(960),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(3540),
    [sym_rest_pattern] = STATE(5126),
    [sym_method_definition] = STATE(5056),
    [sym_pair] = STATE(5056),
    [sym_pair_pattern] = STATE(5126),
    [sym__property_name] = STATE(3352),
    [sym_computed_property_name] = STATE(3505),
    [sym_method_signature] = STATE(4075),
    [sym_accessibility_modifier] = STATE(2736),
    [sym_override_modifier] = STATE(2775),
    [sym_call_signature] = STATE(4075),
    [sym_property_signature] = STATE(4075),
    [sym_type_parameters] = STATE(5867),
    [sym_construct_signature] = STATE(4075),
    [sym_index_signature] = STATE(4075),
    [aux_sym_export_statement_repeat1] = STATE(4766),
    [aux_sym_object_repeat1] = STATE(5050),
    [aux_sym_object_pattern_repeat1] = STATE(4996),
    [sym_identifier] = ACTIONS(3207),
    [anon_sym_export] = ACTIONS(3209),
    [anon_sym_STAR] = ACTIONS(3053),
    [anon_sym_type] = ACTIONS(3207),
    [anon_sym_namespace] = ACTIONS(3207),
    [anon_sym_LBRACE] = ACTIONS(3055),
    [anon_sym_COMMA] = ACTIONS(3057),
    [anon_sym_RBRACE] = ACTIONS(3211),
    [anon_sym_from] = ACTIONS(3207),
    [anon_sym_let] = ACTIONS(3207),
    [anon_sym_LPAREN] = ACTIONS(3061),
    [anon_sym_of] = ACTIONS(3207),
    [anon_sym_SEMI] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3065),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_async] = ACTIONS(3213),
    [anon_sym_new] = ACTIONS(3215),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(219),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_LT] = ACTIONS(3073),
    [aux_sym_comment_token1] = ACTIONS(15),
    [sym_number] = ACTIONS(3075),
    [sym_private_property_identifier] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(3217),
    [anon_sym_readonly] = ACTIONS(3219),
    [anon_sym_get] = ACTIONS(3221),
    [anon_sym_set] = ACTIONS(3221),
    [anon_sym_declare] = ACTIONS(3207),
    [anon_sym_public] = ACTIONS(3223),
    [anon_sym_private] = ACTIONS(3223),
    [anon_sym_protected] = ACTIONS(3223),
    [anon_sym_override] = ACTIONS(3225),
    [anon_sym_module] = ACTIONS(3207),
    [anon_sym_any] = ACTIONS(3207),
    [anon_sym_number] = ACTIONS(3207),
    [anon_sym_boolean] = ACTIONS(3207),
    [anon_sym_string] = ACTIONS(3207),
    [anon_sym_symbol] = ACTIONS(3207),
    [anon_sym_object] = ACTIONS(3207),
    [anon_sym_property] = ACTIONS(3207),
    [anon_sym_signal] = ACTIONS(3207),
    [anon_sym_on] = ACTIONS(3207),
    [anon_sym_required] = ACTIONS(3207),
    [anon_sym_component] = ACTIONS(3207),
    [anon_sym_abstract] = ACTIONS(3087),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3089),
    [sym_html_comment] = ACTIONS(5),
  },
  [961] = {
    [sym_comment] = STATE(961),
    [sym_identifier] = ACTIONS(1958),
    [anon_sym_export] = ACTIONS(1958),
    [anon_sym_STAR] = ACTIONS(1960),
    [anon_sym_default] = ACTIONS(1958),
    [anon_sym_type] = ACTIONS(1958),
    [anon_sym_as] = ACTIONS(1960),
    [anon_sym_namespace] = ACTIONS(1958),
    [anon_sym_COMMA] = ACTIONS(1964),
    [anon_sym_RBRACE] = ACTIONS(1962),
    [anon_sym_from] = ACTIONS(1958),
    [anon_sym_var] = ACTIONS(1958),
    [anon_sym_let] = ACTIONS(1958),
    [anon_sym_BANG] = ACTIONS(1960),
    [anon_sym_else] = ACTIONS(1958),
    [anon_sym_LPAREN] = ACTIONS(1964),
    [anon_sym_in] = ACTIONS(1960),
    [anon_sym_of] = ACTIONS(1958),
    [anon_sym_SEMI] = ACTIONS(1964),
    [anon_sym_LBRACK] = ACTIONS(1964),
    [anon_sym_GT] = ACTIONS(1960),
    [anon_sym_DOT] = ACTIONS(1964),
    [anon_sym_async] = ACTIONS(1958),
    [anon_sym_function] = ACTIONS(1958),
    [anon_sym_QMARK_DOT] = ACTIONS(1964),
    [anon_sym_AMP_AMP] = ACTIONS(1964),
    [anon_sym_PIPE_PIPE] = ACTIONS(1964),
    [anon_sym_GT_GT] = ACTIONS(1960),
    [anon_sym_GT_GT_GT] = ACTIONS(1964),
    [anon_sym_LT_LT] = ACTIONS(1964),
    [anon_sym_AMP] = ACTIONS(1960),
    [anon_sym_CARET] = ACTIONS(1964),
    [anon_sym_PIPE] = ACTIONS(1960),
    [anon_sym_PLUS] = ACTIONS(1960),
    [anon_sym_DASH] = ACTIONS(1960),
    [anon_sym_SLASH] = ACTIONS(1960),
    [anon_sym_PERCENT] = ACTIONS(1964),
    [anon_sym_STAR_STAR] = ACTIONS(1964),
    [anon_sym_LT] = ACTIONS(1960),
    [anon_sym_LT_EQ] = ACTIONS(1964),
    [anon_sym_EQ_EQ] = ACTIONS(1960),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1964),
    [anon_sym_BANG_EQ] = ACTIONS(1960),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1964),
    [anon_sym_GT_EQ] = ACTIONS(1964),
    [anon_sym_QMARK_QMARK] = ACTIONS(1964),
    [anon_sym_instanceof] = ACTIONS(1960),
    [anon_sym_PLUS_PLUS] = ACTIONS(1964),
    [anon_sym_DASH_DASH] = ACTIONS(1964),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1964),
    [anon_sym_AT] = ACTIONS(1962),
    [anon_sym_static] = ACTIONS(1958),
    [anon_sym_readonly] = ACTIONS(1958),
    [anon_sym_get] = ACTIONS(1958),
    [anon_sym_set] = ACTIONS(1958),
    [anon_sym_declare] = ACTIONS(1958),
    [anon_sym_public] = ACTIONS(1958),
    [anon_sym_private] = ACTIONS(1958),
    [anon_sym_protected] = ACTIONS(1958),
    [anon_sym_override] = ACTIONS(1958),
    [anon_sym_module] = ACTIONS(1958),
    [anon_sym_any] = ACTIONS(1958),
    [anon_sym_number] = ACTIONS(1958),
    [anon_sym_boolean] = ACTIONS(1958),
    [anon_sym_string] = ACTIONS(1958),
    [anon_sym_symbol] = ACTIONS(1958),
    [anon_sym_object] = ACTIONS(1958),
    [anon_sym_property] = ACTIONS(1958),
    [anon_sym_signal] = ACTIONS(1958),
    [anon_sym_on] = ACTIONS(1958),
    [anon_sym_required] = ACTIONS(1958),
    [anon_sym_component] = ACTIONS(1958),
    [anon_sym_satisfies] = ACTIONS(1960),
    [anon_sym_enum] = ACTIONS(1958),
    [sym__automatic_semicolon] = ACTIONS(3227),
    [sym__ternary_qmark] = ACTIONS(1964),
    [sym_html_comment] = ACTIONS(5),
  },
  [962] = {
    [sym_export_statement] = STATE(4075),
    [sym_object_pattern] = STATE(3599),
    [sym_object_assignment_pattern] = STATE(5126),
    [sym_array_pattern] = STATE(3599),
    [sym__call_signature] = STATE(4331),
    [sym__destructuring_pattern] = STATE(6297),
    [sym_spread_element] = STATE(5056),
    [sym_string] = STATE(3505),
    [sym_comment] = STATE(962),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(3540),
    [sym_rest_pattern] = STATE(5126),
    [sym_method_definition] = STATE(5056),
    [sym_pair] = STATE(5056),
    [sym_pair_pattern] = STATE(5126),
    [sym__property_name] = STATE(3352),
    [sym_computed_property_name] = STATE(3505),
    [sym_method_signature] = STATE(4075),
    [sym_accessibility_modifier] = STATE(2736),
    [sym_override_modifier] = STATE(2775),
    [sym_call_signature] = STATE(4075),
    [sym_property_signature] = STATE(4075),
    [sym_type_parameters] = STATE(5867),
    [sym_construct_signature] = STATE(4075),
    [sym_index_signature] = STATE(4075),
    [aux_sym_export_statement_repeat1] = STATE(4766),
    [aux_sym_object_repeat1] = STATE(5050),
    [aux_sym_object_pattern_repeat1] = STATE(4996),
    [sym_identifier] = ACTIONS(3095),
    [anon_sym_export] = ACTIONS(3097),
    [anon_sym_STAR] = ACTIONS(3053),
    [anon_sym_type] = ACTIONS(3095),
    [anon_sym_namespace] = ACTIONS(3095),
    [anon_sym_LBRACE] = ACTIONS(3055),
    [anon_sym_COMMA] = ACTIONS(3057),
    [anon_sym_RBRACE] = ACTIONS(3211),
    [anon_sym_from] = ACTIONS(3095),
    [anon_sym_let] = ACTIONS(3095),
    [anon_sym_LPAREN] = ACTIONS(3061),
    [anon_sym_of] = ACTIONS(3095),
    [anon_sym_SEMI] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3065),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_async] = ACTIONS(3101),
    [anon_sym_new] = ACTIONS(3103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(219),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_LT] = ACTIONS(3073),
    [aux_sym_comment_token1] = ACTIONS(15),
    [sym_number] = ACTIONS(3075),
    [sym_private_property_identifier] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(3105),
    [anon_sym_readonly] = ACTIONS(3107),
    [anon_sym_get] = ACTIONS(3109),
    [anon_sym_set] = ACTIONS(3109),
    [anon_sym_declare] = ACTIONS(3095),
    [anon_sym_public] = ACTIONS(3111),
    [anon_sym_private] = ACTIONS(3111),
    [anon_sym_protected] = ACTIONS(3111),
    [anon_sym_override] = ACTIONS(3113),
    [anon_sym_module] = ACTIONS(3095),
    [anon_sym_any] = ACTIONS(3095),
    [anon_sym_number] = ACTIONS(3095),
    [anon_sym_boolean] = ACTIONS(3095),
    [anon_sym_string] = ACTIONS(3095),
    [anon_sym_symbol] = ACTIONS(3095),
    [anon_sym_object] = ACTIONS(3095),
    [anon_sym_property] = ACTIONS(3095),
    [anon_sym_signal] = ACTIONS(3095),
    [anon_sym_on] = ACTIONS(3095),
    [anon_sym_required] = ACTIONS(3095),
    [anon_sym_component] = ACTIONS(3095),
    [anon_sym_abstract] = ACTIONS(3087),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3089),
    [sym_html_comment] = ACTIONS(5),
  },
  [963] = {
    [sym_comment] = STATE(963),
    [sym_identifier] = ACTIONS(1792),
    [anon_sym_export] = ACTIONS(1792),
    [anon_sym_STAR] = ACTIONS(1792),
    [anon_sym_default] = ACTIONS(1792),
    [anon_sym_type] = ACTIONS(1792),
    [anon_sym_as] = ACTIONS(1792),
    [anon_sym_namespace] = ACTIONS(1792),
    [anon_sym_COMMA] = ACTIONS(1798),
    [anon_sym_RBRACE] = ACTIONS(1798),
    [anon_sym_from] = ACTIONS(1792),
    [anon_sym_var] = ACTIONS(1792),
    [anon_sym_let] = ACTIONS(1792),
    [anon_sym_BANG] = ACTIONS(1792),
    [anon_sym_else] = ACTIONS(1792),
    [anon_sym_LPAREN] = ACTIONS(1798),
    [anon_sym_in] = ACTIONS(1792),
    [anon_sym_of] = ACTIONS(1792),
    [anon_sym_SEMI] = ACTIONS(1798),
    [anon_sym_LBRACK] = ACTIONS(1798),
    [anon_sym_GT] = ACTIONS(1792),
    [anon_sym_DOT] = ACTIONS(1798),
    [anon_sym_async] = ACTIONS(1792),
    [anon_sym_function] = ACTIONS(1792),
    [anon_sym_QMARK_DOT] = ACTIONS(1798),
    [anon_sym_AMP_AMP] = ACTIONS(1798),
    [anon_sym_PIPE_PIPE] = ACTIONS(1798),
    [anon_sym_GT_GT] = ACTIONS(1792),
    [anon_sym_GT_GT_GT] = ACTIONS(1798),
    [anon_sym_LT_LT] = ACTIONS(1798),
    [anon_sym_AMP] = ACTIONS(1792),
    [anon_sym_CARET] = ACTIONS(1798),
    [anon_sym_PIPE] = ACTIONS(1792),
    [anon_sym_PLUS] = ACTIONS(1792),
    [anon_sym_DASH] = ACTIONS(1792),
    [anon_sym_SLASH] = ACTIONS(1792),
    [anon_sym_PERCENT] = ACTIONS(1798),
    [anon_sym_STAR_STAR] = ACTIONS(1798),
    [anon_sym_LT] = ACTIONS(1792),
    [anon_sym_LT_EQ] = ACTIONS(1798),
    [anon_sym_EQ_EQ] = ACTIONS(1792),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1798),
    [anon_sym_BANG_EQ] = ACTIONS(1792),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1798),
    [anon_sym_GT_EQ] = ACTIONS(1798),
    [anon_sym_QMARK_QMARK] = ACTIONS(1798),
    [anon_sym_instanceof] = ACTIONS(1792),
    [anon_sym_PLUS_PLUS] = ACTIONS(1798),
    [anon_sym_DASH_DASH] = ACTIONS(1798),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1798),
    [anon_sym_AT] = ACTIONS(1798),
    [anon_sym_static] = ACTIONS(1792),
    [anon_sym_readonly] = ACTIONS(1792),
    [anon_sym_get] = ACTIONS(1792),
    [anon_sym_set] = ACTIONS(1792),
    [anon_sym_declare] = ACTIONS(1792),
    [anon_sym_public] = ACTIONS(1792),
    [anon_sym_private] = ACTIONS(1792),
    [anon_sym_protected] = ACTIONS(1792),
    [anon_sym_override] = ACTIONS(1792),
    [anon_sym_module] = ACTIONS(1792),
    [anon_sym_any] = ACTIONS(1792),
    [anon_sym_number] = ACTIONS(1792),
    [anon_sym_boolean] = ACTIONS(1792),
    [anon_sym_string] = ACTIONS(1792),
    [anon_sym_symbol] = ACTIONS(1792),
    [anon_sym_object] = ACTIONS(1792),
    [anon_sym_property] = ACTIONS(1792),
    [anon_sym_signal] = ACTIONS(1792),
    [anon_sym_on] = ACTIONS(1792),
    [anon_sym_required] = ACTIONS(1792),
    [anon_sym_component] = ACTIONS(1792),
    [anon_sym_satisfies] = ACTIONS(1792),
    [anon_sym_enum] = ACTIONS(1792),
    [sym__automatic_semicolon] = ACTIONS(3229),
    [sym__ternary_qmark] = ACTIONS(1798),
    [sym_html_comment] = ACTIONS(5),
  },
  [964] = {
    [sym_export_statement] = STATE(4075),
    [sym_object_pattern] = STATE(3599),
    [sym_object_assignment_pattern] = STATE(5126),
    [sym_array_pattern] = STATE(3599),
    [sym__call_signature] = STATE(4331),
    [sym__destructuring_pattern] = STATE(6297),
    [sym_spread_element] = STATE(5056),
    [sym_string] = STATE(3505),
    [sym_comment] = STATE(964),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(3540),
    [sym_rest_pattern] = STATE(5126),
    [sym_method_definition] = STATE(5056),
    [sym_pair] = STATE(5056),
    [sym_pair_pattern] = STATE(5126),
    [sym__property_name] = STATE(3352),
    [sym_computed_property_name] = STATE(3505),
    [sym_method_signature] = STATE(4075),
    [sym_accessibility_modifier] = STATE(2736),
    [sym_override_modifier] = STATE(2775),
    [sym_call_signature] = STATE(4075),
    [sym_property_signature] = STATE(4075),
    [sym_type_parameters] = STATE(5867),
    [sym_construct_signature] = STATE(4075),
    [sym_index_signature] = STATE(4075),
    [aux_sym_export_statement_repeat1] = STATE(4766),
    [aux_sym_object_repeat1] = STATE(5050),
    [aux_sym_object_pattern_repeat1] = STATE(4996),
    [sym_identifier] = ACTIONS(3231),
    [anon_sym_export] = ACTIONS(3233),
    [anon_sym_STAR] = ACTIONS(3053),
    [anon_sym_type] = ACTIONS(3231),
    [anon_sym_namespace] = ACTIONS(3231),
    [anon_sym_LBRACE] = ACTIONS(3055),
    [anon_sym_COMMA] = ACTIONS(3057),
    [anon_sym_RBRACE] = ACTIONS(3059),
    [anon_sym_from] = ACTIONS(3231),
    [anon_sym_let] = ACTIONS(3231),
    [anon_sym_LPAREN] = ACTIONS(3061),
    [anon_sym_of] = ACTIONS(3231),
    [anon_sym_SEMI] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3065),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_async] = ACTIONS(3235),
    [anon_sym_new] = ACTIONS(3237),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(219),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_LT] = ACTIONS(3073),
    [aux_sym_comment_token1] = ACTIONS(15),
    [sym_number] = ACTIONS(3075),
    [sym_private_property_identifier] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(3239),
    [anon_sym_readonly] = ACTIONS(3241),
    [anon_sym_get] = ACTIONS(3243),
    [anon_sym_set] = ACTIONS(3243),
    [anon_sym_declare] = ACTIONS(3231),
    [anon_sym_public] = ACTIONS(3245),
    [anon_sym_private] = ACTIONS(3245),
    [anon_sym_protected] = ACTIONS(3245),
    [anon_sym_override] = ACTIONS(3247),
    [anon_sym_module] = ACTIONS(3231),
    [anon_sym_any] = ACTIONS(3231),
    [anon_sym_number] = ACTIONS(3231),
    [anon_sym_boolean] = ACTIONS(3231),
    [anon_sym_string] = ACTIONS(3231),
    [anon_sym_symbol] = ACTIONS(3231),
    [anon_sym_object] = ACTIONS(3231),
    [anon_sym_property] = ACTIONS(3231),
    [anon_sym_signal] = ACTIONS(3231),
    [anon_sym_on] = ACTIONS(3231),
    [anon_sym_required] = ACTIONS(3231),
    [anon_sym_component] = ACTIONS(3231),
    [anon_sym_abstract] = ACTIONS(3087),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3089),
    [sym_html_comment] = ACTIONS(5),
  },
  [965] = {
    [sym_comment] = STATE(965),
    [sym_identifier] = ACTIONS(1926),
    [anon_sym_export] = ACTIONS(1926),
    [anon_sym_STAR] = ACTIONS(1926),
    [anon_sym_default] = ACTIONS(1926),
    [anon_sym_type] = ACTIONS(1926),
    [anon_sym_as] = ACTIONS(1926),
    [anon_sym_namespace] = ACTIONS(1926),
    [anon_sym_COMMA] = ACTIONS(1928),
    [anon_sym_RBRACE] = ACTIONS(1928),
    [anon_sym_from] = ACTIONS(1926),
    [anon_sym_var] = ACTIONS(1926),
    [anon_sym_let] = ACTIONS(1926),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_else] = ACTIONS(1926),
    [anon_sym_LPAREN] = ACTIONS(1928),
    [anon_sym_in] = ACTIONS(1926),
    [anon_sym_of] = ACTIONS(1926),
    [anon_sym_SEMI] = ACTIONS(1928),
    [anon_sym_LBRACK] = ACTIONS(1928),
    [anon_sym_GT] = ACTIONS(1926),
    [anon_sym_DOT] = ACTIONS(1928),
    [anon_sym_async] = ACTIONS(1926),
    [anon_sym_function] = ACTIONS(1926),
    [anon_sym_QMARK_DOT] = ACTIONS(1928),
    [anon_sym_AMP_AMP] = ACTIONS(1928),
    [anon_sym_PIPE_PIPE] = ACTIONS(1928),
    [anon_sym_GT_GT] = ACTIONS(1926),
    [anon_sym_GT_GT_GT] = ACTIONS(1928),
    [anon_sym_LT_LT] = ACTIONS(1928),
    [anon_sym_AMP] = ACTIONS(1926),
    [anon_sym_CARET] = ACTIONS(1928),
    [anon_sym_PIPE] = ACTIONS(1926),
    [anon_sym_PLUS] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1926),
    [anon_sym_SLASH] = ACTIONS(1926),
    [anon_sym_PERCENT] = ACTIONS(1928),
    [anon_sym_STAR_STAR] = ACTIONS(1928),
    [anon_sym_LT] = ACTIONS(1926),
    [anon_sym_LT_EQ] = ACTIONS(1928),
    [anon_sym_EQ_EQ] = ACTIONS(1926),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1928),
    [anon_sym_BANG_EQ] = ACTIONS(1926),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1928),
    [anon_sym_GT_EQ] = ACTIONS(1928),
    [anon_sym_QMARK_QMARK] = ACTIONS(1928),
    [anon_sym_instanceof] = ACTIONS(1926),
    [anon_sym_PLUS_PLUS] = ACTIONS(1928),
    [anon_sym_DASH_DASH] = ACTIONS(1928),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1928),
    [anon_sym_AT] = ACTIONS(1928),
    [anon_sym_static] = ACTIONS(1926),
    [anon_sym_readonly] = ACTIONS(1926),
    [anon_sym_get] = ACTIONS(1926),
    [anon_sym_set] = ACTIONS(1926),
    [anon_sym_declare] = ACTIONS(1926),
    [anon_sym_public] = ACTIONS(1926),
    [anon_sym_private] = ACTIONS(1926),
    [anon_sym_protected] = ACTIONS(1926),
    [anon_sym_override] = ACTIONS(1926),
    [anon_sym_module] = ACTIONS(1926),
    [anon_sym_any] = ACTIONS(1926),
    [anon_sym_number] = ACTIONS(1926),
    [anon_sym_boolean] = ACTIONS(1926),
    [anon_sym_string] = ACTIONS(1926),
    [anon_sym_symbol] = ACTIONS(1926),
    [anon_sym_object] = ACTIONS(1926),
    [anon_sym_property] = ACTIONS(1926),
    [anon_sym_signal] = ACTIONS(1926),
    [anon_sym_on] = ACTIONS(1926),
    [anon_sym_required] = ACTIONS(1926),
    [anon_sym_component] = ACTIONS(1926),
    [anon_sym_satisfies] = ACTIONS(1926),
    [anon_sym_enum] = ACTIONS(1926),
    [sym__automatic_semicolon] = ACTIONS(1928),
    [sym__ternary_qmark] = ACTIONS(1928),
    [sym_html_comment] = ACTIONS(5),
  },
  [966] = {
    [sym_comment] = STATE(966),
    [sym_identifier] = ACTIONS(1982),
    [anon_sym_export] = ACTIONS(1982),
    [anon_sym_STAR] = ACTIONS(1984),
    [anon_sym_default] = ACTIONS(1982),
    [anon_sym_type] = ACTIONS(1982),
    [anon_sym_as] = ACTIONS(1984),
    [anon_sym_namespace] = ACTIONS(1982),
    [anon_sym_COMMA] = ACTIONS(1988),
    [anon_sym_RBRACE] = ACTIONS(1986),
    [anon_sym_from] = ACTIONS(1982),
    [anon_sym_var] = ACTIONS(1982),
    [anon_sym_let] = ACTIONS(1982),
    [anon_sym_BANG] = ACTIONS(1984),
    [anon_sym_else] = ACTIONS(1982),
    [anon_sym_LPAREN] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_of] = ACTIONS(1982),
    [anon_sym_SEMI] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(1988),
    [anon_sym_async] = ACTIONS(1982),
    [anon_sym_function] = ACTIONS(1982),
    [anon_sym_QMARK_DOT] = ACTIONS(1988),
    [anon_sym_AMP_AMP] = ACTIONS(1988),
    [anon_sym_PIPE_PIPE] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_GT_GT_GT] = ACTIONS(1988),
    [anon_sym_LT_LT] = ACTIONS(1988),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1988),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(1984),
    [anon_sym_PERCENT] = ACTIONS(1988),
    [anon_sym_STAR_STAR] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1984),
    [anon_sym_LT_EQ] = ACTIONS(1988),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1988),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1988),
    [anon_sym_GT_EQ] = ACTIONS(1988),
    [anon_sym_QMARK_QMARK] = ACTIONS(1988),
    [anon_sym_instanceof] = ACTIONS(1984),
    [anon_sym_PLUS_PLUS] = ACTIONS(1988),
    [anon_sym_DASH_DASH] = ACTIONS(1988),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1988),
    [anon_sym_AT] = ACTIONS(1986),
    [anon_sym_static] = ACTIONS(1982),
    [anon_sym_readonly] = ACTIONS(1982),
    [anon_sym_get] = ACTIONS(1982),
    [anon_sym_set] = ACTIONS(1982),
    [anon_sym_declare] = ACTIONS(1982),
    [anon_sym_public] = ACTIONS(1982),
    [anon_sym_private] = ACTIONS(1982),
    [anon_sym_protected] = ACTIONS(1982),
    [anon_sym_override] = ACTIONS(1982),
    [anon_sym_module] = ACTIONS(1982),
    [anon_sym_any] = ACTIONS(1982),
    [anon_sym_number] = ACTIONS(1982),
    [anon_sym_boolean] = ACTIONS(1982),
    [anon_sym_string] = ACTIONS(1982),
    [anon_sym_symbol] = ACTIONS(1982),
    [anon_sym_object] = ACTIONS(1982),
    [anon_sym_property] = ACTIONS(1982),
    [anon_sym_signal] = ACTIONS(1982),
    [anon_sym_on] = ACTIONS(1982),
    [anon_sym_required] = ACTIONS(1982),
    [anon_sym_component] = ACTIONS(1982),
    [anon_sym_satisfies] = ACTIONS(1984),
    [anon_sym_enum] = ACTIONS(1982),
    [sym__automatic_semicolon] = ACTIONS(3249),
    [sym__ternary_qmark] = ACTIONS(1988),
    [sym_html_comment] = ACTIONS(5),
  },
  [967] = {
    [sym_export_statement] = STATE(4075),
    [sym_object_pattern] = STATE(3599),
    [sym_object_assignment_pattern] = STATE(5126),
    [sym_array_pattern] = STATE(3599),
    [sym__call_signature] = STATE(4331),
    [sym__destructuring_pattern] = STATE(6297),
    [sym_spread_element] = STATE(5056),
    [sym_string] = STATE(3505),
    [sym_comment] = STATE(967),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(3540),
    [sym_rest_pattern] = STATE(5126),
    [sym_method_definition] = STATE(5056),
    [sym_pair] = STATE(5056),
    [sym_pair_pattern] = STATE(5126),
    [sym__property_name] = STATE(3352),
    [sym_computed_property_name] = STATE(3505),
    [sym_method_signature] = STATE(4075),
    [sym_accessibility_modifier] = STATE(2736),
    [sym_override_modifier] = STATE(2775),
    [sym_call_signature] = STATE(4075),
    [sym_property_signature] = STATE(4075),
    [sym_type_parameters] = STATE(5867),
    [sym_construct_signature] = STATE(4075),
    [sym_index_signature] = STATE(4075),
    [aux_sym_export_statement_repeat1] = STATE(4766),
    [aux_sym_object_repeat1] = STATE(5050),
    [aux_sym_object_pattern_repeat1] = STATE(4996),
    [sym_identifier] = ACTIONS(3207),
    [anon_sym_export] = ACTIONS(3209),
    [anon_sym_STAR] = ACTIONS(3053),
    [anon_sym_type] = ACTIONS(3207),
    [anon_sym_namespace] = ACTIONS(3207),
    [anon_sym_LBRACE] = ACTIONS(3055),
    [anon_sym_COMMA] = ACTIONS(3057),
    [anon_sym_RBRACE] = ACTIONS(3251),
    [anon_sym_from] = ACTIONS(3207),
    [anon_sym_let] = ACTIONS(3207),
    [anon_sym_LPAREN] = ACTIONS(3061),
    [anon_sym_of] = ACTIONS(3207),
    [anon_sym_SEMI] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3065),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_async] = ACTIONS(3213),
    [anon_sym_new] = ACTIONS(3215),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(219),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_LT] = ACTIONS(3073),
    [aux_sym_comment_token1] = ACTIONS(15),
    [sym_number] = ACTIONS(3075),
    [sym_private_property_identifier] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(3217),
    [anon_sym_readonly] = ACTIONS(3219),
    [anon_sym_get] = ACTIONS(3221),
    [anon_sym_set] = ACTIONS(3221),
    [anon_sym_declare] = ACTIONS(3207),
    [anon_sym_public] = ACTIONS(3223),
    [anon_sym_private] = ACTIONS(3223),
    [anon_sym_protected] = ACTIONS(3223),
    [anon_sym_override] = ACTIONS(3225),
    [anon_sym_module] = ACTIONS(3207),
    [anon_sym_any] = ACTIONS(3207),
    [anon_sym_number] = ACTIONS(3207),
    [anon_sym_boolean] = ACTIONS(3207),
    [anon_sym_string] = ACTIONS(3207),
    [anon_sym_symbol] = ACTIONS(3207),
    [anon_sym_object] = ACTIONS(3207),
    [anon_sym_property] = ACTIONS(3207),
    [anon_sym_signal] = ACTIONS(3207),
    [anon_sym_on] = ACTIONS(3207),
    [anon_sym_required] = ACTIONS(3207),
    [anon_sym_component] = ACTIONS(3207),
    [anon_sym_abstract] = ACTIONS(3087),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3089),
    [sym_html_comment] = ACTIONS(5),
  },
  [968] = {
    [sym_export_statement] = STATE(4075),
    [sym_object_pattern] = STATE(3599),
    [sym_object_assignment_pattern] = STATE(5126),
    [sym_array_pattern] = STATE(3599),
    [sym__call_signature] = STATE(4331),
    [sym__destructuring_pattern] = STATE(6297),
    [sym_spread_element] = STATE(5056),
    [sym_string] = STATE(3505),
    [sym_comment] = STATE(968),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(3540),
    [sym_rest_pattern] = STATE(5126),
    [sym_method_definition] = STATE(5056),
    [sym_pair] = STATE(5056),
    [sym_pair_pattern] = STATE(5126),
    [sym__property_name] = STATE(3352),
    [sym_computed_property_name] = STATE(3505),
    [sym_method_signature] = STATE(4075),
    [sym_accessibility_modifier] = STATE(2736),
    [sym_override_modifier] = STATE(2775),
    [sym_call_signature] = STATE(4075),
    [sym_property_signature] = STATE(4075),
    [sym_type_parameters] = STATE(5867),
    [sym_construct_signature] = STATE(4075),
    [sym_index_signature] = STATE(4075),
    [aux_sym_export_statement_repeat1] = STATE(4766),
    [aux_sym_object_repeat1] = STATE(5050),
    [aux_sym_object_pattern_repeat1] = STATE(4996),
    [sym_identifier] = ACTIONS(3207),
    [anon_sym_export] = ACTIONS(3209),
    [anon_sym_STAR] = ACTIONS(3053),
    [anon_sym_type] = ACTIONS(3207),
    [anon_sym_namespace] = ACTIONS(3207),
    [anon_sym_LBRACE] = ACTIONS(3055),
    [anon_sym_COMMA] = ACTIONS(3057),
    [anon_sym_RBRACE] = ACTIONS(3253),
    [anon_sym_from] = ACTIONS(3207),
    [anon_sym_let] = ACTIONS(3207),
    [anon_sym_LPAREN] = ACTIONS(3061),
    [anon_sym_of] = ACTIONS(3207),
    [anon_sym_SEMI] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3065),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_async] = ACTIONS(3213),
    [anon_sym_new] = ACTIONS(3215),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(219),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_LT] = ACTIONS(3073),
    [aux_sym_comment_token1] = ACTIONS(15),
    [sym_number] = ACTIONS(3075),
    [sym_private_property_identifier] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(3217),
    [anon_sym_readonly] = ACTIONS(3219),
    [anon_sym_get] = ACTIONS(3221),
    [anon_sym_set] = ACTIONS(3221),
    [anon_sym_declare] = ACTIONS(3207),
    [anon_sym_public] = ACTIONS(3223),
    [anon_sym_private] = ACTIONS(3223),
    [anon_sym_protected] = ACTIONS(3223),
    [anon_sym_override] = ACTIONS(3225),
    [anon_sym_module] = ACTIONS(3207),
    [anon_sym_any] = ACTIONS(3207),
    [anon_sym_number] = ACTIONS(3207),
    [anon_sym_boolean] = ACTIONS(3207),
    [anon_sym_string] = ACTIONS(3207),
    [anon_sym_symbol] = ACTIONS(3207),
    [anon_sym_object] = ACTIONS(3207),
    [anon_sym_property] = ACTIONS(3207),
    [anon_sym_signal] = ACTIONS(3207),
    [anon_sym_on] = ACTIONS(3207),
    [anon_sym_required] = ACTIONS(3207),
    [anon_sym_component] = ACTIONS(3207),
    [anon_sym_abstract] = ACTIONS(3087),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3089),
    [sym_html_comment] = ACTIONS(5),
  },
  [969] = {
    [sym_export_statement] = STATE(4075),
    [sym_object_pattern] = STATE(3599),
    [sym_object_assignment_pattern] = STATE(5126),
    [sym_array_pattern] = STATE(3599),
    [sym__call_signature] = STATE(4331),
    [sym__destructuring_pattern] = STATE(6297),
    [sym_spread_element] = STATE(5367),
    [sym_string] = STATE(3505),
    [sym_comment] = STATE(969),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(3540),
    [sym_rest_pattern] = STATE(5126),
    [sym_method_definition] = STATE(5367),
    [sym_pair] = STATE(5367),
    [sym_pair_pattern] = STATE(5126),
    [sym__property_name] = STATE(3352),
    [sym_computed_property_name] = STATE(3505),
    [sym_method_signature] = STATE(4075),
    [sym_accessibility_modifier] = STATE(2736),
    [sym_override_modifier] = STATE(2775),
    [sym_call_signature] = STATE(4075),
    [sym_property_signature] = STATE(4075),
    [sym_type_parameters] = STATE(5867),
    [sym_construct_signature] = STATE(4075),
    [sym_index_signature] = STATE(4075),
    [aux_sym_export_statement_repeat1] = STATE(4766),
    [aux_sym_object_repeat1] = STATE(5362),
    [aux_sym_object_pattern_repeat1] = STATE(4996),
    [sym_identifier] = ACTIONS(3167),
    [anon_sym_export] = ACTIONS(3169),
    [anon_sym_STAR] = ACTIONS(3053),
    [anon_sym_type] = ACTIONS(3167),
    [anon_sym_namespace] = ACTIONS(3167),
    [anon_sym_LBRACE] = ACTIONS(3055),
    [anon_sym_COMMA] = ACTIONS(3057),
    [anon_sym_RBRACE] = ACTIONS(3255),
    [anon_sym_from] = ACTIONS(3167),
    [anon_sym_let] = ACTIONS(3167),
    [anon_sym_LPAREN] = ACTIONS(3061),
    [anon_sym_of] = ACTIONS(3167),
    [anon_sym_SEMI] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3065),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_async] = ACTIONS(3173),
    [anon_sym_new] = ACTIONS(3175),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(219),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_LT] = ACTIONS(3073),
    [aux_sym_comment_token1] = ACTIONS(15),
    [sym_number] = ACTIONS(3075),
    [sym_private_property_identifier] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(3177),
    [anon_sym_readonly] = ACTIONS(3179),
    [anon_sym_get] = ACTIONS(3181),
    [anon_sym_set] = ACTIONS(3181),
    [anon_sym_declare] = ACTIONS(3167),
    [anon_sym_public] = ACTIONS(3183),
    [anon_sym_private] = ACTIONS(3183),
    [anon_sym_protected] = ACTIONS(3183),
    [anon_sym_override] = ACTIONS(3185),
    [anon_sym_module] = ACTIONS(3167),
    [anon_sym_any] = ACTIONS(3167),
    [anon_sym_number] = ACTIONS(3167),
    [anon_sym_boolean] = ACTIONS(3167),
    [anon_sym_string] = ACTIONS(3167),
    [anon_sym_symbol] = ACTIONS(3167),
    [anon_sym_object] = ACTIONS(3167),
    [anon_sym_property] = ACTIONS(3167),
    [anon_sym_signal] = ACTIONS(3167),
    [anon_sym_on] = ACTIONS(3167),
    [anon_sym_required] = ACTIONS(3167),
    [anon_sym_component] = ACTIONS(3167),
    [anon_sym_abstract] = ACTIONS(3087),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3089),
    [sym_html_comment] = ACTIONS(5),
  },
  [970] = {
    [sym_comment] = STATE(970),
    [sym_identifier] = ACTIONS(1896),
    [anon_sym_export] = ACTIONS(1896),
    [anon_sym_STAR] = ACTIONS(1896),
    [anon_sym_default] = ACTIONS(1896),
    [anon_sym_type] = ACTIONS(1896),
    [anon_sym_as] = ACTIONS(1896),
    [anon_sym_namespace] = ACTIONS(1896),
    [anon_sym_COMMA] = ACTIONS(1898),
    [anon_sym_RBRACE] = ACTIONS(1898),
    [anon_sym_from] = ACTIONS(1896),
    [anon_sym_var] = ACTIONS(1896),
    [anon_sym_let] = ACTIONS(1896),
    [anon_sym_BANG] = ACTIONS(1896),
    [anon_sym_else] = ACTIONS(1896),
    [anon_sym_LPAREN] = ACTIONS(1898),
    [anon_sym_in] = ACTIONS(1896),
    [anon_sym_of] = ACTIONS(1896),
    [anon_sym_SEMI] = ACTIONS(1898),
    [anon_sym_LBRACK] = ACTIONS(1898),
    [anon_sym_GT] = ACTIONS(1896),
    [anon_sym_DOT] = ACTIONS(1898),
    [anon_sym_async] = ACTIONS(1896),
    [anon_sym_function] = ACTIONS(1896),
    [anon_sym_QMARK_DOT] = ACTIONS(1898),
    [anon_sym_AMP_AMP] = ACTIONS(1898),
    [anon_sym_PIPE_PIPE] = ACTIONS(1898),
    [anon_sym_GT_GT] = ACTIONS(1896),
    [anon_sym_GT_GT_GT] = ACTIONS(1898),
    [anon_sym_LT_LT] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(1896),
    [anon_sym_CARET] = ACTIONS(1898),
    [anon_sym_PIPE] = ACTIONS(1896),
    [anon_sym_PLUS] = ACTIONS(1896),
    [anon_sym_DASH] = ACTIONS(1896),
    [anon_sym_SLASH] = ACTIONS(1896),
    [anon_sym_PERCENT] = ACTIONS(1898),
    [anon_sym_STAR_STAR] = ACTIONS(1898),
    [anon_sym_LT] = ACTIONS(1896),
    [anon_sym_LT_EQ] = ACTIONS(1898),
    [anon_sym_EQ_EQ] = ACTIONS(1896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1898),
    [anon_sym_BANG_EQ] = ACTIONS(1896),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1898),
    [anon_sym_GT_EQ] = ACTIONS(1898),
    [anon_sym_QMARK_QMARK] = ACTIONS(1898),
    [anon_sym_instanceof] = ACTIONS(1896),
    [anon_sym_PLUS_PLUS] = ACTIONS(1898),
    [anon_sym_DASH_DASH] = ACTIONS(1898),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1898),
    [anon_sym_AT] = ACTIONS(1898),
    [anon_sym_static] = ACTIONS(1896),
    [anon_sym_readonly] = ACTIONS(1896),
    [anon_sym_get] = ACTIONS(1896),
    [anon_sym_set] = ACTIONS(1896),
    [anon_sym_declare] = ACTIONS(1896),
    [anon_sym_public] = ACTIONS(1896),
    [anon_sym_private] = ACTIONS(1896),
    [anon_sym_protected] = ACTIONS(1896),
    [anon_sym_override] = ACTIONS(1896),
    [anon_sym_module] = ACTIONS(1896),
    [anon_sym_any] = ACTIONS(1896),
    [anon_sym_number] = ACTIONS(1896),
    [anon_sym_boolean] = ACTIONS(1896),
    [anon_sym_string] = ACTIONS(1896),
    [anon_sym_symbol] = ACTIONS(1896),
    [anon_sym_object] = ACTIONS(1896),
    [anon_sym_property] = ACTIONS(1896),
    [anon_sym_signal] = ACTIONS(1896),
    [anon_sym_on] = ACTIONS(1896),
    [anon_sym_required] = ACTIONS(1896),
    [anon_sym_component] = ACTIONS(1896),
    [anon_sym_satisfies] = ACTIONS(1896),
    [anon_sym_enum] = ACTIONS(1896),
    [sym__automatic_semicolon] = ACTIONS(1898),
    [sym__ternary_qmark] = ACTIONS(1898),
    [sym_html_comment] = ACTIONS(5),
  },
  [971] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(971),
    [sym_formal_parameters] = STATE(6257),
    [sym_rest_pattern] = STATE(5609),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4084),
    [sym_tuple_parameter] = STATE(5584),
    [sym_optional_tuple_parameter] = STATE(5584),
    [sym_optional_type] = STATE(5584),
    [sym_rest_type] = STATE(5584),
    [sym__tuple_type_member] = STATE(5488),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3187),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_COMMA] = ACTIONS(3257),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_RBRACK] = ACTIONS(3259),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [972] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(972),
    [sym_formal_parameters] = STATE(6257),
    [sym_rest_pattern] = STATE(5609),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4084),
    [sym_tuple_parameter] = STATE(5584),
    [sym_optional_tuple_parameter] = STATE(5584),
    [sym_optional_type] = STATE(5584),
    [sym_rest_type] = STATE(5584),
    [sym__tuple_type_member] = STATE(5315),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3187),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_COMMA] = ACTIONS(3261),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_RBRACK] = ACTIONS(3263),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [973] = {
    [sym_export_statement] = STATE(4075),
    [sym_object_pattern] = STATE(3599),
    [sym_object_assignment_pattern] = STATE(5126),
    [sym_array_pattern] = STATE(3599),
    [sym__call_signature] = STATE(4331),
    [sym__destructuring_pattern] = STATE(6297),
    [sym_spread_element] = STATE(5056),
    [sym_string] = STATE(3505),
    [sym_comment] = STATE(973),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(3540),
    [sym_rest_pattern] = STATE(5126),
    [sym_method_definition] = STATE(5056),
    [sym_pair] = STATE(5056),
    [sym_pair_pattern] = STATE(5126),
    [sym__property_name] = STATE(3352),
    [sym_computed_property_name] = STATE(3505),
    [sym_method_signature] = STATE(4075),
    [sym_accessibility_modifier] = STATE(2736),
    [sym_override_modifier] = STATE(2775),
    [sym_call_signature] = STATE(4075),
    [sym_property_signature] = STATE(4075),
    [sym_type_parameters] = STATE(5867),
    [sym_construct_signature] = STATE(4075),
    [sym_index_signature] = STATE(4075),
    [aux_sym_export_statement_repeat1] = STATE(4766),
    [aux_sym_object_repeat1] = STATE(5050),
    [aux_sym_object_pattern_repeat1] = STATE(4996),
    [sym_identifier] = ACTIONS(3265),
    [anon_sym_export] = ACTIONS(3267),
    [anon_sym_STAR] = ACTIONS(3053),
    [anon_sym_type] = ACTIONS(3265),
    [anon_sym_namespace] = ACTIONS(3265),
    [anon_sym_LBRACE] = ACTIONS(3055),
    [anon_sym_COMMA] = ACTIONS(3057),
    [anon_sym_RBRACE] = ACTIONS(3211),
    [anon_sym_from] = ACTIONS(3265),
    [anon_sym_let] = ACTIONS(3265),
    [anon_sym_LPAREN] = ACTIONS(3061),
    [anon_sym_of] = ACTIONS(3265),
    [anon_sym_SEMI] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3065),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_async] = ACTIONS(3269),
    [anon_sym_new] = ACTIONS(3271),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(219),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_LT] = ACTIONS(3073),
    [aux_sym_comment_token1] = ACTIONS(15),
    [sym_number] = ACTIONS(3075),
    [sym_private_property_identifier] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(3273),
    [anon_sym_readonly] = ACTIONS(3275),
    [anon_sym_get] = ACTIONS(3277),
    [anon_sym_set] = ACTIONS(3277),
    [anon_sym_declare] = ACTIONS(3265),
    [anon_sym_public] = ACTIONS(3279),
    [anon_sym_private] = ACTIONS(3279),
    [anon_sym_protected] = ACTIONS(3279),
    [anon_sym_override] = ACTIONS(3281),
    [anon_sym_module] = ACTIONS(3265),
    [anon_sym_any] = ACTIONS(3265),
    [anon_sym_number] = ACTIONS(3265),
    [anon_sym_boolean] = ACTIONS(3265),
    [anon_sym_string] = ACTIONS(3265),
    [anon_sym_symbol] = ACTIONS(3265),
    [anon_sym_object] = ACTIONS(3265),
    [anon_sym_property] = ACTIONS(3265),
    [anon_sym_signal] = ACTIONS(3265),
    [anon_sym_on] = ACTIONS(3265),
    [anon_sym_required] = ACTIONS(3265),
    [anon_sym_component] = ACTIONS(3265),
    [anon_sym_abstract] = ACTIONS(3087),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3089),
    [sym_html_comment] = ACTIONS(5),
  },
  [974] = {
    [sym_comment] = STATE(974),
    [sym_identifier] = ACTIONS(1854),
    [anon_sym_export] = ACTIONS(1854),
    [anon_sym_STAR] = ACTIONS(1854),
    [anon_sym_default] = ACTIONS(1854),
    [anon_sym_type] = ACTIONS(1854),
    [anon_sym_as] = ACTIONS(1854),
    [anon_sym_namespace] = ACTIONS(1854),
    [anon_sym_COMMA] = ACTIONS(1856),
    [anon_sym_RBRACE] = ACTIONS(1856),
    [anon_sym_from] = ACTIONS(1854),
    [anon_sym_var] = ACTIONS(1854),
    [anon_sym_let] = ACTIONS(1854),
    [anon_sym_BANG] = ACTIONS(1854),
    [anon_sym_else] = ACTIONS(1854),
    [anon_sym_LPAREN] = ACTIONS(1856),
    [anon_sym_in] = ACTIONS(1854),
    [anon_sym_of] = ACTIONS(1854),
    [anon_sym_SEMI] = ACTIONS(1856),
    [anon_sym_LBRACK] = ACTIONS(1856),
    [anon_sym_GT] = ACTIONS(1854),
    [anon_sym_DOT] = ACTIONS(1856),
    [anon_sym_async] = ACTIONS(1854),
    [anon_sym_function] = ACTIONS(1854),
    [anon_sym_QMARK_DOT] = ACTIONS(1856),
    [anon_sym_AMP_AMP] = ACTIONS(1856),
    [anon_sym_PIPE_PIPE] = ACTIONS(1856),
    [anon_sym_GT_GT] = ACTIONS(1854),
    [anon_sym_GT_GT_GT] = ACTIONS(1856),
    [anon_sym_LT_LT] = ACTIONS(1856),
    [anon_sym_AMP] = ACTIONS(1854),
    [anon_sym_CARET] = ACTIONS(1856),
    [anon_sym_PIPE] = ACTIONS(1854),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_DASH] = ACTIONS(1854),
    [anon_sym_SLASH] = ACTIONS(1854),
    [anon_sym_PERCENT] = ACTIONS(1856),
    [anon_sym_STAR_STAR] = ACTIONS(1856),
    [anon_sym_LT] = ACTIONS(1854),
    [anon_sym_LT_EQ] = ACTIONS(1856),
    [anon_sym_EQ_EQ] = ACTIONS(1854),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1856),
    [anon_sym_BANG_EQ] = ACTIONS(1854),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1856),
    [anon_sym_GT_EQ] = ACTIONS(1856),
    [anon_sym_QMARK_QMARK] = ACTIONS(1856),
    [anon_sym_instanceof] = ACTIONS(1854),
    [anon_sym_PLUS_PLUS] = ACTIONS(1856),
    [anon_sym_DASH_DASH] = ACTIONS(1856),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1856),
    [anon_sym_AT] = ACTIONS(1856),
    [anon_sym_static] = ACTIONS(1854),
    [anon_sym_readonly] = ACTIONS(1854),
    [anon_sym_get] = ACTIONS(1854),
    [anon_sym_set] = ACTIONS(1854),
    [anon_sym_declare] = ACTIONS(1854),
    [anon_sym_public] = ACTIONS(1854),
    [anon_sym_private] = ACTIONS(1854),
    [anon_sym_protected] = ACTIONS(1854),
    [anon_sym_override] = ACTIONS(1854),
    [anon_sym_module] = ACTIONS(1854),
    [anon_sym_any] = ACTIONS(1854),
    [anon_sym_number] = ACTIONS(1854),
    [anon_sym_boolean] = ACTIONS(1854),
    [anon_sym_string] = ACTIONS(1854),
    [anon_sym_symbol] = ACTIONS(1854),
    [anon_sym_object] = ACTIONS(1854),
    [anon_sym_property] = ACTIONS(1854),
    [anon_sym_signal] = ACTIONS(1854),
    [anon_sym_on] = ACTIONS(1854),
    [anon_sym_required] = ACTIONS(1854),
    [anon_sym_component] = ACTIONS(1854),
    [anon_sym_satisfies] = ACTIONS(1854),
    [anon_sym_enum] = ACTIONS(1854),
    [sym__automatic_semicolon] = ACTIONS(3283),
    [sym__ternary_qmark] = ACTIONS(1856),
    [sym_html_comment] = ACTIONS(5),
  },
  [975] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(975),
    [sym_formal_parameters] = STATE(6257),
    [sym_rest_pattern] = STATE(5609),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4084),
    [sym_tuple_parameter] = STATE(5584),
    [sym_optional_tuple_parameter] = STATE(5584),
    [sym_optional_type] = STATE(5584),
    [sym_rest_type] = STATE(5584),
    [sym__tuple_type_member] = STATE(4939),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3187),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_COMMA] = ACTIONS(3285),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_RBRACK] = ACTIONS(3287),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [976] = {
    [sym_comment] = STATE(976),
    [sym_identifier] = ACTIONS(1930),
    [anon_sym_export] = ACTIONS(1930),
    [anon_sym_STAR] = ACTIONS(1932),
    [anon_sym_default] = ACTIONS(1930),
    [anon_sym_type] = ACTIONS(1930),
    [anon_sym_as] = ACTIONS(1932),
    [anon_sym_namespace] = ACTIONS(1930),
    [anon_sym_COMMA] = ACTIONS(1936),
    [anon_sym_RBRACE] = ACTIONS(1934),
    [anon_sym_from] = ACTIONS(1930),
    [anon_sym_var] = ACTIONS(1930),
    [anon_sym_let] = ACTIONS(1930),
    [anon_sym_BANG] = ACTIONS(1932),
    [anon_sym_else] = ACTIONS(1930),
    [anon_sym_LPAREN] = ACTIONS(1936),
    [anon_sym_in] = ACTIONS(1932),
    [anon_sym_of] = ACTIONS(1930),
    [anon_sym_SEMI] = ACTIONS(1936),
    [anon_sym_LBRACK] = ACTIONS(1936),
    [anon_sym_GT] = ACTIONS(1932),
    [anon_sym_DOT] = ACTIONS(1936),
    [anon_sym_async] = ACTIONS(1930),
    [anon_sym_function] = ACTIONS(1930),
    [anon_sym_QMARK_DOT] = ACTIONS(1936),
    [anon_sym_AMP_AMP] = ACTIONS(1936),
    [anon_sym_PIPE_PIPE] = ACTIONS(1936),
    [anon_sym_GT_GT] = ACTIONS(1932),
    [anon_sym_GT_GT_GT] = ACTIONS(1936),
    [anon_sym_LT_LT] = ACTIONS(1936),
    [anon_sym_AMP] = ACTIONS(1932),
    [anon_sym_CARET] = ACTIONS(1936),
    [anon_sym_PIPE] = ACTIONS(1932),
    [anon_sym_PLUS] = ACTIONS(1932),
    [anon_sym_DASH] = ACTIONS(1932),
    [anon_sym_SLASH] = ACTIONS(1932),
    [anon_sym_PERCENT] = ACTIONS(1936),
    [anon_sym_STAR_STAR] = ACTIONS(1936),
    [anon_sym_LT] = ACTIONS(1932),
    [anon_sym_LT_EQ] = ACTIONS(1936),
    [anon_sym_EQ_EQ] = ACTIONS(1932),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1936),
    [anon_sym_BANG_EQ] = ACTIONS(1932),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1936),
    [anon_sym_GT_EQ] = ACTIONS(1936),
    [anon_sym_QMARK_QMARK] = ACTIONS(1936),
    [anon_sym_instanceof] = ACTIONS(1932),
    [anon_sym_PLUS_PLUS] = ACTIONS(1936),
    [anon_sym_DASH_DASH] = ACTIONS(1936),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1936),
    [anon_sym_AT] = ACTIONS(1934),
    [anon_sym_static] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1930),
    [anon_sym_get] = ACTIONS(1930),
    [anon_sym_set] = ACTIONS(1930),
    [anon_sym_declare] = ACTIONS(1930),
    [anon_sym_public] = ACTIONS(1930),
    [anon_sym_private] = ACTIONS(1930),
    [anon_sym_protected] = ACTIONS(1930),
    [anon_sym_override] = ACTIONS(1930),
    [anon_sym_module] = ACTIONS(1930),
    [anon_sym_any] = ACTIONS(1930),
    [anon_sym_number] = ACTIONS(1930),
    [anon_sym_boolean] = ACTIONS(1930),
    [anon_sym_string] = ACTIONS(1930),
    [anon_sym_symbol] = ACTIONS(1930),
    [anon_sym_object] = ACTIONS(1930),
    [anon_sym_property] = ACTIONS(1930),
    [anon_sym_signal] = ACTIONS(1930),
    [anon_sym_on] = ACTIONS(1930),
    [anon_sym_required] = ACTIONS(1930),
    [anon_sym_component] = ACTIONS(1930),
    [anon_sym_satisfies] = ACTIONS(1932),
    [anon_sym_enum] = ACTIONS(1930),
    [sym__automatic_semicolon] = ACTIONS(3289),
    [sym__ternary_qmark] = ACTIONS(1936),
    [sym_html_comment] = ACTIONS(5),
  },
  [977] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(977),
    [sym_formal_parameters] = STATE(6257),
    [sym_rest_pattern] = STATE(5609),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4084),
    [sym_tuple_parameter] = STATE(5584),
    [sym_optional_tuple_parameter] = STATE(5584),
    [sym_optional_type] = STATE(5584),
    [sym_rest_type] = STATE(5584),
    [sym__tuple_type_member] = STATE(5774),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3187),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_RBRACK] = ACTIONS(3291),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [978] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(978),
    [sym_formal_parameters] = STATE(6257),
    [sym_rest_pattern] = STATE(5609),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4084),
    [sym_tuple_parameter] = STATE(5584),
    [sym_optional_tuple_parameter] = STATE(5584),
    [sym_optional_type] = STATE(5584),
    [sym_rest_type] = STATE(5584),
    [sym__tuple_type_member] = STATE(5774),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3187),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_RBRACK] = ACTIONS(3293),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [979] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(979),
    [sym_formal_parameters] = STATE(6257),
    [sym_rest_pattern] = STATE(5609),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4084),
    [sym_tuple_parameter] = STATE(5584),
    [sym_optional_tuple_parameter] = STATE(5584),
    [sym_optional_type] = STATE(5584),
    [sym_rest_type] = STATE(5584),
    [sym__tuple_type_member] = STATE(5774),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3187),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_RBRACK] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [980] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(980),
    [sym_formal_parameters] = STATE(6257),
    [sym_rest_pattern] = STATE(5609),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4084),
    [sym_tuple_parameter] = STATE(5584),
    [sym_optional_tuple_parameter] = STATE(5584),
    [sym_optional_type] = STATE(5584),
    [sym_rest_type] = STATE(5584),
    [sym__tuple_type_member] = STATE(5774),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3187),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_RBRACK] = ACTIONS(3297),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [981] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(981),
    [sym_formal_parameters] = STATE(6257),
    [sym_rest_pattern] = STATE(5609),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4084),
    [sym_tuple_parameter] = STATE(5584),
    [sym_optional_tuple_parameter] = STATE(5584),
    [sym_optional_type] = STATE(5584),
    [sym_rest_type] = STATE(5584),
    [sym__tuple_type_member] = STATE(5774),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3187),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_RBRACK] = ACTIONS(3299),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [982] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(982),
    [sym_formal_parameters] = STATE(6257),
    [sym_rest_pattern] = STATE(5609),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4084),
    [sym_tuple_parameter] = STATE(5584),
    [sym_optional_tuple_parameter] = STATE(5584),
    [sym_optional_type] = STATE(5584),
    [sym_rest_type] = STATE(5584),
    [sym__tuple_type_member] = STATE(5774),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3187),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_RBRACK] = ACTIONS(3301),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [983] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(983),
    [sym_formal_parameters] = STATE(6257),
    [sym_rest_pattern] = STATE(5609),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4084),
    [sym_tuple_parameter] = STATE(5584),
    [sym_optional_tuple_parameter] = STATE(5584),
    [sym_optional_type] = STATE(5584),
    [sym_rest_type] = STATE(5584),
    [sym__tuple_type_member] = STATE(5774),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3187),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_RBRACK] = ACTIONS(3303),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [984] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(984),
    [sym_formal_parameters] = STATE(6257),
    [sym_rest_pattern] = STATE(5609),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4084),
    [sym_tuple_parameter] = STATE(5584),
    [sym_optional_tuple_parameter] = STATE(5584),
    [sym_optional_type] = STATE(5584),
    [sym_rest_type] = STATE(5584),
    [sym__tuple_type_member] = STATE(5774),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3187),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_RBRACK] = ACTIONS(3305),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [985] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(985),
    [sym_formal_parameters] = STATE(6257),
    [sym_rest_pattern] = STATE(5609),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4084),
    [sym_tuple_parameter] = STATE(5584),
    [sym_optional_tuple_parameter] = STATE(5584),
    [sym_optional_type] = STATE(5584),
    [sym_rest_type] = STATE(5584),
    [sym__tuple_type_member] = STATE(5774),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3187),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_RBRACK] = ACTIONS(3307),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [986] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(986),
    [sym_formal_parameters] = STATE(6257),
    [sym_rest_pattern] = STATE(5609),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4084),
    [sym_tuple_parameter] = STATE(5584),
    [sym_optional_tuple_parameter] = STATE(5584),
    [sym_optional_type] = STATE(5584),
    [sym_rest_type] = STATE(5584),
    [sym__tuple_type_member] = STATE(5774),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3187),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_RBRACK] = ACTIONS(3309),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [987] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(987),
    [sym_formal_parameters] = STATE(6257),
    [sym_rest_pattern] = STATE(5609),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4084),
    [sym_tuple_parameter] = STATE(5584),
    [sym_optional_tuple_parameter] = STATE(5584),
    [sym_optional_type] = STATE(5584),
    [sym_rest_type] = STATE(5584),
    [sym__tuple_type_member] = STATE(5774),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3187),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3193),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [988] = {
    [sym_import] = STATE(4978),
    [sym_nested_identifier] = STATE(6123),
    [sym_string] = STATE(3650),
    [sym_comment] = STATE(988),
    [sym_formal_parameters] = STATE(6329),
    [sym_nested_type_identifier] = STATE(3475),
    [sym__type_query_member_expression_in_type_annotation] = STATE(3773),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4047),
    [sym_asserts] = STATE(4412),
    [sym__type] = STATE(3772),
    [sym_constructor_type] = STATE(3735),
    [sym__primary_type] = STATE(3709),
    [sym_template_literal_type] = STATE(3706),
    [sym_infer_type] = STATE(3735),
    [sym_conditional_type] = STATE(3706),
    [sym_generic_type] = STATE(3706),
    [sym_type_predicate] = STATE(4414),
    [sym_type_query] = STATE(3706),
    [sym_index_type_query] = STATE(3706),
    [sym_lookup_type] = STATE(3706),
    [sym_literal_type] = STATE(3706),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3706),
    [sym_flow_maybe_type] = STATE(3706),
    [sym_parenthesized_type] = STATE(3706),
    [sym_predefined_type] = STATE(3538),
    [sym_object_type] = STATE(3706),
    [sym_type_parameters] = STATE(5682),
    [sym_array_type] = STATE(3706),
    [sym_tuple_type] = STATE(3706),
    [sym_readonly_type] = STATE(3735),
    [sym_union_type] = STATE(3706),
    [sym_intersection_type] = STATE(3706),
    [sym_function_type] = STATE(3735),
    [sym_identifier] = ACTIONS(3311),
    [anon_sym_STAR] = ACTIONS(3313),
    [anon_sym_LBRACE] = ACTIONS(3315),
    [anon_sym_typeof] = ACTIONS(3317),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_LPAREN] = ACTIONS(3321),
    [anon_sym_LBRACK] = ACTIONS(3323),
    [anon_sym_DQUOTE] = ACTIONS(3325),
    [anon_sym_SQUOTE] = ACTIONS(3327),
    [anon_sym_new] = ACTIONS(3329),
    [anon_sym_AMP] = ACTIONS(3331),
    [anon_sym_PIPE] = ACTIONS(3333),
    [anon_sym_PLUS] = ACTIONS(3335),
    [anon_sym_DASH] = ACTIONS(3335),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3337),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3339),
    [sym_number] = ACTIONS(3341),
    [sym_this] = ACTIONS(3343),
    [sym_true] = ACTIONS(3345),
    [sym_false] = ACTIONS(3345),
    [sym_null] = ACTIONS(3345),
    [sym_undefined] = ACTIONS(3345),
    [anon_sym_readonly] = ACTIONS(3347),
    [anon_sym_QMARK] = ACTIONS(3349),
    [anon_sym_any] = ACTIONS(3337),
    [anon_sym_number] = ACTIONS(3337),
    [anon_sym_boolean] = ACTIONS(3337),
    [anon_sym_string] = ACTIONS(3337),
    [anon_sym_symbol] = ACTIONS(3337),
    [anon_sym_object] = ACTIONS(3337),
    [anon_sym_abstract] = ACTIONS(3351),
    [anon_sym_asserts] = ACTIONS(3353),
    [anon_sym_infer] = ACTIONS(3355),
    [anon_sym_keyof] = ACTIONS(3357),
    [anon_sym_unique] = ACTIONS(3359),
    [anon_sym_unknown] = ACTIONS(3337),
    [anon_sym_never] = ACTIONS(3337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3361),
    [sym_html_comment] = ACTIONS(5),
  },
  [989] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(989),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(3585),
    [sym__type_query_call_expression_in_type_annotation] = STATE(3967),
    [sym_asserts] = STATE(5602),
    [sym__type] = STATE(3583),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_predicate] = STATE(5603),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3208),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3363),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(3365),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_asserts] = ACTIONS(3367),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [990] = {
    [sym_import] = STATE(4979),
    [sym_nested_identifier] = STATE(6076),
    [sym_string] = STATE(3484),
    [sym_comment] = STATE(990),
    [sym_formal_parameters] = STATE(5995),
    [sym_nested_type_identifier] = STATE(3366),
    [sym__type_query_member_expression_in_type_annotation] = STATE(3546),
    [sym__type_query_call_expression_in_type_annotation] = STATE(3743),
    [sym_asserts] = STATE(4034),
    [sym__type] = STATE(3537),
    [sym_constructor_type] = STATE(3468),
    [sym__primary_type] = STATE(3467),
    [sym_template_literal_type] = STATE(3466),
    [sym_infer_type] = STATE(3468),
    [sym_conditional_type] = STATE(3466),
    [sym_generic_type] = STATE(3466),
    [sym_type_predicate] = STATE(4032),
    [sym_type_query] = STATE(3466),
    [sym_index_type_query] = STATE(3466),
    [sym_lookup_type] = STATE(3466),
    [sym_literal_type] = STATE(3466),
    [sym__number] = STATE(3465),
    [sym_existential_type] = STATE(3466),
    [sym_flow_maybe_type] = STATE(3466),
    [sym_parenthesized_type] = STATE(3466),
    [sym_predefined_type] = STATE(3426),
    [sym_object_type] = STATE(3466),
    [sym_type_parameters] = STATE(5758),
    [sym_array_type] = STATE(3466),
    [sym_tuple_type] = STATE(3466),
    [sym_readonly_type] = STATE(3468),
    [sym_union_type] = STATE(3466),
    [sym_intersection_type] = STATE(3466),
    [sym_function_type] = STATE(3468),
    [sym_identifier] = ACTIONS(3369),
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_LBRACE] = ACTIONS(2006),
    [anon_sym_typeof] = ACTIONS(2008),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(2010),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_new] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(1109),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [sym_number] = ACTIONS(2028),
    [sym_this] = ACTIONS(3373),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [sym_null] = ACTIONS(2032),
    [sym_undefined] = ACTIONS(2032),
    [anon_sym_readonly] = ACTIONS(2034),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1109),
    [anon_sym_number] = ACTIONS(1109),
    [anon_sym_boolean] = ACTIONS(1109),
    [anon_sym_string] = ACTIONS(1109),
    [anon_sym_symbol] = ACTIONS(1109),
    [anon_sym_object] = ACTIONS(1109),
    [anon_sym_abstract] = ACTIONS(1101),
    [anon_sym_asserts] = ACTIONS(3375),
    [anon_sym_infer] = ACTIONS(1103),
    [anon_sym_keyof] = ACTIONS(1105),
    [anon_sym_unique] = ACTIONS(1107),
    [anon_sym_unknown] = ACTIONS(1109),
    [anon_sym_never] = ACTIONS(1109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1111),
    [sym_html_comment] = ACTIONS(5),
  },
  [991] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(991),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4474),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4962),
    [sym__type] = STATE(4475),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(3377),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [992] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(992),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4474),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4962),
    [sym__type] = STATE(4475),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(3379),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [993] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(993),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4474),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4962),
    [sym__type] = STATE(4475),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(3381),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [994] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(994),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4474),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4962),
    [sym__type] = STATE(4475),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(3383),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [995] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(995),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4474),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4962),
    [sym__type] = STATE(4475),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(3385),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [996] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(996),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4474),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4962),
    [sym__type] = STATE(4475),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(3387),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [997] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(997),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4474),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4962),
    [sym__type] = STATE(4475),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(3389),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [998] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(998),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4474),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4962),
    [sym__type] = STATE(4475),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(3391),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [999] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(999),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4474),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4962),
    [sym__type] = STATE(4475),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(3393),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1000] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1000),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4474),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4962),
    [sym__type] = STATE(4475),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(3395),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1001] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1001),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4474),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4962),
    [sym__type] = STATE(4475),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(3397),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1002] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1002),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4474),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4962),
    [sym__type] = STATE(4475),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(3399),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1003] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1003),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4474),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4962),
    [sym__type] = STATE(4475),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(3401),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1004] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1004),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4474),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4962),
    [sym__type] = STATE(4475),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(3403),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1005] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1005),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4474),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4962),
    [sym__type] = STATE(4475),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(3405),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1006] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1006),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4474),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4962),
    [sym__type] = STATE(4475),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(3407),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1007] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1007),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4474),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4962),
    [sym__type] = STATE(4475),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(3409),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1008] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1008),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4474),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4962),
    [sym__type] = STATE(4475),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(3411),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1009] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1009),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4474),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4962),
    [sym__type] = STATE(4475),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(3413),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1010] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1010),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4054),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4724),
    [sym__type] = STATE(4055),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_type_parameter] = STATE(5266),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3415),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(3417),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1011] = {
    [sym_export_statement] = STATE(4101),
    [sym_object_pattern] = STATE(3599),
    [sym_object_assignment_pattern] = STATE(5553),
    [sym_array_pattern] = STATE(3599),
    [sym__call_signature] = STATE(4331),
    [sym__destructuring_pattern] = STATE(6297),
    [sym_spread_element] = STATE(5562),
    [sym_string] = STATE(3505),
    [sym_comment] = STATE(1011),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(3540),
    [sym_rest_pattern] = STATE(5553),
    [sym_method_definition] = STATE(5562),
    [sym_pair] = STATE(5562),
    [sym_pair_pattern] = STATE(5553),
    [sym__property_name] = STATE(3352),
    [sym_computed_property_name] = STATE(3505),
    [sym_method_signature] = STATE(4101),
    [sym_accessibility_modifier] = STATE(2736),
    [sym_override_modifier] = STATE(2775),
    [sym_call_signature] = STATE(4101),
    [sym_property_signature] = STATE(4101),
    [sym_type_parameters] = STATE(5867),
    [sym_construct_signature] = STATE(4101),
    [sym_index_signature] = STATE(4101),
    [aux_sym_export_statement_repeat1] = STATE(4766),
    [sym_identifier] = ACTIONS(3419),
    [anon_sym_export] = ACTIONS(3421),
    [anon_sym_STAR] = ACTIONS(3053),
    [anon_sym_type] = ACTIONS(3419),
    [anon_sym_namespace] = ACTIONS(3419),
    [anon_sym_LBRACE] = ACTIONS(3055),
    [anon_sym_COMMA] = ACTIONS(3423),
    [anon_sym_RBRACE] = ACTIONS(3423),
    [anon_sym_from] = ACTIONS(3419),
    [anon_sym_let] = ACTIONS(3419),
    [anon_sym_LPAREN] = ACTIONS(3061),
    [anon_sym_of] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3065),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_async] = ACTIONS(3426),
    [anon_sym_new] = ACTIONS(3428),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(219),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_LT] = ACTIONS(3073),
    [aux_sym_comment_token1] = ACTIONS(15),
    [sym_number] = ACTIONS(3075),
    [sym_private_property_identifier] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(3430),
    [anon_sym_readonly] = ACTIONS(3432),
    [anon_sym_get] = ACTIONS(3434),
    [anon_sym_set] = ACTIONS(3434),
    [anon_sym_declare] = ACTIONS(3419),
    [anon_sym_public] = ACTIONS(3436),
    [anon_sym_private] = ACTIONS(3436),
    [anon_sym_protected] = ACTIONS(3436),
    [anon_sym_override] = ACTIONS(3438),
    [anon_sym_module] = ACTIONS(3419),
    [anon_sym_any] = ACTIONS(3419),
    [anon_sym_number] = ACTIONS(3419),
    [anon_sym_boolean] = ACTIONS(3419),
    [anon_sym_string] = ACTIONS(3419),
    [anon_sym_symbol] = ACTIONS(3419),
    [anon_sym_object] = ACTIONS(3419),
    [anon_sym_property] = ACTIONS(3419),
    [anon_sym_signal] = ACTIONS(3419),
    [anon_sym_on] = ACTIONS(3419),
    [anon_sym_required] = ACTIONS(3419),
    [anon_sym_component] = ACTIONS(3419),
    [anon_sym_abstract] = ACTIONS(3087),
    [sym_html_comment] = ACTIONS(5),
  },
  [1012] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1012),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4474),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4962),
    [sym__type] = STATE(4475),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(3440),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1013] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1013),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4474),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4962),
    [sym__type] = STATE(4475),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(3442),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1014] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1014),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4474),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4962),
    [sym__type] = STATE(4475),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(3444),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1015] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1015),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4474),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4962),
    [sym__type] = STATE(4475),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(3446),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1016] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1016),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4474),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4962),
    [sym__type] = STATE(4475),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(3448),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1017] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1017),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4474),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4962),
    [sym__type] = STATE(4475),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(3450),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1018] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1018),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4474),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4962),
    [sym__type] = STATE(4475),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(3452),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1019] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1019),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4474),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4962),
    [sym__type] = STATE(4475),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(3454),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1020] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1020),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4474),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4962),
    [sym__type] = STATE(4475),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(3456),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1021] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1021),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4474),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4962),
    [sym__type] = STATE(4475),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(3458),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1022] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1022),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4474),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4962),
    [sym__type] = STATE(4475),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(3460),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1023] = {
    [sym_export_statement] = STATE(4152),
    [sym_object_pattern] = STATE(3599),
    [sym_object_assignment_pattern] = STATE(5553),
    [sym_array_pattern] = STATE(3599),
    [sym__call_signature] = STATE(4331),
    [sym__destructuring_pattern] = STATE(6297),
    [sym_spread_element] = STATE(5562),
    [sym_string] = STATE(3505),
    [sym_comment] = STATE(1023),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(3540),
    [sym_rest_pattern] = STATE(5553),
    [sym_method_definition] = STATE(5562),
    [sym_pair] = STATE(5562),
    [sym_pair_pattern] = STATE(5553),
    [sym__property_name] = STATE(3352),
    [sym_computed_property_name] = STATE(3505),
    [sym_method_signature] = STATE(4152),
    [sym_accessibility_modifier] = STATE(2736),
    [sym_override_modifier] = STATE(2775),
    [sym_call_signature] = STATE(4152),
    [sym_property_signature] = STATE(4152),
    [sym_type_parameters] = STATE(5867),
    [sym_construct_signature] = STATE(4152),
    [sym_index_signature] = STATE(4152),
    [aux_sym_export_statement_repeat1] = STATE(4766),
    [sym_identifier] = ACTIONS(3419),
    [anon_sym_export] = ACTIONS(3421),
    [anon_sym_STAR] = ACTIONS(3053),
    [anon_sym_type] = ACTIONS(3419),
    [anon_sym_namespace] = ACTIONS(3419),
    [anon_sym_LBRACE] = ACTIONS(3055),
    [anon_sym_COMMA] = ACTIONS(3423),
    [anon_sym_RBRACE] = ACTIONS(3423),
    [anon_sym_from] = ACTIONS(3419),
    [anon_sym_let] = ACTIONS(3419),
    [anon_sym_LPAREN] = ACTIONS(3061),
    [anon_sym_of] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3065),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_async] = ACTIONS(3426),
    [anon_sym_new] = ACTIONS(3428),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(219),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_LT] = ACTIONS(3073),
    [aux_sym_comment_token1] = ACTIONS(15),
    [sym_number] = ACTIONS(3075),
    [sym_private_property_identifier] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(3430),
    [anon_sym_readonly] = ACTIONS(3432),
    [anon_sym_get] = ACTIONS(3434),
    [anon_sym_set] = ACTIONS(3434),
    [anon_sym_declare] = ACTIONS(3419),
    [anon_sym_public] = ACTIONS(3436),
    [anon_sym_private] = ACTIONS(3436),
    [anon_sym_protected] = ACTIONS(3436),
    [anon_sym_override] = ACTIONS(3438),
    [anon_sym_module] = ACTIONS(3419),
    [anon_sym_any] = ACTIONS(3419),
    [anon_sym_number] = ACTIONS(3419),
    [anon_sym_boolean] = ACTIONS(3419),
    [anon_sym_string] = ACTIONS(3419),
    [anon_sym_symbol] = ACTIONS(3419),
    [anon_sym_object] = ACTIONS(3419),
    [anon_sym_property] = ACTIONS(3419),
    [anon_sym_signal] = ACTIONS(3419),
    [anon_sym_on] = ACTIONS(3419),
    [anon_sym_required] = ACTIONS(3419),
    [anon_sym_component] = ACTIONS(3419),
    [anon_sym_abstract] = ACTIONS(3087),
    [sym_html_comment] = ACTIONS(5),
  },
  [1024] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1024),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4474),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4962),
    [sym__type] = STATE(4475),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(3462),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1025] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1025),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4474),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4962),
    [sym__type] = STATE(4475),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(3464),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1026] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1026),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4474),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4962),
    [sym__type] = STATE(4475),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(3466),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1027] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1027),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4474),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4962),
    [sym__type] = STATE(4475),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(3468),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1028] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1028),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4474),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4962),
    [sym__type] = STATE(4475),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(3470),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1029] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1029),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4474),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4962),
    [sym__type] = STATE(4475),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(3472),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1030] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1030),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4474),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4962),
    [sym__type] = STATE(4475),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1031] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1031),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(3585),
    [sym__type_query_call_expression_in_type_annotation] = STATE(3967),
    [sym__type] = STATE(3583),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1032] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1032),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4029),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4690),
    [sym__type] = STATE(4028),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1033] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1033),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4065),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4752),
    [sym__type] = STATE(4069),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1034] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1034),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4180),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4833),
    [sym__type] = STATE(4179),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1035] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1035),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4064),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4735),
    [sym__type] = STATE(4063),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1036] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1036),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4108),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4832),
    [sym__type] = STATE(4107),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1037] = {
    [sym_import] = STATE(4979),
    [sym_nested_identifier] = STATE(6076),
    [sym_string] = STATE(3484),
    [sym_comment] = STATE(1037),
    [sym_formal_parameters] = STATE(5995),
    [sym_nested_type_identifier] = STATE(3366),
    [sym__type_query_member_expression_in_type_annotation] = STATE(3546),
    [sym__type_query_call_expression_in_type_annotation] = STATE(3743),
    [sym__type] = STATE(3537),
    [sym_constructor_type] = STATE(3468),
    [sym__primary_type] = STATE(3467),
    [sym_template_literal_type] = STATE(3466),
    [sym_infer_type] = STATE(3468),
    [sym_conditional_type] = STATE(3466),
    [sym_generic_type] = STATE(3466),
    [sym_type_query] = STATE(3466),
    [sym_index_type_query] = STATE(3466),
    [sym_lookup_type] = STATE(3466),
    [sym_literal_type] = STATE(3466),
    [sym__number] = STATE(3465),
    [sym_existential_type] = STATE(3466),
    [sym_flow_maybe_type] = STATE(3466),
    [sym_parenthesized_type] = STATE(3466),
    [sym_predefined_type] = STATE(3466),
    [sym_object_type] = STATE(3466),
    [sym_type_parameters] = STATE(5758),
    [sym_array_type] = STATE(3466),
    [sym_tuple_type] = STATE(3466),
    [sym_readonly_type] = STATE(3468),
    [sym_union_type] = STATE(3466),
    [sym_intersection_type] = STATE(3466),
    [sym_function_type] = STATE(3468),
    [sym_identifier] = ACTIONS(2002),
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_LBRACE] = ACTIONS(2006),
    [anon_sym_typeof] = ACTIONS(2008),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(2010),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_new] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(1109),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [sym_number] = ACTIONS(2028),
    [sym_this] = ACTIONS(2030),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [sym_null] = ACTIONS(2032),
    [sym_undefined] = ACTIONS(2032),
    [anon_sym_readonly] = ACTIONS(2034),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1109),
    [anon_sym_number] = ACTIONS(1109),
    [anon_sym_boolean] = ACTIONS(1109),
    [anon_sym_string] = ACTIONS(1109),
    [anon_sym_symbol] = ACTIONS(1109),
    [anon_sym_object] = ACTIONS(1109),
    [anon_sym_abstract] = ACTIONS(1101),
    [anon_sym_infer] = ACTIONS(1103),
    [anon_sym_keyof] = ACTIONS(1105),
    [anon_sym_unique] = ACTIONS(1107),
    [anon_sym_unknown] = ACTIONS(1109),
    [anon_sym_never] = ACTIONS(1109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1111),
    [sym_html_comment] = ACTIONS(5),
  },
  [1038] = {
    [sym_import] = STATE(5335),
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1038),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4054),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4724),
    [sym__type] = STATE(4055),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_import] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1039] = {
    [sym_nested_identifier] = STATE(6099),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1039),
    [sym_formal_parameters] = STATE(6035),
    [sym_nested_type_identifier] = STATE(3747),
    [sym_asserts] = STATE(3278),
    [sym__type] = STATE(4149),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_predicate] = STATE(3278),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3803),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5617),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3474),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_typeof] = ACTIONS(3478),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_AMP] = ACTIONS(3482),
    [anon_sym_PIPE] = ACTIONS(3484),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(3486),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(3488),
    [anon_sym_QMARK] = ACTIONS(3490),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(3492),
    [anon_sym_asserts] = ACTIONS(3494),
    [anon_sym_infer] = ACTIONS(3496),
    [anon_sym_keyof] = ACTIONS(3498),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3500),
    [sym_html_comment] = ACTIONS(5),
  },
  [1040] = {
    [sym_nested_identifier] = STATE(6123),
    [sym_string] = STATE(3650),
    [sym_comment] = STATE(1040),
    [sym_formal_parameters] = STATE(6329),
    [sym_nested_type_identifier] = STATE(3475),
    [sym_asserts] = STATE(3601),
    [sym__type] = STATE(3603),
    [sym_constructor_type] = STATE(3735),
    [sym__primary_type] = STATE(3709),
    [sym_template_literal_type] = STATE(3706),
    [sym_infer_type] = STATE(3735),
    [sym_conditional_type] = STATE(3706),
    [sym_generic_type] = STATE(3706),
    [sym_type_predicate] = STATE(3601),
    [sym_type_query] = STATE(3706),
    [sym_index_type_query] = STATE(3706),
    [sym_lookup_type] = STATE(3706),
    [sym_literal_type] = STATE(3706),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3706),
    [sym_flow_maybe_type] = STATE(3706),
    [sym_parenthesized_type] = STATE(3706),
    [sym_predefined_type] = STATE(3538),
    [sym_object_type] = STATE(3706),
    [sym_type_parameters] = STATE(5682),
    [sym_array_type] = STATE(3706),
    [sym_tuple_type] = STATE(3706),
    [sym_readonly_type] = STATE(3735),
    [sym_union_type] = STATE(3706),
    [sym_intersection_type] = STATE(3706),
    [sym_function_type] = STATE(3735),
    [sym_identifier] = ACTIONS(3311),
    [anon_sym_STAR] = ACTIONS(3313),
    [anon_sym_LBRACE] = ACTIONS(3315),
    [anon_sym_typeof] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_LPAREN] = ACTIONS(3321),
    [anon_sym_LBRACK] = ACTIONS(3323),
    [anon_sym_DQUOTE] = ACTIONS(3325),
    [anon_sym_SQUOTE] = ACTIONS(3327),
    [anon_sym_new] = ACTIONS(3329),
    [anon_sym_AMP] = ACTIONS(3331),
    [anon_sym_PIPE] = ACTIONS(3333),
    [anon_sym_PLUS] = ACTIONS(3335),
    [anon_sym_DASH] = ACTIONS(3335),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3337),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3339),
    [sym_number] = ACTIONS(3341),
    [sym_this] = ACTIONS(3343),
    [sym_true] = ACTIONS(3345),
    [sym_false] = ACTIONS(3345),
    [sym_null] = ACTIONS(3345),
    [sym_undefined] = ACTIONS(3345),
    [anon_sym_readonly] = ACTIONS(3347),
    [anon_sym_QMARK] = ACTIONS(3349),
    [anon_sym_any] = ACTIONS(3337),
    [anon_sym_number] = ACTIONS(3337),
    [anon_sym_boolean] = ACTIONS(3337),
    [anon_sym_string] = ACTIONS(3337),
    [anon_sym_symbol] = ACTIONS(3337),
    [anon_sym_object] = ACTIONS(3337),
    [anon_sym_abstract] = ACTIONS(3351),
    [anon_sym_asserts] = ACTIONS(3353),
    [anon_sym_infer] = ACTIONS(3355),
    [anon_sym_keyof] = ACTIONS(3357),
    [anon_sym_unique] = ACTIONS(3359),
    [anon_sym_unknown] = ACTIONS(3337),
    [anon_sym_never] = ACTIONS(3337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3361),
    [sym_html_comment] = ACTIONS(5),
  },
  [1041] = {
    [sym_nested_identifier] = STATE(5958),
    [sym_string] = STATE(2307),
    [sym_comment] = STATE(1041),
    [sym_formal_parameters] = STATE(6100),
    [sym_nested_type_identifier] = STATE(2121),
    [sym_asserts] = STATE(2328),
    [sym__type] = STATE(2327),
    [sym_constructor_type] = STATE(2353),
    [sym__primary_type] = STATE(2401),
    [sym_template_literal_type] = STATE(2397),
    [sym_infer_type] = STATE(2353),
    [sym_conditional_type] = STATE(2397),
    [sym_generic_type] = STATE(2397),
    [sym_type_predicate] = STATE(2328),
    [sym_type_query] = STATE(2397),
    [sym_index_type_query] = STATE(2397),
    [sym_lookup_type] = STATE(2397),
    [sym_literal_type] = STATE(2397),
    [sym__number] = STATE(2309),
    [sym_existential_type] = STATE(2397),
    [sym_flow_maybe_type] = STATE(2397),
    [sym_parenthesized_type] = STATE(2397),
    [sym_predefined_type] = STATE(2177),
    [sym_object_type] = STATE(2397),
    [sym_type_parameters] = STATE(5861),
    [sym_array_type] = STATE(2397),
    [sym_tuple_type] = STATE(2397),
    [sym_readonly_type] = STATE(2353),
    [sym_union_type] = STATE(2397),
    [sym_intersection_type] = STATE(2397),
    [sym_function_type] = STATE(2353),
    [sym_identifier] = ACTIONS(3502),
    [anon_sym_STAR] = ACTIONS(3504),
    [anon_sym_LBRACE] = ACTIONS(3506),
    [anon_sym_typeof] = ACTIONS(3508),
    [anon_sym_const] = ACTIONS(3510),
    [anon_sym_LPAREN] = ACTIONS(3512),
    [anon_sym_LBRACK] = ACTIONS(3514),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_new] = ACTIONS(3516),
    [anon_sym_AMP] = ACTIONS(3518),
    [anon_sym_PIPE] = ACTIONS(3520),
    [anon_sym_PLUS] = ACTIONS(3522),
    [anon_sym_DASH] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3524),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3526),
    [sym_number] = ACTIONS(3528),
    [sym_this] = ACTIONS(3530),
    [sym_true] = ACTIONS(3532),
    [sym_false] = ACTIONS(3532),
    [sym_null] = ACTIONS(3532),
    [sym_undefined] = ACTIONS(3532),
    [anon_sym_readonly] = ACTIONS(3534),
    [anon_sym_QMARK] = ACTIONS(3536),
    [anon_sym_any] = ACTIONS(3524),
    [anon_sym_number] = ACTIONS(3524),
    [anon_sym_boolean] = ACTIONS(3524),
    [anon_sym_string] = ACTIONS(3524),
    [anon_sym_symbol] = ACTIONS(3524),
    [anon_sym_object] = ACTIONS(3524),
    [anon_sym_abstract] = ACTIONS(3538),
    [anon_sym_asserts] = ACTIONS(3540),
    [anon_sym_infer] = ACTIONS(3542),
    [anon_sym_keyof] = ACTIONS(3544),
    [anon_sym_unique] = ACTIONS(3546),
    [anon_sym_unknown] = ACTIONS(3524),
    [anon_sym_never] = ACTIONS(3524),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3548),
    [sym_html_comment] = ACTIONS(5),
  },
  [1042] = {
    [sym_nested_identifier] = STATE(5958),
    [sym_string] = STATE(2307),
    [sym_comment] = STATE(1042),
    [sym_formal_parameters] = STATE(6100),
    [sym_nested_type_identifier] = STATE(2121),
    [sym_asserts] = STATE(2286),
    [sym__type] = STATE(2322),
    [sym_constructor_type] = STATE(2353),
    [sym__primary_type] = STATE(2401),
    [sym_template_literal_type] = STATE(2397),
    [sym_infer_type] = STATE(2353),
    [sym_conditional_type] = STATE(2397),
    [sym_generic_type] = STATE(2397),
    [sym_type_predicate] = STATE(2286),
    [sym_type_query] = STATE(2397),
    [sym_index_type_query] = STATE(2397),
    [sym_lookup_type] = STATE(2397),
    [sym_literal_type] = STATE(2397),
    [sym__number] = STATE(2309),
    [sym_existential_type] = STATE(2397),
    [sym_flow_maybe_type] = STATE(2397),
    [sym_parenthesized_type] = STATE(2397),
    [sym_predefined_type] = STATE(2177),
    [sym_object_type] = STATE(2397),
    [sym_type_parameters] = STATE(5861),
    [sym_array_type] = STATE(2397),
    [sym_tuple_type] = STATE(2397),
    [sym_readonly_type] = STATE(2353),
    [sym_union_type] = STATE(2397),
    [sym_intersection_type] = STATE(2397),
    [sym_function_type] = STATE(2353),
    [sym_identifier] = ACTIONS(3502),
    [anon_sym_STAR] = ACTIONS(3504),
    [anon_sym_LBRACE] = ACTIONS(3506),
    [anon_sym_typeof] = ACTIONS(3508),
    [anon_sym_const] = ACTIONS(3510),
    [anon_sym_LPAREN] = ACTIONS(3512),
    [anon_sym_LBRACK] = ACTIONS(3514),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_new] = ACTIONS(3516),
    [anon_sym_AMP] = ACTIONS(3518),
    [anon_sym_PIPE] = ACTIONS(3520),
    [anon_sym_PLUS] = ACTIONS(3522),
    [anon_sym_DASH] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3524),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3526),
    [sym_number] = ACTIONS(3528),
    [sym_this] = ACTIONS(3530),
    [sym_true] = ACTIONS(3532),
    [sym_false] = ACTIONS(3532),
    [sym_null] = ACTIONS(3532),
    [sym_undefined] = ACTIONS(3532),
    [anon_sym_readonly] = ACTIONS(3534),
    [anon_sym_QMARK] = ACTIONS(3536),
    [anon_sym_any] = ACTIONS(3524),
    [anon_sym_number] = ACTIONS(3524),
    [anon_sym_boolean] = ACTIONS(3524),
    [anon_sym_string] = ACTIONS(3524),
    [anon_sym_symbol] = ACTIONS(3524),
    [anon_sym_object] = ACTIONS(3524),
    [anon_sym_abstract] = ACTIONS(3538),
    [anon_sym_asserts] = ACTIONS(3540),
    [anon_sym_infer] = ACTIONS(3542),
    [anon_sym_keyof] = ACTIONS(3544),
    [anon_sym_unique] = ACTIONS(3546),
    [anon_sym_unknown] = ACTIONS(3524),
    [anon_sym_never] = ACTIONS(3524),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3548),
    [sym_html_comment] = ACTIONS(5),
  },
  [1043] = {
    [sym_nested_identifier] = STATE(6076),
    [sym_string] = STATE(3484),
    [sym_comment] = STATE(1043),
    [sym_formal_parameters] = STATE(5995),
    [sym_nested_type_identifier] = STATE(3366),
    [sym_asserts] = STATE(3453),
    [sym__type] = STATE(3455),
    [sym_constructor_type] = STATE(3468),
    [sym__primary_type] = STATE(3467),
    [sym_template_literal_type] = STATE(3466),
    [sym_infer_type] = STATE(3468),
    [sym_conditional_type] = STATE(3466),
    [sym_generic_type] = STATE(3466),
    [sym_type_predicate] = STATE(3453),
    [sym_type_query] = STATE(3466),
    [sym_index_type_query] = STATE(3466),
    [sym_lookup_type] = STATE(3466),
    [sym_literal_type] = STATE(3466),
    [sym__number] = STATE(3465),
    [sym_existential_type] = STATE(3466),
    [sym_flow_maybe_type] = STATE(3466),
    [sym_parenthesized_type] = STATE(3466),
    [sym_predefined_type] = STATE(3426),
    [sym_object_type] = STATE(3466),
    [sym_type_parameters] = STATE(5758),
    [sym_array_type] = STATE(3466),
    [sym_tuple_type] = STATE(3466),
    [sym_readonly_type] = STATE(3468),
    [sym_union_type] = STATE(3466),
    [sym_intersection_type] = STATE(3466),
    [sym_function_type] = STATE(3468),
    [sym_identifier] = ACTIONS(3369),
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_LBRACE] = ACTIONS(2006),
    [anon_sym_typeof] = ACTIONS(2008),
    [anon_sym_const] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(2010),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_new] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(1109),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [sym_number] = ACTIONS(2028),
    [sym_this] = ACTIONS(3373),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [sym_null] = ACTIONS(2032),
    [sym_undefined] = ACTIONS(2032),
    [anon_sym_readonly] = ACTIONS(2034),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1109),
    [anon_sym_number] = ACTIONS(1109),
    [anon_sym_boolean] = ACTIONS(1109),
    [anon_sym_string] = ACTIONS(1109),
    [anon_sym_symbol] = ACTIONS(1109),
    [anon_sym_object] = ACTIONS(1109),
    [anon_sym_abstract] = ACTIONS(1101),
    [anon_sym_asserts] = ACTIONS(3375),
    [anon_sym_infer] = ACTIONS(1103),
    [anon_sym_keyof] = ACTIONS(1105),
    [anon_sym_unique] = ACTIONS(1107),
    [anon_sym_unknown] = ACTIONS(1109),
    [anon_sym_never] = ACTIONS(1109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1111),
    [sym_html_comment] = ACTIONS(5),
  },
  [1044] = {
    [sym_nested_identifier] = STATE(6123),
    [sym_string] = STATE(3650),
    [sym_comment] = STATE(1044),
    [sym_formal_parameters] = STATE(6329),
    [sym_nested_type_identifier] = STATE(3475),
    [sym_asserts] = STATE(3632),
    [sym__type] = STATE(3634),
    [sym_constructor_type] = STATE(3735),
    [sym__primary_type] = STATE(3709),
    [sym_template_literal_type] = STATE(3706),
    [sym_infer_type] = STATE(3735),
    [sym_conditional_type] = STATE(3706),
    [sym_generic_type] = STATE(3706),
    [sym_type_predicate] = STATE(3632),
    [sym_type_query] = STATE(3706),
    [sym_index_type_query] = STATE(3706),
    [sym_lookup_type] = STATE(3706),
    [sym_literal_type] = STATE(3706),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3706),
    [sym_flow_maybe_type] = STATE(3706),
    [sym_parenthesized_type] = STATE(3706),
    [sym_predefined_type] = STATE(3538),
    [sym_object_type] = STATE(3706),
    [sym_type_parameters] = STATE(5682),
    [sym_array_type] = STATE(3706),
    [sym_tuple_type] = STATE(3706),
    [sym_readonly_type] = STATE(3735),
    [sym_union_type] = STATE(3706),
    [sym_intersection_type] = STATE(3706),
    [sym_function_type] = STATE(3735),
    [sym_identifier] = ACTIONS(3311),
    [anon_sym_STAR] = ACTIONS(3313),
    [anon_sym_LBRACE] = ACTIONS(3315),
    [anon_sym_typeof] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_LPAREN] = ACTIONS(3321),
    [anon_sym_LBRACK] = ACTIONS(3323),
    [anon_sym_DQUOTE] = ACTIONS(3325),
    [anon_sym_SQUOTE] = ACTIONS(3327),
    [anon_sym_new] = ACTIONS(3329),
    [anon_sym_AMP] = ACTIONS(3331),
    [anon_sym_PIPE] = ACTIONS(3333),
    [anon_sym_PLUS] = ACTIONS(3335),
    [anon_sym_DASH] = ACTIONS(3335),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3337),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3339),
    [sym_number] = ACTIONS(3341),
    [sym_this] = ACTIONS(3343),
    [sym_true] = ACTIONS(3345),
    [sym_false] = ACTIONS(3345),
    [sym_null] = ACTIONS(3345),
    [sym_undefined] = ACTIONS(3345),
    [anon_sym_readonly] = ACTIONS(3347),
    [anon_sym_QMARK] = ACTIONS(3349),
    [anon_sym_any] = ACTIONS(3337),
    [anon_sym_number] = ACTIONS(3337),
    [anon_sym_boolean] = ACTIONS(3337),
    [anon_sym_string] = ACTIONS(3337),
    [anon_sym_symbol] = ACTIONS(3337),
    [anon_sym_object] = ACTIONS(3337),
    [anon_sym_abstract] = ACTIONS(3351),
    [anon_sym_asserts] = ACTIONS(3353),
    [anon_sym_infer] = ACTIONS(3355),
    [anon_sym_keyof] = ACTIONS(3357),
    [anon_sym_unique] = ACTIONS(3359),
    [anon_sym_unknown] = ACTIONS(3337),
    [anon_sym_never] = ACTIONS(3337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3361),
    [sym_html_comment] = ACTIONS(5),
  },
  [1045] = {
    [sym_nested_identifier] = STATE(6066),
    [sym_string] = STATE(1759),
    [sym_comment] = STATE(1045),
    [sym_formal_parameters] = STATE(6184),
    [sym_nested_type_identifier] = STATE(1744),
    [sym_asserts] = STATE(1858),
    [sym__type] = STATE(1859),
    [sym_constructor_type] = STATE(1761),
    [sym__primary_type] = STATE(1762),
    [sym_template_literal_type] = STATE(1745),
    [sym_infer_type] = STATE(1761),
    [sym_conditional_type] = STATE(1745),
    [sym_generic_type] = STATE(1745),
    [sym_type_predicate] = STATE(1858),
    [sym_type_query] = STATE(1745),
    [sym_index_type_query] = STATE(1745),
    [sym_lookup_type] = STATE(1745),
    [sym_literal_type] = STATE(1745),
    [sym__number] = STATE(1763),
    [sym_existential_type] = STATE(1745),
    [sym_flow_maybe_type] = STATE(1745),
    [sym_parenthesized_type] = STATE(1745),
    [sym_predefined_type] = STATE(1710),
    [sym_object_type] = STATE(1745),
    [sym_type_parameters] = STATE(5724),
    [sym_array_type] = STATE(1745),
    [sym_tuple_type] = STATE(1745),
    [sym_readonly_type] = STATE(1761),
    [sym_union_type] = STATE(1745),
    [sym_intersection_type] = STATE(1745),
    [sym_function_type] = STATE(1761),
    [sym_identifier] = ACTIONS(3550),
    [anon_sym_STAR] = ACTIONS(3552),
    [anon_sym_LBRACE] = ACTIONS(3554),
    [anon_sym_typeof] = ACTIONS(3556),
    [anon_sym_const] = ACTIONS(3558),
    [anon_sym_LPAREN] = ACTIONS(3560),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(3564),
    [anon_sym_AMP] = ACTIONS(3566),
    [anon_sym_PIPE] = ACTIONS(3568),
    [anon_sym_PLUS] = ACTIONS(3570),
    [anon_sym_DASH] = ACTIONS(3570),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3572),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3574),
    [sym_number] = ACTIONS(3576),
    [sym_this] = ACTIONS(3578),
    [sym_true] = ACTIONS(3580),
    [sym_false] = ACTIONS(3580),
    [sym_null] = ACTIONS(3580),
    [sym_undefined] = ACTIONS(3580),
    [anon_sym_readonly] = ACTIONS(3582),
    [anon_sym_QMARK] = ACTIONS(3584),
    [anon_sym_any] = ACTIONS(3572),
    [anon_sym_number] = ACTIONS(3572),
    [anon_sym_boolean] = ACTIONS(3572),
    [anon_sym_string] = ACTIONS(3572),
    [anon_sym_symbol] = ACTIONS(3572),
    [anon_sym_object] = ACTIONS(3572),
    [anon_sym_abstract] = ACTIONS(3586),
    [anon_sym_asserts] = ACTIONS(3588),
    [anon_sym_infer] = ACTIONS(3590),
    [anon_sym_keyof] = ACTIONS(3592),
    [anon_sym_unique] = ACTIONS(3594),
    [anon_sym_unknown] = ACTIONS(3572),
    [anon_sym_never] = ACTIONS(3572),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3596),
    [sym_html_comment] = ACTIONS(5),
  },
  [1046] = {
    [sym_nested_identifier] = STATE(6099),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1046),
    [sym_formal_parameters] = STATE(6035),
    [sym_nested_type_identifier] = STATE(3747),
    [sym_asserts] = STATE(3209),
    [sym__type] = STATE(4137),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_predicate] = STATE(3209),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3803),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5617),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3474),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_typeof] = ACTIONS(3478),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_AMP] = ACTIONS(3482),
    [anon_sym_PIPE] = ACTIONS(3484),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(3486),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(3488),
    [anon_sym_QMARK] = ACTIONS(3490),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(3492),
    [anon_sym_asserts] = ACTIONS(3494),
    [anon_sym_infer] = ACTIONS(3496),
    [anon_sym_keyof] = ACTIONS(3498),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3500),
    [sym_html_comment] = ACTIONS(5),
  },
  [1047] = {
    [sym_nested_identifier] = STATE(6066),
    [sym_string] = STATE(1759),
    [sym_comment] = STATE(1047),
    [sym_formal_parameters] = STATE(6184),
    [sym_nested_type_identifier] = STATE(1744),
    [sym_asserts] = STATE(1811),
    [sym__type] = STATE(1812),
    [sym_constructor_type] = STATE(1761),
    [sym__primary_type] = STATE(1762),
    [sym_template_literal_type] = STATE(1745),
    [sym_infer_type] = STATE(1761),
    [sym_conditional_type] = STATE(1745),
    [sym_generic_type] = STATE(1745),
    [sym_type_predicate] = STATE(1811),
    [sym_type_query] = STATE(1745),
    [sym_index_type_query] = STATE(1745),
    [sym_lookup_type] = STATE(1745),
    [sym_literal_type] = STATE(1745),
    [sym__number] = STATE(1763),
    [sym_existential_type] = STATE(1745),
    [sym_flow_maybe_type] = STATE(1745),
    [sym_parenthesized_type] = STATE(1745),
    [sym_predefined_type] = STATE(1710),
    [sym_object_type] = STATE(1745),
    [sym_type_parameters] = STATE(5724),
    [sym_array_type] = STATE(1745),
    [sym_tuple_type] = STATE(1745),
    [sym_readonly_type] = STATE(1761),
    [sym_union_type] = STATE(1745),
    [sym_intersection_type] = STATE(1745),
    [sym_function_type] = STATE(1761),
    [sym_identifier] = ACTIONS(3550),
    [anon_sym_STAR] = ACTIONS(3552),
    [anon_sym_LBRACE] = ACTIONS(3554),
    [anon_sym_typeof] = ACTIONS(3556),
    [anon_sym_const] = ACTIONS(3558),
    [anon_sym_LPAREN] = ACTIONS(3560),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(3564),
    [anon_sym_AMP] = ACTIONS(3566),
    [anon_sym_PIPE] = ACTIONS(3568),
    [anon_sym_PLUS] = ACTIONS(3570),
    [anon_sym_DASH] = ACTIONS(3570),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3572),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3574),
    [sym_number] = ACTIONS(3576),
    [sym_this] = ACTIONS(3578),
    [sym_true] = ACTIONS(3580),
    [sym_false] = ACTIONS(3580),
    [sym_null] = ACTIONS(3580),
    [sym_undefined] = ACTIONS(3580),
    [anon_sym_readonly] = ACTIONS(3582),
    [anon_sym_QMARK] = ACTIONS(3584),
    [anon_sym_any] = ACTIONS(3572),
    [anon_sym_number] = ACTIONS(3572),
    [anon_sym_boolean] = ACTIONS(3572),
    [anon_sym_string] = ACTIONS(3572),
    [anon_sym_symbol] = ACTIONS(3572),
    [anon_sym_object] = ACTIONS(3572),
    [anon_sym_abstract] = ACTIONS(3586),
    [anon_sym_asserts] = ACTIONS(3588),
    [anon_sym_infer] = ACTIONS(3590),
    [anon_sym_keyof] = ACTIONS(3592),
    [anon_sym_unique] = ACTIONS(3594),
    [anon_sym_unknown] = ACTIONS(3572),
    [anon_sym_never] = ACTIONS(3572),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3596),
    [sym_html_comment] = ACTIONS(5),
  },
  [1048] = {
    [sym_nested_identifier] = STATE(6076),
    [sym_string] = STATE(3484),
    [sym_comment] = STATE(1048),
    [sym_formal_parameters] = STATE(5995),
    [sym_nested_type_identifier] = STATE(3366),
    [sym_asserts] = STATE(3496),
    [sym__type] = STATE(3503),
    [sym_constructor_type] = STATE(3468),
    [sym__primary_type] = STATE(3467),
    [sym_template_literal_type] = STATE(3466),
    [sym_infer_type] = STATE(3468),
    [sym_conditional_type] = STATE(3466),
    [sym_generic_type] = STATE(3466),
    [sym_type_predicate] = STATE(3496),
    [sym_type_query] = STATE(3466),
    [sym_index_type_query] = STATE(3466),
    [sym_lookup_type] = STATE(3466),
    [sym_literal_type] = STATE(3466),
    [sym__number] = STATE(3465),
    [sym_existential_type] = STATE(3466),
    [sym_flow_maybe_type] = STATE(3466),
    [sym_parenthesized_type] = STATE(3466),
    [sym_predefined_type] = STATE(3426),
    [sym_object_type] = STATE(3466),
    [sym_type_parameters] = STATE(5758),
    [sym_array_type] = STATE(3466),
    [sym_tuple_type] = STATE(3466),
    [sym_readonly_type] = STATE(3468),
    [sym_union_type] = STATE(3466),
    [sym_intersection_type] = STATE(3466),
    [sym_function_type] = STATE(3468),
    [sym_identifier] = ACTIONS(3369),
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_LBRACE] = ACTIONS(2006),
    [anon_sym_typeof] = ACTIONS(2008),
    [anon_sym_const] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(2010),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_new] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(1109),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [sym_number] = ACTIONS(2028),
    [sym_this] = ACTIONS(3373),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [sym_null] = ACTIONS(2032),
    [sym_undefined] = ACTIONS(2032),
    [anon_sym_readonly] = ACTIONS(2034),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1109),
    [anon_sym_number] = ACTIONS(1109),
    [anon_sym_boolean] = ACTIONS(1109),
    [anon_sym_string] = ACTIONS(1109),
    [anon_sym_symbol] = ACTIONS(1109),
    [anon_sym_object] = ACTIONS(1109),
    [anon_sym_abstract] = ACTIONS(1101),
    [anon_sym_asserts] = ACTIONS(3375),
    [anon_sym_infer] = ACTIONS(1103),
    [anon_sym_keyof] = ACTIONS(1105),
    [anon_sym_unique] = ACTIONS(1107),
    [anon_sym_unknown] = ACTIONS(1109),
    [anon_sym_never] = ACTIONS(1109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1111),
    [sym_html_comment] = ACTIONS(5),
  },
  [1049] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1049),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym_asserts] = STATE(3209),
    [sym__type] = STATE(3331),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_predicate] = STATE(3209),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3208),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3363),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(3365),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_asserts] = ACTIONS(3367),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1050] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1050),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym_asserts] = STATE(3278),
    [sym__type] = STATE(3296),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_predicate] = STATE(3278),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3208),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3363),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(3365),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_asserts] = ACTIONS(3367),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1051] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1051),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4809),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_RBRACK] = ACTIONS(3598),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1052] = {
    [sym_variable_declarator] = STATE(4750),
    [sym_object_pattern] = STATE(3973),
    [sym_array_pattern] = STATE(3973),
    [sym__destructuring_pattern] = STATE(3972),
    [sym_comment] = STATE(1052),
    [aux_sym_object_repeat1] = STATE(4915),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(3600),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_LBRACE] = ACTIONS(3602),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(754),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [1053] = {
    [sym_variable_declarator] = STATE(4750),
    [sym_object_pattern] = STATE(3973),
    [sym_array_pattern] = STATE(3973),
    [sym__destructuring_pattern] = STATE(3972),
    [sym_comment] = STATE(1053),
    [aux_sym_object_repeat1] = STATE(4915),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(3600),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_LBRACE] = ACTIONS(3602),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [1054] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1054),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4841),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_RBRACK] = ACTIONS(3606),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1055] = {
    [sym_nested_identifier] = STATE(755),
    [sym_string] = STATE(760),
    [sym_comment] = STATE(1055),
    [sym__module] = STATE(818),
    [aux_sym_object_repeat1] = STATE(4915),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(3608),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(754),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_DQUOTE] = ACTIONS(3610),
    [anon_sym_SQUOTE] = ACTIONS(3612),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [1056] = {
    [sym_nested_identifier] = STATE(226),
    [sym_string] = STATE(227),
    [sym_comment] = STATE(1056),
    [sym__module] = STATE(229),
    [aux_sym_object_repeat1] = STATE(4915),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(3614),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_DQUOTE] = ACTIONS(3616),
    [anon_sym_SQUOTE] = ACTIONS(3618),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [1057] = {
    [sym_variable_declarator] = STATE(4750),
    [sym_object_pattern] = STATE(3973),
    [sym_array_pattern] = STATE(3973),
    [sym__destructuring_pattern] = STATE(3972),
    [sym_comment] = STATE(1057),
    [aux_sym_object_repeat1] = STATE(4915),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(3600),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_LBRACE] = ACTIONS(3602),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [1058] = {
    [sym_nested_identifier] = STATE(226),
    [sym_string] = STATE(227),
    [sym_comment] = STATE(1058),
    [sym__module] = STATE(229),
    [aux_sym_object_repeat1] = STATE(5251),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(3614),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_DQUOTE] = ACTIONS(3616),
    [anon_sym_SQUOTE] = ACTIONS(3618),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [1059] = {
    [sym_variable_declarator] = STATE(4750),
    [sym_object_pattern] = STATE(3973),
    [sym_array_pattern] = STATE(3973),
    [sym__destructuring_pattern] = STATE(3972),
    [sym_comment] = STATE(1059),
    [aux_sym_object_repeat1] = STATE(5251),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(3600),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_LBRACE] = ACTIONS(3602),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [1060] = {
    [sym_nested_identifier] = STATE(226),
    [sym_string] = STATE(227),
    [sym_comment] = STATE(1060),
    [sym__module] = STATE(229),
    [aux_sym_object_repeat1] = STATE(4915),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(3614),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_DQUOTE] = ACTIONS(3616),
    [anon_sym_SQUOTE] = ACTIONS(3618),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [1061] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1061),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4700),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_RBRACK] = ACTIONS(3620),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1062] = {
    [sym_nested_identifier] = STATE(755),
    [sym_string] = STATE(760),
    [sym_comment] = STATE(1062),
    [sym__module] = STATE(818),
    [aux_sym_object_repeat1] = STATE(5251),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(3608),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_DQUOTE] = ACTIONS(3610),
    [anon_sym_SQUOTE] = ACTIONS(3612),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [1063] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1063),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4722),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_RBRACK] = ACTIONS(3622),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1064] = {
    [sym_nested_identifier] = STATE(755),
    [sym_string] = STATE(760),
    [sym_comment] = STATE(1064),
    [sym__module] = STATE(818),
    [aux_sym_object_repeat1] = STATE(4915),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(3608),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_DQUOTE] = ACTIONS(3610),
    [anon_sym_SQUOTE] = ACTIONS(3612),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [1065] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1065),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4718),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_RBRACK] = ACTIONS(3624),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1066] = {
    [sym_nested_identifier] = STATE(755),
    [sym_string] = STATE(760),
    [sym_comment] = STATE(1066),
    [sym__module] = STATE(818),
    [aux_sym_object_repeat1] = STATE(4915),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(3608),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_DQUOTE] = ACTIONS(3610),
    [anon_sym_SQUOTE] = ACTIONS(3612),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [1067] = {
    [sym_nested_identifier] = STATE(226),
    [sym_string] = STATE(227),
    [sym_comment] = STATE(1067),
    [sym__module] = STATE(229),
    [aux_sym_object_repeat1] = STATE(4915),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(3614),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(754),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_DQUOTE] = ACTIONS(3616),
    [anon_sym_SQUOTE] = ACTIONS(3618),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [1068] = {
    [sym_nested_identifier] = STATE(5958),
    [sym_string] = STATE(2307),
    [sym_comment] = STATE(1068),
    [sym_formal_parameters] = STATE(6100),
    [sym_nested_type_identifier] = STATE(2121),
    [sym__type] = STATE(2407),
    [sym_constructor_type] = STATE(2353),
    [sym__primary_type] = STATE(2401),
    [sym_template_literal_type] = STATE(2397),
    [sym_infer_type] = STATE(2353),
    [sym_conditional_type] = STATE(2397),
    [sym_generic_type] = STATE(2397),
    [sym_type_query] = STATE(2397),
    [sym_index_type_query] = STATE(2397),
    [sym_lookup_type] = STATE(2397),
    [sym_literal_type] = STATE(2397),
    [sym__number] = STATE(2309),
    [sym_existential_type] = STATE(2397),
    [sym_flow_maybe_type] = STATE(2397),
    [sym_parenthesized_type] = STATE(2397),
    [sym_predefined_type] = STATE(2397),
    [sym_object_type] = STATE(2397),
    [sym_type_parameters] = STATE(5861),
    [sym_array_type] = STATE(2397),
    [sym_tuple_type] = STATE(2397),
    [sym_readonly_type] = STATE(2353),
    [sym_union_type] = STATE(2397),
    [sym_intersection_type] = STATE(2397),
    [sym_function_type] = STATE(2353),
    [sym_identifier] = ACTIONS(3626),
    [anon_sym_STAR] = ACTIONS(3504),
    [anon_sym_LBRACE] = ACTIONS(3506),
    [anon_sym_typeof] = ACTIONS(3508),
    [anon_sym_const] = ACTIONS(3510),
    [anon_sym_LPAREN] = ACTIONS(3512),
    [anon_sym_LBRACK] = ACTIONS(3514),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_new] = ACTIONS(3516),
    [anon_sym_AMP] = ACTIONS(3518),
    [anon_sym_PIPE] = ACTIONS(3520),
    [anon_sym_PLUS] = ACTIONS(3522),
    [anon_sym_DASH] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3524),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3526),
    [sym_number] = ACTIONS(3528),
    [sym_this] = ACTIONS(3628),
    [sym_true] = ACTIONS(3532),
    [sym_false] = ACTIONS(3532),
    [sym_null] = ACTIONS(3532),
    [sym_undefined] = ACTIONS(3532),
    [anon_sym_readonly] = ACTIONS(3534),
    [anon_sym_QMARK] = ACTIONS(3536),
    [anon_sym_any] = ACTIONS(3524),
    [anon_sym_number] = ACTIONS(3524),
    [anon_sym_boolean] = ACTIONS(3524),
    [anon_sym_string] = ACTIONS(3524),
    [anon_sym_symbol] = ACTIONS(3524),
    [anon_sym_object] = ACTIONS(3524),
    [anon_sym_abstract] = ACTIONS(3538),
    [anon_sym_infer] = ACTIONS(3542),
    [anon_sym_keyof] = ACTIONS(3544),
    [anon_sym_unique] = ACTIONS(3546),
    [anon_sym_unknown] = ACTIONS(3524),
    [anon_sym_never] = ACTIONS(3524),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3548),
    [sym_html_comment] = ACTIONS(5),
  },
  [1069] = {
    [sym_nested_identifier] = STATE(6066),
    [sym_string] = STATE(1759),
    [sym_comment] = STATE(1069),
    [sym_formal_parameters] = STATE(6184),
    [sym_nested_type_identifier] = STATE(1744),
    [sym__type] = STATE(1908),
    [sym_constructor_type] = STATE(1761),
    [sym__primary_type] = STATE(1762),
    [sym_template_literal_type] = STATE(1745),
    [sym_infer_type] = STATE(1761),
    [sym_conditional_type] = STATE(1745),
    [sym_generic_type] = STATE(1745),
    [sym_type_query] = STATE(1745),
    [sym_index_type_query] = STATE(1745),
    [sym_lookup_type] = STATE(1745),
    [sym_literal_type] = STATE(1745),
    [sym__number] = STATE(1763),
    [sym_existential_type] = STATE(1745),
    [sym_flow_maybe_type] = STATE(1745),
    [sym_parenthesized_type] = STATE(1745),
    [sym_predefined_type] = STATE(1745),
    [sym_object_type] = STATE(1745),
    [sym_type_parameters] = STATE(5724),
    [sym_array_type] = STATE(1745),
    [sym_tuple_type] = STATE(1745),
    [sym_readonly_type] = STATE(1761),
    [sym_union_type] = STATE(1745),
    [sym_intersection_type] = STATE(1745),
    [sym_function_type] = STATE(1761),
    [sym_identifier] = ACTIONS(3630),
    [anon_sym_STAR] = ACTIONS(3552),
    [anon_sym_LBRACE] = ACTIONS(3554),
    [anon_sym_typeof] = ACTIONS(3556),
    [anon_sym_const] = ACTIONS(3558),
    [anon_sym_LPAREN] = ACTIONS(3560),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(3564),
    [anon_sym_AMP] = ACTIONS(3566),
    [anon_sym_PIPE] = ACTIONS(3568),
    [anon_sym_PLUS] = ACTIONS(3570),
    [anon_sym_DASH] = ACTIONS(3570),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3572),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3574),
    [sym_number] = ACTIONS(3576),
    [sym_this] = ACTIONS(3632),
    [sym_true] = ACTIONS(3580),
    [sym_false] = ACTIONS(3580),
    [sym_null] = ACTIONS(3580),
    [sym_undefined] = ACTIONS(3580),
    [anon_sym_readonly] = ACTIONS(3582),
    [anon_sym_QMARK] = ACTIONS(3584),
    [anon_sym_any] = ACTIONS(3572),
    [anon_sym_number] = ACTIONS(3572),
    [anon_sym_boolean] = ACTIONS(3572),
    [anon_sym_string] = ACTIONS(3572),
    [anon_sym_symbol] = ACTIONS(3572),
    [anon_sym_object] = ACTIONS(3572),
    [anon_sym_abstract] = ACTIONS(3586),
    [anon_sym_infer] = ACTIONS(3590),
    [anon_sym_keyof] = ACTIONS(3592),
    [anon_sym_unique] = ACTIONS(3594),
    [anon_sym_unknown] = ACTIONS(3572),
    [anon_sym_never] = ACTIONS(3572),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3596),
    [sym_html_comment] = ACTIONS(5),
  },
  [1070] = {
    [sym_nested_identifier] = STATE(6076),
    [sym_string] = STATE(3484),
    [sym_comment] = STATE(1070),
    [sym_formal_parameters] = STATE(5995),
    [sym_nested_type_identifier] = STATE(3366),
    [sym__type] = STATE(3485),
    [sym_constructor_type] = STATE(3468),
    [sym__primary_type] = STATE(3467),
    [sym_template_literal_type] = STATE(3466),
    [sym_infer_type] = STATE(3468),
    [sym_conditional_type] = STATE(3466),
    [sym_generic_type] = STATE(3466),
    [sym_type_query] = STATE(3466),
    [sym_index_type_query] = STATE(3466),
    [sym_lookup_type] = STATE(3466),
    [sym_literal_type] = STATE(3466),
    [sym__number] = STATE(3465),
    [sym_existential_type] = STATE(3466),
    [sym_flow_maybe_type] = STATE(3466),
    [sym_parenthesized_type] = STATE(3466),
    [sym_predefined_type] = STATE(3466),
    [sym_object_type] = STATE(3466),
    [sym_type_parameters] = STATE(5758),
    [sym_array_type] = STATE(3466),
    [sym_tuple_type] = STATE(3466),
    [sym_readonly_type] = STATE(3468),
    [sym_union_type] = STATE(3466),
    [sym_intersection_type] = STATE(3466),
    [sym_function_type] = STATE(3468),
    [sym_identifier] = ACTIONS(2002),
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_LBRACE] = ACTIONS(2006),
    [anon_sym_typeof] = ACTIONS(2008),
    [anon_sym_const] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(2010),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_new] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(1109),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [sym_number] = ACTIONS(2028),
    [sym_this] = ACTIONS(2030),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [sym_null] = ACTIONS(2032),
    [sym_undefined] = ACTIONS(2032),
    [anon_sym_readonly] = ACTIONS(2034),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1109),
    [anon_sym_number] = ACTIONS(1109),
    [anon_sym_boolean] = ACTIONS(1109),
    [anon_sym_string] = ACTIONS(1109),
    [anon_sym_symbol] = ACTIONS(1109),
    [anon_sym_object] = ACTIONS(1109),
    [anon_sym_abstract] = ACTIONS(1101),
    [anon_sym_infer] = ACTIONS(1103),
    [anon_sym_keyof] = ACTIONS(1105),
    [anon_sym_unique] = ACTIONS(1107),
    [anon_sym_unknown] = ACTIONS(1109),
    [anon_sym_never] = ACTIONS(1109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1111),
    [sym_html_comment] = ACTIONS(5),
  },
  [1071] = {
    [sym_nested_identifier] = STATE(6123),
    [sym_string] = STATE(3650),
    [sym_comment] = STATE(1071),
    [sym_formal_parameters] = STATE(6329),
    [sym_nested_type_identifier] = STATE(3475),
    [sym__type] = STATE(3622),
    [sym_constructor_type] = STATE(3735),
    [sym__primary_type] = STATE(3709),
    [sym_template_literal_type] = STATE(3706),
    [sym_infer_type] = STATE(3735),
    [sym_conditional_type] = STATE(3706),
    [sym_generic_type] = STATE(3706),
    [sym_type_query] = STATE(3706),
    [sym_index_type_query] = STATE(3706),
    [sym_lookup_type] = STATE(3706),
    [sym_literal_type] = STATE(3706),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3706),
    [sym_flow_maybe_type] = STATE(3706),
    [sym_parenthesized_type] = STATE(3706),
    [sym_predefined_type] = STATE(3706),
    [sym_object_type] = STATE(3706),
    [sym_type_parameters] = STATE(5682),
    [sym_array_type] = STATE(3706),
    [sym_tuple_type] = STATE(3706),
    [sym_readonly_type] = STATE(3735),
    [sym_union_type] = STATE(3706),
    [sym_intersection_type] = STATE(3706),
    [sym_function_type] = STATE(3735),
    [sym_identifier] = ACTIONS(3634),
    [anon_sym_STAR] = ACTIONS(3313),
    [anon_sym_LBRACE] = ACTIONS(3315),
    [anon_sym_typeof] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_LPAREN] = ACTIONS(3321),
    [anon_sym_LBRACK] = ACTIONS(3323),
    [anon_sym_DQUOTE] = ACTIONS(3325),
    [anon_sym_SQUOTE] = ACTIONS(3327),
    [anon_sym_new] = ACTIONS(3329),
    [anon_sym_AMP] = ACTIONS(3331),
    [anon_sym_PIPE] = ACTIONS(3333),
    [anon_sym_PLUS] = ACTIONS(3335),
    [anon_sym_DASH] = ACTIONS(3335),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3337),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3339),
    [sym_number] = ACTIONS(3341),
    [sym_this] = ACTIONS(3636),
    [sym_true] = ACTIONS(3345),
    [sym_false] = ACTIONS(3345),
    [sym_null] = ACTIONS(3345),
    [sym_undefined] = ACTIONS(3345),
    [anon_sym_readonly] = ACTIONS(3347),
    [anon_sym_QMARK] = ACTIONS(3349),
    [anon_sym_any] = ACTIONS(3337),
    [anon_sym_number] = ACTIONS(3337),
    [anon_sym_boolean] = ACTIONS(3337),
    [anon_sym_string] = ACTIONS(3337),
    [anon_sym_symbol] = ACTIONS(3337),
    [anon_sym_object] = ACTIONS(3337),
    [anon_sym_abstract] = ACTIONS(3351),
    [anon_sym_infer] = ACTIONS(3355),
    [anon_sym_keyof] = ACTIONS(3357),
    [anon_sym_unique] = ACTIONS(3359),
    [anon_sym_unknown] = ACTIONS(3337),
    [anon_sym_never] = ACTIONS(3337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3361),
    [sym_html_comment] = ACTIONS(5),
  },
  [1072] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1072),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4112),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1073] = {
    [sym_nested_identifier] = STATE(6076),
    [sym_string] = STATE(3484),
    [sym_comment] = STATE(1073),
    [sym_formal_parameters] = STATE(5995),
    [sym_nested_type_identifier] = STATE(3366),
    [sym__type] = STATE(3477),
    [sym_constructor_type] = STATE(3468),
    [sym__primary_type] = STATE(3467),
    [sym_template_literal_type] = STATE(3466),
    [sym_infer_type] = STATE(3468),
    [sym_conditional_type] = STATE(3466),
    [sym_generic_type] = STATE(3466),
    [sym_type_query] = STATE(3466),
    [sym_index_type_query] = STATE(3466),
    [sym_lookup_type] = STATE(3466),
    [sym_literal_type] = STATE(3466),
    [sym__number] = STATE(3465),
    [sym_existential_type] = STATE(3466),
    [sym_flow_maybe_type] = STATE(3466),
    [sym_parenthesized_type] = STATE(3466),
    [sym_predefined_type] = STATE(3466),
    [sym_object_type] = STATE(3466),
    [sym_type_parameters] = STATE(5758),
    [sym_array_type] = STATE(3466),
    [sym_tuple_type] = STATE(3466),
    [sym_readonly_type] = STATE(3468),
    [sym_union_type] = STATE(3466),
    [sym_intersection_type] = STATE(3466),
    [sym_function_type] = STATE(3468),
    [sym_identifier] = ACTIONS(2002),
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_LBRACE] = ACTIONS(2006),
    [anon_sym_typeof] = ACTIONS(2008),
    [anon_sym_const] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(2010),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_new] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(1109),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [sym_number] = ACTIONS(2028),
    [sym_this] = ACTIONS(2030),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [sym_null] = ACTIONS(2032),
    [sym_undefined] = ACTIONS(2032),
    [anon_sym_readonly] = ACTIONS(2034),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1109),
    [anon_sym_number] = ACTIONS(1109),
    [anon_sym_boolean] = ACTIONS(1109),
    [anon_sym_string] = ACTIONS(1109),
    [anon_sym_symbol] = ACTIONS(1109),
    [anon_sym_object] = ACTIONS(1109),
    [anon_sym_abstract] = ACTIONS(1101),
    [anon_sym_infer] = ACTIONS(1103),
    [anon_sym_keyof] = ACTIONS(1105),
    [anon_sym_unique] = ACTIONS(1107),
    [anon_sym_unknown] = ACTIONS(1109),
    [anon_sym_never] = ACTIONS(1109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1111),
    [sym_html_comment] = ACTIONS(5),
  },
  [1074] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1074),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4469),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1075] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1075),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(5189),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(4464),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(4834),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1076] = {
    [sym_nested_identifier] = STATE(6123),
    [sym_string] = STATE(3650),
    [sym_comment] = STATE(1076),
    [sym_formal_parameters] = STATE(6329),
    [sym_nested_type_identifier] = STATE(3475),
    [sym__type] = STATE(3653),
    [sym_constructor_type] = STATE(3735),
    [sym__primary_type] = STATE(3709),
    [sym_template_literal_type] = STATE(3706),
    [sym_infer_type] = STATE(3735),
    [sym_conditional_type] = STATE(3706),
    [sym_generic_type] = STATE(3706),
    [sym_type_query] = STATE(3706),
    [sym_index_type_query] = STATE(3706),
    [sym_lookup_type] = STATE(3706),
    [sym_literal_type] = STATE(3706),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3706),
    [sym_flow_maybe_type] = STATE(3706),
    [sym_parenthesized_type] = STATE(3706),
    [sym_predefined_type] = STATE(3706),
    [sym_object_type] = STATE(3706),
    [sym_type_parameters] = STATE(5682),
    [sym_array_type] = STATE(3706),
    [sym_tuple_type] = STATE(3706),
    [sym_readonly_type] = STATE(3735),
    [sym_union_type] = STATE(3706),
    [sym_intersection_type] = STATE(3706),
    [sym_function_type] = STATE(3735),
    [sym_identifier] = ACTIONS(3634),
    [anon_sym_STAR] = ACTIONS(3313),
    [anon_sym_LBRACE] = ACTIONS(3315),
    [anon_sym_typeof] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_LPAREN] = ACTIONS(3321),
    [anon_sym_LBRACK] = ACTIONS(3323),
    [anon_sym_DQUOTE] = ACTIONS(3325),
    [anon_sym_SQUOTE] = ACTIONS(3327),
    [anon_sym_new] = ACTIONS(3329),
    [anon_sym_AMP] = ACTIONS(3331),
    [anon_sym_PIPE] = ACTIONS(3333),
    [anon_sym_PLUS] = ACTIONS(3335),
    [anon_sym_DASH] = ACTIONS(3335),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3337),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3339),
    [sym_number] = ACTIONS(3341),
    [sym_this] = ACTIONS(3636),
    [sym_true] = ACTIONS(3345),
    [sym_false] = ACTIONS(3345),
    [sym_null] = ACTIONS(3345),
    [sym_undefined] = ACTIONS(3345),
    [anon_sym_readonly] = ACTIONS(3347),
    [anon_sym_QMARK] = ACTIONS(3349),
    [anon_sym_any] = ACTIONS(3337),
    [anon_sym_number] = ACTIONS(3337),
    [anon_sym_boolean] = ACTIONS(3337),
    [anon_sym_string] = ACTIONS(3337),
    [anon_sym_symbol] = ACTIONS(3337),
    [anon_sym_object] = ACTIONS(3337),
    [anon_sym_abstract] = ACTIONS(3351),
    [anon_sym_infer] = ACTIONS(3355),
    [anon_sym_keyof] = ACTIONS(3357),
    [anon_sym_unique] = ACTIONS(3359),
    [anon_sym_unknown] = ACTIONS(3337),
    [anon_sym_never] = ACTIONS(3337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3361),
    [sym_html_comment] = ACTIONS(5),
  },
  [1077] = {
    [sym_nested_identifier] = STATE(6099),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1077),
    [sym_formal_parameters] = STATE(6035),
    [sym_nested_type_identifier] = STATE(3747),
    [sym__type] = STATE(4135),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5617),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3638),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_typeof] = ACTIONS(3478),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_AMP] = ACTIONS(3482),
    [anon_sym_PIPE] = ACTIONS(3484),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(3488),
    [anon_sym_QMARK] = ACTIONS(3490),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(3492),
    [anon_sym_infer] = ACTIONS(3496),
    [anon_sym_keyof] = ACTIONS(3498),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3500),
    [sym_html_comment] = ACTIONS(5),
  },
  [1078] = {
    [sym_nested_identifier] = STATE(6099),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1078),
    [sym_formal_parameters] = STATE(6035),
    [sym_nested_type_identifier] = STATE(3747),
    [sym__type] = STATE(4138),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5617),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3638),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_typeof] = ACTIONS(3478),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_AMP] = ACTIONS(3482),
    [anon_sym_PIPE] = ACTIONS(3484),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(3488),
    [anon_sym_QMARK] = ACTIONS(3490),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(3492),
    [anon_sym_infer] = ACTIONS(3496),
    [anon_sym_keyof] = ACTIONS(3498),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3500),
    [sym_html_comment] = ACTIONS(5),
  },
  [1079] = {
    [sym_nested_identifier] = STATE(6099),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1079),
    [sym_formal_parameters] = STATE(6035),
    [sym_nested_type_identifier] = STATE(3747),
    [sym__type] = STATE(3229),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5617),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3638),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_typeof] = ACTIONS(3478),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_AMP] = ACTIONS(3482),
    [anon_sym_PIPE] = ACTIONS(3484),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(3488),
    [anon_sym_QMARK] = ACTIONS(3490),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(3492),
    [anon_sym_infer] = ACTIONS(3496),
    [anon_sym_keyof] = ACTIONS(3498),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3500),
    [sym_html_comment] = ACTIONS(5),
  },
  [1080] = {
    [sym_nested_identifier] = STATE(6099),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1080),
    [sym_formal_parameters] = STATE(6035),
    [sym_nested_type_identifier] = STATE(3747),
    [sym__type] = STATE(4136),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5617),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3638),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_typeof] = ACTIONS(3478),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_AMP] = ACTIONS(3482),
    [anon_sym_PIPE] = ACTIONS(3484),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(3488),
    [anon_sym_QMARK] = ACTIONS(3490),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(3492),
    [anon_sym_infer] = ACTIONS(3496),
    [anon_sym_keyof] = ACTIONS(3498),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3500),
    [sym_html_comment] = ACTIONS(5),
  },
  [1081] = {
    [sym_nested_identifier] = STATE(6066),
    [sym_string] = STATE(1759),
    [sym_comment] = STATE(1081),
    [sym_formal_parameters] = STATE(6184),
    [sym_nested_type_identifier] = STATE(1744),
    [sym__type] = STATE(1819),
    [sym_constructor_type] = STATE(1761),
    [sym__primary_type] = STATE(1762),
    [sym_template_literal_type] = STATE(1745),
    [sym_infer_type] = STATE(1761),
    [sym_conditional_type] = STATE(1745),
    [sym_generic_type] = STATE(1745),
    [sym_type_query] = STATE(1745),
    [sym_index_type_query] = STATE(1745),
    [sym_lookup_type] = STATE(1745),
    [sym_literal_type] = STATE(1745),
    [sym__number] = STATE(1763),
    [sym_existential_type] = STATE(1745),
    [sym_flow_maybe_type] = STATE(1745),
    [sym_parenthesized_type] = STATE(1745),
    [sym_predefined_type] = STATE(1745),
    [sym_object_type] = STATE(1745),
    [sym_type_parameters] = STATE(5724),
    [sym_array_type] = STATE(1745),
    [sym_tuple_type] = STATE(1745),
    [sym_readonly_type] = STATE(1761),
    [sym_union_type] = STATE(1745),
    [sym_intersection_type] = STATE(1745),
    [sym_function_type] = STATE(1761),
    [sym_identifier] = ACTIONS(3630),
    [anon_sym_STAR] = ACTIONS(3552),
    [anon_sym_LBRACE] = ACTIONS(3554),
    [anon_sym_typeof] = ACTIONS(3556),
    [anon_sym_const] = ACTIONS(3558),
    [anon_sym_LPAREN] = ACTIONS(3560),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(3564),
    [anon_sym_AMP] = ACTIONS(3566),
    [anon_sym_PIPE] = ACTIONS(3568),
    [anon_sym_PLUS] = ACTIONS(3570),
    [anon_sym_DASH] = ACTIONS(3570),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3572),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3574),
    [sym_number] = ACTIONS(3576),
    [sym_this] = ACTIONS(3632),
    [sym_true] = ACTIONS(3580),
    [sym_false] = ACTIONS(3580),
    [sym_null] = ACTIONS(3580),
    [sym_undefined] = ACTIONS(3580),
    [anon_sym_readonly] = ACTIONS(3582),
    [anon_sym_QMARK] = ACTIONS(3584),
    [anon_sym_any] = ACTIONS(3572),
    [anon_sym_number] = ACTIONS(3572),
    [anon_sym_boolean] = ACTIONS(3572),
    [anon_sym_string] = ACTIONS(3572),
    [anon_sym_symbol] = ACTIONS(3572),
    [anon_sym_object] = ACTIONS(3572),
    [anon_sym_abstract] = ACTIONS(3586),
    [anon_sym_infer] = ACTIONS(3590),
    [anon_sym_keyof] = ACTIONS(3592),
    [anon_sym_unique] = ACTIONS(3594),
    [anon_sym_unknown] = ACTIONS(3572),
    [anon_sym_never] = ACTIONS(3572),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3596),
    [sym_html_comment] = ACTIONS(5),
  },
  [1082] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1082),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4697),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1083] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1083),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4703),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1084] = {
    [sym_nested_identifier] = STATE(6066),
    [sym_string] = STATE(1759),
    [sym_comment] = STATE(1084),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(1744),
    [sym__type] = STATE(5318),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(1781),
    [sym_template_literal_type] = STATE(1745),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(1745),
    [sym_generic_type] = STATE(1745),
    [sym_type_query] = STATE(1745),
    [sym_index_type_query] = STATE(1745),
    [sym_lookup_type] = STATE(1745),
    [sym_literal_type] = STATE(1745),
    [sym__number] = STATE(1763),
    [sym_existential_type] = STATE(1745),
    [sym_flow_maybe_type] = STATE(1745),
    [sym_parenthesized_type] = STATE(1745),
    [sym_predefined_type] = STATE(1745),
    [sym_object_type] = STATE(1745),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(1745),
    [sym_tuple_type] = STATE(1745),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(1745),
    [sym_intersection_type] = STATE(1745),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3630),
    [anon_sym_STAR] = ACTIONS(3552),
    [anon_sym_LBRACE] = ACTIONS(3554),
    [anon_sym_typeof] = ACTIONS(3556),
    [anon_sym_const] = ACTIONS(3558),
    [anon_sym_LPAREN] = ACTIONS(3560),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(3566),
    [anon_sym_PIPE] = ACTIONS(3568),
    [anon_sym_PLUS] = ACTIONS(3570),
    [anon_sym_DASH] = ACTIONS(3570),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3572),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3574),
    [sym_number] = ACTIONS(3576),
    [sym_this] = ACTIONS(3632),
    [sym_true] = ACTIONS(3580),
    [sym_false] = ACTIONS(3580),
    [sym_null] = ACTIONS(3580),
    [sym_undefined] = ACTIONS(3580),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(3584),
    [anon_sym_any] = ACTIONS(3572),
    [anon_sym_number] = ACTIONS(3572),
    [anon_sym_boolean] = ACTIONS(3572),
    [anon_sym_string] = ACTIONS(3572),
    [anon_sym_symbol] = ACTIONS(3572),
    [anon_sym_object] = ACTIONS(3572),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(3592),
    [anon_sym_unique] = ACTIONS(3594),
    [anon_sym_unknown] = ACTIONS(3572),
    [anon_sym_never] = ACTIONS(3572),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3596),
    [sym_html_comment] = ACTIONS(5),
  },
  [1085] = {
    [sym_nested_identifier] = STATE(6066),
    [sym_string] = STATE(1759),
    [sym_comment] = STATE(1085),
    [sym_formal_parameters] = STATE(6184),
    [sym_nested_type_identifier] = STATE(1744),
    [sym__type] = STATE(1818),
    [sym_constructor_type] = STATE(1761),
    [sym__primary_type] = STATE(1762),
    [sym_template_literal_type] = STATE(1745),
    [sym_infer_type] = STATE(1761),
    [sym_conditional_type] = STATE(1745),
    [sym_generic_type] = STATE(1745),
    [sym_type_query] = STATE(1745),
    [sym_index_type_query] = STATE(1745),
    [sym_lookup_type] = STATE(1745),
    [sym_literal_type] = STATE(1745),
    [sym__number] = STATE(1763),
    [sym_existential_type] = STATE(1745),
    [sym_flow_maybe_type] = STATE(1745),
    [sym_parenthesized_type] = STATE(1745),
    [sym_predefined_type] = STATE(1745),
    [sym_object_type] = STATE(1745),
    [sym_type_parameters] = STATE(5724),
    [sym_array_type] = STATE(1745),
    [sym_tuple_type] = STATE(1745),
    [sym_readonly_type] = STATE(1761),
    [sym_union_type] = STATE(1745),
    [sym_intersection_type] = STATE(1745),
    [sym_function_type] = STATE(1761),
    [sym_identifier] = ACTIONS(3630),
    [anon_sym_STAR] = ACTIONS(3552),
    [anon_sym_LBRACE] = ACTIONS(3554),
    [anon_sym_typeof] = ACTIONS(3556),
    [anon_sym_const] = ACTIONS(3558),
    [anon_sym_LPAREN] = ACTIONS(3560),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(3564),
    [anon_sym_AMP] = ACTIONS(3566),
    [anon_sym_PIPE] = ACTIONS(3568),
    [anon_sym_PLUS] = ACTIONS(3570),
    [anon_sym_DASH] = ACTIONS(3570),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3572),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3574),
    [sym_number] = ACTIONS(3576),
    [sym_this] = ACTIONS(3632),
    [sym_true] = ACTIONS(3580),
    [sym_false] = ACTIONS(3580),
    [sym_null] = ACTIONS(3580),
    [sym_undefined] = ACTIONS(3580),
    [anon_sym_readonly] = ACTIONS(3582),
    [anon_sym_QMARK] = ACTIONS(3584),
    [anon_sym_any] = ACTIONS(3572),
    [anon_sym_number] = ACTIONS(3572),
    [anon_sym_boolean] = ACTIONS(3572),
    [anon_sym_string] = ACTIONS(3572),
    [anon_sym_symbol] = ACTIONS(3572),
    [anon_sym_object] = ACTIONS(3572),
    [anon_sym_abstract] = ACTIONS(3586),
    [anon_sym_infer] = ACTIONS(3590),
    [anon_sym_keyof] = ACTIONS(3592),
    [anon_sym_unique] = ACTIONS(3594),
    [anon_sym_unknown] = ACTIONS(3572),
    [anon_sym_never] = ACTIONS(3572),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3596),
    [sym_html_comment] = ACTIONS(5),
  },
  [1086] = {
    [sym_nested_identifier] = STATE(6076),
    [sym_string] = STATE(3484),
    [sym_comment] = STATE(1086),
    [sym_formal_parameters] = STATE(5995),
    [sym_nested_type_identifier] = STATE(3366),
    [sym__type] = STATE(4366),
    [sym_constructor_type] = STATE(3468),
    [sym__primary_type] = STATE(3467),
    [sym_template_literal_type] = STATE(3466),
    [sym_infer_type] = STATE(3468),
    [sym_conditional_type] = STATE(3466),
    [sym_generic_type] = STATE(3466),
    [sym_type_query] = STATE(3466),
    [sym_index_type_query] = STATE(3466),
    [sym_lookup_type] = STATE(3466),
    [sym_literal_type] = STATE(3466),
    [sym__number] = STATE(3465),
    [sym_existential_type] = STATE(3466),
    [sym_flow_maybe_type] = STATE(3466),
    [sym_parenthesized_type] = STATE(3466),
    [sym_predefined_type] = STATE(3466),
    [sym_object_type] = STATE(3466),
    [sym_type_parameters] = STATE(5758),
    [sym_array_type] = STATE(3466),
    [sym_tuple_type] = STATE(3466),
    [sym_readonly_type] = STATE(3468),
    [sym_union_type] = STATE(3466),
    [sym_intersection_type] = STATE(3466),
    [sym_function_type] = STATE(3468),
    [sym_identifier] = ACTIONS(2002),
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_LBRACE] = ACTIONS(2006),
    [anon_sym_typeof] = ACTIONS(2008),
    [anon_sym_const] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(2010),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_new] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(1109),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [sym_number] = ACTIONS(2028),
    [sym_this] = ACTIONS(2030),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [sym_null] = ACTIONS(2032),
    [sym_undefined] = ACTIONS(2032),
    [anon_sym_readonly] = ACTIONS(2034),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1109),
    [anon_sym_number] = ACTIONS(1109),
    [anon_sym_boolean] = ACTIONS(1109),
    [anon_sym_string] = ACTIONS(1109),
    [anon_sym_symbol] = ACTIONS(1109),
    [anon_sym_object] = ACTIONS(1109),
    [anon_sym_abstract] = ACTIONS(1101),
    [anon_sym_infer] = ACTIONS(1103),
    [anon_sym_keyof] = ACTIONS(1105),
    [anon_sym_unique] = ACTIONS(1107),
    [anon_sym_unknown] = ACTIONS(1109),
    [anon_sym_never] = ACTIONS(1109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1111),
    [sym_html_comment] = ACTIONS(5),
  },
  [1087] = {
    [sym_nested_identifier] = STATE(5958),
    [sym_string] = STATE(2307),
    [sym_comment] = STATE(1087),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(2121),
    [sym__type] = STATE(5025),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(2393),
    [sym_template_literal_type] = STATE(2397),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(2397),
    [sym_generic_type] = STATE(2397),
    [sym_type_query] = STATE(2397),
    [sym_index_type_query] = STATE(2397),
    [sym_lookup_type] = STATE(2397),
    [sym_literal_type] = STATE(2397),
    [sym__number] = STATE(2309),
    [sym_existential_type] = STATE(2397),
    [sym_flow_maybe_type] = STATE(2397),
    [sym_parenthesized_type] = STATE(2397),
    [sym_predefined_type] = STATE(2397),
    [sym_object_type] = STATE(2397),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(2397),
    [sym_tuple_type] = STATE(2397),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(2397),
    [sym_intersection_type] = STATE(2397),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3626),
    [anon_sym_STAR] = ACTIONS(3504),
    [anon_sym_LBRACE] = ACTIONS(3506),
    [anon_sym_typeof] = ACTIONS(3508),
    [anon_sym_const] = ACTIONS(3510),
    [anon_sym_LPAREN] = ACTIONS(3512),
    [anon_sym_LBRACK] = ACTIONS(3514),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(3518),
    [anon_sym_PIPE] = ACTIONS(3520),
    [anon_sym_PLUS] = ACTIONS(3522),
    [anon_sym_DASH] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3524),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3526),
    [sym_number] = ACTIONS(3528),
    [sym_this] = ACTIONS(3628),
    [sym_true] = ACTIONS(3532),
    [sym_false] = ACTIONS(3532),
    [sym_null] = ACTIONS(3532),
    [sym_undefined] = ACTIONS(3532),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(3536),
    [anon_sym_any] = ACTIONS(3524),
    [anon_sym_number] = ACTIONS(3524),
    [anon_sym_boolean] = ACTIONS(3524),
    [anon_sym_string] = ACTIONS(3524),
    [anon_sym_symbol] = ACTIONS(3524),
    [anon_sym_object] = ACTIONS(3524),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(3544),
    [anon_sym_unique] = ACTIONS(3546),
    [anon_sym_unknown] = ACTIONS(3524),
    [anon_sym_never] = ACTIONS(3524),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3548),
    [sym_html_comment] = ACTIONS(5),
  },
  [1088] = {
    [sym_nested_identifier] = STATE(6066),
    [sym_string] = STATE(1759),
    [sym_comment] = STATE(1088),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(1744),
    [sym__type] = STATE(5318),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(1779),
    [sym_template_literal_type] = STATE(1745),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(1745),
    [sym_generic_type] = STATE(1745),
    [sym_type_query] = STATE(1745),
    [sym_index_type_query] = STATE(1745),
    [sym_lookup_type] = STATE(1745),
    [sym_literal_type] = STATE(1745),
    [sym__number] = STATE(1763),
    [sym_existential_type] = STATE(1745),
    [sym_flow_maybe_type] = STATE(1745),
    [sym_parenthesized_type] = STATE(1745),
    [sym_predefined_type] = STATE(1745),
    [sym_object_type] = STATE(1745),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(1745),
    [sym_tuple_type] = STATE(1745),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(1745),
    [sym_intersection_type] = STATE(1745),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3630),
    [anon_sym_STAR] = ACTIONS(3552),
    [anon_sym_LBRACE] = ACTIONS(3554),
    [anon_sym_typeof] = ACTIONS(3556),
    [anon_sym_const] = ACTIONS(3558),
    [anon_sym_LPAREN] = ACTIONS(3560),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(3566),
    [anon_sym_PIPE] = ACTIONS(3568),
    [anon_sym_PLUS] = ACTIONS(3570),
    [anon_sym_DASH] = ACTIONS(3570),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3572),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3574),
    [sym_number] = ACTIONS(3576),
    [sym_this] = ACTIONS(3632),
    [sym_true] = ACTIONS(3580),
    [sym_false] = ACTIONS(3580),
    [sym_null] = ACTIONS(3580),
    [sym_undefined] = ACTIONS(3580),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(3584),
    [anon_sym_any] = ACTIONS(3572),
    [anon_sym_number] = ACTIONS(3572),
    [anon_sym_boolean] = ACTIONS(3572),
    [anon_sym_string] = ACTIONS(3572),
    [anon_sym_symbol] = ACTIONS(3572),
    [anon_sym_object] = ACTIONS(3572),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(3592),
    [anon_sym_unique] = ACTIONS(3594),
    [anon_sym_unknown] = ACTIONS(3572),
    [anon_sym_never] = ACTIONS(3572),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3596),
    [sym_html_comment] = ACTIONS(5),
  },
  [1089] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1089),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(3305),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1090] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1090),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(3332),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1091] = {
    [sym_nested_identifier] = STATE(6066),
    [sym_string] = STATE(1759),
    [sym_comment] = STATE(1091),
    [sym_formal_parameters] = STATE(6184),
    [sym_nested_type_identifier] = STATE(1744),
    [sym__type] = STATE(1890),
    [sym_constructor_type] = STATE(1761),
    [sym__primary_type] = STATE(1762),
    [sym_template_literal_type] = STATE(1745),
    [sym_infer_type] = STATE(1761),
    [sym_conditional_type] = STATE(1745),
    [sym_generic_type] = STATE(1745),
    [sym_type_query] = STATE(1745),
    [sym_index_type_query] = STATE(1745),
    [sym_lookup_type] = STATE(1745),
    [sym_literal_type] = STATE(1745),
    [sym__number] = STATE(1763),
    [sym_existential_type] = STATE(1745),
    [sym_flow_maybe_type] = STATE(1745),
    [sym_parenthesized_type] = STATE(1745),
    [sym_predefined_type] = STATE(1745),
    [sym_object_type] = STATE(1745),
    [sym_type_parameters] = STATE(5724),
    [sym_array_type] = STATE(1745),
    [sym_tuple_type] = STATE(1745),
    [sym_readonly_type] = STATE(1761),
    [sym_union_type] = STATE(1745),
    [sym_intersection_type] = STATE(1745),
    [sym_function_type] = STATE(1761),
    [sym_identifier] = ACTIONS(3630),
    [anon_sym_STAR] = ACTIONS(3552),
    [anon_sym_LBRACE] = ACTIONS(3554),
    [anon_sym_typeof] = ACTIONS(3556),
    [anon_sym_const] = ACTIONS(3558),
    [anon_sym_LPAREN] = ACTIONS(3560),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(3564),
    [anon_sym_AMP] = ACTIONS(3566),
    [anon_sym_PIPE] = ACTIONS(3568),
    [anon_sym_PLUS] = ACTIONS(3570),
    [anon_sym_DASH] = ACTIONS(3570),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3572),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3574),
    [sym_number] = ACTIONS(3576),
    [sym_this] = ACTIONS(3632),
    [sym_true] = ACTIONS(3580),
    [sym_false] = ACTIONS(3580),
    [sym_null] = ACTIONS(3580),
    [sym_undefined] = ACTIONS(3580),
    [anon_sym_readonly] = ACTIONS(3582),
    [anon_sym_QMARK] = ACTIONS(3584),
    [anon_sym_any] = ACTIONS(3572),
    [anon_sym_number] = ACTIONS(3572),
    [anon_sym_boolean] = ACTIONS(3572),
    [anon_sym_string] = ACTIONS(3572),
    [anon_sym_symbol] = ACTIONS(3572),
    [anon_sym_object] = ACTIONS(3572),
    [anon_sym_abstract] = ACTIONS(3586),
    [anon_sym_infer] = ACTIONS(3590),
    [anon_sym_keyof] = ACTIONS(3592),
    [anon_sym_unique] = ACTIONS(3594),
    [anon_sym_unknown] = ACTIONS(3572),
    [anon_sym_never] = ACTIONS(3572),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3596),
    [sym_html_comment] = ACTIONS(5),
  },
  [1092] = {
    [sym_nested_identifier] = STATE(6123),
    [sym_string] = STATE(3650),
    [sym_comment] = STATE(1092),
    [sym_formal_parameters] = STATE(6329),
    [sym_nested_type_identifier] = STATE(3475),
    [sym__type] = STATE(3624),
    [sym_constructor_type] = STATE(3735),
    [sym__primary_type] = STATE(3709),
    [sym_template_literal_type] = STATE(3706),
    [sym_infer_type] = STATE(3735),
    [sym_conditional_type] = STATE(3706),
    [sym_generic_type] = STATE(3706),
    [sym_type_query] = STATE(3706),
    [sym_index_type_query] = STATE(3706),
    [sym_lookup_type] = STATE(3706),
    [sym_literal_type] = STATE(3706),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3706),
    [sym_flow_maybe_type] = STATE(3706),
    [sym_parenthesized_type] = STATE(3706),
    [sym_predefined_type] = STATE(3706),
    [sym_object_type] = STATE(3706),
    [sym_type_parameters] = STATE(5682),
    [sym_array_type] = STATE(3706),
    [sym_tuple_type] = STATE(3706),
    [sym_readonly_type] = STATE(3735),
    [sym_union_type] = STATE(3706),
    [sym_intersection_type] = STATE(3706),
    [sym_function_type] = STATE(3735),
    [sym_identifier] = ACTIONS(3634),
    [anon_sym_STAR] = ACTIONS(3313),
    [anon_sym_LBRACE] = ACTIONS(3315),
    [anon_sym_typeof] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_LPAREN] = ACTIONS(3321),
    [anon_sym_LBRACK] = ACTIONS(3323),
    [anon_sym_DQUOTE] = ACTIONS(3325),
    [anon_sym_SQUOTE] = ACTIONS(3327),
    [anon_sym_new] = ACTIONS(3329),
    [anon_sym_AMP] = ACTIONS(3331),
    [anon_sym_PIPE] = ACTIONS(3333),
    [anon_sym_PLUS] = ACTIONS(3335),
    [anon_sym_DASH] = ACTIONS(3335),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3337),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3339),
    [sym_number] = ACTIONS(3341),
    [sym_this] = ACTIONS(3636),
    [sym_true] = ACTIONS(3345),
    [sym_false] = ACTIONS(3345),
    [sym_null] = ACTIONS(3345),
    [sym_undefined] = ACTIONS(3345),
    [anon_sym_readonly] = ACTIONS(3347),
    [anon_sym_QMARK] = ACTIONS(3349),
    [anon_sym_any] = ACTIONS(3337),
    [anon_sym_number] = ACTIONS(3337),
    [anon_sym_boolean] = ACTIONS(3337),
    [anon_sym_string] = ACTIONS(3337),
    [anon_sym_symbol] = ACTIONS(3337),
    [anon_sym_object] = ACTIONS(3337),
    [anon_sym_abstract] = ACTIONS(3351),
    [anon_sym_infer] = ACTIONS(3355),
    [anon_sym_keyof] = ACTIONS(3357),
    [anon_sym_unique] = ACTIONS(3359),
    [anon_sym_unknown] = ACTIONS(3337),
    [anon_sym_never] = ACTIONS(3337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3361),
    [sym_html_comment] = ACTIONS(5),
  },
  [1093] = {
    [sym_nested_identifier] = STATE(5958),
    [sym_string] = STATE(2307),
    [sym_comment] = STATE(1093),
    [sym_formal_parameters] = STATE(6100),
    [sym_nested_type_identifier] = STATE(2121),
    [sym__type] = STATE(2389),
    [sym_constructor_type] = STATE(2353),
    [sym__primary_type] = STATE(2401),
    [sym_template_literal_type] = STATE(2397),
    [sym_infer_type] = STATE(2353),
    [sym_conditional_type] = STATE(2397),
    [sym_generic_type] = STATE(2397),
    [sym_type_query] = STATE(2397),
    [sym_index_type_query] = STATE(2397),
    [sym_lookup_type] = STATE(2397),
    [sym_literal_type] = STATE(2397),
    [sym__number] = STATE(2309),
    [sym_existential_type] = STATE(2397),
    [sym_flow_maybe_type] = STATE(2397),
    [sym_parenthesized_type] = STATE(2397),
    [sym_predefined_type] = STATE(2397),
    [sym_object_type] = STATE(2397),
    [sym_type_parameters] = STATE(5861),
    [sym_array_type] = STATE(2397),
    [sym_tuple_type] = STATE(2397),
    [sym_readonly_type] = STATE(2353),
    [sym_union_type] = STATE(2397),
    [sym_intersection_type] = STATE(2397),
    [sym_function_type] = STATE(2353),
    [sym_identifier] = ACTIONS(3626),
    [anon_sym_STAR] = ACTIONS(3504),
    [anon_sym_LBRACE] = ACTIONS(3506),
    [anon_sym_typeof] = ACTIONS(3508),
    [anon_sym_const] = ACTIONS(3510),
    [anon_sym_LPAREN] = ACTIONS(3512),
    [anon_sym_LBRACK] = ACTIONS(3514),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_new] = ACTIONS(3516),
    [anon_sym_AMP] = ACTIONS(3518),
    [anon_sym_PIPE] = ACTIONS(3520),
    [anon_sym_PLUS] = ACTIONS(3522),
    [anon_sym_DASH] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3524),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3526),
    [sym_number] = ACTIONS(3528),
    [sym_this] = ACTIONS(3628),
    [sym_true] = ACTIONS(3532),
    [sym_false] = ACTIONS(3532),
    [sym_null] = ACTIONS(3532),
    [sym_undefined] = ACTIONS(3532),
    [anon_sym_readonly] = ACTIONS(3534),
    [anon_sym_QMARK] = ACTIONS(3536),
    [anon_sym_any] = ACTIONS(3524),
    [anon_sym_number] = ACTIONS(3524),
    [anon_sym_boolean] = ACTIONS(3524),
    [anon_sym_string] = ACTIONS(3524),
    [anon_sym_symbol] = ACTIONS(3524),
    [anon_sym_object] = ACTIONS(3524),
    [anon_sym_abstract] = ACTIONS(3538),
    [anon_sym_infer] = ACTIONS(3542),
    [anon_sym_keyof] = ACTIONS(3544),
    [anon_sym_unique] = ACTIONS(3546),
    [anon_sym_unknown] = ACTIONS(3524),
    [anon_sym_never] = ACTIONS(3524),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3548),
    [sym_html_comment] = ACTIONS(5),
  },
  [1094] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1094),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4855),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1095] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1095),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4846),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1096] = {
    [sym_nested_identifier] = STATE(6123),
    [sym_string] = STATE(3650),
    [sym_comment] = STATE(1096),
    [sym_formal_parameters] = STATE(6329),
    [sym_nested_type_identifier] = STATE(3475),
    [sym__type] = STATE(3656),
    [sym_constructor_type] = STATE(3735),
    [sym__primary_type] = STATE(3709),
    [sym_template_literal_type] = STATE(3706),
    [sym_infer_type] = STATE(3735),
    [sym_conditional_type] = STATE(3706),
    [sym_generic_type] = STATE(3706),
    [sym_type_query] = STATE(3706),
    [sym_index_type_query] = STATE(3706),
    [sym_lookup_type] = STATE(3706),
    [sym_literal_type] = STATE(3706),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3706),
    [sym_flow_maybe_type] = STATE(3706),
    [sym_parenthesized_type] = STATE(3706),
    [sym_predefined_type] = STATE(3706),
    [sym_object_type] = STATE(3706),
    [sym_type_parameters] = STATE(5682),
    [sym_array_type] = STATE(3706),
    [sym_tuple_type] = STATE(3706),
    [sym_readonly_type] = STATE(3735),
    [sym_union_type] = STATE(3706),
    [sym_intersection_type] = STATE(3706),
    [sym_function_type] = STATE(3735),
    [sym_identifier] = ACTIONS(3634),
    [anon_sym_STAR] = ACTIONS(3313),
    [anon_sym_LBRACE] = ACTIONS(3315),
    [anon_sym_typeof] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_LPAREN] = ACTIONS(3321),
    [anon_sym_LBRACK] = ACTIONS(3323),
    [anon_sym_DQUOTE] = ACTIONS(3325),
    [anon_sym_SQUOTE] = ACTIONS(3327),
    [anon_sym_new] = ACTIONS(3329),
    [anon_sym_AMP] = ACTIONS(3331),
    [anon_sym_PIPE] = ACTIONS(3333),
    [anon_sym_PLUS] = ACTIONS(3335),
    [anon_sym_DASH] = ACTIONS(3335),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3337),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3339),
    [sym_number] = ACTIONS(3341),
    [sym_this] = ACTIONS(3636),
    [sym_true] = ACTIONS(3345),
    [sym_false] = ACTIONS(3345),
    [sym_null] = ACTIONS(3345),
    [sym_undefined] = ACTIONS(3345),
    [anon_sym_readonly] = ACTIONS(3347),
    [anon_sym_QMARK] = ACTIONS(3349),
    [anon_sym_any] = ACTIONS(3337),
    [anon_sym_number] = ACTIONS(3337),
    [anon_sym_boolean] = ACTIONS(3337),
    [anon_sym_string] = ACTIONS(3337),
    [anon_sym_symbol] = ACTIONS(3337),
    [anon_sym_object] = ACTIONS(3337),
    [anon_sym_abstract] = ACTIONS(3351),
    [anon_sym_infer] = ACTIONS(3355),
    [anon_sym_keyof] = ACTIONS(3357),
    [anon_sym_unique] = ACTIONS(3359),
    [anon_sym_unknown] = ACTIONS(3337),
    [anon_sym_never] = ACTIONS(3337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3361),
    [sym_html_comment] = ACTIONS(5),
  },
  [1097] = {
    [sym_nested_identifier] = STATE(6066),
    [sym_string] = STATE(1759),
    [sym_comment] = STATE(1097),
    [sym_formal_parameters] = STATE(6184),
    [sym_nested_type_identifier] = STATE(1744),
    [sym__type] = STATE(1778),
    [sym_constructor_type] = STATE(1761),
    [sym__primary_type] = STATE(1762),
    [sym_template_literal_type] = STATE(1745),
    [sym_infer_type] = STATE(1761),
    [sym_conditional_type] = STATE(1745),
    [sym_generic_type] = STATE(1745),
    [sym_type_query] = STATE(1745),
    [sym_index_type_query] = STATE(1745),
    [sym_lookup_type] = STATE(1745),
    [sym_literal_type] = STATE(1745),
    [sym__number] = STATE(1763),
    [sym_existential_type] = STATE(1745),
    [sym_flow_maybe_type] = STATE(1745),
    [sym_parenthesized_type] = STATE(1745),
    [sym_predefined_type] = STATE(1745),
    [sym_object_type] = STATE(1745),
    [sym_type_parameters] = STATE(5724),
    [sym_array_type] = STATE(1745),
    [sym_tuple_type] = STATE(1745),
    [sym_readonly_type] = STATE(1761),
    [sym_union_type] = STATE(1745),
    [sym_intersection_type] = STATE(1745),
    [sym_function_type] = STATE(1761),
    [sym_identifier] = ACTIONS(3630),
    [anon_sym_STAR] = ACTIONS(3552),
    [anon_sym_LBRACE] = ACTIONS(3554),
    [anon_sym_typeof] = ACTIONS(3556),
    [anon_sym_const] = ACTIONS(3558),
    [anon_sym_LPAREN] = ACTIONS(3560),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(3564),
    [anon_sym_AMP] = ACTIONS(3566),
    [anon_sym_PIPE] = ACTIONS(3568),
    [anon_sym_PLUS] = ACTIONS(3570),
    [anon_sym_DASH] = ACTIONS(3570),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3572),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3574),
    [sym_number] = ACTIONS(3576),
    [sym_this] = ACTIONS(3632),
    [sym_true] = ACTIONS(3580),
    [sym_false] = ACTIONS(3580),
    [sym_null] = ACTIONS(3580),
    [sym_undefined] = ACTIONS(3580),
    [anon_sym_readonly] = ACTIONS(3582),
    [anon_sym_QMARK] = ACTIONS(3584),
    [anon_sym_any] = ACTIONS(3572),
    [anon_sym_number] = ACTIONS(3572),
    [anon_sym_boolean] = ACTIONS(3572),
    [anon_sym_string] = ACTIONS(3572),
    [anon_sym_symbol] = ACTIONS(3572),
    [anon_sym_object] = ACTIONS(3572),
    [anon_sym_abstract] = ACTIONS(3586),
    [anon_sym_infer] = ACTIONS(3590),
    [anon_sym_keyof] = ACTIONS(3592),
    [anon_sym_unique] = ACTIONS(3594),
    [anon_sym_unknown] = ACTIONS(3572),
    [anon_sym_never] = ACTIONS(3572),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3596),
    [sym_html_comment] = ACTIONS(5),
  },
  [1098] = {
    [sym_nested_identifier] = STATE(6076),
    [sym_string] = STATE(3484),
    [sym_comment] = STATE(1098),
    [sym_formal_parameters] = STATE(5995),
    [sym_nested_type_identifier] = STATE(3366),
    [sym__type] = STATE(4647),
    [sym_constructor_type] = STATE(3468),
    [sym__primary_type] = STATE(3467),
    [sym_template_literal_type] = STATE(3466),
    [sym_infer_type] = STATE(3468),
    [sym_conditional_type] = STATE(3466),
    [sym_generic_type] = STATE(3466),
    [sym_type_query] = STATE(3466),
    [sym_index_type_query] = STATE(3466),
    [sym_lookup_type] = STATE(3466),
    [sym_literal_type] = STATE(3466),
    [sym__number] = STATE(3465),
    [sym_existential_type] = STATE(3466),
    [sym_flow_maybe_type] = STATE(3466),
    [sym_parenthesized_type] = STATE(3466),
    [sym_predefined_type] = STATE(3466),
    [sym_object_type] = STATE(3466),
    [sym_type_parameters] = STATE(5758),
    [sym_array_type] = STATE(3466),
    [sym_tuple_type] = STATE(3466),
    [sym_readonly_type] = STATE(3468),
    [sym_union_type] = STATE(3466),
    [sym_intersection_type] = STATE(3466),
    [sym_function_type] = STATE(3468),
    [sym_identifier] = ACTIONS(2002),
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_LBRACE] = ACTIONS(2006),
    [anon_sym_typeof] = ACTIONS(2008),
    [anon_sym_const] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(2010),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_new] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(1109),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [sym_number] = ACTIONS(2028),
    [sym_this] = ACTIONS(2030),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [sym_null] = ACTIONS(2032),
    [sym_undefined] = ACTIONS(2032),
    [anon_sym_readonly] = ACTIONS(2034),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1109),
    [anon_sym_number] = ACTIONS(1109),
    [anon_sym_boolean] = ACTIONS(1109),
    [anon_sym_string] = ACTIONS(1109),
    [anon_sym_symbol] = ACTIONS(1109),
    [anon_sym_object] = ACTIONS(1109),
    [anon_sym_abstract] = ACTIONS(1101),
    [anon_sym_infer] = ACTIONS(1103),
    [anon_sym_keyof] = ACTIONS(1105),
    [anon_sym_unique] = ACTIONS(1107),
    [anon_sym_unknown] = ACTIONS(1109),
    [anon_sym_never] = ACTIONS(1109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1111),
    [sym_html_comment] = ACTIONS(5),
  },
  [1099] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1099),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(3321),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1100] = {
    [sym_nested_identifier] = STATE(6066),
    [sym_string] = STATE(1759),
    [sym_comment] = STATE(1100),
    [sym_formal_parameters] = STATE(6184),
    [sym_nested_type_identifier] = STATE(1744),
    [sym__type] = STATE(1774),
    [sym_constructor_type] = STATE(1761),
    [sym__primary_type] = STATE(1762),
    [sym_template_literal_type] = STATE(1745),
    [sym_infer_type] = STATE(1761),
    [sym_conditional_type] = STATE(1745),
    [sym_generic_type] = STATE(1745),
    [sym_type_query] = STATE(1745),
    [sym_index_type_query] = STATE(1745),
    [sym_lookup_type] = STATE(1745),
    [sym_literal_type] = STATE(1745),
    [sym__number] = STATE(1763),
    [sym_existential_type] = STATE(1745),
    [sym_flow_maybe_type] = STATE(1745),
    [sym_parenthesized_type] = STATE(1745),
    [sym_predefined_type] = STATE(1745),
    [sym_object_type] = STATE(1745),
    [sym_type_parameters] = STATE(5724),
    [sym_array_type] = STATE(1745),
    [sym_tuple_type] = STATE(1745),
    [sym_readonly_type] = STATE(1761),
    [sym_union_type] = STATE(1745),
    [sym_intersection_type] = STATE(1745),
    [sym_function_type] = STATE(1761),
    [sym_identifier] = ACTIONS(3630),
    [anon_sym_STAR] = ACTIONS(3552),
    [anon_sym_LBRACE] = ACTIONS(3554),
    [anon_sym_typeof] = ACTIONS(3556),
    [anon_sym_const] = ACTIONS(3558),
    [anon_sym_LPAREN] = ACTIONS(3560),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(3564),
    [anon_sym_AMP] = ACTIONS(3566),
    [anon_sym_PIPE] = ACTIONS(3568),
    [anon_sym_PLUS] = ACTIONS(3570),
    [anon_sym_DASH] = ACTIONS(3570),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3572),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3574),
    [sym_number] = ACTIONS(3576),
    [sym_this] = ACTIONS(3632),
    [sym_true] = ACTIONS(3580),
    [sym_false] = ACTIONS(3580),
    [sym_null] = ACTIONS(3580),
    [sym_undefined] = ACTIONS(3580),
    [anon_sym_readonly] = ACTIONS(3582),
    [anon_sym_QMARK] = ACTIONS(3584),
    [anon_sym_any] = ACTIONS(3572),
    [anon_sym_number] = ACTIONS(3572),
    [anon_sym_boolean] = ACTIONS(3572),
    [anon_sym_string] = ACTIONS(3572),
    [anon_sym_symbol] = ACTIONS(3572),
    [anon_sym_object] = ACTIONS(3572),
    [anon_sym_abstract] = ACTIONS(3586),
    [anon_sym_infer] = ACTIONS(3590),
    [anon_sym_keyof] = ACTIONS(3592),
    [anon_sym_unique] = ACTIONS(3594),
    [anon_sym_unknown] = ACTIONS(3572),
    [anon_sym_never] = ACTIONS(3572),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3596),
    [sym_html_comment] = ACTIONS(5),
  },
  [1101] = {
    [sym_nested_identifier] = STATE(6066),
    [sym_string] = STATE(1759),
    [sym_comment] = STATE(1101),
    [sym_formal_parameters] = STATE(6184),
    [sym_nested_type_identifier] = STATE(1744),
    [sym__type] = STATE(1773),
    [sym_constructor_type] = STATE(1761),
    [sym__primary_type] = STATE(1762),
    [sym_template_literal_type] = STATE(1745),
    [sym_infer_type] = STATE(1761),
    [sym_conditional_type] = STATE(1745),
    [sym_generic_type] = STATE(1745),
    [sym_type_query] = STATE(1745),
    [sym_index_type_query] = STATE(1745),
    [sym_lookup_type] = STATE(1745),
    [sym_literal_type] = STATE(1745),
    [sym__number] = STATE(1763),
    [sym_existential_type] = STATE(1745),
    [sym_flow_maybe_type] = STATE(1745),
    [sym_parenthesized_type] = STATE(1745),
    [sym_predefined_type] = STATE(1745),
    [sym_object_type] = STATE(1745),
    [sym_type_parameters] = STATE(5724),
    [sym_array_type] = STATE(1745),
    [sym_tuple_type] = STATE(1745),
    [sym_readonly_type] = STATE(1761),
    [sym_union_type] = STATE(1745),
    [sym_intersection_type] = STATE(1745),
    [sym_function_type] = STATE(1761),
    [sym_identifier] = ACTIONS(3630),
    [anon_sym_STAR] = ACTIONS(3552),
    [anon_sym_LBRACE] = ACTIONS(3554),
    [anon_sym_typeof] = ACTIONS(3556),
    [anon_sym_const] = ACTIONS(3558),
    [anon_sym_LPAREN] = ACTIONS(3560),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(3564),
    [anon_sym_AMP] = ACTIONS(3566),
    [anon_sym_PIPE] = ACTIONS(3568),
    [anon_sym_PLUS] = ACTIONS(3570),
    [anon_sym_DASH] = ACTIONS(3570),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3572),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3574),
    [sym_number] = ACTIONS(3576),
    [sym_this] = ACTIONS(3632),
    [sym_true] = ACTIONS(3580),
    [sym_false] = ACTIONS(3580),
    [sym_null] = ACTIONS(3580),
    [sym_undefined] = ACTIONS(3580),
    [anon_sym_readonly] = ACTIONS(3582),
    [anon_sym_QMARK] = ACTIONS(3584),
    [anon_sym_any] = ACTIONS(3572),
    [anon_sym_number] = ACTIONS(3572),
    [anon_sym_boolean] = ACTIONS(3572),
    [anon_sym_string] = ACTIONS(3572),
    [anon_sym_symbol] = ACTIONS(3572),
    [anon_sym_object] = ACTIONS(3572),
    [anon_sym_abstract] = ACTIONS(3586),
    [anon_sym_infer] = ACTIONS(3590),
    [anon_sym_keyof] = ACTIONS(3592),
    [anon_sym_unique] = ACTIONS(3594),
    [anon_sym_unknown] = ACTIONS(3572),
    [anon_sym_never] = ACTIONS(3572),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3596),
    [sym_html_comment] = ACTIONS(5),
  },
  [1102] = {
    [sym_nested_identifier] = STATE(6076),
    [sym_string] = STATE(3484),
    [sym_comment] = STATE(1102),
    [sym_formal_parameters] = STATE(5995),
    [sym_nested_type_identifier] = STATE(3366),
    [sym__type] = STATE(4590),
    [sym_constructor_type] = STATE(3468),
    [sym__primary_type] = STATE(3467),
    [sym_template_literal_type] = STATE(3466),
    [sym_infer_type] = STATE(3468),
    [sym_conditional_type] = STATE(3466),
    [sym_generic_type] = STATE(3466),
    [sym_type_query] = STATE(3466),
    [sym_index_type_query] = STATE(3466),
    [sym_lookup_type] = STATE(3466),
    [sym_literal_type] = STATE(3466),
    [sym__number] = STATE(3465),
    [sym_existential_type] = STATE(3466),
    [sym_flow_maybe_type] = STATE(3466),
    [sym_parenthesized_type] = STATE(3466),
    [sym_predefined_type] = STATE(3466),
    [sym_object_type] = STATE(3466),
    [sym_type_parameters] = STATE(5758),
    [sym_array_type] = STATE(3466),
    [sym_tuple_type] = STATE(3466),
    [sym_readonly_type] = STATE(3468),
    [sym_union_type] = STATE(3466),
    [sym_intersection_type] = STATE(3466),
    [sym_function_type] = STATE(3468),
    [sym_identifier] = ACTIONS(2002),
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_LBRACE] = ACTIONS(2006),
    [anon_sym_typeof] = ACTIONS(2008),
    [anon_sym_const] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(2010),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_new] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(1109),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [sym_number] = ACTIONS(2028),
    [sym_this] = ACTIONS(2030),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [sym_null] = ACTIONS(2032),
    [sym_undefined] = ACTIONS(2032),
    [anon_sym_readonly] = ACTIONS(2034),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1109),
    [anon_sym_number] = ACTIONS(1109),
    [anon_sym_boolean] = ACTIONS(1109),
    [anon_sym_string] = ACTIONS(1109),
    [anon_sym_symbol] = ACTIONS(1109),
    [anon_sym_object] = ACTIONS(1109),
    [anon_sym_abstract] = ACTIONS(1101),
    [anon_sym_infer] = ACTIONS(1103),
    [anon_sym_keyof] = ACTIONS(1105),
    [anon_sym_unique] = ACTIONS(1107),
    [anon_sym_unknown] = ACTIONS(1109),
    [anon_sym_never] = ACTIONS(1109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1111),
    [sym_html_comment] = ACTIONS(5),
  },
  [1103] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1103),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(3323),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1104] = {
    [sym_nested_identifier] = STATE(6123),
    [sym_string] = STATE(3650),
    [sym_comment] = STATE(1104),
    [sym_formal_parameters] = STATE(6329),
    [sym_nested_type_identifier] = STATE(3475),
    [sym__type] = STATE(3635),
    [sym_constructor_type] = STATE(3735),
    [sym__primary_type] = STATE(3709),
    [sym_template_literal_type] = STATE(3706),
    [sym_infer_type] = STATE(3735),
    [sym_conditional_type] = STATE(3706),
    [sym_generic_type] = STATE(3706),
    [sym_type_query] = STATE(3706),
    [sym_index_type_query] = STATE(3706),
    [sym_lookup_type] = STATE(3706),
    [sym_literal_type] = STATE(3706),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3706),
    [sym_flow_maybe_type] = STATE(3706),
    [sym_parenthesized_type] = STATE(3706),
    [sym_predefined_type] = STATE(3706),
    [sym_object_type] = STATE(3706),
    [sym_type_parameters] = STATE(5682),
    [sym_array_type] = STATE(3706),
    [sym_tuple_type] = STATE(3706),
    [sym_readonly_type] = STATE(3735),
    [sym_union_type] = STATE(3706),
    [sym_intersection_type] = STATE(3706),
    [sym_function_type] = STATE(3735),
    [sym_identifier] = ACTIONS(3634),
    [anon_sym_STAR] = ACTIONS(3313),
    [anon_sym_LBRACE] = ACTIONS(3315),
    [anon_sym_typeof] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_LPAREN] = ACTIONS(3321),
    [anon_sym_LBRACK] = ACTIONS(3323),
    [anon_sym_DQUOTE] = ACTIONS(3325),
    [anon_sym_SQUOTE] = ACTIONS(3327),
    [anon_sym_new] = ACTIONS(3329),
    [anon_sym_AMP] = ACTIONS(3331),
    [anon_sym_PIPE] = ACTIONS(3333),
    [anon_sym_PLUS] = ACTIONS(3335),
    [anon_sym_DASH] = ACTIONS(3335),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3337),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3339),
    [sym_number] = ACTIONS(3341),
    [sym_this] = ACTIONS(3636),
    [sym_true] = ACTIONS(3345),
    [sym_false] = ACTIONS(3345),
    [sym_null] = ACTIONS(3345),
    [sym_undefined] = ACTIONS(3345),
    [anon_sym_readonly] = ACTIONS(3347),
    [anon_sym_QMARK] = ACTIONS(3349),
    [anon_sym_any] = ACTIONS(3337),
    [anon_sym_number] = ACTIONS(3337),
    [anon_sym_boolean] = ACTIONS(3337),
    [anon_sym_string] = ACTIONS(3337),
    [anon_sym_symbol] = ACTIONS(3337),
    [anon_sym_object] = ACTIONS(3337),
    [anon_sym_abstract] = ACTIONS(3351),
    [anon_sym_infer] = ACTIONS(3355),
    [anon_sym_keyof] = ACTIONS(3357),
    [anon_sym_unique] = ACTIONS(3359),
    [anon_sym_unknown] = ACTIONS(3337),
    [anon_sym_never] = ACTIONS(3337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3361),
    [sym_html_comment] = ACTIONS(5),
  },
  [1105] = {
    [sym_comment] = STATE(1105),
    [sym_decorator] = STATE(1202),
    [aux_sym_export_statement_repeat1] = STATE(1105),
    [sym_identifier] = ACTIONS(3640),
    [anon_sym_export] = ACTIONS(3640),
    [anon_sym_type] = ACTIONS(3640),
    [anon_sym_namespace] = ACTIONS(3640),
    [anon_sym_LBRACE] = ACTIONS(3642),
    [anon_sym_typeof] = ACTIONS(3640),
    [anon_sym_import] = ACTIONS(3640),
    [anon_sym_from] = ACTIONS(3640),
    [anon_sym_let] = ACTIONS(3640),
    [anon_sym_BANG] = ACTIONS(3642),
    [anon_sym_LPAREN] = ACTIONS(3642),
    [anon_sym_await] = ACTIONS(3640),
    [anon_sym_of] = ACTIONS(3640),
    [anon_sym_yield] = ACTIONS(3640),
    [anon_sym_LBRACK] = ACTIONS(3642),
    [anon_sym_LTtemplate_GT] = ACTIONS(3642),
    [anon_sym_DQUOTE] = ACTIONS(3642),
    [anon_sym_SQUOTE] = ACTIONS(3642),
    [anon_sym_class] = ACTIONS(3640),
    [anon_sym_async] = ACTIONS(3640),
    [anon_sym_function] = ACTIONS(3640),
    [anon_sym_new] = ACTIONS(3640),
    [anon_sym_using] = ACTIONS(3640),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3642),
    [anon_sym_PLUS] = ACTIONS(3640),
    [anon_sym_DASH] = ACTIONS(3640),
    [anon_sym_SLASH] = ACTIONS(3640),
    [anon_sym_LT] = ACTIONS(3640),
    [anon_sym_TILDE] = ACTIONS(3642),
    [anon_sym_void] = ACTIONS(3640),
    [anon_sym_delete] = ACTIONS(3640),
    [anon_sym_PLUS_PLUS] = ACTIONS(3642),
    [anon_sym_DASH_DASH] = ACTIONS(3642),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3642),
    [sym_number] = ACTIONS(3642),
    [sym_private_property_identifier] = ACTIONS(3642),
    [sym_this] = ACTIONS(3640),
    [sym_super] = ACTIONS(3640),
    [sym_true] = ACTIONS(3640),
    [sym_false] = ACTIONS(3640),
    [sym_null] = ACTIONS(3640),
    [sym_undefined] = ACTIONS(3640),
    [anon_sym_AT] = ACTIONS(3644),
    [anon_sym_static] = ACTIONS(3640),
    [anon_sym_readonly] = ACTIONS(3640),
    [anon_sym_get] = ACTIONS(3640),
    [anon_sym_set] = ACTIONS(3640),
    [anon_sym_declare] = ACTIONS(3640),
    [anon_sym_public] = ACTIONS(3640),
    [anon_sym_private] = ACTIONS(3640),
    [anon_sym_protected] = ACTIONS(3640),
    [anon_sym_override] = ACTIONS(3640),
    [anon_sym_module] = ACTIONS(3640),
    [anon_sym_any] = ACTIONS(3640),
    [anon_sym_number] = ACTIONS(3640),
    [anon_sym_boolean] = ACTIONS(3640),
    [anon_sym_string] = ACTIONS(3640),
    [anon_sym_symbol] = ACTIONS(3640),
    [anon_sym_object] = ACTIONS(3640),
    [anon_sym_property] = ACTIONS(3640),
    [anon_sym_signal] = ACTIONS(3640),
    [anon_sym_on] = ACTIONS(3640),
    [anon_sym_required] = ACTIONS(3640),
    [anon_sym_component] = ACTIONS(3640),
    [sym_html_comment] = ACTIONS(5),
  },
  [1106] = {
    [sym_nested_identifier] = STATE(6066),
    [sym_string] = STATE(1759),
    [sym_comment] = STATE(1106),
    [sym_formal_parameters] = STATE(6184),
    [sym_nested_type_identifier] = STATE(1744),
    [sym__type] = STATE(1821),
    [sym_constructor_type] = STATE(1761),
    [sym__primary_type] = STATE(1762),
    [sym_template_literal_type] = STATE(1745),
    [sym_infer_type] = STATE(1761),
    [sym_conditional_type] = STATE(1745),
    [sym_generic_type] = STATE(1745),
    [sym_type_query] = STATE(1745),
    [sym_index_type_query] = STATE(1745),
    [sym_lookup_type] = STATE(1745),
    [sym_literal_type] = STATE(1745),
    [sym__number] = STATE(1763),
    [sym_existential_type] = STATE(1745),
    [sym_flow_maybe_type] = STATE(1745),
    [sym_parenthesized_type] = STATE(1745),
    [sym_predefined_type] = STATE(1745),
    [sym_object_type] = STATE(1745),
    [sym_type_parameters] = STATE(5724),
    [sym_array_type] = STATE(1745),
    [sym_tuple_type] = STATE(1745),
    [sym_readonly_type] = STATE(1761),
    [sym_union_type] = STATE(1745),
    [sym_intersection_type] = STATE(1745),
    [sym_function_type] = STATE(1761),
    [sym_identifier] = ACTIONS(3630),
    [anon_sym_STAR] = ACTIONS(3552),
    [anon_sym_LBRACE] = ACTIONS(3554),
    [anon_sym_typeof] = ACTIONS(3556),
    [anon_sym_const] = ACTIONS(3558),
    [anon_sym_LPAREN] = ACTIONS(3560),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(3564),
    [anon_sym_AMP] = ACTIONS(3566),
    [anon_sym_PIPE] = ACTIONS(3568),
    [anon_sym_PLUS] = ACTIONS(3570),
    [anon_sym_DASH] = ACTIONS(3570),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3572),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3574),
    [sym_number] = ACTIONS(3576),
    [sym_this] = ACTIONS(3632),
    [sym_true] = ACTIONS(3580),
    [sym_false] = ACTIONS(3580),
    [sym_null] = ACTIONS(3580),
    [sym_undefined] = ACTIONS(3580),
    [anon_sym_readonly] = ACTIONS(3582),
    [anon_sym_QMARK] = ACTIONS(3584),
    [anon_sym_any] = ACTIONS(3572),
    [anon_sym_number] = ACTIONS(3572),
    [anon_sym_boolean] = ACTIONS(3572),
    [anon_sym_string] = ACTIONS(3572),
    [anon_sym_symbol] = ACTIONS(3572),
    [anon_sym_object] = ACTIONS(3572),
    [anon_sym_abstract] = ACTIONS(3586),
    [anon_sym_infer] = ACTIONS(3590),
    [anon_sym_keyof] = ACTIONS(3592),
    [anon_sym_unique] = ACTIONS(3594),
    [anon_sym_unknown] = ACTIONS(3572),
    [anon_sym_never] = ACTIONS(3572),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3596),
    [sym_html_comment] = ACTIONS(5),
  },
  [1107] = {
    [sym_nested_identifier] = STATE(6123),
    [sym_string] = STATE(3650),
    [sym_comment] = STATE(1107),
    [sym_formal_parameters] = STATE(6329),
    [sym_nested_type_identifier] = STATE(3475),
    [sym__type] = STATE(3636),
    [sym_constructor_type] = STATE(3735),
    [sym__primary_type] = STATE(3709),
    [sym_template_literal_type] = STATE(3706),
    [sym_infer_type] = STATE(3735),
    [sym_conditional_type] = STATE(3706),
    [sym_generic_type] = STATE(3706),
    [sym_type_query] = STATE(3706),
    [sym_index_type_query] = STATE(3706),
    [sym_lookup_type] = STATE(3706),
    [sym_literal_type] = STATE(3706),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3706),
    [sym_flow_maybe_type] = STATE(3706),
    [sym_parenthesized_type] = STATE(3706),
    [sym_predefined_type] = STATE(3706),
    [sym_object_type] = STATE(3706),
    [sym_type_parameters] = STATE(5682),
    [sym_array_type] = STATE(3706),
    [sym_tuple_type] = STATE(3706),
    [sym_readonly_type] = STATE(3735),
    [sym_union_type] = STATE(3706),
    [sym_intersection_type] = STATE(3706),
    [sym_function_type] = STATE(3735),
    [sym_identifier] = ACTIONS(3634),
    [anon_sym_STAR] = ACTIONS(3313),
    [anon_sym_LBRACE] = ACTIONS(3315),
    [anon_sym_typeof] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_LPAREN] = ACTIONS(3321),
    [anon_sym_LBRACK] = ACTIONS(3323),
    [anon_sym_DQUOTE] = ACTIONS(3325),
    [anon_sym_SQUOTE] = ACTIONS(3327),
    [anon_sym_new] = ACTIONS(3329),
    [anon_sym_AMP] = ACTIONS(3331),
    [anon_sym_PIPE] = ACTIONS(3333),
    [anon_sym_PLUS] = ACTIONS(3335),
    [anon_sym_DASH] = ACTIONS(3335),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3337),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3339),
    [sym_number] = ACTIONS(3341),
    [sym_this] = ACTIONS(3636),
    [sym_true] = ACTIONS(3345),
    [sym_false] = ACTIONS(3345),
    [sym_null] = ACTIONS(3345),
    [sym_undefined] = ACTIONS(3345),
    [anon_sym_readonly] = ACTIONS(3347),
    [anon_sym_QMARK] = ACTIONS(3349),
    [anon_sym_any] = ACTIONS(3337),
    [anon_sym_number] = ACTIONS(3337),
    [anon_sym_boolean] = ACTIONS(3337),
    [anon_sym_string] = ACTIONS(3337),
    [anon_sym_symbol] = ACTIONS(3337),
    [anon_sym_object] = ACTIONS(3337),
    [anon_sym_abstract] = ACTIONS(3351),
    [anon_sym_infer] = ACTIONS(3355),
    [anon_sym_keyof] = ACTIONS(3357),
    [anon_sym_unique] = ACTIONS(3359),
    [anon_sym_unknown] = ACTIONS(3337),
    [anon_sym_never] = ACTIONS(3337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3361),
    [sym_html_comment] = ACTIONS(5),
  },
  [1108] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1108),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(3229),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1109] = {
    [sym_nested_identifier] = STATE(6076),
    [sym_string] = STATE(3484),
    [sym_comment] = STATE(1109),
    [sym_formal_parameters] = STATE(5995),
    [sym_nested_type_identifier] = STATE(3366),
    [sym__type] = STATE(3488),
    [sym_constructor_type] = STATE(3468),
    [sym__primary_type] = STATE(3467),
    [sym_template_literal_type] = STATE(3466),
    [sym_infer_type] = STATE(3468),
    [sym_conditional_type] = STATE(3466),
    [sym_generic_type] = STATE(3466),
    [sym_type_query] = STATE(3466),
    [sym_index_type_query] = STATE(3466),
    [sym_lookup_type] = STATE(3466),
    [sym_literal_type] = STATE(3466),
    [sym__number] = STATE(3465),
    [sym_existential_type] = STATE(3466),
    [sym_flow_maybe_type] = STATE(3466),
    [sym_parenthesized_type] = STATE(3466),
    [sym_predefined_type] = STATE(3466),
    [sym_object_type] = STATE(3466),
    [sym_type_parameters] = STATE(5758),
    [sym_array_type] = STATE(3466),
    [sym_tuple_type] = STATE(3466),
    [sym_readonly_type] = STATE(3468),
    [sym_union_type] = STATE(3466),
    [sym_intersection_type] = STATE(3466),
    [sym_function_type] = STATE(3468),
    [sym_identifier] = ACTIONS(2002),
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_LBRACE] = ACTIONS(2006),
    [anon_sym_typeof] = ACTIONS(2008),
    [anon_sym_const] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(2010),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_new] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(1109),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [sym_number] = ACTIONS(2028),
    [sym_this] = ACTIONS(2030),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [sym_null] = ACTIONS(2032),
    [sym_undefined] = ACTIONS(2032),
    [anon_sym_readonly] = ACTIONS(2034),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1109),
    [anon_sym_number] = ACTIONS(1109),
    [anon_sym_boolean] = ACTIONS(1109),
    [anon_sym_string] = ACTIONS(1109),
    [anon_sym_symbol] = ACTIONS(1109),
    [anon_sym_object] = ACTIONS(1109),
    [anon_sym_abstract] = ACTIONS(1101),
    [anon_sym_infer] = ACTIONS(1103),
    [anon_sym_keyof] = ACTIONS(1105),
    [anon_sym_unique] = ACTIONS(1107),
    [anon_sym_unknown] = ACTIONS(1109),
    [anon_sym_never] = ACTIONS(1109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1111),
    [sym_html_comment] = ACTIONS(5),
  },
  [1110] = {
    [sym_nested_identifier] = STATE(6076),
    [sym_string] = STATE(3484),
    [sym_comment] = STATE(1110),
    [sym_formal_parameters] = STATE(5995),
    [sym_nested_type_identifier] = STATE(3366),
    [sym__type] = STATE(3487),
    [sym_constructor_type] = STATE(3468),
    [sym__primary_type] = STATE(3467),
    [sym_template_literal_type] = STATE(3466),
    [sym_infer_type] = STATE(3468),
    [sym_conditional_type] = STATE(3466),
    [sym_generic_type] = STATE(3466),
    [sym_type_query] = STATE(3466),
    [sym_index_type_query] = STATE(3466),
    [sym_lookup_type] = STATE(3466),
    [sym_literal_type] = STATE(3466),
    [sym__number] = STATE(3465),
    [sym_existential_type] = STATE(3466),
    [sym_flow_maybe_type] = STATE(3466),
    [sym_parenthesized_type] = STATE(3466),
    [sym_predefined_type] = STATE(3466),
    [sym_object_type] = STATE(3466),
    [sym_type_parameters] = STATE(5758),
    [sym_array_type] = STATE(3466),
    [sym_tuple_type] = STATE(3466),
    [sym_readonly_type] = STATE(3468),
    [sym_union_type] = STATE(3466),
    [sym_intersection_type] = STATE(3466),
    [sym_function_type] = STATE(3468),
    [sym_identifier] = ACTIONS(2002),
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_LBRACE] = ACTIONS(2006),
    [anon_sym_typeof] = ACTIONS(2008),
    [anon_sym_const] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(2010),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_new] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(1109),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [sym_number] = ACTIONS(2028),
    [sym_this] = ACTIONS(2030),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [sym_null] = ACTIONS(2032),
    [sym_undefined] = ACTIONS(2032),
    [anon_sym_readonly] = ACTIONS(2034),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1109),
    [anon_sym_number] = ACTIONS(1109),
    [anon_sym_boolean] = ACTIONS(1109),
    [anon_sym_string] = ACTIONS(1109),
    [anon_sym_symbol] = ACTIONS(1109),
    [anon_sym_object] = ACTIONS(1109),
    [anon_sym_abstract] = ACTIONS(1101),
    [anon_sym_infer] = ACTIONS(1103),
    [anon_sym_keyof] = ACTIONS(1105),
    [anon_sym_unique] = ACTIONS(1107),
    [anon_sym_unknown] = ACTIONS(1109),
    [anon_sym_never] = ACTIONS(1109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1111),
    [sym_html_comment] = ACTIONS(5),
  },
  [1111] = {
    [sym_nested_identifier] = STATE(6123),
    [sym_string] = STATE(3650),
    [sym_comment] = STATE(1111),
    [sym_formal_parameters] = STATE(6329),
    [sym_nested_type_identifier] = STATE(3475),
    [sym__type] = STATE(3647),
    [sym_constructor_type] = STATE(3735),
    [sym__primary_type] = STATE(3709),
    [sym_template_literal_type] = STATE(3706),
    [sym_infer_type] = STATE(3735),
    [sym_conditional_type] = STATE(3706),
    [sym_generic_type] = STATE(3706),
    [sym_type_query] = STATE(3706),
    [sym_index_type_query] = STATE(3706),
    [sym_lookup_type] = STATE(3706),
    [sym_literal_type] = STATE(3706),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3706),
    [sym_flow_maybe_type] = STATE(3706),
    [sym_parenthesized_type] = STATE(3706),
    [sym_predefined_type] = STATE(3706),
    [sym_object_type] = STATE(3706),
    [sym_type_parameters] = STATE(5682),
    [sym_array_type] = STATE(3706),
    [sym_tuple_type] = STATE(3706),
    [sym_readonly_type] = STATE(3735),
    [sym_union_type] = STATE(3706),
    [sym_intersection_type] = STATE(3706),
    [sym_function_type] = STATE(3735),
    [sym_identifier] = ACTIONS(3634),
    [anon_sym_STAR] = ACTIONS(3313),
    [anon_sym_LBRACE] = ACTIONS(3315),
    [anon_sym_typeof] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_LPAREN] = ACTIONS(3321),
    [anon_sym_LBRACK] = ACTIONS(3323),
    [anon_sym_DQUOTE] = ACTIONS(3325),
    [anon_sym_SQUOTE] = ACTIONS(3327),
    [anon_sym_new] = ACTIONS(3329),
    [anon_sym_AMP] = ACTIONS(3331),
    [anon_sym_PIPE] = ACTIONS(3333),
    [anon_sym_PLUS] = ACTIONS(3335),
    [anon_sym_DASH] = ACTIONS(3335),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3337),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3339),
    [sym_number] = ACTIONS(3341),
    [sym_this] = ACTIONS(3636),
    [sym_true] = ACTIONS(3345),
    [sym_false] = ACTIONS(3345),
    [sym_null] = ACTIONS(3345),
    [sym_undefined] = ACTIONS(3345),
    [anon_sym_readonly] = ACTIONS(3347),
    [anon_sym_QMARK] = ACTIONS(3349),
    [anon_sym_any] = ACTIONS(3337),
    [anon_sym_number] = ACTIONS(3337),
    [anon_sym_boolean] = ACTIONS(3337),
    [anon_sym_string] = ACTIONS(3337),
    [anon_sym_symbol] = ACTIONS(3337),
    [anon_sym_object] = ACTIONS(3337),
    [anon_sym_abstract] = ACTIONS(3351),
    [anon_sym_infer] = ACTIONS(3355),
    [anon_sym_keyof] = ACTIONS(3357),
    [anon_sym_unique] = ACTIONS(3359),
    [anon_sym_unknown] = ACTIONS(3337),
    [anon_sym_never] = ACTIONS(3337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3361),
    [sym_html_comment] = ACTIONS(5),
  },
  [1112] = {
    [sym_nested_identifier] = STATE(6066),
    [sym_string] = STATE(1759),
    [sym_comment] = STATE(1112),
    [sym_formal_parameters] = STATE(6184),
    [sym_nested_type_identifier] = STATE(1744),
    [sym__type] = STATE(1809),
    [sym_constructor_type] = STATE(1761),
    [sym__primary_type] = STATE(1762),
    [sym_template_literal_type] = STATE(1745),
    [sym_infer_type] = STATE(1761),
    [sym_conditional_type] = STATE(1745),
    [sym_generic_type] = STATE(1745),
    [sym_type_query] = STATE(1745),
    [sym_index_type_query] = STATE(1745),
    [sym_lookup_type] = STATE(1745),
    [sym_literal_type] = STATE(1745),
    [sym__number] = STATE(1763),
    [sym_existential_type] = STATE(1745),
    [sym_flow_maybe_type] = STATE(1745),
    [sym_parenthesized_type] = STATE(1745),
    [sym_predefined_type] = STATE(1745),
    [sym_object_type] = STATE(1745),
    [sym_type_parameters] = STATE(5724),
    [sym_array_type] = STATE(1745),
    [sym_tuple_type] = STATE(1745),
    [sym_readonly_type] = STATE(1761),
    [sym_union_type] = STATE(1745),
    [sym_intersection_type] = STATE(1745),
    [sym_function_type] = STATE(1761),
    [sym_identifier] = ACTIONS(3630),
    [anon_sym_STAR] = ACTIONS(3552),
    [anon_sym_LBRACE] = ACTIONS(3554),
    [anon_sym_typeof] = ACTIONS(3556),
    [anon_sym_const] = ACTIONS(3647),
    [anon_sym_LPAREN] = ACTIONS(3560),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(3564),
    [anon_sym_AMP] = ACTIONS(3566),
    [anon_sym_PIPE] = ACTIONS(3568),
    [anon_sym_PLUS] = ACTIONS(3570),
    [anon_sym_DASH] = ACTIONS(3570),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3572),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3574),
    [sym_number] = ACTIONS(3576),
    [sym_this] = ACTIONS(3632),
    [sym_true] = ACTIONS(3580),
    [sym_false] = ACTIONS(3580),
    [sym_null] = ACTIONS(3580),
    [sym_undefined] = ACTIONS(3580),
    [anon_sym_readonly] = ACTIONS(3582),
    [anon_sym_QMARK] = ACTIONS(3584),
    [anon_sym_any] = ACTIONS(3572),
    [anon_sym_number] = ACTIONS(3572),
    [anon_sym_boolean] = ACTIONS(3572),
    [anon_sym_string] = ACTIONS(3572),
    [anon_sym_symbol] = ACTIONS(3572),
    [anon_sym_object] = ACTIONS(3572),
    [anon_sym_abstract] = ACTIONS(3586),
    [anon_sym_infer] = ACTIONS(3590),
    [anon_sym_keyof] = ACTIONS(3592),
    [anon_sym_unique] = ACTIONS(3594),
    [anon_sym_unknown] = ACTIONS(3572),
    [anon_sym_never] = ACTIONS(3572),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3596),
    [sym_html_comment] = ACTIONS(5),
  },
  [1113] = {
    [sym_nested_identifier] = STATE(6076),
    [sym_string] = STATE(3484),
    [sym_comment] = STATE(1113),
    [sym_formal_parameters] = STATE(5995),
    [sym_nested_type_identifier] = STATE(3366),
    [sym__type] = STATE(3497),
    [sym_constructor_type] = STATE(3468),
    [sym__primary_type] = STATE(3467),
    [sym_template_literal_type] = STATE(3466),
    [sym_infer_type] = STATE(3468),
    [sym_conditional_type] = STATE(3466),
    [sym_generic_type] = STATE(3466),
    [sym_type_query] = STATE(3466),
    [sym_index_type_query] = STATE(3466),
    [sym_lookup_type] = STATE(3466),
    [sym_literal_type] = STATE(3466),
    [sym__number] = STATE(3465),
    [sym_existential_type] = STATE(3466),
    [sym_flow_maybe_type] = STATE(3466),
    [sym_parenthesized_type] = STATE(3466),
    [sym_predefined_type] = STATE(3466),
    [sym_object_type] = STATE(3466),
    [sym_type_parameters] = STATE(5758),
    [sym_array_type] = STATE(3466),
    [sym_tuple_type] = STATE(3466),
    [sym_readonly_type] = STATE(3468),
    [sym_union_type] = STATE(3466),
    [sym_intersection_type] = STATE(3466),
    [sym_function_type] = STATE(3468),
    [sym_identifier] = ACTIONS(2002),
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_LBRACE] = ACTIONS(2006),
    [anon_sym_typeof] = ACTIONS(2008),
    [anon_sym_const] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(2010),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_new] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(1109),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [sym_number] = ACTIONS(2028),
    [sym_this] = ACTIONS(2030),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [sym_null] = ACTIONS(2032),
    [sym_undefined] = ACTIONS(2032),
    [anon_sym_readonly] = ACTIONS(2034),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1109),
    [anon_sym_number] = ACTIONS(1109),
    [anon_sym_boolean] = ACTIONS(1109),
    [anon_sym_string] = ACTIONS(1109),
    [anon_sym_symbol] = ACTIONS(1109),
    [anon_sym_object] = ACTIONS(1109),
    [anon_sym_abstract] = ACTIONS(1101),
    [anon_sym_infer] = ACTIONS(1103),
    [anon_sym_keyof] = ACTIONS(1105),
    [anon_sym_unique] = ACTIONS(1107),
    [anon_sym_unknown] = ACTIONS(1109),
    [anon_sym_never] = ACTIONS(1109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1111),
    [sym_html_comment] = ACTIONS(5),
  },
  [1114] = {
    [sym_nested_identifier] = STATE(5958),
    [sym_string] = STATE(2307),
    [sym_comment] = STATE(1114),
    [sym_formal_parameters] = STATE(6100),
    [sym_nested_type_identifier] = STATE(2121),
    [sym__type] = STATE(2256),
    [sym_constructor_type] = STATE(2353),
    [sym__primary_type] = STATE(2401),
    [sym_template_literal_type] = STATE(2397),
    [sym_infer_type] = STATE(2353),
    [sym_conditional_type] = STATE(2397),
    [sym_generic_type] = STATE(2397),
    [sym_type_query] = STATE(2397),
    [sym_index_type_query] = STATE(2397),
    [sym_lookup_type] = STATE(2397),
    [sym_literal_type] = STATE(2397),
    [sym__number] = STATE(2309),
    [sym_existential_type] = STATE(2397),
    [sym_flow_maybe_type] = STATE(2397),
    [sym_parenthesized_type] = STATE(2397),
    [sym_predefined_type] = STATE(2397),
    [sym_object_type] = STATE(2397),
    [sym_type_parameters] = STATE(5861),
    [sym_array_type] = STATE(2397),
    [sym_tuple_type] = STATE(2397),
    [sym_readonly_type] = STATE(2353),
    [sym_union_type] = STATE(2397),
    [sym_intersection_type] = STATE(2397),
    [sym_function_type] = STATE(2353),
    [sym_identifier] = ACTIONS(3626),
    [anon_sym_STAR] = ACTIONS(3504),
    [anon_sym_LBRACE] = ACTIONS(3506),
    [anon_sym_typeof] = ACTIONS(3508),
    [anon_sym_const] = ACTIONS(3510),
    [anon_sym_LPAREN] = ACTIONS(3512),
    [anon_sym_LBRACK] = ACTIONS(3514),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_new] = ACTIONS(3516),
    [anon_sym_AMP] = ACTIONS(3518),
    [anon_sym_PIPE] = ACTIONS(3520),
    [anon_sym_PLUS] = ACTIONS(3522),
    [anon_sym_DASH] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3524),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3526),
    [sym_number] = ACTIONS(3528),
    [sym_this] = ACTIONS(3628),
    [sym_true] = ACTIONS(3532),
    [sym_false] = ACTIONS(3532),
    [sym_null] = ACTIONS(3532),
    [sym_undefined] = ACTIONS(3532),
    [anon_sym_readonly] = ACTIONS(3534),
    [anon_sym_QMARK] = ACTIONS(3536),
    [anon_sym_any] = ACTIONS(3524),
    [anon_sym_number] = ACTIONS(3524),
    [anon_sym_boolean] = ACTIONS(3524),
    [anon_sym_string] = ACTIONS(3524),
    [anon_sym_symbol] = ACTIONS(3524),
    [anon_sym_object] = ACTIONS(3524),
    [anon_sym_abstract] = ACTIONS(3538),
    [anon_sym_infer] = ACTIONS(3542),
    [anon_sym_keyof] = ACTIONS(3544),
    [anon_sym_unique] = ACTIONS(3546),
    [anon_sym_unknown] = ACTIONS(3524),
    [anon_sym_never] = ACTIONS(3524),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3548),
    [sym_html_comment] = ACTIONS(5),
  },
  [1115] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1115),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4686),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1116] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1116),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4792),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1117] = {
    [sym_nested_identifier] = STATE(5958),
    [sym_string] = STATE(2307),
    [sym_comment] = STATE(1117),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(2121),
    [sym__type] = STATE(5025),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(2390),
    [sym_template_literal_type] = STATE(2397),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(2397),
    [sym_generic_type] = STATE(2397),
    [sym_type_query] = STATE(2397),
    [sym_index_type_query] = STATE(2397),
    [sym_lookup_type] = STATE(2397),
    [sym_literal_type] = STATE(2397),
    [sym__number] = STATE(2309),
    [sym_existential_type] = STATE(2397),
    [sym_flow_maybe_type] = STATE(2397),
    [sym_parenthesized_type] = STATE(2397),
    [sym_predefined_type] = STATE(2397),
    [sym_object_type] = STATE(2397),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(2397),
    [sym_tuple_type] = STATE(2397),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(2397),
    [sym_intersection_type] = STATE(2397),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3626),
    [anon_sym_STAR] = ACTIONS(3504),
    [anon_sym_LBRACE] = ACTIONS(3506),
    [anon_sym_typeof] = ACTIONS(3508),
    [anon_sym_const] = ACTIONS(3510),
    [anon_sym_LPAREN] = ACTIONS(3512),
    [anon_sym_LBRACK] = ACTIONS(3514),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(3518),
    [anon_sym_PIPE] = ACTIONS(3520),
    [anon_sym_PLUS] = ACTIONS(3522),
    [anon_sym_DASH] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3524),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3526),
    [sym_number] = ACTIONS(3528),
    [sym_this] = ACTIONS(3628),
    [sym_true] = ACTIONS(3532),
    [sym_false] = ACTIONS(3532),
    [sym_null] = ACTIONS(3532),
    [sym_undefined] = ACTIONS(3532),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(3536),
    [anon_sym_any] = ACTIONS(3524),
    [anon_sym_number] = ACTIONS(3524),
    [anon_sym_boolean] = ACTIONS(3524),
    [anon_sym_string] = ACTIONS(3524),
    [anon_sym_symbol] = ACTIONS(3524),
    [anon_sym_object] = ACTIONS(3524),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(3544),
    [anon_sym_unique] = ACTIONS(3546),
    [anon_sym_unknown] = ACTIONS(3524),
    [anon_sym_never] = ACTIONS(3524),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3548),
    [sym_html_comment] = ACTIONS(5),
  },
  [1118] = {
    [sym_nested_identifier] = STATE(6123),
    [sym_string] = STATE(3650),
    [sym_comment] = STATE(1118),
    [sym_formal_parameters] = STATE(6329),
    [sym_nested_type_identifier] = STATE(3475),
    [sym__type] = STATE(3551),
    [sym_constructor_type] = STATE(3735),
    [sym__primary_type] = STATE(3709),
    [sym_template_literal_type] = STATE(3706),
    [sym_infer_type] = STATE(3735),
    [sym_conditional_type] = STATE(3706),
    [sym_generic_type] = STATE(3706),
    [sym_type_query] = STATE(3706),
    [sym_index_type_query] = STATE(3706),
    [sym_lookup_type] = STATE(3706),
    [sym_literal_type] = STATE(3706),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3706),
    [sym_flow_maybe_type] = STATE(3706),
    [sym_parenthesized_type] = STATE(3706),
    [sym_predefined_type] = STATE(3706),
    [sym_object_type] = STATE(3706),
    [sym_type_parameters] = STATE(5682),
    [sym_array_type] = STATE(3706),
    [sym_tuple_type] = STATE(3706),
    [sym_readonly_type] = STATE(3735),
    [sym_union_type] = STATE(3706),
    [sym_intersection_type] = STATE(3706),
    [sym_function_type] = STATE(3735),
    [sym_identifier] = ACTIONS(3634),
    [anon_sym_STAR] = ACTIONS(3313),
    [anon_sym_LBRACE] = ACTIONS(3315),
    [anon_sym_typeof] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_LPAREN] = ACTIONS(3321),
    [anon_sym_LBRACK] = ACTIONS(3323),
    [anon_sym_DQUOTE] = ACTIONS(3325),
    [anon_sym_SQUOTE] = ACTIONS(3327),
    [anon_sym_new] = ACTIONS(3329),
    [anon_sym_AMP] = ACTIONS(3331),
    [anon_sym_PIPE] = ACTIONS(3333),
    [anon_sym_PLUS] = ACTIONS(3335),
    [anon_sym_DASH] = ACTIONS(3335),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3337),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3339),
    [sym_number] = ACTIONS(3341),
    [sym_this] = ACTIONS(3636),
    [sym_true] = ACTIONS(3345),
    [sym_false] = ACTIONS(3345),
    [sym_null] = ACTIONS(3345),
    [sym_undefined] = ACTIONS(3345),
    [anon_sym_readonly] = ACTIONS(3347),
    [anon_sym_QMARK] = ACTIONS(3349),
    [anon_sym_any] = ACTIONS(3337),
    [anon_sym_number] = ACTIONS(3337),
    [anon_sym_boolean] = ACTIONS(3337),
    [anon_sym_string] = ACTIONS(3337),
    [anon_sym_symbol] = ACTIONS(3337),
    [anon_sym_object] = ACTIONS(3337),
    [anon_sym_abstract] = ACTIONS(3351),
    [anon_sym_infer] = ACTIONS(3355),
    [anon_sym_keyof] = ACTIONS(3357),
    [anon_sym_unique] = ACTIONS(3359),
    [anon_sym_unknown] = ACTIONS(3337),
    [anon_sym_never] = ACTIONS(3337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3361),
    [sym_html_comment] = ACTIONS(5),
  },
  [1119] = {
    [sym_nested_identifier] = STATE(6076),
    [sym_string] = STATE(3484),
    [sym_comment] = STATE(1119),
    [sym_formal_parameters] = STATE(5995),
    [sym_nested_type_identifier] = STATE(3366),
    [sym__type] = STATE(4353),
    [sym_constructor_type] = STATE(3468),
    [sym__primary_type] = STATE(3467),
    [sym_template_literal_type] = STATE(3466),
    [sym_infer_type] = STATE(3468),
    [sym_conditional_type] = STATE(3466),
    [sym_generic_type] = STATE(3466),
    [sym_type_query] = STATE(3466),
    [sym_index_type_query] = STATE(3466),
    [sym_lookup_type] = STATE(3466),
    [sym_literal_type] = STATE(3466),
    [sym__number] = STATE(3465),
    [sym_existential_type] = STATE(3466),
    [sym_flow_maybe_type] = STATE(3466),
    [sym_parenthesized_type] = STATE(3466),
    [sym_predefined_type] = STATE(3466),
    [sym_object_type] = STATE(3466),
    [sym_type_parameters] = STATE(5758),
    [sym_array_type] = STATE(3466),
    [sym_tuple_type] = STATE(3466),
    [sym_readonly_type] = STATE(3468),
    [sym_union_type] = STATE(3466),
    [sym_intersection_type] = STATE(3466),
    [sym_function_type] = STATE(3468),
    [sym_identifier] = ACTIONS(2002),
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_LBRACE] = ACTIONS(2006),
    [anon_sym_typeof] = ACTIONS(2008),
    [anon_sym_const] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(2010),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_new] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(1109),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [sym_number] = ACTIONS(2028),
    [sym_this] = ACTIONS(2030),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [sym_null] = ACTIONS(2032),
    [sym_undefined] = ACTIONS(2032),
    [anon_sym_readonly] = ACTIONS(2034),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1109),
    [anon_sym_number] = ACTIONS(1109),
    [anon_sym_boolean] = ACTIONS(1109),
    [anon_sym_string] = ACTIONS(1109),
    [anon_sym_symbol] = ACTIONS(1109),
    [anon_sym_object] = ACTIONS(1109),
    [anon_sym_abstract] = ACTIONS(1101),
    [anon_sym_infer] = ACTIONS(1103),
    [anon_sym_keyof] = ACTIONS(1105),
    [anon_sym_unique] = ACTIONS(1107),
    [anon_sym_unknown] = ACTIONS(1109),
    [anon_sym_never] = ACTIONS(1109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1111),
    [sym_html_comment] = ACTIONS(5),
  },
  [1120] = {
    [sym_nested_identifier] = STATE(6076),
    [sym_string] = STATE(3484),
    [sym_comment] = STATE(1120),
    [sym_formal_parameters] = STATE(5995),
    [sym_nested_type_identifier] = STATE(3366),
    [sym__type] = STATE(3508),
    [sym_constructor_type] = STATE(3468),
    [sym__primary_type] = STATE(3467),
    [sym_template_literal_type] = STATE(3466),
    [sym_infer_type] = STATE(3468),
    [sym_conditional_type] = STATE(3466),
    [sym_generic_type] = STATE(3466),
    [sym_type_query] = STATE(3466),
    [sym_index_type_query] = STATE(3466),
    [sym_lookup_type] = STATE(3466),
    [sym_literal_type] = STATE(3466),
    [sym__number] = STATE(3465),
    [sym_existential_type] = STATE(3466),
    [sym_flow_maybe_type] = STATE(3466),
    [sym_parenthesized_type] = STATE(3466),
    [sym_predefined_type] = STATE(3466),
    [sym_object_type] = STATE(3466),
    [sym_type_parameters] = STATE(5758),
    [sym_array_type] = STATE(3466),
    [sym_tuple_type] = STATE(3466),
    [sym_readonly_type] = STATE(3468),
    [sym_union_type] = STATE(3466),
    [sym_intersection_type] = STATE(3466),
    [sym_function_type] = STATE(3468),
    [sym_identifier] = ACTIONS(2002),
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_LBRACE] = ACTIONS(2006),
    [anon_sym_typeof] = ACTIONS(2008),
    [anon_sym_const] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(2010),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_new] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(1109),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [sym_number] = ACTIONS(2028),
    [sym_this] = ACTIONS(2030),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [sym_null] = ACTIONS(2032),
    [sym_undefined] = ACTIONS(2032),
    [anon_sym_readonly] = ACTIONS(2034),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1109),
    [anon_sym_number] = ACTIONS(1109),
    [anon_sym_boolean] = ACTIONS(1109),
    [anon_sym_string] = ACTIONS(1109),
    [anon_sym_symbol] = ACTIONS(1109),
    [anon_sym_object] = ACTIONS(1109),
    [anon_sym_abstract] = ACTIONS(1101),
    [anon_sym_infer] = ACTIONS(1103),
    [anon_sym_keyof] = ACTIONS(1105),
    [anon_sym_unique] = ACTIONS(1107),
    [anon_sym_unknown] = ACTIONS(1109),
    [anon_sym_never] = ACTIONS(1109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1111),
    [sym_html_comment] = ACTIONS(5),
  },
  [1121] = {
    [sym_nested_identifier] = STATE(6076),
    [sym_string] = STATE(3484),
    [sym_comment] = STATE(1121),
    [sym_formal_parameters] = STATE(5995),
    [sym_nested_type_identifier] = STATE(3366),
    [sym__type] = STATE(3513),
    [sym_constructor_type] = STATE(3468),
    [sym__primary_type] = STATE(3467),
    [sym_template_literal_type] = STATE(3466),
    [sym_infer_type] = STATE(3468),
    [sym_conditional_type] = STATE(3466),
    [sym_generic_type] = STATE(3466),
    [sym_type_query] = STATE(3466),
    [sym_index_type_query] = STATE(3466),
    [sym_lookup_type] = STATE(3466),
    [sym_literal_type] = STATE(3466),
    [sym__number] = STATE(3465),
    [sym_existential_type] = STATE(3466),
    [sym_flow_maybe_type] = STATE(3466),
    [sym_parenthesized_type] = STATE(3466),
    [sym_predefined_type] = STATE(3466),
    [sym_object_type] = STATE(3466),
    [sym_type_parameters] = STATE(5758),
    [sym_array_type] = STATE(3466),
    [sym_tuple_type] = STATE(3466),
    [sym_readonly_type] = STATE(3468),
    [sym_union_type] = STATE(3466),
    [sym_intersection_type] = STATE(3466),
    [sym_function_type] = STATE(3468),
    [sym_identifier] = ACTIONS(2002),
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_LBRACE] = ACTIONS(2006),
    [anon_sym_typeof] = ACTIONS(2008),
    [anon_sym_const] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(2010),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_new] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(1109),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [sym_number] = ACTIONS(2028),
    [sym_this] = ACTIONS(2030),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [sym_null] = ACTIONS(2032),
    [sym_undefined] = ACTIONS(2032),
    [anon_sym_readonly] = ACTIONS(2034),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1109),
    [anon_sym_number] = ACTIONS(1109),
    [anon_sym_boolean] = ACTIONS(1109),
    [anon_sym_string] = ACTIONS(1109),
    [anon_sym_symbol] = ACTIONS(1109),
    [anon_sym_object] = ACTIONS(1109),
    [anon_sym_abstract] = ACTIONS(1101),
    [anon_sym_infer] = ACTIONS(1103),
    [anon_sym_keyof] = ACTIONS(1105),
    [anon_sym_unique] = ACTIONS(1107),
    [anon_sym_unknown] = ACTIONS(1109),
    [anon_sym_never] = ACTIONS(1109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1111),
    [sym_html_comment] = ACTIONS(5),
  },
  [1122] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1122),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(3205),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1123] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1123),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(3279),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1124] = {
    [sym_nested_identifier] = STATE(6076),
    [sym_string] = STATE(3484),
    [sym_comment] = STATE(1124),
    [sym_formal_parameters] = STATE(5995),
    [sym_nested_type_identifier] = STATE(3366),
    [sym__type] = STATE(4578),
    [sym_constructor_type] = STATE(3468),
    [sym__primary_type] = STATE(3467),
    [sym_template_literal_type] = STATE(3466),
    [sym_infer_type] = STATE(3468),
    [sym_conditional_type] = STATE(3466),
    [sym_generic_type] = STATE(3466),
    [sym_type_query] = STATE(3466),
    [sym_index_type_query] = STATE(3466),
    [sym_lookup_type] = STATE(3466),
    [sym_literal_type] = STATE(3466),
    [sym__number] = STATE(3465),
    [sym_existential_type] = STATE(3466),
    [sym_flow_maybe_type] = STATE(3466),
    [sym_parenthesized_type] = STATE(3466),
    [sym_predefined_type] = STATE(3466),
    [sym_object_type] = STATE(3466),
    [sym_type_parameters] = STATE(5758),
    [sym_array_type] = STATE(3466),
    [sym_tuple_type] = STATE(3466),
    [sym_readonly_type] = STATE(3468),
    [sym_union_type] = STATE(3466),
    [sym_intersection_type] = STATE(3466),
    [sym_function_type] = STATE(3468),
    [sym_identifier] = ACTIONS(2002),
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_LBRACE] = ACTIONS(2006),
    [anon_sym_typeof] = ACTIONS(2008),
    [anon_sym_const] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(2010),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_new] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(1109),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [sym_number] = ACTIONS(2028),
    [sym_this] = ACTIONS(2030),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [sym_null] = ACTIONS(2032),
    [sym_undefined] = ACTIONS(2032),
    [anon_sym_readonly] = ACTIONS(2034),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1109),
    [anon_sym_number] = ACTIONS(1109),
    [anon_sym_boolean] = ACTIONS(1109),
    [anon_sym_string] = ACTIONS(1109),
    [anon_sym_symbol] = ACTIONS(1109),
    [anon_sym_object] = ACTIONS(1109),
    [anon_sym_abstract] = ACTIONS(1101),
    [anon_sym_infer] = ACTIONS(1103),
    [anon_sym_keyof] = ACTIONS(1105),
    [anon_sym_unique] = ACTIONS(1107),
    [anon_sym_unknown] = ACTIONS(1109),
    [anon_sym_never] = ACTIONS(1109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1111),
    [sym_html_comment] = ACTIONS(5),
  },
  [1125] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1125),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(3211),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1126] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1126),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(3293),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1127] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1127),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4840),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1128] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1128),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4765),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1129] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1129),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4780),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1130] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1130),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4751),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1131] = {
    [sym_nested_identifier] = STATE(6099),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1131),
    [sym_formal_parameters] = STATE(6035),
    [sym_nested_type_identifier] = STATE(3747),
    [sym__type] = STATE(4604),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5617),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3638),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_typeof] = ACTIONS(3478),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_AMP] = ACTIONS(3482),
    [anon_sym_PIPE] = ACTIONS(3484),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(3488),
    [anon_sym_QMARK] = ACTIONS(3490),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(3492),
    [anon_sym_infer] = ACTIONS(3496),
    [anon_sym_keyof] = ACTIONS(3498),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3500),
    [sym_html_comment] = ACTIONS(5),
  },
  [1132] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1132),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4755),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1133] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1133),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4769),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1134] = {
    [sym_nested_identifier] = STATE(5958),
    [sym_string] = STATE(2307),
    [sym_comment] = STATE(1134),
    [sym_formal_parameters] = STATE(6100),
    [sym_nested_type_identifier] = STATE(2121),
    [sym__type] = STATE(2296),
    [sym_constructor_type] = STATE(2353),
    [sym__primary_type] = STATE(2401),
    [sym_template_literal_type] = STATE(2397),
    [sym_infer_type] = STATE(2353),
    [sym_conditional_type] = STATE(2397),
    [sym_generic_type] = STATE(2397),
    [sym_type_query] = STATE(2397),
    [sym_index_type_query] = STATE(2397),
    [sym_lookup_type] = STATE(2397),
    [sym_literal_type] = STATE(2397),
    [sym__number] = STATE(2309),
    [sym_existential_type] = STATE(2397),
    [sym_flow_maybe_type] = STATE(2397),
    [sym_parenthesized_type] = STATE(2397),
    [sym_predefined_type] = STATE(2397),
    [sym_object_type] = STATE(2397),
    [sym_type_parameters] = STATE(5861),
    [sym_array_type] = STATE(2397),
    [sym_tuple_type] = STATE(2397),
    [sym_readonly_type] = STATE(2353),
    [sym_union_type] = STATE(2397),
    [sym_intersection_type] = STATE(2397),
    [sym_function_type] = STATE(2353),
    [sym_identifier] = ACTIONS(3626),
    [anon_sym_STAR] = ACTIONS(3504),
    [anon_sym_LBRACE] = ACTIONS(3506),
    [anon_sym_typeof] = ACTIONS(3508),
    [anon_sym_const] = ACTIONS(3510),
    [anon_sym_LPAREN] = ACTIONS(3512),
    [anon_sym_LBRACK] = ACTIONS(3514),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_new] = ACTIONS(3516),
    [anon_sym_AMP] = ACTIONS(3518),
    [anon_sym_PIPE] = ACTIONS(3520),
    [anon_sym_PLUS] = ACTIONS(3522),
    [anon_sym_DASH] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3524),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3526),
    [sym_number] = ACTIONS(3528),
    [sym_this] = ACTIONS(3628),
    [sym_true] = ACTIONS(3532),
    [sym_false] = ACTIONS(3532),
    [sym_null] = ACTIONS(3532),
    [sym_undefined] = ACTIONS(3532),
    [anon_sym_readonly] = ACTIONS(3534),
    [anon_sym_QMARK] = ACTIONS(3536),
    [anon_sym_any] = ACTIONS(3524),
    [anon_sym_number] = ACTIONS(3524),
    [anon_sym_boolean] = ACTIONS(3524),
    [anon_sym_string] = ACTIONS(3524),
    [anon_sym_symbol] = ACTIONS(3524),
    [anon_sym_object] = ACTIONS(3524),
    [anon_sym_abstract] = ACTIONS(3538),
    [anon_sym_infer] = ACTIONS(3542),
    [anon_sym_keyof] = ACTIONS(3544),
    [anon_sym_unique] = ACTIONS(3546),
    [anon_sym_unknown] = ACTIONS(3524),
    [anon_sym_never] = ACTIONS(3524),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3548),
    [sym_html_comment] = ACTIONS(5),
  },
  [1135] = {
    [sym_nested_identifier] = STATE(5958),
    [sym_string] = STATE(2307),
    [sym_comment] = STATE(1135),
    [sym_formal_parameters] = STATE(6100),
    [sym_nested_type_identifier] = STATE(2121),
    [sym__type] = STATE(2422),
    [sym_constructor_type] = STATE(2353),
    [sym__primary_type] = STATE(2401),
    [sym_template_literal_type] = STATE(2397),
    [sym_infer_type] = STATE(2353),
    [sym_conditional_type] = STATE(2397),
    [sym_generic_type] = STATE(2397),
    [sym_type_query] = STATE(2397),
    [sym_index_type_query] = STATE(2397),
    [sym_lookup_type] = STATE(2397),
    [sym_literal_type] = STATE(2397),
    [sym__number] = STATE(2309),
    [sym_existential_type] = STATE(2397),
    [sym_flow_maybe_type] = STATE(2397),
    [sym_parenthesized_type] = STATE(2397),
    [sym_predefined_type] = STATE(2397),
    [sym_object_type] = STATE(2397),
    [sym_type_parameters] = STATE(5861),
    [sym_array_type] = STATE(2397),
    [sym_tuple_type] = STATE(2397),
    [sym_readonly_type] = STATE(2353),
    [sym_union_type] = STATE(2397),
    [sym_intersection_type] = STATE(2397),
    [sym_function_type] = STATE(2353),
    [sym_identifier] = ACTIONS(3626),
    [anon_sym_STAR] = ACTIONS(3504),
    [anon_sym_LBRACE] = ACTIONS(3506),
    [anon_sym_typeof] = ACTIONS(3508),
    [anon_sym_const] = ACTIONS(3510),
    [anon_sym_LPAREN] = ACTIONS(3512),
    [anon_sym_LBRACK] = ACTIONS(3514),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_new] = ACTIONS(3516),
    [anon_sym_AMP] = ACTIONS(3518),
    [anon_sym_PIPE] = ACTIONS(3520),
    [anon_sym_PLUS] = ACTIONS(3522),
    [anon_sym_DASH] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3524),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3526),
    [sym_number] = ACTIONS(3528),
    [sym_this] = ACTIONS(3628),
    [sym_true] = ACTIONS(3532),
    [sym_false] = ACTIONS(3532),
    [sym_null] = ACTIONS(3532),
    [sym_undefined] = ACTIONS(3532),
    [anon_sym_readonly] = ACTIONS(3534),
    [anon_sym_QMARK] = ACTIONS(3536),
    [anon_sym_any] = ACTIONS(3524),
    [anon_sym_number] = ACTIONS(3524),
    [anon_sym_boolean] = ACTIONS(3524),
    [anon_sym_string] = ACTIONS(3524),
    [anon_sym_symbol] = ACTIONS(3524),
    [anon_sym_object] = ACTIONS(3524),
    [anon_sym_abstract] = ACTIONS(3538),
    [anon_sym_infer] = ACTIONS(3542),
    [anon_sym_keyof] = ACTIONS(3544),
    [anon_sym_unique] = ACTIONS(3546),
    [anon_sym_unknown] = ACTIONS(3524),
    [anon_sym_never] = ACTIONS(3524),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3548),
    [sym_html_comment] = ACTIONS(5),
  },
  [1136] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1136),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(3204),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1137] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1137),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4073),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1138] = {
    [sym_nested_identifier] = STATE(6066),
    [sym_string] = STATE(1759),
    [sym_comment] = STATE(1138),
    [sym_formal_parameters] = STATE(6184),
    [sym_nested_type_identifier] = STATE(1744),
    [sym__type] = STATE(1853),
    [sym_constructor_type] = STATE(1761),
    [sym__primary_type] = STATE(1762),
    [sym_template_literal_type] = STATE(1745),
    [sym_infer_type] = STATE(1761),
    [sym_conditional_type] = STATE(1745),
    [sym_generic_type] = STATE(1745),
    [sym_type_query] = STATE(1745),
    [sym_index_type_query] = STATE(1745),
    [sym_lookup_type] = STATE(1745),
    [sym_literal_type] = STATE(1745),
    [sym__number] = STATE(1763),
    [sym_existential_type] = STATE(1745),
    [sym_flow_maybe_type] = STATE(1745),
    [sym_parenthesized_type] = STATE(1745),
    [sym_predefined_type] = STATE(1745),
    [sym_object_type] = STATE(1745),
    [sym_type_parameters] = STATE(5724),
    [sym_array_type] = STATE(1745),
    [sym_tuple_type] = STATE(1745),
    [sym_readonly_type] = STATE(1761),
    [sym_union_type] = STATE(1745),
    [sym_intersection_type] = STATE(1745),
    [sym_function_type] = STATE(1761),
    [sym_identifier] = ACTIONS(3630),
    [anon_sym_STAR] = ACTIONS(3552),
    [anon_sym_LBRACE] = ACTIONS(3554),
    [anon_sym_typeof] = ACTIONS(3556),
    [anon_sym_const] = ACTIONS(3558),
    [anon_sym_LPAREN] = ACTIONS(3560),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(3564),
    [anon_sym_AMP] = ACTIONS(3566),
    [anon_sym_PIPE] = ACTIONS(3568),
    [anon_sym_PLUS] = ACTIONS(3570),
    [anon_sym_DASH] = ACTIONS(3570),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3572),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3574),
    [sym_number] = ACTIONS(3576),
    [sym_this] = ACTIONS(3632),
    [sym_true] = ACTIONS(3580),
    [sym_false] = ACTIONS(3580),
    [sym_null] = ACTIONS(3580),
    [sym_undefined] = ACTIONS(3580),
    [anon_sym_readonly] = ACTIONS(3582),
    [anon_sym_QMARK] = ACTIONS(3584),
    [anon_sym_any] = ACTIONS(3572),
    [anon_sym_number] = ACTIONS(3572),
    [anon_sym_boolean] = ACTIONS(3572),
    [anon_sym_string] = ACTIONS(3572),
    [anon_sym_symbol] = ACTIONS(3572),
    [anon_sym_object] = ACTIONS(3572),
    [anon_sym_abstract] = ACTIONS(3586),
    [anon_sym_infer] = ACTIONS(3590),
    [anon_sym_keyof] = ACTIONS(3592),
    [anon_sym_unique] = ACTIONS(3594),
    [anon_sym_unknown] = ACTIONS(3572),
    [anon_sym_never] = ACTIONS(3572),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3596),
    [sym_html_comment] = ACTIONS(5),
  },
  [1139] = {
    [sym_nested_identifier] = STATE(5958),
    [sym_string] = STATE(2307),
    [sym_comment] = STATE(1139),
    [sym_formal_parameters] = STATE(6100),
    [sym_nested_type_identifier] = STATE(2121),
    [sym__type] = STATE(2258),
    [sym_constructor_type] = STATE(2353),
    [sym__primary_type] = STATE(2401),
    [sym_template_literal_type] = STATE(2397),
    [sym_infer_type] = STATE(2353),
    [sym_conditional_type] = STATE(2397),
    [sym_generic_type] = STATE(2397),
    [sym_type_query] = STATE(2397),
    [sym_index_type_query] = STATE(2397),
    [sym_lookup_type] = STATE(2397),
    [sym_literal_type] = STATE(2397),
    [sym__number] = STATE(2309),
    [sym_existential_type] = STATE(2397),
    [sym_flow_maybe_type] = STATE(2397),
    [sym_parenthesized_type] = STATE(2397),
    [sym_predefined_type] = STATE(2397),
    [sym_object_type] = STATE(2397),
    [sym_type_parameters] = STATE(5861),
    [sym_array_type] = STATE(2397),
    [sym_tuple_type] = STATE(2397),
    [sym_readonly_type] = STATE(2353),
    [sym_union_type] = STATE(2397),
    [sym_intersection_type] = STATE(2397),
    [sym_function_type] = STATE(2353),
    [sym_identifier] = ACTIONS(3626),
    [anon_sym_STAR] = ACTIONS(3504),
    [anon_sym_LBRACE] = ACTIONS(3506),
    [anon_sym_typeof] = ACTIONS(3508),
    [anon_sym_const] = ACTIONS(3510),
    [anon_sym_LPAREN] = ACTIONS(3512),
    [anon_sym_LBRACK] = ACTIONS(3514),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_new] = ACTIONS(3516),
    [anon_sym_AMP] = ACTIONS(3518),
    [anon_sym_PIPE] = ACTIONS(3520),
    [anon_sym_PLUS] = ACTIONS(3522),
    [anon_sym_DASH] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3524),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3526),
    [sym_number] = ACTIONS(3528),
    [sym_this] = ACTIONS(3628),
    [sym_true] = ACTIONS(3532),
    [sym_false] = ACTIONS(3532),
    [sym_null] = ACTIONS(3532),
    [sym_undefined] = ACTIONS(3532),
    [anon_sym_readonly] = ACTIONS(3534),
    [anon_sym_QMARK] = ACTIONS(3536),
    [anon_sym_any] = ACTIONS(3524),
    [anon_sym_number] = ACTIONS(3524),
    [anon_sym_boolean] = ACTIONS(3524),
    [anon_sym_string] = ACTIONS(3524),
    [anon_sym_symbol] = ACTIONS(3524),
    [anon_sym_object] = ACTIONS(3524),
    [anon_sym_abstract] = ACTIONS(3538),
    [anon_sym_infer] = ACTIONS(3542),
    [anon_sym_keyof] = ACTIONS(3544),
    [anon_sym_unique] = ACTIONS(3546),
    [anon_sym_unknown] = ACTIONS(3524),
    [anon_sym_never] = ACTIONS(3524),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3548),
    [sym_html_comment] = ACTIONS(5),
  },
  [1140] = {
    [sym_nested_identifier] = STATE(6066),
    [sym_string] = STATE(1759),
    [sym_comment] = STATE(1140),
    [sym_formal_parameters] = STATE(6184),
    [sym_nested_type_identifier] = STATE(1744),
    [sym__type] = STATE(1854),
    [sym_constructor_type] = STATE(1761),
    [sym__primary_type] = STATE(1762),
    [sym_template_literal_type] = STATE(1745),
    [sym_infer_type] = STATE(1761),
    [sym_conditional_type] = STATE(1745),
    [sym_generic_type] = STATE(1745),
    [sym_type_query] = STATE(1745),
    [sym_index_type_query] = STATE(1745),
    [sym_lookup_type] = STATE(1745),
    [sym_literal_type] = STATE(1745),
    [sym__number] = STATE(1763),
    [sym_existential_type] = STATE(1745),
    [sym_flow_maybe_type] = STATE(1745),
    [sym_parenthesized_type] = STATE(1745),
    [sym_predefined_type] = STATE(1745),
    [sym_object_type] = STATE(1745),
    [sym_type_parameters] = STATE(5724),
    [sym_array_type] = STATE(1745),
    [sym_tuple_type] = STATE(1745),
    [sym_readonly_type] = STATE(1761),
    [sym_union_type] = STATE(1745),
    [sym_intersection_type] = STATE(1745),
    [sym_function_type] = STATE(1761),
    [sym_identifier] = ACTIONS(3630),
    [anon_sym_STAR] = ACTIONS(3552),
    [anon_sym_LBRACE] = ACTIONS(3554),
    [anon_sym_typeof] = ACTIONS(3556),
    [anon_sym_const] = ACTIONS(3558),
    [anon_sym_LPAREN] = ACTIONS(3560),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(3564),
    [anon_sym_AMP] = ACTIONS(3566),
    [anon_sym_PIPE] = ACTIONS(3568),
    [anon_sym_PLUS] = ACTIONS(3570),
    [anon_sym_DASH] = ACTIONS(3570),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3572),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3574),
    [sym_number] = ACTIONS(3576),
    [sym_this] = ACTIONS(3632),
    [sym_true] = ACTIONS(3580),
    [sym_false] = ACTIONS(3580),
    [sym_null] = ACTIONS(3580),
    [sym_undefined] = ACTIONS(3580),
    [anon_sym_readonly] = ACTIONS(3582),
    [anon_sym_QMARK] = ACTIONS(3584),
    [anon_sym_any] = ACTIONS(3572),
    [anon_sym_number] = ACTIONS(3572),
    [anon_sym_boolean] = ACTIONS(3572),
    [anon_sym_string] = ACTIONS(3572),
    [anon_sym_symbol] = ACTIONS(3572),
    [anon_sym_object] = ACTIONS(3572),
    [anon_sym_abstract] = ACTIONS(3586),
    [anon_sym_infer] = ACTIONS(3590),
    [anon_sym_keyof] = ACTIONS(3592),
    [anon_sym_unique] = ACTIONS(3594),
    [anon_sym_unknown] = ACTIONS(3572),
    [anon_sym_never] = ACTIONS(3572),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3596),
    [sym_html_comment] = ACTIONS(5),
  },
  [1141] = {
    [sym_nested_identifier] = STATE(6066),
    [sym_string] = STATE(1759),
    [sym_comment] = STATE(1141),
    [sym_formal_parameters] = STATE(6184),
    [sym_nested_type_identifier] = STATE(1744),
    [sym__type] = STATE(1860),
    [sym_constructor_type] = STATE(1761),
    [sym__primary_type] = STATE(1762),
    [sym_template_literal_type] = STATE(1745),
    [sym_infer_type] = STATE(1761),
    [sym_conditional_type] = STATE(1745),
    [sym_generic_type] = STATE(1745),
    [sym_type_query] = STATE(1745),
    [sym_index_type_query] = STATE(1745),
    [sym_lookup_type] = STATE(1745),
    [sym_literal_type] = STATE(1745),
    [sym__number] = STATE(1763),
    [sym_existential_type] = STATE(1745),
    [sym_flow_maybe_type] = STATE(1745),
    [sym_parenthesized_type] = STATE(1745),
    [sym_predefined_type] = STATE(1745),
    [sym_object_type] = STATE(1745),
    [sym_type_parameters] = STATE(5724),
    [sym_array_type] = STATE(1745),
    [sym_tuple_type] = STATE(1745),
    [sym_readonly_type] = STATE(1761),
    [sym_union_type] = STATE(1745),
    [sym_intersection_type] = STATE(1745),
    [sym_function_type] = STATE(1761),
    [sym_identifier] = ACTIONS(3630),
    [anon_sym_STAR] = ACTIONS(3552),
    [anon_sym_LBRACE] = ACTIONS(3554),
    [anon_sym_typeof] = ACTIONS(3556),
    [anon_sym_const] = ACTIONS(3558),
    [anon_sym_LPAREN] = ACTIONS(3560),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(3564),
    [anon_sym_AMP] = ACTIONS(3566),
    [anon_sym_PIPE] = ACTIONS(3568),
    [anon_sym_PLUS] = ACTIONS(3570),
    [anon_sym_DASH] = ACTIONS(3570),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3572),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3574),
    [sym_number] = ACTIONS(3576),
    [sym_this] = ACTIONS(3632),
    [sym_true] = ACTIONS(3580),
    [sym_false] = ACTIONS(3580),
    [sym_null] = ACTIONS(3580),
    [sym_undefined] = ACTIONS(3580),
    [anon_sym_readonly] = ACTIONS(3582),
    [anon_sym_QMARK] = ACTIONS(3584),
    [anon_sym_any] = ACTIONS(3572),
    [anon_sym_number] = ACTIONS(3572),
    [anon_sym_boolean] = ACTIONS(3572),
    [anon_sym_string] = ACTIONS(3572),
    [anon_sym_symbol] = ACTIONS(3572),
    [anon_sym_object] = ACTIONS(3572),
    [anon_sym_abstract] = ACTIONS(3586),
    [anon_sym_infer] = ACTIONS(3590),
    [anon_sym_keyof] = ACTIONS(3592),
    [anon_sym_unique] = ACTIONS(3594),
    [anon_sym_unknown] = ACTIONS(3572),
    [anon_sym_never] = ACTIONS(3572),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3596),
    [sym_html_comment] = ACTIONS(5),
  },
  [1142] = {
    [sym_nested_identifier] = STATE(6066),
    [sym_string] = STATE(1759),
    [sym_comment] = STATE(1142),
    [sym_formal_parameters] = STATE(6184),
    [sym_nested_type_identifier] = STATE(1744),
    [sym__type] = STATE(1861),
    [sym_constructor_type] = STATE(1761),
    [sym__primary_type] = STATE(1762),
    [sym_template_literal_type] = STATE(1745),
    [sym_infer_type] = STATE(1761),
    [sym_conditional_type] = STATE(1745),
    [sym_generic_type] = STATE(1745),
    [sym_type_query] = STATE(1745),
    [sym_index_type_query] = STATE(1745),
    [sym_lookup_type] = STATE(1745),
    [sym_literal_type] = STATE(1745),
    [sym__number] = STATE(1763),
    [sym_existential_type] = STATE(1745),
    [sym_flow_maybe_type] = STATE(1745),
    [sym_parenthesized_type] = STATE(1745),
    [sym_predefined_type] = STATE(1745),
    [sym_object_type] = STATE(1745),
    [sym_type_parameters] = STATE(5724),
    [sym_array_type] = STATE(1745),
    [sym_tuple_type] = STATE(1745),
    [sym_readonly_type] = STATE(1761),
    [sym_union_type] = STATE(1745),
    [sym_intersection_type] = STATE(1745),
    [sym_function_type] = STATE(1761),
    [sym_identifier] = ACTIONS(3630),
    [anon_sym_STAR] = ACTIONS(3552),
    [anon_sym_LBRACE] = ACTIONS(3554),
    [anon_sym_typeof] = ACTIONS(3556),
    [anon_sym_const] = ACTIONS(3558),
    [anon_sym_LPAREN] = ACTIONS(3560),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(3564),
    [anon_sym_AMP] = ACTIONS(3566),
    [anon_sym_PIPE] = ACTIONS(3568),
    [anon_sym_PLUS] = ACTIONS(3570),
    [anon_sym_DASH] = ACTIONS(3570),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3572),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3574),
    [sym_number] = ACTIONS(3576),
    [sym_this] = ACTIONS(3632),
    [sym_true] = ACTIONS(3580),
    [sym_false] = ACTIONS(3580),
    [sym_null] = ACTIONS(3580),
    [sym_undefined] = ACTIONS(3580),
    [anon_sym_readonly] = ACTIONS(3582),
    [anon_sym_QMARK] = ACTIONS(3584),
    [anon_sym_any] = ACTIONS(3572),
    [anon_sym_number] = ACTIONS(3572),
    [anon_sym_boolean] = ACTIONS(3572),
    [anon_sym_string] = ACTIONS(3572),
    [anon_sym_symbol] = ACTIONS(3572),
    [anon_sym_object] = ACTIONS(3572),
    [anon_sym_abstract] = ACTIONS(3586),
    [anon_sym_infer] = ACTIONS(3590),
    [anon_sym_keyof] = ACTIONS(3592),
    [anon_sym_unique] = ACTIONS(3594),
    [anon_sym_unknown] = ACTIONS(3572),
    [anon_sym_never] = ACTIONS(3572),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3596),
    [sym_html_comment] = ACTIONS(5),
  },
  [1143] = {
    [sym_nested_identifier] = STATE(6099),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1143),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3747),
    [sym__type] = STATE(5023),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3281),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3638),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_typeof] = ACTIONS(3478),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(3482),
    [anon_sym_PIPE] = ACTIONS(3484),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(3490),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(3498),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3500),
    [sym_html_comment] = ACTIONS(5),
  },
  [1144] = {
    [sym_nested_identifier] = STATE(6076),
    [sym_string] = STATE(3484),
    [sym_comment] = STATE(1144),
    [sym_formal_parameters] = STATE(5995),
    [sym_nested_type_identifier] = STATE(3366),
    [sym__type] = STATE(4501),
    [sym_constructor_type] = STATE(3468),
    [sym__primary_type] = STATE(3467),
    [sym_template_literal_type] = STATE(3466),
    [sym_infer_type] = STATE(3468),
    [sym_conditional_type] = STATE(3466),
    [sym_generic_type] = STATE(3466),
    [sym_type_query] = STATE(3466),
    [sym_index_type_query] = STATE(3466),
    [sym_lookup_type] = STATE(3466),
    [sym_literal_type] = STATE(3466),
    [sym__number] = STATE(3465),
    [sym_existential_type] = STATE(3466),
    [sym_flow_maybe_type] = STATE(3466),
    [sym_parenthesized_type] = STATE(3466),
    [sym_predefined_type] = STATE(3466),
    [sym_object_type] = STATE(3466),
    [sym_type_parameters] = STATE(5758),
    [sym_array_type] = STATE(3466),
    [sym_tuple_type] = STATE(3466),
    [sym_readonly_type] = STATE(3468),
    [sym_union_type] = STATE(3466),
    [sym_intersection_type] = STATE(3466),
    [sym_function_type] = STATE(3468),
    [sym_identifier] = ACTIONS(2002),
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_LBRACE] = ACTIONS(2006),
    [anon_sym_typeof] = ACTIONS(2008),
    [anon_sym_const] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(2010),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_new] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(1109),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [sym_number] = ACTIONS(2028),
    [sym_this] = ACTIONS(2030),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [sym_null] = ACTIONS(2032),
    [sym_undefined] = ACTIONS(2032),
    [anon_sym_readonly] = ACTIONS(2034),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1109),
    [anon_sym_number] = ACTIONS(1109),
    [anon_sym_boolean] = ACTIONS(1109),
    [anon_sym_string] = ACTIONS(1109),
    [anon_sym_symbol] = ACTIONS(1109),
    [anon_sym_object] = ACTIONS(1109),
    [anon_sym_abstract] = ACTIONS(1101),
    [anon_sym_infer] = ACTIONS(1103),
    [anon_sym_keyof] = ACTIONS(1105),
    [anon_sym_unique] = ACTIONS(1107),
    [anon_sym_unknown] = ACTIONS(1109),
    [anon_sym_never] = ACTIONS(1109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1111),
    [sym_html_comment] = ACTIONS(5),
  },
  [1145] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1145),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4768),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1146] = {
    [sym_nested_identifier] = STATE(5958),
    [sym_string] = STATE(2307),
    [sym_comment] = STATE(1146),
    [sym_formal_parameters] = STATE(6100),
    [sym_nested_type_identifier] = STATE(2121),
    [sym__type] = STATE(2384),
    [sym_constructor_type] = STATE(2353),
    [sym__primary_type] = STATE(2401),
    [sym_template_literal_type] = STATE(2397),
    [sym_infer_type] = STATE(2353),
    [sym_conditional_type] = STATE(2397),
    [sym_generic_type] = STATE(2397),
    [sym_type_query] = STATE(2397),
    [sym_index_type_query] = STATE(2397),
    [sym_lookup_type] = STATE(2397),
    [sym_literal_type] = STATE(2397),
    [sym__number] = STATE(2309),
    [sym_existential_type] = STATE(2397),
    [sym_flow_maybe_type] = STATE(2397),
    [sym_parenthesized_type] = STATE(2397),
    [sym_predefined_type] = STATE(2397),
    [sym_object_type] = STATE(2397),
    [sym_type_parameters] = STATE(5861),
    [sym_array_type] = STATE(2397),
    [sym_tuple_type] = STATE(2397),
    [sym_readonly_type] = STATE(2353),
    [sym_union_type] = STATE(2397),
    [sym_intersection_type] = STATE(2397),
    [sym_function_type] = STATE(2353),
    [sym_identifier] = ACTIONS(3626),
    [anon_sym_STAR] = ACTIONS(3504),
    [anon_sym_LBRACE] = ACTIONS(3506),
    [anon_sym_typeof] = ACTIONS(3508),
    [anon_sym_const] = ACTIONS(3510),
    [anon_sym_LPAREN] = ACTIONS(3512),
    [anon_sym_LBRACK] = ACTIONS(3514),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_new] = ACTIONS(3516),
    [anon_sym_AMP] = ACTIONS(3518),
    [anon_sym_PIPE] = ACTIONS(3520),
    [anon_sym_PLUS] = ACTIONS(3522),
    [anon_sym_DASH] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3524),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3526),
    [sym_number] = ACTIONS(3528),
    [sym_this] = ACTIONS(3628),
    [sym_true] = ACTIONS(3532),
    [sym_false] = ACTIONS(3532),
    [sym_null] = ACTIONS(3532),
    [sym_undefined] = ACTIONS(3532),
    [anon_sym_readonly] = ACTIONS(3534),
    [anon_sym_QMARK] = ACTIONS(3536),
    [anon_sym_any] = ACTIONS(3524),
    [anon_sym_number] = ACTIONS(3524),
    [anon_sym_boolean] = ACTIONS(3524),
    [anon_sym_string] = ACTIONS(3524),
    [anon_sym_symbol] = ACTIONS(3524),
    [anon_sym_object] = ACTIONS(3524),
    [anon_sym_abstract] = ACTIONS(3538),
    [anon_sym_infer] = ACTIONS(3542),
    [anon_sym_keyof] = ACTIONS(3544),
    [anon_sym_unique] = ACTIONS(3546),
    [anon_sym_unknown] = ACTIONS(3524),
    [anon_sym_never] = ACTIONS(3524),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3548),
    [sym_html_comment] = ACTIONS(5),
  },
  [1147] = {
    [sym_nested_identifier] = STATE(6076),
    [sym_string] = STATE(3484),
    [sym_comment] = STATE(1147),
    [sym_formal_parameters] = STATE(5995),
    [sym_nested_type_identifier] = STATE(3366),
    [sym__type] = STATE(3495),
    [sym_constructor_type] = STATE(3468),
    [sym__primary_type] = STATE(3467),
    [sym_template_literal_type] = STATE(3466),
    [sym_infer_type] = STATE(3468),
    [sym_conditional_type] = STATE(3466),
    [sym_generic_type] = STATE(3466),
    [sym_type_query] = STATE(3466),
    [sym_index_type_query] = STATE(3466),
    [sym_lookup_type] = STATE(3466),
    [sym_literal_type] = STATE(3466),
    [sym__number] = STATE(3465),
    [sym_existential_type] = STATE(3466),
    [sym_flow_maybe_type] = STATE(3466),
    [sym_parenthesized_type] = STATE(3466),
    [sym_predefined_type] = STATE(3466),
    [sym_object_type] = STATE(3466),
    [sym_type_parameters] = STATE(5758),
    [sym_array_type] = STATE(3466),
    [sym_tuple_type] = STATE(3466),
    [sym_readonly_type] = STATE(3468),
    [sym_union_type] = STATE(3466),
    [sym_intersection_type] = STATE(3466),
    [sym_function_type] = STATE(3468),
    [sym_identifier] = ACTIONS(2002),
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_LBRACE] = ACTIONS(2006),
    [anon_sym_typeof] = ACTIONS(2008),
    [anon_sym_const] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(2010),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_new] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(1109),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [sym_number] = ACTIONS(2028),
    [sym_this] = ACTIONS(2030),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [sym_null] = ACTIONS(2032),
    [sym_undefined] = ACTIONS(2032),
    [anon_sym_readonly] = ACTIONS(2034),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1109),
    [anon_sym_number] = ACTIONS(1109),
    [anon_sym_boolean] = ACTIONS(1109),
    [anon_sym_string] = ACTIONS(1109),
    [anon_sym_symbol] = ACTIONS(1109),
    [anon_sym_object] = ACTIONS(1109),
    [anon_sym_abstract] = ACTIONS(1101),
    [anon_sym_infer] = ACTIONS(1103),
    [anon_sym_keyof] = ACTIONS(1105),
    [anon_sym_unique] = ACTIONS(1107),
    [anon_sym_unknown] = ACTIONS(1109),
    [anon_sym_never] = ACTIONS(1109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1111),
    [sym_html_comment] = ACTIONS(5),
  },
  [1148] = {
    [sym_nested_identifier] = STATE(6076),
    [sym_string] = STATE(3484),
    [sym_comment] = STATE(1148),
    [sym_formal_parameters] = STATE(5995),
    [sym_nested_type_identifier] = STATE(3366),
    [sym__type] = STATE(3498),
    [sym_constructor_type] = STATE(3468),
    [sym__primary_type] = STATE(3467),
    [sym_template_literal_type] = STATE(3466),
    [sym_infer_type] = STATE(3468),
    [sym_conditional_type] = STATE(3466),
    [sym_generic_type] = STATE(3466),
    [sym_type_query] = STATE(3466),
    [sym_index_type_query] = STATE(3466),
    [sym_lookup_type] = STATE(3466),
    [sym_literal_type] = STATE(3466),
    [sym__number] = STATE(3465),
    [sym_existential_type] = STATE(3466),
    [sym_flow_maybe_type] = STATE(3466),
    [sym_parenthesized_type] = STATE(3466),
    [sym_predefined_type] = STATE(3466),
    [sym_object_type] = STATE(3466),
    [sym_type_parameters] = STATE(5758),
    [sym_array_type] = STATE(3466),
    [sym_tuple_type] = STATE(3466),
    [sym_readonly_type] = STATE(3468),
    [sym_union_type] = STATE(3466),
    [sym_intersection_type] = STATE(3466),
    [sym_function_type] = STATE(3468),
    [sym_identifier] = ACTIONS(2002),
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_LBRACE] = ACTIONS(2006),
    [anon_sym_typeof] = ACTIONS(2008),
    [anon_sym_const] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(2010),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_new] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(1109),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [sym_number] = ACTIONS(2028),
    [sym_this] = ACTIONS(2030),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [sym_null] = ACTIONS(2032),
    [sym_undefined] = ACTIONS(2032),
    [anon_sym_readonly] = ACTIONS(2034),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1109),
    [anon_sym_number] = ACTIONS(1109),
    [anon_sym_boolean] = ACTIONS(1109),
    [anon_sym_string] = ACTIONS(1109),
    [anon_sym_symbol] = ACTIONS(1109),
    [anon_sym_object] = ACTIONS(1109),
    [anon_sym_abstract] = ACTIONS(1101),
    [anon_sym_infer] = ACTIONS(1103),
    [anon_sym_keyof] = ACTIONS(1105),
    [anon_sym_unique] = ACTIONS(1107),
    [anon_sym_unknown] = ACTIONS(1109),
    [anon_sym_never] = ACTIONS(1109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1111),
    [sym_html_comment] = ACTIONS(5),
  },
  [1149] = {
    [sym_nested_identifier] = STATE(6076),
    [sym_string] = STATE(3484),
    [sym_comment] = STATE(1149),
    [sym_formal_parameters] = STATE(5995),
    [sym_nested_type_identifier] = STATE(3366),
    [sym__type] = STATE(3483),
    [sym_constructor_type] = STATE(3468),
    [sym__primary_type] = STATE(3467),
    [sym_template_literal_type] = STATE(3466),
    [sym_infer_type] = STATE(3468),
    [sym_conditional_type] = STATE(3466),
    [sym_generic_type] = STATE(3466),
    [sym_type_query] = STATE(3466),
    [sym_index_type_query] = STATE(3466),
    [sym_lookup_type] = STATE(3466),
    [sym_literal_type] = STATE(3466),
    [sym__number] = STATE(3465),
    [sym_existential_type] = STATE(3466),
    [sym_flow_maybe_type] = STATE(3466),
    [sym_parenthesized_type] = STATE(3466),
    [sym_predefined_type] = STATE(3466),
    [sym_object_type] = STATE(3466),
    [sym_type_parameters] = STATE(5758),
    [sym_array_type] = STATE(3466),
    [sym_tuple_type] = STATE(3466),
    [sym_readonly_type] = STATE(3468),
    [sym_union_type] = STATE(3466),
    [sym_intersection_type] = STATE(3466),
    [sym_function_type] = STATE(3468),
    [sym_identifier] = ACTIONS(2002),
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_LBRACE] = ACTIONS(2006),
    [anon_sym_typeof] = ACTIONS(2008),
    [anon_sym_const] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(2010),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_new] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(1109),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [sym_number] = ACTIONS(2028),
    [sym_this] = ACTIONS(2030),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [sym_null] = ACTIONS(2032),
    [sym_undefined] = ACTIONS(2032),
    [anon_sym_readonly] = ACTIONS(2034),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1109),
    [anon_sym_number] = ACTIONS(1109),
    [anon_sym_boolean] = ACTIONS(1109),
    [anon_sym_string] = ACTIONS(1109),
    [anon_sym_symbol] = ACTIONS(1109),
    [anon_sym_object] = ACTIONS(1109),
    [anon_sym_abstract] = ACTIONS(1101),
    [anon_sym_infer] = ACTIONS(1103),
    [anon_sym_keyof] = ACTIONS(1105),
    [anon_sym_unique] = ACTIONS(1107),
    [anon_sym_unknown] = ACTIONS(1109),
    [anon_sym_never] = ACTIONS(1109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1111),
    [sym_html_comment] = ACTIONS(5),
  },
  [1150] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1150),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4545),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1151] = {
    [sym_nested_identifier] = STATE(6076),
    [sym_string] = STATE(3484),
    [sym_comment] = STATE(1151),
    [sym_formal_parameters] = STATE(5995),
    [sym_nested_type_identifier] = STATE(3366),
    [sym__type] = STATE(3504),
    [sym_constructor_type] = STATE(3468),
    [sym__primary_type] = STATE(3467),
    [sym_template_literal_type] = STATE(3466),
    [sym_infer_type] = STATE(3468),
    [sym_conditional_type] = STATE(3466),
    [sym_generic_type] = STATE(3466),
    [sym_type_query] = STATE(3466),
    [sym_index_type_query] = STATE(3466),
    [sym_lookup_type] = STATE(3466),
    [sym_literal_type] = STATE(3466),
    [sym__number] = STATE(3465),
    [sym_existential_type] = STATE(3466),
    [sym_flow_maybe_type] = STATE(3466),
    [sym_parenthesized_type] = STATE(3466),
    [sym_predefined_type] = STATE(3466),
    [sym_object_type] = STATE(3466),
    [sym_type_parameters] = STATE(5758),
    [sym_array_type] = STATE(3466),
    [sym_tuple_type] = STATE(3466),
    [sym_readonly_type] = STATE(3468),
    [sym_union_type] = STATE(3466),
    [sym_intersection_type] = STATE(3466),
    [sym_function_type] = STATE(3468),
    [sym_identifier] = ACTIONS(2002),
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_LBRACE] = ACTIONS(2006),
    [anon_sym_typeof] = ACTIONS(2008),
    [anon_sym_const] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(2010),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_new] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(1109),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [sym_number] = ACTIONS(2028),
    [sym_this] = ACTIONS(2030),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [sym_null] = ACTIONS(2032),
    [sym_undefined] = ACTIONS(2032),
    [anon_sym_readonly] = ACTIONS(2034),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1109),
    [anon_sym_number] = ACTIONS(1109),
    [anon_sym_boolean] = ACTIONS(1109),
    [anon_sym_string] = ACTIONS(1109),
    [anon_sym_symbol] = ACTIONS(1109),
    [anon_sym_object] = ACTIONS(1109),
    [anon_sym_abstract] = ACTIONS(1101),
    [anon_sym_infer] = ACTIONS(1103),
    [anon_sym_keyof] = ACTIONS(1105),
    [anon_sym_unique] = ACTIONS(1107),
    [anon_sym_unknown] = ACTIONS(1109),
    [anon_sym_never] = ACTIONS(1109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1111),
    [sym_html_comment] = ACTIONS(5),
  },
  [1152] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1152),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4695),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1153] = {
    [sym_nested_identifier] = STATE(6076),
    [sym_string] = STATE(3484),
    [sym_comment] = STATE(1153),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3366),
    [sym__type] = STATE(4869),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3506),
    [sym_template_literal_type] = STATE(3466),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3466),
    [sym_generic_type] = STATE(3466),
    [sym_type_query] = STATE(3466),
    [sym_index_type_query] = STATE(3466),
    [sym_lookup_type] = STATE(3466),
    [sym_literal_type] = STATE(3466),
    [sym__number] = STATE(3465),
    [sym_existential_type] = STATE(3466),
    [sym_flow_maybe_type] = STATE(3466),
    [sym_parenthesized_type] = STATE(3466),
    [sym_predefined_type] = STATE(3466),
    [sym_object_type] = STATE(3466),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3466),
    [sym_tuple_type] = STATE(3466),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3466),
    [sym_intersection_type] = STATE(3466),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(2002),
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_LBRACE] = ACTIONS(2006),
    [anon_sym_typeof] = ACTIONS(2008),
    [anon_sym_const] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(2010),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(1109),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [sym_number] = ACTIONS(2028),
    [sym_this] = ACTIONS(2030),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [sym_null] = ACTIONS(2032),
    [sym_undefined] = ACTIONS(2032),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1109),
    [anon_sym_number] = ACTIONS(1109),
    [anon_sym_boolean] = ACTIONS(1109),
    [anon_sym_string] = ACTIONS(1109),
    [anon_sym_symbol] = ACTIONS(1109),
    [anon_sym_object] = ACTIONS(1109),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(1105),
    [anon_sym_unique] = ACTIONS(1107),
    [anon_sym_unknown] = ACTIONS(1109),
    [anon_sym_never] = ACTIONS(1109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1111),
    [sym_html_comment] = ACTIONS(5),
  },
  [1154] = {
    [sym_nested_identifier] = STATE(5958),
    [sym_string] = STATE(2307),
    [sym_comment] = STATE(1154),
    [sym_formal_parameters] = STATE(6100),
    [sym_nested_type_identifier] = STATE(2121),
    [sym__type] = STATE(2383),
    [sym_constructor_type] = STATE(2353),
    [sym__primary_type] = STATE(2401),
    [sym_template_literal_type] = STATE(2397),
    [sym_infer_type] = STATE(2353),
    [sym_conditional_type] = STATE(2397),
    [sym_generic_type] = STATE(2397),
    [sym_type_query] = STATE(2397),
    [sym_index_type_query] = STATE(2397),
    [sym_lookup_type] = STATE(2397),
    [sym_literal_type] = STATE(2397),
    [sym__number] = STATE(2309),
    [sym_existential_type] = STATE(2397),
    [sym_flow_maybe_type] = STATE(2397),
    [sym_parenthesized_type] = STATE(2397),
    [sym_predefined_type] = STATE(2397),
    [sym_object_type] = STATE(2397),
    [sym_type_parameters] = STATE(5861),
    [sym_array_type] = STATE(2397),
    [sym_tuple_type] = STATE(2397),
    [sym_readonly_type] = STATE(2353),
    [sym_union_type] = STATE(2397),
    [sym_intersection_type] = STATE(2397),
    [sym_function_type] = STATE(2353),
    [sym_identifier] = ACTIONS(3626),
    [anon_sym_STAR] = ACTIONS(3504),
    [anon_sym_LBRACE] = ACTIONS(3506),
    [anon_sym_typeof] = ACTIONS(3508),
    [anon_sym_const] = ACTIONS(3510),
    [anon_sym_LPAREN] = ACTIONS(3512),
    [anon_sym_LBRACK] = ACTIONS(3514),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_new] = ACTIONS(3516),
    [anon_sym_AMP] = ACTIONS(3518),
    [anon_sym_PIPE] = ACTIONS(3520),
    [anon_sym_PLUS] = ACTIONS(3522),
    [anon_sym_DASH] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3524),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3526),
    [sym_number] = ACTIONS(3528),
    [sym_this] = ACTIONS(3628),
    [sym_true] = ACTIONS(3532),
    [sym_false] = ACTIONS(3532),
    [sym_null] = ACTIONS(3532),
    [sym_undefined] = ACTIONS(3532),
    [anon_sym_readonly] = ACTIONS(3534),
    [anon_sym_QMARK] = ACTIONS(3536),
    [anon_sym_any] = ACTIONS(3524),
    [anon_sym_number] = ACTIONS(3524),
    [anon_sym_boolean] = ACTIONS(3524),
    [anon_sym_string] = ACTIONS(3524),
    [anon_sym_symbol] = ACTIONS(3524),
    [anon_sym_object] = ACTIONS(3524),
    [anon_sym_abstract] = ACTIONS(3538),
    [anon_sym_infer] = ACTIONS(3542),
    [anon_sym_keyof] = ACTIONS(3544),
    [anon_sym_unique] = ACTIONS(3546),
    [anon_sym_unknown] = ACTIONS(3524),
    [anon_sym_never] = ACTIONS(3524),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3548),
    [sym_html_comment] = ACTIONS(5),
  },
  [1155] = {
    [sym_nested_identifier] = STATE(6099),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1155),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3747),
    [sym__type] = STATE(5023),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3261),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3638),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_typeof] = ACTIONS(3478),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(3482),
    [anon_sym_PIPE] = ACTIONS(3484),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(3490),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(3498),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3500),
    [sym_html_comment] = ACTIONS(5),
  },
  [1156] = {
    [sym_nested_identifier] = STATE(6066),
    [sym_string] = STATE(1759),
    [sym_comment] = STATE(1156),
    [sym_formal_parameters] = STATE(6184),
    [sym_nested_type_identifier] = STATE(1744),
    [sym__type] = STATE(1892),
    [sym_constructor_type] = STATE(1761),
    [sym__primary_type] = STATE(1762),
    [sym_template_literal_type] = STATE(1745),
    [sym_infer_type] = STATE(1761),
    [sym_conditional_type] = STATE(1745),
    [sym_generic_type] = STATE(1745),
    [sym_type_query] = STATE(1745),
    [sym_index_type_query] = STATE(1745),
    [sym_lookup_type] = STATE(1745),
    [sym_literal_type] = STATE(1745),
    [sym__number] = STATE(1763),
    [sym_existential_type] = STATE(1745),
    [sym_flow_maybe_type] = STATE(1745),
    [sym_parenthesized_type] = STATE(1745),
    [sym_predefined_type] = STATE(1745),
    [sym_object_type] = STATE(1745),
    [sym_type_parameters] = STATE(5724),
    [sym_array_type] = STATE(1745),
    [sym_tuple_type] = STATE(1745),
    [sym_readonly_type] = STATE(1761),
    [sym_union_type] = STATE(1745),
    [sym_intersection_type] = STATE(1745),
    [sym_function_type] = STATE(1761),
    [sym_identifier] = ACTIONS(3630),
    [anon_sym_STAR] = ACTIONS(3552),
    [anon_sym_LBRACE] = ACTIONS(3554),
    [anon_sym_typeof] = ACTIONS(3556),
    [anon_sym_const] = ACTIONS(3558),
    [anon_sym_LPAREN] = ACTIONS(3560),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(3564),
    [anon_sym_AMP] = ACTIONS(3566),
    [anon_sym_PIPE] = ACTIONS(3568),
    [anon_sym_PLUS] = ACTIONS(3570),
    [anon_sym_DASH] = ACTIONS(3570),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3572),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3574),
    [sym_number] = ACTIONS(3576),
    [sym_this] = ACTIONS(3632),
    [sym_true] = ACTIONS(3580),
    [sym_false] = ACTIONS(3580),
    [sym_null] = ACTIONS(3580),
    [sym_undefined] = ACTIONS(3580),
    [anon_sym_readonly] = ACTIONS(3582),
    [anon_sym_QMARK] = ACTIONS(3584),
    [anon_sym_any] = ACTIONS(3572),
    [anon_sym_number] = ACTIONS(3572),
    [anon_sym_boolean] = ACTIONS(3572),
    [anon_sym_string] = ACTIONS(3572),
    [anon_sym_symbol] = ACTIONS(3572),
    [anon_sym_object] = ACTIONS(3572),
    [anon_sym_abstract] = ACTIONS(3586),
    [anon_sym_infer] = ACTIONS(3590),
    [anon_sym_keyof] = ACTIONS(3592),
    [anon_sym_unique] = ACTIONS(3594),
    [anon_sym_unknown] = ACTIONS(3572),
    [anon_sym_never] = ACTIONS(3572),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3596),
    [sym_html_comment] = ACTIONS(5),
  },
  [1157] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1157),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4719),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1158] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1158),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4798),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1159] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1159),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(3230),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1160] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1160),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(3287),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1161] = {
    [sym_nested_identifier] = STATE(5958),
    [sym_string] = STATE(2307),
    [sym_comment] = STATE(1161),
    [sym_formal_parameters] = STATE(6100),
    [sym_nested_type_identifier] = STATE(2121),
    [sym__type] = STATE(2288),
    [sym_constructor_type] = STATE(2353),
    [sym__primary_type] = STATE(2401),
    [sym_template_literal_type] = STATE(2397),
    [sym_infer_type] = STATE(2353),
    [sym_conditional_type] = STATE(2397),
    [sym_generic_type] = STATE(2397),
    [sym_type_query] = STATE(2397),
    [sym_index_type_query] = STATE(2397),
    [sym_lookup_type] = STATE(2397),
    [sym_literal_type] = STATE(2397),
    [sym__number] = STATE(2309),
    [sym_existential_type] = STATE(2397),
    [sym_flow_maybe_type] = STATE(2397),
    [sym_parenthesized_type] = STATE(2397),
    [sym_predefined_type] = STATE(2397),
    [sym_object_type] = STATE(2397),
    [sym_type_parameters] = STATE(5861),
    [sym_array_type] = STATE(2397),
    [sym_tuple_type] = STATE(2397),
    [sym_readonly_type] = STATE(2353),
    [sym_union_type] = STATE(2397),
    [sym_intersection_type] = STATE(2397),
    [sym_function_type] = STATE(2353),
    [sym_identifier] = ACTIONS(3626),
    [anon_sym_STAR] = ACTIONS(3504),
    [anon_sym_LBRACE] = ACTIONS(3506),
    [anon_sym_typeof] = ACTIONS(3508),
    [anon_sym_const] = ACTIONS(3510),
    [anon_sym_LPAREN] = ACTIONS(3512),
    [anon_sym_LBRACK] = ACTIONS(3514),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_new] = ACTIONS(3516),
    [anon_sym_AMP] = ACTIONS(3518),
    [anon_sym_PIPE] = ACTIONS(3520),
    [anon_sym_PLUS] = ACTIONS(3522),
    [anon_sym_DASH] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3524),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3526),
    [sym_number] = ACTIONS(3528),
    [sym_this] = ACTIONS(3628),
    [sym_true] = ACTIONS(3532),
    [sym_false] = ACTIONS(3532),
    [sym_null] = ACTIONS(3532),
    [sym_undefined] = ACTIONS(3532),
    [anon_sym_readonly] = ACTIONS(3534),
    [anon_sym_QMARK] = ACTIONS(3536),
    [anon_sym_any] = ACTIONS(3524),
    [anon_sym_number] = ACTIONS(3524),
    [anon_sym_boolean] = ACTIONS(3524),
    [anon_sym_string] = ACTIONS(3524),
    [anon_sym_symbol] = ACTIONS(3524),
    [anon_sym_object] = ACTIONS(3524),
    [anon_sym_abstract] = ACTIONS(3538),
    [anon_sym_infer] = ACTIONS(3542),
    [anon_sym_keyof] = ACTIONS(3544),
    [anon_sym_unique] = ACTIONS(3546),
    [anon_sym_unknown] = ACTIONS(3524),
    [anon_sym_never] = ACTIONS(3524),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3548),
    [sym_html_comment] = ACTIONS(5),
  },
  [1162] = {
    [sym_nested_identifier] = STATE(6076),
    [sym_string] = STATE(3484),
    [sym_comment] = STATE(1162),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3366),
    [sym__type] = STATE(4869),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3510),
    [sym_template_literal_type] = STATE(3466),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3466),
    [sym_generic_type] = STATE(3466),
    [sym_type_query] = STATE(3466),
    [sym_index_type_query] = STATE(3466),
    [sym_lookup_type] = STATE(3466),
    [sym_literal_type] = STATE(3466),
    [sym__number] = STATE(3465),
    [sym_existential_type] = STATE(3466),
    [sym_flow_maybe_type] = STATE(3466),
    [sym_parenthesized_type] = STATE(3466),
    [sym_predefined_type] = STATE(3466),
    [sym_object_type] = STATE(3466),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3466),
    [sym_tuple_type] = STATE(3466),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3466),
    [sym_intersection_type] = STATE(3466),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(2002),
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_LBRACE] = ACTIONS(2006),
    [anon_sym_typeof] = ACTIONS(2008),
    [anon_sym_const] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(2010),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(1109),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [sym_number] = ACTIONS(2028),
    [sym_this] = ACTIONS(2030),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [sym_null] = ACTIONS(2032),
    [sym_undefined] = ACTIONS(2032),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1109),
    [anon_sym_number] = ACTIONS(1109),
    [anon_sym_boolean] = ACTIONS(1109),
    [anon_sym_string] = ACTIONS(1109),
    [anon_sym_symbol] = ACTIONS(1109),
    [anon_sym_object] = ACTIONS(1109),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(1105),
    [anon_sym_unique] = ACTIONS(1107),
    [anon_sym_unknown] = ACTIONS(1109),
    [anon_sym_never] = ACTIONS(1109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1111),
    [sym_html_comment] = ACTIONS(5),
  },
  [1163] = {
    [sym_nested_identifier] = STATE(5958),
    [sym_string] = STATE(2307),
    [sym_comment] = STATE(1163),
    [sym_formal_parameters] = STATE(6100),
    [sym_nested_type_identifier] = STATE(2121),
    [sym__type] = STATE(2289),
    [sym_constructor_type] = STATE(2353),
    [sym__primary_type] = STATE(2401),
    [sym_template_literal_type] = STATE(2397),
    [sym_infer_type] = STATE(2353),
    [sym_conditional_type] = STATE(2397),
    [sym_generic_type] = STATE(2397),
    [sym_type_query] = STATE(2397),
    [sym_index_type_query] = STATE(2397),
    [sym_lookup_type] = STATE(2397),
    [sym_literal_type] = STATE(2397),
    [sym__number] = STATE(2309),
    [sym_existential_type] = STATE(2397),
    [sym_flow_maybe_type] = STATE(2397),
    [sym_parenthesized_type] = STATE(2397),
    [sym_predefined_type] = STATE(2397),
    [sym_object_type] = STATE(2397),
    [sym_type_parameters] = STATE(5861),
    [sym_array_type] = STATE(2397),
    [sym_tuple_type] = STATE(2397),
    [sym_readonly_type] = STATE(2353),
    [sym_union_type] = STATE(2397),
    [sym_intersection_type] = STATE(2397),
    [sym_function_type] = STATE(2353),
    [sym_identifier] = ACTIONS(3626),
    [anon_sym_STAR] = ACTIONS(3504),
    [anon_sym_LBRACE] = ACTIONS(3506),
    [anon_sym_typeof] = ACTIONS(3508),
    [anon_sym_const] = ACTIONS(3510),
    [anon_sym_LPAREN] = ACTIONS(3512),
    [anon_sym_LBRACK] = ACTIONS(3514),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_new] = ACTIONS(3516),
    [anon_sym_AMP] = ACTIONS(3518),
    [anon_sym_PIPE] = ACTIONS(3520),
    [anon_sym_PLUS] = ACTIONS(3522),
    [anon_sym_DASH] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3524),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3526),
    [sym_number] = ACTIONS(3528),
    [sym_this] = ACTIONS(3628),
    [sym_true] = ACTIONS(3532),
    [sym_false] = ACTIONS(3532),
    [sym_null] = ACTIONS(3532),
    [sym_undefined] = ACTIONS(3532),
    [anon_sym_readonly] = ACTIONS(3534),
    [anon_sym_QMARK] = ACTIONS(3536),
    [anon_sym_any] = ACTIONS(3524),
    [anon_sym_number] = ACTIONS(3524),
    [anon_sym_boolean] = ACTIONS(3524),
    [anon_sym_string] = ACTIONS(3524),
    [anon_sym_symbol] = ACTIONS(3524),
    [anon_sym_object] = ACTIONS(3524),
    [anon_sym_abstract] = ACTIONS(3538),
    [anon_sym_infer] = ACTIONS(3542),
    [anon_sym_keyof] = ACTIONS(3544),
    [anon_sym_unique] = ACTIONS(3546),
    [anon_sym_unknown] = ACTIONS(3524),
    [anon_sym_never] = ACTIONS(3524),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3548),
    [sym_html_comment] = ACTIONS(5),
  },
  [1164] = {
    [sym_nested_identifier] = STATE(6076),
    [sym_string] = STATE(3484),
    [sym_comment] = STATE(1164),
    [sym_formal_parameters] = STATE(5995),
    [sym_nested_type_identifier] = STATE(3366),
    [sym__type] = STATE(3746),
    [sym_constructor_type] = STATE(3468),
    [sym__primary_type] = STATE(3467),
    [sym_template_literal_type] = STATE(3466),
    [sym_infer_type] = STATE(3468),
    [sym_conditional_type] = STATE(3466),
    [sym_generic_type] = STATE(3466),
    [sym_type_query] = STATE(3466),
    [sym_index_type_query] = STATE(3466),
    [sym_lookup_type] = STATE(3466),
    [sym_literal_type] = STATE(3466),
    [sym__number] = STATE(3465),
    [sym_existential_type] = STATE(3466),
    [sym_flow_maybe_type] = STATE(3466),
    [sym_parenthesized_type] = STATE(3466),
    [sym_predefined_type] = STATE(3466),
    [sym_object_type] = STATE(3466),
    [sym_type_parameters] = STATE(5758),
    [sym_array_type] = STATE(3466),
    [sym_tuple_type] = STATE(3466),
    [sym_readonly_type] = STATE(3468),
    [sym_union_type] = STATE(3466),
    [sym_intersection_type] = STATE(3466),
    [sym_function_type] = STATE(3468),
    [sym_identifier] = ACTIONS(2002),
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_LBRACE] = ACTIONS(2006),
    [anon_sym_typeof] = ACTIONS(2008),
    [anon_sym_const] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(2010),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_new] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(1109),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [sym_number] = ACTIONS(2028),
    [sym_this] = ACTIONS(2030),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [sym_null] = ACTIONS(2032),
    [sym_undefined] = ACTIONS(2032),
    [anon_sym_readonly] = ACTIONS(2034),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1109),
    [anon_sym_number] = ACTIONS(1109),
    [anon_sym_boolean] = ACTIONS(1109),
    [anon_sym_string] = ACTIONS(1109),
    [anon_sym_symbol] = ACTIONS(1109),
    [anon_sym_object] = ACTIONS(1109),
    [anon_sym_abstract] = ACTIONS(1101),
    [anon_sym_infer] = ACTIONS(1103),
    [anon_sym_keyof] = ACTIONS(1105),
    [anon_sym_unique] = ACTIONS(1107),
    [anon_sym_unknown] = ACTIONS(1109),
    [anon_sym_never] = ACTIONS(1109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1111),
    [sym_html_comment] = ACTIONS(5),
  },
  [1165] = {
    [sym_nested_identifier] = STATE(6076),
    [sym_string] = STATE(3484),
    [sym_comment] = STATE(1165),
    [sym_formal_parameters] = STATE(5995),
    [sym_nested_type_identifier] = STATE(3366),
    [sym__type] = STATE(3748),
    [sym_constructor_type] = STATE(3468),
    [sym__primary_type] = STATE(3467),
    [sym_template_literal_type] = STATE(3466),
    [sym_infer_type] = STATE(3468),
    [sym_conditional_type] = STATE(3466),
    [sym_generic_type] = STATE(3466),
    [sym_type_query] = STATE(3466),
    [sym_index_type_query] = STATE(3466),
    [sym_lookup_type] = STATE(3466),
    [sym_literal_type] = STATE(3466),
    [sym__number] = STATE(3465),
    [sym_existential_type] = STATE(3466),
    [sym_flow_maybe_type] = STATE(3466),
    [sym_parenthesized_type] = STATE(3466),
    [sym_predefined_type] = STATE(3466),
    [sym_object_type] = STATE(3466),
    [sym_type_parameters] = STATE(5758),
    [sym_array_type] = STATE(3466),
    [sym_tuple_type] = STATE(3466),
    [sym_readonly_type] = STATE(3468),
    [sym_union_type] = STATE(3466),
    [sym_intersection_type] = STATE(3466),
    [sym_function_type] = STATE(3468),
    [sym_identifier] = ACTIONS(2002),
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_LBRACE] = ACTIONS(2006),
    [anon_sym_typeof] = ACTIONS(2008),
    [anon_sym_const] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(2010),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_new] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(1109),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [sym_number] = ACTIONS(2028),
    [sym_this] = ACTIONS(2030),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [sym_null] = ACTIONS(2032),
    [sym_undefined] = ACTIONS(2032),
    [anon_sym_readonly] = ACTIONS(2034),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1109),
    [anon_sym_number] = ACTIONS(1109),
    [anon_sym_boolean] = ACTIONS(1109),
    [anon_sym_string] = ACTIONS(1109),
    [anon_sym_symbol] = ACTIONS(1109),
    [anon_sym_object] = ACTIONS(1109),
    [anon_sym_abstract] = ACTIONS(1101),
    [anon_sym_infer] = ACTIONS(1103),
    [anon_sym_keyof] = ACTIONS(1105),
    [anon_sym_unique] = ACTIONS(1107),
    [anon_sym_unknown] = ACTIONS(1109),
    [anon_sym_never] = ACTIONS(1109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1111),
    [sym_html_comment] = ACTIONS(5),
  },
  [1166] = {
    [sym_nested_identifier] = STATE(6076),
    [sym_string] = STATE(3484),
    [sym_comment] = STATE(1166),
    [sym_formal_parameters] = STATE(5995),
    [sym_nested_type_identifier] = STATE(3366),
    [sym__type] = STATE(3751),
    [sym_constructor_type] = STATE(3468),
    [sym__primary_type] = STATE(3467),
    [sym_template_literal_type] = STATE(3466),
    [sym_infer_type] = STATE(3468),
    [sym_conditional_type] = STATE(3466),
    [sym_generic_type] = STATE(3466),
    [sym_type_query] = STATE(3466),
    [sym_index_type_query] = STATE(3466),
    [sym_lookup_type] = STATE(3466),
    [sym_literal_type] = STATE(3466),
    [sym__number] = STATE(3465),
    [sym_existential_type] = STATE(3466),
    [sym_flow_maybe_type] = STATE(3466),
    [sym_parenthesized_type] = STATE(3466),
    [sym_predefined_type] = STATE(3466),
    [sym_object_type] = STATE(3466),
    [sym_type_parameters] = STATE(5758),
    [sym_array_type] = STATE(3466),
    [sym_tuple_type] = STATE(3466),
    [sym_readonly_type] = STATE(3468),
    [sym_union_type] = STATE(3466),
    [sym_intersection_type] = STATE(3466),
    [sym_function_type] = STATE(3468),
    [sym_identifier] = ACTIONS(2002),
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_LBRACE] = ACTIONS(2006),
    [anon_sym_typeof] = ACTIONS(2008),
    [anon_sym_const] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(2010),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_new] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(1109),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [sym_number] = ACTIONS(2028),
    [sym_this] = ACTIONS(2030),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [sym_null] = ACTIONS(2032),
    [sym_undefined] = ACTIONS(2032),
    [anon_sym_readonly] = ACTIONS(2034),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1109),
    [anon_sym_number] = ACTIONS(1109),
    [anon_sym_boolean] = ACTIONS(1109),
    [anon_sym_string] = ACTIONS(1109),
    [anon_sym_symbol] = ACTIONS(1109),
    [anon_sym_object] = ACTIONS(1109),
    [anon_sym_abstract] = ACTIONS(1101),
    [anon_sym_infer] = ACTIONS(1103),
    [anon_sym_keyof] = ACTIONS(1105),
    [anon_sym_unique] = ACTIONS(1107),
    [anon_sym_unknown] = ACTIONS(1109),
    [anon_sym_never] = ACTIONS(1109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1111),
    [sym_html_comment] = ACTIONS(5),
  },
  [1167] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1167),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(3294),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1168] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1168),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(5189),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3261),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1169] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1169),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(5189),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3281),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1170] = {
    [sym_nested_identifier] = STATE(6123),
    [sym_string] = STATE(3650),
    [sym_comment] = STATE(1170),
    [sym_formal_parameters] = STATE(6329),
    [sym_nested_type_identifier] = STATE(3475),
    [sym__type] = STATE(3612),
    [sym_constructor_type] = STATE(3735),
    [sym__primary_type] = STATE(3709),
    [sym_template_literal_type] = STATE(3706),
    [sym_infer_type] = STATE(3735),
    [sym_conditional_type] = STATE(3706),
    [sym_generic_type] = STATE(3706),
    [sym_type_query] = STATE(3706),
    [sym_index_type_query] = STATE(3706),
    [sym_lookup_type] = STATE(3706),
    [sym_literal_type] = STATE(3706),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3706),
    [sym_flow_maybe_type] = STATE(3706),
    [sym_parenthesized_type] = STATE(3706),
    [sym_predefined_type] = STATE(3706),
    [sym_object_type] = STATE(3706),
    [sym_type_parameters] = STATE(5682),
    [sym_array_type] = STATE(3706),
    [sym_tuple_type] = STATE(3706),
    [sym_readonly_type] = STATE(3735),
    [sym_union_type] = STATE(3706),
    [sym_intersection_type] = STATE(3706),
    [sym_function_type] = STATE(3735),
    [sym_identifier] = ACTIONS(3634),
    [anon_sym_STAR] = ACTIONS(3313),
    [anon_sym_LBRACE] = ACTIONS(3315),
    [anon_sym_typeof] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_LPAREN] = ACTIONS(3321),
    [anon_sym_LBRACK] = ACTIONS(3323),
    [anon_sym_DQUOTE] = ACTIONS(3325),
    [anon_sym_SQUOTE] = ACTIONS(3327),
    [anon_sym_new] = ACTIONS(3329),
    [anon_sym_AMP] = ACTIONS(3331),
    [anon_sym_PIPE] = ACTIONS(3333),
    [anon_sym_PLUS] = ACTIONS(3335),
    [anon_sym_DASH] = ACTIONS(3335),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3337),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3339),
    [sym_number] = ACTIONS(3341),
    [sym_this] = ACTIONS(3636),
    [sym_true] = ACTIONS(3345),
    [sym_false] = ACTIONS(3345),
    [sym_null] = ACTIONS(3345),
    [sym_undefined] = ACTIONS(3345),
    [anon_sym_readonly] = ACTIONS(3347),
    [anon_sym_QMARK] = ACTIONS(3349),
    [anon_sym_any] = ACTIONS(3337),
    [anon_sym_number] = ACTIONS(3337),
    [anon_sym_boolean] = ACTIONS(3337),
    [anon_sym_string] = ACTIONS(3337),
    [anon_sym_symbol] = ACTIONS(3337),
    [anon_sym_object] = ACTIONS(3337),
    [anon_sym_abstract] = ACTIONS(3351),
    [anon_sym_infer] = ACTIONS(3355),
    [anon_sym_keyof] = ACTIONS(3357),
    [anon_sym_unique] = ACTIONS(3359),
    [anon_sym_unknown] = ACTIONS(3337),
    [anon_sym_never] = ACTIONS(3337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3361),
    [sym_html_comment] = ACTIONS(5),
  },
  [1171] = {
    [sym_nested_identifier] = STATE(6076),
    [sym_string] = STATE(3484),
    [sym_comment] = STATE(1171),
    [sym_formal_parameters] = STATE(5995),
    [sym_nested_type_identifier] = STATE(3366),
    [sym__type] = STATE(3459),
    [sym_constructor_type] = STATE(3468),
    [sym__primary_type] = STATE(3467),
    [sym_template_literal_type] = STATE(3466),
    [sym_infer_type] = STATE(3468),
    [sym_conditional_type] = STATE(3466),
    [sym_generic_type] = STATE(3466),
    [sym_type_query] = STATE(3466),
    [sym_index_type_query] = STATE(3466),
    [sym_lookup_type] = STATE(3466),
    [sym_literal_type] = STATE(3466),
    [sym__number] = STATE(3465),
    [sym_existential_type] = STATE(3466),
    [sym_flow_maybe_type] = STATE(3466),
    [sym_parenthesized_type] = STATE(3466),
    [sym_predefined_type] = STATE(3466),
    [sym_object_type] = STATE(3466),
    [sym_type_parameters] = STATE(5758),
    [sym_array_type] = STATE(3466),
    [sym_tuple_type] = STATE(3466),
    [sym_readonly_type] = STATE(3468),
    [sym_union_type] = STATE(3466),
    [sym_intersection_type] = STATE(3466),
    [sym_function_type] = STATE(3468),
    [sym_identifier] = ACTIONS(2002),
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_LBRACE] = ACTIONS(2006),
    [anon_sym_typeof] = ACTIONS(2008),
    [anon_sym_const] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(2010),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_new] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(1109),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [sym_number] = ACTIONS(2028),
    [sym_this] = ACTIONS(2030),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [sym_null] = ACTIONS(2032),
    [sym_undefined] = ACTIONS(2032),
    [anon_sym_readonly] = ACTIONS(2034),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1109),
    [anon_sym_number] = ACTIONS(1109),
    [anon_sym_boolean] = ACTIONS(1109),
    [anon_sym_string] = ACTIONS(1109),
    [anon_sym_symbol] = ACTIONS(1109),
    [anon_sym_object] = ACTIONS(1109),
    [anon_sym_abstract] = ACTIONS(1101),
    [anon_sym_infer] = ACTIONS(1103),
    [anon_sym_keyof] = ACTIONS(1105),
    [anon_sym_unique] = ACTIONS(1107),
    [anon_sym_unknown] = ACTIONS(1109),
    [anon_sym_never] = ACTIONS(1109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1111),
    [sym_html_comment] = ACTIONS(5),
  },
  [1172] = {
    [sym_nested_identifier] = STATE(6099),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1172),
    [sym_formal_parameters] = STATE(6035),
    [sym_nested_type_identifier] = STATE(3747),
    [sym__type] = STATE(4162),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5617),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3638),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_typeof] = ACTIONS(3478),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_AMP] = ACTIONS(3482),
    [anon_sym_PIPE] = ACTIONS(3484),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(3488),
    [anon_sym_QMARK] = ACTIONS(3490),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(3492),
    [anon_sym_infer] = ACTIONS(3496),
    [anon_sym_keyof] = ACTIONS(3498),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3500),
    [sym_html_comment] = ACTIONS(5),
  },
  [1173] = {
    [sym_nested_identifier] = STATE(6076),
    [sym_string] = STATE(3484),
    [sym_comment] = STATE(1173),
    [sym_formal_parameters] = STATE(5995),
    [sym_nested_type_identifier] = STATE(3366),
    [sym__type] = STATE(3457),
    [sym_constructor_type] = STATE(3468),
    [sym__primary_type] = STATE(3467),
    [sym_template_literal_type] = STATE(3466),
    [sym_infer_type] = STATE(3468),
    [sym_conditional_type] = STATE(3466),
    [sym_generic_type] = STATE(3466),
    [sym_type_query] = STATE(3466),
    [sym_index_type_query] = STATE(3466),
    [sym_lookup_type] = STATE(3466),
    [sym_literal_type] = STATE(3466),
    [sym__number] = STATE(3465),
    [sym_existential_type] = STATE(3466),
    [sym_flow_maybe_type] = STATE(3466),
    [sym_parenthesized_type] = STATE(3466),
    [sym_predefined_type] = STATE(3466),
    [sym_object_type] = STATE(3466),
    [sym_type_parameters] = STATE(5758),
    [sym_array_type] = STATE(3466),
    [sym_tuple_type] = STATE(3466),
    [sym_readonly_type] = STATE(3468),
    [sym_union_type] = STATE(3466),
    [sym_intersection_type] = STATE(3466),
    [sym_function_type] = STATE(3468),
    [sym_identifier] = ACTIONS(2002),
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_LBRACE] = ACTIONS(2006),
    [anon_sym_typeof] = ACTIONS(2008),
    [anon_sym_const] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(2010),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_new] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(1109),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [sym_number] = ACTIONS(2028),
    [sym_this] = ACTIONS(2030),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [sym_null] = ACTIONS(2032),
    [sym_undefined] = ACTIONS(2032),
    [anon_sym_readonly] = ACTIONS(2034),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1109),
    [anon_sym_number] = ACTIONS(1109),
    [anon_sym_boolean] = ACTIONS(1109),
    [anon_sym_string] = ACTIONS(1109),
    [anon_sym_symbol] = ACTIONS(1109),
    [anon_sym_object] = ACTIONS(1109),
    [anon_sym_abstract] = ACTIONS(1101),
    [anon_sym_infer] = ACTIONS(1103),
    [anon_sym_keyof] = ACTIONS(1105),
    [anon_sym_unique] = ACTIONS(1107),
    [anon_sym_unknown] = ACTIONS(1109),
    [anon_sym_never] = ACTIONS(1109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1111),
    [sym_html_comment] = ACTIONS(5),
  },
  [1174] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1174),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4793),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1175] = {
    [sym_nested_identifier] = STATE(6076),
    [sym_string] = STATE(3484),
    [sym_comment] = STATE(1175),
    [sym_formal_parameters] = STATE(5995),
    [sym_nested_type_identifier] = STATE(3366),
    [sym__type] = STATE(4596),
    [sym_constructor_type] = STATE(3468),
    [sym__primary_type] = STATE(3467),
    [sym_template_literal_type] = STATE(3466),
    [sym_infer_type] = STATE(3468),
    [sym_conditional_type] = STATE(3466),
    [sym_generic_type] = STATE(3466),
    [sym_type_query] = STATE(3466),
    [sym_index_type_query] = STATE(3466),
    [sym_lookup_type] = STATE(3466),
    [sym_literal_type] = STATE(3466),
    [sym__number] = STATE(3465),
    [sym_existential_type] = STATE(3466),
    [sym_flow_maybe_type] = STATE(3466),
    [sym_parenthesized_type] = STATE(3466),
    [sym_predefined_type] = STATE(3466),
    [sym_object_type] = STATE(3466),
    [sym_type_parameters] = STATE(5758),
    [sym_array_type] = STATE(3466),
    [sym_tuple_type] = STATE(3466),
    [sym_readonly_type] = STATE(3468),
    [sym_union_type] = STATE(3466),
    [sym_intersection_type] = STATE(3466),
    [sym_function_type] = STATE(3468),
    [sym_identifier] = ACTIONS(2002),
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_LBRACE] = ACTIONS(2006),
    [anon_sym_typeof] = ACTIONS(2008),
    [anon_sym_const] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(2010),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_new] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(1109),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [sym_number] = ACTIONS(2028),
    [sym_this] = ACTIONS(2030),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [sym_null] = ACTIONS(2032),
    [sym_undefined] = ACTIONS(2032),
    [anon_sym_readonly] = ACTIONS(2034),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1109),
    [anon_sym_number] = ACTIONS(1109),
    [anon_sym_boolean] = ACTIONS(1109),
    [anon_sym_string] = ACTIONS(1109),
    [anon_sym_symbol] = ACTIONS(1109),
    [anon_sym_object] = ACTIONS(1109),
    [anon_sym_abstract] = ACTIONS(1101),
    [anon_sym_infer] = ACTIONS(1103),
    [anon_sym_keyof] = ACTIONS(1105),
    [anon_sym_unique] = ACTIONS(1107),
    [anon_sym_unknown] = ACTIONS(1109),
    [anon_sym_never] = ACTIONS(1109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1111),
    [sym_html_comment] = ACTIONS(5),
  },
  [1176] = {
    [sym_nested_identifier] = STATE(6099),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1176),
    [sym_formal_parameters] = STATE(6035),
    [sym_nested_type_identifier] = STATE(3747),
    [sym__type] = STATE(4129),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5617),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3638),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_typeof] = ACTIONS(3478),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_AMP] = ACTIONS(3482),
    [anon_sym_PIPE] = ACTIONS(3484),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(3488),
    [anon_sym_QMARK] = ACTIONS(3490),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(3492),
    [anon_sym_infer] = ACTIONS(3496),
    [anon_sym_keyof] = ACTIONS(3498),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3500),
    [sym_html_comment] = ACTIONS(5),
  },
  [1177] = {
    [sym_nested_identifier] = STATE(6099),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1177),
    [sym_formal_parameters] = STATE(6035),
    [sym_nested_type_identifier] = STATE(3747),
    [sym__type] = STATE(4161),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5617),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3638),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_typeof] = ACTIONS(3478),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_AMP] = ACTIONS(3482),
    [anon_sym_PIPE] = ACTIONS(3484),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(3488),
    [anon_sym_QMARK] = ACTIONS(3490),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(3492),
    [anon_sym_infer] = ACTIONS(3496),
    [anon_sym_keyof] = ACTIONS(3498),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3500),
    [sym_html_comment] = ACTIONS(5),
  },
  [1178] = {
    [sym_comment] = STATE(1178),
    [sym_arguments] = STATE(1207),
    [sym_identifier] = ACTIONS(3649),
    [anon_sym_export] = ACTIONS(3649),
    [anon_sym_type] = ACTIONS(3649),
    [anon_sym_namespace] = ACTIONS(3649),
    [anon_sym_LBRACE] = ACTIONS(3651),
    [anon_sym_typeof] = ACTIONS(3649),
    [anon_sym_import] = ACTIONS(3649),
    [anon_sym_from] = ACTIONS(3649),
    [anon_sym_let] = ACTIONS(3649),
    [anon_sym_BANG] = ACTIONS(3651),
    [anon_sym_LPAREN] = ACTIONS(3653),
    [anon_sym_await] = ACTIONS(3649),
    [anon_sym_of] = ACTIONS(3649),
    [anon_sym_yield] = ACTIONS(3649),
    [anon_sym_LBRACK] = ACTIONS(3651),
    [anon_sym_LTtemplate_GT] = ACTIONS(3651),
    [anon_sym_DOT] = ACTIONS(3655),
    [anon_sym_DQUOTE] = ACTIONS(3651),
    [anon_sym_SQUOTE] = ACTIONS(3651),
    [anon_sym_class] = ACTIONS(3649),
    [anon_sym_async] = ACTIONS(3649),
    [anon_sym_function] = ACTIONS(3649),
    [anon_sym_new] = ACTIONS(3649),
    [anon_sym_using] = ACTIONS(3649),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3651),
    [anon_sym_PLUS] = ACTIONS(3649),
    [anon_sym_DASH] = ACTIONS(3649),
    [anon_sym_SLASH] = ACTIONS(3649),
    [anon_sym_LT] = ACTIONS(3649),
    [anon_sym_TILDE] = ACTIONS(3651),
    [anon_sym_void] = ACTIONS(3649),
    [anon_sym_delete] = ACTIONS(3649),
    [anon_sym_PLUS_PLUS] = ACTIONS(3651),
    [anon_sym_DASH_DASH] = ACTIONS(3651),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3651),
    [sym_number] = ACTIONS(3651),
    [sym_private_property_identifier] = ACTIONS(3651),
    [sym_this] = ACTIONS(3649),
    [sym_super] = ACTIONS(3649),
    [sym_true] = ACTIONS(3649),
    [sym_false] = ACTIONS(3649),
    [sym_null] = ACTIONS(3649),
    [sym_undefined] = ACTIONS(3649),
    [anon_sym_AT] = ACTIONS(3651),
    [anon_sym_static] = ACTIONS(3649),
    [anon_sym_readonly] = ACTIONS(3649),
    [anon_sym_get] = ACTIONS(3649),
    [anon_sym_set] = ACTIONS(3649),
    [anon_sym_declare] = ACTIONS(3649),
    [anon_sym_public] = ACTIONS(3649),
    [anon_sym_private] = ACTIONS(3649),
    [anon_sym_protected] = ACTIONS(3649),
    [anon_sym_override] = ACTIONS(3649),
    [anon_sym_module] = ACTIONS(3649),
    [anon_sym_any] = ACTIONS(3649),
    [anon_sym_number] = ACTIONS(3649),
    [anon_sym_boolean] = ACTIONS(3649),
    [anon_sym_string] = ACTIONS(3649),
    [anon_sym_symbol] = ACTIONS(3649),
    [anon_sym_object] = ACTIONS(3649),
    [anon_sym_property] = ACTIONS(3649),
    [anon_sym_signal] = ACTIONS(3649),
    [anon_sym_on] = ACTIONS(3649),
    [anon_sym_required] = ACTIONS(3649),
    [anon_sym_component] = ACTIONS(3649),
    [sym_html_comment] = ACTIONS(5),
  },
  [1179] = {
    [sym_nested_identifier] = STATE(6066),
    [sym_string] = STATE(1759),
    [sym_comment] = STATE(1179),
    [sym_formal_parameters] = STATE(6184),
    [sym_nested_type_identifier] = STATE(1744),
    [sym__type] = STATE(1914),
    [sym_constructor_type] = STATE(1761),
    [sym__primary_type] = STATE(1762),
    [sym_template_literal_type] = STATE(1745),
    [sym_infer_type] = STATE(1761),
    [sym_conditional_type] = STATE(1745),
    [sym_generic_type] = STATE(1745),
    [sym_type_query] = STATE(1745),
    [sym_index_type_query] = STATE(1745),
    [sym_lookup_type] = STATE(1745),
    [sym_literal_type] = STATE(1745),
    [sym__number] = STATE(1763),
    [sym_existential_type] = STATE(1745),
    [sym_flow_maybe_type] = STATE(1745),
    [sym_parenthesized_type] = STATE(1745),
    [sym_predefined_type] = STATE(1745),
    [sym_object_type] = STATE(1745),
    [sym_type_parameters] = STATE(5724),
    [sym_array_type] = STATE(1745),
    [sym_tuple_type] = STATE(1745),
    [sym_readonly_type] = STATE(1761),
    [sym_union_type] = STATE(1745),
    [sym_intersection_type] = STATE(1745),
    [sym_function_type] = STATE(1761),
    [sym_identifier] = ACTIONS(3630),
    [anon_sym_STAR] = ACTIONS(3552),
    [anon_sym_LBRACE] = ACTIONS(3554),
    [anon_sym_typeof] = ACTIONS(3556),
    [anon_sym_const] = ACTIONS(3558),
    [anon_sym_LPAREN] = ACTIONS(3560),
    [anon_sym_LBRACK] = ACTIONS(3562),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(3564),
    [anon_sym_AMP] = ACTIONS(3566),
    [anon_sym_PIPE] = ACTIONS(3568),
    [anon_sym_PLUS] = ACTIONS(3570),
    [anon_sym_DASH] = ACTIONS(3570),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3572),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3574),
    [sym_number] = ACTIONS(3576),
    [sym_this] = ACTIONS(3632),
    [sym_true] = ACTIONS(3580),
    [sym_false] = ACTIONS(3580),
    [sym_null] = ACTIONS(3580),
    [sym_undefined] = ACTIONS(3580),
    [anon_sym_readonly] = ACTIONS(3582),
    [anon_sym_QMARK] = ACTIONS(3584),
    [anon_sym_any] = ACTIONS(3572),
    [anon_sym_number] = ACTIONS(3572),
    [anon_sym_boolean] = ACTIONS(3572),
    [anon_sym_string] = ACTIONS(3572),
    [anon_sym_symbol] = ACTIONS(3572),
    [anon_sym_object] = ACTIONS(3572),
    [anon_sym_abstract] = ACTIONS(3586),
    [anon_sym_infer] = ACTIONS(3590),
    [anon_sym_keyof] = ACTIONS(3592),
    [anon_sym_unique] = ACTIONS(3594),
    [anon_sym_unknown] = ACTIONS(3572),
    [anon_sym_never] = ACTIONS(3572),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3596),
    [sym_html_comment] = ACTIONS(5),
  },
  [1180] = {
    [sym_nested_identifier] = STATE(6099),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1180),
    [sym_formal_parameters] = STATE(6035),
    [sym_nested_type_identifier] = STATE(3747),
    [sym__type] = STATE(3230),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5617),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3638),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_typeof] = ACTIONS(3478),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_AMP] = ACTIONS(3482),
    [anon_sym_PIPE] = ACTIONS(3484),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(3488),
    [anon_sym_QMARK] = ACTIONS(3490),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(3492),
    [anon_sym_infer] = ACTIONS(3496),
    [anon_sym_keyof] = ACTIONS(3498),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3500),
    [sym_html_comment] = ACTIONS(5),
  },
  [1181] = {
    [sym_nested_identifier] = STATE(6123),
    [sym_string] = STATE(3650),
    [sym_comment] = STATE(1181),
    [sym_formal_parameters] = STATE(6329),
    [sym_nested_type_identifier] = STATE(3475),
    [sym__type] = STATE(3555),
    [sym_constructor_type] = STATE(3735),
    [sym__primary_type] = STATE(3709),
    [sym_template_literal_type] = STATE(3706),
    [sym_infer_type] = STATE(3735),
    [sym_conditional_type] = STATE(3706),
    [sym_generic_type] = STATE(3706),
    [sym_type_query] = STATE(3706),
    [sym_index_type_query] = STATE(3706),
    [sym_lookup_type] = STATE(3706),
    [sym_literal_type] = STATE(3706),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3706),
    [sym_flow_maybe_type] = STATE(3706),
    [sym_parenthesized_type] = STATE(3706),
    [sym_predefined_type] = STATE(3706),
    [sym_object_type] = STATE(3706),
    [sym_type_parameters] = STATE(5682),
    [sym_array_type] = STATE(3706),
    [sym_tuple_type] = STATE(3706),
    [sym_readonly_type] = STATE(3735),
    [sym_union_type] = STATE(3706),
    [sym_intersection_type] = STATE(3706),
    [sym_function_type] = STATE(3735),
    [sym_identifier] = ACTIONS(3634),
    [anon_sym_STAR] = ACTIONS(3313),
    [anon_sym_LBRACE] = ACTIONS(3315),
    [anon_sym_typeof] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_LPAREN] = ACTIONS(3321),
    [anon_sym_LBRACK] = ACTIONS(3323),
    [anon_sym_DQUOTE] = ACTIONS(3325),
    [anon_sym_SQUOTE] = ACTIONS(3327),
    [anon_sym_new] = ACTIONS(3329),
    [anon_sym_AMP] = ACTIONS(3331),
    [anon_sym_PIPE] = ACTIONS(3333),
    [anon_sym_PLUS] = ACTIONS(3335),
    [anon_sym_DASH] = ACTIONS(3335),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3337),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3339),
    [sym_number] = ACTIONS(3341),
    [sym_this] = ACTIONS(3636),
    [sym_true] = ACTIONS(3345),
    [sym_false] = ACTIONS(3345),
    [sym_null] = ACTIONS(3345),
    [sym_undefined] = ACTIONS(3345),
    [anon_sym_readonly] = ACTIONS(3347),
    [anon_sym_QMARK] = ACTIONS(3349),
    [anon_sym_any] = ACTIONS(3337),
    [anon_sym_number] = ACTIONS(3337),
    [anon_sym_boolean] = ACTIONS(3337),
    [anon_sym_string] = ACTIONS(3337),
    [anon_sym_symbol] = ACTIONS(3337),
    [anon_sym_object] = ACTIONS(3337),
    [anon_sym_abstract] = ACTIONS(3351),
    [anon_sym_infer] = ACTIONS(3355),
    [anon_sym_keyof] = ACTIONS(3357),
    [anon_sym_unique] = ACTIONS(3359),
    [anon_sym_unknown] = ACTIONS(3337),
    [anon_sym_never] = ACTIONS(3337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3361),
    [sym_html_comment] = ACTIONS(5),
  },
  [1182] = {
    [sym_nested_identifier] = STATE(6099),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1182),
    [sym_formal_parameters] = STATE(6035),
    [sym_nested_type_identifier] = STATE(3747),
    [sym__type] = STATE(3211),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5617),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3638),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_typeof] = ACTIONS(3478),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_AMP] = ACTIONS(3482),
    [anon_sym_PIPE] = ACTIONS(3484),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(3488),
    [anon_sym_QMARK] = ACTIONS(3490),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(3492),
    [anon_sym_infer] = ACTIONS(3496),
    [anon_sym_keyof] = ACTIONS(3498),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3500),
    [sym_html_comment] = ACTIONS(5),
  },
  [1183] = {
    [sym_nested_identifier] = STATE(5958),
    [sym_string] = STATE(2307),
    [sym_comment] = STATE(1183),
    [sym_formal_parameters] = STATE(6100),
    [sym_nested_type_identifier] = STATE(2121),
    [sym__type] = STATE(2317),
    [sym_constructor_type] = STATE(2353),
    [sym__primary_type] = STATE(2401),
    [sym_template_literal_type] = STATE(2397),
    [sym_infer_type] = STATE(2353),
    [sym_conditional_type] = STATE(2397),
    [sym_generic_type] = STATE(2397),
    [sym_type_query] = STATE(2397),
    [sym_index_type_query] = STATE(2397),
    [sym_lookup_type] = STATE(2397),
    [sym_literal_type] = STATE(2397),
    [sym__number] = STATE(2309),
    [sym_existential_type] = STATE(2397),
    [sym_flow_maybe_type] = STATE(2397),
    [sym_parenthesized_type] = STATE(2397),
    [sym_predefined_type] = STATE(2397),
    [sym_object_type] = STATE(2397),
    [sym_type_parameters] = STATE(5861),
    [sym_array_type] = STATE(2397),
    [sym_tuple_type] = STATE(2397),
    [sym_readonly_type] = STATE(2353),
    [sym_union_type] = STATE(2397),
    [sym_intersection_type] = STATE(2397),
    [sym_function_type] = STATE(2353),
    [sym_identifier] = ACTIONS(3626),
    [anon_sym_STAR] = ACTIONS(3504),
    [anon_sym_LBRACE] = ACTIONS(3506),
    [anon_sym_typeof] = ACTIONS(3508),
    [anon_sym_const] = ACTIONS(3510),
    [anon_sym_LPAREN] = ACTIONS(3512),
    [anon_sym_LBRACK] = ACTIONS(3514),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_new] = ACTIONS(3516),
    [anon_sym_AMP] = ACTIONS(3518),
    [anon_sym_PIPE] = ACTIONS(3520),
    [anon_sym_PLUS] = ACTIONS(3522),
    [anon_sym_DASH] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3524),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3526),
    [sym_number] = ACTIONS(3528),
    [sym_this] = ACTIONS(3628),
    [sym_true] = ACTIONS(3532),
    [sym_false] = ACTIONS(3532),
    [sym_null] = ACTIONS(3532),
    [sym_undefined] = ACTIONS(3532),
    [anon_sym_readonly] = ACTIONS(3534),
    [anon_sym_QMARK] = ACTIONS(3536),
    [anon_sym_any] = ACTIONS(3524),
    [anon_sym_number] = ACTIONS(3524),
    [anon_sym_boolean] = ACTIONS(3524),
    [anon_sym_string] = ACTIONS(3524),
    [anon_sym_symbol] = ACTIONS(3524),
    [anon_sym_object] = ACTIONS(3524),
    [anon_sym_abstract] = ACTIONS(3538),
    [anon_sym_infer] = ACTIONS(3542),
    [anon_sym_keyof] = ACTIONS(3544),
    [anon_sym_unique] = ACTIONS(3546),
    [anon_sym_unknown] = ACTIONS(3524),
    [anon_sym_never] = ACTIONS(3524),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3548),
    [sym_html_comment] = ACTIONS(5),
  },
  [1184] = {
    [sym_nested_identifier] = STATE(5958),
    [sym_string] = STATE(2307),
    [sym_comment] = STATE(1184),
    [sym_formal_parameters] = STATE(6100),
    [sym_nested_type_identifier] = STATE(2121),
    [sym__type] = STATE(2315),
    [sym_constructor_type] = STATE(2353),
    [sym__primary_type] = STATE(2401),
    [sym_template_literal_type] = STATE(2397),
    [sym_infer_type] = STATE(2353),
    [sym_conditional_type] = STATE(2397),
    [sym_generic_type] = STATE(2397),
    [sym_type_query] = STATE(2397),
    [sym_index_type_query] = STATE(2397),
    [sym_lookup_type] = STATE(2397),
    [sym_literal_type] = STATE(2397),
    [sym__number] = STATE(2309),
    [sym_existential_type] = STATE(2397),
    [sym_flow_maybe_type] = STATE(2397),
    [sym_parenthesized_type] = STATE(2397),
    [sym_predefined_type] = STATE(2397),
    [sym_object_type] = STATE(2397),
    [sym_type_parameters] = STATE(5861),
    [sym_array_type] = STATE(2397),
    [sym_tuple_type] = STATE(2397),
    [sym_readonly_type] = STATE(2353),
    [sym_union_type] = STATE(2397),
    [sym_intersection_type] = STATE(2397),
    [sym_function_type] = STATE(2353),
    [sym_identifier] = ACTIONS(3626),
    [anon_sym_STAR] = ACTIONS(3504),
    [anon_sym_LBRACE] = ACTIONS(3506),
    [anon_sym_typeof] = ACTIONS(3508),
    [anon_sym_const] = ACTIONS(3657),
    [anon_sym_LPAREN] = ACTIONS(3512),
    [anon_sym_LBRACK] = ACTIONS(3514),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_new] = ACTIONS(3516),
    [anon_sym_AMP] = ACTIONS(3518),
    [anon_sym_PIPE] = ACTIONS(3520),
    [anon_sym_PLUS] = ACTIONS(3522),
    [anon_sym_DASH] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3524),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3526),
    [sym_number] = ACTIONS(3528),
    [sym_this] = ACTIONS(3628),
    [sym_true] = ACTIONS(3532),
    [sym_false] = ACTIONS(3532),
    [sym_null] = ACTIONS(3532),
    [sym_undefined] = ACTIONS(3532),
    [anon_sym_readonly] = ACTIONS(3534),
    [anon_sym_QMARK] = ACTIONS(3536),
    [anon_sym_any] = ACTIONS(3524),
    [anon_sym_number] = ACTIONS(3524),
    [anon_sym_boolean] = ACTIONS(3524),
    [anon_sym_string] = ACTIONS(3524),
    [anon_sym_symbol] = ACTIONS(3524),
    [anon_sym_object] = ACTIONS(3524),
    [anon_sym_abstract] = ACTIONS(3538),
    [anon_sym_infer] = ACTIONS(3542),
    [anon_sym_keyof] = ACTIONS(3544),
    [anon_sym_unique] = ACTIONS(3546),
    [anon_sym_unknown] = ACTIONS(3524),
    [anon_sym_never] = ACTIONS(3524),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3548),
    [sym_html_comment] = ACTIONS(5),
  },
  [1185] = {
    [sym_nested_identifier] = STATE(6123),
    [sym_string] = STATE(3650),
    [sym_comment] = STATE(1185),
    [sym_formal_parameters] = STATE(6329),
    [sym_nested_type_identifier] = STATE(3475),
    [sym__type] = STATE(3611),
    [sym_constructor_type] = STATE(3735),
    [sym__primary_type] = STATE(3709),
    [sym_template_literal_type] = STATE(3706),
    [sym_infer_type] = STATE(3735),
    [sym_conditional_type] = STATE(3706),
    [sym_generic_type] = STATE(3706),
    [sym_type_query] = STATE(3706),
    [sym_index_type_query] = STATE(3706),
    [sym_lookup_type] = STATE(3706),
    [sym_literal_type] = STATE(3706),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3706),
    [sym_flow_maybe_type] = STATE(3706),
    [sym_parenthesized_type] = STATE(3706),
    [sym_predefined_type] = STATE(3706),
    [sym_object_type] = STATE(3706),
    [sym_type_parameters] = STATE(5682),
    [sym_array_type] = STATE(3706),
    [sym_tuple_type] = STATE(3706),
    [sym_readonly_type] = STATE(3735),
    [sym_union_type] = STATE(3706),
    [sym_intersection_type] = STATE(3706),
    [sym_function_type] = STATE(3735),
    [sym_identifier] = ACTIONS(3634),
    [anon_sym_STAR] = ACTIONS(3313),
    [anon_sym_LBRACE] = ACTIONS(3315),
    [anon_sym_typeof] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_LPAREN] = ACTIONS(3321),
    [anon_sym_LBRACK] = ACTIONS(3323),
    [anon_sym_DQUOTE] = ACTIONS(3325),
    [anon_sym_SQUOTE] = ACTIONS(3327),
    [anon_sym_new] = ACTIONS(3329),
    [anon_sym_AMP] = ACTIONS(3331),
    [anon_sym_PIPE] = ACTIONS(3333),
    [anon_sym_PLUS] = ACTIONS(3335),
    [anon_sym_DASH] = ACTIONS(3335),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3337),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3339),
    [sym_number] = ACTIONS(3341),
    [sym_this] = ACTIONS(3636),
    [sym_true] = ACTIONS(3345),
    [sym_false] = ACTIONS(3345),
    [sym_null] = ACTIONS(3345),
    [sym_undefined] = ACTIONS(3345),
    [anon_sym_readonly] = ACTIONS(3347),
    [anon_sym_QMARK] = ACTIONS(3349),
    [anon_sym_any] = ACTIONS(3337),
    [anon_sym_number] = ACTIONS(3337),
    [anon_sym_boolean] = ACTIONS(3337),
    [anon_sym_string] = ACTIONS(3337),
    [anon_sym_symbol] = ACTIONS(3337),
    [anon_sym_object] = ACTIONS(3337),
    [anon_sym_abstract] = ACTIONS(3351),
    [anon_sym_infer] = ACTIONS(3355),
    [anon_sym_keyof] = ACTIONS(3357),
    [anon_sym_unique] = ACTIONS(3359),
    [anon_sym_unknown] = ACTIONS(3337),
    [anon_sym_never] = ACTIONS(3337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3361),
    [sym_html_comment] = ACTIONS(5),
  },
  [1186] = {
    [sym_nested_identifier] = STATE(5958),
    [sym_string] = STATE(2307),
    [sym_comment] = STATE(1186),
    [sym_formal_parameters] = STATE(6100),
    [sym_nested_type_identifier] = STATE(2121),
    [sym__type] = STATE(2318),
    [sym_constructor_type] = STATE(2353),
    [sym__primary_type] = STATE(2401),
    [sym_template_literal_type] = STATE(2397),
    [sym_infer_type] = STATE(2353),
    [sym_conditional_type] = STATE(2397),
    [sym_generic_type] = STATE(2397),
    [sym_type_query] = STATE(2397),
    [sym_index_type_query] = STATE(2397),
    [sym_lookup_type] = STATE(2397),
    [sym_literal_type] = STATE(2397),
    [sym__number] = STATE(2309),
    [sym_existential_type] = STATE(2397),
    [sym_flow_maybe_type] = STATE(2397),
    [sym_parenthesized_type] = STATE(2397),
    [sym_predefined_type] = STATE(2397),
    [sym_object_type] = STATE(2397),
    [sym_type_parameters] = STATE(5861),
    [sym_array_type] = STATE(2397),
    [sym_tuple_type] = STATE(2397),
    [sym_readonly_type] = STATE(2353),
    [sym_union_type] = STATE(2397),
    [sym_intersection_type] = STATE(2397),
    [sym_function_type] = STATE(2353),
    [sym_identifier] = ACTIONS(3626),
    [anon_sym_STAR] = ACTIONS(3504),
    [anon_sym_LBRACE] = ACTIONS(3506),
    [anon_sym_typeof] = ACTIONS(3508),
    [anon_sym_const] = ACTIONS(3510),
    [anon_sym_LPAREN] = ACTIONS(3512),
    [anon_sym_LBRACK] = ACTIONS(3514),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_new] = ACTIONS(3516),
    [anon_sym_AMP] = ACTIONS(3518),
    [anon_sym_PIPE] = ACTIONS(3520),
    [anon_sym_PLUS] = ACTIONS(3522),
    [anon_sym_DASH] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3524),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3526),
    [sym_number] = ACTIONS(3528),
    [sym_this] = ACTIONS(3628),
    [sym_true] = ACTIONS(3532),
    [sym_false] = ACTIONS(3532),
    [sym_null] = ACTIONS(3532),
    [sym_undefined] = ACTIONS(3532),
    [anon_sym_readonly] = ACTIONS(3534),
    [anon_sym_QMARK] = ACTIONS(3536),
    [anon_sym_any] = ACTIONS(3524),
    [anon_sym_number] = ACTIONS(3524),
    [anon_sym_boolean] = ACTIONS(3524),
    [anon_sym_string] = ACTIONS(3524),
    [anon_sym_symbol] = ACTIONS(3524),
    [anon_sym_object] = ACTIONS(3524),
    [anon_sym_abstract] = ACTIONS(3538),
    [anon_sym_infer] = ACTIONS(3542),
    [anon_sym_keyof] = ACTIONS(3544),
    [anon_sym_unique] = ACTIONS(3546),
    [anon_sym_unknown] = ACTIONS(3524),
    [anon_sym_never] = ACTIONS(3524),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3548),
    [sym_html_comment] = ACTIONS(5),
  },
  [1187] = {
    [sym_nested_identifier] = STATE(6123),
    [sym_string] = STATE(3650),
    [sym_comment] = STATE(1187),
    [sym_formal_parameters] = STATE(6329),
    [sym_nested_type_identifier] = STATE(3475),
    [sym__type] = STATE(3557),
    [sym_constructor_type] = STATE(3735),
    [sym__primary_type] = STATE(3709),
    [sym_template_literal_type] = STATE(3706),
    [sym_infer_type] = STATE(3735),
    [sym_conditional_type] = STATE(3706),
    [sym_generic_type] = STATE(3706),
    [sym_type_query] = STATE(3706),
    [sym_index_type_query] = STATE(3706),
    [sym_lookup_type] = STATE(3706),
    [sym_literal_type] = STATE(3706),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3706),
    [sym_flow_maybe_type] = STATE(3706),
    [sym_parenthesized_type] = STATE(3706),
    [sym_predefined_type] = STATE(3706),
    [sym_object_type] = STATE(3706),
    [sym_type_parameters] = STATE(5682),
    [sym_array_type] = STATE(3706),
    [sym_tuple_type] = STATE(3706),
    [sym_readonly_type] = STATE(3735),
    [sym_union_type] = STATE(3706),
    [sym_intersection_type] = STATE(3706),
    [sym_function_type] = STATE(3735),
    [sym_identifier] = ACTIONS(3634),
    [anon_sym_STAR] = ACTIONS(3313),
    [anon_sym_LBRACE] = ACTIONS(3315),
    [anon_sym_typeof] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_LPAREN] = ACTIONS(3321),
    [anon_sym_LBRACK] = ACTIONS(3323),
    [anon_sym_DQUOTE] = ACTIONS(3325),
    [anon_sym_SQUOTE] = ACTIONS(3327),
    [anon_sym_new] = ACTIONS(3329),
    [anon_sym_AMP] = ACTIONS(3331),
    [anon_sym_PIPE] = ACTIONS(3333),
    [anon_sym_PLUS] = ACTIONS(3335),
    [anon_sym_DASH] = ACTIONS(3335),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3337),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3339),
    [sym_number] = ACTIONS(3341),
    [sym_this] = ACTIONS(3636),
    [sym_true] = ACTIONS(3345),
    [sym_false] = ACTIONS(3345),
    [sym_null] = ACTIONS(3345),
    [sym_undefined] = ACTIONS(3345),
    [anon_sym_readonly] = ACTIONS(3347),
    [anon_sym_QMARK] = ACTIONS(3349),
    [anon_sym_any] = ACTIONS(3337),
    [anon_sym_number] = ACTIONS(3337),
    [anon_sym_boolean] = ACTIONS(3337),
    [anon_sym_string] = ACTIONS(3337),
    [anon_sym_symbol] = ACTIONS(3337),
    [anon_sym_object] = ACTIONS(3337),
    [anon_sym_abstract] = ACTIONS(3351),
    [anon_sym_infer] = ACTIONS(3355),
    [anon_sym_keyof] = ACTIONS(3357),
    [anon_sym_unique] = ACTIONS(3359),
    [anon_sym_unknown] = ACTIONS(3337),
    [anon_sym_never] = ACTIONS(3337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3361),
    [sym_html_comment] = ACTIONS(5),
  },
  [1188] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1188),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4715),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1189] = {
    [sym_nested_identifier] = STATE(6123),
    [sym_string] = STATE(3650),
    [sym_comment] = STATE(1189),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3475),
    [sym__type] = STATE(5490),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3572),
    [sym_template_literal_type] = STATE(3706),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3706),
    [sym_generic_type] = STATE(3706),
    [sym_type_query] = STATE(3706),
    [sym_index_type_query] = STATE(3706),
    [sym_lookup_type] = STATE(3706),
    [sym_literal_type] = STATE(3706),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3706),
    [sym_flow_maybe_type] = STATE(3706),
    [sym_parenthesized_type] = STATE(3706),
    [sym_predefined_type] = STATE(3706),
    [sym_object_type] = STATE(3706),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3706),
    [sym_tuple_type] = STATE(3706),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3706),
    [sym_intersection_type] = STATE(3706),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3634),
    [anon_sym_STAR] = ACTIONS(3313),
    [anon_sym_LBRACE] = ACTIONS(3315),
    [anon_sym_typeof] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_LPAREN] = ACTIONS(3321),
    [anon_sym_LBRACK] = ACTIONS(3323),
    [anon_sym_DQUOTE] = ACTIONS(3325),
    [anon_sym_SQUOTE] = ACTIONS(3327),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(3331),
    [anon_sym_PIPE] = ACTIONS(3333),
    [anon_sym_PLUS] = ACTIONS(3335),
    [anon_sym_DASH] = ACTIONS(3335),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3337),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3339),
    [sym_number] = ACTIONS(3341),
    [sym_this] = ACTIONS(3636),
    [sym_true] = ACTIONS(3345),
    [sym_false] = ACTIONS(3345),
    [sym_null] = ACTIONS(3345),
    [sym_undefined] = ACTIONS(3345),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(3349),
    [anon_sym_any] = ACTIONS(3337),
    [anon_sym_number] = ACTIONS(3337),
    [anon_sym_boolean] = ACTIONS(3337),
    [anon_sym_string] = ACTIONS(3337),
    [anon_sym_symbol] = ACTIONS(3337),
    [anon_sym_object] = ACTIONS(3337),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(3357),
    [anon_sym_unique] = ACTIONS(3359),
    [anon_sym_unknown] = ACTIONS(3337),
    [anon_sym_never] = ACTIONS(3337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3361),
    [sym_html_comment] = ACTIONS(5),
  },
  [1190] = {
    [sym_nested_identifier] = STATE(5958),
    [sym_string] = STATE(2307),
    [sym_comment] = STATE(1190),
    [sym_formal_parameters] = STATE(6100),
    [sym_nested_type_identifier] = STATE(2121),
    [sym__type] = STATE(2331),
    [sym_constructor_type] = STATE(2353),
    [sym__primary_type] = STATE(2401),
    [sym_template_literal_type] = STATE(2397),
    [sym_infer_type] = STATE(2353),
    [sym_conditional_type] = STATE(2397),
    [sym_generic_type] = STATE(2397),
    [sym_type_query] = STATE(2397),
    [sym_index_type_query] = STATE(2397),
    [sym_lookup_type] = STATE(2397),
    [sym_literal_type] = STATE(2397),
    [sym__number] = STATE(2309),
    [sym_existential_type] = STATE(2397),
    [sym_flow_maybe_type] = STATE(2397),
    [sym_parenthesized_type] = STATE(2397),
    [sym_predefined_type] = STATE(2397),
    [sym_object_type] = STATE(2397),
    [sym_type_parameters] = STATE(5861),
    [sym_array_type] = STATE(2397),
    [sym_tuple_type] = STATE(2397),
    [sym_readonly_type] = STATE(2353),
    [sym_union_type] = STATE(2397),
    [sym_intersection_type] = STATE(2397),
    [sym_function_type] = STATE(2353),
    [sym_identifier] = ACTIONS(3626),
    [anon_sym_STAR] = ACTIONS(3504),
    [anon_sym_LBRACE] = ACTIONS(3506),
    [anon_sym_typeof] = ACTIONS(3508),
    [anon_sym_const] = ACTIONS(3510),
    [anon_sym_LPAREN] = ACTIONS(3512),
    [anon_sym_LBRACK] = ACTIONS(3514),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_new] = ACTIONS(3516),
    [anon_sym_AMP] = ACTIONS(3518),
    [anon_sym_PIPE] = ACTIONS(3520),
    [anon_sym_PLUS] = ACTIONS(3522),
    [anon_sym_DASH] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3524),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3526),
    [sym_number] = ACTIONS(3528),
    [sym_this] = ACTIONS(3628),
    [sym_true] = ACTIONS(3532),
    [sym_false] = ACTIONS(3532),
    [sym_null] = ACTIONS(3532),
    [sym_undefined] = ACTIONS(3532),
    [anon_sym_readonly] = ACTIONS(3534),
    [anon_sym_QMARK] = ACTIONS(3536),
    [anon_sym_any] = ACTIONS(3524),
    [anon_sym_number] = ACTIONS(3524),
    [anon_sym_boolean] = ACTIONS(3524),
    [anon_sym_string] = ACTIONS(3524),
    [anon_sym_symbol] = ACTIONS(3524),
    [anon_sym_object] = ACTIONS(3524),
    [anon_sym_abstract] = ACTIONS(3538),
    [anon_sym_infer] = ACTIONS(3542),
    [anon_sym_keyof] = ACTIONS(3544),
    [anon_sym_unique] = ACTIONS(3546),
    [anon_sym_unknown] = ACTIONS(3524),
    [anon_sym_never] = ACTIONS(3524),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3548),
    [sym_html_comment] = ACTIONS(5),
  },
  [1191] = {
    [sym_nested_identifier] = STATE(5958),
    [sym_string] = STATE(2307),
    [sym_comment] = STATE(1191),
    [sym_formal_parameters] = STATE(6100),
    [sym_nested_type_identifier] = STATE(2121),
    [sym__type] = STATE(2333),
    [sym_constructor_type] = STATE(2353),
    [sym__primary_type] = STATE(2401),
    [sym_template_literal_type] = STATE(2397),
    [sym_infer_type] = STATE(2353),
    [sym_conditional_type] = STATE(2397),
    [sym_generic_type] = STATE(2397),
    [sym_type_query] = STATE(2397),
    [sym_index_type_query] = STATE(2397),
    [sym_lookup_type] = STATE(2397),
    [sym_literal_type] = STATE(2397),
    [sym__number] = STATE(2309),
    [sym_existential_type] = STATE(2397),
    [sym_flow_maybe_type] = STATE(2397),
    [sym_parenthesized_type] = STATE(2397),
    [sym_predefined_type] = STATE(2397),
    [sym_object_type] = STATE(2397),
    [sym_type_parameters] = STATE(5861),
    [sym_array_type] = STATE(2397),
    [sym_tuple_type] = STATE(2397),
    [sym_readonly_type] = STATE(2353),
    [sym_union_type] = STATE(2397),
    [sym_intersection_type] = STATE(2397),
    [sym_function_type] = STATE(2353),
    [sym_identifier] = ACTIONS(3626),
    [anon_sym_STAR] = ACTIONS(3504),
    [anon_sym_LBRACE] = ACTIONS(3506),
    [anon_sym_typeof] = ACTIONS(3508),
    [anon_sym_const] = ACTIONS(3510),
    [anon_sym_LPAREN] = ACTIONS(3512),
    [anon_sym_LBRACK] = ACTIONS(3514),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_new] = ACTIONS(3516),
    [anon_sym_AMP] = ACTIONS(3518),
    [anon_sym_PIPE] = ACTIONS(3520),
    [anon_sym_PLUS] = ACTIONS(3522),
    [anon_sym_DASH] = ACTIONS(3522),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3524),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3526),
    [sym_number] = ACTIONS(3528),
    [sym_this] = ACTIONS(3628),
    [sym_true] = ACTIONS(3532),
    [sym_false] = ACTIONS(3532),
    [sym_null] = ACTIONS(3532),
    [sym_undefined] = ACTIONS(3532),
    [anon_sym_readonly] = ACTIONS(3534),
    [anon_sym_QMARK] = ACTIONS(3536),
    [anon_sym_any] = ACTIONS(3524),
    [anon_sym_number] = ACTIONS(3524),
    [anon_sym_boolean] = ACTIONS(3524),
    [anon_sym_string] = ACTIONS(3524),
    [anon_sym_symbol] = ACTIONS(3524),
    [anon_sym_object] = ACTIONS(3524),
    [anon_sym_abstract] = ACTIONS(3538),
    [anon_sym_infer] = ACTIONS(3542),
    [anon_sym_keyof] = ACTIONS(3544),
    [anon_sym_unique] = ACTIONS(3546),
    [anon_sym_unknown] = ACTIONS(3524),
    [anon_sym_never] = ACTIONS(3524),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3548),
    [sym_html_comment] = ACTIONS(5),
  },
  [1192] = {
    [sym_nested_identifier] = STATE(6099),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1192),
    [sym_formal_parameters] = STATE(6035),
    [sym_nested_type_identifier] = STATE(3747),
    [sym__type] = STATE(3205),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5617),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3638),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_typeof] = ACTIONS(3478),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_AMP] = ACTIONS(3482),
    [anon_sym_PIPE] = ACTIONS(3484),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(3488),
    [anon_sym_QMARK] = ACTIONS(3490),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(3492),
    [anon_sym_infer] = ACTIONS(3496),
    [anon_sym_keyof] = ACTIONS(3498),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3500),
    [sym_html_comment] = ACTIONS(5),
  },
  [1193] = {
    [sym_nested_identifier] = STATE(6099),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1193),
    [sym_formal_parameters] = STATE(6035),
    [sym_nested_type_identifier] = STATE(3747),
    [sym__type] = STATE(3204),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5617),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3638),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_typeof] = ACTIONS(3478),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_AMP] = ACTIONS(3482),
    [anon_sym_PIPE] = ACTIONS(3484),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(3488),
    [anon_sym_QMARK] = ACTIONS(3490),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(3492),
    [anon_sym_infer] = ACTIONS(3496),
    [anon_sym_keyof] = ACTIONS(3498),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3500),
    [sym_html_comment] = ACTIONS(5),
  },
  [1194] = {
    [sym_nested_identifier] = STATE(6076),
    [sym_string] = STATE(3484),
    [sym_comment] = STATE(1194),
    [sym_formal_parameters] = STATE(5995),
    [sym_nested_type_identifier] = STATE(3366),
    [sym__type] = STATE(4382),
    [sym_constructor_type] = STATE(3468),
    [sym__primary_type] = STATE(3467),
    [sym_template_literal_type] = STATE(3466),
    [sym_infer_type] = STATE(3468),
    [sym_conditional_type] = STATE(3466),
    [sym_generic_type] = STATE(3466),
    [sym_type_query] = STATE(3466),
    [sym_index_type_query] = STATE(3466),
    [sym_lookup_type] = STATE(3466),
    [sym_literal_type] = STATE(3466),
    [sym__number] = STATE(3465),
    [sym_existential_type] = STATE(3466),
    [sym_flow_maybe_type] = STATE(3466),
    [sym_parenthesized_type] = STATE(3466),
    [sym_predefined_type] = STATE(3466),
    [sym_object_type] = STATE(3466),
    [sym_type_parameters] = STATE(5758),
    [sym_array_type] = STATE(3466),
    [sym_tuple_type] = STATE(3466),
    [sym_readonly_type] = STATE(3468),
    [sym_union_type] = STATE(3466),
    [sym_intersection_type] = STATE(3466),
    [sym_function_type] = STATE(3468),
    [sym_identifier] = ACTIONS(2002),
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_LBRACE] = ACTIONS(2006),
    [anon_sym_typeof] = ACTIONS(2008),
    [anon_sym_const] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(2010),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_new] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(1109),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [sym_number] = ACTIONS(2028),
    [sym_this] = ACTIONS(2030),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [sym_null] = ACTIONS(2032),
    [sym_undefined] = ACTIONS(2032),
    [anon_sym_readonly] = ACTIONS(2034),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1109),
    [anon_sym_number] = ACTIONS(1109),
    [anon_sym_boolean] = ACTIONS(1109),
    [anon_sym_string] = ACTIONS(1109),
    [anon_sym_symbol] = ACTIONS(1109),
    [anon_sym_object] = ACTIONS(1109),
    [anon_sym_abstract] = ACTIONS(1101),
    [anon_sym_infer] = ACTIONS(1103),
    [anon_sym_keyof] = ACTIONS(1105),
    [anon_sym_unique] = ACTIONS(1107),
    [anon_sym_unknown] = ACTIONS(1109),
    [anon_sym_never] = ACTIONS(1109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1111),
    [sym_html_comment] = ACTIONS(5),
  },
  [1195] = {
    [sym_nested_identifier] = STATE(6123),
    [sym_string] = STATE(3650),
    [sym_comment] = STATE(1195),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3475),
    [sym__type] = STATE(5490),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3562),
    [sym_template_literal_type] = STATE(3706),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3706),
    [sym_generic_type] = STATE(3706),
    [sym_type_query] = STATE(3706),
    [sym_index_type_query] = STATE(3706),
    [sym_lookup_type] = STATE(3706),
    [sym_literal_type] = STATE(3706),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3706),
    [sym_flow_maybe_type] = STATE(3706),
    [sym_parenthesized_type] = STATE(3706),
    [sym_predefined_type] = STATE(3706),
    [sym_object_type] = STATE(3706),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3706),
    [sym_tuple_type] = STATE(3706),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3706),
    [sym_intersection_type] = STATE(3706),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3634),
    [anon_sym_STAR] = ACTIONS(3313),
    [anon_sym_LBRACE] = ACTIONS(3315),
    [anon_sym_typeof] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_LPAREN] = ACTIONS(3321),
    [anon_sym_LBRACK] = ACTIONS(3323),
    [anon_sym_DQUOTE] = ACTIONS(3325),
    [anon_sym_SQUOTE] = ACTIONS(3327),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(3331),
    [anon_sym_PIPE] = ACTIONS(3333),
    [anon_sym_PLUS] = ACTIONS(3335),
    [anon_sym_DASH] = ACTIONS(3335),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3337),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3339),
    [sym_number] = ACTIONS(3341),
    [sym_this] = ACTIONS(3636),
    [sym_true] = ACTIONS(3345),
    [sym_false] = ACTIONS(3345),
    [sym_null] = ACTIONS(3345),
    [sym_undefined] = ACTIONS(3345),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(3349),
    [anon_sym_any] = ACTIONS(3337),
    [anon_sym_number] = ACTIONS(3337),
    [anon_sym_boolean] = ACTIONS(3337),
    [anon_sym_string] = ACTIONS(3337),
    [anon_sym_symbol] = ACTIONS(3337),
    [anon_sym_object] = ACTIONS(3337),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(3357),
    [anon_sym_unique] = ACTIONS(3359),
    [anon_sym_unknown] = ACTIONS(3337),
    [anon_sym_never] = ACTIONS(3337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3361),
    [sym_html_comment] = ACTIONS(5),
  },
  [1196] = {
    [sym_nested_identifier] = STATE(6076),
    [sym_string] = STATE(3484),
    [sym_comment] = STATE(1196),
    [sym_formal_parameters] = STATE(5995),
    [sym_nested_type_identifier] = STATE(3366),
    [sym__type] = STATE(4577),
    [sym_constructor_type] = STATE(3468),
    [sym__primary_type] = STATE(3467),
    [sym_template_literal_type] = STATE(3466),
    [sym_infer_type] = STATE(3468),
    [sym_conditional_type] = STATE(3466),
    [sym_generic_type] = STATE(3466),
    [sym_type_query] = STATE(3466),
    [sym_index_type_query] = STATE(3466),
    [sym_lookup_type] = STATE(3466),
    [sym_literal_type] = STATE(3466),
    [sym__number] = STATE(3465),
    [sym_existential_type] = STATE(3466),
    [sym_flow_maybe_type] = STATE(3466),
    [sym_parenthesized_type] = STATE(3466),
    [sym_predefined_type] = STATE(3466),
    [sym_object_type] = STATE(3466),
    [sym_type_parameters] = STATE(5758),
    [sym_array_type] = STATE(3466),
    [sym_tuple_type] = STATE(3466),
    [sym_readonly_type] = STATE(3468),
    [sym_union_type] = STATE(3466),
    [sym_intersection_type] = STATE(3466),
    [sym_function_type] = STATE(3468),
    [sym_identifier] = ACTIONS(2002),
    [anon_sym_STAR] = ACTIONS(1063),
    [anon_sym_LBRACE] = ACTIONS(2006),
    [anon_sym_typeof] = ACTIONS(2008),
    [anon_sym_const] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(2010),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_new] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(1109),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [sym_number] = ACTIONS(2028),
    [sym_this] = ACTIONS(2030),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [sym_null] = ACTIONS(2032),
    [sym_undefined] = ACTIONS(2032),
    [anon_sym_readonly] = ACTIONS(2034),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1109),
    [anon_sym_number] = ACTIONS(1109),
    [anon_sym_boolean] = ACTIONS(1109),
    [anon_sym_string] = ACTIONS(1109),
    [anon_sym_symbol] = ACTIONS(1109),
    [anon_sym_object] = ACTIONS(1109),
    [anon_sym_abstract] = ACTIONS(1101),
    [anon_sym_infer] = ACTIONS(1103),
    [anon_sym_keyof] = ACTIONS(1105),
    [anon_sym_unique] = ACTIONS(1107),
    [anon_sym_unknown] = ACTIONS(1109),
    [anon_sym_never] = ACTIONS(1109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1111),
    [sym_html_comment] = ACTIONS(5),
  },
  [1197] = {
    [sym_nested_identifier] = STATE(6099),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1197),
    [sym_formal_parameters] = STATE(6035),
    [sym_nested_type_identifier] = STATE(3747),
    [sym__type] = STATE(4148),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5617),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3638),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_typeof] = ACTIONS(3478),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_AMP] = ACTIONS(3482),
    [anon_sym_PIPE] = ACTIONS(3484),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(3488),
    [anon_sym_QMARK] = ACTIONS(3490),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(3492),
    [anon_sym_infer] = ACTIONS(3496),
    [anon_sym_keyof] = ACTIONS(3498),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3500),
    [sym_html_comment] = ACTIONS(5),
  },
  [1198] = {
    [sym_comment] = STATE(1198),
    [sym_decorator] = STATE(1202),
    [aux_sym_export_statement_repeat1] = STATE(1105),
    [sym_identifier] = ACTIONS(3640),
    [anon_sym_export] = ACTIONS(3640),
    [anon_sym_type] = ACTIONS(3640),
    [anon_sym_namespace] = ACTIONS(3640),
    [anon_sym_LBRACE] = ACTIONS(3642),
    [anon_sym_typeof] = ACTIONS(3640),
    [anon_sym_import] = ACTIONS(3640),
    [anon_sym_from] = ACTIONS(3640),
    [anon_sym_let] = ACTIONS(3640),
    [anon_sym_BANG] = ACTIONS(3642),
    [anon_sym_LPAREN] = ACTIONS(3642),
    [anon_sym_await] = ACTIONS(3640),
    [anon_sym_of] = ACTIONS(3640),
    [anon_sym_yield] = ACTIONS(3640),
    [anon_sym_LBRACK] = ACTIONS(3642),
    [anon_sym_LTtemplate_GT] = ACTIONS(3642),
    [anon_sym_DQUOTE] = ACTIONS(3642),
    [anon_sym_SQUOTE] = ACTIONS(3642),
    [anon_sym_class] = ACTIONS(3659),
    [anon_sym_async] = ACTIONS(3640),
    [anon_sym_function] = ACTIONS(3640),
    [anon_sym_new] = ACTIONS(3640),
    [anon_sym_using] = ACTIONS(3640),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3642),
    [anon_sym_PLUS] = ACTIONS(3640),
    [anon_sym_DASH] = ACTIONS(3640),
    [anon_sym_SLASH] = ACTIONS(3640),
    [anon_sym_LT] = ACTIONS(3640),
    [anon_sym_TILDE] = ACTIONS(3642),
    [anon_sym_void] = ACTIONS(3640),
    [anon_sym_delete] = ACTIONS(3640),
    [anon_sym_PLUS_PLUS] = ACTIONS(3642),
    [anon_sym_DASH_DASH] = ACTIONS(3642),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3642),
    [sym_number] = ACTIONS(3642),
    [sym_private_property_identifier] = ACTIONS(3642),
    [sym_this] = ACTIONS(3640),
    [sym_super] = ACTIONS(3640),
    [sym_true] = ACTIONS(3640),
    [sym_false] = ACTIONS(3640),
    [sym_null] = ACTIONS(3640),
    [sym_undefined] = ACTIONS(3640),
    [anon_sym_AT] = ACTIONS(3644),
    [anon_sym_static] = ACTIONS(3640),
    [anon_sym_readonly] = ACTIONS(3640),
    [anon_sym_get] = ACTIONS(3640),
    [anon_sym_set] = ACTIONS(3640),
    [anon_sym_declare] = ACTIONS(3640),
    [anon_sym_public] = ACTIONS(3640),
    [anon_sym_private] = ACTIONS(3640),
    [anon_sym_protected] = ACTIONS(3640),
    [anon_sym_override] = ACTIONS(3640),
    [anon_sym_module] = ACTIONS(3640),
    [anon_sym_any] = ACTIONS(3640),
    [anon_sym_number] = ACTIONS(3640),
    [anon_sym_boolean] = ACTIONS(3640),
    [anon_sym_string] = ACTIONS(3640),
    [anon_sym_symbol] = ACTIONS(3640),
    [anon_sym_object] = ACTIONS(3640),
    [anon_sym_property] = ACTIONS(3640),
    [anon_sym_signal] = ACTIONS(3640),
    [anon_sym_on] = ACTIONS(3640),
    [anon_sym_required] = ACTIONS(3640),
    [anon_sym_component] = ACTIONS(3640),
    [sym_html_comment] = ACTIONS(5),
  },
  [1199] = {
    [sym_nested_identifier] = STATE(6331),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1199),
    [sym_formal_parameters] = STATE(6257),
    [sym_nested_type_identifier] = STATE(3178),
    [sym__type] = STATE(4777),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5559),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_typeof] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_PIPE] = ACTIONS(716),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(1781),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(122),
    [anon_sym_infer] = ACTIONS(124),
    [anon_sym_keyof] = ACTIONS(126),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(132),
    [sym_html_comment] = ACTIONS(5),
  },
  [1200] = {
    [sym_nested_identifier] = STATE(6123),
    [sym_string] = STATE(3650),
    [sym_comment] = STATE(1200),
    [sym_formal_parameters] = STATE(6329),
    [sym_nested_type_identifier] = STATE(3475),
    [sym__type] = STATE(3561),
    [sym_constructor_type] = STATE(3735),
    [sym__primary_type] = STATE(3709),
    [sym_template_literal_type] = STATE(3706),
    [sym_infer_type] = STATE(3735),
    [sym_conditional_type] = STATE(3706),
    [sym_generic_type] = STATE(3706),
    [sym_type_query] = STATE(3706),
    [sym_index_type_query] = STATE(3706),
    [sym_lookup_type] = STATE(3706),
    [sym_literal_type] = STATE(3706),
    [sym__number] = STATE(3704),
    [sym_existential_type] = STATE(3706),
    [sym_flow_maybe_type] = STATE(3706),
    [sym_parenthesized_type] = STATE(3706),
    [sym_predefined_type] = STATE(3706),
    [sym_object_type] = STATE(3706),
    [sym_type_parameters] = STATE(5682),
    [sym_array_type] = STATE(3706),
    [sym_tuple_type] = STATE(3706),
    [sym_readonly_type] = STATE(3735),
    [sym_union_type] = STATE(3706),
    [sym_intersection_type] = STATE(3706),
    [sym_function_type] = STATE(3735),
    [sym_identifier] = ACTIONS(3634),
    [anon_sym_STAR] = ACTIONS(3313),
    [anon_sym_LBRACE] = ACTIONS(3315),
    [anon_sym_typeof] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_LPAREN] = ACTIONS(3321),
    [anon_sym_LBRACK] = ACTIONS(3323),
    [anon_sym_DQUOTE] = ACTIONS(3325),
    [anon_sym_SQUOTE] = ACTIONS(3327),
    [anon_sym_new] = ACTIONS(3329),
    [anon_sym_AMP] = ACTIONS(3331),
    [anon_sym_PIPE] = ACTIONS(3333),
    [anon_sym_PLUS] = ACTIONS(3335),
    [anon_sym_DASH] = ACTIONS(3335),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3337),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3339),
    [sym_number] = ACTIONS(3341),
    [sym_this] = ACTIONS(3636),
    [sym_true] = ACTIONS(3345),
    [sym_false] = ACTIONS(3345),
    [sym_null] = ACTIONS(3345),
    [sym_undefined] = ACTIONS(3345),
    [anon_sym_readonly] = ACTIONS(3347),
    [anon_sym_QMARK] = ACTIONS(3349),
    [anon_sym_any] = ACTIONS(3337),
    [anon_sym_number] = ACTIONS(3337),
    [anon_sym_boolean] = ACTIONS(3337),
    [anon_sym_string] = ACTIONS(3337),
    [anon_sym_symbol] = ACTIONS(3337),
    [anon_sym_object] = ACTIONS(3337),
    [anon_sym_abstract] = ACTIONS(3351),
    [anon_sym_infer] = ACTIONS(3355),
    [anon_sym_keyof] = ACTIONS(3357),
    [anon_sym_unique] = ACTIONS(3359),
    [anon_sym_unknown] = ACTIONS(3337),
    [anon_sym_never] = ACTIONS(3337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3361),
    [sym_html_comment] = ACTIONS(5),
  },
  [1201] = {
    [sym_nested_identifier] = STATE(6099),
    [sym_string] = STATE(3234),
    [sym_comment] = STATE(1201),
    [sym_formal_parameters] = STATE(6035),
    [sym_nested_type_identifier] = STATE(3747),
    [sym__type] = STATE(3279),
    [sym_constructor_type] = STATE(3212),
    [sym__primary_type] = STATE(3228),
    [sym_template_literal_type] = STATE(3215),
    [sym_infer_type] = STATE(3212),
    [sym_conditional_type] = STATE(3215),
    [sym_generic_type] = STATE(3215),
    [sym_type_query] = STATE(3215),
    [sym_index_type_query] = STATE(3215),
    [sym_lookup_type] = STATE(3215),
    [sym_literal_type] = STATE(3215),
    [sym__number] = STATE(3190),
    [sym_existential_type] = STATE(3215),
    [sym_flow_maybe_type] = STATE(3215),
    [sym_parenthesized_type] = STATE(3215),
    [sym_predefined_type] = STATE(3215),
    [sym_object_type] = STATE(3215),
    [sym_type_parameters] = STATE(5617),
    [sym_array_type] = STATE(3215),
    [sym_tuple_type] = STATE(3215),
    [sym_readonly_type] = STATE(3212),
    [sym_union_type] = STATE(3215),
    [sym_intersection_type] = STATE(3215),
    [sym_function_type] = STATE(3212),
    [sym_identifier] = ACTIONS(3638),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_typeof] = ACTIONS(3478),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1761),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_AMP] = ACTIONS(3482),
    [anon_sym_PIPE] = ACTIONS(3484),
    [anon_sym_PLUS] = ACTIONS(3195),
    [anon_sym_DASH] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(130),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_number] = ACTIONS(1775),
    [sym_this] = ACTIONS(1777),
    [sym_true] = ACTIONS(1779),
    [sym_false] = ACTIONS(1779),
    [sym_null] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_readonly] = ACTIONS(3488),
    [anon_sym_QMARK] = ACTIONS(3490),
    [anon_sym_any] = ACTIONS(130),
    [anon_sym_number] = ACTIONS(130),
    [anon_sym_boolean] = ACTIONS(130),
    [anon_sym_string] = ACTIONS(130),
    [anon_sym_symbol] = ACTIONS(130),
    [anon_sym_object] = ACTIONS(130),
    [anon_sym_abstract] = ACTIONS(3492),
    [anon_sym_infer] = ACTIONS(3496),
    [anon_sym_keyof] = ACTIONS(3498),
    [anon_sym_unique] = ACTIONS(128),
    [anon_sym_unknown] = ACTIONS(130),
    [anon_sym_never] = ACTIONS(130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3500),
    [sym_html_comment] = ACTIONS(5),
  },
  [1202] = {
    [sym_comment] = STATE(1202),
    [sym_identifier] = ACTIONS(3662),
    [anon_sym_export] = ACTIONS(3662),
    [anon_sym_type] = ACTIONS(3662),
    [anon_sym_namespace] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(3664),
    [anon_sym_typeof] = ACTIONS(3662),
    [anon_sym_import] = ACTIONS(3662),
    [anon_sym_from] = ACTIONS(3662),
    [anon_sym_let] = ACTIONS(3662),
    [anon_sym_BANG] = ACTIONS(3664),
    [anon_sym_LPAREN] = ACTIONS(3664),
    [anon_sym_await] = ACTIONS(3662),
    [anon_sym_of] = ACTIONS(3662),
    [anon_sym_yield] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3664),
    [anon_sym_LTtemplate_GT] = ACTIONS(3664),
    [anon_sym_DQUOTE] = ACTIONS(3664),
    [anon_sym_SQUOTE] = ACTIONS(3664),
    [anon_sym_class] = ACTIONS(3662),
    [anon_sym_async] = ACTIONS(3662),
    [anon_sym_function] = ACTIONS(3662),
    [anon_sym_new] = ACTIONS(3662),
    [anon_sym_using] = ACTIONS(3662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3664),
    [anon_sym_PLUS] = ACTIONS(3662),
    [anon_sym_DASH] = ACTIONS(3662),
    [anon_sym_SLASH] = ACTIONS(3662),
    [anon_sym_LT] = ACTIONS(3662),
    [anon_sym_TILDE] = ACTIONS(3664),
    [anon_sym_void] = ACTIONS(3662),
    [anon_sym_delete] = ACTIONS(3662),
    [anon_sym_PLUS_PLUS] = ACTIONS(3664),
    [anon_sym_DASH_DASH] = ACTIONS(3664),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3664),
    [sym_number] = ACTIONS(3664),
    [sym_private_property_identifier] = ACTIONS(3664),
    [sym_this] = ACTIONS(3662),
    [sym_super] = ACTIONS(3662),
    [sym_true] = ACTIONS(3662),
    [sym_false] = ACTIONS(3662),
    [sym_null] = ACTIONS(3662),
    [sym_undefined] = ACTIONS(3662),
    [anon_sym_AT] = ACTIONS(3664),
    [anon_sym_static] = ACTIONS(3662),
    [anon_sym_readonly] = ACTIONS(3662),
    [anon_sym_get] = ACTIONS(3662),
    [anon_sym_set] = ACTIONS(3662),
    [anon_sym_declare] = ACTIONS(3662),
    [anon_sym_public] = ACTIONS(3662),
    [anon_sym_private] = ACTIONS(3662),
    [anon_sym_protected] = ACTIONS(3662),
    [anon_sym_override] = ACTIONS(3662),
    [anon_sym_module] = ACTIONS(3662),
    [anon_sym_any] = ACTIONS(3662),
    [anon_sym_number] = ACTIONS(3662),
    [anon_sym_boolean] = ACTIONS(3662),
    [anon_sym_string] = ACTIONS(3662),
    [anon_sym_symbol] = ACTIONS(3662),
    [anon_sym_object] = ACTIONS(3662),
    [anon_sym_property] = ACTIONS(3662),
    [anon_sym_signal] = ACTIONS(3662),
    [anon_sym_on] = ACTIONS(3662),
    [anon_sym_required] = ACTIONS(3662),
    [anon_sym_component] = ACTIONS(3662),
    [anon_sym_abstract] = ACTIONS(3662),
    [sym_html_comment] = ACTIONS(5),
  },
  [1203] = {
    [sym_nested_identifier] = STATE(1868),
    [sym_string] = STATE(1867),
    [sym_comment] = STATE(1203),
    [sym__module] = STATE(1996),
    [sym_identifier] = ACTIONS(3666),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_EQ] = ACTIONS(134),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_RBRACE] = ACTIONS(137),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(70),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_COLON] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_RBRACK] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_QMARK] = ACTIONS(823),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [1204] = {
    [sym_nested_identifier] = STATE(1868),
    [sym_string] = STATE(1867),
    [sym_comment] = STATE(1204),
    [sym__module] = STATE(1996),
    [sym_identifier] = ACTIONS(3666),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_EQ] = ACTIONS(863),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_COMMA] = ACTIONS(867),
    [anon_sym_RBRACE] = ACTIONS(867),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(70),
    [anon_sym_RPAREN] = ACTIONS(867),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_COLON] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_RBRACK] = ACTIONS(867),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_EQ_GT] = ACTIONS(139),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_QMARK] = ACTIONS(875),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [1205] = {
    [sym_comment] = STATE(1205),
    [sym_identifier] = ACTIONS(3668),
    [anon_sym_export] = ACTIONS(3668),
    [anon_sym_type] = ACTIONS(3668),
    [anon_sym_namespace] = ACTIONS(3668),
    [anon_sym_LBRACE] = ACTIONS(3670),
    [anon_sym_typeof] = ACTIONS(3668),
    [anon_sym_import] = ACTIONS(3668),
    [anon_sym_from] = ACTIONS(3668),
    [anon_sym_let] = ACTIONS(3668),
    [anon_sym_BANG] = ACTIONS(3670),
    [anon_sym_LPAREN] = ACTIONS(3670),
    [anon_sym_await] = ACTIONS(3668),
    [anon_sym_of] = ACTIONS(3668),
    [anon_sym_yield] = ACTIONS(3668),
    [anon_sym_LBRACK] = ACTIONS(3670),
    [anon_sym_LTtemplate_GT] = ACTIONS(3670),
    [anon_sym_DOT] = ACTIONS(3668),
    [anon_sym_DQUOTE] = ACTIONS(3670),
    [anon_sym_SQUOTE] = ACTIONS(3670),
    [anon_sym_class] = ACTIONS(3668),
    [anon_sym_async] = ACTIONS(3668),
    [anon_sym_function] = ACTIONS(3668),
    [anon_sym_new] = ACTIONS(3668),
    [anon_sym_using] = ACTIONS(3668),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3670),
    [anon_sym_PLUS] = ACTIONS(3668),
    [anon_sym_DASH] = ACTIONS(3668),
    [anon_sym_SLASH] = ACTIONS(3668),
    [anon_sym_LT] = ACTIONS(3668),
    [anon_sym_TILDE] = ACTIONS(3670),
    [anon_sym_void] = ACTIONS(3668),
    [anon_sym_delete] = ACTIONS(3668),
    [anon_sym_PLUS_PLUS] = ACTIONS(3670),
    [anon_sym_DASH_DASH] = ACTIONS(3670),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3670),
    [sym_number] = ACTIONS(3670),
    [sym_private_property_identifier] = ACTIONS(3670),
    [sym_this] = ACTIONS(3668),
    [sym_super] = ACTIONS(3668),
    [sym_true] = ACTIONS(3668),
    [sym_false] = ACTIONS(3668),
    [sym_null] = ACTIONS(3668),
    [sym_undefined] = ACTIONS(3668),
    [anon_sym_AT] = ACTIONS(3670),
    [anon_sym_static] = ACTIONS(3668),
    [anon_sym_readonly] = ACTIONS(3668),
    [anon_sym_get] = ACTIONS(3668),
    [anon_sym_set] = ACTIONS(3668),
    [anon_sym_declare] = ACTIONS(3668),
    [anon_sym_public] = ACTIONS(3668),
    [anon_sym_private] = ACTIONS(3668),
    [anon_sym_protected] = ACTIONS(3668),
    [anon_sym_override] = ACTIONS(3668),
    [anon_sym_module] = ACTIONS(3668),
    [anon_sym_any] = ACTIONS(3668),
    [anon_sym_number] = ACTIONS(3668),
    [anon_sym_boolean] = ACTIONS(3668),
    [anon_sym_string] = ACTIONS(3668),
    [anon_sym_symbol] = ACTIONS(3668),
    [anon_sym_object] = ACTIONS(3668),
    [anon_sym_property] = ACTIONS(3668),
    [anon_sym_signal] = ACTIONS(3668),
    [anon_sym_on] = ACTIONS(3668),
    [anon_sym_required] = ACTIONS(3668),
    [anon_sym_component] = ACTIONS(3668),
    [sym_html_comment] = ACTIONS(5),
  },
  [1206] = {
    [sym_nested_identifier] = STATE(1868),
    [sym_string] = STATE(1867),
    [sym_comment] = STATE(1206),
    [sym__module] = STATE(1996),
    [sym_identifier] = ACTIONS(3666),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_EQ] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_COMMA] = ACTIONS(36),
    [anon_sym_RBRACE] = ACTIONS(36),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(70),
    [anon_sym_RPAREN] = ACTIONS(36),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_COLON] = ACTIONS(36),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_RBRACK] = ACTIONS(36),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_EQ_GT] = ACTIONS(68),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_QMARK] = ACTIONS(823),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [1207] = {
    [sym_comment] = STATE(1207),
    [sym_identifier] = ACTIONS(3672),
    [anon_sym_export] = ACTIONS(3672),
    [anon_sym_type] = ACTIONS(3672),
    [anon_sym_namespace] = ACTIONS(3672),
    [anon_sym_LBRACE] = ACTIONS(3674),
    [anon_sym_typeof] = ACTIONS(3672),
    [anon_sym_import] = ACTIONS(3672),
    [anon_sym_from] = ACTIONS(3672),
    [anon_sym_let] = ACTIONS(3672),
    [anon_sym_BANG] = ACTIONS(3674),
    [anon_sym_LPAREN] = ACTIONS(3674),
    [anon_sym_await] = ACTIONS(3672),
    [anon_sym_of] = ACTIONS(3672),
    [anon_sym_yield] = ACTIONS(3672),
    [anon_sym_LBRACK] = ACTIONS(3674),
    [anon_sym_LTtemplate_GT] = ACTIONS(3674),
    [anon_sym_DQUOTE] = ACTIONS(3674),
    [anon_sym_SQUOTE] = ACTIONS(3674),
    [anon_sym_class] = ACTIONS(3672),
    [anon_sym_async] = ACTIONS(3672),
    [anon_sym_function] = ACTIONS(3672),
    [anon_sym_new] = ACTIONS(3672),
    [anon_sym_using] = ACTIONS(3672),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3674),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_DASH] = ACTIONS(3672),
    [anon_sym_SLASH] = ACTIONS(3672),
    [anon_sym_LT] = ACTIONS(3672),
    [anon_sym_TILDE] = ACTIONS(3674),
    [anon_sym_void] = ACTIONS(3672),
    [anon_sym_delete] = ACTIONS(3672),
    [anon_sym_PLUS_PLUS] = ACTIONS(3674),
    [anon_sym_DASH_DASH] = ACTIONS(3674),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3674),
    [sym_number] = ACTIONS(3674),
    [sym_private_property_identifier] = ACTIONS(3674),
    [sym_this] = ACTIONS(3672),
    [sym_super] = ACTIONS(3672),
    [sym_true] = ACTIONS(3672),
    [sym_false] = ACTIONS(3672),
    [sym_null] = ACTIONS(3672),
    [sym_undefined] = ACTIONS(3672),
    [anon_sym_AT] = ACTIONS(3674),
    [anon_sym_static] = ACTIONS(3672),
    [anon_sym_readonly] = ACTIONS(3672),
    [anon_sym_get] = ACTIONS(3672),
    [anon_sym_set] = ACTIONS(3672),
    [anon_sym_declare] = ACTIONS(3672),
    [anon_sym_public] = ACTIONS(3672),
    [anon_sym_private] = ACTIONS(3672),
    [anon_sym_protected] = ACTIONS(3672),
    [anon_sym_override] = ACTIONS(3672),
    [anon_sym_module] = ACTIONS(3672),
    [anon_sym_any] = ACTIONS(3672),
    [anon_sym_number] = ACTIONS(3672),
    [anon_sym_boolean] = ACTIONS(3672),
    [anon_sym_string] = ACTIONS(3672),
    [anon_sym_symbol] = ACTIONS(3672),
    [anon_sym_object] = ACTIONS(3672),
    [anon_sym_property] = ACTIONS(3672),
    [anon_sym_signal] = ACTIONS(3672),
    [anon_sym_on] = ACTIONS(3672),
    [anon_sym_required] = ACTIONS(3672),
    [anon_sym_component] = ACTIONS(3672),
    [anon_sym_abstract] = ACTIONS(3672),
    [sym_html_comment] = ACTIONS(5),
  },
  [1208] = {
    [sym_comment] = STATE(1208),
    [sym_identifier] = ACTIONS(3649),
    [anon_sym_export] = ACTIONS(3649),
    [anon_sym_type] = ACTIONS(3649),
    [anon_sym_namespace] = ACTIONS(3649),
    [anon_sym_LBRACE] = ACTIONS(3651),
    [anon_sym_typeof] = ACTIONS(3649),
    [anon_sym_import] = ACTIONS(3649),
    [anon_sym_from] = ACTIONS(3649),
    [anon_sym_let] = ACTIONS(3649),
    [anon_sym_BANG] = ACTIONS(3651),
    [anon_sym_LPAREN] = ACTIONS(3651),
    [anon_sym_await] = ACTIONS(3649),
    [anon_sym_of] = ACTIONS(3649),
    [anon_sym_yield] = ACTIONS(3649),
    [anon_sym_LBRACK] = ACTIONS(3651),
    [anon_sym_LTtemplate_GT] = ACTIONS(3651),
    [anon_sym_DQUOTE] = ACTIONS(3651),
    [anon_sym_SQUOTE] = ACTIONS(3651),
    [anon_sym_class] = ACTIONS(3649),
    [anon_sym_async] = ACTIONS(3649),
    [anon_sym_function] = ACTIONS(3649),
    [anon_sym_new] = ACTIONS(3649),
    [anon_sym_using] = ACTIONS(3649),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3651),
    [anon_sym_PLUS] = ACTIONS(3649),
    [anon_sym_DASH] = ACTIONS(3649),
    [anon_sym_SLASH] = ACTIONS(3649),
    [anon_sym_LT] = ACTIONS(3649),
    [anon_sym_TILDE] = ACTIONS(3651),
    [anon_sym_void] = ACTIONS(3649),
    [anon_sym_delete] = ACTIONS(3649),
    [anon_sym_PLUS_PLUS] = ACTIONS(3651),
    [anon_sym_DASH_DASH] = ACTIONS(3651),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3651),
    [sym_number] = ACTIONS(3651),
    [sym_private_property_identifier] = ACTIONS(3651),
    [sym_this] = ACTIONS(3649),
    [sym_super] = ACTIONS(3649),
    [sym_true] = ACTIONS(3649),
    [sym_false] = ACTIONS(3649),
    [sym_null] = ACTIONS(3649),
    [sym_undefined] = ACTIONS(3649),
    [anon_sym_AT] = ACTIONS(3651),
    [anon_sym_static] = ACTIONS(3649),
    [anon_sym_readonly] = ACTIONS(3649),
    [anon_sym_get] = ACTIONS(3649),
    [anon_sym_set] = ACTIONS(3649),
    [anon_sym_declare] = ACTIONS(3649),
    [anon_sym_public] = ACTIONS(3649),
    [anon_sym_private] = ACTIONS(3649),
    [anon_sym_protected] = ACTIONS(3649),
    [anon_sym_override] = ACTIONS(3649),
    [anon_sym_module] = ACTIONS(3649),
    [anon_sym_any] = ACTIONS(3649),
    [anon_sym_number] = ACTIONS(3649),
    [anon_sym_boolean] = ACTIONS(3649),
    [anon_sym_string] = ACTIONS(3649),
    [anon_sym_symbol] = ACTIONS(3649),
    [anon_sym_object] = ACTIONS(3649),
    [anon_sym_property] = ACTIONS(3649),
    [anon_sym_signal] = ACTIONS(3649),
    [anon_sym_on] = ACTIONS(3649),
    [anon_sym_required] = ACTIONS(3649),
    [anon_sym_component] = ACTIONS(3649),
    [anon_sym_abstract] = ACTIONS(3649),
    [sym_html_comment] = ACTIONS(5),
  },
  [1209] = {
    [sym_nested_identifier] = STATE(1738),
    [sym_string] = STATE(1734),
    [sym_comment] = STATE(1209),
    [sym__module] = STATE(2070),
    [sym_ui_object_initializer] = STATE(5893),
    [sym_identifier] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_LBRACE] = ACTIONS(2491),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(70),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(2486),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [1210] = {
    [sym_nested_identifier] = STATE(1868),
    [sym_string] = STATE(1867),
    [sym_comment] = STATE(1210),
    [sym__module] = STATE(1996),
    [sym_identifier] = ACTIONS(3666),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_EQ] = ACTIONS(877),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(70),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(70),
    [anon_sym_RPAREN] = ACTIONS(70),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_COLON] = ACTIONS(70),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_RBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_EQ_GT] = ACTIONS(68),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [1211] = {
    [sym_nested_identifier] = STATE(1738),
    [sym_string] = STATE(1734),
    [sym_comment] = STATE(1211),
    [sym__module] = STATE(2070),
    [sym_ui_object_initializer] = STATE(2802),
    [sym_identifier] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_LBRACE] = ACTIONS(2484),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(70),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(2486),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [1212] = {
    [sym_comment] = STATE(1212),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_export] = ACTIONS(3678),
    [anon_sym_type] = ACTIONS(3678),
    [anon_sym_namespace] = ACTIONS(3678),
    [anon_sym_LBRACE] = ACTIONS(3680),
    [anon_sym_typeof] = ACTIONS(3678),
    [anon_sym_import] = ACTIONS(3678),
    [anon_sym_from] = ACTIONS(3678),
    [anon_sym_let] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3680),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_await] = ACTIONS(3678),
    [anon_sym_of] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3678),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_LTtemplate_GT] = ACTIONS(3680),
    [anon_sym_DQUOTE] = ACTIONS(3680),
    [anon_sym_SQUOTE] = ACTIONS(3680),
    [anon_sym_class] = ACTIONS(3678),
    [anon_sym_async] = ACTIONS(3678),
    [anon_sym_function] = ACTIONS(3678),
    [anon_sym_new] = ACTIONS(3678),
    [anon_sym_using] = ACTIONS(3678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3678),
    [anon_sym_DASH] = ACTIONS(3678),
    [anon_sym_SLASH] = ACTIONS(3678),
    [anon_sym_LT] = ACTIONS(3678),
    [anon_sym_TILDE] = ACTIONS(3680),
    [anon_sym_void] = ACTIONS(3678),
    [anon_sym_delete] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3680),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3680),
    [sym_number] = ACTIONS(3680),
    [sym_private_property_identifier] = ACTIONS(3680),
    [sym_this] = ACTIONS(3678),
    [sym_super] = ACTIONS(3678),
    [sym_true] = ACTIONS(3678),
    [sym_false] = ACTIONS(3678),
    [sym_null] = ACTIONS(3678),
    [sym_undefined] = ACTIONS(3678),
    [anon_sym_AT] = ACTIONS(3680),
    [anon_sym_static] = ACTIONS(3678),
    [anon_sym_readonly] = ACTIONS(3678),
    [anon_sym_get] = ACTIONS(3678),
    [anon_sym_set] = ACTIONS(3678),
    [anon_sym_declare] = ACTIONS(3678),
    [anon_sym_public] = ACTIONS(3678),
    [anon_sym_private] = ACTIONS(3678),
    [anon_sym_protected] = ACTIONS(3678),
    [anon_sym_override] = ACTIONS(3678),
    [anon_sym_module] = ACTIONS(3678),
    [anon_sym_any] = ACTIONS(3678),
    [anon_sym_number] = ACTIONS(3678),
    [anon_sym_boolean] = ACTIONS(3678),
    [anon_sym_string] = ACTIONS(3678),
    [anon_sym_symbol] = ACTIONS(3678),
    [anon_sym_object] = ACTIONS(3678),
    [anon_sym_property] = ACTIONS(3678),
    [anon_sym_signal] = ACTIONS(3678),
    [anon_sym_on] = ACTIONS(3678),
    [anon_sym_required] = ACTIONS(3678),
    [anon_sym_component] = ACTIONS(3678),
    [sym_html_comment] = ACTIONS(5),
  },
  [1213] = {
    [sym_comment] = STATE(1213),
    [sym_identifier] = ACTIONS(3682),
    [anon_sym_export] = ACTIONS(3682),
    [anon_sym_type] = ACTIONS(3682),
    [anon_sym_namespace] = ACTIONS(3682),
    [anon_sym_LBRACE] = ACTIONS(3684),
    [anon_sym_typeof] = ACTIONS(3682),
    [anon_sym_import] = ACTIONS(3682),
    [anon_sym_from] = ACTIONS(3682),
    [anon_sym_let] = ACTIONS(3682),
    [anon_sym_BANG] = ACTIONS(3684),
    [anon_sym_LPAREN] = ACTIONS(3684),
    [anon_sym_await] = ACTIONS(3682),
    [anon_sym_of] = ACTIONS(3682),
    [anon_sym_yield] = ACTIONS(3682),
    [anon_sym_LBRACK] = ACTIONS(3684),
    [anon_sym_LTtemplate_GT] = ACTIONS(3684),
    [anon_sym_DQUOTE] = ACTIONS(3684),
    [anon_sym_SQUOTE] = ACTIONS(3684),
    [anon_sym_class] = ACTIONS(3682),
    [anon_sym_async] = ACTIONS(3682),
    [anon_sym_function] = ACTIONS(3682),
    [anon_sym_new] = ACTIONS(3682),
    [anon_sym_using] = ACTIONS(3682),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3684),
    [anon_sym_PLUS] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3682),
    [anon_sym_SLASH] = ACTIONS(3682),
    [anon_sym_LT] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3684),
    [anon_sym_void] = ACTIONS(3682),
    [anon_sym_delete] = ACTIONS(3682),
    [anon_sym_PLUS_PLUS] = ACTIONS(3684),
    [anon_sym_DASH_DASH] = ACTIONS(3684),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3684),
    [sym_number] = ACTIONS(3684),
    [sym_private_property_identifier] = ACTIONS(3684),
    [sym_this] = ACTIONS(3682),
    [sym_super] = ACTIONS(3682),
    [sym_true] = ACTIONS(3682),
    [sym_false] = ACTIONS(3682),
    [sym_null] = ACTIONS(3682),
    [sym_undefined] = ACTIONS(3682),
    [anon_sym_AT] = ACTIONS(3684),
    [anon_sym_static] = ACTIONS(3682),
    [anon_sym_readonly] = ACTIONS(3682),
    [anon_sym_get] = ACTIONS(3682),
    [anon_sym_set] = ACTIONS(3682),
    [anon_sym_declare] = ACTIONS(3682),
    [anon_sym_public] = ACTIONS(3682),
    [anon_sym_private] = ACTIONS(3682),
    [anon_sym_protected] = ACTIONS(3682),
    [anon_sym_override] = ACTIONS(3682),
    [anon_sym_module] = ACTIONS(3682),
    [anon_sym_any] = ACTIONS(3682),
    [anon_sym_number] = ACTIONS(3682),
    [anon_sym_boolean] = ACTIONS(3682),
    [anon_sym_string] = ACTIONS(3682),
    [anon_sym_symbol] = ACTIONS(3682),
    [anon_sym_object] = ACTIONS(3682),
    [anon_sym_property] = ACTIONS(3682),
    [anon_sym_signal] = ACTIONS(3682),
    [anon_sym_on] = ACTIONS(3682),
    [anon_sym_required] = ACTIONS(3682),
    [anon_sym_component] = ACTIONS(3682),
    [sym_html_comment] = ACTIONS(5),
  },
  [1214] = {
    [sym_nested_identifier] = STATE(1868),
    [sym_string] = STATE(1867),
    [sym_comment] = STATE(1214),
    [sym__module] = STATE(1996),
    [sym_identifier] = ACTIONS(3666),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_EQ] = ACTIONS(863),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(70),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(70),
    [anon_sym_RPAREN] = ACTIONS(70),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_COLON] = ACTIONS(70),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_RBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_EQ_GT] = ACTIONS(68),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [1215] = {
    [sym_comment] = STATE(1215),
    [sym_identifier] = ACTIONS(3686),
    [anon_sym_export] = ACTIONS(3686),
    [anon_sym_type] = ACTIONS(3686),
    [anon_sym_namespace] = ACTIONS(3686),
    [anon_sym_LBRACE] = ACTIONS(3688),
    [anon_sym_typeof] = ACTIONS(3686),
    [anon_sym_import] = ACTIONS(3686),
    [anon_sym_from] = ACTIONS(3686),
    [anon_sym_let] = ACTIONS(3686),
    [anon_sym_BANG] = ACTIONS(3688),
    [anon_sym_LPAREN] = ACTIONS(3688),
    [anon_sym_await] = ACTIONS(3686),
    [anon_sym_of] = ACTIONS(3686),
    [anon_sym_yield] = ACTIONS(3686),
    [anon_sym_LBRACK] = ACTIONS(3688),
    [anon_sym_LTtemplate_GT] = ACTIONS(3688),
    [anon_sym_DQUOTE] = ACTIONS(3688),
    [anon_sym_SQUOTE] = ACTIONS(3688),
    [anon_sym_class] = ACTIONS(3686),
    [anon_sym_async] = ACTIONS(3686),
    [anon_sym_function] = ACTIONS(3686),
    [anon_sym_new] = ACTIONS(3686),
    [anon_sym_using] = ACTIONS(3686),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3688),
    [anon_sym_PLUS] = ACTIONS(3686),
    [anon_sym_DASH] = ACTIONS(3686),
    [anon_sym_SLASH] = ACTIONS(3686),
    [anon_sym_LT] = ACTIONS(3686),
    [anon_sym_TILDE] = ACTIONS(3688),
    [anon_sym_void] = ACTIONS(3686),
    [anon_sym_delete] = ACTIONS(3686),
    [anon_sym_PLUS_PLUS] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(3688),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(3688),
    [sym_number] = ACTIONS(3688),
    [sym_private_property_identifier] = ACTIONS(3688),
    [sym_this] = ACTIONS(3686),
    [sym_super] = ACTIONS(3686),
    [sym_true] = ACTIONS(3686),
    [sym_false] = ACTIONS(3686),
    [sym_null] = ACTIONS(3686),
    [sym_undefined] = ACTIONS(3686),
    [anon_sym_AT] = ACTIONS(3688),
    [anon_sym_static] = ACTIONS(3686),
    [anon_sym_readonly] = ACTIONS(3686),
    [anon_sym_get] = ACTIONS(3686),
    [anon_sym_set] = ACTIONS(3686),
    [anon_sym_declare] = ACTIONS(3686),
    [anon_sym_public] = ACTIONS(3686),
    [anon_sym_private] = ACTIONS(3686),
    [anon_sym_protected] = ACTIONS(3686),
    [anon_sym_override] = ACTIONS(3686),
    [anon_sym_module] = ACTIONS(3686),
    [anon_sym_any] = ACTIONS(3686),
    [anon_sym_number] = ACTIONS(3686),
    [anon_sym_boolean] = ACTIONS(3686),
    [anon_sym_string] = ACTIONS(3686),
    [anon_sym_symbol] = ACTIONS(3686),
    [anon_sym_object] = ACTIONS(3686),
    [anon_sym_property] = ACTIONS(3686),
    [anon_sym_signal] = ACTIONS(3686),
    [anon_sym_on] = ACTIONS(3686),
    [anon_sym_required] = ACTIONS(3686),
    [anon_sym_component] = ACTIONS(3686),
    [sym_html_comment] = ACTIONS(5),
  },
  [1216] = {
    [sym_variable_declarator] = STATE(4750),
    [sym_object_pattern] = STATE(3973),
    [sym_array_pattern] = STATE(3973),
    [sym__destructuring_pattern] = STATE(3707),
    [sym_comment] = STATE(1216),
    [sym_identifier] = ACTIONS(3690),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_LBRACE] = ACTIONS(3602),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(70),
    [anon_sym_in] = ACTIONS(984),
    [anon_sym_of] = ACTIONS(3692),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [1217] = {
    [sym_variable_declarator] = STATE(4861),
    [sym_object_pattern] = STATE(3973),
    [sym_array_pattern] = STATE(3973),
    [sym__destructuring_pattern] = STATE(3972),
    [sym_comment] = STATE(1217),
    [sym_identifier] = ACTIONS(3600),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_LBRACE] = ACTIONS(3602),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(70),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [1218] = {
    [sym_nested_identifier] = STATE(2781),
    [sym_string] = STATE(2835),
    [sym_comment] = STATE(1218),
    [sym__module] = STATE(2996),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(70),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_DQUOTE] = ACTIONS(3696),
    [anon_sym_SQUOTE] = ACTIONS(3698),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [1219] = {
    [sym_nested_identifier] = STATE(1738),
    [sym_string] = STATE(1734),
    [sym_comment] = STATE(1219),
    [sym__module] = STATE(2070),
    [sym_identifier] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(70),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [1220] = {
    [sym_nested_identifier] = STATE(226),
    [sym_string] = STATE(227),
    [sym_comment] = STATE(1220),
    [sym__module] = STATE(229),
    [sym_identifier] = ACTIONS(3614),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(70),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(913),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_DQUOTE] = ACTIONS(3616),
    [anon_sym_SQUOTE] = ACTIONS(3618),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [1221] = {
    [sym_nested_identifier] = STATE(1738),
    [sym_string] = STATE(1734),
    [sym_comment] = STATE(1221),
    [sym__module] = STATE(2070),
    [sym_identifier] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(70),
    [anon_sym_in] = ACTIONS(984),
    [anon_sym_of] = ACTIONS(3692),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [1222] = {
    [sym_variable_declarator] = STATE(4750),
    [sym_object_pattern] = STATE(3973),
    [sym_array_pattern] = STATE(3973),
    [sym__destructuring_pattern] = STATE(3972),
    [sym_comment] = STATE(1222),
    [sym_identifier] = ACTIONS(3600),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_LBRACE] = ACTIONS(3602),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(70),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [1223] = {
    [sym_variable_declarator] = STATE(4750),
    [sym_object_pattern] = STATE(3973),
    [sym_array_pattern] = STATE(3973),
    [sym__destructuring_pattern] = STATE(3972),
    [sym_comment] = STATE(1223),
    [sym_identifier] = ACTIONS(3600),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_LBRACE] = ACTIONS(3602),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(70),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(913),
    [anon_sym_LBRACK] = ACTIONS(3604),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [1224] = {
    [sym_nested_identifier] = STATE(755),
    [sym_string] = STATE(760),
    [sym_comment] = STATE(1224),
    [sym__module] = STATE(818),
    [sym_identifier] = ACTIONS(3608),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(70),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(913),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_DQUOTE] = ACTIONS(3610),
    [anon_sym_SQUOTE] = ACTIONS(3612),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [1225] = {
    [sym_nested_identifier] = STATE(921),
    [sym_string] = STATE(919),
    [sym_comment] = STATE(1225),
    [sym__module] = STATE(927),
    [sym_identifier] = ACTIONS(3700),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(70),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_DQUOTE] = ACTIONS(3702),
    [anon_sym_SQUOTE] = ACTIONS(3704),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [1226] = {
    [sym_nested_identifier] = STATE(4359),
    [sym_string] = STATE(4682),
    [sym_comment] = STATE(1226),
    [sym__module] = STATE(818),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(70),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_DQUOTE] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [1227] = {
    [sym_nested_identifier] = STATE(1868),
    [sym_string] = STATE(1867),
    [sym_comment] = STATE(1227),
    [sym__module] = STATE(1996),
    [sym_identifier] = ACTIONS(3666),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_EQ] = ACTIONS(877),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_COMMA] = ACTIONS(964),
    [anon_sym_RBRACE] = ACTIONS(964),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(70),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_COLON] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_RBRACK] = ACTIONS(964),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_EQ_GT] = ACTIONS(68),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [1228] = {
    [sym_nested_identifier] = STATE(1868),
    [sym_string] = STATE(1867),
    [sym_comment] = STATE(1228),
    [sym__module] = STATE(1996),
    [sym_ui_object_initializer] = STATE(2802),
    [sym_identifier] = ACTIONS(3666),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_EQ] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_LBRACE] = ACTIONS(2484),
    [anon_sym_COMMA] = ACTIONS(36),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(70),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_RBRACK] = ACTIONS(36),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(2486),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_EQ_GT] = ACTIONS(68),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [1229] = {
    [sym_nested_identifier] = STATE(1868),
    [sym_string] = STATE(1867),
    [sym_comment] = STATE(1229),
    [sym__module] = STATE(1996),
    [sym_identifier] = ACTIONS(3666),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_EQ] = ACTIONS(863),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(70),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_EQ_GT] = ACTIONS(958),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [1230] = {
    [sym_nested_identifier] = STATE(1868),
    [sym_string] = STATE(1867),
    [sym_comment] = STATE(1230),
    [sym__module] = STATE(1996),
    [sym_identifier] = ACTIONS(3666),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_EQ] = ACTIONS(863),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(70),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(70),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [1231] = {
    [sym_nested_identifier] = STATE(1738),
    [sym_string] = STATE(1734),
    [sym_comment] = STATE(1231),
    [sym__module] = STATE(2070),
    [sym_identifier] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(70),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(70),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [1232] = {
    [sym_nested_identifier] = STATE(1738),
    [sym_string] = STATE(1734),
    [sym_comment] = STATE(1232),
    [sym__module] = STATE(2070),
    [sym_identifier] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_EQ] = ACTIONS(952),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(70),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_of] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [anon_sym_EQ_GT] = ACTIONS(958),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [1233] = {
    [sym_nested_identifier] = STATE(1868),
    [sym_string] = STATE(1867),
    [sym_comment] = STATE(1233),
    [sym__module] = STATE(1996),
    [sym_identifier] = ACTIONS(3666),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_EQ] = ACTIONS(863),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_LBRACE] = ACTIONS(70),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(70),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_EQ_GT] = ACTIONS(1003),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_satisfies] = ACTIONS(30),
    [anon_sym_implements] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [1234] = {
    [sym_nested_identifier] = STATE(1868),
    [sym_string] = STATE(1867),
    [sym_comment] = STATE(1234),
    [sym__module] = STATE(1996),
    [sym_identifier] = ACTIONS(3666),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_EQ] = ACTIONS(971),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(70),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_COLON] = ACTIONS(976),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_RBRACK] = ACTIONS(36),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_EQ_GT] = ACTIONS(980),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [1235] = {
    [sym_export_statement] = STATE(4085),
    [sym__call_signature] = STATE(4331),
    [sym_string] = STATE(3505),
    [sym_comment] = STATE(1235),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(3540),
    [sym__property_name] = STATE(3359),
    [sym_computed_property_name] = STATE(3505),
    [sym_method_signature] = STATE(4085),
    [sym_accessibility_modifier] = STATE(2685),
    [sym_override_modifier] = STATE(2769),
    [sym_call_signature] = STATE(4085),
    [sym_property_signature] = STATE(4085),
    [sym_type_parameters] = STATE(5867),
    [sym_construct_signature] = STATE(4085),
    [sym_index_signature] = STATE(4085),
    [aux_sym_export_statement_repeat1] = STATE(4766),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_export] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_type] = ACTIONS(3708),
    [anon_sym_namespace] = ACTIONS(3708),
    [anon_sym_COMMA] = ACTIONS(3714),
    [anon_sym_RBRACE] = ACTIONS(3716),
    [anon_sym_from] = ACTIONS(3708),
    [anon_sym_let] = ACTIONS(3708),
    [anon_sym_LPAREN] = ACTIONS(3061),
    [anon_sym_of] = ACTIONS(3708),
    [anon_sym_SEMI] = ACTIONS(3714),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_async] = ACTIONS(3720),
    [anon_sym_new] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_LT] = ACTIONS(3073),
    [aux_sym_comment_token1] = ACTIONS(15),
    [sym_number] = ACTIONS(3075),
    [sym_private_property_identifier] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(3724),
    [anon_sym_readonly] = ACTIONS(3726),
    [anon_sym_get] = ACTIONS(3728),
    [anon_sym_set] = ACTIONS(3728),
    [anon_sym_declare] = ACTIONS(3708),
    [anon_sym_public] = ACTIONS(3730),
    [anon_sym_private] = ACTIONS(3730),
    [anon_sym_protected] = ACTIONS(3730),
    [anon_sym_override] = ACTIONS(3732),
    [anon_sym_module] = ACTIONS(3708),
    [anon_sym_any] = ACTIONS(3708),
    [anon_sym_number] = ACTIONS(3708),
    [anon_sym_boolean] = ACTIONS(3708),
    [anon_sym_string] = ACTIONS(3708),
    [anon_sym_symbol] = ACTIONS(3708),
    [anon_sym_object] = ACTIONS(3708),
    [anon_sym_property] = ACTIONS(3708),
    [anon_sym_signal] = ACTIONS(3708),
    [anon_sym_on] = ACTIONS(3708),
    [anon_sym_required] = ACTIONS(3708),
    [anon_sym_component] = ACTIONS(3708),
    [anon_sym_abstract] = ACTIONS(3087),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3716),
    [sym_html_comment] = ACTIONS(5),
  },
  [1236] = {
    [sym_comment] = STATE(1236),
    [aux_sym_object_repeat1] = STATE(4915),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [1237] = {
    [sym_export_statement] = STATE(4021),
    [sym__call_signature] = STATE(4331),
    [sym_string] = STATE(3505),
    [sym_comment] = STATE(1237),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(3540),
    [sym__property_name] = STATE(3359),
    [sym_computed_property_name] = STATE(3505),
    [sym_method_signature] = STATE(4021),
    [sym_accessibility_modifier] = STATE(2685),
    [sym_override_modifier] = STATE(2769),
    [sym_call_signature] = STATE(4021),
    [sym_property_signature] = STATE(4021),
    [sym_type_parameters] = STATE(5867),
    [sym_construct_signature] = STATE(4021),
    [sym_index_signature] = STATE(4021),
    [aux_sym_export_statement_repeat1] = STATE(4766),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_export] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_type] = ACTIONS(3708),
    [anon_sym_namespace] = ACTIONS(3708),
    [anon_sym_COMMA] = ACTIONS(3736),
    [anon_sym_RBRACE] = ACTIONS(3738),
    [anon_sym_from] = ACTIONS(3708),
    [anon_sym_let] = ACTIONS(3708),
    [anon_sym_LPAREN] = ACTIONS(3061),
    [anon_sym_of] = ACTIONS(3708),
    [anon_sym_SEMI] = ACTIONS(3736),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_async] = ACTIONS(3720),
    [anon_sym_new] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_LT] = ACTIONS(3073),
    [aux_sym_comment_token1] = ACTIONS(15),
    [sym_number] = ACTIONS(3075),
    [sym_private_property_identifier] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(3724),
    [anon_sym_readonly] = ACTIONS(3726),
    [anon_sym_get] = ACTIONS(3728),
    [anon_sym_set] = ACTIONS(3728),
    [anon_sym_declare] = ACTIONS(3708),
    [anon_sym_public] = ACTIONS(3730),
    [anon_sym_private] = ACTIONS(3730),
    [anon_sym_protected] = ACTIONS(3730),
    [anon_sym_override] = ACTIONS(3732),
    [anon_sym_module] = ACTIONS(3708),
    [anon_sym_any] = ACTIONS(3708),
    [anon_sym_number] = ACTIONS(3708),
    [anon_sym_boolean] = ACTIONS(3708),
    [anon_sym_string] = ACTIONS(3708),
    [anon_sym_symbol] = ACTIONS(3708),
    [anon_sym_object] = ACTIONS(3708),
    [anon_sym_property] = ACTIONS(3708),
    [anon_sym_signal] = ACTIONS(3708),
    [anon_sym_on] = ACTIONS(3708),
    [anon_sym_required] = ACTIONS(3708),
    [anon_sym_component] = ACTIONS(3708),
    [anon_sym_abstract] = ACTIONS(3087),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3738),
    [sym_html_comment] = ACTIONS(5),
  },
  [1238] = {
    [sym_export_statement] = STATE(4060),
    [sym__call_signature] = STATE(4331),
    [sym_string] = STATE(3505),
    [sym_comment] = STATE(1238),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(3540),
    [sym__property_name] = STATE(3359),
    [sym_computed_property_name] = STATE(3505),
    [sym_method_signature] = STATE(4060),
    [sym_accessibility_modifier] = STATE(2685),
    [sym_override_modifier] = STATE(2769),
    [sym_call_signature] = STATE(4060),
    [sym_property_signature] = STATE(4060),
    [sym_type_parameters] = STATE(5867),
    [sym_construct_signature] = STATE(4060),
    [sym_index_signature] = STATE(4060),
    [aux_sym_export_statement_repeat1] = STATE(4766),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_export] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_type] = ACTIONS(3708),
    [anon_sym_namespace] = ACTIONS(3708),
    [anon_sym_COMMA] = ACTIONS(3740),
    [anon_sym_RBRACE] = ACTIONS(3742),
    [anon_sym_from] = ACTIONS(3708),
    [anon_sym_let] = ACTIONS(3708),
    [anon_sym_LPAREN] = ACTIONS(3061),
    [anon_sym_of] = ACTIONS(3708),
    [anon_sym_SEMI] = ACTIONS(3740),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_async] = ACTIONS(3720),
    [anon_sym_new] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_LT] = ACTIONS(3073),
    [aux_sym_comment_token1] = ACTIONS(15),
    [sym_number] = ACTIONS(3075),
    [sym_private_property_identifier] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(3724),
    [anon_sym_readonly] = ACTIONS(3726),
    [anon_sym_get] = ACTIONS(3728),
    [anon_sym_set] = ACTIONS(3728),
    [anon_sym_declare] = ACTIONS(3708),
    [anon_sym_public] = ACTIONS(3730),
    [anon_sym_private] = ACTIONS(3730),
    [anon_sym_protected] = ACTIONS(3730),
    [anon_sym_override] = ACTIONS(3732),
    [anon_sym_module] = ACTIONS(3708),
    [anon_sym_any] = ACTIONS(3708),
    [anon_sym_number] = ACTIONS(3708),
    [anon_sym_boolean] = ACTIONS(3708),
    [anon_sym_string] = ACTIONS(3708),
    [anon_sym_symbol] = ACTIONS(3708),
    [anon_sym_object] = ACTIONS(3708),
    [anon_sym_property] = ACTIONS(3708),
    [anon_sym_signal] = ACTIONS(3708),
    [anon_sym_on] = ACTIONS(3708),
    [anon_sym_required] = ACTIONS(3708),
    [anon_sym_component] = ACTIONS(3708),
    [anon_sym_abstract] = ACTIONS(3087),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3742),
    [sym_html_comment] = ACTIONS(5),
  },
  [1239] = {
    [sym_comment] = STATE(1239),
    [aux_sym_object_repeat1] = STATE(4915),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(754),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [1240] = {
    [sym_export_statement] = STATE(4169),
    [sym__call_signature] = STATE(4331),
    [sym_string] = STATE(3505),
    [sym_comment] = STATE(1240),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(3540),
    [sym__property_name] = STATE(3359),
    [sym_computed_property_name] = STATE(3505),
    [sym_method_signature] = STATE(4169),
    [sym_accessibility_modifier] = STATE(2685),
    [sym_override_modifier] = STATE(2769),
    [sym_call_signature] = STATE(4169),
    [sym_property_signature] = STATE(4169),
    [sym_type_parameters] = STATE(5867),
    [sym_construct_signature] = STATE(4169),
    [sym_index_signature] = STATE(4169),
    [aux_sym_export_statement_repeat1] = STATE(4766),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_export] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_type] = ACTIONS(3708),
    [anon_sym_namespace] = ACTIONS(3708),
    [anon_sym_COMMA] = ACTIONS(3131),
    [anon_sym_RBRACE] = ACTIONS(3133),
    [anon_sym_from] = ACTIONS(3708),
    [anon_sym_let] = ACTIONS(3708),
    [anon_sym_LPAREN] = ACTIONS(3061),
    [anon_sym_of] = ACTIONS(3708),
    [anon_sym_SEMI] = ACTIONS(3131),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_async] = ACTIONS(3720),
    [anon_sym_new] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_LT] = ACTIONS(3073),
    [aux_sym_comment_token1] = ACTIONS(15),
    [sym_number] = ACTIONS(3075),
    [sym_private_property_identifier] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(3724),
    [anon_sym_readonly] = ACTIONS(3726),
    [anon_sym_get] = ACTIONS(3728),
    [anon_sym_set] = ACTIONS(3728),
    [anon_sym_declare] = ACTIONS(3708),
    [anon_sym_public] = ACTIONS(3730),
    [anon_sym_private] = ACTIONS(3730),
    [anon_sym_protected] = ACTIONS(3730),
    [anon_sym_override] = ACTIONS(3732),
    [anon_sym_module] = ACTIONS(3708),
    [anon_sym_any] = ACTIONS(3708),
    [anon_sym_number] = ACTIONS(3708),
    [anon_sym_boolean] = ACTIONS(3708),
    [anon_sym_string] = ACTIONS(3708),
    [anon_sym_symbol] = ACTIONS(3708),
    [anon_sym_object] = ACTIONS(3708),
    [anon_sym_property] = ACTIONS(3708),
    [anon_sym_signal] = ACTIONS(3708),
    [anon_sym_on] = ACTIONS(3708),
    [anon_sym_required] = ACTIONS(3708),
    [anon_sym_component] = ACTIONS(3708),
    [anon_sym_abstract] = ACTIONS(3087),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3133),
    [sym_html_comment] = ACTIONS(5),
  },
  [1241] = {
    [sym_export_statement] = STATE(4075),
    [sym__call_signature] = STATE(4331),
    [sym_string] = STATE(3505),
    [sym_comment] = STATE(1241),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(3540),
    [sym__property_name] = STATE(3359),
    [sym_computed_property_name] = STATE(3505),
    [sym_method_signature] = STATE(4075),
    [sym_accessibility_modifier] = STATE(2685),
    [sym_override_modifier] = STATE(2769),
    [sym_call_signature] = STATE(4075),
    [sym_property_signature] = STATE(4075),
    [sym_type_parameters] = STATE(5867),
    [sym_construct_signature] = STATE(4075),
    [sym_index_signature] = STATE(4075),
    [aux_sym_export_statement_repeat1] = STATE(4766),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_export] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_type] = ACTIONS(3708),
    [anon_sym_namespace] = ACTIONS(3708),
    [anon_sym_COMMA] = ACTIONS(3063),
    [anon_sym_RBRACE] = ACTIONS(3089),
    [anon_sym_from] = ACTIONS(3708),
    [anon_sym_let] = ACTIONS(3708),
    [anon_sym_LPAREN] = ACTIONS(3061),
    [anon_sym_of] = ACTIONS(3708),
    [anon_sym_SEMI] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_async] = ACTIONS(3720),
    [anon_sym_new] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_LT] = ACTIONS(3073),
    [aux_sym_comment_token1] = ACTIONS(15),
    [sym_number] = ACTIONS(3075),
    [sym_private_property_identifier] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(3724),
    [anon_sym_readonly] = ACTIONS(3726),
    [anon_sym_get] = ACTIONS(3728),
    [anon_sym_set] = ACTIONS(3728),
    [anon_sym_declare] = ACTIONS(3708),
    [anon_sym_public] = ACTIONS(3730),
    [anon_sym_private] = ACTIONS(3730),
    [anon_sym_protected] = ACTIONS(3730),
    [anon_sym_override] = ACTIONS(3732),
    [anon_sym_module] = ACTIONS(3708),
    [anon_sym_any] = ACTIONS(3708),
    [anon_sym_number] = ACTIONS(3708),
    [anon_sym_boolean] = ACTIONS(3708),
    [anon_sym_string] = ACTIONS(3708),
    [anon_sym_symbol] = ACTIONS(3708),
    [anon_sym_object] = ACTIONS(3708),
    [anon_sym_property] = ACTIONS(3708),
    [anon_sym_signal] = ACTIONS(3708),
    [anon_sym_on] = ACTIONS(3708),
    [anon_sym_required] = ACTIONS(3708),
    [anon_sym_component] = ACTIONS(3708),
    [anon_sym_abstract] = ACTIONS(3087),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3089),
    [sym_html_comment] = ACTIONS(5),
  },
  [1242] = {
    [sym_comment] = STATE(1242),
    [aux_sym_object_repeat1] = STATE(4915),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [1243] = {
    [sym_nested_identifier] = STATE(1868),
    [sym_string] = STATE(1867),
    [sym_comment] = STATE(1243),
    [sym__module] = STATE(1996),
    [sym_identifier] = ACTIONS(3666),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_EQ] = ACTIONS(1013),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_LBRACE] = ACTIONS(70),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(70),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_DQUOTE] = ACTIONS(58),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_EQ_GT] = ACTIONS(1003),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(30),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_satisfies] = ACTIONS(30),
    [anon_sym_implements] = ACTIONS(30),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [1244] = {
    [sym_comment] = STATE(1244),
    [aux_sym_object_repeat1] = STATE(5251),
    [aux_sym_object_pattern_repeat1] = STATE(4957),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_STAR] = ACTIONS(30),
    [anon_sym_EQ] = ACTIONS(748),
    [anon_sym_as] = ACTIONS(30),
    [anon_sym_COMMA] = ACTIONS(70),
    [anon_sym_RBRACE] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(30),
    [anon_sym_LPAREN] = ACTIONS(2336),
    [anon_sym_in] = ACTIONS(30),
    [anon_sym_SEMI] = ACTIONS(70),
    [anon_sym_COLON] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_GT] = ACTIONS(30),
    [anon_sym_DOT] = ACTIONS(70),
    [anon_sym_EQ_GT] = ACTIONS(767),
    [anon_sym_QMARK_DOT] = ACTIONS(70),
    [anon_sym_PLUS_EQ] = ACTIONS(76),
    [anon_sym_DASH_EQ] = ACTIONS(76),
    [anon_sym_STAR_EQ] = ACTIONS(76),
    [anon_sym_SLASH_EQ] = ACTIONS(76),
    [anon_sym_PERCENT_EQ] = ACTIONS(76),
    [anon_sym_CARET_EQ] = ACTIONS(76),
    [anon_sym_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(76),
    [anon_sym_LT_LT_EQ] = ACTIONS(76),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(76),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(76),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(76),
    [anon_sym_AMP_AMP] = ACTIONS(30),
    [anon_sym_PIPE_PIPE] = ACTIONS(30),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_GT_GT_GT] = ACTIONS(30),
    [anon_sym_LT_LT] = ACTIONS(30),
    [anon_sym_AMP] = ACTIONS(30),
    [anon_sym_CARET] = ACTIONS(30),
    [anon_sym_PIPE] = ACTIONS(30),
    [anon_sym_PLUS] = ACTIONS(30),
    [anon_sym_DASH] = ACTIONS(30),
    [anon_sym_SLASH] = ACTIONS(30),
    [anon_sym_PERCENT] = ACTIONS(30),
    [anon_sym_STAR_STAR] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(70),
    [anon_sym_EQ_EQ] = ACTIONS(30),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(70),
    [anon_sym_BANG_EQ] = ACTIONS(30),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(70),
    [anon_sym_GT_EQ] = ACTIONS(70),
    [anon_sym_QMARK_QMARK] = ACTIONS(30),
    [anon_sym_instanceof] = ACTIONS(30),
    [anon_sym_PLUS_PLUS] = ACTIONS(70),
    [anon_sym_DASH_DASH] = ACTIONS(70),
    [aux_sym_comment_token1] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(70),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_satisfies] = ACTIONS(30),
    [sym__automatic_semicolon] = ACTIONS(70),
    [sym__ternary_qmark] = ACTIONS(70),
    [sym_html_comment] = ACTIONS(5),
  },
  [1245] = {
    [sym_export_statement] = STATE(4013),
    [sym__call_signature] = STATE(4331),
    [sym_string] = STATE(3505),
    [sym_comment] = STATE(1245),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(3540),
    [sym__property_name] = STATE(3359),
    [sym_computed_property_name] = STATE(3505),
    [sym_method_signature] = STATE(4013),
    [sym_accessibility_modifier] = STATE(2685),
    [sym_override_modifier] = STATE(2769),
    [sym_call_signature] = STATE(4013),
    [sym_property_signature] = STATE(4013),
    [sym_type_parameters] = STATE(5867),
    [sym_construct_signature] = STATE(4013),
    [sym_index_signature] = STATE(4013),
    [aux_sym_export_statement_repeat1] = STATE(4766),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_export] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_type] = ACTIONS(3708),
    [anon_sym_namespace] = ACTIONS(3708),
    [anon_sym_COMMA] = ACTIONS(3744),
    [anon_sym_RBRACE] = ACTIONS(3746),
    [anon_sym_from] = ACTIONS(3708),
    [anon_sym_let] = ACTIONS(3708),
    [anon_sym_LPAREN] = ACTIONS(3061),
    [anon_sym_of] = ACTIONS(3708),
    [anon_sym_SEMI] = ACTIONS(3744),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_async] = ACTIONS(3720),
    [anon_sym_new] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_LT] = ACTIONS(3073),
    [aux_sym_comment_token1] = ACTIONS(15),
    [sym_number] = ACTIONS(3075),
    [sym_private_property_identifier] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(3724),
    [anon_sym_readonly] = ACTIONS(3726),
    [anon_sym_get] = ACTIONS(3728),
    [anon_sym_set] = ACTIONS(3728),
    [anon_sym_declare] = ACTIONS(3708),
    [anon_sym_public] = ACTIONS(3730),
    [anon_sym_private] = ACTIONS(3730),
    [anon_sym_protected] = ACTIONS(3730),
    [anon_sym_override] = ACTIONS(3732),
    [anon_sym_module] = ACTIONS(3708),
    [anon_sym_any] = ACTIONS(3708),
    [anon_sym_number] = ACTIONS(3708),
    [anon_sym_boolean] = ACTIONS(3708),
    [anon_sym_string] = ACTIONS(3708),
    [anon_sym_symbol] = ACTIONS(3708),
    [anon_sym_object] = ACTIONS(3708),
    [anon_sym_property] = ACTIONS(3708),
    [anon_sym_signal] = ACTIONS(3708),
    [anon_sym_on] = ACTIONS(3708),
    [anon_sym_required] = ACTIONS(3708),
    [anon_sym_component] = ACTIONS(3708),
    [anon_sym_abstract] = ACTIONS(3087),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3746),
    [sym_html_comment] = ACTIONS(5),
  },
  [1246] = {
    [sym_export_statement] = STATE(4100),
    [sym__call_signature] = STATE(4331),
    [sym_string] = STATE(3505),
    [sym_comment] = STATE(1246),
    [sym_decorator] = STATE(1202),
    [sym_formal_parameters] = STATE(3540),
    [sym__property_name] = STATE(3359),
    [sym_computed_property_name] = STATE(3505),
    [sym_method_signature] = STATE(4100),
    [sym_accessibility_modifier] = STATE(2685),
    [sym_override_modifier] = STATE(2769),
    [sym_call_signature] = STATE(4100),
    [sym_property_signature] = STATE(4100),
    [sym_type_parameters] = STATE(5867),
    [sym_construct_signature] = STATE(4100),
    [sym_index_signature] = STATE(4100),
    [aux_sym_export_statement_repeat1] = STATE(4766),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_export] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_type] = ACTIONS(3708),
    [anon_sym_namespace] = ACTIONS(3708),
    [anon_sym_COMMA] = ACTIONS(3748),
    [anon_sym_RBRACE] = ACTIONS(3750),
    [anon_sym_from] = ACTIONS(3708),
    [anon_sym_let] = ACTIONS(3708),
    [anon_sym_LPAREN] = ACTIONS(3061),
    [anon_sym_of] = ACTIONS(3708),
    [anon_sym_SEMI] = ACTIONS(3748),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2016),
    [anon_sym_async] = ACTIONS(3720),
    [anon_sym_new] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_LT] = ACTIONS(3073),
    [aux_sym_comment_token1] = ACTIONS(15),
    [sym_number] = ACTIONS(3075),
    [sym_private_property_identifier] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(114),
    [anon_sym_static] = ACTIONS(3724),
    [anon_sym_readonly] = ACTIONS(3726),
    [anon_sym_get] = ACTIONS(3728),
    [anon_sym_set] = ACTIONS(3728),
    [anon_sym_declare] = ACTIONS(3708),
    [anon_sym_public] = ACTIONS(3730),
    [anon_sym_private] = ACTIONS(3730),
    [anon_sym_protected] = ACTIONS(3730),
    [anon_sym_override] = ACTIONS(3732),
    [anon_sym_module] = ACTIONS(3708),
    [anon_sym_any] = ACTIONS(3708),
    [anon_sym_number] = ACTIONS(3708),
    [anon_sym_boolean] = ACTIONS(3708),
    [anon_sym_string] = ACTIONS(3708),
    [anon_sym_symbol] = ACTIONS(3708),
    [anon_sym_object] = ACTIONS(3708),
    [anon_sym_property] = ACTIONS(3708),
    [anon_sym_signal] = ACTIONS(3708),
    [anon_sym_on] = ACTIONS(3708),
    [anon_sym_required] = ACTIONS(3708),
    [anon_sym_component] = ACTIONS(3708),
    [anon_sym_abstract] = ACTIONS(3087),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3750),
    [sym_html_comment] = ACTIONS(5),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(756), 1,
      anon_sym_COLON,
    ACTIONS(775), 1,
      anon_sym_QMARK,
    ACTIONS(791), 1,
      anon_sym_RBRACE,
    ACTIONS(3754), 1,
      anon_sym_EQ,
    ACTIONS(3758), 1,
      anon_sym_LPAREN,
    ACTIONS(3761), 1,
      anon_sym_EQ_GT,
    ACTIONS(3765), 1,
      anon_sym_LT,
    STATE(1247), 1,
      sym_comment,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5251), 1,
      aux_sym_object_repeat1,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3756), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3752), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [95] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(993), 1,
      anon_sym_EQ,
    ACTIONS(999), 1,
      anon_sym_EQ_GT,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3768), 1,
      sym_identifier,
    STATE(1248), 1,
      sym_comment,
    STATE(3759), 1,
      sym_nested_identifier,
    STATE(3864), 1,
      sym_string,
    STATE(4287), 1,
      sym__module,
    ACTIONS(70), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [188] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(748), 1,
      anon_sym_EQ,
    ACTIONS(756), 1,
      anon_sym_COLON,
    ACTIONS(767), 1,
      anon_sym_EQ_GT,
    ACTIONS(775), 1,
      anon_sym_QMARK,
    ACTIONS(791), 1,
      anon_sym_RBRACE,
    ACTIONS(2336), 1,
      anon_sym_LPAREN,
    ACTIONS(2341), 1,
      anon_sym_LT,
    STATE(1249), 1,
      sym_comment,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5251), 1,
      aux_sym_object_repeat1,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(70), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(30), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [283] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1250), 1,
      sym_comment,
    ACTIONS(3770), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(3772), 38,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [358] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(993), 1,
      anon_sym_EQ,
    ACTIONS(999), 1,
      anon_sym_EQ_GT,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(3706), 1,
      sym_identifier,
    STATE(818), 1,
      sym__module,
    STATE(1251), 1,
      sym_comment,
    STATE(4359), 1,
      sym_nested_identifier,
    STATE(4682), 1,
      sym_string,
    ACTIONS(70), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [451] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1252), 1,
      sym_comment,
    ACTIONS(3774), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(3776), 38,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [526] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1253), 1,
      sym_comment,
    ACTIONS(3778), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(3780), 38,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [601] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1254), 1,
      sym_comment,
    ACTIONS(3782), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(3784), 38,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [676] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(748), 1,
      anon_sym_EQ,
    ACTIONS(756), 1,
      anon_sym_COLON,
    ACTIONS(767), 1,
      anon_sym_EQ_GT,
    ACTIONS(775), 1,
      anon_sym_QMARK,
    ACTIONS(781), 1,
      anon_sym_RBRACE,
    ACTIONS(2336), 1,
      anon_sym_LPAREN,
    ACTIONS(2341), 1,
      anon_sym_LT,
    STATE(1255), 1,
      sym_comment,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(70), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(30), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [771] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(993), 1,
      anon_sym_EQ,
    ACTIONS(999), 1,
      anon_sym_EQ_GT,
    ACTIONS(3614), 1,
      sym_identifier,
    ACTIONS(3616), 1,
      anon_sym_DQUOTE,
    ACTIONS(3618), 1,
      anon_sym_SQUOTE,
    STATE(226), 1,
      sym_nested_identifier,
    STATE(227), 1,
      sym_string,
    STATE(229), 1,
      sym__module,
    STATE(1256), 1,
      sym_comment,
    ACTIONS(70), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [864] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1257), 1,
      sym_comment,
    ACTIONS(3786), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(3788), 38,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [939] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(756), 1,
      anon_sym_COLON,
    ACTIONS(775), 1,
      anon_sym_QMARK,
    ACTIONS(781), 1,
      anon_sym_RBRACE,
    ACTIONS(3754), 1,
      anon_sym_EQ,
    ACTIONS(3758), 1,
      anon_sym_LPAREN,
    ACTIONS(3761), 1,
      anon_sym_EQ_GT,
    ACTIONS(3765), 1,
      anon_sym_LT,
    STATE(1258), 1,
      sym_comment,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3756), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3752), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [1034] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(58), 1,
      anon_sym_DQUOTE,
    ACTIONS(60), 1,
      anon_sym_SQUOTE,
    ACTIONS(863), 1,
      anon_sym_EQ,
    ACTIONS(999), 1,
      anon_sym_EQ_GT,
    ACTIONS(3666), 1,
      sym_identifier,
    STATE(1259), 1,
      sym_comment,
    STATE(1867), 1,
      sym_string,
    STATE(1868), 1,
      sym_nested_identifier,
    STATE(1996), 1,
      sym__module,
    ACTIONS(70), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [1127] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(748), 1,
      anon_sym_EQ,
    ACTIONS(756), 1,
      anon_sym_COLON,
    ACTIONS(767), 1,
      anon_sym_EQ_GT,
    ACTIONS(775), 1,
      anon_sym_QMARK,
    ACTIONS(777), 1,
      anon_sym_RBRACE,
    ACTIONS(2336), 1,
      anon_sym_LPAREN,
    ACTIONS(2341), 1,
      anon_sym_LT,
    STATE(1260), 1,
      sym_comment,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(70), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(30), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [1222] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1261), 1,
      sym_comment,
    ACTIONS(3790), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(3792), 38,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [1297] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(993), 1,
      anon_sym_EQ,
    ACTIONS(999), 1,
      anon_sym_EQ_GT,
    ACTIONS(3600), 1,
      sym_identifier,
    ACTIONS(3602), 1,
      anon_sym_LBRACE,
    ACTIONS(3604), 1,
      anon_sym_LBRACK,
    STATE(1262), 1,
      sym_comment,
    STATE(3972), 1,
      sym__destructuring_pattern,
    STATE(4861), 1,
      sym_variable_declarator,
    STATE(3973), 2,
      sym_object_pattern,
      sym_array_pattern,
    ACTIONS(70), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [1390] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(748), 1,
      anon_sym_EQ,
    ACTIONS(754), 1,
      anon_sym_RBRACE,
    ACTIONS(756), 1,
      anon_sym_COLON,
    ACTIONS(767), 1,
      anon_sym_EQ_GT,
    ACTIONS(775), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_LPAREN,
    ACTIONS(2341), 1,
      anon_sym_LT,
    STATE(1263), 1,
      sym_comment,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(70), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(30), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [1485] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(756), 1,
      anon_sym_COLON,
    ACTIONS(775), 1,
      anon_sym_QMARK,
    ACTIONS(777), 1,
      anon_sym_RBRACE,
    ACTIONS(3754), 1,
      anon_sym_EQ,
    ACTIONS(3758), 1,
      anon_sym_LPAREN,
    ACTIONS(3761), 1,
      anon_sym_EQ_GT,
    ACTIONS(3765), 1,
      anon_sym_LT,
    STATE(1264), 1,
      sym_comment,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3756), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3752), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [1580] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(58), 1,
      anon_sym_DQUOTE,
    ACTIONS(60), 1,
      anon_sym_SQUOTE,
    ACTIONS(976), 1,
      anon_sym_COLON,
    ACTIONS(980), 1,
      anon_sym_EQ_GT,
    ACTIONS(1005), 1,
      anon_sym_EQ,
    ACTIONS(3666), 1,
      sym_identifier,
    STATE(1265), 1,
      sym_comment,
    STATE(1867), 1,
      sym_string,
    STATE(1868), 1,
      sym_nested_identifier,
    STATE(1996), 1,
      sym__module,
    ACTIONS(70), 13,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [1675] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(205), 1,
      anon_sym_DQUOTE,
    ACTIONS(207), 1,
      anon_sym_SQUOTE,
    ACTIONS(993), 1,
      anon_sym_EQ,
    ACTIONS(999), 1,
      anon_sym_EQ_GT,
    ACTIONS(3676), 1,
      sym_identifier,
    STATE(1266), 1,
      sym_comment,
    STATE(1734), 1,
      sym_string,
    STATE(1738), 1,
      sym_nested_identifier,
    STATE(2070), 1,
      sym__module,
    ACTIONS(70), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [1768] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3794), 1,
      anon_sym_EQ,
    ACTIONS(3798), 1,
      anon_sym_LPAREN,
    ACTIONS(3800), 1,
      anon_sym_DOT,
    ACTIONS(3802), 1,
      anon_sym_EQ_GT,
    ACTIONS(3804), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3808), 1,
      anon_sym_LT,
    STATE(1267), 1,
      sym_comment,
    STATE(3362), 1,
      sym_arguments,
    STATE(3511), 1,
      sym_type_arguments,
    ACTIONS(3806), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3796), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3756), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [1865] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(993), 1,
      anon_sym_EQ,
    ACTIONS(999), 1,
      anon_sym_EQ_GT,
    ACTIONS(3608), 1,
      sym_identifier,
    ACTIONS(3610), 1,
      anon_sym_DQUOTE,
    ACTIONS(3612), 1,
      anon_sym_SQUOTE,
    STATE(755), 1,
      sym_nested_identifier,
    STATE(760), 1,
      sym_string,
    STATE(818), 1,
      sym__module,
    STATE(1268), 1,
      sym_comment,
    ACTIONS(70), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [1958] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(36), 1,
      anon_sym_RBRACK,
    ACTIONS(58), 1,
      anon_sym_DQUOTE,
    ACTIONS(60), 1,
      anon_sym_SQUOTE,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(971), 1,
      anon_sym_EQ,
    ACTIONS(980), 1,
      anon_sym_EQ_GT,
    ACTIONS(3666), 1,
      sym_identifier,
    STATE(1269), 1,
      sym_comment,
    STATE(1867), 1,
      sym_string,
    STATE(1868), 1,
      sym_nested_identifier,
    STATE(1996), 1,
      sym__module,
    ACTIONS(70), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [2055] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(993), 1,
      anon_sym_EQ,
    ACTIONS(999), 1,
      anon_sym_EQ_GT,
    ACTIONS(3694), 1,
      sym_identifier,
    ACTIONS(3696), 1,
      anon_sym_DQUOTE,
    ACTIONS(3698), 1,
      anon_sym_SQUOTE,
    STATE(1270), 1,
      sym_comment,
    STATE(2781), 1,
      sym_nested_identifier,
    STATE(2835), 1,
      sym_string,
    STATE(2996), 1,
      sym__module,
    ACTIONS(70), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [2148] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(993), 1,
      anon_sym_EQ,
    ACTIONS(999), 1,
      anon_sym_EQ_GT,
    ACTIONS(3600), 1,
      sym_identifier,
    ACTIONS(3602), 1,
      anon_sym_LBRACE,
    ACTIONS(3604), 1,
      anon_sym_LBRACK,
    STATE(1271), 1,
      sym_comment,
    STATE(3972), 1,
      sym__destructuring_pattern,
    STATE(4750), 1,
      sym_variable_declarator,
    STATE(3973), 2,
      sym_object_pattern,
      sym_array_pattern,
    ACTIONS(70), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [2241] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1272), 1,
      sym_comment,
    ACTIONS(3810), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(3812), 38,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [2316] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(58), 1,
      anon_sym_DQUOTE,
    ACTIONS(60), 1,
      anon_sym_SQUOTE,
    ACTIONS(980), 1,
      anon_sym_EQ_GT,
    ACTIONS(1005), 1,
      anon_sym_EQ,
    ACTIONS(1007), 1,
      anon_sym_COLON,
    ACTIONS(3666), 1,
      sym_identifier,
    STATE(1273), 1,
      sym_comment,
    STATE(1867), 1,
      sym_string,
    STATE(1868), 1,
      sym_nested_identifier,
    STATE(1996), 1,
      sym__module,
    ACTIONS(70), 13,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [2411] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(993), 1,
      anon_sym_EQ,
    ACTIONS(999), 1,
      anon_sym_EQ_GT,
    ACTIONS(3700), 1,
      sym_identifier,
    ACTIONS(3702), 1,
      anon_sym_DQUOTE,
    ACTIONS(3704), 1,
      anon_sym_SQUOTE,
    STATE(919), 1,
      sym_string,
    STATE(921), 1,
      sym_nested_identifier,
    STATE(927), 1,
      sym__module,
    STATE(1274), 1,
      sym_comment,
    ACTIONS(70), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [2504] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3794), 1,
      anon_sym_EQ,
    ACTIONS(3802), 1,
      anon_sym_EQ_GT,
    ACTIONS(3814), 1,
      anon_sym_LPAREN,
    ACTIONS(3816), 1,
      anon_sym_DOT,
    ACTIONS(3818), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3820), 1,
      anon_sym_LT,
    STATE(1275), 1,
      sym_comment,
    STATE(3174), 1,
      sym_arguments,
    STATE(3263), 1,
      sym_type_arguments,
    ACTIONS(3796), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3806), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3756), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [2601] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(993), 1,
      anon_sym_EQ,
    ACTIONS(999), 1,
      anon_sym_EQ_GT,
    ACTIONS(3600), 1,
      sym_identifier,
    ACTIONS(3602), 1,
      anon_sym_LBRACE,
    ACTIONS(3604), 1,
      anon_sym_LBRACK,
    STATE(1276), 1,
      sym_comment,
    STATE(3972), 1,
      sym__destructuring_pattern,
    STATE(4825), 1,
      sym_variable_declarator,
    STATE(3973), 2,
      sym_object_pattern,
      sym_array_pattern,
    ACTIONS(70), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [2694] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(754), 1,
      anon_sym_RBRACE,
    ACTIONS(756), 1,
      anon_sym_COLON,
    ACTIONS(775), 1,
      anon_sym_QMARK,
    ACTIONS(3754), 1,
      anon_sym_EQ,
    ACTIONS(3758), 1,
      anon_sym_LPAREN,
    ACTIONS(3761), 1,
      anon_sym_EQ_GT,
    ACTIONS(3765), 1,
      anon_sym_LT,
    STATE(1277), 1,
      sym_comment,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3756), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3752), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [2789] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(3087), 1,
      anon_sym_abstract,
    ACTIONS(3710), 1,
      anon_sym_export,
    ACTIONS(3712), 1,
      anon_sym_STAR,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3720), 1,
      anon_sym_async,
    ACTIONS(3722), 1,
      anon_sym_new,
    ACTIONS(3724), 1,
      anon_sym_static,
    ACTIONS(3726), 1,
      anon_sym_readonly,
    ACTIONS(3732), 1,
      anon_sym_override,
    STATE(1202), 1,
      sym_decorator,
    STATE(1278), 1,
      sym_comment,
    STATE(2685), 1,
      sym_accessibility_modifier,
    STATE(2769), 1,
      sym_override_modifier,
    STATE(3359), 1,
      sym__property_name,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4331), 1,
      sym__call_signature,
    STATE(4766), 1,
      aux_sym_export_statement_repeat1,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3728), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3822), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4555), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3708), 19,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [2919] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(58), 1,
      anon_sym_DQUOTE,
    ACTIONS(60), 1,
      anon_sym_SQUOTE,
    ACTIONS(863), 1,
      anon_sym_EQ,
    ACTIONS(1037), 1,
      anon_sym_EQ_GT,
    ACTIONS(3666), 1,
      sym_identifier,
    STATE(1279), 1,
      sym_comment,
    STATE(1867), 1,
      sym_string,
    STATE(1868), 1,
      sym_nested_identifier,
    STATE(1996), 1,
      sym__module,
    ACTIONS(70), 13,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [3011] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(58), 1,
      anon_sym_DQUOTE,
    ACTIONS(60), 1,
      anon_sym_SQUOTE,
    ACTIONS(139), 1,
      anon_sym_EQ_GT,
    ACTIONS(863), 1,
      anon_sym_EQ,
    ACTIONS(984), 1,
      anon_sym_in,
    ACTIONS(3666), 1,
      sym_identifier,
    ACTIONS(3692), 1,
      anon_sym_of,
    STATE(1280), 1,
      sym_comment,
    STATE(1867), 1,
      sym_string,
    STATE(1868), 1,
      sym_nested_identifier,
    STATE(1996), 1,
      sym__module,
    ACTIONS(70), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [3107] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(3087), 1,
      anon_sym_abstract,
    ACTIONS(3710), 1,
      anon_sym_export,
    ACTIONS(3712), 1,
      anon_sym_STAR,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3720), 1,
      anon_sym_async,
    ACTIONS(3722), 1,
      anon_sym_new,
    ACTIONS(3724), 1,
      anon_sym_static,
    ACTIONS(3726), 1,
      anon_sym_readonly,
    ACTIONS(3732), 1,
      anon_sym_override,
    STATE(1202), 1,
      sym_decorator,
    STATE(1281), 1,
      sym_comment,
    STATE(2685), 1,
      sym_accessibility_modifier,
    STATE(2769), 1,
      sym_override_modifier,
    STATE(3359), 1,
      sym__property_name,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4331), 1,
      sym__call_signature,
    STATE(4766), 1,
      aux_sym_export_statement_repeat1,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3728), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3824), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4555), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3708), 19,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [3237] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(3087), 1,
      anon_sym_abstract,
    ACTIONS(3710), 1,
      anon_sym_export,
    ACTIONS(3712), 1,
      anon_sym_STAR,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3720), 1,
      anon_sym_async,
    ACTIONS(3722), 1,
      anon_sym_new,
    ACTIONS(3724), 1,
      anon_sym_static,
    ACTIONS(3726), 1,
      anon_sym_readonly,
    ACTIONS(3732), 1,
      anon_sym_override,
    STATE(1202), 1,
      sym_decorator,
    STATE(1282), 1,
      sym_comment,
    STATE(2685), 1,
      sym_accessibility_modifier,
    STATE(2769), 1,
      sym_override_modifier,
    STATE(3359), 1,
      sym__property_name,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4331), 1,
      sym__call_signature,
    STATE(4766), 1,
      aux_sym_export_statement_repeat1,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3728), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3826), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4555), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3708), 19,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [3367] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(3087), 1,
      anon_sym_abstract,
    ACTIONS(3710), 1,
      anon_sym_export,
    ACTIONS(3712), 1,
      anon_sym_STAR,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3720), 1,
      anon_sym_async,
    ACTIONS(3722), 1,
      anon_sym_new,
    ACTIONS(3724), 1,
      anon_sym_static,
    ACTIONS(3726), 1,
      anon_sym_readonly,
    ACTIONS(3732), 1,
      anon_sym_override,
    STATE(1202), 1,
      sym_decorator,
    STATE(1283), 1,
      sym_comment,
    STATE(2685), 1,
      sym_accessibility_modifier,
    STATE(2769), 1,
      sym_override_modifier,
    STATE(3359), 1,
      sym__property_name,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4331), 1,
      sym__call_signature,
    STATE(4766), 1,
      aux_sym_export_statement_repeat1,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3728), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3828), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4555), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3708), 19,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [3497] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3794), 1,
      anon_sym_EQ,
    ACTIONS(3802), 1,
      anon_sym_EQ_GT,
    ACTIONS(3836), 1,
      anon_sym_DOT,
    ACTIONS(3839), 1,
      anon_sym_LT,
    ACTIONS(3842), 1,
      anon_sym_extends,
    STATE(1284), 1,
      sym_comment,
    STATE(3240), 1,
      sym_type_arguments,
    ACTIONS(3830), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3833), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3756), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [3589] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(3087), 1,
      anon_sym_abstract,
    ACTIONS(3710), 1,
      anon_sym_export,
    ACTIONS(3712), 1,
      anon_sym_STAR,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3720), 1,
      anon_sym_async,
    ACTIONS(3722), 1,
      anon_sym_new,
    ACTIONS(3724), 1,
      anon_sym_static,
    ACTIONS(3726), 1,
      anon_sym_readonly,
    ACTIONS(3732), 1,
      anon_sym_override,
    STATE(1202), 1,
      sym_decorator,
    STATE(1285), 1,
      sym_comment,
    STATE(2685), 1,
      sym_accessibility_modifier,
    STATE(2769), 1,
      sym_override_modifier,
    STATE(3359), 1,
      sym__property_name,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4331), 1,
      sym__call_signature,
    STATE(4766), 1,
      aux_sym_export_statement_repeat1,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3728), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3844), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4555), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3708), 19,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [3719] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(58), 1,
      anon_sym_DQUOTE,
    ACTIONS(60), 1,
      anon_sym_SQUOTE,
    ACTIONS(1027), 1,
      anon_sym_EQ,
    ACTIONS(1037), 1,
      anon_sym_EQ_GT,
    ACTIONS(3666), 1,
      sym_identifier,
    STATE(1286), 1,
      sym_comment,
    STATE(1867), 1,
      sym_string,
    STATE(1868), 1,
      sym_nested_identifier,
    STATE(1996), 1,
      sym__module,
    ACTIONS(70), 13,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [3811] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(3087), 1,
      anon_sym_abstract,
    ACTIONS(3710), 1,
      anon_sym_export,
    ACTIONS(3712), 1,
      anon_sym_STAR,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3720), 1,
      anon_sym_async,
    ACTIONS(3722), 1,
      anon_sym_new,
    ACTIONS(3724), 1,
      anon_sym_static,
    ACTIONS(3726), 1,
      anon_sym_readonly,
    ACTIONS(3732), 1,
      anon_sym_override,
    STATE(1202), 1,
      sym_decorator,
    STATE(1287), 1,
      sym_comment,
    STATE(2685), 1,
      sym_accessibility_modifier,
    STATE(2769), 1,
      sym_override_modifier,
    STATE(3359), 1,
      sym__property_name,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4331), 1,
      sym__call_signature,
    STATE(4766), 1,
      aux_sym_export_statement_repeat1,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3728), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3846), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4555), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3708), 19,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [3941] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3802), 1,
      anon_sym_EQ_GT,
    ACTIONS(3830), 1,
      anon_sym_LBRACK,
    ACTIONS(3836), 1,
      anon_sym_DOT,
    ACTIONS(3839), 1,
      anon_sym_LT,
    ACTIONS(3842), 1,
      anon_sym_extends,
    ACTIONS(3848), 1,
      anon_sym_EQ,
    ACTIONS(3855), 1,
      anon_sym_COLON,
    ACTIONS(3857), 1,
      anon_sym_QMARK,
    STATE(1288), 1,
      sym_comment,
    STATE(3240), 1,
      sym_type_arguments,
    STATE(5686), 1,
      sym_type_annotation,
    ACTIONS(3833), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3851), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(3756), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4041] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(3087), 1,
      anon_sym_abstract,
    ACTIONS(3710), 1,
      anon_sym_export,
    ACTIONS(3712), 1,
      anon_sym_STAR,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3720), 1,
      anon_sym_async,
    ACTIONS(3722), 1,
      anon_sym_new,
    ACTIONS(3724), 1,
      anon_sym_static,
    ACTIONS(3726), 1,
      anon_sym_readonly,
    ACTIONS(3732), 1,
      anon_sym_override,
    STATE(1202), 1,
      sym_decorator,
    STATE(1289), 1,
      sym_comment,
    STATE(2685), 1,
      sym_accessibility_modifier,
    STATE(2769), 1,
      sym_override_modifier,
    STATE(3359), 1,
      sym__property_name,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4331), 1,
      sym__call_signature,
    STATE(4766), 1,
      aux_sym_export_statement_repeat1,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3728), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3860), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4555), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3708), 19,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [4171] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(3087), 1,
      anon_sym_abstract,
    ACTIONS(3710), 1,
      anon_sym_export,
    ACTIONS(3712), 1,
      anon_sym_STAR,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3720), 1,
      anon_sym_async,
    ACTIONS(3722), 1,
      anon_sym_new,
    ACTIONS(3724), 1,
      anon_sym_static,
    ACTIONS(3726), 1,
      anon_sym_readonly,
    ACTIONS(3732), 1,
      anon_sym_override,
    STATE(1202), 1,
      sym_decorator,
    STATE(1290), 1,
      sym_comment,
    STATE(2685), 1,
      sym_accessibility_modifier,
    STATE(2769), 1,
      sym_override_modifier,
    STATE(3359), 1,
      sym__property_name,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4331), 1,
      sym__call_signature,
    STATE(4766), 1,
      aux_sym_export_statement_repeat1,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3728), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3862), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4555), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3708), 19,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [4301] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(3087), 1,
      anon_sym_abstract,
    ACTIONS(3710), 1,
      anon_sym_export,
    ACTIONS(3712), 1,
      anon_sym_STAR,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3720), 1,
      anon_sym_async,
    ACTIONS(3722), 1,
      anon_sym_new,
    ACTIONS(3724), 1,
      anon_sym_static,
    ACTIONS(3726), 1,
      anon_sym_readonly,
    ACTIONS(3732), 1,
      anon_sym_override,
    STATE(1202), 1,
      sym_decorator,
    STATE(1291), 1,
      sym_comment,
    STATE(2685), 1,
      sym_accessibility_modifier,
    STATE(2769), 1,
      sym_override_modifier,
    STATE(3359), 1,
      sym__property_name,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4331), 1,
      sym__call_signature,
    STATE(4766), 1,
      aux_sym_export_statement_repeat1,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3728), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3864), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4555), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3708), 19,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [4431] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(3087), 1,
      anon_sym_abstract,
    ACTIONS(3710), 1,
      anon_sym_export,
    ACTIONS(3712), 1,
      anon_sym_STAR,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3720), 1,
      anon_sym_async,
    ACTIONS(3722), 1,
      anon_sym_new,
    ACTIONS(3724), 1,
      anon_sym_static,
    ACTIONS(3726), 1,
      anon_sym_readonly,
    ACTIONS(3732), 1,
      anon_sym_override,
    STATE(1202), 1,
      sym_decorator,
    STATE(1292), 1,
      sym_comment,
    STATE(2685), 1,
      sym_accessibility_modifier,
    STATE(2769), 1,
      sym_override_modifier,
    STATE(3359), 1,
      sym__property_name,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4331), 1,
      sym__call_signature,
    STATE(4766), 1,
      aux_sym_export_statement_repeat1,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3728), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3866), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4555), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3708), 19,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [4561] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(58), 1,
      anon_sym_DQUOTE,
    ACTIONS(60), 1,
      anon_sym_SQUOTE,
    ACTIONS(980), 1,
      anon_sym_EQ_GT,
    ACTIONS(1005), 1,
      anon_sym_EQ,
    ACTIONS(3666), 1,
      sym_identifier,
    STATE(1293), 1,
      sym_comment,
    STATE(1867), 1,
      sym_string,
    STATE(1868), 1,
      sym_nested_identifier,
    STATE(1996), 1,
      sym__module,
    ACTIONS(70), 13,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [4653] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3794), 1,
      anon_sym_EQ,
    ACTIONS(3802), 1,
      anon_sym_EQ_GT,
    ACTIONS(3814), 1,
      anon_sym_LPAREN,
    ACTIONS(3816), 1,
      anon_sym_DOT,
    ACTIONS(3818), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3820), 1,
      anon_sym_LT,
    STATE(1294), 1,
      sym_comment,
    STATE(3174), 1,
      sym_arguments,
    STATE(3263), 1,
      sym_type_arguments,
    ACTIONS(3806), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3796), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3756), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4749] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(3087), 1,
      anon_sym_abstract,
    ACTIONS(3710), 1,
      anon_sym_export,
    ACTIONS(3712), 1,
      anon_sym_STAR,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3720), 1,
      anon_sym_async,
    ACTIONS(3722), 1,
      anon_sym_new,
    ACTIONS(3724), 1,
      anon_sym_static,
    ACTIONS(3726), 1,
      anon_sym_readonly,
    ACTIONS(3732), 1,
      anon_sym_override,
    STATE(1202), 1,
      sym_decorator,
    STATE(1295), 1,
      sym_comment,
    STATE(2685), 1,
      sym_accessibility_modifier,
    STATE(2769), 1,
      sym_override_modifier,
    STATE(3359), 1,
      sym__property_name,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4331), 1,
      sym__call_signature,
    STATE(4766), 1,
      aux_sym_export_statement_repeat1,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3728), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3868), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4555), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3708), 19,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [4879] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(3087), 1,
      anon_sym_abstract,
    ACTIONS(3710), 1,
      anon_sym_export,
    ACTIONS(3712), 1,
      anon_sym_STAR,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3720), 1,
      anon_sym_async,
    ACTIONS(3722), 1,
      anon_sym_new,
    ACTIONS(3724), 1,
      anon_sym_static,
    ACTIONS(3726), 1,
      anon_sym_readonly,
    ACTIONS(3732), 1,
      anon_sym_override,
    STATE(1202), 1,
      sym_decorator,
    STATE(1296), 1,
      sym_comment,
    STATE(2685), 1,
      sym_accessibility_modifier,
    STATE(2769), 1,
      sym_override_modifier,
    STATE(3359), 1,
      sym__property_name,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4331), 1,
      sym__call_signature,
    STATE(4766), 1,
      aux_sym_export_statement_repeat1,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3728), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3870), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4555), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3708), 19,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [5009] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(3087), 1,
      anon_sym_abstract,
    ACTIONS(3710), 1,
      anon_sym_export,
    ACTIONS(3712), 1,
      anon_sym_STAR,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3720), 1,
      anon_sym_async,
    ACTIONS(3722), 1,
      anon_sym_new,
    ACTIONS(3724), 1,
      anon_sym_static,
    ACTIONS(3726), 1,
      anon_sym_readonly,
    ACTIONS(3732), 1,
      anon_sym_override,
    STATE(1202), 1,
      sym_decorator,
    STATE(1297), 1,
      sym_comment,
    STATE(2685), 1,
      sym_accessibility_modifier,
    STATE(2769), 1,
      sym_override_modifier,
    STATE(3359), 1,
      sym__property_name,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4331), 1,
      sym__call_signature,
    STATE(4766), 1,
      aux_sym_export_statement_repeat1,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3728), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3872), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4555), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3708), 19,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [5139] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(3087), 1,
      anon_sym_abstract,
    ACTIONS(3710), 1,
      anon_sym_export,
    ACTIONS(3712), 1,
      anon_sym_STAR,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3720), 1,
      anon_sym_async,
    ACTIONS(3722), 1,
      anon_sym_new,
    ACTIONS(3724), 1,
      anon_sym_static,
    ACTIONS(3726), 1,
      anon_sym_readonly,
    ACTIONS(3732), 1,
      anon_sym_override,
    STATE(1202), 1,
      sym_decorator,
    STATE(1298), 1,
      sym_comment,
    STATE(2685), 1,
      sym_accessibility_modifier,
    STATE(2769), 1,
      sym_override_modifier,
    STATE(3359), 1,
      sym__property_name,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4331), 1,
      sym__call_signature,
    STATE(4766), 1,
      aux_sym_export_statement_repeat1,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3728), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3874), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4555), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3708), 19,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [5269] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(3087), 1,
      anon_sym_abstract,
    ACTIONS(3710), 1,
      anon_sym_export,
    ACTIONS(3712), 1,
      anon_sym_STAR,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3720), 1,
      anon_sym_async,
    ACTIONS(3722), 1,
      anon_sym_new,
    ACTIONS(3724), 1,
      anon_sym_static,
    ACTIONS(3726), 1,
      anon_sym_readonly,
    ACTIONS(3732), 1,
      anon_sym_override,
    STATE(1202), 1,
      sym_decorator,
    STATE(1299), 1,
      sym_comment,
    STATE(2685), 1,
      sym_accessibility_modifier,
    STATE(2769), 1,
      sym_override_modifier,
    STATE(3359), 1,
      sym__property_name,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4331), 1,
      sym__call_signature,
    STATE(4766), 1,
      aux_sym_export_statement_repeat1,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3728), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3876), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4555), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3708), 19,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [5399] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(3087), 1,
      anon_sym_abstract,
    ACTIONS(3710), 1,
      anon_sym_export,
    ACTIONS(3712), 1,
      anon_sym_STAR,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3720), 1,
      anon_sym_async,
    ACTIONS(3722), 1,
      anon_sym_new,
    ACTIONS(3724), 1,
      anon_sym_static,
    ACTIONS(3726), 1,
      anon_sym_readonly,
    ACTIONS(3732), 1,
      anon_sym_override,
    STATE(1202), 1,
      sym_decorator,
    STATE(1300), 1,
      sym_comment,
    STATE(2685), 1,
      sym_accessibility_modifier,
    STATE(2769), 1,
      sym_override_modifier,
    STATE(3359), 1,
      sym__property_name,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4331), 1,
      sym__call_signature,
    STATE(4766), 1,
      aux_sym_export_statement_repeat1,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3728), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3878), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4555), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3708), 19,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [5529] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(3087), 1,
      anon_sym_abstract,
    ACTIONS(3710), 1,
      anon_sym_export,
    ACTIONS(3712), 1,
      anon_sym_STAR,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3720), 1,
      anon_sym_async,
    ACTIONS(3722), 1,
      anon_sym_new,
    ACTIONS(3724), 1,
      anon_sym_static,
    ACTIONS(3726), 1,
      anon_sym_readonly,
    ACTIONS(3732), 1,
      anon_sym_override,
    STATE(1202), 1,
      sym_decorator,
    STATE(1301), 1,
      sym_comment,
    STATE(2685), 1,
      sym_accessibility_modifier,
    STATE(2769), 1,
      sym_override_modifier,
    STATE(3359), 1,
      sym__property_name,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4331), 1,
      sym__call_signature,
    STATE(4766), 1,
      aux_sym_export_statement_repeat1,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3728), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3880), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4555), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3708), 19,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [5659] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(58), 1,
      anon_sym_DQUOTE,
    ACTIONS(60), 1,
      anon_sym_SQUOTE,
    ACTIONS(863), 1,
      anon_sym_EQ,
    ACTIONS(1053), 1,
      anon_sym_EQ_GT,
    ACTIONS(3666), 1,
      sym_identifier,
    STATE(1302), 1,
      sym_comment,
    STATE(1867), 1,
      sym_string,
    STATE(1868), 1,
      sym_nested_identifier,
    STATE(1996), 1,
      sym__module,
    ACTIONS(70), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [5751] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(3087), 1,
      anon_sym_abstract,
    ACTIONS(3710), 1,
      anon_sym_export,
    ACTIONS(3712), 1,
      anon_sym_STAR,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3720), 1,
      anon_sym_async,
    ACTIONS(3722), 1,
      anon_sym_new,
    ACTIONS(3724), 1,
      anon_sym_static,
    ACTIONS(3726), 1,
      anon_sym_readonly,
    ACTIONS(3732), 1,
      anon_sym_override,
    STATE(1202), 1,
      sym_decorator,
    STATE(1303), 1,
      sym_comment,
    STATE(2685), 1,
      sym_accessibility_modifier,
    STATE(2769), 1,
      sym_override_modifier,
    STATE(3359), 1,
      sym__property_name,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4331), 1,
      sym__call_signature,
    STATE(4766), 1,
      aux_sym_export_statement_repeat1,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3728), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3882), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4555), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3708), 19,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [5881] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3761), 1,
      anon_sym_EQ_GT,
    ACTIONS(3814), 1,
      anon_sym_LPAREN,
    ACTIONS(3816), 1,
      anon_sym_DOT,
    ACTIONS(3818), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3820), 1,
      anon_sym_LT,
    ACTIONS(3884), 1,
      anon_sym_EQ,
    STATE(1304), 1,
      sym_comment,
    STATE(3174), 1,
      sym_arguments,
    STATE(3263), 1,
      sym_type_arguments,
    ACTIONS(3796), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3806), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3756), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5977] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(3087), 1,
      anon_sym_abstract,
    ACTIONS(3710), 1,
      anon_sym_export,
    ACTIONS(3712), 1,
      anon_sym_STAR,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3720), 1,
      anon_sym_async,
    ACTIONS(3722), 1,
      anon_sym_new,
    ACTIONS(3724), 1,
      anon_sym_static,
    ACTIONS(3726), 1,
      anon_sym_readonly,
    ACTIONS(3732), 1,
      anon_sym_override,
    STATE(1202), 1,
      sym_decorator,
    STATE(1305), 1,
      sym_comment,
    STATE(2685), 1,
      sym_accessibility_modifier,
    STATE(2769), 1,
      sym_override_modifier,
    STATE(3359), 1,
      sym__property_name,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4331), 1,
      sym__call_signature,
    STATE(4766), 1,
      aux_sym_export_statement_repeat1,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3728), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3886), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4555), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3708), 19,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [6107] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(58), 1,
      anon_sym_DQUOTE,
    ACTIONS(60), 1,
      anon_sym_SQUOTE,
    ACTIONS(1047), 1,
      anon_sym_EQ,
    ACTIONS(1053), 1,
      anon_sym_EQ_GT,
    ACTIONS(3666), 1,
      sym_identifier,
    STATE(1306), 1,
      sym_comment,
    STATE(1867), 1,
      sym_string,
    STATE(1868), 1,
      sym_nested_identifier,
    STATE(1996), 1,
      sym__module,
    ACTIONS(70), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 25,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [6199] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(58), 1,
      anon_sym_DQUOTE,
    ACTIONS(60), 1,
      anon_sym_SQUOTE,
    ACTIONS(863), 1,
      anon_sym_EQ,
    ACTIONS(980), 1,
      anon_sym_EQ_GT,
    ACTIONS(3666), 1,
      sym_identifier,
    STATE(1307), 1,
      sym_comment,
    STATE(1867), 1,
      sym_string,
    STATE(1868), 1,
      sym_nested_identifier,
    STATE(1996), 1,
      sym__module,
    ACTIONS(70), 13,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [6291] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1308), 1,
      sym_comment,
    ACTIONS(2611), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2613), 38,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [6365] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1309), 1,
      sym_comment,
    ACTIONS(2619), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2621), 38,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [6439] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3802), 1,
      anon_sym_EQ_GT,
    ACTIONS(3830), 1,
      anon_sym_LBRACK,
    ACTIONS(3848), 1,
      anon_sym_EQ,
    ACTIONS(3888), 1,
      anon_sym_DOT,
    ACTIONS(3891), 1,
      anon_sym_LT,
    STATE(1310), 1,
      sym_comment,
    STATE(3502), 1,
      sym_type_arguments,
    ACTIONS(3833), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3851), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3842), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3756), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6533] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3894), 1,
      anon_sym_EQ,
    STATE(1311), 1,
      sym_comment,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3756), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [6611] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3814), 1,
      anon_sym_LPAREN,
    ACTIONS(3816), 1,
      anon_sym_DOT,
    ACTIONS(3818), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3820), 1,
      anon_sym_LT,
    ACTIONS(3896), 1,
      anon_sym_EQ,
    ACTIONS(3898), 1,
      anon_sym_EQ_GT,
    STATE(1312), 1,
      sym_comment,
    STATE(3174), 1,
      sym_arguments,
    STATE(3263), 1,
      sym_type_arguments,
    ACTIONS(3796), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3806), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3756), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6707] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(3087), 1,
      anon_sym_abstract,
    ACTIONS(3710), 1,
      anon_sym_export,
    ACTIONS(3712), 1,
      anon_sym_STAR,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3720), 1,
      anon_sym_async,
    ACTIONS(3722), 1,
      anon_sym_new,
    ACTIONS(3724), 1,
      anon_sym_static,
    ACTIONS(3726), 1,
      anon_sym_readonly,
    ACTIONS(3732), 1,
      anon_sym_override,
    STATE(1202), 1,
      sym_decorator,
    STATE(1313), 1,
      sym_comment,
    STATE(2685), 1,
      sym_accessibility_modifier,
    STATE(2769), 1,
      sym_override_modifier,
    STATE(3359), 1,
      sym__property_name,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4331), 1,
      sym__call_signature,
    STATE(4766), 1,
      aux_sym_export_statement_repeat1,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3728), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3900), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4555), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3708), 19,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [6837] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(3087), 1,
      anon_sym_abstract,
    ACTIONS(3710), 1,
      anon_sym_export,
    ACTIONS(3712), 1,
      anon_sym_STAR,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3720), 1,
      anon_sym_async,
    ACTIONS(3722), 1,
      anon_sym_new,
    ACTIONS(3724), 1,
      anon_sym_static,
    ACTIONS(3726), 1,
      anon_sym_readonly,
    ACTIONS(3732), 1,
      anon_sym_override,
    STATE(1202), 1,
      sym_decorator,
    STATE(1314), 1,
      sym_comment,
    STATE(2685), 1,
      sym_accessibility_modifier,
    STATE(2769), 1,
      sym_override_modifier,
    STATE(3359), 1,
      sym__property_name,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4331), 1,
      sym__call_signature,
    STATE(4766), 1,
      aux_sym_export_statement_repeat1,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3728), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3902), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4555), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3708), 19,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [6967] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(58), 1,
      anon_sym_DQUOTE,
    ACTIONS(60), 1,
      anon_sym_SQUOTE,
    ACTIONS(139), 1,
      anon_sym_EQ_GT,
    ACTIONS(1113), 1,
      anon_sym_EQ,
    ACTIONS(3666), 1,
      sym_identifier,
    STATE(1315), 1,
      sym_comment,
    STATE(1867), 1,
      sym_string,
    STATE(1868), 1,
      sym_nested_identifier,
    STATE(1996), 1,
      sym__module,
    ACTIONS(70), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [7058] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(27), 1,
      anon_sym_EQ,
    ACTIONS(68), 1,
      anon_sym_EQ_GT,
    ACTIONS(823), 1,
      anon_sym_QMARK,
    STATE(1316), 1,
      sym_comment,
    ACTIONS(36), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(70), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7141] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(58), 1,
      anon_sym_DQUOTE,
    ACTIONS(60), 1,
      anon_sym_SQUOTE,
    ACTIONS(139), 1,
      anon_sym_EQ_GT,
    ACTIONS(1117), 1,
      anon_sym_EQ,
    ACTIONS(3666), 1,
      sym_identifier,
    STATE(1317), 1,
      sym_comment,
    STATE(1867), 1,
      sym_string,
    STATE(1868), 1,
      sym_nested_identifier,
    STATE(1996), 1,
      sym__module,
    ACTIONS(70), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [7232] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(58), 1,
      anon_sym_DQUOTE,
    ACTIONS(60), 1,
      anon_sym_SQUOTE,
    ACTIONS(139), 1,
      anon_sym_EQ_GT,
    ACTIONS(863), 1,
      anon_sym_EQ,
    ACTIONS(3666), 1,
      sym_identifier,
    STATE(1318), 1,
      sym_comment,
    STATE(1867), 1,
      sym_string,
    STATE(1868), 1,
      sym_nested_identifier,
    STATE(1996), 1,
      sym__module,
    ACTIONS(70), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [7323] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3814), 1,
      anon_sym_LPAREN,
    ACTIONS(3816), 1,
      anon_sym_DOT,
    ACTIONS(3818), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3820), 1,
      anon_sym_LT,
    ACTIONS(3904), 1,
      anon_sym_EQ,
    ACTIONS(3906), 1,
      anon_sym_EQ_GT,
    STATE(1319), 1,
      sym_comment,
    STATE(3174), 1,
      sym_arguments,
    STATE(3263), 1,
      sym_type_arguments,
    ACTIONS(3796), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3806), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3756), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7418] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3894), 1,
      anon_sym_EQ,
    ACTIONS(3910), 1,
      anon_sym_EQ_GT,
    ACTIONS(3912), 1,
      anon_sym_QMARK,
    STATE(1320), 1,
      sym_comment,
    ACTIONS(3908), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3756), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7501] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3794), 1,
      anon_sym_EQ,
    ACTIONS(3802), 1,
      anon_sym_EQ_GT,
    ACTIONS(3814), 1,
      anon_sym_LPAREN,
    ACTIONS(3816), 1,
      anon_sym_DOT,
    ACTIONS(3818), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3820), 1,
      anon_sym_LT,
    STATE(1321), 1,
      sym_comment,
    STATE(3174), 1,
      sym_arguments,
    STATE(3263), 1,
      sym_type_arguments,
    ACTIONS(3806), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
    ACTIONS(3796), 4,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(3756), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7596] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(58), 1,
      anon_sym_DQUOTE,
    ACTIONS(60), 1,
      anon_sym_SQUOTE,
    ACTIONS(139), 1,
      anon_sym_EQ_GT,
    ACTIONS(1119), 1,
      anon_sym_EQ,
    ACTIONS(3666), 1,
      sym_identifier,
    STATE(1322), 1,
      sym_comment,
    STATE(1867), 1,
      sym_string,
    STATE(1868), 1,
      sym_nested_identifier,
    STATE(1996), 1,
      sym__module,
    ACTIONS(70), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [7687] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(58), 1,
      anon_sym_DQUOTE,
    ACTIONS(60), 1,
      anon_sym_SQUOTE,
    ACTIONS(139), 1,
      anon_sym_EQ_GT,
    ACTIONS(1127), 1,
      anon_sym_EQ,
    ACTIONS(3666), 1,
      sym_identifier,
    STATE(1323), 1,
      sym_comment,
    STATE(1867), 1,
      sym_string,
    STATE(1868), 1,
      sym_nested_identifier,
    STATE(1996), 1,
      sym__module,
    ACTIONS(70), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [7778] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3802), 1,
      anon_sym_EQ_GT,
    ACTIONS(3848), 1,
      anon_sym_EQ,
    ACTIONS(3917), 1,
      anon_sym_QMARK,
    STATE(1324), 1,
      sym_comment,
    ACTIONS(3914), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3756), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7861] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(27), 1,
      anon_sym_EQ,
    ACTIONS(68), 1,
      anon_sym_EQ_GT,
    ACTIONS(3919), 1,
      anon_sym_LBRACK,
    STATE(1325), 1,
      sym_comment,
    ACTIONS(3922), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1709), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(70), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7946] = 17,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3830), 1,
      anon_sym_LBRACK,
    ACTIONS(3836), 1,
      anon_sym_DOT,
    ACTIONS(3839), 1,
      anon_sym_LT,
    ACTIONS(3842), 1,
      anon_sym_extends,
    ACTIONS(3910), 1,
      anon_sym_EQ_GT,
    ACTIONS(3917), 1,
      anon_sym_QMARK,
    ACTIONS(3925), 1,
      anon_sym_EQ,
    ACTIONS(3930), 1,
      anon_sym_RPAREN,
    STATE(1326), 1,
      sym_comment,
    STATE(3240), 1,
      sym_type_arguments,
    ACTIONS(3833), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3928), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3756), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8043] = 17,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3802), 1,
      anon_sym_EQ_GT,
    ACTIONS(3830), 1,
      anon_sym_LBRACK,
    ACTIONS(3836), 1,
      anon_sym_DOT,
    ACTIONS(3839), 1,
      anon_sym_LT,
    ACTIONS(3842), 1,
      anon_sym_extends,
    ACTIONS(3848), 1,
      anon_sym_EQ,
    ACTIONS(3851), 1,
      anon_sym_RPAREN,
    ACTIONS(3917), 1,
      anon_sym_QMARK,
    STATE(1327), 1,
      sym_comment,
    STATE(3240), 1,
      sym_type_arguments,
    ACTIONS(3833), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3914), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3756), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8140] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(139), 1,
      anon_sym_EQ_GT,
    ACTIONS(863), 1,
      anon_sym_EQ,
    ACTIONS(875), 1,
      anon_sym_QMARK,
    STATE(1328), 1,
      sym_comment,
    ACTIONS(867), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(70), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8223] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1329), 1,
      sym_comment,
    ACTIONS(3774), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3776), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [8296] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(134), 1,
      anon_sym_EQ,
    ACTIONS(139), 1,
      anon_sym_EQ_GT,
    ACTIONS(823), 1,
      anon_sym_QMARK,
    STATE(1330), 1,
      sym_comment,
    ACTIONS(137), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(70), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8379] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1331), 1,
      sym_comment,
    ACTIONS(3770), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3772), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [8452] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(58), 1,
      anon_sym_DQUOTE,
    ACTIONS(60), 1,
      anon_sym_SQUOTE,
    ACTIONS(139), 1,
      anon_sym_EQ_GT,
    ACTIONS(1125), 1,
      anon_sym_EQ,
    ACTIONS(3666), 1,
      sym_identifier,
    STATE(1332), 1,
      sym_comment,
    STATE(1867), 1,
      sym_string,
    STATE(1868), 1,
      sym_nested_identifier,
    STATE(1996), 1,
      sym__module,
    ACTIONS(70), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [8543] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3836), 1,
      anon_sym_DOT,
    ACTIONS(3839), 1,
      anon_sym_LT,
    ACTIONS(3842), 1,
      anon_sym_extends,
    ACTIONS(3896), 1,
      anon_sym_EQ,
    ACTIONS(3898), 1,
      anon_sym_EQ_GT,
    STATE(1333), 1,
      sym_comment,
    STATE(3240), 1,
      sym_type_arguments,
    ACTIONS(3830), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3833), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3756), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3752), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8634] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(58), 1,
      anon_sym_DQUOTE,
    ACTIONS(60), 1,
      anon_sym_SQUOTE,
    ACTIONS(139), 1,
      anon_sym_EQ_GT,
    ACTIONS(1059), 1,
      anon_sym_EQ,
    ACTIONS(3666), 1,
      sym_identifier,
    STATE(1334), 1,
      sym_comment,
    STATE(1867), 1,
      sym_string,
    STATE(1868), 1,
      sym_nested_identifier,
    STATE(1996), 1,
      sym__module,
    ACTIONS(70), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [8725] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(139), 1,
      anon_sym_EQ_GT,
    ACTIONS(863), 1,
      anon_sym_EQ,
    ACTIONS(984), 1,
      anon_sym_in,
    ACTIONS(3055), 1,
      anon_sym_LBRACE,
    ACTIONS(3692), 1,
      anon_sym_of,
    ACTIONS(3933), 1,
      sym_identifier,
    ACTIONS(3935), 1,
      anon_sym_LBRACK,
    STATE(1335), 1,
      sym_comment,
    STATE(5824), 1,
      sym__destructuring_pattern,
    STATE(3599), 2,
      sym_object_pattern,
      sym_array_pattern,
    ACTIONS(70), 11,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [8818] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(58), 1,
      anon_sym_DQUOTE,
    ACTIONS(60), 1,
      anon_sym_SQUOTE,
    ACTIONS(139), 1,
      anon_sym_EQ_GT,
    ACTIONS(1115), 1,
      anon_sym_EQ,
    ACTIONS(3666), 1,
      sym_identifier,
    STATE(1336), 1,
      sym_comment,
    STATE(1867), 1,
      sym_string,
    STATE(1868), 1,
      sym_nested_identifier,
    STATE(1996), 1,
      sym__module,
    ACTIONS(70), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [8909] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(58), 1,
      anon_sym_DQUOTE,
    ACTIONS(60), 1,
      anon_sym_SQUOTE,
    ACTIONS(139), 1,
      anon_sym_EQ_GT,
    ACTIONS(1121), 1,
      anon_sym_EQ,
    ACTIONS(3666), 1,
      sym_identifier,
    STATE(1337), 1,
      sym_comment,
    STATE(1867), 1,
      sym_string,
    STATE(1868), 1,
      sym_nested_identifier,
    STATE(1996), 1,
      sym__module,
    ACTIONS(70), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [9000] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3910), 1,
      anon_sym_EQ_GT,
    ACTIONS(3917), 1,
      anon_sym_QMARK,
    ACTIONS(3925), 1,
      anon_sym_EQ,
    STATE(1338), 1,
      sym_comment,
    ACTIONS(3928), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3756), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9083] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3761), 1,
      anon_sym_EQ_GT,
    ACTIONS(3836), 1,
      anon_sym_DOT,
    ACTIONS(3839), 1,
      anon_sym_LT,
    ACTIONS(3842), 1,
      anon_sym_extends,
    ACTIONS(3884), 1,
      anon_sym_EQ,
    STATE(1339), 1,
      sym_comment,
    STATE(3240), 1,
      sym_type_arguments,
    ACTIONS(3830), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3833), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3756), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3752), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9174] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(68), 1,
      anon_sym_EQ_GT,
    ACTIONS(877), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_extends,
    STATE(1340), 1,
      sym_comment,
    ACTIONS(3919), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3922), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(70), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [9259] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(58), 1,
      anon_sym_DQUOTE,
    ACTIONS(60), 1,
      anon_sym_SQUOTE,
    ACTIONS(139), 1,
      anon_sym_EQ_GT,
    ACTIONS(1123), 1,
      anon_sym_EQ,
    ACTIONS(3666), 1,
      sym_identifier,
    STATE(1341), 1,
      sym_comment,
    STATE(1867), 1,
      sym_string,
    STATE(1868), 1,
      sym_nested_identifier,
    STATE(1996), 1,
      sym__module,
    ACTIONS(70), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [9350] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3814), 1,
      anon_sym_LPAREN,
    ACTIONS(3816), 1,
      anon_sym_DOT,
    ACTIONS(3818), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3820), 1,
      anon_sym_LT,
    ACTIONS(3938), 1,
      anon_sym_EQ,
    ACTIONS(3940), 1,
      anon_sym_EQ_GT,
    STATE(1342), 1,
      sym_comment,
    STATE(3174), 1,
      sym_arguments,
    STATE(3263), 1,
      sym_type_arguments,
    ACTIONS(3796), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3806), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3756), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9445] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(134), 1,
      anon_sym_EQ,
    ACTIONS(139), 1,
      anon_sym_EQ_GT,
    ACTIONS(823), 1,
      anon_sym_QMARK,
    ACTIONS(3919), 1,
      anon_sym_LBRACK,
    STATE(1343), 1,
      sym_comment,
    ACTIONS(137), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1709), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(3922), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(70), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9533] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(68), 1,
      anon_sym_EQ_GT,
    ACTIONS(877), 1,
      anon_sym_EQ,
    STATE(1344), 1,
      sym_comment,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(70), 20,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(30), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9611] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2484), 1,
      anon_sym_LBRACE,
    ACTIONS(3761), 1,
      anon_sym_EQ_GT,
    ACTIONS(3884), 1,
      anon_sym_EQ,
    ACTIONS(3942), 1,
      anon_sym_DOT,
    STATE(1345), 1,
      sym_comment,
    STATE(2843), 1,
      sym_ui_object_initializer,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3756), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9695] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(767), 1,
      anon_sym_EQ_GT,
    ACTIONS(911), 1,
      anon_sym_EQ,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    ACTIONS(2491), 1,
      anon_sym_LBRACE,
    STATE(1346), 1,
      sym_comment,
    STATE(5893), 1,
      sym_ui_object_initializer,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(70), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(30), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9779] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3814), 1,
      anon_sym_LPAREN,
    ACTIONS(3816), 1,
      anon_sym_DOT,
    ACTIONS(3818), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3820), 1,
      anon_sym_LT,
    ACTIONS(3945), 1,
      anon_sym_EQ,
    ACTIONS(3947), 1,
      anon_sym_EQ_GT,
    STATE(1347), 1,
      sym_comment,
    STATE(3174), 1,
      sym_arguments,
    STATE(3263), 1,
      sym_type_arguments,
    ACTIONS(3796), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3806), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3756), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9873] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(68), 1,
      anon_sym_EQ_GT,
    ACTIONS(863), 1,
      anon_sym_EQ,
    STATE(1348), 1,
      sym_comment,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(70), 20,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(30), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9951] = 32,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(3087), 1,
      anon_sym_abstract,
    ACTIONS(3710), 1,
      anon_sym_export,
    ACTIONS(3712), 1,
      anon_sym_STAR,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3720), 1,
      anon_sym_async,
    ACTIONS(3722), 1,
      anon_sym_new,
    ACTIONS(3724), 1,
      anon_sym_static,
    ACTIONS(3726), 1,
      anon_sym_readonly,
    ACTIONS(3732), 1,
      anon_sym_override,
    STATE(1202), 1,
      sym_decorator,
    STATE(1349), 1,
      sym_comment,
    STATE(2685), 1,
      sym_accessibility_modifier,
    STATE(2769), 1,
      sym_override_modifier,
    STATE(3359), 1,
      sym__property_name,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4331), 1,
      sym__call_signature,
    STATE(4766), 1,
      aux_sym_export_statement_repeat1,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3728), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4087), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3708), 19,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [10077] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(27), 1,
      anon_sym_EQ,
    ACTIONS(68), 1,
      anon_sym_EQ_GT,
    ACTIONS(823), 1,
      anon_sym_QMARK,
    ACTIONS(3919), 1,
      anon_sym_LBRACK,
    STATE(1350), 1,
      sym_comment,
    ACTIONS(36), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1709), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(3922), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(70), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10165] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3917), 1,
      anon_sym_QMARK,
    ACTIONS(3925), 1,
      anon_sym_EQ,
    STATE(1351), 1,
      sym_comment,
    ACTIONS(3928), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3756), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10245] = 32,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(3087), 1,
      anon_sym_abstract,
    ACTIONS(3710), 1,
      anon_sym_export,
    ACTIONS(3712), 1,
      anon_sym_STAR,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3720), 1,
      anon_sym_async,
    ACTIONS(3722), 1,
      anon_sym_new,
    ACTIONS(3724), 1,
      anon_sym_static,
    ACTIONS(3726), 1,
      anon_sym_readonly,
    ACTIONS(3732), 1,
      anon_sym_override,
    STATE(1202), 1,
      sym_decorator,
    STATE(1352), 1,
      sym_comment,
    STATE(2685), 1,
      sym_accessibility_modifier,
    STATE(2769), 1,
      sym_override_modifier,
    STATE(3359), 1,
      sym__property_name,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4331), 1,
      sym__call_signature,
    STATE(4766), 1,
      aux_sym_export_statement_repeat1,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3728), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4152), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3708), 19,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [10371] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(767), 1,
      anon_sym_EQ_GT,
    ACTIONS(911), 1,
      anon_sym_EQ,
    ACTIONS(913), 1,
      anon_sym_COLON,
    ACTIONS(3734), 1,
      sym_identifier,
    STATE(1353), 1,
      sym_comment,
    ACTIONS(70), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [10453] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3814), 1,
      anon_sym_LPAREN,
    ACTIONS(3816), 1,
      anon_sym_DOT,
    ACTIONS(3818), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3820), 1,
      anon_sym_LT,
    ACTIONS(3894), 1,
      anon_sym_EQ,
    ACTIONS(3910), 1,
      anon_sym_EQ_GT,
    STATE(1354), 1,
      sym_comment,
    STATE(3174), 1,
      sym_arguments,
    STATE(3263), 1,
      sym_type_arguments,
    ACTIONS(3806), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3796), 4,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(3756), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10547] = 32,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(3087), 1,
      anon_sym_abstract,
    ACTIONS(3710), 1,
      anon_sym_export,
    ACTIONS(3712), 1,
      anon_sym_STAR,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3720), 1,
      anon_sym_async,
    ACTIONS(3722), 1,
      anon_sym_new,
    ACTIONS(3724), 1,
      anon_sym_static,
    ACTIONS(3726), 1,
      anon_sym_readonly,
    ACTIONS(3732), 1,
      anon_sym_override,
    STATE(1202), 1,
      sym_decorator,
    STATE(1355), 1,
      sym_comment,
    STATE(2685), 1,
      sym_accessibility_modifier,
    STATE(2769), 1,
      sym_override_modifier,
    STATE(3359), 1,
      sym__property_name,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4331), 1,
      sym__call_signature,
    STATE(4766), 1,
      aux_sym_export_statement_repeat1,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3728), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4053), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3708), 19,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [10673] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(767), 1,
      anon_sym_EQ_GT,
    ACTIONS(911), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_extends,
    STATE(1356), 1,
      sym_comment,
    ACTIONS(3919), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3922), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(70), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(30), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10757] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2491), 1,
      anon_sym_LBRACE,
    ACTIONS(3761), 1,
      anon_sym_EQ_GT,
    ACTIONS(3884), 1,
      anon_sym_EQ,
    ACTIONS(3942), 1,
      anon_sym_DOT,
    STATE(1357), 1,
      sym_comment,
    STATE(5892), 1,
      sym_ui_object_initializer,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3756), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10841] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(767), 1,
      anon_sym_EQ_GT,
    ACTIONS(911), 1,
      anon_sym_EQ,
    ACTIONS(925), 1,
      anon_sym_COLON,
    ACTIONS(3734), 1,
      sym_identifier,
    STATE(1358), 1,
      sym_comment,
    ACTIONS(70), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [10923] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3830), 1,
      anon_sym_LBRACK,
    ACTIONS(3836), 1,
      anon_sym_DOT,
    ACTIONS(3839), 1,
      anon_sym_LT,
    ACTIONS(3938), 1,
      anon_sym_EQ,
    ACTIONS(3940), 1,
      anon_sym_EQ_GT,
    STATE(1359), 1,
      sym_comment,
    STATE(3240), 1,
      sym_type_arguments,
    ACTIONS(3842), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3833), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3756), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11013] = 32,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(3087), 1,
      anon_sym_abstract,
    ACTIONS(3710), 1,
      anon_sym_export,
    ACTIONS(3712), 1,
      anon_sym_STAR,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3720), 1,
      anon_sym_async,
    ACTIONS(3722), 1,
      anon_sym_new,
    ACTIONS(3724), 1,
      anon_sym_static,
    ACTIONS(3726), 1,
      anon_sym_readonly,
    ACTIONS(3732), 1,
      anon_sym_override,
    STATE(1202), 1,
      sym_decorator,
    STATE(1360), 1,
      sym_comment,
    STATE(2685), 1,
      sym_accessibility_modifier,
    STATE(2769), 1,
      sym_override_modifier,
    STATE(3359), 1,
      sym__property_name,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4331), 1,
      sym__call_signature,
    STATE(4766), 1,
      aux_sym_export_statement_repeat1,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3728), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4095), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3708), 19,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [11139] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3814), 1,
      anon_sym_LPAREN,
    ACTIONS(3816), 1,
      anon_sym_DOT,
    ACTIONS(3818), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3820), 1,
      anon_sym_LT,
    ACTIONS(3949), 1,
      anon_sym_EQ,
    ACTIONS(3951), 1,
      anon_sym_EQ_GT,
    STATE(1361), 1,
      sym_comment,
    STATE(3174), 1,
      sym_arguments,
    STATE(3263), 1,
      sym_type_arguments,
    ACTIONS(3796), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3806), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3756), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11233] = 32,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(3087), 1,
      anon_sym_abstract,
    ACTIONS(3710), 1,
      anon_sym_export,
    ACTIONS(3712), 1,
      anon_sym_STAR,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3720), 1,
      anon_sym_async,
    ACTIONS(3722), 1,
      anon_sym_new,
    ACTIONS(3724), 1,
      anon_sym_static,
    ACTIONS(3726), 1,
      anon_sym_readonly,
    ACTIONS(3732), 1,
      anon_sym_override,
    STATE(1202), 1,
      sym_decorator,
    STATE(1362), 1,
      sym_comment,
    STATE(2685), 1,
      sym_accessibility_modifier,
    STATE(2769), 1,
      sym_override_modifier,
    STATE(3359), 1,
      sym__property_name,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4331), 1,
      sym__call_signature,
    STATE(4766), 1,
      aux_sym_export_statement_repeat1,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3728), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4101), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3708), 19,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [11359] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3794), 1,
      anon_sym_EQ,
    ACTIONS(3802), 1,
      anon_sym_EQ_GT,
    ACTIONS(3830), 1,
      anon_sym_LBRACK,
    ACTIONS(3836), 1,
      anon_sym_DOT,
    ACTIONS(3839), 1,
      anon_sym_LT,
    ACTIONS(3842), 1,
      anon_sym_extends,
    ACTIONS(3908), 1,
      anon_sym_COLON,
    STATE(1363), 1,
      sym_comment,
    STATE(3240), 1,
      sym_type_arguments,
    ACTIONS(3833), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3953), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(3756), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11453] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(767), 1,
      anon_sym_EQ_GT,
    ACTIONS(911), 1,
      anon_sym_EQ,
    ACTIONS(923), 1,
      anon_sym_COLON,
    ACTIONS(3957), 1,
      sym_identifier,
    STATE(1364), 1,
      sym_comment,
    ACTIONS(70), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [11535] = 32,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(3087), 1,
      anon_sym_abstract,
    ACTIONS(3710), 1,
      anon_sym_export,
    ACTIONS(3712), 1,
      anon_sym_STAR,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3720), 1,
      anon_sym_async,
    ACTIONS(3722), 1,
      anon_sym_new,
    ACTIONS(3724), 1,
      anon_sym_static,
    ACTIONS(3726), 1,
      anon_sym_readonly,
    ACTIONS(3732), 1,
      anon_sym_override,
    STATE(1202), 1,
      sym_decorator,
    STATE(1365), 1,
      sym_comment,
    STATE(2685), 1,
      sym_accessibility_modifier,
    STATE(2769), 1,
      sym_override_modifier,
    STATE(3359), 1,
      sym__property_name,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4331), 1,
      sym__call_signature,
    STATE(4766), 1,
      aux_sym_export_statement_repeat1,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3728), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4555), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3708), 19,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [11661] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3830), 1,
      anon_sym_LBRACK,
    ACTIONS(3836), 1,
      anon_sym_DOT,
    ACTIONS(3839), 1,
      anon_sym_LT,
    ACTIONS(3894), 1,
      anon_sym_EQ,
    ACTIONS(3908), 1,
      anon_sym_COLON,
    ACTIONS(3910), 1,
      anon_sym_EQ_GT,
    STATE(1366), 1,
      sym_comment,
    STATE(3240), 1,
      sym_type_arguments,
    ACTIONS(3833), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3842), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(3756), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11753] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3794), 1,
      anon_sym_EQ,
    ACTIONS(3802), 1,
      anon_sym_EQ_GT,
    STATE(1367), 1,
      sym_comment,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3756), 20,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11831] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(767), 1,
      anon_sym_EQ_GT,
    ACTIONS(911), 1,
      anon_sym_EQ,
    ACTIONS(2484), 1,
      anon_sym_LBRACE,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    STATE(1368), 1,
      sym_comment,
    STATE(2802), 1,
      sym_ui_object_initializer,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(70), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(30), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11915] = 32,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(3087), 1,
      anon_sym_abstract,
    ACTIONS(3710), 1,
      anon_sym_export,
    ACTIONS(3712), 1,
      anon_sym_STAR,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3720), 1,
      anon_sym_async,
    ACTIONS(3722), 1,
      anon_sym_new,
    ACTIONS(3724), 1,
      anon_sym_static,
    ACTIONS(3726), 1,
      anon_sym_readonly,
    ACTIONS(3732), 1,
      anon_sym_override,
    STATE(1202), 1,
      sym_decorator,
    STATE(1369), 1,
      sym_comment,
    STATE(2685), 1,
      sym_accessibility_modifier,
    STATE(2769), 1,
      sym_override_modifier,
    STATE(3359), 1,
      sym__property_name,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4331), 1,
      sym__call_signature,
    STATE(4766), 1,
      aux_sym_export_statement_repeat1,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3728), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4109), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3708), 19,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [12041] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3802), 1,
      anon_sym_EQ_GT,
    ACTIONS(3894), 1,
      anon_sym_EQ,
    STATE(1370), 1,
      sym_comment,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3756), 20,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12119] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(952), 1,
      anon_sym_EQ,
    ACTIONS(958), 1,
      anon_sym_EQ_GT,
    ACTIONS(1709), 1,
      anon_sym_extends,
    STATE(1371), 1,
      sym_comment,
    ACTIONS(3919), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3922), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(70), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(30), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12203] = 32,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(3087), 1,
      anon_sym_abstract,
    ACTIONS(3710), 1,
      anon_sym_export,
    ACTIONS(3712), 1,
      anon_sym_STAR,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3720), 1,
      anon_sym_async,
    ACTIONS(3722), 1,
      anon_sym_new,
    ACTIONS(3724), 1,
      anon_sym_static,
    ACTIONS(3726), 1,
      anon_sym_readonly,
    ACTIONS(3732), 1,
      anon_sym_override,
    STATE(1202), 1,
      sym_decorator,
    STATE(1372), 1,
      sym_comment,
    STATE(2685), 1,
      sym_accessibility_modifier,
    STATE(2769), 1,
      sym_override_modifier,
    STATE(3359), 1,
      sym__property_name,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4331), 1,
      sym__call_signature,
    STATE(4766), 1,
      aux_sym_export_statement_repeat1,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3728), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4016), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3708), 19,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [12329] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3848), 1,
      anon_sym_EQ,
    ACTIONS(3917), 1,
      anon_sym_QMARK,
    STATE(1373), 1,
      sym_comment,
    ACTIONS(3914), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3756), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12409] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3836), 1,
      anon_sym_DOT,
    ACTIONS(3839), 1,
      anon_sym_LT,
    ACTIONS(3842), 1,
      anon_sym_extends,
    ACTIONS(3904), 1,
      anon_sym_EQ,
    ACTIONS(3906), 1,
      anon_sym_EQ_GT,
    STATE(1374), 1,
      sym_comment,
    STATE(3240), 1,
      sym_type_arguments,
    ACTIONS(3830), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3833), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3756), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12499] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3894), 1,
      anon_sym_EQ,
    ACTIONS(3912), 1,
      anon_sym_QMARK,
    STATE(1375), 1,
      sym_comment,
    ACTIONS(3908), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3756), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12579] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3814), 1,
      anon_sym_LPAREN,
    ACTIONS(3816), 1,
      anon_sym_DOT,
    ACTIONS(3818), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3820), 1,
      anon_sym_LT,
    ACTIONS(3959), 1,
      anon_sym_EQ,
    ACTIONS(3961), 1,
      anon_sym_EQ_GT,
    STATE(1376), 1,
      sym_comment,
    STATE(3174), 1,
      sym_arguments,
    STATE(3263), 1,
      sym_type_arguments,
    ACTIONS(3796), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3806), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3756), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12673] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(139), 1,
      anon_sym_EQ_GT,
    ACTIONS(863), 1,
      anon_sym_EQ,
    ACTIONS(867), 1,
      anon_sym_COLON,
    ACTIONS(3919), 1,
      anon_sym_LBRACK,
    STATE(1377), 1,
      sym_comment,
    ACTIONS(3922), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1709), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(70), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12758] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3814), 1,
      anon_sym_LPAREN,
    ACTIONS(3816), 1,
      anon_sym_DOT,
    ACTIONS(3818), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3820), 1,
      anon_sym_LT,
    ACTIONS(3894), 1,
      anon_sym_EQ,
    ACTIONS(3910), 1,
      anon_sym_EQ_GT,
    STATE(1378), 1,
      sym_comment,
    STATE(3174), 1,
      sym_arguments,
    STATE(3263), 1,
      sym_type_arguments,
    ACTIONS(3796), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3806), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3756), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12851] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2484), 1,
      anon_sym_LBRACE,
    ACTIONS(3802), 1,
      anon_sym_EQ_GT,
    ACTIONS(3848), 1,
      anon_sym_EQ,
    ACTIONS(3942), 1,
      anon_sym_DOT,
    STATE(1379), 1,
      sym_comment,
    STATE(2843), 1,
      sym_ui_object_initializer,
    ACTIONS(3914), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(3756), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12936] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1380), 1,
      sym_comment,
    ACTIONS(3770), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3772), 35,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [13007] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1381), 1,
      sym_comment,
    ACTIONS(3774), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3776), 35,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [13078] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1382), 1,
      sym_comment,
    ACTIONS(2611), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2613), 35,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [13149] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3894), 1,
      anon_sym_EQ,
    ACTIONS(3898), 1,
      anon_sym_EQ_GT,
    STATE(1383), 1,
      sym_comment,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3756), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13226] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(993), 1,
      anon_sym_EQ,
    ACTIONS(999), 1,
      anon_sym_EQ_GT,
    ACTIONS(3919), 1,
      anon_sym_LBRACK,
    STATE(1384), 1,
      sym_comment,
    ACTIONS(1709), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3922), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(70), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(30), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13309] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(27), 1,
      anon_sym_EQ,
    ACTIONS(68), 1,
      anon_sym_EQ_GT,
    ACTIONS(2484), 1,
      anon_sym_LBRACE,
    ACTIONS(2486), 1,
      anon_sym_DOT,
    STATE(1385), 1,
      sym_comment,
    STATE(2802), 1,
      sym_ui_object_initializer,
    ACTIONS(36), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(70), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13394] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(767), 1,
      anon_sym_EQ_GT,
    ACTIONS(863), 1,
      anon_sym_EQ,
    STATE(1386), 1,
      sym_comment,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(70), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(30), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13471] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1387), 1,
      sym_comment,
    ACTIONS(3810), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3812), 35,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [13542] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(923), 1,
      anon_sym_COLON,
    ACTIONS(3761), 1,
      anon_sym_EQ_GT,
    ACTIONS(3884), 1,
      anon_sym_EQ,
    STATE(1388), 1,
      sym_comment,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3756), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13621] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3794), 1,
      anon_sym_EQ,
    STATE(1389), 1,
      sym_comment,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3756), 20,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13696] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(767), 1,
      anon_sym_EQ_GT,
    ACTIONS(911), 1,
      anon_sym_EQ,
    ACTIONS(923), 1,
      anon_sym_COLON,
    STATE(1390), 1,
      sym_comment,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(70), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(30), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13775] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3830), 1,
      anon_sym_LBRACK,
    ACTIONS(3836), 1,
      anon_sym_DOT,
    ACTIONS(3839), 1,
      anon_sym_LT,
    ACTIONS(3945), 1,
      anon_sym_EQ,
    ACTIONS(3947), 1,
      anon_sym_EQ_GT,
    STATE(1391), 1,
      sym_comment,
    STATE(3240), 1,
      sym_type_arguments,
    ACTIONS(3842), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3833), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3756), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13864] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3761), 1,
      anon_sym_EQ_GT,
    ACTIONS(3884), 1,
      anon_sym_EQ,
    STATE(1392), 1,
      sym_comment,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3756), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13941] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(767), 1,
      anon_sym_EQ_GT,
    ACTIONS(911), 1,
      anon_sym_EQ,
    STATE(1393), 1,
      sym_comment,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(70), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(30), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14018] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3761), 1,
      anon_sym_EQ_GT,
    ACTIONS(3894), 1,
      anon_sym_EQ,
    STATE(1394), 1,
      sym_comment,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3756), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14095] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1395), 1,
      sym_comment,
    ACTIONS(3778), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3780), 35,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [14166] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(913), 1,
      anon_sym_COLON,
    ACTIONS(3761), 1,
      anon_sym_EQ_GT,
    ACTIONS(3884), 1,
      anon_sym_EQ,
    STATE(1396), 1,
      sym_comment,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3756), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14245] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(767), 1,
      anon_sym_EQ_GT,
    ACTIONS(911), 1,
      anon_sym_EQ,
    ACTIONS(984), 1,
      anon_sym_in,
    ACTIONS(3963), 1,
      anon_sym_of,
    STATE(1397), 1,
      sym_comment,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(70), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(30), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14326] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3830), 1,
      anon_sym_LBRACK,
    ACTIONS(3836), 1,
      anon_sym_DOT,
    ACTIONS(3839), 1,
      anon_sym_LT,
    ACTIONS(3949), 1,
      anon_sym_EQ,
    ACTIONS(3951), 1,
      anon_sym_EQ_GT,
    STATE(1398), 1,
      sym_comment,
    STATE(3240), 1,
      sym_type_arguments,
    ACTIONS(3842), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3833), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3756), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14415] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(863), 1,
      anon_sym_EQ,
    ACTIONS(958), 1,
      anon_sym_EQ_GT,
    STATE(1399), 1,
      sym_comment,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(70), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(30), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14492] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(27), 1,
      anon_sym_EQ,
    ACTIONS(68), 1,
      anon_sym_EQ_GT,
    ACTIONS(1711), 1,
      anon_sym_QMARK,
    ACTIONS(3919), 1,
      anon_sym_LBRACK,
    STATE(1400), 1,
      sym_comment,
    ACTIONS(3922), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1709), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(70), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14577] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3761), 1,
      anon_sym_EQ_GT,
    ACTIONS(3884), 1,
      anon_sym_EQ,
    ACTIONS(3965), 1,
      anon_sym_in,
    ACTIONS(3968), 1,
      anon_sym_of,
    STATE(1401), 1,
      sym_comment,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3756), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3752), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14658] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1402), 1,
      sym_comment,
    ACTIONS(3790), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3792), 35,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [14729] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3794), 1,
      anon_sym_EQ,
    ACTIONS(3802), 1,
      anon_sym_EQ_GT,
    ACTIONS(3836), 1,
      anon_sym_DOT,
    ACTIONS(3839), 1,
      anon_sym_LT,
    ACTIONS(3842), 1,
      anon_sym_extends,
    STATE(1403), 1,
      sym_comment,
    STATE(3240), 1,
      sym_type_arguments,
    ACTIONS(3830), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3833), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3756), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14818] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(68), 1,
      anon_sym_EQ_GT,
    ACTIONS(867), 1,
      anon_sym_COLON,
    ACTIONS(877), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_extends,
    ACTIONS(3919), 1,
      anon_sym_LBRACK,
    STATE(1404), 1,
      sym_comment,
    ACTIONS(3922), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3970), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(70), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14905] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(767), 1,
      anon_sym_EQ_GT,
    ACTIONS(911), 1,
      anon_sym_EQ,
    ACTIONS(925), 1,
      anon_sym_COLON,
    STATE(1405), 1,
      sym_comment,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(70), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(30), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14984] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(68), 1,
      anon_sym_EQ_GT,
    ACTIONS(867), 1,
      anon_sym_COLON,
    ACTIONS(877), 1,
      anon_sym_EQ,
    STATE(1406), 1,
      sym_comment,
    ACTIONS(964), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(70), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15065] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(925), 1,
      anon_sym_COLON,
    ACTIONS(3761), 1,
      anon_sym_EQ_GT,
    ACTIONS(3884), 1,
      anon_sym_EQ,
    STATE(1407), 1,
      sym_comment,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3756), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15144] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1003), 1,
      anon_sym_EQ_GT,
    ACTIONS(1013), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_extends,
    STATE(1408), 1,
      sym_comment,
    ACTIONS(3919), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3922), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(70), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(30), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15227] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3830), 1,
      anon_sym_LBRACK,
    ACTIONS(3836), 1,
      anon_sym_DOT,
    ACTIONS(3839), 1,
      anon_sym_LT,
    ACTIONS(3959), 1,
      anon_sym_EQ,
    ACTIONS(3961), 1,
      anon_sym_EQ_GT,
    STATE(1409), 1,
      sym_comment,
    STATE(3240), 1,
      sym_type_arguments,
    ACTIONS(3842), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3833), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3756), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15316] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(952), 1,
      anon_sym_EQ,
    ACTIONS(958), 1,
      anon_sym_EQ_GT,
    STATE(1410), 1,
      sym_comment,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(70), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(30), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15393] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3896), 1,
      anon_sym_EQ,
    ACTIONS(3898), 1,
      anon_sym_EQ_GT,
    STATE(1411), 1,
      sym_comment,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3756), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15470] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(767), 1,
      anon_sym_EQ_GT,
    ACTIONS(911), 1,
      anon_sym_EQ,
    ACTIONS(913), 1,
      anon_sym_COLON,
    STATE(1412), 1,
      sym_comment,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(70), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(30), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15549] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3814), 1,
      anon_sym_LPAREN,
    ACTIONS(3816), 1,
      anon_sym_DOT,
    ACTIONS(3818), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3820), 1,
      anon_sym_LT,
    ACTIONS(3894), 1,
      anon_sym_EQ,
    ACTIONS(3910), 1,
      anon_sym_EQ_GT,
    STATE(1413), 1,
      sym_comment,
    STATE(3174), 1,
      sym_arguments,
    STATE(3263), 1,
      sym_type_arguments,
    ACTIONS(3806), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3796), 3,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3756), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15642] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1414), 1,
      sym_comment,
    ACTIONS(3974), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3770), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3772), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [15715] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1415), 1,
      sym_comment,
    ACTIONS(2619), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2621), 35,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [15786] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1416), 1,
      sym_comment,
    ACTIONS(3786), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3788), 35,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [15857] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1417), 1,
      sym_comment,
    ACTIONS(3782), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3784), 35,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [15928] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1418), 1,
      sym_comment,
    ACTIONS(3976), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3774), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3776), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [16001] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1419), 1,
      sym_comment,
    ACTIONS(3774), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3776), 35,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [16072] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1420), 1,
      sym_comment,
    ACTIONS(3770), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3772), 35,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [16143] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3894), 1,
      anon_sym_EQ,
    STATE(1421), 1,
      sym_comment,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3756), 20,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [16218] = 32,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(3978), 1,
      anon_sym_STAR,
    ACTIONS(3980), 1,
      anon_sym_RBRACE,
    ACTIONS(3982), 1,
      anon_sym_SEMI,
    ACTIONS(3984), 1,
      anon_sym_async,
    ACTIONS(3986), 1,
      anon_sym_AT,
    ACTIONS(3988), 1,
      anon_sym_static,
    ACTIONS(3990), 1,
      anon_sym_readonly,
    ACTIONS(3994), 1,
      anon_sym_declare,
    ACTIONS(3996), 1,
      anon_sym_abstract,
    STATE(1422), 1,
      sym_comment,
    STATE(1466), 1,
      aux_sym_class_body_repeat1,
    STATE(1732), 1,
      aux_sym_export_statement_repeat1,
    STATE(2105), 1,
      sym_method_definition,
    STATE(2398), 1,
      sym_class_static_block,
    STATE(2523), 1,
      sym_accessibility_modifier,
    STATE(2763), 1,
      sym_override_modifier,
    STATE(2850), 1,
      sym_decorator,
    STATE(3306), 1,
      sym__property_name,
    STATE(4763), 1,
      sym_method_signature,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3992), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5210), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3708), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [16342] = 32,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(3978), 1,
      anon_sym_STAR,
    ACTIONS(3982), 1,
      anon_sym_SEMI,
    ACTIONS(3984), 1,
      anon_sym_async,
    ACTIONS(3986), 1,
      anon_sym_AT,
    ACTIONS(3988), 1,
      anon_sym_static,
    ACTIONS(3990), 1,
      anon_sym_readonly,
    ACTIONS(3994), 1,
      anon_sym_declare,
    ACTIONS(3996), 1,
      anon_sym_abstract,
    ACTIONS(3998), 1,
      anon_sym_RBRACE,
    STATE(1423), 1,
      sym_comment,
    STATE(1458), 1,
      aux_sym_class_body_repeat1,
    STATE(1732), 1,
      aux_sym_export_statement_repeat1,
    STATE(2105), 1,
      sym_method_definition,
    STATE(2398), 1,
      sym_class_static_block,
    STATE(2523), 1,
      sym_accessibility_modifier,
    STATE(2763), 1,
      sym_override_modifier,
    STATE(2850), 1,
      sym_decorator,
    STATE(3306), 1,
      sym__property_name,
    STATE(4763), 1,
      sym_method_signature,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3992), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5210), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3708), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [16466] = 29,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(145), 1,
      anon_sym_STAR,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(3055), 1,
      anon_sym_LBRACE,
    ACTIONS(4002), 1,
      anon_sym_RBRACE,
    ACTIONS(4004), 1,
      anon_sym_LBRACK,
    ACTIONS(4006), 1,
      anon_sym_async,
    ACTIONS(4008), 1,
      anon_sym_static,
    ACTIONS(4010), 1,
      anon_sym_readonly,
    ACTIONS(4016), 1,
      anon_sym_override,
    STATE(1424), 1,
      sym_comment,
    STATE(2731), 1,
      sym_accessibility_modifier,
    STATE(2774), 1,
      sym_override_modifier,
    STATE(3944), 1,
      sym__property_name,
    STATE(4996), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5050), 1,
      aux_sym_object_repeat1,
    STATE(6297), 1,
      sym__destructuring_pattern,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4012), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3599), 2,
      sym_object_pattern,
      sym_array_pattern,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4014), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5056), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(5126), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    ACTIONS(4000), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [16584] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3976), 1,
      anon_sym_COMMA,
    STATE(1425), 1,
      sym_comment,
    ACTIONS(3774), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3776), 33,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [16656] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(993), 1,
      anon_sym_EQ,
    ACTIONS(999), 1,
      anon_sym_EQ_GT,
    ACTIONS(3957), 1,
      sym_identifier,
    STATE(1426), 1,
      sym_comment,
    ACTIONS(70), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [16734] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3974), 1,
      anon_sym_COMMA,
    STATE(1427), 1,
      sym_comment,
    ACTIONS(3770), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3772), 33,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [16806] = 29,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(145), 1,
      anon_sym_STAR,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(3055), 1,
      anon_sym_LBRACE,
    ACTIONS(4004), 1,
      anon_sym_LBRACK,
    ACTIONS(4020), 1,
      anon_sym_RBRACE,
    ACTIONS(4022), 1,
      anon_sym_async,
    ACTIONS(4024), 1,
      anon_sym_static,
    ACTIONS(4026), 1,
      anon_sym_readonly,
    ACTIONS(4032), 1,
      anon_sym_override,
    STATE(1428), 1,
      sym_comment,
    STATE(2731), 1,
      sym_accessibility_modifier,
    STATE(2774), 1,
      sym_override_modifier,
    STATE(3944), 1,
      sym__property_name,
    STATE(4996), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5362), 1,
      aux_sym_object_repeat1,
    STATE(6297), 1,
      sym__destructuring_pattern,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4028), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3599), 2,
      sym_object_pattern,
      sym_array_pattern,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4030), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5126), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5367), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4018), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [16924] = 29,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(145), 1,
      anon_sym_STAR,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(3055), 1,
      anon_sym_LBRACE,
    ACTIONS(4004), 1,
      anon_sym_LBRACK,
    ACTIONS(4036), 1,
      anon_sym_RBRACE,
    ACTIONS(4038), 1,
      anon_sym_async,
    ACTIONS(4040), 1,
      anon_sym_static,
    ACTIONS(4042), 1,
      anon_sym_readonly,
    ACTIONS(4048), 1,
      anon_sym_override,
    STATE(1429), 1,
      sym_comment,
    STATE(2731), 1,
      sym_accessibility_modifier,
    STATE(2774), 1,
      sym_override_modifier,
    STATE(3944), 1,
      sym__property_name,
    STATE(4996), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5050), 1,
      aux_sym_object_repeat1,
    STATE(6297), 1,
      sym__destructuring_pattern,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4044), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3599), 2,
      sym_object_pattern,
      sym_array_pattern,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4046), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5056), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(5126), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    ACTIONS(4034), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [17042] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3794), 1,
      anon_sym_EQ,
    ACTIONS(3908), 1,
      anon_sym_COLON,
    STATE(1430), 1,
      sym_comment,
    ACTIONS(4050), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(3756), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17120] = 32,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(3978), 1,
      anon_sym_STAR,
    ACTIONS(3982), 1,
      anon_sym_SEMI,
    ACTIONS(3984), 1,
      anon_sym_async,
    ACTIONS(3986), 1,
      anon_sym_AT,
    ACTIONS(3988), 1,
      anon_sym_static,
    ACTIONS(3990), 1,
      anon_sym_readonly,
    ACTIONS(3994), 1,
      anon_sym_declare,
    ACTIONS(3996), 1,
      anon_sym_abstract,
    ACTIONS(4053), 1,
      anon_sym_RBRACE,
    STATE(1431), 1,
      sym_comment,
    STATE(1458), 1,
      aux_sym_class_body_repeat1,
    STATE(1732), 1,
      aux_sym_export_statement_repeat1,
    STATE(2105), 1,
      sym_method_definition,
    STATE(2398), 1,
      sym_class_static_block,
    STATE(2523), 1,
      sym_accessibility_modifier,
    STATE(2763), 1,
      sym_override_modifier,
    STATE(2850), 1,
      sym_decorator,
    STATE(3306), 1,
      sym__property_name,
    STATE(4763), 1,
      sym_method_signature,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3992), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5210), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3708), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [17244] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(993), 1,
      anon_sym_EQ,
    ACTIONS(999), 1,
      anon_sym_EQ_GT,
    ACTIONS(3734), 1,
      sym_identifier,
    STATE(1432), 1,
      sym_comment,
    ACTIONS(70), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [17322] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(980), 1,
      anon_sym_EQ_GT,
    ACTIONS(1005), 1,
      anon_sym_EQ,
    ACTIONS(3919), 1,
      anon_sym_LBRACK,
    STATE(1433), 1,
      sym_comment,
    ACTIONS(1709), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3922), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(70), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17404] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3794), 1,
      anon_sym_EQ,
    ACTIONS(3802), 1,
      anon_sym_EQ_GT,
    STATE(1434), 1,
      sym_comment,
    ACTIONS(4050), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(3756), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17482] = 32,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(3978), 1,
      anon_sym_STAR,
    ACTIONS(3982), 1,
      anon_sym_SEMI,
    ACTIONS(3984), 1,
      anon_sym_async,
    ACTIONS(3986), 1,
      anon_sym_AT,
    ACTIONS(3988), 1,
      anon_sym_static,
    ACTIONS(3990), 1,
      anon_sym_readonly,
    ACTIONS(3994), 1,
      anon_sym_declare,
    ACTIONS(3996), 1,
      anon_sym_abstract,
    ACTIONS(4055), 1,
      anon_sym_RBRACE,
    STATE(1435), 1,
      sym_comment,
    STATE(1458), 1,
      aux_sym_class_body_repeat1,
    STATE(1732), 1,
      aux_sym_export_statement_repeat1,
    STATE(2105), 1,
      sym_method_definition,
    STATE(2398), 1,
      sym_class_static_block,
    STATE(2523), 1,
      sym_accessibility_modifier,
    STATE(2763), 1,
      sym_override_modifier,
    STATE(2850), 1,
      sym_decorator,
    STATE(3306), 1,
      sym__property_name,
    STATE(4763), 1,
      sym_method_signature,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3992), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5210), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3708), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [17606] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(68), 1,
      anon_sym_EQ_GT,
    ACTIONS(877), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_extends,
    STATE(1436), 1,
      sym_comment,
    ACTIONS(3919), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3922), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(70), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17688] = 29,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(145), 1,
      anon_sym_STAR,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(3055), 1,
      anon_sym_LBRACE,
    ACTIONS(4004), 1,
      anon_sym_LBRACK,
    ACTIONS(4059), 1,
      anon_sym_RBRACE,
    ACTIONS(4061), 1,
      anon_sym_async,
    ACTIONS(4063), 1,
      anon_sym_static,
    ACTIONS(4065), 1,
      anon_sym_readonly,
    ACTIONS(4071), 1,
      anon_sym_override,
    STATE(1437), 1,
      sym_comment,
    STATE(2731), 1,
      sym_accessibility_modifier,
    STATE(2774), 1,
      sym_override_modifier,
    STATE(3944), 1,
      sym__property_name,
    STATE(4996), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5050), 1,
      aux_sym_object_repeat1,
    STATE(6297), 1,
      sym__destructuring_pattern,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4067), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3599), 2,
      sym_object_pattern,
      sym_array_pattern,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4069), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5056), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(5126), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    ACTIONS(4057), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [17806] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3884), 1,
      anon_sym_EQ,
    ACTIONS(3965), 1,
      anon_sym_in,
    ACTIONS(3968), 1,
      anon_sym_of,
    STATE(1438), 1,
      sym_comment,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3756), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3752), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17884] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(993), 1,
      anon_sym_EQ,
    ACTIONS(999), 1,
      anon_sym_EQ_GT,
    ACTIONS(4073), 1,
      sym_identifier,
    STATE(1439), 1,
      sym_comment,
    ACTIONS(70), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [17962] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1027), 1,
      anon_sym_EQ,
    ACTIONS(1037), 1,
      anon_sym_EQ_GT,
    ACTIONS(3919), 1,
      anon_sym_LBRACK,
    STATE(1440), 1,
      sym_comment,
    ACTIONS(1709), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3922), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(70), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18044] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(863), 1,
      anon_sym_EQ,
    ACTIONS(1003), 1,
      anon_sym_EQ_GT,
    STATE(1441), 1,
      sym_comment,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(70), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(30), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18120] = 32,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(3978), 1,
      anon_sym_STAR,
    ACTIONS(3982), 1,
      anon_sym_SEMI,
    ACTIONS(3984), 1,
      anon_sym_async,
    ACTIONS(3986), 1,
      anon_sym_AT,
    ACTIONS(3988), 1,
      anon_sym_static,
    ACTIONS(3990), 1,
      anon_sym_readonly,
    ACTIONS(3994), 1,
      anon_sym_declare,
    ACTIONS(3996), 1,
      anon_sym_abstract,
    ACTIONS(4075), 1,
      anon_sym_RBRACE,
    STATE(1431), 1,
      aux_sym_class_body_repeat1,
    STATE(1442), 1,
      sym_comment,
    STATE(1732), 1,
      aux_sym_export_statement_repeat1,
    STATE(2105), 1,
      sym_method_definition,
    STATE(2398), 1,
      sym_class_static_block,
    STATE(2523), 1,
      sym_accessibility_modifier,
    STATE(2763), 1,
      sym_override_modifier,
    STATE(2850), 1,
      sym_decorator,
    STATE(3306), 1,
      sym__property_name,
    STATE(4763), 1,
      sym_method_signature,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3992), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5210), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3708), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [18244] = 32,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(3978), 1,
      anon_sym_STAR,
    ACTIONS(3982), 1,
      anon_sym_SEMI,
    ACTIONS(3984), 1,
      anon_sym_async,
    ACTIONS(3986), 1,
      anon_sym_AT,
    ACTIONS(3988), 1,
      anon_sym_static,
    ACTIONS(3990), 1,
      anon_sym_readonly,
    ACTIONS(3994), 1,
      anon_sym_declare,
    ACTIONS(3996), 1,
      anon_sym_abstract,
    ACTIONS(4077), 1,
      anon_sym_RBRACE,
    STATE(1443), 1,
      sym_comment,
    STATE(1452), 1,
      aux_sym_class_body_repeat1,
    STATE(1732), 1,
      aux_sym_export_statement_repeat1,
    STATE(2105), 1,
      sym_method_definition,
    STATE(2398), 1,
      sym_class_static_block,
    STATE(2523), 1,
      sym_accessibility_modifier,
    STATE(2763), 1,
      sym_override_modifier,
    STATE(2850), 1,
      sym_decorator,
    STATE(3306), 1,
      sym__property_name,
    STATE(4763), 1,
      sym_method_signature,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3992), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5210), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3708), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [18368] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1047), 1,
      anon_sym_EQ,
    ACTIONS(1053), 1,
      anon_sym_EQ_GT,
    ACTIONS(3919), 1,
      anon_sym_LBRACK,
    STATE(1444), 1,
      sym_comment,
    ACTIONS(1709), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3922), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(70), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18450] = 32,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(3978), 1,
      anon_sym_STAR,
    ACTIONS(3982), 1,
      anon_sym_SEMI,
    ACTIONS(3984), 1,
      anon_sym_async,
    ACTIONS(3986), 1,
      anon_sym_AT,
    ACTIONS(3988), 1,
      anon_sym_static,
    ACTIONS(3990), 1,
      anon_sym_readonly,
    ACTIONS(3994), 1,
      anon_sym_declare,
    ACTIONS(3996), 1,
      anon_sym_abstract,
    ACTIONS(4079), 1,
      anon_sym_RBRACE,
    STATE(1445), 1,
      sym_comment,
    STATE(1455), 1,
      aux_sym_class_body_repeat1,
    STATE(1732), 1,
      aux_sym_export_statement_repeat1,
    STATE(2105), 1,
      sym_method_definition,
    STATE(2398), 1,
      sym_class_static_block,
    STATE(2523), 1,
      sym_accessibility_modifier,
    STATE(2763), 1,
      sym_override_modifier,
    STATE(2850), 1,
      sym_decorator,
    STATE(3306), 1,
      sym__property_name,
    STATE(4763), 1,
      sym_method_signature,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3992), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5210), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3708), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [18574] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3894), 1,
      anon_sym_EQ,
    ACTIONS(3906), 1,
      anon_sym_EQ_GT,
    STATE(1446), 1,
      sym_comment,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3756), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18650] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3830), 1,
      anon_sym_LBRACK,
    ACTIONS(3836), 1,
      anon_sym_DOT,
    ACTIONS(3839), 1,
      anon_sym_LT,
    ACTIONS(3894), 1,
      anon_sym_EQ,
    ACTIONS(3910), 1,
      anon_sym_EQ_GT,
    STATE(1447), 1,
      sym_comment,
    STATE(3240), 1,
      sym_type_arguments,
    ACTIONS(3842), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3833), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3756), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18738] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3914), 1,
      anon_sym_RBRACK,
    ACTIONS(3928), 1,
      anon_sym_COMMA,
    ACTIONS(3951), 1,
      anon_sym_EQ_GT,
    ACTIONS(4081), 1,
      anon_sym_EQ,
    ACTIONS(4084), 1,
      anon_sym_in,
    ACTIONS(4086), 1,
      anon_sym_COLON,
    STATE(1448), 1,
      sym_comment,
    ACTIONS(3756), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18822] = 29,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(145), 1,
      anon_sym_STAR,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(3055), 1,
      anon_sym_LBRACE,
    ACTIONS(4004), 1,
      anon_sym_LBRACK,
    ACTIONS(4090), 1,
      anon_sym_RBRACE,
    ACTIONS(4092), 1,
      anon_sym_async,
    ACTIONS(4094), 1,
      anon_sym_static,
    ACTIONS(4096), 1,
      anon_sym_readonly,
    ACTIONS(4102), 1,
      anon_sym_override,
    STATE(1449), 1,
      sym_comment,
    STATE(2731), 1,
      sym_accessibility_modifier,
    STATE(2774), 1,
      sym_override_modifier,
    STATE(3944), 1,
      sym__property_name,
    STATE(4996), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5050), 1,
      aux_sym_object_repeat1,
    STATE(6297), 1,
      sym__destructuring_pattern,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4098), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3599), 2,
      sym_object_pattern,
      sym_array_pattern,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4100), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5056), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(5126), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    ACTIONS(4088), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [18940] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1003), 1,
      anon_sym_EQ_GT,
    ACTIONS(1013), 1,
      anon_sym_EQ,
    STATE(1450), 1,
      sym_comment,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(70), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(30), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19016] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3896), 1,
      anon_sym_EQ,
    STATE(1451), 1,
      sym_comment,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3756), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19090] = 32,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(3978), 1,
      anon_sym_STAR,
    ACTIONS(3982), 1,
      anon_sym_SEMI,
    ACTIONS(3984), 1,
      anon_sym_async,
    ACTIONS(3986), 1,
      anon_sym_AT,
    ACTIONS(3988), 1,
      anon_sym_static,
    ACTIONS(3990), 1,
      anon_sym_readonly,
    ACTIONS(3994), 1,
      anon_sym_declare,
    ACTIONS(3996), 1,
      anon_sym_abstract,
    ACTIONS(4104), 1,
      anon_sym_RBRACE,
    STATE(1452), 1,
      sym_comment,
    STATE(1458), 1,
      aux_sym_class_body_repeat1,
    STATE(1732), 1,
      aux_sym_export_statement_repeat1,
    STATE(2105), 1,
      sym_method_definition,
    STATE(2398), 1,
      sym_class_static_block,
    STATE(2523), 1,
      sym_accessibility_modifier,
    STATE(2763), 1,
      sym_override_modifier,
    STATE(2850), 1,
      sym_decorator,
    STATE(3306), 1,
      sym__property_name,
    STATE(4763), 1,
      sym_method_signature,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3992), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5210), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3708), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [19214] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3904), 1,
      anon_sym_EQ,
    ACTIONS(3906), 1,
      anon_sym_EQ_GT,
    STATE(1453), 1,
      sym_comment,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3756), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19290] = 32,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(3978), 1,
      anon_sym_STAR,
    ACTIONS(3982), 1,
      anon_sym_SEMI,
    ACTIONS(3984), 1,
      anon_sym_async,
    ACTIONS(3986), 1,
      anon_sym_AT,
    ACTIONS(3988), 1,
      anon_sym_static,
    ACTIONS(3990), 1,
      anon_sym_readonly,
    ACTIONS(3994), 1,
      anon_sym_declare,
    ACTIONS(3996), 1,
      anon_sym_abstract,
    ACTIONS(4106), 1,
      anon_sym_RBRACE,
    STATE(1454), 1,
      sym_comment,
    STATE(1458), 1,
      aux_sym_class_body_repeat1,
    STATE(1732), 1,
      aux_sym_export_statement_repeat1,
    STATE(2105), 1,
      sym_method_definition,
    STATE(2398), 1,
      sym_class_static_block,
    STATE(2523), 1,
      sym_accessibility_modifier,
    STATE(2763), 1,
      sym_override_modifier,
    STATE(2850), 1,
      sym_decorator,
    STATE(3306), 1,
      sym__property_name,
    STATE(4763), 1,
      sym_method_signature,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3992), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5210), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3708), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [19414] = 32,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(3978), 1,
      anon_sym_STAR,
    ACTIONS(3982), 1,
      anon_sym_SEMI,
    ACTIONS(3984), 1,
      anon_sym_async,
    ACTIONS(3986), 1,
      anon_sym_AT,
    ACTIONS(3988), 1,
      anon_sym_static,
    ACTIONS(3990), 1,
      anon_sym_readonly,
    ACTIONS(3994), 1,
      anon_sym_declare,
    ACTIONS(3996), 1,
      anon_sym_abstract,
    ACTIONS(4108), 1,
      anon_sym_RBRACE,
    STATE(1455), 1,
      sym_comment,
    STATE(1458), 1,
      aux_sym_class_body_repeat1,
    STATE(1732), 1,
      aux_sym_export_statement_repeat1,
    STATE(2105), 1,
      sym_method_definition,
    STATE(2398), 1,
      sym_class_static_block,
    STATE(2523), 1,
      sym_accessibility_modifier,
    STATE(2763), 1,
      sym_override_modifier,
    STATE(2850), 1,
      sym_decorator,
    STATE(3306), 1,
      sym__property_name,
    STATE(4763), 1,
      sym_method_signature,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3992), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5210), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3708), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [19538] = 32,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(3978), 1,
      anon_sym_STAR,
    ACTIONS(3982), 1,
      anon_sym_SEMI,
    ACTIONS(3984), 1,
      anon_sym_async,
    ACTIONS(3986), 1,
      anon_sym_AT,
    ACTIONS(3988), 1,
      anon_sym_static,
    ACTIONS(3990), 1,
      anon_sym_readonly,
    ACTIONS(3994), 1,
      anon_sym_declare,
    ACTIONS(3996), 1,
      anon_sym_abstract,
    ACTIONS(4110), 1,
      anon_sym_RBRACE,
    STATE(1456), 1,
      sym_comment,
    STATE(1465), 1,
      aux_sym_class_body_repeat1,
    STATE(1732), 1,
      aux_sym_export_statement_repeat1,
    STATE(2105), 1,
      sym_method_definition,
    STATE(2398), 1,
      sym_class_static_block,
    STATE(2523), 1,
      sym_accessibility_modifier,
    STATE(2763), 1,
      sym_override_modifier,
    STATE(2850), 1,
      sym_decorator,
    STATE(3306), 1,
      sym__property_name,
    STATE(4763), 1,
      sym_method_signature,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3992), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5210), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3708), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [19662] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(36), 1,
      anon_sym_RBRACK,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(971), 1,
      anon_sym_EQ,
    ACTIONS(976), 1,
      anon_sym_COLON,
    ACTIONS(980), 1,
      anon_sym_EQ_GT,
    STATE(1457), 1,
      sym_comment,
    ACTIONS(70), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19744] = 31,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4115), 1,
      anon_sym_STAR,
    ACTIONS(4118), 1,
      anon_sym_RBRACE,
    ACTIONS(4120), 1,
      anon_sym_SEMI,
    ACTIONS(4123), 1,
      anon_sym_LBRACK,
    ACTIONS(4126), 1,
      anon_sym_DQUOTE,
    ACTIONS(4129), 1,
      anon_sym_SQUOTE,
    ACTIONS(4132), 1,
      anon_sym_async,
    ACTIONS(4141), 1,
      anon_sym_AT,
    ACTIONS(4144), 1,
      anon_sym_static,
    ACTIONS(4147), 1,
      anon_sym_readonly,
    ACTIONS(4153), 1,
      anon_sym_declare,
    ACTIONS(4159), 1,
      anon_sym_override,
    ACTIONS(4162), 1,
      anon_sym_abstract,
    STATE(1732), 1,
      aux_sym_export_statement_repeat1,
    STATE(2105), 1,
      sym_method_definition,
    STATE(2398), 1,
      sym_class_static_block,
    STATE(2523), 1,
      sym_accessibility_modifier,
    STATE(2763), 1,
      sym_override_modifier,
    STATE(2850), 1,
      sym_decorator,
    STATE(3306), 1,
      sym__property_name,
    STATE(4763), 1,
      sym_method_signature,
    ACTIONS(4135), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4138), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4150), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1458), 2,
      sym_comment,
      aux_sym_class_body_repeat1,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4156), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5210), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4112), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [19866] = 32,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(3978), 1,
      anon_sym_STAR,
    ACTIONS(3982), 1,
      anon_sym_SEMI,
    ACTIONS(3984), 1,
      anon_sym_async,
    ACTIONS(3986), 1,
      anon_sym_AT,
    ACTIONS(3988), 1,
      anon_sym_static,
    ACTIONS(3990), 1,
      anon_sym_readonly,
    ACTIONS(3994), 1,
      anon_sym_declare,
    ACTIONS(3996), 1,
      anon_sym_abstract,
    ACTIONS(4165), 1,
      anon_sym_RBRACE,
    STATE(1423), 1,
      aux_sym_class_body_repeat1,
    STATE(1459), 1,
      sym_comment,
    STATE(1732), 1,
      aux_sym_export_statement_repeat1,
    STATE(2105), 1,
      sym_method_definition,
    STATE(2398), 1,
      sym_class_static_block,
    STATE(2523), 1,
      sym_accessibility_modifier,
    STATE(2763), 1,
      sym_override_modifier,
    STATE(2850), 1,
      sym_decorator,
    STATE(3306), 1,
      sym__property_name,
    STATE(4763), 1,
      sym_method_signature,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3992), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5210), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3708), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [19990] = 32,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(3978), 1,
      anon_sym_STAR,
    ACTIONS(3982), 1,
      anon_sym_SEMI,
    ACTIONS(3984), 1,
      anon_sym_async,
    ACTIONS(3986), 1,
      anon_sym_AT,
    ACTIONS(3988), 1,
      anon_sym_static,
    ACTIONS(3990), 1,
      anon_sym_readonly,
    ACTIONS(3994), 1,
      anon_sym_declare,
    ACTIONS(3996), 1,
      anon_sym_abstract,
    ACTIONS(4167), 1,
      anon_sym_RBRACE,
    STATE(1435), 1,
      aux_sym_class_body_repeat1,
    STATE(1460), 1,
      sym_comment,
    STATE(1732), 1,
      aux_sym_export_statement_repeat1,
    STATE(2105), 1,
      sym_method_definition,
    STATE(2398), 1,
      sym_class_static_block,
    STATE(2523), 1,
      sym_accessibility_modifier,
    STATE(2763), 1,
      sym_override_modifier,
    STATE(2850), 1,
      sym_decorator,
    STATE(3306), 1,
      sym__property_name,
    STATE(4763), 1,
      sym_method_signature,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3992), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5210), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3708), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [20114] = 32,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(3978), 1,
      anon_sym_STAR,
    ACTIONS(3982), 1,
      anon_sym_SEMI,
    ACTIONS(3984), 1,
      anon_sym_async,
    ACTIONS(3986), 1,
      anon_sym_AT,
    ACTIONS(3988), 1,
      anon_sym_static,
    ACTIONS(3990), 1,
      anon_sym_readonly,
    ACTIONS(3994), 1,
      anon_sym_declare,
    ACTIONS(3996), 1,
      anon_sym_abstract,
    ACTIONS(4169), 1,
      anon_sym_RBRACE,
    STATE(1454), 1,
      aux_sym_class_body_repeat1,
    STATE(1461), 1,
      sym_comment,
    STATE(1732), 1,
      aux_sym_export_statement_repeat1,
    STATE(2105), 1,
      sym_method_definition,
    STATE(2398), 1,
      sym_class_static_block,
    STATE(2523), 1,
      sym_accessibility_modifier,
    STATE(2763), 1,
      sym_override_modifier,
    STATE(2850), 1,
      sym_decorator,
    STATE(3306), 1,
      sym__property_name,
    STATE(4763), 1,
      sym_method_signature,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3992), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5210), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3708), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [20238] = 29,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(145), 1,
      anon_sym_STAR,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(3055), 1,
      anon_sym_LBRACE,
    ACTIONS(4004), 1,
      anon_sym_LBRACK,
    ACTIONS(4173), 1,
      anon_sym_RBRACE,
    ACTIONS(4175), 1,
      anon_sym_async,
    ACTIONS(4177), 1,
      anon_sym_static,
    ACTIONS(4179), 1,
      anon_sym_readonly,
    ACTIONS(4185), 1,
      anon_sym_override,
    STATE(1462), 1,
      sym_comment,
    STATE(2731), 1,
      sym_accessibility_modifier,
    STATE(2774), 1,
      sym_override_modifier,
    STATE(3944), 1,
      sym__property_name,
    STATE(4996), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5050), 1,
      aux_sym_object_repeat1,
    STATE(6297), 1,
      sym__destructuring_pattern,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4181), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3599), 2,
      sym_object_pattern,
      sym_array_pattern,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4183), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5056), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(5126), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    ACTIONS(4171), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [20356] = 29,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(145), 1,
      anon_sym_STAR,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(3055), 1,
      anon_sym_LBRACE,
    ACTIONS(4004), 1,
      anon_sym_LBRACK,
    ACTIONS(4189), 1,
      anon_sym_RBRACE,
    ACTIONS(4191), 1,
      anon_sym_async,
    ACTIONS(4193), 1,
      anon_sym_static,
    ACTIONS(4195), 1,
      anon_sym_readonly,
    ACTIONS(4201), 1,
      anon_sym_override,
    STATE(1463), 1,
      sym_comment,
    STATE(2731), 1,
      sym_accessibility_modifier,
    STATE(2774), 1,
      sym_override_modifier,
    STATE(3944), 1,
      sym__property_name,
    STATE(4996), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5362), 1,
      aux_sym_object_repeat1,
    STATE(6297), 1,
      sym__destructuring_pattern,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4197), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3599), 2,
      sym_object_pattern,
      sym_array_pattern,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4199), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5126), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5367), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4187), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [20474] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3884), 1,
      anon_sym_EQ,
    STATE(1464), 1,
      sym_comment,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3756), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20548] = 32,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(3978), 1,
      anon_sym_STAR,
    ACTIONS(3982), 1,
      anon_sym_SEMI,
    ACTIONS(3984), 1,
      anon_sym_async,
    ACTIONS(3986), 1,
      anon_sym_AT,
    ACTIONS(3988), 1,
      anon_sym_static,
    ACTIONS(3990), 1,
      anon_sym_readonly,
    ACTIONS(3994), 1,
      anon_sym_declare,
    ACTIONS(3996), 1,
      anon_sym_abstract,
    ACTIONS(4203), 1,
      anon_sym_RBRACE,
    STATE(1458), 1,
      aux_sym_class_body_repeat1,
    STATE(1465), 1,
      sym_comment,
    STATE(1732), 1,
      aux_sym_export_statement_repeat1,
    STATE(2105), 1,
      sym_method_definition,
    STATE(2398), 1,
      sym_class_static_block,
    STATE(2523), 1,
      sym_accessibility_modifier,
    STATE(2763), 1,
      sym_override_modifier,
    STATE(2850), 1,
      sym_decorator,
    STATE(3306), 1,
      sym__property_name,
    STATE(4763), 1,
      sym_method_signature,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3992), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5210), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3708), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [20672] = 32,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3718), 1,
      anon_sym_LBRACK,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(3978), 1,
      anon_sym_STAR,
    ACTIONS(3982), 1,
      anon_sym_SEMI,
    ACTIONS(3984), 1,
      anon_sym_async,
    ACTIONS(3986), 1,
      anon_sym_AT,
    ACTIONS(3988), 1,
      anon_sym_static,
    ACTIONS(3990), 1,
      anon_sym_readonly,
    ACTIONS(3994), 1,
      anon_sym_declare,
    ACTIONS(3996), 1,
      anon_sym_abstract,
    ACTIONS(4205), 1,
      anon_sym_RBRACE,
    STATE(1458), 1,
      aux_sym_class_body_repeat1,
    STATE(1466), 1,
      sym_comment,
    STATE(1732), 1,
      aux_sym_export_statement_repeat1,
    STATE(2105), 1,
      sym_method_definition,
    STATE(2398), 1,
      sym_class_static_block,
    STATE(2523), 1,
      sym_accessibility_modifier,
    STATE(2763), 1,
      sym_override_modifier,
    STATE(2850), 1,
      sym_decorator,
    STATE(3306), 1,
      sym__property_name,
    STATE(4763), 1,
      sym_method_signature,
    ACTIONS(3071), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3992), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5210), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3708), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [20796] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3938), 1,
      anon_sym_EQ,
    ACTIONS(3940), 1,
      anon_sym_EQ_GT,
    STATE(1467), 1,
      sym_comment,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3756), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20871] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(993), 1,
      anon_sym_EQ,
    ACTIONS(999), 1,
      anon_sym_EQ_GT,
    STATE(1468), 1,
      sym_comment,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(70), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(30), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20946] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(36), 1,
      anon_sym_RBRACK,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(971), 1,
      anon_sym_EQ,
    ACTIONS(980), 1,
      anon_sym_EQ_GT,
    STATE(1469), 1,
      sym_comment,
    ACTIONS(70), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21025] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(863), 1,
      anon_sym_EQ,
    ACTIONS(999), 1,
      anon_sym_EQ_GT,
    STATE(1470), 1,
      sym_comment,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(70), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(30), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21100] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3914), 1,
      anon_sym_RBRACK,
    ACTIONS(3928), 1,
      anon_sym_COMMA,
    ACTIONS(3951), 1,
      anon_sym_EQ_GT,
    ACTIONS(4081), 1,
      anon_sym_EQ,
    STATE(1471), 1,
      sym_comment,
    ACTIONS(3756), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21179] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3949), 1,
      anon_sym_EQ,
    ACTIONS(3951), 1,
      anon_sym_EQ_GT,
    ACTIONS(4084), 1,
      anon_sym_in,
    ACTIONS(4207), 1,
      anon_sym_COLON,
    STATE(1472), 1,
      sym_comment,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3756), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3752), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21258] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3904), 1,
      anon_sym_EQ,
    STATE(1473), 1,
      sym_comment,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3756), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21331] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(139), 1,
      anon_sym_EQ_GT,
    ACTIONS(863), 1,
      anon_sym_EQ,
    ACTIONS(3919), 1,
      anon_sym_LBRACK,
    STATE(1474), 1,
      sym_comment,
    ACTIONS(1709), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3922), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(70), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21412] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3949), 1,
      anon_sym_EQ,
    ACTIONS(3951), 1,
      anon_sym_EQ_GT,
    ACTIONS(4084), 1,
      anon_sym_in,
    ACTIONS(4086), 1,
      anon_sym_COLON,
    STATE(1475), 1,
      sym_comment,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3756), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3752), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21491] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3894), 1,
      anon_sym_EQ,
    ACTIONS(3940), 1,
      anon_sym_EQ_GT,
    STATE(1476), 1,
      sym_comment,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3756), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21566] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(980), 1,
      anon_sym_EQ_GT,
    ACTIONS(1005), 1,
      anon_sym_EQ,
    ACTIONS(1007), 1,
      anon_sym_COLON,
    STATE(1477), 1,
      sym_comment,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(70), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(30), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21643] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3974), 1,
      anon_sym_COMMA,
    STATE(1478), 1,
      sym_comment,
    ACTIONS(3770), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3772), 32,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [21714] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(976), 1,
      anon_sym_COLON,
    ACTIONS(980), 1,
      anon_sym_EQ_GT,
    ACTIONS(1005), 1,
      anon_sym_EQ,
    STATE(1479), 1,
      sym_comment,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(70), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(30), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21791] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3976), 1,
      anon_sym_COMMA,
    STATE(1480), 1,
      sym_comment,
    ACTIONS(3774), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3776), 32,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [21862] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(863), 1,
      anon_sym_EQ,
    ACTIONS(1053), 1,
      anon_sym_EQ_GT,
    STATE(1481), 1,
      sym_comment,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(70), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(30), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21936] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(863), 1,
      anon_sym_EQ,
    ACTIONS(980), 1,
      anon_sym_EQ_GT,
    STATE(1482), 1,
      sym_comment,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(70), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(30), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22010] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3894), 1,
      anon_sym_EQ,
    ACTIONS(3947), 1,
      anon_sym_EQ_GT,
    STATE(1483), 1,
      sym_comment,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3756), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22084] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3894), 1,
      anon_sym_EQ,
    ACTIONS(3951), 1,
      anon_sym_EQ_GT,
    STATE(1484), 1,
      sym_comment,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3756), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22158] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1027), 1,
      anon_sym_EQ,
    ACTIONS(1037), 1,
      anon_sym_EQ_GT,
    STATE(1485), 1,
      sym_comment,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(70), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(30), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22232] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3945), 1,
      anon_sym_EQ,
    ACTIONS(3947), 1,
      anon_sym_EQ_GT,
    STATE(1486), 1,
      sym_comment,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3756), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22306] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3938), 1,
      anon_sym_EQ,
    STATE(1487), 1,
      sym_comment,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3756), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22378] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(139), 1,
      anon_sym_EQ_GT,
    ACTIONS(863), 1,
      anon_sym_EQ,
    ACTIONS(984), 1,
      anon_sym_in,
    ACTIONS(3963), 1,
      anon_sym_of,
    STATE(1488), 1,
      sym_comment,
    ACTIONS(70), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22456] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3914), 1,
      anon_sym_RBRACK,
    ACTIONS(3928), 1,
      anon_sym_COMMA,
    ACTIONS(4081), 1,
      anon_sym_EQ,
    STATE(1489), 1,
      sym_comment,
    ACTIONS(3756), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22532] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(980), 1,
      anon_sym_EQ_GT,
    ACTIONS(1005), 1,
      anon_sym_EQ,
    STATE(1490), 1,
      sym_comment,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(70), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(30), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22606] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(863), 1,
      anon_sym_EQ,
    ACTIONS(1037), 1,
      anon_sym_EQ_GT,
    STATE(1491), 1,
      sym_comment,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(70), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(30), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22680] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3949), 1,
      anon_sym_EQ,
    ACTIONS(3951), 1,
      anon_sym_EQ_GT,
    STATE(1492), 1,
      sym_comment,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3756), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22754] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3894), 1,
      anon_sym_EQ,
    ACTIONS(3910), 1,
      anon_sym_EQ_GT,
    ACTIONS(3965), 1,
      anon_sym_in,
    ACTIONS(3968), 1,
      anon_sym_of,
    STATE(1493), 1,
      sym_comment,
    ACTIONS(3756), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22832] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3959), 1,
      anon_sym_EQ,
    ACTIONS(3961), 1,
      anon_sym_EQ_GT,
    STATE(1494), 1,
      sym_comment,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3756), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22906] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3894), 1,
      anon_sym_EQ,
    ACTIONS(3961), 1,
      anon_sym_EQ_GT,
    STATE(1495), 1,
      sym_comment,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3756), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22980] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1047), 1,
      anon_sym_EQ,
    ACTIONS(1053), 1,
      anon_sym_EQ_GT,
    STATE(1496), 1,
      sym_comment,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(70), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(30), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23054] = 26,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(145), 1,
      anon_sym_STAR,
    ACTIONS(219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(3055), 1,
      anon_sym_LBRACE,
    ACTIONS(4004), 1,
      anon_sym_LBRACK,
    ACTIONS(4211), 1,
      anon_sym_async,
    ACTIONS(4213), 1,
      anon_sym_static,
    ACTIONS(4215), 1,
      anon_sym_readonly,
    ACTIONS(4221), 1,
      anon_sym_override,
    STATE(1497), 1,
      sym_comment,
    STATE(2731), 1,
      sym_accessibility_modifier,
    STATE(2774), 1,
      sym_override_modifier,
    STATE(3944), 1,
      sym__property_name,
    STATE(6297), 1,
      sym__destructuring_pattern,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3423), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4217), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3599), 2,
      sym_object_pattern,
      sym_array_pattern,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4219), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5553), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5562), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4209), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [23164] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3894), 1,
      anon_sym_EQ,
    ACTIONS(3965), 1,
      anon_sym_in,
    ACTIONS(3968), 1,
      anon_sym_of,
    STATE(1498), 1,
      sym_comment,
    ACTIONS(3756), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23239] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(139), 1,
      anon_sym_EQ_GT,
    ACTIONS(1059), 1,
      anon_sym_EQ,
    STATE(1499), 1,
      sym_comment,
    ACTIONS(70), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23312] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(139), 1,
      anon_sym_EQ_GT,
    ACTIONS(863), 1,
      anon_sym_EQ,
    STATE(1500), 1,
      sym_comment,
    ACTIONS(70), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23385] = 25,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(17), 1,
      anon_sym_AT,
    ACTIONS(600), 1,
      anon_sym_var,
    ACTIONS(4223), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_default,
    ACTIONS(4229), 1,
      anon_sym_RBRACE,
    ACTIONS(4231), 1,
      anon_sym_async,
    ACTIONS(4233), 1,
      anon_sym_function,
    ACTIONS(4235), 1,
      anon_sym_readonly,
    ACTIONS(4237), 1,
      anon_sym_property,
    ACTIONS(4239), 1,
      anon_sym_signal,
    ACTIONS(4241), 1,
      anon_sym_required,
    ACTIONS(4243), 1,
      anon_sym_component,
    ACTIONS(4245), 1,
      anon_sym_enum,
    STATE(1501), 1,
      sym_comment,
    STATE(1511), 1,
      aux_sym_ui_object_initializer_repeat1,
    STATE(1573), 1,
      aux_sym_ui_annotated_object_repeat1,
    STATE(3051), 1,
      sym__qml_enum_declaration,
    STATE(3086), 1,
      sym_ui_annotation,
    STATE(4030), 1,
      aux_sym_ui_property_repeat1,
    STATE(4212), 1,
      sym_ui_nested_identifier,
    STATE(4689), 1,
      sym_ui_property_modifier,
    STATE(3039), 11,
      sym_variable_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_ui_object_definition,
      sym_ui_annotated_object_member,
      sym_ui_object_definition_binding,
      sym_ui_binding,
      sym_ui_property,
      sym_ui_required,
      sym_ui_signal,
      sym_ui_inline_component,
    ACTIONS(4225), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_on,
  [23492] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3910), 1,
      anon_sym_EQ_GT,
    ACTIONS(4247), 1,
      anon_sym_EQ,
    STATE(1502), 1,
      sym_comment,
    ACTIONS(3756), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23565] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3910), 1,
      anon_sym_EQ_GT,
    ACTIONS(4249), 1,
      anon_sym_EQ,
    STATE(1503), 1,
      sym_comment,
    ACTIONS(3756), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23638] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3894), 1,
      anon_sym_EQ,
    ACTIONS(3910), 1,
      anon_sym_EQ_GT,
    STATE(1504), 1,
      sym_comment,
    ACTIONS(3756), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23711] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(139), 1,
      anon_sym_EQ_GT,
    ACTIONS(1121), 1,
      anon_sym_EQ,
    STATE(1505), 1,
      sym_comment,
    ACTIONS(70), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23784] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(139), 1,
      anon_sym_EQ_GT,
    ACTIONS(1117), 1,
      anon_sym_EQ,
    STATE(1506), 1,
      sym_comment,
    ACTIONS(70), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23857] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3910), 1,
      anon_sym_EQ_GT,
    ACTIONS(4251), 1,
      anon_sym_EQ,
    STATE(1507), 1,
      sym_comment,
    ACTIONS(3756), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23930] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(139), 1,
      anon_sym_EQ_GT,
    ACTIONS(1115), 1,
      anon_sym_EQ,
    STATE(1508), 1,
      sym_comment,
    ACTIONS(70), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24003] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3910), 1,
      anon_sym_EQ_GT,
    ACTIONS(4253), 1,
      anon_sym_EQ,
    STATE(1509), 1,
      sym_comment,
    ACTIONS(3756), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24076] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3910), 1,
      anon_sym_EQ_GT,
    ACTIONS(4255), 1,
      anon_sym_EQ,
    STATE(1510), 1,
      sym_comment,
    ACTIONS(3756), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24149] = 24,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4257), 1,
      sym_identifier,
    ACTIONS(4263), 1,
      anon_sym_default,
    ACTIONS(4266), 1,
      anon_sym_RBRACE,
    ACTIONS(4268), 1,
      anon_sym_var,
    ACTIONS(4271), 1,
      anon_sym_async,
    ACTIONS(4274), 1,
      anon_sym_function,
    ACTIONS(4277), 1,
      anon_sym_AT,
    ACTIONS(4280), 1,
      anon_sym_readonly,
    ACTIONS(4283), 1,
      anon_sym_property,
    ACTIONS(4286), 1,
      anon_sym_signal,
    ACTIONS(4289), 1,
      anon_sym_required,
    ACTIONS(4292), 1,
      anon_sym_component,
    ACTIONS(4295), 1,
      anon_sym_enum,
    STATE(1573), 1,
      aux_sym_ui_annotated_object_repeat1,
    STATE(3051), 1,
      sym__qml_enum_declaration,
    STATE(3086), 1,
      sym_ui_annotation,
    STATE(4030), 1,
      aux_sym_ui_property_repeat1,
    STATE(4212), 1,
      sym_ui_nested_identifier,
    STATE(4689), 1,
      sym_ui_property_modifier,
    STATE(1511), 2,
      sym_comment,
      aux_sym_ui_object_initializer_repeat1,
    STATE(3039), 11,
      sym_variable_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_ui_object_definition,
      sym_ui_annotated_object_member,
      sym_ui_object_definition_binding,
      sym_ui_binding,
      sym_ui_property,
      sym_ui_required,
      sym_ui_signal,
      sym_ui_inline_component,
    ACTIONS(4260), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_on,
  [24254] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(139), 1,
      anon_sym_EQ_GT,
    ACTIONS(1123), 1,
      anon_sym_EQ,
    STATE(1512), 1,
      sym_comment,
    ACTIONS(70), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24327] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3959), 1,
      anon_sym_EQ,
    STATE(1513), 1,
      sym_comment,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3756), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24398] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(139), 1,
      anon_sym_EQ_GT,
    ACTIONS(1125), 1,
      anon_sym_EQ,
    STATE(1514), 1,
      sym_comment,
    ACTIONS(70), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24471] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(139), 1,
      anon_sym_EQ_GT,
    ACTIONS(1119), 1,
      anon_sym_EQ,
    STATE(1515), 1,
      sym_comment,
    ACTIONS(70), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24544] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3910), 1,
      anon_sym_EQ_GT,
    ACTIONS(4298), 1,
      anon_sym_EQ,
    STATE(1516), 1,
      sym_comment,
    ACTIONS(3756), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24617] = 25,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(17), 1,
      anon_sym_AT,
    ACTIONS(600), 1,
      anon_sym_var,
    ACTIONS(4223), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_default,
    ACTIONS(4231), 1,
      anon_sym_async,
    ACTIONS(4233), 1,
      anon_sym_function,
    ACTIONS(4235), 1,
      anon_sym_readonly,
    ACTIONS(4237), 1,
      anon_sym_property,
    ACTIONS(4239), 1,
      anon_sym_signal,
    ACTIONS(4241), 1,
      anon_sym_required,
    ACTIONS(4243), 1,
      anon_sym_component,
    ACTIONS(4245), 1,
      anon_sym_enum,
    ACTIONS(4300), 1,
      anon_sym_RBRACE,
    STATE(1511), 1,
      aux_sym_ui_object_initializer_repeat1,
    STATE(1517), 1,
      sym_comment,
    STATE(1573), 1,
      aux_sym_ui_annotated_object_repeat1,
    STATE(3051), 1,
      sym__qml_enum_declaration,
    STATE(3086), 1,
      sym_ui_annotation,
    STATE(4030), 1,
      aux_sym_ui_property_repeat1,
    STATE(4212), 1,
      sym_ui_nested_identifier,
    STATE(4689), 1,
      sym_ui_property_modifier,
    STATE(3039), 11,
      sym_variable_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_ui_object_definition,
      sym_ui_annotated_object_member,
      sym_ui_object_definition_binding,
      sym_ui_binding,
      sym_ui_property,
      sym_ui_required,
      sym_ui_signal,
      sym_ui_inline_component,
    ACTIONS(4225), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_on,
  [24724] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3910), 1,
      anon_sym_EQ_GT,
    ACTIONS(4302), 1,
      anon_sym_EQ,
    STATE(1518), 1,
      sym_comment,
    ACTIONS(3756), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24797] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(139), 1,
      anon_sym_EQ_GT,
    ACTIONS(1127), 1,
      anon_sym_EQ,
    STATE(1519), 1,
      sym_comment,
    ACTIONS(70), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24870] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3949), 1,
      anon_sym_EQ,
    STATE(1520), 1,
      sym_comment,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3756), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24941] = 25,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(17), 1,
      anon_sym_AT,
    ACTIONS(600), 1,
      anon_sym_var,
    ACTIONS(4223), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_default,
    ACTIONS(4231), 1,
      anon_sym_async,
    ACTIONS(4233), 1,
      anon_sym_function,
    ACTIONS(4235), 1,
      anon_sym_readonly,
    ACTIONS(4237), 1,
      anon_sym_property,
    ACTIONS(4239), 1,
      anon_sym_signal,
    ACTIONS(4241), 1,
      anon_sym_required,
    ACTIONS(4243), 1,
      anon_sym_component,
    ACTIONS(4245), 1,
      anon_sym_enum,
    ACTIONS(4304), 1,
      anon_sym_RBRACE,
    STATE(1501), 1,
      aux_sym_ui_object_initializer_repeat1,
    STATE(1521), 1,
      sym_comment,
    STATE(1573), 1,
      aux_sym_ui_annotated_object_repeat1,
    STATE(3051), 1,
      sym__qml_enum_declaration,
    STATE(3086), 1,
      sym_ui_annotation,
    STATE(4030), 1,
      aux_sym_ui_property_repeat1,
    STATE(4212), 1,
      sym_ui_nested_identifier,
    STATE(4689), 1,
      sym_ui_property_modifier,
    STATE(3039), 11,
      sym_variable_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_ui_object_definition,
      sym_ui_annotated_object_member,
      sym_ui_object_definition_binding,
      sym_ui_binding,
      sym_ui_property,
      sym_ui_required,
      sym_ui_signal,
      sym_ui_inline_component,
    ACTIONS(4225), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_on,
  [25048] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3910), 1,
      anon_sym_EQ_GT,
    ACTIONS(4306), 1,
      anon_sym_EQ,
    STATE(1522), 1,
      sym_comment,
    ACTIONS(3756), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25121] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3945), 1,
      anon_sym_EQ,
    STATE(1523), 1,
      sym_comment,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3756), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25192] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(139), 1,
      anon_sym_EQ_GT,
    ACTIONS(1113), 1,
      anon_sym_EQ,
    STATE(1524), 1,
      sym_comment,
    ACTIONS(70), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(76), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(30), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25265] = 25,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(17), 1,
      anon_sym_AT,
    ACTIONS(600), 1,
      anon_sym_var,
    ACTIONS(4223), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_default,
    ACTIONS(4231), 1,
      anon_sym_async,
    ACTIONS(4233), 1,
      anon_sym_function,
    ACTIONS(4235), 1,
      anon_sym_readonly,
    ACTIONS(4237), 1,
      anon_sym_property,
    ACTIONS(4239), 1,
      anon_sym_signal,
    ACTIONS(4241), 1,
      anon_sym_required,
    ACTIONS(4243), 1,
      anon_sym_component,
    ACTIONS(4245), 1,
      anon_sym_enum,
    ACTIONS(4308), 1,
      anon_sym_RBRACE,
    STATE(1517), 1,
      aux_sym_ui_object_initializer_repeat1,
    STATE(1525), 1,
      sym_comment,
    STATE(1573), 1,
      aux_sym_ui_annotated_object_repeat1,
    STATE(3051), 1,
      sym__qml_enum_declaration,
    STATE(3086), 1,
      sym_ui_annotation,
    STATE(4030), 1,
      aux_sym_ui_property_repeat1,
    STATE(4212), 1,
      sym_ui_nested_identifier,
    STATE(4689), 1,
      sym_ui_property_modifier,
    STATE(3039), 11,
      sym_variable_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_ui_object_definition,
      sym_ui_annotated_object_member,
      sym_ui_object_definition_binding,
      sym_ui_binding,
      sym_ui_property,
      sym_ui_required,
      sym_ui_signal,
      sym_ui_inline_component,
    ACTIONS(4225), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_on,
  [25372] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3910), 1,
      anon_sym_EQ_GT,
    ACTIONS(4310), 1,
      anon_sym_EQ,
    STATE(1526), 1,
      sym_comment,
    ACTIONS(3756), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25445] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4306), 1,
      anon_sym_EQ,
    STATE(1527), 1,
      sym_comment,
    ACTIONS(3756), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25515] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4302), 1,
      anon_sym_EQ,
    STATE(1528), 1,
      sym_comment,
    ACTIONS(3756), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25585] = 22,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(4312), 1,
      anon_sym_STAR,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4319), 1,
      anon_sym_RBRACE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4326), 1,
      anon_sym_async,
    ACTIONS(4328), 1,
      anon_sym_readonly,
    STATE(1529), 1,
      sym_comment,
    STATE(2780), 1,
      sym_override_modifier,
    STATE(3342), 1,
      sym__property_name,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4330), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3708), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [25685] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4247), 1,
      anon_sym_EQ,
    STATE(1530), 1,
      sym_comment,
    ACTIONS(3756), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25755] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4298), 1,
      anon_sym_EQ,
    STATE(1531), 1,
      sym_comment,
    ACTIONS(3756), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25825] = 22,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(4312), 1,
      anon_sym_STAR,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4326), 1,
      anon_sym_async,
    ACTIONS(4328), 1,
      anon_sym_readonly,
    ACTIONS(4332), 1,
      anon_sym_RBRACE,
    STATE(1532), 1,
      sym_comment,
    STATE(2780), 1,
      sym_override_modifier,
    STATE(3342), 1,
      sym__property_name,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4330), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3708), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [25925] = 22,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(4312), 1,
      anon_sym_STAR,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4326), 1,
      anon_sym_async,
    ACTIONS(4328), 1,
      anon_sym_readonly,
    ACTIONS(4335), 1,
      anon_sym_RBRACE,
    STATE(1533), 1,
      sym_comment,
    STATE(2780), 1,
      sym_override_modifier,
    STATE(3342), 1,
      sym__property_name,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4330), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3708), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [26025] = 22,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(4312), 1,
      anon_sym_STAR,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4326), 1,
      anon_sym_async,
    ACTIONS(4328), 1,
      anon_sym_readonly,
    ACTIONS(4338), 1,
      anon_sym_RBRACE,
    STATE(1534), 1,
      sym_comment,
    STATE(2780), 1,
      sym_override_modifier,
    STATE(3342), 1,
      sym__property_name,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4330), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3708), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [26125] = 22,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(4312), 1,
      anon_sym_STAR,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4326), 1,
      anon_sym_async,
    ACTIONS(4328), 1,
      anon_sym_readonly,
    ACTIONS(4341), 1,
      anon_sym_RBRACE,
    STATE(1535), 1,
      sym_comment,
    STATE(2780), 1,
      sym_override_modifier,
    STATE(3342), 1,
      sym__property_name,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4330), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3708), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [26225] = 22,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(4312), 1,
      anon_sym_STAR,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4326), 1,
      anon_sym_async,
    ACTIONS(4328), 1,
      anon_sym_readonly,
    ACTIONS(4344), 1,
      anon_sym_RBRACE,
    STATE(1536), 1,
      sym_comment,
    STATE(2780), 1,
      sym_override_modifier,
    STATE(3342), 1,
      sym__property_name,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5251), 1,
      aux_sym_object_repeat1,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4330), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3708), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [26325] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4255), 1,
      anon_sym_EQ,
    STATE(1537), 1,
      sym_comment,
    ACTIONS(3756), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26395] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4310), 1,
      anon_sym_EQ,
    STATE(1538), 1,
      sym_comment,
    ACTIONS(3756), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26465] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4249), 1,
      anon_sym_EQ,
    STATE(1539), 1,
      sym_comment,
    ACTIONS(3756), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26535] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3043), 1,
      sym__automatic_semicolon,
    STATE(1540), 1,
      sym_comment,
    ACTIONS(1798), 12,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1792), 39,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
      anon_sym_enum,
  [26603] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4347), 1,
      sym__automatic_semicolon,
    STATE(1541), 1,
      sym_comment,
    ACTIONS(1856), 12,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1854), 39,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
      anon_sym_enum,
  [26671] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4253), 1,
      anon_sym_EQ,
    STATE(1542), 1,
      sym_comment,
    ACTIONS(3756), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26741] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4251), 1,
      anon_sym_EQ,
    STATE(1543), 1,
      sym_comment,
    ACTIONS(3756), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(3763), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3752), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26811] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1544), 1,
      sym_comment,
    ACTIONS(1904), 12,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1902), 39,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
      anon_sym_enum,
  [26876] = 20,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4349), 1,
      anon_sym_STAR,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    ACTIONS(4353), 1,
      anon_sym_async,
    ACTIONS(4355), 1,
      anon_sym_readonly,
    ACTIONS(4359), 1,
      sym__automatic_semicolon,
    STATE(1545), 1,
      sym_comment,
    STATE(2260), 1,
      sym_statement_block,
    STATE(2755), 1,
      sym_override_modifier,
    STATE(3298), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4357), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3708), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [26971] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1546), 1,
      sym_comment,
    ACTIONS(1856), 14,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1854), 37,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
      anon_sym_enum,
  [27036] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1547), 1,
      sym_comment,
    ACTIONS(1856), 12,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1854), 39,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
      anon_sym_enum,
  [27101] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4362), 1,
      sym__automatic_semicolon,
    STATE(1548), 1,
      sym_comment,
    ACTIONS(1856), 13,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1854), 37,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
      anon_sym_enum,
  [27168] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4312), 1,
      anon_sym_STAR,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4344), 1,
      anon_sym_RBRACE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(1549), 1,
      sym_comment,
    STATE(4153), 1,
      sym__property_name,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5251), 1,
      aux_sym_object_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4366), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2334), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [27259] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4312), 1,
      anon_sym_STAR,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4326), 1,
      anon_sym_async,
    ACTIONS(4335), 1,
      anon_sym_RBRACE,
    ACTIONS(4368), 1,
      anon_sym_LBRACK,
    STATE(1550), 1,
      sym_comment,
    STATE(3342), 1,
      sym__property_name,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4330), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3708), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [27352] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4312), 1,
      anon_sym_STAR,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4326), 1,
      anon_sym_async,
    ACTIONS(4344), 1,
      anon_sym_RBRACE,
    ACTIONS(4368), 1,
      anon_sym_LBRACK,
    STATE(1551), 1,
      sym_comment,
    STATE(3342), 1,
      sym__property_name,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5251), 1,
      aux_sym_object_repeat1,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4330), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3708), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [27445] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4312), 1,
      anon_sym_STAR,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4341), 1,
      anon_sym_RBRACE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(1552), 1,
      sym_comment,
    STATE(4153), 1,
      sym__property_name,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4366), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2334), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [27536] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4312), 1,
      anon_sym_STAR,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4335), 1,
      anon_sym_RBRACE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(1553), 1,
      sym_comment,
    STATE(4153), 1,
      sym__property_name,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4366), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2334), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [27627] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4370), 1,
      sym__automatic_semicolon,
    STATE(1554), 1,
      sym_comment,
    ACTIONS(1798), 13,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1792), 37,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
      anon_sym_enum,
  [27694] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4312), 1,
      anon_sym_STAR,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4326), 1,
      anon_sym_async,
    ACTIONS(4338), 1,
      anon_sym_RBRACE,
    ACTIONS(4368), 1,
      anon_sym_LBRACK,
    STATE(1555), 1,
      sym_comment,
    STATE(3342), 1,
      sym__property_name,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4330), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3708), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [27787] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1556), 1,
      sym_comment,
    ACTIONS(1904), 14,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1902), 37,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
      anon_sym_enum,
  [27852] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4312), 1,
      anon_sym_STAR,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4332), 1,
      anon_sym_RBRACE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(1557), 1,
      sym_comment,
    STATE(4153), 1,
      sym__property_name,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4366), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2334), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [27943] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4312), 1,
      anon_sym_STAR,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4326), 1,
      anon_sym_async,
    ACTIONS(4332), 1,
      anon_sym_RBRACE,
    ACTIONS(4368), 1,
      anon_sym_LBRACK,
    STATE(1558), 1,
      sym_comment,
    STATE(3342), 1,
      sym__property_name,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4330), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3708), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [28036] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4312), 1,
      anon_sym_STAR,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4338), 1,
      anon_sym_RBRACE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(1559), 1,
      sym_comment,
    STATE(4153), 1,
      sym__property_name,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4366), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2334), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [28127] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4312), 1,
      anon_sym_STAR,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4319), 1,
      anon_sym_RBRACE,
    ACTIONS(4326), 1,
      anon_sym_async,
    ACTIONS(4368), 1,
      anon_sym_LBRACK,
    STATE(1560), 1,
      sym_comment,
    STATE(3342), 1,
      sym__property_name,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4330), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3708), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [28220] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4312), 1,
      anon_sym_STAR,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4326), 1,
      anon_sym_async,
    ACTIONS(4341), 1,
      anon_sym_RBRACE,
    ACTIONS(4368), 1,
      anon_sym_LBRACK,
    STATE(1561), 1,
      sym_comment,
    STATE(3342), 1,
      sym__property_name,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4330), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3708), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [28313] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4312), 1,
      anon_sym_STAR,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4319), 1,
      anon_sym_RBRACE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(1562), 1,
      sym_comment,
    STATE(4153), 1,
      sym__property_name,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4366), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2334), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [28404] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4372), 1,
      anon_sym_static,
    ACTIONS(4374), 1,
      anon_sym_readonly,
    ACTIONS(4376), 1,
      anon_sym_abstract,
    STATE(1563), 1,
      sym_comment,
    STATE(2679), 1,
      sym_accessibility_modifier,
    STATE(2878), 1,
      sym_override_modifier,
    STATE(3676), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3708), 24,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [28494] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(4312), 1,
      anon_sym_STAR,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4326), 1,
      anon_sym_async,
    ACTIONS(4328), 1,
      anon_sym_readonly,
    STATE(1564), 1,
      sym_comment,
    STATE(2780), 1,
      sym_override_modifier,
    STATE(3342), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4330), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4378), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3708), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [28586] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2362), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_namespace,
    ACTIONS(2548), 1,
      anon_sym_import,
    ACTIONS(2550), 1,
      anon_sym_var,
    ACTIONS(2552), 1,
      anon_sym_let,
    ACTIONS(2554), 1,
      anon_sym_const,
    ACTIONS(2556), 1,
      anon_sym_class,
    ACTIONS(2558), 1,
      anon_sym_async,
    ACTIONS(2560), 1,
      anon_sym_function,
    ACTIONS(2562), 1,
      anon_sym_declare,
    ACTIONS(2566), 1,
      anon_sym_abstract,
    ACTIONS(2570), 1,
      anon_sym_interface,
    ACTIONS(2572), 1,
      anon_sym_enum,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4338), 1,
      anon_sym_RBRACE,
    ACTIONS(4382), 1,
      anon_sym_STAR,
    ACTIONS(4384), 1,
      anon_sym_default,
    ACTIONS(4386), 1,
      anon_sym_type,
    ACTIONS(4388), 1,
      anon_sym_EQ,
    ACTIONS(4390), 1,
      anon_sym_as,
    ACTIONS(4392), 1,
      anon_sym_module,
    STATE(1202), 1,
      sym_decorator,
    STATE(1565), 1,
      sym_comment,
    STATE(4243), 1,
      aux_sym_export_statement_repeat1,
    STATE(4271), 1,
      sym_declaration,
    STATE(4277), 1,
      sym_internal_module,
    STATE(4826), 1,
      sym_export_clause,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5857), 1,
      sym_namespace_export,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(4205), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [28710] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4341), 1,
      anon_sym_RBRACE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(1566), 1,
      sym_comment,
    STATE(4153), 1,
      sym__property_name,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [28796] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4319), 1,
      anon_sym_RBRACE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(1567), 1,
      sym_comment,
    STATE(4153), 1,
      sym__property_name,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [28882] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4332), 1,
      anon_sym_RBRACE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(1568), 1,
      sym_comment,
    STATE(4153), 1,
      sym__property_name,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [28968] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2362), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_namespace,
    ACTIONS(2548), 1,
      anon_sym_import,
    ACTIONS(2550), 1,
      anon_sym_var,
    ACTIONS(2552), 1,
      anon_sym_let,
    ACTIONS(2554), 1,
      anon_sym_const,
    ACTIONS(2556), 1,
      anon_sym_class,
    ACTIONS(2558), 1,
      anon_sym_async,
    ACTIONS(2560), 1,
      anon_sym_function,
    ACTIONS(2562), 1,
      anon_sym_declare,
    ACTIONS(2566), 1,
      anon_sym_abstract,
    ACTIONS(2570), 1,
      anon_sym_interface,
    ACTIONS(2572), 1,
      anon_sym_enum,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4332), 1,
      anon_sym_RBRACE,
    ACTIONS(4382), 1,
      anon_sym_STAR,
    ACTIONS(4384), 1,
      anon_sym_default,
    ACTIONS(4386), 1,
      anon_sym_type,
    ACTIONS(4388), 1,
      anon_sym_EQ,
    ACTIONS(4390), 1,
      anon_sym_as,
    ACTIONS(4392), 1,
      anon_sym_module,
    STATE(1202), 1,
      sym_decorator,
    STATE(1569), 1,
      sym_comment,
    STATE(4243), 1,
      aux_sym_export_statement_repeat1,
    STATE(4271), 1,
      sym_declaration,
    STATE(4277), 1,
      sym_internal_module,
    STATE(4826), 1,
      sym_export_clause,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5857), 1,
      sym_namespace_export,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(4205), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [29092] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4338), 1,
      anon_sym_RBRACE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(1570), 1,
      sym_comment,
    STATE(4153), 1,
      sym__property_name,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [29178] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4394), 1,
      anon_sym_static,
    ACTIONS(4396), 1,
      anon_sym_readonly,
    ACTIONS(4398), 1,
      anon_sym_abstract,
    STATE(1571), 1,
      sym_comment,
    STATE(2741), 1,
      sym_accessibility_modifier,
    STATE(2816), 1,
      sym_override_modifier,
    STATE(3717), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3708), 24,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [29268] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2362), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_namespace,
    ACTIONS(2548), 1,
      anon_sym_import,
    ACTIONS(2550), 1,
      anon_sym_var,
    ACTIONS(2552), 1,
      anon_sym_let,
    ACTIONS(2554), 1,
      anon_sym_const,
    ACTIONS(2556), 1,
      anon_sym_class,
    ACTIONS(2558), 1,
      anon_sym_async,
    ACTIONS(2560), 1,
      anon_sym_function,
    ACTIONS(2562), 1,
      anon_sym_declare,
    ACTIONS(2566), 1,
      anon_sym_abstract,
    ACTIONS(2570), 1,
      anon_sym_interface,
    ACTIONS(2572), 1,
      anon_sym_enum,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4335), 1,
      anon_sym_RBRACE,
    ACTIONS(4382), 1,
      anon_sym_STAR,
    ACTIONS(4384), 1,
      anon_sym_default,
    ACTIONS(4386), 1,
      anon_sym_type,
    ACTIONS(4388), 1,
      anon_sym_EQ,
    ACTIONS(4390), 1,
      anon_sym_as,
    ACTIONS(4392), 1,
      anon_sym_module,
    STATE(1202), 1,
      sym_decorator,
    STATE(1572), 1,
      sym_comment,
    STATE(4243), 1,
      aux_sym_export_statement_repeat1,
    STATE(4271), 1,
      sym_declaration,
    STATE(4277), 1,
      sym_internal_module,
    STATE(4826), 1,
      sym_export_clause,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5857), 1,
      sym_namespace_export,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(4205), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [29392] = 32,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(17), 1,
      anon_sym_AT,
    ACTIONS(600), 1,
      anon_sym_var,
    ACTIONS(4223), 1,
      sym_identifier,
    ACTIONS(4227), 1,
      anon_sym_default,
    ACTIONS(4231), 1,
      anon_sym_async,
    ACTIONS(4233), 1,
      anon_sym_function,
    ACTIONS(4235), 1,
      anon_sym_readonly,
    ACTIONS(4237), 1,
      anon_sym_property,
    ACTIONS(4239), 1,
      anon_sym_signal,
    ACTIONS(4241), 1,
      anon_sym_required,
    ACTIONS(4243), 1,
      anon_sym_component,
    ACTIONS(4245), 1,
      anon_sym_enum,
    STATE(1573), 1,
      sym_comment,
    STATE(2966), 1,
      aux_sym_ui_annotated_object_repeat1,
    STATE(3029), 1,
      sym_ui_object_definition,
    STATE(3056), 1,
      sym_variable_declaration,
    STATE(3059), 1,
      sym_function_declaration,
    STATE(3062), 1,
      sym_generator_function_declaration,
    STATE(3065), 1,
      sym_ui_object_definition_binding,
    STATE(3070), 1,
      sym_ui_binding,
    STATE(3071), 1,
      sym_ui_property,
    STATE(3072), 1,
      sym_ui_required,
    STATE(3073), 1,
      sym_ui_signal,
    STATE(3078), 1,
      sym_ui_inline_component,
    STATE(3079), 1,
      sym__qml_enum_declaration,
    STATE(3086), 1,
      sym_ui_annotation,
    STATE(4030), 1,
      aux_sym_ui_property_repeat1,
    STATE(4212), 1,
      sym_ui_nested_identifier,
    STATE(4689), 1,
      sym_ui_property_modifier,
    ACTIONS(4225), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_on,
  [29510] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2362), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_namespace,
    ACTIONS(2548), 1,
      anon_sym_import,
    ACTIONS(2550), 1,
      anon_sym_var,
    ACTIONS(2552), 1,
      anon_sym_let,
    ACTIONS(2554), 1,
      anon_sym_const,
    ACTIONS(2556), 1,
      anon_sym_class,
    ACTIONS(2558), 1,
      anon_sym_async,
    ACTIONS(2560), 1,
      anon_sym_function,
    ACTIONS(2562), 1,
      anon_sym_declare,
    ACTIONS(2566), 1,
      anon_sym_abstract,
    ACTIONS(2570), 1,
      anon_sym_interface,
    ACTIONS(2572), 1,
      anon_sym_enum,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4341), 1,
      anon_sym_RBRACE,
    ACTIONS(4382), 1,
      anon_sym_STAR,
    ACTIONS(4384), 1,
      anon_sym_default,
    ACTIONS(4386), 1,
      anon_sym_type,
    ACTIONS(4388), 1,
      anon_sym_EQ,
    ACTIONS(4390), 1,
      anon_sym_as,
    ACTIONS(4392), 1,
      anon_sym_module,
    STATE(1202), 1,
      sym_decorator,
    STATE(1574), 1,
      sym_comment,
    STATE(4243), 1,
      aux_sym_export_statement_repeat1,
    STATE(4271), 1,
      sym_declaration,
    STATE(4277), 1,
      sym_internal_module,
    STATE(4826), 1,
      sym_export_clause,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5857), 1,
      sym_namespace_export,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(4205), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [29634] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2362), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_namespace,
    ACTIONS(2548), 1,
      anon_sym_import,
    ACTIONS(2550), 1,
      anon_sym_var,
    ACTIONS(2552), 1,
      anon_sym_let,
    ACTIONS(2554), 1,
      anon_sym_const,
    ACTIONS(2556), 1,
      anon_sym_class,
    ACTIONS(2558), 1,
      anon_sym_async,
    ACTIONS(2560), 1,
      anon_sym_function,
    ACTIONS(2562), 1,
      anon_sym_declare,
    ACTIONS(2566), 1,
      anon_sym_abstract,
    ACTIONS(2570), 1,
      anon_sym_interface,
    ACTIONS(2572), 1,
      anon_sym_enum,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4319), 1,
      anon_sym_RBRACE,
    ACTIONS(4382), 1,
      anon_sym_STAR,
    ACTIONS(4384), 1,
      anon_sym_default,
    ACTIONS(4386), 1,
      anon_sym_type,
    ACTIONS(4388), 1,
      anon_sym_EQ,
    ACTIONS(4390), 1,
      anon_sym_as,
    ACTIONS(4392), 1,
      anon_sym_module,
    STATE(1202), 1,
      sym_decorator,
    STATE(1575), 1,
      sym_comment,
    STATE(4243), 1,
      aux_sym_export_statement_repeat1,
    STATE(4271), 1,
      sym_declaration,
    STATE(4277), 1,
      sym_internal_module,
    STATE(4826), 1,
      sym_export_clause,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5857), 1,
      sym_namespace_export,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(4205), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [29758] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2362), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_namespace,
    ACTIONS(2548), 1,
      anon_sym_import,
    ACTIONS(2550), 1,
      anon_sym_var,
    ACTIONS(2552), 1,
      anon_sym_let,
    ACTIONS(2554), 1,
      anon_sym_const,
    ACTIONS(2556), 1,
      anon_sym_class,
    ACTIONS(2558), 1,
      anon_sym_async,
    ACTIONS(2560), 1,
      anon_sym_function,
    ACTIONS(2562), 1,
      anon_sym_declare,
    ACTIONS(2566), 1,
      anon_sym_abstract,
    ACTIONS(2570), 1,
      anon_sym_interface,
    ACTIONS(2572), 1,
      anon_sym_enum,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4344), 1,
      anon_sym_RBRACE,
    ACTIONS(4382), 1,
      anon_sym_STAR,
    ACTIONS(4384), 1,
      anon_sym_default,
    ACTIONS(4386), 1,
      anon_sym_type,
    ACTIONS(4388), 1,
      anon_sym_EQ,
    ACTIONS(4390), 1,
      anon_sym_as,
    ACTIONS(4392), 1,
      anon_sym_module,
    STATE(1202), 1,
      sym_decorator,
    STATE(1576), 1,
      sym_comment,
    STATE(4243), 1,
      aux_sym_export_statement_repeat1,
    STATE(4271), 1,
      sym_declaration,
    STATE(4277), 1,
      sym_internal_module,
    STATE(4826), 1,
      sym_export_clause,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5251), 1,
      aux_sym_object_repeat1,
    STATE(5857), 1,
      sym_namespace_export,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(4205), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [29882] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4335), 1,
      anon_sym_RBRACE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(1577), 1,
      sym_comment,
    STATE(4153), 1,
      sym__property_name,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [29968] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4344), 1,
      anon_sym_RBRACE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(1578), 1,
      sym_comment,
    STATE(4153), 1,
      sym__property_name,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5251), 1,
      aux_sym_object_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [30054] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4400), 1,
      anon_sym_STAR,
    ACTIONS(4402), 1,
      anon_sym_async,
    ACTIONS(4406), 1,
      anon_sym_abstract,
    STATE(1579), 1,
      sym_comment,
    STATE(3304), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4404), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3708), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [30137] = 22,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(777), 1,
      anon_sym_RBRACE,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(2339), 1,
      anon_sym_async,
    ACTIONS(2344), 1,
      anon_sym_readonly,
    ACTIONS(2348), 1,
      anon_sym_override,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4408), 1,
      anon_sym_STAR,
    STATE(1580), 1,
      sym_comment,
    STATE(2779), 1,
      sym_override_modifier,
    STATE(4068), 1,
      sym__property_name,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2346), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [30234] = 22,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(791), 1,
      anon_sym_RBRACE,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(2339), 1,
      anon_sym_async,
    ACTIONS(2344), 1,
      anon_sym_readonly,
    ACTIONS(2348), 1,
      anon_sym_override,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4408), 1,
      anon_sym_STAR,
    STATE(1581), 1,
      sym_comment,
    STATE(2779), 1,
      sym_override_modifier,
    STATE(4068), 1,
      sym__property_name,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5251), 1,
      aux_sym_object_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2346), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [30331] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4349), 1,
      anon_sym_STAR,
    ACTIONS(4353), 1,
      anon_sym_async,
    ACTIONS(4368), 1,
      anon_sym_LBRACK,
    ACTIONS(4410), 1,
      anon_sym_abstract,
    STATE(1582), 1,
      sym_comment,
    STATE(3298), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4357), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3708), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [30414] = 22,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(2339), 1,
      anon_sym_async,
    ACTIONS(2344), 1,
      anon_sym_readonly,
    ACTIONS(2348), 1,
      anon_sym_override,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4408), 1,
      anon_sym_STAR,
    ACTIONS(4412), 1,
      anon_sym_RBRACE,
    STATE(1583), 1,
      sym_comment,
    STATE(2779), 1,
      sym_override_modifier,
    STATE(4068), 1,
      sym__property_name,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5251), 1,
      aux_sym_object_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2346), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [30511] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(78), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(3055), 1,
      anon_sym_LBRACE,
    ACTIONS(4004), 1,
      anon_sym_LBRACK,
    ACTIONS(4416), 1,
      anon_sym_COMMA,
    ACTIONS(4418), 1,
      anon_sym_RBRACE,
    STATE(1584), 1,
      sym_comment,
    STATE(5408), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6296), 1,
      sym__property_name,
    STATE(6297), 1,
      sym__destructuring_pattern,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3599), 2,
      sym_object_pattern,
      sym_array_pattern,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    STATE(5409), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    ACTIONS(4414), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [30600] = 17,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4420), 1,
      anon_sym_STAR,
    ACTIONS(4422), 1,
      anon_sym_async,
    ACTIONS(4424), 1,
      anon_sym_readonly,
    STATE(1585), 1,
      sym_comment,
    STATE(2795), 1,
      sym_override_modifier,
    STATE(3399), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4426), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3708), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [30687] = 17,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4428), 1,
      anon_sym_STAR,
    ACTIONS(4430), 1,
      anon_sym_async,
    ACTIONS(4432), 1,
      anon_sym_readonly,
    STATE(1586), 1,
      sym_comment,
    STATE(2790), 1,
      sym_override_modifier,
    STATE(3329), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4434), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3708), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [30774] = 22,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(781), 1,
      anon_sym_RBRACE,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(2339), 1,
      anon_sym_async,
    ACTIONS(2344), 1,
      anon_sym_readonly,
    ACTIONS(2348), 1,
      anon_sym_override,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4408), 1,
      anon_sym_STAR,
    STATE(1587), 1,
      sym_comment,
    STATE(2779), 1,
      sym_override_modifier,
    STATE(4068), 1,
      sym__property_name,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2346), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [30871] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4436), 1,
      anon_sym_static,
    ACTIONS(4438), 1,
      anon_sym_readonly,
    ACTIONS(4440), 1,
      anon_sym_abstract,
    STATE(1588), 1,
      sym_comment,
    STATE(2838), 1,
      sym_override_modifier,
    STATE(3594), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3708), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [30956] = 17,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4400), 1,
      anon_sym_STAR,
    ACTIONS(4402), 1,
      anon_sym_async,
    ACTIONS(4442), 1,
      anon_sym_readonly,
    STATE(1589), 1,
      sym_comment,
    STATE(2792), 1,
      sym_override_modifier,
    STATE(3295), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4404), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3708), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [31043] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4444), 1,
      anon_sym_static,
    ACTIONS(4446), 1,
      anon_sym_readonly,
    ACTIONS(4448), 1,
      anon_sym_abstract,
    STATE(1590), 1,
      sym_comment,
    STATE(2823), 1,
      sym_override_modifier,
    STATE(3715), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3708), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [31128] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4428), 1,
      anon_sym_STAR,
    ACTIONS(4430), 1,
      anon_sym_async,
    ACTIONS(4450), 1,
      anon_sym_abstract,
    STATE(1591), 1,
      sym_comment,
    STATE(3330), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4434), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3708), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [31211] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4452), 1,
      anon_sym_STAR,
    ACTIONS(4454), 1,
      anon_sym_async,
    ACTIONS(4458), 1,
      anon_sym_abstract,
    STATE(1592), 1,
      sym_comment,
    STATE(3324), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4456), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3708), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [31294] = 17,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4452), 1,
      anon_sym_STAR,
    ACTIONS(4454), 1,
      anon_sym_async,
    ACTIONS(4460), 1,
      anon_sym_readonly,
    STATE(1593), 1,
      sym_comment,
    STATE(2787), 1,
      sym_override_modifier,
    STATE(3324), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4456), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3708), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [31381] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(78), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(3055), 1,
      anon_sym_LBRACE,
    ACTIONS(4004), 1,
      anon_sym_LBRACK,
    ACTIONS(4416), 1,
      anon_sym_COMMA,
    ACTIONS(4464), 1,
      anon_sym_RBRACE,
    STATE(1594), 1,
      sym_comment,
    STATE(4996), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6296), 1,
      sym__property_name,
    STATE(6297), 1,
      sym__destructuring_pattern,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3599), 2,
      sym_object_pattern,
      sym_array_pattern,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    STATE(5126), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    ACTIONS(4462), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [31470] = 17,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4466), 1,
      anon_sym_STAR,
    ACTIONS(4468), 1,
      anon_sym_async,
    ACTIONS(4470), 1,
      anon_sym_readonly,
    STATE(1595), 1,
      sym_comment,
    STATE(2786), 1,
      sym_override_modifier,
    STATE(3345), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4472), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3708), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [31557] = 22,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(2339), 1,
      anon_sym_async,
    ACTIONS(2344), 1,
      anon_sym_readonly,
    ACTIONS(2348), 1,
      anon_sym_override,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4408), 1,
      anon_sym_STAR,
    ACTIONS(4474), 1,
      anon_sym_RBRACE,
    STATE(1596), 1,
      sym_comment,
    STATE(2779), 1,
      sym_override_modifier,
    STATE(4068), 1,
      sym__property_name,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2346), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [31654] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4312), 1,
      anon_sym_STAR,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(1597), 1,
      sym_comment,
    STATE(4153), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4366), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4378), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2334), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [31737] = 17,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4476), 1,
      anon_sym_STAR,
    ACTIONS(4478), 1,
      anon_sym_async,
    ACTIONS(4480), 1,
      anon_sym_readonly,
    STATE(1598), 1,
      sym_comment,
    STATE(2773), 1,
      sym_override_modifier,
    STATE(3371), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4482), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3708), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [31824] = 22,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(754), 1,
      anon_sym_RBRACE,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(2339), 1,
      anon_sym_async,
    ACTIONS(2344), 1,
      anon_sym_readonly,
    ACTIONS(2348), 1,
      anon_sym_override,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4408), 1,
      anon_sym_STAR,
    STATE(1599), 1,
      sym_comment,
    STATE(2779), 1,
      sym_override_modifier,
    STATE(4068), 1,
      sym__property_name,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2346), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [31921] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4312), 1,
      anon_sym_STAR,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4326), 1,
      anon_sym_async,
    ACTIONS(4368), 1,
      anon_sym_LBRACK,
    STATE(1600), 1,
      sym_comment,
    STATE(3342), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4330), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4378), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3708), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [32006] = 22,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(2339), 1,
      anon_sym_async,
    ACTIONS(2344), 1,
      anon_sym_readonly,
    ACTIONS(2348), 1,
      anon_sym_override,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4408), 1,
      anon_sym_STAR,
    ACTIONS(4484), 1,
      anon_sym_RBRACE,
    STATE(1601), 1,
      sym_comment,
    STATE(2779), 1,
      sym_override_modifier,
    STATE(4068), 1,
      sym__property_name,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2346), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [32103] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4319), 1,
      anon_sym_RBRACE,
    STATE(1602), 1,
      sym_comment,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2100), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2098), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [32177] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4486), 1,
      anon_sym_STAR,
    STATE(1603), 1,
      sym_comment,
    STATE(4189), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4488), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [32255] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(2339), 1,
      anon_sym_async,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4408), 1,
      anon_sym_STAR,
    ACTIONS(4484), 1,
      anon_sym_RBRACE,
    STATE(1604), 1,
      sym_comment,
    STATE(4068), 1,
      sym__property_name,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2346), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [32345] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4490), 1,
      anon_sym_STAR,
    STATE(1605), 1,
      sym_comment,
    STATE(4184), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4492), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2334), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [32423] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4319), 1,
      anon_sym_RBRACE,
    STATE(1606), 1,
      sym_comment,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2104), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2102), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [32497] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4494), 1,
      anon_sym_STAR,
    ACTIONS(4496), 1,
      anon_sym_async,
    STATE(1607), 1,
      sym_comment,
    STATE(3314), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4498), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3708), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [32577] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(791), 1,
      anon_sym_RBRACE,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4408), 1,
      anon_sym_STAR,
    STATE(1608), 1,
      sym_comment,
    STATE(4068), 1,
      sym__property_name,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5251), 1,
      aux_sym_object_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2346), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [32665] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4368), 1,
      anon_sym_LBRACK,
    ACTIONS(4476), 1,
      anon_sym_STAR,
    ACTIONS(4478), 1,
      anon_sym_async,
    STATE(1609), 1,
      sym_comment,
    STATE(3371), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4482), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3708), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [32745] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4490), 1,
      anon_sym_STAR,
    ACTIONS(4500), 1,
      anon_sym_async,
    STATE(1610), 1,
      sym_comment,
    STATE(3369), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4502), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3708), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [32825] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(2339), 1,
      anon_sym_async,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4408), 1,
      anon_sym_STAR,
    ACTIONS(4474), 1,
      anon_sym_RBRACE,
    STATE(1611), 1,
      sym_comment,
    STATE(4068), 1,
      sym__property_name,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2346), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [32915] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4408), 1,
      anon_sym_STAR,
    ACTIONS(4412), 1,
      anon_sym_RBRACE,
    STATE(1612), 1,
      sym_comment,
    STATE(4068), 1,
      sym__property_name,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5251), 1,
      aux_sym_object_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2346), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [33003] = 32,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2362), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_namespace,
    ACTIONS(2548), 1,
      anon_sym_import,
    ACTIONS(2550), 1,
      anon_sym_var,
    ACTIONS(2552), 1,
      anon_sym_let,
    ACTIONS(2554), 1,
      anon_sym_const,
    ACTIONS(2556), 1,
      anon_sym_class,
    ACTIONS(2558), 1,
      anon_sym_async,
    ACTIONS(2560), 1,
      anon_sym_function,
    ACTIONS(2562), 1,
      anon_sym_declare,
    ACTIONS(2566), 1,
      anon_sym_abstract,
    ACTIONS(2570), 1,
      anon_sym_interface,
    ACTIONS(2572), 1,
      anon_sym_enum,
    ACTIONS(4382), 1,
      anon_sym_STAR,
    ACTIONS(4384), 1,
      anon_sym_default,
    ACTIONS(4386), 1,
      anon_sym_type,
    ACTIONS(4388), 1,
      anon_sym_EQ,
    ACTIONS(4390), 1,
      anon_sym_as,
    ACTIONS(4392), 1,
      anon_sym_module,
    STATE(1202), 1,
      sym_decorator,
    STATE(1613), 1,
      sym_comment,
    STATE(4243), 1,
      aux_sym_export_statement_repeat1,
    STATE(4271), 1,
      sym_declaration,
    STATE(4277), 1,
      sym_internal_module,
    STATE(4826), 1,
      sym_export_clause,
    STATE(5857), 1,
      sym_namespace_export,
    ACTIONS(4378), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(4205), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [33119] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4428), 1,
      anon_sym_STAR,
    ACTIONS(4430), 1,
      anon_sym_async,
    STATE(1614), 1,
      sym_comment,
    STATE(3316), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4434), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3708), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [33199] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(1615), 1,
      sym_comment,
    STATE(4153), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4378), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [33277] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4504), 1,
      anon_sym_STAR,
    STATE(1616), 1,
      sym_comment,
    STATE(4041), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4506), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2334), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [33355] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4408), 1,
      anon_sym_STAR,
    ACTIONS(4484), 1,
      anon_sym_RBRACE,
    STATE(1617), 1,
      sym_comment,
    STATE(4068), 1,
      sym__property_name,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2346), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [33443] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4476), 1,
      anon_sym_STAR,
    STATE(1618), 1,
      sym_comment,
    STATE(4105), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4508), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2334), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [33521] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(754), 1,
      anon_sym_RBRACE,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4408), 1,
      anon_sym_STAR,
    STATE(1619), 1,
      sym_comment,
    STATE(4068), 1,
      sym__property_name,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2346), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [33609] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4420), 1,
      anon_sym_STAR,
    ACTIONS(4422), 1,
      anon_sym_async,
    STATE(1620), 1,
      sym_comment,
    STATE(3399), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4426), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3708), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [33689] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4466), 1,
      anon_sym_STAR,
    ACTIONS(4468), 1,
      anon_sym_async,
    STATE(1621), 1,
      sym_comment,
    STATE(3345), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4472), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3708), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [33769] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(777), 1,
      anon_sym_RBRACE,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(2339), 1,
      anon_sym_async,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4408), 1,
      anon_sym_STAR,
    STATE(1622), 1,
      sym_comment,
    STATE(4068), 1,
      sym__property_name,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2346), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [33859] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(777), 1,
      anon_sym_RBRACE,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4408), 1,
      anon_sym_STAR,
    STATE(1623), 1,
      sym_comment,
    STATE(4068), 1,
      sym__property_name,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2346), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [33947] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(791), 1,
      anon_sym_RBRACE,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(2339), 1,
      anon_sym_async,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4408), 1,
      anon_sym_STAR,
    STATE(1624), 1,
      sym_comment,
    STATE(4068), 1,
      sym__property_name,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5251), 1,
      aux_sym_object_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2346), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [34037] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4335), 1,
      anon_sym_RBRACE,
    STATE(1625), 1,
      sym_comment,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2100), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2098), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [34111] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4510), 1,
      anon_sym_STAR,
    ACTIONS(4512), 1,
      anon_sym_async,
    STATE(1626), 1,
      sym_comment,
    STATE(3307), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4514), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3708), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [34191] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4516), 1,
      anon_sym_STAR,
    ACTIONS(4518), 1,
      anon_sym_async,
    STATE(1627), 1,
      sym_comment,
    STATE(3347), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4520), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3708), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [34271] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4344), 1,
      anon_sym_RBRACE,
    STATE(1628), 1,
      sym_comment,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5251), 1,
      aux_sym_object_repeat1,
    ACTIONS(2104), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2102), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [34345] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4494), 1,
      anon_sym_STAR,
    STATE(1629), 1,
      sym_comment,
    STATE(4167), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4522), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [34423] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4341), 1,
      anon_sym_RBRACE,
    STATE(1630), 1,
      sym_comment,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2100), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2098), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [34497] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4341), 1,
      anon_sym_RBRACE,
    STATE(1631), 1,
      sym_comment,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2104), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2102), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [34571] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4510), 1,
      anon_sym_STAR,
    STATE(1632), 1,
      sym_comment,
    STATE(4141), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4524), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [34649] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4526), 1,
      anon_sym_STAR,
    STATE(1633), 1,
      sym_comment,
    STATE(4130), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4528), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2334), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [34727] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4344), 1,
      anon_sym_RBRACE,
    STATE(1634), 1,
      sym_comment,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5251), 1,
      aux_sym_object_repeat1,
    ACTIONS(2100), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2098), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [34801] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(781), 1,
      anon_sym_RBRACE,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(2339), 1,
      anon_sym_async,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4408), 1,
      anon_sym_STAR,
    STATE(1635), 1,
      sym_comment,
    STATE(4068), 1,
      sym__property_name,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2346), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [34891] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4530), 1,
      anon_sym_STAR,
    ACTIONS(4532), 1,
      anon_sym_async,
    STATE(1636), 1,
      sym_comment,
    STATE(3290), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4534), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3708), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [34971] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4408), 1,
      anon_sym_STAR,
    ACTIONS(4474), 1,
      anon_sym_RBRACE,
    STATE(1637), 1,
      sym_comment,
    STATE(4068), 1,
      sym__property_name,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2346), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [35059] = 31,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2362), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_namespace,
    ACTIONS(2548), 1,
      anon_sym_import,
    ACTIONS(2550), 1,
      anon_sym_var,
    ACTIONS(2552), 1,
      anon_sym_let,
    ACTIONS(2554), 1,
      anon_sym_const,
    ACTIONS(2556), 1,
      anon_sym_class,
    ACTIONS(2558), 1,
      anon_sym_async,
    ACTIONS(2560), 1,
      anon_sym_function,
    ACTIONS(2562), 1,
      anon_sym_declare,
    ACTIONS(2566), 1,
      anon_sym_abstract,
    ACTIONS(2570), 1,
      anon_sym_interface,
    ACTIONS(2572), 1,
      anon_sym_enum,
    ACTIONS(4382), 1,
      anon_sym_STAR,
    ACTIONS(4384), 1,
      anon_sym_default,
    ACTIONS(4386), 1,
      anon_sym_type,
    ACTIONS(4390), 1,
      anon_sym_as,
    ACTIONS(4392), 1,
      anon_sym_module,
    ACTIONS(4536), 1,
      anon_sym_EQ,
    STATE(1202), 1,
      sym_decorator,
    STATE(1638), 1,
      sym_comment,
    STATE(4243), 1,
      aux_sym_export_statement_repeat1,
    STATE(4271), 1,
      sym_declaration,
    STATE(4277), 1,
      sym_internal_module,
    STATE(4826), 1,
      sym_export_clause,
    STATE(5857), 1,
      sym_namespace_export,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(4205), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [35173] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4400), 1,
      anon_sym_STAR,
    STATE(1639), 1,
      sym_comment,
    STATE(4155), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4538), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [35251] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1640), 1,
      sym_comment,
    ACTIONS(1850), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(1852), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [35313] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4332), 1,
      anon_sym_RBRACE,
    STATE(1641), 1,
      sym_comment,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2100), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2098), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [35387] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1642), 1,
      sym_comment,
    ACTIONS(1858), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(1860), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [35449] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4540), 1,
      anon_sym_STAR,
    ACTIONS(4542), 1,
      anon_sym_async,
    STATE(1643), 1,
      sym_comment,
    STATE(3378), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4544), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3708), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [35529] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4332), 1,
      anon_sym_RBRACE,
    STATE(1644), 1,
      sym_comment,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2104), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2102), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [35603] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(78), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(3055), 1,
      anon_sym_LBRACE,
    ACTIONS(4004), 1,
      anon_sym_LBRACK,
    STATE(1645), 1,
      sym_comment,
    STATE(6296), 1,
      sym__property_name,
    STATE(6297), 1,
      sym__destructuring_pattern,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4548), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3599), 2,
      sym_object_pattern,
      sym_array_pattern,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    STATE(5553), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    ACTIONS(4546), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [35687] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(781), 1,
      anon_sym_RBRACE,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4408), 1,
      anon_sym_STAR,
    STATE(1646), 1,
      sym_comment,
    STATE(4068), 1,
      sym__property_name,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2346), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [35775] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4530), 1,
      anon_sym_STAR,
    STATE(1647), 1,
      sym_comment,
    STATE(4181), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4550), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [35853] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4530), 1,
      anon_sym_STAR,
    ACTIONS(4532), 1,
      anon_sym_async,
    STATE(1648), 1,
      sym_comment,
    STATE(3308), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4534), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3708), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [35933] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4552), 1,
      anon_sym_STAR,
    STATE(1649), 1,
      sym_comment,
    STATE(4182), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4554), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [36011] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(754), 1,
      anon_sym_RBRACE,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(2339), 1,
      anon_sym_async,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4408), 1,
      anon_sym_STAR,
    STATE(1650), 1,
      sym_comment,
    STATE(4068), 1,
      sym__property_name,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2346), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [36101] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4556), 1,
      anon_sym_STAR,
    ACTIONS(4558), 1,
      anon_sym_async,
    STATE(1651), 1,
      sym_comment,
    STATE(3360), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4560), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3708), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [36181] = 24,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(145), 1,
      anon_sym_STAR,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(2048), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4564), 1,
      anon_sym_COMMA,
    ACTIONS(4566), 1,
      anon_sym_RBRACE,
    ACTIONS(4568), 1,
      anon_sym_async,
    ACTIONS(4570), 1,
      anon_sym_static,
    ACTIONS(4572), 1,
      anon_sym_readonly,
    ACTIONS(4578), 1,
      anon_sym_override,
    STATE(1652), 1,
      sym_comment,
    STATE(2731), 1,
      sym_accessibility_modifier,
    STATE(2774), 1,
      sym_override_modifier,
    STATE(3876), 1,
      sym__property_name,
    STATE(4952), 1,
      aux_sym_object_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4574), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4576), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4950), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4562), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [36281] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4516), 1,
      anon_sym_STAR,
    STATE(1653), 1,
      sym_comment,
    STATE(4133), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4580), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2334), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [36359] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4452), 1,
      anon_sym_STAR,
    ACTIONS(4454), 1,
      anon_sym_async,
    STATE(1654), 1,
      sym_comment,
    STATE(3324), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4456), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3708), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [36439] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4452), 1,
      anon_sym_STAR,
    STATE(1655), 1,
      sym_comment,
    STATE(4124), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4582), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [36517] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4428), 1,
      anon_sym_STAR,
    ACTIONS(4430), 1,
      anon_sym_async,
    STATE(1656), 1,
      sym_comment,
    STATE(3315), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4434), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3708), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [36597] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4556), 1,
      anon_sym_STAR,
    STATE(1657), 1,
      sym_comment,
    STATE(4157), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4584), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2334), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [36675] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4540), 1,
      anon_sym_STAR,
    STATE(1658), 1,
      sym_comment,
    STATE(4131), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4586), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2334), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [36753] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4428), 1,
      anon_sym_STAR,
    STATE(1659), 1,
      sym_comment,
    STATE(4173), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4588), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [36831] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_STAR,
    STATE(1660), 1,
      sym_comment,
    STATE(4185), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4592), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [36909] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4466), 1,
      anon_sym_STAR,
    STATE(1661), 1,
      sym_comment,
    STATE(4144), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4594), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2334), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [36987] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1662), 1,
      sym_comment,
    ACTIONS(2104), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4322), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2102), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [37051] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4530), 1,
      anon_sym_STAR,
    ACTIONS(4532), 1,
      anon_sym_async,
    STATE(1663), 1,
      sym_comment,
    STATE(3288), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4534), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3708), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [37131] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4552), 1,
      anon_sym_STAR,
    ACTIONS(4596), 1,
      anon_sym_async,
    STATE(1664), 1,
      sym_comment,
    STATE(3320), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4598), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3708), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [37211] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(2339), 1,
      anon_sym_async,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4408), 1,
      anon_sym_STAR,
    ACTIONS(4412), 1,
      anon_sym_RBRACE,
    STATE(1665), 1,
      sym_comment,
    STATE(4068), 1,
      sym__property_name,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5251), 1,
      aux_sym_object_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2346), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [37301] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4338), 1,
      anon_sym_RBRACE,
    STATE(1666), 1,
      sym_comment,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2100), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2098), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [37375] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4349), 1,
      anon_sym_STAR,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(1667), 1,
      sym_comment,
    STATE(4098), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4600), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [37453] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4335), 1,
      anon_sym_RBRACE,
    STATE(1668), 1,
      sym_comment,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2104), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2102), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [37527] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4338), 1,
      anon_sym_RBRACE,
    STATE(1669), 1,
      sym_comment,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2104), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2102), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [37601] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4420), 1,
      anon_sym_STAR,
    STATE(1670), 1,
      sym_comment,
    STATE(4126), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4602), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2334), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [37679] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(1671), 1,
      sym_comment,
    STATE(4157), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [37752] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(781), 1,
      anon_sym_RBRACE,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(1672), 1,
      sym_comment,
    STATE(4068), 1,
      sym__property_name,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [37835] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(1673), 1,
      sym_comment,
    STATE(4105), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [37908] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(1674), 1,
      sym_comment,
    STATE(4144), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [37981] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(1675), 1,
      sym_comment,
    STATE(4185), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [38054] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(791), 1,
      anon_sym_RBRACE,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(1676), 1,
      sym_comment,
    STATE(4068), 1,
      sym__property_name,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5251), 1,
      aux_sym_object_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [38137] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4412), 1,
      anon_sym_RBRACE,
    STATE(1677), 1,
      sym_comment,
    STATE(4068), 1,
      sym__property_name,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5251), 1,
      aux_sym_object_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [38220] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(1678), 1,
      sym_comment,
    STATE(4124), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [38293] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(1679), 1,
      sym_comment,
    STATE(4126), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [38366] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4484), 1,
      anon_sym_RBRACE,
    STATE(1680), 1,
      sym_comment,
    STATE(4068), 1,
      sym__property_name,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [38449] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(2339), 1,
      anon_sym_async,
    ACTIONS(2344), 1,
      anon_sym_readonly,
    ACTIONS(2348), 1,
      anon_sym_override,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4408), 1,
      anon_sym_STAR,
    STATE(1681), 1,
      sym_comment,
    STATE(2779), 1,
      sym_override_modifier,
    STATE(4068), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2346), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4604), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [38538] = 22,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(145), 1,
      anon_sym_STAR,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(2048), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4611), 1,
      anon_sym_async,
    ACTIONS(4613), 1,
      anon_sym_static,
    ACTIONS(4615), 1,
      anon_sym_readonly,
    ACTIONS(4621), 1,
      anon_sym_override,
    STATE(1682), 1,
      sym_comment,
    STATE(2731), 1,
      sym_accessibility_modifier,
    STATE(2774), 1,
      sym_override_modifier,
    STATE(3876), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4609), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4617), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4619), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5562), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4607), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [38633] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(1683), 1,
      sym_comment,
    STATE(4147), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [38706] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4629), 1,
      anon_sym_DOT,
    ACTIONS(4631), 1,
      anon_sym_LT,
    STATE(1684), 1,
      sym_comment,
    STATE(1795), 1,
      sym_arguments,
    STATE(1797), 1,
      sym_type_arguments,
    ACTIONS(4623), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4625), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [38777] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(1685), 1,
      sym_comment,
    STATE(4167), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [38850] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(1686), 1,
      sym_comment,
    STATE(4141), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [38923] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(1687), 1,
      sym_comment,
    STATE(4133), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [38996] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(1688), 1,
      sym_comment,
    STATE(4173), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [39069] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(1689), 1,
      sym_comment,
    STATE(4131), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [39142] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(754), 1,
      anon_sym_RBRACE,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(1690), 1,
      sym_comment,
    STATE(4068), 1,
      sym__property_name,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [39225] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(1691), 1,
      sym_comment,
    STATE(4130), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [39298] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(1692), 1,
      sym_comment,
    STATE(4098), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [39371] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1693), 1,
      sym_comment,
    ACTIONS(2100), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4322), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2098), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [39434] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(1694), 1,
      sym_comment,
    STATE(4181), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [39507] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(1695), 1,
      sym_comment,
    STATE(4182), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [39580] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    STATE(1696), 1,
      sym_comment,
    STATE(3713), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3708), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [39653] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4631), 1,
      anon_sym_LT,
    ACTIONS(4637), 1,
      anon_sym_DOT,
    STATE(1697), 1,
      sym_comment,
    STATE(1798), 1,
      sym_arguments,
    STATE(1799), 1,
      sym_type_arguments,
    ACTIONS(4633), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4635), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [39724] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4474), 1,
      anon_sym_RBRACE,
    STATE(1698), 1,
      sym_comment,
    STATE(4068), 1,
      sym__property_name,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [39807] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(1699), 1,
      sym_comment,
    STATE(4184), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [39880] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(1700), 1,
      sym_comment,
    STATE(4155), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [39953] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4631), 1,
      anon_sym_LT,
    ACTIONS(4639), 1,
      anon_sym_DOT,
    STATE(1701), 1,
      sym_comment,
    STATE(1793), 1,
      sym_arguments,
    STATE(1794), 1,
      sym_type_arguments,
    ACTIONS(3806), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3796), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [40024] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(1702), 1,
      sym_comment,
    STATE(4041), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [40097] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4631), 1,
      anon_sym_LT,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4649), 1,
      anon_sym_QMARK_DOT,
    STATE(1703), 1,
      sym_comment,
    STATE(1796), 1,
      sym_type_arguments,
    STATE(2072), 1,
      sym_arguments,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4641), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4643), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [40174] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(1704), 1,
      sym_comment,
    STATE(4189), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [40247] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(777), 1,
      anon_sym_RBRACE,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(1705), 1,
      sym_comment,
    STATE(4068), 1,
      sym__property_name,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [40330] = 20,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(2339), 1,
      anon_sym_async,
    ACTIONS(2344), 1,
      anon_sym_readonly,
    ACTIONS(2348), 1,
      anon_sym_override,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4408), 1,
      anon_sym_STAR,
    ACTIONS(4564), 1,
      anon_sym_COMMA,
    ACTIONS(4651), 1,
      anon_sym_RBRACE,
    STATE(1706), 1,
      sym_comment,
    STATE(2779), 1,
      sym_override_modifier,
    STATE(4068), 1,
      sym__property_name,
    STATE(4998), 1,
      aux_sym_object_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2346), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [40421] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4631), 1,
      anon_sym_LT,
    ACTIONS(4655), 1,
      anon_sym_DOT,
    ACTIONS(4657), 1,
      anon_sym_is,
    STATE(1707), 1,
      sym_comment,
    STATE(1777), 1,
      sym_type_arguments,
    ACTIONS(4653), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3842), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [40490] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    STATE(1708), 1,
      sym_comment,
    STATE(3715), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3708), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [40563] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(1709), 1,
      sym_comment,
    STATE(4122), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [40636] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4663), 1,
      anon_sym_is,
    STATE(1710), 1,
      sym_comment,
    ACTIONS(4659), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4661), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [40698] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4657), 1,
      anon_sym_is,
    STATE(1711), 1,
      sym_comment,
    ACTIONS(4665), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [40760] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(2339), 1,
      anon_sym_async,
    ACTIONS(2344), 1,
      anon_sym_readonly,
    ACTIONS(2348), 1,
      anon_sym_override,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4408), 1,
      anon_sym_STAR,
    STATE(1712), 1,
      sym_comment,
    STATE(2779), 1,
      sym_override_modifier,
    STATE(4068), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2346), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4669), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [40846] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4657), 1,
      anon_sym_is,
    STATE(1713), 1,
      sym_comment,
    ACTIONS(4671), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4673), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [40908] = 17,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(2339), 1,
      anon_sym_async,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4408), 1,
      anon_sym_STAR,
    ACTIONS(4564), 1,
      anon_sym_COMMA,
    ACTIONS(4651), 1,
      anon_sym_RBRACE,
    STATE(1714), 1,
      sym_comment,
    STATE(4068), 1,
      sym__property_name,
    STATE(4998), 1,
      aux_sym_object_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2346), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [40992] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1715), 1,
      sym_comment,
    ACTIONS(3686), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(3688), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [41052] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4408), 1,
      anon_sym_STAR,
    ACTIONS(4564), 1,
      anon_sym_COMMA,
    ACTIONS(4651), 1,
      anon_sym_RBRACE,
    STATE(1716), 1,
      sym_comment,
    STATE(4068), 1,
      sym__property_name,
    STATE(4998), 1,
      aux_sym_object_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2346), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [41134] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4675), 1,
      anon_sym_readonly,
    STATE(1717), 1,
      sym_comment,
    STATE(2849), 1,
      sym_override_modifier,
    STATE(3713), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3708), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [41212] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4677), 1,
      anon_sym_abstract,
    STATE(1718), 1,
      sym_comment,
    STATE(3713), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3708), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [41286] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4458), 1,
      anon_sym_abstract,
    STATE(1719), 1,
      sym_comment,
    STATE(3715), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3708), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [41360] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4679), 1,
      anon_sym_readonly,
    STATE(1720), 1,
      sym_comment,
    STATE(2823), 1,
      sym_override_modifier,
    STATE(3715), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3708), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [41438] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4681), 1,
      anon_sym_abstract,
    STATE(1721), 1,
      sym_comment,
    STATE(3730), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3708), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [41512] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1722), 1,
      sym_comment,
    ACTIONS(4683), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4685), 33,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_is,
  [41572] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4687), 1,
      anon_sym_readonly,
    STATE(1723), 1,
      sym_comment,
    STATE(2865), 1,
      sym_override_modifier,
    STATE(3731), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3708), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [41650] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4689), 1,
      anon_sym_abstract,
    STATE(1724), 1,
      sym_comment,
    STATE(3684), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3708), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [41724] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1725), 1,
      sym_comment,
    ACTIONS(1858), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(1860), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [41784] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1796), 1,
      anon_sym_EQ,
    ACTIONS(4691), 1,
      sym__automatic_semicolon,
    STATE(1726), 1,
      sym_comment,
    ACTIONS(1792), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1798), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [41848] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    STATE(1727), 1,
      sym_comment,
    STATE(2053), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4693), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4695), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [41914] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4697), 1,
      anon_sym_readonly,
    STATE(1728), 1,
      sym_comment,
    STATE(2873), 1,
      sym_override_modifier,
    STATE(3721), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3708), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [41992] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1729), 1,
      sym_comment,
    ACTIONS(1711), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1709), 33,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_is,
  [42052] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1730), 1,
      sym_comment,
    ACTIONS(1850), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(1852), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [42112] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4408), 1,
      anon_sym_STAR,
    STATE(1731), 1,
      sym_comment,
    STATE(4068), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2346), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4604), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [42192] = 25,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(3986), 1,
      anon_sym_AT,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4699), 1,
      anon_sym_STAR,
    ACTIONS(4701), 1,
      anon_sym_async,
    ACTIONS(4703), 1,
      anon_sym_static,
    ACTIONS(4705), 1,
      anon_sym_readonly,
    ACTIONS(4709), 1,
      anon_sym_declare,
    ACTIONS(4711), 1,
      anon_sym_abstract,
    STATE(1732), 1,
      sym_comment,
    STATE(2168), 1,
      sym_method_definition,
    STATE(2668), 1,
      sym_accessibility_modifier,
    STATE(2694), 1,
      aux_sym_export_statement_repeat1,
    STATE(2772), 1,
      sym_override_modifier,
    STATE(2850), 1,
      sym_decorator,
    STATE(3297), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4707), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3730), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    ACTIONS(3708), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [42292] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(2339), 1,
      anon_sym_async,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4408), 1,
      anon_sym_STAR,
    STATE(1733), 1,
      sym_comment,
    STATE(4068), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2346), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4604), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [42374] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4713), 1,
      anon_sym_LBRACE,
    STATE(1734), 1,
      sym_comment,
    STATE(1983), 1,
      sym_statement_block,
    ACTIONS(1818), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1822), 31,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [42438] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4715), 1,
      anon_sym_readonly,
    STATE(1735), 1,
      sym_comment,
    STATE(2803), 1,
      sym_override_modifier,
    STATE(3686), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3708), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [42516] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1736), 1,
      sym_comment,
    ACTIONS(3678), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(3680), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [42576] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    STATE(1737), 1,
      sym_comment,
    ACTIONS(4378), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2104), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2102), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [42642] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4713), 1,
      anon_sym_LBRACE,
    ACTIONS(4717), 1,
      anon_sym_DOT,
    STATE(1738), 1,
      sym_comment,
    STATE(1983), 1,
      sym_statement_block,
    ACTIONS(1818), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1822), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [42708] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4631), 1,
      anon_sym_LT,
    ACTIONS(4655), 1,
      anon_sym_DOT,
    STATE(1739), 1,
      sym_comment,
    STATE(1777), 1,
      sym_type_arguments,
    ACTIONS(4653), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3842), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [42774] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4713), 1,
      anon_sym_LBRACE,
    ACTIONS(4719), 1,
      anon_sym_DOT,
    STATE(1740), 1,
      sym_comment,
    STATE(1983), 1,
      sym_statement_block,
    ACTIONS(1818), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1822), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [42840] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4721), 1,
      anon_sym_abstract,
    STATE(1741), 1,
      sym_comment,
    STATE(3720), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3708), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [42914] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1742), 1,
      sym_comment,
    ACTIONS(3682), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(3684), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [42974] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    STATE(1743), 1,
      sym_comment,
    ACTIONS(4378), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2100), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2098), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [43040] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4631), 1,
      anon_sym_LT,
    STATE(1744), 1,
      sym_comment,
    STATE(1783), 1,
      sym_type_arguments,
    ACTIONS(4659), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4661), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [43104] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1745), 1,
      sym_comment,
    ACTIONS(4659), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4661), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [43163] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(1746), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4727), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [43280] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1747), 1,
      sym_comment,
    ACTIONS(3091), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3093), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [43339] = 38,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(3855), 1,
      anon_sym_COLON,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    ACTIONS(4771), 1,
      anon_sym_COMMA,
    ACTIONS(4773), 1,
      anon_sym_RPAREN,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(1748), 1,
      sym_comment,
    STATE(4039), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(4963), 1,
      sym_optional_chain,
    STATE(6203), 1,
      sym_type_annotation,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [43464] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1749), 1,
      sym_comment,
    ACTIONS(3091), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3093), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [43523] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4779), 1,
      anon_sym_QMARK,
    ACTIONS(4781), 1,
      anon_sym_extends,
    STATE(1750), 1,
      sym_comment,
    ACTIONS(4775), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4777), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [43586] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1751), 1,
      sym_comment,
    ACTIONS(3145), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3147), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [43645] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1752), 1,
      sym_comment,
    ACTIONS(3153), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3155), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [43704] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1753), 1,
      sym_comment,
    ACTIONS(3159), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3161), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [43763] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1754), 1,
      sym_comment,
    ACTIONS(3119), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3121), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [43822] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4474), 1,
      anon_sym_RBRACE,
    STATE(1755), 1,
      sym_comment,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2100), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2098), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [43893] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1756), 1,
      sym_comment,
    ACTIONS(3119), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3121), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [43952] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1757), 1,
      sym_comment,
    ACTIONS(4783), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4785), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [44011] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1758), 1,
      sym_comment,
    ACTIONS(4787), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4789), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3752), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [44074] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1759), 1,
      sym_comment,
    ACTIONS(4791), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4793), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [44133] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1760), 1,
      sym_comment,
    ACTIONS(4665), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [44192] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1761), 1,
      sym_comment,
    ACTIONS(4795), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4797), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [44251] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4799), 1,
      anon_sym_LBRACK,
    STATE(1762), 1,
      sym_comment,
    ACTIONS(4795), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4797), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [44312] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1763), 1,
      sym_comment,
    ACTIONS(4801), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4803), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [44371] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4809), 1,
      anon_sym_DOT,
    STATE(1764), 1,
      sym_comment,
    ACTIONS(4805), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4807), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [44432] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4812), 1,
      anon_sym_DOT,
    STATE(1765), 1,
      sym_comment,
    ACTIONS(4805), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4807), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [44493] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4564), 1,
      anon_sym_COMMA,
    ACTIONS(4651), 1,
      anon_sym_RBRACE,
    STATE(1766), 1,
      sym_comment,
    STATE(4068), 1,
      sym__property_name,
    STATE(4998), 1,
      aux_sym_object_repeat1,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [44570] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    STATE(1767), 1,
      sym_comment,
    STATE(3659), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3708), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [44641] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1768), 1,
      sym_comment,
    ACTIONS(2396), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2398), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [44700] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4819), 1,
      anon_sym_DOT,
    STATE(1769), 1,
      sym_comment,
    ACTIONS(4815), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4817), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [44761] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1770), 1,
      sym_comment,
    ACTIONS(4821), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4823), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [44820] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    STATE(1771), 1,
      sym_comment,
    STATE(3643), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3708), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [44891] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1772), 1,
      sym_comment,
    ACTIONS(4825), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4827), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [44950] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1773), 1,
      sym_comment,
    ACTIONS(4829), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4831), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [45009] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4837), 1,
      anon_sym_AMP,
    STATE(1774), 1,
      sym_comment,
    ACTIONS(4833), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4835), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [45070] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1775), 1,
      sym_comment,
    ACTIONS(4789), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4787), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [45129] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1776), 1,
      sym_comment,
    ACTIONS(4839), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4841), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [45188] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1777), 1,
      sym_comment,
    ACTIONS(4843), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4845), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [45247] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4837), 1,
      anon_sym_AMP,
    ACTIONS(4851), 1,
      anon_sym_PIPE,
    ACTIONS(4853), 1,
      anon_sym_extends,
    STATE(1778), 1,
      sym_comment,
    ACTIONS(4847), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4849), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [45312] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4797), 1,
      anon_sym_extends,
    ACTIONS(4799), 1,
      anon_sym_LBRACK,
    STATE(1779), 1,
      sym_comment,
    ACTIONS(4795), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4855), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4857), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [45377] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4863), 1,
      anon_sym_extends,
    STATE(1780), 1,
      sym_comment,
    ACTIONS(4859), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4861), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [45438] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4799), 1,
      anon_sym_LBRACK,
    STATE(1781), 1,
      sym_comment,
    ACTIONS(4865), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4867), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [45499] = 38,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(3855), 1,
      anon_sym_COLON,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    ACTIONS(4771), 1,
      anon_sym_COMMA,
    ACTIONS(4869), 1,
      anon_sym_RPAREN,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(1782), 1,
      sym_comment,
    STATE(4039), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(4963), 1,
      sym_optional_chain,
    STATE(6006), 1,
      sym_type_annotation,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45624] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1783), 1,
      sym_comment,
    ACTIONS(4871), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4873), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [45683] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    STATE(1784), 1,
      sym_comment,
    STATE(3652), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3708), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [45754] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4474), 1,
      anon_sym_RBRACE,
    STATE(1785), 1,
      sym_comment,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2104), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2102), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [45825] = 38,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(3855), 1,
      anon_sym_COLON,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    ACTIONS(4771), 1,
      anon_sym_COMMA,
    ACTIONS(4875), 1,
      anon_sym_RPAREN,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(1786), 1,
      sym_comment,
    STATE(4039), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(4963), 1,
      sym_optional_chain,
    STATE(6034), 1,
      sym_type_annotation,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45950] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(791), 1,
      anon_sym_RBRACE,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    STATE(1787), 1,
      sym_comment,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5251), 1,
      aux_sym_object_repeat1,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2104), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2102), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [46021] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(791), 1,
      anon_sym_RBRACE,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    STATE(1788), 1,
      sym_comment,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5251), 1,
      aux_sym_object_repeat1,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2100), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2098), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [46092] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(777), 1,
      anon_sym_RBRACE,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    STATE(1789), 1,
      sym_comment,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2100), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2098), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [46163] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(777), 1,
      anon_sym_RBRACE,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    STATE(1790), 1,
      sym_comment,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2104), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2102), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [46234] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4881), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(1791), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4877), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4879), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [46313] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1792), 1,
      sym_comment,
    ACTIONS(2404), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2406), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [46372] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1793), 1,
      sym_comment,
    ACTIONS(4779), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4781), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [46431] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1794), 1,
      sym_comment,
    ACTIONS(4884), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4886), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [46490] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1795), 1,
      sym_comment,
    ACTIONS(4888), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4890), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [46549] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    STATE(1796), 1,
      sym_comment,
    STATE(1972), 1,
      sym_arguments,
    ACTIONS(4892), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4894), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [46612] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1797), 1,
      sym_comment,
    ACTIONS(4896), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4898), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [46671] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1798), 1,
      sym_comment,
    ACTIONS(4900), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4902), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [46730] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1799), 1,
      sym_comment,
    ACTIONS(4904), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4906), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [46789] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    STATE(1800), 1,
      sym_comment,
    STATE(3588), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3708), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [46860] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1796), 1,
      anon_sym_EQ,
    ACTIONS(2398), 1,
      anon_sym_extends,
    STATE(1801), 1,
      sym_comment,
    ACTIONS(4908), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4911), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1794), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1800), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [46927] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    STATE(1802), 1,
      sym_comment,
    STATE(3703), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3708), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [46998] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4827), 1,
      anon_sym_extends,
    ACTIONS(4916), 1,
      anon_sym_EQ,
    STATE(1803), 1,
      sym_comment,
    ACTIONS(4920), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4923), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4914), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4918), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [47065] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4661), 1,
      anon_sym_extends,
    STATE(1804), 1,
      sym_comment,
    ACTIONS(4926), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4928), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [47126] = 38,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(3855), 1,
      anon_sym_COLON,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    ACTIONS(4771), 1,
      anon_sym_COMMA,
    ACTIONS(4930), 1,
      anon_sym_RPAREN,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(1805), 1,
      sym_comment,
    STATE(4039), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(4963), 1,
      sym_optional_chain,
    STATE(5946), 1,
      sym_type_annotation,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47251] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1806), 1,
      sym_comment,
    ACTIONS(4932), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4934), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [47310] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1807), 1,
      sym_comment,
    ACTIONS(4936), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4938), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [47369] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1808), 1,
      sym_comment,
    ACTIONS(4940), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4942), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [47428] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4837), 1,
      anon_sym_AMP,
    ACTIONS(4851), 1,
      anon_sym_PIPE,
    ACTIONS(4853), 1,
      anon_sym_extends,
    STATE(1809), 1,
      sym_comment,
    ACTIONS(4926), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4928), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [47493] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    STATE(1810), 1,
      sym_comment,
    STATE(3737), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3708), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [47564] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1811), 1,
      sym_comment,
    ACTIONS(4944), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4946), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [47623] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4837), 1,
      anon_sym_AMP,
    ACTIONS(4851), 1,
      anon_sym_PIPE,
    ACTIONS(4853), 1,
      anon_sym_extends,
    STATE(1812), 1,
      sym_comment,
    ACTIONS(4944), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4946), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [47688] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    STATE(1813), 1,
      sym_comment,
    STATE(3741), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3708), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [47759] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(1814), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4948), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [47876] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    STATE(1815), 1,
      sym_comment,
    STATE(3552), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3708), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [47947] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4484), 1,
      anon_sym_RBRACE,
    STATE(1816), 1,
      sym_comment,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2100), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2098), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [48018] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4484), 1,
      anon_sym_RBRACE,
    STATE(1817), 1,
      sym_comment,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2104), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2102), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [48089] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1818), 1,
      sym_comment,
    ACTIONS(4950), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4952), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [48148] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4837), 1,
      anon_sym_AMP,
    STATE(1819), 1,
      sym_comment,
    ACTIONS(4954), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4956), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [48209] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1820), 1,
      sym_comment,
    ACTIONS(4958), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4960), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [48268] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4837), 1,
      anon_sym_AMP,
    ACTIONS(4851), 1,
      anon_sym_PIPE,
    ACTIONS(4853), 1,
      anon_sym_extends,
    STATE(1821), 1,
      sym_comment,
    ACTIONS(4962), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4964), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [48333] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(754), 1,
      anon_sym_RBRACE,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    STATE(1822), 1,
      sym_comment,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2100), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2098), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [48404] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(2339), 1,
      anon_sym_async,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4408), 1,
      anon_sym_STAR,
    STATE(1823), 1,
      sym_comment,
    STATE(4068), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2346), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4669), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [48483] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4408), 1,
      anon_sym_STAR,
    STATE(1824), 1,
      sym_comment,
    STATE(4068), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2346), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4669), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [48560] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(754), 1,
      anon_sym_RBRACE,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    STATE(1825), 1,
      sym_comment,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2104), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2102), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [48631] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(781), 1,
      anon_sym_RBRACE,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    STATE(1826), 1,
      sym_comment,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2104), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2102), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [48702] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(781), 1,
      anon_sym_RBRACE,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    STATE(1827), 1,
      sym_comment,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2100), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2098), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [48773] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4691), 1,
      sym__automatic_semicolon,
    STATE(1828), 1,
      sym_comment,
    ACTIONS(1792), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1798), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [48834] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1829), 1,
      sym_comment,
    ACTIONS(4671), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4673), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [48893] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4966), 1,
      sym__automatic_semicolon,
    STATE(1830), 1,
      sym_comment,
    ACTIONS(1854), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1856), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [48954] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1831), 1,
      sym_comment,
    ACTIONS(2392), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2394), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [49013] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1832), 1,
      sym_comment,
    ACTIONS(4968), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4970), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [49072] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1833), 1,
      sym_comment,
    ACTIONS(4972), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4974), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [49131] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1834), 1,
      sym_comment,
    ACTIONS(4976), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4978), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [49190] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1835), 1,
      sym_comment,
    ACTIONS(4980), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4982), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [49249] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1836), 1,
      sym_comment,
    ACTIONS(4976), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4978), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [49308] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1837), 1,
      sym_comment,
    ACTIONS(4980), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4982), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [49367] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1838), 1,
      sym_comment,
    ACTIONS(4984), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4986), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [49426] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    STATE(1839), 1,
      sym_comment,
    STATE(3736), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3708), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [49497] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1840), 1,
      sym_comment,
    ACTIONS(4988), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4990), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [49556] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1841), 1,
      sym_comment,
    ACTIONS(4984), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4986), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [49615] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(1842), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4992), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [49732] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(1843), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4994), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [49849] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    STATE(1844), 1,
      sym_comment,
    STATE(3732), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3708), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [49920] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1874), 1,
      anon_sym_DOT,
    STATE(1845), 1,
      sym_comment,
    ACTIONS(4807), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4805), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_EQ,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_extends,
  [49981] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1846), 1,
      sym_comment,
    ACTIONS(4988), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4990), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [50040] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1847), 1,
      sym_comment,
    ACTIONS(4996), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4998), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [50099] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(1848), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5000), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [50216] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1849), 1,
      sym_comment,
    ACTIONS(5002), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5004), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [50275] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1850), 1,
      sym_comment,
    ACTIONS(4996), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4998), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [50334] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1851), 1,
      sym_comment,
    ACTIONS(5002), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5004), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [50393] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1852), 1,
      sym_comment,
    ACTIONS(5006), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5008), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [50452] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1853), 1,
      sym_comment,
    ACTIONS(5010), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5012), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [50511] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4837), 1,
      anon_sym_AMP,
    ACTIONS(4851), 1,
      anon_sym_PIPE,
    ACTIONS(4853), 1,
      anon_sym_extends,
    STATE(1854), 1,
      sym_comment,
    ACTIONS(5014), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5016), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [50576] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    STATE(1855), 1,
      sym_comment,
    STATE(3726), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3708), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [50647] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    STATE(1856), 1,
      sym_comment,
    STATE(3619), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3708), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [50718] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1857), 1,
      sym_comment,
    ACTIONS(5018), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5020), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [50777] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1858), 1,
      sym_comment,
    ACTIONS(5022), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5024), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [50836] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4837), 1,
      anon_sym_AMP,
    ACTIONS(4851), 1,
      anon_sym_PIPE,
    ACTIONS(4853), 1,
      anon_sym_extends,
    STATE(1859), 1,
      sym_comment,
    ACTIONS(5022), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5024), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [50901] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4837), 1,
      anon_sym_AMP,
    ACTIONS(4851), 1,
      anon_sym_PIPE,
    ACTIONS(4853), 1,
      anon_sym_extends,
    STATE(1860), 1,
      sym_comment,
    ACTIONS(5026), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5028), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [50966] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4837), 1,
      anon_sym_AMP,
    ACTIONS(4851), 1,
      anon_sym_PIPE,
    ACTIONS(4853), 1,
      anon_sym_extends,
    STATE(1861), 1,
      sym_comment,
    ACTIONS(5030), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5032), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [51031] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1862), 1,
      sym_comment,
    ACTIONS(2388), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2390), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [51090] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1863), 1,
      sym_comment,
    ACTIONS(5034), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5036), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [51149] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1946), 1,
      anon_sym_DOT,
    STATE(1864), 1,
      sym_comment,
    ACTIONS(4807), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4805), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_EQ,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_extends,
  [51210] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1865), 1,
      sym_comment,
    ACTIONS(3045), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3047), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [51269] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(1866), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5038), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [51386] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5040), 1,
      anon_sym_LBRACE,
    STATE(1867), 1,
      sym_comment,
    STATE(2037), 1,
      sym_statement_block,
    ACTIONS(1818), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1822), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [51449] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5040), 1,
      anon_sym_LBRACE,
    ACTIONS(5042), 1,
      anon_sym_DOT,
    STATE(1868), 1,
      sym_comment,
    STATE(2037), 1,
      sym_statement_block,
    ACTIONS(1818), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1822), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [51514] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5040), 1,
      anon_sym_LBRACE,
    ACTIONS(5044), 1,
      anon_sym_DOT,
    STATE(1869), 1,
      sym_comment,
    STATE(2037), 1,
      sym_statement_block,
    ACTIONS(1818), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1822), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [51579] = 38,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(3855), 1,
      anon_sym_COLON,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    ACTIONS(4771), 1,
      anon_sym_COMMA,
    ACTIONS(5046), 1,
      anon_sym_RPAREN,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(1870), 1,
      sym_comment,
    STATE(4039), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(4963), 1,
      sym_optional_chain,
    STATE(6189), 1,
      sym_type_annotation,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51704] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(1871), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5048), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [51821] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(1872), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5050), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [51938] = 30,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(5054), 1,
      anon_sym_BANG,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(1873), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [52047] = 23,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(1874), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5054), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [52142] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1875), 1,
      sym_comment,
    ACTIONS(5056), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5058), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [52201] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1876), 1,
      sym_comment,
    ACTIONS(5056), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5058), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [52260] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    STATE(1877), 1,
      sym_comment,
    STATE(3663), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3708), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [52331] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(1878), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5060), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [52448] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    STATE(1879), 1,
      sym_comment,
    STATE(3582), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3708), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [52519] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1880), 1,
      sym_comment,
    ACTIONS(5056), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5058), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [52578] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1881), 1,
      sym_comment,
    ACTIONS(5062), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5064), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [52637] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1882), 1,
      sym_comment,
    ACTIONS(5062), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5064), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [52696] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1883), 1,
      sym_comment,
    ACTIONS(5062), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5064), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [52755] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    STATE(1884), 1,
      sym_comment,
    STATE(3626), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3708), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [52826] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4649), 1,
      anon_sym_QMARK_DOT,
    STATE(1885), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(1844), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1848), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [52893] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1886), 1,
      sym_comment,
    ACTIONS(5066), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5068), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [52952] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1887), 1,
      sym_comment,
    ACTIONS(5066), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5068), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [53011] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1888), 1,
      sym_comment,
    ACTIONS(5066), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5068), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [53070] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1889), 1,
      sym_comment,
    ACTIONS(5070), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5072), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [53129] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1890), 1,
      sym_comment,
    ACTIONS(5074), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5076), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [53188] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4755), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(1891), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5078), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5080), 26,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [53259] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1892), 1,
      sym_comment,
    ACTIONS(5082), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5084), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [53318] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1893), 1,
      sym_comment,
    ACTIONS(2400), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2402), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [53377] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1894), 1,
      sym_comment,
    ACTIONS(5086), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5088), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [53436] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1895), 1,
      sym_comment,
    ACTIONS(5090), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5092), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [53495] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3894), 1,
      anon_sym_EQ,
    STATE(1896), 1,
      sym_comment,
    ACTIONS(3752), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [53556] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1897), 1,
      sym_comment,
    ACTIONS(5090), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5092), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [53615] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1898), 1,
      sym_comment,
    ACTIONS(5090), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5092), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [53674] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1899), 1,
      sym_comment,
    ACTIONS(5094), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5096), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [53733] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1900), 1,
      sym_comment,
    ACTIONS(5094), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5096), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [53792] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(1901), 1,
      sym_comment,
    STATE(4068), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4604), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [53867] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5102), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(1902), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5098), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5100), 19,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [53952] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1903), 1,
      sym_comment,
    ACTIONS(5094), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5096), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [54011] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5105), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(1904), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 18,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [54098] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1905), 1,
      sym_comment,
    ACTIONS(5108), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5110), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [54157] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1906), 1,
      sym_comment,
    ACTIONS(5108), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5110), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [54216] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1907), 1,
      sym_comment,
    ACTIONS(5108), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5110), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [54275] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1908), 1,
      sym_comment,
    ACTIONS(5112), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5114), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [54334] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5105), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(1909), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [54419] = 27,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(1910), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5054), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [54522] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(1911), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5116), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [54639] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(1912), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5118), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [54756] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1913), 1,
      sym_comment,
    ACTIONS(1944), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1946), 32,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [54815] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4837), 1,
      anon_sym_AMP,
    ACTIONS(4851), 1,
      anon_sym_PIPE,
    ACTIONS(4853), 1,
      anon_sym_extends,
    STATE(1914), 1,
      sym_comment,
    ACTIONS(5120), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5122), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [54880] = 26,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(1915), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5054), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [54981] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1916), 1,
      sym_comment,
    ACTIONS(1872), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1874), 32,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [55040] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(1917), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5124), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [55157] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5130), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(1918), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5126), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5128), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [55234] = 25,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(1919), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5054), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5052), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [55333] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5105), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(1920), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [55420] = 29,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(5054), 1,
      anon_sym_BANG,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(1921), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [55527] = 28,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(5054), 1,
      anon_sym_BANG,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(1922), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [55632] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5105), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(1923), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 20,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [55713] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(1924), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5133), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [55830] = 21,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(1925), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [55921] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(1926), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5135), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [56038] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(1927), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5137), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [56155] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4412), 1,
      anon_sym_RBRACE,
    STATE(1928), 1,
      sym_comment,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5251), 1,
      aux_sym_object_repeat1,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2100), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2098), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [56226] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4412), 1,
      anon_sym_RBRACE,
    STATE(1929), 1,
      sym_comment,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5251), 1,
      aux_sym_object_repeat1,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2104), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2102), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [56297] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    STATE(1930), 1,
      sym_comment,
    STATE(3658), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3708), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [56368] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1931), 1,
      sym_comment,
    ACTIONS(3115), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3117), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [56427] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1932), 1,
      sym_comment,
    ACTIONS(3123), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3125), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [56486] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1933), 1,
      sym_comment,
    ACTIONS(3135), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3137), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [56545] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5153), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5155), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5157), 1,
      anon_sym_GT_GT,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_CARET,
    ACTIONS(5165), 1,
      anon_sym_PIPE,
    ACTIONS(5169), 1,
      anon_sym_PERCENT,
    ACTIONS(5171), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5173), 1,
      anon_sym_LT,
    ACTIONS(5181), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5187), 1,
      sym__ternary_qmark,
    STATE(1934), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5139), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5147), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5159), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5175), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5137), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [56661] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5191), 1,
      anon_sym_EQ,
    STATE(1935), 1,
      sym_comment,
    ACTIONS(5189), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5193), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [56721] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1936), 1,
      sym_comment,
    ACTIONS(5195), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5197), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [56779] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1937), 1,
      sym_comment,
    ACTIONS(1854), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1856), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [56837] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5207), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5211), 1,
      anon_sym_GT_GT,
    ACTIONS(5215), 1,
      anon_sym_AMP,
    ACTIONS(5217), 1,
      anon_sym_CARET,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_PERCENT,
    ACTIONS(5225), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5237), 1,
      sym__ternary_qmark,
    STATE(1938), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5199), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5201), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(5203), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5205), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5213), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5229), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56955] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1796), 1,
      anon_sym_EQ,
    STATE(1939), 1,
      sym_comment,
    ACTIONS(1794), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1800), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [57015] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5153), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5155), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5157), 1,
      anon_sym_GT_GT,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_CARET,
    ACTIONS(5165), 1,
      anon_sym_PIPE,
    ACTIONS(5169), 1,
      anon_sym_PERCENT,
    ACTIONS(5171), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5173), 1,
      anon_sym_LT,
    ACTIONS(5181), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5187), 1,
      sym__ternary_qmark,
    STATE(1940), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5139), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5147), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5159), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5175), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5135), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [57131] = 21,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5157), 1,
      anon_sym_GT_GT,
    ACTIONS(5169), 1,
      anon_sym_PERCENT,
    ACTIONS(5171), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5173), 1,
      anon_sym_LT,
    STATE(1941), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5139), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5159), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [57221] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5225), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5239), 1,
      anon_sym_LT,
    STATE(1942), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [57301] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1943), 1,
      sym_comment,
    ACTIONS(1902), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1904), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [57359] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5242), 1,
      anon_sym_DOT,
    ACTIONS(5244), 1,
      anon_sym_LT,
    STATE(1944), 1,
      sym_comment,
    STATE(2231), 1,
      sym_arguments,
    STATE(2237), 1,
      sym_type_arguments,
    ACTIONS(4633), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4635), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [57427] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5244), 1,
      anon_sym_LT,
    ACTIONS(5246), 1,
      anon_sym_DOT,
    STATE(1945), 1,
      sym_comment,
    STATE(2230), 1,
      sym_arguments,
    STATE(2325), 1,
      sym_type_arguments,
    ACTIONS(4623), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4625), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [57495] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5244), 1,
      anon_sym_LT,
    ACTIONS(5248), 1,
      anon_sym_DOT,
    STATE(1946), 1,
      sym_comment,
    STATE(2232), 1,
      sym_type_arguments,
    STATE(2235), 1,
      sym_arguments,
    ACTIONS(3806), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3796), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [57563] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1947), 1,
      sym_comment,
    ACTIONS(1968), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1970), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [57621] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1948), 1,
      sym_comment,
    ACTIONS(1984), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1988), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [57679] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(1949), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5250), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [57795] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5153), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5155), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5157), 1,
      anon_sym_GT_GT,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_CARET,
    ACTIONS(5165), 1,
      anon_sym_PIPE,
    ACTIONS(5169), 1,
      anon_sym_PERCENT,
    ACTIONS(5171), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5173), 1,
      anon_sym_LT,
    ACTIONS(5181), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5187), 1,
      sym__ternary_qmark,
    STATE(1950), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5139), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5147), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5159), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5175), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5133), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [57911] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1951), 1,
      sym_comment,
    ACTIONS(1960), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1964), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [57969] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5171), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5252), 1,
      anon_sym_LT,
    STATE(1952), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [58049] = 28,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5054), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5157), 1,
      anon_sym_GT_GT,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_CARET,
    ACTIONS(5165), 1,
      anon_sym_PIPE,
    ACTIONS(5169), 1,
      anon_sym_PERCENT,
    ACTIONS(5171), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5173), 1,
      anon_sym_LT,
    STATE(1953), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5139), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5147), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5159), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5175), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [58153] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1954), 1,
      sym_comment,
    ACTIONS(5255), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5257), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [58211] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1955), 1,
      sym_comment,
    ACTIONS(5259), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5038), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [58269] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4916), 1,
      anon_sym_EQ,
    STATE(1956), 1,
      sym_comment,
    ACTIONS(4914), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4918), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [58329] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5261), 1,
      sym__automatic_semicolon,
    STATE(1957), 1,
      sym_comment,
    ACTIONS(1792), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1798), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [58389] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5263), 1,
      sym__automatic_semicolon,
    STATE(1958), 1,
      sym_comment,
    ACTIONS(1854), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1856), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [58449] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5207), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5211), 1,
      anon_sym_GT_GT,
    ACTIONS(5215), 1,
      anon_sym_AMP,
    ACTIONS(5217), 1,
      anon_sym_CARET,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_PERCENT,
    ACTIONS(5225), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5237), 1,
      sym__ternary_qmark,
    ACTIONS(5265), 1,
      anon_sym_COMMA,
    STATE(1959), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(4727), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5199), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5203), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5213), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5267), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5229), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58569] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1960), 1,
      sym_comment,
    ACTIONS(5269), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5271), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [58627] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5207), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5211), 1,
      anon_sym_GT_GT,
    ACTIONS(5215), 1,
      anon_sym_AMP,
    ACTIONS(5217), 1,
      anon_sym_CARET,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_PERCENT,
    ACTIONS(5225), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5237), 1,
      sym__ternary_qmark,
    ACTIONS(5265), 1,
      anon_sym_COMMA,
    STATE(1961), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(4727), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5199), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5203), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5213), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5273), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5229), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58747] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5153), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5155), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5157), 1,
      anon_sym_GT_GT,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_CARET,
    ACTIONS(5165), 1,
      anon_sym_PIPE,
    ACTIONS(5169), 1,
      anon_sym_PERCENT,
    ACTIONS(5171), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5173), 1,
      anon_sym_LT,
    ACTIONS(5181), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5187), 1,
      sym__ternary_qmark,
    STATE(1962), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5139), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5147), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5159), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5175), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5118), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [58863] = 29,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5054), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5153), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5157), 1,
      anon_sym_GT_GT,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_CARET,
    ACTIONS(5165), 1,
      anon_sym_PIPE,
    ACTIONS(5169), 1,
      anon_sym_PERCENT,
    ACTIONS(5171), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5173), 1,
      anon_sym_LT,
    STATE(1963), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5139), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5147), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5159), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5175), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 9,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [58969] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1964), 1,
      sym_comment,
    ACTIONS(5275), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5060), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [59027] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5207), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5211), 1,
      anon_sym_GT_GT,
    ACTIONS(5215), 1,
      anon_sym_AMP,
    ACTIONS(5217), 1,
      anon_sym_CARET,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_PERCENT,
    ACTIONS(5225), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5237), 1,
      sym__ternary_qmark,
    STATE(1965), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5199), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5203), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5213), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5229), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5048), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [59143] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1966), 1,
      sym_comment,
    ACTIONS(5277), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4727), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [59201] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5207), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5211), 1,
      anon_sym_GT_GT,
    ACTIONS(5215), 1,
      anon_sym_AMP,
    ACTIONS(5217), 1,
      anon_sym_CARET,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_PERCENT,
    ACTIONS(5225), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5237), 1,
      sym__ternary_qmark,
    STATE(1967), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5199), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5203), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5213), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5229), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5050), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [59317] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1968), 1,
      sym_comment,
    ACTIONS(5279), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5281), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [59375] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1969), 1,
      sym_comment,
    ACTIONS(1864), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1868), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [59433] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5153), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5155), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5157), 1,
      anon_sym_GT_GT,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_CARET,
    ACTIONS(5165), 1,
      anon_sym_PIPE,
    ACTIONS(5169), 1,
      anon_sym_PERCENT,
    ACTIONS(5171), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5173), 1,
      anon_sym_LT,
    ACTIONS(5181), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5187), 1,
      sym__ternary_qmark,
    STATE(1970), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5139), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5147), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5159), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5175), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5116), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [59549] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1971), 1,
      sym_comment,
    ACTIONS(5283), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5285), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [59607] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1972), 1,
      sym_comment,
    ACTIONS(5287), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5289), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [59665] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1973), 1,
      sym_comment,
    ACTIONS(5291), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5293), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [59723] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5169), 1,
      anon_sym_PERCENT,
    ACTIONS(5171), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5252), 1,
      anon_sym_LT,
    STATE(1974), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5139), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [59809] = 30,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5054), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5207), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5211), 1,
      anon_sym_GT_GT,
    ACTIONS(5215), 1,
      anon_sym_AMP,
    ACTIONS(5217), 1,
      anon_sym_CARET,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_PERCENT,
    ACTIONS(5225), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_LT,
    STATE(1975), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5199), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5203), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5213), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5229), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 8,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [59917] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1976), 1,
      sym_comment,
    ACTIONS(3752), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [59975] = 23,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5211), 1,
      anon_sym_GT_GT,
    ACTIONS(5223), 1,
      anon_sym_PERCENT,
    ACTIONS(5225), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_LT,
    STATE(1977), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5199), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5203), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5213), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5229), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5054), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [60069] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5207), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5211), 1,
      anon_sym_GT_GT,
    ACTIONS(5215), 1,
      anon_sym_AMP,
    ACTIONS(5217), 1,
      anon_sym_CARET,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_PERCENT,
    ACTIONS(5225), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5237), 1,
      sym__ternary_qmark,
    ACTIONS(5265), 1,
      anon_sym_COMMA,
    STATE(1978), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(4727), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5199), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5203), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5213), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5295), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5229), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60189] = 25,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5157), 1,
      anon_sym_GT_GT,
    ACTIONS(5169), 1,
      anon_sym_PERCENT,
    ACTIONS(5171), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5173), 1,
      anon_sym_LT,
    STATE(1979), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5139), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5147), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5159), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5175), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 11,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [60287] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1980), 1,
      sym_comment,
    ACTIONS(1844), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1848), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [60345] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5147), 1,
      anon_sym_GT,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5153), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5155), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5157), 1,
      anon_sym_GT_GT,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_CARET,
    ACTIONS(5165), 1,
      anon_sym_PIPE,
    ACTIONS(5169), 1,
      anon_sym_PERCENT,
    ACTIONS(5171), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5173), 1,
      anon_sym_LT,
    ACTIONS(5181), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5187), 1,
      sym__ternary_qmark,
    ACTIONS(5299), 1,
      anon_sym_in,
    STATE(1981), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5139), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5159), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5175), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5297), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [60463] = 26,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5157), 1,
      anon_sym_GT_GT,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5169), 1,
      anon_sym_PERCENT,
    ACTIONS(5171), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5173), 1,
      anon_sym_LT,
    STATE(1982), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5054), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(5139), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5147), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5159), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5175), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 11,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [60563] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1983), 1,
      sym_comment,
    ACTIONS(1896), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1898), 31,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [60621] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5201), 1,
      anon_sym_RBRACE,
    ACTIONS(5207), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5211), 1,
      anon_sym_GT_GT,
    ACTIONS(5215), 1,
      anon_sym_AMP,
    ACTIONS(5217), 1,
      anon_sym_CARET,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_PERCENT,
    ACTIONS(5225), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5237), 1,
      sym__ternary_qmark,
    ACTIONS(5302), 1,
      anon_sym_COMMA,
    STATE(1984), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5199), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5203), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5213), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5305), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5229), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60741] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5207), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5211), 1,
      anon_sym_GT_GT,
    ACTIONS(5215), 1,
      anon_sym_AMP,
    ACTIONS(5217), 1,
      anon_sym_CARET,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_PERCENT,
    ACTIONS(5225), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5237), 1,
      sym__ternary_qmark,
    STATE(1985), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5199), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5203), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5213), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5229), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5118), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [60857] = 27,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5157), 1,
      anon_sym_GT_GT,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_CARET,
    ACTIONS(5169), 1,
      anon_sym_PERCENT,
    ACTIONS(5171), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5173), 1,
      anon_sym_LT,
    STATE(1986), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5054), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(5139), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5147), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5159), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5175), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [60959] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5169), 1,
      anon_sym_PERCENT,
    ACTIONS(5171), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5252), 1,
      anon_sym_LT,
    STATE(1987), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5139), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [61043] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5171), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5252), 1,
      anon_sym_LT,
    STATE(1988), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [61129] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5207), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5211), 1,
      anon_sym_GT_GT,
    ACTIONS(5215), 1,
      anon_sym_AMP,
    ACTIONS(5217), 1,
      anon_sym_CARET,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_PERCENT,
    ACTIONS(5225), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5237), 1,
      sym__ternary_qmark,
    STATE(1989), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5199), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5203), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5213), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5229), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5116), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [61245] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5225), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5239), 1,
      anon_sym_LT,
    STATE(1990), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [61331] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5223), 1,
      anon_sym_PERCENT,
    ACTIONS(5225), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5239), 1,
      anon_sym_LT,
    STATE(1991), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5199), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [61415] = 27,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5211), 1,
      anon_sym_GT_GT,
    ACTIONS(5215), 1,
      anon_sym_AMP,
    ACTIONS(5217), 1,
      anon_sym_CARET,
    ACTIONS(5223), 1,
      anon_sym_PERCENT,
    ACTIONS(5225), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_LT,
    STATE(1992), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5054), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5199), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5203), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5213), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5229), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [61517] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5201), 1,
      anon_sym_RBRACE,
    ACTIONS(5207), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5211), 1,
      anon_sym_GT_GT,
    ACTIONS(5215), 1,
      anon_sym_AMP,
    ACTIONS(5217), 1,
      anon_sym_CARET,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_PERCENT,
    ACTIONS(5225), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5237), 1,
      sym__ternary_qmark,
    ACTIONS(5302), 1,
      anon_sym_COMMA,
    STATE(1993), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5116), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5199), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5203), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5213), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5229), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61637] = 26,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5211), 1,
      anon_sym_GT_GT,
    ACTIONS(5215), 1,
      anon_sym_AMP,
    ACTIONS(5223), 1,
      anon_sym_PERCENT,
    ACTIONS(5225), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_LT,
    STATE(1994), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5054), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5199), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5203), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5213), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5229), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 11,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [61737] = 25,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5211), 1,
      anon_sym_GT_GT,
    ACTIONS(5223), 1,
      anon_sym_PERCENT,
    ACTIONS(5225), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_LT,
    STATE(1995), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5199), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5203), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5213), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5229), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 11,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [61835] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(1996), 1,
      sym_comment,
    ACTIONS(1838), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1840), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [61893] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5223), 1,
      anon_sym_PERCENT,
    ACTIONS(5225), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5239), 1,
      anon_sym_LT,
    STATE(1997), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5199), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [61979] = 29,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5054), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5207), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5211), 1,
      anon_sym_GT_GT,
    ACTIONS(5215), 1,
      anon_sym_AMP,
    ACTIONS(5217), 1,
      anon_sym_CARET,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_PERCENT,
    ACTIONS(5225), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_LT,
    STATE(1998), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5199), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5203), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5213), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5229), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 9,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [62085] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5201), 1,
      anon_sym_RBRACE,
    ACTIONS(5207), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5211), 1,
      anon_sym_GT_GT,
    ACTIONS(5215), 1,
      anon_sym_AMP,
    ACTIONS(5217), 1,
      anon_sym_CARET,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_PERCENT,
    ACTIONS(5225), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5237), 1,
      sym__ternary_qmark,
    ACTIONS(5307), 1,
      anon_sym_COMMA,
    STATE(1999), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5137), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5199), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5203), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5213), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5229), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62205] = 28,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5054), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5211), 1,
      anon_sym_GT_GT,
    ACTIONS(5215), 1,
      anon_sym_AMP,
    ACTIONS(5217), 1,
      anon_sym_CARET,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_PERCENT,
    ACTIONS(5225), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_LT,
    STATE(2000), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5199), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5203), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5213), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5229), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [62309] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2001), 1,
      sym_comment,
    ACTIONS(4916), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5310), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4914), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4918), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [62371] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4667), 1,
      anon_sym_extends,
    STATE(2002), 1,
      sym_comment,
    ACTIONS(5312), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5315), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3752), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [62435] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2003), 1,
      sym_comment,
    ACTIONS(5318), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5320), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [62493] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2004), 1,
      sym_comment,
    ACTIONS(5322), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5324), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [62551] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2005), 1,
      sym_comment,
    ACTIONS(1908), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1912), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [62609] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2006), 1,
      sym_comment,
    ACTIONS(5326), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5328), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [62667] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2007), 1,
      sym_comment,
    ACTIONS(5330), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5332), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [62725] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2008), 1,
      sym_comment,
    ACTIONS(5334), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5336), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [62783] = 23,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5157), 1,
      anon_sym_GT_GT,
    ACTIONS(5169), 1,
      anon_sym_PERCENT,
    ACTIONS(5171), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5173), 1,
      anon_sym_LT,
    STATE(2009), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5139), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5147), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5159), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5175), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5054), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [62877] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2010), 1,
      sym_comment,
    ACTIONS(5338), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5340), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [62935] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2011), 1,
      sym_comment,
    ACTIONS(1918), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1922), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [62993] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2012), 1,
      sym_comment,
    ACTIONS(1944), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1946), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [63051] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2013), 1,
      sym_comment,
    ACTIONS(1872), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1874), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [63109] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2014), 1,
      sym_comment,
    ACTIONS(4775), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4777), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [63167] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5207), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5211), 1,
      anon_sym_GT_GT,
    ACTIONS(5215), 1,
      anon_sym_AMP,
    ACTIONS(5217), 1,
      anon_sym_CARET,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_PERCENT,
    ACTIONS(5225), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5237), 1,
      sym__ternary_qmark,
    ACTIONS(5342), 1,
      anon_sym_COMMA,
    ACTIONS(5345), 1,
      anon_sym_RBRACE,
    STATE(2015), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5137), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5199), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5203), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5213), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5229), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63287] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2016), 1,
      sym_comment,
    ACTIONS(5347), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5349), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [63345] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2017), 1,
      sym_comment,
    ACTIONS(1888), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1892), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [63403] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2018), 1,
      sym_comment,
    ACTIONS(5351), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5353), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [63461] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2019), 1,
      sym_comment,
    ACTIONS(1796), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5355), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(1794), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1800), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [63523] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2020), 1,
      sym_comment,
    ACTIONS(1878), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1882), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [63581] = 21,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5211), 1,
      anon_sym_GT_GT,
    ACTIONS(5223), 1,
      anon_sym_PERCENT,
    ACTIONS(5225), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_LT,
    STATE(2021), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5199), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5213), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [63671] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2022), 1,
      sym_comment,
    ACTIONS(5357), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5050), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [63729] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2023), 1,
      sym_comment,
    ACTIONS(5359), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5361), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [63787] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5207), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5211), 1,
      anon_sym_GT_GT,
    ACTIONS(5215), 1,
      anon_sym_AMP,
    ACTIONS(5217), 1,
      anon_sym_CARET,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_PERCENT,
    ACTIONS(5225), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5237), 1,
      sym__ternary_qmark,
    STATE(2024), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5199), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5203), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5213), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5229), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5135), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [63903] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2025), 1,
      sym_comment,
    ACTIONS(5363), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5365), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [63961] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2026), 1,
      sym_comment,
    STATE(4068), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4669), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [64033] = 30,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5054), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5153), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5155), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5157), 1,
      anon_sym_GT_GT,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_CARET,
    ACTIONS(5165), 1,
      anon_sym_PIPE,
    ACTIONS(5169), 1,
      anon_sym_PERCENT,
    ACTIONS(5171), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5173), 1,
      anon_sym_LT,
    STATE(2027), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5139), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5147), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5159), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5175), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 8,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [64141] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5153), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5155), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5157), 1,
      anon_sym_GT_GT,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_CARET,
    ACTIONS(5165), 1,
      anon_sym_PIPE,
    ACTIONS(5169), 1,
      anon_sym_PERCENT,
    ACTIONS(5171), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5173), 1,
      anon_sym_LT,
    ACTIONS(5181), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5187), 1,
      sym__ternary_qmark,
    STATE(2028), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5139), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5147), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5159), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5175), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5050), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [64257] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5227), 1,
      anon_sym_LT,
    STATE(2029), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5078), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5080), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [64327] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2030), 1,
      sym_comment,
    ACTIONS(5367), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5369), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [64385] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2031), 1,
      sym_comment,
    ACTIONS(5371), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5373), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [64443] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2032), 1,
      sym_comment,
    ACTIONS(5375), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5377), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [64501] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5153), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5155), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5157), 1,
      anon_sym_GT_GT,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_CARET,
    ACTIONS(5165), 1,
      anon_sym_PIPE,
    ACTIONS(5169), 1,
      anon_sym_PERCENT,
    ACTIONS(5171), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5173), 1,
      anon_sym_LT,
    ACTIONS(5181), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5187), 1,
      sym__ternary_qmark,
    STATE(2033), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5139), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5147), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5159), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5175), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5048), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [64617] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5173), 1,
      anon_sym_LT,
    STATE(2034), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5078), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5080), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [64687] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5379), 1,
      anon_sym_LT,
    STATE(2035), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5126), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5128), 22,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [64763] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2036), 1,
      sym_comment,
    ACTIONS(5382), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5118), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [64821] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2037), 1,
      sym_comment,
    ACTIONS(1896), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1898), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [64879] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2038), 1,
      sym_comment,
    ACTIONS(5191), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5384), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(5189), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5193), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [64941] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2039), 1,
      sym_comment,
    ACTIONS(1950), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1954), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [64999] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2040), 1,
      sym_comment,
    ACTIONS(1994), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1998), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [65057] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5207), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5211), 1,
      anon_sym_GT_GT,
    ACTIONS(5215), 1,
      anon_sym_AMP,
    ACTIONS(5217), 1,
      anon_sym_CARET,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_PERCENT,
    ACTIONS(5225), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5237), 1,
      sym__ternary_qmark,
    ACTIONS(5265), 1,
      anon_sym_COMMA,
    STATE(2041), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(4727), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5199), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5203), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5213), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5386), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5229), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65177] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5207), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5211), 1,
      anon_sym_GT_GT,
    ACTIONS(5215), 1,
      anon_sym_AMP,
    ACTIONS(5217), 1,
      anon_sym_CARET,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_PERCENT,
    ACTIONS(5225), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5237), 1,
      sym__ternary_qmark,
    ACTIONS(5265), 1,
      anon_sym_COMMA,
    STATE(2042), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(4727), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5199), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5203), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5213), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5388), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5229), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65297] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5207), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5211), 1,
      anon_sym_GT_GT,
    ACTIONS(5215), 1,
      anon_sym_AMP,
    ACTIONS(5217), 1,
      anon_sym_CARET,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_PERCENT,
    ACTIONS(5225), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5237), 1,
      sym__ternary_qmark,
    ACTIONS(5265), 1,
      anon_sym_COMMA,
    STATE(2043), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(4727), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5199), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5203), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5213), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5390), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5229), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65417] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5244), 1,
      anon_sym_LT,
    ACTIONS(5392), 1,
      anon_sym_QMARK_DOT,
    STATE(2044), 1,
      sym_comment,
    STATE(2287), 1,
      sym_type_arguments,
    STATE(2641), 1,
      sym_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(4641), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4643), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [65491] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2045), 1,
      sym_comment,
    ACTIONS(5394), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5396), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [65549] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2046), 1,
      sym_comment,
    ACTIONS(1968), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1970), 31,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [65607] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2047), 1,
      sym_comment,
    ACTIONS(5398), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5400), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [65665] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5207), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5211), 1,
      anon_sym_GT_GT,
    ACTIONS(5215), 1,
      anon_sym_AMP,
    ACTIONS(5217), 1,
      anon_sym_CARET,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_PERCENT,
    ACTIONS(5225), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5237), 1,
      sym__ternary_qmark,
    STATE(2048), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5199), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5203), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5213), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5229), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5038), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [65781] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5244), 1,
      anon_sym_LT,
    ACTIONS(5402), 1,
      anon_sym_DOT,
    ACTIONS(5404), 1,
      anon_sym_is,
    STATE(2049), 1,
      sym_comment,
    STATE(2387), 1,
      sym_type_arguments,
    ACTIONS(4653), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3842), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [65847] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5207), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5211), 1,
      anon_sym_GT_GT,
    ACTIONS(5215), 1,
      anon_sym_AMP,
    ACTIONS(5217), 1,
      anon_sym_CARET,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_PERCENT,
    ACTIONS(5225), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5237), 1,
      sym__ternary_qmark,
    STATE(2050), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5199), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5203), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5213), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5229), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5137), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [65963] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4841), 1,
      anon_sym_extends,
    STATE(2051), 1,
      sym_comment,
    ACTIONS(5406), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5409), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5338), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5340), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [66027] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5207), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5211), 1,
      anon_sym_GT_GT,
    ACTIONS(5215), 1,
      anon_sym_AMP,
    ACTIONS(5217), 1,
      anon_sym_CARET,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_PERCENT,
    ACTIONS(5225), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5237), 1,
      sym__ternary_qmark,
    STATE(2052), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5199), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5203), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5213), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5229), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5060), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [66143] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2053), 1,
      sym_comment,
    ACTIONS(5412), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5414), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [66201] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2054), 1,
      sym_comment,
    ACTIONS(1830), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1834), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [66259] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5207), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5211), 1,
      anon_sym_GT_GT,
    ACTIONS(5215), 1,
      anon_sym_AMP,
    ACTIONS(5217), 1,
      anon_sym_CARET,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_PERCENT,
    ACTIONS(5225), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5237), 1,
      sym__ternary_qmark,
    STATE(2055), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5199), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5203), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5213), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5229), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4727), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [66375] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5207), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5211), 1,
      anon_sym_GT_GT,
    ACTIONS(5215), 1,
      anon_sym_AMP,
    ACTIONS(5217), 1,
      anon_sym_CARET,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_PERCENT,
    ACTIONS(5225), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5237), 1,
      sym__ternary_qmark,
    STATE(2056), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5199), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5203), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5213), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5229), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5124), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [66491] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2057), 1,
      sym_comment,
    ACTIONS(1974), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1978), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [66549] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5416), 1,
      anon_sym_LT,
    STATE(2058), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5098), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5100), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [66633] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5207), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5211), 1,
      anon_sym_GT_GT,
    ACTIONS(5215), 1,
      anon_sym_AMP,
    ACTIONS(5217), 1,
      anon_sym_CARET,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_PERCENT,
    ACTIONS(5225), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5237), 1,
      sym__ternary_qmark,
    STATE(2059), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5199), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5203), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5213), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5229), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5000), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [66749] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5207), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5211), 1,
      anon_sym_GT_GT,
    ACTIONS(5215), 1,
      anon_sym_AMP,
    ACTIONS(5217), 1,
      anon_sym_CARET,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_PERCENT,
    ACTIONS(5225), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5237), 1,
      sym__ternary_qmark,
    STATE(2060), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5199), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5203), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5213), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5229), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4994), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [66865] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2061), 1,
      sym_comment,
    ACTIONS(1932), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1936), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [66923] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2062), 1,
      sym_comment,
    ACTIONS(5419), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5135), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [66981] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5207), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5211), 1,
      anon_sym_GT_GT,
    ACTIONS(5215), 1,
      anon_sym_AMP,
    ACTIONS(5217), 1,
      anon_sym_CARET,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_PERCENT,
    ACTIONS(5225), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5237), 1,
      sym__ternary_qmark,
    STATE(2063), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5199), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5203), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5213), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5229), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4992), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [67097] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2064), 1,
      sym_comment,
    ACTIONS(1926), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1928), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [67155] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2065), 1,
      sym_comment,
    ACTIONS(1902), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1904), 31,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [67213] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5153), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5155), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5157), 1,
      anon_sym_GT_GT,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_CARET,
    ACTIONS(5165), 1,
      anon_sym_PIPE,
    ACTIONS(5169), 1,
      anon_sym_PERCENT,
    ACTIONS(5171), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5173), 1,
      anon_sym_LT,
    ACTIONS(5181), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5187), 1,
      sym__ternary_qmark,
    STATE(2066), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5139), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5147), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5159), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5175), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5124), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [67329] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2067), 1,
      sym_comment,
    ACTIONS(5421), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5423), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [67387] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5207), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5211), 1,
      anon_sym_GT_GT,
    ACTIONS(5215), 1,
      anon_sym_AMP,
    ACTIONS(5217), 1,
      anon_sym_CARET,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_PERCENT,
    ACTIONS(5225), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5237), 1,
      sym__ternary_qmark,
    STATE(2068), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5199), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5203), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5213), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5229), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5133), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [67503] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5153), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5155), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5157), 1,
      anon_sym_GT_GT,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_CARET,
    ACTIONS(5165), 1,
      anon_sym_PIPE,
    ACTIONS(5169), 1,
      anon_sym_PERCENT,
    ACTIONS(5171), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5173), 1,
      anon_sym_LT,
    ACTIONS(5181), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5187), 1,
      sym__ternary_qmark,
    STATE(2069), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5139), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5147), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5159), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5175), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5038), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [67619] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2070), 1,
      sym_comment,
    ACTIONS(1838), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1840), 31,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [67677] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5153), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5155), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5157), 1,
      anon_sym_GT_GT,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_CARET,
    ACTIONS(5165), 1,
      anon_sym_PIPE,
    ACTIONS(5169), 1,
      anon_sym_PERCENT,
    ACTIONS(5171), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5173), 1,
      anon_sym_LT,
    ACTIONS(5181), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5187), 1,
      sym__ternary_qmark,
    STATE(2071), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5139), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5147), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5159), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5175), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5060), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [67793] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2072), 1,
      sym_comment,
    ACTIONS(5425), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5427), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [67851] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5429), 1,
      anon_sym_LT,
    STATE(2073), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5098), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5100), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [67935] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5153), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5155), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5157), 1,
      anon_sym_GT_GT,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_CARET,
    ACTIONS(5165), 1,
      anon_sym_PIPE,
    ACTIONS(5169), 1,
      anon_sym_PERCENT,
    ACTIONS(5171), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5173), 1,
      anon_sym_LT,
    ACTIONS(5181), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5187), 1,
      sym__ternary_qmark,
    STATE(2074), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5139), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5147), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5159), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5175), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4727), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [68051] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2075), 1,
      sym_comment,
    ACTIONS(5432), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5434), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [68109] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5153), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5155), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5157), 1,
      anon_sym_GT_GT,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_CARET,
    ACTIONS(5165), 1,
      anon_sym_PIPE,
    ACTIONS(5169), 1,
      anon_sym_PERCENT,
    ACTIONS(5171), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5173), 1,
      anon_sym_LT,
    ACTIONS(5181), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5187), 1,
      sym__ternary_qmark,
    STATE(2076), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5139), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5147), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5159), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5175), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5000), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [68225] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5153), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5155), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5157), 1,
      anon_sym_GT_GT,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_CARET,
    ACTIONS(5165), 1,
      anon_sym_PIPE,
    ACTIONS(5169), 1,
      anon_sym_PERCENT,
    ACTIONS(5171), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5173), 1,
      anon_sym_LT,
    ACTIONS(5181), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5187), 1,
      sym__ternary_qmark,
    STATE(2077), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5139), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5147), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5159), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5175), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4994), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [68341] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2078), 1,
      sym_comment,
    ACTIONS(5436), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5438), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [68399] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5440), 1,
      anon_sym_LT,
    STATE(2079), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4877), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4879), 20,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [68477] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2080), 1,
      sym_comment,
    ACTIONS(5443), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5445), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [68535] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4793), 1,
      anon_sym_extends,
    STATE(2081), 1,
      sym_comment,
    ACTIONS(5447), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5450), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3752), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [68599] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2082), 1,
      sym_comment,
    ACTIONS(1854), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1856), 31,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [68657] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5153), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5155), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5157), 1,
      anon_sym_GT_GT,
    ACTIONS(5161), 1,
      anon_sym_AMP,
    ACTIONS(5163), 1,
      anon_sym_CARET,
    ACTIONS(5165), 1,
      anon_sym_PIPE,
    ACTIONS(5169), 1,
      anon_sym_PERCENT,
    ACTIONS(5171), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5173), 1,
      anon_sym_LT,
    ACTIONS(5181), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5187), 1,
      sym__ternary_qmark,
    STATE(2083), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5139), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5147), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5159), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5167), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5177), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5179), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5175), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4992), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [68773] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5453), 1,
      anon_sym_LT,
    STATE(2084), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4877), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4879), 20,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [68851] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2085), 1,
      sym_comment,
    ACTIONS(1926), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1928), 31,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [68909] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5456), 1,
      anon_sym_LT,
    STATE(2086), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5126), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5128), 22,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [68985] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2087), 1,
      sym_comment,
    ACTIONS(5459), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5461), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [69043] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2088), 1,
      sym_comment,
    ACTIONS(5463), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5465), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [69101] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2089), 1,
      sym_comment,
    ACTIONS(3686), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3688), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [69158] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2090), 1,
      sym_comment,
    ACTIONS(5469), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5467), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [69215] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2091), 1,
      sym_comment,
    ACTIONS(5473), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5471), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [69272] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2092), 1,
      sym_comment,
    ACTIONS(5477), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5475), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [69329] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4827), 1,
      anon_sym_extends,
    ACTIONS(4916), 1,
      anon_sym_EQ,
    STATE(2093), 1,
      sym_comment,
    ACTIONS(4920), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4923), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4914), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4918), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [69394] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2094), 1,
      sym_comment,
    ACTIONS(5477), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5475), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [69451] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5479), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2095), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5126), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5128), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [69526] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5488), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5490), 1,
      anon_sym_GT_GT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5496), 1,
      anon_sym_CARET,
    ACTIONS(5498), 1,
      anon_sym_PIPE,
    ACTIONS(5502), 1,
      anon_sym_PERCENT,
    ACTIONS(5504), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_LT,
    ACTIONS(5514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5516), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2096), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5482), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5484), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5492), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5510), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5512), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5124), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5508), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69641] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1796), 1,
      anon_sym_EQ,
    ACTIONS(2398), 1,
      anon_sym_extends,
    STATE(2097), 1,
      sym_comment,
    ACTIONS(4908), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4911), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1794), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1800), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [69706] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2098), 1,
      sym_comment,
    ACTIONS(5520), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5518), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [69763] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2099), 1,
      sym_comment,
    ACTIONS(4775), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4777), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [69820] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5404), 1,
      anon_sym_is,
    STATE(2100), 1,
      sym_comment,
    ACTIONS(4671), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4673), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [69879] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5522), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2101), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5098), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5100), 17,
      sym__ternary_qmark,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [69962] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2102), 1,
      sym_comment,
    ACTIONS(5473), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5471), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [70019] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2103), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5525), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [70134] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2104), 1,
      sym_comment,
    ACTIONS(5529), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5527), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [70191] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5535), 1,
      anon_sym_SEMI,
    ACTIONS(5538), 1,
      sym__automatic_semicolon,
    STATE(2105), 1,
      sym_comment,
    ACTIONS(5533), 10,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5531), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [70252] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2106), 1,
      sym_comment,
    ACTIONS(4683), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4685), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_is,
  [70309] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2107), 1,
      sym_comment,
    ACTIONS(5477), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5475), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [70366] = 17,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(2348), 1,
      anon_sym_override,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(5540), 1,
      anon_sym_STAR,
    ACTIONS(5542), 1,
      anon_sym_async,
    ACTIONS(5544), 1,
      anon_sym_readonly,
    STATE(2108), 1,
      sym_comment,
    STATE(2761), 1,
      sym_override_modifier,
    STATE(4091), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5546), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [70447] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2109), 1,
      sym_comment,
    ACTIONS(5477), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5475), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [70504] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5548), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2110), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4877), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4879), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
      anon_sym_implements,
  [70581] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    ACTIONS(4771), 1,
      anon_sym_COMMA,
    ACTIONS(5551), 1,
      anon_sym_RBRACK,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2111), 1,
      sym_comment,
    STATE(4039), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70700] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(2044), 1,
      anon_sym_COMMA,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    ACTIONS(5553), 1,
      anon_sym_RBRACK,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2112), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    STATE(5213), 1,
      aux_sym_array_repeat1,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70819] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    ACTIONS(4771), 1,
      anon_sym_COMMA,
    ACTIONS(5555), 1,
      anon_sym_RPAREN,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2113), 1,
      sym_comment,
    STATE(4039), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70938] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(5506), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2114), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5078), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5080), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [71007] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5488), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5490), 1,
      anon_sym_GT_GT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5496), 1,
      anon_sym_CARET,
    ACTIONS(5498), 1,
      anon_sym_PIPE,
    ACTIONS(5502), 1,
      anon_sym_PERCENT,
    ACTIONS(5504), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_LT,
    ACTIONS(5514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5516), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2115), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5482), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5484), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5492), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5510), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5512), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5116), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5508), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71122] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2116), 1,
      sym_comment,
    ACTIONS(5191), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5557), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(5189), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5193), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [71183] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5488), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5490), 1,
      anon_sym_GT_GT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5496), 1,
      anon_sym_CARET,
    ACTIONS(5498), 1,
      anon_sym_PIPE,
    ACTIONS(5502), 1,
      anon_sym_PERCENT,
    ACTIONS(5504), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_LT,
    ACTIONS(5514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5516), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2117), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5482), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5484), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5492), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5510), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5512), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5118), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5508), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71298] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5488), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5490), 1,
      anon_sym_GT_GT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5496), 1,
      anon_sym_CARET,
    ACTIONS(5498), 1,
      anon_sym_PIPE,
    ACTIONS(5502), 1,
      anon_sym_PERCENT,
    ACTIONS(5504), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_LT,
    ACTIONS(5514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5516), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2118), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5482), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5484), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5492), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5510), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5512), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5133), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5508), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71413] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3917), 1,
      anon_sym_QMARK,
    ACTIONS(3925), 1,
      anon_sym_EQ,
    STATE(2119), 1,
      sym_comment,
    ACTIONS(3928), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3752), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [71476] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2120), 1,
      sym_comment,
    ACTIONS(5562), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5560), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [71533] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5244), 1,
      anon_sym_LT,
    STATE(2121), 1,
      sym_comment,
    STATE(2396), 1,
      sym_type_arguments,
    ACTIONS(4659), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4661), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [71594] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    ACTIONS(4771), 1,
      anon_sym_COMMA,
    ACTIONS(5564), 1,
      anon_sym_COLON,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2122), 1,
      sym_comment,
    STATE(4039), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71713] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    STATE(2123), 1,
      sym_comment,
    ACTIONS(4604), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2100), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2098), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [71776] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    STATE(2124), 1,
      sym_comment,
    ACTIONS(4604), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2104), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2102), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [71839] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(2044), 1,
      anon_sym_COMMA,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    ACTIONS(5566), 1,
      anon_sym_RPAREN,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2125), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    STATE(5450), 1,
      aux_sym_array_repeat1,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71958] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5244), 1,
      anon_sym_LT,
    ACTIONS(5402), 1,
      anon_sym_DOT,
    STATE(2126), 1,
      sym_comment,
    STATE(2387), 1,
      sym_type_arguments,
    ACTIONS(4653), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3842), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [72021] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5488), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5490), 1,
      anon_sym_GT_GT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5496), 1,
      anon_sym_CARET,
    ACTIONS(5498), 1,
      anon_sym_PIPE,
    ACTIONS(5502), 1,
      anon_sym_PERCENT,
    ACTIONS(5504), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_LT,
    ACTIONS(5514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5516), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2127), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5482), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5484), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5492), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5510), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5512), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5137), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5508), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72136] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(2044), 1,
      anon_sym_COMMA,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    ACTIONS(5568), 1,
      anon_sym_RPAREN,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2128), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    STATE(4974), 1,
      aux_sym_array_repeat1,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72255] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(2044), 1,
      anon_sym_COMMA,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    ACTIONS(5570), 1,
      anon_sym_RBRACK,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2129), 1,
      sym_comment,
    STATE(4868), 1,
      aux_sym_array_repeat1,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72374] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5488), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5490), 1,
      anon_sym_GT_GT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5496), 1,
      anon_sym_CARET,
    ACTIONS(5498), 1,
      anon_sym_PIPE,
    ACTIONS(5502), 1,
      anon_sym_PERCENT,
    ACTIONS(5504), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_LT,
    ACTIONS(5514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5516), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2130), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5482), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5484), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5492), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5510), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5512), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5135), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5508), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72489] = 21,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5490), 1,
      anon_sym_GT_GT,
    ACTIONS(5502), 1,
      anon_sym_PERCENT,
    ACTIONS(5504), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2131), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5482), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5492), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
      anon_sym_implements,
  [72578] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2132), 1,
      sym_comment,
    ACTIONS(5574), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5572), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [72635] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5504), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5576), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2133), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
      anon_sym_implements,
  [72714] = 28,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5054), 1,
      anon_sym_BANG,
    ACTIONS(5490), 1,
      anon_sym_GT_GT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5496), 1,
      anon_sym_CARET,
    ACTIONS(5498), 1,
      anon_sym_PIPE,
    ACTIONS(5502), 1,
      anon_sym_PERCENT,
    ACTIONS(5504), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2134), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5482), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5484), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5492), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5510), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5512), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5508), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [72817] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3848), 1,
      anon_sym_EQ,
    ACTIONS(3917), 1,
      anon_sym_QMARK,
    STATE(2135), 1,
      sym_comment,
    ACTIONS(3914), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3752), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [72880] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    ACTIONS(4771), 1,
      anon_sym_COMMA,
    ACTIONS(5579), 1,
      anon_sym_RPAREN,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2136), 1,
      sym_comment,
    STATE(4039), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72999] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    ACTIONS(4771), 1,
      anon_sym_COMMA,
    ACTIONS(5581), 1,
      anon_sym_RPAREN,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2137), 1,
      sym_comment,
    STATE(4039), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73118] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(2044), 1,
      anon_sym_COMMA,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    ACTIONS(5583), 1,
      anon_sym_RPAREN,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2138), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    STATE(5108), 1,
      aux_sym_array_repeat1,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73237] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5488), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5490), 1,
      anon_sym_GT_GT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5496), 1,
      anon_sym_CARET,
    ACTIONS(5498), 1,
      anon_sym_PIPE,
    ACTIONS(5502), 1,
      anon_sym_PERCENT,
    ACTIONS(5504), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_LT,
    ACTIONS(5514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5516), 1,
      sym__ternary_qmark,
    STATE(2139), 1,
      sym_comment,
    STATE(2651), 1,
      sym_type_arguments,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5482), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5484), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5492), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5510), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5512), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5508), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5585), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
  [73352] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    ACTIONS(4771), 1,
      anon_sym_COMMA,
    ACTIONS(5587), 1,
      anon_sym_RBRACK,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2140), 1,
      sym_comment,
    STATE(4039), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73471] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5207), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5211), 1,
      anon_sym_GT_GT,
    ACTIONS(5215), 1,
      anon_sym_AMP,
    ACTIONS(5217), 1,
      anon_sym_CARET,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_PERCENT,
    ACTIONS(5225), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5237), 1,
      sym__ternary_qmark,
    STATE(2141), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5199), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5203), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5213), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4948), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(5229), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73586] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2142), 1,
      sym_comment,
    ACTIONS(5591), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5589), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [73643] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2143), 1,
      sym_comment,
    ACTIONS(5595), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5593), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [73700] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2144), 1,
      sym_comment,
    ACTIONS(5595), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5593), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [73757] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2145), 1,
      sym_comment,
    ACTIONS(5529), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5527), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [73814] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3794), 1,
      anon_sym_EQ,
    ACTIONS(4793), 1,
      anon_sym_extends,
    STATE(2146), 1,
      sym_comment,
    ACTIONS(5447), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5450), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3752), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 26,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [73879] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    ACTIONS(4771), 1,
      anon_sym_COMMA,
    ACTIONS(5597), 1,
      anon_sym_RBRACK,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2147), 1,
      sym_comment,
    STATE(4039), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73998] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2148), 1,
      sym_comment,
    ACTIONS(5601), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5599), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [74055] = 29,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5054), 1,
      anon_sym_BANG,
    ACTIONS(5486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5490), 1,
      anon_sym_GT_GT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5496), 1,
      anon_sym_CARET,
    ACTIONS(5498), 1,
      anon_sym_PIPE,
    ACTIONS(5502), 1,
      anon_sym_PERCENT,
    ACTIONS(5504), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2149), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5482), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5484), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5492), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5510), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5512), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5508), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [74160] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(2044), 1,
      anon_sym_COMMA,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    ACTIONS(5603), 1,
      anon_sym_RBRACK,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2150), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    STATE(5213), 1,
      aux_sym_array_repeat1,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74279] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2151), 1,
      sym_comment,
    ACTIONS(5607), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5605), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [74336] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(2044), 1,
      anon_sym_COMMA,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    ACTIONS(5609), 1,
      anon_sym_RPAREN,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2152), 1,
      sym_comment,
    STATE(4942), 1,
      aux_sym_array_repeat1,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74455] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5502), 1,
      anon_sym_PERCENT,
    ACTIONS(5504), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5576), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2153), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5482), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
      anon_sym_implements,
  [74540] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2154), 1,
      sym_comment,
    ACTIONS(3682), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3684), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [74597] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2155), 1,
      sym_comment,
    ACTIONS(5473), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5471), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [74654] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5116), 1,
      anon_sym_COMMA,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5207), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5211), 1,
      anon_sym_GT_GT,
    ACTIONS(5215), 1,
      anon_sym_AMP,
    ACTIONS(5217), 1,
      anon_sym_CARET,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_PERCENT,
    ACTIONS(5225), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5237), 1,
      sym__ternary_qmark,
    STATE(2156), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5199), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5203), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5213), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5305), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5229), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74771] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2157), 1,
      sym_comment,
    ACTIONS(5595), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5593), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [74828] = 25,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5490), 1,
      anon_sym_GT_GT,
    ACTIONS(5502), 1,
      anon_sym_PERCENT,
    ACTIONS(5504), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2158), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5482), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5484), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5492), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5510), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5512), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5508), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [74925] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2159), 1,
      sym_comment,
    ACTIONS(5520), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5518), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [74982] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2160), 1,
      sym_comment,
    ACTIONS(5477), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5475), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [75039] = 26,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5490), 1,
      anon_sym_GT_GT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5502), 1,
      anon_sym_PERCENT,
    ACTIONS(5504), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2161), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5054), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(5482), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5484), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5492), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5510), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5512), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5508), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [75138] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5116), 1,
      anon_sym_COMMA,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5207), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5211), 1,
      anon_sym_GT_GT,
    ACTIONS(5215), 1,
      anon_sym_AMP,
    ACTIONS(5217), 1,
      anon_sym_CARET,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_PERCENT,
    ACTIONS(5225), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5237), 1,
      sym__ternary_qmark,
    STATE(2162), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5199), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5203), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5213), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5611), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5229), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [75255] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2163), 1,
      sym_comment,
    ACTIONS(5615), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5613), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [75312] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2164), 1,
      sym_comment,
    ACTIONS(1711), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1709), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_is,
  [75369] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2165), 1,
      sym_comment,
    ACTIONS(5520), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5518), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [75426] = 27,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5490), 1,
      anon_sym_GT_GT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5496), 1,
      anon_sym_CARET,
    ACTIONS(5502), 1,
      anon_sym_PERCENT,
    ACTIONS(5504), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2166), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5054), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(5482), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5484), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5492), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5510), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5512), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5508), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [75527] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    ACTIONS(4771), 1,
      anon_sym_COMMA,
    ACTIONS(5617), 1,
      anon_sym_RBRACK,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2167), 1,
      sym_comment,
    STATE(4039), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [75646] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5623), 1,
      anon_sym_SEMI,
    ACTIONS(5626), 1,
      sym__automatic_semicolon,
    STATE(2168), 1,
      sym_comment,
    ACTIONS(5621), 10,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5619), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [75707] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5488), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5490), 1,
      anon_sym_GT_GT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5496), 1,
      anon_sym_CARET,
    ACTIONS(5498), 1,
      anon_sym_PIPE,
    ACTIONS(5502), 1,
      anon_sym_PERCENT,
    ACTIONS(5504), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_LT,
    ACTIONS(5514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5516), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2169), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5482), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5484), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5492), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5510), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5512), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4992), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5508), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [75822] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5502), 1,
      anon_sym_PERCENT,
    ACTIONS(5504), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5576), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2170), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5482), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
      anon_sym_implements,
  [75905] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5504), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5576), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2171), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 16,
      sym__ternary_qmark,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [75990] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5488), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5490), 1,
      anon_sym_GT_GT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5496), 1,
      anon_sym_CARET,
    ACTIONS(5498), 1,
      anon_sym_PIPE,
    ACTIONS(5502), 1,
      anon_sym_PERCENT,
    ACTIONS(5504), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_LT,
    ACTIONS(5514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5516), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2172), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5482), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5484), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5492), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5510), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5512), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4994), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5508), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [76105] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5488), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5490), 1,
      anon_sym_GT_GT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5496), 1,
      anon_sym_CARET,
    ACTIONS(5498), 1,
      anon_sym_PIPE,
    ACTIONS(5502), 1,
      anon_sym_PERCENT,
    ACTIONS(5504), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_LT,
    ACTIONS(5514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5516), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2173), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5482), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5484), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5492), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5510), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5512), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5000), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5508), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [76220] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2174), 1,
      sym_comment,
    ACTIONS(4916), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5628), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4914), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4918), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [76281] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5207), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5209), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5211), 1,
      anon_sym_GT_GT,
    ACTIONS(5215), 1,
      anon_sym_AMP,
    ACTIONS(5217), 1,
      anon_sym_CARET,
    ACTIONS(5219), 1,
      anon_sym_PIPE,
    ACTIONS(5223), 1,
      anon_sym_PERCENT,
    ACTIONS(5225), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5227), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5237), 1,
      sym__ternary_qmark,
    STATE(2175), 1,
      sym_comment,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5199), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5203), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5213), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5229), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5297), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [76396] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5404), 1,
      anon_sym_is,
    STATE(2176), 1,
      sym_comment,
    ACTIONS(4665), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [76455] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5631), 1,
      anon_sym_is,
    STATE(2177), 1,
      sym_comment,
    ACTIONS(4659), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4661), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [76514] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5488), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5490), 1,
      anon_sym_GT_GT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5496), 1,
      anon_sym_CARET,
    ACTIONS(5498), 1,
      anon_sym_PIPE,
    ACTIONS(5502), 1,
      anon_sym_PERCENT,
    ACTIONS(5504), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_LT,
    ACTIONS(5514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5516), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2178), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5482), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5484), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5492), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5510), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5512), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4727), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5508), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [76629] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2179), 1,
      sym_comment,
    ACTIONS(5473), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5471), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [76686] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2180), 1,
      sym_comment,
    ACTIONS(5477), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5475), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [76743] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5488), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5490), 1,
      anon_sym_GT_GT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5496), 1,
      anon_sym_CARET,
    ACTIONS(5498), 1,
      anon_sym_PIPE,
    ACTIONS(5502), 1,
      anon_sym_PERCENT,
    ACTIONS(5504), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_LT,
    ACTIONS(5514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5516), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2181), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5482), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5484), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5492), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5510), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5512), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5060), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5508), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [76858] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2182), 1,
      sym_comment,
    ACTIONS(5520), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5518), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [76915] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2183), 1,
      sym_comment,
    ACTIONS(5520), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5518), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [76972] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2184), 1,
      sym_comment,
    ACTIONS(5477), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5475), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [77029] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2185), 1,
      sym_comment,
    ACTIONS(5595), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5593), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [77086] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5488), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5490), 1,
      anon_sym_GT_GT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5496), 1,
      anon_sym_CARET,
    ACTIONS(5498), 1,
      anon_sym_PIPE,
    ACTIONS(5502), 1,
      anon_sym_PERCENT,
    ACTIONS(5504), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_LT,
    ACTIONS(5514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5516), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2186), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5482), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5484), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5492), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5510), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5512), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5038), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5508), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [77201] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5488), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5490), 1,
      anon_sym_GT_GT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5496), 1,
      anon_sym_CARET,
    ACTIONS(5498), 1,
      anon_sym_PIPE,
    ACTIONS(5502), 1,
      anon_sym_PERCENT,
    ACTIONS(5504), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_LT,
    ACTIONS(5514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5516), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2187), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5482), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5484), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5492), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5510), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5512), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5048), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5508), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [77316] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2188), 1,
      sym_comment,
    ACTIONS(3678), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3680), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [77373] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2189), 1,
      sym_comment,
    ACTIONS(5473), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5471), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [77430] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3894), 1,
      anon_sym_EQ,
    ACTIONS(3912), 1,
      anon_sym_QMARK,
    STATE(2190), 1,
      sym_comment,
    ACTIONS(3908), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3752), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [77493] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5488), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5490), 1,
      anon_sym_GT_GT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5496), 1,
      anon_sym_CARET,
    ACTIONS(5498), 1,
      anon_sym_PIPE,
    ACTIONS(5502), 1,
      anon_sym_PERCENT,
    ACTIONS(5504), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_LT,
    ACTIONS(5514), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5516), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2191), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5482), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5484), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5492), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5510), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5512), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5050), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5508), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [77608] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2192), 1,
      sym_comment,
    ACTIONS(5601), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5599), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [77665] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2193), 1,
      sym_comment,
    ACTIONS(5601), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5599), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [77722] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    ACTIONS(4771), 1,
      anon_sym_COMMA,
    ACTIONS(5633), 1,
      anon_sym_RBRACE,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2194), 1,
      sym_comment,
    STATE(4039), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [77841] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2195), 1,
      sym_comment,
    ACTIONS(5595), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5593), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [77898] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2196), 1,
      sym_comment,
    ACTIONS(5529), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5527), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [77955] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2197), 1,
      sym_comment,
    ACTIONS(5637), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5635), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [78012] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2198), 1,
      sym_comment,
    ACTIONS(5529), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5527), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [78069] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    ACTIONS(4771), 1,
      anon_sym_COMMA,
    ACTIONS(5639), 1,
      anon_sym_RPAREN,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2199), 1,
      sym_comment,
    STATE(4039), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [78188] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    ACTIONS(4771), 1,
      anon_sym_COMMA,
    ACTIONS(5641), 1,
      anon_sym_RPAREN,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2200), 1,
      sym_comment,
    STATE(4039), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [78307] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2201), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5297), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
  [78422] = 30,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5054), 1,
      anon_sym_BANG,
    ACTIONS(5486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5488), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5490), 1,
      anon_sym_GT_GT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5496), 1,
      anon_sym_CARET,
    ACTIONS(5498), 1,
      anon_sym_PIPE,
    ACTIONS(5502), 1,
      anon_sym_PERCENT,
    ACTIONS(5504), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2202), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5482), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5484), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5492), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5510), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5512), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5508), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [78529] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1796), 1,
      anon_sym_EQ,
    ACTIONS(4908), 1,
      anon_sym_LBRACK,
    STATE(2203), 1,
      sym_comment,
    ACTIONS(4911), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5643), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2398), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1794), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1800), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [78596] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(2044), 1,
      anon_sym_COMMA,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    ACTIONS(5647), 1,
      anon_sym_RPAREN,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2204), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    STATE(5361), 1,
      aux_sym_array_repeat1,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [78715] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4916), 1,
      anon_sym_EQ,
    ACTIONS(4920), 1,
      anon_sym_LBRACK,
    STATE(2205), 1,
      sym_comment,
    ACTIONS(4923), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5649), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4827), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4914), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4918), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [78782] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    ACTIONS(4771), 1,
      anon_sym_COMMA,
    ACTIONS(5653), 1,
      anon_sym_RPAREN,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2206), 1,
      sym_comment,
    STATE(4039), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [78901] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4564), 1,
      anon_sym_COMMA,
    ACTIONS(4651), 1,
      anon_sym_RBRACE,
    STATE(2207), 1,
      sym_comment,
    STATE(4998), 1,
      aux_sym_object_repeat1,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2100), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2098), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [78966] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2208), 1,
      sym_comment,
    ACTIONS(5607), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5605), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [79023] = 23,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5490), 1,
      anon_sym_GT_GT,
    ACTIONS(5502), 1,
      anon_sym_PERCENT,
    ACTIONS(5504), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5506), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2209), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5482), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5484), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5492), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5500), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5508), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5054), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [79116] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2210), 1,
      sym_comment,
    ACTIONS(5595), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5593), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [79173] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4564), 1,
      anon_sym_COMMA,
    ACTIONS(4651), 1,
      anon_sym_RBRACE,
    STATE(2211), 1,
      sym_comment,
    STATE(4998), 1,
      aux_sym_object_repeat1,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2104), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2102), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [79238] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2212), 1,
      sym_comment,
    ACTIONS(5574), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5572), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [79295] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2213), 1,
      sym_comment,
    ACTIONS(5601), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5599), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [79352] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2214), 1,
      sym_comment,
    ACTIONS(5657), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5655), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [79409] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2215), 1,
      sym_comment,
    ACTIONS(1796), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5659), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(1794), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1800), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [79470] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3848), 1,
      anon_sym_EQ,
    ACTIONS(5447), 1,
      anon_sym_LBRACK,
    STATE(2216), 1,
      sym_comment,
    ACTIONS(5450), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4793), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3752), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [79535] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(2044), 1,
      anon_sym_COMMA,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    ACTIONS(5662), 1,
      anon_sym_RPAREN,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2217), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    STATE(5395), 1,
      aux_sym_array_repeat1,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [79654] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    ACTIONS(4771), 1,
      anon_sym_COMMA,
    ACTIONS(5664), 1,
      anon_sym_RPAREN,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2218), 1,
      sym_comment,
    STATE(4039), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [79773] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2219), 1,
      sym_comment,
    ACTIONS(5529), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5527), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [79830] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    ACTIONS(4771), 1,
      anon_sym_COMMA,
    ACTIONS(5666), 1,
      anon_sym_RPAREN,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2220), 1,
      sym_comment,
    STATE(4039), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [79949] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    ACTIONS(4771), 1,
      anon_sym_COMMA,
    ACTIONS(5668), 1,
      anon_sym_RPAREN,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2221), 1,
      sym_comment,
    STATE(4039), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [80068] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(2044), 1,
      anon_sym_COMMA,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    ACTIONS(5670), 1,
      anon_sym_RPAREN,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2222), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    STATE(5086), 1,
      aux_sym_array_repeat1,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [80187] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    ACTIONS(4771), 1,
      anon_sym_COMMA,
    ACTIONS(5672), 1,
      anon_sym_RPAREN,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2223), 1,
      sym_comment,
    STATE(4039), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [80306] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2224), 1,
      sym_comment,
    ACTIONS(5595), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5593), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [80363] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    STATE(2225), 1,
      sym_comment,
    STATE(2514), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4693), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4695), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [80426] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2226), 1,
      sym_comment,
    ACTIONS(5601), 12,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5599), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [80483] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2227), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5674), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [80598] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2228), 1,
      sym_comment,
    ACTIONS(4669), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2104), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2102), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [80658] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2229), 1,
      sym_comment,
    ACTIONS(3091), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3093), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [80714] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2230), 1,
      sym_comment,
    ACTIONS(4888), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4890), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [80770] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2231), 1,
      sym_comment,
    ACTIONS(4900), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4902), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [80826] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2232), 1,
      sym_comment,
    ACTIONS(4884), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4886), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [80882] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5682), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5684), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5686), 1,
      anon_sym_GT_GT,
    ACTIONS(5690), 1,
      anon_sym_AMP,
    ACTIONS(5692), 1,
      anon_sym_CARET,
    ACTIONS(5694), 1,
      anon_sym_PIPE,
    ACTIONS(5698), 1,
      anon_sym_PERCENT,
    ACTIONS(5700), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5702), 1,
      anon_sym_LT,
    ACTIONS(5710), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5712), 1,
      sym__ternary_qmark,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(2233), 1,
      sym_comment,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5676), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5678), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5680), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5688), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5696), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5706), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5708), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5704), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [80996] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2234), 1,
      sym_comment,
    ACTIONS(5062), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5064), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [81052] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2235), 1,
      sym_comment,
    ACTIONS(4779), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4781), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [81108] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5682), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5684), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5686), 1,
      anon_sym_GT_GT,
    ACTIONS(5690), 1,
      anon_sym_AMP,
    ACTIONS(5692), 1,
      anon_sym_CARET,
    ACTIONS(5694), 1,
      anon_sym_PIPE,
    ACTIONS(5698), 1,
      anon_sym_PERCENT,
    ACTIONS(5700), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5702), 1,
      anon_sym_LT,
    ACTIONS(5710), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5712), 1,
      sym__ternary_qmark,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(2236), 1,
      sym_comment,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5133), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5676), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5678), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5688), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5696), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5706), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5708), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5704), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [81222] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2237), 1,
      sym_comment,
    ACTIONS(4904), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4906), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [81278] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2238), 1,
      sym_comment,
    ACTIONS(2404), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2406), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [81334] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1796), 1,
      anon_sym_EQ,
    ACTIONS(4908), 1,
      anon_sym_LBRACK,
    STATE(2239), 1,
      sym_comment,
    ACTIONS(2398), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4911), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1794), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1800), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [81398] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1796), 1,
      anon_sym_EQ,
    ACTIONS(5261), 1,
      sym__automatic_semicolon,
    STATE(2240), 1,
      sym_comment,
    ACTIONS(1792), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1798), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [81458] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3794), 1,
      anon_sym_EQ,
    STATE(2241), 1,
      sym_comment,
    ACTIONS(3752), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [81516] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5682), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5684), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5686), 1,
      anon_sym_GT_GT,
    ACTIONS(5690), 1,
      anon_sym_AMP,
    ACTIONS(5692), 1,
      anon_sym_CARET,
    ACTIONS(5694), 1,
      anon_sym_PIPE,
    ACTIONS(5698), 1,
      anon_sym_PERCENT,
    ACTIONS(5700), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5702), 1,
      anon_sym_LT,
    ACTIONS(5710), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5712), 1,
      sym__ternary_qmark,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(2242), 1,
      sym_comment,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(4992), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5676), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5678), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5688), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5696), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5706), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5708), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5704), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [81630] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2243), 1,
      sym_comment,
    ACTIONS(4669), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2100), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2098), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [81690] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3917), 1,
      anon_sym_QMARK,
    ACTIONS(3925), 1,
      anon_sym_EQ,
    ACTIONS(5447), 1,
      anon_sym_LBRACK,
    STATE(2244), 1,
      sym_comment,
    ACTIONS(3928), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(4793), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(5450), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3752), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [81758] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4667), 1,
      anon_sym_extends,
    ACTIONS(5312), 1,
      anon_sym_LBRACK,
    ACTIONS(5718), 1,
      anon_sym_RPAREN,
    STATE(2245), 1,
      sym_comment,
    ACTIONS(5315), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5714), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5716), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3752), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [81826] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1796), 1,
      anon_sym_EQ,
    STATE(2246), 1,
      sym_comment,
    ACTIONS(1794), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1800), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [81884] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5721), 1,
      anon_sym_LT,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(2247), 1,
      sym_comment,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4877), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4879), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [81960] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4916), 1,
      anon_sym_EQ,
    ACTIONS(4920), 1,
      anon_sym_LBRACK,
    STATE(2248), 1,
      sym_comment,
    ACTIONS(4827), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4923), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4914), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4918), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [82024] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5724), 1,
      anon_sym_LT,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(2249), 1,
      sym_comment,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5098), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5100), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [82106] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1796), 1,
      anon_sym_EQ,
    ACTIONS(3043), 1,
      sym__automatic_semicolon,
    STATE(2250), 1,
      sym_comment,
    ACTIONS(1798), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1794), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1800), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [82168] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5682), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5684), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5686), 1,
      anon_sym_GT_GT,
    ACTIONS(5690), 1,
      anon_sym_AMP,
    ACTIONS(5692), 1,
      anon_sym_CARET,
    ACTIONS(5694), 1,
      anon_sym_PIPE,
    ACTIONS(5698), 1,
      anon_sym_PERCENT,
    ACTIONS(5700), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5702), 1,
      anon_sym_LT,
    ACTIONS(5710), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5712), 1,
      sym__ternary_qmark,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(2251), 1,
      sym_comment,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5124), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5676), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5678), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5688), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5696), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5706), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5708), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5704), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [82282] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2252), 1,
      sym_comment,
    ACTIONS(4932), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4934), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [82338] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2253), 1,
      sym_comment,
    ACTIONS(4936), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4938), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [82394] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5682), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5684), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5686), 1,
      anon_sym_GT_GT,
    ACTIONS(5690), 1,
      anon_sym_AMP,
    ACTIONS(5692), 1,
      anon_sym_CARET,
    ACTIONS(5694), 1,
      anon_sym_PIPE,
    ACTIONS(5698), 1,
      anon_sym_PERCENT,
    ACTIONS(5700), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5702), 1,
      anon_sym_LT,
    ACTIONS(5710), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5712), 1,
      sym__ternary_qmark,
    ACTIONS(5727), 1,
      anon_sym_SEMI,
    ACTIONS(5729), 1,
      sym__automatic_semicolon,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(2254), 1,
      sym_comment,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5676), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5678), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5688), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5696), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5706), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5708), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5704), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [82510] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5682), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5684), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5686), 1,
      anon_sym_GT_GT,
    ACTIONS(5690), 1,
      anon_sym_AMP,
    ACTIONS(5692), 1,
      anon_sym_CARET,
    ACTIONS(5694), 1,
      anon_sym_PIPE,
    ACTIONS(5698), 1,
      anon_sym_PERCENT,
    ACTIONS(5700), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5702), 1,
      anon_sym_LT,
    ACTIONS(5710), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5712), 1,
      sym__ternary_qmark,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(2255), 1,
      sym_comment,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5676), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5678), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5688), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5696), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5706), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5708), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5731), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5704), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [82624] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5733), 1,
      anon_sym_AMP,
    ACTIONS(5735), 1,
      anon_sym_PIPE,
    ACTIONS(5737), 1,
      anon_sym_extends,
    STATE(2256), 1,
      sym_comment,
    ACTIONS(5120), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5122), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [82686] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2257), 1,
      sym_comment,
    ACTIONS(5315), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5312), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(4667), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3752), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [82748] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2258), 1,
      sym_comment,
    ACTIONS(5112), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5114), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [82804] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5739), 1,
      anon_sym_LT,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(2259), 1,
      sym_comment,
    STATE(5319), 1,
      sym_optional_chain,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5126), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5128), 20,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [82878] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2260), 1,
      sym_comment,
    ACTIONS(5744), 11,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5742), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [82934] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2261), 1,
      sym_comment,
    ACTIONS(5108), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5110), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [82990] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2262), 1,
      sym_comment,
    ACTIONS(5108), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5110), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [83046] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2263), 1,
      sym_comment,
    ACTIONS(5108), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5110), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [83102] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2264), 1,
      sym_comment,
    ACTIONS(5094), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5096), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [83158] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2265), 1,
      sym_comment,
    ACTIONS(4789), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4787), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3752), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [83218] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2266), 1,
      sym_comment,
    ACTIONS(4781), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(4775), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4777), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [83276] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3894), 1,
      anon_sym_EQ,
    STATE(2267), 1,
      sym_comment,
    ACTIONS(3752), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [83334] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2268), 1,
      sym_comment,
    ACTIONS(5094), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5096), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [83390] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2269), 1,
      sym_comment,
    ACTIONS(5409), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5406), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(4841), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5338), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5340), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [83452] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2270), 1,
      sym_comment,
    ACTIONS(5094), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5096), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [83508] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2271), 1,
      sym_comment,
    ACTIONS(5090), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5092), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [83564] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2272), 1,
      sym_comment,
    ACTIONS(5090), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5092), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [83620] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2273), 1,
      sym_comment,
    ACTIONS(5748), 11,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5746), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [83676] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2274), 1,
      sym_comment,
    ACTIONS(3159), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3161), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [83732] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2275), 1,
      sym_comment,
    ACTIONS(3153), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3155), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [83788] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2276), 1,
      sym_comment,
    ACTIONS(5090), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5092), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [83844] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2277), 1,
      sym_comment,
    ACTIONS(5450), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5447), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(4793), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3752), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [83906] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2278), 1,
      sym_comment,
    ACTIONS(5086), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5088), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [83962] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(5750), 1,
      anon_sym_STAR,
    ACTIONS(5752), 1,
      anon_sym_async,
    STATE(2279), 1,
      sym_comment,
    STATE(4117), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5754), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [84036] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(5750), 1,
      anon_sym_STAR,
    STATE(2280), 1,
      sym_comment,
    STATE(4117), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5754), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [84108] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2281), 1,
      sym_comment,
    ACTIONS(2400), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2402), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [84164] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2282), 1,
      sym_comment,
    ACTIONS(3145), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3147), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [84220] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4781), 1,
      anon_sym_extends,
    STATE(2283), 1,
      sym_comment,
    ACTIONS(4775), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4777), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [84278] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2284), 1,
      sym_comment,
    ACTIONS(4940), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4942), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [84334] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2285), 1,
      sym_comment,
    ACTIONS(4783), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4785), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [84390] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2286), 1,
      sym_comment,
    ACTIONS(4944), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4946), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [84446] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    STATE(2287), 1,
      sym_comment,
    STATE(2556), 1,
      sym_arguments,
    ACTIONS(4892), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4894), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [84506] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2288), 1,
      sym_comment,
    ACTIONS(5082), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5084), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [84562] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2289), 1,
      sym_comment,
    ACTIONS(5074), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5076), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [84618] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2290), 1,
      sym_comment,
    ACTIONS(5070), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5072), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [84674] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2291), 1,
      sym_comment,
    ACTIONS(5066), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5068), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [84730] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2292), 1,
      sym_comment,
    ACTIONS(5066), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5068), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [84786] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2293), 1,
      sym_comment,
    ACTIONS(5066), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5068), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [84842] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5682), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5684), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5686), 1,
      anon_sym_GT_GT,
    ACTIONS(5690), 1,
      anon_sym_AMP,
    ACTIONS(5692), 1,
      anon_sym_CARET,
    ACTIONS(5694), 1,
      anon_sym_PIPE,
    ACTIONS(5698), 1,
      anon_sym_PERCENT,
    ACTIONS(5700), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5702), 1,
      anon_sym_LT,
    ACTIONS(5710), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5712), 1,
      sym__ternary_qmark,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(2294), 1,
      sym_comment,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5205), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5676), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5678), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5688), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5696), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5706), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5708), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5704), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [84956] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4825), 1,
      anon_sym_QMARK,
    ACTIONS(4827), 1,
      anon_sym_extends,
    ACTIONS(4916), 1,
      anon_sym_EQ,
    ACTIONS(4920), 1,
      anon_sym_LBRACK,
    ACTIONS(5310), 1,
      anon_sym_COLON,
    STATE(2295), 1,
      sym_comment,
    ACTIONS(4923), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5649), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(4914), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4918), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [85026] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2296), 1,
      sym_comment,
    ACTIONS(4950), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4952), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [85082] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1796), 1,
      anon_sym_EQ,
    ACTIONS(2396), 1,
      anon_sym_QMARK,
    ACTIONS(2398), 1,
      anon_sym_extends,
    ACTIONS(4908), 1,
      anon_sym_LBRACK,
    ACTIONS(5355), 1,
      anon_sym_COLON,
    STATE(2297), 1,
      sym_comment,
    ACTIONS(4911), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5643), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1794), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1800), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [85152] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2298), 1,
      sym_comment,
    ACTIONS(5062), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5064), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [85208] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2299), 1,
      sym_comment,
    ACTIONS(5062), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5064), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [85264] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2300), 1,
      sym_comment,
    ACTIONS(5056), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5058), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [85320] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2301), 1,
      sym_comment,
    ACTIONS(5056), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5058), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [85376] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2302), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5756), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [85490] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2303), 1,
      sym_comment,
    ACTIONS(5056), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5058), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [85546] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3896), 1,
      anon_sym_EQ,
    ACTIONS(4793), 1,
      anon_sym_extends,
    STATE(2304), 1,
      sym_comment,
    ACTIONS(5447), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5450), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3752), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [85610] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2305), 1,
      sym_comment,
    ACTIONS(5034), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5036), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [85666] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5682), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5684), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5686), 1,
      anon_sym_GT_GT,
    ACTIONS(5690), 1,
      anon_sym_AMP,
    ACTIONS(5692), 1,
      anon_sym_CARET,
    ACTIONS(5694), 1,
      anon_sym_PIPE,
    ACTIONS(5698), 1,
      anon_sym_PERCENT,
    ACTIONS(5700), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5702), 1,
      anon_sym_LT,
    ACTIONS(5710), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5712), 1,
      sym__ternary_qmark,
    ACTIONS(5758), 1,
      anon_sym_SEMI,
    ACTIONS(5760), 1,
      sym__automatic_semicolon,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(2306), 1,
      sym_comment,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5676), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5678), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5688), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5696), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5706), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5708), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5704), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [85782] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2307), 1,
      sym_comment,
    ACTIONS(4791), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4793), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [85838] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5682), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5684), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5686), 1,
      anon_sym_GT_GT,
    ACTIONS(5690), 1,
      anon_sym_AMP,
    ACTIONS(5692), 1,
      anon_sym_CARET,
    ACTIONS(5694), 1,
      anon_sym_PIPE,
    ACTIONS(5698), 1,
      anon_sym_PERCENT,
    ACTIONS(5700), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5702), 1,
      anon_sym_LT,
    ACTIONS(5710), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5712), 1,
      sym__ternary_qmark,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(2308), 1,
      sym_comment,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(4994), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5676), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5678), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5688), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5696), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5706), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5708), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5704), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [85952] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2309), 1,
      sym_comment,
    ACTIONS(4801), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4803), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [86008] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5682), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5684), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5686), 1,
      anon_sym_GT_GT,
    ACTIONS(5690), 1,
      anon_sym_AMP,
    ACTIONS(5692), 1,
      anon_sym_CARET,
    ACTIONS(5694), 1,
      anon_sym_PIPE,
    ACTIONS(5698), 1,
      anon_sym_PERCENT,
    ACTIONS(5700), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5702), 1,
      anon_sym_LT,
    ACTIONS(5710), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5712), 1,
      sym__ternary_qmark,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(2310), 1,
      sym_comment,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5000), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5676), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5678), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5688), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5696), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5706), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5708), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5704), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [86122] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2311), 1,
      sym_comment,
    ACTIONS(2388), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2390), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [86178] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4916), 1,
      anon_sym_EQ,
    STATE(2312), 1,
      sym_comment,
    ACTIONS(4914), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4918), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [86236] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4661), 1,
      anon_sym_extends,
    STATE(2313), 1,
      sym_comment,
    ACTIONS(4926), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4928), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [86294] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5682), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5684), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5686), 1,
      anon_sym_GT_GT,
    ACTIONS(5690), 1,
      anon_sym_AMP,
    ACTIONS(5692), 1,
      anon_sym_CARET,
    ACTIONS(5694), 1,
      anon_sym_PIPE,
    ACTIONS(5698), 1,
      anon_sym_PERCENT,
    ACTIONS(5700), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5702), 1,
      anon_sym_LT,
    ACTIONS(5710), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5712), 1,
      sym__ternary_qmark,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(2314), 1,
      sym_comment,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5060), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5676), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5678), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5688), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5696), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5706), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5708), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5704), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [86408] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5733), 1,
      anon_sym_AMP,
    ACTIONS(5735), 1,
      anon_sym_PIPE,
    ACTIONS(5737), 1,
      anon_sym_extends,
    STATE(2315), 1,
      sym_comment,
    ACTIONS(4926), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4928), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [86470] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(5762), 1,
      anon_sym_STAR,
    STATE(2316), 1,
      sym_comment,
    STATE(4132), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5764), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [86542] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5733), 1,
      anon_sym_AMP,
    ACTIONS(5735), 1,
      anon_sym_PIPE,
    ACTIONS(5737), 1,
      anon_sym_extends,
    STATE(2317), 1,
      sym_comment,
    ACTIONS(5030), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5032), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [86604] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5733), 1,
      anon_sym_AMP,
    ACTIONS(5735), 1,
      anon_sym_PIPE,
    ACTIONS(5737), 1,
      anon_sym_extends,
    STATE(2318), 1,
      sym_comment,
    ACTIONS(5026), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5028), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [86666] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5682), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5684), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5686), 1,
      anon_sym_GT_GT,
    ACTIONS(5690), 1,
      anon_sym_AMP,
    ACTIONS(5692), 1,
      anon_sym_CARET,
    ACTIONS(5694), 1,
      anon_sym_PIPE,
    ACTIONS(5698), 1,
      anon_sym_PERCENT,
    ACTIONS(5700), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5702), 1,
      anon_sym_LT,
    ACTIONS(5710), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5712), 1,
      sym__ternary_qmark,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(2319), 1,
      sym_comment,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5038), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5676), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5678), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5688), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5696), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5706), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5708), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5704), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [86780] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2320), 1,
      sym_comment,
    ACTIONS(3045), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3047), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [86836] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2321), 1,
      sym_comment,
    ACTIONS(3091), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3093), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [86892] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5733), 1,
      anon_sym_AMP,
    ACTIONS(5735), 1,
      anon_sym_PIPE,
    ACTIONS(5737), 1,
      anon_sym_extends,
    STATE(2322), 1,
      sym_comment,
    ACTIONS(4944), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4946), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [86954] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(5766), 1,
      anon_sym_STAR,
    STATE(2323), 1,
      sym_comment,
    STATE(4159), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5768), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [87026] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2324), 1,
      sym_comment,
    ACTIONS(4665), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4667), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [87082] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2325), 1,
      sym_comment,
    ACTIONS(4896), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4898), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [87138] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5682), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5684), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5686), 1,
      anon_sym_GT_GT,
    ACTIONS(5690), 1,
      anon_sym_AMP,
    ACTIONS(5692), 1,
      anon_sym_CARET,
    ACTIONS(5694), 1,
      anon_sym_PIPE,
    ACTIONS(5698), 1,
      anon_sym_PERCENT,
    ACTIONS(5700), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5702), 1,
      anon_sym_LT,
    ACTIONS(5710), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5712), 1,
      sym__ternary_qmark,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(2326), 1,
      sym_comment,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5137), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5676), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5678), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5688), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5696), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5706), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5708), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5704), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [87252] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5733), 1,
      anon_sym_AMP,
    ACTIONS(5735), 1,
      anon_sym_PIPE,
    ACTIONS(5737), 1,
      anon_sym_extends,
    STATE(2327), 1,
      sym_comment,
    ACTIONS(5022), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5024), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [87314] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2328), 1,
      sym_comment,
    ACTIONS(5022), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5024), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [87370] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5682), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5684), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5686), 1,
      anon_sym_GT_GT,
    ACTIONS(5690), 1,
      anon_sym_AMP,
    ACTIONS(5692), 1,
      anon_sym_CARET,
    ACTIONS(5694), 1,
      anon_sym_PIPE,
    ACTIONS(5698), 1,
      anon_sym_PERCENT,
    ACTIONS(5700), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5702), 1,
      anon_sym_LT,
    ACTIONS(5710), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5712), 1,
      sym__ternary_qmark,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(2329), 1,
      sym_comment,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5135), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5676), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5678), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5688), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5696), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5706), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5708), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5704), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [87484] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2330), 1,
      sym_comment,
    ACTIONS(5018), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5020), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [87540] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5733), 1,
      anon_sym_AMP,
    ACTIONS(5735), 1,
      anon_sym_PIPE,
    ACTIONS(5737), 1,
      anon_sym_extends,
    STATE(2331), 1,
      sym_comment,
    ACTIONS(5014), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5016), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [87602] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5191), 1,
      anon_sym_EQ,
    STATE(2332), 1,
      sym_comment,
    ACTIONS(5189), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5193), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [87660] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2333), 1,
      sym_comment,
    ACTIONS(5010), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5012), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [87716] = 21,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5686), 1,
      anon_sym_GT_GT,
    ACTIONS(5698), 1,
      anon_sym_PERCENT,
    ACTIONS(5700), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5702), 1,
      anon_sym_LT,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(2334), 1,
      sym_comment,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5676), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5688), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5696), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [87804] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2335), 1,
      sym_comment,
    ACTIONS(5006), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5008), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [87860] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2336), 1,
      sym_comment,
    ACTIONS(5002), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5004), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [87916] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5682), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5684), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5686), 1,
      anon_sym_GT_GT,
    ACTIONS(5690), 1,
      anon_sym_AMP,
    ACTIONS(5692), 1,
      anon_sym_CARET,
    ACTIONS(5694), 1,
      anon_sym_PIPE,
    ACTIONS(5698), 1,
      anon_sym_PERCENT,
    ACTIONS(5700), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5702), 1,
      anon_sym_LT,
    ACTIONS(5710), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5712), 1,
      sym__ternary_qmark,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(2337), 1,
      sym_comment,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5676), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5678), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5688), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5696), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5706), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5708), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5770), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5704), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [88030] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(5762), 1,
      anon_sym_STAR,
    ACTIONS(5772), 1,
      anon_sym_async,
    STATE(2338), 1,
      sym_comment,
    STATE(4132), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5764), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [88104] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2339), 1,
      sym_comment,
    ACTIONS(4996), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4998), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [88160] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2340), 1,
      sym_comment,
    ACTIONS(3119), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3121), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [88216] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5682), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5684), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5686), 1,
      anon_sym_GT_GT,
    ACTIONS(5690), 1,
      anon_sym_AMP,
    ACTIONS(5692), 1,
      anon_sym_CARET,
    ACTIONS(5694), 1,
      anon_sym_PIPE,
    ACTIONS(5698), 1,
      anon_sym_PERCENT,
    ACTIONS(5700), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5702), 1,
      anon_sym_LT,
    ACTIONS(5710), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5712), 1,
      sym__ternary_qmark,
    ACTIONS(5774), 1,
      anon_sym_SEMI,
    ACTIONS(5776), 1,
      sym__automatic_semicolon,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(2341), 1,
      sym_comment,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5676), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5678), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5688), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5696), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5706), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5708), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5704), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [88332] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5700), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5778), 1,
      anon_sym_LT,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(2342), 1,
      sym_comment,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [88410] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2343), 1,
      sym_comment,
    ACTIONS(3119), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3121), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [88466] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2344), 1,
      sym_comment,
    ACTIONS(5002), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5004), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [88522] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5785), 1,
      sym_regex_flags,
    STATE(2345), 1,
      sym_comment,
    ACTIONS(5781), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_satisfies,
    ACTIONS(5783), 25,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [88580] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2346), 1,
      sym_comment,
    ACTIONS(4996), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4998), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [88636] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4809), 1,
      anon_sym_DOT,
    STATE(2347), 1,
      sym_comment,
    ACTIONS(4805), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4807), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [88694] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4812), 1,
      anon_sym_DOT,
    STATE(2348), 1,
      sym_comment,
    ACTIONS(4805), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4807), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [88752] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5682), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5684), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5686), 1,
      anon_sym_GT_GT,
    ACTIONS(5690), 1,
      anon_sym_AMP,
    ACTIONS(5692), 1,
      anon_sym_CARET,
    ACTIONS(5694), 1,
      anon_sym_PIPE,
    ACTIONS(5698), 1,
      anon_sym_PERCENT,
    ACTIONS(5700), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5702), 1,
      anon_sym_LT,
    ACTIONS(5710), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5712), 1,
      sym__ternary_qmark,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(2349), 1,
      sym_comment,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(4727), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5676), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5678), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5688), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5696), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5706), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5708), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5704), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [88866] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2350), 1,
      sym_comment,
    ACTIONS(4988), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4990), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [88922] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2351), 1,
      sym_comment,
    ACTIONS(4984), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4986), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [88978] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2352), 1,
      sym_comment,
    ACTIONS(4988), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4990), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [89034] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2353), 1,
      sym_comment,
    ACTIONS(4795), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4797), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [89090] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2354), 1,
      sym_comment,
    ACTIONS(4781), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4775), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4777), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [89148] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2355), 1,
      sym_comment,
    ACTIONS(4984), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4986), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [89204] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2356), 1,
      sym_comment,
    ACTIONS(5789), 11,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5787), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [89260] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4793), 1,
      anon_sym_extends,
    STATE(2357), 1,
      sym_comment,
    ACTIONS(5447), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5450), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3752), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [89322] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2398), 1,
      anon_sym_extends,
    ACTIONS(4908), 1,
      anon_sym_LBRACK,
    ACTIONS(5791), 1,
      anon_sym_RPAREN,
    STATE(2358), 1,
      sym_comment,
    ACTIONS(1796), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4911), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5355), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1794), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1800), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [89390] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4667), 1,
      anon_sym_extends,
    ACTIONS(5312), 1,
      anon_sym_LBRACK,
    ACTIONS(5797), 1,
      anon_sym_RPAREN,
    STATE(2359), 1,
      sym_comment,
    ACTIONS(5315), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5714), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5794), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3752), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [89458] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3848), 1,
      anon_sym_EQ,
    ACTIONS(3917), 1,
      anon_sym_QMARK,
    ACTIONS(5447), 1,
      anon_sym_LBRACK,
    STATE(2360), 1,
      sym_comment,
    ACTIONS(3914), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(4793), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(5450), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3752), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [89526] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2361), 1,
      sym_comment,
    ACTIONS(4980), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4982), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [89582] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4841), 1,
      anon_sym_extends,
    STATE(2362), 1,
      sym_comment,
    ACTIONS(5406), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5409), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5338), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5340), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [89644] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2363), 1,
      sym_comment,
    ACTIONS(4976), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4978), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [89700] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2364), 1,
      sym_comment,
    ACTIONS(4787), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4789), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3752), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [89760] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4827), 1,
      anon_sym_extends,
    ACTIONS(4920), 1,
      anon_sym_LBRACK,
    ACTIONS(5801), 1,
      anon_sym_RPAREN,
    STATE(2365), 1,
      sym_comment,
    ACTIONS(4916), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4923), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5310), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(4914), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4918), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [89828] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2366), 1,
      sym_comment,
    ACTIONS(5789), 11,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5787), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [89884] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(2148), 1,
      anon_sym_EQ_GT,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2367), 1,
      sym_comment,
    STATE(4091), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [89954] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5392), 1,
      anon_sym_QMARK_DOT,
    STATE(2368), 1,
      sym_comment,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(1844), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1848), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [90018] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(5540), 1,
      anon_sym_STAR,
    STATE(2369), 1,
      sym_comment,
    STATE(4091), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5546), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [90090] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(5540), 1,
      anon_sym_STAR,
    ACTIONS(5542), 1,
      anon_sym_async,
    STATE(2370), 1,
      sym_comment,
    STATE(4091), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5546), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [90164] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2371), 1,
      sym_comment,
    ACTIONS(5806), 11,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5804), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [90220] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2372), 1,
      sym_comment,
    ACTIONS(4980), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4982), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [90276] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2373), 1,
      sym_comment,
    ACTIONS(2396), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2398), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [90332] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4827), 1,
      anon_sym_extends,
    ACTIONS(4920), 1,
      anon_sym_LBRACK,
    ACTIONS(5649), 1,
      anon_sym_RPAREN,
    STATE(2374), 1,
      sym_comment,
    ACTIONS(4916), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4923), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5628), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(4914), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4918), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [90400] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2398), 1,
      anon_sym_extends,
    ACTIONS(4908), 1,
      anon_sym_LBRACK,
    ACTIONS(5643), 1,
      anon_sym_RPAREN,
    STATE(2375), 1,
      sym_comment,
    ACTIONS(1796), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4911), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5659), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1794), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1800), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [90468] = 28,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5054), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5686), 1,
      anon_sym_GT_GT,
    ACTIONS(5690), 1,
      anon_sym_AMP,
    ACTIONS(5692), 1,
      anon_sym_CARET,
    ACTIONS(5694), 1,
      anon_sym_PIPE,
    ACTIONS(5698), 1,
      anon_sym_PERCENT,
    ACTIONS(5700), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5702), 1,
      anon_sym_LT,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(2376), 1,
      sym_comment,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5676), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5678), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5688), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5696), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5706), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5708), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5704), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 8,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [90570] = 29,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5054), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5682), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5686), 1,
      anon_sym_GT_GT,
    ACTIONS(5690), 1,
      anon_sym_AMP,
    ACTIONS(5692), 1,
      anon_sym_CARET,
    ACTIONS(5694), 1,
      anon_sym_PIPE,
    ACTIONS(5698), 1,
      anon_sym_PERCENT,
    ACTIONS(5700), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5702), 1,
      anon_sym_LT,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(2377), 1,
      sym_comment,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5676), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5678), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5688), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5696), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5706), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5708), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5704), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 7,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [90674] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5808), 1,
      anon_sym_DOT,
    STATE(2378), 1,
      sym_comment,
    ACTIONS(4815), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4817), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [90732] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2379), 1,
      sym_comment,
    ACTIONS(4976), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4978), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [90788] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2380), 1,
      sym_comment,
    ACTIONS(4821), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4823), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [90844] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4667), 1,
      anon_sym_extends,
    ACTIONS(5312), 1,
      anon_sym_LBRACK,
    ACTIONS(5814), 1,
      anon_sym_RPAREN,
    STATE(2381), 1,
      sym_comment,
    ACTIONS(5315), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5810), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5812), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3752), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [90912] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2382), 1,
      sym_comment,
    ACTIONS(4825), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4827), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [90968] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2383), 1,
      sym_comment,
    ACTIONS(4829), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4831), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [91024] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5733), 1,
      anon_sym_AMP,
    STATE(2384), 1,
      sym_comment,
    ACTIONS(4833), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4835), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [91082] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2385), 1,
      sym_comment,
    ACTIONS(4789), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4787), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [91138] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2386), 1,
      sym_comment,
    ACTIONS(4839), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4841), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [91194] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2387), 1,
      sym_comment,
    ACTIONS(4843), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4845), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [91250] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5698), 1,
      anon_sym_PERCENT,
    ACTIONS(5700), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5778), 1,
      anon_sym_LT,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(2388), 1,
      sym_comment,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5676), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5696), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [91334] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5733), 1,
      anon_sym_AMP,
    ACTIONS(5735), 1,
      anon_sym_PIPE,
    ACTIONS(5737), 1,
      anon_sym_extends,
    STATE(2389), 1,
      sym_comment,
    ACTIONS(4847), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4849), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [91396] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4797), 1,
      anon_sym_extends,
    ACTIONS(5817), 1,
      anon_sym_LBRACK,
    STATE(2390), 1,
      sym_comment,
    ACTIONS(4795), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4855), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4857), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [91458] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2391), 1,
      sym_comment,
    ACTIONS(4972), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4974), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [91514] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5819), 1,
      anon_sym_extends,
    STATE(2392), 1,
      sym_comment,
    ACTIONS(4859), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4861), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [91572] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5817), 1,
      anon_sym_LBRACK,
    STATE(2393), 1,
      sym_comment,
    ACTIONS(4865), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4867), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [91630] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2394), 1,
      sym_comment,
    ACTIONS(4968), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4970), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [91686] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2395), 1,
      sym_comment,
    ACTIONS(2392), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2394), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [91742] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2396), 1,
      sym_comment,
    ACTIONS(4871), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4873), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [91798] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2397), 1,
      sym_comment,
    ACTIONS(4659), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4661), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [91854] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2398), 1,
      sym_comment,
    ACTIONS(5533), 11,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5531), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [91910] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2399), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5345), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [92024] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4735), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4737), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4739), 1,
      anon_sym_GT_GT,
    ACTIONS(4743), 1,
      anon_sym_AMP,
    ACTIONS(4745), 1,
      anon_sym_CARET,
    ACTIONS(4747), 1,
      anon_sym_PIPE,
    ACTIONS(4751), 1,
      anon_sym_PERCENT,
    ACTIONS(4753), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4755), 1,
      anon_sym_LT,
    ACTIONS(4763), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4769), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2400), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4723), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4731), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4741), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4749), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4759), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4761), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5201), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4757), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [92138] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5817), 1,
      anon_sym_LBRACK,
    STATE(2401), 1,
      sym_comment,
    ACTIONS(4795), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4797), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [92196] = 25,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5686), 1,
      anon_sym_GT_GT,
    ACTIONS(5698), 1,
      anon_sym_PERCENT,
    ACTIONS(5700), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5702), 1,
      anon_sym_LT,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(2402), 1,
      sym_comment,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5676), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5678), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5688), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5696), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5706), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5708), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5704), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 9,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [92292] = 26,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5686), 1,
      anon_sym_GT_GT,
    ACTIONS(5690), 1,
      anon_sym_AMP,
    ACTIONS(5698), 1,
      anon_sym_PERCENT,
    ACTIONS(5700), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5702), 1,
      anon_sym_LT,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(2403), 1,
      sym_comment,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5054), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5676), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5678), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5688), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5696), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5706), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5708), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5704), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 9,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [92390] = 27,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5686), 1,
      anon_sym_GT_GT,
    ACTIONS(5690), 1,
      anon_sym_AMP,
    ACTIONS(5692), 1,
      anon_sym_CARET,
    ACTIONS(5698), 1,
      anon_sym_PERCENT,
    ACTIONS(5700), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5702), 1,
      anon_sym_LT,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(2404), 1,
      sym_comment,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5054), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5676), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5678), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5688), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5696), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5706), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5708), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5704), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 8,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [92490] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5698), 1,
      anon_sym_PERCENT,
    ACTIONS(5700), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5778), 1,
      anon_sym_LT,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(2405), 1,
      sym_comment,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5676), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [92572] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5700), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5778), 1,
      anon_sym_LT,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(2406), 1,
      sym_comment,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [92656] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5733), 1,
      anon_sym_AMP,
    ACTIONS(5735), 1,
      anon_sym_PIPE,
    ACTIONS(5737), 1,
      anon_sym_extends,
    STATE(2407), 1,
      sym_comment,
    ACTIONS(4962), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4964), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [92718] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2408), 1,
      sym_comment,
    ACTIONS(3115), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3117), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [92774] = 23,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5686), 1,
      anon_sym_GT_GT,
    ACTIONS(5698), 1,
      anon_sym_PERCENT,
    ACTIONS(5700), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5702), 1,
      anon_sym_LT,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(2409), 1,
      sym_comment,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5676), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5678), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5688), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5696), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5704), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5054), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 11,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [92866] = 30,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5054), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5682), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5684), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5686), 1,
      anon_sym_GT_GT,
    ACTIONS(5690), 1,
      anon_sym_AMP,
    ACTIONS(5692), 1,
      anon_sym_CARET,
    ACTIONS(5694), 1,
      anon_sym_PIPE,
    ACTIONS(5698), 1,
      anon_sym_PERCENT,
    ACTIONS(5700), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5702), 1,
      anon_sym_LT,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(2410), 1,
      sym_comment,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5676), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5678), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5688), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5696), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5706), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5708), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5704), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 6,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [92972] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5682), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5684), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5686), 1,
      anon_sym_GT_GT,
    ACTIONS(5690), 1,
      anon_sym_AMP,
    ACTIONS(5692), 1,
      anon_sym_CARET,
    ACTIONS(5694), 1,
      anon_sym_PIPE,
    ACTIONS(5698), 1,
      anon_sym_PERCENT,
    ACTIONS(5700), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5702), 1,
      anon_sym_LT,
    ACTIONS(5710), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5712), 1,
      sym__ternary_qmark,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(2411), 1,
      sym_comment,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5050), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5676), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5678), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5688), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5696), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5706), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5708), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5704), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [93086] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2412), 1,
      sym_comment,
    ACTIONS(4671), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4673), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [93142] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5682), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5684), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5686), 1,
      anon_sym_GT_GT,
    ACTIONS(5690), 1,
      anon_sym_AMP,
    ACTIONS(5692), 1,
      anon_sym_CARET,
    ACTIONS(5694), 1,
      anon_sym_PIPE,
    ACTIONS(5698), 1,
      anon_sym_PERCENT,
    ACTIONS(5700), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5702), 1,
      anon_sym_LT,
    ACTIONS(5710), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5712), 1,
      sym__ternary_qmark,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(2413), 1,
      sym_comment,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5048), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5676), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5678), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5688), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5696), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5706), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5708), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5704), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [93256] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5702), 1,
      anon_sym_LT,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(2414), 1,
      sym_comment,
    STATE(5319), 1,
      sym_optional_chain,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5078), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5080), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [93324] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2415), 1,
      sym_comment,
    ACTIONS(4958), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4960), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [93380] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2416), 1,
      sym_comment,
    ACTIONS(3123), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3125), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [93436] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2417), 1,
      sym_comment,
    ACTIONS(3135), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3137), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [93492] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3884), 1,
      anon_sym_EQ,
    ACTIONS(4793), 1,
      anon_sym_extends,
    STATE(2418), 1,
      sym_comment,
    ACTIONS(5447), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5450), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3752), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [93556] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4667), 1,
      anon_sym_extends,
    STATE(2419), 1,
      sym_comment,
    ACTIONS(5312), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5315), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3752), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [93618] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5682), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5684), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5686), 1,
      anon_sym_GT_GT,
    ACTIONS(5690), 1,
      anon_sym_AMP,
    ACTIONS(5692), 1,
      anon_sym_CARET,
    ACTIONS(5694), 1,
      anon_sym_PIPE,
    ACTIONS(5698), 1,
      anon_sym_PERCENT,
    ACTIONS(5700), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5702), 1,
      anon_sym_LT,
    ACTIONS(5710), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5712), 1,
      sym__ternary_qmark,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(2420), 1,
      sym_comment,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5116), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5676), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5678), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5688), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5696), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5706), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5708), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5704), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [93732] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5141), 1,
      anon_sym_as,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(5185), 1,
      anon_sym_satisfies,
    ACTIONS(5682), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5684), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5686), 1,
      anon_sym_GT_GT,
    ACTIONS(5690), 1,
      anon_sym_AMP,
    ACTIONS(5692), 1,
      anon_sym_CARET,
    ACTIONS(5694), 1,
      anon_sym_PIPE,
    ACTIONS(5698), 1,
      anon_sym_PERCENT,
    ACTIONS(5700), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5702), 1,
      anon_sym_LT,
    ACTIONS(5710), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5712), 1,
      sym__ternary_qmark,
    STATE(2225), 1,
      sym_type_arguments,
    STATE(2421), 1,
      sym_comment,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(5118), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5183), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5676), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5678), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5688), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5696), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5706), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5708), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5704), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [93846] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5733), 1,
      anon_sym_AMP,
    STATE(2422), 1,
      sym_comment,
    ACTIONS(4954), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4956), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [93904] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4992), 1,
      anon_sym_RBRACK,
    ACTIONS(5825), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5827), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5829), 1,
      anon_sym_GT_GT,
    ACTIONS(5833), 1,
      anon_sym_AMP,
    ACTIONS(5835), 1,
      anon_sym_CARET,
    ACTIONS(5837), 1,
      anon_sym_PIPE,
    ACTIONS(5841), 1,
      anon_sym_PERCENT,
    ACTIONS(5843), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5845), 1,
      anon_sym_LT,
    ACTIONS(5853), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5855), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2423), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5821), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5823), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5831), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5839), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5849), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5851), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5847), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [94017] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5118), 1,
      anon_sym_RBRACK,
    ACTIONS(5825), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5827), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5829), 1,
      anon_sym_GT_GT,
    ACTIONS(5833), 1,
      anon_sym_AMP,
    ACTIONS(5835), 1,
      anon_sym_CARET,
    ACTIONS(5837), 1,
      anon_sym_PIPE,
    ACTIONS(5841), 1,
      anon_sym_PERCENT,
    ACTIONS(5843), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5845), 1,
      anon_sym_LT,
    ACTIONS(5853), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5855), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2424), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5821), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5823), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5831), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5839), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5849), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5851), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5847), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [94130] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2425), 1,
      sym_comment,
    STATE(4144), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [94197] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2426), 1,
      sym_comment,
    STATE(4173), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [94264] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2427), 1,
      sym_comment,
    ACTIONS(5394), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5396), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [94319] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5861), 1,
      anon_sym_COLON,
    ACTIONS(5863), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5867), 1,
      anon_sym_GT_GT,
    ACTIONS(5871), 1,
      anon_sym_AMP,
    ACTIONS(5873), 1,
      anon_sym_CARET,
    ACTIONS(5875), 1,
      anon_sym_PIPE,
    ACTIONS(5879), 1,
      anon_sym_PERCENT,
    ACTIONS(5881), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5883), 1,
      anon_sym_LT,
    ACTIONS(5891), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5893), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2428), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5857), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5887), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5889), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5885), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [94432] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5895), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2429), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4877), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4879), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [94507] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5447), 1,
      anon_sym_LBRACK,
    STATE(2430), 1,
      sym_comment,
    ACTIONS(4793), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5450), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3752), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [94568] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3848), 1,
      anon_sym_EQ,
    ACTIONS(4791), 1,
      anon_sym_QMARK,
    ACTIONS(5447), 1,
      anon_sym_LBRACK,
    STATE(2431), 1,
      sym_comment,
    ACTIONS(5450), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4793), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(3752), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [94633] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5825), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5827), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5829), 1,
      anon_sym_GT_GT,
    ACTIONS(5833), 1,
      anon_sym_AMP,
    ACTIONS(5835), 1,
      anon_sym_CARET,
    ACTIONS(5837), 1,
      anon_sym_PIPE,
    ACTIONS(5841), 1,
      anon_sym_PERCENT,
    ACTIONS(5843), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5845), 1,
      anon_sym_LT,
    ACTIONS(5853), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5855), 1,
      sym__ternary_qmark,
    ACTIONS(5898), 1,
      anon_sym_RBRACK,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2432), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5821), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5823), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5831), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5839), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5849), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5851), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5847), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [94746] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2433), 1,
      sym_comment,
    ACTIONS(1974), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1978), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [94801] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5900), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2434), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5098), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5100), 15,
      sym__ternary_qmark,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [94882] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2435), 1,
      sym_comment,
    ACTIONS(5357), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5050), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [94937] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2436), 1,
      sym_comment,
    ACTIONS(5359), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5361), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [94992] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2437), 1,
      sym_comment,
    ACTIONS(5363), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5365), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [95047] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5863), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5867), 1,
      anon_sym_GT_GT,
    ACTIONS(5871), 1,
      anon_sym_AMP,
    ACTIONS(5873), 1,
      anon_sym_CARET,
    ACTIONS(5875), 1,
      anon_sym_PIPE,
    ACTIONS(5879), 1,
      anon_sym_PERCENT,
    ACTIONS(5881), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5883), 1,
      anon_sym_LT,
    ACTIONS(5891), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5893), 1,
      sym__ternary_qmark,
    ACTIONS(5903), 1,
      anon_sym_COLON,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2438), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5857), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5887), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5889), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5885), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [95160] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4793), 1,
      anon_sym_extends,
    STATE(2439), 1,
      sym_comment,
    ACTIONS(5450), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5447), 3,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(3752), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [95221] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2440), 1,
      sym_comment,
    STATE(4147), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [95288] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5905), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5907), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2441), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [95365] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5124), 1,
      anon_sym_COLON,
    ACTIONS(5863), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5867), 1,
      anon_sym_GT_GT,
    ACTIONS(5871), 1,
      anon_sym_AMP,
    ACTIONS(5873), 1,
      anon_sym_CARET,
    ACTIONS(5875), 1,
      anon_sym_PIPE,
    ACTIONS(5879), 1,
      anon_sym_PERCENT,
    ACTIONS(5881), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5883), 1,
      anon_sym_LT,
    ACTIONS(5891), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5893), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2442), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5857), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5887), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5889), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5885), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [95478] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2443), 1,
      sym_comment,
    STATE(4091), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [95545] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2444), 1,
      sym_comment,
    STATE(4141), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [95612] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4841), 1,
      anon_sym_extends,
    STATE(2445), 1,
      sym_comment,
    ACTIONS(5409), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5406), 3,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(5338), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5340), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [95673] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5135), 1,
      anon_sym_COLON,
    ACTIONS(5863), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5867), 1,
      anon_sym_GT_GT,
    ACTIONS(5871), 1,
      anon_sym_AMP,
    ACTIONS(5873), 1,
      anon_sym_CARET,
    ACTIONS(5875), 1,
      anon_sym_PIPE,
    ACTIONS(5879), 1,
      anon_sym_PERCENT,
    ACTIONS(5881), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5883), 1,
      anon_sym_LT,
    ACTIONS(5891), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5893), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2446), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5857), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5887), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5889), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5885), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [95786] = 21,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5867), 1,
      anon_sym_GT_GT,
    ACTIONS(5879), 1,
      anon_sym_PERCENT,
    ACTIONS(5881), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5883), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2447), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5857), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [95873] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2448), 1,
      sym_comment,
    STATE(4184), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [95940] = 26,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5867), 1,
      anon_sym_GT_GT,
    ACTIONS(5871), 1,
      anon_sym_AMP,
    ACTIONS(5879), 1,
      anon_sym_PERCENT,
    ACTIONS(5881), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5883), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2449), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5054), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(5857), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5887), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5889), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5885), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [96037] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5910), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2450), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5126), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5128), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [96110] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3938), 1,
      anon_sym_EQ,
    ACTIONS(5447), 1,
      anon_sym_LBRACK,
    STATE(2451), 1,
      sym_comment,
    ACTIONS(4793), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5450), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3752), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [96173] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2452), 1,
      sym_comment,
    ACTIONS(5913), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4775), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4777), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [96230] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5881), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5915), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2453), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [96307] = 27,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5867), 1,
      anon_sym_GT_GT,
    ACTIONS(5871), 1,
      anon_sym_AMP,
    ACTIONS(5873), 1,
      anon_sym_CARET,
    ACTIONS(5879), 1,
      anon_sym_PERCENT,
    ACTIONS(5881), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5883), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2454), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5054), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(5857), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5887), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5889), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5885), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [96406] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3894), 1,
      anon_sym_EQ,
    ACTIONS(3908), 1,
      anon_sym_COLON,
    ACTIONS(5447), 1,
      anon_sym_LBRACK,
    STATE(2455), 1,
      sym_comment,
    ACTIONS(5450), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4793), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(3752), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [96471] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2456), 1,
      sym_comment,
    ACTIONS(1844), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1848), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [96526] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2457), 1,
      sym_comment,
    ACTIONS(1976), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1974), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1978), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [96583] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5918), 1,
      sym__automatic_semicolon,
    STATE(2458), 1,
      sym_comment,
    ACTIONS(1832), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1830), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1834), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [96642] = 28,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5054), 1,
      anon_sym_BANG,
    ACTIONS(5867), 1,
      anon_sym_GT_GT,
    ACTIONS(5871), 1,
      anon_sym_AMP,
    ACTIONS(5873), 1,
      anon_sym_CARET,
    ACTIONS(5875), 1,
      anon_sym_PIPE,
    ACTIONS(5879), 1,
      anon_sym_PERCENT,
    ACTIONS(5881), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5883), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2459), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5857), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5887), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5889), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5885), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [96743] = 29,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5054), 1,
      anon_sym_BANG,
    ACTIONS(5863), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5867), 1,
      anon_sym_GT_GT,
    ACTIONS(5871), 1,
      anon_sym_AMP,
    ACTIONS(5873), 1,
      anon_sym_CARET,
    ACTIONS(5875), 1,
      anon_sym_PIPE,
    ACTIONS(5879), 1,
      anon_sym_PERCENT,
    ACTIONS(5881), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5883), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2460), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5857), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5887), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5889), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5885), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [96846] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2461), 1,
      sym_comment,
    ACTIONS(5351), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5353), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [96901] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2462), 1,
      sym_comment,
    ACTIONS(5810), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5812), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(3752), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [96960] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2463), 1,
      sym_comment,
    ACTIONS(1830), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1834), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [97015] = 28,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5054), 1,
      anon_sym_BANG,
    ACTIONS(5905), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5924), 1,
      anon_sym_GT_GT,
    ACTIONS(5928), 1,
      anon_sym_AMP,
    ACTIONS(5930), 1,
      anon_sym_CARET,
    ACTIONS(5932), 1,
      anon_sym_PIPE,
    ACTIONS(5936), 1,
      anon_sym_PERCENT,
    ACTIONS(5938), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2464), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5920), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5922), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5926), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5934), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5942), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5944), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5940), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [97116] = 29,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5054), 1,
      anon_sym_BANG,
    ACTIONS(5905), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5924), 1,
      anon_sym_GT_GT,
    ACTIONS(5928), 1,
      anon_sym_AMP,
    ACTIONS(5930), 1,
      anon_sym_CARET,
    ACTIONS(5932), 1,
      anon_sym_PIPE,
    ACTIONS(5936), 1,
      anon_sym_PERCENT,
    ACTIONS(5938), 1,
      anon_sym_LT,
    ACTIONS(5946), 1,
      anon_sym_AMP_AMP,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2465), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5920), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5922), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5926), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5934), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5942), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5944), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5940), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [97219] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5879), 1,
      anon_sym_PERCENT,
    ACTIONS(5881), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5915), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2466), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5857), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [97302] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4839), 1,
      anon_sym_QMARK,
    STATE(2467), 1,
      sym_comment,
    ACTIONS(4841), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(5409), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5406), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(5338), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5340), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [97365] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5137), 1,
      anon_sym_COLON,
    ACTIONS(5863), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5867), 1,
      anon_sym_GT_GT,
    ACTIONS(5871), 1,
      anon_sym_AMP,
    ACTIONS(5873), 1,
      anon_sym_CARET,
    ACTIONS(5875), 1,
      anon_sym_PIPE,
    ACTIONS(5879), 1,
      anon_sym_PERCENT,
    ACTIONS(5881), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5883), 1,
      anon_sym_LT,
    ACTIONS(5891), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5893), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2468), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5857), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5887), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5889), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5885), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [97478] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2469), 1,
      sym_comment,
    ACTIONS(5948), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5950), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(3752), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [97537] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3794), 1,
      anon_sym_EQ,
    ACTIONS(3908), 1,
      anon_sym_COLON,
    ACTIONS(4793), 1,
      anon_sym_extends,
    ACTIONS(5447), 1,
      anon_sym_LBRACK,
    STATE(2470), 1,
      sym_comment,
    ACTIONS(5450), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5952), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(3752), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [97604] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2471), 1,
      sym_comment,
    ACTIONS(5948), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5950), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(3752), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [97663] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5879), 1,
      anon_sym_PERCENT,
    ACTIONS(5881), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5915), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2472), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5857), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [97744] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5881), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5915), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2473), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 14,
      sym__ternary_qmark,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [97827] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2474), 1,
      sym_comment,
    STATE(4171), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [97894] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2475), 1,
      sym_comment,
    ACTIONS(5948), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5950), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(3752), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [97953] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2476), 1,
      sym_comment,
    ACTIONS(4789), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4787), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3752), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [98012] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5133), 1,
      anon_sym_COLON,
    ACTIONS(5863), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5867), 1,
      anon_sym_GT_GT,
    ACTIONS(5871), 1,
      anon_sym_AMP,
    ACTIONS(5873), 1,
      anon_sym_CARET,
    ACTIONS(5875), 1,
      anon_sym_PIPE,
    ACTIONS(5879), 1,
      anon_sym_PERCENT,
    ACTIONS(5881), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5883), 1,
      anon_sym_LT,
    ACTIONS(5891), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5893), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2477), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5857), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5887), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5889), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5885), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [98125] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2478), 1,
      sym_comment,
    ACTIONS(5956), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5958), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(3752), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [98184] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1938), 1,
      sym__automatic_semicolon,
    STATE(2479), 1,
      sym_comment,
    ACTIONS(1934), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1932), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1936), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [98243] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2480), 1,
      sym_comment,
    ACTIONS(3752), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [98298] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5118), 1,
      anon_sym_COLON,
    ACTIONS(5863), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5867), 1,
      anon_sym_GT_GT,
    ACTIONS(5871), 1,
      anon_sym_AMP,
    ACTIONS(5873), 1,
      anon_sym_CARET,
    ACTIONS(5875), 1,
      anon_sym_PIPE,
    ACTIONS(5879), 1,
      anon_sym_PERCENT,
    ACTIONS(5881), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5883), 1,
      anon_sym_LT,
    ACTIONS(5891), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5893), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2481), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5857), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5887), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5889), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5885), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [98411] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5863), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5867), 1,
      anon_sym_GT_GT,
    ACTIONS(5871), 1,
      anon_sym_AMP,
    ACTIONS(5873), 1,
      anon_sym_CARET,
    ACTIONS(5875), 1,
      anon_sym_PIPE,
    ACTIONS(5879), 1,
      anon_sym_PERCENT,
    ACTIONS(5881), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5883), 1,
      anon_sym_LT,
    ACTIONS(5891), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5893), 1,
      sym__ternary_qmark,
    ACTIONS(5960), 1,
      anon_sym_COLON,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2482), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5857), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5887), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5889), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5885), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [98524] = 23,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5867), 1,
      anon_sym_GT_GT,
    ACTIONS(5879), 1,
      anon_sym_PERCENT,
    ACTIONS(5881), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5883), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2483), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5857), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5885), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5054), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [98615] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5905), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5907), 1,
      anon_sym_LT,
    ACTIONS(5936), 1,
      anon_sym_PERCENT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2484), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5920), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5934), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [98698] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5962), 1,
      anon_sym_LPAREN,
    ACTIONS(5965), 1,
      anon_sym_COLON,
    ACTIONS(5967), 1,
      anon_sym_LT,
    ACTIONS(5970), 1,
      anon_sym_QMARK,
    STATE(2485), 1,
      sym_comment,
    ACTIONS(3752), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [98761] = 26,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5905), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5924), 1,
      anon_sym_GT_GT,
    ACTIONS(5928), 1,
      anon_sym_AMP,
    ACTIONS(5936), 1,
      anon_sym_PERCENT,
    ACTIONS(5938), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2486), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5054), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(5920), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5922), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5926), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5934), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5942), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5944), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5940), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [98858] = 27,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5905), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5924), 1,
      anon_sym_GT_GT,
    ACTIONS(5928), 1,
      anon_sym_AMP,
    ACTIONS(5930), 1,
      anon_sym_CARET,
    ACTIONS(5936), 1,
      anon_sym_PERCENT,
    ACTIONS(5938), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2487), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5054), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(5920), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5922), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5926), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5934), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5942), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5944), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5940), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [98957] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2488), 1,
      sym_comment,
    ACTIONS(5382), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5118), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [99012] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2489), 1,
      sym_comment,
    ACTIONS(5334), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5336), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [99067] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4916), 1,
      anon_sym_EQ,
    ACTIONS(5310), 1,
      anon_sym_of,
    ACTIONS(5972), 1,
      anon_sym_in,
    STATE(2490), 1,
      sym_comment,
    ACTIONS(4914), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4918), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [99128] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1796), 1,
      anon_sym_EQ,
    ACTIONS(5355), 1,
      anon_sym_of,
    ACTIONS(5975), 1,
      anon_sym_in,
    STATE(2491), 1,
      sym_comment,
    ACTIONS(1794), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1800), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [99189] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2492), 1,
      sym_comment,
    STATE(4132), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [99256] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5905), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5907), 1,
      anon_sym_LT,
    ACTIONS(5936), 1,
      anon_sym_PERCENT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2493), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5920), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [99337] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5191), 1,
      anon_sym_EQ,
    ACTIONS(5384), 1,
      anon_sym_of,
    ACTIONS(5978), 1,
      anon_sym_in,
    STATE(2494), 1,
      sym_comment,
    ACTIONS(5189), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5193), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [99398] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2495), 1,
      sym_comment,
    ACTIONS(1996), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1994), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1998), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [99455] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2496), 1,
      sym_comment,
    ACTIONS(1952), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1950), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1954), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [99512] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5981), 1,
      sym__automatic_semicolon,
    STATE(2497), 1,
      sym_comment,
    ACTIONS(1880), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1878), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1882), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [99571] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5983), 1,
      sym__automatic_semicolon,
    STATE(2498), 1,
      sym_comment,
    ACTIONS(1890), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1888), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1892), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [99630] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2499), 1,
      sym_comment,
    ACTIONS(1920), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1918), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1922), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [99687] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5905), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5907), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2500), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 14,
      sym__ternary_qmark,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [99770] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5116), 1,
      anon_sym_COLON,
    ACTIONS(5863), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5867), 1,
      anon_sym_GT_GT,
    ACTIONS(5871), 1,
      anon_sym_AMP,
    ACTIONS(5873), 1,
      anon_sym_CARET,
    ACTIONS(5875), 1,
      anon_sym_PIPE,
    ACTIONS(5879), 1,
      anon_sym_PERCENT,
    ACTIONS(5881), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5883), 1,
      anon_sym_LT,
    ACTIONS(5891), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5893), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2501), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5857), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5887), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5889), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5885), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [99883] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2502), 1,
      sym_comment,
    STATE(4186), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [99950] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2503), 1,
      sym_comment,
    STATE(4185), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [100017] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5863), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5867), 1,
      anon_sym_GT_GT,
    ACTIONS(5871), 1,
      anon_sym_AMP,
    ACTIONS(5873), 1,
      anon_sym_CARET,
    ACTIONS(5875), 1,
      anon_sym_PIPE,
    ACTIONS(5879), 1,
      anon_sym_PERCENT,
    ACTIONS(5881), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5883), 1,
      anon_sym_LT,
    ACTIONS(5891), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5893), 1,
      sym__ternary_qmark,
    ACTIONS(5985), 1,
      anon_sym_COLON,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2504), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5857), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5887), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5889), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5885), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [100130] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4994), 1,
      anon_sym_RBRACK,
    ACTIONS(5825), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5827), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5829), 1,
      anon_sym_GT_GT,
    ACTIONS(5833), 1,
      anon_sym_AMP,
    ACTIONS(5835), 1,
      anon_sym_CARET,
    ACTIONS(5837), 1,
      anon_sym_PIPE,
    ACTIONS(5841), 1,
      anon_sym_PERCENT,
    ACTIONS(5843), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5845), 1,
      anon_sym_LT,
    ACTIONS(5853), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5855), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2505), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5821), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5823), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5831), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5839), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5849), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5851), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5847), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [100243] = 30,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5054), 1,
      anon_sym_BANG,
    ACTIONS(5863), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5867), 1,
      anon_sym_GT_GT,
    ACTIONS(5871), 1,
      anon_sym_AMP,
    ACTIONS(5873), 1,
      anon_sym_CARET,
    ACTIONS(5875), 1,
      anon_sym_PIPE,
    ACTIONS(5879), 1,
      anon_sym_PERCENT,
    ACTIONS(5881), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5883), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2506), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5857), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5887), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5889), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5885), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 5,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [100348] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2507), 1,
      sym_comment,
    STATE(4133), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [100415] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2508), 1,
      sym_comment,
    ACTIONS(1918), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1922), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [100470] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2509), 1,
      sym_comment,
    ACTIONS(5347), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5349), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [100525] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2510), 1,
      sym_comment,
    ACTIONS(1846), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1844), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1848), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [100582] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5000), 1,
      anon_sym_RBRACK,
    ACTIONS(5825), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5827), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5829), 1,
      anon_sym_GT_GT,
    ACTIONS(5833), 1,
      anon_sym_AMP,
    ACTIONS(5835), 1,
      anon_sym_CARET,
    ACTIONS(5837), 1,
      anon_sym_PIPE,
    ACTIONS(5841), 1,
      anon_sym_PERCENT,
    ACTIONS(5843), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5845), 1,
      anon_sym_LT,
    ACTIONS(5853), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5855), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2511), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5821), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5823), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5831), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5839), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5849), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5851), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5847), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [100695] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2512), 1,
      sym_comment,
    ACTIONS(5269), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5271), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [100750] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5050), 1,
      anon_sym_COLON,
    ACTIONS(5863), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5867), 1,
      anon_sym_GT_GT,
    ACTIONS(5871), 1,
      anon_sym_AMP,
    ACTIONS(5873), 1,
      anon_sym_CARET,
    ACTIONS(5875), 1,
      anon_sym_PIPE,
    ACTIONS(5879), 1,
      anon_sym_PERCENT,
    ACTIONS(5881), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5883), 1,
      anon_sym_LT,
    ACTIONS(5891), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5893), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2513), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5857), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5887), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5889), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5885), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [100863] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2514), 1,
      sym_comment,
    ACTIONS(5412), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5414), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [100918] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3884), 1,
      anon_sym_EQ,
    ACTIONS(3965), 1,
      anon_sym_in,
    ACTIONS(3968), 1,
      anon_sym_of,
    STATE(2515), 1,
      sym_comment,
    ACTIONS(3752), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [100979] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5048), 1,
      anon_sym_COLON,
    ACTIONS(5863), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5867), 1,
      anon_sym_GT_GT,
    ACTIONS(5871), 1,
      anon_sym_AMP,
    ACTIONS(5873), 1,
      anon_sym_CARET,
    ACTIONS(5875), 1,
      anon_sym_PIPE,
    ACTIONS(5879), 1,
      anon_sym_PERCENT,
    ACTIONS(5881), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5883), 1,
      anon_sym_LT,
    ACTIONS(5891), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5893), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2516), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5857), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5887), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5889), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5885), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [101092] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2517), 1,
      sym_comment,
    ACTIONS(1878), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1882), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [101147] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5987), 1,
      anon_sym_LPAREN,
    ACTIONS(5990), 1,
      anon_sym_COLON,
    ACTIONS(5992), 1,
      anon_sym_LT,
    ACTIONS(5995), 1,
      anon_sym_QMARK,
    STATE(2518), 1,
      sym_comment,
    ACTIONS(5443), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5445), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [101210] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2519), 1,
      sym_comment,
    ACTIONS(5714), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5794), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(3752), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [101269] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5038), 1,
      anon_sym_COLON,
    ACTIONS(5863), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5867), 1,
      anon_sym_GT_GT,
    ACTIONS(5871), 1,
      anon_sym_AMP,
    ACTIONS(5873), 1,
      anon_sym_CARET,
    ACTIONS(5875), 1,
      anon_sym_PIPE,
    ACTIONS(5879), 1,
      anon_sym_PERCENT,
    ACTIONS(5881), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5883), 1,
      anon_sym_LT,
    ACTIONS(5891), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5893), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2520), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5857), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5887), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5889), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5885), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [101382] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2521), 1,
      sym_comment,
    ACTIONS(5714), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5716), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(3752), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [101441] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2522), 1,
      sym_comment,
    STATE(4126), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [101508] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4349), 1,
      anon_sym_STAR,
    ACTIONS(4353), 1,
      anon_sym_async,
    ACTIONS(5997), 1,
      anon_sym_static,
    ACTIONS(5999), 1,
      anon_sym_readonly,
    ACTIONS(6001), 1,
      anon_sym_declare,
    ACTIONS(6003), 1,
      anon_sym_abstract,
    STATE(2523), 1,
      sym_comment,
    STATE(2755), 1,
      sym_override_modifier,
    STATE(3298), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4357), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3708), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [101591] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2524), 1,
      sym_comment,
    STATE(4157), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [101658] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5060), 1,
      anon_sym_COLON,
    ACTIONS(5863), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5867), 1,
      anon_sym_GT_GT,
    ACTIONS(5871), 1,
      anon_sym_AMP,
    ACTIONS(5873), 1,
      anon_sym_CARET,
    ACTIONS(5875), 1,
      anon_sym_PIPE,
    ACTIONS(5879), 1,
      anon_sym_PERCENT,
    ACTIONS(5881), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5883), 1,
      anon_sym_LT,
    ACTIONS(5891), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5893), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2525), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5857), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5887), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5889), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5885), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [101771] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4727), 1,
      anon_sym_COLON,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5863), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5867), 1,
      anon_sym_GT_GT,
    ACTIONS(5871), 1,
      anon_sym_AMP,
    ACTIONS(5873), 1,
      anon_sym_CARET,
    ACTIONS(5875), 1,
      anon_sym_PIPE,
    ACTIONS(5879), 1,
      anon_sym_PERCENT,
    ACTIONS(5881), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5883), 1,
      anon_sym_LT,
    ACTIONS(5891), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5893), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2526), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5857), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5887), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5889), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5885), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [101884] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5000), 1,
      anon_sym_COLON,
    ACTIONS(5863), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5867), 1,
      anon_sym_GT_GT,
    ACTIONS(5871), 1,
      anon_sym_AMP,
    ACTIONS(5873), 1,
      anon_sym_CARET,
    ACTIONS(5875), 1,
      anon_sym_PIPE,
    ACTIONS(5879), 1,
      anon_sym_PERCENT,
    ACTIONS(5881), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5883), 1,
      anon_sym_LT,
    ACTIONS(5891), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5893), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2527), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5857), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5887), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5889), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5885), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [101997] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4994), 1,
      anon_sym_COLON,
    ACTIONS(5863), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5867), 1,
      anon_sym_GT_GT,
    ACTIONS(5871), 1,
      anon_sym_AMP,
    ACTIONS(5873), 1,
      anon_sym_CARET,
    ACTIONS(5875), 1,
      anon_sym_PIPE,
    ACTIONS(5879), 1,
      anon_sym_PERCENT,
    ACTIONS(5881), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5883), 1,
      anon_sym_LT,
    ACTIONS(5891), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5893), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2528), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5857), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5887), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5889), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5885), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [102110] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4992), 1,
      anon_sym_COLON,
    ACTIONS(5863), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5867), 1,
      anon_sym_GT_GT,
    ACTIONS(5871), 1,
      anon_sym_AMP,
    ACTIONS(5873), 1,
      anon_sym_CARET,
    ACTIONS(5875), 1,
      anon_sym_PIPE,
    ACTIONS(5879), 1,
      anon_sym_PERCENT,
    ACTIONS(5881), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5883), 1,
      anon_sym_LT,
    ACTIONS(5891), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5893), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2529), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5857), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5887), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5889), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5885), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [102223] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(5883), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2530), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5078), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5080), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [102290] = 23,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5905), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5924), 1,
      anon_sym_GT_GT,
    ACTIONS(5936), 1,
      anon_sym_PERCENT,
    ACTIONS(5938), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2531), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5920), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5922), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5926), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5934), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5940), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5054), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [102381] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1990), 1,
      sym__automatic_semicolon,
    STATE(2532), 1,
      sym_comment,
    ACTIONS(1986), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1984), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1988), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [102440] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1966), 1,
      sym__automatic_semicolon,
    STATE(2533), 1,
      sym_comment,
    ACTIONS(1962), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1960), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1964), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [102499] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3205), 1,
      sym__automatic_semicolon,
    STATE(2534), 1,
      sym_comment,
    ACTIONS(1866), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1864), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1868), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [102558] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2535), 1,
      sym_comment,
    ACTIONS(5291), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5293), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [102613] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2536), 1,
      sym_comment,
    ACTIONS(1910), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1908), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1912), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [102670] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6005), 1,
      sym__automatic_semicolon,
    STATE(2537), 1,
      sym_comment,
    ACTIONS(1866), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1864), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1868), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [102729] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2538), 1,
      sym_comment,
    ACTIONS(1962), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1960), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1964), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [102786] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2539), 1,
      sym_comment,
    ACTIONS(1986), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1984), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1988), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [102843] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1914), 1,
      sym__automatic_semicolon,
    STATE(2540), 1,
      sym_comment,
    ACTIONS(1910), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1908), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1912), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [102902] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5863), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5867), 1,
      anon_sym_GT_GT,
    ACTIONS(5871), 1,
      anon_sym_AMP,
    ACTIONS(5873), 1,
      anon_sym_CARET,
    ACTIONS(5875), 1,
      anon_sym_PIPE,
    ACTIONS(5879), 1,
      anon_sym_PERCENT,
    ACTIONS(5881), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5883), 1,
      anon_sym_LT,
    ACTIONS(5891), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5893), 1,
      sym__ternary_qmark,
    ACTIONS(6007), 1,
      anon_sym_COLON,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2541), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5857), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5887), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5889), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5885), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [103015] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(5938), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2542), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5078), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5080), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [103082] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2543), 1,
      sym_comment,
    STATE(4174), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [103149] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5863), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5867), 1,
      anon_sym_GT_GT,
    ACTIONS(5871), 1,
      anon_sym_AMP,
    ACTIONS(5873), 1,
      anon_sym_CARET,
    ACTIONS(5875), 1,
      anon_sym_PIPE,
    ACTIONS(5879), 1,
      anon_sym_PERCENT,
    ACTIONS(5881), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5883), 1,
      anon_sym_LT,
    ACTIONS(5891), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5893), 1,
      sym__ternary_qmark,
    ACTIONS(6009), 1,
      anon_sym_COLON,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2544), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5857), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5887), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5889), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5885), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [103262] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3904), 1,
      anon_sym_EQ,
    ACTIONS(4793), 1,
      anon_sym_extends,
    STATE(2545), 1,
      sym_comment,
    ACTIONS(5447), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5450), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3752), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [103325] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2546), 1,
      sym_comment,
    ACTIONS(5419), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5135), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [103380] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2547), 1,
      sym_comment,
    STATE(4117), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [103447] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3896), 1,
      anon_sym_EQ,
    STATE(2548), 1,
      sym_comment,
    ACTIONS(3752), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [103504] = 30,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5054), 1,
      anon_sym_BANG,
    ACTIONS(5905), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5924), 1,
      anon_sym_GT_GT,
    ACTIONS(5928), 1,
      anon_sym_AMP,
    ACTIONS(5930), 1,
      anon_sym_CARET,
    ACTIONS(5932), 1,
      anon_sym_PIPE,
    ACTIONS(5936), 1,
      anon_sym_PERCENT,
    ACTIONS(5938), 1,
      anon_sym_LT,
    ACTIONS(5946), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6011), 1,
      anon_sym_PIPE_PIPE,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2549), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5920), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5922), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5926), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5934), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5942), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5944), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5940), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 5,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [103609] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5116), 1,
      anon_sym_of,
    ACTIONS(5905), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5924), 1,
      anon_sym_GT_GT,
    ACTIONS(5928), 1,
      anon_sym_AMP,
    ACTIONS(5930), 1,
      anon_sym_CARET,
    ACTIONS(5932), 1,
      anon_sym_PIPE,
    ACTIONS(5936), 1,
      anon_sym_PERCENT,
    ACTIONS(5938), 1,
      anon_sym_LT,
    ACTIONS(5946), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6011), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6013), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6015), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2550), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5920), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5922), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5926), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5934), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5942), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5944), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5940), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [103722] = 21,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5905), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5924), 1,
      anon_sym_GT_GT,
    ACTIONS(5936), 1,
      anon_sym_PERCENT,
    ACTIONS(5938), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2551), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5920), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5926), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5934), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [103809] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5118), 1,
      anon_sym_of,
    ACTIONS(5905), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5924), 1,
      anon_sym_GT_GT,
    ACTIONS(5928), 1,
      anon_sym_AMP,
    ACTIONS(5930), 1,
      anon_sym_CARET,
    ACTIONS(5932), 1,
      anon_sym_PIPE,
    ACTIONS(5936), 1,
      anon_sym_PERCENT,
    ACTIONS(5938), 1,
      anon_sym_LT,
    ACTIONS(5946), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6011), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6013), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6015), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2552), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5920), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5922), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5926), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5934), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5942), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5944), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5940), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [103922] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1796), 1,
      anon_sym_EQ,
    ACTIONS(4908), 1,
      anon_sym_LBRACK,
    ACTIONS(5355), 1,
      anon_sym_COLON,
    STATE(2553), 1,
      sym_comment,
    ACTIONS(4911), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2398), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(1794), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1800), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [103987] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4727), 1,
      anon_sym_RBRACK,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5825), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5827), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5829), 1,
      anon_sym_GT_GT,
    ACTIONS(5833), 1,
      anon_sym_AMP,
    ACTIONS(5835), 1,
      anon_sym_CARET,
    ACTIONS(5837), 1,
      anon_sym_PIPE,
    ACTIONS(5841), 1,
      anon_sym_PERCENT,
    ACTIONS(5843), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5845), 1,
      anon_sym_LT,
    ACTIONS(5853), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5855), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2554), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5821), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5823), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5831), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5839), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5849), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5851), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5847), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [104100] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4916), 1,
      anon_sym_EQ,
    ACTIONS(4920), 1,
      anon_sym_LBRACK,
    ACTIONS(5310), 1,
      anon_sym_COLON,
    STATE(2555), 1,
      sym_comment,
    ACTIONS(4923), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4827), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(4914), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4918), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [104165] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2556), 1,
      sym_comment,
    ACTIONS(5287), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5289), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [104220] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1924), 1,
      sym__automatic_semicolon,
    STATE(2557), 1,
      sym_comment,
    ACTIONS(1920), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1918), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1922), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [104279] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5133), 1,
      anon_sym_of,
    ACTIONS(5905), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5924), 1,
      anon_sym_GT_GT,
    ACTIONS(5928), 1,
      anon_sym_AMP,
    ACTIONS(5930), 1,
      anon_sym_CARET,
    ACTIONS(5932), 1,
      anon_sym_PIPE,
    ACTIONS(5936), 1,
      anon_sym_PERCENT,
    ACTIONS(5938), 1,
      anon_sym_LT,
    ACTIONS(5946), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6011), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6013), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6015), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2558), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5920), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5922), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5926), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5934), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5942), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5944), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5940), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [104392] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2559), 1,
      sym_comment,
    ACTIONS(5421), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5423), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [104447] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3163), 1,
      sym__automatic_semicolon,
    STATE(2560), 1,
      sym_comment,
    ACTIONS(1890), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1888), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1892), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [104506] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6017), 1,
      anon_sym_LPAREN,
    ACTIONS(6019), 1,
      anon_sym_DOT,
    STATE(2561), 1,
      sym_comment,
    STATE(2856), 1,
      sym_arguments,
    ACTIONS(3651), 7,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(3649), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [104567] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3157), 1,
      sym__automatic_semicolon,
    STATE(2562), 1,
      sym_comment,
    ACTIONS(1880), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1878), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1882), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [104626] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2563), 1,
      sym_comment,
    STATE(4024), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [104693] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1956), 1,
      sym__automatic_semicolon,
    STATE(2564), 1,
      sym_comment,
    ACTIONS(1952), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1950), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1954), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [104752] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2565), 1,
      sym_comment,
    STATE(4181), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [104819] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2000), 1,
      sym__automatic_semicolon,
    STATE(2566), 1,
      sym_comment,
    ACTIONS(1996), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1994), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1998), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [104878] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2567), 1,
      sym_comment,
    ACTIONS(1932), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1936), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [104933] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2568), 1,
      sym_comment,
    ACTIONS(1864), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1868), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [104988] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3143), 1,
      sym__automatic_semicolon,
    STATE(2569), 1,
      sym_comment,
    ACTIONS(1832), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1830), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1834), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [105047] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5863), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5867), 1,
      anon_sym_GT_GT,
    ACTIONS(5871), 1,
      anon_sym_AMP,
    ACTIONS(5873), 1,
      anon_sym_CARET,
    ACTIONS(5875), 1,
      anon_sym_PIPE,
    ACTIONS(5879), 1,
      anon_sym_PERCENT,
    ACTIONS(5881), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5883), 1,
      anon_sym_LT,
    ACTIONS(5891), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5893), 1,
      sym__ternary_qmark,
    ACTIONS(6021), 1,
      anon_sym_COLON,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2570), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5857), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5887), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5889), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5885), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [105160] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2571), 1,
      sym_comment,
    ACTIONS(5279), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5281), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [105215] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2572), 1,
      sym_comment,
    STATE(4189), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [105282] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5825), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5827), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5829), 1,
      anon_sym_GT_GT,
    ACTIONS(5833), 1,
      anon_sym_AMP,
    ACTIONS(5835), 1,
      anon_sym_CARET,
    ACTIONS(5837), 1,
      anon_sym_PIPE,
    ACTIONS(5841), 1,
      anon_sym_PERCENT,
    ACTIONS(5843), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5845), 1,
      anon_sym_LT,
    ACTIONS(5853), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5855), 1,
      sym__ternary_qmark,
    ACTIONS(6023), 1,
      anon_sym_RBRACK,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2573), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5821), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5823), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5831), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5839), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5849), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5851), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5847), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [105395] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5843), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6025), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2574), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 14,
      sym__ternary_qmark,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [105478] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(5845), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2575), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5078), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5080), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [105545] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1980), 1,
      sym__automatic_semicolon,
    STATE(2576), 1,
      sym_comment,
    ACTIONS(1976), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1974), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1978), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [105604] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2577), 1,
      sym_comment,
    ACTIONS(1934), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1932), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1936), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [105661] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5060), 1,
      anon_sym_RBRACK,
    ACTIONS(5825), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5827), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5829), 1,
      anon_sym_GT_GT,
    ACTIONS(5833), 1,
      anon_sym_AMP,
    ACTIONS(5835), 1,
      anon_sym_CARET,
    ACTIONS(5837), 1,
      anon_sym_PIPE,
    ACTIONS(5841), 1,
      anon_sym_PERCENT,
    ACTIONS(5843), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5845), 1,
      anon_sym_LT,
    ACTIONS(5853), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5855), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2578), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5821), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5823), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5831), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5839), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5849), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5851), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5847), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [105774] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2579), 1,
      sym_comment,
    ACTIONS(6028), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(6030), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(3752), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [105833] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5038), 1,
      anon_sym_RBRACK,
    ACTIONS(5825), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5827), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5829), 1,
      anon_sym_GT_GT,
    ACTIONS(5833), 1,
      anon_sym_AMP,
    ACTIONS(5835), 1,
      anon_sym_CARET,
    ACTIONS(5837), 1,
      anon_sym_PIPE,
    ACTIONS(5841), 1,
      anon_sym_PERCENT,
    ACTIONS(5843), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5845), 1,
      anon_sym_LT,
    ACTIONS(5853), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5855), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2580), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5821), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5823), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5831), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5839), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5849), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5851), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5847), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [105946] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5116), 1,
      anon_sym_RBRACK,
    ACTIONS(5825), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5827), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5829), 1,
      anon_sym_GT_GT,
    ACTIONS(5833), 1,
      anon_sym_AMP,
    ACTIONS(5835), 1,
      anon_sym_CARET,
    ACTIONS(5837), 1,
      anon_sym_PIPE,
    ACTIONS(5841), 1,
      anon_sym_PERCENT,
    ACTIONS(5843), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5845), 1,
      anon_sym_LT,
    ACTIONS(5853), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5855), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2581), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5821), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5823), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5831), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5839), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5849), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5851), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5847), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [106059] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2582), 1,
      sym_comment,
    STATE(4182), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [106126] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5048), 1,
      anon_sym_RBRACK,
    ACTIONS(5825), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5827), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5829), 1,
      anon_sym_GT_GT,
    ACTIONS(5833), 1,
      anon_sym_AMP,
    ACTIONS(5835), 1,
      anon_sym_CARET,
    ACTIONS(5837), 1,
      anon_sym_PIPE,
    ACTIONS(5841), 1,
      anon_sym_PERCENT,
    ACTIONS(5843), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5845), 1,
      anon_sym_LT,
    ACTIONS(5853), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5855), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2583), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5821), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5823), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5831), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5839), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5849), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5851), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5847), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [106239] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2584), 1,
      sym_comment,
    ACTIONS(5463), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5465), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [106294] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5135), 1,
      anon_sym_of,
    ACTIONS(5905), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5924), 1,
      anon_sym_GT_GT,
    ACTIONS(5928), 1,
      anon_sym_AMP,
    ACTIONS(5930), 1,
      anon_sym_CARET,
    ACTIONS(5932), 1,
      anon_sym_PIPE,
    ACTIONS(5936), 1,
      anon_sym_PERCENT,
    ACTIONS(5938), 1,
      anon_sym_LT,
    ACTIONS(5946), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6011), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6013), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6015), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2585), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5920), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5922), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5926), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5934), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5942), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5944), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5940), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [106407] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2586), 1,
      sym_comment,
    STATE(4167), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [106474] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2587), 1,
      sym_comment,
    ACTIONS(1950), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1954), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [106529] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6032), 1,
      anon_sym_catch,
    ACTIONS(6034), 1,
      anon_sym_finally,
    STATE(2588), 1,
      sym_comment,
    STATE(2793), 1,
      sym_catch_clause,
    STATE(2917), 1,
      sym_finally_clause,
    ACTIONS(2532), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2530), 35,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [106592] = 25,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5867), 1,
      anon_sym_GT_GT,
    ACTIONS(5879), 1,
      anon_sym_PERCENT,
    ACTIONS(5881), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5883), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2589), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5857), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5887), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5889), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5885), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [106687] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2590), 1,
      sym_comment,
    ACTIONS(1994), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1998), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [106742] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2591), 1,
      sym_comment,
    ACTIONS(5459), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5461), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [106797] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5841), 1,
      anon_sym_PERCENT,
    ACTIONS(5843), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6025), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2592), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5821), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [106878] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2593), 1,
      sym_comment,
    ACTIONS(5398), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5400), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [106933] = 27,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5829), 1,
      anon_sym_GT_GT,
    ACTIONS(5833), 1,
      anon_sym_AMP,
    ACTIONS(5835), 1,
      anon_sym_CARET,
    ACTIONS(5841), 1,
      anon_sym_PERCENT,
    ACTIONS(5843), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5845), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2594), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5054), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(5821), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5823), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5831), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5839), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5849), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5851), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5847), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [107032] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5133), 1,
      anon_sym_RBRACK,
    ACTIONS(5825), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5827), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5829), 1,
      anon_sym_GT_GT,
    ACTIONS(5833), 1,
      anon_sym_AMP,
    ACTIONS(5835), 1,
      anon_sym_CARET,
    ACTIONS(5837), 1,
      anon_sym_PIPE,
    ACTIONS(5841), 1,
      anon_sym_PERCENT,
    ACTIONS(5843), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5845), 1,
      anon_sym_LT,
    ACTIONS(5853), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5855), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2595), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5821), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5823), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5831), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5839), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5849), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5851), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5847), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [107145] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1796), 1,
      anon_sym_EQ,
    ACTIONS(4908), 1,
      anon_sym_LBRACK,
    STATE(2596), 1,
      sym_comment,
    ACTIONS(2398), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4911), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1794), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1800), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [107208] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4916), 1,
      anon_sym_EQ,
    ACTIONS(4920), 1,
      anon_sym_LBRACK,
    STATE(2597), 1,
      sym_comment,
    ACTIONS(4827), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4923), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4914), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4918), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [107271] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5137), 1,
      anon_sym_of,
    ACTIONS(5905), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5924), 1,
      anon_sym_GT_GT,
    ACTIONS(5928), 1,
      anon_sym_AMP,
    ACTIONS(5930), 1,
      anon_sym_CARET,
    ACTIONS(5932), 1,
      anon_sym_PIPE,
    ACTIONS(5936), 1,
      anon_sym_PERCENT,
    ACTIONS(5938), 1,
      anon_sym_LT,
    ACTIONS(5946), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6011), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6013), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6015), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2598), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5920), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5922), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5926), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5934), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5942), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5944), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5940), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [107384] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2599), 1,
      sym_comment,
    STATE(4130), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [107451] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2600), 1,
      sym_comment,
    ACTIONS(5283), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5285), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [107506] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2601), 1,
      sym_comment,
    ACTIONS(1888), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1892), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [107561] = 26,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5829), 1,
      anon_sym_GT_GT,
    ACTIONS(5833), 1,
      anon_sym_AMP,
    ACTIONS(5841), 1,
      anon_sym_PERCENT,
    ACTIONS(5843), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5845), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2602), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5054), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(5821), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5823), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5831), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5839), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5849), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5851), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5847), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [107658] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6036), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2603), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5126), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5128), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [107731] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5124), 1,
      anon_sym_RBRACK,
    ACTIONS(5825), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5827), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5829), 1,
      anon_sym_GT_GT,
    ACTIONS(5833), 1,
      anon_sym_AMP,
    ACTIONS(5835), 1,
      anon_sym_CARET,
    ACTIONS(5837), 1,
      anon_sym_PIPE,
    ACTIONS(5841), 1,
      anon_sym_PERCENT,
    ACTIONS(5843), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5845), 1,
      anon_sym_LT,
    ACTIONS(5853), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5855), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2604), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5821), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5823), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5831), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5839), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5849), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5851), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5847), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [107844] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(6039), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2605), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5098), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5100), 15,
      sym__ternary_qmark,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [107925] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2606), 1,
      sym_comment,
    ACTIONS(5375), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5377), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [107980] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2607), 1,
      sym_comment,
    ACTIONS(5436), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5438), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [108035] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2608), 1,
      sym_comment,
    ACTIONS(6042), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(6044), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(3752), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [108094] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5312), 1,
      anon_sym_LBRACK,
    STATE(2609), 1,
      sym_comment,
    ACTIONS(4667), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5315), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3752), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [108155] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3884), 1,
      anon_sym_EQ,
    STATE(2610), 1,
      sym_comment,
    ACTIONS(3752), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [108212] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2611), 1,
      sym_comment,
    ACTIONS(5371), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5373), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [108267] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2612), 1,
      sym_comment,
    ACTIONS(6046), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(6048), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(3752), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [108326] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6050), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2613), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5126), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5128), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [108399] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5124), 1,
      anon_sym_of,
    ACTIONS(5905), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5924), 1,
      anon_sym_GT_GT,
    ACTIONS(5928), 1,
      anon_sym_AMP,
    ACTIONS(5930), 1,
      anon_sym_CARET,
    ACTIONS(5932), 1,
      anon_sym_PIPE,
    ACTIONS(5936), 1,
      anon_sym_PERCENT,
    ACTIONS(5938), 1,
      anon_sym_LT,
    ACTIONS(5946), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6011), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6013), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6015), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2614), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5920), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5922), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5926), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5934), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5942), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5944), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5940), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [108512] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4992), 1,
      anon_sym_of,
    ACTIONS(5905), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5924), 1,
      anon_sym_GT_GT,
    ACTIONS(5928), 1,
      anon_sym_AMP,
    ACTIONS(5930), 1,
      anon_sym_CARET,
    ACTIONS(5932), 1,
      anon_sym_PIPE,
    ACTIONS(5936), 1,
      anon_sym_PERCENT,
    ACTIONS(5938), 1,
      anon_sym_LT,
    ACTIONS(5946), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6011), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6013), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6015), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2615), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5920), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5922), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5926), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5934), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5942), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5944), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5940), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [108625] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2616), 1,
      sym_comment,
    ACTIONS(6053), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(6055), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(3752), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [108684] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5863), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5867), 1,
      anon_sym_GT_GT,
    ACTIONS(5871), 1,
      anon_sym_AMP,
    ACTIONS(5873), 1,
      anon_sym_CARET,
    ACTIONS(5875), 1,
      anon_sym_PIPE,
    ACTIONS(5879), 1,
      anon_sym_PERCENT,
    ACTIONS(5881), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5883), 1,
      anon_sym_LT,
    ACTIONS(5891), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5893), 1,
      sym__ternary_qmark,
    ACTIONS(6057), 1,
      anon_sym_COLON,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2617), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5857), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5887), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5889), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5885), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [108797] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6059), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2618), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4877), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4879), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [108872] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6062), 1,
      sym_regex_flags,
    STATE(2619), 1,
      sym_comment,
    ACTIONS(5781), 17,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_satisfies,
    ACTIONS(5783), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [108929] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2620), 1,
      sym_comment,
    ACTIONS(6053), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(6055), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(3752), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [108988] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2621), 1,
      sym_comment,
    ACTIONS(6053), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(6055), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(3752), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [109047] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2622), 1,
      sym_comment,
    STATE(4103), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [109114] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(4994), 1,
      anon_sym_of,
    ACTIONS(5905), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5924), 1,
      anon_sym_GT_GT,
    ACTIONS(5928), 1,
      anon_sym_AMP,
    ACTIONS(5930), 1,
      anon_sym_CARET,
    ACTIONS(5932), 1,
      anon_sym_PIPE,
    ACTIONS(5936), 1,
      anon_sym_PERCENT,
    ACTIONS(5938), 1,
      anon_sym_LT,
    ACTIONS(5946), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6011), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6013), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6015), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2623), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5920), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5922), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5926), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5934), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5942), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5944), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5940), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [109227] = 23,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5829), 1,
      anon_sym_GT_GT,
    ACTIONS(5841), 1,
      anon_sym_PERCENT,
    ACTIONS(5843), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5845), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2624), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5821), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5823), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5831), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5839), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5847), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5054), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [109318] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2625), 1,
      sym_comment,
    ACTIONS(4775), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4777), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [109373] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5050), 1,
      anon_sym_RBRACK,
    ACTIONS(5825), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5827), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5829), 1,
      anon_sym_GT_GT,
    ACTIONS(5833), 1,
      anon_sym_AMP,
    ACTIONS(5835), 1,
      anon_sym_CARET,
    ACTIONS(5837), 1,
      anon_sym_PIPE,
    ACTIONS(5841), 1,
      anon_sym_PERCENT,
    ACTIONS(5843), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5845), 1,
      anon_sym_LT,
    ACTIONS(5853), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5855), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2626), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5821), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5823), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5831), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5839), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5849), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5851), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5847), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [109486] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2627), 1,
      sym_comment,
    ACTIONS(5432), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5434), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [109541] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2628), 1,
      sym_comment,
    ACTIONS(5277), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4727), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [109596] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2629), 1,
      sym_comment,
    ACTIONS(5195), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5197), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [109651] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5137), 1,
      anon_sym_RBRACK,
    ACTIONS(5825), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5827), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5829), 1,
      anon_sym_GT_GT,
    ACTIONS(5833), 1,
      anon_sym_AMP,
    ACTIONS(5835), 1,
      anon_sym_CARET,
    ACTIONS(5837), 1,
      anon_sym_PIPE,
    ACTIONS(5841), 1,
      anon_sym_PERCENT,
    ACTIONS(5843), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5845), 1,
      anon_sym_LT,
    ACTIONS(5853), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5855), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2630), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5821), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5823), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5831), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5839), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5849), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5851), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5847), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [109764] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2631), 1,
      sym_comment,
    STATE(4128), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [109831] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2632), 1,
      sym_comment,
    ACTIONS(5318), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5320), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [109886] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5135), 1,
      anon_sym_RBRACK,
    ACTIONS(5825), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5827), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5829), 1,
      anon_sym_GT_GT,
    ACTIONS(5833), 1,
      anon_sym_AMP,
    ACTIONS(5835), 1,
      anon_sym_CARET,
    ACTIONS(5837), 1,
      anon_sym_PIPE,
    ACTIONS(5841), 1,
      anon_sym_PERCENT,
    ACTIONS(5843), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5845), 1,
      anon_sym_LT,
    ACTIONS(5853), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5855), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2633), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5821), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5823), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5831), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5839), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5849), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5851), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5847), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [109999] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5297), 1,
      anon_sym_of,
    ACTIONS(5905), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5922), 1,
      anon_sym_GT,
    ACTIONS(5924), 1,
      anon_sym_GT_GT,
    ACTIONS(5928), 1,
      anon_sym_AMP,
    ACTIONS(5930), 1,
      anon_sym_CARET,
    ACTIONS(5932), 1,
      anon_sym_PIPE,
    ACTIONS(5936), 1,
      anon_sym_PERCENT,
    ACTIONS(5938), 1,
      anon_sym_LT,
    ACTIONS(5946), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6011), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6013), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6015), 1,
      sym__ternary_qmark,
    ACTIONS(6064), 1,
      anon_sym_in,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2634), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5920), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5926), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5934), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5942), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5944), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5940), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [110114] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2635), 1,
      sym_comment,
    ACTIONS(5275), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5060), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [110169] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(6067), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2636), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5098), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5100), 15,
      sym__ternary_qmark,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [110250] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2637), 1,
      sym_comment,
    ACTIONS(5367), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5369), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [110305] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2638), 1,
      sym_comment,
    ACTIONS(4775), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4777), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [110360] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2639), 1,
      sym_comment,
    ACTIONS(5338), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5340), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [110415] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5000), 1,
      anon_sym_of,
    ACTIONS(5905), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5924), 1,
      anon_sym_GT_GT,
    ACTIONS(5928), 1,
      anon_sym_AMP,
    ACTIONS(5930), 1,
      anon_sym_CARET,
    ACTIONS(5932), 1,
      anon_sym_PIPE,
    ACTIONS(5936), 1,
      anon_sym_PERCENT,
    ACTIONS(5938), 1,
      anon_sym_LT,
    ACTIONS(5946), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6011), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6013), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6015), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2640), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5920), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5922), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5926), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5934), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5942), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5944), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5940), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [110528] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2641), 1,
      sym_comment,
    ACTIONS(5425), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5427), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [110583] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_QMARK,
    STATE(2642), 1,
      sym_comment,
    ACTIONS(4793), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(5450), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5447), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(3752), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [110646] = 21,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5829), 1,
      anon_sym_GT_GT,
    ACTIONS(5841), 1,
      anon_sym_PERCENT,
    ACTIONS(5843), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5845), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2643), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5821), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5831), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5839), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [110733] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5843), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6025), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2644), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [110810] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2645), 1,
      sym_comment,
    ACTIONS(1908), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1912), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [110865] = 25,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5905), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5924), 1,
      anon_sym_GT_GT,
    ACTIONS(5936), 1,
      anon_sym_PERCENT,
    ACTIONS(5938), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2646), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5920), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5922), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5926), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5934), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5942), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5944), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5940), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [110960] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5863), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5867), 1,
      anon_sym_GT_GT,
    ACTIONS(5871), 1,
      anon_sym_AMP,
    ACTIONS(5873), 1,
      anon_sym_CARET,
    ACTIONS(5875), 1,
      anon_sym_PIPE,
    ACTIONS(5879), 1,
      anon_sym_PERCENT,
    ACTIONS(5881), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5883), 1,
      anon_sym_LT,
    ACTIONS(5891), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5893), 1,
      sym__ternary_qmark,
    ACTIONS(6070), 1,
      anon_sym_COLON,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2647), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5857), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5887), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5889), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5885), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [111073] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2648), 1,
      sym_comment,
    ACTIONS(5443), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5445), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [111128] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2649), 1,
      sym_comment,
    ACTIONS(5259), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5038), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [111183] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2650), 1,
      sym_comment,
    ACTIONS(5255), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5257), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [111238] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    STATE(2651), 1,
      sym_comment,
    STATE(2053), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6072), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4693), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4695), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [111301] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5406), 1,
      anon_sym_LBRACK,
    STATE(2652), 1,
      sym_comment,
    ACTIONS(4841), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5409), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5338), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5340), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [111362] = 28,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5054), 1,
      anon_sym_BANG,
    ACTIONS(5829), 1,
      anon_sym_GT_GT,
    ACTIONS(5833), 1,
      anon_sym_AMP,
    ACTIONS(5835), 1,
      anon_sym_CARET,
    ACTIONS(5837), 1,
      anon_sym_PIPE,
    ACTIONS(5841), 1,
      anon_sym_PERCENT,
    ACTIONS(5843), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5845), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2653), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5821), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5823), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5831), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5839), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5849), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5851), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5847), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [111463] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2654), 1,
      sym_comment,
    ACTIONS(1846), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1844), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1848), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [111520] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6074), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2655), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4877), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4879), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [111595] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2656), 1,
      sym_comment,
    ACTIONS(1960), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1964), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [111650] = 29,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5054), 1,
      anon_sym_BANG,
    ACTIONS(5825), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5829), 1,
      anon_sym_GT_GT,
    ACTIONS(5833), 1,
      anon_sym_AMP,
    ACTIONS(5835), 1,
      anon_sym_CARET,
    ACTIONS(5837), 1,
      anon_sym_PIPE,
    ACTIONS(5841), 1,
      anon_sym_PERCENT,
    ACTIONS(5843), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5845), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2657), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5821), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5823), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5831), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5839), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5849), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5851), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5847), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [111753] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2658), 1,
      sym_comment,
    STATE(4124), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [111820] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2659), 1,
      sym_comment,
    ACTIONS(5322), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5324), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [111875] = 30,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5054), 1,
      anon_sym_BANG,
    ACTIONS(5825), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5827), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5829), 1,
      anon_sym_GT_GT,
    ACTIONS(5833), 1,
      anon_sym_AMP,
    ACTIONS(5835), 1,
      anon_sym_CARET,
    ACTIONS(5837), 1,
      anon_sym_PIPE,
    ACTIONS(5841), 1,
      anon_sym_PERCENT,
    ACTIONS(5843), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5845), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2660), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5821), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5823), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5831), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5839), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5849), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5851), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5847), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 5,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [111980] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5841), 1,
      anon_sym_PERCENT,
    ACTIONS(5843), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6025), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2661), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5821), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5839), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [112063] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2662), 1,
      sym_comment,
    ACTIONS(1984), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1988), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [112118] = 25,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5829), 1,
      anon_sym_GT_GT,
    ACTIONS(5841), 1,
      anon_sym_PERCENT,
    ACTIONS(5843), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5845), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2663), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5821), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5823), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5831), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5839), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5849), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5851), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5847), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [112213] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2664), 1,
      sym_comment,
    STATE(4041), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [112280] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2665), 1,
      sym_comment,
    ACTIONS(5326), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5328), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [112335] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2666), 1,
      sym_comment,
    ACTIONS(5330), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5332), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [112390] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2667), 1,
      sym_comment,
    STATE(4159), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [112457] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4400), 1,
      anon_sym_STAR,
    ACTIONS(4402), 1,
      anon_sym_async,
    ACTIONS(6077), 1,
      anon_sym_static,
    ACTIONS(6079), 1,
      anon_sym_readonly,
    ACTIONS(6081), 1,
      anon_sym_declare,
    ACTIONS(6083), 1,
      anon_sym_abstract,
    STATE(2668), 1,
      sym_comment,
    STATE(2789), 1,
      sym_override_modifier,
    STATE(3303), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4404), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3708), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [112540] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5050), 1,
      anon_sym_of,
    ACTIONS(5905), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5924), 1,
      anon_sym_GT_GT,
    ACTIONS(5928), 1,
      anon_sym_AMP,
    ACTIONS(5930), 1,
      anon_sym_CARET,
    ACTIONS(5932), 1,
      anon_sym_PIPE,
    ACTIONS(5936), 1,
      anon_sym_PERCENT,
    ACTIONS(5938), 1,
      anon_sym_LT,
    ACTIONS(5946), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6011), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6013), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6015), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2669), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5920), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5922), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5926), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5934), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5942), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5944), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5940), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [112653] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4727), 1,
      anon_sym_of,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5905), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5924), 1,
      anon_sym_GT_GT,
    ACTIONS(5928), 1,
      anon_sym_AMP,
    ACTIONS(5930), 1,
      anon_sym_CARET,
    ACTIONS(5932), 1,
      anon_sym_PIPE,
    ACTIONS(5936), 1,
      anon_sym_PERCENT,
    ACTIONS(5938), 1,
      anon_sym_LT,
    ACTIONS(5946), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6011), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6013), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6015), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2670), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5920), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5922), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5926), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5934), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5942), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5944), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5940), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [112766] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6062), 1,
      sym_regex_flags,
    STATE(2671), 1,
      sym_comment,
    ACTIONS(5781), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_satisfies,
    ACTIONS(5783), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [112823] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5060), 1,
      anon_sym_of,
    ACTIONS(5905), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5924), 1,
      anon_sym_GT_GT,
    ACTIONS(5928), 1,
      anon_sym_AMP,
    ACTIONS(5930), 1,
      anon_sym_CARET,
    ACTIONS(5932), 1,
      anon_sym_PIPE,
    ACTIONS(5936), 1,
      anon_sym_PERCENT,
    ACTIONS(5938), 1,
      anon_sym_LT,
    ACTIONS(5946), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6011), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6013), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6015), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2672), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5920), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5922), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5926), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5934), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5942), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5944), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5940), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [112936] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2673), 1,
      sym_comment,
    STATE(4131), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4322), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [113003] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5038), 1,
      anon_sym_of,
    ACTIONS(5905), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5924), 1,
      anon_sym_GT_GT,
    ACTIONS(5928), 1,
      anon_sym_AMP,
    ACTIONS(5930), 1,
      anon_sym_CARET,
    ACTIONS(5932), 1,
      anon_sym_PIPE,
    ACTIONS(5936), 1,
      anon_sym_PERCENT,
    ACTIONS(5938), 1,
      anon_sym_LT,
    ACTIONS(5946), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6011), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6013), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6015), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2674), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5920), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5922), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5926), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5934), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5942), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5944), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5940), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [113116] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5048), 1,
      anon_sym_of,
    ACTIONS(5905), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5924), 1,
      anon_sym_GT_GT,
    ACTIONS(5928), 1,
      anon_sym_AMP,
    ACTIONS(5930), 1,
      anon_sym_CARET,
    ACTIONS(5932), 1,
      anon_sym_PIPE,
    ACTIONS(5936), 1,
      anon_sym_PERCENT,
    ACTIONS(5938), 1,
      anon_sym_LT,
    ACTIONS(5946), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6011), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6013), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6015), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2675), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5920), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5922), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5926), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5934), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5942), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5944), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5940), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [113229] = 28,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5054), 1,
      anon_sym_BANG,
    ACTIONS(6089), 1,
      anon_sym_GT_GT,
    ACTIONS(6093), 1,
      anon_sym_AMP,
    ACTIONS(6095), 1,
      anon_sym_CARET,
    ACTIONS(6097), 1,
      anon_sym_PIPE,
    ACTIONS(6101), 1,
      anon_sym_PERCENT,
    ACTIONS(6103), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6105), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2676), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6085), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6087), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6091), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6099), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6109), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6111), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6107), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [113329] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4679), 1,
      anon_sym_readonly,
    ACTIONS(6113), 1,
      anon_sym_STAR,
    STATE(2677), 1,
      sym_comment,
    STATE(2756), 1,
      sym_override_modifier,
    STATE(3311), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6115), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3708), 26,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [113403] = 29,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5054), 1,
      anon_sym_BANG,
    ACTIONS(6089), 1,
      anon_sym_GT_GT,
    ACTIONS(6093), 1,
      anon_sym_AMP,
    ACTIONS(6095), 1,
      anon_sym_CARET,
    ACTIONS(6097), 1,
      anon_sym_PIPE,
    ACTIONS(6101), 1,
      anon_sym_PERCENT,
    ACTIONS(6103), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6105), 1,
      anon_sym_LT,
    ACTIONS(6117), 1,
      anon_sym_AMP_AMP,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2678), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6085), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6087), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6091), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6099), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6109), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6111), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6107), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 5,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [113505] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4444), 1,
      anon_sym_static,
    ACTIONS(4446), 1,
      anon_sym_readonly,
    ACTIONS(4448), 1,
      anon_sym_abstract,
    STATE(2679), 1,
      sym_comment,
    STATE(2823), 1,
      sym_override_modifier,
    STATE(3715), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3708), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [113579] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(5143), 1,
      anon_sym_BANG,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5149), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(6089), 1,
      anon_sym_GT_GT,
    ACTIONS(6093), 1,
      anon_sym_AMP,
    ACTIONS(6095), 1,
      anon_sym_CARET,
    ACTIONS(6097), 1,
      anon_sym_PIPE,
    ACTIONS(6101), 1,
      anon_sym_PERCENT,
    ACTIONS(6103), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6105), 1,
      anon_sym_LT,
    ACTIONS(6117), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6119), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6121), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6123), 1,
      sym__ternary_qmark,
    STATE(2680), 1,
      sym_comment,
    STATE(2812), 1,
      sym_type_arguments,
    STATE(5319), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6085), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6087), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6091), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6099), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6109), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6111), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6107), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [113689] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6101), 1,
      anon_sym_PERCENT,
    ACTIONS(6103), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6125), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2681), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6085), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6099), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [113771] = 25,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6089), 1,
      anon_sym_GT_GT,
    ACTIONS(6101), 1,
      anon_sym_PERCENT,
    ACTIONS(6103), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6105), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2682), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6085), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6087), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6091), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6099), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6109), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6111), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(6107), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [113865] = 26,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6089), 1,
      anon_sym_GT_GT,
    ACTIONS(6093), 1,
      anon_sym_AMP,
    ACTIONS(6101), 1,
      anon_sym_PERCENT,
    ACTIONS(6103), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6105), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2683), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5054), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(6085), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6087), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6091), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6099), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6109), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6111), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6107), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [113961] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(6089), 1,
      anon_sym_GT_GT,
    ACTIONS(6093), 1,
      anon_sym_AMP,
    ACTIONS(6095), 1,
      anon_sym_CARET,
    ACTIONS(6097), 1,
      anon_sym_PIPE,
    ACTIONS(6101), 1,
      anon_sym_PERCENT,
    ACTIONS(6103), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6105), 1,
      anon_sym_LT,
    ACTIONS(6117), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6119), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6121), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6123), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2684), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6085), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6087), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6091), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6099), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6109), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6111), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6107), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [114071] = 17,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4476), 1,
      anon_sym_STAR,
    ACTIONS(4478), 1,
      anon_sym_async,
    ACTIONS(4480), 1,
      anon_sym_readonly,
    ACTIONS(6128), 1,
      anon_sym_static,
    STATE(2685), 1,
      sym_comment,
    STATE(2773), 1,
      sym_override_modifier,
    STATE(3371), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4482), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3708), 24,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [114149] = 27,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6089), 1,
      anon_sym_GT_GT,
    ACTIONS(6093), 1,
      anon_sym_AMP,
    ACTIONS(6095), 1,
      anon_sym_CARET,
    ACTIONS(6101), 1,
      anon_sym_PERCENT,
    ACTIONS(6103), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6105), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2686), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5054), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(6085), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6087), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6091), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6099), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6109), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6111), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6107), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [114247] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4916), 1,
      anon_sym_EQ,
    ACTIONS(5310), 1,
      anon_sym_COMMA,
    ACTIONS(5628), 1,
      anon_sym_RBRACK,
    STATE(2687), 1,
      sym_comment,
    ACTIONS(4914), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4918), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [114307] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(6130), 1,
      anon_sym_RBRACE,
    STATE(2688), 1,
      sym_comment,
    STATE(4791), 1,
      sym__property_name,
    STATE(5933), 1,
      sym_enum_assignment,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [114375] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(6089), 1,
      anon_sym_GT_GT,
    ACTIONS(6093), 1,
      anon_sym_AMP,
    ACTIONS(6095), 1,
      anon_sym_CARET,
    ACTIONS(6097), 1,
      anon_sym_PIPE,
    ACTIONS(6101), 1,
      anon_sym_PERCENT,
    ACTIONS(6103), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6105), 1,
      anon_sym_LT,
    ACTIONS(6117), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6119), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6121), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6123), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2689), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6085), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6087), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6091), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6099), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6109), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6111), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6107), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [114485] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6101), 1,
      anon_sym_PERCENT,
    ACTIONS(6103), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6125), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2690), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6085), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [114565] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3794), 1,
      anon_sym_EQ,
    STATE(2691), 1,
      sym_comment,
    ACTIONS(4050), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(3752), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [114623] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6103), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6125), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2692), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [114699] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1796), 1,
      anon_sym_EQ,
    ACTIONS(5355), 1,
      anon_sym_COMMA,
    ACTIONS(5659), 1,
      anon_sym_RBRACK,
    STATE(2693), 1,
      sym_comment,
    ACTIONS(1794), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1800), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [114759] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6132), 1,
      anon_sym_AT,
    STATE(2850), 1,
      sym_decorator,
    STATE(2694), 2,
      sym_comment,
      aux_sym_export_statement_repeat1,
    ACTIONS(3642), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3640), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [114817] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5191), 1,
      anon_sym_EQ,
    ACTIONS(5384), 1,
      anon_sym_COMMA,
    ACTIONS(5557), 1,
      anon_sym_RBRACK,
    STATE(2695), 1,
      sym_comment,
    ACTIONS(5189), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5193), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [114877] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(6089), 1,
      anon_sym_GT_GT,
    ACTIONS(6093), 1,
      anon_sym_AMP,
    ACTIONS(6095), 1,
      anon_sym_CARET,
    ACTIONS(6097), 1,
      anon_sym_PIPE,
    ACTIONS(6101), 1,
      anon_sym_PERCENT,
    ACTIONS(6103), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6105), 1,
      anon_sym_LT,
    ACTIONS(6117), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6119), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6121), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6123), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2696), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6085), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6087), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6091), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6099), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6109), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6111), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6107), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [114987] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(6105), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2697), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5078), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5080), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [115053] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(6135), 1,
      anon_sym_RBRACE,
    STATE(2698), 1,
      sym_comment,
    STATE(4515), 1,
      sym__property_name,
    STATE(4895), 1,
      sym_enum_assignment,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [115121] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(6137), 1,
      anon_sym_RBRACE,
    STATE(2699), 1,
      sym_comment,
    STATE(4791), 1,
      sym__property_name,
    STATE(5933), 1,
      sym_enum_assignment,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [115189] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(6139), 1,
      anon_sym_RBRACE,
    STATE(2700), 1,
      sym_comment,
    STATE(4377), 1,
      sym__property_name,
    STATE(5106), 1,
      sym_enum_assignment,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [115257] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3904), 1,
      anon_sym_EQ,
    STATE(2701), 1,
      sym_comment,
    ACTIONS(3752), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 26,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [115313] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3945), 1,
      anon_sym_EQ,
    ACTIONS(5447), 1,
      anon_sym_LBRACK,
    STATE(2702), 1,
      sym_comment,
    ACTIONS(4793), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5450), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3752), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [115375] = 30,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5054), 1,
      anon_sym_BANG,
    ACTIONS(6089), 1,
      anon_sym_GT_GT,
    ACTIONS(6093), 1,
      anon_sym_AMP,
    ACTIONS(6095), 1,
      anon_sym_CARET,
    ACTIONS(6097), 1,
      anon_sym_PIPE,
    ACTIONS(6101), 1,
      anon_sym_PERCENT,
    ACTIONS(6103), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6105), 1,
      anon_sym_LT,
    ACTIONS(6117), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6119), 1,
      anon_sym_PIPE_PIPE,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2703), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6085), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6087), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6091), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6099), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6109), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6111), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6107), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5052), 4,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [115479] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4827), 1,
      anon_sym_extends,
    ACTIONS(4916), 1,
      anon_sym_EQ,
    STATE(2704), 1,
      sym_comment,
    ACTIONS(4920), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(4923), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4914), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4918), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [115541] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4665), 1,
      anon_sym_QMARK,
    ACTIONS(4667), 1,
      anon_sym_extends,
    STATE(2705), 1,
      sym_comment,
    ACTIONS(5315), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5312), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(3752), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [115603] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3794), 1,
      anon_sym_EQ,
    ACTIONS(4793), 1,
      anon_sym_extends,
    STATE(2706), 1,
      sym_comment,
    ACTIONS(5447), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(5450), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3752), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [115665] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1796), 1,
      anon_sym_EQ,
    ACTIONS(2398), 1,
      anon_sym_extends,
    STATE(2707), 1,
      sym_comment,
    ACTIONS(4908), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(4911), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1794), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1800), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [115727] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5191), 1,
      anon_sym_EQ,
    ACTIONS(5384), 1,
      anon_sym_COLON,
    STATE(2708), 1,
      sym_comment,
    ACTIONS(5557), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(5189), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5193), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [115787] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(6089), 1,
      anon_sym_GT_GT,
    ACTIONS(6093), 1,
      anon_sym_AMP,
    ACTIONS(6095), 1,
      anon_sym_CARET,
    ACTIONS(6097), 1,
      anon_sym_PIPE,
    ACTIONS(6101), 1,
      anon_sym_PERCENT,
    ACTIONS(6103), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6105), 1,
      anon_sym_LT,
    ACTIONS(6117), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6119), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6121), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6123), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2709), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6085), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6087), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6091), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6099), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6109), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6111), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6107), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [115897] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(6089), 1,
      anon_sym_GT_GT,
    ACTIONS(6093), 1,
      anon_sym_AMP,
    ACTIONS(6095), 1,
      anon_sym_CARET,
    ACTIONS(6097), 1,
      anon_sym_PIPE,
    ACTIONS(6101), 1,
      anon_sym_PERCENT,
    ACTIONS(6103), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6105), 1,
      anon_sym_LT,
    ACTIONS(6117), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6119), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6121), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6123), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2710), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6085), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6087), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6091), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6099), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6109), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6111), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6107), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [116007] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(6141), 1,
      anon_sym_RBRACE,
    STATE(2711), 1,
      sym_comment,
    STATE(4791), 1,
      sym__property_name,
    STATE(5933), 1,
      sym_enum_assignment,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [116075] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_import,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(17), 1,
      anon_sym_AT,
    ACTIONS(19), 1,
      anon_sym_pragma,
    STATE(2712), 1,
      sym_comment,
    STATE(2726), 1,
      aux_sym_program_repeat1,
    STATE(3084), 1,
      aux_sym_ui_annotated_object_repeat1,
    STATE(3086), 1,
      sym_ui_annotation,
    STATE(5505), 1,
      sym_ui_nested_identifier,
    STATE(3106), 2,
      sym_ui_pragma,
      sym_ui_import,
    STATE(6354), 2,
      sym_ui_object_definition,
      sym_ui_annotated_object,
    ACTIONS(11), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [116147] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(6089), 1,
      anon_sym_GT_GT,
    ACTIONS(6093), 1,
      anon_sym_AMP,
    ACTIONS(6095), 1,
      anon_sym_CARET,
    ACTIONS(6097), 1,
      anon_sym_PIPE,
    ACTIONS(6101), 1,
      anon_sym_PERCENT,
    ACTIONS(6103), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6105), 1,
      anon_sym_LT,
    ACTIONS(6117), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6119), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6121), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6123), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2713), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6085), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6087), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6091), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6099), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6109), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6111), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6107), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [116257] = 21,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6089), 1,
      anon_sym_GT_GT,
    ACTIONS(6101), 1,
      anon_sym_PERCENT,
    ACTIONS(6103), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6105), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2714), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6085), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6091), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6099), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [116343] = 23,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6089), 1,
      anon_sym_GT_GT,
    ACTIONS(6101), 1,
      anon_sym_PERCENT,
    ACTIONS(6103), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6105), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2715), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6085), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6087), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6091), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6099), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6107), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5054), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [116433] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5312), 1,
      anon_sym_LBRACK,
    STATE(2716), 1,
      sym_comment,
    ACTIONS(4667), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5315), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3752), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [116493] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(6143), 1,
      anon_sym_RBRACE,
    STATE(2717), 1,
      sym_comment,
    STATE(4791), 1,
      sym__property_name,
    STATE(5933), 1,
      sym_enum_assignment,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [116561] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(6145), 1,
      anon_sym_RBRACE,
    STATE(2718), 1,
      sym_comment,
    STATE(4791), 1,
      sym__property_name,
    STATE(5933), 1,
      sym_enum_assignment,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [116629] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6147), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2719), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5126), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5128), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [116701] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(6089), 1,
      anon_sym_GT_GT,
    ACTIONS(6093), 1,
      anon_sym_AMP,
    ACTIONS(6095), 1,
      anon_sym_CARET,
    ACTIONS(6097), 1,
      anon_sym_PIPE,
    ACTIONS(6101), 1,
      anon_sym_PERCENT,
    ACTIONS(6103), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6105), 1,
      anon_sym_LT,
    ACTIONS(6117), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6119), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6121), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6123), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2720), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6085), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6087), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6091), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6099), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6109), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6111), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6107), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [116811] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(6150), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2721), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5098), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5100), 14,
      sym__ternary_qmark,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [116891] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5406), 1,
      anon_sym_LBRACK,
    STATE(2722), 1,
      sym_comment,
    ACTIONS(4841), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5409), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5338), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5340), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [116951] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3959), 1,
      anon_sym_EQ,
    ACTIONS(5447), 1,
      anon_sym_LBRACK,
    STATE(2723), 1,
      sym_comment,
    ACTIONS(4793), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5450), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3752), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [117013] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5913), 1,
      anon_sym_COMMA,
    STATE(2724), 1,
      sym_comment,
    ACTIONS(4775), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4777), 26,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [117069] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(6089), 1,
      anon_sym_GT_GT,
    ACTIONS(6093), 1,
      anon_sym_AMP,
    ACTIONS(6095), 1,
      anon_sym_CARET,
    ACTIONS(6097), 1,
      anon_sym_PIPE,
    ACTIONS(6101), 1,
      anon_sym_PERCENT,
    ACTIONS(6103), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6105), 1,
      anon_sym_LT,
    ACTIONS(6117), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6119), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6121), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6123), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2725), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6085), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6087), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6091), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6099), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6109), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6111), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6107), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [117179] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_import,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(17), 1,
      anon_sym_AT,
    ACTIONS(19), 1,
      anon_sym_pragma,
    STATE(2726), 1,
      sym_comment,
    STATE(3076), 1,
      aux_sym_program_repeat1,
    STATE(3084), 1,
      aux_sym_ui_annotated_object_repeat1,
    STATE(3086), 1,
      sym_ui_annotation,
    STATE(5505), 1,
      sym_ui_nested_identifier,
    STATE(3106), 2,
      sym_ui_pragma,
      sym_ui_import,
    STATE(6348), 2,
      sym_ui_object_definition,
      sym_ui_annotated_object,
    ACTIONS(11), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [117251] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2727), 1,
      sym_comment,
    ACTIONS(4781), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4775), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4777), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [117307] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6153), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2728), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4877), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4879), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [117381] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5447), 1,
      anon_sym_LBRACK,
    STATE(2729), 1,
      sym_comment,
    ACTIONS(4793), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5450), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3752), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [117441] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(6103), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6125), 1,
      anon_sym_LT,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2730), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5054), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5052), 13,
      sym__ternary_qmark,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [117523] = 17,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(2339), 1,
      anon_sym_async,
    ACTIONS(2344), 1,
      anon_sym_readonly,
    ACTIONS(2348), 1,
      anon_sym_override,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4408), 1,
      anon_sym_STAR,
    ACTIONS(6156), 1,
      anon_sym_static,
    STATE(2731), 1,
      sym_comment,
    STATE(2779), 1,
      sym_override_modifier,
    STATE(4068), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2346), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 24,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [117601] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(6158), 1,
      anon_sym_RBRACE,
    STATE(2732), 1,
      sym_comment,
    STATE(4791), 1,
      sym__property_name,
    STATE(5933), 1,
      sym_enum_assignment,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [117669] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(6160), 1,
      anon_sym_RBRACE,
    STATE(2733), 1,
      sym_comment,
    STATE(4791), 1,
      sym__property_name,
    STATE(5933), 1,
      sym_enum_assignment,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [117737] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3949), 1,
      anon_sym_EQ,
    ACTIONS(5447), 1,
      anon_sym_LBRACK,
    STATE(2734), 1,
      sym_comment,
    ACTIONS(4793), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5450), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3752), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [117799] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(6162), 1,
      anon_sym_RBRACE,
    STATE(2735), 1,
      sym_comment,
    STATE(4791), 1,
      sym__property_name,
    STATE(5933), 1,
      sym_enum_assignment,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [117867] = 17,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(4312), 1,
      anon_sym_STAR,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4326), 1,
      anon_sym_async,
    ACTIONS(4328), 1,
      anon_sym_readonly,
    ACTIONS(6164), 1,
      anon_sym_static,
    STATE(2736), 1,
      sym_comment,
    STATE(2780), 1,
      sym_override_modifier,
    STATE(3342), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4330), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3708), 24,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [117945] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(6166), 1,
      anon_sym_RBRACE,
    STATE(2737), 1,
      sym_comment,
    STATE(4791), 1,
      sym__property_name,
    STATE(5933), 1,
      sym_enum_assignment,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [118013] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(6168), 1,
      anon_sym_RBRACE,
    STATE(2738), 1,
      sym_comment,
    STATE(4634), 1,
      sym__property_name,
    STATE(5307), 1,
      sym_enum_assignment,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [118081] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(6089), 1,
      anon_sym_GT_GT,
    ACTIONS(6093), 1,
      anon_sym_AMP,
    ACTIONS(6095), 1,
      anon_sym_CARET,
    ACTIONS(6097), 1,
      anon_sym_PIPE,
    ACTIONS(6101), 1,
      anon_sym_PERCENT,
    ACTIONS(6103), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6105), 1,
      anon_sym_LT,
    ACTIONS(6117), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6119), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6121), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6123), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2739), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6085), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6087), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6091), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6099), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6109), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6111), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6107), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [118191] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(6089), 1,
      anon_sym_GT_GT,
    ACTIONS(6093), 1,
      anon_sym_AMP,
    ACTIONS(6095), 1,
      anon_sym_CARET,
    ACTIONS(6097), 1,
      anon_sym_PIPE,
    ACTIONS(6101), 1,
      anon_sym_PERCENT,
    ACTIONS(6103), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6105), 1,
      anon_sym_LT,
    ACTIONS(6117), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6119), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6121), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6123), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2740), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6085), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6087), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6091), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6099), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6109), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6111), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6107), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [118301] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(6170), 1,
      anon_sym_static,
    ACTIONS(6172), 1,
      anon_sym_readonly,
    ACTIONS(6174), 1,
      anon_sym_abstract,
    STATE(2741), 1,
      sym_comment,
    STATE(2809), 1,
      sym_override_modifier,
    STATE(3639), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3708), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [118375] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_import,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(17), 1,
      anon_sym_AT,
    ACTIONS(19), 1,
      anon_sym_pragma,
    STATE(2742), 1,
      sym_comment,
    STATE(3076), 1,
      aux_sym_program_repeat1,
    STATE(3084), 1,
      aux_sym_ui_annotated_object_repeat1,
    STATE(3086), 1,
      sym_ui_annotation,
    STATE(5505), 1,
      sym_ui_nested_identifier,
    STATE(3106), 2,
      sym_ui_pragma,
      sym_ui_import,
    STATE(6354), 2,
      sym_ui_object_definition,
      sym_ui_annotated_object,
    ACTIONS(11), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [118447] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(6176), 1,
      anon_sym_RBRACE,
    STATE(2743), 1,
      sym_comment,
    STATE(4791), 1,
      sym__property_name,
    STATE(5933), 1,
      sym_enum_assignment,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [118515] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(3732), 1,
      anon_sym_override,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(6178), 1,
      anon_sym_STAR,
    ACTIONS(6180), 1,
      anon_sym_readonly,
    STATE(2744), 1,
      sym_comment,
    STATE(2771), 1,
      sym_override_modifier,
    STATE(3313), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6182), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3708), 26,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [118589] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2745), 1,
      sym_comment,
    ACTIONS(4789), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
    ACTIONS(4787), 4,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(3752), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [118647] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(6184), 1,
      anon_sym_RBRACE,
    STATE(2746), 1,
      sym_comment,
    STATE(4791), 1,
      sym__property_name,
    STATE(5933), 1,
      sym_enum_assignment,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [118715] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(6089), 1,
      anon_sym_GT_GT,
    ACTIONS(6093), 1,
      anon_sym_AMP,
    ACTIONS(6095), 1,
      anon_sym_CARET,
    ACTIONS(6097), 1,
      anon_sym_PIPE,
    ACTIONS(6101), 1,
      anon_sym_PERCENT,
    ACTIONS(6103), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6105), 1,
      anon_sym_LT,
    ACTIONS(6117), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6119), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6121), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6123), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2747), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6085), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6087), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6091), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6099), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6109), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6111), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6107), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [118825] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(6089), 1,
      anon_sym_GT_GT,
    ACTIONS(6093), 1,
      anon_sym_AMP,
    ACTIONS(6095), 1,
      anon_sym_CARET,
    ACTIONS(6097), 1,
      anon_sym_PIPE,
    ACTIONS(6101), 1,
      anon_sym_PERCENT,
    ACTIONS(6103), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6105), 1,
      anon_sym_LT,
    ACTIONS(6117), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6119), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6121), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6123), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2748), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6085), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6087), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6091), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6099), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6109), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6111), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6107), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [118935] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(6089), 1,
      anon_sym_GT_GT,
    ACTIONS(6093), 1,
      anon_sym_AMP,
    ACTIONS(6095), 1,
      anon_sym_CARET,
    ACTIONS(6097), 1,
      anon_sym_PIPE,
    ACTIONS(6101), 1,
      anon_sym_PERCENT,
    ACTIONS(6103), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6105), 1,
      anon_sym_LT,
    ACTIONS(6117), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6119), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6121), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6123), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2749), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6085), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6087), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6091), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6099), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6109), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6111), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6107), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [119045] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(6089), 1,
      anon_sym_GT_GT,
    ACTIONS(6093), 1,
      anon_sym_AMP,
    ACTIONS(6095), 1,
      anon_sym_CARET,
    ACTIONS(6097), 1,
      anon_sym_PIPE,
    ACTIONS(6101), 1,
      anon_sym_PERCENT,
    ACTIONS(6103), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6105), 1,
      anon_sym_LT,
    ACTIONS(6117), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6119), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6121), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6123), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2750), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6085), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6087), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6091), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6099), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6109), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6111), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6107), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [119155] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2751), 1,
      sym_comment,
    ACTIONS(3670), 8,
      anon_sym_STAR,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(3668), 32,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_DOT,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [119209] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4645), 1,
      anon_sym_LBRACK,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4725), 1,
      anon_sym_as,
    ACTIONS(4729), 1,
      anon_sym_BANG,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4767), 1,
      anon_sym_satisfies,
    ACTIONS(6089), 1,
      anon_sym_GT_GT,
    ACTIONS(6093), 1,
      anon_sym_AMP,
    ACTIONS(6095), 1,
      anon_sym_CARET,
    ACTIONS(6097), 1,
      anon_sym_PIPE,
    ACTIONS(6101), 1,
      anon_sym_PERCENT,
    ACTIONS(6103), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6105), 1,
      anon_sym_LT,
    ACTIONS(6117), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6119), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6121), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6123), 1,
      sym__ternary_qmark,
    STATE(1727), 1,
      sym_type_arguments,
    STATE(2752), 1,
      sym_comment,
    STATE(4963), 1,
      sym_optional_chain,
    ACTIONS(4765), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6085), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6087), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6091), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6099), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6109), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6111), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6107), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [119319] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(6186), 1,
      anon_sym_RBRACE,
    STATE(2753), 1,
      sym_comment,
    STATE(4791), 1,
      sym__property_name,
    STATE(5933), 1,
      sym_enum_assignment,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [119387] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5785), 1,
      sym_regex_flags,
    STATE(2754), 1,
      sym_comment,
    ACTIONS(5781), 17,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(5783), 22,
      sym__ternary_qmark,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [119443] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4452), 1,
      anon_sym_STAR,
    ACTIONS(4454), 1,
      anon_sym_async,
    ACTIONS(4460), 1,
      anon_sym_readonly,
    STATE(2755), 1,
      sym_comment,
    STATE(3324), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4456), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3708), 26,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [119514] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(6188), 1,
      anon_sym_STAR,
    STATE(2756), 1,
      sym_comment,
    STATE(4147), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6190), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [119581] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3914), 1,
      anon_sym_RBRACK,
    ACTIONS(3928), 1,
      anon_sym_COMMA,
    ACTIONS(4081), 1,
      anon_sym_EQ,
    STATE(2757), 1,
      sym_comment,
    ACTIONS(3752), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [119640] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2758), 1,
      sym_comment,
    ACTIONS(5353), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(6192), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6195), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [119695] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5447), 1,
      anon_sym_LBRACK,
    STATE(2759), 1,
      sym_comment,
    ACTIONS(5450), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4793), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(3752), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [119754] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2760), 1,
      sym_comment,
    STATE(4791), 1,
      sym__property_name,
    STATE(5933), 1,
      sym_enum_assignment,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [119819] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(5750), 1,
      anon_sym_STAR,
    ACTIONS(5752), 1,
      anon_sym_async,
    ACTIONS(6198), 1,
      anon_sym_readonly,
    STATE(2761), 1,
      sym_comment,
    STATE(4117), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5754), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 26,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [119890] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2762), 1,
      sym_comment,
    ACTIONS(1954), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(6200), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6203), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [119945] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4349), 1,
      anon_sym_STAR,
    ACTIONS(4353), 1,
      anon_sym_async,
    ACTIONS(4355), 1,
      anon_sym_readonly,
    STATE(2763), 1,
      sym_comment,
    STATE(3298), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4357), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3708), 26,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [120016] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2764), 1,
      sym_comment,
    ACTIONS(1998), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(6206), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6209), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [120071] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2765), 1,
      sym_comment,
    ACTIONS(5400), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(6212), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6215), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [120126] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2766), 1,
      sym_comment,
    ACTIONS(4781), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4775), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4777), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [120181] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5406), 1,
      anon_sym_LBRACK,
    STATE(2767), 1,
      sym_comment,
    ACTIONS(5409), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4841), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(5338), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5340), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [120240] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3938), 1,
      anon_sym_EQ,
    STATE(2768), 1,
      sym_comment,
    ACTIONS(3752), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [120295] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4476), 1,
      anon_sym_STAR,
    ACTIONS(4478), 1,
      anon_sym_async,
    ACTIONS(4480), 1,
      anon_sym_readonly,
    STATE(2769), 1,
      sym_comment,
    STATE(3371), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4482), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3708), 26,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [120366] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4667), 1,
      anon_sym_extends,
    STATE(2770), 1,
      sym_comment,
    ACTIONS(5312), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(5315), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3752), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [120425] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(6113), 1,
      anon_sym_STAR,
    STATE(2771), 1,
      sym_comment,
    STATE(4122), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6218), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [120492] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4400), 1,
      anon_sym_STAR,
    ACTIONS(4402), 1,
      anon_sym_async,
    ACTIONS(6220), 1,
      anon_sym_readonly,
    STATE(2772), 1,
      sym_comment,
    STATE(3300), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4404), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3708), 26,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [120563] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4420), 1,
      anon_sym_STAR,
    ACTIONS(4422), 1,
      anon_sym_async,
    ACTIONS(4424), 1,
      anon_sym_readonly,
    STATE(2773), 1,
      sym_comment,
    STATE(3399), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4426), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3708), 26,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [120634] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(2339), 1,
      anon_sym_async,
    ACTIONS(2344), 1,
      anon_sym_readonly,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(4408), 1,
      anon_sym_STAR,
    STATE(2774), 1,
      sym_comment,
    STATE(4068), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2346), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 26,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [120705] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4312), 1,
      anon_sym_STAR,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4326), 1,
      anon_sym_async,
    ACTIONS(4328), 1,
      anon_sym_readonly,
    STATE(2775), 1,
      sym_comment,
    STATE(3342), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4330), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3708), 26,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [120776] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2776), 1,
      sym_comment,
    ACTIONS(4322), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2100), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2098), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [120831] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2777), 1,
      sym_comment,
    ACTIONS(1978), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(6222), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6225), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [120886] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3894), 1,
      anon_sym_EQ,
    ACTIONS(5447), 1,
      anon_sym_LBRACK,
    STATE(2778), 1,
      sym_comment,
    ACTIONS(4793), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5450), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3752), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [120947] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    ACTIONS(5540), 1,
      anon_sym_STAR,
    ACTIONS(5542), 1,
      anon_sym_async,
    ACTIONS(5544), 1,
      anon_sym_readonly,
    STATE(2779), 1,
      sym_comment,
    STATE(4091), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5546), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 26,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [121018] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4466), 1,
      anon_sym_STAR,
    ACTIONS(4468), 1,
      anon_sym_async,
    ACTIONS(4470), 1,
      anon_sym_readonly,
    STATE(2780), 1,
      sym_comment,
    STATE(3345), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4472), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3708), 26,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [121089] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    ACTIONS(6228), 1,
      anon_sym_DOT,
    STATE(2781), 1,
      sym_comment,
    STATE(2945), 1,
      sym_statement_block,
    ACTIONS(1822), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1818), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [121148] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    ACTIONS(6230), 1,
      anon_sym_DOT,
    STATE(2782), 1,
      sym_comment,
    STATE(2945), 1,
      sym_statement_block,
    ACTIONS(1822), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1818), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [121207] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2783), 1,
      sym_comment,
    ACTIONS(1946), 4,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_AT,
    ACTIONS(1944), 35,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [121260] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2784), 1,
      sym_comment,
    ACTIONS(1874), 4,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_AT,
    ACTIONS(1872), 35,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [121313] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5312), 1,
      anon_sym_LBRACK,
    STATE(2785), 1,
      sym_comment,
    ACTIONS(5315), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4667), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(3752), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [121372] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4516), 1,
      anon_sym_STAR,
    ACTIONS(4518), 1,
      anon_sym_async,
    ACTIONS(6232), 1,
      anon_sym_readonly,
    STATE(2786), 1,
      sym_comment,
    STATE(3347), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4520), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3708), 26,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [121443] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4510), 1,
      anon_sym_STAR,
    ACTIONS(4512), 1,
      anon_sym_async,
    ACTIONS(6234), 1,
      anon_sym_readonly,
    STATE(2787), 1,
      sym_comment,
    STATE(3307), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4514), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3708), 26,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [121514] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2788), 1,
      sym_comment,
    ACTIONS(1912), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(6236), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6239), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [121569] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4428), 1,
      anon_sym_STAR,
    ACTIONS(4430), 1,
      anon_sym_async,
    ACTIONS(6242), 1,
      anon_sym_readonly,
    STATE(2789), 1,
      sym_comment,
    STATE(3317), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4434), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3708), 26,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [121640] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4530), 1,
      anon_sym_STAR,
    ACTIONS(4532), 1,
      anon_sym_async,
    ACTIONS(6244), 1,
      anon_sym_readonly,
    STATE(2790), 1,
      sym_comment,
    STATE(3301), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4534), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3708), 26,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [121711] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2791), 1,
      sym_comment,
    ACTIONS(5332), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(6246), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6249), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [121766] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4428), 1,
      anon_sym_STAR,
    ACTIONS(4430), 1,
      anon_sym_async,
    ACTIONS(6252), 1,
      anon_sym_readonly,
    STATE(2792), 1,
      sym_comment,
    STATE(3328), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4434), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3708), 26,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [121837] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6034), 1,
      anon_sym_finally,
    STATE(2793), 1,
      sym_comment,
    STATE(2911), 1,
      sym_finally_clause,
    ACTIONS(2583), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2581), 35,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [121894] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5913), 1,
      anon_sym_COMMA,
    STATE(2794), 1,
      sym_comment,
    ACTIONS(4775), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4777), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [121949] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4556), 1,
      anon_sym_STAR,
    ACTIONS(4558), 1,
      anon_sym_async,
    ACTIONS(6254), 1,
      anon_sym_readonly,
    STATE(2795), 1,
      sym_comment,
    STATE(3360), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4560), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3708), 26,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [122020] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2796), 1,
      sym_comment,
    ACTIONS(5328), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(6256), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6259), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [122075] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3894), 1,
      anon_sym_EQ,
    ACTIONS(3965), 1,
      anon_sym_in,
    ACTIONS(3968), 1,
      anon_sym_of,
    STATE(2797), 1,
      sym_comment,
    ACTIONS(3752), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [122133] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1796), 1,
      anon_sym_EQ,
    ACTIONS(5355), 1,
      anon_sym_of,
    ACTIONS(5975), 1,
      anon_sym_in,
    STATE(2798), 1,
      sym_comment,
    ACTIONS(1794), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1800), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [122191] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2799), 1,
      sym_comment,
    ACTIONS(2617), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2615), 36,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_finally,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [122243] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2800), 1,
      sym_comment,
    ACTIONS(6262), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_AT,
    ACTIONS(6264), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [122295] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2801), 1,
      sym_comment,
    ACTIONS(2633), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6266), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(2631), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [122349] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2802), 1,
      sym_comment,
    ACTIONS(6268), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_AT,
    ACTIONS(6270), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [122401] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(6272), 1,
      anon_sym_readonly,
    STATE(2803), 1,
      sym_comment,
    STATE(3734), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3708), 29,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [122465] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2804), 1,
      sym_comment,
    STATE(4098), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [122527] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    STATE(2805), 1,
      sym_comment,
    STATE(3733), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3708), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [122589] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2806), 1,
      sym_comment,
    STATE(4157), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [122651] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2807), 1,
      sym_comment,
    STATE(4182), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [122713] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(6274), 1,
      anon_sym_readonly,
    STATE(2808), 1,
      sym_comment,
    STATE(3728), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3708), 29,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [122777] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(6276), 1,
      anon_sym_readonly,
    STATE(2809), 1,
      sym_comment,
    STATE(3727), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3708), 29,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [122841] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(6278), 1,
      anon_sym_readonly,
    STATE(2810), 1,
      sym_comment,
    STATE(3576), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3708), 29,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [122905] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    STATE(2811), 1,
      sym_comment,
    STATE(3722), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3708), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [122967] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    STATE(2812), 1,
      sym_comment,
    STATE(2514), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4693), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4695), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [123025] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4916), 1,
      anon_sym_EQ,
    ACTIONS(5310), 1,
      anon_sym_of,
    ACTIONS(5972), 1,
      anon_sym_in,
    STATE(2813), 1,
      sym_comment,
    ACTIONS(4914), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4918), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [123083] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(6280), 1,
      anon_sym_readonly,
    STATE(2814), 1,
      sym_comment,
    STATE(3719), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3708), 29,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [123147] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2815), 1,
      sym_comment,
    STATE(4153), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [123209] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(6282), 1,
      anon_sym_readonly,
    STATE(2816), 1,
      sym_comment,
    STATE(3638), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3708), 29,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [123273] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(6284), 1,
      anon_sym_readonly,
    STATE(2817), 1,
      sym_comment,
    STATE(3678), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3708), 29,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [123337] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    STATE(2818), 1,
      sym_comment,
    STATE(3690), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3708), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [123399] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2819), 1,
      sym_comment,
    STATE(4184), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [123461] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2820), 1,
      sym_comment,
    STATE(4171), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [123523] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2821), 1,
      sym_comment,
    STATE(4147), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [123585] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    STATE(2822), 1,
      sym_comment,
    STATE(3713), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3708), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [123647] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4675), 1,
      anon_sym_readonly,
    STATE(2823), 1,
      sym_comment,
    STATE(3713), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3708), 29,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [123711] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2824), 1,
      sym_comment,
    STATE(4141), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [123773] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3205), 1,
      sym__automatic_semicolon,
    STATE(2825), 1,
      sym_comment,
    ACTIONS(1866), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1862), 35,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [123827] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2826), 1,
      sym_comment,
    ACTIONS(2621), 4,
      sym__automatic_semicolon,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
    ACTIONS(2619), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [123879] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5785), 1,
      sym_regex_flags,
    STATE(2827), 1,
      sym_comment,
    ACTIONS(5781), 17,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_satisfies,
    ACTIONS(5783), 20,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [123933] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2828), 1,
      sym_comment,
    STATE(4155), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [123995] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3945), 1,
      anon_sym_EQ,
    STATE(2829), 1,
      sym_comment,
    ACTIONS(3752), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [124049] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2830), 1,
      sym_comment,
    STATE(4024), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [124111] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2831), 1,
      sym_comment,
    STATE(4132), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [124173] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2832), 1,
      sym_comment,
    STATE(4186), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [124235] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3163), 1,
      sym__automatic_semicolon,
    STATE(2833), 1,
      sym_comment,
    ACTIONS(1890), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1886), 35,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [124289] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3157), 1,
      sym__automatic_semicolon,
    STATE(2834), 1,
      sym_comment,
    ACTIONS(1880), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1876), 35,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [124343] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(2835), 1,
      sym_comment,
    STATE(2945), 1,
      sym_statement_block,
    ACTIONS(1822), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1818), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [124399] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2836), 1,
      sym_comment,
    STATE(4105), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [124461] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2837), 1,
      sym_comment,
    ACTIONS(2625), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2623), 36,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_finally,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [124513] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(6286), 1,
      anon_sym_readonly,
    STATE(2838), 1,
      sym_comment,
    STATE(3714), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3708), 29,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [124577] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2839), 1,
      sym_comment,
    STATE(4159), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [124639] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2840), 1,
      sym_comment,
    STATE(4117), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [124701] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2841), 1,
      sym_comment,
    ACTIONS(2599), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2597), 36,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_finally,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [124753] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2842), 1,
      sym_comment,
    ACTIONS(3680), 7,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(3678), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [124805] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2843), 1,
      sym_comment,
    ACTIONS(6288), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_AT,
    ACTIONS(6290), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [124857] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2844), 1,
      sym_comment,
    ACTIONS(3651), 7,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(3649), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [124909] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2845), 1,
      sym_comment,
    ACTIONS(3688), 7,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(3686), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [124961] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    STATE(2846), 1,
      sym_comment,
    STATE(3737), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3708), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [125023] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2847), 1,
      sym_comment,
    STATE(4189), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [125085] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2848), 1,
      sym_comment,
    ACTIONS(2613), 4,
      sym__automatic_semicolon,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
    ACTIONS(2611), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [125137] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(6292), 1,
      anon_sym_readonly,
    STATE(2849), 1,
      sym_comment,
    STATE(3737), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3708), 29,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [125201] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2850), 1,
      sym_comment,
    ACTIONS(3664), 7,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(3662), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [125253] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2851), 1,
      sym_comment,
    STATE(4185), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [125315] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2852), 1,
      sym_comment,
    STATE(4167), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [125377] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2853), 1,
      sym_comment,
    ACTIONS(3684), 7,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(3682), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [125429] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3143), 1,
      sym__automatic_semicolon,
    STATE(2854), 1,
      sym_comment,
    ACTIONS(1832), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1828), 35,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [125483] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3949), 1,
      anon_sym_EQ,
    STATE(2855), 1,
      sym_comment,
    ACTIONS(3752), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [125537] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2856), 1,
      sym_comment,
    ACTIONS(3674), 7,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(3672), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [125589] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2857), 1,
      sym_comment,
    STATE(4103), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [125651] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2858), 1,
      sym_comment,
    STATE(4144), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [125713] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2859), 1,
      sym_comment,
    STATE(4068), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [125775] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5191), 1,
      anon_sym_EQ,
    ACTIONS(5384), 1,
      anon_sym_of,
    ACTIONS(5978), 1,
      anon_sym_in,
    STATE(2860), 1,
      sym_comment,
    ACTIONS(5189), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5193), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [125833] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2861), 1,
      sym_comment,
    STATE(4173), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [125895] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2862), 1,
      sym_comment,
    STATE(4174), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [125957] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2863), 1,
      sym_comment,
    STATE(4124), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [126019] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2864), 1,
      sym_comment,
    STATE(4041), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [126081] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(6294), 1,
      anon_sym_readonly,
    STATE(2865), 1,
      sym_comment,
    STATE(3645), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3708), 29,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [126145] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    STATE(2866), 1,
      sym_comment,
    STATE(3644), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3708), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [126207] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2867), 1,
      sym_comment,
    STATE(4128), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [126269] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2868), 1,
      sym_comment,
    STATE(4091), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [126331] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2869), 1,
      sym_comment,
    STATE(4133), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [126393] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2870), 1,
      sym_comment,
    STATE(4130), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [126455] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2871), 1,
      sym_comment,
    STATE(4181), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [126517] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2872), 1,
      sym_comment,
    STATE(4126), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [126579] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(6296), 1,
      anon_sym_readonly,
    STATE(2873), 1,
      sym_comment,
    STATE(3664), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3708), 29,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [126643] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    STATE(2874), 1,
      sym_comment,
    STATE(3698), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3708), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [126705] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3959), 1,
      anon_sym_EQ,
    STATE(2875), 1,
      sym_comment,
    ACTIONS(3752), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [126759] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    STATE(2876), 1,
      sym_comment,
    STATE(3715), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3708), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [126821] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(6298), 1,
      anon_sym_readonly,
    STATE(2877), 1,
      sym_comment,
    STATE(3718), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3708), 29,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [126885] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(4324), 1,
      anon_sym_LBRACK,
    ACTIONS(4679), 1,
      anon_sym_readonly,
    STATE(2878), 1,
      sym_comment,
    STATE(3715), 1,
      sym__property_name,
    ACTIONS(3075), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3505), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(3708), 29,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [126949] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2879), 1,
      sym_comment,
    STATE(4131), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [127011] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2880), 1,
      sym_comment,
    ACTIONS(6300), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_AT,
    ACTIONS(6302), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [127063] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      anon_sym_LBRACK,
    STATE(2881), 1,
      sym_comment,
    STATE(4122), 1,
      sym__property_name,
    ACTIONS(2330), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3955), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2334), 30,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [127125] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4251), 1,
      anon_sym_EQ,
    STATE(2882), 1,
      sym_comment,
    ACTIONS(3752), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [127178] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3203), 1,
      sym__automatic_semicolon,
    STATE(2883), 1,
      sym_comment,
    ACTIONS(1910), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1906), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [127231] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3149), 1,
      sym__automatic_semicolon,
    STATE(2884), 1,
      sym_comment,
    ACTIONS(1996), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1992), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [127284] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3151), 1,
      sym__automatic_semicolon,
    STATE(2885), 1,
      sym_comment,
    ACTIONS(1952), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1948), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [127337] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4249), 1,
      anon_sym_EQ,
    STATE(2886), 1,
      sym_comment,
    ACTIONS(3752), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [127390] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4247), 1,
      anon_sym_EQ,
    STATE(2887), 1,
      sym_comment,
    ACTIONS(3752), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [127443] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3165), 1,
      sym__automatic_semicolon,
    STATE(2888), 1,
      sym_comment,
    ACTIONS(1920), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1916), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [127496] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4253), 1,
      anon_sym_EQ,
    STATE(2889), 1,
      sym_comment,
    ACTIONS(3752), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [127549] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2890), 1,
      sym_comment,
    ACTIONS(2699), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2697), 35,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [127600] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2891), 1,
      sym_comment,
    ACTIONS(2695), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2693), 35,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [127651] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3139), 1,
      sym__automatic_semicolon,
    STATE(2892), 1,
      sym_comment,
    ACTIONS(1976), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1972), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [127704] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2893), 1,
      sym_comment,
    ACTIONS(2651), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2649), 35,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [127755] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2894), 1,
      sym_comment,
    ACTIONS(1928), 3,
      sym__automatic_semicolon,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1926), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [127806] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4298), 1,
      anon_sym_EQ,
    STATE(2895), 1,
      sym_comment,
    ACTIONS(3752), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [127859] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4310), 1,
      anon_sym_EQ,
    STATE(2896), 1,
      sym_comment,
    ACTIONS(3752), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [127912] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2897), 1,
      sym_comment,
    ACTIONS(2887), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2885), 35,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [127963] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2898), 1,
      sym_comment,
    ACTIONS(1860), 3,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1858), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [128014] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3227), 1,
      sym__automatic_semicolon,
    STATE(2899), 1,
      sym_comment,
    ACTIONS(1962), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1958), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [128067] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4255), 1,
      anon_sym_EQ,
    STATE(2900), 1,
      sym_comment,
    ACTIONS(3752), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [128120] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4302), 1,
      anon_sym_EQ,
    STATE(2901), 1,
      sym_comment,
    ACTIONS(3752), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [128173] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2902), 1,
      sym_comment,
    ACTIONS(2719), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2717), 35,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [128224] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2903), 1,
      sym_comment,
    ACTIONS(1852), 3,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1850), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [128275] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2904), 1,
      sym_comment,
    ACTIONS(2739), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2737), 35,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [128326] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3249), 1,
      sym__automatic_semicolon,
    STATE(2905), 1,
      sym_comment,
    ACTIONS(1986), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1982), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [128379] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2906), 1,
      sym_comment,
    ACTIONS(1970), 3,
      sym__automatic_semicolon,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1968), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [128430] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2907), 1,
      sym_comment,
    ACTIONS(2743), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2741), 35,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [128481] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6304), 1,
      anon_sym_else,
    STATE(2908), 1,
      sym_comment,
    STATE(2909), 1,
      sym_else_clause,
    ACTIONS(2603), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2601), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [128536] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2909), 1,
      sym_comment,
    ACTIONS(2731), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2729), 35,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [128587] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2910), 1,
      sym_comment,
    ACTIONS(2687), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2685), 35,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [128638] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2911), 1,
      sym_comment,
    ACTIONS(2715), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2713), 35,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [128689] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2912), 1,
      sym_comment,
    ACTIONS(2723), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2721), 35,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [128740] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2913), 1,
      sym_comment,
    ACTIONS(2839), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2837), 35,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [128791] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2914), 1,
      sym_comment,
    ACTIONS(2663), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2661), 35,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [128842] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4306), 1,
      anon_sym_EQ,
    STATE(2915), 1,
      sym_comment,
    ACTIONS(3752), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [128895] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2916), 1,
      sym_comment,
    ACTIONS(2609), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2607), 35,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [128946] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2917), 1,
      sym_comment,
    ACTIONS(2639), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2637), 35,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [128997] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3289), 1,
      sym__automatic_semicolon,
    STATE(2918), 1,
      sym_comment,
    ACTIONS(1934), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1930), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [129050] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2919), 1,
      sym_comment,
    ACTIONS(2595), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2593), 35,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [129101] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2920), 1,
      sym_comment,
    ACTIONS(2643), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2641), 35,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [129152] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2921), 1,
      sym_comment,
    ACTIONS(2923), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2921), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [129202] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2922), 1,
      sym_comment,
    ACTIONS(2895), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2893), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [129252] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2923), 1,
      sym_comment,
    ACTIONS(2819), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2817), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [129302] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2924), 1,
      sym_comment,
    ACTIONS(2811), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2809), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [129352] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2925), 1,
      sym_comment,
    ACTIONS(2943), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2941), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [129402] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2926), 1,
      sym_comment,
    ACTIONS(2951), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2949), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [129452] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2927), 1,
      sym_comment,
    ACTIONS(2959), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2957), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [129502] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2928), 1,
      sym_comment,
    ACTIONS(2763), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2761), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [129552] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2929), 1,
      sym_comment,
    ACTIONS(2787), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2785), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [129602] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2930), 1,
      sym_comment,
    ACTIONS(2855), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2853), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [129652] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2931), 1,
      sym_comment,
    ACTIONS(2807), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2805), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [129702] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2932), 1,
      sym_comment,
    ACTIONS(2795), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2793), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [129752] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2933), 1,
      sym_comment,
    ACTIONS(2791), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2789), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [129802] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2934), 1,
      sym_comment,
    ACTIONS(2759), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2757), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [129852] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2935), 1,
      sym_comment,
    ACTIONS(2735), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2733), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [129902] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2936), 1,
      sym_comment,
    ACTIONS(2727), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2725), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [129952] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2937), 1,
      sym_comment,
    ACTIONS(2683), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2681), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [130002] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2938), 1,
      sym_comment,
    ACTIONS(2823), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2821), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [130052] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2939), 1,
      sym_comment,
    ACTIONS(2707), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2705), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [130102] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2940), 1,
      sym_comment,
    ACTIONS(2703), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2701), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [130152] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2941), 1,
      sym_comment,
    ACTIONS(1840), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1838), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [130202] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2942), 1,
      sym_comment,
    ACTIONS(2671), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2669), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [130252] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2943), 1,
      sym_comment,
    ACTIONS(2895), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2893), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [130302] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2944), 1,
      sym_comment,
    ACTIONS(2667), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2665), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [130352] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2945), 1,
      sym_comment,
    ACTIONS(1898), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1896), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [130402] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2946), 1,
      sym_comment,
    ACTIONS(2659), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2657), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [130452] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2947), 1,
      sym_comment,
    ACTIONS(2911), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2909), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [130502] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2948), 1,
      sym_comment,
    ACTIONS(2783), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2781), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [130552] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2949), 1,
      sym_comment,
    ACTIONS(1846), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1842), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [130602] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2950), 1,
      sym_comment,
    ACTIONS(2398), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2396), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [130652] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2951), 1,
      sym_comment,
    ACTIONS(2919), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2917), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [130702] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2952), 1,
      sym_comment,
    ACTIONS(2895), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2893), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [130752] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2953), 1,
      sym_comment,
    ACTIONS(2895), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2893), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [130802] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2954), 1,
      sym_comment,
    ACTIONS(2895), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2893), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [130852] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2955), 1,
      sym_comment,
    ACTIONS(2895), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2893), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [130902] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2956), 1,
      sym_comment,
    ACTIONS(2675), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2673), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [130952] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2957), 1,
      sym_comment,
    ACTIONS(2971), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2969), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [131002] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2958), 1,
      sym_comment,
    ACTIONS(2406), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2404), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [131052] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2959), 1,
      sym_comment,
    ACTIONS(2394), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2392), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [131102] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2960), 1,
      sym_comment,
    ACTIONS(2975), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2973), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [131152] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2961), 1,
      sym_comment,
    ACTIONS(2390), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2388), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [131202] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2962), 1,
      sym_comment,
    ACTIONS(2402), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2400), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [131252] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2963), 1,
      sym_comment,
    ACTIONS(2991), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2989), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [131302] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2964), 1,
      sym_comment,
    ACTIONS(2991), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2989), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [131352] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2965), 1,
      sym_comment,
    ACTIONS(2995), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2993), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [131402] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6308), 1,
      anon_sym_AT,
    STATE(3086), 1,
      sym_ui_annotation,
    STATE(2966), 2,
      sym_comment,
      aux_sym_ui_annotated_object_repeat1,
    ACTIONS(6306), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [131454] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2967), 1,
      sym_comment,
    ACTIONS(2999), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2997), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [131504] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2968), 1,
      sym_comment,
    ACTIONS(3003), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(3001), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [131554] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2969), 1,
      sym_comment,
    ACTIONS(2851), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2849), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [131604] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2970), 1,
      sym_comment,
    ACTIONS(2755), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2753), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [131654] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2971), 1,
      sym_comment,
    ACTIONS(2843), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2841), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [131704] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2972), 1,
      sym_comment,
    ACTIONS(2863), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2861), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [131754] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2973), 1,
      sym_comment,
    ACTIONS(2859), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2857), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [131804] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2974), 1,
      sym_comment,
    ACTIONS(2847), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2845), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [131854] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2975), 1,
      sym_comment,
    ACTIONS(2871), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2869), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [131904] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2976), 1,
      sym_comment,
    ACTIONS(2831), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2829), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [131954] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2977), 1,
      sym_comment,
    ACTIONS(3015), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(3013), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [132004] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2978), 1,
      sym_comment,
    ACTIONS(2843), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2841), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [132054] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2979), 1,
      sym_comment,
    ACTIONS(3011), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(3009), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [132104] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2980), 1,
      sym_comment,
    ACTIONS(2955), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2953), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [132154] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2981), 1,
      sym_comment,
    ACTIONS(2931), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2929), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [132204] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2982), 1,
      sym_comment,
    ACTIONS(2843), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2841), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [132254] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2983), 1,
      sym_comment,
    ACTIONS(2983), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2981), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [132304] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2984), 1,
      sym_comment,
    ACTIONS(2947), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2945), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [132354] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2985), 1,
      sym_comment,
    ACTIONS(2939), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2937), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [132404] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2986), 1,
      sym_comment,
    ACTIONS(2935), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2933), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [132454] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2987), 1,
      sym_comment,
    ACTIONS(1970), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1968), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [132504] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2988), 1,
      sym_comment,
    ACTIONS(2899), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2897), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [132554] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2989), 1,
      sym_comment,
    ACTIONS(2655), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2653), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [132604] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2990), 1,
      sym_comment,
    ACTIONS(2891), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2889), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [132654] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2991), 1,
      sym_comment,
    ACTIONS(2815), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2813), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [132704] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2992), 1,
      sym_comment,
    ACTIONS(2815), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2813), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [132754] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2993), 1,
      sym_comment,
    ACTIONS(2655), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2653), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [132804] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2994), 1,
      sym_comment,
    ACTIONS(2647), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2645), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [132854] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2995), 1,
      sym_comment,
    ACTIONS(2827), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2825), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [132904] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2996), 1,
      sym_comment,
    ACTIONS(2747), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2745), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [132954] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2997), 1,
      sym_comment,
    ACTIONS(2751), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2749), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [133004] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2998), 1,
      sym_comment,
    ACTIONS(2803), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2801), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [133054] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(2999), 1,
      sym_comment,
    ACTIONS(2835), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2833), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [133104] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3000), 1,
      sym_comment,
    ACTIONS(2835), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2833), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [133154] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3001), 1,
      sym_comment,
    ACTIONS(2879), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2877), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [133204] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3002), 1,
      sym_comment,
    ACTIONS(2767), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2765), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [133254] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3003), 1,
      sym_comment,
    ACTIONS(2771), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2769), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [133304] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3004), 1,
      sym_comment,
    ACTIONS(2775), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2773), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [133354] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3005), 1,
      sym_comment,
    ACTIONS(2779), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2777), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [133404] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3006), 1,
      sym_comment,
    ACTIONS(2883), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2881), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [133454] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3007), 1,
      sym_comment,
    ACTIONS(2903), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2901), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [133504] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3008), 1,
      sym_comment,
    ACTIONS(1928), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1926), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [133554] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3009), 1,
      sym_comment,
    ACTIONS(2907), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2905), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [133604] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3010), 1,
      sym_comment,
    ACTIONS(2907), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2905), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [133654] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3011), 1,
      sym_comment,
    ACTIONS(2915), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2913), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [133704] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3012), 1,
      sym_comment,
    ACTIONS(2963), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2961), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [133754] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3013), 1,
      sym_comment,
    ACTIONS(2967), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2965), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [133804] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3014), 1,
      sym_comment,
    ACTIONS(2927), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2925), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [133854] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3015), 1,
      sym_comment,
    ACTIONS(2927), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2925), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [133904] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3016), 1,
      sym_comment,
    ACTIONS(2691), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2689), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [133954] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3017), 1,
      sym_comment,
    ACTIONS(2679), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2677), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [134004] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3018), 1,
      sym_comment,
    ACTIONS(2711), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2709), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [134054] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3019), 1,
      sym_comment,
    ACTIONS(2799), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2797), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [134104] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3020), 1,
      sym_comment,
    ACTIONS(1846), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1842), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [134154] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3021), 1,
      sym_comment,
    ACTIONS(2867), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2865), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [134204] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3022), 1,
      sym_comment,
    ACTIONS(2875), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2873), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [134254] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3023), 1,
      sym_comment,
    ACTIONS(2979), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2977), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [134304] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3024), 1,
      sym_comment,
    ACTIONS(2987), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2985), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [134354] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3025), 1,
      sym_comment,
    ACTIONS(2987), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2985), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [134404] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3026), 1,
      sym_comment,
    ACTIONS(2987), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2985), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [134454] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3027), 1,
      sym_comment,
    ACTIONS(3007), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(3005), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [134504] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3028), 1,
      sym_comment,
    ACTIONS(6313), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6311), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [134553] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3029), 1,
      sym_comment,
    ACTIONS(6317), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6315), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [134602] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3030), 1,
      sym_comment,
    ACTIONS(6321), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6319), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [134651] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3031), 1,
      sym_comment,
    ACTIONS(6325), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6323), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [134700] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3032), 1,
      sym_comment,
    ACTIONS(6329), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6327), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [134749] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3033), 1,
      sym_comment,
    ACTIONS(6333), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6331), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [134798] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3034), 1,
      sym_comment,
    ACTIONS(6337), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6335), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [134847] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3035), 1,
      sym_comment,
    ACTIONS(6341), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6339), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [134896] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3036), 1,
      sym_comment,
    ACTIONS(6345), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6343), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [134945] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3037), 1,
      sym_comment,
    ACTIONS(6349), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6347), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [134994] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3038), 1,
      sym_comment,
    ACTIONS(6353), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6351), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [135043] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3039), 1,
      sym_comment,
    ACTIONS(6357), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6355), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [135092] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3040), 1,
      sym_comment,
    ACTIONS(6361), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6359), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [135141] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3041), 1,
      sym_comment,
    ACTIONS(6365), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6363), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [135190] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3042), 1,
      sym_comment,
    ACTIONS(6369), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6367), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [135239] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3043), 1,
      sym_comment,
    ACTIONS(6373), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6371), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [135288] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3044), 1,
      sym_comment,
    ACTIONS(6377), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6375), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [135337] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3045), 1,
      sym_comment,
    ACTIONS(6381), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6379), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [135386] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3046), 1,
      sym_comment,
    ACTIONS(6385), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6383), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [135435] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3047), 1,
      sym_comment,
    ACTIONS(6389), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6387), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [135484] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3048), 1,
      sym_comment,
    ACTIONS(6393), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6391), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [135533] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3049), 1,
      sym_comment,
    ACTIONS(6397), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6395), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [135582] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3050), 1,
      sym_comment,
    ACTIONS(6401), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6399), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [135631] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3051), 1,
      sym_comment,
    ACTIONS(6405), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6403), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [135680] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3052), 1,
      sym_comment,
    ACTIONS(6409), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6407), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [135729] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3053), 1,
      sym_comment,
    ACTIONS(6413), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6411), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [135778] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3054), 1,
      sym_comment,
    ACTIONS(6417), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6415), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [135827] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3055), 1,
      sym_comment,
    ACTIONS(6421), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6419), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [135876] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3056), 1,
      sym_comment,
    ACTIONS(6317), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6315), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [135925] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3057), 1,
      sym_comment,
    ACTIONS(6425), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6423), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [135974] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3058), 1,
      sym_comment,
    ACTIONS(6429), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6427), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [136023] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3059), 1,
      sym_comment,
    ACTIONS(6317), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6315), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [136072] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3060), 1,
      sym_comment,
    ACTIONS(6433), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6431), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [136121] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3061), 1,
      sym_comment,
    ACTIONS(6437), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6435), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [136170] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3062), 1,
      sym_comment,
    ACTIONS(6317), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6315), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [136219] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3063), 1,
      sym_comment,
    ACTIONS(6441), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6439), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [136268] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3064), 1,
      sym_comment,
    ACTIONS(6445), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6443), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [136317] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3065), 1,
      sym_comment,
    ACTIONS(6317), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6315), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [136366] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3066), 1,
      sym_comment,
    ACTIONS(6449), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6447), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [136415] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3067), 1,
      sym_comment,
    ACTIONS(6453), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6451), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [136464] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3068), 1,
      sym_comment,
    ACTIONS(6457), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6455), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [136513] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3069), 1,
      sym_comment,
    ACTIONS(6461), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6459), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [136562] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3070), 1,
      sym_comment,
    ACTIONS(6317), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6315), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [136611] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3071), 1,
      sym_comment,
    ACTIONS(6317), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6315), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [136660] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3072), 1,
      sym_comment,
    ACTIONS(6317), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6315), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [136709] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3073), 1,
      sym_comment,
    ACTIONS(6317), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6315), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [136758] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3074), 1,
      sym_comment,
    ACTIONS(6465), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6463), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [136807] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3075), 1,
      sym_comment,
    ACTIONS(6469), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6467), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [136856] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6473), 1,
      anon_sym_import,
    ACTIONS(6476), 1,
      anon_sym_AT,
    ACTIONS(6478), 1,
      anon_sym_pragma,
    STATE(3076), 2,
      sym_comment,
      aux_sym_program_repeat1,
    STATE(3106), 2,
      sym_ui_pragma,
      sym_ui_import,
    ACTIONS(6471), 29,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [136911] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3077), 1,
      sym_comment,
    ACTIONS(6483), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6481), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [136960] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3078), 1,
      sym_comment,
    ACTIONS(6317), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6315), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [137009] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3079), 1,
      sym_comment,
    ACTIONS(6487), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6485), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [137058] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3080), 1,
      sym_comment,
    ACTIONS(6491), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6489), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [137107] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3081), 1,
      sym_comment,
    ACTIONS(6495), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6493), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [137156] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3082), 1,
      sym_comment,
    ACTIONS(6499), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6497), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [137205] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3083), 1,
      sym_comment,
    ACTIONS(6503), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(6501), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [137254] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(17), 1,
      anon_sym_AT,
    STATE(2966), 1,
      aux_sym_ui_annotated_object_repeat1,
    STATE(3084), 1,
      sym_comment,
    STATE(3086), 1,
      sym_ui_annotation,
    STATE(5505), 1,
      sym_ui_nested_identifier,
    STATE(6349), 1,
      sym_ui_object_definition,
    ACTIONS(11), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [137312] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2484), 1,
      anon_sym_LBRACE,
    ACTIONS(6505), 1,
      sym_identifier,
    ACTIONS(6509), 1,
      anon_sym_default,
    ACTIONS(6511), 1,
      anon_sym_COLON,
    ACTIONS(6513), 1,
      anon_sym_DOT,
    ACTIONS(6518), 1,
      anon_sym_on,
    STATE(2802), 1,
      sym_ui_object_initializer,
    STATE(3085), 1,
      sym_comment,
    ACTIONS(6515), 3,
      anon_sym_readonly,
      anon_sym_property,
      anon_sym_required,
    ACTIONS(6507), 24,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_signal,
      anon_sym_component,
  [137374] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6522), 1,
      anon_sym_AT,
    STATE(3086), 1,
      sym_comment,
    ACTIONS(6520), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [137422] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6526), 1,
      anon_sym_AT,
    STATE(3087), 1,
      sym_comment,
    ACTIONS(6524), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [137470] = 24,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2436), 1,
      anon_sym_var,
    ACTIONS(2456), 1,
      anon_sym_namespace,
    ACTIONS(2458), 1,
      anon_sym_import,
    ACTIONS(2460), 1,
      anon_sym_let,
    ACTIONS(2462), 1,
      anon_sym_const,
    ACTIONS(2464), 1,
      anon_sym_class,
    ACTIONS(2466), 1,
      anon_sym_async,
    ACTIONS(2468), 1,
      anon_sym_function,
    ACTIONS(2470), 1,
      anon_sym_declare,
    ACTIONS(2474), 1,
      anon_sym_abstract,
    ACTIONS(2476), 1,
      anon_sym_interface,
    ACTIONS(2478), 1,
      anon_sym_enum,
    ACTIONS(2497), 1,
      anon_sym_type,
    ACTIONS(2499), 1,
      anon_sym_module,
    ACTIONS(2501), 1,
      anon_sym_global,
    STATE(1202), 1,
      sym_decorator,
    STATE(2997), 1,
      sym_declaration,
    STATE(3020), 1,
      sym_internal_module,
    STATE(3088), 1,
      sym_comment,
    STATE(4344), 1,
      aux_sym_export_statement_repeat1,
    STATE(2949), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [137555] = 24,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2544), 1,
      anon_sym_type,
    ACTIONS(2546), 1,
      anon_sym_namespace,
    ACTIONS(2548), 1,
      anon_sym_import,
    ACTIONS(2550), 1,
      anon_sym_var,
    ACTIONS(2552), 1,
      anon_sym_let,
    ACTIONS(2554), 1,
      anon_sym_const,
    ACTIONS(2556), 1,
      anon_sym_class,
    ACTIONS(2558), 1,
      anon_sym_async,
    ACTIONS(2560), 1,
      anon_sym_function,
    ACTIONS(2562), 1,
      anon_sym_declare,
    ACTIONS(2566), 1,
      anon_sym_abstract,
    ACTIONS(2570), 1,
      anon_sym_interface,
    ACTIONS(2572), 1,
      anon_sym_enum,
    ACTIONS(4392), 1,
      anon_sym_module,
    ACTIONS(6528), 1,
      anon_sym_default,
    STATE(1202), 1,
      sym_decorator,
    STATE(3089), 1,
      sym_comment,
    STATE(4243), 1,
      aux_sym_export_statement_repeat1,
    STATE(4277), 1,
      sym_internal_module,
    STATE(4471), 1,
      sym_declaration,
    STATE(4205), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [137640] = 24,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2364), 1,
      anon_sym_import,
    ACTIONS(2368), 1,
      anon_sym_let,
    ACTIONS(2370), 1,
      anon_sym_const,
    ACTIONS(2372), 1,
      anon_sym_class,
    ACTIONS(2382), 1,
      anon_sym_abstract,
    ACTIONS(2384), 1,
      anon_sym_interface,
    ACTIONS(2386), 1,
      anon_sym_enum,
    ACTIONS(2408), 1,
      anon_sym_type,
    ACTIONS(2434), 1,
      anon_sym_namespace,
    ACTIONS(2436), 1,
      anon_sym_var,
    ACTIONS(2438), 1,
      anon_sym_async,
    ACTIONS(2440), 1,
      anon_sym_function,
    ACTIONS(2442), 1,
      anon_sym_declare,
    ACTIONS(2513), 1,
      anon_sym_module,
    ACTIONS(2515), 1,
      anon_sym_global,
    STATE(819), 1,
      sym_declaration,
    STATE(831), 1,
      sym_internal_module,
    STATE(1202), 1,
      sym_decorator,
    STATE(3090), 1,
      sym_comment,
    STATE(4313), 1,
      aux_sym_export_statement_repeat1,
    STATE(829), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [137725] = 24,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2364), 1,
      anon_sym_import,
    ACTIONS(2368), 1,
      anon_sym_let,
    ACTIONS(2370), 1,
      anon_sym_const,
    ACTIONS(2372), 1,
      anon_sym_class,
    ACTIONS(2382), 1,
      anon_sym_abstract,
    ACTIONS(2384), 1,
      anon_sym_interface,
    ACTIONS(2386), 1,
      anon_sym_enum,
    ACTIONS(2408), 1,
      anon_sym_type,
    ACTIONS(2434), 1,
      anon_sym_namespace,
    ACTIONS(2436), 1,
      anon_sym_var,
    ACTIONS(2438), 1,
      anon_sym_async,
    ACTIONS(2440), 1,
      anon_sym_function,
    ACTIONS(2442), 1,
      anon_sym_declare,
    ACTIONS(2444), 1,
      anon_sym_module,
    ACTIONS(6530), 1,
      anon_sym_default,
    STATE(798), 1,
      sym_declaration,
    STATE(831), 1,
      sym_internal_module,
    STATE(1202), 1,
      sym_decorator,
    STATE(3091), 1,
      sym_comment,
    STATE(4313), 1,
      aux_sym_export_statement_repeat1,
    STATE(829), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [137810] = 24,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2436), 1,
      anon_sym_var,
    ACTIONS(2456), 1,
      anon_sym_namespace,
    ACTIONS(2458), 1,
      anon_sym_import,
    ACTIONS(2460), 1,
      anon_sym_let,
    ACTIONS(2462), 1,
      anon_sym_const,
    ACTIONS(2464), 1,
      anon_sym_class,
    ACTIONS(2466), 1,
      anon_sym_async,
    ACTIONS(2468), 1,
      anon_sym_function,
    ACTIONS(2470), 1,
      anon_sym_declare,
    ACTIONS(2472), 1,
      anon_sym_module,
    ACTIONS(2474), 1,
      anon_sym_abstract,
    ACTIONS(2476), 1,
      anon_sym_interface,
    ACTIONS(2478), 1,
      anon_sym_enum,
    ACTIONS(2497), 1,
      anon_sym_type,
    ACTIONS(6532), 1,
      anon_sym_default,
    STATE(1202), 1,
      sym_decorator,
    STATE(2937), 1,
      sym_declaration,
    STATE(3020), 1,
      sym_internal_module,
    STATE(3092), 1,
      sym_comment,
    STATE(4344), 1,
      aux_sym_export_statement_repeat1,
    STATE(2949), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [137895] = 24,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2544), 1,
      anon_sym_type,
    ACTIONS(2546), 1,
      anon_sym_namespace,
    ACTIONS(2548), 1,
      anon_sym_import,
    ACTIONS(2550), 1,
      anon_sym_var,
    ACTIONS(2552), 1,
      anon_sym_let,
    ACTIONS(2554), 1,
      anon_sym_const,
    ACTIONS(2556), 1,
      anon_sym_class,
    ACTIONS(2558), 1,
      anon_sym_async,
    ACTIONS(2560), 1,
      anon_sym_function,
    ACTIONS(2562), 1,
      anon_sym_declare,
    ACTIONS(2564), 1,
      anon_sym_module,
    ACTIONS(2566), 1,
      anon_sym_abstract,
    ACTIONS(2568), 1,
      anon_sym_global,
    ACTIONS(2570), 1,
      anon_sym_interface,
    ACTIONS(2572), 1,
      anon_sym_enum,
    STATE(1202), 1,
      sym_decorator,
    STATE(3093), 1,
      sym_comment,
    STATE(4243), 1,
      aux_sym_export_statement_repeat1,
    STATE(4277), 1,
      sym_internal_module,
    STATE(4286), 1,
      sym_declaration,
    STATE(4205), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [137980] = 24,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2360), 1,
      anon_sym_namespace,
    ACTIONS(2364), 1,
      anon_sym_import,
    ACTIONS(2366), 1,
      anon_sym_var,
    ACTIONS(2368), 1,
      anon_sym_let,
    ACTIONS(2370), 1,
      anon_sym_const,
    ACTIONS(2372), 1,
      anon_sym_class,
    ACTIONS(2374), 1,
      anon_sym_async,
    ACTIONS(2376), 1,
      anon_sym_function,
    ACTIONS(2378), 1,
      anon_sym_declare,
    ACTIONS(2382), 1,
      anon_sym_abstract,
    ACTIONS(2384), 1,
      anon_sym_interface,
    ACTIONS(2386), 1,
      anon_sym_enum,
    ACTIONS(2408), 1,
      anon_sym_type,
    ACTIONS(2410), 1,
      anon_sym_module,
    ACTIONS(2412), 1,
      anon_sym_global,
    STATE(819), 1,
      sym_declaration,
    STATE(831), 1,
      sym_internal_module,
    STATE(1202), 1,
      sym_decorator,
    STATE(3094), 1,
      sym_comment,
    STATE(4313), 1,
      aux_sym_export_statement_repeat1,
    STATE(829), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [138065] = 24,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(2360), 1,
      anon_sym_namespace,
    ACTIONS(2364), 1,
      anon_sym_import,
    ACTIONS(2366), 1,
      anon_sym_var,
    ACTIONS(2368), 1,
      anon_sym_let,
    ACTIONS(2370), 1,
      anon_sym_const,
    ACTIONS(2372), 1,
      anon_sym_class,
    ACTIONS(2374), 1,
      anon_sym_async,
    ACTIONS(2376), 1,
      anon_sym_function,
    ACTIONS(2378), 1,
      anon_sym_declare,
    ACTIONS(2380), 1,
      anon_sym_module,
    ACTIONS(2382), 1,
      anon_sym_abstract,
    ACTIONS(2384), 1,
      anon_sym_interface,
    ACTIONS(2386), 1,
      anon_sym_enum,
    ACTIONS(2408), 1,
      anon_sym_type,
    ACTIONS(6534), 1,
      anon_sym_default,
    STATE(798), 1,
      sym_declaration,
    STATE(831), 1,
      sym_internal_module,
    STATE(1202), 1,
      sym_decorator,
    STATE(3095), 1,
      sym_comment,
    STATE(4313), 1,
      aux_sym_export_statement_repeat1,
    STATE(829), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [138150] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(6536), 1,
      sym_identifier,
    STATE(3096), 1,
      sym_comment,
    STATE(4019), 1,
      sym_ui_nested_identifier,
    STATE(4202), 1,
      sym_string,
    ACTIONS(6538), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [138205] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6542), 1,
      anon_sym_AT,
    STATE(3097), 1,
      sym_comment,
    ACTIONS(6540), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_import,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_pragma,
  [138251] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6546), 1,
      anon_sym_AT,
    STATE(3098), 1,
      sym_comment,
    ACTIONS(6544), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_import,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_pragma,
  [138297] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6550), 1,
      anon_sym_AT,
    STATE(3099), 1,
      sym_comment,
    ACTIONS(6548), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_import,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_pragma,
  [138343] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6552), 1,
      sym_identifier,
    STATE(3100), 1,
      sym_comment,
    STATE(5413), 1,
      sym_ui_nested_identifier,
    ACTIONS(6556), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(6554), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [138393] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6560), 1,
      anon_sym_AT,
    STATE(3101), 1,
      sym_comment,
    ACTIONS(6558), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_import,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_pragma,
  [138439] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6564), 1,
      anon_sym_AT,
    STATE(3102), 1,
      sym_comment,
    ACTIONS(6562), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_import,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_pragma,
  [138485] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6568), 1,
      anon_sym_AT,
    STATE(3103), 1,
      sym_comment,
    ACTIONS(6566), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_import,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_pragma,
  [138531] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6572), 1,
      anon_sym_AT,
    STATE(3104), 1,
      sym_comment,
    ACTIONS(6570), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_import,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_pragma,
  [138577] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6576), 1,
      anon_sym_AT,
    STATE(3105), 1,
      sym_comment,
    ACTIONS(6574), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_import,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_pragma,
  [138623] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6580), 1,
      anon_sym_AT,
    STATE(3106), 1,
      sym_comment,
    ACTIONS(6578), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_import,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_pragma,
  [138669] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6584), 1,
      anon_sym_AT,
    STATE(3107), 1,
      sym_comment,
    ACTIONS(6582), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_import,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_pragma,
  [138715] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6572), 1,
      anon_sym_AT,
    STATE(3108), 1,
      sym_comment,
    ACTIONS(6570), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_import,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_pragma,
  [138761] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6588), 1,
      anon_sym_AT,
    STATE(3109), 1,
      sym_comment,
    ACTIONS(6586), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_import,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_pragma,
  [138807] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6592), 1,
      anon_sym_AT,
    STATE(3110), 1,
      sym_comment,
    ACTIONS(6590), 31,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_import,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_pragma,
  [138853] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3111), 1,
      sym_comment,
    STATE(5505), 1,
      sym_ui_nested_identifier,
    STATE(5648), 1,
      sym_ui_object_definition,
    ACTIONS(11), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [138902] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3064), 1,
      sym_ui_object_definition,
    STATE(3112), 1,
      sym_comment,
    STATE(5505), 1,
      sym_ui_nested_identifier,
    ACTIONS(11), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [138951] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6594), 1,
      sym_identifier,
    STATE(3113), 1,
      sym_comment,
    STATE(5983), 1,
      sym_mapped_type_clause,
    ACTIONS(6596), 29,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_new,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [138998] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6598), 1,
      sym_identifier,
    STATE(3114), 1,
      sym_comment,
    STATE(5387), 1,
      sym_ui_nested_identifier,
    ACTIONS(6600), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [139044] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6602), 1,
      sym_identifier,
    ACTIONS(6606), 1,
      anon_sym_DOT,
    STATE(3115), 1,
      sym_comment,
    ACTIONS(6604), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [139090] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6552), 1,
      sym_identifier,
    STATE(3116), 1,
      sym_comment,
    STATE(5413), 1,
      sym_ui_nested_identifier,
    ACTIONS(6554), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [139136] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6606), 1,
      anon_sym_DOT,
    ACTIONS(6608), 1,
      sym_identifier,
    STATE(3117), 1,
      sym_comment,
    ACTIONS(6610), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [139182] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3118), 1,
      sym_comment,
    ACTIONS(6612), 29,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [139223] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3119), 1,
      sym_comment,
    ACTIONS(6614), 29,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [139264] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6616), 1,
      sym_identifier,
    STATE(3120), 1,
      sym_comment,
    ACTIONS(6618), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [139307] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6620), 1,
      sym_identifier,
    STATE(3121), 1,
      sym_comment,
    ACTIONS(6622), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_let,
      anon_sym_of,
      anon_sym_async,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [139350] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3122), 1,
      sym_comment,
    ACTIONS(3686), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3688), 19,
      anon_sym_export,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_abstract,
      anon_sym_extends,
  [139385] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3123), 1,
      sym_comment,
    ACTIONS(3678), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3680), 19,
      anon_sym_export,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_abstract,
      anon_sym_extends,
  [139420] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3124), 1,
      sym_comment,
    ACTIONS(3682), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3684), 19,
      anon_sym_export,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_abstract,
      anon_sym_extends,
  [139455] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3814), 1,
      anon_sym_LPAREN,
    ACTIONS(3816), 1,
      anon_sym_DOT,
    ACTIONS(3818), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6624), 1,
      anon_sym_LT,
    STATE(3125), 1,
      sym_comment,
    STATE(3174), 1,
      sym_arguments,
    STATE(3263), 1,
      sym_type_arguments,
    ACTIONS(3806), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3796), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [139501] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3814), 1,
      anon_sym_LPAREN,
    ACTIONS(6624), 1,
      anon_sym_LT,
    ACTIONS(6626), 1,
      anon_sym_DOT,
    ACTIONS(6628), 1,
      anon_sym_QMARK_DOT,
    STATE(3126), 1,
      sym_comment,
    STATE(3173), 1,
      sym_arguments,
    STATE(3269), 1,
      sym_type_arguments,
    ACTIONS(4623), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4625), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [139547] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1850), 1,
      anon_sym_EQ,
    STATE(3127), 1,
      sym_comment,
    ACTIONS(1852), 19,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_from,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_extends,
  [139581] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1858), 1,
      anon_sym_EQ,
    STATE(3128), 1,
      sym_comment,
    ACTIONS(1860), 19,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_from,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_extends,
  [139615] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3814), 1,
      anon_sym_LPAREN,
    ACTIONS(6624), 1,
      anon_sym_LT,
    ACTIONS(6630), 1,
      anon_sym_DOT,
    ACTIONS(6632), 1,
      anon_sym_QMARK_DOT,
    STATE(3129), 1,
      sym_comment,
    STATE(3170), 1,
      sym_arguments,
    STATE(3270), 1,
      sym_type_arguments,
    ACTIONS(4633), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4635), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [139661] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3130), 1,
      sym_comment,
    ACTIONS(5108), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5110), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [139694] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3131), 1,
      sym_comment,
    ACTIONS(4996), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4998), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [139727] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3132), 1,
      sym_comment,
    ACTIONS(4980), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4982), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [139760] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3133), 1,
      sym_comment,
    ACTIONS(5056), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5058), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [139793] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3134), 1,
      sym_comment,
    ACTIONS(4984), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4986), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [139826] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3135), 1,
      sym_comment,
    ACTIONS(4988), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4990), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [139859] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3136), 1,
      sym_comment,
    ACTIONS(5062), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5064), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [139892] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3137), 1,
      sym_comment,
    ACTIONS(4984), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4986), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [139925] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3138), 1,
      sym_comment,
    ACTIONS(5062), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5064), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [139958] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3139), 1,
      sym_comment,
    ACTIONS(4972), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4974), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [139991] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3140), 1,
      sym_comment,
    ACTIONS(4976), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4978), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [140024] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3141), 1,
      sym_comment,
    ACTIONS(4988), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4990), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [140057] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3142), 1,
      sym_comment,
    ACTIONS(4980), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4982), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [140090] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3143), 1,
      sym_comment,
    ACTIONS(5062), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5064), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [140123] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3144), 1,
      sym_comment,
    ACTIONS(5066), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5068), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [140156] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3145), 1,
      sym_comment,
    ACTIONS(5066), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5068), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [140189] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3146), 1,
      sym_comment,
    ACTIONS(5066), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5068), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [140222] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3147), 1,
      sym_comment,
    ACTIONS(5056), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5058), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [140255] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3148), 1,
      sym_comment,
    ACTIONS(5034), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5036), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [140288] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3149), 1,
      sym_comment,
    ACTIONS(5090), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5092), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [140321] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3150), 1,
      sym_comment,
    ACTIONS(5002), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5004), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [140354] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3151), 1,
      sym_comment,
    ACTIONS(5086), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5088), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [140387] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3152), 1,
      sym_comment,
    ACTIONS(4996), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4998), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [140420] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3153), 1,
      sym_comment,
    ACTIONS(5090), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5092), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [140453] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3154), 1,
      sym_comment,
    ACTIONS(5002), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5004), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [140486] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3155), 1,
      sym_comment,
    ACTIONS(5056), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5058), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [140519] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3156), 1,
      sym_comment,
    ACTIONS(5108), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5110), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [140552] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3157), 1,
      sym_comment,
    ACTIONS(5108), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5110), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [140585] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1850), 1,
      anon_sym_PIPE,
    STATE(3158), 1,
      sym_comment,
    ACTIONS(1852), 18,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_with,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
      aux_sym_ui_version_specifier_token1,
  [140618] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3159), 1,
      sym_comment,
    ACTIONS(5094), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5096), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [140651] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3160), 1,
      sym_comment,
    ACTIONS(5094), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5096), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [140684] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3161), 1,
      sym_comment,
    ACTIONS(5094), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5096), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [140717] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3162), 1,
      sym_comment,
    ACTIONS(5090), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5092), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [140750] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3163), 1,
      sym_comment,
    ACTIONS(4968), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4970), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [140783] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3164), 1,
      sym_comment,
    ACTIONS(4976), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4978), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [140816] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1858), 1,
      anon_sym_PIPE,
    STATE(3165), 1,
      sym_comment,
    ACTIONS(1860), 18,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_with,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
      aux_sym_ui_version_specifier_token1,
  [140849] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(6634), 1,
      sym_identifier,
    ACTIONS(6636), 1,
      anon_sym_STAR,
    ACTIONS(6638), 1,
      anon_sym_type,
    ACTIONS(6640), 1,
      anon_sym_LBRACE,
    ACTIONS(6642), 1,
      anon_sym_typeof,
    STATE(3166), 1,
      sym_comment,
    STATE(4848), 1,
      sym_import_require_clause,
    STATE(4850), 1,
      sym_string,
    STATE(5564), 1,
      sym__import_identifier,
    STATE(5789), 1,
      sym_import_clause,
    STATE(6231), 2,
      sym_namespace_import,
      sym_named_imports,
    ACTIONS(6644), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT,
      anon_sym_BQUOTE,
  [140903] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4653), 1,
      anon_sym_EQ,
    ACTIONS(6606), 1,
      anon_sym_DOT,
    ACTIONS(6624), 1,
      anon_sym_LT,
    ACTIONS(6646), 1,
      anon_sym_is,
    STATE(3167), 1,
      sym_comment,
    STATE(3240), 1,
      sym_type_arguments,
    ACTIONS(3842), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [140943] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(6636), 1,
      anon_sym_STAR,
    ACTIONS(6640), 1,
      anon_sym_LBRACE,
    ACTIONS(6648), 1,
      sym_identifier,
    ACTIONS(6650), 1,
      anon_sym_type,
    ACTIONS(6652), 1,
      anon_sym_typeof,
    STATE(3168), 1,
      sym_comment,
    STATE(4747), 1,
      sym_string,
    STATE(4748), 1,
      sym_import_require_clause,
    STATE(5563), 1,
      sym_import_clause,
    STATE(5564), 1,
      sym__import_identifier,
    STATE(6231), 2,
      sym_namespace_import,
      sym_named_imports,
    ACTIONS(6644), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT,
      anon_sym_BQUOTE,
  [140997] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3798), 1,
      anon_sym_LPAREN,
    ACTIONS(4623), 1,
      anon_sym_PIPE,
    ACTIONS(6654), 1,
      anon_sym_DOT,
    ACTIONS(6656), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6658), 1,
      anon_sym_LT,
    STATE(3169), 1,
      sym_comment,
    STATE(3393), 1,
      sym_arguments,
    STATE(3516), 1,
      sym_type_arguments,
    ACTIONS(4625), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [141040] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3170), 1,
      sym_comment,
    ACTIONS(4900), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4902), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [141071] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3798), 1,
      anon_sym_LPAREN,
    ACTIONS(4633), 1,
      anon_sym_PIPE,
    ACTIONS(6658), 1,
      anon_sym_LT,
    ACTIONS(6660), 1,
      anon_sym_DOT,
    ACTIONS(6662), 1,
      anon_sym_QMARK_DOT,
    STATE(3171), 1,
      sym_comment,
    STATE(3400), 1,
      sym_arguments,
    STATE(3518), 1,
      sym_type_arguments,
    ACTIONS(4635), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [141114] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4653), 1,
      anon_sym_EQ,
    ACTIONS(6606), 1,
      anon_sym_DOT,
    ACTIONS(6624), 1,
      anon_sym_LT,
    STATE(3172), 1,
      sym_comment,
    STATE(3240), 1,
      sym_type_arguments,
    ACTIONS(3842), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [141151] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3173), 1,
      sym_comment,
    ACTIONS(4888), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4890), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [141182] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3174), 1,
      sym_comment,
    ACTIONS(4779), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4781), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [141213] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3798), 1,
      anon_sym_LPAREN,
    ACTIONS(3800), 1,
      anon_sym_DOT,
    ACTIONS(3804), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3806), 1,
      anon_sym_PIPE,
    ACTIONS(6658), 1,
      anon_sym_LT,
    STATE(3175), 1,
      sym_comment,
    STATE(3362), 1,
      sym_arguments,
    STATE(3511), 1,
      sym_type_arguments,
    ACTIONS(3796), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [141256] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6664), 1,
      anon_sym_DOT,
    ACTIONS(6666), 1,
      anon_sym_QMARK_DOT,
    STATE(3176), 1,
      sym_comment,
    ACTIONS(4815), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4817), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [141291] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4683), 1,
      anon_sym_EQ,
    STATE(3177), 1,
      sym_comment,
    ACTIONS(4685), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_is,
  [141321] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4659), 1,
      anon_sym_EQ,
    ACTIONS(6624), 1,
      anon_sym_LT,
    STATE(3178), 1,
      sym_comment,
    STATE(3283), 1,
      sym_type_arguments,
    ACTIONS(4661), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [141355] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1711), 1,
      anon_sym_EQ,
    STATE(3179), 1,
      sym_comment,
    ACTIONS(1709), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_is,
  [141385] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4665), 1,
      anon_sym_EQ,
    ACTIONS(6646), 1,
      anon_sym_is,
    STATE(3180), 1,
      sym_comment,
    ACTIONS(4667), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [141416] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5056), 1,
      anon_sym_PIPE,
    STATE(3181), 1,
      sym_comment,
    ACTIONS(5058), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [141445] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3182), 1,
      sym_comment,
    ACTIONS(6668), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [141472] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(6672), 1,
      sym_number,
    ACTIONS(6674), 1,
      anon_sym_unique,
    STATE(3183), 1,
      sym_comment,
    STATE(6138), 1,
      sym_string,
    STATE(6139), 1,
      sym_predefined_type,
    ACTIONS(6670), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [141511] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(6674), 1,
      anon_sym_unique,
    ACTIONS(6676), 1,
      sym_number,
    STATE(3184), 1,
      sym_comment,
    STATE(6288), 1,
      sym_string,
    STATE(6289), 1,
      sym_predefined_type,
    ACTIONS(6670), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [141550] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(6674), 1,
      anon_sym_unique,
    ACTIONS(6678), 1,
      sym_number,
    STATE(3185), 1,
      sym_comment,
    STATE(6135), 1,
      sym_string,
    STATE(6136), 1,
      sym_predefined_type,
    ACTIONS(6670), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [141589] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4821), 1,
      anon_sym_EQ,
    STATE(3186), 1,
      sym_comment,
    ACTIONS(4823), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [141618] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(6674), 1,
      anon_sym_unique,
    ACTIONS(6680), 1,
      sym_number,
    STATE(3187), 1,
      sym_comment,
    STATE(6157), 1,
      sym_string,
    STATE(6158), 1,
      sym_predefined_type,
    ACTIONS(6670), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [141657] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3188), 1,
      sym_comment,
    ACTIONS(6682), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [141684] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3189), 1,
      sym_comment,
    ACTIONS(6684), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [141711] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4801), 1,
      anon_sym_EQ,
    STATE(3190), 1,
      sym_comment,
    ACTIONS(4803), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [141740] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6686), 1,
      anon_sym_LPAREN,
    ACTIONS(6688), 1,
      anon_sym_DOT,
    ACTIONS(6690), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6692), 1,
      anon_sym_LT,
    STATE(3191), 1,
      sym_comment,
    STATE(3515), 1,
      sym_arguments,
    STATE(3595), 1,
      sym_type_arguments,
    ACTIONS(4635), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [141779] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5108), 1,
      anon_sym_PIPE,
    STATE(3192), 1,
      sym_comment,
    ACTIONS(5110), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [141808] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5108), 1,
      anon_sym_PIPE,
    STATE(3193), 1,
      sym_comment,
    ACTIONS(5110), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [141837] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5108), 1,
      anon_sym_PIPE,
    STATE(3194), 1,
      sym_comment,
    ACTIONS(5110), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [141866] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6686), 1,
      anon_sym_LPAREN,
    ACTIONS(6692), 1,
      anon_sym_LT,
    ACTIONS(6694), 1,
      anon_sym_DOT,
    ACTIONS(6696), 1,
      anon_sym_QMARK_DOT,
    STATE(3195), 1,
      sym_comment,
    STATE(3473), 1,
      sym_arguments,
    STATE(3593), 1,
      sym_type_arguments,
    ACTIONS(4625), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [141905] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6686), 1,
      anon_sym_LPAREN,
    ACTIONS(6692), 1,
      anon_sym_LT,
    ACTIONS(6698), 1,
      anon_sym_DOT,
    ACTIONS(6700), 1,
      anon_sym_QMARK_DOT,
    STATE(3196), 1,
      sym_comment,
    STATE(3469), 1,
      sym_arguments,
    STATE(3592), 1,
      sym_type_arguments,
    ACTIONS(3796), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [141944] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5094), 1,
      anon_sym_PIPE,
    STATE(3197), 1,
      sym_comment,
    ACTIONS(5096), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [141973] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4653), 1,
      anon_sym_PIPE,
    ACTIONS(6658), 1,
      anon_sym_LT,
    ACTIONS(6702), 1,
      anon_sym_DOT,
    ACTIONS(6704), 1,
      anon_sym_is,
    STATE(3198), 1,
      sym_comment,
    STATE(3502), 1,
      sym_type_arguments,
    ACTIONS(3842), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [142010] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5094), 1,
      anon_sym_PIPE,
    STATE(3199), 1,
      sym_comment,
    ACTIONS(5096), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [142039] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5094), 1,
      anon_sym_PIPE,
    STATE(3200), 1,
      sym_comment,
    ACTIONS(5096), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [142068] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5090), 1,
      anon_sym_PIPE,
    STATE(3201), 1,
      sym_comment,
    ACTIONS(5092), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [142097] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5090), 1,
      anon_sym_PIPE,
    STATE(3202), 1,
      sym_comment,
    ACTIONS(5092), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [142126] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5090), 1,
      anon_sym_PIPE,
    STATE(3203), 1,
      sym_comment,
    ACTIONS(5092), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [142155] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5082), 1,
      anon_sym_EQ,
    STATE(3204), 1,
      sym_comment,
    ACTIONS(5084), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [142184] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5074), 1,
      anon_sym_EQ,
    STATE(3205), 1,
      sym_comment,
    ACTIONS(5076), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [142213] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5086), 1,
      anon_sym_PIPE,
    STATE(3206), 1,
      sym_comment,
    ACTIONS(5088), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [142242] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5070), 1,
      anon_sym_EQ,
    STATE(3207), 1,
      sym_comment,
    ACTIONS(5072), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [142271] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4659), 1,
      anon_sym_EQ,
    ACTIONS(6706), 1,
      anon_sym_is,
    STATE(3208), 1,
      sym_comment,
    ACTIONS(4661), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [142302] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5022), 1,
      anon_sym_EQ,
    STATE(3209), 1,
      sym_comment,
    ACTIONS(5024), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [142331] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5018), 1,
      anon_sym_EQ,
    STATE(3210), 1,
      sym_comment,
    ACTIONS(5020), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [142360] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5112), 1,
      anon_sym_EQ,
    STATE(3211), 1,
      sym_comment,
    ACTIONS(5114), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [142389] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4795), 1,
      anon_sym_EQ,
    STATE(3212), 1,
      sym_comment,
    ACTIONS(4797), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [142418] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4825), 1,
      anon_sym_EQ,
    STATE(3213), 1,
      sym_comment,
    ACTIONS(4827), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [142447] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(6674), 1,
      anon_sym_unique,
    ACTIONS(6708), 1,
      sym_number,
    STATE(3214), 1,
      sym_comment,
    STATE(6221), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(6670), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [142484] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4659), 1,
      anon_sym_EQ,
    STATE(3215), 1,
      sym_comment,
    ACTIONS(4661), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [142513] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(6674), 1,
      anon_sym_unique,
    ACTIONS(6710), 1,
      sym_number,
    STATE(3216), 1,
      sym_comment,
    STATE(6224), 1,
      sym_string,
    STATE(6225), 1,
      sym_predefined_type,
    ACTIONS(6670), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [142552] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5066), 1,
      anon_sym_PIPE,
    STATE(3217), 1,
      sym_comment,
    ACTIONS(5068), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [142581] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5066), 1,
      anon_sym_PIPE,
    STATE(3218), 1,
      sym_comment,
    ACTIONS(5068), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [142610] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5066), 1,
      anon_sym_PIPE,
    STATE(3219), 1,
      sym_comment,
    ACTIONS(5068), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [142639] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5062), 1,
      anon_sym_PIPE,
    STATE(3220), 1,
      sym_comment,
    ACTIONS(5064), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [142668] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5062), 1,
      anon_sym_PIPE,
    STATE(3221), 1,
      sym_comment,
    ACTIONS(5064), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [142697] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5062), 1,
      anon_sym_PIPE,
    STATE(3222), 1,
      sym_comment,
    ACTIONS(5064), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [142726] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3223), 1,
      sym_comment,
    ACTIONS(6712), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [142753] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5056), 1,
      anon_sym_PIPE,
    STATE(3224), 1,
      sym_comment,
    ACTIONS(5058), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [142782] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5056), 1,
      anon_sym_PIPE,
    STATE(3225), 1,
      sym_comment,
    ACTIONS(5058), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [142811] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(6674), 1,
      anon_sym_unique,
    ACTIONS(6714), 1,
      sym_number,
    STATE(3226), 1,
      sym_comment,
    STATE(6250), 1,
      sym_string,
    STATE(6284), 1,
      sym_predefined_type,
    ACTIONS(6670), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [142850] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5034), 1,
      anon_sym_PIPE,
    STATE(3227), 1,
      sym_comment,
    ACTIONS(5036), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [142879] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4795), 1,
      anon_sym_EQ,
    ACTIONS(6716), 1,
      anon_sym_LBRACK,
    STATE(3228), 1,
      sym_comment,
    ACTIONS(4797), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [142910] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5010), 1,
      anon_sym_EQ,
    STATE(3229), 1,
      sym_comment,
    ACTIONS(5012), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [142939] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4829), 1,
      anon_sym_EQ,
    STATE(3230), 1,
      sym_comment,
    ACTIONS(4831), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [142968] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(6674), 1,
      anon_sym_unique,
    ACTIONS(6718), 1,
      sym_number,
    STATE(3231), 1,
      sym_comment,
    STATE(6130), 1,
      sym_string,
    STATE(6232), 1,
      sym_predefined_type,
    ACTIONS(6670), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [143007] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5006), 1,
      anon_sym_EQ,
    STATE(3232), 1,
      sym_comment,
    ACTIONS(5008), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [143036] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4665), 1,
      anon_sym_EQ,
    STATE(3233), 1,
      sym_comment,
    ACTIONS(4667), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [143065] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_EQ,
    STATE(3234), 1,
      sym_comment,
    ACTIONS(4793), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [143094] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4789), 1,
      anon_sym_EQ,
    STATE(3235), 1,
      sym_comment,
    ACTIONS(4787), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [143123] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4839), 1,
      anon_sym_EQ,
    STATE(3236), 1,
      sym_comment,
    ACTIONS(4841), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [143152] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3237), 1,
      sym_comment,
    ACTIONS(6720), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [143179] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4783), 1,
      anon_sym_EQ,
    STATE(3238), 1,
      sym_comment,
    ACTIONS(4785), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [143208] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(6674), 1,
      anon_sym_unique,
    ACTIONS(6722), 1,
      sym_number,
    STATE(3239), 1,
      sym_comment,
    STATE(6132), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(6670), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [143245] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4843), 1,
      anon_sym_EQ,
    STATE(3240), 1,
      sym_comment,
    ACTIONS(4845), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [143274] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(6674), 1,
      anon_sym_unique,
    ACTIONS(6724), 1,
      sym_number,
    STATE(3241), 1,
      sym_comment,
    STATE(6078), 1,
      sym_string,
    STATE(6079), 1,
      sym_predefined_type,
    ACTIONS(6670), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [143313] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3242), 1,
      sym_comment,
    ACTIONS(6726), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [143340] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(6674), 1,
      anon_sym_unique,
    ACTIONS(6728), 1,
      sym_number,
    STATE(3243), 1,
      sym_comment,
    STATE(6226), 1,
      sym_predefined_type,
    STATE(6228), 1,
      sym_string,
    ACTIONS(6670), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [143379] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(6674), 1,
      anon_sym_unique,
    ACTIONS(6730), 1,
      sym_number,
    STATE(3244), 1,
      sym_comment,
    STATE(5961), 1,
      sym_predefined_type,
    STATE(5962), 1,
      sym_string,
    ACTIONS(6670), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [143418] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3245), 1,
      sym_comment,
    ACTIONS(6732), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [143445] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3246), 1,
      sym_comment,
    ACTIONS(6734), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [143472] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(6674), 1,
      anon_sym_unique,
    ACTIONS(6736), 1,
      sym_number,
    STATE(3247), 1,
      sym_comment,
    STATE(6236), 1,
      sym_predefined_type,
    STATE(6242), 1,
      sym_string,
    ACTIONS(6670), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [143511] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5002), 1,
      anon_sym_PIPE,
    STATE(3248), 1,
      sym_comment,
    ACTIONS(5004), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [143540] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4996), 1,
      anon_sym_PIPE,
    STATE(3249), 1,
      sym_comment,
    ACTIONS(4998), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [143569] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5002), 1,
      anon_sym_PIPE,
    STATE(3250), 1,
      sym_comment,
    ACTIONS(5004), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [143598] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4996), 1,
      anon_sym_PIPE,
    STATE(3251), 1,
      sym_comment,
    ACTIONS(4998), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [143627] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4988), 1,
      anon_sym_PIPE,
    STATE(3252), 1,
      sym_comment,
    ACTIONS(4990), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [143656] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4984), 1,
      anon_sym_PIPE,
    STATE(3253), 1,
      sym_comment,
    ACTIONS(4986), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [143685] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4988), 1,
      anon_sym_PIPE,
    STATE(3254), 1,
      sym_comment,
    ACTIONS(4990), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [143714] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4984), 1,
      anon_sym_PIPE,
    STATE(3255), 1,
      sym_comment,
    ACTIONS(4986), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [143743] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4980), 1,
      anon_sym_PIPE,
    STATE(3256), 1,
      sym_comment,
    ACTIONS(4982), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [143772] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4976), 1,
      anon_sym_PIPE,
    STATE(3257), 1,
      sym_comment,
    ACTIONS(4978), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [143801] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4980), 1,
      anon_sym_PIPE,
    STATE(3258), 1,
      sym_comment,
    ACTIONS(4982), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [143830] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4976), 1,
      anon_sym_PIPE,
    STATE(3259), 1,
      sym_comment,
    ACTIONS(4978), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [143859] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4972), 1,
      anon_sym_PIPE,
    STATE(3260), 1,
      sym_comment,
    ACTIONS(4974), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [143888] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4855), 1,
      anon_sym_EQ,
    ACTIONS(6716), 1,
      anon_sym_LBRACK,
    STATE(3261), 1,
      sym_comment,
    ACTIONS(4797), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(4857), 10,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [143921] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4968), 1,
      anon_sym_PIPE,
    STATE(3262), 1,
      sym_comment,
    ACTIONS(4970), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [143950] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4884), 1,
      anon_sym_EQ,
    STATE(3263), 1,
      sym_comment,
    ACTIONS(4886), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [143979] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(6674), 1,
      anon_sym_unique,
    ACTIONS(6738), 1,
      sym_number,
    STATE(3264), 1,
      sym_comment,
    STATE(6074), 1,
      sym_string,
    STATE(6080), 1,
      sym_predefined_type,
    ACTIONS(6670), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [144018] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(6674), 1,
      anon_sym_unique,
    ACTIONS(6740), 1,
      sym_number,
    STATE(3265), 1,
      sym_comment,
    STATE(5966), 1,
      sym_predefined_type,
    STATE(5967), 1,
      sym_string,
    ACTIONS(6670), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [144057] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(6674), 1,
      anon_sym_unique,
    ACTIONS(6742), 1,
      sym_number,
    STATE(3266), 1,
      sym_comment,
    STATE(6070), 1,
      sym_string,
    STATE(6072), 1,
      sym_predefined_type,
    ACTIONS(6670), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [144096] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(6674), 1,
      anon_sym_unique,
    ACTIONS(6744), 1,
      sym_number,
    STATE(3267), 1,
      sym_comment,
    STATE(6246), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(6670), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [144133] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(6674), 1,
      anon_sym_unique,
    ACTIONS(6746), 1,
      sym_number,
    STATE(3268), 1,
      sym_comment,
    STATE(6067), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(6670), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [144170] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4896), 1,
      anon_sym_EQ,
    STATE(3269), 1,
      sym_comment,
    ACTIONS(4898), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [144199] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4904), 1,
      anon_sym_EQ,
    STATE(3270), 1,
      sym_comment,
    ACTIONS(4906), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [144228] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3271), 1,
      sym_comment,
    ACTIONS(6748), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [144255] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(6674), 1,
      anon_sym_unique,
    ACTIONS(6750), 1,
      sym_number,
    STATE(3272), 1,
      sym_comment,
    STATE(5969), 1,
      sym_predefined_type,
    STATE(5971), 1,
      sym_string,
    ACTIONS(6670), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [144294] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4932), 1,
      anon_sym_EQ,
    STATE(3273), 1,
      sym_comment,
    ACTIONS(4934), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [144323] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4936), 1,
      anon_sym_EQ,
    STATE(3274), 1,
      sym_comment,
    ACTIONS(4938), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [144352] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(6674), 1,
      anon_sym_unique,
    ACTIONS(6752), 1,
      sym_number,
    STATE(3275), 1,
      sym_comment,
    STATE(5973), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(6670), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [144389] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4940), 1,
      anon_sym_EQ,
    STATE(3276), 1,
      sym_comment,
    ACTIONS(4942), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [144418] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4671), 1,
      anon_sym_EQ,
    STATE(3277), 1,
      sym_comment,
    ACTIONS(4673), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [144447] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4944), 1,
      anon_sym_EQ,
    STATE(3278), 1,
      sym_comment,
    ACTIONS(4946), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [144476] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4950), 1,
      anon_sym_EQ,
    STATE(3279), 1,
      sym_comment,
    ACTIONS(4952), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [144505] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4958), 1,
      anon_sym_EQ,
    STATE(3280), 1,
      sym_comment,
    ACTIONS(4960), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [144534] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4865), 1,
      anon_sym_EQ,
    ACTIONS(6716), 1,
      anon_sym_LBRACK,
    STATE(3281), 1,
      sym_comment,
    ACTIONS(4867), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [144565] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4671), 1,
      anon_sym_EQ,
    ACTIONS(6646), 1,
      anon_sym_is,
    STATE(3282), 1,
      sym_comment,
    ACTIONS(4673), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [144596] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4871), 1,
      anon_sym_EQ,
    STATE(3283), 1,
      sym_comment,
    ACTIONS(4873), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [144625] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4653), 1,
      anon_sym_PIPE,
    ACTIONS(6658), 1,
      anon_sym_LT,
    ACTIONS(6702), 1,
      anon_sym_DOT,
    STATE(3284), 1,
      sym_comment,
    STATE(3502), 1,
      sym_type_arguments,
    ACTIONS(3842), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [144659] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(128), 1,
      anon_sym_unique,
    STATE(3285), 1,
      sym_comment,
    STATE(3517), 1,
      sym_type_predicate,
    STATE(5978), 1,
      sym_predefined_type,
    ACTIONS(6754), 2,
      sym_identifier,
      sym_this,
    ACTIONS(130), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [144693] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(128), 1,
      anon_sym_unique,
    STATE(3286), 1,
      sym_comment,
    STATE(3616), 1,
      sym_type_predicate,
    STATE(6287), 1,
      sym_predefined_type,
    ACTIONS(6756), 2,
      sym_identifier,
      sym_this,
    ACTIONS(130), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [144727] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4833), 1,
      anon_sym_EQ,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    STATE(3287), 1,
      sym_comment,
    ACTIONS(4835), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [144757] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6764), 1,
      anon_sym_BANG,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(6770), 1,
      anon_sym_QMARK,
    STATE(3288), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4297), 1,
      sym_type_annotation,
    STATE(5326), 1,
      sym__initializer,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5902), 1,
      sym__call_signature,
    ACTIONS(6762), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [144805] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4319), 1,
      anon_sym_RBRACE,
    STATE(3289), 1,
      sym_comment,
    STATE(3872), 1,
      sym_formal_parameters,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5660), 1,
      sym_type_parameters,
    ACTIONS(4322), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [144849] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(6772), 1,
      anon_sym_BANG,
    ACTIONS(6774), 1,
      anon_sym_QMARK,
    STATE(3290), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4292), 1,
      sym_type_annotation,
    STATE(5341), 1,
      sym__initializer,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5916), 1,
      sym__call_signature,
    ACTIONS(6762), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [144897] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4338), 1,
      anon_sym_RBRACE,
    STATE(3291), 1,
      sym_comment,
    STATE(3872), 1,
      sym_formal_parameters,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5660), 1,
      sym_type_parameters,
    ACTIONS(4322), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [144941] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4344), 1,
      anon_sym_RBRACE,
    STATE(3292), 1,
      sym_comment,
    STATE(3872), 1,
      sym_formal_parameters,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5251), 1,
      aux_sym_object_repeat1,
    STATE(5660), 1,
      sym_type_parameters,
    ACTIONS(4322), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [144985] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4954), 1,
      anon_sym_EQ,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    STATE(3293), 1,
      sym_comment,
    ACTIONS(4956), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [145015] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4847), 1,
      anon_sym_EQ,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    STATE(3294), 1,
      sym_comment,
    ACTIONS(4849), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [145049] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(6782), 1,
      anon_sym_BANG,
    ACTIONS(6784), 1,
      anon_sym_QMARK,
    STATE(3295), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4669), 1,
      sym_type_annotation,
    STATE(5452), 1,
      sym__initializer,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5856), 1,
      sym__call_signature,
    ACTIONS(6780), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [145097] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4944), 1,
      anon_sym_EQ,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    STATE(3296), 1,
      sym_comment,
    ACTIONS(4946), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [145131] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(6788), 1,
      anon_sym_BANG,
    ACTIONS(6790), 1,
      anon_sym_QMARK,
    STATE(3297), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4540), 1,
      sym_type_annotation,
    STATE(5185), 1,
      sym__initializer,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5826), 1,
      sym__call_signature,
    ACTIONS(6786), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [145179] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(6794), 1,
      anon_sym_BANG,
    ACTIONS(6796), 1,
      anon_sym_LPAREN,
    ACTIONS(6798), 1,
      anon_sym_QMARK,
    STATE(3298), 1,
      sym_comment,
    STATE(3571), 1,
      sym_formal_parameters,
    STATE(4121), 1,
      sym__call_signature,
    STATE(4535), 1,
      sym_type_annotation,
    STATE(4878), 1,
      sym__initializer,
    STATE(5701), 1,
      sym_type_parameters,
    ACTIONS(6792), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [145227] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(6636), 1,
      anon_sym_STAR,
    ACTIONS(6640), 1,
      anon_sym_LBRACE,
    ACTIONS(6800), 1,
      sym_identifier,
    ACTIONS(6802), 1,
      anon_sym_type,
    ACTIONS(6804), 1,
      anon_sym_COMMA,
    ACTIONS(6806), 1,
      anon_sym_from,
    STATE(3299), 1,
      sym_comment,
    STATE(4800), 1,
      sym_string,
    STATE(4801), 1,
      sym_import_require_clause,
    STATE(5564), 1,
      sym__import_identifier,
    STATE(5626), 1,
      sym_import_clause,
    STATE(6231), 2,
      sym_namespace_import,
      sym_named_imports,
  [145277] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(6808), 1,
      anon_sym_BANG,
    ACTIONS(6810), 1,
      anon_sym_QMARK,
    STATE(3300), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4622), 1,
      sym_type_annotation,
    STATE(5244), 1,
      sym__initializer,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5859), 1,
      sym__call_signature,
    ACTIONS(6780), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [145325] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(6812), 1,
      anon_sym_BANG,
    ACTIONS(6814), 1,
      anon_sym_QMARK,
    STATE(3301), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4598), 1,
      sym_type_annotation,
    STATE(5218), 1,
      sym__initializer,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5912), 1,
      sym__call_signature,
    ACTIONS(6762), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [145373] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    STATE(3302), 1,
      sym_comment,
    STATE(2053), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4886), 10,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [145405] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(6816), 1,
      anon_sym_BANG,
    ACTIONS(6818), 1,
      anon_sym_QMARK,
    STATE(3303), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4636), 1,
      sym_type_annotation,
    STATE(5311), 1,
      sym__initializer,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5864), 1,
      sym__call_signature,
    ACTIONS(6780), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [145453] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(6820), 1,
      anon_sym_BANG,
    ACTIONS(6822), 1,
      anon_sym_QMARK,
    STATE(3304), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4662), 1,
      sym_type_annotation,
    STATE(5456), 1,
      sym__initializer,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5855), 1,
      sym__call_signature,
    ACTIONS(6780), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [145501] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5120), 1,
      anon_sym_EQ,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    STATE(3305), 1,
      sym_comment,
    ACTIONS(5122), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [145535] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(6796), 1,
      anon_sym_LPAREN,
    ACTIONS(6826), 1,
      anon_sym_BANG,
    ACTIONS(6828), 1,
      anon_sym_QMARK,
    STATE(3306), 1,
      sym_comment,
    STATE(3571), 1,
      sym_formal_parameters,
    STATE(4099), 1,
      sym__call_signature,
    STATE(4422), 1,
      sym_type_annotation,
    STATE(5028), 1,
      sym__initializer,
    STATE(5701), 1,
      sym_type_parameters,
    ACTIONS(6824), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [145583] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(6796), 1,
      anon_sym_LPAREN,
    ACTIONS(6832), 1,
      anon_sym_BANG,
    ACTIONS(6834), 1,
      anon_sym_QMARK,
    STATE(3307), 1,
      sym_comment,
    STATE(3571), 1,
      sym_formal_parameters,
    STATE(4170), 1,
      sym__call_signature,
    STATE(4542), 1,
      sym_type_annotation,
    STATE(4944), 1,
      sym__initializer,
    STATE(5701), 1,
      sym_type_parameters,
    ACTIONS(6830), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [145631] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(6836), 1,
      anon_sym_BANG,
    ACTIONS(6838), 1,
      anon_sym_QMARK,
    STATE(3308), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4644), 1,
      sym_type_annotation,
    STATE(5434), 1,
      sym__initializer,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5910), 1,
      sym__call_signature,
    ACTIONS(6762), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [145679] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(128), 1,
      anon_sym_unique,
    STATE(1829), 1,
      sym_type_predicate,
    STATE(3309), 1,
      sym_comment,
    STATE(6202), 1,
      sym_predefined_type,
    ACTIONS(6840), 2,
      sym_identifier,
      sym_this,
    ACTIONS(130), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [145713] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4332), 1,
      anon_sym_RBRACE,
    STATE(3310), 1,
      sym_comment,
    STATE(3872), 1,
      sym_formal_parameters,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5660), 1,
      sym_type_parameters,
    ACTIONS(4322), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [145757] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(6844), 1,
      anon_sym_BANG,
    ACTIONS(6846), 1,
      anon_sym_QMARK,
    STATE(3311), 1,
      sym_comment,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4610), 1,
      sym_type_annotation,
    STATE(5437), 1,
      sym__call_signature,
    STATE(5442), 1,
      sym__initializer,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(6842), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [145805] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4859), 1,
      anon_sym_EQ,
    ACTIONS(6848), 1,
      anon_sym_extends,
    STATE(3312), 1,
      sym_comment,
    ACTIONS(4861), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [145835] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(6794), 1,
      anon_sym_BANG,
    ACTIONS(6850), 1,
      anon_sym_QMARK,
    STATE(3313), 1,
      sym_comment,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4535), 1,
      sym_type_annotation,
    STATE(4872), 1,
      sym__initializer,
    STATE(4873), 1,
      sym__call_signature,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(6792), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [145883] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(6796), 1,
      anon_sym_LPAREN,
    ACTIONS(6854), 1,
      anon_sym_BANG,
    ACTIONS(6856), 1,
      anon_sym_QMARK,
    STATE(3314), 1,
      sym_comment,
    STATE(3571), 1,
      sym_formal_parameters,
    STATE(4193), 1,
      sym__call_signature,
    STATE(4315), 1,
      sym_type_annotation,
    STATE(5297), 1,
      sym__initializer,
    STATE(5701), 1,
      sym_type_parameters,
    ACTIONS(6852), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [145931] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(6860), 1,
      anon_sym_BANG,
    ACTIONS(6862), 1,
      anon_sym_QMARK,
    STATE(3315), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4511), 1,
      sym_type_annotation,
    STATE(4937), 1,
      sym__initializer,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5922), 1,
      sym__call_signature,
    ACTIONS(6858), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [145979] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(6864), 1,
      anon_sym_BANG,
    ACTIONS(6866), 1,
      anon_sym_QMARK,
    STATE(3316), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4367), 1,
      sym_type_annotation,
    STATE(5129), 1,
      sym__initializer,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5923), 1,
      sym__call_signature,
    ACTIONS(6858), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [146027] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(6868), 1,
      anon_sym_BANG,
    ACTIONS(6870), 1,
      anon_sym_QMARK,
    STATE(3317), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4370), 1,
      sym_type_annotation,
    STATE(5118), 1,
      sym__initializer,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5924), 1,
      sym__call_signature,
    ACTIONS(6858), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [146075] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(128), 1,
      anon_sym_unique,
    STATE(3277), 1,
      sym_type_predicate,
    STATE(3318), 1,
      sym_comment,
    STATE(5994), 1,
      sym_predefined_type,
    ACTIONS(6872), 2,
      sym_identifier,
      sym_this,
    ACTIONS(130), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [146109] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4341), 1,
      anon_sym_RBRACE,
    STATE(3319), 1,
      sym_comment,
    STATE(3872), 1,
      sym_formal_parameters,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5660), 1,
      sym_type_parameters,
    ACTIONS(4322), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [146153] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(6876), 1,
      anon_sym_BANG,
    ACTIONS(6878), 1,
      anon_sym_QMARK,
    STATE(3320), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4204), 1,
      sym_type_annotation,
    STATE(5493), 1,
      sym__initializer,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5901), 1,
      sym__call_signature,
    ACTIONS(6874), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [146201] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5014), 1,
      anon_sym_EQ,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    STATE(3321), 1,
      sym_comment,
    ACTIONS(5016), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [146235] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4335), 1,
      anon_sym_RBRACE,
    STATE(3322), 1,
      sym_comment,
    STATE(3872), 1,
      sym_formal_parameters,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5660), 1,
      sym_type_parameters,
    ACTIONS(4322), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [146279] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5030), 1,
      anon_sym_EQ,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    STATE(3323), 1,
      sym_comment,
    ACTIONS(5032), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [146313] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(6796), 1,
      anon_sym_LPAREN,
    ACTIONS(6844), 1,
      anon_sym_BANG,
    ACTIONS(6880), 1,
      anon_sym_QMARK,
    STATE(3324), 1,
      sym_comment,
    STATE(3571), 1,
      sym_formal_parameters,
    STATE(4145), 1,
      sym__call_signature,
    STATE(4610), 1,
      sym_type_annotation,
    STATE(5303), 1,
      sym__initializer,
    STATE(5701), 1,
      sym_type_parameters,
    ACTIONS(6842), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [146361] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(6636), 1,
      anon_sym_STAR,
    ACTIONS(6640), 1,
      anon_sym_LBRACE,
    ACTIONS(6800), 1,
      sym_identifier,
    ACTIONS(6802), 1,
      anon_sym_type,
    ACTIONS(6804), 1,
      anon_sym_COMMA,
    ACTIONS(6806), 1,
      anon_sym_from,
    STATE(3325), 1,
      sym_comment,
    STATE(4742), 1,
      sym_import_require_clause,
    STATE(4744), 1,
      sym_string,
    STATE(5564), 1,
      sym__import_identifier,
    STATE(5828), 1,
      sym_import_clause,
    STATE(6231), 2,
      sym_namespace_import,
      sym_named_imports,
  [146411] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(128), 1,
      anon_sym_unique,
    STATE(2412), 1,
      sym_type_predicate,
    STATE(3326), 1,
      sym_comment,
    STATE(6114), 1,
      sym_predefined_type,
    ACTIONS(6882), 2,
      sym_identifier,
      sym_this,
    ACTIONS(130), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [146445] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(128), 1,
      anon_sym_unique,
    STATE(3277), 1,
      sym_type_predicate,
    STATE(3327), 1,
      sym_comment,
    STATE(6091), 1,
      sym_predefined_type,
    ACTIONS(6884), 2,
      sym_identifier,
      sym_this,
    ACTIONS(130), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [146479] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(6886), 1,
      anon_sym_BANG,
    ACTIONS(6888), 1,
      anon_sym_QMARK,
    STATE(3328), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4495), 1,
      sym_type_annotation,
    STATE(4929), 1,
      sym__initializer,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5929), 1,
      sym__call_signature,
    ACTIONS(6858), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [146527] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(6890), 1,
      anon_sym_BANG,
    ACTIONS(6892), 1,
      anon_sym_QMARK,
    STATE(3329), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4407), 1,
      sym_type_annotation,
    STATE(5057), 1,
      sym__initializer,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5927), 1,
      sym__call_signature,
    ACTIONS(6858), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [146575] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(6894), 1,
      anon_sym_BANG,
    ACTIONS(6896), 1,
      anon_sym_QMARK,
    STATE(3330), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4403), 1,
      sym_type_annotation,
    STATE(5062), 1,
      sym__initializer,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5926), 1,
      sym__call_signature,
    ACTIONS(6858), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [146623] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5022), 1,
      anon_sym_EQ,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    STATE(3331), 1,
      sym_comment,
    ACTIONS(5024), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [146657] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5026), 1,
      anon_sym_EQ,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    STATE(3332), 1,
      sym_comment,
    ACTIONS(5028), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [146691] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3333), 1,
      sym_comment,
    ACTIONS(5096), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [146716] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3334), 1,
      sym_comment,
    ACTIONS(5096), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [146741] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4815), 1,
      anon_sym_PIPE,
    ACTIONS(6898), 1,
      anon_sym_DOT,
    ACTIONS(6900), 1,
      anon_sym_QMARK_DOT,
    STATE(3335), 1,
      sym_comment,
    ACTIONS(4817), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [146772] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3336), 1,
      sym_comment,
    ACTIONS(4982), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [146797] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3337), 1,
      sym_comment,
    ACTIONS(4986), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [146822] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3045), 1,
      anon_sym_PIPE,
    STATE(3338), 1,
      sym_comment,
    ACTIONS(3047), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [146849] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3686), 1,
      anon_sym_PIPE,
    STATE(3339), 1,
      sym_comment,
    ACTIONS(3688), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [146876] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3340), 1,
      sym_comment,
    ACTIONS(4998), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [146901] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3341), 1,
      sym_comment,
    ACTIONS(5064), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [146926] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(6904), 1,
      anon_sym_QMARK,
    STATE(3342), 1,
      sym_comment,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(3980), 1,
      sym__call_signature,
    STATE(4552), 1,
      sym_type_annotation,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(6902), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [146967] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3145), 1,
      anon_sym_PIPE,
    STATE(3343), 1,
      sym_comment,
    ACTIONS(3147), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [146994] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3123), 1,
      anon_sym_PIPE,
    STATE(3344), 1,
      sym_comment,
    ACTIONS(3125), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [147021] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(6908), 1,
      anon_sym_QMARK,
    STATE(3345), 1,
      sym_comment,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(3984), 1,
      sym__call_signature,
    STATE(4609), 1,
      sym_type_annotation,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(6906), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [147062] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3346), 1,
      sym_comment,
    ACTIONS(4978), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [147087] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(6912), 1,
      anon_sym_QMARK,
    STATE(3347), 1,
      sym_comment,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(3904), 1,
      sym__call_signature,
    STATE(4346), 1,
      sym_type_annotation,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(6910), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [147128] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3348), 1,
      sym_comment,
    ACTIONS(4982), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [147153] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3135), 1,
      anon_sym_PIPE,
    STATE(3349), 1,
      sym_comment,
    ACTIONS(3137), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [147180] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3159), 1,
      anon_sym_PIPE,
    STATE(3350), 1,
      sym_comment,
    ACTIONS(3161), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [147207] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3351), 1,
      sym_comment,
    ACTIONS(4978), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [147232] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6916), 1,
      anon_sym_COLON,
    ACTIONS(6918), 1,
      anon_sym_QMARK,
    STATE(3352), 1,
      sym_comment,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(3977), 1,
      sym__call_signature,
    STATE(4436), 1,
      sym_type_annotation,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(6914), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [147273] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3353), 1,
      sym_comment,
    ACTIONS(5110), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [147298] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3354), 1,
      sym_comment,
    ACTIONS(5058), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [147323] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3153), 1,
      anon_sym_PIPE,
    STATE(3355), 1,
      sym_comment,
    ACTIONS(3155), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [147350] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3678), 1,
      anon_sym_PIPE,
    STATE(3356), 1,
      sym_comment,
    ACTIONS(3680), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [147377] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3357), 1,
      sym_comment,
    ACTIONS(5110), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [147402] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4884), 1,
      anon_sym_PIPE,
    STATE(3358), 1,
      sym_comment,
    STATE(2053), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4886), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [147435] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(6920), 1,
      anon_sym_QMARK,
    STATE(3359), 1,
      sym_comment,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4434), 1,
      sym__call_signature,
    STATE(4436), 1,
      sym_type_annotation,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(6914), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [147476] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(6922), 1,
      anon_sym_QMARK,
    STATE(3360), 1,
      sym_comment,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4346), 1,
      sym_type_annotation,
    STATE(4347), 1,
      sym__call_signature,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(6910), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [147517] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3361), 1,
      sym_comment,
    ACTIONS(5110), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [147542] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4779), 1,
      anon_sym_PIPE,
    STATE(3362), 1,
      sym_comment,
    ACTIONS(4781), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [147569] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3363), 1,
      sym_comment,
    ACTIONS(5096), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [147594] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3115), 1,
      anon_sym_PIPE,
    STATE(3364), 1,
      sym_comment,
    ACTIONS(3117), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [147621] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3365), 1,
      sym_comment,
    ACTIONS(4990), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [147646] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4659), 1,
      anon_sym_PIPE,
    ACTIONS(6658), 1,
      anon_sym_LT,
    STATE(3366), 1,
      sym_comment,
    STATE(3512), 1,
      sym_type_arguments,
    ACTIONS(4661), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [147677] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1874), 1,
      anon_sym_DOT,
    ACTIONS(4805), 1,
      anon_sym_PIPE,
    STATE(3367), 1,
      sym_comment,
    ACTIONS(4807), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [147706] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1946), 1,
      anon_sym_DOT,
    ACTIONS(4805), 1,
      anon_sym_PIPE,
    STATE(3368), 1,
      sym_comment,
    ACTIONS(4807), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [147735] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(6926), 1,
      anon_sym_QMARK,
    STATE(3369), 1,
      sym_comment,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4222), 1,
      sym_type_annotation,
    STATE(4224), 1,
      sym__call_signature,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(6924), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [147776] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3370), 1,
      sym_comment,
    ACTIONS(5092), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [147801] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(6928), 1,
      anon_sym_QMARK,
    STATE(3371), 1,
      sym_comment,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4551), 1,
      sym__call_signature,
    STATE(4552), 1,
      sym_type_annotation,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(6902), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [147842] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3372), 1,
      sym_comment,
    ACTIONS(5092), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [147867] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3373), 1,
      sym_comment,
    ACTIONS(4986), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [147892] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3374), 1,
      sym_comment,
    ACTIONS(5092), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [147917] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3375), 1,
      sym_comment,
    ACTIONS(5088), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [147942] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3376), 1,
      sym_comment,
    ACTIONS(5058), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [147967] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3377), 1,
      sym_comment,
    ACTIONS(4974), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [147992] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(6930), 1,
      anon_sym_QMARK,
    STATE(3378), 1,
      sym_comment,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(3991), 1,
      sym__call_signature,
    STATE(4222), 1,
      sym_type_annotation,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(6924), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [148033] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3379), 1,
      sym_comment,
    ACTIONS(5068), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [148058] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3091), 1,
      anon_sym_PIPE,
    STATE(3380), 1,
      sym_comment,
    ACTIONS(3093), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [148085] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3091), 1,
      anon_sym_PIPE,
    STATE(3381), 1,
      sym_comment,
    ACTIONS(3093), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [148112] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3382), 1,
      sym_comment,
    ACTIONS(4990), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [148137] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3383), 1,
      sym_comment,
    ACTIONS(4970), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [148162] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3119), 1,
      anon_sym_PIPE,
    STATE(3384), 1,
      sym_comment,
    ACTIONS(3121), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [148189] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3385), 1,
      sym_comment,
    ACTIONS(5004), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [148214] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3682), 1,
      anon_sym_PIPE,
    STATE(3386), 1,
      sym_comment,
    ACTIONS(3684), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [148241] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3119), 1,
      anon_sym_PIPE,
    STATE(3387), 1,
      sym_comment,
    ACTIONS(3121), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [148268] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3388), 1,
      sym_comment,
    ACTIONS(5058), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [148293] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3389), 1,
      sym_comment,
    ACTIONS(4998), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [148318] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3390), 1,
      sym_comment,
    ACTIONS(5064), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [148343] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3391), 1,
      sym_comment,
    ACTIONS(5068), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [148368] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3392), 1,
      sym_comment,
    ACTIONS(5068), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [148393] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4888), 1,
      anon_sym_PIPE,
    STATE(3393), 1,
      sym_comment,
    ACTIONS(4890), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [148420] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3394), 1,
      sym_comment,
    ACTIONS(5004), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [148445] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3395), 1,
      sym_comment,
    ACTIONS(5064), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [148470] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6606), 1,
      anon_sym_DOT,
    ACTIONS(6624), 1,
      anon_sym_LT,
    ACTIONS(6932), 1,
      anon_sym_EQ,
    ACTIONS(6937), 1,
      anon_sym_COLON,
    ACTIONS(6939), 1,
      anon_sym_extends,
    STATE(3240), 1,
      sym_type_arguments,
    STATE(3396), 1,
      sym_comment,
    STATE(4773), 1,
      sym_constraint,
    STATE(5590), 1,
      sym_default_type,
    ACTIONS(6934), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    ACTIONS(3842), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
  [148513] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6692), 1,
      anon_sym_LT,
    ACTIONS(6942), 1,
      anon_sym_DOT,
    ACTIONS(6944), 1,
      anon_sym_is,
    STATE(3397), 1,
      sym_comment,
    STATE(3560), 1,
      sym_type_arguments,
    ACTIONS(3842), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [148546] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3398), 1,
      sym_comment,
    ACTIONS(5036), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [148571] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(6946), 1,
      anon_sym_QMARK,
    STATE(3399), 1,
      sym_comment,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4601), 1,
      sym__call_signature,
    STATE(4609), 1,
      sym_type_annotation,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(6906), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [148612] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4900), 1,
      anon_sym_PIPE,
    STATE(3400), 1,
      sym_comment,
    ACTIONS(4902), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [148639] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3401), 1,
      sym_comment,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4349), 1,
      sym_type_annotation,
    STATE(4351), 1,
      sym__call_signature,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(6948), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [148677] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3402), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4655), 1,
      sym_type_annotation,
    STATE(5372), 1,
      sym__initializer,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5787), 1,
      sym__call_signature,
    ACTIONS(6950), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [148719] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4338), 1,
      anon_sym_RBRACE,
    STATE(3403), 1,
      sym_comment,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [148753] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4671), 1,
      anon_sym_PIPE,
    ACTIONS(6704), 1,
      anon_sym_is,
    STATE(3404), 1,
      sym_comment,
    ACTIONS(4673), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [148781] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3405), 1,
      sym_comment,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4543), 1,
      sym__call_signature,
    STATE(4544), 1,
      sym_type_annotation,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(6952), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [148819] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3406), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4249), 1,
      sym_type_annotation,
    STATE(5254), 1,
      sym__initializer,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5908), 1,
      sym__call_signature,
    ACTIONS(6954), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [148861] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3407), 1,
      sym_comment,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(3981), 1,
      sym__call_signature,
    STATE(4561), 1,
      sym_type_annotation,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(6956), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [148899] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(6796), 1,
      anon_sym_LPAREN,
    STATE(3408), 1,
      sym_comment,
    STATE(3571), 1,
      sym_formal_parameters,
    STATE(4123), 1,
      sym__call_signature,
    STATE(4537), 1,
      sym_type_annotation,
    STATE(5371), 1,
      sym__initializer,
    STATE(5701), 1,
      sym_type_parameters,
    ACTIONS(6958), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [148941] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3409), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4290), 1,
      sym_type_annotation,
    STATE(5339), 1,
      sym__initializer,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5909), 1,
      sym__call_signature,
    ACTIONS(6954), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [148983] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3410), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4304), 1,
      sym_type_annotation,
    STATE(5283), 1,
      sym__initializer,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5899), 1,
      sym__call_signature,
    ACTIONS(6960), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [149025] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3411), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4281), 1,
      sym_type_annotation,
    STATE(5357), 1,
      sym__initializer,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5915), 1,
      sym__call_signature,
    ACTIONS(6954), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [149067] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    STATE(3412), 1,
      sym_comment,
    STATE(3872), 1,
      sym_formal_parameters,
    STATE(5660), 1,
      sym_type_parameters,
    ACTIONS(4378), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4322), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [149103] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3413), 1,
      sym_comment,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(3997), 1,
      sym__call_signature,
    STATE(4226), 1,
      sym_type_annotation,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(6962), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [149141] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3414), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4541), 1,
      sym_type_annotation,
    STATE(4959), 1,
      sym__initializer,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5911), 1,
      sym__call_signature,
    ACTIONS(6954), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [149183] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4341), 1,
      anon_sym_RBRACE,
    STATE(3415), 1,
      sym_comment,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [149217] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3416), 1,
      sym_comment,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4226), 1,
      sym_type_annotation,
    STATE(4228), 1,
      sym__call_signature,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(6962), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [149255] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4683), 1,
      anon_sym_PIPE,
    STATE(3417), 1,
      sym_comment,
    ACTIONS(4685), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_is,
      anon_sym_PIPE_RBRACE,
  [149281] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(6636), 1,
      anon_sym_STAR,
    ACTIONS(6640), 1,
      anon_sym_LBRACE,
    ACTIONS(6800), 1,
      sym_identifier,
    ACTIONS(6802), 1,
      anon_sym_type,
    STATE(3418), 1,
      sym_comment,
    STATE(4800), 1,
      sym_string,
    STATE(4801), 1,
      sym_import_require_clause,
    STATE(5564), 1,
      sym__import_identifier,
    STATE(5626), 1,
      sym_import_clause,
    STATE(6231), 2,
      sym_namespace_import,
      sym_named_imports,
  [149325] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3419), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4211), 1,
      sym_type_annotation,
    STATE(5065), 1,
      sym__initializer,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5900), 1,
      sym__call_signature,
    ACTIONS(6960), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [149367] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3420), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4624), 1,
      sym_type_annotation,
    STATE(5273), 1,
      sym__initializer,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5913), 1,
      sym__call_signature,
    ACTIONS(6954), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [149409] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3421), 1,
      sym_comment,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4002), 1,
      sym__call_signature,
    STATE(4544), 1,
      sym_type_annotation,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(6952), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [149447] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3422), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4485), 1,
      sym_type_annotation,
    STATE(4935), 1,
      sym__initializer,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5928), 1,
      sym__call_signature,
    ACTIONS(6964), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [149489] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4332), 1,
      anon_sym_RBRACE,
    STATE(3423), 1,
      sym_comment,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [149523] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3424), 1,
      sym_comment,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4554), 1,
      sym_type_annotation,
    STATE(4896), 1,
      sym__call_signature,
    STATE(4898), 1,
      sym__initializer,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(6966), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [149565] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1711), 1,
      anon_sym_PIPE,
    STATE(3425), 1,
      sym_comment,
    ACTIONS(1709), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_is,
      anon_sym_PIPE_RBRACE,
  [149591] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4659), 1,
      anon_sym_PIPE,
    ACTIONS(6968), 1,
      anon_sym_is,
    STATE(3426), 1,
      sym_comment,
    ACTIONS(4661), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [149619] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3427), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4433), 1,
      sym_type_annotation,
    STATE(4882), 1,
      sym__initializer,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5894), 1,
      sym__call_signature,
    ACTIONS(6960), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [149661] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4665), 1,
      anon_sym_PIPE,
    ACTIONS(6704), 1,
      anon_sym_is,
    STATE(3428), 1,
      sym_comment,
    ACTIONS(4667), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [149689] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3429), 1,
      sym_comment,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4557), 1,
      sym__call_signature,
    STATE(4561), 1,
      sym_type_annotation,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(6956), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [149727] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3430), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4362), 1,
      sym_type_annotation,
    STATE(5154), 1,
      sym__initializer,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5914), 1,
      sym__call_signature,
    ACTIONS(6964), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [149769] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4319), 1,
      anon_sym_RBRACE,
    STATE(3431), 1,
      sym_comment,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [149803] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6692), 1,
      anon_sym_LT,
    ACTIONS(6942), 1,
      anon_sym_DOT,
    STATE(3432), 1,
      sym_comment,
    STATE(3560), 1,
      sym_type_arguments,
    ACTIONS(3842), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [149833] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3814), 1,
      anon_sym_LPAREN,
    ACTIONS(6630), 1,
      anon_sym_DOT,
    ACTIONS(6632), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6970), 1,
      anon_sym_LT,
    STATE(3170), 1,
      sym_arguments,
    STATE(3270), 1,
      sym_type_arguments,
    STATE(3433), 1,
      sym_comment,
    ACTIONS(4635), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [149869] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(6796), 1,
      anon_sym_LPAREN,
    STATE(3434), 1,
      sym_comment,
    STATE(3571), 1,
      sym_formal_parameters,
    STATE(4146), 1,
      sym__call_signature,
    STATE(4642), 1,
      sym_type_annotation,
    STATE(5396), 1,
      sym__initializer,
    STATE(5701), 1,
      sym_type_parameters,
    ACTIONS(6972), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [149911] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3435), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4503), 1,
      sym_type_annotation,
    STATE(4904), 1,
      sym__initializer,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5930), 1,
      sym__call_signature,
    ACTIONS(6964), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [149953] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3436), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4258), 1,
      sym_type_annotation,
    STATE(5506), 1,
      sym__initializer,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5903), 1,
      sym__call_signature,
    ACTIONS(6960), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [149995] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3437), 1,
      sym_comment,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4642), 1,
      sym_type_annotation,
    STATE(5432), 1,
      sym__call_signature,
    STATE(5433), 1,
      sym__initializer,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(6972), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [150037] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(6796), 1,
      anon_sym_LPAREN,
    STATE(3438), 1,
      sym_comment,
    STATE(3571), 1,
      sym_formal_parameters,
    STATE(4168), 1,
      sym__call_signature,
    STATE(4554), 1,
      sym_type_annotation,
    STATE(4970), 1,
      sym__initializer,
    STATE(5701), 1,
      sym_type_parameters,
    ACTIONS(6966), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [150079] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(6796), 1,
      anon_sym_LPAREN,
    STATE(3439), 1,
      sym_comment,
    STATE(3571), 1,
      sym_formal_parameters,
    STATE(4190), 1,
      sym__call_signature,
    STATE(4323), 1,
      sym_type_annotation,
    STATE(5234), 1,
      sym__initializer,
    STATE(5701), 1,
      sym_type_parameters,
    ACTIONS(6974), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [150121] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3440), 1,
      sym_comment,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4607), 1,
      sym_type_annotation,
    STATE(4608), 1,
      sym__call_signature,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(6976), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [150159] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(6796), 1,
      anon_sym_LPAREN,
    STATE(3441), 1,
      sym_comment,
    STATE(3571), 1,
      sym_formal_parameters,
    STATE(4023), 1,
      sym__call_signature,
    STATE(4213), 1,
      sym_type_annotation,
    STATE(5480), 1,
      sym__initializer,
    STATE(5701), 1,
      sym_type_parameters,
    ACTIONS(6978), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [150201] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4344), 1,
      anon_sym_RBRACE,
    STATE(3442), 1,
      sym_comment,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5251), 1,
      aux_sym_object_repeat1,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [150235] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3443), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4299), 1,
      sym_type_annotation,
    STATE(5310), 1,
      sym__initializer,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5917), 1,
      sym__call_signature,
    ACTIONS(6954), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [150277] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3444), 1,
      sym_comment,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(3986), 1,
      sym__call_signature,
    STATE(4607), 1,
      sym_type_annotation,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(6976), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [150315] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3445), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4502), 1,
      sym_type_annotation,
    STATE(4907), 1,
      sym__initializer,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5895), 1,
      sym__call_signature,
    ACTIONS(6980), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [150357] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3855), 1,
      anon_sym_COLON,
    ACTIONS(6606), 1,
      anon_sym_DOT,
    ACTIONS(6624), 1,
      anon_sym_LT,
    ACTIONS(6982), 1,
      anon_sym_QMARK,
    STATE(3240), 1,
      sym_type_arguments,
    STATE(3446), 1,
      sym_comment,
    STATE(5686), 1,
      sym_type_annotation,
    ACTIONS(3842), 6,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [150393] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3814), 1,
      anon_sym_LPAREN,
    ACTIONS(3816), 1,
      anon_sym_DOT,
    ACTIONS(3818), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6970), 1,
      anon_sym_LT,
    STATE(3174), 1,
      sym_arguments,
    STATE(3263), 1,
      sym_type_arguments,
    STATE(3447), 1,
      sym_comment,
    ACTIONS(3796), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [150429] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3814), 1,
      anon_sym_LPAREN,
    ACTIONS(6626), 1,
      anon_sym_DOT,
    ACTIONS(6628), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6970), 1,
      anon_sym_LT,
    STATE(3173), 1,
      sym_arguments,
    STATE(3269), 1,
      sym_type_arguments,
    STATE(3448), 1,
      sym_comment,
    ACTIONS(4625), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [150465] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4316), 1,
      anon_sym_COMMA,
    ACTIONS(4335), 1,
      anon_sym_RBRACE,
    STATE(3449), 1,
      sym_comment,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [150499] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3450), 1,
      sym_comment,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(3870), 1,
      sym__call_signature,
    STATE(4349), 1,
      sym_type_annotation,
    STATE(5867), 1,
      sym_type_parameters,
    ACTIONS(6948), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [150537] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(6636), 1,
      anon_sym_STAR,
    ACTIONS(6640), 1,
      anon_sym_LBRACE,
    ACTIONS(6800), 1,
      sym_identifier,
    ACTIONS(6802), 1,
      anon_sym_type,
    STATE(3451), 1,
      sym_comment,
    STATE(4742), 1,
      sym_import_require_clause,
    STATE(4744), 1,
      sym_string,
    STATE(5564), 1,
      sym__import_identifier,
    STATE(5828), 1,
      sym_import_clause,
    STATE(6231), 2,
      sym_namespace_import,
      sym_named_imports,
  [150581] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3452), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4380), 1,
      sym_type_annotation,
    STATE(5101), 1,
      sym__initializer,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5925), 1,
      sym__call_signature,
    ACTIONS(6964), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [150623] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4944), 1,
      anon_sym_PIPE,
    STATE(3453), 1,
      sym_comment,
    ACTIONS(4946), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [150648] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4940), 1,
      anon_sym_PIPE,
    STATE(3454), 1,
      sym_comment,
    ACTIONS(4942), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [150673] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6985), 1,
      anon_sym_AMP,
    ACTIONS(6987), 1,
      anon_sym_PIPE,
    ACTIONS(6989), 1,
      anon_sym_extends,
    STATE(3455), 1,
      sym_comment,
    ACTIONS(4946), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [150702] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2392), 1,
      anon_sym_PIPE,
    STATE(3456), 1,
      sym_comment,
    ACTIONS(2394), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [150727] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5082), 1,
      anon_sym_PIPE,
    STATE(3457), 1,
      sym_comment,
    ACTIONS(5084), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [150752] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3458), 1,
      sym_comment,
    ACTIONS(3680), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [150775] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5074), 1,
      anon_sym_PIPE,
    STATE(3459), 1,
      sym_comment,
    ACTIONS(5076), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [150800] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3460), 1,
      sym_comment,
    ACTIONS(3688), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [150823] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5070), 1,
      anon_sym_PIPE,
    STATE(3461), 1,
      sym_comment,
    ACTIONS(5072), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [150848] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3462), 1,
      sym_comment,
    ACTIONS(3684), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [150871] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4936), 1,
      anon_sym_PIPE,
    STATE(3463), 1,
      sym_comment,
    ACTIONS(4938), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [150896] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4932), 1,
      anon_sym_PIPE,
    STATE(3464), 1,
      sym_comment,
    ACTIONS(4934), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [150921] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4801), 1,
      anon_sym_PIPE,
    STATE(3465), 1,
      sym_comment,
    ACTIONS(4803), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [150946] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4659), 1,
      anon_sym_PIPE,
    STATE(3466), 1,
      sym_comment,
    ACTIONS(4661), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [150971] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4795), 1,
      anon_sym_PIPE,
    ACTIONS(6991), 1,
      anon_sym_LBRACK,
    STATE(3467), 1,
      sym_comment,
    ACTIONS(4797), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [150998] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4795), 1,
      anon_sym_PIPE,
    STATE(3468), 1,
      sym_comment,
    ACTIONS(4797), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151023] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3469), 1,
      sym_comment,
    ACTIONS(4781), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [151046] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2396), 1,
      anon_sym_PIPE,
    STATE(3470), 1,
      sym_comment,
    ACTIONS(2398), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151071] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2400), 1,
      anon_sym_PIPE,
    STATE(3471), 1,
      sym_comment,
    ACTIONS(2402), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151096] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4665), 1,
      anon_sym_PIPE,
    STATE(3472), 1,
      sym_comment,
    ACTIONS(4667), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151121] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3473), 1,
      sym_comment,
    ACTIONS(4890), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [151144] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4821), 1,
      anon_sym_PIPE,
    STATE(3474), 1,
      sym_comment,
    ACTIONS(4823), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151169] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6692), 1,
      anon_sym_LT,
    STATE(3475), 1,
      sym_comment,
    STATE(3577), 1,
      sym_type_arguments,
    ACTIONS(4661), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [151196] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5006), 1,
      anon_sym_PIPE,
    STATE(3476), 1,
      sym_comment,
    ACTIONS(5008), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151221] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5010), 1,
      anon_sym_PIPE,
    STATE(3477), 1,
      sym_comment,
    ACTIONS(5012), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151246] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1874), 1,
      anon_sym_DOT,
    STATE(3478), 1,
      sym_comment,
    ACTIONS(4807), 10,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [151271] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1946), 1,
      anon_sym_DOT,
    STATE(3479), 1,
      sym_comment,
    ACTIONS(4807), 10,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [151296] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2388), 1,
      anon_sym_PIPE,
    STATE(3480), 1,
      sym_comment,
    ACTIONS(2390), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151321] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2404), 1,
      anon_sym_PIPE,
    STATE(3481), 1,
      sym_comment,
    ACTIONS(2406), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151346] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3482), 1,
      sym_comment,
    ACTIONS(5990), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [151369] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5112), 1,
      anon_sym_PIPE,
    STATE(3483), 1,
      sym_comment,
    ACTIONS(5114), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151394] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4791), 1,
      anon_sym_PIPE,
    STATE(3484), 1,
      sym_comment,
    ACTIONS(4793), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151419] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6985), 1,
      anon_sym_AMP,
    ACTIONS(6987), 1,
      anon_sym_PIPE,
    ACTIONS(6989), 1,
      anon_sym_extends,
    STATE(3485), 1,
      sym_comment,
    ACTIONS(5016), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [151448] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4783), 1,
      anon_sym_PIPE,
    STATE(3486), 1,
      sym_comment,
    ACTIONS(4785), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151473] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4950), 1,
      anon_sym_PIPE,
    STATE(3487), 1,
      sym_comment,
    ACTIONS(4952), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151498] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4954), 1,
      anon_sym_PIPE,
    ACTIONS(6985), 1,
      anon_sym_AMP,
    STATE(3488), 1,
      sym_comment,
    ACTIONS(4956), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151525] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6993), 1,
      anon_sym_DOT,
    ACTIONS(6995), 1,
      anon_sym_QMARK_DOT,
    STATE(3489), 1,
      sym_comment,
    ACTIONS(4817), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [151552] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5018), 1,
      anon_sym_PIPE,
    STATE(3490), 1,
      sym_comment,
    ACTIONS(5020), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151577] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1946), 1,
      anon_sym_DOT,
    ACTIONS(4805), 1,
      anon_sym_LBRACE,
    STATE(3491), 1,
      sym_comment,
    ACTIONS(4807), 9,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [151604] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1874), 1,
      anon_sym_DOT,
    ACTIONS(4805), 1,
      anon_sym_LBRACE,
    STATE(3492), 1,
      sym_comment,
    ACTIONS(4807), 9,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [151631] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4958), 1,
      anon_sym_PIPE,
    STATE(3493), 1,
      sym_comment,
    ACTIONS(4960), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151656] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4825), 1,
      anon_sym_PIPE,
    STATE(3494), 1,
      sym_comment,
    ACTIONS(4827), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151681] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4829), 1,
      anon_sym_PIPE,
    STATE(3495), 1,
      sym_comment,
    ACTIONS(4831), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151706] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5022), 1,
      anon_sym_PIPE,
    STATE(3496), 1,
      sym_comment,
    ACTIONS(5024), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151731] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6985), 1,
      anon_sym_AMP,
    ACTIONS(6987), 1,
      anon_sym_PIPE,
    ACTIONS(6989), 1,
      anon_sym_extends,
    STATE(3497), 1,
      sym_comment,
    ACTIONS(5122), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [151760] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4833), 1,
      anon_sym_PIPE,
    ACTIONS(6985), 1,
      anon_sym_AMP,
    STATE(3498), 1,
      sym_comment,
    ACTIONS(4835), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151787] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4789), 1,
      anon_sym_PIPE,
    STATE(3499), 1,
      sym_comment,
    ACTIONS(4787), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151812] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4839), 1,
      anon_sym_PIPE,
    STATE(3500), 1,
      sym_comment,
    ACTIONS(4841), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151837] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    STATE(3501), 1,
      sym_comment,
    STATE(3872), 1,
      sym_formal_parameters,
    STATE(5660), 1,
      sym_type_parameters,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [151868] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4843), 1,
      anon_sym_PIPE,
    STATE(3502), 1,
      sym_comment,
    ACTIONS(4845), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151893] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6985), 1,
      anon_sym_AMP,
    ACTIONS(6987), 1,
      anon_sym_PIPE,
    ACTIONS(6989), 1,
      anon_sym_extends,
    STATE(3503), 1,
      sym_comment,
    ACTIONS(5024), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [151922] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6985), 1,
      anon_sym_AMP,
    ACTIONS(6987), 1,
      anon_sym_PIPE,
    ACTIONS(6989), 1,
      anon_sym_extends,
    STATE(3504), 1,
      sym_comment,
    ACTIONS(4849), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [151951] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3505), 1,
      sym_comment,
    ACTIONS(5965), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [151974] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4795), 1,
      anon_sym_PIPE,
    ACTIONS(6991), 1,
      anon_sym_LBRACK,
    STATE(3506), 1,
      sym_comment,
    ACTIONS(4797), 2,
      anon_sym_AMP,
      anon_sym_extends,
    ACTIONS(4857), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [152003] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4859), 1,
      anon_sym_PIPE,
    ACTIONS(6997), 1,
      anon_sym_extends,
    STATE(3507), 1,
      sym_comment,
    ACTIONS(4861), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [152030] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6985), 1,
      anon_sym_AMP,
    ACTIONS(6987), 1,
      anon_sym_PIPE,
    ACTIONS(6989), 1,
      anon_sym_extends,
    STATE(3508), 1,
      sym_comment,
    ACTIONS(5028), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [152059] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(6999), 1,
      sym_identifier,
    ACTIONS(7001), 1,
      anon_sym_type,
    ACTIONS(7003), 1,
      anon_sym_COMMA,
    ACTIONS(7005), 1,
      anon_sym_RBRACE,
    ACTIONS(7007), 1,
      anon_sym_typeof,
    STATE(3509), 1,
      sym_comment,
    STATE(4799), 1,
      sym_string,
    STATE(5098), 1,
      sym_import_specifier,
    STATE(5627), 1,
      sym__import_identifier,
    STATE(6141), 1,
      sym__module_export_name,
  [152102] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4865), 1,
      anon_sym_PIPE,
    ACTIONS(6991), 1,
      anon_sym_LBRACK,
    STATE(3510), 1,
      sym_comment,
    ACTIONS(4867), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [152129] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4884), 1,
      anon_sym_PIPE,
    STATE(3511), 1,
      sym_comment,
    ACTIONS(4886), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [152154] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4871), 1,
      anon_sym_PIPE,
    STATE(3512), 1,
      sym_comment,
    ACTIONS(4873), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [152179] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6985), 1,
      anon_sym_AMP,
    ACTIONS(6987), 1,
      anon_sym_PIPE,
    ACTIONS(6989), 1,
      anon_sym_extends,
    STATE(3513), 1,
      sym_comment,
    ACTIONS(5032), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [152208] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3514), 1,
      sym_comment,
    ACTIONS(4322), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [152231] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3515), 1,
      sym_comment,
    ACTIONS(4902), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [152254] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4896), 1,
      anon_sym_PIPE,
    STATE(3516), 1,
      sym_comment,
    ACTIONS(4898), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [152279] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4671), 1,
      anon_sym_PIPE,
    STATE(3517), 1,
      sym_comment,
    ACTIONS(4673), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [152304] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4904), 1,
      anon_sym_PIPE,
    STATE(3518), 1,
      sym_comment,
    ACTIONS(4906), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [152329] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6944), 1,
      anon_sym_is,
    STATE(3519), 1,
      sym_comment,
    ACTIONS(4667), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [152353] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7011), 1,
      anon_sym_COLON,
    STATE(3520), 1,
      sym_comment,
    STATE(4031), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
    ACTIONS(7009), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [152379] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7013), 1,
      sym_identifier,
    ACTIONS(7015), 1,
      anon_sym_LBRACE,
    ACTIONS(7017), 1,
      anon_sym_extends,
    ACTIONS(7019), 1,
      anon_sym_implements,
    STATE(2461), 1,
      sym_class_body,
    STATE(3521), 1,
      sym_comment,
    STATE(3914), 1,
      sym_type_parameters,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5605), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [152419] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6970), 1,
      anon_sym_LT,
    ACTIONS(7021), 1,
      anon_sym_DOT,
    ACTIONS(7023), 1,
      anon_sym_is,
    STATE(3240), 1,
      sym_type_arguments,
    STATE(3522), 1,
      sym_comment,
    ACTIONS(3842), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [152449] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7015), 1,
      anon_sym_LBRACE,
    ACTIONS(7017), 1,
      anon_sym_extends,
    ACTIONS(7019), 1,
      anon_sym_implements,
    ACTIONS(7025), 1,
      sym_identifier,
    STATE(2659), 1,
      sym_class_body,
    STATE(3523), 1,
      sym_comment,
    STATE(3940), 1,
      sym_type_parameters,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5546), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [152489] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3524), 1,
      sym_comment,
    ACTIONS(1709), 10,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
      anon_sym_is,
  [152511] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7015), 1,
      anon_sym_LBRACE,
    ACTIONS(7017), 1,
      anon_sym_extends,
    ACTIONS(7019), 1,
      anon_sym_implements,
    ACTIONS(7027), 1,
      sym_identifier,
    STATE(2461), 1,
      sym_class_body,
    STATE(3525), 1,
      sym_comment,
    STATE(3914), 1,
      sym_type_parameters,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5605), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [152551] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    STATE(3526), 1,
      sym_comment,
    STATE(2514), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4886), 6,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [152579] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7015), 1,
      anon_sym_LBRACE,
    ACTIONS(7017), 1,
      anon_sym_extends,
    ACTIONS(7019), 1,
      anon_sym_implements,
    ACTIONS(7029), 1,
      sym_identifier,
    STATE(2659), 1,
      sym_class_body,
    STATE(3527), 1,
      sym_comment,
    STATE(3940), 1,
      sym_type_parameters,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5546), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [152619] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7017), 1,
      anon_sym_extends,
    ACTIONS(7019), 1,
      anon_sym_implements,
    ACTIONS(7031), 1,
      sym_identifier,
    ACTIONS(7033), 1,
      anon_sym_LBRACE,
    STATE(2018), 1,
      sym_class_body,
    STATE(3528), 1,
      sym_comment,
    STATE(3783), 1,
      sym_type_parameters,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5754), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [152659] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(6999), 1,
      sym_identifier,
    ACTIONS(7001), 1,
      anon_sym_type,
    ACTIONS(7007), 1,
      anon_sym_typeof,
    ACTIONS(7035), 1,
      anon_sym_RBRACE,
    STATE(3529), 1,
      sym_comment,
    STATE(4799), 1,
      sym_string,
    STATE(5627), 1,
      sym__import_identifier,
    STATE(5815), 1,
      sym_import_specifier,
    STATE(6141), 1,
      sym__module_export_name,
  [152699] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7017), 1,
      anon_sym_extends,
    ACTIONS(7019), 1,
      anon_sym_implements,
    ACTIONS(7033), 1,
      anon_sym_LBRACE,
    ACTIONS(7037), 1,
      sym_identifier,
    STATE(2004), 1,
      sym_class_body,
    STATE(3530), 1,
      sym_comment,
    STATE(3833), 1,
      sym_type_parameters,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5858), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [152739] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7041), 1,
      anon_sym_BANG,
    STATE(3531), 1,
      sym_comment,
    STATE(4253), 1,
      sym_type_annotation,
    STATE(5401), 1,
      sym__initializer,
    ACTIONS(7043), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(7039), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [152773] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7041), 1,
      anon_sym_BANG,
    ACTIONS(7045), 1,
      anon_sym_EQ,
    STATE(3532), 1,
      sym_comment,
    STATE(4253), 1,
      sym_type_annotation,
    STATE(4580), 1,
      sym__initializer,
    ACTIONS(7043), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(7039), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [152807] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(6999), 1,
      sym_identifier,
    ACTIONS(7001), 1,
      anon_sym_type,
    ACTIONS(7007), 1,
      anon_sym_typeof,
    ACTIONS(7047), 1,
      anon_sym_RBRACE,
    STATE(3533), 1,
      sym_comment,
    STATE(4799), 1,
      sym_string,
    STATE(5627), 1,
      sym__import_identifier,
    STATE(5815), 1,
      sym_import_specifier,
    STATE(6141), 1,
      sym__module_export_name,
  [152847] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7015), 1,
      anon_sym_LBRACE,
    ACTIONS(7017), 1,
      anon_sym_extends,
    ACTIONS(7019), 1,
      anon_sym_implements,
    ACTIONS(7049), 1,
      sym_identifier,
    STATE(2659), 1,
      sym_class_body,
    STATE(3534), 1,
      sym_comment,
    STATE(3940), 1,
      sym_type_parameters,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5546), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [152887] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7015), 1,
      anon_sym_LBRACE,
    ACTIONS(7017), 1,
      anon_sym_extends,
    ACTIONS(7019), 1,
      anon_sym_implements,
    ACTIONS(7051), 1,
      sym_identifier,
    STATE(2461), 1,
      sym_class_body,
    STATE(3535), 1,
      sym_comment,
    STATE(3914), 1,
      sym_type_parameters,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5605), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [152927] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(6999), 1,
      sym_identifier,
    ACTIONS(7053), 1,
      anon_sym_type,
    ACTIONS(7055), 1,
      anon_sym_as,
    STATE(3536), 1,
      sym_comment,
    STATE(4799), 1,
      sym_string,
    STATE(5738), 1,
      sym__import_identifier,
    STATE(6061), 1,
      sym__module_export_name,
    ACTIONS(6804), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [152965] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6985), 1,
      anon_sym_AMP,
    ACTIONS(6987), 1,
      anon_sym_PIPE,
    ACTIONS(6989), 1,
      anon_sym_extends,
    STATE(3537), 1,
      sym_comment,
    ACTIONS(7057), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [152993] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7059), 1,
      anon_sym_is,
    STATE(3538), 1,
      sym_comment,
    ACTIONS(4661), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [153017] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7017), 1,
      anon_sym_extends,
    ACTIONS(7019), 1,
      anon_sym_implements,
    ACTIONS(7033), 1,
      anon_sym_LBRACE,
    ACTIONS(7061), 1,
      sym_identifier,
    STATE(2758), 1,
      sym_class_body,
    STATE(3539), 1,
      sym_comment,
    STATE(3874), 1,
      sym_type_parameters,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5647), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [153057] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7011), 1,
      anon_sym_COLON,
    STATE(3540), 1,
      sym_comment,
    STATE(4044), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
    ACTIONS(7063), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [153083] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    STATE(3541), 1,
      sym_comment,
    ACTIONS(4378), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4322), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [153109] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7015), 1,
      anon_sym_LBRACE,
    ACTIONS(7017), 1,
      anon_sym_extends,
    ACTIONS(7019), 1,
      anon_sym_implements,
    ACTIONS(7065), 1,
      sym_identifier,
    STATE(2461), 1,
      sym_class_body,
    STATE(3542), 1,
      sym_comment,
    STATE(3914), 1,
      sym_type_parameters,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5605), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [153149] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7015), 1,
      anon_sym_LBRACE,
    ACTIONS(7017), 1,
      anon_sym_extends,
    ACTIONS(7019), 1,
      anon_sym_implements,
    ACTIONS(7067), 1,
      sym_identifier,
    STATE(2659), 1,
      sym_class_body,
    STATE(3543), 1,
      sym_comment,
    STATE(3940), 1,
      sym_type_parameters,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5546), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [153189] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2484), 1,
      anon_sym_LBRACE,
    ACTIONS(6511), 1,
      anon_sym_COLON,
    ACTIONS(6513), 1,
      anon_sym_DOT,
    ACTIONS(7069), 1,
      sym_identifier,
    ACTIONS(7071), 1,
      anon_sym_on,
    ACTIONS(7073), 1,
      anon_sym_list,
    STATE(2802), 1,
      sym_ui_object_initializer,
    STATE(3544), 1,
      sym_comment,
    STATE(6331), 1,
      sym_nested_identifier,
    STATE(3121), 2,
      sym_nested_type_identifier,
      sym_ui_list_property_type,
  [153227] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6944), 1,
      anon_sym_is,
    STATE(3545), 1,
      sym_comment,
    ACTIONS(4673), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [153251] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3798), 1,
      anon_sym_LPAREN,
    ACTIONS(7077), 1,
      anon_sym_DOT,
    STATE(3546), 1,
      sym_comment,
    STATE(3774), 1,
      sym_arguments,
    ACTIONS(7075), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [153279] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(7079), 1,
      sym_identifier,
    ACTIONS(7083), 1,
      anon_sym_COMMA,
    ACTIONS(7085), 1,
      anon_sym_RBRACE,
    STATE(3547), 1,
      sym_comment,
    STATE(4799), 1,
      sym_string,
    STATE(5131), 1,
      sym__module_export_name,
    STATE(5133), 1,
      sym_export_specifier,
    ACTIONS(7081), 2,
      anon_sym_type,
      anon_sym_typeof,
  [153317] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7015), 1,
      anon_sym_LBRACE,
    ACTIONS(7017), 1,
      anon_sym_extends,
    ACTIONS(7019), 1,
      anon_sym_implements,
    ACTIONS(7087), 1,
      sym_identifier,
    STATE(2461), 1,
      sym_class_body,
    STATE(3548), 1,
      sym_comment,
    STATE(3914), 1,
      sym_type_parameters,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5605), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [153357] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3549), 1,
      sym_comment,
    ACTIONS(4685), 10,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
      anon_sym_is,
  [153379] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7015), 1,
      anon_sym_LBRACE,
    ACTIONS(7017), 1,
      anon_sym_extends,
    ACTIONS(7019), 1,
      anon_sym_implements,
    ACTIONS(7089), 1,
      sym_identifier,
    STATE(2659), 1,
      sym_class_body,
    STATE(3550), 1,
      sym_comment,
    STATE(3940), 1,
      sym_type_parameters,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5546), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [153419] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3551), 1,
      sym_comment,
    ACTIONS(5084), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [153440] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3552), 1,
      sym_comment,
    STATE(4210), 1,
      sym_type_annotation,
    STATE(5477), 1,
      sym__initializer,
    ACTIONS(7093), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(7091), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [153471] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3553), 1,
      sym_comment,
    ACTIONS(4823), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [153492] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3554), 1,
      sym_comment,
    ACTIONS(4827), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [153513] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3555), 1,
      sym_comment,
    ACTIONS(4831), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [153534] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2484), 1,
      anon_sym_LBRACE,
    ACTIONS(6511), 1,
      anon_sym_COLON,
    ACTIONS(6513), 1,
      anon_sym_DOT,
    ACTIONS(7097), 1,
      anon_sym_on,
    STATE(2802), 1,
      sym_ui_object_initializer,
    STATE(3556), 1,
      sym_comment,
    ACTIONS(7095), 4,
      anon_sym_default,
      anon_sym_readonly,
      anon_sym_property,
      anon_sym_required,
  [153565] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7099), 1,
      anon_sym_AMP,
    STATE(3557), 1,
      sym_comment,
    ACTIONS(4835), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [153588] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3558), 1,
      sym_comment,
    ACTIONS(4787), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [153609] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3559), 1,
      sym_comment,
    ACTIONS(4841), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [153630] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3560), 1,
      sym_comment,
    ACTIONS(4845), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [153651] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7099), 1,
      anon_sym_AMP,
    ACTIONS(7101), 1,
      anon_sym_PIPE,
    ACTIONS(7103), 1,
      anon_sym_extends,
    STATE(3561), 1,
      sym_comment,
    ACTIONS(4849), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [153678] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7105), 1,
      anon_sym_LBRACK,
    STATE(3562), 1,
      sym_comment,
    ACTIONS(4797), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(4857), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [153703] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(777), 1,
      anon_sym_RBRACE,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    STATE(3563), 1,
      sym_comment,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [153734] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3564), 1,
      sym_comment,
    ACTIONS(7107), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE_RBRACE,
  [153755] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3565), 1,
      sym_comment,
    ACTIONS(7109), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE_RBRACE,
  [153776] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3566), 1,
      sym_comment,
    ACTIONS(7111), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE_RBRACE,
  [153797] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3567), 1,
      sym_comment,
    ACTIONS(7113), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE_RBRACE,
  [153818] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3568), 1,
      sym_comment,
    ACTIONS(3976), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE_RBRACE,
  [153839] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3569), 1,
      sym_comment,
    ACTIONS(3974), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE_RBRACE,
  [153860] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7115), 1,
      anon_sym_extends,
    STATE(3570), 1,
      sym_comment,
    ACTIONS(4861), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
  [153883] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7117), 1,
      anon_sym_COLON,
    STATE(3571), 1,
      sym_comment,
    STATE(4241), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
    ACTIONS(7063), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [153908] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7105), 1,
      anon_sym_LBRACK,
    STATE(3572), 1,
      sym_comment,
    ACTIONS(4867), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [153931] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3573), 1,
      sym_comment,
    ACTIONS(7119), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [153952] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3574), 1,
      sym_comment,
    ACTIONS(7121), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [153973] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3575), 1,
      sym_comment,
    ACTIONS(7123), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [153994] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7125), 1,
      anon_sym_BANG,
    ACTIONS(7127), 1,
      anon_sym_QMARK,
    STATE(3576), 1,
      sym_comment,
    STATE(4387), 1,
      sym_type_annotation,
    STATE(5093), 1,
      sym__initializer,
    ACTIONS(6858), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [154027] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3577), 1,
      sym_comment,
    ACTIONS(4873), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [154048] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(6624), 1,
      anon_sym_LT,
    STATE(2638), 1,
      sym_template_string,
    STATE(2727), 1,
      sym_arguments,
    STATE(3526), 1,
      sym_type_arguments,
    STATE(3578), 1,
      sym_comment,
    STATE(5550), 1,
      sym_optional_chain,
  [154085] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3115), 1,
      anon_sym_LBRACE,
    STATE(3579), 1,
      sym_comment,
    ACTIONS(3117), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [154108] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7015), 1,
      anon_sym_LBRACE,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    STATE(2540), 1,
      sym_class_body,
    STATE(3580), 1,
      sym_comment,
    STATE(3799), 1,
      sym_type_parameters,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5755), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [154145] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3123), 1,
      anon_sym_LBRACE,
    STATE(3581), 1,
      sym_comment,
    ACTIONS(3125), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [154168] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7135), 1,
      anon_sym_BANG,
    ACTIONS(7137), 1,
      anon_sym_QMARK,
    STATE(3582), 1,
      sym_comment,
    STATE(4633), 1,
      sym_type_annotation,
    STATE(5454), 1,
      sym__initializer,
    ACTIONS(7133), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [154201] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(7139), 1,
      anon_sym_EQ,
    STATE(3583), 1,
      sym_comment,
    ACTIONS(7057), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
  [154230] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3135), 1,
      anon_sym_LBRACE,
    STATE(3584), 1,
      sym_comment,
    ACTIONS(3137), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [154253] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3814), 1,
      anon_sym_LPAREN,
    ACTIONS(7141), 1,
      anon_sym_EQ,
    ACTIONS(7143), 1,
      anon_sym_DOT,
    STATE(3585), 1,
      sym_comment,
    STATE(3766), 1,
      sym_arguments,
    ACTIONS(7075), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
  [154282] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3586), 1,
      sym_comment,
    ACTIONS(7145), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [154303] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3587), 1,
      sym_comment,
    ACTIONS(7147), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [154324] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7149), 1,
      anon_sym_BANG,
    ACTIONS(7151), 1,
      anon_sym_QMARK,
    STATE(3588), 1,
      sym_comment,
    STATE(4208), 1,
      sym_type_annotation,
    STATE(5449), 1,
      sym__initializer,
    ACTIONS(6874), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [154357] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7117), 1,
      anon_sym_COLON,
    STATE(3589), 1,
      sym_comment,
    STATE(4421), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
    ACTIONS(7009), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [154382] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(6624), 1,
      anon_sym_LT,
    STATE(3590), 1,
      sym_comment,
    STATE(4726), 1,
      sym_type_arguments,
    STATE(5550), 1,
      sym_optional_chain,
    STATE(2638), 2,
      sym_template_string,
      sym_arguments,
  [154417] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3591), 1,
      sym_comment,
    ACTIONS(2406), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [154438] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3592), 1,
      sym_comment,
    ACTIONS(4886), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [154459] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3593), 1,
      sym_comment,
    ACTIONS(4898), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [154480] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7153), 1,
      anon_sym_BANG,
    ACTIONS(7155), 1,
      anon_sym_QMARK,
    STATE(3594), 1,
      sym_comment,
    STATE(4394), 1,
      sym_type_annotation,
    STATE(5070), 1,
      sym__initializer,
    ACTIONS(6858), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [154513] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3595), 1,
      sym_comment,
    ACTIONS(4906), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [154534] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    ACTIONS(7157), 1,
      anon_sym_LBRACE,
    STATE(2918), 1,
      sym_class_body,
    STATE(3596), 1,
      sym_comment,
    STATE(3796), 1,
      sym_type_parameters,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5766), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [154571] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3597), 1,
      sym_comment,
    ACTIONS(4934), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [154592] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3598), 1,
      sym_comment,
    ACTIONS(4938), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [154613] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3599), 1,
      sym_comment,
    ACTIONS(7159), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [154634] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3600), 1,
      sym_comment,
    ACTIONS(4942), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [154655] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3601), 1,
      sym_comment,
    ACTIONS(4946), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [154676] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7033), 1,
      anon_sym_LBRACE,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    STATE(2005), 1,
      sym_class_body,
    STATE(3602), 1,
      sym_comment,
    STATE(3795), 1,
      sym_type_parameters,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5770), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [154713] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7099), 1,
      anon_sym_AMP,
    ACTIONS(7101), 1,
      anon_sym_PIPE,
    ACTIONS(7103), 1,
      anon_sym_extends,
    STATE(3603), 1,
      sym_comment,
    ACTIONS(4946), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [154740] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3119), 1,
      anon_sym_LBRACE,
    STATE(3604), 1,
      sym_comment,
    ACTIONS(3121), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [154763] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3119), 1,
      anon_sym_LBRACE,
    STATE(3605), 1,
      sym_comment,
    ACTIONS(3121), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [154786] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3091), 1,
      anon_sym_LBRACE,
    STATE(3606), 1,
      sym_comment,
    ACTIONS(3093), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [154809] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6624), 1,
      anon_sym_LT,
    STATE(2014), 1,
      sym_template_string,
    STATE(2766), 1,
      sym_arguments,
    STATE(3302), 1,
      sym_type_arguments,
    STATE(3607), 1,
      sym_comment,
    STATE(5839), 1,
      sym_optional_chain,
  [154846] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7015), 1,
      anon_sym_LBRACE,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    STATE(2567), 1,
      sym_class_body,
    STATE(3608), 1,
      sym_comment,
    STATE(3916), 1,
      sym_type_parameters,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5577), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [154883] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3091), 1,
      anon_sym_LBRACE,
    STATE(3609), 1,
      sym_comment,
    ACTIONS(3093), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [154906] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3045), 1,
      anon_sym_LBRACE,
    STATE(3610), 1,
      sym_comment,
    ACTIONS(3047), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [154929] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3611), 1,
      sym_comment,
    ACTIONS(4952), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [154950] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7099), 1,
      anon_sym_AMP,
    STATE(3612), 1,
      sym_comment,
    ACTIONS(4956), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [154973] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7015), 1,
      anon_sym_LBRACE,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    STATE(2536), 1,
      sym_class_body,
    STATE(3613), 1,
      sym_comment,
    STATE(3945), 1,
      sym_type_parameters,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5585), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [155010] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3614), 1,
      sym_comment,
    ACTIONS(4960), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [155031] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(6624), 1,
      anon_sym_LT,
    ACTIONS(7161), 1,
      anon_sym_DOT,
    STATE(2638), 1,
      sym_template_string,
    STATE(2794), 1,
      sym_arguments,
    STATE(3615), 1,
      sym_comment,
    STATE(4726), 1,
      sym_type_arguments,
    STATE(5550), 1,
      sym_optional_chain,
  [155068] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3616), 1,
      sym_comment,
    ACTIONS(4673), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [155089] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3617), 1,
      sym_comment,
    ACTIONS(4785), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [155110] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3618), 1,
      sym_comment,
    ACTIONS(2394), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [155131] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7163), 1,
      anon_sym_BANG,
    ACTIONS(7165), 1,
      anon_sym_QMARK,
    STATE(3619), 1,
      sym_comment,
    STATE(4587), 1,
      sym_type_annotation,
    STATE(5184), 1,
      sym__initializer,
    ACTIONS(6874), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [155164] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3620), 1,
      sym_comment,
    ACTIONS(5008), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [155185] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7015), 1,
      anon_sym_LBRACE,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    STATE(2577), 1,
      sym_class_body,
    STATE(3621), 1,
      sym_comment,
    STATE(3936), 1,
      sym_type_parameters,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5596), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [155222] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3622), 1,
      sym_comment,
    ACTIONS(5012), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [155243] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(781), 1,
      anon_sym_RBRACE,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    STATE(3623), 1,
      sym_comment,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [155274] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7099), 1,
      anon_sym_AMP,
    ACTIONS(7101), 1,
      anon_sym_PIPE,
    ACTIONS(7103), 1,
      anon_sym_extends,
    STATE(3624), 1,
      sym_comment,
    ACTIONS(5016), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [155301] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(754), 1,
      anon_sym_RBRACE,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    STATE(3625), 1,
      sym_comment,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [155332] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7167), 1,
      anon_sym_BANG,
    ACTIONS(7169), 1,
      anon_sym_QMARK,
    STATE(3626), 1,
      sym_comment,
    STATE(4419), 1,
      sym_type_annotation,
    STATE(5033), 1,
      sym__initializer,
    ACTIONS(6858), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [155365] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3145), 1,
      anon_sym_LBRACE,
    STATE(3627), 1,
      sym_comment,
    ACTIONS(3147), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [155388] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3153), 1,
      anon_sym_LBRACE,
    STATE(3628), 1,
      sym_comment,
    ACTIONS(3155), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [155411] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3159), 1,
      anon_sym_LBRACE,
    STATE(3629), 1,
      sym_comment,
    ACTIONS(3161), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [155434] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3630), 1,
      sym_comment,
    ACTIONS(5020), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [155455] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    ACTIONS(7171), 1,
      anon_sym_LBRACE,
    STATE(246), 1,
      sym_class_body,
    STATE(3631), 1,
      sym_comment,
    STATE(3881), 1,
      sym_type_parameters,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5633), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [155492] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3632), 1,
      sym_comment,
    ACTIONS(5024), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [155513] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4412), 1,
      anon_sym_RBRACE,
    STATE(3633), 1,
      sym_comment,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5251), 1,
      aux_sym_object_repeat1,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [155544] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7099), 1,
      anon_sym_AMP,
    ACTIONS(7101), 1,
      anon_sym_PIPE,
    ACTIONS(7103), 1,
      anon_sym_extends,
    STATE(3634), 1,
      sym_comment,
    ACTIONS(5024), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [155571] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7099), 1,
      anon_sym_AMP,
    ACTIONS(7101), 1,
      anon_sym_PIPE,
    ACTIONS(7103), 1,
      anon_sym_extends,
    STATE(3635), 1,
      sym_comment,
    ACTIONS(5028), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [155598] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7099), 1,
      anon_sym_AMP,
    ACTIONS(7101), 1,
      anon_sym_PIPE,
    ACTIONS(7103), 1,
      anon_sym_extends,
    STATE(3636), 1,
      sym_comment,
    ACTIONS(5032), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [155625] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3637), 1,
      sym_comment,
    ACTIONS(2390), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [155646] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7173), 1,
      anon_sym_BANG,
    ACTIONS(7175), 1,
      anon_sym_QMARK,
    STATE(3638), 1,
      sym_comment,
    STATE(4424), 1,
      sym_type_annotation,
    STATE(5026), 1,
      sym__initializer,
    ACTIONS(6858), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [155679] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7177), 1,
      anon_sym_BANG,
    ACTIONS(7179), 1,
      anon_sym_QMARK,
    STATE(3639), 1,
      sym_comment,
    STATE(4435), 1,
      sym_type_annotation,
    STATE(5008), 1,
      sym__initializer,
    ACTIONS(6858), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [155712] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6624), 1,
      anon_sym_LT,
    ACTIONS(7181), 1,
      anon_sym_DOT,
    STATE(2014), 1,
      sym_template_string,
    STATE(2724), 1,
      sym_arguments,
    STATE(3640), 1,
      sym_comment,
    STATE(4835), 1,
      sym_type_arguments,
    STATE(5839), 1,
      sym_optional_chain,
  [155749] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(6624), 1,
      anon_sym_LT,
    ACTIONS(7183), 1,
      anon_sym_DOT,
    STATE(2625), 1,
      sym_arguments,
    STATE(2638), 1,
      sym_template_string,
    STATE(3641), 1,
      sym_comment,
    STATE(4726), 1,
      sym_type_arguments,
    STATE(5550), 1,
      sym_optional_chain,
  [155786] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7015), 1,
      anon_sym_LBRACE,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    STATE(2645), 1,
      sym_class_body,
    STATE(3642), 1,
      sym_comment,
    STATE(3865), 1,
      sym_type_parameters,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5692), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [155823] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7185), 1,
      anon_sym_BANG,
    ACTIONS(7187), 1,
      anon_sym_QMARK,
    STATE(3643), 1,
      sym_comment,
    STATE(4667), 1,
      sym_type_annotation,
    STATE(5453), 1,
      sym__initializer,
    ACTIONS(6874), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [155856] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7189), 1,
      anon_sym_BANG,
    ACTIONS(7191), 1,
      anon_sym_QMARK,
    STATE(3644), 1,
      sym_comment,
    STATE(4584), 1,
      sym_type_annotation,
    STATE(5170), 1,
      sym__initializer,
    ACTIONS(6874), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [155889] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7193), 1,
      anon_sym_BANG,
    ACTIONS(7195), 1,
      anon_sym_QMARK,
    STATE(3645), 1,
      sym_comment,
    STATE(4573), 1,
      sym_type_annotation,
    STATE(4874), 1,
      sym__initializer,
    ACTIONS(6874), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [155922] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3646), 1,
      sym_comment,
    ACTIONS(5072), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [155943] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3647), 1,
      sym_comment,
    ACTIONS(5076), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [155964] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    ACTIONS(7197), 1,
      anon_sym_LBRACE,
    STATE(2983), 1,
      sym_class_body,
    STATE(3648), 1,
      sym_comment,
    STATE(3798), 1,
      sym_type_parameters,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5757), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [156001] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3649), 1,
      sym_comment,
    ACTIONS(2402), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [156022] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3650), 1,
      sym_comment,
    ACTIONS(4793), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [156043] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    ACTIONS(7199), 1,
      anon_sym_LBRACE,
    STATE(772), 1,
      sym_class_body,
    STATE(3651), 1,
      sym_comment,
    STATE(3858), 1,
      sym_type_parameters,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5726), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [156080] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7201), 1,
      anon_sym_BANG,
    ACTIONS(7203), 1,
      anon_sym_QMARK,
    STATE(3652), 1,
      sym_comment,
    STATE(4505), 1,
      sym_type_annotation,
    STATE(4905), 1,
      sym__initializer,
    ACTIONS(6874), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [156113] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3653), 1,
      sym_comment,
    ACTIONS(5114), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [156134] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(6658), 1,
      anon_sym_LT,
    STATE(2014), 1,
      sym_template_string,
    STATE(2354), 1,
      sym_arguments,
    STATE(3358), 1,
      sym_type_arguments,
    STATE(3654), 1,
      sym_comment,
    STATE(5839), 1,
      sym_optional_chain,
  [156171] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    ACTIONS(7199), 1,
      anon_sym_LBRACE,
    STATE(3655), 1,
      sym_comment,
    STATE(3884), 1,
      sym_type_parameters,
    STATE(4440), 1,
      sym_class_body,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5635), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [156208] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7099), 1,
      anon_sym_AMP,
    ACTIONS(7101), 1,
      anon_sym_PIPE,
    ACTIONS(7103), 1,
      anon_sym_extends,
    STATE(3656), 1,
      sym_comment,
    ACTIONS(5122), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [156235] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5151), 1,
      anon_sym_DOT,
    ACTIONS(6624), 1,
      anon_sym_LT,
    STATE(2283), 1,
      sym_arguments,
    STATE(2638), 1,
      sym_template_string,
    STATE(3526), 1,
      sym_type_arguments,
    STATE(3657), 1,
      sym_comment,
    STATE(5550), 1,
      sym_optional_chain,
  [156272] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7205), 1,
      anon_sym_BANG,
    ACTIONS(7207), 1,
      anon_sym_QMARK,
    STATE(3658), 1,
      sym_comment,
    STATE(4420), 1,
      sym_type_annotation,
    STATE(5017), 1,
      sym__initializer,
    ACTIONS(7133), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [156305] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7209), 1,
      anon_sym_BANG,
    ACTIONS(7211), 1,
      anon_sym_QMARK,
    STATE(3659), 1,
      sym_comment,
    STATE(4358), 1,
      sym_type_annotation,
    STATE(5160), 1,
      sym__initializer,
    ACTIONS(6874), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [156338] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    ACTIONS(7199), 1,
      anon_sym_LBRACE,
    STATE(3660), 1,
      sym_comment,
    STATE(3903), 1,
      sym_type_parameters,
    STATE(4494), 1,
      sym_class_body,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5640), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [156375] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3661), 1,
      sym_comment,
    ACTIONS(3117), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [156396] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3662), 1,
      sym_comment,
    ACTIONS(3125), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [156417] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7213), 1,
      anon_sym_BANG,
    ACTIONS(7215), 1,
      anon_sym_QMARK,
    STATE(3663), 1,
      sym_comment,
    STATE(4518), 1,
      sym_type_annotation,
    STATE(5240), 1,
      sym__initializer,
    ACTIONS(6762), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [156450] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7217), 1,
      anon_sym_BANG,
    ACTIONS(7219), 1,
      anon_sym_QMARK,
    STATE(3664), 1,
      sym_comment,
    STATE(4248), 1,
      sym_type_annotation,
    STATE(5418), 1,
      sym__initializer,
    ACTIONS(6874), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [156483] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    ACTIONS(7197), 1,
      anon_sym_LBRACE,
    STATE(3011), 1,
      sym_class_body,
    STATE(3665), 1,
      sym_comment,
    STATE(3815), 1,
      sym_type_parameters,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5731), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [156520] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3666), 1,
      sym_comment,
    ACTIONS(3121), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [156541] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    ACTIONS(7221), 1,
      anon_sym_LBRACE,
    STATE(958), 1,
      sym_class_body,
    STATE(3667), 1,
      sym_comment,
    STATE(3897), 1,
      sym_type_parameters,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5653), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [156578] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    ACTIONS(7171), 1,
      anon_sym_LBRACE,
    STATE(243), 1,
      sym_class_body,
    STATE(3668), 1,
      sym_comment,
    STATE(3854), 1,
      sym_type_parameters,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5749), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [156615] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    ACTIONS(7199), 1,
      anon_sym_LBRACE,
    STATE(3669), 1,
      sym_comment,
    STATE(3896), 1,
      sym_type_parameters,
    STATE(4678), 1,
      sym_class_body,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5654), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [156652] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3670), 1,
      sym_comment,
    ACTIONS(3093), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [156673] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4484), 1,
      anon_sym_RBRACE,
    STATE(3671), 1,
      sym_comment,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [156704] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    ACTIONS(7199), 1,
      anon_sym_LBRACE,
    STATE(3672), 1,
      sym_comment,
    STATE(3780), 1,
      sym_type_parameters,
    STATE(4652), 1,
      sym_class_body,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5657), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [156741] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7033), 1,
      anon_sym_LBRACE,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    STATE(2788), 1,
      sym_class_body,
    STATE(3673), 1,
      sym_comment,
    STATE(3853), 1,
      sym_type_parameters,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5751), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [156778] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3674), 1,
      sym_comment,
    ACTIONS(3093), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [156799] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6624), 1,
      anon_sym_LT,
    ACTIONS(7223), 1,
      anon_sym_DOT,
    STATE(2014), 1,
      sym_template_string,
    STATE(2099), 1,
      sym_arguments,
    STATE(3675), 1,
      sym_comment,
    STATE(4835), 1,
      sym_type_arguments,
    STATE(5839), 1,
      sym_optional_chain,
  [156836] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3676), 1,
      sym_comment,
    STATE(4535), 1,
      sym_type_annotation,
    STATE(4875), 1,
      sym__initializer,
    ACTIONS(6794), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(6792), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [156867] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3677), 1,
      sym_comment,
    ACTIONS(3047), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [156888] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7225), 1,
      anon_sym_BANG,
    ACTIONS(7227), 1,
      anon_sym_QMARK,
    STATE(3678), 1,
      sym_comment,
    STATE(4452), 1,
      sym_type_annotation,
    STATE(4880), 1,
      sym__initializer,
    ACTIONS(6858), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [156921] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    ACTIONS(7229), 1,
      anon_sym_LBRACE,
    STATE(891), 1,
      sym_class_body,
    STATE(3679), 1,
      sym_comment,
    STATE(3856), 1,
      sym_type_parameters,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5747), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [156958] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3680), 1,
      sym_comment,
    ACTIONS(3147), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [156979] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3681), 1,
      sym_comment,
    ACTIONS(3155), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [157000] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3682), 1,
      sym_comment,
    ACTIONS(3161), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [157021] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3683), 1,
      sym_comment,
    ACTIONS(1860), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [157042] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7231), 1,
      anon_sym_BANG,
    ACTIONS(7233), 1,
      anon_sym_QMARK,
    STATE(3684), 1,
      sym_comment,
    STATE(4460), 1,
      sym_type_annotation,
    STATE(4971), 1,
      sym__initializer,
    ACTIONS(6858), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [157075] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3685), 1,
      sym_comment,
    ACTIONS(1852), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [157096] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7235), 1,
      anon_sym_BANG,
    ACTIONS(7237), 1,
      anon_sym_QMARK,
    STATE(3686), 1,
      sym_comment,
    STATE(4473), 1,
      sym_type_annotation,
    STATE(4965), 1,
      sym__initializer,
    ACTIONS(6858), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [157129] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    ACTIONS(7221), 1,
      anon_sym_LBRACE,
    STATE(976), 1,
      sym_class_body,
    STATE(3687), 1,
      sym_comment,
    STATE(3875), 1,
      sym_type_parameters,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5668), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [157166] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6624), 1,
      anon_sym_LT,
    STATE(2014), 1,
      sym_template_string,
    STATE(2266), 1,
      sym_arguments,
    STATE(3302), 1,
      sym_type_arguments,
    STATE(3688), 1,
      sym_comment,
    STATE(5839), 1,
      sym_optional_chain,
  [157203] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4474), 1,
      anon_sym_RBRACE,
    STATE(3689), 1,
      sym_comment,
    STATE(4915), 1,
      aux_sym_object_repeat1,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [157234] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7239), 1,
      anon_sym_BANG,
    ACTIONS(7241), 1,
      anon_sym_QMARK,
    STATE(3690), 1,
      sym_comment,
    STATE(4489), 1,
      sym_type_annotation,
    STATE(4931), 1,
      sym__initializer,
    ACTIONS(6858), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [157267] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7243), 1,
      anon_sym_EQ,
    STATE(3691), 1,
      sym_comment,
    ACTIONS(3974), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
  [157290] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7245), 1,
      anon_sym_EQ,
    STATE(3692), 1,
      sym_comment,
    ACTIONS(3976), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
  [157313] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7247), 1,
      anon_sym_EQ,
    STATE(3693), 1,
      sym_comment,
    ACTIONS(7113), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
  [157336] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7249), 1,
      anon_sym_EQ,
    STATE(3694), 1,
      sym_comment,
    ACTIONS(7111), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
  [157359] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7251), 1,
      anon_sym_EQ,
    STATE(3695), 1,
      sym_comment,
    ACTIONS(7109), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
  [157382] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7253), 1,
      anon_sym_EQ,
    STATE(3696), 1,
      sym_comment,
    ACTIONS(7107), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
  [157405] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6624), 1,
      anon_sym_LT,
    STATE(1750), 1,
      sym_arguments,
    STATE(2014), 1,
      sym_template_string,
    STATE(3302), 1,
      sym_type_arguments,
    STATE(3697), 1,
      sym_comment,
    STATE(5839), 1,
      sym_optional_chain,
  [157442] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7255), 1,
      anon_sym_BANG,
    ACTIONS(7257), 1,
      anon_sym_QMARK,
    STATE(3698), 1,
      sym_comment,
    STATE(4250), 1,
      sym_type_annotation,
    STATE(5411), 1,
      sym__initializer,
    ACTIONS(6874), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [157475] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(7079), 1,
      sym_identifier,
    ACTIONS(7259), 1,
      anon_sym_RBRACE,
    STATE(3699), 1,
      sym_comment,
    STATE(4799), 1,
      sym_string,
    STATE(5131), 1,
      sym__module_export_name,
    STATE(5853), 1,
      sym_export_specifier,
    ACTIONS(7081), 2,
      anon_sym_type,
      anon_sym_typeof,
  [157510] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3700), 1,
      sym_comment,
    ACTIONS(2398), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [157531] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3701), 1,
      sym_comment,
    ACTIONS(4667), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [157552] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    ACTIONS(7199), 1,
      anon_sym_LBRACE,
    STATE(781), 1,
      sym_class_body,
    STATE(3702), 1,
      sym_comment,
    STATE(3831), 1,
      sym_type_parameters,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5804), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [157589] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7261), 1,
      anon_sym_BANG,
    ACTIONS(7263), 1,
      anon_sym_QMARK,
    STATE(3703), 1,
      sym_comment,
    STATE(4278), 1,
      sym_type_annotation,
    STATE(5366), 1,
      sym__initializer,
    ACTIONS(6874), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [157622] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3704), 1,
      sym_comment,
    ACTIONS(4803), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [157643] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7045), 1,
      anon_sym_EQ,
    STATE(3705), 1,
      sym_comment,
    STATE(4253), 1,
      sym_type_annotation,
    STATE(4581), 1,
      sym__initializer,
    ACTIONS(7043), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(7039), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [157674] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3706), 1,
      sym_comment,
    ACTIONS(4661), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [157695] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3707), 1,
      sym_comment,
    STATE(4253), 1,
      sym_type_annotation,
    STATE(5394), 1,
      sym__initializer,
    ACTIONS(7043), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(7039), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [157726] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(6999), 1,
      sym_identifier,
    ACTIONS(7001), 1,
      anon_sym_type,
    ACTIONS(7007), 1,
      anon_sym_typeof,
    STATE(3708), 1,
      sym_comment,
    STATE(4799), 1,
      sym_string,
    STATE(5627), 1,
      sym__import_identifier,
    STATE(5815), 1,
      sym_import_specifier,
    STATE(6141), 1,
      sym__module_export_name,
  [157763] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7105), 1,
      anon_sym_LBRACK,
    STATE(3709), 1,
      sym_comment,
    ACTIONS(4797), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [157786] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4647), 1,
      anon_sym_DOT,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6624), 1,
      anon_sym_LT,
    STATE(3710), 1,
      sym_comment,
    STATE(4835), 1,
      sym_type_arguments,
    STATE(5839), 1,
      sym_optional_chain,
    STATE(2014), 2,
      sym_template_string,
      sym_arguments,
  [157821] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    ACTIONS(7229), 1,
      anon_sym_LBRACE,
    STATE(867), 1,
      sym_class_body,
    STATE(3711), 1,
      sym_comment,
    STATE(3812), 1,
      sym_type_parameters,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5848), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [157858] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3712), 1,
      sym_comment,
    ACTIONS(3137), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [157879] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3713), 1,
      sym_comment,
    STATE(4542), 1,
      sym_type_annotation,
    STATE(4886), 1,
      sym__initializer,
    ACTIONS(6832), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(6830), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [157910] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7265), 1,
      anon_sym_BANG,
    ACTIONS(7267), 1,
      anon_sym_QMARK,
    STATE(3714), 1,
      sym_comment,
    STATE(4324), 1,
      sym_type_annotation,
    STATE(5205), 1,
      sym__initializer,
    ACTIONS(6762), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [157943] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3715), 1,
      sym_comment,
    STATE(4610), 1,
      sym_type_annotation,
    STATE(5428), 1,
      sym__initializer,
    ACTIONS(6844), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(6842), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [157974] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6970), 1,
      anon_sym_LT,
    ACTIONS(7021), 1,
      anon_sym_DOT,
    STATE(3240), 1,
      sym_type_arguments,
    STATE(3716), 1,
      sym_comment,
    ACTIONS(3842), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [158001] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7269), 1,
      anon_sym_BANG,
    ACTIONS(7271), 1,
      anon_sym_QMARK,
    STATE(3717), 1,
      sym_comment,
    STATE(4674), 1,
      sym_type_annotation,
    STATE(5459), 1,
      sym__initializer,
    ACTIONS(6780), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [158034] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7273), 1,
      anon_sym_BANG,
    ACTIONS(7275), 1,
      anon_sym_QMARK,
    STATE(3718), 1,
      sym_comment,
    STATE(4661), 1,
      sym_type_annotation,
    STATE(5484), 1,
      sym__initializer,
    ACTIONS(6780), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [158067] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7277), 1,
      anon_sym_BANG,
    ACTIONS(7279), 1,
      anon_sym_QMARK,
    STATE(3719), 1,
      sym_comment,
    STATE(4379), 1,
      sym_type_annotation,
    STATE(5075), 1,
      sym__initializer,
    ACTIONS(6762), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [158100] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7281), 1,
      anon_sym_BANG,
    ACTIONS(7283), 1,
      anon_sym_QMARK,
    STATE(3720), 1,
      sym_comment,
    STATE(4401), 1,
      sym_type_annotation,
    STATE(5052), 1,
      sym__initializer,
    ACTIONS(6762), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [158133] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7285), 1,
      anon_sym_BANG,
    ACTIONS(7287), 1,
      anon_sym_QMARK,
    STATE(3721), 1,
      sym_comment,
    STATE(4430), 1,
      sym_type_annotation,
    STATE(5004), 1,
      sym__initializer,
    ACTIONS(6762), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [158166] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7289), 1,
      anon_sym_BANG,
    ACTIONS(7291), 1,
      anon_sym_QMARK,
    STATE(3722), 1,
      sym_comment,
    STATE(4568), 1,
      sym_type_annotation,
    STATE(5083), 1,
      sym__initializer,
    ACTIONS(6762), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [158199] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7033), 1,
      anon_sym_LBRACE,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    STATE(2061), 1,
      sym_class_body,
    STATE(3723), 1,
      sym_comment,
    STATE(3802), 1,
      sym_type_parameters,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5820), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [158236] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(7079), 1,
      sym_identifier,
    ACTIONS(7293), 1,
      anon_sym_RBRACE,
    STATE(3724), 1,
      sym_comment,
    STATE(4799), 1,
      sym_string,
    STATE(5131), 1,
      sym__module_export_name,
    STATE(5853), 1,
      sym_export_specifier,
    ACTIONS(7081), 2,
      anon_sym_type,
      anon_sym_typeof,
  [158271] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    ACTIONS(7157), 1,
      anon_sym_LBRACE,
    STATE(2883), 1,
      sym_class_body,
    STATE(3725), 1,
      sym_comment,
    STATE(3813), 1,
      sym_type_parameters,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5740), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [158308] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7295), 1,
      anon_sym_BANG,
    ACTIONS(7297), 1,
      anon_sym_QMARK,
    STATE(3726), 1,
      sym_comment,
    STATE(4356), 1,
      sym_type_annotation,
    STATE(4969), 1,
      sym__initializer,
    ACTIONS(6762), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [158341] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7299), 1,
      anon_sym_BANG,
    ACTIONS(7301), 1,
      anon_sym_QMARK,
    STATE(3727), 1,
      sym_comment,
    STATE(4437), 1,
      sym_type_annotation,
    STATE(5095), 1,
      sym__initializer,
    ACTIONS(6762), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [158374] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7303), 1,
      anon_sym_BANG,
    ACTIONS(7305), 1,
      anon_sym_QMARK,
    STATE(3728), 1,
      sym_comment,
    STATE(4201), 1,
      sym_type_annotation,
    STATE(5489), 1,
      sym__initializer,
    ACTIONS(6762), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [158407] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3729), 1,
      sym_comment,
    ACTIONS(3121), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [158428] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7307), 1,
      anon_sym_BANG,
    ACTIONS(7309), 1,
      anon_sym_QMARK,
    STATE(3730), 1,
      sym_comment,
    STATE(4209), 1,
      sym_type_annotation,
    STATE(5482), 1,
      sym__initializer,
    ACTIONS(6762), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [158461] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7311), 1,
      anon_sym_BANG,
    ACTIONS(7313), 1,
      anon_sym_QMARK,
    STATE(3731), 1,
      sym_comment,
    STATE(4218), 1,
      sym_type_annotation,
    STATE(5465), 1,
      sym__initializer,
    ACTIONS(6762), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [158494] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7315), 1,
      anon_sym_BANG,
    ACTIONS(7317), 1,
      anon_sym_QMARK,
    STATE(3732), 1,
      sym_comment,
    STATE(4233), 1,
      sym_type_annotation,
    STATE(5439), 1,
      sym__initializer,
    ACTIONS(6762), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [158527] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7319), 1,
      anon_sym_BANG,
    ACTIONS(7321), 1,
      anon_sym_QMARK,
    STATE(3733), 1,
      sym_comment,
    STATE(4242), 1,
      sym_type_annotation,
    STATE(5426), 1,
      sym__initializer,
    ACTIONS(6762), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [158560] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7323), 1,
      anon_sym_BANG,
    ACTIONS(7325), 1,
      anon_sym_QMARK,
    STATE(3734), 1,
      sym_comment,
    STATE(4246), 1,
      sym_type_annotation,
    STATE(5412), 1,
      sym__initializer,
    ACTIONS(6762), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [158593] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3735), 1,
      sym_comment,
    ACTIONS(4797), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [158614] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7327), 1,
      anon_sym_BANG,
    ACTIONS(7329), 1,
      anon_sym_QMARK,
    STATE(3736), 1,
      sym_comment,
    STATE(4261), 1,
      sym_type_annotation,
    STATE(5392), 1,
      sym__initializer,
    ACTIONS(6762), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [158647] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3737), 1,
      sym_comment,
    STATE(4315), 1,
      sym_type_annotation,
    STATE(5219), 1,
      sym__initializer,
    ACTIONS(6854), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(6852), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [158678] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(153), 1,
      anon_sym_COMMA,
    ACTIONS(791), 1,
      anon_sym_RBRACE,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    STATE(3738), 1,
      sym_comment,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5251), 1,
      aux_sym_object_repeat1,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [158709] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4733), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(6624), 1,
      anon_sym_LT,
    ACTIONS(7331), 1,
      anon_sym_DOT,
    STATE(2014), 1,
      sym_template_string,
    STATE(2452), 1,
      sym_arguments,
    STATE(3739), 1,
      sym_comment,
    STATE(4835), 1,
      sym_type_arguments,
    STATE(5839), 1,
      sym_optional_chain,
  [158746] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7015), 1,
      anon_sym_LBRACE,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    STATE(2479), 1,
      sym_class_body,
    STATE(3740), 1,
      sym_comment,
    STATE(3778), 1,
      sym_type_parameters,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5788), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [158783] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7333), 1,
      anon_sym_BANG,
    ACTIONS(7335), 1,
      anon_sym_QMARK,
    STATE(3741), 1,
      sym_comment,
    STATE(4301), 1,
      sym_type_annotation,
    STATE(5317), 1,
      sym__initializer,
    ACTIONS(6874), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [158816] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3600), 1,
      sym_identifier,
    ACTIONS(3602), 1,
      anon_sym_LBRACE,
    ACTIONS(3604), 1,
      anon_sym_LBRACK,
    ACTIONS(7337), 1,
      anon_sym_enum,
    STATE(3742), 1,
      sym_comment,
    STATE(3972), 1,
      sym__destructuring_pattern,
    STATE(4861), 1,
      sym_variable_declarator,
    STATE(3973), 2,
      sym_object_pattern,
      sym_array_pattern,
  [158848] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7341), 1,
      anon_sym_DOT,
    STATE(3743), 1,
      sym_comment,
    ACTIONS(7339), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [158870] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7343), 1,
      sym_escape_sequence,
    ACTIONS(7345), 1,
      anon_sym_BQUOTE,
    ACTIONS(7347), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7349), 1,
      sym__template_chars,
    STATE(3744), 1,
      sym_comment,
    STATE(4178), 1,
      aux_sym_template_string_repeat1,
    STATE(4334), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(4725), 1,
      sym_template_substitution,
    STATE(5192), 1,
      sym_template_type,
  [158904] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7351), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(7353), 1,
      anon_sym_PLUS_QMARK_COLON,
    ACTIONS(7355), 1,
      anon_sym_QMARK_COLON,
    STATE(3745), 1,
      sym_comment,
    STATE(4330), 4,
      sym_omitting_type_annotation,
      sym_adding_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [158932] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6985), 1,
      anon_sym_AMP,
    ACTIONS(6987), 1,
      anon_sym_PIPE,
    ACTIONS(6989), 1,
      anon_sym_extends,
    STATE(3746), 1,
      sym_comment,
    ACTIONS(7357), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [158958] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6970), 1,
      anon_sym_LT,
    STATE(3283), 1,
      sym_type_arguments,
    STATE(3747), 1,
      sym_comment,
    ACTIONS(4661), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [158982] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6985), 1,
      anon_sym_AMP,
    ACTIONS(6987), 1,
      anon_sym_PIPE,
    ACTIONS(6989), 1,
      anon_sym_extends,
    STATE(3748), 1,
      sym_comment,
    ACTIONS(7359), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [159008] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7351), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(7353), 1,
      anon_sym_PLUS_QMARK_COLON,
    ACTIONS(7355), 1,
      anon_sym_QMARK_COLON,
    STATE(3749), 1,
      sym_comment,
    STATE(4534), 4,
      sym_omitting_type_annotation,
      sym_adding_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [159036] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7343), 1,
      sym_escape_sequence,
    ACTIONS(7347), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7349), 1,
      sym__template_chars,
    ACTIONS(7361), 1,
      anon_sym_BQUOTE,
    STATE(3750), 1,
      sym_comment,
    STATE(4178), 1,
      aux_sym_template_string_repeat1,
    STATE(4565), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(4725), 1,
      sym_template_substitution,
    STATE(5192), 1,
      sym_template_type,
  [159070] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6985), 1,
      anon_sym_AMP,
    ACTIONS(6987), 1,
      anon_sym_PIPE,
    ACTIONS(6989), 1,
      anon_sym_extends,
    STATE(3751), 1,
      sym_comment,
    ACTIONS(7363), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [159096] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7351), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(7353), 1,
      anon_sym_PLUS_QMARK_COLON,
    ACTIONS(7355), 1,
      anon_sym_QMARK_COLON,
    STATE(3752), 1,
      sym_comment,
    STATE(4612), 4,
      sym_omitting_type_annotation,
      sym_adding_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [159124] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7351), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(7353), 1,
      anon_sym_PLUS_QMARK_COLON,
    ACTIONS(7355), 1,
      anon_sym_QMARK_COLON,
    STATE(3753), 1,
      sym_comment,
    STATE(4336), 4,
      sym_omitting_type_annotation,
      sym_adding_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [159152] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7351), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(7353), 1,
      anon_sym_PLUS_QMARK_COLON,
    ACTIONS(7355), 1,
      anon_sym_QMARK_COLON,
    STATE(3754), 1,
      sym_comment,
    STATE(4340), 4,
      sym_omitting_type_annotation,
      sym_adding_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [159180] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7351), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(7353), 1,
      anon_sym_PLUS_QMARK_COLON,
    ACTIONS(7355), 1,
      anon_sym_QMARK_COLON,
    STATE(3755), 1,
      sym_comment,
    STATE(4219), 4,
      sym_omitting_type_annotation,
      sym_adding_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [159208] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7351), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(7353), 1,
      anon_sym_PLUS_QMARK_COLON,
    ACTIONS(7355), 1,
      anon_sym_QMARK_COLON,
    STATE(3756), 1,
      sym_comment,
    STATE(4215), 4,
      sym_omitting_type_annotation,
      sym_adding_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [159236] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(7079), 1,
      sym_identifier,
    STATE(3757), 1,
      sym_comment,
    STATE(4799), 1,
      sym_string,
    STATE(5131), 1,
      sym__module_export_name,
    STATE(5853), 1,
      sym_export_specifier,
    ACTIONS(7081), 2,
      anon_sym_type,
      anon_sym_typeof,
  [159268] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7343), 1,
      sym_escape_sequence,
    ACTIONS(7347), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7349), 1,
      sym__template_chars,
    ACTIONS(7365), 1,
      anon_sym_BQUOTE,
    STATE(3758), 1,
      sym_comment,
    STATE(4057), 1,
      aux_sym_template_string_repeat1,
    STATE(4334), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(4725), 1,
      sym_template_substitution,
    STATE(5192), 1,
      sym_template_type,
  [159302] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    ACTIONS(7369), 1,
      anon_sym_DOT,
    STATE(3759), 1,
      sym_comment,
    STATE(4291), 1,
      sym_statement_block,
    ACTIONS(1822), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [159328] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3600), 1,
      sym_identifier,
    ACTIONS(3602), 1,
      anon_sym_LBRACE,
    ACTIONS(3604), 1,
      anon_sym_LBRACK,
    ACTIONS(7371), 1,
      anon_sym_enum,
    STATE(3760), 1,
      sym_comment,
    STATE(3972), 1,
      sym__destructuring_pattern,
    STATE(4825), 1,
      sym_variable_declarator,
    STATE(3973), 2,
      sym_object_pattern,
      sym_array_pattern,
  [159360] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7343), 1,
      sym_escape_sequence,
    ACTIONS(7347), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7349), 1,
      sym__template_chars,
    ACTIONS(7373), 1,
      anon_sym_BQUOTE,
    STATE(3761), 1,
      sym_comment,
    STATE(4057), 1,
      aux_sym_template_string_repeat1,
    STATE(4334), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(4725), 1,
      sym_template_substitution,
    STATE(5192), 1,
      sym_template_type,
  [159394] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7343), 1,
      sym_escape_sequence,
    ACTIONS(7347), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7349), 1,
      sym__template_chars,
    ACTIONS(7375), 1,
      anon_sym_BQUOTE,
    STATE(3762), 1,
      sym_comment,
    STATE(4178), 1,
      aux_sym_template_string_repeat1,
    STATE(4334), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(4725), 1,
      sym_template_substitution,
    STATE(5192), 1,
      sym_template_type,
  [159428] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7351), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(7353), 1,
      anon_sym_PLUS_QMARK_COLON,
    ACTIONS(7355), 1,
      anon_sym_QMARK_COLON,
    STATE(3763), 1,
      sym_comment,
    STATE(4559), 4,
      sym_omitting_type_annotation,
      sym_adding_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [159456] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7343), 1,
      sym_escape_sequence,
    ACTIONS(7347), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7349), 1,
      sym__template_chars,
    ACTIONS(7377), 1,
      anon_sym_BQUOTE,
    STATE(3764), 1,
      sym_comment,
    STATE(4178), 1,
      aux_sym_template_string_repeat1,
    STATE(4334), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(4725), 1,
      sym_template_substitution,
    STATE(5192), 1,
      sym_template_type,
  [159490] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7351), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(7353), 1,
      anon_sym_PLUS_QMARK_COLON,
    ACTIONS(7355), 1,
      anon_sym_QMARK_COLON,
    STATE(3765), 1,
      sym_comment,
    STATE(4547), 4,
      sym_omitting_type_annotation,
      sym_adding_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [159518] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7379), 1,
      anon_sym_EQ,
    STATE(3766), 1,
      sym_comment,
    ACTIONS(7381), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
  [159540] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7383), 1,
      anon_sym_EQ,
    STATE(3767), 1,
      sym_comment,
    ACTIONS(5913), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
  [159562] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7343), 1,
      sym_escape_sequence,
    ACTIONS(7347), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7349), 1,
      sym__template_chars,
    ACTIONS(7385), 1,
      anon_sym_BQUOTE,
    STATE(3768), 1,
      sym_comment,
    STATE(4178), 1,
      aux_sym_template_string_repeat1,
    STATE(4334), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(4725), 1,
      sym_template_substitution,
    STATE(5192), 1,
      sym_template_type,
  [159596] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    ACTIONS(7387), 1,
      anon_sym_DOT,
    STATE(3769), 1,
      sym_comment,
    STATE(4291), 1,
      sym_statement_block,
    ACTIONS(1822), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [159622] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7343), 1,
      sym_escape_sequence,
    ACTIONS(7347), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7349), 1,
      sym__template_chars,
    ACTIONS(7389), 1,
      anon_sym_BQUOTE,
    STATE(3770), 1,
      sym_comment,
    STATE(4178), 1,
      aux_sym_template_string_repeat1,
    STATE(4334), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(4725), 1,
      sym_template_substitution,
    STATE(5192), 1,
      sym_template_type,
  [159656] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3600), 1,
      sym_identifier,
    ACTIONS(3602), 1,
      anon_sym_LBRACE,
    ACTIONS(3604), 1,
      anon_sym_LBRACK,
    ACTIONS(7391), 1,
      anon_sym_enum,
    STATE(3771), 1,
      sym_comment,
    STATE(3972), 1,
      sym__destructuring_pattern,
    STATE(4750), 1,
      sym_variable_declarator,
    STATE(3973), 2,
      sym_object_pattern,
      sym_array_pattern,
  [159688] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7099), 1,
      anon_sym_AMP,
    ACTIONS(7101), 1,
      anon_sym_PIPE,
    ACTIONS(7103), 1,
      anon_sym_extends,
    STATE(3772), 1,
      sym_comment,
    ACTIONS(7057), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [159714] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6686), 1,
      anon_sym_LPAREN,
    ACTIONS(7393), 1,
      anon_sym_DOT,
    STATE(3773), 1,
      sym_comment,
    STATE(4082), 1,
      sym_arguments,
    ACTIONS(7075), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [159740] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3774), 1,
      sym_comment,
    ACTIONS(7381), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE_RBRACE,
  [159760] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    ACTIONS(7041), 1,
      anon_sym_BANG,
    STATE(3775), 1,
      sym_comment,
    STATE(4253), 1,
      sym_type_annotation,
    STATE(5401), 1,
      sym__initializer,
    ACTIONS(7039), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [159790] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3776), 1,
      sym_comment,
    ACTIONS(5913), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE_RBRACE,
  [159810] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3777), 1,
      sym_comment,
    STATE(4450), 1,
      sym_type_annotation,
    STATE(4985), 1,
      sym__initializer,
    ACTIONS(6964), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [159837] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7015), 1,
      anon_sym_LBRACE,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    STATE(2533), 1,
      sym_class_body,
    STATE(3778), 1,
      sym_comment,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5761), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [159868] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3602), 1,
      anon_sym_LBRACE,
    ACTIONS(3604), 1,
      anon_sym_LBRACK,
    ACTIONS(7395), 1,
      sym_identifier,
    STATE(3779), 1,
      sym_comment,
    STATE(3972), 1,
      sym__destructuring_pattern,
    STATE(4825), 1,
      sym_variable_declarator,
    STATE(3973), 2,
      sym_object_pattern,
      sym_array_pattern,
  [159897] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    ACTIONS(7199), 1,
      anon_sym_LBRACE,
    STATE(3780), 1,
      sym_comment,
    STATE(4497), 1,
      sym_class_body,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5641), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [159928] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3781), 1,
      sym_comment,
    STATE(4365), 1,
      sym_type_annotation,
    STATE(5130), 1,
      sym__initializer,
    ACTIONS(6964), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [159955] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3782), 1,
      sym_comment,
    STATE(4383), 1,
      sym_type_annotation,
    STATE(5094), 1,
      sym__initializer,
    ACTIONS(6964), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [159982] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7033), 1,
      anon_sym_LBRACE,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    STATE(2007), 1,
      sym_class_body,
    STATE(3783), 1,
      sym_comment,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5769), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [160013] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3602), 1,
      anon_sym_LBRACE,
    ACTIONS(3604), 1,
      anon_sym_LBRACK,
    ACTIONS(7395), 1,
      sym_identifier,
    STATE(3784), 1,
      sym_comment,
    STATE(3972), 1,
      sym__destructuring_pattern,
    STATE(4861), 1,
      sym_variable_declarator,
    STATE(3973), 2,
      sym_object_pattern,
      sym_array_pattern,
  [160042] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3785), 1,
      sym_comment,
    STATE(4415), 1,
      sym_type_annotation,
    STATE(5042), 1,
      sym__initializer,
    ACTIONS(6964), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160069] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3786), 1,
      sym_comment,
    STATE(4417), 1,
      sym_type_annotation,
    STATE(5041), 1,
      sym__initializer,
    ACTIONS(6964), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160096] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3787), 1,
      sym_comment,
    STATE(4345), 1,
      sym_type_annotation,
    ACTIONS(7397), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [160119] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3788), 1,
      sym_comment,
    STATE(4447), 1,
      sym_type_annotation,
    STATE(4987), 1,
      sym__initializer,
    ACTIONS(6964), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160146] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3789), 1,
      sym_comment,
    STATE(4320), 1,
      sym_type_annotation,
    STATE(5233), 1,
      sym__initializer,
    ACTIONS(7399), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160173] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3602), 1,
      anon_sym_LBRACE,
    ACTIONS(3604), 1,
      anon_sym_LBRACK,
    ACTIONS(7395), 1,
      sym_identifier,
    STATE(3790), 1,
      sym_comment,
    STATE(3972), 1,
      sym__destructuring_pattern,
    STATE(4859), 1,
      sym_variable_declarator,
    STATE(3973), 2,
      sym_object_pattern,
      sym_array_pattern,
  [160202] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3791), 1,
      sym_comment,
    STATE(4316), 1,
      sym_type_annotation,
    STATE(5238), 1,
      sym__initializer,
    ACTIONS(7399), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160229] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3792), 1,
      sym_comment,
    STATE(4487), 1,
      sym_type_annotation,
    STATE(4934), 1,
      sym__initializer,
    ACTIONS(6964), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160256] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3793), 1,
      sym_comment,
    STATE(4509), 1,
      sym_type_annotation,
    STATE(4903), 1,
      sym__initializer,
    ACTIONS(6964), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160283] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7023), 1,
      anon_sym_is,
    STATE(3794), 1,
      sym_comment,
    ACTIONS(4673), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [160304] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7033), 1,
      anon_sym_LBRACE,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    STATE(2040), 1,
      sym_class_body,
    STATE(3795), 1,
      sym_comment,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5742), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [160335] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    ACTIONS(7157), 1,
      anon_sym_LBRACE,
    STATE(2899), 1,
      sym_class_body,
    STATE(3796), 1,
      sym_comment,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5741), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [160366] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3797), 1,
      sym_comment,
    STATE(4554), 1,
      sym_type_annotation,
    STATE(4975), 1,
      sym__initializer,
    ACTIONS(6966), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160393] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    ACTIONS(7197), 1,
      anon_sym_LBRACE,
    STATE(3021), 1,
      sym_class_body,
    STATE(3798), 1,
      sym_comment,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5733), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [160424] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7015), 1,
      anon_sym_LBRACE,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    STATE(2566), 1,
      sym_class_body,
    STATE(3799), 1,
      sym_comment,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5732), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [160455] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3800), 1,
      sym_comment,
    STATE(4323), 1,
      sym_type_annotation,
    STATE(5222), 1,
      sym__initializer,
    ACTIONS(6974), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160482] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7023), 1,
      anon_sym_is,
    STATE(3801), 1,
      sym_comment,
    ACTIONS(4667), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [160503] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7033), 1,
      anon_sym_LBRACE,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    STATE(1951), 1,
      sym_class_body,
    STATE(3802), 1,
      sym_comment,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5786), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [160534] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7401), 1,
      anon_sym_is,
    STATE(3803), 1,
      sym_comment,
    ACTIONS(4661), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [160555] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(41), 1,
      anon_sym_import,
    ACTIONS(7403), 1,
      sym_identifier,
    STATE(3176), 1,
      sym__type_query_call_expression,
    STATE(3186), 1,
      sym__type_query_instantiation_expression,
    STATE(3433), 1,
      sym__type_query_subscript_expression,
    STATE(3448), 1,
      sym__type_query_member_expression,
    STATE(3804), 1,
      sym_comment,
    STATE(4794), 1,
      sym_import,
  [160586] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7405), 1,
      anon_sym_LBRACE,
    ACTIONS(7407), 1,
      anon_sym_LT,
    ACTIONS(7409), 1,
      anon_sym_extends,
    ACTIONS(7411), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2935), 1,
      sym_object_type,
    STATE(3805), 1,
      sym_comment,
    STATE(4643), 1,
      sym_type_parameters,
    STATE(5333), 1,
      sym_extends_type_clause,
  [160617] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(7413), 1,
      sym_identifier,
    ACTIONS(7415), 1,
      anon_sym_DOT,
    STATE(818), 1,
      sym__module,
    STATE(3806), 1,
      sym_comment,
    STATE(4359), 1,
      sym_nested_identifier,
    STATE(4682), 1,
      sym_string,
  [160648] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(7417), 1,
      sym_identifier,
    ACTIONS(7419), 1,
      anon_sym_STAR,
    STATE(3807), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5818), 1,
      sym__call_signature,
  [160679] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3808), 1,
      sym_comment,
    STATE(4303), 1,
      sym_type_annotation,
    STATE(5309), 1,
      sym__initializer,
    ACTIONS(6954), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160706] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3809), 1,
      sym_comment,
    STATE(4289), 1,
      sym_type_annotation,
    STATE(5343), 1,
      sym__initializer,
    ACTIONS(6954), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160733] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3810), 1,
      sym_comment,
    STATE(4275), 1,
      sym_type_annotation,
    STATE(5368), 1,
      sym__initializer,
    ACTIONS(6954), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160760] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3811), 1,
      sym_comment,
    STATE(4268), 1,
      sym_type_annotation,
    STATE(5369), 1,
      sym__initializer,
    ACTIONS(6954), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160787] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    ACTIONS(7229), 1,
      anon_sym_LBRACE,
    STATE(850), 1,
      sym_class_body,
    STATE(3812), 1,
      sym_comment,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5932), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [160818] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    ACTIONS(7157), 1,
      anon_sym_LBRACE,
    STATE(2884), 1,
      sym_class_body,
    STATE(3813), 1,
      sym_comment,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5714), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [160849] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3814), 1,
      sym_comment,
    STATE(4259), 1,
      sym_type_annotation,
    STATE(5393), 1,
      sym__initializer,
    ACTIONS(6954), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160876] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    ACTIONS(7197), 1,
      anon_sym_LBRACE,
    STATE(2972), 1,
      sym_class_body,
    STATE(3815), 1,
      sym_comment,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5711), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [160907] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3816), 1,
      sym_comment,
    STATE(4257), 1,
      sym_type_annotation,
    STATE(5399), 1,
      sym__initializer,
    ACTIONS(6954), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160934] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(6624), 1,
      anon_sym_LT,
    STATE(2025), 1,
      sym_arguments,
    STATE(3817), 1,
      sym_comment,
    STATE(5803), 1,
      sym_type_arguments,
    ACTIONS(7421), 3,
      anon_sym_LBRACK,
      sym_identifier,
      sym_private_property_identifier,
  [160961] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7423), 1,
      anon_sym_EQ,
    STATE(3818), 1,
      sym_comment,
    ACTIONS(3928), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [160982] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(7426), 1,
      sym_identifier,
    ACTIONS(7428), 1,
      anon_sym_STAR,
    STATE(3819), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5854), 1,
      sym__call_signature,
  [161013] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3820), 1,
      sym_comment,
    STATE(4240), 1,
      sym_type_annotation,
    STATE(5427), 1,
      sym__initializer,
    ACTIONS(6954), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161040] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3821), 1,
      sym_comment,
    STATE(4238), 1,
      sym_type_annotation,
    STATE(5429), 1,
      sym__initializer,
    ACTIONS(6954), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161067] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3602), 1,
      anon_sym_LBRACE,
    ACTIONS(3604), 1,
      anon_sym_LBRACK,
    ACTIONS(7395), 1,
      sym_identifier,
    STATE(3822), 1,
      sym_comment,
    STATE(3972), 1,
      sym__destructuring_pattern,
    STATE(4783), 1,
      sym_variable_declarator,
    STATE(3973), 2,
      sym_object_pattern,
      sym_array_pattern,
  [161096] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3823), 1,
      sym_comment,
    STATE(4229), 1,
      sym_type_annotation,
    STATE(5440), 1,
      sym__initializer,
    ACTIONS(6954), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161123] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3824), 1,
      sym_comment,
    STATE(4227), 1,
      sym_type_annotation,
    STATE(5444), 1,
      sym__initializer,
    ACTIONS(6954), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161150] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(41), 1,
      anon_sym_import,
    ACTIONS(7430), 1,
      sym_identifier,
    STATE(3169), 1,
      sym__type_query_member_expression,
    STATE(3171), 1,
      sym__type_query_subscript_expression,
    STATE(3335), 1,
      sym__type_query_call_expression,
    STATE(3474), 1,
      sym__type_query_instantiation_expression,
    STATE(3825), 1,
      sym_comment,
    STATE(4838), 1,
      sym_import,
  [161181] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4564), 1,
      anon_sym_COMMA,
    ACTIONS(4651), 1,
      anon_sym_RBRACE,
    STATE(3826), 1,
      sym_comment,
    STATE(4998), 1,
      aux_sym_object_repeat1,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [161206] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3827), 1,
      sym_comment,
    ACTIONS(7107), 7,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
  [161225] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3828), 1,
      sym_comment,
    ACTIONS(7109), 7,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
  [161244] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3829), 1,
      sym_comment,
    STATE(4199), 1,
      sym_type_annotation,
    STATE(5504), 1,
      sym__initializer,
    ACTIONS(6954), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161271] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3830), 1,
      sym_comment,
    STATE(4325), 1,
      sym_type_annotation,
    STATE(5230), 1,
      sym__initializer,
    ACTIONS(6954), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161298] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    ACTIONS(7199), 1,
      anon_sym_LBRACE,
    STATE(780), 1,
      sym_class_body,
    STATE(3831), 1,
      sym_comment,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5866), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [161329] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3832), 1,
      sym_comment,
    ACTIONS(7111), 7,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
  [161348] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7033), 1,
      anon_sym_LBRACE,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    STATE(2087), 1,
      sym_class_body,
    STATE(3833), 1,
      sym_comment,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5819), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [161379] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3834), 1,
      sym_comment,
    STATE(4512), 1,
      sym_type_annotation,
    STATE(4917), 1,
      sym__initializer,
    ACTIONS(6954), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161406] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3835), 1,
      sym_comment,
    ACTIONS(7113), 7,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
  [161425] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3836), 1,
      sym_comment,
    STATE(4517), 1,
      sym_type_annotation,
    STATE(4902), 1,
      sym__initializer,
    ACTIONS(6954), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161452] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3837), 1,
      sym_comment,
    STATE(4556), 1,
      sym_type_annotation,
    STATE(4946), 1,
      sym__initializer,
    ACTIONS(6954), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161479] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3838), 1,
      sym_comment,
    STATE(4562), 1,
      sym_type_annotation,
    STATE(4984), 1,
      sym__initializer,
    ACTIONS(6954), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161506] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3839), 1,
      sym_comment,
    STATE(4631), 1,
      sym_type_annotation,
    STATE(5296), 1,
      sym__initializer,
    ACTIONS(6954), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161533] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3840), 1,
      sym_comment,
    STATE(4606), 1,
      sym_type_annotation,
    ACTIONS(7432), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [161556] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3841), 1,
      sym_comment,
    STATE(4549), 1,
      sym_type_annotation,
    STATE(4986), 1,
      sym__initializer,
    ACTIONS(6954), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161583] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3842), 1,
      sym_comment,
    ACTIONS(3976), 7,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
  [161602] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3843), 1,
      sym_comment,
    ACTIONS(3974), 7,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
  [161621] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3844), 1,
      sym_comment,
    STATE(4616), 1,
      sym_type_annotation,
    ACTIONS(7434), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [161644] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3845), 1,
      sym_comment,
    STATE(4374), 1,
      sym_type_annotation,
    STATE(5112), 1,
      sym__initializer,
    ACTIONS(6954), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161671] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3846), 1,
      sym_comment,
    STATE(4342), 1,
      sym_type_annotation,
    STATE(5119), 1,
      sym__initializer,
    ACTIONS(6954), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161698] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3847), 1,
      sym_comment,
    STATE(4658), 1,
      sym_type_annotation,
    STATE(5498), 1,
      sym__initializer,
    ACTIONS(6950), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161725] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3848), 1,
      sym_comment,
    STATE(4642), 1,
      sym_type_annotation,
    STATE(5342), 1,
      sym__initializer,
    ACTIONS(6972), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161752] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3849), 1,
      sym_comment,
    STATE(4308), 1,
      sym_type_annotation,
    STATE(5260), 1,
      sym__initializer,
    ACTIONS(6954), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161779] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3850), 1,
      sym_comment,
    STATE(4306), 1,
      sym_type_annotation,
    STATE(5285), 1,
      sym__initializer,
    ACTIONS(6954), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161806] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3851), 1,
      sym_comment,
    STATE(4295), 1,
      sym_type_annotation,
    STATE(5332), 1,
      sym__initializer,
    ACTIONS(6954), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161833] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3852), 1,
      sym_comment,
    STATE(4267), 1,
      sym_type_annotation,
    STATE(5363), 1,
      sym__initializer,
    ACTIONS(6954), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161860] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7033), 1,
      anon_sym_LBRACE,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    STATE(2764), 1,
      sym_class_body,
    STATE(3853), 1,
      sym_comment,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5849), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [161891] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    ACTIONS(7171), 1,
      anon_sym_LBRACE,
    STATE(255), 1,
      sym_class_body,
    STATE(3854), 1,
      sym_comment,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5843), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [161922] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6970), 1,
      anon_sym_LT,
    ACTIONS(7021), 1,
      anon_sym_DOT,
    ACTIONS(7436), 1,
      anon_sym_LBRACE,
    ACTIONS(7438), 1,
      anon_sym_COMMA,
    ACTIONS(7440), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3855), 1,
      sym_comment,
    STATE(4778), 1,
      aux_sym_extends_type_clause_repeat1,
    STATE(5410), 1,
      sym_type_arguments,
  [161953] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    ACTIONS(7229), 1,
      anon_sym_LBRACE,
    STATE(851), 1,
      sym_class_body,
    STATE(3856), 1,
      sym_comment,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5838), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [161984] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3857), 1,
      sym_comment,
    STATE(4213), 1,
      sym_type_annotation,
    STATE(5469), 1,
      sym__initializer,
    ACTIONS(6978), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [162011] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    ACTIONS(7199), 1,
      anon_sym_LBRACE,
    STATE(771), 1,
      sym_class_body,
    STATE(3858), 1,
      sym_comment,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5793), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [162042] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3859), 1,
      sym_comment,
    ACTIONS(1946), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE_RBRACE,
  [162061] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3860), 1,
      sym_comment,
    ACTIONS(1874), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE_RBRACE,
  [162080] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3861), 1,
      sym_comment,
    STATE(4198), 1,
      sym_type_annotation,
    STATE(5503), 1,
      sym__initializer,
    ACTIONS(6960), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [162107] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3862), 1,
      sym_comment,
    STATE(4364), 1,
      sym_type_annotation,
    STATE(5128), 1,
      sym__initializer,
    ACTIONS(6980), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [162134] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3863), 1,
      sym_comment,
    STATE(4376), 1,
      sym_type_annotation,
    STATE(5405), 1,
      sym__initializer,
    ACTIONS(6980), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [162161] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(3864), 1,
      sym_comment,
    STATE(4291), 1,
      sym_statement_block,
    ACTIONS(1822), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [162184] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7015), 1,
      anon_sym_LBRACE,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    STATE(2590), 1,
      sym_class_body,
    STATE(3865), 1,
      sym_comment,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5775), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [162215] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(41), 1,
      anon_sym_import,
    ACTIONS(7442), 1,
      sym_identifier,
    STATE(1944), 1,
      sym__type_query_subscript_expression,
    STATE(1945), 1,
      sym__type_query_member_expression,
    STATE(2378), 1,
      sym__type_query_call_expression,
    STATE(2380), 1,
      sym__type_query_instantiation_expression,
    STATE(3866), 1,
      sym_comment,
    STATE(4823), 1,
      sym_import,
  [162246] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3867), 1,
      sym_comment,
    STATE(4305), 1,
      sym_type_annotation,
    STATE(5301), 1,
      sym__initializer,
    ACTIONS(7399), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [162273] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3696), 1,
      anon_sym_DQUOTE,
    ACTIONS(3698), 1,
      anon_sym_SQUOTE,
    ACTIONS(7444), 1,
      sym_identifier,
    ACTIONS(7446), 1,
      anon_sym_DOT,
    STATE(2781), 1,
      sym_nested_identifier,
    STATE(2835), 1,
      sym_string,
    STATE(2996), 1,
      sym__module,
    STATE(3868), 1,
      sym_comment,
  [162304] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1111), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2006), 1,
      anon_sym_LBRACE,
    ACTIONS(7407), 1,
      anon_sym_LT,
    ACTIONS(7409), 1,
      anon_sym_extends,
    STATE(3869), 1,
      sym_comment,
    STATE(4404), 1,
      sym_type_parameters,
    STATE(4441), 1,
      sym_object_type,
    STATE(5059), 1,
      sym_extends_type_clause,
  [162335] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(3870), 1,
      sym_comment,
    STATE(5884), 1,
      sym_statement_block,
    ACTIONS(7448), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [162358] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3871), 1,
      sym_comment,
    STATE(4302), 1,
      sym_type_annotation,
    STATE(5305), 1,
      sym__initializer,
    ACTIONS(7399), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [162385] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3872), 1,
      sym_comment,
    STATE(4550), 1,
      sym_type_annotation,
    ACTIONS(7450), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [162408] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3873), 1,
      sym_comment,
    STATE(4537), 1,
      sym_type_annotation,
    STATE(4871), 1,
      sym__initializer,
    ACTIONS(6958), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [162435] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7033), 1,
      anon_sym_LBRACE,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    STATE(2791), 1,
      sym_class_body,
    STATE(3874), 1,
      sym_comment,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5752), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [162466] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    ACTIONS(7221), 1,
      anon_sym_LBRACE,
    STATE(961), 1,
      sym_class_body,
    STATE(3875), 1,
      sym_comment,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5656), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [162497] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(7452), 1,
      anon_sym_COLON,
    ACTIONS(7454), 1,
      anon_sym_QMARK,
    STATE(3876), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5574), 1,
      sym__call_signature,
  [162528] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3877), 1,
      sym_comment,
    STATE(4332), 1,
      sym_type_annotation,
    STATE(5202), 1,
      sym__initializer,
    ACTIONS(6960), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [162555] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3878), 1,
      sym_comment,
    STATE(4378), 1,
      sym_type_annotation,
    STATE(5102), 1,
      sym__initializer,
    ACTIONS(6980), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [162582] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3879), 1,
      sym_comment,
    STATE(4384), 1,
      sym_type_annotation,
    STATE(5092), 1,
      sym__initializer,
    ACTIONS(6980), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [162609] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3880), 1,
      sym_comment,
    STATE(4338), 1,
      sym_type_annotation,
    STATE(5194), 1,
      sym__initializer,
    ACTIONS(6960), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [162636] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    ACTIONS(7171), 1,
      anon_sym_LBRACE,
    STATE(251), 1,
      sym_class_body,
    STATE(3881), 1,
      sym_comment,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5753), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [162667] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3602), 1,
      anon_sym_LBRACE,
    ACTIONS(3604), 1,
      anon_sym_LBRACK,
    ACTIONS(7456), 1,
      sym_identifier,
    STATE(3707), 1,
      sym__destructuring_pattern,
    STATE(3882), 1,
      sym_comment,
    STATE(4750), 1,
      sym_variable_declarator,
    STATE(3973), 2,
      sym_object_pattern,
      sym_array_pattern,
  [162696] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3602), 1,
      anon_sym_LBRACE,
    ACTIONS(3604), 1,
      anon_sym_LBRACK,
    ACTIONS(7458), 1,
      sym_identifier,
    STATE(3705), 1,
      sym__destructuring_pattern,
    STATE(3883), 1,
      sym_comment,
    STATE(4783), 1,
      sym_variable_declarator,
    STATE(3973), 2,
      sym_object_pattern,
      sym_array_pattern,
  [162725] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    ACTIONS(7199), 1,
      anon_sym_LBRACE,
    STATE(3884), 1,
      sym_comment,
    STATE(4314), 1,
      sym_class_body,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5621), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [162756] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3885), 1,
      sym_comment,
    STATE(4389), 1,
      sym_type_annotation,
    STATE(4995), 1,
      sym__initializer,
    ACTIONS(6960), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [162783] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3886), 1,
      sym_comment,
    STATE(4300), 1,
      sym_type_annotation,
    STATE(5066), 1,
      sym__initializer,
    ACTIONS(6960), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [162810] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3887), 1,
      sym_comment,
    STATE(4388), 1,
      sym_type_annotation,
    STATE(5063), 1,
      sym__initializer,
    ACTIONS(6980), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [162837] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3888), 1,
      sym_comment,
    STATE(4402), 1,
      sym_type_annotation,
    STATE(5061), 1,
      sym__initializer,
    ACTIONS(6980), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [162864] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3889), 1,
      sym_comment,
    STATE(4423), 1,
      sym_type_annotation,
    STATE(5030), 1,
      sym__initializer,
    ACTIONS(6960), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [162891] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3890), 1,
      sym_comment,
    STATE(4439), 1,
      sym_type_annotation,
    STATE(5016), 1,
      sym__initializer,
    ACTIONS(6960), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [162918] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3891), 1,
      sym_comment,
    STATE(4408), 1,
      sym_type_annotation,
    STATE(5054), 1,
      sym__initializer,
    ACTIONS(6980), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [162945] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3892), 1,
      sym_comment,
    STATE(4409), 1,
      sym_type_annotation,
    STATE(5045), 1,
      sym__initializer,
    ACTIONS(6980), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [162972] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(6999), 1,
      sym_identifier,
    ACTIONS(7053), 1,
      anon_sym_type,
    STATE(3893), 1,
      sym_comment,
    STATE(4799), 1,
      sym_string,
    STATE(5738), 1,
      sym__import_identifier,
    STATE(6061), 1,
      sym__module_export_name,
  [163003] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3894), 1,
      sym_comment,
    STATE(4454), 1,
      sym_type_annotation,
    STATE(4980), 1,
      sym__initializer,
    ACTIONS(6960), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [163030] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3895), 1,
      sym_comment,
    STATE(4465), 1,
      sym_type_annotation,
    STATE(4976), 1,
      sym__initializer,
    ACTIONS(6960), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [163057] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    ACTIONS(7199), 1,
      anon_sym_LBRACE,
    STATE(3896), 1,
      sym_comment,
    STATE(4467), 1,
      sym_class_body,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5637), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [163088] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    ACTIONS(7221), 1,
      anon_sym_LBRACE,
    STATE(945), 1,
      sym_class_body,
    STATE(3897), 1,
      sym_comment,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5636), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [163119] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(7460), 1,
      sym_identifier,
    ACTIONS(7462), 1,
      anon_sym_STAR,
    STATE(3898), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5547), 1,
      sym__call_signature,
  [163150] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3899), 1,
      sym_comment,
    STATE(4514), 1,
      sym_type_annotation,
    STATE(4901), 1,
      sym__initializer,
    ACTIONS(6960), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [163177] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3900), 1,
      sym_comment,
    STATE(4405), 1,
      sym_type_annotation,
    STATE(5268), 1,
      sym__initializer,
    ACTIONS(6960), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [163204] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3901), 1,
      sym_comment,
    STATE(4479), 1,
      sym_type_annotation,
    STATE(4951), 1,
      sym__initializer,
    ACTIONS(6980), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [163231] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3902), 1,
      sym_comment,
    STATE(4480), 1,
      sym_type_annotation,
    STATE(4928), 1,
      sym__initializer,
    ACTIONS(6980), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [163258] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    ACTIONS(7199), 1,
      anon_sym_LBRACE,
    STATE(3903), 1,
      sym_comment,
    STATE(4392), 1,
      sym_class_body,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5622), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [163289] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(3904), 1,
      sym_comment,
    STATE(5883), 1,
      sym_statement_block,
    ACTIONS(7464), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [163312] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_STAR,
    STATE(3905), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5580), 1,
      sym__call_signature,
  [163343] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3906), 1,
      sym_comment,
    ACTIONS(7119), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [163362] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3907), 1,
      sym_comment,
    ACTIONS(7121), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [163381] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3908), 1,
      sym_comment,
    ACTIONS(5990), 7,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [163400] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3909), 1,
      sym_comment,
    STATE(4602), 1,
      sym_type_annotation,
    STATE(5226), 1,
      sym__initializer,
    ACTIONS(6960), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [163427] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3910), 1,
      sym_comment,
    STATE(4627), 1,
      sym_type_annotation,
    STATE(5237), 1,
      sym__initializer,
    ACTIONS(6960), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [163454] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3911), 1,
      sym_comment,
    ACTIONS(7123), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [163473] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3912), 1,
      sym_comment,
    STATE(4660), 1,
      sym_type_annotation,
    STATE(5468), 1,
      sym__initializer,
    ACTIONS(6960), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [163500] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3913), 1,
      sym_comment,
    STATE(4645), 1,
      sym_type_annotation,
    STATE(5398), 1,
      sym__initializer,
    ACTIONS(6960), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [163527] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7015), 1,
      anon_sym_LBRACE,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    STATE(2666), 1,
      sym_class_body,
    STATE(3914), 1,
      sym_comment,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5693), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [163558] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6932), 1,
      anon_sym_EQ,
    STATE(3915), 1,
      sym_comment,
    STATE(4827), 1,
      sym_constraint,
    STATE(5680), 1,
      sym_default_type,
    ACTIONS(6937), 2,
      anon_sym_COLON,
      anon_sym_extends,
    ACTIONS(7470), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [163585] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7015), 1,
      anon_sym_LBRACE,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    STATE(2656), 1,
      sym_class_body,
    STATE(3916), 1,
      sym_comment,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5650), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [163616] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3917), 1,
      sym_comment,
    STATE(4504), 1,
      sym_type_annotation,
    STATE(4906), 1,
      sym__initializer,
    ACTIONS(6980), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [163643] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(132), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1755), 1,
      anon_sym_LBRACE,
    ACTIONS(7407), 1,
      anon_sym_LT,
    ACTIONS(7409), 1,
      anon_sym_extends,
    STATE(815), 1,
      sym_object_type,
    STATE(3918), 1,
      sym_comment,
    STATE(4397), 1,
      sym_type_parameters,
    STATE(5068), 1,
      sym_extends_type_clause,
  [163674] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3610), 1,
      anon_sym_DQUOTE,
    ACTIONS(3612), 1,
      anon_sym_SQUOTE,
    ACTIONS(7415), 1,
      anon_sym_DOT,
    ACTIONS(7472), 1,
      sym_identifier,
    STATE(755), 1,
      sym_nested_identifier,
    STATE(760), 1,
      sym_string,
    STATE(818), 1,
      sym__module,
    STATE(3919), 1,
      sym_comment,
  [163705] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(7474), 1,
      sym_identifier,
    ACTIONS(7476), 1,
      anon_sym_STAR,
    STATE(3920), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5580), 1,
      sym__call_signature,
  [163736] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    STATE(3921), 1,
      sym_comment,
    ACTIONS(4604), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [163759] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3602), 1,
      anon_sym_LBRACE,
    ACTIONS(3604), 1,
      anon_sym_LBRACK,
    ACTIONS(7395), 1,
      sym_identifier,
    STATE(3922), 1,
      sym_comment,
    STATE(3972), 1,
      sym__destructuring_pattern,
    STATE(4750), 1,
      sym_variable_declarator,
    STATE(3973), 2,
      sym_object_pattern,
      sym_array_pattern,
  [163788] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6932), 1,
      anon_sym_EQ,
    STATE(3923), 1,
      sym_comment,
    STATE(4773), 1,
      sym_constraint,
    STATE(5590), 1,
      sym_default_type,
    ACTIONS(6937), 2,
      anon_sym_COLON,
      anon_sym_extends,
    ACTIONS(7478), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [163815] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(41), 1,
      anon_sym_import,
    ACTIONS(7480), 1,
      sym_identifier,
    STATE(1684), 1,
      sym__type_query_member_expression,
    STATE(1697), 1,
      sym__type_query_subscript_expression,
    STATE(1769), 1,
      sym__type_query_call_expression,
    STATE(1770), 1,
      sym__type_query_instantiation_expression,
    STATE(3924), 1,
      sym_comment,
    STATE(4731), 1,
      sym_import,
  [163846] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3925), 1,
      sym_comment,
    ACTIONS(7145), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [163865] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3926), 1,
      sym_comment,
    ACTIONS(7147), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [163884] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(7482), 1,
      sym_identifier,
    ACTIONS(7484), 1,
      anon_sym_DOT,
    STATE(3759), 1,
      sym_nested_identifier,
    STATE(3864), 1,
      sym_string,
    STATE(3927), 1,
      sym_comment,
    STATE(4287), 1,
      sym__module,
  [163915] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3928), 1,
      sym_comment,
    STATE(4570), 1,
      sym_type_annotation,
    STATE(5088), 1,
      sym__initializer,
    ACTIONS(6960), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [163942] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3929), 1,
      sym_comment,
    STATE(4553), 1,
      sym_type_annotation,
    STATE(5053), 1,
      sym__initializer,
    ACTIONS(6960), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [163969] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3930), 1,
      sym_comment,
    STATE(4463), 1,
      sym_type_annotation,
    STATE(4876), 1,
      sym__initializer,
    ACTIONS(6960), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [163996] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3931), 1,
      sym_comment,
    STATE(4296), 1,
      sym_type_annotation,
    STATE(4977), 1,
      sym__initializer,
    ACTIONS(6960), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [164023] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7486), 1,
      anon_sym_EQ,
    STATE(3932), 1,
      sym_comment,
    ACTIONS(3908), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [164044] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3933), 1,
      sym_comment,
    ACTIONS(5384), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [164063] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(6624), 1,
      anon_sym_LT,
    STATE(2437), 1,
      sym_arguments,
    STATE(3934), 1,
      sym_comment,
    STATE(5599), 1,
      sym_type_arguments,
    ACTIONS(7421), 3,
      anon_sym_LBRACK,
      sym_identifier,
      sym_private_property_identifier,
  [164090] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3814), 1,
      anon_sym_LPAREN,
    ACTIONS(7488), 1,
      anon_sym_DOT,
    STATE(1207), 1,
      sym_arguments,
    STATE(3935), 1,
      sym_comment,
    ACTIONS(3651), 4,
      anon_sym_export,
      anon_sym_class,
      anon_sym_AT,
      anon_sym_abstract,
  [164115] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7015), 1,
      anon_sym_LBRACE,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    STATE(2538), 1,
      sym_class_body,
    STATE(3936), 1,
      sym_comment,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5587), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [164146] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4659), 1,
      anon_sym_extends,
    ACTIONS(7490), 1,
      sym_identifier,
    STATE(3937), 1,
      sym_comment,
    ACTIONS(4661), 5,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
  [164169] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(41), 1,
      anon_sym_import,
    ACTIONS(7492), 1,
      sym_identifier,
    STATE(3126), 1,
      sym__type_query_member_expression,
    STATE(3129), 1,
      sym__type_query_subscript_expression,
    STATE(3176), 1,
      sym__type_query_call_expression,
    STATE(3186), 1,
      sym__type_query_instantiation_expression,
    STATE(3938), 1,
      sym_comment,
    STATE(4767), 1,
      sym_import,
  [164200] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(7494), 1,
      sym_identifier,
    ACTIONS(7496), 1,
      anon_sym_STAR,
    STATE(3939), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5580), 1,
      sym__call_signature,
  [164231] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7015), 1,
      anon_sym_LBRACE,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    STATE(2591), 1,
      sym_class_body,
    STATE(3940), 1,
      sym_comment,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5579), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [164262] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3941), 1,
      sym_comment,
    STATE(4536), 1,
      sym_type_annotation,
    STATE(5000), 1,
      sym__initializer,
    ACTIONS(6980), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [164289] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3942), 1,
      sym_comment,
    STATE(4539), 1,
      sym_type_annotation,
    STATE(4865), 1,
      sym__initializer,
    ACTIONS(6980), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [164316] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3855), 1,
      anon_sym_COLON,
    ACTIONS(7498), 1,
      anon_sym_EQ,
    ACTIONS(7502), 1,
      anon_sym_QMARK,
    STATE(3943), 1,
      sym_comment,
    STATE(4761), 1,
      sym_type_annotation,
    STATE(5575), 1,
      sym__initializer,
    ACTIONS(7500), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [164345] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(7454), 1,
      anon_sym_QMARK,
    ACTIONS(7504), 1,
      anon_sym_COLON,
    STATE(3944), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5574), 1,
      sym__call_signature,
  [164376] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7015), 1,
      anon_sym_LBRACE,
    ACTIONS(7129), 1,
      anon_sym_extends,
    ACTIONS(7131), 1,
      anon_sym_implements,
    STATE(2495), 1,
      sym_class_body,
    STATE(3945), 1,
      sym_comment,
    STATE(5349), 1,
      sym_extends_clause,
    STATE(5572), 1,
      sym_class_heritage,
    STATE(6269), 1,
      sym_implements_clause,
  [164407] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(7506), 1,
      sym_identifier,
    ACTIONS(7508), 1,
      anon_sym_STAR,
    STATE(3946), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5547), 1,
      sym__call_signature,
  [164438] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(7510), 1,
      sym_identifier,
    ACTIONS(7512), 1,
      anon_sym_STAR,
    STATE(3947), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5547), 1,
      sym__call_signature,
  [164469] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3602), 1,
      anon_sym_LBRACE,
    ACTIONS(3604), 1,
      anon_sym_LBRACK,
    ACTIONS(7395), 1,
      sym_identifier,
    STATE(3948), 1,
      sym_comment,
    STATE(3972), 1,
      sym__destructuring_pattern,
    STATE(5274), 1,
      sym_variable_declarator,
    STATE(3973), 2,
      sym_object_pattern,
      sym_array_pattern,
  [164498] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3949), 1,
      sym_comment,
    ACTIONS(3928), 7,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [164517] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3950), 1,
      sym_comment,
    STATE(4310), 1,
      sym_type_annotation,
    STATE(5279), 1,
      sym__initializer,
    ACTIONS(6960), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [164544] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7514), 1,
      anon_sym_EQ,
    STATE(3951), 1,
      sym_comment,
    ACTIONS(3928), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [164565] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3952), 1,
      sym_comment,
    STATE(4566), 1,
      sym_type_annotation,
    STATE(5082), 1,
      sym__initializer,
    ACTIONS(6980), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [164592] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3953), 1,
      sym_comment,
    STATE(4575), 1,
      sym_type_annotation,
    STATE(5085), 1,
      sym__initializer,
    ACTIONS(6980), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [164619] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3954), 1,
      sym_comment,
    ACTIONS(5310), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [164638] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3955), 1,
      sym_comment,
    ACTIONS(5965), 7,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [164657] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3956), 1,
      sym_comment,
    ACTIONS(5355), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [164676] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3957), 1,
      sym_comment,
    STATE(4207), 1,
      sym_type_annotation,
    STATE(5486), 1,
      sym__initializer,
    ACTIONS(6960), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [164703] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3958), 1,
      sym_comment,
    STATE(4214), 1,
      sym_type_annotation,
    STATE(5476), 1,
      sym__initializer,
    ACTIONS(6960), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [164730] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3959), 1,
      sym_comment,
    STATE(4216), 1,
      sym_type_annotation,
    STATE(5471), 1,
      sym__initializer,
    ACTIONS(6960), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [164757] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3960), 1,
      sym_comment,
    ACTIONS(7517), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [164776] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3961), 1,
      sym_comment,
    STATE(4588), 1,
      sym_type_annotation,
    STATE(5181), 1,
      sym__initializer,
    ACTIONS(6980), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [164803] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3962), 1,
      sym_comment,
    STATE(4593), 1,
      sym_type_annotation,
    STATE(5200), 1,
      sym__initializer,
    ACTIONS(6980), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [164830] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(7519), 1,
      sym_identifier,
    ACTIONS(7521), 1,
      anon_sym_STAR,
    STATE(3963), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5547), 1,
      sym__call_signature,
  [164861] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(7523), 1,
      sym_identifier,
    ACTIONS(7525), 1,
      anon_sym_STAR,
    STATE(3964), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5580), 1,
      sym__call_signature,
  [164892] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3965), 1,
      sym_comment,
    STATE(4599), 1,
      sym_type_annotation,
    STATE(5134), 1,
      sym__initializer,
    ACTIONS(6980), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [164919] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3966), 1,
      sym_comment,
    STATE(4628), 1,
      sym_type_annotation,
    STATE(5281), 1,
      sym__initializer,
    ACTIONS(6980), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [164946] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7527), 1,
      anon_sym_EQ,
    ACTIONS(7529), 1,
      anon_sym_DOT,
    STATE(3967), 1,
      sym_comment,
    ACTIONS(7339), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
  [164969] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3968), 1,
      sym_comment,
    ACTIONS(7531), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [164988] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(7533), 1,
      sym_identifier,
    ACTIONS(7535), 1,
      anon_sym_STAR,
    STATE(3969), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5547), 1,
      sym__call_signature,
  [165019] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(7537), 1,
      sym_identifier,
    ACTIONS(7539), 1,
      anon_sym_STAR,
    STATE(3970), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5580), 1,
      sym__call_signature,
  [165050] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3971), 1,
      sym_comment,
    STATE(4232), 1,
      sym_type_annotation,
    STATE(5443), 1,
      sym__initializer,
    ACTIONS(6960), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165077] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3972), 1,
      sym_comment,
    STATE(4253), 1,
      sym_type_annotation,
    STATE(5394), 1,
      sym__initializer,
    ACTIONS(7039), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165104] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3973), 1,
      sym_comment,
    ACTIONS(7159), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [165123] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(41), 1,
      anon_sym_import,
    ACTIONS(7541), 1,
      sym_identifier,
    STATE(3191), 1,
      sym__type_query_subscript_expression,
    STATE(3195), 1,
      sym__type_query_member_expression,
    STATE(3489), 1,
      sym__type_query_call_expression,
    STATE(3553), 1,
      sym__type_query_instantiation_expression,
    STATE(3974), 1,
      sym_comment,
    STATE(4687), 1,
      sym_import,
  [165154] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3975), 1,
      sym_comment,
    STATE(4649), 1,
      sym_type_annotation,
    STATE(5243), 1,
      sym__initializer,
    ACTIONS(6980), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165181] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3976), 1,
      sym_comment,
    STATE(4646), 1,
      sym_type_annotation,
    STATE(5360), 1,
      sym__initializer,
    ACTIONS(6980), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165208] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(3977), 1,
      sym_comment,
    STATE(5642), 1,
      sym_statement_block,
    ACTIONS(7543), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [165231] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3978), 1,
      sym_comment,
    ACTIONS(7545), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [165250] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(3979), 1,
      sym_comment,
    ACTIONS(7547), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [165269] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(3980), 1,
      sym_comment,
    STATE(5886), 1,
      sym_statement_block,
    ACTIONS(7549), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [165292] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(3981), 1,
      sym_comment,
    STATE(5748), 1,
      sym_statement_block,
    ACTIONS(7551), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [165315] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(3982), 1,
      sym_comment,
    STATE(5805), 1,
      sym_statement_block,
    ACTIONS(7553), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [165338] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(3983), 1,
      sym_comment,
    STATE(5834), 1,
      sym_statement_block,
    ACTIONS(7555), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [165361] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(3984), 1,
      sym_comment,
    STATE(5879), 1,
      sym_statement_block,
    ACTIONS(7555), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [165384] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3985), 1,
      sym_comment,
    STATE(4236), 1,
      sym_type_annotation,
    STATE(5438), 1,
      sym__initializer,
    ACTIONS(6960), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165411] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(3986), 1,
      sym_comment,
    STATE(5885), 1,
      sym_statement_block,
    ACTIONS(7553), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [165434] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(3987), 1,
      sym_comment,
    STATE(5728), 1,
      sym_statement_block,
    ACTIONS(7549), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [165457] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(3988), 1,
      sym_comment,
    STATE(5889), 1,
      sym_statement_block,
    ACTIONS(7557), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [165480] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3602), 1,
      anon_sym_LBRACE,
    ACTIONS(3604), 1,
      anon_sym_LBRACK,
    ACTIONS(7395), 1,
      sym_identifier,
    STATE(3972), 1,
      sym__destructuring_pattern,
    STATE(3989), 1,
      sym_comment,
    STATE(4699), 1,
      sym_variable_declarator,
    STATE(3973), 2,
      sym_object_pattern,
      sym_array_pattern,
  [165509] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3990), 1,
      sym_comment,
    STATE(4254), 1,
      sym_type_annotation,
    STATE(5403), 1,
      sym__initializer,
    ACTIONS(6960), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165536] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(3991), 1,
      sym_comment,
    STATE(5881), 1,
      sym_statement_block,
    ACTIONS(7559), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [165559] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3992), 1,
      sym_comment,
    STATE(4283), 1,
      sym_type_annotation,
    STATE(5365), 1,
      sym__initializer,
    ACTIONS(6960), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165586] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3993), 1,
      sym_comment,
    STATE(4285), 1,
      sym_type_annotation,
    STATE(5352), 1,
      sym__initializer,
    ACTIONS(6960), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165613] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(3994), 1,
      sym_comment,
    STATE(5935), 1,
      sym_statement_block,
    ACTIONS(7464), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [165636] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(3995), 1,
      sym_comment,
    STATE(5896), 1,
      sym_statement_block,
    ACTIONS(7561), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [165659] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(3996), 1,
      sym_comment,
    STATE(5898), 1,
      sym_statement_block,
    ACTIONS(7563), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [165682] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(3997), 1,
      sym_comment,
    STATE(5882), 1,
      sym_statement_block,
    ACTIONS(7565), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [165705] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3998), 1,
      sym_comment,
    STATE(4613), 1,
      sym_type_annotation,
    STATE(4961), 1,
      sym__initializer,
    ACTIONS(6980), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165732] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(3999), 1,
      sym_comment,
    STATE(4605), 1,
      sym_type_annotation,
    STATE(5229), 1,
      sym__initializer,
    ACTIONS(6980), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165759] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(4000), 1,
      sym_comment,
    STATE(5723), 1,
      sym_statement_block,
    ACTIONS(7448), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [165782] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(4001), 1,
      sym_comment,
    STATE(4196), 1,
      sym_type_annotation,
    STATE(5242), 1,
      sym__initializer,
    ACTIONS(6960), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165809] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(4002), 1,
      sym_comment,
    STATE(5880), 1,
      sym_statement_block,
    ACTIONS(7567), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [165832] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(4003), 1,
      sym_comment,
    STATE(5919), 1,
      sym_statement_block,
    ACTIONS(7559), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [165855] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(4004), 1,
      sym_comment,
    STATE(5905), 1,
      sym_statement_block,
    ACTIONS(7569), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [165878] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(4005), 1,
      sym_comment,
    STATE(4400), 1,
      sym_type_annotation,
    STATE(5074), 1,
      sym__initializer,
    ACTIONS(6960), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165905] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(4006), 1,
      sym_comment,
    STATE(5907), 1,
      sym_statement_block,
    ACTIONS(7567), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [165928] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(4007), 1,
      sym_comment,
    STATE(4432), 1,
      sym_type_annotation,
    STATE(5064), 1,
      sym__initializer,
    ACTIONS(6960), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165955] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(4008), 1,
      sym_comment,
    STATE(4410), 1,
      sym_type_annotation,
    STATE(5060), 1,
      sym__initializer,
    ACTIONS(6960), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165982] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(4009), 1,
      sym_comment,
    STATE(4263), 1,
      sym_type_annotation,
    STATE(5400), 1,
      sym__initializer,
    ACTIONS(6960), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [166009] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(4010), 1,
      sym_comment,
    STATE(4431), 1,
      sym_type_annotation,
    STATE(5012), 1,
      sym__initializer,
    ACTIONS(6960), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [166036] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(4011), 1,
      sym_comment,
    STATE(5921), 1,
      sym_statement_block,
    ACTIONS(7565), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [166059] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(4012), 1,
      sym_comment,
    STATE(4576), 1,
      sym_type_annotation,
    STATE(5090), 1,
      sym__initializer,
    ACTIONS(7571), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [166086] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4013), 1,
      sym_comment,
    STATE(4093), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(7575), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7573), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [166108] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4014), 1,
      sym_comment,
    ACTIONS(2398), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [166126] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4015), 1,
      sym_comment,
    STATE(4127), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3824), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7577), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [166148] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4016), 1,
      sym_comment,
    STATE(4048), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3824), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7577), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [166170] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7579), 1,
      sym_identifier,
    STATE(4017), 1,
      sym_comment,
    ACTIONS(6644), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT,
      anon_sym_BQUOTE,
  [166190] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7581), 1,
      anon_sym_as,
    ACTIONS(7585), 1,
      anon_sym_DOT,
    ACTIONS(7587), 1,
      aux_sym_ui_version_specifier_token1,
    STATE(4018), 1,
      sym_comment,
    STATE(5461), 1,
      sym_ui_version_specifier,
    ACTIONS(7583), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [166216] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7587), 1,
      aux_sym_ui_version_specifier_token1,
    ACTIONS(7589), 1,
      anon_sym_as,
    ACTIONS(7593), 1,
      anon_sym_DOT,
    STATE(4019), 1,
      sym_comment,
    STATE(5455), 1,
      sym_ui_version_specifier,
    ACTIONS(7591), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [166242] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7595), 1,
      sym_identifier,
    STATE(4020), 1,
      sym_comment,
    ACTIONS(6644), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT,
      anon_sym_BQUOTE,
  [166262] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4015), 1,
      aux_sym_object_type_repeat1,
    STATE(4021), 1,
      sym_comment,
    ACTIONS(7599), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7597), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [166284] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4022), 1,
      sym_comment,
    ACTIONS(7517), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [166302] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2132), 1,
      sym_statement_block,
    STATE(4023), 1,
      sym_comment,
    ACTIONS(7567), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [166324] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6796), 1,
      anon_sym_LPAREN,
    ACTIONS(7601), 1,
      anon_sym_QMARK,
    STATE(3571), 1,
      sym_formal_parameters,
    STATE(4024), 1,
      sym_comment,
    STATE(4158), 1,
      sym__call_signature,
    STATE(5701), 1,
      sym_type_parameters,
  [166352] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2484), 1,
      anon_sym_LBRACE,
    ACTIONS(6511), 1,
      anon_sym_COLON,
    ACTIONS(6513), 1,
      anon_sym_DOT,
    ACTIONS(7097), 1,
      anon_sym_on,
    ACTIONS(7603), 1,
      anon_sym_function,
    STATE(2802), 1,
      sym_ui_object_initializer,
    STATE(4025), 1,
      sym_comment,
  [166380] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2484), 1,
      anon_sym_LBRACE,
    ACTIONS(6511), 1,
      anon_sym_COLON,
    ACTIONS(6513), 1,
      anon_sym_DOT,
    ACTIONS(7071), 1,
      anon_sym_on,
    ACTIONS(7605), 1,
      sym_identifier,
    STATE(2802), 1,
      sym_ui_object_initializer,
    STATE(4026), 1,
      sym_comment,
  [166408] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2484), 1,
      anon_sym_LBRACE,
    ACTIONS(6511), 1,
      anon_sym_COLON,
    ACTIONS(6513), 1,
      anon_sym_DOT,
    ACTIONS(7071), 1,
      anon_sym_on,
    ACTIONS(7607), 1,
      sym_identifier,
    STATE(2802), 1,
      sym_ui_object_initializer,
    STATE(4027), 1,
      sym_comment,
  [166436] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(7609), 1,
      anon_sym_COMMA,
    ACTIONS(7611), 1,
      anon_sym_GT,
    STATE(4028), 1,
      sym_comment,
    STATE(5496), 1,
      aux_sym_type_arguments_repeat1,
  [166464] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3814), 1,
      anon_sym_LPAREN,
    ACTIONS(7143), 1,
      anon_sym_DOT,
    ACTIONS(7613), 1,
      anon_sym_COMMA,
    ACTIONS(7615), 1,
      anon_sym_GT,
    STATE(3766), 1,
      sym_arguments,
    STATE(4029), 1,
      sym_comment,
    STATE(5492), 1,
      aux_sym_type_arguments_repeat1,
  [166492] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7619), 1,
      anon_sym_property,
    STATE(4030), 1,
      sym_comment,
    STATE(4040), 1,
      aux_sym_ui_property_repeat1,
    STATE(4689), 1,
      sym_ui_property_modifier,
    ACTIONS(7617), 3,
      anon_sym_default,
      anon_sym_readonly,
      anon_sym_required,
  [166516] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4031), 1,
      sym_comment,
    ACTIONS(7621), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [166534] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4032), 1,
      sym_comment,
    ACTIONS(7623), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [166552] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2214), 1,
      sym_statement_block,
    STATE(4033), 1,
      sym_comment,
    ACTIONS(7569), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [166574] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4034), 1,
      sym_comment,
    ACTIONS(7625), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [166592] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2212), 1,
      sym_statement_block,
    STATE(4035), 1,
      sym_comment,
    ACTIONS(7567), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [166614] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7627), 1,
      anon_sym_COMMA,
    STATE(4036), 2,
      sym_comment,
      aux_sym_sequence_expression_repeat1,
    ACTIONS(4948), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [166634] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(7630), 1,
      sym_identifier,
    STATE(4037), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5681), 1,
      sym__call_signature,
  [166662] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(7632), 1,
      sym_identifier,
    STATE(4038), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5581), 1,
      sym__call_signature,
  [166690] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4771), 1,
      anon_sym_COMMA,
    STATE(4036), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(4039), 1,
      sym_comment,
    ACTIONS(7634), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [166712] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7639), 1,
      anon_sym_property,
    STATE(4689), 1,
      sym_ui_property_modifier,
    STATE(4040), 2,
      sym_comment,
      aux_sym_ui_property_repeat1,
    ACTIONS(7636), 3,
      anon_sym_default,
      anon_sym_readonly,
      anon_sym_required,
  [166734] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7641), 1,
      anon_sym_QMARK,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4041), 1,
      sym_comment,
    STATE(4481), 1,
      sym__call_signature,
    STATE(5867), 1,
      sym_type_parameters,
  [166762] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(7643), 1,
      sym_identifier,
    STATE(4042), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5681), 1,
      sym__call_signature,
  [166790] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(7645), 1,
      sym_identifier,
    STATE(4043), 1,
      sym_comment,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5581), 1,
      sym__call_signature,
  [166818] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4044), 1,
      sym_comment,
    ACTIONS(7647), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [166836] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7649), 1,
      anon_sym_BQUOTE,
    ACTIONS(7651), 1,
      anon_sym_DOLLAR_LBRACE,
    STATE(4045), 1,
      sym_comment,
    STATE(4057), 1,
      aux_sym_template_string_repeat1,
    STATE(4725), 1,
      sym_template_substitution,
    ACTIONS(7343), 2,
      sym__template_chars,
      sym_escape_sequence,
  [166862] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7653), 1,
      anon_sym_COLON,
    STATE(4046), 1,
      sym_comment,
    ACTIONS(7063), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(5552), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
  [166884] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7655), 1,
      anon_sym_DOT,
    STATE(4047), 1,
      sym_comment,
    ACTIONS(7339), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [166904] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4048), 1,
      sym_comment,
    STATE(4127), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3862), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7657), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [166926] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4049), 1,
      sym_comment,
    STATE(4127), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3844), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7659), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [166948] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(7661), 1,
      anon_sym_export,
    ACTIONS(7663), 1,
      anon_sym_class,
    ACTIONS(7665), 1,
      anon_sym_abstract,
    STATE(1202), 1,
      sym_decorator,
    STATE(4050), 1,
      sym_comment,
    STATE(4059), 1,
      aux_sym_export_statement_repeat1,
  [166976] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(7667), 1,
      sym_identifier,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4051), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5581), 1,
      sym__call_signature,
  [167004] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4052), 1,
      sym_comment,
    STATE(4127), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3902), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7669), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [167026] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4049), 1,
      aux_sym_object_type_repeat1,
    STATE(4053), 1,
      sym_comment,
    ACTIONS(3902), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7669), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [167048] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3814), 1,
      anon_sym_LPAREN,
    ACTIONS(7143), 1,
      anon_sym_DOT,
    ACTIONS(7671), 1,
      anon_sym_COMMA,
    ACTIONS(7673), 1,
      anon_sym_GT,
    STATE(3766), 1,
      sym_arguments,
    STATE(4054), 1,
      sym_comment,
    STATE(4863), 1,
      aux_sym_type_arguments_repeat1,
  [167076] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(7675), 1,
      anon_sym_COMMA,
    ACTIONS(7677), 1,
      anon_sym_GT,
    STATE(4055), 1,
      sym_comment,
    STATE(5182), 1,
      aux_sym_type_arguments_repeat1,
  [167104] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4056), 1,
      sym_comment,
    ACTIONS(7531), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [167122] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7651), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7679), 1,
      anon_sym_BQUOTE,
    STATE(4057), 1,
      sym_comment,
    STATE(4079), 1,
      aux_sym_template_string_repeat1,
    STATE(4725), 1,
      sym_template_substitution,
    ACTIONS(7343), 2,
      sym__template_chars,
      sym_escape_sequence,
  [167148] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7653), 1,
      anon_sym_COLON,
    STATE(4058), 1,
      sym_comment,
    ACTIONS(7009), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(5604), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
  [167170] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7681), 1,
      anon_sym_AT,
    STATE(1202), 1,
      sym_decorator,
    STATE(4059), 2,
      sym_comment,
      aux_sym_export_statement_repeat1,
    ACTIONS(3642), 3,
      anon_sym_export,
      anon_sym_class,
      anon_sym_abstract,
  [167192] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4052), 1,
      aux_sym_object_type_repeat1,
    STATE(4060), 1,
      sym_comment,
    ACTIONS(7686), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7684), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [167214] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(7482), 1,
      sym_identifier,
    STATE(3759), 1,
      sym_nested_identifier,
    STATE(3864), 1,
      sym_string,
    STATE(4061), 1,
      sym_comment,
    STATE(4287), 1,
      sym__module,
  [167242] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(7482), 1,
      sym_identifier,
    STATE(3759), 1,
      sym_nested_identifier,
    STATE(3864), 1,
      sym_string,
    STATE(4062), 1,
      sym_comment,
    STATE(4288), 1,
      sym__module,
  [167270] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(7688), 1,
      anon_sym_COMMA,
    ACTIONS(7690), 1,
      anon_sym_GT,
    STATE(4063), 1,
      sym_comment,
    STATE(5324), 1,
      aux_sym_type_arguments_repeat1,
  [167298] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3814), 1,
      anon_sym_LPAREN,
    ACTIONS(7143), 1,
      anon_sym_DOT,
    ACTIONS(7692), 1,
      anon_sym_COMMA,
    ACTIONS(7694), 1,
      anon_sym_GT,
    STATE(3766), 1,
      sym_arguments,
    STATE(4064), 1,
      sym_comment,
    STATE(5320), 1,
      aux_sym_type_arguments_repeat1,
  [167326] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3814), 1,
      anon_sym_LPAREN,
    ACTIONS(7143), 1,
      anon_sym_DOT,
    ACTIONS(7696), 1,
      anon_sym_COMMA,
    ACTIONS(7698), 1,
      anon_sym_GT,
    STATE(3766), 1,
      sym_arguments,
    STATE(4065), 1,
      sym_comment,
    STATE(5132), 1,
      aux_sym_type_arguments_repeat1,
  [167354] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3610), 1,
      anon_sym_DQUOTE,
    ACTIONS(3612), 1,
      anon_sym_SQUOTE,
    ACTIONS(7472), 1,
      sym_identifier,
    STATE(755), 1,
      sym_nested_identifier,
    STATE(760), 1,
      sym_string,
    STATE(807), 1,
      sym__module,
    STATE(4066), 1,
      sym_comment,
  [167382] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3610), 1,
      anon_sym_DQUOTE,
    ACTIONS(3612), 1,
      anon_sym_SQUOTE,
    ACTIONS(7472), 1,
      sym_identifier,
    STATE(755), 1,
      sym_nested_identifier,
    STATE(760), 1,
      sym_string,
    STATE(818), 1,
      sym__module,
    STATE(4067), 1,
      sym_comment,
  [167410] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(7700), 1,
      anon_sym_QMARK,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4068), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5625), 1,
      sym__call_signature,
  [167438] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(7702), 1,
      anon_sym_COMMA,
    ACTIONS(7704), 1,
      anon_sym_GT,
    STATE(4069), 1,
      sym_comment,
    STATE(5124), 1,
      aux_sym_type_arguments_repeat1,
  [167466] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(7706), 1,
      sym_identifier,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4070), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5581), 1,
      sym__call_signature,
  [167494] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4071), 1,
      sym_comment,
    ACTIONS(4322), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [167512] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3855), 1,
      anon_sym_COLON,
    ACTIONS(7498), 1,
      anon_sym_EQ,
    STATE(4072), 1,
      sym_comment,
    STATE(4819), 1,
      sym_type_annotation,
    STATE(5645), 1,
      sym__initializer,
    ACTIONS(7708), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [167538] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(7710), 1,
      anon_sym_LBRACE,
    ACTIONS(7712), 1,
      anon_sym_COMMA,
    STATE(4073), 1,
      sym_comment,
    STATE(5021), 1,
      aux_sym_implements_clause_repeat1,
  [167566] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(7714), 1,
      sym_identifier,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4074), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5681), 1,
      sym__call_signature,
  [167594] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4075), 1,
      sym_comment,
    STATE(4102), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(7718), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7716), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [167616] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2197), 1,
      sym_statement_block,
    STATE(4076), 1,
      sym_comment,
    ACTIONS(7557), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [167638] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7720), 1,
      anon_sym_default,
    ACTIONS(7722), 1,
      anon_sym_RBRACE,
    ACTIONS(7724), 1,
      anon_sym_case,
    STATE(4077), 1,
      sym_comment,
    STATE(4096), 1,
      aux_sym_switch_body_repeat1,
    STATE(5055), 2,
      sym_switch_case,
      sym_switch_default,
  [167664] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3055), 1,
      anon_sym_LBRACE,
    ACTIONS(7726), 1,
      sym_identifier,
    ACTIONS(7728), 1,
      anon_sym_LBRACK,
    STATE(4078), 1,
      sym_comment,
    STATE(5009), 1,
      sym__destructuring_pattern,
    STATE(3599), 2,
      sym_object_pattern,
      sym_array_pattern,
  [167690] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7733), 1,
      anon_sym_BQUOTE,
    ACTIONS(7735), 1,
      anon_sym_DOLLAR_LBRACE,
    STATE(4725), 1,
      sym_template_substitution,
    ACTIONS(7730), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(4079), 2,
      sym_comment,
      aux_sym_template_string_repeat1,
  [167714] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(7738), 1,
      sym_identifier,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4080), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5681), 1,
      sym__call_signature,
  [167742] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4081), 1,
      sym_comment,
    ACTIONS(5913), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT,
  [167760] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4082), 1,
      sym_comment,
    ACTIONS(7381), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT,
  [167778] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(7740), 1,
      sym_identifier,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4083), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5581), 1,
      sym__call_signature,
  [167806] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(7744), 1,
      anon_sym_QMARK,
    STATE(4084), 1,
      sym_comment,
    ACTIONS(7742), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [167832] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4085), 1,
      sym_comment,
    STATE(4088), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(7748), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7746), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [167854] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7750), 1,
      sym_identifier,
    STATE(4086), 1,
      sym_comment,
    ACTIONS(6644), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT,
      anon_sym_BQUOTE,
  [167874] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4087), 1,
      sym_comment,
    STATE(4090), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3868), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7752), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [167896] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4088), 1,
      sym_comment,
    STATE(4127), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3868), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7752), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [167918] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4089), 1,
      sym_comment,
    STATE(4127), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3870), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7754), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [167940] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4090), 1,
      sym_comment,
    STATE(4127), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3872), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7756), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [167962] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(7758), 1,
      anon_sym_QMARK,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4091), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5745), 1,
      sym__call_signature,
  [167990] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(7760), 1,
      sym_identifier,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4092), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5681), 1,
      sym__call_signature,
  [168018] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4093), 1,
      sym_comment,
    STATE(4127), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3880), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7762), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [168040] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4094), 1,
      sym_comment,
    ACTIONS(4669), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4322), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [168060] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4089), 1,
      aux_sym_object_type_repeat1,
    STATE(4095), 1,
      sym_comment,
    ACTIONS(3880), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7762), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [168082] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7720), 1,
      anon_sym_default,
    ACTIONS(7724), 1,
      anon_sym_case,
    ACTIONS(7764), 1,
      anon_sym_RBRACE,
    STATE(4096), 1,
      sym_comment,
    STATE(4119), 1,
      aux_sym_switch_body_repeat1,
    STATE(5055), 2,
      sym_switch_case,
      sym_switch_default,
  [168108] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3055), 1,
      anon_sym_LBRACE,
    ACTIONS(7728), 1,
      anon_sym_LBRACK,
    ACTIONS(7766), 1,
      sym_identifier,
    STATE(4097), 1,
      sym_comment,
    STATE(4885), 1,
      sym__destructuring_pattern,
    STATE(3599), 2,
      sym_object_pattern,
      sym_array_pattern,
  [168134] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6796), 1,
      anon_sym_LPAREN,
    ACTIONS(7768), 1,
      anon_sym_QMARK,
    STATE(3571), 1,
      sym_formal_parameters,
    STATE(4098), 1,
      sym_comment,
    STATE(4120), 1,
      sym__call_signature,
    STATE(5701), 1,
      sym_type_parameters,
  [168162] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2120), 1,
      sym_statement_block,
    STATE(4099), 1,
      sym_comment,
    ACTIONS(7543), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [168184] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4100), 1,
      sym_comment,
    STATE(4110), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(7772), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7770), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [168206] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4101), 1,
      sym_comment,
    STATE(4125), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3866), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7774), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [168228] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4102), 1,
      sym_comment,
    STATE(4127), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3866), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7774), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [168250] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(7776), 1,
      anon_sym_QMARK,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4103), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5706), 1,
      sym__call_signature,
  [168278] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3696), 1,
      anon_sym_DQUOTE,
    ACTIONS(3698), 1,
      anon_sym_SQUOTE,
    ACTIONS(7444), 1,
      sym_identifier,
    STATE(2781), 1,
      sym_nested_identifier,
    STATE(2835), 1,
      sym_string,
    STATE(2996), 1,
      sym__module,
    STATE(4104), 1,
      sym_comment,
  [168306] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7778), 1,
      anon_sym_QMARK,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4105), 1,
      sym_comment,
    STATE(4548), 1,
      sym__call_signature,
    STATE(5867), 1,
      sym_type_parameters,
  [168334] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3696), 1,
      anon_sym_DQUOTE,
    ACTIONS(3698), 1,
      anon_sym_SQUOTE,
    ACTIONS(7444), 1,
      sym_identifier,
    STATE(2781), 1,
      sym_nested_identifier,
    STATE(2835), 1,
      sym_string,
    STATE(2941), 1,
      sym__module,
    STATE(4106), 1,
      sym_comment,
  [168362] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(7780), 1,
      anon_sym_COMMA,
    ACTIONS(7782), 1,
      anon_sym_GT,
    STATE(4107), 1,
      sym_comment,
    STATE(5034), 1,
      aux_sym_type_arguments_repeat1,
  [168390] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3814), 1,
      anon_sym_LPAREN,
    ACTIONS(7143), 1,
      anon_sym_DOT,
    ACTIONS(7784), 1,
      anon_sym_COMMA,
    ACTIONS(7786), 1,
      anon_sym_GT,
    STATE(3766), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_comment,
    STATE(5029), 1,
      aux_sym_type_arguments_repeat1,
  [168418] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4109), 1,
      sym_comment,
    STATE(4111), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3864), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7788), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [168440] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4110), 1,
      sym_comment,
    STATE(4127), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3864), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7788), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [168462] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4111), 1,
      sym_comment,
    STATE(4127), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3900), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7790), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [168484] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    STATE(4112), 1,
      sym_comment,
    ACTIONS(7792), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
  [168508] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4113), 1,
      sym_comment,
    ACTIONS(7547), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [168526] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4114), 1,
      sym_comment,
    ACTIONS(3670), 6,
      anon_sym_export,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_AT,
      anon_sym_abstract,
  [168544] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3055), 1,
      anon_sym_LBRACE,
    ACTIONS(7728), 1,
      anon_sym_LBRACK,
    ACTIONS(7794), 1,
      sym_identifier,
    STATE(4115), 1,
      sym_comment,
    STATE(4681), 1,
      sym__destructuring_pattern,
    STATE(3599), 2,
      sym_object_pattern,
      sym_array_pattern,
  [168570] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3055), 1,
      anon_sym_LBRACE,
    ACTIONS(7728), 1,
      anon_sym_LBRACK,
    ACTIONS(7796), 1,
      sym_identifier,
    STATE(4116), 1,
      sym_comment,
    STATE(5824), 1,
      sym__destructuring_pattern,
    STATE(3599), 2,
      sym_object_pattern,
      sym_array_pattern,
  [168596] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(7798), 1,
      anon_sym_QMARK,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4117), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5837), 1,
      sym__call_signature,
  [168624] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6970), 1,
      anon_sym_LT,
    ACTIONS(7438), 1,
      anon_sym_COMMA,
    ACTIONS(7800), 1,
      anon_sym_LBRACE,
    ACTIONS(7802), 1,
      anon_sym_LBRACE_PIPE,
    STATE(4118), 1,
      sym_comment,
    STATE(4776), 1,
      aux_sym_extends_type_clause_repeat1,
    STATE(5407), 1,
      sym_type_arguments,
  [168652] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7804), 1,
      anon_sym_default,
    ACTIONS(7807), 1,
      anon_sym_RBRACE,
    ACTIONS(7809), 1,
      anon_sym_case,
    STATE(4119), 2,
      sym_comment,
      aux_sym_switch_body_repeat1,
    STATE(5055), 2,
      sym_switch_case,
      sym_switch_default,
  [168676] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2159), 1,
      sym_statement_block,
    STATE(4120), 1,
      sym_comment,
    ACTIONS(7549), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [168698] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2182), 1,
      sym_statement_block,
    STATE(4121), 1,
      sym_comment,
    ACTIONS(7549), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [168720] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7812), 1,
      anon_sym_QMARK,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4122), 1,
      sym_comment,
    STATE(5431), 1,
      sym__call_signature,
    STATE(5867), 1,
      sym_type_parameters,
  [168748] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2163), 1,
      sym_statement_block,
    STATE(4123), 1,
      sym_comment,
    ACTIONS(7551), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [168770] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6796), 1,
      anon_sym_LPAREN,
    ACTIONS(7814), 1,
      anon_sym_QMARK,
    STATE(3571), 1,
      sym_formal_parameters,
    STATE(4124), 1,
      sym_comment,
    STATE(4140), 1,
      sym__call_signature,
    STATE(5701), 1,
      sym_type_parameters,
  [168798] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4125), 1,
      sym_comment,
    STATE(4127), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3846), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7816), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [168820] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7818), 1,
      anon_sym_QMARK,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4126), 1,
      sym_comment,
    STATE(4619), 1,
      sym__call_signature,
    STATE(5867), 1,
      sym_type_parameters,
  [168848] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7823), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(4127), 2,
      sym_comment,
      aux_sym_object_type_repeat1,
    ACTIONS(7820), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [168868] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7825), 1,
      anon_sym_QMARK,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(3995), 1,
      sym__call_signature,
    STATE(4128), 1,
      sym_comment,
    STATE(5867), 1,
      sym_type_parameters,
  [168896] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7827), 1,
      anon_sym_AMP,
    ACTIONS(7829), 1,
      anon_sym_PIPE,
    ACTIONS(7831), 1,
      anon_sym_extends,
    STATE(4129), 1,
      sym_comment,
    ACTIONS(5122), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [168920] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7833), 1,
      anon_sym_QMARK,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4004), 1,
      sym__call_signature,
    STATE(4130), 1,
      sym_comment,
    STATE(5867), 1,
      sym_type_parameters,
  [168948] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7835), 1,
      anon_sym_QMARK,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4003), 1,
      sym__call_signature,
    STATE(4131), 1,
      sym_comment,
    STATE(5867), 1,
      sym_type_parameters,
  [168976] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4132), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5934), 1,
      sym__call_signature,
  [169004] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7839), 1,
      anon_sym_QMARK,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(3994), 1,
      sym__call_signature,
    STATE(4133), 1,
      sym_comment,
    STATE(5867), 1,
      sym_type_parameters,
  [169032] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(7665), 1,
      anon_sym_abstract,
    ACTIONS(7841), 1,
      anon_sym_export,
    ACTIONS(7843), 1,
      anon_sym_class,
    STATE(1202), 1,
      sym_decorator,
    STATE(4059), 1,
      aux_sym_export_statement_repeat1,
    STATE(4134), 1,
      sym_comment,
  [169060] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7827), 1,
      anon_sym_AMP,
    ACTIONS(7829), 1,
      anon_sym_PIPE,
    ACTIONS(7831), 1,
      anon_sym_extends,
    STATE(4135), 1,
      sym_comment,
    ACTIONS(5032), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [169084] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7827), 1,
      anon_sym_AMP,
    ACTIONS(7829), 1,
      anon_sym_PIPE,
    ACTIONS(7831), 1,
      anon_sym_extends,
    STATE(4136), 1,
      sym_comment,
    ACTIONS(5028), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [169108] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7827), 1,
      anon_sym_AMP,
    ACTIONS(7829), 1,
      anon_sym_PIPE,
    ACTIONS(7831), 1,
      anon_sym_extends,
    STATE(4137), 1,
      sym_comment,
    ACTIONS(5024), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [169132] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7827), 1,
      anon_sym_AMP,
    ACTIONS(7829), 1,
      anon_sym_PIPE,
    ACTIONS(7831), 1,
      anon_sym_extends,
    STATE(4138), 1,
      sym_comment,
    ACTIONS(5016), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [169156] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2179), 1,
      sym_statement_block,
    STATE(4139), 1,
      sym_comment,
    ACTIONS(7553), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [169178] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2180), 1,
      sym_statement_block,
    STATE(4140), 1,
      sym_comment,
    ACTIONS(7555), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [169200] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6796), 1,
      anon_sym_LPAREN,
    ACTIONS(7845), 1,
      anon_sym_QMARK,
    STATE(3571), 1,
      sym_formal_parameters,
    STATE(4141), 1,
      sym_comment,
    STATE(4166), 1,
      sym__call_signature,
    STATE(5701), 1,
      sym_type_parameters,
  [169228] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(7847), 1,
      sym_identifier,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4142), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5817), 1,
      sym__call_signature,
  [169256] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4127), 1,
      aux_sym_object_type_repeat1,
    STATE(4143), 1,
      sym_comment,
    ACTIONS(3882), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7849), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [169278] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7851), 1,
      anon_sym_QMARK,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(3983), 1,
      sym__call_signature,
    STATE(4144), 1,
      sym_comment,
    STATE(5867), 1,
      sym_type_parameters,
  [169306] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2184), 1,
      sym_statement_block,
    STATE(4145), 1,
      sym_comment,
    ACTIONS(7555), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [169328] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2189), 1,
      sym_statement_block,
    STATE(4146), 1,
      sym_comment,
    ACTIONS(7553), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [169350] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7853), 1,
      anon_sym_QMARK,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4147), 1,
      sym_comment,
    STATE(4892), 1,
      sym__call_signature,
    STATE(5867), 1,
      sym_type_parameters,
  [169378] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7827), 1,
      anon_sym_AMP,
    STATE(4148), 1,
      sym_comment,
    ACTIONS(4956), 5,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [169398] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7827), 1,
      anon_sym_AMP,
    ACTIONS(7829), 1,
      anon_sym_PIPE,
    ACTIONS(7831), 1,
      anon_sym_extends,
    STATE(4149), 1,
      sym_comment,
    ACTIONS(4946), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [169422] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4150), 1,
      sym_comment,
    ACTIONS(7545), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [169440] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4127), 1,
      aux_sym_object_type_repeat1,
    STATE(4151), 1,
      sym_comment,
    ACTIONS(3822), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7855), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [169462] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4143), 1,
      aux_sym_object_type_repeat1,
    STATE(4152), 1,
      sym_comment,
    ACTIONS(3822), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7855), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [169484] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7857), 1,
      anon_sym_QMARK,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(3987), 1,
      sym__call_signature,
    STATE(4153), 1,
      sym_comment,
    STATE(5867), 1,
      sym_type_parameters,
  [169512] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7720), 1,
      anon_sym_default,
    ACTIONS(7724), 1,
      anon_sym_case,
    ACTIONS(7859), 1,
      anon_sym_RBRACE,
    STATE(4119), 1,
      aux_sym_switch_body_repeat1,
    STATE(4154), 1,
      sym_comment,
    STATE(5055), 2,
      sym_switch_case,
      sym_switch_default,
  [169538] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(7861), 1,
      anon_sym_QMARK,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4155), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5797), 1,
      sym__call_signature,
  [169566] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(7863), 1,
      sym_identifier,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4156), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5783), 1,
      sym__call_signature,
  [169594] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7865), 1,
      anon_sym_QMARK,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4157), 1,
      sym_comment,
    STATE(4256), 1,
      sym__call_signature,
    STATE(5867), 1,
      sym_type_parameters,
  [169622] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2142), 1,
      sym_statement_block,
    STATE(4158), 1,
      sym_comment,
    ACTIONS(7561), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [169644] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(7867), 1,
      anon_sym_QMARK,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4159), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5918), 1,
      sym__call_signature,
  [169672] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6970), 1,
      anon_sym_LT,
    ACTIONS(7021), 1,
      anon_sym_DOT,
    ACTIONS(7869), 1,
      anon_sym_LBRACE,
    STATE(4160), 1,
      sym_comment,
    STATE(5410), 1,
      sym_type_arguments,
    ACTIONS(7871), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [169698] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7827), 1,
      anon_sym_AMP,
    STATE(4161), 1,
      sym_comment,
    ACTIONS(4835), 5,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [169718] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7827), 1,
      anon_sym_AMP,
    ACTIONS(7829), 1,
      anon_sym_PIPE,
    ACTIONS(7831), 1,
      anon_sym_extends,
    STATE(4162), 1,
      sym_comment,
    ACTIONS(4849), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [169742] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2185), 1,
      sym_statement_block,
    STATE(4163), 1,
      sym_comment,
    ACTIONS(7448), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [169764] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2090), 1,
      sym_statement_block,
    STATE(4164), 1,
      sym_comment,
    ACTIONS(7563), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [169786] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7873), 1,
      anon_sym_extends,
    STATE(4165), 1,
      sym_comment,
    ACTIONS(4861), 5,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
  [169806] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2193), 1,
      sym_statement_block,
    STATE(4166), 1,
      sym_comment,
    ACTIONS(7464), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [169828] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6796), 1,
      anon_sym_LPAREN,
    ACTIONS(7875), 1,
      anon_sym_QMARK,
    STATE(3571), 1,
      sym_formal_parameters,
    STATE(4167), 1,
      sym_comment,
    STATE(4188), 1,
      sym__call_signature,
    STATE(5701), 1,
      sym_type_parameters,
  [169856] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2195), 1,
      sym_statement_block,
    STATE(4168), 1,
      sym_comment,
    ACTIONS(7448), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [169878] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4151), 1,
      aux_sym_object_type_repeat1,
    STATE(4169), 1,
      sym_comment,
    ACTIONS(7879), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7877), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [169900] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2192), 1,
      sym_statement_block,
    STATE(4170), 1,
      sym_comment,
    ACTIONS(7464), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [169922] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7881), 1,
      anon_sym_QMARK,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4171), 1,
      sym_comment,
    STATE(4335), 1,
      sym__call_signature,
    STATE(5867), 1,
      sym_type_parameters,
  [169950] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7720), 1,
      anon_sym_default,
    ACTIONS(7724), 1,
      anon_sym_case,
    ACTIONS(7883), 1,
      anon_sym_RBRACE,
    STATE(4154), 1,
      aux_sym_switch_body_repeat1,
    STATE(4172), 1,
      sym_comment,
    STATE(5055), 2,
      sym_switch_case,
      sym_switch_default,
  [169976] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(7885), 1,
      anon_sym_QMARK,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4173), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5760), 1,
      sym__call_signature,
  [170004] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7887), 1,
      anon_sym_QMARK,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4174), 1,
      sym_comment,
    STATE(5302), 1,
      sym__call_signature,
    STATE(5867), 1,
      sym_type_parameters,
  [170032] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(7889), 1,
      anon_sym_export,
    ACTIONS(7891), 1,
      anon_sym_class,
    ACTIONS(7893), 1,
      anon_sym_abstract,
    STATE(1202), 1,
      sym_decorator,
    STATE(4059), 1,
      aux_sym_export_statement_repeat1,
    STATE(4175), 1,
      sym_comment,
  [170060] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(7413), 1,
      sym_identifier,
    STATE(818), 1,
      sym__module,
    STATE(4176), 1,
      sym_comment,
    STATE(4359), 1,
      sym_nested_identifier,
    STATE(4682), 1,
      sym_string,
  [170088] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(7413), 1,
      sym_identifier,
    STATE(807), 1,
      sym__module,
    STATE(4177), 1,
      sym_comment,
    STATE(4359), 1,
      sym_nested_identifier,
    STATE(4682), 1,
      sym_string,
  [170116] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7651), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7895), 1,
      anon_sym_BQUOTE,
    STATE(4079), 1,
      aux_sym_template_string_repeat1,
    STATE(4178), 1,
      sym_comment,
    STATE(4725), 1,
      sym_template_substitution,
    ACTIONS(7343), 2,
      sym__template_chars,
      sym_escape_sequence,
  [170142] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(7897), 1,
      anon_sym_COMMA,
    ACTIONS(7899), 1,
      anon_sym_GT,
    STATE(4179), 1,
      sym_comment,
    STATE(5100), 1,
      aux_sym_type_arguments_repeat1,
  [170170] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3814), 1,
      anon_sym_LPAREN,
    ACTIONS(7143), 1,
      anon_sym_DOT,
    ACTIONS(7901), 1,
      anon_sym_COMMA,
    ACTIONS(7903), 1,
      anon_sym_GT,
    STATE(3766), 1,
      sym_arguments,
    STATE(4180), 1,
      sym_comment,
    STATE(5069), 1,
      aux_sym_type_arguments_repeat1,
  [170198] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(7905), 1,
      anon_sym_QMARK,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4181), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5734), 1,
      sym__call_signature,
  [170226] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(7907), 1,
      anon_sym_QMARK,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4182), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5712), 1,
      sym__call_signature,
  [170254] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7651), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7909), 1,
      anon_sym_BQUOTE,
    STATE(4178), 1,
      aux_sym_template_string_repeat1,
    STATE(4183), 1,
      sym_comment,
    STATE(4725), 1,
      sym_template_substitution,
    ACTIONS(7343), 2,
      sym__template_chars,
      sym_escape_sequence,
  [170280] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(7911), 1,
      anon_sym_QMARK,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4184), 1,
      sym_comment,
    STATE(4234), 1,
      sym__call_signature,
    STATE(5867), 1,
      sym_type_parameters,
  [170308] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(7913), 1,
      anon_sym_QMARK,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4185), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5708), 1,
      sym__call_signature,
  [170336] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    ACTIONS(7915), 1,
      anon_sym_QMARK,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4186), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5904), 1,
      sym__call_signature,
  [170364] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2198), 1,
      sym_statement_block,
    STATE(4187), 1,
      sym_comment,
    ACTIONS(7565), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [170386] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2208), 1,
      sym_statement_block,
    STATE(4188), 1,
      sym_comment,
    ACTIONS(7559), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [170408] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6796), 1,
      anon_sym_LPAREN,
    ACTIONS(7917), 1,
      anon_sym_QMARK,
    STATE(3571), 1,
      sym_formal_parameters,
    STATE(4033), 1,
      sym__call_signature,
    STATE(4189), 1,
      sym_comment,
    STATE(5701), 1,
      sym_type_parameters,
  [170436] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2145), 1,
      sym_statement_block,
    STATE(4190), 1,
      sym_comment,
    ACTIONS(7565), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [170458] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4191), 1,
      sym_comment,
    ACTIONS(2402), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [170476] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4192), 1,
      sym_comment,
    ACTIONS(2390), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [170494] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2151), 1,
      sym_statement_block,
    STATE(4193), 1,
      sym_comment,
    ACTIONS(7559), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [170516] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4194), 1,
      sym_comment,
    ACTIONS(2394), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [170534] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4195), 1,
      sym_comment,
    ACTIONS(2406), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [170552] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4196), 1,
      sym_comment,
    STATE(5140), 1,
      sym__initializer,
    ACTIONS(7919), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [170573] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7653), 1,
      anon_sym_COLON,
    ACTIONS(7921), 1,
      anon_sym_EQ_GT,
    STATE(4197), 1,
      sym_comment,
    STATE(5604), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
  [170594] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4198), 1,
      sym_comment,
    STATE(5195), 1,
      sym__initializer,
    ACTIONS(7919), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [170615] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4199), 1,
      sym_comment,
    STATE(4927), 1,
      sym__initializer,
    ACTIONS(7924), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [170636] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4200), 1,
      sym_comment,
    ACTIONS(2739), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [170653] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4201), 1,
      sym_comment,
    STATE(5253), 1,
      sym__initializer,
    ACTIONS(7926), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [170674] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7587), 1,
      aux_sym_ui_version_specifier_token1,
    ACTIONS(7589), 1,
      anon_sym_as,
    STATE(4202), 1,
      sym_comment,
    STATE(5455), 1,
      sym_ui_version_specifier,
    ACTIONS(7591), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [170697] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7928), 1,
      anon_sym_BQUOTE,
    ACTIONS(7930), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7932), 1,
      sym__template_chars,
    STATE(4203), 1,
      sym_comment,
    STATE(4466), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(5192), 1,
      sym_template_type,
  [170722] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4204), 1,
      sym_comment,
    STATE(4911), 1,
      sym__initializer,
    ACTIONS(7934), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [170743] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4205), 1,
      sym_comment,
    ACTIONS(1846), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [170760] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2484), 1,
      anon_sym_LBRACE,
    ACTIONS(6511), 1,
      anon_sym_COLON,
    ACTIONS(6513), 1,
      anon_sym_DOT,
    ACTIONS(7097), 1,
      anon_sym_on,
    STATE(2802), 1,
      sym_ui_object_initializer,
    STATE(4206), 1,
      sym_comment,
  [170785] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4207), 1,
      sym_comment,
    STATE(4916), 1,
      sym__initializer,
    ACTIONS(7919), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [170806] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4208), 1,
      sym_comment,
    STATE(4958), 1,
      sym__initializer,
    ACTIONS(7934), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [170827] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4209), 1,
      sym_comment,
    STATE(5241), 1,
      sym__initializer,
    ACTIONS(7926), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [170848] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4210), 1,
      sym_comment,
    STATE(5091), 1,
      sym__initializer,
    ACTIONS(7936), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [170869] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4211), 1,
      sym_comment,
    STATE(4918), 1,
      sym__initializer,
    ACTIONS(7919), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [170890] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2484), 1,
      anon_sym_LBRACE,
    ACTIONS(7938), 1,
      anon_sym_COLON,
    ACTIONS(7940), 1,
      anon_sym_DOT,
    ACTIONS(7942), 1,
      anon_sym_on,
    STATE(2843), 1,
      sym_ui_object_initializer,
    STATE(4212), 1,
      sym_comment,
  [170915] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4213), 1,
      sym_comment,
    STATE(4990), 1,
      sym__initializer,
    ACTIONS(7944), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [170936] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4214), 1,
      sym_comment,
    STATE(4919), 1,
      sym__initializer,
    ACTIONS(7919), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [170957] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4215), 1,
      sym_comment,
    ACTIONS(7946), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [170974] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4216), 1,
      sym_comment,
    STATE(4922), 1,
      sym__initializer,
    ACTIONS(7919), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [170995] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7930), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7932), 1,
      sym__template_chars,
    ACTIONS(7948), 1,
      anon_sym_BQUOTE,
    STATE(4203), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(4217), 1,
      sym_comment,
    STATE(5192), 1,
      sym_template_type,
  [171020] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4218), 1,
      sym_comment,
    STATE(4879), 1,
      sym__initializer,
    ACTIONS(7926), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171041] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4219), 1,
      sym_comment,
    ACTIONS(7950), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [171058] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6796), 1,
      anon_sym_LPAREN,
    STATE(3571), 1,
      sym_formal_parameters,
    STATE(4164), 1,
      sym__call_signature,
    STATE(4220), 1,
      sym_comment,
    STATE(5701), 1,
      sym_type_parameters,
  [171083] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4221), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5897), 1,
      sym__call_signature,
  [171108] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4222), 1,
      sym_comment,
    ACTIONS(7952), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [171125] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4223), 1,
      sym_comment,
    ACTIONS(3015), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [171142] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4224), 1,
      sym_comment,
    ACTIONS(7559), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [171159] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4225), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5536), 1,
      sym__call_signature,
  [171184] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4226), 1,
      sym_comment,
    ACTIONS(7954), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [171201] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4227), 1,
      sym_comment,
    STATE(4943), 1,
      sym__initializer,
    ACTIONS(7924), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171222] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4228), 1,
      sym_comment,
    ACTIONS(7565), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [171239] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4229), 1,
      sym_comment,
    STATE(4953), 1,
      sym__initializer,
    ACTIONS(7924), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171260] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4230), 1,
      sym_comment,
    ACTIONS(5384), 5,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
  [171277] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7073), 1,
      anon_sym_list,
    ACTIONS(7956), 1,
      sym_identifier,
    STATE(4231), 1,
      sym_comment,
    STATE(6331), 1,
      sym_nested_identifier,
    STATE(3120), 2,
      sym_nested_type_identifier,
      sym_ui_list_property_type,
  [171300] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4232), 1,
      sym_comment,
    STATE(4964), 1,
      sym__initializer,
    ACTIONS(7919), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171321] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4233), 1,
      sym_comment,
    STATE(4966), 1,
      sym__initializer,
    ACTIONS(7926), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171342] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4234), 1,
      sym_comment,
    ACTIONS(7559), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [171359] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4235), 1,
      sym_comment,
    STATE(4472), 1,
      sym__call_signature,
    STATE(5867), 1,
      sym_type_parameters,
  [171384] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4236), 1,
      sym_comment,
    STATE(5002), 1,
      sym__initializer,
    ACTIONS(7919), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171405] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4237), 1,
      sym_comment,
    ACTIONS(7565), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [171422] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4238), 1,
      sym_comment,
    STATE(4982), 1,
      sym__initializer,
    ACTIONS(7924), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171443] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4239), 1,
      sym_comment,
    ACTIONS(6644), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT,
      anon_sym_BQUOTE,
  [171460] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4240), 1,
      sym_comment,
    STATE(4994), 1,
      sym__initializer,
    ACTIONS(7924), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171481] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4241), 1,
      sym_comment,
    ACTIONS(7647), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171498] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4242), 1,
      sym_comment,
    STATE(4883), 1,
      sym__initializer,
    ACTIONS(7926), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171519] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(7958), 1,
      anon_sym_class,
    ACTIONS(7960), 1,
      anon_sym_abstract,
    STATE(1202), 1,
      sym_decorator,
    STATE(4059), 1,
      aux_sym_export_statement_repeat1,
    STATE(4243), 1,
      sym_comment,
  [171544] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4244), 1,
      sym_comment,
    ACTIONS(5310), 5,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
  [171561] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4322), 1,
      anon_sym_COLON,
    ACTIONS(4416), 1,
      anon_sym_COMMA,
    ACTIONS(7962), 1,
      anon_sym_RBRACE,
    STATE(4245), 1,
      sym_comment,
    STATE(5304), 1,
      aux_sym_object_pattern_repeat1,
  [171586] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4246), 1,
      sym_comment,
    STATE(5035), 1,
      sym__initializer,
    ACTIONS(7926), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171607] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4247), 1,
      sym_comment,
    ACTIONS(5355), 5,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
  [171624] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4248), 1,
      sym_comment,
    STATE(5058), 1,
      sym__initializer,
    ACTIONS(7934), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171645] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4249), 1,
      sym_comment,
    STATE(4968), 1,
      sym__initializer,
    ACTIONS(7924), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171666] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4250), 1,
      sym_comment,
    STATE(5077), 1,
      sym__initializer,
    ACTIONS(7934), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171687] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4251), 1,
      sym_comment,
    ACTIONS(2887), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [171704] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4252), 1,
      sym_comment,
    ACTIONS(7964), 5,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_DOT,
      aux_sym_ui_version_specifier_token1,
  [171721] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4253), 1,
      sym_comment,
    STATE(5275), 1,
      sym__initializer,
    ACTIONS(7966), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171742] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4254), 1,
      sym_comment,
    STATE(5080), 1,
      sym__initializer,
    ACTIONS(7919), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171763] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4255), 1,
      sym_comment,
    ACTIONS(7968), 5,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_DOT,
      aux_sym_ui_version_specifier_token1,
  [171780] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4256), 1,
      sym_comment,
    ACTIONS(7464), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [171797] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4257), 1,
      sym_comment,
    STATE(5164), 1,
      sym__initializer,
    ACTIONS(7924), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171818] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4258), 1,
      sym_comment,
    STATE(5199), 1,
      sym__initializer,
    ACTIONS(7919), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171839] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4259), 1,
      sym_comment,
    STATE(5174), 1,
      sym__initializer,
    ACTIONS(7924), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171860] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4260), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5555), 1,
      sym__call_signature,
  [171885] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4261), 1,
      sym_comment,
    STATE(5177), 1,
      sym__initializer,
    ACTIONS(7926), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171906] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4262), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5556), 1,
      sym__call_signature,
  [171931] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4263), 1,
      sym_comment,
    STATE(5081), 1,
      sym__initializer,
    ACTIONS(7919), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171952] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    ACTIONS(7970), 1,
      anon_sym_SEMI,
    ACTIONS(7972), 1,
      sym__automatic_semicolon,
    ACTIONS(7974), 1,
      sym__function_signature_automatic_semicolon,
    STATE(4264), 1,
      sym_comment,
    STATE(4617), 1,
      sym_statement_block,
  [171977] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7976), 1,
      sym_identifier,
    ACTIONS(7978), 1,
      anon_sym_RPAREN,
    STATE(4265), 1,
      sym_comment,
    STATE(5269), 1,
      sym_ui_signal_parameter,
    STATE(6243), 1,
      sym_nested_type_identifier,
    STATE(6331), 1,
      sym_nested_identifier,
  [172002] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4266), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5705), 1,
      sym__call_signature,
  [172027] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4267), 1,
      sym_comment,
    STATE(4989), 1,
      sym__initializer,
    ACTIONS(7924), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172048] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4268), 1,
      sym_comment,
    STATE(5206), 1,
      sym__initializer,
    ACTIONS(7924), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172069] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4269), 1,
      sym_comment,
    ACTIONS(2707), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [172086] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4270), 1,
      sym_comment,
    ACTIONS(2671), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [172103] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4271), 1,
      sym_comment,
    ACTIONS(2799), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [172120] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4272), 1,
      sym_comment,
    ACTIONS(2659), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [172137] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4273), 1,
      sym_comment,
    ACTIONS(1976), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [172154] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5229), 1,
      anon_sym_in,
    STATE(4274), 1,
      sym_comment,
    ACTIONS(5965), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [172173] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4275), 1,
      sym_comment,
    STATE(5223), 1,
      sym__initializer,
    ACTIONS(7924), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172194] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4713), 1,
      anon_sym_LBRACE,
    ACTIONS(7970), 1,
      anon_sym_SEMI,
    ACTIONS(7972), 1,
      sym__automatic_semicolon,
    ACTIONS(7974), 1,
      sym__function_signature_automatic_semicolon,
    STATE(2498), 1,
      sym_statement_block,
    STATE(4276), 1,
      sym_comment,
  [172219] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4277), 1,
      sym_comment,
    ACTIONS(1846), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [172236] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4278), 1,
      sym_comment,
    STATE(5107), 1,
      sym__initializer,
    ACTIONS(7934), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172257] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    ACTIONS(7980), 1,
      anon_sym_SEMI,
    ACTIONS(7982), 1,
      sym__automatic_semicolon,
    ACTIONS(7984), 1,
      sym__function_signature_automatic_semicolon,
    STATE(4279), 1,
      sym_comment,
    STATE(4492), 1,
      sym_statement_block,
  [172282] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4280), 1,
      sym_comment,
    ACTIONS(5716), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [172299] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4281), 1,
      sym_comment,
    STATE(5236), 1,
      sym__initializer,
    ACTIONS(7924), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172320] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4282), 1,
      sym_comment,
    ACTIONS(7557), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [172337] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4283), 1,
      sym_comment,
    STATE(5109), 1,
      sym__initializer,
    ACTIONS(7919), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172358] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4284), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5582), 1,
      sym__call_signature,
  [172383] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4285), 1,
      sym_comment,
    STATE(5001), 1,
      sym__initializer,
    ACTIONS(7919), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172404] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4286), 1,
      sym_comment,
    ACTIONS(2751), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [172421] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4287), 1,
      sym_comment,
    ACTIONS(2747), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [172438] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4288), 1,
      sym_comment,
    ACTIONS(1840), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [172455] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4289), 1,
      sym_comment,
    STATE(5249), 1,
      sym__initializer,
    ACTIONS(7924), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172476] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4290), 1,
      sym_comment,
    STATE(4983), 1,
      sym__initializer,
    ACTIONS(7924), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172497] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4291), 1,
      sym_comment,
    ACTIONS(1898), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [172514] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4292), 1,
      sym_comment,
    STATE(5076), 1,
      sym__initializer,
    ACTIONS(7926), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172535] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7930), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7932), 1,
      sym__template_chars,
    ACTIONS(7986), 1,
      anon_sym_BQUOTE,
    STATE(4293), 1,
      sym_comment,
    STATE(4334), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(5192), 1,
      sym_template_type,
  [172560] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4713), 1,
      anon_sym_LBRACE,
    ACTIONS(7980), 1,
      anon_sym_SEMI,
    ACTIONS(7982), 1,
      sym__automatic_semicolon,
    ACTIONS(7984), 1,
      sym__function_signature_automatic_semicolon,
    STATE(2537), 1,
      sym_statement_block,
    STATE(4294), 1,
      sym_comment,
  [172585] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4295), 1,
      sym_comment,
    STATE(5003), 1,
      sym__initializer,
    ACTIONS(7924), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172606] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4296), 1,
      sym_comment,
    STATE(4894), 1,
      sym__initializer,
    ACTIONS(7919), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172627] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4297), 1,
      sym_comment,
    STATE(5011), 1,
      sym__initializer,
    ACTIONS(7926), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172648] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7930), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7932), 1,
      sym__template_chars,
    ACTIONS(7988), 1,
      anon_sym_BQUOTE,
    STATE(4298), 1,
      sym_comment,
    STATE(4466), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(5192), 1,
      sym_template_type,
  [172673] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4299), 1,
      sym_comment,
    STATE(5501), 1,
      sym__initializer,
    ACTIONS(7924), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172694] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4300), 1,
      sym_comment,
    STATE(5282), 1,
      sym__initializer,
    ACTIONS(7919), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172715] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4301), 1,
      sym_comment,
    STATE(5138), 1,
      sym__initializer,
    ACTIONS(7934), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172736] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4302), 1,
      sym_comment,
    STATE(5378), 1,
      sym__initializer,
    ACTIONS(7990), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172757] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4303), 1,
      sym_comment,
    STATE(5495), 1,
      sym__initializer,
    ACTIONS(7924), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172778] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4304), 1,
      sym_comment,
    STATE(4900), 1,
      sym__initializer,
    ACTIONS(7919), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172799] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4305), 1,
      sym_comment,
    STATE(5247), 1,
      sym__initializer,
    ACTIONS(7990), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172820] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4306), 1,
      sym_comment,
    STATE(5015), 1,
      sym__initializer,
    ACTIONS(7924), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172841] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4307), 1,
      sym_comment,
    STATE(5483), 1,
      sym__call_signature,
    STATE(5867), 1,
      sym_type_parameters,
  [172866] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4308), 1,
      sym_comment,
    STATE(5027), 1,
      sym__initializer,
    ACTIONS(7924), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172887] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7930), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7932), 1,
      sym__template_chars,
    ACTIONS(7992), 1,
      anon_sym_BQUOTE,
    STATE(4298), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(4309), 1,
      sym_comment,
    STATE(5192), 1,
      sym_template_type,
  [172912] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4310), 1,
      sym_comment,
    STATE(4899), 1,
      sym__initializer,
    ACTIONS(7919), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172933] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4311), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5608), 1,
      sym__call_signature,
  [172958] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    ACTIONS(6230), 1,
      anon_sym_DOT,
    STATE(801), 1,
      sym_statement_block,
    STATE(4312), 1,
      sym_comment,
    ACTIONS(1822), 2,
      anon_sym_else,
      anon_sym_while,
  [172981] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(7665), 1,
      anon_sym_abstract,
    ACTIONS(7994), 1,
      anon_sym_class,
    STATE(1202), 1,
      sym_decorator,
    STATE(4059), 1,
      aux_sym_export_statement_repeat1,
    STATE(4313), 1,
      sym_comment,
  [173006] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4314), 1,
      sym_comment,
    ACTIONS(2863), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173023] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4315), 1,
      sym_comment,
    STATE(5473), 1,
      sym__initializer,
    ACTIONS(7996), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [173044] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4316), 1,
      sym_comment,
    STATE(5370), 1,
      sym__initializer,
    ACTIONS(7990), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [173065] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4317), 1,
      sym_comment,
    ACTIONS(2859), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173082] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6796), 1,
      anon_sym_LPAREN,
    STATE(3571), 1,
      sym_formal_parameters,
    STATE(4318), 1,
      sym_comment,
    STATE(4395), 1,
      sym__call_signature,
    STATE(5701), 1,
      sym_type_parameters,
  [173107] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4319), 1,
      sym_comment,
    ACTIONS(2831), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173124] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4320), 1,
      sym_comment,
    STATE(5356), 1,
      sym__initializer,
    ACTIONS(7990), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [173145] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4321), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5639), 1,
      sym__call_signature,
  [173170] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4322), 1,
      sym_comment,
    ACTIONS(5812), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [173187] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4323), 1,
      sym_comment,
    STATE(5464), 1,
      sym__initializer,
    ACTIONS(7998), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [173208] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4324), 1,
      sym_comment,
    STATE(5067), 1,
      sym__initializer,
    ACTIONS(7926), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [173229] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4325), 1,
      sym_comment,
    STATE(5190), 1,
      sym__initializer,
    ACTIONS(7924), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [173250] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4326), 1,
      sym_comment,
    ACTIONS(6030), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [173267] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4327), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5651), 1,
      sym__call_signature,
  [173292] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6796), 1,
      anon_sym_LPAREN,
    STATE(3571), 1,
      sym_formal_parameters,
    STATE(4035), 1,
      sym__call_signature,
    STATE(4328), 1,
      sym_comment,
    STATE(5701), 1,
      sym_type_parameters,
  [173317] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4329), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5652), 1,
      sym__call_signature,
  [173342] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4330), 1,
      sym_comment,
    ACTIONS(8000), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173359] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4331), 1,
      sym_comment,
    ACTIONS(8002), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173376] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4332), 1,
      sym_comment,
    STATE(5209), 1,
      sym__initializer,
    ACTIONS(7919), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [173397] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7653), 1,
      anon_sym_COLON,
    ACTIONS(8004), 1,
      anon_sym_EQ_GT,
    STATE(4333), 1,
      sym_comment,
    STATE(5552), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
  [173418] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7930), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7932), 1,
      sym__template_chars,
    ACTIONS(8007), 1,
      anon_sym_BQUOTE,
    STATE(4334), 1,
      sym_comment,
    STATE(4466), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(5192), 1,
      sym_template_type,
  [173443] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4335), 1,
      sym_comment,
    ACTIONS(7561), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173460] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4336), 1,
      sym_comment,
    ACTIONS(8009), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173477] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4282), 1,
      sym__call_signature,
    STATE(4337), 1,
      sym_comment,
    STATE(5867), 1,
      sym_type_parameters,
  [173502] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4338), 1,
      sym_comment,
    STATE(5211), 1,
      sym__initializer,
    ACTIONS(7919), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [173523] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4339), 1,
      sym_comment,
    ACTIONS(8011), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_extends,
      anon_sym_implements,
  [173540] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4340), 1,
      sym_comment,
    ACTIONS(8013), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173557] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4341), 1,
      sym_comment,
    ACTIONS(7563), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173574] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4342), 1,
      sym_comment,
    STATE(5340), 1,
      sym__initializer,
    ACTIONS(7924), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [173595] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4343), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5906), 1,
      sym__call_signature,
  [173620] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(7893), 1,
      anon_sym_abstract,
    ACTIONS(8015), 1,
      anon_sym_class,
    STATE(1202), 1,
      sym_decorator,
    STATE(4059), 1,
      aux_sym_export_statement_repeat1,
    STATE(4344), 1,
      sym_comment,
  [173645] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4345), 1,
      sym_comment,
    ACTIONS(8017), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173662] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4346), 1,
      sym_comment,
    ACTIONS(8019), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173679] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4347), 1,
      sym_comment,
    ACTIONS(7464), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173696] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4348), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5821), 1,
      sym__call_signature,
  [173721] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4349), 1,
      sym_comment,
    ACTIONS(8021), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173738] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4350), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5709), 1,
      sym__call_signature,
  [173763] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4351), 1,
      sym_comment,
    ACTIONS(7448), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173780] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4341), 1,
      sym__call_signature,
    STATE(4352), 1,
      sym_comment,
    STATE(5867), 1,
      sym_type_parameters,
  [173805] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6985), 1,
      anon_sym_AMP,
    ACTIONS(6989), 1,
      anon_sym_extends,
    ACTIONS(8025), 1,
      anon_sym_PIPE,
    STATE(4353), 1,
      sym_comment,
    ACTIONS(8023), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [173828] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(8027), 1,
      sym_identifier,
    STATE(4354), 1,
      sym_comment,
    STATE(4799), 1,
      sym_string,
    STATE(6075), 1,
      sym__module_export_name,
  [173853] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4237), 1,
      sym__call_signature,
    STATE(4355), 1,
      sym_comment,
    STATE(5867), 1,
      sym_type_parameters,
  [173878] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4356), 1,
      sym_comment,
    STATE(5156), 1,
      sym__initializer,
    ACTIONS(7926), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [173899] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4357), 1,
      sym_comment,
    ACTIONS(7448), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173916] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4358), 1,
      sym_comment,
    STATE(5239), 1,
      sym__initializer,
    ACTIONS(7934), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [173937] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    ACTIONS(6228), 1,
      anon_sym_DOT,
    STATE(801), 1,
      sym_statement_block,
    STATE(4359), 1,
      sym_comment,
    ACTIONS(1822), 2,
      anon_sym_else,
      anon_sym_while,
  [173960] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(7663), 1,
      anon_sym_class,
    ACTIONS(7665), 1,
      anon_sym_abstract,
    STATE(1202), 1,
      sym_decorator,
    STATE(4059), 1,
      aux_sym_export_statement_repeat1,
    STATE(4360), 1,
      sym_comment,
  [173985] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4361), 1,
      sym_comment,
    ACTIONS(3011), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [174002] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4362), 1,
      sym_comment,
    STATE(5422), 1,
      sym__initializer,
    ACTIONS(8029), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174023] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(8027), 1,
      sym_identifier,
    STATE(4363), 1,
      sym_comment,
    STATE(4799), 1,
      sym_string,
    STATE(4925), 1,
      sym__module_export_name,
  [174048] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4364), 1,
      sym_comment,
    STATE(5350), 1,
      sym__initializer,
    ACTIONS(8031), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174069] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4365), 1,
      sym_comment,
    STATE(5420), 1,
      sym__initializer,
    ACTIONS(8029), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174090] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6985), 1,
      anon_sym_AMP,
    ACTIONS(6989), 1,
      anon_sym_extends,
    ACTIONS(8025), 1,
      anon_sym_PIPE,
    STATE(4366), 1,
      sym_comment,
    ACTIONS(8033), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [174113] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4367), 1,
      sym_comment,
    STATE(5416), 1,
      sym__initializer,
    ACTIONS(8035), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174134] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    ACTIONS(8037), 1,
      anon_sym_SEMI,
    ACTIONS(8039), 1,
      sym__automatic_semicolon,
    ACTIONS(8041), 1,
      sym__function_signature_automatic_semicolon,
    STATE(2833), 1,
      sym_statement_block,
    STATE(4368), 1,
      sym_comment,
  [174159] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4369), 1,
      sym_comment,
    ACTIONS(2955), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [174176] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4370), 1,
      sym_comment,
    STATE(5346), 1,
      sym__initializer,
    ACTIONS(8035), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174197] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4322), 1,
      anon_sym_COLON,
    ACTIONS(4416), 1,
      anon_sym_COMMA,
    ACTIONS(8043), 1,
      anon_sym_RBRACE,
    STATE(4371), 1,
      sym_comment,
    STATE(4957), 1,
      aux_sym_object_pattern_repeat1,
  [174222] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6796), 1,
      anon_sym_LPAREN,
    STATE(3571), 1,
      sym_formal_parameters,
    STATE(4372), 1,
      sym_comment,
    STATE(4500), 1,
      sym__call_signature,
    STATE(5701), 1,
      sym_type_parameters,
  [174247] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4373), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5780), 1,
      sym__call_signature,
  [174272] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4374), 1,
      sym_comment,
    STATE(5344), 1,
      sym__initializer,
    ACTIONS(7924), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174293] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4375), 1,
      sym_comment,
    ACTIONS(2931), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [174310] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4376), 1,
      sym_comment,
    STATE(5348), 1,
      sym__initializer,
    ACTIONS(8031), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174331] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7498), 1,
      anon_sym_EQ,
    ACTIONS(8045), 1,
      anon_sym_COMMA,
    ACTIONS(8047), 1,
      anon_sym_RBRACE,
    STATE(4377), 1,
      sym_comment,
    STATE(5135), 1,
      aux_sym_enum_body_repeat1,
    STATE(5842), 1,
      sym__initializer,
  [174356] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4378), 1,
      sym_comment,
    STATE(5347), 1,
      sym__initializer,
    ACTIONS(8031), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174377] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4379), 1,
      sym_comment,
    STATE(5345), 1,
      sym__initializer,
    ACTIONS(7926), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174398] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4380), 1,
      sym_comment,
    STATE(5308), 1,
      sym__initializer,
    ACTIONS(8029), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174419] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3037), 1,
      anon_sym_LBRACE,
    ACTIONS(8037), 1,
      anon_sym_SEMI,
    ACTIONS(8039), 1,
      sym__automatic_semicolon,
    ACTIONS(8041), 1,
      sym__function_signature_automatic_semicolon,
    STATE(951), 1,
      sym_statement_block,
    STATE(4381), 1,
      sym_comment,
  [174444] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6985), 1,
      anon_sym_AMP,
    ACTIONS(6989), 1,
      anon_sym_extends,
    ACTIONS(8025), 1,
      anon_sym_PIPE,
    STATE(4382), 1,
      sym_comment,
    ACTIONS(8049), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [174467] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4383), 1,
      sym_comment,
    STATE(5306), 1,
      sym__initializer,
    ACTIONS(8029), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174488] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4384), 1,
      sym_comment,
    STATE(5338), 1,
      sym__initializer,
    ACTIONS(8031), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174509] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4385), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5713), 1,
      sym__call_signature,
  [174534] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    ACTIONS(8051), 1,
      anon_sym_SEMI,
    ACTIONS(8053), 1,
      sym__automatic_semicolon,
    ACTIONS(8055), 1,
      sym__function_signature_automatic_semicolon,
    STATE(2825), 1,
      sym_statement_block,
    STATE(4386), 1,
      sym_comment,
  [174559] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4387), 1,
      sym_comment,
    STATE(5299), 1,
      sym__initializer,
    ACTIONS(8035), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174580] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4388), 1,
      sym_comment,
    STATE(5336), 1,
      sym__initializer,
    ACTIONS(8031), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174601] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4389), 1,
      sym_comment,
    STATE(5245), 1,
      sym__initializer,
    ACTIONS(7919), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174622] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6796), 1,
      anon_sym_LPAREN,
    STATE(3571), 1,
      sym_formal_parameters,
    STATE(4390), 1,
      sym_comment,
    STATE(4510), 1,
      sym__call_signature,
    STATE(5701), 1,
      sym_type_parameters,
  [174647] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4391), 1,
      sym_comment,
    ACTIONS(2803), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [174664] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4392), 1,
      sym_comment,
    ACTIONS(1996), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [174681] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4393), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5746), 1,
      sym__call_signature,
  [174706] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4394), 1,
      sym_comment,
    STATE(5169), 1,
      sym__initializer,
    ACTIONS(8035), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174727] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1820), 1,
      anon_sym_LBRACE,
    ACTIONS(8057), 1,
      anon_sym_SEMI,
    ACTIONS(8059), 1,
      sym__automatic_semicolon,
    ACTIONS(8061), 1,
      sym__function_signature_automatic_semicolon,
    STATE(235), 1,
      sym_statement_block,
    STATE(4395), 1,
      sym_comment,
  [174752] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4396), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5727), 1,
      sym__call_signature,
  [174777] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(132), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1755), 1,
      anon_sym_LBRACE,
    ACTIONS(7409), 1,
      anon_sym_extends,
    STATE(874), 1,
      sym_object_type,
    STATE(4397), 1,
      sym_comment,
    STATE(4897), 1,
      sym_extends_type_clause,
  [174802] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4398), 1,
      sym_comment,
    ACTIONS(1952), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [174819] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4399), 1,
      sym_comment,
    ACTIONS(1920), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [174836] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4400), 1,
      sym_comment,
    STATE(5161), 1,
      sym__initializer,
    ACTIONS(7919), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174857] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4401), 1,
      sym_comment,
    STATE(5391), 1,
      sym__initializer,
    ACTIONS(7926), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174878] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4402), 1,
      sym_comment,
    STATE(5331), 1,
      sym__initializer,
    ACTIONS(8031), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174899] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4403), 1,
      sym_comment,
    STATE(5153), 1,
      sym__initializer,
    ACTIONS(8035), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174920] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1111), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2006), 1,
      anon_sym_LBRACE,
    ACTIONS(7409), 1,
      anon_sym_extends,
    STATE(4404), 1,
      sym_comment,
    STATE(4676), 1,
      sym_object_type,
    STATE(5104), 1,
      sym_extends_type_clause,
  [174945] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4405), 1,
      sym_comment,
    STATE(5462), 1,
      sym__initializer,
    ACTIONS(7919), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174966] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3037), 1,
      anon_sym_LBRACE,
    ACTIONS(8051), 1,
      anon_sym_SEMI,
    ACTIONS(8053), 1,
      sym__automatic_semicolon,
    ACTIONS(8055), 1,
      sym__function_signature_automatic_semicolon,
    STATE(959), 1,
      sym_statement_block,
    STATE(4406), 1,
      sym_comment,
  [174991] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4407), 1,
      sym_comment,
    STATE(5228), 1,
      sym__initializer,
    ACTIONS(8035), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175012] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4408), 1,
      sym_comment,
    STATE(5325), 1,
      sym__initializer,
    ACTIONS(8031), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175033] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4409), 1,
      sym_comment,
    STATE(5314), 1,
      sym__initializer,
    ACTIONS(8031), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175054] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4410), 1,
      sym_comment,
    STATE(5166), 1,
      sym__initializer,
    ACTIONS(7919), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175075] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4411), 1,
      sym_comment,
    ACTIONS(6048), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [175092] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4412), 1,
      sym_comment,
    ACTIONS(7625), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175109] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4413), 1,
      sym_comment,
    ACTIONS(6055), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [175126] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4414), 1,
      sym_comment,
    ACTIONS(7623), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175143] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4415), 1,
      sym_comment,
    STATE(5497), 1,
      sym__initializer,
    ACTIONS(8029), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175164] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4416), 1,
      sym_comment,
    ACTIONS(6055), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [175181] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4417), 1,
      sym_comment,
    STATE(5404), 1,
      sym__initializer,
    ACTIONS(8029), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175202] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4418), 1,
      sym_comment,
    ACTIONS(6055), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [175219] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4419), 1,
      sym_comment,
    STATE(5046), 1,
      sym__initializer,
    ACTIONS(8035), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175240] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4420), 1,
      sym_comment,
    STATE(5312), 1,
      sym__initializer,
    ACTIONS(8063), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175261] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4421), 1,
      sym_comment,
    ACTIONS(7621), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175278] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4422), 1,
      sym_comment,
    STATE(4867), 1,
      sym__initializer,
    ACTIONS(8065), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175299] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4423), 1,
      sym_comment,
    STATE(5430), 1,
      sym__initializer,
    ACTIONS(7919), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175320] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4424), 1,
      sym_comment,
    STATE(4881), 1,
      sym__initializer,
    ACTIONS(8035), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175341] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7930), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7932), 1,
      sym__template_chars,
    ACTIONS(8067), 1,
      anon_sym_BQUOTE,
    STATE(4425), 1,
      sym_comment,
    STATE(4466), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(5192), 1,
      sym_template_type,
  [175366] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4426), 1,
      sym_comment,
    ACTIONS(2743), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [175383] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4427), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5790), 1,
      sym__call_signature,
  [175408] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4428), 1,
      sym_comment,
    ACTIONS(2855), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [175425] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4429), 1,
      sym_comment,
    ACTIONS(2763), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [175442] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4430), 1,
      sym_comment,
    STATE(5424), 1,
      sym__initializer,
    ACTIONS(7926), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175463] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4431), 1,
      sym_comment,
    STATE(5167), 1,
      sym__initializer,
    ACTIONS(7919), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175484] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4432), 1,
      sym_comment,
    STATE(5162), 1,
      sym__initializer,
    ACTIONS(7919), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175505] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4433), 1,
      sym_comment,
    STATE(5168), 1,
      sym__initializer,
    ACTIONS(7919), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175526] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4434), 1,
      sym_comment,
    ACTIONS(7543), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [175543] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4435), 1,
      sym_comment,
    STATE(5179), 1,
      sym__initializer,
    ACTIONS(8035), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175564] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4436), 1,
      sym_comment,
    ACTIONS(8069), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [175581] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4437), 1,
      sym_comment,
    STATE(4949), 1,
      sym__initializer,
    ACTIONS(7926), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175602] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4438), 1,
      sym_comment,
    ACTIONS(2943), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [175619] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4439), 1,
      sym_comment,
    STATE(5316), 1,
      sym__initializer,
    ACTIONS(7919), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175640] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4440), 1,
      sym_comment,
    ACTIONS(2915), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [175657] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4441), 1,
      sym_comment,
    ACTIONS(2735), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [175674] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3855), 1,
      anon_sym_COLON,
    STATE(4442), 1,
      sym_comment,
    STATE(5686), 1,
      sym_type_annotation,
    ACTIONS(3928), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [175695] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4443), 1,
      sym_comment,
    ACTIONS(2927), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [175712] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7653), 1,
      anon_sym_COLON,
    ACTIONS(8071), 1,
      anon_sym_EQ_GT,
    STATE(4444), 1,
      sym_comment,
    STATE(5552), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
  [175733] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4445), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5735), 1,
      sym__call_signature,
  [175758] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4446), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5736), 1,
      sym__call_signature,
  [175783] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4447), 1,
      sym_comment,
    STATE(5448), 1,
      sym__initializer,
    ACTIONS(8029), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175804] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4448), 1,
      sym_comment,
    ACTIONS(2927), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [175821] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4449), 1,
      sym_comment,
    ACTIONS(2727), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [175838] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4450), 1,
      sym_comment,
    STATE(5447), 1,
      sym__initializer,
    ACTIONS(8029), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175859] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7653), 1,
      anon_sym_COLON,
    ACTIONS(8074), 1,
      anon_sym_EQ_GT,
    STATE(4451), 1,
      sym_comment,
    STATE(5604), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
  [175880] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4452), 1,
      sym_comment,
    STATE(5037), 1,
      sym__initializer,
    ACTIONS(8035), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175901] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7930), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7932), 1,
      sym__template_chars,
    ACTIONS(8077), 1,
      anon_sym_BQUOTE,
    STATE(4453), 1,
      sym_comment,
    STATE(4565), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(5192), 1,
      sym_template_type,
  [175926] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4454), 1,
      sym_comment,
    STATE(5321), 1,
      sym__initializer,
    ACTIONS(7919), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175947] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4455), 1,
      sym_comment,
    ACTIONS(2691), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [175964] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6796), 1,
      anon_sym_LPAREN,
    STATE(3571), 1,
      sym_formal_parameters,
    STATE(4456), 1,
      sym_comment,
    STATE(4597), 1,
      sym__call_signature,
    STATE(5701), 1,
      sym_type_parameters,
  [175989] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4457), 1,
      sym_comment,
    ACTIONS(2679), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [176006] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4458), 1,
      sym_comment,
    ACTIONS(2711), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [176023] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    STATE(4459), 1,
      sym_comment,
    ACTIONS(8079), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [176046] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4460), 1,
      sym_comment,
    STATE(5436), 1,
      sym__initializer,
    ACTIONS(8035), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [176067] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7930), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7932), 1,
      sym__template_chars,
    ACTIONS(8081), 1,
      anon_sym_BQUOTE,
    STATE(4425), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(4461), 1,
      sym_comment,
    STATE(5192), 1,
      sym_template_type,
  [176092] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4462), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5707), 1,
      sym__call_signature,
  [176117] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4463), 1,
      sym_comment,
    STATE(4893), 1,
      sym__initializer,
    ACTIONS(7919), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [176138] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6716), 1,
      anon_sym_LBRACK,
    ACTIONS(8083), 1,
      anon_sym_RBRACE,
    STATE(4464), 1,
      sym_comment,
    ACTIONS(4797), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [176159] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4465), 1,
      sym_comment,
    STATE(5327), 1,
      sym__initializer,
    ACTIONS(7919), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [176180] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8085), 1,
      anon_sym_BQUOTE,
    ACTIONS(8087), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(8090), 1,
      sym__template_chars,
    STATE(5192), 1,
      sym_template_type,
    STATE(4466), 2,
      sym_comment,
      aux_sym_template_literal_type_repeat1,
  [176203] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4467), 1,
      sym_comment,
    ACTIONS(2867), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [176220] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4468), 1,
      sym_comment,
    ACTIONS(2875), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [176237] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    STATE(4469), 1,
      sym_comment,
    ACTIONS(8093), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [176260] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4470), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5722), 1,
      sym__call_signature,
  [176285] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4471), 1,
      sym_comment,
    ACTIONS(2683), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [176302] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4472), 1,
      sym_comment,
    ACTIONS(7567), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [176319] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4473), 1,
      sym_comment,
    STATE(5446), 1,
      sym__initializer,
    ACTIONS(8035), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [176340] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3814), 1,
      anon_sym_LPAREN,
    ACTIONS(7143), 1,
      anon_sym_DOT,
    STATE(3766), 1,
      sym_arguments,
    STATE(4474), 1,
      sym_comment,
    ACTIONS(8095), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [176363] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    STATE(4475), 1,
      sym_comment,
    ACTIONS(8097), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [176386] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4476), 1,
      sym_comment,
    ACTIONS(2987), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [176403] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4477), 1,
      sym_comment,
    ACTIONS(2987), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [176420] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4478), 1,
      sym_comment,
    ACTIONS(2987), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [176437] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4479), 1,
      sym_comment,
    STATE(5300), 1,
      sym__initializer,
    ACTIONS(8031), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [176458] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4480), 1,
      sym_comment,
    STATE(5298), 1,
      sym__initializer,
    ACTIONS(8031), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [176479] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4481), 1,
      sym_comment,
    ACTIONS(7569), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [176496] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4482), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5573), 1,
      sym__call_signature,
  [176521] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4483), 1,
      sym_comment,
    ACTIONS(2903), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [176538] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6796), 1,
      anon_sym_LPAREN,
    STATE(3571), 1,
      sym_formal_parameters,
    STATE(4264), 1,
      sym__call_signature,
    STATE(4484), 1,
      sym_comment,
    STATE(5701), 1,
      sym_type_parameters,
  [176563] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4485), 1,
      sym_comment,
    STATE(5384), 1,
      sym__initializer,
    ACTIONS(8029), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [176584] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4486), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5586), 1,
      sym__call_signature,
  [176609] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4487), 1,
      sym_comment,
    STATE(5252), 1,
      sym__initializer,
    ACTIONS(8029), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [176630] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6796), 1,
      anon_sym_LPAREN,
    STATE(3571), 1,
      sym_formal_parameters,
    STATE(4276), 1,
      sym__call_signature,
    STATE(4488), 1,
      sym_comment,
    STATE(5701), 1,
      sym_type_parameters,
  [176655] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4489), 1,
      sym_comment,
    STATE(5376), 1,
      sym__initializer,
    ACTIONS(8035), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [176676] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6796), 1,
      anon_sym_LPAREN,
    STATE(3571), 1,
      sym_formal_parameters,
    STATE(4279), 1,
      sym__call_signature,
    STATE(4490), 1,
      sym_comment,
    STATE(5701), 1,
      sym_type_parameters,
  [176701] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(7960), 1,
      anon_sym_abstract,
    ACTIONS(8099), 1,
      anon_sym_class,
    STATE(1202), 1,
      sym_decorator,
    STATE(4059), 1,
      aux_sym_export_statement_repeat1,
    STATE(4491), 1,
      sym_comment,
  [176726] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6005), 1,
      sym__automatic_semicolon,
    STATE(4492), 1,
      sym_comment,
    ACTIONS(1866), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [176745] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4493), 1,
      sym_comment,
    ACTIONS(2827), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [176762] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4494), 1,
      sym_comment,
    ACTIONS(1910), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [176779] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4495), 1,
      sym_comment,
    STATE(5364), 1,
      sym__initializer,
    ACTIONS(8035), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [176800] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6796), 1,
      anon_sym_LPAREN,
    STATE(3571), 1,
      sym_formal_parameters,
    STATE(4294), 1,
      sym__call_signature,
    STATE(4496), 1,
      sym_comment,
    STATE(5701), 1,
      sym_type_parameters,
  [176825] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4497), 1,
      sym_comment,
    ACTIONS(1962), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [176842] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(8027), 1,
      sym_identifier,
    STATE(4498), 1,
      sym_comment,
    STATE(4799), 1,
      sym_string,
    STATE(5791), 1,
      sym__module_export_name,
  [176867] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6796), 1,
      anon_sym_LPAREN,
    STATE(3571), 1,
      sym_formal_parameters,
    STATE(4499), 1,
      sym_comment,
    STATE(4572), 1,
      sym__call_signature,
    STATE(5701), 1,
      sym_type_parameters,
  [176892] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8057), 1,
      anon_sym_SEMI,
    ACTIONS(8059), 1,
      sym__automatic_semicolon,
    ACTIONS(8061), 1,
      sym__function_signature_automatic_semicolon,
    ACTIONS(8101), 1,
      anon_sym_LBRACE,
    STATE(776), 1,
      sym_statement_block,
    STATE(4500), 1,
      sym_comment,
  [176917] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6985), 1,
      anon_sym_AMP,
    ACTIONS(6989), 1,
      anon_sym_extends,
    ACTIONS(8025), 1,
      anon_sym_PIPE,
    STATE(4501), 1,
      sym_comment,
    ACTIONS(8103), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [176940] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4502), 1,
      sym_comment,
    STATE(5292), 1,
      sym__initializer,
    ACTIONS(8031), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [176961] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4503), 1,
      sym_comment,
    STATE(5337), 1,
      sym__initializer,
    ACTIONS(8029), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [176982] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4504), 1,
      sym_comment,
    STATE(5290), 1,
      sym__initializer,
    ACTIONS(8031), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [177003] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4505), 1,
      sym_comment,
    STATE(5415), 1,
      sym__initializer,
    ACTIONS(7934), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [177024] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4506), 1,
      sym_comment,
    ACTIONS(8105), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_extends,
      anon_sym_implements,
  [177041] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4507), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5759), 1,
      sym__call_signature,
  [177066] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4508), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5836), 1,
      sym__call_signature,
  [177091] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4509), 1,
      sym_comment,
    STATE(5334), 1,
      sym__initializer,
    ACTIONS(8029), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [177112] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1820), 1,
      anon_sym_LBRACE,
    ACTIONS(8107), 1,
      anon_sym_SEMI,
    ACTIONS(8109), 1,
      sym__automatic_semicolon,
    ACTIONS(8111), 1,
      sym__function_signature_automatic_semicolon,
    STATE(239), 1,
      sym_statement_block,
    STATE(4510), 1,
      sym_comment,
  [177137] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4511), 1,
      sym_comment,
    STATE(5330), 1,
      sym__initializer,
    ACTIONS(8035), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [177158] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4512), 1,
      sym_comment,
    STATE(5157), 1,
      sym__initializer,
    ACTIONS(7924), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [177179] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4513), 1,
      sym_comment,
    ACTIONS(1986), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [177196] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4514), 1,
      sym_comment,
    STATE(5479), 1,
      sym__initializer,
    ACTIONS(7919), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [177217] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7498), 1,
      anon_sym_EQ,
    ACTIONS(8113), 1,
      anon_sym_COMMA,
    ACTIONS(8115), 1,
      anon_sym_RBRACE,
    STATE(4515), 1,
      sym_comment,
    STATE(5191), 1,
      aux_sym_enum_body_repeat1,
    STATE(5842), 1,
      sym__initializer,
  [177242] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6796), 1,
      anon_sym_LPAREN,
    STATE(3571), 1,
      sym_formal_parameters,
    STATE(4516), 1,
      sym_comment,
    STATE(4639), 1,
      sym__call_signature,
    STATE(5701), 1,
      sym_type_parameters,
  [177267] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4517), 1,
      sym_comment,
    STATE(5204), 1,
      sym__initializer,
    ACTIONS(7924), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [177288] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4518), 1,
      sym_comment,
    STATE(5031), 1,
      sym__initializer,
    ACTIONS(7926), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [177309] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4519), 1,
      sym_comment,
    ACTIONS(5958), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [177326] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4520), 1,
      sym_comment,
    STATE(5257), 1,
      sym__call_signature,
    STATE(5867), 1,
      sym_type_parameters,
  [177351] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4521), 1,
      sym_comment,
    ACTIONS(5950), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [177368] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4522), 1,
      sym_comment,
    ACTIONS(2647), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [177385] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4523), 1,
      sym_comment,
    ACTIONS(2655), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [177402] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4524), 1,
      sym_comment,
    ACTIONS(5950), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [177419] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4525), 1,
      sym_comment,
    ACTIONS(2655), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [177436] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4526), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5765), 1,
      sym__call_signature,
  [177461] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4527), 1,
      sym_comment,
    ACTIONS(5950), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [177478] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6796), 1,
      anon_sym_LPAREN,
    STATE(3571), 1,
      sym_formal_parameters,
    STATE(4528), 1,
      sym_comment,
    STATE(4651), 1,
      sym__call_signature,
    STATE(5701), 1,
      sym_type_parameters,
  [177503] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4529), 1,
      sym_comment,
    ACTIONS(2651), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [177520] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6796), 1,
      anon_sym_LPAREN,
    STATE(3571), 1,
      sym_formal_parameters,
    STATE(4139), 1,
      sym__call_signature,
    STATE(4530), 1,
      sym_comment,
    STATE(5701), 1,
      sym_type_parameters,
  [177545] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4531), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5825), 1,
      sym__call_signature,
  [177570] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4532), 1,
      sym_comment,
    ACTIONS(2759), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [177587] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(7665), 1,
      anon_sym_abstract,
    ACTIONS(7843), 1,
      anon_sym_class,
    STATE(1202), 1,
      sym_decorator,
    STATE(4059), 1,
      aux_sym_export_statement_repeat1,
    STATE(4533), 1,
      sym_comment,
  [177612] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4534), 1,
      sym_comment,
    ACTIONS(8117), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [177629] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4535), 1,
      sym_comment,
    STATE(5397), 1,
      sym__initializer,
    ACTIONS(8119), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [177650] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4536), 1,
      sym_comment,
    STATE(5288), 1,
      sym__initializer,
    ACTIONS(8031), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [177671] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4537), 1,
      sym_comment,
    STATE(5435), 1,
      sym__initializer,
    ACTIONS(8121), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [177692] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4538), 1,
      sym_comment,
    ACTIONS(2667), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [177709] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4539), 1,
      sym_comment,
    STATE(5280), 1,
      sym__initializer,
    ACTIONS(8031), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [177730] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4540), 1,
      sym_comment,
    STATE(5417), 1,
      sym__initializer,
    ACTIONS(8123), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [177751] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4541), 1,
      sym_comment,
    STATE(5451), 1,
      sym__initializer,
    ACTIONS(7924), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [177772] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4542), 1,
      sym_comment,
    STATE(5235), 1,
      sym__initializer,
    ACTIONS(8125), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [177793] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4543), 1,
      sym_comment,
    ACTIONS(7567), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [177810] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4544), 1,
      sym_comment,
    ACTIONS(8127), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [177827] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    STATE(4545), 1,
      sym_comment,
    ACTIONS(8129), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
  [177850] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4546), 1,
      sym_comment,
    STATE(4621), 1,
      sym__call_signature,
    STATE(5867), 1,
      sym_type_parameters,
  [177875] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4547), 1,
      sym_comment,
    ACTIONS(8131), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [177892] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4548), 1,
      sym_comment,
    ACTIONS(7549), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [177909] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4549), 1,
      sym_comment,
    STATE(5466), 1,
      sym__initializer,
    ACTIONS(7924), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [177930] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4550), 1,
      sym_comment,
    ACTIONS(8133), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [177947] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4551), 1,
      sym_comment,
    ACTIONS(7549), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [177964] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4552), 1,
      sym_comment,
    ACTIONS(8135), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [177981] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4553), 1,
      sym_comment,
    STATE(4889), 1,
      sym__initializer,
    ACTIONS(7919), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [178002] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4554), 1,
      sym_comment,
    STATE(5125), 1,
      sym__initializer,
    ACTIONS(8137), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [178023] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4555), 1,
      sym_comment,
    ACTIONS(7823), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [178040] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4556), 1,
      sym_comment,
    STATE(5216), 1,
      sym__initializer,
    ACTIONS(7924), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [178061] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4557), 1,
      sym_comment,
    ACTIONS(7551), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [178078] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6796), 1,
      anon_sym_LPAREN,
    STATE(3571), 1,
      sym_formal_parameters,
    STATE(4187), 1,
      sym__call_signature,
    STATE(4558), 1,
      sym_comment,
    STATE(5701), 1,
      sym_type_parameters,
  [178103] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4559), 1,
      sym_comment,
    ACTIONS(8139), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [178120] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7653), 1,
      anon_sym_COLON,
    ACTIONS(8141), 1,
      anon_sym_EQ_GT,
    STATE(4560), 1,
      sym_comment,
    STATE(5552), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
  [178141] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4561), 1,
      sym_comment,
    ACTIONS(8144), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [178158] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4562), 1,
      sym_comment,
    STATE(5272), 1,
      sym__initializer,
    ACTIONS(7924), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [178179] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7653), 1,
      anon_sym_COLON,
    ACTIONS(8146), 1,
      anon_sym_EQ_GT,
    STATE(4563), 1,
      sym_comment,
    STATE(5604), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
  [178200] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4564), 1,
      sym_comment,
    ACTIONS(8149), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_extends,
      anon_sym_implements,
  [178217] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7930), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7932), 1,
      sym__template_chars,
    ACTIONS(8151), 1,
      anon_sym_BQUOTE,
    STATE(4466), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(4565), 1,
      sym_comment,
    STATE(5192), 1,
      sym_template_type,
  [178242] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4566), 1,
      sym_comment,
    STATE(5278), 1,
      sym__initializer,
    ACTIONS(8031), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [178263] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(3988), 1,
      sym__call_signature,
    STATE(4567), 1,
      sym_comment,
    STATE(5867), 1,
      sym_type_parameters,
  [178288] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4568), 1,
      sym_comment,
    STATE(5467), 1,
      sym__initializer,
    ACTIONS(7926), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [178309] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(3996), 1,
      sym__call_signature,
    STATE(4569), 1,
      sym_comment,
    STATE(5867), 1,
      sym_type_parameters,
  [178334] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4570), 1,
      sym_comment,
    STATE(5116), 1,
      sym__initializer,
    ACTIONS(7919), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [178355] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4006), 1,
      sym__call_signature,
    STATE(4571), 1,
      sym_comment,
    STATE(5867), 1,
      sym_type_parameters,
  [178380] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8101), 1,
      anon_sym_LBRACE,
    ACTIONS(8107), 1,
      anon_sym_SEMI,
    ACTIONS(8109), 1,
      sym__automatic_semicolon,
    ACTIONS(8111), 1,
      sym__function_signature_automatic_semicolon,
    STATE(784), 1,
      sym_statement_block,
    STATE(4572), 1,
      sym_comment,
  [178405] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4573), 1,
      sym_comment,
    STATE(5201), 1,
      sym__initializer,
    ACTIONS(7934), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [178426] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4011), 1,
      sym__call_signature,
    STATE(4574), 1,
      sym_comment,
    STATE(5867), 1,
      sym_type_parameters,
  [178451] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4575), 1,
      sym_comment,
    STATE(5277), 1,
      sym__initializer,
    ACTIONS(8031), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [178472] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4576), 1,
      sym_comment,
    STATE(5197), 1,
      sym__initializer,
    ACTIONS(8153), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [178493] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6985), 1,
      anon_sym_AMP,
    ACTIONS(6989), 1,
      anon_sym_extends,
    ACTIONS(8025), 1,
      anon_sym_PIPE,
    STATE(4577), 1,
      sym_comment,
    ACTIONS(8155), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [178516] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6985), 1,
      anon_sym_AMP,
    ACTIONS(6989), 1,
      anon_sym_extends,
    ACTIONS(8025), 1,
      anon_sym_PIPE,
    STATE(4578), 1,
      sym_comment,
    ACTIONS(8157), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [178539] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6796), 1,
      anon_sym_LPAREN,
    STATE(3571), 1,
      sym_formal_parameters,
    STATE(4076), 1,
      sym__call_signature,
    STATE(4579), 1,
      sym_comment,
    STATE(5701), 1,
      sym_type_parameters,
  [178564] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8161), 1,
      anon_sym_in,
    ACTIONS(8163), 1,
      anon_sym_of,
    STATE(4580), 1,
      sym_comment,
    ACTIONS(8159), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [178585] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8165), 1,
      anon_sym_in,
    ACTIONS(8167), 1,
      anon_sym_of,
    STATE(4581), 1,
      sym_comment,
    ACTIONS(8159), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [178606] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4582), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5936), 1,
      sym__call_signature,
  [178631] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4583), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5638), 1,
      sym__call_signature,
  [178656] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4584), 1,
      sym_comment,
    STATE(5155), 1,
      sym__initializer,
    ACTIONS(7934), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [178677] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4000), 1,
      sym__call_signature,
    STATE(4585), 1,
      sym_comment,
    STATE(5867), 1,
      sym_type_parameters,
  [178702] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6970), 1,
      anon_sym_LT,
    ACTIONS(8169), 1,
      anon_sym_LBRACE,
    STATE(4586), 1,
      sym_comment,
    STATE(5407), 1,
      sym_type_arguments,
    ACTIONS(8171), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [178725] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4587), 1,
      sym_comment,
    STATE(5295), 1,
      sym__initializer,
    ACTIONS(7934), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [178746] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4588), 1,
      sym_comment,
    STATE(5276), 1,
      sym__initializer,
    ACTIONS(8031), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [178767] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4589), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5802), 1,
      sym__call_signature,
  [178792] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6985), 1,
      anon_sym_AMP,
    ACTIONS(6989), 1,
      anon_sym_extends,
    ACTIONS(8025), 1,
      anon_sym_PIPE,
    STATE(4590), 1,
      sym_comment,
    ACTIONS(8173), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [178815] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6796), 1,
      anon_sym_LPAREN,
    STATE(3571), 1,
      sym_formal_parameters,
    STATE(4368), 1,
      sym__call_signature,
    STATE(4591), 1,
      sym_comment,
    STATE(5701), 1,
      sym_type_parameters,
  [178840] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4592), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5920), 1,
      sym__call_signature,
  [178865] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4593), 1,
      sym_comment,
    STATE(5271), 1,
      sym__initializer,
    ACTIONS(8031), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [178886] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4594), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5655), 1,
      sym__call_signature,
  [178911] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6796), 1,
      anon_sym_LPAREN,
    STATE(3571), 1,
      sym_formal_parameters,
    STATE(4381), 1,
      sym__call_signature,
    STATE(4595), 1,
      sym_comment,
    STATE(5701), 1,
      sym_type_parameters,
  [178936] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6985), 1,
      anon_sym_AMP,
    ACTIONS(6989), 1,
      anon_sym_extends,
    ACTIONS(8025), 1,
      anon_sym_PIPE,
    STATE(4596), 1,
      sym_comment,
    ACTIONS(8175), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [178959] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    ACTIONS(8107), 1,
      anon_sym_SEMI,
    ACTIONS(8109), 1,
      sym__automatic_semicolon,
    ACTIONS(8111), 1,
      sym__function_signature_automatic_semicolon,
    STATE(2833), 1,
      sym_statement_block,
    STATE(4597), 1,
      sym_comment,
  [178984] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4598), 1,
      sym_comment,
    STATE(5478), 1,
      sym__initializer,
    ACTIONS(7926), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179005] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4599), 1,
      sym_comment,
    STATE(5256), 1,
      sym__initializer,
    ACTIONS(8031), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179026] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4600), 1,
      sym_comment,
    ACTIONS(6044), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [179043] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4601), 1,
      sym_comment,
    ACTIONS(7555), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [179060] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4602), 1,
      sym_comment,
    STATE(5152), 1,
      sym__initializer,
    ACTIONS(7919), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179081] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6796), 1,
      anon_sym_LPAREN,
    STATE(3571), 1,
      sym_formal_parameters,
    STATE(4386), 1,
      sym__call_signature,
    STATE(4603), 1,
      sym_comment,
    STATE(5701), 1,
      sym_type_parameters,
  [179106] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7827), 1,
      anon_sym_AMP,
    ACTIONS(7829), 1,
      anon_sym_PIPE,
    ACTIONS(7831), 1,
      anon_sym_extends,
    ACTIONS(8177), 1,
      anon_sym_as,
    ACTIONS(8179), 1,
      anon_sym_RBRACK,
    STATE(4604), 1,
      sym_comment,
  [179131] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4605), 1,
      sym_comment,
    STATE(5208), 1,
      sym__initializer,
    ACTIONS(8031), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179152] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4606), 1,
      sym_comment,
    ACTIONS(8181), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [179169] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4607), 1,
      sym_comment,
    ACTIONS(8183), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [179186] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4608), 1,
      sym_comment,
    ACTIONS(7553), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [179203] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4609), 1,
      sym_comment,
    ACTIONS(8185), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [179220] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4610), 1,
      sym_comment,
    STATE(4960), 1,
      sym__initializer,
    ACTIONS(8187), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179241] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7653), 1,
      anon_sym_COLON,
    ACTIONS(8189), 1,
      anon_sym_EQ_GT,
    STATE(4611), 1,
      sym_comment,
    STATE(5604), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
  [179262] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4612), 1,
      sym_comment,
    ACTIONS(8192), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [179279] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4613), 1,
      sym_comment,
    STATE(5217), 1,
      sym__initializer,
    ACTIONS(8031), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179300] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4614), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5781), 1,
      sym__call_signature,
  [179325] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4615), 1,
      sym_comment,
    ACTIONS(2699), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [179342] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4616), 1,
      sym_comment,
    ACTIONS(8194), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [179359] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5983), 1,
      sym__automatic_semicolon,
    STATE(4617), 1,
      sym_comment,
    ACTIONS(1890), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [179378] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5981), 1,
      sym__automatic_semicolon,
    STATE(4618), 1,
      sym_comment,
    ACTIONS(1880), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [179397] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4619), 1,
      sym_comment,
    ACTIONS(7555), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [179414] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4357), 1,
      sym__call_signature,
    STATE(4620), 1,
      sym_comment,
    STATE(5867), 1,
      sym_type_parameters,
  [179439] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4621), 1,
      sym_comment,
    ACTIONS(7553), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [179456] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4622), 1,
      sym_comment,
    STATE(5146), 1,
      sym__initializer,
    ACTIONS(8196), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179477] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6796), 1,
      anon_sym_LPAREN,
    STATE(3571), 1,
      sym_formal_parameters,
    STATE(4163), 1,
      sym__call_signature,
    STATE(4623), 1,
      sym_comment,
    STATE(5701), 1,
      sym_type_parameters,
  [179502] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4624), 1,
      sym_comment,
    STATE(5502), 1,
      sym__initializer,
    ACTIONS(7924), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179523] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(7891), 1,
      anon_sym_class,
    ACTIONS(7893), 1,
      anon_sym_abstract,
    STATE(1202), 1,
      sym_decorator,
    STATE(4059), 1,
      aux_sym_export_statement_repeat1,
    STATE(4625), 1,
      sym_comment,
  [179548] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4626), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5782), 1,
      sym__call_signature,
  [179573] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4627), 1,
      sym_comment,
    STATE(5145), 1,
      sym__initializer,
    ACTIONS(7919), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179594] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4628), 1,
      sym_comment,
    STATE(5255), 1,
      sym__initializer,
    ACTIONS(8031), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179615] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4629), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5816), 1,
      sym__call_signature,
  [179640] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    ACTIONS(8027), 1,
      sym_identifier,
    STATE(4630), 1,
      sym_comment,
    STATE(4799), 1,
      sym_string,
    STATE(5865), 1,
      sym__module_export_name,
  [179665] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4631), 1,
      sym_comment,
    STATE(5380), 1,
      sym__initializer,
    ACTIONS(7924), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179686] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(3982), 1,
      sym__call_signature,
    STATE(4632), 1,
      sym_comment,
    STATE(5867), 1,
      sym_type_parameters,
  [179711] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4633), 1,
      sym_comment,
    STATE(5123), 1,
      sym__initializer,
    ACTIONS(8063), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179732] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7498), 1,
      anon_sym_EQ,
    ACTIONS(8198), 1,
      anon_sym_COMMA,
    ACTIONS(8200), 1,
      anon_sym_RBRACE,
    STATE(4634), 1,
      sym_comment,
    STATE(5188), 1,
      aux_sym_enum_body_repeat1,
    STATE(5842), 1,
      sym__initializer,
  [179757] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6796), 1,
      anon_sym_LPAREN,
    STATE(3571), 1,
      sym_formal_parameters,
    STATE(4635), 1,
      sym_comment,
    STATE(4640), 1,
      sym__call_signature,
    STATE(5701), 1,
      sym_type_parameters,
  [179782] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4636), 1,
      sym_comment,
    STATE(5117), 1,
      sym__initializer,
    ACTIONS(8196), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179803] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4637), 1,
      sym_comment,
    ACTIONS(2695), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [179820] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4638), 1,
      sym_comment,
    ACTIONS(2895), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [179837] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4713), 1,
      anon_sym_LBRACE,
    ACTIONS(8107), 1,
      anon_sym_SEMI,
    ACTIONS(8109), 1,
      sym__automatic_semicolon,
    ACTIONS(8111), 1,
      sym__function_signature_automatic_semicolon,
    STATE(2560), 1,
      sym_statement_block,
    STATE(4639), 1,
      sym_comment,
  [179862] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4713), 1,
      anon_sym_LBRACE,
    ACTIONS(8057), 1,
      anon_sym_SEMI,
    ACTIONS(8059), 1,
      sym__automatic_semicolon,
    ACTIONS(8061), 1,
      sym__function_signature_automatic_semicolon,
    STATE(2534), 1,
      sym_statement_block,
    STATE(4640), 1,
      sym_comment,
  [179887] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4641), 1,
      sym_comment,
    ACTIONS(2895), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [179904] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4642), 1,
      sym_comment,
    STATE(4956), 1,
      sym__initializer,
    ACTIONS(8202), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179925] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7405), 1,
      anon_sym_LBRACE,
    ACTIONS(7409), 1,
      anon_sym_extends,
    ACTIONS(7411), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2985), 1,
      sym_object_type,
    STATE(4643), 1,
      sym_comment,
    STATE(5313), 1,
      sym_extends_type_clause,
  [179950] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4644), 1,
      sym_comment,
    STATE(4870), 1,
      sym__initializer,
    ACTIONS(7926), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179971] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4645), 1,
      sym_comment,
    STATE(4864), 1,
      sym__initializer,
    ACTIONS(7919), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179992] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4646), 1,
      sym_comment,
    STATE(5225), 1,
      sym__initializer,
    ACTIONS(8031), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180013] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6985), 1,
      anon_sym_AMP,
    ACTIONS(6989), 1,
      anon_sym_extends,
    ACTIONS(8025), 1,
      anon_sym_PIPE,
    STATE(4647), 1,
      sym_comment,
    ACTIONS(8204), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [180036] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4648), 1,
      sym_comment,
    ACTIONS(2911), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [180053] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4649), 1,
      sym_comment,
    STATE(5232), 1,
      sym__initializer,
    ACTIONS(8031), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180074] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4650), 1,
      sym_comment,
    ACTIONS(2919), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [180091] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    ACTIONS(8057), 1,
      anon_sym_SEMI,
    ACTIONS(8059), 1,
      sym__automatic_semicolon,
    ACTIONS(8061), 1,
      sym__function_signature_automatic_semicolon,
    STATE(2825), 1,
      sym_statement_block,
    STATE(4651), 1,
      sym_comment,
  [180116] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4652), 1,
      sym_comment,
    ACTIONS(1934), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [180133] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4653), 1,
      sym_comment,
    ACTIONS(2895), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [180150] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4654), 1,
      sym_comment,
    ACTIONS(2843), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [180167] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4655), 1,
      sym_comment,
    STATE(5047), 1,
      sym__initializer,
    ACTIONS(8206), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180188] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4656), 1,
      sym_comment,
    ACTIONS(2843), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [180205] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4046), 1,
      sym_formal_parameters,
    STATE(4657), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_parameters,
    STATE(5801), 1,
      sym__call_signature,
  [180230] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4658), 1,
      sym_comment,
    STATE(5044), 1,
      sym__initializer,
    ACTIONS(8206), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180251] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4659), 1,
      sym_comment,
    ACTIONS(2999), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [180268] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4660), 1,
      sym_comment,
    STATE(4967), 1,
      sym__initializer,
    ACTIONS(7919), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180289] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4661), 1,
      sym_comment,
    STATE(5043), 1,
      sym__initializer,
    ACTIONS(8196), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180310] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4662), 1,
      sym_comment,
    STATE(5142), 1,
      sym__initializer,
    ACTIONS(8196), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180331] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8208), 1,
      anon_sym_EQ,
    STATE(4663), 1,
      sym_comment,
    ACTIONS(3908), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [180350] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5918), 1,
      sym__automatic_semicolon,
    STATE(4664), 1,
      sym_comment,
    ACTIONS(1832), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [180369] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6796), 1,
      anon_sym_LPAREN,
    STATE(3571), 1,
      sym_formal_parameters,
    STATE(4406), 1,
      sym__call_signature,
    STATE(4665), 1,
      sym_comment,
    STATE(5701), 1,
      sym_type_parameters,
  [180394] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4666), 1,
      sym_comment,
    ACTIONS(2895), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [180411] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4667), 1,
      sym_comment,
    STATE(4981), 1,
      sym__initializer,
    ACTIONS(7934), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180432] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4668), 1,
      sym_comment,
    ACTIONS(3003), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [180449] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4669), 1,
      sym_comment,
    STATE(4920), 1,
      sym__initializer,
    ACTIONS(8196), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180470] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4670), 1,
      sym_comment,
    ACTIONS(2895), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [180487] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4671), 1,
      sym_comment,
    ACTIONS(2895), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [180504] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4672), 1,
      sym_comment,
    ACTIONS(2923), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [180521] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4673), 1,
      sym_comment,
    ACTIONS(2935), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [180538] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6760), 1,
      anon_sym_EQ,
    STATE(4674), 1,
      sym_comment,
    STATE(4988), 1,
      sym__initializer,
    ACTIONS(8196), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180559] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    STATE(3540), 1,
      sym_formal_parameters,
    STATE(4675), 1,
      sym_comment,
    STATE(4888), 1,
      sym__call_signature,
    STATE(5867), 1,
      sym_type_parameters,
  [180584] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4676), 1,
      sym_comment,
    ACTIONS(2939), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [180601] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4677), 1,
      sym_comment,
    ACTIONS(2947), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [180618] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4678), 1,
      sym_comment,
    ACTIONS(2983), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [180635] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4679), 1,
      sym_comment,
    ACTIONS(2843), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [180652] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7653), 1,
      anon_sym_COLON,
    ACTIONS(8210), 1,
      anon_sym_EQ_GT,
    STATE(4680), 1,
      sym_comment,
    STATE(5552), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
  [180673] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8213), 1,
      anon_sym_EQ,
    STATE(4681), 1,
      sym_comment,
    STATE(5875), 1,
      sym__initializer,
    ACTIONS(7043), 2,
      anon_sym_in,
      anon_sym_of,
  [180693] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(801), 1,
      sym_statement_block,
    STATE(4682), 1,
      sym_comment,
    ACTIONS(1822), 2,
      anon_sym_else,
      anon_sym_while,
  [180713] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8215), 1,
      anon_sym_DQUOTE,
    STATE(4683), 1,
      sym_comment,
    STATE(4693), 1,
      aux_sym_string_repeat1,
    ACTIONS(8217), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [180733] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8215), 1,
      anon_sym_SQUOTE,
    STATE(4684), 1,
      sym_comment,
    STATE(4694), 1,
      aux_sym_string_repeat2,
    ACTIONS(8219), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [180753] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(8221), 1,
      anon_sym_RPAREN,
    STATE(4685), 1,
      sym_comment,
  [180775] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(8223), 1,
      anon_sym_QMARK,
    STATE(4686), 1,
      sym_comment,
  [180797] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6686), 1,
      anon_sym_LPAREN,
    ACTIONS(6692), 1,
      anon_sym_LT,
    STATE(3469), 1,
      sym_arguments,
    STATE(3592), 1,
      sym_type_arguments,
    STATE(4687), 1,
      sym_comment,
  [180819] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4688), 1,
      sym_comment,
    ACTIONS(7095), 4,
      anon_sym_default,
      anon_sym_readonly,
      anon_sym_property,
      anon_sym_required,
  [180835] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4689), 1,
      sym_comment,
    ACTIONS(8225), 4,
      anon_sym_default,
      anon_sym_readonly,
      anon_sym_property,
      anon_sym_required,
  [180851] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7529), 1,
      anon_sym_DOT,
    ACTIONS(8227), 1,
      anon_sym_COMMA,
    ACTIONS(8229), 1,
      anon_sym_GT,
    STATE(4690), 1,
      sym_comment,
    STATE(5494), 1,
      aux_sym_type_arguments_repeat1,
  [180873] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4691), 1,
      sym_comment,
    ACTIONS(7968), 4,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_on,
  [180889] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8233), 1,
      anon_sym_DOT,
    STATE(4692), 1,
      sym_comment,
    ACTIONS(8231), 3,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
  [180907] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8235), 1,
      anon_sym_DQUOTE,
    STATE(4693), 1,
      sym_comment,
    STATE(4704), 1,
      aux_sym_string_repeat1,
    ACTIONS(8217), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [180927] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8235), 1,
      anon_sym_SQUOTE,
    STATE(4694), 1,
      sym_comment,
    STATE(4709), 1,
      aux_sym_string_repeat2,
    ACTIONS(8219), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [180947] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(8237), 1,
      anon_sym_QMARK,
    STATE(4695), 1,
      sym_comment,
  [180969] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4696), 1,
      sym_comment,
    ACTIONS(7964), 4,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_on,
  [180985] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(8239), 1,
      anon_sym_QMARK,
    STATE(4697), 1,
      sym_comment,
  [181007] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(8241), 1,
      sym_identifier,
    STATE(4698), 1,
      sym_comment,
    STATE(4710), 1,
      sym_string,
  [181029] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8243), 1,
      anon_sym_COMMA,
    STATE(4699), 1,
      sym_comment,
    STATE(4716), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(8245), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [181049] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(8247), 1,
      anon_sym_RBRACK,
    STATE(4700), 1,
      sym_comment,
  [181071] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8249), 1,
      sym_identifier,
    ACTIONS(8251), 1,
      anon_sym_const,
    ACTIONS(8253), 1,
      anon_sym_GT,
    STATE(4701), 1,
      sym_comment,
    STATE(5744), 1,
      sym_type_parameter,
  [181093] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8255), 1,
      anon_sym_LPAREN,
    STATE(4702), 1,
      sym_comment,
    STATE(5537), 1,
      sym_ui_signal_parameters,
    ACTIONS(8257), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [181113] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(8259), 1,
      anon_sym_QMARK,
    STATE(4703), 1,
      sym_comment,
  [181135] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8261), 1,
      anon_sym_DQUOTE,
    ACTIONS(8263), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
    STATE(4704), 2,
      sym_comment,
      aux_sym_string_repeat1,
  [181153] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8266), 1,
      anon_sym_SQUOTE,
    STATE(4705), 1,
      sym_comment,
    STATE(4709), 1,
      aux_sym_string_repeat2,
    ACTIONS(8219), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [181173] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8266), 1,
      anon_sym_DQUOTE,
    STATE(4704), 1,
      aux_sym_string_repeat1,
    STATE(4706), 1,
      sym_comment,
    ACTIONS(8217), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [181193] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8268), 1,
      anon_sym_SQUOTE,
    STATE(4705), 1,
      aux_sym_string_repeat2,
    STATE(4707), 1,
      sym_comment,
    ACTIONS(8219), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [181213] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8268), 1,
      anon_sym_DQUOTE,
    STATE(4706), 1,
      aux_sym_string_repeat1,
    STATE(4708), 1,
      sym_comment,
    ACTIONS(8217), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [181233] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8270), 1,
      anon_sym_SQUOTE,
    ACTIONS(8272), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
    STATE(4709), 2,
      sym_comment,
      aux_sym_string_repeat2,
  [181251] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8275), 1,
      anon_sym_COMMA,
    STATE(4710), 1,
      sym_comment,
    STATE(4720), 1,
      aux_sym_ui_pragma_repeat1,
    ACTIONS(8277), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [181271] = 7,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8279), 1,
      sym__glimmer_template_content,
    ACTIONS(8281), 1,
      anon_sym_LT_SLASHtemplate_GT,
    STATE(2023), 1,
      sym_glimmer_closing_tag,
    STATE(4711), 1,
      sym_comment,
    STATE(5171), 1,
      aux_sym_glimmer_template_repeat1,
  [181293] = 7,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8279), 1,
      sym__glimmer_template_content,
    ACTIONS(8283), 1,
      anon_sym_LT_SLASHtemplate_GT,
    STATE(2606), 1,
      sym_glimmer_closing_tag,
    STATE(4712), 1,
      sym_comment,
    STATE(4730), 1,
      aux_sym_glimmer_template_repeat1,
  [181315] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(8285), 1,
      anon_sym_class,
    STATE(1202), 1,
      sym_decorator,
    STATE(4059), 1,
      aux_sym_export_statement_repeat1,
    STATE(4713), 1,
      sym_comment,
  [181337] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1743), 1,
      anon_sym_COMMA,
    ACTIONS(8287), 1,
      anon_sym_EQ,
    ACTIONS(8289), 1,
      anon_sym_RBRACK,
    STATE(4714), 1,
      sym_comment,
    STATE(5289), 1,
      aux_sym_array_pattern_repeat1,
  [181359] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(8291), 1,
      anon_sym_COLON,
    STATE(4715), 1,
      sym_comment,
  [181381] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8243), 1,
      anon_sym_COMMA,
    STATE(4716), 1,
      sym_comment,
    STATE(4739), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(8293), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [181401] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8295), 1,
      anon_sym_with,
    ACTIONS(8297), 1,
      anon_sym_SEMI,
    ACTIONS(8299), 1,
      sym__automatic_semicolon,
    STATE(4717), 1,
      sym_comment,
    STATE(5510), 1,
      sym_import_attribute,
  [181423] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(8301), 1,
      anon_sym_RBRACK,
    STATE(4718), 1,
      sym_comment,
  [181445] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(8303), 1,
      anon_sym_COLON,
    STATE(4719), 1,
      sym_comment,
  [181467] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8275), 1,
      anon_sym_COMMA,
    ACTIONS(8305), 1,
      anon_sym_SEMI,
    ACTIONS(8307), 1,
      sym__automatic_semicolon,
    STATE(4720), 1,
      sym_comment,
    STATE(4743), 1,
      aux_sym_ui_pragma_repeat1,
  [181489] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    ACTIONS(8309), 1,
      sym_identifier,
    STATE(4721), 1,
      sym_comment,
    STATE(5262), 1,
      sym_string,
  [181511] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(8311), 1,
      anon_sym_RBRACK,
    STATE(4722), 1,
      sym_comment,
  [181533] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4723), 1,
      sym_comment,
    STATE(5588), 1,
      sym_type_parameters,
    STATE(6201), 1,
      sym_formal_parameters,
  [181555] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7529), 1,
      anon_sym_DOT,
    ACTIONS(8313), 1,
      anon_sym_COMMA,
    ACTIONS(8315), 1,
      anon_sym_GT,
    STATE(4724), 1,
      sym_comment,
    STATE(5183), 1,
      aux_sym_type_arguments_repeat1,
  [181577] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4725), 1,
      sym_comment,
    ACTIONS(8317), 4,
      sym__template_chars,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [181593] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(225), 1,
      anon_sym_BQUOTE,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    STATE(4726), 1,
      sym_comment,
    STATE(2514), 2,
      sym_template_string,
      sym_arguments,
  [181613] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5265), 1,
      anon_sym_COMMA,
    STATE(4727), 1,
      sym_comment,
    STATE(4784), 1,
      aux_sym_sequence_expression_repeat1,
    ACTIONS(7634), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [181633] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4728), 1,
      sym_comment,
    STATE(5808), 1,
      sym_type_parameters,
    STATE(6011), 1,
      sym_formal_parameters,
  [181655] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(8319), 1,
      anon_sym_RPAREN,
    STATE(4729), 1,
      sym_comment,
  [181677] = 7,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8279), 1,
      sym__glimmer_template_content,
    ACTIONS(8283), 1,
      anon_sym_LT_SLASHtemplate_GT,
    STATE(2436), 1,
      sym_glimmer_closing_tag,
    STATE(4730), 1,
      sym_comment,
    STATE(5171), 1,
      aux_sym_glimmer_template_repeat1,
  [181699] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(8321), 1,
      anon_sym_LT,
    STATE(1793), 1,
      sym_arguments,
    STATE(1794), 1,
      sym_type_arguments,
    STATE(4731), 1,
      sym_comment,
  [181721] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4322), 1,
      anon_sym_COLON,
    STATE(4732), 1,
      sym_comment,
    ACTIONS(8323), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [181741] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8325), 1,
      anon_sym_DQUOTE,
    STATE(4733), 1,
      sym_comment,
    STATE(4737), 1,
      aux_sym_string_repeat1,
    ACTIONS(8217), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [181761] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8325), 1,
      anon_sym_SQUOTE,
    STATE(4734), 1,
      sym_comment,
    STATE(4738), 1,
      aux_sym_string_repeat2,
    ACTIONS(8219), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [181781] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7529), 1,
      anon_sym_DOT,
    ACTIONS(8327), 1,
      anon_sym_COMMA,
    ACTIONS(8329), 1,
      anon_sym_GT,
    STATE(4735), 1,
      sym_comment,
    STATE(5322), 1,
      aux_sym_type_arguments_repeat1,
  [181803] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8243), 1,
      anon_sym_COMMA,
    STATE(4736), 1,
      sym_comment,
    STATE(4739), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(8331), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [181823] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8333), 1,
      anon_sym_DQUOTE,
    STATE(4704), 1,
      aux_sym_string_repeat1,
    STATE(4737), 1,
      sym_comment,
    ACTIONS(8217), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [181843] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8333), 1,
      anon_sym_SQUOTE,
    STATE(4709), 1,
      aux_sym_string_repeat2,
    STATE(4738), 1,
      sym_comment,
    ACTIONS(8219), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [181863] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8335), 1,
      anon_sym_COMMA,
    ACTIONS(8338), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(4739), 2,
      sym_comment,
      aux_sym_variable_declaration_repeat1,
  [181881] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8295), 1,
      anon_sym_with,
    ACTIONS(8340), 1,
      anon_sym_SEMI,
    ACTIONS(8342), 1,
      sym__automatic_semicolon,
    STATE(4740), 1,
      sym_comment,
    STATE(5762), 1,
      sym_import_attribute,
  [181903] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8344), 1,
      anon_sym_EQ,
    ACTIONS(8346), 1,
      anon_sym_COMMA,
    ACTIONS(8348), 1,
      anon_sym_RBRACE,
    STATE(4741), 1,
      sym_comment,
    STATE(5149), 1,
      aux_sym__qml_enum_body_repeat1,
  [181925] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8295), 1,
      anon_sym_with,
    STATE(4742), 1,
      sym_comment,
    STATE(5763), 1,
      sym_import_attribute,
    ACTIONS(8350), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [181945] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8352), 1,
      anon_sym_COMMA,
    ACTIONS(8355), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(4743), 2,
      sym_comment,
      aux_sym_ui_pragma_repeat1,
  [181963] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8295), 1,
      anon_sym_with,
    STATE(4744), 1,
      sym_comment,
    STATE(5764), 1,
      sym_import_attribute,
    ACTIONS(8357), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [181983] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8359), 1,
      anon_sym_from,
    STATE(4745), 1,
      sym_comment,
    STATE(5624), 1,
      sym__from_clause,
    ACTIONS(8361), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [182003] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4746), 1,
      sym_comment,
    STATE(5846), 1,
      sym_type_parameters,
    STATE(6113), 1,
      sym_formal_parameters,
  [182025] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8295), 1,
      anon_sym_with,
    STATE(4747), 1,
      sym_comment,
    STATE(5629), 1,
      sym_import_attribute,
    ACTIONS(8363), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [182045] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8295), 1,
      anon_sym_with,
    STATE(4748), 1,
      sym_comment,
    STATE(5630), 1,
      sym_import_attribute,
    ACTIONS(8365), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [182065] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8359), 1,
      anon_sym_from,
    STATE(4749), 1,
      sym_comment,
    STATE(5768), 1,
      sym__from_clause,
    ACTIONS(5611), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [182085] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8243), 1,
      anon_sym_COMMA,
    STATE(4750), 1,
      sym_comment,
    STATE(4814), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(8367), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [182105] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(8369), 1,
      anon_sym_RBRACK,
    STATE(4751), 1,
      sym_comment,
  [182127] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7529), 1,
      anon_sym_DOT,
    ACTIONS(8371), 1,
      anon_sym_COMMA,
    ACTIONS(8373), 1,
      anon_sym_GT,
    STATE(4752), 1,
      sym_comment,
    STATE(5127), 1,
      aux_sym_type_arguments_repeat1,
  [182149] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2148), 1,
      anon_sym_EQ_GT,
    STATE(4753), 1,
      sym_comment,
    ACTIONS(4322), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [182167] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8375), 1,
      anon_sym_EQ_GT,
    STATE(4754), 1,
      sym_comment,
    ACTIONS(4322), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [182185] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(8377), 1,
      anon_sym_RBRACK,
    STATE(4755), 1,
      sym_comment,
  [182207] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8379), 1,
      anon_sym_SQUOTE,
    STATE(4709), 1,
      aux_sym_string_repeat2,
    STATE(4756), 1,
      sym_comment,
    ACTIONS(8219), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [182227] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8379), 1,
      anon_sym_DQUOTE,
    STATE(4704), 1,
      aux_sym_string_repeat1,
    STATE(4757), 1,
      sym_comment,
    ACTIONS(8217), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [182247] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8381), 1,
      anon_sym_SQUOTE,
    STATE(4756), 1,
      aux_sym_string_repeat2,
    STATE(4758), 1,
      sym_comment,
    ACTIONS(8219), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [182267] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8381), 1,
      anon_sym_DQUOTE,
    STATE(4757), 1,
      aux_sym_string_repeat1,
    STATE(4759), 1,
      sym_comment,
    ACTIONS(8217), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [182287] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4760), 1,
      sym_comment,
    STATE(5852), 1,
      sym_type_parameters,
    STATE(6107), 1,
      sym_formal_parameters,
  [182309] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7498), 1,
      anon_sym_EQ,
    STATE(4761), 1,
      sym_comment,
    STATE(5646), 1,
      sym__initializer,
    ACTIONS(8383), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [182329] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(5674), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(4762), 2,
      sym_comment,
      aux_sym_array_repeat1,
  [182347] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4763), 1,
      sym_comment,
    ACTIONS(5538), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [182363] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8390), 1,
      anon_sym_COMMA,
    STATE(4764), 1,
      sym_comment,
    STATE(4820), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(8388), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [182383] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(8392), 1,
      anon_sym_RBRACK,
    STATE(4765), 1,
      sym_comment,
  [182405] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(8394), 1,
      anon_sym_export,
    STATE(1202), 1,
      sym_decorator,
    STATE(4059), 1,
      aux_sym_export_statement_repeat1,
    STATE(4766), 1,
      sym_comment,
  [182427] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3814), 1,
      anon_sym_LPAREN,
    ACTIONS(6624), 1,
      anon_sym_LT,
    STATE(3174), 1,
      sym_arguments,
    STATE(3263), 1,
      sym_type_arguments,
    STATE(4767), 1,
      sym_comment,
  [182449] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(8396), 1,
      anon_sym_COLON,
    STATE(4768), 1,
      sym_comment,
  [182471] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(8398), 1,
      anon_sym_RBRACK,
    STATE(4769), 1,
      sym_comment,
  [182493] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8400), 1,
      anon_sym_DQUOTE,
    STATE(4770), 1,
      sym_comment,
    STATE(4779), 1,
      aux_sym_string_repeat1,
    ACTIONS(8217), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [182513] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(8402), 1,
      anon_sym_RPAREN,
    STATE(4771), 1,
      sym_comment,
  [182535] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8400), 1,
      anon_sym_SQUOTE,
    STATE(4772), 1,
      sym_comment,
    STATE(4781), 1,
      aux_sym_string_repeat2,
    ACTIONS(8219), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [182555] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6932), 1,
      anon_sym_EQ,
    STATE(4773), 1,
      sym_comment,
    STATE(5688), 1,
      sym_default_type,
    ACTIONS(8404), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [182575] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4774), 1,
      sym_comment,
    STATE(5689), 1,
      sym_type_parameters,
    STATE(6096), 1,
      sym_formal_parameters,
  [182597] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7438), 1,
      anon_sym_COMMA,
    ACTIONS(8406), 1,
      anon_sym_LBRACE,
    ACTIONS(8408), 1,
      anon_sym_LBRACE_PIPE,
    STATE(4775), 1,
      sym_comment,
    STATE(4789), 1,
      aux_sym_extends_type_clause_repeat1,
  [182619] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7438), 1,
      anon_sym_COMMA,
    ACTIONS(8406), 1,
      anon_sym_LBRACE,
    ACTIONS(8408), 1,
      anon_sym_LBRACE_PIPE,
    STATE(4776), 1,
      sym_comment,
    STATE(4789), 1,
      aux_sym_extends_type_clause_repeat1,
  [182641] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(8410), 1,
      anon_sym_RBRACK,
    STATE(4777), 1,
      sym_comment,
  [182663] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7438), 1,
      anon_sym_COMMA,
    ACTIONS(8412), 1,
      anon_sym_LBRACE,
    ACTIONS(8414), 1,
      anon_sym_LBRACE_PIPE,
    STATE(4778), 1,
      sym_comment,
    STATE(4789), 1,
      aux_sym_extends_type_clause_repeat1,
  [182685] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8416), 1,
      anon_sym_DQUOTE,
    STATE(4704), 1,
      aux_sym_string_repeat1,
    STATE(4779), 1,
      sym_comment,
    ACTIONS(8217), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [182705] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(8418), 1,
      anon_sym_QMARK,
    STATE(4780), 1,
      sym_comment,
  [182727] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8416), 1,
      anon_sym_SQUOTE,
    STATE(4709), 1,
      aux_sym_string_repeat2,
    STATE(4781), 1,
      sym_comment,
    ACTIONS(8219), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [182747] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8249), 1,
      sym_identifier,
    ACTIONS(8251), 1,
      anon_sym_const,
    ACTIONS(8420), 1,
      anon_sym_GT,
    STATE(4782), 1,
      sym_comment,
    STATE(5744), 1,
      sym_type_parameter,
  [182769] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8243), 1,
      anon_sym_COMMA,
    STATE(4783), 1,
      sym_comment,
    STATE(4803), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(8422), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [182789] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8424), 1,
      anon_sym_COMMA,
    ACTIONS(4948), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(4784), 2,
      sym_comment,
      aux_sym_sequence_expression_repeat1,
  [182807] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4785), 1,
      sym_comment,
    STATE(5598), 1,
      sym_type_parameters,
    STATE(5996), 1,
      sym_formal_parameters,
  [182829] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8427), 1,
      sym_identifier,
    STATE(4586), 1,
      sym_nested_type_identifier,
    STATE(4786), 1,
      sym_comment,
    STATE(5172), 1,
      sym_generic_type,
    STATE(6099), 1,
      sym_nested_identifier,
  [182851] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(114), 1,
      anon_sym_AT,
    ACTIONS(8429), 1,
      anon_sym_class,
    STATE(1202), 1,
      sym_decorator,
    STATE(4059), 1,
      aux_sym_export_statement_repeat1,
    STATE(4787), 1,
      sym_comment,
  [182873] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7976), 1,
      sym_identifier,
    STATE(4788), 1,
      sym_comment,
    STATE(5695), 1,
      sym_ui_signal_parameter,
    STATE(6243), 1,
      sym_nested_type_identifier,
    STATE(6331), 1,
      sym_nested_identifier,
  [182895] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8431), 1,
      anon_sym_LBRACE,
    ACTIONS(8433), 1,
      anon_sym_COMMA,
    ACTIONS(8436), 1,
      anon_sym_LBRACE_PIPE,
    STATE(4789), 2,
      sym_comment,
      aux_sym_extends_type_clause_repeat1,
  [182915] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4790), 1,
      sym_comment,
    STATE(5606), 1,
      sym_type_parameters,
    STATE(6013), 1,
      sym_formal_parameters,
  [182937] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7498), 1,
      anon_sym_EQ,
    STATE(4791), 1,
      sym_comment,
    STATE(5842), 1,
      sym__initializer,
    ACTIONS(8438), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [182957] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(8440), 1,
      anon_sym_COLON,
    STATE(4792), 1,
      sym_comment,
  [182979] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(8442), 1,
      anon_sym_COLON,
    STATE(4793), 1,
      sym_comment,
  [183001] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3814), 1,
      anon_sym_LPAREN,
    ACTIONS(6970), 1,
      anon_sym_LT,
    STATE(3174), 1,
      sym_arguments,
    STATE(3263), 1,
      sym_type_arguments,
    STATE(4794), 1,
      sym_comment,
  [183023] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8249), 1,
      sym_identifier,
    ACTIONS(8251), 1,
      anon_sym_const,
    ACTIONS(8444), 1,
      anon_sym_GT,
    STATE(4795), 1,
      sym_comment,
    STATE(5744), 1,
      sym_type_parameter,
  [183045] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8359), 1,
      anon_sym_from,
    STATE(4796), 1,
      sym_comment,
    STATE(5718), 1,
      sym__from_clause,
    ACTIONS(5305), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [183065] = 7,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8279), 1,
      sym__glimmer_template_content,
    ACTIONS(8281), 1,
      anon_sym_LT_SLASHtemplate_GT,
    STATE(2032), 1,
      sym_glimmer_closing_tag,
    STATE(4711), 1,
      aux_sym_glimmer_template_repeat1,
    STATE(4797), 1,
      sym_comment,
  [183087] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(8446), 1,
      anon_sym_COLON,
    STATE(4798), 1,
      sym_comment,
  [183109] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4799), 1,
      sym_comment,
    ACTIONS(8448), 4,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_from,
  [183125] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8295), 1,
      anon_sym_with,
    STATE(4800), 1,
      sym_comment,
    STATE(5729), 1,
      sym_import_attribute,
    ACTIONS(8450), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [183145] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8295), 1,
      anon_sym_with,
    STATE(4801), 1,
      sym_comment,
    STATE(5737), 1,
      sym_import_attribute,
    ACTIONS(8452), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [183165] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1743), 1,
      anon_sym_COMMA,
    ACTIONS(8287), 1,
      anon_sym_EQ,
    ACTIONS(8454), 1,
      anon_sym_RBRACK,
    STATE(4802), 1,
      sym_comment,
    STATE(4933), 1,
      aux_sym_array_pattern_repeat1,
  [183187] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8243), 1,
      anon_sym_COMMA,
    STATE(4739), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4803), 1,
      sym_comment,
    ACTIONS(8456), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [183207] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8458), 1,
      anon_sym_DQUOTE,
    STATE(4804), 1,
      sym_comment,
    STATE(4807), 1,
      aux_sym_string_repeat1,
    ACTIONS(8217), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [183227] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8458), 1,
      anon_sym_SQUOTE,
    STATE(4805), 1,
      sym_comment,
    STATE(4808), 1,
      aux_sym_string_repeat2,
    ACTIONS(8219), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [183247] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8460), 1,
      anon_sym_SQUOTE,
    STATE(4709), 1,
      aux_sym_string_repeat2,
    STATE(4806), 1,
      sym_comment,
    ACTIONS(8219), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [183267] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8462), 1,
      anon_sym_DQUOTE,
    STATE(4704), 1,
      aux_sym_string_repeat1,
    STATE(4807), 1,
      sym_comment,
    ACTIONS(8217), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [183287] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8462), 1,
      anon_sym_SQUOTE,
    STATE(4709), 1,
      aux_sym_string_repeat2,
    STATE(4808), 1,
      sym_comment,
    ACTIONS(8219), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [183307] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(8464), 1,
      anon_sym_RBRACK,
    STATE(4809), 1,
      sym_comment,
  [183329] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8460), 1,
      anon_sym_DQUOTE,
    STATE(4704), 1,
      aux_sym_string_repeat1,
    STATE(4810), 1,
      sym_comment,
    ACTIONS(8217), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [183349] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8466), 1,
      anon_sym_SQUOTE,
    STATE(4806), 1,
      aux_sym_string_repeat2,
    STATE(4811), 1,
      sym_comment,
    ACTIONS(8219), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [183369] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8295), 1,
      anon_sym_with,
    ACTIONS(8468), 1,
      anon_sym_SEMI,
    ACTIONS(8470), 1,
      sym__automatic_semicolon,
    STATE(4812), 1,
      sym_comment,
    STATE(5739), 1,
      sym_import_attribute,
  [183391] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6636), 1,
      anon_sym_STAR,
    ACTIONS(6640), 1,
      anon_sym_LBRACE,
    STATE(4813), 1,
      sym_comment,
    STATE(6054), 2,
      sym_namespace_import,
      sym_named_imports,
  [183411] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8243), 1,
      anon_sym_COMMA,
    STATE(4739), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4814), 1,
      sym_comment,
    ACTIONS(8472), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [183431] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8466), 1,
      anon_sym_DQUOTE,
    STATE(4810), 1,
      aux_sym_string_repeat1,
    STATE(4815), 1,
      sym_comment,
    ACTIONS(8217), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [183451] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8474), 1,
      sym_identifier,
    STATE(4118), 1,
      sym_nested_type_identifier,
    STATE(4816), 1,
      sym_comment,
    STATE(4852), 1,
      sym_generic_type,
    STATE(6099), 1,
      sym_nested_identifier,
  [183473] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8243), 1,
      anon_sym_COMMA,
    STATE(4739), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4817), 1,
      sym_comment,
    ACTIONS(8476), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [183493] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8359), 1,
      anon_sym_from,
    STATE(4818), 1,
      sym_comment,
    STATE(5659), 1,
      sym__from_clause,
    ACTIONS(5205), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [183513] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7498), 1,
      anon_sym_EQ,
    STATE(4819), 1,
      sym_comment,
    STATE(5750), 1,
      sym__initializer,
    ACTIONS(8478), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [183533] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8390), 1,
      anon_sym_COMMA,
    STATE(4820), 1,
      sym_comment,
    STATE(4844), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(8480), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [183553] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(8482), 1,
      anon_sym_RPAREN,
    STATE(4821), 1,
      sym_comment,
  [183575] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    ACTIONS(3073), 1,
      anon_sym_LT,
    STATE(3840), 1,
      sym_formal_parameters,
    STATE(4822), 1,
      sym_comment,
    STATE(5756), 1,
      sym_type_parameters,
  [183597] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(8484), 1,
      anon_sym_LT,
    STATE(2232), 1,
      sym_type_arguments,
    STATE(2235), 1,
      sym_arguments,
    STATE(4823), 1,
      sym_comment,
  [183619] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4824), 1,
      sym_comment,
    STATE(5674), 1,
      sym_type_parameters,
    STATE(6298), 1,
      sym_formal_parameters,
  [183641] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8243), 1,
      anon_sym_COMMA,
    STATE(4817), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4825), 1,
      sym_comment,
    ACTIONS(8486), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [183661] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8359), 1,
      anon_sym_from,
    STATE(4826), 1,
      sym_comment,
    STATE(5670), 1,
      sym__from_clause,
    ACTIONS(8488), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [183681] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6932), 1,
      anon_sym_EQ,
    STATE(4827), 1,
      sym_comment,
    STATE(5771), 1,
      sym_default_type,
    ACTIONS(8490), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [183701] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4828), 1,
      sym_comment,
    STATE(5844), 1,
      sym_type_parameters,
    STATE(6022), 1,
      sym_formal_parameters,
  [183723] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4829), 1,
      sym_comment,
    STATE(5676), 1,
      sym_type_parameters,
    STATE(6333), 1,
      sym_formal_parameters,
  [183745] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(8492), 1,
      anon_sym_RPAREN,
    STATE(4830), 1,
      sym_comment,
  [183767] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8317), 1,
      sym_escape_sequence,
    STATE(4831), 1,
      sym_comment,
    ACTIONS(8494), 3,
      sym__template_chars,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [183785] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7529), 1,
      anon_sym_DOT,
    ACTIONS(8497), 1,
      anon_sym_COMMA,
    ACTIONS(8499), 1,
      anon_sym_GT,
    STATE(4832), 1,
      sym_comment,
    STATE(5032), 1,
      aux_sym_type_arguments_repeat1,
  [183807] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7529), 1,
      anon_sym_DOT,
    ACTIONS(8501), 1,
      anon_sym_COMMA,
    ACTIONS(8503), 1,
      anon_sym_GT,
    STATE(4833), 1,
      sym_comment,
    STATE(5089), 1,
      aux_sym_type_arguments_repeat1,
  [183829] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8083), 1,
      anon_sym_RBRACE,
    STATE(4834), 1,
      sym_comment,
    ACTIONS(4797), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [183847] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(855), 1,
      anon_sym_BQUOTE,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    STATE(4835), 1,
      sym_comment,
    STATE(2053), 2,
      sym_template_string,
      sym_arguments,
  [183867] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8505), 1,
      anon_sym_DQUOTE,
    STATE(4836), 1,
      sym_comment,
    STATE(4839), 1,
      aux_sym_string_repeat1,
    ACTIONS(8217), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [183887] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8505), 1,
      anon_sym_SQUOTE,
    STATE(4837), 1,
      sym_comment,
    STATE(4845), 1,
      aux_sym_string_repeat2,
    ACTIONS(8219), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [183907] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3798), 1,
      anon_sym_LPAREN,
    ACTIONS(6658), 1,
      anon_sym_LT,
    STATE(3362), 1,
      sym_arguments,
    STATE(3511), 1,
      sym_type_arguments,
    STATE(4838), 1,
      sym_comment,
  [183929] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8507), 1,
      anon_sym_DQUOTE,
    STATE(4704), 1,
      aux_sym_string_repeat1,
    STATE(4839), 1,
      sym_comment,
    ACTIONS(8217), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [183949] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(8509), 1,
      anon_sym_QMARK,
    STATE(4840), 1,
      sym_comment,
  [183971] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(8511), 1,
      anon_sym_RBRACK,
    STATE(4841), 1,
      sym_comment,
  [183993] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8249), 1,
      sym_identifier,
    ACTIONS(8251), 1,
      anon_sym_const,
    ACTIONS(8513), 1,
      anon_sym_GT,
    STATE(4842), 1,
      sym_comment,
    STATE(5744), 1,
      sym_type_parameter,
  [184015] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4843), 1,
      sym_comment,
    ACTIONS(8515), 4,
      sym__template_chars,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [184031] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8519), 1,
      anon_sym_COMMA,
    ACTIONS(8517), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
    STATE(4844), 2,
      sym_comment,
      aux_sym_extends_clause_repeat1,
  [184049] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8507), 1,
      anon_sym_SQUOTE,
    STATE(4709), 1,
      aux_sym_string_repeat2,
    STATE(4845), 1,
      sym_comment,
    ACTIONS(8219), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [184069] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(8522), 1,
      anon_sym_RBRACK,
    STATE(4846), 1,
      sym_comment,
  [184091] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8243), 1,
      anon_sym_COMMA,
    STATE(4739), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4847), 1,
      sym_comment,
    ACTIONS(8524), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [184111] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8295), 1,
      anon_sym_with,
    STATE(4848), 1,
      sym_comment,
    STATE(5795), 1,
      sym_import_attribute,
    ACTIONS(8526), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [184131] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4849), 1,
      sym_comment,
    STATE(5699), 1,
      sym_type_parameters,
    STATE(6200), 1,
      sym_formal_parameters,
  [184153] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8295), 1,
      anon_sym_with,
    STATE(4850), 1,
      sym_comment,
    STATE(5796), 1,
      sym_import_attribute,
    ACTIONS(8528), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [184173] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8359), 1,
      anon_sym_from,
    STATE(4851), 1,
      sym_comment,
    STATE(5798), 1,
      sym__from_clause,
    ACTIONS(8530), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [184193] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7438), 1,
      anon_sym_COMMA,
    ACTIONS(7800), 1,
      anon_sym_LBRACE,
    ACTIONS(7802), 1,
      anon_sym_LBRACE_PIPE,
    STATE(4775), 1,
      aux_sym_extends_type_clause_repeat1,
    STATE(4852), 1,
      sym_comment,
  [184215] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4853), 1,
      sym_comment,
    STATE(5716), 1,
      sym_type_parameters,
    STATE(6195), 1,
      sym_formal_parameters,
  [184237] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8532), 1,
      anon_sym_DQUOTE,
    STATE(4854), 1,
      sym_comment,
    STATE(4857), 1,
      aux_sym_string_repeat1,
    ACTIONS(8217), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [184257] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(8534), 1,
      anon_sym_RBRACK,
    STATE(4855), 1,
      sym_comment,
  [184279] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8532), 1,
      anon_sym_SQUOTE,
    STATE(4856), 1,
      sym_comment,
    STATE(4858), 1,
      aux_sym_string_repeat2,
    ACTIONS(8219), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [184299] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8536), 1,
      anon_sym_DQUOTE,
    STATE(4704), 1,
      aux_sym_string_repeat1,
    STATE(4857), 1,
      sym_comment,
    ACTIONS(8217), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [184319] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8536), 1,
      anon_sym_SQUOTE,
    STATE(4709), 1,
      aux_sym_string_repeat2,
    STATE(4858), 1,
      sym_comment,
    ACTIONS(8219), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [184339] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8243), 1,
      anon_sym_COMMA,
    STATE(4847), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4859), 1,
      sym_comment,
    ACTIONS(8538), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [184359] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8295), 1,
      anon_sym_with,
    ACTIONS(8540), 1,
      anon_sym_SEMI,
    ACTIONS(8542), 1,
      sym__automatic_semicolon,
    STATE(4860), 1,
      sym_comment,
    STATE(5807), 1,
      sym_import_attribute,
  [184381] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8243), 1,
      anon_sym_COMMA,
    STATE(4736), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(4861), 1,
      sym_comment,
    ACTIONS(8544), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [184401] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7387), 1,
      anon_sym_DOT,
    STATE(4862), 1,
      sym_comment,
    ACTIONS(8546), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [184418] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8548), 1,
      anon_sym_COMMA,
    ACTIONS(8550), 1,
      anon_sym_GT,
    STATE(4863), 1,
      sym_comment,
    STATE(4954), 1,
      aux_sym_type_arguments_repeat1,
  [184437] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4864), 1,
      sym_comment,
    ACTIONS(8552), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [184452] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4865), 1,
      sym_comment,
    ACTIONS(8554), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [184467] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8556), 1,
      anon_sym_COMMA,
    ACTIONS(8558), 1,
      anon_sym_RBRACK,
    STATE(4866), 1,
      sym_comment,
    STATE(5036), 1,
      aux_sym_ui_object_array_repeat1,
  [184486] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4867), 1,
      sym_comment,
    ACTIONS(8560), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [184501] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2044), 1,
      anon_sym_COMMA,
    ACTIONS(8562), 1,
      anon_sym_RBRACK,
    STATE(4762), 1,
      aux_sym_array_repeat1,
    STATE(4868), 1,
      sym_comment,
  [184520] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6985), 1,
      anon_sym_AMP,
    ACTIONS(6989), 1,
      anon_sym_extends,
    ACTIONS(8025), 1,
      anon_sym_PIPE,
    STATE(4869), 1,
      sym_comment,
  [184539] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4870), 1,
      sym_comment,
    ACTIONS(8564), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [184554] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4871), 1,
      sym_comment,
    ACTIONS(8566), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [184569] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4872), 1,
      sym_comment,
    ACTIONS(8568), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [184584] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4873), 1,
      sym_comment,
    ACTIONS(8570), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [184599] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4874), 1,
      sym_comment,
    ACTIONS(8572), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [184614] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4875), 1,
      sym_comment,
    ACTIONS(8568), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [184629] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4876), 1,
      sym_comment,
    ACTIONS(8574), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [184644] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2585), 1,
      anon_sym_LBRACE,
    ACTIONS(8576), 1,
      anon_sym_LPAREN,
    STATE(768), 1,
      sym_statement_block,
    STATE(4877), 1,
      sym_comment,
  [184663] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4878), 1,
      sym_comment,
    ACTIONS(8568), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [184678] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4879), 1,
      sym_comment,
    ACTIONS(8564), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [184693] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4880), 1,
      sym_comment,
    ACTIONS(8578), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [184708] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4881), 1,
      sym_comment,
    ACTIONS(8580), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [184723] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4882), 1,
      sym_comment,
    ACTIONS(8574), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [184738] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4883), 1,
      sym_comment,
    ACTIONS(8564), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [184753] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2603), 1,
      anon_sym_while,
    ACTIONS(8582), 1,
      anon_sym_else,
    STATE(2909), 1,
      sym_else_clause,
    STATE(4884), 1,
      sym_comment,
  [184772] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3855), 1,
      anon_sym_COLON,
    ACTIONS(8584), 1,
      anon_sym_RPAREN,
    STATE(4885), 1,
      sym_comment,
    STATE(5988), 1,
      sym_type_annotation,
  [184791] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4886), 1,
      sym_comment,
    ACTIONS(8586), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [184806] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4564), 1,
      anon_sym_COMMA,
    ACTIONS(8588), 1,
      anon_sym_RBRACE,
    STATE(4887), 1,
      sym_comment,
    STATE(5224), 1,
      aux_sym_object_repeat1,
  [184825] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4888), 1,
      sym_comment,
    ACTIONS(8590), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [184840] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4889), 1,
      sym_comment,
    ACTIONS(8552), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [184855] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8592), 1,
      sym_identifier,
    ACTIONS(8594), 1,
      anon_sym_require,
    STATE(4890), 1,
      sym_comment,
    STATE(5377), 1,
      sym_nested_identifier,
  [184874] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4891), 1,
      sym_comment,
    ACTIONS(7545), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [184889] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4892), 1,
      sym_comment,
    ACTIONS(8596), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [184904] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4893), 1,
      sym_comment,
    ACTIONS(8552), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [184919] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4894), 1,
      sym_comment,
    ACTIONS(8552), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [184934] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8598), 1,
      anon_sym_COMMA,
    ACTIONS(8600), 1,
      anon_sym_RBRACE,
    STATE(4895), 1,
      sym_comment,
    STATE(5196), 1,
      aux_sym_enum_body_repeat1,
  [184953] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4896), 1,
      sym_comment,
    ACTIONS(8590), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [184968] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(132), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1755), 1,
      anon_sym_LBRACE,
    STATE(806), 1,
      sym_object_type,
    STATE(4897), 1,
      sym_comment,
  [184987] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4898), 1,
      sym_comment,
    ACTIONS(8602), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [185002] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4899), 1,
      sym_comment,
    ACTIONS(8552), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [185017] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4900), 1,
      sym_comment,
    ACTIONS(8552), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [185032] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4901), 1,
      sym_comment,
    ACTIONS(8574), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [185047] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4902), 1,
      sym_comment,
    ACTIONS(8604), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [185062] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4903), 1,
      sym_comment,
    ACTIONS(8606), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [185077] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4904), 1,
      sym_comment,
    ACTIONS(8606), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [185092] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4905), 1,
      sym_comment,
    ACTIONS(8572), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [185107] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4906), 1,
      sym_comment,
    ACTIONS(8554), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [185122] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4907), 1,
      sym_comment,
    ACTIONS(8554), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [185137] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7369), 1,
      anon_sym_DOT,
    STATE(4908), 1,
      sym_comment,
    ACTIONS(8608), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [185154] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7387), 1,
      anon_sym_DOT,
    STATE(4909), 1,
      sym_comment,
    ACTIONS(8608), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [185171] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7047), 1,
      anon_sym_RBRACE,
    ACTIONS(8610), 1,
      anon_sym_COMMA,
    STATE(4910), 1,
      sym_comment,
    STATE(5139), 1,
      aux_sym_named_imports_repeat1,
  [185190] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4911), 1,
      sym_comment,
    ACTIONS(8612), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [185205] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6802), 1,
      anon_sym_type,
    ACTIONS(8614), 1,
      sym_identifier,
    STATE(4912), 1,
      sym_comment,
    STATE(5814), 1,
      sym__import_identifier,
  [185224] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6802), 1,
      anon_sym_type,
    ACTIONS(8614), 1,
      sym_identifier,
    STATE(4913), 1,
      sym_comment,
    STATE(5813), 1,
      sym__import_identifier,
  [185243] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8616), 1,
      anon_sym_as,
    STATE(4914), 1,
      sym_comment,
    ACTIONS(6804), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [185260] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4564), 1,
      anon_sym_COMMA,
    ACTIONS(8618), 1,
      anon_sym_RBRACE,
    STATE(4915), 1,
      sym_comment,
    STATE(5224), 1,
      aux_sym_object_repeat1,
  [185279] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4916), 1,
      sym_comment,
    ACTIONS(8552), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [185294] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4917), 1,
      sym_comment,
    ACTIONS(8604), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [185309] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4918), 1,
      sym_comment,
    ACTIONS(8552), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [185324] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4919), 1,
      sym_comment,
    ACTIONS(8552), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [185339] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4920), 1,
      sym_comment,
    ACTIONS(8620), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [185354] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7259), 1,
      anon_sym_RBRACE,
    ACTIONS(8622), 1,
      anon_sym_COMMA,
    STATE(4921), 1,
      sym_comment,
    STATE(5049), 1,
      aux_sym_export_clause_repeat1,
  [185373] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4922), 1,
      sym_comment,
    ACTIONS(8552), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [185388] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4923), 1,
      sym_comment,
    ACTIONS(8624), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [185403] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8626), 1,
      sym_identifier,
    STATE(2561), 1,
      sym_decorator_member_expression,
    STATE(2844), 1,
      sym_decorator_call_expression,
    STATE(4924), 1,
      sym_comment,
  [185422] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8628), 1,
      anon_sym_as,
    STATE(4925), 1,
      sym_comment,
    ACTIONS(8630), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [185439] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4926), 1,
      sym_comment,
    ACTIONS(8632), 3,
      sym__automatic_semicolon,
      anon_sym_with,
      anon_sym_SEMI,
  [185454] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4927), 1,
      sym_comment,
    ACTIONS(8634), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [185469] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4928), 1,
      sym_comment,
    ACTIONS(8554), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [185484] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4929), 1,
      sym_comment,
    ACTIONS(8578), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [185499] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8636), 1,
      anon_sym_COMMA,
    ACTIONS(8639), 1,
      anon_sym_RBRACE,
    STATE(4930), 2,
      sym_comment,
      aux_sym__qml_enum_body_repeat1,
  [185516] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4931), 1,
      sym_comment,
    ACTIONS(8578), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [185531] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8344), 1,
      anon_sym_EQ,
    STATE(4932), 1,
      sym_comment,
    ACTIONS(8641), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [185548] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1743), 1,
      anon_sym_COMMA,
    ACTIONS(8643), 1,
      anon_sym_RBRACK,
    STATE(4933), 1,
      sym_comment,
    STATE(5287), 1,
      aux_sym_array_pattern_repeat1,
  [185567] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4934), 1,
      sym_comment,
    ACTIONS(8606), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [185582] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4935), 1,
      sym_comment,
    ACTIONS(8606), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [185597] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8645), 1,
      anon_sym_COMMA,
    ACTIONS(8648), 1,
      anon_sym_RPAREN,
    STATE(4936), 2,
      sym_comment,
      aux_sym_ui_signal_parameters_repeat1,
  [185614] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4937), 1,
      sym_comment,
    ACTIONS(8578), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [185629] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8650), 1,
      anon_sym_LPAREN,
    ACTIONS(8652), 1,
      anon_sym_await,
    STATE(50), 1,
      sym__for_header,
    STATE(4938), 1,
      sym_comment,
  [185648] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8654), 1,
      anon_sym_COMMA,
    ACTIONS(8656), 1,
      anon_sym_RBRACK,
    STATE(4939), 1,
      sym_comment,
    STATE(5457), 1,
      aux_sym_tuple_type_repeat1,
  [185667] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6606), 1,
      anon_sym_DOT,
    STATE(4940), 1,
      sym_comment,
    ACTIONS(8658), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [185684] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4416), 1,
      anon_sym_COMMA,
    ACTIONS(8660), 1,
      anon_sym_RBRACE,
    STATE(4941), 1,
      sym_comment,
    STATE(5293), 1,
      aux_sym_object_pattern_repeat1,
  [185703] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2044), 1,
      anon_sym_COMMA,
    ACTIONS(8662), 1,
      anon_sym_RPAREN,
    STATE(4762), 1,
      aux_sym_array_repeat1,
    STATE(4942), 1,
      sym_comment,
  [185722] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4943), 1,
      sym_comment,
    ACTIONS(8634), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [185737] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4944), 1,
      sym_comment,
    ACTIONS(8586), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [185752] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8664), 1,
      anon_sym_COMMA,
    ACTIONS(8667), 1,
      anon_sym_GT,
    STATE(4945), 2,
      sym_comment,
      aux_sym_type_parameters_repeat1,
  [185769] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4946), 1,
      sym_comment,
    ACTIONS(8604), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [185784] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8669), 1,
      sym_identifier,
    ACTIONS(8671), 1,
      anon_sym_LBRACK,
    ACTIONS(8673), 1,
      sym_private_property_identifier,
    STATE(4947), 1,
      sym_comment,
  [185803] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8129), 1,
      anon_sym_LBRACE,
    ACTIONS(8675), 1,
      anon_sym_COMMA,
    STATE(4948), 2,
      sym_comment,
      aux_sym_implements_clause_repeat1,
  [185820] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4949), 1,
      sym_comment,
    ACTIONS(8564), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [185835] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4564), 1,
      anon_sym_COMMA,
    ACTIONS(8678), 1,
      anon_sym_RBRACE,
    STATE(4950), 1,
      sym_comment,
    STATE(5006), 1,
      aux_sym_object_repeat1,
  [185854] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4951), 1,
      sym_comment,
    ACTIONS(8554), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [185869] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4564), 1,
      anon_sym_COMMA,
    ACTIONS(8678), 1,
      anon_sym_RBRACE,
    STATE(4952), 1,
      sym_comment,
    STATE(5224), 1,
      aux_sym_object_repeat1,
  [185888] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4953), 1,
      sym_comment,
    ACTIONS(8634), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [185903] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8097), 1,
      anon_sym_GT,
    ACTIONS(8680), 1,
      anon_sym_COMMA,
    STATE(4954), 2,
      sym_comment,
      aux_sym_type_arguments_repeat1,
  [185920] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8683), 1,
      anon_sym_COMMA,
    ACTIONS(8685), 1,
      anon_sym_RPAREN,
    STATE(4955), 1,
      sym_comment,
    STATE(5010), 1,
      aux_sym_formal_parameters_repeat1,
  [185939] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4956), 1,
      sym_comment,
    ACTIONS(8687), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [185954] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4416), 1,
      anon_sym_COMMA,
    ACTIONS(8689), 1,
      anon_sym_RBRACE,
    STATE(4957), 1,
      sym_comment,
    STATE(5293), 1,
      aux_sym_object_pattern_repeat1,
  [185973] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4958), 1,
      sym_comment,
    ACTIONS(8612), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [185988] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4959), 1,
      sym_comment,
    ACTIONS(8604), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [186003] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4960), 1,
      sym_comment,
    ACTIONS(8691), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [186018] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4961), 1,
      sym_comment,
    ACTIONS(8554), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [186033] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7529), 1,
      anon_sym_DOT,
    STATE(4962), 1,
      sym_comment,
    ACTIONS(8693), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [186050] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8695), 1,
      sym_identifier,
    ACTIONS(8697), 1,
      anon_sym_LBRACK,
    ACTIONS(8699), 1,
      sym_private_property_identifier,
    STATE(4963), 1,
      sym_comment,
  [186069] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4964), 1,
      sym_comment,
    ACTIONS(8552), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [186084] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4965), 1,
      sym_comment,
    ACTIONS(8578), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [186099] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4966), 1,
      sym_comment,
    ACTIONS(8564), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [186114] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4967), 1,
      sym_comment,
    ACTIONS(8552), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [186129] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4968), 1,
      sym_comment,
    ACTIONS(8634), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [186144] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4969), 1,
      sym_comment,
    ACTIONS(8701), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [186159] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4970), 1,
      sym_comment,
    ACTIONS(8602), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [186174] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4971), 1,
      sym_comment,
    ACTIONS(8578), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [186189] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8703), 1,
      anon_sym_COMMA,
    ACTIONS(8705), 1,
      anon_sym_GT,
    STATE(4972), 1,
      sym_comment,
    STATE(5284), 1,
      aux_sym_type_parameters_repeat1,
  [186208] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3297), 1,
      anon_sym_RBRACK,
    ACTIONS(8707), 1,
      anon_sym_COMMA,
    STATE(4973), 1,
      sym_comment,
    STATE(4997), 1,
      aux_sym_tuple_type_repeat1,
  [186227] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2044), 1,
      anon_sym_COMMA,
    ACTIONS(8709), 1,
      anon_sym_RPAREN,
    STATE(4762), 1,
      aux_sym_array_repeat1,
    STATE(4974), 1,
      sym_comment,
  [186246] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4975), 1,
      sym_comment,
    ACTIONS(8602), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [186261] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4976), 1,
      sym_comment,
    ACTIONS(8574), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [186276] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4977), 1,
      sym_comment,
    ACTIONS(8574), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [186291] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6686), 1,
      anon_sym_LPAREN,
    ACTIONS(8711), 1,
      anon_sym_DOT,
    STATE(4081), 1,
      sym_arguments,
    STATE(4978), 1,
      sym_comment,
  [186310] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3798), 1,
      anon_sym_LPAREN,
    ACTIONS(8713), 1,
      anon_sym_DOT,
    STATE(3776), 1,
      sym_arguments,
    STATE(4979), 1,
      sym_comment,
  [186329] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4980), 1,
      sym_comment,
    ACTIONS(8574), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [186344] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4981), 1,
      sym_comment,
    ACTIONS(8612), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [186359] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4982), 1,
      sym_comment,
    ACTIONS(8634), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [186374] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4983), 1,
      sym_comment,
    ACTIONS(8634), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [186389] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4984), 1,
      sym_comment,
    ACTIONS(8604), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [186404] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4985), 1,
      sym_comment,
    ACTIONS(8606), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [186419] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4986), 1,
      sym_comment,
    ACTIONS(8604), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [186434] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4987), 1,
      sym_comment,
    ACTIONS(8606), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [186449] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4988), 1,
      sym_comment,
    ACTIONS(8620), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [186464] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4989), 1,
      sym_comment,
    ACTIONS(8634), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [186479] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4990), 1,
      sym_comment,
    ACTIONS(8715), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [186494] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8717), 1,
      sym_identifier,
    ACTIONS(8719), 1,
      anon_sym_LBRACK,
    ACTIONS(8721), 1,
      sym_private_property_identifier,
    STATE(4991), 1,
      sym_comment,
  [186513] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2044), 1,
      anon_sym_COMMA,
    ACTIONS(5568), 1,
      anon_sym_RPAREN,
    STATE(4762), 1,
      aux_sym_array_repeat1,
    STATE(4992), 1,
      sym_comment,
  [186532] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2044), 1,
      anon_sym_COMMA,
    ACTIONS(5568), 1,
      anon_sym_RPAREN,
    STATE(4974), 1,
      aux_sym_array_repeat1,
    STATE(4993), 1,
      sym_comment,
  [186551] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4994), 1,
      sym_comment,
    ACTIONS(8634), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [186566] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4995), 1,
      sym_comment,
    ACTIONS(8574), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [186581] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4416), 1,
      anon_sym_COMMA,
    ACTIONS(8723), 1,
      anon_sym_RBRACE,
    STATE(4996), 1,
      sym_comment,
    STATE(5293), 1,
      aux_sym_object_pattern_repeat1,
  [186600] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8725), 1,
      anon_sym_COMMA,
    ACTIONS(8728), 1,
      anon_sym_RBRACK,
    STATE(4997), 2,
      sym_comment,
      aux_sym_tuple_type_repeat1,
  [186617] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4564), 1,
      anon_sym_COMMA,
    ACTIONS(8730), 1,
      anon_sym_RBRACE,
    STATE(4998), 1,
      sym_comment,
    STATE(5224), 1,
      aux_sym_object_repeat1,
  [186636] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(4999), 1,
      sym_comment,
    ACTIONS(8732), 3,
      sym__template_chars,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [186651] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5000), 1,
      sym_comment,
    ACTIONS(8554), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [186666] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5001), 1,
      sym_comment,
    ACTIONS(8552), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [186681] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5002), 1,
      sym_comment,
    ACTIONS(8552), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [186696] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5003), 1,
      sym_comment,
    ACTIONS(8634), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [186711] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5004), 1,
      sym_comment,
    ACTIONS(8701), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [186726] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8734), 1,
      sym_identifier,
    ACTIONS(8736), 1,
      anon_sym_LBRACK,
    ACTIONS(8738), 1,
      sym_private_property_identifier,
    STATE(5005), 1,
      sym_comment,
  [186745] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4564), 1,
      anon_sym_COMMA,
    ACTIONS(8740), 1,
      anon_sym_RBRACE,
    STATE(5006), 1,
      sym_comment,
    STATE(5224), 1,
      aux_sym_object_repeat1,
  [186764] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8742), 1,
      sym_identifier,
    ACTIONS(8744), 1,
      anon_sym_LBRACK,
    ACTIONS(8746), 1,
      sym_private_property_identifier,
    STATE(5007), 1,
      sym_comment,
  [186783] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5008), 1,
      sym_comment,
    ACTIONS(8578), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [186798] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3855), 1,
      anon_sym_COLON,
    ACTIONS(8748), 1,
      anon_sym_RPAREN,
    STATE(5009), 1,
      sym_comment,
    STATE(5959), 1,
      sym_type_annotation,
  [186817] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1687), 1,
      anon_sym_RPAREN,
    ACTIONS(8750), 1,
      anon_sym_COMMA,
    STATE(5010), 1,
      sym_comment,
    STATE(5048), 1,
      aux_sym_formal_parameters_repeat1,
  [186836] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5011), 1,
      sym_comment,
    ACTIONS(8564), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [186851] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5012), 1,
      sym_comment,
    ACTIONS(8574), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [186866] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8249), 1,
      sym_identifier,
    ACTIONS(8251), 1,
      anon_sym_const,
    STATE(5013), 1,
      sym_comment,
    STATE(5744), 1,
      sym_type_parameter,
  [186885] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5014), 1,
      sym_comment,
    ACTIONS(8752), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
  [186900] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5015), 1,
      sym_comment,
    ACTIONS(8634), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [186915] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5016), 1,
      sym_comment,
    ACTIONS(8574), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [186930] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5017), 1,
      sym_comment,
    ACTIONS(8754), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [186945] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2044), 1,
      anon_sym_COMMA,
    ACTIONS(5570), 1,
      anon_sym_RBRACK,
    STATE(4762), 1,
      aux_sym_array_repeat1,
    STATE(5018), 1,
      sym_comment,
  [186964] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8556), 1,
      anon_sym_COMMA,
    ACTIONS(8756), 1,
      anon_sym_RBRACK,
    STATE(4866), 1,
      aux_sym_ui_object_array_repeat1,
    STATE(5019), 1,
      sym_comment,
  [186983] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5020), 1,
      sym_comment,
    ACTIONS(8758), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [186998] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7712), 1,
      anon_sym_COMMA,
    ACTIONS(8760), 1,
      anon_sym_LBRACE,
    STATE(4948), 1,
      aux_sym_implements_clause_repeat1,
    STATE(5021), 1,
      sym_comment,
  [187017] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8762), 1,
      anon_sym_COMMA,
    ACTIONS(8764), 1,
      anon_sym_RBRACK,
    STATE(5022), 1,
      sym_comment,
    STATE(5079), 1,
      aux_sym_tuple_type_repeat1,
  [187036] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7827), 1,
      anon_sym_AMP,
    ACTIONS(7829), 1,
      anon_sym_PIPE,
    ACTIONS(7831), 1,
      anon_sym_extends,
    STATE(5023), 1,
      sym_comment,
  [187055] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2044), 1,
      anon_sym_COMMA,
    ACTIONS(5570), 1,
      anon_sym_RBRACK,
    STATE(4868), 1,
      aux_sym_array_repeat1,
    STATE(5024), 1,
      sym_comment,
  [187074] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5737), 1,
      anon_sym_extends,
    ACTIONS(8766), 1,
      anon_sym_AMP,
    ACTIONS(8768), 1,
      anon_sym_PIPE,
    STATE(5025), 1,
      sym_comment,
  [187093] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5026), 1,
      sym_comment,
    ACTIONS(8578), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187108] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5027), 1,
      sym_comment,
    ACTIONS(8634), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187123] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5028), 1,
      sym_comment,
    ACTIONS(8770), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187138] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8772), 1,
      anon_sym_COMMA,
    ACTIONS(8774), 1,
      anon_sym_GT,
    STATE(4954), 1,
      aux_sym_type_arguments_repeat1,
    STATE(5029), 1,
      sym_comment,
  [187157] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5030), 1,
      sym_comment,
    ACTIONS(8574), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187172] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5031), 1,
      sym_comment,
    ACTIONS(8564), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187187] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8776), 1,
      anon_sym_COMMA,
    ACTIONS(8778), 1,
      anon_sym_GT,
    STATE(4954), 1,
      aux_sym_type_arguments_repeat1,
    STATE(5032), 1,
      sym_comment,
  [187206] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5033), 1,
      sym_comment,
    ACTIONS(8578), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187221] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3444), 1,
      anon_sym_GT,
    ACTIONS(8780), 1,
      anon_sym_COMMA,
    STATE(4954), 1,
      aux_sym_type_arguments_repeat1,
    STATE(5034), 1,
      sym_comment,
  [187240] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5035), 1,
      sym_comment,
    ACTIONS(8564), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187255] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8782), 1,
      anon_sym_COMMA,
    ACTIONS(8785), 1,
      anon_sym_RBRACK,
    STATE(5036), 2,
      sym_comment,
      aux_sym_ui_object_array_repeat1,
  [187272] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5037), 1,
      sym_comment,
    ACTIONS(8580), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187287] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8787), 1,
      anon_sym_COMMA,
    ACTIONS(8789), 1,
      anon_sym_RPAREN,
    STATE(5038), 1,
      sym_comment,
    STATE(5147), 1,
      aux_sym_formal_parameters_repeat1,
  [187306] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2044), 1,
      anon_sym_COMMA,
    ACTIONS(5670), 1,
      anon_sym_RPAREN,
    STATE(5039), 1,
      sym_comment,
    STATE(5086), 1,
      aux_sym_array_repeat1,
  [187325] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2044), 1,
      anon_sym_COMMA,
    ACTIONS(5670), 1,
      anon_sym_RPAREN,
    STATE(4762), 1,
      aux_sym_array_repeat1,
    STATE(5040), 1,
      sym_comment,
  [187344] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5041), 1,
      sym_comment,
    ACTIONS(8606), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187359] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5042), 1,
      sym_comment,
    ACTIONS(8606), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187374] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5043), 1,
      sym_comment,
    ACTIONS(8620), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187389] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5044), 1,
      sym_comment,
    ACTIONS(8791), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187404] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5045), 1,
      sym_comment,
    ACTIONS(8554), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187419] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5046), 1,
      sym_comment,
    ACTIONS(8580), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187434] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5047), 1,
      sym_comment,
    ACTIONS(8791), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187449] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8793), 1,
      anon_sym_COMMA,
    ACTIONS(8796), 1,
      anon_sym_RPAREN,
    STATE(5048), 2,
      sym_comment,
      aux_sym_formal_parameters_repeat1,
  [187466] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8798), 1,
      anon_sym_COMMA,
    ACTIONS(8801), 1,
      anon_sym_RBRACE,
    STATE(5049), 2,
      sym_comment,
      aux_sym_export_clause_repeat1,
  [187483] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4564), 1,
      anon_sym_COMMA,
    ACTIONS(8803), 1,
      anon_sym_RBRACE,
    STATE(5050), 1,
      sym_comment,
    STATE(5224), 1,
      aux_sym_object_repeat1,
  [187502] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5051), 1,
      sym_comment,
    ACTIONS(7547), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [187517] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5052), 1,
      sym_comment,
    ACTIONS(8701), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187532] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5053), 1,
      sym_comment,
    ACTIONS(8574), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187547] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5054), 1,
      sym_comment,
    ACTIONS(8554), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187562] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5055), 1,
      sym_comment,
    ACTIONS(8805), 3,
      anon_sym_default,
      anon_sym_RBRACE,
      anon_sym_case,
  [187577] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4564), 1,
      anon_sym_COMMA,
    ACTIONS(8803), 1,
      anon_sym_RBRACE,
    STATE(4887), 1,
      aux_sym_object_repeat1,
    STATE(5056), 1,
      sym_comment,
  [187596] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5057), 1,
      sym_comment,
    ACTIONS(8578), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187611] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5058), 1,
      sym_comment,
    ACTIONS(8612), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187626] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1111), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2006), 1,
      anon_sym_LBRACE,
    STATE(4677), 1,
      sym_object_type,
    STATE(5059), 1,
      sym_comment,
  [187645] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5060), 1,
      sym_comment,
    ACTIONS(8574), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187660] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5061), 1,
      sym_comment,
    ACTIONS(8554), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187675] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5062), 1,
      sym_comment,
    ACTIONS(8578), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187690] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5063), 1,
      sym_comment,
    ACTIONS(8554), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187705] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5064), 1,
      sym_comment,
    ACTIONS(8574), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187720] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5065), 1,
      sym_comment,
    ACTIONS(8574), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187735] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5066), 1,
      sym_comment,
    ACTIONS(8574), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187750] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5067), 1,
      sym_comment,
    ACTIONS(8564), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187765] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(132), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1755), 1,
      anon_sym_LBRACE,
    STATE(876), 1,
      sym_object_type,
    STATE(5068), 1,
      sym_comment,
  [187784] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8807), 1,
      anon_sym_COMMA,
    ACTIONS(8809), 1,
      anon_sym_GT,
    STATE(4954), 1,
      aux_sym_type_arguments_repeat1,
    STATE(5069), 1,
      sym_comment,
  [187803] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5070), 1,
      sym_comment,
    ACTIONS(8578), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187818] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8811), 1,
      sym_identifier,
    STATE(5071), 1,
      sym_comment,
    ACTIONS(8813), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [187835] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8815), 1,
      sym_identifier,
    STATE(5072), 1,
      sym_comment,
    ACTIONS(8817), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [187852] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8819), 1,
      anon_sym_LPAREN,
    ACTIONS(8821), 1,
      anon_sym_await,
    STATE(56), 1,
      sym__for_header,
    STATE(5073), 1,
      sym_comment,
  [187871] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5074), 1,
      sym_comment,
    ACTIONS(8574), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187886] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5075), 1,
      sym_comment,
    ACTIONS(8701), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187901] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5076), 1,
      sym_comment,
    ACTIONS(8564), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187916] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5077), 1,
      sym_comment,
    ACTIONS(8612), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187931] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8823), 1,
      anon_sym_EQ,
    STATE(5078), 1,
      sym_comment,
    ACTIONS(3968), 2,
      anon_sym_in,
      anon_sym_of,
  [187948] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3309), 1,
      anon_sym_RBRACK,
    ACTIONS(8825), 1,
      anon_sym_COMMA,
    STATE(4997), 1,
      aux_sym_tuple_type_repeat1,
    STATE(5079), 1,
      sym_comment,
  [187967] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5080), 1,
      sym_comment,
    ACTIONS(8552), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187982] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5081), 1,
      sym_comment,
    ACTIONS(8552), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187997] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5082), 1,
      sym_comment,
    ACTIONS(8554), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188012] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5083), 1,
      sym_comment,
    ACTIONS(8701), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188027] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8827), 1,
      sym_identifier,
    ACTIONS(8829), 1,
      anon_sym_LBRACK,
    ACTIONS(8831), 1,
      sym_private_property_identifier,
    STATE(5084), 1,
      sym_comment,
  [188046] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5085), 1,
      sym_comment,
    ACTIONS(8554), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188061] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2044), 1,
      anon_sym_COMMA,
    ACTIONS(8833), 1,
      anon_sym_RPAREN,
    STATE(4762), 1,
      aux_sym_array_repeat1,
    STATE(5086), 1,
      sym_comment,
  [188080] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8594), 1,
      anon_sym_require,
    ACTIONS(8835), 1,
      sym_identifier,
    STATE(4908), 1,
      sym_nested_identifier,
    STATE(5087), 1,
      sym_comment,
  [188099] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5088), 1,
      sym_comment,
    ACTIONS(8574), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188114] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8837), 1,
      anon_sym_COMMA,
    ACTIONS(8839), 1,
      anon_sym_GT,
    STATE(4954), 1,
      aux_sym_type_arguments_repeat1,
    STATE(5089), 1,
      sym_comment,
  [188133] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5090), 1,
      sym_comment,
    ACTIONS(8841), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188148] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5091), 1,
      sym_comment,
    ACTIONS(8843), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188163] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5092), 1,
      sym_comment,
    ACTIONS(8554), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188178] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5093), 1,
      sym_comment,
    ACTIONS(8578), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188193] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5094), 1,
      sym_comment,
    ACTIONS(8606), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188208] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5095), 1,
      sym_comment,
    ACTIONS(8701), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188223] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8359), 1,
      anon_sym_from,
    ACTIONS(8845), 1,
      anon_sym_as,
    STATE(5096), 1,
      sym_comment,
    STATE(5800), 1,
      sym__from_clause,
  [188242] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7369), 1,
      anon_sym_DOT,
    STATE(5097), 1,
      sym_comment,
    ACTIONS(8546), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [188259] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8847), 1,
      anon_sym_COMMA,
    ACTIONS(8849), 1,
      anon_sym_RBRACE,
    STATE(4910), 1,
      aux_sym_named_imports_repeat1,
    STATE(5098), 1,
      sym_comment,
  [188278] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8448), 1,
      anon_sym_as,
    STATE(5099), 1,
      sym_comment,
    ACTIONS(8851), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [188295] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3381), 1,
      anon_sym_GT,
    ACTIONS(8853), 1,
      anon_sym_COMMA,
    STATE(4954), 1,
      aux_sym_type_arguments_repeat1,
    STATE(5100), 1,
      sym_comment,
  [188314] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5101), 1,
      sym_comment,
    ACTIONS(8606), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188329] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5102), 1,
      sym_comment,
    ACTIONS(8554), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188344] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1743), 1,
      anon_sym_COMMA,
    ACTIONS(8454), 1,
      anon_sym_RBRACK,
    STATE(5103), 1,
      sym_comment,
    STATE(5287), 1,
      aux_sym_array_pattern_repeat1,
  [188363] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1111), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2006), 1,
      anon_sym_LBRACE,
    STATE(4458), 1,
      sym_object_type,
    STATE(5104), 1,
      sym_comment,
  [188382] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6802), 1,
      anon_sym_type,
    ACTIONS(8614), 1,
      sym_identifier,
    STATE(5105), 1,
      sym_comment,
    STATE(5869), 1,
      sym__import_identifier,
  [188401] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8855), 1,
      anon_sym_COMMA,
    ACTIONS(8857), 1,
      anon_sym_RBRACE,
    STATE(5106), 1,
      sym_comment,
    STATE(5137), 1,
      aux_sym_enum_body_repeat1,
  [188420] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5107), 1,
      sym_comment,
    ACTIONS(8612), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188435] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2044), 1,
      anon_sym_COMMA,
    ACTIONS(8859), 1,
      anon_sym_RPAREN,
    STATE(4762), 1,
      aux_sym_array_repeat1,
    STATE(5108), 1,
      sym_comment,
  [188454] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5109), 1,
      sym_comment,
    ACTIONS(8552), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188469] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1743), 1,
      anon_sym_COMMA,
    ACTIONS(8454), 1,
      anon_sym_RBRACK,
    STATE(4933), 1,
      aux_sym_array_pattern_repeat1,
    STATE(5110), 1,
      sym_comment,
  [188488] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8861), 1,
      anon_sym_COMMA,
    ACTIONS(8864), 1,
      anon_sym_RBRACE,
    STATE(5111), 2,
      sym_comment,
      aux_sym_enum_body_repeat1,
  [188505] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5112), 1,
      sym_comment,
    ACTIONS(8604), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188520] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6802), 1,
      anon_sym_type,
    ACTIONS(8614), 1,
      sym_identifier,
    STATE(5113), 1,
      sym_comment,
    STATE(5870), 1,
      sym__import_identifier,
  [188539] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8866), 1,
      anon_sym_EQ,
    STATE(5114), 1,
      sym_comment,
    ACTIONS(8851), 2,
      anon_sym_COMMA,
      anon_sym_from,
  [188556] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5115), 1,
      sym_comment,
    ACTIONS(6804), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_from,
  [188571] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5116), 1,
      sym_comment,
    ACTIONS(8552), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188586] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5117), 1,
      sym_comment,
    ACTIONS(8620), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188601] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5118), 1,
      sym_comment,
    ACTIONS(8578), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188616] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5119), 1,
      sym_comment,
    ACTIONS(8604), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188631] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2044), 1,
      anon_sym_COMMA,
    ACTIONS(5583), 1,
      anon_sym_RPAREN,
    STATE(4762), 1,
      aux_sym_array_repeat1,
    STATE(5120), 1,
      sym_comment,
  [188650] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2044), 1,
      anon_sym_COMMA,
    ACTIONS(5583), 1,
      anon_sym_RPAREN,
    STATE(5108), 1,
      aux_sym_array_repeat1,
    STATE(5121), 1,
      sym_comment,
  [188669] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8868), 1,
      anon_sym_EQ,
    STATE(5122), 1,
      sym_comment,
    ACTIONS(8851), 2,
      anon_sym_COMMA,
      anon_sym_from,
  [188686] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5123), 1,
      sym_comment,
    ACTIONS(8870), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188701] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3442), 1,
      anon_sym_GT,
    ACTIONS(8872), 1,
      anon_sym_COMMA,
    STATE(4954), 1,
      aux_sym_type_arguments_repeat1,
    STATE(5124), 1,
      sym_comment,
  [188720] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5125), 1,
      sym_comment,
    ACTIONS(8874), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188735] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4416), 1,
      anon_sym_COMMA,
    ACTIONS(8723), 1,
      anon_sym_RBRACE,
    STATE(4941), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5126), 1,
      sym_comment,
  [188754] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8876), 1,
      anon_sym_COMMA,
    ACTIONS(8878), 1,
      anon_sym_GT,
    STATE(4954), 1,
      aux_sym_type_arguments_repeat1,
    STATE(5127), 1,
      sym_comment,
  [188773] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5128), 1,
      sym_comment,
    ACTIONS(8554), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188788] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5129), 1,
      sym_comment,
    ACTIONS(8578), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188803] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5130), 1,
      sym_comment,
    ACTIONS(8606), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188818] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8880), 1,
      anon_sym_as,
    STATE(5131), 1,
      sym_comment,
    ACTIONS(8882), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [188835] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8884), 1,
      anon_sym_COMMA,
    ACTIONS(8886), 1,
      anon_sym_GT,
    STATE(4954), 1,
      aux_sym_type_arguments_repeat1,
    STATE(5132), 1,
      sym_comment,
  [188854] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8888), 1,
      anon_sym_COMMA,
    ACTIONS(8890), 1,
      anon_sym_RBRACE,
    STATE(4921), 1,
      aux_sym_export_clause_repeat1,
    STATE(5133), 1,
      sym_comment,
  [188873] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5134), 1,
      sym_comment,
    ACTIONS(8554), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188888] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8892), 1,
      anon_sym_COMMA,
    ACTIONS(8894), 1,
      anon_sym_RBRACE,
    STATE(5111), 1,
      aux_sym_enum_body_repeat1,
    STATE(5135), 1,
      sym_comment,
  [188907] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5136), 1,
      sym_comment,
    ACTIONS(8896), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [188922] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8898), 1,
      anon_sym_COMMA,
    ACTIONS(8900), 1,
      anon_sym_RBRACE,
    STATE(5111), 1,
      aux_sym_enum_body_repeat1,
    STATE(5137), 1,
      sym_comment,
  [188941] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5138), 1,
      sym_comment,
    ACTIONS(8612), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188956] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8902), 1,
      anon_sym_COMMA,
    ACTIONS(8905), 1,
      anon_sym_RBRACE,
    STATE(5139), 2,
      sym_comment,
      aux_sym_named_imports_repeat1,
  [188973] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5140), 1,
      sym_comment,
    ACTIONS(8552), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188988] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1763), 1,
      anon_sym_DQUOTE,
    ACTIONS(1765), 1,
      anon_sym_SQUOTE,
    STATE(5141), 1,
      sym_comment,
    STATE(5953), 1,
      sym_string,
  [189007] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5142), 1,
      sym_comment,
    ACTIONS(8620), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189022] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8907), 1,
      sym_identifier,
    STATE(1178), 1,
      sym_decorator_member_expression,
    STATE(1208), 1,
      sym_decorator_call_expression,
    STATE(5143), 1,
      sym_comment,
  [189041] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2014), 1,
      anon_sym_DQUOTE,
    ACTIONS(2016), 1,
      anon_sym_SQUOTE,
    STATE(4926), 1,
      sym_string,
    STATE(5144), 1,
      sym_comment,
  [189060] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5145), 1,
      sym_comment,
    ACTIONS(8552), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189075] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5146), 1,
      sym_comment,
    ACTIONS(8620), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189090] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1685), 1,
      anon_sym_RPAREN,
    ACTIONS(8909), 1,
      anon_sym_COMMA,
    STATE(5048), 1,
      aux_sym_formal_parameters_repeat1,
    STATE(5147), 1,
      sym_comment,
  [189109] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8346), 1,
      anon_sym_COMMA,
    ACTIONS(8911), 1,
      anon_sym_RBRACE,
    STATE(4930), 1,
      aux_sym__qml_enum_body_repeat1,
    STATE(5148), 1,
      sym_comment,
  [189128] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8346), 1,
      anon_sym_COMMA,
    ACTIONS(8913), 1,
      anon_sym_RBRACE,
    STATE(4930), 1,
      aux_sym__qml_enum_body_repeat1,
    STATE(5149), 1,
      sym_comment,
  [189147] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8915), 1,
      anon_sym_DASH,
    ACTIONS(8917), 1,
      sym_number,
    STATE(5150), 1,
      sym_comment,
    STATE(5700), 1,
      sym__qml_enum_negative_number,
  [189166] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8919), 1,
      anon_sym_COMMA,
    ACTIONS(8921), 1,
      anon_sym_RPAREN,
    STATE(4936), 1,
      aux_sym_ui_signal_parameters_repeat1,
    STATE(5151), 1,
      sym_comment,
  [189185] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5152), 1,
      sym_comment,
    ACTIONS(8552), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189200] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5153), 1,
      sym_comment,
    ACTIONS(8580), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189215] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5154), 1,
      sym_comment,
    ACTIONS(8606), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189230] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5155), 1,
      sym_comment,
    ACTIONS(8612), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189245] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5156), 1,
      sym_comment,
    ACTIONS(8564), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189260] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5157), 1,
      sym_comment,
    ACTIONS(8634), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189275] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8923), 1,
      sym_identifier,
    STATE(5158), 1,
      sym_comment,
    STATE(5694), 1,
      sym_nested_type_identifier,
    STATE(6331), 1,
      sym_nested_identifier,
  [189294] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(8925), 1,
      anon_sym_EQ,
    STATE(5159), 1,
      sym_comment,
    STATE(6188), 1,
      sym_type_parameters,
  [189313] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5160), 1,
      sym_comment,
    ACTIONS(8572), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189328] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5161), 1,
      sym_comment,
    ACTIONS(8552), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189343] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5162), 1,
      sym_comment,
    ACTIONS(8552), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189358] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8287), 1,
      anon_sym_EQ,
    STATE(5163), 1,
      sym_comment,
    ACTIONS(8927), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [189375] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5164), 1,
      sym_comment,
    ACTIONS(8634), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189390] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5165), 1,
      sym_comment,
    ACTIONS(8929), 3,
      sym__automatic_semicolon,
      anon_sym_with,
      anon_sym_SEMI,
  [189405] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5166), 1,
      sym_comment,
    ACTIONS(8552), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189420] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5167), 1,
      sym_comment,
    ACTIONS(8552), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189435] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5168), 1,
      sym_comment,
    ACTIONS(8552), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189450] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5169), 1,
      sym_comment,
    ACTIONS(8580), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189465] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5170), 1,
      sym_comment,
    ACTIONS(8572), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189480] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8931), 1,
      sym__glimmer_template_content,
    ACTIONS(8934), 1,
      anon_sym_LT_SLASHtemplate_GT,
    STATE(5171), 2,
      sym_comment,
      aux_sym_glimmer_template_repeat1,
  [189497] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8169), 1,
      anon_sym_LBRACE,
    STATE(5172), 1,
      sym_comment,
    ACTIONS(8171), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [189514] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2044), 1,
      anon_sym_COMMA,
    ACTIONS(5566), 1,
      anon_sym_RPAREN,
    STATE(5173), 1,
      sym_comment,
    STATE(5450), 1,
      aux_sym_array_repeat1,
  [189533] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5174), 1,
      sym_comment,
    ACTIONS(8634), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189548] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2044), 1,
      anon_sym_COMMA,
    ACTIONS(5609), 1,
      anon_sym_RPAREN,
    STATE(4762), 1,
      aux_sym_array_repeat1,
    STATE(5175), 1,
      sym_comment,
  [189567] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2044), 1,
      anon_sym_COMMA,
    ACTIONS(5609), 1,
      anon_sym_RPAREN,
    STATE(4942), 1,
      aux_sym_array_repeat1,
    STATE(5176), 1,
      sym_comment,
  [189586] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5177), 1,
      sym_comment,
    ACTIONS(8564), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189601] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8420), 1,
      anon_sym_GT,
    ACTIONS(8936), 1,
      anon_sym_COMMA,
    STATE(4945), 1,
      aux_sym_type_parameters_repeat1,
    STATE(5178), 1,
      sym_comment,
  [189620] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5179), 1,
      sym_comment,
    ACTIONS(8580), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189635] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2044), 1,
      anon_sym_COMMA,
    ACTIONS(5566), 1,
      anon_sym_RPAREN,
    STATE(4762), 1,
      aux_sym_array_repeat1,
    STATE(5180), 1,
      sym_comment,
  [189654] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5181), 1,
      sym_comment,
    ACTIONS(8554), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189669] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3409), 1,
      anon_sym_GT,
    ACTIONS(8938), 1,
      anon_sym_COMMA,
    STATE(4954), 1,
      aux_sym_type_arguments_repeat1,
    STATE(5182), 1,
      sym_comment,
  [189688] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8940), 1,
      anon_sym_COMMA,
    ACTIONS(8942), 1,
      anon_sym_GT,
    STATE(4954), 1,
      aux_sym_type_arguments_repeat1,
    STATE(5183), 1,
      sym_comment,
  [189707] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5184), 1,
      sym_comment,
    ACTIONS(8572), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189722] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5185), 1,
      sym_comment,
    ACTIONS(8944), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189737] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8249), 1,
      sym_identifier,
    ACTIONS(8251), 1,
      anon_sym_const,
    STATE(4972), 1,
      sym_type_parameter,
    STATE(5186), 1,
      sym_comment,
  [189756] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8946), 1,
      anon_sym_COMMA,
    ACTIONS(8948), 1,
      anon_sym_RBRACE,
    STATE(5111), 1,
      aux_sym_enum_body_repeat1,
    STATE(5187), 1,
      sym_comment,
  [189775] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8950), 1,
      anon_sym_COMMA,
    ACTIONS(8952), 1,
      anon_sym_RBRACE,
    STATE(5111), 1,
      aux_sym_enum_body_repeat1,
    STATE(5188), 1,
      sym_comment,
  [189794] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6758), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    STATE(5189), 1,
      sym_comment,
  [189813] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5190), 1,
      sym_comment,
    ACTIONS(8634), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189828] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8954), 1,
      anon_sym_COMMA,
    ACTIONS(8956), 1,
      anon_sym_RBRACE,
    STATE(5111), 1,
      aux_sym_enum_body_repeat1,
    STATE(5191), 1,
      sym_comment,
  [189847] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5192), 1,
      sym_comment,
    ACTIONS(8958), 3,
      sym__template_chars,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [189862] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8960), 1,
      anon_sym_COMMA,
    ACTIONS(8962), 1,
      anon_sym_RBRACK,
    STATE(4973), 1,
      aux_sym_tuple_type_repeat1,
    STATE(5193), 1,
      sym_comment,
  [189881] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5194), 1,
      sym_comment,
    ACTIONS(8574), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189896] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5195), 1,
      sym_comment,
    ACTIONS(8552), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189911] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8964), 1,
      anon_sym_COMMA,
    ACTIONS(8966), 1,
      anon_sym_RBRACE,
    STATE(5111), 1,
      aux_sym_enum_body_repeat1,
    STATE(5196), 1,
      sym_comment,
  [189930] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5197), 1,
      sym_comment,
    ACTIONS(8968), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189945] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5198), 1,
      sym_comment,
    ACTIONS(8970), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [189960] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5199), 1,
      sym_comment,
    ACTIONS(8552), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189975] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5200), 1,
      sym_comment,
    ACTIONS(8554), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189990] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5201), 1,
      sym_comment,
    ACTIONS(8612), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190005] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5202), 1,
      sym_comment,
    ACTIONS(8574), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190020] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2491), 1,
      anon_sym_LBRACE,
    ACTIONS(7940), 1,
      anon_sym_DOT,
    STATE(5203), 1,
      sym_comment,
    STATE(5892), 1,
      sym_ui_object_initializer,
  [190039] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5204), 1,
      sym_comment,
    ACTIONS(8634), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190054] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5205), 1,
      sym_comment,
    ACTIONS(8701), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190069] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5206), 1,
      sym_comment,
    ACTIONS(8634), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190084] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8972), 1,
      anon_sym_EQ,
    STATE(5207), 1,
      sym_comment,
    ACTIONS(3928), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [190101] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5208), 1,
      sym_comment,
    ACTIONS(8975), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190116] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5209), 1,
      sym_comment,
    ACTIONS(8552), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190131] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5210), 1,
      sym_comment,
    ACTIONS(5538), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190146] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5211), 1,
      sym_comment,
    ACTIONS(8552), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190161] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8556), 1,
      anon_sym_COMMA,
    ACTIONS(8977), 1,
      anon_sym_RBRACK,
    STATE(5036), 1,
      aux_sym_ui_object_array_repeat1,
    STATE(5212), 1,
      sym_comment,
  [190180] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2044), 1,
      anon_sym_COMMA,
    ACTIONS(8979), 1,
      anon_sym_RBRACK,
    STATE(4762), 1,
      aux_sym_array_repeat1,
    STATE(5213), 1,
      sym_comment,
  [190199] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5214), 1,
      sym_comment,
    ACTIONS(5674), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [190214] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    ACTIONS(8981), 1,
      anon_sym_LPAREN,
    STATE(2799), 1,
      sym_statement_block,
    STATE(5215), 1,
      sym_comment,
  [190233] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5216), 1,
      sym_comment,
    ACTIONS(8634), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190248] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5217), 1,
      sym_comment,
    ACTIONS(8975), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190263] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5218), 1,
      sym_comment,
    ACTIONS(8701), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190278] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5219), 1,
      sym_comment,
    ACTIONS(8983), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190293] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1693), 1,
      anon_sym_RPAREN,
    ACTIONS(8985), 1,
      anon_sym_COMMA,
    STATE(5048), 1,
      aux_sym_formal_parameters_repeat1,
    STATE(5220), 1,
      sym_comment,
  [190312] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5221), 1,
      sym_comment,
    ACTIONS(7531), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [190327] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5222), 1,
      sym_comment,
    ACTIONS(8987), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190342] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5223), 1,
      sym_comment,
    ACTIONS(8634), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190357] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8989), 1,
      anon_sym_COMMA,
    ACTIONS(8992), 1,
      anon_sym_RBRACE,
    STATE(5224), 2,
      sym_comment,
      aux_sym_object_repeat1,
  [190374] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5225), 1,
      sym_comment,
    ACTIONS(8975), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190389] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5226), 1,
      sym_comment,
    ACTIONS(8574), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190404] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8359), 1,
      anon_sym_from,
    ACTIONS(8845), 1,
      anon_sym_as,
    STATE(5227), 1,
      sym_comment,
    STATE(5672), 1,
      sym__from_clause,
  [190423] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5228), 1,
      sym_comment,
    ACTIONS(8580), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190438] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5229), 1,
      sym_comment,
    ACTIONS(8554), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190453] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5230), 1,
      sym_comment,
    ACTIONS(8604), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190468] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4564), 1,
      anon_sym_COMMA,
    ACTIONS(8994), 1,
      anon_sym_RBRACE,
    STATE(5224), 1,
      aux_sym_object_repeat1,
    STATE(5231), 1,
      sym_comment,
  [190487] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5232), 1,
      sym_comment,
    ACTIONS(8975), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190502] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5233), 1,
      sym_comment,
    ACTIONS(8996), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190517] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5234), 1,
      sym_comment,
    ACTIONS(8987), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190532] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5235), 1,
      sym_comment,
    ACTIONS(8998), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190547] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5236), 1,
      sym_comment,
    ACTIONS(8634), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190562] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5237), 1,
      sym_comment,
    ACTIONS(8574), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190577] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5238), 1,
      sym_comment,
    ACTIONS(8996), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190592] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5239), 1,
      sym_comment,
    ACTIONS(8612), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190607] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5240), 1,
      sym_comment,
    ACTIONS(8701), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190622] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5241), 1,
      sym_comment,
    ACTIONS(8564), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190637] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5242), 1,
      sym_comment,
    ACTIONS(8574), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190652] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5243), 1,
      sym_comment,
    ACTIONS(8554), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190667] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5244), 1,
      sym_comment,
    ACTIONS(9000), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190682] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5245), 1,
      sym_comment,
    ACTIONS(8552), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190697] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9002), 1,
      anon_sym_EQ,
    STATE(5246), 1,
      sym_comment,
    ACTIONS(8851), 2,
      anon_sym_COMMA,
      anon_sym_from,
  [190714] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5247), 1,
      sym_comment,
    ACTIONS(9004), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190729] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(9006), 1,
      anon_sym_EQ,
    STATE(5248), 1,
      sym_comment,
    STATE(6149), 1,
      sym_type_parameters,
  [190748] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5249), 1,
      sym_comment,
    ACTIONS(8634), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190763] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9010), 1,
      anon_sym_COLON,
    STATE(5250), 1,
      sym_comment,
    ACTIONS(9008), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [190780] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4564), 1,
      anon_sym_COMMA,
    ACTIONS(9012), 1,
      anon_sym_RBRACE,
    STATE(5224), 1,
      aux_sym_object_repeat1,
    STATE(5251), 1,
      sym_comment,
  [190799] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5252), 1,
      sym_comment,
    ACTIONS(9014), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190814] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5253), 1,
      sym_comment,
    ACTIONS(8564), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190829] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5254), 1,
      sym_comment,
    ACTIONS(8604), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190844] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5255), 1,
      sym_comment,
    ACTIONS(8975), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190859] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5256), 1,
      sym_comment,
    ACTIONS(8975), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190874] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5257), 1,
      sym_comment,
    ACTIONS(9016), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190889] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2362), 1,
      anon_sym_LBRACE,
    ACTIONS(9018), 1,
      sym_identifier,
    STATE(4796), 1,
      sym_export_clause,
    STATE(5258), 1,
      sym_comment,
  [190908] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8359), 1,
      anon_sym_from,
    ACTIONS(8845), 1,
      anon_sym_as,
    STATE(5259), 1,
      sym_comment,
    STATE(5619), 1,
      sym__from_clause,
  [190927] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5260), 1,
      sym_comment,
    ACTIONS(8604), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190942] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2362), 1,
      anon_sym_LBRACE,
    ACTIONS(9020), 1,
      sym_identifier,
    STATE(4818), 1,
      sym_export_clause,
    STATE(5261), 1,
      sym_comment,
  [190961] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5262), 1,
      sym_comment,
    ACTIONS(9022), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190976] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9026), 1,
      anon_sym_COLON,
    STATE(5263), 1,
      sym_comment,
    ACTIONS(9024), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [190993] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9030), 1,
      anon_sym_COLON,
    STATE(5264), 1,
      sym_comment,
    ACTIONS(9028), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [191010] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9034), 1,
      anon_sym_COLON,
    STATE(5265), 1,
      sym_comment,
    ACTIONS(9032), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [191027] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9036), 1,
      anon_sym_COMMA,
    ACTIONS(9038), 1,
      anon_sym_GT,
    STATE(5178), 1,
      aux_sym_type_parameters_repeat1,
    STATE(5266), 1,
      sym_comment,
  [191046] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8346), 1,
      anon_sym_COMMA,
    ACTIONS(9040), 1,
      anon_sym_RBRACE,
    STATE(5148), 1,
      aux_sym__qml_enum_body_repeat1,
    STATE(5267), 1,
      sym_comment,
  [191065] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5268), 1,
      sym_comment,
    ACTIONS(8574), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191080] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8919), 1,
      anon_sym_COMMA,
    ACTIONS(9042), 1,
      anon_sym_RPAREN,
    STATE(5151), 1,
      aux_sym_ui_signal_parameters_repeat1,
    STATE(5269), 1,
      sym_comment,
  [191099] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6606), 1,
      anon_sym_DOT,
    ACTIONS(9044), 1,
      sym_identifier,
    ACTIONS(9046), 1,
      anon_sym_COLON,
    STATE(5270), 1,
      sym_comment,
  [191118] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5271), 1,
      sym_comment,
    ACTIONS(8975), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191133] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5272), 1,
      sym_comment,
    ACTIONS(8634), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191148] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5273), 1,
      sym_comment,
    ACTIONS(8604), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191163] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5274), 1,
      sym_comment,
    ACTIONS(8338), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191178] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5275), 1,
      sym_comment,
    ACTIONS(9048), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191193] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5276), 1,
      sym_comment,
    ACTIONS(8975), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191208] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5277), 1,
      sym_comment,
    ACTIONS(8975), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191223] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5278), 1,
      sym_comment,
    ACTIONS(8975), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191238] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5279), 1,
      sym_comment,
    ACTIONS(8574), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191253] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5280), 1,
      sym_comment,
    ACTIONS(8975), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191268] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5281), 1,
      sym_comment,
    ACTIONS(8554), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191283] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5282), 1,
      sym_comment,
    ACTIONS(8552), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191298] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5283), 1,
      sym_comment,
    ACTIONS(8574), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191313] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8444), 1,
      anon_sym_GT,
    ACTIONS(9050), 1,
      anon_sym_COMMA,
    STATE(4945), 1,
      aux_sym_type_parameters_repeat1,
    STATE(5284), 1,
      sym_comment,
  [191332] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5285), 1,
      sym_comment,
    ACTIONS(8604), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191347] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5286), 1,
      sym_comment,
    ACTIONS(9052), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191362] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9054), 1,
      anon_sym_COMMA,
    ACTIONS(9057), 1,
      anon_sym_RBRACK,
    STATE(5287), 2,
      sym_comment,
      aux_sym_array_pattern_repeat1,
  [191379] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5288), 1,
      sym_comment,
    ACTIONS(8975), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191394] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1743), 1,
      anon_sym_COMMA,
    ACTIONS(9059), 1,
      anon_sym_RBRACK,
    STATE(5287), 1,
      aux_sym_array_pattern_repeat1,
    STATE(5289), 1,
      sym_comment,
  [191413] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5290), 1,
      sym_comment,
    ACTIONS(8975), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191428] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8287), 1,
      anon_sym_EQ,
    STATE(5291), 1,
      sym_comment,
    ACTIONS(9057), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [191445] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5292), 1,
      sym_comment,
    ACTIONS(8975), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191460] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9061), 1,
      anon_sym_COMMA,
    ACTIONS(9064), 1,
      anon_sym_RBRACE,
    STATE(5293), 2,
      sym_comment,
      aux_sym_object_pattern_repeat1,
  [191477] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4416), 1,
      anon_sym_COMMA,
    ACTIONS(9066), 1,
      anon_sym_RBRACE,
    STATE(5293), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5294), 1,
      sym_comment,
  [191496] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5295), 1,
      sym_comment,
    ACTIONS(8612), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191511] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5296), 1,
      sym_comment,
    ACTIONS(8604), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191526] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5297), 1,
      sym_comment,
    ACTIONS(8983), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191541] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5298), 1,
      sym_comment,
    ACTIONS(8975), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191556] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5299), 1,
      sym_comment,
    ACTIONS(8580), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191571] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5300), 1,
      sym_comment,
    ACTIONS(8975), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191586] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5301), 1,
      sym_comment,
    ACTIONS(8996), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191601] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5302), 1,
      sym_comment,
    ACTIONS(9068), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191616] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5303), 1,
      sym_comment,
    ACTIONS(9070), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191631] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4416), 1,
      anon_sym_COMMA,
    ACTIONS(9072), 1,
      anon_sym_RBRACE,
    STATE(5293), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5304), 1,
      sym_comment,
  [191650] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5305), 1,
      sym_comment,
    ACTIONS(8996), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191665] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5306), 1,
      sym_comment,
    ACTIONS(9014), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191680] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9074), 1,
      anon_sym_COMMA,
    ACTIONS(9076), 1,
      anon_sym_RBRACE,
    STATE(5187), 1,
      aux_sym_enum_body_repeat1,
    STATE(5307), 1,
      sym_comment,
  [191699] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5308), 1,
      sym_comment,
    ACTIONS(9014), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191714] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5309), 1,
      sym_comment,
    ACTIONS(8604), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191729] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5310), 1,
      sym_comment,
    ACTIONS(8604), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191744] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5311), 1,
      sym_comment,
    ACTIONS(9000), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191759] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5312), 1,
      sym_comment,
    ACTIONS(8870), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191774] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7405), 1,
      anon_sym_LBRACE,
    ACTIONS(7411), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3018), 1,
      sym_object_type,
    STATE(5313), 1,
      sym_comment,
  [191793] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5314), 1,
      sym_comment,
    ACTIONS(8975), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191808] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9078), 1,
      anon_sym_COMMA,
    ACTIONS(9080), 1,
      anon_sym_RBRACK,
    STATE(5315), 1,
      sym_comment,
    STATE(5354), 1,
      aux_sym_tuple_type_repeat1,
  [191827] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5316), 1,
      sym_comment,
    ACTIONS(8552), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191842] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5317), 1,
      sym_comment,
    ACTIONS(8572), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191857] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4853), 1,
      anon_sym_extends,
    ACTIONS(9082), 1,
      anon_sym_AMP,
    ACTIONS(9084), 1,
      anon_sym_PIPE,
    STATE(5318), 1,
      sym_comment,
  [191876] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9086), 1,
      sym_identifier,
    ACTIONS(9088), 1,
      anon_sym_LBRACK,
    ACTIONS(9090), 1,
      sym_private_property_identifier,
    STATE(5319), 1,
      sym_comment,
  [191895] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9092), 1,
      anon_sym_COMMA,
    ACTIONS(9094), 1,
      anon_sym_GT,
    STATE(4954), 1,
      aux_sym_type_arguments_repeat1,
    STATE(5320), 1,
      sym_comment,
  [191914] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5321), 1,
      sym_comment,
    ACTIONS(8552), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191929] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9096), 1,
      anon_sym_COMMA,
    ACTIONS(9098), 1,
      anon_sym_GT,
    STATE(4954), 1,
      aux_sym_type_arguments_repeat1,
    STATE(5322), 1,
      sym_comment,
  [191948] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5323), 1,
      sym_comment,
    ACTIONS(7421), 3,
      anon_sym_LBRACK,
      sym_identifier,
      sym_private_property_identifier,
  [191963] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3403), 1,
      anon_sym_GT,
    ACTIONS(9100), 1,
      anon_sym_COMMA,
    STATE(4954), 1,
      aux_sym_type_arguments_repeat1,
    STATE(5324), 1,
      sym_comment,
  [191982] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5325), 1,
      sym_comment,
    ACTIONS(8975), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191997] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5326), 1,
      sym_comment,
    ACTIONS(8701), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192012] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5327), 1,
      sym_comment,
    ACTIONS(8552), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192027] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2044), 1,
      anon_sym_COMMA,
    ACTIONS(5647), 1,
      anon_sym_RPAREN,
    STATE(5328), 1,
      sym_comment,
    STATE(5361), 1,
      aux_sym_array_repeat1,
  [192046] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2044), 1,
      anon_sym_COMMA,
    ACTIONS(5647), 1,
      anon_sym_RPAREN,
    STATE(4762), 1,
      aux_sym_array_repeat1,
    STATE(5329), 1,
      sym_comment,
  [192065] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5330), 1,
      sym_comment,
    ACTIONS(8580), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192080] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5331), 1,
      sym_comment,
    ACTIONS(8975), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192095] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5332), 1,
      sym_comment,
    ACTIONS(8604), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192110] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7405), 1,
      anon_sym_LBRACE,
    ACTIONS(7411), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2984), 1,
      sym_object_type,
    STATE(5333), 1,
      sym_comment,
  [192129] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5334), 1,
      sym_comment,
    ACTIONS(9014), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192144] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3814), 1,
      anon_sym_LPAREN,
    ACTIONS(9102), 1,
      anon_sym_DOT,
    STATE(3767), 1,
      sym_arguments,
    STATE(5335), 1,
      sym_comment,
  [192163] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5336), 1,
      sym_comment,
    ACTIONS(8975), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192178] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5337), 1,
      sym_comment,
    ACTIONS(9014), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192193] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5338), 1,
      sym_comment,
    ACTIONS(8975), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192208] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5339), 1,
      sym_comment,
    ACTIONS(8604), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192223] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5340), 1,
      sym_comment,
    ACTIONS(8634), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192238] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5341), 1,
      sym_comment,
    ACTIONS(8701), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192253] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5342), 1,
      sym_comment,
    ACTIONS(9104), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192268] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5343), 1,
      sym_comment,
    ACTIONS(8604), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192283] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5344), 1,
      sym_comment,
    ACTIONS(8634), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192298] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5345), 1,
      sym_comment,
    ACTIONS(8564), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192313] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5346), 1,
      sym_comment,
    ACTIONS(8580), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192328] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5347), 1,
      sym_comment,
    ACTIONS(8975), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192343] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5348), 1,
      sym_comment,
    ACTIONS(8975), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192358] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7131), 1,
      anon_sym_implements,
    ACTIONS(9106), 1,
      anon_sym_LBRACE,
    STATE(5349), 1,
      sym_comment,
    STATE(6211), 1,
      sym_implements_clause,
  [192377] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5350), 1,
      sym_comment,
    ACTIONS(8975), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192392] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2044), 1,
      anon_sym_COMMA,
    ACTIONS(5603), 1,
      anon_sym_RBRACK,
    STATE(4762), 1,
      aux_sym_array_repeat1,
    STATE(5351), 1,
      sym_comment,
  [192411] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5352), 1,
      sym_comment,
    ACTIONS(8574), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192426] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8556), 1,
      anon_sym_COMMA,
    ACTIONS(9108), 1,
      anon_sym_RBRACK,
    STATE(5212), 1,
      aux_sym_ui_object_array_repeat1,
    STATE(5353), 1,
      sym_comment,
  [192445] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3295), 1,
      anon_sym_RBRACK,
    ACTIONS(9110), 1,
      anon_sym_COMMA,
    STATE(4997), 1,
      aux_sym_tuple_type_repeat1,
    STATE(5354), 1,
      sym_comment,
  [192464] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2044), 1,
      anon_sym_COMMA,
    ACTIONS(5603), 1,
      anon_sym_RBRACK,
    STATE(5213), 1,
      aux_sym_array_repeat1,
    STATE(5355), 1,
      sym_comment,
  [192483] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5356), 1,
      sym_comment,
    ACTIONS(9004), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192498] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5357), 1,
      sym_comment,
    ACTIONS(8604), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192513] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9112), 1,
      anon_sym_COMMA,
    ACTIONS(9114), 1,
      anon_sym_RPAREN,
    STATE(5220), 1,
      aux_sym_formal_parameters_repeat1,
    STATE(5358), 1,
      sym_comment,
  [192532] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5359), 1,
      sym_comment,
    ACTIONS(7517), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [192547] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5360), 1,
      sym_comment,
    ACTIONS(8554), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192562] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2044), 1,
      anon_sym_COMMA,
    ACTIONS(9116), 1,
      anon_sym_RPAREN,
    STATE(4762), 1,
      aux_sym_array_repeat1,
    STATE(5361), 1,
      sym_comment,
  [192581] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4564), 1,
      anon_sym_COMMA,
    ACTIONS(9118), 1,
      anon_sym_RBRACE,
    STATE(5224), 1,
      aux_sym_object_repeat1,
    STATE(5362), 1,
      sym_comment,
  [192600] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5363), 1,
      sym_comment,
    ACTIONS(8604), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192615] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5364), 1,
      sym_comment,
    ACTIONS(8580), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192630] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5365), 1,
      sym_comment,
    ACTIONS(8574), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192645] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5366), 1,
      sym_comment,
    ACTIONS(8572), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192660] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4564), 1,
      anon_sym_COMMA,
    ACTIONS(9118), 1,
      anon_sym_RBRACE,
    STATE(5231), 1,
      aux_sym_object_repeat1,
    STATE(5367), 1,
      sym_comment,
  [192679] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5368), 1,
      sym_comment,
    ACTIONS(8604), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192694] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5369), 1,
      sym_comment,
    ACTIONS(8604), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192709] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5370), 1,
      sym_comment,
    ACTIONS(9004), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192724] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5371), 1,
      sym_comment,
    ACTIONS(8566), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192739] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5372), 1,
      sym_comment,
    ACTIONS(9120), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192754] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9122), 1,
      sym_identifier,
    STATE(5373), 1,
      sym_comment,
    ACTIONS(9124), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [192771] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9126), 1,
      sym_identifier,
    STATE(5374), 1,
      sym_comment,
    ACTIONS(9128), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [192788] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9130), 1,
      anon_sym_LPAREN,
    ACTIONS(9132), 1,
      anon_sym_await,
    STATE(47), 1,
      sym__for_header,
    STATE(5375), 1,
      sym_comment,
  [192807] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5376), 1,
      sym_comment,
    ACTIONS(8580), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192822] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7369), 1,
      anon_sym_DOT,
    STATE(5377), 1,
      sym_comment,
    ACTIONS(9134), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [192839] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5378), 1,
      sym_comment,
    ACTIONS(9004), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192854] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5379), 1,
      sym_comment,
    ACTIONS(9136), 3,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
  [192869] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5380), 1,
      sym_comment,
    ACTIONS(8634), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192884] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9140), 1,
      anon_sym_COLON,
    STATE(5381), 1,
      sym_comment,
    ACTIONS(9138), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [192901] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9144), 1,
      anon_sym_COLON,
    STATE(5382), 1,
      sym_comment,
    ACTIONS(9142), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [192918] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9146), 1,
      sym_identifier,
    STATE(5383), 1,
      sym_comment,
    STATE(6245), 1,
      sym_nested_type_identifier,
    STATE(6331), 1,
      sym_nested_identifier,
  [192937] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5384), 1,
      sym_comment,
    ACTIONS(9014), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192952] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9150), 1,
      anon_sym_COLON,
    STATE(5385), 1,
      sym_comment,
    ACTIONS(9148), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [192969] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9154), 1,
      anon_sym_COLON,
    STATE(5386), 1,
      sym_comment,
    ACTIONS(9152), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [192986] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2484), 1,
      anon_sym_LBRACE,
    ACTIONS(7940), 1,
      anon_sym_DOT,
    STATE(3035), 1,
      sym_ui_object_initializer,
    STATE(5387), 1,
      sym_comment,
  [193005] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2484), 1,
      anon_sym_LBRACE,
    ACTIONS(6513), 1,
      anon_sym_DOT,
    STATE(3036), 1,
      sym_ui_object_initializer,
    STATE(5388), 1,
      sym_comment,
  [193024] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8249), 1,
      sym_identifier,
    ACTIONS(8251), 1,
      anon_sym_const,
    STATE(5266), 1,
      sym_type_parameter,
    STATE(5389), 1,
      sym_comment,
  [193043] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7387), 1,
      anon_sym_DOT,
    STATE(5390), 1,
      sym_comment,
    ACTIONS(9134), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [193060] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5391), 1,
      sym_comment,
    ACTIONS(8564), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193075] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5392), 1,
      sym_comment,
    ACTIONS(8701), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193090] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5393), 1,
      sym_comment,
    ACTIONS(8604), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193105] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5394), 1,
      sym_comment,
    ACTIONS(8159), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193120] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2044), 1,
      anon_sym_COMMA,
    ACTIONS(9156), 1,
      anon_sym_RPAREN,
    STATE(4762), 1,
      aux_sym_array_repeat1,
    STATE(5395), 1,
      sym_comment,
  [193139] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5396), 1,
      sym_comment,
    ACTIONS(9104), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193154] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5397), 1,
      sym_comment,
    ACTIONS(9158), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193169] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5398), 1,
      sym_comment,
    ACTIONS(8574), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193184] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5399), 1,
      sym_comment,
    ACTIONS(8604), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193199] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5400), 1,
      sym_comment,
    ACTIONS(8574), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193214] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5401), 1,
      sym_comment,
    ACTIONS(8159), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193229] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1743), 1,
      anon_sym_COMMA,
    ACTIONS(8289), 1,
      anon_sym_RBRACK,
    STATE(5287), 1,
      aux_sym_array_pattern_repeat1,
    STATE(5402), 1,
      sym_comment,
  [193248] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5403), 1,
      sym_comment,
    ACTIONS(8574), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193263] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5404), 1,
      sym_comment,
    ACTIONS(9014), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193278] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5405), 1,
      sym_comment,
    ACTIONS(8554), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193293] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1743), 1,
      anon_sym_COMMA,
    ACTIONS(8289), 1,
      anon_sym_RBRACK,
    STATE(5289), 1,
      aux_sym_array_pattern_repeat1,
    STATE(5406), 1,
      sym_comment,
  [193312] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4871), 1,
      anon_sym_LBRACE,
    STATE(5407), 1,
      sym_comment,
    ACTIONS(4873), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [193329] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4416), 1,
      anon_sym_COMMA,
    ACTIONS(9160), 1,
      anon_sym_RBRACE,
    STATE(5293), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5408), 1,
      sym_comment,
  [193348] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4416), 1,
      anon_sym_COMMA,
    ACTIONS(9160), 1,
      anon_sym_RBRACE,
    STATE(5294), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5409), 1,
      sym_comment,
  [193367] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4843), 1,
      anon_sym_LBRACE,
    STATE(5410), 1,
      sym_comment,
    ACTIONS(4845), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [193384] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5411), 1,
      sym_comment,
    ACTIONS(8572), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193399] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5412), 1,
      sym_comment,
    ACTIONS(8701), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193414] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2484), 1,
      anon_sym_LBRACE,
    ACTIONS(7940), 1,
      anon_sym_DOT,
    STATE(3081), 1,
      sym_ui_object_initializer,
    STATE(5413), 1,
      sym_comment,
  [193433] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2484), 1,
      anon_sym_LBRACE,
    ACTIONS(6513), 1,
      anon_sym_DOT,
    STATE(3083), 1,
      sym_ui_object_initializer,
    STATE(5414), 1,
      sym_comment,
  [193452] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5415), 1,
      sym_comment,
    ACTIONS(8612), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193467] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5416), 1,
      sym_comment,
    ACTIONS(8580), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193482] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5417), 1,
      sym_comment,
    ACTIONS(9162), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193497] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5418), 1,
      sym_comment,
    ACTIONS(8572), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193512] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9164), 1,
      sym_identifier,
    STATE(1208), 1,
      sym_decorator_call_expression,
    STATE(3935), 1,
      sym_decorator_member_expression,
    STATE(5419), 1,
      sym_comment,
  [193531] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5420), 1,
      sym_comment,
    ACTIONS(9014), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193546] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2362), 1,
      anon_sym_LBRACE,
    ACTIONS(9166), 1,
      sym_identifier,
    STATE(4749), 1,
      sym_export_clause,
    STATE(5421), 1,
      sym_comment,
  [193565] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5422), 1,
      sym_comment,
    ACTIONS(9014), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193580] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2484), 1,
      anon_sym_LBRACE,
    ACTIONS(6513), 1,
      anon_sym_DOT,
    STATE(2802), 1,
      sym_ui_object_initializer,
    STATE(5423), 1,
      sym_comment,
  [193599] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5424), 1,
      sym_comment,
    ACTIONS(8564), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193614] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3073), 1,
      anon_sym_LT,
    ACTIONS(9168), 1,
      anon_sym_EQ,
    STATE(5425), 1,
      sym_comment,
    STATE(6319), 1,
      sym_type_parameters,
  [193633] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5426), 1,
      sym_comment,
    ACTIONS(8701), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193648] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5427), 1,
      sym_comment,
    ACTIONS(8604), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193663] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5428), 1,
      sym_comment,
    ACTIONS(9070), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193678] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5429), 1,
      sym_comment,
    ACTIONS(8604), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193693] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5430), 1,
      sym_comment,
    ACTIONS(8552), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193708] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5431), 1,
      sym_comment,
    ACTIONS(9170), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193723] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5432), 1,
      sym_comment,
    ACTIONS(9172), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193738] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5433), 1,
      sym_comment,
    ACTIONS(9104), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193753] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5434), 1,
      sym_comment,
    ACTIONS(8701), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193768] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5435), 1,
      sym_comment,
    ACTIONS(9174), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193783] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5436), 1,
      sym_comment,
    ACTIONS(8580), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193798] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5437), 1,
      sym_comment,
    ACTIONS(9170), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193813] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5438), 1,
      sym_comment,
    ACTIONS(8574), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193828] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5439), 1,
      sym_comment,
    ACTIONS(8701), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193843] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5440), 1,
      sym_comment,
    ACTIONS(8604), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193858] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3305), 1,
      anon_sym_RBRACK,
    ACTIONS(9176), 1,
      anon_sym_COMMA,
    STATE(4997), 1,
      aux_sym_tuple_type_repeat1,
    STATE(5441), 1,
      sym_comment,
  [193877] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5442), 1,
      sym_comment,
    ACTIONS(9070), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193892] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5443), 1,
      sym_comment,
    ACTIONS(8574), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193907] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5444), 1,
      sym_comment,
    ACTIONS(8604), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193922] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9178), 1,
      anon_sym_LBRACE,
    STATE(5445), 1,
      sym_comment,
    ACTIONS(8011), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [193939] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5446), 1,
      sym_comment,
    ACTIONS(8580), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193954] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5447), 1,
      sym_comment,
    ACTIONS(9014), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193969] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5448), 1,
      sym_comment,
    ACTIONS(9014), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193984] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5449), 1,
      sym_comment,
    ACTIONS(8572), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193999] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2044), 1,
      anon_sym_COMMA,
    ACTIONS(9180), 1,
      anon_sym_RPAREN,
    STATE(4762), 1,
      aux_sym_array_repeat1,
    STATE(5450), 1,
      sym_comment,
  [194018] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5451), 1,
      sym_comment,
    ACTIONS(8634), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194033] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5452), 1,
      sym_comment,
    ACTIONS(9000), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194048] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5453), 1,
      sym_comment,
    ACTIONS(8572), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194063] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5454), 1,
      sym_comment,
    ACTIONS(8754), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194078] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9182), 1,
      anon_sym_as,
    STATE(5455), 1,
      sym_comment,
    ACTIONS(9184), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [194095] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5456), 1,
      sym_comment,
    ACTIONS(9000), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194110] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3291), 1,
      anon_sym_RBRACK,
    ACTIONS(9186), 1,
      anon_sym_COMMA,
    STATE(4997), 1,
      aux_sym_tuple_type_repeat1,
    STATE(5457), 1,
      sym_comment,
  [194129] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9188), 1,
      anon_sym_SQUOTE,
    STATE(5458), 1,
      sym_comment,
    ACTIONS(9190), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [194146] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5459), 1,
      sym_comment,
    ACTIONS(9000), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194161] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9192), 1,
      anon_sym_DQUOTE,
    STATE(5460), 1,
      sym_comment,
    ACTIONS(9194), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [194178] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9196), 1,
      anon_sym_as,
    STATE(5461), 1,
      sym_comment,
    ACTIONS(9198), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [194195] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5462), 1,
      sym_comment,
    ACTIONS(8552), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194210] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9200), 1,
      sym_identifier,
    ACTIONS(9202), 1,
      anon_sym_LBRACK,
    ACTIONS(9204), 1,
      sym_private_property_identifier,
    STATE(5463), 1,
      sym_comment,
  [194229] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5464), 1,
      sym_comment,
    ACTIONS(9206), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194244] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5465), 1,
      sym_comment,
    ACTIONS(8701), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194259] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5466), 1,
      sym_comment,
    ACTIONS(8634), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194274] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5467), 1,
      sym_comment,
    ACTIONS(8564), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194289] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5468), 1,
      sym_comment,
    ACTIONS(8574), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194304] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5469), 1,
      sym_comment,
    ACTIONS(9208), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194319] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9210), 1,
      sym_identifier,
    ACTIONS(9212), 1,
      anon_sym_LBRACK,
    ACTIONS(9214), 1,
      sym_private_property_identifier,
    STATE(5470), 1,
      sym_comment,
  [194338] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5471), 1,
      sym_comment,
    ACTIONS(8574), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194353] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7486), 1,
      anon_sym_EQ,
    STATE(5472), 1,
      sym_comment,
    ACTIONS(3968), 2,
      anon_sym_in,
      anon_sym_of,
  [194370] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5473), 1,
      sym_comment,
    ACTIONS(9216), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194385] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9218), 1,
      anon_sym_LBRACE,
    STATE(5474), 1,
      sym_comment,
    ACTIONS(8105), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [194402] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9220), 1,
      anon_sym_LBRACE,
    STATE(5475), 1,
      sym_comment,
    ACTIONS(8149), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [194419] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5476), 1,
      sym_comment,
    ACTIONS(8574), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194434] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5477), 1,
      sym_comment,
    ACTIONS(9222), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194449] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5478), 1,
      sym_comment,
    ACTIONS(8564), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194464] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5479), 1,
      sym_comment,
    ACTIONS(8552), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194479] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5480), 1,
      sym_comment,
    ACTIONS(9208), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194494] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9224), 1,
      sym_identifier,
    ACTIONS(9226), 1,
      anon_sym_LBRACK,
    ACTIONS(9228), 1,
      sym_private_property_identifier,
    STATE(5481), 1,
      sym_comment,
  [194513] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5482), 1,
      sym_comment,
    ACTIONS(8701), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194528] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5483), 1,
      sym_comment,
    ACTIONS(9230), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194543] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5484), 1,
      sym_comment,
    ACTIONS(9000), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194558] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9234), 1,
      anon_sym_COLON,
    STATE(5485), 1,
      sym_comment,
    ACTIONS(9232), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [194575] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5486), 1,
      sym_comment,
    ACTIONS(8574), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194590] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9236), 1,
      sym_identifier,
    ACTIONS(9238), 1,
      anon_sym_LBRACK,
    ACTIONS(9240), 1,
      sym_private_property_identifier,
    STATE(5487), 1,
      sym_comment,
  [194609] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9242), 1,
      anon_sym_COMMA,
    ACTIONS(9244), 1,
      anon_sym_RBRACK,
    STATE(5441), 1,
      aux_sym_tuple_type_repeat1,
    STATE(5488), 1,
      sym_comment,
  [194628] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5489), 1,
      sym_comment,
    ACTIONS(8701), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194643] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7099), 1,
      anon_sym_AMP,
    ACTIONS(7101), 1,
      anon_sym_PIPE,
    ACTIONS(7103), 1,
      anon_sym_extends,
    STATE(5490), 1,
      sym_comment,
  [194662] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2484), 1,
      anon_sym_LBRACE,
    ACTIONS(9246), 1,
      anon_sym_DOT,
    STATE(3087), 1,
      sym_ui_object_initializer,
    STATE(5491), 1,
      sym_comment,
  [194681] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9248), 1,
      anon_sym_COMMA,
    ACTIONS(9250), 1,
      anon_sym_GT,
    STATE(4954), 1,
      aux_sym_type_arguments_repeat1,
    STATE(5492), 1,
      sym_comment,
  [194700] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5493), 1,
      sym_comment,
    ACTIONS(8572), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194715] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9252), 1,
      anon_sym_COMMA,
    ACTIONS(9254), 1,
      anon_sym_GT,
    STATE(4954), 1,
      aux_sym_type_arguments_repeat1,
    STATE(5494), 1,
      sym_comment,
  [194734] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5495), 1,
      sym_comment,
    ACTIONS(8634), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194749] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3379), 1,
      anon_sym_GT,
    ACTIONS(9256), 1,
      anon_sym_COMMA,
    STATE(4954), 1,
      aux_sym_type_arguments_repeat1,
    STATE(5496), 1,
      sym_comment,
  [194768] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5497), 1,
      sym_comment,
    ACTIONS(9014), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194783] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5498), 1,
      sym_comment,
    ACTIONS(9120), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194798] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2044), 1,
      anon_sym_COMMA,
    ACTIONS(5662), 1,
      anon_sym_RPAREN,
    STATE(5395), 1,
      aux_sym_array_repeat1,
    STATE(5499), 1,
      sym_comment,
  [194817] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2044), 1,
      anon_sym_COMMA,
    ACTIONS(5662), 1,
      anon_sym_RPAREN,
    STATE(4762), 1,
      aux_sym_array_repeat1,
    STATE(5500), 1,
      sym_comment,
  [194836] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5501), 1,
      sym_comment,
    ACTIONS(8634), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194851] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5502), 1,
      sym_comment,
    ACTIONS(8634), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194866] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5503), 1,
      sym_comment,
    ACTIONS(8574), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194881] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5504), 1,
      sym_comment,
    ACTIONS(8604), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194896] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2484), 1,
      anon_sym_LBRACE,
    ACTIONS(7940), 1,
      anon_sym_DOT,
    STATE(2843), 1,
      sym_ui_object_initializer,
    STATE(5505), 1,
      sym_comment,
  [194915] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5506), 1,
      sym_comment,
    ACTIONS(8574), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194930] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9258), 1,
      sym_identifier,
    ACTIONS(9260), 1,
      anon_sym_LBRACK,
    ACTIONS(9262), 1,
      sym_private_property_identifier,
    STATE(5507), 1,
      sym_comment,
  [194949] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9264), 1,
      sym_identifier,
    ACTIONS(9266), 1,
      anon_sym_LBRACK,
    ACTIONS(9268), 1,
      sym_private_property_identifier,
    STATE(5508), 1,
      sym_comment,
  [194968] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9270), 1,
      sym_identifier,
    ACTIONS(9272), 1,
      anon_sym_LBRACK,
    ACTIONS(9274), 1,
      sym_private_property_identifier,
    STATE(5509), 1,
      sym_comment,
  [194987] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9276), 1,
      anon_sym_SEMI,
    ACTIONS(9278), 1,
      sym__automatic_semicolon,
    STATE(5510), 1,
      sym_comment,
  [195003] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5511), 1,
      sym_comment,
    ACTIONS(9280), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [195017] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9282), 1,
      sym_identifier,
    STATE(5491), 1,
      sym_ui_simple_nested_identifier,
    STATE(5512), 1,
      sym_comment,
  [195033] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9284), 1,
      sym_identifier,
    ACTIONS(9286), 1,
      anon_sym_STAR,
    STATE(5513), 1,
      sym_comment,
  [195049] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9288), 1,
      sym_identifier,
    ACTIONS(9290), 1,
      anon_sym_STAR,
    STATE(5514), 1,
      sym_comment,
  [195065] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9292), 1,
      sym_identifier,
    ACTIONS(9294), 1,
      anon_sym_STAR,
    STATE(5515), 1,
      sym_comment,
  [195081] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5516), 1,
      sym_comment,
    ACTIONS(6556), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [195095] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9258), 1,
      sym_identifier,
    ACTIONS(9262), 1,
      sym_private_property_identifier,
    STATE(5517), 1,
      sym_comment,
  [195111] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9296), 1,
      sym_identifier,
    ACTIONS(9298), 1,
      anon_sym_STAR,
    STATE(5518), 1,
      sym_comment,
  [195127] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9300), 1,
      sym_identifier,
    ACTIONS(9302), 1,
      sym_private_property_identifier,
    STATE(5519), 1,
      sym_comment,
  [195143] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5520), 1,
      sym_comment,
    ACTIONS(9304), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [195157] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9306), 1,
      sym_identifier,
    ACTIONS(9308), 1,
      sym_private_property_identifier,
    STATE(5521), 1,
      sym_comment,
  [195173] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9310), 1,
      anon_sym_LBRACE,
    STATE(3060), 1,
      sym__qml_enum_body,
    STATE(5522), 1,
      sym_comment,
  [195189] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9312), 1,
      sym_identifier,
    ACTIONS(9314), 1,
      sym_private_property_identifier,
    STATE(5523), 1,
      sym_comment,
  [195205] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5524), 1,
      sym_comment,
    ACTIONS(9316), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [195219] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5525), 1,
      sym_comment,
    ACTIONS(9318), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [195233] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9290), 1,
      anon_sym_STAR,
    ACTIONS(9320), 1,
      sym_identifier,
    STATE(5526), 1,
      sym_comment,
  [195249] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5527), 1,
      sym_comment,
    ACTIONS(9322), 2,
      anon_sym_LBRACE,
      anon_sym_DOT,
  [195263] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9324), 1,
      anon_sym_LPAREN,
    STATE(52), 1,
      sym_parenthesized_expression,
    STATE(5528), 1,
      sym_comment,
  [195279] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9324), 1,
      anon_sym_LPAREN,
    STATE(49), 1,
      sym_parenthesized_expression,
    STATE(5529), 1,
      sym_comment,
  [195295] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9324), 1,
      anon_sym_LPAREN,
    STATE(5530), 1,
      sym_comment,
    STATE(5544), 1,
      sym_parenthesized_expression,
  [195311] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(5531), 1,
      sym_comment,
    ACTIONS(9326), 2,
      sym__glimmer_template_content,
      anon_sym_LT_SLASHtemplate_GT,
  [195325] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9286), 1,
      anon_sym_STAR,
    ACTIONS(9328), 1,
      sym_identifier,
    STATE(5532), 1,
      sym_comment,
  [195341] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5533), 1,
      sym_comment,
    ACTIONS(5295), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [195355] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4058), 1,
      sym_formal_parameters,
    STATE(5534), 1,
      sym_comment,
  [195371] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6768), 1,
      anon_sym_COLON,
    STATE(5286), 1,
      sym_type_annotation,
    STATE(5535), 1,
      sym_comment,
  [195387] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2825), 1,
      sym_statement_block,
    STATE(5536), 1,
      sym_comment,
  [195403] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5537), 1,
      sym_comment,
    ACTIONS(9330), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [195417] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9332), 1,
      sym_identifier,
    STATE(5267), 1,
      sym__qml_enum_assignment,
    STATE(5538), 1,
      sym_comment,
  [195433] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5539), 1,
      sym_comment,
    ACTIONS(9334), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [195447] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5540), 1,
      sym_comment,
    ACTIONS(9336), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [195461] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9338), 1,
      sym_identifier,
    ACTIONS(9340), 1,
      sym_private_property_identifier,
    STATE(5541), 1,
      sym_comment,
  [195477] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9324), 1,
      anon_sym_LPAREN,
    STATE(44), 1,
      sym_parenthesized_expression,
    STATE(5542), 1,
      sym_comment,
  [195493] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(2588), 1,
      sym_statement_block,
    STATE(5543), 1,
      sym_comment,
  [195509] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9342), 1,
      anon_sym_LBRACE,
    STATE(2913), 1,
      sym_switch_body,
    STATE(5544), 1,
      sym_comment,
  [195525] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5545), 1,
      sym_comment,
    ACTIONS(9344), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [195539] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7015), 1,
      anon_sym_LBRACE,
    STATE(2584), 1,
      sym_class_body,
    STATE(5546), 1,
      sym_comment,
  [195555] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4713), 1,
      anon_sym_LBRACE,
    STATE(2607), 1,
      sym_statement_block,
    STATE(5547), 1,
      sym_comment,
  [195571] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5548), 1,
      sym_comment,
    ACTIONS(9346), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [195585] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9348), 1,
      sym_identifier,
    ACTIONS(9350), 1,
      sym_private_property_identifier,
    STATE(5549), 1,
      sym_comment,
  [195601] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9086), 1,
      sym_identifier,
    ACTIONS(9090), 1,
      sym_private_property_identifier,
    STATE(5550), 1,
      sym_comment,
  [195617] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(5551), 1,
      sym_comment,
    ACTIONS(9352), 2,
      sym__glimmer_template_content,
      anon_sym_LT_SLASHtemplate_GT,
  [195631] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5552), 1,
      sym_comment,
    ACTIONS(7647), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [195645] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5553), 1,
      sym_comment,
    ACTIONS(9064), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [195659] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5554), 1,
      sym_comment,
    ACTIONS(9057), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [195673] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2833), 1,
      sym_statement_block,
    STATE(5555), 1,
      sym_comment,
  [195689] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2834), 1,
      sym_statement_block,
    STATE(5556), 1,
      sym_comment,
  [195705] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6606), 1,
      anon_sym_DOT,
    ACTIONS(9354), 1,
      anon_sym_GT,
    STATE(5557), 1,
      sym_comment,
  [195721] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5558), 1,
      sym_comment,
    ACTIONS(9356), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [195735] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(5559), 1,
      sym_comment,
    STATE(6194), 1,
      sym_formal_parameters,
  [195751] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9358), 1,
      sym_identifier,
    ACTIONS(9360), 1,
      anon_sym_STAR,
    STATE(5560), 1,
      sym_comment,
  [195767] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8359), 1,
      anon_sym_from,
    STATE(5561), 1,
      sym_comment,
    STATE(5623), 1,
      sym__from_clause,
  [195783] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5562), 1,
      sym_comment,
    ACTIONS(8992), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [195797] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8359), 1,
      anon_sym_from,
    STATE(4812), 1,
      sym__from_clause,
    STATE(5563), 1,
      sym_comment,
  [195813] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9362), 1,
      anon_sym_COMMA,
    ACTIONS(9364), 1,
      anon_sym_from,
    STATE(5564), 1,
      sym_comment,
  [195829] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9366), 1,
      anon_sym_LPAREN,
    STATE(60), 1,
      sym__for_header,
    STATE(5565), 1,
      sym_comment,
  [195845] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5566), 1,
      sym_comment,
    ACTIONS(9368), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [195859] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5567), 1,
      sym_comment,
    ACTIONS(9370), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [195873] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5568), 1,
      sym_comment,
    ACTIONS(5273), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [195887] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5569), 1,
      sym_comment,
    ACTIONS(5267), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [195901] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2585), 1,
      anon_sym_LBRACE,
    STATE(821), 1,
      sym_statement_block,
    STATE(5570), 1,
      sym_comment,
  [195917] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9372), 1,
      anon_sym_LBRACE,
    STATE(813), 1,
      sym_enum_body,
    STATE(5571), 1,
      sym_comment,
  [195933] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7015), 1,
      anon_sym_LBRACE,
    STATE(2457), 1,
      sym_class_body,
    STATE(5572), 1,
      sym_comment,
  [195949] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4713), 1,
      anon_sym_LBRACE,
    STATE(2458), 1,
      sym_statement_block,
    STATE(5573), 1,
      sym_comment,
  [195965] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(5574), 1,
      sym_comment,
    STATE(5642), 1,
      sym_statement_block,
  [195981] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5575), 1,
      sym_comment,
    ACTIONS(9374), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [195995] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(2902), 1,
      sym_statement_block,
    STATE(5576), 1,
      sym_comment,
  [196011] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7015), 1,
      anon_sym_LBRACE,
    STATE(2662), 1,
      sym_class_body,
    STATE(5577), 1,
      sym_comment,
  [196027] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9376), 1,
      sym_identifier,
    ACTIONS(9378), 1,
      sym_private_property_identifier,
    STATE(5578), 1,
      sym_comment,
  [196043] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7015), 1,
      anon_sym_LBRACE,
    STATE(2650), 1,
      sym_class_body,
    STATE(5579), 1,
      sym_comment,
  [196059] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4713), 1,
      anon_sym_LBRACE,
    STATE(2512), 1,
      sym_statement_block,
    STATE(5580), 1,
      sym_comment,
  [196075] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4713), 1,
      anon_sym_LBRACE,
    STATE(2571), 1,
      sym_statement_block,
    STATE(5581), 1,
      sym_comment,
  [196091] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4713), 1,
      anon_sym_LBRACE,
    STATE(2568), 1,
      sym_statement_block,
    STATE(5582), 1,
      sym_comment,
  [196107] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4451), 1,
      sym_formal_parameters,
    STATE(5583), 1,
      sym_comment,
  [196123] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5584), 1,
      sym_comment,
    ACTIONS(7742), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [196137] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7015), 1,
      anon_sym_LBRACE,
    STATE(2496), 1,
      sym_class_body,
    STATE(5585), 1,
      sym_comment,
  [196153] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4713), 1,
      anon_sym_LBRACE,
    STATE(2497), 1,
      sym_statement_block,
    STATE(5586), 1,
      sym_comment,
  [196169] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7015), 1,
      anon_sym_LBRACE,
    STATE(2499), 1,
      sym_class_body,
    STATE(5587), 1,
      sym_comment,
  [196185] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(5588), 1,
      sym_comment,
    STATE(6098), 1,
      sym_formal_parameters,
  [196201] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9380), 1,
      sym_identifier,
    ACTIONS(9382), 1,
      sym_private_property_identifier,
    STATE(5589), 1,
      sym_comment,
  [196217] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5590), 1,
      sym_comment,
    ACTIONS(9384), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [196231] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9386), 1,
      sym_identifier,
    ACTIONS(9388), 1,
      sym_private_property_identifier,
    STATE(5591), 1,
      sym_comment,
  [196247] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9390), 1,
      sym_identifier,
    ACTIONS(9392), 1,
      sym_private_property_identifier,
    STATE(5592), 1,
      sym_comment,
  [196263] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9394), 1,
      sym_identifier,
    ACTIONS(9396), 1,
      sym_private_property_identifier,
    STATE(5593), 1,
      sym_comment,
  [196279] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9398), 1,
      sym_identifier,
    ACTIONS(9400), 1,
      sym_private_property_identifier,
    STATE(5594), 1,
      sym_comment,
  [196295] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9402), 1,
      sym_identifier,
    ACTIONS(9404), 1,
      sym_private_property_identifier,
    STATE(5595), 1,
      sym_comment,
  [196311] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7015), 1,
      anon_sym_LBRACE,
    STATE(2539), 1,
      sym_class_body,
    STATE(5596), 1,
      sym_comment,
  [196327] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9406), 1,
      sym_identifier,
    ACTIONS(9408), 1,
      sym_private_property_identifier,
    STATE(5597), 1,
      sym_comment,
  [196343] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(5598), 1,
      sym_comment,
    STATE(5974), 1,
      sym_formal_parameters,
  [196359] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    STATE(2632), 1,
      sym_arguments,
    STATE(5599), 1,
      sym_comment,
  [196375] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9290), 1,
      anon_sym_STAR,
    ACTIONS(9410), 1,
      sym_identifier,
    STATE(5600), 1,
      sym_comment,
  [196391] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(4532), 1,
      sym_statement_block,
    STATE(5601), 1,
      sym_comment,
  [196407] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5602), 1,
      sym_comment,
    ACTIONS(7625), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [196421] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5603), 1,
      sym_comment,
    ACTIONS(7623), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [196435] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5604), 1,
      sym_comment,
    ACTIONS(7621), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [196449] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7015), 1,
      anon_sym_LBRACE,
    STATE(2665), 1,
      sym_class_body,
    STATE(5605), 1,
      sym_comment,
  [196465] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(5606), 1,
      sym_comment,
    STATE(5997), 1,
      sym_formal_parameters,
  [196481] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5607), 1,
      sym_comment,
    ACTIONS(8927), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [196495] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2854), 1,
      sym_statement_block,
    STATE(5608), 1,
      sym_comment,
  [196511] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3855), 1,
      anon_sym_COLON,
    STATE(5609), 1,
      sym_comment,
    STATE(5686), 1,
      sym_type_annotation,
  [196527] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5610), 1,
      sym_comment,
    ACTIONS(9412), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [196541] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5611), 1,
      sym_comment,
    ACTIONS(9414), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [196555] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5612), 1,
      sym_comment,
    ACTIONS(9416), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [196569] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5613), 1,
      sym_comment,
    ACTIONS(9418), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [196583] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5614), 1,
      sym_comment,
    ACTIONS(9420), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [196597] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9286), 1,
      anon_sym_STAR,
    ACTIONS(9422), 1,
      sym_identifier,
    STATE(5615), 1,
      sym_comment,
  [196613] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5616), 1,
      sym_comment,
    ACTIONS(9424), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [196627] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(5617), 1,
      sym_comment,
    STATE(6010), 1,
      sym_formal_parameters,
  [196643] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9426), 1,
      sym_identifier,
    STATE(5618), 1,
      sym_comment,
    STATE(5702), 1,
      sym__qml_enum_assignment,
  [196659] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9428), 1,
      anon_sym_SEMI,
    ACTIONS(9430), 1,
      sym__automatic_semicolon,
    STATE(5619), 1,
      sym_comment,
  [196675] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9432), 1,
      sym_identifier,
    ACTIONS(9434), 1,
      anon_sym_STAR,
    STATE(5620), 1,
      sym_comment,
  [196691] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7199), 1,
      anon_sym_LBRACE,
    STATE(4269), 1,
      sym_class_body,
    STATE(5621), 1,
      sym_comment,
  [196707] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7199), 1,
      anon_sym_LBRACE,
    STATE(4273), 1,
      sym_class_body,
    STATE(5622), 1,
      sym_comment,
  [196723] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9436), 1,
      anon_sym_SEMI,
    ACTIONS(9438), 1,
      sym__automatic_semicolon,
    STATE(5623), 1,
      sym_comment,
  [196739] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9440), 1,
      anon_sym_SEMI,
    ACTIONS(9442), 1,
      sym__automatic_semicolon,
    STATE(5624), 1,
      sym_comment,
  [196755] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(5625), 1,
      sym_comment,
    STATE(5728), 1,
      sym_statement_block,
  [196771] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8359), 1,
      anon_sym_from,
    STATE(4860), 1,
      sym__from_clause,
    STATE(5626), 1,
      sym_comment,
  [196787] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5627), 1,
      sym_comment,
    ACTIONS(9444), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [196801] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    STATE(5628), 1,
      sym_comment,
    STATE(5743), 1,
      sym_object,
  [196817] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5629), 1,
      sym_comment,
    ACTIONS(9448), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [196831] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5630), 1,
      sym_comment,
    ACTIONS(8452), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [196845] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9372), 1,
      anon_sym_LBRACE,
    STATE(898), 1,
      sym_enum_body,
    STATE(5631), 1,
      sym_comment,
  [196861] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9450), 1,
      anon_sym_LPAREN,
    STATE(782), 1,
      sym_parenthesized_expression,
    STATE(5632), 1,
      sym_comment,
  [196877] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7171), 1,
      anon_sym_LBRACE,
    STATE(254), 1,
      sym_class_body,
    STATE(5633), 1,
      sym_comment,
  [196893] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5634), 1,
      sym_comment,
    ACTIONS(9452), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [196907] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7199), 1,
      anon_sym_LBRACE,
    STATE(4317), 1,
      sym_class_body,
    STATE(5635), 1,
      sym_comment,
  [196923] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7221), 1,
      anon_sym_LBRACE,
    STATE(941), 1,
      sym_class_body,
    STATE(5636), 1,
      sym_comment,
  [196939] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7199), 1,
      anon_sym_LBRACE,
    STATE(4375), 1,
      sym_class_body,
    STATE(5637), 1,
      sym_comment,
  [196955] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3037), 1,
      anon_sym_LBRACE,
    STATE(943), 1,
      sym_statement_block,
    STATE(5638), 1,
      sym_comment,
  [196971] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(5639), 1,
      sym_comment,
    STATE(5748), 1,
      sym_statement_block,
  [196987] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7199), 1,
      anon_sym_LBRACE,
    STATE(4398), 1,
      sym_class_body,
    STATE(5640), 1,
      sym_comment,
  [197003] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7199), 1,
      anon_sym_LBRACE,
    STATE(4399), 1,
      sym_class_body,
    STATE(5641), 1,
      sym_comment,
  [197019] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5642), 1,
      sym_comment,
    ACTIONS(5562), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [197033] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9366), 1,
      anon_sym_LPAREN,
    STATE(42), 1,
      sym__for_header,
    STATE(5643), 1,
      sym_comment,
  [197049] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5644), 1,
      sym_comment,
    ACTIONS(8796), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [197063] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5645), 1,
      sym_comment,
    ACTIONS(9454), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [197077] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5646), 1,
      sym_comment,
    ACTIONS(9456), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [197091] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7033), 1,
      anon_sym_LBRACE,
    STATE(2796), 1,
      sym_class_body,
    STATE(5647), 1,
      sym_comment,
  [197107] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5648), 1,
      sym_comment,
    ACTIONS(8785), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [197121] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(2371), 1,
      sym_statement_block,
    STATE(5649), 1,
      sym_comment,
  [197137] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7015), 1,
      anon_sym_LBRACE,
    STATE(2508), 1,
      sym_class_body,
    STATE(5650), 1,
      sym_comment,
  [197153] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4713), 1,
      anon_sym_LBRACE,
    STATE(2601), 1,
      sym_statement_block,
    STATE(5651), 1,
      sym_comment,
  [197169] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4713), 1,
      anon_sym_LBRACE,
    STATE(2517), 1,
      sym_statement_block,
    STATE(5652), 1,
      sym_comment,
  [197185] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7221), 1,
      anon_sym_LBRACE,
    STATE(947), 1,
      sym_class_body,
    STATE(5653), 1,
      sym_comment,
  [197201] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7199), 1,
      anon_sym_LBRACE,
    STATE(4468), 1,
      sym_class_body,
    STATE(5654), 1,
      sym_comment,
  [197217] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3037), 1,
      anon_sym_LBRACE,
    STATE(949), 1,
      sym_statement_block,
    STATE(5655), 1,
      sym_comment,
  [197233] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7221), 1,
      anon_sym_LBRACE,
    STATE(952), 1,
      sym_class_body,
    STATE(5656), 1,
      sym_comment,
  [197249] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7199), 1,
      anon_sym_LBRACE,
    STATE(4513), 1,
      sym_class_body,
    STATE(5657), 1,
      sym_comment,
  [197265] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5658), 1,
      sym_comment,
    ACTIONS(9458), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [197279] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9460), 1,
      anon_sym_SEMI,
    ACTIONS(9462), 1,
      sym__automatic_semicolon,
    STATE(5659), 1,
      sym_comment,
  [197295] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    STATE(3844), 1,
      sym_formal_parameters,
    STATE(5660), 1,
      sym_comment,
  [197311] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9464), 1,
      sym_identifier,
    ACTIONS(9466), 1,
      sym_private_property_identifier,
    STATE(5661), 1,
      sym_comment,
  [197327] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8742), 1,
      sym_identifier,
    ACTIONS(8746), 1,
      sym_private_property_identifier,
    STATE(5662), 1,
      sym_comment,
  [197343] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9468), 1,
      sym_identifier,
    ACTIONS(9470), 1,
      sym_private_property_identifier,
    STATE(5663), 1,
      sym_comment,
  [197359] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9472), 1,
      sym_identifier,
    ACTIONS(9474), 1,
      sym_private_property_identifier,
    STATE(5664), 1,
      sym_comment,
  [197375] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9476), 1,
      sym_identifier,
    ACTIONS(9478), 1,
      sym_private_property_identifier,
    STATE(5665), 1,
      sym_comment,
  [197391] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9480), 1,
      sym_identifier,
    ACTIONS(9482), 1,
      sym_private_property_identifier,
    STATE(5666), 1,
      sym_comment,
  [197407] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9484), 1,
      sym_identifier,
    ACTIONS(9486), 1,
      sym_private_property_identifier,
    STATE(5667), 1,
      sym_comment,
  [197423] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7221), 1,
      anon_sym_LBRACE,
    STATE(966), 1,
      sym_class_body,
    STATE(5668), 1,
      sym_comment,
  [197439] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9488), 1,
      anon_sym_LBRACE,
    STATE(4668), 1,
      sym_enum_body,
    STATE(5669), 1,
      sym_comment,
  [197455] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9490), 1,
      anon_sym_SEMI,
    ACTIONS(9492), 1,
      sym__automatic_semicolon,
    STATE(5670), 1,
      sym_comment,
  [197471] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9494), 1,
      anon_sym_SEMI,
    ACTIONS(9496), 1,
      sym__automatic_semicolon,
    STATE(5671), 1,
      sym_comment,
  [197487] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9498), 1,
      anon_sym_SEMI,
    ACTIONS(9500), 1,
      sym__automatic_semicolon,
    STATE(5672), 1,
      sym_comment,
  [197503] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9502), 1,
      sym_identifier,
    ACTIONS(9504), 1,
      sym_private_property_identifier,
    STATE(5673), 1,
      sym_comment,
  [197519] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(5674), 1,
      sym_comment,
    STATE(6249), 1,
      sym_formal_parameters,
  [197535] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9506), 1,
      sym_identifier,
    ACTIONS(9508), 1,
      sym_private_property_identifier,
    STATE(5675), 1,
      sym_comment,
  [197551] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(5676), 1,
      sym_comment,
    STATE(6299), 1,
      sym_formal_parameters,
  [197567] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9510), 1,
      sym_identifier,
    ACTIONS(9512), 1,
      sym_private_property_identifier,
    STATE(5677), 1,
      sym_comment,
  [197583] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9514), 1,
      sym_identifier,
    ACTIONS(9516), 1,
      sym_private_property_identifier,
    STATE(5678), 1,
      sym_comment,
  [197599] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9518), 1,
      sym_identifier,
    ACTIONS(9520), 1,
      sym_private_property_identifier,
    STATE(5679), 1,
      sym_comment,
  [197615] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5680), 1,
      sym_comment,
    ACTIONS(9522), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [197629] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4713), 1,
      anon_sym_LBRACE,
    STATE(2509), 1,
      sym_statement_block,
    STATE(5681), 1,
      sym_comment,
  [197645] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(5682), 1,
      sym_comment,
    STATE(6330), 1,
      sym_formal_parameters,
  [197661] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9488), 1,
      anon_sym_LBRACE,
    STATE(4449), 1,
      sym_enum_body,
    STATE(5683), 1,
      sym_comment,
  [197677] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(2934), 1,
      sym_statement_block,
    STATE(5684), 1,
      sym_comment,
  [197693] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3855), 1,
      anon_sym_COLON,
    STATE(5685), 1,
      sym_comment,
    STATE(5772), 1,
      sym_type_annotation,
  [197709] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5686), 1,
      sym_comment,
    ACTIONS(9524), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [197723] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5687), 1,
      sym_comment,
    ACTIONS(9526), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [197737] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5688), 1,
      sym_comment,
    ACTIONS(9528), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [197751] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(5689), 1,
      sym_comment,
    STATE(6020), 1,
      sym_formal_parameters,
  [197767] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4563), 1,
      sym_formal_parameters,
    STATE(5690), 1,
      sym_comment,
  [197783] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9530), 1,
      sym_identifier,
    ACTIONS(9532), 1,
      sym_private_property_identifier,
    STATE(5691), 1,
      sym_comment,
  [197799] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7015), 1,
      anon_sym_LBRACE,
    STATE(2587), 1,
      sym_class_body,
    STATE(5692), 1,
      sym_comment,
  [197815] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7015), 1,
      anon_sym_LBRACE,
    STATE(2593), 1,
      sym_class_body,
    STATE(5693), 1,
      sym_comment,
  [197831] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5694), 1,
      sym_comment,
    ACTIONS(9534), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [197845] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5695), 1,
      sym_comment,
    ACTIONS(8648), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [197859] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5696), 1,
      sym_comment,
    ACTIONS(9536), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [197873] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5697), 1,
      sym_comment,
    ACTIONS(9538), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [197887] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9324), 1,
      anon_sym_LPAREN,
    STATE(41), 1,
      sym_parenthesized_expression,
    STATE(5698), 1,
      sym_comment,
  [197903] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(5699), 1,
      sym_comment,
    STATE(6219), 1,
      sym_formal_parameters,
  [197919] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5700), 1,
      sym_comment,
    ACTIONS(9540), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [197933] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6796), 1,
      anon_sym_LPAREN,
    STATE(3589), 1,
      sym_formal_parameters,
    STATE(5701), 1,
      sym_comment,
  [197949] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5702), 1,
      sym_comment,
    ACTIONS(9542), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [197963] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5703), 1,
      sym_comment,
    ACTIONS(9544), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [197977] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5704), 1,
      sym_comment,
    ACTIONS(9546), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [197991] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2197), 1,
      sym_statement_block,
    STATE(5705), 1,
      sym_comment,
  [198007] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2142), 1,
      sym_statement_block,
    STATE(5706), 1,
      sym_comment,
  [198023] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2090), 1,
      sym_statement_block,
    STATE(5707), 1,
      sym_comment,
  [198039] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2214), 1,
      sym_statement_block,
    STATE(5708), 1,
      sym_comment,
  [198055] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2212), 1,
      sym_statement_block,
    STATE(5709), 1,
      sym_comment,
  [198071] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2585), 1,
      anon_sym_LBRACE,
    STATE(774), 1,
      sym_statement_block,
    STATE(5710), 1,
      sym_comment,
  [198087] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7197), 1,
      anon_sym_LBRACE,
    STATE(2939), 1,
      sym_class_body,
    STATE(5711), 1,
      sym_comment,
  [198103] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2208), 1,
      sym_statement_block,
    STATE(5712), 1,
      sym_comment,
  [198119] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2198), 1,
      sym_statement_block,
    STATE(5713), 1,
      sym_comment,
  [198135] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7157), 1,
      anon_sym_LBRACE,
    STATE(2892), 1,
      sym_class_body,
    STATE(5714), 1,
      sym_comment,
  [198151] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5715), 1,
      sym_comment,
    ACTIONS(9548), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [198165] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(5716), 1,
      sym_comment,
    STATE(6199), 1,
      sym_formal_parameters,
  [198181] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5717), 1,
      sym_comment,
    ACTIONS(9550), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [198195] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9552), 1,
      anon_sym_SEMI,
    ACTIONS(9554), 1,
      sym__automatic_semicolon,
    STATE(5718), 1,
      sym_comment,
  [198211] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9324), 1,
      anon_sym_LPAREN,
    STATE(59), 1,
      sym_parenthesized_expression,
    STATE(5719), 1,
      sym_comment,
  [198227] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9324), 1,
      anon_sym_LPAREN,
    STATE(54), 1,
      sym_parenthesized_expression,
    STATE(5720), 1,
      sym_comment,
  [198243] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9324), 1,
      anon_sym_LPAREN,
    STATE(5721), 1,
      sym_comment,
    STATE(5860), 1,
      sym_parenthesized_expression,
  [198259] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5040), 1,
      anon_sym_LBRACE,
    STATE(2054), 1,
      sym_statement_block,
    STATE(5722), 1,
      sym_comment,
  [198275] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5723), 1,
      sym_comment,
    ACTIONS(5595), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [198289] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(5724), 1,
      sym_comment,
    STATE(6196), 1,
      sym_formal_parameters,
  [198305] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9556), 1,
      sym_identifier,
    STATE(4908), 1,
      sym_nested_identifier,
    STATE(5725), 1,
      sym_comment,
  [198321] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7199), 1,
      anon_sym_LBRACE,
    STATE(786), 1,
      sym_class_body,
    STATE(5726), 1,
      sym_comment,
  [198337] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(5727), 1,
      sym_comment,
    STATE(5805), 1,
      sym_statement_block,
  [198353] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5728), 1,
      sym_comment,
    ACTIONS(5520), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [198367] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5729), 1,
      sym_comment,
    ACTIONS(9558), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [198381] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2585), 1,
      anon_sym_LBRACE,
    STATE(763), 1,
      sym_statement_block,
    STATE(5730), 1,
      sym_comment,
  [198397] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7197), 1,
      anon_sym_LBRACE,
    STATE(2973), 1,
      sym_class_body,
    STATE(5731), 1,
      sym_comment,
  [198413] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7015), 1,
      anon_sym_LBRACE,
    STATE(2576), 1,
      sym_class_body,
    STATE(5732), 1,
      sym_comment,
  [198429] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7197), 1,
      anon_sym_LBRACE,
    STATE(2981), 1,
      sym_class_body,
    STATE(5733), 1,
      sym_comment,
  [198445] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2193), 1,
      sym_statement_block,
    STATE(5734), 1,
      sym_comment,
  [198461] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4713), 1,
      anon_sym_LBRACE,
    STATE(2569), 1,
      sym_statement_block,
    STATE(5735), 1,
      sym_comment,
  [198477] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2185), 1,
      sym_statement_block,
    STATE(5736), 1,
      sym_comment,
  [198493] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5737), 1,
      sym_comment,
    ACTIONS(9560), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [198507] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5738), 1,
      sym_comment,
    ACTIONS(9562), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [198521] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9564), 1,
      anon_sym_SEMI,
    ACTIONS(9566), 1,
      sym__automatic_semicolon,
    STATE(5739), 1,
      sym_comment,
  [198537] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7157), 1,
      anon_sym_LBRACE,
    STATE(2885), 1,
      sym_class_body,
    STATE(5740), 1,
      sym_comment,
  [198553] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7157), 1,
      anon_sym_LBRACE,
    STATE(2888), 1,
      sym_class_body,
    STATE(5741), 1,
      sym_comment,
  [198569] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7033), 1,
      anon_sym_LBRACE,
    STATE(2057), 1,
      sym_class_body,
    STATE(5742), 1,
      sym_comment,
  [198585] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5743), 1,
      sym_comment,
    ACTIONS(9568), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [198599] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5744), 1,
      sym_comment,
    ACTIONS(8667), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [198613] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(5745), 1,
      sym_comment,
    STATE(5834), 1,
      sym_statement_block,
  [198629] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1820), 1,
      anon_sym_LBRACE,
    STATE(238), 1,
      sym_statement_block,
    STATE(5746), 1,
      sym_comment,
  [198645] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7229), 1,
      anon_sym_LBRACE,
    STATE(853), 1,
      sym_class_body,
    STATE(5747), 1,
      sym_comment,
  [198661] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5748), 1,
      sym_comment,
    ACTIONS(5615), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [198675] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7171), 1,
      anon_sym_LBRACE,
    STATE(250), 1,
      sym_class_body,
    STATE(5749), 1,
      sym_comment,
  [198691] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5750), 1,
      sym_comment,
    ACTIONS(9570), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [198705] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7033), 1,
      anon_sym_LBRACE,
    STATE(2762), 1,
      sym_class_body,
    STATE(5751), 1,
      sym_comment,
  [198721] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7033), 1,
      anon_sym_LBRACE,
    STATE(2765), 1,
      sym_class_body,
    STATE(5752), 1,
      sym_comment,
  [198737] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7171), 1,
      anon_sym_LBRACE,
    STATE(244), 1,
      sym_class_body,
    STATE(5753), 1,
      sym_comment,
  [198753] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7033), 1,
      anon_sym_LBRACE,
    STATE(2006), 1,
      sym_class_body,
    STATE(5754), 1,
      sym_comment,
  [198769] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7015), 1,
      anon_sym_LBRACE,
    STATE(2564), 1,
      sym_class_body,
    STATE(5755), 1,
      sym_comment,
  [198785] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    STATE(3787), 1,
      sym_formal_parameters,
    STATE(5756), 1,
      sym_comment,
  [198801] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7197), 1,
      anon_sym_LBRACE,
    STATE(3022), 1,
      sym_class_body,
    STATE(5757), 1,
      sym_comment,
  [198817] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(5758), 1,
      sym_comment,
    STATE(6012), 1,
      sym_formal_parameters,
  [198833] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4713), 1,
      anon_sym_LBRACE,
    STATE(2562), 1,
      sym_statement_block,
    STATE(5759), 1,
      sym_comment,
  [198849] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2180), 1,
      sym_statement_block,
    STATE(5760), 1,
      sym_comment,
  [198865] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7015), 1,
      anon_sym_LBRACE,
    STATE(2557), 1,
      sym_class_body,
    STATE(5761), 1,
      sym_comment,
  [198881] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9572), 1,
      anon_sym_SEMI,
    ACTIONS(9574), 1,
      sym__automatic_semicolon,
    STATE(5762), 1,
      sym_comment,
  [198897] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5763), 1,
      sym_comment,
    ACTIONS(9576), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [198911] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5764), 1,
      sym_comment,
    ACTIONS(9578), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [198925] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2179), 1,
      sym_statement_block,
    STATE(5765), 1,
      sym_comment,
  [198941] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7157), 1,
      anon_sym_LBRACE,
    STATE(2905), 1,
      sym_class_body,
    STATE(5766), 1,
      sym_comment,
  [198957] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5767), 1,
      sym_comment,
    ACTIONS(9580), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [198971] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9582), 1,
      anon_sym_SEMI,
    ACTIONS(9584), 1,
      sym__automatic_semicolon,
    STATE(5768), 1,
      sym_comment,
  [198987] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7033), 1,
      anon_sym_LBRACE,
    STATE(2047), 1,
      sym_class_body,
    STATE(5769), 1,
      sym_comment,
  [199003] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7033), 1,
      anon_sym_LBRACE,
    STATE(2039), 1,
      sym_class_body,
    STATE(5770), 1,
      sym_comment,
  [199019] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5771), 1,
      sym_comment,
    ACTIONS(9586), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [199033] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5772), 1,
      sym_comment,
    ACTIONS(9588), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [199047] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9590), 1,
      sym_identifier,
    ACTIONS(9592), 1,
      sym_private_property_identifier,
    STATE(5773), 1,
      sym_comment,
  [199063] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5774), 1,
      sym_comment,
    ACTIONS(8728), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [199077] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7015), 1,
      anon_sym_LBRACE,
    STATE(2433), 1,
      sym_class_body,
    STATE(5775), 1,
      sym_comment,
  [199093] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9594), 1,
      sym_identifier,
    ACTIONS(9596), 1,
      sym_private_property_identifier,
    STATE(5776), 1,
      sym_comment,
  [199109] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9598), 1,
      sym_identifier,
    ACTIONS(9600), 1,
      sym_private_property_identifier,
    STATE(5777), 1,
      sym_comment,
  [199125] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9602), 1,
      sym_identifier,
    ACTIONS(9604), 1,
      sym_private_property_identifier,
    STATE(5778), 1,
      sym_comment,
  [199141] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9236), 1,
      sym_identifier,
    ACTIONS(9240), 1,
      sym_private_property_identifier,
    STATE(5779), 1,
      sym_comment,
  [199157] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(4618), 1,
      sym_statement_block,
    STATE(5780), 1,
      sym_comment,
  [199173] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5040), 1,
      anon_sym_LBRACE,
    STATE(2020), 1,
      sym_statement_block,
    STATE(5781), 1,
      sym_comment,
  [199189] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5040), 1,
      anon_sym_LBRACE,
    STATE(2017), 1,
      sym_statement_block,
    STATE(5782), 1,
      sym_comment,
  [199205] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5040), 1,
      anon_sym_LBRACE,
    STATE(2016), 1,
      sym_statement_block,
    STATE(5783), 1,
      sym_comment,
  [199221] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5784), 1,
      sym_comment,
    ACTIONS(9606), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [199235] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8359), 1,
      anon_sym_from,
    STATE(5785), 1,
      sym_comment,
    STATE(5799), 1,
      sym__from_clause,
  [199251] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7033), 1,
      anon_sym_LBRACE,
    STATE(2011), 1,
      sym_class_body,
    STATE(5786), 1,
      sym_comment,
  [199267] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2163), 1,
      sym_statement_block,
    STATE(5787), 1,
      sym_comment,
  [199283] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7015), 1,
      anon_sym_LBRACE,
    STATE(2532), 1,
      sym_class_body,
    STATE(5788), 1,
      sym_comment,
  [199299] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8359), 1,
      anon_sym_from,
    STATE(4740), 1,
      sym__from_clause,
    STATE(5789), 1,
      sym_comment,
  [199315] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4713), 1,
      anon_sym_LBRACE,
    STATE(2463), 1,
      sym_statement_block,
    STATE(5790), 1,
      sym_comment,
  [199331] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5791), 1,
      sym_comment,
    ACTIONS(9608), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [199345] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9610), 1,
      anon_sym_LPAREN,
    STATE(2801), 1,
      sym_parenthesized_expression,
    STATE(5792), 1,
      sym_comment,
  [199361] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7199), 1,
      anon_sym_LBRACE,
    STATE(761), 1,
      sym_class_body,
    STATE(5793), 1,
      sym_comment,
  [199377] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9612), 1,
      anon_sym_LBRACE,
    STATE(2968), 1,
      sym_enum_body,
    STATE(5794), 1,
      sym_comment,
  [199393] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5795), 1,
      sym_comment,
    ACTIONS(8350), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [199407] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5796), 1,
      sym_comment,
    ACTIONS(9614), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [199421] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2159), 1,
      sym_statement_block,
    STATE(5797), 1,
      sym_comment,
  [199437] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9616), 1,
      anon_sym_SEMI,
    ACTIONS(9618), 1,
      sym__automatic_semicolon,
    STATE(5798), 1,
      sym_comment,
  [199453] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9620), 1,
      anon_sym_SEMI,
    ACTIONS(9622), 1,
      sym__automatic_semicolon,
    STATE(5799), 1,
      sym_comment,
  [199469] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9624), 1,
      anon_sym_SEMI,
    ACTIONS(9626), 1,
      sym__automatic_semicolon,
    STATE(5800), 1,
      sym_comment,
  [199485] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8101), 1,
      anon_sym_LBRACE,
    STATE(759), 1,
      sym_statement_block,
    STATE(5801), 1,
      sym_comment,
  [199501] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8101), 1,
      anon_sym_LBRACE,
    STATE(785), 1,
      sym_statement_block,
    STATE(5802), 1,
      sym_comment,
  [199517] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    STATE(2003), 1,
      sym_arguments,
    STATE(5803), 1,
      sym_comment,
  [199533] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7199), 1,
      anon_sym_LBRACE,
    STATE(783), 1,
      sym_class_body,
    STATE(5804), 1,
      sym_comment,
  [199549] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5805), 1,
      sym_comment,
    ACTIONS(5473), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [199563] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4197), 1,
      sym_formal_parameters,
    STATE(5806), 1,
      sym_comment,
  [199579] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9628), 1,
      anon_sym_SEMI,
    ACTIONS(9630), 1,
      sym__automatic_semicolon,
    STATE(5807), 1,
      sym_comment,
  [199595] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(5808), 1,
      sym_comment,
    STATE(6021), 1,
      sym_formal_parameters,
  [199611] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5809), 1,
      sym_comment,
    ACTIONS(8851), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [199625] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9632), 1,
      sym_identifier,
    ACTIONS(9634), 1,
      sym_private_property_identifier,
    STATE(5810), 1,
      sym_comment,
  [199641] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9636), 1,
      sym_identifier,
    ACTIONS(9638), 1,
      sym_private_property_identifier,
    STATE(5811), 1,
      sym_comment,
  [199657] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9640), 1,
      sym_identifier,
    ACTIONS(9642), 1,
      sym_private_property_identifier,
    STATE(5812), 1,
      sym_comment,
  [199673] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5813), 1,
      sym_comment,
    ACTIONS(9644), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [199687] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5814), 1,
      sym_comment,
    ACTIONS(9646), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [199701] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5815), 1,
      sym_comment,
    ACTIONS(8905), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [199715] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5040), 1,
      anon_sym_LBRACE,
    STATE(1969), 1,
      sym_statement_block,
    STATE(5816), 1,
      sym_comment,
  [199731] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5040), 1,
      anon_sym_LBRACE,
    STATE(1968), 1,
      sym_statement_block,
    STATE(5817), 1,
      sym_comment,
  [199747] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5040), 1,
      anon_sym_LBRACE,
    STATE(1960), 1,
      sym_statement_block,
    STATE(5818), 1,
      sym_comment,
  [199763] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7033), 1,
      anon_sym_LBRACE,
    STATE(1954), 1,
      sym_class_body,
    STATE(5819), 1,
      sym_comment,
  [199779] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7033), 1,
      anon_sym_LBRACE,
    STATE(1948), 1,
      sym_class_body,
    STATE(5820), 1,
      sym_comment,
  [199795] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(4664), 1,
      sym_statement_block,
    STATE(5821), 1,
      sym_comment,
  [199811] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2585), 1,
      anon_sym_LBRACE,
    STATE(809), 1,
      sym_statement_block,
    STATE(5822), 1,
      sym_comment,
  [199827] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5823), 1,
      sym_comment,
    ACTIONS(1800), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [199841] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5824), 1,
      sym_comment,
    ACTIONS(7043), 2,
      anon_sym_in,
      anon_sym_of,
  [199855] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(5723), 1,
      sym_statement_block,
    STATE(5825), 1,
      sym_comment,
  [199871] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2120), 1,
      sym_statement_block,
    STATE(5826), 1,
      sym_comment,
  [199887] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9612), 1,
      anon_sym_LBRACE,
    STATE(2936), 1,
      sym_enum_body,
    STATE(5827), 1,
      sym_comment,
  [199903] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8359), 1,
      anon_sym_from,
    STATE(4717), 1,
      sym__from_clause,
    STATE(5828), 1,
      sym_comment,
  [199919] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(821), 1,
      sym_statement_block,
    STATE(5829), 1,
      sym_comment,
  [199935] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5830), 1,
      sym_comment,
    ACTIONS(5386), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [199949] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5831), 1,
      sym_comment,
    ACTIONS(5390), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [199963] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5832), 1,
      sym_comment,
    ACTIONS(9648), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [199977] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5833), 1,
      sym_comment,
    ACTIONS(9650), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [199991] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5834), 1,
      sym_comment,
    ACTIONS(5477), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [200005] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9366), 1,
      anon_sym_LPAREN,
    STATE(43), 1,
      sym__for_header,
    STATE(5835), 1,
      sym_comment,
  [200021] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(1820), 1,
      anon_sym_LBRACE,
    STATE(228), 1,
      sym_statement_block,
    STATE(5836), 1,
      sym_comment,
  [200037] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(5837), 1,
      sym_comment,
    STATE(5935), 1,
      sym_statement_block,
  [200053] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7229), 1,
      anon_sym_LBRACE,
    STATE(872), 1,
      sym_class_body,
    STATE(5838), 1,
      sym_comment,
  [200069] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8695), 1,
      sym_identifier,
    ACTIONS(8699), 1,
      sym_private_property_identifier,
    STATE(5839), 1,
      sym_comment,
  [200085] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(4611), 1,
      sym_formal_parameters,
    STATE(5840), 1,
      sym_comment,
  [200101] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9652), 1,
      sym_identifier,
    ACTIONS(9654), 1,
      sym_private_property_identifier,
    STATE(5841), 1,
      sym_comment,
  [200117] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5842), 1,
      sym_comment,
    ACTIONS(9656), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [200131] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7171), 1,
      anon_sym_LBRACE,
    STATE(253), 1,
      sym_class_body,
    STATE(5843), 1,
      sym_comment,
  [200147] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(5844), 1,
      sym_comment,
    STATE(6056), 1,
      sym_formal_parameters,
  [200163] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9658), 1,
      sym_identifier,
    STATE(5097), 1,
      sym_nested_identifier,
    STATE(5845), 1,
      sym_comment,
  [200179] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(5846), 1,
      sym_comment,
    STATE(6105), 1,
      sym_formal_parameters,
  [200195] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9660), 1,
      sym_identifier,
    STATE(5377), 1,
      sym_nested_identifier,
    STATE(5847), 1,
      sym_comment,
  [200211] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7229), 1,
      anon_sym_LBRACE,
    STATE(849), 1,
      sym_class_body,
    STATE(5848), 1,
      sym_comment,
  [200227] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7033), 1,
      anon_sym_LBRACE,
    STATE(2777), 1,
      sym_class_body,
    STATE(5849), 1,
      sym_comment,
  [200243] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(2841), 1,
      sym_statement_block,
    STATE(5850), 1,
      sym_comment,
  [200259] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9662), 1,
      anon_sym_in,
    ACTIONS(9664), 1,
      anon_sym_COLON,
    STATE(5851), 1,
      sym_comment,
  [200275] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(5852), 1,
      sym_comment,
    STATE(6112), 1,
      sym_formal_parameters,
  [200291] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5853), 1,
      sym_comment,
    ACTIONS(8801), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [200305] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5040), 1,
      anon_sym_LBRACE,
    STATE(2078), 1,
      sym_statement_block,
    STATE(5854), 1,
      sym_comment,
  [200321] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2098), 1,
      sym_statement_block,
    STATE(5855), 1,
      sym_comment,
  [200337] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2182), 1,
      sym_statement_block,
    STATE(5856), 1,
      sym_comment,
  [200353] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8359), 1,
      anon_sym_from,
    STATE(5671), 1,
      sym__from_clause,
    STATE(5857), 1,
      sym_comment,
  [200369] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7033), 1,
      anon_sym_LBRACE,
    STATE(2088), 1,
      sym_class_body,
    STATE(5858), 1,
      sym_comment,
  [200385] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2183), 1,
      sym_statement_block,
    STATE(5859), 1,
      sym_comment,
  [200401] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9666), 1,
      anon_sym_LBRACE,
    STATE(844), 1,
      sym_switch_body,
    STATE(5860), 1,
      sym_comment,
  [200417] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6766), 1,
      anon_sym_LPAREN,
    STATE(5861), 1,
      sym_comment,
    STATE(6110), 1,
      sym_formal_parameters,
  [200433] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5862), 1,
      sym_comment,
    ACTIONS(9668), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [200447] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9324), 1,
      anon_sym_LPAREN,
    STATE(55), 1,
      sym_parenthesized_expression,
    STATE(5863), 1,
      sym_comment,
  [200463] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2165), 1,
      sym_statement_block,
    STATE(5864), 1,
      sym_comment,
  [200479] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5865), 1,
      sym_comment,
    ACTIONS(9670), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [200493] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7199), 1,
      anon_sym_LBRACE,
    STATE(778), 1,
      sym_class_body,
    STATE(5866), 1,
      sym_comment,
  [200509] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(3061), 1,
      anon_sym_LPAREN,
    STATE(3520), 1,
      sym_formal_parameters,
    STATE(5867), 1,
      sym_comment,
  [200525] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5868), 1,
      sym_comment,
    ACTIONS(5388), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [200539] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5869), 1,
      sym_comment,
    ACTIONS(9672), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [200553] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5870), 1,
      sym_comment,
    ACTIONS(9674), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [200567] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5871), 1,
      sym_comment,
    ACTIONS(5193), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [200581] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2585), 1,
      anon_sym_LBRACE,
    STATE(722), 1,
      sym_statement_block,
    STATE(5872), 1,
      sym_comment,
  [200597] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9324), 1,
      anon_sym_LPAREN,
    STATE(32), 1,
      sym_parenthesized_expression,
    STATE(5873), 1,
      sym_comment,
  [200613] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9324), 1,
      anon_sym_LPAREN,
    STATE(33), 1,
      sym_parenthesized_expression,
    STATE(5874), 1,
      sym_comment,
  [200629] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8161), 1,
      anon_sym_in,
    ACTIONS(8163), 1,
      anon_sym_of,
    STATE(5875), 1,
      sym_comment,
  [200645] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5876), 1,
      sym_comment,
    ACTIONS(5396), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [200659] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5877), 1,
      sym_comment,
    ACTIONS(5285), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [200673] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5878), 1,
      sym_comment,
    ACTIONS(5336), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [200687] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5879), 1,
      sym_comment,
    ACTIONS(5477), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [200701] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5880), 1,
      sym_comment,
    ACTIONS(5574), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [200715] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5881), 1,
      sym_comment,
    ACTIONS(5607), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [200729] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5882), 1,
      sym_comment,
    ACTIONS(5529), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [200743] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5883), 1,
      sym_comment,
    ACTIONS(5601), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [200757] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5884), 1,
      sym_comment,
    ACTIONS(5595), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [200771] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5885), 1,
      sym_comment,
    ACTIONS(5473), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [200785] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5886), 1,
      sym_comment,
    ACTIONS(5520), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [200799] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5887), 1,
      sym_comment,
    ACTIONS(6325), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [200813] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5888), 1,
      sym_comment,
    ACTIONS(6393), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [200827] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5889), 1,
      sym_comment,
    ACTIONS(5637), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [200841] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5890), 1,
      sym_comment,
    ACTIONS(6262), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [200855] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5891), 1,
      sym_comment,
    ACTIONS(6300), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [200869] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5892), 1,
      sym_comment,
    ACTIONS(6288), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [200883] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5893), 1,
      sym_comment,
    ACTIONS(6268), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [200897] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2104), 1,
      sym_statement_block,
    STATE(5894), 1,
      sym_comment,
  [200913] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2132), 1,
      sym_statement_block,
    STATE(5895), 1,
      sym_comment,
  [200929] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5896), 1,
      sym_comment,
    ACTIONS(5591), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [200943] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(5889), 1,
      sym_statement_block,
    STATE(5897), 1,
      sym_comment,
  [200959] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5898), 1,
      sym_comment,
    ACTIONS(5469), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [200973] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2219), 1,
      sym_statement_block,
    STATE(5899), 1,
      sym_comment,
  [200989] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2196), 1,
      sym_statement_block,
    STATE(5900), 1,
      sym_comment,
  [201005] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2151), 1,
      sym_statement_block,
    STATE(5901), 1,
      sym_comment,
  [201021] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2148), 1,
      sym_statement_block,
    STATE(5902), 1,
      sym_comment,
  [201037] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2145), 1,
      sym_statement_block,
    STATE(5903), 1,
      sym_comment,
  [201053] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(5896), 1,
      sym_statement_block,
    STATE(5904), 1,
      sym_comment,
  [201069] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5905), 1,
      sym_comment,
    ACTIONS(5657), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [201083] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(5898), 1,
      sym_statement_block,
    STATE(5906), 1,
      sym_comment,
  [201099] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5907), 1,
      sym_comment,
    ACTIONS(5574), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [201113] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2143), 1,
      sym_statement_block,
    STATE(5908), 1,
      sym_comment,
  [201129] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2144), 1,
      sym_statement_block,
    STATE(5909), 1,
      sym_comment,
  [201145] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2226), 1,
      sym_statement_block,
    STATE(5910), 1,
      sym_comment,
  [201161] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2210), 1,
      sym_statement_block,
    STATE(5911), 1,
      sym_comment,
  [201177] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2213), 1,
      sym_statement_block,
    STATE(5912), 1,
      sym_comment,
  [201193] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2224), 1,
      sym_statement_block,
    STATE(5913), 1,
      sym_comment,
  [201209] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2091), 1,
      sym_statement_block,
    STATE(5914), 1,
      sym_comment,
  [201225] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2157), 1,
      sym_statement_block,
    STATE(5915), 1,
      sym_comment,
  [201241] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2192), 1,
      sym_statement_block,
    STATE(5916), 1,
      sym_comment,
  [201257] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2195), 1,
      sym_statement_block,
    STATE(5917), 1,
      sym_comment,
  [201273] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(5905), 1,
      sym_statement_block,
    STATE(5918), 1,
      sym_comment,
  [201289] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5919), 1,
      sym_comment,
    ACTIONS(5607), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [201303] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(5907), 1,
      sym_statement_block,
    STATE(5920), 1,
      sym_comment,
  [201319] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5921), 1,
      sym_comment,
    ACTIONS(5529), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [201333] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2184), 1,
      sym_statement_block,
    STATE(5922), 1,
      sym_comment,
  [201349] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2092), 1,
      sym_statement_block,
    STATE(5923), 1,
      sym_comment,
  [201365] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2094), 1,
      sym_statement_block,
    STATE(5924), 1,
      sym_comment,
  [201381] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2102), 1,
      sym_statement_block,
    STATE(5925), 1,
      sym_comment,
  [201397] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2107), 1,
      sym_statement_block,
    STATE(5926), 1,
      sym_comment,
  [201413] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2109), 1,
      sym_statement_block,
    STATE(5927), 1,
      sym_comment,
  [201429] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2155), 1,
      sym_statement_block,
    STATE(5928), 1,
      sym_comment,
  [201445] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2160), 1,
      sym_statement_block,
    STATE(5929), 1,
      sym_comment,
  [201461] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7367), 1,
      anon_sym_LBRACE,
    STATE(2189), 1,
      sym_statement_block,
    STATE(5930), 1,
      sym_comment,
  [201477] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(2837), 1,
      sym_statement_block,
    STATE(5931), 1,
      sym_comment,
  [201493] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7229), 1,
      anon_sym_LBRACE,
    STATE(805), 1,
      sym_class_body,
    STATE(5932), 1,
      sym_comment,
  [201509] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5933), 1,
      sym_comment,
    ACTIONS(9676), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [201523] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(5919), 1,
      sym_statement_block,
    STATE(5934), 1,
      sym_comment,
  [201539] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    STATE(5935), 1,
      sym_comment,
    ACTIONS(5601), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [201553] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4351), 1,
      anon_sym_LBRACE,
    STATE(5921), 1,
      sym_statement_block,
    STATE(5936), 1,
      sym_comment,
  [201569] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9678), 1,
      anon_sym_RBRACK,
    STATE(5937), 1,
      sym_comment,
  [201582] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9680), 1,
      sym_identifier,
    STATE(5938), 1,
      sym_comment,
  [201595] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9682), 1,
      anon_sym_EQ,
    STATE(5939), 1,
      sym_comment,
  [201608] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9684), 1,
      anon_sym_EQ_GT,
    STATE(5940), 1,
      sym_comment,
  [201621] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9686), 1,
      anon_sym_EQ_GT,
    STATE(5941), 1,
      sym_comment,
  [201634] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9688), 1,
      anon_sym_EQ_GT,
    STATE(5942), 1,
      sym_comment,
  [201647] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9690), 1,
      anon_sym_RPAREN,
    STATE(5943), 1,
      sym_comment,
  [201660] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9692), 1,
      anon_sym_RPAREN,
    STATE(5944), 1,
      sym_comment,
  [201673] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9694), 1,
      anon_sym_RPAREN,
    STATE(5945), 1,
      sym_comment,
  [201686] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9696), 1,
      anon_sym_RPAREN,
    STATE(5946), 1,
      sym_comment,
  [201699] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5847), 1,
      anon_sym_in,
    STATE(5947), 1,
      sym_comment,
  [201712] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9698), 1,
      anon_sym_EQ_GT,
    STATE(5948), 1,
      sym_comment,
  [201725] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2146), 1,
      anon_sym_EQ_GT,
    STATE(5949), 1,
      sym_comment,
  [201738] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9700), 1,
      anon_sym_EQ,
    STATE(5950), 1,
      sym_comment,
  [201751] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5555), 1,
      anon_sym_RPAREN,
    STATE(5951), 1,
      sym_comment,
  [201764] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9702), 1,
      sym_identifier,
    STATE(5952), 1,
      sym_comment,
  [201777] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9704), 1,
      anon_sym_RPAREN,
    STATE(5953), 1,
      sym_comment,
  [201790] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9706), 1,
      anon_sym_from,
    STATE(5954), 1,
      sym_comment,
  [201803] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9708), 1,
      sym_identifier,
    STATE(5955), 1,
      sym_comment,
  [201816] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9710), 1,
      anon_sym_EQ_GT,
    STATE(5956), 1,
      sym_comment,
  [201829] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7486), 1,
      anon_sym_EQ,
    STATE(5957), 1,
      sym_comment,
  [201842] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9712), 1,
      anon_sym_DOT,
    STATE(5958), 1,
      sym_comment,
  [201855] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9714), 1,
      anon_sym_RPAREN,
    STATE(5959), 1,
      sym_comment,
  [201868] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9716), 1,
      sym_regex_pattern,
    STATE(5960), 1,
      sym_comment,
  [201881] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9718), 1,
      anon_sym_RBRACK,
    STATE(5961), 1,
      sym_comment,
  [201894] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9720), 1,
      anon_sym_RBRACK,
    STATE(5962), 1,
      sym_comment,
  [201907] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9722), 1,
      anon_sym_RBRACK,
    STATE(5963), 1,
      sym_comment,
  [201920] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9724), 1,
      sym_identifier,
    STATE(5964), 1,
      sym_comment,
  [201933] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9726), 1,
      sym_identifier,
    STATE(5965), 1,
      sym_comment,
  [201946] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9728), 1,
      anon_sym_RBRACK,
    STATE(5966), 1,
      sym_comment,
  [201959] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9730), 1,
      anon_sym_RBRACK,
    STATE(5967), 1,
      sym_comment,
  [201972] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9732), 1,
      sym_identifier,
    STATE(5968), 1,
      sym_comment,
  [201985] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9734), 1,
      anon_sym_RBRACK,
    STATE(5969), 1,
      sym_comment,
  [201998] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9736), 1,
      sym_identifier,
    STATE(5970), 1,
      sym_comment,
  [202011] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9738), 1,
      anon_sym_RBRACK,
    STATE(5971), 1,
      sym_comment,
  [202024] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9740), 1,
      anon_sym_RBRACK,
    STATE(5972), 1,
      sym_comment,
  [202037] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9742), 1,
      anon_sym_RBRACK,
    STATE(5973), 1,
      sym_comment,
  [202050] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9744), 1,
      anon_sym_EQ_GT,
    STATE(5974), 1,
      sym_comment,
  [202063] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9746), 1,
      sym_identifier,
    STATE(5975), 1,
      sym_comment,
  [202076] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4869), 1,
      anon_sym_RPAREN,
    STATE(5976), 1,
      sym_comment,
  [202089] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9748), 1,
      sym_identifier,
    STATE(5977), 1,
      sym_comment,
  [202102] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6968), 1,
      anon_sym_is,
    STATE(5978), 1,
      sym_comment,
  [202115] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9750), 1,
      sym_identifier,
    STATE(5979), 1,
      sym_comment,
  [202128] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9752), 1,
      anon_sym_EQ_GT,
    STATE(5980), 1,
      sym_comment,
  [202141] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9754), 1,
      anon_sym_EQ_GT,
    STATE(5981), 1,
      sym_comment,
  [202154] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9756), 1,
      anon_sym_target,
    STATE(5982), 1,
      sym_comment,
  [202167] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9758), 1,
      anon_sym_RBRACK,
    STATE(5983), 1,
      sym_comment,
  [202180] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9760), 1,
      anon_sym_EQ,
    STATE(5984), 1,
      sym_comment,
  [202193] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9762), 1,
      sym_identifier,
    STATE(5985), 1,
      sym_comment,
  [202206] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9764), 1,
      anon_sym_COLON,
    STATE(5986), 1,
      sym_comment,
  [202219] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9766), 1,
      sym_identifier,
    STATE(5987), 1,
      sym_comment,
  [202232] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_RPAREN,
    STATE(5988), 1,
      sym_comment,
  [202245] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9770), 1,
      anon_sym_SLASH2,
    STATE(5989), 1,
      sym_comment,
  [202258] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9772), 1,
      sym_number,
    STATE(5990), 1,
      sym_comment,
  [202271] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6107), 1,
      anon_sym_in,
    STATE(5991), 1,
      sym_comment,
  [202284] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9774), 1,
      sym_identifier,
    STATE(5992), 1,
      sym_comment,
  [202297] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9776), 1,
      anon_sym_symbol,
    STATE(5993), 1,
      sym_comment,
  [202310] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7401), 1,
      anon_sym_is,
    STATE(5994), 1,
      sym_comment,
  [202323] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9778), 1,
      anon_sym_EQ_GT,
    STATE(5995), 1,
      sym_comment,
  [202336] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9780), 1,
      anon_sym_EQ_GT,
    STATE(5996), 1,
      sym_comment,
  [202349] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9782), 1,
      anon_sym_EQ_GT,
    STATE(5997), 1,
      sym_comment,
  [202362] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9784), 1,
      sym_identifier,
    STATE(5998), 1,
      sym_comment,
  [202375] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9786), 1,
      sym_identifier,
    STATE(5999), 1,
      sym_comment,
  [202388] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9788), 1,
      sym_identifier,
    STATE(6000), 1,
      sym_comment,
  [202401] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9790), 1,
      sym_identifier,
    STATE(6001), 1,
      sym_comment,
  [202414] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9792), 1,
      sym_identifier,
    STATE(6002), 1,
      sym_comment,
  [202427] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5639), 1,
      anon_sym_RPAREN,
    STATE(6003), 1,
      sym_comment,
  [202440] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5641), 1,
      anon_sym_RPAREN,
    STATE(6004), 1,
      sym_comment,
  [202453] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5653), 1,
      anon_sym_RPAREN,
    STATE(6005), 1,
      sym_comment,
  [202466] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9794), 1,
      anon_sym_RPAREN,
    STATE(6006), 1,
      sym_comment,
  [202479] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9796), 1,
      sym_identifier,
    STATE(6007), 1,
      sym_comment,
  [202492] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9798), 1,
      anon_sym_from,
    STATE(6008), 1,
      sym_comment,
  [202505] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8656), 1,
      anon_sym_RBRACK,
    STATE(6009), 1,
      sym_comment,
  [202518] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9800), 1,
      anon_sym_EQ_GT,
    STATE(6010), 1,
      sym_comment,
  [202531] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9802), 1,
      anon_sym_EQ_GT,
    STATE(6011), 1,
      sym_comment,
  [202544] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9804), 1,
      anon_sym_EQ_GT,
    STATE(6012), 1,
      sym_comment,
  [202557] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9806), 1,
      anon_sym_EQ_GT,
    STATE(6013), 1,
      sym_comment,
  [202570] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9808), 1,
      sym_identifier,
    STATE(6014), 1,
      sym_comment,
  [202583] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5551), 1,
      anon_sym_RBRACK,
    STATE(6015), 1,
      sym_comment,
  [202596] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9810), 1,
      sym_identifier,
    STATE(6016), 1,
      sym_comment,
  [202609] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9812), 1,
      anon_sym_while,
    STATE(6017), 1,
      sym_comment,
  [202622] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9814), 1,
      sym_identifier,
    STATE(6018), 1,
      sym_comment,
  [202635] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9816), 1,
      sym_identifier,
    STATE(6019), 1,
      sym_comment,
  [202648] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9818), 1,
      anon_sym_EQ_GT,
    STATE(6020), 1,
      sym_comment,
  [202661] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9820), 1,
      anon_sym_EQ_GT,
    STATE(6021), 1,
      sym_comment,
  [202674] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9822), 1,
      anon_sym_EQ_GT,
    STATE(6022), 1,
      sym_comment,
  [202687] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5617), 1,
      anon_sym_RBRACK,
    STATE(6023), 1,
      sym_comment,
  [202700] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9824), 1,
      anon_sym_RBRACK,
    STATE(6024), 1,
      sym_comment,
  [202713] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9826), 1,
      anon_sym_RBRACK,
    STATE(6025), 1,
      sym_comment,
  [202726] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9828), 1,
      anon_sym_RBRACK,
    STATE(6026), 1,
      sym_comment,
  [202739] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9830), 1,
      anon_sym_RBRACK,
    STATE(6027), 1,
      sym_comment,
  [202752] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9832), 1,
      anon_sym_RBRACK,
    STATE(6028), 1,
      sym_comment,
  [202765] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9834), 1,
      anon_sym_RBRACK,
    STATE(6029), 1,
      sym_comment,
  [202778] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9836), 1,
      anon_sym_RBRACK,
    STATE(6030), 1,
      sym_comment,
  [202791] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9838), 1,
      anon_sym_RBRACK,
    STATE(6031), 1,
      sym_comment,
  [202804] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9840), 1,
      anon_sym_RBRACK,
    STATE(6032), 1,
      sym_comment,
  [202817] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9842), 1,
      anon_sym_RBRACK,
    STATE(6033), 1,
      sym_comment,
  [202830] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9844), 1,
      anon_sym_RPAREN,
    STATE(6034), 1,
      sym_comment,
  [202843] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9846), 1,
      anon_sym_EQ_GT,
    STATE(6035), 1,
      sym_comment,
  [202856] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9848), 1,
      anon_sym_RBRACK,
    STATE(6036), 1,
      sym_comment,
  [202869] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9850), 1,
      anon_sym_RBRACK,
    STATE(6037), 1,
      sym_comment,
  [202882] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9852), 1,
      anon_sym_RBRACK,
    STATE(6038), 1,
      sym_comment,
  [202895] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9854), 1,
      anon_sym_RBRACK,
    STATE(6039), 1,
      sym_comment,
  [202908] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5564), 1,
      anon_sym_COLON,
    STATE(6040), 1,
      sym_comment,
  [202921] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9856), 1,
      anon_sym_RBRACK,
    STATE(6041), 1,
      sym_comment,
  [202934] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9858), 1,
      anon_sym_RBRACK,
    STATE(6042), 1,
      sym_comment,
  [202947] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9860), 1,
      anon_sym_RBRACK,
    STATE(6043), 1,
      sym_comment,
  [202960] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9862), 1,
      anon_sym_COLON,
    STATE(6044), 1,
      sym_comment,
  [202973] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9864), 1,
      anon_sym_RBRACK,
    STATE(6045), 1,
      sym_comment,
  [202986] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5885), 1,
      anon_sym_in,
    STATE(6046), 1,
      sym_comment,
  [202999] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9866), 1,
      anon_sym_EQ_GT,
    STATE(6047), 1,
      sym_comment,
  [203012] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9868), 1,
      anon_sym_RBRACK,
    STATE(6048), 1,
      sym_comment,
  [203025] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9870), 1,
      anon_sym_EQ,
    STATE(6049), 1,
      sym_comment,
  [203038] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9872), 1,
      anon_sym_EQ_GT,
    STATE(6050), 1,
      sym_comment,
  [203051] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9874), 1,
      anon_sym_EQ_GT,
    STATE(6051), 1,
      sym_comment,
  [203064] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9876), 1,
      anon_sym_EQ_GT,
    STATE(6052), 1,
      sym_comment,
  [203077] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9878), 1,
      anon_sym_RBRACK,
    STATE(6053), 1,
      sym_comment,
  [203090] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9880), 1,
      anon_sym_from,
    STATE(6054), 1,
      sym_comment,
  [203103] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9882), 1,
      anon_sym_RBRACK,
    STATE(6055), 1,
      sym_comment,
  [203116] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9884), 1,
      anon_sym_EQ_GT,
    STATE(6056), 1,
      sym_comment,
  [203129] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9886), 1,
      anon_sym_LPAREN,
    STATE(6057), 1,
      sym_comment,
  [203142] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9888), 1,
      anon_sym_from,
    STATE(6058), 1,
      sym_comment,
  [203155] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9890), 1,
      sym_identifier,
    STATE(6059), 1,
      sym_comment,
  [203168] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9892), 1,
      anon_sym_EQ,
    STATE(6060), 1,
      sym_comment,
  [203181] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9894), 1,
      anon_sym_as,
    STATE(6061), 1,
      sym_comment,
  [203194] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9896), 1,
      sym_identifier,
    STATE(6062), 1,
      sym_comment,
  [203207] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5581), 1,
      anon_sym_RPAREN,
    STATE(6063), 1,
      sym_comment,
  [203220] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9898), 1,
      anon_sym_require,
    STATE(6064), 1,
      sym_comment,
  [203233] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9900), 1,
      anon_sym_from,
    STATE(6065), 1,
      sym_comment,
  [203246] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9902), 1,
      anon_sym_DOT,
    STATE(6066), 1,
      sym_comment,
  [203259] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9904), 1,
      anon_sym_RBRACK,
    STATE(6067), 1,
      sym_comment,
  [203272] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9906), 1,
      sym_regex_pattern,
    STATE(6068), 1,
      sym_comment,
  [203285] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9908), 1,
      anon_sym_RBRACK,
    STATE(6069), 1,
      sym_comment,
  [203298] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9910), 1,
      anon_sym_RBRACK,
    STATE(6070), 1,
      sym_comment,
  [203311] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9912), 1,
      sym_regex_pattern,
    STATE(6071), 1,
      sym_comment,
  [203324] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9914), 1,
      anon_sym_RBRACK,
    STATE(6072), 1,
      sym_comment,
  [203337] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9916), 1,
      anon_sym_RBRACK,
    STATE(6073), 1,
      sym_comment,
  [203350] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9918), 1,
      anon_sym_RBRACK,
    STATE(6074), 1,
      sym_comment,
  [203363] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9920), 1,
      anon_sym_from,
    STATE(6075), 1,
      sym_comment,
  [203376] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9922), 1,
      anon_sym_DOT,
    STATE(6076), 1,
      sym_comment,
  [203389] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9924), 1,
      anon_sym_RBRACK,
    STATE(6077), 1,
      sym_comment,
  [203402] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9926), 1,
      anon_sym_RBRACK,
    STATE(6078), 1,
      sym_comment,
  [203415] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9928), 1,
      anon_sym_RBRACK,
    STATE(6079), 1,
      sym_comment,
  [203428] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9930), 1,
      anon_sym_RBRACK,
    STATE(6080), 1,
      sym_comment,
  [203441] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9932), 1,
      anon_sym_EQ_GT,
    STATE(6081), 1,
      sym_comment,
  [203454] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8208), 1,
      anon_sym_EQ,
    STATE(6082), 1,
      sym_comment,
  [203467] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9934), 1,
      sym_identifier,
    STATE(6083), 1,
      sym_comment,
  [203480] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9936), 1,
      sym_identifier,
    STATE(6084), 1,
      sym_comment,
  [203493] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9938), 1,
      sym_number,
    STATE(6085), 1,
      sym_comment,
  [203506] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4875), 1,
      anon_sym_RPAREN,
    STATE(6086), 1,
      sym_comment,
  [203519] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9940), 1,
      anon_sym_EQ_GT,
    STATE(6087), 1,
      sym_comment,
  [203532] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9942), 1,
      anon_sym_EQ_GT,
    STATE(6088), 1,
      sym_comment,
  [203545] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9944), 1,
      anon_sym_EQ_GT,
    STATE(6089), 1,
      sym_comment,
  [203558] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9946), 1,
      anon_sym_EQ,
    STATE(6090), 1,
      sym_comment,
  [203571] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(6706), 1,
      anon_sym_is,
    STATE(6091), 1,
      sym_comment,
  [203584] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5597), 1,
      anon_sym_RBRACK,
    STATE(6092), 1,
      sym_comment,
  [203597] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9948), 1,
      anon_sym_SLASH2,
    STATE(6093), 1,
      sym_comment,
  [203610] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9950), 1,
      sym_number,
    STATE(6094), 1,
      sym_comment,
  [203623] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9952), 1,
      sym_identifier,
    STATE(6095), 1,
      sym_comment,
  [203636] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9954), 1,
      anon_sym_EQ_GT,
    STATE(6096), 1,
      sym_comment,
  [203649] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9956), 1,
      anon_sym_symbol,
    STATE(6097), 1,
      sym_comment,
  [203662] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9958), 1,
      anon_sym_EQ_GT,
    STATE(6098), 1,
      sym_comment,
  [203675] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9960), 1,
      anon_sym_DOT,
    STATE(6099), 1,
      sym_comment,
  [203688] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9962), 1,
      anon_sym_EQ_GT,
    STATE(6100), 1,
      sym_comment,
  [203701] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9964), 1,
      sym_regex_pattern,
    STATE(6101), 1,
      sym_comment,
  [203714] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9966), 1,
      sym_identifier,
    STATE(6102), 1,
      sym_comment,
  [203727] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9968), 1,
      sym_identifier,
    STATE(6103), 1,
      sym_comment,
  [203740] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4757), 1,
      anon_sym_in,
    STATE(6104), 1,
      sym_comment,
  [203753] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9970), 1,
      anon_sym_EQ_GT,
    STATE(6105), 1,
      sym_comment,
  [203766] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8764), 1,
      anon_sym_RBRACK,
    STATE(6106), 1,
      sym_comment,
  [203779] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9972), 1,
      anon_sym_EQ_GT,
    STATE(6107), 1,
      sym_comment,
  [203792] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9974), 1,
      sym_identifier,
    STATE(6108), 1,
      sym_comment,
  [203805] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9976), 1,
      sym_identifier,
    STATE(6109), 1,
      sym_comment,
  [203818] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9978), 1,
      anon_sym_EQ_GT,
    STATE(6110), 1,
      sym_comment,
  [203831] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9980), 1,
      sym_identifier,
    STATE(6111), 1,
      sym_comment,
  [203844] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9982), 1,
      anon_sym_EQ_GT,
    STATE(6112), 1,
      sym_comment,
  [203857] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9984), 1,
      anon_sym_EQ_GT,
    STATE(6113), 1,
      sym_comment,
  [203870] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5631), 1,
      anon_sym_is,
    STATE(6114), 1,
      sym_comment,
  [203883] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9986), 1,
      anon_sym_RBRACK,
    STATE(6115), 1,
      sym_comment,
  [203896] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9988), 1,
      sym_identifier,
    STATE(6116), 1,
      sym_comment,
  [203909] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9990), 1,
      anon_sym_RBRACK,
    STATE(6117), 1,
      sym_comment,
  [203922] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9992), 1,
      anon_sym_RBRACK,
    STATE(6118), 1,
      sym_comment,
  [203935] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9994), 1,
      anon_sym_LBRACK,
    STATE(6119), 1,
      sym_comment,
  [203948] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9996), 1,
      anon_sym_RBRACK,
    STATE(6120), 1,
      sym_comment,
  [203961] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9998), 1,
      anon_sym_RBRACK,
    STATE(6121), 1,
      sym_comment,
  [203974] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10000), 1,
      anon_sym_RBRACK,
    STATE(6122), 1,
      sym_comment,
  [203987] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10002), 1,
      anon_sym_DOT,
    STATE(6123), 1,
      sym_comment,
  [204000] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10004), 1,
      anon_sym_RBRACK,
    STATE(6124), 1,
      sym_comment,
  [204013] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10006), 1,
      anon_sym_RBRACK,
    STATE(6125), 1,
      sym_comment,
  [204026] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10008), 1,
      anon_sym_RBRACK,
    STATE(6126), 1,
      sym_comment,
  [204039] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10010), 1,
      anon_sym_COLON,
    STATE(6127), 1,
      sym_comment,
  [204052] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10012), 1,
      sym_identifier,
    STATE(6128), 1,
      sym_comment,
  [204065] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10014), 1,
      anon_sym_RBRACK,
    STATE(6129), 1,
      sym_comment,
  [204078] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10016), 1,
      anon_sym_RBRACK,
    STATE(6130), 1,
      sym_comment,
  [204091] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5579), 1,
      anon_sym_RPAREN,
    STATE(6131), 1,
      sym_comment,
  [204104] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10018), 1,
      anon_sym_RBRACK,
    STATE(6132), 1,
      sym_comment,
  [204117] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10020), 1,
      anon_sym_RBRACK,
    STATE(6133), 1,
      sym_comment,
  [204130] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10022), 1,
      sym_identifier,
    STATE(6134), 1,
      sym_comment,
  [204143] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10024), 1,
      anon_sym_RBRACK,
    STATE(6135), 1,
      sym_comment,
  [204156] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10026), 1,
      anon_sym_RBRACK,
    STATE(6136), 1,
      sym_comment,
  [204169] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10028), 1,
      anon_sym_RBRACK,
    STATE(6137), 1,
      sym_comment,
  [204182] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10030), 1,
      anon_sym_RBRACK,
    STATE(6138), 1,
      sym_comment,
  [204195] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10032), 1,
      anon_sym_RBRACK,
    STATE(6139), 1,
      sym_comment,
  [204208] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5704), 1,
      anon_sym_in,
    STATE(6140), 1,
      sym_comment,
  [204221] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10034), 1,
      anon_sym_as,
    STATE(6141), 1,
      sym_comment,
  [204234] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10036), 1,
      anon_sym_from,
    STATE(6142), 1,
      sym_comment,
  [204247] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10038), 1,
      anon_sym_EQ_GT,
    STATE(6143), 1,
      sym_comment,
  [204260] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8849), 1,
      anon_sym_RBRACE,
    STATE(6144), 1,
      sym_comment,
  [204273] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10040), 1,
      anon_sym_EQ,
    STATE(6145), 1,
      sym_comment,
  [204286] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10042), 1,
      sym_identifier,
    STATE(6146), 1,
      sym_comment,
  [204299] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10044), 1,
      sym_identifier,
    STATE(6147), 1,
      sym_comment,
  [204312] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10046), 1,
      anon_sym_RPAREN,
    STATE(6148), 1,
      sym_comment,
  [204325] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10048), 1,
      anon_sym_EQ,
    STATE(6149), 1,
      sym_comment,
  [204338] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10050), 1,
      sym_identifier,
    STATE(6150), 1,
      sym_comment,
  [204351] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10052), 1,
      anon_sym_class,
    STATE(6151), 1,
      sym_comment,
  [204364] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10054), 1,
      sym_identifier,
    STATE(6152), 1,
      sym_comment,
  [204377] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10056), 1,
      anon_sym_EQ_GT,
    STATE(6153), 1,
      sym_comment,
  [204390] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10058), 1,
      anon_sym_EQ_GT,
    STATE(6154), 1,
      sym_comment,
  [204403] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10060), 1,
      anon_sym_EQ_GT,
    STATE(6155), 1,
      sym_comment,
  [204416] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10062), 1,
      anon_sym_RBRACK,
    STATE(6156), 1,
      sym_comment,
  [204429] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10064), 1,
      anon_sym_RBRACK,
    STATE(6157), 1,
      sym_comment,
  [204442] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10066), 1,
      anon_sym_RBRACK,
    STATE(6158), 1,
      sym_comment,
  [204455] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10068), 1,
      anon_sym_EQ,
    STATE(6159), 1,
      sym_comment,
  [204468] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8890), 1,
      anon_sym_RBRACE,
    STATE(6160), 1,
      sym_comment,
  [204481] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10070), 1,
      sym_identifier,
    STATE(6161), 1,
      sym_comment,
  [204494] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5175), 1,
      anon_sym_in,
    STATE(6162), 1,
      sym_comment,
  [204507] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10072), 1,
      anon_sym_EQ,
    STATE(6163), 1,
      sym_comment,
  [204520] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10074), 1,
      anon_sym_EQ_GT,
    STATE(6164), 1,
      sym_comment,
  [204533] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10076), 1,
      anon_sym_new,
    STATE(6165), 1,
      sym_comment,
  [204546] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10078), 1,
      sym_identifier,
    STATE(6166), 1,
      sym_comment,
  [204559] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10080), 1,
      anon_sym_EQ,
    STATE(6167), 1,
      sym_comment,
  [204572] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10082), 1,
      sym_identifier,
    STATE(6168), 1,
      sym_comment,
  [204585] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10084), 1,
      anon_sym_namespace,
    STATE(6169), 1,
      sym_comment,
  [204598] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10086), 1,
      sym_identifier,
    STATE(6170), 1,
      sym_comment,
  [204611] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10088), 1,
      anon_sym_RBRACK,
    STATE(6171), 1,
      sym_comment,
  [204624] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10090), 1,
      anon_sym_EQ_GT,
    STATE(6172), 1,
      sym_comment,
  [204637] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10092), 1,
      anon_sym_EQ_GT,
    STATE(6173), 1,
      sym_comment,
  [204650] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10094), 1,
      anon_sym_EQ_GT,
    STATE(6174), 1,
      sym_comment,
  [204663] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10096), 1,
      anon_sym_EQ,
    STATE(6175), 1,
      sym_comment,
  [204676] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10098), 1,
      anon_sym_SLASH2,
    STATE(6176), 1,
      sym_comment,
  [204689] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10100), 1,
      sym_identifier,
    STATE(6177), 1,
      sym_comment,
  [204702] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10102), 1,
      sym_identifier,
    STATE(6178), 1,
      sym_comment,
  [204715] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9166), 1,
      sym_identifier,
    STATE(6179), 1,
      sym_comment,
  [204728] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10104), 1,
      anon_sym_class,
    STATE(6180), 1,
      sym_comment,
  [204741] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10106), 1,
      sym_number,
    STATE(6181), 1,
      sym_comment,
  [204754] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10108), 1,
      sym_identifier,
    STATE(6182), 1,
      sym_comment,
  [204767] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10110), 1,
      anon_sym_symbol,
    STATE(6183), 1,
      sym_comment,
  [204780] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10112), 1,
      anon_sym_EQ_GT,
    STATE(6184), 1,
      sym_comment,
  [204793] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10114), 1,
      sym_identifier,
    STATE(6185), 1,
      sym_comment,
  [204806] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10116), 1,
      anon_sym_EQ,
    STATE(6186), 1,
      sym_comment,
  [204819] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10118), 1,
      sym_identifier,
    STATE(6187), 1,
      sym_comment,
  [204832] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10120), 1,
      anon_sym_EQ,
    STATE(6188), 1,
      sym_comment,
  [204845] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10122), 1,
      anon_sym_RPAREN,
    STATE(6189), 1,
      sym_comment,
  [204858] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5587), 1,
      anon_sym_RBRACK,
    STATE(6190), 1,
      sym_comment,
  [204871] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10124), 1,
      sym_identifier,
    STATE(6191), 1,
      sym_comment,
  [204884] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5633), 1,
      anon_sym_RBRACE,
    STATE(6192), 1,
      sym_comment,
  [204897] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9080), 1,
      anon_sym_RBRACK,
    STATE(6193), 1,
      sym_comment,
  [204910] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10126), 1,
      anon_sym_EQ_GT,
    STATE(6194), 1,
      sym_comment,
  [204923] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10128), 1,
      anon_sym_EQ_GT,
    STATE(6195), 1,
      sym_comment,
  [204936] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10130), 1,
      anon_sym_EQ_GT,
    STATE(6196), 1,
      sym_comment,
  [204949] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10132), 1,
      anon_sym_COLON,
    STATE(6197), 1,
      sym_comment,
  [204962] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5046), 1,
      anon_sym_RPAREN,
    STATE(6198), 1,
      sym_comment,
  [204975] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10134), 1,
      anon_sym_EQ_GT,
    STATE(6199), 1,
      sym_comment,
  [204988] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10136), 1,
      anon_sym_EQ_GT,
    STATE(6200), 1,
      sym_comment,
  [205001] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10138), 1,
      anon_sym_EQ_GT,
    STATE(6201), 1,
      sym_comment,
  [205014] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4663), 1,
      anon_sym_is,
    STATE(6202), 1,
      sym_comment,
  [205027] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10140), 1,
      anon_sym_RPAREN,
    STATE(6203), 1,
      sym_comment,
  [205040] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8962), 1,
      anon_sym_RBRACK,
    STATE(6204), 1,
      sym_comment,
  [205053] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10142), 1,
      anon_sym_RBRACK,
    STATE(6205), 1,
      sym_comment,
  [205066] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10144), 1,
      anon_sym_new,
    STATE(6206), 1,
      sym_comment,
  [205079] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10146), 1,
      anon_sym_RBRACK,
    STATE(6207), 1,
      sym_comment,
  [205092] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10148), 1,
      anon_sym_RBRACK,
    STATE(6208), 1,
      sym_comment,
  [205105] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10150), 1,
      anon_sym_RBRACK,
    STATE(6209), 1,
      sym_comment,
  [205118] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10152), 1,
      anon_sym_RBRACK,
    STATE(6210), 1,
      sym_comment,
  [205131] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10154), 1,
      anon_sym_LBRACE,
    STATE(6211), 1,
      sym_comment,
  [205144] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10156), 1,
      anon_sym_RBRACK,
    STATE(6212), 1,
      sym_comment,
  [205157] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10158), 1,
      anon_sym_readonly,
    STATE(6213), 1,
      sym_comment,
  [205170] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10160), 1,
      anon_sym_RBRACK,
    STATE(6214), 1,
      sym_comment,
  [205183] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10162), 1,
      anon_sym_RBRACK,
    STATE(6215), 1,
      sym_comment,
  [205196] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10164), 1,
      anon_sym_as,
    STATE(6216), 1,
      sym_comment,
  [205209] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10166), 1,
      anon_sym_class,
    STATE(6217), 1,
      sym_comment,
  [205222] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10168), 1,
      anon_sym_RBRACK,
    STATE(6218), 1,
      sym_comment,
  [205235] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10170), 1,
      anon_sym_EQ_GT,
    STATE(6219), 1,
      sym_comment,
  [205248] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10172), 1,
      sym_identifier,
    STATE(6220), 1,
      sym_comment,
  [205261] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10174), 1,
      anon_sym_RBRACK,
    STATE(6221), 1,
      sym_comment,
  [205274] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9018), 1,
      sym_identifier,
    STATE(6222), 1,
      sym_comment,
  [205287] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10176), 1,
      anon_sym_RBRACK,
    STATE(6223), 1,
      sym_comment,
  [205300] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10178), 1,
      anon_sym_RBRACK,
    STATE(6224), 1,
      sym_comment,
  [205313] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10180), 1,
      anon_sym_RBRACK,
    STATE(6225), 1,
      sym_comment,
  [205326] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10182), 1,
      anon_sym_RBRACK,
    STATE(6226), 1,
      sym_comment,
  [205339] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10184), 1,
      anon_sym_while,
    STATE(6227), 1,
      sym_comment,
  [205352] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10186), 1,
      anon_sym_RBRACK,
    STATE(6228), 1,
      sym_comment,
  [205365] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10188), 1,
      sym_identifier,
    STATE(6229), 1,
      sym_comment,
  [205378] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10190), 1,
      anon_sym_RBRACK,
    STATE(6230), 1,
      sym_comment,
  [205391] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9364), 1,
      anon_sym_from,
    STATE(6231), 1,
      sym_comment,
  [205404] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10192), 1,
      anon_sym_RBRACK,
    STATE(6232), 1,
      sym_comment,
  [205417] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10194), 1,
      sym_identifier,
    STATE(6233), 1,
      sym_comment,
  [205430] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10196), 1,
      sym_number,
    STATE(6234), 1,
      sym_comment,
  [205443] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10198), 1,
      anon_sym_RBRACK,
    STATE(6235), 1,
      sym_comment,
  [205456] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10200), 1,
      anon_sym_RBRACK,
    STATE(6236), 1,
      sym_comment,
  [205469] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10202), 1,
      anon_sym_function,
    STATE(6237), 1,
      sym_comment,
  [205482] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10204), 1,
      sym_identifier,
    STATE(6238), 1,
      sym_comment,
  [205495] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7750), 1,
      sym_identifier,
    STATE(6239), 1,
      sym_comment,
  [205508] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10206), 1,
      anon_sym_namespace,
    STATE(6240), 1,
      sym_comment,
  [205521] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10208), 1,
      sym_identifier,
    STATE(6241), 1,
      sym_comment,
  [205534] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10210), 1,
      anon_sym_RBRACK,
    STATE(6242), 1,
      sym_comment,
  [205547] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10212), 1,
      sym_identifier,
    STATE(6243), 1,
      sym_comment,
  [205560] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10214), 1,
      anon_sym_RBRACK,
    STATE(6244), 1,
      sym_comment,
  [205573] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10216), 1,
      anon_sym_GT,
    STATE(6245), 1,
      sym_comment,
  [205586] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10218), 1,
      anon_sym_RBRACK,
    STATE(6246), 1,
      sym_comment,
  [205599] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10220), 1,
      sym_identifier,
    STATE(6247), 1,
      sym_comment,
  [205612] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10222), 1,
      anon_sym_RBRACK,
    STATE(6248), 1,
      sym_comment,
  [205625] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10224), 1,
      anon_sym_EQ_GT,
    STATE(6249), 1,
      sym_comment,
  [205638] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10226), 1,
      anon_sym_RBRACK,
    STATE(6250), 1,
      sym_comment,
  [205651] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10228), 1,
      anon_sym_RBRACK,
    STATE(6251), 1,
      sym_comment,
  [205664] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10230), 1,
      anon_sym_RBRACK,
    STATE(6252), 1,
      sym_comment,
  [205677] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10232), 1,
      anon_sym_RBRACK,
    STATE(6253), 1,
      sym_comment,
  [205690] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10234), 1,
      anon_sym_RBRACK,
    STATE(6254), 1,
      sym_comment,
  [205703] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10236), 1,
      anon_sym_RBRACK,
    STATE(6255), 1,
      sym_comment,
  [205716] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10238), 1,
      anon_sym_RBRACK,
    STATE(6256), 1,
      sym_comment,
  [205729] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10240), 1,
      anon_sym_EQ_GT,
    STATE(6257), 1,
      sym_comment,
  [205742] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10242), 1,
      anon_sym_symbol,
    STATE(6258), 1,
      sym_comment,
  [205755] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10244), 1,
      sym_identifier,
    STATE(6259), 1,
      sym_comment,
  [205768] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10246), 1,
      anon_sym_new,
    STATE(6260), 1,
      sym_comment,
  [205781] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10248), 1,
      sym_number,
    STATE(6261), 1,
      sym_comment,
  [205794] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10250), 1,
      anon_sym_SLASH2,
    STATE(6262), 1,
      sym_comment,
  [205807] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10252), 1,
      anon_sym_EQ,
    STATE(6263), 1,
      sym_comment,
  [205820] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10254), 1,
      anon_sym_target,
    STATE(6264), 1,
      sym_comment,
  [205833] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10256), 1,
      anon_sym_RBRACK,
    STATE(6265), 1,
      sym_comment,
  [205846] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10258), 1,
      anon_sym_EQ_GT,
    STATE(6266), 1,
      sym_comment,
  [205859] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8375), 1,
      anon_sym_EQ_GT,
    STATE(6267), 1,
      sym_comment,
  [205872] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(2148), 1,
      anon_sym_EQ_GT,
    STATE(6268), 1,
      sym_comment,
  [205885] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9106), 1,
      anon_sym_LBRACE,
    STATE(6269), 1,
      sym_comment,
  [205898] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10260), 1,
      anon_sym_RBRACK,
    STATE(6270), 1,
      sym_comment,
  [205911] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5508), 1,
      anon_sym_in,
    STATE(6271), 1,
      sym_comment,
  [205924] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10262), 1,
      anon_sym_EQ_GT,
    STATE(6272), 1,
      sym_comment,
  [205937] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10264), 1,
      anon_sym_RBRACK,
    STATE(6273), 1,
      sym_comment,
  [205950] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10266), 1,
      anon_sym_EQ,
    STATE(6274), 1,
      sym_comment,
  [205963] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10268), 1,
      anon_sym_EQ_GT,
    STATE(6275), 1,
      sym_comment,
  [205976] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10270), 1,
      anon_sym_EQ_GT,
    STATE(6276), 1,
      sym_comment,
  [205989] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10272), 1,
      anon_sym_EQ_GT,
    STATE(6277), 1,
      sym_comment,
  [206002] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4773), 1,
      anon_sym_RPAREN,
    STATE(6278), 1,
      sym_comment,
  [206015] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10274), 1,
      anon_sym_RBRACK,
    STATE(6279), 1,
      sym_comment,
  [206028] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10276), 1,
      anon_sym_EQ,
    STATE(6280), 1,
      sym_comment,
  [206041] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10278), 1,
      sym_identifier,
    STATE(6281), 1,
      sym_comment,
  [206054] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10280), 1,
      sym_identifier,
    STATE(6282), 1,
      sym_comment,
  [206067] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10282), 1,
      anon_sym_class,
    STATE(6283), 1,
      sym_comment,
  [206080] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10284), 1,
      anon_sym_RBRACK,
    STATE(6284), 1,
      sym_comment,
  [206093] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10286), 1,
      anon_sym_EQ,
    STATE(6285), 1,
      sym_comment,
  [206106] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10288), 1,
      anon_sym_RBRACK,
    STATE(6286), 1,
      sym_comment,
  [206119] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7059), 1,
      anon_sym_is,
    STATE(6287), 1,
      sym_comment,
  [206132] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10290), 1,
      anon_sym_RBRACK,
    STATE(6288), 1,
      sym_comment,
  [206145] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10292), 1,
      anon_sym_RBRACK,
    STATE(6289), 1,
      sym_comment,
  [206158] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5940), 1,
      anon_sym_in,
    STATE(6290), 1,
      sym_comment,
  [206171] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10294), 1,
      sym_identifier,
    STATE(6291), 1,
      sym_comment,
  [206184] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10296), 1,
      sym_identifier,
    STATE(6292), 1,
      sym_comment,
  [206197] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10298), 1,
      anon_sym_EQ_GT,
    STATE(6293), 1,
      sym_comment,
  [206210] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10300), 1,
      sym_identifier,
    STATE(6294), 1,
      sym_comment,
  [206223] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10302), 1,
      anon_sym_EQ,
    STATE(6295), 1,
      sym_comment,
  [206236] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10304), 1,
      anon_sym_COLON,
    STATE(6296), 1,
      sym_comment,
  [206249] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10306), 1,
      anon_sym_EQ,
    STATE(6297), 1,
      sym_comment,
  [206262] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10308), 1,
      anon_sym_EQ_GT,
    STATE(6298), 1,
      sym_comment,
  [206275] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10310), 1,
      anon_sym_EQ_GT,
    STATE(6299), 1,
      sym_comment,
  [206288] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(8823), 1,
      anon_sym_EQ,
    STATE(6300), 1,
      sym_comment,
  [206301] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10312), 1,
      anon_sym_EQ_GT,
    STATE(6301), 1,
      sym_comment,
  [206314] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(5229), 1,
      anon_sym_in,
    STATE(6302), 1,
      sym_comment,
  [206327] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10314), 1,
      sym_regex_pattern,
    STATE(6303), 1,
      sym_comment,
  [206340] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10316), 1,
      anon_sym_class,
    STATE(6304), 1,
      sym_comment,
  [206353] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10318), 1,
      anon_sym_new,
    STATE(6305), 1,
      sym_comment,
  [206366] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10320), 1,
      anon_sym_namespace,
    STATE(6306), 1,
      sym_comment,
  [206379] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10322), 1,
      sym_identifier,
    STATE(6307), 1,
      sym_comment,
  [206392] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10324), 1,
      sym_identifier,
    STATE(6308), 1,
      sym_comment,
  [206405] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(4930), 1,
      anon_sym_RPAREN,
    STATE(6309), 1,
      sym_comment,
  [206418] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10326), 1,
      anon_sym_EQ_GT,
    STATE(6310), 1,
      sym_comment,
  [206431] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10328), 1,
      anon_sym_EQ_GT,
    STATE(6311), 1,
      sym_comment,
  [206444] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9020), 1,
      sym_identifier,
    STATE(6312), 1,
      sym_comment,
  [206457] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10330), 1,
      anon_sym_class,
    STATE(6313), 1,
      sym_comment,
  [206470] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10332), 1,
      sym_identifier,
    STATE(6314), 1,
      sym_comment,
  [206483] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10334), 1,
      anon_sym_EQ_GT,
    STATE(6315), 1,
      sym_comment,
  [206496] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10336), 1,
      sym_identifier,
    STATE(6316), 1,
      sym_comment,
  [206509] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10338), 1,
      anon_sym_EQ,
    STATE(6317), 1,
      sym_comment,
  [206522] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10340), 1,
      anon_sym_EQ,
    STATE(6318), 1,
      sym_comment,
  [206535] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10342), 1,
      anon_sym_EQ,
    STATE(6319), 1,
      sym_comment,
  [206548] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10344), 1,
      anon_sym_SLASH2,
    STATE(6320), 1,
      sym_comment,
  [206561] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10346), 1,
      sym_identifier,
    STATE(6321), 1,
      sym_comment,
  [206574] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10348), 1,
      anon_sym_COLON,
    STATE(6322), 1,
      sym_comment,
  [206587] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10350), 1,
      aux_sym_ui_version_specifier_token1,
    STATE(6323), 1,
      sym_comment,
  [206600] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10352), 1,
      anon_sym_RBRACK,
    STATE(6324), 1,
      sym_comment,
  [206613] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10354), 1,
      sym_identifier,
    STATE(6325), 1,
      sym_comment,
  [206626] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10356), 1,
      anon_sym_COLON,
    STATE(6326), 1,
      sym_comment,
  [206639] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10358), 1,
      sym_identifier,
    STATE(6327), 1,
      sym_comment,
  [206652] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10360), 1,
      anon_sym_new,
    STATE(6328), 1,
      sym_comment,
  [206665] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10362), 1,
      anon_sym_EQ_GT,
    STATE(6329), 1,
      sym_comment,
  [206678] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10364), 1,
      anon_sym_EQ_GT,
    STATE(6330), 1,
      sym_comment,
  [206691] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10366), 1,
      anon_sym_DOT,
    STATE(6331), 1,
      sym_comment,
  [206704] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10368), 1,
      anon_sym_LT,
    STATE(6332), 1,
      sym_comment,
  [206717] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10370), 1,
      anon_sym_EQ_GT,
    STATE(6333), 1,
      sym_comment,
  [206730] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10372), 1,
      sym_identifier,
    STATE(6334), 1,
      sym_comment,
  [206743] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10374), 1,
      anon_sym_symbol,
    STATE(6335), 1,
      sym_comment,
  [206756] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10376), 1,
      anon_sym_new,
    STATE(6336), 1,
      sym_comment,
  [206769] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10378), 1,
      sym_identifier,
    STATE(6337), 1,
      sym_comment,
  [206782] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10380), 1,
      sym_identifier,
    STATE(6338), 1,
      sym_comment,
  [206795] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10382), 1,
      sym_identifier,
    STATE(6339), 1,
      sym_comment,
  [206808] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10384), 1,
      sym_identifier,
    STATE(6340), 1,
      sym_comment,
  [206821] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10386), 1,
      anon_sym_new,
    STATE(6341), 1,
      sym_comment,
  [206834] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10388), 1,
      sym_identifier,
    STATE(6342), 1,
      sym_comment,
  [206847] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7595), 1,
      sym_identifier,
    STATE(6343), 1,
      sym_comment,
  [206860] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10390), 1,
      anon_sym_function,
    STATE(6344), 1,
      sym_comment,
  [206873] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10392), 1,
      sym_identifier,
    STATE(6345), 1,
      sym_comment,
  [206886] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(9244), 1,
      anon_sym_RBRACK,
    STATE(6346), 1,
      sym_comment,
  [206899] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10394), 1,
      sym_identifier,
    STATE(6347), 1,
      sym_comment,
  [206912] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10396), 1,
      ts_builtin_sym_end,
    STATE(6348), 1,
      sym_comment,
  [206925] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10398), 1,
      ts_builtin_sym_end,
    STATE(6349), 1,
      sym_comment,
  [206938] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10400), 1,
      sym_identifier,
    STATE(6350), 1,
      sym_comment,
  [206951] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10402), 1,
      sym_identifier,
    STATE(6351), 1,
      sym_comment,
  [206964] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(7579), 1,
      sym_identifier,
    STATE(6352), 1,
      sym_comment,
  [206977] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10404), 1,
      anon_sym_function,
    STATE(6353), 1,
      sym_comment,
  [206990] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10406), 1,
      ts_builtin_sym_end,
    STATE(6354), 1,
      sym_comment,
  [207003] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10408), 1,
      ts_builtin_sym_end,
    STATE(6355), 1,
      sym_comment,
  [207016] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10410), 1,
      sym_identifier,
    STATE(6356), 1,
      sym_comment,
  [207029] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10412), 1,
      anon_sym_function,
    STATE(6357), 1,
      sym_comment,
  [207042] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10414), 1,
      ts_builtin_sym_end,
    STATE(6358), 1,
      sym_comment,
  [207055] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(15), 1,
      aux_sym_comment_token1,
    ACTIONS(10416), 1,
      sym_identifier,
    STATE(6359), 1,
      sym_comment,
  [207068] = 1,
    ACTIONS(10418), 1,
      ts_builtin_sym_end,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(1247)] = 0,
  [SMALL_STATE(1248)] = 95,
  [SMALL_STATE(1249)] = 188,
  [SMALL_STATE(1250)] = 283,
  [SMALL_STATE(1251)] = 358,
  [SMALL_STATE(1252)] = 451,
  [SMALL_STATE(1253)] = 526,
  [SMALL_STATE(1254)] = 601,
  [SMALL_STATE(1255)] = 676,
  [SMALL_STATE(1256)] = 771,
  [SMALL_STATE(1257)] = 864,
  [SMALL_STATE(1258)] = 939,
  [SMALL_STATE(1259)] = 1034,
  [SMALL_STATE(1260)] = 1127,
  [SMALL_STATE(1261)] = 1222,
  [SMALL_STATE(1262)] = 1297,
  [SMALL_STATE(1263)] = 1390,
  [SMALL_STATE(1264)] = 1485,
  [SMALL_STATE(1265)] = 1580,
  [SMALL_STATE(1266)] = 1675,
  [SMALL_STATE(1267)] = 1768,
  [SMALL_STATE(1268)] = 1865,
  [SMALL_STATE(1269)] = 1958,
  [SMALL_STATE(1270)] = 2055,
  [SMALL_STATE(1271)] = 2148,
  [SMALL_STATE(1272)] = 2241,
  [SMALL_STATE(1273)] = 2316,
  [SMALL_STATE(1274)] = 2411,
  [SMALL_STATE(1275)] = 2504,
  [SMALL_STATE(1276)] = 2601,
  [SMALL_STATE(1277)] = 2694,
  [SMALL_STATE(1278)] = 2789,
  [SMALL_STATE(1279)] = 2919,
  [SMALL_STATE(1280)] = 3011,
  [SMALL_STATE(1281)] = 3107,
  [SMALL_STATE(1282)] = 3237,
  [SMALL_STATE(1283)] = 3367,
  [SMALL_STATE(1284)] = 3497,
  [SMALL_STATE(1285)] = 3589,
  [SMALL_STATE(1286)] = 3719,
  [SMALL_STATE(1287)] = 3811,
  [SMALL_STATE(1288)] = 3941,
  [SMALL_STATE(1289)] = 4041,
  [SMALL_STATE(1290)] = 4171,
  [SMALL_STATE(1291)] = 4301,
  [SMALL_STATE(1292)] = 4431,
  [SMALL_STATE(1293)] = 4561,
  [SMALL_STATE(1294)] = 4653,
  [SMALL_STATE(1295)] = 4749,
  [SMALL_STATE(1296)] = 4879,
  [SMALL_STATE(1297)] = 5009,
  [SMALL_STATE(1298)] = 5139,
  [SMALL_STATE(1299)] = 5269,
  [SMALL_STATE(1300)] = 5399,
  [SMALL_STATE(1301)] = 5529,
  [SMALL_STATE(1302)] = 5659,
  [SMALL_STATE(1303)] = 5751,
  [SMALL_STATE(1304)] = 5881,
  [SMALL_STATE(1305)] = 5977,
  [SMALL_STATE(1306)] = 6107,
  [SMALL_STATE(1307)] = 6199,
  [SMALL_STATE(1308)] = 6291,
  [SMALL_STATE(1309)] = 6365,
  [SMALL_STATE(1310)] = 6439,
  [SMALL_STATE(1311)] = 6533,
  [SMALL_STATE(1312)] = 6611,
  [SMALL_STATE(1313)] = 6707,
  [SMALL_STATE(1314)] = 6837,
  [SMALL_STATE(1315)] = 6967,
  [SMALL_STATE(1316)] = 7058,
  [SMALL_STATE(1317)] = 7141,
  [SMALL_STATE(1318)] = 7232,
  [SMALL_STATE(1319)] = 7323,
  [SMALL_STATE(1320)] = 7418,
  [SMALL_STATE(1321)] = 7501,
  [SMALL_STATE(1322)] = 7596,
  [SMALL_STATE(1323)] = 7687,
  [SMALL_STATE(1324)] = 7778,
  [SMALL_STATE(1325)] = 7861,
  [SMALL_STATE(1326)] = 7946,
  [SMALL_STATE(1327)] = 8043,
  [SMALL_STATE(1328)] = 8140,
  [SMALL_STATE(1329)] = 8223,
  [SMALL_STATE(1330)] = 8296,
  [SMALL_STATE(1331)] = 8379,
  [SMALL_STATE(1332)] = 8452,
  [SMALL_STATE(1333)] = 8543,
  [SMALL_STATE(1334)] = 8634,
  [SMALL_STATE(1335)] = 8725,
  [SMALL_STATE(1336)] = 8818,
  [SMALL_STATE(1337)] = 8909,
  [SMALL_STATE(1338)] = 9000,
  [SMALL_STATE(1339)] = 9083,
  [SMALL_STATE(1340)] = 9174,
  [SMALL_STATE(1341)] = 9259,
  [SMALL_STATE(1342)] = 9350,
  [SMALL_STATE(1343)] = 9445,
  [SMALL_STATE(1344)] = 9533,
  [SMALL_STATE(1345)] = 9611,
  [SMALL_STATE(1346)] = 9695,
  [SMALL_STATE(1347)] = 9779,
  [SMALL_STATE(1348)] = 9873,
  [SMALL_STATE(1349)] = 9951,
  [SMALL_STATE(1350)] = 10077,
  [SMALL_STATE(1351)] = 10165,
  [SMALL_STATE(1352)] = 10245,
  [SMALL_STATE(1353)] = 10371,
  [SMALL_STATE(1354)] = 10453,
  [SMALL_STATE(1355)] = 10547,
  [SMALL_STATE(1356)] = 10673,
  [SMALL_STATE(1357)] = 10757,
  [SMALL_STATE(1358)] = 10841,
  [SMALL_STATE(1359)] = 10923,
  [SMALL_STATE(1360)] = 11013,
  [SMALL_STATE(1361)] = 11139,
  [SMALL_STATE(1362)] = 11233,
  [SMALL_STATE(1363)] = 11359,
  [SMALL_STATE(1364)] = 11453,
  [SMALL_STATE(1365)] = 11535,
  [SMALL_STATE(1366)] = 11661,
  [SMALL_STATE(1367)] = 11753,
  [SMALL_STATE(1368)] = 11831,
  [SMALL_STATE(1369)] = 11915,
  [SMALL_STATE(1370)] = 12041,
  [SMALL_STATE(1371)] = 12119,
  [SMALL_STATE(1372)] = 12203,
  [SMALL_STATE(1373)] = 12329,
  [SMALL_STATE(1374)] = 12409,
  [SMALL_STATE(1375)] = 12499,
  [SMALL_STATE(1376)] = 12579,
  [SMALL_STATE(1377)] = 12673,
  [SMALL_STATE(1378)] = 12758,
  [SMALL_STATE(1379)] = 12851,
  [SMALL_STATE(1380)] = 12936,
  [SMALL_STATE(1381)] = 13007,
  [SMALL_STATE(1382)] = 13078,
  [SMALL_STATE(1383)] = 13149,
  [SMALL_STATE(1384)] = 13226,
  [SMALL_STATE(1385)] = 13309,
  [SMALL_STATE(1386)] = 13394,
  [SMALL_STATE(1387)] = 13471,
  [SMALL_STATE(1388)] = 13542,
  [SMALL_STATE(1389)] = 13621,
  [SMALL_STATE(1390)] = 13696,
  [SMALL_STATE(1391)] = 13775,
  [SMALL_STATE(1392)] = 13864,
  [SMALL_STATE(1393)] = 13941,
  [SMALL_STATE(1394)] = 14018,
  [SMALL_STATE(1395)] = 14095,
  [SMALL_STATE(1396)] = 14166,
  [SMALL_STATE(1397)] = 14245,
  [SMALL_STATE(1398)] = 14326,
  [SMALL_STATE(1399)] = 14415,
  [SMALL_STATE(1400)] = 14492,
  [SMALL_STATE(1401)] = 14577,
  [SMALL_STATE(1402)] = 14658,
  [SMALL_STATE(1403)] = 14729,
  [SMALL_STATE(1404)] = 14818,
  [SMALL_STATE(1405)] = 14905,
  [SMALL_STATE(1406)] = 14984,
  [SMALL_STATE(1407)] = 15065,
  [SMALL_STATE(1408)] = 15144,
  [SMALL_STATE(1409)] = 15227,
  [SMALL_STATE(1410)] = 15316,
  [SMALL_STATE(1411)] = 15393,
  [SMALL_STATE(1412)] = 15470,
  [SMALL_STATE(1413)] = 15549,
  [SMALL_STATE(1414)] = 15642,
  [SMALL_STATE(1415)] = 15715,
  [SMALL_STATE(1416)] = 15786,
  [SMALL_STATE(1417)] = 15857,
  [SMALL_STATE(1418)] = 15928,
  [SMALL_STATE(1419)] = 16001,
  [SMALL_STATE(1420)] = 16072,
  [SMALL_STATE(1421)] = 16143,
  [SMALL_STATE(1422)] = 16218,
  [SMALL_STATE(1423)] = 16342,
  [SMALL_STATE(1424)] = 16466,
  [SMALL_STATE(1425)] = 16584,
  [SMALL_STATE(1426)] = 16656,
  [SMALL_STATE(1427)] = 16734,
  [SMALL_STATE(1428)] = 16806,
  [SMALL_STATE(1429)] = 16924,
  [SMALL_STATE(1430)] = 17042,
  [SMALL_STATE(1431)] = 17120,
  [SMALL_STATE(1432)] = 17244,
  [SMALL_STATE(1433)] = 17322,
  [SMALL_STATE(1434)] = 17404,
  [SMALL_STATE(1435)] = 17482,
  [SMALL_STATE(1436)] = 17606,
  [SMALL_STATE(1437)] = 17688,
  [SMALL_STATE(1438)] = 17806,
  [SMALL_STATE(1439)] = 17884,
  [SMALL_STATE(1440)] = 17962,
  [SMALL_STATE(1441)] = 18044,
  [SMALL_STATE(1442)] = 18120,
  [SMALL_STATE(1443)] = 18244,
  [SMALL_STATE(1444)] = 18368,
  [SMALL_STATE(1445)] = 18450,
  [SMALL_STATE(1446)] = 18574,
  [SMALL_STATE(1447)] = 18650,
  [SMALL_STATE(1448)] = 18738,
  [SMALL_STATE(1449)] = 18822,
  [SMALL_STATE(1450)] = 18940,
  [SMALL_STATE(1451)] = 19016,
  [SMALL_STATE(1452)] = 19090,
  [SMALL_STATE(1453)] = 19214,
  [SMALL_STATE(1454)] = 19290,
  [SMALL_STATE(1455)] = 19414,
  [SMALL_STATE(1456)] = 19538,
  [SMALL_STATE(1457)] = 19662,
  [SMALL_STATE(1458)] = 19744,
  [SMALL_STATE(1459)] = 19866,
  [SMALL_STATE(1460)] = 19990,
  [SMALL_STATE(1461)] = 20114,
  [SMALL_STATE(1462)] = 20238,
  [SMALL_STATE(1463)] = 20356,
  [SMALL_STATE(1464)] = 20474,
  [SMALL_STATE(1465)] = 20548,
  [SMALL_STATE(1466)] = 20672,
  [SMALL_STATE(1467)] = 20796,
  [SMALL_STATE(1468)] = 20871,
  [SMALL_STATE(1469)] = 20946,
  [SMALL_STATE(1470)] = 21025,
  [SMALL_STATE(1471)] = 21100,
  [SMALL_STATE(1472)] = 21179,
  [SMALL_STATE(1473)] = 21258,
  [SMALL_STATE(1474)] = 21331,
  [SMALL_STATE(1475)] = 21412,
  [SMALL_STATE(1476)] = 21491,
  [SMALL_STATE(1477)] = 21566,
  [SMALL_STATE(1478)] = 21643,
  [SMALL_STATE(1479)] = 21714,
  [SMALL_STATE(1480)] = 21791,
  [SMALL_STATE(1481)] = 21862,
  [SMALL_STATE(1482)] = 21936,
  [SMALL_STATE(1483)] = 22010,
  [SMALL_STATE(1484)] = 22084,
  [SMALL_STATE(1485)] = 22158,
  [SMALL_STATE(1486)] = 22232,
  [SMALL_STATE(1487)] = 22306,
  [SMALL_STATE(1488)] = 22378,
  [SMALL_STATE(1489)] = 22456,
  [SMALL_STATE(1490)] = 22532,
  [SMALL_STATE(1491)] = 22606,
  [SMALL_STATE(1492)] = 22680,
  [SMALL_STATE(1493)] = 22754,
  [SMALL_STATE(1494)] = 22832,
  [SMALL_STATE(1495)] = 22906,
  [SMALL_STATE(1496)] = 22980,
  [SMALL_STATE(1497)] = 23054,
  [SMALL_STATE(1498)] = 23164,
  [SMALL_STATE(1499)] = 23239,
  [SMALL_STATE(1500)] = 23312,
  [SMALL_STATE(1501)] = 23385,
  [SMALL_STATE(1502)] = 23492,
  [SMALL_STATE(1503)] = 23565,
  [SMALL_STATE(1504)] = 23638,
  [SMALL_STATE(1505)] = 23711,
  [SMALL_STATE(1506)] = 23784,
  [SMALL_STATE(1507)] = 23857,
  [SMALL_STATE(1508)] = 23930,
  [SMALL_STATE(1509)] = 24003,
  [SMALL_STATE(1510)] = 24076,
  [SMALL_STATE(1511)] = 24149,
  [SMALL_STATE(1512)] = 24254,
  [SMALL_STATE(1513)] = 24327,
  [SMALL_STATE(1514)] = 24398,
  [SMALL_STATE(1515)] = 24471,
  [SMALL_STATE(1516)] = 24544,
  [SMALL_STATE(1517)] = 24617,
  [SMALL_STATE(1518)] = 24724,
  [SMALL_STATE(1519)] = 24797,
  [SMALL_STATE(1520)] = 24870,
  [SMALL_STATE(1521)] = 24941,
  [SMALL_STATE(1522)] = 25048,
  [SMALL_STATE(1523)] = 25121,
  [SMALL_STATE(1524)] = 25192,
  [SMALL_STATE(1525)] = 25265,
  [SMALL_STATE(1526)] = 25372,
  [SMALL_STATE(1527)] = 25445,
  [SMALL_STATE(1528)] = 25515,
  [SMALL_STATE(1529)] = 25585,
  [SMALL_STATE(1530)] = 25685,
  [SMALL_STATE(1531)] = 25755,
  [SMALL_STATE(1532)] = 25825,
  [SMALL_STATE(1533)] = 25925,
  [SMALL_STATE(1534)] = 26025,
  [SMALL_STATE(1535)] = 26125,
  [SMALL_STATE(1536)] = 26225,
  [SMALL_STATE(1537)] = 26325,
  [SMALL_STATE(1538)] = 26395,
  [SMALL_STATE(1539)] = 26465,
  [SMALL_STATE(1540)] = 26535,
  [SMALL_STATE(1541)] = 26603,
  [SMALL_STATE(1542)] = 26671,
  [SMALL_STATE(1543)] = 26741,
  [SMALL_STATE(1544)] = 26811,
  [SMALL_STATE(1545)] = 26876,
  [SMALL_STATE(1546)] = 26971,
  [SMALL_STATE(1547)] = 27036,
  [SMALL_STATE(1548)] = 27101,
  [SMALL_STATE(1549)] = 27168,
  [SMALL_STATE(1550)] = 27259,
  [SMALL_STATE(1551)] = 27352,
  [SMALL_STATE(1552)] = 27445,
  [SMALL_STATE(1553)] = 27536,
  [SMALL_STATE(1554)] = 27627,
  [SMALL_STATE(1555)] = 27694,
  [SMALL_STATE(1556)] = 27787,
  [SMALL_STATE(1557)] = 27852,
  [SMALL_STATE(1558)] = 27943,
  [SMALL_STATE(1559)] = 28036,
  [SMALL_STATE(1560)] = 28127,
  [SMALL_STATE(1561)] = 28220,
  [SMALL_STATE(1562)] = 28313,
  [SMALL_STATE(1563)] = 28404,
  [SMALL_STATE(1564)] = 28494,
  [SMALL_STATE(1565)] = 28586,
  [SMALL_STATE(1566)] = 28710,
  [SMALL_STATE(1567)] = 28796,
  [SMALL_STATE(1568)] = 28882,
  [SMALL_STATE(1569)] = 28968,
  [SMALL_STATE(1570)] = 29092,
  [SMALL_STATE(1571)] = 29178,
  [SMALL_STATE(1572)] = 29268,
  [SMALL_STATE(1573)] = 29392,
  [SMALL_STATE(1574)] = 29510,
  [SMALL_STATE(1575)] = 29634,
  [SMALL_STATE(1576)] = 29758,
  [SMALL_STATE(1577)] = 29882,
  [SMALL_STATE(1578)] = 29968,
  [SMALL_STATE(1579)] = 30054,
  [SMALL_STATE(1580)] = 30137,
  [SMALL_STATE(1581)] = 30234,
  [SMALL_STATE(1582)] = 30331,
  [SMALL_STATE(1583)] = 30414,
  [SMALL_STATE(1584)] = 30511,
  [SMALL_STATE(1585)] = 30600,
  [SMALL_STATE(1586)] = 30687,
  [SMALL_STATE(1587)] = 30774,
  [SMALL_STATE(1588)] = 30871,
  [SMALL_STATE(1589)] = 30956,
  [SMALL_STATE(1590)] = 31043,
  [SMALL_STATE(1591)] = 31128,
  [SMALL_STATE(1592)] = 31211,
  [SMALL_STATE(1593)] = 31294,
  [SMALL_STATE(1594)] = 31381,
  [SMALL_STATE(1595)] = 31470,
  [SMALL_STATE(1596)] = 31557,
  [SMALL_STATE(1597)] = 31654,
  [SMALL_STATE(1598)] = 31737,
  [SMALL_STATE(1599)] = 31824,
  [SMALL_STATE(1600)] = 31921,
  [SMALL_STATE(1601)] = 32006,
  [SMALL_STATE(1602)] = 32103,
  [SMALL_STATE(1603)] = 32177,
  [SMALL_STATE(1604)] = 32255,
  [SMALL_STATE(1605)] = 32345,
  [SMALL_STATE(1606)] = 32423,
  [SMALL_STATE(1607)] = 32497,
  [SMALL_STATE(1608)] = 32577,
  [SMALL_STATE(1609)] = 32665,
  [SMALL_STATE(1610)] = 32745,
  [SMALL_STATE(1611)] = 32825,
  [SMALL_STATE(1612)] = 32915,
  [SMALL_STATE(1613)] = 33003,
  [SMALL_STATE(1614)] = 33119,
  [SMALL_STATE(1615)] = 33199,
  [SMALL_STATE(1616)] = 33277,
  [SMALL_STATE(1617)] = 33355,
  [SMALL_STATE(1618)] = 33443,
  [SMALL_STATE(1619)] = 33521,
  [SMALL_STATE(1620)] = 33609,
  [SMALL_STATE(1621)] = 33689,
  [SMALL_STATE(1622)] = 33769,
  [SMALL_STATE(1623)] = 33859,
  [SMALL_STATE(1624)] = 33947,
  [SMALL_STATE(1625)] = 34037,
  [SMALL_STATE(1626)] = 34111,
  [SMALL_STATE(1627)] = 34191,
  [SMALL_STATE(1628)] = 34271,
  [SMALL_STATE(1629)] = 34345,
  [SMALL_STATE(1630)] = 34423,
  [SMALL_STATE(1631)] = 34497,
  [SMALL_STATE(1632)] = 34571,
  [SMALL_STATE(1633)] = 34649,
  [SMALL_STATE(1634)] = 34727,
  [SMALL_STATE(1635)] = 34801,
  [SMALL_STATE(1636)] = 34891,
  [SMALL_STATE(1637)] = 34971,
  [SMALL_STATE(1638)] = 35059,
  [SMALL_STATE(1639)] = 35173,
  [SMALL_STATE(1640)] = 35251,
  [SMALL_STATE(1641)] = 35313,
  [SMALL_STATE(1642)] = 35387,
  [SMALL_STATE(1643)] = 35449,
  [SMALL_STATE(1644)] = 35529,
  [SMALL_STATE(1645)] = 35603,
  [SMALL_STATE(1646)] = 35687,
  [SMALL_STATE(1647)] = 35775,
  [SMALL_STATE(1648)] = 35853,
  [SMALL_STATE(1649)] = 35933,
  [SMALL_STATE(1650)] = 36011,
  [SMALL_STATE(1651)] = 36101,
  [SMALL_STATE(1652)] = 36181,
  [SMALL_STATE(1653)] = 36281,
  [SMALL_STATE(1654)] = 36359,
  [SMALL_STATE(1655)] = 36439,
  [SMALL_STATE(1656)] = 36517,
  [SMALL_STATE(1657)] = 36597,
  [SMALL_STATE(1658)] = 36675,
  [SMALL_STATE(1659)] = 36753,
  [SMALL_STATE(1660)] = 36831,
  [SMALL_STATE(1661)] = 36909,
  [SMALL_STATE(1662)] = 36987,
  [SMALL_STATE(1663)] = 37051,
  [SMALL_STATE(1664)] = 37131,
  [SMALL_STATE(1665)] = 37211,
  [SMALL_STATE(1666)] = 37301,
  [SMALL_STATE(1667)] = 37375,
  [SMALL_STATE(1668)] = 37453,
  [SMALL_STATE(1669)] = 37527,
  [SMALL_STATE(1670)] = 37601,
  [SMALL_STATE(1671)] = 37679,
  [SMALL_STATE(1672)] = 37752,
  [SMALL_STATE(1673)] = 37835,
  [SMALL_STATE(1674)] = 37908,
  [SMALL_STATE(1675)] = 37981,
  [SMALL_STATE(1676)] = 38054,
  [SMALL_STATE(1677)] = 38137,
  [SMALL_STATE(1678)] = 38220,
  [SMALL_STATE(1679)] = 38293,
  [SMALL_STATE(1680)] = 38366,
  [SMALL_STATE(1681)] = 38449,
  [SMALL_STATE(1682)] = 38538,
  [SMALL_STATE(1683)] = 38633,
  [SMALL_STATE(1684)] = 38706,
  [SMALL_STATE(1685)] = 38777,
  [SMALL_STATE(1686)] = 38850,
  [SMALL_STATE(1687)] = 38923,
  [SMALL_STATE(1688)] = 38996,
  [SMALL_STATE(1689)] = 39069,
  [SMALL_STATE(1690)] = 39142,
  [SMALL_STATE(1691)] = 39225,
  [SMALL_STATE(1692)] = 39298,
  [SMALL_STATE(1693)] = 39371,
  [SMALL_STATE(1694)] = 39434,
  [SMALL_STATE(1695)] = 39507,
  [SMALL_STATE(1696)] = 39580,
  [SMALL_STATE(1697)] = 39653,
  [SMALL_STATE(1698)] = 39724,
  [SMALL_STATE(1699)] = 39807,
  [SMALL_STATE(1700)] = 39880,
  [SMALL_STATE(1701)] = 39953,
  [SMALL_STATE(1702)] = 40024,
  [SMALL_STATE(1703)] = 40097,
  [SMALL_STATE(1704)] = 40174,
  [SMALL_STATE(1705)] = 40247,
  [SMALL_STATE(1706)] = 40330,
  [SMALL_STATE(1707)] = 40421,
  [SMALL_STATE(1708)] = 40490,
  [SMALL_STATE(1709)] = 40563,
  [SMALL_STATE(1710)] = 40636,
  [SMALL_STATE(1711)] = 40698,
  [SMALL_STATE(1712)] = 40760,
  [SMALL_STATE(1713)] = 40846,
  [SMALL_STATE(1714)] = 40908,
  [SMALL_STATE(1715)] = 40992,
  [SMALL_STATE(1716)] = 41052,
  [SMALL_STATE(1717)] = 41134,
  [SMALL_STATE(1718)] = 41212,
  [SMALL_STATE(1719)] = 41286,
  [SMALL_STATE(1720)] = 41360,
  [SMALL_STATE(1721)] = 41438,
  [SMALL_STATE(1722)] = 41512,
  [SMALL_STATE(1723)] = 41572,
  [SMALL_STATE(1724)] = 41650,
  [SMALL_STATE(1725)] = 41724,
  [SMALL_STATE(1726)] = 41784,
  [SMALL_STATE(1727)] = 41848,
  [SMALL_STATE(1728)] = 41914,
  [SMALL_STATE(1729)] = 41992,
  [SMALL_STATE(1730)] = 42052,
  [SMALL_STATE(1731)] = 42112,
  [SMALL_STATE(1732)] = 42192,
  [SMALL_STATE(1733)] = 42292,
  [SMALL_STATE(1734)] = 42374,
  [SMALL_STATE(1735)] = 42438,
  [SMALL_STATE(1736)] = 42516,
  [SMALL_STATE(1737)] = 42576,
  [SMALL_STATE(1738)] = 42642,
  [SMALL_STATE(1739)] = 42708,
  [SMALL_STATE(1740)] = 42774,
  [SMALL_STATE(1741)] = 42840,
  [SMALL_STATE(1742)] = 42914,
  [SMALL_STATE(1743)] = 42974,
  [SMALL_STATE(1744)] = 43040,
  [SMALL_STATE(1745)] = 43104,
  [SMALL_STATE(1746)] = 43163,
  [SMALL_STATE(1747)] = 43280,
  [SMALL_STATE(1748)] = 43339,
  [SMALL_STATE(1749)] = 43464,
  [SMALL_STATE(1750)] = 43523,
  [SMALL_STATE(1751)] = 43586,
  [SMALL_STATE(1752)] = 43645,
  [SMALL_STATE(1753)] = 43704,
  [SMALL_STATE(1754)] = 43763,
  [SMALL_STATE(1755)] = 43822,
  [SMALL_STATE(1756)] = 43893,
  [SMALL_STATE(1757)] = 43952,
  [SMALL_STATE(1758)] = 44011,
  [SMALL_STATE(1759)] = 44074,
  [SMALL_STATE(1760)] = 44133,
  [SMALL_STATE(1761)] = 44192,
  [SMALL_STATE(1762)] = 44251,
  [SMALL_STATE(1763)] = 44312,
  [SMALL_STATE(1764)] = 44371,
  [SMALL_STATE(1765)] = 44432,
  [SMALL_STATE(1766)] = 44493,
  [SMALL_STATE(1767)] = 44570,
  [SMALL_STATE(1768)] = 44641,
  [SMALL_STATE(1769)] = 44700,
  [SMALL_STATE(1770)] = 44761,
  [SMALL_STATE(1771)] = 44820,
  [SMALL_STATE(1772)] = 44891,
  [SMALL_STATE(1773)] = 44950,
  [SMALL_STATE(1774)] = 45009,
  [SMALL_STATE(1775)] = 45070,
  [SMALL_STATE(1776)] = 45129,
  [SMALL_STATE(1777)] = 45188,
  [SMALL_STATE(1778)] = 45247,
  [SMALL_STATE(1779)] = 45312,
  [SMALL_STATE(1780)] = 45377,
  [SMALL_STATE(1781)] = 45438,
  [SMALL_STATE(1782)] = 45499,
  [SMALL_STATE(1783)] = 45624,
  [SMALL_STATE(1784)] = 45683,
  [SMALL_STATE(1785)] = 45754,
  [SMALL_STATE(1786)] = 45825,
  [SMALL_STATE(1787)] = 45950,
  [SMALL_STATE(1788)] = 46021,
  [SMALL_STATE(1789)] = 46092,
  [SMALL_STATE(1790)] = 46163,
  [SMALL_STATE(1791)] = 46234,
  [SMALL_STATE(1792)] = 46313,
  [SMALL_STATE(1793)] = 46372,
  [SMALL_STATE(1794)] = 46431,
  [SMALL_STATE(1795)] = 46490,
  [SMALL_STATE(1796)] = 46549,
  [SMALL_STATE(1797)] = 46612,
  [SMALL_STATE(1798)] = 46671,
  [SMALL_STATE(1799)] = 46730,
  [SMALL_STATE(1800)] = 46789,
  [SMALL_STATE(1801)] = 46860,
  [SMALL_STATE(1802)] = 46927,
  [SMALL_STATE(1803)] = 46998,
  [SMALL_STATE(1804)] = 47065,
  [SMALL_STATE(1805)] = 47126,
  [SMALL_STATE(1806)] = 47251,
  [SMALL_STATE(1807)] = 47310,
  [SMALL_STATE(1808)] = 47369,
  [SMALL_STATE(1809)] = 47428,
  [SMALL_STATE(1810)] = 47493,
  [SMALL_STATE(1811)] = 47564,
  [SMALL_STATE(1812)] = 47623,
  [SMALL_STATE(1813)] = 47688,
  [SMALL_STATE(1814)] = 47759,
  [SMALL_STATE(1815)] = 47876,
  [SMALL_STATE(1816)] = 47947,
  [SMALL_STATE(1817)] = 48018,
  [SMALL_STATE(1818)] = 48089,
  [SMALL_STATE(1819)] = 48148,
  [SMALL_STATE(1820)] = 48209,
  [SMALL_STATE(1821)] = 48268,
  [SMALL_STATE(1822)] = 48333,
  [SMALL_STATE(1823)] = 48404,
  [SMALL_STATE(1824)] = 48483,
  [SMALL_STATE(1825)] = 48560,
  [SMALL_STATE(1826)] = 48631,
  [SMALL_STATE(1827)] = 48702,
  [SMALL_STATE(1828)] = 48773,
  [SMALL_STATE(1829)] = 48834,
  [SMALL_STATE(1830)] = 48893,
  [SMALL_STATE(1831)] = 48954,
  [SMALL_STATE(1832)] = 49013,
  [SMALL_STATE(1833)] = 49072,
  [SMALL_STATE(1834)] = 49131,
  [SMALL_STATE(1835)] = 49190,
  [SMALL_STATE(1836)] = 49249,
  [SMALL_STATE(1837)] = 49308,
  [SMALL_STATE(1838)] = 49367,
  [SMALL_STATE(1839)] = 49426,
  [SMALL_STATE(1840)] = 49497,
  [SMALL_STATE(1841)] = 49556,
  [SMALL_STATE(1842)] = 49615,
  [SMALL_STATE(1843)] = 49732,
  [SMALL_STATE(1844)] = 49849,
  [SMALL_STATE(1845)] = 49920,
  [SMALL_STATE(1846)] = 49981,
  [SMALL_STATE(1847)] = 50040,
  [SMALL_STATE(1848)] = 50099,
  [SMALL_STATE(1849)] = 50216,
  [SMALL_STATE(1850)] = 50275,
  [SMALL_STATE(1851)] = 50334,
  [SMALL_STATE(1852)] = 50393,
  [SMALL_STATE(1853)] = 50452,
  [SMALL_STATE(1854)] = 50511,
  [SMALL_STATE(1855)] = 50576,
  [SMALL_STATE(1856)] = 50647,
  [SMALL_STATE(1857)] = 50718,
  [SMALL_STATE(1858)] = 50777,
  [SMALL_STATE(1859)] = 50836,
  [SMALL_STATE(1860)] = 50901,
  [SMALL_STATE(1861)] = 50966,
  [SMALL_STATE(1862)] = 51031,
  [SMALL_STATE(1863)] = 51090,
  [SMALL_STATE(1864)] = 51149,
  [SMALL_STATE(1865)] = 51210,
  [SMALL_STATE(1866)] = 51269,
  [SMALL_STATE(1867)] = 51386,
  [SMALL_STATE(1868)] = 51449,
  [SMALL_STATE(1869)] = 51514,
  [SMALL_STATE(1870)] = 51579,
  [SMALL_STATE(1871)] = 51704,
  [SMALL_STATE(1872)] = 51821,
  [SMALL_STATE(1873)] = 51938,
  [SMALL_STATE(1874)] = 52047,
  [SMALL_STATE(1875)] = 52142,
  [SMALL_STATE(1876)] = 52201,
  [SMALL_STATE(1877)] = 52260,
  [SMALL_STATE(1878)] = 52331,
  [SMALL_STATE(1879)] = 52448,
  [SMALL_STATE(1880)] = 52519,
  [SMALL_STATE(1881)] = 52578,
  [SMALL_STATE(1882)] = 52637,
  [SMALL_STATE(1883)] = 52696,
  [SMALL_STATE(1884)] = 52755,
  [SMALL_STATE(1885)] = 52826,
  [SMALL_STATE(1886)] = 52893,
  [SMALL_STATE(1887)] = 52952,
  [SMALL_STATE(1888)] = 53011,
  [SMALL_STATE(1889)] = 53070,
  [SMALL_STATE(1890)] = 53129,
  [SMALL_STATE(1891)] = 53188,
  [SMALL_STATE(1892)] = 53259,
  [SMALL_STATE(1893)] = 53318,
  [SMALL_STATE(1894)] = 53377,
  [SMALL_STATE(1895)] = 53436,
  [SMALL_STATE(1896)] = 53495,
  [SMALL_STATE(1897)] = 53556,
  [SMALL_STATE(1898)] = 53615,
  [SMALL_STATE(1899)] = 53674,
  [SMALL_STATE(1900)] = 53733,
  [SMALL_STATE(1901)] = 53792,
  [SMALL_STATE(1902)] = 53867,
  [SMALL_STATE(1903)] = 53952,
  [SMALL_STATE(1904)] = 54011,
  [SMALL_STATE(1905)] = 54098,
  [SMALL_STATE(1906)] = 54157,
  [SMALL_STATE(1907)] = 54216,
  [SMALL_STATE(1908)] = 54275,
  [SMALL_STATE(1909)] = 54334,
  [SMALL_STATE(1910)] = 54419,
  [SMALL_STATE(1911)] = 54522,
  [SMALL_STATE(1912)] = 54639,
  [SMALL_STATE(1913)] = 54756,
  [SMALL_STATE(1914)] = 54815,
  [SMALL_STATE(1915)] = 54880,
  [SMALL_STATE(1916)] = 54981,
  [SMALL_STATE(1917)] = 55040,
  [SMALL_STATE(1918)] = 55157,
  [SMALL_STATE(1919)] = 55234,
  [SMALL_STATE(1920)] = 55333,
  [SMALL_STATE(1921)] = 55420,
  [SMALL_STATE(1922)] = 55527,
  [SMALL_STATE(1923)] = 55632,
  [SMALL_STATE(1924)] = 55713,
  [SMALL_STATE(1925)] = 55830,
  [SMALL_STATE(1926)] = 55921,
  [SMALL_STATE(1927)] = 56038,
  [SMALL_STATE(1928)] = 56155,
  [SMALL_STATE(1929)] = 56226,
  [SMALL_STATE(1930)] = 56297,
  [SMALL_STATE(1931)] = 56368,
  [SMALL_STATE(1932)] = 56427,
  [SMALL_STATE(1933)] = 56486,
  [SMALL_STATE(1934)] = 56545,
  [SMALL_STATE(1935)] = 56661,
  [SMALL_STATE(1936)] = 56721,
  [SMALL_STATE(1937)] = 56779,
  [SMALL_STATE(1938)] = 56837,
  [SMALL_STATE(1939)] = 56955,
  [SMALL_STATE(1940)] = 57015,
  [SMALL_STATE(1941)] = 57131,
  [SMALL_STATE(1942)] = 57221,
  [SMALL_STATE(1943)] = 57301,
  [SMALL_STATE(1944)] = 57359,
  [SMALL_STATE(1945)] = 57427,
  [SMALL_STATE(1946)] = 57495,
  [SMALL_STATE(1947)] = 57563,
  [SMALL_STATE(1948)] = 57621,
  [SMALL_STATE(1949)] = 57679,
  [SMALL_STATE(1950)] = 57795,
  [SMALL_STATE(1951)] = 57911,
  [SMALL_STATE(1952)] = 57969,
  [SMALL_STATE(1953)] = 58049,
  [SMALL_STATE(1954)] = 58153,
  [SMALL_STATE(1955)] = 58211,
  [SMALL_STATE(1956)] = 58269,
  [SMALL_STATE(1957)] = 58329,
  [SMALL_STATE(1958)] = 58389,
  [SMALL_STATE(1959)] = 58449,
  [SMALL_STATE(1960)] = 58569,
  [SMALL_STATE(1961)] = 58627,
  [SMALL_STATE(1962)] = 58747,
  [SMALL_STATE(1963)] = 58863,
  [SMALL_STATE(1964)] = 58969,
  [SMALL_STATE(1965)] = 59027,
  [SMALL_STATE(1966)] = 59143,
  [SMALL_STATE(1967)] = 59201,
  [SMALL_STATE(1968)] = 59317,
  [SMALL_STATE(1969)] = 59375,
  [SMALL_STATE(1970)] = 59433,
  [SMALL_STATE(1971)] = 59549,
  [SMALL_STATE(1972)] = 59607,
  [SMALL_STATE(1973)] = 59665,
  [SMALL_STATE(1974)] = 59723,
  [SMALL_STATE(1975)] = 59809,
  [SMALL_STATE(1976)] = 59917,
  [SMALL_STATE(1977)] = 59975,
  [SMALL_STATE(1978)] = 60069,
  [SMALL_STATE(1979)] = 60189,
  [SMALL_STATE(1980)] = 60287,
  [SMALL_STATE(1981)] = 60345,
  [SMALL_STATE(1982)] = 60463,
  [SMALL_STATE(1983)] = 60563,
  [SMALL_STATE(1984)] = 60621,
  [SMALL_STATE(1985)] = 60741,
  [SMALL_STATE(1986)] = 60857,
  [SMALL_STATE(1987)] = 60959,
  [SMALL_STATE(1988)] = 61043,
  [SMALL_STATE(1989)] = 61129,
  [SMALL_STATE(1990)] = 61245,
  [SMALL_STATE(1991)] = 61331,
  [SMALL_STATE(1992)] = 61415,
  [SMALL_STATE(1993)] = 61517,
  [SMALL_STATE(1994)] = 61637,
  [SMALL_STATE(1995)] = 61737,
  [SMALL_STATE(1996)] = 61835,
  [SMALL_STATE(1997)] = 61893,
  [SMALL_STATE(1998)] = 61979,
  [SMALL_STATE(1999)] = 62085,
  [SMALL_STATE(2000)] = 62205,
  [SMALL_STATE(2001)] = 62309,
  [SMALL_STATE(2002)] = 62371,
  [SMALL_STATE(2003)] = 62435,
  [SMALL_STATE(2004)] = 62493,
  [SMALL_STATE(2005)] = 62551,
  [SMALL_STATE(2006)] = 62609,
  [SMALL_STATE(2007)] = 62667,
  [SMALL_STATE(2008)] = 62725,
  [SMALL_STATE(2009)] = 62783,
  [SMALL_STATE(2010)] = 62877,
  [SMALL_STATE(2011)] = 62935,
  [SMALL_STATE(2012)] = 62993,
  [SMALL_STATE(2013)] = 63051,
  [SMALL_STATE(2014)] = 63109,
  [SMALL_STATE(2015)] = 63167,
  [SMALL_STATE(2016)] = 63287,
  [SMALL_STATE(2017)] = 63345,
  [SMALL_STATE(2018)] = 63403,
  [SMALL_STATE(2019)] = 63461,
  [SMALL_STATE(2020)] = 63523,
  [SMALL_STATE(2021)] = 63581,
  [SMALL_STATE(2022)] = 63671,
  [SMALL_STATE(2023)] = 63729,
  [SMALL_STATE(2024)] = 63787,
  [SMALL_STATE(2025)] = 63903,
  [SMALL_STATE(2026)] = 63961,
  [SMALL_STATE(2027)] = 64033,
  [SMALL_STATE(2028)] = 64141,
  [SMALL_STATE(2029)] = 64257,
  [SMALL_STATE(2030)] = 64327,
  [SMALL_STATE(2031)] = 64385,
  [SMALL_STATE(2032)] = 64443,
  [SMALL_STATE(2033)] = 64501,
  [SMALL_STATE(2034)] = 64617,
  [SMALL_STATE(2035)] = 64687,
  [SMALL_STATE(2036)] = 64763,
  [SMALL_STATE(2037)] = 64821,
  [SMALL_STATE(2038)] = 64879,
  [SMALL_STATE(2039)] = 64941,
  [SMALL_STATE(2040)] = 64999,
  [SMALL_STATE(2041)] = 65057,
  [SMALL_STATE(2042)] = 65177,
  [SMALL_STATE(2043)] = 65297,
  [SMALL_STATE(2044)] = 65417,
  [SMALL_STATE(2045)] = 65491,
  [SMALL_STATE(2046)] = 65549,
  [SMALL_STATE(2047)] = 65607,
  [SMALL_STATE(2048)] = 65665,
  [SMALL_STATE(2049)] = 65781,
  [SMALL_STATE(2050)] = 65847,
  [SMALL_STATE(2051)] = 65963,
  [SMALL_STATE(2052)] = 66027,
  [SMALL_STATE(2053)] = 66143,
  [SMALL_STATE(2054)] = 66201,
  [SMALL_STATE(2055)] = 66259,
  [SMALL_STATE(2056)] = 66375,
  [SMALL_STATE(2057)] = 66491,
  [SMALL_STATE(2058)] = 66549,
  [SMALL_STATE(2059)] = 66633,
  [SMALL_STATE(2060)] = 66749,
  [SMALL_STATE(2061)] = 66865,
  [SMALL_STATE(2062)] = 66923,
  [SMALL_STATE(2063)] = 66981,
  [SMALL_STATE(2064)] = 67097,
  [SMALL_STATE(2065)] = 67155,
  [SMALL_STATE(2066)] = 67213,
  [SMALL_STATE(2067)] = 67329,
  [SMALL_STATE(2068)] = 67387,
  [SMALL_STATE(2069)] = 67503,
  [SMALL_STATE(2070)] = 67619,
  [SMALL_STATE(2071)] = 67677,
  [SMALL_STATE(2072)] = 67793,
  [SMALL_STATE(2073)] = 67851,
  [SMALL_STATE(2074)] = 67935,
  [SMALL_STATE(2075)] = 68051,
  [SMALL_STATE(2076)] = 68109,
  [SMALL_STATE(2077)] = 68225,
  [SMALL_STATE(2078)] = 68341,
  [SMALL_STATE(2079)] = 68399,
  [SMALL_STATE(2080)] = 68477,
  [SMALL_STATE(2081)] = 68535,
  [SMALL_STATE(2082)] = 68599,
  [SMALL_STATE(2083)] = 68657,
  [SMALL_STATE(2084)] = 68773,
  [SMALL_STATE(2085)] = 68851,
  [SMALL_STATE(2086)] = 68909,
  [SMALL_STATE(2087)] = 68985,
  [SMALL_STATE(2088)] = 69043,
  [SMALL_STATE(2089)] = 69101,
  [SMALL_STATE(2090)] = 69158,
  [SMALL_STATE(2091)] = 69215,
  [SMALL_STATE(2092)] = 69272,
  [SMALL_STATE(2093)] = 69329,
  [SMALL_STATE(2094)] = 69394,
  [SMALL_STATE(2095)] = 69451,
  [SMALL_STATE(2096)] = 69526,
  [SMALL_STATE(2097)] = 69641,
  [SMALL_STATE(2098)] = 69706,
  [SMALL_STATE(2099)] = 69763,
  [SMALL_STATE(2100)] = 69820,
  [SMALL_STATE(2101)] = 69879,
  [SMALL_STATE(2102)] = 69962,
  [SMALL_STATE(2103)] = 70019,
  [SMALL_STATE(2104)] = 70134,
  [SMALL_STATE(2105)] = 70191,
  [SMALL_STATE(2106)] = 70252,
  [SMALL_STATE(2107)] = 70309,
  [SMALL_STATE(2108)] = 70366,
  [SMALL_STATE(2109)] = 70447,
  [SMALL_STATE(2110)] = 70504,
  [SMALL_STATE(2111)] = 70581,
  [SMALL_STATE(2112)] = 70700,
  [SMALL_STATE(2113)] = 70819,
  [SMALL_STATE(2114)] = 70938,
  [SMALL_STATE(2115)] = 71007,
  [SMALL_STATE(2116)] = 71122,
  [SMALL_STATE(2117)] = 71183,
  [SMALL_STATE(2118)] = 71298,
  [SMALL_STATE(2119)] = 71413,
  [SMALL_STATE(2120)] = 71476,
  [SMALL_STATE(2121)] = 71533,
  [SMALL_STATE(2122)] = 71594,
  [SMALL_STATE(2123)] = 71713,
  [SMALL_STATE(2124)] = 71776,
  [SMALL_STATE(2125)] = 71839,
  [SMALL_STATE(2126)] = 71958,
  [SMALL_STATE(2127)] = 72021,
  [SMALL_STATE(2128)] = 72136,
  [SMALL_STATE(2129)] = 72255,
  [SMALL_STATE(2130)] = 72374,
  [SMALL_STATE(2131)] = 72489,
  [SMALL_STATE(2132)] = 72578,
  [SMALL_STATE(2133)] = 72635,
  [SMALL_STATE(2134)] = 72714,
  [SMALL_STATE(2135)] = 72817,
  [SMALL_STATE(2136)] = 72880,
  [SMALL_STATE(2137)] = 72999,
  [SMALL_STATE(2138)] = 73118,
  [SMALL_STATE(2139)] = 73237,
  [SMALL_STATE(2140)] = 73352,
  [SMALL_STATE(2141)] = 73471,
  [SMALL_STATE(2142)] = 73586,
  [SMALL_STATE(2143)] = 73643,
  [SMALL_STATE(2144)] = 73700,
  [SMALL_STATE(2145)] = 73757,
  [SMALL_STATE(2146)] = 73814,
  [SMALL_STATE(2147)] = 73879,
  [SMALL_STATE(2148)] = 73998,
  [SMALL_STATE(2149)] = 74055,
  [SMALL_STATE(2150)] = 74160,
  [SMALL_STATE(2151)] = 74279,
  [SMALL_STATE(2152)] = 74336,
  [SMALL_STATE(2153)] = 74455,
  [SMALL_STATE(2154)] = 74540,
  [SMALL_STATE(2155)] = 74597,
  [SMALL_STATE(2156)] = 74654,
  [SMALL_STATE(2157)] = 74771,
  [SMALL_STATE(2158)] = 74828,
  [SMALL_STATE(2159)] = 74925,
  [SMALL_STATE(2160)] = 74982,
  [SMALL_STATE(2161)] = 75039,
  [SMALL_STATE(2162)] = 75138,
  [SMALL_STATE(2163)] = 75255,
  [SMALL_STATE(2164)] = 75312,
  [SMALL_STATE(2165)] = 75369,
  [SMALL_STATE(2166)] = 75426,
  [SMALL_STATE(2167)] = 75527,
  [SMALL_STATE(2168)] = 75646,
  [SMALL_STATE(2169)] = 75707,
  [SMALL_STATE(2170)] = 75822,
  [SMALL_STATE(2171)] = 75905,
  [SMALL_STATE(2172)] = 75990,
  [SMALL_STATE(2173)] = 76105,
  [SMALL_STATE(2174)] = 76220,
  [SMALL_STATE(2175)] = 76281,
  [SMALL_STATE(2176)] = 76396,
  [SMALL_STATE(2177)] = 76455,
  [SMALL_STATE(2178)] = 76514,
  [SMALL_STATE(2179)] = 76629,
  [SMALL_STATE(2180)] = 76686,
  [SMALL_STATE(2181)] = 76743,
  [SMALL_STATE(2182)] = 76858,
  [SMALL_STATE(2183)] = 76915,
  [SMALL_STATE(2184)] = 76972,
  [SMALL_STATE(2185)] = 77029,
  [SMALL_STATE(2186)] = 77086,
  [SMALL_STATE(2187)] = 77201,
  [SMALL_STATE(2188)] = 77316,
  [SMALL_STATE(2189)] = 77373,
  [SMALL_STATE(2190)] = 77430,
  [SMALL_STATE(2191)] = 77493,
  [SMALL_STATE(2192)] = 77608,
  [SMALL_STATE(2193)] = 77665,
  [SMALL_STATE(2194)] = 77722,
  [SMALL_STATE(2195)] = 77841,
  [SMALL_STATE(2196)] = 77898,
  [SMALL_STATE(2197)] = 77955,
  [SMALL_STATE(2198)] = 78012,
  [SMALL_STATE(2199)] = 78069,
  [SMALL_STATE(2200)] = 78188,
  [SMALL_STATE(2201)] = 78307,
  [SMALL_STATE(2202)] = 78422,
  [SMALL_STATE(2203)] = 78529,
  [SMALL_STATE(2204)] = 78596,
  [SMALL_STATE(2205)] = 78715,
  [SMALL_STATE(2206)] = 78782,
  [SMALL_STATE(2207)] = 78901,
  [SMALL_STATE(2208)] = 78966,
  [SMALL_STATE(2209)] = 79023,
  [SMALL_STATE(2210)] = 79116,
  [SMALL_STATE(2211)] = 79173,
  [SMALL_STATE(2212)] = 79238,
  [SMALL_STATE(2213)] = 79295,
  [SMALL_STATE(2214)] = 79352,
  [SMALL_STATE(2215)] = 79409,
  [SMALL_STATE(2216)] = 79470,
  [SMALL_STATE(2217)] = 79535,
  [SMALL_STATE(2218)] = 79654,
  [SMALL_STATE(2219)] = 79773,
  [SMALL_STATE(2220)] = 79830,
  [SMALL_STATE(2221)] = 79949,
  [SMALL_STATE(2222)] = 80068,
  [SMALL_STATE(2223)] = 80187,
  [SMALL_STATE(2224)] = 80306,
  [SMALL_STATE(2225)] = 80363,
  [SMALL_STATE(2226)] = 80426,
  [SMALL_STATE(2227)] = 80483,
  [SMALL_STATE(2228)] = 80598,
  [SMALL_STATE(2229)] = 80658,
  [SMALL_STATE(2230)] = 80714,
  [SMALL_STATE(2231)] = 80770,
  [SMALL_STATE(2232)] = 80826,
  [SMALL_STATE(2233)] = 80882,
  [SMALL_STATE(2234)] = 80996,
  [SMALL_STATE(2235)] = 81052,
  [SMALL_STATE(2236)] = 81108,
  [SMALL_STATE(2237)] = 81222,
  [SMALL_STATE(2238)] = 81278,
  [SMALL_STATE(2239)] = 81334,
  [SMALL_STATE(2240)] = 81398,
  [SMALL_STATE(2241)] = 81458,
  [SMALL_STATE(2242)] = 81516,
  [SMALL_STATE(2243)] = 81630,
  [SMALL_STATE(2244)] = 81690,
  [SMALL_STATE(2245)] = 81758,
  [SMALL_STATE(2246)] = 81826,
  [SMALL_STATE(2247)] = 81884,
  [SMALL_STATE(2248)] = 81960,
  [SMALL_STATE(2249)] = 82024,
  [SMALL_STATE(2250)] = 82106,
  [SMALL_STATE(2251)] = 82168,
  [SMALL_STATE(2252)] = 82282,
  [SMALL_STATE(2253)] = 82338,
  [SMALL_STATE(2254)] = 82394,
  [SMALL_STATE(2255)] = 82510,
  [SMALL_STATE(2256)] = 82624,
  [SMALL_STATE(2257)] = 82686,
  [SMALL_STATE(2258)] = 82748,
  [SMALL_STATE(2259)] = 82804,
  [SMALL_STATE(2260)] = 82878,
  [SMALL_STATE(2261)] = 82934,
  [SMALL_STATE(2262)] = 82990,
  [SMALL_STATE(2263)] = 83046,
  [SMALL_STATE(2264)] = 83102,
  [SMALL_STATE(2265)] = 83158,
  [SMALL_STATE(2266)] = 83218,
  [SMALL_STATE(2267)] = 83276,
  [SMALL_STATE(2268)] = 83334,
  [SMALL_STATE(2269)] = 83390,
  [SMALL_STATE(2270)] = 83452,
  [SMALL_STATE(2271)] = 83508,
  [SMALL_STATE(2272)] = 83564,
  [SMALL_STATE(2273)] = 83620,
  [SMALL_STATE(2274)] = 83676,
  [SMALL_STATE(2275)] = 83732,
  [SMALL_STATE(2276)] = 83788,
  [SMALL_STATE(2277)] = 83844,
  [SMALL_STATE(2278)] = 83906,
  [SMALL_STATE(2279)] = 83962,
  [SMALL_STATE(2280)] = 84036,
  [SMALL_STATE(2281)] = 84108,
  [SMALL_STATE(2282)] = 84164,
  [SMALL_STATE(2283)] = 84220,
  [SMALL_STATE(2284)] = 84278,
  [SMALL_STATE(2285)] = 84334,
  [SMALL_STATE(2286)] = 84390,
  [SMALL_STATE(2287)] = 84446,
  [SMALL_STATE(2288)] = 84506,
  [SMALL_STATE(2289)] = 84562,
  [SMALL_STATE(2290)] = 84618,
  [SMALL_STATE(2291)] = 84674,
  [SMALL_STATE(2292)] = 84730,
  [SMALL_STATE(2293)] = 84786,
  [SMALL_STATE(2294)] = 84842,
  [SMALL_STATE(2295)] = 84956,
  [SMALL_STATE(2296)] = 85026,
  [SMALL_STATE(2297)] = 85082,
  [SMALL_STATE(2298)] = 85152,
  [SMALL_STATE(2299)] = 85208,
  [SMALL_STATE(2300)] = 85264,
  [SMALL_STATE(2301)] = 85320,
  [SMALL_STATE(2302)] = 85376,
  [SMALL_STATE(2303)] = 85490,
  [SMALL_STATE(2304)] = 85546,
  [SMALL_STATE(2305)] = 85610,
  [SMALL_STATE(2306)] = 85666,
  [SMALL_STATE(2307)] = 85782,
  [SMALL_STATE(2308)] = 85838,
  [SMALL_STATE(2309)] = 85952,
  [SMALL_STATE(2310)] = 86008,
  [SMALL_STATE(2311)] = 86122,
  [SMALL_STATE(2312)] = 86178,
  [SMALL_STATE(2313)] = 86236,
  [SMALL_STATE(2314)] = 86294,
  [SMALL_STATE(2315)] = 86408,
  [SMALL_STATE(2316)] = 86470,
  [SMALL_STATE(2317)] = 86542,
  [SMALL_STATE(2318)] = 86604,
  [SMALL_STATE(2319)] = 86666,
  [SMALL_STATE(2320)] = 86780,
  [SMALL_STATE(2321)] = 86836,
  [SMALL_STATE(2322)] = 86892,
  [SMALL_STATE(2323)] = 86954,
  [SMALL_STATE(2324)] = 87026,
  [SMALL_STATE(2325)] = 87082,
  [SMALL_STATE(2326)] = 87138,
  [SMALL_STATE(2327)] = 87252,
  [SMALL_STATE(2328)] = 87314,
  [SMALL_STATE(2329)] = 87370,
  [SMALL_STATE(2330)] = 87484,
  [SMALL_STATE(2331)] = 87540,
  [SMALL_STATE(2332)] = 87602,
  [SMALL_STATE(2333)] = 87660,
  [SMALL_STATE(2334)] = 87716,
  [SMALL_STATE(2335)] = 87804,
  [SMALL_STATE(2336)] = 87860,
  [SMALL_STATE(2337)] = 87916,
  [SMALL_STATE(2338)] = 88030,
  [SMALL_STATE(2339)] = 88104,
  [SMALL_STATE(2340)] = 88160,
  [SMALL_STATE(2341)] = 88216,
  [SMALL_STATE(2342)] = 88332,
  [SMALL_STATE(2343)] = 88410,
  [SMALL_STATE(2344)] = 88466,
  [SMALL_STATE(2345)] = 88522,
  [SMALL_STATE(2346)] = 88580,
  [SMALL_STATE(2347)] = 88636,
  [SMALL_STATE(2348)] = 88694,
  [SMALL_STATE(2349)] = 88752,
  [SMALL_STATE(2350)] = 88866,
  [SMALL_STATE(2351)] = 88922,
  [SMALL_STATE(2352)] = 88978,
  [SMALL_STATE(2353)] = 89034,
  [SMALL_STATE(2354)] = 89090,
  [SMALL_STATE(2355)] = 89148,
  [SMALL_STATE(2356)] = 89204,
  [SMALL_STATE(2357)] = 89260,
  [SMALL_STATE(2358)] = 89322,
  [SMALL_STATE(2359)] = 89390,
  [SMALL_STATE(2360)] = 89458,
  [SMALL_STATE(2361)] = 89526,
  [SMALL_STATE(2362)] = 89582,
  [SMALL_STATE(2363)] = 89644,
  [SMALL_STATE(2364)] = 89700,
  [SMALL_STATE(2365)] = 89760,
  [SMALL_STATE(2366)] = 89828,
  [SMALL_STATE(2367)] = 89884,
  [SMALL_STATE(2368)] = 89954,
  [SMALL_STATE(2369)] = 90018,
  [SMALL_STATE(2370)] = 90090,
  [SMALL_STATE(2371)] = 90164,
  [SMALL_STATE(2372)] = 90220,
  [SMALL_STATE(2373)] = 90276,
  [SMALL_STATE(2374)] = 90332,
  [SMALL_STATE(2375)] = 90400,
  [SMALL_STATE(2376)] = 90468,
  [SMALL_STATE(2377)] = 90570,
  [SMALL_STATE(2378)] = 90674,
  [SMALL_STATE(2379)] = 90732,
  [SMALL_STATE(2380)] = 90788,
  [SMALL_STATE(2381)] = 90844,
  [SMALL_STATE(2382)] = 90912,
  [SMALL_STATE(2383)] = 90968,
  [SMALL_STATE(2384)] = 91024,
  [SMALL_STATE(2385)] = 91082,
  [SMALL_STATE(2386)] = 91138,
  [SMALL_STATE(2387)] = 91194,
  [SMALL_STATE(2388)] = 91250,
  [SMALL_STATE(2389)] = 91334,
  [SMALL_STATE(2390)] = 91396,
  [SMALL_STATE(2391)] = 91458,
  [SMALL_STATE(2392)] = 91514,
  [SMALL_STATE(2393)] = 91572,
  [SMALL_STATE(2394)] = 91630,
  [SMALL_STATE(2395)] = 91686,
  [SMALL_STATE(2396)] = 91742,
  [SMALL_STATE(2397)] = 91798,
  [SMALL_STATE(2398)] = 91854,
  [SMALL_STATE(2399)] = 91910,
  [SMALL_STATE(2400)] = 92024,
  [SMALL_STATE(2401)] = 92138,
  [SMALL_STATE(2402)] = 92196,
  [SMALL_STATE(2403)] = 92292,
  [SMALL_STATE(2404)] = 92390,
  [SMALL_STATE(2405)] = 92490,
  [SMALL_STATE(2406)] = 92572,
  [SMALL_STATE(2407)] = 92656,
  [SMALL_STATE(2408)] = 92718,
  [SMALL_STATE(2409)] = 92774,
  [SMALL_STATE(2410)] = 92866,
  [SMALL_STATE(2411)] = 92972,
  [SMALL_STATE(2412)] = 93086,
  [SMALL_STATE(2413)] = 93142,
  [SMALL_STATE(2414)] = 93256,
  [SMALL_STATE(2415)] = 93324,
  [SMALL_STATE(2416)] = 93380,
  [SMALL_STATE(2417)] = 93436,
  [SMALL_STATE(2418)] = 93492,
  [SMALL_STATE(2419)] = 93556,
  [SMALL_STATE(2420)] = 93618,
  [SMALL_STATE(2421)] = 93732,
  [SMALL_STATE(2422)] = 93846,
  [SMALL_STATE(2423)] = 93904,
  [SMALL_STATE(2424)] = 94017,
  [SMALL_STATE(2425)] = 94130,
  [SMALL_STATE(2426)] = 94197,
  [SMALL_STATE(2427)] = 94264,
  [SMALL_STATE(2428)] = 94319,
  [SMALL_STATE(2429)] = 94432,
  [SMALL_STATE(2430)] = 94507,
  [SMALL_STATE(2431)] = 94568,
  [SMALL_STATE(2432)] = 94633,
  [SMALL_STATE(2433)] = 94746,
  [SMALL_STATE(2434)] = 94801,
  [SMALL_STATE(2435)] = 94882,
  [SMALL_STATE(2436)] = 94937,
  [SMALL_STATE(2437)] = 94992,
  [SMALL_STATE(2438)] = 95047,
  [SMALL_STATE(2439)] = 95160,
  [SMALL_STATE(2440)] = 95221,
  [SMALL_STATE(2441)] = 95288,
  [SMALL_STATE(2442)] = 95365,
  [SMALL_STATE(2443)] = 95478,
  [SMALL_STATE(2444)] = 95545,
  [SMALL_STATE(2445)] = 95612,
  [SMALL_STATE(2446)] = 95673,
  [SMALL_STATE(2447)] = 95786,
  [SMALL_STATE(2448)] = 95873,
  [SMALL_STATE(2449)] = 95940,
  [SMALL_STATE(2450)] = 96037,
  [SMALL_STATE(2451)] = 96110,
  [SMALL_STATE(2452)] = 96173,
  [SMALL_STATE(2453)] = 96230,
  [SMALL_STATE(2454)] = 96307,
  [SMALL_STATE(2455)] = 96406,
  [SMALL_STATE(2456)] = 96471,
  [SMALL_STATE(2457)] = 96526,
  [SMALL_STATE(2458)] = 96583,
  [SMALL_STATE(2459)] = 96642,
  [SMALL_STATE(2460)] = 96743,
  [SMALL_STATE(2461)] = 96846,
  [SMALL_STATE(2462)] = 96901,
  [SMALL_STATE(2463)] = 96960,
  [SMALL_STATE(2464)] = 97015,
  [SMALL_STATE(2465)] = 97116,
  [SMALL_STATE(2466)] = 97219,
  [SMALL_STATE(2467)] = 97302,
  [SMALL_STATE(2468)] = 97365,
  [SMALL_STATE(2469)] = 97478,
  [SMALL_STATE(2470)] = 97537,
  [SMALL_STATE(2471)] = 97604,
  [SMALL_STATE(2472)] = 97663,
  [SMALL_STATE(2473)] = 97744,
  [SMALL_STATE(2474)] = 97827,
  [SMALL_STATE(2475)] = 97894,
  [SMALL_STATE(2476)] = 97953,
  [SMALL_STATE(2477)] = 98012,
  [SMALL_STATE(2478)] = 98125,
  [SMALL_STATE(2479)] = 98184,
  [SMALL_STATE(2480)] = 98243,
  [SMALL_STATE(2481)] = 98298,
  [SMALL_STATE(2482)] = 98411,
  [SMALL_STATE(2483)] = 98524,
  [SMALL_STATE(2484)] = 98615,
  [SMALL_STATE(2485)] = 98698,
  [SMALL_STATE(2486)] = 98761,
  [SMALL_STATE(2487)] = 98858,
  [SMALL_STATE(2488)] = 98957,
  [SMALL_STATE(2489)] = 99012,
  [SMALL_STATE(2490)] = 99067,
  [SMALL_STATE(2491)] = 99128,
  [SMALL_STATE(2492)] = 99189,
  [SMALL_STATE(2493)] = 99256,
  [SMALL_STATE(2494)] = 99337,
  [SMALL_STATE(2495)] = 99398,
  [SMALL_STATE(2496)] = 99455,
  [SMALL_STATE(2497)] = 99512,
  [SMALL_STATE(2498)] = 99571,
  [SMALL_STATE(2499)] = 99630,
  [SMALL_STATE(2500)] = 99687,
  [SMALL_STATE(2501)] = 99770,
  [SMALL_STATE(2502)] = 99883,
  [SMALL_STATE(2503)] = 99950,
  [SMALL_STATE(2504)] = 100017,
  [SMALL_STATE(2505)] = 100130,
  [SMALL_STATE(2506)] = 100243,
  [SMALL_STATE(2507)] = 100348,
  [SMALL_STATE(2508)] = 100415,
  [SMALL_STATE(2509)] = 100470,
  [SMALL_STATE(2510)] = 100525,
  [SMALL_STATE(2511)] = 100582,
  [SMALL_STATE(2512)] = 100695,
  [SMALL_STATE(2513)] = 100750,
  [SMALL_STATE(2514)] = 100863,
  [SMALL_STATE(2515)] = 100918,
  [SMALL_STATE(2516)] = 100979,
  [SMALL_STATE(2517)] = 101092,
  [SMALL_STATE(2518)] = 101147,
  [SMALL_STATE(2519)] = 101210,
  [SMALL_STATE(2520)] = 101269,
  [SMALL_STATE(2521)] = 101382,
  [SMALL_STATE(2522)] = 101441,
  [SMALL_STATE(2523)] = 101508,
  [SMALL_STATE(2524)] = 101591,
  [SMALL_STATE(2525)] = 101658,
  [SMALL_STATE(2526)] = 101771,
  [SMALL_STATE(2527)] = 101884,
  [SMALL_STATE(2528)] = 101997,
  [SMALL_STATE(2529)] = 102110,
  [SMALL_STATE(2530)] = 102223,
  [SMALL_STATE(2531)] = 102290,
  [SMALL_STATE(2532)] = 102381,
  [SMALL_STATE(2533)] = 102440,
  [SMALL_STATE(2534)] = 102499,
  [SMALL_STATE(2535)] = 102558,
  [SMALL_STATE(2536)] = 102613,
  [SMALL_STATE(2537)] = 102670,
  [SMALL_STATE(2538)] = 102729,
  [SMALL_STATE(2539)] = 102786,
  [SMALL_STATE(2540)] = 102843,
  [SMALL_STATE(2541)] = 102902,
  [SMALL_STATE(2542)] = 103015,
  [SMALL_STATE(2543)] = 103082,
  [SMALL_STATE(2544)] = 103149,
  [SMALL_STATE(2545)] = 103262,
  [SMALL_STATE(2546)] = 103325,
  [SMALL_STATE(2547)] = 103380,
  [SMALL_STATE(2548)] = 103447,
  [SMALL_STATE(2549)] = 103504,
  [SMALL_STATE(2550)] = 103609,
  [SMALL_STATE(2551)] = 103722,
  [SMALL_STATE(2552)] = 103809,
  [SMALL_STATE(2553)] = 103922,
  [SMALL_STATE(2554)] = 103987,
  [SMALL_STATE(2555)] = 104100,
  [SMALL_STATE(2556)] = 104165,
  [SMALL_STATE(2557)] = 104220,
  [SMALL_STATE(2558)] = 104279,
  [SMALL_STATE(2559)] = 104392,
  [SMALL_STATE(2560)] = 104447,
  [SMALL_STATE(2561)] = 104506,
  [SMALL_STATE(2562)] = 104567,
  [SMALL_STATE(2563)] = 104626,
  [SMALL_STATE(2564)] = 104693,
  [SMALL_STATE(2565)] = 104752,
  [SMALL_STATE(2566)] = 104819,
  [SMALL_STATE(2567)] = 104878,
  [SMALL_STATE(2568)] = 104933,
  [SMALL_STATE(2569)] = 104988,
  [SMALL_STATE(2570)] = 105047,
  [SMALL_STATE(2571)] = 105160,
  [SMALL_STATE(2572)] = 105215,
  [SMALL_STATE(2573)] = 105282,
  [SMALL_STATE(2574)] = 105395,
  [SMALL_STATE(2575)] = 105478,
  [SMALL_STATE(2576)] = 105545,
  [SMALL_STATE(2577)] = 105604,
  [SMALL_STATE(2578)] = 105661,
  [SMALL_STATE(2579)] = 105774,
  [SMALL_STATE(2580)] = 105833,
  [SMALL_STATE(2581)] = 105946,
  [SMALL_STATE(2582)] = 106059,
  [SMALL_STATE(2583)] = 106126,
  [SMALL_STATE(2584)] = 106239,
  [SMALL_STATE(2585)] = 106294,
  [SMALL_STATE(2586)] = 106407,
  [SMALL_STATE(2587)] = 106474,
  [SMALL_STATE(2588)] = 106529,
  [SMALL_STATE(2589)] = 106592,
  [SMALL_STATE(2590)] = 106687,
  [SMALL_STATE(2591)] = 106742,
  [SMALL_STATE(2592)] = 106797,
  [SMALL_STATE(2593)] = 106878,
  [SMALL_STATE(2594)] = 106933,
  [SMALL_STATE(2595)] = 107032,
  [SMALL_STATE(2596)] = 107145,
  [SMALL_STATE(2597)] = 107208,
  [SMALL_STATE(2598)] = 107271,
  [SMALL_STATE(2599)] = 107384,
  [SMALL_STATE(2600)] = 107451,
  [SMALL_STATE(2601)] = 107506,
  [SMALL_STATE(2602)] = 107561,
  [SMALL_STATE(2603)] = 107658,
  [SMALL_STATE(2604)] = 107731,
  [SMALL_STATE(2605)] = 107844,
  [SMALL_STATE(2606)] = 107925,
  [SMALL_STATE(2607)] = 107980,
  [SMALL_STATE(2608)] = 108035,
  [SMALL_STATE(2609)] = 108094,
  [SMALL_STATE(2610)] = 108155,
  [SMALL_STATE(2611)] = 108212,
  [SMALL_STATE(2612)] = 108267,
  [SMALL_STATE(2613)] = 108326,
  [SMALL_STATE(2614)] = 108399,
  [SMALL_STATE(2615)] = 108512,
  [SMALL_STATE(2616)] = 108625,
  [SMALL_STATE(2617)] = 108684,
  [SMALL_STATE(2618)] = 108797,
  [SMALL_STATE(2619)] = 108872,
  [SMALL_STATE(2620)] = 108929,
  [SMALL_STATE(2621)] = 108988,
  [SMALL_STATE(2622)] = 109047,
  [SMALL_STATE(2623)] = 109114,
  [SMALL_STATE(2624)] = 109227,
  [SMALL_STATE(2625)] = 109318,
  [SMALL_STATE(2626)] = 109373,
  [SMALL_STATE(2627)] = 109486,
  [SMALL_STATE(2628)] = 109541,
  [SMALL_STATE(2629)] = 109596,
  [SMALL_STATE(2630)] = 109651,
  [SMALL_STATE(2631)] = 109764,
  [SMALL_STATE(2632)] = 109831,
  [SMALL_STATE(2633)] = 109886,
  [SMALL_STATE(2634)] = 109999,
  [SMALL_STATE(2635)] = 110114,
  [SMALL_STATE(2636)] = 110169,
  [SMALL_STATE(2637)] = 110250,
  [SMALL_STATE(2638)] = 110305,
  [SMALL_STATE(2639)] = 110360,
  [SMALL_STATE(2640)] = 110415,
  [SMALL_STATE(2641)] = 110528,
  [SMALL_STATE(2642)] = 110583,
  [SMALL_STATE(2643)] = 110646,
  [SMALL_STATE(2644)] = 110733,
  [SMALL_STATE(2645)] = 110810,
  [SMALL_STATE(2646)] = 110865,
  [SMALL_STATE(2647)] = 110960,
  [SMALL_STATE(2648)] = 111073,
  [SMALL_STATE(2649)] = 111128,
  [SMALL_STATE(2650)] = 111183,
  [SMALL_STATE(2651)] = 111238,
  [SMALL_STATE(2652)] = 111301,
  [SMALL_STATE(2653)] = 111362,
  [SMALL_STATE(2654)] = 111463,
  [SMALL_STATE(2655)] = 111520,
  [SMALL_STATE(2656)] = 111595,
  [SMALL_STATE(2657)] = 111650,
  [SMALL_STATE(2658)] = 111753,
  [SMALL_STATE(2659)] = 111820,
  [SMALL_STATE(2660)] = 111875,
  [SMALL_STATE(2661)] = 111980,
  [SMALL_STATE(2662)] = 112063,
  [SMALL_STATE(2663)] = 112118,
  [SMALL_STATE(2664)] = 112213,
  [SMALL_STATE(2665)] = 112280,
  [SMALL_STATE(2666)] = 112335,
  [SMALL_STATE(2667)] = 112390,
  [SMALL_STATE(2668)] = 112457,
  [SMALL_STATE(2669)] = 112540,
  [SMALL_STATE(2670)] = 112653,
  [SMALL_STATE(2671)] = 112766,
  [SMALL_STATE(2672)] = 112823,
  [SMALL_STATE(2673)] = 112936,
  [SMALL_STATE(2674)] = 113003,
  [SMALL_STATE(2675)] = 113116,
  [SMALL_STATE(2676)] = 113229,
  [SMALL_STATE(2677)] = 113329,
  [SMALL_STATE(2678)] = 113403,
  [SMALL_STATE(2679)] = 113505,
  [SMALL_STATE(2680)] = 113579,
  [SMALL_STATE(2681)] = 113689,
  [SMALL_STATE(2682)] = 113771,
  [SMALL_STATE(2683)] = 113865,
  [SMALL_STATE(2684)] = 113961,
  [SMALL_STATE(2685)] = 114071,
  [SMALL_STATE(2686)] = 114149,
  [SMALL_STATE(2687)] = 114247,
  [SMALL_STATE(2688)] = 114307,
  [SMALL_STATE(2689)] = 114375,
  [SMALL_STATE(2690)] = 114485,
  [SMALL_STATE(2691)] = 114565,
  [SMALL_STATE(2692)] = 114623,
  [SMALL_STATE(2693)] = 114699,
  [SMALL_STATE(2694)] = 114759,
  [SMALL_STATE(2695)] = 114817,
  [SMALL_STATE(2696)] = 114877,
  [SMALL_STATE(2697)] = 114987,
  [SMALL_STATE(2698)] = 115053,
  [SMALL_STATE(2699)] = 115121,
  [SMALL_STATE(2700)] = 115189,
  [SMALL_STATE(2701)] = 115257,
  [SMALL_STATE(2702)] = 115313,
  [SMALL_STATE(2703)] = 115375,
  [SMALL_STATE(2704)] = 115479,
  [SMALL_STATE(2705)] = 115541,
  [SMALL_STATE(2706)] = 115603,
  [SMALL_STATE(2707)] = 115665,
  [SMALL_STATE(2708)] = 115727,
  [SMALL_STATE(2709)] = 115787,
  [SMALL_STATE(2710)] = 115897,
  [SMALL_STATE(2711)] = 116007,
  [SMALL_STATE(2712)] = 116075,
  [SMALL_STATE(2713)] = 116147,
  [SMALL_STATE(2714)] = 116257,
  [SMALL_STATE(2715)] = 116343,
  [SMALL_STATE(2716)] = 116433,
  [SMALL_STATE(2717)] = 116493,
  [SMALL_STATE(2718)] = 116561,
  [SMALL_STATE(2719)] = 116629,
  [SMALL_STATE(2720)] = 116701,
  [SMALL_STATE(2721)] = 116811,
  [SMALL_STATE(2722)] = 116891,
  [SMALL_STATE(2723)] = 116951,
  [SMALL_STATE(2724)] = 117013,
  [SMALL_STATE(2725)] = 117069,
  [SMALL_STATE(2726)] = 117179,
  [SMALL_STATE(2727)] = 117251,
  [SMALL_STATE(2728)] = 117307,
  [SMALL_STATE(2729)] = 117381,
  [SMALL_STATE(2730)] = 117441,
  [SMALL_STATE(2731)] = 117523,
  [SMALL_STATE(2732)] = 117601,
  [SMALL_STATE(2733)] = 117669,
  [SMALL_STATE(2734)] = 117737,
  [SMALL_STATE(2735)] = 117799,
  [SMALL_STATE(2736)] = 117867,
  [SMALL_STATE(2737)] = 117945,
  [SMALL_STATE(2738)] = 118013,
  [SMALL_STATE(2739)] = 118081,
  [SMALL_STATE(2740)] = 118191,
  [SMALL_STATE(2741)] = 118301,
  [SMALL_STATE(2742)] = 118375,
  [SMALL_STATE(2743)] = 118447,
  [SMALL_STATE(2744)] = 118515,
  [SMALL_STATE(2745)] = 118589,
  [SMALL_STATE(2746)] = 118647,
  [SMALL_STATE(2747)] = 118715,
  [SMALL_STATE(2748)] = 118825,
  [SMALL_STATE(2749)] = 118935,
  [SMALL_STATE(2750)] = 119045,
  [SMALL_STATE(2751)] = 119155,
  [SMALL_STATE(2752)] = 119209,
  [SMALL_STATE(2753)] = 119319,
  [SMALL_STATE(2754)] = 119387,
  [SMALL_STATE(2755)] = 119443,
  [SMALL_STATE(2756)] = 119514,
  [SMALL_STATE(2757)] = 119581,
  [SMALL_STATE(2758)] = 119640,
  [SMALL_STATE(2759)] = 119695,
  [SMALL_STATE(2760)] = 119754,
  [SMALL_STATE(2761)] = 119819,
  [SMALL_STATE(2762)] = 119890,
  [SMALL_STATE(2763)] = 119945,
  [SMALL_STATE(2764)] = 120016,
  [SMALL_STATE(2765)] = 120071,
  [SMALL_STATE(2766)] = 120126,
  [SMALL_STATE(2767)] = 120181,
  [SMALL_STATE(2768)] = 120240,
  [SMALL_STATE(2769)] = 120295,
  [SMALL_STATE(2770)] = 120366,
  [SMALL_STATE(2771)] = 120425,
  [SMALL_STATE(2772)] = 120492,
  [SMALL_STATE(2773)] = 120563,
  [SMALL_STATE(2774)] = 120634,
  [SMALL_STATE(2775)] = 120705,
  [SMALL_STATE(2776)] = 120776,
  [SMALL_STATE(2777)] = 120831,
  [SMALL_STATE(2778)] = 120886,
  [SMALL_STATE(2779)] = 120947,
  [SMALL_STATE(2780)] = 121018,
  [SMALL_STATE(2781)] = 121089,
  [SMALL_STATE(2782)] = 121148,
  [SMALL_STATE(2783)] = 121207,
  [SMALL_STATE(2784)] = 121260,
  [SMALL_STATE(2785)] = 121313,
  [SMALL_STATE(2786)] = 121372,
  [SMALL_STATE(2787)] = 121443,
  [SMALL_STATE(2788)] = 121514,
  [SMALL_STATE(2789)] = 121569,
  [SMALL_STATE(2790)] = 121640,
  [SMALL_STATE(2791)] = 121711,
  [SMALL_STATE(2792)] = 121766,
  [SMALL_STATE(2793)] = 121837,
  [SMALL_STATE(2794)] = 121894,
  [SMALL_STATE(2795)] = 121949,
  [SMALL_STATE(2796)] = 122020,
  [SMALL_STATE(2797)] = 122075,
  [SMALL_STATE(2798)] = 122133,
  [SMALL_STATE(2799)] = 122191,
  [SMALL_STATE(2800)] = 122243,
  [SMALL_STATE(2801)] = 122295,
  [SMALL_STATE(2802)] = 122349,
  [SMALL_STATE(2803)] = 122401,
  [SMALL_STATE(2804)] = 122465,
  [SMALL_STATE(2805)] = 122527,
  [SMALL_STATE(2806)] = 122589,
  [SMALL_STATE(2807)] = 122651,
  [SMALL_STATE(2808)] = 122713,
  [SMALL_STATE(2809)] = 122777,
  [SMALL_STATE(2810)] = 122841,
  [SMALL_STATE(2811)] = 122905,
  [SMALL_STATE(2812)] = 122967,
  [SMALL_STATE(2813)] = 123025,
  [SMALL_STATE(2814)] = 123083,
  [SMALL_STATE(2815)] = 123147,
  [SMALL_STATE(2816)] = 123209,
  [SMALL_STATE(2817)] = 123273,
  [SMALL_STATE(2818)] = 123337,
  [SMALL_STATE(2819)] = 123399,
  [SMALL_STATE(2820)] = 123461,
  [SMALL_STATE(2821)] = 123523,
  [SMALL_STATE(2822)] = 123585,
  [SMALL_STATE(2823)] = 123647,
  [SMALL_STATE(2824)] = 123711,
  [SMALL_STATE(2825)] = 123773,
  [SMALL_STATE(2826)] = 123827,
  [SMALL_STATE(2827)] = 123879,
  [SMALL_STATE(2828)] = 123933,
  [SMALL_STATE(2829)] = 123995,
  [SMALL_STATE(2830)] = 124049,
  [SMALL_STATE(2831)] = 124111,
  [SMALL_STATE(2832)] = 124173,
  [SMALL_STATE(2833)] = 124235,
  [SMALL_STATE(2834)] = 124289,
  [SMALL_STATE(2835)] = 124343,
  [SMALL_STATE(2836)] = 124399,
  [SMALL_STATE(2837)] = 124461,
  [SMALL_STATE(2838)] = 124513,
  [SMALL_STATE(2839)] = 124577,
  [SMALL_STATE(2840)] = 124639,
  [SMALL_STATE(2841)] = 124701,
  [SMALL_STATE(2842)] = 124753,
  [SMALL_STATE(2843)] = 124805,
  [SMALL_STATE(2844)] = 124857,
  [SMALL_STATE(2845)] = 124909,
  [SMALL_STATE(2846)] = 124961,
  [SMALL_STATE(2847)] = 125023,
  [SMALL_STATE(2848)] = 125085,
  [SMALL_STATE(2849)] = 125137,
  [SMALL_STATE(2850)] = 125201,
  [SMALL_STATE(2851)] = 125253,
  [SMALL_STATE(2852)] = 125315,
  [SMALL_STATE(2853)] = 125377,
  [SMALL_STATE(2854)] = 125429,
  [SMALL_STATE(2855)] = 125483,
  [SMALL_STATE(2856)] = 125537,
  [SMALL_STATE(2857)] = 125589,
  [SMALL_STATE(2858)] = 125651,
  [SMALL_STATE(2859)] = 125713,
  [SMALL_STATE(2860)] = 125775,
  [SMALL_STATE(2861)] = 125833,
  [SMALL_STATE(2862)] = 125895,
  [SMALL_STATE(2863)] = 125957,
  [SMALL_STATE(2864)] = 126019,
  [SMALL_STATE(2865)] = 126081,
  [SMALL_STATE(2866)] = 126145,
  [SMALL_STATE(2867)] = 126207,
  [SMALL_STATE(2868)] = 126269,
  [SMALL_STATE(2869)] = 126331,
  [SMALL_STATE(2870)] = 126393,
  [SMALL_STATE(2871)] = 126455,
  [SMALL_STATE(2872)] = 126517,
  [SMALL_STATE(2873)] = 126579,
  [SMALL_STATE(2874)] = 126643,
  [SMALL_STATE(2875)] = 126705,
  [SMALL_STATE(2876)] = 126759,
  [SMALL_STATE(2877)] = 126821,
  [SMALL_STATE(2878)] = 126885,
  [SMALL_STATE(2879)] = 126949,
  [SMALL_STATE(2880)] = 127011,
  [SMALL_STATE(2881)] = 127063,
  [SMALL_STATE(2882)] = 127125,
  [SMALL_STATE(2883)] = 127178,
  [SMALL_STATE(2884)] = 127231,
  [SMALL_STATE(2885)] = 127284,
  [SMALL_STATE(2886)] = 127337,
  [SMALL_STATE(2887)] = 127390,
  [SMALL_STATE(2888)] = 127443,
  [SMALL_STATE(2889)] = 127496,
  [SMALL_STATE(2890)] = 127549,
  [SMALL_STATE(2891)] = 127600,
  [SMALL_STATE(2892)] = 127651,
  [SMALL_STATE(2893)] = 127704,
  [SMALL_STATE(2894)] = 127755,
  [SMALL_STATE(2895)] = 127806,
  [SMALL_STATE(2896)] = 127859,
  [SMALL_STATE(2897)] = 127912,
  [SMALL_STATE(2898)] = 127963,
  [SMALL_STATE(2899)] = 128014,
  [SMALL_STATE(2900)] = 128067,
  [SMALL_STATE(2901)] = 128120,
  [SMALL_STATE(2902)] = 128173,
  [SMALL_STATE(2903)] = 128224,
  [SMALL_STATE(2904)] = 128275,
  [SMALL_STATE(2905)] = 128326,
  [SMALL_STATE(2906)] = 128379,
  [SMALL_STATE(2907)] = 128430,
  [SMALL_STATE(2908)] = 128481,
  [SMALL_STATE(2909)] = 128536,
  [SMALL_STATE(2910)] = 128587,
  [SMALL_STATE(2911)] = 128638,
  [SMALL_STATE(2912)] = 128689,
  [SMALL_STATE(2913)] = 128740,
  [SMALL_STATE(2914)] = 128791,
  [SMALL_STATE(2915)] = 128842,
  [SMALL_STATE(2916)] = 128895,
  [SMALL_STATE(2917)] = 128946,
  [SMALL_STATE(2918)] = 128997,
  [SMALL_STATE(2919)] = 129050,
  [SMALL_STATE(2920)] = 129101,
  [SMALL_STATE(2921)] = 129152,
  [SMALL_STATE(2922)] = 129202,
  [SMALL_STATE(2923)] = 129252,
  [SMALL_STATE(2924)] = 129302,
  [SMALL_STATE(2925)] = 129352,
  [SMALL_STATE(2926)] = 129402,
  [SMALL_STATE(2927)] = 129452,
  [SMALL_STATE(2928)] = 129502,
  [SMALL_STATE(2929)] = 129552,
  [SMALL_STATE(2930)] = 129602,
  [SMALL_STATE(2931)] = 129652,
  [SMALL_STATE(2932)] = 129702,
  [SMALL_STATE(2933)] = 129752,
  [SMALL_STATE(2934)] = 129802,
  [SMALL_STATE(2935)] = 129852,
  [SMALL_STATE(2936)] = 129902,
  [SMALL_STATE(2937)] = 129952,
  [SMALL_STATE(2938)] = 130002,
  [SMALL_STATE(2939)] = 130052,
  [SMALL_STATE(2940)] = 130102,
  [SMALL_STATE(2941)] = 130152,
  [SMALL_STATE(2942)] = 130202,
  [SMALL_STATE(2943)] = 130252,
  [SMALL_STATE(2944)] = 130302,
  [SMALL_STATE(2945)] = 130352,
  [SMALL_STATE(2946)] = 130402,
  [SMALL_STATE(2947)] = 130452,
  [SMALL_STATE(2948)] = 130502,
  [SMALL_STATE(2949)] = 130552,
  [SMALL_STATE(2950)] = 130602,
  [SMALL_STATE(2951)] = 130652,
  [SMALL_STATE(2952)] = 130702,
  [SMALL_STATE(2953)] = 130752,
  [SMALL_STATE(2954)] = 130802,
  [SMALL_STATE(2955)] = 130852,
  [SMALL_STATE(2956)] = 130902,
  [SMALL_STATE(2957)] = 130952,
  [SMALL_STATE(2958)] = 131002,
  [SMALL_STATE(2959)] = 131052,
  [SMALL_STATE(2960)] = 131102,
  [SMALL_STATE(2961)] = 131152,
  [SMALL_STATE(2962)] = 131202,
  [SMALL_STATE(2963)] = 131252,
  [SMALL_STATE(2964)] = 131302,
  [SMALL_STATE(2965)] = 131352,
  [SMALL_STATE(2966)] = 131402,
  [SMALL_STATE(2967)] = 131454,
  [SMALL_STATE(2968)] = 131504,
  [SMALL_STATE(2969)] = 131554,
  [SMALL_STATE(2970)] = 131604,
  [SMALL_STATE(2971)] = 131654,
  [SMALL_STATE(2972)] = 131704,
  [SMALL_STATE(2973)] = 131754,
  [SMALL_STATE(2974)] = 131804,
  [SMALL_STATE(2975)] = 131854,
  [SMALL_STATE(2976)] = 131904,
  [SMALL_STATE(2977)] = 131954,
  [SMALL_STATE(2978)] = 132004,
  [SMALL_STATE(2979)] = 132054,
  [SMALL_STATE(2980)] = 132104,
  [SMALL_STATE(2981)] = 132154,
  [SMALL_STATE(2982)] = 132204,
  [SMALL_STATE(2983)] = 132254,
  [SMALL_STATE(2984)] = 132304,
  [SMALL_STATE(2985)] = 132354,
  [SMALL_STATE(2986)] = 132404,
  [SMALL_STATE(2987)] = 132454,
  [SMALL_STATE(2988)] = 132504,
  [SMALL_STATE(2989)] = 132554,
  [SMALL_STATE(2990)] = 132604,
  [SMALL_STATE(2991)] = 132654,
  [SMALL_STATE(2992)] = 132704,
  [SMALL_STATE(2993)] = 132754,
  [SMALL_STATE(2994)] = 132804,
  [SMALL_STATE(2995)] = 132854,
  [SMALL_STATE(2996)] = 132904,
  [SMALL_STATE(2997)] = 132954,
  [SMALL_STATE(2998)] = 133004,
  [SMALL_STATE(2999)] = 133054,
  [SMALL_STATE(3000)] = 133104,
  [SMALL_STATE(3001)] = 133154,
  [SMALL_STATE(3002)] = 133204,
  [SMALL_STATE(3003)] = 133254,
  [SMALL_STATE(3004)] = 133304,
  [SMALL_STATE(3005)] = 133354,
  [SMALL_STATE(3006)] = 133404,
  [SMALL_STATE(3007)] = 133454,
  [SMALL_STATE(3008)] = 133504,
  [SMALL_STATE(3009)] = 133554,
  [SMALL_STATE(3010)] = 133604,
  [SMALL_STATE(3011)] = 133654,
  [SMALL_STATE(3012)] = 133704,
  [SMALL_STATE(3013)] = 133754,
  [SMALL_STATE(3014)] = 133804,
  [SMALL_STATE(3015)] = 133854,
  [SMALL_STATE(3016)] = 133904,
  [SMALL_STATE(3017)] = 133954,
  [SMALL_STATE(3018)] = 134004,
  [SMALL_STATE(3019)] = 134054,
  [SMALL_STATE(3020)] = 134104,
  [SMALL_STATE(3021)] = 134154,
  [SMALL_STATE(3022)] = 134204,
  [SMALL_STATE(3023)] = 134254,
  [SMALL_STATE(3024)] = 134304,
  [SMALL_STATE(3025)] = 134354,
  [SMALL_STATE(3026)] = 134404,
  [SMALL_STATE(3027)] = 134454,
  [SMALL_STATE(3028)] = 134504,
  [SMALL_STATE(3029)] = 134553,
  [SMALL_STATE(3030)] = 134602,
  [SMALL_STATE(3031)] = 134651,
  [SMALL_STATE(3032)] = 134700,
  [SMALL_STATE(3033)] = 134749,
  [SMALL_STATE(3034)] = 134798,
  [SMALL_STATE(3035)] = 134847,
  [SMALL_STATE(3036)] = 134896,
  [SMALL_STATE(3037)] = 134945,
  [SMALL_STATE(3038)] = 134994,
  [SMALL_STATE(3039)] = 135043,
  [SMALL_STATE(3040)] = 135092,
  [SMALL_STATE(3041)] = 135141,
  [SMALL_STATE(3042)] = 135190,
  [SMALL_STATE(3043)] = 135239,
  [SMALL_STATE(3044)] = 135288,
  [SMALL_STATE(3045)] = 135337,
  [SMALL_STATE(3046)] = 135386,
  [SMALL_STATE(3047)] = 135435,
  [SMALL_STATE(3048)] = 135484,
  [SMALL_STATE(3049)] = 135533,
  [SMALL_STATE(3050)] = 135582,
  [SMALL_STATE(3051)] = 135631,
  [SMALL_STATE(3052)] = 135680,
  [SMALL_STATE(3053)] = 135729,
  [SMALL_STATE(3054)] = 135778,
  [SMALL_STATE(3055)] = 135827,
  [SMALL_STATE(3056)] = 135876,
  [SMALL_STATE(3057)] = 135925,
  [SMALL_STATE(3058)] = 135974,
  [SMALL_STATE(3059)] = 136023,
  [SMALL_STATE(3060)] = 136072,
  [SMALL_STATE(3061)] = 136121,
  [SMALL_STATE(3062)] = 136170,
  [SMALL_STATE(3063)] = 136219,
  [SMALL_STATE(3064)] = 136268,
  [SMALL_STATE(3065)] = 136317,
  [SMALL_STATE(3066)] = 136366,
  [SMALL_STATE(3067)] = 136415,
  [SMALL_STATE(3068)] = 136464,
  [SMALL_STATE(3069)] = 136513,
  [SMALL_STATE(3070)] = 136562,
  [SMALL_STATE(3071)] = 136611,
  [SMALL_STATE(3072)] = 136660,
  [SMALL_STATE(3073)] = 136709,
  [SMALL_STATE(3074)] = 136758,
  [SMALL_STATE(3075)] = 136807,
  [SMALL_STATE(3076)] = 136856,
  [SMALL_STATE(3077)] = 136911,
  [SMALL_STATE(3078)] = 136960,
  [SMALL_STATE(3079)] = 137009,
  [SMALL_STATE(3080)] = 137058,
  [SMALL_STATE(3081)] = 137107,
  [SMALL_STATE(3082)] = 137156,
  [SMALL_STATE(3083)] = 137205,
  [SMALL_STATE(3084)] = 137254,
  [SMALL_STATE(3085)] = 137312,
  [SMALL_STATE(3086)] = 137374,
  [SMALL_STATE(3087)] = 137422,
  [SMALL_STATE(3088)] = 137470,
  [SMALL_STATE(3089)] = 137555,
  [SMALL_STATE(3090)] = 137640,
  [SMALL_STATE(3091)] = 137725,
  [SMALL_STATE(3092)] = 137810,
  [SMALL_STATE(3093)] = 137895,
  [SMALL_STATE(3094)] = 137980,
  [SMALL_STATE(3095)] = 138065,
  [SMALL_STATE(3096)] = 138150,
  [SMALL_STATE(3097)] = 138205,
  [SMALL_STATE(3098)] = 138251,
  [SMALL_STATE(3099)] = 138297,
  [SMALL_STATE(3100)] = 138343,
  [SMALL_STATE(3101)] = 138393,
  [SMALL_STATE(3102)] = 138439,
  [SMALL_STATE(3103)] = 138485,
  [SMALL_STATE(3104)] = 138531,
  [SMALL_STATE(3105)] = 138577,
  [SMALL_STATE(3106)] = 138623,
  [SMALL_STATE(3107)] = 138669,
  [SMALL_STATE(3108)] = 138715,
  [SMALL_STATE(3109)] = 138761,
  [SMALL_STATE(3110)] = 138807,
  [SMALL_STATE(3111)] = 138853,
  [SMALL_STATE(3112)] = 138902,
  [SMALL_STATE(3113)] = 138951,
  [SMALL_STATE(3114)] = 138998,
  [SMALL_STATE(3115)] = 139044,
  [SMALL_STATE(3116)] = 139090,
  [SMALL_STATE(3117)] = 139136,
  [SMALL_STATE(3118)] = 139182,
  [SMALL_STATE(3119)] = 139223,
  [SMALL_STATE(3120)] = 139264,
  [SMALL_STATE(3121)] = 139307,
  [SMALL_STATE(3122)] = 139350,
  [SMALL_STATE(3123)] = 139385,
  [SMALL_STATE(3124)] = 139420,
  [SMALL_STATE(3125)] = 139455,
  [SMALL_STATE(3126)] = 139501,
  [SMALL_STATE(3127)] = 139547,
  [SMALL_STATE(3128)] = 139581,
  [SMALL_STATE(3129)] = 139615,
  [SMALL_STATE(3130)] = 139661,
  [SMALL_STATE(3131)] = 139694,
  [SMALL_STATE(3132)] = 139727,
  [SMALL_STATE(3133)] = 139760,
  [SMALL_STATE(3134)] = 139793,
  [SMALL_STATE(3135)] = 139826,
  [SMALL_STATE(3136)] = 139859,
  [SMALL_STATE(3137)] = 139892,
  [SMALL_STATE(3138)] = 139925,
  [SMALL_STATE(3139)] = 139958,
  [SMALL_STATE(3140)] = 139991,
  [SMALL_STATE(3141)] = 140024,
  [SMALL_STATE(3142)] = 140057,
  [SMALL_STATE(3143)] = 140090,
  [SMALL_STATE(3144)] = 140123,
  [SMALL_STATE(3145)] = 140156,
  [SMALL_STATE(3146)] = 140189,
  [SMALL_STATE(3147)] = 140222,
  [SMALL_STATE(3148)] = 140255,
  [SMALL_STATE(3149)] = 140288,
  [SMALL_STATE(3150)] = 140321,
  [SMALL_STATE(3151)] = 140354,
  [SMALL_STATE(3152)] = 140387,
  [SMALL_STATE(3153)] = 140420,
  [SMALL_STATE(3154)] = 140453,
  [SMALL_STATE(3155)] = 140486,
  [SMALL_STATE(3156)] = 140519,
  [SMALL_STATE(3157)] = 140552,
  [SMALL_STATE(3158)] = 140585,
  [SMALL_STATE(3159)] = 140618,
  [SMALL_STATE(3160)] = 140651,
  [SMALL_STATE(3161)] = 140684,
  [SMALL_STATE(3162)] = 140717,
  [SMALL_STATE(3163)] = 140750,
  [SMALL_STATE(3164)] = 140783,
  [SMALL_STATE(3165)] = 140816,
  [SMALL_STATE(3166)] = 140849,
  [SMALL_STATE(3167)] = 140903,
  [SMALL_STATE(3168)] = 140943,
  [SMALL_STATE(3169)] = 140997,
  [SMALL_STATE(3170)] = 141040,
  [SMALL_STATE(3171)] = 141071,
  [SMALL_STATE(3172)] = 141114,
  [SMALL_STATE(3173)] = 141151,
  [SMALL_STATE(3174)] = 141182,
  [SMALL_STATE(3175)] = 141213,
  [SMALL_STATE(3176)] = 141256,
  [SMALL_STATE(3177)] = 141291,
  [SMALL_STATE(3178)] = 141321,
  [SMALL_STATE(3179)] = 141355,
  [SMALL_STATE(3180)] = 141385,
  [SMALL_STATE(3181)] = 141416,
  [SMALL_STATE(3182)] = 141445,
  [SMALL_STATE(3183)] = 141472,
  [SMALL_STATE(3184)] = 141511,
  [SMALL_STATE(3185)] = 141550,
  [SMALL_STATE(3186)] = 141589,
  [SMALL_STATE(3187)] = 141618,
  [SMALL_STATE(3188)] = 141657,
  [SMALL_STATE(3189)] = 141684,
  [SMALL_STATE(3190)] = 141711,
  [SMALL_STATE(3191)] = 141740,
  [SMALL_STATE(3192)] = 141779,
  [SMALL_STATE(3193)] = 141808,
  [SMALL_STATE(3194)] = 141837,
  [SMALL_STATE(3195)] = 141866,
  [SMALL_STATE(3196)] = 141905,
  [SMALL_STATE(3197)] = 141944,
  [SMALL_STATE(3198)] = 141973,
  [SMALL_STATE(3199)] = 142010,
  [SMALL_STATE(3200)] = 142039,
  [SMALL_STATE(3201)] = 142068,
  [SMALL_STATE(3202)] = 142097,
  [SMALL_STATE(3203)] = 142126,
  [SMALL_STATE(3204)] = 142155,
  [SMALL_STATE(3205)] = 142184,
  [SMALL_STATE(3206)] = 142213,
  [SMALL_STATE(3207)] = 142242,
  [SMALL_STATE(3208)] = 142271,
  [SMALL_STATE(3209)] = 142302,
  [SMALL_STATE(3210)] = 142331,
  [SMALL_STATE(3211)] = 142360,
  [SMALL_STATE(3212)] = 142389,
  [SMALL_STATE(3213)] = 142418,
  [SMALL_STATE(3214)] = 142447,
  [SMALL_STATE(3215)] = 142484,
  [SMALL_STATE(3216)] = 142513,
  [SMALL_STATE(3217)] = 142552,
  [SMALL_STATE(3218)] = 142581,
  [SMALL_STATE(3219)] = 142610,
  [SMALL_STATE(3220)] = 142639,
  [SMALL_STATE(3221)] = 142668,
  [SMALL_STATE(3222)] = 142697,
  [SMALL_STATE(3223)] = 142726,
  [SMALL_STATE(3224)] = 142753,
  [SMALL_STATE(3225)] = 142782,
  [SMALL_STATE(3226)] = 142811,
  [SMALL_STATE(3227)] = 142850,
  [SMALL_STATE(3228)] = 142879,
  [SMALL_STATE(3229)] = 142910,
  [SMALL_STATE(3230)] = 142939,
  [SMALL_STATE(3231)] = 142968,
  [SMALL_STATE(3232)] = 143007,
  [SMALL_STATE(3233)] = 143036,
  [SMALL_STATE(3234)] = 143065,
  [SMALL_STATE(3235)] = 143094,
  [SMALL_STATE(3236)] = 143123,
  [SMALL_STATE(3237)] = 143152,
  [SMALL_STATE(3238)] = 143179,
  [SMALL_STATE(3239)] = 143208,
  [SMALL_STATE(3240)] = 143245,
  [SMALL_STATE(3241)] = 143274,
  [SMALL_STATE(3242)] = 143313,
  [SMALL_STATE(3243)] = 143340,
  [SMALL_STATE(3244)] = 143379,
  [SMALL_STATE(3245)] = 143418,
  [SMALL_STATE(3246)] = 143445,
  [SMALL_STATE(3247)] = 143472,
  [SMALL_STATE(3248)] = 143511,
  [SMALL_STATE(3249)] = 143540,
  [SMALL_STATE(3250)] = 143569,
  [SMALL_STATE(3251)] = 143598,
  [SMALL_STATE(3252)] = 143627,
  [SMALL_STATE(3253)] = 143656,
  [SMALL_STATE(3254)] = 143685,
  [SMALL_STATE(3255)] = 143714,
  [SMALL_STATE(3256)] = 143743,
  [SMALL_STATE(3257)] = 143772,
  [SMALL_STATE(3258)] = 143801,
  [SMALL_STATE(3259)] = 143830,
  [SMALL_STATE(3260)] = 143859,
  [SMALL_STATE(3261)] = 143888,
  [SMALL_STATE(3262)] = 143921,
  [SMALL_STATE(3263)] = 143950,
  [SMALL_STATE(3264)] = 143979,
  [SMALL_STATE(3265)] = 144018,
  [SMALL_STATE(3266)] = 144057,
  [SMALL_STATE(3267)] = 144096,
  [SMALL_STATE(3268)] = 144133,
  [SMALL_STATE(3269)] = 144170,
  [SMALL_STATE(3270)] = 144199,
  [SMALL_STATE(3271)] = 144228,
  [SMALL_STATE(3272)] = 144255,
  [SMALL_STATE(3273)] = 144294,
  [SMALL_STATE(3274)] = 144323,
  [SMALL_STATE(3275)] = 144352,
  [SMALL_STATE(3276)] = 144389,
  [SMALL_STATE(3277)] = 144418,
  [SMALL_STATE(3278)] = 144447,
  [SMALL_STATE(3279)] = 144476,
  [SMALL_STATE(3280)] = 144505,
  [SMALL_STATE(3281)] = 144534,
  [SMALL_STATE(3282)] = 144565,
  [SMALL_STATE(3283)] = 144596,
  [SMALL_STATE(3284)] = 144625,
  [SMALL_STATE(3285)] = 144659,
  [SMALL_STATE(3286)] = 144693,
  [SMALL_STATE(3287)] = 144727,
  [SMALL_STATE(3288)] = 144757,
  [SMALL_STATE(3289)] = 144805,
  [SMALL_STATE(3290)] = 144849,
  [SMALL_STATE(3291)] = 144897,
  [SMALL_STATE(3292)] = 144941,
  [SMALL_STATE(3293)] = 144985,
  [SMALL_STATE(3294)] = 145015,
  [SMALL_STATE(3295)] = 145049,
  [SMALL_STATE(3296)] = 145097,
  [SMALL_STATE(3297)] = 145131,
  [SMALL_STATE(3298)] = 145179,
  [SMALL_STATE(3299)] = 145227,
  [SMALL_STATE(3300)] = 145277,
  [SMALL_STATE(3301)] = 145325,
  [SMALL_STATE(3302)] = 145373,
  [SMALL_STATE(3303)] = 145405,
  [SMALL_STATE(3304)] = 145453,
  [SMALL_STATE(3305)] = 145501,
  [SMALL_STATE(3306)] = 145535,
  [SMALL_STATE(3307)] = 145583,
  [SMALL_STATE(3308)] = 145631,
  [SMALL_STATE(3309)] = 145679,
  [SMALL_STATE(3310)] = 145713,
  [SMALL_STATE(3311)] = 145757,
  [SMALL_STATE(3312)] = 145805,
  [SMALL_STATE(3313)] = 145835,
  [SMALL_STATE(3314)] = 145883,
  [SMALL_STATE(3315)] = 145931,
  [SMALL_STATE(3316)] = 145979,
  [SMALL_STATE(3317)] = 146027,
  [SMALL_STATE(3318)] = 146075,
  [SMALL_STATE(3319)] = 146109,
  [SMALL_STATE(3320)] = 146153,
  [SMALL_STATE(3321)] = 146201,
  [SMALL_STATE(3322)] = 146235,
  [SMALL_STATE(3323)] = 146279,
  [SMALL_STATE(3324)] = 146313,
  [SMALL_STATE(3325)] = 146361,
  [SMALL_STATE(3326)] = 146411,
  [SMALL_STATE(3327)] = 146445,
  [SMALL_STATE(3328)] = 146479,
  [SMALL_STATE(3329)] = 146527,
  [SMALL_STATE(3330)] = 146575,
  [SMALL_STATE(3331)] = 146623,
  [SMALL_STATE(3332)] = 146657,
  [SMALL_STATE(3333)] = 146691,
  [SMALL_STATE(3334)] = 146716,
  [SMALL_STATE(3335)] = 146741,
  [SMALL_STATE(3336)] = 146772,
  [SMALL_STATE(3337)] = 146797,
  [SMALL_STATE(3338)] = 146822,
  [SMALL_STATE(3339)] = 146849,
  [SMALL_STATE(3340)] = 146876,
  [SMALL_STATE(3341)] = 146901,
  [SMALL_STATE(3342)] = 146926,
  [SMALL_STATE(3343)] = 146967,
  [SMALL_STATE(3344)] = 146994,
  [SMALL_STATE(3345)] = 147021,
  [SMALL_STATE(3346)] = 147062,
  [SMALL_STATE(3347)] = 147087,
  [SMALL_STATE(3348)] = 147128,
  [SMALL_STATE(3349)] = 147153,
  [SMALL_STATE(3350)] = 147180,
  [SMALL_STATE(3351)] = 147207,
  [SMALL_STATE(3352)] = 147232,
  [SMALL_STATE(3353)] = 147273,
  [SMALL_STATE(3354)] = 147298,
  [SMALL_STATE(3355)] = 147323,
  [SMALL_STATE(3356)] = 147350,
  [SMALL_STATE(3357)] = 147377,
  [SMALL_STATE(3358)] = 147402,
  [SMALL_STATE(3359)] = 147435,
  [SMALL_STATE(3360)] = 147476,
  [SMALL_STATE(3361)] = 147517,
  [SMALL_STATE(3362)] = 147542,
  [SMALL_STATE(3363)] = 147569,
  [SMALL_STATE(3364)] = 147594,
  [SMALL_STATE(3365)] = 147621,
  [SMALL_STATE(3366)] = 147646,
  [SMALL_STATE(3367)] = 147677,
  [SMALL_STATE(3368)] = 147706,
  [SMALL_STATE(3369)] = 147735,
  [SMALL_STATE(3370)] = 147776,
  [SMALL_STATE(3371)] = 147801,
  [SMALL_STATE(3372)] = 147842,
  [SMALL_STATE(3373)] = 147867,
  [SMALL_STATE(3374)] = 147892,
  [SMALL_STATE(3375)] = 147917,
  [SMALL_STATE(3376)] = 147942,
  [SMALL_STATE(3377)] = 147967,
  [SMALL_STATE(3378)] = 147992,
  [SMALL_STATE(3379)] = 148033,
  [SMALL_STATE(3380)] = 148058,
  [SMALL_STATE(3381)] = 148085,
  [SMALL_STATE(3382)] = 148112,
  [SMALL_STATE(3383)] = 148137,
  [SMALL_STATE(3384)] = 148162,
  [SMALL_STATE(3385)] = 148189,
  [SMALL_STATE(3386)] = 148214,
  [SMALL_STATE(3387)] = 148241,
  [SMALL_STATE(3388)] = 148268,
  [SMALL_STATE(3389)] = 148293,
  [SMALL_STATE(3390)] = 148318,
  [SMALL_STATE(3391)] = 148343,
  [SMALL_STATE(3392)] = 148368,
  [SMALL_STATE(3393)] = 148393,
  [SMALL_STATE(3394)] = 148420,
  [SMALL_STATE(3395)] = 148445,
  [SMALL_STATE(3396)] = 148470,
  [SMALL_STATE(3397)] = 148513,
  [SMALL_STATE(3398)] = 148546,
  [SMALL_STATE(3399)] = 148571,
  [SMALL_STATE(3400)] = 148612,
  [SMALL_STATE(3401)] = 148639,
  [SMALL_STATE(3402)] = 148677,
  [SMALL_STATE(3403)] = 148719,
  [SMALL_STATE(3404)] = 148753,
  [SMALL_STATE(3405)] = 148781,
  [SMALL_STATE(3406)] = 148819,
  [SMALL_STATE(3407)] = 148861,
  [SMALL_STATE(3408)] = 148899,
  [SMALL_STATE(3409)] = 148941,
  [SMALL_STATE(3410)] = 148983,
  [SMALL_STATE(3411)] = 149025,
  [SMALL_STATE(3412)] = 149067,
  [SMALL_STATE(3413)] = 149103,
  [SMALL_STATE(3414)] = 149141,
  [SMALL_STATE(3415)] = 149183,
  [SMALL_STATE(3416)] = 149217,
  [SMALL_STATE(3417)] = 149255,
  [SMALL_STATE(3418)] = 149281,
  [SMALL_STATE(3419)] = 149325,
  [SMALL_STATE(3420)] = 149367,
  [SMALL_STATE(3421)] = 149409,
  [SMALL_STATE(3422)] = 149447,
  [SMALL_STATE(3423)] = 149489,
  [SMALL_STATE(3424)] = 149523,
  [SMALL_STATE(3425)] = 149565,
  [SMALL_STATE(3426)] = 149591,
  [SMALL_STATE(3427)] = 149619,
  [SMALL_STATE(3428)] = 149661,
  [SMALL_STATE(3429)] = 149689,
  [SMALL_STATE(3430)] = 149727,
  [SMALL_STATE(3431)] = 149769,
  [SMALL_STATE(3432)] = 149803,
  [SMALL_STATE(3433)] = 149833,
  [SMALL_STATE(3434)] = 149869,
  [SMALL_STATE(3435)] = 149911,
  [SMALL_STATE(3436)] = 149953,
  [SMALL_STATE(3437)] = 149995,
  [SMALL_STATE(3438)] = 150037,
  [SMALL_STATE(3439)] = 150079,
  [SMALL_STATE(3440)] = 150121,
  [SMALL_STATE(3441)] = 150159,
  [SMALL_STATE(3442)] = 150201,
  [SMALL_STATE(3443)] = 150235,
  [SMALL_STATE(3444)] = 150277,
  [SMALL_STATE(3445)] = 150315,
  [SMALL_STATE(3446)] = 150357,
  [SMALL_STATE(3447)] = 150393,
  [SMALL_STATE(3448)] = 150429,
  [SMALL_STATE(3449)] = 150465,
  [SMALL_STATE(3450)] = 150499,
  [SMALL_STATE(3451)] = 150537,
  [SMALL_STATE(3452)] = 150581,
  [SMALL_STATE(3453)] = 150623,
  [SMALL_STATE(3454)] = 150648,
  [SMALL_STATE(3455)] = 150673,
  [SMALL_STATE(3456)] = 150702,
  [SMALL_STATE(3457)] = 150727,
  [SMALL_STATE(3458)] = 150752,
  [SMALL_STATE(3459)] = 150775,
  [SMALL_STATE(3460)] = 150800,
  [SMALL_STATE(3461)] = 150823,
  [SMALL_STATE(3462)] = 150848,
  [SMALL_STATE(3463)] = 150871,
  [SMALL_STATE(3464)] = 150896,
  [SMALL_STATE(3465)] = 150921,
  [SMALL_STATE(3466)] = 150946,
  [SMALL_STATE(3467)] = 150971,
  [SMALL_STATE(3468)] = 150998,
  [SMALL_STATE(3469)] = 151023,
  [SMALL_STATE(3470)] = 151046,
  [SMALL_STATE(3471)] = 151071,
  [SMALL_STATE(3472)] = 151096,
  [SMALL_STATE(3473)] = 151121,
  [SMALL_STATE(3474)] = 151144,
  [SMALL_STATE(3475)] = 151169,
  [SMALL_STATE(3476)] = 151196,
  [SMALL_STATE(3477)] = 151221,
  [SMALL_STATE(3478)] = 151246,
  [SMALL_STATE(3479)] = 151271,
  [SMALL_STATE(3480)] = 151296,
  [SMALL_STATE(3481)] = 151321,
  [SMALL_STATE(3482)] = 151346,
  [SMALL_STATE(3483)] = 151369,
  [SMALL_STATE(3484)] = 151394,
  [SMALL_STATE(3485)] = 151419,
  [SMALL_STATE(3486)] = 151448,
  [SMALL_STATE(3487)] = 151473,
  [SMALL_STATE(3488)] = 151498,
  [SMALL_STATE(3489)] = 151525,
  [SMALL_STATE(3490)] = 151552,
  [SMALL_STATE(3491)] = 151577,
  [SMALL_STATE(3492)] = 151604,
  [SMALL_STATE(3493)] = 151631,
  [SMALL_STATE(3494)] = 151656,
  [SMALL_STATE(3495)] = 151681,
  [SMALL_STATE(3496)] = 151706,
  [SMALL_STATE(3497)] = 151731,
  [SMALL_STATE(3498)] = 151760,
  [SMALL_STATE(3499)] = 151787,
  [SMALL_STATE(3500)] = 151812,
  [SMALL_STATE(3501)] = 151837,
  [SMALL_STATE(3502)] = 151868,
  [SMALL_STATE(3503)] = 151893,
  [SMALL_STATE(3504)] = 151922,
  [SMALL_STATE(3505)] = 151951,
  [SMALL_STATE(3506)] = 151974,
  [SMALL_STATE(3507)] = 152003,
  [SMALL_STATE(3508)] = 152030,
  [SMALL_STATE(3509)] = 152059,
  [SMALL_STATE(3510)] = 152102,
  [SMALL_STATE(3511)] = 152129,
  [SMALL_STATE(3512)] = 152154,
  [SMALL_STATE(3513)] = 152179,
  [SMALL_STATE(3514)] = 152208,
  [SMALL_STATE(3515)] = 152231,
  [SMALL_STATE(3516)] = 152254,
  [SMALL_STATE(3517)] = 152279,
  [SMALL_STATE(3518)] = 152304,
  [SMALL_STATE(3519)] = 152329,
  [SMALL_STATE(3520)] = 152353,
  [SMALL_STATE(3521)] = 152379,
  [SMALL_STATE(3522)] = 152419,
  [SMALL_STATE(3523)] = 152449,
  [SMALL_STATE(3524)] = 152489,
  [SMALL_STATE(3525)] = 152511,
  [SMALL_STATE(3526)] = 152551,
  [SMALL_STATE(3527)] = 152579,
  [SMALL_STATE(3528)] = 152619,
  [SMALL_STATE(3529)] = 152659,
  [SMALL_STATE(3530)] = 152699,
  [SMALL_STATE(3531)] = 152739,
  [SMALL_STATE(3532)] = 152773,
  [SMALL_STATE(3533)] = 152807,
  [SMALL_STATE(3534)] = 152847,
  [SMALL_STATE(3535)] = 152887,
  [SMALL_STATE(3536)] = 152927,
  [SMALL_STATE(3537)] = 152965,
  [SMALL_STATE(3538)] = 152993,
  [SMALL_STATE(3539)] = 153017,
  [SMALL_STATE(3540)] = 153057,
  [SMALL_STATE(3541)] = 153083,
  [SMALL_STATE(3542)] = 153109,
  [SMALL_STATE(3543)] = 153149,
  [SMALL_STATE(3544)] = 153189,
  [SMALL_STATE(3545)] = 153227,
  [SMALL_STATE(3546)] = 153251,
  [SMALL_STATE(3547)] = 153279,
  [SMALL_STATE(3548)] = 153317,
  [SMALL_STATE(3549)] = 153357,
  [SMALL_STATE(3550)] = 153379,
  [SMALL_STATE(3551)] = 153419,
  [SMALL_STATE(3552)] = 153440,
  [SMALL_STATE(3553)] = 153471,
  [SMALL_STATE(3554)] = 153492,
  [SMALL_STATE(3555)] = 153513,
  [SMALL_STATE(3556)] = 153534,
  [SMALL_STATE(3557)] = 153565,
  [SMALL_STATE(3558)] = 153588,
  [SMALL_STATE(3559)] = 153609,
  [SMALL_STATE(3560)] = 153630,
  [SMALL_STATE(3561)] = 153651,
  [SMALL_STATE(3562)] = 153678,
  [SMALL_STATE(3563)] = 153703,
  [SMALL_STATE(3564)] = 153734,
  [SMALL_STATE(3565)] = 153755,
  [SMALL_STATE(3566)] = 153776,
  [SMALL_STATE(3567)] = 153797,
  [SMALL_STATE(3568)] = 153818,
  [SMALL_STATE(3569)] = 153839,
  [SMALL_STATE(3570)] = 153860,
  [SMALL_STATE(3571)] = 153883,
  [SMALL_STATE(3572)] = 153908,
  [SMALL_STATE(3573)] = 153931,
  [SMALL_STATE(3574)] = 153952,
  [SMALL_STATE(3575)] = 153973,
  [SMALL_STATE(3576)] = 153994,
  [SMALL_STATE(3577)] = 154027,
  [SMALL_STATE(3578)] = 154048,
  [SMALL_STATE(3579)] = 154085,
  [SMALL_STATE(3580)] = 154108,
  [SMALL_STATE(3581)] = 154145,
  [SMALL_STATE(3582)] = 154168,
  [SMALL_STATE(3583)] = 154201,
  [SMALL_STATE(3584)] = 154230,
  [SMALL_STATE(3585)] = 154253,
  [SMALL_STATE(3586)] = 154282,
  [SMALL_STATE(3587)] = 154303,
  [SMALL_STATE(3588)] = 154324,
  [SMALL_STATE(3589)] = 154357,
  [SMALL_STATE(3590)] = 154382,
  [SMALL_STATE(3591)] = 154417,
  [SMALL_STATE(3592)] = 154438,
  [SMALL_STATE(3593)] = 154459,
  [SMALL_STATE(3594)] = 154480,
  [SMALL_STATE(3595)] = 154513,
  [SMALL_STATE(3596)] = 154534,
  [SMALL_STATE(3597)] = 154571,
  [SMALL_STATE(3598)] = 154592,
  [SMALL_STATE(3599)] = 154613,
  [SMALL_STATE(3600)] = 154634,
  [SMALL_STATE(3601)] = 154655,
  [SMALL_STATE(3602)] = 154676,
  [SMALL_STATE(3603)] = 154713,
  [SMALL_STATE(3604)] = 154740,
  [SMALL_STATE(3605)] = 154763,
  [SMALL_STATE(3606)] = 154786,
  [SMALL_STATE(3607)] = 154809,
  [SMALL_STATE(3608)] = 154846,
  [SMALL_STATE(3609)] = 154883,
  [SMALL_STATE(3610)] = 154906,
  [SMALL_STATE(3611)] = 154929,
  [SMALL_STATE(3612)] = 154950,
  [SMALL_STATE(3613)] = 154973,
  [SMALL_STATE(3614)] = 155010,
  [SMALL_STATE(3615)] = 155031,
  [SMALL_STATE(3616)] = 155068,
  [SMALL_STATE(3617)] = 155089,
  [SMALL_STATE(3618)] = 155110,
  [SMALL_STATE(3619)] = 155131,
  [SMALL_STATE(3620)] = 155164,
  [SMALL_STATE(3621)] = 155185,
  [SMALL_STATE(3622)] = 155222,
  [SMALL_STATE(3623)] = 155243,
  [SMALL_STATE(3624)] = 155274,
  [SMALL_STATE(3625)] = 155301,
  [SMALL_STATE(3626)] = 155332,
  [SMALL_STATE(3627)] = 155365,
  [SMALL_STATE(3628)] = 155388,
  [SMALL_STATE(3629)] = 155411,
  [SMALL_STATE(3630)] = 155434,
  [SMALL_STATE(3631)] = 155455,
  [SMALL_STATE(3632)] = 155492,
  [SMALL_STATE(3633)] = 155513,
  [SMALL_STATE(3634)] = 155544,
  [SMALL_STATE(3635)] = 155571,
  [SMALL_STATE(3636)] = 155598,
  [SMALL_STATE(3637)] = 155625,
  [SMALL_STATE(3638)] = 155646,
  [SMALL_STATE(3639)] = 155679,
  [SMALL_STATE(3640)] = 155712,
  [SMALL_STATE(3641)] = 155749,
  [SMALL_STATE(3642)] = 155786,
  [SMALL_STATE(3643)] = 155823,
  [SMALL_STATE(3644)] = 155856,
  [SMALL_STATE(3645)] = 155889,
  [SMALL_STATE(3646)] = 155922,
  [SMALL_STATE(3647)] = 155943,
  [SMALL_STATE(3648)] = 155964,
  [SMALL_STATE(3649)] = 156001,
  [SMALL_STATE(3650)] = 156022,
  [SMALL_STATE(3651)] = 156043,
  [SMALL_STATE(3652)] = 156080,
  [SMALL_STATE(3653)] = 156113,
  [SMALL_STATE(3654)] = 156134,
  [SMALL_STATE(3655)] = 156171,
  [SMALL_STATE(3656)] = 156208,
  [SMALL_STATE(3657)] = 156235,
  [SMALL_STATE(3658)] = 156272,
  [SMALL_STATE(3659)] = 156305,
  [SMALL_STATE(3660)] = 156338,
  [SMALL_STATE(3661)] = 156375,
  [SMALL_STATE(3662)] = 156396,
  [SMALL_STATE(3663)] = 156417,
  [SMALL_STATE(3664)] = 156450,
  [SMALL_STATE(3665)] = 156483,
  [SMALL_STATE(3666)] = 156520,
  [SMALL_STATE(3667)] = 156541,
  [SMALL_STATE(3668)] = 156578,
  [SMALL_STATE(3669)] = 156615,
  [SMALL_STATE(3670)] = 156652,
  [SMALL_STATE(3671)] = 156673,
  [SMALL_STATE(3672)] = 156704,
  [SMALL_STATE(3673)] = 156741,
  [SMALL_STATE(3674)] = 156778,
  [SMALL_STATE(3675)] = 156799,
  [SMALL_STATE(3676)] = 156836,
  [SMALL_STATE(3677)] = 156867,
  [SMALL_STATE(3678)] = 156888,
  [SMALL_STATE(3679)] = 156921,
  [SMALL_STATE(3680)] = 156958,
  [SMALL_STATE(3681)] = 156979,
  [SMALL_STATE(3682)] = 157000,
  [SMALL_STATE(3683)] = 157021,
  [SMALL_STATE(3684)] = 157042,
  [SMALL_STATE(3685)] = 157075,
  [SMALL_STATE(3686)] = 157096,
  [SMALL_STATE(3687)] = 157129,
  [SMALL_STATE(3688)] = 157166,
  [SMALL_STATE(3689)] = 157203,
  [SMALL_STATE(3690)] = 157234,
  [SMALL_STATE(3691)] = 157267,
  [SMALL_STATE(3692)] = 157290,
  [SMALL_STATE(3693)] = 157313,
  [SMALL_STATE(3694)] = 157336,
  [SMALL_STATE(3695)] = 157359,
  [SMALL_STATE(3696)] = 157382,
  [SMALL_STATE(3697)] = 157405,
  [SMALL_STATE(3698)] = 157442,
  [SMALL_STATE(3699)] = 157475,
  [SMALL_STATE(3700)] = 157510,
  [SMALL_STATE(3701)] = 157531,
  [SMALL_STATE(3702)] = 157552,
  [SMALL_STATE(3703)] = 157589,
  [SMALL_STATE(3704)] = 157622,
  [SMALL_STATE(3705)] = 157643,
  [SMALL_STATE(3706)] = 157674,
  [SMALL_STATE(3707)] = 157695,
  [SMALL_STATE(3708)] = 157726,
  [SMALL_STATE(3709)] = 157763,
  [SMALL_STATE(3710)] = 157786,
  [SMALL_STATE(3711)] = 157821,
  [SMALL_STATE(3712)] = 157858,
  [SMALL_STATE(3713)] = 157879,
  [SMALL_STATE(3714)] = 157910,
  [SMALL_STATE(3715)] = 157943,
  [SMALL_STATE(3716)] = 157974,
  [SMALL_STATE(3717)] = 158001,
  [SMALL_STATE(3718)] = 158034,
  [SMALL_STATE(3719)] = 158067,
  [SMALL_STATE(3720)] = 158100,
  [SMALL_STATE(3721)] = 158133,
  [SMALL_STATE(3722)] = 158166,
  [SMALL_STATE(3723)] = 158199,
  [SMALL_STATE(3724)] = 158236,
  [SMALL_STATE(3725)] = 158271,
  [SMALL_STATE(3726)] = 158308,
  [SMALL_STATE(3727)] = 158341,
  [SMALL_STATE(3728)] = 158374,
  [SMALL_STATE(3729)] = 158407,
  [SMALL_STATE(3730)] = 158428,
  [SMALL_STATE(3731)] = 158461,
  [SMALL_STATE(3732)] = 158494,
  [SMALL_STATE(3733)] = 158527,
  [SMALL_STATE(3734)] = 158560,
  [SMALL_STATE(3735)] = 158593,
  [SMALL_STATE(3736)] = 158614,
  [SMALL_STATE(3737)] = 158647,
  [SMALL_STATE(3738)] = 158678,
  [SMALL_STATE(3739)] = 158709,
  [SMALL_STATE(3740)] = 158746,
  [SMALL_STATE(3741)] = 158783,
  [SMALL_STATE(3742)] = 158816,
  [SMALL_STATE(3743)] = 158848,
  [SMALL_STATE(3744)] = 158870,
  [SMALL_STATE(3745)] = 158904,
  [SMALL_STATE(3746)] = 158932,
  [SMALL_STATE(3747)] = 158958,
  [SMALL_STATE(3748)] = 158982,
  [SMALL_STATE(3749)] = 159008,
  [SMALL_STATE(3750)] = 159036,
  [SMALL_STATE(3751)] = 159070,
  [SMALL_STATE(3752)] = 159096,
  [SMALL_STATE(3753)] = 159124,
  [SMALL_STATE(3754)] = 159152,
  [SMALL_STATE(3755)] = 159180,
  [SMALL_STATE(3756)] = 159208,
  [SMALL_STATE(3757)] = 159236,
  [SMALL_STATE(3758)] = 159268,
  [SMALL_STATE(3759)] = 159302,
  [SMALL_STATE(3760)] = 159328,
  [SMALL_STATE(3761)] = 159360,
  [SMALL_STATE(3762)] = 159394,
  [SMALL_STATE(3763)] = 159428,
  [SMALL_STATE(3764)] = 159456,
  [SMALL_STATE(3765)] = 159490,
  [SMALL_STATE(3766)] = 159518,
  [SMALL_STATE(3767)] = 159540,
  [SMALL_STATE(3768)] = 159562,
  [SMALL_STATE(3769)] = 159596,
  [SMALL_STATE(3770)] = 159622,
  [SMALL_STATE(3771)] = 159656,
  [SMALL_STATE(3772)] = 159688,
  [SMALL_STATE(3773)] = 159714,
  [SMALL_STATE(3774)] = 159740,
  [SMALL_STATE(3775)] = 159760,
  [SMALL_STATE(3776)] = 159790,
  [SMALL_STATE(3777)] = 159810,
  [SMALL_STATE(3778)] = 159837,
  [SMALL_STATE(3779)] = 159868,
  [SMALL_STATE(3780)] = 159897,
  [SMALL_STATE(3781)] = 159928,
  [SMALL_STATE(3782)] = 159955,
  [SMALL_STATE(3783)] = 159982,
  [SMALL_STATE(3784)] = 160013,
  [SMALL_STATE(3785)] = 160042,
  [SMALL_STATE(3786)] = 160069,
  [SMALL_STATE(3787)] = 160096,
  [SMALL_STATE(3788)] = 160119,
  [SMALL_STATE(3789)] = 160146,
  [SMALL_STATE(3790)] = 160173,
  [SMALL_STATE(3791)] = 160202,
  [SMALL_STATE(3792)] = 160229,
  [SMALL_STATE(3793)] = 160256,
  [SMALL_STATE(3794)] = 160283,
  [SMALL_STATE(3795)] = 160304,
  [SMALL_STATE(3796)] = 160335,
  [SMALL_STATE(3797)] = 160366,
  [SMALL_STATE(3798)] = 160393,
  [SMALL_STATE(3799)] = 160424,
  [SMALL_STATE(3800)] = 160455,
  [SMALL_STATE(3801)] = 160482,
  [SMALL_STATE(3802)] = 160503,
  [SMALL_STATE(3803)] = 160534,
  [SMALL_STATE(3804)] = 160555,
  [SMALL_STATE(3805)] = 160586,
  [SMALL_STATE(3806)] = 160617,
  [SMALL_STATE(3807)] = 160648,
  [SMALL_STATE(3808)] = 160679,
  [SMALL_STATE(3809)] = 160706,
  [SMALL_STATE(3810)] = 160733,
  [SMALL_STATE(3811)] = 160760,
  [SMALL_STATE(3812)] = 160787,
  [SMALL_STATE(3813)] = 160818,
  [SMALL_STATE(3814)] = 160849,
  [SMALL_STATE(3815)] = 160876,
  [SMALL_STATE(3816)] = 160907,
  [SMALL_STATE(3817)] = 160934,
  [SMALL_STATE(3818)] = 160961,
  [SMALL_STATE(3819)] = 160982,
  [SMALL_STATE(3820)] = 161013,
  [SMALL_STATE(3821)] = 161040,
  [SMALL_STATE(3822)] = 161067,
  [SMALL_STATE(3823)] = 161096,
  [SMALL_STATE(3824)] = 161123,
  [SMALL_STATE(3825)] = 161150,
  [SMALL_STATE(3826)] = 161181,
  [SMALL_STATE(3827)] = 161206,
  [SMALL_STATE(3828)] = 161225,
  [SMALL_STATE(3829)] = 161244,
  [SMALL_STATE(3830)] = 161271,
  [SMALL_STATE(3831)] = 161298,
  [SMALL_STATE(3832)] = 161329,
  [SMALL_STATE(3833)] = 161348,
  [SMALL_STATE(3834)] = 161379,
  [SMALL_STATE(3835)] = 161406,
  [SMALL_STATE(3836)] = 161425,
  [SMALL_STATE(3837)] = 161452,
  [SMALL_STATE(3838)] = 161479,
  [SMALL_STATE(3839)] = 161506,
  [SMALL_STATE(3840)] = 161533,
  [SMALL_STATE(3841)] = 161556,
  [SMALL_STATE(3842)] = 161583,
  [SMALL_STATE(3843)] = 161602,
  [SMALL_STATE(3844)] = 161621,
  [SMALL_STATE(3845)] = 161644,
  [SMALL_STATE(3846)] = 161671,
  [SMALL_STATE(3847)] = 161698,
  [SMALL_STATE(3848)] = 161725,
  [SMALL_STATE(3849)] = 161752,
  [SMALL_STATE(3850)] = 161779,
  [SMALL_STATE(3851)] = 161806,
  [SMALL_STATE(3852)] = 161833,
  [SMALL_STATE(3853)] = 161860,
  [SMALL_STATE(3854)] = 161891,
  [SMALL_STATE(3855)] = 161922,
  [SMALL_STATE(3856)] = 161953,
  [SMALL_STATE(3857)] = 161984,
  [SMALL_STATE(3858)] = 162011,
  [SMALL_STATE(3859)] = 162042,
  [SMALL_STATE(3860)] = 162061,
  [SMALL_STATE(3861)] = 162080,
  [SMALL_STATE(3862)] = 162107,
  [SMALL_STATE(3863)] = 162134,
  [SMALL_STATE(3864)] = 162161,
  [SMALL_STATE(3865)] = 162184,
  [SMALL_STATE(3866)] = 162215,
  [SMALL_STATE(3867)] = 162246,
  [SMALL_STATE(3868)] = 162273,
  [SMALL_STATE(3869)] = 162304,
  [SMALL_STATE(3870)] = 162335,
  [SMALL_STATE(3871)] = 162358,
  [SMALL_STATE(3872)] = 162385,
  [SMALL_STATE(3873)] = 162408,
  [SMALL_STATE(3874)] = 162435,
  [SMALL_STATE(3875)] = 162466,
  [SMALL_STATE(3876)] = 162497,
  [SMALL_STATE(3877)] = 162528,
  [SMALL_STATE(3878)] = 162555,
  [SMALL_STATE(3879)] = 162582,
  [SMALL_STATE(3880)] = 162609,
  [SMALL_STATE(3881)] = 162636,
  [SMALL_STATE(3882)] = 162667,
  [SMALL_STATE(3883)] = 162696,
  [SMALL_STATE(3884)] = 162725,
  [SMALL_STATE(3885)] = 162756,
  [SMALL_STATE(3886)] = 162783,
  [SMALL_STATE(3887)] = 162810,
  [SMALL_STATE(3888)] = 162837,
  [SMALL_STATE(3889)] = 162864,
  [SMALL_STATE(3890)] = 162891,
  [SMALL_STATE(3891)] = 162918,
  [SMALL_STATE(3892)] = 162945,
  [SMALL_STATE(3893)] = 162972,
  [SMALL_STATE(3894)] = 163003,
  [SMALL_STATE(3895)] = 163030,
  [SMALL_STATE(3896)] = 163057,
  [SMALL_STATE(3897)] = 163088,
  [SMALL_STATE(3898)] = 163119,
  [SMALL_STATE(3899)] = 163150,
  [SMALL_STATE(3900)] = 163177,
  [SMALL_STATE(3901)] = 163204,
  [SMALL_STATE(3902)] = 163231,
  [SMALL_STATE(3903)] = 163258,
  [SMALL_STATE(3904)] = 163289,
  [SMALL_STATE(3905)] = 163312,
  [SMALL_STATE(3906)] = 163343,
  [SMALL_STATE(3907)] = 163362,
  [SMALL_STATE(3908)] = 163381,
  [SMALL_STATE(3909)] = 163400,
  [SMALL_STATE(3910)] = 163427,
  [SMALL_STATE(3911)] = 163454,
  [SMALL_STATE(3912)] = 163473,
  [SMALL_STATE(3913)] = 163500,
  [SMALL_STATE(3914)] = 163527,
  [SMALL_STATE(3915)] = 163558,
  [SMALL_STATE(3916)] = 163585,
  [SMALL_STATE(3917)] = 163616,
  [SMALL_STATE(3918)] = 163643,
  [SMALL_STATE(3919)] = 163674,
  [SMALL_STATE(3920)] = 163705,
  [SMALL_STATE(3921)] = 163736,
  [SMALL_STATE(3922)] = 163759,
  [SMALL_STATE(3923)] = 163788,
  [SMALL_STATE(3924)] = 163815,
  [SMALL_STATE(3925)] = 163846,
  [SMALL_STATE(3926)] = 163865,
  [SMALL_STATE(3927)] = 163884,
  [SMALL_STATE(3928)] = 163915,
  [SMALL_STATE(3929)] = 163942,
  [SMALL_STATE(3930)] = 163969,
  [SMALL_STATE(3931)] = 163996,
  [SMALL_STATE(3932)] = 164023,
  [SMALL_STATE(3933)] = 164044,
  [SMALL_STATE(3934)] = 164063,
  [SMALL_STATE(3935)] = 164090,
  [SMALL_STATE(3936)] = 164115,
  [SMALL_STATE(3937)] = 164146,
  [SMALL_STATE(3938)] = 164169,
  [SMALL_STATE(3939)] = 164200,
  [SMALL_STATE(3940)] = 164231,
  [SMALL_STATE(3941)] = 164262,
  [SMALL_STATE(3942)] = 164289,
  [SMALL_STATE(3943)] = 164316,
  [SMALL_STATE(3944)] = 164345,
  [SMALL_STATE(3945)] = 164376,
  [SMALL_STATE(3946)] = 164407,
  [SMALL_STATE(3947)] = 164438,
  [SMALL_STATE(3948)] = 164469,
  [SMALL_STATE(3949)] = 164498,
  [SMALL_STATE(3950)] = 164517,
  [SMALL_STATE(3951)] = 164544,
  [SMALL_STATE(3952)] = 164565,
  [SMALL_STATE(3953)] = 164592,
  [SMALL_STATE(3954)] = 164619,
  [SMALL_STATE(3955)] = 164638,
  [SMALL_STATE(3956)] = 164657,
  [SMALL_STATE(3957)] = 164676,
  [SMALL_STATE(3958)] = 164703,
  [SMALL_STATE(3959)] = 164730,
  [SMALL_STATE(3960)] = 164757,
  [SMALL_STATE(3961)] = 164776,
  [SMALL_STATE(3962)] = 164803,
  [SMALL_STATE(3963)] = 164830,
  [SMALL_STATE(3964)] = 164861,
  [SMALL_STATE(3965)] = 164892,
  [SMALL_STATE(3966)] = 164919,
  [SMALL_STATE(3967)] = 164946,
  [SMALL_STATE(3968)] = 164969,
  [SMALL_STATE(3969)] = 164988,
  [SMALL_STATE(3970)] = 165019,
  [SMALL_STATE(3971)] = 165050,
  [SMALL_STATE(3972)] = 165077,
  [SMALL_STATE(3973)] = 165104,
  [SMALL_STATE(3974)] = 165123,
  [SMALL_STATE(3975)] = 165154,
  [SMALL_STATE(3976)] = 165181,
  [SMALL_STATE(3977)] = 165208,
  [SMALL_STATE(3978)] = 165231,
  [SMALL_STATE(3979)] = 165250,
  [SMALL_STATE(3980)] = 165269,
  [SMALL_STATE(3981)] = 165292,
  [SMALL_STATE(3982)] = 165315,
  [SMALL_STATE(3983)] = 165338,
  [SMALL_STATE(3984)] = 165361,
  [SMALL_STATE(3985)] = 165384,
  [SMALL_STATE(3986)] = 165411,
  [SMALL_STATE(3987)] = 165434,
  [SMALL_STATE(3988)] = 165457,
  [SMALL_STATE(3989)] = 165480,
  [SMALL_STATE(3990)] = 165509,
  [SMALL_STATE(3991)] = 165536,
  [SMALL_STATE(3992)] = 165559,
  [SMALL_STATE(3993)] = 165586,
  [SMALL_STATE(3994)] = 165613,
  [SMALL_STATE(3995)] = 165636,
  [SMALL_STATE(3996)] = 165659,
  [SMALL_STATE(3997)] = 165682,
  [SMALL_STATE(3998)] = 165705,
  [SMALL_STATE(3999)] = 165732,
  [SMALL_STATE(4000)] = 165759,
  [SMALL_STATE(4001)] = 165782,
  [SMALL_STATE(4002)] = 165809,
  [SMALL_STATE(4003)] = 165832,
  [SMALL_STATE(4004)] = 165855,
  [SMALL_STATE(4005)] = 165878,
  [SMALL_STATE(4006)] = 165905,
  [SMALL_STATE(4007)] = 165928,
  [SMALL_STATE(4008)] = 165955,
  [SMALL_STATE(4009)] = 165982,
  [SMALL_STATE(4010)] = 166009,
  [SMALL_STATE(4011)] = 166036,
  [SMALL_STATE(4012)] = 166059,
  [SMALL_STATE(4013)] = 166086,
  [SMALL_STATE(4014)] = 166108,
  [SMALL_STATE(4015)] = 166126,
  [SMALL_STATE(4016)] = 166148,
  [SMALL_STATE(4017)] = 166170,
  [SMALL_STATE(4018)] = 166190,
  [SMALL_STATE(4019)] = 166216,
  [SMALL_STATE(4020)] = 166242,
  [SMALL_STATE(4021)] = 166262,
  [SMALL_STATE(4022)] = 166284,
  [SMALL_STATE(4023)] = 166302,
  [SMALL_STATE(4024)] = 166324,
  [SMALL_STATE(4025)] = 166352,
  [SMALL_STATE(4026)] = 166380,
  [SMALL_STATE(4027)] = 166408,
  [SMALL_STATE(4028)] = 166436,
  [SMALL_STATE(4029)] = 166464,
  [SMALL_STATE(4030)] = 166492,
  [SMALL_STATE(4031)] = 166516,
  [SMALL_STATE(4032)] = 166534,
  [SMALL_STATE(4033)] = 166552,
  [SMALL_STATE(4034)] = 166574,
  [SMALL_STATE(4035)] = 166592,
  [SMALL_STATE(4036)] = 166614,
  [SMALL_STATE(4037)] = 166634,
  [SMALL_STATE(4038)] = 166662,
  [SMALL_STATE(4039)] = 166690,
  [SMALL_STATE(4040)] = 166712,
  [SMALL_STATE(4041)] = 166734,
  [SMALL_STATE(4042)] = 166762,
  [SMALL_STATE(4043)] = 166790,
  [SMALL_STATE(4044)] = 166818,
  [SMALL_STATE(4045)] = 166836,
  [SMALL_STATE(4046)] = 166862,
  [SMALL_STATE(4047)] = 166884,
  [SMALL_STATE(4048)] = 166904,
  [SMALL_STATE(4049)] = 166926,
  [SMALL_STATE(4050)] = 166948,
  [SMALL_STATE(4051)] = 166976,
  [SMALL_STATE(4052)] = 167004,
  [SMALL_STATE(4053)] = 167026,
  [SMALL_STATE(4054)] = 167048,
  [SMALL_STATE(4055)] = 167076,
  [SMALL_STATE(4056)] = 167104,
  [SMALL_STATE(4057)] = 167122,
  [SMALL_STATE(4058)] = 167148,
  [SMALL_STATE(4059)] = 167170,
  [SMALL_STATE(4060)] = 167192,
  [SMALL_STATE(4061)] = 167214,
  [SMALL_STATE(4062)] = 167242,
  [SMALL_STATE(4063)] = 167270,
  [SMALL_STATE(4064)] = 167298,
  [SMALL_STATE(4065)] = 167326,
  [SMALL_STATE(4066)] = 167354,
  [SMALL_STATE(4067)] = 167382,
  [SMALL_STATE(4068)] = 167410,
  [SMALL_STATE(4069)] = 167438,
  [SMALL_STATE(4070)] = 167466,
  [SMALL_STATE(4071)] = 167494,
  [SMALL_STATE(4072)] = 167512,
  [SMALL_STATE(4073)] = 167538,
  [SMALL_STATE(4074)] = 167566,
  [SMALL_STATE(4075)] = 167594,
  [SMALL_STATE(4076)] = 167616,
  [SMALL_STATE(4077)] = 167638,
  [SMALL_STATE(4078)] = 167664,
  [SMALL_STATE(4079)] = 167690,
  [SMALL_STATE(4080)] = 167714,
  [SMALL_STATE(4081)] = 167742,
  [SMALL_STATE(4082)] = 167760,
  [SMALL_STATE(4083)] = 167778,
  [SMALL_STATE(4084)] = 167806,
  [SMALL_STATE(4085)] = 167832,
  [SMALL_STATE(4086)] = 167854,
  [SMALL_STATE(4087)] = 167874,
  [SMALL_STATE(4088)] = 167896,
  [SMALL_STATE(4089)] = 167918,
  [SMALL_STATE(4090)] = 167940,
  [SMALL_STATE(4091)] = 167962,
  [SMALL_STATE(4092)] = 167990,
  [SMALL_STATE(4093)] = 168018,
  [SMALL_STATE(4094)] = 168040,
  [SMALL_STATE(4095)] = 168060,
  [SMALL_STATE(4096)] = 168082,
  [SMALL_STATE(4097)] = 168108,
  [SMALL_STATE(4098)] = 168134,
  [SMALL_STATE(4099)] = 168162,
  [SMALL_STATE(4100)] = 168184,
  [SMALL_STATE(4101)] = 168206,
  [SMALL_STATE(4102)] = 168228,
  [SMALL_STATE(4103)] = 168250,
  [SMALL_STATE(4104)] = 168278,
  [SMALL_STATE(4105)] = 168306,
  [SMALL_STATE(4106)] = 168334,
  [SMALL_STATE(4107)] = 168362,
  [SMALL_STATE(4108)] = 168390,
  [SMALL_STATE(4109)] = 168418,
  [SMALL_STATE(4110)] = 168440,
  [SMALL_STATE(4111)] = 168462,
  [SMALL_STATE(4112)] = 168484,
  [SMALL_STATE(4113)] = 168508,
  [SMALL_STATE(4114)] = 168526,
  [SMALL_STATE(4115)] = 168544,
  [SMALL_STATE(4116)] = 168570,
  [SMALL_STATE(4117)] = 168596,
  [SMALL_STATE(4118)] = 168624,
  [SMALL_STATE(4119)] = 168652,
  [SMALL_STATE(4120)] = 168676,
  [SMALL_STATE(4121)] = 168698,
  [SMALL_STATE(4122)] = 168720,
  [SMALL_STATE(4123)] = 168748,
  [SMALL_STATE(4124)] = 168770,
  [SMALL_STATE(4125)] = 168798,
  [SMALL_STATE(4126)] = 168820,
  [SMALL_STATE(4127)] = 168848,
  [SMALL_STATE(4128)] = 168868,
  [SMALL_STATE(4129)] = 168896,
  [SMALL_STATE(4130)] = 168920,
  [SMALL_STATE(4131)] = 168948,
  [SMALL_STATE(4132)] = 168976,
  [SMALL_STATE(4133)] = 169004,
  [SMALL_STATE(4134)] = 169032,
  [SMALL_STATE(4135)] = 169060,
  [SMALL_STATE(4136)] = 169084,
  [SMALL_STATE(4137)] = 169108,
  [SMALL_STATE(4138)] = 169132,
  [SMALL_STATE(4139)] = 169156,
  [SMALL_STATE(4140)] = 169178,
  [SMALL_STATE(4141)] = 169200,
  [SMALL_STATE(4142)] = 169228,
  [SMALL_STATE(4143)] = 169256,
  [SMALL_STATE(4144)] = 169278,
  [SMALL_STATE(4145)] = 169306,
  [SMALL_STATE(4146)] = 169328,
  [SMALL_STATE(4147)] = 169350,
  [SMALL_STATE(4148)] = 169378,
  [SMALL_STATE(4149)] = 169398,
  [SMALL_STATE(4150)] = 169422,
  [SMALL_STATE(4151)] = 169440,
  [SMALL_STATE(4152)] = 169462,
  [SMALL_STATE(4153)] = 169484,
  [SMALL_STATE(4154)] = 169512,
  [SMALL_STATE(4155)] = 169538,
  [SMALL_STATE(4156)] = 169566,
  [SMALL_STATE(4157)] = 169594,
  [SMALL_STATE(4158)] = 169622,
  [SMALL_STATE(4159)] = 169644,
  [SMALL_STATE(4160)] = 169672,
  [SMALL_STATE(4161)] = 169698,
  [SMALL_STATE(4162)] = 169718,
  [SMALL_STATE(4163)] = 169742,
  [SMALL_STATE(4164)] = 169764,
  [SMALL_STATE(4165)] = 169786,
  [SMALL_STATE(4166)] = 169806,
  [SMALL_STATE(4167)] = 169828,
  [SMALL_STATE(4168)] = 169856,
  [SMALL_STATE(4169)] = 169878,
  [SMALL_STATE(4170)] = 169900,
  [SMALL_STATE(4171)] = 169922,
  [SMALL_STATE(4172)] = 169950,
  [SMALL_STATE(4173)] = 169976,
  [SMALL_STATE(4174)] = 170004,
  [SMALL_STATE(4175)] = 170032,
  [SMALL_STATE(4176)] = 170060,
  [SMALL_STATE(4177)] = 170088,
  [SMALL_STATE(4178)] = 170116,
  [SMALL_STATE(4179)] = 170142,
  [SMALL_STATE(4180)] = 170170,
  [SMALL_STATE(4181)] = 170198,
  [SMALL_STATE(4182)] = 170226,
  [SMALL_STATE(4183)] = 170254,
  [SMALL_STATE(4184)] = 170280,
  [SMALL_STATE(4185)] = 170308,
  [SMALL_STATE(4186)] = 170336,
  [SMALL_STATE(4187)] = 170364,
  [SMALL_STATE(4188)] = 170386,
  [SMALL_STATE(4189)] = 170408,
  [SMALL_STATE(4190)] = 170436,
  [SMALL_STATE(4191)] = 170458,
  [SMALL_STATE(4192)] = 170476,
  [SMALL_STATE(4193)] = 170494,
  [SMALL_STATE(4194)] = 170516,
  [SMALL_STATE(4195)] = 170534,
  [SMALL_STATE(4196)] = 170552,
  [SMALL_STATE(4197)] = 170573,
  [SMALL_STATE(4198)] = 170594,
  [SMALL_STATE(4199)] = 170615,
  [SMALL_STATE(4200)] = 170636,
  [SMALL_STATE(4201)] = 170653,
  [SMALL_STATE(4202)] = 170674,
  [SMALL_STATE(4203)] = 170697,
  [SMALL_STATE(4204)] = 170722,
  [SMALL_STATE(4205)] = 170743,
  [SMALL_STATE(4206)] = 170760,
  [SMALL_STATE(4207)] = 170785,
  [SMALL_STATE(4208)] = 170806,
  [SMALL_STATE(4209)] = 170827,
  [SMALL_STATE(4210)] = 170848,
  [SMALL_STATE(4211)] = 170869,
  [SMALL_STATE(4212)] = 170890,
  [SMALL_STATE(4213)] = 170915,
  [SMALL_STATE(4214)] = 170936,
  [SMALL_STATE(4215)] = 170957,
  [SMALL_STATE(4216)] = 170974,
  [SMALL_STATE(4217)] = 170995,
  [SMALL_STATE(4218)] = 171020,
  [SMALL_STATE(4219)] = 171041,
  [SMALL_STATE(4220)] = 171058,
  [SMALL_STATE(4221)] = 171083,
  [SMALL_STATE(4222)] = 171108,
  [SMALL_STATE(4223)] = 171125,
  [SMALL_STATE(4224)] = 171142,
  [SMALL_STATE(4225)] = 171159,
  [SMALL_STATE(4226)] = 171184,
  [SMALL_STATE(4227)] = 171201,
  [SMALL_STATE(4228)] = 171222,
  [SMALL_STATE(4229)] = 171239,
  [SMALL_STATE(4230)] = 171260,
  [SMALL_STATE(4231)] = 171277,
  [SMALL_STATE(4232)] = 171300,
  [SMALL_STATE(4233)] = 171321,
  [SMALL_STATE(4234)] = 171342,
  [SMALL_STATE(4235)] = 171359,
  [SMALL_STATE(4236)] = 171384,
  [SMALL_STATE(4237)] = 171405,
  [SMALL_STATE(4238)] = 171422,
  [SMALL_STATE(4239)] = 171443,
  [SMALL_STATE(4240)] = 171460,
  [SMALL_STATE(4241)] = 171481,
  [SMALL_STATE(4242)] = 171498,
  [SMALL_STATE(4243)] = 171519,
  [SMALL_STATE(4244)] = 171544,
  [SMALL_STATE(4245)] = 171561,
  [SMALL_STATE(4246)] = 171586,
  [SMALL_STATE(4247)] = 171607,
  [SMALL_STATE(4248)] = 171624,
  [SMALL_STATE(4249)] = 171645,
  [SMALL_STATE(4250)] = 171666,
  [SMALL_STATE(4251)] = 171687,
  [SMALL_STATE(4252)] = 171704,
  [SMALL_STATE(4253)] = 171721,
  [SMALL_STATE(4254)] = 171742,
  [SMALL_STATE(4255)] = 171763,
  [SMALL_STATE(4256)] = 171780,
  [SMALL_STATE(4257)] = 171797,
  [SMALL_STATE(4258)] = 171818,
  [SMALL_STATE(4259)] = 171839,
  [SMALL_STATE(4260)] = 171860,
  [SMALL_STATE(4261)] = 171885,
  [SMALL_STATE(4262)] = 171906,
  [SMALL_STATE(4263)] = 171931,
  [SMALL_STATE(4264)] = 171952,
  [SMALL_STATE(4265)] = 171977,
  [SMALL_STATE(4266)] = 172002,
  [SMALL_STATE(4267)] = 172027,
  [SMALL_STATE(4268)] = 172048,
  [SMALL_STATE(4269)] = 172069,
  [SMALL_STATE(4270)] = 172086,
  [SMALL_STATE(4271)] = 172103,
  [SMALL_STATE(4272)] = 172120,
  [SMALL_STATE(4273)] = 172137,
  [SMALL_STATE(4274)] = 172154,
  [SMALL_STATE(4275)] = 172173,
  [SMALL_STATE(4276)] = 172194,
  [SMALL_STATE(4277)] = 172219,
  [SMALL_STATE(4278)] = 172236,
  [SMALL_STATE(4279)] = 172257,
  [SMALL_STATE(4280)] = 172282,
  [SMALL_STATE(4281)] = 172299,
  [SMALL_STATE(4282)] = 172320,
  [SMALL_STATE(4283)] = 172337,
  [SMALL_STATE(4284)] = 172358,
  [SMALL_STATE(4285)] = 172383,
  [SMALL_STATE(4286)] = 172404,
  [SMALL_STATE(4287)] = 172421,
  [SMALL_STATE(4288)] = 172438,
  [SMALL_STATE(4289)] = 172455,
  [SMALL_STATE(4290)] = 172476,
  [SMALL_STATE(4291)] = 172497,
  [SMALL_STATE(4292)] = 172514,
  [SMALL_STATE(4293)] = 172535,
  [SMALL_STATE(4294)] = 172560,
  [SMALL_STATE(4295)] = 172585,
  [SMALL_STATE(4296)] = 172606,
  [SMALL_STATE(4297)] = 172627,
  [SMALL_STATE(4298)] = 172648,
  [SMALL_STATE(4299)] = 172673,
  [SMALL_STATE(4300)] = 172694,
  [SMALL_STATE(4301)] = 172715,
  [SMALL_STATE(4302)] = 172736,
  [SMALL_STATE(4303)] = 172757,
  [SMALL_STATE(4304)] = 172778,
  [SMALL_STATE(4305)] = 172799,
  [SMALL_STATE(4306)] = 172820,
  [SMALL_STATE(4307)] = 172841,
  [SMALL_STATE(4308)] = 172866,
  [SMALL_STATE(4309)] = 172887,
  [SMALL_STATE(4310)] = 172912,
  [SMALL_STATE(4311)] = 172933,
  [SMALL_STATE(4312)] = 172958,
  [SMALL_STATE(4313)] = 172981,
  [SMALL_STATE(4314)] = 173006,
  [SMALL_STATE(4315)] = 173023,
  [SMALL_STATE(4316)] = 173044,
  [SMALL_STATE(4317)] = 173065,
  [SMALL_STATE(4318)] = 173082,
  [SMALL_STATE(4319)] = 173107,
  [SMALL_STATE(4320)] = 173124,
  [SMALL_STATE(4321)] = 173145,
  [SMALL_STATE(4322)] = 173170,
  [SMALL_STATE(4323)] = 173187,
  [SMALL_STATE(4324)] = 173208,
  [SMALL_STATE(4325)] = 173229,
  [SMALL_STATE(4326)] = 173250,
  [SMALL_STATE(4327)] = 173267,
  [SMALL_STATE(4328)] = 173292,
  [SMALL_STATE(4329)] = 173317,
  [SMALL_STATE(4330)] = 173342,
  [SMALL_STATE(4331)] = 173359,
  [SMALL_STATE(4332)] = 173376,
  [SMALL_STATE(4333)] = 173397,
  [SMALL_STATE(4334)] = 173418,
  [SMALL_STATE(4335)] = 173443,
  [SMALL_STATE(4336)] = 173460,
  [SMALL_STATE(4337)] = 173477,
  [SMALL_STATE(4338)] = 173502,
  [SMALL_STATE(4339)] = 173523,
  [SMALL_STATE(4340)] = 173540,
  [SMALL_STATE(4341)] = 173557,
  [SMALL_STATE(4342)] = 173574,
  [SMALL_STATE(4343)] = 173595,
  [SMALL_STATE(4344)] = 173620,
  [SMALL_STATE(4345)] = 173645,
  [SMALL_STATE(4346)] = 173662,
  [SMALL_STATE(4347)] = 173679,
  [SMALL_STATE(4348)] = 173696,
  [SMALL_STATE(4349)] = 173721,
  [SMALL_STATE(4350)] = 173738,
  [SMALL_STATE(4351)] = 173763,
  [SMALL_STATE(4352)] = 173780,
  [SMALL_STATE(4353)] = 173805,
  [SMALL_STATE(4354)] = 173828,
  [SMALL_STATE(4355)] = 173853,
  [SMALL_STATE(4356)] = 173878,
  [SMALL_STATE(4357)] = 173899,
  [SMALL_STATE(4358)] = 173916,
  [SMALL_STATE(4359)] = 173937,
  [SMALL_STATE(4360)] = 173960,
  [SMALL_STATE(4361)] = 173985,
  [SMALL_STATE(4362)] = 174002,
  [SMALL_STATE(4363)] = 174023,
  [SMALL_STATE(4364)] = 174048,
  [SMALL_STATE(4365)] = 174069,
  [SMALL_STATE(4366)] = 174090,
  [SMALL_STATE(4367)] = 174113,
  [SMALL_STATE(4368)] = 174134,
  [SMALL_STATE(4369)] = 174159,
  [SMALL_STATE(4370)] = 174176,
  [SMALL_STATE(4371)] = 174197,
  [SMALL_STATE(4372)] = 174222,
  [SMALL_STATE(4373)] = 174247,
  [SMALL_STATE(4374)] = 174272,
  [SMALL_STATE(4375)] = 174293,
  [SMALL_STATE(4376)] = 174310,
  [SMALL_STATE(4377)] = 174331,
  [SMALL_STATE(4378)] = 174356,
  [SMALL_STATE(4379)] = 174377,
  [SMALL_STATE(4380)] = 174398,
  [SMALL_STATE(4381)] = 174419,
  [SMALL_STATE(4382)] = 174444,
  [SMALL_STATE(4383)] = 174467,
  [SMALL_STATE(4384)] = 174488,
  [SMALL_STATE(4385)] = 174509,
  [SMALL_STATE(4386)] = 174534,
  [SMALL_STATE(4387)] = 174559,
  [SMALL_STATE(4388)] = 174580,
  [SMALL_STATE(4389)] = 174601,
  [SMALL_STATE(4390)] = 174622,
  [SMALL_STATE(4391)] = 174647,
  [SMALL_STATE(4392)] = 174664,
  [SMALL_STATE(4393)] = 174681,
  [SMALL_STATE(4394)] = 174706,
  [SMALL_STATE(4395)] = 174727,
  [SMALL_STATE(4396)] = 174752,
  [SMALL_STATE(4397)] = 174777,
  [SMALL_STATE(4398)] = 174802,
  [SMALL_STATE(4399)] = 174819,
  [SMALL_STATE(4400)] = 174836,
  [SMALL_STATE(4401)] = 174857,
  [SMALL_STATE(4402)] = 174878,
  [SMALL_STATE(4403)] = 174899,
  [SMALL_STATE(4404)] = 174920,
  [SMALL_STATE(4405)] = 174945,
  [SMALL_STATE(4406)] = 174966,
  [SMALL_STATE(4407)] = 174991,
  [SMALL_STATE(4408)] = 175012,
  [SMALL_STATE(4409)] = 175033,
  [SMALL_STATE(4410)] = 175054,
  [SMALL_STATE(4411)] = 175075,
  [SMALL_STATE(4412)] = 175092,
  [SMALL_STATE(4413)] = 175109,
  [SMALL_STATE(4414)] = 175126,
  [SMALL_STATE(4415)] = 175143,
  [SMALL_STATE(4416)] = 175164,
  [SMALL_STATE(4417)] = 175181,
  [SMALL_STATE(4418)] = 175202,
  [SMALL_STATE(4419)] = 175219,
  [SMALL_STATE(4420)] = 175240,
  [SMALL_STATE(4421)] = 175261,
  [SMALL_STATE(4422)] = 175278,
  [SMALL_STATE(4423)] = 175299,
  [SMALL_STATE(4424)] = 175320,
  [SMALL_STATE(4425)] = 175341,
  [SMALL_STATE(4426)] = 175366,
  [SMALL_STATE(4427)] = 175383,
  [SMALL_STATE(4428)] = 175408,
  [SMALL_STATE(4429)] = 175425,
  [SMALL_STATE(4430)] = 175442,
  [SMALL_STATE(4431)] = 175463,
  [SMALL_STATE(4432)] = 175484,
  [SMALL_STATE(4433)] = 175505,
  [SMALL_STATE(4434)] = 175526,
  [SMALL_STATE(4435)] = 175543,
  [SMALL_STATE(4436)] = 175564,
  [SMALL_STATE(4437)] = 175581,
  [SMALL_STATE(4438)] = 175602,
  [SMALL_STATE(4439)] = 175619,
  [SMALL_STATE(4440)] = 175640,
  [SMALL_STATE(4441)] = 175657,
  [SMALL_STATE(4442)] = 175674,
  [SMALL_STATE(4443)] = 175695,
  [SMALL_STATE(4444)] = 175712,
  [SMALL_STATE(4445)] = 175733,
  [SMALL_STATE(4446)] = 175758,
  [SMALL_STATE(4447)] = 175783,
  [SMALL_STATE(4448)] = 175804,
  [SMALL_STATE(4449)] = 175821,
  [SMALL_STATE(4450)] = 175838,
  [SMALL_STATE(4451)] = 175859,
  [SMALL_STATE(4452)] = 175880,
  [SMALL_STATE(4453)] = 175901,
  [SMALL_STATE(4454)] = 175926,
  [SMALL_STATE(4455)] = 175947,
  [SMALL_STATE(4456)] = 175964,
  [SMALL_STATE(4457)] = 175989,
  [SMALL_STATE(4458)] = 176006,
  [SMALL_STATE(4459)] = 176023,
  [SMALL_STATE(4460)] = 176046,
  [SMALL_STATE(4461)] = 176067,
  [SMALL_STATE(4462)] = 176092,
  [SMALL_STATE(4463)] = 176117,
  [SMALL_STATE(4464)] = 176138,
  [SMALL_STATE(4465)] = 176159,
  [SMALL_STATE(4466)] = 176180,
  [SMALL_STATE(4467)] = 176203,
  [SMALL_STATE(4468)] = 176220,
  [SMALL_STATE(4469)] = 176237,
  [SMALL_STATE(4470)] = 176260,
  [SMALL_STATE(4471)] = 176285,
  [SMALL_STATE(4472)] = 176302,
  [SMALL_STATE(4473)] = 176319,
  [SMALL_STATE(4474)] = 176340,
  [SMALL_STATE(4475)] = 176363,
  [SMALL_STATE(4476)] = 176386,
  [SMALL_STATE(4477)] = 176403,
  [SMALL_STATE(4478)] = 176420,
  [SMALL_STATE(4479)] = 176437,
  [SMALL_STATE(4480)] = 176458,
  [SMALL_STATE(4481)] = 176479,
  [SMALL_STATE(4482)] = 176496,
  [SMALL_STATE(4483)] = 176521,
  [SMALL_STATE(4484)] = 176538,
  [SMALL_STATE(4485)] = 176563,
  [SMALL_STATE(4486)] = 176584,
  [SMALL_STATE(4487)] = 176609,
  [SMALL_STATE(4488)] = 176630,
  [SMALL_STATE(4489)] = 176655,
  [SMALL_STATE(4490)] = 176676,
  [SMALL_STATE(4491)] = 176701,
  [SMALL_STATE(4492)] = 176726,
  [SMALL_STATE(4493)] = 176745,
  [SMALL_STATE(4494)] = 176762,
  [SMALL_STATE(4495)] = 176779,
  [SMALL_STATE(4496)] = 176800,
  [SMALL_STATE(4497)] = 176825,
  [SMALL_STATE(4498)] = 176842,
  [SMALL_STATE(4499)] = 176867,
  [SMALL_STATE(4500)] = 176892,
  [SMALL_STATE(4501)] = 176917,
  [SMALL_STATE(4502)] = 176940,
  [SMALL_STATE(4503)] = 176961,
  [SMALL_STATE(4504)] = 176982,
  [SMALL_STATE(4505)] = 177003,
  [SMALL_STATE(4506)] = 177024,
  [SMALL_STATE(4507)] = 177041,
  [SMALL_STATE(4508)] = 177066,
  [SMALL_STATE(4509)] = 177091,
  [SMALL_STATE(4510)] = 177112,
  [SMALL_STATE(4511)] = 177137,
  [SMALL_STATE(4512)] = 177158,
  [SMALL_STATE(4513)] = 177179,
  [SMALL_STATE(4514)] = 177196,
  [SMALL_STATE(4515)] = 177217,
  [SMALL_STATE(4516)] = 177242,
  [SMALL_STATE(4517)] = 177267,
  [SMALL_STATE(4518)] = 177288,
  [SMALL_STATE(4519)] = 177309,
  [SMALL_STATE(4520)] = 177326,
  [SMALL_STATE(4521)] = 177351,
  [SMALL_STATE(4522)] = 177368,
  [SMALL_STATE(4523)] = 177385,
  [SMALL_STATE(4524)] = 177402,
  [SMALL_STATE(4525)] = 177419,
  [SMALL_STATE(4526)] = 177436,
  [SMALL_STATE(4527)] = 177461,
  [SMALL_STATE(4528)] = 177478,
  [SMALL_STATE(4529)] = 177503,
  [SMALL_STATE(4530)] = 177520,
  [SMALL_STATE(4531)] = 177545,
  [SMALL_STATE(4532)] = 177570,
  [SMALL_STATE(4533)] = 177587,
  [SMALL_STATE(4534)] = 177612,
  [SMALL_STATE(4535)] = 177629,
  [SMALL_STATE(4536)] = 177650,
  [SMALL_STATE(4537)] = 177671,
  [SMALL_STATE(4538)] = 177692,
  [SMALL_STATE(4539)] = 177709,
  [SMALL_STATE(4540)] = 177730,
  [SMALL_STATE(4541)] = 177751,
  [SMALL_STATE(4542)] = 177772,
  [SMALL_STATE(4543)] = 177793,
  [SMALL_STATE(4544)] = 177810,
  [SMALL_STATE(4545)] = 177827,
  [SMALL_STATE(4546)] = 177850,
  [SMALL_STATE(4547)] = 177875,
  [SMALL_STATE(4548)] = 177892,
  [SMALL_STATE(4549)] = 177909,
  [SMALL_STATE(4550)] = 177930,
  [SMALL_STATE(4551)] = 177947,
  [SMALL_STATE(4552)] = 177964,
  [SMALL_STATE(4553)] = 177981,
  [SMALL_STATE(4554)] = 178002,
  [SMALL_STATE(4555)] = 178023,
  [SMALL_STATE(4556)] = 178040,
  [SMALL_STATE(4557)] = 178061,
  [SMALL_STATE(4558)] = 178078,
  [SMALL_STATE(4559)] = 178103,
  [SMALL_STATE(4560)] = 178120,
  [SMALL_STATE(4561)] = 178141,
  [SMALL_STATE(4562)] = 178158,
  [SMALL_STATE(4563)] = 178179,
  [SMALL_STATE(4564)] = 178200,
  [SMALL_STATE(4565)] = 178217,
  [SMALL_STATE(4566)] = 178242,
  [SMALL_STATE(4567)] = 178263,
  [SMALL_STATE(4568)] = 178288,
  [SMALL_STATE(4569)] = 178309,
  [SMALL_STATE(4570)] = 178334,
  [SMALL_STATE(4571)] = 178355,
  [SMALL_STATE(4572)] = 178380,
  [SMALL_STATE(4573)] = 178405,
  [SMALL_STATE(4574)] = 178426,
  [SMALL_STATE(4575)] = 178451,
  [SMALL_STATE(4576)] = 178472,
  [SMALL_STATE(4577)] = 178493,
  [SMALL_STATE(4578)] = 178516,
  [SMALL_STATE(4579)] = 178539,
  [SMALL_STATE(4580)] = 178564,
  [SMALL_STATE(4581)] = 178585,
  [SMALL_STATE(4582)] = 178606,
  [SMALL_STATE(4583)] = 178631,
  [SMALL_STATE(4584)] = 178656,
  [SMALL_STATE(4585)] = 178677,
  [SMALL_STATE(4586)] = 178702,
  [SMALL_STATE(4587)] = 178725,
  [SMALL_STATE(4588)] = 178746,
  [SMALL_STATE(4589)] = 178767,
  [SMALL_STATE(4590)] = 178792,
  [SMALL_STATE(4591)] = 178815,
  [SMALL_STATE(4592)] = 178840,
  [SMALL_STATE(4593)] = 178865,
  [SMALL_STATE(4594)] = 178886,
  [SMALL_STATE(4595)] = 178911,
  [SMALL_STATE(4596)] = 178936,
  [SMALL_STATE(4597)] = 178959,
  [SMALL_STATE(4598)] = 178984,
  [SMALL_STATE(4599)] = 179005,
  [SMALL_STATE(4600)] = 179026,
  [SMALL_STATE(4601)] = 179043,
  [SMALL_STATE(4602)] = 179060,
  [SMALL_STATE(4603)] = 179081,
  [SMALL_STATE(4604)] = 179106,
  [SMALL_STATE(4605)] = 179131,
  [SMALL_STATE(4606)] = 179152,
  [SMALL_STATE(4607)] = 179169,
  [SMALL_STATE(4608)] = 179186,
  [SMALL_STATE(4609)] = 179203,
  [SMALL_STATE(4610)] = 179220,
  [SMALL_STATE(4611)] = 179241,
  [SMALL_STATE(4612)] = 179262,
  [SMALL_STATE(4613)] = 179279,
  [SMALL_STATE(4614)] = 179300,
  [SMALL_STATE(4615)] = 179325,
  [SMALL_STATE(4616)] = 179342,
  [SMALL_STATE(4617)] = 179359,
  [SMALL_STATE(4618)] = 179378,
  [SMALL_STATE(4619)] = 179397,
  [SMALL_STATE(4620)] = 179414,
  [SMALL_STATE(4621)] = 179439,
  [SMALL_STATE(4622)] = 179456,
  [SMALL_STATE(4623)] = 179477,
  [SMALL_STATE(4624)] = 179502,
  [SMALL_STATE(4625)] = 179523,
  [SMALL_STATE(4626)] = 179548,
  [SMALL_STATE(4627)] = 179573,
  [SMALL_STATE(4628)] = 179594,
  [SMALL_STATE(4629)] = 179615,
  [SMALL_STATE(4630)] = 179640,
  [SMALL_STATE(4631)] = 179665,
  [SMALL_STATE(4632)] = 179686,
  [SMALL_STATE(4633)] = 179711,
  [SMALL_STATE(4634)] = 179732,
  [SMALL_STATE(4635)] = 179757,
  [SMALL_STATE(4636)] = 179782,
  [SMALL_STATE(4637)] = 179803,
  [SMALL_STATE(4638)] = 179820,
  [SMALL_STATE(4639)] = 179837,
  [SMALL_STATE(4640)] = 179862,
  [SMALL_STATE(4641)] = 179887,
  [SMALL_STATE(4642)] = 179904,
  [SMALL_STATE(4643)] = 179925,
  [SMALL_STATE(4644)] = 179950,
  [SMALL_STATE(4645)] = 179971,
  [SMALL_STATE(4646)] = 179992,
  [SMALL_STATE(4647)] = 180013,
  [SMALL_STATE(4648)] = 180036,
  [SMALL_STATE(4649)] = 180053,
  [SMALL_STATE(4650)] = 180074,
  [SMALL_STATE(4651)] = 180091,
  [SMALL_STATE(4652)] = 180116,
  [SMALL_STATE(4653)] = 180133,
  [SMALL_STATE(4654)] = 180150,
  [SMALL_STATE(4655)] = 180167,
  [SMALL_STATE(4656)] = 180188,
  [SMALL_STATE(4657)] = 180205,
  [SMALL_STATE(4658)] = 180230,
  [SMALL_STATE(4659)] = 180251,
  [SMALL_STATE(4660)] = 180268,
  [SMALL_STATE(4661)] = 180289,
  [SMALL_STATE(4662)] = 180310,
  [SMALL_STATE(4663)] = 180331,
  [SMALL_STATE(4664)] = 180350,
  [SMALL_STATE(4665)] = 180369,
  [SMALL_STATE(4666)] = 180394,
  [SMALL_STATE(4667)] = 180411,
  [SMALL_STATE(4668)] = 180432,
  [SMALL_STATE(4669)] = 180449,
  [SMALL_STATE(4670)] = 180470,
  [SMALL_STATE(4671)] = 180487,
  [SMALL_STATE(4672)] = 180504,
  [SMALL_STATE(4673)] = 180521,
  [SMALL_STATE(4674)] = 180538,
  [SMALL_STATE(4675)] = 180559,
  [SMALL_STATE(4676)] = 180584,
  [SMALL_STATE(4677)] = 180601,
  [SMALL_STATE(4678)] = 180618,
  [SMALL_STATE(4679)] = 180635,
  [SMALL_STATE(4680)] = 180652,
  [SMALL_STATE(4681)] = 180673,
  [SMALL_STATE(4682)] = 180693,
  [SMALL_STATE(4683)] = 180713,
  [SMALL_STATE(4684)] = 180733,
  [SMALL_STATE(4685)] = 180753,
  [SMALL_STATE(4686)] = 180775,
  [SMALL_STATE(4687)] = 180797,
  [SMALL_STATE(4688)] = 180819,
  [SMALL_STATE(4689)] = 180835,
  [SMALL_STATE(4690)] = 180851,
  [SMALL_STATE(4691)] = 180873,
  [SMALL_STATE(4692)] = 180889,
  [SMALL_STATE(4693)] = 180907,
  [SMALL_STATE(4694)] = 180927,
  [SMALL_STATE(4695)] = 180947,
  [SMALL_STATE(4696)] = 180969,
  [SMALL_STATE(4697)] = 180985,
  [SMALL_STATE(4698)] = 181007,
  [SMALL_STATE(4699)] = 181029,
  [SMALL_STATE(4700)] = 181049,
  [SMALL_STATE(4701)] = 181071,
  [SMALL_STATE(4702)] = 181093,
  [SMALL_STATE(4703)] = 181113,
  [SMALL_STATE(4704)] = 181135,
  [SMALL_STATE(4705)] = 181153,
  [SMALL_STATE(4706)] = 181173,
  [SMALL_STATE(4707)] = 181193,
  [SMALL_STATE(4708)] = 181213,
  [SMALL_STATE(4709)] = 181233,
  [SMALL_STATE(4710)] = 181251,
  [SMALL_STATE(4711)] = 181271,
  [SMALL_STATE(4712)] = 181293,
  [SMALL_STATE(4713)] = 181315,
  [SMALL_STATE(4714)] = 181337,
  [SMALL_STATE(4715)] = 181359,
  [SMALL_STATE(4716)] = 181381,
  [SMALL_STATE(4717)] = 181401,
  [SMALL_STATE(4718)] = 181423,
  [SMALL_STATE(4719)] = 181445,
  [SMALL_STATE(4720)] = 181467,
  [SMALL_STATE(4721)] = 181489,
  [SMALL_STATE(4722)] = 181511,
  [SMALL_STATE(4723)] = 181533,
  [SMALL_STATE(4724)] = 181555,
  [SMALL_STATE(4725)] = 181577,
  [SMALL_STATE(4726)] = 181593,
  [SMALL_STATE(4727)] = 181613,
  [SMALL_STATE(4728)] = 181633,
  [SMALL_STATE(4729)] = 181655,
  [SMALL_STATE(4730)] = 181677,
  [SMALL_STATE(4731)] = 181699,
  [SMALL_STATE(4732)] = 181721,
  [SMALL_STATE(4733)] = 181741,
  [SMALL_STATE(4734)] = 181761,
  [SMALL_STATE(4735)] = 181781,
  [SMALL_STATE(4736)] = 181803,
  [SMALL_STATE(4737)] = 181823,
  [SMALL_STATE(4738)] = 181843,
  [SMALL_STATE(4739)] = 181863,
  [SMALL_STATE(4740)] = 181881,
  [SMALL_STATE(4741)] = 181903,
  [SMALL_STATE(4742)] = 181925,
  [SMALL_STATE(4743)] = 181945,
  [SMALL_STATE(4744)] = 181963,
  [SMALL_STATE(4745)] = 181983,
  [SMALL_STATE(4746)] = 182003,
  [SMALL_STATE(4747)] = 182025,
  [SMALL_STATE(4748)] = 182045,
  [SMALL_STATE(4749)] = 182065,
  [SMALL_STATE(4750)] = 182085,
  [SMALL_STATE(4751)] = 182105,
  [SMALL_STATE(4752)] = 182127,
  [SMALL_STATE(4753)] = 182149,
  [SMALL_STATE(4754)] = 182167,
  [SMALL_STATE(4755)] = 182185,
  [SMALL_STATE(4756)] = 182207,
  [SMALL_STATE(4757)] = 182227,
  [SMALL_STATE(4758)] = 182247,
  [SMALL_STATE(4759)] = 182267,
  [SMALL_STATE(4760)] = 182287,
  [SMALL_STATE(4761)] = 182309,
  [SMALL_STATE(4762)] = 182329,
  [SMALL_STATE(4763)] = 182347,
  [SMALL_STATE(4764)] = 182363,
  [SMALL_STATE(4765)] = 182383,
  [SMALL_STATE(4766)] = 182405,
  [SMALL_STATE(4767)] = 182427,
  [SMALL_STATE(4768)] = 182449,
  [SMALL_STATE(4769)] = 182471,
  [SMALL_STATE(4770)] = 182493,
  [SMALL_STATE(4771)] = 182513,
  [SMALL_STATE(4772)] = 182535,
  [SMALL_STATE(4773)] = 182555,
  [SMALL_STATE(4774)] = 182575,
  [SMALL_STATE(4775)] = 182597,
  [SMALL_STATE(4776)] = 182619,
  [SMALL_STATE(4777)] = 182641,
  [SMALL_STATE(4778)] = 182663,
  [SMALL_STATE(4779)] = 182685,
  [SMALL_STATE(4780)] = 182705,
  [SMALL_STATE(4781)] = 182727,
  [SMALL_STATE(4782)] = 182747,
  [SMALL_STATE(4783)] = 182769,
  [SMALL_STATE(4784)] = 182789,
  [SMALL_STATE(4785)] = 182807,
  [SMALL_STATE(4786)] = 182829,
  [SMALL_STATE(4787)] = 182851,
  [SMALL_STATE(4788)] = 182873,
  [SMALL_STATE(4789)] = 182895,
  [SMALL_STATE(4790)] = 182915,
  [SMALL_STATE(4791)] = 182937,
  [SMALL_STATE(4792)] = 182957,
  [SMALL_STATE(4793)] = 182979,
  [SMALL_STATE(4794)] = 183001,
  [SMALL_STATE(4795)] = 183023,
  [SMALL_STATE(4796)] = 183045,
  [SMALL_STATE(4797)] = 183065,
  [SMALL_STATE(4798)] = 183087,
  [SMALL_STATE(4799)] = 183109,
  [SMALL_STATE(4800)] = 183125,
  [SMALL_STATE(4801)] = 183145,
  [SMALL_STATE(4802)] = 183165,
  [SMALL_STATE(4803)] = 183187,
  [SMALL_STATE(4804)] = 183207,
  [SMALL_STATE(4805)] = 183227,
  [SMALL_STATE(4806)] = 183247,
  [SMALL_STATE(4807)] = 183267,
  [SMALL_STATE(4808)] = 183287,
  [SMALL_STATE(4809)] = 183307,
  [SMALL_STATE(4810)] = 183329,
  [SMALL_STATE(4811)] = 183349,
  [SMALL_STATE(4812)] = 183369,
  [SMALL_STATE(4813)] = 183391,
  [SMALL_STATE(4814)] = 183411,
  [SMALL_STATE(4815)] = 183431,
  [SMALL_STATE(4816)] = 183451,
  [SMALL_STATE(4817)] = 183473,
  [SMALL_STATE(4818)] = 183493,
  [SMALL_STATE(4819)] = 183513,
  [SMALL_STATE(4820)] = 183533,
  [SMALL_STATE(4821)] = 183553,
  [SMALL_STATE(4822)] = 183575,
  [SMALL_STATE(4823)] = 183597,
  [SMALL_STATE(4824)] = 183619,
  [SMALL_STATE(4825)] = 183641,
  [SMALL_STATE(4826)] = 183661,
  [SMALL_STATE(4827)] = 183681,
  [SMALL_STATE(4828)] = 183701,
  [SMALL_STATE(4829)] = 183723,
  [SMALL_STATE(4830)] = 183745,
  [SMALL_STATE(4831)] = 183767,
  [SMALL_STATE(4832)] = 183785,
  [SMALL_STATE(4833)] = 183807,
  [SMALL_STATE(4834)] = 183829,
  [SMALL_STATE(4835)] = 183847,
  [SMALL_STATE(4836)] = 183867,
  [SMALL_STATE(4837)] = 183887,
  [SMALL_STATE(4838)] = 183907,
  [SMALL_STATE(4839)] = 183929,
  [SMALL_STATE(4840)] = 183949,
  [SMALL_STATE(4841)] = 183971,
  [SMALL_STATE(4842)] = 183993,
  [SMALL_STATE(4843)] = 184015,
  [SMALL_STATE(4844)] = 184031,
  [SMALL_STATE(4845)] = 184049,
  [SMALL_STATE(4846)] = 184069,
  [SMALL_STATE(4847)] = 184091,
  [SMALL_STATE(4848)] = 184111,
  [SMALL_STATE(4849)] = 184131,
  [SMALL_STATE(4850)] = 184153,
  [SMALL_STATE(4851)] = 184173,
  [SMALL_STATE(4852)] = 184193,
  [SMALL_STATE(4853)] = 184215,
  [SMALL_STATE(4854)] = 184237,
  [SMALL_STATE(4855)] = 184257,
  [SMALL_STATE(4856)] = 184279,
  [SMALL_STATE(4857)] = 184299,
  [SMALL_STATE(4858)] = 184319,
  [SMALL_STATE(4859)] = 184339,
  [SMALL_STATE(4860)] = 184359,
  [SMALL_STATE(4861)] = 184381,
  [SMALL_STATE(4862)] = 184401,
  [SMALL_STATE(4863)] = 184418,
  [SMALL_STATE(4864)] = 184437,
  [SMALL_STATE(4865)] = 184452,
  [SMALL_STATE(4866)] = 184467,
  [SMALL_STATE(4867)] = 184486,
  [SMALL_STATE(4868)] = 184501,
  [SMALL_STATE(4869)] = 184520,
  [SMALL_STATE(4870)] = 184539,
  [SMALL_STATE(4871)] = 184554,
  [SMALL_STATE(4872)] = 184569,
  [SMALL_STATE(4873)] = 184584,
  [SMALL_STATE(4874)] = 184599,
  [SMALL_STATE(4875)] = 184614,
  [SMALL_STATE(4876)] = 184629,
  [SMALL_STATE(4877)] = 184644,
  [SMALL_STATE(4878)] = 184663,
  [SMALL_STATE(4879)] = 184678,
  [SMALL_STATE(4880)] = 184693,
  [SMALL_STATE(4881)] = 184708,
  [SMALL_STATE(4882)] = 184723,
  [SMALL_STATE(4883)] = 184738,
  [SMALL_STATE(4884)] = 184753,
  [SMALL_STATE(4885)] = 184772,
  [SMALL_STATE(4886)] = 184791,
  [SMALL_STATE(4887)] = 184806,
  [SMALL_STATE(4888)] = 184825,
  [SMALL_STATE(4889)] = 184840,
  [SMALL_STATE(4890)] = 184855,
  [SMALL_STATE(4891)] = 184874,
  [SMALL_STATE(4892)] = 184889,
  [SMALL_STATE(4893)] = 184904,
  [SMALL_STATE(4894)] = 184919,
  [SMALL_STATE(4895)] = 184934,
  [SMALL_STATE(4896)] = 184953,
  [SMALL_STATE(4897)] = 184968,
  [SMALL_STATE(4898)] = 184987,
  [SMALL_STATE(4899)] = 185002,
  [SMALL_STATE(4900)] = 185017,
  [SMALL_STATE(4901)] = 185032,
  [SMALL_STATE(4902)] = 185047,
  [SMALL_STATE(4903)] = 185062,
  [SMALL_STATE(4904)] = 185077,
  [SMALL_STATE(4905)] = 185092,
  [SMALL_STATE(4906)] = 185107,
  [SMALL_STATE(4907)] = 185122,
  [SMALL_STATE(4908)] = 185137,
  [SMALL_STATE(4909)] = 185154,
  [SMALL_STATE(4910)] = 185171,
  [SMALL_STATE(4911)] = 185190,
  [SMALL_STATE(4912)] = 185205,
  [SMALL_STATE(4913)] = 185224,
  [SMALL_STATE(4914)] = 185243,
  [SMALL_STATE(4915)] = 185260,
  [SMALL_STATE(4916)] = 185279,
  [SMALL_STATE(4917)] = 185294,
  [SMALL_STATE(4918)] = 185309,
  [SMALL_STATE(4919)] = 185324,
  [SMALL_STATE(4920)] = 185339,
  [SMALL_STATE(4921)] = 185354,
  [SMALL_STATE(4922)] = 185373,
  [SMALL_STATE(4923)] = 185388,
  [SMALL_STATE(4924)] = 185403,
  [SMALL_STATE(4925)] = 185422,
  [SMALL_STATE(4926)] = 185439,
  [SMALL_STATE(4927)] = 185454,
  [SMALL_STATE(4928)] = 185469,
  [SMALL_STATE(4929)] = 185484,
  [SMALL_STATE(4930)] = 185499,
  [SMALL_STATE(4931)] = 185516,
  [SMALL_STATE(4932)] = 185531,
  [SMALL_STATE(4933)] = 185548,
  [SMALL_STATE(4934)] = 185567,
  [SMALL_STATE(4935)] = 185582,
  [SMALL_STATE(4936)] = 185597,
  [SMALL_STATE(4937)] = 185614,
  [SMALL_STATE(4938)] = 185629,
  [SMALL_STATE(4939)] = 185648,
  [SMALL_STATE(4940)] = 185667,
  [SMALL_STATE(4941)] = 185684,
  [SMALL_STATE(4942)] = 185703,
  [SMALL_STATE(4943)] = 185722,
  [SMALL_STATE(4944)] = 185737,
  [SMALL_STATE(4945)] = 185752,
  [SMALL_STATE(4946)] = 185769,
  [SMALL_STATE(4947)] = 185784,
  [SMALL_STATE(4948)] = 185803,
  [SMALL_STATE(4949)] = 185820,
  [SMALL_STATE(4950)] = 185835,
  [SMALL_STATE(4951)] = 185854,
  [SMALL_STATE(4952)] = 185869,
  [SMALL_STATE(4953)] = 185888,
  [SMALL_STATE(4954)] = 185903,
  [SMALL_STATE(4955)] = 185920,
  [SMALL_STATE(4956)] = 185939,
  [SMALL_STATE(4957)] = 185954,
  [SMALL_STATE(4958)] = 185973,
  [SMALL_STATE(4959)] = 185988,
  [SMALL_STATE(4960)] = 186003,
  [SMALL_STATE(4961)] = 186018,
  [SMALL_STATE(4962)] = 186033,
  [SMALL_STATE(4963)] = 186050,
  [SMALL_STATE(4964)] = 186069,
  [SMALL_STATE(4965)] = 186084,
  [SMALL_STATE(4966)] = 186099,
  [SMALL_STATE(4967)] = 186114,
  [SMALL_STATE(4968)] = 186129,
  [SMALL_STATE(4969)] = 186144,
  [SMALL_STATE(4970)] = 186159,
  [SMALL_STATE(4971)] = 186174,
  [SMALL_STATE(4972)] = 186189,
  [SMALL_STATE(4973)] = 186208,
  [SMALL_STATE(4974)] = 186227,
  [SMALL_STATE(4975)] = 186246,
  [SMALL_STATE(4976)] = 186261,
  [SMALL_STATE(4977)] = 186276,
  [SMALL_STATE(4978)] = 186291,
  [SMALL_STATE(4979)] = 186310,
  [SMALL_STATE(4980)] = 186329,
  [SMALL_STATE(4981)] = 186344,
  [SMALL_STATE(4982)] = 186359,
  [SMALL_STATE(4983)] = 186374,
  [SMALL_STATE(4984)] = 186389,
  [SMALL_STATE(4985)] = 186404,
  [SMALL_STATE(4986)] = 186419,
  [SMALL_STATE(4987)] = 186434,
  [SMALL_STATE(4988)] = 186449,
  [SMALL_STATE(4989)] = 186464,
  [SMALL_STATE(4990)] = 186479,
  [SMALL_STATE(4991)] = 186494,
  [SMALL_STATE(4992)] = 186513,
  [SMALL_STATE(4993)] = 186532,
  [SMALL_STATE(4994)] = 186551,
  [SMALL_STATE(4995)] = 186566,
  [SMALL_STATE(4996)] = 186581,
  [SMALL_STATE(4997)] = 186600,
  [SMALL_STATE(4998)] = 186617,
  [SMALL_STATE(4999)] = 186636,
  [SMALL_STATE(5000)] = 186651,
  [SMALL_STATE(5001)] = 186666,
  [SMALL_STATE(5002)] = 186681,
  [SMALL_STATE(5003)] = 186696,
  [SMALL_STATE(5004)] = 186711,
  [SMALL_STATE(5005)] = 186726,
  [SMALL_STATE(5006)] = 186745,
  [SMALL_STATE(5007)] = 186764,
  [SMALL_STATE(5008)] = 186783,
  [SMALL_STATE(5009)] = 186798,
  [SMALL_STATE(5010)] = 186817,
  [SMALL_STATE(5011)] = 186836,
  [SMALL_STATE(5012)] = 186851,
  [SMALL_STATE(5013)] = 186866,
  [SMALL_STATE(5014)] = 186885,
  [SMALL_STATE(5015)] = 186900,
  [SMALL_STATE(5016)] = 186915,
  [SMALL_STATE(5017)] = 186930,
  [SMALL_STATE(5018)] = 186945,
  [SMALL_STATE(5019)] = 186964,
  [SMALL_STATE(5020)] = 186983,
  [SMALL_STATE(5021)] = 186998,
  [SMALL_STATE(5022)] = 187017,
  [SMALL_STATE(5023)] = 187036,
  [SMALL_STATE(5024)] = 187055,
  [SMALL_STATE(5025)] = 187074,
  [SMALL_STATE(5026)] = 187093,
  [SMALL_STATE(5027)] = 187108,
  [SMALL_STATE(5028)] = 187123,
  [SMALL_STATE(5029)] = 187138,
  [SMALL_STATE(5030)] = 187157,
  [SMALL_STATE(5031)] = 187172,
  [SMALL_STATE(5032)] = 187187,
  [SMALL_STATE(5033)] = 187206,
  [SMALL_STATE(5034)] = 187221,
  [SMALL_STATE(5035)] = 187240,
  [SMALL_STATE(5036)] = 187255,
  [SMALL_STATE(5037)] = 187272,
  [SMALL_STATE(5038)] = 187287,
  [SMALL_STATE(5039)] = 187306,
  [SMALL_STATE(5040)] = 187325,
  [SMALL_STATE(5041)] = 187344,
  [SMALL_STATE(5042)] = 187359,
  [SMALL_STATE(5043)] = 187374,
  [SMALL_STATE(5044)] = 187389,
  [SMALL_STATE(5045)] = 187404,
  [SMALL_STATE(5046)] = 187419,
  [SMALL_STATE(5047)] = 187434,
  [SMALL_STATE(5048)] = 187449,
  [SMALL_STATE(5049)] = 187466,
  [SMALL_STATE(5050)] = 187483,
  [SMALL_STATE(5051)] = 187502,
  [SMALL_STATE(5052)] = 187517,
  [SMALL_STATE(5053)] = 187532,
  [SMALL_STATE(5054)] = 187547,
  [SMALL_STATE(5055)] = 187562,
  [SMALL_STATE(5056)] = 187577,
  [SMALL_STATE(5057)] = 187596,
  [SMALL_STATE(5058)] = 187611,
  [SMALL_STATE(5059)] = 187626,
  [SMALL_STATE(5060)] = 187645,
  [SMALL_STATE(5061)] = 187660,
  [SMALL_STATE(5062)] = 187675,
  [SMALL_STATE(5063)] = 187690,
  [SMALL_STATE(5064)] = 187705,
  [SMALL_STATE(5065)] = 187720,
  [SMALL_STATE(5066)] = 187735,
  [SMALL_STATE(5067)] = 187750,
  [SMALL_STATE(5068)] = 187765,
  [SMALL_STATE(5069)] = 187784,
  [SMALL_STATE(5070)] = 187803,
  [SMALL_STATE(5071)] = 187818,
  [SMALL_STATE(5072)] = 187835,
  [SMALL_STATE(5073)] = 187852,
  [SMALL_STATE(5074)] = 187871,
  [SMALL_STATE(5075)] = 187886,
  [SMALL_STATE(5076)] = 187901,
  [SMALL_STATE(5077)] = 187916,
  [SMALL_STATE(5078)] = 187931,
  [SMALL_STATE(5079)] = 187948,
  [SMALL_STATE(5080)] = 187967,
  [SMALL_STATE(5081)] = 187982,
  [SMALL_STATE(5082)] = 187997,
  [SMALL_STATE(5083)] = 188012,
  [SMALL_STATE(5084)] = 188027,
  [SMALL_STATE(5085)] = 188046,
  [SMALL_STATE(5086)] = 188061,
  [SMALL_STATE(5087)] = 188080,
  [SMALL_STATE(5088)] = 188099,
  [SMALL_STATE(5089)] = 188114,
  [SMALL_STATE(5090)] = 188133,
  [SMALL_STATE(5091)] = 188148,
  [SMALL_STATE(5092)] = 188163,
  [SMALL_STATE(5093)] = 188178,
  [SMALL_STATE(5094)] = 188193,
  [SMALL_STATE(5095)] = 188208,
  [SMALL_STATE(5096)] = 188223,
  [SMALL_STATE(5097)] = 188242,
  [SMALL_STATE(5098)] = 188259,
  [SMALL_STATE(5099)] = 188278,
  [SMALL_STATE(5100)] = 188295,
  [SMALL_STATE(5101)] = 188314,
  [SMALL_STATE(5102)] = 188329,
  [SMALL_STATE(5103)] = 188344,
  [SMALL_STATE(5104)] = 188363,
  [SMALL_STATE(5105)] = 188382,
  [SMALL_STATE(5106)] = 188401,
  [SMALL_STATE(5107)] = 188420,
  [SMALL_STATE(5108)] = 188435,
  [SMALL_STATE(5109)] = 188454,
  [SMALL_STATE(5110)] = 188469,
  [SMALL_STATE(5111)] = 188488,
  [SMALL_STATE(5112)] = 188505,
  [SMALL_STATE(5113)] = 188520,
  [SMALL_STATE(5114)] = 188539,
  [SMALL_STATE(5115)] = 188556,
  [SMALL_STATE(5116)] = 188571,
  [SMALL_STATE(5117)] = 188586,
  [SMALL_STATE(5118)] = 188601,
  [SMALL_STATE(5119)] = 188616,
  [SMALL_STATE(5120)] = 188631,
  [SMALL_STATE(5121)] = 188650,
  [SMALL_STATE(5122)] = 188669,
  [SMALL_STATE(5123)] = 188686,
  [SMALL_STATE(5124)] = 188701,
  [SMALL_STATE(5125)] = 188720,
  [SMALL_STATE(5126)] = 188735,
  [SMALL_STATE(5127)] = 188754,
  [SMALL_STATE(5128)] = 188773,
  [SMALL_STATE(5129)] = 188788,
  [SMALL_STATE(5130)] = 188803,
  [SMALL_STATE(5131)] = 188818,
  [SMALL_STATE(5132)] = 188835,
  [SMALL_STATE(5133)] = 188854,
  [SMALL_STATE(5134)] = 188873,
  [SMALL_STATE(5135)] = 188888,
  [SMALL_STATE(5136)] = 188907,
  [SMALL_STATE(5137)] = 188922,
  [SMALL_STATE(5138)] = 188941,
  [SMALL_STATE(5139)] = 188956,
  [SMALL_STATE(5140)] = 188973,
  [SMALL_STATE(5141)] = 188988,
  [SMALL_STATE(5142)] = 189007,
  [SMALL_STATE(5143)] = 189022,
  [SMALL_STATE(5144)] = 189041,
  [SMALL_STATE(5145)] = 189060,
  [SMALL_STATE(5146)] = 189075,
  [SMALL_STATE(5147)] = 189090,
  [SMALL_STATE(5148)] = 189109,
  [SMALL_STATE(5149)] = 189128,
  [SMALL_STATE(5150)] = 189147,
  [SMALL_STATE(5151)] = 189166,
  [SMALL_STATE(5152)] = 189185,
  [SMALL_STATE(5153)] = 189200,
  [SMALL_STATE(5154)] = 189215,
  [SMALL_STATE(5155)] = 189230,
  [SMALL_STATE(5156)] = 189245,
  [SMALL_STATE(5157)] = 189260,
  [SMALL_STATE(5158)] = 189275,
  [SMALL_STATE(5159)] = 189294,
  [SMALL_STATE(5160)] = 189313,
  [SMALL_STATE(5161)] = 189328,
  [SMALL_STATE(5162)] = 189343,
  [SMALL_STATE(5163)] = 189358,
  [SMALL_STATE(5164)] = 189375,
  [SMALL_STATE(5165)] = 189390,
  [SMALL_STATE(5166)] = 189405,
  [SMALL_STATE(5167)] = 189420,
  [SMALL_STATE(5168)] = 189435,
  [SMALL_STATE(5169)] = 189450,
  [SMALL_STATE(5170)] = 189465,
  [SMALL_STATE(5171)] = 189480,
  [SMALL_STATE(5172)] = 189497,
  [SMALL_STATE(5173)] = 189514,
  [SMALL_STATE(5174)] = 189533,
  [SMALL_STATE(5175)] = 189548,
  [SMALL_STATE(5176)] = 189567,
  [SMALL_STATE(5177)] = 189586,
  [SMALL_STATE(5178)] = 189601,
  [SMALL_STATE(5179)] = 189620,
  [SMALL_STATE(5180)] = 189635,
  [SMALL_STATE(5181)] = 189654,
  [SMALL_STATE(5182)] = 189669,
  [SMALL_STATE(5183)] = 189688,
  [SMALL_STATE(5184)] = 189707,
  [SMALL_STATE(5185)] = 189722,
  [SMALL_STATE(5186)] = 189737,
  [SMALL_STATE(5187)] = 189756,
  [SMALL_STATE(5188)] = 189775,
  [SMALL_STATE(5189)] = 189794,
  [SMALL_STATE(5190)] = 189813,
  [SMALL_STATE(5191)] = 189828,
  [SMALL_STATE(5192)] = 189847,
  [SMALL_STATE(5193)] = 189862,
  [SMALL_STATE(5194)] = 189881,
  [SMALL_STATE(5195)] = 189896,
  [SMALL_STATE(5196)] = 189911,
  [SMALL_STATE(5197)] = 189930,
  [SMALL_STATE(5198)] = 189945,
  [SMALL_STATE(5199)] = 189960,
  [SMALL_STATE(5200)] = 189975,
  [SMALL_STATE(5201)] = 189990,
  [SMALL_STATE(5202)] = 190005,
  [SMALL_STATE(5203)] = 190020,
  [SMALL_STATE(5204)] = 190039,
  [SMALL_STATE(5205)] = 190054,
  [SMALL_STATE(5206)] = 190069,
  [SMALL_STATE(5207)] = 190084,
  [SMALL_STATE(5208)] = 190101,
  [SMALL_STATE(5209)] = 190116,
  [SMALL_STATE(5210)] = 190131,
  [SMALL_STATE(5211)] = 190146,
  [SMALL_STATE(5212)] = 190161,
  [SMALL_STATE(5213)] = 190180,
  [SMALL_STATE(5214)] = 190199,
  [SMALL_STATE(5215)] = 190214,
  [SMALL_STATE(5216)] = 190233,
  [SMALL_STATE(5217)] = 190248,
  [SMALL_STATE(5218)] = 190263,
  [SMALL_STATE(5219)] = 190278,
  [SMALL_STATE(5220)] = 190293,
  [SMALL_STATE(5221)] = 190312,
  [SMALL_STATE(5222)] = 190327,
  [SMALL_STATE(5223)] = 190342,
  [SMALL_STATE(5224)] = 190357,
  [SMALL_STATE(5225)] = 190374,
  [SMALL_STATE(5226)] = 190389,
  [SMALL_STATE(5227)] = 190404,
  [SMALL_STATE(5228)] = 190423,
  [SMALL_STATE(5229)] = 190438,
  [SMALL_STATE(5230)] = 190453,
  [SMALL_STATE(5231)] = 190468,
  [SMALL_STATE(5232)] = 190487,
  [SMALL_STATE(5233)] = 190502,
  [SMALL_STATE(5234)] = 190517,
  [SMALL_STATE(5235)] = 190532,
  [SMALL_STATE(5236)] = 190547,
  [SMALL_STATE(5237)] = 190562,
  [SMALL_STATE(5238)] = 190577,
  [SMALL_STATE(5239)] = 190592,
  [SMALL_STATE(5240)] = 190607,
  [SMALL_STATE(5241)] = 190622,
  [SMALL_STATE(5242)] = 190637,
  [SMALL_STATE(5243)] = 190652,
  [SMALL_STATE(5244)] = 190667,
  [SMALL_STATE(5245)] = 190682,
  [SMALL_STATE(5246)] = 190697,
  [SMALL_STATE(5247)] = 190714,
  [SMALL_STATE(5248)] = 190729,
  [SMALL_STATE(5249)] = 190748,
  [SMALL_STATE(5250)] = 190763,
  [SMALL_STATE(5251)] = 190780,
  [SMALL_STATE(5252)] = 190799,
  [SMALL_STATE(5253)] = 190814,
  [SMALL_STATE(5254)] = 190829,
  [SMALL_STATE(5255)] = 190844,
  [SMALL_STATE(5256)] = 190859,
  [SMALL_STATE(5257)] = 190874,
  [SMALL_STATE(5258)] = 190889,
  [SMALL_STATE(5259)] = 190908,
  [SMALL_STATE(5260)] = 190927,
  [SMALL_STATE(5261)] = 190942,
  [SMALL_STATE(5262)] = 190961,
  [SMALL_STATE(5263)] = 190976,
  [SMALL_STATE(5264)] = 190993,
  [SMALL_STATE(5265)] = 191010,
  [SMALL_STATE(5266)] = 191027,
  [SMALL_STATE(5267)] = 191046,
  [SMALL_STATE(5268)] = 191065,
  [SMALL_STATE(5269)] = 191080,
  [SMALL_STATE(5270)] = 191099,
  [SMALL_STATE(5271)] = 191118,
  [SMALL_STATE(5272)] = 191133,
  [SMALL_STATE(5273)] = 191148,
  [SMALL_STATE(5274)] = 191163,
  [SMALL_STATE(5275)] = 191178,
  [SMALL_STATE(5276)] = 191193,
  [SMALL_STATE(5277)] = 191208,
  [SMALL_STATE(5278)] = 191223,
  [SMALL_STATE(5279)] = 191238,
  [SMALL_STATE(5280)] = 191253,
  [SMALL_STATE(5281)] = 191268,
  [SMALL_STATE(5282)] = 191283,
  [SMALL_STATE(5283)] = 191298,
  [SMALL_STATE(5284)] = 191313,
  [SMALL_STATE(5285)] = 191332,
  [SMALL_STATE(5286)] = 191347,
  [SMALL_STATE(5287)] = 191362,
  [SMALL_STATE(5288)] = 191379,
  [SMALL_STATE(5289)] = 191394,
  [SMALL_STATE(5290)] = 191413,
  [SMALL_STATE(5291)] = 191428,
  [SMALL_STATE(5292)] = 191445,
  [SMALL_STATE(5293)] = 191460,
  [SMALL_STATE(5294)] = 191477,
  [SMALL_STATE(5295)] = 191496,
  [SMALL_STATE(5296)] = 191511,
  [SMALL_STATE(5297)] = 191526,
  [SMALL_STATE(5298)] = 191541,
  [SMALL_STATE(5299)] = 191556,
  [SMALL_STATE(5300)] = 191571,
  [SMALL_STATE(5301)] = 191586,
  [SMALL_STATE(5302)] = 191601,
  [SMALL_STATE(5303)] = 191616,
  [SMALL_STATE(5304)] = 191631,
  [SMALL_STATE(5305)] = 191650,
  [SMALL_STATE(5306)] = 191665,
  [SMALL_STATE(5307)] = 191680,
  [SMALL_STATE(5308)] = 191699,
  [SMALL_STATE(5309)] = 191714,
  [SMALL_STATE(5310)] = 191729,
  [SMALL_STATE(5311)] = 191744,
  [SMALL_STATE(5312)] = 191759,
  [SMALL_STATE(5313)] = 191774,
  [SMALL_STATE(5314)] = 191793,
  [SMALL_STATE(5315)] = 191808,
  [SMALL_STATE(5316)] = 191827,
  [SMALL_STATE(5317)] = 191842,
  [SMALL_STATE(5318)] = 191857,
  [SMALL_STATE(5319)] = 191876,
  [SMALL_STATE(5320)] = 191895,
  [SMALL_STATE(5321)] = 191914,
  [SMALL_STATE(5322)] = 191929,
  [SMALL_STATE(5323)] = 191948,
  [SMALL_STATE(5324)] = 191963,
  [SMALL_STATE(5325)] = 191982,
  [SMALL_STATE(5326)] = 191997,
  [SMALL_STATE(5327)] = 192012,
  [SMALL_STATE(5328)] = 192027,
  [SMALL_STATE(5329)] = 192046,
  [SMALL_STATE(5330)] = 192065,
  [SMALL_STATE(5331)] = 192080,
  [SMALL_STATE(5332)] = 192095,
  [SMALL_STATE(5333)] = 192110,
  [SMALL_STATE(5334)] = 192129,
  [SMALL_STATE(5335)] = 192144,
  [SMALL_STATE(5336)] = 192163,
  [SMALL_STATE(5337)] = 192178,
  [SMALL_STATE(5338)] = 192193,
  [SMALL_STATE(5339)] = 192208,
  [SMALL_STATE(5340)] = 192223,
  [SMALL_STATE(5341)] = 192238,
  [SMALL_STATE(5342)] = 192253,
  [SMALL_STATE(5343)] = 192268,
  [SMALL_STATE(5344)] = 192283,
  [SMALL_STATE(5345)] = 192298,
  [SMALL_STATE(5346)] = 192313,
  [SMALL_STATE(5347)] = 192328,
  [SMALL_STATE(5348)] = 192343,
  [SMALL_STATE(5349)] = 192358,
  [SMALL_STATE(5350)] = 192377,
  [SMALL_STATE(5351)] = 192392,
  [SMALL_STATE(5352)] = 192411,
  [SMALL_STATE(5353)] = 192426,
  [SMALL_STATE(5354)] = 192445,
  [SMALL_STATE(5355)] = 192464,
  [SMALL_STATE(5356)] = 192483,
  [SMALL_STATE(5357)] = 192498,
  [SMALL_STATE(5358)] = 192513,
  [SMALL_STATE(5359)] = 192532,
  [SMALL_STATE(5360)] = 192547,
  [SMALL_STATE(5361)] = 192562,
  [SMALL_STATE(5362)] = 192581,
  [SMALL_STATE(5363)] = 192600,
  [SMALL_STATE(5364)] = 192615,
  [SMALL_STATE(5365)] = 192630,
  [SMALL_STATE(5366)] = 192645,
  [SMALL_STATE(5367)] = 192660,
  [SMALL_STATE(5368)] = 192679,
  [SMALL_STATE(5369)] = 192694,
  [SMALL_STATE(5370)] = 192709,
  [SMALL_STATE(5371)] = 192724,
  [SMALL_STATE(5372)] = 192739,
  [SMALL_STATE(5373)] = 192754,
  [SMALL_STATE(5374)] = 192771,
  [SMALL_STATE(5375)] = 192788,
  [SMALL_STATE(5376)] = 192807,
  [SMALL_STATE(5377)] = 192822,
  [SMALL_STATE(5378)] = 192839,
  [SMALL_STATE(5379)] = 192854,
  [SMALL_STATE(5380)] = 192869,
  [SMALL_STATE(5381)] = 192884,
  [SMALL_STATE(5382)] = 192901,
  [SMALL_STATE(5383)] = 192918,
  [SMALL_STATE(5384)] = 192937,
  [SMALL_STATE(5385)] = 192952,
  [SMALL_STATE(5386)] = 192969,
  [SMALL_STATE(5387)] = 192986,
  [SMALL_STATE(5388)] = 193005,
  [SMALL_STATE(5389)] = 193024,
  [SMALL_STATE(5390)] = 193043,
  [SMALL_STATE(5391)] = 193060,
  [SMALL_STATE(5392)] = 193075,
  [SMALL_STATE(5393)] = 193090,
  [SMALL_STATE(5394)] = 193105,
  [SMALL_STATE(5395)] = 193120,
  [SMALL_STATE(5396)] = 193139,
  [SMALL_STATE(5397)] = 193154,
  [SMALL_STATE(5398)] = 193169,
  [SMALL_STATE(5399)] = 193184,
  [SMALL_STATE(5400)] = 193199,
  [SMALL_STATE(5401)] = 193214,
  [SMALL_STATE(5402)] = 193229,
  [SMALL_STATE(5403)] = 193248,
  [SMALL_STATE(5404)] = 193263,
  [SMALL_STATE(5405)] = 193278,
  [SMALL_STATE(5406)] = 193293,
  [SMALL_STATE(5407)] = 193312,
  [SMALL_STATE(5408)] = 193329,
  [SMALL_STATE(5409)] = 193348,
  [SMALL_STATE(5410)] = 193367,
  [SMALL_STATE(5411)] = 193384,
  [SMALL_STATE(5412)] = 193399,
  [SMALL_STATE(5413)] = 193414,
  [SMALL_STATE(5414)] = 193433,
  [SMALL_STATE(5415)] = 193452,
  [SMALL_STATE(5416)] = 193467,
  [SMALL_STATE(5417)] = 193482,
  [SMALL_STATE(5418)] = 193497,
  [SMALL_STATE(5419)] = 193512,
  [SMALL_STATE(5420)] = 193531,
  [SMALL_STATE(5421)] = 193546,
  [SMALL_STATE(5422)] = 193565,
  [SMALL_STATE(5423)] = 193580,
  [SMALL_STATE(5424)] = 193599,
  [SMALL_STATE(5425)] = 193614,
  [SMALL_STATE(5426)] = 193633,
  [SMALL_STATE(5427)] = 193648,
  [SMALL_STATE(5428)] = 193663,
  [SMALL_STATE(5429)] = 193678,
  [SMALL_STATE(5430)] = 193693,
  [SMALL_STATE(5431)] = 193708,
  [SMALL_STATE(5432)] = 193723,
  [SMALL_STATE(5433)] = 193738,
  [SMALL_STATE(5434)] = 193753,
  [SMALL_STATE(5435)] = 193768,
  [SMALL_STATE(5436)] = 193783,
  [SMALL_STATE(5437)] = 193798,
  [SMALL_STATE(5438)] = 193813,
  [SMALL_STATE(5439)] = 193828,
  [SMALL_STATE(5440)] = 193843,
  [SMALL_STATE(5441)] = 193858,
  [SMALL_STATE(5442)] = 193877,
  [SMALL_STATE(5443)] = 193892,
  [SMALL_STATE(5444)] = 193907,
  [SMALL_STATE(5445)] = 193922,
  [SMALL_STATE(5446)] = 193939,
  [SMALL_STATE(5447)] = 193954,
  [SMALL_STATE(5448)] = 193969,
  [SMALL_STATE(5449)] = 193984,
  [SMALL_STATE(5450)] = 193999,
  [SMALL_STATE(5451)] = 194018,
  [SMALL_STATE(5452)] = 194033,
  [SMALL_STATE(5453)] = 194048,
  [SMALL_STATE(5454)] = 194063,
  [SMALL_STATE(5455)] = 194078,
  [SMALL_STATE(5456)] = 194095,
  [SMALL_STATE(5457)] = 194110,
  [SMALL_STATE(5458)] = 194129,
  [SMALL_STATE(5459)] = 194146,
  [SMALL_STATE(5460)] = 194161,
  [SMALL_STATE(5461)] = 194178,
  [SMALL_STATE(5462)] = 194195,
  [SMALL_STATE(5463)] = 194210,
  [SMALL_STATE(5464)] = 194229,
  [SMALL_STATE(5465)] = 194244,
  [SMALL_STATE(5466)] = 194259,
  [SMALL_STATE(5467)] = 194274,
  [SMALL_STATE(5468)] = 194289,
  [SMALL_STATE(5469)] = 194304,
  [SMALL_STATE(5470)] = 194319,
  [SMALL_STATE(5471)] = 194338,
  [SMALL_STATE(5472)] = 194353,
  [SMALL_STATE(5473)] = 194370,
  [SMALL_STATE(5474)] = 194385,
  [SMALL_STATE(5475)] = 194402,
  [SMALL_STATE(5476)] = 194419,
  [SMALL_STATE(5477)] = 194434,
  [SMALL_STATE(5478)] = 194449,
  [SMALL_STATE(5479)] = 194464,
  [SMALL_STATE(5480)] = 194479,
  [SMALL_STATE(5481)] = 194494,
  [SMALL_STATE(5482)] = 194513,
  [SMALL_STATE(5483)] = 194528,
  [SMALL_STATE(5484)] = 194543,
  [SMALL_STATE(5485)] = 194558,
  [SMALL_STATE(5486)] = 194575,
  [SMALL_STATE(5487)] = 194590,
  [SMALL_STATE(5488)] = 194609,
  [SMALL_STATE(5489)] = 194628,
  [SMALL_STATE(5490)] = 194643,
  [SMALL_STATE(5491)] = 194662,
  [SMALL_STATE(5492)] = 194681,
  [SMALL_STATE(5493)] = 194700,
  [SMALL_STATE(5494)] = 194715,
  [SMALL_STATE(5495)] = 194734,
  [SMALL_STATE(5496)] = 194749,
  [SMALL_STATE(5497)] = 194768,
  [SMALL_STATE(5498)] = 194783,
  [SMALL_STATE(5499)] = 194798,
  [SMALL_STATE(5500)] = 194817,
  [SMALL_STATE(5501)] = 194836,
  [SMALL_STATE(5502)] = 194851,
  [SMALL_STATE(5503)] = 194866,
  [SMALL_STATE(5504)] = 194881,
  [SMALL_STATE(5505)] = 194896,
  [SMALL_STATE(5506)] = 194915,
  [SMALL_STATE(5507)] = 194930,
  [SMALL_STATE(5508)] = 194949,
  [SMALL_STATE(5509)] = 194968,
  [SMALL_STATE(5510)] = 194987,
  [SMALL_STATE(5511)] = 195003,
  [SMALL_STATE(5512)] = 195017,
  [SMALL_STATE(5513)] = 195033,
  [SMALL_STATE(5514)] = 195049,
  [SMALL_STATE(5515)] = 195065,
  [SMALL_STATE(5516)] = 195081,
  [SMALL_STATE(5517)] = 195095,
  [SMALL_STATE(5518)] = 195111,
  [SMALL_STATE(5519)] = 195127,
  [SMALL_STATE(5520)] = 195143,
  [SMALL_STATE(5521)] = 195157,
  [SMALL_STATE(5522)] = 195173,
  [SMALL_STATE(5523)] = 195189,
  [SMALL_STATE(5524)] = 195205,
  [SMALL_STATE(5525)] = 195219,
  [SMALL_STATE(5526)] = 195233,
  [SMALL_STATE(5527)] = 195249,
  [SMALL_STATE(5528)] = 195263,
  [SMALL_STATE(5529)] = 195279,
  [SMALL_STATE(5530)] = 195295,
  [SMALL_STATE(5531)] = 195311,
  [SMALL_STATE(5532)] = 195325,
  [SMALL_STATE(5533)] = 195341,
  [SMALL_STATE(5534)] = 195355,
  [SMALL_STATE(5535)] = 195371,
  [SMALL_STATE(5536)] = 195387,
  [SMALL_STATE(5537)] = 195403,
  [SMALL_STATE(5538)] = 195417,
  [SMALL_STATE(5539)] = 195433,
  [SMALL_STATE(5540)] = 195447,
  [SMALL_STATE(5541)] = 195461,
  [SMALL_STATE(5542)] = 195477,
  [SMALL_STATE(5543)] = 195493,
  [SMALL_STATE(5544)] = 195509,
  [SMALL_STATE(5545)] = 195525,
  [SMALL_STATE(5546)] = 195539,
  [SMALL_STATE(5547)] = 195555,
  [SMALL_STATE(5548)] = 195571,
  [SMALL_STATE(5549)] = 195585,
  [SMALL_STATE(5550)] = 195601,
  [SMALL_STATE(5551)] = 195617,
  [SMALL_STATE(5552)] = 195631,
  [SMALL_STATE(5553)] = 195645,
  [SMALL_STATE(5554)] = 195659,
  [SMALL_STATE(5555)] = 195673,
  [SMALL_STATE(5556)] = 195689,
  [SMALL_STATE(5557)] = 195705,
  [SMALL_STATE(5558)] = 195721,
  [SMALL_STATE(5559)] = 195735,
  [SMALL_STATE(5560)] = 195751,
  [SMALL_STATE(5561)] = 195767,
  [SMALL_STATE(5562)] = 195783,
  [SMALL_STATE(5563)] = 195797,
  [SMALL_STATE(5564)] = 195813,
  [SMALL_STATE(5565)] = 195829,
  [SMALL_STATE(5566)] = 195845,
  [SMALL_STATE(5567)] = 195859,
  [SMALL_STATE(5568)] = 195873,
  [SMALL_STATE(5569)] = 195887,
  [SMALL_STATE(5570)] = 195901,
  [SMALL_STATE(5571)] = 195917,
  [SMALL_STATE(5572)] = 195933,
  [SMALL_STATE(5573)] = 195949,
  [SMALL_STATE(5574)] = 195965,
  [SMALL_STATE(5575)] = 195981,
  [SMALL_STATE(5576)] = 195995,
  [SMALL_STATE(5577)] = 196011,
  [SMALL_STATE(5578)] = 196027,
  [SMALL_STATE(5579)] = 196043,
  [SMALL_STATE(5580)] = 196059,
  [SMALL_STATE(5581)] = 196075,
  [SMALL_STATE(5582)] = 196091,
  [SMALL_STATE(5583)] = 196107,
  [SMALL_STATE(5584)] = 196123,
  [SMALL_STATE(5585)] = 196137,
  [SMALL_STATE(5586)] = 196153,
  [SMALL_STATE(5587)] = 196169,
  [SMALL_STATE(5588)] = 196185,
  [SMALL_STATE(5589)] = 196201,
  [SMALL_STATE(5590)] = 196217,
  [SMALL_STATE(5591)] = 196231,
  [SMALL_STATE(5592)] = 196247,
  [SMALL_STATE(5593)] = 196263,
  [SMALL_STATE(5594)] = 196279,
  [SMALL_STATE(5595)] = 196295,
  [SMALL_STATE(5596)] = 196311,
  [SMALL_STATE(5597)] = 196327,
  [SMALL_STATE(5598)] = 196343,
  [SMALL_STATE(5599)] = 196359,
  [SMALL_STATE(5600)] = 196375,
  [SMALL_STATE(5601)] = 196391,
  [SMALL_STATE(5602)] = 196407,
  [SMALL_STATE(5603)] = 196421,
  [SMALL_STATE(5604)] = 196435,
  [SMALL_STATE(5605)] = 196449,
  [SMALL_STATE(5606)] = 196465,
  [SMALL_STATE(5607)] = 196481,
  [SMALL_STATE(5608)] = 196495,
  [SMALL_STATE(5609)] = 196511,
  [SMALL_STATE(5610)] = 196527,
  [SMALL_STATE(5611)] = 196541,
  [SMALL_STATE(5612)] = 196555,
  [SMALL_STATE(5613)] = 196569,
  [SMALL_STATE(5614)] = 196583,
  [SMALL_STATE(5615)] = 196597,
  [SMALL_STATE(5616)] = 196613,
  [SMALL_STATE(5617)] = 196627,
  [SMALL_STATE(5618)] = 196643,
  [SMALL_STATE(5619)] = 196659,
  [SMALL_STATE(5620)] = 196675,
  [SMALL_STATE(5621)] = 196691,
  [SMALL_STATE(5622)] = 196707,
  [SMALL_STATE(5623)] = 196723,
  [SMALL_STATE(5624)] = 196739,
  [SMALL_STATE(5625)] = 196755,
  [SMALL_STATE(5626)] = 196771,
  [SMALL_STATE(5627)] = 196787,
  [SMALL_STATE(5628)] = 196801,
  [SMALL_STATE(5629)] = 196817,
  [SMALL_STATE(5630)] = 196831,
  [SMALL_STATE(5631)] = 196845,
  [SMALL_STATE(5632)] = 196861,
  [SMALL_STATE(5633)] = 196877,
  [SMALL_STATE(5634)] = 196893,
  [SMALL_STATE(5635)] = 196907,
  [SMALL_STATE(5636)] = 196923,
  [SMALL_STATE(5637)] = 196939,
  [SMALL_STATE(5638)] = 196955,
  [SMALL_STATE(5639)] = 196971,
  [SMALL_STATE(5640)] = 196987,
  [SMALL_STATE(5641)] = 197003,
  [SMALL_STATE(5642)] = 197019,
  [SMALL_STATE(5643)] = 197033,
  [SMALL_STATE(5644)] = 197049,
  [SMALL_STATE(5645)] = 197063,
  [SMALL_STATE(5646)] = 197077,
  [SMALL_STATE(5647)] = 197091,
  [SMALL_STATE(5648)] = 197107,
  [SMALL_STATE(5649)] = 197121,
  [SMALL_STATE(5650)] = 197137,
  [SMALL_STATE(5651)] = 197153,
  [SMALL_STATE(5652)] = 197169,
  [SMALL_STATE(5653)] = 197185,
  [SMALL_STATE(5654)] = 197201,
  [SMALL_STATE(5655)] = 197217,
  [SMALL_STATE(5656)] = 197233,
  [SMALL_STATE(5657)] = 197249,
  [SMALL_STATE(5658)] = 197265,
  [SMALL_STATE(5659)] = 197279,
  [SMALL_STATE(5660)] = 197295,
  [SMALL_STATE(5661)] = 197311,
  [SMALL_STATE(5662)] = 197327,
  [SMALL_STATE(5663)] = 197343,
  [SMALL_STATE(5664)] = 197359,
  [SMALL_STATE(5665)] = 197375,
  [SMALL_STATE(5666)] = 197391,
  [SMALL_STATE(5667)] = 197407,
  [SMALL_STATE(5668)] = 197423,
  [SMALL_STATE(5669)] = 197439,
  [SMALL_STATE(5670)] = 197455,
  [SMALL_STATE(5671)] = 197471,
  [SMALL_STATE(5672)] = 197487,
  [SMALL_STATE(5673)] = 197503,
  [SMALL_STATE(5674)] = 197519,
  [SMALL_STATE(5675)] = 197535,
  [SMALL_STATE(5676)] = 197551,
  [SMALL_STATE(5677)] = 197567,
  [SMALL_STATE(5678)] = 197583,
  [SMALL_STATE(5679)] = 197599,
  [SMALL_STATE(5680)] = 197615,
  [SMALL_STATE(5681)] = 197629,
  [SMALL_STATE(5682)] = 197645,
  [SMALL_STATE(5683)] = 197661,
  [SMALL_STATE(5684)] = 197677,
  [SMALL_STATE(5685)] = 197693,
  [SMALL_STATE(5686)] = 197709,
  [SMALL_STATE(5687)] = 197723,
  [SMALL_STATE(5688)] = 197737,
  [SMALL_STATE(5689)] = 197751,
  [SMALL_STATE(5690)] = 197767,
  [SMALL_STATE(5691)] = 197783,
  [SMALL_STATE(5692)] = 197799,
  [SMALL_STATE(5693)] = 197815,
  [SMALL_STATE(5694)] = 197831,
  [SMALL_STATE(5695)] = 197845,
  [SMALL_STATE(5696)] = 197859,
  [SMALL_STATE(5697)] = 197873,
  [SMALL_STATE(5698)] = 197887,
  [SMALL_STATE(5699)] = 197903,
  [SMALL_STATE(5700)] = 197919,
  [SMALL_STATE(5701)] = 197933,
  [SMALL_STATE(5702)] = 197949,
  [SMALL_STATE(5703)] = 197963,
  [SMALL_STATE(5704)] = 197977,
  [SMALL_STATE(5705)] = 197991,
  [SMALL_STATE(5706)] = 198007,
  [SMALL_STATE(5707)] = 198023,
  [SMALL_STATE(5708)] = 198039,
  [SMALL_STATE(5709)] = 198055,
  [SMALL_STATE(5710)] = 198071,
  [SMALL_STATE(5711)] = 198087,
  [SMALL_STATE(5712)] = 198103,
  [SMALL_STATE(5713)] = 198119,
  [SMALL_STATE(5714)] = 198135,
  [SMALL_STATE(5715)] = 198151,
  [SMALL_STATE(5716)] = 198165,
  [SMALL_STATE(5717)] = 198181,
  [SMALL_STATE(5718)] = 198195,
  [SMALL_STATE(5719)] = 198211,
  [SMALL_STATE(5720)] = 198227,
  [SMALL_STATE(5721)] = 198243,
  [SMALL_STATE(5722)] = 198259,
  [SMALL_STATE(5723)] = 198275,
  [SMALL_STATE(5724)] = 198289,
  [SMALL_STATE(5725)] = 198305,
  [SMALL_STATE(5726)] = 198321,
  [SMALL_STATE(5727)] = 198337,
  [SMALL_STATE(5728)] = 198353,
  [SMALL_STATE(5729)] = 198367,
  [SMALL_STATE(5730)] = 198381,
  [SMALL_STATE(5731)] = 198397,
  [SMALL_STATE(5732)] = 198413,
  [SMALL_STATE(5733)] = 198429,
  [SMALL_STATE(5734)] = 198445,
  [SMALL_STATE(5735)] = 198461,
  [SMALL_STATE(5736)] = 198477,
  [SMALL_STATE(5737)] = 198493,
  [SMALL_STATE(5738)] = 198507,
  [SMALL_STATE(5739)] = 198521,
  [SMALL_STATE(5740)] = 198537,
  [SMALL_STATE(5741)] = 198553,
  [SMALL_STATE(5742)] = 198569,
  [SMALL_STATE(5743)] = 198585,
  [SMALL_STATE(5744)] = 198599,
  [SMALL_STATE(5745)] = 198613,
  [SMALL_STATE(5746)] = 198629,
  [SMALL_STATE(5747)] = 198645,
  [SMALL_STATE(5748)] = 198661,
  [SMALL_STATE(5749)] = 198675,
  [SMALL_STATE(5750)] = 198691,
  [SMALL_STATE(5751)] = 198705,
  [SMALL_STATE(5752)] = 198721,
  [SMALL_STATE(5753)] = 198737,
  [SMALL_STATE(5754)] = 198753,
  [SMALL_STATE(5755)] = 198769,
  [SMALL_STATE(5756)] = 198785,
  [SMALL_STATE(5757)] = 198801,
  [SMALL_STATE(5758)] = 198817,
  [SMALL_STATE(5759)] = 198833,
  [SMALL_STATE(5760)] = 198849,
  [SMALL_STATE(5761)] = 198865,
  [SMALL_STATE(5762)] = 198881,
  [SMALL_STATE(5763)] = 198897,
  [SMALL_STATE(5764)] = 198911,
  [SMALL_STATE(5765)] = 198925,
  [SMALL_STATE(5766)] = 198941,
  [SMALL_STATE(5767)] = 198957,
  [SMALL_STATE(5768)] = 198971,
  [SMALL_STATE(5769)] = 198987,
  [SMALL_STATE(5770)] = 199003,
  [SMALL_STATE(5771)] = 199019,
  [SMALL_STATE(5772)] = 199033,
  [SMALL_STATE(5773)] = 199047,
  [SMALL_STATE(5774)] = 199063,
  [SMALL_STATE(5775)] = 199077,
  [SMALL_STATE(5776)] = 199093,
  [SMALL_STATE(5777)] = 199109,
  [SMALL_STATE(5778)] = 199125,
  [SMALL_STATE(5779)] = 199141,
  [SMALL_STATE(5780)] = 199157,
  [SMALL_STATE(5781)] = 199173,
  [SMALL_STATE(5782)] = 199189,
  [SMALL_STATE(5783)] = 199205,
  [SMALL_STATE(5784)] = 199221,
  [SMALL_STATE(5785)] = 199235,
  [SMALL_STATE(5786)] = 199251,
  [SMALL_STATE(5787)] = 199267,
  [SMALL_STATE(5788)] = 199283,
  [SMALL_STATE(5789)] = 199299,
  [SMALL_STATE(5790)] = 199315,
  [SMALL_STATE(5791)] = 199331,
  [SMALL_STATE(5792)] = 199345,
  [SMALL_STATE(5793)] = 199361,
  [SMALL_STATE(5794)] = 199377,
  [SMALL_STATE(5795)] = 199393,
  [SMALL_STATE(5796)] = 199407,
  [SMALL_STATE(5797)] = 199421,
  [SMALL_STATE(5798)] = 199437,
  [SMALL_STATE(5799)] = 199453,
  [SMALL_STATE(5800)] = 199469,
  [SMALL_STATE(5801)] = 199485,
  [SMALL_STATE(5802)] = 199501,
  [SMALL_STATE(5803)] = 199517,
  [SMALL_STATE(5804)] = 199533,
  [SMALL_STATE(5805)] = 199549,
  [SMALL_STATE(5806)] = 199563,
  [SMALL_STATE(5807)] = 199579,
  [SMALL_STATE(5808)] = 199595,
  [SMALL_STATE(5809)] = 199611,
  [SMALL_STATE(5810)] = 199625,
  [SMALL_STATE(5811)] = 199641,
  [SMALL_STATE(5812)] = 199657,
  [SMALL_STATE(5813)] = 199673,
  [SMALL_STATE(5814)] = 199687,
  [SMALL_STATE(5815)] = 199701,
  [SMALL_STATE(5816)] = 199715,
  [SMALL_STATE(5817)] = 199731,
  [SMALL_STATE(5818)] = 199747,
  [SMALL_STATE(5819)] = 199763,
  [SMALL_STATE(5820)] = 199779,
  [SMALL_STATE(5821)] = 199795,
  [SMALL_STATE(5822)] = 199811,
  [SMALL_STATE(5823)] = 199827,
  [SMALL_STATE(5824)] = 199841,
  [SMALL_STATE(5825)] = 199855,
  [SMALL_STATE(5826)] = 199871,
  [SMALL_STATE(5827)] = 199887,
  [SMALL_STATE(5828)] = 199903,
  [SMALL_STATE(5829)] = 199919,
  [SMALL_STATE(5830)] = 199935,
  [SMALL_STATE(5831)] = 199949,
  [SMALL_STATE(5832)] = 199963,
  [SMALL_STATE(5833)] = 199977,
  [SMALL_STATE(5834)] = 199991,
  [SMALL_STATE(5835)] = 200005,
  [SMALL_STATE(5836)] = 200021,
  [SMALL_STATE(5837)] = 200037,
  [SMALL_STATE(5838)] = 200053,
  [SMALL_STATE(5839)] = 200069,
  [SMALL_STATE(5840)] = 200085,
  [SMALL_STATE(5841)] = 200101,
  [SMALL_STATE(5842)] = 200117,
  [SMALL_STATE(5843)] = 200131,
  [SMALL_STATE(5844)] = 200147,
  [SMALL_STATE(5845)] = 200163,
  [SMALL_STATE(5846)] = 200179,
  [SMALL_STATE(5847)] = 200195,
  [SMALL_STATE(5848)] = 200211,
  [SMALL_STATE(5849)] = 200227,
  [SMALL_STATE(5850)] = 200243,
  [SMALL_STATE(5851)] = 200259,
  [SMALL_STATE(5852)] = 200275,
  [SMALL_STATE(5853)] = 200291,
  [SMALL_STATE(5854)] = 200305,
  [SMALL_STATE(5855)] = 200321,
  [SMALL_STATE(5856)] = 200337,
  [SMALL_STATE(5857)] = 200353,
  [SMALL_STATE(5858)] = 200369,
  [SMALL_STATE(5859)] = 200385,
  [SMALL_STATE(5860)] = 200401,
  [SMALL_STATE(5861)] = 200417,
  [SMALL_STATE(5862)] = 200433,
  [SMALL_STATE(5863)] = 200447,
  [SMALL_STATE(5864)] = 200463,
  [SMALL_STATE(5865)] = 200479,
  [SMALL_STATE(5866)] = 200493,
  [SMALL_STATE(5867)] = 200509,
  [SMALL_STATE(5868)] = 200525,
  [SMALL_STATE(5869)] = 200539,
  [SMALL_STATE(5870)] = 200553,
  [SMALL_STATE(5871)] = 200567,
  [SMALL_STATE(5872)] = 200581,
  [SMALL_STATE(5873)] = 200597,
  [SMALL_STATE(5874)] = 200613,
  [SMALL_STATE(5875)] = 200629,
  [SMALL_STATE(5876)] = 200645,
  [SMALL_STATE(5877)] = 200659,
  [SMALL_STATE(5878)] = 200673,
  [SMALL_STATE(5879)] = 200687,
  [SMALL_STATE(5880)] = 200701,
  [SMALL_STATE(5881)] = 200715,
  [SMALL_STATE(5882)] = 200729,
  [SMALL_STATE(5883)] = 200743,
  [SMALL_STATE(5884)] = 200757,
  [SMALL_STATE(5885)] = 200771,
  [SMALL_STATE(5886)] = 200785,
  [SMALL_STATE(5887)] = 200799,
  [SMALL_STATE(5888)] = 200813,
  [SMALL_STATE(5889)] = 200827,
  [SMALL_STATE(5890)] = 200841,
  [SMALL_STATE(5891)] = 200855,
  [SMALL_STATE(5892)] = 200869,
  [SMALL_STATE(5893)] = 200883,
  [SMALL_STATE(5894)] = 200897,
  [SMALL_STATE(5895)] = 200913,
  [SMALL_STATE(5896)] = 200929,
  [SMALL_STATE(5897)] = 200943,
  [SMALL_STATE(5898)] = 200959,
  [SMALL_STATE(5899)] = 200973,
  [SMALL_STATE(5900)] = 200989,
  [SMALL_STATE(5901)] = 201005,
  [SMALL_STATE(5902)] = 201021,
  [SMALL_STATE(5903)] = 201037,
  [SMALL_STATE(5904)] = 201053,
  [SMALL_STATE(5905)] = 201069,
  [SMALL_STATE(5906)] = 201083,
  [SMALL_STATE(5907)] = 201099,
  [SMALL_STATE(5908)] = 201113,
  [SMALL_STATE(5909)] = 201129,
  [SMALL_STATE(5910)] = 201145,
  [SMALL_STATE(5911)] = 201161,
  [SMALL_STATE(5912)] = 201177,
  [SMALL_STATE(5913)] = 201193,
  [SMALL_STATE(5914)] = 201209,
  [SMALL_STATE(5915)] = 201225,
  [SMALL_STATE(5916)] = 201241,
  [SMALL_STATE(5917)] = 201257,
  [SMALL_STATE(5918)] = 201273,
  [SMALL_STATE(5919)] = 201289,
  [SMALL_STATE(5920)] = 201303,
  [SMALL_STATE(5921)] = 201319,
  [SMALL_STATE(5922)] = 201333,
  [SMALL_STATE(5923)] = 201349,
  [SMALL_STATE(5924)] = 201365,
  [SMALL_STATE(5925)] = 201381,
  [SMALL_STATE(5926)] = 201397,
  [SMALL_STATE(5927)] = 201413,
  [SMALL_STATE(5928)] = 201429,
  [SMALL_STATE(5929)] = 201445,
  [SMALL_STATE(5930)] = 201461,
  [SMALL_STATE(5931)] = 201477,
  [SMALL_STATE(5932)] = 201493,
  [SMALL_STATE(5933)] = 201509,
  [SMALL_STATE(5934)] = 201523,
  [SMALL_STATE(5935)] = 201539,
  [SMALL_STATE(5936)] = 201553,
  [SMALL_STATE(5937)] = 201569,
  [SMALL_STATE(5938)] = 201582,
  [SMALL_STATE(5939)] = 201595,
  [SMALL_STATE(5940)] = 201608,
  [SMALL_STATE(5941)] = 201621,
  [SMALL_STATE(5942)] = 201634,
  [SMALL_STATE(5943)] = 201647,
  [SMALL_STATE(5944)] = 201660,
  [SMALL_STATE(5945)] = 201673,
  [SMALL_STATE(5946)] = 201686,
  [SMALL_STATE(5947)] = 201699,
  [SMALL_STATE(5948)] = 201712,
  [SMALL_STATE(5949)] = 201725,
  [SMALL_STATE(5950)] = 201738,
  [SMALL_STATE(5951)] = 201751,
  [SMALL_STATE(5952)] = 201764,
  [SMALL_STATE(5953)] = 201777,
  [SMALL_STATE(5954)] = 201790,
  [SMALL_STATE(5955)] = 201803,
  [SMALL_STATE(5956)] = 201816,
  [SMALL_STATE(5957)] = 201829,
  [SMALL_STATE(5958)] = 201842,
  [SMALL_STATE(5959)] = 201855,
  [SMALL_STATE(5960)] = 201868,
  [SMALL_STATE(5961)] = 201881,
  [SMALL_STATE(5962)] = 201894,
  [SMALL_STATE(5963)] = 201907,
  [SMALL_STATE(5964)] = 201920,
  [SMALL_STATE(5965)] = 201933,
  [SMALL_STATE(5966)] = 201946,
  [SMALL_STATE(5967)] = 201959,
  [SMALL_STATE(5968)] = 201972,
  [SMALL_STATE(5969)] = 201985,
  [SMALL_STATE(5970)] = 201998,
  [SMALL_STATE(5971)] = 202011,
  [SMALL_STATE(5972)] = 202024,
  [SMALL_STATE(5973)] = 202037,
  [SMALL_STATE(5974)] = 202050,
  [SMALL_STATE(5975)] = 202063,
  [SMALL_STATE(5976)] = 202076,
  [SMALL_STATE(5977)] = 202089,
  [SMALL_STATE(5978)] = 202102,
  [SMALL_STATE(5979)] = 202115,
  [SMALL_STATE(5980)] = 202128,
  [SMALL_STATE(5981)] = 202141,
  [SMALL_STATE(5982)] = 202154,
  [SMALL_STATE(5983)] = 202167,
  [SMALL_STATE(5984)] = 202180,
  [SMALL_STATE(5985)] = 202193,
  [SMALL_STATE(5986)] = 202206,
  [SMALL_STATE(5987)] = 202219,
  [SMALL_STATE(5988)] = 202232,
  [SMALL_STATE(5989)] = 202245,
  [SMALL_STATE(5990)] = 202258,
  [SMALL_STATE(5991)] = 202271,
  [SMALL_STATE(5992)] = 202284,
  [SMALL_STATE(5993)] = 202297,
  [SMALL_STATE(5994)] = 202310,
  [SMALL_STATE(5995)] = 202323,
  [SMALL_STATE(5996)] = 202336,
  [SMALL_STATE(5997)] = 202349,
  [SMALL_STATE(5998)] = 202362,
  [SMALL_STATE(5999)] = 202375,
  [SMALL_STATE(6000)] = 202388,
  [SMALL_STATE(6001)] = 202401,
  [SMALL_STATE(6002)] = 202414,
  [SMALL_STATE(6003)] = 202427,
  [SMALL_STATE(6004)] = 202440,
  [SMALL_STATE(6005)] = 202453,
  [SMALL_STATE(6006)] = 202466,
  [SMALL_STATE(6007)] = 202479,
  [SMALL_STATE(6008)] = 202492,
  [SMALL_STATE(6009)] = 202505,
  [SMALL_STATE(6010)] = 202518,
  [SMALL_STATE(6011)] = 202531,
  [SMALL_STATE(6012)] = 202544,
  [SMALL_STATE(6013)] = 202557,
  [SMALL_STATE(6014)] = 202570,
  [SMALL_STATE(6015)] = 202583,
  [SMALL_STATE(6016)] = 202596,
  [SMALL_STATE(6017)] = 202609,
  [SMALL_STATE(6018)] = 202622,
  [SMALL_STATE(6019)] = 202635,
  [SMALL_STATE(6020)] = 202648,
  [SMALL_STATE(6021)] = 202661,
  [SMALL_STATE(6022)] = 202674,
  [SMALL_STATE(6023)] = 202687,
  [SMALL_STATE(6024)] = 202700,
  [SMALL_STATE(6025)] = 202713,
  [SMALL_STATE(6026)] = 202726,
  [SMALL_STATE(6027)] = 202739,
  [SMALL_STATE(6028)] = 202752,
  [SMALL_STATE(6029)] = 202765,
  [SMALL_STATE(6030)] = 202778,
  [SMALL_STATE(6031)] = 202791,
  [SMALL_STATE(6032)] = 202804,
  [SMALL_STATE(6033)] = 202817,
  [SMALL_STATE(6034)] = 202830,
  [SMALL_STATE(6035)] = 202843,
  [SMALL_STATE(6036)] = 202856,
  [SMALL_STATE(6037)] = 202869,
  [SMALL_STATE(6038)] = 202882,
  [SMALL_STATE(6039)] = 202895,
  [SMALL_STATE(6040)] = 202908,
  [SMALL_STATE(6041)] = 202921,
  [SMALL_STATE(6042)] = 202934,
  [SMALL_STATE(6043)] = 202947,
  [SMALL_STATE(6044)] = 202960,
  [SMALL_STATE(6045)] = 202973,
  [SMALL_STATE(6046)] = 202986,
  [SMALL_STATE(6047)] = 202999,
  [SMALL_STATE(6048)] = 203012,
  [SMALL_STATE(6049)] = 203025,
  [SMALL_STATE(6050)] = 203038,
  [SMALL_STATE(6051)] = 203051,
  [SMALL_STATE(6052)] = 203064,
  [SMALL_STATE(6053)] = 203077,
  [SMALL_STATE(6054)] = 203090,
  [SMALL_STATE(6055)] = 203103,
  [SMALL_STATE(6056)] = 203116,
  [SMALL_STATE(6057)] = 203129,
  [SMALL_STATE(6058)] = 203142,
  [SMALL_STATE(6059)] = 203155,
  [SMALL_STATE(6060)] = 203168,
  [SMALL_STATE(6061)] = 203181,
  [SMALL_STATE(6062)] = 203194,
  [SMALL_STATE(6063)] = 203207,
  [SMALL_STATE(6064)] = 203220,
  [SMALL_STATE(6065)] = 203233,
  [SMALL_STATE(6066)] = 203246,
  [SMALL_STATE(6067)] = 203259,
  [SMALL_STATE(6068)] = 203272,
  [SMALL_STATE(6069)] = 203285,
  [SMALL_STATE(6070)] = 203298,
  [SMALL_STATE(6071)] = 203311,
  [SMALL_STATE(6072)] = 203324,
  [SMALL_STATE(6073)] = 203337,
  [SMALL_STATE(6074)] = 203350,
  [SMALL_STATE(6075)] = 203363,
  [SMALL_STATE(6076)] = 203376,
  [SMALL_STATE(6077)] = 203389,
  [SMALL_STATE(6078)] = 203402,
  [SMALL_STATE(6079)] = 203415,
  [SMALL_STATE(6080)] = 203428,
  [SMALL_STATE(6081)] = 203441,
  [SMALL_STATE(6082)] = 203454,
  [SMALL_STATE(6083)] = 203467,
  [SMALL_STATE(6084)] = 203480,
  [SMALL_STATE(6085)] = 203493,
  [SMALL_STATE(6086)] = 203506,
  [SMALL_STATE(6087)] = 203519,
  [SMALL_STATE(6088)] = 203532,
  [SMALL_STATE(6089)] = 203545,
  [SMALL_STATE(6090)] = 203558,
  [SMALL_STATE(6091)] = 203571,
  [SMALL_STATE(6092)] = 203584,
  [SMALL_STATE(6093)] = 203597,
  [SMALL_STATE(6094)] = 203610,
  [SMALL_STATE(6095)] = 203623,
  [SMALL_STATE(6096)] = 203636,
  [SMALL_STATE(6097)] = 203649,
  [SMALL_STATE(6098)] = 203662,
  [SMALL_STATE(6099)] = 203675,
  [SMALL_STATE(6100)] = 203688,
  [SMALL_STATE(6101)] = 203701,
  [SMALL_STATE(6102)] = 203714,
  [SMALL_STATE(6103)] = 203727,
  [SMALL_STATE(6104)] = 203740,
  [SMALL_STATE(6105)] = 203753,
  [SMALL_STATE(6106)] = 203766,
  [SMALL_STATE(6107)] = 203779,
  [SMALL_STATE(6108)] = 203792,
  [SMALL_STATE(6109)] = 203805,
  [SMALL_STATE(6110)] = 203818,
  [SMALL_STATE(6111)] = 203831,
  [SMALL_STATE(6112)] = 203844,
  [SMALL_STATE(6113)] = 203857,
  [SMALL_STATE(6114)] = 203870,
  [SMALL_STATE(6115)] = 203883,
  [SMALL_STATE(6116)] = 203896,
  [SMALL_STATE(6117)] = 203909,
  [SMALL_STATE(6118)] = 203922,
  [SMALL_STATE(6119)] = 203935,
  [SMALL_STATE(6120)] = 203948,
  [SMALL_STATE(6121)] = 203961,
  [SMALL_STATE(6122)] = 203974,
  [SMALL_STATE(6123)] = 203987,
  [SMALL_STATE(6124)] = 204000,
  [SMALL_STATE(6125)] = 204013,
  [SMALL_STATE(6126)] = 204026,
  [SMALL_STATE(6127)] = 204039,
  [SMALL_STATE(6128)] = 204052,
  [SMALL_STATE(6129)] = 204065,
  [SMALL_STATE(6130)] = 204078,
  [SMALL_STATE(6131)] = 204091,
  [SMALL_STATE(6132)] = 204104,
  [SMALL_STATE(6133)] = 204117,
  [SMALL_STATE(6134)] = 204130,
  [SMALL_STATE(6135)] = 204143,
  [SMALL_STATE(6136)] = 204156,
  [SMALL_STATE(6137)] = 204169,
  [SMALL_STATE(6138)] = 204182,
  [SMALL_STATE(6139)] = 204195,
  [SMALL_STATE(6140)] = 204208,
  [SMALL_STATE(6141)] = 204221,
  [SMALL_STATE(6142)] = 204234,
  [SMALL_STATE(6143)] = 204247,
  [SMALL_STATE(6144)] = 204260,
  [SMALL_STATE(6145)] = 204273,
  [SMALL_STATE(6146)] = 204286,
  [SMALL_STATE(6147)] = 204299,
  [SMALL_STATE(6148)] = 204312,
  [SMALL_STATE(6149)] = 204325,
  [SMALL_STATE(6150)] = 204338,
  [SMALL_STATE(6151)] = 204351,
  [SMALL_STATE(6152)] = 204364,
  [SMALL_STATE(6153)] = 204377,
  [SMALL_STATE(6154)] = 204390,
  [SMALL_STATE(6155)] = 204403,
  [SMALL_STATE(6156)] = 204416,
  [SMALL_STATE(6157)] = 204429,
  [SMALL_STATE(6158)] = 204442,
  [SMALL_STATE(6159)] = 204455,
  [SMALL_STATE(6160)] = 204468,
  [SMALL_STATE(6161)] = 204481,
  [SMALL_STATE(6162)] = 204494,
  [SMALL_STATE(6163)] = 204507,
  [SMALL_STATE(6164)] = 204520,
  [SMALL_STATE(6165)] = 204533,
  [SMALL_STATE(6166)] = 204546,
  [SMALL_STATE(6167)] = 204559,
  [SMALL_STATE(6168)] = 204572,
  [SMALL_STATE(6169)] = 204585,
  [SMALL_STATE(6170)] = 204598,
  [SMALL_STATE(6171)] = 204611,
  [SMALL_STATE(6172)] = 204624,
  [SMALL_STATE(6173)] = 204637,
  [SMALL_STATE(6174)] = 204650,
  [SMALL_STATE(6175)] = 204663,
  [SMALL_STATE(6176)] = 204676,
  [SMALL_STATE(6177)] = 204689,
  [SMALL_STATE(6178)] = 204702,
  [SMALL_STATE(6179)] = 204715,
  [SMALL_STATE(6180)] = 204728,
  [SMALL_STATE(6181)] = 204741,
  [SMALL_STATE(6182)] = 204754,
  [SMALL_STATE(6183)] = 204767,
  [SMALL_STATE(6184)] = 204780,
  [SMALL_STATE(6185)] = 204793,
  [SMALL_STATE(6186)] = 204806,
  [SMALL_STATE(6187)] = 204819,
  [SMALL_STATE(6188)] = 204832,
  [SMALL_STATE(6189)] = 204845,
  [SMALL_STATE(6190)] = 204858,
  [SMALL_STATE(6191)] = 204871,
  [SMALL_STATE(6192)] = 204884,
  [SMALL_STATE(6193)] = 204897,
  [SMALL_STATE(6194)] = 204910,
  [SMALL_STATE(6195)] = 204923,
  [SMALL_STATE(6196)] = 204936,
  [SMALL_STATE(6197)] = 204949,
  [SMALL_STATE(6198)] = 204962,
  [SMALL_STATE(6199)] = 204975,
  [SMALL_STATE(6200)] = 204988,
  [SMALL_STATE(6201)] = 205001,
  [SMALL_STATE(6202)] = 205014,
  [SMALL_STATE(6203)] = 205027,
  [SMALL_STATE(6204)] = 205040,
  [SMALL_STATE(6205)] = 205053,
  [SMALL_STATE(6206)] = 205066,
  [SMALL_STATE(6207)] = 205079,
  [SMALL_STATE(6208)] = 205092,
  [SMALL_STATE(6209)] = 205105,
  [SMALL_STATE(6210)] = 205118,
  [SMALL_STATE(6211)] = 205131,
  [SMALL_STATE(6212)] = 205144,
  [SMALL_STATE(6213)] = 205157,
  [SMALL_STATE(6214)] = 205170,
  [SMALL_STATE(6215)] = 205183,
  [SMALL_STATE(6216)] = 205196,
  [SMALL_STATE(6217)] = 205209,
  [SMALL_STATE(6218)] = 205222,
  [SMALL_STATE(6219)] = 205235,
  [SMALL_STATE(6220)] = 205248,
  [SMALL_STATE(6221)] = 205261,
  [SMALL_STATE(6222)] = 205274,
  [SMALL_STATE(6223)] = 205287,
  [SMALL_STATE(6224)] = 205300,
  [SMALL_STATE(6225)] = 205313,
  [SMALL_STATE(6226)] = 205326,
  [SMALL_STATE(6227)] = 205339,
  [SMALL_STATE(6228)] = 205352,
  [SMALL_STATE(6229)] = 205365,
  [SMALL_STATE(6230)] = 205378,
  [SMALL_STATE(6231)] = 205391,
  [SMALL_STATE(6232)] = 205404,
  [SMALL_STATE(6233)] = 205417,
  [SMALL_STATE(6234)] = 205430,
  [SMALL_STATE(6235)] = 205443,
  [SMALL_STATE(6236)] = 205456,
  [SMALL_STATE(6237)] = 205469,
  [SMALL_STATE(6238)] = 205482,
  [SMALL_STATE(6239)] = 205495,
  [SMALL_STATE(6240)] = 205508,
  [SMALL_STATE(6241)] = 205521,
  [SMALL_STATE(6242)] = 205534,
  [SMALL_STATE(6243)] = 205547,
  [SMALL_STATE(6244)] = 205560,
  [SMALL_STATE(6245)] = 205573,
  [SMALL_STATE(6246)] = 205586,
  [SMALL_STATE(6247)] = 205599,
  [SMALL_STATE(6248)] = 205612,
  [SMALL_STATE(6249)] = 205625,
  [SMALL_STATE(6250)] = 205638,
  [SMALL_STATE(6251)] = 205651,
  [SMALL_STATE(6252)] = 205664,
  [SMALL_STATE(6253)] = 205677,
  [SMALL_STATE(6254)] = 205690,
  [SMALL_STATE(6255)] = 205703,
  [SMALL_STATE(6256)] = 205716,
  [SMALL_STATE(6257)] = 205729,
  [SMALL_STATE(6258)] = 205742,
  [SMALL_STATE(6259)] = 205755,
  [SMALL_STATE(6260)] = 205768,
  [SMALL_STATE(6261)] = 205781,
  [SMALL_STATE(6262)] = 205794,
  [SMALL_STATE(6263)] = 205807,
  [SMALL_STATE(6264)] = 205820,
  [SMALL_STATE(6265)] = 205833,
  [SMALL_STATE(6266)] = 205846,
  [SMALL_STATE(6267)] = 205859,
  [SMALL_STATE(6268)] = 205872,
  [SMALL_STATE(6269)] = 205885,
  [SMALL_STATE(6270)] = 205898,
  [SMALL_STATE(6271)] = 205911,
  [SMALL_STATE(6272)] = 205924,
  [SMALL_STATE(6273)] = 205937,
  [SMALL_STATE(6274)] = 205950,
  [SMALL_STATE(6275)] = 205963,
  [SMALL_STATE(6276)] = 205976,
  [SMALL_STATE(6277)] = 205989,
  [SMALL_STATE(6278)] = 206002,
  [SMALL_STATE(6279)] = 206015,
  [SMALL_STATE(6280)] = 206028,
  [SMALL_STATE(6281)] = 206041,
  [SMALL_STATE(6282)] = 206054,
  [SMALL_STATE(6283)] = 206067,
  [SMALL_STATE(6284)] = 206080,
  [SMALL_STATE(6285)] = 206093,
  [SMALL_STATE(6286)] = 206106,
  [SMALL_STATE(6287)] = 206119,
  [SMALL_STATE(6288)] = 206132,
  [SMALL_STATE(6289)] = 206145,
  [SMALL_STATE(6290)] = 206158,
  [SMALL_STATE(6291)] = 206171,
  [SMALL_STATE(6292)] = 206184,
  [SMALL_STATE(6293)] = 206197,
  [SMALL_STATE(6294)] = 206210,
  [SMALL_STATE(6295)] = 206223,
  [SMALL_STATE(6296)] = 206236,
  [SMALL_STATE(6297)] = 206249,
  [SMALL_STATE(6298)] = 206262,
  [SMALL_STATE(6299)] = 206275,
  [SMALL_STATE(6300)] = 206288,
  [SMALL_STATE(6301)] = 206301,
  [SMALL_STATE(6302)] = 206314,
  [SMALL_STATE(6303)] = 206327,
  [SMALL_STATE(6304)] = 206340,
  [SMALL_STATE(6305)] = 206353,
  [SMALL_STATE(6306)] = 206366,
  [SMALL_STATE(6307)] = 206379,
  [SMALL_STATE(6308)] = 206392,
  [SMALL_STATE(6309)] = 206405,
  [SMALL_STATE(6310)] = 206418,
  [SMALL_STATE(6311)] = 206431,
  [SMALL_STATE(6312)] = 206444,
  [SMALL_STATE(6313)] = 206457,
  [SMALL_STATE(6314)] = 206470,
  [SMALL_STATE(6315)] = 206483,
  [SMALL_STATE(6316)] = 206496,
  [SMALL_STATE(6317)] = 206509,
  [SMALL_STATE(6318)] = 206522,
  [SMALL_STATE(6319)] = 206535,
  [SMALL_STATE(6320)] = 206548,
  [SMALL_STATE(6321)] = 206561,
  [SMALL_STATE(6322)] = 206574,
  [SMALL_STATE(6323)] = 206587,
  [SMALL_STATE(6324)] = 206600,
  [SMALL_STATE(6325)] = 206613,
  [SMALL_STATE(6326)] = 206626,
  [SMALL_STATE(6327)] = 206639,
  [SMALL_STATE(6328)] = 206652,
  [SMALL_STATE(6329)] = 206665,
  [SMALL_STATE(6330)] = 206678,
  [SMALL_STATE(6331)] = 206691,
  [SMALL_STATE(6332)] = 206704,
  [SMALL_STATE(6333)] = 206717,
  [SMALL_STATE(6334)] = 206730,
  [SMALL_STATE(6335)] = 206743,
  [SMALL_STATE(6336)] = 206756,
  [SMALL_STATE(6337)] = 206769,
  [SMALL_STATE(6338)] = 206782,
  [SMALL_STATE(6339)] = 206795,
  [SMALL_STATE(6340)] = 206808,
  [SMALL_STATE(6341)] = 206821,
  [SMALL_STATE(6342)] = 206834,
  [SMALL_STATE(6343)] = 206847,
  [SMALL_STATE(6344)] = 206860,
  [SMALL_STATE(6345)] = 206873,
  [SMALL_STATE(6346)] = 206886,
  [SMALL_STATE(6347)] = 206899,
  [SMALL_STATE(6348)] = 206912,
  [SMALL_STATE(6349)] = 206925,
  [SMALL_STATE(6350)] = 206938,
  [SMALL_STATE(6351)] = 206951,
  [SMALL_STATE(6352)] = 206964,
  [SMALL_STATE(6353)] = 206977,
  [SMALL_STATE(6354)] = 206990,
  [SMALL_STATE(6355)] = 207003,
  [SMALL_STATE(6356)] = 207016,
  [SMALL_STATE(6357)] = 207029,
  [SMALL_STATE(6358)] = 207042,
  [SMALL_STATE(6359)] = 207055,
  [SMALL_STATE(6360)] = 207068,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6360),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5505),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2712),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5423),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3096),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6360),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5512),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6359),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1326),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1330),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3238),
  [27] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, -1, 10), SHIFT(500),
  [30] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 10),
  [32] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1203),
  [34] = {.entry = {.count = 1, .reusable = false}}, SHIFT(932),
  [36] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 10), REDUCE(sym_pattern, 1, -1, 10),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(276),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4239),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3215),
  [45] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 10), SHIFT(504),
  [48] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [50] = {.entry = {.count = 1, .reusable = false}}, SHIFT(506),
  [52] = {.entry = {.count = 1, .reusable = false}}, SHIFT(166),
  [54] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [56] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5531),
  [58] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4759),
  [60] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4758),
  [62] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3530),
  [64] = {.entry = {.count = 1, .reusable = false}}, SHIFT(697),
  [66] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3819),
  [68] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [70] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 10),
  [72] = {.entry = {.count = 1, .reusable = false}}, SHIFT(105),
  [74] = {.entry = {.count = 1, .reusable = false}}, SHIFT(429),
  [76] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__augmented_assignment_lhs, 1, 0, 10),
  [78] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [80] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1159),
  [82] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1160),
  [84] = {.entry = {.count = 1, .reusable = false}}, SHIFT(484),
  [86] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 10), SHIFT(6071),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1010),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(216),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(504),
  [97] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 10), SHIFT(546),
  [100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3768),
  [102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2642),
  [104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5991),
  [106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2381),
  [108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1976),
  [110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2642),
  [112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2244),
  [114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5419),
  [116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(237),
  [118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1168),
  [120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1343),
  [122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6260),
  [124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6259),
  [126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1169),
  [128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6258),
  [130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3179),
  [132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [134] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, -1, 10), SHIFT(524),
  [137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, -1, 10),
  [139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1264),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(675),
  [145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2859),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1236),
  [149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1060),
  [151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1726),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(492),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3168),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1260),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5874),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3822),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1053),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3771),
  [171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5873),
  [175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5721),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5375),
  [179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(510),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5542),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(36),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5872),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5374),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5373),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5548),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(311),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(320),
  [199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(160),
  [203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4770),
  [207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4772),
  [209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3543),
  [211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(658),
  [213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3946),
  [215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(65),
  [217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(533),
  [219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6303),
  [223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4045),
  [227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2485),
  [229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4274),
  [231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2480),
  [233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2610),
  [235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(663),
  [237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(670),
  [239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(671),
  [241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(689),
  [243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(686),
  [245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(688),
  [247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1064),
  [249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6283),
  [251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6282),
  [253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6281),
  [255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1247),
  [257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(672),
  [259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1244),
  [261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1058),
  [263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1249),
  [267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1059),
  [269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(657),
  [271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(71),
  [273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(661),
  [275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(667),
  [277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(666),
  [279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(692),
  [281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(683),
  [283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(684),
  [285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1062),
  [287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1277),
  [289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(674),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1239),
  [293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1067),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1263),
  [297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1052),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(659),
  [301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(64),
  [303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(660),
  [305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(664),
  [307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(669),
  [309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(690),
  [311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(687),
  [313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(681),
  [315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1055),
  [317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1258),
  [319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(673),
  [321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1242),
  [323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1056),
  [325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1255),
  [327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1057),
  [329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(656),
  [331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(67),
  [333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(662),
  [335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(668),
  [337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(665),
  [339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(691),
  [341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(685),
  [343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(682),
  [345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1066),
  [347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2250),
  [351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2240),
  [353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1396),
  [355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(694),
  [357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 4, 0, 299),
  [359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1353),
  [361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1220),
  [363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 4, 0, 299),
  [365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1412),
  [367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1223),
  [369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(705),
  [373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(94),
  [375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2480),
  [377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6302),
  [379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(714),
  [381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1224),
  [383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 2, 0, 0),
  [385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_default, 2, 0, 0),
  [387] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 3, 0, 54),
  [389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 3, 0, 54),
  [391] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 3, 0, 92),
  [393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_default, 3, 0, 92),
  [395] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1396),
  [398] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(694),
  [401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0),
  [403] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1353),
  [406] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1220),
  [409] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(8),
  [412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0),
  [414] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(492),
  [417] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3168),
  [420] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1412),
  [423] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(5874),
  [426] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3822),
  [429] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1223),
  [432] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3771),
  [435] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(492),
  [438] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(5873),
  [441] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(5721),
  [444] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(5375),
  [447] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(189),
  [450] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(510),
  [453] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(5542),
  [456] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(36),
  [459] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(5872),
  [462] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(5374),
  [465] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(5373),
  [468] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(5548),
  [471] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(311),
  [474] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(320),
  [477] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(766),
  [480] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(160),
  [483] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(204),
  [486] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(5531),
  [489] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(4770),
  [492] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(4772),
  [495] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3543),
  [498] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(705),
  [501] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3946),
  [504] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(94),
  [507] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(533),
  [510] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(6303),
  [513] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1010),
  [516] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(536),
  [519] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(4045),
  [522] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2480),
  [525] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(6302),
  [528] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2480),
  [531] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2610),
  [534] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(5419),
  [537] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(714),
  [540] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1224),
  [543] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(6283),
  [546] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(6282),
  [549] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2, 0, 0), SHIFT_REPEAT(6281),
  [552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1828),
  [560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1554),
  [562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1957),
  [570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1958),
  [580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1388),
  [586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(698),
  [588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1364),
  [590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1225),
  [592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3166),
  [596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1390),
  [598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5528),
  [600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3989),
  [602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1217),
  [604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3742),
  [606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5529),
  [608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5530),
  [610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4938),
  [612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5698),
  [614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(37),
  [616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5543),
  [618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5072),
  [620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5071),
  [622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5862),
  [624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(305),
  [626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(387),
  [628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2916),
  [630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3523),
  [632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(707),
  [634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3947),
  [636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(96),
  [638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(710),
  [640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1218),
  [642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6151),
  [644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6062),
  [646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6059),
  [648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1407),
  [650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(696),
  [652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1358),
  [654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1219),
  [656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1405),
  [660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5719),
  [662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1222),
  [664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5720),
  [666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5073),
  [668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5863),
  [670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3527),
  [672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(708),
  [674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3898),
  [676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(102),
  [678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(716),
  [680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1226),
  [682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1288),
  [684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1316),
  [686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3238),
  [688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1206),
  [690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(930),
  [692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(297),
  [696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(490),
  [700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(159),
  [702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2374),
  [706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(693),
  [708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(593),
  [712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(452),
  [720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6071),
  [722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(206),
  [724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(487),
  [726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6104),
  [730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2705),
  [732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2431),
  [734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(266),
  [736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1400),
  [740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2295),
  [742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2704),
  [744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1394),
  [746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1386),
  [748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(557),
  [750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1230),
  [752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2695),
  [756] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, 0, 23), SHIFT(58),
  [759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6264),
  [761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3550),
  [763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(703),
  [765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3963),
  [767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(93),
  [771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2267),
  [775] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__property_name, 1, 0, 23),
  [777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1935),
  [779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2365),
  [781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2038),
  [783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2597),
  [785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2248),
  [787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2205),
  [791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2332),
  [793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2555),
  [795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2093),
  [797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1803),
  [799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1338),
  [801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [803] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 10), SHIFT(188),
  [806] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 10), SHIFT(201),
  [809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [811] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 10), SHIFT(1010),
  [814] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 10), SHIFT(4183),
  [817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1976),
  [819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2608),
  [821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2119),
  [823] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, -1, 10),
  [825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2462),
  [827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2475),
  [829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2612),
  [831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2616),
  [833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2478),
  [835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2469),
  [837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1370),
  [839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1348),
  [841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1214),
  [843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5982),
  [851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(699),
  [853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4183),
  [857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1896),
  [859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1504),
  [861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1500),
  [863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(524),
  [865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1318),
  [867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_pattern, 2, 0, 53),
  [869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(757),
  [873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(133),
  [875] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rest_pattern, 2, 0, 53),
  [877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(500),
  [879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1327),
  [881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(956),
  [883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(286),
  [885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5359),
  [887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(430),
  [891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3744),
  [893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2439),
  [895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2359),
  [897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2439),
  [899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2360),
  [901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5143),
  [903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2),
  [905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(303),
  [907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(304),
  [909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1350),
  [911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(610),
  [913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2245),
  [917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3),
  [919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(302),
  [921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(301),
  [923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1367),
  [929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1344),
  [931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1210),
  [933] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 10), SHIFT(487),
  [936] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 10), SHIFT(203),
  [939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(701),
  [941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [943] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 10), SHIFT(457),
  [946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2241),
  [948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1383),
  [950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1399),
  [952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(552),
  [954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1229),
  [956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(717),
  [958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(107),
  [962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6068),
  [964] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 10), REDUCE(sym_rest_pattern, 2, 0, 53),
  [967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1484),
  [969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1482),
  [971] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, -1, 10), SHIFT(523),
  [974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1307),
  [976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(736),
  [980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(128),
  [984] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 10), SHIFT(366),
  [987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(103),
  [989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1476),
  [991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1470),
  [993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(402),
  [995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1259),
  [997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(728),
  [999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [1001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(116),
  [1003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [1005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(523),
  [1007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [1009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1446),
  [1011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1441),
  [1013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(548),
  [1015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1233),
  [1017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(715),
  [1019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(114),
  [1021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5960),
  [1023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1483),
  [1025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1491),
  [1027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(647),
  [1029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1279),
  [1031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [1033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [1035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(735),
  [1037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [1039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(127),
  [1041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(125),
  [1043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1495),
  [1045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1481),
  [1047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(461),
  [1049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1302),
  [1051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(742),
  [1053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [1055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(144),
  [1057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6101),
  [1059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [1061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1310),
  [1063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3486),
  [1065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(938),
  [1067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(278),
  [1069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3466),
  [1071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [1073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [1075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(119),
  [1077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [1079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [1081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(592),
  [1083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(211),
  [1085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3750),
  [1087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2277),
  [1089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2257),
  [1091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2277),
  [1093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2216),
  [1095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(256),
  [1097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [1099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1325),
  [1101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6165),
  [1103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5998),
  [1105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1162),
  [1107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5993),
  [1109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3425),
  [1111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1240),
  [1113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(446),
  [1115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(617),
  [1117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(609),
  [1119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(539),
  [1121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(512),
  [1123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(566),
  [1125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(532),
  [1127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(590),
  [1129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1359),
  [1131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1468),
  [1133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1266),
  [1135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(969),
  [1137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(283),
  [1139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [1141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [1143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(474),
  [1145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(162),
  [1147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [1149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(721),
  [1151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(120),
  [1153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(502),
  [1155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(643),
  [1157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(268),
  [1159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(475),
  [1161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [1163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3761),
  [1165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2729),
  [1167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6140),
  [1169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2716),
  [1171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2729),
  [1173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2451),
  [1175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(269),
  [1177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1384),
  [1179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1391),
  [1181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1485),
  [1183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1286),
  [1185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(973),
  [1187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(296),
  [1189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [1191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(398),
  [1193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(165),
  [1195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [1197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(730),
  [1199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(130),
  [1201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(630),
  [1203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(464),
  [1205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(273),
  [1207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(399),
  [1209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [1211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3762),
  [1213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2430),
  [1215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6046),
  [1217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2609),
  [1219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2430),
  [1221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2702),
  [1223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(279),
  [1225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1440),
  [1227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1398),
  [1229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1490),
  [1231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1293),
  [1233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(960),
  [1235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(280),
  [1237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [1239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(441),
  [1241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(164),
  [1243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(737),
  [1245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(129),
  [1247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(468),
  [1249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(521),
  [1251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(263),
  [1253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(560),
  [1255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [1257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5947),
  [1259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2734),
  [1261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(285),
  [1263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1433),
  [1265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1284),
  [1267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(967),
  [1269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(291),
  [1271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [1273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(89),
  [1275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(572),
  [1277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3770),
  [1279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2081),
  [1281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2002),
  [1283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2081),
  [1285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2146),
  [1287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(213),
  [1289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1340),
  [1291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1339),
  [1293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1393),
  [1295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1231),
  [1297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(954),
  [1299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(277),
  [1301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [1303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(709),
  [1305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(100),
  [1307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(580),
  [1309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(264),
  [1311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3758),
  [1313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2357),
  [1315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2419),
  [1317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2357),
  [1319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2418),
  [1321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(218),
  [1323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1356),
  [1325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1333),
  [1327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1410),
  [1329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1232),
  [1331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(290),
  [1333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [1335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(622),
  [1337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(161),
  [1339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(718),
  [1341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(106),
  [1343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(401),
  [1345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(620),
  [1347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(270),
  [1349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(627),
  [1351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [1353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6162),
  [1355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2304),
  [1357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(224),
  [1359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1371),
  [1361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1447),
  [1363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(962),
  [1365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(284),
  [1367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(146),
  [1369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(514),
  [1371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2778),
  [1373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(309),
  [1375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1474),
  [1377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1409),
  [1379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1496),
  [1381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1306),
  [1383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(295),
  [1385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [1387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(473),
  [1389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(167),
  [1391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(744),
  [1393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(145),
  [1395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(481),
  [1397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(431),
  [1399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(271),
  [1401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(478),
  [1403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [1405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6290),
  [1407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2723),
  [1409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(298),
  [1411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1444),
  [1413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1374),
  [1415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1450),
  [1417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1243),
  [1419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(300),
  [1421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [1423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(520),
  [1425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [1427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(711),
  [1429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(122),
  [1431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(573),
  [1433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(614),
  [1435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(259),
  [1437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(507),
  [1439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [1441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6271),
  [1443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2545),
  [1445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(275),
  [1447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1408),
  [1449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1403),
  [1451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(968),
  [1453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [1455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2770),
  [1457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2706),
  [1459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1436),
  [1461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1366),
  [1463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1328),
  [1465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1204),
  [1467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(942),
  [1469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(287),
  [1471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [1473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(695),
  [1475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(123),
  [1477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(404),
  [1479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3764),
  [1481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2759),
  [1483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2785),
  [1485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2759),
  [1487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2455),
  [1489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(281),
  [1491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1377),
  [1493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1363),
  [1495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1406),
  [1497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1227),
  [1499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(964),
  [1501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(704),
  [1503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(108),
  [1505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2470),
  [1507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(230),
  [1509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1404),
  [1511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(586),
  [1513] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 1, 0, 0),
  [1515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 1, 0, 0),
  [1517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1392),
  [1519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(517),
  [1521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(101),
  [1523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1411),
  [1525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(601),
  [1527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(110),
  [1529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2548),
  [1531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1467),
  [1533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(442),
  [1535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(113),
  [1537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2768),
  [1539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1453),
  [1541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(559),
  [1543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(121),
  [1545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2701),
  [1547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1492),
  [1549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(518),
  [1551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(124),
  [1553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2855),
  [1555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1486),
  [1557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(454),
  [1559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(126),
  [1561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2829),
  [1563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(498),
  [1565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1494),
  [1567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(462),
  [1569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(132),
  [1571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2875),
  [1573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1426),
  [1575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1274),
  [1577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4020),
  [1579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1262),
  [1581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(725),
  [1583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(738),
  [1585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1270),
  [1587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1432),
  [1589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1256),
  [1591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4086),
  [1593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1271),
  [1595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(720),
  [1597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(733),
  [1599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1268),
  [1601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(726),
  [1603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(729),
  [1605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1251),
  [1607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1439),
  [1609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4017),
  [1611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3790),
  [1613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1276),
  [1615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3760),
  [1617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3534),
  [1619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(719),
  [1621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3969),
  [1623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(740),
  [1625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1248),
  [1627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6304),
  [1629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5964),
  [1631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5965),
  [1633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1357),
  [1635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1346),
  [1637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1209),
  [1639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [1641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(702),
  [1643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1345),
  [1645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1368),
  [1647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1211),
  [1649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [1651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(700),
  [1653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1379),
  [1655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1385),
  [1657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1228),
  [1659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [1661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [1663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [1665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2312),
  [1667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(706),
  [1669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(83),
  [1671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2135),
  [1673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1324),
  [1675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2519),
  [1677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(76),
  [1679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4150),
  [1681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2521),
  [1683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(79),
  [1685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3979),
  [1687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4113),
  [1689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3978),
  [1691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4022),
  [1693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5051),
  [1695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3960),
  [1697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4891),
  [1699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2813),
  [1701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2001),
  [1703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2687),
  [1705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1956),
  [1707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2174),
  [1709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_predefined_type, 1, 0, 0),
  [1711] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_predefined_type, 1, 0, 0),
  [1713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2490),
  [1715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1401),
  [1717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1397),
  [1719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1221),
  [1721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [1723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3883),
  [1725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1216),
  [1727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3882),
  [1729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [1731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(713),
  [1733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(111),
  [1735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2515),
  [1737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1448),
  [1739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1457),
  [1741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1234),
  [1743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [1745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4244),
  [1747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(712),
  [1749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(109),
  [1751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2757),
  [1753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3172),
  [1755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1241),
  [1757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3938),
  [1759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [1761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [1763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4854),
  [1765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4856),
  [1767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4723),
  [1769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6261),
  [1771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5389),
  [1773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4293),
  [1775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3234),
  [1777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3233),
  [1779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3234),
  [1781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1167),
  [1783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3954),
  [1785] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1, 0, 0), REDUCE(aux_sym_array_pattern_repeat1, 1, 0, 0),
  [1788] = {.entry = {.count = 3, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1, 0, 0), REDUCE(aux_sym_array_pattern_repeat1, 1, 0, 0), SHIFT(3463),
  [1792] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 2, 0, 0),
  [1794] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 2, 0, 0),
  [1796] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_pattern, 2, 0, 0),
  [1798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 2, 0, 0),
  [1800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 2, 0, 0),
  [1802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [1804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1471),
  [1806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1469),
  [1808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1269),
  [1810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(727),
  [1812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(117),
  [1814] = {.entry = {.count = 3, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1, 0, 0), REDUCE(aux_sym_array_pattern_repeat1, 1, 0, 0), SHIFT(3274),
  [1818] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__module, 1, 0, 16),
  [1820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [1822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 1, 0, 16),
  [1824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6102),
  [1826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6103),
  [1828] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 6, 0, 188),
  [1830] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 6, 0, 188),
  [1832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 6, 0, 188),
  [1834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 6, 0, 188),
  [1836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [1838] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_internal_module, 2, 0, 33),
  [1840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_internal_module, 2, 0, 33),
  [1842] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 1, 0, 0),
  [1844] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0),
  [1846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 1, 0, 0),
  [1848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0),
  [1850] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3, 0, 0),
  [1852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3, 0, 0),
  [1854] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 3, 0, 0),
  [1856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 3, 0, 0),
  [1858] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2, 0, 0),
  [1860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2, 0, 0),
  [1862] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, 0, 59),
  [1864] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_expression, 4, 0, 59),
  [1866] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, 0, 59),
  [1868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_expression, 4, 0, 59),
  [1870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [1872] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_identifier, 3, 0, 63),
  [1874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_identifier, 3, 0, 63),
  [1876] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 5, 0, 122),
  [1878] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 5, 0, 122),
  [1880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 5, 0, 122),
  [1882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 5, 0, 122),
  [1884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [1886] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, 0, 122),
  [1888] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_expression, 5, 0, 122),
  [1890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, 0, 122),
  [1892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_expression, 5, 0, 122),
  [1894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [1896] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__module, 2, 0, 77),
  [1898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 2, 0, 77),
  [1900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [1902] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 4, 0, 0),
  [1904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 4, 0, 0),
  [1906] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, 0, 185),
  [1908] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, 0, 185),
  [1910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, 0, 185),
  [1912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, 0, 185),
  [1914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [1916] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, 0, 227),
  [1918] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, 0, 227),
  [1920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, 0, 227),
  [1922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, 0, 227),
  [1924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [1926] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 2, 0, 0),
  [1928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 2, 0, 0),
  [1930] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 3, 0, 89),
  [1932] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, 0, 89),
  [1934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 3, 0, 89),
  [1936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, 0, 89),
  [1938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [1940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_pattern_repeat1, 1, 0, 0),
  [1942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [1944] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_identifier, 3, 0, 66),
  [1946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_identifier, 3, 0, 66),
  [1948] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, 0, 241),
  [1950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, 0, 241),
  [1952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, 0, 241),
  [1954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, 0, 241),
  [1956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [1958] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, 0, 158),
  [1960] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, 0, 158),
  [1962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, 0, 158),
  [1964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, 0, 158),
  [1966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [1968] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 3, 0, 156),
  [1970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 3, 0, 156),
  [1972] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, 0, 286),
  [1974] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 6, 0, 286),
  [1976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, 0, 286),
  [1978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 6, 0, 286),
  [1980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [1982] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, 0, 157),
  [1984] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, 0, 157),
  [1986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, 0, 157),
  [1988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, 0, 157),
  [1990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [1992] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, 0, 242),
  [1994] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, 0, 242),
  [1996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, 0, 242),
  [1998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, 0, 242),
  [2000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [2002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3284),
  [2004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3486),
  [2006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1240),
  [2008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3825),
  [2010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [2012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [2014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4683),
  [2016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4684),
  [2018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4728),
  [2020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1147),
  [2022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1148),
  [2024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5990),
  [2026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4453),
  [2028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3484),
  [2030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3472),
  [2032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3484),
  [2034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1151),
  [2036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1153),
  [2038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3539),
  [2040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2579),
  [2042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(80),
  [2044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [2046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3462),
  [2048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [2050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2154),
  [2052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [2054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3124),
  [2056] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1, 0, 0),
  [2058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2853),
  [2060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3386),
  [2062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1742),
  [2064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1413),
  [2066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1304),
  [2068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1267),
  [2070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1361),
  [2072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1342),
  [2074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1378),
  [2076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1294),
  [2078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1354),
  [2080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(78),
  [2082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1312),
  [2084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1275),
  [2086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2620),
  [2088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(77),
  [2090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1376),
  [2092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1347),
  [2094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1321),
  [2096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1319),
  [2098] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_override_modifier, 1, 0, 0),
  [2100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_override_modifier, 1, 0, 0),
  [2102] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accessibility_modifier, 1, 0, 0),
  [2104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accessibility_modifier, 1, 0, 0),
  [2106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3002),
  [2108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(81),
  [2110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2621),
  [2112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(82),
  [2114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2471),
  [2116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(75),
  [2118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [2120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [2122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1493),
  [2124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1488),
  [2126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1280),
  [2128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [2130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4115),
  [2132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1335),
  [2134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4116),
  [2136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [2138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(758),
  [2140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(131),
  [2142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2797),
  [2144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [2146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [2148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [2150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [2152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [2154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [2156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [2158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [2160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1475),
  [2162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1479),
  [2164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1265),
  [2166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(724),
  [2168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(118),
  [2170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1472),
  [2172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1477),
  [2174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1273),
  [2176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(723),
  [2178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(115),
  [2180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1526),
  [2182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1508),
  [2184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1336),
  [2186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(743),
  [2188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(137),
  [2190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2896),
  [2192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2745),
  [2194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1503),
  [2196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1515),
  [2198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1322),
  [2200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(746),
  [2202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(139),
  [2204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2886),
  [2206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2476),
  [2208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1758),
  [2210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1522),
  [2212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1505),
  [2214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1337),
  [2216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(750),
  [2218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(140),
  [2220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2915),
  [2222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1516),
  [2224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1524),
  [2226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1315),
  [2228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(751),
  [2230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(136),
  [2232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2895),
  [2234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1518),
  [2236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1506),
  [2238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1317),
  [2240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(745),
  [2242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(138),
  [2244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2901),
  [2246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1510),
  [2248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1514),
  [2250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1332),
  [2252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(741),
  [2254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(142),
  [2256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2900),
  [2258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1502),
  [2260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1499),
  [2262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1334),
  [2264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(756),
  [2266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(134),
  [2268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2887),
  [2270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2364),
  [2272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1434),
  [2274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(112),
  [2276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2691),
  [2278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1320),
  [2280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(84),
  [2282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2190),
  [2284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2265),
  [2286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1509),
  [2288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1512),
  [2290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1341),
  [2292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(747),
  [2294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(141),
  [2296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2889),
  [2298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1507),
  [2300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1519),
  [2302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1323),
  [2304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(754),
  [2306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(143),
  [2308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2882),
  [2310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4754),
  [2312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4753),
  [2314] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 10), SHIFT(2868),
  [2317] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 10), REDUCE(sym__property_name, 1, 0, 23), SHIFT(197),
  [2321] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 10), SHIFT(555),
  [2324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3920),
  [2326] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 10), REDUCE(sym__property_name, 1, 0, 23), SHIFT(5389),
  [2330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3955),
  [2332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2367),
  [2334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4071),
  [2336] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 10), REDUCE(sym__property_name, 1, 0, 23),
  [2339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2369),
  [2341] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 10), REDUCE(sym__property_name, 1, 0, 23),
  [2344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2370),
  [2346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2443),
  [2348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2776),
  [2350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5259),
  [2352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [2354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5258),
  [2356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(535),
  [2358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6240),
  [2360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4066),
  [2362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3547),
  [2364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6239),
  [2366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3822),
  [2368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3922),
  [2370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3771),
  [2372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6238),
  [2374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6237),
  [2376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5560),
  [2378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3094),
  [2380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4067),
  [2382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6283),
  [2384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6282),
  [2386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6281),
  [2388] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 5, 0, 0),
  [2390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 5, 0, 0),
  [2392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 4, 0, 0),
  [2394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 4, 0, 0),
  [2396] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 2, 0, 0),
  [2398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 2, 0, 0),
  [2400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 6, 0, 0),
  [2402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 6, 0, 0),
  [2404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 3, 0, 0),
  [2406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 3, 0, 0),
  [2408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6222),
  [2410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3919),
  [2412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5570),
  [2414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6088),
  [2416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6087),
  [2418] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 10), SHIFT(197),
  [2421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3807),
  [2423] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 10), SHIFT(5389),
  [2426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(525),
  [2428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5980),
  [2430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5949),
  [2432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [2434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4177),
  [2436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3989),
  [2438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6344),
  [2440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5615),
  [2442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3090),
  [2444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4176),
  [2446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5096),
  [2448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [2450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5421),
  [2452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(616),
  [2454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6169),
  [2456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4106),
  [2458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6343),
  [2460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3784),
  [2462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3742),
  [2464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6019),
  [2466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6353),
  [2468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5532),
  [2470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3088),
  [2472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4104),
  [2474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6151),
  [2476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6062),
  [2478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6059),
  [2480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6267),
  [2482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6268),
  [2484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [2486] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 10), SHIFT(6351),
  [2489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3939),
  [2491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [2493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3964),
  [2495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3905),
  [2497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6179),
  [2499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3868),
  [2501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5684),
  [2503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6276),
  [2505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6275),
  [2507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5941),
  [2509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5940),
  [2511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(316),
  [2513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3806),
  [2515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5829),
  [2517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6173),
  [2519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6172),
  [2521] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 10), SHIFT(6172),
  [2524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6154),
  [2526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6153),
  [2528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3970),
  [2530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 2, 0, 37),
  [2532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 2, 0, 37),
  [2534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4877),
  [2536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5822),
  [2538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6051),
  [2540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6050),
  [2542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [2544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6312),
  [2546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4062),
  [2548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6352),
  [2550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3790),
  [2552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3779),
  [2554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3760),
  [2556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5975),
  [2558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6357),
  [2560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5518),
  [2562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3093),
  [2564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3927),
  [2566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6304),
  [2568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5601),
  [2570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5964),
  [2572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5965),
  [2574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6311),
  [2576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6310),
  [2578] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 10), SHIFT(6310),
  [2581] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, 0, 87),
  [2583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, 0, 87),
  [2585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [2587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6185),
  [2589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6187),
  [2591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(315),
  [2593] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [2595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [2597] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 5, 0, 300),
  [2599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 5, 0, 300),
  [2601] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, 0, 81),
  [2603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, 0, 81),
  [2605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(53),
  [2607] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1, 0, 0),
  [2609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1, 0, 0),
  [2611] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 4, 0, 146),
  [2613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 4, 0, 146),
  [2615] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 2, 0, 37),
  [2617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 2, 0, 37),
  [2619] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [2621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [2623] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 6, 0, 331),
  [2625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 6, 0, 331),
  [2627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [2629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [2631] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 4, 0, 207),
  [2633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 4, 0, 207),
  [2635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [2637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, 0, 88),
  [2639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, 0, 88),
  [2641] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 3, 0, 80),
  [2643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 3, 0, 80),
  [2645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 5, 0, 0),
  [2647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 5, 0, 0),
  [2649] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 7, 0, 188),
  [2651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 7, 0, 188),
  [2653] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 5, 0, 248),
  [2655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 5, 0, 248),
  [2657] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 7, 0, 329),
  [2659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 7, 0, 329),
  [2661] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 3, 0, 0),
  [2663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 3, 0, 0),
  [2665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 5, 0, 195),
  [2667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 5, 0, 195),
  [2669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 5, 0, 296),
  [2671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 5, 0, 296),
  [2673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, 0, 326),
  [2675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, 0, 326),
  [2677] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 3, 0, 15),
  [2679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 3, 0, 15),
  [2681] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3, 0, 144),
  [2683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3, 0, 144),
  [2685] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2, 0, 0),
  [2687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2, 0, 0),
  [2689] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 3, 0, 0),
  [2691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 3, 0, 0),
  [2693] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 6, 0, 122),
  [2695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 6, 0, 122),
  [2697] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, 0, 122),
  [2699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, 0, 122),
  [2701] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, 0, 286),
  [2703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, 0, 286),
  [2705] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 7, 0, 330),
  [2707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 7, 0, 330),
  [2709] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, 0, 258),
  [2711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, 0, 258),
  [2713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, 0, 152),
  [2715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, 0, 152),
  [2717] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 2, 0, 37),
  [2719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 2, 0, 37),
  [2721] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 2, 0, 0),
  [2723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 2, 0, 0),
  [2725] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 3, 0, 142),
  [2727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 3, 0, 142),
  [2729] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, 0, 145),
  [2731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, 0, 145),
  [2733] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 3, 0, 141),
  [2735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 3, 0, 141),
  [2737] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 3, 0, 0),
  [2739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 3, 0, 0),
  [2741] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, 0, 59),
  [2743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, 0, 59),
  [2745] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 2, 0, 33),
  [2747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 2, 0, 33),
  [2749] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 2, 0, 0),
  [2751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 2, 0, 0),
  [2753] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, 0, 89),
  [2755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, 0, 89),
  [2757] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 3, 0, 0),
  [2759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 3, 0, 0),
  [2761] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3, 0, 0),
  [2763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3, 0, 0),
  [2765] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2, 0, 0),
  [2767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2, 0, 0),
  [2769] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_debugger_statement, 2, 0, 0),
  [2771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_debugger_statement, 2, 0, 0),
  [2773] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2, 0, 0),
  [2775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2, 0, 0),
  [2777] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2, 0, 0),
  [2779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2, 0, 0),
  [2781] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 1, 0, 0),
  [2783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1, 0, 0),
  [2785] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, -1, 136),
  [2787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, -1, 136),
  [2789] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 3, 0, 0),
  [2791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 3, 0, 0),
  [2793] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3, 0, 0),
  [2795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3, 0, 0),
  [2797] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 2, 0, 79),
  [2799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 2, 0, 79),
  [2801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias_declaration, 6, 0, 288),
  [2803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias_declaration, 6, 0, 288),
  [2805] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 3, 0, 140),
  [2807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 3, 0, 140),
  [2809] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 3, 0, 140),
  [2811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 3, 0, 140),
  [2813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 6, 0, 248),
  [2815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 6, 0, 248),
  [2817] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, 0, 139),
  [2819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, 0, 139),
  [2821] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 3, 0, 138),
  [2823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 3, 0, 138),
  [2825] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias_declaration, 5, 0, 251),
  [2827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias_declaration, 5, 0, 251),
  [2829] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4, 0, 296),
  [2831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, 0, 296),
  [2833] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 5, 0, 248),
  [2835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 5, 0, 248),
  [2837] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, 0, 82),
  [2839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, 0, 82),
  [2841] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 4, 0, 208),
  [2843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 4, 0, 208),
  [2845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, 0, 242),
  [2847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, 0, 242),
  [2849] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 4, 0, 206),
  [2851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 4, 0, 206),
  [2853] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3, 0, 135),
  [2855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3, 0, 135),
  [2857] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, 0, 297),
  [2859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, 0, 297),
  [2861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, 0, 298),
  [2863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, 0, 298),
  [2865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, 0, 255),
  [2867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, 0, 255),
  [2869] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, 0, 241),
  [2871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, 0, 241),
  [2873] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, 0, 254),
  [2875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, 0, 254),
  [2877] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 5, 0, 204),
  [2879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 5, 0, 204),
  [2881] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 5, 0, 0),
  [2883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 5, 0, 0),
  [2885] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 4, 0, 0),
  [2887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 4, 0, 0),
  [2889] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, 0, 292),
  [2891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, 0, 292),
  [2893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, 0, 202),
  [2895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, 0, 202),
  [2897] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, 0, 227),
  [2899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, 0, 227),
  [2901] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_alias, 5, 0, 0),
  [2903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_alias, 5, 0, 0),
  [2905] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 5, 0, 202),
  [2907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 5, 0, 202),
  [2909] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, 0, 203),
  [2911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, 0, 203),
  [2913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, 0, 260),
  [2915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, 0, 260),
  [2917] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, 0, 0),
  [2919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, 0, 0),
  [2921] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, 0, 215),
  [2923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, 0, 215),
  [2925] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 5, 0, 259),
  [2927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 5, 0, 259),
  [2929] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, 0, 294),
  [2931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, 0, 294),
  [2933] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 2, 0, 0),
  [2935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 2, 0, 0),
  [2937] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, 0, 213),
  [2939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, 0, 213),
  [2941] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexical_declaration, 3, 0, 137),
  [2943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexical_declaration, 3, 0, 137),
  [2945] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, 0, 212),
  [2947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, 0, 212),
  [2949] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 3, 0, 0),
  [2951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 3, 0, 0),
  [2953] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4, 0, 15),
  [2955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, 0, 15),
  [2957] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 3, 0, 13),
  [2959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 3, 0, 13),
  [2961] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, 0, 185),
  [2963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, 0, 185),
  [2965] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, 0, 207),
  [2967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, 0, 207),
  [2969] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 4, 0, 204),
  [2971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4, 0, 204),
  [2973] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 4, 0, 0),
  [2975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4, 0, 0),
  [2977] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, 0, 157),
  [2979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, 0, 157),
  [2981] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 4, 0, 209),
  [2983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 4, 0, 209),
  [2985] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 5, 0, 253),
  [2987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 5, 0, 253),
  [2989] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 4, 0, 202),
  [2991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4, 0, 202),
  [2993] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 4, 0, 13),
  [2995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4, 0, 13),
  [2997] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexical_declaration, 4, 0, 137),
  [2999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexical_declaration, 4, 0, 137),
  [3001] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 4, 0, 205),
  [3003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 4, 0, 205),
  [3005] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, 0, 158),
  [3007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, 0, 158),
  [3009] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4, 0, 195),
  [3011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, 0, 195),
  [3013] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4, 0, 0),
  [3015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, 0, 0),
  [3017] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 1, 0, 0),
  [3019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 1, 0, 0),
  [3021] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 7, 0, 353),
  [3023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 7, 0, 353),
  [3025] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, 0, 291),
  [3027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, 0, 291),
  [3029] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, 0, 290),
  [3031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, 0, 290),
  [3033] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 6, 0, 325),
  [3035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 6, 0, 325),
  [3037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [3039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6150),
  [3041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6147),
  [3043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [3045] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 4, 0, 0),
  [3047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 4, 0, 0),
  [3049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3415),
  [3051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1574),
  [3053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2815),
  [3055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [3057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [3059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2297),
  [3061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [3063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [3065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [3067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1552),
  [3069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3319),
  [3071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6213),
  [3073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5389),
  [3075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3505),
  [3077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1535),
  [3079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1561),
  [3081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1566),
  [3083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1631),
  [3085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1630),
  [3087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6206),
  [3089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [3091] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 4, 0, 57),
  [3093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 4, 0, 57),
  [3095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3449),
  [3097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1572),
  [3099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2358),
  [3101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1553),
  [3103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3322),
  [3105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1533),
  [3107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1550),
  [3109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1577),
  [3111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1668),
  [3113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1625),
  [3115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 3, 0, 56),
  [3117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 3, 0, 56),
  [3119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 4, 0, 56),
  [3121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 4, 0, 56),
  [3123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 3, 0, 57),
  [3125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 3, 0, 57),
  [3127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [3129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2203),
  [3131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [3133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3470),
  [3135] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 3, 0, 0),
  [3137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 3, 0, 0),
  [3139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2940),
  [3141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2553),
  [3143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2893),
  [3145] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 5, 0, 56),
  [3147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 5, 0, 56),
  [3149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2974),
  [3151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2975),
  [3153] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 5, 0, 57),
  [3155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 5, 0, 57),
  [3157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2891),
  [3159] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 5, 0, 0),
  [3161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 5, 0, 0),
  [3163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2890),
  [3165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2988),
  [3167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3442),
  [3169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1576),
  [3171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2097),
  [3173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1549),
  [3175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3292),
  [3177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1536),
  [3179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1551),
  [3181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1578),
  [3183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1628),
  [3185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1634),
  [3187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3446),
  [3189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6204),
  [3191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3213),
  [3193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [3195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6261),
  [3197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2375),
  [3199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6106),
  [3201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2382),
  [3203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3012),
  [3205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2907),
  [3207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3431),
  [3209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1575),
  [3211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2239),
  [3213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1562),
  [3215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3289),
  [3217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1529),
  [3219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1560),
  [3221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1567),
  [3223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1606),
  [3225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1602),
  [3227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3027),
  [3229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [3231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3403),
  [3233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1565),
  [3235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1559),
  [3237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3291),
  [3239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1534),
  [3241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1555),
  [3243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1570),
  [3245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1669),
  [3247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1666),
  [3249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3023),
  [3251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [3253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2707),
  [3255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2596),
  [3257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6346),
  [3259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3554),
  [3261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6193),
  [3263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1772),
  [3265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3423),
  [3267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1569),
  [3269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1557),
  [3271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3310),
  [3273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1532),
  [3275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1558),
  [3277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1568),
  [3279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1644),
  [3281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1641),
  [3283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [3285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6009),
  [3287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3494),
  [3289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2970),
  [3291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3476),
  [3293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3207),
  [3295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1852),
  [3297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3232),
  [3299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3646),
  [3301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2290),
  [3303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1889),
  [3305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3620),
  [3307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3461),
  [3309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2335),
  [3311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3397),
  [3313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3617),
  [3315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1235),
  [3317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3974),
  [3319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3706),
  [3321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [3323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [3325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4815),
  [3327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4811),
  [3329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4829),
  [3331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [3333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [3335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6234),
  [3337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3524),
  [3339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4217),
  [3341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3650),
  [3343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3519),
  [3345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3650),
  [3347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1200),
  [3349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [3351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6336),
  [3353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3286),
  [3355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6314),
  [3357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1189),
  [3359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6335),
  [3361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [3363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3167),
  [3365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3180),
  [3367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3327),
  [3369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3198),
  [3371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5990),
  [3373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3428),
  [3375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3285),
  [3377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2275),
  [3379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3610),
  [3381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2320),
  [3383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3682),
  [3385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3681),
  [3387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [3389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3387),
  [3391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [3393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3381),
  [3395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3680),
  [3397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2229),
  [3399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [3401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3629),
  [3403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3338),
  [3405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3627),
  [3407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2282),
  [3409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [3411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2274),
  [3413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1753),
  [3415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3396),
  [3417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3937),
  [3419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3541),
  [3421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1613),
  [3423] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 1, 0, 0), REDUCE(aux_sym_object_pattern_repeat1, 1, 0, 0),
  [3426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1597),
  [3428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3412),
  [3430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1564),
  [3432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1600),
  [3434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1615),
  [3436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1737),
  [3438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1743),
  [3440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [3442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3677),
  [3444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1865),
  [3446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [3448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3604),
  [3450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3628),
  [3452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2343),
  [3454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3670),
  [3456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3729),
  [3458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3606),
  [3460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1756),
  [3462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [3464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [3466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1752),
  [3468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3343),
  [3470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3355),
  [3472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3350),
  [3474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3522),
  [3476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1246),
  [3478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3804),
  [3480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4790),
  [3482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [3484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [3486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3801),
  [3488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1172),
  [3490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [3492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6341),
  [3494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3318),
  [3496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6166),
  [3498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1143),
  [3500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [3502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2049),
  [3504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2285),
  [3506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1245),
  [3508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3866),
  [3510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2397),
  [3512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [3514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [3516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4760),
  [3518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [3520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [3522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6094),
  [3524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2164),
  [3526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4461),
  [3528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2307),
  [3530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2176),
  [3532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2307),
  [3534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1093),
  [3536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [3538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6305),
  [3540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3326),
  [3542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6095),
  [3544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1087),
  [3546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6097),
  [3548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [3550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1707),
  [3552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [3554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1238),
  [3556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3924),
  [3558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1745),
  [3560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [3562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [3564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4853),
  [3566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [3568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [3570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6181),
  [3572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1729),
  [3574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4309),
  [3576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [3578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1711),
  [3580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1759),
  [3582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1097),
  [3584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [3586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6328),
  [3588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3309),
  [3590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6182),
  [3592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1084),
  [3594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6183),
  [3596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [3598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2415),
  [3600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3775),
  [3602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [3604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [3606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3280),
  [3608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(752),
  [3610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4733),
  [3612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4734),
  [3614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(225),
  [3616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4708),
  [3618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4707),
  [3620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3493),
  [3622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1820),
  [3624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3614),
  [3626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2126),
  [3628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2324),
  [3630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1739),
  [3632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1760),
  [3634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3432),
  [3636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3701),
  [3638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3716),
  [3640] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 49),
  [3642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 49),
  [3644] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 49), SHIFT_REPEAT(5143),
  [3647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1804),
  [3649] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator, 2, 0, 0),
  [3651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator, 2, 0, 0),
  [3653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [3655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6014),
  [3657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2313),
  [3659] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 49), SHIFT(3528),
  [3662] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 1, 0, 21),
  [3664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 1, 0, 21),
  [3666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1869),
  [3668] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_member_expression, 3, 0, 63),
  [3670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_member_expression, 3, 0, 63),
  [3672] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_call_expression, 2, 0, 43),
  [3674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_call_expression, 2, 0, 43),
  [3676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1740),
  [3678] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 4, 0, 0),
  [3680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4, 0, 0),
  [3682] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 2, 0, 0),
  [3684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 2, 0, 0),
  [3686] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3, 0, 0),
  [3688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3, 0, 0),
  [3690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3531),
  [3692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(366),
  [3694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2782),
  [3696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4836),
  [3698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4837),
  [3700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(920),
  [3702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4804),
  [3704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4805),
  [3706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4312),
  [3708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3514),
  [3710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1638),
  [3712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2836),
  [3714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [3716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3700),
  [3718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [3720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1618),
  [3722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3501),
  [3724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1598),
  [3726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1609),
  [3728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1673),
  [3730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1662),
  [3732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1693),
  [3734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5248),
  [3736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [3738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2950),
  [3740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [3742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [3744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [3746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2373),
  [3748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [3750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4014),
  [3752] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 0),
  [3754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(615),
  [3756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0),
  [3758] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym__property_name, 1, 0, 23),
  [3761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [3763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__augmented_assignment_lhs, 1, 0, 0),
  [3765] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym__property_name, 1, 0, 23),
  [3768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3769),
  [3770] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, 0, 63),
  [3772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, 0, 63),
  [3774] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, 0, 111),
  [3776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, 0, 111),
  [3778] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 4, 0, 183),
  [3780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 4, 0, 183),
  [3782] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, 0, 112),
  [3784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, 0, 112),
  [3786] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, 0, 113),
  [3788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, 0, 113),
  [3790] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_non_null_expression, 2, 0, 0),
  [3792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_non_null_expression, 2, 0, 0),
  [3794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(603),
  [3796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2, 0, 0),
  [3798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [3800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5779),
  [3802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [3804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5487),
  [3806] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2, 0, 0),
  [3808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1035),
  [3810] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 5, 0, 239),
  [3812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 5, 0, 239),
  [3814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [3816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5662),
  [3818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5007),
  [3820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1038),
  [3822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3456),
  [3824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2959),
  [3826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2962),
  [3828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1893),
  [3830] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym__primary_type, 1, 0, 39),
  [3833] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym__primary_type, 1, 0, 39),
  [3836] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), SHIFT(6292),
  [3839] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 0), SHIFT(1038),
  [3842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1, 0, 39),
  [3844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1862),
  [3846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [3848] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, -1, 0), SHIFT(603),
  [3851] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym_pattern, 1, -1, 0), REDUCE(sym__primary_type, 1, 0, 39),
  [3855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [3857] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_type, 1, 0, 39), SHIFT(5685),
  [3860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4191),
  [3862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2961),
  [3864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4194),
  [3866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [3868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3618),
  [3870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2311),
  [3872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3637),
  [3874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2281),
  [3876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3649),
  [3878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3471),
  [3880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2395),
  [3882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3480),
  [3884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(527),
  [3886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [3888] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), SHIFT(5968),
  [3891] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 0), SHIFT(1035),
  [3894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(489),
  [3896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(636),
  [3898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [3900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4192),
  [3902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1831),
  [3904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(571),
  [3906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [3908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_pattern, 2, 0, 0),
  [3910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [3912] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rest_pattern, 2, 0, 0),
  [3914] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym_pattern, 1, -1, 0),
  [3917] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, -1, 0),
  [3919] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 10), REDUCE(sym_predefined_type, 1, 0, 0),
  [3922] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 10), REDUCE(sym_predefined_type, 1, 0, 0),
  [3925] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, -1, 0), SHIFT(489),
  [3928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, -1, 0),
  [3930] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, -1, 0), REDUCE(sym__primary_type, 1, 0, 39),
  [3933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5824),
  [3935] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 10), SHIFT(223),
  [3938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(453),
  [3940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [3942] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), SHIFT(6350),
  [3945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(400),
  [3947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [3949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(515),
  [3951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [3953] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym__primary_type, 1, 0, 39), REDUCE(sym_rest_pattern, 2, 0, 0),
  [3957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5159),
  [3959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(465),
  [3961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [3963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [3965] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 0), SHIFT(382),
  [3968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [3970] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 10), REDUCE(sym_predefined_type, 1, 0, 0), REDUCE(sym_rest_pattern, 2, 0, 53),
  [3974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression_in_type_annotation, 3, 0, 63),
  [3976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression_in_type_annotation, 3, 0, 111),
  [3978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2804),
  [3980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [3982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2398),
  [3984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1667),
  [3986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4924),
  [3988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1545),
  [3990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1582),
  [3992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1692),
  [3994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1563),
  [3996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2744),
  [3998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [4000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3563),
  [4002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1939),
  [4004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [4006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1623),
  [4008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1580),
  [4010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1622),
  [4012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1705),
  [4014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1790),
  [4016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1789),
  [4018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3633),
  [4020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2491),
  [4022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1612),
  [4024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1583),
  [4026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1665),
  [4028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1677),
  [4030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1929),
  [4032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1928),
  [4034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3671),
  [4036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2798),
  [4038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1617),
  [4040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1601),
  [4042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1604),
  [4044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1680),
  [4046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1817),
  [4048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1816),
  [4050] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym_rest_pattern, 2, 0, 0),
  [4053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [4055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2046),
  [4057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3625),
  [4059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2693),
  [4061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1619),
  [4063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1599),
  [4065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1650),
  [4067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1690),
  [4069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1825),
  [4071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1822),
  [4073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5425),
  [4075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [4077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2894),
  [4079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2064),
  [4081] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, -1, 0), SHIFT(515),
  [4084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1131),
  [4086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [4088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3623),
  [4090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2019),
  [4092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1646),
  [4094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1587),
  [4096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1635),
  [4098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1672),
  [4100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1826),
  [4102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1827),
  [4104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2906),
  [4106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [4108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1947),
  [4110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3008),
  [4112] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 49), SHIFT_REPEAT(3514),
  [4115] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 49), SHIFT_REPEAT(2804),
  [4118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 49),
  [4120] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 49), SHIFT_REPEAT(2398),
  [4123] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 49), SHIFT_REPEAT(341),
  [4126] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 49), SHIFT_REPEAT(4683),
  [4129] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 49), SHIFT_REPEAT(4684),
  [4132] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 49), SHIFT_REPEAT(1667),
  [4135] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 49), SHIFT_REPEAT(6213),
  [4138] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 49), SHIFT_REPEAT(3505),
  [4141] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 49), SHIFT_REPEAT(4924),
  [4144] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 49), SHIFT_REPEAT(1545),
  [4147] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 49), SHIFT_REPEAT(1582),
  [4150] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 49), SHIFT_REPEAT(1692),
  [4153] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 49), SHIFT_REPEAT(1563),
  [4156] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 49), SHIFT_REPEAT(1662),
  [4159] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 49), SHIFT_REPEAT(1693),
  [4162] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 49), SHIFT_REPEAT(2744),
  [4165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [4167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2085),
  [4169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [4171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3689),
  [4173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2215),
  [4175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1637),
  [4177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1596),
  [4179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1611),
  [4181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1698),
  [4183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1785),
  [4185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1755),
  [4187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3738),
  [4189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2246),
  [4191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1608),
  [4193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1581),
  [4195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1624),
  [4197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1676),
  [4199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1787),
  [4201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1788),
  [4203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2987),
  [4205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [4207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [4209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3921),
  [4211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1731),
  [4213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1681),
  [4215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1733),
  [4217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1901),
  [4219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2124),
  [4221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2123),
  [4223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4212),
  [4225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4206),
  [4227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4688),
  [4229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2800),
  [4231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4025),
  [4233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5513),
  [4235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3556),
  [4237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3544),
  [4239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4026),
  [4241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3085),
  [4243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4027),
  [4245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6345),
  [4247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(544),
  [4249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(542),
  [4251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(508),
  [4253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(564),
  [4255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(530),
  [4257] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ui_object_initializer_repeat1, 2, 0, 0), SHIFT_REPEAT(4212),
  [4260] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ui_object_initializer_repeat1, 2, 0, 0), SHIFT_REPEAT(4206),
  [4263] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ui_object_initializer_repeat1, 2, 0, 0), SHIFT_REPEAT(4688),
  [4266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ui_object_initializer_repeat1, 2, 0, 0),
  [4268] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ui_object_initializer_repeat1, 2, 0, 0), SHIFT_REPEAT(3989),
  [4271] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ui_object_initializer_repeat1, 2, 0, 0), SHIFT_REPEAT(4025),
  [4274] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ui_object_initializer_repeat1, 2, 0, 0), SHIFT_REPEAT(5513),
  [4277] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_ui_object_initializer_repeat1, 2, 0, 0), SHIFT_REPEAT(5512),
  [4280] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ui_object_initializer_repeat1, 2, 0, 0), SHIFT_REPEAT(3556),
  [4283] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ui_object_initializer_repeat1, 2, 0, 0), SHIFT_REPEAT(3544),
  [4286] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ui_object_initializer_repeat1, 2, 0, 0), SHIFT_REPEAT(4026),
  [4289] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ui_object_initializer_repeat1, 2, 0, 0), SHIFT_REPEAT(3085),
  [4292] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ui_object_initializer_repeat1, 2, 0, 0), SHIFT_REPEAT(4027),
  [4295] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ui_object_initializer_repeat1, 2, 0, 0), SHIFT_REPEAT(6345),
  [4298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(451),
  [4300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5890),
  [4302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(422),
  [4304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2880),
  [4306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(516),
  [4308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5891),
  [4310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(618),
  [4312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2858),
  [4314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [4316] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, 0, 23), SHIFT(1497),
  [4319] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, 0, 23), SHIFT(1935),
  [4322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_name, 1, 0, 23),
  [4324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [4326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1661),
  [4328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1621),
  [4330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1674),
  [4332] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, 0, 23), SHIFT(2695),
  [4335] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, 0, 23), SHIFT(2038),
  [4338] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, 0, 23), SHIFT(2708),
  [4341] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, 0, 23), SHIFT(2116),
  [4344] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, 0, 23), SHIFT(2332),
  [4347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [4349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2863),
  [4351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [4353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1655),
  [4355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1654),
  [4357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1678),
  [4359] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, 0, 23), SHIFT(5649),
  [4362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [4364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [4366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2425),
  [4368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [4370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1546),
  [4372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1720),
  [4374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1719),
  [4376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2878),
  [4378] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__property_name, 1, 0, 23), REDUCE(aux_sym_object_repeat1, 2, 0, 78), REDUCE(aux_sym_object_pattern_repeat1, 2, 0, 52),
  [4382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5227),
  [4384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [4386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5261),
  [4388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [4390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6306),
  [4392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4061),
  [4394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1735),
  [4396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1724),
  [4398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2817),
  [4400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2861),
  [4402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1659),
  [4404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1688),
  [4406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2818),
  [4408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2868),
  [4410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2876),
  [4412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2494),
  [4414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4245),
  [4416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [4418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3956),
  [4420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2806),
  [4422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1657),
  [4424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1651),
  [4426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1671),
  [4428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2871),
  [4430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1647),
  [4432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1648),
  [4434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1694),
  [4436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1728),
  [4438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1741),
  [4440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2814),
  [4442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1656),
  [4444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1717),
  [4446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1718),
  [4448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2823),
  [4450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2811),
  [4452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2824),
  [4454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1632),
  [4456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1686),
  [4458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2822),
  [4460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1626),
  [4462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4371),
  [4464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4247),
  [4466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2869),
  [4468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1653),
  [4470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1627),
  [4472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1687),
  [4474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2116),
  [4476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2872),
  [4478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1670),
  [4480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1620),
  [4482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1679),
  [4484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2860),
  [4486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2830),
  [4488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2563),
  [4490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2864),
  [4492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2664),
  [4494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2847),
  [4496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1603),
  [4498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1704),
  [4500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1616),
  [4502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1702),
  [4504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2820),
  [4506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2474),
  [4508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2522),
  [4510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2852),
  [4512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1629),
  [4514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1685),
  [4516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2879),
  [4518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1658),
  [4520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1689),
  [4522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2572),
  [4524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2586),
  [4526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2867),
  [4528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2631),
  [4530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2807),
  [4532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1649),
  [4534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1695),
  [4536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [4538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2426),
  [4540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2870),
  [4542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1633),
  [4544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1691),
  [4546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4732),
  [4548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 1, 0, 0),
  [4550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2582),
  [4552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2851),
  [4554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2503),
  [4556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2819),
  [4558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1605),
  [4560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1699),
  [4562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3826),
  [4564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [4566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5823),
  [4568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1716),
  [4570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1706),
  [4572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1714),
  [4574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1766),
  [4576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2211),
  [4578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2207),
  [4580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2673),
  [4582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2444),
  [4584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2448),
  [4586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2599),
  [4588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2565),
  [4590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2857),
  [4592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2622),
  [4594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2507),
  [4596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1660),
  [4598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1675),
  [4600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2658),
  [4602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2524),
  [4604] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2, 0, 78), REDUCE(aux_sym_object_pattern_repeat1, 2, 0, 52),
  [4607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4094),
  [4609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 1, 0, 0),
  [4611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1824),
  [4613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1712),
  [4615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1823),
  [4617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2026),
  [4619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2228),
  [4621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2243),
  [4623] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2, 0, 56),
  [4625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2, 0, 56),
  [4627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [4629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5594),
  [4631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1036),
  [4633] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2, 0, 98),
  [4635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2, 0, 98),
  [4637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5578),
  [4639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5595),
  [4641] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 2, 0, 38),
  [4643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 2, 0, 38),
  [4645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [4647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5841),
  [4649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3817),
  [4651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5871),
  [4653] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1, 0, 39),
  [4655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6168),
  [4657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [4659] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1, 0, 0),
  [4661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1, 0, 0),
  [4663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [4665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1, 0, 41),
  [4667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1, 0, 41),
  [4669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2, 0, 78),
  [4671] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_asserts, 2, 0, 0),
  [4673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asserts, 2, 0, 0),
  [4675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1810),
  [4677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2846),
  [4679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1696),
  [4681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2866),
  [4683] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_predefined_type, 2, 0, 105),
  [4685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_predefined_type, 2, 0, 105),
  [4687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1784),
  [4689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2805),
  [4691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1937),
  [4693] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instantiation_expression, 2, 0, 45),
  [4695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instantiation_expression, 2, 0, 45),
  [4697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1800),
  [4699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2828),
  [4701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1639),
  [4703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1589),
  [4705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1579),
  [4707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1700),
  [4709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1571),
  [4711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2877),
  [4713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [4715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1839),
  [4717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6241),
  [4719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6233),
  [4721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2874),
  [4723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(608),
  [4725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [4727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, 0, 165),
  [4729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1261),
  [4731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(607),
  [4733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5323),
  [4735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [4737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [4739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(637),
  [4741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [4743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(642),
  [4745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [4747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(653),
  [4749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(651),
  [4751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [4753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [4755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(150),
  [4757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [4759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(648),
  [4761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [4763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [4765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2030),
  [4767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [4769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [4771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [4773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [4775] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, 0, 43),
  [4777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, 0, 43),
  [4779] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_call_expression, 2, 0, 43),
  [4781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_call_expression, 2, 0, 43),
  [4783] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_existential_type, 1, 0, 0),
  [4785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_existential_type, 1, 0, 0),
  [4787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__number, 2, 0, 34),
  [4789] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__number, 2, 0, 34),
  [4791] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_type, 1, 0, 0),
  [4793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_type, 1, 0, 0),
  [4795] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 1, 0, 0),
  [4797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1, 0, 0),
  [4799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [4801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_type, 1, 0, 42),
  [4803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_type, 1, 0, 42),
  [4805] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_type_identifier, 3, 0, 64),
  [4807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_type_identifier, 3, 0, 64),
  [4809] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_nested_identifier, 3, 0, 63), REDUCE(sym_nested_type_identifier, 3, 0, 64),
  [4812] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_nested_identifier, 3, 0, 66), REDUCE(sym_nested_type_identifier, 3, 0, 64),
  [4815] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2, 0, 57),
  [4817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2, 0, 57),
  [4819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5592),
  [4821] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2, 0, 99),
  [4823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2, 0, 99),
  [4825] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 2, 0, 0),
  [4827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 2, 0, 0),
  [4829] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intersection_type, 2, 0, 0),
  [4831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 2, 0, 0),
  [4833] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 2, 0, 0),
  [4835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 2, 0, 0),
  [4837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1085),
  [4839] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_literal_type, 2, 0, 0),
  [4841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_literal_type, 2, 0, 0),
  [4843] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, 0, 101),
  [4845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, 0, 101),
  [4847] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_readonly_type, 2, 0, 0),
  [4849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_readonly_type, 2, 0, 0),
  [4851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1081),
  [4853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [4855] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_flow_maybe_type, 2, 0, 0),
  [4857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_flow_maybe_type, 2, 0, 0),
  [4859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_infer_type, 2, 0, 104),
  [4861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_infer_type, 2, 0, 104),
  [4863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [4865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_type_query, 2, 0, 0),
  [4867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_type_query, 2, 0, 0),
  [4869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [4871] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, 0, 106),
  [4873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, 0, 106),
  [4875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [4877] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 34),
  [4879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, 0, 34),
  [4881] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 34), SHIFT(150),
  [4884] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_instantiation_expression, 2, 0, 171),
  [4886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_instantiation_expression, 2, 0, 171),
  [4888] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_call_expression, 2, 0, 107),
  [4890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_call_expression, 2, 0, 107),
  [4892] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, 0, 96),
  [4894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, 0, 96),
  [4896] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_instantiation_expression, 2, 0, 172),
  [4898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_instantiation_expression, 2, 0, 172),
  [4900] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_call_expression, 2, 0, 173),
  [4902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_call_expression, 2, 0, 173),
  [4904] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_instantiation_expression, 2, 0, 174),
  [4906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_instantiation_expression, 2, 0, 174),
  [4908] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object, 2, 0, 0), REDUCE(sym_object_type, 2, 0, 0),
  [4911] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_object, 2, 0, 0), REDUCE(sym_object_type, 2, 0, 0),
  [4914] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 2, 0, 0),
  [4916] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_pattern, 2, 0, 0),
  [4918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 2, 0, 0),
  [4920] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 2, 0, 0), REDUCE(sym_tuple_type, 2, 0, 0),
  [4923] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 2, 0, 0), REDUCE(sym_tuple_type, 2, 0, 0),
  [4926] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_as_expression, 3, 0, 0),
  [4928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_as_expression, 3, 0, 0),
  [4930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2826),
  [4932] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type, 3, 0, 0),
  [4934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type, 3, 0, 0),
  [4936] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 3, 0, 0),
  [4938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 3, 0, 0),
  [4940] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_literal_type, 3, 0, 0),
  [4942] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_literal_type, 3, 0, 0),
  [4944] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 3, 0, 178),
  [4946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 3, 0, 178),
  [4948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_sequence_expression_repeat1, 2, 0, 0),
  [4950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intersection_type, 3, 0, 0),
  [4952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 3, 0, 0),
  [4954] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 3, 0, 0),
  [4956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 3, 0, 0),
  [4958] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 3, 0, 0),
  [4960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0),
  [4962] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_satisfies_expression, 3, 0, 0),
  [4964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_satisfies_expression, 3, 0, 0),
  [4966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1943),
  [4968] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, 0, 63),
  [4970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, 0, 63),
  [4972] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, 0, 111),
  [4974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, 0, 111),
  [4976] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, 0, 179),
  [4978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, 0, 179),
  [4980] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, 0, 180),
  [4982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, 0, 180),
  [4984] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, 0, 233),
  [4986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, 0, 233),
  [4988] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, 0, 234),
  [4990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, 0, 234),
  [4992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ternary_expression, 5, 0, 238),
  [4994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 4, 0, 168),
  [4996] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, 0, 181),
  [4998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, 0, 181),
  [5000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 4, 0, 167),
  [5002] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, 0, 182),
  [5004] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, 0, 182),
  [5006] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 4, 0, 0),
  [5008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 4, 0, 0),
  [5010] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 4, 0, 236),
  [5012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 4, 0, 236),
  [5014] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_infer_type, 4, 0, 104),
  [5016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_infer_type, 4, 0, 104),
  [5018] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lookup_type, 4, 0, 0),
  [5020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lookup_type, 4, 0, 0),
  [5022] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 4, 0, 237),
  [5024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 4, 0, 237),
  [5026] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_predicate, 3, 0, 55),
  [5028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_predicate, 3, 0, 55),
  [5030] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_predicate, 3, 0, 240),
  [5032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_predicate, 3, 0, 240),
  [5034] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, 0, 183),
  [5036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, 0, 183),
  [5038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, 0, 162),
  [5040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [5042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6000),
  [5044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5999),
  [5046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [5048] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_augmented_assignment_expression, 3, 0, 110),
  [5050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, 0, 117),
  [5052] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 110),
  [5054] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 110),
  [5056] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, 0, 281),
  [5058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, 0, 281),
  [5060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, 0, 164),
  [5062] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, 0, 282),
  [5064] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, 0, 282),
  [5066] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, 0, 283),
  [5068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, 0, 283),
  [5070] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 5, 0, 0),
  [5072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 5, 0, 0),
  [5074] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 5, 0, 284),
  [5076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 5, 0, 284),
  [5078] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_assertion, 2, 0, 0),
  [5080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_assertion, 2, 0, 0),
  [5082] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 5, 0, 285),
  [5084] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 5, 0, 285),
  [5086] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, 0, 319),
  [5088] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, 0, 319),
  [5090] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, 0, 320),
  [5092] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, 0, 320),
  [5094] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, 0, 321),
  [5096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, 0, 321),
  [5098] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await_expression, 2, 0, 0),
  [5100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await_expression, 2, 0, 0),
  [5102] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2, 0, 0), SHIFT(150),
  [5105] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 110), SHIFT(150),
  [5108] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, 0, 322),
  [5110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, 0, 322),
  [5112] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 6, 0, 323),
  [5114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 6, 0, 323),
  [5116] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, 0, 75),
  [5118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, 0, 76),
  [5120] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_type, 7, 0, 352),
  [5122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_type, 7, 0, 352),
  [5124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 2, 0, 0),
  [5126] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 34),
  [5128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, 0, 34),
  [5130] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 34), SHIFT(150),
  [5133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 3, 0, 0),
  [5135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, 0, 109),
  [5137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, 0, 108),
  [5139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(633),
  [5141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [5143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1402),
  [5145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [5147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(634),
  [5149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [5151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5549),
  [5153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [5155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [5157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(611),
  [5159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [5161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(594),
  [5163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [5165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(519),
  [5167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(435),
  [5169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [5171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [5173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(152),
  [5175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [5177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(425),
  [5179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [5181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [5183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2637),
  [5185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [5187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [5189] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 3, 0, 78),
  [5191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_pattern, 3, 0, 52),
  [5193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 3, 0, 78),
  [5195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 4, 0, 0),
  [5197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 4, 0, 0),
  [5199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(409),
  [5201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, 0, 120),
  [5203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(397),
  [5205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4650),
  [5207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [5209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [5211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(416),
  [5213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [5215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(417),
  [5217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [5219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(419),
  [5221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(420),
  [5223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [5225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [5227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(151),
  [5229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [5231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(423),
  [5233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [5235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [5237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [5239] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 110), SHIFT(151),
  [5242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5665),
  [5244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1034),
  [5246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5666),
  [5248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5667),
  [5250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_spread_element, 2, 0, 0),
  [5252] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 110), SHIFT(152),
  [5255] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, 0, 161),
  [5257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, 0, 161),
  [5259] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, 0, 162),
  [5261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2082),
  [5263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2065),
  [5265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [5267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [5269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_expression, 4, 0, 163),
  [5271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_expression, 4, 0, 163),
  [5273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [5275] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, 0, 164),
  [5277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, 0, 165),
  [5279] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 4, 0, 163),
  [5281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 4, 0, 163),
  [5283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 4, 0, 0),
  [5285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 4, 0, 0),
  [5287] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 166),
  [5289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 166),
  [5291] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 4, 0, 169),
  [5293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 4, 0, 169),
  [5295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2919),
  [5297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__initializer, 2, 0, 54),
  [5299] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__initializer, 2, 0, 54), SHIFT(634),
  [5302] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, 0, 120), REDUCE(sym_assignment_expression, 3, 0, 75),
  [5305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [5307] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, 0, 120), REDUCE(sym_assignment_expression, 3, 0, 108),
  [5310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 2, 0, 0),
  [5312] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym__primary_type, 1, 0, 41),
  [5315] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym__primary_type, 1, 0, 41),
  [5318] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 4, 0, 184),
  [5320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 4, 0, 184),
  [5322] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 2, 0, 37),
  [5324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 2, 0, 37),
  [5326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, 0, 186),
  [5328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, 0, 186),
  [5330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, 0, 187),
  [5332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, 0, 187),
  [5334] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 4, 0, 78),
  [5336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 4, 0, 78),
  [5338] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_string, 2, 0, 0),
  [5340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_string, 2, 0, 0),
  [5342] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, 0, 108), REDUCE(sym_assignment_expression, 3, 0, 108),
  [5345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, 0, 108),
  [5347] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 5, 0, 229),
  [5349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 5, 0, 229),
  [5351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, 0, 119),
  [5353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, 0, 119),
  [5355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 2, 0, 0),
  [5357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, 0, 117),
  [5359] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_glimmer_template, 3, 0, 116),
  [5361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_glimmer_template, 3, 0, 116),
  [5363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, 0, 115),
  [5365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, 0, 115),
  [5367] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 44),
  [5369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, 0, 44),
  [5371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_glimmer_closing_tag, 1, 0, 0),
  [5373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_glimmer_closing_tag, 1, 0, 0),
  [5375] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_glimmer_template, 2, 0, 46),
  [5377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_glimmer_template, 2, 0, 46),
  [5379] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 34), SHIFT(151),
  [5382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, 0, 76),
  [5384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 3, 0, 52),
  [5386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2933),
  [5388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [5390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2932),
  [5392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3934),
  [5394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 3, 0, 0),
  [5396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 3, 0, 0),
  [5398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, 0, 243),
  [5400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, 0, 243),
  [5402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6083),
  [5404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [5406] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_template_string, 2, 0, 0), REDUCE(sym_template_literal_type, 2, 0, 0),
  [5409] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_template_string, 2, 0, 0), REDUCE(sym_template_literal_type, 2, 0, 0),
  [5412] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, 0, 114),
  [5414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, 0, 114),
  [5416] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2, 0, 0), SHIFT(151),
  [5419] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, 0, 109),
  [5421] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_string, 3, 0, 0),
  [5423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_string, 3, 0, 0),
  [5425] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, 0, 95),
  [5427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, 0, 95),
  [5429] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2, 0, 0), SHIFT(152),
  [5432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_meta_property, 3, 0, 0),
  [5434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_property, 3, 0, 0),
  [5436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_expression, 3, 0, 94),
  [5438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_expression, 3, 0, 94),
  [5440] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 34), SHIFT(151),
  [5443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 3, 0, 0),
  [5445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 3, 0, 0),
  [5447] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym_literal_type, 1, 0, 0),
  [5450] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym_literal_type, 1, 0, 0),
  [5453] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 34), SHIFT(152),
  [5456] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 34), SHIFT(152),
  [5459] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, 0, 93),
  [5461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, 0, 93),
  [5463] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, 0, 92),
  [5465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, 0, 92),
  [5467] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 9, 0, 373),
  [5469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 9, 0, 373),
  [5471] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 5, 0, 250),
  [5473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 5, 0, 250),
  [5475] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 5, 0, 122),
  [5477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 5, 0, 122),
  [5479] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 34), SHIFT(155),
  [5482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(654),
  [5484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(606),
  [5486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [5488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [5490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(635),
  [5492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [5494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(628),
  [5496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [5498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(623),
  [5500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(621),
  [5502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [5504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [5506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(155),
  [5508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [5510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(598),
  [5512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [5514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [5516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [5518] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 4, 0, 59),
  [5520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 4, 0, 59),
  [5522] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2, 0, 0), SHIFT(155),
  [5525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, 0, 108),
  [5527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 7, 0, 327),
  [5529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 7, 0, 327),
  [5531] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 1, 0, 0),
  [5533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 1, 0, 0),
  [5535] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 1, 0, 0), SHIFT_REPEAT(2273),
  [5538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2273),
  [5540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2840),
  [5542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2280),
  [5544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2279),
  [5546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2547),
  [5548] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 34), SHIFT(155),
  [5551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [5553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2518),
  [5555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [5557] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object, 3, 0, 78), REDUCE(sym_object_pattern, 3, 0, 52),
  [5560] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 3, 0, 143),
  [5562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 3, 0, 143),
  [5564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [5566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1715),
  [5568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3460),
  [5570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2080),
  [5572] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 8, 0, 354),
  [5574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 8, 0, 354),
  [5576] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 110), SHIFT(155),
  [5579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [5581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [5583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2845),
  [5585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__extends_clause_single, 1, 0, 90),
  [5587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1395),
  [5589] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 9, 0, 374),
  [5591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 9, 0, 374),
  [5593] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 6, 0, 293),
  [5595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 6, 0, 293),
  [5597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1387),
  [5599] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 6, 0, 188),
  [5601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 6, 0, 188),
  [5603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2648),
  [5605] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 7, 0, 328),
  [5607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 7, 0, 328),
  [5609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2089),
  [5611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2951),
  [5613] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 4, 0, 214),
  [5615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 4, 0, 214),
  [5617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [5619] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 154),
  [5621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 154),
  [5623] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 154), SHIFT_REPEAT(2366),
  [5626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2356),
  [5628] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 2, 0, 0), REDUCE(sym_array_pattern, 2, 0, 0),
  [5631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [5633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4843),
  [5635] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 10, 0, 389),
  [5637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 10, 0, 389),
  [5639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [5641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [5643] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_object, 2, 0, 0), REDUCE(sym_object_pattern, 2, 0, 0), REDUCE(sym_object_type, 2, 0, 0),
  [5647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3339),
  [5649] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array, 2, 0, 0), REDUCE(sym_array_pattern, 2, 0, 0), REDUCE(sym_tuple_type, 2, 0, 0),
  [5653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [5655] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 8, 0, 355),
  [5657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 8, 0, 355),
  [5659] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object, 2, 0, 0), REDUCE(sym_object_pattern, 2, 0, 0),
  [5662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [5664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [5666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [5668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [5670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3122),
  [5672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [5674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2, 0, 0),
  [5676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(491),
  [5678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(479),
  [5680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4648),
  [5682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [5684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [5686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(543),
  [5688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [5690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(554),
  [5692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [5694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(561),
  [5696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(569),
  [5698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [5700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [5702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(147),
  [5704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [5706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(583),
  [5708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [5710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [5712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [5714] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 1, 0, 35),
  [5716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 1, 0, 35),
  [5718] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__parameter_name, 1, 0, 35), REDUCE(sym__primary_type, 1, 0, 41),
  [5721] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 34), SHIFT(147),
  [5724] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2, 0, 0), SHIFT(147),
  [5727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3014),
  [5729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3015),
  [5731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2947),
  [5733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1134),
  [5735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1135),
  [5737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [5739] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 34), SHIFT(147),
  [5742] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_static_block, 2, 0, 37),
  [5744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_static_block, 2, 0, 37),
  [5746] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 0),
  [5748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 0),
  [5750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2831),
  [5752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2316),
  [5754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2492),
  [5756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, 0, 121),
  [5758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4443),
  [5760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4448),
  [5762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2839),
  [5764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2667),
  [5766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2832),
  [5768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2502),
  [5770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [5772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2323),
  [5774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [5776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [5778] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 110), SHIFT(147),
  [5781] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 3, 0, 83),
  [5783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 3, 0, 83),
  [5785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1973),
  [5787] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 3, 0, 154),
  [5789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 3, 0, 154),
  [5791] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_pattern, 2, 0, 0), REDUCE(sym_object_type, 2, 0, 0),
  [5794] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym__parameter_name, 1, 0, 35),
  [5797] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym__parameter_name, 1, 0, 35), REDUCE(sym__primary_type, 1, 0, 41),
  [5801] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_pattern, 2, 0, 0), REDUCE(sym_tuple_type, 2, 0, 0),
  [5804] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_static_block, 3, 0, 92),
  [5806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_static_block, 3, 0, 92),
  [5808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5664),
  [5810] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 2, 0, 83),
  [5812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 2, 0, 83),
  [5814] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, 0, 41), REDUCE(sym__parameter_name, 2, 0, 83),
  [5817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [5819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [5821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(495),
  [5823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(505),
  [5825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [5827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [5829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(434),
  [5831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [5833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(432),
  [5835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [5837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(595),
  [5839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(600),
  [5841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [5843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [5845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(149),
  [5847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [5849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(405),
  [5851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [5853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [5855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [5857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(482),
  [5859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(427),
  [5861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [5863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [5865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [5867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(553),
  [5869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [5871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(563),
  [5873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [5875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(568),
  [5877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(574),
  [5879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [5881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [5883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(148),
  [5885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [5887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(576),
  [5889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [5891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [5893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [5895] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 34), SHIFT(148),
  [5898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3482),
  [5900] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2, 0, 0), SHIFT(148),
  [5903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [5905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [5907] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 110), SHIFT(154),
  [5910] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 34), SHIFT(148),
  [5913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_call_expression_in_type_annotation, 2, 0, 43),
  [5915] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 110), SHIFT(148),
  [5918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4529),
  [5920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(469),
  [5922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(466),
  [5924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(494),
  [5926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [5928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(496),
  [5930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [5932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(529),
  [5934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(531),
  [5936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [5938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(154),
  [5940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [5942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(624),
  [5944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [5946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [5948] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 4, 0, 218),
  [5950] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 4, 0, 218),
  [5952] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym_literal_type, 1, 0, 0), REDUCE(sym_rest_pattern, 2, 0, 0),
  [5956] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 4, 0, 216),
  [5958] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 4, 0, 216),
  [5960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [5962] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym__property_name, 1, 0, 0),
  [5965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_name, 1, 0, 0),
  [5967] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym__property_name, 1, 0, 0),
  [5970] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__property_name, 1, 0, 0),
  [5972] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 2, 0, 0), REDUCE(sym_array_pattern, 2, 0, 0),
  [5975] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_object, 2, 0, 0), REDUCE(sym_object_pattern, 2, 0, 0),
  [5978] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_object, 3, 0, 78), REDUCE(sym_object_pattern, 3, 0, 52),
  [5981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4637),
  [5983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4615),
  [5985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [5987] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 3, 0, 0), REDUCE(sym_computed_property_name, 3, 0, 0),
  [5990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_computed_property_name, 3, 0, 0),
  [5992] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 3, 0, 0), REDUCE(sym_computed_property_name, 3, 0, 0),
  [5995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_computed_property_name, 3, 0, 0),
  [5997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1593),
  [5999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1592),
  [6001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1590),
  [6003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2677),
  [6005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4426),
  [6007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [6009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [6011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [6013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [6015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [6017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [6019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6111),
  [6021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [6023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3908),
  [6025] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 110), SHIFT(149),
  [6028] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 2, 0, 86),
  [6030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 2, 0, 86),
  [6032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5215),
  [6034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5576),
  [6036] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 34), SHIFT(149),
  [6039] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2, 0, 0), SHIFT(149),
  [6042] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 5, 0, 261),
  [6044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 5, 0, 261),
  [6046] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 3, 0, 147),
  [6048] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 3, 0, 147),
  [6050] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 34), SHIFT(154),
  [6053] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 3, 0, 151),
  [6055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 3, 0, 151),
  [6057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [6059] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 34), SHIFT(149),
  [6062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2535),
  [6064] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__initializer, 2, 0, 54), SHIFT(466),
  [6067] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2, 0, 0), SHIFT(154),
  [6070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [6072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__extends_clause_single, 2, 0, 159),
  [6074] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 34), SHIFT(154),
  [6077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1586),
  [6079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1591),
  [6081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1588),
  [6083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2810),
  [6085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(471),
  [6087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(486),
  [6089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(458),
  [6091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [6093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(456),
  [6095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [6097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(447),
  [6099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(444),
  [6101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [6103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [6105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(153),
  [6107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [6109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(438),
  [6111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [6113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2821),
  [6115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1683),
  [6117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [6119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [6121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [6123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [6125] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 110), SHIFT(153),
  [6128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1585),
  [6130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2942),
  [6132] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 49), SHIFT_REPEAT(4924),
  [6135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [6137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2944),
  [6139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4673),
  [6141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2980),
  [6143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2977),
  [6145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [6147] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 34), SHIFT(153),
  [6150] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2, 0, 0), SHIFT(153),
  [6153] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 34), SHIFT(153),
  [6156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2108),
  [6158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [6160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [6162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4369),
  [6164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1595),
  [6166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4223),
  [6168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2986),
  [6170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1723),
  [6172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1721),
  [6174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2808),
  [6176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4538),
  [6178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2881),
  [6180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1708),
  [6182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1709),
  [6184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [6186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4270),
  [6188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2862),
  [6190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2543),
  [6192] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 2, 0, 37), REDUCE(sym_class, 3, 0, 119),
  [6195] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 2, 0, 37), REDUCE(sym_class, 3, 0, 119),
  [6198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2338),
  [6200] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 4, 0, 157), REDUCE(sym_class, 5, 0, 241),
  [6203] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 4, 0, 157), REDUCE(sym_class, 5, 0, 241),
  [6206] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 4, 0, 158), REDUCE(sym_class, 5, 0, 242),
  [6209] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 4, 0, 158), REDUCE(sym_class, 5, 0, 242),
  [6212] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 4, 0, 161), REDUCE(sym_class, 5, 0, 243),
  [6215] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 4, 0, 161), REDUCE(sym_class, 5, 0, 243),
  [6218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2440),
  [6220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1614),
  [6222] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 5, 0, 227), REDUCE(sym_class, 6, 0, 286),
  [6225] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 5, 0, 227), REDUCE(sym_class, 6, 0, 286),
  [6228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6325),
  [6230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6327),
  [6232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1643),
  [6234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1607),
  [6236] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 3, 0, 89), REDUCE(sym_class, 4, 0, 185),
  [6239] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 3, 0, 89), REDUCE(sym_class, 4, 0, 185),
  [6242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1663),
  [6244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1664),
  [6246] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 3, 0, 93), REDUCE(sym_class, 4, 0, 187),
  [6249] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 3, 0, 93), REDUCE(sym_class, 4, 0, 187),
  [6252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1636),
  [6254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1610),
  [6256] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 3, 0, 92), REDUCE(sym_class, 4, 0, 186),
  [6259] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 3, 0, 92), REDUCE(sym_class, 4, 0, 186),
  [6262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_object_initializer, 3, 0, 0),
  [6264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_object_initializer, 3, 0, 0),
  [6266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3013),
  [6268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_object_definition, 2, 0, 4),
  [6270] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_object_definition, 2, 0, 4),
  [6272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1767),
  [6274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1771),
  [6276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1856),
  [6278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1877),
  [6280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1802),
  [6282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1855),
  [6284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1844),
  [6286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1813),
  [6288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_object_definition, 2, 0, 5),
  [6290] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_object_definition, 2, 0, 5),
  [6292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1815),
  [6294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1879),
  [6296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1930),
  [6298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1884),
  [6300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_object_initializer, 2, 0, 0),
  [6302] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_object_initializer, 2, 0, 0),
  [6304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(34),
  [6306] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_ui_annotated_object_repeat1, 2, 0, 7),
  [6308] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_ui_annotated_object_repeat1, 2, 0, 7), SHIFT_REPEAT(5512),
  [6311] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 6, 0, 192),
  [6313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 6, 0, 192),
  [6315] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_annotated_object_member, 2, 0, 6),
  [6317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_annotated_object_member, 2, 0, 6),
  [6319] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 5, 0, 124),
  [6321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 5, 0, 124),
  [6323] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_object_array, 4, 0, 0),
  [6325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_object_array, 4, 0, 0),
  [6327] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 5, 0, 134),
  [6329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 5, 0, 134),
  [6331] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 4, 0, 67),
  [6333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 4, 0, 67),
  [6335] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_binding, 3, 0, 26),
  [6337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_binding, 3, 0, 26),
  [6339] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_object_definition_binding, 4, 0, 61),
  [6341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_object_definition_binding, 4, 0, 61),
  [6343] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_object_definition_binding, 4, 0, 60),
  [6345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_object_definition_binding, 4, 0, 60),
  [6347] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 4, 0, 68),
  [6349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 4, 0, 68),
  [6351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_signal, 4, 0, 69),
  [6353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_signal, 4, 0, 69),
  [6355] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_ui_object_initializer_repeat1, 1, 0, 0),
  [6357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ui_object_initializer_repeat1, 1, 0, 0),
  [6359] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 5, 0, 132),
  [6361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 5, 0, 132),
  [6363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 6, 0, 201),
  [6365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 6, 0, 201),
  [6367] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 6, 0, 200),
  [6369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 6, 0, 200),
  [6371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_signal, 3, 0, 15),
  [6373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_signal, 3, 0, 15),
  [6375] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 6, 0, 199),
  [6377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 6, 0, 199),
  [6379] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 5, 0, 123),
  [6381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 5, 0, 123),
  [6383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_required, 3, 0, 27),
  [6385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_required, 3, 0, 27),
  [6387] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 6, 0, 198),
  [6389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 6, 0, 198),
  [6391] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_object_array, 3, 0, 0),
  [6393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_object_array, 3, 0, 0),
  [6395] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qml_enum_body, 4, 0, 197),
  [6397] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qml_enum_body, 4, 0, 197),
  [6399] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 7, 0, 247),
  [6401] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 7, 0, 247),
  [6403] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_ui_object_initializer_repeat1, 1, 0, 9),
  [6405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ui_object_initializer_repeat1, 1, 0, 9),
  [6407] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_required, 3, 0, 15),
  [6409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_required, 3, 0, 15),
  [6411] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 7, 0, 246),
  [6413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 7, 0, 246),
  [6415] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 7, 0, 245),
  [6417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 7, 0, 245),
  [6419] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qml_enum_body, 4, 0, 195),
  [6421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qml_enum_body, 4, 0, 195),
  [6423] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 7, 0, 244),
  [6425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 7, 0, 244),
  [6427] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 6, 0, 190),
  [6429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 6, 0, 190),
  [6431] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qml_enum_declaration, 3, 0, 28),
  [6433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qml_enum_declaration, 3, 0, 28),
  [6435] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 5, 0, 133),
  [6437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 5, 0, 133),
  [6439] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 4, 0, 62),
  [6441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 4, 0, 62),
  [6443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_inline_component, 4, 0, 70),
  [6445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_inline_component, 4, 0, 70),
  [6447] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 6, 0, 191),
  [6449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 6, 0, 191),
  [6451] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 6, 0, 189),
  [6453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 6, 0, 189),
  [6455] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 5, 0, 131),
  [6457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 5, 0, 131),
  [6459] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 5, 0, 127),
  [6461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 5, 0, 127),
  [6463] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_binding, 3, 0, 20),
  [6465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_binding, 3, 0, 20),
  [6467] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 5, 0, 126),
  [6469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 5, 0, 126),
  [6471] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0),
  [6473] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(3096),
  [6476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0),
  [6478] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(6359),
  [6481] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 4, 0, 65),
  [6483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 4, 0, 65),
  [6485] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_annotated_object_member, 2, 0, 17),
  [6487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_annotated_object_member, 2, 0, 17),
  [6489] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qml_enum_body, 3, 0, 15),
  [6491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qml_enum_body, 3, 0, 15),
  [6493] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_object_definition_binding, 4, 0, 51),
  [6495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_object_definition_binding, 4, 0, 51),
  [6497] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qml_enum_body, 3, 0, 130),
  [6499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qml_enum_body, 3, 0, 130),
  [6501] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_object_definition_binding, 4, 0, 50),
  [6503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_object_definition_binding, 4, 0, 50),
  [6505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5520),
  [6507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5516),
  [6509] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property_modifier, 1, 0, 0),
  [6511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [6513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6351),
  [6515] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_ui_property_modifier, 1, 0, 0), SHIFT(5516),
  [6518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3100),
  [6520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_ui_annotated_object_repeat1, 1, 0, 2),
  [6522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ui_annotated_object_repeat1, 1, 0, 2),
  [6524] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_annotation, 3, 0, 14),
  [6526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_annotation, 3, 0, 14),
  [6528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [6530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [6532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [6534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [6536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4019),
  [6538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4018),
  [6540] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_pragma, 3, 0, 15),
  [6542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_pragma, 3, 0, 15),
  [6544] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_import, 3, 0, 11),
  [6546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_import, 3, 0, 11),
  [6548] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_import, 4, 0, 19),
  [6550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_import, 4, 0, 19),
  [6552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5413),
  [6554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5414),
  [6556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3046),
  [6558] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_pragma, 5, 0, 32),
  [6560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_pragma, 5, 0, 32),
  [6562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_import, 5, 0, 29),
  [6564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_import, 5, 0, 29),
  [6566] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_import, 5, 0, 31),
  [6568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_import, 5, 0, 31),
  [6570] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_pragma, 6, 0, 73),
  [6572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_pragma, 6, 0, 73),
  [6574] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_import, 6, 0, 71),
  [6576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_import, 6, 0, 71),
  [6578] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 1, 0, 0),
  [6580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 1, 0, 0),
  [6582] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_import, 3, 0, 13),
  [6584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_import, 3, 0, 13),
  [6586] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_import, 6, 0, 72),
  [6588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_import, 6, 0, 72),
  [6590] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_import, 4, 0, 18),
  [6592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_import, 4, 0, 18),
  [6594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5851),
  [6596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5986),
  [6598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5387),
  [6600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5388),
  [6602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5385),
  [6604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5386),
  [6606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6292),
  [6608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5265),
  [6610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5250),
  [6612] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_list_property_type, 4, 0, 0),
  [6614] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_list_property_type, 4, 0, 125),
  [6616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5263),
  [6618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5264),
  [6620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5381),
  [6622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5382),
  [6624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [6626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5663),
  [6628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5005),
  [6630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5673),
  [6632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4947),
  [6634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5122),
  [6636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6216),
  [6638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3325),
  [6640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3509),
  [6642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3451),
  [6644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 1, 0, 0),
  [6646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [6648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5246),
  [6650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3299),
  [6652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3418),
  [6654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5778),
  [6656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5481),
  [6658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [6660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5777),
  [6662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5470),
  [6664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5675),
  [6666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4991),
  [6668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [6670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3179),
  [6672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6137),
  [6674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6258),
  [6676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6286),
  [6678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6133),
  [6680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6156),
  [6682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [6684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [6686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [6688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5521),
  [6690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5509),
  [6692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [6694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5519),
  [6696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5508),
  [6698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5517),
  [6700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5507),
  [6702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5968),
  [6704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [6706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [6708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6221),
  [6710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6223),
  [6712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [6714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6248),
  [6716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [6718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6235),
  [6720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [6722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6132),
  [6724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6077),
  [6726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [6728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6230),
  [6730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5963),
  [6732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [6734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [6736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6244),
  [6738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6073),
  [6740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5937),
  [6742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6069),
  [6744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6246),
  [6746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6067),
  [6748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [6750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5972),
  [6752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5973),
  [6754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3404),
  [6756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3545),
  [6758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [6760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [6762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 316),
  [6764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4010),
  [6766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [6768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [6770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3427),
  [6772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3861),
  [6774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3436),
  [6776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1126),
  [6778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [6780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, 0, 224),
  [6782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3793),
  [6784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3435),
  [6786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, 0, 155),
  [6788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3847),
  [6790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3402),
  [6792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, 0, 15),
  [6794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3848),
  [6796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [6798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3434),
  [6800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5114),
  [6802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5115),
  [6804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_identifier, 1, 0, 10),
  [6806] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__import_identifier, 1, 0, 10),
  [6808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3781),
  [6810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3430),
  [6812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3957),
  [6814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3419),
  [6816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3782),
  [6818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3452),
  [6820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3792),
  [6822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3422),
  [6824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 1, 0, 16),
  [6826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3873),
  [6828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3408),
  [6830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 270),
  [6832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3800),
  [6834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3439),
  [6836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3950),
  [6838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3410),
  [6840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1713),
  [6842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, 0, 219),
  [6844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3797),
  [6846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3424),
  [6848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [6850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3437),
  [6852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 310),
  [6854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3857),
  [6856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3441),
  [6858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 272),
  [6860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3808),
  [6862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3443),
  [6864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3852),
  [6866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3406),
  [6868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3851),
  [6870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3409),
  [6872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3794),
  [6874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 351),
  [6876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3917),
  [6878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3445),
  [6880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3438),
  [6882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2100),
  [6884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3282),
  [6886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3809),
  [6888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3411),
  [6890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3839),
  [6892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3420),
  [6894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3841),
  [6896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3414),
  [6898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5776),
  [6900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5463),
  [6902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, 0, 15),
  [6904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3444),
  [6906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, 0, 219),
  [6908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3450),
  [6910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, 0, 270),
  [6912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3413),
  [6914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 1, 0, 16),
  [6916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [6918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3407),
  [6920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3429),
  [6922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3416),
  [6924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, 0, 310),
  [6926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3405),
  [6928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3440),
  [6930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3421),
  [6932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [6934] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, 0, 39), REDUCE(sym_type_parameter, 1, 0, 40),
  [6937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [6939] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, 0, 39), SHIFT(1072),
  [6942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6178),
  [6944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [6946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3401),
  [6948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, 0, 219),
  [6950] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, 0, 155),
  [6952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 6, 0, 310),
  [6954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 272),
  [6956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, 0, 16),
  [6958] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, 0, 16),
  [6960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 316),
  [6962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, 0, 270),
  [6964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 224),
  [6966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 219),
  [6968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [6970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [6972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, 0, 15),
  [6974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 270),
  [6976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, 0, 15),
  [6978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 310),
  [6980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 351),
  [6982] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, 0, 39), SHIFT(5685),
  [6985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [6987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1109),
  [6989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [6991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [6993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5523),
  [6995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5084),
  [6997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [6999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5099),
  [7001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3536),
  [7003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6144),
  [7005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6142),
  [7007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3893),
  [7009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 2, 0, 48),
  [7011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [7013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3580),
  [7015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [7017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(334),
  [7019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1137),
  [7021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6307),
  [7023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [7025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3687),
  [7027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3667),
  [7029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3740),
  [7031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3602),
  [7033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1445),
  [7035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5954),
  [7037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3723),
  [7039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, 0, 16),
  [7041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5535),
  [7043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [7045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [7047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6008),
  [7049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3621),
  [7051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3613),
  [7053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4914),
  [7055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4913),
  [7057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_annotation, 2, 0, 0),
  [7059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [7061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3673),
  [7063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 1, 0, 22),
  [7065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3668),
  [7067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3631),
  [7069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3115),
  [7071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3116),
  [7073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6332),
  [7075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_annotation, 2, 0, 56),
  [7077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5811),
  [7079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4799),
  [7081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4363),
  [7083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6160),
  [7085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5136),
  [7087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3642),
  [7089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3608),
  [7091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 344),
  [7093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4012),
  [7095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property_modifier, 1, 0, 0),
  [7097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3116),
  [7099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [7101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [7103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [7105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [7107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression_in_type_annotation, 3, 0, 182),
  [7109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression_in_type_annotation, 3, 0, 181),
  [7111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression_in_type_annotation, 3, 0, 180),
  [7113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression_in_type_annotation, 3, 0, 179),
  [7115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [7117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [7119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 4, 0, 0),
  [7121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 4, 0, 0),
  [7123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 4, 0, 52),
  [7125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3849),
  [7127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3850),
  [7129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [7131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [7133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 372),
  [7135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3789),
  [7137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3791),
  [7139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_annotation, 2, 0, 0),
  [7141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_annotation, 2, 0, 56),
  [7143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5593),
  [7145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 3, 0, 0),
  [7147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 3, 0, 0),
  [7149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3902),
  [7151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3901),
  [7153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3845),
  [7155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3846),
  [7157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [7159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__destructuring_pattern, 1, 0, 0),
  [7161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5589),
  [7163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3942),
  [7165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3941),
  [7167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3837),
  [7169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3838),
  [7171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [7173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3834),
  [7175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3836),
  [7177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3829),
  [7179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3830),
  [7181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5773),
  [7183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5691),
  [7185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3953),
  [7187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3952),
  [7189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3962),
  [7191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3961),
  [7193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3966),
  [7195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3965),
  [7197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1456),
  [7199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [7201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3976),
  [7203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3975),
  [7205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3867),
  [7207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3871),
  [7209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3999),
  [7211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3998),
  [7213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4007),
  [7215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4008),
  [7217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3892),
  [7219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3891),
  [7221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1461),
  [7223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5661),
  [7225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3823),
  [7227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3824),
  [7229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [7231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3820),
  [7233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3821),
  [7235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3814),
  [7237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3816),
  [7239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3810),
  [7241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3811),
  [7243] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression_in_type_annotation, 3, 0, 63),
  [7245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression_in_type_annotation, 3, 0, 111),
  [7247] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression_in_type_annotation, 3, 0, 179),
  [7249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression_in_type_annotation, 3, 0, 180),
  [7251] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression_in_type_annotation, 3, 0, 181),
  [7253] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression_in_type_annotation, 3, 0, 182),
  [7255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3888),
  [7257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3887),
  [7259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5020),
  [7261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3879),
  [7263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3878),
  [7265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4001),
  [7267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4005),
  [7269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3777),
  [7271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3788),
  [7273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3786),
  [7275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3785),
  [7277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3992),
  [7279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3993),
  [7281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3990),
  [7283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4009),
  [7285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3971),
  [7287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3985),
  [7289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3958),
  [7291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3959),
  [7293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5198),
  [7295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3930),
  [7297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3931),
  [7299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3928),
  [7301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3929),
  [7303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3912),
  [7305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3913),
  [7307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3909),
  [7309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3910),
  [7311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3899),
  [7313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3900),
  [7315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3894),
  [7317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3895),
  [7319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3889),
  [7321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3890),
  [7323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3885),
  [7325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3886),
  [7327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3877),
  [7329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3880),
  [7331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5541),
  [7333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3863),
  [7335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3862),
  [7337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6018),
  [7339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_annotation, 2, 0, 57),
  [7341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5810),
  [7343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4725),
  [7345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2445),
  [7347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [7349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4831),
  [7351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [7353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [7355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [7357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opting_type_annotation, 2, 0, 0),
  [7359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_adding_type_annotation, 2, 0, 0),
  [7361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2269),
  [7363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_omitting_type_annotation, 2, 0, 0),
  [7365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2362),
  [7367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [7369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6108),
  [7371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5977),
  [7373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2722),
  [7375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2652),
  [7377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2767),
  [7379] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_call_expression_in_type_annotation, 2, 0, 107),
  [7381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_call_expression_in_type_annotation, 2, 0, 107),
  [7383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_call_expression_in_type_annotation, 2, 0, 43),
  [7385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2467),
  [7387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6109),
  [7389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2051),
  [7391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6229),
  [7393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5678),
  [7395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3775),
  [7397] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 4, 0, 280),
  [7399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, 0, 372),
  [7401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [7403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3447),
  [7405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1237),
  [7407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5186),
  [7409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4816),
  [7411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [7413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4312),
  [7415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6116),
  [7417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4626),
  [7419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4156),
  [7421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_chain, 1, 0, 0),
  [7423] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, -1, 0), SHIFT(603),
  [7426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4629),
  [7428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4142),
  [7430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3175),
  [7432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 3, 0, 232),
  [7434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 3, 0, 231),
  [7436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 2, 0, 210),
  [7438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4786),
  [7440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 2, 0, 210),
  [7442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1946),
  [7444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2782),
  [7446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6347),
  [7448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 5, 0, 301),
  [7450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 2, 0, 170),
  [7452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [7454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4321),
  [7456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3531),
  [7458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3532),
  [7460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4635),
  [7462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4083),
  [7464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 5, 0, 302),
  [7466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4516),
  [7468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4080),
  [7470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, 0, 100),
  [7472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [7474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4390),
  [7476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4092),
  [7478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 1, 0, 40),
  [7480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1701),
  [7482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3769),
  [7484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6356),
  [7486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [7488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6191),
  [7490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3915),
  [7492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3125),
  [7494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4327),
  [7496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4074),
  [7498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [7500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 1, 0, 36),
  [7502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4072),
  [7504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [7506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4318),
  [7508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4070),
  [7510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4665),
  [7512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4043),
  [7514] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, -1, 0), SHIFT(489),
  [7517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 2, 0, 0),
  [7519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4284),
  [7521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4051),
  [7523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4595),
  [7525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4042),
  [7527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_annotation, 2, 0, 57),
  [7529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5597),
  [7531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 3, 0, 0),
  [7533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4496),
  [7535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4038),
  [7537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4488),
  [7539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4037),
  [7541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3196),
  [7543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 2, 0, 153),
  [7545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 5, 0, 0),
  [7547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 4, 0, 0),
  [7549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 3, 0, 208),
  [7551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 3, 0, 223),
  [7553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 4, 0, 262),
  [7555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 4, 0, 253),
  [7557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 9, 0, 391),
  [7559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 6, 0, 337),
  [7561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 8, 0, 382),
  [7563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 8, 0, 377),
  [7565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 6, 0, 336),
  [7567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 7, 0, 356),
  [7569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 7, 0, 357),
  [7571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 344),
  [7573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [7575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2238),
  [7577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [7579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6317),
  [7581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6342),
  [7583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3098),
  [7585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5955),
  [7587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4692),
  [7589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6339),
  [7591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3107),
  [7593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5952),
  [7595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6186),
  [7597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [7599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2958),
  [7601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4579),
  [7603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5514),
  [7605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4702),
  [7607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6326),
  [7609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [7611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3584),
  [7613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [7615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3579),
  [7617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4688),
  [7619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4231),
  [7621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 3, 0, 118),
  [7623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_predicate_annotation, 2, 0, 0),
  [7625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asserts_annotation, 2, 0, 0),
  [7627] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(470),
  [7630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4482),
  [7632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4486),
  [7634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_expression, 2, 0, 0),
  [7636] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_ui_property_repeat1, 2, 0, 0), SHIFT_REPEAT(4688),
  [7639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ui_property_repeat1, 2, 0, 0),
  [7641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4352),
  [7643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4583),
  [7645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4594),
  [7647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 2, 0, 47),
  [7649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2639),
  [7651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [7653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [7655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5677),
  [7657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [7659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [7661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3095),
  [7663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3542),
  [7665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6217),
  [7667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4329),
  [7669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [7671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [7673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [7675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [7677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [7679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2559),
  [7681] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 49), SHIFT_REPEAT(5419),
  [7684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [7686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [7688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [7690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3349),
  [7692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [7694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3364),
  [7696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [7698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3661),
  [7700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4396),
  [7702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [7704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3712),
  [7706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4393),
  [7708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 2, 0, 36),
  [7710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implements_clause, 2, 0, 0),
  [7712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [7714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4427),
  [7716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [7718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [7720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6127),
  [7722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2912),
  [7724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [7726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5009),
  [7728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [7730] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2, 0, 0), SHIFT_REPEAT(4725),
  [7733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2, 0, 0),
  [7735] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2, 0, 0), SHIFT_REPEAT(388),
  [7738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4445),
  [7740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4507),
  [7742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_type_member, 1, 0, 0),
  [7744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5687),
  [7746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [7748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3591),
  [7750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6159),
  [7752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [7754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [7756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [7758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4531),
  [7760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4508),
  [7762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [7764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2914),
  [7766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4885),
  [7768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4530),
  [7770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [7772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4195),
  [7774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [7776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4266),
  [7778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4546),
  [7780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [7782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1933),
  [7784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [7786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1931),
  [7788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [7790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [7792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 2, 0, 0),
  [7794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4681),
  [7796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5824),
  [7798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4582),
  [7800] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 2, 0, 211),
  [7802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 2, 0, 211),
  [7804] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2, 0, 0), SHIFT_REPEAT(6127),
  [7807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2, 0, 0),
  [7809] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2, 0, 0), SHIFT_REPEAT(321),
  [7812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4675),
  [7814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4623),
  [7816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [7818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4620),
  [7820] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_type_repeat1, 2, 0, 0), SHIFT_REPEAT(1365),
  [7823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_type_repeat1, 2, 0, 0),
  [7825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4567),
  [7827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [7829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [7831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [7833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4569),
  [7835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4571),
  [7837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4592),
  [7839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4574),
  [7841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3091),
  [7843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3521),
  [7845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4558),
  [7847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4614),
  [7849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [7851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4585),
  [7853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4520),
  [7855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [7857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4632),
  [7859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [7861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4526),
  [7863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4470),
  [7865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4355),
  [7867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4343),
  [7869] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, 0, 210),
  [7871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, 0, 210),
  [7873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [7875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4328),
  [7877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [7879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3481),
  [7881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4337),
  [7883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [7885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4446),
  [7887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4307),
  [7889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3092),
  [7891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3525),
  [7893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6180),
  [7895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2067),
  [7897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [7899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2417),
  [7901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [7903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2408),
  [7905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4385),
  [7907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4350),
  [7909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2010),
  [7911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4235),
  [7913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4462),
  [7915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4221),
  [7917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4220),
  [7919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 368),
  [7921] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, 0, 48), SHIFT(1048),
  [7924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 346),
  [7926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 350),
  [7928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3600),
  [7930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [7932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5192),
  [7934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 371),
  [7936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 365),
  [7938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [7940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6350),
  [7942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3114),
  [7944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 362),
  [7946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 7, 0, 360),
  [7948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3559),
  [7950] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 7, 0, 359),
  [7952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 6, 0, 343),
  [7954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 6, 0, 340),
  [7956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3117),
  [7958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5987),
  [7960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6313),
  [7962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3933),
  [7964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_nested_identifier, 3, 0, 0),
  [7966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, 0, 25),
  [7968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_nested_identifier, 3, 0, 10),
  [7970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4476),
  [7972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4478),
  [7974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4477),
  [7976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5270),
  [7978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5558),
  [7980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4679),
  [7982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4656),
  [7984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4654),
  [7986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3236),
  [7988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1808),
  [7990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 9, 0, 394),
  [7992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1776),
  [7994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6152),
  [7996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 343),
  [7998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 340),
  [8000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, 0, 335),
  [8002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_signature, 1, 0, 97),
  [8004] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, 0, 22), SHIFT(1050),
  [8007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3276),
  [8009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, 0, 334),
  [8011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 3, 0, 0),
  [8013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, 0, 332),
  [8015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6002),
  [8017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 5, 0, 318),
  [8019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, 0, 308),
  [8021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, 0, 304),
  [8023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4272),
  [8025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [8027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4799),
  [8029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 314),
  [8031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, 0, 385),
  [8033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4391),
  [8035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 312),
  [8037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3024),
  [8039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3026),
  [8041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3025),
  [8043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4230),
  [8045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2735),
  [8047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4457),
  [8049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4493),
  [8051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2982),
  [8053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2971),
  [8055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2978),
  [8057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [8059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [8061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [8063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, 0, 388),
  [8065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, 0, 25),
  [8067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2284),
  [8069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, 0, 25),
  [8071] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, 0, 22), SHIFT(1108),
  [8074] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, 0, 48), SHIFT(1049),
  [8077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3500),
  [8079] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_type, 2, 0, 0),
  [8081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2386),
  [8083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4999),
  [8085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_literal_type_repeat1, 2, 0, 0),
  [8087] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_literal_type_repeat1, 2, 0, 0), SHIFT_REPEAT(1075),
  [8090] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_literal_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5192),
  [8093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_type, 2, 0, 0),
  [8095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2, 0, 56),
  [8097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2, 0, 0),
  [8099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3535),
  [8101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [8103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [8105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 4, 0, 0),
  [8107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [8109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [8111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [8113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2746),
  [8115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [8117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 5, 0, 309),
  [8119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, 0, 221),
  [8121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, 0, 55),
  [8123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, 0, 226),
  [8125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 308),
  [8127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 7, 0, 362),
  [8129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_implements_clause_repeat1, 2, 0, 0),
  [8131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 8, 0, 375),
  [8133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 3, 0, 230),
  [8135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, 0, 221),
  [8137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 304),
  [8139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 8, 0, 376),
  [8141] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, 0, 22), SHIFT(1043),
  [8144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, 0, 55),
  [8146] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, 0, 48), SHIFT(1122),
  [8149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 5, 0, 0),
  [8151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3454),
  [8153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, 0, 380),
  [8155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [8157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2946),
  [8159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, 0, 24),
  [8161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [8163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [8165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [8167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [8169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, 0, 211),
  [8171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, 0, 211),
  [8173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [8175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2998),
  [8177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [8179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mapped_type_clause, 3, 0, 263),
  [8181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 4, 0, 279),
  [8183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, 0, 268),
  [8185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, 0, 266),
  [8187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 266),
  [8189] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, 0, 48), SHIFT(1171),
  [8192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 4, 0, 264),
  [8194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 4, 0, 278),
  [8196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 274),
  [8198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2711),
  [8200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3017),
  [8202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 268),
  [8204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2995),
  [8206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 276),
  [8208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [8210] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, 0, 22), SHIFT(1073),
  [8213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [8215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3165),
  [8217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5460),
  [8219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5458),
  [8221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3597),
  [8223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [8225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ui_property_repeat1, 1, 0, 0),
  [8227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [8229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3581),
  [8231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_version_specifier, 1, 0, 12),
  [8233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6323),
  [8235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3158),
  [8237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [8239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [8241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4710),
  [8243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3948),
  [8245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2904),
  [8247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3490),
  [8249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3923),
  [8251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6247),
  [8253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5475),
  [8255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4265),
  [8257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3043),
  [8259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [8261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0),
  [8263] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0), SHIFT_REPEAT(5460),
  [8266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(232),
  [8268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(234),
  [8270] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2, 0, 0),
  [8272] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat2, 2, 0, 0), SHIFT_REPEAT(5458),
  [8275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4721),
  [8277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3101),
  [8279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5551),
  [8281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2031),
  [8283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2611),
  [8285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3548),
  [8287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [8289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3925),
  [8291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [8293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2897),
  [8295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5628),
  [8297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3000),
  [8299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2999),
  [8301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3630),
  [8303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [8305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3104),
  [8307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3108),
  [8309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5262),
  [8311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1857),
  [8313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [8315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [8317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 1, 0, 0),
  [8319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1806),
  [8321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [8323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 2, 0, 52),
  [8325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(812),
  [8327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [8329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3344),
  [8331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2967),
  [8333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(810),
  [8335] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(3948),
  [8338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2, 0, 0),
  [8340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2964),
  [8342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2963),
  [8344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5150),
  [8346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5618),
  [8348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3080),
  [8350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2960),
  [8352] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_ui_pragma_repeat1, 2, 0, 74), SHIFT_REPEAT(4721),
  [8355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ui_pragma_repeat1, 2, 0, 74),
  [8357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2957),
  [8359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5144),
  [8361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [8363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [8365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [8367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [8369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3753),
  [8371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [8373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3662),
  [8375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [8377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3754),
  [8379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1730),
  [8381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1725),
  [8383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 2, 0, 85),
  [8385] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2, 0, 0), SHIFT_REPEAT(265),
  [8388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 2, 0, 91),
  [8390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [8392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3763),
  [8394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3089),
  [8396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [8398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3765),
  [8400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1642),
  [8402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3273),
  [8404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, 0, 103),
  [8406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 3, 0, 257),
  [8408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 3, 0, 257),
  [8410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mapped_type_clause, 5, 0, 333),
  [8412] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 3, 0, 256),
  [8414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 3, 0, 256),
  [8416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1640),
  [8418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [8420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4506),
  [8422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [8424] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(411),
  [8427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4160),
  [8429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3528),
  [8431] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, 0, 295),
  [8433] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, 0, 295), SHIFT_REPEAT(4786),
  [8436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, 0, 295),
  [8438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, 0, 15),
  [8440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [8442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [8444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5474),
  [8446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [8448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module_export_name, 1, 0, 0),
  [8450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [8452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [8454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3586),
  [8456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [8458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(923),
  [8460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3685),
  [8462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(924),
  [8464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2330),
  [8466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3683),
  [8468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [8470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [8472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [8474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3855),
  [8476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4659),
  [8478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 3, 0, 149),
  [8480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 3, 0, 160),
  [8482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2252),
  [8484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1034),
  [8486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4438),
  [8488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4429),
  [8490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3, 0, 176),
  [8492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3464),
  [8494] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 1, 0, 0), REDUCE(aux_sym_template_literal_type_repeat1, 1, 0, 0),
  [8497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [8499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1932),
  [8501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [8503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2416),
  [8505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2898),
  [8507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2903),
  [8509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [8511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3210),
  [8513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4564),
  [8515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_substitution, 3, 0, 0),
  [8517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2, 0, 228),
  [8519] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2, 0, 228), SHIFT_REPEAT(358),
  [8522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3755),
  [8524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4251),
  [8526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2926),
  [8528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2927),
  [8530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2928),
  [8532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3128),
  [8534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3756),
  [8536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3127),
  [8538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4200),
  [8540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [8542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [8544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2925),
  [8546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4483),
  [8548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [8550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [8552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, 0, 383),
  [8554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, 0, 384),
  [8556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3111),
  [8558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5887),
  [8560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, 0, 58),
  [8562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1936),
  [8564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 369),
  [8566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, 0, 222),
  [8568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, 0, 220),
  [8570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 3, 0, 208),
  [8572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 370),
  [8574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 367),
  [8576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4078),
  [8578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 311),
  [8580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 347),
  [8582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [8584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5850),
  [8586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 307),
  [8588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1971),
  [8590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 5, 0, 301),
  [8592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5390),
  [8594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6057),
  [8596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 5, 0, 302),
  [8598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2718),
  [8600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [8602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 303),
  [8604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 345),
  [8606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 313),
  [8608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [8610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3529),
  [8612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, 0, 386),
  [8614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5809),
  [8616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5105),
  [8618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2008),
  [8620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 315),
  [8622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3724),
  [8624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 3, 0, 0),
  [8626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2561),
  [8628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4630),
  [8630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_specifier, 2, 0, 15),
  [8632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__from_clause, 2, 0, 13),
  [8634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 366),
  [8636] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__qml_enum_body_repeat1, 2, 0, 196), SHIFT_REPEAT(5618),
  [8639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__qml_enum_body_repeat1, 2, 0, 196),
  [8641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__qml_enum_body_repeat1, 2, 0, 15),
  [8643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3573),
  [8645] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_ui_signal_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(4788),
  [8648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ui_signal_parameters_repeat1, 2, 0, 0),
  [8650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [8652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5643),
  [8654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [8656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3463),
  [8658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_signal_parameter, 3, 0, 193),
  [8660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3574),
  [8662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2188),
  [8664] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(5013),
  [8667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2, 0, 0),
  [8669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3137),
  [8671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3265),
  [8673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3141),
  [8675] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_implements_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(1150),
  [8678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5876),
  [8680] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2, 0, 0), SHIFT_REPEAT(1030),
  [8683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [8685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4056),
  [8687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 306),
  [8689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3575),
  [8691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 305),
  [8693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2, 0, 57),
  [8695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [8697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [8699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [8701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 349),
  [8703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4795),
  [8705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5445),
  [8707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [8709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3458),
  [8711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5679),
  [8713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5812),
  [8715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, 0, 378),
  [8717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3152),
  [8719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3244),
  [8721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3154),
  [8723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3587),
  [8725] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2, 0, 0), SHIFT_REPEAT(987),
  [8728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2, 0, 0),
  [8730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5878),
  [8732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_type, 3, 0, 0),
  [8734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3164),
  [8736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3272),
  [8738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3132),
  [8740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5877),
  [8742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3163),
  [8744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3275),
  [8746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3139),
  [8748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5730),
  [8750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [8752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2, 0, 91),
  [8754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, 0, 387),
  [8756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5888),
  [8758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 4, 0, 0),
  [8760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implements_clause, 3, 0, 0),
  [8762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [8764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2253),
  [8766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [8768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [8770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, 0, 24),
  [8772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [8774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1754),
  [8776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [8778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [8780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [8782] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_ui_object_array_repeat1, 2, 0, 0), SHIFT_REPEAT(3111),
  [8785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ui_object_array_repeat1, 2, 0, 0),
  [8787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [8789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3968),
  [8791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 317),
  [8793] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(207),
  [8796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2, 0, 0),
  [8798] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3757),
  [8801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2, 0, 0),
  [8803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2045),
  [8805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 1, 0, 0),
  [8807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [8809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2340),
  [8811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5832),
  [8813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3004),
  [8815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5833),
  [8817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3005),
  [8819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [8821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5835),
  [8823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [8825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [8827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3389),
  [8829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3243),
  [8831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3394),
  [8833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3123),
  [8835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4909),
  [8837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [8839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2321),
  [8841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, 0, 379),
  [8843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, 0, 381),
  [8845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4354),
  [8847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3533),
  [8849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6058),
  [8851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_identifier, 1, 0, 0),
  [8853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [8855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2737),
  [8857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4455),
  [8859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2842),
  [8861] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, 0, 196), SHIFT_REPEAT(2760),
  [8864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, 0, 196),
  [8866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6064),
  [8868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4890),
  [8870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 9, 0, 395),
  [8872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [8874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 338),
  [8876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [8878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3674),
  [8880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4498),
  [8882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_specifier, 1, 0, 16),
  [8884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [8886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3666),
  [8888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3699),
  [8890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4923),
  [8892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2743),
  [8894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4361),
  [8896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 2, 0, 0),
  [8898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2753),
  [8900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4319),
  [8902] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2, 0, 0), SHIFT_REPEAT(3708),
  [8905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2, 0, 0),
  [8907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [8909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [8911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3049),
  [8913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3055),
  [8915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6085),
  [8917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5697),
  [8919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4788),
  [8921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5696),
  [8923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4940),
  [8925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [8927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair_pattern, 3, 0, 121),
  [8929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_require_clause, 6, 0, 324),
  [8931] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_glimmer_template_repeat1, 2, 0, 0), SHIFT_REPEAT(5551),
  [8934] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_glimmer_template_repeat1, 2, 0, 0),
  [8936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4842),
  [8938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [8940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [8942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [8944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, 0, 225),
  [8946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2688),
  [8948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2976),
  [8950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2699),
  [8952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2979),
  [8954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2733),
  [8956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [8958] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_literal_type_repeat1, 1, 0, 0),
  [8960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [8962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3274),
  [8964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2732),
  [8966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [8968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 9, 0, 390),
  [8970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 5, 0, 0),
  [8972] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, -1, 0), SHIFT(515),
  [8975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 9, 0, 392),
  [8977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3031),
  [8979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2629),
  [8981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4097),
  [8983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 342),
  [8985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [8987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 339),
  [8989] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2, 0, 0), SHIFT_REPEAT(1682),
  [8992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2, 0, 0),
  [8994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2600),
  [8996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 9, 0, 393),
  [8998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 341),
  [9000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 273),
  [9002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5087),
  [9004] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 10, 0, 396),
  [9006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [9008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3068),
  [9010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [9012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2489),
  [9014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 348),
  [9016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 6, 0, 336),
  [9018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5248),
  [9020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5425),
  [9022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ui_pragma_repeat1, 2, 0, 54),
  [9024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3032),
  [9026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [9028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3061),
  [9030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [9032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3040),
  [9034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [9036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4782),
  [9038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4339),
  [9040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3082),
  [9042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5616),
  [9044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5613),
  [9046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5158),
  [9048] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, 0, 58),
  [9050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4701),
  [9052] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, 0, 55),
  [9054] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(247),
  [9057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_pattern_repeat1, 2, 0, 0),
  [9059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3906),
  [9061] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(1645),
  [9064] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 2, 0, 0),
  [9066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3907),
  [9068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 6, 0, 337),
  [9070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 265),
  [9072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3911),
  [9074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2717),
  [9076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3016),
  [9078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [9080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1807),
  [9082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [9084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1081),
  [9086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [9088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [9090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [9092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [9094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3384),
  [9096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [9098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3380),
  [9100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [9102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5591),
  [9104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 267),
  [9106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_heritage, 1, 0, 0),
  [9108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3048),
  [9110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [9112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [9114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5221),
  [9116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3356),
  [9118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2427),
  [9120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 275),
  [9122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5567),
  [9124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [9126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5566),
  [9128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [9130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [9132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5565),
  [9134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3007),
  [9136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_version_specifier, 3, 0, 30),
  [9138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3037),
  [9140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [9142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3033),
  [9144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [9146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5557),
  [9148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3077),
  [9150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [9152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3063),
  [9154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [9156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [9158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 269),
  [9160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3926),
  [9162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 277),
  [9164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3935),
  [9166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5159),
  [9168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [9170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 4, 0, 253),
  [9172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 4, 0, 262),
  [9174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 271),
  [9176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [9178] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 3, 0, 0),
  [9180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1736),
  [9182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6316),
  [9184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3099),
  [9186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [9188] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 1, 0, 0),
  [9190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_repeat2, 1, 0, 0),
  [9192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 1, 0, 0),
  [9194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 1, 0, 0),
  [9196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6321),
  [9198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3110),
  [9200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3249),
  [9202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3241),
  [9204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3248),
  [9206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 358),
  [9208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 361),
  [9210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3253),
  [9212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3264),
  [9214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3252),
  [9216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 363),
  [9218] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 4, 0, 0),
  [9220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 5, 0, 0),
  [9222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 364),
  [9224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3257),
  [9226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3266),
  [9228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3256),
  [9230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 7, 0, 356),
  [9232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3097),
  [9234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4698),
  [9236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3262),
  [9238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3268),
  [9240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3260),
  [9242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [9244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3598),
  [9246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6337),
  [9248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [9250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3605),
  [9252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [9254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3609),
  [9256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [9258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3383),
  [9260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3267),
  [9262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3377),
  [9264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3346),
  [9266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3247),
  [9268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3336),
  [9270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3373),
  [9272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3231),
  [9274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3382),
  [9276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2991),
  [9278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2992),
  [9280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [9282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5491),
  [9284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4225),
  [9286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6334),
  [9288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4260),
  [9290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6294),
  [9292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4484),
  [9294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6340),
  [9296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4490),
  [9298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6338),
  [9300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3351),
  [9302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3348),
  [9304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3052),
  [9306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3337),
  [9308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3365),
  [9310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5538),
  [9312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3340),
  [9314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3385),
  [9316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3102),
  [9318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3103),
  [9320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4591),
  [9322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_simple_nested_identifier, 3, 0, 0),
  [9324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [9326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_glimmer_opening_tag, 1, 0, 0),
  [9328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4603),
  [9330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3038),
  [9332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4741),
  [9334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3105),
  [9336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3109),
  [9338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [9340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [9342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4077),
  [9344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__formal_parameter, 1, 0, 0),
  [9346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [9348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1420),
  [9350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [9352] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_glimmer_template_repeat1, 1, 0, 0),
  [9354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3119),
  [9356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_signal_parameters, 2, 0, 0),
  [9358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4372),
  [9360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6134),
  [9362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4813),
  [9364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_clause, 1, 0, 0),
  [9366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [9368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [9370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [9372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2698),
  [9374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 2, 0, 84),
  [9376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1838),
  [9378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1840),
  [9380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [9382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [9384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, 0, 102),
  [9386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3691),
  [9388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3692),
  [9390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1847),
  [9392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1849),
  [9394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3693),
  [9396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3694),
  [9398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1834),
  [9400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1835),
  [9402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1832),
  [9404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [9406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3695),
  [9408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3696),
  [9410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4456),
  [9412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3058),
  [9414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3066),
  [9416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3028),
  [9418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_signal_parameter, 2, 0, 128),
  [9420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_signal_parameter, 2, 0, 129),
  [9422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4528),
  [9424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_signal_parameters, 3, 0, 0),
  [9426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4932),
  [9428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [9430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [9432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4499),
  [9434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6146),
  [9436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [9438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [9440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [9442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [9444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_specifier, 1, 0, 16),
  [9446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [9448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [9450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [9452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3067),
  [9454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 3, 0, 148),
  [9456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 3, 0, 150),
  [9458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4522),
  [9460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4523),
  [9462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4525),
  [9464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [9466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [9468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3140),
  [9470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3142),
  [9472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2346),
  [9474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2344),
  [9476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2355),
  [9478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2352),
  [9480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2379),
  [9482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2372),
  [9484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2394),
  [9486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2391),
  [9488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2700),
  [9490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4670),
  [9492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4666),
  [9494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4671),
  [9496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4653),
  [9498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4641),
  [9500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4638),
  [9502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3134),
  [9504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3135),
  [9506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3131),
  [9508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3150),
  [9510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3828),
  [9512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3827),
  [9514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3835),
  [9516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3832),
  [9518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3843),
  [9520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3842),
  [9522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3, 0, 175),
  [9524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_parameter, 2, 0, 25),
  [9526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type, 2, 0, 0),
  [9528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3, 0, 177),
  [9530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [9532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [9534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_signal_parameter, 3, 0, 55),
  [9536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_signal_parameters, 4, 0, 0),
  [9538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qml_enum_assignment, 3, 0, 26),
  [9540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qml_enum_assignment, 3, 0, 194),
  [9542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__qml_enum_body_repeat1, 2, 0, 130),
  [9544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3057),
  [9546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3054),
  [9548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3053),
  [9550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3050),
  [9552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [9554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [9556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4909),
  [9558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [9560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [9562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_specifier, 2, 0, 15),
  [9564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [9566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [9568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_attribute, 2, 0, 0),
  [9570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 4, 0, 217),
  [9572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3010),
  [9574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3009),
  [9576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3006),
  [9578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3001),
  [9580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2994),
  [9582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2993),
  [9584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2989),
  [9586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 4, 0, 235),
  [9588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_tuple_parameter, 3, 0, 55),
  [9590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1427),
  [9592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [9594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3251),
  [9596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3250),
  [9598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3255),
  [9600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3254),
  [9602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3259),
  [9604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3258),
  [9606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qml_enum_negative_number, 2, 0, 34),
  [9608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_specifier, 3, 0, 249),
  [9610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [9612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2738),
  [9614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2965),
  [9616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2955),
  [9618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2954),
  [9620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2953),
  [9622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2952),
  [9624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2943),
  [9626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2922),
  [9628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [9630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [9632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3565),
  [9634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3564),
  [9636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3567),
  [9638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3566),
  [9640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3569),
  [9642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3568),
  [9644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_specifier, 3, 0, 252),
  [9646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_specifier, 3, 0, 249),
  [9648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2931),
  [9650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2924),
  [9652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [9654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [9656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_assignment, 2, 0, 24),
  [9658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4862),
  [9660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5390),
  [9662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [9664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [9666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4172),
  [9668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3003),
  [9670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_specifier, 4, 0, 287),
  [9672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_specifier, 4, 0, 289),
  [9674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_specifier, 4, 0, 287),
  [9676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, 0, 0),
  [9678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3161),
  [9680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6065),
  [9682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [9684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [9686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [9688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [9690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [9692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [9694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [9696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2848),
  [9698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [9700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [9702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4252),
  [9704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5165),
  [9706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 5, 0, 0),
  [9708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4255),
  [9710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [9712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6084),
  [9714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5710),
  [9716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6093),
  [9718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3156),
  [9720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3157),
  [9722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3130),
  [9724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3869),
  [9726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5683),
  [9728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3159),
  [9730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3160),
  [9732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3367),
  [9734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3162),
  [9736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3368),
  [9738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3149),
  [9740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3153),
  [9742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3151),
  [9744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [9746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3672),
  [9748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5669),
  [9750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3669),
  [9752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [9754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [9756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2075),
  [9758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3745),
  [9760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [9762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5658),
  [9764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [9766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3660),
  [9768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5931),
  [9770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2345),
  [9772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3499),
  [9774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3655),
  [9776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3417),
  [9778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [9780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [9782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [9784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3507),
  [9786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2013),
  [9788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2012),
  [9790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3665),
  [9792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3725),
  [9794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [9796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5767),
  [9798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 4, 0, 0),
  [9800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [9802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [9804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [9806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [9808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [9810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3648),
  [9812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5792),
  [9814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5794),
  [9816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3596),
  [9818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [9820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [9822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [9824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3146),
  [9826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3145),
  [9828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3144),
  [9830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3143),
  [9832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3138),
  [9834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3136),
  [9836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3133),
  [9838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3155),
  [9840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3147),
  [9842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3148),
  [9844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [9846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [9848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3749),
  [9850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3227),
  [9852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3225),
  [9854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3224),
  [9856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3181),
  [9858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3222),
  [9860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3221),
  [9862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [9864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3220),
  [9866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [9868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3219),
  [9870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [9872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [9874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [9876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [9878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3218),
  [9880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_clause, 3, 0, 0),
  [9882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3217),
  [9884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [9886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5141),
  [9888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 3, 0, 0),
  [9890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5827),
  [9892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [9894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5113),
  [9896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3805),
  [9898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6057),
  [9900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_import, 3, 0, 0),
  [9902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6170),
  [9904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3206),
  [9906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6176),
  [9908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3203),
  [9910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3202),
  [9912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5989),
  [9914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3201),
  [9916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3200),
  [9918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3199),
  [9920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_export, 3, 0, 0),
  [9922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5970),
  [9924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3194),
  [9926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3193),
  [9928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3192),
  [9930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3197),
  [9932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [9934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2347),
  [9936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2348),
  [9938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5784),
  [9940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [9942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [9944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [9946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [9948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2754),
  [9950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2385),
  [9952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2392),
  [9954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [9956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2106),
  [9958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [9960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6308),
  [9962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [9964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6320),
  [9966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [9968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [9970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [9972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [9974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3859),
  [9976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3860),
  [9978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [9980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2751),
  [9982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [9984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [9986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2305),
  [9988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6044),
  [9990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2303),
  [9992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2301),
  [9994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3113),
  [9996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3752),
  [9998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2300),
  [10000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2299),
  [10002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6177),
  [10004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2298),
  [10006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2234),
  [10008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2293),
  [10010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [10012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3711),
  [10014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2292),
  [10016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3363),
  [10018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2278),
  [10020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2276),
  [10022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4589),
  [10024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2272),
  [10026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2271),
  [10028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2270),
  [10030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2268),
  [10032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2264),
  [10034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4912),
  [10036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 2, 0, 0),
  [10038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [10040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [10042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4657),
  [10044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [10046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [10048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [10050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [10052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6016),
  [10054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3702),
  [10056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [10058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [10060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [10062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2263),
  [10064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2262),
  [10066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2261),
  [10068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5725),
  [10070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5511),
  [10072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [10074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [10076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4828),
  [10078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4165),
  [10080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [10082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [10084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6007),
  [10086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [10088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2291),
  [10090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [10092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [10094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [10096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [10098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2619),
  [10100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3479),
  [10102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3478),
  [10104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6001),
  [10106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1775),
  [10108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [10110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1722),
  [10112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [10114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [10116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5847),
  [10118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [10120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [10122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [10124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4114),
  [10126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [10128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [10130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [10132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [10134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [10136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [10138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [10140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [10142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [10144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4822),
  [10146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1875),
  [10148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1876),
  [10150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1880),
  [10152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1881),
  [10154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_heritage, 2, 0, 0),
  [10156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1882),
  [10158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6119),
  [10160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1886),
  [10162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [10164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5938),
  [10166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6128),
  [10168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1888),
  [10170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [10172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3679),
  [10174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1894),
  [10176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1895),
  [10178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1897),
  [10180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1898),
  [10182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3353),
  [10184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5632),
  [10186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3357),
  [10188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5631),
  [10190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3361),
  [10192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3333),
  [10194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1916),
  [10196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3558),
  [10198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3334),
  [10200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3370),
  [10202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5620),
  [10204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3651),
  [10206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6161),
  [10208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1913),
  [10210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3372),
  [10212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5614),
  [10214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3374),
  [10216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3118),
  [10218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3375),
  [10220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3915),
  [10222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1899),
  [10224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [10226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1900),
  [10228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3379),
  [10230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3391),
  [10232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3392),
  [10234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3395),
  [10236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3341),
  [10238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3390),
  [10240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [10242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3177),
  [10244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3312),
  [10246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4774),
  [10248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3235),
  [10250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2671),
  [10252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [10254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2627),
  [10256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3354),
  [10258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [10260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3376),
  [10262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [10264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3388),
  [10266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [10268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [10270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [10272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [10274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3398),
  [10276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [10278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5571),
  [10280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3918),
  [10282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6220),
  [10284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1903),
  [10286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [10288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1905),
  [10290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1906),
  [10292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1907),
  [10294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [10296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1845),
  [10298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [10300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4311),
  [10302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [10304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [10306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [10308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [10310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [10312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [10314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6262),
  [10316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5979),
  [10318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4746),
  [10320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5985),
  [10322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3492),
  [10324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3491),
  [10326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [10328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [10330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5992),
  [10332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3570),
  [10334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [10336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5540),
  [10338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5845),
  [10340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [10342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1086),
  [10344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2827),
  [10346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5539),
  [10348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [10350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5379),
  [10352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1883),
  [10354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2783),
  [10356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3112),
  [10358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2784),
  [10360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4849),
  [10362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [10364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [10366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6291),
  [10368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5383),
  [10370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [10372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4262),
  [10374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3549),
  [10376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4824),
  [10378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5527),
  [10380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4373),
  [10382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5525),
  [10384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4348),
  [10386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4785),
  [10388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5524),
  [10390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5600),
  [10392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5522),
  [10394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6197),
  [10396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 3, 0, 8),
  [10398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_annotated_object, 2, 0, 6),
  [10400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4696),
  [10402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4691),
  [10404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5526),
  [10406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 2, 0, 3),
  [10408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1, 0, 1),
  [10410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6322),
  [10412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5515),
  [10414] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [10416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5485),
  [10418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comment, 1, 0, 0),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__automatic_semicolon = 0,
  ts_external_token__template_chars = 1,
  ts_external_token__ternary_qmark = 2,
  ts_external_token_html_comment = 3,
  ts_external_token_PIPE_PIPE = 4,
  ts_external_token_escape_sequence = 5,
  ts_external_token_regex_pattern = 6,
  ts_external_token__function_signature_automatic_semicolon = 7,
  ts_external_token___error_recovery = 8,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__automatic_semicolon] = sym__automatic_semicolon,
  [ts_external_token__template_chars] = sym__template_chars,
  [ts_external_token__ternary_qmark] = sym__ternary_qmark,
  [ts_external_token_html_comment] = sym_html_comment,
  [ts_external_token_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [ts_external_token_escape_sequence] = sym_escape_sequence,
  [ts_external_token_regex_pattern] = sym_regex_pattern,
  [ts_external_token__function_signature_automatic_semicolon] = sym__function_signature_automatic_semicolon,
  [ts_external_token___error_recovery] = sym___error_recovery,
};

static const bool ts_external_scanner_states[11][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__template_chars] = true,
    [ts_external_token__ternary_qmark] = true,
    [ts_external_token_html_comment] = true,
    [ts_external_token_PIPE_PIPE] = true,
    [ts_external_token_escape_sequence] = true,
    [ts_external_token__function_signature_automatic_semicolon] = true,
    [ts_external_token___error_recovery] = true,
  },
  [2] = {
    [ts_external_token_html_comment] = true,
  },
  [3] = {
    [ts_external_token__ternary_qmark] = true,
    [ts_external_token_html_comment] = true,
    [ts_external_token_PIPE_PIPE] = true,
  },
  [4] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__ternary_qmark] = true,
    [ts_external_token_html_comment] = true,
    [ts_external_token_PIPE_PIPE] = true,
  },
  [5] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token_html_comment] = true,
  },
  [6] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token_html_comment] = true,
    [ts_external_token__function_signature_automatic_semicolon] = true,
  },
  [7] = {
    [ts_external_token__template_chars] = true,
    [ts_external_token_html_comment] = true,
    [ts_external_token_escape_sequence] = true,
  },
  [8] = {
    [ts_external_token__template_chars] = true,
    [ts_external_token_html_comment] = true,
  },
  [9] = {
    [ts_external_token_html_comment] = true,
    [ts_external_token_escape_sequence] = true,
  },
  [10] = {
    [ts_external_token_html_comment] = true,
    [ts_external_token_regex_pattern] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_qmljs_external_scanner_create(void);
void tree_sitter_qmljs_external_scanner_destroy(void *);
bool tree_sitter_qmljs_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_qmljs_external_scanner_serialize(void *, char *);
void tree_sitter_qmljs_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_qmljs(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_qmljs_external_scanner_create,
      tree_sitter_qmljs_external_scanner_destroy,
      tree_sitter_qmljs_external_scanner_scan,
      tree_sitter_qmljs_external_scanner_serialize,
      tree_sitter_qmljs_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
